//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  acvpbtsp.h
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     3/16/96    A. Krist    original baseline
//  2.0    09/02/97    M.Perry     32-bit conversion.
//  2.3    07/14/99    M.Perry     added const to ctor params.
//********************************************************************
#if !defined(__acvpbtsp_h)
#define __acvpbtsp_h

#include "osprite.h"
#include "casglord.h"
#include "ocurmgr.h"
//*******************************************************************
class TACCasButton:public TSprite
{
public:
  TCursorData      DefaultActionCursor;
  TAnm            *PButton;
  TWav            *PDownWav;
  TWav            *PUpWav;
  TWav            *PChime;
  TResponder      *PButtonResponder;
  TCasinoGameLord *POwnerBase;
  dword            ButtonDownFUC;
  dword            ExpertStart;
  int16              GoodUp;
  int16              Info;
  int16              CurrentDownFrame;
  int16              CurrentUpFrame;
  int16              CurrentGrayFrame;
  bool             ButtonUp;
  bool             LeftUp;
  bool             Enabled;
  bool             ThirdWave;
  bool             Freeze;

public:
  void SetupWavs();
  void SetupAnms();
  virtual bool Respond(TResponder &responder);
  virtual bool Respond(int16 Button,int16 Info,void *Ptr) {return true;}

  TACCasButton(TOgleModeWindow *pmw,
             TFileMode NewFileMode,
             TCasinoGameLord *GameLord,
				 int16 ZOrder,
             const TRect &rect,
             int16 IdNum,
             bool Handled,
             char Ch='~',
             const TCursorData &cd = TCursorData(TOgleApp::GetOgleApp(),ID_POINTING_FINGER_CURSOR),
             const TCursorData &dac = TCursorData(TOgleApp::GetOgleApp(),ID_PRESSING_FINGER_CURSOR));
  TACCasButton(TOgleModeWindow *pmw,
             TFileMode fm,
             void *psource,
             TCasinoGameLord *GameLord,
				 int16 ZOrder,
             const TRect &rect,
             int16 IdNum,
             bool Handled,
             char Ch='~',
             const TCursorData &cd = TCursorData(TOgleApp::GetOgleApp(),ID_POINTING_FINGER_CURSOR),
             const TCursorData &dac = TCursorData(TOgleApp::GetOgleApp(),ID_PRESSING_FINGER_CURSOR));
  TACCasButton(TOgleModeWindow *pmw,TFileMode NewFileMode);
  TACCasButton(TOgleModeWindow *pmw,TFileMode fm,void *psource);
  virtual ~TACCasButton();
  void SetCurrentUpFrame(int16 Frame);
  void SetCurrentDownFrame(int16 Frame);
  void SetCurrentGrayFrame(int16 Frame);
  void ShowGray();
  void ShowUp();
  void ShowLite();
  void ShowExpert();
  void NoShowExpert();
  void PlayChime();
  void ShowVoidUp();
  void ShowDown();
  virtual void PostUpdate(dword NewFUC);
  virtual void Update(dword NewFUC);
};
//*******************************************************************
#endif
