//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  bjlord.h
//    Project Name:  Ogle
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     07/2/95   A. Krist    Original baseline
//*******************************************************************
#if !defined _bjlord_h
#define _bjlord_h

#include "ogobj.h"
#include "deck.h"
//#include "bjmodwin.h"
class TBJModeWin;
class TBJLordMainState;
#include "bjsmarts.h"
#include "bjhand.h"
#include "bjdeck.h"
#include "cbjdspsp.h"  // dealer spot

#include "cbjbssp.h"
#include "cbjrdsp.h"
#include "cbjcnssp.h"
#include "cbjsyhsp.h"
#include "cbjdssp.h"
//#include "cvpcosp.h"
//#include "cvpwpsp.h"
//#include "cvpwrsp.h"
//#include "cvpcrsp.h"
#include "cbjchsp.h"
#include "cassbsp.h"    //Status Bar
#include "cbjdlrsp.h"
#include "casnames.h"
//*******************************************************************
enum TGLordRID
{
  idBetSpot0,
  idBetSpot1,
  idBetSpot2,
  idBetSpot3,
  idBetSpot4,
  idBetSpot5,
  idBetSpot6,

  idDealer,
  idDealerSpot,

  idOneChip,
  idFiveChip,
  idTwentyFiveChip,
  idOneHundredChip,
  idOneThouChip,
  idTenThouChip,

  idRemoveDouble,
  idClearNoInsureStand,
  idSameYesInsureHit,
  idDealSplit,

  idAskExpert
};
#define NumResponders 11
//*******************************************************************

class TBJLord:public TGameObject
{
  public:
  TResponder *Responders[NumResponders];
  virtual BOOL Respond(TResponder &responder);
  void SetupResponders();
  void CleanupResponders() {for(int i=0;i<NumResponders;i++) {delete Responders[i];}}
  int BetSpotUse[7];
  int credits;
  int machinenum;
  int coinsplayed;
  int coinsize;
  int winnerpaid;
  int activeplayer;
  int maxbet;
  int pot;
  int playersin;
  int game;
  int totaldecks;
  int halfdecksplayed;
  int halfdecksleft;
  int truecount;
  int runningcount;
  int acecount;
  int cardsplayed;
  int newdeal;
  int numofdecks;
  int newdeckcount;
  int decksflag;

  TBJLordMainState   *pState;
  TBJModeWin         *pMWin;
  TBJDeck            *pDeck;
  TBJSmarts          *pSmarts;
  TBJHand            *pHand;

  TBJBetSpot             *BetSpot[7];
  TBJDealer              *Dealer;
  TBJDealerSpot          *DealerSpot;
  TBJRemoveDouble        *RemoveDouble;
  TBJClearNoInsureStand  *ClearNoInsureStand;
  TBJSameYesInsureHit    *SameYesInsureHit;
  TBJDealSplit           *DealSplit;
  TBJChips               *Chips;
  TCasStatusBar          *CasStatusBar;

  TBJLord(TBJModeWin *pmwin,TFileMode NewFileMode,int gametype,int coindenom);
  virtual TSpriteList *CreateSpriteList(TFileMode splfm);
  void SetupSprites();
  void CleanupSprites();
 ~TBJLord();

  ShuffleCards();
  SwitchDecks();
  DrawCards1();
  DrawCards3();
  DrawCards5();
  Split1();
  Split2();
  Split3();
  Split4();
  Split5();
  Split6();
  Split7();
  Split8();
  Split9();
  DoubleDown(int x);

  ShowHands();
  ShowWinner();
  BetLast();
  GetBet();
  ClearBet();
  Bet1(int betsize);
  UnBet1(int betsize);
  BetMax();
  CashOut();
  int GoodToGo();
  InitBJ();
  DrawDeal();
  DealerDraw();
  Winner();
  Clear();
  PlaceBet(int x);
  RemoveBet(int x);
  BlackJack();
  Count(TCard *card);
  GetPlayin() {return playersin;};
};
#endif