//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  casctrl.h
//    Project Name:  Cas
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.3     5/20/97    M.Perry    controls compilation of game types.
//  2.5    09/22/99    M.Perry    added controls for acvp
//********************************************************************
#if !defined(__casctrl_h)
#define __casctrl_h

//*******************************************************************
#if defined(CASINO_COMPILE)
  #define KENO_COMPILE
  #define BJ_COMPILE
  #define SLOTS_COMPILE
  #define VP_COMPILE
  #define CRAPS_COMPILE
  #define ROULETTE_COMPILE
  #define OVERALL_COMPILE
  #define NUM_GAME_TYPES 6
  #define PLAYERMGR_NUMACTIVEPLAYERS 3
  #define PLAYERMGR_NUMPLAYERSALLOWED 20
  #define NUMSESSIONS 20
#elif defined(VPLITE_COMPILE)
  #define VP_COMPILE
  #define NUM_GAME_TYPES 1
  #define PLAYERMGR_NUMACTIVEPLAYERS 3
  #define PLAYERMGR_NUMPLAYERSALLOWED 20
  #define NUMSESSIONS 20
#elif defined(SLOTLITE_COMPILE)
  #define SLOTS_COMPILE
  #define NUM_GAME_TYPES 1
  #define PLAYERMGR_NUMACTIVEPLAYERS 3
  #define PLAYERMGR_NUMPLAYERSALLOWED 20
  #define NUMSESSIONS 20
#elif defined(HUNSLOTS_COMPILE)
  #define SLOTS_COMPILE
  #define NUM_GAME_TYPES 1
  #define PLAYERDATA_SALARY
  #define PLAYERDATA_CREDIT
  #define PLAYERMGR_NUMACTIVEPLAYERS 1
  #define PLAYERMGR_NUMPLAYERSALLOWED 20
  #define PLAYERDATA_TRACKCENTS
  #define PLAYERMGR_FORCEACTIVATEONCREATE
  #define NUMSESSIONS 25
  #define ROUNDCASHTO5CENT
#elif defined(ACVP_COMPILE)
  #define VP_COMPILE
  #define SLOTS_COMPILE
  #define NUM_GAME_TYPES 2
  #define PLAYERDATA_SALARY
  #define PLAYERDATA_CREDIT
  #define PLAYERMGR_NUMACTIVEPLAYERS 1
  #define PLAYERMGR_NUMPLAYERSALLOWED 20
  #define PLAYERDATA_TRACKCENTS
  #define PLAYERMGR_FORCEACTIVATEONCREATE
  #define NUMSESSIONS 25
  #define ROUNDCASHTO5CENT
  #define OVERALL_COMPILE
#endif

#if defined(OVERALL_COMPILE)
  #define NUM_STAT_GAMES (NUM_GAME_TYPES + 1)
#else
  #define NUM_STAT_GAMES NUM_GAME_TYPES
#endif
//*******************************************************************
#endif