//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  vplgfw.h
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.2     4/17/97    M.Perry    modified framewin hierarchy.
//********************************************************************
#if !defined(__vplgfw_h)
#define __vplgfw_h

#include "casgfw.h"
class TVPLiteApp;
//*******************************************************************
class TVPLMenuEnable:public TCasinoMenuEnable
{
public:
  BOOL Lobby;

  BOOL VPJack1,VPJack5,VPJack25,VPJack100,VPJack1P;

  BOOL VPDWild1,VPDWild5,VPDWild25,VPDWild100;

  BOOL VPJWild100;

public:
  TVPLMenuEnable(BOOL setvalues = TRUE);
  virtual ~TVPLMenuEnable();
  virtual void SetAll(BOOL value);
  virtual void SetModes(BOOL value = TRUE);
};
//*******************************************************************
class TVPLGameFrameWindow:public TCasinoGameFrameWindow
{
public:
  TVPLGameFrameWindow(TVPLiteApp *pvplapp,const char *szTitle);
  virtual ~TVPLGameFrameWindow();
  virtual TWindow *CreateModeWindow(int ModeIndex);
  virtual int GetMenuID();
  virtual int GetAboutID();
  void DoMenu();
  virtual void SwitchGameModes(int modeindex);
  virtual void SwitchGameModes(string &name) {SwitchGameModes(GetModeIndex(name));}

protected:
  TVPLMenuEnable *GetVPLMenuEnable() {return (TVPLMenuEnable *)GetCasMenuEnable();}
  virtual void CreateMenuEnable();

  void CmGameLobby();
  void CeGameLobby(TCommandEnabler &enabler);

  void CmGameVPJack1();
  void CeGameVPJack1(TCommandEnabler &enabler);
  void CmGameVPJack5();
  void CeGameVPJack5(TCommandEnabler &enabler);
  void CmGameVPJack100();
  void CeGameVPJack100(TCommandEnabler &enabler);
  void CmGameVPJack25();
  void CeGameVPJack25(TCommandEnabler &enabler);
  void CmGameVPJack1P();
  void CeGameVPJack1P(TCommandEnabler &enabler);
  void CmGameVPDWild1();
  void CeGameVPDWild1(TCommandEnabler &enabler);
  void CmGameVPDWild5();
  void CeGameVPDWild5(TCommandEnabler &enabler);
  void CmGameVPDWild100();
  void CeGameVPDWild100(TCommandEnabler &enabler);
  void CmGameVPDWild25();
  void CeGameVPDWild25(TCommandEnabler &enabler);
  void CmGameVPJWild100();
  void CeGameVPJWild100(TCommandEnabler &enabler);

private:
  void SetupModeStrings();
  string strIntro;
  string strLobby;
  string strVPJack1,strVPJack5,strVPJack25,strVPJack100,strVPJack1P;
  string strVPDWild1,strVPDWild5,strVPDWild25,strVPDWild100;
  string strVPJWild100;

  DECLARE_RESPONSE_TABLE(TVPLGameFrameWindow);
};
//*******************************************************************
#endif