//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  accvpgld.h
//    Project Name:  acc
// Original Author:  Michael R.Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  2.5    09/27/99    M.Perry    original baseline
//********************************************************************
#if !defined(__accvpgld_h)
#define __accvpgld_h

#include "cvpglord.h"
#include "cvpnames.rh"
#include "casbutsp.h"  // Button
#include "cascdsp.h"    //Cash Display
#include "vpdeck.h"
#include "vpsmarts.h"

class TVideoPokerModeWin;
class TVPLordMainState;
class TVPAsk;

#include "cvpcrdsp.h"
#include "cvpcpsp.h"
#include "cvpwpsp.h"
#include "cvpvlsp.h" //VertLite
#include "cvpposp.h"  // payoff in coins
#include "cvpdbsp.h"  // DrawButton Background
#include "cvpwrsp.h"
#include "cvpcrsp.h"
#include "cvpjpsp.h"
#include "caschsp.h"
#include "cnamesp.h"
#include "cvpsdsp.h"
//*******************************************************************
enum TGLordRID
{
  idButton0,
  idButton1,
  idButton2,
  idButton3,
  idButton4,
  idButton5,
  idButton6,
  idButton7,
  idButton8,
  idOneChip,
  idFiveChip,
  idTwentyFiveChip,
  idOneHundredChip,
  idOneThouChip,
  idTenThouChip,
  idSpeedClick,
  idAddCoins,
  idHoldCard0,
  idHoldCard1,
  idHoldCard2,
  idHoldCard3,
  idHoldCard4,
  idNamePlate,
  idProgressive
};
//*******************************************************************
class TACCVPGLord:public TCasinoVPGameLord
{
public:
  TACCVPGLord(TVideoPokerModeWin *pvpmw,const TFileMode &fm,int16 sgt,int16 denomid);
  virtual ~TACCVPGLord();
  virtual void SetUIDS();
  #if defined(SUPPORT_OLD_VER)
  virtual int16 GetUniqueID(const string &s);
  #endif
//  TSprite *CreateSprite(string spritename,int16 id = 0,void *psource = NULL);
//  virtual void SetupResponders();

  enum {MAXBET = 5,NUMOFBUTTONS = 9,NumResponders = 14};
  TResponder *Responders[NumResponders];
  string winhand;
  TPokerHand *fake;

  TVPSound *VPSounds;
  TVPCard *CardSprites[5];
  TVPCoinsPlayed *CoinsPlayed;
  TCasButton *Button0;     //ask
  TCasButton *Button1;     //stat
  TCasButton *Button2;     //menu
  TCasButton *Button3;     //help
  TCasButton *Button4;     //CashOut
  TCasButton *Button5;     //Bet1
  TCasButton *Button6;     //BetMax
  TCasButton *Button7;     //Deal
  TCasButton *Button8;     //Draw
  TCasCashDisplay *BankCashDisplay;

  TVPDrawBack *DrawBack;
  TVPCoinPay *CoinPay;
  TVPVertLite *VertLite;

  TVPWinPaid *WinPaid;
  TVPCredits *Credits;
  TVPWinRatio *WinRatio;
  TCasChips *Chips;

  TCasNamePlate *NamePlate1;
  TCasNamePlate *NamePlate2;
  TCasNamePlate *NamePlate3;
  TVPProgressive *Progressive;
  TVPDeck *pDeck;
  TVPSmarts *pSmarts;
  TVPAsk *ask;
  int32 pot;
  int16 ButtonInfo;
  int16 machinenum;
  int16 numofsplits;
  int16 playersin;
  int16 r1;
  int16 r2;
  int16 r3;
  int16 shutdownstate;
  bool  ButtonHit[NUMOFBUTTONS];

  void EnableAllButtons();
  void FreezeAllButtons();
  void UnFreezeAllButtons();
  void DisEnableAllButtons();
  void EnableButton(int16 button);
  void DisEnableButton(int16 button);
  void ButtonClear(int16 button);
  int16 ShuffleCards();
  int16 ShowWinner();
  int16 GetBet();
  int16 Bet1();
  bool BetX(TMoney x);
  int16 BetMax();
  int16 CashOut();
  int16 Switch();
  int16 AddCoins();
  int16 GoodToGo();
  int16 DrawDeal();
  TMoney Winner();
  int16 Clear();
  int16 InitVP();
  void ClearActions();
  void HoldCard(int16 cardnum);
  TMoney PayOutJacks();
  TMoney PayOutTens();
  TMoney PayOutWild2();
  TMoney PayOutWildJoker();
  TMoney PayOutProgressive();
  int16 Wild2(bool Copy);
  int16 WildJoker(bool Copy);
  int16 GetNumOfWildCards();
  int16 GetPlayin() {return playersin;};
  bool CheckExpertCode();
  void AskGenExpert();
  void AskMoneyExpert();
  void AskHoldCards(bool Show);

  int16 idsSounds,idsVertLite,idsDrawBack,idsCoinPay,idsChips,idsCard1,
        idsCard2,idsCard3,idsCard4,idsCard5,idsNP1,idsNP2,idsNP3,idsCoinsPlayed,
        idsCredits,idsWinPaid,idsButton0,idsButton1,idsButton2,idsButton3,
        idsButton4,idsButton5,idsButton6,idsButton7,idsButton8,idsWinRatio,
        idsBankCash,idsProgressive;
//  virtual void SetUIDSStrings();
  string strSounds;
  string strVertLite;
  string strDrawBack;
  string strCoinPay;
  string strChips;
  string strCard1;
  string strCard2;
  string strCard3;
  string strCard4;
  string strCard5;
  string strNP1;
  string strNP2;
  string strNP3;
  string strCoinsPlayed;
  string strCredits;
  string strWinPaid;
  string strButton0;
  string strButton1;
  string strButton2;
  string strButton3;
  string strButton4;
  string strButton5;
  string strButton6;
  string strButton7;
  string strButton8;
  string strWinRatio;
  string strBankCash;
  string strProgressive;
  virtual TSprite *CreateSprite(string spritename,int16 id = 0,void *psource = NULL);
  virtual bool AddCredits(int16 AddCredits);
  virtual bool Respond(int16 Button,int16 info = 0,void *pdata = NULL);
  virtual bool Respond(TResponder &responder);
  virtual void SetupResponders();
  virtual void CleanupResponders();
  virtual void SwitchToPlayer(int16 player);
  virtual void CyclePlayers();
  virtual void SetupActivePlayer(int16 slot);
  virtual void ShuttingDown();
  virtual void NotifyPlayerActivation(int16 slotnum);
  virtual void NotifyPlayerDeActivation(int16 slotnum);
  virtual void SetupSprites();
  virtual void CleanupSprites();
  virtual void SetUIDSStrings();
};
//*******************************************************************
#endif