//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  acvpglrd.h
//    Project Name:  acvp
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  2.5    09/28/99    M.Perry    original baseline
//********************************************************************
#if !defined(__acvpglrd_h)
#define __acvpglrd_h

#include "cvpglord.h"
#include "acvpbtsp.h"  // Button
//#include "acvpcdsp.h"    //Cash Display
#include "acvscdsp.h"
#include "acvpdeck.h"
#include "vpsmarts.h"
#include "acvpvsp.h"
class TVideoPokerModeWin;
class TVPLordMainState;
class TACVPAsk;

#include "acvpjbsp.h"
#include "acvpttsp.h"
#include "acvpwdsp.h"
#include "vp5crdsp.h"
#include "acvpcpsp.h"
#include "acvpwpsp.h"
#include "acvpvlsp.h" //VertLite
#include "acvpposp.h"  // payoff in coins
#include "cvpdbsp.h"  // DrawButton Background
#include "acvpwrsp.h"
#include "acvpcrsp.h"
#include "acvpjpsp.h"
#include "acvpbksp.h"
#include "acvplksp.h"
#include "acvpfasp.h"
#include "acvpgdsp.h"
//???#include "caschsp.h"
#include "acvpnsp.h"
#include "cvpsdsp.h"
//*******************************************************************
enum TGLordRID
{
  idButton0,
  idButton1,
  idButton2,
  idButton3,
  idButton4,
  idButton5,
  idButton6,
  idButton7,
  idButton8,
  idButton9,
  idOneChip,
  idFiveChip,
  idTwentyFiveChip,
  idOneHundredChip,
  idOneThouChip,
  idTenThouChip,
  idSpeedClick,
  idAddCoins,
  idHoldCard0,
  idHoldCard1,
  idHoldCard2,
  idHoldCard3,
  idHoldCard4,
  idNamePlate,
  idProgressive,
  idValue,
  idWheel,
  idChest,
  idJackpotBonus,
  idProg1,
  idProg2,
  idProg3,
  idProg4,
  idBackG,
  idLook,
  idFAss,
  idGrid,
  idGridWin
};
//*******************************************************************
class TACVPVPGLord:public TCasinoVPGameLord
{
public:
  uint32 flushStartTime;
  int numPlays;
  int currentNumPlays;
  int XName;
  void SetFlushAssault();
  void ShowFlushAssault();
  TACVPVPGLord(TVideoPokerModeWin *pvpmw,const TFileMode &fm,int16 sgt,
                  int16 denomid);
  virtual ~TACVPVPGLord();
  virtual void SetUIDS();
  TSprite *CreateSprite(string spritename,int16 id = 0,void *psource = NULL);
  virtual void SetupResponders();
  int16 idsSounds,idsVertLite,idsDrawBack,idsCoinPay,idsChips,idsCard1,
        idsCard2,idsCard3,idsCard4,idsCard5,idsNP1,idsNP2,idsNP3,idsCoinsPlayed,
        idsCredits,idsWinPaid,idsButton0,idsButton1,idsButton2,idsButton3,
        idsButton4,idsButton5,idsButton6,idsButton7,idsButton8,idsButton9,idsWinRatio,
        idsBankCash,idsProgressive,idsValue,idsWheel,idsChest,idsJackpotBonus,
        idsProg1,idsProg2,idsProg3,idsProg4,idsBackG,idsLook,idsFAss,idsVertLite2,idsGrid,
        idsGridWin,idsWinPaidTop,idsWinPaidMid,idsWinPaidBot;

  enum {MAXBET = 5,NUMOFBUTTONS = 10,NumResponders = 14};
  TResponder *Responders[NumResponders];
  string winhand;

  TPokerHand *fake;
  TPokerHand *TripTopHand;
  TPokerHand *TripMidHand;

  TMoney ProgressiveBaseAmount;
  TMoney ProgressiveMaxAmount;
 // TMoney progressive;
  TMoney ProgressiveIncrement;
  TMoney IncAdd2;
  TMoney IncAdd3;
  TMoney IncAdd4;

  TMoney progressive1;
  TMoney progressive2;
  TMoney progressive3;
  TMoney progressive4;

  TACVPBackground *Title;
  TSprite         *Song;

  TACVPProgressive *Prog1;
  TACVPProgressive *Prog2;
  TACVPProgressive *Prog3;
  TACVPProgressive *Prog4;
  TACVPJackpotBonus *JackpotBonus;
  TACVPTreasureTrove *Chest;
  TACVPValue *Value;
  TACVPGrid *Grid;
  TSprite   *GridWin;
  TACVPWinRatio  *FAss;
  TACVPLook  *Look;
  TACVPBackground *BackG;
  TACVPWheelDeal *Wheel;
  TVPSound *VPSounds;
  TVP5Card *CardSprite;
  TVP5Card *TopCardSprite;
  TVP5Card *MidCardSprite;
  TACVPCoinsPlayed *CoinsPlayed;
  TACCasButton *Button0;     //cashout
  TACCasButton *Button1;     //bet 1
  TACCasButton *Button2;     //betmax
  TACCasButton *Button3;     //deal/draw
  TACCasButton *Button4;     //lobby
  TACCasButton *Button5;     //menu
  TACCasButton *Button6;     //add50
  TACCasButton *Button7;     //askex
  TACCasButton *Button8;     //Double Down
  TACCasButton *Button9;     //Take winnings
//  TACCasCashDisplay *BankCashDisplay;
  TACVPSlotsCashDisplay *BankCashDisplay;

  TVPDrawBack  *DrawBack;
  TACVPCoinPay *CoinPay;
  TACVPVertLite  *VertLite;
  TACVPVertLite  *VertLite2;

  TACVPWinPaid *WinPaid;
  TACVPWinPaid *WinPaidTop;
  TACVPWinPaid *WinPaidMid;
  TACVPWinPaid *WinPaidBot;
  TACVPCredits *Credits;
  TACVPWinRatio *WinRatio;
  TACVPWinRatio *DullWRatio;

  TACCasNamePlate *NamePlate1;
  TACCasNamePlate *NamePlate2;
  TACCasNamePlate *NamePlate3;
  TACVPProgressive *Progressive;
  TACVPDeck *pDeck;
  TACVPDeck *pTopDeck;
  TACVPDeck *pMidDeck;
  TVPSmarts *pSmarts;
  TACVPAsk *ask;

  TMoney FourAceJackpot;
  TMoney Four234Jackpot;
  TMoney ClubProgJackpot;
  TMoney DiamondProgJackpot;
  TMoney SpadeProgJackpot;
  TMoney HeartProgJackpot;

  TMoney Dcoinsplayed;
  bool ShowTripleBack;
  bool FlushSwitch;
  bool DoubleBet;
  bool isCoin;
  bool WaitOnDoubleDown;
  bool IsDoubleType;
  bool IsDDrawType;
  bool IsNormalType;
  bool IsDoubleWinner;
  bool IsDoubleTie;
  bool FlushAssaultOn;
  TMoney MultPayoff;
  TMoney JackpotBonusAmount;
  int32 pot;
  int16 ButtonInfo;
  int16 machinenum;
  int16 numofsplits;
  int16 playersin;
  int16 r1;
  int16 r2;
  int16 r3;
  int16 shutdownstate;
  bool  ButtonHit[NUMOFBUTTONS];
  bool IsCycle;
  TMoney Denom[11];
  int16 NumOfDenoms;
  int16 CurrentDenomNum;

  void ClearHand();
  void SetupDenoms();
  virtual void CycleDenom();
  virtual bool SwitchDenom(TMoney denom);
  void DoubleTheBet();
  void SetupJackpots();
  void EnableAllButtons();
  void FreezeAllButtons();
  void UnFreezeAllButtons();
  void DisEnableAllButtons();
  void EnableButton(int16 button);
  void DisEnableButton(int16 button);
  void ButtonClear(int16 button);
  int16 ShuffleCards();
  int16 ShowWinner();
  void PreWinner();
  int16 GetBet();
  int16 Bet1();
  int16 BetTP1();
  int16 BetD1();
  int16 BetDMax();
  int16 BetRD1();
  int16 BetRDMax();
  bool BetX(TMoney x);
  int16 BetMax();
  int16 BetTPMax();
  int16 CashOut();
  int16 Switch();
  int16 AddCoins();
  int16 GoodToGo();
  int16 DrawDeal();
  TMoney Winner();
  TMoney WinnerTop();
  TMoney WinnerMid();
  TMoney GetJackpotBonusAmount();
  int16 Clear();
  int16 InitVP();
  void ClearActions();
  void HoldCard(int16 cardnum);
  void HoldCardTrip(int16 cardnum);
  
  TMoney PayOutJacks();
  TMoney PayOutTens();
  TMoney PayOutWild2();
  TMoney PayOutWildJoker();
  TMoney PayOutProgressive();

  TMoney PayOutFivesUp();
  TMoney PayOutBonusDeluxeP();
  TMoney PayOutClubBonus();
  TMoney PayOutCrazy8();
  TMoney PayOutDDrawJacks();
  TMoney PayOutDDrawJokers();
  TMoney PayOutDDownStud();
  TMoney PayOut2WildBonus();
  TMoney PayOut2Wild();
  TMoney PayOut2WildProg();
  TMoney PayOutDiamondBonus();
  TMoney PayOutDoubleBonusPoker();
  TMoney PayOutFlushAssault();
  TMoney PayOutFreeLook();
  TMoney PayOutGamblersEdge();
  TMoney PayOutHeartBonus();
  TMoney PayOutBlackJacks();
  TMoney PayOutJacksBetterProg();
  TMoney PayOutJackpotBonus();
  TMoney PayOutJacksBetter96();
  TMoney PayOutTreasureTrove();
  TMoney PayOutJacksBetter85();
  TMoney PayOutJacksBetterDoubleD();
  TMoney PayOutJokerWildProg();
  TMoney PayOutJumpinJoker();
  TMoney PayOutTripProg();
  TMoney PayOutTriplePlayTop();
  TMoney PayOutTriplePlayMid();
  TMoney PayOutProgRoyals();
  TMoney PayOutPowerFullHouse();
  TMoney PayOutRaiseDrawJoker();
  TMoney PayOutSpadeBonus();
  TMoney PayOutSuperDoubleJackpot();
  TMoney PayOutSevenWildJoker();
  TMoney PayOutTensBetter();
  TMoney PayOutTriplePlay();
  TMoney PayOutTripleBonus();
  TMoney PayOutWheelDeal();

  int16 Wild2s(bool Copy);
  int16 WildJokers(bool Copy);
  int16 WildJoker5(bool Copy);
  int16 WildSevensJoker(bool Copy);
  
  int16 Wild2(bool Copy);
  int16 WildJoker(bool Copy);
  int16 GetNumOfWildCards();
  int16 GetPlayin() {return playersin;};
  bool CheckExpertCode();
  void AskGenExpert();
  void AskMoneyExpert();
  void AskHoldCards(bool Show);
  int16 SetMult();

  void SetupGrid();
  void SaveGrid();
  bool DoGrid();
  void ClearRowCol();
  bool JackpotGrid[5][5];
  
  string strProg1;
  string strProg2;
  string strProg3;
  string strProg4;
  string strJackpotBonus;
  string strChest;
  string strWheel;
  string strValue;
  string strGridWin;
  string strGrid;
  string strFAss;
  string strLook;
  string strBackG;
  string strSounds;
  string strVertLite;
  string strVertLite2;
  string strDrawBack;
  string strCoinPay;
  string strChips;
  string strCard1;
  string strCard2;
  string strCard3;
  string strCard4;
  string strCard5;
  string strNP1;
  string strNP2;
  string strNP3;
  string strCoinsPlayed;
  string strCredits;
  string strWinPaid;
  string strWinPaidTop;
  string strWinPaidMid;
  string strWinPaidBot;
  string strButton0;
  string strButton1;
  string strButton2;
  string strButton3;
  string strButton4;
  string strButton5;
  string strButton6;
  string strButton7;
  string strButton8;
  string strButton9;
  string strWinRatio;
  string strBankCash;
  string strProgressive;
  virtual bool AddCredits(int16 AddCredits);
  virtual bool Respond(int16 Button,int16 info = 0,void *pdata = NULL);
  virtual bool Respond(TResponder &responder);
  virtual void CleanupResponders();
  virtual void SwitchToPlayer(int16 player);
  virtual void CyclePlayers();
  virtual void SetupActivePlayer(int16 slot);
  virtual void ShuttingDown();
  virtual void NotifyPlayerActivation(int16 slotnum);
  virtual void NotifyPlayerDeActivation(int16 slotnum);
  virtual void SetupSprites();
  virtual void CleanupSprites();
  virtual void SetUIDSStrings();
  void SaveJackpots();
};
//*******************************************************************
#endif