//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  acvpsgld.h
//    Project Name:  acvp
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  2.5    10/16/99    M.Perry      original baseline
//********************************************************************
#if !defined(__acvpsgld_h)
#define __acvpsgld_h

#include "casglord.h"
#include "casbutsp.h"
#include "acvscdsp.h"
#include "acvsposp.h"

class TACVPSlotsModeWin;
class TACVPSlotsLordState;
class TACVPSlotsMainState;

#include "acvscpsp.h"
#include "cgametyp.h"
#include "acvswpsp.h"
#include "acvswhsp.h"
#include "acvscrsp.h"
//#include "acvsjpsp.h"
#include "acvsmtsp.h"
#include "acvszssp.h"
#include "acvsnmsp.h"
#include "acvsrlsp.h"
#include "acvssdsp.h"
#include "acvsplsp.h"
#include "acvsvsp.h"
//#include "acvsmusp.h"
//#include "acvsmdsp.h"
//#include "acvsmmsp.h"
#include "acvscmsp.h"
#include "omdat.h"
//*******************************************************************
enum TGLordACVPSID
{
  acvpsidButton0 = 0,
  acvpsidButton1 = 1,
  acvpsidButton2 = 2,
  acvpsidButton3 = 3,
  acvpsidButton4 = 4,
  acvpsidButton5 = 5,
  acvpsidButton6 = 6,
  acvpsidButton7 = 7,
  acvpsidAddCoins = 8,
  acvpsidSpeedClick = 9,
  acvpsidNamePlate = 10,
  acvpsidDenom = 11//,
//  acvpsidProgressive
};
//*******************************************************************
class TACVPSlotsGameLord:public TCasinoGameLord
{
public:
  enum {MAXBET = 3,/*NUMOFBUTTONS = 7,*/NumResponders = 3,MaxNumCoins = 6,NumButtons = 8};

  //Super7 reel symbols
  enum {symBlank = 0,sym1Cherry = 1,sym2Cherry = 2,sym1Bar = 3,sym2Bar = 4,
        sym3Bar = 5,symSuper7 = 6};

  //Crystal Palace reel symbols
  enum {symCrystalCherry = 1,sym1CrystalBar = 2,sym2CrystalBar = 3,
        sym3CrystalBar = 4,symCrystal7 = 5,symBigCrystal = 6,symHugeCrystal = 7};

  //Super7 winning combos
  enum {wc1of1Cherry = 0,wc2of1Cherry = 1,wc1of2Cherry = 2,
        wc1of1CherryAnd1of2Cherry = 3,wc2of1CherryAnd1of2Cherry = 4,
        wc2of2Cherry = 5,wc1of1CherryAnd2of2Cherry = 6,
        wc3of1Cherry = 7,wc3of2Cherry = 8,wc3ofXBar = 9,wc3of1Bar = 10,
        wc3of2Bar = 11,wc3of3Bar = 12,wc3ofSuper7 = 13,wcSuper7NumCombos = 14};

  //Crystal Palace winning combos.
  enum {wc1ofCrystalCherry = 0,wc2ofCrystalCherry = 1,wc3ofXCrystalBar = 2,
        wc3ofCrystalCherry = 3,wc3of1CrystalBar = 4,wc3of2CrystalBar = 5,
        wc3of3CrystalBar = 6,wc3ofCrystal7 = 7,wc3ofBigCrystal = 8,
        wc3ofHugeCrystal = 9,wcCrystalNumCombos = 10};

protected:
  string strBankruptTitle,strPlayCheaperCreditYes,strPlayCheaperCreditNo,
         strBrokeCreditYes,strBrokeCreditNo,strHasCoinsPlayedCreditYes,
         strHasCoinsPlayedCreditNo;
         
  int16 Super7WC[wcSuper7NumCombos][MaxNumCoins];
  int16 CrystalPalaceWC[wcCrystalNumCombos][MaxNumCoins];
  TResponder *Responders[NumResponders];
  TCasButton *PButtons[NumButtons];
  bool ButtonHit[NumButtons];

  string strValue,strSounds,strCoinPay,strNP1,strCoinsPlayed,strCredits,
         strWinPaid,strButton0,strButton1,strButton2,strButton3,strButton4,
         strButton5,strButton6,strButton7,strBankCash;

  int16 idsSounds,idsCoinPay,idsNP1,idsCoinsPlayed,idsCredits,idsWinPaid,
        idsButton0,idsButton1,idsButton2,idsButton3,idsButton4,idsButton5,
        idsButton6,idsButton7,idsBankCash,idsValue;

public:
  TACVPSlotsTitle *PTitle;
  TACVPSlotsSound *PSounds;
  TACVPSlotsCoinsPlayed *PCoinsPlayed;
  TACVPSlotsWinPaid *PWinPaid;
  TACVPSlotsCredits *PCredits;
  TACVPSlotsReel *PReel1;
  TACVPSlotsReel *PReel2;
  TACVPSlotsReel *PReel3;
  TACVPSlotsNamePlate *PNamePlate1;
  TACVPSlotsCashDisplay *PBankCashDisplay;
  TACVPSlotsCoinPay *PCoinPay;
  TACVPSlotsPayLine *PPayLine;
  TACVPSlotsValue *PValue;
  TACVPSlotsWinHighLight *PWinHighLight;
  TSprite *PSong;
  TACVPSlotsColumn *PColumn;

  dword StartFUC;
  dword FUCLength;

  TMoney Denom[TMoney::did_NumIDs];
//  TMoney credits;
  int16 credits;
//  TMoney ProgressiveIncrement;
  int16 coinsplayed;
//  TMoney coinsplayed;
  TMoney coinsize;
//  TMoney winnerpaid;
  int16 winnerpaid;
  int16 WinningCombo;
//  TMoney maxbet;
  int16 maxbet;
//  TMoney pot;
//  TMoney ProgressiveBaseAmount;
//  TMoney ProgressiveMaxAmount;
//  TMoney progressive;

  int16 BetMaxNumOfCredits;
  int16 BetMaxNumOfCoins;
  int16 AdvanceNumOfFrames;
//  int16 Multiplier;
  int16 ButtonInfo;
//  int16 machinenum;
//  int16 PayOffSound;
//  int16 playersin;
//  int16 r1;
//  int16 r2;
//  int16 r3;
//  int16 Song;
  int16 shutdownstate;
  int16 NumOfDenoms;
  int16 CurrentDenomNum;

  bool MaxOnly;
  bool BMNumOfCredits;
  bool BMNumOfCoins;
  bool IsCycle;
//  bool HoldMultiplier;
  bool IsMultiPayline;

public:
  int16 GetCrystalPalaceWC(int16 s0,int16 s1,int16 s2,int16 &mult);
  int16 GetSuper7WC(int16 s0,int16 s1,int16 s2);
  int16 GetWinningCombo(int16 s0,int16 s1,int16 s2,int16 &mult);
  int16 GetPayOffLevel(int16 wc);
  TACVPSlotsGameLord(TACVPSlotsModeWin *psmw,const TFileMode &fm,
                     int16 sgt,int16 did);
  virtual ~TACVPSlotsGameLord();

  TACVPSlotsLordState *GetState() {return (TACVPSlotsLordState *)PState;}
  TMiscData *GetReelDataPtr() {return GetMiscData();}
  virtual bool SwitchDenom(TMoney Denom);
  virtual TSprite *CreateSprite(string spritename,int16 id = 0,void *psource = NULL);
  virtual bool AddCredits(int16 AddCredits);
  void EnableAllButtons();
  void FreezeAllButtons();
  void UnFreezeAllButtons();
  void DisEnableAllButtons();
  void EnableButton(int16 button);
  void DisEnableButton(int16 button);
  void ButtonClear(int16 button);
  void BtnShowVoidUp(int16 button);
  void BtnSetCurrentUpFrame(int16 button,int16 framenum);
  void BtnSetCurrentGrayFrame(int16 button,int16 framenum);
  void BtnShowGray(int16 button);
  void BtnSetResponderCh(int16 whichchar,int16 button,char ch);
  bool CheckButtonIndex(int16 button) {return bool(button >= 0 && button < NumButtons);}
  void BtnSetHit(int16 button,bool hit = true)
  {
    if (CheckButtonIndex(button))
    {
      ButtonHit[button] = hit;
    }
  }
  bool BtnGetHit(int16 button)
  {
    if (!CheckButtonIndex(button)) {return false;}
    return ButtonHit[button];
  }
  virtual bool Respond(int16 Button,int16 info = 0,void *pdata = NULL);
  virtual bool Respond(TResponder &responder);
//  int16 ShowWinner();
//  int16 GetBet();
  bool Bet1();
//  TMoney BetX(TMoney x);
  int16 BetX(int16 numcoins);
  int16 BetMax();
  int16 CashOut();
  bool Spin();
  virtual void SetReel();
  virtual void CycleDenom();
  int16 Switch();
  bool AddCoins();
//  int GoodToGo();
//  TMoney Winner();
  int16 Winner();
  virtual void Clear();
  bool InitS();
//  void ClearActions();
//  int16 PayOutProgressive();
  int16 PayOut();
//  int16 GetPlayin() {return playersin;};
//  int16 ChangeGame();
  void  SwitchToPlayer(int16 player);
  void  CyclePlayers();
  virtual void NotifyPlayerActivation(int16 slotnum);
  virtual void NotifyPlayerDeActivation(int16 slotnum);
  int16 GetReelDataint16(int16 index);

protected:
  virtual TMoney PayLine1();
  void SetupResponders();
  void CleanupResponders();
  virtual void SetupActivePlayer(int16 slot);
  virtual void ShuttingDown();
  virtual void SetupSprites();
  virtual void CleanupSprites();
  virtual void SetUIDS();
  virtual void SetUIDSStrings();
};
//*******************************************************************
#endif
