                              //*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  betbuy.h
//    Project Name:  Ogle
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     08/18/95   A. Krist    Original baseline
//  2.0     09/18/97   M.Perry     32-bit conversion.
//*******************************************************************
#if !defined _betbuy_h
#define _betbuy_h

#include "ccbssp.h"
//*******************************************************************
class TBetBuy : public TCBetSpot
{
public:
  int16 BuyPoint;
  bool Bought[3];
  TBetBuy(TOgleModeWindow *pmw,const TFileMode &NewFileMode,int16 point,int16 MessageCode);
  TBetBuy(TOgleModeWindow *pmw,const TFileMode &NewFileMode,void *psource,int16 point,
          int16 MessageCode);
  virtual ~TBetBuy();
  virtual bool Winner(int16 FirstDice,int16 SecondDice,int16 Point,bool ComeOut);
  virtual bool Loser(int16 FirstDice,int16 SecondDice,int16 Point,bool ComeOut);
  virtual bool Winner(int16 FirstDice,int16 SecondDice,int16 Point,bool ComeOut,
                      bool Buy4n10,bool Buy5n9,bool Buy6n8,bool ComeFreeOdds,
                      bool DoNotComeFreeOdds,bool BuyPlaceOn,bool HardWaysOn);
  virtual bool Loser(int16 FirstDice,int16 SecondDice,int16 Point,bool ComeOut,
                     bool Buy4n10,bool Buy5n9,bool Buy6n8,bool ComeFreeOdds,
                     bool DoNotComeFreeOdds,bool BuyPlaceOn,bool HardWaysOn);
  virtual int32 Odds();
  virtual void ClearSpot();
  virtual TMoney TrueOdds(TMoney amount,int16 winnum);
  virtual TMoney TrueOdds(TMoney amount,int16 winnum,int16 slot);
  virtual TMoney WinBSCash(int16 slot,int16 WinNum); // Give odds and remove cash, make chips glow
  virtual TMoney WinBSPayOff(int16 slot,int16 WinNum); // Give odds and remove cash, make chips glow
  virtual TMoney AddBSCash(int16 Slot,TMoney amount,bool ComeOut,int16 Point);
  virtual TMoney AddBSCash(int16 Slot,TMoney amount,bool ComeOut,int16 Point,bool Buy);  // add cash to bet spot
  virtual void SetNum();
};
//*******************************************************************
#endif