//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  bjact1st.h    // input
//    Project Name:  Casino
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     06/28/95   A. Krist    Original baseline
//  2.0     09/24/97   M.Perry     32-bit conversion.
//*******************************************************************
#if !defined __bjact1st_h
#define __bjact1st_h

#include "cbjglord.h"
#include "bjlordst.h"
//*******************************************************************
class TBJAct1State : public TBJLordState
{
public:
  dword StartingFUC;
  dword FUCLength;
  TResponder *BetSpot1Responder;
  TResponder *BetSpot2Responder;
  TResponder *BetSpot3Responder;
  TResponder *OneChipResponder;
  TResponder *FiveChipResponder;
  TResponder *TwentyFiveChipResponder;
  TResponder *OneHundredChipResponder;
  TResponder *OneThouChipResponder;
  TResponder *TenThouChipResponder;
  TResponder *RemoveDoubleResponder;
  TResponder *ClearNoInsureStandResponder;
  TResponder *SameYesInsureHitResponder;
  TResponder *DealSplitResponder;
  TResponder *AskExpertResponder;
  TResponder *MenuEscResponder;
  int16 remove,show;
  int16 WaitingOnWRCounter;
  bool       askexpertflag;
  bool       WaitOnDealerBJ;
  bool       FinishDealerBJ;
  bool       WaitOnPlace;
  bool       WaitOnSkit;
  bool       WaitOnShuffle;
  bool       WaitOnPreDealCom;
  bool       LookAtFirstPlayer;

public:
  TBJAct1State(TCasinoBJGameLord *pNewBJLord);
  virtual ~TBJAct1State();
  virtual void ExecuteFirstTime();
  virtual void CreateSubState1();
  virtual void CreateSubState2();
  virtual void CreateSubState3();
  virtual void CreateSubState4();
  virtual void EndSubState2();
  virtual void EndSubState3();
  virtual void EndSubState4();
  virtual bool HandleShuffleNewDeck();
  virtual bool HandleBetSpot1(TResponder &responder);
  virtual bool HandleBetSpot2(TResponder &responder);
  virtual bool HandleBetSpot3(TResponder &responder);
  virtual bool HandleOneChip(TResponder &responder);
  virtual bool HandleFiveChip(TResponder &responder);
  virtual bool HandleTwentyFiveChip(TResponder &responder);
  virtual bool HandleOneHundredChip(TResponder &responder);
  virtual bool HandleOneThouChip(TResponder &responder);
  virtual bool HandleTenThouChip(TResponder &responder);
  virtual bool HandleRemoveDouble(TResponder &responder);
  virtual bool HandleClearNoInsureStand(TResponder &responder);
  virtual bool HandleSameYesInsureHit(TResponder &responder);
  virtual bool HandleDealSplit(TResponder &responder);
  virtual bool HandleAskExpert(TResponder &responder);
  virtual bool HandleMenuEsc(TResponder &responder);
  virtual bool HandleNamePlate(TResponder &responder);

  virtual void HandlePostUpdate(dword NewFUC);
};
//*******************************************************************
#endif
