//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  bjbs3st.h    // bet spot 3 state
//    Project Name:  Casino
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     06/28/95   A. Krist    Original baseline
//  2.0     09/24/97   M.Perry     32-bit conversion.
//*******************************************************************
#if !defined __bjbs3st_h
#define __bjbs3st_h

#include "cbjglord.h"
#include "bjlordst.h"
//*******************************************************************
class TBJBetSpot3State : public TBJLordState
{
public:
  dword       Stalling;
  dword       StartingFUC;
  dword       FUCLength;

  TResponder *RemoveDoubleResponder;
  TResponder *ClearNoInsureStandResponder;
  TResponder *SameYesInsureHitResponder;
  TResponder *DealSplitResponder;
  TResponder *AskExpertResponder;
  TResponder *MenuEscResponder;

  bool        doubleflag;
  bool        firsttwocards;
  bool        splitflag;
  bool        splitbutton;
  bool        askexpertflag;
  bool        WaitOnSkit;

  bool        WaitOnHitCom;
  bool        WaitOnStandCom;
  bool        WaitOnDoubleCom;
  bool        FinishHit;
  bool        FinishStand;
  bool        FinishDouble;
  
public:
  TBJBetSpot3State(TCasinoBJGameLord *pNewBJLord);
  virtual ~TBJBetSpot3State();

  virtual void ExecuteFirstTime();
  virtual void CreateSubState1();
  virtual void CreateSubState2();
  virtual void CreateSubState3();
  virtual void CreateSubState4();
  virtual void CreateSubState5();
  virtual void EndSubState1();
  virtual void EndSubState2();
  virtual void EndSubState4();
  virtual bool HandleRemoveDouble(TResponder &responder);
  virtual bool HandleClearNoInsureStand(TResponder &responder);
  virtual bool HandleSameYesInsureHit(TResponder &responder);
  virtual bool HandleDealSplit(TResponder &responder);
  virtual bool HandleAskExpert(TResponder &responder);
  virtual bool HandleMenuEsc(TResponder &responder);

  virtual void HandlePostUpdate(dword NewFUC);
};
//*******************************************************************
#endif