//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  bjdeck.h
//    Project Name:  Ogle
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     06/01/95   A. Krist    Original baseline
//  2.0     09/23/97   M.Perry     32-bit conversion.
//*******************************************************************
#if !defined __bjdeck_h
#define __bjdeck_h

#include <iostream.h>
#include "card.h"
#include "bjhand.h"
#include "hand.h"
#include "casbjmw.h"

const DECK  = 52;
const DECK2 = 104;
const DECK4 = 208;
const DECK6 = 312;
//*******************************************************************
class TBJDeck
{
public:
  TCard  *deck;
  int16 NumCards;
  int16     top;

public:
  TBJDeck(int16 numofdecks = 1);
  virtual ~TBJDeck();
  int16 Swap(int16 x,int16 y);
  int16 InitDeck(int16 numofdecks);
  int16 Draw(THand * h,TBlackJackModeWin *pmwin);
  int16 Busted(THand * h);
  int16 FirstDeal(TBlackJackModeWin *pmwin);
  int16 BlackJack(TBJHand * h);
  int16 ChangeDecks(int16 newnumofdecks);
  int16 Shuffler(int16 decks);
  int16 DontSplitDraw(THand * h,TBlackJackModeWin *pmwin,int16 totalcards);
  virtual int16 InitTemp(){return 1;};
};
//*******************************************************************
#endif