//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  bjlordst.h
//    Project Name:  Ogle
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     06/01/95   A. Krist    Original baseline
//  2.0     09/23/97   M.Perry     32-bit conversion.
//*******************************************************************
#if !defined __bjlordst_h
#define __bjlordst_h

#include "ostate.h"
#include "cbjglord.h"
#include "bjaskex.h"

#define EXPERTDELAY 12

class TCasinoBJGameLord;
class TResponder;
//*******************************************************************
class TBJLordState : public TState
{
public:
  int16 lastaction;
  bool LockButtons;
  bool LockHit;
  bool IgnoreCoach;
  bool HitTotal;
  dword ExpertDelayStart;
  TCasinoBJGameLord *pOwnerLord;

public:
  TBJLordState(TCasinoBJGameLord *pNewBJLord);
  virtual ~TBJLordState();

  void  PlayerTotalMessage(int16 BCU); // BetSpotUse
  void Coach(int16 Spot,TBJAction Action);
  void CoachStats(int16 Spot,TBJAction Action,int16 FTC);//firsttwocards
  bool MenuEscButton(TResponder &responder);
  virtual bool HandleMenuEsc(TResponder &responder);

  bool BetSpot1(TResponder &responder);
  virtual bool HandleBetSpot1(TResponder &responder);

  bool BetSpot2(TResponder &responder);
  virtual bool HandleBetSpot2(TResponder &responder);

  bool BetSpot3(TResponder &responder);
  virtual bool HandleBetSpot3(TResponder &responder);

  bool OneChip(TResponder &responder);
  virtual bool HandleOneChip(TResponder &responder);

  bool FiveChip(TResponder &responder);
  virtual bool HandleFiveChip(TResponder &responder);

  bool TwentyFiveChip(TResponder &responder);
  virtual bool HandleTwentyFiveChip(TResponder &responder);

  bool OneHundredChip(TResponder &responder);
  virtual bool HandleOneHundredChip(TResponder &responder);

  bool AskExpertButton(TResponder &responder);
  virtual bool HandleAskExpert(TResponder &responder);

  bool OneThouChip(TResponder &responder);
  virtual bool HandleOneThouChip(TResponder &responder);

  bool TenThouChip(TResponder &responder);
  virtual bool HandleTenThouChip(TResponder &responder);

  bool RemoveDouble(TResponder &responder);
  virtual bool HandleRemoveDouble(TResponder &responder);

  bool ClearNoInsureStand(TResponder &responder);
  virtual bool HandleClearNoInsureStand(TResponder &responder);

  bool SameYesInsureHit(TResponder &responder);
  virtual bool HandleSameYesInsureHit(TResponder &responder);

  bool DealSplit(TResponder &responder);
  virtual bool HandleDealSplit(TResponder &responder);

  bool ShuffleNewDeck();
  virtual bool HandleShuffleNewDeck();

  bool StatBar(TResponder &responder);
  virtual bool HandleStatBar(TResponder &responder);

  bool NamePlate(TResponder &responder);
  virtual bool HandleNamePlate(TResponder &responder);

  TBJLookFromTo Looker(int16 lookingat,int16 lookto);
};
//*******************************************************************
#endif