//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  casdata.h
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0      9/9/96    M.Perry     moved into new file.
//  2.0     08/31/97   M.Perry     32-bit conversion.
//********************************************************************
#if !defined(__casdata_h)
#define __casdata_h

#include "otypedef.h"
#include "cgametyp.h"
#include <classlib\time.h>
//*******************************************************************
struct TCasinoSession
{
  // data
  bool Valid;
  bool InPlay;
  dword StartingTime;                       
  dword EndingTime;
//  TGameName GameName; // <-- Mike, remove this.
  int16 GameSubtype; //i.e., Alladins, Keno, etc. see cgametyp.h
  TMoney GameDenom;
  TMoney StartingCash;  //= Starting Bankroll
  TMoney EndingCash;    //= Ending Bankroll
  TMoney TotalBetsCash; //= Total $ Bet
  int16 Wins;
  int16 Losses;
  int16 HandsPlayed;
  int16 IncorrectPlays;
  int16 WinStreak;
  int16 LosingStreak;
  int16 CurrentWinStreak;
  int16 CurrentLosingStreak;
  TMoney LargestWin;
  TMoney LargestLoss;
  TMoney PeakWin;
  TMoney PeakLoss;

  //proc's
  TCasinoSession();
  void ClearData();
  void SetStartingTime();
  void SetEndingTime();
  void StartSession(TMoney startingcash,int16 subgametype,TMoney denom);
  void EndSession(TMoney endingcash);
};
//*******************************************************************
struct TCasinoData
{
  int16 CurrentSession;
  TCasinoData();
  TMoney OverallWL;
  void ClearData();
  int16 SessionIterator;
};
//*******************************************************************
#endif

