//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  casglord.h
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     10/11/95   M.Perry     original baseline
//  2.0     08/31/97   M.Perry     32-bit conversion.
//********************************************************************
#if !defined(__casglord_h)
#define __casglord_h                  

#include "oglord.h"
#include "casplay.h"
#include "casmw.h"
#include "cgametyp.h"

class TCasinoGameData;
//*******************************************************************
class TCasinoGameLord:public TGameLord
{
public:
  int16 SubGameType;
  TMoney GameDenom;
  int16 DenomID; // mrp - v2.5 - 09/27/99 - used w/ defines/enums for switch statements.
  int16 GetDenomID();
  int16  activeplayer;
  int16 GetActivePlayer(){return activeplayer;}
  bool WaitOnButtonDown;

  virtual bool AddCredits(int16 AddCredits) {return false;}
  // mrp - v2.5 - 09/27/99 - changed for new gamelord system.
//  TCasinoGameLord(TOgleModeWindow *PNewOwnerWindow,const TFileMode &fm,int16 subgametype,TMoney denom);
  TCasinoGameLord(TOgleModeWindow *PNewOwnerWindow,const TFileMode &fm,int16 subgametype,int16 denomid);
  virtual ~TCasinoGameLord();
  virtual int16 AskCriteriaQuestion(int16 QNum) {return 0;}
  TCasinoModeWin *GetCasMW() {return (TCasinoModeWin *)PModeWin;}
  TCasinoPlayer *GetCasPlayer(int16 slotnum);
  TCasinoPlayerData *GetCasPD(int16 slotnum);
  TCasinoGameData *GetCasGameData();
  void AddCash(int16 slotnum,TMoney cash);
  void SubCash(int16 slotnum,TMoney cash);
  TMoney GetCash(int16 slotnum);
  void SetCash(int16 slotnum,TMoney cash);
  virtual void  SetupActivePlayer(int16 slot) {}
  int16 GetNumActivePlayers();
  int16 NextSlotNum(int16 activeplayernum);
  virtual void Recommendation() {}
};
//*******************************************************************
#endif

