//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  cascdsp.h    //CashDisplay
//    Project Name:  Casino
// Original Author:  A.Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     9/26/95    A.Krist    original baseline
//  2.0    09/16/97    M.Perry    32-bit conversion.
//********************************************************************
#if !defined(__casmessp_h)
#define __casmessp_h

#include "osprite.h"
//*******************************************************************
enum TOddsMessage
{
  om1To2  = 1,
  om2To3  = 2,
  om5To6  = 3,
  om1To1  = 4,
  om2To1  = 5,
  om3To2  = 6,
  om6To5  = 7,
  om3To1  = 8,
  om9To5  = 9,
  om7To5  = 10,
  om7To6  = 11,
  om4To1  = 12,
  om7To1  = 13,
  om9To1  = 14,
  om15To1 = 15,
  om30To1 = 16,
  om5To1  = 17,
  om6To1  = 18,
  om8To1  = 19,
  om11To1 = 20,
  om17To1 = 21,
  om35To1 = 22
};
//*******************************************************************
class TCasMessageDisplay : public TSprite
{
public:
  TAnm           *PMessage;
  TAnm           *POdds;
  TAnm           *PThouComma;
  TAnm           *PMillComma;
  TAnm           *PBillComma;
  TAnm           *PDigits[11];
  long            DelayEndFUC;
  TMoney            Win;
  TMoney            Bet;
  bool            DELAY;
  void ShowMessage(int Code,TMoney money = 0l);
  void ShowLobbyMessage(int Code);
  void ShowBJMessage(int Code,TMoney money = 0l,bool BJack=false);
  void ShowCrapsMessage(int Code,TMoney money = 0l,int Point = 0);
  int HornOdds(int Point);
  int CEOdds(int Point);
  int FreeOdds(int Point);
  void CrapOdds(int Odds);
  void RouletteOdds(int Odds);
  void NoShowDisplay();
  void SetupAnms();
  TCasMessageDisplay(TOgleModeWindow *pmw,TFileMode NewFileMode);
  TCasMessageDisplay(TOgleModeWindow *pmw,TFileMode NewFileMode,void *psource);
  virtual ~TCasMessageDisplay();
  int SetNum(TMoney money,bool OddsOn=true);
};
//*******************************************************************
#endif