//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  ccact1st.h    // input
//    Project Name:  Casino
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     03/28/96   A. Krist    Original baseline
//  2.0     09/18/97   M.Perry     32-bit conversion.
//*******************************************************************
#if !defined _ccact1st_h
#define _ccact1st_h

#include "ccglord.h"
#include "cclordst.h"
//*******************************************************************
class TCAct1State : public TCLordState
{
public:
  TCAct1State(TCasinoCGameLord *pNewCLord);
  virtual ~TCAct1State();
  int16 oldspot;
  int16 BettingSpot;
  bool       IgnoreCoach;
  bool       IgnoreCoach2;
  bool       WaitOnD;
  bool       WaitOnExtendShake;
  bool       Throw;
  bool       WaitOnShake;
  bool       WaitOnNoComeOut;
  bool       WaitOnStall;
  bool       StallOn;
  bool       Roll;
  bool       AdvBets;
  bool       ContinueAdv;
  bool       WaitOnAdvBets;
  bool       WaitOnGiveDice;
  bool       SkitOn;
  bool       DiceGiven;
  bool       askexpertflag;
  bool       WaitOnSkit;
  bool       WaitOnRolling;
  bool   	 WaitOnDiceRolling;
  bool   	 FinishDiceRolling;
  bool   	 FinishDiceRoll;
  bool       WaitOnPreRollCom;
  bool       FinishDiceDrop;

  dword StartingFUC;
  dword FUCLength;
  dword ActionTime;
  TResponder *BetSpotResponder;
  TResponder *OneChipResponder;
  TResponder *FiveChipResponder;
  TResponder *TwentyFiveChipResponder;
  TResponder *OneHundredChipResponder;
  TResponder *OneThouChipResponder;
  TResponder *TenThouChipResponder;
  TResponder *Button1Responder;
  TResponder *Button2Responder;
  TResponder *Button3Responder;
  TResponder *Button4Responder;
  TResponder *ButtonFourResponder;
  TResponder *AskExpertResponder;
  TResponder *MenuEscResponder;
  int16 WaitingOnWRCounter;
  int16 randoutspin;
  virtual void ExecuteFirstTime();
  virtual void CreateSubState1();
  virtual void CreateSubState2();
  virtual void CreateSubState3();
  virtual void CreateSubState4();
  virtual void EndSubState2();
  virtual void EndSubState4();
  virtual bool HandleBetSpot(TResponder &responder,int16 Spot);
  virtual bool HandleOneChip(TResponder &responder);
  virtual bool HandleFiveChip(TResponder &responder);
  virtual bool HandleTwentyFiveChip(TResponder &responder);
  virtual bool HandleOneHundredChip(TResponder &responder);
  virtual bool HandleOneThouChip(TResponder &responder);
  virtual bool HandleTenThouChip(TResponder &responder);
  virtual bool HandleButton1(TResponder &responder);
  virtual bool HandleButton2(TResponder &responder);
  virtual bool HandleButton3(TResponder &responder);
  virtual bool HandleButton4(TResponder &responder);
  virtual bool HandleAskExpert(TResponder &responder);
  virtual bool HandleMenuEsc(TResponder &responder);
  virtual bool HandleNamePlate(TResponder &responder);

  virtual void HandlePostUpdate(dword NewFUC);
};
//*******************************************************************
#endif