//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  ccbssp.h   // BetSpot
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     10/2/95    A. Krist    original baseline
//  2.0     09/18/97   M.Perry     32-bit conversion.
//********************************************************************
#if !defined(__ccbssp_h)
#define __ccbssp_h

#include "osprite.h"
//*******************************************************************
enum  TCSpotType {DefaultSpot,Pass,PassNot,Come,ComeNot,ComeNum,DoNotComeNum,Hard,
						Field,Big,OneRoll,AnyCraps,CE,Buy,Lay,Si,Colum,Doze,Re,Blac,Od,Eve,Hig,Lo};

enum  TCSpot {COMEBET,COMENOT,PASSBET,PASSNOT,PLACEBET4,PLACEBET5,PLACEBET6,
				  PLACEBET8,PLACEBET9,PLACEBET10,BUYBET4,BUYBET5,BUYBET6,BUYBET8,
				  BUYBET9,BUYBET10,LAYBET4,LAYBET5,LAYBET6,LAYBET8,LAYBET9,
				  LAYBET10,FIELDBET,ANYSEVEN,ANYCRAPS,PROP2,PROP12,PROP3,PROP11,
				  HORNBET,HOPBET,HARD4,HARD10,HARD6,HARD8,ADDFREE4,ADDFREE5,
				  ADDFREE6,ADDFREE8,ADDFREE9,ADDFREE10,ADDNOT4,ADDNOT5,ADDNOT6,
				  ADDNOT8,ADDNOT9,ADDNOT10,REMOVEFREE4,REMOVEFREE5,REMOVEFREE6,
				  REMOVEFREE8,REMOVEFREE9,REMOVEFREE10};

//*******************************************************************
class TCBetSpot:public TSprite
{
public:
  TCSpotType  SpotType;
  int16   MessageCode;
  TAnm *PChips[3][6];
  TAnm *PSpark;
  TAnm *PChits[3];
  bool NotFound;
  int16  TopY,TopZ,TopAY,TopBY,TopCY,TopAZ,TopBZ,TopCZ;
  TMoney BetAmount[3];
  virtual void SetupAnms();
  virtual int16 MessCode(int16 Player);
  TCBetSpot(TOgleModeWindow *pmw,const TFileMode &NewFileMode,int16 MessageCode);
  TCBetSpot(TOgleModeWindow *pmw,const TFileMode &fm,void *psource,int16 MessageCode);
  virtual ~TCBetSpot();
  void ShowSpark();
  void ShowFreeOddsSpark(int16 slot);
  void NoShowSpark();
  void NoShowChips();
  virtual void AddCome(int16 slot,TMoney amount);
  virtual bool Winner(int16 FirstDice,int16 SecondDice,int16 Point,bool ComeOut);
  virtual bool Winner(int16 FirstDice,int16 SecondDice,int16 Point,bool ComeOut,
                      bool Buy4n10,bool Buy5n9,bool Buy6n8,bool ComeFreeOdds,
                      bool DoNotComeFreeOdds,bool BuyPlaceOn,bool HardWaysOn);
  virtual bool Loser(int16 FirstDice,int16 SecondDice,int16 Point,bool ComeOut);
  virtual bool Loser(int16 FirstDice,int16 SecondDice,int16 Point,bool ComeOut,
                     bool Buy4n10,bool Buy5n9,bool Buy6n8,bool ComeFreeOdds,
                     bool DoNotComeFreeOdds,bool BuyPlaceOn,bool HardWaysOn);
  virtual int32 Odds();
  virtual TMoney TrueOdds(TMoney amount,int16 winnum);
  virtual TMoney TrueOdds(TMoney amount,int16 winnum,int16 slot);
  virtual TMoney GetBSCash(int16 Slot);  // return amount of cash on bet spot
  virtual TMoney SubBSCash(int16 Slot,bool ComeOut);   // remove and return cash from bet spot
  virtual TMoney AddBSCash(int16 Slot,TMoney amount,bool ComeOut,int16 Point);  // add cash to bet spot
  virtual TMoney AddBSCash(int16 Slot,TMoney amount,bool ComeOut,int16 Point,bool Flag);  // add cash to bet spot
  virtual bool IsValidAdd(int16 Slot,TMoney amount,bool ComeOut,int16 Point);  //
  virtual bool IsValidRemove(int16 Slot,TMoney amount,bool ComeOut,int16 Point);  //
  void ClearGlowChips(int16 slot); //remove top glowing chips
  bool HasBSBet(int16 Slot); // Player has Money on bet spot?
  bool IsBSBet(); // Any Money on bet spot?
  virtual TMoney WinBSCash(int16 slot,int16 WinNum); // Give odds and remove cash, make chips glow
  virtual TMoney WinBSPayOff(int16 slot,int16 WinNum); // Give odds and remove cash, make chips glow
  TMoney StatWinBSCash(int16 slot,int16 WinNum); // Give odds plus bet
  virtual void ClearSpot();
  void SetSpot();
  virtual void SetNum();
  virtual TMoney ReturnFreeOdds(int16 slot);
  virtual TMoney ReturnFree(int16 slot,int16 dice1,int16 dice2);
  virtual TMoney GetBSFreeOdds(int16 slot);
};
//*******************************************************************
#endif