//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************* ***********************************************
//
//       File Name:  ccdata.h
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     9/9/96     M.Perry    split up cplaydat file.
//  2.0    09/17/97    M.Perry    32-bit conversion.
//********************************************************************
#if !defined(__ccdata_h)
#define __ccdata_h

#include "casdata.h"
//*******************************************************************
struct TCCSession : public TCasinoSession
{
  TCCSession();
  bool RightBetCurrentShoot;
  bool WrongBetCurrentShoot;
  TMoney CurrentTotalShootCashWLRB;
  TMoney CurrentTotalShootCashWLWB;
  int16  CurrentWinningStreakRB;
  int16  CurrentWinningStreakWB;
  int16  CurrentLongestShoot;
  int16  CurrentLongestPassStreak;
  int16  CurrentLongestDoNotPassStreak;
  int16 TotalShoots;
  int16 Numpasswins;
  int16 Numnaturals;
  int16 Numpointsmade;
  int16 Numdontpasswins;
  int16 Numcrapouts;
  int16 Numsevenouts;
  int16 LongestShootNumRolls;
  int16 LongestPassStreak;
  int16 LongestDontPassStreak;
  int16 NumShootsBettingRight;
  TMoney TotalCashBetRightBettor;
  TMoney AverageCashBetperShootRightBettor;
  int16 NumShootsWonCashRightBettor;
  int16 NumShootsLostCashRightBettor;
  TMoney TotalCashWonLostRightBettor;
  TMoney AvgCashWonLostperShootRightBettor;
  int16 LongestWinStreakRightBettor;
  TMoney MostCashWon1ShootRightBettor;
  TMoney MostCashLost1ShootRightBettor;
  int16 NumShootsBettingWrong;
  TMoney TotalCashBetWrongBettor;
  TMoney AverageCashBetperShootWrongBettor;
  int16 NumShootsThatWonCashWrongBettor;
  int16 NumShootsThatLostCashWrongBettor;
  TMoney TotalCashWonLostWrongBettor;
  TMoney AvgCashWonLostperShootWrongBettor;
  int16 LongestWinStreakWrongBettor;
  TMoney MostCashWon1ShootWrongBettor;
  TMoney MostCashLost1ShootWrongBettor;
  TMoney PassBetsCash;
  TMoney PassFreeOddsBetsCash;
  TMoney DontPassBetsCash;
  TMoney DontPassFreeOddsBetsCash;
  TMoney ComeBetsCash;
  TMoney ComeFreeOddsBetsCash;
  TMoney DontComeBetsCash;
  TMoney DontComeFreeOddsBetsCash;
  TMoney FieldBetsCash;
  TMoney HardwaysBetsCash;
  TMoney Big6Big8BetsCash;
  TMoney Buy4BetsCash;
  TMoney Place5BetsCash;
  TMoney Place6BetsCash;
  TMoney Place8BetsCash;
  TMoney Place9BetsCash;
  TMoney Buy10BetsCash;
  TMoney Place410BetsCash;
  TMoney Buy59BetsCash;
  TMoney Buy68BetsCash;
  TMoney Lay410BetsCash;
  TMoney Lay59BetsCash;
  TMoney Lay68BetsCash;
  TMoney PropositionBetsCash;
  TMoney TotalCashWon;
  TMoney TotalCashLost;
  TMoney PassBetsCashWL;
  TMoney PassFreeOddsBetsCashWL;
  TMoney DontPassBetsCashWL;
  TMoney PassFreeOddsBetsCashWL87;
  TMoney ComeBetsCashWL;
  TMoney ComeFreeOddsBetsCashWL;
  TMoney DontComeBetsCashWL;
  TMoney DontComeFreeOddsBetsCashWL;
  TMoney FieldBetsCashWL;
  TMoney HardwaysBetsCashWL;
  TMoney Big6Big8BetsCashWL;
  TMoney Buy4BetsCashWL;
  TMoney Place5BetsCashWL;
  TMoney Place6BetsCashWL;
  TMoney Place8BetsCashWL;
  TMoney Place9BetsCashWL;
  TMoney Buy10BetsCashWL;
  TMoney Place410BetsCashWL;
  TMoney Buy59BetsCashWL;
  TMoney Buy68BetsCashWL;
  TMoney Lay410BetsCashWL;
  TMoney Lay59BetsCashWL;
  TMoney Lay68BetsCashWL;
  TMoney PropositionBetsCashWL;
  int16 NumHighPercentageBets;
  int16 NumLowPercentageBets;

  void ClearData();
  void StartSession(TMoney startingcash,int16 subgametype,TMoney denom);
  void EndSession(TMoney endingcash);
};
//*******************************************************************
struct TCasinoCData : public TCasinoData
{
  TCCSession Sessions[NUMSESSIONS];
  TMoney Cumulative;
  bool Buy4and10;
  bool Buy5and9;
  bool Buy6and8;
  bool FreeOddsOn;
  bool DoNotFreeOddsOn;
  bool BuyandPlaceOn;
  bool HardwayOn;

  TCasinoCData();
  void ClearData();
  void StartSession(TMoney startingcash,int16 subgametype = cc1,
                    TMoney denom = TMoney(TMoney::ctorDenomID,TMoney::did_1_00));//cd1);
  void EndSession(TMoney endingcash);
  int16 GetFirstValidSession();
  int16 GetNextValidSession();
  void IncCurrentSession();
  int16 GetPrevValidSession();
  void SetOddsToDefault();

  // the following are static so we don't need an actual instance to
  // get the default values. (used by TCasinoCrapsModeWindow)
  static bool GetBuy4and10Def()     {return true;}
  static bool GetBuy5and9Def()      {return false;}
  static bool GetBuy6and8Def()      {return false;}
  static bool GetFreeOddsDef()      {return false;}
  static bool GetDoNotFreeOddsDef() {return true;}
  static bool GetBuyandPlaceDef()   {return false;}
  static bool GetHardwayDef()       {return true;}
  void ToggleBuy4and10()     {Buy4and10       = !Buy4and10;}
  void ToggleBuy5and9()      {Buy5and9        = !Buy5and9;}
  void ToggleBuy6and8()      {Buy6and8        = !Buy6and8;}
  void ToggleFreeOdds()      {FreeOddsOn      = !FreeOddsOn;}
  void ToggleDoNotFreeOdds() {DoNotFreeOddsOn = !DoNotFreeOddsOn;}
  void ToggleBuyandPlace()   {BuyandPlaceOn   = !BuyandPlaceOn;}
  void ToggleHardway()       {HardwayOn       = !HardwayOn;}
};
//*******************************************************************
#endif
