//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  cclordst.h
//    Project Name:  Ogle
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     06/01/95   A. Krist    Original baseline
//  2.0     09/18/97   M.Perry     32-bit conversion.
//*******************************************************************
#if !defined _cclordst_h
#define _cclordst_h

#include "ostate.h"
#include "ccglord.h"
#define EXPERTDELAY 12

class TCasinoCGameLord;
class TResponder;
//*******************************************************************
class TCLordState : public TState
{
public:
  bool LockButtons;
  bool LockHit;
  bool IgnoreCoach;
  bool HitTotal;
  dword ExpertDelayStart;
  TCasinoCGameLord *pOwnerLord;

  TCLordState(TCasinoCGameLord *pNewCLord);
  virtual ~TCLordState();

  bool MenuEscButton(TResponder &responder);
  virtual bool HandleMenuEsc(TResponder &responder) {return true;}

  bool BetSpot(TResponder &responder,int16 Spot);
  virtual bool HandleBetSpot(TResponder &responder,int16 Spot) {return true;}

  bool OneChip(TResponder &responder);
  virtual bool HandleOneChip(TResponder &responder) {return true;}

  bool FiveChip(TResponder &responder);
  virtual bool HandleFiveChip(TResponder &responder) {return true;}

  bool TwentyFiveChip(TResponder &responder);
  virtual bool HandleTwentyFiveChip(TResponder &responder) {return true;}

  bool OneHundredChip(TResponder &responder);
  virtual bool HandleOneHundredChip(TResponder &responder) {return true;}

  bool AskExpertButton(TResponder &responder);
  virtual bool HandleAskExpert(TResponder &responder) {return true;}

  bool OneThouChip(TResponder &responder);
  virtual bool HandleOneThouChip(TResponder &responder) {return true;}

  bool TenThouChip(TResponder &responder);
  virtual bool HandleTenThouChip(TResponder &responder) {return true;}

  bool Button1(TResponder &responder);
  virtual bool HandleButton1(TResponder &responder) {return true;}

  bool Button2(TResponder &responder);
  virtual bool HandleButton2(TResponder &responder) {return true;}

  bool Button3(TResponder &responder);
  virtual bool HandleButton3(TResponder &responder) {return true;}

  bool Button4(TResponder &responder);
  virtual bool HandleButton4(TResponder &responder) {return true;}

  bool StatBar(TResponder &responder);
  virtual bool HandleStatBar(TResponder &responder) {return true;}

  bool NamePlate(TResponder &responder);
  virtual bool HandleNamePlate(TResponder &responder) {return true;}
};
//*******************************************************************
#endif