//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  cgametyp.h
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     5/31/96    M.Perry     original baseline
//  2.0    08/31/97    M.Perry     32-bit conversion.
//********************************************************************
#if !defined(__cgametyp_h)
#define __cgametyp_h

#include "casctrl.h"
//*******************************************************************
typedef enum tagCasAppType
{
  catNone = 0,
  catCasino = 1,
  catSlotLite = 2,
  catVPLite = 3,
  catHunSlots = 4,
  catACVP = 5
}TCasAppType;
//*******************************************************************
typedef enum tagCasAppSubType
// future: hook into debug defines and have release,demo,debug,etc types avail.
{
  castNone = 0,
  castDemo = 1
}TCasAppSubType;
//*******************************************************************
typedef enum tagCasGameType
{
  gtNone       = 0,
  gtVideoPoker = 1,
  gtBlackJack  = 2,
  gtRoulette   = 3,
  gtCraps      = 4,
  gtSlots      = 5,
  gtKeno       = 6,
  gtOverall    = 7,
  gtIntro      = 8,
  gtLobby      = 9
}TCasGameType;
//*********************** SubGameTypes ******************************
typedef enum tagCasSubGameType
{
  sgtNone = 0
}TCasSubGameType;
//*********************** Intro *************************************
typedef enum tagCasIntroGameType
{
  ciNone = 0,
  ciACCIntro = 1,
  ciACHSIntro = 2,
  ciACVPIntro = 3
}TCasIntroGameType;
//*********************** Lobby *************************************
typedef enum tagCasLobbyGameType
{
  clNone = 0,
  clACCLobby = 1,
  clACHSLobby = 2,
  clACVPLobby = 3
}TCasLobbyGameType;
//*********************** Black Jack ********************************
#if defined(BJ_COMPILE)
typedef enum tagCasBJGameType
{
  cbjNone  = 0,
  cbj1Deck = 1, //1 Deck
  cbj2Deck = 2, //2 Deck
  cbj4Deck = 4, //4 Deck
  cbj6Deck = 6  //6 Deck
}TCasBJGameType;
#endif
//*********************** Video Poker *******************************
#if defined(VP_COMPILE)
typedef enum tagCasVPGameType
{
  cvpNone = 0,
  cvpDeucesWild    = 1,
  cvpJokersWild    = 2,
  cvpJacksOrBetter = 3,
  cvpTensOrBetter  = 4,
  cvpJacksProgressive = 5,
  ///
  cvpFivesUp = 6,
  cvpBlackJacks = 7,
  cvpBonusDeluxe = 8,
  cvpClubBonus = 9,
  cvpCrazy8s = 10,
  cvpDDrawJB = 11,
  cvpDDrawJokerPoker = 12,
  cvpDDownStud = 13,
  cvpDeucesWildBonus = 14,
  cvpDeucesWildII = 15,
  cvpDeucesWildProg = 16,
  cvpDiamondBonus = 17,
  cvpDBonusPoker = 18,
  cvpFlushAssault = 19,
  cvpFreeLook = 20,
  cvpGamblersEdge = 21,
  cvpHeartBonus = 22,
  cvpJacksProgII = 23,
  cvpJackpotBonus = 24,
  cvp96JacksOrBetterII = 25,
  cvp85JacksOrBetter = 26,
  cvpDJacksOrBetter = 27,
  cvpJokersWildProg = 28,
  cvpJumpinJokers = 29,
  cvpTripleProg = 30,
  cvpRoyalProg = 31,
  cvpPowerProg = 32,
  cvpRaiseJokersWild = 33,
  cvpSpadeBonus = 34,
  cvpSuperDJackpot = 35,
  cvp7Wild1Joker = 36,
  cvpTensOrBetterII = 37,
  cvpTreasureTrove = 38,
  cvpTriplePlay = 39,
  cvpTripleBonus = 40,
  cvpWheelDeal = 41
}TCasVPGameType;
#endif
//************************* Roulette ********************************
#if defined(ROULETTE_COMPILE)
typedef enum tagCasRGameType
{
  crNone = 0,
  cr1 = 1
}TCasRGameType;
#endif
//************************ Craps ************************************
#if defined(CRAPS_COMPILE)
typedef enum tagCasCGameType
{
  ccNone = 0,
  cc1 = 1
}TCasCGameType;
#endif
//************************ Slots ************************************
#if defined(SLOTS_COMPILE)
typedef enum tagCasSlGameType
{
  cslNone              = 0,
  cslAlladinsLamp      = 1, // start of ACC slot games
  cslParadiseDreaming  = 2,
  cslCherrySlam        = 3,
  cslJungleJingle      = 4,
  cslLuckyLeprechaun   = 5,
  cslTotalEclipse      = 6,
  cslJokersWild        = 7,
  cslPiratesPlunder    = 8,
  cslSpiritOf76        = 9,  // end of ACC slot games
  cslRockRoll          = 10, // start of HunSlots slot games
  cslPoolShark         = 11,
  cslGoldRush          = 12,
  cslTreasuresAtlantis = 13,
  cslZodiacAttackI     = 14,
  cslZodiacAttackII    = 15,
  cslZodiacAttackIII   = 16,
  cslFruitLoot         = 17,
  cslRagsRiches        = 18,
  cslSilverSafari      = 19,
  cslTexasTwister      = 20,
  cslThunderAlley      = 21,
  cslTreasureHaunt     = 22,
  cslTycoonsTrust      = 23,
  cslWinnersCircle     = 24,
  cslCashQuest         = 25,
  cslBirthdayBash      = 26,
  cslSouthernCross     = 27,
  cslMonkeyMadness     = 28,
  cslAlienInvasion     = 29,
  cslSuperJackpot      = 30,
  cslRoadRally         = 31,
  cslHotReels          = 32,
  cslSwampMusic        = 33,
  cslLightningStrikes  = 34,
  cslQuestGold         = 35,
  cslShootMoon         = 36, // end of HunSlots slot games
  cslCrystalPalace     = 37, // start of acvp slot games
  cslSuperSevens       = 38  // end of acvp slot games
}TCasSlGameType;
#endif
//************************ Keno *************************************
#if defined(KENO_COMPILE)
typedef enum tagCasKGameType
{
  ckNone = 0,
  ck1 = 1
}TCasKGameType;
#endif
//*******************************************************************
#endif
