//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  cgraph.h
//    Project Name:  Casino
// Original Author:  Dave Anderson
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     9/9/96     M.Perry    renamed & modified during stat's restructuring.
//  2.0     9/16/97    M.Perry    32-bit conversion.
//********************************************************************
#if !defined (__cgraph_h)
#define __cgraph_h

#include "cstats.rh"
#include "otypedef.h"
#include <owl/dialog.h>
#include <owl\combobox.h>
#include <owl/gdiobjec.h>
#include <owl/button.h>
#include "cplaydat.h"

#define MAX_STAT_CB_ENTRIES 25
#define MAX_GRAPH_SESSIONS NUMSESSIONS
#define NUM_X_TICKS (MAX_GRAPH_SESSIONS + 1)
#define NUM_Y_TICKS 20

class TCasinoStatDlg;
class TCasinoStatCalc;
//*******************************************************************
class TCasinoGraphDlg:public TDialog
{
protected:
  virtual void LoadLB();
  virtual void GetData();
  virtual string GetTitle();
  string strName;
  string strSlash;
  void SetTitle();
  int BaseStringID;
  int GetStatStrID(int stat_enum) {return (BaseStringID + stat_enum);}
  int StatTT[MAX_STAT_CB_ENTRIES];
  string StatLabelStr[MAX_STAT_CB_ENTRIES];
  bool UseStatLabelStr;
protected:
  int EstablishNumYDivisions();
  BOOL DoTheXCharsFit(TPaintDC& dc);
  TCasinoStatDlg* PStatDlg;
  int m_numYDivisions;
  int m_xRes,m_yRes;
  int m_dialogWidth;
  int m_dialogHeight;
  TButton* m_OK;
  void SetBoxSize();
  int m_box_X1,m_box_Y1,m_box_X2,m_box_Y2;
  void SetAxesPositions();
  int m_topofYAxis_X1, m_topofYAxis_Y1,m_topTickOfY;
  int m_Origin_Y,m_Origin_X,m_EndofXAxis_X,m_EndofXAxis_Y;
  int m_nOffset;

  int m_XTick[NUM_X_TICKS];
  int m_YTick[NUM_Y_TICKS];

  void EstablishXTickDivisions();
  void EstablishYTickDivisions(TPaintDC& dc);
  BOOL DrawXTicks(TPaintDC& dc);
  void DrawXLabel(TPaintDC& dc);
  void DrawResults(TPaintDC& dc);
  void DrawYLabels(TPaintDC& dc);
  void DrawYTicksAndLabels(TPaintDC& dc);
  void DrawXAxis(TPaintDC& dc);
  void DrawYAxis(TPaintDC& dc);
//  long int m_nMin,m_nMax,m_nRange;
  float m_nMin,m_nMax,m_nRange;

  void FindMinMaxAndRange();
  int m_nZeroY;
  float m_fScale;
  float FindYScale();
  int StatIndex;
  int LastStatIndex;
  bool CheckStatIndex(int statindex) {return (statindex >= 0 && statindex <= LastStatIndex)?true:false;}
  short m_RED,m_GREEN,m_BLUE;
  TCasinoStatCalc *PStatCalc;
public:
  TCasinoGraphDlg(TCasinoStatDlg* pstatdlg,TCasinoStatCalc *pstatcalc,TResId resIdDialog = IDD_GRAPH);
  virtual ~TCasinoGraphDlg();

  void EvCbnSelchange();
  TComboBox* PStats_CB;
  void SetupWindow();
  void EvPaint();
  void CmOK();
  void SetResults(float* intArray);
  float GraphValues[MAX_GRAPH_SESSIONS];

  DECLARE_RESPONSE_TABLE(TCasinoGraphDlg);
};
//*******************************************************************
#endif