//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  ckact1st.h    // input
//    Project Name:  Casino
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     03/28/96   A. Krist    Original baseline
//  2.0     09/17/97   M.Perry     32-bit conversion.
//*******************************************************************
#if !defined _ckact1st_h
#define _ckact1st_h

#include "ckglord.h"
#include "cklordst.h"
//*******************************************************************
class TKAct1State : public TKLordState
{
public:
  dword empty;
  dword nolen;
  bool  StartTrash;
  bool  FinishTrash;
  bool  historyleftflag;
  bool  historyrightflag;
  int32 timedelta;
  int16 historyDelta;
  TKAct1State(TCasinoKGameLord *pNewKLord);
  virtual ~TKAct1State();
  bool askexpertflag;

  TResponder *HistoryLeftResponder;
  TResponder *HistoryRightResponder;
  TResponder *TicketLeftResponder;
  TResponder *TicketRightResponder;
  TResponder *BetAmountResponder;
  TResponder *BetSpotResponder;
  TResponder *PlaysResponder;
  TResponder *GamesResponder;
  TResponder *Button1Responder;
  TResponder *Button2Responder;
  TResponder *Button3Responder;
  TResponder *Button4Responder;
  TResponder *AskExpertResponder;
  TResponder *MenuEscResponder;

  virtual void ExecuteFirstTime();
  virtual bool HandleBetAmount(TResponder &responder);
  virtual bool HandlePlays(TResponder &responder);
  virtual bool HandleGames(TResponder &responder);
  virtual bool HandleHistoryLeft(TResponder &responder);
  virtual bool HandleHistoryRight(TResponder &responder);
  virtual bool HandleTicketLeft(TResponder &responder);
  virtual bool HandleTicketRight(TResponder &responder);
  virtual bool HandleBetSpot(TResponder &responder,int16 Spot);
  virtual bool HandleButton1(TResponder &responder);
  virtual bool HandleButton2(TResponder &responder);
  virtual bool HandleButton3(TResponder &responder);
  virtual bool HandleButton4(TResponder &responder);
  virtual bool HandleAskExpert(TResponder &responder);
  virtual bool HandleMenuEsc(TResponder &responder);
  virtual bool HandleNamePlate(TResponder &responder);

  virtual void HandlePostUpdate(dword NewFUC);
};
//*******************************************************************
#endif