//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  ckdata.h
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     9/9/96     M.Perry    split up cplaydat file.
//  2.0    09/17/97    M.Perry    32-bit conversion.
//********************************************************************
#if !defined(__ckdata_h)
#define __ckdata_h

#include "casdata.h"

#define MAX_KENO_SPOTS 80
//*******************************************************************
enum TKenoGame
{
  kgNone          = 0,
  kg1Spot         = 1,
  kg2Spot         = 2,
  kg3Spot         = 3,
  kg3SpotSpecial  = 4,
  kg4Spot         = 5,
  kg4SpotSpecial  = 6,
  kg5Spot         = 7,
  kg6Spot         = 8,
  kg6SpotSpecial  = 9,
  kg7Spot         = 10,
  kg8Spot         = 11,
  kg9Spot         = 12,
  kg10Spot        = 13
};
//*******************************************************************
struct TKenoTicket
{
  int32      startinggame;
  TMoney    paid;
  TMoney    amountper;
  int16       ticketnum;
  int16       plays;
  int16       LoserPrintType;
  bool      spots[MAX_KENO_SPOTS];
  bool      New;
  TKenoGame game;

};
//*******************************************************************
struct TCKSession : public TCasinoSession
{
  TCKSession();

  int16  nTotalBets;
  int16  nWinningBets;
  int16  nLosingBetsLost;
  int16  nLongestWinningStreak;
  int16  nLongestLosingStreak;
  TMoney lLargestCashWin1Ticket;
  TMoney lLargestCashLoss1Ticket;
  TMoney lPeakCashWinLevel;
  TMoney lLowCashLossLevel;
  int16  nNum1SpotBets;
  int16  nNum2SpotBets;
  int16  nNum3SpotBets;
  int16  nNum4SpotBets;
  int16  nNum5SpotBets;
  int16  nNum6SpotBets;
  int16  nNum7SpotBets;
  int16  nNum8SpotBets;
  int16  nNum9SpotBets;
  int16  nNum10SpotBets;
  int16  nNum3SpotSpecialBets;
  int16  nNum4SpotSpecialBets;
  int16  nNum6SpotSpecialBets;

  //these are the tracked but not displayed total cash played per bet vars
  TMoney l1SpotBetsCash;
  TMoney l2SpotBetsCash;
  TMoney l3SpotBetsCash;
  TMoney l4SpotBetsCash;
  TMoney l5SpotBetsCash;
  TMoney l6SpotBetsCash;
  TMoney l7SpotBetsCash;
  TMoney l8SpotBetsCash;
  TMoney l9SpotBetsCash;
  TMoney l10SpotBetsCash;
  TMoney l3SpotSpecialBetsCash;
  TMoney l4SpotSpecialBetsCash;
  TMoney l6SpotSpecialBetsCash;

  TMoney l1SpotBetsCashWL;
  TMoney l2SpotBetsCashWL;
  TMoney l3SpotBetsCashWL;
  TMoney l4SpotBetsCashWL;
  TMoney l5SpotBetsCashWL;
  TMoney l6SpotBetsCashWL;
  TMoney l7SpotBetsCashWL;
  TMoney l8SpotBetsCashWL;
  TMoney l9SpotBetsCashWL;
  TMoney l10SpotBetsCashWL;
  TMoney l3SpotSpecialBetsCashWL;
  TMoney l4SpotSpecialBetsCashWL;
  TMoney l6SpotSpecialBetsCashWL;

  int16  nTotalGames;
  int16  nMostFrequentNums[MAX_KENO_SPOTS];

  void ClearData();
  void StartSession(TMoney startingcash,int16 subgametype,TMoney denom);
  void EndSession(TMoney endingcash);
};
//*******************************************************************
struct TCasinoKData : public TCasinoData
{
  TCKSession Sessions[NUMSESSIONS];
  TKenoTicket tickets[100];
  TMoney Cumulative;
  TCasinoKData();
  void ClearData();
  void StartSession(TMoney startingcash,int16 subgametype = ck1,
                    TMoney denom = TMoney(TMoney::ctorDenomID,TMoney::did_1_00));//cd1);
  void EndSession(TMoney endingcash);
  int16 GetFirstValidSession();
  int16 GetNextValidSession();
  bool IsActiveTicket();
  void IncCurrentSession();
  int16 GetPrevValidSession();
};
//*******************************************************************
#endif