//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  clglord.h
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     10/11/95   M.Perry     original baseline
//  2.0     09/25/97   M.Perry     32-bit conversion.
//  2.3     07/08/99   M.Perry     gobjlist removal
//********************************************************************
#if !defined(__clglord_h)
#define __clglord_h

#include "caslgld.h"

class TLobbyModeWin;
class TLLordMainState;

#include "cgametyp.h"
#include "casbutsp.h"  // Button
#include "clmessp.h"   //Message Display
//*******************************************************************
enum TGLordLID
{
  idHotSpot1,
  idHotSpot2,
  idHotSpot3,
  idHotSpot4,
  idHotSpot5,
  idHotSpot6,
  idHotSpot7,
  idHotSpot8,
  idHotSpot9,
  idHotSpot10,
  idHotSpot11,
  idHotSpot12,
  idHotSpot13,
  idHotSpot14,
  idHotSpot15,
  idHotSpot16,
  idHotSpot17,
  idHotSpot18,
  idHotSpot19,
  idHotSpot20,
  idHotSpot21,
  idHotSpot22,
  idHotSpot23,
  idHotSpot24,
  idHotSpot25,
  idHotSpot26,
  idHotSpot27,
  idHotSpot28,
  idHotSpot29,
  idHotSpot30,
  idHotSpot31,
  idHotSpot32,
  idHotSpot33,
  idHotSpot34,
  idHotSpot35,
  idHotSpot36,
  idHotSpot37,
  idHotSpot38,
  idHotSpot39,
  idHotSpot40,
  idHotSpot41,
  idHotSpot42,
  idHotSpot43,
  idHotSpot44,
  idHotSpot45,
  idHotSpot46,
  idHotSpot47,
  idHotSpot48,
  idHotSpot49,
  idHotSpot50,
  idHotSpot51,
  idHotSpot52,
  idHotSpot53,
  idHotSpot54,
  idHotSpot55,
  idHotSpot56,
  idHotSpot57,
  idHotSpot58,
  idHotSpot59,
  idHotSpot60,
  idHotSpot61,
  idCrap,
  idRoulette,
  idBlackJack,
  idKeno,
  idSlots,
  idVideoPoker,
  idSpeed,
  idButton0
};
//#define NumResponders 62
//*******************************************************************
enum TLobbyIdleEnum
{
  liCrapsDealer = 1,
  liRouletteDealer = 2,
  liBJDealer = 3,
  liFountain = 4,
  liVPSign = 5,
  liSlots = 6,
  liProgSign = 7,
  liKeno = 8,
  liEscalator = 9,
  liHorse = 10,
  liMessageThingy = 11,
  liWheel = 12,
  liLight1 = 13,
  liLight2 = 14,
  liLight3 = 15,
  liLight4 = 16,
  liWater = 17,
  liSlot1 = 18,
  liSlot2 = 19,
  liSlot3 = 20
};
//*******************************************************************
class TCasinoLGameLord:public TCasLobbyGameLord
{
public:
  enum {NumResponders = 62};

  int16 MsgCodes[NumResponders];
  int16 CmdCodes[NumResponders];

  TResponder *Responders[NumResponders];

  virtual TSprite *CreateSprite(string spritename,int16 id = 0,void *psource = NULL);

  TLobbyModeWin           *pMWin;
  TCasButton              *MenuEscButton;
  TCasLobbyMessageDisplay *MessageDisplay;
  TSprite *PLow1;
  TSprite *PLow2;
  TSprite *PLow3;
  TSprite *PLow4;
  TSprite *PLow5;
  TSprite *PLow6;
  TSprite *PLow7;
  TSprite *PLow8;
  TSprite *PWater;

  int16 ButtonInfo;
  int16 playersin;
  int16 shutdownstate;

  bool ButtonHit[1];
  bool ProgSignKilled;

public:
  TCasinoLGameLord(TLobbyModeWin *PNewOwnerWindow,const TFileMode &fm);
  virtual ~TCasinoLGameLord();
  virtual bool Respond(TResponder &responder);
  void ButtonClear(int16 button);
  virtual bool Respond(int16 Button,int16 info = 0,void *pdata = NULL);
  void SetupResponders();
  void CleanupResponders();
  bool SetBJIdle(int16 set = 0);
  bool SetCrapIdle(int16 set = 0);
  bool SetRouletteIdle(int16 set = 0);
  bool SetFountainIdle(int16 set = 0);
  bool SetVPSignIdle(int16 set = 0);
  bool SetSlotsIdle(int16 set = 0);
  bool SetProgSignIdle(int16 set = 0);
  bool SetKeno(int16 set = 0);
  bool SetHorse(int16 set = 0);
  bool SetLight1(int16 set = 0);
  bool SetLight2(int16 set = 0);
  bool SetLight3(int16 set = 0);
  bool SetLight4(int16 set = 0);
  bool SetWheel(int16 set = 0);
  bool SetEscalator(int16 set = 0);
  bool SetWater(int16 set = 0);
  bool SetSlot1(int16 set = 0);
  bool SetSlot2(int16 set = 0);
  bool SetSlot3(int16 set = 0);
  int16 Switch();
  int16 InitL();
  int16 GetPlayin() {return playersin;};
  void  SwitchToPlayer(int16 player);
  void  CyclePlayers();
  virtual void SetupActivePlayer(int16 slot);
  virtual void ShuttingDown();
  virtual void NotifyPlayerActivation(int16 slotnum);
  virtual void NotifyPlayerDeActivation(int16 slotnum);
  virtual void SetupSprites();
  virtual void CleanupSprites();
  virtual void Update(dword fuc);
  virtual void TurnOnNext();
  virtual void TurnOffNext();

  #if defined(SUPPORT_OLD_VER)
  virtual void SetupUniqueIDStrings();
  virtual int16 GetUniqueID(const string &s);
  string strMsgDisplay;
  string strMenuEsc;
  string strLow1;
  string strLow2;
  string strLow3;
  string strLow4;
  string strLow5;
  string strLow6;
  string strLow7;
  string strLow8;
  string strWater;
  #endif
};
//*******************************************************************
//*********************** inlines ***********************************
//*******************************************************************
inline bool TCasinoLGameLord::SetBJIdle(int16 set)
{
  return SetCurrentSpriteSet(liBJDealer,set);
}
//*******************************************************************
inline bool TCasinoLGameLord::SetCrapIdle(int16 set)
{
  return SetCurrentSpriteSet(liCrapsDealer,set);
}
//*******************************************************************
inline bool TCasinoLGameLord::SetRouletteIdle(int16 set)
{
  return SetCurrentSpriteSet(liRouletteDealer,set);
}
//*******************************************************************
inline bool TCasinoLGameLord::SetFountainIdle(int16 set)
{
  return SetCurrentSpriteSet(liFountain,set);
}
//*******************************************************************
inline bool TCasinoLGameLord::SetVPSignIdle(int16 set)
{
  return SetCurrentSpriteSet(liVPSign,set);
}
//*******************************************************************
inline bool TCasinoLGameLord::SetSlotsIdle(int16 set)
{
  return SetCurrentSpriteSet(liSlots,set);
}
//*******************************************************************
inline bool TCasinoLGameLord::SetProgSignIdle(int16 set)
{
  return SetCurrentSpriteSet(liProgSign,set);
}
//*******************************************************************
inline bool TCasinoLGameLord::SetKeno(int16 set)
{
  return SetCurrentSpriteSet(liKeno,set);
}
//*******************************************************************
inline bool TCasinoLGameLord::SetHorse(int16 set)
{
  return SetCurrentSpriteSet(liHorse,set);
}
//*******************************************************************
inline bool TCasinoLGameLord::SetLight1(int16 set)
{
  return SetCurrentSpriteSet(liLight1,set);
}
//*******************************************************************
inline bool TCasinoLGameLord::SetLight2(int16 set)
{
  return SetCurrentSpriteSet(liLight2,set);
}
//*******************************************************************
inline bool TCasinoLGameLord::SetLight3(int16 set)
{
  return SetCurrentSpriteSet(liLight3,set);
}
//*******************************************************************
inline bool TCasinoLGameLord::SetLight4(int16 set)
{
  return SetCurrentSpriteSet(liLight4,set);
}
//*******************************************************************
inline bool TCasinoLGameLord::SetWheel(int16 set)
{
  return SetCurrentSpriteSet(liWheel,set);
}
//*******************************************************************
inline bool TCasinoLGameLord::SetEscalator(int16 set)
{
  return SetCurrentSpriteSet(liEscalator,set);
}
//*******************************************************************
inline bool TCasinoLGameLord::SetWater(int16 set)
{
  return SetCurrentSpriteSet(liWater,set);
}
//*******************************************************************
inline bool TCasinoLGameLord::SetSlot1(int16 set)
{
  return SetCurrentSpriteSet(liSlot1,set);
}
//*******************************************************************
inline bool TCasinoLGameLord::SetSlot2(int16 set)
{
  return SetCurrentSpriteSet(liSlot2,set);
}
//*******************************************************************
inline bool TCasinoLGameLord::SetSlot3(int16 set)
{
  return SetCurrentSpriteSet(liSlot3,set);
}
//*******************************************************************
#endif