//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  cplaymgr.h
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0    10/12/95   M.Perry    original baseline
//  2.0    08/31/97   M.Perry    32-bit conversion.
//  2.5    11/01/99   M.Perry    mod for daily paydays.
//********************************************************************
#if !defined(__cplaymgr_h)
#define __cplaymgr_h

#include "casdef.h"
#include "oplaymgr.h"                   
#include "cplaydat.h"
#include "cgamedat.h"

class CASOWLCLASS TCasinoGameFrameWindow;
//*******************************************************************
class TCasinoPlayerMgr:public TPlayerMgr
{
private:
  #if defined(PLAYERDATA_SALARY)
  int16 PayDayWeekDay;
  int16 PayDayHour;
  uint32 PayDayIntervalSecs;
  #endif
  bool CreatePlayer(const string &name,bool Male,TMoney &cash);
public:
  bool CreatePlayer(string name,bool male,TMoney cash,TMoney salary);
  virtual void ModeDeActivated();
  virtual void DoManagementDialog();
  virtual void DoStatisticsDialog(int16 playernum = -1,TWindow *parent = NULL);
  TCasinoPlayerMgr(TCasinoGameFrameWindow *parent,string drivedir,
                   int16 numactiveallowed = 3,int16 numplayers = 20,bool demo = false);
  virtual ~TCasinoPlayerMgr();
  TCasinoPlayerData *GetActiveCasinoPlayerDataPtr(int16 slotnum);
  TCasinoGameData *GetCasinoGameDataPtr();
  TCasinoPlayerData *GetCasinoPlayerDataPtr(int16 playernum);
  virtual void CreateActivateDefPlayer();
  virtual void CreateDefPlayer();
  virtual void PrePlayerActivation(int16 playernum,TWindow *pwin);
  #if defined(PLAYERDATA_SALARY)
  void CheckForPaydays(int16 playernum,TWindow *pwin,bool onactivation);
  void CheckActivePaydays();
  int16 GetPaydayWeekDay() {return PayDayWeekDay;}//{return 5;}
  int16 GetPaydayHour() {return PayDayHour;}//{return 17;}
  #endif
protected:
  virtual string GetSaveName();
  virtual int32 GetGameDataSize();
  virtual TGameData *GetNewGameData();
  virtual int32 GetPlayerDataSize();
  virtual TPlayerData *GetNewPlayerData();
  virtual void ClearPlayerData(int16 playernum);
};
//*******************************************************************
//************************ inlines **********************************
//*******************************************************************
inline bool TCasinoPlayerMgr::CreatePlayer(const string &name,bool Male,TMoney &cash)
{
  return TPlayerMgr::CreatePlayer(name,Male,cash);
}
//*******************************************************************
inline TCasinoPlayerData *TCasinoPlayerMgr::GetActiveCasinoPlayerDataPtr(int16 slotnum)
{
  return ((TCasinoPlayerData *)(GetActivePlayerDataPtr(slotnum)));
}
//*******************************************************************
inline TCasinoGameData *TCasinoPlayerMgr::GetCasinoGameDataPtr()
{
  return ((TCasinoGameData *)GetGameDataPtr());
}
//*******************************************************************
inline TCasinoPlayerData *TCasinoPlayerMgr::GetCasinoPlayerDataPtr(int16 playernum)
{
  return ((TCasinoPlayerData *)GetPlayerDataPtr(playernum));
}
//*******************************************************************
#endif

