//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  crcalc.h
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     9/6/96     M.Perry    derived from Dave's code.
//  2.0    09/17/97    M.Perry    32-bit conversion.
//********************************************************************
#if !defined(__crcalc_h)
#define __crcalc_h

#include "cstcalc.h"
//*******************************************************************
class TStatCalcRoulette:public TCasinoStatCalc
{
public:
  enum{rDate = 1,rHoursPlayed = 2,rGameType = 3,rTotalNumBets = 6,rTotalCashBets = 7,rAvgCashBets = 8,
       rStartingBankroll = 9,rEndingBankroll = 10,rTotalCashWL = 11,rPercRet = 12,rAvgWLPerHour = 13,
       rCumCashWL = 14,rTotalNumBets2 = 17,rBetsWon = 18,rBetsLost = 19,rPercBetsWon = 20,rPercBetsLost = 21,
       rLargestCashWin = 22,rLargestCashLoss = 23,r1NumBets = 24,r2NumBets = 25,r3NumBets = 26,
       r4NumBets = 27,r5NumBets = 28,r6NumBets = 29,rColumnBets = 30,rDozenBets = 31,rEvenMoneyBets = 32,
       rRedBets = 33,rBlackBets = 34,rOddBets = 35,rEvenBets = 36,rHighBets = 37,rLowBets = 38,
       rCashWL1Num = 41,rCashWL2Num = 42,rCashWL3Num = 43,rCashWL4Num = 44,rCashWL5Num = 45,
       rCashWL6Num = 46,rCashWLColumn = 47,rCashWLDozen = 48,rCashWLEvenMoney = 49,rCashWLRed = 50,
       rCashWLBlack = 51,rCashWLOdd = 52,rCashWLEven = 53,rCashWLHigh = 54,rCashWLLow = 55,
       rLongestWinStreak = 58,rLongestLosingStreak = 59,rMostFreqNum1 = 60,rMostFreqNum1Occ = 61,
       rMostFreqNum2 = 62,rMostFreqNum2Occ = 63,rMostFreqNum3 = 64,rMostFreqNum3Occ = 65,
       r1RedinaRow = 67,r2RedinaRow = 68,r3RedinaRow= 69,r4RedinaRow = 70,r5PlusRedinaRow = 71,
       rRedStreak = 72,r1BlackinaRow = 74,r2BlackinaRow = 75,r3BlackinaRow = 76,r4BlackinaRow = 77,
       r5PlusBlackinaRow = 78,rBlackStreak = 79,r1OddinaRow = 81,r2OddinaRow = 82,r3OddinaRow = 83,
       r4OddinaRow = 84,r5PlusOddinaRow = 85,rOddStreak = 86,r1EveninaRow = 88,r2EveninaRow = 89,
       r3EveninaRow = 90,r4EveninaRow = 91,r5PlusEveninaRow = 92,rEvenStreak = 93,r1HighinaRow = 95,
       r2HighinaRow = 96,r3HighinaRow = 97,r4HighinaRow = 98,r5PlusHighinaRow = 99,rHighStreak = 100,
       r1LowinaRow = 102,r2LowinaRow = 103,r3LowinaRow = 104,r4LowinaRow = 105,r5PlusLowinaRow = 106,
       rLowStreak = 107}; 
  TStatCalcRoulette(TCasinoStatDlg *pstatdlg);
  virtual ~TStatCalcRoulette();
  virtual void LocalFillGrid();
  virtual void LocalCalculate();
  virtual void LocalMakeAllStrings();
  virtual void GetSessionPtrs();
  TCasinoRData *GetRData() {return (TCasinoRData *)PData;}
  TCRSession *GetRSession(int i) {return (TCRSession *)PSessions[i];}
  virtual bool GetValues(int statindex,float *values,int maxvalues);
private:
  virtual string MakeSubGameTypeStr(int subgametype,TMoney gamedenom);
  virtual void Calc_TotalNumBets();

  void Make_CumulativeCashWLStrs();
  void Calc_CumulativeCashWL();

  void Make_SingleNumBetsStrs();
  void Calc_SingleNumBets();
  string SingleNumBetsStr[NUMSESSIONS];
  string Total_SingleNumBetsStr;
  long Total_SingleNumBets;

  void Make_TwoNumBetsStrs();
  void Calc_TwoNumBets();
  string TwoNumBetsStr[NUMSESSIONS];
  string Total_TwoNumBetsStr;
  long Total_TwoNumBets;

  void Make_ThreeNumBetsStrs();
  void Calc_ThreeNumBets();
  string ThreeNumBetsStr[NUMSESSIONS];
  string Total_ThreeNumBetsStr;
  long Total_ThreeNumBets;

  void Make_FourNumBetsStrs();
  void Calc_FourNumBets();
  string FourNumBetsStr[NUMSESSIONS];
  string Total_FourNumBetsStr;
  long Total_FourNumBets;

  void Make_FiveNumBetsStrs();
  void Calc_FiveNumBets();
  string FiveNumBetsStr[NUMSESSIONS];
  string Total_FiveNumBetsStr;
  long Total_FiveNumBets;

  void Make_SixNumBetsStrs();
  void Calc_SixNumBets();
  string SixNumBetsStr[NUMSESSIONS];
  string Total_SixNumBetsStr;
  long Total_SixNumBets;

  void Make_ColumnBetsStrs();
  void Calc_ColumnBets();
  string ColumnBetsStr[NUMSESSIONS];
  string Total_ColumnBetsStr;
  long Total_ColumnBets;

  void Make_DozenBetsStrs();
  void Calc_DozenBets();
  string DozenBetsStr[NUMSESSIONS];
  string Total_DozenBetsStr;
  long Total_DozenBets;

  void Make_RedBetsStrs();
  void Calc_RedBets();
  string RedBetsStr[NUMSESSIONS];
  string Total_RedBetsStr;
  long Total_RedBets;

  void Make_BlackBetsStrs();
  void Calc_BlackBets();
  string BlackBetsStr[NUMSESSIONS];
  string Total_BlackBetsStr;
  long Total_BlackBets;

  void Make_OddBetsStrs();
  void Calc_OddBets();
  string OddBetsStr[NUMSESSIONS];
  string Total_OddBetsStr;
  long Total_OddBets;

  void Make_EvenBetsStrs();
  void Calc_EvenBets();
  string EvenBetsStr[NUMSESSIONS];
  string Total_EvenBetsStr;
  long Total_EvenBets;

  void Make_HighBetsStrs();
  void Calc_HighBets();
  string HighBetsStr[NUMSESSIONS];
  string Total_HighBetsStr;
  long Total_HighBets;

  void Make_LowBetsStrs();
  void Calc_LowBets();
  string LowBetsStr[NUMSESSIONS];
  string Total_LowBetsStr;
  long Total_LowBets;

  void Make_EvenMoneyBetsStrs();
  void Calc_EvenMoneyBets();
  string EvenMoneyBetsStr[NUMSESSIONS];
  string Total_EvenMoneyBetsStr;
  long Total_EvenMoneyBets;
  int EvenMoneyBets[NUMSESSIONS];

  void Make_TotalCashWLSingleNumBetsStrs();
  void Calc_TotalCashWLSingleNumBets();
  string TotalCashWLSingleNumBetsStr[NUMSESSIONS];
  string Total_TotalCashWLSingleNumBetsStr;
  long Total_TotalCashWLSingleNumBets;

  void Make_TotalCashWLTwoNumBetsStrs();
  void Calc_TotalCashWLTwoNumBets();
  string TotalCashWLTwoNumBetsStr[NUMSESSIONS];
  string Total_TotalCashWLTwoNumBetsStr;
  long Total_TotalCashWLTwoNumBets;

  void Make_TotalCashWLThreeNumBetsStrs();
  void Calc_TotalCashWLThreeNumBets();
  string TotalCashWLThreeNumBetsStr[NUMSESSIONS];
  string Total_TotalCashWLThreeNumBetsStr;
  long Total_TotalCashWLThreeNumBets;

  void Make_TotalCashWLFourNumBetsStrs();
  void Calc_TotalCashWLFourNumBets();
  string TotalCashWLFourNumBetsStr[NUMSESSIONS];
  string Total_TotalCashWLFourNumBetsStr;
  long Total_TotalCashWLFourNumBets;

  void Make_TotalCashWLFiveNumBetsStrs();
  void Calc_TotalCashWLFiveNumBets();
  string TotalCashWLFiveNumBetsStr[NUMSESSIONS];
  string Total_TotalCashWLFiveNumBetsStr;
  long Total_TotalCashWLFiveNumBets;

  void Make_TotalCashWLSixNumBetsStrs();
  void Calc_TotalCashWLSixNumBets();
  string TotalCashWLSixNumBetsStr[NUMSESSIONS];
  string Total_TotalCashWLSixNumBetsStr;
  long Total_TotalCashWLSixNumBets;

  void Make_TotalCashWLColumnBetsStrs();
  void Calc_TotalCashWLColumnBets();
  string TotalCashWLColumnBetsStr[NUMSESSIONS];
  string Total_TotalCashWLColumnBetsStr;
  long Total_TotalCashWLColumnBets;

  void Make_TotalCashWLDozenBetsStrs();
  void Calc_TotalCashWLDozenBets();
  string TotalCashWLDozenBetsStr[NUMSESSIONS];
  string Total_TotalCashWLDozenBetsStr;
  long Total_TotalCashWLDozenBets;

  void Make_TotalCashWLRedBetsStrs();
  void Calc_TotalCashWLRedBets();
  string TotalCashWLRedBetsStr[NUMSESSIONS];
  string Total_TotalCashWLRedBetsStr;
  long Total_TotalCashWLRedBets;

  void Make_TotalCashWLBlackBetsStrs();
  void Calc_TotalCashWLBlackBets();
  string TotalCashWLBlackBetsStr[NUMSESSIONS];
  string Total_TotalCashWLBlackBetsStr;
  long Total_TotalCashWLBlackBets;

  void Make_TotalCashWLOddBetsStrs();
  void Calc_TotalCashWLOddBets();
  string TotalCashWLOddBetsStr[NUMSESSIONS];
  string Total_TotalCashWLOddBetsStr;
  long Total_TotalCashWLOddBets;

  void Make_TotalCashWLEvenBetsStrs();
  void Calc_TotalCashWLEvenBets();
  string TotalCashWLEvenBetsStr[NUMSESSIONS];
  string Total_TotalCashWLEvenBetsStr;
  long Total_TotalCashWLEvenBets;

  void Make_TotalCashWLHighBetsStrs();
  void Calc_TotalCashWLHighBets();
  string TotalCashWLHighBetsStr[NUMSESSIONS];
  string Total_TotalCashWLHighBetsStr;
  long Total_TotalCashWLHighBets;

  void Make_TotalCashWLLowBetsStrs();
  void Calc_TotalCashWLLowBets();
  string TotalCashWLLowBetsStr[NUMSESSIONS];
  string Total_TotalCashWLLowBetsStr;
  long Total_TotalCashWLLowBets;

  void Make_TotalCashWLEvenMoneyBetsStrs();
  void Calc_TotalCashWLEvenMoneyBets();
  string TotalCashWLEvenMoneyBetsStr[NUMSESSIONS];
  string Total_TotalCashWLEvenMoneyBetsStr;
  long Total_TotalCashWLEvenMoneyBets;
  long TotalCashWLEvenMoneyBets[NUMSESSIONS];

  void Calc_MostFreqNums();
  long TotalMostFreqNums[MAX_ROULETTE_SPOTS];

  void Make_MostFreqNum1Strs();
  void Calc_MostFreqNum1();
  string MostFreqNum1Str[NUMSESSIONS];
  string Total_MostFreqNum1Str;
  int Total_MostFreqNum1Index;
  int MostFreqNum1Index[NUMSESSIONS];

  void Make_MostFreqNum2Strs();
  void Calc_MostFreqNum2();
  string MostFreqNum2Str[NUMSESSIONS];
  string Total_MostFreqNum2Str;
  int Total_MostFreqNum2Index;
  int MostFreqNum2Index[NUMSESSIONS];

  void Make_MostFreqNum3Strs();
  void Calc_MostFreqNum3();
  string MostFreqNum3Str[NUMSESSIONS];
  string Total_MostFreqNum3Str;
  int Total_MostFreqNum3Index;
  int MostFreqNum3Index[NUMSESSIONS];

  void Make_MostFreqNumOcc1Strs();
  void Calc_MostFreqNumOcc1();
  string MostFreqNumOcc1Str[NUMSESSIONS];
  string Total_MostFreqNumOcc1Str;

  void Make_MostFreqNumOcc2Strs();
  void Calc_MostFreqNumOcc2();
  string MostFreqNumOcc2Str[NUMSESSIONS];
  string Total_MostFreqNumOcc2Str;

  void Make_MostFreqNumOcc3Strs();
  void Calc_MostFreqNumOcc3();
  string MostFreqNumOcc3Str[NUMSESSIONS];
  string Total_MostFreqNumOcc3Str;

  void Make_OneRedInRowStrs();
  void Calc_OneRedInRow();
  string OneRedInRowStr[NUMSESSIONS];
  string Total_OneRedInRowStr;
  int Total_OneRedInRow;

  void Make_TwoRedInRowStrs();
  void Calc_TwoRedInRow();
  string TwoRedInRowStr[NUMSESSIONS];
  string Total_TwoRedInRowStr;
  int Total_TwoRedInRow;

  void Make_ThreeRedInRowStrs();
  void Calc_ThreeRedInRow();
  string ThreeRedInRowStr[NUMSESSIONS];
  string Total_ThreeRedInRowStr;
  int Total_ThreeRedInRow;

  void Make_FourRedInRowStrs();
  void Calc_FourRedInRow();
  string FourRedInRowStr[NUMSESSIONS];
  string Total_FourRedInRowStr;
  int Total_FourRedInRow;

  void Make_FivePlusRedInRowStrs();
  void Calc_FivePlusRedInRow();
  string FivePlusRedInRowStr[NUMSESSIONS];
  string Total_FivePlusRedInRowStr;
  int Total_FivePlusRedInRow;

  void Make_RedStreakStrs();
  void Calc_RedStreak();
  string RedStreakStr[NUMSESSIONS];
  string Total_RedStreakStr;
  int Total_RedStreak;
  bool GetRedStreaks(float *values,int num);

  void Make_OneBlackInRowStrs();
  void Calc_OneBlackInRow();
  string OneBlackInRowStr[NUMSESSIONS];
  string Total_OneBlackInRowStr;
  int Total_OneBlackInRow;

  void Make_TwoBlackInRowStrs();
  void Calc_TwoBlackInRow();
  string TwoBlackInRowStr[NUMSESSIONS];
  string Total_TwoBlackInRowStr;
  int Total_TwoBlackInRow;

  void Make_ThreeBlackInRowStrs();
  void Calc_ThreeBlackInRow();
  string ThreeBlackInRowStr[NUMSESSIONS];
  string Total_ThreeBlackInRowStr;
  int Total_ThreeBlackInRow;

  void Make_FourBlackInRowStrs();
  void Calc_FourBlackInRow();
  string FourBlackInRowStr[NUMSESSIONS];
  string Total_FourBlackInRowStr;
  int Total_FourBlackInRow;

  void Make_FivePlusBlackInRowStrs();
  void Calc_FivePlusBlackInRow();
  string FivePlusBlackInRowStr[NUMSESSIONS];
  string Total_FivePlusBlackInRowStr;
  int Total_FivePlusBlackInRow;

  void Make_BlackStreakStrs();
  void Calc_BlackStreak();
  string BlackStreakStr[NUMSESSIONS];
  string Total_BlackStreakStr;
  int Total_BlackStreak;
  bool GetBlackStreaks(float *values,int num);

  void Make_OneOddInRowStrs();
  void Calc_OneOddInRow();
  string OneOddInRowStr[NUMSESSIONS];
  string Total_OneOddInRowStr;
  int Total_OneOddInRow;

  void Make_TwoOddInRowStrs();
  void Calc_TwoOddInRow();
  string TwoOddInRowStr[NUMSESSIONS];
  string Total_TwoOddInRowStr;
  int Total_TwoOddInRow;

  void Make_ThreeOddInRowStrs();
  void Calc_ThreeOddInRow();
  string ThreeOddInRowStr[NUMSESSIONS];
  string Total_ThreeOddInRowStr;
  int Total_ThreeOddInRow;

  void Make_FourOddInRowStrs();
  void Calc_FourOddInRow();
  string FourOddInRowStr[NUMSESSIONS];
  string Total_FourOddInRowStr;
  int Total_FourOddInRow;

  void Make_FivePlusOddInRowStrs();
  void Calc_FivePlusOddInRow();
  string FivePlusOddInRowStr[NUMSESSIONS];
  string Total_FivePlusOddInRowStr;
  int Total_FivePlusOddInRow;

  void Make_OddStreakStrs();
  void Calc_OddStreak();
  string OddStreakStr[NUMSESSIONS];
  string Total_OddStreakStr;
  int Total_OddStreak;
  bool GetOddStreaks(float *values,int num);

  void Make_OneEvenInRowStrs();
  void Calc_OneEvenInRow();
  string OneEvenInRowStr[NUMSESSIONS];
  string Total_OneEvenInRowStr;
  int Total_OneEvenInRow;

  void Make_TwoEvenInRowStrs();
  void Calc_TwoEvenInRow();
  string TwoEvenInRowStr[NUMSESSIONS];
  string Total_TwoEvenInRowStr;
  int Total_TwoEvenInRow;

  void Make_ThreeEvenInRowStrs();
  void Calc_ThreeEvenInRow();
  string ThreeEvenInRowStr[NUMSESSIONS];
  string Total_ThreeEvenInRowStr;
  int Total_ThreeEvenInRow;

  void Make_FourEvenInRowStrs();
  void Calc_FourEvenInRow();
  string FourEvenInRowStr[NUMSESSIONS];
  string Total_FourEvenInRowStr;
  int Total_FourEvenInRow;

  void Make_FivePlusEvenInRowStrs();
  void Calc_FivePlusEvenInRow();
  string FivePlusEvenInRowStr[NUMSESSIONS];
  string Total_FivePlusEvenInRowStr;
  int Total_FivePlusEvenInRow;

  void Make_EvenStreakStrs();
  void Calc_EvenStreak();
  string EvenStreakStr[NUMSESSIONS];
  string Total_EvenStreakStr;
  int Total_EvenStreak;
  bool GetEvenStreaks(float *values,int num);

  void Make_OneHighInRowStrs();
  void Calc_OneHighInRow();
  string OneHighInRowStr[NUMSESSIONS];
  string Total_OneHighInRowStr;
  int Total_OneHighInRow;

  void Make_TwoHighInRowStrs();
  void Calc_TwoHighInRow();
  string TwoHighInRowStr[NUMSESSIONS];
  string Total_TwoHighInRowStr;
  int Total_TwoHighInRow;

  void Make_ThreeHighInRowStrs();
  void Calc_ThreeHighInRow();
  string ThreeHighInRowStr[NUMSESSIONS];
  string Total_ThreeHighInRowStr;
  int Total_ThreeHighInRow;

  void Make_FourHighInRowStrs();
  void Calc_FourHighInRow();
  string FourHighInRowStr[NUMSESSIONS];
  string Total_FourHighInRowStr;
  int Total_FourHighInRow;

  void Make_FivePlusHighInRowStrs();
  void Calc_FivePlusHighInRow();
  string FivePlusHighInRowStr[NUMSESSIONS];
  string Total_FivePlusHighInRowStr;
  int Total_FivePlusHighInRow;

  void Make_HighStreakStrs();
  void Calc_HighStreak();
  string HighStreakStr[NUMSESSIONS];
  string Total_HighStreakStr;
  int Total_HighStreak;
  bool GetHighStreaks(float *values,int num);

  void Make_OneLowInRowStrs();
  void Calc_OneLowInRow();
  string OneLowInRowStr[NUMSESSIONS];
  string Total_OneLowInRowStr;
  int Total_OneLowInRow;

  void Make_TwoLowInRowStrs();
  void Calc_TwoLowInRow();
  string TwoLowInRowStr[NUMSESSIONS];
  string Total_TwoLowInRowStr;
  int Total_TwoLowInRow;

  void Make_ThreeLowInRowStrs();
  void Calc_ThreeLowInRow();
  string ThreeLowInRowStr[NUMSESSIONS];
  string Total_ThreeLowInRowStr;
  int Total_ThreeLowInRow;

  void Make_FourLowInRowStrs();
  void Calc_FourLowInRow();
  string FourLowInRowStr[NUMSESSIONS];
  string Total_FourLowInRowStr;
  int Total_FourLowInRow;

  void Make_FivePlusLowInRowStrs();
  void Calc_FivePlusLowInRow();
  string FivePlusLowInRowStr[NUMSESSIONS];
  string Total_FivePlusLowInRowStr;
  int Total_FivePlusLowInRow;

  void Make_LowStreakStrs();
  void Calc_LowStreak();
  string LowStreakStr[NUMSESSIONS];
  string Total_LowStreakStr;
  int Total_LowStreak;
  bool GetLowStreaks(float *values,int num);
};
//*******************************************************************
//*******************************************************************
class TRouletteGraph:public TCasinoGraphDlg
{
public:
  TRouletteGraph(TCasinoStatDlg* pstatdlg,TStatCalcRoulette *pstatcalc);
  virtual ~TRouletteGraph();
};
//*******************************************************************
#endif