//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  crdata.h
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     9/9/96     M.Perry    split up cplaydat file.
//  2.0    09/17/97    M.Perry    32-bit conversion.
//********************************************************************
#if !defined(__crdata_h)
#define __crdata_h

#include "casdata.h"

#define MAX_ROULETTE_SPOTS 38
//*******************************************************************
struct TCRSession : public TCasinoSession
{
  TCRSession();
  int16  SingleNumBets;
  int16  TwoNumBets;
  int16  ThreeNumBets;
  int16  FourNumBets;
  int16  FiveNumBets;
  int16  SixNumBets;
  int16  ColumnBets;
  int16  DozenBets;
  int16  RedBets;
  int16  BlackBets;
  int16  OddBets;
  int16  EvenBets;
  int16  HighBets;
  int16  LowBets;

  TMoney SingleNumBetsTotalCashWL;
  TMoney TwoNumBetsTotalCashWL;
  TMoney ThreeNumBetsTotalCashWL;
  TMoney FourNumBetsTotalCashWL;
  TMoney FiveNumBetsTotalCashWL;
  TMoney SixNumBetsTotalCashWL;
  TMoney ColumnBetsTotalCashWL;
  TMoney DozenBetsTotalCashWL;
  TMoney RedBetsTotalCashWL;
  TMoney BlackBetsTotalCashWL;
  TMoney OddBetsTotalCashWL;
  TMoney EvenBetsTotalCashWL;
  TMoney HighBetsTotalCashWL;
  TMoney LowBetsTotalCashWL;

  int16  MostFrequentNums[MAX_ROULETTE_SPOTS];

  int16  OneRedInRow;
  int16  TwoRedInRow;
  int16  ThreeRedInRow;
  int16  FourRedInRow;
  int16  FivePlusRedInRow;
  int16  RedStreak;
  int16  CurrentRedStreak;

  int16  OneBlackInRow;
  int16  TwoBlackInRow;
  int16  ThreeBlackInRow;
  int16  FourBlackInRow;
  int16  FivePlusBlackInRow;
  int16  BlackStreak;
  int16  CurrentBlackStreak;

  int16  OneOddInRow;
  int16  TwoOddInRow;
  int16  ThreeOddInRow;
  int16  FourOddInRow;
  int16  FivePlusOddInRow;
  int16  OddStreak;
  int16  CurrentOddStreak;

  int16  OneEvenInRow;
  int16  TwoEvenInRow;
  int16  ThreeEvenInRow;
  int16  FourEvenInRow;
  int16  FivePlusEvenInRow;
  int16  EvenStreak;
  int16  CurrentEvenStreak;

  int16  OneHighInRow;
  int16  TwoHighInRow;
  int16  ThreeHighInRow;
  int16  FourHighInRow;
  int16  FivePlusHighInRow;
  int16  HighStreak;
  int16  CurrentHighStreak;

  int16  OneLowInRow;
  int16  TwoLowInRow;
  int16  ThreeLowInRow;
  int16  FourLowInRow;
  int16  FivePlusLowInRow;
  int16  LowStreak;
  int16  CurrentLowStreak;

  void ClearData();
  void StartSession(TMoney startingcash,int16 subgametype = cr1,
                    TMoney denom = TMoney(TMoney::ctorDenomID,TMoney::did_1_00));//cd1);
  void EndSession(TMoney endingcash);
};
//*******************************************************************
struct TCasinoRData : public TCasinoData
{
  TCRSession Sessions[NUMSESSIONS];
  TMoney Cumulative;
  TCasinoRData();
  void ClearData();
  void StartSession(TMoney startingcash,int16 subgametype = cr1,TMoney denom = 1);
  void EndSession(TMoney endingcash);
  int16 GetFirstValidSession();
  int16 GetNextValidSession();
  void IncCurrentSession();
  int16 GetPrevValidSession();
};
//*******************************************************************
#endif