//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  cscalc.h
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     9/6/96     M.Perry     derived from Dave's code.
//  2.0     9/16/97    M.Perry     32-bit conversion.
//********************************************************************
#if !defined(__cscalc_h)
#define __cscalc_h

#include "cstcalc.h"
//*******************************************************************
class TStatCalcSlots:public TCasinoStatCalc
{
public:
  enum{sDate = 1,sHoursPlayed = 2,sGameType = 3,sTotalNumBets = 6,sTotalCashBets = 7,sAvgCashBets = 8,
       sStartingBankroll = 9,sEndingBankroll = 10,sTotalCashWL = 11,sRetPerc = 12,sAvgCashWLPerHour = 13,
       sCumCashWL = 14,sNumSpins = 17,sSpinsWon = 18,sSpinsLost = 19,sPercWon = 20,sPercLost = 21,
       sLongestWinStreak = 22,sLongestLosingStreak = 23,sLargestCashWin = 24,sPeakCashWinLevel = 25,
       sLowCashLossLevel = 26,sLowPayoffs = 27,sHighPayoffs = 28};
  TStatCalcSlots(TCasinoStatDlg *pstatdlg);
  virtual ~TStatCalcSlots();
  virtual void LocalFillGrid();
  virtual void LocalCalculate();
  virtual void LocalMakeAllStrings();
  virtual void GetSessionPtrs();
  TCasinoSData *GetSData() {return (TCasinoSData *)PData;}
  TCSSession *GetSSession(int i) {return (TCSSession *)PSessions[i];}
  virtual bool GetValues(int statindex,float *values,int maxvalues);

private:
  virtual string MakeSubGameTypeStr(int subgametype,TMoney gamedenom);

  void Make_CumulativeCashWLStrs();
  void Calc_CumulativeCashWL();

  void Make_LowPayoffsStrs();
  void Calc_LowPayoffs();
  string LowPayoffsStr[NUMSESSIONS];
  string Total_LowPayoffsStr;
  long Total_LowPayoffs;
  bool GetLowPayoffs(float *values,int num);

  void Make_HighPayoffsStrs();
  void Calc_HighPayoffs();
  string HighPayoffsStr[NUMSESSIONS];
  string Total_HighPayoffsStr;
  long Total_HighPayoffs;
  bool GetHighPayoffs(float *values,int num);
};
//*******************************************************************
//*******************************************************************
class TSlotsGraph:public TCasinoGraphDlg
{
public:
  TSlotsGraph(TCasinoStatDlg* pstatdlg,TStatCalcSlots *pstatcalc);
  virtual ~TSlotsGraph();
};
//*******************************************************************
#endif
