//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  cstcalc.h
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     9/6/96     M.Perry    derived from Dave's code.
//********************************************************************
#if !defined(__cstcalc_h)
#define __cstcalc_h

#include "ogle.h"
#include "cplaydat.h"
#include "cgametyp.h"
#include "cstats.rh"
#include "cgraph.h"
class TCasinoStatDlg;
//*******************************************************************
class TCasinoStatCalc
{
protected:
  bool bShowCents;
  TCasinoStatDlg *PStatDlg;
  TCasinoPlayerData *PPlayerData;
  void AllocDataStorage();
  virtual void LocalAllocDataStorage();
  void AllocStringStorage();
  virtual void LocalAllocStringStorage();
  void DeAllocDataStorage();
  virtual void LocalDeAllocDataStorage();
  void DeAllocStringStorage();
  virtual void LocalDeAllocStringStorage();
  bool bDataStorageAlloc;
  bool bStringStorageAlloc;
  bool bCalculated;
  bool bStringsMade;
  bool IsDataStorageAlloc() {return bDataStorageAlloc;}
  bool IsStringStorageAlloc() {return bStringStorageAlloc;}
  void SetDataStorageAlloc(bool allocated = true) {bDataStorageAlloc = allocated;}
  void SetStringStorageAlloc(bool allocated = true) {bStringStorageAlloc = allocated;}
  bool IsCalculated() {return bCalculated;}
  bool IsStringsMade() {return bStringsMade;}
  void SetCalculated(bool calculated = true) {bCalculated = calculated;}
  void SetStringsMade(bool stringsmade = true) {bStringsMade = stringsmade;}
  void ClearOwnerGrid();

public:
  virtual bool GetValues(int statindex,float *values,int maxvalueindex);
  int GetMaxValueIndex(int maxvalues)
  {
    int num = int(min(maxvalues,NUMSESSIONS));
    num = int(min(num,(LastSessionNum + 1)));
    return num;
  }
  void GetPlayerData();
  TCasinoStatCalc(TCasinoStatDlg *pstatdlg);
  virtual ~TCasinoStatCalc();
  void FillGrid();
  virtual void LocalFillGrid();
  void Calculate();
  virtual void LocalCalculate();
  void MakeAllStrings();
  virtual void LocalMakeAllStrings();
  TCasinoData *PData;
  TCasinoSession *PSessions[NUMSESSIONS];
  int LastSessionNum;
  virtual void GetSessionPtrs();
  TCasinoSession *GetSession(int i) {return PSessions[i];}

public:
  virtual void Calc_Date();
  virtual void Make_DateStrs();
  string DateStr[NUMSESSIONS];
  string Total_DateStr;
  DWORD Total_Date;

  virtual void Make_HoursPlayedStrs();
  virtual void Calc_HoursPlayed();
  string HoursPlayedStr[NUMSESSIONS];
  string Total_HoursPlayedStr;
  DWORD SecondsPlayed[NUMSESSIONS];
  DWORD Total_SecondsPlayed;

  virtual string MakeSubGameTypeStr(int subgametype,TMoney denom);
  virtual void Make_TypeGamePlayedStrs();
  virtual void Calc_TypeGamePlayed();
  string TypeGamePlayedStr[NUMSESSIONS];
  string Total_TypeGamePlayedStr;

  // total num bets
  virtual void Make_TotalNumBetsStrs();
  virtual void Calc_TotalNumBets();
  long TotalNumBets[NUMSESSIONS];
  long Total_TotalNumBets;
  string TotalNumBetsStr[NUMSESSIONS];
  string Total_TotalNumBetsStr;
  bool GetTotalNumBets(float *values,int num);

  // total cash bet
  virtual void Make_TotalCashBetsStrs();
  virtual void Calc_TotalCashBets();
  TMoney Total_TotalCashBets;
  string TotalCashBetsStr[NUMSESSIONS];
  string Total_TotalCashBetsStr;
  bool GetTotalCashBets(float *values,int num);

  // avg cash bet
  virtual void Make_AvgCashBetsStrs();
  virtual void Calc_AvgCashBets();
  TMoney AvgCashBets[NUMSESSIONS];
  TMoney Total_AvgCashBets;
  string AvgCashBetsStr[NUMSESSIONS];
  string Total_AvgCashBetsStr;
  bool GetAvgCashBets(float *values,int num);

  virtual void Make_StartingBankrollStrs();
  virtual void Calc_StartingBankroll();
  TMoney Total_StartingBankroll;
  string StartingBankrollStr[NUMSESSIONS];
  string Total_StartingBankrollStr;
  bool GetStartingBankrolls(float *values,int num);

  // ending bankroll
  virtual void Make_EndingBankrollStrs();
  virtual void Calc_EndingBankroll();
  TMoney Total_EndingBankroll;
  string EndingBankrollStr[NUMSESSIONS];
  string Total_EndingBankrollStr;
  bool GetEndingBankrolls(float *values,int num);

  // total cash won/loss
  virtual void Make_TotalCashWLStrs();
  virtual void Calc_TotalCashWL();
  TMoney TotalCashWL[NUMSESSIONS];
  TMoney Total_TotalCashWL;
  string TotalCashWLStr[NUMSESSIONS];
  string Total_TotalCashWLStr;
  bool GetTotalCashWL(float *values,int num);

  // return percentage
  virtual void Make_ReturnPercStrs();
  virtual void Calc_ReturnPerc();
  float ReturnPerc[NUMSESSIONS];
  float Total_ReturnPerc;
  string ReturnPercStr[NUMSESSIONS];
  string Total_ReturnPercStr;
  bool GetReturnPerc(float *values,int num);

  // avg won/loss per hour.
  virtual void Make_AvgWLPerHourStrs();
  virtual void Calc_AvgWLPerHour();
  TMoney AvgWLPerHour[NUMSESSIONS];
  TMoney Total_AvgWLPerHour;
  string AvgWLPerHourStr[NUMSESSIONS];
  string Total_AvgWLPerHourStr;
  bool GetAvgWLPerHour(float *values,int num);

  // hands won
  virtual void Make_HandsWonStrs();
  virtual void Calc_HandsWon();
  string HandsWonStr[NUMSESSIONS];
  string Total_HandsWonStr;
  long Total_HandsWon;
  bool GetWins(float *values,int num);

  // hands lost
  virtual void Make_HandsLostStrs();
  virtual void Calc_HandsLost();
  string HandsLostStr[NUMSESSIONS];
  string Total_HandsLostStr;
  long Total_HandsLost;
  bool GetLosses(float *values,int num);

  // percentage hands won
  virtual void Make_PercHandsWonStrs();
  virtual void Calc_PercHandsWon();
  string PercHandsWonStr[NUMSESSIONS];
  string Total_PercHandsWonStr;
  float PercHandsWon[NUMSESSIONS];
  float Total_PercHandsWon;
  bool GetPercWins(float *values,int num);

  // percentage hands lost
  virtual void Make_PercHandsLostStrs();
  virtual void Calc_PercHandsLost();
  string PercHandsLostStr[NUMSESSIONS];
  string Total_PercHandsLostStr;
  float Total_PercHandsLost;
  float PercHandsLost[NUMSESSIONS];
  bool GetPercLosses(float *values,int num);

  // longest winning streak
  virtual void Make_LongestWinStreakStrs();
  virtual void Calc_LongestWinStreak();
  string LongestWinStreakStr[NUMSESSIONS];
  string Total_LongestWinStreakStr;
  long Total_LongestWinStreak;
  bool GetLongestWinStreaks(float *values,int num);

  // longest losing streak
  virtual void Make_LongestLosingStreakStrs();
  virtual void Calc_LongestLosingStreak();
  string LongestLosingStreakStr[NUMSESSIONS];
  string Total_LongestLosingStreakStr;
  long Total_LongestLosingStreak;
  bool GetLongestLosingStreak(float *values,int num);

  // largest cash win
  virtual void Make_LargestCashWinStrs();
  virtual void Calc_LargestCashWin();
  string LargestCashWinStr[NUMSESSIONS];
  string Total_LargestCashWinStr;
  TMoney Total_LargestCashWin;
  bool GetLargestCashWin(float *values,int num);

  virtual void Make_LargestCashLostStrs();
  virtual void Calc_LargestCashLost();
  string LargestCashLostStr[NUMSESSIONS];
  string Total_LargestCashLostStr;
  TMoney Total_LargestCashLost;
  bool GetLargestCashLost(float *values,int num);

  // peak cash level
  virtual void Make_PeakCashWinLevelStrs();
  virtual void Calc_PeakCashWinLevel();
  string PeakCashWinLevelStr[NUMSESSIONS];
  string Total_PeakCashWinLevelStr;
  TMoney Total_PeakWinLevel;
  bool GetPeakWinLevel(float *values,int num);

  // low cash level
  virtual void Make_LowCashLostLevelStrs();
  virtual void Calc_LowCashLostLevel();
  string LowCashLostLevelStr[NUMSESSIONS];
  string Total_LowCashLostLevelStr;
  TMoney Total_LowCashLostLevel;
  bool GetLowCashLostLevel(float *values,int num);

public:
  // the following used by overalls.
  TMoney Get_Total_TotalCashBets() {return Total_TotalCashBets;}
  TMoney Get_Total_TotalNumBets() {return Total_TotalNumBets;}
  TMoney Get_StartingBankroll()
  {
    if (PPlayerData == NULL) {return 0.0;}
    return PPlayerData->InitialCash;
//    return ((PPlayerData != NULL)?PPlayerData->InitialCash:TMoney(0));
  }
  TMoney Get_EndingBankroll()
  {
    if (PPlayerData == NULL) {return 0.0;}
    return PPlayerData->Cash;
//    return ((PPlayerData != NULL)?PPlayerData->Cash:TMoney(0));
  }
  DWORD Get_Total_SecondsPlayed() {return Total_SecondsPlayed;}
  TMoney Get_Total_TotalCashWL() {return Total_TotalCashWL;}
  TMoney Get_Total_PeakWinLevel() {return Total_PeakWinLevel;}
  TMoney Get_Total_LowCashLostLevel() {return Total_LowCashLostLevel;}
  int Get_NumSessions() {return (LastSessionNum + 1);}
  float Get_Total_ReturnPerc() {return Total_ReturnPerc;}
  TMoney Get_Total_AvgWLPerHour() {return Total_AvgWLPerHour;}

protected:
  string MakeString(int value);
  string MakeString(long value);
  string MakeString(TMoney money);
  string InPlayStr;
  string NAStr;
  string EmptyStr;
  string MakeDateStr(DWORD seconds);
  string MakeTimeStr(DWORD lengthseconds);
  string MakeDenomStr(TMoney denom);
  string MakeString(float value);
  float GetAvg(long upper,long lower,float def = 0.0);
  TMoney GetMoneyAvg(TMoney upper,long lower,TMoney def = 0.0);
  float GetPerc(long upper,long lower,float def = 0.0 );
  float GetPercRet(long upper,long lower,float def = 0.0);
  float GetAvgPerHour(long value,long seconds,float def = 0.0);
  long max(long v1,long v2) {return ((v1 > v2)?v1:v2);}
  DWORD maxDW(DWORD dw1,DWORD dw2) {return ((dw1 > dw2)?dw1:dw2);}
  long min(long v1,long v2) {return ((v1 < v2)?v1:v2);}
};
//*******************************************************************
#endif