//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  cvpcalc.h
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     9/6/96     M.Perry    derived from Dave's code
//  2.0    09/17/97    M.Perry    32-bit conversion.
//********************************************************************
#if !defined(__cvpcalc_h)
#define __cvpcalc_h

#include "cstcalc.h"
//*******************************************************************
class TStatCalcVP:public TCasinoStatCalc
{
public:
  enum
  {
    vpDate = 1,
    vpHoursPlayed,//2,
    vpGameType,//3,
    vpb1,
    //
    vpWinLossStats,//5,
    vpTotalNumBets,//6,
    vpTotalCashBets,//7,
    vpAvgCashBet,//8,
    vpStartingBankroll,//9,
    vpEndingBankroll,//10,
    vpTotalCashWL,//11,
    vpRetPerc,//12,
    vpAvgWLPerHour,//13,
    vpCumCashWL,//14,
    vpb2,
    //
    vpGameStats,//16,
    vpHandsPlayed,//17,
    vpHandsWon,//18,
    vpHandsLost,//19,
    vpPercHandsWon,//20,
    vpPercHandsLost,//21,
    vpLongestWinStreak,//22,
    vpLongestLosingStreak,//23,
    vpLargestCashWin,//24,
    vpPeakCashWinLevel,//25,
    vpLowCashLossLevel,//26,
    vpb3,
    //empty line
    vpNumOccurrences,//28,
    vpGarbageHands,//29,
    #if defined(ACVP_COMPILE)
    vpPair6,//30,
    #endif
//    vpPairJacks,//31,
//    vpPairKings,//32,
    vpHighPairs,//33,
    vpTwoPairs,//34,
    vpThreeofaKinds,//35,
    #if defined(ACVP_COMPILE)
    vpThreeofaKinds5,//36,
    vpThreeofaKinds8,//37,
    #endif
    vpStraights,//38,
    vpFlushes,//39,
    #if defined(ACVP_COMPILE)
    vpFlushDiamond,//40,
    vpFlushHeart,//41,
    vpFlushSpade,//42,
    vpFlushClub,//43,
    vpFlushAssault,//44,
    #endif
    vpFullHouses,//45,
    vpFourofaKinds,//46,
    #if defined(ACVP_COMPILE)
    vpFourofaKinds5,//47,
    vpFourofaKinds7,//48,
    vpFourofaKinds8,//49,
    vpFourofaKind2_10,//50,
    vpFourFaces,//51,
    vpFourFacesWAceorFace,//52,
    vpFourFacesWAce,//53,
    vpFourAcesWFace,//54,
    vpFourofaKind4_K,//55,
    vpFourofaKind5_K,//56,
    vpFourofaKind2_4,//57,
    vpFourAces,//58,
    #endif
    vpStraightFlushes,//59,
    #if defined(ACVP_COMPILE)
    vpStraightDiamondFlush,//60,
    vpStraightHeartFlush,//61,
    vpStraightSpadeFlush,//62,
    vpStraightClubFlush,//63,
    #endif
    vpRoyalFlushesNatural,//64,
    vpRoyalFlushesWild,//65,
    #if defined(ACVP_COMPILE)
    vpRoyalDiamondFlush,//66,
    vpRoyalHeartFlush,//67,
    vpRoyalSpadeFlush,//68,
    vpRoyalClubFlush,//69,
    #endif
    vpFiveofaKinds,//70,
    #if defined(ACVP_COMPILE)
    vpFiveofaKind6_K,//71,
    vpFiveofaKind3_5,//72,
    vpFiveAces,//73,
    #endif
    vpFourDeuces,//74,
    #if defined(ACVP_COMPILE)
    vpFour2WAce,//75,
    vpFour7WJoker,//76,
    vpFiveJoker,//77,
    #endif
    //
    vpb4,
    vpTotalCashWins,//79,
    vpTotalCashBets2,//80,
    vpTotalCashWon,//81,
    #if defined(ACVP_COMPILE)
    vpPair6Cash,//82,
    #endif
//    vpPairJacksCash,//83,
//    vpPairKingsCash,//84,
    vpHighPairsCash,//85,
    vpTwoPairsCash,//86,
    vpThreeofaKindsCash,//87,
    #if defined(ACVP_COMPILE)
    vpThreeofaKinds5Cash,//88,
    vpThreeofaKinds8Cash,//89,
    #endif
    vpStraightsCash,//90,
    vpFlushesCash,//91,
    #if defined(ACVP_COMPILE)
    vpFlushDiamondCash,//92,
    vpFlushHeartCash,//93,
    vpFlushSpadeCash,//94,
    vpFlushClubCash,//95,
    vpFlushAssaultCash,//96,
    #endif
    vpFullHousesCash,//97,
    vpFourofaKindsCash,//98,
    #if defined(ACVP_COMPILE)
    vpFourofaKinds5Cash,//99,
    vpFourofaKinds7Cash,//100,
    vpFourofaKinds8Cash,//101,
    vpFourofaKind2_10Cash,//102,
    vpFourFacesCash,//103,
    vpFourFacesWAceorFaceCash,//104,
    vpFourFacesWAceCash,//105,
    vpFourAcesWFaceCash,//106,
    vpFourofaKind4_KCash,//107,
    vpFourofaKind5_KCash,//108,
    vpFourofaKind2_4Cash,//109,
    vpFourAcesCash,//110,
    #endif
    vpStraightFlushesCash,//111,
    #if defined(ACVP_COMPILE)
    vpStraightDiamondFlushCash,//112,
    vpStraightHeartFlushCash,//113,
    vpStraightClubFlushCash,//114,
    vpStraightSpadeFlushCash,//115,
    #endif
    vpRoyalFlushesNaturalCash,//116,
    vpRoyalFlushesWildCash,//117,
    #if defined(ACVP_COMPILE)
    vpRoyalDiamondFlushCash,//118,
    vpRoyalHeartFlushCash,//119,
    vpRoyalSpadeFlushCash,//120,
    vpRoyalClubFlushCash,//121,
    #endif
    vpFourDeucesCash,//122,
    vpFiveofaKindsCash,//123,
    #if defined(ACVP_COMPILE)
    vpFiveofaKind6_KCash,//124,
    vpFiveofaKind3_5Cash,//125,
    vpFiveAcesCash,//126,
    vpFour2WAceCash,//127,
    vpFour7WJokerCash,//128,
    vpFiveJokersCash,//129,
    #endif
    //
    vpb5,
    vpPercTotalCashWon,//131,
    #if defined(ACVP_COMPILE)
    vpPercCashPair6,//132,
    #endif
//    vpPercCashPairJacks,//133,
//    vpPercCashPairKings,//134,
    vpPercCashHighPairs,//135,
    vpPercCashTwoPairs,//136,
    vpPercCashThreeofaKinds,//137,
    #if defined(ACVP_COMPILE)
    vpPercCashThreeofaKinds5,//138,
    vpPercCashThreeofaKinds8,//139,
    #endif
    vpPercCashStraights,//140,
    vpPercCashFlushes,//141,
    #if defined(ACVP_COMPILE)
    vpPercCashDiamondFlush,//142,
    vpPercCashHeartFlush,//143,
    vpPercCashSpadeFlush,//144,
    vpPercCashClubFlush,//145,
    vpPercCashFlushAssault,//146,
    #endif
    vpPercCashFullHouses,//147,
    vpPercCashFourofaKinds,//148,
    #if defined(ACVP_COMPILE)
    vpPercCashFourofaKinds5,//149,
    vpPercCashFourofaKinds7,//150,
    vpPercCashFourofaKinds8,//151,
    vpPercCashFourofaKind2_10,//152,
    vpPercCashFourFaces,//153,
    vpPercCashFourFacesWAceorFace,//154,
    vpPercCashFourFacesWAce,//155,
    vpPercCashFourAcesWFace,//156,
    vpPercCashFourofaKind4_K,//157,
    vpPercCashFourofaKind5_K,//158,
    vpPercCashFourofaKind2_4,//159,
    vpPercCashFourAces,//160,
    #endif
    vpPercCashStraightFlushes,//161,
    #if defined(ACVP_COMPILE)
    vpPercCashStraightDiamondFlush,//162,
    vpPercCashStraightHeartFlush,//162,
    vpPercCashStraightClubFlush,//163,
    vpPercCashStraightSpadeFlush,//164,
    #endif
    vpPercCashRoyalFlushesNatural,//165,
    vpPercCashRoyalFlushesWild,//166,
    #if defined(ACVP_COMPILE)
    vpPercCashRoyalDiamondFlush,//167,
    vpPercCashRoyalHeartFlush,//168,
    vpPercCashRoyalSpadeFlush,//169,
    vpPercCashRoyalClubFlush,//170,
    #endif
    vpPercCashFourDeuces,//171,
    vpPercCashFiveofaKinds,//172,
    #if defined(ACVP_COMPILE)
    vpPercCashFiveofaKind6_K,//173,
    vpPercCashFiveofaKind3_5,//174,
    vpPercCashFiveAces,//175,
    vpPercCashFour2WAce,//176,
    vpPercCashFour7WJoker,//177,
    vpPercCashFiveJoker,//178,
    #endif
    //
    vpb6,
    vpAdvancedStats,// = 180,
    vpNumIncPlays,// = 181,
    vpPercPlayingAccuracy,// = 182,
    vpNumRows,// = 183,
    vpDelta = 12,
    vpOcc1 = vpNumOccurrences + vpDelta,
    vpOcc2 = vpOcc1 + vpDelta,
    vpOcc3 = vpOcc2 + vpDelta,
    vpCash1 = vpTotalCashWins + vpDelta,
    vpCash2 = vpCash1 + vpDelta,
    vpCash3 = vpCash2 + vpDelta,
    vpPerc1 = vpPercTotalCashWon + vpDelta,
    vpPerc2 = vpPerc1 + vpDelta,
    vpPerc3 = vpPerc2 + vpDelta
//#else
//    vpGarbageHands = 29,
//    vpHighPairs = 30,
//    vpTwoPairs = 31,
//    vpThreeofaKinds = 32,
//    vpStraights = 33,
//    vpFlushes = 34,
//    vpFullHouses = 35,
//    vpFourofaKinds = 36,
//    vpStraightFlushes = 37,
//    vpRoyalFlushesNatural = 38,
//    vpRoyalFlushesWild = 39,
//    vpFiveofaKinds = 40,
//    vpFourDeuces = 41,
//    vpTotalCashWins = 43,
//    vpTotalCashBets2 = 44,
//    vpTotalCashWon = 45,
//    vpHighPairsCash = 46,
//    vpTwoPairsCash = 47,
//    vpThreeofaKindsCash = 48,
//    vpStraightsCash = 49,
//    vpFlushesCash = 50,
//    vpFullHousesCash = 51,
//    vpFourofaKindsCash = 52,
//    vpStraightFlushesCash = 53,
//    vpRoyalFlushesNaturalCash = 54,
//    vpRoyalFlushesWildCash = 55,
//    vpFourDeucesCash = 56,
//    vpFiveofaKindsCash = 57,
//    vpPercTotalCashWon = 59,
//    vpPercCashHighPairs = 60,
//    vpPercCashTwoPairs = 61,
//    vpPercCashThreeofaKinds = 62,
//    vpPercCashStraights = 63,
//    vpPercCashFlushes = 64,
//    vpPercCashFullHouses = 65,
//    vpPercCashFourofaKinds = 66,
//    vpPercCashStraightFlushes = 67,
//    vpPercCashRoyalFlushesNatural = 68,
//    vpPercCashRoyalFlushesWild = 69,
//    vpPercCashFourDeuces = 70,
//    vpPercCashFiveofaKinds = 71,
//    vpAdvancedStats = 73,
//    vpNumIncPlays = 74,
//    vpPercPlayingAccuracy = 75,
//    vpNumRows = 76,
//    vpDelta = 0
//#endif
  };

protected:
  int16 LabelResIds[vpNumRows];
  string LabelStrs[vpNumRows];

public:
  string GetLabelStr(int16 row_ndx);
  TStatCalcVP(TCasinoStatDlg *pstatdlg);
  virtual ~TStatCalcVP();
  virtual void LocalFillGrid();
  virtual void LocalCalculate();
  virtual void LocalMakeAllStrings();
  virtual void GetSessionPtrs();
  TCasinoVPData *GetVPData() {return (TCasinoVPData *)PData;}
  TCVPSession *GetVPSession(int i) {return (TCVPSession *)PSessions[i];}
  virtual bool GetValues(int statindex,float *values,int maxvalueindex);

  virtual string MakeSubGameTypeStr(int subgametype,TMoney denom);
  virtual void Calc_TotalNumBets();
  void Make_CumulativeCashWLStrs();
  void Calc_CumulativeCashWL();
  void Make_HandsPlayedStrs();
  void Calc_HandsPlayed();

  void Make_NumGarbageHandsStrs();
  void Calc_NumGarbageHands();
  string NumGarbageHandsStr[NUMSESSIONS];
  string Total_NumGarbageHandsStr;
  long Total_NumGarbageHands;

  // high pairs
  void Make_HighPairsStrs();
  void Calc_HighPairs();
  string HighPairsStr[NUMSESSIONS];
  string Total_HighPairsStr;
  long Total_HighPairs;

  // 2 pairs
  void Make_TwoPairsStrs();
  void Calc_TwoPairs();
  string TwoPairsStr[NUMSESSIONS];
  string Total_TwoPairsStr;
  long Total_TwoPairs;

  // 3 of kind.
  void Make_ThreeOfKindsStrs();
  void Calc_ThreeOfKinds();
  string ThreeOfKindsStr[NUMSESSIONS];
  string Total_ThreeOfKindsStr;
  long Total_ThreeOfKinds;

  // straights
  void Make_StraightsStrs();
  void Calc_Straights();
  string StraightsStr[NUMSESSIONS];
  string Total_StraightsStr;
  long Total_Straights;

  // flushes
  void Make_FlushesStrs();
  void Calc_Flushes();
  string FlushesStr[NUMSESSIONS];
  string Total_FlushesStr;
  long Total_Flushes;

  // full houses
  void Make_FullHousesStrs();
  void Calc_FullHouses();
  string FullHousesStr[NUMSESSIONS];
  string Total_FullHousesStr;
  long Total_FullHouses;

  // 4 of kind
  void Make_FourOfKindsStrs();
  void Calc_FourOfKinds();
  string FourOfKindsStr[NUMSESSIONS];
  string Total_FourOfKindsStr;
  long Total_FourOfKinds;

  // straight flushes
  void Make_StraightFlushesStrs();
  void Calc_StraightFlushes();
  string StraightFlushesStr[NUMSESSIONS];
  string Total_StraightFlushesStr;
  long Total_StraightFlushes;

  // natural royal flushes
  void Make_RoyalFlushesNaturalStrs();
  void Calc_RoyalFlushesNatural();
  string RoyalFlushesNaturalStr[NUMSESSIONS];
  string Total_RoyalFlushesNaturalStr;
  long Total_RoyalFlushesNatural;

  // wild royal flushes
  void Make_RoyalFlushesWildStrs();
  void Calc_RoyalFlushesWild();
  string RoyalFlushesWildStr[NUMSESSIONS];
  string Total_RoyalFlushesWildStr;
  long Total_RoyalFlushesWild;

  //  4 deuces
  void Make_FourDeucesStrs();
  void Calc_FourDeuces();
  string FourDeucesStr[NUMSESSIONS];
  string Total_FourDeucesStr;
  long Total_FourDeuces;

  // 5 of kind
  void Make_FiveOfKindsStrs();
  void Calc_FiveOfKinds();
  string FiveOfKindsStr[NUMSESSIONS];
  string Total_FiveOfKindsStr;
  long Total_FiveOfKinds;

  void Make_HighPairsCashStrs();
  void Calc_HighPairsCash();
  string HighPairsCashStr[NUMSESSIONS];
  string Total_HighPairsCashStr;
  TMoney Total_HighPairsCash;

  void Make_TwoPairsCashStrs();
  void Calc_TwoPairsCash();
  string TwoPairsCashStr[NUMSESSIONS];
  string Total_TwoPairsCashStr;
  TMoney Total_TwoPairsCash;

  void Make_ThreeOfKindsCashStrs();
  void Calc_ThreeOfKindsCash();
  string ThreeOfKindsCashStr[NUMSESSIONS];
  string Total_ThreeOfKindsCashStr;
  TMoney Total_ThreeOfKindsCash;

  void Make_StraightsCashStrs();
  void Calc_StraightsCash();
  string StraightsCashStr[NUMSESSIONS];
  string Total_StraightsCashStr;
  TMoney Total_StraightsCash;

  void Make_FlushesCashStrs();
  void Calc_FlushesCash();
  string FlushesCashStr[NUMSESSIONS];
  string Total_FlushesCashStr;
  TMoney Total_FlushesCash;

  void Make_FullHousesCashStrs();
  void Calc_FullHousesCash();
  string FullHousesCashStr[NUMSESSIONS];
  string Total_FullHousesCashStr;
  TMoney Total_FullHousesCash;

  void Make_FourOfKindsCashStrs();
  void Calc_FourOfKindsCash();
  string FourOfKindsCashStr[NUMSESSIONS];
  string Total_FourOfKindsCashStr;
  TMoney Total_FourOfKindsCash;

  void Make_StraightFlushesCashStrs();
  void Calc_StraightFlushesCash();
  string StraightFlushesCashStr[NUMSESSIONS];
  string Total_StraightFlushesCashStr;
  TMoney Total_StraightFlushesCash;

  void Make_RoyalFlushesNaturalCashStrs();
  void Calc_RoyalFlushesNaturalCash();
  string RoyalFlushesNaturalCashStr[NUMSESSIONS];
  string Total_RoyalFlushesNaturalCashStr;
  TMoney Total_RoyalFlushesNaturalCash;

  void Make_RoyalFlushesWildCashStrs();
  void Calc_RoyalFlushesWildCash();
  string RoyalFlushesWildCashStr[NUMSESSIONS];
  string Total_RoyalFlushesWildCashStr;
  TMoney Total_RoyalFlushesWildCash;

  void Make_FourDeucesCashStrs();
  void Calc_FourDeucesCash();
  string FourDeucesCashStr[NUMSESSIONS];
  string Total_FourDeucesCashStr;
  TMoney Total_FourDeucesCash;

  void Make_FiveOfKindsCashStrs();
  void Calc_FiveOfKindsCash();
  string FiveOfKindsCashStr[NUMSESSIONS];
  string Total_FiveOfKindsCashStr;
  TMoney Total_FiveOfKindsCash;

  void Make_TotalCashWonStrs();
  void Calc_TotalCashWon();
  TMoney TotalCashWon[NUMSESSIONS];
  TMoney Total_TotalCashWon;
  string TotalCashWonStr[NUMSESSIONS];
  string Total_TotalCashWonStr;

  void Make_PercHighPairsCashWonStrs();
  void Calc_PercHighPairsCashWon();
  string PercHighPairsCashWonStr[NUMSESSIONS];
  string Total_PercHighPairsCashWonStr;
  float PercHighPairsCashWon[NUMSESSIONS];
  float Total_PercHighPairsCashWon;

  void Make_PercTwoPairsCashWonStrs();
  void Calc_PercTwoPairsCashWon();
  string PercTwoPairsCashWonStr[NUMSESSIONS];
  string Total_PercTwoPairsCashWonStr;
  float PercTwoPairsCashWon[NUMSESSIONS];
  float Total_PercTwoPairsCashWon;

  void Make_PercThreeOfKindsCashWonStrs();
  void Calc_PercThreeOfKindsCashWon();
  string PercThreeOfKindsCashWonStr[NUMSESSIONS];
  string Total_PercThreeOfKindsCashWonStr;
  float PercThreeOfKindsCashWon[NUMSESSIONS];
  float Total_PercThreeOfKindsCashWon;

  void Make_PercStraightsCashWonStrs();
  void Calc_PercStraightsCashWon();
  string PercStraightsCashWonStr[NUMSESSIONS];
  string Total_PercStraightsCashWonStr;
  float PercStraightsCashWon[NUMSESSIONS];
  float Total_PercStraightsCashWon;

  void Make_PercFlushesCashWonStrs();
  void Calc_PercFlushesCashWon();
  string PercFlushesCashWonStr[NUMSESSIONS];
  string Total_PercFlushesCashWonStr;
  float PercFlushesCashWon[NUMSESSIONS];
  float Total_PercFlushesCashWon;

  void Make_PercFullHousesCashWonStrs();
  void Calc_PercFullHousesCashWon();
  string PercFullHousesCashWonStr[NUMSESSIONS];
  string Total_PercFullHousesCashWonStr;
  float PercFullHousesCashWon[NUMSESSIONS];
  float Total_PercFullHousesCashWon;

  void Make_PercFourOfKindsCashWonStrs();
  void Calc_PercFourOfKindsCashWon();
  string PercFourOfKindsCashWonStr[NUMSESSIONS];
  string Total_PercFourOfKindsCashWonStr;
  float PercFourOfKindsCashWon[NUMSESSIONS];
  float Total_PercFourOfKindsCashWon;

  void Make_PercStraightFlushesCashWonStrs();
  void Calc_PercStraightFlushesCashWon();
  string PercStraightFlushesCashWonStr[NUMSESSIONS];
  string Total_PercStraightFlushesCashWonStr;
  float PercStraightFlushesCashWon[NUMSESSIONS];
  float Total_PercStraightFlushesCashWon;

  void Make_PercRoyalFlushesNaturalCashWonStrs();
  void Calc_PercRoyalFlushesNaturalCashWon();
  string PercRoyalFlushesNaturalCashWonStr[NUMSESSIONS];
  string Total_PercRoyalFlushesNaturalCashWonStr;
  float PercRoyalFlushesNaturalCashWon[NUMSESSIONS];
  float Total_PercRoyalFlushesNaturalCashWon;

  void Make_PercRoyalFlushesWildCashWonStrs();
  void Calc_PercRoyalFlushesWildCashWon();
  string PercRoyalFlushesWildCashWonStr[NUMSESSIONS];
  string Total_PercRoyalFlushesWildCashWonStr;
  float PercRoyalFlushesWildCashWon[NUMSESSIONS];
  float Total_PercRoyalFlushesWildCashWon;

  void Make_PercFourDeucesCashWonStrs();
  void Calc_PercFourDeucesCashWon();
  string PercFourDeucesCashWonStr[NUMSESSIONS];
  string Total_PercFourDeucesCashWonStr;
  float PercFourDeucesCashWon[NUMSESSIONS];
  float Total_PercFourDeucesCashWon;

  void Make_PercFiveOfKindsCashWonStrs();
  void Calc_PercFiveOfKindsCashWon();
  string PercFiveOfKindsCashWonStr[NUMSESSIONS];
  string Total_PercFiveOfKindsCashWonStr;
  float PercFiveOfKindsCashWon[NUMSESSIONS];
  float Total_PercFiveOfKindsCashWon;

  // number of bad strategy plays
  void Make_NumBadStrategyPlaysStrs();
  void Calc_NumBadStrategyPlays();
  string NumBadStrategyPlaysStr[NUMSESSIONS];
  string Total_NumBadStrategyPlaysStr;
  long Total_NumBadStrategyPlays;
  bool GetNumBadStrategyPlays(float *values ,int num);

  // percentage playing accuracy
  void Make_PercPlayingAccuracyStrs();
  void Calc_PercPlayingAccuracy();
  string PercPlayingAccuracyStr[NUMSESSIONS];
  string Total_PercPlayingAccuracyStr;
  float PercPlayingAccuracy[NUMSESSIONS];
  float Total_PercPlayingAccuracy;
  bool GetPercPlayingAccuracy(float *values,int num);

  #if defined(ACVP_COMPILE)
  void Make_Pair6Strs();
  void Calc_Pair6();
  string Pair6Str[NUMSESSIONS];
  string Total_Pair6Str;
  long Total_Pair6;

  void Make_Pair6CashStrs();
  void Calc_Pair6Cash();
  string Pair6CashStr[NUMSESSIONS];
  string Total_Pair6CashStr;
  TMoney Total_Pair6Cash;

  void Make_PercPair6CashWonStrs();
  void Calc_PercPair6CashWon();
  string PercPair6CashWonStr[NUMSESSIONS];
  string Total_PercPair6CashWonStr;
  float PercPair6CashWon[NUMSESSIONS];
  float Total_PercPair6CashWon;

//  void Make_PairJacksStrs();
//  void Calc_PairJacks();
//  string PairJacksStr[NUMSESSIONS];
//  string Total_PairJacksStr;
//  long Total_PairJacks;
//
//  void Make_PairJacksCashStrs();
//  void Calc_PairJacksCash();
//  string PairJacksCashStr[NUMSESSIONS];
//  string Total_PairJacksCashStr;
//  TMoney Total_PairJacksCash;
//
//  void Make_PercPairJacksCashWonStrs();
//  void Calc_PercPairJacksCashWon();
//  string PercPairJacksCashWonStr[NUMSESSIONS];
//  string Total_PercPairJacksCashWonStr;
//  float PercPairJacksCashWon[NUMSESSIONS];
//  float Total_PercPairJacksCashWon;
//
//  void Make_PairKingsStrs();
//  void Calc_PairKings();
//  string PairKingsStr[NUMSESSIONS];
//  string Total_PairKingsStr;
//  long Total_PairKings;
//
//  void Make_PairKingsCashStrs();
//  void Calc_PairKingsCash();
//  string PairKingsCashStr[NUMSESSIONS];
//  string Total_PairKingsCashStr;
//  TMoney Total_PairKingsCash;
//
//  void Make_PercPairKingsCashWonStrs();
//  void Calc_PercPairKingsCashWon();
//  string PercPairKingsCashWonStr[NUMSESSIONS];
//  string Total_PercPairKingsCashWonStr;
//  float PercPairKingsCashWon[NUMSESSIONS];
//  float Total_PercPairKingsCashWon;
//
  void Make_ThreeOfKinds5Strs();
  void Calc_ThreeOfKinds5();
  string ThreeOfKinds5Str[NUMSESSIONS];
  string Total_ThreeOfKinds5Str;
  long Total_ThreeOfKinds5;

  void Make_ThreeOfKinds5CashStrs();
  void Calc_ThreeOfKinds5Cash();
  string ThreeOfKinds5CashStr[NUMSESSIONS];
  string Total_ThreeOfKinds5CashStr;
  TMoney Total_ThreeOfKinds5Cash;

  void Make_PercThreeOfKinds5CashWonStrs();
  void Calc_PercThreeOfKinds5CashWon();
  string PercThreeOfKinds5CashWonStr[NUMSESSIONS];
  string Total_PercThreeOfKinds5CashWonStr;
  float PercThreeOfKinds5CashWon[NUMSESSIONS];
  float Total_PercThreeOfKinds5CashWon;

  void Make_ThreeOfKinds8Strs();
  void Calc_ThreeOfKinds8();
  string ThreeOfKinds8Str[NUMSESSIONS];
  string Total_ThreeOfKinds8Str;
  long Total_ThreeOfKinds8;

  void Make_ThreeOfKinds8CashStrs();
  void Calc_ThreeOfKinds8Cash();
  string ThreeOfKinds8CashStr[NUMSESSIONS];
  string Total_ThreeOfKinds8CashStr;
  TMoney Total_ThreeOfKinds8Cash;

  void Make_PercThreeOfKinds8CashWonStrs();
  void Calc_PercThreeOfKinds8CashWon();
  string PercThreeOfKinds8CashWonStr[NUMSESSIONS];
  string Total_PercThreeOfKinds8CashWonStr;
  float PercThreeOfKinds8CashWon[NUMSESSIONS];
  float Total_PercThreeOfKinds8CashWon;

  void Make_FlushDiamondStrs();
  void Calc_FlushDiamond();
  string FlushDiamondStr[NUMSESSIONS];
  string Total_FlushDiamondStr;
  long Total_FlushDiamond;

  void Make_FlushDiamondCashStrs();
  void Calc_FlushDiamondCash();
  string FlushDiamondCashStr[NUMSESSIONS];
  string Total_FlushDiamondCashStr;
  TMoney Total_FlushDiamondCash;

  void Make_PercFlushDiamondCashWonStrs();
  void Calc_PercFlushDiamondCashWon();
  string PercFlushDiamondCashWonStr[NUMSESSIONS];
  string Total_PercFlushDiamondCashWonStr;
  float PercFlushDiamondCashWon[NUMSESSIONS];
  float Total_PercFlushDiamondCashWon;

  void Make_FlushHeartStrs();
  void Calc_FlushHeart();
  string FlushHeartStr[NUMSESSIONS];
  string Total_FlushHeartStr;
  long Total_FlushHeart;

  void Make_FlushHeartCashStrs();
  void Calc_FlushHeartCash();
  string FlushHeartCashStr[NUMSESSIONS];
  string Total_FlushHeartCashStr;
  TMoney Total_FlushHeartCash;

  void Make_PercFlushHeartCashWonStrs();
  void Calc_PercFlushHeartCashWon();
  string PercFlushHeartCashWonStr[NUMSESSIONS];
  string Total_PercFlushHeartCashWonStr;
  float PercFlushHeartCashWon[NUMSESSIONS];
  float Total_PercFlushHeartCashWon;

  void Make_FlushSpadeStrs();
  void Calc_FlushSpade();
  string FlushSpadeStr[NUMSESSIONS];
  string Total_FlushSpadeStr;
  long Total_FlushSpade;

  void Make_FlushSpadeCashStrs();
  void Calc_FlushSpadeCash();
  string FlushSpadeCashStr[NUMSESSIONS];
  string Total_FlushSpadeCashStr;
  TMoney Total_FlushSpadeCash;

  void Make_PercFlushSpadeCashWonStrs();
  void Calc_PercFlushSpadeCashWon();
  string PercFlushSpadeCashWonStr[NUMSESSIONS];
  string Total_PercFlushSpadeCashWonStr;
  float PercFlushSpadeCashWon[NUMSESSIONS];
  float Total_PercFlushSpadeCashWon;

  void Make_FlushClubStrs();
  void Calc_FlushClub();
  string FlushClubStr[NUMSESSIONS];
  string Total_FlushClubStr;
  long Total_FlushClub;

  void Make_FlushClubCashStrs();
  void Calc_FlushClubCash();
  string FlushClubCashStr[NUMSESSIONS];
  string Total_FlushClubCashStr;
  TMoney Total_FlushClubCash;

  void Make_PercFlushClubCashWonStrs();
  void Calc_PercFlushClubCashWon();
  string PercFlushClubCashWonStr[NUMSESSIONS];
  string Total_PercFlushClubCashWonStr;
  float PercFlushClubCashWon[NUMSESSIONS];
  float Total_PercFlushClubCashWon;

  void Make_FlushAssaultStrs();
  void Calc_FlushAssault();
  string FlushAssaultStr[NUMSESSIONS];
  string Total_FlushAssaultStr;
  long Total_FlushAssault;

  void Make_FlushAssaultCashStrs();
  void Calc_FlushAssaultCash();
  string FlushAssaultCashStr[NUMSESSIONS];
  string Total_FlushAssaultCashStr;
  TMoney Total_FlushAssaultCash;

  void Make_PercFlushAssaultCashWonStrs();
  void Calc_PercFlushAssaultCashWon();
  string PercFlushAssaultCashWonStr[NUMSESSIONS];
  string Total_PercFlushAssaultCashWonStr;
  float PercFlushAssaultCashWon[NUMSESSIONS];
  float Total_PercFlushAssaultCashWon;

  void Make_FourOfKinds5Strs();
  void Calc_FourOfKinds5();
  string FourOfKinds5Str[NUMSESSIONS];
  string Total_FourOfKinds5Str;
  long Total_FourOfKinds5;

  void Make_FourOfKinds5CashStrs();
  void Calc_FourOfKinds5Cash();
  string FourOfKinds5CashStr[NUMSESSIONS];
  string Total_FourOfKinds5CashStr;
  TMoney Total_FourOfKinds5Cash;

  void Make_PercFourOfKinds5CashWonStrs();
  void Calc_PercFourOfKinds5CashWon();
  string PercFourOfKinds5CashWonStr[NUMSESSIONS];
  string Total_PercFourOfKinds5CashWonStr;
  float PercFourOfKinds5CashWon[NUMSESSIONS];
  float Total_PercFourOfKinds5CashWon;

  void Make_FourOfKinds8Strs();
  void Calc_FourOfKinds8();
  string FourOfKinds8Str[NUMSESSIONS];
  string Total_FourOfKinds8Str;
  long Total_FourOfKinds8;

  void Make_FourOfKinds8CashStrs();
  void Calc_FourOfKinds8Cash();
  string FourOfKinds8CashStr[NUMSESSIONS];
  string Total_FourOfKinds8CashStr;
  TMoney Total_FourOfKinds8Cash;

  void Make_PercFourOfKinds8CashWonStrs();
  void Calc_PercFourOfKinds8CashWon();
  string PercFourOfKinds8CashWonStr[NUMSESSIONS];
  string Total_PercFourOfKinds8CashWonStr;
  float PercFourOfKinds8CashWon[NUMSESSIONS];
  float Total_PercFourOfKinds8CashWon;

  void Make_FourOfKinds7Strs();
  void Calc_FourOfKinds7();
  string FourOfKinds7Str[NUMSESSIONS];
  string Total_FourOfKinds7Str;
  long Total_FourOfKinds7;

  void Make_FourOfKinds7CashStrs();
  void Calc_FourOfKinds7Cash();
  string FourOfKinds7CashStr[NUMSESSIONS];
  string Total_FourOfKinds7CashStr;
  TMoney Total_FourOfKinds7Cash;

  void Make_PercFourOfKinds7CashWonStrs();
  void Calc_PercFourOfKinds7CashWon();
  string PercFourOfKinds7CashWonStr[NUMSESSIONS];
  string Total_PercFourOfKinds7CashWonStr;
  float PercFourOfKinds7CashWon[NUMSESSIONS];
  float Total_PercFourOfKinds7CashWon;

  void Make_FourOfKinds2_10Strs();
  void Calc_FourOfKinds2_10();
  string FourOfKinds2_10Str[NUMSESSIONS];
  string Total_FourOfKinds2_10Str;
  long Total_FourOfKinds2_10;

  void Make_FourOfKinds2_10CashStrs();
  void Calc_FourOfKinds2_10Cash();
  string FourOfKinds2_10CashStr[NUMSESSIONS];
  string Total_FourOfKinds2_10CashStr;
  TMoney Total_FourOfKinds2_10Cash;

  void Make_PercFourOfKinds2_10CashWonStrs();
  void Calc_PercFourOfKinds2_10CashWon();
  string PercFourOfKinds2_10CashWonStr[NUMSESSIONS];
  string Total_PercFourOfKinds2_10CashWonStr;
  float PercFourOfKinds2_10CashWon[NUMSESSIONS];
  float Total_PercFourOfKinds2_10CashWon;

  void Make_FourOfKindsFacesStrs();
  void Calc_FourOfKindsFaces();
  string FourOfKindsFacesStr[NUMSESSIONS];
  string Total_FourOfKindsFacesStr;
  long Total_FourOfKindsFaces;

  void Make_FourOfKindsFacesCashStrs();
  void Calc_FourOfKindsFacesCash();
  string FourOfKindsFacesCashStr[NUMSESSIONS];
  string Total_FourOfKindsFacesCashStr;
  TMoney Total_FourOfKindsFacesCash;

  void Make_PercFourOfKindsFacesCashWonStrs();
  void Calc_PercFourOfKindsFacesCashWon();
  string PercFourOfKindsFacesCashWonStr[NUMSESSIONS];
  string Total_PercFourOfKindsFacesCashWonStr;
  float PercFourOfKindsFacesCashWon[NUMSESSIONS];
  float Total_PercFourOfKindsFacesCashWon;

  void Make_FourOfKindsFacesWAceOrFaceStrs();
  void Calc_FourOfKindsFacesWAceOrFace();
  string FourOfKindsFacesWAceOrFaceStr[NUMSESSIONS];
  string Total_FourOfKindsFacesWAceOrFaceStr;
  long Total_FourOfKindsFacesWAceOrFace;

  void Make_FourOfKindsFacesWAceOrFaceCashStrs();
  void Calc_FourOfKindsFacesWAceOrFaceCash();
  string FourOfKindsFacesWAceOrFaceCashStr[NUMSESSIONS];
  string Total_FourOfKindsFacesWAceOrFaceCashStr;
  TMoney Total_FourOfKindsFacesWAceOrFaceCash;

  void Make_PercFourOfKindsFacesWAceOrFaceCashWonStrs();
  void Calc_PercFourOfKindsFacesWAceOrFaceCashWon();
  string PercFourOfKindsFacesWAceOrFaceCashWonStr[NUMSESSIONS];
  string Total_PercFourOfKindsFacesWAceOrFaceCashWonStr;
  float PercFourOfKindsFacesWAceOrFaceCashWon[NUMSESSIONS];
  float Total_PercFourOfKindsFacesWAceOrFaceCashWon;

  void Make_FourOfKindsFacesWAceStrs();
  void Calc_FourOfKindsFacesWAce();
  string FourOfKindsFacesWAceStr[NUMSESSIONS];
  string Total_FourOfKindsFacesWAceStr;
  long Total_FourOfKindsFacesWAce;

  void Make_FourOfKindsFacesWAceCashStrs();
  void Calc_FourOfKindsFacesWAceCash();
  string FourOfKindsFacesWAceCashStr[NUMSESSIONS];
  string Total_FourOfKindsFacesWAceCashStr;
  TMoney Total_FourOfKindsFacesWAceCash;

  void Make_PercFourOfKindsFacesWAceCashWonStrs();
  void Calc_PercFourOfKindsFacesWAceCashWon();
  string PercFourOfKindsFacesWAceCashWonStr[NUMSESSIONS];
  string Total_PercFourOfKindsFacesWAceCashWonStr;
  float PercFourOfKindsFacesWAceCashWon[NUMSESSIONS];
  float Total_PercFourOfKindsFacesWAceCashWon;

  void Make_FourOfKindsAcesWFaceStrs();
  void Calc_FourOfKindsAcesWFace();
  string FourOfKindsAcesWFaceStr[NUMSESSIONS];
  string Total_FourOfKindsAcesWFaceStr;
  long Total_FourOfKindsAcesWFace;

  void Make_FourOfKindsAcesWFaceCashStrs();
  void Calc_FourOfKindsAcesWFaceCash();
  string FourOfKindsAcesWFaceCashStr[NUMSESSIONS];
  string Total_FourOfKindsAcesWFaceCashStr;
  TMoney Total_FourOfKindsAcesWFaceCash;

  void Make_PercFourOfKindsAcesWFaceCashWonStrs();
  void Calc_PercFourOfKindsAcesWFaceCashWon();
  string PercFourOfKindsAcesWFaceCashWonStr[NUMSESSIONS];
  string Total_PercFourOfKindsAcesWFaceCashWonStr;
  float PercFourOfKindsAcesWFaceCashWon[NUMSESSIONS];
  float Total_PercFourOfKindsAcesWFaceCashWon;

  void Make_FourOfKinds4_KStrs();
  void Calc_FourOfKinds4_K();
  string FourOfKinds4_KStr[NUMSESSIONS];
  string Total_FourOfKinds4_KStr;
  long Total_FourOfKinds4_K;

  void Make_FourOfKinds4_KCashStrs();
  void Calc_FourOfKinds4_KCash();
  string FourOfKinds4_KCashStr[NUMSESSIONS];
  string Total_FourOfKinds4_KCashStr;
  TMoney Total_FourOfKinds4_KCash;

  void Make_PercFourOfKinds4_KCashWonStrs();
  void Calc_PercFourOfKinds4_KCashWon();
  string PercFourOfKinds4_KCashWonStr[NUMSESSIONS];
  string Total_PercFourOfKinds4_KCashWonStr;
  float PercFourOfKinds4_KCashWon[NUMSESSIONS];
  float Total_PercFourOfKinds4_KCashWon;

  void Make_FourOfKinds5_KStrs();
  void Calc_FourOfKinds5_K();
  string FourOfKinds5_KStr[NUMSESSIONS];
  string Total_FourOfKinds5_KStr;
  long Total_FourOfKinds5_K;

  void Make_FourOfKinds5_KCashStrs();
  void Calc_FourOfKinds5_KCash();
  string FourOfKinds5_KCashStr[NUMSESSIONS];
  string Total_FourOfKinds5_KCashStr;
  TMoney Total_FourOfKinds5_KCash;

  void Make_PercFourOfKinds5_KCashWonStrs();
  void Calc_PercFourOfKinds5_KCashWon();
  string PercFourOfKinds5_KCashWonStr[NUMSESSIONS];
  string Total_PercFourOfKinds5_KCashWonStr;
  float PercFourOfKinds5_KCashWon[NUMSESSIONS];
  float Total_PercFourOfKinds5_KCashWon;

  void Make_FourOfKinds2_4Strs();
  void Calc_FourOfKinds2_4();
  string FourOfKinds2_4Str[NUMSESSIONS];
  string Total_FourOfKinds2_4Str;
  long Total_FourOfKinds2_4;

  void Make_FourOfKinds2_4CashStrs();
  void Calc_FourOfKinds2_4Cash();
  string FourOfKinds2_4CashStr[NUMSESSIONS];
  string Total_FourOfKinds2_4CashStr;
  TMoney Total_FourOfKinds2_4Cash;

  void Make_PercFourOfKinds2_4CashWonStrs();
  void Calc_PercFourOfKinds2_4CashWon();
  string PercFourOfKinds2_4CashWonStr[NUMSESSIONS];
  string Total_PercFourOfKinds2_4CashWonStr;
  float PercFourOfKinds2_4CashWon[NUMSESSIONS];
  float Total_PercFourOfKinds2_4CashWon;

  void Make_FourOfKindsAcesStrs();
  void Calc_FourOfKindsAces();
  string FourOfKindsAcesStr[NUMSESSIONS];
  string Total_FourOfKindsAcesStr;
  long Total_FourOfKindsAces;

  void Make_FourOfKindsAcesCashStrs();
  void Calc_FourOfKindsAcesCash();
  string FourOfKindsAcesCashStr[NUMSESSIONS];
  string Total_FourOfKindsAcesCashStr;
  TMoney Total_FourOfKindsAcesCash;

  void Make_PercFourOfKindsAcesCashWonStrs();
  void Calc_PercFourOfKindsAcesCashWon();
  string PercFourOfKindsAcesCashWonStr[NUMSESSIONS];
  string Total_PercFourOfKindsAcesCashWonStr;
  float PercFourOfKindsAcesCashWon[NUMSESSIONS];
  float Total_PercFourOfKindsAcesCashWon;

  void Make_StraightFlushesDiamondStrs();
  void Calc_StraightFlushesDiamond();
  string StraightFlushesDiamondStr[NUMSESSIONS];
  string Total_StraightFlushesDiamondStr;
  long Total_StraightFlushesDiamond;

  void Make_StraightFlushesDiamondCashStrs();
  void Calc_StraightFlushesDiamondCash();
  string StraightFlushesDiamondCashStr[NUMSESSIONS];
  string Total_StraightFlushesDiamondCashStr;
  TMoney Total_StraightFlushesDiamondCash;

  void Make_PercStraightFlushesDiamondCashWonStrs();
  void Calc_PercStraightFlushesDiamondCashWon();
  string PercStraightFlushesDiamondCashWonStr[NUMSESSIONS];
  string Total_PercStraightFlushesDiamondCashWonStr;
  float PercStraightFlushesDiamondCashWon[NUMSESSIONS];
  float Total_PercStraightFlushesDiamondCashWon;

  void Make_StraightFlushesHeartStrs();
  void Calc_StraightFlushesHeart();
  string StraightFlushesHeartStr[NUMSESSIONS];
  string Total_StraightFlushesHeartStr;
  long Total_StraightFlushesHeart;

  void Make_StraightFlushesHeartCashStrs();
  void Calc_StraightFlushesHeartCash();
  string StraightFlushesHeartCashStr[NUMSESSIONS];
  string Total_StraightFlushesHeartCashStr;
  TMoney Total_StraightFlushesHeartCash;

  void Make_PercStraightFlushesHeartCashWonStrs();
  void Calc_PercStraightFlushesHeartCashWon();
  string PercStraightFlushesHeartCashWonStr[NUMSESSIONS];
  string Total_PercStraightFlushesHeartCashWonStr;
  float PercStraightFlushesHeartCashWon[NUMSESSIONS];
  float Total_PercStraightFlushesHeartCashWon;

  void Make_StraightFlushesSpadeStrs();
  void Calc_StraightFlushesSpade();
  string StraightFlushesSpadeStr[NUMSESSIONS];
  string Total_StraightFlushesSpadeStr;
  long Total_StraightFlushesSpade;

  void Make_StraightFlushesSpadeCashStrs();
  void Calc_StraightFlushesSpadeCash();
  string StraightFlushesSpadeCashStr[NUMSESSIONS];
  string Total_StraightFlushesSpadeCashStr;
  TMoney Total_StraightFlushesSpadeCash;

  void Make_PercStraightFlushesSpadeCashWonStrs();
  void Calc_PercStraightFlushesSpadeCashWon();
  string PercStraightFlushesSpadeCashWonStr[NUMSESSIONS];
  string Total_PercStraightFlushesSpadeCashWonStr;
  float PercStraightFlushesSpadeCashWon[NUMSESSIONS];
  float Total_PercStraightFlushesSpadeCashWon;

  void Make_StraightFlushesClubStrs();
  void Calc_StraightFlushesClub();
  string StraightFlushesClubStr[NUMSESSIONS];
  string Total_StraightFlushesClubStr;
  long Total_StraightFlushesClub;

  void Make_StraightFlushesClubCashStrs();
  void Calc_StraightFlushesClubCash();
  string StraightFlushesClubCashStr[NUMSESSIONS];
  string Total_StraightFlushesClubCashStr;
  TMoney Total_StraightFlushesClubCash;

  void Make_PercStraightFlushesClubCashWonStrs();
  void Calc_PercStraightFlushesClubCashWon();
  string PercStraightFlushesClubCashWonStr[NUMSESSIONS];
  string Total_PercStraightFlushesClubCashWonStr;
  float PercStraightFlushesClubCashWon[NUMSESSIONS];
  float Total_PercStraightFlushesClubCashWon;

  void Make_RoyalFlushesHeartStrs();
  void Calc_RoyalFlushesHeart();
  string RoyalFlushesHeartStr[NUMSESSIONS];
  string Total_RoyalFlushesHeartStr;
  long Total_RoyalFlushesHeart;

  void Make_RoyalFlushesHeartCashStrs();
  void Calc_RoyalFlushesHeartCash();
  string RoyalFlushesHeartCashStr[NUMSESSIONS];
  string Total_RoyalFlushesHeartCashStr;
  TMoney Total_RoyalFlushesHeartCash;

  void Make_PercRoyalFlushesHeartCashWonStrs();
  void Calc_PercRoyalFlushesHeartCashWon();
  string PercRoyalFlushesHeartCashWonStr[NUMSESSIONS];
  string Total_PercRoyalFlushesHeartCashWonStr;
  float PercRoyalFlushesHeartCashWon[NUMSESSIONS];
  float Total_PercRoyalFlushesHeartCashWon;

  void Make_RoyalFlushesDiamondStrs();
  void Calc_RoyalFlushesDiamond();
  string RoyalFlushesDiamondStr[NUMSESSIONS];
  string Total_RoyalFlushesDiamondStr;
  long Total_RoyalFlushesDiamond;

  void Make_RoyalFlushesDiamondCashStrs();
  void Calc_RoyalFlushesDiamondCash();
  string RoyalFlushesDiamondCashStr[NUMSESSIONS];
  string Total_RoyalFlushesDiamondCashStr;
  TMoney Total_RoyalFlushesDiamondCash;

  void Make_PercRoyalFlushesDiamondCashWonStrs();
  void Calc_PercRoyalFlushesDiamondCashWon();
  string PercRoyalFlushesDiamondCashWonStr[NUMSESSIONS];
  string Total_PercRoyalFlushesDiamondCashWonStr;
  float PercRoyalFlushesDiamondCashWon[NUMSESSIONS];
  float Total_PercRoyalFlushesDiamondCashWon;

  void Make_RoyalFlushesSpadeStrs();
  void Calc_RoyalFlushesSpade();
  string RoyalFlushesSpadeStr[NUMSESSIONS];
  string Total_RoyalFlushesSpadeStr;
  long Total_RoyalFlushesSpade;

  void Make_RoyalFlushesSpadeCashStrs();
  void Calc_RoyalFlushesSpadeCash();
  string RoyalFlushesSpadeCashStr[NUMSESSIONS];
  string Total_RoyalFlushesSpadeCashStr;
  TMoney Total_RoyalFlushesSpadeCash;

  void Make_PercRoyalFlushesSpadeCashWonStrs();
  void Calc_PercRoyalFlushesSpadeCashWon();
  string PercRoyalFlushesSpadeCashWonStr[NUMSESSIONS];
  string Total_PercRoyalFlushesSpadeCashWonStr;
  float PercRoyalFlushesSpadeCashWon[NUMSESSIONS];
  float Total_PercRoyalFlushesSpadeCashWon;

  void Make_RoyalFlushesClubStrs();
  void Calc_RoyalFlushesClub();
  string RoyalFlushesClubStr[NUMSESSIONS];
  string Total_RoyalFlushesClubStr;
  long Total_RoyalFlushesClub;

  void Make_RoyalFlushesClubCashStrs();
  void Calc_RoyalFlushesClubCash();
  string RoyalFlushesClubCashStr[NUMSESSIONS];
  string Total_RoyalFlushesClubCashStr;
  TMoney Total_RoyalFlushesClubCash;

  void Make_PercRoyalFlushesClubCashWonStrs();
  void Calc_PercRoyalFlushesClubCashWon();
  string PercRoyalFlushesClubCashWonStr[NUMSESSIONS];
  string Total_PercRoyalFlushesClubCashWonStr;
  float PercRoyalFlushesClubCashWon[NUMSESSIONS];
  float Total_PercRoyalFlushesClubCashWon;

  void Make_FiveOfKinds6_KStrs();
  void Calc_FiveOfKinds6_K();
  string FiveOfKinds6_KStr[NUMSESSIONS];
  string Total_FiveOfKinds6_KStr;
  long Total_FiveOfKinds6_K;

  void Make_FiveOfKinds6_KCashStrs();
  void Calc_FiveOfKinds6_KCash();
  string FiveOfKinds6_KCashStr[NUMSESSIONS];
  string Total_FiveOfKinds6_KCashStr;
  TMoney Total_FiveOfKinds6_KCash;

  void Make_PercFiveOfKinds6_KCashWonStrs();
  void Calc_PercFiveOfKinds6_KCashWon();
  string PercFiveOfKinds6_KCashWonStr[NUMSESSIONS];
  string Total_PercFiveOfKinds6_KCashWonStr;
  float PercFiveOfKinds6_KCashWon[NUMSESSIONS];
  float Total_PercFiveOfKinds6_KCashWon;

  void Make_FiveOfKinds3_5Strs();
  void Calc_FiveOfKinds3_5();
  string FiveOfKinds3_5Str[NUMSESSIONS];
  string Total_FiveOfKinds3_5Str;
  long Total_FiveOfKinds3_5;

  void Make_FiveOfKinds3_5CashStrs();
  void Calc_FiveOfKinds3_5Cash();
  string FiveOfKinds3_5CashStr[NUMSESSIONS];
  string Total_FiveOfKinds3_5CashStr;
  TMoney Total_FiveOfKinds3_5Cash;

  void Make_PercFiveOfKinds3_5CashWonStrs();
  void Calc_PercFiveOfKinds3_5CashWon();
  string PercFiveOfKinds3_5CashWonStr[NUMSESSIONS];
  string Total_PercFiveOfKinds3_5CashWonStr;
  float PercFiveOfKinds3_5CashWon[NUMSESSIONS];
  float Total_PercFiveOfKinds3_5CashWon;

  void Make_FiveOfKindsAcesStrs();
  void Calc_FiveOfKindsAces();
  string FiveOfKindsAcesStr[NUMSESSIONS];
  string Total_FiveOfKindsAcesStr;
  long Total_FiveOfKindsAces;

  void Make_FiveOfKindsAcesCashStrs();
  void Calc_FiveOfKindsAcesCash();
  string FiveOfKindsAcesCashStr[NUMSESSIONS];
  string Total_FiveOfKindsAcesCashStr;
  TMoney Total_FiveOfKindsAcesCash;

  void Make_PercFiveOfKindsAcesCashWonStrs();
  void Calc_PercFiveOfKindsAcesCashWon();
  string PercFiveOfKindsAcesCashWonStr[NUMSESSIONS];
  string Total_PercFiveOfKindsAcesCashWonStr;
  float PercFiveOfKindsAcesCashWon[NUMSESSIONS];
  float Total_PercFiveOfKindsAcesCashWon;

  void Make_FourOfKinds2WAceStrs();
  void Calc_FourOfKinds2WAce();
  string FourOfKinds2WAceStr[NUMSESSIONS];
  string Total_FourOfKinds2WAceStr;
  long Total_FourOfKinds2WAce;

  void Make_FourOfKinds2WAceCashStrs();
  void Calc_FourOfKinds2WAceCash();
  string FourOfKinds2WAceCashStr[NUMSESSIONS];
  string Total_FourOfKinds2WAceCashStr;
  TMoney Total_FourOfKinds2WAceCash;

  void Make_PercFourOfKinds2WAceCashWonStrs();
  void Calc_PercFourOfKinds2WAceCashWon();
  string PercFourOfKinds2WAceCashWonStr[NUMSESSIONS];
  string Total_PercFourOfKinds2WAceCashWonStr;
  float PercFourOfKinds2WAceCashWon[NUMSESSIONS];
  float Total_PercFourOfKinds2WAceCashWon;

  void Make_FourOfKinds7WJokerStrs();
  void Calc_FourOfKinds7WJoker();
  string FourOfKinds7WJokerStr[NUMSESSIONS];
  string Total_FourOfKinds7WJokerStr;
  long Total_FourOfKinds7WJoker;

  void Make_FourOfKinds7WJokerCashStrs();
  void Calc_FourOfKinds7WJokerCash();
  string FourOfKinds7WJokerCashStr[NUMSESSIONS];
  string Total_FourOfKinds7WJokerCashStr;
  TMoney Total_FourOfKinds7WJokerCash;

  void Make_PercFourOfKinds7WJokerCashWonStrs();
  void Calc_PercFourOfKinds7WJokerCashWon();
  string PercFourOfKinds7WJokerCashWonStr[NUMSESSIONS];
  string Total_PercFourOfKinds7WJokerCashWonStr;
  float PercFourOfKinds7WJokerCashWon[NUMSESSIONS];
  float Total_PercFourOfKinds7WJokerCashWon;

  void Make_FiveOfKindsJokerStrs();
  void Calc_FiveOfKindsJoker();
  string FiveOfKindsJokerStr[NUMSESSIONS];
  string Total_FiveOfKindsJokerStr;
  long Total_FiveOfKindsJoker;

  void Make_FiveOfKindsJokerCashStrs();
  void Calc_FiveOfKindsJokerCash();
  string FiveOfKindsJokerCashStr[NUMSESSIONS];
  string Total_FiveOfKindsJokerCashStr;
  TMoney Total_FiveOfKindsJokerCash;

  void Make_PercFiveOfKindsJokerCashWonStrs();
  void Calc_PercFiveOfKindsJokerCashWon();
  string PercFiveOfKindsJokerCashWonStr[NUMSESSIONS];
  string Total_PercFiveOfKindsJokerCashWonStr;
  float PercFiveOfKindsJokerCashWon[NUMSESSIONS];
  float Total_PercFiveOfKindsJokerCashWon;
  #endif
};
//*******************************************************************
//*******************************************************************
class TVPGraph:public TCasinoGraphDlg
{
public:
  TVPGraph(TCasinoStatDlg* pstatdlg,TStatCalcVP *pstatcalc);
  virtual ~TVPGraph();
};
//*******************************************************************
#endif