//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  cvpdata.h
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     9/9/96    M.Perry     split up cplaydat file.
//  2.0    09/17/97   M.Perry     32-bit conversion.
//********************************************************************
#if !defined(__cvpdata_h)
#define __cvpdata_h

#include "casdata.h"
//*******************************************************************
struct TCVPSession : public TCasinoSession
{
  int16 GarbageHands;
  int16 HighPairs;
  int16 TwoPairs;
  int16 ThreeOfKinds;
  int16 Straights;
  int16 Flushes;
  int16 FullHouses;
  int16 FourOfKinds;
  int16 StraightFlushes;
  int16 NaturalRoyals;
  int16 WildRoyals;
  int16 FiveOfKinds;
  int16 FourDeuces;
  TMoney TotalCashWon;
  TMoney TotalHighPairCash;
  TMoney TotalTwoPairCash;
  TMoney TotalThreeOfKindCash;
  TMoney TotalStraightCash;
  TMoney TotalFlushCash;
  TMoney TotalFullHouseCash;
  TMoney TotalFourOfKindCash;
  TMoney TotalStraightFlushCash;
  TMoney TotalNaturalRoyalCash;
  TMoney TotalWildRoyalCash;
  TMoney TotalFiveOfKindCash;
  TMoney TotalFourDeuceCash;
  #if defined(ACVP_COMPILE)
  int16 Pair6;
  int16 PairJacks;
  int16 PairKings;
  int16 ThreeOfKinds5;
  int16 ThreeOfKinds8;
  int16 FlushDiamond;
  int16 FlushHeart;
  int16 FlushSpade;
  int16 FlushClub;
  int16 FlushAssault;
  int16 FourOfKinds5;
  int16 FourOfKinds8;
  int16 FourOfKinds7;
  int16 FourOfKinds2_10;
  int16 FourOfKindsFaces;
  int16 FourOfKindsFacesWAceOrFace;
  int16 FourOfKindsFacesWAce;
  int16 FourOfKindsAcesWFace;
  int16 FourOfKinds4_K;
  int16 FourOfKinds5_K;
  int16 FourOfKinds2_4;
  int16 FourOfKindsAces;
  int16 StraightFlushesDiamond;
  int16 StraightFlushesHeart;
  int16 StraightFlushesSpade;
  int16 StraightFlushesClub;
  int16 RoyalFlushesHeart;
  int16 RoyalFlushesDiamond;
  int16 RoyalFlushesSpade;
  int16 RoyalFlushesClub;
  int16 FiveOfKinds6_K;
  int16 FiveOfKinds3_5;
  int16 FiveOfKindsAces;
  int16 FourOfKinds2WAce;
  int16 FourOfKinds7WJoker;
  int16 FiveOfKindsJoker;

  TMoney TotalPair6Cash;
  TMoney TotalPairJacksCash;
  TMoney TotalPairKingsCash;
  TMoney TotalThreeOfKinds5Cash;
  TMoney TotalThreeOfKinds8Cash;
  TMoney TotalFlushDiamondCash;
  TMoney TotalFlushHeartCash;
  TMoney TotalFlushSpadeCash;
  TMoney TotalFlushClubCash;
  TMoney TotalFlushAssaultCash;
  TMoney TotalFourOfKinds5Cash;
  TMoney TotalFourOfKinds8Cash;
  TMoney TotalFourOfKinds7Cash;
  TMoney TotalFourOfKinds2_10Cash;
  TMoney TotalFourOfKindsFacesCash;
  TMoney TotalFourOfKindsFacesWAceOrFaceCash;
  TMoney TotalFourOfKindsFacesWAceCash;
  TMoney TotalFourOfKindsAcesWFaceCash;
  TMoney TotalFourOfKinds4_KCash;
  TMoney TotalFourOfKinds5_KCash;
  TMoney TotalFourOfKinds2_4Cash;
  TMoney TotalFourOfKindsAcesCash;
  TMoney TotalStraightFlushesDiamondCash;
  TMoney TotalStraightFlushesHeartCash;
  TMoney TotalStraightFlushesSpadeCash;
  TMoney TotalStraightFlushesClubCash;
  TMoney TotalRoyalFlushesHeartCash;
  TMoney TotalRoyalFlushesDiamondCash;
  TMoney TotalRoyalFlushesSpadeCash;
  TMoney TotalRoyalFlushesClubCash;
  TMoney TotalFiveOfKinds6_KCash;
  TMoney TotalFiveOfKinds3_5Cash;
  TMoney TotalFiveOfKindsAcesCash;
  TMoney TotalFourOfKinds2WAceCash;
  TMoney TotalFourOfKinds7WJokerCash;
  TMoney TotalFiveOfKindsJokerCash;
  #endif
  TCVPSession();
  void ClearData();
  void StartSession(TMoney startingcash,int16 subgametype,TMoney denom);
  void EndSession(TMoney endingcash);
};
//*******************************************************************
struct TCasinoVPData : public TCasinoData
{
  TMoney Cumulative;

  TCVPSession Sessions[NUMSESSIONS];
  TCasinoVPData();

  void ClearData();
  void StartSession(TMoney startingcash,int16 subgametype,TMoney denom);
  void EndSession(TMoney endingcash);
  int16 GetFirstValidSession();
  int16 GetNextValidSession();
  void IncCurrentSession();
  int16 GetPrevValidSession();
};
//*******************************************************************
#endif
