//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//                                              
//       File Name:  hsgfw.h
//    Project Name:  Hundred Slots
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.3     5/20/97    M.Perry    original baseline
//  2.0    09/09/97    M.Perry    32-bit conversion.
//********************************************************************
#if !defined(__hsgfw_h)
#define __hsgfw_h

#include "casgfw.h"
class THSApp;
//*******************************************************************
class THSMenuEnable:public TCasinoMenuEnable
{
public:
//  TMoney Denom;

//  bool Lobby;

  bool TreasuresAtlantis_5c,TreasuresAtlantis_25c,TreasuresAtlantis_1,TreasuresAtlantis_10,
       TreasuresAtlantis_50;

  bool ThunderAlley_25c,ThunderAlley_1,ThunderAlley_5;

  bool RagsRiches_5c,RagsRiches_10c,RagsRiches_25c,RagsRiches_1;

  bool WinnersCircle_5c,WinnersCircle_10c,WinnersCircle_25c;

  bool TexasTwister_25c,TexasTwister_1,TexasTwister_5,TexasTwister_10,TexasTwister_25;

  bool TreasureHaunt_5c,TreasureHaunt_10c,TreasureHaunt_25c,TreasureHaunt_50;

  bool CashQuest_5c,CashQuest_25c,CashQuest_1,CashQuest_5;

  bool BirthdayBash_5c,BirthdayBash_25c,BirthdayBash_1;

  bool MonkeyMadness_5cp,MonkeyMadness_10cp,MonkeyMadness_25cp;

  bool ZodiacAttackI_10c,ZodiacAttackI_25c,ZodiacAttackI_1;

  bool ZodiacAttackII_10c,ZodiacAttackII_25c,ZodiacAttackII_1;

  bool ZodiacAttackIII_10c,ZodiacAttackIII_25c,ZodiacAttackIII_1;

  bool RockRoll_25c,RockRoll_1,RockRoll_50,RockRoll_100,RockRoll_1000;

  bool SilverSafari_1,SilverSafari_5,SilverSafari_100,SilverSafari_1000;

  bool AlienInvasion_25cp,AlienInvasion_1p;

  bool FruitLoot_1,FruitLoot_5,FruitLoot_10;

  bool TycoonsTrust_1,TycoonsTrust_5,TycoonsTrust_10,TycoonsTrust_25;

  bool SouthernCross_1,SouthernCross_5,SouthernCross_10,SouthernCross_25;

  bool PoolShark_5,PoolShark_10,PoolShark_25,PoolShark_50,PoolShark_500;

  bool SuperJackpot_10p,SuperJackpot_100p;

  bool GoldRush_50,GoldRush_500,GoldRush_1000;

  bool QuestGold_10c,QuestGold_25c,QuestGold_1,QuestGold_25;

  bool RoadRallyII_25c,RoadRallyII_1,RoadRallyII_5,RoadRallyII_100;

  bool HotReels_25c,HotReels_1,HotReels_5,HotReels_10,HotReels_100,HotReels_1000;

  bool SwampMusic_25c,SwampMusic_1,SwampMusic_10;

  bool LightningStrikes_25c,LightningStrikes_1,LightningStrikes_5,LightningStrikes_50,LightningStrikes_100,LightningStrikes_1000;

  bool ShootMoon_25c,ShootMoon_1,ShootMoon_10;

public:
  THSMenuEnable(bool setvalues = true);
  virtual ~THSMenuEnable();
  virtual void SetAll(bool value);
  virtual void SetModes(bool value = true);
};
//*******************************************************************
class THSGameFrameWindow:public TCasinoGameFrameWindow
{
public:
  virtual void NotifyDenomSwitch(TMoney denom);
  TMoney ModeDenom;  // set by switchxxx, used by createmodewindow
  THSGameFrameWindow(THSApp *phsapp,const char *szTitle);
  virtual ~THSGameFrameWindow();
  virtual TWindow *CreateModeWindow(int16 ModeIndex);
  virtual int GetAboutID();
  virtual int GetMenuID();
  void DoMenu();
  virtual void SwitchGameModes(int16 modeindex);
  virtual void SwitchGameModes(string &name) {SwitchGameModes(GetModeIndex(name));}
protected:
//  virtual void CreatePlayerMgr();
  void SwitchModesID(word id,word sid);
//  virtual void HandleSwitchModesIDCode(TSwToModeIDCodeMsg &msg);
  void SetupModeNameStrings();
  THSMenuEnable *GetHSMenuEnable() {return (THSMenuEnable *)GetCasMenuEnable();}
  virtual void CreateMenuEnable();

//  string strIntro;

//  string strLobby;
  void CmGameLobby();
  void CeGameLobby(TCommandEnabler &enabler);

  bool SwitchModeDenom(int16 modeid,TMoney money);
  void EnableCheckMenu(TCommandEnabler &ce,bool enable,int16 modeid,TMoney money);

  string strTreasuresAtlantis;
  bool SwitchTreasuresAtlantis(TMoney money);
  void CmTreasuresAtlantis_5c();
  void CeTreasuresAtlantis_5c(TCommandEnabler &enabler);
  void CmTreasuresAtlantis_25c();
  void CeTreasuresAtlantis_25c(TCommandEnabler &enabler);
  void CmTreasureAtlantis_1();
  void CeTreasureAtlantis_1(TCommandEnabler &enabler);
//  void CmTreasuresAtlantis_5();
//  void CeTreasuresAtlantis_5(TCommandEnabler &enabler);
  void CmTreasuresAtlantis_10();
  void CeTreasuresAtlantis_10(TCommandEnabler &enabler);
//  void CmTreasuresAtlantis_25();
//  void CeTreasuresAtlantis_25(TCommandEnabler &enabler);
  void CmTreasuresAtlantis_50();
  void CeTreasuresAtlantis_50(TCommandEnabler &enabler);

  string strThunderAlley;
  bool SwitchThunderAlley(TMoney money);
//  void CmThunderAlley_5c();
//  void CeThunderAlley_5c(TCommandEnabler &enabler);
//  void CmThunderAlley_10c();
//  void CeThunderAlley_10c(TCommandEnabler &enabler);
  void CmThunderAlley_25c();
  void CeThunderAlley_25c(TCommandEnabler &enabler);
  void CmThunderAlley_1();
  void CeThunderAlley_1(TCommandEnabler &enabler);
  void CmThunderAlley_5();
  void CeThunderAlley_5(TCommandEnabler &enabler);

  string strRagsRiches;
  bool SwitchRagsRiches(TMoney money);
  void CmRagsRiches_5c();
  void CeRagsRiches_5c(TCommandEnabler &enabler);
  void CmRagsRiches_10c();
  void CeRagsRiches_10c(TCommandEnabler &enabler);
  void CmRagsRiches_25c();
  void CeRagsRiches_25c(TCommandEnabler &enabler);
  void CmRagsRiches_1();
  void CeRagsRiches_1(TCommandEnabler &enabler);

  string strWinnersCircle;
  bool SwitchWinnersCircle(TMoney money);
  void CmWinnersCircle_5c();
  void CeWinnersCircle_5c(TCommandEnabler &enabler);
  void CmWinnersCircle_10c();
  void CeWinnersCircle_10c(TCommandEnabler &enabler);
  void CmWinnersCircle_25c();
  void CeWinnersCircle_25c(TCommandEnabler &enabler);

  string strTexasTwister;
  bool SwitchTexasTwister(TMoney money);
//  void CmTexasTwister_5c();
//  void CeTexasTwister_5c(TCommandEnabler &enabler);
//  void CmTexasTwister_10c();
//  void CeTexasTwister_10c(TCommandEnabler &enabler);
  void CmTexasTwister_25c();
  void CeTexasTwister_25c(TCommandEnabler &enabler);
  void CmTexasTwister_1();
  void CeTexasTwister_1(TCommandEnabler &enabler);
  void CmTexasTwister_5();
  void CeTexasTwister_5(TCommandEnabler &enabler);
  void CmTexasTwister_10();
  void CeTexasTwister_10(TCommandEnabler &enabler);
  void CmTexasTwister_25();
  void CeTexasTwister_25(TCommandEnabler &enabler);

  string strTreasureHaunt;
  bool SwitchTreasureHaunt(TMoney money);
  void CmTreasureHaunt_5c();
  void CeTreasureHaunt_5c(TCommandEnabler &enabler);
  void CmTreasureHaunt_10c();
  void CeTreasureHaunt_10c(TCommandEnabler &enabler);
  void CmTreasureHaunt_25c();
  void CeTreasureHaunt_25c(TCommandEnabler &enabler);
  void CmTreasureHaunt_50();
  void CeTreasureHaunt_50(TCommandEnabler &enabler);
//  void CmTreasureHaunt_100();
//  void CeTreasureHaunt_100(TCommandEnabler &enabler);

  string strCashQuest;
  bool SwitchCashQuest(TMoney money);
  void CmCashQuest_5c();
  void CeCashQuest_5c(TCommandEnabler &enabler);
//  void CmCashQuest_10c();
//  void CeCashQuest_10c(TCommandEnabler &enabler);
  void CmCashQuest_25c();
  void CeCashQuest_25c(TCommandEnabler &enabler);
  void CmCashQuest_1();
  void CeCashQuest_1(TCommandEnabler &enabler);
  void CmCashQuest_5();
  void CeCashQuest_5(TCommandEnabler &enabler);
//  void CmCashQuest_10();
//  void CeCashQuest_10(TCommandEnabler &enabler);
//  void CmCashQuest_25();
//  void CeCashQuest_25(TCommandEnabler &enabler);
//  void CmCashQuest_50();
//  void CeCashQuest_50(TCommandEnabler &enabler);
//  void CmCashQuest_100();
//  void CeCashQuest_100(TCommandEnabler &enabler);

  string strBirthdayBash;
  bool SwitchBirthdayBash(TMoney money);
  void CmBirthdayBash_5c();
  void CeBirthdayBash_5c(TCommandEnabler &enabler);
//  void CmBirthdayBash_10c();
//  void CeBirthdayBash_10c(TCommandEnabler &enabler);
  void CmBirthdayBash_25c();
  void CeBirthdayBash_25c(TCommandEnabler &enabler);
  void CmBirthdayBash_1();
  void CeBirthdayBash_1(TCommandEnabler &enabler);
//  void CmBirthdayBash_5();
//  void CeBirthdayBash_5(TCommandEnabler &enabler);

  string strMonkeyMadness;
  bool SwitchMonkeyMadness(TMoney money);
  void CmMonkeyMadness_5cp();
  void CeMonkeyMadness_5cp(TCommandEnabler &enabler);
  void CmMonkeyMadness_10cp();
  void CeMonkeyMadness_10cp(TCommandEnabler &enabler);
  void CmMonkeyMadness_25cp();
  void CeMonkeyMadness_25cp(TCommandEnabler &enabler);

  string strZodiacAttackI;
  bool SwitchZodiacAttackI(TMoney money);
  void CmZodiacAttackI_10c();
  void CeZodiacAttackI_10c(TCommandEnabler &enabler);
  void CmZodiacAttackI_25c();
  void CeZodiacAttackI_25c(TCommandEnabler &enabler);
  void CmZodiacAttackI_1();
  void CeZodiacAttackI_1(TCommandEnabler &enabler);
//  void CmZodiacAttackI_5();
//  void CeZodiacAttackI_5(TCommandEnabler &enabler);

  string strZodiacAttackII;
  bool SwitchZodiacAttackII(TMoney money);
  void CmZodiacAttackII_10c();
  void CeZodiacAttackII_10c(TCommandEnabler &enabler);
  void CmZodiacAttackII_25c();
  void CeZodiacAttackII_25c(TCommandEnabler &enabler);
  void CmZodiacAttackII_1();
  void CeZodiacAttackII_1(TCommandEnabler &enabler);
//  void CmZodiacAttackII_5();
//  void CeZodiacAttackII_5(TCommandEnabler &enabler);

  string strZodiacAttackIII;
  bool SwitchZodiacAttackIII(TMoney money);
  void CmZodiacAttackIII_10c();
  void CeZodiacAttackIII_10c(TCommandEnabler &enabler);
  void CmZodiacAttackIII_25c();
  void CeZodiacAttackIII_25c(TCommandEnabler &enabler);
  void CmZodiacAttackIII_1();
  void CeZodiacAttackIII_1(TCommandEnabler &enabler);
//  void CmZodiacAttackIII_5();
//  void CeZodiacAttackIII_5(TCommandEnabler &enabler);

  string strRockRoll;
  bool SwitchRockRoll(TMoney money);
  void CmRockRoll_25c();
  void CeRockRoll_25c(TCommandEnabler &enabler);
  void CmRockRoll_1();
  void CeRockRoll_1(TCommandEnabler &enabler);
  void CmRockRoll_50();
  void CeRockRoll_50(TCommandEnabler &enabler);
  void CmRockRoll_100();
  void CeRockRoll_100(TCommandEnabler &enabler);
//  void CmRockRoll_500();
//  void CeRockRoll_500(TCommandEnabler &enabler);
  void CmRockRoll_1000();
  void CeRockRoll_1000(TCommandEnabler &enabler);

  string strSilverSafari;
  bool SwitchSilverSafari(TMoney money);
//  void CmSilverSafari_25c();
//  void CeSilverSafari_25c(TCommandEnabler &enabler);
  void CmSilverSafari_1();
  void CeSilverSafari_1(TCommandEnabler &enabler);
  void CmSilverSafari_5();
  void CeSilverSafari_5(TCommandEnabler &enabler);
//  void CmSilverSafari_10();
//  void CeSilverSafari_10(TCommandEnabler &enabler);
//  void CmSilverSafari_25();
//  void CeSilverSafari_25(TCommandEnabler &enabler);
//  void CmSilverSafari_50();
//  void CeSilverSafari_50(TCommandEnabler &enabler);
  void CmSilverSafari_100();
  void CeSilverSafari_100(TCommandEnabler &enabler);
//  void CmSilverSafari_500();
//  void CeSilverSafari_500(TCommandEnabler &enabler);
  void CmSilverSafari_1000();
  void CeSilverSafari_1000(TCommandEnabler &enabler);

  string strAlienInvasion;
  bool SwitchAlienInvasion(TMoney money);
  void CmAlienInvasion_25cp();
  void CeAlienInvasion_25cp(TCommandEnabler &enabler);
  void CmAlienInvasion_1p();
  void CeAlienInvasion_1p(TCommandEnabler &enabler);

  string strFruitLoot;
  bool SwitchFruitLoot(TMoney money);
  void CmFruitLoot_1();
  void CeFruitLoot_1(TCommandEnabler &enabler);
  void CmFruitLoot_5();
  void CeFruitLoot_5(TCommandEnabler &enabler);
  void CmFruitLoot_10();
  void CeFruitLoot_10(TCommandEnabler &enabler);

  string strTycoonsTrust;
  bool SwitchTycoonsTrust(TMoney money);
  void CmTycoonsTrust_1();
  void CeTycoonsTrust_1(TCommandEnabler &enabler);
  void CmTycoonsTrust_5();
  void CeTycoonsTrust_5(TCommandEnabler &enabler);
  void CmTycoonsTrust_10();
  void CeTycoonsTrust_10(TCommandEnabler &enabler);
  void CmTycoonsTrust_25();
  void CeTycoonsTrust_25(TCommandEnabler &enabler);

  string strSouthernCross;
  bool SwitchSouthernCross(TMoney money);
  void CmSouthernCross_1();
  void CeSouthernCross_1(TCommandEnabler &enabler);
  void CmSouthernCross_5();
  void CeSouthernCross_5(TCommandEnabler &enabler);
  void CmSouthernCross_10();
  void CeSouthernCross_10(TCommandEnabler &enabler);
  void CmSouthernCross_25();
  void CeSouthernCross_25(TCommandEnabler &enabler);
//  void CmSouthernCross_50();
//  void CeSouthernCross_50(TCommandEnabler &enabler);
//  void CmSouthernCross_100();
//  void CeSouthernCross_100(TCommandEnabler &enabler);

  string strPoolShark;
  bool SwitchPoolShark(TMoney money);
  void CmPoolShark_5();
  void CePoolShark_5(TCommandEnabler &enabler);
  void CmPoolShark_10();
  void CePoolShark_10(TCommandEnabler &enabler);
  void CmPoolShark_25();
  void CePoolShark_25(TCommandEnabler &enabler);
  void CmPoolShark_50();
  void CePoolShark_50(TCommandEnabler &enabler);
  void CmPoolShark_500();
  void CePoolShark_500(TCommandEnabler &enabler);

  string strSuperJackpot;
  bool SwitchSuperJackpot(TMoney money);
  void CmSuperJackpot_10p();
  void CeSuperJackpot_10p(TCommandEnabler &enabler);
  void CmSuperJackpot_100p();
  void CeSuperJackpot_100p(TCommandEnabler &enabler);

  string strGoldRush;
  bool SwitchGoldRush(TMoney money);
  void CmGoldRush_50();
  void CeGoldRush_50(TCommandEnabler &enabler);
//  void CmGoldRush_100();
//  void CeGoldRush_100(TCommandEnabler &enabler);
  void CmGoldRush_500();
  void CeGoldRush_500(TCommandEnabler &enabler);
  void CmGoldRush_1000();
  void CeGoldRush_1000(TCommandEnabler &enabler);

  // start of new modes.

  string strShootMoon;
  bool SwitchShootMoon(TMoney money);
  void CmShootMoon_25c();
  void CeShootMoon_25c(TCommandEnabler &ce);
  void CmShootMoon_1();
  void CeShootMoon_1(TCommandEnabler &ce);
  void CmShootMoon_10();
  void CeShootMoon_10(TCommandEnabler &ce);


  string strQuestGold;
  bool SwitchQuestGold(TMoney money);
  void CmQuestGold_10c();
  void CeQuestGold_10c(TCommandEnabler &ce);
  void CmQuestGold_25c();
  void CeQuestGold_25c(TCommandEnabler &ce);
  void CmQuestGold_1();
  void CeQuestGold_1(TCommandEnabler &ce);
  void CmQuestGold_25();
  void CeQuestGold_25(TCommandEnabler &ce);

  string strHotReels;
  bool SwitchHotReels(TMoney money);
  void CmHotReels_25c();
  void CeHotReels_25c(TCommandEnabler &ce);
  void CmHotReels_1();
  void CeHotReels_1(TCommandEnabler &ce);
  void CmHotReels_5();
  void CeHotReels_5(TCommandEnabler &ce);
  void CmHotReels_10();
  void CeHotReels_10(TCommandEnabler &ce);
  void CmHotReels_100();
  void CeHotReels_100(TCommandEnabler &ce);
  void CmHotReels_1000();
  void CeHotReels_1000(TCommandEnabler &ce);

  string strLightningStrike;
  bool SwitchLightningStrike(TMoney money);
  void CmLightningStrike_25c();
  void CeLightningStrike_25c(TCommandEnabler &ce);
  void CmLightningStrike_1();
  void CeLightningStrike_1(TCommandEnabler &ce);
  void CmLightningStrike_5();
  void CeLightningStrike_5(TCommandEnabler &ce);
  void CmLightningStrike_50();
  void CeLightningStrike_50(TCommandEnabler &ce);
  void CmLightningStrike_100();
  void CeLightningStrike_100(TCommandEnabler &ce);
  void CmLightningStrike_1000();
  void CeLightningStrike_1000(TCommandEnabler &ce);

  string strRoadRally;
  bool SwitchRoadRally(TMoney money);
  void CmRoadRally_25c();
  void CeRoadRally_25c(TCommandEnabler &ce);
  void CmRoadRally_1();
  void CeRoadRally_1(TCommandEnabler &ce);
  void CmRoadRally_5();
  void CeRoadRally_5(TCommandEnabler &ce);
  void CmRoadRally_100();
  void CeRoadRally_100(TCommandEnabler &ce);

  string strSwampMusic;
  bool SwitchSwampMusic(TMoney money);
  void CmSwampMusic_25c();
  void CeSwampMusic_25c(TCommandEnabler &ce);
  void CmSwampMusic_1();
  void CeSwampMusic_1(TCommandEnabler &ce);
  void CmSwampMusic_10();
  void CeSwampMusic_10(TCommandEnabler &ce);

  DECLARE_RESPONSE_TABLE(THSGameFrameWindow);
};
//*******************************************************************
#endif