//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  accvpgld.cpp
//    Project Name:  acc
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  2.5    09/27/99   M.Perry     original baseline.
//********************************************************************
#include "accvpgld.h"
#include "orespond.h"
#include "vplordst.h"
#include "vplordms.h"
#include "ostate.h"
#include <time.h>   //To Set Random Number Generator
#include "vpdeck.h"
#include <stdlib.h> //For Random Number Generator
#include "casvpmw.h"
#include "oskitcat.h"
#include "cvpplay.h"
#include "expert.h"
#include "vpaskex.h"
#include "cplaymgr.h"
#include "ogamefw.h"
#include "casapp.h"
#include "orespond.h"
#include "oanm.h"
#include "cas_cm.rh"

#define  BET1  5
//*******************************************************************
string GetAppString(int16 ids)
{
  return TAppString(ids);
}
//*******************************************************************
TACCVPGLord::TACCVPGLord(TVideoPokerModeWin *pvpmw,const TFileMode &fm,
                         int16 sgt,int16 denomid)
:TCasinoVPGameLord(pvpmw,fm,sgt,denomid)
{
  idsSounds = 0;
  idsVertLite = 0;
  idsDrawBack = 0;
  idsCoinPay = 0;
  idsChips = 0;
  idsCard1 = 0;
  idsCard2 = 0;
  idsCard3 = 0;
  idsCard4 = 0;
  idsCard5 = 0;
  idsNP1 = 0;
  idsNP2 = 0;
  idsNP3 = 0;
  idsCoinsPlayed = 0;
  idsCredits = 0;
  idsWinPaid = 0;
  idsButton0 = 0;
  idsButton1 = 0;
  idsButton2 = 0;
  idsButton3 = 0;
  idsButton4 = 0;
  idsButton5 = 0;
  idsButton6 = 0;
  idsButton7 = 0;
  idsButton8 = 0;
  idsWinRatio = 0;
  idsBankCash = 0;
  idsProgressive = 0;
  strSounds = TAppString::strEmpty;
  strVertLite = TAppString::strEmpty;
  strDrawBack = TAppString::strEmpty;
  strCoinPay = TAppString::strEmpty;
  strChips = TAppString::strEmpty;
  strCard1 = TAppString::strEmpty;
  strCard2 = TAppString::strEmpty;
  strCard3 = TAppString::strEmpty;
  strCard4 = TAppString::strEmpty;
  strCard5 = TAppString::strEmpty;
  strNP1 = TAppString::strEmpty;
  strNP2 = TAppString::strEmpty;
  strNP3 = TAppString::strEmpty;
  strCoinsPlayed = TAppString::strEmpty;
  strCredits = TAppString::strEmpty;
  strWinPaid = TAppString::strEmpty;
  strButton0 = TAppString::strEmpty;
  strButton1 = TAppString::strEmpty;
  strButton2 = TAppString::strEmpty;
  strButton3 = TAppString::strEmpty;
  strButton4 = TAppString::strEmpty;
  strButton5 = TAppString::strEmpty;
  strButton6 = TAppString::strEmpty;
  strButton7 = TAppString::strEmpty;
  strButton8 = TAppString::strEmpty;
  strWinRatio = TAppString::strEmpty;
  strBankCash = TAppString::strEmpty;
  strProgressive = TAppString::strEmpty;

  for (int16 i=0;i<5;i++)
  {
	 CardSprites[i] = NULL;
  }
  VPSounds = NULL;
  Progressive     = NULL;
  Button0 = NULL;
  Button1 = NULL;
  Button2 = NULL;
  Button3 = NULL;
  Button4 = NULL;
  Button5 = NULL;
  Button6 = NULL;
  Button7 = NULL;
  Button8 = NULL;

  CoinsPlayed     = NULL;
  WinRatio        = NULL;
  WinPaid         = NULL;
  Credits         = NULL;
  Chips           = NULL;
  NamePlate1      = NULL;
  NamePlate2      = NULL;
  NamePlate3      = NULL;
  BankCashDisplay = NULL;
  DrawBack        = NULL;
  CoinPay         = NULL;
  VertLite        = NULL;

  shutdownstate    = 0;
  winhand = "";

  r1=0;
  r2=0;
  r3=0;
  activeplayer = 0;
  machinenum = 0;
  playersin=0;
  numofsplits = 0;
  ButtonInfo = 0;

  for(int16 i=0;i<NUMOFBUTTONS;i++)
  {
	 ButtonHit[i] = false;
  }

  PState   = new TVPLordMainState(this);
  pDeck    = new TVPDeck(pvpmw);
  pSmarts  = new TVPSmarts;
  fake     = new TPokerHand;
  ask      = new TVPAsk(this);

  pDeck->InitVPDeck();

  SetupResponders(); // moved from ancestor class to here.
  SetupUniqueIDStrings();

  TFileMode splfm(SpriteListName,
                  TFileMode::fm_None,
                  TFileMode::fm_Immed,
                  FileMode.GetDirIndex());
  CreateAddSpriteList(splfm);

  SetupSprites();
}
//*******************************************************************
TACCVPGLord::~TACCVPGLord()
{
  if(PState != NULL)
  {
	 delete PState;
	 PState = NULL;
  }
  if (pSmarts != NULL)
  {
    delete pSmarts;
    pSmarts = NULL;
  }
  if (pDeck != NULL)
  {
    delete pDeck;
    pDeck = NULL;
  }
  if (ask != NULL)
  {
    delete ask;
    ask = NULL;
  }
  if (fake != NULL)
  {
    delete fake;
    fake = NULL;
  }

  CleanupSprites();
  CleanupResponders();
}
//*******************************************************************
void TACCVPGLord::SetUIDS()
{
  switch (SubGameType)
  {
    case cvpDeucesWild:switch (DenomID)
                       {
                         case TMoney::did_1_00:idsSounds = IDS_MS_SOUNDS_VP_DW1;
                                  idsVertLite = IDS_MS_VERTLITE_VP_DW1;
                                  idsDrawBack = IDS_MS_DRAWBACK_VP_DW1;
                                  idsCoinPay = IDS_MS_COINPAY_VP_DW1;
                                  idsChips = IDS_MS_CHIPS_VP_DW1;
                                  idsCard1 = IDS_MS_CARD1_VP_DW1;
                                  idsCard2 = IDS_MS_CARD2_VP_DW1;
                                  idsCard3 = IDS_MS_CARD3_VP_DW1;
                                  idsCard4 = IDS_MS_CARD4_VP_DW1;
                                  idsCard5 = IDS_MS_CARD5_VP_DW1;
                                  idsNP1 = IDS_MS_NP1_VP_DW1;
                                  idsNP2 = IDS_MS_NP2_VP_DW1;
                                  idsNP3 = IDS_MS_NP3_VP_DW1;
                                  idsCoinsPlayed = IDS_MS_COINSPLAYED_VP_DW1;
                                  idsCredits = IDS_MS_CREDITS_VP_DW1;
                                  idsWinPaid = IDS_MS_WINPAID_VP_DW1;
                                  idsButton0 = IDS_MS_B0_VP_DW1;
                                  idsButton1 = IDS_MS_B1_VP_DW1;
                                  idsButton2 = IDS_MS_B2_VP_DW1;
                                  idsButton3 = IDS_MS_B3_VP_DW1;
                                  idsButton4 = IDS_MS_B4_VP_DW1;
                                  idsButton5 = IDS_MS_B5_VP_DW1;
                                  idsButton6 = IDS_MS_B6_VP_DW1;
                                  idsButton7 = IDS_MS_B7_VP_DW1;
                                  idsButton8 = IDS_MS_B8_VP_DW1;
                                  idsWinRatio = IDS_MS_WINRATIO_VP_DW1;
                                  idsBankCash = IDS_MS_BANKCASH_VP_DW1;
                                  break;
                         case TMoney::did_5_00:idsSounds = IDS_MS_SOUNDS_VP_DW5;
                                  idsVertLite = IDS_MS_VERTLITE_VP_DW5;
                                  idsDrawBack = IDS_MS_DRAWBACK_VP_DW5;
                                  idsCoinPay = IDS_MS_COINPAY_VP_DW5;
                                  idsChips = IDS_MS_CHIPS_VP_DW5;
                                  idsCard1 = IDS_MS_CARD1_VP_DW5;
                                  idsCard2 = IDS_MS_CARD2_VP_DW5;
                                  idsCard3 = IDS_MS_CARD3_VP_DW5;
                                  idsCard4 = IDS_MS_CARD4_VP_DW5;
                                  idsCard5 = IDS_MS_CARD5_VP_DW5;
                                  idsNP1 = IDS_MS_NP1_VP_DW5;
                                  idsNP2 = IDS_MS_NP2_VP_DW5;
                                  idsNP3 = IDS_MS_NP3_VP_DW5;
                                  idsCoinsPlayed = IDS_MS_COINSPLAYED_VP_DW5;
                                  idsCredits = IDS_MS_CREDITS_VP_DW5;
                                  idsWinPaid = IDS_MS_WINPAID_VP_DW5;
                                  idsButton0 = IDS_MS_B0_VP_DW5;
                                  idsButton1 = IDS_MS_B1_VP_DW5;
                                  idsButton2 = IDS_MS_B2_VP_DW5;
                                  idsButton3 = IDS_MS_B3_VP_DW5;
                                  idsButton4 = IDS_MS_B4_VP_DW5;
                                  idsButton5 = IDS_MS_B5_VP_DW5;
                                  idsButton6 = IDS_MS_B6_VP_DW5;
                                  idsButton7 = IDS_MS_B7_VP_DW5;
                                  idsButton8 = IDS_MS_B8_VP_DW5;
                                  idsWinRatio = IDS_MS_WINRATIO_VP_DW5;
                                  idsBankCash = IDS_MS_BANKCASH_VP_DW5;
                                  break;
                         case TMoney::did_25_00:idsSounds = IDS_MS_SOUNDS_VP_DW25;
                                   idsVertLite = IDS_MS_VERTLITE_VP_DW25;
                                   idsDrawBack = IDS_MS_DRAWBACK_VP_DW25;
                                   idsCoinPay = IDS_MS_COINPAY_VP_DW25;
                                   idsChips = IDS_MS_CHIPS_VP_DW25;
                                   idsCard1 = IDS_MS_CARD1_VP_DW25;
                                   idsCard2 = IDS_MS_CARD2_VP_DW25;
                                   idsCard3 = IDS_MS_CARD3_VP_DW25;
                                   idsCard4 = IDS_MS_CARD4_VP_DW25;
                                   idsCard5 = IDS_MS_CARD5_VP_DW25;
                                   idsNP1 = IDS_MS_NP1_VP_DW25;
                                   idsNP2 = IDS_MS_NP2_VP_DW25;
                                   idsNP3 = IDS_MS_NP3_VP_DW25;
                                   idsCoinsPlayed = IDS_MS_COINSPLAYED_VP_DW25;
                                   idsCredits = IDS_MS_CREDITS_VP_DW25;
                                   idsWinPaid = IDS_MS_WINPAID_VP_DW25;
                                   idsButton0 = IDS_MS_B0_VP_DW25;
                                   idsButton1 = IDS_MS_B1_VP_DW25;
                                   idsButton2 = IDS_MS_B2_VP_DW25;
                                   idsButton3 = IDS_MS_B3_VP_DW25;
                                   idsButton4 = IDS_MS_B4_VP_DW25;
                                   idsButton5 = IDS_MS_B5_VP_DW25;
                                   idsButton6 = IDS_MS_B6_VP_DW25;
                                   idsButton7 = IDS_MS_B7_VP_DW25;
                                   idsButton8 = IDS_MS_B8_VP_DW25;
                                   idsWinRatio = IDS_MS_WINRATIO_VP_DW25;
                                   idsBankCash = IDS_MS_BANKCASH_VP_DW25;
                                   break;
                         case TMoney::did_100_00:idsSounds = IDS_MS_SOUNDS_VP_DW100;
                                    idsVertLite = IDS_MS_VERTLITE_VP_DW100;
                                    idsDrawBack = IDS_MS_DRAWBACK_VP_DW100;
                                    idsCoinPay = IDS_MS_COINPAY_VP_DW100;
                                    idsChips = IDS_MS_CHIPS_VP_DW100;
                                    idsCard1 = IDS_MS_CARD1_VP_DW100;
                                    idsCard2 = IDS_MS_CARD2_VP_DW100;
                                    idsCard3 = IDS_MS_CARD3_VP_DW100;
                                    idsCard4 = IDS_MS_CARD4_VP_DW100;
                                    idsCard5 = IDS_MS_CARD5_VP_DW100;
                                    idsNP1 = IDS_MS_NP1_VP_DW100;
                                    idsNP2 = IDS_MS_NP2_VP_DW100;
                                    idsNP3 = IDS_MS_NP3_VP_DW100;
                                    idsCoinsPlayed = IDS_MS_COINSPLAYED_VP_DW100;
                                    idsCredits = IDS_MS_CREDITS_VP_DW100;
                                    idsWinPaid = IDS_MS_WINPAID_VP_DW100;
                                    idsButton0 = IDS_MS_B0_VP_DW100;
                                    idsButton1 = IDS_MS_B1_VP_DW100;
                                    idsButton2 = IDS_MS_B2_VP_DW100;
                                    idsButton3 = IDS_MS_B3_VP_DW100;
                                    idsButton4 = IDS_MS_B4_VP_DW100;
                                    idsButton5 = IDS_MS_B5_VP_DW100;
                                    idsButton6 = IDS_MS_B6_VP_DW100;
                                    idsButton7 = IDS_MS_B7_VP_DW100;
                                    idsButton8 = IDS_MS_B8_VP_DW100;
                                    idsWinRatio = IDS_MS_WINRATIO_VP_DW100;
                                    idsBankCash = IDS_MS_BANKCASH_VP_DW100;
                                    break;
                         default:break;
                       }
                       break;
    case cvpJacksOrBetter:switch (DenomID)
                          {
                            case TMoney::did_1_00:idsSounds = IDS_MS_SOUNDS_VP_JB1;
                                     idsVertLite = IDS_MS_VERTLITE_VP_JB1;
                                     idsDrawBack = IDS_MS_DRAWBACK_VP_JB1;
                                     idsCoinPay = IDS_MS_COINPAY_VP_JB1;
                                     idsChips = IDS_MS_CHIPS_VP_JB1;
                                     idsCard1 = IDS_MS_CARD1_VP_JB1;
                                     idsCard2 = IDS_MS_CARD2_VP_JB1;
                                     idsCard3 = IDS_MS_CARD3_VP_JB1;
                                     idsCard4 = IDS_MS_CARD4_VP_JB1;
                                     idsCard5 = IDS_MS_CARD5_VP_JB1;
                                     idsNP1 = IDS_MS_NP1_VP_JB1;
                                     idsNP2 = IDS_MS_NP2_VP_JB1;
                                     idsNP3 = IDS_MS_NP3_VP_JB1;
                                     idsCoinsPlayed = IDS_MS_COINSPLAYED_VP_JB1;
                                     idsCredits = IDS_MS_CREDITS_VP_JB1;
                                     idsWinPaid = IDS_MS_WINPAID_VP_JB1;
                                     idsButton0 = IDS_MS_B0_VP_JB1;
                                     idsButton1 = IDS_MS_B1_VP_JB1;
                                     idsButton2 = IDS_MS_B2_VP_JB1;
                                     idsButton3 = IDS_MS_B3_VP_JB1;
                                     idsButton4 = IDS_MS_B4_VP_JB1;
                                     idsButton5 = IDS_MS_B5_VP_JB1;
                                     idsButton6 = IDS_MS_B6_VP_JB1;
                                     idsButton7 = IDS_MS_B7_VP_JB1;
                                     idsButton8 = IDS_MS_B8_VP_JB1;
                                     idsWinRatio = IDS_MS_WINRATIO_VP_JB1;
                                     idsBankCash = IDS_MS_BANKCASH_VP_JB1;
                                     break;
                            case TMoney::did_5_00:idsSounds = IDS_MS_SOUNDS_VP_JB5;
                                     idsVertLite = IDS_MS_VERTLITE_VP_JB5;
                                     idsDrawBack = IDS_MS_DRAWBACK_VP_JB5;
                                     idsCoinPay = IDS_MS_COINPAY_VP_JB5;
                                     idsChips = IDS_MS_CHIPS_VP_JB5;
                                     idsCard1 = IDS_MS_CARD1_VP_JB5;
                                     idsCard2 = IDS_MS_CARD2_VP_JB5;
                                     idsCard3 = IDS_MS_CARD3_VP_JB5;
                                     idsCard4 = IDS_MS_CARD4_VP_JB5;
                                     idsCard5 = IDS_MS_CARD5_VP_JB5;
                                     idsNP1 = IDS_MS_NP1_VP_JB5;
                                     idsNP2 = IDS_MS_NP2_VP_JB5;
                                     idsNP3 = IDS_MS_NP3_VP_JB5;
                                     idsCoinsPlayed = IDS_MS_COINSPLAYED_VP_JB5;
                                     idsCredits = IDS_MS_CREDITS_VP_JB5;
                                     idsWinPaid = IDS_MS_WINPAID_VP_JB5;
                                     idsButton0 = IDS_MS_B0_VP_JB5;
                                     idsButton1 = IDS_MS_B1_VP_JB5;
                                     idsButton2 = IDS_MS_B2_VP_JB5;
                                     idsButton3 = IDS_MS_B3_VP_JB5;
                                     idsButton4 = IDS_MS_B4_VP_JB5;
                                     idsButton5 = IDS_MS_B5_VP_JB5;
                                     idsButton6 = IDS_MS_B6_VP_JB5;
                                     idsButton7 = IDS_MS_B7_VP_JB5;
                                     idsButton8 = IDS_MS_B8_VP_JB5;
                                     idsWinRatio = IDS_MS_WINRATIO_VP_JB5;
                                     idsBankCash = IDS_MS_BANKCASH_VP_JB5;
                                     break;
                            case TMoney::did_25_00:idsSounds = IDS_MS_SOUNDS_VP_JB25;
                                      idsVertLite = IDS_MS_VERTLITE_VP_JB25;
                                      idsDrawBack = IDS_MS_DRAWBACK_VP_JB25;
                                      idsCoinPay = IDS_MS_COINPAY_VP_JB25;
                                      idsChips = IDS_MS_CHIPS_VP_JB25;
                                      idsCard1 = IDS_MS_CARD1_VP_JB25;
                                      idsCard2 = IDS_MS_CARD2_VP_JB25;
                                      idsCard3 = IDS_MS_CARD3_VP_JB25;
                                      idsCard4 = IDS_MS_CARD4_VP_JB25;
                                      idsCard5 = IDS_MS_CARD5_VP_JB25;
                                      idsNP1 = IDS_MS_NP1_VP_JB25;
                                      idsNP2 = IDS_MS_NP2_VP_JB25;
                                      idsNP3 = IDS_MS_NP3_VP_JB25;
                                      idsCoinsPlayed = IDS_MS_COINSPLAYED_VP_JB25;
                                      idsCredits = IDS_MS_CREDITS_VP_JB25;
                                      idsWinPaid = IDS_MS_WINPAID_VP_JB25;
                                      idsButton0 = IDS_MS_B0_VP_JB25;
                                      idsButton1 = IDS_MS_B1_VP_JB25;
                                      idsButton2 = IDS_MS_B2_VP_JB25;
                                      idsButton3 = IDS_MS_B3_VP_JB25;
                                      idsButton4 = IDS_MS_B4_VP_JB25;
                                      idsButton5 = IDS_MS_B5_VP_JB25;
                                      idsButton6 = IDS_MS_B6_VP_JB25;
                                      idsButton7 = IDS_MS_B7_VP_JB25;
                                      idsButton8 = IDS_MS_B8_VP_JB25;
                                      idsWinRatio = IDS_MS_WINRATIO_VP_JB25;
                                      idsBankCash = IDS_MS_BANKCASH_VP_JB25;
                                      break;
                            case TMoney::did_100_00:idsSounds = IDS_MS_SOUNDS_VP_JB100;
                                       idsVertLite = IDS_MS_VERTLITE_VP_JB100;
                                       idsDrawBack = IDS_MS_DRAWBACK_VP_JB100;
                                       idsCoinPay = IDS_MS_COINPAY_VP_JB100;
                                       idsChips = IDS_MS_CHIPS_VP_JB100;
                                       idsCard1 = IDS_MS_CARD1_VP_JB100;
                                       idsCard2 = IDS_MS_CARD2_VP_JB100;
                                       idsCard3 = IDS_MS_CARD3_VP_JB100;
                                       idsCard4 = IDS_MS_CARD4_VP_JB100;
                                       idsCard5 = IDS_MS_CARD5_VP_JB100;
                                       idsNP1 = IDS_MS_NP1_VP_JB100;
                                       idsNP2 = IDS_MS_NP2_VP_JB100;
                                       idsNP3 = IDS_MS_NP3_VP_JB100;
                                       idsCoinsPlayed = IDS_MS_COINSPLAYED_VP_JB100;
                                       idsCredits = IDS_MS_CREDITS_VP_JB100;
                                       idsWinPaid = IDS_MS_WINPAID_VP_JB100;
                                       idsButton0 = IDS_MS_B0_VP_JB100;
                                       idsButton1 = IDS_MS_B1_VP_JB100;
                                       idsButton2 = IDS_MS_B2_VP_JB100;
                                       idsButton3 = IDS_MS_B3_VP_JB100;
                                       idsButton4 = IDS_MS_B4_VP_JB100;
                                       idsButton5 = IDS_MS_B5_VP_JB100;
                                       idsButton6 = IDS_MS_B6_VP_JB100;
                                       idsButton7 = IDS_MS_B7_VP_JB100;
                                       idsButton8 = IDS_MS_B8_VP_JB100;
                                       idsWinRatio = IDS_MS_WINRATIO_VP_JB100;
                                       idsBankCash = IDS_MS_BANKCASH_VP_JB100;
                                       break;
                          }
                          break;
    case cvpJacksProgressive:switch (DenomID)
                             {
                               case TMoney::did_1_00:idsSounds = IDS_MS_SOUNDS_VP_JB1P;
                                        idsVertLite = IDS_MS_VERTLITE_VP_JB1P;
                                        idsDrawBack = IDS_MS_DRAWBACK_VP_JB1P;
                                        idsCoinPay = IDS_MS_COINPAY_VP_JB1P;
                                        idsChips = IDS_MS_CHIPS_VP_JB1P;
                                        idsCard1 = IDS_MS_CARD1_VP_JB1P;
                                        idsCard2 = IDS_MS_CARD2_VP_JB1P;
                                        idsCard3 = IDS_MS_CARD3_VP_JB1P;
                                        idsCard4 = IDS_MS_CARD4_VP_JB1P;
                                        idsCard5 = IDS_MS_CARD5_VP_JB1P;
                                        idsNP1 = IDS_MS_NP1_VP_JB1P;
                                        idsNP2 = IDS_MS_NP2_VP_JB1P;
                                        idsNP3 = IDS_MS_NP3_VP_JB1P;
                                        idsCoinsPlayed = IDS_MS_COINSPLAYED_VP_JB1P;
                                        idsCredits = IDS_MS_CREDITS_VP_JB1P;
                                        idsWinPaid = IDS_MS_WINPAID_VP_JB1P;
                                        idsButton0 = IDS_MS_B0_VP_JB1P;
                                        idsButton1 = IDS_MS_B1_VP_JB1P;
                                        idsButton2 = IDS_MS_B2_VP_JB1P;
                                        idsButton3 = IDS_MS_B3_VP_JB1P;
                                        idsButton4 = IDS_MS_B4_VP_JB1P;
                                        idsButton5 = IDS_MS_B5_VP_JB1P;
                                        idsButton6 = IDS_MS_B6_VP_JB1P;
                                        idsButton7 = IDS_MS_B7_VP_JB1P;
                                        idsButton8 = IDS_MS_B8_VP_JB1P;
                                        idsWinRatio = IDS_MS_WINRATIO_VP_JB1P;
                                        idsBankCash = IDS_MS_BANKCASH_VP_JB1P;
                                        idsProgressive = IDS_MS_JP_VP_JB1P;
                                        break;
                               default:break;
                             }
                             break;
    case cvpJokersWild:switch (DenomID)
                       {
                         case TMoney::did_1_00:idsSounds = IDS_MS_SOUNDS_VP_JW1;
                                  idsVertLite = IDS_MS_VERTLITE_VP_JW1;
                                  idsDrawBack = IDS_MS_DRAWBACK_VP_JW1;
                                  idsCoinPay = IDS_MS_COINPAY_VP_JW1;
                                  idsChips = IDS_MS_CHIPS_VP_JW1;
                                  idsCard1 = IDS_MS_CARD1_VP_JW1;
                                  idsCard2 = IDS_MS_CARD2_VP_JW1;
                                  idsCard3 = IDS_MS_CARD3_VP_JW1;
                                  idsCard4 = IDS_MS_CARD4_VP_JW1;
                                  idsCard5 = IDS_MS_CARD5_VP_JW1;
                                  idsNP1 = IDS_MS_NP1_VP_JW1;
                                  idsNP2 = IDS_MS_NP2_VP_JW1;
                                  idsNP3 = IDS_MS_NP3_VP_JW1;
                                  idsCoinsPlayed = IDS_MS_COINSPLAYED_VP_JW1;
                                  idsCredits = IDS_MS_CREDITS_VP_JW1;
                                  idsWinPaid = IDS_MS_WINPAID_VP_JW1;
                                  idsButton0 = IDS_MS_B0_VP_JW1;
                                  idsButton1 = IDS_MS_B1_VP_JW1;
                                  idsButton2 = IDS_MS_B2_VP_JW1;
                                  idsButton3 = IDS_MS_B3_VP_JW1;
                                  idsButton4 = IDS_MS_B4_VP_JW1;
                                  idsButton5 = IDS_MS_B5_VP_JW1;
                                  idsButton6 = IDS_MS_B6_VP_JW1;
                                  idsButton7 = IDS_MS_B7_VP_JW1;
                                  idsButton8 = IDS_MS_B8_VP_JW1;
                                  idsWinRatio = IDS_MS_WINRATIO_VP_JW1;
                                  idsBankCash = IDS_MS_BANKCASH_VP_JW1;
                                  break;
                         case TMoney::did_5_00:idsSounds = IDS_MS_SOUNDS_VP_JW5;
                                  idsVertLite = IDS_MS_VERTLITE_VP_JW5;
                                  idsDrawBack = IDS_MS_DRAWBACK_VP_JW5;
                                  idsCoinPay = IDS_MS_COINPAY_VP_JW5;
                                  idsChips = IDS_MS_CHIPS_VP_JW5;
                                  idsCard1 = IDS_MS_CARD1_VP_JW5;
                                  idsCard2 = IDS_MS_CARD2_VP_JW5;
                                  idsCard3 = IDS_MS_CARD3_VP_JW5;
                                  idsCard4 = IDS_MS_CARD4_VP_JW5;
                                  idsCard5 = IDS_MS_CARD5_VP_JW5;
                                  idsNP1 = IDS_MS_NP1_VP_JW5;
                                  idsNP2 = IDS_MS_NP2_VP_JW5;
                                  idsNP3 = IDS_MS_NP3_VP_JW5;
                                  idsCoinsPlayed = IDS_MS_COINSPLAYED_VP_JW5;
                                  idsCredits = IDS_MS_CREDITS_VP_JW5;
                                  idsWinPaid = IDS_MS_WINPAID_VP_JW5;
                                  idsButton0 = IDS_MS_B0_VP_JW5;
                                  idsButton1 = IDS_MS_B1_VP_JW5;
                                  idsButton2 = IDS_MS_B2_VP_JW5;
                                  idsButton3 = IDS_MS_B3_VP_JW5;
                                  idsButton4 = IDS_MS_B4_VP_JW5;
                                  idsButton5 = IDS_MS_B5_VP_JW5;
                                  idsButton6 = IDS_MS_B6_VP_JW5;
                                  idsButton7 = IDS_MS_B7_VP_JW5;
                                  idsButton8 = IDS_MS_B8_VP_JW5;
                                  idsWinRatio = IDS_MS_WINRATIO_VP_JW5;
                                  idsBankCash = IDS_MS_BANKCASH_VP_JW5;
                                  break;
                         case TMoney::did_25_00:idsSounds = IDS_MS_SOUNDS_VP_JW25;
                                   idsVertLite = IDS_MS_VERTLITE_VP_JW25;
                                   idsDrawBack = IDS_MS_DRAWBACK_VP_JW25;
                                   idsCoinPay = IDS_MS_COINPAY_VP_JW25;
                                   idsChips = IDS_MS_CHIPS_VP_JW25;
                                   idsCard1 = IDS_MS_CARD1_VP_JW25;
                                   idsCard2 = IDS_MS_CARD2_VP_JW25;
                                   idsCard3 = IDS_MS_CARD3_VP_JW25;
                                   idsCard4 = IDS_MS_CARD4_VP_JW25;
                                   idsCard5 = IDS_MS_CARD5_VP_JW25;
                                   idsNP1 = IDS_MS_NP1_VP_JW25;
                                   idsNP2 = IDS_MS_NP2_VP_JW25;
                                   idsNP3 = IDS_MS_NP3_VP_JW25;
                                   idsCoinsPlayed = IDS_MS_COINSPLAYED_VP_JW25;
                                   idsCredits = IDS_MS_CREDITS_VP_JW25;
                                   idsWinPaid = IDS_MS_WINPAID_VP_JW25;
                                   idsButton0 = IDS_MS_B0_VP_JW25;
                                   idsButton1 = IDS_MS_B1_VP_JW25;
                                   idsButton2 = IDS_MS_B2_VP_JW25;
                                   idsButton3 = IDS_MS_B3_VP_JW25;
                                   idsButton4 = IDS_MS_B4_VP_JW25;
                                   idsButton5 = IDS_MS_B5_VP_JW25;
                                   idsButton6 = IDS_MS_B6_VP_JW25;
                                   idsButton7 = IDS_MS_B7_VP_JW25;
                                   idsButton8 = IDS_MS_B8_VP_JW25;
                                   idsWinRatio = IDS_MS_WINRATIO_VP_JW25;
                                   idsBankCash = IDS_MS_BANKCASH_VP_JW25;
                                   break;
                         case TMoney::did_100_00:idsSounds = IDS_MS_SOUNDS_VP_JW100;
                                    idsVertLite = IDS_MS_VERTLITE_VP_JW100;
                                    idsDrawBack = IDS_MS_DRAWBACK_VP_JW100;
                                    idsCoinPay = IDS_MS_COINPAY_VP_JW100;
                                    idsChips = IDS_MS_CHIPS_VP_JW100;
                                    idsCard1 = IDS_MS_CARD1_VP_JW100;
                                    idsCard2 = IDS_MS_CARD2_VP_JW100;
                                    idsCard3 = IDS_MS_CARD3_VP_JW100;
                                    idsCard4 = IDS_MS_CARD4_VP_JW100;
                                    idsCard5 = IDS_MS_CARD5_VP_JW100;
                                    idsNP1 = IDS_MS_NP1_VP_JW100;
                                    idsNP2 = IDS_MS_NP2_VP_JW100;
                                    idsNP3 = IDS_MS_NP3_VP_JW100;
                                    idsCoinsPlayed = IDS_MS_COINSPLAYED_VP_JW100;
                                    idsCredits = IDS_MS_CREDITS_VP_JW100;
                                    idsWinPaid = IDS_MS_WINPAID_VP_JW100;
                                    idsButton0 = IDS_MS_B0_VP_JW100;
                                    idsButton1 = IDS_MS_B1_VP_JW100;
                                    idsButton2 = IDS_MS_B2_VP_JW100;
                                    idsButton3 = IDS_MS_B3_VP_JW100;
                                    idsButton4 = IDS_MS_B4_VP_JW100;
                                    idsButton5 = IDS_MS_B5_VP_JW100;
                                    idsButton6 = IDS_MS_B6_VP_JW100;
                                    idsButton7 = IDS_MS_B7_VP_JW100;
                                    idsButton8 = IDS_MS_B8_VP_JW100;
                                    idsWinRatio = IDS_MS_WINRATIO_VP_JW100;
                                    idsBankCash = IDS_MS_BANKCASH_VP_JW100;
                                    break;
                         default:break;
                       }
                       break;
    case cvpTensOrBetter:switch (DenomID)
                         {
                           case TMoney::did_1_00:idsSounds = IDS_MS_SOUNDS_VP_TB1;
                                    idsVertLite = IDS_MS_VERTLITE_VP_TB1;
                                    idsDrawBack = IDS_MS_DRAWBACK_VP_TB1;
                                    idsCoinPay = IDS_MS_COINPAY_VP_TB1;
                                    idsChips = IDS_MS_CHIPS_VP_TB1;
                                    idsCard1 = IDS_MS_CARD1_VP_TB1;
                                    idsCard2 = IDS_MS_CARD2_VP_TB1;
                                    idsCard3 = IDS_MS_CARD3_VP_TB1;
                                    idsCard4 = IDS_MS_CARD4_VP_TB1;
                                    idsCard5 = IDS_MS_CARD5_VP_TB1;
                                    idsNP1 = IDS_MS_NP1_VP_TB1;
                                    idsNP2 = IDS_MS_NP2_VP_TB1;
                                    idsNP3 = IDS_MS_NP3_VP_TB1;
                                    idsCoinsPlayed = IDS_MS_COINSPLAYED_VP_TB1;
                                    idsCredits = IDS_MS_CREDITS_VP_TB1;
                                    idsWinPaid = IDS_MS_WINPAID_VP_TB1;
                                    idsButton0 = IDS_MS_B0_VP_TB1;
                                    idsButton1 = IDS_MS_B1_VP_TB1;
                                    idsButton2 = IDS_MS_B2_VP_TB1;
                                    idsButton3 = IDS_MS_B3_VP_TB1;
                                    idsButton4 = IDS_MS_B4_VP_TB1;
                                    idsButton5 = IDS_MS_B5_VP_TB1;
                                    idsButton6 = IDS_MS_B6_VP_TB1;
                                    idsButton7 = IDS_MS_B7_VP_TB1;
                                    idsButton8 = IDS_MS_B8_VP_TB1;
                                    idsWinRatio = IDS_MS_WINRATIO_VP_TB1;
                                    idsBankCash = IDS_MS_BANKCASH_VP_TB1;
                                    break;
                           case TMoney::did_5_00:idsSounds = IDS_MS_SOUNDS_VP_TB5;
                                    idsVertLite = IDS_MS_VERTLITE_VP_TB5;
                                    idsDrawBack = IDS_MS_DRAWBACK_VP_TB5;
                                    idsCoinPay = IDS_MS_COINPAY_VP_TB5;
                                    idsChips = IDS_MS_CHIPS_VP_TB5;
                                    idsCard1 = IDS_MS_CARD1_VP_TB5;
                                    idsCard2 = IDS_MS_CARD2_VP_TB5;
                                    idsCard3 = IDS_MS_CARD3_VP_TB5;
                                    idsCard4 = IDS_MS_CARD4_VP_TB5;
                                    idsCard5 = IDS_MS_CARD5_VP_TB5;
                                    idsNP1 = IDS_MS_NP1_VP_TB5;
                                    idsNP2 = IDS_MS_NP2_VP_TB5;
                                    idsNP3 = IDS_MS_NP3_VP_TB5;
                                    idsCoinsPlayed = IDS_MS_COINSPLAYED_VP_TB5;
                                    idsCredits = IDS_MS_CREDITS_VP_TB5;
                                    idsWinPaid = IDS_MS_WINPAID_VP_TB5;
                                    idsButton0 = IDS_MS_B0_VP_TB5;
                                    idsButton1 = IDS_MS_B1_VP_TB5;
                                    idsButton2 = IDS_MS_B2_VP_TB5;
                                    idsButton3 = IDS_MS_B3_VP_TB5;
                                    idsButton4 = IDS_MS_B4_VP_TB5;
                                    idsButton5 = IDS_MS_B5_VP_TB5;
                                    idsButton6 = IDS_MS_B6_VP_TB5;
                                    idsButton7 = IDS_MS_B7_VP_TB5;
                                    idsButton8 = IDS_MS_B8_VP_TB5;
                                    idsWinRatio = IDS_MS_WINRATIO_VP_TB5;
                                    idsBankCash = IDS_MS_BANKCASH_VP_TB5;
                                    break;
                           case TMoney::did_25_00:idsSounds = IDS_MS_SOUNDS_VP_TB25;
                                     idsVertLite = IDS_MS_VERTLITE_VP_TB25;
                                     idsDrawBack = IDS_MS_DRAWBACK_VP_TB25;
                                     idsCoinPay = IDS_MS_COINPAY_VP_TB25;
                                     idsChips = IDS_MS_CHIPS_VP_TB25;
                                     idsCard1 = IDS_MS_CARD1_VP_TB25;
                                     idsCard2 = IDS_MS_CARD2_VP_TB25;
                                     idsCard3 = IDS_MS_CARD3_VP_TB25;
                                     idsCard4 = IDS_MS_CARD4_VP_TB25;
                                     idsCard5 = IDS_MS_CARD5_VP_TB25;
                                     idsNP1 = IDS_MS_NP1_VP_TB25;
                                     idsNP2 = IDS_MS_NP2_VP_TB25;
                                     idsNP3 = IDS_MS_NP3_VP_TB25;
                                     idsCoinsPlayed = IDS_MS_COINSPLAYED_VP_TB25;
                                     idsCredits = IDS_MS_CREDITS_VP_TB25;
                                     idsWinPaid = IDS_MS_WINPAID_VP_TB25;
                                     idsButton0 = IDS_MS_B0_VP_TB25;
                                     idsButton1 = IDS_MS_B1_VP_TB25;
                                     idsButton2 = IDS_MS_B2_VP_TB25;
                                     idsButton3 = IDS_MS_B3_VP_TB25;
                                     idsButton4 = IDS_MS_B4_VP_TB25;
                                     idsButton5 = IDS_MS_B5_VP_TB25;
                                     idsButton6 = IDS_MS_B6_VP_TB25;
                                     idsButton7 = IDS_MS_B7_VP_TB25;
                                     idsButton8 = IDS_MS_B8_VP_TB25;
                                     idsWinRatio = IDS_MS_WINRATIO_VP_TB25;
                                     idsBankCash = IDS_MS_BANKCASH_VP_TB25;
                                     break;
                           case TMoney::did_100_00:idsSounds = IDS_MS_SOUNDS_VP_TB100;
                                      idsVertLite = IDS_MS_VERTLITE_VP_TB100;
                                      idsDrawBack = IDS_MS_DRAWBACK_VP_TB100;
                                      idsCoinPay = IDS_MS_COINPAY_VP_TB100;
                                      idsChips = IDS_MS_CHIPS_VP_TB100;
                                      idsCard1 = IDS_MS_CARD1_VP_TB100;
                                      idsCard2 = IDS_MS_CARD2_VP_TB100;
                                      idsCard3 = IDS_MS_CARD3_VP_TB100;
                                      idsCard4 = IDS_MS_CARD4_VP_TB100;
                                      idsCard5 = IDS_MS_CARD5_VP_TB100;
                                      idsNP1 = IDS_MS_NP1_VP_TB100;
                                      idsNP2 = IDS_MS_NP2_VP_TB100;
                                      idsNP3 = IDS_MS_NP3_VP_TB100;
                                      idsCoinsPlayed = IDS_MS_COINSPLAYED_VP_TB100;
                                      idsCredits = IDS_MS_CREDITS_VP_TB100;
                                      idsWinPaid = IDS_MS_WINPAID_VP_TB100;
                                      idsButton0 = IDS_MS_B0_VP_TB100;
                                      idsButton1 = IDS_MS_B1_VP_TB100;
                                      idsButton2 = IDS_MS_B2_VP_TB100;
                                      idsButton3 = IDS_MS_B3_VP_TB100;
                                      idsButton4 = IDS_MS_B4_VP_TB100;
                                      idsButton5 = IDS_MS_B5_VP_TB100;
                                      idsButton6 = IDS_MS_B6_VP_TB100;
                                      idsButton7 = IDS_MS_B7_VP_TB100;
                                      idsButton8 = IDS_MS_B8_VP_TB100;
                                      idsWinRatio = IDS_MS_WINRATIO_VP_TB100;
                                      idsBankCash = IDS_MS_BANKCASH_VP_TB100;
                                      break;
                           default:break;
                         }
                         break;
    default:break;
  }
}
//*******************************************************************
#if defined(SUPPORT_OLD_VER)
int16 TACCVPGLord::GetUniqueID(const string &s)
{
  if (s == strSounds) {return 26;}
  if (s == strVertLite) {return 27;}
  if (s == strDrawBack) {return 11;}
  if (s == strCoinPay) {return 18;}
  if (s == strChips) {return 17;}
  if (s == strCard1) {return 12;}
  if (s == strCard2) {return 13;}
  if (s == strCard3) {return 14;}
  if (s == strCard4) {return 15;}
  if (s == strCard5) {return 16;}
  if (s == strNP1) {return 22;}
  if (s == strNP2) {return 23;}
  if (s == strNP3) {return 24;}
  if (s == strCoinsPlayed) {return 19;}
  if (s == strCredits) {return 30;}
  if (s == strWinPaid) {return 28;}
  if (s == strButton0) {return 1;}
  if (s == strButton1) {return 2;}
  if (s == strButton2) {return 3;}
  if (s == strButton3) {return 4;}
  if (s == strButton4) {return 5;}
  if (s == strButton5) {return 7;}
  if (s == strButton6) {return 8;}
  if (s == strButton7) {return 9;}
  if (s == strButton8) {return 10;}
  if (s == strWinRatio) {return 29;}
  if (s == strBankCash) {return 6;}
  if (s == strProgressive) {return 31;}
  return SPRITEID_UNK;
}
#endif
//*******************************************************************
TSprite *TACCVPGLord::CreateSprite(string spritename,int16 id,void *psource)
{
  TFileMode FM(spritename,
               TFileMode::fm_None,
               TFileMode::fm_None,
               FileMode.GetDirIndex());
  if (psource != NULL)
  {
    switch (id)
	 {
		case  0 : return new TSprite(PModeWin,FM,psource);
      case  1 : Button0 = new TCasButton(PModeWin,FM,psource,this,100,
                                         TRect(1,430,50,479),idButton0,true,'x');
                return Button0;
		case  2 : Button1 = new TCasButton(PModeWin,FM,psource,this,100,
                                         TRect(170,430,219,479),idButton1,true);
                return Button1;
		case  3 : Button2 = new TCasButton(PModeWin,FM,psource,this,100,
                                         TRect(223,464,258,479),idButton2,true);
                return Button2;
		case  4 : Button3 = new TCasButton(PModeWin,FM,psource,this,100,
                                         TRect(376,464,412,479),idButton3,true);
                return Button3;
		case  5 : Button4 = new TCasButton(PModeWin,FM,psource,this,125,
                                         TRect(416,430,468,479),idButton4,true,'c');
                return Button4;
		case  6 : BankCashDisplay = new TCasCashDisplay(PModeWin,FM,psource);
                return BankCashDisplay;
      case  7 : Button5 = new TCasButton(PModeWin,FM,psource,this,125,
                                         TRect(470,430,522,479),idButton5,true,'b');
                return Button5;
		case  8 : Button6 = new TCasButton(PModeWin,FM,psource,this,125,
                                         TRect(533,430,585,479),idButton6,true,'m');
                return Button6;
		case  9 : Button7 = new TCasButton(PModeWin,FM,psource,this,125,
                                         TRect(587,432,639,478),idButton7,true,'d');
                return Button7;
		case 10 : Button8 = new TCasButton(PModeWin,FM,psource,this,100,
                                         TRect(587,432,639,478),idButton8,true,'w');
                return Button8;
		case 11 : DrawBack = new TVPDrawBack(PModeWin,FM,psource);
                return DrawBack;
		case 12 : CardSprites[0] = new TVPCard(PModeWin,FM,psource);
                return CardSprites[0];
		case 13 : CardSprites[1] = new TVPCard(PModeWin,FM,psource);
                return CardSprites[1];
		case 14 : CardSprites[2] = new TVPCard(PModeWin,FM,psource);
                return CardSprites[2];
		case 15 : CardSprites[3] = new TVPCard(PModeWin,FM,psource);
                return CardSprites[3];
		case 16 : CardSprites[4] = new TVPCard(PModeWin,FM,psource);
                return CardSprites[4];
		case 17 : Chips = new TCasChips(PModeWin,FM,psource);
                return Chips;
		case 18 : CoinPay = new TVPCoinPay(PModeWin,FM,psource);
                return CoinPay;
		case 19 : CoinsPlayed = new TVPCoinsPlayed(PModeWin,FM,psource);
                return CoinsPlayed;
		case 22 : NamePlate1 = new TCasNamePlate(PModeWin,FM,psource);
                return NamePlate1;
		case 23 : NamePlate2 = new TCasNamePlate(PModeWin,FM,psource);
                return NamePlate2;
		case 24 : NamePlate3 = new TCasNamePlate(PModeWin,FM,psource);
                return NamePlate3;
		case 26 : VPSounds = new TVPSound(PModeWin,FM,psource);
                return VPSounds;
		case 27 : VertLite = new TVPVertLite(PModeWin,FM,psource);
                return VertLite;
		case 28 : WinPaid = new TVPWinPaid(PModeWin,FM,psource);
                return WinPaid;
		case 29 : WinRatio = new TVPWinRatio(PModeWin,FM,psource);
                return WinRatio;
		case 30 : Credits = new TVPCredits(PModeWin,FM,psource);
                return Credits;
		case 31 : Progressive = new TVPProgressive(PModeWin,FM,psource);
                return Progressive;
      default : return new TSprite(PModeWin,FM,psource);
	 }
  }
  else
  {
	 FM.SetRamImmed();
	 switch (id)
	 {
		case  0 : return new TSprite(PModeWin,FM);
		case  1 : Button0 = new TCasButton(PModeWin,FM,this,100,
                                         TRect(1,430,50,479),idButton0,true,'x');
                return Button0;
		case  2 : Button1 = new TCasButton(PModeWin,FM,this,100,
                                         TRect(170,430,219,479),idButton1,true);
                return Button1;
		case  3 : Button2 = new TCasButton(PModeWin,FM,this,100,
                                         TRect(223,464,258,479),idButton2,true);
                return Button2;
		case  4 : Button3 = new TCasButton(PModeWin,FM,this,100,
                                         TRect(376,464,412,479),idButton3,true);
                return Button3;
		case  5 : Button4 = new TCasButton(PModeWin,FM,this,125,
                                         TRect(416,430,468,479),idButton4,true,'c');
                return Button4;
		case  6 : BankCashDisplay = new TCasCashDisplay(PModeWin,FM);
                return BankCashDisplay;
      case  7 : Button5 = new TCasButton(PModeWin,FM,this,125,
                                         TRect(470,430,522,479),idButton5,true,'b');
                return Button5;
		case  8 : Button6 = new TCasButton(PModeWin,FM,this,125,
                                         TRect(533,430,585,479),idButton6,true,'m');
                return Button6;
  		case  9 : Button7 = new TCasButton(PModeWin,FM,this,125,
                                         TRect(587,432,639,478),idButton7,true,'d');
                return Button7;
		case 10 : Button8 = new TCasButton(PModeWin,FM,this,100,
                                         TRect(587,432,639,478),idButton8,true,'w');
                return Button8;
		case 11 : DrawBack = new TVPDrawBack(PModeWin,FM);
                return DrawBack;
		case 12 : CardSprites[0] = new TVPCard(PModeWin,FM);
                return CardSprites[0];
		case 13 : CardSprites[1] = new TVPCard(PModeWin,FM);
                return CardSprites[1];
		case 14 : CardSprites[2] = new TVPCard(PModeWin,FM);
                return CardSprites[2];
		case 15 : CardSprites[3] = new TVPCard(PModeWin,FM);
                return CardSprites[3];
		case 16 : CardSprites[4] = new TVPCard(PModeWin,FM);
                return CardSprites[4];
		case 17 : Chips = new TCasChips(PModeWin,FM);
                return Chips;
		case 18 : CoinPay = new TVPCoinPay(PModeWin,FM);
                return CoinPay;
		case 19 : CoinsPlayed = new TVPCoinsPlayed(PModeWin,FM);
                return CoinsPlayed;
		case 22 : NamePlate1 = new TCasNamePlate(PModeWin,FM);
                return NamePlate1;
		case 23 : NamePlate2 = new TCasNamePlate(PModeWin,FM);
                return NamePlate2;
		case 24 : NamePlate3 = new TCasNamePlate(PModeWin,FM);
                return NamePlate3;
		case 26 : VPSounds = new TVPSound(PModeWin,FM);
                return VPSounds;
		case 27 : VertLite = new TVPVertLite(PModeWin,FM);
                return VertLite;
		case 28 : WinPaid = new TVPWinPaid(PModeWin,FM);
                return WinPaid;
		case 29 : WinRatio = new TVPWinRatio(PModeWin,FM);
                return WinRatio;
		case 30 : Credits = new TVPCredits(PModeWin,FM);
                return Credits;
		case 31 : Progressive = new TVPProgressive(PModeWin,FM);
                return Progressive;
      default : return new TSprite(PModeWin,FM);
	 }
  }
}
//*******************************************************************
void TACCVPGLord::SetupResponders()
{
  Responders[0] = new TResponder(PModeWin,100,TRect(543,404,617,424),idAddCoins,this,true,'~',TCursorData(GetOgleApp(),ID_POINTING_FINGER_CURSOR));
  Responders[1] = new TResponder(PModeWin,100,TRect(25,263,116,402),idHoldCard0,this,true,'1',TCursorData(GetOgleApp(),ID_POINTING_FINGER_CURSOR));
  Responders[2] = new TResponder(PModeWin,100,TRect(122,263,211,402),idHoldCard1,this,true,'2',TCursorData(GetOgleApp(),ID_POINTING_FINGER_CURSOR));
  Responders[3] = new TResponder(PModeWin,100,TRect(217,263,307,402),idHoldCard2,this,true,'3',TCursorData(GetOgleApp(),ID_POINTING_FINGER_CURSOR));
  Responders[4] = new TResponder(PModeWin,100,TRect(312,263,401,402),idHoldCard3,this,true,'4',TCursorData(GetOgleApp(),ID_POINTING_FINGER_CURSOR));
  Responders[5] = new TResponder(PModeWin,100,TRect(407,263,497,402),idHoldCard4,this,true,'5',TCursorData(GetOgleApp(),ID_POINTING_FINGER_CURSOR));
  Responders[6]  = new TResponder(PModeWin,100,TRect(394,431,424,463),idOneChip,this,true,'~',TCursorData(GetOgleApp(),ID_POINTING_FINGER_CURSOR));
  Responders[7]  = new TResponder(PModeWin,100,TRect(358,431,390,463),idFiveChip,this,true,'~',TCursorData(GetOgleApp(),ID_POINTING_FINGER_CURSOR));
  Responders[8]  = new TResponder(PModeWin,100,TRect(323,431,354,463),idTwentyFiveChip,this,true,'~',TCursorData(GetOgleApp(),ID_POINTING_FINGER_CURSOR));
  Responders[9]  = new TResponder(PModeWin,100,TRect(288,431,320,463),idOneHundredChip,this,true,'~',TCursorData(GetOgleApp(),ID_POINTING_FINGER_CURSOR));
  Responders[10]  = new TResponder(PModeWin,100,TRect(253,431,285,463),idOneThouChip,this,true,'~',TCursorData(GetOgleApp(),ID_POINTING_FINGER_CURSOR));
  Responders[11]  = new TResponder(PModeWin,100,TRect(219,431,250,463),idTenThouChip,this,true,'~',TCursorData(GetOgleApp(),ID_POINTING_FINGER_CURSOR));
  Responders[12]  = new TResponder(PModeWin,200,TRect(5,5,635,475)    ,idSpeedClick        ,this,true,VK_SPACE,TCursorData(0,0));
  Responders[13]  = new TResponder(PModeWin,100,TRect(260,465,375,477)   ,idNamePlate,this,true,VK_TAB,TCursorData(GetOgleApp(),ID_POINTING_FINGER_CURSOR));
}
//*******************************************************************
void TACCVPGLord::AskHoldCards(bool show)
{
  ask->HoldCards(show);
}
//*******************************************************************
void TACCVPGLord::AskMoneyExpert()
{
  string expertstring;

  if(coinsize*(maxbet - coinsplayed) > GetCash(activeplayer))
  {
	 expertstring = GetAppString(5123);
	 expertstring += GetAppString(5124);
	 expertstring += GetAppString(5125);
  }
  else
  {
	 expertstring = GetAppString(5126);
	 expertstring += GetAppString(5127);
	 expertstring += GetAppString(5128);
  }
  GetFW()->DisplayExpert(expertstring);
}
//*******************************************************************
void TACCVPGLord::AskGenExpert()
{
  string  expertstring = GetAppString(5110);
  expertstring += GetAppString(5111);
  expertstring += GetAppString(5112);
  expertstring += GetAppString(5113);
  expertstring += GetAppString(5114);
  expertstring += GetAppString(5115);
  expertstring += GetAppString(5116);
  expertstring += GetAppString(5117);
  expertstring += GetAppString(5118);
  expertstring += GetAppString(5119);
  expertstring += GetAppString(5120);
  expertstring += GetAppString(5121);
  expertstring += GetAppString(5122);
  GetFW()->DisplayExpert(expertstring);
}
//*******************************************************************
TMoney TACCVPGLord::PayOutJacks()
{
  int16 session = GetCasPD(activeplayer)->VPData.CurrentSession;
  TCVPSession &cs = GetCasPD(activeplayer)->VPData.Sessions[session];

  switch (GetCasPlayer(activeplayer)->pHand->highhand)
  {
	 case 10:   if (GetCasPlayer(activeplayer)->pHand->highcard > Ten)
					{
					  fake->highcard = GetCasPlayer(activeplayer)->pHand->highcard;
					  winnerpaid += coinsplayed;
					  cs.TotalHighPairCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.HighPairs++;
					  switch(GetCasPlayer(activeplayer)->pHand->highcard)
                 {
						 case Ten   : winhand = "Pair of Tens";break;
						 case Jack  : winhand = "Pair of Jacks";break;
						 case Queen : winhand = "Pair of Queens";break;
						 case King  : winhand = "Pair of Kings";break;
						 case AceHi : winhand = "Pair of Aces";break;
					  }
					  VertLite->SetRow(0);
					}
					break;
	 case 15 :  winnerpaid += coinsplayed*2;
               winhand = "Two Pair";
					cs.TotalTwoPairCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.TwoPairs++;
					VertLite->SetRow(1);
               break;
	 case 20 :  winnerpaid += coinsplayed*3;
               winhand = "Three of a Kind";
					cs.TotalThreeOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.ThreeOfKinds++;
					VertLite->SetRow(2);
               break;
	 case 23 :  winnerpaid += coinsplayed*4;
               winhand = "Straight";
					cs.TotalStraightCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Straights++;
					VertLite->SetRow(3);
               break;
	 case 26 :  winnerpaid += coinsplayed*6;
               winhand = "Flush";
					cs.TotalFlushCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Flushes++;
					VertLite->SetRow(4);
               break;
	 case 70 :  winnerpaid += coinsplayed*9;
               winhand = "Full House";
					cs.TotalFullHouseCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FullHouses++;
					VertLite->SetRow(5);
               break;
	 case 71 :  winnerpaid += coinsplayed*25;
               winhand = "Four of a Kind";
					cs.TotalFourOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FourOfKinds++;
					VertLite->SetRow(6);
               break;
	 case 99 :  if (GetCasPlayer(activeplayer)->pHand->highcard == AceHi)
					{
					  if(coinsplayed == 5)
					  {
						 winnerpaid += 4000;
                   winhand = "Royal Flush";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  else
					  {
						 winnerpaid += coinsplayed*250;
                   winhand = "Royal Flush";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  VertLite->SetRow(8);
                 break;
					}
					else
					{
					  winnerpaid += coinsplayed*50;winhand = "Straight Flush";
					  cs.TotalStraightFlushCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.StraightFlushes++;
					  VertLite->SetRow(7);
                 break;
					}
	 default : return 1;
  }
  switch(((int32)(winnerpaid/coinsplayed)))
  {
	 case 1  : VPSounds->PlaySound(17);break;
	 case 2  : VPSounds->PlaySound(18);break;
	 case 3  : VPSounds->PlaySound(19);break;
	 case 4  : VPSounds->PlaySound(20);break;
	 case 5  : VPSounds->PlaySound(21);break;
	 case 6  : VPSounds->PlaySound(22);break;
	 case 7  : VPSounds->PlaySound(23);break;
	 case 8  : VPSounds->PlaySound(24);break;
	 case 9  : VPSounds->PlaySound(25);break;
	 default : if(winnerpaid/coinsplayed > 9 && winnerpaid/coinsplayed < 26)
				  {
                VPSounds->PlaySound(26);
                break;
              }
				  else if(winnerpaid/coinsplayed > 25 && winnerpaid/coinsplayed < 4000)
				  {
                VPSounds->PlaySound(27);
                break;
              }
				  else if(winnerpaid >= 4000)
				  {
                VPSounds->PlaySound(28);
                break;
              }
  }
  return 1;
}
//*******************************************************************
TMoney TACCVPGLord::PayOutWild2()
{
  int16 session = GetCasPD(activeplayer)->VPData.CurrentSession;
  TCVPSession &cs = GetCasPD(activeplayer)->VPData.Sessions[session];

  switch (GetCasPlayer(activeplayer)->pHand->highhand) {
	 case 20 :  winnerpaid += coinsplayed*1;
               winhand = "Three of a Kind";
					cs.TotalThreeOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.ThreeOfKinds++;
					VertLite->SetRow(0);
               break;
	 case 23 :  winnerpaid += coinsplayed*2;
               winhand = "Straight";
					cs.TotalStraightCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Straights++;
					VertLite->SetRow(1);
               break;
	 case 26 :  winnerpaid += coinsplayed*2;
               winhand = "Flush";
					cs.TotalFlushCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Flushes++;
					VertLite->SetRow(2);
               break;
	 case 70 :  winnerpaid += coinsplayed*3;
               winhand = "Full House";
					cs.TotalFullHouseCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FullHouses++;
					VertLite->SetRow(3);
               break;
	 case 71 :  winnerpaid += coinsplayed*5;
               winhand = "Four of a Kind";
					cs.TotalFourOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FourOfKinds++;
					VertLite->SetRow(4);
               break;
	 case 99 :  if (GetCasPlayer(activeplayer)->pHand->highcard == AceHi)
					{
					  VertLite->SetRow(9);
					  if(coinsplayed == 5)
					  {
						 winnerpaid += 4000;
                   winhand = "Royal Flush(Nat)";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
                   break;
					  }
					  else
					  {
						 winnerpaid += coinsplayed*250;
                   winhand = "Royal Flush(Nat)";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
                   break;
					  }
					}
					else
					{
					  VertLite->SetRow(5);
					  winnerpaid += coinsplayed*9;
                 winhand = "Straight Flush";
					  cs.TotalStraightFlushCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.StraightFlushes++;
                 break;
					}
	 case 100 :   winnerpaid += coinsplayed*15;
                 winhand = "Five of a Kind";
					  cs.TotalFiveOfKindCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.FiveOfKinds++;
					  VertLite->SetRow(6);
                 break;
	 case 105 :   winnerpaid += coinsplayed*25;
                 winhand = "Royal Flush(Wild)";
					  cs.TotalWildRoyalCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.WildRoyals++;
					  VertLite->SetRow(7);
                 break;
	 case 110 :   winnerpaid += coinsplayed*200;
                 winhand = "Four Deuces";
					  cs.TotalFourDeuceCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.FourDeuces++;
					  VertLite->SetRow(8);
                 break;
	 default : return 1;
  }
  switch(((int32)(winnerpaid/coinsplayed)))
  {
	 case 1  : VPSounds->PlaySound(17);break;
	 case 2  : VPSounds->PlaySound(18);break;
	 case 3  : VPSounds->PlaySound(19);break;
	 case 4  : VPSounds->PlaySound(20);break;
	 case 5  : VPSounds->PlaySound(21);break;
	 case 6  : VPSounds->PlaySound(22);break;
	 case 7  : VPSounds->PlaySound(23);break;
	 case 8  : VPSounds->PlaySound(24);break;
	 case 9  : VPSounds->PlaySound(25);break;
	 default : if(winnerpaid/coinsplayed > 9 && winnerpaid/coinsplayed < 26)
				  {
                VPSounds->PlaySound(26);
                break;
              }
				  else if(winnerpaid/coinsplayed > 25 && winnerpaid/coinsplayed < 4000)
				  {
                VPSounds->PlaySound(27);
                break;
              }
				  else if(winnerpaid >= 4000)
				  {
                VPSounds->PlaySound(28);
                break;
              }
  }
  return 1;
}
//*******************************************************************
TMoney TACCVPGLord::PayOutWildJoker()
{
  int16 session = GetCasPD(activeplayer)->VPData.CurrentSession;
  TCVPSession &cs = GetCasPD(activeplayer)->VPData.Sessions[session];

  switch (GetCasPlayer(activeplayer)->pHand->highhand) {
	 case 15 :  winnerpaid += coinsplayed;
               winhand = "Two Pair";
					cs.TotalTwoPairCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.TwoPairs++;
					VertLite->SetRow(0);
               break;
	 case 20 :  winnerpaid += coinsplayed*2;
               winhand = "Three of a Kind";
					cs.TotalThreeOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.ThreeOfKinds++;
					VertLite->SetRow(1);
               break;
	 case 23 :  winnerpaid += coinsplayed*5;
               winhand = "Straight";
					cs.TotalStraightCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Straights++;
					VertLite->SetRow(2);
               break;
	 case 26 :  winnerpaid += coinsplayed*7;
               winhand = "Flush";
					cs.TotalFlushCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Flushes++;
					VertLite->SetRow(3);
               break;
	 case 70 :  winnerpaid += coinsplayed*8;
               winhand = "Full House";
					cs.TotalFullHouseCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FullHouses++;
					VertLite->SetRow(4);
               break;
	 case 71 :  winnerpaid += coinsplayed*20;
               winhand = "Four of a Kind";
					cs.TotalFourOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FourOfKinds++;
					VertLite->SetRow(5);
               break;
	 case 99 :  if (GetCasPlayer(activeplayer)->pHand->highcard == AceHi)
					{
					  if(coinsplayed == 5)
					  {
						 winnerpaid += 4000;
                   winhand = "Royal Flush(Nat)";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  else
					  {
						 winnerpaid += coinsplayed*250;
                   winhand = "Royal Flush(Nat)";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  VertLite->SetRow(9);
                 break;
					}
					else
					{
					  winnerpaid += coinsplayed*50;
                 winhand = "Straight Flush";
					  cs.TotalStraightFlushCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.StraightFlushes++;
					  VertLite->SetRow(6);
                 break;
					}
	 case 100 :   winnerpaid += coinsplayed*100;
                 winhand = "Five of a Kind";
					  cs.TotalFiveOfKindCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.FiveOfKinds++;
					  VertLite->SetRow(8);
                 break;
	 case 105 :   winnerpaid += coinsplayed*50;
                 winhand = "Royal Flush(Wild)";
					  cs.TotalWildRoyalCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.WildRoyals++;
					  VertLite->SetRow(7);
                 break;
	 default : return 1;
  }
  switch(((int32)(winnerpaid/coinsplayed)))
  {
	 case 1  : VPSounds->PlaySound(17);break;
	 case 2  : VPSounds->PlaySound(18);break;
	 case 3  : VPSounds->PlaySound(19);break;
	 case 4  : VPSounds->PlaySound(20);break;
	 case 5  : VPSounds->PlaySound(21);break;
	 case 6  : VPSounds->PlaySound(22);break;
	 case 7  : VPSounds->PlaySound(23);break;
	 case 8  : VPSounds->PlaySound(24);break;
	 case 9  : VPSounds->PlaySound(25);break;
	 default : if(winnerpaid/coinsplayed > 9 && winnerpaid/coinsplayed < 26)
				  {
                VPSounds->PlaySound(26);
                break;
              }
				  else if(winnerpaid/coinsplayed > 25 && winnerpaid/coinsplayed < 4000)
				  {
                VPSounds->PlaySound(27);
                break;
              }
				  else if(winnerpaid >= 4000)
				  {
                VPSounds->PlaySound(28);
                break;
              }
  }
  return 1;
}
//*******************************************************************
TMoney TACCVPGLord::PayOutProgressive()
{
  int16 session = GetCasPD(activeplayer)->VPData.CurrentSession;
  TCVPSession &cs = GetCasPD(activeplayer)->VPData.Sessions[session];

  switch (GetCasPlayer(activeplayer)->pHand->highhand) {
	 case 10 :  if (GetCasPlayer(activeplayer)->pHand->highcard > Ten)
					{
					  switch(GetCasPlayer(activeplayer)->pHand->highcard){
						 case Ten   : winhand = "Pair of Tens";break;
						 case Jack  : winhand = "Pair of Jacks";break;
						 case Queen : winhand = "Pair of Queens";break;
						 case King  : winhand = "Pair of Kings";break;
						 case AceHi : winhand = "Pair of Aces";break;
					  }
					  winnerpaid += coinsplayed;
					  cs.TotalHighPairCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.HighPairs++;
					  VertLite->SetRow(0);
					}
					break;
	 case 15 :  winnerpaid += coinsplayed*2 ;
               winhand = "Two Pair";
					cs.TotalTwoPairCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.TwoPairs++;
               VertLite->SetRow(1);
               break;
	 case 20 :  winnerpaid += coinsplayed*3;
               winhand = "Three of a Kind";
					cs.TotalThreeOfKindCash += winnerpaid*coinsize;
               cs.Wins++;
					cs.ThreeOfKinds++;
					VertLite->SetRow(2);
               break;
	 case 23 :  winnerpaid += coinsplayed*4 ;
               winhand = "Straight";
					cs.TotalStraightCash += winnerpaid*coinsize;
               cs.Wins++;
					cs.Straights++;
					VertLite->SetRow(3);
               break;
	 case 26 :  winnerpaid += coinsplayed*5;
               winhand = "Flush";
					cs.TotalFlushCash += winnerpaid*coinsize;
               cs.Wins++;
					cs.Flushes++;
					VertLite->SetRow(4);
               break;
	 case 70 :  winnerpaid += coinsplayed*8;
               winhand = "Full House";
					cs.TotalFullHouseCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FullHouses++;
					VertLite->SetRow(5);
               break;
	 case 71 :  winnerpaid += coinsplayed*25;
               winhand = "Four of a Kind";
					cs.TotalFourOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FourOfKinds++;
					VertLite->SetRow(6);
               break;
	 case 99 :  if (GetCasPlayer(activeplayer)->pHand->highcard == AceHi)
					{
					  if(coinsplayed == 5)
					  {
						 winnerpaid += progressive;
                   progressive = 4000;
                   winhand = "Royal Flush";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
					    cs.Wins++;
					    cs.NaturalRoyals++;
					  }
					  else
					  {
						 winnerpaid += coinsplayed*250;
                   winhand = "Royal Flush";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  VertLite->SetRow(8);
                 break;
					}
					else
					{
					  winnerpaid += coinsplayed*50;
                 winhand = "Straight Flush";
					  cs.TotalStraightFlushCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.StraightFlushes++;
					  VertLite->SetRow(7);
                 break;
					}
	 default : return 1;
  }
  switch(((int32)(winnerpaid/coinsplayed)))
  {
	 case 1  : VPSounds->PlaySound(17);break;
	 case 2  : VPSounds->PlaySound(18);break;
	 case 3  : VPSounds->PlaySound(19);break;
	 case 4  : VPSounds->PlaySound(20);break;
	 case 5  : VPSounds->PlaySound(21);break;
	 case 6  : VPSounds->PlaySound(22);break;
	 case 7  : VPSounds->PlaySound(23);break;
	 case 8  : VPSounds->PlaySound(24);break;
	 case 9  : VPSounds->PlaySound(25);break;
	 default : if(winnerpaid/coinsplayed > 9 && winnerpaid/coinsplayed < 26)
				  {
                VPSounds->PlaySound(26);
                break;
              }
				  else if(winnerpaid/coinsplayed > 25 && winnerpaid/coinsplayed < 4000)
				  {
                VPSounds->PlaySound(27);
                break;
              }
				  else if(winnerpaid >= 4000)
				  {
                VPSounds->PlaySound(28);
                break;
              }
  }
  return 1;
}
//*******************************************************************
TMoney TACCVPGLord::PayOutTens()
{
  int16 session = GetCasPD(activeplayer)->VPData.CurrentSession;
  TCVPSession &cs = GetCasPD(activeplayer)->VPData.Sessions[session];

  switch (GetCasPlayer(activeplayer)->pHand->highhand) {
	 case 10 :  if (GetCasPlayer(activeplayer)->pHand->highcard > Nine)
					{
					  switch(GetCasPlayer(activeplayer)->pHand->highcard){
						 case Ten   : winhand = "Pair of Tens";break;
						 case Jack  : winhand = "Pair of Jacks";break;
						 case Queen : winhand = "Pair of Queens";break;
						 case King  : winhand = "Pair of Kings";break;
						 case AceHi : winhand = "Pair of Aces";break;
					  }
					  cs.Wins++;
					  cs.HighPairs++;
					  winnerpaid += coinsplayed;
					  cs.TotalHighPairCash += winnerpaid*coinsize;
					  VertLite->SetRow(0);
					}
					break;
	 case 15 :  winnerpaid += coinsplayed*2;
               winhand = "Two Pair";
					cs.TotalTwoPairCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.TwoPairs++;
					VertLite->SetRow(1);
               break;
	 case 20 :  winnerpaid += coinsplayed*3;
               winhand = "Three of a Kind";
					cs.TotalThreeOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.ThreeOfKinds++;
					VertLite->SetRow(2);
               break;
	 case 23 :  winnerpaid += coinsplayed*4;
               winhand = "Straight";
					cs.TotalStraightCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Straights++;
					VertLite->SetRow(3);
               break;
	 case 26 :  winnerpaid += coinsplayed*5;
               winhand = "Flush";
					cs.TotalFlushCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Flushes++;
					VertLite->SetRow(4);
               break;
	 case 70 :  winnerpaid += coinsplayed*6;
               winhand = "Full House";
					cs.TotalFullHouseCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FullHouses++;
					VertLite->SetRow(5);
               break;
	 case 71 :  winnerpaid += coinsplayed*25;
               winhand = "Four of a Kind";
					cs.TotalFourOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FourOfKinds++;
					VertLite->SetRow(6);
               break;
	 case 99 :  if (GetCasPlayer(activeplayer)->pHand->highcard == AceHi)
					{
					  if(coinsplayed == 5)
					  {
						 winnerpaid += 4000;
                   winhand = "Rotal Flush";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  else
					  {
						 winnerpaid += coinsplayed*250;
                   winhand = "Royal Flush";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  VertLite->SetRow(8);
                 break;
					}
					else
					{
					  winnerpaid += coinsplayed*50;
                 winhand = "Straight Flush";
					  cs.TotalStraightFlushCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.StraightFlushes++;
					  VertLite->SetRow(7);
                 break;
					}
	 default : return 1;
  }
  switch(((int32)(winnerpaid/coinsplayed)))
  {
	 case 1  : VPSounds->PlaySound(17);break;
	 case 2  : VPSounds->PlaySound(18);break;
	 case 3  : VPSounds->PlaySound(19);break;
	 case 4  : VPSounds->PlaySound(20);break;
	 case 5  : VPSounds->PlaySound(21);break;
	 case 6  : VPSounds->PlaySound(22);break;
	 case 7  : VPSounds->PlaySound(23);break;
	 case 8  : VPSounds->PlaySound(24);break;
	 case 9  : VPSounds->PlaySound(25);break;
	 default : if(winnerpaid/coinsplayed > 9 && winnerpaid/coinsplayed < 26)
				  {
                VPSounds->PlaySound(26);
                break;
              }
				  else if(winnerpaid/coinsplayed > 25 && winnerpaid/coinsplayed < 4000)
				  {
                VPSounds->PlaySound(27);
                break;
              }
				  else if(winnerpaid >= 4000)
				  {
                VPSounds->PlaySound(28);
                break;
              }
  }
  return 1;
}
//*******************************************************************
int16 TACCVPGLord::Clear()
{
  UnFreezeAllButtons();
  if(DrawBack != NULL)
  {
    DrawBack->ClearBack();
  }
  shutdownstate    = 0;
  ChangeActivePlayersOk = true;
  if(credits > 0)
  {
	 Button4->ShowVoidUp();
  }
  else
  {
	 Button4->ShowGray();
  }
  if(activeplayer > -1 && (GetCash(activeplayer) >= coinsize || credits > 0))
  {
	 Button5->ShowVoidUp();
	 Button6->ShowVoidUp();
  }
  DisEnableButton(idButton8);
  if(activeplayer > -1){BankCashDisplay->SetNum(GetCash(activeplayer));}
  GetCasPlayer(activeplayer)->pHand->highhand      = 0;
  GetCasPlayer(activeplayer)->pHand->highcard      = 0;
  GetCasPlayer(activeplayer)->pHand->toflush       = 0;
  GetCasPlayer(activeplayer)->pHand->instrght      = 0;
  GetCasPlayer(activeplayer)->pHand->outstrght     = 0;
  GetCasPlayer(activeplayer)->pHand->instrflsh     = 0;
  GetCasPlayer(activeplayer)->pHand->outstrflsh    = 0;
  GetCasPlayer(activeplayer)->pHand->lohighcard    = 0;
  GetCasPlayer(activeplayer)->pHand->lolowcard     = 0;
  GetCasPlayer(activeplayer)->pHand->lohand        = 0;
  GetCasPlayer(activeplayer)->pHand->inhand        = 0;
  GetCasPlayer(activeplayer)->pHand->lowcard       = 0;
  GetCasPlayer(activeplayer)->pHand->wildcount     = 0;
  fake->highhand      = 0;
  fake->inhand        = 0;
  fake->highcard      = 0;
  fake->toflush       = 0;
  fake->instrght      = 0;
  fake->outstrght     = 0;
  fake->lohighcard    = 0;
  fake->lolowcard     = 0;
  fake->lohand        = 0;
  fake->lowcard       = 0;
  fake->instrflsh     = 0;
  fake->outstrflsh    = 0;
  fake->wildcount     = 0;
  for(int16 i=0;i<5;i++)
  {
	 GetCasPlayer(activeplayer)->pHand->hold[i]    = 0;
  }
  if(pDeck != NULL)
  {
	 pDeck->top = 0;
  }
  return 1;
}
//*******************************************************************
int16 TACCVPGLord::GetNumOfWildCards()
{
  if (SubGameType == cvpDeucesWild)
  {
	 for(int16 i=0;i<5;i++)
	 {
		if (GetCasPlayer(activeplayer)->pHand->cards[i].name == Two)
		{
		  GetCasPlayer(activeplayer)->pHand->wildcount++;
		}
	 }
  }
  else
  {
	 for(int16 i=0;i<5;i++)
	 {
		if (GetCasPlayer(activeplayer)->pHand->cards[i].name == Joker)
		{
		  GetCasPlayer(activeplayer)->pHand->wildcount++;
		}
	 }
  }
  return 1;
}
//*******************************************************************
int16 TACCVPGLord::Wild2(bool copy)
{
  if(copy)
  {
	 fake->inhand = 0;
	 for(int16 i=0;i<5;i++)
	 {
		fake->cards[i].name = GetCasPlayer(activeplayer)->pHand->cards[i].name;
		fake->cards[i].suit = GetCasPlayer(activeplayer)->pHand->cards[i].suit;
		fake->inhand++;
	 }
  }
  pSmarts->Insert_Sort(fake);

  if(GetCasPlayer(activeplayer)->pHand->wildcount && fake->inhand && fake->cards[0].name == Two)
  {
	 if(GetCasPlayer(activeplayer)->pHand->wildcount > 3)
	 {
		GetCasPlayer(activeplayer)->pHand->highhand = 110; // Four Deuces
		return 1;
	 }
	 if(GetCasPlayer(activeplayer)->pHand->wildcount > 2)
	 {
		if(fake->cards[3].suit == fake->cards[4].suit)
		{
		  if(fake->cards[3].name > Nine && fake->cards[4].name > Nine)
		  {
			 GetCasPlayer(activeplayer)->pHand->highhand = 105; // Royal with wild
			 return 1;
		  }
		  else
		  {
			 if(fake->cards[4].name - fake->cards[3].name < 5)
			 {
				GetCasPlayer(activeplayer)->pHand->highhand = 99; // Straight flush
				return 1;
			 }
			 else if(fake->cards[4].name == AceHi && fake->cards[3].name < Six)
			 {
				GetCasPlayer(activeplayer)->pHand->highhand = 99; // Straight flush
				return 1;
			 }
		  }
		}
		else
		{
		  if(fake->cards[4].name == fake->cards[3].name)
		  {
			 GetCasPlayer(activeplayer)->pHand->highhand = 100; // Five of kind
			 return 1;
		  }
		}
		GetCasPlayer(activeplayer)->pHand->highhand = 71; // Four of a kind
		return 1;
	 }
	 if(GetCasPlayer(activeplayer)->pHand->wildcount > 1)
	 {
		if(fake->cards[4].suit == fake->cards[3].suit &&
			fake->cards[2].suit == fake->cards[3].suit)
		{
		  if(fake->cards[4].name - fake->cards[2].name < 5)
		  {
			 if(fake->cards[2].name > Nine)
			 {
				GetCasPlayer(activeplayer)->pHand->highhand = 105;  // Royal wilds
				GetCasPlayer(activeplayer)->pHand->highcard = AceHi;
				return 1;
			 }
			 else
			 {
				GetCasPlayer(activeplayer)->pHand->highhand = 99; //Straight flush
				return 1;
			 }
		  }
		  else
		  {
			 if(fake->cards[4].name == AceHi && fake->cards[3].name < Six)
			 {
				GetCasPlayer(activeplayer)->pHand->highhand = 99; //Straight flush
				return 1;
			 }
			 else
			 {
				GetCasPlayer(activeplayer)->pHand->highhand = 26; // flush
				return 1;
			 }
		  }
		}
		if(fake->cards[4].name - fake->cards[2].name < 5)
		{
		  GetCasPlayer(activeplayer)->pHand->highhand = 23; // Straight
		}
		else
		{
		  if(fake->cards[4].name == AceHi && fake->cards[3].name < Six)
		  {
			 GetCasPlayer(activeplayer)->pHand->highhand = 23; // Straight
		  }
		}
		if(fake->cards[4].name == fake->cards[2].name)
		{
		  GetCasPlayer(activeplayer)->pHand->highhand = 100; // 5 o'kind
		  return 1;
		}
		if(fake->cards[3].name == fake->cards[2].name ||
			fake->cards[3].name == fake->cards[4].name)
		{
		  GetCasPlayer(activeplayer)->pHand->highhand = 71; // 4 o'kind
		  return 1;
		}
		if(GetCasPlayer(activeplayer)->pHand->highhand < 20)
		{
		  GetCasPlayer(activeplayer)->pHand->highhand = 20; // 3 o'kind
		}
		return 1;
	 }
	 for(int16 i=Two;i<=AceHi;i++)
	 {
		fake->cards[0].name = (TCardName)i;
		for(int16 j=0;j<4;j++)
		{
		  fake->cards[0].suit = (TSuit)j;
		  fake->highhand      = 0;
		  fake->highcard      = 0;
		  fake->toflush       = 0;
		  fake->instrght      = 0;
		  fake->outstrght     = 0;
		  fake->lohighcard    = 0;
		  fake->lolowcard     = 0;
		  fake->lohand        = 0;
		  fake->lowcard       = 0;
		  fake->instrght      = 0;
		  fake->outstrght     = 0;
		  fake->instrflsh     = 0;
		  fake->outstrflsh    = 0;
		  pSmarts->Holding(fake);
		  if(fake->highhand > GetCasPlayer(activeplayer)->pHand->highhand)
		  {
			 if(fake->highhand == 99 && fake->highcard == AceHi)
			 {
				GetCasPlayer(activeplayer)->pHand->highhand = 105;
				GetCasPlayer(activeplayer)->pHand->highcard = AceHi;
			 }
			 else
			 {
				GetCasPlayer(activeplayer)->pHand->highhand = fake->highhand;
				GetCasPlayer(activeplayer)->pHand->highcard = fake->highcard;
			 }
		  }
		  else
		  {
			 if(fake->highhand == 99 && fake->highcard == AceHi)
			 {
				GetCasPlayer(activeplayer)->pHand->highhand = 105;
				GetCasPlayer(activeplayer)->pHand->highcard = AceHi;
			 }
		  }
		  if(fake->instrflsh > GetCasPlayer(activeplayer)->pHand->instrflsh)
		  {
			 GetCasPlayer(activeplayer)->pHand->instrflsh = fake->instrflsh;
		  }
		  if(fake->outstrflsh > GetCasPlayer(activeplayer)->pHand->outstrflsh)
		  {
			 GetCasPlayer(activeplayer)->pHand->outstrflsh = fake->outstrflsh;
		  }
		  if(fake->instrght > GetCasPlayer(activeplayer)->pHand->instrght)
		  {
			 GetCasPlayer(activeplayer)->pHand->instrght = fake->instrght;
		  }
		  if(fake->outstrght > GetCasPlayer(activeplayer)->pHand->outstrght)
		  {
			 GetCasPlayer(activeplayer)->pHand->outstrght = fake->outstrght;
		  }
		  if(fake->toflush > GetCasPlayer(activeplayer)->pHand->toflush)
		  {
			 GetCasPlayer(activeplayer)->pHand->toflush = fake->toflush;
		  }
		}
	 }
	 return 1;
  }//if(wildcount)
  pSmarts->Holding(GetCasPlayer(activeplayer)->pHand);
  pSmarts->Holding(fake);
  return 1;
}
//*******************************************************************
int16 TACCVPGLord::WildJoker(bool copy)
{
  if(copy)
  {
	 fake->inhand = 0;
	 for(int16 i=0;i<5;i++)
	 {
		fake->cards[i].name = GetCasPlayer(activeplayer)->pHand->cards[i].name;
		fake->cards[i].suit = GetCasPlayer(activeplayer)->pHand->cards[i].suit;
		fake->inhand++;
	 }
  }
  pSmarts->Insert_Sort(fake);
  if(GetCasPlayer(activeplayer)->pHand->wildcount && fake->inhand && fake->cards[fake->inhand-1].name == Joker)
  {
	 for(int16 i=Two;i<=AceHi;i++)
	 {
		fake->cards[fake->inhand-1].name = (TCardName)i;
		for(int16 j=0;j<4;j++)
		{
		  fake->cards[fake->inhand-1].suit = (TSuit)j;
		  fake->highhand      = 0;
		  fake->highcard      = 0;
		  fake->toflush       = 0;
		  fake->instrght      = 0;
		  fake->outstrght     = 0;
		  fake->lohighcard    = 0;
		  fake->lolowcard     = 0;
		  fake->lohand        = 0;
		  fake->lowcard       = 0;
		  pSmarts->Holding(fake);
		  if(fake->highhand > GetCasPlayer(activeplayer)->pHand->highhand)
		  {
			 if(fake->highhand == 99 && fake->highcard == AceHi)
			 {
				GetCasPlayer(activeplayer)->pHand->highhand = 105;
				GetCasPlayer(activeplayer)->pHand->highcard = AceHi;
			 }
			 else
			 {
				GetCasPlayer(activeplayer)->pHand->highhand = fake->highhand;
				GetCasPlayer(activeplayer)->pHand->highcard = fake->highcard;
			 }
		  }
		  else
		  {
			 if(fake->highhand == 99 && fake->highcard == AceHi)
			 {
				GetCasPlayer(activeplayer)->pHand->highhand = 105;
				GetCasPlayer(activeplayer)->pHand->highcard = AceHi;
			 }
		  }
        if(fake->instrflsh > GetCasPlayer(activeplayer)->pHand->instrflsh)
		  {
			 GetCasPlayer(activeplayer)->pHand->instrflsh = fake->instrflsh;
		  }
		  if(fake->outstrflsh > GetCasPlayer(activeplayer)->pHand->outstrflsh)
		  {
			 GetCasPlayer(activeplayer)->pHand->outstrflsh = fake->outstrflsh;
		  }
		  if(fake->instrght > GetCasPlayer(activeplayer)->pHand->instrght)
		  {
			 GetCasPlayer(activeplayer)->pHand->instrght = fake->instrght;
		  }
		  if(fake->outstrght > GetCasPlayer(activeplayer)->pHand->outstrght)
		  {
			 GetCasPlayer(activeplayer)->pHand->outstrght = fake->outstrght;
		  }
		  if(fake->toflush > GetCasPlayer(activeplayer)->pHand->toflush)
		  {
			 GetCasPlayer(activeplayer)->pHand->toflush = fake->toflush;
		  }
		}
	 }
	 return 1;
  }//if(wildcount)
  pSmarts->Holding(GetCasPlayer(activeplayer)->pHand);
  pSmarts->Holding(fake);
  return 1;
}
//*******************************************************************
TMoney TACCVPGLord::Winner()
{
  winnerpaid = 0;
  if (SubGameType == cvpDeucesWild || SubGameType == cvpJokersWild)
  {
	 GetNumOfWildCards();
  }
  switch (SubGameType)
  {
	 case cvpTensOrBetter:     pSmarts->Holding(GetCasPlayer(activeplayer)->pHand);break;
	 case cvpJacksOrBetter:    pSmarts->Holding(GetCasPlayer(activeplayer)->pHand);break;
	 case cvpJacksProgressive: pSmarts->Holding(GetCasPlayer(activeplayer)->pHand);break;
	 case cvpDeucesWild:       Wild2(true);break;
	 case cvpJokersWild:       WildJoker(true);break;
	 default:                  return 0;
  }
  if(GetCasPlayer(activeplayer)->pHand->highhand >= 10)
  {
	 switch (SubGameType)
	 {
		case cvpTensOrBetter:     PayOutTens();break;
		case cvpJacksOrBetter:    PayOutJacks();break;
		case cvpJacksProgressive: PayOutProgressive();break;
		case cvpDeucesWild:       PayOutWild2();break;
		case cvpJokersWild:       PayOutWildJoker();break;
		default: break;
	 }
	 if(winhand != "")
	 {
		winhand = "";
	 }
  }
  TCasinoVPData &cd = GetCasPD(activeplayer)->VPData;
  int16 session = cd.CurrentSession;
  TCVPSession &cs = cd.Sessions[session];

  cs.TotalCashWon -= coinsplayed*coinsize;
  if(winnerpaid == 0)
  {
	 cd.Cumulative -= coinsplayed*coinsize;
	 cs.CurrentLosingStreak++;
	 cs.CurrentWinStreak = 0;
	 cs.Losses++;
	 cs.GarbageHands++;
	 if(cs.CurrentLosingStreak > cs.LosingStreak)
	 {
		cs.LosingStreak = cs.CurrentLosingStreak;
	 }
	 if((cs.StartingCash + cs.TotalCashWon) < cs.PeakLoss)
	 {
		cs.PeakLoss = cs.StartingCash + cs.TotalCashWon;
	 }
  }
  else
  {
	 cd.Cumulative += winnerpaid*coinsize;
	 cs.TotalCashWon += winnerpaid*coinsize;
	 cs.CurrentWinStreak++;
	 cs.CurrentLosingStreak = 0;
	 if(cs.CurrentWinStreak > cs.WinStreak)
	 {
		cs.WinStreak = cs.CurrentWinStreak;
	 }
	 if(winnerpaid*coinsize > cs.LargestWin)
	 {
		cs.LargestWin = winnerpaid*coinsize;
	 }
	 if((cs.StartingCash + cs.TotalCashWon) > cs.PeakWin)
	 {
		cs.PeakWin = cs.StartingCash + cs.TotalCashWon;
	 }
  }
  BankCashDisplay->SetNum(GetCash(activeplayer));
  return winnerpaid;
}// winner
//*******************************************************************
int16 TACCVPGLord::AddCoins()
{
  if(GetCash(activeplayer) == 0 && credits == 0)
  {
	 if(coinsplayed > 0)
	 {
		  PModeWin->MessageBox("You're out of money and may not make additional bets. Your current bets are your only hope.","Out of Cash",MB_OK);
	 }
    #if defined(KENO_COMPILE)
	 else if(GetCasPD(activeplayer)->IsActiveKenoTicket())
	 {
		PModeWin->MessageBox("You're out of money and may not bet. Your only hope is that one of your Keno tickets pays off.","Out of Cash",MB_OK);
	 }
    #endif
	 else
	 {
		PModeWin->MessageBox("You've hit rock bottom. Your gambler is bankrupt. Select GAMBLER MANAGEMENT under the FILE menu to create or select a new gambler.","Bankrupt!",MB_OK);
	 }
	 return 1;
  }
  if(coinsplayed < maxbet)
  {
	 SubCash(activeplayer,coinsize);
	 coinsplayed++;
  }
  else
  {
	 if(coinsplayed == maxbet)   // Not a needed check, oh well...
	 {
		SubCash(activeplayer,coinsize);
		credits++;
	 }
  }
  BankCashDisplay->SetNum(GetCash(activeplayer));
  return 1;
}
//*******************************************************************
int16 TACCVPGLord::CashOut()
{
  return 1;
}
//*******************************************************************
int16 TACCVPGLord::Bet1()
{
  if((GetCash(activeplayer) == 0 || GetCash(activeplayer) < coinsize) && credits == 0)
  {
	 if(GetCash(activeplayer) < coinsize && GetCash(activeplayer) > 0)
	 {
		PModeWin->MessageBox("You don't have enough money to bet more.","Not Enough",MB_OK);
	 }
	 else if(coinsplayed > 0)
	 {
		  PModeWin->MessageBox("You're out of money and may not make additional bets. Your current bets are your only hope.","Out of Cash",MB_OK);
	 }
    #if defined(KENO_COMPILE)
	 else if(GetCasPD(activeplayer)->IsActiveKenoTicket())
	 {
		PModeWin->MessageBox("You're out of money and may not bet. Your only hope is that one of your Keno tickets pays off.","Out of Cash",MB_OK);
	 }
    #endif
	 else
	 {
		PModeWin->MessageBox("You've hit rock bottom. Your gambler is bankrupt. Select Create/Delete under the FILE menu to create or select a new gambler.","Bankrupt!",MB_OK);
	 }
	 return 1;
  }
  int16 session = GetCasPD(activeplayer)->VPData.CurrentSession;
  TCVPSession &cs = GetCasPD(activeplayer)->VPData.Sessions[session];

	if(credits > 0)
	{
	  VPSounds->PlaySound(6);
	  credits--;
	  coinsplayed++;
	  CoinsPlayed->SetNum(coinsplayed);
	  VertLite->ClearRows();
	  WinRatio->SetColumn(coinsplayed - 1);
	  Credits->SetNum(credits);
	  Button7->ShowVoidUp();
	  cs.TotalBetsCash += coinsize;

	  if(credits == 0)
	  {
		 Button4->ShowGray();
	  }
	  WinPaid->SetNum(0);
	  BankCashDisplay->SetNum(GetCash(activeplayer));
	  return 1;
	}
	if (GetCash(activeplayer) >= coinsize)
	{
	  SubCash(activeplayer,coinsize);
	  VPSounds->PlaySound(0);
	  coinsplayed++;
	  cs.TotalBetsCash += coinsize;
	  CoinsPlayed->SetNum(coinsplayed);
	  VertLite->ClearRows();
	  WinRatio->SetColumn(coinsplayed - 1);
	  Credits->SetNum(credits);
	  Button7->ShowVoidUp();
	  Chips->SetNum(GetCash(activeplayer));
	  WinPaid->SetNum(0);
	}
	BankCashDisplay->SetNum(GetCash(activeplayer));
	return 1;
}
//*******************************************************************
bool TACCVPGLord::BetX(TMoney x)
{
  if(GetCash(activeplayer) == 0 && credits == 0)
  {
	 if(coinsplayed > 0)
	 {
		  PModeWin->MessageBox("You're out of money and may not make additional bets. Your current bets are your only hope.","Out of Cash",MB_OK);
	 }
    #if defined(KENO_COMPILE)
	 else if(GetCasPD(activeplayer)->IsActiveKenoTicket())
	 {
		PModeWin->MessageBox("You're out of money and may not bet. Your only hope is that one of your Keno tickets pays off.","Out of Cash",MB_OK);
	 }
    #endif
	 else
	 {
		PModeWin->MessageBox("You've hit rock bottom. Your gambler is bankrupt. Select Create/Delete under the FILE menu to create or select a new gambler.","Bankrupt!",MB_OK);
	 }
	 return true;
  }
  int32 bm=0;
	bm = ((int32)(x/coinsize));
	int16 session = GetCasPD(activeplayer)->VPData.CurrentSession;
   TCVPSession &cs = GetCasPD(activeplayer)->VPData.Sessions[session];

	if (GetCash(activeplayer) >= x && bm > 0)
	{
	  SubCash(activeplayer,(coinsize * bm));
	  cs.TotalBetsCash += (coinsize * bm);

	  Chips->SetNum(GetCash(activeplayer));
	  if(coinsplayed == 5)
	  {
		 credits += bm;
		 Credits->SetNum(credits);
		 Button4->ShowVoidUp();
	  }
	  else if(coinsplayed+bm < 6)
	  {
		 coinsplayed += bm;
		 CoinsPlayed->SetNum(coinsplayed);
		 WinRatio->SetColumn(coinsplayed - 1);
		 switch((int32)bm)
		 {
			case 1  : VPSounds->PlaySound(0);break;
			case 2  : VPSounds->PlaySound(1);break;
			case 3  : VPSounds->PlaySound(2);break;
			case 4  : VPSounds->PlaySound(3);break;
			case 5  : VPSounds->PlaySound(4);break;
			default : if(bm > 5) {VPSounds->PlaySound(5);}
		 }
	  }
	  else if(coinsplayed+bm > 5)
	  {
		 bm -= BET1 - (int32)coinsplayed;
		 switch(BET1 - (int32)coinsplayed)
		 {
			case 1  : VPSounds->PlaySound(0);break;
			case 2  : VPSounds->PlaySound(1);break;
			case 3  : VPSounds->PlaySound(2);break;
			case 4  : VPSounds->PlaySound(3);break;
			case 5  : VPSounds->PlaySound(4);break;
			default : if(bm > 5) {VPSounds->PlaySound(5);}
		 }
		 credits += bm;
		 Credits->SetNum(credits);
		 coinsplayed = BET1;
		 CoinsPlayed->SetNum(coinsplayed);
		 WinRatio->SetColumn(coinsplayed - 1);
		 Button4->ShowVoidUp();
	  }
	  VertLite->ClearRows();
	  WinPaid->SetNum(0);
	  Button7->ShowVoidUp();
	  BankCashDisplay->SetNum(GetCash(activeplayer));
	  if(credits != 0){Button4->ShowVoidUp();}
	  return true;
	}
	return false;
}
//*******************************************************************
int16 TACCVPGLord::BetMax()
{
  if((GetCash(activeplayer) == 0 || GetCash(activeplayer) < coinsize) && credits == 0)
  {
	 if(GetCash(activeplayer) < coinsize && GetCash(activeplayer) > 0)
	 {
		PModeWin->MessageBox("You don't have enough money to bet more.","Not Enough",MB_OK);
	 }
	 else if(coinsplayed > 0)
	 {
		  PModeWin->MessageBox("You're out of money and may not make additional bets. Your current bets are your only hope.","Out of Cash",MB_OK);
	 }
    #if defined(KENO_COMPILE)
	 else if(GetCasPD(activeplayer)->IsActiveKenoTicket())
	 {
		PModeWin->MessageBox("You're out of money and may not bet. Your only hope is that one of your Keno tickets pays off.","Out of Cash",MB_OK);
	 }
    #endif
	 else
	 {
		PModeWin->MessageBox("You've hit rock bottom. Your gambler is bankrupt. Select Create/Delete under the FILE menu to create or select a new gambler.","Bankrupt!",MB_OK);
	 }
	 return 0;
  }
  int cp = coinsplayed;
  int16 creditsoundoffset=0;
  int16 session = GetCasPD(activeplayer)->VPData.CurrentSession;
  TCVPSession &cs = GetCasPD(activeplayer)->VPData.Sessions[session];

  if(credits >= maxbet-coinsplayed)
  {
	 credits -= maxbet-coinsplayed;
	 switch((int32)(maxbet - coinsplayed))
		 {
			case 1  : VPSounds->PlaySound(6);creditsoundoffset=2;break;
			case 2  : VPSounds->PlaySound(7);creditsoundoffset=4;break;
			case 3  : VPSounds->PlaySound(8);creditsoundoffset=5;break;
			case 4  : VPSounds->PlaySound(9);creditsoundoffset=6;break;
			case 5  : VPSounds->PlaySound(10);creditsoundoffset=7;break;
		 }
	 cs.TotalBetsCash += (maxbet-coinsplayed)*coinsize;

	 coinsplayed = maxbet;
	 CoinsPlayed->SetNum(coinsplayed);
	 Credits->SetNum(credits);
	 Button7->ShowVoidUp();
	 if(credits == 0)
	 {
		Button4->ShowGray();
	 }
	 Button5->ShowGray();
	 Button6->ShowGray();
	 VertLite->ClearRows();
	 WinPaid->SetNum(0);
	 return (coinsplayed - cp);
  }
  else
  {
	 coinsplayed += credits;
	 cs.TotalBetsCash += credits*coinsize;
	 Button7->ShowVoidUp();
	 Button5->ShowGray();
	 Button6->ShowGray();
	 Button4->ShowGray();
	 switch((int32)credits)
	 {
			case 1  : VPSounds->PlaySound(6);creditsoundoffset=2;break;
			case 2  : VPSounds->PlaySound(7);creditsoundoffset=4;break;
			case 3  : VPSounds->PlaySound(8);creditsoundoffset=5;break;
			case 4  : VPSounds->PlaySound(9);creditsoundoffset=6;break;
			case 5  : VPSounds->PlaySound(10);creditsoundoffset=7;break;
	 }
	 credits = 0;                          // Could make a little faster
  }

  if (GetCash(activeplayer) > (maxbet - coinsplayed) * coinsize)
  {
	 SubCash(activeplayer,(maxbet - coinsplayed) * coinsize);
    cs.TotalBetsCash += (maxbet-coinsplayed)*coinsize;
	 switch((int32)(maxbet - coinsplayed))
	 {
			case 1  : VPSounds->PlaySound(0,creditsoundoffset);break;
			case 2  : VPSounds->PlaySound(1,creditsoundoffset);break;
			case 3  : VPSounds->PlaySound(2,creditsoundoffset);break;
			case 4  : VPSounds->PlaySound(3,creditsoundoffset);break;
			case 5  : VPSounds->PlaySound(4,creditsoundoffset);break;
	 }
	 coinsplayed = maxbet;
    CoinsPlayed->SetNum(coinsplayed);
    Credits->SetNum(credits);
	 Chips->SetNum(GetCash(activeplayer));
  }
  else
  {
	 TMoney x;
	 x = GetCash(activeplayer) / coinsize;
    x.Truncate();
	 coinsplayed += x;
	 switch((int16)x)
	 {
			case 1  : VPSounds->PlaySound(0,creditsoundoffset);break;
			case 2  : VPSounds->PlaySound(1,creditsoundoffset);break;
			case 3  : VPSounds->PlaySound(2,creditsoundoffset);break;
			case 4  : VPSounds->PlaySound(3,creditsoundoffset);break;
			case 5  : VPSounds->PlaySound(4,creditsoundoffset);break;
	 }
	 SubCash(activeplayer,coinsize*x);
	 cs.TotalBetsCash += coinsize*x;

	 CoinsPlayed->SetNum(coinsplayed);
	 if(coinsplayed > 0)
	 {
	  //???	WinRatio->SetColumn(coinsplayed - 1);
	 }
    Credits->SetNum(credits);
	 Chips->SetNum(GetCash(activeplayer));
  }
  if(coinsplayed > cp)
  {
	 VertLite->ClearRows();
	 WinPaid->SetNum(0);
  }
  else if(coinsplayed == cp)
  {
	 //string allin("Your All In");
	 //StatusBar->ShowMessageString(allin,12);
  }
  BankCashDisplay->SetNum(GetCash(activeplayer));
  return (coinsplayed - cp);
}
//*******************************************************************
void TACCVPGLord::HoldCard(int16 cardnum)
{
  if ((cardnum < 0) || (cardnum > 4)) {return;}

  if(GetCasPlayer(activeplayer)->pHand->hold[cardnum] == 1)
  {
	 GetCasPlayer(activeplayer)->pHand->hold[cardnum] = 0;
	 VPSounds->PlaySound(30);
  }
  else
  {
	 GetCasPlayer(activeplayer)->pHand->hold[cardnum] = 1;
	 VPSounds->PlaySound(29);
  }

  bool held = GetCasPlayer(activeplayer)->pHand->hold[cardnum];
  CardSprites[cardnum]->Hold(held);
}
//*******************************************************************
int16 TACCVPGLord::ShowWinner()
{
  credits += (winnerpaid)/(coinsize);
  return 1;
}
//*******************************************************************
//*******************************************************************
void TACCVPGLord::SetUIDSStrings()
{
  strSounds = GetAppString(idsSounds);
  strVertLite = GetAppString(idsVertLite);
  strDrawBack = GetAppString(idsDrawBack);
  strCoinPay = GetAppString(idsCoinPay);
  strChips = GetAppString(idsChips);
  strCard1 = GetAppString(idsCard1);
  if (idsCard2 > 0)
  {
    strCard2 = GetAppString(idsCard2);
    if (idsCard3 > 0)
    {
      strCard3 = GetAppString(idsCard3);
      if (idsCard4 > 0)
      {
        strCard4 = GetAppString(idsCard4);
        if (idsCard5 > 0)
        {
          strCard5 = GetAppString(idsCard5);
        }
      }
    }
  }
  strNP1 = GetAppString(idsNP1);
  strNP2 = GetAppString(idsNP2);
  strNP3 = GetAppString(idsNP3);
  strCoinsPlayed = GetAppString(idsCoinsPlayed);
  strCredits = GetAppString(idsCredits);
  strWinPaid = GetAppString(idsWinPaid);
  strButton0 = GetAppString(idsButton0);
  strButton1 = GetAppString(idsButton1);
  strButton2 = GetAppString(idsButton2);
  strButton3 = GetAppString(idsButton3);
  strButton4 = GetAppString(idsButton4);
  strButton5 = GetAppString(idsButton5);
  strButton6 = GetAppString(idsButton6);
  strButton7 = GetAppString(idsButton7);
  strButton8 = GetAppString(idsButton8);
  strWinRatio = GetAppString(idsWinRatio);
  strBankCash = GetAppString(idsBankCash);
  if (idsProgressive > 0)
  {
    strProgressive = GetAppString(idsProgressive);
  }
}
//*******************************************************************
void TACCVPGLord::SetupSprites()
{
  if (idsSounds > 0 && VPSounds == NULL)        {SpriteError("VPSounds",strSounds);}
  if (idsDrawBack > 0 && DrawBack == NULL)        {SpriteError("DrawBack",strDrawBack);}
  if (CoinPay == NULL)         {SpriteError("CoinPay",strCoinPay);}
  if (VertLite == NULL)        {SpriteError("VertLite",strVertLite);}
  if (NamePlate1 == NULL)      {SpriteError("NamePlate1",strNP1);}
  if (idsNP2 > 0 && NamePlate2 == NULL)      {SpriteError("NamePlate2",strNP2);}
  if (idsNP3 > 0 && NamePlate3 == NULL)      {SpriteError("NamePlate3",strNP3);}
  if (BankCashDisplay == NULL) {SpriteError("BankCashDisplay",strBankCash);}
  if (Button0 == NULL)         {SpriteError("Button0",strButton0);}
  if (idsButton1 > 0 && Button1 == NULL)         {SpriteError("Button1",strButton1);}
  if (Button2 == NULL)         {SpriteError("Button2",strButton2);}
  if (idsButton3 > 0 && Button3 == NULL)         {SpriteError("Button3",strButton3);}
  if (Button4 == NULL)         {SpriteError("Button4",strButton4);}
  if (Button5 == NULL)         {SpriteError("Button5",strButton5);}
  if (Button6 == NULL)         {SpriteError("Button6",strButton6);}
  if (Button7 == NULL)         {SpriteError("Button7",strButton7);}
  if (idsButton8 > 0 && Button8 == NULL)         {SpriteError("Button8",strButton8);}
  if (CardSprites[0] == NULL)  {SpriteError("Card Sprite 1",strCard1);}
  if (idsCard2 > 0 && CardSprites[1] == NULL)  {SpriteError("Card Sprite 2",strCard2);}
  if (idsCard3 > 0 && CardSprites[2] == NULL)  {SpriteError("Card Sprite 3",strCard3);}
  if (idsCard4 > 0 && CardSprites[3] == NULL)  {SpriteError("Card Sprite 4",strCard4);}
  if (idsCard5 > 0 && CardSprites[4] == NULL)  {SpriteError("Card Sprite 5",strCard5);}
  if (CoinsPlayed == NULL)     {SpriteError("Coins Played Nums",strCoinsPlayed);}
  if (WinRatio == NULL)        {SpriteError("Win Ratio Bars",strWinRatio);}
  if (WinPaid == NULL)         {SpriteError("Win Paid Nums",strWinPaid);}
  if (Credits == NULL)         {SpriteError("Credits Nums",strCredits);}
  if (idsChips > 0 && Chips == NULL)           {SpriteError("Chip Stacks",strChips);}

  if (idsProgressive > 0)
  {
    if (Progressive == NULL) {SpriteError("Progressive",strProgressive);}
    ActivateSpriteNow(Progressive);
  }

  if (idsSounds > 0) {ActivateSpriteNow(VPSounds);}
  VertLite->Start(GetFUC());
  if (idsDrawBack > 0) {DrawBack->Start(GetFUC());}
  CoinPay->Start(GetFUC());

  BankCashDisplay->Start(GetFUC());
  ActivateSpriteNow(Button0);
  if (idsButton1 > 0) {ActivateSpriteNow(Button1);}
  ActivateSpriteNow(Button2);
  if (!GetFW()->GetHandleShowMenu())
  {
	 Button2->PButton->CAD.SetCurrentFrame(1);
	 Button2->Show();
	 Button2->PButtonResponder->Remove();
  }

  if (idsButton3 > 0) {ActivateSpriteNow(Button3);}
  ActivateSpriteNow(Button4);
  ActivateSpriteNow(Button5);
  ActivateSpriteNow(Button6);
  ActivateSpriteNow(Button7);
  if (idsButton8 > 0) {ActivateSpriteNow(Button8);}
  CoinsPlayed->Start(GetFUC());
  WinRatio->Start(GetFUC());
  Credits->Start(GetFUC());
  WinPaid->Start(GetFUC());

  for (int16 j=0;j<5;j++)
  {
    if (CardSprites[j] != NULL)
    {
	   CardSprites[j]->Start(GetFUC());
    }
  }

  if (idsChips > 0) {Chips->Start(GetFUC());}
  NamePlate1->Start(GetFUC());
  if (NamePlate2 != NULL) {NamePlate2->Start(GetFUC());}
  if (NamePlate3 != NULL) {NamePlate3->Start(GetFUC());}
}
//*******************************************************************
void TACCVPGLord::CleanupSprites()
{
  CoinsPlayed->NoShow(); // is this necessary ??
}
//*******************************************************************
bool TACCVPGLord::AddCredits(int16 addcredits)
{
  TMoney amount = addcredits;
  if(GetCasPlayer(activeplayer) && (GetCash(activeplayer) >= amount*coinsize))
  {
	 credits += (long)amount;
	 SubCash(activeplayer,amount*coinsize);
	 BankCashDisplay->SetNum(GetCash(activeplayer));
	 if(Chips != NULL)
    {
      Chips->SetNum(GetCash(activeplayer));
    }
	 Credits->SetNum(credits);
	 Button4->ShowVoidUp();
  }
  else
  {
	 PModeWin->MessageBox("You do not have that much.","Bankroll",MB_OK);
  }
  return true;
}
//*******************************************************************
void TACCVPGLord::EnableButton(int16 button)
{
  switch(button)
  {
	 case 0  : if(Button0 != NULL)
              {
                Button0->Enabled = true;
              }
              break;
	 case 1  : if(Button1 != NULL)
              {
                Button1->Enabled = true;
              }
              break;
	 case 2  : if(Button2 != NULL)
              {
                Button2->Enabled = true;
              }
              break;
	 case 3  : if(Button3 != NULL)
              {
                Button3->Enabled = true;
              }
              break;
	 case 4  : if(Button4 != NULL)
              {
                Button4->Enabled = true;
              }
              break;
	 case 5  : if(Button5 != NULL)
              {
                Button5->Enabled = true;
              }
              break;
	 case 6  : if(Button6 != NULL)
              {
                Button6->Enabled = true;
              }
              break;
	 case 7  : if(Button7 != NULL)
              {
                Button7->Enabled = true;
              }
              break;
	 case 8  : if(Button8 != NULL)
              {
                Button8->Enabled = true;
              }
              break;
  }
}
//*******************************************************************
void TACCVPGLord::DisEnableButton(int16 button)
{
  switch(button)
  {
	 case 0  : if(Button0 != NULL)
              {
                Button0->Enabled = false;
              }
              break;
	 case 1  : if(Button1 != NULL)
              {
                Button1->Enabled = false;
              }
              break;
	 case 2  : if(Button2 != NULL)
              {
                Button2->Enabled = false;
              }
              break;
	 case 3  : if(Button3 != NULL)
              {
                Button3->Enabled = false;
              }
              break;
	 case 4  : if(Button4 != NULL)
              {
                Button4->Enabled = false;
              }
              break;
	 case 5  : if(Button5 != NULL)
              {
                Button5->Enabled = false;
              }
              break;
	 case 6  : if(Button6 != NULL)
              {
                Button6->Enabled = false;
              }
              break;
	 case 7  : if(Button7 != NULL)
              {
                Button7->Enabled = false;
              }
              break;
	 case 8  : if(Button8 != NULL)
              {
                Button8->Enabled = false;
              }
              break;
  }
}
//*******************************************************************
void TACCVPGLord::FreezeAllButtons()
{
  if(Button0 != NULL)
  {
    Button0->Freeze = true;
  }
  if(Button1 != NULL)
  {
    Button1->Freeze = true;
  }
  if(Button2 != NULL)
  {
    Button2->Freeze = true;
  }
  if(Button3 != NULL)
  {
    Button3->Freeze = true;
  }
  if(Button4 != NULL)
  {
    Button4->Freeze = true;
  }
  if(Button5 != NULL)
  {
    Button5->Freeze = true;
  }
  if(Button6 != NULL)
  {
    Button6->Freeze = true;
  }
  if(Button7 != NULL)
  {
    Button7->Freeze = true;
  }
  if(Button8 != NULL)
  {
    Button8->Freeze = true;
  }
}
//*******************************************************************
void TACCVPGLord::UnFreezeAllButtons()
{
  if(Button0 != NULL)
  {
    Button0->Freeze = false;
  }
  if(Button1 != NULL)
  {
    Button1->Freeze = false;
  }
  if(Button2 != NULL)
  {
    Button2->Freeze = false;
  }
  if(Button3 != NULL)
  {
    Button3->Freeze = false;
  }
  if(Button4 != NULL)
  {
    Button4->Freeze = false;
  }
  if(Button5 != NULL)
  {
    Button5->Freeze = false;
  }
  if(Button6 != NULL)
  {
    Button6->Freeze = false;
  }
  if(Button7 != NULL)
  {
    Button7->Freeze = false;
  }
  if(Button8 != NULL)
  {
    Button8->Freeze = false;
  }
}
//*******************************************************************
void TACCVPGLord::EnableAllButtons()
{
  if(Button0 != NULL)
  {
    Button0->Enabled = true;
  }
  if(Button1 != NULL)
  {
    Button1->Enabled = true;
  }
  if(Button2 != NULL)
  {
    Button2->Enabled = true;
  }
  if(Button3 != NULL)
  {
    Button3->Enabled = true;
  }
  if(Button4 != NULL)
  {
    Button4->Enabled = true;
  }
  if(Button5 != NULL)
  {
    Button5->Enabled = true;
  }
  if(Button6 != NULL)
  {
    Button6->Enabled = true;
  }
  if(Button7 != NULL)
  {
    Button7->Enabled = true;
  }
  if(Button8 != NULL)
  {
    Button8->Enabled = true;
  }
}
//*******************************************************************
void TACCVPGLord::DisEnableAllButtons()
{
  if(Button0 != NULL)
  {
    Button0->Enabled = false;
  }
  if(Button1 != NULL)
  {
    Button1->Enabled = false;
  }
  if(Button2 != NULL)
  {
    Button2->Enabled = false;
  }
  if(Button3 != NULL)
  {
    Button3->Enabled = false;
  }
  if(Button4 != NULL)
  {
    Button4->Enabled = false;
  }
  if(Button5 != NULL)
  {
    Button5->Enabled = false;
  }
  if(Button6 != NULL)
  {
    Button6->Enabled = false;
  }
  if(Button7 != NULL)
  {
    Button7->Enabled = false;
  }
  if(Button8 != NULL)
  {
    Button8->Enabled = false;
  }
}
//*******************************************************************
#pragma argsused
bool TACCVPGLord::Respond(int16 button,int16 info,void *pdata)
{
  if(info == -5)//gray button hit
  {
	 if(button == idButton7 && (GetCash(activeplayer) > coinsize || credits > 0 || shutdownstate != 0))
	 {return false;}
	 if(button == idButton7 && GetCash(activeplayer) == 0 && credits == 0 && shutdownstate == 0)
	 {
      #if defined(KENO_COMPILE)
		if(GetCasPD(activeplayer)->IsActiveKenoTicket())
		{
		  PModeWin->MessageBox("You're out of money and may not bet. Your only hope is that one of your Keno tickets pays off.","Out of Cash",MB_OK);
		}
		else
		{
      #endif
		  PModeWin->MessageBox("You've hit rock bottom. Your gambler is bankrupt. Select GAMBLER MANAGEMENT under the FILE menu to create or select a new gambler.","Bankrupt!",MB_OK);
      #if defined(KENO_COMPILE)
		}
      #endif
	 }
	 if(button == idButton8){return false;}
	 return true;
  }
  ButtonInfo = info;
  if(info != -1)
  {
	 switch(button)
	 {
	 case idButton0  : ButtonHit[idButton0]=true;break;
	 case idButton1  : TCmMsg(CM_ASKEXPERTSTATISTICS).PostToFW();ButtonHit[idButton1]=true;break;
	 case idButton2  : ButtonHit[idButton2]=true;break;
	 case idButton3  : ButtonHit[idButton3]=true;break;
	 case idButton4  : ButtonHit[idButton4]=true;break;
	 case idButton5  : ButtonHit[idButton5]=true;break;
	 case idButton6  : ButtonHit[idButton6]=true;break;
	 case idButton7  : ButtonHit[idButton7]=true;break;
	 case idButton8  : ButtonHit[idButton8]=true;break;
	 default           : WaitOnButtonDown = false;break;
	 }
  }
  return true;
}
//*******************************************************************
void TACCVPGLord::ButtonClear(int16 button)
{
  switch(button)
  {
	 case idButton0  : ButtonHit[idButton0]=false;break;
	 case idButton1  : ButtonHit[idButton1]=false;break;
	 case idButton2  : ButtonHit[idButton2]=false;GetFW()->CmShowMenu();break;
	 case idButton3  : ButtonHit[idButton3]=false;PModeWin->ModeHelp();break;
	 case idButton4  : ButtonHit[idButton4]=false;break;
	 case idButton5  : ButtonHit[idButton5]=false;break;
	 case idButton6  : ButtonHit[idButton6]=false;break;
	 case idButton7  : ButtonHit[idButton7]=false;break;
	 case idButton8  : ButtonHit[idButton8]=false;break;
	 default           : WaitOnButtonDown = false;break;
  }
  WaitOnButtonDown = false;
  return;
}
//*******************************************************************
bool TACCVPGLord::Respond(TResponder &responder)
{
  if (PState == NULL) {return true;}

  switch (responder.GetID())
  {
	 case idAddCoins  :  return (((TVPLordState *)PState)->AddCoin(responder));
	 case idHoldCard0 :  return (((TVPLordState *)PState)->HoldCard0(responder));
	 case idHoldCard1 :  return (((TVPLordState *)PState)->HoldCard1(responder));
	 case idHoldCard2 :  return (((TVPLordState *)PState)->HoldCard2(responder));
	 case idHoldCard3 :  return (((TVPLordState *)PState)->HoldCard3(responder));
	 case idHoldCard4 :  return (((TVPLordState *)PState)->HoldCard4(responder));
	 case idSpeedClick:  return (((TVPLordState *)PState)->SpeedClick(responder));

	 case idOneChip            :  return true;//(((TVPLordState *)PState)->OneChip(responder));
	 case idFiveChip           :  return true;//(((TVPLordState *)PState)->FiveChip(responder));
	 case idTwentyFiveChip     :  return true;//(((TVPLordState *)PState)->TwentyFiveChip(responder));
	 case idOneHundredChip     :  return true;//(((TVPLordState *)PState)->OneHundredChip(responder));
	 case idOneThouChip        :  return true;//((TVPLordState *)PState)->OneThouChip(responder));
	 case idTenThouChip        :  return true;//(((TVPLordState *)PState)->TenThouChip(responder));
	 case idNamePlate          :  if(shutdownstate){return true;}
											return (((TVPLordState *)PState)->NamePlate(responder));
	 default     :  return true;
  }
}
//*******************************************************************
void TACCVPGLord::CleanupResponders()
{
  for(int16 i=0;i<NumResponders;i++)
  {
    delete Responders[i];
  }
}
//*******************************************************************
int16 TACCVPGLord::InitVP()
{
//  if(game == gtJacksProg)
  Button7->PButtonResponder->SetCh2(VK_RETURN);
  if (Button8 != NULL) Button8->PButtonResponder->SetCh2(VK_RETURN); //???
  Button5->PButtonResponder->SetCh('o');
  if (SubGameType == cvpJacksProgressive)
  {

	 dword interval=0;
//	 progressive = ((TCasinoModeWin *)pMWin)->GetCasPlayerMgr()->GetCasinoGameDataPtr()->ProgressiveVPAmount;
    progressive = GetCasMW()->GetCasPlayerMgr()->GetCasinoGameDataPtr()->ProgressiveVPAmount;
//	 interval = TTime().Seconds() - ((TCasinoModeWin *)pMWin)->GetCasPlayerMgr()->GetCasinoGameDataPtr()->ProgressiveVPEndTime;
    interval = TTime().Seconds() - GetCasMW()->GetCasPlayerMgr()->GetCasinoGameDataPtr()->ProgressiveVPEndTime;

	 if(interval < 600 && interval > 0)
	 {
		interval = interval/17;
		for(int16 i=0;i<interval;i++)
		{
		  progressive += 1;
		  if(progressive > 99963l){progressive = 4000;}
		}
		if(random(300) == 1){progressive = 4000;}
	 }
	 else if(interval < 600000l && interval > 0)
	 {
		interval = interval/600;
		for(int16 i=0;i<interval;i++)
		{
		  if(random(300) == 1)
		  {progressive = 4000;}
		  progressive += 36;
		  if(progressive > 99963l){progressive = 4000;}
		}
	 }
	 else
	 {
		progressive = 4000 + random(6001);
	 }
  }
  SetupActivePlayer(NextSlotNum(-1)); // -1 because order of checking
  if(GetCasPD(0))
  {
	 GetCasPD(0)->StartVPSession(SubGameType,GameDenom);
  }
  if(GetCasPD(1))
  {
	 GetCasPD(1)->StartVPSession(SubGameType,GameDenom);
  }
  if(GetCasPD(2))
  {
	 GetCasPD(2)->StartVPSession(SubGameType,GameDenom);
  }
  credits = 0;
  coinsplayed = 0;
  winnerpaid = 0;
  if(credits > 0)
  {
	 Button4->ShowVoidUp();
  }
  else
  {
	 Button4->ShowGray();
  }
  if (!GetFW()->GetHandleShowMenu())
  {
	 Button2->PButton->CAD.SetCurrentFrame(3);
	 Button2->PButton->Show();
	 Button2->PButtonResponder->Remove();
  }
  return 1;
}
//*******************************************************************
void TACCVPGLord::SwitchToPlayer(int16 player)
{
  if(GetCasPD(player))
  {
	 if(activeplayer != player && activeplayer != -1)
	 {
		credits += coinsplayed;
		coinsplayed = 0;
		CoinsPlayed->SetNum(0);
		GetCasPlayer(activeplayer)->credit = credits;
		credits = 0;
		Button7->ShowGray();
		GetCasPD(activeplayer)->Columns[0] = Chips->col1;
		GetCasPD(activeplayer)->Columns[1] = Chips->col2;
		GetCasPD(activeplayer)->Columns[2] = Chips->col3;
		GetCasPD(activeplayer)->Columns[3] = Chips->col4;
		GetCasPD(activeplayer)->Columns[4] = Chips->col5;
		GetCasPD(activeplayer)->Columns[5] = Chips->col6;
	 }

	 if(activeplayer != player)
	 {
		switch(activeplayer)
		{
			 case 0 : NamePlate1->NoShowNamePlate();break;
			 case 1 : NamePlate2->NoShowNamePlate();break;
			 case 2 : NamePlate3->NoShowNamePlate();break;
		}
		activeplayer = player;
		BankCashDisplay->SetNum(GetCash(activeplayer));
		Chips->SetupCols(GetCasPD(player)->Cash,GetCasPD(player)->Columns[0],
						  GetCasPD(player)->Columns[1],GetCasPD(player)->Columns[2],
						  GetCasPD(player)->Columns[3],GetCasPD(player)->Columns[4],
						  GetCasPD(player)->Columns[5],false);
		credits = GetCasPlayer(player)->credit;
		GetCasPlayer(player)->credit = 0;
		Credits->SetNum(credits);
		if(GetCasPD(player)->Cash != 0)
		{
		  Button5->ShowVoidUp();
		  Button6->ShowVoidUp();
		}
		else
		{
		  Button5->ShowGray();
		  Button6->ShowGray();
		}
		if(GetNumActivePlayers() > 1)
		{
		  string name;
		  name = GetCasPD(player)->GetName();
		  switch(player)
		  {
			 case 0 : NamePlate1->ShowNamePlateString(name);break;
			 case 1 : NamePlate2->ShowNamePlateString(name);break;
			 case 2 : NamePlate3->ShowNamePlateString(name);break;
		  }
		}
	 }
	 if(credits != 0)
	 {
		Button4->ShowVoidUp();
	 }
	 else
	 {
		Button4->ShowGray();
	 }
  }
}
//*******************************************************************
void TACCVPGLord::CyclePlayers()
{
  if(activeplayer != -1)
  {
	 SwitchToPlayer(NextSlotNum(activeplayer));
  }
}
//*******************************************************************
void  TACCVPGLord::ShuttingDown()
{
	 if(GetCasPD(0))
	 {
		NotifyPlayerDeActivation(0);
	 }
	 if(GetCasPD(1))
	 {
		NotifyPlayerDeActivation(1);
	 }
	 if(GetCasPD(2))
	 {
		NotifyPlayerDeActivation(2);
	 }
  if(SubGameType == cvpJacksProgressive)
  {
//	 ((TCasinoModeWin *)pMWin)->GetCasPlayerMgr()->GetCasinoGameDataPtr()->ProgressiveVPAmount =
//	 progressive;
    GetCasMW()->GetCasPlayerMgr()->GetCasinoGameDataPtr()->ProgressiveVPAmount = progressive;

//	 ((TCasinoModeWin *)pMWin)->GetCasPlayerMgr()->GetCasinoGameDataPtr()->ProgressiveVPEndTime =
//	 TTime().Seconds();
    GetCasMW()->GetCasPlayerMgr()->GetCasinoGameDataPtr()->ProgressiveVPEndTime = TTime().Seconds();
  }
}
//*******************************************************************
void TACCVPGLord::NotifyPlayerActivation(int16 slotnum)
{
  if(GetCasPD(slotnum))
  {
	 GetCasPD(slotnum)->StartVPSession(SubGameType,GameDenom);
	 if(activeplayer == -1)
	 {
		activeplayer = slotnum;
		BankCashDisplay->SetNum(GetCash(activeplayer));
		if(Chips != NULL)
      {
        Chips->SetupCols(GetCasPD(slotnum)->Cash,
                       GetCasPD(slotnum)->Columns[0],
							  GetCasPD(slotnum)->Columns[1],
                       GetCasPD(slotnum)->Columns[2],
							  GetCasPD(slotnum)->Columns[3],
                       GetCasPD(slotnum)->Columns[4],
							  GetCasPD(slotnum)->Columns[5],
                       false);
      }
		if(GetCasPD(slotnum)->Cash >= coinsize)
		{
			 Button5->ShowVoidUp();
			 Button6->ShowVoidUp();
		}
		else
		{
			 Button5->ShowGray();
			 Button6->ShowGray();
		}
		string name;
		name = GetCasPD(slotnum)->GetName();
		switch(slotnum)
		{
			 case 0 : NamePlate1->ShowNamePlateString(name);break;
			 case 1 : NamePlate2->ShowNamePlateString(name);break;
			 case 2 : NamePlate3->ShowNamePlateString(name);break;
		}
	 }
  }
}
//*******************************************************************
void TACCVPGLord::NotifyPlayerDeActivation(int16 slotnum)
{
  if(GetCasPD(slotnum))
  {
	 switch(slotnum)
	 {
			 case 0 : NamePlate1->NoShowNamePlate();break;
			 case 1 : NamePlate2->NoShowNamePlate();break;
			 case 2 : NamePlate3->NoShowNamePlate();break;
	 }
	 GetCasPD(slotnum)->Cash += GetCasPlayer(slotnum)->credit*coinsize;
	 GetCasPlayer(slotnum)->credit = 0;
	 if(activeplayer == slotnum)
	 {
		if(shutdownstate == 0)
		{
		  GetCasPD(slotnum)->Cash += coinsplayed*coinsize;
		}
		GetCasPD(slotnum)->Cash += credits*coinsize;
		credits = 0;
		coinsplayed = 0;
		Button7->ShowGray();
		CoinsPlayed->SetNum(0);
		if(Chips != NULL)
      {
        Chips->SetNum(GetCash(activeplayer));
		  GetCasPD(slotnum)->Columns[0] = Chips->col1;
		  GetCasPD(slotnum)->Columns[1] = Chips->col2;
		  GetCasPD(slotnum)->Columns[2] = Chips->col3;
		  GetCasPD(slotnum)->Columns[3] = Chips->col4;
		  GetCasPD(slotnum)->Columns[4] = Chips->col5;
		  GetCasPD(slotnum)->Columns[5] = Chips->col6;
      }
	 }
	 if(GetNumActivePlayers() == 1)
	 {
		activeplayer = -1;
		if(Chips != NULL) {Chips->NoShow();}
		Credits->SetNum(0);
		credits = 0;
		CoinsPlayed->SetNum(0);
		NamePlate1->NoShow();
      if(NamePlate2 != NULL)
      {
        NamePlate2->NoShow();
        NamePlate3->NoShow();
      }
		Button7->ShowGray();
		BankCashDisplay->SetNum(0);
	 }
	 if(GetNumActivePlayers() > 1 && activeplayer == slotnum)
	 {
		int16 newplayer=-1;
		newplayer = NextSlotNum(slotnum);
		activeplayer = newplayer;
      if(Chips != NULL)
      {
		  Chips->SetupCols(GetCasPD(newplayer)->Cash,
                       GetCasPD(newplayer)->Columns[0],
							  GetCasPD(newplayer)->Columns[1],
                       GetCasPD(newplayer)->Columns[2],
							  GetCasPD(newplayer)->Columns[3],
                       GetCasPD(newplayer)->Columns[4],
							  GetCasPD(newplayer)->Columns[5],
                       false);
      }
		credits = GetCasPlayer(newplayer)->credit;
		GetCasPlayer(newplayer)->credit = 0;
		Credits->SetNum(credits);
		CoinsPlayed->SetNum(0);
		BankCashDisplay->SetNum(GetCash(activeplayer));
		if(GetCasPD(activeplayer)->Cash >= coinsize || credits > 0)
		{
		  Button5->ShowVoidUp();
		  Button6->ShowVoidUp();
		}
		else
		{
		  Button5->ShowGray();
		  Button6->ShowGray();
		}
		Button7->ShowGray();
		string name;
		name = GetCasPD(newplayer)->GetName();
		switch(newplayer)
		{
			 case 0 : NamePlate1->ShowNamePlateString(name);break;
			 case 1 : NamePlate2->ShowNamePlateString(name);break;
			 case 2 : NamePlate3->ShowNamePlateString(name);break;
		}
	 }
	 GetCasPD(slotnum)->EndVPSession();
  }
}
//*******************************************************************
void TACCVPGLord::SetupActivePlayer(int16 slot)
{
  if(GetCasPD(slot))
  {
	 activeplayer = slot;
    if(Chips != NULL)
    {
	   Chips->SetupCols(GetCasPD(slot)->Cash,
                     GetCasPD(slot)->Columns[0],
						   GetCasPD(slot)->Columns[1],
                     GetCasPD(slot)->Columns[2],
						   GetCasPD(slot)->Columns[3],
                     GetCasPD(slot)->Columns[4],
						   GetCasPD(slot)->Columns[5],
                     false);
    }
	 if(GetNumActivePlayers() > 0)
	 {
		string name;
		name = GetCasPD(slot)->GetName();
		switch(slot)
		  {
			 case 0 : NamePlate1->ShowNamePlateString(name);break;
			 case 1 : NamePlate2->ShowNamePlateString(name);break;
			 case 2 : NamePlate3->ShowNamePlateString(name);break;
		  }
	 }
  }
}
//*******************************************************************
bool TACCVPGLord::CheckExpertCode()
{
  bool returnvalue = true;
  bool wildHeld = false;
  GetCasPlayer(activeplayer)->pHand->highhand      = 0;
  GetCasPlayer(activeplayer)->pHand->highcard      = 0;
  GetCasPlayer(activeplayer)->pHand->toflush       = 0;
  GetCasPlayer(activeplayer)->pHand->instrght      = 0;
  GetCasPlayer(activeplayer)->pHand->outstrght     = 0;
  GetCasPlayer(activeplayer)->pHand->instrflsh     = 0;
  GetCasPlayer(activeplayer)->pHand->outstrflsh    = 0;
  GetCasPlayer(activeplayer)->pHand->lohighcard    = 0;
  GetCasPlayer(activeplayer)->pHand->lolowcard     = 0;
  GetCasPlayer(activeplayer)->pHand->lohand        = 0;
  GetCasPlayer(activeplayer)->pHand->lowcard       = 0;
  GetCasPlayer(activeplayer)->pHand->wildcount     = 0;
  fake->highhand      = 0;
  fake->highcard      = 0;
  fake->toflush       = 0;
  fake->instrght      = 0;
  fake->outstrght     = 0;
  fake->instrflsh     = 0;
  fake->outstrflsh    = 0;
  fake->lohighcard    = 0;
  fake->lolowcard     = 0;
  fake->lohand        = 0;
  fake->lowcard       = 0;
  fake->wildcount     = 0;
  fake->inhand        = 0;
  GetNumOfWildCards();
  for(int16 i=0;i<5;i++)
  {
	 if(GetCasPlayer(activeplayer)->pHand->hold[i] == 1)
	 {
		fake->cards[fake->inhand].name = GetCasPlayer(activeplayer)->pHand->cards[i].name;
		fake->cards[fake->inhand].suit = GetCasPlayer(activeplayer)->pHand->cards[i].suit;
		if (SubGameType == cvpDeucesWild && fake->cards[fake->inhand].name == Two)
		{
		  wildHeld = true;
		}
		if (SubGameType == cvpJokersWild && fake->cards[fake->inhand].name == Joker)
		{
		  wildHeld = true;
		}
		fake->inhand++;
	 }
  }
  if (SubGameType == cvpDeucesWild)
  {
	 Wild2(false);
  }
  else if (SubGameType == cvpJokersWild)
  {
	 WildJoker(false);
  }
  else
  {
	 pSmarts->Holding(GetCasPlayer(activeplayer)->pHand);
	 pSmarts->Holding(fake);
  }
  pSmarts->Insert_Sort(fake);
  if(ask->ExpertCode == 1)
  {
	 if(fake->inhand == 5)
	 {returnvalue = true;}
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 2)
  {
	 if(fake->inhand == 4 && GetCasPlayer(activeplayer)->pHand->highhand == 71 &&
		 fake->cards[0].name == fake->cards[1].name  &&
		 fake->cards[0].name == fake->cards[2].name  &&
		 fake->cards[0].name == fake->cards[3].name                               )
	 {returnvalue = true;}
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 102)
  {
	 if(fake->inhand == 4 &&
		 fake->cards[0].name == fake->cards[1].name &&
		 fake->cards[2].name == fake->cards[3].name &&
		 fake->cards[0].name == Two)
	 {returnvalue = true;}
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 302)
  {
	 if(fake->inhand == 4 &&
		 fake->cards[1].name == fake->cards[2].name &&
		 fake->cards[2].name == fake->cards[0].name &&
		 fake->cards[3].name == AceHi)
	 {returnvalue = true;}
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 402)
  {
	 if(fake->inhand == 4 && GetCasPlayer(activeplayer)->pHand->highhand == 71)
	 {returnvalue = true;}
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 3)
  {
	 if((GetCasPlayer(activeplayer)->pHand->outstrflsh > 3 ||
			 GetCasPlayer(activeplayer)->pHand->instrflsh > 3 ) &&
		  fake->cards[0].name > Nine && fake->inhand == 4      &&
		  fake->cards[0].suit == fake->cards[1].suit	          &&
		  fake->cards[0].suit == fake->cards[2].suit	          &&
		  fake->cards[0].suit == fake->cards[3].suit	            )
	 { // four to a royal flush
		returnvalue = true;
	 }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 103)
  {
	 returnvalue = false;
	 if((GetCasPlayer(activeplayer)->pHand->outstrflsh > 3 ||
		  GetCasPlayer(activeplayer)->pHand->instrflsh > 3 ) &&
		  fake->cards[0].name > Nine && fake->inhand == 4 &&
		  fake->cards[0].suit == fake->cards[1].suit	&&
		  fake->cards[0].suit == fake->cards[2].suit)
	 { // four to a royal flush
		for(int zz=0;zz<5;zz++)
		{
		  if(GetCasPlayer(activeplayer)->pHand->hold[zz] == 1   &&
			  GetCasPlayer(activeplayer)->pHand->cards[zz].name == Joker)
		  {
			 returnvalue = true;
		  }
		}
	 }
  }
  else if(ask->ExpertCode == 4)
  {
	 if(((fake->outstrflsh > 3 ||
         fake->instrflsh  > 3) &&
			fake->inhand == 4 &&
			!wildHeld) ||
			(wildHeld &&
         fake->inhand == 4 &&
			(GetCasPlayer(activeplayer)->pHand->outstrflsh > 3 ||
			 GetCasPlayer(activeplayer)->pHand->instrflsh  > 3   ))     )
	 {
      returnvalue = true;
    } //four to a straight flush
	 else
	 {
      returnvalue = false;
    }
  }
  else if(ask->ExpertCode == 104)
  {
	 if(((fake->outstrflsh > 3 || fake->instrflsh  > 3)         &&
			fake->inhand == 4                                     &&
			!wildHeld                                               ) ||
			(wildHeld &&
			 fake->inhand == 4 &&
			(GetCasPlayer(activeplayer)->pHand->outstrflsh > 3 ||
			 GetCasPlayer(activeplayer)->pHand->instrflsh  > 3   ))     )
	 {returnvalue = true;} //four to a straight flush
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 5)
  {
	 returnvalue = false;
	 if( fake->highhand == 20 && fake->inhand == 3  &&
		  fake->cards[0].name == fake->cards[1].name &&
		  fake->cards[1].name == fake->cards[2].name   )
	 {returnvalue = true;}// three o' kind
	 else if((GetCasPlayer(activeplayer)->pHand->highhand == 20 && fake->inhand == 3)  &&
				(SubGameType == cvpDeucesWild || SubGameType == cvpJokersWild)              )
	 {returnvalue = true;}// three o' kind
  }
  else if(ask->ExpertCode == 55)
  {
	 if( fake->inhand == 3 &&
		 (fake->cards[0].name == fake->cards[1].name && fake->cards[1].name ==
		  fake->cards[2].name) )
	 {returnvalue = true;}// three two's
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 6)
  {
	 returnvalue = false;
	 if(((GetCasPlayer(activeplayer)->pHand->outstrflsh > 2 ||
			GetCasPlayer(activeplayer)->pHand->instrflsh  > 2  ) &&
			wildHeld                                               ) ||
		  (!wildHeld  &&
		  (fake->outstrflsh > 2 || fake->instrflsh > 2)               )  )
	 {// three to a royal
		  if(fake->cards[0].name > Nine && fake->inhand == 3 )
		  {returnvalue = true;}
	 }
  }
  else if(ask->ExpertCode == 7)
  {
	 if((wildHeld && GetCasPlayer(activeplayer)->pHand->outstrght > 3 && fake->inhand == 4) ||
		 (!wildHeld && fake->outstrght > 3 && fake->inhand == 4)                               )
	 {returnvalue = true;}//four card straight
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 8)
  {
	 if(fake->inhand == 3 && fake->cards[0].suit == fake->cards[1].suit &&
		 fake->cards[0].suit == fake->cards[2].suit &&
		 fake->cards[2].name - fake->cards[0].name < 5)
	 {//three to straight flush
		returnvalue = true;
	 }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 88)
  {
	 if(fake->inhand == 3 && fake->cards[0].suit == fake->cards[1].suit &&
		 fake->cards[2].name == 13 &&
		 fake->cards[1].name - fake->cards[0].name < 5)
	 {//three to straight flush
		returnvalue = true;
	 }
	 else if(fake->inhand == 3 &&
				fake->cards[2].name == 13 &&
				fake->cards[1].name == 13 &&
			  (fake->cards[0].suit == fake->cards[1].suit ||
				fake->cards[0].suit == fake->cards[2].suit   )  &&
			  (fake->cards[1].name - fake->cards[0].name < 5 ||
				fake->cards[0].name < Six)                        )
	 {//three to straight flush
		returnvalue = true;
	 }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 9)
  {
	 if((wildHeld && GetCasPlayer(activeplayer)->pHand->toflush  > 3 && fake->inhand == 4) ||
		 (!wildHeld && fake->toflush > 3 && fake->inhand == 4)                                )
	 {//four to flush
		returnvalue = true;
	 }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 10)
  {
	 if(((wildHeld && GetCasPlayer(activeplayer)->pHand->outstrght > 3) ||
		  (!wildHeld && fake->outstrght > 3) ) && fake->inhand == 4        )
	 {//four to straight
		returnvalue = true;
	 }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 11)
  {
	 if((wildHeld && GetCasPlayer(activeplayer)->pHand->outstrght > 2 && fake->inhand == 3) ||
		 (!wildHeld && fake->outstrght > 2 && fake->inhand == 3)                               )
	 {//three to straight
		returnvalue = true;
	 }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 12)
  {
	 int xy=0;
	 returnvalue = false;
	 for(xy=0;xy<5;xy++)
	 {
		if(GetCasPlayer(activeplayer)->pHand->hold[xy] == 1)
		{
		  if(fake->inhand == 1 && GetCasPlayer(activeplayer)->pHand->cards[xy].name == Joker)
		  {returnvalue = true;} //joker only
		}
	 }
  }
  else if(ask->ExpertCode == 13)
  {
	 if(fake->inhand == 0)    //garbage
	 {returnvalue = true;}
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 15)
  {
	 if(((wildHeld && GetCasPlayer(activeplayer)->pHand->highhand == 15) ||
		  (!wildHeld && fake->highhand == 15) ) && fake->inhand == 4        )
	 {//two pair
		returnvalue = true;
	 }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 16)
  {
	 if(fake->highhand == 10 && fake->inhand == 2)
	 {//any pair
		returnvalue = true;
	 }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 17)
  {
	 if((wildHeld && GetCasPlayer(activeplayer)->pHand->toflush > 2 && fake->inhand == 3) ||
		 (!wildHeld && fake->toflush > 2 && fake->inhand == 3)                               )
	 { //three to a flush
		returnvalue = true;
	 }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 18)
  {
	 if(((GetCasPlayer(activeplayer)->pHand->instrflsh > 1 ||
		  GetCasPlayer(activeplayer)->pHand->outstrflsh > 1  ) &&
		  fake->inhand == 2 &&
		  wildHeld          &&
		  fake->cards[0].name > Nine)                          ||
		  (!wildHeld && fake->inhand == 2 && (fake->instrflsh > 1 || fake->outstrflsh > 1))  )
	 {//two to a royal
		returnvalue = true;
	 }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 19)
  {
	 if((wildHeld && GetCasPlayer(activeplayer)->pHand->outstrflsh > 1 && fake->inhand == 2) ||
		 (!wildHeld && fake->inhand == 2 && fake->outstrflsh > 1)                               )
	 {//two to a straight flush
		returnvalue = true;
	 }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 20)
  {
	 if(fake->inhand > 3 &&
		((wildHeld && GetCasPlayer(activeplayer)->pHand->highhand == 71) ||
		 (!wildHeld && fake->highhand == 71)                              ) )
	 {returnvalue = true;}//four of kind, hold 4 or 5 cards
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 220)
  {
	 if((fake->inhand == 4 &&
		  fake->cards[0].name == fake->cards[1].name &&
		  fake->cards[0].name == fake->cards[2].name &&
		  fake->cards[0].name == fake->cards[3].name   ) ||
		  fake->inhand == 5                                )
	 {returnvalue = true;}//four of kind, hold 4 or 5 cards
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 21)
  {
	 if(GetCasPlayer(activeplayer)->pHand->highhand == 10 && fake->inhand == 2 &&
		 fake->cards[0].name > Nine && fake->cards[1].name > Nine && fake->cards[0].name ==
		 fake->cards[1].name)
	 {//high pair
		returnvalue = true;
	 }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 22)
  {
	 if(((GetCasPlayer(activeplayer)->pHand->instrflsh  > 2 ||
			GetCasPlayer(activeplayer)->pHand->outstrflsh > 1  ) &&
			wildHeld                                             &&
			fake->inhand == 3)                                   ||
		  (!wildHeld && (fake->instrflsh > 2 || fake->outstrflsh > 1) && fake->inhand == 3)  )
	 {//three to straight flush (inside)
		returnvalue = true;
	 }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 23)
  {
	 if((wildHeld && GetCasPlayer(activeplayer)->pHand->outstrflsh  > 2 && fake->inhand == 3 &&
		  fake->cards[2].name > Nine)                                                           ||
		 (!wildHeld && fake->inhand == 3 && fake->outstrflsh > 2 && fake->cards[2].name > Nine)   )
	 {//three to straight flush with 10 or higher
		returnvalue = true;
	 }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 24)
  {
	 if((wildHeld && (GetCasPlayer(activeplayer)->pHand->instrflsh  > 2 ||
		  GetCasPlayer(activeplayer)->pHand->outstrflsh > 1  ) &&
		  fake->inhand == 3 &&
		  fake->cards[2].name > Nine)                                      ||
		((fake->instrflsh  > 2 ||
		  fake->outstrflsh > 1  ) &&
		  fake->inhand == 3 && !wildHeld &&
		  fake->cards[2].name > Nine)                                        )

	 {//three to straight flush with 10 or higher
		returnvalue = true;
	 }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 25)
  {
	 if(fake->inhand == 2 && fake->cards[0].name > Nine && fake->cards[1].name > Nine)
	 {//two high cards
		returnvalue = true;
	 }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 26)
  {
	 if(fake->inhand == 1 && fake->cards[0].name > Nine)
	 {//one high cards
		returnvalue = true;
	 }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 27)
  {
	 if(GetCasPlayer(activeplayer)->pHand->highhand == 10 && fake->inhand == 2 &&
		 fake->cards[0].name > Ten && fake->cards[0].name == fake->cards[1].name)
	 {//high pair
		returnvalue = true;
	 }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 28)
  {
	 if(((GetCasPlayer(activeplayer)->pHand->instrflsh  > 2 ||
			GetCasPlayer(activeplayer)->pHand->outstrflsh > 2  ) &&
			fake->inhand == 3 &&
			wildHeld)                                              ||
		  (!wildHeld && (fake->instrflsh > 2 || fake->outstrflsh > 2) && fake->inhand == 3)   )
	 {//three to straight flush with jack or higher
		returnvalue = true;
	 }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 29)
  {
	 if(((GetCasPlayer(activeplayer)->pHand->instrflsh > 1 ||
			GetCasPlayer(activeplayer)->pHand->outstrflsh > 1  ) &&
			fake->inhand == 2 &&
			fake->cards[0].name > Ten &&
			wildHeld)                                              ||
		  (!wildHeld && (fake->instrflsh > 1 || fake->outstrflsh > 1) &&
			fake->cards[0].name > Ten && fake->inhand == 2)               )

	 {//two to a royal no ten
		returnvalue = true;
	 }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 30)
  {
	 if(fake->inhand == 2 && fake->cards[0].name > Ten && fake->cards[1].name > Ten)
	 {//two high cards
		returnvalue = true;
	 }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 31)
  {
	 if(fake->inhand == 3 && fake->cards[0].name == Jack && fake->cards[1].name == Queen &&
		 fake->cards[2].name == King)
	 {//King-Queen-Jack
		returnvalue = true;
	 }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 32)
  {
	 if(fake->inhand == 1 && fake->cards[0].name > Ten)
	 {//one high cards
		returnvalue = true;
	 }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 33)
  {
	 if((wildHeld && GetCasPlayer(activeplayer)->pHand->outstrflsh > 3 && fake->inhand == 4) ||
		 (!wildHeld && fake->outstrflsh > 3 && fake->inhand == 4)                               )
	 {returnvalue = true;} //four to a straight flush
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 34)
  {
	 if(fake->inhand == 1)
	 {
		for(int z=0;z<5;z++)
		{
		  if(GetCasPlayer(activeplayer)->pHand->hold[z] == 1)
		  {
			  if(GetCasPlayer(activeplayer)->pHand->cards[z].name == Two)
			  {returnvalue = true;} //deuce only
			  else
			  {returnvalue = false;}
		  }
		}
	 }
	 else
	 {
		returnvalue = false;
	 }
  }
  else if(ask->ExpertCode == 35)
  {
	 if(((GetCasPlayer(activeplayer)->pHand->outstrflsh > 3 ||
			GetCasPlayer(activeplayer)->pHand->instrflsh > 3 ) &&
			fake->inhand == 4                                    &&
			fake->cards[1].name > Nine                           &&
			wildHeld  )                                             ||
		  (!wildHeld && (fake->outstrflsh > 3 || fake->instrflsh > 3) &&
			fake->inhand == 4 && fake->cards[1].name > Nine)             )
	 { // four to a royal flush
		returnvalue = true;
	 }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 135)
  {
	 returnvalue = false;
	 if((GetCasPlayer(activeplayer)->pHand->outstrflsh > 3 ||
			 GetCasPlayer(activeplayer)->pHand->instrflsh > 3 ) &&
		  fake->inhand == 4                                    &&
		  fake->cards[0].name > Nine                           &&
		  fake->cards[0].suit == fake->cards[1].suit           &&
		  (fake->cards[0].suit == fake->cards[2].suit          ||
			fake->cards[0].suit == fake->cards[3].suit	         ) )
	 { // four to a royal flush with one wild 2
		for(int zz=0;zz<5;zz++)
		{
		  if(GetCasPlayer(activeplayer)->pHand->hold[zz] == 1   &&
			  GetCasPlayer(activeplayer)->pHand->cards[zz].name == Two)
		  {
			 returnvalue = true;
		  }
		}
	 }
  }
  else if(ask->ExpertCode == 36)
  {
	 if(fake->cards[2].name > Nine && fake->inhand == 4)
	 { // four to a royal flush
		returnvalue = true;
	 }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 136)
  {
	 if(fake->cards[2].name > Nine                      &&
		 fake->inhand == 4                               &&
		 fake->cards[2].suit == fake->cards[3].suit      &&
		 fake->cards[0].name == Two                      &&
		 fake->cards[1].name == Two                        )
	 { // four to a royal flush with two wild 2's
		returnvalue = true;
	 }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 37)
  {
	 if(fake->inhand == 2 && fake->cards[0].name == Two && fake->cards[1].name == Two)
	 {//two deuces
		returnvalue = true;
	 }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 38)
  {
	 if(((wildHeld && GetCasPlayer(activeplayer)->pHand->instrght > 3) ||
		  (!wildHeld && fake->instrght > 3)) && fake->inhand == 4         )
	 {//four to straight
		returnvalue = true;
	 }
	 else
	 {returnvalue = false;}
  }
  GetCasPlayer(activeplayer)->pHand->highhand      = 0;
  GetCasPlayer(activeplayer)->pHand->highcard      = 0;
  GetCasPlayer(activeplayer)->pHand->toflush       = 0;
  GetCasPlayer(activeplayer)->pHand->instrght      = 0;
  GetCasPlayer(activeplayer)->pHand->outstrght     = 0;
  GetCasPlayer(activeplayer)->pHand->instrflsh     = 0;
  GetCasPlayer(activeplayer)->pHand->outstrflsh    = 0;
  GetCasPlayer(activeplayer)->pHand->lohighcard    = 0;
  GetCasPlayer(activeplayer)->pHand->lolowcard     = 0;
  GetCasPlayer(activeplayer)->pHand->lohand        = 0;
  GetCasPlayer(activeplayer)->pHand->lowcard       = 0;
  GetCasPlayer(activeplayer)->pHand->wildcount     = 0;
  fake->highhand      = 0;
  fake->highcard      = 0;
  fake->toflush       = 0;
  fake->instrght      = 0;
  fake->outstrght     = 0;
  fake->instrflsh     = 0;
  fake->outstrflsh    = 0;
  fake->lohighcard    = 0;
  fake->lolowcard     = 0;
  fake->lohand        = 0;
  fake->lowcard       = 0;
  fake->wildcount     = 0;
  fake->inhand        = 0;
  return returnvalue;
}
//*******************************************************************
