//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  accvpmw.cpp
//    Project Name:  acc
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  2.5    09/23/99    M.Perry    original baseline
//********************************************************************
#include "accvpmw.h"
#include "vp_cm.rh"
#include "cvpnames.rh"
#include "cvpplay.h"

#include "accvpgld.h"

//#include "tb1gld.h"
//#include "tb5gld.h"
//#include "tb25gld.h"
//#include "tb100gld.h"
//#include "jw1gld.h"
//#include "jw5gld.h"
//#include "jw25gld.h"
//#include "jw100gld.h"
//#include "jb1gld.h"
//#include "jb5gld.h"
//#include "jb25gld.h"
//#include "jb100gld.h"
//#include "jb1pgld.h"
//#include "dw1gld.h"
//#include "dw5gld.h"
//#include "dw25gld.h"
//#include "dw100gld.h"
//*******************************************************************
TACCVPModeWin::TACCVPModeWin(string modename,TPal *ppal,int16 sgt,int16 denomid,string title)
:TVideoPokerModeWin(modename,ppal,title),
 ModeSubGameType(sgt),
 ModeDenomID(denomid),
 idsGameLord(0),
 idsHuman0(0),
 idsHuman1(0),
 idsHuman2(0)
{
}
//*******************************************************************
TACCVPModeWin::~TACCVPModeWin()
{
}
//*******************************************************************
string TACCVPModeWin::GetDetName()
{
  return string("vp");
}
//*******************************************************************
int TACCVPModeWin::GetMenuID()
{
  return IDM_CASINO_VP;
}
//*******************************************************************
void TACCVPModeWin::SetupGObjIDS()
{
  if (GObjIDSInitialized) {return;}

  TVideoPokerModeWin::SetupGObjIDS();  //call up chain.

  switch (ModeSubGameType)
  {
    case cvpDeucesWild:switch(ModeDenomID)
                       {
                         case TMoney::did_1_00:
                                  idsGameLord = IDS_GL_VP_DW1;
                                  idsHuman0 = IDS_H1_VP_DW1;
                                  idsHuman1 = IDS_H2_VP_DW1;
                                  idsHuman2 = IDS_H3_VP_DW1;
                                  break;
                         case TMoney::did_5_00:
                                  idsGameLord = IDS_GL_VP_DW5;
                                  idsHuman0 = IDS_H1_VP_DW5;
                                  idsHuman1 = IDS_H2_VP_DW5;
                                  idsHuman2 = IDS_H3_VP_DW5;
                                  break;
                         case TMoney::did_25_00:
                                  idsGameLord = IDS_GL_VP_DW25;
                                  idsHuman0 = IDS_H1_VP_DW25;
                                  idsHuman1 = IDS_H2_VP_DW25;
                                  idsHuman2 = IDS_H3_VP_DW25;
                                  break;
                         case TMoney::did_100_00:
                                  idsGameLord = IDS_GL_VP_DW100;
                                  idsHuman0 = IDS_H1_VP_DW100;
                                  idsHuman1 = IDS_H2_VP_DW100;
                                  idsHuman2 = IDS_H3_VP_DW100;
                                  break;
                         default:break;
                       }
                       break;
    case cvpJokersWild:switch(ModeDenomID)
                       {
                         case TMoney::did_1_00:
                                  idsGameLord = IDS_GL_VP_JW1;
                                  idsHuman0 = IDS_H1_VP_JW1;
                                  idsHuman1 = IDS_H2_VP_JW1;
                                  idsHuman2 = IDS_H3_VP_JW1;
                                  break;
                         case TMoney::did_5_00:
                                  idsGameLord = IDS_GL_VP_JW5;
                                  idsHuman0 = IDS_H1_VP_JW5;
                                  idsHuman1 = IDS_H2_VP_JW5;
                                  idsHuman2 = IDS_H3_VP_JW5;
                                  break;
                         case TMoney::did_25_00:
                                   idsGameLord = IDS_GL_VP_JW25;
                                   idsHuman0 = IDS_H1_VP_JW25;
                                   idsHuman1 = IDS_H2_VP_JW25;
                                   idsHuman2 = IDS_H3_VP_JW25;
                                   break;
                         case TMoney::did_100_00:
                                    idsGameLord = IDS_GL_VP_JW100;
                                    idsHuman0 = IDS_H1_VP_JW100;
                                    idsHuman1 = IDS_H2_VP_JW100;
                                    idsHuman2 = IDS_H3_VP_JW100;
                                    break;
                         default:break;
                       }
                       break;
    case cvpJacksOrBetter:switch(ModeDenomID)
                          {
                            case TMoney::did_1_00:
                                     idsGameLord = IDS_GL_VP_JB1;
                                     idsHuman0 = IDS_H1_VP_JB1;
                                     idsHuman1 = IDS_H2_VP_JB1;
                                     idsHuman2 = IDS_H3_VP_JB1;
                                     break;
                            case TMoney::did_5_00:idsGameLord = IDS_GL_VP_JB5;
                                     idsHuman0 = IDS_H1_VP_JB5;
                                     idsHuman1 = IDS_H2_VP_JB5;
                                     idsHuman2 = IDS_H3_VP_JB5;
                                     break;
                            case TMoney::did_25_00:idsGameLord = IDS_GL_VP_JB25;
                                     idsHuman0 = IDS_H1_VP_JB25;
                                     idsHuman1 = IDS_H2_VP_JB25;
                                     idsHuman2 = IDS_H3_VP_JB25;
                                     break;
                            case TMoney::did_100_00:idsGameLord = IDS_GL_VP_JB100;
                                     idsHuman0 = IDS_H1_VP_JB100;
                                     idsHuman1 = IDS_H2_VP_JB100;
                                     idsHuman2 = IDS_H3_VP_JB100;
                                     break;
                            default:break;
                          }
                          break;
    case cvpTensOrBetter:switch(ModeDenomID)
                         {
                           case TMoney::did_1_00:idsGameLord = IDS_GL_VP_TB1;
                                    idsHuman0 = IDS_H1_VP_TB1;
                                    idsHuman1 = IDS_H2_VP_TB1;
                                    idsHuman2 = IDS_H3_VP_TB1;
                                    break;
                           case TMoney::did_5_00:idsGameLord = IDS_GL_VP_TB5;
                                    idsHuman0 = IDS_H1_VP_TB5;
                                    idsHuman1 = IDS_H2_VP_TB5;
                                    idsHuman2 = IDS_H3_VP_TB5;
                                    break;
                           case TMoney::did_25_00:idsGameLord = IDS_GL_VP_TB25;
                                     idsHuman0 = IDS_H1_VP_TB25;
                                     idsHuman1 = IDS_H2_VP_TB25;
                                     idsHuman2 = IDS_H3_VP_TB25;
                                     break;
                           case TMoney::did_100_00:idsGameLord = IDS_GL_VP_TB100;
                                      idsHuman0 = IDS_H1_VP_TB100;
                                      idsHuman1 = IDS_H2_VP_TB100;
                                      idsHuman2 = IDS_H3_VP_TB100;
                                      break;
                           default:break;
                         }
                         break;
    case cvpJacksProgressive:switch(ModeDenomID)
                             {
                               case TMoney::did_1_00:idsGameLord = IDS_GL_VP_JB1P;
                                        idsHuman0 = IDS_H1_VP_JB1P;
                                        idsHuman1 = IDS_H2_VP_JB1P;
                                        idsHuman2 = IDS_H3_VP_JB1P;
                                        break;
                               default:break;
                             }
                             break;
    default:break;
  }
}
//*******************************************************************
void TACCVPModeWin::SetupGObjStrings()
{
  if (GObjStringsInitialized) {return;}

  TVideoPokerModeWin::SetupGObjStrings();

  strGameLord = GetResString(idsGameLord);

  if (idsHuman0 > 0)
  {
    strHuman0 = GetResString(idsHuman0);
    if (idsHuman1 > 0)
    {
      strHuman1 = GetResString(idsHuman1);
      if (idsHuman2 > 0)
      {
        strHuman2 = GetResString(idsHuman2);
      }
    }
  }
}
//*******************************************************************
TGameObject *TACCVPModeWin::CreateGObj(TFileMode &fm,int16 id,void *psource)
{
  #if defined(OGLE_DEBUG_GOBJ)
  if (!GObjInfoInitialized)
  {
    ::MessageBox(NULL,
                 "GObjInfoInitialized == false",
                 "Warning! TACCVPModeWin::CreateGObj()",
                 MB_OK | MB_TASKMODAL);
  }

  if (ModeSubGameType != cvpDeucesWild &&
      ModeSubGameType != cvpJokersWild &&
      ModeSubGameType != cvpJacksOrBetter &&
      ModeSubGameType != cvpTensOrBetter &&
      ModeSubGameType != cvpJacksProgressive)
  {
    ::MessageBox(NULL,
                 "Invalid SubGameType",
                 "Error! TACCVPModeWin::CreateGObj()",
                 MB_OK | MB_TASKMODAL);
  }
  if (ModeDenomID != TMoney::did_1_00 &&
      ModeDenomID != TMoney::did_5_00 &&
      ModeDenomID != TMoney::did_25_00 &&
      ModeDenomID != TMoney::did_100_00)
  {
    ::MessageBox(NULL,
                 "Invalid SubGameType",
                 "Error! TACCVPModeWin::CreateGObj()",
                 MB_OK | MB_TASKMODAL);
  }

  if (fm == strGameLord && pLord != NULL)
  {
    ::MessageBox(NULL,
                 "GameLord already created",
                 "Error! TACCVPModeWin::CreateGObj()",
                 MB_OK | MB_TASKMODAL);
  }
  #endif

  if (fm == strHuman0)
  {
    GObj[0] = new TCasinoVPPlayer(this,fm,0);
    return GObj[0];
  }
  else if (fm == strHuman1)
  {
    GObj[1] = new TCasinoVPPlayer(this,fm,1);
    return GObj[1];
  }
  else if (fm == strHuman2)
  {
    GObj[2] = new TCasinoVPPlayer(this,fm,2);
    return GObj[2];
  }
  else if (fm == strGameLord && pLord == NULL)
  {
    pLord = new TACCVPGLord(this,fm,ModeSubGameType,ModeDenomID);
    return pLord;
  }
  else
  {
    #if defined(OGLE_DEBUG_GOBJ)
    string s = "gobj failed match:";
    s += fm.Name.GetStr();
    s += "\nCreating default TGameObject";
    s += "\nstrGameLord:";
    s += strGameLord;
    ::MessageBox(NULL,s.c_str(),"Warning! TACCVPMW::CreateGObj()",MB_OK | MB_TASKMODAL);
    #endif
    // if all else fails, then create a generic gobj.
  return new TGameObject(this,fm);
  }
}
//*******************************************************************
