//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  caccgfw.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.2     4/11/97    M.Perry    modified framewin hierarchy.
//  2.0    09/17/97    M.Perry    32-bit conversion.
//********************************************************************
#include "caccgfw.h"
#include "caccapp.h"
#include "cgametyp.h"
#include "ogame.h"
#include "accmenu.rh"
#include "casnames.rh"
#include "cabtdlg.rh"
//*******************************************************************
TACCMenuEnable::TACCMenuEnable(bool setvalues)
:TCasinoMenuEnable(false)
{
  if (setvalues)
  {
    SetAll(true);
  }
  CurrentMode =  IDS_M_LOBBY;
//  Lobby = false;
}
//*******************************************************************
TACCMenuEnable::~TACCMenuEnable()
{
}
//*******************************************************************
void TACCMenuEnable::SetAll(bool value)
{
  TCasinoMenuEnable::SetAll(value);
}
//*******************************************************************
void TACCMenuEnable::SetModes(bool value)
{
  TCasinoMenuEnable::SetModes(value);

//  Lobby = value;

  BlackJackOne = value;
  BlackJackTwo = value;
  BlackJackFour = value;
  BlackJackSix = value;

  Craps = value;

  Roulette = value;

  Keno = value;

  SlotsAladdin100 = value;
  SlotsAladdin500 = value;
  SlotsAladdin1P = value;

  SlotsParadise25 = value;
  SlotsParadise50 = value;
  SlotsParadise100 = value;

  SlotsJungle1 = value;
  SlotsJungle2 = value;
  SlotsJungle100 = value;

  SlotsPirate1 = value;
  SlotsPirate2 = value;
  SlotsPirate5 = value;
  SlotsPirate10 = value;
  SlotsPirate25 = value;
  SlotsPirate50 = value;
  SlotsPirate100 = value;

  SlotsLucky1 = value;
  SlotsLucky2 = value;
  SlotsLucky5 = value;
  SlotsLucky10 = value;
  SlotsLucky25 = value;
  SlotsLucky50 = value;

  SlotsSpirit1000 = value;

  SlotsJokers5 = value;
  SlotsJokers10 = value;
  SlotsJokers25 = value;
  SlotsJokers50 = value;
  SlotsJokers100 = value;

  SlotsTotal1 = value;
  SlotsTotal2 = value;
  SlotsTotal5 = value;
  SlotsTotal10 = value;
  SlotsTotal500 = value;
  SlotsTotal1000 = value;

  SlotsCherry1 = value;
  SlotsCherry2 = value;
  SlotsCherry5 = value;
  SlotsCherry10 = value;
  SlotsCherry25 = value;
  SlotsCherry50 = value;

  VPJack1 = value;
  VPJack5 = value;
  VPJack25 = value;
  VPJack100 = value;
  VPJack1P = value;

  VPDWild1 = value;
  VPDWild5 = value;
  VPDWild25 = value;
  VPDWild100 = value;

  VPJWild100 = value;

  VPTen1 = value;
  VPTen5 = value;
  VPTen25 = value;
  VPTen100 = value;

  VPJWild1 = value;
  VPJWild5 = value;
  VPJWild25 = value;
}
//*******************************************************************
//*******************************************************************
DEFINE_RESPONSE_TABLE1(TCasACCGameFrameWindow,TCasinoGameFrameWindow)
  // lobby
  EV_COMMAND(CM_GAMELOBBY,CmGameLobby),
  EV_COMMAND_ENABLE(CM_GAMELOBBY,CeGameLobby),

  // bj
  EV_COMMAND(CM_GAMEBLACKJACKONE,CmGameBlackJackOne),
  EV_COMMAND_ENABLE(CM_GAMEBLACKJACKONE,CeGameBlackJackOne),
  EV_COMMAND(CM_GAMEBLACKJACKTWO,CmGameBlackJackTwo),
  EV_COMMAND_ENABLE(CM_GAMEBLACKJACKTWO,CeGameBlackJackTwo),
  EV_COMMAND(CM_GAMEBLACKJACKFOUR,CmGameBlackJackFour),
  EV_COMMAND_ENABLE(CM_GAMEBLACKJACKFOUR,CeGameBlackJackFour),
  EV_COMMAND(CM_GAMEBLACKJACKSIX,CmGameBlackJackSix),
  EV_COMMAND_ENABLE(CM_GAMEBLACKJACKSIX,CeGameBlackJackSix),
  // craps
  EV_COMMAND(CM_GAMECRAPS,CmGameCraps),
  EV_COMMAND_ENABLE(CM_GAMECRAPS,CeGameCraps),
  // keno
  EV_COMMAND(CM_GAMEKENO,CmGameKeno),
  EV_COMMAND_ENABLE(CM_GAMEKENO,CeGameKeno),
  // roulette
  EV_COMMAND(CM_GAMEROULETTE,CmGameRoulette),
  EV_COMMAND_ENABLE(CM_GAMEROULETTE,CeGameRoulette),

  EV_COMMAND(CM_OPTIONSLOBBY_SHOWINTRO ,CmShowIntro),
  EV_COMMAND_ENABLE(CM_OPTIONSLOBBY_SHOWINTRO ,CeShowIntro),

  // vp tb
  EV_COMMAND(CM_GAMEVPTEN1,CmGameVPTen1),
  EV_COMMAND_ENABLE(CM_GAMEVPTEN1,CeGameVPTen1),
  EV_COMMAND(CM_GAMEVPTEN5,CmGameVPTen5),
  EV_COMMAND_ENABLE(CM_GAMEVPTEN5,CeGameVPTen5),
  EV_COMMAND(CM_GAMEVPTEN100,CmGameVPTen100),
  EV_COMMAND_ENABLE(CM_GAMEVPTEN100,CeGameVPTen100),
  EV_COMMAND(CM_GAMEVPTEN25,CmGameVPTen25),
  EV_COMMAND_ENABLE(CM_GAMEVPTEN25,CeGameVPTen25),
  // vp jb
  EV_COMMAND(CM_GAMEVPJACK1,CmGameVPJack1),
  EV_COMMAND_ENABLE(CM_GAMEVPJACK1,CeGameVPJack1),
  EV_COMMAND(CM_GAMEVPJACK5,CmGameVPJack5),
  EV_COMMAND_ENABLE(CM_GAMEVPJACK5,CeGameVPJack5),
  EV_COMMAND(CM_GAMEVPJACK100,CmGameVPJack100),
  EV_COMMAND_ENABLE(CM_GAMEVPJACK100,CeGameVPJack100),
  EV_COMMAND(CM_GAMEVPJACK25,CmGameVPJack25),
  EV_COMMAND_ENABLE(CM_GAMEVPJACK25,CeGameVPJack25),
  EV_COMMAND(CM_GAMEVPJACK1P,CmGameVPJack1P),
  EV_COMMAND_ENABLE(CM_GAMEVPJACK1P,CeGameVPJack1P),
  // vp dw
  EV_COMMAND(CM_GAMEVPDWILD1,CmGameVPDWild1),
  EV_COMMAND_ENABLE(CM_GAMEVPDWILD1,CeGameVPDWild1),
  EV_COMMAND(CM_GAMEVPDWILD5,CmGameVPDWild5),
  EV_COMMAND_ENABLE(CM_GAMEVPDWILD5,CeGameVPDWild5),
  EV_COMMAND(CM_GAMEVPDWILD100,CmGameVPDWild100),
  EV_COMMAND_ENABLE(CM_GAMEVPDWILD100,CeGameVPDWild100),
  EV_COMMAND(CM_GAMEVPDWILD25,CmGameVPDWild25),
  EV_COMMAND_ENABLE(CM_GAMEVPDWILD25,CeGameVPDWild25),
  // vp jw
  EV_COMMAND(CM_GAMEVPJWILD1,CmGameVPJWild1),
  EV_COMMAND_ENABLE(CM_GAMEVPJWILD1,CeGameVPJWild1),
  EV_COMMAND(CM_GAMEVPJWILD5,CmGameVPJWild5),
  EV_COMMAND_ENABLE(CM_GAMEVPJWILD5,CeGameVPJWild5),
  EV_COMMAND(CM_GAMEVPJWILD25,CmGameVPJWild25),
  EV_COMMAND_ENABLE(CM_GAMEVPJWILD25,CeGameVPJWild25),
  EV_COMMAND(CM_GAMEVPJWILD100,CmGameVPJWild100),
  EV_COMMAND_ENABLE(CM_GAMEVPJWILD100,CeGameVPJWild100),

  EV_COMMAND(CM_GAMESLOTSALADDIN500,CmGameSlotsAladdin500),
  EV_COMMAND_ENABLE(CM_GAMESLOTSALADDIN500,CeGameSlotsAladdin500),

  EV_COMMAND(CM_GAMESLOTSPARADISE25,CmGameSlotsParadise25),
  EV_COMMAND_ENABLE(CM_GAMESLOTSPARADISE25,CeGameSlotsParadise25),
  EV_COMMAND(CM_GAMESLOTSPARADISE50,CmGameSlotsParadise50),
  EV_COMMAND_ENABLE(CM_GAMESLOTSPARADISE50,CeGameSlotsParadise50),
  EV_COMMAND(CM_GAMESLOTSPARADISE100,CmGameSlotsParadise100),
  EV_COMMAND_ENABLE(CM_GAMESLOTSPARADISE100,CeGameSlotsParadise100),

  EV_COMMAND(CM_GAMESLOTSPIRATE1,CmGameSlotsPirate1),
  EV_COMMAND_ENABLE(CM_GAMESLOTSPIRATE1,CeGameSlotsPirate1),
  EV_COMMAND(CM_GAMESLOTSPIRATE2,CmGameSlotsPirate2),
  EV_COMMAND_ENABLE(CM_GAMESLOTSPIRATE2,CeGameSlotsPirate2),
  EV_COMMAND(CM_GAMESLOTSPIRATE5,CmGameSlotsPirate5),
  EV_COMMAND_ENABLE(CM_GAMESLOTSPIRATE5,CeGameSlotsPirate5),
  EV_COMMAND(CM_GAMESLOTSPIRATE10,CmGameSlotsPirate10),
  EV_COMMAND_ENABLE(CM_GAMESLOTSPIRATE10,CeGameSlotsPirate10),
  EV_COMMAND(CM_GAMESLOTSPIRATE25,CmGameSlotsPirate25),
  EV_COMMAND_ENABLE(CM_GAMESLOTSPIRATE25,CeGameSlotsPirate25),
  EV_COMMAND(CM_GAMESLOTSPIRATE50,CmGameSlotsPirate50),
  EV_COMMAND_ENABLE(CM_GAMESLOTSPIRATE50,CeGameSlotsPirate50),
  EV_COMMAND(CM_GAMESLOTSPIRATE100,CmGameSlotsPirate100),
  EV_COMMAND_ENABLE(CM_GAMESLOTSPIRATE100,CeGameSlotsPirate100),

  EV_COMMAND(CM_GAMESLOTSLUCKY1,CmGameSlotsLucky1),
  EV_COMMAND_ENABLE(CM_GAMESLOTSLUCKY1,CeGameSlotsLucky1),
  EV_COMMAND(CM_GAMESLOTSLUCKY2,CmGameSlotsLucky2),
  EV_COMMAND_ENABLE(CM_GAMESLOTSLUCKY2,CeGameSlotsLucky2),
  EV_COMMAND(CM_GAMESLOTSLUCKY5,CmGameSlotsLucky5),
  EV_COMMAND_ENABLE(CM_GAMESLOTSLUCKY5,CeGameSlotsLucky5),
  EV_COMMAND(CM_GAMESLOTSLUCKY10,CmGameSlotsLucky10),
  EV_COMMAND_ENABLE(CM_GAMESLOTSLUCKY10,CeGameSlotsLucky10),
  EV_COMMAND(CM_GAMESLOTSLUCKY25,CmGameSlotsLucky25),
  EV_COMMAND_ENABLE(CM_GAMESLOTSLUCKY25,CeGameSlotsLucky25),
  EV_COMMAND(CM_GAMESLOTSLUCKY50,CmGameSlotsLucky50),
  EV_COMMAND_ENABLE(CM_GAMESLOTSLUCKY50,CeGameSlotsLucky50),

  EV_COMMAND(CM_GAMESLOTSJOKERS10,CmGameSlotsJokers10),
  EV_COMMAND_ENABLE(CM_GAMESLOTSJOKERS10,CeGameSlotsJokers10),
  EV_COMMAND(CM_GAMESLOTSJOKERS50,CmGameSlotsJokers50),
  EV_COMMAND_ENABLE(CM_GAMESLOTSJOKERS50,CeGameSlotsJokers50),
  EV_COMMAND(CM_GAMESLOTSJOKERS100,CmGameSlotsJokers100),
  EV_COMMAND_ENABLE(CM_GAMESLOTSJOKERS100,CeGameSlotsJokers100),

  EV_COMMAND(CM_GAMESLOTSTOTAL1,CmGameSlotsTotal1),
  EV_COMMAND_ENABLE(CM_GAMESLOTSTOTAL1,CeGameSlotsTotal1),
  EV_COMMAND(CM_GAMESLOTSTOTAL2,CmGameSlotsTotal2),
  EV_COMMAND_ENABLE(CM_GAMESLOTSTOTAL2,CeGameSlotsTotal2),
  EV_COMMAND(CM_GAMESLOTSTOTAL5,CmGameSlotsTotal5),
  EV_COMMAND_ENABLE(CM_GAMESLOTSTOTAL5,CeGameSlotsTotal5),
  EV_COMMAND(CM_GAMESLOTSTOTAL10,CmGameSlotsTotal10),
  EV_COMMAND_ENABLE(CM_GAMESLOTSTOTAL10,CeGameSlotsTotal10),
  EV_COMMAND(CM_GAMESLOTSTOTAL500,CmGameSlotsTotal500),
  EV_COMMAND_ENABLE(CM_GAMESLOTSTOTAL500,CeGameSlotsTotal500),
  EV_COMMAND(CM_GAMESLOTSTOTAL1000,CmGameSlotsTotal1000),
  EV_COMMAND_ENABLE(CM_GAMESLOTSTOTAL1000,CeGameSlotsTotal1000),

  EV_COMMAND(CM_GAMESLOTSCHERRY10,CmGameSlotsCherry10),
  EV_COMMAND_ENABLE(CM_GAMESLOTSCHERRY10,CeGameSlotsCherry10),
  EV_COMMAND(CM_GAMESLOTSCHERRY25,CmGameSlotsCherry25),
  EV_COMMAND_ENABLE(CM_GAMESLOTSCHERRY25,CeGameSlotsCherry25),
  EV_COMMAND(CM_GAMESLOTSCHERRY50,CmGameSlotsCherry50),
  EV_COMMAND_ENABLE(CM_GAMESLOTSCHERRY50,CeGameSlotsCherry50),

  EV_COMMAND(CM_GAMESLOTSJUNGLE100,CmGameSlotsJungle100),
  EV_COMMAND_ENABLE(CM_GAMESLOTSJUNGLE100,CeGameSlotsJungle100),

  EV_COMMAND(CM_GAMESLOTSALADDIN1P,CmGameSlotsAladdin1P),
  EV_COMMAND_ENABLE(CM_GAMESLOTSALADDIN1P,CeGameSlotsAladdin1P),
  EV_COMMAND(CM_GAMESLOTSALADDIN100,CmGameSlotsAladdin100),
  EV_COMMAND_ENABLE(CM_GAMESLOTSALADDIN100,CeGameSlotsAladdin100),

  EV_COMMAND(CM_GAMESLOTSSPIRIT1000,CmGameSlotsSpirit1000),
  EV_COMMAND_ENABLE(CM_GAMESLOTSSPIRIT1000,CeGameSlotsSpirit1000),

  EV_COMMAND(CM_GAMESLOTSJOKERS5,CmGameSlotsJokers5),
  EV_COMMAND_ENABLE(CM_GAMESLOTSJOKERS5,CeGameSlotsJokers5),

  EV_COMMAND(CM_GAMESLOTSJOKERS25,CmGameSlotsJokers25),
  EV_COMMAND_ENABLE(CM_GAMESLOTSJOKERS25,CeGameSlotsJokers25),

  EV_COMMAND(CM_GAMESLOTSCHERRY1,CmGameSlotsCherry1),
  EV_COMMAND_ENABLE(CM_GAMESLOTSCHERRY1,CeGameSlotsCherry1),
  EV_COMMAND(CM_GAMESLOTSCHERRY2,CmGameSlotsCherry2),
  EV_COMMAND_ENABLE(CM_GAMESLOTSCHERRY2,CeGameSlotsCherry2),
  EV_COMMAND(CM_GAMESLOTSCHERRY5,CmGameSlotsCherry5),
  EV_COMMAND_ENABLE(CM_GAMESLOTSCHERRY5,CeGameSlotsCherry5),

  EV_COMMAND(CM_GAMESLOTSJUNGLE1,CmGameSlotsJungle1),
  EV_COMMAND_ENABLE(CM_GAMESLOTSJUNGLE1,CeGameSlotsJungle1),
  EV_COMMAND(CM_GAMESLOTSJUNGLE2,CmGameSlotsJungle2),
  EV_COMMAND_ENABLE(CM_GAMESLOTSJUNGLE2,CeGameSlotsJungle2),
END_RESPONSE_TABLE;
//*******************************************************************
TCasACCGameFrameWindow::TCasACCGameFrameWindow(TCasACCApp *pcasaccapp,const char *szTitle)
:TCasinoGameFrameWindow(pcasaccapp,szTitle,true,false)
{
//  idsIntro = IDS_M_INTRO;
//  SetupModeStrings();
  FadeIn = false;
  GetIniShowIntro();
  DoStyle();
  DoIcon();
  DoMenu();
  BJNumDecks = cbj1Deck;

  // mrp - v2.5 - 09/23/99 - 
  StartupModeIndex = -1;
//  if (ShowIntro)
//  {
//    StartupModeIndex = GetGame()->GetModeIndex(strIntro);//"s1intro");
//  }
//  else
//  {
//    StartupModeIndex = GetGame()->GetModeIndex(strLobby);//TAppString(IDS_M_LOBBY));
//  }
}
//*******************************************************************
TCasACCGameFrameWindow::~TCasACCGameFrameWindow()
{
}
//*******************************************************************
void TCasACCGameFrameWindow::SwitchGameModes(string &name)
{
  SwitchGameModes(GetModeIndex(name));
}
//*******************************************************************
void TCasACCGameFrameWindow::CreateMenuEnable()
{
  PMenuEnable = new TACCMenuEnable(true);
}
//*******************************************************************
int TCasACCGameFrameWindow::GetAboutID()
{
//  return IDB_CASINO_ABOUT_V1_2;
  return IDB_CASINO_ABOUT;
}
//*******************************************************************
int TCasACCGameFrameWindow::GetMenuID()
{
  return IDM_CASINO_DEF;
}
//*******************************************************************
void TCasACCGameFrameWindow::DoMenu()
{
  AssignMenu(IDM_CASINO_DEF);
}
//*******************************************************************
void TCasACCGameFrameWindow::SwitchGameModes(int16 modeindex)
{
  if (!IsValidModeIndex(modeindex))
  {
	 MessageBox("Internal error, no switch attempted","Switch Mode",MB_OK);
  }
  else
  {
	 if (!SwitchModes(modeindex))
	 {
		MessageBox("Internal error, switching to startup mode","Switch Mode",MB_OK);
		SwitchModes(GetModeIndex(strLobby));//TAppString(IDS_M_LOBBY)));
	 }
  }
}
//*******************************************************************
void TCasACCGameFrameWindow::CmGameLobby()
{
  SwitchGameModes(strLobby);
}
//*******************************************************************
void TCasACCGameFrameWindow::CeGameLobby(TCommandEnabler &enabler)
{
  enabler.Enable(GetACCMenuEnable()->Lobby);
  if (GetACCMenuEnable()->GetCurrentMode() == IDS_M_LOBBY)
  {
    enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
    enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TCasACCGameFrameWindow::CmGameBlackJackOne()
{
  SwitchBJ(cbj1Deck);
}
//*******************************************************************
void TCasACCGameFrameWindow::CeGameBlackJackOne(TCommandEnabler &enabler)
{
  enabler.Enable(GetACCMenuEnable()->BlackJackOne);
  if (GetACCMenuEnable()->GetCurrentMode() == IDS_M_BJ1 && BJNumDecks == cbj1Deck)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TCasACCGameFrameWindow::CmGameBlackJackTwo()
{
  SwitchBJ(cbj2Deck);
}
//*******************************************************************
void TCasACCGameFrameWindow::CeGameBlackJackTwo(TCommandEnabler &enabler)
{
  enabler.Enable(GetACCMenuEnable()->BlackJackTwo);
  if (GetACCMenuEnable()->GetCurrentMode() == IDS_M_BJ1 && BJNumDecks == cbj2Deck)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TCasACCGameFrameWindow::CmGameBlackJackFour()
{
  SwitchBJ(cbj4Deck);
}
//*******************************************************************
void TCasACCGameFrameWindow::CeGameBlackJackFour(TCommandEnabler &enabler)
{
  enabler.Enable(GetACCMenuEnable()->BlackJackFour);
  if (GetACCMenuEnable()->GetCurrentMode() == IDS_M_BJ1 && BJNumDecks == cbj4Deck)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TCasACCGameFrameWindow::CmGameBlackJackSix()
{
  SwitchBJ(cbj6Deck);
}
//*******************************************************************
void TCasACCGameFrameWindow::CeGameBlackJackSix(TCommandEnabler &enabler)
{
  enabler.Enable(GetACCMenuEnable()->BlackJackSix);
  if (GetACCMenuEnable()->GetCurrentMode() == IDS_M_BJ1 && BJNumDecks == cbj6Deck)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TCasACCGameFrameWindow::CmGameCraps()
{
  SwitchGameModes(strCraps);
}
//*******************************************************************
void TCasACCGameFrameWindow::CeGameCraps(TCommandEnabler &enabler)
{
  enabler.Enable(GetACCMenuEnable()->Craps);
  if (GetACCMenuEnable()->GetCurrentMode() == IDS_M_CRAPS)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TCasACCGameFrameWindow::CmGameKeno()
{
  SwitchGameModes(strKeno);
}
//*******************************************************************
void TCasACCGameFrameWindow::CeGameKeno(TCommandEnabler &enabler)
{
  enabler.Enable(GetACCMenuEnable()->Keno);
  if (GetACCMenuEnable()->GetCurrentMode() == IDS_M_KENO)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TCasACCGameFrameWindow::CmGameRoulette()
{
  SwitchGameModes(strRoulette);
}
//*******************************************************************
void TCasACCGameFrameWindow::CeGameRoulette(TCommandEnabler &enabler)
{
  enabler.Enable(GetACCMenuEnable()->Roulette);
  if (GetACCMenuEnable()->GetCurrentMode() == IDS_M_ROULETTE)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TCasACCGameFrameWindow::CmGameSlotsAladdin1P()
{
  SwitchGameModes(strSlotsAladdin1P);
}
//*******************************************************************
void TCasACCGameFrameWindow::CeGameSlotsAladdin1P(TCommandEnabler &enabler)
{
  enabler.Enable(GetACCMenuEnable()->SlotsAladdin1P);
  if (GetACCMenuEnable()->GetCurrentMode() == IDS_M_SL_ALADDIN1P)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TCasACCGameFrameWindow::CmGameSlotsAladdin100()
{
  SwitchGameModes(strSlotsAladdin100);
}
//*******************************************************************
void TCasACCGameFrameWindow::CeGameSlotsAladdin100(TCommandEnabler &enabler)
{
  enabler.Enable(GetACCMenuEnable()->SlotsAladdin100);
  if (GetACCMenuEnable()->GetCurrentMode() == IDS_M_SL_ALADDIN100)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TCasACCGameFrameWindow::CmGameSlotsAladdin500()
{
  SwitchGameModes(strSlotsAladdin500);
}
//*******************************************************************
void TCasACCGameFrameWindow::CeGameSlotsAladdin500(TCommandEnabler &enabler)
{
  enabler.Enable(GetACCMenuEnable()->SlotsAladdin500);
  if (GetACCMenuEnable()->GetCurrentMode() == IDS_M_SL_ALADDIN500)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TCasACCGameFrameWindow::CmGameSlotsParadise25()
{
  SwitchGameModes(strSlotsParadise25);
}
//*******************************************************************
void TCasACCGameFrameWindow::CeGameSlotsParadise25(TCommandEnabler &enabler)
{
  enabler.Enable(GetACCMenuEnable()->SlotsParadise25);
  if (GetACCMenuEnable()->GetCurrentMode() == IDS_M_SL_PARADISE25)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TCasACCGameFrameWindow::CmGameSlotsParadise50()
{
  SwitchGameModes(strSlotsParadise50);
}
//*******************************************************************
void TCasACCGameFrameWindow::CeGameSlotsParadise50(TCommandEnabler &enabler)
{
  enabler.Enable(GetACCMenuEnable()->SlotsParadise50);
  if (GetACCMenuEnable()->GetCurrentMode() == IDS_M_SL_PARADISE50)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TCasACCGameFrameWindow::CmGameSlotsParadise100()
{
  SwitchGameModes(strSlotsParadise100);
}
//*******************************************************************
void TCasACCGameFrameWindow::CeGameSlotsParadise100(TCommandEnabler &enabler)
{
  enabler.Enable(GetACCMenuEnable()->SlotsParadise100);
  if (GetACCMenuEnable()->GetCurrentMode() == IDS_M_SL_PARADISE100)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TCasACCGameFrameWindow::CmGameSlotsPirate1()
{
  SwitchGameModes(strSlotsPirate1);
}
//*******************************************************************
void TCasACCGameFrameWindow::CeGameSlotsPirate1(TCommandEnabler &enabler)
{
  enabler.Enable(GetACCMenuEnable()->SlotsPirate1);
  if (GetACCMenuEnable()->GetCurrentMode() == IDS_M_SL_PIRATE1)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TCasACCGameFrameWindow::CmGameSlotsPirate2()
{
  SwitchGameModes(strSlotsPirate2);
}
//*******************************************************************
void TCasACCGameFrameWindow::CeGameSlotsPirate2(TCommandEnabler &enabler)
{
  enabler.Enable(GetACCMenuEnable()->SlotsPirate2);
  if (GetACCMenuEnable()->GetCurrentMode() == IDS_M_SL_PIRATE2)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TCasACCGameFrameWindow::CmGameSlotsPirate5()
{
  SwitchGameModes(strSlotsPirate5);
}
//*******************************************************************
void TCasACCGameFrameWindow::CeGameSlotsPirate5(TCommandEnabler &enabler)
{
  enabler.Enable(GetACCMenuEnable()->SlotsPirate5);
  if (GetACCMenuEnable()->GetCurrentMode() == IDS_M_SL_PIRATE5)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TCasACCGameFrameWindow::CmGameSlotsPirate10()
{
  SwitchGameModes(strSlotsPirate10);
}
//*******************************************************************
void TCasACCGameFrameWindow::CeGameSlotsPirate10(TCommandEnabler &enabler)
{
  enabler.Enable(GetACCMenuEnable()->SlotsPirate10);
  if (GetACCMenuEnable()->GetCurrentMode() == IDS_M_SL_PIRATE10)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TCasACCGameFrameWindow::CmGameSlotsPirate25()
{
  SwitchGameModes(strSlotsPirate25);
}
//*******************************************************************
void TCasACCGameFrameWindow::CeGameSlotsPirate25(TCommandEnabler &enabler)
{
  enabler.Enable(GetACCMenuEnable()->SlotsPirate25);
  if (GetACCMenuEnable()->GetCurrentMode() == IDS_M_SL_PIRATE25)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TCasACCGameFrameWindow::CmGameSlotsPirate50()
{
  SwitchGameModes(strSlotsPirate50);
}
//*******************************************************************
void TCasACCGameFrameWindow::CeGameSlotsPirate50(TCommandEnabler &enabler)
{
  enabler.Enable(GetACCMenuEnable()->SlotsPirate50);
  if (GetACCMenuEnable()->GetCurrentMode() == IDS_M_SL_PIRATE50)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TCasACCGameFrameWindow::CmGameSlotsPirate100()
{
  SwitchGameModes(strSlotsPirate100);
}
//*******************************************************************
void TCasACCGameFrameWindow::CeGameSlotsPirate100(TCommandEnabler &enabler)
{
  enabler.Enable(GetACCMenuEnable()->SlotsPirate100);
  if (GetACCMenuEnable()->GetCurrentMode() == IDS_M_SL_PIRATE100)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TCasACCGameFrameWindow::CmGameSlotsLucky1()
{
  SwitchGameModes(strSlotsLucky1);
}
//*******************************************************************
void TCasACCGameFrameWindow::CeGameSlotsLucky1(TCommandEnabler &enabler)
{
  enabler.Enable(GetACCMenuEnable()->SlotsLucky1);
  if (GetACCMenuEnable()->GetCurrentMode() == IDS_M_SL_LUCKY1)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TCasACCGameFrameWindow::CmGameSlotsLucky2()
{
  SwitchGameModes(strSlotsLucky2);
}
//*******************************************************************
void TCasACCGameFrameWindow::CeGameSlotsLucky2(TCommandEnabler &enabler)
{
  enabler.Enable(GetACCMenuEnable()->SlotsLucky2);
  if (GetACCMenuEnable()->GetCurrentMode() == IDS_M_SL_LUCKY2)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TCasACCGameFrameWindow::CmGameSlotsLucky5()
{
  SwitchGameModes(strSlotsLucky5);
}
//*******************************************************************
void TCasACCGameFrameWindow::CeGameSlotsLucky5(TCommandEnabler &enabler)
{
  enabler.Enable(GetACCMenuEnable()->SlotsLucky5);
  if (GetACCMenuEnable()->GetCurrentMode() == IDS_M_SL_LUCKY5)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TCasACCGameFrameWindow::CmGameSlotsLucky10()
{
  SwitchGameModes(strSlotsLucky10);
}
//*******************************************************************
void TCasACCGameFrameWindow::CeGameSlotsLucky10(TCommandEnabler &enabler)
{
  enabler.Enable(GetACCMenuEnable()->SlotsLucky10);
  if (GetACCMenuEnable()->GetCurrentMode() == IDS_M_SL_LUCKY10)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TCasACCGameFrameWindow::CmGameSlotsLucky25()
{
  SwitchGameModes(strSlotsLucky25);
}
//*******************************************************************
void TCasACCGameFrameWindow::CeGameSlotsLucky25(TCommandEnabler &enabler)
{
  enabler.Enable(GetACCMenuEnable()->SlotsLucky25);
  if (GetACCMenuEnable()->GetCurrentMode() == IDS_M_SL_LUCKY25)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TCasACCGameFrameWindow::CmGameSlotsLucky50()
{
  SwitchGameModes(strSlotsLucky50);
}
//*******************************************************************
void TCasACCGameFrameWindow::CeGameSlotsLucky50(TCommandEnabler &enabler)
{
  enabler.Enable(GetACCMenuEnable()->SlotsLucky50);
  if (GetACCMenuEnable()->GetCurrentMode() == IDS_M_SL_LUCKY50)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TCasACCGameFrameWindow::CmGameSlotsSpirit1000()
{
  SwitchGameModes(strSlotsSpirit1000);
}
//*******************************************************************
void TCasACCGameFrameWindow::CeGameSlotsSpirit1000(TCommandEnabler &enabler)
{
  enabler.Enable(GetACCMenuEnable()->SlotsSpirit1000);
  if (GetACCMenuEnable()->GetCurrentMode() == IDS_M_SL_SPIRIT1000)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TCasACCGameFrameWindow::CmGameSlotsJokers5()
{
  SwitchGameModes(strSlotsJokers5);
}
//*******************************************************************
void TCasACCGameFrameWindow::CeGameSlotsJokers5(TCommandEnabler &enabler)
{
  enabler.Enable(GetACCMenuEnable()->SlotsJokers5);
  if (GetACCMenuEnable()->GetCurrentMode() == IDS_M_SL_JOKER5)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TCasACCGameFrameWindow::CmGameSlotsJokers10()
{
  SwitchGameModes(strSlotsJokers10);
}
//*******************************************************************
void TCasACCGameFrameWindow::CeGameSlotsJokers10(TCommandEnabler &enabler)
{
  enabler.Enable(GetACCMenuEnable()->SlotsJokers10);
  if (GetACCMenuEnable()->GetCurrentMode() == IDS_M_SL_JOKER10)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TCasACCGameFrameWindow::CmGameSlotsJokers25()
{
  SwitchGameModes(strSlotsJokers25);
}
//*******************************************************************
void TCasACCGameFrameWindow::CeGameSlotsJokers25(TCommandEnabler &enabler)
{
  enabler.Enable(GetACCMenuEnable()->SlotsJokers25);
  if (GetACCMenuEnable()->GetCurrentMode() == IDS_M_SL_JOKER25)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TCasACCGameFrameWindow::CmGameSlotsJokers50()
{
  SwitchGameModes(strSlotsJokers50);
}
//*******************************************************************
void TCasACCGameFrameWindow::CeGameSlotsJokers50(TCommandEnabler &enabler)
{
  enabler.Enable(GetACCMenuEnable()->SlotsJokers50);
  if (GetACCMenuEnable()->GetCurrentMode() == IDS_M_SL_JOKER50)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TCasACCGameFrameWindow::CmGameSlotsJokers100()
{
  SwitchGameModes(strSlotsJokers100);
}
//*******************************************************************
void TCasACCGameFrameWindow::CeGameSlotsJokers100(TCommandEnabler &enabler)
{
  enabler.Enable(GetACCMenuEnable()->SlotsJokers100);
  if (GetACCMenuEnable()->GetCurrentMode() == IDS_M_SL_JOKER100)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TCasACCGameFrameWindow::CmGameSlotsTotal1()
{
  SwitchGameModes(strSlotsTotal1);
}
//*******************************************************************
void TCasACCGameFrameWindow::CeGameSlotsTotal1(TCommandEnabler &enabler)
{
  enabler.Enable(GetACCMenuEnable()->SlotsTotal1);
  if (GetACCMenuEnable()->GetCurrentMode() == IDS_M_SL_TOTAL1)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TCasACCGameFrameWindow::CmGameSlotsTotal2()
{
  SwitchGameModes(strSlotsTotal2);
}
//*******************************************************************
void TCasACCGameFrameWindow::CeGameSlotsTotal2(TCommandEnabler &enabler)
{
  enabler.Enable(GetACCMenuEnable()->SlotsTotal2);
  if (GetACCMenuEnable()->GetCurrentMode() == IDS_M_SL_TOTAL2)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TCasACCGameFrameWindow::CmGameSlotsTotal5()
{
  SwitchGameModes(strSlotsTotal5);
}
//*******************************************************************
void TCasACCGameFrameWindow::CeGameSlotsTotal5(TCommandEnabler &enabler)
{
  enabler.Enable(GetACCMenuEnable()->SlotsTotal5);
  if (GetACCMenuEnable()->GetCurrentMode() == IDS_M_SL_TOTAL5)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TCasACCGameFrameWindow::CmGameSlotsTotal10()
{
  SwitchGameModes(strSlotsTotal10);
}
//*******************************************************************
void TCasACCGameFrameWindow::CeGameSlotsTotal10(TCommandEnabler &enabler)
{
  enabler.Enable(GetACCMenuEnable()->SlotsTotal10);
  if (GetACCMenuEnable()->GetCurrentMode() == IDS_M_SL_TOTAL10)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TCasACCGameFrameWindow::CmGameSlotsTotal500()
{
  SwitchGameModes(strSlotsTotal500);
}
//*******************************************************************
void TCasACCGameFrameWindow::CeGameSlotsTotal500(TCommandEnabler &enabler)
{
  enabler.Enable(GetACCMenuEnable()->SlotsTotal500);
  if (GetACCMenuEnable()->GetCurrentMode() == IDS_M_SL_TOTAL500)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TCasACCGameFrameWindow::CmGameSlotsTotal1000()
{
  SwitchGameModes(strSlotsTotal1000);
}
//*******************************************************************
void TCasACCGameFrameWindow::CeGameSlotsTotal1000(TCommandEnabler &enabler)
{
  enabler.Enable(GetACCMenuEnable()->SlotsTotal1000);
  if (GetACCMenuEnable()->GetCurrentMode() == IDS_M_SL_TOTAL1000)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TCasACCGameFrameWindow::CmGameSlotsCherry1()
{
  SwitchGameModes(strSlotsCherry1);
}
//*******************************************************************
void TCasACCGameFrameWindow::CeGameSlotsCherry1(TCommandEnabler &enabler)
{
  enabler.Enable(GetACCMenuEnable()->SlotsCherry1);
  if (GetACCMenuEnable()->GetCurrentMode() == IDS_M_SL_CHERRY1)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TCasACCGameFrameWindow::CmGameSlotsCherry2()
{
  SwitchGameModes(strSlotsCherry2);
}
//*******************************************************************
void TCasACCGameFrameWindow::CeGameSlotsCherry2(TCommandEnabler &enabler)
{
  enabler.Enable(GetACCMenuEnable()->SlotsCherry2);
  if (GetACCMenuEnable()->GetCurrentMode() == IDS_M_SL_CHERRY2)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TCasACCGameFrameWindow::CmGameSlotsCherry5()
{
  SwitchGameModes(strSlotsCherry5);
}
//*******************************************************************
void TCasACCGameFrameWindow::CeGameSlotsCherry5(TCommandEnabler &enabler)
{
  enabler.Enable(GetACCMenuEnable()->SlotsCherry5);
  if (GetACCMenuEnable()->GetCurrentMode() == IDS_M_SL_CHERRY5)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TCasACCGameFrameWindow::CmGameSlotsCherry10()
{
  SwitchGameModes(strSlotsCherry10);
}
//*******************************************************************
void TCasACCGameFrameWindow::CeGameSlotsCherry10(TCommandEnabler &enabler)
{
  enabler.Enable(GetACCMenuEnable()->SlotsCherry10);
  if (GetACCMenuEnable()->GetCurrentMode() == IDS_M_SL_CHERRY10)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TCasACCGameFrameWindow::CmGameSlotsCherry25()
{
  SwitchGameModes(strSlotsCherry25);
}
//*******************************************************************
void TCasACCGameFrameWindow::CeGameSlotsCherry25(TCommandEnabler &enabler)
{
  enabler.Enable(GetACCMenuEnable()->SlotsCherry25);
  if (GetACCMenuEnable()->GetCurrentMode() == IDS_M_SL_CHERRY25)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TCasACCGameFrameWindow::CmGameSlotsCherry50()
{
  SwitchGameModes(strSlotsCherry50);
}
//*******************************************************************
void TCasACCGameFrameWindow::CeGameSlotsCherry50(TCommandEnabler &enabler)
{
  enabler.Enable(GetACCMenuEnable()->SlotsCherry50);
  if (GetACCMenuEnable()->GetCurrentMode() == IDS_M_SL_CHERRY50)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TCasACCGameFrameWindow::CmGameSlotsJungle1()
{
  SwitchGameModes(strSlotsJungle1);
}
//*******************************************************************
void TCasACCGameFrameWindow::CeGameSlotsJungle1(TCommandEnabler &enabler)
{
  enabler.Enable(GetACCMenuEnable()->SlotsJungle1);
  if (GetACCMenuEnable()->GetCurrentMode() == IDS_M_SL_JUNGLE1)
  {
    enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
    enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TCasACCGameFrameWindow::CmGameSlotsJungle2()
{
  SwitchGameModes(strSlotsJungle2);
}
//*******************************************************************
void TCasACCGameFrameWindow::CeGameSlotsJungle2(TCommandEnabler &enabler)
{
  enabler.Enable(GetACCMenuEnable()->SlotsJungle2);
  if (GetACCMenuEnable()->GetCurrentMode() == IDS_M_SL_JUNGLE2)
  {
    enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
    enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TCasACCGameFrameWindow::CmGameSlotsJungle100()
{
  SwitchGameModes(strSlotsJungle100);
}
//*******************************************************************
void TCasACCGameFrameWindow::CeGameSlotsJungle100(TCommandEnabler &enabler)
{
  enabler.Enable(GetACCMenuEnable()->SlotsJungle100);
  if (GetACCMenuEnable()->GetCurrentMode() == IDS_M_SL_JUNGLE100)
  {
    enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
    enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TCasACCGameFrameWindow::CmGameVPTen1()
{
  SwitchGameModes(strVPTen1);
}
//*******************************************************************
void TCasACCGameFrameWindow::CeGameVPTen1(TCommandEnabler &enabler)
{
  enabler.Enable(GetACCMenuEnable()->VPTen1);
  if (GetACCMenuEnable()->GetCurrentMode() == IDS_M_VP_TB1)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TCasACCGameFrameWindow::CmGameVPTen5()
{
  SwitchGameModes(strVPTen5);
}
//*******************************************************************
void TCasACCGameFrameWindow::CeGameVPTen5(TCommandEnabler &enabler)
{
  enabler.Enable(GetACCMenuEnable()->VPTen5);
  if (GetACCMenuEnable()->GetCurrentMode() == IDS_M_VP_TB5)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TCasACCGameFrameWindow::CmGameVPTen100()
{
  SwitchGameModes(strVPTen100);
}
//*******************************************************************
void TCasACCGameFrameWindow::CeGameVPTen100(TCommandEnabler &enabler)
{
  enabler.Enable(GetACCMenuEnable()->VPTen100);
  if (GetACCMenuEnable()->GetCurrentMode() == IDS_M_VP_TB100)
  {
    enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
    enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TCasACCGameFrameWindow::CmGameVPTen25()
{
  SwitchGameModes(strVPTen25);
}
//*******************************************************************
void TCasACCGameFrameWindow::CeGameVPTen25(TCommandEnabler &enabler)
{
  enabler.Enable(GetACCMenuEnable()->VPTen25);
  if (GetACCMenuEnable()->GetCurrentMode() == IDS_M_VP_TB25)
  {
    enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
    enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TCasACCGameFrameWindow::CmGameVPJack1()
{
  SwitchGameModes(strVPJack1);
}
//*******************************************************************
void TCasACCGameFrameWindow::CeGameVPJack1(TCommandEnabler &enabler)
{
  enabler.Enable(GetACCMenuEnable()->VPJack1);
  if (GetACCMenuEnable()->GetCurrentMode() == IDS_M_VP_JB1)
  {
    enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
    enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TCasACCGameFrameWindow::CmGameVPJack5()
{
  SwitchGameModes(strVPJack5);
}
//*******************************************************************
void TCasACCGameFrameWindow::CeGameVPJack5(TCommandEnabler &enabler)
{
  enabler.Enable(GetACCMenuEnable()->VPJack5);
  if (GetACCMenuEnable()->GetCurrentMode() == IDS_M_VP_JB5)
  {
    enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
    enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TCasACCGameFrameWindow::CmGameVPJack100()
{
  SwitchGameModes(strVPJack100);
}
//*******************************************************************
void TCasACCGameFrameWindow::CeGameVPJack100(TCommandEnabler &enabler)
{
  enabler.Enable(GetACCMenuEnable()->VPJack100);
  if (GetACCMenuEnable()->GetCurrentMode() == IDS_M_VP_JB100)
  {
    enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
    enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TCasACCGameFrameWindow::CmGameVPJack25()
{
  SwitchGameModes(strVPJack25);
}
//*******************************************************************
void TCasACCGameFrameWindow::CeGameVPJack25(TCommandEnabler &enabler)
{
  enabler.Enable(GetACCMenuEnable()->VPJack25);
  if (GetACCMenuEnable()->GetCurrentMode() == IDS_M_VP_JB25)
  {
    enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
    enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TCasACCGameFrameWindow::CmGameVPJack1P()
{
  SwitchGameModes(strVPJack1P);
}
//*******************************************************************
void TCasACCGameFrameWindow::CeGameVPJack1P(TCommandEnabler &enabler)
{
  enabler.Enable(GetACCMenuEnable()->VPJack1P);
  if (GetACCMenuEnable()->GetCurrentMode() == IDS_M_VP_JB1P)
  {
    enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
    enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TCasACCGameFrameWindow::CmGameVPDWild1()
{
  SwitchGameModes(strVPDWild1);
}
//*******************************************************************
void TCasACCGameFrameWindow::CeGameVPDWild1(TCommandEnabler &enabler)
{
  enabler.Enable(GetACCMenuEnable()->VPDWild1);
  if (GetACCMenuEnable()->GetCurrentMode() == IDS_M_VP_DW1)
  {
    enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
    enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TCasACCGameFrameWindow::CmGameVPDWild5()
{
  SwitchGameModes(strVPDWild5);
}
//*******************************************************************
void TCasACCGameFrameWindow::CeGameVPDWild5(TCommandEnabler &enabler)
{
  enabler.Enable(GetACCMenuEnable()->VPDWild5);
  if (GetACCMenuEnable()->GetCurrentMode() == IDS_M_VP_DW5)
  {
    enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
    enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TCasACCGameFrameWindow::CmGameVPDWild100()
{
  SwitchGameModes(strVPDWild100);
}
//*******************************************************************
void TCasACCGameFrameWindow::CeGameVPDWild100(TCommandEnabler &enabler)
{
  enabler.Enable(GetACCMenuEnable()->VPDWild100);
  if (GetACCMenuEnable()->GetCurrentMode() == IDS_M_VP_DW100)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
    enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TCasACCGameFrameWindow::CmGameVPDWild25()
{
  SwitchGameModes(strVPDWild25);
}
//*******************************************************************
void TCasACCGameFrameWindow::CeGameVPDWild25(TCommandEnabler &enabler)
{
  enabler.Enable(GetACCMenuEnable()->VPDWild25);
  if (GetACCMenuEnable()->GetCurrentMode() == IDS_M_VP_DW25)
  {
    enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
    enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TCasACCGameFrameWindow::CmGameVPJWild1()
{
  SwitchGameModes(strVPJWild1);
}
//*******************************************************************
void TCasACCGameFrameWindow::CeGameVPJWild1(TCommandEnabler &enabler)
{
  enabler.Enable(GetACCMenuEnable()->VPJWild1);
  if (GetACCMenuEnable()->GetCurrentMode() == IDS_M_VP_JW1)
  {
    enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
    enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TCasACCGameFrameWindow::CmGameVPJWild5()
{
  SwitchGameModes(strVPJWild5);
}
//*******************************************************************
void TCasACCGameFrameWindow::CeGameVPJWild5(TCommandEnabler &enabler)
{
  enabler.Enable(GetACCMenuEnable()->VPJWild5);
  if (GetACCMenuEnable()->GetCurrentMode() == IDS_M_VP_JW5)
  {
    enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TCasACCGameFrameWindow::CmGameVPJWild25()
{
  SwitchGameModes(strVPJWild25);
}
//*******************************************************************
void TCasACCGameFrameWindow::CeGameVPJWild25(TCommandEnabler &enabler)
{
  enabler.Enable(GetACCMenuEnable()->VPJWild25);
  if (GetACCMenuEnable()->GetCurrentMode() == IDS_M_VP_JW25)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TCasACCGameFrameWindow::CmGameVPJWild100()
{
  SwitchGameModes(strVPJWild100);
}
//*******************************************************************
void TCasACCGameFrameWindow::CeGameVPJWild100(TCommandEnabler &enabler)
{
  enabler.Enable(GetACCMenuEnable()->VPJWild100);
  if (GetACCMenuEnable()->GetCurrentMode() == IDS_M_VP_JW100)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************

