//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  bj1gld.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     1/25/96    M.Perry    original baseline
//  2.0    09/23/97    M.Perry    32-bit conversion.
//  2.3    07/14/99    M.Perry    retrofit to Ogle
//********************************************************************
#include "bj1gld.h"
#include "casnames.rh"
#include "cbjnames.rh"
#include "ogamefw.h"
//#include "bj1glspl.h"
#include "oskitcat.h"
#include "orespond.h"
#include "oanm.h"
//*******************************************************************
//TSpriteList *TBJ1GameLord::CreateSpriteList(TFileMode splfm)
//{
//  return (new TBJ1GLordSpriteList(PModeWin,splfm,this));
//}
//*******************************************************************
void TBJ1GameLord::SetupSkits()
{
  getcards1                  = GetSkitListIndex(GetResString(IDS_KCL_GETCARDS1_BJ1));
  if (getcards1 == -1)         {SpriteError("getcards1",GetResString(IDS_KCL_GETCARDS2_BJ1));}

  getcards2                  = GetSkitListIndex(GetResString(IDS_KCL_GETCARDS2_BJ1));
  if (getcards2 == -1)         {SpriteError("getcards2",GetResString(IDS_KCL_GETCARDS2_BJ1));}

  getcards3                  = GetSkitListIndex(GetResString(IDS_KCL_GETCARDS3_BJ1));
  if (getcards3 == -1)         {SpriteError("getcards3",GetResString(IDS_KCL_GETCARDS3_BJ1));}

  greetplayers              = GetSkitListIndex(GetResString(IDS_KCL_GREETPLAYERS_BJ1));
  if (greetplayers == -1)     {SpriteError("greetplayers",GetResString(IDS_KCL_GREETPLAYERS_BJ1));}

  shuffle                   = GetSkitListIndex(GetResString(IDS_KCL_SHUFFLE_BJ1));
  if (shuffle == -1)          {SpriteError("Shuffle",GetResString(IDS_KCL_SHUFFLE_BJ1));}

  placebets                 = GetSkitListIndex(GetResString(IDS_KCL_PLACEBETS_BJ1));
  if (placebets == -1)        {SpriteError("PlaceBets",GetResString(IDS_KCL_PLACEBETS_BJ1));}

  predealcom                = GetSkitListIndex(GetResString(IDS_KCL_PREDEALCOMMENT_BJ1));
  if (predealcom == -1)       {SpriteError("PreDealCom",GetResString(IDS_KCL_PREDEALCOMMENT_BJ1));}

  declareplayer1bj          = GetSkitListIndex(GetResString(IDS_KCL_DECLAREP1BJ_BJ1));
  if (declareplayer1bj == -1) {SpriteError("DeclarePlayer1BJ",GetResString(IDS_KCL_DECLAREP1BJ_BJ1));}

  declareplayer2bj          = GetSkitListIndex(GetResString(IDS_KCL_DECLAREP2BJ_BJ1));
  if (declareplayer2bj == -1) {SpriteError("DeclarePlayer2BJ",GetResString(IDS_KCL_DECLAREP2BJ_BJ1));}

  declareplayer3bj          = GetSkitListIndex(GetResString(IDS_KCL_DECLAREP3BJ_BJ1));
  if (declareplayer3bj == -1) {SpriteError("DeclarePlayer3BJ",GetResString(IDS_KCL_DECLAREP3BJ_BJ1));}

  promptinsurance           = GetSkitListIndex(GetResString(IDS_KCL_PROMPTINSURANCE_BJ1));
  if (promptinsurance == -1)  {SpriteError("PromptInsurance",GetResString(IDS_KCL_PROMPTINSURANCE_BJ1));}

  evenmoneyplayer1          = GetSkitListIndex(GetResString(IDS_KCL_EVENMONEYPLAYER1_BJ1));
  if (evenmoneyplayer1 == -1) {SpriteError("EvenMoneyPlayer1",GetResString(IDS_KCL_EVENMONEYPLAYER1_BJ1));}

  evenmoneyplayer2          = GetSkitListIndex(GetResString(IDS_KCL_EVENMONEYPLAYER2_BJ1));
  if (evenmoneyplayer2 == -1) {SpriteError("EvenMoneyPlayer2",GetResString(IDS_KCL_EVENMONEYPLAYER2_BJ1));}

  evenmoneyplayer3          = GetSkitListIndex(GetResString(IDS_KCL_EVENMONEYPLAYER3_BJ1));
  if (evenmoneyplayer3 == -1) {SpriteError("EvenMoneyPlayer3",GetResString(IDS_KCL_EVENMONEYPLAYER3_BJ1));}

  dealerbj                  = GetSkitListIndex(GetResString(IDS_KCL_DEALERBJ_BJ1));
  if (dealerbj == -1)         {SpriteError("DealerBJ",GetResString(IDS_KCL_DEALERBJ_BJ1));}
  BJSkitIndex[GetSkitIndex(dealerbj,"\\e1glrd00\\e100d000.sk")] = 0;
  BJSkitIndex[GetSkitIndex(dealerbj,"\\e1glrd00\\e100d001.sk")] = 1;
  BJSkitIndex[GetSkitIndex(dealerbj,"\\e1glrd00\\e100d002.sk")] = 2;
  BJSkitIndex[GetSkitIndex(dealerbj,"\\e1glrd00\\e100d003.sk")] = 3;
  BJSkitIndex[GetSkitIndex(dealerbj,"\\e1glrd00\\e100d004.sk")] = 4;
  BJSkitIndex[GetSkitIndex(dealerbj,"\\e1glrd00\\e100d005.sk")] = 5;
  BJSkitIndex[GetSkitIndex(dealerbj,"\\e1glrd00\\e100d006.sk")] = 6;
  BJSkitIndex[GetSkitIndex(dealerbj,"\\e1glrd00\\e100d007.sk")] = 7;
  BJSkitIndex[GetSkitIndex(dealerbj,"\\e1glrd00\\e100d008.sk")] = 8;
  BJSkitIndex[GetSkitIndex(dealerbj,"\\e1glrd00\\e100d009.sk")] = 9;
  BJSkitIndex[GetSkitIndex(dealerbj,"\\e1glrd00\\e100d00a.sk")] = 10;

  dealernobj                = GetSkitListIndex(GetResString(IDS_KCL_DEALERNOBJ_BJ1));
  if (dealernobj == -1)       {SpriteError("DealerNoBJ",GetResString(IDS_KCL_DEALERNOBJ_BJ1));}

  stalling1a                = GetSkitListIndex(GetResString(IDS_KCL_STALLING1A_BJ1));
  if (stalling1a == -1)       {SpriteError("Stalling1A",GetResString(IDS_KCL_STALLING1A_BJ1));}

  stalling1b                = GetSkitListIndex(GetResString(IDS_KCL_STALLING1B_BJ1));
  if (stalling1b == -1)       {SpriteError("Stalling1B",GetResString(IDS_KCL_STALLING1B_BJ1));}

  stalling1c                = GetSkitListIndex(GetResString(IDS_KCL_STALLING1C_BJ1));
  if (stalling1c == -1)       {SpriteError("Stalling1C",GetResString(IDS_KCL_STALLING1C_BJ1));}

  stalling2c                = GetSkitListIndex(GetResString(IDS_KCL_STALLING2C_BJ1));
  if (stalling2c == -1)       {SpriteError("Stalling2C",GetResString(IDS_KCL_STALLING2C_BJ1));}

  stalling2d                = GetSkitListIndex(GetResString(IDS_KCL_STALLING2D_BJ1));
  if (stalling2d == -1)       {SpriteError("Stalling2D",GetResString(IDS_KCL_STALLING2D_BJ1));}

  stalling2e                = GetSkitListIndex(GetResString(IDS_KCL_STALLING2E_BJ1));
  if (stalling2e == -1)       {SpriteError("Stalling2E",GetResString(IDS_KCL_STALLING2E_BJ1));}

  stalling3e                = GetSkitListIndex(GetResString(IDS_KCL_STALLING3E_BJ1));
  if (stalling3e == -1)       {SpriteError("Stalling3E",GetResString(IDS_KCL_STALLING3E_BJ1));}

  stalling3f                = GetSkitListIndex(GetResString(IDS_KCL_STALLING3F_BJ1));
  if (stalling3f == -1)       {SpriteError("Stalling3F",GetResString(IDS_KCL_STALLING3F_BJ1));}

  stalling3g                = GetSkitListIndex(GetResString(IDS_KCL_STALLING3G_BJ1));
  if (stalling3g == -1)       {SpriteError("Stalling3G",GetResString(IDS_KCL_STALLING3G_BJ1));}

  doublecomplayer1          = GetSkitListIndex(GetResString(IDS_KCL_DDOWNCOMMP1_BJ1));
  if (doublecomplayer1 == -1) {SpriteError("DoubleComPlayer1",GetResString(IDS_KCL_DDOWNCOMMP1_BJ1));}

  doublecomplayer2          = GetSkitListIndex(GetResString(IDS_KCL_DDOWNCOMMP2_BJ1));
  if (doublecomplayer2 == -1) {SpriteError("DoubleComPlayer2",GetResString(IDS_KCL_DDOWNCOMMP2_BJ1));}

  doublecomplayer3          = GetSkitListIndex(GetResString(IDS_KCL_DDOWNCOMMP3_BJ1));
  if (doublecomplayer3 == -1) {SpriteError("DoubleComPlayer3",GetResString(IDS_KCL_DDOWNCOMMP3_BJ1));}

  hitcomplayer1             = GetSkitListIndex(GetResString(IDS_KCL_HITCOMMP1_BJ1));
  if (hitcomplayer1 == -1)    {SpriteError("HitComPlayer1",GetResString(IDS_KCL_HITCOMMP1_BJ1));}

  hitcomplayer2             = GetSkitListIndex(GetResString(IDS_KCL_HITCOMMP2_BJ1));
  if (hitcomplayer2 == -1)    {SpriteError("HitComPlayer2",GetResString(IDS_KCL_HITCOMMP2_BJ1));}

  hitcomplayer3             = GetSkitListIndex(GetResString(IDS_KCL_HITCOMMP3_BJ1));
  if (hitcomplayer3 == -1)    {SpriteError("HitComPlayer3",GetResString(IDS_KCL_HITCOMMP3_BJ1));}

  standcomplayer1           = GetSkitListIndex(GetResString(IDS_KCL_STANDCOMMP1_BJ1));
  if (standcomplayer1 == -1)  {SpriteError("StandComPlayer1",GetResString(IDS_KCL_STANDCOMMP1_BJ1));}

  standcomplayer2           = GetSkitListIndex(GetResString(IDS_KCL_STANDCOMMP2_BJ1));
  if (standcomplayer2 == -1)  {SpriteError("StandComPlayer2",GetResString(IDS_KCL_STANDCOMMP2_BJ1));}

  standcomplayer3           = GetSkitListIndex(GetResString(IDS_KCL_STANDCOMMP3_BJ1));
  if (standcomplayer3 == -1)  {SpriteError("StandComPlayer3",GetResString(IDS_KCL_STANDCOMMP3_BJ1));}

  splitcomplayer1           = GetSkitListIndex(GetResString(IDS_KCL_SPLITCOMMP1_BJ1));
  if (splitcomplayer1 == -1)  {SpriteError("SplitComPlayer1",GetResString(IDS_KCL_SPLITCOMMP1_BJ1));}

  splitcomplayer2           = GetSkitListIndex(GetResString(IDS_KCL_SPLITCOMMP2_BJ1));
  if (splitcomplayer2 == -1)  {SpriteError("SplitComPlayer2",GetResString(IDS_KCL_SPLITCOMMP2_BJ1));}

  splitcomplayer3           = GetSkitListIndex(GetResString(IDS_KCL_SPLITCOMMP3_BJ1));
  if (splitcomplayer3 == -1)  {SpriteError("SplitComPlayer3",GetResString(IDS_KCL_SPLITCOMMP3_BJ1));}

  announcedealertotal       = GetSkitListIndex(GetResString(IDS_KCL_ANNOUNCEDEALERTOTAL_BJ1));
  if (announcedealertotal == -1) {SpriteError("AnnounceDealerTotal",GetResString(IDS_KCL_ANNOUNCEDEALERTOTAL_BJ1));}

  announceplayer1total      = GetSkitListIndex(GetResString(IDS_KCL_ANNOUNCEP1TOTAL_BJ1));
  if (announceplayer1total == -1) {SpriteError("AnnouncePlayer1Total",GetResString(IDS_KCL_ANNOUNCEP1TOTAL_BJ1));}

  announceplayer2total      = GetSkitListIndex(GetResString(IDS_KCL_ANNOUNCEP2TOTAL_BJ1));
  if (announceplayer2total == -1) {SpriteError("AnnouncePlayer2Total",GetResString(IDS_KCL_ANNOUNCEP2TOTAL_BJ1));}

  announceplayer3total      = GetSkitListIndex(GetResString(IDS_KCL_ANNOUNCEP3TOTAL_BJ1));
  if (announceplayer3total == -1) {SpriteError("AnnouncePlayer3Total",GetResString(IDS_KCL_ANNOUNCEP3TOTAL_BJ1));}

  announcedealerbust        = GetSkitListIndex(GetResString(IDS_KCL_ANNOUNCEDEALERBUST_BJ1));
  if (announcedealerbust == -1) {SpriteError("AnnounceDealerBust",GetResString(IDS_KCL_ANNOUNCEDEALERBUST_BJ1));}

  player1bust               = GetSkitListIndex(GetResString(IDS_KCL_BUSTP1_BJ1));
  if (player1bust == -1)      {SpriteError("Player1Bust",GetResString(IDS_KCL_BUSTP1_BJ1));}

  player2bust               = GetSkitListIndex(GetResString(IDS_KCL_BUSTP2_BJ1));
  if (player2bust == -1)      {SpriteError("Player2Bust",GetResString(IDS_KCL_BUSTP2_BJ1));}

  player3bust               = GetSkitListIndex(GetResString(IDS_KCL_BUSTP3_BJ1));
  if (player3bust == -1)      {SpriteError("Player3Bust",GetResString(IDS_KCL_BUSTP3_BJ1));}

  accepttipplayer1          = GetSkitListIndex(GetResString(IDS_KCL_ACCEPTTIPP1_BJ1));
  if (accepttipplayer1 == -1) {SpriteError("AcceptTipPlayer1",GetResString(IDS_KCL_ACCEPTTIPP1_BJ1));}

  accepttipplayer2          = GetSkitListIndex(GetResString(IDS_KCL_ACCEPTTIPP2_BJ1));
  if (accepttipplayer2 == -1) {SpriteError("AcceptTipPlayer2",GetResString(IDS_KCL_ACCEPTTIPP2_BJ1));}

  accepttipplayer3          = GetSkitListIndex(GetResString(IDS_KCL_ACCEPTTIPP3_BJ1));
  if (accepttipplayer3 == -1) {SpriteError("AcceptTipPlayer3",GetResString(IDS_KCL_ACCEPTTIPP3_BJ1));}

  winner1                   = GetSkitListIndex(GetResString(IDS_KCL_WINNERP1_BJ1));
  if (winner1 == -1)          {SpriteError("Winner1",GetResString(IDS_KCL_WINNERP1_BJ1));}

  winner2                   = GetSkitListIndex(GetResString(IDS_KCL_WINNERP2_BJ1));
  if (winner2 == -1)          {SpriteError("Winner2",GetResString(IDS_KCL_WINNERP2_BJ1));}

  winner3                   = GetSkitListIndex(GetResString(IDS_KCL_WINNERP3_BJ1));
  if (winner3 == -1)          {SpriteError("Winner3",GetResString(IDS_KCL_WINNERP3_BJ1));}

  push1                     = GetSkitListIndex(GetResString(IDS_KCL_PUSHP1_BJ1));
  if (push1 == -1)            {SpriteError("Push1",GetResString(IDS_KCL_PUSHP1_BJ1));}

  push2                     = GetSkitListIndex(GetResString(IDS_KCL_PUSHP2_BJ1));
  if (push2 == -1)            {SpriteError("Push2",GetResString(IDS_KCL_PUSHP2_BJ1));}

  push3                     = GetSkitListIndex(GetResString(IDS_KCL_PUSHP3_BJ1));
  if (push3 == -1)            {SpriteError("Push3",GetResString(IDS_KCL_PUSHP3_BJ1));}

  loser1                    = GetSkitListIndex(GetResString(IDS_KCL_LOSERP1_BJ1));
  if (loser1 == -1)           {SpriteError("Loser1",GetResString(IDS_KCL_LOSERP1_BJ1));}

  loser2                    = GetSkitListIndex(GetResString(IDS_KCL_LOSERP2_BJ1));
  if (loser2 == -1)           {SpriteError("Loser2",GetResString(IDS_KCL_LOSERP2_BJ1));}

  loser3                    = GetSkitListIndex(GetResString(IDS_KCL_LOSERP3_BJ1));
  if (loser3 == -1)           {SpriteError("Loser3",GetResString(IDS_KCL_LOSERP3_BJ1));}

  postreconcilecom          = GetSkitListIndex(GetResString(IDS_KCL_POSTRECONCILECOMM_BJ1));
  if (postreconcilecom == -1) {SpriteError("PostReconcileCom",GetResString(IDS_KCL_POSTRECONCILECOMM_BJ1));}

  gettraydiscards           = GetSkitListIndex(GetResString(IDS_KCL_GETTRAYDISCARDS_BJ1));
  if (gettraydiscards == -1)  {SpriteError("gettraydiscards",GetResString(IDS_KCL_GETTRAYDISCARDS_BJ1));}
}
//*******************************************************************
void TBJ1GameLord::SetupSprites()
{
 /* Rack              = NULL;
  Sign              = NULL;
  Dealer            = NULL;
  DealerSpot        = NULL;
  BetSpot[0]        = NULL;
  BetSpot[1]        = NULL;
  BetSpot[2]        = NULL;
  BetSpot[3]        = NULL;
  BetSpot[4]        = NULL;
  BetSpot[5]        = NULL;
  BetSpot[6]        = NULL;

  BJSounds          = NULL;
  Chips              = NULL;
  NamePlate1         = NULL;
  NamePlate2         = NULL;
  NamePlate3         = NULL;
  Circle1          = NULL;
  Circle2          = NULL;
  Circle3          = NULL;
  Button0          = NULL;
  Button1          = NULL;
  Button2          = NULL;
  Button3          = NULL;
  Button4          = NULL;
  Button5          = NULL;
  Button6          = NULL;
  Button7          = NULL;
  Button8          = NULL;
  Button9          = NULL;
  Button10         = NULL;
  Button11         = NULL;
  Button12         = NULL;
  Button13         = NULL;
  Button14         = NULL;
  Button15         = NULL;
  Button16         = NULL;
  Button17         = NULL;
  Button18         = NULL;
  MessageDisplay   = NULL;
  BankCashDisplay  = NULL;
  BetAmountDisplay = NULL;
//  BetUnitChips     = NULL;

  BJSounds           = (TBJSound      *)        GetSpritePtr(GetResString(IDS_MS_SOUNDS_BJ1));
  Rack               = (TBJRack        *)        GetSpritePtr(GetResString(IDS_MS_RACK_BJ1));
  Sign               = (TBJSign        *)        GetSpritePtr(GetResString(IDS_MS_SIGN_BJ1));
  DealerSpot         = (TBJDealerSpot  *)        GetSpritePtr(GetResString(IDS_MS_DS_BJ1));
  BetSpot[0]         = (TBJBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS0_BJ1));
  BetSpot[1]         = (TBJBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS1_BJ1));
  BetSpot[2]         = (TBJBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS2_BJ1));
  BetSpot[3]         = (TBJBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS3_BJ1));
  BetSpot[4]         = (TBJBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS4_BJ1));
  BetSpot[5]         = (TBJBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS5_BJ1));
  BetSpot[6]         = (TBJBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS6_BJ1));
  MessageDisplay     = (TCasMessageDisplay    *) GetSpritePtr(GetResString(IDS_MS_MESS_BJ1));
  BankCashDisplay    = (TCasCashDisplay       *) GetSpritePtr(GetResString(IDS_MS_BANKCASH_BJ1));
  BetAmountDisplay   = (TCasCashDisplay       *) GetSpritePtr(GetResString(IDS_MS_UNITCASH_BJ1));
//  BetUnitChips       = (TBetUnitChips         *) GetSpritePtr(GetResString(IDS_MS_BETUNITCHIPS_BJ1));
  Button0            = (TCasButton            *) GetSpritePtr(GetResString(IDS_MS_B0_BJ1));
  Button1            = (TCasButton            *) GetSpritePtr(GetResString(IDS_MS_B1_BJ1));
  Button2            = (TCasButton            *) GetSpritePtr(GetResString(IDS_MS_B2_BJ1));
  Button3            = (TCasButton            *) GetSpritePtr(GetResString(IDS_MS_B3_BJ1));
  Button4            = (TCasButton            *) GetSpritePtr(GetResString(IDS_MS_B4_BJ1));
  Button5            = (TCasButton            *) GetSpritePtr(GetResString(IDS_MS_B5_BJ1));
  Button6            = (TCasButton            *) GetSpritePtr(GetResString(IDS_MS_B6_BJ1));
  Button7            = (TCasButton            *) GetSpritePtr(GetResString(IDS_MS_B7_BJ1));
  Button8            = (TCasButton            *) GetSpritePtr(GetResString(IDS_MS_B8_BJ1));
  Button9            = (TCasButton            *) GetSpritePtr(GetResString(IDS_MS_B9_BJ1));
  Button10           = (TCasButton            *) GetSpritePtr(GetResString(IDS_MS_B10_BJ1));
  Button11           = (TCasButton            *) GetSpritePtr(GetResString(IDS_MS_B11_BJ1));
  Button12           = (TCasButton            *) GetSpritePtr(GetResString(IDS_MS_B12_BJ1));
  Button13           = (TCasButton            *) GetSpritePtr(GetResString(IDS_MS_B13_BJ1));
  Button14           = (TCasButton            *) GetSpritePtr(GetResString(IDS_MS_B14_BJ1));
  Button15           = (TCasButton            *) GetSpritePtr(GetResString(IDS_MS_B15_BJ1));
  Button16           = (TCasButton            *) GetSpritePtr(GetResString(IDS_MS_B16_BJ1));
  Button17           = (TCasButton            *) GetSpritePtr(GetResString(IDS_MS_B17_BJ1));
  Button18           = (TCasButton            *) GetSpritePtr(GetResString(IDS_MS_B18_BJ1));
  Circle1            = (TCircle               *) GetSpritePtr(GetResString(IDS_MS_CIRCLE1_BJ1));
  Circle2            = (TCircle               *) GetSpritePtr(GetResString(IDS_MS_CIRCLE2_BJ1));
  Circle3            = (TCircle               *) GetSpritePtr(GetResString(IDS_MS_CIRCLE3_BJ1));
  Chips              = (TCasChips             *) GetSpritePtr(GetResString(IDS_MS_CHIPS_BJ1));
  NamePlate1         = (TCasNamePlate         *) GetSpritePtr(GetResString(IDS_MS_NP1_BJ1));
  NamePlate2         = (TCasNamePlate         *) GetSpritePtr(GetResString(IDS_MS_NP2_BJ1));
  NamePlate3         = (TCasNamePlate         *) GetSpritePtr(GetResString(IDS_MS_NP3_BJ1));
  */
  removedealercards = GetSpriteIndex(GetResString(IDS_AS_RDCARDS_BJ1));
  SpritePriority(removedealercards);
  dealcard1a = GetSpriteIndex(GetResString(IDS_AS_DEALCARD1A_BJ1));
  SpritePriority(dealcard1a);
  dealcard1b = GetSpriteIndex(GetResString(IDS_AS_DEALCARD1B_BJ1));
  SpritePriority(dealcard1b);
  dealcard1c = GetSpriteIndex(GetResString(IDS_AS_DEALCARD1C_BJ1));
  SpritePriority(dealcard1c);
  dealcard2c = GetSpriteIndex(GetResString(IDS_AS_DEALCARD2C_BJ1));
  SpritePriority(dealcard2c);
  dealcard2d = GetSpriteIndex(GetResString(IDS_AS_DEALCARD2D_BJ1));
  SpritePriority(dealcard2d);
  dealcard2e = GetSpriteIndex(GetResString(IDS_AS_DEALCARD2E_BJ1));
  SpritePriority(dealcard2e);
  dealcard3e = GetSpriteIndex(GetResString(IDS_AS_DEALCARD3E_BJ1));
  SpritePriority(dealcard3e);
  dealcard3f = GetSpriteIndex(GetResString(IDS_AS_DEALCARD3F_BJ1));
  SpritePriority(dealcard3f);
  dealcard3g = GetSpriteIndex(GetResString(IDS_AS_DEALCARD3G_BJ1));
  SpritePriority(dealcard3g);
  dealerup   = GetSpriteIndex(GetResString(IDS_AS_DEALERUP_BJ1));
  SpritePriority(dealerup);
  dealerdown = GetSpriteIndex(GetResString(IDS_AS_DEALERDOWN_BJ1));
  SpritePriority(dealerdown);
  dealercheckholecard = GetSpriteIndex(GetResString(IDS_AS_DEALERCHECKHOLECARD_BJ1));
  SpritePriority(dealercheckholecard);
  dealerexposeholecard = GetSpriteIndex(GetResString(IDS_AS_DEALEREXPOSESHOLECARD_BJ1));
  SpritePriority(dealerexposeholecard);

  lookfrom0to1 = GetSpriteIndex(GetResString(IDS_AS_LOOKFROM0TO1_BJ1));
  SpritePriority(lookfrom0to1);
  lookfrom0to2 = GetSpriteIndex(GetResString(IDS_AS_LOOKFROM0TO2_BJ1));
  SpritePriority(lookfrom0to2);
  lookfrom0to3 = GetSpriteIndex(GetResString(IDS_AS_LOOKFROM0TO3_BJ1));
  SpritePriority(lookfrom0to3);
  lookfrom1to2 = GetSpriteIndex(GetResString(IDS_AS_LOOKFROM1TO2_BJ1));
  SpritePriority(lookfrom1to2);
  lookfrom1to3 = GetSpriteIndex(GetResString(IDS_AS_LOOKFROM1TO3_BJ1));
  SpritePriority(lookfrom1to3);
  lookfrom2to3 = GetSpriteIndex(GetResString(IDS_AS_LOOKFROM2TO3_BJ1));
  SpritePriority(lookfrom2to3);
  lookfrom1to0 = GetSpriteIndex(GetResString(IDS_AS_LOOKFROM1TO0_BJ1));
  SpritePriority(lookfrom1to0);
  lookfrom2to0 = GetSpriteIndex(GetResString(IDS_AS_LOOKFROM2TO0_BJ1));
  SpritePriority(lookfrom2to0);
  lookfrom3to0 = GetSpriteIndex(GetResString(IDS_AS_LOOKFROM3TO0_BJ1));
  SpritePriority(lookfrom3to0);
  lookfrom3to1 = GetSpriteIndex(GetResString(IDS_AS_LOOKFROM3TO1_BJ1));
  SpritePriority(lookfrom3to1);
  lookfrom3to2 = GetSpriteIndex(GetResString(IDS_AS_LOOKFROM3TO2_BJ1));
  SpritePriority(lookfrom3to2);
  lookfrom2to1 = GetSpriteIndex(GetResString(IDS_AS_LOOKFROM2TO1_BJ1));
  SpritePriority(lookfrom2to1);

  promptaction1a = GetSpriteIndex(GetResString(IDS_AS_PROMPTACTION1A_BJ1));
  promptaction1b = GetSpriteIndex(GetResString(IDS_AS_PROMPTACTION1B_BJ1));
  promptaction1c = GetSpriteIndex(GetResString(IDS_AS_PROMPTACTION1C_BJ1));
  promptaction2c = GetSpriteIndex(GetResString(IDS_AS_PROMPTACTION2C_BJ1));
  promptaction2d = GetSpriteIndex(GetResString(IDS_AS_PROMPTACTION2D_BJ1));
  promptaction2e = GetSpriteIndex(GetResString(IDS_AS_PROMPTACTION2E_BJ1));
  promptaction3e = GetSpriteIndex(GetResString(IDS_AS_PROMPTACTION3E_BJ1));
  promptaction3f = GetSpriteIndex(GetResString(IDS_AS_PROMPTACTION3F_BJ1));
  promptaction3g = GetSpriteIndex(GetResString(IDS_AS_PROMPTACTION3G_BJ1));

  hitfingersm1a = GetSpriteIndex(GetResString(IDS_AS_HITFINGERSM1A_BJ1));
  SpritePriority(hitfingersm1a);
  hitfingersm1b = GetSpriteIndex(GetResString(IDS_AS_HITFINGERSM1B_BJ1));
  SpritePriority(hitfingersm1b);
  hitfingersm1c = GetSpriteIndex(GetResString(IDS_AS_HITFINGERSM1C_BJ1));
  SpritePriority(hitfingersm1c);
  hitfingersm2c = GetSpriteIndex(GetResString(IDS_AS_HITFINGERSM2C_BJ1));
  SpritePriority(hitfingersm2c);
  hitfingersm2d = GetSpriteIndex(GetResString(IDS_AS_HITFINGERSM2D_BJ1));
  SpritePriority(hitfingersm2d);
  hitfingersm2e = GetSpriteIndex(GetResString(IDS_AS_HITFINGERSM2E_BJ1));
  SpritePriority(hitfingersm2e);
  hitfingersm3e = GetSpriteIndex(GetResString(IDS_AS_HITFINGERSM3E_BJ1));
  SpritePriority(hitfingersm3e);
  hitfingersm3f = GetSpriteIndex(GetResString(IDS_AS_HITFINGERSM3F_BJ1));
  SpritePriority(hitfingersm3f);
  hitfingersm3g = GetSpriteIndex(GetResString(IDS_AS_HITFINGERSM3G_BJ1));
  SpritePriority(hitfingersm3g);

  hitfingersf1a = GetSpriteIndex(GetResString(IDS_AS_HITFINGERSF1A_BJ1));
  SpritePriority(hitfingersf1a);
  hitfingersf1b = GetSpriteIndex(GetResString(IDS_AS_HITFINGERSF1B_BJ1));
  SpritePriority(hitfingersf1b);
  hitfingersf1c = GetSpriteIndex(GetResString(IDS_AS_HITFINGERSF1C_BJ1));
  SpritePriority(hitfingersf1c);
  hitfingersf2c = GetSpriteIndex(GetResString(IDS_AS_HITFINGERSF2C_BJ1));
  SpritePriority(hitfingersf2c);
  hitfingersf2d = GetSpriteIndex(GetResString(IDS_AS_HITFINGERSF2D_BJ1));
  SpritePriority(hitfingersf2d);
  hitfingersf2e = GetSpriteIndex(GetResString(IDS_AS_HITFINGERSF2E_BJ1));
  SpritePriority(hitfingersf2e);
  hitfingersf3e = GetSpriteIndex(GetResString(IDS_AS_HITFINGERSF3E_BJ1));
  SpritePriority(hitfingersf3e);
  hitfingersf3f = GetSpriteIndex(GetResString(IDS_AS_HITFINGERSF3F_BJ1));
  SpritePriority(hitfingersf3f);
  hitfingersf3g = GetSpriteIndex(GetResString(IDS_AS_HITFINGERSF3G_BJ1));
  SpritePriority(hitfingersf3g);

  standfingersm1a = GetSpriteIndex(GetResString(IDS_AS_STANDFINGERSM1A_BJ1));
  SpritePriority(standfingersm1a);
  standfingersm1b = GetSpriteIndex(GetResString(IDS_AS_STANDFINGERSM1B_BJ1));
  SpritePriority(standfingersm1b);
  standfingersm1c = GetSpriteIndex(GetResString(IDS_AS_STANDFINGERSM1C_BJ1));
  SpritePriority(standfingersm1c);
  standfingersm2c = GetSpriteIndex(GetResString(IDS_AS_STANDFINGERSM2C_BJ1));
  SpritePriority(standfingersm2c);
  standfingersm2d = GetSpriteIndex(GetResString(IDS_AS_STANDFINGERSM2D_BJ1));
  SpritePriority(standfingersm2d);
  standfingersm2e = GetSpriteIndex(GetResString(IDS_AS_STANDFINGERSM2E_BJ1));
  SpritePriority(standfingersm2e);
  standfingersm3e = GetSpriteIndex(GetResString(IDS_AS_STANDFINGERSM3E_BJ1));
  SpritePriority(standfingersm3e);
  standfingersm3f = GetSpriteIndex(GetResString(IDS_AS_STANDFINGERSM3F_BJ1));
  SpritePriority(standfingersm3f);
  standfingersm3g = GetSpriteIndex(GetResString(IDS_AS_STANDFINGERSM3G_BJ1));
  SpritePriority(standfingersm3g);

  standfingersf1a = GetSpriteIndex(GetResString(IDS_AS_STANDFINGERSF1A_BJ1));
  SpritePriority(standfingersf1a);
  standfingersf1b = GetSpriteIndex(GetResString(IDS_AS_STANDFINGERSF1B_BJ1));
  SpritePriority(standfingersf1b);
  standfingersf1c = GetSpriteIndex(GetResString(IDS_AS_STANDFINGERSF1C_BJ1));
  SpritePriority(standfingersf1c);
  standfingersf2c = GetSpriteIndex(GetResString(IDS_AS_STANDFINGERSF2C_BJ1));
  SpritePriority(standfingersf2c);
  standfingersf2d = GetSpriteIndex(GetResString(IDS_AS_STANDFINGERSF2D_BJ1));
  SpritePriority(standfingersf2d);
  standfingersf2e = GetSpriteIndex(GetResString(IDS_AS_STANDFINGERSF2E_BJ1));
  SpritePriority(standfingersf2e);
  standfingersf3e = GetSpriteIndex(GetResString(IDS_AS_STANDFINGERSF3E_BJ1));
  SpritePriority(standfingersf3e);
  standfingersf3f = GetSpriteIndex(GetResString(IDS_AS_STANDFINGERSF3F_BJ1));
  SpritePriority(standfingersf3f);
  standfingersf3g = GetSpriteIndex(GetResString(IDS_AS_STANDFINGERSF3G_BJ1));
  SpritePriority(standfingersf3g);

  if (DealerSpot == NULL) {SpriteError("Dealer Spot",GetResString(IDS_MS_DS_BJ1));}

  if (Rack       == NULL)         {SpriteError("Rack"      ,        GetResString(IDS_MS_RACK_BJ1));}
  if (BJSounds   == NULL)         {SpriteError("Sounds"    ,        GetResString(IDS_MS_SOUNDS_BJ1));}
  if (Sign       == NULL)         {SpriteError("Sign"      ,        GetResString(IDS_MS_SIGN_BJ1));}
  if (BetSpot[0] == NULL)         {SpriteError("Bet Spot 0",        GetResString(IDS_MS_BS0_BJ1));}
  if (BetSpot[1] == NULL)         {SpriteError("Bet Spot 1",        GetResString(IDS_MS_BS1_BJ1));}
  if (BetSpot[2] == NULL)         {SpriteError("Bet Spot 2",        GetResString(IDS_MS_BS2_BJ1));}
  if (BetSpot[3] == NULL)         {SpriteError("Bet Spot 3",        GetResString(IDS_MS_BS3_BJ1));}
  if (BetSpot[4] == NULL)         {SpriteError("Bet Spot 4",        GetResString(IDS_MS_BS4_BJ1));}
  if (BetSpot[5] == NULL)         {SpriteError("Bet Spot 5",        GetResString(IDS_MS_BS5_BJ1));}
  if (BetSpot[6] == NULL)         {SpriteError("Bet Spot 6",        GetResString(IDS_MS_BS6_BJ1));}
  if (Chips == NULL)              {SpriteError("Chip Stacks",       GetResString(IDS_MS_CHIPS_BJ1));}
  if (NamePlate1 == NULL)         {SpriteError("NamePlate1",        GetResString(IDS_MS_NP1_BJ1));}
  if (NamePlate2 == NULL)         {SpriteError("NamePlate2",        GetResString(IDS_MS_NP2_BJ1));}
  if (NamePlate3 == NULL)         {SpriteError("NamePlate3",        GetResString(IDS_MS_NP3_BJ1));}
  if (MessageDisplay == NULL)     {SpriteError("MessageDisplay",    GetResString(IDS_MS_MESS_BJ1));}
  if (BankCashDisplay == NULL)    {SpriteError("BankCashDisplay",   GetResString(IDS_MS_BANKCASH_BJ1));}
  if (BetAmountDisplay == NULL)   {SpriteError("BetAmountDisplay",  GetResString(IDS_MS_UNITCASH_BJ1));}
//  if (BetUnitChips == NULL)       {SpriteError("BetUnitChips",      GetResString(IDS_MS_BETUNITCHIPS_BJ1));}
  if (Button0 == NULL)       {SpriteError("Button0",      GetResString(IDS_MS_B0_BJ1));}
  if (Button1 == NULL)       {SpriteError("Button1",      GetResString(IDS_MS_B1_BJ1));}
  if (Button2 == NULL)       {SpriteError("Button2",      GetResString(IDS_MS_B2_BJ1));}
  if (Button3 == NULL)       {SpriteError("Button3",      GetResString(IDS_MS_B3_BJ1));}
  if (Button4 == NULL)       {SpriteError("Button4",      GetResString(IDS_MS_B4_BJ1));}
  if (Button5 == NULL)       {SpriteError("Button5",      GetResString(IDS_MS_B5_BJ1));}
  if (Button6 == NULL)       {SpriteError("Button6",      GetResString(IDS_MS_B6_BJ1));}
  if (Button7 == NULL)       {SpriteError("Button7",      GetResString(IDS_MS_B7_BJ1));}
  if (Button8 == NULL)       {SpriteError("Button8",      GetResString(IDS_MS_B8_BJ1));}
  if (Button9 == NULL)       {SpriteError("Button9",      GetResString(IDS_MS_B9_BJ1));}
  if (Button10 == NULL)      {SpriteError("Button10",     GetResString(IDS_MS_B10_BJ1));}
  if (Button11 == NULL)      {SpriteError("Button11",     GetResString(IDS_MS_B11_BJ1));}
  if (Button12 == NULL)      {SpriteError("Button12",     GetResString(IDS_MS_B12_BJ1));}
  if (Button13 == NULL)      {SpriteError("Button13",     GetResString(IDS_MS_B13_BJ1));}
  if (Button14 == NULL)      {SpriteError("Button14",     GetResString(IDS_MS_B14_BJ1));}
  if (Button15 == NULL)      {SpriteError("Button15",     GetResString(IDS_MS_B15_BJ1));}
  if (Button16 == NULL)      {SpriteError("Button16",     GetResString(IDS_MS_B16_BJ1));}
  if (Button17 == NULL)      {SpriteError("Button17",     GetResString(IDS_MS_B17_BJ1));}
  if (Button18 == NULL)      {SpriteError("Button18",     GetResString(IDS_MS_B18_BJ1));}
  if (Circle1 == NULL)       {SpriteError("Circle1",      GetResString(IDS_MS_CIRCLE1_BJ1));}
  if (Circle2 == NULL)       {SpriteError("Circle2",      GetResString(IDS_MS_CIRCLE2_BJ1));}
  if (Circle3 == NULL)       {SpriteError("Circle3",      GetResString(IDS_MS_CIRCLE3_BJ1));}

  ActivateSpriteNow(BJSounds);
  Rack->Start(GetFUC());
  Sign->Start(GetFUC());
//  Dealer->Start(GetFUC());
  DealerSpot->Start(GetFUC());
  BetSpot[0]->Start(GetFUC());
  BetSpot[1]->Start(GetFUC());
  BetSpot[2]->Start(GetFUC());
  BetSpot[3]->Start(GetFUC());
  BetSpot[4]->Start(GetFUC());
  BetSpot[5]->Start(GetFUC());
  BetSpot[6]->Start(GetFUC());
  Circle1->Start(GetFUC());
  Circle2->Start(GetFUC());
  Circle3->Start(GetFUC());
  ActivateSpriteNow(Button0);
  ActivateSpriteNow(Button1);
  ActivateSpriteNow(Button2);
  if (!GetFW()->GetHandleShowMenu())
  {
	 Button2->PButton->CAD.SetCurrentFrame(1);
	 Button2->Show();
	 Button2->PButtonResponder->Remove();
  }

  ActivateSpriteNow(Button3);
  ActivateSpriteNow(Button4);
  ActivateSpriteNow(Button5);
  ActivateSpriteNow(Button6);
  ActivateSpriteNow(Button7);
  ActivateSpriteNow(Button8);
  ActivateSpriteNow(Button9);
  ActivateSpriteNow(Button10);
  ActivateSpriteNow(Button11);
  ActivateSpriteNow(Button12);
  ActivateSpriteNow(Button13);
  ActivateSpriteNow(Button14);
  ActivateSpriteNow(Button15);
  ActivateSpriteNow(Button16);
  ActivateSpriteNow(Button17);
  ActivateSpriteNow(Button18);
  Chips->Start(GetFUC());
  NamePlate1->Start(GetFUC());
  NamePlate2->Start(GetFUC());
  NamePlate3->Start(GetFUC());
  MessageDisplay->Start(GetFUC());
  BankCashDisplay->Start(GetFUC());
  BetAmountDisplay->Start(GetFUC());
//ActivateSpriteNow(MessageDisplay);
 // ActivateSpriteNow(BankCashDisplay);
 // ActivateSpriteNow(BetAmountDisplay);
 // ActivateSpriteNow(BetUnitChips);
  #ifdef DEBUGIDLES
  DealerPos = GetSpritePtr("\\e1glrd00\\e100sp07.sp");
  Pos1 = GetSpritePtr("\\e1glrd00\\e100sp04.sp");
  Pos2 = GetSpritePtr("\\e1glrd00\\e100sp05.sp");
  Pos3 = GetSpritePtr("\\e1glrd00\\e100sp06.sp");
  #endif
}
//*******************************************************************
void TBJ1GameLord::CleanupSprites()
{
  //CoinsPlayed->NoShow();
}
//*******************************************************************
TBJ1GameLord::TBJ1GameLord(TBlackJackModeWin *pbjmodewin,const TFileMode &filemode)
  :TCasinoBJGameLord(pbjmodewin,filemode)
{
  randomize();
  TFileMode splfm(SpriteListName,
                  TFileMode::fm_None,
                  TFileMode::fm_Immed,
                  FileMode.GetDirIndex());
//  AddElement(CreateSpriteList(splfm));
  CreateAddSpriteList(splfm);

  TFileMode skcfm(SkitCatName,
                  TFileMode::fm_None,
                  TFileMode::fm_Immed,
                  FileMode.GetDirIndex());
//  AddElement(CreateSkitCat(skcfm));
  CreateAddSkitCat(skcfm);

  SetupSprites();
  SetupSkits();
}
//*******************************************************************
TBJ1GameLord::~TBJ1GameLord()
{
}
//*******************************************************************

