//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  bj1glspl.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     1/24/96    M.Perry    original baseline
//  2.0    09/23/97    M.Perry    32-bit conversion.
//********************************************************************
#include "bj1glspl.h"
#include "casnames.rh"
#include "cbjnames.rh"
//*******************************************************************
TBJ1GLordSpriteList::TBJ1GLordSpriteList(TOgleModeWindow *pmw,const TFileMode &filemode,
                                         TGameObject *PGObj)
:TBJGLordSpriteList(pmw,filemode,PGObj)
{
  Init(filemode,true,false);
}
//*******************************************************************
TBJ1GLordSpriteList::~TBJ1GLordSpriteList()
{
}
//*******************************************************************
TSprite *TBJ1GLordSpriteList::CreateSprite(string spritename,int16 id,void *psource)
{
  TFileMode FM(spritename,fm_None,fm_None,FileMode.DirIndex);
  if (psource == NULL)
  {
    FM.SetRamImmed();
  }
  if (psource == NULL)
  {
    switch (id)
    {
      case 0:return new TSprite(PModeWin,FM);
      case 1:return new TBJSound(PModeWin,FM);
      case 2:return new TBJSign(PModeWin,FM);
      case 3:return new TBJRack(PModeWin,FM);
      case 4:return new TCircle(PModeWin,FM);
      case 5:return new TCircle(PModeWin,FM);
      case 6:return new TCircle(PModeWin,FM);
      case 7:return new TCasNamePlate(PModeWin,FM);
      case 8:return new TCasNamePlate(PModeWin,FM);
      case 9:return new TCasNamePlate(PModeWin,FM);
      case 10:return new TBetUnitChips(PModeWin,FM);
      case 11:return new TCasMessageDisplay(PModeWin,FM);
      case 12:return new TCasCashDisplay(PModeWin,FM);
      case 13:return new TCasCashDisplay(PModeWin,FM);
      case 14:return new TCasButton(PModeWin,FM,(TCasinoGameLord *)POwnerGObj,100,TRect(1,430,50,479),bjidButton0,true,'x');
      case 15:return new TCasButton(PModeWin,FM,(TCasinoGameLord *)POwnerGObj,100,TRect(170,430,219,479),bjidButton1,true);
      case 16:return new TCasButton(PModeWin,FM,(TCasinoGameLord *)POwnerGObj,100,TRect(223,464,258,479),bjidButton2,true);
      case 17:return new TCasButton(PModeWin,FM,(TCasinoGameLord *)POwnerGObj,100,TRect(376,464,412,479),bjidButton3,true);
      case 18:return new TCasButton(PModeWin,FM,(TCasinoGameLord *)POwnerGObj,100,TRect(416,430,468,452),bjidButton4,true,'c');
      case 19:return new TCasButton(PModeWin,FM,(TCasinoGameLord *)POwnerGObj,100,TRect(416,454,468,479),bjidButton5,true,'r');
      case 20:return new TCasButton(PModeWin,FM,(TCasinoGameLord *)POwnerGObj,100,TRect(472,455,489,479),bjidButton6,true,'4');
      case 21:return new TCasButton(PModeWin,FM,(TCasinoGameLord *)POwnerGObj,100,TRect(491,455,508,479),bjidButton7,true,'5');
      case 22:return new TCasButton(PModeWin,FM,(TCasinoGameLord *)POwnerGObj,100,TRect(510,455,527,479),bjidButton8,true,'6');
      case 23:return new TCasButton(PModeWin,FM,(TCasinoGameLord *)POwnerGObj,100,TRect(529,455,546,479),bjidButton9,true,'7');
      case 24:return new TCasButton(PModeWin,FM,(TCasinoGameLord *)POwnerGObj,100,TRect(548,455,564,479),bjidButton10,true,'8');
      case 25:return new TCasButton(PModeWin,FM,(TCasinoGameLord *)POwnerGObj,100,TRect(566,455,584,479),bjidButton11,true,'9');
      case 26:return new TCasButton(PModeWin,FM,(TCasinoGameLord *)POwnerGObj,100,TRect(587,432,639,478),bjidButton12,true);
      case 27:return new TCasButton(PModeWin,FM,(TCasinoGameLord *)POwnerGObj,125,TRect(416,430,468,479),bjidButton13,true,'p');
      case 28:return new TCasButton(PModeWin,FM,(TCasinoGameLord *)POwnerGObj,125,TRect(470,430,522,479	),bjidButton14,true,'d');
      case 29:return new TCasButton(PModeWin,FM,(TCasinoGameLord *)POwnerGObj,250,TRect(533,430,585,479),bjidButton15,true,'h');
      case 30:return new TCasButton(PModeWin,FM,(TCasinoGameLord *)POwnerGObj,250,TRect(587,432,639,478),bjidButton16,true,'s');
      case 31:return new TCasButton(PModeWin,FM,(TCasinoGameLord *)POwnerGObj,250,TRect(416,430,522,479),bjidButton17,true,'n');
      case 32:return new TCasButton(PModeWin,FM,(TCasinoGameLord *)POwnerGObj,250,TRect(533,430,639,478),bjidButton18,true,'y');
      case 33:return new TBJBetSpot(PModeWin,FM);
      case 34:return new TBJBetSpot(PModeWin,FM);
      case 35:return new TBJBetSpot(PModeWin,FM);
      case 36:return new TBJBetSpot(PModeWin,FM);
      case 37:return new TBJBetSpot(PModeWin,FM);
      case 38:return new TBJBetSpot(PModeWin,FM);
      case 39:return new TBJBetSpot(PModeWin,FM);
      case 40:return new TBJDealerSpot(PModeWin,FM);
      case 41:return new TCasChips(PModeWin,FM);
      default:return new TSprite(PModeWin,FM);
    }
  }
  else
  {
    switch (id)
    {
      case 0:return new TSprite(PModeWin,FM,psource);
      case 1:return new TBJSound(PModeWin,FM,psource);
      case 2:return new TBJSign(PModeWin,FM,psource);
      case 3:return new TBJRack(PModeWin,FM,psource);
      case 4:return new TCircle(PModeWin,FM,psource);
      case 5:return new TCircle(PModeWin,FM,psource);
      case 6:return new TCircle(PModeWin,FM,psource);
      case 7:return new TCasNamePlate(PModeWin,FM,psource);
      case 8:return new TCasNamePlate(PModeWin,FM,psource);
      case 9:return new TCasNamePlate(PModeWin,FM,psource);
      case 10:return new TBetUnitChips(PModeWin,FM,psource);
      case 11:return new TCasMessageDisplay(PModeWin,FM,psource);
      case 12:return new TCasCashDisplay(PModeWin,FM,psource);
      case 13:return new TCasCashDisplay(PModeWin,FM,psource);
      case 14:return new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,100,TRect(1,430,50,479),bjidButton0,true,'x');
      case 15:return new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,100,TRect(170,430,219,479),bjidButton1,true);
      case 16:return new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,100,TRect(223,464,258,479),bjidButton2,true);
      case 17:return new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,100,TRect(376,464,412,479),bjidButton3,true);
      case 18:return new  TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,100,TRect(416,430,468,452),bjidButton4,true,'c');
      case 19:return new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,100,TRect(416,454,468,479),bjidButton5,true,'r');
      case 20:return new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,100,TRect(472,455,489,479),bjidButton6,true,'4');
      case 21:return new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,100,TRect(491,455,508,479),bjidButton7,true,'5');
      case 22:return new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,100,TRect(510,455,527,479),bjidButton8,true,'6');
      case 23:return new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,100,TRect(529,455,546,479),bjidButton9,true,'7');
      case 24:return new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,100,TRect(548,455,564,479),bjidButton10,true,'8');
      case 25:return new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,100,TRect(566,455,584,479),bjidButton11,true,'9');
      case 26:return new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,100,TRect(587,432,639,478),bjidButton12,true);
      case 27:return new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,125,TRect(416,430,468,479),bjidButton13,true,'p');
      case 28:return new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,125,TRect(470,430,522,479	),bjidButton14,true,'d');
      case 29:return new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,250,TRect(533,430,585,479),bjidButton15,true,'h');
      case 30:return new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,250,TRect(587,432,639,478),bjidButton16,true,'s');
      case 31:return new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,250,TRect(416,430,522,479),bjidButton17,true,'n');
      case 32:return new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,250,TRect(533,430,639,478),bjidButton18,true,'y');
      case 33:return new TBJBetSpot(PModeWin,FM,psource);
      case 34:return new TBJBetSpot(PModeWin,FM,psource);
      case 35:return new TBJBetSpot(PModeWin,FM,psource);
      case 36:return new TBJBetSpot(PModeWin,FM,psource);
      case 37:return new TBJBetSpot(PModeWin,FM,psource);
      case 38:return new TBJBetSpot(PModeWin,FM,psource);
      case 39:return new TBJBetSpot(PModeWin,FM,psource);
      case 40:return new TBJDealerSpot(PModeWin,FM,psource);
      case 41:return new TCasChips(PModeWin,FM,psource);
      default:return new TSprite(PModeWin,FM,psource);
    }
  }
}
//*******************************************************************

