 //*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  bjact1st.cpp   ///
//    Project Name:  Casino
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     06/29/95   A. Krist    Original baseline
//  2.0     09/24/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "bjact1st.h"
#include "bjrmst.h"
#include "bjfdst.h"
#include "bjstate.h"
#include "casbjmw.h"
//#include "cbjglspl.h"
#include "hand.h"
#include "orespond.h"
//*******************************************************************
TBJAct1State::TBJAct1State(TCasinoBJGameLord *pNewBJLord)
:TBJLordState(pNewBJLord)
{
	 SetRunOrder(ess_Execute,ess_StartSubState3,ess_Execute,ess_Done,ess_Done,ess_Done);
	 StartingFUC = 0;
	 FUCLength = 0;
	 BetSpot1Responder           = NULL;
	 BetSpot2Responder           = NULL;
	 BetSpot3Responder           = NULL;

	 OneChipResponder            = NULL;
	 FiveChipResponder           = NULL;
	 TwentyFiveChipResponder     = NULL;
	 OneHundredChipResponder     = NULL;
	 OneThouChipResponder        = NULL;
	 TenThouChipResponder        = NULL;

	 MenuEscResponder            = NULL;
	 RemoveDoubleResponder       = NULL;
	 ClearNoInsureStandResponder = NULL;
	 SameYesInsureHitResponder   = NULL;
	 DealSplitResponder          = NULL;
	 AskExpertResponder          = NULL;
	 WaitOnSkit                  = false;
	 WaitOnShuffle               = false;
	 WaitOnPreDealCom            = false;
	 askexpertflag               = false;
	 WaitOnPlace                 = false;
	 WaitingOnWRCounter          = 0;
	WaitOnDealerBJ = false;
	FinishDealerBJ = false;
	remove = 0;
	show = 0;

}
//*******************************************************************
TBJAct1State::~TBJAct1State()
{
}
//*******************************************************************
void TBJAct1State::ExecuteFirstTime()
{
  //pOwnerLord->BetUnitChips->SetNum(pOwnerLord->GetBJPlayer(pOwnerLord->activeplayer)->lastbet);
  pOwnerLord->MessageDisplay->ShowMessage(1);
  pOwnerLord->UnFreezeAllButtons();
  pOwnerLord->Button16->PButtonResponder->SetCh2('^');
  pOwnerLord->Button12->PButtonResponder->SetCh2(VK_RETURN);
  pOwnerLord->Responders[0]->Add();
  pOwnerLord->Responders[1]->Add();
  pOwnerLord->Responders[2]->Add();
  pOwnerLord->Responders[3]->Add();
  pOwnerLord->Responders[4]->Add();
  pOwnerLord->EnableButton(4);
  pOwnerLord->EnableButton(5);
  pOwnerLord->EnableButton(6);
  pOwnerLord->EnableButton(7);
  pOwnerLord->EnableButton(8);
  pOwnerLord->EnableButton(9);
  pOwnerLord->EnableButton(10);
  pOwnerLord->EnableButton(11);
  pOwnerLord->Button12->ShowGray();
 // pOwnerLord->Responders[9]->SetCh('p');
 // pOwnerLord->Responders[10]->SetCh('c');
//  pOwnerLord->Responders[11]->SetCh('s');
//  pOwnerLord->Responders[12]->SetCh('d');
  pOwnerLord->LookingAt = bjnl0U;
  pOwnerLord->SetBodyIdle();
  //pOwnerLord->RemoveDouble->NoShow();
 // pOwnerLord->ClearNoInsureStand->NoShow();
 // pOwnerLord->SameYesInsureHit->NoShow();
 // pOwnerLord->DealSplit->ShowGrayDeal();
  pOwnerLord->Clear();
  for(int16 i=0;i<7;i++)
  {
	 pOwnerLord->BetSpot[i]->NoShowCards();
	 pOwnerLord->BetSpot[i]->NoShowChips();
  }
  pOwnerLord->DealerSpot->NoShowCards();
  ExecuteWaiting = true;
  LookAtFirstPlayer = false;
  ExecuteStatus    = ess_Execute;
  if(pOwnerLord->newdeal)
  {
//	 StartingFUC = PTimePtr->GetFrameUpdateCount() + 1;
    StartingFUC = pOwnerLord->GetAdjFUC();
	 pOwnerLord->GetTrayDiscards(StartingFUC,FUCLength);
	 WaitOnSkit = true;
	 pOwnerLord->newdeal = 0;
	 WaitOnShuffle = true;
  }
  if(!WaitOnSkit)
  {
//	 StartingFUC = PTimePtr->GetFrameUpdateCount() + 1;
    StartingFUC = pOwnerLord->GetAdjFUC();
	 pOwnerLord->PlaceBets(StartingFUC,FUCLength);
	 WaitOnSkit = true;
  }

}
//*******************************************************************
void TBJAct1State::CreateSubState1()
{
  pOwnerLord->StartTC = pOwnerLord->truecount;
  pOwnerLord->Responders[0]->Remove();
  pOwnerLord->Responders[1]->Remove();
  pOwnerLord->Responders[2]->Remove();
  pOwnerLord->Responders[3]->Remove();
  pOwnerLord->Responders[4]->Remove();
  pOwnerLord->GetOgleApp()->GetCursorMgr()->SetCursor(ctAction,0,0);
  PActiveSubState = new TBJFirstDealState(pOwnerLord);
}
//*******************************************************************
void TBJAct1State::CreateSubState2()
{
  pOwnerLord->MessageDisplay->ShowMessage(0);

  pOwnerLord->Button5->ShowLite();
  pOwnerLord->PlaceBetsMode = false;
  pOwnerLord->PModeWin->ReSendEnterArea();
  pOwnerLord->DisEnableButton(4);
  pOwnerLord->DisEnableButton(6);
  pOwnerLord->DisEnableButton(7);
  pOwnerLord->DisEnableButton(8);
  pOwnerLord->DisEnableButton(9);
  pOwnerLord->DisEnableButton(10);
  pOwnerLord->DisEnableButton(11);
  pOwnerLord->DisEnableButton(12);
  PActiveSubState = new TBJRemoveState(pOwnerLord);
}
//*******************************************************************
void TBJAct1State::CreateSubState4()
{
}
//*******************************************************************
void TBJAct1State::CreateSubState3()
{
  pOwnerLord->SetBlackJack();
  if(pOwnerLord->pHand->cards[0].name > Nine)
  {
	 PActiveSubState = new TBJState(pOwnerLord);
  }
}
//*******************************************************************
void TBJAct1State::EndSubState3()
{
  TState::EndSubState3();
  if(pOwnerLord->pHand->bj)
  {
	 ExecuteWaiting = true;
	 ExecuteStatus = ess_Execute;
	 WaitOnDealerBJ = true;
  }
}
//*******************************************************************
void TBJAct1State::EndSubState4()
{
  TState::EndSubState4();
  ExecuteWaiting = false;
  ExecuteStatus = ess_Done;
}
//*******************************************************************
void TBJAct1State::EndSubState2()
{
  TState::EndSubState2();
  ExecuteWaiting = true;
  pOwnerLord->MessageDisplay->ShowMessage(1);
  pOwnerLord->PlaceBetsMode = true;
  pOwnerLord->PModeWin->ReSendEnterArea();
  pOwnerLord->EnableButton(4);
  pOwnerLord->EnableButton(6);
  pOwnerLord->EnableButton(7);
  pOwnerLord->EnableButton(8);
  pOwnerLord->EnableButton(9);
  pOwnerLord->EnableButton(10);
  pOwnerLord->EnableButton(11);
  if ((pOwnerLord->BetSpotUse[1] == -1) &&
		(pOwnerLord->BetSpotUse[3] == -1) &&
		(pOwnerLord->BetSpotUse[5] == -1))
	{
	  pOwnerLord->Button12->ShowGray();
	}
	else
	{pOwnerLord->EnableButton(12);}
   if(!pOwnerLord->BetMade(pOwnerLord->activeplayer)){pOwnerLord->Button5->ShowGray();}
}
//*******************************************************************
bool TBJAct1State::HandleShuffleNewDeck()
{
  FUCLength = 0;
//  StartingFUC = PTimePtr->GetFrameUpdateCount() + 1;
  StartingFUC = pOwnerLord->GetAdjFUC();
  //pOwnerLord->Shuffle(StartingFUC,FUCLength);
  if(pOwnerLord->SwitchDeckNowFlag == false)
  {
	 pOwnerLord->GetTrayDiscards(StartingFUC,FUCLength);
	 WaitOnSkit = true;
	 pOwnerLord->SwitchDeckNowFlag = true;
  }
  pOwnerLord->newdeal = 0;
  WaitOnShuffle = true;
  return 1;
}
//*******************************************************************
void TBJAct1State::HandlePostUpdate(dword NewFUC)
{
  if(WaitOnDealerBJ)
  {
	 StartingFUC = pOwnerLord->GetAdjFUC();
	 pOwnerLord->RemoveDealerCards(StartingFUC,FUCLength,remove,show);
	 WaitOnDealerBJ = false;
	 FinishDealerBJ = true;
  }
  if(FinishDealerBJ)
  {
	 if(StartingFUC + remove == NewFUC)
	 {
		pOwnerLord->DealerSpot->NoShow();
	 }
	 if(StartingFUC + FUCLength <= NewFUC)
	 {
		FinishDealerBJ = false;
		remove = 0;show = 0;
      ExecuteWaiting = false;
		ExecuteStatus = ess_Done;
	 }
  }

  if(pOwnerLord->ButtonHit[bjidButton12])
  {
	 pOwnerLord->ButtonClear(bjidButton12);
	 if ((pOwnerLord->BetSpotUse[1] > -1) || (pOwnerLord->BetSpotUse[3] > -1) || (pOwnerLord->BetSpotUse[5] > -1))
	 {
		if(pOwnerLord->BetSpotUse[1] > -1)
		{pOwnerLord->ThreeBets++;}
		if(pOwnerLord->BetSpotUse[3] > -1)
		{pOwnerLord->ThreeBets++;}
		if(pOwnerLord->BetSpotUse[5] > -1)
		{pOwnerLord->ThreeBets++;}

		pOwnerLord->DisEnableButton(4);
		pOwnerLord->DisEnableButton(5);
		pOwnerLord->DisEnableButton(6);
		pOwnerLord->DisEnableButton(7);
		pOwnerLord->DisEnableButton(8);
		pOwnerLord->DisEnableButton(9);
		pOwnerLord->DisEnableButton(10);
		pOwnerLord->DisEnableButton(11);
		pOwnerLord->DisEnableButton(12);
		StartingFUC = pOwnerLord->GetAdjFUC();
		pOwnerLord->PreDealCom(StartingFUC,FUCLength);
		WaitOnSkit       = true;   //Trickle down to next if statement
		WaitOnPreDealCom = true;
      pOwnerLord->ChangeActivePlayersOk = false;
		LockHit = true;
		pOwnerLord->MessageDisplay->NoShow();
	 //	pOwnerLord->BetUnitChips->SetNum(0);
		pOwnerLord->FreezeAllButtons();
      pOwnerLord->SwitchDeckNowFlag = false;
	 }
	 return;
  }
  if (pOwnerLord->ButtonHit[bjidButton11])
  {
	 pOwnerLord->ButtonClear(bjidButton11);
	 if(pOwnerLord->ButtonInfo == 1)
	 {
		pOwnerLord->UnBet1(1);
	 }
	 else
	 {
		pOwnerLord->Bet1(1);
	 }
	 if(!WaitOnSkit)
	 {
		return;
	 }
  }
  if (pOwnerLord->ButtonHit[bjidButton10])
  {
	 pOwnerLord->ButtonClear(bjidButton10);
	 if(pOwnerLord->ButtonInfo == 1)
	 {
		pOwnerLord->UnBet1(5);
	 }
	 else
	 {
		pOwnerLord->Bet1(5);
	 }
	 if(!WaitOnSkit)
	 {
		return;
	 }
  }
  if (pOwnerLord->ButtonHit[bjidButton9])
  {
	 pOwnerLord->ButtonClear(bjidButton9);
	 if(pOwnerLord->ButtonInfo == 1)
	 {
		pOwnerLord->UnBet1(25);
	 }
	 else
	 {
		pOwnerLord->Bet1(25);
	 }
	 if(!WaitOnSkit)
	 {
		return;
	 }
  }
  if (pOwnerLord->ButtonHit[bjidButton8])
  {
	 pOwnerLord->ButtonClear(bjidButton8);
	 if(pOwnerLord->ButtonInfo == 1)
	 {
		pOwnerLord->UnBet1(100);
	 }
	 else
	 {
		pOwnerLord->Bet1(100);
	 }
	 if(!WaitOnSkit)
	 {
		return;
	 }
  }
  if (pOwnerLord->ButtonHit[bjidButton7])
  {
	 pOwnerLord->ButtonClear(bjidButton7);
	 if(pOwnerLord->ButtonInfo == 1)
	 {
		pOwnerLord->UnBet1(1000);
	 }
	 else
	 {
		pOwnerLord->Bet1(1000);
	 }
	 if(!WaitOnSkit)
	 {
		return;
	 }
  }
  if (pOwnerLord->ButtonHit[bjidButton6])
  {
	 pOwnerLord->ButtonClear(bjidButton6);
	 if(pOwnerLord->ButtonInfo == 1)
	 {
		pOwnerLord->UnBet1(10000);
	 }
	 else
	 {
		pOwnerLord->Bet1(10000);
	 }
	 if(!WaitOnSkit)
	 {
		return;
	 }
  }
  if(pOwnerLord->ButtonHit[bjidButton5])
  {
	 pOwnerLord->ButtonClear(bjidButton5);
	 ExecuteWaiting = false;
	 LockHit = false;
	 ExecuteStatus = ess_StartSubState2;
	 return;
  }

  if(pOwnerLord->ButtonHit[bjidButton4])
  {
	 pOwnerLord->ButtonClear(bjidButton4);
	 pOwnerLord->ClearBet();
	 LockHit = false;

	 return;
  }
  if(pOwnerLord->ButtonHit[bjidButton3])
  {
	 //pOwnerLord->Button3->ShowUp();
	 LockHit = false;
	 pOwnerLord->ButtonClear(bjidButton3);
	 return;
  }
  if(pOwnerLord->ButtonHit[bjidButton2])
  {
	 //pOwnerLord->Button3->ShowUp();
	 LockHit = false;
	 pOwnerLord->ButtonClear(bjidButton2);
	 return;
  }
  if(pOwnerLord->ButtonHit[bjidButton1])
  {
	 //pOwnerLord->Button3->ShowUp();
	 LockHit = false;
	 pOwnerLord->ButtonClear(bjidButton1);
	 return;
  }
  if(pOwnerLord->ButtonHit[bjidButton0])
  {
	 //pOwnerLord->Button3->ShowUp();
	 LockHit = false;
	 askexpertflag = false;
	 pOwnerLord->AskBetExpert();
	 pOwnerLord->ButtonClear(bjidButton0);
	 return;
  }
  if (BetSpot1Responder != NULL)
  {
	 if(pOwnerLord->BetSpotUse[1] >= 0)
	 {
		pOwnerLord->BetSpot[1]->
		 SetNum(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->coinsplayedhand1);
	 //	pOwnerLord->DealSplit->NoShow();
	 }
	 if (BetSpot1Responder->GetResponseEvent() != reChar)
	 {
		BetSpot1Responder->ClearPriority();
	 }
	 LockHit = false;
	 BetSpot1Responder = NULL;
  }
  if (BetSpot2Responder != NULL)
  {
	 if(pOwnerLord->BetSpotUse[3] >= 0)
	 {
		pOwnerLord->BetSpot[3]->
		 SetNum(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->coinsplayedhand3);
		//pOwnerLord->DealSplit->NoShow();
	 }
	 if (BetSpot2Responder->GetResponseEvent() != reChar)
	 {
		BetSpot2Responder->ClearPriority();
	 }
	 LockHit = false;
	 BetSpot2Responder = NULL;
  }
  if (BetSpot3Responder != NULL)
  {
	 if(pOwnerLord->BetSpotUse[5] >= 0)
	 {
		pOwnerLord->BetSpot[5]->
		 SetNum(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->coinsplayedhand5);
	  //	pOwnerLord->DealSplit->NoShow();
	 }
	 if (BetSpot3Responder->GetResponseEvent() != reChar)
	 {
		BetSpot3Responder->ClearPriority();
	 }
	 LockHit = false;
	 BetSpot3Responder = NULL;
  }
  if(WaitOnSkit)
  {
	 if((StartingFUC + FUCLength) <= NewFUC)
	 {
		StartingFUC = 0;
		FUCLength   = 0;
		WaitOnSkit  = false;
		if(LockHit)
		{
		  LockHit = false;
		  LockButtons = false;
		}
	 }
	 if(WaitOnShuffle && (StartingFUC + 4) == NewFUC)
	 {
		pOwnerLord->Rack->ShowBJRack(0);
	 }
  //???	 return;//?
  }
  if(LookAtFirstPlayer && !WaitOnSkit)
  {
	 ExecuteWaiting = false;
	 ExecuteStatus = ess_Done;
	 LookAtFirstPlayer = false;
  }
  if(!WaitOnSkit && WaitOnShuffle)
  {
//	 StartingFUC = PTimePtr->GetFrameUpdateCount() + 1;
	 StartingFUC = pOwnerLord->GetAdjFUC();
	 pOwnerLord->Shuffle(StartingFUC,FUCLength);
	 WaitOnSkit    = true;
	 LockHit = true;
	 WaitOnShuffle = false;
	 WaitOnPlace = true;
  }
  if(WaitOnPlace)
  {
    StartingFUC = pOwnerLord->GetAdjFUC();
	 pOwnerLord->PlaceBets(StartingFUC,FUCLength);
	 WaitOnSkit    = true;
	 LockHit = true;
	 WaitOnPlace = false;
  }
  if (WaitingOnWRCounter)
  {
	 WaitingOnWRCounter--;
	 if (!WaitingOnWRCounter)
	 {
		ExecuteWaiting = false;
		ExecuteStatus = ess_StartSubState1;
	 }
  }


  if(RemoveDoubleResponder != NULL)
  {
	// pOwnerLord->RemoveDouble->NoShow();
	 if (RemoveDoubleResponder->GetResponseEvent() != reChar)
	 {
		RemoveDoubleResponder->ClearPriority();
	 }
	 RemoveDoubleResponder = NULL;

	 ExecuteWaiting = false;
	 LockHit = false;
	 ExecuteStatus = ess_StartSubState2;
	 return;
  }

  if(ClearNoInsureStandResponder != NULL)
  {
	// pOwnerLord->ClearNoInsureStand->NoShow();
	 if (ClearNoInsureStandResponder->GetResponseEvent() != reChar)
	 {
		ClearNoInsureStandResponder->ClearPriority();
	 }
	 LockHit = false;
	 ClearNoInsureStandResponder = NULL;

	 return;
  }
  if(SameYesInsureHitResponder != NULL)
  {
	// pOwnerLord->SameYesInsureHit->NoShow();
	 if (SameYesInsureHitResponder->GetResponseEvent() != reChar)
	 {
		SameYesInsureHitResponder->ClearPriority();
	 }
	 pOwnerLord->BetLast();
	 SameYesInsureHitResponder = NULL;
	 LockHit = false;
	 return;
  }
  if(DealSplitResponder != NULL)
  {
	// pOwnerLord->DealSplit->NoShow();
	 if (DealSplitResponder->GetResponseEvent() != reChar)
	 {
		DealSplitResponder->ClearPriority();
	 }
	 DealSplitResponder = NULL;
	 if ((pOwnerLord->BetSpotUse[1] > -1) || (pOwnerLord->BetSpotUse[3] > -1) || (pOwnerLord->BetSpotUse[5] > -1))
	 {
//		StartingFUC = PTimePtr->GetFrameUpdateCount() + 1;
		StartingFUC = pOwnerLord->GetAdjFUC();
		pOwnerLord->PreDealCom(StartingFUC,FUCLength);
		WaitOnSkit       = true;   //Trickle down to next if statement
		WaitOnPreDealCom = true;
		LockHit = true;
	 }
  }
  if(!WaitOnSkit && WaitOnPreDealCom)
  {
	 ExecuteWaiting = false;
	 ExecuteStatus = ess_StartSubState1;
	 WaitOnPreDealCom = false;
	 pOwnerLord->shutdownstate = 1;
	 return;
  }
  if(MenuEscResponder != NULL)
  {
 //	 pOwnerLord->MenuEscButton->Release();
	 if (MenuEscResponder->GetResponseEvent() != reChar)
	 {
		MenuEscResponder->ClearPriority();
	 }
	 MenuEscResponder = NULL;

	 return;
  }
  if(AskExpertResponder != NULL)
  {
	 if(!askexpertflag)
	 {
	//	pOwnerLord->AskExpertButton->Release();
		if (AskExpertResponder->GetResponseEvent() != reChar)
		{
		  AskExpertResponder->ClearPriority();
		}
		askexpertflag = true;
	 }
	 else
	 {
		AskExpertResponder = NULL;
		askexpertflag = false;
		pOwnerLord->AskBetExpert();
	 }
	 return;
  }

}
//*******************************************************************
bool TBJAct1State::HandleNamePlate(TResponder &responder)
{
  if(responder.GetResponseEvent() == reLDown)
  {
	 responder.SetPriority();
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_PRESSING_FINGER_CURSOR));
	 return true;
  }
  if ((responder.GetResponseEvent() == reLUp    ) ||
		(responder.GetResponseEvent() == reLDblClk) ||
		(responder.GetResponseEvent() == reChar   )   )
  {
	 if(responder.GetIsPriority())
	 {
		responder.ClearPriority();
	 }
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_POINTING_FINGER_CURSOR));
	 if(responder.Contains(responder.GetPoint()) ||
		 responder.GetResponseEvent() == reChar     )
	 {
		if(pOwnerLord->GetNumActivePlayers() > 1)
		{
		  pOwnerLord->CyclePlayers();
		}
	 }
  }
  return true;
}
//*******************************************************************
bool TBJAct1State::HandleBetSpot1(TResponder &responder)
{
  if((pOwnerLord->GetBJPlayer(pOwnerLord->activeplayer)->lastbet > 0 ||
		pOwnerLord->coinsplayed > 0) && (pOwnerLord->activeplayer != -1) &&
	  (!LockHit))
  {
	 if (responder.GetResponseEvent() == reLUp)
	 {
		if(pOwnerLord->BetSpotUse[1] == -1 || pOwnerLord->BetSpotUse[1] == pOwnerLord->activeplayer)
		{
		  pOwnerLord->PlaceBet(1);
		  BetSpot1Responder = &responder;
		  LockHit = true;
		}
		else
		{
		  responder.ClearPriority();
		}
	 }
	 if (responder.GetResponseEvent() == reLDown)
	 {
		responder.SetPriority();
	 }
	 if (responder.GetResponseEvent() == reChar)
	 {
		if(pOwnerLord->BetSpotUse[1] == -1 || pOwnerLord->BetSpotUse[1] == pOwnerLord->activeplayer)
		{
		  pOwnerLord->PlaceBet(1);
		  BetSpot1Responder = &responder;
		}
		BetSpot1Responder = &responder;
	 }
	 return true;
  }
  else
  {
	 return false;
  }
}
//*******************************************************************
bool TBJAct1State::HandleBetSpot2(TResponder &responder)
{
  if((pOwnerLord->GetBJPlayer(pOwnerLord->activeplayer)->lastbet > 0 ||
		pOwnerLord->coinsplayed > 0) && (pOwnerLord->activeplayer != -1) &&
	  (!LockHit))
  {

	 if (responder.GetResponseEvent() == reLUp)
	 {
		if(pOwnerLord->BetSpotUse[3] == -1 || pOwnerLord->BetSpotUse[3] == pOwnerLord->activeplayer)
		{
		  pOwnerLord->PlaceBet(3);
		  BetSpot2Responder = &responder;
		  LockHit = true;
		}
      else
		{
		  responder.ClearPriority();
		}
	 }

	 if (responder.GetResponseEvent() == reLDown)
	 {
		responder.SetPriority();
	 }

	 if (responder.GetResponseEvent() == reChar)
	 {
		if(pOwnerLord->BetSpotUse[3] == -1 || pOwnerLord->BetSpotUse[3] == pOwnerLord->activeplayer)
		{
		  pOwnerLord->PlaceBet(3);
		  BetSpot2Responder = &responder;
		}
		BetSpot2Responder = &responder;
	 }
	 return true;
  }
  else
  {
	 return false;
  }
}
//*******************************************************************
bool TBJAct1State::HandleBetSpot3(TResponder &responder)
{
  if((pOwnerLord->GetBJPlayer(pOwnerLord->activeplayer)->lastbet > 0 ||
		pOwnerLord->coinsplayed > 0) && (pOwnerLord->activeplayer != -1) &&
	  (!LockHit))
  {

	 if (responder.GetResponseEvent() == reLUp)
	 {
		if(pOwnerLord->BetSpotUse[5] == -1 || pOwnerLord->BetSpotUse[5] == pOwnerLord->activeplayer)
		{
		  pOwnerLord->PlaceBet(5);
		  BetSpot3Responder = &responder;
		  LockHit = true;
		}
      else
		{
		  responder.ClearPriority();
		}
	 }
	 if (responder.GetResponseEvent() == reLDown)
	 {
		responder.SetPriority();
	 }
	 if (responder.GetResponseEvent() == reChar)
	 {
		if(pOwnerLord->BetSpotUse[5] == -1 || pOwnerLord->BetSpotUse[5] == pOwnerLord->activeplayer)
		{
		  pOwnerLord->PlaceBet(5);
		  BetSpot3Responder = &responder;
		}
		BetSpot3Responder = &responder;
	 }
	 return true;
  }
  else
  {
	 return false;
  }
}
//*******************************************************************
bool TBJAct1State::HandleRemoveDouble(TResponder &responder)
{
  if((pOwnerLord->activeplayer != -1) && (!WaitOnSkit) && (!LockHit))
  {
	 if(pOwnerLord->BetSpotUse[1] != -1 || pOwnerLord->BetSpotUse[3] != -1 || pOwnerLord->BetSpotUse[5] != -1)
	 {
		if (responder.GetResponseEvent() == reLUp)
		{
		  LockHit = true;
		  RemoveDoubleResponder = &responder;
		}
		if (responder.GetResponseEvent() == reLDown)
		{
	 //	  pOwnerLord->RemoveDouble->ShowRemoveDown();
		  responder.SetPriority();
		}
		if (responder.GetResponseEvent() == reChar)
		{
	 //	  pOwnerLord->RemoveDouble->ShowRemoveDown();
		  RemoveDoubleResponder = &responder;
		}
	 }
	 return true;
  }
  return true;
}
//*******************************************************************
bool TBJAct1State::HandleClearNoInsureStand(TResponder &responder)
{
  if((pOwnerLord->activeplayer != -1) && (!WaitOnSkit) && (!LockHit))
  {
	 if (responder.GetResponseEvent() == reLUp)
	 {
		ClearNoInsureStandResponder = &responder;
		LockHit = true;
		pOwnerLord->ClearBet();
	 }

	 if (responder.GetResponseEvent() == reLDown)
	 {
	  //	pOwnerLord->ClearNoInsureStand->ShowClearDown();
		responder.SetPriority();
	 }

	 if (responder.GetResponseEvent() == reChar)
	 {
	  //	pOwnerLord->ClearNoInsureStand->ShowClearDown();
		ClearNoInsureStandResponder = &responder;
		pOwnerLord->ClearBet();
	 }
	 return true;
  }
  return true;
}
//*******************************************************************
bool TBJAct1State::HandleSameYesInsureHit(TResponder &responder)
{
  if((pOwnerLord->activeplayer != -1) && (!WaitOnSkit) && (!LockHit))
  {
	 if (responder.GetResponseEvent() == reLUp)
	 {
		LockHit = true;
		SameYesInsureHitResponder = &responder;
	 }

	 if (responder.GetResponseEvent() == reLDown)
	 {
	 //	pOwnerLord->SameYesInsureHit->ShowSameDown();
		responder.SetPriority();
	 }

	 if (responder.GetResponseEvent() == reChar)
	 {
	//	pOwnerLord->SameYesInsureHit->ShowSameDown();
		SameYesInsureHitResponder = &responder;
	 }
	 return true;
  }
  return true;
}
//*******************************************************************
bool TBJAct1State::HandleDealSplit(TResponder &responder)
{
  if((pOwnerLord->activeplayer != -1) && (!WaitOnSkit) && (!LockHit) &&
	  ((pOwnerLord->BetSpotUse[1] > -1) || (pOwnerLord->BetSpotUse[3] > -1)
		|| (pOwnerLord->BetSpotUse[5] > -1)))
  {
	 if (responder.GetResponseEvent() == reLUp)
	 {
		LockHit = true;
		DealSplitResponder = &responder;
	 }
	 if (responder.GetResponseEvent() == reLDown)
	 {
		pOwnerLord->SwitchDeckNowFlag = false;
	  //	pOwnerLord->DealSplit->ShowDealDown();
		responder.SetPriority();
	 }
	 if (responder.GetResponseEvent() == reChar)
	 {
		pOwnerLord->SwitchDeckNowFlag = false;
	//	pOwnerLord->DealSplit->ShowDealDown();
		DealSplitResponder = &responder;
	 }
	 return true;
  }
  return true;
}
//*******************************************************************
bool TBJAct1State::HandleOneChip(TResponder &responder)
{
  if(pOwnerLord->activeplayer != -1)
  {
	 if (responder.GetResponseEvent() == reLUp || responder.GetResponseEvent() == reRUp)
	 {
		OneChipResponder = &responder;
	 }

	 if (responder.GetResponseEvent() == reLDown || responder.GetResponseEvent() == reRDown)
	 {
		responder.SetPriority();
	 }

	 if (responder.GetResponseEvent() == reChar)
	 {
		OneChipResponder = &responder;
	 }
	 return true;
  }
  return true;
}
//*******************************************************************
bool TBJAct1State::HandleFiveChip(TResponder &responder)
{
  if(pOwnerLord->activeplayer != -1)
  {
	 if (responder.GetResponseEvent() == reLUp || responder.GetResponseEvent() == reRUp)
	 {
		FiveChipResponder = &responder;
	 }

	 if (responder.GetResponseEvent() == reLDown || responder.GetResponseEvent() == reRDown)
	 {
		responder.SetPriority();
	 }

	 if (responder.GetResponseEvent() == reChar)
	 {
		FiveChipResponder = &responder;
	 }
	 return true;
  }
  return true;
}
//*******************************************************************
bool TBJAct1State::HandleTwentyFiveChip(TResponder &responder)
{
  if(pOwnerLord->activeplayer != -1)
  {

  if (responder.GetResponseEvent() == reLUp || responder.GetResponseEvent() == reRUp)
  {
	 TwentyFiveChipResponder = &responder;
  }

  if (responder.GetResponseEvent() == reLDown || responder.GetResponseEvent() == reRDown)
  {
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
	 TwentyFiveChipResponder = &responder;
  }
  return true;
  }
  return true;
}
//*******************************************************************
bool TBJAct1State::HandleOneHundredChip(TResponder &responder)
{
  if(pOwnerLord->activeplayer != -1)
  {

  if (responder.GetResponseEvent() == reLUp || responder.GetResponseEvent() == reRUp)
  {
	 OneHundredChipResponder = &responder;
  }

  if (responder.GetResponseEvent() == reLDown || responder.GetResponseEvent() == reRDown)
  {
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
	 OneHundredChipResponder = &responder;
  }
  return true;
  }
  return true;
}
//*******************************************************************
bool TBJAct1State::HandleOneThouChip(TResponder &responder)
{
  if(pOwnerLord->activeplayer != -1)
  {

  if (responder.GetResponseEvent() == reLUp || responder.GetResponseEvent() == reRUp)
  {
	 OneThouChipResponder = &responder;
  }

  if (responder.GetResponseEvent() == reLDown || responder.GetResponseEvent() == reRDown)
  {
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
	 OneThouChipResponder = &responder;
  }
  return true;
  }
  return true;
}
//*******************************************************************
bool TBJAct1State::HandleTenThouChip(TResponder &responder)
{
  if(pOwnerLord->activeplayer != -1)
  {

  if (responder.GetResponseEvent() == reLUp || responder.GetResponseEvent() == reRUp)
  {
	 TenThouChipResponder = &responder;
  }

  if (responder.GetResponseEvent() == reLDown || responder.GetResponseEvent() == reRDown)
  {
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
	 TenThouChipResponder = &responder;
  }
  return true;
  }
  return true;
}
//*******************************************************************
bool TBJAct1State::HandleMenuEsc(TResponder &responder)
{
  if(!WaitOnSkit)
  {
  if (responder.GetResponseEvent() == reLUp)
  {
	 MenuEscResponder = &responder;
  }

  if (responder.GetResponseEvent() == reLDown)
  {
//	 pOwnerLord->MenuEscButton->Depress();
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
	// pOwnerLord->MenuEscButton->Depress();
	 MenuEscResponder = &responder;
  }
  }
  return true;
}
//*******************************************************************
bool TBJAct1State::HandleAskExpert(TResponder &responder)
{
  if(pOwnerLord->activeplayer != -1 && !WaitOnSkit)
  {

	if (responder.GetResponseEvent() == reLUp)
  {
	 AskExpertResponder = &responder;
  }

  if (responder.GetResponseEvent() == reLDown)
  {
  //	 pOwnerLord->AskExpertButton->Depress();
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
 //	 pOwnerLord->AskExpertButton->Depress();
	 AskExpertResponder = &responder;
  }

  return true;
  }
  return true;
}
//*******************************************************************
