//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  bjact2st.cpp
//    Project Name:  Casino
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     06/29/95   A. Krist    Original baseline
//  2.0     09/24/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "bjact2st.h"
#include "cbjglord.h"
#include "bjgobj.h"
#include "casbjmw.h"
#include "bjbs1st.h"
#include "bjbs2st.h"
#include "bjbs3st.h"
#include "bjwinst.h"
#include "bjddst.h"
#include "bjwst.h"
#include "bjexpost.h"

class TBJHand;

#include "otimers.h"
#include "orespond.h"
//*******************************************************************
TBJAct2State::TBJAct2State(TCasinoBJGameLord *pNewBJLord)
:TBJLordState(pNewBJLord)
{
  SetRunOrder(ess_Execute,ess_Execute,ess_Execute,
				  ess_StartSubState4,ess_StartSubState5,ess_StartSubState6,
				  ess_Done);
  StartingFUC = 0;
  FUCLength = 0;
  WaitOnSkit = false;
  Start1 = false;
  Start2 = false;
  Start3 = false;
  Start4 = false;
  Start5 = false;
  Start6 = false;
  Start7 = false;
  Start8 = false;
  WaitOnDealerRemoveCards = false;
  FinishDealerRemoveCards = false;
  remove = 0;
  show = 0;

}
//*******************************************************************
TBJAct2State::~TBJAct2State()
{
  pOwnerLord->BJSounds->NoShowFourBack();
  pOwnerLord->DisEnableButton(13);
  pOwnerLord->DisEnableButton(14);
  pOwnerLord->DisEnableButton(15);
  pOwnerLord->DisEnableButton(16);

  pOwnerLord->EnableButton(4);
  pOwnerLord->EnableButton(5);
  pOwnerLord->EnableButton(6);
  pOwnerLord->EnableButton(7);
  pOwnerLord->EnableButton(8);
  pOwnerLord->EnableButton(9);
  pOwnerLord->EnableButton(10);
  pOwnerLord->EnableButton(11);
  pOwnerLord->EnableButton(12);
}
//*******************************************************************
void TBJAct2State::ExecuteFirstTime()
{
  pOwnerLord->Button12->PButtonResponder->SetCh2('^');
  pOwnerLord->Button16->PButtonResponder->SetCh2(VK_RETURN);
  pOwnerLord->DisEnableButton(4);
  pOwnerLord->DisEnableButton(5);
  pOwnerLord->DisEnableButton(6);
  pOwnerLord->DisEnableButton(7);
  pOwnerLord->DisEnableButton(8);
  pOwnerLord->DisEnableButton(9);
  pOwnerLord->DisEnableButton(10);
  pOwnerLord->DisEnableButton(11);
  pOwnerLord->DisEnableButton(12);

  pOwnerLord->EnableButton(13);
  pOwnerLord->EnableButton(14);
  pOwnerLord->EnableButton(15);
  pOwnerLord->EnableButton(16);

  pOwnerLord->BJSounds->ShowFourBack();
 // pOwnerLord->RemoveDouble->ShowDouble();
 // pOwnerLord->DealSplit->ShowSplit();
 // pOwnerLord->ClearNoInsureStand->ShowStand();
  //pOwnerLord->SameYesInsureHit->ShowHit();
  pOwnerLord->FreezeAllButtons();
  LookToNextPlayer(7);
  //ExecuteStatus = ess_StartSubState1;
}
//*******************************************************************
void TBJAct2State::HandlePostUpdate(dword NewFUC)
{
  if(WaitOnDealerRemoveCards)
  {
	 StartingFUC = pOwnerLord->GetAdjFUC();
	 pOwnerLord->RemoveDealerCards(StartingFUC,FUCLength,remove,show);
	 WaitOnDealerRemoveCards = false;
	 FinishDealerRemoveCards = true;
	 pOwnerLord->FreezeAllButtons();
  }
  if(FinishDealerRemoveCards)
  {
	 if(StartingFUC + remove == NewFUC)
	 {
		pOwnerLord->DealerSpot->NoShow();
	 }
	 if(StartingFUC + FUCLength <= NewFUC)
	 {
		FinishDealerRemoveCards = false;
		remove = 0;show = 0;
      ExecuteWaiting = false;
		ExecuteStatus = ess_Done;
	 }
  }
  if(WaitOnSkit)
  {
	 if((StartingFUC != 0) && ((StartingFUC + FUCLength) <= NewFUC))
	 {
		StartingFUC = 0;
		FUCLength   = 0;
		WaitOnSkit  = false;
	 }
	 return;//?
  }
  if(!WaitOnSkit && Start1)
  {
	 Start1  = false;
	 ExecuteWaiting = false;
	 ExecuteStatus = ess_StartSubState1;
  }
  if(!WaitOnSkit && Start2)
  {
	 Start2  = false;
	 ExecuteWaiting = false;
	 ExecuteStatus = ess_StartSubState2;
  }
  if(!WaitOnSkit && Start3)
  {
	 Start3  = false;
	 ExecuteWaiting = false;
	 ExecuteStatus = ess_StartSubState3;
  }
  if(!WaitOnSkit && Start4)
  {
	 Start4  = false;
	 ExecuteWaiting = false;
	 ExecuteStatus = ess_StartSubState4;
  }
  if(!WaitOnSkit && Start5)
  {
	 Start5  = false;
	 ExecuteWaiting = false;
	 ExecuteStatus = ess_StartSubState5;
  }
  if(!WaitOnSkit && Start6)
  {
	 Start6  = false;
	 ExecuteWaiting = false;
	 ExecuteStatus = ess_StartSubState6;
  }
  if(!WaitOnSkit && Start7)
  {
	 Start7  = false;
	 ExecuteWaiting = false;
	 ExecuteStatus = ess_StartSubState7;
  }
  if(!WaitOnSkit && Start8)
  {
	 Start8  = false;
	 ExecuteWaiting = false;
	 ExecuteStatus = ess_StartSubState8;
  }

}
//*******************************************************************
TBJLookFromTo TBJAct2State::NextPlayer(int16 from)
{
  switch(from) {
  case 7 : if(pOwnerLord->BetSpotUse[1] >= 0)
           {
             pOwnerLord->LookingAt = bjnl1B;
             Start1=true;
             return bjlf0To1;
           }
			  if(pOwnerLord->BetSpotUse[3] >= 0)
           {
             pOwnerLord->LookingAt = bjnl2D;
             Start2=true;
             return bjlf0To2;
           }
			  if(pOwnerLord->BetSpotUse[5] >= 0)
           {
             pOwnerLord->LookingAt = bjnl3F;
             Start3=true;
             return bjlf0To3;
           }
			  pOwnerLord->LookingAt = bjnl0U;
			  Start6=true;
			  return bjlf0To0;

  case 1 : if(pOwnerLord->BetSpotUse[3] >= 0)
           {
             pOwnerLord->LookingAt = bjnl2D;
             Start2=true;
             return bjlf1To2;
           }
			  if(pOwnerLord->BetSpotUse[5] >= 0)
           {
             pOwnerLord->LookingAt = bjnl3F;
             Start3=true;
             return bjlf1To3;
           }
			  pOwnerLord->LookingAt = bjnl0U;
			  Start4=true;
			  return bjlf1To0;
  case 3 : if(pOwnerLord->BetSpotUse[5] >= 0)
           {
             pOwnerLord->LookingAt = bjnl3F;
             Start3=true;
             return bjlf2To3;
           }
			  Start4=true;
			  pOwnerLord->LookingAt = bjnl0U;
			  return bjlf2To0;
  case 5 : Start4=true;
			  pOwnerLord->LookingAt = bjnl0U;
			  return bjlf3To0;
  }
  return bjlf0To0;
}
//*******************************************************************
void TBJAct2State::LookToNextPlayer(int16 from)
{
  StartingFUC = pOwnerLord->GetAdjFUC();
  pOwnerLord->LookFromTo(NextPlayer(from),StartingFUC,FUCLength);
  pOwnerLord->SetBodyIdle();
  ExecuteWaiting = true;
  ExecuteStatus = ess_Execute;
  WaitOnSkit        = true;
  pOwnerLord->FreezeAllButtons();
}
//*******************************************************************
void TBJAct2State::EndSubState1()
{
  TState::EndSubState1();
  if(pOwnerLord->BetSpotUse[1] != -1)
  {
	 if(((TBJHand *)pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand1)->bj)
	 {
		pOwnerLord->BetSpotUse[1] = -1;
	 }
  }
  LookToNextPlayer(1);
  ExecuteWaiting = true;
}
//*******************************************************************
void TBJAct2State::EndSubState2()
{
  TState::EndSubState2();
  if(pOwnerLord->BetSpotUse[3] != -1)
  {
	 if(((TBJHand *)pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3)->bj)
	 {
		pOwnerLord->BetSpotUse[3] = -1;
	 }
  }
  LookToNextPlayer(3);
  ExecuteWaiting = true;
}
//*******************************************************************
void TBJAct2State::EndSubState3()
{
  TState::EndSubState3();
  if(pOwnerLord->BetSpotUse[5] != -1)
  {
	 if(((TBJHand *)pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->pHand5)->bj)
	 {
		pOwnerLord->BetSpotUse[5] = -1;
	 }
  }
  LookToNextPlayer(5);
  ExecuteWaiting = true;
 // ExecuteStatus = ess_StartSubState4;
}
//*******************************************************************
void TBJAct2State::EndSubState6()
{
  TState::EndSubState6();
  if(pOwnerLord->pHand != NULL)
  {
	 WaitOnDealerRemoveCards = true;
	 ExecuteWaiting = true;
	 ExecuteStatus = ess_Execute;
  }
}
//*******************************************************************
void TBJAct2State::CreateSubState1()
{
  if(pOwnerLord->BetSpotUse[1] > -1)
  {
	 pOwnerLord->SwitchToPlayer(pOwnerLord->BetSpotUse[1]);
	 if(((TBJHand *)pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand1)->bj)
	 {
		PActiveSubState = new TBJWinState(pOwnerLord,1);
	 }
	 else
	 {
		PActiveSubState = new TBJBetSpot1State(pOwnerLord);
	 }
  }
}
//*******************************************************************
void TBJAct2State::CreateSubState2()
{
  if(pOwnerLord->BetSpotUse[3] > -1)
  {
	 pOwnerLord->SwitchToPlayer(pOwnerLord->BetSpotUse[3]);
	 if(((TBJHand *)pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3)->bj)
	 {
		PActiveSubState = new TBJWinState(pOwnerLord,4);
	 }
	 else
	 {
		PActiveSubState = new TBJBetSpot2State(pOwnerLord);
	 }
  }
}
//*******************************************************************
void TBJAct2State::CreateSubState3()
{
  if(pOwnerLord->BetSpotUse[5] > -1)
  {
	 pOwnerLord->SwitchToPlayer(pOwnerLord->BetSpotUse[5]);
	 if(((TBJHand *)pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->pHand5)->bj)
	 {
		PActiveSubState = new TBJWinState(pOwnerLord,7);
	 }
	 else
	 {
		PActiveSubState = new TBJBetSpot3State(pOwnerLord);
	 }
  }
}
//*******************************************************************
void TBJAct2State::CreateSubState4()
{
  pOwnerLord->FreezeAllButtons();
  PActiveSubState = new TBJDealerExpoState(pOwnerLord);
}
//*******************************************************************
void TBJAct2State::CreateSubState5()
{
  if(pOwnerLord->BetSpotUse[0] != -1 ||
     pOwnerLord->BetSpotUse[1] != -1 ||
     pOwnerLord->BetSpotUse[2] != -1 ||
	  pOwnerLord->BetSpotUse[3] != -1 ||
     pOwnerLord->BetSpotUse[4] != -1 ||
     pOwnerLord->BetSpotUse[5] != -1 ||
	  pOwnerLord->BetSpotUse[6] != -1)
  {
	 PActiveSubState = new TBJDealerDrawState(pOwnerLord);
  }
}
//*******************************************************************
void TBJAct2State::CreateSubState6()
{
  PActiveSubState = new TBJWinnerState(pOwnerLord);
}
//*******************************************************************

