//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  bjaskex.cpp
//    Project Name:  Casino
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     12/29/95   A. Krist    Original baseline
//  2.0     09/23/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "bjaskex.h"
#include "cbjglord.h"
#include "casbjmw.h"
#include "bjhand.h"
#include "ogamefw.h"

#define DEALER_UP_CARD 0
//*******************************************************************
TBJAsk::TBJAsk(TCasinoBJGameLord *pNewBJLord)
{
  pOwnerLord = pNewBJLord;
  BJAction   = bjNone;
}
//*******************************************************************
TBJAsk::~TBJAsk()
{
}
//*******************************************************************
void TBJAsk::AskInsuranceExpert()
{
	 expertRecomString = TAppString(5245);
	 expertRecomString += TAppString(5246);
	 expertRecomString += TAppString(5247);

	 pOwnerLord->GetFW()->DisplayExpert(expertRecomString);
}
//*******************************************************************
void TBJAsk::AskBetExpert()
{
  expertRecomString = TAppString(5212);
  if(pOwnerLord->runningcount > 0)
  {
	 expertRecomString += TAppString(5210);
  }
  else if(pOwnerLord->runningcount < 0)
  {
	 expertRecomString += TAppString(5211);
  }
  switch(pOwnerLord->runningcount/10){
	 case  1 : expertRecomString += TAppString(5201);break;
	 case -1 : expertRecomString += TAppString(5201);break;
	 case  2 : expertRecomString += TAppString(5202);break;
	 case -2 : expertRecomString += TAppString(5202);break;
	 case  3 : expertRecomString += TAppString(5203);break;
	 case -3 : expertRecomString += TAppString(5203);break;
	 case  4 : expertRecomString += TAppString(5204);break;
	 case -4 : expertRecomString += TAppString(5204);break;
	 case  5 : expertRecomString += TAppString(5205);break;
	 case -5 : expertRecomString += TAppString(5205);break;
	 case  6 : expertRecomString += TAppString(5206);break;
	 case -6 : expertRecomString += TAppString(5206);break;
	 case  7 : expertRecomString += TAppString(5207);break;
	 case -7 : expertRecomString += TAppString(5207);break;
	 case  8 : expertRecomString += TAppString(5208);break;
	 case -8 : expertRecomString += TAppString(5208);break;
	 case  9 : expertRecomString += TAppString(5209);break;
	 case -9 : expertRecomString += TAppString(5209);break;
	 }
  switch(pOwnerLord->runningcount%10){
	 case  0 : expertRecomString += TAppString(5200);break;
	 case  1 : expertRecomString += TAppString(5201);break;
	 case -1 : expertRecomString += TAppString(5201);break;
	 case  2 : expertRecomString += TAppString(5202);break;
	 case -2 : expertRecomString += TAppString(5202);break;
	 case  3 : expertRecomString += TAppString(5203);break;
	 case -3 : expertRecomString += TAppString(5203);break;
	 case  4 : expertRecomString += TAppString(5204);break;
	 case -4 : expertRecomString += TAppString(5204);break;
	 case  5 : expertRecomString += TAppString(5205);break;
	 case -5 : expertRecomString += TAppString(5205);break;
	 case  6 : expertRecomString += TAppString(5206);break;
	 case -6 : expertRecomString += TAppString(5206);break;
	 case  7 : expertRecomString += TAppString(5207);break;
	 case -7 : expertRecomString += TAppString(5207);break;
	 case  8 : expertRecomString += TAppString(5208);break;
	 case -8 : expertRecomString += TAppString(5208);break;
	 case  9 : expertRecomString += TAppString(5209);break;
	 case -9 : expertRecomString += TAppString(5209);break;
  }
  expertRecomString += TAppString(5213);
  switch(pOwnerLord->halfdecksleft/10){
	 case 1 : expertRecomString += TAppString(5201);break;
	 case 2 : expertRecomString += TAppString(5202);break;
	 case 3 : expertRecomString += TAppString(5203);break;
	 case 4 : expertRecomString += TAppString(5204);break;
	 case 5 : expertRecomString += TAppString(5205);break;
	 case 6 : expertRecomString += TAppString(5206);break;
	 case 7 : expertRecomString += TAppString(5207);break;
	 case 8 : expertRecomString += TAppString(5208);break;
	 case 9 : expertRecomString += TAppString(5209);break;
  }
  switch(pOwnerLord->halfdecksleft%10){
	 case 0 : expertRecomString += TAppString(5200);break;
	 case 1 : expertRecomString += TAppString(5201);break;
	 case 2 : expertRecomString += TAppString(5202);break;
	 case 3 : expertRecomString += TAppString(5203);break;
	 case 4 : expertRecomString += TAppString(5204);break;
	 case 5 : expertRecomString += TAppString(5205);break;
	 case 6 : expertRecomString += TAppString(5206);break;
	 case 7 : expertRecomString += TAppString(5207);break;
	 case 8 : expertRecomString += TAppString(5208);break;
	 case 9 : expertRecomString += TAppString(5209);break;
  }
  expertRecomString += TAppString(5214);
  if(pOwnerLord->truecount > 0)
  {
	 expertRecomString += TAppString(5210);
  }
  else if(pOwnerLord->truecount < 0)
  {
	 expertRecomString += TAppString(5211);
  }
  switch(pOwnerLord->truecount/10){
	 case  1 : expertRecomString += TAppString(5201);break;
	 case -1 : expertRecomString += TAppString(5201);break;
	 case  2 : expertRecomString += TAppString(5202);break;
	 case -2 : expertRecomString += TAppString(5202);break;
	 case  3 : expertRecomString += TAppString(5203);break;
	 case -3 : expertRecomString += TAppString(5203);break;
	 case  4 : expertRecomString += TAppString(5204);break;
	 case -4 : expertRecomString += TAppString(5204);break;
	 case  5 : expertRecomString += TAppString(5205);break;
	 case -5 : expertRecomString += TAppString(5205);break;
	 case  6 : expertRecomString += TAppString(5206);break;
	 case -6 : expertRecomString += TAppString(5206);break;
	 case  7 : expertRecomString += TAppString(5207);break;
	 case -7 : expertRecomString += TAppString(5207);break;
	 case  8 : expertRecomString += TAppString(5208);break;
	 case -8 : expertRecomString += TAppString(5208);break;
	 case  9 : expertRecomString += TAppString(5209);break;
	 case -9 : expertRecomString += TAppString(5209);break;
	 }
  switch(pOwnerLord->truecount%10){
	 case 0  : expertRecomString += TAppString(5200);break;
	 case  1 : expertRecomString += TAppString(5201);break;
	 case -1 : expertRecomString += TAppString(5201);break;
	 case  2 : expertRecomString += TAppString(5202);break;
	 case -2 : expertRecomString += TAppString(5202);break;
	 case  3 : expertRecomString += TAppString(5203);break;
	 case -3 : expertRecomString += TAppString(5203);break;
	 case  4 : expertRecomString += TAppString(5204);break;
	 case -4 : expertRecomString += TAppString(5204);break;
	 case  5 : expertRecomString += TAppString(5205);break;
	 case -5 : expertRecomString += TAppString(5205);break;
	 case  6 : expertRecomString += TAppString(5206);break;
	 case -6 : expertRecomString += TAppString(5206);break;
	 case  7 : expertRecomString += TAppString(5207);break;
	 case -7 : expertRecomString += TAppString(5207);break;
	 case  8 : expertRecomString += TAppString(5208);break;
	 case -8 : expertRecomString += TAppString(5208);break;
	 case  9 : expertRecomString += TAppString(5209);break;
	 case -9 : expertRecomString += TAppString(5209);break;
  }
  expertRecomString += TAppString(5215);

  if(pOwnerLord->SubGameType == cbj1Deck)
  {
	 if(pOwnerLord->truecount > 0)
	 {
		switch(pOwnerLord->truecount){
		  case 1  : expertRecomString += TAppString(5202);break;
		  case 2  : expertRecomString += TAppString(5203);break;
		  case 3  : expertRecomString += TAppString(5204);break;
		  case 4  : expertRecomString += TAppString(5205);break;
		  default : expertRecomString += TAppString(5205);break;
		}
	 }
	 else
	 {
		expertRecomString += TAppString(5201);
	 }
  }
  else
  {
	 if(pOwnerLord->truecount > 0)
	 {
		switch(pOwnerLord->truecount){
		  case 1  : expertRecomString += TAppString(5202);break;
		  case 2  : expertRecomString += TAppString(5203);break;
		  case 3  : expertRecomString += TAppString(5205);break;
		  case 4  : expertRecomString += TAppString(5207);break;
		  case 5  : expertRecomString += TAppString(5209);break;
		  case 6  : expertRecomString += TAppString(5201);
						expertRecomString += TAppString(5201);break;
		  case 7  : expertRecomString += TAppString(5201);
						expertRecomString += TAppString(5203);break;
		  case 8  : expertRecomString += TAppString(5201);
						expertRecomString += TAppString(5205);break;
		  case 9  : expertRecomString += TAppString(5201);
						expertRecomString += TAppString(5207);break;
		  case 10 : expertRecomString += TAppString(5202);
						expertRecomString += TAppString(5200);break;
		  default : expertRecomString += TAppString(5202);
						expertRecomString += TAppString(5200);break;
		}
	 }
	 else
	 {
		expertRecomString += TAppString(5201);
	 }
  }
  if(pOwnerLord->totaldecks > 1)
  {
	 expertRecomString += TAppString(5216);
  }
  else
  {
	 expertRecomString += TAppString(5217);
  }
  pOwnerLord->GetFW()->DisplayExpert(expertRecomString);
}
//*******************************************************************
#pragma argsused
void TBJAsk::AskAfterFirstTwoCardsExpert(TBJHand *hand,int16 decks,bool show)
{
	expertRecomString = "No advice, sorry...";
	if(hand->highhand < 12)
	{
	  if(show)                 //1
	  {
	  expertRecomString  = TAppString(5221);
	  expertRecomString += TAppString(5222);
	  }
	  BJAction = bjHit;
	}
	else if(hand->lohand > 16)
	{
	  if(show)
	  {              //2
	  expertRecomString  = TAppString(5223);
	  expertRecomString += TAppString(5224);
	  }
		BJAction = bjStand;
	}
	else if( (hand->lohand < 17 && hand->lohand > 11) &&
				(pOwnerLord->pHand->cards[DEALER_UP_CARD].name >= Seven) )  //???
	{
	  if(show)
	  {                 //3
	  expertRecomString  = TAppString(5225);
	  expertRecomString += TAppString(5226);
	  expertRecomString += TAppString(5227);
	  }
	  BJAction = bjHit;
	}
	else if( (hand->lohand < 17 && hand->lohand > 12) &&
				(pOwnerLord->pHand->cards[DEALER_UP_CARD].name < Seven) )
	{
	  if(show)
	  {                    //4
	  expertRecomString  = TAppString(5228);
	  expertRecomString += TAppString(5229);
	  expertRecomString += TAppString(5230);
	  }
	  BJAction = bjStand;
	}
	else if( (hand->lohand == 12) &&
				((pOwnerLord->pHand->cards[DEALER_UP_CARD].name == Six ) ||
				 (pOwnerLord->pHand->cards[DEALER_UP_CARD].name == Five) ||
				 (pOwnerLord->pHand->cards[DEALER_UP_CARD].name == Four))  )
	{
	  if(show)
	  {                       //5
	  expertRecomString  = TAppString(5231);
	  expertRecomString += TAppString(5232);
	  expertRecomString += TAppString(5233);
	  }
	  BJAction = bjStand;
	}
	else if( (hand->lohand == 12) &&
				((pOwnerLord->pHand->cards[DEALER_UP_CARD].name == Two  ) ||
				 (pOwnerLord->pHand->cards[DEALER_UP_CARD].name == Three))  )
	{
	  if(show)
	  {                          //6
	  expertRecomString  = TAppString(5234);
	  expertRecomString += TAppString(5235);
	  expertRecomString += TAppString(5236);
	  }
	  BJAction = bjHit;
	}
	else if( (hand->lohand == (hand->highhand - 10)) &&
				 (hand->highhand < 18)  )
	{
	  if(show)
	  {                             //7
	  expertRecomString  = TAppString(5237);
	  expertRecomString += TAppString(5238);
	  expertRecomString += TAppString(5239);
	  }
	  BJAction = bjHit;
	}
	else if( ((hand->lohand == (hand->highhand - 10)) &&
				 (hand->highhand == 18)) &&
				 (pOwnerLord->pHand->cards[DEALER_UP_CARD].name < Nine)	)
	{
	  if(show)
	  {                                //8
	  expertRecomString  = TAppString(5240);
	  expertRecomString += TAppString(5241);
	  }
	  BJAction = bjStand;
	}
	else if( ((hand->lohand == (hand->highhand - 10)) &&
				 (hand->highhand == 18)) &&
				 (pOwnerLord->pHand->cards[DEALER_UP_CARD].name > Eight)	)
	{
	  if(show)
	  {                                   //9
	  expertRecomString  = TAppString(5242);
	  expertRecomString += TAppString(5243);
	  }
	  BJAction = bjHit;
	}
	else if( (hand->lohand == (hand->highhand - 10)) &&
				(hand->highhand > 18)  )
	{
	  if(show)
	  {                                      //10
	  expertRecomString  = TAppString(5244);
	  }
	  BJAction = bjStand;
	}
	if(show)
	{
	  pOwnerLord->GetFW()->DisplayExpert(expertRecomString);
	}
}
//*******************************************************************

