//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  bjaskex2.cpp
//    Project Name:  Casino
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     2/2/96     M.Perry    split up bjaskex into seperate cpp files.
//  2.0    09/23/97    M.Perry    32-bit conversion.
//********************************************************************
#include "bjaskex.h"
#include "cbjglord.h"
#include "casbjmw.h"
#include "bjhand.h"
#include "ogamefw.h"

#define DEALER_UP_CARD 0
//*******************************************************************
void TBJAsk::AskFirstTwoCardsExpert(TBJHand *hand,int16 decks,bool show)
{
  expertRecomString = "No advice, sorry...";
  bool Found = false;
  int xnorm=hand->cards[0].name,ynorm=hand->cards[1].name;
  if(xnorm > 9 && xnorm < 13){xnorm = 9;}
  if(ynorm > 9 && ynorm < 13){ynorm = 9;}

  if(decks > 1)
  {
	 if( (hand->cards[0].name == Two && hand->cards[1].name == Two) &&
		  (pOwnerLord->pHand->cards[DEALER_UP_CARD].name < Eight)    &&
		  (pOwnerLord->pHand->cards[DEALER_UP_CARD].name > Three)	   )
	 {
		  if(show)
		  {
			 expertRecomString  = TAppString(5411);
			 expertRecomString += TAppString(5412);
			 expertRecomString += TAppString(5413);
		  }
		  BJAction = bjSplit;
	 }
	 else if( (hand->cards[0].name == Three && hand->cards[1].name == Three) &&
		  (pOwnerLord->pHand->cards[DEALER_UP_CARD].name < Eight)    &&
		  (pOwnerLord->pHand->cards[DEALER_UP_CARD].name > Three)	   )
	 {
		  if(show)
		  {
			 expertRecomString  = TAppString(5414);
			 expertRecomString += TAppString(5415);
			 expertRecomString += TAppString(5416);
		  }
		  BJAction = bjSplit;
	 }
	 else if( ((hand->cards[0].name + hand->cards[1].name) < 7) &&   //if player total < 9
				  (pOwnerLord->pHand->cards[DEALER_UP_CARD].name < Ten) )
	 {
		if(show)
		{                       //11
		expertRecomString  = TAppString(5250);
		expertRecomString += TAppString(5251);
		expertRecomString += TAppString(5252);
		}
		BJAction = bjHit;
		Found = true;
	 }
	 else if( ((hand->cards[0].name + hand->cards[1].name) == 7) &&   //if player total = 9
				  (pOwnerLord->pHand->cards[DEALER_UP_CARD].name == Two) )
	 {
		if(show)
		{                       //12
		expertRecomString  = TAppString(5253);
		expertRecomString += TAppString(5254);
		expertRecomString += TAppString(5255);
		}
		Found = true;
		BJAction = bjHit;
	 }
	 else if( ((hand->cards[0].name + hand->cards[1].name) == 7) &&   //if player total = 9
				  (pOwnerLord->pHand->cards[DEALER_UP_CARD].name < Seven) )
	 {
		if(show)
		{                       //13
		expertRecomString  = TAppString(5256);
		expertRecomString += TAppString(5257);
		expertRecomString += TAppString(5258);
		}
		Found = true;
		BJAction = bjDouble;
	 }
	 else if( ((hand->cards[0].name + hand->cards[1].name) == 9) &&   //if player total = 11
				  (pOwnerLord->pHand->cards[DEALER_UP_CARD].name != AceHi) )
	 {
		if(show)
		{                       //14
		expertRecomString  = TAppString(5259);
		expertRecomString += TAppString(5260);
		expertRecomString += TAppString(5261);
		}
		Found = true;
		BJAction = bjDouble;
	 }
	 else if( (hand->cards[0].name + hand->cards[1].name) == 9)    //if player total = 11
	 {
		if(show)
		{                       //15
		expertRecomString  = TAppString(5262);
		expertRecomString += TAppString(5263);
		expertRecomString += TAppString(5264);
		}
		Found = true;
		BJAction = bjHit;
	 }
	 else if( ( ((hand->cards[0].name == AceHi) && (hand->cards[1].name < Four)) ||
					((hand->cards[0].name < Four) && (hand->cards[1].name == AceHi)) ) &&
					 (pOwnerLord->pHand->cards[DEALER_UP_CARD].name == Four) )
	 {
		  if(show)
		  {                            //16
		  expertRecomString  = TAppString(5265);
		  expertRecomString += TAppString(5266);
		  expertRecomString += TAppString(5267);
		  }
		  Found = true;
		  BJAction = bjHit;
	 }
	 else if( ( ((hand->cards[0].name == AceHi) && (hand->cards[1].name < Four)) ||
					((hand->cards[0].name < Four) && (hand->cards[1].name == AceHi)) ) &&
					 ( (pOwnerLord->pHand->cards[DEALER_UP_CARD].name == Five) ||
						(pOwnerLord->pHand->cards[DEALER_UP_CARD].name == Six) ) )
	 {
		  if(show)
		  {                            //17
		  expertRecomString  = TAppString(5268);
		  expertRecomString += TAppString(5269);
		  expertRecomString += TAppString(5270);
		  }
		  Found = true;
		  BJAction = bjDouble;
	 }
	 else if( ( ((hand->cards[0].name == AceHi) && (hand->cards[1].name == Four)) ||
					((hand->cards[0].name == Four) && (hand->cards[1].name == AceHi)) ||
					((hand->cards[1].name == Five) && (hand->cards[0].name == AceHi)) ||
					((hand->cards[0].name == Five) && (hand->cards[1].name == AceHi))   ) &&
					 ( (pOwnerLord->pHand->cards[DEALER_UP_CARD].name > Three) &&
						(pOwnerLord->pHand->cards[DEALER_UP_CARD].name < Seven) ) )
	 {
		  if(show)
		  {                            //18
		  expertRecomString  = TAppString(5271);
		  expertRecomString += TAppString(5272);
		  expertRecomString += TAppString(5273);
		  }
		  Found = true;
		  BJAction = bjDouble;
	 }
	 else if( ( ((hand->cards[0].name == AceHi) && (hand->cards[1].name == Six)) ||
					((hand->cards[0].name == Six) && (hand->cards[1].name == AceHi)) ) &&
					 (pOwnerLord->pHand->cards[DEALER_UP_CARD].name == Two) )
	 {
		  if(show)
		  {                            //19
		  expertRecomString  = TAppString(5274);
		  expertRecomString += TAppString(5275);
		  expertRecomString += TAppString(5276);
		  }
		  Found = true;
		  BJAction = bjHit;
	 }
	 else if( ( ((hand->cards[0].name == AceHi) && (hand->cards[1].name == Six)) ||
					((hand->cards[0].name == Six) && (hand->cards[1].name == AceHi)) ) &&
					 (pOwnerLord->pHand->cards[DEALER_UP_CARD].name < Seven) )
	 {
		  if(show)
		  {                            //20
		  expertRecomString  = TAppString(5277);
		  expertRecomString += TAppString(5278);
		  expertRecomString += TAppString(5279);
		  }
		  Found = true;
		  BJAction = bjDouble;
	 }
	 else if( (hand->cards[0].name == hand->cards[1].name) &&
				 (hand->cards[0].name < Four) &&
				 (pOwnerLord->pHand->cards[DEALER_UP_CARD].name < Four) )
	 {
		 if(show)
		  {                         //21
			 expertRecomString  = TAppString(5280);
			 expertRecomString += TAppString(5281);
			 expertRecomString += TAppString(5282);

		  }
		  Found = true;
		  BJAction = bjHit;
	 }
	 else if( (hand->cards[0].name == hand->cards[1].name) &&
				 (hand->cards[0].name < Four) &&
				 (pOwnerLord->pHand->cards[DEALER_UP_CARD].name > Three) &&
				 (pOwnerLord->pHand->cards[DEALER_UP_CARD].name < Eight) )
	 {
		 if(show)
		  {                         //22
			 expertRecomString  = TAppString(5283);
			 expertRecomString += TAppString(5284);
			 expertRecomString += TAppString(5285);

		  }
		  Found = true;
		  BJAction = bjSplit;
	 }
	 else if( (hand->cards[0].name == hand->cards[1].name) &&
				 (hand->cards[0].name == Six) &&
				 (pOwnerLord->pHand->cards[DEALER_UP_CARD].name == Two) )
	 {
		 if(show)
		  {                         //23
			 expertRecomString  = TAppString(5286);
			 expertRecomString += TAppString(5287);
		  }
		  Found = true;
		  BJAction = bjHit;
	 }
    else if( (hand->cards[0].name == hand->cards[1].name) &&
				 (hand->cards[0].name == Six) &&
				 (pOwnerLord->pHand->cards[DEALER_UP_CARD].name < Seven) )
	 {
		 if(show)
		  {                         //24
			 expertRecomString  = TAppString(5288);
			 expertRecomString += TAppString(5289);
			 expertRecomString += TAppString(5290);
		  }
		  Found = true;
		  BJAction = bjSplit;
	 }
  }
  if(!Found)
  {
	 if( (hand->cards[0].name == Two && hand->cards[1].name == Two) &&
		  (pOwnerLord->pHand->cards[DEALER_UP_CARD].name < Eight) )
	 {
		if(pOwnerLord->pHand->cards[DEALER_UP_CARD].name == Two)
		{
		  if(show)
		  {                         //25
			 expertRecomString  = TAppString(5291);
			 expertRecomString += TAppString(5292);
			 expertRecomString += TAppString(5293);
		  }
		  BJAction = bjHit;
		}
		else
		{
		  if(show)
		  {                             //26
			 expertRecomString  = TAppString(5294);
			 expertRecomString += TAppString(5295);
			 expertRecomString += TAppString(5296);
		  }
		  BJAction = bjSplit;
		}
	 }
	 else if( (hand->cards[0].name == Two && hand->cards[1].name == Two) &&
				 (pOwnerLord->pHand->cards[DEALER_UP_CARD].name >= Eight  )   )
	 {
		 if(show)
		  {                         //27
			 expertRecomString  = TAppString(5297);
			 expertRecomString += TAppString(5298);
		  }
		  BJAction = bjHit;
	 }
	 else if( (hand->cards[0].name == Three && hand->cards[1].name == Three) &&
				 (pOwnerLord->pHand->cards[DEALER_UP_CARD].name < Four) )
	 {
		if(show)
		{                                 //28
		  expertRecomString  = TAppString(5299);
		  expertRecomString += TAppString(5300);
		  expertRecomString += TAppString(5301);
		}
		BJAction = bjHit;
	 }
	 else if( (hand->cards[0].name == Three && hand->cards[1].name == Three) &&
				 (pOwnerLord->pHand->cards[DEALER_UP_CARD].name < Eight) )
	 {
		if(show)
		{                                 //29
		  expertRecomString  = TAppString(5302);
		  expertRecomString += TAppString(5303);
		  expertRecomString += TAppString(5304);
		}
		BJAction = bjSplit;
	 }
	 else if( (hand->cards[0].name == Three && hand->cards[1].name == Three) )
	 {
		if(show)
		{                                 //30
		  expertRecomString  = TAppString(5305);
		  expertRecomString += TAppString(5306);
		  expertRecomString += TAppString(5307);
		}
		BJAction = bjHit;
	 }
	 else if( (hand->cards[0].name == Five && hand->cards[1].name == Five) &&
		  (pOwnerLord->pHand->cards[DEALER_UP_CARD].name <= Nine) )
	 {
		  if(show)
		  {                           //31
			 expertRecomString  = TAppString(5308);
			 expertRecomString += TAppString(5309);
			 expertRecomString += TAppString(5310);
		  }
		  BJAction = bjDouble;
	 }
	 else if( (hand->cards[0].name == Six && hand->cards[1].name == Six) &&
				 (pOwnerLord->pHand->cards[DEALER_UP_CARD].name < Seven) )
	 {
		  if(show)
		  {                  //32
		  expertRecomString  = TAppString(5311);
		  expertRecomString += TAppString(5312);
		  expertRecomString += TAppString(5313);
		  }
		  BJAction = bjSplit;
	 }
	 else if( (hand->cards[0].name == Six && hand->cards[1].name == Six) &&
				 (pOwnerLord->pHand->cards[DEALER_UP_CARD].name > Six) )
	 {
		  if(show)
		  {                  //33
		  expertRecomString  = TAppString(5314);
		  expertRecomString += TAppString(5315);
		  expertRecomString += TAppString(5316);
		  }
		  BJAction = bjSplit;
	 }
	 else if( (hand->cards[0].name == Seven && hand->cards[1].name == Seven) &&
				 (pOwnerLord->pHand->cards[DEALER_UP_CARD].name < Eight) )
	 {
		if(show)
		{                           //34
		expertRecomString  = TAppString(5317);
		expertRecomString += TAppString(5318);
		expertRecomString += TAppString(5319);
		}
		BJAction = bjSplit;
	 }
	 else if( (hand->cards[0].name == Seven && hand->cards[1].name == Seven) &&
				 (pOwnerLord->pHand->cards[DEALER_UP_CARD].name > Seven) )
	 {
		if(show)
		{                           //35
		expertRecomString  = TAppString(5320);
		expertRecomString += TAppString(5321);
		expertRecomString += TAppString(5322);
		}
		BJAction = bjSplit;
	 }
	 else if(hand->cards[0].name == Eight && hand->cards[1].name == Eight)
	 {
		if(show)
		{                               //36
		expertRecomString  = TAppString(5323);
		expertRecomString += TAppString(5324);
		expertRecomString += TAppString(5325);
		}
		BJAction = bjSplit;
	 }
	 else if( (hand->cards[0].name == Nine && hand->cards[1].name == Nine) &&
					(pOwnerLord->pHand->cards[DEALER_UP_CARD].name < Seven)    )
	 {
		if(show)
		{                                      //37
		expertRecomString  = TAppString(5326);
		expertRecomString += TAppString(5327);
		}
		BJAction = bjSplit;
	 }
	 else if( (hand->cards[0].name == Nine && hand->cards[1].name == Nine) &&
					(pOwnerLord->pHand->cards[DEALER_UP_CARD].name == Seven)    )
	 {
		if(show)
		{                                      //38
		expertRecomString  = TAppString(5328);
		expertRecomString += TAppString(5329);
		}
		BJAction = bjStand;
	 }
	 else if( (hand->cards[0].name == Nine && hand->cards[1].name == Nine) &&
					(pOwnerLord->pHand->cards[DEALER_UP_CARD].name <= Nine)    )
	 {
		if(show)
		{                                      //39
		expertRecomString  = TAppString(5330);
		expertRecomString += TAppString(5331);
		expertRecomString += TAppString(5332);
		}
		BJAction = bjSplit;
	 }
	 else if(hand->cards[0].name == Nine && hand->cards[1].name == Nine)
	 {
		if(show)
		{                                      //40
		expertRecomString  = TAppString(5333);
		expertRecomString += TAppString(5334);
		expertRecomString += TAppString(5335);
		}
		BJAction = bjStand;
	 }
	 else if(hand->cards[0].name == AceHi && hand->cards[1].name == AceHi)
	 {
		if(show)
		{                                     //41
		expertRecomString  = TAppString(5336);
		expertRecomString += TAppString(5337);
		expertRecomString += TAppString(5338);
		}
		BJAction = bjSplit;
	 }////////////////////////////////////////////////////////////////////////////
	 else if( ( ((hand->cards[0].name == AceHi) && (hand->cards[1].name < Six)) ||
					((hand->cards[0].name < Six) && (hand->cards[1].name == AceHi)) ) &&
				 ((pOwnerLord->pHand->cards[DEALER_UP_CARD].name == Two) ||
				  (pOwnerLord->pHand->cards[DEALER_UP_CARD].name == Three))   )
	 {
		  if(show)
		  {                            //42
		  expertRecomString  = TAppString(5339);
		  expertRecomString += TAppString(5340);
		  expertRecomString += TAppString(5341);
		  }
		  BJAction = bjHit;
	 }
	 else if( ( ((hand->cards[0].name == AceHi) && (hand->cards[1].name < Six)) ||
					((hand->cards[0].name < Six) && (hand->cards[1].name == AceHi)) ) &&
				 ((pOwnerLord->pHand->cards[DEALER_UP_CARD].name == Four) ||
				  (pOwnerLord->pHand->cards[DEALER_UP_CARD].name == Six)  ||
				  (pOwnerLord->pHand->cards[DEALER_UP_CARD].name == Five))   )
	 {
		  if(show)
		  {                            //43
		  expertRecomString  = TAppString(5342);
		  expertRecomString += TAppString(5343);
		  expertRecomString += TAppString(5344);
		  }
		  BJAction = bjDouble;
	 }
	 else if( ( ((hand->cards[0].name == AceHi) && (hand->cards[1].name < Six)) ||
					((hand->cards[0].name < Six) && (hand->cards[1].name == AceHi)) ) &&
					 (pOwnerLord->pHand->cards[DEALER_UP_CARD].name > Six)   )
	 {
		  if(show)
		  {                            //44
		  expertRecomString  = TAppString(5345);
		  expertRecomString += TAppString(5346);
		  expertRecomString += TAppString(5347);
		  }
		  BJAction = bjHit;
	 }
	 else if( ( ((hand->cards[0].name == AceHi) && (hand->cards[1].name == Six)) ||
					((hand->cards[0].name == Six) && (hand->cards[1].name == AceHi)) ) &&
					 (pOwnerLord->pHand->cards[DEALER_UP_CARD].name < Seven)   )
	 {
		  if(show)
		  {                            //45
		  expertRecomString  = TAppString(5348);
		  expertRecomString += TAppString(5349);
		  expertRecomString += TAppString(5350);
		  }
		  BJAction = bjDouble;
	 }
	 else if( ( ((hand->cards[0].name == AceHi) && (hand->cards[1].name == Six)) ||
					((hand->cards[0].name == Six) && (hand->cards[1].name == AceHi)) ) &&
					 (pOwnerLord->pHand->cards[DEALER_UP_CARD].name > Six)   )
	 {
		  if(show)
		  {                            //46
		  expertRecomString  = TAppString(5351);
		  expertRecomString += TAppString(5352);
		  }
		  BJAction = bjHit;
	 }
	 else if( ( ((hand->cards[0].name == AceHi) && (hand->cards[1].name == Seven)) ||
					((hand->cards[0].name == Seven) && (hand->cards[1].name == AceHi)) ) &&
					 (pOwnerLord->pHand->cards[DEALER_UP_CARD].name == Two)   )
	 {
		  if(show)
		  {                            //47
		  expertRecomString  = TAppString(5353);
		  expertRecomString += TAppString(5354);
		  expertRecomString += TAppString(5355);
		  }
		  BJAction = bjStand;
	 }
	 else if( ( ((hand->cards[0].name == AceHi) && (hand->cards[1].name == Seven)) ||
					((hand->cards[0].name == Seven) && (hand->cards[1].name == AceHi)) ) &&
					 (pOwnerLord->pHand->cards[DEALER_UP_CARD].name < Seven)   )
	 {
		  if(show)
		  {                            //48
		  expertRecomString  = TAppString(5356);
		  expertRecomString += TAppString(5357);
		  }
		  BJAction = bjDouble;
	 }
	 else if( ( ((hand->cards[0].name == AceHi) && (hand->cards[1].name == Seven)) ||
					((hand->cards[0].name == Seven) && (hand->cards[1].name == AceHi)) ) &&
					 (pOwnerLord->pHand->cards[DEALER_UP_CARD].name < Nine)   )
	 {
		  if(show)
		  {                            //49
		  expertRecomString  = TAppString(5358);
		  expertRecomString += TAppString(5359);
		  expertRecomString += TAppString(5360);
		  }
		  BJAction = bjStand;
	 }
	 else if( ( ((hand->cards[0].name == AceHi) && (hand->cards[1].name == Seven)) ||
					((hand->cards[0].name == Seven) && (hand->cards[1].name == AceHi)) ) &&
					 (pOwnerLord->pHand->cards[DEALER_UP_CARD].name > Eight)   )
	 {
		  if(show)
		  {                            //50
		  expertRecomString  = TAppString(5361);
		  expertRecomString += TAppString(5362);
		  expertRecomString += TAppString(5363);
		  }
		  BJAction = bjHit;
	 }
	 else if( ((hand->cards[0].name == AceHi) && (hand->cards[1].name == Eight)) ||
				 ((hand->cards[0].name == Eight) && (hand->cards[1].name == AceHi)) ||
				 ((hand->cards[0].name == AceHi) && (hand->cards[1].name == Nine )) ||
				 ((hand->cards[0].name == Nine)  && (hand->cards[1].name == AceHi))    )
	 {
		  if(show)
		  {                            //51
		  expertRecomString  = TAppString(5364);
		  expertRecomString += TAppString(5365);
		  }
		  BJAction = bjStand;
	 }
	 else if( (hand->cards[0].name + hand->cards[1].name) < 6)    //if player total < 8
	 {
		  if(show)
		  {                           //52
		  expertRecomString  = TAppString(5366);
		  expertRecomString += TAppString(5367);
		  }
		  BJAction = bjHit;
	 }
	 else if( ((hand->cards[0].name + hand->cards[1].name) == 6) &&    //if player total = 8
				  (pOwnerLord->pHand->cards[DEALER_UP_CARD].name < Five))
	 {
		  if(show)
		  {                           //53
		  expertRecomString  = TAppString(5368);
		  expertRecomString += TAppString(5369);
		  }
		  BJAction = bjHit;
	 }
	 else if( ( ((hand->cards[0].name == Two) && (hand->cards[1].name == Six)) ||
					((hand->cards[0].name == Six) && (hand->cards[1].name == Two)) ) &&
				 ((pOwnerLord->pHand->cards[DEALER_UP_CARD].name == Five) ||
				  (pOwnerLord->pHand->cards[DEALER_UP_CARD].name == Six ))   )
	 {
		  if(show)
		  {                          //54
		  expertRecomString  = TAppString(5370);
		  expertRecomString += TAppString(5371);
		  expertRecomString += TAppString(5372);
		  }
		  BJAction = bjHit;
	 }
	 else if( ( ((hand->cards[0].name == Three) && (hand->cards[1].name == Five)) ||
					((hand->cards[0].name == Five) && (hand->cards[1].name == Three)) ) &&
				 ((pOwnerLord->pHand->cards[DEALER_UP_CARD].name == Five) ||
				  (pOwnerLord->pHand->cards[DEALER_UP_CARD].name == Six ))   )
	 {
		  if(show)
		  {                           //55
		  expertRecomString  = TAppString(5373);
		  expertRecomString += TAppString(5374);
		  expertRecomString += TAppString(5375);
		  }
		  BJAction = bjDouble;
	 }
	 else if( ((hand->cards[0].name == Four) && (hand->cards[1].name == Four)) &&
				 ((pOwnerLord->pHand->cards[DEALER_UP_CARD].name == Five) ||
				  (pOwnerLord->pHand->cards[DEALER_UP_CARD].name == Six ))   )
	 {
		  if(show)
		  {                           //56
		  expertRecomString  = TAppString(5376);
		  expertRecomString += TAppString(5377);
		  expertRecomString += TAppString(5378);
		  }
		  BJAction = bjDouble;
	 }
	 else if( ((hand->cards[0].name + hand->cards[1].name) == 6) &&   //if player total = 8
				  (pOwnerLord->pHand->cards[DEALER_UP_CARD].name > Six) )
	 {
		  if(show)
		  {                             //57
		  expertRecomString  = TAppString(5379);
		  expertRecomString += TAppString(5380);
		  }
		  BJAction = bjHit;
	 }
	 else if( ((hand->cards[0].name + hand->cards[1].name) == 7) &&   //if player total = 9
				  (pOwnerLord->pHand->cards[DEALER_UP_CARD].name < Seven) )
	 {
		  if(show)
		  {                             //58
		  expertRecomString  = TAppString(5381);
		  expertRecomString += TAppString(5382);
		  expertRecomString += TAppString(5383);
		  }
		  BJAction = bjDouble;
	 }
	 else if( (hand->cards[0].name + hand->cards[1].name) == 7)    //if player total = 9
	 {
		  if(show)
		  {                             //59
		  expertRecomString  = TAppString(5384);
		  expertRecomString += TAppString(5385);
		  expertRecomString += TAppString(5386);
		  }
		  BJAction = bjHit;
	 }
	 else if( ((hand->cards[0].name + hand->cards[1].name) == 8) &&   //if player total = 10
				  (pOwnerLord->pHand->cards[DEALER_UP_CARD].name < Ten) )
	 {
		if(show)
		{                       //60
		expertRecomString  = TAppString(5387);
		expertRecomString += TAppString(5388);
		}
		BJAction = bjDouble;
	 }
	 else if((hand->cards[0].name + hand->cards[1].name) == 8)    //if player total = 10
	 {
		  if(show)
		  {                              //61
		  expertRecomString  = TAppString(5389);
		  expertRecomString += TAppString(5390);
		  expertRecomString += TAppString(5391);
		  }
		  BJAction = bjHit;
	 }
	 else if(hand->highhand == 11)
	 {
		if(show)
		{                               //62
		expertRecomString  = TAppString(5392);
		expertRecomString += TAppString(5393);
		expertRecomString += TAppString(5394);
		}
		BJAction = bjDouble;
	 }
	 else if( ((xnorm + ynorm) == 10) &&   //if player total = 12
				  (pOwnerLord->pHand->cards[DEALER_UP_CARD].name < Four) )
	 {
		if(show)
		{                           //63
		expertRecomString  = TAppString(5395);
		expertRecomString += TAppString(5396);
		expertRecomString += TAppString(5397);
		}
		BJAction = bjHit;
	 }
	 else if( ((xnorm + ynorm) == 10) &&   //if player total = 12
				  ((pOwnerLord->pHand->cards[DEALER_UP_CARD].name == Four) ||
					(pOwnerLord->pHand->cards[DEALER_UP_CARD].name == Five) ||
					(pOwnerLord->pHand->cards[DEALER_UP_CARD].name == Six )   )    )
	 {
		if(show)
		{                               //64
		expertRecomString  = TAppString(5398);
		expertRecomString += TAppString(5399);
		expertRecomString += TAppString(5400);
		}
		BJAction = bjStand;
	 }
	 else if( ((hand->highhand == 12) ||  //12
				  (hand->highhand == 13) ||  //13
				  (hand->highhand == 14) ||  //14
				  (hand->highhand == 15) ||  //15
				  (hand->highhand == 16)   ) &&   //16
				  (pOwnerLord->pHand->cards[DEALER_UP_CARD].name > Six) )
	 {
		if(show)
		{                           //65
		expertRecomString  = TAppString(5401);
		expertRecomString += TAppString(5402);
		expertRecomString += TAppString(5403);
		}
		BJAction = bjHit;
	 }
	 else if( ((hand->highhand == 13) ||  //13
				  (hand->highhand == 14) ||  //14
				  (hand->highhand == 15) ||  //15
				  (hand->highhand == 16)   ) &&   //16
				  (pOwnerLord->pHand->cards[DEALER_UP_CARD].name < Seven) )
	 {
		if(show)
		{                              //66
		expertRecomString  = TAppString(5404);
		expertRecomString += TAppString(5405);
		expertRecomString += TAppString(5406);
		}
		BJAction = bjStand;
	 }
	 else if( (hand->cards[0].name > Nine) && (hand->cards[0].name < AceHi) &&
				 (hand->cards[1].name > Nine) && (hand->cards[1].name < AceHi)  )
	 {
		  if(show)
		  {                           //67
		  expertRecomString  = TAppString(5407);
		  expertRecomString += TAppString(5408);
		  }
		  BJAction = bjStand;
	 }
	 else if(hand->lohand > 16)
	 {
	  if(show)
	  {                            //68
	  expertRecomString  = TAppString(5409);
	  expertRecomString += TAppString(5410);
	  }
		BJAction = bjStand;
	 }
  }
  if(show)
  {
	 pOwnerLord->GetFW()->DisplayExpert(expertRecomString);
  }
}
//*******************************************************************