//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  bjbs3st.cpp    // bet spot 3 state
//    Project Name:  Ogle
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     06/22/95   A. Krist    Original baseline
//  2.0     09/24/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "bjbs3st.h"
#include "cbjglord.h"
#include "otimers.h"
#include "bjdealst.h"
#include "bjbustst.h"
#include "cbjplay.h"
#include "bjdeck.h"
#include "bjs5st.h"
#include "bjs6st.h"
//#include "cbjglspl.h"
#include <iostream.h>
#include "orespond.h"
//*******************************************************************
TBJBetSpot3State::TBJBetSpot3State(TCasinoBJGameLord *pNewBJLord)
:TBJLordState(pNewBJLord)
{
  SetRunOrder(ess_Execute,ess_StartSubState4,ess_Done,
				  ess_Done,ess_Execute,ess_StartSubState2);
  RemoveDoubleResponder       = NULL;
  ClearNoInsureStandResponder = NULL;
  SameYesInsureHitResponder   = NULL;
  DealSplitResponder          = NULL;
  splitflag                   = false;
  doubleflag                  = false;
  splitbutton                 = false;
  pOwnerLord->splitwait       = false;
  StartingFUC = 0;
  FUCLength   = 0;
  MenuEscResponder            = NULL;
  AskExpertResponder          = NULL;

  askexpertflag               = false;
  firsttwocards               = true;
  WaitOnSkit                  = false;

}
//*******************************************************************
TBJBetSpot3State::~TBJBetSpot3State()
{
 // pOwnerLord->CasStatusBar->NoShowStatusBar();
 pOwnerLord->FreezeAllButtons();
 pOwnerLord->Circle3->NoShow();
}
//*******************************************************************
void TBJBetSpot3State::HandlePostUpdate(dword NewFUC)
{
  if(pOwnerLord->ButtonHit[bjidButton2])
  {
	 LockHit = false;
	 Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	 pOwnerLord->ButtonClear(bjidButton2);
	 return;
  }
  if(pOwnerLord->ButtonHit[bjidButton3])
  {
	 pOwnerLord->ButtonClear(bjidButton3);
	 return;
  }
  if(pOwnerLord->ButtonHit[bjidButton1])
  {
	 pOwnerLord->ButtonClear(bjidButton1);
	 return;
  }
  if(pOwnerLord->ButtonHit[bjidButton0])
  {
	 if(!askexpertflag)
	 {
		askexpertflag = true;
	 }
	 else
	 {
		if(firsttwocards)
		{
		  pOwnerLord->AskFirstTwoCardsExpert(5);
		}
		else
		{
		  pOwnerLord->AskAfterFirstTwoCardsExpert(5);
		}
		pOwnerLord->ButtonClear(bjidButton0);
		askexpertflag = false;
	 }
	 LockHit = false;
	 Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	 return;
  }
  if(ExpertDelayStart)
  {
	 if(ExpertDelayStart + EXPERTDELAY <= NewFUC)
	 {
		ExpertDelayStart = 0;
  //		pOwnerLord->AskExpertButton->Release();
	 }
  }
  if(WaitOnSkit)
  {
	 if((StartingFUC != 0) && ((StartingFUC + FUCLength) <= NewFUC))
	 {
		StartingFUC = 0;
		FUCLength   = 0;
		WaitOnSkit  = false;
		if(!FinishHit && !FinishStand && !FinishDouble)
		{
		  pOwnerLord->UnFreezeAllButtons();
		}
		if(LockHit)
		{
		  LockHit = false;
		  LockButtons = false;
		  if(HitTotal)
		  {
			 if(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->pHand5->highhand == 21 ||
				 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->pHand5->lohand == 21)
			 {
			   ExecuteWaiting = false;
	         ExecuteStatus  = ess_StartSubState2;
			 }
		    HitTotal = false;
		  }
		}
	 }
	 //??return;//?
  }
  if(!WaitOnSkit && WaitOnHitCom)
  {
	 StartingFUC = pOwnerLord->GetAdjFUC();
	 pOwnerLord->HitComPlayer3(StartingFUC,FUCLength);
    pOwnerLord->FreezeAllButtons();
	 WaitOnSkit    = true;
	 WaitOnHitCom  = false;
	 FinishHit     = true;
  }
  if(!WaitOnSkit && FinishHit)
  {
	 ExecuteWaiting = false;
	 ExecuteStatus  = ess_StartSubState4;
	 FinishHit = false;
  }
  if(!WaitOnSkit && WaitOnStandCom)
  {
	 StartingFUC = pOwnerLord->GetAdjFUC();
	 pOwnerLord->StandComPlayer3(StartingFUC,FUCLength);
    pOwnerLord->FreezeAllButtons();
	 WaitOnSkit    = true;
	 WaitOnStandCom  = false;
	 FinishStand     = true;
  }
  if(!WaitOnSkit && FinishStand)
  {
	 ExecuteWaiting = false;
	 ExecuteStatus  = ess_StartSubState2;
	 FinishStand = false;
  }
  if(!WaitOnSkit && WaitOnDoubleCom)
  {
	 StartingFUC = pOwnerLord->GetAdjFUC();
	 pOwnerLord->DoubleComPlayer3(StartingFUC,FUCLength);
    pOwnerLord->FreezeAllButtons();
	 WaitOnSkit    = true;
	 WaitOnDoubleCom  = false;
	 FinishDouble     = true;
  }
  if(!WaitOnSkit && FinishDouble)
  {
	 ExecuteWaiting = false;
	 ExecuteStatus  = ess_StartSubState4;
	 FinishDouble = false;
  }
  if((Stalling + TCasinoBJGameLord::STALLDELAY) <= NewFUC)
  {
//	 StartingFUC = PTimePtr->GetFrameUpdateCount() + 1;
    StartingFUC = pOwnerLord->GetAdjFUC();
	 pOwnerLord->Stalling(StartingFUC,FUCLength);
    pOwnerLord->FreezeAllButtons();
	 WaitOnSkit    = true;
	 Stalling      = NewFUC + FUCLength;
  }
  if(pOwnerLord->ButtonHit[bjidButton16])
  {
	 if(StartingFUC == 0)
	 {
		CoachStats(5,bjStand,firsttwocards);
		Coach(5,bjStand);
	 }
	 if(IgnoreCoach)
	 {
		LockHit = false;
		pOwnerLord->ButtonClear(bjidButton16);
	  //	CoachStats(1,bjStand,firsttwocards);
	  //	Coach(1,bjStand);
		Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
      pOwnerLord->StallsInRow = 0;
		LockButtons = false;
		return;
	 }
	 if(StartingFUC)
	 {
		if(StartingFUC + FUCLength == NewFUC)
		{
		  WaitOnStandCom = true;
		  LockHit = false;
		  pOwnerLord->ButtonClear(bjidButton16);
		  Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
        pOwnerLord->StallsInRow = 0;
		  LockButtons = false;
		  StartingFUC = 0;
		  FUCLength   = 0;
		  return;
		}
	 }
	 else
	 {
		StartingFUC = pOwnerLord->GetAdjFUC();
		bool mf=true;
		pOwnerLord->FreezeAllButtons();
		pOwnerLord->StandFingers(mf,bjnl3F,StartingFUC,FUCLength);
	 }
	 return;
  }
  if(pOwnerLord->ButtonHit[bjidButton14])
  {
	 if(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->pHand5->inhand < 3)
	 {
		CoachStats(5,bjDouble,firsttwocards);
		Coach(5,bjDouble);
		if(IgnoreCoach)
		{
		  pOwnerLord->ButtonClear(bjidButton14);
		  LockButtons = false;
		  return;
		}

		LockHit = false;
		pOwnerLord->ButtonClear(bjidButton14);
		pOwnerLord->DoubleDown(5);
		doubleflag = true;
		Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
      pOwnerLord->StallsInRow = 0;
		WaitOnDoubleCom = true;
		pOwnerLord->FreezeAllButtons();
	 }

	 return;
  }
  if(pOwnerLord->ButtonHit[bjidButton13])
  {
	 if(!LockButtons && pOwnerLord->GetCash(pOwnerLord->activeplayer) >=
	 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->coinsplayedhand5)
	 {
		if((pOwnerLord->BetSpotUse[4] == -1 || pOwnerLord->BetSpotUse[6] == -1) &&
		pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->numsplitshand5 < 2 &&
		pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->pHand5->inhand < 3 &&
	 ((pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->pHand5->cards[0].name ==
		pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->pHand5->cards[1].name) ||
	  (pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->pHand5->cards[0].name >= Ten &&
		pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->pHand5->cards[0].name < AceHi) &&
	  (pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->pHand5->cards[1].name >= Ten &&
		pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->pHand5->cards[1].name < AceHi)) )
	  {
		 CoachStats(5,bjSplit,firsttwocards);
		 Coach(5,bjSplit);
		 if(IgnoreCoach)
		 {
			pOwnerLord->ButtonClear(bjidButton13);
			LockButtons = false;
			return;
		 }
		 if (pOwnerLord->BetSpotUse[4] == -1)
		 {
			LockButtons = false;
			ExecuteWaiting = false;
			ExecuteStatus = ess_StartSubState1;
			splitflag = true;
			pOwnerLord->BetSpot[5]->NoShowCard(1);
			pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->numsplitshand5++;
         pOwnerLord->FreezeAllButtons();
		 }
		 else if (pOwnerLord->BetSpotUse[6] == -1)
		 {
			pOwnerLord->Button13->ShowGray();
			ExecuteWaiting = false;
			ExecuteStatus = ess_StartSubState4;
			pOwnerLord->splitwait = true;
			splitflag = true;
			pOwnerLord->BetSpot[5]->NoShowCard(1);
			pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->numsplitshand5++;

			pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->pHand6 = new TBJHand;
			pOwnerLord->BetSpotUse[6] = pOwnerLord->BetSpotUse[5];
			pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[6])->coinsplayedhand6
				= pOwnerLord->SplitMoney(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->coinsplayedhand5);

			pOwnerLord->BetSpot[6]->
				SetNum(pOwnerLord->GetBJPlayer(pOwnerLord->activeplayer)->coinsplayedhand6);

			pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[6])->pHand6->cards[0] =
				pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->pHand5->cards[1];
			pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[6])->pHand6->inhand++;
			pOwnerLord->BetSpot[6]->ShowFace(
						  pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[6])->pHand6);

			pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->pHand5->inhand--;
			pOwnerLord->FreezeAllButtons();
		 }
       Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
       pOwnerLord->StallsInRow = 0;
		 pOwnerLord->ButtonClear(bjidButton13);
	  }
	 }
    Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	 pOwnerLord->ButtonClear(bjidButton13);
	 return;
  }
  if(pOwnerLord->ButtonHit[bjidButton15])
  {
	 if(StartingFUC == 0)
	 {
		CoachStats(5,bjHit,firsttwocards);
		Coach(5,bjHit);
	 }
	 if(IgnoreCoach)
	 {
		Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
      pOwnerLord->StallsInRow = 0;
		pOwnerLord->ButtonClear(bjidButton15);
		LockButtons = false;
		return;
	 }
	 if(StartingFUC)
	 {
		if(StartingFUC + FUCLength <= NewFUC)
		{
		  WaitOnHitCom = true;
		  Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
        pOwnerLord->StallsInRow = 0;
		  pOwnerLord->ButtonClear(bjidButton15);
		  StartingFUC = 0;
		  FUCLength   = 0;
		  return;
		}
	 }
	 else
	 {
		pOwnerLord->Button14->ShowGray();
		pOwnerLord->Button13->ShowGray();
		firsttwocards = false;
		StartingFUC = pOwnerLord->GetAdjFUC();
		bool mf=true;
		pOwnerLord->FreezeAllButtons();
		pOwnerLord->HitFingers(mf,bjnl3F,StartingFUC,FUCLength);
	 }
	 return;
  }
}
//*******************************************************************
bool TBJBetSpot3State::HandleRemoveDouble(TResponder &responder)
{
 if(!LockButtons && pOwnerLord->GetCash(pOwnerLord->activeplayer) > 0)
 {
  if(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->pHand5->inhand < 3)
  {
	 if (responder.GetResponseEvent() == reLUp)
	 {
		CoachStats(5,bjDouble,firsttwocards);
		Coach(5,bjDouble);
		RemoveDoubleResponder = &responder;
		LockButtons = true;
	 }

	 if (responder.GetResponseEvent() == reLDown)
	 {
//		Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
      Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
      pOwnerLord->StallsInRow = 0;
//		pOwnerLord->RemoveDouble->ShowDoubleDown();
		responder.SetPriority();
	 }

	 if (responder.GetResponseEvent() == reChar)
	 {
//		Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
      Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
      pOwnerLord->StallsInRow = 0;
	 //	pOwnerLord->RemoveDouble->ShowDoubleDown();
		RemoveDoubleResponder = &responder;
	 }
  }
 }
 return true;
}
//*******************************************************************
bool TBJBetSpot3State::HandleClearNoInsureStand(TResponder &responder)
{
 if(!LockButtons)
 {
  if (responder.GetResponseEvent() == reLUp)
  {
	 CoachStats(5,bjStand,firsttwocards);
	 Coach(5,bjStand);
	 ClearNoInsureStandResponder = &responder;
	 LockButtons = true;
  }

  if (responder.GetResponseEvent() == reLDown)
  {
//	 Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
    Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
 //	 pOwnerLord->ClearNoInsureStand->ShowStandDown();
  //	 pOwnerLord->RemoveDouble->ShowDouble();
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
//	 Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
    Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	 //pOwnerLord->ClearNoInsureStand->ShowStandDown();
	 //pOwnerLord->RemoveDouble->ShowDouble();
	 ClearNoInsureStandResponder = &responder;
  }
 }
 return true;
}
//*******************************************************************
bool TBJBetSpot3State::HandleSameYesInsureHit(TResponder &responder)
{
 if(!LockButtons)
 {
  if (responder.GetResponseEvent() == reLUp)
  {
	 CoachStats(5,bjHit,firsttwocards);
	 Coach(5,bjHit);
	 SameYesInsureHitResponder = &responder;
	 LockButtons = true;
  }

  if (responder.GetResponseEvent() == reLDown)
  {
//	 Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
    Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	 //pOwnerLord->SameYesInsureHit->ShowHitDown();
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
//	 Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
    Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
  //	 pOwnerLord->SameYesInsureHit->ShowHitDown();
	 SameYesInsureHitResponder = &responder;
  }
 }
 return true;
}
//*******************************************************************
bool TBJBetSpot3State::HandleDealSplit(TResponder &responder)
{
 if(!LockButtons && pOwnerLord->GetCash(pOwnerLord->activeplayer) >=
	 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->coinsplayedhand5)
 {
  if((pOwnerLord->BetSpotUse[4] == -1 || pOwnerLord->BetSpotUse[6] == -1) &&
		pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->numsplitshand5 < 2 &&
		pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->pHand5->inhand < 3 &&
	 ((pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->pHand5->cards[0].name ==
		pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->pHand5->cards[1].name) ||
	  (pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->pHand5->cards[0].name >= Ten &&
		pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->pHand5->cards[0].name < AceHi) &&
	  (pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->pHand5->cards[1].name >= Ten &&
		pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->pHand5->cards[1].name < AceHi)) )
  {
	 if (responder.GetResponseEvent() == reLUp)
	 {
		CoachStats(5,bjSplit,firsttwocards);
		Coach(5,bjSplit);
		LockButtons = true;
		DealSplitResponder = &responder;
	 }

	 if (responder.GetResponseEvent() == reLDown)
	 {
//		Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
      Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
      pOwnerLord->StallsInRow = 0;
	//	pOwnerLord->DealSplit->ShowSplitDown();
		responder.SetPriority();
	 }

	 if (responder.GetResponseEvent() == reChar)
	 {
//		Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
      Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
      pOwnerLord->StallsInRow = 0;
	  //	pOwnerLord->DealSplit->ShowSplitDown();
		DealSplitResponder = &responder;
	 }
  }
 }
 return true;
}
//*******************************************************************
void TBJBetSpot3State::ExecuteFirstTime()
{
  pOwnerLord->Circle3->SetCircle(pOwnerLord->activeplayer,bjnl3F);
  pOwnerLord->pDeck->Busted(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->pHand5);
  pOwnerLord->MessageDisplay->ShowBJMessage(pOwnerLord->PlayerTotal());
  ExecuteWaiting = true;
  ExecuteStatus    = ess_Execute;
  pOwnerLord->Button15->ShowVoidUp();
  pOwnerLord->Button16->ShowVoidUp();
  PlayerTotalMessage(5);

  if(pOwnerLord->GetCash(pOwnerLord->activeplayer) > 0)
  {
	 pOwnerLord->Button14->ShowVoidUp();
	 if(pOwnerLord->GetCash(pOwnerLord->activeplayer) <
		 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->coinsplayedhand5)
	 {
		pOwnerLord->Button13->ShowGray();
	 }
	 else if((pOwnerLord->BetSpotUse[4] == -1 || pOwnerLord->BetSpotUse[6] == -1) &&
			 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->numsplitshand5 < 2 &&
			 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->pHand5->inhand < 3 &&
		  ((pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->pHand5->cards[0].name ==
			 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->pHand5->cards[1].name) ||
			(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->pHand5->cards[0].name >= Ten &&
			 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->pHand5->cards[0].name < AceHi) &&
			(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->pHand5->cards[1].name >= Ten &&
			 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->pHand5->cards[1].name < AceHi)) )
	 {
		pOwnerLord->Button13->ShowVoidUp();
	 }
	 else
	 {
		pOwnerLord->Button13->ShowGray();
	 }
  }
  else
  {
	 pOwnerLord->Button13->ShowGray();
	 pOwnerLord->Button14->ShowGray();
  }
  pOwnerLord->SwitchToPlayer(pOwnerLord->BetSpotUse[5]);
  Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
  pOwnerLord->StallsInRow = 0;
  FinishHit    = false;
  FinishStand  = false;
  FinishDouble = false;
  WaitOnHitCom    = false;
  WaitOnStandCom  = false;
  WaitOnDoubleCom = false;
  pOwnerLord->UnFreezeAllButtons();
}
//*******************************************************************
void TBJBetSpot3State::CreateSubState1()
{
  ((TBJHand *)pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->pHand5)->IsSplitHand = true;
  pOwnerLord->Circle3->SetPart(pOwnerLord->activeplayer,bjnl3E);
  PActiveSubState = new TBJSplit5State(pOwnerLord);
}
//*******************************************************************
void TBJBetSpot3State::EndSubState1()
{
  TState::EndSubState1();
//  Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
  Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
  pOwnerLord->StallsInRow = 0;
  splitbutton = true;
  pOwnerLord->Circle3->SetPart(pOwnerLord->activeplayer,bjnl3F);
  if(pOwnerLord->BetSpotUse[5] != -1)
  {
    pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->pHand5->inhand--;
	 pOwnerLord->pDeck->Busted(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->pHand5);
	 pOwnerLord->MessageDisplay->ShowBJMessage(pOwnerLord->PlayerTotal());
  }
}
//*******************************************************************
void TBJBetSpot3State::CreateSubState2()
{
  if(pOwnerLord->splitwait)
  {
	 ((TBJHand *)pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[6])->pHand6)->IsSplitHand = true;
	 pOwnerLord->Circle3->SetPart(pOwnerLord->activeplayer,bjnl3G);
	 PActiveSubState = new TBJSplit6State(pOwnerLord,1);
  }
}
//*******************************************************************
void TBJBetSpot3State::EndSubState2()
{
  TState::EndSubState2();
  ExecuteWaiting   = false;
//  Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
  if(pOwnerLord->BetSpotUse[5] != -1)
  {
	 pOwnerLord->pDeck->Busted(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->pHand5);
	 pOwnerLord->MessageDisplay->ShowBJMessage(pOwnerLord->PlayerTotal());
  }
  Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
  pOwnerLord->StallsInRow = 0;
  pOwnerLord->splitwait = false;
}
//*******************************************************************
void TBJBetSpot3State::CreateSubState3()
{
  //PActiveSubState = new TBJBustedState(pOwnerLord);
}
//*******************************************************************
void TBJBetSpot3State::CreateSubState4()
{
  pOwnerLord->FreezeAllButtons();
  PActiveSubState = new TBJDealState(pOwnerLord,7);
}
//*******************************************************************
void TBJBetSpot3State::EndSubState4()
{
  TState::EndSubState4();
  if(pOwnerLord->/*((TBJDeck *)*/pDeck->
	  Busted(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->pHand5) == 1)
  {
    pOwnerLord->FreezeAllButtons();
	 ExecuteStatus = ess_StartSubState5;
  }
  else if(doubleflag == true)
  {
	 doubleflag = false;
	 ExecuteStatus = ess_StartSubState2;
	 ExecuteWaiting = false;
  }
  else
  {
	 if(splitflag == true && pOwnerLord->
		 GetBJPlayer(pOwnerLord->BetSpotUse[5])->pHand5->cards[0].name == AceHi)
	 {
		splitflag = false;
		ExecuteStatus = ess_StartSubState2;
	 }
	 else
	 {
		splitflag = false;
	 }
  }
  ExecuteWaiting = true;
  PlayerTotalMessage(5);
  if(ExecuteStatus != ess_StartSubState2 && ExecuteStatus != ess_StartSubState5)
  {
//	 StartingFUC = PTimePtr->GetFrameUpdateCount() + 1;
	 StartingFUC = pOwnerLord->GetAdjFUC();
	 pOwnerLord->AnnouncePlayer3Total(StartingFUC,FUCLength);
    pOwnerLord->FreezeAllButtons();
	 WaitOnSkit    = true;
	 LockHit = true;
	 HitTotal = true;
  }
  if(splitbutton)
  {
	 splitbutton = false;
	 LockButtons = false;
	 if((pOwnerLord->BetSpotUse[4] == -1 || pOwnerLord->BetSpotUse[6] == -1) &&
			 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->numsplitshand5 < 2 &&
			 pOwnerLord->GetCash(pOwnerLord->activeplayer) >=
			 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->coinsplayedhand5   &&
			 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->pHand5->inhand < 3 &&
		  ((pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->pHand5->cards[0].name ==
			 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->pHand5->cards[1].name) ||
			(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->pHand5->cards[0].name >= Ten &&
			 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->pHand5->cards[0].name < AceHi) &&
			(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->pHand5->cards[1].name >= Ten &&
			 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->pHand5->cards[1].name < AceHi)) )
	 {
		pOwnerLord->Button13->ShowVoidUp();
	 }
	 else
	 {
		pOwnerLord->Button13->ShowGray();
	 }
  }
//  Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
  Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
  pOwnerLord->StallsInRow = 0;
}
//*******************************************************************
void TBJBetSpot3State::CreateSubState5()
{
  PActiveSubState = new TBJBustState(pOwnerLord,7);
}
//*******************************************************************
bool TBJBetSpot3State::HandleMenuEsc(TResponder &responder)
{
	if (responder.GetResponseEvent() == reLUp)
  {
	 MenuEscResponder = &responder;
  }

  if (responder.GetResponseEvent() == reLDown)
  {
//	 Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
	 Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	// pOwnerLord->MenuEscButton->Depress();
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
//	 Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
	 Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	// pOwnerLord->MenuEscButton->Depress();
	 MenuEscResponder = &responder;
  }

  return true;
}
//*******************************************************************
bool TBJBetSpot3State::HandleAskExpert(TResponder &responder)
{
	if (responder.GetResponseEvent() == reLUp)
  {
	 AskExpertResponder = &responder;
  }

  if (responder.GetResponseEvent() == reLDown)
  {
//	 Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
    Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	 //pOwnerLord->AskExpertButton->Depress();
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
//	 Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
    Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	 //pOwnerLord->AskExpertButton->Depress();
	 AskExpertResponder = &responder;
  }

  return true;
}

//*******************************************************************

