//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  bjdealst.cpp
//    Project Name:  Ogle
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     06/22/95   A. Krist    Original baseline
//  2.0     09/24/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "bjdealst.h"
#include "cbjglord.h"
#include "otimers.h"
#include "bjgobj.h"
#include "casbjmw.h"
#include "hand.h"
#include "cbjdlrsp.h"
#include "cbjbssp.h"  // bet spot
#include "cbjdspsp.h"  // dealer spot
#include "bjdeck.h"
#include <iostream.h>
//*******************************************************************
TBJDealState::TBJDealState(TCasinoBJGameLord *pNewBJLord,int16 DealTo,bool show,bool showdeal)
:TBJLordState(pNewBJLord)
{
  ShowDeal    = showdeal;
  dealto      = DealTo;
  ShowTotal   = show;
  FUCLength   = 0;
  NextFUC     = 0;
  StartingFUC = 0;
  CardFUC     = 0;
}
//*******************************************************************
TBJDealState::~TBJDealState()
{
}
//*******************************************************************
void TBJDealState::ExecuteFirstTime()
{

  switch(dealto) {
  case 0 :pOwnerLord->pDeck->Draw(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[dealto])->pHand0,pOwnerLord->pMWin);
			 pOwnerLord->pDeck->Busted(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[dealto])->pHand0);break;
  case 1 :pOwnerLord->pDeck->Draw(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[dealto])->pHand1,pOwnerLord->pMWin);
			 pOwnerLord->pDeck->Busted(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[dealto])->pHand1);break;
  case 2 :pOwnerLord->pDeck->Draw(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[dealto])->pHand2,pOwnerLord->pMWin);
			 pOwnerLord->pDeck->Busted(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[dealto])->pHand2);break;
  case 3 :pOwnerLord->pDeck->Draw(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[dealto-1])->pHand2,pOwnerLord->pMWin);
			 pOwnerLord->pDeck->Busted(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[dealto-1])->pHand2);break;
  case 4 :pOwnerLord->pDeck->Draw(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[dealto-1])->pHand3,pOwnerLord->pMWin);
			 pOwnerLord->pDeck->Busted(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[dealto-1])->pHand3);break;
  case 5 :pOwnerLord->pDeck->Draw(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[dealto-1])->pHand4,pOwnerLord->pMWin);
			 pOwnerLord->pDeck->Busted(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[dealto-1])->pHand4);break;
  case 6 :pOwnerLord->pDeck->Draw(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[dealto-2])->pHand4,pOwnerLord->pMWin);
			 pOwnerLord->pDeck->Busted(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[dealto-2])->pHand4);break;
  case 7 :pOwnerLord->pDeck->Draw(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[dealto-2])->pHand5,pOwnerLord->pMWin);
			 pOwnerLord->pDeck->Busted(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[dealto-2])->pHand5);break;
  case 8 :pOwnerLord->pDeck->Draw(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[dealto-2])->pHand6,pOwnerLord->pMWin);
			 pOwnerLord->pDeck->Busted(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[dealto-2])->pHand6);break;
  case 9 :pOwnerLord->pDeck->Draw(pOwnerLord->pHand,pOwnerLord->pMWin);
			 pOwnerLord->pDeck->Busted(pOwnerLord->pHand);break;
  case 10:pOwnerLord->pDeck->Draw(pOwnerLord->pHand,pOwnerLord->pMWin);
			 pOwnerLord->pDeck->Busted(pOwnerLord->pHand);break;
  }
//  StartingFUC = PTimePtr->GetFrameUpdateCount() + 1;
  StartingFUC = pOwnerLord->GetAdjFUC();
  pOwnerLord->LookFromTo(Looking(int16(pOwnerLord->LookingAt),dealto),StartingFUC,FUCLength,ShowDeal);
  ExecuteWaiting = true;
  ExecuteStatus    = ess_Execute;

}
//*******************************************************************
TBJLookFromTo TBJDealState::Looking(int16 lookingat,int16 lookto)
{
  switch(lookingat) {
  case bjnl1A : pOwnerLord->LookingAt = (TBJNumLet)lookto;
					 if(lookto < 3)
					 {
						return bjlf0To0;
					 }
					 else if(lookto > 2 && lookto < 6)
					 {
						//pOwnerLord->LookingAt = bjnl2D;
						return bjlf1To2;
					 }
					 else if(lookto > 5 && lookto < 9)
					 {
						//pOwnerLord->LookingAt = bjnl3F;
						return bjlf1To3;
					 }
					 else if(lookto == 9 || lookto == 10)
					 {
						//pOwnerLord->LookingAt = bjnl0D;
						return bjlf1To0;
					 }
  case bjnl1B : pOwnerLord->LookingAt = (TBJNumLet)lookto;
					 if(lookto < 3)
					 {
						return bjlf0To0;
					 }
					 else if(lookto > 2 && lookto < 6)
					 {
					  //	pOwnerLord->LookingAt = bjnl2D;
						return bjlf1To2;
					 }
					 else if(lookto > 5 && lookto < 9)
					 {
						//pOwnerLord->LookingAt = bjnl3F;
						return bjlf1To3;
					 }
					 else if(lookto == 9 || lookto == 10)
					 {
						//pOwnerLord->LookingAt = bjnl0D;
						return bjlf1To0;
					 }
  case bjnl1C : pOwnerLord->LookingAt = (TBJNumLet)lookto;
					 if(lookto < 3)
					 {
						return bjlf0To0;
					 }
					 else if(lookto > 2 && lookto < 6)
					 {
						//pOwnerLord->LookingAt = bjnl2D;
						return bjlf1To2;
					 }
					 else if(lookto > 5 && lookto < 9)
					 {
					  //	pOwnerLord->LookingAt = bjnl3F;
						return bjlf1To3;
					 }
					 else if(lookto == 9 || lookto == 10)
					 {
						//pOwnerLord->LookingAt = bjnl0D;
						return bjlf1To0;
					 }
  case bjnl2C : pOwnerLord->LookingAt = (TBJNumLet)lookto;
					 if(lookto < 3)
					 {
						return bjlf0To0;
					 }
					 else if(lookto > 2 && lookto < 6)
					 {
						return bjlf0To0;
					 }
					 else if(lookto > 5 && lookto < 9)
					 {
						//pOwnerLord->LookingAt = bjnl3F;
						return bjlf2To3;
					 }
					 else if(lookto == 9 || lookto == 10)
					 {
						//pOwnerLord->LookingAt = bjnl0D;
						return bjlf2To0;
					 }
  case bjnl2D : pOwnerLord->LookingAt = (TBJNumLet)lookto;
					 if(lookto < 3)
					 {
						return bjlf0To0;
					 }
					 else if(lookto > 2 && lookto < 6)
					 {
						return bjlf0To0;
					 }
					 else if(lookto > 5 && lookto < 9)
					 {
						//pOwnerLord->LookingAt = bjnl3F;
						return bjlf2To3;
					 }
					 else if(lookto == 9 || lookto == 10)
					 {
						//pOwnerLord->LookingAt = bjnl0D;
						return bjlf2To0;
					 }
  case bjnl2E : pOwnerLord->LookingAt = (TBJNumLet)lookto;
					 if(lookto < 3)
					 {
						return bjlf0To0; //do nothing
					 }
					 else if(lookto > 2 && lookto < 6)
					 {
						return bjlf0To0;
					 }
					 else if(lookto > 5 && lookto < 9)
					 {
						//pOwnerLord->LookingAt = bjnl3F;
						return bjlf2To3;
					 }
					 else if(lookto == 9 || lookto == 10)
					 {
						//pOwnerLord->LookingAt = bjnl0D;
						return bjlf2To0;
					 }
  case bjnl3E : pOwnerLord->LookingAt = (TBJNumLet)lookto;
					 if(lookto < 3)
					 {
						return bjlf0To0;
					 }
					 else if(lookto > 2 && lookto < 6)
					 {
						return bjlf0To0;
					 }
					 else if(lookto > 5 && lookto < 9)
					 {
						return bjlf0To0;
					 }
					 else if(lookto == 9 || lookto == 10)
					 {
						//pOwnerLord->LookingAt = bjnl0D;
						return bjlf3To0;
					 }
  case bjnl3F : pOwnerLord->LookingAt = (TBJNumLet)lookto;
					 if(lookto < 3)
					 {
						return bjlf0To0;
					 }
					 else if(lookto > 2 && lookto < 6)
					 {
						return bjlf0To0;
					 }
					 else if(lookto > 5 && lookto < 9)
					 {
						return bjlf0To0;
					 }
					 else if(lookto == 9 || lookto == 10)
					 {
						//pOwnerLord->LookingAt = bjnl0D;
						return bjlf3To0;
					 }
  case bjnl3G : pOwnerLord->LookingAt = (TBJNumLet)lookto;
					 if(lookto < 3)
					 {
						return bjlf0To0;
					 }
					 else if(lookto > 2 && lookto < 6)
					 {
						return bjlf0To0;
					 }
					 else if(lookto > 5 && lookto < 9)
					 {
						return bjlf0To0;
					 }
					 else if(lookto == 9 || lookto == 10)
					 {
						return bjlf3To0;
					 }
  case bjnl0D : pOwnerLord->LookingAt = (TBJNumLet)lookto;
					 if(lookto < 3)
					 {
						//pOwnerLord->LookingAt = bjnl1B;
						return bjlf0To1;
					 }
					 else if(lookto > 2 && lookto < 6)
					 {
						//pOwnerLord->LookingAt = bjnl2D;
						return bjlf0To2;
					 }
					 else if(lookto > 5 && lookto < 9)
					 {
						//pOwnerLord->LookingAt = bjnl3F;
						return bjlf0To3;
					 }
					 else if(lookto == 9)
					 {
						return bjlf0To0;
					 }
                else if(lookto == 10)
					 {
						return bjlf0To0;
					 }
	case bjnl0U: pOwnerLord->LookingAt = (TBJNumLet)lookto;
					 if(lookto < 3)
					 {
						///pOwnerLord->LookingAt = bjnl1B;
						return bjlf0To1;
					 }
					 else if(lookto > 2 && lookto < 6)
					 {
						//pOwnerLord->LookingAt = bjnl2D;
						return bjlf0To2;
					 }
					 else if(lookto > 5 && lookto < 9)
					 {
						//pOwnerLord->LookingAt = bjnl3F;
						return bjlf0To3;
					 }
					 else if(lookto == 9 || lookto == 10)
					 {
						return bjlf0To0;
					 }

  }
  return bjlf0To0;
}
//*******************************************************************
void TBJDealState::HandlePostUpdate(dword NewFUC)
{
  if (StartingFUC == NewFUC && ShowDeal) {pOwnerLord->SetBodyIdle();}

  if ((StartingFUC + FUCLength) == NewFUC && NextFUC == 0 && ShowDeal)
  {
	  NextFUC = NewFUC+1;
	  pOwnerLord->DealCard(dealto,NextFUC,FUCLength,CardFUC);
  }
  else if (((NextFUC+CardFUC) == NewFUC && NextFUC != 0) || !ShowDeal)
  {
	 switch(dealto) {
	 case 0 :pOwnerLord->BetSpot[dealto]->ShowFace(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[dealto])->pHand0);break;
	 case 1 :pOwnerLord->BetSpot[dealto]->ShowFace(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[dealto])->pHand1);break;
	 case 2 :pOwnerLord->BetSpot[dealto]->ShowFace(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[dealto])->pHand2);break;
	 case 3 :pOwnerLord->BetSpot[dealto-1]->ShowFace(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[dealto-1])->pHand2);break;
	 case 4 :pOwnerLord->BetSpot[dealto-1]->ShowFace(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[dealto-1])->pHand3);break;
	 case 5 :pOwnerLord->BetSpot[dealto-1]->ShowFace(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[dealto-1])->pHand4);break;
	 case 6 :pOwnerLord->BetSpot[dealto-2]->ShowFace(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[dealto-2])->pHand4);break;
	 case 7 :pOwnerLord->BetSpot[dealto-2]->ShowFace(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[dealto-2])->pHand5);break;
	 case 8 :pOwnerLord->BetSpot[dealto-2]->ShowFace(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[dealto-2])->pHand6);break;
	 case 9 :pOwnerLord->DealerSpot->ShowBack();break;
	 case 10:pOwnerLord->DealerSpot->ShowFace(pOwnerLord->pHand);break;

	 }
	 if(ShowTotal)
	 {
		if(dealto == 10){pOwnerLord->MessageDisplay->ShowBJMessage(pOwnerLord->DealerTotal());}
		if(dealto <   9){pOwnerLord->MessageDisplay->ShowBJMessage(pOwnerLord->PlayerTotal());}
	 }
	 if(!ShowDeal)
	 {
		ExecuteWaiting = false;
	 }
  }
  else if ((NextFUC + FUCLength) <= NewFUC && NextFUC != 0)
  {
	 ExecuteWaiting = false;
  }
}
//*******************************************************************
