//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  bjflipst.cpp    // dealer flip hole card state
//    Project Name:  Ogle
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     06/22/95   A. Krist    Original baseline
//  2.0     09/24/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "bjflipst.h"   // dealer draw state
#include "cbjglord.h"
#include "otimers.h"
#include "bjgobj.h"
#include "casbjmw.h"
#include "hand.h"
#include "bjdealst.h"
#include "bjdeck.h"
#include <iostream.h>
//*******************************************************************
TBJDealerFlipState::TBJDealerFlipState(TCasinoBJGameLord *pNewBJLord,int16 Hole)
:TBJLordState(pNewBJLord)
{
  SetRunOrder(ess_StartSubState1,ess_Done);
  hole = Hole;
  StartingFUC = 0;
  NextFUC     = 0;
  FUCLength   = 0;
  RemoveBackFUC = 0;
  ShowFaceFUC   = 0;
  ShowBackFUC   = 0;
  WaitOnSkit  = true;
  ShowHole    = false;
  HoleDelay   = false;
  CheckHole   = false;
  CardShow    = false;
}
//*******************************************************************
TBJDealerFlipState::~TBJDealerFlipState()
{
}
//*******************************************************************
void TBJDealerFlipState::CreateSubState1()
{
}
//*******************************************************************
void TBJDealerFlipState::ExecuteFirstTime()
{
  ExecuteWaiting = true;
  ExecuteStatus  = ess_Execute;

//  StartingFUC = PTimePtr->GetFrameUpdateCount() + 1;
  StartingFUC = pOwnerLord->GetAdjFUC();
  switch(pOwnerLord->LookingAt) {
	 case bjnl1A : pOwnerLord->LookFromTo(bjlf1To0,StartingFUC,FUCLength);break;
	 case bjnl1B : pOwnerLord->LookFromTo(bjlf1To0,StartingFUC,FUCLength);break;
	 case bjnl1C : pOwnerLord->LookFromTo(bjlf1To0,StartingFUC,FUCLength);break;
	 case bjnl2C : pOwnerLord->LookFromTo(bjlf2To0,StartingFUC,FUCLength);break;
	 case bjnl2D : pOwnerLord->LookFromTo(bjlf2To0,StartingFUC,FUCLength);break;
	 case bjnl2E : pOwnerLord->LookFromTo(bjlf2To0,StartingFUC,FUCLength);break;
	 case bjnl3E : pOwnerLord->LookFromTo(bjlf3To0,StartingFUC,FUCLength);break;
	 case bjnl3F : pOwnerLord->LookFromTo(bjlf3To0,StartingFUC,FUCLength);break;
	 case bjnl3G : pOwnerLord->LookFromTo(bjlf3To0,StartingFUC,FUCLength);break;
  }
  pOwnerLord->LookingAt = bjnl0U;
  pOwnerLord->SetBodyIdle();
}
//*******************************************************************
void TBJDealerFlipState::HandlePostUpdate(dword NewFUC)
{
  if(WaitOnSkit)
  {
	 if((StartingFUC + FUCLength) <= NewFUC)
	 {
		StartingFUC = 0;
		FUCLength   = 0;
		WaitOnSkit  = false;
		CheckHole   = true;
	 }
	 return;//?
  }
  if(CheckHole)
  {
//	 StartingFUC    = PTimePtr->GetFrameUpdateCount() + 1;
    StartingFUC = pOwnerLord->GetAdjFUC();
	 pOwnerLord->CheckHoleCard(StartingFUC,FUCLength,RemoveBackFUC,ShowBackFUC);
	 CheckHole = false;
	 ShowHole  = true;
  }
  if(ShowHole)
  {
	 if((StartingFUC + RemoveBackFUC) == NewFUC)
	 {
		pOwnerLord->DealerSpot->NoShowBack();
	 }
	 if((StartingFUC + ShowBackFUC) == NewFUC)
	 {
		pOwnerLord->DealerSpot->ShowBack();
	 }
	 if((StartingFUC + FUCLength) <= NewFUC)
	 {
//		StartingFUC    = PTimePtr->GetFrameUpdateCount() + 1;
      StartingFUC = pOwnerLord->GetAdjFUC();
		FUCLength = 0;
		ShowHole = false;
		CardShow = true;
		switch(hole) {
		 case 1 : pOwnerLord->DealerNoBJ(StartingFUC,FUCLength);break;
		 case 2 : if(pOwnerLord->pHand->bj)
					 {pOwnerLord->DealerBJ(StartingFUC,FUCLength,RemoveBackFUC,ShowFaceFUC);}
					 else
					 {pOwnerLord->ExposeHoleCard(StartingFUC,FUCLength,RemoveBackFUC,ShowBackFUC);}break;//never gets called?
		 case 3 : FUCLength = 1;break;
		}
	 }
  }
  if(HoleDelay)
  {
	 if((StartingFUC + FUCLength + 1) <= NewFUC)   //+6
	 {
		ExecuteWaiting = false;
		HoleDelay = false;
		ShowHole = false;
	 }
	 return;
  }
  if(CardShow)
  {
	 if((StartingFUC + FUCLength) <= NewFUC)
	 {
		ExecuteWaiting = false;
		ShowHole = false;
		CardShow = false;
	 }
	 if((StartingFUC + RemoveBackFUC) == NewFUC && hole == 2)
	 {
		pOwnerLord->DealerSpot->NoShowBack();
	 }

	 if((StartingFUC +  ShowFaceFUC) == NewFUC)
	 {
		if(hole == 2 || hole == 3)
		{
		  pOwnerLord->DealerSpot->ShowHoleCard(pOwnerLord->pHand);
		  HoleDelay = true;
		}
		else
		{
		  //pOwnerLord->DealerSpot->ShowBack();
		  ExecuteWaiting = false;
		  ShowHole = false;
		}
	 }
  }
}
//*******************************************************************

