//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  bjinitst.cpp   // FLop deal
//    Project Name:  Ogle
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     06/29/95   A. Krist    Original baseline
//  2.0     09/24/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "bjinitst.h"
#include "cbjglord.h"
//*******************************************************************
TInitBJState::TInitBJState(TCasinoBJGameLord *pNewBJLord)
	: TBJLordState(pNewBJLord)
{
 StartingFUC = 0;
 FUCLength = 0;
}
//*******************************************************************
TInitBJState::~TInitBJState()
{
}
//*******************************************************************
void TInitBJState::RecommendSibling()
{
	Status = ss_DoneRecom8;
}
//*******************************************************************
void TInitBJState::ExecuteFirstTime()
{
  pOwnerLord->FreezeAllButtons();
  pOwnerLord->InitBJ();
  WaitOnSkit = false;
  ExecuteWaiting = true;
  ExecuteStatus  = ess_Execute;
  StartingFUC    = pOwnerLord->GetAdjFUC() + 1; // give manual sprites a chance to load.
  pOwnerLord->SetBodyIdle();
  pOwnerLord->GreetPlayers(StartingFUC,FUCLength);
}
//*******************************************************************
void TInitBJState::HandlePostUpdate(dword NewFUC)
{
  if ((StartingFUC + FUCLength) <= NewFUC)
  {
	 if(!WaitOnSkit)
	 {
		StartingFUC = pOwnerLord->GetAdjFUC();
		pOwnerLord->Shuffle(StartingFUC,FUCLength);
	 }
	 if(WaitOnSkit){ExecuteWaiting = false;}
	 else{WaitOnSkit = true;}

  }                                                 
}
//*******************************************************************
