//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  bjlordst.cpp
//    Project Name:  Ogle
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     06/01/95   A. Krist    Original baseline
//  2.0     09/23/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "bjlordst.h"
#include "cbjglord.h"
#include "cbjplay.h"
#include "bjdeck.h"
//*******************************************************************
TBJLordState::TBJLordState(TCasinoBJGameLord *pNewBJLord)
{
  pOwnerLord = pNewBJLord;
  LockButtons = false;
  LockHit = false;
  HitTotal = false;
  IgnoreCoach = false;
  lastaction = -1;
  ExpertDelayStart = 0;
}
//*******************************************************************
TBJLordState::~TBJLordState()
{
}
//*******************************************************************
void TBJLordState::Coach(int16 spot,TBJAction action)
{
	 if(pOwnerLord->GetCasPD(pOwnerLord->BetSpotUse[spot])->CoachOn && !IgnoreCoach)
	 {
		if(pOwnerLord->pAskExpert->BJAction != action)
		{
		  ExpertDelayStart = pOwnerLord->GetAdjFUC();
		  pOwnerLord->Button0->ShowExpert();
		  IgnoreCoach = true;
		}
	 }
	 else
	 {
		if(pOwnerLord->pAskExpert->BJAction != action)
		{
		  int session=0;
		  session = pOwnerLord->GetCasPD(pOwnerLord->BetSpotUse[spot])->BJData.CurrentSession;
		  pOwnerLord->GetCasPD(pOwnerLord->BetSpotUse[spot])->BJData.Sessions[session].IncorrectPlays++;
		}
		if(IgnoreCoach)
		{
		  IgnoreCoach = false;
		}
	 }
}
//*******************************************************************
void TBJLordState::CoachStats(int16 spot,TBJAction action,int16 ftc)
{
	 if(lastaction != action)
	 {
		IgnoreCoach = false;
	 }
	 lastaction = int16(action);
	 if(ftc)
	 {
		pOwnerLord->AskFirstTwoCardsExpert(spot,false);
	 }
	 else
	 {
		pOwnerLord->AskAfterFirstTwoCardsExpert(spot,false);
	 }
}
//*******************************************************************
#pragma argsused
void TBJLordState::PlayerTotalMessage(int16 bsu)
{
}
//*******************************************************************
bool TBJLordState::StatBar(TResponder &responder)
{
  return HandleStatBar(responder);
}
//*******************************************************************
bool TBJLordState::BetSpot1(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TBJLordState *)PActiveSubState)->BetSpot1(responder);
  }
  else
  {
	 return HandleBetSpot1(responder);
  }
}
//*******************************************************************
bool TBJLordState::ShuffleNewDeck()
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TBJLordState *)PActiveSubState)->ShuffleNewDeck();
  }
  else
  {
	 return HandleShuffleNewDeck();
  }
}
//*******************************************************************
bool TBJLordState::NamePlate(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TBJLordState *)PActiveSubState)->NamePlate(responder);
  }
  else
  {
	 return HandleNamePlate(responder);
  }
}
//*******************************************************************
bool TBJLordState::BetSpot2(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TBJLordState *)PActiveSubState)->BetSpot2(responder);
  }
  else
  {
	 return HandleBetSpot2(responder);
  }
}
//*******************************************************************
bool TBJLordState::BetSpot3(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TBJLordState *)PActiveSubState)->BetSpot3(responder);
  }
  else
  {
	 return HandleBetSpot3(responder);
  }
}
//*******************************************************************
bool TBJLordState::OneChip(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TBJLordState *)PActiveSubState)->OneChip(responder);
  }
  else
  {
	 return HandleOneChip(responder);
  }
}
//*******************************************************************
bool TBJLordState::FiveChip(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TBJLordState *)PActiveSubState)->FiveChip(responder);
  }
  else
  {
	 return HandleFiveChip(responder);
  }
}
//*******************************************************************
bool TBJLordState::AskExpertButton(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TBJLordState *)PActiveSubState)->AskExpertButton(responder);
  }
  else
  {
	 return HandleAskExpert(responder);
  }
}
//*******************************************************************
bool TBJLordState::TwentyFiveChip(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TBJLordState *)PActiveSubState)->TwentyFiveChip(responder);
  }
  else
  {
	 return HandleTwentyFiveChip(responder);
  }
}
//*******************************************************************
bool TBJLordState::OneHundredChip(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TBJLordState *)PActiveSubState)->OneHundredChip(responder);
  }
  else
  {
	 return HandleOneHundredChip(responder);
  }
}
//*******************************************************************
bool TBJLordState::OneThouChip(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TBJLordState *)PActiveSubState)->OneThouChip(responder);
  }
  else
  {
	 return HandleOneThouChip(responder);
  }
}
//*******************************************************************
bool TBJLordState::TenThouChip(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TBJLordState *)PActiveSubState)->TenThouChip(responder);
  }
  else
  {
	 return HandleTenThouChip(responder);
  }
}
//*******************************************************************
bool TBJLordState::RemoveDouble(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TBJLordState *)PActiveSubState)->RemoveDouble(responder);
  }
  else
  {
	 return HandleRemoveDouble(responder);
  }
}
//*******************************************************************
bool TBJLordState::ClearNoInsureStand(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TBJLordState *)PActiveSubState)->ClearNoInsureStand(responder);
  }
  else
  {
	 return HandleClearNoInsureStand(responder);
  }
}
//*******************************************************************
bool TBJLordState::SameYesInsureHit(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TBJLordState *)PActiveSubState)->SameYesInsureHit(responder);
  }
  else
  {
	 return HandleSameYesInsureHit(responder);
  }
}
//*******************************************************************
bool TBJLordState::DealSplit(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TBJLordState *)PActiveSubState)->DealSplit(responder);
  }
  else
  {
	 return HandleDealSplit(responder);
  }
}
//*******************************************************************
bool TBJLordState::MenuEscButton(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TBJLordState *)PActiveSubState)->MenuEscButton(responder);
  }
  else
  {
	 return HandleMenuEsc(responder);
  }
}
//*******************************************************************
TBJLookFromTo TBJLordState::Looker(int16 lookingat,int16 lookto)
{
  switch(lookto){
  case 0  : pOwnerLord->LookingAt = bjnl1A;break;
  case 1  : pOwnerLord->LookingAt = bjnl1B;break;
  case 2  : pOwnerLord->LookingAt = bjnl1C;break;
  case 3  : pOwnerLord->LookingAt = bjnl2C;break;
  case 4  : pOwnerLord->LookingAt = bjnl2D;break;
  case 5  : pOwnerLord->LookingAt = bjnl2E;break;
  case 6  : pOwnerLord->LookingAt = bjnl3E;break;
  case 7  : pOwnerLord->LookingAt = bjnl3F;break;
  case 8  : pOwnerLord->LookingAt = bjnl3G;break;
  case 9  : pOwnerLord->LookingAt = bjnl0D;break;
  case 10 : pOwnerLord->LookingAt = bjnl0U;break;
  }

  switch(lookingat) {
  case bjnl1A : if(lookto < 3)
					 {
						return bjlf0To0;
					 }
					 else if(lookto > 2 && lookto < 6)
					 {
						return bjlf1To2;
					 }
					 else if(lookto > 5 && lookto < 9)
					 {
						return bjlf1To3;
					 }
					 else if(lookto == 9 || lookto == 10)
					 {
						return bjlf1To0;
					 }
  case bjnl1B : if(lookto < 3)
					 {
						return bjlf0To0;
					 }
					 else if(lookto > 2 && lookto < 6)
					 {
						return bjlf1To2;
					 }
					 else if(lookto > 5 && lookto < 9)
					 {
						return bjlf1To3;
					 }
					 else if(lookto == 9 || lookto == 10)
					 {
						return bjlf1To0;
					 }
  case bjnl1C : if(lookto < 3)
					 {
						return bjlf0To0;
					 }
					 else if(lookto > 2 && lookto < 6)
					 {
						return bjlf1To2;
					 }
					 else if(lookto > 5 && lookto < 9)
					 {
						return bjlf1To3;
					 }
					 else if(lookto == 9 || lookto == 10)
					 {
						return bjlf1To0;
					 }
  case bjnl2C : if(lookto < 3)
					 {
						return bjlf2To1;
					 }
					 else if(lookto > 2 && lookto < 6)
					 {
						return bjlf0To0;
					 }
					 else if(lookto > 5 && lookto < 9)
					 {
						return bjlf2To3;
					 }
					 else if(lookto == 9 || lookto == 10)
					 {
						return bjlf2To0;
					 }
  case bjnl2D : if(lookto < 3)
					 {
						return bjlf2To1;
					 }
					 else if(lookto > 2 && lookto < 6)
					 {
						return bjlf0To0;
					 }
					 else if(lookto > 5 && lookto < 9)
					 {
						return bjlf2To3;
					 }
					 else if(lookto == 9 || lookto == 10)
					 {
						return bjlf2To0;
					 }
  case bjnl2E : if(lookto < 3)
					 {
						return bjlf2To1;
					 }
					 else if(lookto > 2 && lookto < 6)
					 {
						return bjlf0To0;
					 }
					 else if(lookto > 5 && lookto < 9)
					 {
						return bjlf2To3;
					 }
					 else if(lookto == 9 || lookto == 10)
					 {
						return bjlf2To0;
					 }
  case bjnl3E : if(lookto < 3)
					 {
						return bjlf3To1;
					 }
					 else if(lookto > 2 && lookto < 6)
					 {
						return bjlf3To2;
					 }
					 else if(lookto > 5 && lookto < 9)
					 {
						return bjlf0To0;
					 }
					 else if(lookto == 9 || lookto == 10)
					 {
						return bjlf3To0;
					 }
  case bjnl3F : if(lookto < 3)
					 {
						return bjlf3To1;
					 }
					 else if(lookto > 2 && lookto < 6)
					 {
						return bjlf3To2;
					 }
					 else if(lookto > 5 && lookto < 9)
					 {
						return bjlf0To0;
					 }
					 else if(lookto == 9 || lookto == 10)
					 {
						return bjlf3To0;
					 }
  case bjnl3G : if(lookto < 3)
					 {
						return bjlf3To1;
					 }
					 else if(lookto > 2 && lookto < 6)
					 {
						return bjlf3To2;
					 }
					 else if(lookto > 5 && lookto < 9)
					 {
						return bjlf0To0;
					 }
					 else if(lookto == 9 || lookto == 10)
					 {
						return bjlf3To0;
					 }
  case bjnl0D : if(lookto < 3)
					 {
						return bjlf0To1;
					 }
					 else if(lookto > 2 && lookto < 6)
					 {
						return bjlf0To2;
					 }
					 else if(lookto > 5 && lookto < 9)
					 {
						return bjlf0To3;
					 }
					 else if(lookto == 9)
					 {
						return bjlf0To0;
					 }
					 else if(lookto == 10)
					 {
						return bjlf0To0;
					 }
	case bjnl0U: if(lookto < 3)
					 {
						return bjlf0To1;
					 }
					 else if(lookto > 2 && lookto < 6)
					 {
						return bjlf0To2;
					 }
					 else if(lookto > 5 && lookto < 9)
					 {
						return bjlf0To3;
					 }
					 else if(lookto == 9 || lookto == 10)
					 {
						return bjlf0To0;
					 }
  }
  return bjlf0To0;
}
//*******************************************************************
#pragma argsused
bool TBJLordState::HandleMenuEsc(TResponder &responder)
{
  return true;
}
//*******************************************************************
#pragma argsused
bool TBJLordState::HandleBetSpot1(TResponder &responder)
{
  return true;
}
//*******************************************************************
#pragma argsused
bool TBJLordState::HandleBetSpot2(TResponder &responder)
{
  return true;
}
//*******************************************************************
#pragma argsused
bool TBJLordState::HandleBetSpot3(TResponder &responder)
{
  return true;
}
//*******************************************************************
#pragma argsused
bool TBJLordState::HandleOneChip(TResponder &responder)
{
  return true;
}
//*******************************************************************
#pragma argsused
bool TBJLordState::HandleFiveChip(TResponder &responder)
{
  return true;
}
//*******************************************************************
#pragma argsused
bool TBJLordState::HandleTwentyFiveChip(TResponder &responder)
{
  return true;
}
//*******************************************************************
#pragma argsused
bool TBJLordState::HandleOneHundredChip(TResponder &responder)
{
  return true;
}
//*******************************************************************
#pragma argsused
bool TBJLordState::HandleAskExpert(TResponder &responder)
{
  return true;
}
//*******************************************************************
#pragma argsused
bool TBJLordState::HandleOneThouChip(TResponder &responder)
{
  return true;
}
//*******************************************************************
#pragma argsused
bool TBJLordState::HandleTenThouChip(TResponder &responder)
{
  return true;
}
//*******************************************************************
#pragma argsused
bool TBJLordState::HandleRemoveDouble(TResponder &responder)
{
  return true;
}
//*******************************************************************
#pragma argsused
bool TBJLordState::HandleClearNoInsureStand(TResponder &responder)
{
  return true;
}
//*******************************************************************
#pragma argsused
bool TBJLordState::HandleSameYesInsureHit(TResponder &responder)
{
  return true;
}
//*******************************************************************
#pragma argsused
bool TBJLordState::HandleDealSplit(TResponder &responder)
{
  return true;
}
//*******************************************************************
#pragma argsused
bool TBJLordState::HandleShuffleNewDeck()
{
  return true;
}
//*******************************************************************
#pragma argsused
bool TBJLordState::HandleStatBar(TResponder &responder)
{
  return true;
}
//*******************************************************************
#pragma argsused
bool TBJLordState::HandleNamePlate(TResponder &responder)
{
  if(pOwnerLord->GetNumActivePlayers() > 1)
  {
    pOwnerLord->NamePlate1->ShowRedX();
    return true;
  }
  return true;
}
//*******************************************************************
