//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  bjlst.cpp    // lose state
//    Project Name:  Ogle
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     10/20/95   A. Krist    Original baseline
//  2.0     09/23/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "bjlst.h"
#include "cbjglord.h"
#include "cbjplay.h"
#include "otimers.h"
#include <iostream.h>
//*******************************************************************
TBJLoseState::TBJLoseState(TCasinoBJGameLord *pNewBJLord,int16 LoseTo)
:TBJLordState(pNewBJLord)
{
  loseto = LoseTo;
  remove = 0;show = 0;
  FinishPlayer = false;
  FirstTime = true;
  discards =0;
  StartingFUC = 0;
  FUCLength = 0;
  SetRunOrder(ess_StartSubState1,ess_StartSubState2,ess_StartSubState3,ess_Done);
}
//*******************************************************************
TBJLoseState::~TBJLoseState()
{
}
//*******************************************************************
void TBJLoseState::ExecuteFirstTime()
{
	 switch(loseto) {
	 case 0  : discards = pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[0])->pHand0->inhand;break;
	 case 1  : discards = pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand1->inhand;break;
	 case 2  : discards = pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->pHand2->inhand;break;
	 case 3  : discards = pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->pHand2->inhand;break;
	 case 4  : discards = pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3->inhand;break;
	 case 5  : discards = pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->inhand;break;
	 case 6  : discards = pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->inhand;break;
	 case 7  : discards = pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->pHand5->inhand;break;
	 case 8  : discards = pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[6])->pHand6->inhand;break;
	 }

  ExecuteWaiting = true;
  ExecuteStatus  = ess_Execute;
  pOwnerLord->ALLHANDSWON = false;

  StartingFUC = pOwnerLord->GetAdjFUC();
  switch(loseto) {
  case 0  : pOwnerLord->Loser1(StartingFUC,FUCLength);remove = 4;show = 8;break;
  case 1  : pOwnerLord->Loser1(StartingFUC,FUCLength);remove = 4;show = 8;break;
  case 2  : pOwnerLord->Loser1(StartingFUC,FUCLength);remove = 4;show = 8;break;
  case 3  : pOwnerLord->Loser2(StartingFUC,FUCLength);remove = 2;show = 6;break;
  case 4  : pOwnerLord->Loser2(StartingFUC,FUCLength);remove = 2;show = 6;break;
  case 5  : pOwnerLord->Loser2(StartingFUC,FUCLength);remove = 2;show = 6;break;
  case 6  : pOwnerLord->Loser3(StartingFUC,FUCLength);remove = 4;show = 8;break;
  case 7  : pOwnerLord->Loser3(StartingFUC,FUCLength);remove = 4;show = 8;break;
  case 8  : pOwnerLord->Loser3(StartingFUC,FUCLength);remove = 4;show = 8;break;
  case 9  : pOwnerLord->AnnounceDealerTotal(StartingFUC,FUCLength);break;
  case 10 : pOwnerLord->AnnounceDealerTotal(StartingFUC,FUCLength);break;
  }
  FinishPlayer = true;
}
//*******************************************************************
void TBJLoseState::HandlePostUpdate(dword NewFUC)
{
  if((StartingFUC + FUCLength - 8) == NewFUC && FirstTime)
  {
	 pOwnerLord->Loser(loseto);
	 FirstTime = false;
  }
  if(FinishPlayer)
  {
	 if(StartingFUC + remove == NewFUC)
	 {
		  switch(loseto) {
		  case 0  : pOwnerLord->BetSpot[0]->NoShow();break;
		  case 1  : pOwnerLord->BetSpot[1]->NoShow();break;
		  case 2  : pOwnerLord->BetSpot[2]->NoShow();break;
		  case 3  : pOwnerLord->BetSpot[2]->NoShow();break;
		  case 4  : pOwnerLord->BetSpot[3]->NoShow();break;
		  case 5  : pOwnerLord->BetSpot[4]->NoShow();break;
		  case 6  : pOwnerLord->BetSpot[4]->NoShow();break;
		  case 7  : pOwnerLord->BetSpot[5]->NoShow();break;
		  case 8  : pOwnerLord->BetSpot[6]->NoShow();break;
		  }
	 }
	 if(StartingFUC + show == NewFUC)
	 {
		pOwnerLord->Rack->ShowBJRack(discards);
	 }
	 if(StartingFUC + FUCLength <= NewFUC)
	 {
		FinishPlayer = false;
		remove = 0;
      show = 0;
		ExecuteWaiting = false;
		ExecuteStatus = ess_Done;
	 }
  }
}
//*******************************************************************
void TBJLoseState::CreateSubState1()
{
}
//*******************************************************************
void TBJLoseState::CreateSubState2()
{
}
//*******************************************************************
void TBJLoseState::CreateSubState3()
{
}
//*******************************************************************