//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  bjpst.cpp    // push state
//    Project Name:  Ogle
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     10/20/95   A. Krist    Original baseline
//  2.0     09/23/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "bjpst.h"
#include "cbjglord.h"
#include "otimers.h"
#include "cbjplay.h"
#include <iostream.h>
//*******************************************************************
TBJPushState::TBJPushState(TCasinoBJGameLord *pNewBJLord,int16 PushTo)
:TBJLordState(pNewBJLord)
{
  pushto = PushTo;
  StartingFUC = 0;
  FUCLength = 0;
  SetRunOrder(ess_StartSubState1,ess_StartSubState2,ess_StartSubState3,ess_Done);
}
//*******************************************************************
TBJPushState::~TBJPushState()
{
}
//*******************************************************************
void TBJPushState::ExecuteFirstTime()
{
  ExecuteWaiting = true;
  ExecuteStatus  = ess_Execute;
  pOwnerLord->ALLHANDSWON = false;
  StartingFUC = pOwnerLord->GetAdjFUC();
  switch(pushto) {
  case 0  : pOwnerLord->Push1(StartingFUC,FUCLength);break;
  case 1  : pOwnerLord->Push1(StartingFUC,FUCLength);break;
  case 2  : pOwnerLord->Push1(StartingFUC,FUCLength);break;
  case 3  : pOwnerLord->Push2(StartingFUC,FUCLength);break;
  case 4  : pOwnerLord->Push2(StartingFUC,FUCLength);break;
  case 5  : pOwnerLord->Push2(StartingFUC,FUCLength);break;
  case 6  : pOwnerLord->Push3(StartingFUC,FUCLength);break;
  case 7  : pOwnerLord->Push3(StartingFUC,FUCLength);break;
  case 8  : pOwnerLord->Push3(StartingFUC,FUCLength);break;
  case 9  : pOwnerLord->AnnounceDealerTotal(StartingFUC,FUCLength);break;
  case 10 : pOwnerLord->AnnounceDealerTotal(StartingFUC,FUCLength);break;
  }
}
//*******************************************************************
void TBJPushState::HandlePostUpdate(dword NewFUC)
{
  if((StartingFUC + FUCLength - 8) == NewFUC)
  {
	 pOwnerLord->Pusher(pushto);
  }
  if((StartingFUC + FUCLength - 8) == NewFUC)
  {
	 switch(pushto) {
	 case 0  : pOwnerLord->BetSpot[0]->NoShowCards();break;
	 case 1  : pOwnerLord->BetSpot[1]->NoShowCards();break;
	 case 2  : pOwnerLord->BetSpot[2]->NoShowCards();break;
	 case 3  : pOwnerLord->BetSpot[2]->NoShowCards();break;
	 case 4  : pOwnerLord->BetSpot[3]->NoShowCards();break;
	 case 5  : pOwnerLord->BetSpot[4]->NoShowCards();break;
	 case 6  : pOwnerLord->BetSpot[4]->NoShowCards();break;
	 case 7  : pOwnerLord->BetSpot[5]->NoShowCards();break;
	 case 8  : pOwnerLord->BetSpot[6]->NoShowCards();break;
	 }
  }

  if ((StartingFUC + FUCLength) <= NewFUC)
  {
	 int16 discards = 0;
	 switch(pushto) {
	 case 0  : discards = pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[0])->pHand0->inhand;
				  pOwnerLord->BetSpot[0]->NoShow();break;
	 case 1  : discards = pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand1->inhand;
				  pOwnerLord->BetSpot[1]->NoShow();break;
	 case 2  : discards = pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->pHand2->inhand;
				  pOwnerLord->BetSpot[2]->NoShow();break;
	 case 3  : discards = pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->pHand2->inhand;
				  pOwnerLord->BetSpot[2]->NoShow();break;
	 case 4  : discards = pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3->inhand;
				  pOwnerLord->BetSpot[3]->NoShow();break;
	 case 5  : discards = pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->inhand;
				  pOwnerLord->BetSpot[4]->NoShow();break;
	 case 6  : discards = pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->inhand;
				  pOwnerLord->BetSpot[4]->NoShow();break;
	 case 7  : discards = pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->pHand5->inhand;
				  pOwnerLord->BetSpot[5]->NoShow();break;
	 case 8  : discards = pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[6])->pHand6->inhand;
				  pOwnerLord->BetSpot[6]->NoShow();break;
	 }
	 pOwnerLord->Rack->ShowBJRack(discards);

	 ExecuteWaiting = false;
	 FUCLength = 0;
  }
}
//*******************************************************************
void TBJPushState::CreateSubState1()
{
}
//*******************************************************************
void TBJPushState::CreateSubState2()
{
}
//*******************************************************************
void TBJPushState::CreateSubState3()
{
}
//*******************************************************************