//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  bjrmst.cpp
//    Project Name:  Casino
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     10/9/95   A. Krist    Original baseline
//  2.0     09/24/97  M.Perry     32-bit conversion.
//*******************************************************************
#include "bjrmst.h"
#include "cbjglord.h"
#include "casbjmw.h"
//#include "cbjglspl.h"
#include "orespond.h"
//*******************************************************************
TBJRemoveState::TBJRemoveState(TCasinoBJGameLord *pNewBJLord)
:TBJLordState(pNewBJLord)
{
  BetSpot1Responder           = NULL;
  BetSpot2Responder           = NULL;
  BetSpot3Responder           = NULL;
  RemoveDoubleResponder       = NULL;
  QuickKick                   = false;
}
//*******************************************************************
TBJRemoveState::~TBJRemoveState()
{
 // pOwnerLord->Responders[9]->SetCh('p');
  pOwnerLord->Button5->ShowVoidUp();
  pOwnerLord->Button3->ShowVoidUp();

}
//*******************************************************************
void TBJRemoveState::ExecuteFirstTime()
{
  ExecuteWaiting = true;
  ExecuteStatus    = ess_Execute;
}
//*******************************************************************
void TBJRemoveState::HandlePostUpdate(dword NewFUC)
{
  if(pOwnerLord->ButtonHit[bjidButton3])
  {
	 pOwnerLord->ButtonClear(bjidButton3);
	 LockHit = false;

	 return;
  }
  if(pOwnerLord->ButtonHit[bjidButton5])
  {
	 pOwnerLord->ButtonClear(bjidButton5);
	 if(pOwnerLord->BetSpotUse[1] > -1 || pOwnerLord->BetSpotUse[3] > -1 ||pOwnerLord->BetSpotUse[5] > -1)
	 {
		pOwnerLord->Button12->ShowVoidUp();
	 }
	 ExecuteWaiting = false;
	 ExecuteStatus  = ess_Done;
	 LockHit = false;
	 return;
  }
  if (BetSpot1Responder != NULL)
  {
	 if (BetSpot1Responder->GetResponseEvent() != reChar)
	 {
		BetSpot1Responder->ClearPriority();
	 }
	 if(!pOwnerLord->BetMade(pOwnerLord->activeplayer))
	 {
		QuickKick = true;;
	 }
	 BetSpot1Responder = NULL;
	 return;
  }
  if (BetSpot2Responder != NULL)
  {
	 if (BetSpot2Responder->GetResponseEvent() != reChar)
	 {
		BetSpot2Responder->ClearPriority();
	 }
	 if(!pOwnerLord->BetMade(pOwnerLord->activeplayer))
	 {
		QuickKick = true;;
	 }
	 BetSpot2Responder = NULL;
	 return;
  }
  if (BetSpot3Responder != NULL)
  {
	 if (BetSpot3Responder->GetResponseEvent() != reChar)
	 {
		BetSpot3Responder->ClearPriority();
	 }
	 if(!pOwnerLord->BetMade(pOwnerLord->activeplayer))
	 {
		QuickKick = true;;
	 }
	 BetSpot3Responder = NULL;
	 return;
  }
  if(RemoveDoubleResponder != NULL)
  {
  //	 pOwnerLord->RemoveDouble->NoShow();
	 if (RemoveDoubleResponder->GetResponseEvent() != reChar)
	 {
		RemoveDoubleResponder->ClearPriority();
	 }
	 RemoveDoubleResponder = NULL;
  //	 pOwnerLord->ClearNoInsureStand->NoShow();
  //	 pOwnerLord->SameYesInsureHit->NoShow();
	 if(pOwnerLord->BetSpotUse[1] > -1 || pOwnerLord->BetSpotUse[3] > -1 ||pOwnerLord->BetSpotUse[5] > -1)
	 {
		//pOwnerLord->DealSplit->NoShow();
	 }
	 ExecuteWaiting = false;
	 ExecuteStatus  = ess_Done;
  //	 pOwnerLord->CasStatusBar->NoShowStatusBar();
	 return;
  }
  if(QuickKick)
  {
	 QuickKick = false;
	 //pOwnerLord->RemoveDouble->NoShow();
	// pOwnerLord->ClearNoInsureStand->NoShow();
	// pOwnerLord->SameYesInsureHit->NoShow();
	 ExecuteWaiting = false;
	 ExecuteStatus  = ess_Done;
	// pOwnerLord->CasStatusBar->NoShowStatusBar();
  }
  if(NewFUC){return;}
}
//*******************************************************************
bool TBJRemoveState::HandleBetSpot1(TResponder &responder)
{
  if (responder.GetResponseEvent() == reLUp)
  {
	 if(pOwnerLord->BetSpotUse[1] > -1)
	 {
		pOwnerLord->RemoveBet(1);
		BetSpot1Responder = &responder;
	 }
	 else
	 {
		responder.ClearPriority();
	 }
  }

  if (responder.GetResponseEvent() == reLDown)
  {
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
	 if(pOwnerLord->BetSpotUse[1] > -1)
	 {
		pOwnerLord->RemoveBet(1);
		BetSpot1Responder = &responder;
	 }
	 BetSpot1Responder = &responder;
  }
  return true;
}
//*******************************************************************
bool TBJRemoveState::HandleBetSpot2(TResponder &responder)
{
  if (responder.GetResponseEvent() == reLUp)
  {
	 if(pOwnerLord->BetSpotUse[3] > -1)
	 {
		pOwnerLord->RemoveBet(3);
		BetSpot2Responder = &responder;
	 }
    else
	 {
		responder.ClearPriority();
	 }
  }

  if (responder.GetResponseEvent() == reLDown)
  {
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
	 if(pOwnerLord->BetSpotUse[3] > -1)
	 {
		pOwnerLord->RemoveBet(3);
		BetSpot2Responder = &responder;
	 }
	 BetSpot2Responder = &responder;
  }
  return true;
}
//*******************************************************************
bool TBJRemoveState::HandleBetSpot3(TResponder &responder)
{
  if (responder.GetResponseEvent() == reLUp)
  {
	 if(pOwnerLord->BetSpotUse[5] > -1)
	 {
		pOwnerLord->RemoveBet(5);
		BetSpot3Responder = &responder;
	 }
    else
	 {
		responder.ClearPriority();
	 }
  }

  if (responder.GetResponseEvent() == reLDown)
  {
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
	 if(pOwnerLord->BetSpotUse[5] > -1)
	 {
		pOwnerLord->RemoveBet(5);
		BetSpot3Responder = &responder;
	 }
	 BetSpot3Responder = &responder;
  }
  return true;
}
//*******************************************************************
bool TBJRemoveState::HandleRemoveDouble(TResponder &responder)
{
  if (responder.GetResponseEvent() == reLUp)
  {
	 RemoveDoubleResponder = &responder;
  }

  if (responder.GetResponseEvent() == reLDown)
  {
	// pOwnerLord->RemoveDouble->ShowRemoveDown();
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
 //	 pOwnerLord->RemoveDouble->ShowRemoveDown();
	 RemoveDoubleResponder = &responder;
  }
  return true;
}
//*******************************************************************
