//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  bjs3st.cpp    // split 3 state
//    Project Name:  Ogle
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     06/22/95   A. Krist    Original baseline
//  2.0     09/24/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "bjs3st.h"
#include "cbjglord.h"
#include "otimers.h"
#include "bjdealst.h"
#include "bjbustst.h"
#include "cbjplay.h"
#include "bjdeck.h"
#include "bjs4st.h"
//#include "cbjglspl.h"
#include <iostream.h>
#include "orespond.h"
//*******************************************************************
TBJSplit3State::TBJSplit3State(TCasinoBJGameLord *pNewBJLord)
:TBJLordState(pNewBJLord)
{
  SetRunOrder(ess_Execute,ess_StartSubState2,ess_Execute,ess_Done);
  RemoveDoubleResponder       = NULL;
  ClearNoInsureStandResponder = NULL;
  SameYesInsureHitResponder   = NULL;
  DealSplitResponder          = NULL;
  splitflag                   = false;
  doubleflag                  = false;
  splitacesflag               = false;
  StartingFUC = 0;
  FUCLength   = 0;
  MenuEscResponder            = NULL;
  AskExpertResponder         = NULL;

  askexpertflag               = false;
  firsttwocards               = true;
  WaitOnSkit  = false;

}
//*******************************************************************
TBJSplit3State::~TBJSplit3State()
{
 // pOwnerLord->CasStatusBar->NoShowStatusBar();
 // pOwnerLord->AskExpertButton->Release();
 pOwnerLord->FreezeAllButtons();
}
//*******************************************************************
void TBJSplit3State::HandlePostUpdate(dword NewFUC)
{
  if(pOwnerLord->ButtonHit[bjidButton2])
  {
	 LockHit = false;
	 Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	 pOwnerLord->ButtonClear(bjidButton2);
	 return;
  }
  if(pOwnerLord->ButtonHit[bjidButton3])
  {
	 pOwnerLord->ButtonClear(bjidButton3);
	 return;
  }
  if(pOwnerLord->ButtonHit[bjidButton1])
  {
	 pOwnerLord->ButtonClear(bjidButton1);
	 return;
  }
  if(pOwnerLord->ButtonHit[bjidButton0])
  {
	 if(!askexpertflag)
	 {
		askexpertflag = true;
	 }
	 else
	 {
		if(firsttwocards)
		{
		  pOwnerLord->AskFirstTwoCardsExpert(2);
		}
		else
		{
		  pOwnerLord->AskAfterFirstTwoCardsExpert(2);
		}
		pOwnerLord->ButtonClear(bjidButton0);
		askexpertflag = false;
	 }
	 LockHit = false;
	 Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	 return;
  }
  if(ExpertDelayStart)
  {
	 if(ExpertDelayStart + EXPERTDELAY <= NewFUC)
	 {
		ExpertDelayStart = 0;
	  //	pOwnerLord->AskExpertButton->Release();
	 }
  }
  if(WaitOnSkit)
  {
	 if((StartingFUC != 0) && ((StartingFUC + FUCLength) <= NewFUC))
	 {
		StartingFUC = 0;
		FUCLength   = 0;
		WaitOnSkit  = false;
      if(!FinishHit && !FinishStand && !FinishDouble)
		{
		  pOwnerLord->UnFreezeAllButtons();
		}
		if(LockHit)
		{
		  LockHit = false;
		  LockButtons = false;
		}
      if(HitTotal)
		{
		  if(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->pHand2->highhand == 21 ||
			  pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->pHand2->lohand == 21)
		  {
			 ExecuteStatus = ess_Done;
			 ExecuteWaiting = false;
		  }
		  HitTotal = false;
		}
	 }
	//?? return;//?
  }
  if(!WaitOnSkit && WaitOnHitCom)
  {
//	 StartingFUC = PTimePtr->GetFrameUpdateCount() + 1;
    StartingFUC = pOwnerLord->GetAdjFUC();
	 pOwnerLord->HitComPlayer2(StartingFUC,FUCLength);
	 WaitOnSkit    = true;
    pOwnerLord->FreezeAllButtons();

	 WaitOnHitCom  = false;
	 FinishHit     = true;
  }
  if(!WaitOnSkit && FinishHit)
  {
	 ExecuteWaiting = false;
	 ExecuteStatus  = ess_StartSubState2;
	 FinishHit = false;
  }
  if(!WaitOnSkit && WaitOnStandCom)
  {
//	 StartingFUC = PTimePtr->GetFrameUpdateCount() + 1;
    StartingFUC = pOwnerLord->GetAdjFUC();
	 pOwnerLord->StandComPlayer2(StartingFUC,FUCLength);
	 WaitOnSkit    = true;
    pOwnerLord->FreezeAllButtons();
	 WaitOnStandCom  = false;
	 FinishStand     = true;
  }
  if(!WaitOnSkit && FinishStand)
  {
	 ExecuteWaiting = false;
	 ExecuteStatus  = ess_Done;
	 FinishStand = false;
  }
  if(!WaitOnSkit && WaitOnDoubleCom)
  {
//	 StartingFUC = PTimePtr->GetFrameUpdateCount() + 1;
    StartingFUC = pOwnerLord->GetAdjFUC();
	 pOwnerLord->DoubleComPlayer2(StartingFUC,FUCLength);
	 WaitOnSkit    = true;
    pOwnerLord->FreezeAllButtons();
	 WaitOnDoubleCom  = false;
	 FinishDouble     = true;
  }
  if(!WaitOnSkit && FinishDouble)
  {
	 ExecuteWaiting = false;
	 ExecuteStatus  = ess_StartSubState2;
	 FinishDouble = false;
  }

  if((Stalling + TCasinoBJGameLord::STALLDELAY) <= NewFUC)
  {
//	 StartingFUC = PTimePtr->GetFrameUpdateCount() + 1;
    StartingFUC = pOwnerLord->GetAdjFUC();
	 pOwnerLord->Stalling(StartingFUC,FUCLength);
	 WaitOnSkit    = true;
    pOwnerLord->FreezeAllButtons();
	 Stalling      = NewFUC + FUCLength;
  }
  if(pOwnerLord->ButtonHit[bjidButton16])
  {
	 if(StartingFUC == 0)
	 {
		CoachStats(2,bjStand,firsttwocards);
		Coach(2,bjStand);
	 }
	 if(IgnoreCoach)
	 {
		LockHit = false;
		pOwnerLord->ButtonClear(bjidButton16);
	  //	CoachStats(1,bjStand,firsttwocards);
	  //	Coach(1,bjStand);
		Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
      pOwnerLord->StallsInRow = 0;
		LockButtons = false;
		return;
	 }
	 if(StartingFUC)
	 {
		if(StartingFUC + FUCLength == NewFUC)
		{
		  WaitOnStandCom = true;
		  LockHit = false;
		  pOwnerLord->ButtonClear(bjidButton16);
		  Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
        pOwnerLord->StallsInRow = 0;
		  LockButtons = false;
		  StartingFUC = 0;
		  FUCLength   = 0;
		  return;
		}
	 }
	 else
	 {
		StartingFUC = pOwnerLord->GetAdjFUC();
		bool mf=true;
      pOwnerLord->FreezeAllButtons();
		pOwnerLord->StandFingers(mf,bjnl2C,StartingFUC,FUCLength);
	 }
	 return;
  }
  if(pOwnerLord->ButtonHit[bjidButton14])
  {
	 if(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->pHand2->inhand < 3)
	 {
		CoachStats(2,bjDouble,firsttwocards);
		Coach(2,bjDouble);
		if(IgnoreCoach)
		{
		  pOwnerLord->ButtonClear(bjidButton14);
		  LockButtons = false;
		  return;
		}

		LockHit = false;
		pOwnerLord->ButtonClear(bjidButton14);
		pOwnerLord->DoubleDown(2);
		doubleflag = true;
		Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
      pOwnerLord->StallsInRow = 0;
		WaitOnDoubleCom = true;
		pOwnerLord->FreezeAllButtons();
	 }

	 return;
  }
  if(pOwnerLord->ButtonHit[bjidButton13])
  {
    if(!LockButtons && pOwnerLord->GetCash(pOwnerLord->activeplayer) >=
	 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->coinsplayedhand2)
	 {
		if(pOwnerLord->BetSpotUse[4] == -1 && pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->pHand2->inhand < 3 &&
		 ((pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->pHand2->cards[0].name ==
			pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->pHand2->cards[1].name) ||
		  (pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->pHand2->cards[0].name >= Ten &&
			pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->pHand2->cards[0].name < AceHi) &&
		  (pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->pHand2->cards[1].name >= Ten &&
			pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->pHand2->cards[1].name < AceHi)) )
	  {
		 CoachStats(2,bjSplit,firsttwocards);
		 Coach(2,bjSplit);
		 if(IgnoreCoach)
		 {
			pOwnerLord->ButtonClear(bjidButton13);
			LockButtons = false;
			return;
		 }
		 if (pOwnerLord->BetSpotUse[4] == -1)
		 {
			ExecuteWaiting = true;
			LockButtons = false;
			ExecuteStatus = ess_StartSubState1;
			pOwnerLord->splitwait = true;
			splitflag = true;
			pOwnerLord->BetSpot[2]->NoShowCard(1);
			pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->numsplitshand3++;

			pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand4 = new TBJHand;
			pOwnerLord->BetSpotUse[4] = pOwnerLord->BetSpotUse[3];
			pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->coinsplayedhand4
				= pOwnerLord->SplitMoney(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->coinsplayedhand2);

			pOwnerLord->BetSpot[4]->
				SetNum(pOwnerLord->GetBJPlayer(pOwnerLord->activeplayer)->coinsplayedhand4);

			pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->cards[0] =
			  pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->pHand2->cards[1];
			pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->inhand++;
			pOwnerLord->BetSpot[4]->ShowFace(
						  pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4);

			pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->pHand2->inhand--;
			pOwnerLord->FreezeAllButtons();
		 }
		 Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
       pOwnerLord->StallsInRow = 0;
		 pOwnerLord->ButtonClear(bjidButton13);
	  }
	 }
    Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	 pOwnerLord->ButtonClear(bjidButton13);
	 return;
  }
  if(pOwnerLord->ButtonHit[bjidButton15])
  {
	 if(StartingFUC == 0)
	 {
		CoachStats(2,bjHit,firsttwocards);
		Coach(2,bjHit);
	 }
    if(IgnoreCoach)
	 {
		Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
      pOwnerLord->StallsInRow = 0;
		pOwnerLord->ButtonClear(bjidButton15);
		LockButtons = false;
		return;
	 }
    if(StartingFUC)
	 {
		if(StartingFUC + FUCLength <= NewFUC)
		{
		  WaitOnHitCom = true;
        Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
        pOwnerLord->StallsInRow = 0;
		  pOwnerLord->ButtonClear(bjidButton15);
		  StartingFUC = 0;
		  FUCLength   = 0;
		  return;
		}
	 }
	 else
	 {
		pOwnerLord->Button14->ShowGray();
		pOwnerLord->Button13->ShowGray();
		firsttwocards = false;
		StartingFUC = pOwnerLord->GetAdjFUC();
		bool mf=true;
      pOwnerLord->FreezeAllButtons();
		pOwnerLord->HitFingers(mf,bjnl2C,StartingFUC,FUCLength);
	 }
	 //LockHit = false;
	// Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;pOwnerLord->StallsInRow = 0;
	// pOwnerLord->ButtonClear(bjidButton15);
	 return;
  }

}
//*******************************************************************
bool TBJSplit3State::HandleRemoveDouble(TResponder &responder)
{
 if(!LockButtons && pOwnerLord->GetCash(pOwnerLord->activeplayer) > 0)
 {
  if(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->pHand2->inhand < 3)
  {
	 if (responder.GetResponseEvent() == reLUp)
	 {
		CoachStats(2,bjDouble,firsttwocards);
		Coach(2,bjDouble);
		RemoveDoubleResponder = &responder;
		LockButtons = true;
	 }

	 if (responder.GetResponseEvent() == reLDown)
	 {
//		Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
      Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
      pOwnerLord->StallsInRow = 0;
	//	pOwnerLord->RemoveDouble->ShowDoubleDown();
		responder.SetPriority();
	 }

	 if (responder.GetResponseEvent() == reChar)
	 {
//		Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
      Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
      pOwnerLord->StallsInRow = 0;
  //		pOwnerLord->RemoveDouble->ShowDoubleDown();
		RemoveDoubleResponder = &responder;
	 }
  }
 }
 return true;
}
//*******************************************************************
bool TBJSplit3State::HandleClearNoInsureStand(TResponder &responder)
{
 if(!LockButtons)
 {
  if (responder.GetResponseEvent() == reLUp)
  {
	 CoachStats(2,bjStand,firsttwocards);
	 Coach(2,bjStand);
	 ClearNoInsureStandResponder = &responder;
	 LockButtons = true;
  }

  if (responder.GetResponseEvent() == reLDown)
  {
//	 Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
    Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	  //	pOwnerLord->ClearNoInsureStand->ShowStandDown();
	  //	pOwnerLord->RemoveDouble->ShowDouble();
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
//	 Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
    Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	  //	pOwnerLord->ClearNoInsureStand->ShowStandDown();
	  // pOwnerLord->RemoveDouble->ShowDouble();
	 ClearNoInsureStandResponder = &responder;
  }
 }
 return true;
}
//*******************************************************************
bool TBJSplit3State::HandleSameYesInsureHit(TResponder &responder)
{
 if(!LockButtons)
 {
  if (responder.GetResponseEvent() == reLUp)
  {
	 CoachStats(2,bjHit,firsttwocards);
	 Coach(2,bjHit);
	 SameYesInsureHitResponder = &responder;
	 LockButtons = true;
  }

  if (responder.GetResponseEvent() == reLDown)
  {
//	 Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
    Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	// pOwnerLord->SameYesInsureHit->ShowHitDown();
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
//	 Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
    Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	// pOwnerLord->SameYesInsureHit->ShowHitDown();
	 SameYesInsureHitResponder = &responder;
  }
 }
 return true;
}
//*******************************************************************
bool TBJSplit3State::HandleDealSplit(TResponder &responder)
{
 if(!LockButtons && pOwnerLord->GetCash(pOwnerLord->activeplayer) >=
	 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->coinsplayedhand2)
 {
	if(pOwnerLord->BetSpotUse[4] == -1 && pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->pHand2->inhand < 3 &&
	  ((pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->pHand2->cards[0].name ==
		 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->pHand2->cards[1].name) ||
		(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->pHand2->cards[0].name >= Ten &&
		 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->pHand2->cards[0].name < AceHi) &&
		(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->pHand2->cards[1].name >= Ten &&
		 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->pHand2->cards[1].name < AceHi)) )
	{
	  if (responder.GetResponseEvent() == reLUp)
	  {
		 CoachStats(2,bjSplit,firsttwocards);
		 Coach(2,bjSplit);
		 DealSplitResponder = &responder;
		 LockButtons = true;
	  }

	 if (responder.GetResponseEvent() == reLDown)
	 {
//		Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
      Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
      pOwnerLord->StallsInRow = 0;
	  //	pOwnerLord->DealSplit->ShowSplitDown();
		responder.SetPriority();
	 }

	 if (responder.GetResponseEvent() == reChar)
	 {
//		Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
      Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
      pOwnerLord->StallsInRow = 0;
	  //	pOwnerLord->DealSplit->ShowSplitDown();
		DealSplitResponder = &responder;
	 }
  }
 }
 return true;
}
//*******************************************************************
void TBJSplit3State::ExecuteFirstTime()
{
  pOwnerLord->Button0->ShowVoidUp();
  pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand2 = new TBJHand;
  pOwnerLord->BetSpotUse[2] = pOwnerLord->BetSpotUse[3];
  pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->coinsplayedhand2 =
    pOwnerLord->SplitMoney(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->coinsplayedhand3);

  pOwnerLord->BetSpot[2]->
			 SetNum(pOwnerLord->GetBJPlayer(pOwnerLord->activeplayer)->coinsplayedhand2);

  pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->pHand2->cards[0] =
											  pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3->cards[1];
  pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->pHand2->inhand++;
  pOwnerLord->BetSpot[2]->ShowFace(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->pHand2);
  /*********/
  if(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->pHand2->cards[0].name == AceHi)
  {
	 splitacesflag = true;
  }
  int16 session = pOwnerLord->GetCasPD(pOwnerLord->BetSpotUse[2])->BJData.CurrentSession;
  TCBJSession &cs = pOwnerLord->GetCasPD(pOwnerLord->BetSpotUse[2])->BJData.Sessions[session];

  cs.HandsPlayed++;
  cs.Splits++;
  cs.TotalBetsCash += pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->coinsplayedhand2;
   /////*&*&$%#!@%*** set split flag
  ExecuteWaiting = true;
  ExecuteStatus    = ess_StartSubState2;
  if(pOwnerLord->GetCash(pOwnerLord->activeplayer) > 0)
  {
	 pOwnerLord->Button14->ShowVoidUp();
  }
  else
  {
	 pOwnerLord->Button13->ShowGray();
	 pOwnerLord->Button14->ShowGray();
  }
  if(pOwnerLord->GetCash(pOwnerLord->activeplayer) <
		 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->coinsplayedhand2)
  {
	 pOwnerLord->Button13->ShowGray();
  }
  pOwnerLord->Button16->ShowVoidUp();
  pOwnerLord->Button15->ShowVoidUp();
  splitbutton = true;
  pOwnerLord->pDeck->Busted(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->pHand2);
  pOwnerLord->MessageDisplay->ShowBJMessage(pOwnerLord->PlayerTotal());
  PlayerTotalMessage(2);
  FinishHit    = false;
  FinishStand  = false;
  FinishDouble = false;
  WaitOnHitCom    = false;
  WaitOnStandCom  = false;
  WaitOnDoubleCom = false;
  Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
  pOwnerLord->StallsInRow = 0;
  pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->hand2owner = 2;
  pOwnerLord->UnFreezeAllButtons();
}
//*******************************************************************
void TBJSplit3State::CreateSubState1()
{
  //PActiveSubState = new TBJSplit4State(pOwnerLord,4);
}
//*******************************************************************
void TBJSplit3State::EndSubState1()
{
  TState::EndSubState1();
  splitbutton = true;
}
//*******************************************************************
void TBJSplit3State::CreateSubState2()
{
  pOwnerLord->FreezeAllButtons();
  PActiveSubState = new TBJDealState(pOwnerLord,3);
}
//*******************************************************************
void TBJSplit3State::EndSubState2()
{
  TState::EndSubState2();
  if(splitacesflag)
  {
	 ExecuteStatus = ess_Done;
	 ExecuteWaiting = false;
	 splitacesflag = false;
  }
  else if(pOwnerLord->/*((TBJDeck *)*/pDeck->
	  Busted(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->pHand2) == 1)
  {
	 pOwnerLord->FreezeAllButtons();
	 ExecuteStatus = ess_StartSubState3;
  }
  else if(doubleflag == true)
  {
	 doubleflag = false;
	 ExecuteStatus = ess_Done;
	 ExecuteWaiting = false;
  }
  else
  {
	 if(splitflag == true && pOwnerLord->
		 GetBJPlayer(pOwnerLord->BetSpotUse[2])->pHand2->cards[0].name == AceHi)
	 {
		splitflag = false;
		ExecuteStatus = ess_Done;
	 }
	 else
	 {
		splitflag = false;
	 }
  }
  ExecuteWaiting = true;
  PlayerTotalMessage(2);
  if(ExecuteStatus != ess_StartSubState3 && ExecuteStatus != ess_Done)
  {
//	 StartingFUC = PTimePtr->GetFrameUpdateCount() + 1;
    StartingFUC = pOwnerLord->GetAdjFUC();
	 pOwnerLord->AnnouncePlayer2Total(StartingFUC,FUCLength);
	 WaitOnSkit    = true;
	 pOwnerLord->FreezeAllButtons();
	 LockHit = true;
	 HitTotal = true;
  }

  if(splitbutton)
  {
    LockButtons = false;
	 splitbutton = false;
	 if(pOwnerLord->BetSpotUse[4] == -1 &&
		 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->pHand2->inhand < 3 &&
		 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->numsplitshand3 < 2 &&
		 pOwnerLord->GetCash(pOwnerLord->activeplayer) >=
		 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->coinsplayedhand2   &&
	  ((pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->pHand2->cards[0].name ==
		 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->pHand2->cards[1].name) ||
		(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->pHand2->cards[0].name >= Ten &&
		 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->pHand2->cards[0].name < AceHi) &&
		(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->pHand2->cards[1].name >= Ten &&
		 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->pHand2->cards[1].name < AceHi)) )
	 {
		pOwnerLord->Button13->ShowVoidUp();
	 }
	 else
	 {
		pOwnerLord->Button13->ShowGray();
    }
  }
}
//*******************************************************************
void TBJSplit3State::CreateSubState3()
{
  pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->hand2owner = 0;
  PActiveSubState = new TBJBustState(pOwnerLord,3);
}
//*******************************************************************
bool TBJSplit3State::HandleMenuEsc(TResponder &responder)
{
	if (responder.GetResponseEvent() == reLUp)
  {
	 MenuEscResponder = &responder;
  }

  if (responder.GetResponseEvent() == reLDown)
  {
//	 Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
    Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	//	pOwnerLord->MenuEscButton->Depress();
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
//	 Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
    Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	  //	pOwnerLord->MenuEscButton->Depress();
	 MenuEscResponder = &responder;
  }

  return true;
}
//*******************************************************************
bool TBJSplit3State::HandleAskExpert(TResponder &responder)
{
	if (responder.GetResponseEvent() == reLUp)
  {
	 AskExpertResponder = &responder;
  }

  if (responder.GetResponseEvent() == reLDown)
  {
//	 Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
    Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
		//pOwnerLord->AskExpertButton->Depress();
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
//	 Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
	 Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	 //	pOwnerLord->AskExpertButton->Depress();
	 AskExpertResponder = &responder;
  }

  return true;
}

//*******************************************************************
