//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  bjs4st.cpp    // split 4 state
//    Project Name:  Ogle
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     06/22/95   A. Krist    Original baseline
//  2.0     09/24/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "bjs4st.h"
#include "bjs7st.h"
#include "cbjglord.h"
#include "otimers.h"
#include "bjdealst.h"
#include "bjbustst.h"
#include "cbjplay.h"
#include "bjdeck.h"
//#include "cbjglspl.h"
#include <iostream.h>
#include "orespond.h"
//*******************************************************************
TBJSplit4State::TBJSplit4State(TCasinoBJGameLord *pNewBJLord,int16 Split)
:TBJLordState(pNewBJLord)
{
  SetRunOrder(ess_Execute,ess_Execute,ess_Done,ess_StartSubState1);
  RemoveDoubleResponder       = NULL;
  ClearNoInsureStandResponder = NULL;
  SameYesInsureHitResponder   = NULL;
  DealSplitResponder          = NULL;
  doubleflag                  = false;
  splitflag                   = false;
  splitbutton                 = false;
  pOwnerLord->splitwait       = false;
  splitacesflag               = false;
  split                       = Split;
  StartingFUC = 0;
  FUCLength   = 0;
  MenuEscResponder            = NULL;
  AskExpertResponder         = NULL;
  FinishHit    = false;
  FinishSplit  = false;
  FinishStand  = false;
  FinishDouble = false;
  WaitOnHitCom    = false;
  WaitOnStandCom  = false;
  WaitOnDoubleCom = false;
  askexpertflag               = false;
  firsttwocards               = true;
  WaitOnSkit  = false;

}
//*******************************************************************
TBJSplit4State::~TBJSplit4State()
{
  //pOwnerLord->CasStatusBar->NoShowStatusBar();
 // pOwnerLord->AskExpertButton->Release();
 pOwnerLord->FreezeAllButtons();
}
//*******************************************************************
void TBJSplit4State::HandlePostUpdate(dword NewFUC)
{
  if(pOwnerLord->ButtonHit[bjidButton2])
  {
	 LockHit = false;
	 Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	 pOwnerLord->ButtonClear(bjidButton2);
	 return;
  }
  if(pOwnerLord->ButtonHit[bjidButton3])
  {
	 pOwnerLord->ButtonClear(bjidButton3);
	 return;
  }
  if(pOwnerLord->ButtonHit[bjidButton1])
  {
	 pOwnerLord->ButtonClear(bjidButton1);
	 return;
  }
  if(pOwnerLord->ButtonHit[bjidButton0])
  {
	 if(!askexpertflag)
	 {
		askexpertflag = true;
	 }
	 else
	 {
		if(firsttwocards)
		{
		  pOwnerLord->AskFirstTwoCardsExpert(4);
		}
		else
		{
		  pOwnerLord->AskAfterFirstTwoCardsExpert(4);
		}
		pOwnerLord->ButtonClear(bjidButton0);
		askexpertflag = false;
	 }
	 LockHit = false;
	 Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	 return;
  }
  if(ExpertDelayStart)
  {
	 if(ExpertDelayStart + EXPERTDELAY <= NewFUC)
	 {
		ExpertDelayStart = 0;
	 //	pOwnerLord->AskExpertButton->Release();
	 }
  }
  if(WaitOnSkit)
  {
	 if((StartingFUC != 0) && ((StartingFUC + FUCLength) <= NewFUC))
	 {
		StartingFUC = 0;
		FUCLength   = 0;
		WaitOnSkit  = false;
		if(!FinishHit && !FinishStand && !FinishDouble && !FinishSplit)
		{
		  pOwnerLord->UnFreezeAllButtons();
		}
		if(LockHit)
		{
		  LockHit = false;
		  LockButtons = false;
		}
      if(HitTotal)
		{
		  if(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->highhand == 21 ||
			  pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->lohand == 21)
		  {
			 ExecuteStatus = ess_Done;
			 ExecuteWaiting = false;
		  }
		  HitTotal = false;
		}
	 }
	//?? return;//?
  }
  if(!WaitOnSkit && WaitOnHitCom)
  {
//	 StartingFUC = PTimePtr->GetFrameUpdateCount() + 1;
    StartingFUC = pOwnerLord->GetAdjFUC();
	 pOwnerLord->HitComPlayer2(StartingFUC,FUCLength);
	 WaitOnSkit    = true;
    pOwnerLord->FreezeAllButtons();
	 WaitOnHitCom  = false;
	 FinishHit     = true;
  }
  if(!WaitOnSkit && FinishHit)
  {
	 ExecuteWaiting = false;
	 ExecuteStatus  = ess_StartSubState1;
	 FinishHit = false;
  }
  if(!WaitOnSkit && WaitOnStandCom)
  {
//	 StartingFUC = PTimePtr->GetFrameUpdateCount() + 1;
    StartingFUC = pOwnerLord->GetAdjFUC();
	 pOwnerLord->StandComPlayer2(StartingFUC,FUCLength);
	 WaitOnSkit    = true;
    pOwnerLord->FreezeAllButtons();
	 WaitOnStandCom  = false;
	 FinishStand     = true;
  }
  if(!WaitOnSkit && FinishStand)
  {
	 ExecuteWaiting = false;
	 ExecuteStatus  = ess_Done;
	 FinishStand = false;
  }
  if(!WaitOnSkit && WaitOnDoubleCom)
  {
//	 StartingFUC = PTimePtr->GetFrameUpdateCount() + 1;
    StartingFUC = pOwnerLord->GetAdjFUC();
	 pOwnerLord->DoubleComPlayer2(StartingFUC,FUCLength);
	 WaitOnSkit    = true;
    pOwnerLord->FreezeAllButtons();
	 WaitOnDoubleCom  = false;
	 FinishDouble     = true;
  }
  if(!WaitOnSkit && FinishDouble)
  {
	 ExecuteWaiting = false;
	 ExecuteStatus  = ess_StartSubState1;
	 FinishDouble = false;
  }
  if(!WaitOnSkit && FinishSplit)
  {
	 FinishSplit = false;
	 if (pOwnerLord->BetSpotUse[3] == -1)
	 {
		LockButtons = false;
	  //	pOwnerLord->DealSplit->ShowSplit();
		ExecuteWaiting = false;
		ExecuteStatus = ess_StartSubState3;
		splitflag = true;
		pOwnerLord->BetSpot[4]->NoShowCard(1);
		pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->numsplitshand3++;
	 }
  }
  if((Stalling + TCasinoBJGameLord::STALLDELAY) <= NewFUC)
  {
//	 StartingFUC = PTimePtr->GetFrameUpdateCount() + 1;
    StartingFUC = pOwnerLord->GetAdjFUC();
	 pOwnerLord->Stalling(StartingFUC,FUCLength);
	 WaitOnSkit    = true;
    pOwnerLord->FreezeAllButtons();
	 Stalling      = NewFUC + FUCLength;
  }
  if(pOwnerLord->ButtonHit[bjidButton16])
  {
	 if(StartingFUC == 0)
	 {
		CoachStats(4,bjStand,firsttwocards);
		Coach(4,bjStand);
	 }
	 if(IgnoreCoach)
	 {
		LockHit = false;
		pOwnerLord->ButtonClear(bjidButton16);
	  //	CoachStats(1,bjStand,firsttwocards);
	  //	Coach(1,bjStand);
		Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
      pOwnerLord->StallsInRow = 0;
		LockButtons = false;
		return;
	 }
	 if(StartingFUC)
	 {
		if(StartingFUC + FUCLength == NewFUC)
		{
		  WaitOnStandCom = true;
		  LockHit = false;
		  pOwnerLord->ButtonClear(bjidButton16);
		  Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
        pOwnerLord->StallsInRow = 0;
		  LockButtons = false;
		  StartingFUC = 0;
		  FUCLength   = 0;
		  return;
		}
	 }
	 else
	 {
		StartingFUC = pOwnerLord->GetAdjFUC();
		bool mf=true;
      pOwnerLord->FreezeAllButtons();
		pOwnerLord->StandFingers(mf,bjnl2E,StartingFUC,FUCLength);
	 }
	 return;
  }
  if(pOwnerLord->ButtonHit[bjidButton14])
  {
	 if(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->inhand < 3)
	 {
		CoachStats(4,bjDouble,firsttwocards);
		Coach(4,bjDouble);
		if(IgnoreCoach)
		{
		  pOwnerLord->ButtonClear(bjidButton14);
		  LockButtons = false;
		  return;
		}

		LockHit = false;
		pOwnerLord->ButtonClear(bjidButton14);
		pOwnerLord->DoubleDown(4);
		doubleflag = true;
		Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
      pOwnerLord->StallsInRow = 0;
		WaitOnDoubleCom = true;
		pOwnerLord->FreezeAllButtons();
	 }

	 return;
  }
  if(pOwnerLord->ButtonHit[bjidButton13])
  {
	 if(!LockButtons && pOwnerLord->GetCash(pOwnerLord->activeplayer) >=
	 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->coinsplayedhand4)
	 {
		TCasinoBJPlayer *player;
		player = pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4]);
		if((pOwnerLord->BetSpotUse[3] == -1) &&
		  player->numsplitshand3 < 2 &&
		  player->pHand4->inhand < 3 &&
		((player->pHand4->cards[0].name ==
		  player->pHand4->cards[1].name) ||
		 (player->pHand4->cards[0].name >= Ten &&
		  player->pHand4->cards[0].name < AceHi) &&
		 (player->pHand4->cards[1].name >= Ten &&
		  player->pHand4->cards[1].name < AceHi) ) )
		{
		  CoachStats(4,bjSplit,firsttwocards);
		  Coach(4,bjSplit);
		  if(IgnoreCoach)
		  {
			 pOwnerLord->ButtonClear(bjidButton13);
			 LockButtons = false;
			 return;
		  }
		  if(pOwnerLord->BetSpotUse[3] == -1)
		  {
			 FUCLength = 0;
			 StartingFUC = pOwnerLord->GetAdjFUC();
			 pOwnerLord->SplitComPlayer2(StartingFUC,FUCLength);
			 WaitOnSkit    = true;
          pOwnerLord->FreezeAllButtons();
			 FinishSplit   = true;
		  }
        Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
        pOwnerLord->StallsInRow = 0;
		  pOwnerLord->ButtonClear(bjidButton13);
		}
	 }
    Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	 pOwnerLord->ButtonClear(bjidButton13);
	 return;
  }
  if(pOwnerLord->ButtonHit[bjidButton15])
  {
	 if(StartingFUC == 0)
	 {
		CoachStats(4,bjHit,firsttwocards);
		Coach(4,bjHit);
	 }
    if(IgnoreCoach)
	 {
		Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
      pOwnerLord->StallsInRow = 0;
		pOwnerLord->ButtonClear(bjidButton15);
		LockButtons = false;
		return;
	 }
    if(StartingFUC)
	 {
		if(StartingFUC + FUCLength <= NewFUC)
		{
		  WaitOnHitCom = true;
        Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
        pOwnerLord->StallsInRow = 0;
		  pOwnerLord->ButtonClear(bjidButton15);
		  StartingFUC = 0;
		  FUCLength   = 0;
		  return;
		}
	 }
	 else
	 {
		pOwnerLord->Button14->ShowGray();
		pOwnerLord->Button13->ShowGray();
		firsttwocards = false;
		StartingFUC = pOwnerLord->GetAdjFUC();
		bool mf=true;
      pOwnerLord->FreezeAllButtons();
		pOwnerLord->HitFingers(mf,bjnl2E,StartingFUC,FUCLength);
	 }
	 //LockHit = false;
	// Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;pOwnerLord->StallsInRow = 0;
	// pOwnerLord->ButtonClear(bjidButton15);
	 return;
  }

}
//*******************************************************************
bool TBJSplit4State::HandleRemoveDouble(TResponder &responder)
{
 if(!LockButtons && pOwnerLord->GetCash(pOwnerLord->activeplayer) > 0)
 {
  if(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->inhand < 3)
  {
	 if (responder.GetResponseEvent() == reLUp)
	 {
		CoachStats(4,bjDouble,firsttwocards);
		Coach(4,bjDouble);
		RemoveDoubleResponder = &responder;
		LockButtons = true;
	 }

	 if (responder.GetResponseEvent() == reLDown)
	 {
//		Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
      Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
      pOwnerLord->StallsInRow = 0;
  //		pOwnerLord->RemoveDouble->ShowDoubleDown();
		responder.SetPriority();
	 }

	 if (responder.GetResponseEvent() == reChar)
	 {
//		Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
      Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
      pOwnerLord->StallsInRow = 0;
	//	pOwnerLord->RemoveDouble->ShowDoubleDown();
		RemoveDoubleResponder = &responder;
	 }
  }
 }
 return true;
}
//*******************************************************************
bool TBJSplit4State::HandleClearNoInsureStand(TResponder &responder)
{
 if(!LockButtons)
 {
  if (responder.GetResponseEvent() == reLUp)
  {
	 CoachStats(4,bjStand,firsttwocards);
	 Coach(4,bjStand);
	 ClearNoInsureStandResponder = &responder;
	 LockButtons = true;
  }

  if (responder.GetResponseEvent() == reLDown)
  {
//	 Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
    Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
 //		pOwnerLord->ClearNoInsureStand->ShowStandDown();
  //		pOwnerLord->RemoveDouble->ShowDouble();
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
//	 Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
    Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	  //	pOwnerLord->ClearNoInsureStand->ShowStandDown();
	  //	pOwnerLord->RemoveDouble->ShowDouble();
	 ClearNoInsureStandResponder = &responder;
  }
 }
 return true;
}
//*******************************************************************
bool TBJSplit4State::HandleSameYesInsureHit(TResponder &responder)
{
 if(!LockButtons)
 {
  if (responder.GetResponseEvent() == reLUp)
  {
	 CoachStats(4,bjHit,firsttwocards);
	 Coach(4,bjHit);
	 SameYesInsureHitResponder = &responder;
	 LockButtons = true;
  }

  if (responder.GetResponseEvent() == reLDown)
  {
//	 Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
    Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	// pOwnerLord->SameYesInsureHit->ShowHitDown();
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
//	 Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
    Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	// pOwnerLord->SameYesInsureHit->ShowHitDown();
	 SameYesInsureHitResponder = &responder;
  }
 }
 return true;
}
//*******************************************************************
bool TBJSplit4State::HandleDealSplit(TResponder &responder)
{
 if(!LockButtons && pOwnerLord->GetCash(pOwnerLord->activeplayer) >=
	 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->coinsplayedhand4)
 {
	 TCasinoBJPlayer *player;
	 player = pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4]);
	 if((pOwnerLord->BetSpotUse[3] == -1) &&
		player->numsplitshand3 < 2 &&
		player->pHand4->inhand < 3 &&
	 ((player->pHand4->cards[0].name ==
		player->pHand4->cards[1].name) ||
	  (player->pHand4->cards[0].name >= Ten &&
		player->pHand4->cards[0].name < AceHi) &&
	  (player->pHand4->cards[1].name >= Ten &&
		player->pHand4->cards[1].name < AceHi) ) )
  {
	 if (responder.GetResponseEvent() == reLUp)
	 {
		CoachStats(4,bjSplit,firsttwocards);
		Coach(4,bjSplit);
		LockButtons = true;
		DealSplitResponder = &responder;
	 }

	 if (responder.GetResponseEvent() == reLDown)
	 {
//		Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
      Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
      pOwnerLord->StallsInRow = 0;
	//	pOwnerLord->DealSplit->ShowSplitDown();
		responder.SetPriority();
	 }

	 if (responder.GetResponseEvent() == reChar)
	 {
//		Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
      Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
      pOwnerLord->StallsInRow = 0;
	 ///	pOwnerLord->DealSplit->ShowSplitDown();
		DealSplitResponder = &responder;
	 }
  }
 }
 return true;
}
//*******************************************************************
void TBJSplit4State::ExecuteFirstTime()
{
  pOwnerLord->Button0->ShowVoidUp();
  if(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->cards[0].name == AceHi)
  {
	 splitacesflag = true;
  }
  int16 session = pOwnerLord->GetCasPD(pOwnerLord->BetSpotUse[4])->BJData.CurrentSession;
  TCBJSession &cs = pOwnerLord->GetCasPD(pOwnerLord->BetSpotUse[4])->BJData.Sessions[session];

  cs.HandsPlayed++;
  cs.Splits++;
  cs.TotalBetsCash += pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->coinsplayedhand4;
  ExecuteWaiting = true;
  ExecuteStatus    = ess_StartSubState1;
  if((pOwnerLord->BetSpotUse[3] == -1) &&
			 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->numsplitshand3 < 2 &&
			 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->inhand < 3 &&
		  ((pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->cards[0].name ==
			 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->cards[1].name) ||
			(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->cards[0].name >= Ten &&
			 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->cards[0].name < AceHi) &&
			(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->cards[1].name >= Ten &&
			 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->cards[1].name < AceHi)) )
  {
	 pOwnerLord->Button13->ShowVoidUp();
  }
  if(pOwnerLord->GetCash(pOwnerLord->activeplayer) > 0)
  {
	 pOwnerLord->Button14->ShowVoidUp();
  }
  else
  {
	 pOwnerLord->Button13->ShowGray();
	 pOwnerLord->Button14->ShowGray();
  }
  if(pOwnerLord->GetCash(pOwnerLord->activeplayer) <
		 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->coinsplayedhand4)
  {
	 pOwnerLord->Button13->ShowGray();
  }
  splitbutton = true;
  pOwnerLord->Button15->ShowVoidUp();
  pOwnerLord->Button16->ShowVoidUp();
  pOwnerLord->pDeck->Busted(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4);
  pOwnerLord->MessageDisplay->ShowBJMessage(pOwnerLord->PlayerTotal());
  PlayerTotalMessage(4);

  Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
  pOwnerLord->StallsInRow = 0;
  pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->hand4owner = 2;
  pOwnerLord->UnFreezeAllButtons();
}
//*******************************************************************
void TBJSplit4State::CreateSubState3()
{
  pOwnerLord->Circle2->SetPart(pOwnerLord->activeplayer,bjnl2D);
  PActiveSubState = new TBJSplit7State(pOwnerLord,1);
}
//*******************************************************************
void TBJSplit4State::EndSubState3()
{
  TState::EndSubState3();
  Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
  pOwnerLord->StallsInRow = 0;
  pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->inhand--;
  splitbutton = true;
}
//*******************************************************************
void TBJSplit4State::CreateSubState1()
{
  pOwnerLord->FreezeAllButtons();
  PActiveSubState = new TBJDealState(pOwnerLord,5);
}
//*******************************************************************
void TBJSplit4State::EndSubState1()
{
  TState::EndSubState1();
  if(splitacesflag)
  {
	 ExecuteStatus  = ess_Done;
	 ExecuteWaiting = false;
	 splitacesflag  = false;
  }
  else if(pOwnerLord->/*((TBJDeck *)*/pDeck->
	  Busted(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4) == 1)
  {
    pOwnerLord->FreezeAllButtons();
	 ExecuteStatus = ess_StartSubState2;
  }
  else if(doubleflag == true)
  {
	 doubleflag = false;
	 ExecuteStatus = ess_Done;
	 ExecuteWaiting = false;
  }
  ExecuteWaiting = true;    //What the hell is this doing here...
  PlayerTotalMessage(4);
  if(ExecuteStatus != ess_StartSubState2 && ExecuteStatus != ess_Done)
  {
    StartingFUC = pOwnerLord->GetAdjFUC();
	 pOwnerLord->AnnouncePlayer2Total(StartingFUC,FUCLength);
	 WaitOnSkit    = true;
	 pOwnerLord->FreezeAllButtons();
	 LockHit = true;
	 HitTotal = true;
  }
  if(splitbutton)
  {
	 LockButtons = false;
	 splitbutton = false;
	 if((pOwnerLord->BetSpotUse[3] == -1) &&
			 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->numsplitshand3 < 2 &&
			 pOwnerLord->GetCash(pOwnerLord->activeplayer) >=
			 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->coinsplayedhand4   &&
			 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->inhand < 3 &&
		  ((pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->cards[0].name ==
			 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->cards[1].name) ||
			(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->cards[0].name >= Ten &&
			 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->cards[0].name < AceHi) &&
			(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->cards[1].name >= Ten &&
			 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->cards[1].name < AceHi)) )
	 {
		pOwnerLord->Button13->ShowVoidUp();
	 }
	 else
	 {
		pOwnerLord->Button13->ShowGray();
	 }
  }
  Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
  pOwnerLord->StallsInRow = 0;
}
//*******************************************************************
void TBJSplit4State::CreateSubState2()
{
  pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->hand4owner = 0;
  PActiveSubState = new TBJBustState(pOwnerLord,5);
}
//*******************************************************************
bool TBJSplit4State::HandleMenuEsc(TResponder &responder)
{
	if (responder.GetResponseEvent() == reLUp)
  {
	 MenuEscResponder = &responder;
  }

  if (responder.GetResponseEvent() == reLDown)
  {
//	 Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
	 Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	  //	pOwnerLord->MenuEscButton->Depress();
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
//	 Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
	 Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
		//pOwnerLord->MenuEscButton->Depress();
	 MenuEscResponder = &responder;
  }

  return true;
}
//*******************************************************************
bool TBJSplit4State::HandleAskExpert(TResponder &responder)
{
	if (responder.GetResponseEvent() == reLUp)
  {
	 AskExpertResponder = &responder;
  }

  if (responder.GetResponseEvent() == reLDown)
  {
//	 Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
    Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	  ///	pOwnerLord->AskExpertButton->Depress();
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
//	 Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
    Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	  //	pOwnerLord->AskExpertButton->Depress();
	 AskExpertResponder = &responder;
  }

  return true;
}

//*******************************************************************//*******************************************************************