//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  bjs5st.cpp    // split 5 state
//    Project Name:  Ogle
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     06/22/95   A. Krist    Original baseline
//  2.0     09/23/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "bjs5st.h"
#include "cbjglord.h"
#include "otimers.h"
#include "bjdealst.h"
#include "bjbustst.h"
#include "cbjplay.h"
#include "bjdeck.h"
#include "bjs6st.h"
//#include "cbjglspl.h"
//#include "cbjglspl.h"
#include <iostream.h>
#include "orespond.h"
//*******************************************************************
TBJSplit5State::TBJSplit5State(TCasinoBJGameLord *pNewBJLord)
:TBJLordState(pNewBJLord)
{
  SetRunOrder(ess_Execute,ess_StartSubState2,ess_Execute,ess_Done);
  RemoveDoubleResponder       = NULL;
  ClearNoInsureStandResponder = NULL;
  SameYesInsureHitResponder   = NULL;
  DealSplitResponder          = NULL;
  splitflag                   = false;
  doubleflag                  = false;
  splitacesflag               = false;
  StartingFUC = 0;
  FUCLength   = 0;
  MenuEscResponder            = NULL;
  AskExpertResponder         = NULL;

  askexpertflag               = false;
  firsttwocards               = true;
  WaitOnSkit  = false;
}
//*******************************************************************
TBJSplit5State::~TBJSplit5State()
{
  pOwnerLord->Button0->ShowUp();
  pOwnerLord->FreezeAllButtons();
}
//*******************************************************************
void TBJSplit5State::HandlePostUpdate(dword NewFUC)
{
  if(pOwnerLord->ButtonHit[bjidButton2])
  {
	 LockHit = false;
	 Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	 pOwnerLord->ButtonClear(bjidButton2);
	 return;
  }
  if(pOwnerLord->ButtonHit[bjidButton3])
  {
	 pOwnerLord->ButtonClear(bjidButton3);
	 return;
  }
  if(pOwnerLord->ButtonHit[bjidButton1])
  {
	 pOwnerLord->ButtonClear(bjidButton1);
	 return;
  }
  if(pOwnerLord->ButtonHit[bjidButton0])
  {
	 if(!askexpertflag)
	 {
		askexpertflag = true;
	 }
	 else
	 {
		if(firsttwocards)
		{
		  pOwnerLord->AskFirstTwoCardsExpert(4);
		}
		else
		{
		  pOwnerLord->AskAfterFirstTwoCardsExpert(4);
		}
		pOwnerLord->ButtonClear(bjidButton0);
		askexpertflag = false;
	 }
	 LockHit = false;
	 Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	 return;
  }
  if(ExpertDelayStart)
  {
	 if(ExpertDelayStart + EXPERTDELAY <= NewFUC)
	 {
		ExpertDelayStart = 0;
		pOwnerLord->Button0->ShowUp();
	 }
  }
  if(WaitOnSkit)
  {
	 if((StartingFUC != 0) && ((StartingFUC + FUCLength) <= NewFUC))
	 {
		StartingFUC = 0;
		FUCLength   = 0;
		WaitOnSkit  = false;
		if(!FinishHit && !FinishStand && !FinishDouble)
		{
		  pOwnerLord->UnFreezeAllButtons();
		}
		if(LockHit)
		{
		  LockHit = false;
		  LockButtons = false;
		}
      if(HitTotal)
		{
		  if(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->highhand == 21 ||
			  pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->lohand == 21)
		  {
			 ExecuteStatus = ess_Done;
			 ExecuteWaiting = false;
		  }
		  HitTotal = false;
		}
	 }
	 //??return;//?
  }
  if(!WaitOnSkit && WaitOnHitCom)
  {
    StartingFUC = pOwnerLord->GetAdjFUC();
	 pOwnerLord->HitComPlayer3(StartingFUC,FUCLength);
	 WaitOnSkit    = true;
    pOwnerLord->FreezeAllButtons();
	 WaitOnHitCom  = false;
	 FinishHit     = true;
  }
  if(!WaitOnSkit && FinishHit)
  {
	 ExecuteWaiting = false;
	 ExecuteStatus  = ess_StartSubState2;
	 FinishHit = false;
  }
  if(!WaitOnSkit && WaitOnStandCom)
  {
    StartingFUC = pOwnerLord->GetAdjFUC();
	 pOwnerLord->StandComPlayer3(StartingFUC,FUCLength);
	 WaitOnSkit    = true;
    pOwnerLord->FreezeAllButtons();
	 WaitOnStandCom  = false;
	 FinishStand     = true;
  }
  if(!WaitOnSkit && FinishStand)
  {
	 ExecuteWaiting = false;
	 ExecuteStatus  = ess_Done;
	 FinishStand = false;
  }
  if(!WaitOnSkit && WaitOnDoubleCom)
  {
    StartingFUC = pOwnerLord->GetAdjFUC();
	 pOwnerLord->DoubleComPlayer3(StartingFUC,FUCLength);
	 WaitOnSkit    = true;
    pOwnerLord->FreezeAllButtons();
	 WaitOnDoubleCom  = false;
	 FinishDouble     = true;
  }
  if(!WaitOnSkit && FinishDouble)
  {
	 ExecuteWaiting = false;
	 ExecuteStatus  = ess_StartSubState2;
	 FinishDouble = false;
  }

  if((Stalling + TCasinoBJGameLord::STALLDELAY) <= NewFUC)
  {
    StartingFUC = pOwnerLord->GetAdjFUC();
	 pOwnerLord->Stalling(StartingFUC,FUCLength);
	 WaitOnSkit    = true;
    pOwnerLord->FreezeAllButtons();
	 Stalling      = NewFUC + FUCLength;
  }
  if (pOwnerLord->ButtonHit[bjidButton2])
  {
	 pOwnerLord->ButtonHit[bjidButton2] = false;
  }
  if (pOwnerLord->ButtonHit[bjidButton0])
  {
	 pOwnerLord->ButtonHit[bjidButton0] = false;
    if(!askexpertflag)
	 {askexpertflag = true;}
	 else
	 {
		if(firsttwocards)
		{
		  pOwnerLord->AskFirstTwoCardsExpert(4);
		}
		else
		{
		  pOwnerLord->AskAfterFirstTwoCardsExpert(4);
		}
		askexpertflag = false;
	 }
  }
  if(pOwnerLord->ButtonHit[bjidButton16])
  {
	 if(StartingFUC == 0)
	 {
		CoachStats(4,bjStand,firsttwocards);
		Coach(4,bjStand);
	 }
	 if(IgnoreCoach)
	 {
		LockHit = false;
		pOwnerLord->ButtonClear(bjidButton16);
	  //	CoachStats(1,bjStand,firsttwocards);
	  //	Coach(1,bjStand);
		Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
      pOwnerLord->StallsInRow = 0;
		LockButtons = false;
		return;
	 }
	 if(StartingFUC)
	 {
		if(StartingFUC + FUCLength == NewFUC)
		{
		  WaitOnStandCom = true;
		  LockHit = false;
		  pOwnerLord->ButtonClear(bjidButton16);
		  Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
        pOwnerLord->StallsInRow = 0;
		  LockButtons = false;
		  StartingFUC = 0;
		  FUCLength   = 0;
		  return;
		}
	 }
	 else
	 {
		StartingFUC = pOwnerLord->GetAdjFUC();
		bool mf=true;
      pOwnerLord->FreezeAllButtons();
		pOwnerLord->StandFingers(mf,bjnl3E,StartingFUC,FUCLength);
	 }
	 return;
  }
  if(pOwnerLord->ButtonHit[bjidButton14])
  {
	 if(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->inhand < 3)
	 {
		CoachStats(4,bjDouble,firsttwocards);
		Coach(4,bjDouble);
		if(IgnoreCoach)
		{
		  pOwnerLord->ButtonClear(bjidButton14);
		  LockButtons = false;
		  return;
		}

		LockHit = false;
		pOwnerLord->ButtonClear(bjidButton14);
		pOwnerLord->DoubleDown(4);
		doubleflag = true;
		Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
      pOwnerLord->StallsInRow = 0;
		WaitOnDoubleCom = true;
		pOwnerLord->FreezeAllButtons();
	 }

	 return;
  }

  if (pOwnerLord->ButtonHit[bjidButton13])
  {
	 if(!LockButtons && pOwnerLord->GetCash(pOwnerLord->activeplayer) >=
	 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->coinsplayedhand4)
	 {
		if(pOwnerLord->BetSpotUse[6] == -1 &&
        pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->inhand < 3 &&
		((pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->cards[0].name ==
		  pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->cards[1].name) ||
		 (pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->cards[0].name >= Ten &&
		  pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->cards[0].name < AceHi) &&
		 (pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->cards[1].name >= Ten &&
		  pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->cards[1].name < AceHi)) )
		{
		 CoachStats(4,bjSplit,firsttwocards);
		 Coach(4,bjSplit);
		 if(IgnoreCoach)
		 {
			pOwnerLord->ButtonClear(bjidButton13);
			LockButtons = false;
			return;
		 }
		 if (pOwnerLord->BetSpotUse[6] == -1)
		 {
			LockButtons = false;
			ExecuteWaiting = true;
			ExecuteStatus = ess_StartSubState1;
			pOwnerLord->splitwait = true;
			splitflag = true;
			pOwnerLord->BetSpot[4]->NoShowCard(1);
			pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->numsplitshand5++;

			pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->pHand6 = new TBJHand;
			pOwnerLord->BetSpotUse[6] = pOwnerLord->BetSpotUse[5];
			pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[6])->coinsplayedhand6
				= pOwnerLord->SplitMoney(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->coinsplayedhand4);
			pOwnerLord->SubCash(pOwnerLord->BetSpotUse[6],
				 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[6])->coinsplayedhand6);

			pOwnerLord->BetSpot[6]->
				 SetNum(pOwnerLord->GetBJPlayer(pOwnerLord->activeplayer)->coinsplayedhand6);

			pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[6])->pHand6->cards[0] =
				 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->cards[1];
			pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[6])->pHand6->inhand++;
			pOwnerLord->BetSpot[6]->ShowFace(
						  pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[6])->pHand6);

			pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->inhand--;
		 }
		 Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
       pOwnerLord->StallsInRow = 0;
		 pOwnerLord->ButtonClear(bjidButton13);
		 pOwnerLord->FreezeAllButtons();
	  }
	 }
	 Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	 pOwnerLord->ButtonClear(bjidButton13);
	 return;
  }
  if(pOwnerLord->ButtonHit[bjidButton15])
  {
	 if(StartingFUC == 0)
	 {
		CoachStats(4,bjHit,firsttwocards);
		Coach(4,bjHit);
	 }
	 if(IgnoreCoach)
	 {
		Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
      pOwnerLord->StallsInRow = 0;
		pOwnerLord->ButtonClear(bjidButton15);
		LockButtons = false;
		return;
	 }
    if(StartingFUC)
	 {
		if(StartingFUC + FUCLength <= NewFUC)
		{
		  WaitOnHitCom = true;
        Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
        pOwnerLord->StallsInRow = 0;
		  pOwnerLord->ButtonClear(bjidButton15);
		  StartingFUC = 0;
		  FUCLength   = 0;
		  return;
		}
	 }
	 else
	 {
		pOwnerLord->Button14->ShowGray();
		pOwnerLord->Button13->ShowGray();
		firsttwocards = false;
		StartingFUC = pOwnerLord->GetAdjFUC();
		bool mf=true;
      pOwnerLord->FreezeAllButtons();
		pOwnerLord->HitFingers(mf,bjnl3E,StartingFUC,FUCLength);
	 }
	 //LockHit = false;
	// Stalling = pOwnerLord->GetFUC() + STALLDELAY;pOwnerLord->StallsInRow = 0;
	// pOwnerLord->ButtonClear(bjidButton15);
	 return;
  }

}
//*******************************************************************
bool TBJSplit5State::HandleRemoveDouble(TResponder &responder)
{
 if(!LockButtons && pOwnerLord->GetCash(pOwnerLord->activeplayer) > 0)
 {
  if(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->inhand < 3)
  {
	 if (responder.GetResponseEvent() == reLUp)
	 {
		CoachStats(4,bjDouble,firsttwocards);
		Coach(4,bjDouble);
		RemoveDoubleResponder = &responder;
		LockButtons = true;
	 }

	 if (responder.GetResponseEvent() == reLDown)
	 {
		Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
      pOwnerLord->StallsInRow = 0;
	//	pOwnerLord->RemoveDouble->ShowDoubleDown();
		responder.SetPriority();
	 }

	 if (responder.GetResponseEvent() == reChar)
	 {
		Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
      pOwnerLord->StallsInRow = 0;
		//pOwnerLord->RemoveDouble->ShowDoubleDown();
		RemoveDoubleResponder = &responder;
	 }
  }
 }
 return true;
}
//*******************************************************************
bool TBJSplit5State::HandleClearNoInsureStand(TResponder &responder)
{
 if(!LockButtons)
 {
  if (responder.GetResponseEvent() == reLUp)
  {
	 CoachStats(4,bjStand,firsttwocards);
	 Coach(4,bjStand);
	 ClearNoInsureStandResponder = &responder;
	 LockButtons = true;
  }

  if (responder.GetResponseEvent() == reLDown)
  {
	 Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	  //	pOwnerLord->ClearNoInsureStand->ShowStandDown();
	//	pOwnerLord->RemoveDouble->ShowDouble();
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
	 Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
  //	 pOwnerLord->ClearNoInsureStand->ShowStandDown();
 //	 pOwnerLord->RemoveDouble->ShowDouble();
	 ClearNoInsureStandResponder = &responder;
  }
 }
 return true;
}
//*******************************************************************
bool TBJSplit5State::HandleSameYesInsureHit(TResponder &responder)
{
 if(!LockButtons)
 {
  if (responder.GetResponseEvent() == reLUp)
  {
	 CoachStats(4,bjHit,firsttwocards);
	 Coach(4,bjHit);
	 SameYesInsureHitResponder = &responder;
	 LockButtons = true;
  }

  if (responder.GetResponseEvent() == reLDown)
  {
    Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
  //	 pOwnerLord->SameYesInsureHit->ShowHitDown();
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
    Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
 //	 pOwnerLord->SameYesInsureHit->ShowHitDown();
	 SameYesInsureHitResponder = &responder;
  }
 }
 return true;
}
//*******************************************************************
bool TBJSplit5State::HandleDealSplit(TResponder &responder)
{
 if(!LockButtons && pOwnerLord->GetCash(pOwnerLord->activeplayer) >=
	 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->coinsplayedhand4)
 {
	if(pOwnerLord->BetSpotUse[6] == -1 && pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->inhand < 3 &&
	  ((pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->cards[0].name ==
		 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->cards[1].name) ||
		(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->cards[0].name >= Ten &&
		 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->cards[0].name < AceHi) &&
		(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->cards[1].name >= Ten &&
		 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->cards[1].name < AceHi)) )
	{
	  if (responder.GetResponseEvent() == reLUp)
	  {
		 CoachStats(4,bjSplit,firsttwocards);
		 Coach(4,bjSplit);
		 DealSplitResponder = &responder;
		 LockButtons = true;
	  }

	 if (responder.GetResponseEvent() == reLDown)
	 {
      Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
      pOwnerLord->StallsInRow = 0;
	 //	pOwnerLord->DealSplit->ShowSplitDown();
		responder.SetPriority();
	 }

	 if (responder.GetResponseEvent() == reChar)
	 {
      Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
      pOwnerLord->StallsInRow = 0;
	  //	pOwnerLord->DealSplit->ShowSplitDown();
		DealSplitResponder = &responder;
	 }
  }
 }
 return true;
}
//*******************************************************************
void TBJSplit5State::ExecuteFirstTime()
{
  pOwnerLord->Button0->ShowVoidUp();
  pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->pHand4 = new TBJHand;
  pOwnerLord->BetSpotUse[4] = pOwnerLord->BetSpotUse[5];
  pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->coinsplayedhand4 =
	pOwnerLord->SplitMoney(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->coinsplayedhand5);

  pOwnerLord->BetSpot[4]->
			 SetNum(pOwnerLord->GetBJPlayer(pOwnerLord->activeplayer)->coinsplayedhand4);

  pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->cards[0] =
											  pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->pHand5->cards[1];
  pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->inhand++;
  pOwnerLord->BetSpot[4]->ShowFace(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4);
  /*********/
  pOwnerLord->/*((TBJDeck *)*/pDeck->
	  Busted(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4);

  if(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->cards[0].name == AceHi)
  {
	 splitacesflag = true;
  }
  int session=0;
  session = pOwnerLord->GetCasPD(pOwnerLord->BetSpotUse[4])->BJData.CurrentSession;
  pOwnerLord->GetCasPD(pOwnerLord->BetSpotUse[4])->BJData.Sessions[session].HandsPlayed++;
  pOwnerLord->GetCasPD(pOwnerLord->BetSpotUse[4])->BJData.Sessions[session].Splits++;
  pOwnerLord->GetCasPD(pOwnerLord->BetSpotUse[4])->BJData.Sessions[session].TotalBetsCash +=
	 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->coinsplayedhand4;

  ExecuteWaiting = true;
  ExecuteStatus    = ess_StartSubState2;
  if(pOwnerLord->GetCash(pOwnerLord->activeplayer) > 0)
  {
	 pOwnerLord->Button14->ShowVoidUp();
  }
  else
  {
	 pOwnerLord->Button13->ShowGray();
	 pOwnerLord->Button14->ShowGray();
  }
  if(pOwnerLord->GetCash(pOwnerLord->activeplayer) <
		 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->coinsplayedhand4)
  {
	 pOwnerLord->Button13->ShowGray();
  }
  pOwnerLord->Button16->ShowVoidUp();
  pOwnerLord->Button15->ShowVoidUp();
  splitbutton = true;
  pOwnerLord->pDeck->Busted(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4);
  pOwnerLord->MessageDisplay->ShowBJMessage(pOwnerLord->PlayerTotal());
  PlayerTotalMessage(4);
  FinishHit    = false;
  FinishStand  = false;
  FinishDouble = false;
  WaitOnHitCom    = false;
  WaitOnStandCom  = false;
  WaitOnDoubleCom = false;
  Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
  pOwnerLord->StallsInRow = 0;
  pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->hand4owner = 3;
  pOwnerLord->UnFreezeAllButtons();
}
//*******************************************************************
void TBJSplit5State::CreateSubState1()
{
  //PActiveSubState = new TBJSplit4State(pOwnerLord,4);
}
//*******************************************************************
void TBJSplit5State::EndSubState1()
{
  TState::EndSubState1();
  splitbutton = true;
}
//*******************************************************************
void TBJSplit5State::CreateSubState2()
{
  pOwnerLord->FreezeAllButtons();
  PActiveSubState = new TBJDealState(pOwnerLord,6);
}
//*******************************************************************
void TBJSplit5State::EndSubState2()
{
  TState::EndSubState2();
  if(splitacesflag)
  {
	 ExecuteStatus = ess_Done;
	 ExecuteWaiting = false;
	 splitacesflag = false;
  }
  else if(pOwnerLord->/*((TBJDeck *)*/pDeck->
	  Busted(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4) == 1)
  {
	 pOwnerLord->FreezeAllButtons();
	 ExecuteStatus = ess_StartSubState3;
  }
  else if(doubleflag == true)
  {
	 doubleflag = false;
	 ExecuteStatus = ess_Done;
	 ExecuteWaiting = false;
  }
  else
  {
	 if(splitflag == true && pOwnerLord->
		 GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->cards[0].name == AceHi)
	 {
		splitflag = false;
		ExecuteStatus = ess_Done;
	 }
	 else
	 {
		splitflag = false;
	 }
  }
  ExecuteWaiting = true;
  PlayerTotalMessage(4);
  if(ExecuteStatus != ess_StartSubState3 && ExecuteStatus != ess_Done)
  {
    StartingFUC = pOwnerLord->GetAdjFUC();
	 pOwnerLord->AnnouncePlayer3Total(StartingFUC,FUCLength);
	 WaitOnSkit    = true;
    pOwnerLord->FreezeAllButtons();
	 LockHit = true;
	 HitTotal = true;
  }
  if(splitbutton)
  {
	 splitbutton = false;
    LockButtons = false;
	 if(pOwnerLord->BetSpotUse[6] == -1 &&
		 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->inhand < 3 &&
		 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->numsplitshand5 < 2 &&
		 pOwnerLord->GetCash(pOwnerLord->activeplayer) >=
		 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->coinsplayedhand4   &&
	  ((pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->cards[0].name ==
		 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->cards[1].name) ||
		(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->cards[0].name >= Ten &&
		 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->cards[0].name < AceHi) &&
		(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->cards[1].name >= Ten &&
		 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->cards[1].name < AceHi)) )
	 {
		pOwnerLord->Button13->ShowVoidUp();
	 }
	 else
	 {
		pOwnerLord->Button13->ShowGray();
    }
  }
}
//*******************************************************************
void TBJSplit5State::CreateSubState3()
{
  pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->hand4owner = 0;
  PActiveSubState = new TBJBustState(pOwnerLord,6);
}
//*******************************************************************
bool TBJSplit5State::HandleMenuEsc(TResponder &responder)
{
	if (responder.GetResponseEvent() == reLUp)
  {
	 MenuEscResponder = &responder;
  }

  if (responder.GetResponseEvent() == reLDown)
  {
    Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
    pOwnerLord->StallsInRow = 0;
    pOwnerLord->Button2->ShowDown();
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
    Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
    pOwnerLord->StallsInRow = 0;
    pOwnerLord->Button2->ShowDown();
	 MenuEscResponder = &responder;
  }

  return true;
}
//*******************************************************************
bool TBJSplit5State::HandleAskExpert(TResponder &responder)
{
	if (responder.GetResponseEvent() == reLUp)
  {
	 AskExpertResponder = &responder;
  }

  if (responder.GetResponseEvent() == reLDown)
  {
    Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
    pOwnerLord->StallsInRow = 0;
    pOwnerLord->Button0->ShowDown();
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
	 Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
    pOwnerLord->Button0->ShowDown();
	 AskExpertResponder = &responder;
  }
  return true;
}
//*******************************************************************//*******************************************************************