//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  bjstate.cpp    // discard
//    Project Name:  Ogle
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     06/22/95   A. Krist    Original baseline
//  2.0     09/23/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "bjstate.h"
#include "cbjglord.h"
#include "bjisst.h"     // insure state
#include "bjrist.h"     // remove insure state
#include "bjpist.h"     // pay  insure state
#include "otimers.h"
#include "cbjplay.h"
#include "bjflipst.h"
#include <iostream.h>
//*******************************************************************
TBJState::TBJState(TCasinoBJGameLord *pNewBJLord)
:TBJLordState(pNewBJLord)
{
  dealerblackjack = 0;
  SetRunOrder(ess_Execute,ess_StartSubState2,ess_StartSubState3,
				  ess_StartSubState4,ess_StartSubState5,ess_StartSubState6,
				  ess_StartSubState7,ess_StartSubState8,ess_Execute);

  if(pOwnerLord->pHand->cards[0].name == AceHi)
  {
	// string  insuremessage("Insurance");
	// pOwnerLord->CasStatusBar->ShowMessageString(insuremessage,12);
  }
  StartingFUC = 0;
  FUCLength   = 0;
  WaitOnSkit  = false;
  FinalLook   = false;

}
//*******************************************************************
TBJState::~TBJState()
{
  pOwnerLord->UnFreezeAllButtons();
  pOwnerLord->MessageDisplay->NoShow();
}
//*******************************************************************
void TBJState::ExecuteFirstTime()
{
//  int i;
  pOwnerLord->LookingAt = bjnl0U;
  pOwnerLord->SetBodyIdle();
  //pOwnerLord->RemoveDouble->NoShow();
  //pOwnerLord->ClearNoInsureStand->NoShow();
  //pOwnerLord->SameYesInsureHit->NoShow();
  //pOwnerLord->DealSplit->NoShow();
  ExecuteWaiting = true;
  ExecuteStatus    = ess_Execute;
//  StartingFUC = PTimePtr->GetFrameUpdateCount() + 1;
  StartingFUC = pOwnerLord->GetAdjFUC();
  if(pOwnerLord->pHand->cards[0].name == AceHi)
  {
	 pOwnerLord->MessageDisplay->ShowMessage(51);
	 pOwnerLord->PromptInsurance(StartingFUC,FUCLength);
  }
  pOwnerLord->FreezeAllButtons();
  WaitOnSkit = true;

}
//*******************************************************************
void TBJState::HandlePostUpdate(dword NewFUC)
{
  if(WaitOnSkit)
  {
	 if((StartingFUC + FUCLength) <= NewFUC)
	 {
		StartingFUC = 0;
		FUCLength   = 0;
		WaitOnSkit  = false;
		if(FinalLook)
		{
		  FinalLook = false;
		  ExecuteStatus = ess_Done;
		  ExecuteWaiting = false;
		  pOwnerLord->UnFreezeAllButtons();
		}
		else
		{
		  ExecuteStatus = ess_StartSubState1;
		  ExecuteWaiting = false;
		}
	 }
	 return;//?
  }
}
//*******************************************************************
void TBJState::CreateSubState1()
{
	 if(pOwnerLord->BetSpotUse[1] > -1 && pOwnerLord->GetCash(pOwnerLord->BetSpotUse[1]) > 0)
	 {
      if(pOwnerLord->pHand->cards[0].name == AceHi)
		{
		  pOwnerLord->SwitchToPlayer(pOwnerLord->BetSpotUse[1]);
		  pOwnerLord->Circle1->SetCircle(pOwnerLord->activeplayer,bjnl1B);
		  PActiveSubState = new TBJInsureState(pOwnerLord,1);
		}
	 }
}
//*******************************************************************
void TBJState::CreateSubState2()
{
	 if(pOwnerLord->BetSpotUse[3] > -1)
	 {
		if(pOwnerLord->pHand->cards[0].name == AceHi)
		{
		  pOwnerLord->SwitchToPlayer(pOwnerLord->BetSpotUse[3]);
		  pOwnerLord->Circle2->SetCircle(pOwnerLord->activeplayer,bjnl2D);
		  PActiveSubState = new TBJInsureState(pOwnerLord,3);
		}
	 }
}
//*******************************************************************
void TBJState::CreateSubState3()
{
	 if(pOwnerLord->BetSpotUse[5] > -1)
	 {
		if(pOwnerLord->pHand->cards[0].name == AceHi)
		{
		  pOwnerLord->SwitchToPlayer(pOwnerLord->BetSpotUse[5]);
		  pOwnerLord->Circle3->SetCircle(pOwnerLord->activeplayer,bjnl3F);
		  PActiveSubState = new TBJInsureState(pOwnerLord,5);
		}
	 }
}
//*******************************************************************
void TBJState::CreateSubState7()
{
if(pOwnerLord->BetSpotUse[1] > -1)
{
	 pOwnerLord->SwitchToPlayer(pOwnerLord->BetSpotUse[1]);
	 if(pOwnerLord->pHand->bj == 1 && pOwnerLord->BetSpotUse[1] > -1)
	 {
		int session=0;
		session = pOwnerLord->GetCasPD(pOwnerLord->BetSpotUse[1])->BJData.CurrentSession;
		pOwnerLord->GetCasPD(pOwnerLord->BetSpotUse[1])->BJData.Sessions[session].DealerBJ++;
		PActiveSubState = new TBJPayInsureState(pOwnerLord,1);
	 }
	 else
	 {
		if((bool)pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand1->insurance &&
			pOwnerLord->BetSpotUse[1] > -1)
		{
		  PActiveSubState = new TBJRemoveInsureState(pOwnerLord,1);
		}
	 }
}
}
//*******************************************************************
void TBJState::CreateSubState6()
{
if(pOwnerLord->BetSpotUse[3] > -1)
{
 // if(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3->insurance)
 // {
	 pOwnerLord->SwitchToPlayer(pOwnerLord->BetSpotUse[3]);
	 if(pOwnerLord->pHand->bj == 1 && pOwnerLord->BetSpotUse[3] > -1)
	 {
      int session=0;
		session = pOwnerLord->GetCasPD(pOwnerLord->BetSpotUse[3])->BJData.CurrentSession;
		pOwnerLord->GetCasPD(pOwnerLord->BetSpotUse[3])->BJData.Sessions[session].DealerBJ++;
		PActiveSubState = new TBJPayInsureState(pOwnerLord,4);
	 }
	 else
	 {
		if((bool)pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3->insurance &&
			pOwnerLord->BetSpotUse[3] > -1)
		{
		  PActiveSubState = new TBJRemoveInsureState(pOwnerLord,3);
		}
	 }
  //}
}
}
//*******************************************************************
void TBJState::CreateSubState5()
{
if(pOwnerLord->BetSpotUse[5] > -1)
{
  //
	 pOwnerLord->SwitchToPlayer(pOwnerLord->BetSpotUse[5]);
	 if(pOwnerLord->pHand->bj == 1)// && pOwnerLord->BetSpotUse[5] > -1)
	 {
      int session=0;
		session = pOwnerLord->GetCasPD(pOwnerLord->BetSpotUse[5])->BJData.CurrentSession;
		pOwnerLord->GetCasPD(pOwnerLord->BetSpotUse[5])->BJData.Sessions[session].DealerBJ++;
		PActiveSubState = new TBJPayInsureState(pOwnerLord,7);
	 }
	 else
	 {
		if((bool)pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->pHand5->insurance &&
			pOwnerLord->BetSpotUse[5] > -1)
		{
		  PActiveSubState = new TBJRemoveInsureState(pOwnerLord,5);
		}
	 }
  //}
}
}
//*******************************************************************
void TBJState::CreateSubState4()
{
  if(pOwnerLord->pHand->bj)
  {
	 PActiveSubState = new TBJDealerFlipState(pOwnerLord,2);
  }
  else
  {
	 PActiveSubState = new TBJDealerFlipState(pOwnerLord,1);
  }
}
//*******************************************************************
void TBJState::CreateSubState8()
{
  if(pOwnerLord->pHand->bj)
  {
	 FinalLook = true;
//	 StartingFUC = PTimePtr->GetFrameUpdateCount() + 1;
    StartingFUC = pOwnerLord->GetAdjFUC();
	 FUCLength = 0;
	 if(pOwnerLord->LookingAt == bjnl1A || pOwnerLord->LookingAt == bjnl1B || pOwnerLord->LookingAt == bjnl1C)
	 {
		pOwnerLord->LookFromTo(bjlf1To0,StartingFUC,FUCLength);
	 }
	 else if(pOwnerLord->LookingAt == bjnl2C || pOwnerLord->LookingAt == bjnl2D || pOwnerLord->LookingAt == bjnl2E)
	 {
		pOwnerLord->LookFromTo(bjlf2To0,StartingFUC,FUCLength);
	 }
	 else if(pOwnerLord->LookingAt == bjnl3E || pOwnerLord->LookingAt == bjnl3F || pOwnerLord->LookingAt == bjnl3G)
	 {
		pOwnerLord->LookFromTo(bjlf3To0,StartingFUC,FUCLength);
	 }
	 pOwnerLord->SetBodyIdle();
	 //pOwnerLord->EnableButton(4);
	 //pOwnerLord->EnableButton(5);
	// pOwnerLord->EnableButton(6);
	 //pOwnerLord->EnableButton(7);
	// pOwnerLord->EnableButton(8);
	// pOwnerLord->EnableButton(9);
  //	 pOwnerLord->EnableButton(10);
	// pOwnerLord->EnableButton(11);
  //	 pOwnerLord->Button12->ShowGray();
  }
}
//*******************************************************************
