//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  cbjdata.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     9/9/96    M.Perry     split up cplaydat file.
//  2.0    09/17/97   M.Perry     32-bit conversion.
//********************************************************************
#include "cbjdata.h"

//*******************************************************************
TCBJSession::TCBJSession()
{
  ClearData();
}
//*******************************************************************
void TCBJSession::ClearData()
{
  TCasinoSession::ClearData();
  HandsPlayedCGT1 = 0;
  HandsPlayedCLT2 = 0;
  TotalBetsCashCGT1 = 0;
  TotalBetsCashCLT2 = 0;
  TotalCashWLCGT1 = 0;
  TotalCashWLCLT1 = 0;
  DDWinnings = 0;
  InsureWon = 0;
  InsureLost = 0;
  DDownWL = 0;
  SplitsWL = 0;
  Player21 = 0;
  Player20 = 0;
  Player19 = 0;
  Player18 = 0;
  Player17 = 0;
  Player16Less = 0;
  BJWins = 0;
  DDWins = 0;
  WinsCGT1 = 0;
  WinsCLT2 = 0;
  Pushes = 0;
  Splits = 0;
  DDowns = 0;
  Busts = 0;
  DealerBusts = 0;
  DealerBJ = 0;
}
//*******************************************************************
void TCBJSession::StartSession(TMoney startingcash,int16 subgametype,TMoney denom)
{
  ClearData();
  TCasinoSession::StartSession(startingcash,subgametype,denom);
}
//*******************************************************************
void TCBJSession::EndSession(TMoney endingcash)
{
  TCasinoSession::EndSession(endingcash);
}
//*******************************************************************
//*******************************************************************
void TCasinoBJData::StartSession(TMoney startingcash,int16 subgametype,TMoney denom)
{
  IncCurrentSession();
  Sessions[CurrentSession].StartSession(startingcash,subgametype,denom);
}
//*******************************************************************
void TCasinoBJData::EndSession(TMoney endingcash)
{
  LastBJSessionEndTime = TTime().Seconds();
  Sessions[CurrentSession].EndSession(endingcash);
}
//*******************************************************************
void TCasinoBJData::IncCurrentSession()
{
  if (CurrentSession == 0 && !Sessions[0].Valid)
  {
    CurrentSession = 0;
    return;
  }
  CurrentSession++;
  if (CurrentSession >= NUMSESSIONS) {CurrentSession = 0;}
}
//*******************************************************************
int16 TCasinoBJData::GetFirstValidSession()
{
  // Sanity check on CurrentSession.
  if ((CurrentSession < 0) || (CurrentSession >= NUMSESSIONS)) {SessionIterator = -1;}
  else {SessionIterator = CurrentSession;}

  if (SessionIterator == -1) {return SessionIterator;}

  // Validity check on current session.
  if (!Sessions[SessionIterator].Valid)
  {
    SessionIterator = -1;
    return SessionIterator;
  }
  // currents session is valid, so start looping from current session to find oldest session.
  for (SessionIterator++;SessionIterator<NUMSESSIONS;SessionIterator++)
  {
    if (Sessions[SessionIterator].Valid) {return SessionIterator;}
  }
  if (CurrentSession == 0) // we already checked all sessions and didn't find a valid one.
  {
    if (Sessions[0].Valid) {SessionIterator = 0;}
    else {SessionIterator = -1;}
    return SessionIterator;
  }

  for (SessionIterator = 0;SessionIterator < CurrentSession;SessionIterator++)
  {
    if (Sessions[SessionIterator].Valid) {return SessionIterator;}
  }
  SessionIterator = -1;
  return SessionIterator;
}
//*******************************************************************
int16 TCasinoBJData::GetNextValidSession()
{
  // check if already found last valid session.
  if (SessionIterator == -1) {return SessionIterator;}
  // go to next session.
  SessionIterator++;
  // check for wraparound.
  if (SessionIterator >= NUMSESSIONS) {SessionIterator = 0;}
  // check if we went all the way around to beginning.
  if (SessionIterator == CurrentSession)
  {
    SessionIterator = -1;
    return CurrentSession;
  }
  // validity check on session.
  if (!Sessions[SessionIterator].Valid)
  {
    SessionIterator = -1;
    return SessionIterator;
  }
  return SessionIterator;
}
//*******************************************************************
int16 TCasinoBJData::GetPrevValidSession()
{
  int16 prevsession = CurrentSession;
  prevsession--;
  if (prevsession <= 0) {prevsession = NUMSESSIONS - 1;}
  if (!Sessions[prevsession].Valid) {return -1;}
  return prevsession;
}
//*******************************************************************
TCasinoBJData::TCasinoBJData()
{
  ClearData();
}
//*******************************************************************
void TCasinoBJData::ClearData()
{
  TCasinoData::ClearData();
  Cumulative = 0;
  LastBJSessionEndTime = 0;
  FirstPlayerBJHandEver = true;
  for (int i=0;i<NUMSESSIONS;i++)
  {
	 Sessions[i].ClearData();
  }
}

//*******************************************************************

