//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  cvpglord.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     10/11/95   M.Perry    Original baseline
//  2.0     09/20/97   M.Perry    32-bit conversion.
//*******************************************************************
#include "cbjglord.h"
//#include "cbjglspl.h"
#include "bjlordst.h"
#include "bjlordms.h"
#include "ostate.h"
#include <assert.h>
#include <time.h>   //To Set Random Number Generator
#include "bjdeck.h"
#include "bjaskex.h"
#include <stdlib.h> //For Random Number Generator
#include "oskitcat.h"
#include "cplaymgr.h"
#include "cbjplay.h"
#include "casnames.rh"
#include "ogamefw.h"
#include "casapp.h"
#include "orespond.h"
#include "oanm.h"
//*******************************************************************
#define FUC_DEALCARD1A 1
#define FUC_DEALCARD1B 1
#define FUC_DEALCARD1C 1
#define FUC_DEALCARD2C 1
#define FUC_DEALCARD2D 1
#define FUC_DEALCARD2E 1
#define FUC_DEALCARD3E 1
#define FUC_DEALCARD3F 1
#define FUC_DEALCARD3G 1
#define FUC_DEALERUP 2
#define FUC_DEALERDOWN 3
#define FUC_SHOWBACK   5
#define FUC_REMOVEBACK 2
#define FUC_REMOVEBJBACK 3
#define FUC_SHOWBJFACE   6
#define FUC_SHOWFACE   5
//*******************************************************************
void TCasinoBJGameLord::SetupSprites()
{
}
//*******************************************************************
void TCasinoBJGameLord::CleanupSprites()
{
}
//*******************************************************************
bool TCasinoBJGameLord::BetMade(int16 Player)
{
  if(BetSpotUse[1] == Player ||
     BetSpotUse[3] == Player ||
     BetSpotUse[5] == Player)
  {
    return true;
  }
  return false;
}
//*******************************************************************
bool TCasinoBJGameLord::Stalling(dword &StartFUC,dword &FUCLength)
{
  int16 ListNum = -1;
  switch(LookingAt) //LookingAt Should be set to correct spot at this point
  {
	 case bjnl1A:ListNum = stalling1a;break;
	 case bjnl1B:ListNum = stalling1b;break;
	 case bjnl1C:ListNum = stalling1c;break;
	 case bjnl2C:ListNum = stalling2c;break;
	 case bjnl2D:ListNum = stalling2d;break;
	 case bjnl2E:ListNum = stalling2e;break;
	 case bjnl3E:ListNum = stalling3e;break;
	 case bjnl3F:ListNum = stalling3f;break;
	 case bjnl3G:ListNum = stalling3g;break;

	 default:return false;
  }
  StallsInRow++;
  return ChooseStartSkit(ListNum,StartFUC,FUCLength);
}
//*******************************************************************
bool TCasinoBJGameLord::DealCard(int16 dealto,dword &StartFUC,dword &FUCLength,dword &CardFUC)
{
  int16 ListNum = -1;
  switch (dealto)
  {
    case bjnl1A:ListNum = dealcard1a;CardFUC = FUC_DEALCARD1A;break;
    case bjnl1B:ListNum = dealcard1b;CardFUC = FUC_DEALCARD1B;break;
    case bjnl1C:ListNum = dealcard1c;CardFUC = FUC_DEALCARD1C;break;
    case bjnl2C:ListNum = dealcard2c;CardFUC = FUC_DEALCARD2C;break;
    case bjnl2D:ListNum = dealcard2d;CardFUC = FUC_DEALCARD2D;break;
    case bjnl2E:ListNum = dealcard2e;CardFUC = FUC_DEALCARD2E;break;
    case bjnl3E:ListNum = dealcard3e;CardFUC = FUC_DEALCARD3E;break;
	 case bjnl3F:ListNum = dealcard3f;CardFUC = FUC_DEALCARD3F;break;
	 case bjnl3G:ListNum = dealcard3g;CardFUC = FUC_DEALCARD3G;break;
	 case bjnl0D:ListNum = dealerdown;CardFUC = FUC_DEALERDOWN;break;
	 case bjnl0U:ListNum = dealerup;CardFUC   = FUC_DEALERUP;break;
	 default: return false;
  }
   return ActivateSprite(ListNum,StartFUC,FUCLength);
}
//*******************************************************************
bool TCasinoBJGameLord::CheckHoleCard(dword &StartFUC,dword &FUCLength,int16 &remove,int16 &show)
{
//  int ListNum = GetSpriteIndex(GetResString(IDS_AS_DEALERCHECKHOLECARD_BJ1));
  remove = FUC_REMOVEBACK;
  show = FUC_SHOWBACK;
  return (ActivateSprite(dealercheckholecard,StartFUC,FUCLength));
}
//*******************************************************************
bool TCasinoBJGameLord::RemoveDealerCards(dword &StartFUC,dword &FUCLength,int16 &remove,int16 &show)
{
  remove = 4;show = 11;
  return (ActivateSprite(removedealercards,StartFUC,FUCLength));
}
//*******************************************************************
bool TCasinoBJGameLord::ExposeHoleCard(dword &StartFUC,dword &FUCLength,int16 &remove,int16 &show)
{
//  int ListNum = GetSpriteIndex(GetResString(IDS_AS_DEALEREXPOSESHOLECARD_BJ1));
  remove = FUC_REMOVEBACK;
  show = FUC_SHOWBACK;
  return (ActivateSprite(dealerexposeholecard,StartFUC,FUCLength));
}
//*******************************************************************
bool TCasinoBJGameLord::SetBodyIdle()
{
  switch (LookingAt)
  {
    case bjnl1A : return BodyIdle(bjbiP1);
    case bjnl1B : return BodyIdle(bjbiP1);
	 case bjnl1C : return BodyIdle(bjbiP1);
    case bjnl2C : return BodyIdle(bjbiP2);
    case bjnl2D : return BodyIdle(bjbiP2);
    case bjnl2E : return BodyIdle(bjbiP2);
    case bjnl3E : return BodyIdle(bjbiP3);
    case bjnl3F : return BodyIdle(bjbiP3);
    case bjnl3G : return BodyIdle(bjbiP3);
    case bjnl0D : return BodyIdle(bjbiDealer);
    case bjnl0U : return BodyIdle(bjbiDealer);
    default:      return BodyIdle(bjbiDealer);
  }
}
//*******************************************************************
bool TCasinoBJGameLord::LookFromTo(TBJLookFromTo lookfromto,dword &StartFUC,dword &FUCLength,bool AnmOn)
{
  int16 ListNum = -1;
  switch (lookfromto)
  {
	 case bjlf0To1:ListNum = lookfrom0to1;break;
	 case bjlf0To2:ListNum = lookfrom0to2;break;
	 case bjlf0To3:ListNum = lookfrom0to3;break;
	 case bjlf1To2:ListNum = lookfrom1to2;break;
	 case bjlf1To3:ListNum = lookfrom1to3;break;
	 case bjlf2To3:ListNum = lookfrom2to3;break;
	 case bjlf1To0:ListNum = lookfrom1to0;break;
	 case bjlf2To0:ListNum = lookfrom2to0;break;
	 case bjlf3To0:ListNum = lookfrom3to0;break;
	 case bjlf3To1:ListNum = lookfrom3to1;break;
	 case bjlf3To2:ListNum = lookfrom3to2;break;
	 case bjlf2To1:ListNum = lookfrom2to1;break;
	 default:return false;
  }
  if(AnmOn)
  {
	 return (ActivateSprite(ListNum,StartFUC,FUCLength));
  }
  else
  {
	 FUCLength = 0;
	 return true;
  }
}
//*******************************************************************
bool TCasinoBJGameLord::PromptAction(int16 promptwho,dword &StartFUC,dword &FUCLength)
{
  int16 ListNum = -1;
  switch (promptwho)
  {
    case bjnl1A:ListNum = promptaction1a;break;
    case bjnl1B:ListNum = promptaction1b;break;
    case bjnl1C:ListNum = promptaction1c;break;
    case bjnl2C:ListNum = promptaction2c;break;
    case bjnl2D:ListNum = promptaction2d;break;
    case bjnl2E:ListNum = promptaction2e;break;
    case bjnl3E:ListNum = promptaction3e;break;
    case bjnl3F:ListNum = promptaction3f;break;
    case bjnl3G:ListNum = promptaction3g;break;
    default:return false;
  }
  return (ActivateSprite(ListNum,StartFUC,FUCLength));
}
//*******************************************************************
#pragma argsused
bool TCasinoBJGameLord::HitFingers(bool SexMale,int16 hitwho,dword &StartFUC,dword &FUCLength)
{
  if(PModeWin->GetDetailLevel() != 3)
  {
	 FUCLength = 1;
	 return true;
  }

  int16 ListNum = -1;
  if(GetCasPD(activeplayer) != NULL && GetCasPD(activeplayer)->Male)
  {
    switch (hitwho)
    {
      case bjnl1A:ListNum = hitfingersm1a;break;
		case bjnl1B:ListNum = hitfingersm1b;break;
		case bjnl1C:ListNum = hitfingersm1c;break;
		case bjnl2C:ListNum = hitfingersm2c;break;
		case bjnl2D:ListNum = hitfingersm2d;break;
		case bjnl2E:ListNum = hitfingersm2e;break;
		case bjnl3E:ListNum = hitfingersm3e;break;
		case bjnl3F:ListNum = hitfingersm3f;break;
		case bjnl3G:ListNum = hitfingersm3g;break;
		default:return false;
    }
  }
  else
  {
    switch (hitwho)
	 {
		case bjnl1A:ListNum = hitfingersf1a;break;
		case bjnl1B:ListNum = hitfingersf1b;break;
		case bjnl1C:ListNum = hitfingersf1c;break;
		case bjnl2C:ListNum = hitfingersf2c;break;
		case bjnl2D:ListNum = hitfingersf2d;break;
		case bjnl2E:ListNum = hitfingersf2e;break;
		case bjnl3E:ListNum = hitfingersf3e;break;
		case bjnl3F:ListNum = hitfingersf3f;break;
		case bjnl3G:ListNum = hitfingersf3g;break;
		default:return false;
	 }
  }
  return (ActivateSprite(ListNum,StartFUC,FUCLength));
}
//*******************************************************************
#pragma argsused
bool TCasinoBJGameLord::StandFingers(bool SexMale,int16 standwho,dword &StartFUC,dword &FUCLength)
{
  int16 ListNum = -1;
  if(PModeWin->GetDetailLevel() != 3)
  {
	 FUCLength =1;
	 return true;
  }
  if(GetCasPD(activeplayer) != NULL && GetCasPD(activeplayer)->Male)
  {
    switch (standwho)
    {
		case bjnl1A:ListNum = standfingersm1a;break;
		case bjnl1B:ListNum = standfingersm1b;break;
		case bjnl1C:ListNum = standfingersm1c;break;
		case bjnl2C:ListNum = standfingersm2c;break;
		case bjnl2D:ListNum = standfingersm2d;break;
		case bjnl2E:ListNum = standfingersm2e;break;
		case bjnl3E:ListNum = standfingersm3e;break;
		case bjnl3F:ListNum = standfingersm3f;break;
		case bjnl3G:ListNum = standfingersm3g;break;
		default:return false;
    }
  }
  else
  {
    switch (standwho)
    {
		case bjnl1A:ListNum = standfingersf1a;break;
		case bjnl1B:ListNum = standfingersf1b;break;
		case bjnl1C:ListNum = standfingersf1c;break;
		case bjnl2C:ListNum = standfingersf2c;break;
		case bjnl2D:ListNum = standfingersf2d;break;
		case bjnl2E:ListNum = standfingersf2e;break;
		case bjnl3E:ListNum = standfingersf3e;break;
		case bjnl3F:ListNum = standfingersf3f;break;
		case bjnl3G:ListNum = standfingersf3g;break;
		default:return false;
    }
  }

  return (ActivateSprite(ListNum,StartFUC,FUCLength));
}
//*******************************************************************
TMoney TCasinoBJGameLord::SplitMoney(TMoney amount)
{
  TMoney betamount=0;
  if(GetBJPlayer(activeplayer) == NULL){return -1;}
  if(GetCash(activeplayer) < amount)
  {
	 betamount = GetCash(activeplayer);
  }
  else
  {
	 betamount = amount;
  }
  SubCash(activeplayer,betamount);
  BankCashDisplay->SetNum(GetCash(activeplayer));
  Chips->SetNum(GetCash(activeplayer));
  BJSounds->PlaySound(10);
  return betamount;
}
//*******************************************************************
int16 TCasinoBJGameLord::DoubleDown(int16 x)
{
  int16 session=0;
  TMoney betamount = 0;
  if(GetBJPlayer(activeplayer) == NULL){return -1;}
  betamount = GetCash(activeplayer);
  switch(x) {
  case 0:   if(GetBJPlayer(BetSpotUse[0])->coinsplayedhand0 < betamount)
				{
				  betamount = GetBJPlayer(BetSpotUse[0])->coinsplayedhand0;
				}
				SubCash(BetSpotUse[0],betamount);
				BetSpot[0]->ShowDoubleDownChips(betamount);;
				GetBJPlayer(BetSpotUse[0])->coinsplayedhand0 += betamount;
				GetBJPlayer(BetSpotUse[0])->DubDown = true;
				((TBJHand *)GetBJPlayer(BetSpotUse[0])->pHand0)->IsDDHand = true;
				session = GetCasPD(BetSpotUse[0])->BJData.CurrentSession;
				GetCasPD(BetSpotUse[0])->BJData.Sessions[session].DDowns++;
				GetCasPD(BetSpotUse[0])->BJData.Sessions[session].TotalBetsCash += betamount;
				break;
  case 1:   if(GetBJPlayer(BetSpotUse[1])->coinsplayedhand1 < betamount)
				{
				  betamount = GetBJPlayer(BetSpotUse[1])->coinsplayedhand1;
				}
				SubCash(BetSpotUse[1],betamount);
				BetSpot[1]->ShowDoubleDownChips(betamount);;
				GetBJPlayer(BetSpotUse[1])->coinsplayedhand1 += betamount;
				GetBJPlayer(BetSpotUse[1])->DubDown = true;
				((TBJHand *)GetBJPlayer(BetSpotUse[1])->pHand1)->IsDDHand = true;
				session = GetCasPD(BetSpotUse[1])->BJData.CurrentSession;
				GetCasPD(BetSpotUse[1])->BJData.Sessions[session].DDowns++;
				GetCasPD(BetSpotUse[1])->BJData.Sessions[session].TotalBetsCash += betamount;
				break;
  case 2:   if(GetBJPlayer(BetSpotUse[2])->coinsplayedhand2 < betamount)
				{
				  betamount = GetBJPlayer(BetSpotUse[2])->coinsplayedhand2;
				}
				SubCash(BetSpotUse[2],betamount);
				BetSpot[2]->ShowDoubleDownChips(betamount);;
				GetBJPlayer(BetSpotUse[2])->coinsplayedhand2 += betamount;
				GetBJPlayer(BetSpotUse[2])->DubDown = true;
				((TBJHand *)GetBJPlayer(BetSpotUse[2])->pHand2)->IsDDHand = true;
				session = GetCasPD(BetSpotUse[2])->BJData.CurrentSession;
				GetCasPD(BetSpotUse[2])->BJData.Sessions[session].DDowns++;
				GetCasPD(BetSpotUse[2])->BJData.Sessions[session].TotalBetsCash += betamount;
				break;
  case 3:   if(GetBJPlayer(BetSpotUse[3])->coinsplayedhand3 < betamount)
				{
				  betamount = GetBJPlayer(BetSpotUse[3])->coinsplayedhand3;
				}
				SubCash(BetSpotUse[3],betamount);
				BetSpot[3]->ShowDoubleDownChips(betamount);;
				GetBJPlayer(BetSpotUse[3])->coinsplayedhand3 += betamount;
				GetBJPlayer(BetSpotUse[3])->DubDown = true;
				((TBJHand *)GetBJPlayer(BetSpotUse[3])->pHand3)->IsDDHand = true;
				session = GetCasPD(BetSpotUse[3])->BJData.CurrentSession;
				GetCasPD(BetSpotUse[3])->BJData.Sessions[session].DDowns++;
				GetCasPD(BetSpotUse[3])->BJData.Sessions[session].TotalBetsCash += betamount;
				break;
  case 4:   if(GetBJPlayer(BetSpotUse[4])->coinsplayedhand4 < betamount)
				{
				  betamount = GetBJPlayer(BetSpotUse[4])->coinsplayedhand4;
				}
				SubCash(BetSpotUse[4],betamount);
				BetSpot[4]->ShowDoubleDownChips(betamount);;
				GetBJPlayer(BetSpotUse[4])->coinsplayedhand4 += betamount;
				GetBJPlayer(BetSpotUse[4])->DubDown = true;
				((TBJHand *)GetBJPlayer(BetSpotUse[4])->pHand4)->IsDDHand = true;
				session = GetCasPD(BetSpotUse[4])->BJData.CurrentSession;
				GetCasPD(BetSpotUse[4])->BJData.Sessions[session].DDowns++;
				GetCasPD(BetSpotUse[4])->BJData.Sessions[session].TotalBetsCash += betamount;
				break;
  case 5:   if(GetBJPlayer(BetSpotUse[5])->coinsplayedhand5 < betamount)
				{
				  betamount = GetBJPlayer(BetSpotUse[5])->coinsplayedhand5;
				}
				SubCash(BetSpotUse[5],betamount);
				BetSpot[5]->ShowDoubleDownChips(betamount);;
				GetBJPlayer(BetSpotUse[5])->coinsplayedhand5 += betamount;
				GetBJPlayer(BetSpotUse[5])->DubDown = true;
				((TBJHand *)GetBJPlayer(BetSpotUse[5])->pHand5)->IsDDHand = true;
				session = GetCasPD(BetSpotUse[5])->BJData.CurrentSession;
				GetCasPD(BetSpotUse[5])->BJData.Sessions[session].DDowns++;
				GetCasPD(BetSpotUse[5])->BJData.Sessions[session].TotalBetsCash += betamount;
				break;
  case 6:   if(GetBJPlayer(BetSpotUse[6])->coinsplayedhand6 < betamount)
				{
				  betamount = GetBJPlayer(BetSpotUse[6])->coinsplayedhand6;
				}
				SubCash(BetSpotUse[6],betamount);
				BetSpot[6]->ShowDoubleDownChips(betamount);;
				GetBJPlayer(BetSpotUse[6])->coinsplayedhand6 += betamount;
				GetBJPlayer(BetSpotUse[6])->DubDown = true;
				((TBJHand *)GetBJPlayer(BetSpotUse[6])->pHand6)->IsDDHand = true;
				session = GetCasPD(BetSpotUse[6])->BJData.CurrentSession;
				GetCasPD(BetSpotUse[6])->BJData.Sessions[session].DDowns++;
				GetCasPD(BetSpotUse[6])->BJData.Sessions[session].TotalBetsCash += betamount;
				break;
  default : break;
  }
  Chips->SetNum(GetCash(activeplayer));
  BankCashDisplay->SetNum(GetCash(activeplayer));
  return 1;
}
//*******************************************************************
int16 TCasinoBJGameLord::SwitchDecks()
{
  switch (SubGameType)
  {
    case cbj1Deck : newdeckcount = DECK;break;
	 case cbj2Deck : newdeckcount = DECK2;break;
    case cbj4Deck : newdeckcount = DECK4;break;
    case cbj6Deck : newdeckcount = DECK6;break;
    default : return -1;
  }
  decksflag = 1;
  newdeal   = 1;
  return 1;
}
//*******************************************************************
int16 TCasinoBJGameLord::Count(TCard *card)
{
  if(card->name > Nine && card->name < AceHi)
  {
	 runningcount --;
  }
  else
  {
	 if(card->name > Two && card->name < Seven)
	 {
		runningcount++;
	 }
  }
  if(card->name == AceHi)
  {
	 acecount++;
  }
  cardsplayed++;
  halfdecksplayed = int16(cardsplayed/26);
  if(cardsplayed%26 > 13)
  {
	halfdecksplayed++;
  }
  halfdecksleft = int16((totaldecks*2) - halfdecksplayed);
  if(halfdecksleft == 0){halfdecksleft++;}
  truecount = int16(runningcount/halfdecksleft);
  return 1;
}
//*******************************************************************
int16 TCasinoBJGameLord::Clear()
{
  int16 session=0;
  TCasinoBJPlayer *bjplayer;
  SwitchDeckNowFlag = true;
  ALLPREVIOUSHANDSWON = ALLHANDSWON;
  ALLHANDSWON = true;
  ThreePreviousBets = ThreeBets;
  ThreeBets = 0;
  InsuranceBetMade = false;
  StallsInRow = 0;
  shutdownstate    = 0;
  ChangeActivePlayersOk = true;
  Button13->ShowVoidUp();Button13->Enabled = false;
  Button14->ShowVoidUp();Button14->Enabled = false;
  Button15->ShowVoidUp();Button15->Enabled = false;
  Button16->ShowVoidUp();Button16->Enabled = false;
  Button17->ShowVoidUp();Button17->Enabled = false;
  Button18->ShowVoidUp();Button18->Enabled = false;
  for(int16 i=0;i<3;i++)
  {
	 bjplayer = NULL;
	 bjplayer = GetBJPlayer(i);
	 if(bjplayer != NULL)
	 {
		if(GetCash(i) < GetBJPlayer(i)->lastbet)
		{
		  GetBJPlayer(i)->lastbet = GetCash(i);
		}
      if(activeplayer == i)
		{
		  BetAmountDisplay->SetNum(GetBJPlayer(i)->lastbet);
		}
		if(GetCasPD(i))
		{
		  session = GetCasPD(i)->BJData.CurrentSession;
        TCBJSession &cursession = GetCasPD(i)->BJData.Sessions[session];

		  if(cursession.PeakWin < GetCash(i))
		  {
          cursession.PeakWin = GetCash(i);
        }
		  if(cursession.PeakLoss > GetCash(i))
		  {
          cursession.PeakLoss = GetCash(i);
        }
		}
		bjplayer->coinsplayedhand0 = 0;
		bjplayer->coinsplayedhand1 = 0;
		bjplayer->coinsplayedhand2 = 0;
		bjplayer->coinsplayedhand3 = 0;
		bjplayer->coinsplayedhand4 = 0;
		bjplayer->coinsplayedhand5 = 0;
		bjplayer->coinsplayedhand6 = 0;
		bjplayer->hand2owner = 0;
		bjplayer->hand4owner = 0;
		if(bjplayer->pHand0 != NULL)
		{
		  delete bjplayer->pHand0;
		  bjplayer->pHand0 = NULL;
		}
		if(bjplayer->pHand1 != NULL)
		{
		  delete bjplayer->pHand1;
		  bjplayer->pHand1 = NULL;
		}
		if(bjplayer->pHand2 != NULL)
		{
		  delete bjplayer->pHand2;
		  bjplayer->pHand2 = NULL;
		}
		if(bjplayer->pHand3 != NULL)
		{
		  delete bjplayer->pHand3;
		  bjplayer->pHand3 = NULL;
		}
		if(bjplayer->pHand4 != NULL)
		{
		  delete bjplayer->pHand4;
		  bjplayer->pHand4 = NULL;
		}
		if(bjplayer->pHand5 != NULL)
		{
		  delete bjplayer->pHand5;
		  bjplayer->pHand5 = NULL;
		}
		if(bjplayer->pHand6 != NULL)
		{
		  delete bjplayer->pHand6;
		  bjplayer->pHand6 = NULL;
		}
		bjplayer->numsplitshand1 = 0;
		bjplayer->numsplitshand3 = 0;
		bjplayer->numsplitshand5 = 0;
	 }
  }
  for(int16 i=0;i<7;i++)
  {
	 BetSpotUse[i] = -1;
	 BetSpot[i]->NoShowInsureChips();
  }
  splitwait       = false;
  pHand->inhand   = 0;
  pHand->highhand = 0;
  pHand->lohand   = 0;
  pHand->bj       = 0;
  playersin       = 1;
  coinsplayed     = 0;
  if(GetCasPD(0))
  {
	 GetBJPlayer(0)->coinsplayed = 0;
  }
  if(GetCasPD(1))
  {
	 GetBJPlayer(1)->coinsplayed = 0;
  }
  if(GetCasPD(2))
  {
	 GetBJPlayer(2)->coinsplayed = 0;
  }
  StartTC = 0;
  delete pHand;
  pHand = new TBJHand;
  if(pDeck != NULL)
  {
	 if(pDeck->top >= (numofdecks - 31))
	 {
		newdeal =1;         //check it bonehead
	 }
  }
 // int stuff = pMWin->GetNumDecks();
//  if(game != pMWin->GetNumDecks())
  if (SubGameType != pMWin->GetNumDecks())
  {
//	 game = pMWin->GetNumDecks();
	 SubGameType = pMWin->GetNumDecks();
	 SwitchDecks();
  }
  if(newdeal)
  {
	 if(decksflag)
	 {
		numofdecks = newdeckcount;
		((TBJDeck *)pDeck)->ChangeDecks(numofdecks);
		decksflag = 0;
		totaldecks = int16(numofdecks/52);
		Sign->ShowBJSign(pMWin->GetNumDecks());
	 }
	 ((TBJDeck *)pDeck)->Shuffler(numofdecks);
	 runningcount    = 0;
	 truecount       = 0;
	 halfdecksleft   = int16((numofdecks*2)/52);
	 halfdecksplayed = 0;
	 cardsplayed     = 0;
	 acecount        = 0;
  //	 newdeal         = 0;
	 ((TBJDeck *)pDeck)->top   = 0;
  }
//  cout << "top-> " << pDeck->top << endl;
  return 1;
}
//*******************************************************************
void TCasinoBJGameLord::SwitchDeckNow()
{
  if(SwitchDeckNowFlag)
  {
//	 game = pMWin->GetNumDecks();
	 if(Rack->numofcards > 0){SwitchDeckNowFlag = false;}//Let State know had discards
	 SubGameType = pMWin->GetNumDecks();
	 SwitchDecks();
	 decksflag = 0;
	 numofdecks = newdeckcount;
	 ((TBJDeck *)pDeck)->ChangeDecks(numofdecks);
	 totaldecks = int16(numofdecks/52);
	 Sign->ShowBJSign(pMWin->GetNumDecks());
	 ((TBJDeck *)pDeck)->Shuffler(numofdecks);
	 runningcount    = 0;
	 truecount       = 0;
	 halfdecksleft   = 0;
	 halfdecksplayed = 0;
	 cardsplayed     = 0;
	 acecount        = 0;
	 //	 newdeal         = 0;
	 ((TBJDeck *)pDeck)->top   = 0;
	 //Rack->ShowBJRack(0);
	 ((TBJLordState *)PState)->ShuffleNewDeck();
  }
}
//*******************************************************************
int16 TCasinoBJGameLord::PlaceBet(int16 x)
{
  if(BetSpotUse[x] == -1 || BetSpotUse[x] == activeplayer)
  {
	 if(coinsplayed==0)
	 {
		BetLast();
	 }
	 if(coinsplayed > 0){Button12->ShowVoidUp();}
	 else
	 {
		if(BetSpotUse[1] == activeplayer ||
			BetSpotUse[3] == activeplayer ||
			BetSpotUse[5] == activeplayer   )
		{
		  PModeWin->MessageBox("You're out of money and may not make additional bets. Your current bets are your only hope.","Out of Cash",MB_OK);
		}
		else if(GetCasPD(activeplayer)->IsActiveKenoTicket())
		{
		  PModeWin->MessageBox("You're out of money and may not bet. Your only hope is that one of your Keno tickets pays off.","Out of Cash",MB_OK);
		}
		else
		{
		  PModeWin->MessageBox("You've hit rock bottom. Your gambler is bankrupt. Select Create/Delete under the FILE menu to create or select a new gambler.","Bankrupt!",MB_OK);
		}
		return 0;
	 }
	 if((x == 1 && coinsplayed+GetBJPlayer(activeplayer)->coinsplayedhand1 > 100000l) ||
		 (x == 3 && coinsplayed+GetBJPlayer(activeplayer)->coinsplayedhand3 > 100000l) ||
		 (x == 5 && coinsplayed+GetBJPlayer(activeplayer)->coinsplayedhand5 > 100000l)  )
	 {
		PModeWin->MessageBox("You may bet no more than $100,000 on any single bet spot.","Table Limit",MB_OK);
		return 0;
	 }
	 SubCash(activeplayer,coinsplayed);
	 GetBJPlayer(activeplayer)->lastbet = coinsplayed;
	 BankCashDisplay->SetNum(GetCash(activeplayer));
	 if(x == 1)
	 {
		if(BetSpotUse[x] == -1)
		{
		  GetBJPlayer(activeplayer)->pHand1 = new TBJHand;
		}
		GetBJPlayer(activeplayer)->coinsplayedhand1 += coinsplayed;
		BJSounds->PlaySound(NumOfCoins(coinsplayed));
		coinsplayed = 0;
		GetBJPlayer(activeplayer)->coinsplayed = 0;
		BetSpotUse[x] = activeplayer;
		BetSpot[1]->SetNum(GetBJPlayer(activeplayer)->coinsplayedhand1);
	 }
	 if(x == 3)
	 {
		if(BetSpotUse[x] == -1)
		{
		  GetBJPlayer(activeplayer)->pHand3 = new TBJHand;
		}
		GetBJPlayer(activeplayer)->coinsplayedhand3 += coinsplayed;
		BJSounds->PlaySound(NumOfCoins(coinsplayed));
		coinsplayed = 0;
		GetBJPlayer(activeplayer)->coinsplayed = 0;
		BetSpotUse[x] = activeplayer;
	 }
	 if(x == 5)
	 {
		if(BetSpotUse[x] == -1)
		{
		  GetBJPlayer(activeplayer)->pHand5 = new TBJHand;
		}
		GetBJPlayer(activeplayer)->coinsplayedhand5 += coinsplayed;
		BJSounds->PlaySound(NumOfCoins(coinsplayed));
		coinsplayed = 0;
		GetBJPlayer(activeplayer)->coinsplayed = 0;//recent change 3/15/96
		BetSpotUse[x] = activeplayer;
	 }
	 if(!BetMade(activeplayer)){Button5->ShowGray();}
	 else{Button5->ShowVoidUp();}
    if(GetCash(activeplayer) < GetBJPlayer(activeplayer)->lastbet)
	 {
		GetBJPlayer(activeplayer)->lastbet = GetCash(activeplayer);
		BetAmountDisplay->SetNum(GetBJPlayer(activeplayer)->lastbet);
	 }
	 Chips->SetNum(GetCash(activeplayer));
  }
  else
  {
	 return 0;
  }
  return 1;
}
//*******************************************************************
int16 TCasinoBJGameLord::NumOfCoins(TMoney money)
{
  int32 cash = (int32)money;
  int32 coins=0;
  cash = cash%100000l;
  int32 tenthous = cash / 10000;
  int32 tenthousvalue = tenthous * 10000;
  int32 thous = (cash - tenthousvalue) / 1000;
  int32 thousvalue = thous * 1000;
  int32 huns = (cash - tenthousvalue - thousvalue) / 100;
  int32 hunsvalue = huns * 100;
  int32 twfive = (cash - tenthousvalue - thousvalue - hunsvalue) / 25;
  int32 twfivevalue = twfive * 25;
  int32 fives = (cash - tenthousvalue - thousvalue - hunsvalue - twfivevalue) / 5;
  int32 fivesvalue = fives * 5;
  int32 ones = (cash - tenthousvalue - thousvalue - hunsvalue - twfivevalue - fivesvalue);
  coins = tenthous+thous+huns+twfive+fives+ones;
  if(coins == 0){return 5;}
  if(coins == 1){return 1;}
  if(coins >= 2 && coins <= 4){return 2;}
  if(coins >= 5){return 3;}

  return 0; // just to shut up the compiler.
}
//*******************************************************************
int16 TCasinoBJGameLord::RemoveBet(int16 x)
{
  if(BetSpotUse[x] > -1 && BetSpotUse[x] == activeplayer)
  {
	 BetSpot[x]->NoShow();
	 if(x == 1)
	 {
		delete GetBJPlayer(activeplayer)->pHand1;
		AddCash(activeplayer,GetBJPlayer(activeplayer)->coinsplayedhand1);
		GetBJPlayer(activeplayer)->coinsplayedhand1 = 0;
		BetSpotUse[x] = -1;
		GetBJPlayer(activeplayer)->pHand1 = NULL;
	 }
	 if(x == 3)
	 {
		delete GetBJPlayer(activeplayer)->pHand3;
		AddCash(activeplayer,GetBJPlayer(activeplayer)->coinsplayedhand3);
		GetBJPlayer(activeplayer)->coinsplayedhand3 = 0;
		BetSpotUse[x] = -1;
		GetBJPlayer(activeplayer)->pHand3 = NULL;
	 }
	 if(x == 5)
	 {
		delete GetBJPlayer(activeplayer)->pHand5;
		AddCash(activeplayer,GetBJPlayer(activeplayer)->coinsplayedhand5);
		GetBJPlayer(activeplayer)->coinsplayedhand5 = 0;
		BetSpotUse[x] = -1;
		GetBJPlayer(activeplayer)->pHand5 = NULL;
	 }
	 BankCashDisplay->SetNum(GetCash(activeplayer));
	 Chips->SetNum(GetCash(activeplayer));
	 if(BetSpotUse[1] == -1 && BetSpotUse[3] == -1 && BetSpotUse[5] == -1)
	 {Button12->ShowGray();}
    if(!BetMade(activeplayer)){Button5->ShowGray();}
  }
  else
  {
	 return 0;
  }
  PModeWin->ReSendEnterArea();
  return 1;
}
//*******************************************************************
TMoney TCasinoBJGameLord::Winner(int16 winner)
{
  int32 retValue=-1;
  int16 bsi = -1;
  switch (winner)
  {
    case 0: bsi = 0;break;
    case 1: bsi = 1;break;
    case 2: bsi = 2;break;
    case 3: bsi = 2;break;
    case 4: bsi = 3;break;
    case 5: bsi = 4;break;
    case 6: bsi = 4;break;
    case 7: bsi = 5;break;
    case 8: bsi = 6;break;
  }

  if (bsi > -1)
  {
  int16 session = GetCasPD(BetSpotUse[bsi])->BJData.CurrentSession;
  TCBJSession &cs = GetCasPD(BetSpotUse[bsi])->BJData.Sessions[session];

  switch(winner){
  case 0  :  if(((TBJHand *)GetBJPlayer(BetSpotUse[0])->pHand0)->bj)
				 {
					AddCash(BetSpotUse[0],(((GetBJPlayer(BetSpotUse[0])->coinsplayedhand0)*3)/2)+
							                GetBJPlayer(BetSpotUse[0])->coinsplayedhand0);
					MessageDisplay->ShowBJMessage(52,((GetBJPlayer(BetSpotUse[0])->coinsplayedhand0)*3)/2,true);
					BetSpot[0]->ShowBJChips();
					cs.BJWins++;
					cs.Player21++;
					if(cs.LargestWin < (GetBJPlayer( BetSpotUse[0])->coinsplayedhand0*3)/2)
					{
					  cs.LargestWin = (GetBJPlayer(BetSpotUse[0])->coinsplayedhand0*3)/2;
					}
					if(StartTC > 0)
					{
					  cs.WinsCGT1++;
					  cs.TotalCashWLCGT1 += (GetBJPlayer(BetSpotUse[0])->coinsplayedhand0*3)/2;
					}
					if(StartTC < 1)
					{
					  cs.WinsCLT2++;
					  cs.TotalCashWLCLT1 += (GetBJPlayer(BetSpotUse[0])->coinsplayedhand0*3)/2;
					}
					cs.SplitsWL += (GetBJPlayer(BetSpotUse[0])->coinsplayedhand0*3)/2;
					retValue = GetBJPlayer(BetSpotUse[0])->coinsplayedhand0;
					//BetSpotUse[0] = -1;
				 }
				 else
				 {
					AddCash(BetSpotUse[0],(GetBJPlayer(BetSpotUse[0])->coinsplayedhand0)*2);
					MessageDisplay->ShowBJMessage(52,GetBJPlayer(BetSpotUse[0])->coinsplayedhand0,false);
					BetSpot[0]->ShowWinChips();
					if(cs.LargestWin < (GetBJPlayer( BetSpotUse[0])->coinsplayedhand0))
					{
					  cs.LargestWin = GetBJPlayer(BetSpotUse[0])->coinsplayedhand0;
					}
					cs.SplitsWL += GetBJPlayer(BetSpotUse[0])->coinsplayedhand0;
					if(StartTC > 0)
					{
					  cs.WinsCGT1++;
					  cs.TotalCashWLCGT1 += GetBJPlayer(BetSpotUse[0])->coinsplayedhand0;
					}
					if(StartTC < 1)
					{
					  cs.WinsCLT2++;
					  cs.TotalCashWLCLT1 += GetBJPlayer(BetSpotUse[0])->coinsplayedhand0;
					}
					if(GetBJPlayer(BetSpotUse[0])->coinsplayedhand0 == (BetSpot[0]->betamount)*2)
					{
					  BetSpot[0]->ShowDoubleDownWinChips();
					  cs.DDWins++;
					  cs.DDWinnings += GetBJPlayer(BetSpotUse[0])->coinsplayedhand0;
					  //AddCash(BetSpotUse[0],(GetBJPlayer(BetSpotUse[0])->coinsplayedhand0)*2);
					}
				 }
				 cs.CurrentWinStreak++;
				 cs.CurrentLosingStreak = 0;
				 if(cs.CurrentWinStreak > cs.WinStreak)
				 {
					cs.WinStreak = cs.CurrentWinStreak;
				 }
				 cs.Wins++;
				 break;
  case 1  :  if(((TBJHand *)GetBJPlayer(BetSpotUse[1])->pHand1)->bj)
				 {
					AddCash(BetSpotUse[1],(((GetBJPlayer(BetSpotUse[1])->coinsplayedhand1)*3)/2)+
							                GetBJPlayer(BetSpotUse[1])->coinsplayedhand1);
					MessageDisplay->ShowBJMessage(52,((GetBJPlayer(BetSpotUse[1])->coinsplayedhand1)*3)/2,true);
					BetSpot[1]->ShowBJChips();
					//BetSpotUse[1] = -1;
					retValue = GetBJPlayer(BetSpotUse[1])->coinsplayedhand1;
					cs.Player21++;
					cs.BJWins++;
					if(StartTC > 0)
					{
					  cs.WinsCGT1++;
					  cs.TotalCashWLCGT1 += (GetBJPlayer(BetSpotUse[1])->coinsplayedhand1*3)/2;
					}
					if(StartTC < 1)
					{
					  cs.WinsCLT2++;
					  cs.TotalCashWLCLT1 += (GetBJPlayer(BetSpotUse[1])->coinsplayedhand1*3)/2;
					}
					if(cs.LargestWin < (GetBJPlayer( BetSpotUse[1])->coinsplayedhand1*3)/2)
					{
					  cs.LargestWin = (GetBJPlayer(BetSpotUse[1])->coinsplayedhand1*3)/2;
					}
				 }
				 else
				 {
					AddCash(BetSpotUse[1],(GetBJPlayer(BetSpotUse[1])->coinsplayedhand1)*2);
					MessageDisplay->ShowBJMessage(52,GetBJPlayer(BetSpotUse[1])->coinsplayedhand1,false);
					BetSpot[1]->ShowWinChips();
					if(cs.LargestWin < (GetBJPlayer( BetSpotUse[1])->coinsplayedhand1))
					{
					  cs.LargestWin = GetBJPlayer(BetSpotUse[1])->coinsplayedhand1;
					}
					if(((TBJHand *)GetBJPlayer(BetSpotUse[1])->pHand1)->IsSplitHand)
					{
					  cs.SplitsWL += GetBJPlayer(BetSpotUse[1])->coinsplayedhand1;
					}
					if(StartTC > 0)
					{
					  cs.WinsCGT1++;
					  cs.TotalCashWLCGT1 += GetBJPlayer(BetSpotUse[1])->coinsplayedhand1;
					}
					if(StartTC < 1)
					{
					  cs.WinsCLT2++;
					  cs.TotalCashWLCLT1 += GetBJPlayer(BetSpotUse[1])->coinsplayedhand1;
					}
					if(GetBJPlayer(BetSpotUse[1])->coinsplayedhand1 == (BetSpot[1]->betamount)*2)
					{
					  cs.DDWins++;
					  cs.DDWinnings += GetBJPlayer(BetSpotUse[1])->coinsplayedhand1;
					  BetSpot[1]->ShowDoubleDownWinChips();
					 // AddCash(BetSpotUse[1],(GetBJPlayer(BetSpotUse[1])->coinsplayedhand1)*2);
					}
				 }
				 cs.CurrentWinStreak++;
				 cs.CurrentLosingStreak = 0;
				 if(cs.CurrentWinStreak > cs.WinStreak)
				 {
					cs.WinStreak = cs.CurrentWinStreak;
				 }
				 cs.Wins++;
				 break;
  case 2  :  if(((TBJHand *)GetBJPlayer(BetSpotUse[2])->pHand2)->bj)
				 {
					AddCash(BetSpotUse[2],(((GetBJPlayer(BetSpotUse[2])->coinsplayedhand2)*3)/2)+
							  GetBJPlayer(BetSpotUse[2])->coinsplayedhand2);
					MessageDisplay->ShowBJMessage(52,((GetBJPlayer(BetSpotUse[2])->coinsplayedhand2)*3)/2,true);
					BetSpot[2]->ShowBJChips();
					//BetSpotUse[2] = -1;
					retValue = GetBJPlayer(BetSpotUse[2])->coinsplayedhand2;
					cs.Player21++;
					cs.BJWins++;
					cs.SplitsWL += (GetBJPlayer(BetSpotUse[2])->coinsplayedhand2*3)/2;
					if(StartTC > 0)
					{
					  cs.WinsCGT1++;
					  cs.TotalCashWLCGT1 += (GetBJPlayer(BetSpotUse[2])->coinsplayedhand2*3)/2;
					}
					if(StartTC < 1)
					{
					  cs.WinsCLT2++;
					  cs.TotalCashWLCLT1 += (GetBJPlayer(BetSpotUse[2])->coinsplayedhand2*3)/2;
					}
					if(cs.LargestWin < (GetBJPlayer( BetSpotUse[2])->coinsplayedhand2*3)/2            )
					{
					  cs.LargestWin = (GetBJPlayer(BetSpotUse[2])->coinsplayedhand2*3)/2;
					}
				 }
				 else
				 {
					AddCash(BetSpotUse[2],(GetBJPlayer(BetSpotUse[2])->coinsplayedhand2)*2);
					MessageDisplay->ShowBJMessage(52,GetBJPlayer(BetSpotUse[2])->coinsplayedhand2,false);
					BetSpot[2]->ShowWinChips();
					if(cs.LargestWin < (GetBJPlayer( BetSpotUse[2])->coinsplayedhand2)                )
					{
					  cs.LargestWin = GetBJPlayer(BetSpotUse[2])->coinsplayedhand2;
					}
					cs.SplitsWL += GetBJPlayer(BetSpotUse[2])->coinsplayedhand2;
					if(StartTC > 0)
					{
					  cs.WinsCGT1++;
					  cs.TotalCashWLCGT1 += GetBJPlayer(BetSpotUse[2])->coinsplayedhand2;
					}
					if(StartTC < 1)
					{
					  cs.WinsCLT2++;
					  cs.TotalCashWLCLT1 += GetBJPlayer(BetSpotUse[2])->coinsplayedhand2;
					}
					if(GetBJPlayer(BetSpotUse[2])->coinsplayedhand2 == (BetSpot[2]->betamount)*2)
					{
					  cs.DDWins++;
					  cs.DDWinnings += GetBJPlayer(BetSpotUse[2])->coinsplayedhand2;
					  BetSpot[2]->ShowDoubleDownWinChips();
					  //AddCash(BetSpotUse[2],(GetBJPlayer(BetSpotUse[2])->coinsplayedhand2)*2);
					}
				 }
				 cs.CurrentWinStreak++;
				 cs.CurrentLosingStreak = 0;
				 if(cs.CurrentWinStreak > cs.WinStreak)
				 {
					cs.WinStreak = cs.CurrentWinStreak;
				 }
				 cs.Wins++;
				 break;
  case 3  :  if(((TBJHand *)GetBJPlayer(BetSpotUse[2])->pHand2)->bj)
				 {
					AddCash(BetSpotUse[2],(((GetBJPlayer(BetSpotUse[2])->coinsplayedhand2)*3)/2)+
							  GetBJPlayer(BetSpotUse[2])->coinsplayedhand2);
					MessageDisplay->ShowBJMessage(52,((GetBJPlayer(BetSpotUse[2])->coinsplayedhand2)*3)/2,true);
					BetSpot[2]->ShowBJChips();
					//BetSpotUse[2] = -1;
					retValue = GetBJPlayer(BetSpotUse[2])->coinsplayedhand2;
					cs.Player21++;
					cs.BJWins++;
					cs.SplitsWL += (GetBJPlayer(BetSpotUse[2])->coinsplayedhand2*3)/2;
					if(StartTC > 0)
					{
					  cs.WinsCGT1++;
					  cs.TotalCashWLCGT1 += (GetBJPlayer(BetSpotUse[2])->coinsplayedhand2*3)/2;
					}
					if(StartTC < 1)
					{
					  cs.WinsCLT2++;
					  cs.TotalCashWLCLT1 += (GetBJPlayer(BetSpotUse[2])->coinsplayedhand2*3)/2;
					}
					if(cs.LargestWin < (GetBJPlayer( BetSpotUse[2])->coinsplayedhand2*3)/2            )
					{
					  cs.LargestWin = (GetBJPlayer(BetSpotUse[2])->coinsplayedhand2*3)/2;
					}
				 }
				 else
				 {
					AddCash(BetSpotUse[2],(GetBJPlayer(BetSpotUse[2])->coinsplayedhand2)*2);
					MessageDisplay->ShowBJMessage(52,GetBJPlayer(BetSpotUse[2])->coinsplayedhand2,false);
					BetSpot[2]->ShowWinChips();
					if(cs.LargestWin < (GetBJPlayer( BetSpotUse[2])->coinsplayedhand2)                )
					{
					  cs.LargestWin = GetBJPlayer(BetSpotUse[2])->coinsplayedhand2;
					}
					cs.SplitsWL += GetBJPlayer(BetSpotUse[2])->coinsplayedhand2;
					if(StartTC > 0)
					{
					  cs.WinsCGT1++;
					  cs.TotalCashWLCGT1 += GetBJPlayer(BetSpotUse[2])->coinsplayedhand2;
					}
					if(StartTC < 1)
					{
					  cs.WinsCLT2++;
					  cs.TotalCashWLCLT1 += GetBJPlayer(BetSpotUse[2])->coinsplayedhand2;
					}
					if(GetBJPlayer(BetSpotUse[2])->coinsplayedhand2 == (BetSpot[2]->betamount)*2)
					{
					  cs.DDWins++;
					  cs.DDWinnings += GetBJPlayer(BetSpotUse[2])->coinsplayedhand2;
					  BetSpot[2]->ShowDoubleDownWinChips();
					  //AddCash(BetSpotUse[2],(GetBJPlayer(BetSpotUse[2])->coinsplayedhand2)*2);
					}
				 }
				 cs.CurrentWinStreak++;
				 cs.CurrentLosingStreak = 0;
				 if(cs.CurrentWinStreak > cs.WinStreak)
				 {
					cs.WinStreak = cs.CurrentWinStreak;
				 }
				 cs.Wins++;
				 break;
  case 4  :  if(((TBJHand *)GetBJPlayer(BetSpotUse[3])->pHand3)->bj)
				 {
					AddCash(BetSpotUse[3],(((GetBJPlayer(BetSpotUse[3])->coinsplayedhand3)*3)/2)+
							  GetBJPlayer(BetSpotUse[3])->coinsplayedhand3);
					MessageDisplay->ShowBJMessage(52,((GetBJPlayer(BetSpotUse[3])->coinsplayedhand3)*3)/2,true);
					BetSpot[3]->ShowBJChips();
					//BetSpotUse[3] = -1;
					retValue = GetBJPlayer(BetSpotUse[3])->coinsplayedhand3;
					cs.Player21++;
					cs.BJWins++;
					if(StartTC > 0)
					{
					  cs.WinsCGT1++;
					  cs.TotalCashWLCGT1 += (GetBJPlayer(BetSpotUse[3])->coinsplayedhand3*3)/2;
					}
					if(StartTC < 1)
					{
					  cs.WinsCLT2++;
					  cs.TotalCashWLCLT1 += (GetBJPlayer(BetSpotUse[3])->coinsplayedhand3*3)/2;
					}
					if(((TBJHand *)GetBJPlayer(BetSpotUse[3])->pHand3)->IsSplitHand)
					{
					  cs.SplitsWL += (GetBJPlayer(BetSpotUse[3])->coinsplayedhand3*3)/2;
					}
					if(cs.LargestWin < (GetBJPlayer( BetSpotUse[3])->coinsplayedhand3*3)/2            )
					{
					  cs.LargestWin = (GetBJPlayer(BetSpotUse[3])->coinsplayedhand3*3)/2;
					}
				 }
				 else
				 {
					AddCash(BetSpotUse[3],(GetBJPlayer(BetSpotUse[3])->coinsplayedhand3)*2);
					MessageDisplay->ShowBJMessage(52,GetBJPlayer(BetSpotUse[3])->coinsplayedhand3,false);
					BetSpot[3]->ShowWinChips();
					if(cs.LargestWin < (GetBJPlayer( BetSpotUse[3])->coinsplayedhand3)                )
					{
					  cs.LargestWin = GetBJPlayer(BetSpotUse[3])->coinsplayedhand3;
					}
					if(((TBJHand *)GetBJPlayer(BetSpotUse[3])->pHand3)->IsSplitHand)
					{
					  cs.SplitsWL += GetBJPlayer(BetSpotUse[3])->coinsplayedhand3;
					}
					if(StartTC > 0)
					{
					  cs.WinsCGT1++;
					  cs.TotalCashWLCGT1 += GetBJPlayer(BetSpotUse[3])->coinsplayedhand3;
					}
					if(StartTC < 1)
					{
					  cs.WinsCLT2++;
					  cs.TotalCashWLCLT1 += GetBJPlayer(BetSpotUse[3])->coinsplayedhand3;
					}
					if(GetBJPlayer(BetSpotUse[3])->coinsplayedhand3 == (BetSpot[3]->betamount)*2)
					{
					  cs.DDWins++;
					  cs.DDWinnings += GetBJPlayer(BetSpotUse[3])->coinsplayedhand3;
					  BetSpot[3]->ShowDoubleDownWinChips();
					  //AddCash(BetSpotUse[3],(GetBJPlayer(BetSpotUse[3])->coinsplayedhand3)*2);
					}
				 }
				 cs.CurrentWinStreak++;
				 cs.CurrentLosingStreak = 0;
				 if(cs.CurrentWinStreak > cs.WinStreak)
				 {
					cs.WinStreak = cs.CurrentWinStreak;
				 }
				 cs.Wins++;
				 break;
  case 5  :  if(((TBJHand *)GetBJPlayer(BetSpotUse[4])->pHand4)->bj)
				 {
					AddCash(BetSpotUse[4],(((GetBJPlayer(BetSpotUse[4])->coinsplayedhand4)*3)/2)+
							  GetBJPlayer(BetSpotUse[4])->coinsplayedhand4);
					MessageDisplay->ShowBJMessage(52,((GetBJPlayer(BetSpotUse[4])->coinsplayedhand4)*3)/2,true);
					BetSpot[4]->ShowBJChips();
					//BetSpotUse[4] = -1;
					retValue = GetBJPlayer(BetSpotUse[4])->coinsplayedhand4;
					cs.Player21++;
					cs.BJWins++;
					cs.SplitsWL += (GetBJPlayer(BetSpotUse[4])->coinsplayedhand4*3)/2;
					if(StartTC > 0)
					{
					  cs.WinsCGT1++;
					  cs.TotalCashWLCGT1 += (GetBJPlayer(BetSpotUse[4])->coinsplayedhand4*3)/2;
					}
					if(StartTC < 1)
					{
					  cs.WinsCLT2++;
					  cs.TotalCashWLCLT1 += (GetBJPlayer(BetSpotUse[4])->coinsplayedhand4*3)/2;
					}
					if(cs.LargestWin < (GetBJPlayer( BetSpotUse[4])->coinsplayedhand4*3)/2            )
					{
					  cs.LargestWin = (GetBJPlayer(BetSpotUse[4])->coinsplayedhand4*3)/2;
					}
				 }
				 else
				 {
					AddCash(BetSpotUse[4],(GetBJPlayer(BetSpotUse[4])->coinsplayedhand4)*2);
					MessageDisplay->ShowBJMessage(52,GetBJPlayer(BetSpotUse[4])->coinsplayedhand4,false);
					BetSpot[4]->ShowWinChips();
					if(cs.LargestWin < (GetBJPlayer( BetSpotUse[4])->coinsplayedhand4)                )
					{
					  cs.LargestWin = GetBJPlayer(BetSpotUse[4])->coinsplayedhand4;
					}
					cs.SplitsWL += GetBJPlayer(BetSpotUse[4])->coinsplayedhand4;
					if(StartTC > 0)
					{
					  cs.WinsCGT1++;
					  cs.TotalCashWLCGT1 += GetBJPlayer(BetSpotUse[4])->coinsplayedhand4;
					}
					if(StartTC < 1)
					{
					  cs.WinsCLT2++;
					  cs.TotalCashWLCLT1 += GetBJPlayer(BetSpotUse[4])->coinsplayedhand4;
					}
					if(GetBJPlayer(BetSpotUse[4])->coinsplayedhand4 == (BetSpot[4]->betamount)*2)
					{
					  cs.DDWins++;
					  cs.DDWinnings += GetBJPlayer(BetSpotUse[4])->coinsplayedhand4;
					  BetSpot[4]->ShowDoubleDownWinChips();
					  //AddCash(BetSpotUse[4],(GetBJPlayer(BetSpotUse[4])->coinsplayedhand4)*2);
					}
				 }
				 cs.CurrentWinStreak++;
				 cs.CurrentLosingStreak = 0;
				 if(cs.CurrentWinStreak > cs.WinStreak)
				 {
					cs.WinStreak = cs.CurrentWinStreak;
				 }
				 cs.Wins++;
				 break;
  case 6  :  if(((TBJHand *)GetBJPlayer(BetSpotUse[4])->pHand4)->bj)
				 {
					AddCash(BetSpotUse[4],(((GetBJPlayer(BetSpotUse[4])->coinsplayedhand4)*3)/2)+
							  GetBJPlayer(BetSpotUse[4])->coinsplayedhand4);
					MessageDisplay->ShowBJMessage(52,((GetBJPlayer(BetSpotUse[4])->coinsplayedhand4)*3)/2,true);
					BetSpot[4]->ShowBJChips();
					//BetSpotUse[4] = -1;
					retValue = GetBJPlayer(BetSpotUse[4])->coinsplayedhand4;
					cs.Player21++;
					cs.BJWins++;
					cs.SplitsWL += (GetBJPlayer(BetSpotUse[4])->coinsplayedhand4*3)/2;
					if(StartTC > 0)
					{
					  cs.WinsCGT1++;
					  cs.TotalCashWLCGT1 += (GetBJPlayer(BetSpotUse[4])->coinsplayedhand4*3)/2;
					}
					if(StartTC < 1)
					{
					  cs.WinsCLT2++;
					  cs.TotalCashWLCLT1 += (GetBJPlayer(BetSpotUse[4])->coinsplayedhand4*3)/2;
					}
					if(cs.LargestWin < (GetBJPlayer( BetSpotUse[4])->coinsplayedhand4*3)/2)
					{
					  cs.LargestWin = (GetBJPlayer(BetSpotUse[4])->coinsplayedhand4*3)/2;
					}
				 }
				 else
				 {
					AddCash(BetSpotUse[4],(GetBJPlayer(BetSpotUse[4])->coinsplayedhand4)*2);
					MessageDisplay->ShowBJMessage(52,GetBJPlayer(BetSpotUse[4])->coinsplayedhand4,false);
					BetSpot[4]->ShowWinChips();
					if(cs.LargestWin < (GetBJPlayer( BetSpotUse[4])->coinsplayedhand4))
					{
					  cs.LargestWin = GetBJPlayer(BetSpotUse[4])->coinsplayedhand4;
					}
					cs.SplitsWL += GetBJPlayer(BetSpotUse[4])->coinsplayedhand4;
					if(StartTC > 0)
					{
					  cs.WinsCGT1++;
					  cs.TotalCashWLCGT1 += GetBJPlayer(BetSpotUse[4])->coinsplayedhand4;
					}
					if(StartTC < 1)
					{
					  cs.WinsCLT2++;
					  cs.TotalCashWLCLT1 += GetBJPlayer(BetSpotUse[4])->coinsplayedhand4;
					}
					if(GetBJPlayer(BetSpotUse[4])->coinsplayedhand4 == (BetSpot[4]->betamount)*2)
					{
					  cs.DDWins++;
					  cs.DDWinnings += GetBJPlayer(BetSpotUse[4])->coinsplayedhand4;
					  BetSpot[4]->ShowDoubleDownWinChips();
					  //AddCash(BetSpotUse[4],(GetBJPlayer(BetSpotUse[4])->coinsplayedhand4)*2);
					}
				 }
				 cs.CurrentWinStreak++;
				 cs.CurrentLosingStreak = 0;
				 if(cs.CurrentWinStreak > cs.WinStreak)
				 {
					cs.WinStreak = cs.CurrentWinStreak;
				 }
				 cs.Wins++;
				 break;
  case 7  :  if(((TBJHand *)GetBJPlayer(BetSpotUse[5])->pHand5)->bj)
				 {
					AddCash(BetSpotUse[5],(((GetBJPlayer(BetSpotUse[5])->coinsplayedhand5)*3)/2)+
							  GetBJPlayer(BetSpotUse[5])->coinsplayedhand5);
					MessageDisplay->ShowBJMessage(52,((GetBJPlayer(BetSpotUse[5])->coinsplayedhand5)*3)/2,true);
					BetSpot[5]->ShowBJChips();
					//BetSpotUse[5] = -1;
					retValue = GetBJPlayer(BetSpotUse[5])->coinsplayedhand5;
					cs.Player21++;
					cs.BJWins++;
					if(((TBJHand *)GetBJPlayer(BetSpotUse[5])->pHand5)->IsSplitHand)
					{
					  cs.SplitsWL += (GetBJPlayer(BetSpotUse[5])->coinsplayedhand5*3)/2;
					}
					if(StartTC > 0)
					{
					  cs.WinsCGT1++;
					  cs.TotalCashWLCGT1 += (GetBJPlayer(BetSpotUse[5])->coinsplayedhand5*3)/2;
					}
					if(StartTC < 1)
					{
					  cs.WinsCLT2++;
					  cs.TotalCashWLCLT1 += (GetBJPlayer(BetSpotUse[5])->coinsplayedhand5*3)/2;
					}
					if(cs.LargestWin < (GetBJPlayer( BetSpotUse[5])->coinsplayedhand5*3)/2)
					{
					  cs.LargestWin = (GetBJPlayer(BetSpotUse[5])->coinsplayedhand5*3)/2;
					}
				 }
				 else
				 {
					AddCash(BetSpotUse[5],(GetBJPlayer(BetSpotUse[5])->coinsplayedhand5)*2);
					MessageDisplay->ShowBJMessage(52,GetBJPlayer(BetSpotUse[5])->coinsplayedhand5,false);
					BetSpot[5]->ShowWinChips();
					if(cs.LargestWin < (GetBJPlayer( BetSpotUse[5])->coinsplayedhand5))
					{
					  cs.LargestWin = GetBJPlayer(BetSpotUse[5])->coinsplayedhand5;
					}
					if(((TBJHand *)GetBJPlayer(BetSpotUse[5])->pHand5)->IsSplitHand)
					{
					  cs.SplitsWL += GetBJPlayer(BetSpotUse[5])->coinsplayedhand5;
					}
					if(StartTC > 0)
					{
					  cs.WinsCGT1++;
					  cs.TotalCashWLCGT1 += GetBJPlayer(BetSpotUse[5])->coinsplayedhand5;
					}
					if(StartTC < 1)
					{
					  cs.WinsCLT2++;
					  cs.TotalCashWLCLT1 += GetBJPlayer(BetSpotUse[5])->coinsplayedhand5;
					}
					if(GetBJPlayer(BetSpotUse[5])->coinsplayedhand5 == (BetSpot[5]->betamount)*2)
					{
					  cs.DDWins++;
					  cs.DDWinnings += GetBJPlayer(BetSpotUse[5])->coinsplayedhand5;
					  BetSpot[5]->ShowDoubleDownWinChips();
					  //AddCash(BetSpotUse[5],(GetBJPlayer(BetSpotUse[5])->coinsplayedhand5)*2);
					}
				 }
				 cs.CurrentWinStreak++;
				 cs.CurrentLosingStreak = 0;
				 if(cs.CurrentWinStreak > cs.WinStreak)
				 {
					cs.WinStreak = cs.CurrentWinStreak;
				 }
				 cs.Wins++;
				 break;
  case 8  :  if(((TBJHand *)GetBJPlayer(BetSpotUse[6])->pHand6)->bj)
				 {
					AddCash(BetSpotUse[6],(((GetBJPlayer(BetSpotUse[6])->coinsplayedhand6)*3)/2)+
							  GetBJPlayer(BetSpotUse[6])->coinsplayedhand6);
					MessageDisplay->ShowBJMessage(52,((GetBJPlayer(BetSpotUse[6])->coinsplayedhand6)*3)/2,true);
					BetSpot[6]->ShowBJChips();
					//BetSpotUse[6] = -1;
					retValue = GetBJPlayer(BetSpotUse[6])->coinsplayedhand6;
					cs.Player21++;
					cs.BJWins++;
					cs.SplitsWL += (GetBJPlayer(BetSpotUse[6])->coinsplayedhand6*3)/2;
					if(StartTC > 0)
					{
					  cs.WinsCGT1++;
					  cs.TotalCashWLCGT1 += (GetBJPlayer(BetSpotUse[6])->coinsplayedhand6*3)/2;
					}
					if(StartTC < 1)
					{
					  cs.WinsCLT2++;
					  cs.TotalCashWLCLT1 += (GetBJPlayer(BetSpotUse[6])->coinsplayedhand6*3)/2;
					}
					if(cs.LargestWin < (GetBJPlayer( BetSpotUse[6])->coinsplayedhand6*3)/2            )
					{
					  cs.LargestWin = (GetBJPlayer(BetSpotUse[6])->coinsplayedhand6*3)/2;
					}
				 }
				 else
				 {
					AddCash(BetSpotUse[6],(GetBJPlayer(BetSpotUse[6])->coinsplayedhand6)*2);
					MessageDisplay->ShowBJMessage(52,GetBJPlayer(BetSpotUse[6])->coinsplayedhand6,false);
					BetSpot[6]->ShowWinChips();
					if(cs.LargestWin < (GetBJPlayer( BetSpotUse[6])->coinsplayedhand6)                )
					{
					  cs.LargestWin = GetBJPlayer(BetSpotUse[6])->coinsplayedhand6;
					}
					cs.SplitsWL += GetBJPlayer(BetSpotUse[6])->coinsplayedhand6;
					if(StartTC > 0)
					{
					  cs.WinsCGT1++;
					  cs.TotalCashWLCGT1 += GetBJPlayer(BetSpotUse[6])->coinsplayedhand6;
					}
					if(StartTC < 1)
					{
					  cs.WinsCLT2++;
					  cs.TotalCashWLCLT1 += GetBJPlayer(BetSpotUse[6])->coinsplayedhand6;
					}
					if(GetBJPlayer(BetSpotUse[6])->coinsplayedhand6 == (BetSpot[6]->betamount)*2)
					{
					  cs.DDWins++;
					  cs.DDWinnings += GetBJPlayer(BetSpotUse[6])->coinsplayedhand6;
					  BetSpot[6]->ShowDoubleDownWinChips();
					}
				 }
				 cs.CurrentWinStreak++;
				 cs.CurrentLosingStreak = 0;
				 if(cs.CurrentWinStreak > cs.WinStreak)
				 {
					cs.WinStreak = cs.CurrentWinStreak;
				 }
				 cs.Wins++;
				 break;
  default :  break;
  }
  }// end if (bsi > -1)

  Chips->SetNum(GetCash(activeplayer));
  BankCashDisplay->SetNum(GetCash(activeplayer));
  return retValue;
}// winner
//*******************************************************************
int16 TCasinoBJGameLord::Loser(int16 loser)
{
  int16 bsi = -1;
  switch (loser)
  {
    case 0: bsi = 0;break;
    case 1: bsi = 1;break;
    case 2: bsi = 2;break;
    case 3: bsi = 2;break;
    case 4: bsi = 3;break;
    case 5: bsi = 4;break;
    case 6: bsi = 4;break;
    case 7: bsi = 5;break;
    case 8: bsi = 6;break;
  }

  if (bsi > -1)
  {
  int16 session = GetCasPD(BetSpotUse[bsi])->BJData.CurrentSession;
  TCBJSession &cs = GetCasPD(BetSpotUse[bsi])->BJData.Sessions[session];

  switch(loser){
  case 0  :  cs.CurrentWinStreak = 0;
				 cs.CurrentLosingStreak++;
				 if(StartTC > 0)
				 {
					cs.TotalCashWLCGT1 -= GetBJPlayer(BetSpotUse[0])->coinsplayedhand0;
				 }
				 if(StartTC < 1)
				 {
					cs.TotalCashWLCLT1 -= GetBJPlayer(BetSpotUse[0])->coinsplayedhand0;
				 }
				 if(cs.CurrentLosingStreak > cs.LosingStreak)
				 {
					 cs.LosingStreak = cs.CurrentLosingStreak;
				 }
				 if(cs.LargestLoss < GetBJPlayer( BetSpotUse[0])->coinsplayedhand0                   )
				 {
					 cs.LargestLoss = GetBJPlayer(BetSpotUse[0])->coinsplayedhand0;
				 }
				 if(((TBJHand *)GetBJPlayer(BetSpotUse[0])->pHand0)->IsDDHand)
				 {
					cs.DDWinnings -= GetBJPlayer(BetSpotUse[0])->coinsplayedhand0;
				 }
				 cs.SplitsWL -= GetBJPlayer(BetSpotUse[0])->coinsplayedhand0;
				 cs.Losses++;
             break;
  case 1  :  cs.CurrentWinStreak = 0;
				 cs.CurrentLosingStreak++;
				 if(StartTC > 0)
				 {
					cs.TotalCashWLCGT1 -= GetBJPlayer(BetSpotUse[1])->coinsplayedhand1;
				 }
				 if(StartTC < 1)
				 {
					cs.TotalCashWLCLT1 -= GetBJPlayer(BetSpotUse[1])->coinsplayedhand1;
				 }
				 if(cs.CurrentLosingStreak > cs.LosingStreak)
				 {
					 cs.LosingStreak = cs.CurrentLosingStreak;
				 }
				 if(cs.LargestLoss < GetBJPlayer( BetSpotUse[1])->coinsplayedhand1)
				 {
					 cs.LargestLoss = GetBJPlayer(BetSpotUse[1])->coinsplayedhand1;
				 }
				 if(((TBJHand *)GetBJPlayer(BetSpotUse[1])->pHand1)->IsSplitHand)
				 {
					cs.SplitsWL -= GetBJPlayer(BetSpotUse[1])->coinsplayedhand1;
				 }
				 if(((TBJHand *)GetBJPlayer(BetSpotUse[1])->pHand1)->IsDDHand)
				 {
					cs.DDWinnings -= GetBJPlayer(BetSpotUse[1])->coinsplayedhand1;
				 }
				 cs.Losses++;
             break;
  case 2  :  cs.CurrentWinStreak = 0;
				 cs.CurrentLosingStreak++;
				 if(StartTC > 0)
				 {
					cs.TotalCashWLCGT1 -= GetBJPlayer(BetSpotUse[2])->coinsplayedhand2;
				 }
				 if(StartTC < 1)
				 {
					cs.TotalCashWLCLT1 -= GetBJPlayer(BetSpotUse[2])->coinsplayedhand2;
				 }
				 if(cs.CurrentLosingStreak > cs.LosingStreak)
				 {
					 cs.LosingStreak = cs.CurrentLosingStreak;
				 }
				 if(cs.LargestLoss < GetBJPlayer( BetSpotUse[2])->coinsplayedhand2                   )
				 {
					 cs.LargestLoss = GetBJPlayer(BetSpotUse[2])->coinsplayedhand2;
				 }
				 if(((TBJHand *)GetBJPlayer(BetSpotUse[2])->pHand2)->IsDDHand)
				 {
					cs.DDWinnings -= GetBJPlayer(BetSpotUse[2])->coinsplayedhand2;
				 }
				 cs.SplitsWL -= GetBJPlayer(BetSpotUse[2])->coinsplayedhand2;
				 cs.Losses++;
             break;
  case 3  :  cs.CurrentWinStreak = 0;
				 cs.CurrentLosingStreak++;
				 if(StartTC > 0)
				 {
					cs.TotalCashWLCGT1 -= GetBJPlayer(BetSpotUse[2])->coinsplayedhand2;
				 }
				 if(StartTC < 1)
				 {
					cs.TotalCashWLCLT1 -= GetBJPlayer(BetSpotUse[2])->coinsplayedhand2;
				 }
				 if(cs.CurrentLosingStreak > cs.LosingStreak)
				 {
					 cs.LosingStreak = cs.CurrentLosingStreak;
				 }
				 if(cs.LargestLoss < GetBJPlayer( BetSpotUse[2])->coinsplayedhand2)
				 {
					 cs.LargestLoss = GetBJPlayer(BetSpotUse[2])->coinsplayedhand2;
				 }
				 if(((TBJHand *)GetBJPlayer(BetSpotUse[2])->pHand2)->IsDDHand)
				 {
					cs.DDWinnings -= GetBJPlayer(BetSpotUse[2])->coinsplayedhand2;
				 }
				 cs.SplitsWL -= GetBJPlayer(BetSpotUse[2])->coinsplayedhand2;
				 cs.Losses++;
             break;
  case 4  :  cs.CurrentWinStreak = 0;
				 cs.CurrentLosingStreak++;
				 if(StartTC > 0)
				 {
					cs.TotalCashWLCGT1 -= GetBJPlayer(BetSpotUse[3])->coinsplayedhand3;
				 }
				 if(StartTC < 1)
				 {
				  	cs.TotalCashWLCLT1 -= GetBJPlayer(BetSpotUse[3])->coinsplayedhand3;
				 }
				 if(cs.CurrentLosingStreak > cs.LosingStreak)
				 {
					 cs.LosingStreak = cs.CurrentLosingStreak;
				 }
				 if(cs.LargestLoss < GetBJPlayer( BetSpotUse[3])->coinsplayedhand3)
				 {
					 cs.LargestLoss = GetBJPlayer(BetSpotUse[3])->coinsplayedhand3;
				 }
				 if(((TBJHand *)GetBJPlayer(BetSpotUse[3])->pHand3)->IsSplitHand)
				 {
					cs.SplitsWL -= GetBJPlayer(BetSpotUse[3])->coinsplayedhand3;
				 }
				 if(((TBJHand *)GetBJPlayer(BetSpotUse[3])->pHand3)->IsDDHand)
				 {
					cs.DDWinnings -= GetBJPlayer(BetSpotUse[3])->coinsplayedhand3;
				 }
				 cs.Losses++;
             break;
  case 5  :  cs.CurrentWinStreak = 0;
				 cs.CurrentLosingStreak++;
				 if(StartTC > 0)
				 {
					cs.TotalCashWLCGT1 -= GetBJPlayer(BetSpotUse[4])->coinsplayedhand4;
				 }
				 if(StartTC < 1)
				 {
					cs.TotalCashWLCLT1 -= GetBJPlayer(BetSpotUse[4])->coinsplayedhand4;
				 }
				 if(cs.CurrentLosingStreak > cs.LosingStreak)
				 {
					 cs.LosingStreak = cs.CurrentLosingStreak;
				 }
				 if(cs.LargestLoss < GetBJPlayer( BetSpotUse[4])->coinsplayedhand4)
				 {
					 cs.LargestLoss = GetBJPlayer(BetSpotUse[4])->coinsplayedhand4;
				 }
				 if(((TBJHand *)GetBJPlayer(BetSpotUse[4])->pHand4)->IsDDHand)
				 {
					cs.DDWinnings -= GetBJPlayer(BetSpotUse[4])->coinsplayedhand4;
				 }
				 cs.SplitsWL -= GetBJPlayer(BetSpotUse[4])->coinsplayedhand4;
				 cs.Losses++;
             break;
  case 6  :  cs.CurrentWinStreak = 0;
				 cs.CurrentLosingStreak++;
				 if(StartTC > 0)
				 {
					cs.TotalCashWLCGT1 -= GetBJPlayer(BetSpotUse[4])->coinsplayedhand4;
				 }
				 if(StartTC < 1)
				 {
					cs.TotalCashWLCLT1 -= GetBJPlayer(BetSpotUse[4])->coinsplayedhand4;
				 }
				 if(cs.CurrentLosingStreak > cs.LosingStreak)
				 {
					 cs.LosingStreak = cs.CurrentLosingStreak;
				 }
				 if(cs.LargestLoss < GetBJPlayer( BetSpotUse[4])->coinsplayedhand4)
				 {
					 cs.LargestLoss = GetBJPlayer(BetSpotUse[4])->coinsplayedhand4;
				 }
				 if(((TBJHand *)GetBJPlayer(BetSpotUse[4])->pHand4)->IsDDHand)
				 {
					cs.DDWinnings -= GetBJPlayer(BetSpotUse[4])->coinsplayedhand4;
				 }
				 cs.SplitsWL -= GetBJPlayer(BetSpotUse[4])->coinsplayedhand4;
				 cs.Losses++;
             break;
  case 7  :  cs.CurrentWinStreak = 0;
				 cs.CurrentLosingStreak++;
				 if(StartTC > 0)
				 {
					cs.TotalCashWLCGT1 -= GetBJPlayer(BetSpotUse[5])->coinsplayedhand5;
				 }
				 if(StartTC < 1)
				 {
					cs.TotalCashWLCLT1 -= GetBJPlayer(BetSpotUse[5])->coinsplayedhand5;
				 }
				 if(cs.CurrentLosingStreak > cs.LosingStreak)
				 {
					 cs.LosingStreak = cs.CurrentLosingStreak;
				 }
				 if(cs.LargestLoss < GetBJPlayer( BetSpotUse[5])->coinsplayedhand5)
				 {
					 cs.LargestLoss = GetBJPlayer(BetSpotUse[5])->coinsplayedhand5;
				 }
				 if(((TBJHand *)GetBJPlayer(BetSpotUse[5])->pHand5)->IsSplitHand)
				 {
					cs.SplitsWL -= GetBJPlayer(BetSpotUse[5])->coinsplayedhand5;
				 }
				 if(((TBJHand *)GetBJPlayer(BetSpotUse[5])->pHand5)->IsDDHand)
				 {
					cs.DDWinnings -= GetBJPlayer(BetSpotUse[5])->coinsplayedhand5;
				 }
				 cs.Losses++;
             break;
  case 8  :  cs.CurrentWinStreak = 0;
				 cs.CurrentLosingStreak++;
				 if(StartTC > 0)
				 {
					cs.TotalCashWLCGT1 -= GetBJPlayer(BetSpotUse[6])->coinsplayedhand6;
				 }
				 if(StartTC < 1)
				 {
					cs.TotalCashWLCLT1 -= GetBJPlayer(BetSpotUse[6])->coinsplayedhand6;
				 }
				 if(cs.CurrentLosingStreak > cs.LosingStreak)
				 {
					 cs.LosingStreak = cs.CurrentLosingStreak;
				 }
				 if(cs.LargestLoss < GetBJPlayer( BetSpotUse[6])->coinsplayedhand6)
				 {
					 cs.LargestLoss = GetBJPlayer(BetSpotUse[6])->coinsplayedhand6;
				 }
				 if(((TBJHand *)GetBJPlayer(BetSpotUse[6])->pHand6)->IsDDHand)
				 {
					cs.DDWinnings -= GetBJPlayer(BetSpotUse[6])->coinsplayedhand6;
				 }
				 cs.SplitsWL -= GetBJPlayer(BetSpotUse[6])->coinsplayedhand6;
				 cs.Losses++;
             break;
  default :  break;
  }
  } // end if (bsi > -1)
  return 1;
}// loser
//*******************************************************************
int16 TCasinoBJGameLord::Pusher(int16 pusher)
{
  int16 session=0;
  switch(pusher){
  case 0  :  AddCash(BetSpotUse[0],(GetBJPlayer(BetSpotUse[0])->coinsplayedhand0));
				 session = GetCasPD(BetSpotUse[0])->BJData.CurrentSession;
				 GetCasPD(BetSpotUse[0])->BJData.Sessions[session].Pushes++;
				 break;
  case 1  :	 AddCash(BetSpotUse[1],(GetBJPlayer(BetSpotUse[1])->coinsplayedhand1));
				 session = GetCasPD(BetSpotUse[1])->BJData.CurrentSession;
				 GetCasPD(BetSpotUse[1])->BJData.Sessions[session].Pushes++;
				 break;
  case 2  :	 AddCash(BetSpotUse[2],(GetBJPlayer(BetSpotUse[2])->coinsplayedhand2));
				 session = GetCasPD(BetSpotUse[2])->BJData.CurrentSession;
				 GetCasPD(BetSpotUse[2])->BJData.Sessions[session].Pushes++;
				 break;
  case 3  :	 AddCash(BetSpotUse[2],(GetBJPlayer(BetSpotUse[2])->coinsplayedhand2));
				 session = GetCasPD(BetSpotUse[2])->BJData.CurrentSession;
				 GetCasPD(BetSpotUse[2])->BJData.Sessions[session].Pushes++;
				 break;
  case 4  :	 AddCash(BetSpotUse[3],(GetBJPlayer(BetSpotUse[3])->coinsplayedhand3));
				 session = GetCasPD(BetSpotUse[3])->BJData.CurrentSession;
				 GetCasPD(BetSpotUse[3])->BJData.Sessions[session].Pushes++;
				 break;
  case 5  :	 AddCash(BetSpotUse[4],(GetBJPlayer(BetSpotUse[4])->coinsplayedhand4));
				 session = GetCasPD(BetSpotUse[4])->BJData.CurrentSession;
				 GetCasPD(BetSpotUse[4])->BJData.Sessions[session].Pushes++;
				 break;
  case 6  :	 AddCash(BetSpotUse[4],(GetBJPlayer(BetSpotUse[4])->coinsplayedhand4));
				 session = GetCasPD(BetSpotUse[4])->BJData.CurrentSession;
				 GetCasPD(BetSpotUse[4])->BJData.Sessions[session].Pushes++;
				 break;
  case 7  :	 AddCash(BetSpotUse[5],(GetBJPlayer(BetSpotUse[5])->coinsplayedhand5));
				 session = GetCasPD(BetSpotUse[5])->BJData.CurrentSession;
				 GetCasPD(BetSpotUse[5])->BJData.Sessions[session].Pushes++;
				 break;
  case 8  :	 AddCash(BetSpotUse[6],(GetBJPlayer(BetSpotUse[6])->coinsplayedhand6));
				 session = GetCasPD(BetSpotUse[6])->BJData.CurrentSession;
				 GetCasPD(BetSpotUse[6])->BJData.Sessions[session].Pushes++;
				 break;
	 default :  break;
  }
  Chips->SetNum(GetCash(activeplayer));
  BankCashDisplay->SetNum(GetCash(activeplayer));
  return 1;
}// push
//*******************************************************************
int16 TCasinoBJGameLord::InitBJ()
{
  NamePlate1->NoShow();
  NamePlate2->NoShow();
  NamePlate3->NoShow();
  string name;
  Responders[0]->SetEnterLeave();
  Responders[1]->SetEnterLeave();
  Responders[2]->SetEnterLeave();
  Responders[4]->SetEnterLeave();

  DisEnableButton(13);
  DisEnableButton(14);
  DisEnableButton(15);
  DisEnableButton(16);
  DisEnableButton(17);
  DisEnableButton(18);
  Button12->ShowGray();
  Button5->ShowGray();
  SetupActivePlayer(NextSlotNum(-1)); // -1 because order of checking
  if(GetCasPD(0))
  {
	 name = GetCasPD(0)->GetName();
	 NamePlate1->ShowNamePlateString(name);
	 BankCashDisplay->SetNum(GetCash(0));
  }
  else if(GetCasPD(1))
  {
	 name = GetCasPD(1)->GetName();
	 NamePlate2->ShowNamePlateString(name);
	 BankCashDisplay->SetNum(GetCash(1));
  }
  else if(GetCasPD(2))
  {
	 name = GetCasPD(2)->GetName();
	 NamePlate3->ShowNamePlateString(name);
	 BankCashDisplay->SetNum(GetCash(2));
  }
  else
  {
	 BankCashDisplay->SetNum(0);
  }
  BetAmountDisplay->SetNum(0);
  if(GetCasPD(0))
  {
	 GetCasPD(0)->StartBJSession(SubGameType,GameDenom);
	 if(GetCash(0) >= 5)
	 {
		GetBJPlayer(0)->lastbet = 5;
	 }

//	 int session = GetCasPD(0)->BJData.CurrentSession;
//	 GetCasPD(0)->BJData.Sessions[session].GameName = (TGameName)game;
  }
  if(GetCasPD(1))
  {
	 GetCasPD(1)->StartBJSession(SubGameType,GameDenom);
	 if(GetCash(1) >= 5)
	 {
		GetBJPlayer(1)->lastbet = 5;
	 }

//	 int session = GetCasPD(1)->BJData.CurrentSession;
//	 GetCasPD(1)->BJData.Sessions[session].GameName = (TGameName)game;
  }
  if(GetCasPD(2))
  {
	 GetCasPD(2)->StartBJSession(SubGameType,GameDenom);
	 if(GetCash(2) >= 5)
	 {
		GetBJPlayer(2)->lastbet = 5;
	 }

//	 int session = GetCasPD(2)->BJData.CurrentSession;
//	 GetCasPD(2)->BJData.Sessions[session].GameName = (TGameName)game;
  }
  credits = 0;
  coinsplayed = 0;
  winnerpaid = 0;
  Rack->ShowBJRack(0);
  Sign->ShowBJSign(pMWin->GetNumDecks());
  if(activeplayer != -1 && GetCash(activeplayer) >= 5)
  {
	// coinsplayed = 5;
	// GetBJPlayer(activeplayer)->coinsplayed = 5;
	 GetBJPlayer(activeplayer)->lastbet = 5;
	 BetAmountDisplay->SetNum(GetBJPlayer(activeplayer)->lastbet);
	// BetUnitChips->SetNum(GetBJPlayer(activeplayer)->coinsplayed);
  }
  if (!GetFW()->GetHandleShowMenu())
  {
	 Button2->PButton->CAD.SetCurrentFrame(3);
	 Button2->PButton->Show();
	 Button2->PButtonResponder->Remove();
  }
  return 1;
}
//*******************************************************************
int16 TCasinoBJGameLord::SetBlackJack()
{
  if(pHand != NULL)
  {
	((TBJDeck *)pDeck)->BlackJack(pHand);
  }
  if(BetSpotUse[1] != -1)
  {
	((TBJDeck *)pDeck)->BlackJack(((TBJHand *)GetBJPlayer(BetSpotUse[1])->pHand1));
  }
  if(BetSpotUse[3] != -1)
  {
	((TBJDeck *)pDeck)->BlackJack(((TBJHand *)GetBJPlayer(BetSpotUse[3])->pHand3));
  }
  if(BetSpotUse[5] != -1)
  {
	((TBJDeck *)pDeck)->BlackJack(((TBJHand *)GetBJPlayer(BetSpotUse[5])->pHand5));
  }
  if(pHand->bj)
  {
	 return 1;
  }
  else
  {
	 return 0;
  }
}
//*******************************************************************

