//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  cbjrksp.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0    1/23/96    A.Krist     moved inline functions into .cpp file.
//  2.0   09/23/97    M.Perry     32-bit conversion.
//********************************************************************
#include "cbjrksp.h"
#include "oanm.h"
//*******************************************************************
void TBJRack::SetupAnms()
{
  PRack = GetAnm(0);
  if (PRack == NULL) {AnmError("Rack","rack",0);}

  PRack->CAD.ClearAutoStart();
  PRack->CAD.ClearAutoStop();
  PRack->CAD.SetDirStill();
}
//*******************************************************************
TBJRack::TBJRack(TOgleModeWindow *pmw,TFileMode NewFileMode)
:TSprite(pmw,NewFileMode)
{
  SetToManual();
  numofcards = 0;
  NoShow();
  SetupAnms();
}
//*******************************************************************
TBJRack::TBJRack(TOgleModeWindow *pmw,TFileMode fm,void *psource)
:TSprite(pmw,fm,psource)
{
  SetToManual();
  numofcards = 0;
  NoShow();
  SetupAnms();
}
//*******************************************************************
TBJRack::~TBJRack()
{
}
//*******************************************************************
void TBJRack::ShowBJRack(int16 cards)
{
  numofcards += cards;
  //yoffset   = PChips3[0]->SAD.GetY();
  // zoffset   = PChips3[0]->SAD.GetZ();
  if(cards == 0)
  {
	 PRack->CAD.SetCurrentFrame(0);
	 numofcards = 0;
  }
  else
  {
	 PRack->CAD.SetCurrentFrame(int16(((numofcards/13) + 1)%306));
  }
  PRack->Show();
  Update(GetAdjFUC());
}
//*******************************************************************
void TBJRack::NoShowBJRack()
{
  PRack->NoShow();
}
//*******************************************************************

