//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  cbjsdsp.cpp
//    Project Name:  Casino
// Original Author:  A.Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     7/19/96    M.Perry    moved into cpp file.
//  2.0    09/23/97    M.Perry    32-bit conversion.
//********************************************************************
#include "cbjsdsp.h"
#include "oanm.h"
#include "owav.h"
//*******************************************************************
void TBJSound::SetupWavs()
{
  for(int16 i=0;i<11;i++)
  {
	 Sounds[i] = GetWav(i);
	 if (Sounds[i] == NULL) {AnmError("Sound Sprite","sound",i);}
  }
  FourBack = GetAnm(0);
  TwoBack = GetAnm(1);
  if (FourBack == NULL) {AnmError("FourBack","bark",0);}
  FourBack->CAD.ClearAutoStart();
  FourBack->CAD.SetDirStill();
  FourBack->CAD.ClearAutoStop();
  if (TwoBack == NULL) {AnmError("TwoBack","bark",1);}
  TwoBack->CAD.ClearAutoStart();
  TwoBack->CAD.SetDirStill();
  TwoBack->CAD.ClearAutoStop();
}
//*******************************************************************
TBJSound::TBJSound(TOgleModeWindow *pmw,const TFileMode &NewFileMode)
:TSprite(pmw,NewFileMode)
{
  SetToManual();
  NoShow();
  SetupWavs();
}
//*******************************************************************
TBJSound::TBJSound(TOgleModeWindow *pmw,const TFileMode &fm,void *psource)
:TSprite(pmw,fm,psource)
{
  SetToManual();
  NoShow();
  SetupWavs();
}
//*******************************************************************
TBJSound::~TBJSound()
{
}
//*******************************************************************
void TBJSound::ShowFourBack()
{
  FourBack->Show();
}
//*******************************************************************
void TBJSound::NoShowFourBack()
{
  FourBack->NoShow();
}
//*******************************************************************
void TBJSound::NoShowTwoBack()
{
  TwoBack->NoShow();
}
//*******************************************************************
void TBJSound::ShowTwoBack()
{
  TwoBack->Show();
}
//*******************************************************************
void TBJSound::PlaySound(int16 sound)
{
  Sounds[sound]->Start();
}
//*******************************************************************

