//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  circlesp.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0    12/23/95    M.Perry    moved inline functions into .cpp file.
//  2.0    09/23/97    M.Perry    32-bit conversion.
//********************************************************************
#include "circlesp.h"
#include "cbjglord.h"
#include "oanm.h"
//*******************************************************************
TCircle::TCircle(TOgleModeWindow *pmw,TFileMode NewFileMode,void *psource)
:TSprite(pmw,NewFileMode,psource)
{
  NoShow();
  SetToManual();
  SetupAnms();
}
//*******************************************************************
TCircle::TCircle(TOgleModeWindow *pmw,TFileMode NewFileMode)
:TSprite(pmw,NewFileMode)
{
  NoShow();
  SetToManual();
  SetupAnms();
}
//********************************************************************
TCircle::~TCircle()
{
}
//*******************************************************************
void TCircle::NoShowCircle()
{
	 PPlayer->NoShow();
}
//*******************************************************************
void TCircle::SetupAnms()
{
  PPlayer = GetAnm(0);
  if (PPlayer == NULL) {AnmError("Circle","sprite",0);}
  PPlayer->CAD.ClearAutoStart();
  PPlayer->CAD.ClearAutoStop();
  PPlayer->CAD.SetDirStill();
}
//*******************************************************************
void TCircle::SetCircle(int16 player,int16 spot)
{
  int16 frame = 0;
  switch(spot)
  {
	 case bjnl1A : frame = int16(1+(player*4));break;
	 case bjnl1B : frame = int16(0+(player*4));break;
	 case bjnl1C : frame = int16(3+(player*4));break;
	 case bjnl2C : frame = int16(1+(player*4));break;
	 case bjnl2D : frame = int16(0+(player*4));break;
	 case bjnl2E : frame = int16(3+(player*4));break;
	 case bjnl3E : frame = int16(1+(player*4));break;
	 case bjnl3F : frame = int16(0+(player*4));break;
	 case bjnl3G : frame = int16(3+(player*4));break;
  }
  PPlayer->CAD.SetCurrentFrame(frame);
  PPlayer->Show();
  Update(GetAdjFUC());
}
//*******************************************************************
void TCircle::SetPart(int16 player,int16 spot)
{
  int16 frame = 0;
  switch(spot)
  {
	 case bjnl1A : frame = int16(1+(player*4));break;
	 case bjnl1B : frame = int16(2+(player*4));break;
	 case bjnl1C : frame = int16(3+(player*4));break;
	 case bjnl2C : frame = int16(1+(player*4));break;
	 case bjnl2D : frame = int16(2+(player*4));break;
	 case bjnl2E : frame = int16(3+(player*4));break;
	 case bjnl3E : frame = int16(1+(player*4));break;
	 case bjnl3F : frame = int16(2+(player*4));break;
	 case bjnl3G : frame = int16(3+(player*4));break;

  }
  PPlayer->CAD.SetCurrentFrame(frame);
  PPlayer->Show();
  Update(GetAdjFUC());
}
//*******************************************************************