//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  casnames.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     10/2/95    M.Perry     original baseline
//  1.1     10/27/95   M.Perry     created class.
//********************************************************************
#include "casnames.h"

TCasinoNames *PCasNames;
//*******************************************************************
TCasinoNames::TCasinoNames()
{
  CasinoGame          = "casino";
  BlackJackOneMode    = "e1bj1";
  //BlackJackTwoMode = "";
  //BlackJackFourMode = "";
  //BlackJackSixMode = "";
  CrapsMode           = "";
  KenoMode            = "";
  RouletteMode        = "";
  SlotsAladdinMode    = "";
  SlotsCaliforniaMode = "";
  SlotsPirateMode     = "";
  SlotsLuckyMode      = "";
  SlotsSpiritMode     = "";
  SlotsJokersMode     = "";
  SlotsTotalMode      = "";
  SlotsCherryMode     = "";
  VPTen1Mode          = "c1vptb";
  VPTen5Mode          = "c2vptb";
  VPTen100Mode        = "c3vptb";
  VPTen1000Mode       = "c4vptb";
  VPJack1Mode         = "d1vpjb";
  VPJack5Mode         = "d2vpjb";
  VPJack100Mode       = "d3vpjb";
  VPJack1000Mode      = "d4vpjb";
  VPJack1PMode        = "d5vpjb";
  VPDWild1Mode        = "a1vpdwld";
  VPDWild5Mode        = "a2vpdwld";
  VPDWild100Mode      = "a3vpdwld";
  VPDWild1000Mode     = "a4vpdwld";
  VPJWild1Mode        = "b1vpjwld";
  VPJWild5Mode        = "b2vpjwld";
  VPJWild100Mode      = "b3vpjwld";
  VPJWild1000Mode     = "b4vpjwld";
}
//*******************************************************************
void TCasinoNames::SetToWalkAbout()
{
}
//*******************************************************************
void TCasinoNames::SetToBJ1()
{
  GreetPlayer          = "e100kca0";
  PlaceBets            = "e100kca2";
  Shuffle              = "e100kca1";
  PreDealCom           = "e100kca3";
  DeclarePlayer1BJ     = "e100kcb0";
  DeclarePlayer2BJ     = "e100kcb1";
  DeclarePlayer3BJ     = "e100kcb2";
  PromptInsurance      = "e100kcc0";
  DealerBJ             = "e100kcd0";
  DealerNoBJ           = "e100kcd1";
  Stalling1A           = "e100kce1";
  Stalling1B           = "e100kce2";
  Stalling1C           = "e100kce3";
  Stalling2C           = "e100kce4";
  Stalling2D           = "e100kce5";
  Stalling2E           = "e100kce6";
  Stalling3E           = "e100kce7";
  Stalling3F           = "e100kce8";
  Stalling3G           = "e100kce9";
  DoubleComPlayer1     = "e100kcf0";
  DoubleComPlayer2     = "e100kcf1";
  DoubleComPlayer3     = "e100kcf2";
  HitComPlayer1        = "e100kch0";
  HitComPlayer2        = "e100kch1";
  HitComPlayer3        = "e100kch2";
  StandComPlayer1      = "e100kci0";
  StandComPlayer2      = "e100kci1";
  StandComPlayer3      = "e100kci2";
  AnnouncePlayer1Total = "e100kcj0";
  AnnouncePlayer2Total = "e100kcj1";
  AnnouncePlayer3Total = "e100kcj2";
  AnnounceDealerTotal  = "e100kcs0";
  AnnounceDealerBust   = "e100kcs1";
  Player1Bust          = "e100kck0";
  Player2Bust          = "e100kck1";
  Player3Bust          = "e100kck2";
  AcceptTipPlayer1     = "e100kcl0";
  AcceptTipPlayer2     = "e100kcl1";
  AcceptTipPlayer3     = "e100kcl2";
  Winner1              = "e100kcm0";
  Winner2              = "e100kcm1";
  Winner3              = "e100kcm2";
  Push1                = "e100kcn0";
  Push2                = "e100kcn1";
  Push3                = "e100kcn2";
  Loser1               = "e100kco0";
  Loser2               = "e100kco1";
  Loser3               = "e100kco2";
  PostReconcileCom     = "e100kcp0";
  GetTrayDiscards      = "e100kcq0";

  GameLord      = "e1glrd00";
  Human1        = "e1humn01";
  Human2        = "e1humn02";
  Human3        = "e1humn03";

  Button0Name   = "e100b000";
  Button1Name   = "e100b100";
  Button2Name   = "e100b200";
  Button3Name   = "e100b300";
  Button4Name   = "e100b400";
  Button5Name   = "e100b500";

  ChipsName     = "e100ch00";
  NamePlateName = "e100nt00";
  BJBetSpot0    = "e100bs00";
  BJBetSpot1    = "e100bs01";
  BJBetSpot2    = "e100bs02";
  BJBetSpot3    = "e100bs03";
  BJBetSpot4    = "e100bs04";
  BJBetSpot5    = "e100bs05";
  BJBetSpot6    = "e100bs06";
  BJDealerSpot  = "e100ds00";

  StatusBarName = "e100sb00";

  DealCard1A = "e100dc1a";
  DealCard1B = "e100dc1b";
  DealCard1C = "e100dc1c";
  DealCard2C = "e100dc2c";
  DealCard2D = "e100dc2d";
  DealCard2E = "e100dc2e";
  DealCard3E = "e100dc3e";
  DealCard3F = "e100dc3f";
  DealCard3G = "e100dc3g";
  DealerUp = "e100dc00";
  DealerDown = "e100dc01";

  DealerCheckHoleCard = "e100hc00";
  DealerExposesHoleCard = "e100hc01";

  LookFrom0To1 = "e100lf01";
  LookFrom0To2 = "e100lf02";
  LookFrom0To3 = "e100lf03";
  LookFrom1To2 = "e100lf12";
  LookFrom2To3 = "e100lf23";
  LookFrom1To0 = "e100lf10";
  LookFrom2To0 = "e100lf20";
  LookFrom3To0 = "e100lf30";

  PromptAction1A = "e100pa1a";
  PromptAction1B = "e100pa1b";
  PromptAction1C = "e100pa1c";
  PromptAction2C = "e100pa2c";
  PromptAction2D = "e100pa2d";
  PromptAction2E = "e100pa2e";
  PromptAction3E = "e100pa3e";
  PromptAction3F = "e100pa3f";
  PromptAction3G = "e100pa3g";

  HitFingersM1A = "e100hm1a";
  HitFingersM1B = "e100hm1b";
  HitFingersM1C = "e100hm1c";
  HitFingersM2C = "e100hm2c";
  HitFingersM2D = "e100hm2d";
  HitFingersM2E = "e100hm2e";
  HitFingersM3E = "e100hm3e";
  HitFingersM3F = "e100hm3f";
  HitFingersM3G = "e100hm3g";
  HitFingersF1A = "e100hf1a";
  HitFingersF1B = "e100hf1b";
  HitFingersF1C = "e100hf1c";
  HitFingersF2C = "e100hf2c";
  HitFingersF2D = "e100hf2d";
  HitFingersF2E = "e100hf2e";
  HitFingersF3E = "e100hf3e";
  HitFingersF3F = "e100hf3f";
  HitFingersF3G = "e100hf3g";

  StandFingersM1A = "e100sm1a";
  StandFingersM1B = "e100sm1b";
  StandFingersM1C = "e100sm1c";
  StandFingersM2C = "e100sm2c";
  StandFingersM2D = "e100sm2d";
  StandFingersM2E = "e100sm2e";
  StandFingersM3E = "e100sm3e";
  StandFingersM3F = "e100sm3f";
  StandFingersM3G = "e100sm3g";
  StandFingersF1A = "e100sf1a";
  StandFingersF1B = "e100sf1b";
  StandFingersF1C = "e100sf1c";
  StandFingersF2C = "e100sf2c";
  StandFingersF2D = "e100sf2d";
  StandFingersF2E = "e100sf2e";
  StandFingersF3E = "e100sf3e";
  StandFingersF3F = "e100sf3f";
  StandFingersF3G = "e100sf3g";
}
//*******************************************************************
void TCasinoNames::SetToBJ2()
{
}
//*******************************************************************
void TCasinoNames::SetToBJ4()
{
}
//*******************************************************************
void TCasinoNames::SetToBJ6()
{
}
//*******************************************************************
void TCasinoNames::SetToCraps()
{
}
//*******************************************************************
void TCasinoNames::SetToKeno()
{
}
//*******************************************************************
void TCasinoNames::SetToRoulette()
{
}
//*******************************************************************
void TCasinoNames::SetToSlotsAladdin()
{
}
//*******************************************************************
void TCasinoNames::SetToSlotsCalifornia()
{
}
//*******************************************************************
void TCasinoNames::SetToSlotsPirate()
{
}
//*******************************************************************
void TCasinoNames::SetToSlotsLucky()
{
}
//*******************************************************************
void TCasinoNames::SetToSlotsSpirit()
{
}
//*******************************************************************
void TCasinoNames::SetToSlotsJokers()
{
}
//*******************************************************************
void TCasinoNames::SetToSlotsTotal()
{
}
//*******************************************************************
void TCasinoNames::SetToSlotsCherry()
{
}
//*******************************************************************
void TCasinoNames::SetToVPDW1()
{
  VPGameType    = gt2Wild;
  VPCoinSize    = 1;
  GameLord      = "a1glrd00";
  Human1        = "a1humn01";
  Human2        = "a1humn02";
  Human3        = "a1humn03";

  VPCard1       = "a100cd00";
  VPCard2       = "a100cd01";
  VPCard3       = "a100cd02";
  VPCard4       = "a100cd03";
  VPCard5       = "a100cd04";

  VPCoinsPlayed = "a100cp00";
  VPWinPaid     = "a100wp00";
  VPCredits     = "a100cr00";
  VPWinRatio    = "a100wr00";

  Button0Name   = "a100b000";
  Button1Name   = "a100b100";
  Button2Name   = "a100b200";
  Button3Name   = "a100b300";
  Button4Name   = "a100b400";
  Button5Name   = "a100b500";

  StatusBarName = "a100sb00";
  ChipsName     = "a100ch00";
  NamePlateName = "a100nt00";
}
//*******************************************************************
void TCasinoNames::SetToVPDW5()
{
  VPGameType    = gt2Wild;
  VPCoinSize    = 5;
  GameLord    = "a2glrd00";
  Human1      = "a2humn01";
  Human2      = "a2humn02";
  Human3      = "a2humn03";

  VPCard1       = "a200cd00";
  VPCard2       = "a200cd01";
  VPCard3       = "a200cd02";
  VPCard4       = "a200cd03";
  VPCard5       = "a200cd04";

  VPCoinsPlayed = "a200cp00";
  VPWinPaid     = "a200wp00";
  VPCredits     = "a200cr00";
  VPWinRatio    = "a200wr00";

  Button0Name   = "a200b000";
  Button1Name   = "a200b100";
  Button2Name   = "a200b200";
  Button3Name   = "a200b300";
  Button4Name   = "a200b400";
  Button5Name   = "a200b500";

  StatusBarName = "a200sb00";
  ChipsName     = "a200ch00";
  NamePlateName = "a200nt00";
}
//*******************************************************************
void TCasinoNames::SetToVPDW100()
{
  VPGameType    = gt2Wild;
  VPCoinSize    = 100;
  GameLord    = "a3glrd00";
  Human1      = "a3humn01";
  Human2      = "a3humn02";
  Human3      = "a3humn03";

  VPCard1       = "a300cd00";
  VPCard2       = "a300cd01";
  VPCard3       = "a300cd02";
  VPCard4       = "a300cd03";
  VPCard5       = "a300cd04";

  VPCoinsPlayed = "a300cp00";
  VPWinPaid     = "a300wp00";
  VPCredits     = "a300cr00";
  VPWinRatio    = "a300wr00";

  Button0Name   = "a300b000";
  Button1Name   = "a300b100";
  Button2Name   = "a300b200";
  Button3Name   = "a300b300";
  Button4Name   = "a300b400";
  Button5Name   = "a300b500";

  StatusBarName = "a300sb00";
  ChipsName     = "a300ch00";
  NamePlateName = "a300nt00";
}
//*******************************************************************
void TCasinoNames::SetToVPDW1000()
{
  VPGameType    = gt2Wild;
  VPCoinSize    = 1000;
  GameLord    = "a4glrd00";
  Human1      = "a4humn01";
  Human2      = "a4humn02";
  Human3      = "a4humn03";

  VPCard1       = "a400cd00";
  VPCard2       = "a400cd01";
  VPCard3       = "a400cd02";
  VPCard4       = "a400cd03";
  VPCard5       = "a400cd04";

  VPCoinsPlayed = "a400cp00";
  VPWinPaid     = "a400wp00";
  VPCredits     = "a400cr00";
  VPWinRatio    = "a400wr00";

  Button0Name   = "a400b000";
  Button1Name   = "a400b100";
  Button2Name   = "a400b200";
  Button3Name   = "a400b300";
  Button4Name   = "a400b400";
  Button5Name   = "a400b500";

  StatusBarName = "a400sb00";
  ChipsName     = "a400ch00";
  NamePlateName = "a400nt00";
}
//*******************************************************************
void TCasinoNames::SetToVPJW1()
{
  VPGameType    = gtJWild;
  VPCoinSize    = 1;
  GameLord    = "b1glrd00";
  Human1      = "b1humn01";
  Human2      = "b1humn02";
  Human3      = "b1humn03";

  VPCard1       = "b100cd00";
  VPCard2       = "b100cd01";
  VPCard3       = "b100cd02";
  VPCard4       = "b100cd03";
  VPCard5       = "b100cd04";

  VPCoinsPlayed = "b100cp00";
  VPWinPaid     = "b100wp00";
  VPCredits     = "b100cr00";
  VPWinRatio    = "b100wr00";

  Button0Name   = "b100b000";
  Button1Name   = "b100b100";
  Button2Name   = "b100b200";
  Button3Name   = "b100b300";
  Button4Name   = "b100b400";
  Button5Name   = "b100b500";

  StatusBarName = "b100sb00";
  ChipsName     = "b100ch00";
  NamePlateName = "b100nt00";
}
//*******************************************************************
void TCasinoNames::SetToVPJW5()
{
   VPGameType    = gtJWild;
  VPCoinSize    = 5;
  GameLord    = "b2glrd00";
  Human1      = "b2humn01";
  Human2      = "b2humn02";
  Human3      = "b2humn03";

  VPCard1       = "b200cd00";
  VPCard2       = "b200cd01";
  VPCard3       = "b200cd02";
  VPCard4       = "b200cd03";
  VPCard5       = "b200cd04";

  VPCoinsPlayed = "b200cp00";
  VPWinPaid     = "b200wp00";
  VPCredits     = "b200cr00";
  VPWinRatio    = "b200wr00";

  Button0Name   = "b200b000";
  Button1Name   = "b200b100";
  Button2Name   = "b200b200";
  Button3Name   = "b200b300";
  Button4Name   = "b200b400";
  Button5Name   = "b200b500";

  StatusBarName = "b200sb00";
  ChipsName     = "b200ch00";
  NamePlateName = "b200nt00";
}
//*******************************************************************
void TCasinoNames::SetToVPJW100()
{
  VPGameType    = gtJWild;
  VPCoinSize    = 100;
  GameLord    = "b3glrd00";
  Human1      = "b3humn01";
  Human2      = "b3humn02";
  Human3      = "b3humn03";

  VPCard1       = "b300cd00";
  VPCard2       = "b300cd01";
  VPCard3       = "b300cd02";
  VPCard4       = "b300cd03";
  VPCard5       = "b300cd04";

  VPCoinsPlayed = "b300cp00";
  VPWinPaid     = "b300wp00";
  VPCredits     = "b300cr00";
  VPWinRatio    = "b300wr00";

  Button0Name   = "b300b000";
  Button1Name   = "b300b100";
  Button2Name   = "b300b200";
  Button3Name   = "b300b300";
  Button4Name   = "b300b400";
  Button5Name   = "b300b500";

  StatusBarName = "b300sb00";
  ChipsName     = "b300ch00";
  NamePlateName = "b300nt00";
}
//*******************************************************************
void TCasinoNames::SetToVPJW1000()
{
  VPGameType    = gtJWild;
  VPCoinSize    = 1000;
  GameLord    = "b4glrd00";
  Human1      = "b4humn01";
  Human2      = "b4humn02";
  Human3      = "b4humn03";

  VPCard1       = "b400cd00";
  VPCard2       = "b400cd01";
  VPCard3       = "b400cd02";
  VPCard4       = "b400cd03";
  VPCard5       = "b400cd04";

  VPCoinsPlayed = "b400cp00";
  VPWinPaid     = "b400wp00";
  VPCredits     = "b400cr00";
  VPWinRatio    = "b400wr00";

  Button0Name   = "b400b000";
  Button1Name   = "b400b100";
  Button2Name   = "b400b200";
  Button3Name   = "b400b300";
  Button4Name   = "b400b400";
  Button5Name   = "b400b500";

  StatusBarName = "b400sb00";
  ChipsName     = "b400ch00";
  NamePlateName = "b400nt00";
}
//*******************************************************************
void TCasinoNames::SetToVPTB1()
{
  VPGameType    = gtTens;
  VPCoinSize    = 1;
  GameLord    = "c1glrd00";
  Human1      = "c1humn01";
  Human2      = "c1humn02";
  Human3      = "c1humn03";

  VPCard1       = "c100cd00";
  VPCard2       = "c100cd01";
  VPCard3       = "c100cd02";
  VPCard4       = "c100cd03";
  VPCard5       = "c100cd04";

  VPCoinsPlayed = "c100cp00";
  VPWinPaid     = "c100wp00";
  VPCredits     = "c100cr00";
  VPWinRatio    = "c100wr00";

  Button0Name   = "c100b000";
  Button1Name   = "c100b100";
  Button2Name   = "c100b200";
  Button3Name   = "c100b300";
  Button4Name   = "c100b400";
  Button5Name   = "c100b500";

  StatusBarName = "c100sb00";
  ChipsName     = "c100ch00";
  NamePlateName = "c100nt00";
}
//*******************************************************************
void TCasinoNames::SetToVPTB5()
{
   VPGameType    = gtTens;
  VPCoinSize    = 5;
  GameLord    = "c2glrd00";
  Human1      = "c2humn01";
  Human2      = "c2humn02";
  Human3      = "c2humn03";

  VPCard1       = "c200cd00";
  VPCard2       = "c200cd01";
  VPCard3       = "c200cd02";
  VPCard4       = "c200cd03";
  VPCard5       = "c200cd04";

  VPCoinsPlayed = "c200cp00";
  VPWinPaid     = "c200wp00";
  VPCredits     = "c200cr00";
  VPWinRatio    = "c200wr00";

  Button0Name   = "c200b000";
  Button1Name   = "c200b100";
  Button2Name   = "c200b200";
  Button3Name   = "c200b300";
  Button4Name   = "c200b400";
  Button5Name   = "c200b500";

  StatusBarName = "c200sb00";
  ChipsName     = "c200ch00";
  NamePlateName = "c200nt00";
}
//*******************************************************************
void TCasinoNames::SetToVPTB100()
{
  VPGameType    = gtTens;
  VPCoinSize    = 100;
  GameLord      = "c3glrd00";
  Human1        = "c3humn01";
  Human2        = "c3humn02";
  Human3        = "c3humn03";

  VPCard1       = "c300cd00";
  VPCard2       = "c300cd01";
  VPCard3       = "c300cd02";
  VPCard4       = "c300cd03";
  VPCard5       = "c300cd04";

  VPCoinsPlayed = "c300cp00";
  VPWinPaid     = "c300wp00";
  VPCredits     = "c300cr00";
  VPWinRatio    = "c300wr00";

  Button0Name   = "c300b000";
  Button1Name   = "c300b100";
  Button2Name   = "c300b200";
  Button3Name   = "c300b300";
  Button4Name   = "c300b400";
  Button5Name   = "c300b500";

  StatusBarName = "c300sb00";
  ChipsName     = "c300ch00";
  NamePlateName = "c300nt00";
}
//*******************************************************************
void TCasinoNames::SetToVPTB1000()
{
  VPGameType    = gtTens;
  VPCoinSize    = 1000;
  GameLord    = "c4glrd00";
  Human1      = "c4humn01";
  Human2      = "c4humn02";
  Human3      = "c4humn03";

  VPCard1       = "c400cd00";
  VPCard2       = "c400cd01";
  VPCard3       = "c400cd02";
  VPCard4       = "c400cd03";
  VPCard5       = "c400cd04";

  VPCoinsPlayed = "c400cp00";
  VPWinPaid     = "c400wp00";
  VPCredits     = "c400cr00";
  VPWinRatio    = "c400wr00";

  Button0Name   = "c400b000";
  Button1Name   = "c400b100";
  Button2Name   = "c400b200";
  Button3Name   = "c400b300";
  Button4Name   = "c400b400";
  Button5Name   = "c400b500";

  StatusBarName = "c400sb00";
  ChipsName     = "c400ch00";
  NamePlateName = "c400nt00";
}
//*******************************************************************
void TCasinoNames::SetToVPJB1()
{
  VPGameType    = gtJacks;
  VPCoinSize    = 1;
  GameLord    = "d1glrd00";
  Human1      = "d1humn01";
  Human2      = "d1humn02";
  Human3      = "d1humn03";

  VPCard1       = "d100cd00";
  VPCard2       = "d100cd01";
  VPCard3       = "d100cd02";
  VPCard4       = "d100cd03";
  VPCard5       = "d100cd04";

  VPCoinsPlayed = "d100cp00";
  VPWinPaid     = "d100wp00";
  VPCredits     = "d100cr00";
  VPWinRatio    = "d100wr00";

  Button0Name   = "d100b000";
  Button1Name   = "d100b100";
  Button2Name   = "d100b200";
  Button3Name   = "d100b300";
  Button4Name   = "d100b400";
  Button5Name   = "d100b500";

  StatusBarName = "d100sb00";
  ChipsName     = "d100ch00";
  NamePlateName = "d100nt00";
}
//*******************************************************************
void TCasinoNames::SetToVPJB5()
{
  VPGameType    = gtJacks;
  VPCoinSize    = 5;
  GameLord    = "d2glrd00";
  Human1      = "d2humn01";
  Human2      = "d2humn02";
  Human3      = "d2humn03";

  VPCard1       = "d200cd00";
  VPCard2       = "d200cd01";
  VPCard3       = "d200cd02";
  VPCard4       = "d200cd03";
  VPCard5       = "d200cd04";

  VPCoinsPlayed = "d200cp00";
  VPWinPaid     = "d200wp00";
  VPCredits     = "d200cr00";
  VPWinRatio    = "d200wr00";

  Button0Name   = "d200b000";
  Button1Name   = "d200b100";
  Button2Name   = "d200b200";
  Button3Name   = "d200b300";
  Button4Name   = "d200b400";
  Button5Name   = "d200b500";

  StatusBarName = "d200sb00";
  ChipsName     = "d200ch00";
  NamePlateName = "d200nt00";
}
//*******************************************************************
void TCasinoNames::SetToVPJB100()
{
  VPGameType    = gtJacks;
  VPCoinSize    = 100;
  GameLord    = "d3glrd00";
  Human1      = "d3humn01";
  Human2      = "d3humn02";
  Human3      = "d3humn03";

  VPCard1       = "d300cd00";
  VPCard2       = "d300cd01";
  VPCard3       = "d300cd02";
  VPCard4       = "d300cd03";
  VPCard5       = "d300cd04";

  VPCoinsPlayed = "d300cp00";
  VPWinPaid     = "d300wp00";
  VPCredits     = "d300cr00";
  VPWinRatio    = "d300wr00";

  Button0Name   = "d300b000";
  Button1Name   = "d300b100";
  Button2Name   = "d300b200";
  Button3Name   = "d300b300";
  Button4Name   = "d300b400";
  Button5Name   = "d300b500";

  StatusBarName = "d300sb00";
  ChipsName     = "d300ch00";
  NamePlateName = "d300nt00";
}
//*******************************************************************
void TCasinoNames::SetToVPJB1000()
{
  VPGameType    = gtJacks;
  VPCoinSize    = 1000;
  GameLord    = "d4glrd00";
  Human1      = "d4humn01";
  Human2      = "d4humn02";
  Human3      = "d4humn03";

  VPCard1       = "d400cd00";
  VPCard2       = "d400cd01";
  VPCard3       = "d400cd02";
  VPCard4       = "d400cd03";
  VPCard5       = "d400cd04";

  VPCoinsPlayed = "d400cp00";
  VPWinPaid     = "d400wp00";
  VPCredits     = "d400cr00";
  VPWinRatio    = "d400wr00";

  Button0Name   = "d400b000";
  Button1Name   = "d400b100";
  Button2Name   = "d400b200";
  Button3Name   = "d400b300";
  Button4Name   = "d400b400";
  Button5Name   = "d400b500";

  StatusBarName = "d400sb00";
  ChipsName     = "d400ch00";
  NamePlateName = "d400nt00";
}
//*******************************************************************
void TCasinoNames::SetToVPJB1P()
{
  VPGameType    = gtJacksProg;
  VPCoinSize    = 1;
  GameLord    = "d5glrd00";
  Human1      = "d5humn01";
  Human2      = "d5humn02";
  Human3      = "d5humn03";

  VPCard1       = "d500cd00";
  VPCard2       = "d500cd01";
  VPCard3       = "d500cd02";
  VPCard4       = "d500cd03";
  VPCard5       = "d500cd04";

  VPCoinsPlayed = "d500cp00";
  VPWinPaid     = "d500wp00";
  VPCredits     = "d500cr00";
  VPWinRatio    = "d500wr00";

  Button0Name   = "d500b000";
  Button1Name   = "d500b100";
  Button2Name   = "d500b200";
  Button3Name   = "d500b300";
  Button4Name   = "d500b400";
  Button5Name   = "d500b500";

  StatusBarName = "d500sb00";
  ChipsName     = "d500ch00";
  NamePlateName = "d500nt00";
}
//*******************************************************************

