//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  cgobj.cpp
//    Project Name:  Ogle
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     08/2/95   A. Krist    Original baseline
//*******************************************************************
#include "cgobj.h"
#include "craphead.h"
#include "iostream.h"
//#include "gomstate.h"
#include <stdio.h>

TCGObj::TCGObj()
{
  int i=0;
  //pGObj  = new TGObjMainState(this);
  cash = 1000;
  currentbets = 0;
  for(i=0;i<MAXBETS;i++)
  {
	 Bets[i] = NULL;
  }
  top = 0;
}
//*******************************************************************
TCGObj::~TCGObj()
{
  int i=0;
  for(i=0;i<MAXBETS;i++)
  {
	 if(Bets[i] != NULL)
	 {
		delete Bets[i];
		Bets[i] = NULL;
	 }
  }
  top = 0;
}
//*******************************************************************
TCGObj::AddBet(TCSpot betspot,int coins)
{
  int i;
  if(top == MAXBETS){return 0;}
  for(i=0;i<MAXBETS;i++)
  {
	 if(Bets[i] == NULL)
	 {
		break;
	 }
  }
  if(i == MAXBETS)
  {
	 return -1;
  }
  //cash -= coins;
  switch (betspot) {
	case COMEBET    : Bets[i] = new TComeBet(COMEBET,coins);currentbets++;top++;return 1;
	case COMENOT    : Bets[i] = new TComeNot(COMENOT,coins);currentbets++;top++;return 1;
	case PASSBET    : Bets[i] = new TPassBet(PASSBET,coins);currentbets++;top++;return 1;
	case PASSNOT    : Bets[i] = new TPassNot(PASSNOT,coins);currentbets++;top++;return 1;
	case PLACEBET4  : Bets[i] = new TPlaceBet(PLACEBET4,4,coins);currentbets++;top++;return 1;
	case PLACEBET5  : Bets[i] = new TPlaceBet(PLACEBET5,5,coins);currentbets++;top++;return 1;
	case PLACEBET6  : Bets[i] = new TPlaceBet(PLACEBET6,6,coins);currentbets++;top++;return 1;
	case PLACEBET8  : Bets[i] = new TPlaceBet(PLACEBET8,8,coins);currentbets++;top++;return 1;
	case PLACEBET9  : Bets[i] = new TPlaceBet(PLACEBET9,9,coins);currentbets++;top++;return 1;
	case PLACEBET10 : Bets[i] = new TPlaceBet(PLACEBET10,10,coins);currentbets++;top++;return 1;
	case BUYBET4    : Bets[i] = new TBuyBet(BUYBET4,4,coins);currentbets++;top++;Commission(coins);return 1;
	case BUYBET5    : Bets[i] = new TBuyBet(BUYBET5,5,coins);currentbets++;top++;Commission(coins);return 1;
	case BUYBET6    : Bets[i] = new TBuyBet(BUYBET6,6,coins);currentbets++;top++;Commission(coins);return 1;
	case BUYBET8    : Bets[i] = new TBuyBet(BUYBET8,8,coins);currentbets++;top++;Commission(coins);return 1;
	case BUYBET9    : Bets[i] = new TBuyBet(BUYBET9,9,coins);currentbets++;top++;Commission(coins);return 1;
	case BUYBET10   : Bets[i] = new TBuyBet(BUYBET10,10,coins);currentbets++;top++;Commission(coins);return 1;
	case LAYBET4    : Bets[i] = new TLayBet(LAYBET4,4,coins);currentbets++;top++;LayCommission(coins,1);return 1;
	case LAYBET5    : Bets[i] = new TLayBet(LAYBET5,5,coins);currentbets++;top++;LayCommission(coins,2);return 1;
	case LAYBET6    : Bets[i] = new TLayBet(LAYBET6,6,coins);currentbets++;top++;LayCommission(coins,3);return 1;
	case LAYBET8    : Bets[i] = new TLayBet(LAYBET8,8,coins);currentbets++;top++;LayCommission(coins,3);return 1;
	case LAYBET9    : Bets[i] = new TLayBet(LAYBET9,9,coins);currentbets++;top++;LayCommission(coins,2);return 1;
	case LAYBET10   : Bets[i] = new TLayBet(LAYBET10,10,coins);currentbets++;top++;LayCommission(coins,1);return 1;

	case ADDFREE4   : return AddFreeOdds(4,coins,1);
	case ADDFREE5   : return AddFreeOdds(5,coins,2);
	case ADDFREE6   : return AddFreeOdds(6,coins,5);
	case ADDFREE8   : return AddFreeOdds(8,coins,5);
	case ADDFREE9   : return AddFreeOdds(9,coins,2);
	case ADDFREE10  : return AddFreeOdds(10,coins,1);

	case ADDNOT4    : return AddFreeOdds(4,coins,2);
	case ADDNOT5    : return AddFreeOdds(5,coins,3);
	case ADDNOT6    : return AddFreeOdds(6,coins,6);
	case ADDNOT8    : return AddFreeOdds(8,coins,6);
	case ADDNOT9    : return AddFreeOdds(9,coins,3);
	case ADDNOT10   : return AddFreeOdds(10,coins,2);

	case REMOVEFREE4   : return RemoveFreeOdds(4);
	case REMOVEFREE5   : return RemoveFreeOdds(5);
	case REMOVEFREE6   : return RemoveFreeOdds(6);
	case REMOVEFREE8   : return RemoveFreeOdds(8);
	case REMOVEFREE9   : return RemoveFreeOdds(9);
	case REMOVEFREE10  : return RemoveFreeOdds(10);

	default    :   return -1;
  }
}
//*******************************************************************
TCGObj::RemoveFreeOdds(int num)
{
  int i=0;
  int x=0;
  int count=0;
  count = top;
  for(i=0;i<MAXBETS && count != 0;i++)
  {
	 if(Bets[i] != NULL)
	 {
		if(Bets[i]->id < 4)
		{
		  if(((TComeBet *)Bets[i])->point == num)
		  {
			 if(((TComeBet *)Bets[i])->freeodds > 0)
			 {
				cout << "You have " << ((TComeBet *)Bets[i])->freeodds <<
						  ". Remove -> ";
				cin >> x;
				((TComeBet *)Bets[i])->freeodds -= x;

				return 1;
			 }
		  }
		}
		count--;
	 }
  }
}
//*******************************************************************
TCGObj::AddFreeOdds(int num,int coin,int oddsnum)
{
  int i=0;
  int count=0;
  count = top;
  for(i=0;i<MAXBETS && count != 0;i++)
  {
	 if(Bets[i] != NULL)
	 {
		if(Bets[i]->id < 4)
		{
		  if(((TComeBet *)Bets[i])->point == num)
		  {
			 if((((TComeBet *)Bets[i])->freeodds + coin) <= 2*Bets[i]->payoff)
			 {
				((TComeBet *)Bets[i])->freeodds += coin;
				return 1;
			 }
			 if( ((2*Bets[i]->payoff)%oddsnum != 0) &&         // odds denominator = oddnum
				  (2*Bets[i]->payoff + (oddsnum - (2*Bets[i]->payoff)%oddsnum) ==
													((TComeBet *)Bets[i])->freeodds + coin) )
			 {
				((TComeBet *)Bets[i])->freeodds += coin;
				return 1;
			 }
			 else
			 {
				cout << "Too Big " << endl;
				return -1;
			 }
		  }
		}
		count--;
	 }
  }
}
//*******************************************************************
TCGObj::Commission(int coins)
{
  cash -= coins/20;
  if(coins%20)
  {
	 cash--;
  }
  return 1;
}
//*******************************************************************
TCGObj::LayCommission(int coins,int odds)
{
  if(odds == 1)
  {
	 cash -= coins/40;
	 if(coins%40)
	 {
		cash--;
	 }
  }
  if(odds == 2)
  {
	 cash -= coins/30;
	 if(coins%30)
	 {
		cash--;
	 }
  }
  if(odds == 3)
  {
	 cash -= coins/24;
	 if(coins%24)
	 {
		cash--;
	 }
  }
  return 1;
}
//*******************************************************************
TCGObj::Winnings(int dice1,int dice2,int comeoutroll)
{
  int i=0;
  int winreturn=0;
  int count=0;
  count = top;
  for(i=0;i<MAXBETS && top != 0 && count != 0;i++)
  {
	 if(Bets[i] != NULL)
	 {
		if(comeoutroll && Bets[i]->onoff == 0)
		{
		}
		else
		{
		  winreturn = Bets[i]->Win(dice1,dice2);
		  if(winreturn > 0)
		  {
          cout << "WinNAW.Winner..." << endl;
			 cash += Bets[i]->payoff + winreturn;
			 delete Bets[i];
			 Bets[i] = NULL;
			 currentbets--;
			 top--;
		  }
		  else
		  {
			 if(winreturn == -1)
			 {
				cout << "Loser,loser,ha ha ha." << endl;
				delete Bets[i];
				Bets[i] = NULL;
				currentbets--;
				top--;
			 }
		  }
		}
      count--;
	 }
  }
  cout << "Total cash -> " << cash << endl;
  return 1;
}
