//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  bet1roll.cpp
//    Project Name:  Ogle
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     05/18/96   A. Krist    Original baseline
//  2.0     09/18/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "bet1roll.h"
#include <assert.h>
//*******************************************************************
TBet1Roll::TBet1Roll(TOgleModeWindow *pmw,const TFileMode &NewFileMode,int16 point,
                     int16 MessageCode)
:TCBetSpot(pmw,NewFileMode,MessageCode)
{
  SpotType = OneRoll;
  RollPoint = point;
}
//*******************************************************************
TBet1Roll::TBet1Roll(TOgleModeWindow *pmw,const TFileMode &NewFileMode,void *psource,
                     int16 point,int16 MessageCode)
:TCBetSpot(pmw,NewFileMode,psource,MessageCode)
{
  SpotType = OneRoll;
  RollPoint = point;
}
//*******************************************************************
TBet1Roll::~TBet1Roll()
{
}
//*******************************************************************
long TBet1Roll::Odds()
{
  switch(RollPoint)
  {
	 case 0  : return 30;
	 case 1  : return 15;
	 case 5  : return 4;
	 case 9  : return 15;
	 case 10 : return 30;
  }
  // MRP 12/21/96
  // I'm assuming we shouldn't hit this.
  assert(false);
  return 1;
}
//*******************************************************************
#pragma argsused
bool TBet1Roll::Winner(int16 FirstDice,int16 SecondDice,int16 Point,bool ComeOut)
  {
	  if( (FirstDice+SecondDice) == RollPoint )
	  {
		 return true;
	  }
	  else
	  {
		 return false;
	  }
  }
//*******************************************************************
#pragma argsused
bool TBet1Roll::Loser(int16 FirstDice,int16 SecondDice,int16 Point,bool ComeOut)
  {
	  if( (FirstDice+SecondDice) != RollPoint )
	  {
		 return true;
	  }
	  else
	  {
		 return false;
	  }
  }
//*******************************************************************