//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  betbuy.cpp
//    Project Name:  Ogle
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     05/18/96   A. Krist    Original baseline
//  2.0     09/18/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "betbuy.h"
#include "oanm.h"
//*******************************************************************
TBetBuy::TBetBuy(TOgleModeWindow *pmw,const TFileMode &NewFileMode,int16 point,
                 int16 MessageCode)
:TCBetSpot(pmw,NewFileMode,MessageCode)
{
  SpotType = Buy;
  BuyPoint = point;
  Bought[0]=false;
  Bought[1]=false;
  Bought[2]=false;
}
//*******************************************************************
TBetBuy::TBetBuy(TOgleModeWindow *pmw,const TFileMode &NewFileMode,void *psource,
                 int16 point,int16 MessageCode)
:TCBetSpot(pmw,NewFileMode,psource,MessageCode)
{
  SpotType = Buy;
  BuyPoint = point;
  Bought[0]=false;
  Bought[1]=false;
  Bought[2]=false;
}
//*******************************************************************
TBetBuy::~TBetBuy()
{
}
//*******************************************************************
TMoney TBetBuy::TrueOdds(TMoney amount,int16 winnum)
{
  return TCBetSpot::TrueOdds(amount,winnum);
}
//*******************************************************************
TMoney TBetBuy::AddBSCash(int16 Slot,TMoney amount,bool ComeOut,int16 Point)
{
  return TCBetSpot::AddBSCash(Slot,amount,ComeOut,Point);
}
//*******************************************************************
void TBetBuy::ClearSpot()
{
  BetAmount[0] = 0l;
  BetAmount[1] = 0l;
  BetAmount[2] = 0l;
  Bought[0]    = false;
  Bought[1]    = false;
  Bought[2]    = false;
  NoShow();
}
//*******************************************************************
#pragma argsused
TMoney TBetBuy::AddBSCash(int16 slot,TMoney amount,bool comeout,int16 point,bool Buy)
{
  if(Buy)
  {
	 Bought[slot] = true;
	 if(MessageCode > 68)
	 {
		MessageCode -= int16(6);
	 }
  }
  else
  {
	 Bought[slot] = false;
	 if(MessageCode < 69)
	 {
		MessageCode += int16(6);
	 }
  }
  BetAmount[slot] += amount;
  SetNum();
  return 0l;
}
//*******************************************************************
int32 TBetBuy::Odds()
{
  return 1;
}
//*******************************************************************
TMoney TBetBuy::WinBSCash(int16 slot,int16 winnum)
{
  TMoney x=0;
  x = TrueOdds(BetAmount[slot],winnum,slot)+BetAmount[slot];
  BetAmount[slot] = 0l;
  return x;
}
//*******************************************************************
TMoney TBetBuy::WinBSPayOff(int16 slot,int16 winnum)
{
  TMoney x=0l;
  x = TrueOdds(BetAmount[slot],winnum,slot);
  return x;
}
//*******************************************************************
#pragma argsused
TMoney TBetBuy::TrueOdds(TMoney amount,int16 winnum,int16 slot)
{
  int32 to,num;//,units;
  TMoney winnings=0l;
  if(Bought[slot])
  {
	 switch(BuyPoint)// or winnum
	 {
		case 2  :  num = 2;to = 1;break;
		case 3  :  num = 3;to = 2;break;
		case 4  :  num = 6;to = 5;break;
		case 6  :  num = 6;to = 5;break;
		case 7  :  num = 3;to = 2;break;
		case 8  :  num = 2;to = 1;break;
		default :  num = 0;to = 1;break;
	 }
  }
  else
  {
	 switch(BuyPoint)// or winnum
	 {
		case 2  :  num = 9;to = 5;break;
		case 3  :  num = 7;to = 5;break;
		case 4  :  num = 7;to = 6;break;
		case 6  :  num = 7;to = 6;break;
		case 7  :  num = 7;to = 5;break;
		case 8  :  num = 9;to = 5;break;
		default :  num = 0;to = 1;break;
	 }
  }
  winnings = (amount*num)/to;
  if(Bought[slot])
  {
	 winnings = ((amount*num*20l)-(amount*to))/(to*20l); //subtract 5% commission
  }
  return winnings;
}
//*******************************************************************
#pragma argsused
bool TBetBuy::Winner(int16 FirstDice,int16 SecondDice,int16 Point,bool ComeOut,
                     bool Buy4n10,bool Buy5n9,bool Buy6n8,bool ComeFreeOdds,
                     bool DoNotComeFreeOdds,bool BuyPlaceOn,bool HardWaysOn)
{
  if(ComeOut && !BuyPlaceOn){return false;}
  if(FirstDice+SecondDice == BuyPoint)
  {
	 return true;
  }
  else
  {
	 return false;
  }
}
//*******************************************************************
#pragma argsused
bool TBetBuy::Loser(int16 FirstDice,int16 SecondDice,int16 Point,bool ComeOut,
                    bool Buy4n10,bool Buy5n9,bool Buy6n8,bool ComeFreeOdds,
                    bool DoNotComeFreeOdds,bool BuyPlaceOn,bool HardWaysOn)
{
	if(ComeOut && !BuyPlaceOn){return false;}
	if(FirstDice+SecondDice == 5)
	{
	  return true;
	}
	else
	{
	  return false;
	}
}
//*******************************************************************
#pragma argsused
bool TBetBuy::Winner(int16 FirstDice,int16 SecondDice,int16 Point,bool ComeOut)
  {
	  if( (FirstDice+SecondDice) == BuyPoint )
	  {
		 return true;
	  }
	  else
	  {
		 return false;
	  }
  }
//*******************************************************************
#pragma argsused
bool TBetBuy::Loser(int16 FirstDice,int16 SecondDice,int16 Point,bool ComeOut)
  {
	  if( (FirstDice+SecondDice) == 5 )
	  {
		 return true;
	  }
	  else
	  {
		 return false;
	  }
  }
//*******************************************************************
void TBetBuy::SetNum()
{
  if (NotFound) {return;}
  int16 xoffset,yoffset,zoffset,i;
  int32 num;
  yoffset   = PChips[0][0]->SAD.GetY();
  zoffset   = PChips[0][0]->SAD.GetZ();
  xoffset   = PChips[0][0]->SAD.GetX();
	for(i=0;i<3;i++)
  {
	 if(xoffset != PChips[i][0]->SAD.GetX())
	 {
		yoffset = PChips[i][0]->SAD.GetY();
		zoffset = PChips[i][0]->SAD.GetZ();
	 }
	 num = (int32)BetAmount[i];
	 num = num%100001l;
	 zoffset += i;
	 int32 tenthous = num / 10000;
	 int32 tenthousvalue = tenthous * 10000;
	 int32 thous = (num - tenthousvalue) / 1000;
	 int32 thousvalue = thous * 1000;
	 int32 huns = (num - tenthousvalue - thousvalue) / 100;
	 int32 hunsvalue = huns * 100;
	 int32 twfive = (num - tenthousvalue - thousvalue - hunsvalue) / 25;
	 int32 twfivevalue = twfive * 25;
	 int32 fives = (num - tenthousvalue - thousvalue - hunsvalue - twfivevalue) / 5;
	 int32 fivesvalue = fives * 5;
	 int32 ones = (num - tenthousvalue - thousvalue - hunsvalue - twfivevalue - fivesvalue);


	 if (tenthous)
	 {
		PChips[i][5]->CAD.SetY(yoffset);
		PChips[i][5]->CAD.SetZ(zoffset);

		PChips[i][5]->CAD.SetCurrentFrame(int16(tenthous - 1));
		PChips[i][5]->Show();
	 }
	 else {PChips[i][5]->NoShow();}
	 yoffset -= int16(2*tenthous);
	 zoffset += int16(tenthous);

	 if (thous)
	 {
		PChips[i][4]->CAD.SetY(yoffset);
		PChips[i][4]->CAD.SetZ(zoffset);

		PChips[i][4]->CAD.SetCurrentFrame(int16(thous - 1));
		PChips[i][4]->Show();
	 }
	 else {PChips[i][4]->NoShow();}
	 yoffset -= int16(2*thous);
	 zoffset += int16(thous);

	 if (huns)
	 {
		PChips[i][3]->CAD.SetY(yoffset);
		PChips[i][3]->CAD.SetZ(zoffset);

		PChips[i][3]->CAD.SetCurrentFrame(int16(huns - 1));
		PChips[i][3]->Show();
	 }
	 else {PChips[i][3]->NoShow();}
	 yoffset -= int16(2*huns);
	 zoffset += int16(huns);

	 if (twfive)
	 {
		PChips[i][2]->CAD.SetY(yoffset);
		PChips[i][2]->CAD.SetZ(zoffset);

		PChips[i][2]->CAD.SetCurrentFrame(int16(twfive - 1));
		PChips[i][2]->Show();
	 }
	 else {PChips[i][2]->NoShow();}
	 yoffset -= int16(2*twfive);
	 zoffset += int16(twfive);

	 if (fives)
	 {
		PChips[i][1]->CAD.SetY(yoffset);
		PChips[i][1]->CAD.SetZ(zoffset);

		PChips[i][1]->CAD.SetCurrentFrame(int16(fives - 1));
		PChips[i][1]->Show();
	 }
	 else {PChips[i][1]->NoShow();}
	 yoffset -= int16(2*fives);
	 zoffset += int16(fives);

	 if (ones)
	 {
		PChips[i][0]->CAD.SetY(yoffset);
		PChips[i][0]->CAD.SetZ(zoffset);

		PChips[i][0]->CAD.SetCurrentFrame(int16(ones - 1));
		PChips[i][0]->Show();
	 }
	 else {PChips[i][0]->NoShow();}
	 yoffset -= int16(2*ones);
	 zoffset += int16(ones);

	 if(i==0)
	 {
      TopAY = yoffset;
      TopAZ = zoffset;
    }
	 else if(i==1)
	 {
      TopBY = yoffset;
      TopBZ = zoffset;
    }
	 else if(i==2)
	 {
      TopCY = yoffset;
      TopCZ = zoffset;
    }
	 TopY = yoffset;
	 TopZ = zoffset;
  }
  if(Bought[0] && BetAmount[0] > 0)
  {
    PChits[0]->CAD.SetY(TopAY);
    PChits[0]->CAD.SetZ(int16(TopAZ+1));
    PChits[0]->Show();
  }
  else
  {
    PChits[0]->NoShow();
  }
  if(Bought[1] && BetAmount[1] > 0)
  {
    PChits[1]->CAD.SetY(TopBY);
    PChits[1]->CAD.SetZ(int16(TopBZ+1));
    PChits[1]->Show();
  }
  else
  {
    PChits[1]->NoShow();
  }
  if(Bought[2] && BetAmount[2] > 0)
  {
    PChits[2]->CAD.SetY(TopCY);
    PChits[2]->CAD.SetZ(int16(TopCZ+1));
    PChits[2]->Show();
  }
  else
  {
    PChits[2]->NoShow();
  }
  Update(GetFUC());
}
//*******************************************************************
