//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  betce.cpp
//    Project Name:  Ogle
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     05/18/96   A. Krist    Original baseline
//  2.0     09/18/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "betce.h"
//*******************************************************************
TBetCraps11::TBetCraps11(TOgleModeWindow *pmw,const TFileMode &NewFileMode,
                         int16 MessageCode,bool horn)
:TCBetSpot(pmw,NewFileMode,MessageCode)
{
  SpotType = CE;
  Horn = horn;
}
//*******************************************************************
TBetCraps11::TBetCraps11(TOgleModeWindow *pmw,const TFileMode &NewFileMode,
                         void *psource,int16 MessageCode,bool horn)
:TCBetSpot(pmw,NewFileMode,psource,MessageCode)
{
  SpotType = CE;
  Horn = horn;
}
//*******************************************************************
TBetCraps11::~TBetCraps11()
{
}
//*******************************************************************
int32 TBetCraps11::Odds()
{
  if(Horn)
  {
	 if(WinNum == 0 || WinNum == 10)
	 {
		return 30;
	 }
	 else
	 {
		return 15;
	 }
  }
  else
  {
    if(WinNum == 9)
	 {
		return 15;
	 }
	 else
	 {
		return 7;
	 }
  }
}
//*******************************************************************
#pragma argsused
TMoney TBetCraps11::WinBSCash(int16 slot,int16 winnum)
{
  TMoney x=0l;
  if(Horn)
  {
	 x = ((BetAmount[slot]*Odds())/4l)+BetAmount[slot];
  }
  else
  {
	 x = ((BetAmount[slot]*Odds())/2l)+BetAmount[slot];
  }
	 BetAmount[slot] = 0l;
	 return x;
}
//*******************************************************************
#pragma argsused
TMoney TBetCraps11::WinBSPayOff(int16 slot,int16 winnum)
{
  TMoney x=0l;
  if(Horn)
  {
	 x = ((BetAmount[slot]*Odds())/4l);
  }
  else
  {
	 x = ((BetAmount[slot]*Odds())/2l);
  }
  return x;
}
//*******************************************************************
#pragma argsused
bool TBetCraps11::Winner(int16 FirstDice,int16 SecondDice,int16 Point,bool ComeOut)
  {
	 WinNum = int16(FirstDice+SecondDice);
	  if( ((FirstDice+SecondDice) == 0) ||((FirstDice+SecondDice) == 1) ||
         ((FirstDice+SecondDice) == 10) ||((FirstDice+SecondDice) == 9) )
	  {
		 return true;
	  }
	  else
	  {
		 return false;
	  }
  }
//*******************************************************************
#pragma argsused
bool TBetCraps11::Loser(int16 FirstDice,int16 SecondDice,int16 Point,bool ComeOut)
  {
	  if( ((FirstDice+SecondDice) != 0)&&((FirstDice+SecondDice) != 1)&&
         ((FirstDice+SecondDice) != 10) &&((FirstDice+SecondDice) != 9) )
	  {
		 return true;
	  }
	  else
	  {
		 return false;
	  }
  }
//*******************************************************************