//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  betdpass.cpp
//    Project Name:  Ogle
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     05/18/96   A. Krist    Original baseline
//  2.0     09/18/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "betcnum.h"
#include "oanm.h"
//*******************************************************************
TBetComeNum::TBetComeNum(TOgleModeWindow *pmw,const TFileMode &NewFileMode,
                         int16 point,int16 MessageCode)
:TCBetSpot(pmw,NewFileMode,MessageCode)
{
  SpotType = ComeNum;
  FreeOdds[0]=0l;
  FreeOdds[1]=0l;
  FreeOdds[2]=0l;
  ComePoint=point;
  Setup();
}
//*******************************************************************
TBetComeNum::TBetComeNum(TOgleModeWindow *pmw,const TFileMode &NewFileMode,
                         void *psource,int16 point,int16 MessageCode)
:TCBetSpot(pmw,NewFileMode,psource,MessageCode)
{
  SpotType = ComeNum;
  FreeOdds[0]=0l;
  FreeOdds[1]=0l;
  FreeOdds[2]=0l;
  ComePoint=point;
  Setup();
}
//*******************************************************************
TBetComeNum::~TBetComeNum()
{
}
//*******************************************************************
TMoney TBetComeNum::TrueOdds(TMoney amount,int16 winnum,int16 slot)
{
  return TCBetSpot::TrueOdds(amount,winnum,slot);
}
//*******************************************************************
TMoney TBetComeNum::AddBSCash(int16 Slot,TMoney amount,bool ComeOut,int16 Point,bool Flag)
{
  return TCBetSpot::AddBSCash(Slot,amount,ComeOut,Point,Flag);
}
//*******************************************************************
int16 TBetComeNum::MessCode(int16 player)
{
  if((int32)FreeOdds[player]){return int16(MessageCode+100);}
  return MessageCode;
}
//*******************************************************************
TMoney TBetComeNum::GetBSFreeOdds(int16 slot)
{
  return FreeOdds[slot];
}
//*******************************************************************
#pragma argsused
bool TBetComeNum::IsValidAdd(int16 slot,TMoney amount,bool comeout,int16 point)
{
  if((point == 4 || point == 6) && ((BetAmount[slot]%2l) == 0l) && BetAmount[slot] > 0l)
  {
	 if( ((BetAmount[slot]*2l)-FreeOdds[slot]+BetAmount[slot]/2l) > 0l)
	 {
		return true;
	 }
  }
  else
  {
	 if( ((BetAmount[slot]*2l)-FreeOdds[slot]) > 0l)
	 {
		return true;
	 }
  }
  return false;
}
//*******************************************************************
#pragma argsused
bool TBetComeNum::IsValidRemove(int16 slot,TMoney amount,bool comeout,int16 point)
{
  if(FreeOdds[slot] > 0l){return true;}
  return false;
}
//*******************************************************************
int32 TBetComeNum::Odds()
{
  return 1;
}
//*******************************************************************
void TBetComeNum::ClearSpot()
{
  BetAmount[0] = 0l;
  BetAmount[1] = 0l;
  BetAmount[2] = 0l;
  FreeOdds[0]  = 0l;
  FreeOdds[1]  = 0l;
  FreeOdds[2]  = 0l;
  NoShow();
}
//*******************************************************************
TMoney TBetComeNum::TrueOdds(TMoney amount,int16 winnum)
{
  int32 to,num,units;
  TMoney winnings=0l;
  switch(winnum)
  {
	 case 2  :  num = 2;to = 1;break;
	 case 3  :  num = 3;to = 2;break;
	 case 4  :  num = 6;to = 5;break;
	 case 6  :  num = 6;to = 5;break;
	 case 7  :  num = 3;to = 2;break;
	 case 8  :  num = 2;to = 1;break;
	 default :  num = 0;to = 1;break;
  }
  units =  amount/to;
  winnings = (amount%to) + (units*num);
  return winnings;
}
//*******************************************************************
TMoney TBetComeNum::WinBSCash(int16 slot,int16 winnum)
{
  TMoney x=0l;
  x = (BetAmount[slot]*Odds())+BetAmount[slot]+(TrueOdds(FreeOdds[slot],winnum))+FreeOdds[slot];
  BetAmount[slot] = 0l;
  FreeOdds[slot] = 0l;
  return x;
}
//*******************************************************************
TMoney TBetComeNum::WinBSPayOff(int16 slot,int16 winnum)
{
  TMoney x=0l;
  x = (BetAmount[slot]*Odds())+(TrueOdds(FreeOdds[slot],winnum));
  return x;
}
//*******************************************************************
void TBetComeNum::SetFree(int16 yoff,int16 slot)
{
  if (NotFound) {return;}
  int16 yoffset,zoffset;//,i;
  int32 num;
  yoffset   = yoff;//PChips[0][0]->SAD.GetY();
  zoffset   = PFreeChips[slot][0]->SAD.GetZ();
	 num = (int32)FreeOdds[slot];
	 num = num%100000l;
	 int32 tenthous = num / 10000;
	 int32 tenthousvalue = tenthous * 10000;
	 int32 thous = (num - tenthousvalue) / 1000;
	 int32 thousvalue = thous * 1000;
	 int32 huns = (num - tenthousvalue - thousvalue) / 100;
	 int32 hunsvalue = huns * 100;
	 int32 twfive = (num - tenthousvalue - thousvalue - hunsvalue) / 25;
	 int32 twfivevalue = twfive * 25;
	 int32 fives = (num - tenthousvalue - thousvalue - hunsvalue - twfivevalue) / 5;
	 int32 fivesvalue = fives * 5;
	 int32 ones = (num - tenthousvalue - thousvalue - hunsvalue - twfivevalue - fivesvalue);


	 if (tenthous)
	 {
		PFreeChips[slot][5]->CAD.SetY(yoffset);
		PFreeChips[slot][5]->CAD.SetZ(zoffset);

		PFreeChips[slot][5]->CAD.SetCurrentFrame(int16(tenthous - 1));
		PFreeChips[slot][5]->Show();
	 }
	 else {PFreeChips[slot][5]->NoShow();}
	 yoffset -= int16(2*tenthous);
	 zoffset += int16(tenthous);

	 if (thous)
	 {
		PFreeChips[slot][4]->CAD.SetY(yoffset);
		PFreeChips[slot][4]->CAD.SetZ(zoffset);

		PFreeChips[slot][4]->CAD.SetCurrentFrame(int16(thous - 1));
		PFreeChips[slot][4]->Show();
	 }
	 else {PFreeChips[slot][4]->NoShow();}
	 yoffset -= int16(2*thous);
	 zoffset += int16(thous);

	 if (huns)
	 {
		PFreeChips[slot][3]->CAD.SetY(yoffset);
		PFreeChips[slot][3]->CAD.SetZ(zoffset);

		PFreeChips[slot][3]->CAD.SetCurrentFrame(int16(huns - 1));
		PFreeChips[slot][3]->Show();
	 }
	 else {PFreeChips[slot][3]->NoShow();}
	 yoffset -= int16(2*huns);
	 zoffset += int16(huns);

	 if (twfive)
	 {
		PFreeChips[slot][2]->CAD.SetY(yoffset);
		PFreeChips[slot][2]->CAD.SetZ(zoffset);

		PFreeChips[slot][2]->CAD.SetCurrentFrame(int16(twfive - 1));
		PFreeChips[slot][2]->Show();
	 }
	 else {PFreeChips[slot][2]->NoShow();}
	 yoffset -= int16(2*twfive);
	 zoffset += int16(twfive);

	 if (fives)
	 {
		PFreeChips[slot][1]->CAD.SetY(yoffset);
		PFreeChips[slot][1]->CAD.SetZ(zoffset);

		PFreeChips[slot][1]->CAD.SetCurrentFrame(int16(fives - 1));
		PFreeChips[slot][1]->Show();
	 }
	 else {PFreeChips[slot][1]->NoShow();}
	 yoffset -= int16(2*fives);
	 zoffset += int16(fives);

	 if (ones)
	 {
		PFreeChips[slot][0]->CAD.SetY(yoffset);
		PFreeChips[slot][0]->CAD.SetZ(zoffset);

		PFreeChips[slot][0]->CAD.SetCurrentFrame(int16(ones - 1));
		PFreeChips[slot][0]->Show();
	 }
	 else {PFreeChips[slot][0]->NoShow();}
	 yoffset -= int16(2*ones);
	 zoffset += int16(ones);
	 if(slot==0)
	 {TopAY = yoffset;TopAZ = zoffset;}
	 else if(slot==1)
	 {TopBY = yoffset;TopBZ = zoffset;}
	 else if(slot==2)
	 {TopCY = yoffset;TopCZ = zoffset;}
	 TopY = yoffset;
	 TopZ = zoffset;
}
//*******************************************************************
void TBetComeNum::SetNum()
{
  if (NotFound) {return;}
  int16 xoffset,yoffset,zoffset,i;
  int32 num;
  yoffset   = PChips[0][0]->SAD.GetY();
  zoffset   = PChips[0][0]->SAD.GetZ();
  xoffset   = PChips[0][0]->SAD.GetX();
	for(i=0;i<3;i++)
  {
	 if(xoffset != PChips[i][0]->SAD.GetX())
	 {
		yoffset = PChips[i][0]->SAD.GetY();
		zoffset = PChips[i][0]->SAD.GetZ();
	 }
	 num = (int32)BetAmount[i];
	 if(num == 0){PChits[i]->NoShow();}
	 num = num%100001l;
	 zoffset += i;
	 int32 tenthous = num / 10000;
	 int32 tenthousvalue = tenthous * 10000;
	 int32 thous = (num - tenthousvalue) / 1000;
	 int32 thousvalue = thous * 1000;
	 int32 huns = (num - tenthousvalue - thousvalue) / 100;
	 int32 hunsvalue = huns * 100;
	 int32 twfive = (num - tenthousvalue - thousvalue - hunsvalue) / 25;
	 int32 twfivevalue = twfive * 25;
	 int32 fives = (num - tenthousvalue - thousvalue - hunsvalue - twfivevalue) / 5;
	 int32 fivesvalue = fives * 5;
	 int32 ones = (num - tenthousvalue - thousvalue - hunsvalue - twfivevalue - fivesvalue);


	 if (tenthous)
	 {
		PChips[i][5]->CAD.SetY(yoffset);
		PChips[i][5]->CAD.SetZ(zoffset);

		PChips[i][5]->CAD.SetCurrentFrame(int16(tenthous - 1));
		PChips[i][5]->Show();
	 }
	 else {PChips[i][5]->NoShow();}
	 yoffset -= int16(2*tenthous);
	 zoffset += int16(tenthous);

	 if (thous)
	 {
		PChips[i][4]->CAD.SetY(yoffset);
		PChips[i][4]->CAD.SetZ(zoffset);

		PChips[i][4]->CAD.SetCurrentFrame(int16(thous - 1));
		PChips[i][4]->Show();
	 }
	 else {PChips[i][4]->NoShow();}
	 yoffset -= int16(2*thous);
	 zoffset += int16(thous);

	 if (huns)
	 {
		PChips[i][3]->CAD.SetY(yoffset);
		PChips[i][3]->CAD.SetZ(zoffset);

		PChips[i][3]->CAD.SetCurrentFrame(int16(huns - 1));
		PChips[i][3]->Show();
	 }
	 else {PChips[i][3]->NoShow();}
	 yoffset -= int16(2*huns);
	 zoffset += int16(huns);

	 if (twfive)
	 {
		PChips[i][2]->CAD.SetY(yoffset);
		PChips[i][2]->CAD.SetZ(zoffset);

		PChips[i][2]->CAD.SetCurrentFrame(int16(twfive - 1));
		PChips[i][2]->Show();
	 }
	 else {PChips[i][2]->NoShow();}
	 yoffset -= int16(2*twfive);
	 zoffset += int16(twfive);

	 if (fives)
	 {
		PChips[i][1]->CAD.SetY(yoffset);
		PChips[i][1]->CAD.SetZ(zoffset);

		PChips[i][1]->CAD.SetCurrentFrame(int16(fives - 1));
		PChips[i][1]->Show();
	 }
	 else {PChips[i][1]->NoShow();}
	 yoffset -= int16(2*fives);
	 zoffset += int16(fives);

	 if (ones)
	 {
		PChips[i][0]->CAD.SetY(yoffset);
		PChips[i][0]->CAD.SetZ(zoffset);

		PChips[i][0]->CAD.SetCurrentFrame(int16(ones - 1));
		PChips[i][0]->Show();
	 }
	 else {PChips[i][0]->NoShow();}
	 yoffset -= int16(2*ones);
	 zoffset += int16(ones);

	 SetFree(yoffset,i);
	 Update(GetFUC());
//	 TopZ = zoffset;
  }

}
//*******************************************************************
void TBetComeNum::Setup()
{
  for(int16 j=0;j<3;j++)
  {
	 for (int16 i=0;i<6;i++)
	 {

		PFreeChips[j][i] = NULL;
		PFreeChips[j][i] = GetAnm(int16(i+(j*6)+22));
		if (PFreeChips[j][i] == NULL) {AnmError("CBetSpot","FreeChips",int16(i+(j*6)+22));}
		PFreeChips[j][i]->CAD.ClearAutoStart();
		PFreeChips[j][i]->CAD.ClearAutoStop();
		PFreeChips[j][i]->CAD.SetDirStill();
	 }
  }

}
//*******************************************************************
void TBetComeNum::AddCome(int16 slot,TMoney amount)
{
  BetAmount[slot] = amount;
  SetNum();
}
//*******************************************************************
#pragma argsused
TMoney TBetComeNum::SubBSCash(int16 slot,bool comeout)
{
  TMoney temp=0l;
  temp = FreeOdds[slot];
  FreeOdds[slot] = 0l;
  SetNum();
  return temp;
}
//*******************************************************************
#pragma argsused
TMoney TBetComeNum::AddBSCash(int16 slot,TMoney amount,bool comeout,int16 point)
{
	 if((ComePoint == 4 || ComePoint == 6) && ((BetAmount[slot]%2l) == 0l))
	 {
		if( ((BetAmount[slot]*2l)-FreeOdds[slot]+BetAmount[slot]/2l) >= amount)
		{
		  FreeOdds[slot] += amount;
		  SetNum();
		  return 0l;
		}
		else
		{
		  if(FreeOdds[slot] == 0l)
		  {
			 FreeOdds[slot] = (BetAmount[slot]*2l)+(BetAmount[slot]/2l);
			 SetNum();
			 return (amount-(BetAmount[slot]*2l)+(BetAmount[slot]/2l));
		  }
		  else
		  {
			 TMoney x = FreeOdds[slot];
			 FreeOdds[slot] = (BetAmount[slot]*2l)+(BetAmount[slot]/2l);
			 SetNum();
			 return (amount+x-((BetAmount[slot]*2l)+(BetAmount[slot]/2l)));
		  }
		}
	 }
	 else
	 {
		if( ((BetAmount[slot]*2l)-FreeOdds[slot]) >= amount)
		{
		  FreeOdds[slot] += amount;
		  SetNum();
		  return 0l;
		}
		else
		{
		  if(FreeOdds[slot] == 0l)
		  {
			 FreeOdds[slot] = BetAmount[slot]*2l;
			 SetNum();
			 return (amount-(BetAmount[slot]*2l));
		  }
		  else
		  {
			 TMoney x = FreeOdds[slot];
			 FreeOdds[slot] = BetAmount[slot]*2l;
			 SetNum();
			 return (amount+x-(BetAmount[slot]*2l));
		  }
		}
	 }
}
//*******************************************************************
#pragma argsused
bool TBetComeNum::Winner(int16 FirstDice,int16 SecondDice,int16 Point,bool ComeOut,bool Buy4n10,bool Buy5n9,bool Buy6n8,bool ComeFreeOdds,bool DoNotComeFreeOdds,bool BuyPlaceOn,bool HardWaysOn)
{
  if(FirstDice+SecondDice == ComePoint)
	  {
		 return true;
	  }
	  else
	  {
		 return false;
	  }
}
//*******************************************************************
#pragma argsused
bool TBetComeNum::Loser(int16 FirstDice,int16 SecondDice,int16 Point,bool ComeOut,bool Buy4n10,bool Buy5n9,bool Buy6n8,bool ComeFreeOdds,bool DoNotComeFreeOdds,bool BuyPlaceOn,bool HardWaysOn)
{
	  if(FirstDice+SecondDice == 5)
	  {
		 return true;
	  }
	  else
	  {
		 return false;
	  }
}
//*******************************************************************
#pragma argsused
bool TBetComeNum::Winner(int16 FirstDice,int16 SecondDice,int16 Point,bool ComeOut)
{
	  if(FirstDice+SecondDice == ComePoint)
	  {
		 return true;
	  }
	  else
	  {
		 return false;
	  }
}
//*******************************************************************
#pragma argsused
bool TBetComeNum::Loser(int16 FirstDice,int16 SecondDice,int16 Point,bool ComeOut)
{
	  if(FirstDice+SecondDice == 5)
	  {
		 return true;
	  }
	  else
	  {
		 return false;
	  }
}
//*******************************************************************
TMoney TBetComeNum::ReturnFree(int16 slot,int16 dice1,int16 dice2)
{
  TMoney x=0l;
  if(dice1+dice2 == 5 || dice1+dice2 == ComePoint)
  {
	 x = FreeOdds[slot];
	 FreeOdds[slot] = 0l;
  }
  return x;
}
//*******************************************************************
TMoney TBetComeNum::ReturnFreeOdds(int16 slot)
{
  TMoney x=FreeOdds[slot];
  FreeOdds[slot] = 0l;
  return x;
}
//*******************************************************************

