//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  bethard.cpp
//    Project Name:  Ogle
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     05/18/96   A. Krist    Original baseline
//  2.0     09/18/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "bethard.h"
#include <assert.h>
//*******************************************************************
TBetHard::TBetHard(TOgleModeWindow *pmw,const TFileMode &NewFileMode,int16 point,
                   int16 MessageCode)
:TCBetSpot(pmw,NewFileMode,MessageCode)
{
  SpotType = Hard;
  HardPoint=point;
}
//*******************************************************************
TBetHard::TBetHard(TOgleModeWindow *pmw,const TFileMode &NewFileMode,void *psource,
                   int16 point,int16 MessageCode)
:TCBetSpot(pmw,NewFileMode,psource,MessageCode)
{
  SpotType = Hard;
  HardPoint=point;
}
//*******************************************************************
TBetHard::~TBetHard()
{
}
//*******************************************************************
long TBetHard::Odds()
{
  switch(HardPoint)
  {
	 case 2 : return 7;
	 case 4 : return 9;
	 case 6 : return 9;
	 case 8 : return 7;
  }
  // MRP 12/21/96
  //I'm assuming we shouldn't get here.
  assert(false);
  return 1;
}
//*******************************************************************
#pragma argsused
bool TBetHard::Winner(int16 FirstDice,int16 SecondDice,int16 Point,bool ComeOut)
{
	  if( (FirstDice == SecondDice) && (FirstDice+SecondDice == HardPoint) )
	  {
		 return true;
	  }
	  else
	  {
		 return false;
	  }
}
//*******************************************************************
#pragma argsused
bool TBetHard::Winner(int16 FirstDice,int16 SecondDice,int16 Point,bool ComeOut,
                      bool Buy4n10,bool Buy5n9,bool Buy6n8,bool ComeFreeOdds,
                      bool DoNotComeFreeOdds,bool BuyPlaceOn,bool HardWaysOn)
{
  if(!HardWaysOn && ComeOut)
  {
	 return false;
  }
  if( (FirstDice == SecondDice) && (FirstDice+SecondDice == HardPoint) )
  {
	 return true;
  }
  else
  {
	 return false;
  }
}
//*******************************************************************
#pragma argsused
bool TBetHard::Loser(int16 FirstDice,int16 SecondDice,int16 Point,bool ComeOut,
                     bool Buy4n10,bool Buy5n9,bool Buy6n8,bool ComeFreeOdds,
                     bool DoNotComeFreeOdds,bool BuyPlaceOn,bool HardWaysOn)
{
	  if(!HardWaysOn && ComeOut)
	  {
		 return false;
	  }
	  if( (FirstDice != SecondDice) && (FirstDice+SecondDice == HardPoint) ||
			(FirstDice+SecondDice == 5) )
	  {
		 return true;
	  }
	  else
	  {
		 return false;
	  }
}
//*******************************************************************
#pragma argsused
bool TBetHard::Loser(int16 FirstDice,int16 SecondDice,int16 Point,bool ComeOut)
{
  if( (FirstDice != SecondDice) && (FirstDice+SecondDice == HardPoint) ||
		(FirstDice+SecondDice == 5) )
  {
	 return true;
  }
  else
  {
	 return false;
  }
}
//*******************************************************************