 //*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CACDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  cract1st.cpp   ///
//    Project Name:  Casino
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     03/29/95   A. Krist    Original baseline
//  2.0     09/18/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "ccact1st.h"
#include "ccrmst.h"
#include "orespond.h"
//*******************************************************************
TCAct1State::TCAct1State(TCasinoCGameLord *pNewCLord)
:TCLordState(pNewCLord)
{
	 SetRunOrder(ess_Execute,ess_StartSubState3,ess_Execute,ess_Done,ess_Done,ess_Done);
	 StartingFUC = 0;
	 FUCLength   = 0;
	 randoutspin = 0;
	 BetSpotResponder            = NULL;

	 OneChipResponder            = NULL;
	 FiveChipResponder           = NULL;
	 TwentyFiveChipResponder     = NULL;
	 OneHundredChipResponder     = NULL;
	 OneThouChipResponder        = NULL;
	 TenThouChipResponder        = NULL;

	 MenuEscResponder            = NULL;
	 Button1Responder            = NULL;
	 Button2Responder            = NULL;
	 Button3Responder            = NULL;
	 Button4Responder            = NULL;
	 ButtonFourResponder         = NULL;
	 AskExpertResponder          = NULL;
	 WaitOnSkit                  = false;
	 askexpertflag               = false;
	 WaitingOnWRCounter          = 0;
	 WaitOnPreRollCom            = false;
	 WaitOnRolling               = false;
	 WaitOnDiceRolling           = false;
	 FinishDiceRolling           = false;
	 FinishDiceRoll              = false;
	 FinishDiceDrop              = false;
	 DiceGiven                   = false;
	 SkitOn                      = false;
	 WaitOnGiveDice              = false;
	 AdvBets                     = false;
	 WaitOnAdvBets               = false;
	 ContinueAdv                 = false;
	 Roll                        = false;
	 StallOn                     = false;
	 WaitOnStall                 = false;
	 WaitOnNoComeOut             = false;
	 WaitOnShake                 = false;
	 Throw                       = false;
	 WaitOnExtendShake           = false;
	 WaitOnD                     = false;
	 IgnoreCoach = false;
	 IgnoreCoach2 = false;
	 oldspot = -1;
	 BettingSpot = 0;
}
//*******************************************************************
TCAct1State::~TCAct1State()
{
}
//*******************************************************************
void TCAct1State::ExecuteFirstTime()
{
//  int i;
  pOwnerLord->Responders[44]->Add();
  pOwnerLord->BetSpotsOn = true;
  ActionTime = pOwnerLord->GetFUC();
  pOwnerLord->StallsInRow = 0;
  pOwnerLord->SetBodyIdle();
  pOwnerLord->Clear();
  ExecuteWaiting = true;
  ExecuteStatus    = ess_Execute;
  if(!WaitOnSkit)
  {
	 StartingFUC = pOwnerLord->GetAdjFUC();
	 pOwnerLord->PlaceBets(StartingFUC,FUCLength);
	 WaitOnSkit = true;
	 SkitOn     = true;
	 AdvBets = true;
  }

}
//*******************************************************************
void TCAct1State::CreateSubState1()
{
  //PActiveSubState = new TBJFirstDealState(pOwnerLord);
}
//*******************************************************************
void TCAct1State::CreateSubState2()
{
  pOwnerLord->MessageDisplay->ShowMessage(0);
  pOwnerLord->Button5->ShowLite();
  pOwnerLord->PlaceBetsMode = false;
  pOwnerLord->PModeWin->ReSendEnterArea();
  PActiveSubState = new TCRemoveState(pOwnerLord);
}
//*******************************************************************
void TCAct1State::CreateSubState4()
{
}
//*******************************************************************
void TCAct1State::CreateSubState3()
{
  //pOwnerLord->SetBlackJack();
 // if(pOwnerLord->pHand->cards[0].name > Nine)
  //{
	// PActiveSubState = new TBJState(pOwnerLord);
  //}
}
//*******************************************************************
void TCAct1State::EndSubState4()
{
  TState::EndSubState4();
  ExecuteWaiting = false;
  ExecuteStatus = ess_Done;
}
//*******************************************************************
void TCAct1State::EndSubState2()
{
  TState::EndSubState2();
  ExecuteWaiting = true;
  pOwnerLord->MessageDisplay->NoShow();
  ActionTime = pOwnerLord->GetFUC();
  pOwnerLord->StallsInRow = 0;
  pOwnerLord->PlaceBetsMode = true;
  if(!pOwnerLord->BetMade(pOwnerLord->activeplayer)){pOwnerLord->Button5->ShowGray();}
  pOwnerLord->PModeWin->ReSendEnterArea();
}
//*******************************************************************
void TCAct1State::HandlePostUpdate(dword NewFUC)
{
  if (BetSpotResponder != NULL)
  {
	 if (BetSpotResponder->GetResponseEvent() != reChar)
	 {
		BetSpotResponder->ClearPriority();
	 }
	 if(pOwnerLord->CoachIsOn() &&
		 pOwnerLord->BetNoGood(BettingSpot) > 0 && (!IgnoreCoach || oldspot != BettingSpot))
	 {
		  pOwnerLord->Button0->ShowExpert();
		  IgnoreCoach = true;
		  oldspot = BettingSpot;
	 }
	 else
	 {
		IgnoreCoach = false;
		IgnoreCoach2 = false;
		BetSpotResponder = NULL;
		pOwnerLord->PlaceBet(BettingSpot);
	 }

	 if(pOwnerLord->BetMade())
	 {
		pOwnerLord->Button4->NoShow(); //???
	 }
	 LockHit = false;
	 BetSpotResponder = NULL;
	 ActionTime = pOwnerLord->GetFUC();
	 pOwnerLord->StallsInRow = 0;
  }
  if (pOwnerLord->ButtonHit[cidButton13])
  {
	 pOwnerLord->ButtonClear(cidButton13);
	 ActionTime = NewFUC;
    pOwnerLord->StallsInRow = 0;
  }
  if (pOwnerLord->ButtonHit[cidButton11])
  {
	 pOwnerLord->ButtonClear(cidButton11);
	 if(pOwnerLord->ButtonInfo == 1)
	 {
		pOwnerLord->UnBet1(1);
	 }
	 else
	 {
		pOwnerLord->Bet1(1);
	 }
	 ActionTime = NewFUC;
    pOwnerLord->StallsInRow = 0;
  }
  if (pOwnerLord->ButtonHit[cidButton10])
  {
	 pOwnerLord->ButtonClear(cidButton10);
	 if(pOwnerLord->ButtonInfo == 1)
	 {
		pOwnerLord->UnBet1(5l);
	 }
	 else
	 {
		pOwnerLord->Bet1(5l);
	 }
	 ActionTime = NewFUC;
    pOwnerLord->StallsInRow = 0;
  }
  if (pOwnerLord->ButtonHit[cidButton9])
  {
	 pOwnerLord->ButtonClear(cidButton9);
	 if(pOwnerLord->ButtonInfo == 1)
	 {
		pOwnerLord->UnBet1(25l);
	 }
	 else
	 {
		pOwnerLord->Bet1(25l);
	 }
	 ActionTime = NewFUC;
	 pOwnerLord->StallsInRow = 0;
  }
  if (pOwnerLord->ButtonHit[cidButton8])
  {
	 pOwnerLord->ButtonClear(cidButton8);
	 if(pOwnerLord->ButtonInfo == 1)
	 {
		pOwnerLord->UnBet1(100l);
	 }
	 else
	 {
		pOwnerLord->Bet1(100l);
	 }
	 ActionTime = NewFUC;
	 pOwnerLord->StallsInRow = 0;
  }
  if (pOwnerLord->ButtonHit[cidButton7])
  {
	 pOwnerLord->ButtonClear(cidButton7);
	 if(pOwnerLord->ButtonInfo == 1)
	 {
		pOwnerLord->UnBet1(1000l);
	 }
	 else
	 {
		pOwnerLord->Bet1(1000l);
	 }
	 ActionTime = NewFUC;
	 pOwnerLord->StallsInRow = 0;
  }
  if (pOwnerLord->ButtonHit[cidButton6])
  {
	 pOwnerLord->ButtonClear(cidButton6);
	 if(pOwnerLord->ButtonInfo == 1)
	 {
		pOwnerLord->UnBet1(10000l);
	 }
	 else
	 {
		pOwnerLord->Bet1(10000l);
	 }
	 ActionTime = NewFUC;
	 pOwnerLord->StallsInRow = 0;
  }
  if(pOwnerLord->ButtonHit[cidButton5])
  {
	 pOwnerLord->ButtonClear(cidButton5);
	 ExecuteWaiting = false;
	 ActionTime = NewFUC;
	 pOwnerLord->StallsInRow = 0;
	 LockHit = false;
	 ExecuteStatus = ess_StartSubState2;
	 return;
  }

  if(pOwnerLord->ButtonHit[cidButton4])
  {
	 pOwnerLord->ButtonClear(cidButton4);
	 ActionTime = NewFUC;
	 pOwnerLord->StallsInRow = 0;
	 pOwnerLord->ClearBet();
	 LockHit = false;

	 return;
  }
  if(pOwnerLord->ButtonHit[cidButton3])
  {
	 //pOwnerLord->Button3->ShowUp();
	 LockHit = false;
	 ActionTime = NewFUC;
	 pOwnerLord->StallsInRow = 0;
	 pOwnerLord->ButtonClear(cidButton3);
	 return;
  }
  if(pOwnerLord->ButtonHit[cidButton2])
  {
	 //pOwnerLord->Button3->ShowUp();
	 LockHit = false;
	 ActionTime = NewFUC;
	 pOwnerLord->StallsInRow = 0;
	 pOwnerLord->ButtonClear(cidButton2);
	 return;
  }
  if(pOwnerLord->ButtonHit[cidButton1])
  {
	 //pOwnerLord->Button3->ShowUp();
	 LockHit = false;
	 ActionTime = NewFUC;
	 pOwnerLord->StallsInRow = 0;
	 pOwnerLord->ButtonClear(cidButton1);
	 return;
  }
  if(pOwnerLord->ButtonHit[cidButton0])
  {
	 LockHit = false;
	 askexpertflag = false;
	 ActionTime = NewFUC;
	 pOwnerLord->StallsInRow = 0;
	 pOwnerLord->ButtonClear(cidButton0);
	 if(pOwnerLord->Button0->ExpertStart > 0)
	 {
		pOwnerLord->Button0->ExpertStart = 0;
		if(IgnoreCoach)
		{
		  pOwnerLord->AskBetExpert(oldspot);
		}
		else if(IgnoreCoach2)
		{
		  pOwnerLord->AskOddsExpert();
		}
	 }
	 else
	 {
		pOwnerLord->AskExpert();
	 }
	 IgnoreCoach  = false;
	 IgnoreCoach2 = false;

	 return;
  }
  if(StallOn && ((ActionTime+TCasinoCGameLord::STALLDELAY) <= NewFUC) && !Roll)
  {
	 StartingFUC = pOwnerLord->GetAdjFUC();
	 pOwnerLord->Stall(StartingFUC,FUCLength);
	 WaitOnStall = true;
	 StallOn = false;
	 return;
  }
  if(WaitOnStall)
  {
	 if(StartingFUC + FUCLength <= NewFUC)
	 {
		WaitOnStall = false;
		StallOn = true;
//		ActionTime = PTimePtr->GetFrameUpdateCount();
		ActionTime = pOwnerLord->GetFUC();
	  //	pOwnerLord->StallsInRow++;   //??? is in ccglord2.cpp
	 }
	 else
	 {
		return;
	 }
  }
  if(!DiceGiven && !SkitOn && pOwnerLord->BetMade() && !AdvBets && !WaitOnGiveDice)
  {
	 pOwnerLord->ClearBigDice();
	 StartingFUC = pOwnerLord->GetAdjFUC();
	 /*ReturnValue = */pOwnerLord->GiveDice(StartingFUC,FUCLength);
		 //Trickle down to next if statement
	 WaitOnGiveDice = true;
	 return;
  }
  if(WaitOnGiveDice)
  {
	 if(StartingFUC + FUCLength - 1 <= NewFUC)
	 {
		DiceGiven        = true;
		WaitOnGiveDice = false;
		pOwnerLord->ShowTableDice();
		ActionTime = pOwnerLord->GetFUC();
		pOwnerLord->StallsInRow = 0;
	 }
	 else
	 {
		return;
	 }
  }
  if((!WaitOnSkit && AdvBets && !WaitOnGiveDice && !WaitOnPreRollCom) || (ContinueAdv && !Roll))
  {
	 StartingFUC = pOwnerLord->GetAdjFUC();
	 pOwnerLord->AdvBets(StartingFUC,FUCLength);
	 AdvBets        = false;
	 WaitOnAdvBets  = true;
	 SkitOn         = true;
	 ContinueAdv    = false;
	 return;
  }
  if(WaitOnAdvBets)
  {
	 if(StartingFUC + FUCLength <= NewFUC)
	 {
		WaitOnAdvBets = false;
		SkitOn        = false;
		StallOn = true;
		ActionTime = pOwnerLord->GetFUC();
	 }
	 else
	 {
		return;
	 }
  }
  if(WaitOnSkit)
  {
	 if((StartingFUC + FUCLength) <= NewFUC)
	 {
		SkitOn      = false;
		StartingFUC = 0;
		FUCLength   = 0;
		WaitOnSkit  = false;
		ActionTime = pOwnerLord->GetFUC();
		pOwnerLord->StallsInRow = 0;

		if(LockHit)
		{
		  LockHit = false;
		  LockButtons = false;
		}
	 }
	 return;//?
  }
  if (WaitingOnWRCounter)
  {
	 WaitingOnWRCounter--;
	 if (!WaitingOnWRCounter)
	 {
		ExecuteWaiting = false;
		ExecuteStatus = ess_StartSubState1;
	 }
  }

  if (pOwnerLord->ButtonHit[cidButton12])
  {
	 pOwnerLord->ButtonClear(cidButton12);
	 if(Throw){return;}
	 if(pOwnerLord->Shooter != -1)
	 {
		ActionTime = NewFUC;
		pOwnerLord->StallsInRow = 0;
		if(pOwnerLord->CoachIsOn() &&
			pOwnerLord->NoFreeOdds() > 0 && !IgnoreCoach2)
		{
		  pOwnerLord->Button0->ShowExpert();
		  IgnoreCoach2 = true;
		  pOwnerLord->EnableButton(12);
		}
		else
		{
		  IgnoreCoach2 = false;
		  WaitOnD = true;
		  pOwnerLord->BetSpotsOn = false;
		  pOwnerLord->Responders[44]->Remove();
		}
	 }
  }
  if(WaitOnD && DiceGiven)
  {
	 WaitOnD = false;
	 Throw = true;
	 Roll = true;
	 if (pOwnerLord->BetMade())
	 {
		StartingFUC = pOwnerLord->GetAdjFUC();
		if(pOwnerLord->COMEOUT)
		{
		  pOwnerLord->ComeCom(StartingFUC,FUCLength);
		}
		else
		{
		  pOwnerLord->PointCom(StartingFUC,FUCLength);
		}
		pOwnerLord->Roll();
		pOwnerLord->PreRollStats();
		WaitOnSkit       = true;   //Trickle down to next if statement
		WaitOnPreRollCom = true;
	 }
	 else
	 {
		  StartingFUC = pOwnerLord->GetAdjFUC();
		  pOwnerLord->NoComeCom(StartingFUC,FUCLength);
		  WaitOnNoComeOut       = true;
	 }
  }
  if(WaitOnNoComeOut)
  {
	 if(StartingFUC + FUCLength <= NewFUC)
	 {
		WaitOnNoComeOut = false;
		Roll = false;
		ActionTime = pOwnerLord->GetFUC();
		pOwnerLord->StallsInRow = 0;
	 }
	 else
	 {
		return;
	 }
  }
  if(!WaitOnSkit && WaitOnPreRollCom)
  {
	 {
		pOwnerLord->NoShowTableDice();
		StartingFUC = pOwnerLord->GetAdjFUC();
		pOwnerLord->NoShowTableDice();
		pOwnerLord->PickUpDice(StartingFUC,FUCLength);
		WaitOnPreRollCom = false;
		pOwnerLord->shutdownstate = 1;
		WaitOnShake = true;
	 }
	 return;

  }
  if(WaitOnShake)
  {
	 if(StartingFUC + FUCLength - 1 <= NewFUC)
	 {
		StartingFUC = pOwnerLord->GetAdjFUC();
		pOwnerLord->Shake(StartingFUC,FUCLength);
		WaitOnDiceRolling = true;
		pOwnerLord->ShakeInRow = 1;
		WaitOnShake = false;
	 }
  }
  if(WaitOnExtendShake)
  {
	 if(StartingFUC + FUCLength - 1 <= NewFUC)
	 {
		WaitOnExtendShake = false;
		WaitOnDiceRolling = true;
	 }
  }
  if(WaitOnDiceRolling)
  {
	 if(StartingFUC + FUCLength - 1 <= NewFUC)
	 {
		if(pOwnerLord->ButtonInfo != -1)
		{
		  StartingFUC = pOwnerLord->GetAdjFUC();
		  pOwnerLord->DisEnableButton(12);
		  pOwnerLord->Throw(StartingFUC,FUCLength);
		  FinishDiceRolling = true;
		  WaitOnDiceRolling = false;
		}
		else
		{
		  StartingFUC = pOwnerLord->GetAdjFUC();
		  pOwnerLord->Shake(StartingFUC,FUCLength);
		  pOwnerLord->ShakeInRow++;
		  WaitOnExtendShake = true;
		  WaitOnDiceRolling = false;
		}
	 }
  }
  if(FinishDiceRolling)
  {
	 if(StartingFUC + FUCLength <= NewFUC)
	 {
		StartingFUC = pOwnerLord->GetAdjFUC();
		pOwnerLord->DiceLand(StartingFUC,FUCLength);
		FinishDiceRolling = false;
		FinishDiceDrop = true;
	 }
  }
  if(FinishDiceDrop)
  {
	 if(StartingFUC + FUCLength - 1 <= NewFUC)
	 {
		pOwnerLord->BigDice();
		FinishDiceDrop = false;
		ExecuteWaiting = false;
		ExecuteStatus = ess_StartSubState1;
	 }
  }
  if(MenuEscResponder != NULL)
  {
	 MenuEscResponder->ClearPriority();
	 MenuEscResponder = NULL;
	 ActionTime = pOwnerLord->GetFUC();
	 pOwnerLord->StallsInRow = 0;
	 return;
  }
  if(AskExpertResponder != NULL)
  {
	 if(!askexpertflag)
	 {
		if (AskExpertResponder->GetResponseEvent() != reChar)
		{
		  AskExpertResponder->ClearPriority();
		}
		askexpertflag = true;
	 }
	 else
	 {
		AskExpertResponder = NULL;
		askexpertflag = false;
		ActionTime = pOwnerLord->GetFUC();
		pOwnerLord->StallsInRow = 0;
	 }
	 return;
  }

}
//*******************************************************************
bool TCAct1State::HandleNamePlate(TResponder &responder)
{
  if(responder.GetResponseEvent() == reLDown)
  {
	 responder.SetPriority();
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_PRESSING_FINGER_CURSOR));
	 return true;
  }
  if ((responder.GetResponseEvent() == reLUp    ) ||
		(responder.GetResponseEvent() == reLDblClk) ||
		(responder.GetResponseEvent() == reChar   )   )
  {
	 if(responder.GetIsPriority())
	 {
		responder.ClearPriority();
	 }
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_POINTING_FINGER_CURSOR));
	 if(responder.Contains(responder.GetPoint()) ||
		 responder.GetResponseEvent() == reChar     )
	 {
		if(pOwnerLord->GetNumActivePlayers() > 1)
		{
		  pOwnerLord->CyclePlayers();
		}
	 }
  }
  return true;
}
//*******************************************************************
bool TCAct1State::HandleBetSpot(TResponder &responder,int16 spot)
{
  if((pOwnerLord->activeplayer != -1) && (!LockHit))
  {
	 if (responder.GetResponseEvent() == reLUp)
	 {
		BettingSpot = spot;
		BetSpotResponder = &responder;
		LockHit = true;
	 }
	 if (responder.GetResponseEvent() == reLDown)
	 {
		responder.SetPriority();
	 }
	 if (responder.GetResponseEvent() == reChar)
	 {
		BettingSpot = spot;
		BetSpotResponder = &responder;
	 }
  }
  return true;
}
//*******************************************************************
bool TCAct1State::HandleButton1(TResponder &responder)
{
  if((pOwnerLord->activeplayer != -1) && (!WaitOnSkit) && (!LockHit))
  {
	 if(pOwnerLord->BetMade())
	 {
		if (responder.GetResponseEvent() == reLUp)
		{
		  LockHit = true;
		  Button1Responder = &responder;
		}
		if (responder.GetResponseEvent() == reLDown)
		{
		  responder.SetPriority();
		}
		if (responder.GetResponseEvent() == reChar)
		{
		  Button1Responder = &responder;
		}
	 }
	 return true;
  }
  return true;
}
//*******************************************************************
bool TCAct1State::HandleButton2(TResponder &responder)
{
  if((pOwnerLord->activeplayer != -1) && (!WaitOnSkit) && (!LockHit))
  {
	 if (responder.GetResponseEvent() == reLUp)
	 {
		Button2Responder = &responder;
		LockHit = true;
		pOwnerLord->ClearBet();
	 }

	 if (responder.GetResponseEvent() == reLDown)
	 {
		responder.SetPriority();
	 }

	 if (responder.GetResponseEvent() == reChar)
	 {
		Button2Responder = &responder;
		pOwnerLord->ClearBet();
	 }
	 return true;
  }
  return true;
}
//*******************************************************************
bool TCAct1State::HandleButton3(TResponder &responder)
{
  if((pOwnerLord->activeplayer != -1) && (!WaitOnSkit) && (!LockHit))
  {
	 if (responder.GetResponseEvent() == reLUp)
	 {
		LockHit = true;
		Button3Responder = &responder;
	 }

	 if (responder.GetResponseEvent() == reLDown)
	 {
		responder.SetPriority();
	 }

	 if (responder.GetResponseEvent() == reChar)
	 {
		Button3Responder = &responder;
	 }
	 return true;
  }
  return true;
}
//*******************************************************************
bool TCAct1State::HandleButton4(TResponder &responder)
{
  if((pOwnerLord->activeplayer != -1) && (!Throw))
  {
	 if (responder.GetResponseEvent() == reLUp)
	 {
		Throw = true;
		ButtonFourResponder = &responder;
		return true;
	 }
	 if(!Roll)
	 {
		if (responder.GetResponseEvent() == reLDown)
		{
		  Button4Responder = &responder;
		  responder.SetPriority();
		}
		if (responder.GetResponseEvent() == reChar)
		{
		  Button4Responder = &responder;
		}
		return true;
	 }
  }
  return true;
}
//*******************************************************************
bool TCAct1State::HandleOneChip(TResponder &responder)
{
  if(pOwnerLord->activeplayer != -1)
  {
	 if (responder.GetResponseEvent() == reLUp || responder.GetResponseEvent() == reRUp)
	 {
		OneChipResponder = &responder;
	 }

	 if (responder.GetResponseEvent() == reLDown || responder.GetResponseEvent() == reRDown)
	 {
		responder.SetPriority();
	 }

	 if (responder.GetResponseEvent() == reChar)
	 {
		OneChipResponder = &responder;
	 }
	 return true;
  }
  return true;
}
//*******************************************************************
bool TCAct1State::HandleFiveChip(TResponder &responder)
{
  if(pOwnerLord->activeplayer != -1)
  {
	 if (responder.GetResponseEvent() == reLUp || responder.GetResponseEvent() == reRUp)
	 {
		FiveChipResponder = &responder;
	 }

	 if (responder.GetResponseEvent() == reLDown || responder.GetResponseEvent() == reRDown)
	 {
		responder.SetPriority();
	 }

	 if (responder.GetResponseEvent() == reChar)
	 {
		FiveChipResponder = &responder;
	 }
	 return true;
  }
  return true;
}
//*******************************************************************
bool TCAct1State::HandleTwentyFiveChip(TResponder &responder)
{
  if(pOwnerLord->activeplayer != -1)
  {

  if (responder.GetResponseEvent() == reLUp || responder.GetResponseEvent() == reRUp)
  {
	 TwentyFiveChipResponder = &responder;
  }

  if (responder.GetResponseEvent() == reLDown || responder.GetResponseEvent() == reRDown)
  {
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
	 TwentyFiveChipResponder = &responder;
  }
  return true;
  }
  return true;
}
//*******************************************************************
bool TCAct1State::HandleOneHundredChip(TResponder &responder)
{
  if(pOwnerLord->activeplayer != -1)
  {

  if (responder.GetResponseEvent() == reLUp || responder.GetResponseEvent() == reRUp)
  {
	 OneHundredChipResponder = &responder;
  }

  if (responder.GetResponseEvent() == reLDown || responder.GetResponseEvent() == reRDown)
  {
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
	 OneHundredChipResponder = &responder;
  }
  return true;
  }
  return true;
}
//*******************************************************************
bool TCAct1State::HandleOneThouChip(TResponder &responder)
{
  if(pOwnerLord->activeplayer != -1)
  {

  if (responder.GetResponseEvent() == reLUp || responder.GetResponseEvent() == reRUp)
  {
	 OneThouChipResponder = &responder;
  }

  if (responder.GetResponseEvent() == reLDown || responder.GetResponseEvent() == reRDown)
  {
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
	 OneThouChipResponder = &responder;
  }
  return true;
  }
  return true;
}
//*******************************************************************
bool TCAct1State::HandleTenThouChip(TResponder &responder)
{
  if(pOwnerLord->activeplayer != -1)
  {

  if (responder.GetResponseEvent() == reLUp || responder.GetResponseEvent() == reRUp)
  {
	 TenThouChipResponder = &responder;
  }

  if (responder.GetResponseEvent() == reLDown || responder.GetResponseEvent() == reRDown)
  {
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
	 TenThouChipResponder = &responder;
  }
  return true;
  }
  return true;
}
//*******************************************************************
bool TCAct1State::HandleMenuEsc(TResponder &responder)
{
  if(!WaitOnSkit)
  {
  if (responder.GetResponseEvent() == reLUp)
  {
	 MenuEscResponder = &responder;
  }

  if (responder.GetResponseEvent() == reLDown)
  {
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
	 MenuEscResponder = &responder;
  }
  }
  return true;
}
//*******************************************************************
bool TCAct1State::HandleAskExpert(TResponder &responder)
{
  if(pOwnerLord->activeplayer != -1 && !WaitOnSkit)
  {

	if (responder.GetResponseEvent() == reLUp)
  {
	 AskExpertResponder = &responder;
  }

  if (responder.GetResponseEvent() == reLDown)
  {
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
	 AskExpertResponder = &responder;
  }

  return true;
  }
  return true;
}
//*******************************************************************
