 //*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  ccact2st.cpp
//    Project Name:  Casino
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     03/29/95   A. Krist    Original baseline
//  2.0     09/18/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "ccact2st.h"
#include "ccpost.h" //payout
#include "orespond.h"
//*******************************************************************
TCAct2State::TCAct2State(TCasinoCGameLord *pNewCLord)
:TCLordState(pNewCLord)
{
	 SetRunOrder(ess_Execute,ess_StartSubState3,ess_Execute,ess_Done,ess_Done,ess_Done);
	 StartingFUC = 0;
	 FUCLength   = 0;
	 MarkFUC     = 0;
	 MenuEscResponder            = NULL;
	 WaitOnMarker                = false;
	 WaitOnGetMark               = false;
	 WaitOnResult                = false;
	 askexpertflag               = false;
	 GetNextWinner      = false;
	 Player             = 2;
	 Player0 = true;
	 Player1 = true;
	 Player2 = true;
	 BetCounter                  = 0;
	 FinishWinners               = false;
	 WaitOnFirstWinner           = false;
	 WaitOnLoser                 = false;
	 WaitOnReturnOdds            = false;
	 FinishReturnOdds            = false;
	 PayoutOrder[0]   = 0;
	 PayoutOrder[1]   = 1;PayoutOrder[2]    = 2;PayoutOrder[3]    = 3;PayoutOrder[4]    = 4;PayoutOrder[5]   = 5;
	 PayoutOrder[6]   = 6;PayoutOrder[7]    = 7;PayoutOrder[8]    = 8;PayoutOrder[9]    = 9;PayoutOrder[10]  = 10;
	 PayoutOrder[11]  = 11;PayoutOrder[12]  = 12;PayoutOrder[13]  = 13;PayoutOrder[14]  = 14;PayoutOrder[15]  = 15;
	 PayoutOrder[16]  = 16;PayoutOrder[17]  = 17;PayoutOrder[18]  = 18;PayoutOrder[19]  = 19;PayoutOrder[20]  = 20;
	 PayoutOrder[21]  = 21;PayoutOrder[22]  = 22;PayoutOrder[23]  = 23;PayoutOrder[24]  = 24;PayoutOrder[25]  = 25;
	 PayoutOrder[26]  = 26;PayoutOrder[27]  = 27;PayoutOrder[28]  = 28;PayoutOrder[29]  = 29;PayoutOrder[30]  = 30;
	 PayoutOrder[31]  = 31;PayoutOrder[32]  = 32;PayoutOrder[33]  = 33;PayoutOrder[34]  = 34;PayoutOrder[35]  = 35;
	 PayoutOrder[36]  = 36;PayoutOrder[37]  = 37;PayoutOrder[38]  = 38;PayoutOrder[39]  = 39;PayoutOrder[40]  = 40;
	 PayoutOrder[41]  = 41;PayoutOrder[42]  = 42;

}
//*******************************************************************
TCAct2State::~TCAct2State()
{
  pOwnerLord->MoveComeBets();
  pOwnerLord->FirstRoll = false;
}
//*******************************************************************
void TCAct2State::ExecuteFirstTime()
{
//  pOwnerLord->SetBodyIdle();
  if(!pOwnerLord->GetCasPD(2))
	 {
		Player2 = false;
	 }
	 if(!pOwnerLord->GetCasPD(1))
	 {
		Player1 = false;
	 }
	 if(!pOwnerLord->GetCasPD(0))
	 {
		Player0 = false;
	 }
  ExecuteWaiting = true;
  ExecuteStatus    = ess_Execute;
  pOwnerLord->PostRollStats();
//  StartingFUC = PTimePtr->GetFrameUpdateCount() + 1;
  StartingFUC = pOwnerLord->GetAdjFUC();
  WaitOnResult = true;
  //if(pOwnerLord->IsWinner())
 // {
  //	 pOwnerLord->Winner(StartingFUC,FUCLength);
 // }
 // else
 // {
	 pOwnerLord->Result(StartingFUC,FUCLength);
 // }

}
//*******************************************************************
void TCAct2State::CreateSubState1()
{
  PActiveSubState = new TCPayOutState(pOwnerLord,BetCounter);
}
//*******************************************************************
void TCAct2State::EndSubState1()
{
  bool skip=false;
  pOwnerLord->BetSpot[PayoutOrder[BetCounter]]->NoShowSpark();
  TState::EndSubState1();
  ExecuteWaiting = false;
  pOwnerLord->SetOnOffFlags();
  while(BetCounter < 43 &&
			(!(pOwnerLord->BetSpot[PayoutOrder[BetCounter]]->Winner(pOwnerLord->Dice1,pOwnerLord->Dice2,pOwnerLord->Point,pOwnerLord->COMEOUT,pOwnerLord->OnOffFlags[0],pOwnerLord->OnOffFlags[1],pOwnerLord->OnOffFlags[2],pOwnerLord->OnOffFlags[3],pOwnerLord->OnOffFlags[4],pOwnerLord->OnOffFlags[5],pOwnerLord->OnOffFlags[6])) ||
			 !(pOwnerLord->BetSpot[PayoutOrder[BetCounter]]->HasBSBet(Player))   ) )
  {
	 BetCounter++;
	 skip = true;
  }
  if(BetCounter >= 43)
  {
	 ExecuteStatus = ess_Execute;
	 ExecuteWaiting = true;
    GetNextWinner = true;
    if(Player == 2)
	 {Player2 = false;BetCounter = 0;}
	 if(Player == 1)
	 {Player1 = false;BetCounter = 0;}
	 if(Player == 0)
	 {Player0 = false;BetCounter = 0;}
  //	 StartingFUC = pOwnerLord->GetAdjFUC();
  //	 pOwnerLord->Result(StartingFUC,FUCLength);//RemoveMarker(StartingFUC,FUCLength);
  //	 FinishWinners = true;
  }
  else
  {
	 if(!skip)
	 {
		BetCounter++;
		skip = false;
	 }
	 ExecuteStatus = ess_StartSubState1;
  }
}
//*******************************************************************
void TCAct2State::CreateSubState2()
{
  //PActiveSubState = new TRRemoveState(pOwnerLord);
}
//*******************************************************************
void TCAct2State::EndSubState2()
{
  TState::EndSubState2();
  if(!(pOwnerLord->COMEOUT))
  {
	 if(pOwnerLord->ClearMark())
	 {
       ExecuteStatus = ess_Execute;
		 ExecuteWaiting = true;
//		 StartingFUC = PTimePtr->GetFrameUpdateCount() + 1;
       StartingFUC = pOwnerLord->GetAdjFUC();
		 pOwnerLord->GetMark(StartingFUC,FUCLength);
		 pOwnerLord->Point = -1;
		 WaitOnGetMark = true;
	 }
  }
  else
  {
	 if(pOwnerLord->MarkComeOut() )
	 {
		pOwnerLord->COMEOUT = false;
	 }
	 ExecuteWaiting = false;
	 ExecuteStatus  = ess_Done;
  }
}
//*******************************************************************
void TCAct2State::HandlePostUpdate(dword NewFUC)
{
  if(pOwnerLord->ButtonHit[cidButton3])
  {
	 pOwnerLord->ButtonClear(cidButton3);
	 return;
  }
  if(pOwnerLord->ButtonHit[cidButton2])
  {
	 pOwnerLord->ButtonClear(cidButton2);
	 return;
  }
  if(pOwnerLord->ButtonHit[cidButton1])
  {
	 pOwnerLord->ButtonClear(cidButton1);
	 return;
  }
  if(pOwnerLord->ButtonHit[cidButton0])
  {
	 pOwnerLord->ButtonClear(cidButton0);
	 pOwnerLord->AskExpert();
	 return;
  }
  if (WaitOnResult)
  {
	 if((StartingFUC + FUCLength) <= NewFUC)
	 {
		if(pOwnerLord->COMEOUT)
		{
		  if(pOwnerLord->MarkComeOut())
		  {
			 pOwnerLord->Puck->NoShow();
			 ExecuteStatus = ess_Execute;
			 ExecuteWaiting = true;
//			 StartingFUC = PTimePtr->GetFrameUpdateCount() + 1;
			 StartingFUC = pOwnerLord->GetAdjFUC();
			 MarkFUC = 0;
			 pOwnerLord->PlaceMark(StartingFUC,FUCLength,MarkFUC);

		  }
		}
      WaitOnResult = false;
		WaitOnMarker = true;
	 }
  }
  if (WaitOnMarker)
  {
	 if((StartingFUC + MarkFUC) == NewFUC)
	 {
		pOwnerLord->Puck->SetNum(pOwnerLord->Point);
	 }
	 if((StartingFUC + FUCLength) <= NewFUC)
	 {
		StartingFUC = pOwnerLord->GetAdjFUC();
		if(pOwnerLord->ReturnFreeOdds())
		{
		  pOwnerLord->ReturnOdds(StartingFUC,FUCLength);
		  WaitOnReturnOdds = true;
		}
		else
		{
		  pOwnerLord->Loser(StartingFUC,FUCLength);
		  WaitOnLoser = true;
		}
		WaitOnMarker = false;
	 }
  }
  if(WaitOnReturnOdds)
  {
	 if((StartingFUC + FUCLength) <= NewFUC)
	 {
		pOwnerLord->BetSpot[pOwnerLord->SparkOff]->NoShowSpark();
		pOwnerLord->BetSpot[pOwnerLord->SparkOff]->SetNum();
		pOwnerLord->BankCashDisplay->SetNum(pOwnerLord->GetCash(pOwnerLord->activeplayer));
		if(pOwnerLord->ReturnFreeOdds())
		{
		  StartingFUC = pOwnerLord->GetAdjFUC();
		  FUCLength = 12;
		}
		else
		{
		  WaitOnReturnOdds = false;
		  FinishReturnOdds = true;
		  StartingFUC = pOwnerLord->GetAdjFUC();
		  FUCLength = 6;
		}
	 }
  }
  if(FinishReturnOdds)
  {
	 if((StartingFUC + FUCLength) <= NewFUC)
	 {
		pOwnerLord->MessageDisplay->ShowCrapsMessage(pOwnerLord->messagestate);
		FinishReturnOdds = false;
		StartingFUC = pOwnerLord->GetAdjFUC();
		pOwnerLord->Loser(StartingFUC,FUCLength);
		WaitOnLoser = true;
	 }
  }
  if(WaitOnLoser)
  {
	 if((StartingFUC + 4) == NewFUC)
	 {
		pOwnerLord->ClearLosers();
	 }
	 if((StartingFUC + FUCLength) <= NewFUC)
	 {
		WaitOnLoser = false;
		if(pOwnerLord->IsWinner())
		{
		  StartingFUC = pOwnerLord->GetAdjFUC();
		  pOwnerLord->Winner(StartingFUC,FUCLength);
		  WaitOnFirstWinner = true;
		}
		else
		{
		  FinishWinners = true;
		}
	 }
  }
  if(WaitOnFirstWinner)
  {
    if((StartingFUC + FUCLength) <= NewFUC)
	 {
		WaitOnFirstWinner = false;
		FinishWinners = true;
	 }
  }
  if(FinishWinners)
  {
	 if((StartingFUC + FUCLength) <= NewFUC)
	 {
		FinishWinners = false;
		ExecuteWaiting = false;
		GetNextWinner = true;
	 }
  }
  if(GetNextWinner)
  {
	 if(Player2 == false){Player = 1;}
	 if(Player1 == false && Player2 == false){Player = 0;}
	 if(Player0 == false && Player1 == false && Player2 == false){Player = -1;}
	 if((Player0 == false && Player1 == false && Player2 == false) || Player <= -1)
	 {
		ExecuteStatus = ess_StartSubState2;
		GetNextWinner = false;
      ExecuteWaiting = false;
	 }
	 else
	 {
      pOwnerLord->SetOnOffFlags();
		while(BetCounter < 43 &&
		(!(pOwnerLord->BetSpot[PayoutOrder[BetCounter]]->Winner(pOwnerLord->Dice1,pOwnerLord->Dice2,pOwnerLord->Point,pOwnerLord->COMEOUT,pOwnerLord->OnOffFlags[0],pOwnerLord->OnOffFlags[1],pOwnerLord->OnOffFlags[2],pOwnerLord->OnOffFlags[3],pOwnerLord->OnOffFlags[4],pOwnerLord->OnOffFlags[5],pOwnerLord->OnOffFlags[6])) ||
		 !(pOwnerLord->BetSpot[PayoutOrder[BetCounter]]->HasBSBet(Player))   ) )
		{BetCounter++;}
		if(BetCounter >= 43)
		{
		 if(Player == 2)
		 {Player2 = false;BetCounter = 0;}
		 if(Player == 1)
		 {Player1 = false;BetCounter = 0;}
		 if(Player == 0)
		 {Player0 = false;BetCounter = 0;}
       ExecuteWaiting = true;
		 ExecuteStatus    = ess_Execute;
		}
		else
		{ExecuteStatus = ess_StartSubState1;GetNextWinner = false;}
	 }
  }
  if (WaitOnGetMark)
  {
	 if((StartingFUC + 3) == NewFUC)
	 {
		pOwnerLord->Puck->NoShow();
	 }
	 if((StartingFUC + FUCLength - 2) <= NewFUC)
	 {
		pOwnerLord->Puck->SetNum(0);
		WaitOnGetMark = false;
		ExecuteWaiting = false;
		ExecuteStatus = ess_Done;
	 }
  }

  if(MenuEscResponder != NULL)
  {
	// pOwnerLord->MenuEscButton->Release();
	 if (MenuEscResponder->GetResponseEvent() != reChar)
	 {
		MenuEscResponder->ClearPriority();
	 }
	 MenuEscResponder = NULL;

	 return;
  }

}
//*******************************************************************
bool TCAct2State::HandleMenuEsc(TResponder &responder)
{
  if(!WaitOnMarker || !WaitOnResult)
  {
  if (responder.GetResponseEvent() == reLUp)
  {
	 MenuEscResponder = &responder;
  }

  if (responder.GetResponseEvent() == reLDown)
  {
	 //pOwnerLord->MenuEscButton->Depress();
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
	 //pOwnerLord->MenuEscButton->Depress();
	 MenuEscResponder = &responder;
  }
  }
  return true;
}
//*******************************************************************