//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  cclordst.cpp
//    Project Name:  Ogle
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     06/01/95   A. Krist    Original baseline
//  2.0     09/18/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "cclordst.h"
#include "ccglord.h"
#include "ccplay.h"
//*******************************************************************
TCLordState::TCLordState(TCasinoCGameLord *pNewCLord)
{
  pOwnerLord = pNewCLord;
  LockButtons = false;
  LockHit = false;
  HitTotal = false;
  IgnoreCoach = false;
  ExpertDelayStart = 0;
}
//*******************************************************************
TCLordState::~TCLordState()
{
}
//*******************************************************************
bool TCLordState::StatBar(TResponder &responder)
{
  return HandleStatBar(responder);
}
//*******************************************************************
bool TCLordState::BetSpot(TResponder &responder,int16 spot)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TCLordState *)PActiveSubState)->BetSpot(responder,spot);
  }
  else
  {
	 return HandleBetSpot(responder,spot);
  }
}
//*******************************************************************
bool TCLordState::NamePlate(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TCLordState *)PActiveSubState)->NamePlate(responder);
  }
  else
  {
	 return HandleNamePlate(responder);
  }
}
//*******************************************************************
bool TCLordState::OneChip(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TCLordState *)PActiveSubState)->OneChip(responder);
  }
  else
  {
	 return HandleOneChip(responder);
  }
}
//*******************************************************************
bool TCLordState::FiveChip(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TCLordState *)PActiveSubState)->FiveChip(responder);
  }
  else
  {
	 return HandleFiveChip(responder);
  }
}
//*******************************************************************
bool TCLordState::AskExpertButton(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TCLordState *)PActiveSubState)->AskExpertButton(responder);
  }
  else
  {
	 return HandleAskExpert(responder);
  }
}
//*******************************************************************
bool TCLordState::TwentyFiveChip(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TCLordState *)PActiveSubState)->TwentyFiveChip(responder);
  }
  else
  {
	 return HandleTwentyFiveChip(responder);
  }
}
//*******************************************************************
bool TCLordState::OneHundredChip(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TCLordState *)PActiveSubState)->OneHundredChip(responder);
  }
  else
  {
	 return HandleOneHundredChip(responder);
  }
}
//*******************************************************************
bool TCLordState::OneThouChip(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TCLordState *)PActiveSubState)->OneThouChip(responder);
  }
  else
  {
	 return HandleOneThouChip(responder);
  }
}
//*******************************************************************
bool TCLordState::TenThouChip(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TCLordState *)PActiveSubState)->TenThouChip(responder);
  }
  else
  {
	 return HandleTenThouChip(responder);
  }
}
//*******************************************************************
bool TCLordState::Button1(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TCLordState *)PActiveSubState)->Button1(responder);
  }
  else
  {
	 return HandleButton1(responder);
  }
}
//*******************************************************************
bool TCLordState::Button2(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TCLordState *)PActiveSubState)->Button2(responder);
  }
  else
  {
	 return HandleButton2(responder);
  }
}
//*******************************************************************
bool TCLordState::Button3(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TCLordState *)PActiveSubState)->Button3(responder);
  }
  else
  {
	 return HandleButton3(responder);
  }
}
//*******************************************************************
bool TCLordState::Button4(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TCLordState *)PActiveSubState)->Button4(responder);
  }
  else
  {
	 return HandleButton4(responder);
  }
}
//*******************************************************************
bool TCLordState::MenuEscButton(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TCLordState *)PActiveSubState)->MenuEscButton(responder);
  }
  else
  {
	 return HandleMenuEsc(responder);
  }
}
//*******************************************************************
