//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  crposp.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0    03/23/96    A.Krist     moved inline functions into .cpp file.
//  2.0    09/18/97    M.Perry     32-bit conversion.
//********************************************************************
#include "ccposp.h"
#include "oanm.h"
//*******************************************************************
void TCPayOff::SetupAnms()
{
  for(int16 j=0;j<3;j++)
  {
	 for (int16 i=0;i<6;i++)
	 {
		PPayOffChips[j][i] = GetAnm(int16(i+(j*6)));
		if (PPayOffChips[j][i] == NULL) {AnmError("CPayOff","Chips",int16(i+(j*6)));}
		PPayOffChips[j][i]->CAD.ClearAutoStart();
		PPayOffChips[j][i]->CAD.ClearAutoStop();
		PPayOffChips[j][i]->CAD.SetDirStill();
	 }
  }
}
//*******************************************************************
TCPayOff::TCPayOff(TOgleModeWindow *pmw,const TFileMode &NewFileMode)
:TSprite(pmw,NewFileMode)
{
  SetToManual();
  NotFound = false;
  NoShow();
  WinAmount = 0l;
  SetupAnms();
}
//********************************************************************
TCPayOff::TCPayOff(TOgleModeWindow *pmw,const TFileMode &fm,void *psource)
:TSprite(pmw,fm,psource)
{
  SetToManual();
  NotFound = false;
  NoShow();
  WinAmount = 0l;
  SetupAnms();
}
 //*******************************************************************
TCPayOff::~TCPayOff()
{
}
//*******************************************************************
void TCPayOff::NoShowChips()
{
  for(int16 i=0;i<6;i++)
  {
	 PPayOffChips[0][i]->NoShow();
	 PPayOffChips[0][i]->NoShow();
	 PPayOffChips[0][i]->NoShow();
  }
}
//*******************************************************************
void TCPayOff::SetNum(int16 slot,TMoney money)
{
  int32 amount = (int32)money;
  if (NotFound) {return;}
  int32 num=0;
  int16 yoffset,zoffset;
  num = amount;
  num = num%100000l;
  yoffset   = PPayOffChips[slot][0]->SAD.GetY();
  zoffset   = PPayOffChips[slot][0]->SAD.GetZ();

  int32 tenthous = num / 10000;
  int32 tenthousvalue = tenthous * 10000;
  int32 thous = (num - tenthousvalue) / 1000;
  int32 thousvalue = thous * 1000;
  int32 huns = (num - tenthousvalue - thousvalue) / 100;
  int32 hunsvalue = huns * 100;
  int32 twfive = (num - tenthousvalue - thousvalue - hunsvalue) / 25;
  int32 twfivevalue = twfive * 25;
  int32 fives = (num - tenthousvalue - thousvalue - hunsvalue - twfivevalue) / 5;
  int32 fivesvalue = fives * 5;
  int32 ones = (num - tenthousvalue - thousvalue - hunsvalue - twfivevalue - fivesvalue);


  if (tenthous)
  {
	 PPayOffChips[slot][5]->CAD.SetY(yoffset);
	 PPayOffChips[slot][5]->CAD.SetZ(zoffset);

	 PPayOffChips[slot][5]->CAD.SetCurrentFrame(int16(tenthous - 1));
	 PPayOffChips[slot][5]->Show();
  }
  else {PPayOffChips[slot][5]->NoShow();}
  yoffset -= int16(2*tenthous);
  zoffset += int16(tenthous);

  if (thous)
  {
	 PPayOffChips[slot][4]->CAD.SetY(yoffset);
	 PPayOffChips[slot][4]->CAD.SetZ(zoffset);

	 PPayOffChips[slot][4]->CAD.SetCurrentFrame(int16(thous - 1));
	 PPayOffChips[slot][4]->Show();
  }
  else {PPayOffChips[slot][4]->NoShow();}
  yoffset -= int16(2*thous);
  zoffset += int16(thous);

  if (huns)
  {
	 PPayOffChips[slot][3]->CAD.SetY(yoffset);
	 PPayOffChips[slot][3]->CAD.SetZ(zoffset);

	 PPayOffChips[slot][3]->CAD.SetCurrentFrame(int16(huns - 1));
	 PPayOffChips[slot][3]->Show();
  }
  else {PPayOffChips[slot][3]->NoShow();}
  yoffset -= int16(2*huns);
  zoffset += int16(huns);

  if (twfive)
  {
	 PPayOffChips[slot][2]->CAD.SetY(yoffset);
	 PPayOffChips[slot][2]->CAD.SetZ(zoffset);

	 PPayOffChips[slot][2]->CAD.SetCurrentFrame(int16(twfive - 1));
	 PPayOffChips[slot][2]->Show();
  }
  else {PPayOffChips[slot][2]->NoShow();}
  yoffset -= int16(2*twfive);
  zoffset += int16(twfive);

  if (fives)
  {
	 PPayOffChips[slot][1]->CAD.SetY(yoffset);
	 PPayOffChips[slot][1]->CAD.SetZ(zoffset);

	 PPayOffChips[slot][1]->CAD.SetCurrentFrame(int16(fives - 1));
	 PPayOffChips[slot][1]->Show();
  }
  else {PPayOffChips[slot][1]->NoShow();}
  yoffset -= int16(2*fives);
  zoffset += int16(fives);

  if (ones)
  {
	 PPayOffChips[slot][0]->CAD.SetY(yoffset);
	 PPayOffChips[slot][0]->CAD.SetZ(zoffset);

	 PPayOffChips[slot][0]->CAD.SetCurrentFrame(int16(ones - 1));
	 PPayOffChips[slot][0]->Show();
  }
  else {PPayOffChips[slot][0]->NoShow();}
  Update(GetAdjFUC());

}
//*******************************************************************