//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  ccrmst.cpp
//    Project Name:  Casino
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     3/9/96   A. Krist    Original baseline
//  2.0    09/18/97  M.Perry     32-bit conversion.
//*******************************************************************
#include "ccrmst.h"
#include "ccglord.h"
#include "cascmw.h"
#include "orespond.h"
//*******************************************************************
TCRemoveState::TCRemoveState(TCasinoCGameLord *pNewCLord)
:TCLordState(pNewCLord)
{
  BetSpotResponder           = NULL;
  Button1Responder            = NULL;
  QuickKick                   = false;
}
//*******************************************************************
TCRemoveState::~TCRemoveState()
{
  pOwnerLord->Button5->ShowVoidUp();
  pOwnerLord->Button3->ShowVoidUp();
  pOwnerLord->EnableAllButtons();
  pOwnerLord->messagestate = 1;
}
//*******************************************************************
void TCRemoveState::ExecuteFirstTime()
{
  pOwnerLord->messagestate = 2;
  pOwnerLord->MessageDisplay->ShowCrapsMessage(2);
  ExecuteWaiting = true;
  ExecuteStatus    = ess_Execute;
  pOwnerLord->DisEnableAllButtons();
  pOwnerLord->EnableButton(5);
  pOwnerLord->EnableButton(3);

}
//*******************************************************************
void TCRemoveState::HandlePostUpdate(dword NewFUC)
{
  if (BetSpotResponder != NULL)
  {
	 if (BetSpotResponder->GetResponseEvent() != reChar)
	 {
		BetSpotResponder->ClearPriority();
	 }
	 if(!pOwnerLord->BetMade(pOwnerLord->activeplayer))
	 {
		QuickKick = true;;
	 }
	 BetSpotResponder = NULL;
	 return;
  }
  if(pOwnerLord->ButtonHit[cidButton5])
  {
	 pOwnerLord->ButtonClear(cidButton5);
	 ExecuteWaiting = false;
	 ExecuteStatus  = ess_Done;
	 return;
  }
  if(pOwnerLord->ButtonHit[cidButton3])
  {
	 pOwnerLord->ButtonClear(cidButton3);
	 LockHit = false;

	 return;
  }
  if(QuickKick)
  {
	 QuickKick = false;
	 ExecuteWaiting = false;
	 ExecuteStatus  = ess_Done;
  }
  if(NewFUC){return;}
}
//*******************************************************************
bool TCRemoveState::HandleBetSpot(TResponder &responder,int16 spot)
{
  if (responder.GetResponseEvent() == reLUp)
  {
	 if(pOwnerLord->BetSpot[spot]->HasBSBet(pOwnerLord->activeplayer))
	 {
		pOwnerLord->RemoveBet(spot);

		BetSpotResponder = &responder;
	 }
	 else
	 {
		responder.ClearPriority();
	 }
  }

  if (responder.GetResponseEvent() == reLDown)
  {
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
	 if(pOwnerLord->BetSpot[spot]->HasBSBet(pOwnerLord->activeplayer))
	 {
		pOwnerLord->RemoveBet(spot);
		BetSpotResponder = &responder;
	 }
	 BetSpotResponder = &responder;
  }
  return true;
}
//*******************************************************************
bool TCRemoveState::HandleButton1(TResponder &responder)
{
  if (responder.GetResponseEvent() == reLUp)
  {
	 Button1Responder = &responder;
  }

  if (responder.GetResponseEvent() == reLDown)
  {
	// pOwnerLord->Button1->ShowRemoveDown();
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
  //	 pOwnerLord->Button1->ShowRemoveDown();
	 Button1Responder = &responder;
  }
  return true;
}
//*******************************************************************