//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  hscdsp.cpp
//    Project Name:  Casino
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0    12/23/95    A.Krist    moved inline functions into .cpp file.
//  2.0    09/04/97    M.Perry    32-bit conversion.
//********************************************************************
#include "hscdsp.h"
#include "oanm.h"
#include <assert.h>
//*******************************************************************
THSCashDisplay::THSCashDisplay(TOgleModeWindow *pmw,TFileMode NewFileMode,void *psource)
  :TSprite(pmw,NewFileMode,psource)
{
  NoShow();
  SetToManual();
  SetupAnms();
  DelayEndFUC = 0;
  DELAY = false;
}
//*******************************************************************
THSCashDisplay::THSCashDisplay(TOgleModeWindow *pmw,TFileMode NewFileMode):TSprite(pmw,NewFileMode)
{
  NoShow();
  SetToManual();
  SetupAnms();
  DelayEndFUC = 0;
  DELAY = false;
}
//********************************************************************
THSCashDisplay::~THSCashDisplay()
{
}
//*******************************************************************
void THSCashDisplay::Update(dword NewFUC)
{
  if(DELAY)
  {
	 if(DelayEndFUC<=NewFUC)
	 {
		DELAY = false;
		DelayEndFUC = 0;
	 }
  }
  TSprite::Update(NewFUC);
}
//*******************************************************************
#pragma argsused
void THSCashDisplay::ShowMessageString(string str,dword fuclen,int OffSet)
{
}
//*******************************************************************
#pragma argsused
void THSCashDisplay::ShowWinNum(TMoney money,dword fuclen)
{
}
//*******************************************************************
#pragma argsused
void THSCashDisplay::ShowCashOut(TMoney money,dword fuclen)
{
}
//*******************************************************************
#pragma argsused
void THSCashDisplay::ShowBetNum(TMoney money,dword fuclen)
{
}
//*******************************************************************
#pragma argsused
void THSCashDisplay::NoShowDisplay(bool back)
{
}
//*******************************************************************
void THSCashDisplay::SetupAnms()
{
  int16 j=0;

  for(j=14;j>=0;j--)
  {
	 PDigits[j]  = NULL;
	 PDigits[j]  = GetAnm(int16(14-j));
	 assert(PDigits[j]);
	 PDigits[j]->CAD.ClearAutoStart();
	 PDigits[j]->CAD.ClearAutoStop();
	 PDigits[j]->CAD.SetDirStill();

  }
}
//*******************************************************************
#pragma argsused
int THSCashDisplay::SetNum(TMoney money,dword fuclen)
{
  long num = (long)money;
  int framesused=9,i=0;
  bool found = false;
  long hunmil=0;
  long tenmil=0;
  long million=0;
  long hunthou=0;
  long tenthou=0;
  long thousan=0;
  long hun=0;
  long ten=0;
  long one=0;

  for(i=0;i<15;i++)
  {
	 PDigits[i]->CAD.SetX(PDigits[i]->SAD.GetX());
	 PDigits[i]->CAD.SetCurrentFrame(0);
	 PDigits[i]->NoShow();
  }
  if( (num/1000) )
  {
	 PDigits[6]->CAD.SetCurrentFrame(11);
	 PDigits[6]->Show();
  }
  if( (num/1000000l) )
  {
	 PDigits[10]->CAD.SetCurrentFrame(11);
	 PDigits[10]->Show();
  }
  PDigits[2]->CAD.SetCurrentFrame(12);
  PDigits[2]->Show();
  if(money < 0)
  {
	 PDigits[4]->CAD.SetCurrentFrame(10);
	 PDigits[4]->Show();
  }
  hunmil  = (num/100000000l)%10;
  if(!hunmil && !found){framesused--;}else{found=TRUE;}

  tenmil  = (num/10000000l)%10;
  if(!tenmil && !found){framesused--;}else{found=TRUE;}

  million = (num/1000000l) %10;
  if(!million && !found){framesused--;}else{found=TRUE;}

  hunthou = (num/100000l)  %10;
  if(!hunthou && !found){framesused--;}else{found=TRUE;}

  tenthou = (num/10000)   %10;
  if(!tenthou && !found){framesused--;}else{found=TRUE;}

  thousan = (num/1000)    %10;
  if(!thousan && !found)   {framesused--;}else{found=TRUE;}

  hun     = (num/100)     %10;
  if(!hun && !found)    {framesused--;}else{found=TRUE;}

  ten     = (num/10)      %10;
  if(!ten && !found)    {framesused--;}else{found=TRUE;}

  one     = (num  )       %10;
  if(!one && !found)    {framesused--;}else{found=TRUE;}

  PDigits[0]->CAD.SetCurrentFrame(int16(money.GetCents()%10));
  PDigits[0]->Show();
  PDigits[1]->CAD.SetCurrentFrame(int16(money.GetCents()/10));
  PDigits[1]->Show();
  PDigits[3]->CAD.SetCurrentFrame(int16(one));
  PDigits[3]->Show();

  if(framesused > 1)
  {
	 PDigits[4]->CAD.SetCurrentFrame(int16(ten));
	 PDigits[4]->Show();
  }
  else
  {
	 PDigits[4]->CAD.SetCurrentFrame(10);
	 PDigits[4]->Show();
  }

  if(framesused > 2)
  {
	 PDigits[5]->CAD.SetCurrentFrame(int16(hun));
	 PDigits[5]->Show();
  }
  else
  {
	 if(framesused == 2)
	 {
		PDigits[5]->CAD.SetCurrentFrame(10);
		PDigits[5]->Show();
	 }
	 else
	 {
		PDigits[5]->NoShow();
	 }
  }

  if(framesused > 3)
  {
	 PDigits[6]->CAD.SetCurrentFrame(11);
	 PDigits[6]->Show();
  }
  else
  {
	 if(framesused == 3)
	 {
		PDigits[6]->CAD.SetCurrentFrame(10);
		PDigits[6]->Show();
	 }
	 else
	 {
		PDigits[6]->NoShow();
	 }
  }
  if(framesused > 4)
  {
	 PDigits[7]->CAD.SetCurrentFrame(int16(thousan));
	 PDigits[7]->Show();
  }
  else
  {
	 if(framesused == 4)
	 {
		PDigits[7]->CAD.SetCurrentFrame(int16(thousan));
		PDigits[7]->Show();
		PDigits[8]->CAD.SetCurrentFrame(10);
		PDigits[8]->Show();
	 }
	 else
	 {
		PDigits[7]->NoShow();
	 }
  }

  if(framesused > 5)
  {
	 PDigits[8]->CAD.SetCurrentFrame(int16(tenthou));
	 PDigits[8]->Show();
  }
  else
  {
	 if(framesused == 5)
	 {
		PDigits[8]->CAD.SetCurrentFrame(int16(tenthou));
		PDigits[8]->Show();
		PDigits[9]->CAD.SetCurrentFrame(10);
		PDigits[9]->Show();
	 }
	 else if(framesused != 4)
	 {
		PDigits[8]->NoShow();
	 }
  }

  if(framesused > 6)
  {
	 PDigits[9]->CAD.SetCurrentFrame(int16(hunthou));
	 PDigits[9]->Show();
	 PDigits[10]->CAD.SetCurrentFrame(11);
	 PDigits[10]->Show();
  }
  else
  {
	 if(framesused == 6)
	 {
		PDigits[9]->CAD.SetCurrentFrame(int16(hunthou));
		PDigits[9]->Show();
		PDigits[10]->CAD.SetCurrentFrame(10);
		PDigits[10]->Show();
	 }
	 else if(framesused != 5)
	 {
		PDigits[9]->NoShow();
	 }
  }

  if(framesused >= 7)
  {
		PDigits[11]->CAD.SetCurrentFrame(int16(million));
		PDigits[11]->Show();
		PDigits[12]->CAD.SetCurrentFrame(10);
		PDigits[12]->Show();
  }
  Update(GetAdjFUC());
  return framesused;
}
//*******************************************************************