//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  hscoutst.cpp
//    Project Name:  Casino
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     09/29/95   A. Krist    Original baseline
//  2.0     09/04/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "hscoutst.h"
#include "hsplay.h"
#include "cashsmw.h"
#include "orespond.h"
#include "owav.h"
#include "oanm.h"
//*******************************************************************
THSCashOutState::THSCashOutState(TCasinoHSGameLord *pNewHSLord)
:THSLordState(pNewHSLord)
{
  SpeedClickResponder = NULL;
  Count = 0;
  Start16 = false;
}
//*******************************************************************
THSCashOutState::~THSCashOutState()
{
}
//*******************************************************************
void THSCashOutState::ExecuteFirstTime()
{
  ExecuteWaiting = true;
  ExecuteStatus    = ess_Execute;
  pOwnerLord->CashOut();
  if(pOwnerLord->credits > 0)
  {
	 switch((long)pOwnerLord->credits)
	 {
		case 1  : pOwnerLord->CoinPay->PlaySound(0);break;
		case 2  : pOwnerLord->CoinPay->PlaySound(1);break;
		case 3  : pOwnerLord->CoinPay->PlaySound(2);break;
		case 4  : pOwnerLord->CoinPay->PlaySound(3);break;
		case 5  : pOwnerLord->CoinPay->PlaySound(4);break;
		default : pOwnerLord->CoinPay->PlaySound(5);Start16 = true;break;
	 }
  }
}
//*******************************************************************
void THSCashOutState::HandlePostUpdate(dword NewFUC)
{
  if (SpeedClickResponder != NULL)
  {
	 if (SpeedClickResponder->GetResponseEvent() != reChar)
	 {
		SpeedClickResponder->ClearPriority();
	 }
	 if (pOwnerLord->credits > 0)
	 {
		pOwnerLord->CoinPay->SetTray(pOwnerLord->credits-1+Count);
		pOwnerLord->AddCash(pOwnerLord->activeplayer,pOwnerLord->coinsize*pOwnerLord->credits);
		pOwnerLord->credits = 0;
		pOwnerLord->Credits->SetNum(pOwnerLord->credits);
		pOwnerLord->CoinPay->StopSounds();
	 }
	 SpeedClickResponder = NULL;
	 ExecuteWaiting = false;
	 pOwnerLord->CoinPay->PlaySound(6);
	 return;
  }

  if (pOwnerLord->credits > 0)
  {
	 Count++;
	 pOwnerLord->CoinPay->SetTray(Count-1);
	 if(pOwnerLord->CoinPay->PWavs[5]->GetStopped() && Start16)
	 {
		pOwnerLord->CoinPay->PlaySound(5);
	 }
	 /*if(pOwnerLord->CoinPay->PCoinPay->CAD.GetCurrentFrame() == 98 && Start16)
	 {
		pOwnerLord->Sounds->Sounds[16]->Stop();
		Start16 = FALSE;
	 } */
	 pOwnerLord->credits--;
	 pOwnerLord->AddCash(pOwnerLord->activeplayer,pOwnerLord->coinsize);
	 pOwnerLord->Credits->SetNum(pOwnerLord->credits);
  }
  else
  {
	 pOwnerLord->CoinPay->StopSounds();
	 ExecuteWaiting = false;
	 pOwnerLord->CoinPay->PlaySound(6);
  }
  if(NewFUC){return;}
}
//*******************************************************************
bool THSCashOutState::HandleSpeedClick(TResponder &responder)
{
  if (responder.GetResponseEvent() == reRUp)
  {
	 SpeedClickResponder = &responder;
  }

  if (responder.GetResponseEvent() == reRDown)
  {
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
	 SpeedClickResponder = &responder;
  }
  return true;
}
//*******************************************************************
