//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  hscpsp.cpp
//    Project Name:  Casino
// Original Author:  Adam Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     7/19/96    A.Krist      moved into cpp file.
//  2.0    09/04/97    M.Perry      32-bit conversion.
//********************************************************************
#include "hscpsp.h"
#include "oanm.h"
#include "owav.h"
//********************************************************************
bool THSCoinsPlayed::IsWaveStopped(int16 wave)
{
  if(wave != -1)
  {
	 if(PWavs[wave]->GetStarted() && PWavs[wave]->GetStopped())
	 {
		return true;
	 }
  }
  if(PWavs[MostRecentWav]->GetStarted() && PWavs[MostRecentWav]->GetStopped())
  {
	return true;
  }
  return false;
}
  //*******************************************************************
void THSCoinsPlayed::PlaySound(int16 sound)
{
  if (sound >= 0 && sound < 10)
  {
    PWavs[sound]->Start();
    MostRecentWav = sound;
  }
}
//*******************************************************************
void THSCoinsPlayed::SetupAnms()
{
  PNums = GetAnm(0);
  if (PNums == NULL) {AnmError("Coins Played","Nums",0);}
  TAnmData ad = PNums->CAD;
  ad.ClearAutoStart();
  ad.SetDirStill();
  ad.ClearAutoStop();
  PNums->SetCurrentData(ad);
  for(int16 z=0;z<10;z++)
  {
//	 PWavs[z] = NULL;
	 PWavs[z] = GetWav(z);
	 if (PWavs[z] == NULL) {AnmError("Sound Sprite","sound",z);}
  }
}
//*******************************************************************
THSCoinsPlayed::THSCoinsPlayed(TOgleModeWindow *pmw,const TFileMode &NewFileMode)
:TSprite(pmw,NewFileMode)
{
  SetToManual();
  SetupAnms();
  MostRecentWav = 0;
}
//*******************************************************************
THSCoinsPlayed::THSCoinsPlayed(TOgleModeWindow *pmw,const TFileMode &NewFileMode,void *psource)
:TSprite(pmw,NewFileMode,psource)
{
  SetToManual();
  SetupAnms();
  MostRecentWav = 0;
}
//*******************************************************************
THSCoinsPlayed::~THSCoinsPlayed()
{
}
//*******************************************************************
void THSCoinsPlayed::SetNum(int16 num)
{
  if (PNums == NULL) {return;}
  PNums->CAD.SetCurrentFrame(num);
  PNums->Show();
  Update(GetAdjFUC());
}
//*******************************************************************