//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  hslgld.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     10/11/95   M.Perry    Original baseline
//  2.0     09/09/97   M.Perry    32-bit conversion.
//  2.3     06/26/99   M.Perry    filename mod's.
//*******************************************************************
#include "hslgld.h"
#include "oskitcat.h"
#include "ogamefw.h"
#include "orespond.h"
#include "owav.h"
#include "clnames.rh"
//*******************************************************************
TSprite *THSLobby1GameLord::CreateSprite(string spritename,int16 id,void *psource)
{
  TFileMode FM(spritename,
               TFileMode::fm_None,
               TFileMode::fm_None,
               FileMode.GetDirIndex());

  if (psource != NULL)
  {
	 if(spritename == "\\o1glrd00\\o100stsb.sp")
	 {
		Sounds = new THSSound(PModeWin,FM,psource);
		return Sounds;
	 }
	 if(spritename == "\\o1glrd00\\o100pays.sp")
	 {
		WinHighLight = new THSLWinHighLight(PModeWin,FM,psource);
		return WinHighLight;
	 }
	 if(spritename == "\\o1glrd00\\o100play.sp")
	 {
      TRect budrect(259,209,343,219);
		BudPlayButton = new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)this,125,budrect,HSLidBudPlay,false/*true*/,'m'); // MRP 7/29/97
		return BudPlayButton;
	 }
	 if(spritename == "\\o1glrd00\\o100prog.sp")
	 {
		Progressive = new THSProgressive(PModeWin,FM,psource);
		return Progressive;
	 }
	 if(spritename == "\\o1glrd00\\o100bank.sp")
	 {
		BankCashDisplay = new THSCashDisplay(PModeWin,FM,psource);
		return BankCashDisplay;
	 }
	 if(spritename == "\\o1glrd00\\o100name.sp")
	 {
		NamePlate1 = new THSNamePlate(PModeWin,FM,psource);
		return NamePlate1;
	 }
	 if(spritename == "\\o1glrd00\\o100crdl.sp")
	 {
      TRect createrect(232,463,388,477);
		CreateButton = new TCasButton(PModeWin,FM,psource,this,100,createrect,HSLidCreate,true);
		return CreateButton;
	 }
	 if(spritename == "\\o1glrd00\\o100menu.sp")
	 {
      TRect menurect(138,439,212,470);
		return (new TCasButton(PModeWin,FM,psource,this,100,menurect,HSLidButton0,true));
	 }
	 if (spritename == "\\o1glrd00\\o100mess.sp")
	 {
		return (new THSLobbyMessageDisplay(PModeWin,FM,psource));
	 }
	 if(spritename == "\\o1glrd00\\o100rel1.sp")
	 {
		Reel1 = new THSReel(PModeWin,FM,psource);
		return Reel1;
	 }
	 if(spritename == "\\o1glrd00\\o100rel2.sp")
	 {
		Reel2 = new THSReel(PModeWin,FM,psource);
		return Reel2;
	 }
	 if(spritename == "\\o1glrd00\\o100rel3.sp")
	 {
		Reel3 = new THSReel(PModeWin,FM,psource);
		return Reel3;
	 }
	 return new TSprite(PModeWin,FM,psource);
  }
  else
  {
	 FM.SetRamImmed();
	 if(spritename == "\\o1glrd00\\o100stsb.sp")
	 {
		Sounds = new THSSound(PModeWin,FM);
		return Sounds;
	 }
	 if(spritename == "\\o1glrd00\\o100pays.sp")
	 {
		WinHighLight = new THSLWinHighLight(PModeWin,FM);
		return WinHighLight;
	 }
	 if(spritename == "\\o1glrd00\\o100play.sp")
	 {
      TRect budrect(259,209,343,219);
		BudPlayButton = new TCasButton(PModeWin,FM,(TCasinoGameLord *)this,125,budrect,HSLidBudPlay,false/*true*/,'m'); // MRP 7/29/97
		return BudPlayButton;
	 }
	 if(spritename == "\\o1glrd00\\o100prog.sp")
	 {
		Progressive = new THSProgressive(PModeWin,FM);
		return Progressive;
	 }
	 if(spritename == "\\o1glrd00\\o100bank.sp")
	 {
		BankCashDisplay = new THSCashDisplay(PModeWin,FM);
		return BankCashDisplay;
	 }
	 if(spritename == "\\o1glrd00\\o100name.sp")
	 {
		NamePlate1 = new THSNamePlate(PModeWin,FM);
		return NamePlate1;
	 }
	 if(spritename == "\\o1glrd00\\o100crdl.sp")
	 {
      TRect createrect(232,463,388,477);
		CreateButton = new TCasButton(PModeWin,FM,this,100,createrect,HSLidCreate,true);
		return CreateButton;
	 }
	 if(spritename == "\\o1glrd00\\o100menu.sp")
	 {
      TRect menurect(138,439,212,470);
		return (new TCasButton(PModeWin,FM,this,100,menurect,HSLidButton0,true));
	 }
	 if (spritename == "\\o1glrd00\\o100mess.sp")
	 {
		return (new THSLobbyMessageDisplay(PModeWin,FM));
	 }
	 if(spritename == "\\o1glrd00\\o100rel1.sp")
	 {
		Reel1 = new THSReel(PModeWin,FM);
		return Reel1;
	 }
	 if(spritename == "\\o1glrd00\\o100rel2.sp")
	 {
		Reel2 = new THSReel(PModeWin,FM);
		return Reel2;
	 }
	 if(spritename == "\\o1glrd00\\o100rel3.sp")
	 {
		Reel3 = new THSReel(PModeWin,FM);
		return Reel3;
	 }
	 return new TSprite(PModeWin,FM);
  }
}
//*******************************************************************
void THSLobby1GameLord::SetupSprites()
{
  if (Sounds  == NULL) {SpriteError("Slots Sounds","sounds");}
  Sounds->Start(GetFUC());
  coinsplayedwav = GetSpriteIndex("\\o1glrd00\\o100coin.sp");
  spin1 = GetSpriteIndex("\\o1glrd00\\o100spn1.sp");
  spin2 = GetSpriteIndex("\\o1glrd00\\o100spn2.sp");
  spin3 = GetSpriteIndex("\\o1glrd00\\o100spn3.sp");
  win1  = GetSpriteIndex("\\o1glrd00\\o100bwn1.sp");
  win2  = GetSpriteIndex("\\o1glrd00\\o100bwn2.sp");
  win3  = GetSpriteIndex("\\o1glrd00\\o100bwn3.sp");
  win4  = GetSpriteIndex("\\o1glrd00\\o100bwn4.sp");
  win5  = GetSpriteIndex("\\o1glrd00\\o100bwn5.sp");
  if (Reel1           == NULL) {SpriteError("Reel1","rel1");}
  if (Reel2           == NULL) {SpriteError("Reel2","rel2");}
  if (Reel3           == NULL) {SpriteError("Reel3","rel3");}

  ActivateSpriteNow(Reel1);
  Reel1->NoShow();
  ActivateSpriteNow(Reel2);
  Reel2->NoShow();
  ActivateSpriteNow(Reel3);
  Reel3->NoShow();
  volcano1              = GetSkitListIndex("\\o1glrd00\\o100kcv1.skl");
  if (volcano1 == -1)     {SpriteError("volcano1","vol1");}
  volcano2              = GetSkitListIndex("\\o1glrd00\\o100kcv2.skl");
  if (volcano2 == -1)     {SpriteError("volcano2","vol2");}
  bud1              = GetSkitListIndex("\\o1glrd00\\o100kceb.skl");
  if (bud1 == -1)     {SpriteError("bud1","eb");}
 // bud2              = GetSkitListIndex("o100kcfb");
 // if (bud2 == -1)     {SpriteError("bud2","fb");}
  if (BankCashDisplay == NULL)    {SpriteError("BankCashDisplay","bank");}
  if (NamePlate1 == NULL)    {SpriteError("NamePlate1","name"        );}
  BankCashDisplay->Start(GetFUC());
  NamePlate1->Start(GetFUC());

  MenuEscButton   = (TCasButton *) GetSpritePtr("\\o1glrd00\\o100menu.sp");
  if (MenuEscButton   == NULL) {SpriteError("Menu Esc Button","o100menu");}
  if (CreateButton   == NULL) {SpriteError("Create Button","o100crdl");}
  if (WinHighLight   == NULL) {SpriteError("WinHighLight","o100pays");}
  ActivateSpriteNow(CreateButton);
  if (BudPlayButton   == NULL) {SpriteError("BudPlay Button","o100play");}
  ActivateSpriteNow(BudPlayButton);
  BudPlayButton->NoShow();
  if (GetFW()->GetHandleShowMenu())
  {
	 ActivateSpriteNow(MenuEscButton);
  }
  else
  {
	 MenuEscButton->Freeze = true;
	 MenuEscButton->PButtonResponder->Remove();
  }
  if(Progressive != NULL)
  {
	 Progressive->Start(GetFUC());
  }
  MessageDisplay   = NULL;
  MessageDisplay     = (THSLobbyMessageDisplay    *) GetSpritePtr("\\o1glrd00\\o100mess.sp");
  if (MessageDisplay == NULL)     {SpriteError("MessageDisplay","o100mess");}
  MessageDisplay->Start(GetFUC());
  ActivateSpriteNow(WinHighLight);
  WinHighLight->NoShow();
}
//*******************************************************************
void THSLobby1GameLord::CleanupSprites()
{
}
//*******************************************************************
THSLobby1GameLord::THSLobby1GameLord(TLobbyModeWin *pmwin,const TFileMode &fm)
  :TCasinoHSLGameLord(pmwin,fm)
{
  TFileMode splfm(SpriteListName,
                  TFileMode::fm_None,
                  TFileMode::fm_Immed,
                  FileMode.GetDirIndex());

  CreateAddSpriteList(splfm);

  TFileMode skcfm(SkitCatName,
                  TFileMode::fm_None,
                  TFileMode::fm_Immed,
                  FileMode.GetDirIndex());

  CreateAddSkitCat(splfm);

  TFileMode mdfm(strMiscDataName,
                 TFileMode::fm_None,
                 TFileMode::fm_Immed,
                 FileMode.GetDirIndex());

  CreateAddMiscData(mdfm);

  SetupSprites();
}
//*******************************************************************
THSLobby1GameLord::~THSLobby1GameLord()
{
  CleanupSprites();
}
//*******************************************************************
