//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  hsposp.cpp
//    Project Name:  Casino
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     5/19/97    A.Krist     moved into cpp file.
//********************************************************************
#include "hsposp.h"
#include "oanm.h"
#include "owav.h"
//*******************************************************************
void THSCoinPay::StopSounds()
{
  for(int i=0;i<7;i++)
  {
	 PWavs[i]->Stop();
  }
}
//*******************************************************************
void THSCoinPay::PlaySound(int16 sound)
{
  if (sound >= 0 && sound < 7)
  {
    PWavs[sound]->Start();
  }
}
//*******************************************************************
void THSCoinPay::SetupAnms()
{
  for(int16 i=0;i<8;i++)
  {
	 PCoinPay[i] = GetAnm(i);
	 if (PCoinPay[i] == NULL) {AnmError("CoinPay","Bar",i);}
	 PCoinPay[i]->CAD.ClearAutoStart();
	 PCoinPay[i]->CAD.ClearAutoStop();
	 PCoinPay[i]->CAD.SetDirStill();;
  }
  for(int16 z=0;z<7;z++)
  {
	 PWavs[z] = GetWav(z);
	 if (PWavs[z] == NULL) {AnmError("CPSound Sprite","sound",z);}
  }
}
//*******************************************************************
THSCoinPay::THSCoinPay(TOgleModeWindow *pmw,const TFileMode &NewFileMode)
:TSprite(pmw,NewFileMode)
{
  NoShow();
  SetToManual();
  SetupAnms();
}
//*******************************************************************
THSCoinPay::THSCoinPay(TOgleModeWindow *pmw,const TFileMode &NewFileMode,void *psource)
:TSprite(pmw,NewFileMode,psource)
{
  NoShow();
  SetToManual();
  SetupAnms();
}
//*******************************************************************
THSCoinPay::~THSCoinPay()
{
}
//*******************************************************************
void THSCoinPay::ClearTray()
{
  for(int i=0;i<8;i++)
  {
	 PCoinPay[i]->NoShow();
  }
}
//*******************************************************************
void THSCoinPay::SetTray(int32 num)
{
  if(num>=200)
  {
	 PCoinPay[7]->CAD.SetCurrentFrame(24);
	 PCoinPay[7]->Show();

  }
  else if(num>=175)
  {
	 PCoinPay[7]->CAD.SetCurrentFrame(int16(num - 175));
	 PCoinPay[7]->Show();
  }
  else if(num>=150)
  {
	 PCoinPay[6]->CAD.SetCurrentFrame(int16(num - 150));
	 PCoinPay[6]->Show();
  }
  else if(num>=125)
  {
	 PCoinPay[5]->CAD.SetCurrentFrame(int16(num - 125));
	 PCoinPay[5]->Show();
  }
  else if(num>=100)
  {
	 PCoinPay[4]->CAD.SetCurrentFrame(int16(num - 100));
	 PCoinPay[4]->Show();
  }
  else if(num>=75)
  {
	 PCoinPay[3]->CAD.SetCurrentFrame(int16(num - 75));
	 PCoinPay[3]->Show();
  }
  else if(num>=50)
  {
	 PCoinPay[2]->CAD.SetCurrentFrame(int16(num - 50));
	 PCoinPay[2]->Show();
  }
  else if(num>=25)
  {
	 PCoinPay[1]->CAD.SetCurrentFrame(int16(num - 25));
	 PCoinPay[1]->Show();
  }
  else if(num>=0)
  {
	 PCoinPay[0]->CAD.SetCurrentFrame(int16(num));
	 PCoinPay[0]->Show();
  }
  Update(GetAdjFUC());
}
//*******************************************************************
