//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  cssdsp.cpp
//    Project Name:  Casino
// Original Author:  A.Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     9/19/96    M.Perry    moved into cpp file.
//  2.0    09/04/97    M.Perry    32-bit conversion.
//********************************************************************
#include "hssdsp.h"
#include "owav.h"
//*******************************************************************
void THSSound::SetupWavs()
{
  for(int16 i=0;i<4;i++)
  {
	 Sounds[i] = GetWav(i);
	 if (Sounds[i] == NULL) {AnmError("Sound Sprite","sound",i);}
  }
  Sounds[4] = GetWav(4);
  Sounds[5] = GetWav(5);
}
//*******************************************************************
THSSound::THSSound(TOgleModeWindow *pmw,const TFileMode &NewFileMode)
:TSprite(pmw,NewFileMode)
{
  SetToManual();
  NoShow();
  SetupWavs();
}
//*******************************************************************
THSSound::THSSound(TOgleModeWindow *pmw,const TFileMode &fm,void *psource)
:TSprite(pmw,fm,psource)
{
  SetToManual();
  NoShow();
  SetupWavs();
}
//*******************************************************************
THSSound::~THSSound()
{
}
//*******************************************************************
void THSSound::PlaySound(int16 sound)
{
  if (sound >= 0 && sound < 6 && Sounds[sound] != NULL)
  {
    Sounds[sound]->Start();
    Update(GetAdjFUC());
  }
}
//*******************************************************************
