//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  hsvsp.cpp
//    Project Name:  Casino
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     9/26/95    A.Krist      original baseline
//  2.0    09/04/97    M.Perry      32-bit conversion.
//********************************************************************
#include "hsvsp.h"
#include "oanm.h"
#include "owav.h"
//*******************************************************************
THSValue::THSValue(TOgleModeWindow *pmw,const TFileMode &NewFileMode)
:TSprite(pmw,NewFileMode)
{
  SetToManual();
  SetupAnms();
}
//*******************************************************************
THSValue::THSValue(TOgleModeWindow *pmw,const TFileMode &NewFileMode,void *psource)
:TSprite(pmw,NewFileMode,psource)
{
  SetToManual();
  SetupAnms();
}
//*******************************************************************
THSValue::~THSValue()
{
}
//*******************************************************************
void THSValue::SetDenom(TMoney amount)
{
  if(amount == 0.05)        {PValue->CAD.SetCurrentFrame(0);}
  else if(amount == 0.1)    {PValue->CAD.SetCurrentFrame(1);}
  else if(amount == 0.25)   {PValue->CAD.SetCurrentFrame(2);}
  else if(amount == 1.0)    {PValue->CAD.SetCurrentFrame(3);}
  else if(amount == 5.0)    {PValue->CAD.SetCurrentFrame(4);}
  else if(amount == 10.0)   {PValue->CAD.SetCurrentFrame(5);}
  else if(amount == 25.0)   {PValue->CAD.SetCurrentFrame(6);}
  else if(amount == 50.0)   {PValue->CAD.SetCurrentFrame(7);}
  else if(amount == 100.0)  {PValue->CAD.SetCurrentFrame(8);}
  else if(amount == 500.0)  {PValue->CAD.SetCurrentFrame(9);}
  else if(amount == 1000.0) {PValue->CAD.SetCurrentFrame(10);}
  PValue->Show();
  Update(GetAdjFUC());
}
//*******************************************************************
void THSValue::ChangeDenom(TMoney amount,bool NoSound)
{
  if(amount == 0.05)        {PValue->CAD.SetCurrentFrame(0);}
  else if(amount == 0.1)    {PValue->CAD.SetCurrentFrame(1);}
  else if(amount == 0.25)   {PValue->CAD.SetCurrentFrame(2);}
  else if(amount == 1.0)    {PValue->CAD.SetCurrentFrame(3);}
  else if(amount == 5.0)    {PValue->CAD.SetCurrentFrame(4);}
  else if(amount == 10.0)   {PValue->CAD.SetCurrentFrame(5);}
  else if(amount == 25.0)   {PValue->CAD.SetCurrentFrame(6);}
  else if(amount == 50.0)   {PValue->CAD.SetCurrentFrame(7);}
  else if(amount == 100.0)  {PValue->CAD.SetCurrentFrame(8);}
  else if(amount == 500.0)  {PValue->CAD.SetCurrentFrame(9);}
  else if(amount == 1000.0) {PValue->CAD.SetCurrentFrame(10);}
  PValue->Show();
  if(!NoSound) {PRockValue->Start();}
  Update(GetAdjFUC());
}
//*******************************************************************
void THSValue::SetupAnms()
{
	PValue = GetAnm(0);
	if (PValue == NULL) {AnmError("Value","Nums",0);}
	PValue->CAD.ClearAutoStart();
	PValue->CAD.ClearAutoStop();
	PValue->CAD.SetDirStill();
	PRockValue = GetWav(0);
	if (PRockValue == NULL) {AnmError("RockSound Sprite","sound",0);}
}
//*******************************************************************
