//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  hswinst.cpp
//    Project Name:  Casino
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     09/29/95   A. Krist    Original baseline
//  2.0     09/04/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "hswinst.h"
#include "otimers.h"
#include "orespond.h"
//*******************************************************************
THSWinState::THSWinState(TCasinoHSGameLord *pNewHSLord)
:THSLordState(pNewHSLord)
{
  wincount   = 0;
  SpeedClickResponder = NULL;
  WaitOnTravel = false;
  wincountup = 0;
}
//*******************************************************************
THSWinState::~THSWinState()
{
}
//*******************************************************************
void THSWinState::ExecuteFirstTime()
{
  ExecuteWaiting = true;
  ExecuteStatus    = ess_Execute;
  wincount = (double)pOwnerLord->Winner();
  pOwnerLord->WinPaid->SetNum(0);
  pOwnerLord->Credits->SetNum(pOwnerLord->credits);
}
//*******************************************************************
void THSWinState::HandlePostUpdate(dword NewFUC)
{
  if (SpeedClickResponder != NULL)
  {
	 if (SpeedClickResponder->GetResponseEvent() != reChar)
	 {
		SpeedClickResponder->ClearPriority();
	 }
	 wincountup += wincount;
	 pOwnerLord->credits += wincount;
	 pOwnerLord->WinPaid->SetNum(wincountup);
	 pOwnerLord->Credits->SetNum(pOwnerLord->credits);
	 SpeedClickResponder = NULL;
	 if(pOwnerLord->WinHighLight != NULL)
	 {
		pOwnerLord->WinHighLight->StopAll();
	 }
	 WaitOnTravel = true;
	 wincount = 0;
	 return;
  }
  else if (wincount > 0)
  {
	 if(wincount < pOwnerLord->coinsplayed)
	 {
		wincountup          += wincount;
		pOwnerLord->credits += wincount;
		wincount             = 0;
	 }
	 else
	 {
		wincount   -= pOwnerLord->coinsplayed;
		wincountup += pOwnerLord->coinsplayed;
		pOwnerLord->credits += pOwnerLord->coinsplayed;
	 }
	 pOwnerLord->WinPaid->SetNum(wincountup);
	 pOwnerLord->Credits->SetNum(pOwnerLord->credits);
  }
  else if(!WaitOnTravel)
  {
	 if(pOwnerLord->WinHighLight != NULL)
	 {
		if(pOwnerLord->WinHighLight->IsWaveStopped())
		{
		  WaitOnTravel = true;
		 //ExecuteWaiting = FALSE;
		 // if(pOwnerLord->Button3){pOwnerLord->Button3->ShowVoidUp();}
		 // pOwnerLord->Button4->ShowVoidUp();
		 // if(pOwnerLord->Button5){pOwnerLord->Button5->ShowGray();}
		}
	 }
	 else
	 {
		WaitOnTravel = true;
		//ExecuteWaiting = FALSE;
	  //	if(pOwnerLord->Button3){pOwnerLord->Button3->ShowVoidUp();}
		//pOwnerLord->Button4->ShowVoidUp();
	  //	if(pOwnerLord->Button5){pOwnerLord->Button5->ShowGray();}
	 }

  }
  if(WaitOnTravel)
  {
	 if(pOwnerLord->Travel == NULL)
	 {
		ExecuteWaiting = false;
		if(pOwnerLord->Button3){pOwnerLord->Button3->ShowVoidUp();}
		pOwnerLord->Button4->ShowVoidUp();
		if(pOwnerLord->Button5){pOwnerLord->Button5->ShowGray();}
		WaitOnTravel = false;
		if(pOwnerLord->credits > 0)
		{
		  pOwnerLord->Button0->ShowVoidUp();
		}
	 }
	 else
	 {
		if(pOwnerLord->Travel->IsDone())
		{
		  ExecuteWaiting = false;
		  if(pOwnerLord->Button3){pOwnerLord->Button3->ShowVoidUp();}
		  pOwnerLord->Button4->ShowVoidUp();
		  if(pOwnerLord->Button5){pOwnerLord->Button5->ShowGray();}
		  WaitOnTravel = false;
        if(pOwnerLord->credits > 0)
		  {
			 pOwnerLord->Button0->ShowVoidUp();
		  }
		}
	 }
  }
  if(NewFUC){return;}
}
//*******************************************************************
bool THSWinState::HandleSpeedClick(TResponder &responder)
{
  if (responder.GetResponseEvent() == reRUp)
  {
	 SpeedClickResponder = &responder;
  }

  if (responder.GetResponseEvent() == reRDown)
  {
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
	 SpeedClickResponder = &responder;
  }
  return true;
}
//*******************************************************************
