 //*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CACDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  ckact1st.cpp   ///
//    Project Name:  Casino
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     03/29/95   A. Krist    Original baseline
//  2.0     09/17/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "ckact1st.h"
#include "orespond.h"
#include "owav.h"
//*******************************************************************
TKAct1State::TKAct1State(TCasinoKGameLord *pNewKLord)
:TKLordState(pNewKLord)
{
	 SetRunOrder(ess_Execute,ess_StartSubState3,ess_Execute,ess_Done,ess_Done,ess_Done);
	 BetSpotResponder            = NULL;

	 BetAmountResponder          = NULL;
	 PlaysResponder              = NULL;
	 GamesResponder              = NULL;
	 HistoryLeftResponder        = NULL;
	 HistoryRightResponder       = NULL;
	 TicketLeftResponder         = NULL;
	 TicketRightResponder        = NULL;
	 MenuEscResponder            = NULL;
	 Button1Responder            = NULL;
	 Button2Responder            = NULL;
	 Button3Responder            = NULL;
	 Button4Responder            = NULL;
	 AskExpertResponder          = NULL;
	 historyDelta                = 1;
	 timedelta                   = 0;
	 historyleftflag             = false;
	 historyrightflag            = false;
	 IgnoreCoach                 = false;
	 empty                       = 0;
	 nolen                       = 0;
	 StartTrash                  = true;
	 FinishTrash                 = false;
}
//*******************************************************************
TKAct1State::~TKAct1State()
{
}
//*******************************************************************
void TKAct1State::ExecuteFirstTime()
{
  pOwnerLord->Clear();
  ExecuteWaiting = true;
  ExecuteStatus    = ess_Execute;
}
//*******************************************************************
void TKAct1State::HandlePostUpdate(dword NewFUC)
{
  pOwnerLord->UpdateMain();
  if (BetSpotResponder != NULL)
  {
	 if (BetSpotResponder->GetResponseEvent() != reChar)
	 {
		BetSpotResponder->ClearPriority();
	 }
    IgnoreCoach = false;
	 LockHit = false;
	 BetSpotResponder = NULL;
	 return;
  }
  if (pOwnerLord->ButtonHit[kidButton0])
  {
	 if(pOwnerLord->Button0->ExpertStart > 0)
	 {
		if(pOwnerLord->CurrentTicket.game == kg1Spot)
		{pOwnerLord->AskSpotExpert(1);}
		else if(pOwnerLord->CurrentTicket.game == kg2Spot)
		{pOwnerLord->AskSpotExpert(2);}
		else if(pOwnerLord->CurrentTicket.game == kg9Spot)
		{pOwnerLord->AskSpotExpert(9);}
		else if(pOwnerLord->CurrentTicket.game == kg10Spot)
		{pOwnerLord->AskSpotExpert(10);}
		else
		{pOwnerLord->AskBetExpert();}
		pOwnerLord->Button0->ExpertStart = 0;
	 }
	 else
	 {
		askexpertflag = false;
		pOwnerLord->AskBetExpert();
	 }
	 IgnoreCoach = false;
	 pOwnerLord->ButtonClear(kidButton0);
	 return;
  }
  if (pOwnerLord->ButtonHit[kidButton1])
  {
	 pOwnerLord->ButtonClear(kidButton1);
	 return;
  }
  if (pOwnerLord->ButtonHit[kidButton2])
  {
	 pOwnerLord->ButtonClear(kidButton2);
	 return;
  }
  if (pOwnerLord->ButtonHit[kidButton3])
  {
	 pOwnerLord->ButtonClear(kidButton3);
	 return;
  }
  if (pOwnerLord->ButtonHit[kidButton4] && StartTrash == true)
  {
	 empty=0;
	 nolen=0;
	 StartTrash = false;
	 FinishTrash = true;
	 empty = pOwnerLord->GetAdjFUC();
	 pOwnerLord->TrashTicket(empty,nolen);
	 return;
  }
  if(FinishTrash)
  {
	 if(empty+nolen <= NewFUC)
	 {
		pOwnerLord->ButtonClear(kidButton4);
		StartTrash = true;
		FinishTrash = false;
	 }
  }
  if (pOwnerLord->ButtonHit[kidButton5])
  {
	 pOwnerLord->ButtonClear(kidButton5);
	 pOwnerLord->ReplayTicket();
	 return;
  }
  if (pOwnerLord->ButtonHit[kidButton6])
  {
	 pOwnerLord->ButtonClear(kidButton6);
	 if(!pOwnerLord->NewTicket())
	 {
		pOwnerLord->PModeWin->MessageBox("You have to many tickets. You should trash some of your old ones.","To many tickets",MB_OK);
	 }
	 return;
  }
  if (pOwnerLord->ButtonHit[kidButton7])
  {
	 pOwnerLord->ButtonClear(kidButton7);
	 if(pOwnerLord->GetCasPD(pOwnerLord->activeplayer)->CoachOn &&
		 (pOwnerLord->CurrentTicket.game == kg1Spot || pOwnerLord->CurrentTicket.game == kg2Spot ||
		  pOwnerLord->CurrentTicket.game == kg9Spot || pOwnerLord->CurrentTicket.game == kg10Spot)
		 && !IgnoreCoach)
	 {
		  pOwnerLord->Button0->ShowExpert();
		  IgnoreCoach = true;
	 }
	 else
	 {
		pOwnerLord->PlayTicket();
		IgnoreCoach = false;
	 }
	 return;
  }
  if(BetAmountResponder != NULL)
  {
	 pOwnerLord->BetUp();
	 if (BetAmountResponder->GetResponseEvent() != reChar)
	 {
		BetAmountResponder->ClearPriority();
	 }
	 BetAmountResponder = NULL;
	 LockHit = false;
	 return;
  }
  if(PlaysResponder != NULL)
  {
	 pOwnerLord->PlayUp();
	 if (PlaysResponder->GetResponseEvent() != reChar)
	 {
		PlaysResponder->ClearPriority();
	 }
	 PlaysResponder = NULL;
	 LockHit = false;
	 return;
  }
  if(GamesResponder != NULL)
  {
	 pOwnerLord->GameUp();
	 if (GamesResponder->GetResponseEvent() != reChar)
	 {
		GamesResponder->ClearPriority();
	 }
	 GamesResponder = NULL;
	 LockHit = false;
	 return;
  }
  if(historyleftflag)
  {
	 timedelta++;
	 if(timedelta == 1)
	 {historyDelta=1;pOwnerLord->Sounds->PlaySound(10);}
	 else if(timedelta < 6 && timedelta != 1)
	 {historyDelta=0;}
	 else if(timedelta == 6)
	 {historyDelta=1;pOwnerLord->Sounds->Sounds[10]->Stop();pOwnerLord->Sounds->PlaySound(11);}
	 else if(timedelta == 18)
	 {historyDelta=10;pOwnerLord->Sounds->Sounds[11]->Stop();pOwnerLord->Sounds->PlaySound(12);}
	 else if(timedelta == 30)
	 {historyDelta=100;pOwnerLord->Sounds->Sounds[12]->Stop();pOwnerLord->Sounds->PlaySound(13);}
	 else if(timedelta >= 42)
	 {
		if(timedelta > 42)
		{
		  if(pOwnerLord->Sounds->Sounds[14]->GetStopped())
		  {pOwnerLord->Sounds->PlaySound(14);}
		}
		else if(timedelta == 42)
		{
		  historyDelta=500;
		  pOwnerLord->Sounds->Sounds[13]->Stop();
		  pOwnerLord->Sounds->PlaySound(14);
		}
	 }
	 pOwnerLord->DisplayHistoryBackward(historyDelta);
  }
  if(historyrightflag)
  {
	 timedelta++;
	 if(timedelta == 1)
	 {historyDelta=1;pOwnerLord->Sounds->PlaySound(10);}
	 else if(timedelta < 6 && timedelta != 1)
	 {historyDelta=0;}
	 else if(timedelta == 6)
	 {historyDelta=1;pOwnerLord->Sounds->Sounds[10]->Stop();pOwnerLord->Sounds->PlaySound(11);}
	 else if(timedelta == 18)
	 {historyDelta=10;pOwnerLord->Sounds->Sounds[11]->Stop();pOwnerLord->Sounds->PlaySound(12);}
	 else if(timedelta == 30)
	 {historyDelta=100;pOwnerLord->Sounds->Sounds[12]->Stop();pOwnerLord->Sounds->PlaySound(13);}
	 else if(timedelta >= 42)
	 {
		if(timedelta > 42)
		{
		  if(pOwnerLord->Sounds->Sounds[14]->GetStopped())
		  {pOwnerLord->Sounds->PlaySound(14);}
		}
		else if(timedelta == 42)
		{
		  historyDelta=500;
		  pOwnerLord->Sounds->Sounds[13]->Stop();
		  pOwnerLord->Sounds->PlaySound(14);
		}
	 }
	 pOwnerLord->DisplayHistoryForward(historyDelta);
  }
  if(HistoryLeftResponder)
  {
	 pOwnerLord->HistoryLeft->NoShow();
	 HistoryLeftResponder        = NULL;
  }
  if(HistoryRightResponder)
  {
	 pOwnerLord->HistoryRight->NoShow();
	 HistoryRightResponder       = NULL;
  }
  if(TicketLeftResponder)
  {
	 pOwnerLord->TicketLeft->NoShow();
	 TicketLeftResponder         = NULL;
  }
  if(TicketRightResponder)
  {
	 pOwnerLord->TicketRight->NoShow();
	 TicketRightResponder        = NULL;
  }
}
//*******************************************************************
bool TKAct1State::HandleNamePlate(TResponder &responder)
{
  if(responder.GetResponseEvent() == reLDown)
  {
	 responder.SetPriority();
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_PRESSING_FINGER_CURSOR));
	 return true;
  }
  if ((responder.GetResponseEvent() == reLUp    ) ||
		(responder.GetResponseEvent() == reLDblClk) ||
		(responder.GetResponseEvent() == reChar   )   )
  {
	 if(responder.GetIsPriority())
	 {
		responder.ClearPriority();
	 }
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_POINTING_FINGER_CURSOR));
	 if(responder.Contains(responder.GetPoint()) ||
		 responder.GetResponseEvent() == reChar     )
	 {
		if(pOwnerLord->GetNumActivePlayers() > 1)
		{
		  pOwnerLord->CyclePlayers();
		}
	 }
  }
  return true;
}
//*******************************************************************
bool TKAct1State::HandleBetSpot(TResponder &responder,int16 spot)
{
  if((pOwnerLord->activeplayer != -1) && (!LockHit))
  {
	 if (responder.GetResponseEvent() == reLUp)
	 {
		pOwnerLord->PlaceBet(spot);
		BetSpotResponder = &responder;
		LockHit = true;
	 }
	 if (responder.GetResponseEvent() == reLDown)
	 {
		responder.SetPriority();
	 }
	 if (responder.GetResponseEvent() == reChar)
	 {
		pOwnerLord->PlaceBet(spot);
		BetSpotResponder = &responder;
	 }
	 return true;
  }
  else
  {
	 return false;
  }
}
//*******************************************************************
#pragma argsused
bool TKAct1State::HandleButton1(TResponder &responder)
{
  return true;
}
//*******************************************************************
bool TKAct1State::HandleBetAmount(TResponder &responder)
{
  if((pOwnerLord->activeplayer != -1) && (!LockHit))
  {
		if (responder.GetResponseEvent() == reLUp)
		{
		  LockHit = true;
		  BetAmountResponder = &responder;
		}
		if (responder.GetResponseEvent() == reLDown)
		{
		  responder.SetPriority();
		}
		if (responder.GetResponseEvent() == reChar)
		{
		  BetAmountResponder = &responder;
		}
	 return true;
  }
  return true;
}
//*******************************************************************
bool TKAct1State::HandlePlays(TResponder &responder)
{
  if((pOwnerLord->activeplayer != -1) && (!LockHit))
  {
		if (responder.GetResponseEvent() == reLUp)
		{
		  LockHit = true;
		  PlaysResponder = &responder;
		}
		if (responder.GetResponseEvent() == reLDown)
		{
		  responder.SetPriority();
		}
		if (responder.GetResponseEvent() == reChar)
		{
		  PlaysResponder = &responder;
		}
	 return true;
  }
  return true;
}
//*******************************************************************
bool TKAct1State::HandleGames(TResponder &responder)
{
  if((pOwnerLord->activeplayer != -1) && (!LockHit))
  {
		if (responder.GetResponseEvent() == reLUp)
		{
		  LockHit = true;
		  GamesResponder = &responder;
		}
		if (responder.GetResponseEvent() == reLDown)
		{
		  responder.SetPriority();
		}
		if (responder.GetResponseEvent() == reChar)
		{
		  GamesResponder = &responder;
		}
	 return true;
  }
  return true;
}
//*******************************************************************
bool TKAct1State::HandleTicketLeft(TResponder &responder)
{
  if(responder.GetResponseEvent() == reLDown)
  {
	 pOwnerLord->TicketLeft->SetNum(0);
	 responder.SetPriority();
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_PRESSING_FINGER_CURSOR));
	 return true;
  }
  if ((responder.GetResponseEvent() == reLUp    ) ||
		(responder.GetResponseEvent() == reLDblClk) ||
		(responder.GetResponseEvent() == reChar   )   )
  {
	 if(responder.GetIsPriority())
	 {
		responder.ClearPriority();
	 }
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_POINTING_FINGER_CURSOR));
	 if(responder.Contains(responder.GetPoint()) ||
		 responder.GetResponseEvent() == reChar     )
	 {
		pOwnerLord->DisplayTicketBackward();
		TicketLeftResponder         = &responder;
	 }
  }
  return true;
}
//*******************************************************************
bool TKAct1State::HandleTicketRight(TResponder &responder)
{
  if(responder.GetResponseEvent() == reLDown)
  {
	 pOwnerLord->TicketRight->SetNum(0);
	 responder.SetPriority();
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_PRESSING_FINGER_CURSOR));
	 return true;
  }
  if ((responder.GetResponseEvent() == reLUp    ) ||
		(responder.GetResponseEvent() == reLDblClk) ||
		(responder.GetResponseEvent() == reChar   )   )
  {
	 if(responder.GetIsPriority())
	 {
		responder.ClearPriority();
	 }
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_POINTING_FINGER_CURSOR));
	 if(responder.Contains(responder.GetPoint()) ||
		 responder.GetResponseEvent() == reChar     )
	 {
      pOwnerLord->DisplayTicketForward();
		TicketRightResponder        = &responder;
	 }
  }
  return true;
}
//*******************************************************************
bool TKAct1State::HandleHistoryLeft(TResponder &responder)
{
  if(responder.GetResponseEvent() == reLDown)
  {
	 pOwnerLord->HistoryLeft->SetNum(0);
	 historyleftflag = true;
	 responder.SetPriority();
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_PRESSING_FINGER_CURSOR));
	 return true;
  }
  if ((responder.GetResponseEvent() == reLUp    ) ||
		(responder.GetResponseEvent() == reLDblClk) ||
		(responder.GetResponseEvent() == reChar   )   )
  {
	 switch(historyDelta)
	 {
		case 1   : pOwnerLord->Sounds->Sounds[11]->Stop();break;
		case 10  : pOwnerLord->Sounds->Sounds[12]->Stop();break;
		case 100 : pOwnerLord->Sounds->Sounds[13]->Stop();break;
		case 500 : pOwnerLord->Sounds->Sounds[14]->Stop();break;
	 }
	 if(responder.GetIsPriority())
	 {
		responder.ClearPriority();
	 }
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_POINTING_FINGER_CURSOR));
	 if(responder.Contains(responder.GetPoint()) ||
		 responder.GetResponseEvent() == reChar     )
	 {
      if(timedelta == 0)
		{
		  pOwnerLord->DisplayHistoryBackward(historyDelta);
		}
		//???pOwnerLord->HistoryLeft->NoShow();
		LockHit = false;
		historyleftflag = false;
		if(timedelta == 0){pOwnerLord->Sounds->PlaySound(10);}
		timedelta=0;
		historyDelta = 1;
	 }
	 HistoryLeftResponder        = &responder;
	 LockHit = false;
	 historyleftflag = false;
	 timedelta=0;
	 historyDelta = 1;
  }
  return true;
}
//*******************************************************************
bool TKAct1State::HandleHistoryRight(TResponder &responder)
{
  if(responder.GetResponseEvent() == reLDown)
  {
	 historyrightflag = true;
	 pOwnerLord->HistoryRight->SetNum(0);
	 responder.SetPriority();
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_PRESSING_FINGER_CURSOR));
	 return true;
  }
  if ((responder.GetResponseEvent() == reLUp    ) ||
		(responder.GetResponseEvent() == reLDblClk) ||
		(responder.GetResponseEvent() == reChar   )   )
  {
	 switch(historyDelta)
	 {
		case 1   : pOwnerLord->Sounds->Sounds[11]->Stop();break;
		case 10  : pOwnerLord->Sounds->Sounds[12]->Stop();break;
		case 100 : pOwnerLord->Sounds->Sounds[13]->Stop();break;
		case 500 : pOwnerLord->Sounds->Sounds[14]->Stop();break;
	 }
	 if(responder.GetIsPriority())
	 {
		responder.ClearPriority();
	 }
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_POINTING_FINGER_CURSOR));
	 if(responder.Contains(responder.GetPoint()) ||
		 responder.GetResponseEvent() == reChar     )
	 {
      if(timedelta == 0)
		{
		  pOwnerLord->DisplayHistoryForward(historyDelta);
		}
		//???pOwnerLord->HistoryRight->NoShow();
		LockHit = false;
		historyrightflag = false;
		if(timedelta == 0){pOwnerLord->Sounds->PlaySound(10);}
		timedelta=0;
		historyDelta = 1;
	 }
	 HistoryRightResponder       = &responder;
	 LockHit = false;
	 historyrightflag = false;
	 timedelta=0;
	 historyDelta = 1;
  }
  return true;
}
//*******************************************************************
#pragma argsused
bool TKAct1State::HandleButton2(TResponder &responder)
{
  return true;
}
//*******************************************************************
#pragma argsused
bool TKAct1State::HandleButton3(TResponder &responder)
{
  return true;
}
//*******************************************************************
#pragma argsused
bool TKAct1State::HandleButton4(TResponder &responder)
{
  return true;
}
//*******************************************************************
#pragma argsused
bool TKAct1State::HandleMenuEsc(TResponder &responder)
{
  return true;
}
//*******************************************************************
#pragma argsused
bool TKAct1State::HandleAskExpert(TResponder &responder)
{
  return true;
}

//*******************************************************************