//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  ccglord.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     3/26/96   A.Krist      Original baseline
//  2.0    09/17/97   M.Perry      32-bit conversion.
//  2.3    07/14/99    M.Perry    gobjlist removal
//*******************************************************************
#include "ckglord.h"
#include "cklordst.h"
#include "cklrdmst.h"
#include "ostate.h"
#include <assert.h>
#include <time.h>   //To Set Random Number Generator
//#include "ccaskex.h"
//#define  NUMBEROFPLAYERS 3
#include <stdlib.h> //For Random Number Generator
#include "caskmw.h"
#include "oskitcat.h"
#include "cplaymgr.h"
#include "ckplay.h"
#include "casnames.rh"
#include "casapp.h"
#include "orespond.h"
#include "oanm.h"
//*******************************************************************
TCasinoKGameLord::TCasinoKGameLord(TKenoModeWin *pmwin,const TFileMode &NewFileMode)
:TCasinoGameLord(pmwin,NewFileMode,gtKeno,TMoney::did_1_00)//cd1)
{
  Sounds = NULL;
  BankCashDisplay    = NULL;
  NamePlate1         = NULL;
  NamePlate2         = NULL;
  NamePlate3         = NULL;
  Button0            = NULL;
  Button1            = NULL;
  Button2            = NULL;
  Button3            = NULL;
  Button4            = NULL;
  Button5            = NULL;
  Button6            = NULL;
  Button7            = NULL;
  Chips              = NULL;

  HistoryLeft        = NULL;
  HistoryRight       = NULL;
  TicketLeft         = NULL;
  TicketRight        = NULL;
  Plays              = NULL;
  MainDisplay        = NULL;
  Genie              = NULL;
  HistoryDisplay     = NULL;
  Checks             = NULL;
  PayOff             = NULL;
  Result             = NULL;
  HistoryNums        = NULL;
  Time               = NULL;
  GameNum            = NULL;
  GameType           = NULL;
  BetAmount          = NULL;
  ValidGames         = NULL;
  randomize();
  PState        = new TKLordMainState(this);
  pMWin            = pmwin;
  maxbet           = 3;
  credits          = 0;
  coinsize         = GameDenom;
  activeplayer     = -1;
  playersin        = 1;
  coinsplayed      = 0l;
  shutdownstate    = 0;
  currentwinnings  = 0l;
  currenthistory   = 0;
  currentgame      = 0;
  LastTime         = 0;
  CurrentTicket.ticketnum      = -1;
  CurrentTicket.plays          = -1;
  CurrentTicket.game           = kgNone;
  CurrentTicket.amountper      = -1l;
  CurrentTicket.startinggame   = -1;
  CurrentTicket.paid           = -1l;
  CurrentTicket.New            = false;
  CurrentTicket.LoserPrintType = -1;
  LoserType                    = 0;
  numofplays                   = 0;
  amountbet                    = 0l;
  numofspots                   = kg1Spot;  //MRP 12/21/96
  PayOffOn                     = false;
  ShowWin                      = false;
  for(int16 k=0;k<80;k++)
  {
	 CurrentTicket.spots[k]   = false;
  }
  for(int16 i=0;i<NUMOFBUTTONS;i++)
  {
	 ButtonHit[i] = false;
  }
  currentticketnum[0] = -1;
  currentticketnum[1] = -1;
  currentticketnum[2] = -1;
  SetupResponders();
  GoodX = true;
}
//*******************************************************************
TCasinoKGameLord::~TCasinoKGameLord()
{
  DestroyState();
  CleanupResponders();
}
//*******************************************************************
void TCasinoKGameLord::PreStats()
{
  return;
}
//*******************************************************************
void TCasinoKGameLord::PostStats(TMoney won,int16 ticnum)
{
  TMoney amountbet =0l;
  TCasinoPlayerData *player;
  player = GetCasPD(activeplayer);
  if(player)
  {
    TCasinoKData &curdata = player->KData;
	 int16 session = curdata.CurrentSession;
    TCKSession &cursession = curdata.Sessions[session];

	 if (curdata.tickets[ticnum].amountper == 1l)
	 {
      amountbet = 1l;
    }
	 else if (curdata.tickets[ticnum].amountper == 2l)
	 {
      amountbet = 5l;
    }
	 else if(curdata.tickets[ticnum].amountper == 3l)
	 {
      amountbet = 10l;
    }
	 cursession.TotalBetsCash += amountbet;
	 cursession.HandsPlayed++;
	 if (won != 0.0)
    {
      cursession.Wins++;
    }
	 else
    {
      cursession.Losses++;
    }

	 switch(curdata.tickets[ticnum].game)
	 {
		case kgNone         :  break;
		case kg1Spot        :  if(won != 0.0) {cursession.l1SpotBetsCashWL += won;}
									  else {cursession.l1SpotBetsCashWL -= amountbet;}
									  cursession.l1SpotBetsCash += amountbet;
									  cursession.nNum1SpotBets++;
                             break;
		case kg2Spot        :  if (won != 0.0) {cursession.l2SpotBetsCashWL += won;}
									  else {cursession.l2SpotBetsCashWL -= amountbet;}
									  cursession.l2SpotBetsCash += amountbet;
									  cursession.nNum2SpotBets++;
                             break;
		case kg3Spot        :  if (won != 0.0) {cursession.l3SpotBetsCashWL += won;}
									  else {cursession.l3SpotBetsCashWL -= amountbet;}
									  cursession.l3SpotBetsCash += amountbet;
									  cursession.nNum3SpotBets++;
                             break;
		case kg3SpotSpecial :  if (won != 0.0){cursession.l3SpotSpecialBetsCashWL += won;}
									  else {cursession.l3SpotSpecialBetsCashWL -= amountbet;}
									  cursession.l3SpotSpecialBetsCash += amountbet;
									  cursession.nNum3SpotSpecialBets++;
                             break;
		case kg4Spot        :  if (won != 0.0) {cursession.l4SpotBetsCashWL += won;}
									  else {cursession.l4SpotBetsCashWL -= amountbet;}
									  cursession.l4SpotBetsCash += amountbet;
									  cursession.nNum4SpotBets++;
                             break;
		case kg4SpotSpecial :  if (won != 0.0) {cursession.l4SpotSpecialBetsCashWL += won;}
									  else {cursession.l4SpotSpecialBetsCashWL -= amountbet;}
									  cursession.l4SpotSpecialBetsCash += amountbet;
									  cursession.nNum4SpotSpecialBets++;
                             break;
		case kg5Spot        :  if (won != 0.0) {cursession.l5SpotBetsCashWL += won;}
									  else {cursession.l5SpotBetsCashWL -= amountbet;}
									  cursession.l5SpotBetsCash += amountbet;
									  cursession.nNum5SpotBets++;
                             break;
		case kg6Spot        :  if (won != 0.0) {cursession.l6SpotBetsCashWL += won;}
									  else {cursession.l6SpotBetsCashWL -= amountbet;}
									  cursession.l6SpotBetsCash += amountbet;
									  cursession.nNum6SpotBets++;
                             break;
		case kg6SpotSpecial :  if (won != 0.0) {cursession.l6SpotSpecialBetsCashWL += won;}
									  else {cursession.l6SpotSpecialBetsCashWL -= amountbet;}
									  cursession.l6SpotSpecialBetsCash += amountbet;
									  cursession.nNum6SpotSpecialBets++;
                             break;
		case kg7Spot        :  if (won != 0.0) {cursession.l7SpotBetsCashWL += won;}
									  else {cursession.l7SpotBetsCashWL -= amountbet;}
									  cursession.l7SpotBetsCash += amountbet;
									  cursession.nNum7SpotBets++;
                             break;
		case kg8Spot        :  if (won != 0.0) {cursession.l8SpotBetsCashWL += won;}
									  else {cursession.l8SpotBetsCashWL -= amountbet;}
									  cursession.l8SpotBetsCash += amountbet;
									  cursession.nNum8SpotBets++;
                             break;
		case kg9Spot        :  if (won != 0.0) {cursession.l9SpotBetsCashWL += won;}
									  else {cursession.l9SpotBetsCashWL -= amountbet;}
									  cursession.l9SpotBetsCash += amountbet;
									  cursession.nNum9SpotBets++;
                             break;
		case kg10Spot       :  if (won != 0.0) {cursession.l10SpotBetsCashWL += won;}
									  else {cursession.l10SpotBetsCashWL -= amountbet;}
									  cursession.l10SpotBetsCash += amountbet;
									  cursession.nNum10SpotBets++;
                             break;
		default             :  break;
	 }
	 if((int32)won)
	 {
		if(won > cursession.LargestWin)
		{
		  cursession.LargestWin = won;
		}
		cursession.CurrentWinStreak++;
		cursession.CurrentLosingStreak=0;
		if(cursession.CurrentWinStreak > cursession.WinStreak)
		{
		  cursession.WinStreak = cursession.CurrentWinStreak;
		}
		if(GetCash(activeplayer) > cursession.PeakWin)
		{
		  cursession.PeakWin = GetCash(activeplayer);
		}
	 }
	 else
	 {
		  if(amountbet > cursession.LargestLoss)
		  {
			 cursession.LargestLoss = amountbet;
		  }
		  cursession.CurrentLosingStreak++;
		  cursession.CurrentWinStreak=0;
		  if(cursession.CurrentLosingStreak > cursession.LosingStreak)
		  {
			 cursession.LosingStreak = cursession.CurrentLosingStreak;
		  }
		  if(GetCash(activeplayer) < cursession.PeakLoss)
		  {
			 cursession.PeakLoss = GetCash(activeplayer);
		  }
	 }
  }
  return;
}
//*******************************************************************
void  TCasinoKGameLord::ShuttingDown()
{
  if(shutdownstate == 0)
  {
	 if(GetCasPD(0))
	 {
		NotifyPlayerDeActivation(0);
	 }
	 if(GetCasPD(1))
	 {
		NotifyPlayerDeActivation(1);
	 }
	 if(GetCasPD(2))
	 {
		NotifyPlayerDeActivation(2);
	 }
  }
  else if(shutdownstate == 1)
  {
	 if(GetCasPD(0))
	 {
	 //???	GetCasPD(0)->EndKSession();
	 }
	 if(GetCasPD(1))
	 {
	 //???	GetCasPD(1)->EndKSession();
	 }
	 if(GetCasPD(2))
	 {
	 //???	GetCasPD(2)->EndKSession();
	 }
  }

}
//*******************************************************************
void  TCasinoKGameLord::SwitchToPlayer(int16 player)
{
  if(GetCasPD(player))
  {
	 if(activeplayer != player && activeplayer != -1)
	 {
		coinsplayed = 0l;
		GetCasPD(activeplayer)->Columns[0] = Chips->col1;
		GetCasPD(activeplayer)->Columns[1] = Chips->col2;
		GetCasPD(activeplayer)->Columns[2] = Chips->col3;
		GetCasPD(activeplayer)->Columns[3] = Chips->col4;
		GetCasPD(activeplayer)->Columns[4] = Chips->col5;
		GetCasPD(activeplayer)->Columns[5] = Chips->col6;
	 }

	 if(activeplayer != player)
	 {
		switch(activeplayer)
		{
			 case 0 : NamePlate1->NoShowNamePlate();break;
			 case 1 : NamePlate2->NoShowNamePlate();break;
			 case 2 : NamePlate3->NoShowNamePlate();break;
		}
		activeplayer = player;
		DisplayTicketForward();
		DisplayTicketBackward();
		BankCashDisplay->SetNum(GetCash(activeplayer));
		Chips->SetupCols(GetCasPD(player)->Cash,
                       GetCasPD(player)->Columns[0],
                       GetCasPD(player)->Columns[1],
                       GetCasPD(player)->Columns[2],
						     GetCasPD(player)->Columns[3],
                       GetCasPD(player)->Columns[4],
						     GetCasPD(player)->Columns[5],
                       false);
		if(GetNumActivePlayers() > 0)
		{
		  string name;
		  name = GetCasPD(player)->GetName();
		  switch(player)
		  {
			 case 0 : NamePlate1->ShowNamePlateString(name);break;
			 case 1 : NamePlate2->ShowNamePlateString(name);break;
			 case 2 : NamePlate3->ShowNamePlateString(name);break;
		  }
		}
	 }
  }
}
//*******************************************************************
void  TCasinoKGameLord::CyclePlayers()
{
  if(activeplayer != -1)
  {
	 SwitchToPlayer(NextSlotNum(activeplayer));
  }
}
//*******************************************************************
bool TCasinoKGameLord::IsWinner()
{
  return true;
}
//*******************************************************************
void TCasinoKGameLord::NotifyPlayerActivation(int16 slotnum)
{
  if(GetCasPD(slotnum))
  {
	 GetCasPD(slotnum)->StartKSession(SubGameType,GameDenom);
	 if(activeplayer == -1)
	 {
	  activeplayer = slotnum;
	  DisplayTicketForward();
	  DisplayTicketBackward();
	  BankCashDisplay->SetNum(GetCash(activeplayer));
	  Chips->SetupCols(GetCasPD(slotnum)->Cash,
                      GetCasPD(slotnum)->Columns[0],
						    GetCasPD(slotnum)->Columns[1],
                      GetCasPD(slotnum)->Columns[2],
						    GetCasPD(slotnum)->Columns[3],
                      GetCasPD(slotnum)->Columns[4],
						    GetCasPD(slotnum)->Columns[5],
                      false);
		string name;
		name = GetCasPD(slotnum)->GetName();
		switch(slotnum)
		  {
			 case 0 : NamePlate1->ShowNamePlateString(name);break;
			 case 1 : NamePlate2->ShowNamePlateString(name);break;
			 case 2 : NamePlate3->ShowNamePlateString(name);break;
		  }
	 }
  }
}
//*******************************************************************
void TCasinoKGameLord::NotifyPlayerDeActivation(int16 slotnum)
{
  if(GetCasPD(slotnum))
  {
	 if(activeplayer == slotnum)
	 {
		GetCasPD(activeplayer)->Cash += coinsplayed;
		coinsplayed = 0l;
		GetCasPD(slotnum)->Columns[0] = Chips->col1;
		GetCasPD(slotnum)->Columns[1] = Chips->col2;
		GetCasPD(slotnum)->Columns[2] = Chips->col3;
		GetCasPD(slotnum)->Columns[3] = Chips->col4;
		GetCasPD(slotnum)->Columns[4] = Chips->col5;
		GetCasPD(slotnum)->Columns[5] = Chips->col6;
		switch(slotnum)
		{
			 case 0 : NamePlate1->NoShow();break;
			 case 1 : NamePlate2->NoShow();break;
			 case 2 : NamePlate3->NoShow();break;
		}
	 }
	 if(GetNumActivePlayers() == 1)
	 {
		switch(slotnum)
		{
			 case 0 : NamePlate1->NoShow();break;
			 case 1 : NamePlate2->NoShow();break;
			 case 2 : NamePlate3->NoShow();break;
		}
		BankCashDisplay->SetNum(0l);
		activeplayer = -1;
		Chips->NoShow();
	 }
	 if(GetNumActivePlayers() > 1 && activeplayer == slotnum)
	 {
		int16 newplayer=-1;
		newplayer = NextSlotNum(slotnum);
		activeplayer = newplayer;
		DisplayTicketForward();
		DisplayTicketBackward();
		BankCashDisplay->SetNum(GetCash(activeplayer));
		string name;
		name = GetCasPD(newplayer)->GetName();
		switch(activeplayer)
		{
			 case 0 : NamePlate1->ShowNamePlateString(name);break;
			 case 1 : NamePlate2->ShowNamePlateString(name);break;
			 case 2 : NamePlate3->ShowNamePlateString(name);break;
		}
		BankCashDisplay->SetNum(GetCash(activeplayer));
	 }
	 GetCasPD(slotnum)->EndKSession();
  }
}
//*******************************************************************
void TCasinoKGameLord::SetupActivePlayer(int16 slot)
{
  if(GetCasPD(slot))
  {
	 activeplayer = slot;
	 Chips->SetupCols(GetCasPD(slot)->Cash,
                     GetCasPD(slot)->Columns[0],
						   GetCasPD(slot)->Columns[1],
                     GetCasPD(slot)->Columns[2],
						   GetCasPD(slot)->Columns[3],
                     GetCasPD(slot)->Columns[4],
						   GetCasPD(slot)->Columns[5],
                     false);
		string name;
		name = GetCasPD(slot)->GetName();
		switch(slot)
		{
			 case 0 : NamePlate1->ShowNamePlateString(name);break;
			 case 1 : NamePlate2->ShowNamePlateString(name);break;
			 case 2 : NamePlate3->ShowNamePlateString(name);break;
		}
		BankCashDisplay->SetNum(GetCash(activeplayer));
  }
}
//*******************************************************************
void TCasinoKGameLord::AskSpotExpert(int16 spots)
{
  string expertstring="";
  switch(spots)
  {
	 case  1 : expertstring  = GetOgleApp()->LoadString(5750);
				  expertstring  += GetOgleApp()->LoadString(5751);
				  expertstring  += GetOgleApp()->LoadString(5752);
				  break;
	 case  2 : expertstring  = GetOgleApp()->LoadString(5753);
				  expertstring  += GetOgleApp()->LoadString(5754);
				  expertstring  += GetOgleApp()->LoadString(5755);
				  break;
	 default : expertstring  = GetOgleApp()->LoadString(5756);
				  expertstring  += GetOgleApp()->LoadString(5757);
				  expertstring  += GetOgleApp()->LoadString(5758);
				  break;
  }
  GetFW()->DisplayExpert(expertstring);
}
//*******************************************************************
void TCasinoKGameLord::AskBetExpert()
{
  string expertstring="";
  expertstring   = GetOgleApp()->LoadString(5759);
  expertstring  += GetOgleApp()->LoadString(5760);
  expertstring  += GetOgleApp()->LoadString(5761);
  expertstring  += GetOgleApp()->LoadString(5762);
  expertstring  += GetOgleApp()->LoadString(5763);
  expertstring  += GetOgleApp()->LoadString(5764);
  expertstring  += GetOgleApp()->LoadString(5765);
  expertstring  += GetOgleApp()->LoadString(5766);
  expertstring  += GetOgleApp()->LoadString(5767);
  expertstring  += GetOgleApp()->LoadString(5768);
  expertstring  += GetOgleApp()->LoadString(5769);
  expertstring  += GetOgleApp()->LoadString(5770);
  expertstring  += GetOgleApp()->LoadString(5771);
  expertstring  += GetOgleApp()->LoadString(5772);
  expertstring  += GetOgleApp()->LoadString(5773);
  GetFW()->DisplayExpert(expertstring);
}
//*******************************************************************
int16 TCasinoKGameLord::PlayerBet1000()
{
  if (currentwinnings > 1000l) {return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoKGameLord::PlayerBetGT(TMoney amount)
{
  TCasinoKPlayer *player;
  player = GetKPlayer(activeplayer);
  if(player == NULL) {return -1;}
  return 0;
}
//*******************************************************************
int16 TCasinoKGameLord::OneAndOnlyPlayerGT20000()
{
  if(GetNumActivePlayers() != 1){return -1;}
  if(GetKPlayer(activeplayer) == NULL){return -1;}
  if(GetCash(activeplayer) > 20000l) {return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoKGameLord::OneHumanPlayer()
{
  if (GetNumActivePlayers() == 1) {return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoKGameLord::TwoHumanPlayers()
{
  if (GetNumActivePlayers() == 2) {return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoKGameLord::ThreeHumanPlayers()
{
  if (GetNumActivePlayers() == 3){return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoKGameLord::AllPlayersMale()
{
  if(GetCasPD(0) != NULL && !GetCasPD(0)->Male) {return -1;}
  if(GetCasPD(1) != NULL && !GetCasPD(1)->Male) {return -1;}
  if(GetCasPD(2) != NULL && !GetCasPD(2)->Male) {return -1;}
  return 1;
}
//*******************************************************************
int16 TCasinoKGameLord::AllPlayersFemale()
{
  if(GetCasPD(0) != NULL && GetCasPD(0)->Male) {return -1;}
  if(GetCasPD(1) != NULL && GetCasPD(1)->Male) {return -1;}
  if(GetCasPD(2) != NULL && GetCasPD(2)->Male) {return -1;}
  return 1;
}
//*******************************************************************
int16 TCasinoKGameLord::RandomLT(int16 num)
{
  if (random(100) < num) {return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoKGameLord::BetweenDec22_Dec25()
{
  TDate today;
  if(today.Month() == 12)
  {
	 if(today.DayOfMonth() > 21 && today.DayOfMonth() < 26)
	 {
		return 1;
	 }
  }
  return -1;
}
//*******************************************************************
int16 TCasinoKGameLord::BetweenDec31_Jan2()
{
  TDate today;
  if(today.Month() == 12 && today.DayOfMonth() > 30)
  {
	 return 1;
  }
  if(today.Month() == 1 && today.DayOfMonth() < 3)
  {
	 return 1;
  }
  return -1;
}
//*******************************************************************
int16 TCasinoKGameLord::ValentinesDay()
{
  TDate today;
  if(today.Month() == 2 && today.DayOfMonth() == 14)
  {
	 return 1;
  }
  return -1;
}
//*******************************************************************
int16 TCasinoKGameLord::IsAWinningNumber()
{
	 return 1;
}
//*******************************************************************
int16 TCasinoKGameLord::FirstGamePlayer()
{
  //???
  return 0;
}
//*******************************************************************
int16 TCasinoKGameLord::Morning()
{
  TTime today;
  if((today.Hour())%24 < 12) {return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoKGameLord::Afternoon()
{
  TTime today;
  if((today.Hour())%24 > 11 && (today.Hour())%24 < 6) {return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoKGameLord::Evening()
{
  TTime today;
  if((today.Hour())%24 > 5) {return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoKGameLord::IsNumber(int16 x)
{
  if(x) {return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoKGameLord::StPatricksDay()
{
  TDate today;
  if(today.Month() == 3 && today.DayOfMonth() == 17)
  {
	 return 1;
  }
  return -1;
}
//*******************************************************************
int16 TCasinoKGameLord::AskCriteriaQuestion(int16 QNum)
{
  switch (QNum)
  {
	 case 0   : return FirstGamePlayer(); //activeplayer
	 case 1   : return Morning();
	 case 2   : return Afternoon();
	 case 3   : return Evening();
	 case 4   : return IsAWinningNumber();
	 case 5   : return IsNumber(37);
	 case 6   : return IsNumber(0);
	 case 7   : return IsNumber(1);
	 case 8   : return IsNumber(2);
	 case 9   : return IsNumber(3);
	 case 10  : return IsNumber(4);
	 case 11  : return IsNumber(5);
	 case 12  : return IsNumber(6);
	 case 13  : return IsNumber(7);
	 case 14  : return IsNumber(8);
	 case 15  : return IsNumber(9);
	 case 16  : return IsNumber(10);
	 case 17  : return IsNumber(11);
	 case 18  : return IsNumber(12);
	 case 19  : return IsNumber(13);
	 case 20  : return IsNumber(14);
	 case 21  : return IsNumber(15);
	 case 22  : return IsNumber(16);
	 case 23  : return IsNumber(17);
	 case 24  : return IsNumber(18);
	 case 25  : return IsNumber(19);
	 case 26  : return IsNumber(20);
	 case 27  : return IsNumber(21);
	 case 28  : return IsNumber(22);
	 case 29  : return IsNumber(23);
	 case 30  : return IsNumber(24);
	 case 31  : return IsNumber(25);
	 case 32  : return IsNumber(26);
	 case 33  : return IsNumber(27);
	 case 34  : return IsNumber(28);
	 case 35  : return IsNumber(29);
	 case 36  : return IsNumber(30);
	 case 37  : return IsNumber(31);
	 case 38  : return IsNumber(32);
	 case 39  : return IsNumber(33);
	 case 40  : return IsNumber(34);
	 case 41  : return IsNumber(35);
	 case 42  : return IsNumber(36);
	 case 43  : return PlayerBet1000();
  }
  return 0;
}
//*******************************************************************
int16 TCasinoKGameLord::Clear()
{
  shutdownstate    = 0;
  playersin       = 1;
  coinsplayed     = 0l;
  winnerpaid      = 0l;
  currentwinnings = 0l;
  return 1;
}
//*******************************************************************
int16 TCasinoKGameLord::PlaceBet(int16 x)
{
  TCasinoPlayerData *player;
  player = GetCasPD(activeplayer);
  if(player==NULL) {return false;}
  TCasinoKData &curdata = player->KData;

  if(curdata.tickets[CurrentTicket.ticketnum].New)
  {
	 if(curdata.tickets[CurrentTicket.ticketnum].spots[x])
	 {
		curdata.tickets[CurrentTicket.ticketnum].spots[x] = false;
	 }
	 else if(NumOfSpots() < 10)
	 {
		curdata.tickets[CurrentTicket.ticketnum].spots[x] = true;
		Sounds->PlaySound(4);
	 }
	 CurrentTicket.spots[x] = curdata.tickets[CurrentTicket.ticketnum].spots[x];
	 switch(NumOfSpots())
	 {
		case 0  : CurrentTicket.game = kgNone; numofspots   = kgNone;break;
		case 1  : CurrentTicket.game = kg1Spot; numofspots  = kg1Spot;break;
		case 2  : CurrentTicket.game = kg2Spot; numofspots  = kg2Spot;break;
		case 3  : CurrentTicket.game = kg3Spot; numofspots  = kg3Spot;break;
		case 4  : CurrentTicket.game = kg4Spot; numofspots  = kg4Spot;break;
		case 5  : CurrentTicket.game = kg5Spot; numofspots  = kg5Spot;break;
		case 6  : CurrentTicket.game = kg6Spot; numofspots  = kg6Spot;break;
		case 7  : CurrentTicket.game = kg7Spot; numofspots  = kg7Spot;break;
		case 8  : CurrentTicket.game = kg8Spot; numofspots  = kg8Spot;break;
		case 9  : CurrentTicket.game = kg9Spot; numofspots  = kg9Spot;break;
		case 10 : CurrentTicket.game = kg10Spot; numofspots = kg10Spot;break;
	 }
	 curdata.tickets[CurrentTicket.ticketnum].game = CurrentTicket.game;
	 DisplayTicket();
  }
  return 1;
}
//*******************************************************************
#pragma argsused
int16 TCasinoKGameLord::RemoveBet(int16 x)
{
  return 1;
}
//*******************************************************************
int16 TCasinoKGameLord::Matches(int32 gameNumber)
{
  int16 temp=currentticketnum[activeplayer];
  TCasinoPlayerData *player = GetCasPD(activeplayer);
  if (player == NULL) {return 0;}
  TCasinoKData &curdata = player->KData;

  int16 x=-1,matches=0;
  int16 temparray[80];
  for(int16 i=0;i<80;i++)
  {
    temparray[i]=-1;
  }
  srand(int16(gameNumber));
  for(int16 i=0;i<20;i++)
  {
    x = (int16)random(80);
    while(temparray[x]>=0)
    {
  	   x=(int16)random(80);
    }
    temparray[x] = x;
  }
	for(int16 i=0;i<80;i++)
	{
	  if(curdata.tickets[temp].spots[i] == true && temparray[i] != -1)
     {
       matches++;
     }
	}
	return matches;
}
//*******************************************************************
TMoney TCasinoKGameLord::Pay1Spot()
{
  TCasinoPlayerData *player = GetCasPD(activeplayer);
  if (player == NULL) {return 0;}
  TCasinoKData &curdata = player->KData;

  int16 temp=currentticketnum[activeplayer],match=0;
  TMoney total=0l,currenttotal=0l;
  int32 i=0,x=0;
  i = curdata.tickets[temp].startinggame;
  x = i + curdata.tickets[temp].plays;
  for(;i<x;i++)
  {
	 match = Matches(i);
	 switch(match)
	 {
		case 1  : if (curdata.tickets[temp].amountper == 1l) {total+= 1l;}
					 else if (curdata.tickets[temp].amountper == 2l){total+= 15l;}
					 else if (curdata.tickets[temp].amountper == 3l){total+= 30l;}
					 break;
	 }
	 PostStats(total-currenttotal,temp);
	 currenttotal = total;
  }
  return total;
}
//*******************************************************************
TMoney TCasinoKGameLord::Pay2Spot()
{
  TCasinoPlayerData *player = GetCasPD(activeplayer);
  if (player == NULL) {return 0;}
  TCasinoKData &curdata = player->KData;

  int16 temp=currentticketnum[activeplayer],match=0;
  TMoney total=0l,currenttotal=0l;
  int32 i=0,x=0;
  i = curdata.tickets[temp].startinggame;
  x = i + curdata.tickets[temp].plays;
  for(;i<x;i++)
  {
	 match = Matches(i);
	 switch(match)
	 {
		case 2  : if (curdata.tickets[temp].amountper == 1l){total+= 13l;}
					 else if (curdata.tickets[temp].amountper == 2l){total+= 65l;}
					 else if (curdata.tickets[temp].amountper == 3l){total+= 130l;}
					 break;
	 }
    PostStats(total-currenttotal,temp);
	 currenttotal = total;
  }
  return total;
}
//*******************************************************************
TMoney TCasinoKGameLord::Pay3Spot()
{
  TCasinoPlayerData *player = GetCasPD(activeplayer);
  if (player == NULL) {return 0;}
  TCasinoKData &curdata = player->KData;

  int16 temp = currentticketnum[activeplayer],match=0;
  TMoney total=0l,currenttotal=0l;
  int32 i=0,x=0;
  i = curdata.tickets[temp].startinggame;
  x = i + curdata.tickets[temp].plays;
  for(;i<x;i++)
  {
	 match = Matches(i);
	 switch(match)
	 {
		case 2  : if (curdata.tickets[temp].amountper == 1l){total+= 1l;}
					 else if (curdata.tickets[temp].amountper == 2l){total+= 5l;}
					 else if (curdata.tickets[temp].amountper == 3l){total+= 10l;}
					 break;
		case 3  : if (curdata.tickets[temp].amountper == 1l){total+= 45l;}
					 else if (curdata.tickets[temp].amountper == 2l){total+= 225l;}
					 else if (curdata.tickets[temp].amountper == 3l){total+= 450l;}
					 break;

	 }
    PostStats(total-currenttotal,temp);
	 currenttotal = total;
  }
  return total;
}
//*******************************************************************
TMoney TCasinoKGameLord::Pay3SpotSpecial()
{
  TCasinoPlayerData *player = GetCasPD(activeplayer);
  if (player == NULL) {return 0;}
  TCasinoKData &curdata = player->KData;

  int16 temp=currentticketnum[activeplayer],match=0;
  TMoney total=0l,currenttotal=0l;
  int32 i=0,x=0;
  i = curdata.tickets[temp].startinggame;
  x = i + curdata.tickets[temp].plays;
  for(;i<x;i++)
  {
	 match = Matches(i);
	 switch(match)
	 {
		case 3  : if (curdata.tickets[temp].amountper == 1l){total+= 50l;}
					 else if (curdata.tickets[temp].amountper == 2l){total+= 250l;}
					 else if (curdata.tickets[temp].amountper == 3l){total+= 500l;}
					 break;
	 }
    PostStats(total-currenttotal,temp);
	 currenttotal = total;
  }
  return total;
}
//*******************************************************************
TMoney TCasinoKGameLord::Pay4Spot()
{
  TCasinoPlayerData *player = GetCasPD(activeplayer);
  if (player == NULL) {return 0;}
  TCasinoKData &curdata = player->KData;

  int16 temp=currentticketnum[activeplayer],match=0;
  TMoney total=0l,currenttotal=0l;
  int32 i=0,x=0;
  i = curdata.tickets[temp].startinggame;
  x = i + curdata.tickets[temp].plays;
  for(;i<x;i++)
  {
	 match = Matches(i);
	 switch(match)
	 {
		case 2  : if (curdata.tickets[temp].amountper == 1l){total+= 1l;}
					 else if (curdata.tickets[temp].amountper == 2l){total+= 5l;}
					 else if (curdata.tickets[temp].amountper == 3l){total+= 10l;}
					 break;
		case 3  : if (curdata.tickets[temp].amountper == 1l){total+= 3l;}
					 else if (curdata.tickets[temp].amountper == 2l){total+= 15l;}
					 else if (curdata.tickets[temp].amountper == 3l){total+= 30l;}
					 break;
		case 4  : if (curdata.tickets[temp].amountper == 1l){total+= 150l;}
					 else if (curdata.tickets[temp].amountper == 2l){total+= 750l;}
					 else if (curdata.tickets[temp].amountper == 3l){total+= 1500l;}
					 break;

	 }
    PostStats(total-currenttotal,temp);
	 currenttotal = total;
  }
  return total;
}
//*******************************************************************
TMoney TCasinoKGameLord::Pay4SpotSpecial()
{
  TCasinoPlayerData *player = GetCasPD(activeplayer);
  if (player == NULL) {return 0;}
  TCasinoKData &curdata = player->KData;

  int16 temp=currentticketnum[activeplayer],match=0;
  TMoney total=0l,currenttotal=0l;
  int32 i=0,x=0;
  i = curdata.tickets[temp].startinggame;
  x = i + curdata.tickets[temp].plays;
  for(;i<x;i++)
  {
	 match = Matches(i);
	 switch(match)
	 {
		case 3  : if(curdata.tickets[temp].amountper == 1l){total+= 5l;}
					 else if(curdata.tickets[temp].amountper == 2l){total+= 25l;}
					 else if(curdata.tickets[temp].amountper == 3l){total+= 50l;}
					 break;
		case 4  : if(curdata.tickets[temp].amountper == 1l){total+= 175;}
					 else if(curdata.tickets[temp].amountper == 2l){total+= 875l;}
					 else if(curdata.tickets[temp].amountper == 3l){total+= 1750l;}
					 break;
	 }
    PostStats(total-currenttotal,temp);
	 currenttotal = total;
  }
  return total;
}
//*******************************************************************
TMoney TCasinoKGameLord::Pay5Spot()
{
  TCasinoPlayerData *player = GetCasPD(activeplayer);
  if (player == NULL) {return 0;}
  TCasinoKData &curdata = player->KData;

  int16 temp=currentticketnum[activeplayer],match=0;
  TMoney total=0l,currenttotal=0l;
  int32 i=0,x=0;
  i = curdata.tickets[temp].startinggame;
  x = i + curdata.tickets[temp].plays;
  for(;i<x;i++)
  {
	 match = Matches(i);
	 switch(match)
	 {
		case 3  : if(curdata.tickets[temp].amountper == 1l){total+= 1l;}
					 else if(curdata.tickets[temp].amountper == 2l){total+= 5l;}
					 else if(curdata.tickets[temp].amountper == 3l){total+= 10l;}
					 break;
		case 4  : if(curdata.tickets[temp].amountper == 1l){total+= 25l;}
					 else if(curdata.tickets[temp].amountper == 2l){total+= 125l;}
					 else if(curdata.tickets[temp].amountper == 3l){total+= 250l;}
					 break;
		case 5  : if(curdata.tickets[temp].amountper == 1l){total+= 600l;}
					 else if(curdata.tickets[temp].amountper == 2l){total+= 3000l;}
					 else if(curdata.tickets[temp].amountper == 3l){total+= 6000l;}
					 break;
	 }
    PostStats(total-currenttotal,temp);
	 currenttotal = total;
  }
  return total;
}
//*******************************************************************
TMoney TCasinoKGameLord::Pay6Spot()
{
  TCasinoPlayerData *player = GetCasPD(activeplayer);
  if (player == NULL) {return 0;}
  TCasinoKData &curdata = player->KData;

  int16 temp=currentticketnum[activeplayer],match=0;
  TMoney total=0l,currenttotal=0l;
  int32 i=0,x=0;
  i = curdata.tickets[temp].startinggame;
  x = i + curdata.tickets[temp].plays;
  for(;i<x;i++)
  {
	 match = Matches(i);
	 switch(match)
	 {
		case 3  : if(curdata.tickets[temp].amountper == 1l){total+= 1l;}
					 else if(curdata.tickets[temp].amountper == 2l){total+= 5l;}
					 else if(curdata.tickets[temp].amountper == 3l){total+= 10l;}
					 break;
		case 4  : if(curdata.tickets[temp].amountper == 1l){total+= 5l;}
					 else if(curdata.tickets[temp].amountper == 2l){total+= 25l;}
					 else if(curdata.tickets[temp].amountper == 3l){total+= 50l;}
					 break;
		case 5  : if(curdata.tickets[temp].amountper == 1l){total+= 75l;}
					 else if(curdata.tickets[temp].amountper == 2l){total+= 375l;}
					 else if(curdata.tickets[temp].amountper == 3l){total+= 750l;}
					 break;
		case 6  : if(curdata.tickets[temp].amountper == 1l){total+= 200l;}
					 else if(curdata.tickets[temp].amountper == 2l){total+= 1000l;}
					 else if(curdata.tickets[temp].amountper == 3l){total+= 2000l;}
					 break;
	 }
    PostStats(total-currenttotal,temp);
	 currenttotal = total;
  }
  return total;
}
//*******************************************************************
TMoney TCasinoKGameLord::Pay6SpotSpecial()
{
  TCasinoPlayerData *player = GetCasPD(activeplayer);
  if (player == NULL) {return 0;}
  TCasinoKData &curdata = player->KData;

  int16 temp=currentticketnum[activeplayer],match=0;
  TMoney total=0l,currenttotal=0l;
  int32 i=0,x=0;
  i = curdata.tickets[temp].startinggame;
  x = i + curdata.tickets[temp].plays;
  for(;i<x;i++)
  {
	 match = Matches(i);
	 switch(match)
	 {
		case 4  : if(curdata.tickets[temp].amountper == 1l){total+= 1l;}
					 else if(curdata.tickets[temp].amountper == 2l){total+= 5l;}
					 else if(curdata.tickets[temp].amountper == 3l){total+= 10l;}
					 break;
		case 5  : if(curdata.tickets[temp].amountper == 1l){total+= 25;}
					 else if(curdata.tickets[temp].amountper == 2l){total+= 125l;}
					 else if(curdata.tickets[temp].amountper == 3l){total+= 250l;}
					 break;
		case 6  : if(curdata.tickets[temp].amountper == 1l){total+= 2000l;}
					 else if(curdata.tickets[temp].amountper == 2l){total+= 10000l;}
					 else if(curdata.tickets[temp].amountper == 3l){total+= 20000l;}
					 break;
	 }
    PostStats(total-currenttotal,temp);
	 currenttotal = total;
  }
  return total;
}
//*******************************************************************
TMoney TCasinoKGameLord::Pay7Spot()
{
  TCasinoPlayerData *player = GetCasPD(activeplayer);
  if (player == NULL) {return 0;}
  TCasinoKData &curdata = player->KData;

  int16 temp=currentticketnum[activeplayer],match=0;
  TMoney total,currenttotal;
  int32 i=0,x=0;
  i = curdata.tickets[temp].startinggame;
  x = i + curdata.tickets[temp].plays;
  for(;i<x;i++)
  {
	 match = Matches(i);
	 switch(match)
	 {
		case 4  : if(curdata.tickets[temp].amountper == 1l){total+= 1l;}
					 else if(curdata.tickets[temp].amountper == 2l){total+= 5l;}
					 else if(curdata.tickets[temp].amountper == 3l){total+= 10l;}
					 break;
		case 5  : if(curdata.tickets[temp].amountper == 1l){total+= 20l;}
					 else if(curdata.tickets[temp].amountper == 2l){total+= 100l;}
					 else if(curdata.tickets[temp].amountper == 3l){total+= 200l;}
					 break;
		case 6  : if(curdata.tickets[temp].amountper == 1l){total+= 5000l;}
					 else if(curdata.tickets[temp].amountper == 2l){total+= 25000l;}
					 else if(curdata.tickets[temp].amountper == 3l){total+= 50000l;}
					 break;
		case 7  : if(curdata.tickets[temp].amountper == 1l){total+= 7500l;}
					 else if(curdata.tickets[temp].amountper == 2l){total+= 37500l;}
					 else if(curdata.tickets[temp].amountper == 3l){total+= 75000l;}
					 break;
	 }
	 PostStats(total-currenttotal,temp);
	 currenttotal = total;
  }
  return total;
}
//*******************************************************************
TMoney TCasinoKGameLord::Pay8Spot()
{
  TCasinoPlayerData *player = GetCasPD(activeplayer);
  if (player == NULL) {return 0;}
  TCasinoKData &curdata = player->KData;

  int16 temp=currentticketnum[activeplayer],match=0;
  TMoney total=0,currenttotal=0;
  int32 i=0,x=0;
  i = curdata.tickets[temp].startinggame;
  x = i + curdata.tickets[temp].plays;
  for(;i<x;i++)
  {
	 match = Matches(i);
	 switch(match)
	 {
		case 5  : if(curdata.tickets[temp].amountper == 1){total+= 5;}
					 else if(curdata.tickets[temp].amountper == 2){total+= 25;}
					 else if(curdata.tickets[temp].amountper == 3){total+= 50;}
					 break;
		case 6  : if(curdata.tickets[temp].amountper == 1){total+= 100;}
					 else if(curdata.tickets[temp].amountper == 2){total+= 500;}
					 else if(curdata.tickets[temp].amountper == 3){total+= 1000;}
					 break;
		case 7  : if(curdata.tickets[temp].amountper == 1){total+= 1500;}
					 else if(curdata.tickets[temp].amountper == 2){total+= 7500;}
					 else if(curdata.tickets[temp].amountper == 3){total+= 15000;}
					 break;
		case 8  : if(curdata.tickets[temp].amountper == 1){total+= 50000l;}
					 else if(curdata.tickets[temp].amountper == 2){total+= 250000l;}
					 else if(curdata.tickets[temp].amountper == 3){total+= 500000l;}
					 break;
	 }
	 PostStats(total-currenttotal,temp);
	 currenttotal = total;
  }
  return total;
}
//*******************************************************************
TMoney TCasinoKGameLord::Pay9Spot()
{
  TCasinoPlayerData *player = GetCasPD(activeplayer);
  if (player == NULL) {return 0;}
  TCasinoKData &curdata = player->KData;

  int16 temp=currentticketnum[activeplayer],match=0;
  TMoney total=0,currenttotal=0;
  int32 i=0,x=0;
  i = curdata.tickets[temp].startinggame;
  x = i + curdata.tickets[temp].plays;
  for(;i<x;i++)
  {
	 match = Matches(i);
	 switch(match)
	 {
		case 4  : if(curdata.tickets[temp].amountper == 1l){total+= 1l;}
					 else if(curdata.tickets[temp].amountper == 2l){total+= 5l;}
					 else if(curdata.tickets[temp].amountper == 3l){total+= 10l;}
					 break;
		case 5  : if(curdata.tickets[temp].amountper == 1l){total+= 5l;}
					 else if(curdata.tickets[temp].amountper == 2l){total+= 25l;}
					 else if(curdata.tickets[temp].amountper == 3l){total+= 50l;}
					 break;
		case 6  : if(curdata.tickets[temp].amountper == 1l){total+= 25l;}
					 else if(curdata.tickets[temp].amountper == 2l){total+= 125l;}
					 else if(curdata.tickets[temp].amountper == 3l){total+= 250l;}
					 break;
		case 7  : if(curdata.tickets[temp].amountper == 1l){total+= 250l;}
					 else if(curdata.tickets[temp].amountper == 2l){total+= 1200l;}
					 else if(curdata.tickets[temp].amountper == 3l){total+= 2500l;}
					 break;
		case 8  : if(curdata.tickets[temp].amountper == 1l){total+= 5000l;}
					 else if(curdata.tickets[temp].amountper == 2){total+= 25000l;}
					 else if(curdata.tickets[temp].amountper == 3l){total+= 50000l;}
					 break;
		case 9  : if(curdata.tickets[temp].amountper == 1l){total+= 50000l;}
					 else if(curdata.tickets[temp].amountper == 2l){total+= 250000l;}
					 else if(curdata.tickets[temp].amountper == 3l){total+= 500000l;}
					 break;
	 }
	 PostStats(total-currenttotal,temp);
	 currenttotal = total;
  }
  return total;
}
//*******************************************************************
TMoney TCasinoKGameLord::Pay10Spot()
{
  TCasinoPlayerData *player = GetCasPD(activeplayer);
  if (player == NULL) {return 0;}
  TCasinoKData &curdata = player->KData;

  int16 temp=currentticketnum[activeplayer],match=0;
  TMoney total=0,currenttotal=0;
  int32 i=0,x=0;
  i = curdata.tickets[temp].startinggame;
  x = i + curdata.tickets[temp].plays;
  for(;i<x;i++)
  {
	 match = Matches(i);
	 switch(match)
	 {
		case 5  : if(curdata.tickets[temp].amountper == 1l){total+= 1l;}
					 else if(curdata.tickets[temp].amountper == 2l){total+= 5l;}
					 else if(curdata.tickets[temp].amountper == 3l){total+= 10l;}
					 break;
		case 6  : if(curdata.tickets[temp].amountper == 1l){total+= 25l;}
					 else if(curdata.tickets[temp].amountper == 2l){total+= 125l;}
					 else if(curdata.tickets[temp].amountper == 3l){total+= 250l;}
					 break;
		case 7  : if(curdata.tickets[temp].amountper == 1l){total+= 125l;}
					 else if(curdata.tickets[temp].amountper == 2l){total+= 625l;}
					 else if(curdata.tickets[temp].amountper == 3l){total+= 1250l;}
					 break;
		case 8  : if(curdata.tickets[temp].amountper == 1l){total+= 1000l;}
					 else if(curdata.tickets[temp].amountper == 2l){total+= 5000l;}
					 else if(curdata.tickets[temp].amountper == 3l){total+= 10000l;}
					 break;
		case 9  : if(curdata.tickets[temp].amountper == 1l){total+= 12500l;}
					 else if(curdata.tickets[temp].amountper == 2l){total+= 62500l;}
					 else if(curdata.tickets[temp].amountper == 3l){total+= 125000l;}
					 break;
		case 10 : if(curdata.tickets[temp].amountper == 1l){total+= 100000l;}
					 else if(curdata.tickets[temp].amountper == 2l){total+= 500000l;}
					 else if(curdata.tickets[temp].amountper == 3l){total+= 1000000l;}
					 break;
	 }
    PostStats(total-currenttotal,temp);
	 currenttotal = total;
  }
  return total;
}
//*******************************************************************
TMoney TCasinoKGameLord::PayOut()
{
  int16 temp=currentticketnum[activeplayer];
  TCasinoPlayerData *player;
  player = GetCasPD(activeplayer);
  switch(player->KData.tickets[temp].game)
  {
	 case kgNone         : return 0l;
	 case kg1Spot        : return Pay1Spot();
	 case kg2Spot        : return Pay2Spot();
	 case kg3Spot        : return Pay3Spot();
	 case kg3SpotSpecial : return Pay3SpotSpecial();
	 case kg4Spot        : return Pay4Spot();
	 case kg4SpotSpecial : return Pay4SpotSpecial();
	 case kg5Spot        : return Pay5Spot();
	 case kg6Spot        : return Pay6Spot();
	 case kg6SpotSpecial : return Pay6SpotSpecial();
	 case kg7Spot        : return Pay7Spot();
	 case kg8Spot        : return Pay8Spot();
	 case kg9Spot        : return Pay9Spot();
	 case kg10Spot       : return Pay10Spot();
	 default             : return 0l;
  }
}
//*******************************************************************
bool TCasinoKGameLord::Winner()
{
  int16 temp=currentticketnum[activeplayer];
  TCasinoPlayerData *player;
  player = GetCasPD(activeplayer);
  if (player == NULL) {return false;}

  TCasinoKData &curdata = player->KData;

  if(curdata.tickets[temp].startinggame != -1 &&
     curdata.tickets[temp].paid == -1l        &&
     !(curdata.tickets[temp].New)             &&
     ((curdata.tickets[temp].startinggame + curdata.tickets[temp].plays - 1 < currentgame) ||
     (ShowWin &&
      curdata.tickets[temp].startinggame + curdata.tickets[temp].plays - 1 == currentgame)))
  {
    curdata.tickets[temp].paid = PayOut();
    CurrentTicket.paid = curdata.tickets[temp].paid;
    AddCash(activeplayer,curdata.tickets[temp].paid);
    if(CurrentTicket.paid == 0l)
    {
      Sounds->PlaySound(8);
      LoserType = int16(((++LoserType)%3)+1);// range 1-3
      curdata.tickets[temp].LoserPrintType = LoserType;
      CurrentTicket.LoserPrintType = LoserType;
    } //loser
    if(CurrentTicket.paid >  0l){Sounds->PlaySound(7);} //winner
    DisplayTicket();
    Chips->SetNum(GetCash(activeplayer));
    BankCashDisplay->SetNum(GetCash(activeplayer));
  }
  return true;
}// winner
//*******************************************************************
#pragma argsused
int16 TCasinoKGameLord::Loser(int16 loser)
{
  return 1;
}// loser
//*******************************************************************
bool TCasinoKGameLord::HasTicket()
{
  int16 i=0;
  TCasinoPlayerData *player;
  player = GetCasPD(activeplayer);
  if(player != NULL)
  {
	 for(i=0;i<100;i++)
	 {
		if(player->KData.tickets[i].startinggame != -1 ||
			player->KData.tickets[i].New == true         )
		{
		  return true;
		}
	 }
  }
  return false;
}
//*******************************************************************
int16 TCasinoKGameLord::HasBlankTicket()
{
  int16 i=0,k=0;
  bool Check = false;
  TCasinoPlayerData *player;
  player = GetCasPD(activeplayer);
  if(player != NULL)
  {
    TCasinoKData &curdata = player->KData;
	 for(i=0;i<100;i++)
	 {
		Check = false;
		if(curdata.tickets[i].New          == true   &&
			curdata.tickets[i].plays        == -1     &&
			curdata.tickets[i].game         == kgNone &&
			curdata.tickets[i].amountper    == -1l    &&
			curdata.tickets[i].startinggame == -1     &&
			curdata.tickets[i].paid         == -1l      )
		{
		  for(k=0;k<80;k++)
		  {
			 if(curdata.tickets[i].spots[k] == true){Check = true;}
		  }
		  if(!Check){return i;}
		}
	 }
  }
  return -1;
}
//*******************************************************************
void TCasinoKGameLord::HasTwoBlankTickets()
{
  int16 firstblank = HasBlankTicket(),secondblank = -1;
  if(firstblank == -1){return;}
  int16 i=0,k=0;
  bool Check = false;
  TCasinoPlayerData *player;
  player = GetCasPD(activeplayer);
  if(player != NULL)
  {
    TCasinoKData &curdata = player->KData;
	 for(i=int16(firstblank+1);i<100;i++)
	 {
		Check = false;
		if(curdata.tickets[i].New          == true   &&
			curdata.tickets[i].plays        == -1     &&
			curdata.tickets[i].game         == kgNone &&
			curdata.tickets[i].amountper    == -1l    &&
			curdata.tickets[i].startinggame == -1     &&
			curdata.tickets[i].paid         == -1l      )
		{
		  for(k=0;k<80;k++)
		  {
			 if(curdata.tickets[i].spots[k] == true){Check = true;}
		  }
		  if(!Check){secondblank = i;}
		}
	 }
	 if(secondblank != -1)
	 {
		int16 temp=currentticketnum[activeplayer];
		if(secondblank == temp){DeleteTicket(firstblank);}
		else{DeleteTicket(secondblank);}
	 }
  }
  return;
}
//*******************************************************************
void TCasinoKGameLord::NewTicketCheck()
{
  if(!HasTicket())
  {
	 NewTicket();
    DisplayTicketForward();
  }
  HasTwoBlankTickets();
  return;
}
//*******************************************************************
void TCasinoKGameLord::TimeChanged()
{
  GetCasGameData()->SetCurrentGameStartSec();
  GetCasGameData()->ShiftCreationSecBack();
  MainDisplay->NoShow();
}
//*******************************************************************
void TCasinoKGameLord::UpdateMain()
{
  Winner();
  if(activeplayer > -1 && GetCash(activeplayer) > 0l)
  {
		 NewTicketCheck();
  }
  if(GetCasGameData()->ShiftCreationSecBack())
  {
	 TimeChanged();
  }
  dword  CurrentDelta = GetCasGameData()->CurrentTimeDelta();
  if(LastTime == CurrentDelta)
//  {return 1;}
  {return;} //MRP 12/21/96
  else
  {
	 if(LastTime/180 != CurrentDelta/180){MainDisplay->NoShow();}
	 LastTime=CurrentDelta;
  }
  dword SecondsInto=0;
  currentgame = (CurrentDelta/180)+1;
  SecondsInto = CurrentDelta - ((currentgame-1)*180);
  Time->SetNum(int16(SecondsInto));
  if(CurrentDelta%180 == 0)
  {
    ShowWin = false;
    GetCasGameData()->SetCurrentGameStartSec();
  }
  if(SecondsInto == 60)
  {
	 ShowWin = true;
	 TCasinoPlayerData *player;
	 player = GetCasPD(activeplayer);
	 if(player)
	 {
		int16 session = player->KData.CurrentSession;
		for(int16 i=0;i<80;i++)
		{
		  if(KenoArray[i] > -1)
		  {
			 player->KData.Sessions[session].nMostFrequentNums[i]++;
		  }
		}
	 }
  }
  if(SecondsInto > 165)
//  {return 1;}
  {return;} //MRP 12/21/96
  GameNum->SetNum(currentgame);
  if(SecondsInto > 164)
  {
	 MainDisplay->NoShow();
	 GameNum->NoShow();
	 Sounds->PlaySound(0);
  }
  else
  {
	 int16 drawnums=int16(SecondsInto/3);
    int16 i=0;
	 if(drawnums>20){drawnums=20;}
	 srand(int16(currentgame));
	 int16 x = -1;
	 for(i=0;i<80;i++)
	 {
		KenoArray[i] = -1;
	 }
	 for(i=0;i<drawnums;i++)
	 {
		x = int16(random(80));
		while(KenoArray[x] >= 0)
		{
        x = int16(random(80));
      }
		KenoArray[x] = x;
		MainDisplay->SetNum(x,i);
	 }
	 if(drawnums<20)
	 {
		x = int16(random(80));
		while(KenoArray[x] >= 0)
		{
        x = int16(random(80));
      }
		KenoArray[x] = x;
		if(SecondsInto%3 == 0)
		{
		  Genie->SetNum(x);
		  Sounds->PlaySound(1);
		}
		else
		{
		  Genie->NoShow();
		  MainDisplay->SetNum(x,i);
		}
	 }
  }

}
//*******************************************************************
void TCasinoKGameLord::InitHistoryDisplay()
{
  GetCasGameData()->SetCurrentGameStartSec();
  GetCasGameData()->ShiftCreationSecBack();
  dword  StartDelta = GetCasGameData()->CurrentTimeDelta();
  LastTime = StartDelta;
  currenthistory = StartDelta/180;
  currentgame = currenthistory+1;
  GameNum->SetNum(currentgame);
  DisplayHistory();
  dword SecondsInto=0;
  SecondsInto = StartDelta - (currenthistory*180);
  int16 drawnums=int16(SecondsInto/3);
  int16 i=0;
  if(drawnums>20){drawnums=20;}
  srand(int16(currentgame));
  int16 x = -1;
  for(i=0;i<80;i++)
  {
	 KenoArray[i] = -1;
  }
  for(i=0;i<drawnums;i++)
  {
	 x = int16(random(80));
	 while(KenoArray[x] >= 0)
	 {
      x = int16(random(80));
    }
	 KenoArray[x] = x;
	 MainDisplay->SetNum(x,i);
  }
  if(drawnums<20)
  {
	 x = int16(random(80));
	 while(KenoArray[x] >= 0)
	 {
      x = int16(random(80));
    }
	 KenoArray[x] = x;
	 if(SecondsInto%3 == 0)
	 {
		Genie->SetNum(x);
	 }
	 else
	 {
		MainDisplay->SetNum(x,i);
	 }
  }
  if(SecondsInto > 164)
  {
	 MainDisplay->NoShow();
	 GameNum->NoShow();
  }
  Time->SetNum(int16(SecondsInto));
}
//*******************************************************************
int16 TCasinoKGameLord::InitKeno()
{
  InitHistoryDisplay();
  NamePlate1->NoShow();NamePlate2->NoShow();NamePlate3->NoShow();
  SetupActivePlayer(NextSlotNum(-1)); // -1 because order of checking
  string name;
  Responders[89]->SetEnterLeave();
  if(GetCasPD(0))
  {
    name = GetCasPD(0)->GetName();
	 NamePlate1->ShowNamePlateString(name);
	 BankCashDisplay->SetNum(GetCash(0));
	 GetCasPD(0)->StartKSession(SubGameType,GameDenom);
  }
  else if(GetCasPD(1))
  {
	 name = GetCasPD(1)->GetName();
	 NamePlate2->ShowNamePlateString(name);
	 BankCashDisplay->SetNum(GetCash(1));
	 GetCasPD(1)->StartKSession(SubGameType,GameDenom);
  }
  else if(GetCasPD(2))
  {
	 name = GetCasPD(2)->GetName();
	 NamePlate3->ShowNamePlateString(name);
	 BankCashDisplay->SetNum(GetCash(2));
	 GetCasPD(2)->StartKSession(SubGameType,GameDenom);
  }
  credits = 0;
  coinsplayed = 0l;
  winnerpaid = 0l;
  Winner();
  Button7->PButtonResponder->SetCh(VK_RETURN);
  if (!GetFW()->GetHandleShowMenu())
  {
	 Button2->PButton->CAD.SetCurrentFrame(3);
	 Button2->PButton->Show();
	 Button2->PButtonResponder->Remove();
  }
  return 1;
}
//*******************************************************************
int16 TCasinoKGameLord::BetLast()
{
  if(GetCash(activeplayer) > GetKPlayer(activeplayer)->lastbet)
  {
	 SubCash(activeplayer,GetKPlayer(activeplayer)->lastbet);
	 coinsplayed += GetKPlayer(activeplayer)->lastbet;
	 GetKPlayer(activeplayer)->coinsplayed += GetKPlayer(activeplayer)->lastbet;
	 Chips->SetNum(GetCash(activeplayer));
    BankCashDisplay->SetNum(GetCash(activeplayer));
  }
  return 1;
}
//*******************************************************************
int16 TCasinoKGameLord::ClearBet()
{
  if(coinsplayed > 0l)
  {
	 AddCash(activeplayer,coinsplayed);
	 coinsplayed = 0l;
	 GetKPlayer(activeplayer)->coinsplayed = 0l;

	 Chips->SetNum(GetCash(activeplayer));
	 BankCashDisplay->SetNum(GetCash(activeplayer));
  }
  return 1;
}
//*******************************************************************
int16 TCasinoKGameLord::BetMax()
{
  if(GetCash(activeplayer) > ((maxbet-coinsplayed)*coinsize))
  {
	 SubCash(activeplayer,(int32)((maxbet-coinsplayed)*coinsize));
	 coinsplayed = (int32)maxbet;
  }
  else
  {
	 SetCash(activeplayer,GetCash(activeplayer)%(int32)coinsize);
  }
  return 1;
}
//*******************************************************************