//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  cksp.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0    03/23/96    A.Krist     moved inline functions into .cpp file.
//  2.0    09/17/97    M.Perry     32-bit conversion.
//********************************************************************
#include "ckhnsp.h"
#include "oanm.h"
//*******************************************************************
void TKHistoryNums::SetupAnms()
{
  for(int16 i=0;i<5;i++)
  {
	 PHistoryNums[i] = GetAnm(i);
	 if (PHistoryNums[i] == NULL) {AnmError("KHistoryNums","HistoryNums",i);}
	 PHistoryNums[i]->CAD.ClearAutoStart();
	 PHistoryNums[i]->CAD.ClearAutoStop();
	 PHistoryNums[i]->CAD.SetDirStill();
  }
}
//*******************************************************************
TKHistoryNums::TKHistoryNums(TOgleModeWindow *pmw,TFileMode NewFileMode)
:TSprite(pmw,NewFileMode)
{
  SetToManual();
  NoShow();
  SetupAnms();
}
//********************************************************************
TKHistoryNums::TKHistoryNums(TOgleModeWindow *pmw,TFileMode fm,void *psource)
:TSprite(pmw,fm,psource)
{
  SetToManual();
  NoShow();
  SetupAnms();
}
 //*******************************************************************
TKHistoryNums::~TKHistoryNums()
{
}
//*******************************************************************
void TKHistoryNums::SetNum(int32 num)
{
	int32 ones=0,tens=0,huns=0,thou=0,tenthou=0;
	 if (PHistoryNums[0] == NULL) {return;}
	 if (PHistoryNums[1] == NULL) {return;}
	 if (PHistoryNums[2] == NULL) {return;}
	 if (PHistoryNums[3] == NULL) {return;}
	 if (PHistoryNums[4] == NULL) {return;}

	 ones = num % 10;
	 tens = (num / 10  ) % 10;
	 huns = (num / 100 ) % 10;
	 thou = (num / 1000) % 10;
	 tenthou = (num / 10000) % 10;
	 PHistoryNums[4]->CAD.SetCurrentFrame(int16(ones));
	 PHistoryNums[3]->CAD.SetCurrentFrame(int16(tens));
	 PHistoryNums[2]->CAD.SetCurrentFrame(int16(huns));
	 PHistoryNums[1]->CAD.SetCurrentFrame(int16(thou));
	 PHistoryNums[0]->CAD.SetCurrentFrame(int16(tenthou));
	 for(int i=0;i<5;i++)
	 {
		PHistoryNums[i]->Show();
	 }
    Update(GetAdjFUC());
}
//*******************************************************************