//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  cclordst.cpp
//    Project Name:  Ogle
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     06/01/95   A. Krist    Original baseline
//  2.0     09/17/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "cklordst.h"
#include "ckglord.h"
#include "ckplay.h"
//*******************************************************************
TKLordState::TKLordState(TCasinoKGameLord *pNewKLord)
{
  pOwnerLord = pNewKLord;
  LockButtons = false;
  LockHit = false;
  HitTotal = false;
  IgnoreCoach = false;
  ExpertDelayStart = 0;
}
//*******************************************************************
TKLordState::~TKLordState()
{
}
//*******************************************************************
bool TKLordState::StatBar(TResponder &responder)
{
  return HandleStatBar(responder);
}
//*******************************************************************
bool TKLordState::BetSpot(TResponder &responder,int16 spot)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TKLordState *)PActiveSubState)->BetSpot(responder,spot);
  }
  else
  {
	 return HandleBetSpot(responder,spot);
  }
}
//*******************************************************************
bool TKLordState::NamePlate(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TKLordState *)PActiveSubState)->NamePlate(responder);
  }
  else
  {
	 return HandleNamePlate(responder);
  }
}
//*******************************************************************
bool TKLordState::AskExpertButton(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TKLordState *)PActiveSubState)->AskExpertButton(responder);
  }
  else
  {
	 return HandleAskExpert(responder);
  }
}
//*******************************************************************
bool TKLordState::Button1(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TKLordState *)PActiveSubState)->Button1(responder);
  }
  else
  {
	 return HandleButton1(responder);
  }
}
//*******************************************************************
bool TKLordState::Button2(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TKLordState *)PActiveSubState)->Button2(responder);
  }
  else
  {
	 return HandleButton2(responder);
  }
}
//*******************************************************************
bool TKLordState::Button3(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TKLordState *)PActiveSubState)->Button3(responder);
  }
  else
  {
	 return HandleButton3(responder);
  }
}
//*******************************************************************
bool TKLordState::Button4(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TKLordState *)PActiveSubState)->Button4(responder);
  }
  else
  {
	 return HandleButton4(responder);
  }
}
//*******************************************************************
bool TKLordState::MenuEscButton(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TKLordState *)PActiveSubState)->MenuEscButton(responder);
  }
  else
  {
	 return HandleMenuEsc(responder);
  }
}
//*******************************************************************
bool TKLordState::BetAmount(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TKLordState *)PActiveSubState)->BetAmount(responder);
  }
  else
  {
	 return HandleBetAmount(responder);
  }
}
//*******************************************************************
bool TKLordState::Games(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TKLordState *)PActiveSubState)->Games(responder);
  }
  else
  {
	 return HandleGames(responder);
  }
}
//*******************************************************************
bool TKLordState::Plays(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TKLordState *)PActiveSubState)->Plays(responder);
  }
  else
  {
	 return HandlePlays(responder);
  }
}
//*******************************************************************
bool TKLordState::TicketRight(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TKLordState *)PActiveSubState)->TicketRight(responder);
  }
  else
  {
	 return HandleTicketRight(responder);
  }
}
//*******************************************************************
bool TKLordState::TicketLeft(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TKLordState *)PActiveSubState)->TicketLeft(responder);
  }
  else
  {
	 return HandleTicketLeft(responder);
  }
}
//*******************************************************************
bool TKLordState::HistoryRight(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TKLordState *)PActiveSubState)->HistoryRight(responder);
  }
  else
  {
	 return HandleHistoryRight(responder);
  }
}
//*******************************************************************
bool TKLordState::HistoryLeft(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TKLordState *)PActiveSubState)->HistoryLeft(responder);
  }
  else
  {
	 return HandleHistoryLeft(responder);
  }
}
//*******************************************************************

