//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  cksp.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0    03/23/96    A.Krist     moved inline functions into .cpp file.
//  2.0    09/17/97    M.Perry     32-bit conversion.
//********************************************************************
#include "ckoldsp.h"
#include "oanm.h"
//*******************************************************************
void TKResult::SetupAnms()
{
  for(int16 i=0;i<9;i++)
  {
	 PResult[i] = GetAnm(i);
	 if (PResult[i] == NULL) {AnmError("KResult","Result",i);}
	 PResult[i]->CAD.ClearAutoStart();
	 PResult[i]->CAD.ClearAutoStop();
	 PResult[i]->CAD.SetDirStill();
  }
}
//*******************************************************************
TKResult::TKResult(TOgleModeWindow *pmw,TFileMode NewFileMode)
:TSprite(pmw,NewFileMode)
{
  SetToManual();
  NoShow();
  SetupAnms();
}
//********************************************************************
TKResult::TKResult(TOgleModeWindow *pmw,TFileMode fm,void *psource)
:TSprite(pmw,fm,psource)
{
  SetToManual();
  NoShow();
  SetupAnms();
}
 //*******************************************************************
TKResult::~TKResult()
{
}
//*******************************************************************
void TKResult::SetNum(TMoney money,int16 loserframe)
{
  long paid = (long)money;
	if(paid <= -1)
	{
	  for(int i=0;i<9;i++)
	  {
		 PResult[i]->NoShow();
	  }
	  return;
	}
	else if(paid == 0)
	{
	  for(int i=0;i<8;i++)
	  {
		 PResult[i]->NoShow();
	  }
	  if(loserframe < 1 || loserframe > 3){loserframe = 1;}
	  PResult[8]->CAD.SetCurrentFrame(loserframe);
	  PResult[8]->Show();
	  Update(GetAdjFUC());
	}
	else
	{
    int32 ones=0,tens=0,huns=0,thou=0,tenthou=0,hunthou=0,mill=0;
	 if (PResult[0] == NULL) {return;}
	 if (PResult[1] == NULL) {return;}
	 if (PResult[2] == NULL) {return;}
	 if (PResult[3] == NULL) {return;}
	 if (PResult[4] == NULL) {return;}
	 if (PResult[5] == NULL) {return;}
	 if (PResult[6] == NULL) {return;}
	 if (PResult[7] == NULL) {return;}
	 if (PResult[8] == NULL) {return;}

	 ones =    (paid          ) % 10;
	 tens =    (paid / 10     ) % 10;
	 huns =    (paid / 100    ) % 10;
	 thou =    (paid / 1000   ) % 10;
	 tenthou = (paid / 10000  ) % 10;
	 hunthou = (paid / 100000l ) % 10;
	 mill    = (paid / 1000000l) % 10;
	 if(mill)
	 {
		PResult[0]->CAD.SetCurrentFrame(10);
      PResult[0]->Show();
		PResult[1]->CAD.SetCurrentFrame(int16(mill));
      PResult[1]->Show();
		PResult[2]->CAD.SetCurrentFrame(int16(hunthou));
      PResult[2]->Show();
		PResult[3]->CAD.SetCurrentFrame(int16(tenthou));
      PResult[3]->Show();
		PResult[4]->CAD.SetCurrentFrame(int16(thou));
      PResult[4]->Show();
		PResult[5]->CAD.SetCurrentFrame(int16(huns));
      PResult[5]->Show();
		PResult[6]->CAD.SetCurrentFrame(int16(tens));
      PResult[6]->Show();
		PResult[7]->CAD.SetCurrentFrame(int16(ones));
      PResult[7]->Show();
	 }
	 else if(hunthou)
	 {
		PResult[0]->NoShow();
		PResult[1]->CAD.SetCurrentFrame(10);
      PResult[1]->Show();
		PResult[2]->CAD.SetCurrentFrame(int16(hunthou));
      PResult[2]->Show();
		PResult[3]->CAD.SetCurrentFrame(int16(tenthou));
      PResult[3]->Show();
		PResult[4]->CAD.SetCurrentFrame(int16(thou));
      PResult[4]->Show();
		PResult[5]->CAD.SetCurrentFrame(int16(huns));
      PResult[5]->Show();
		PResult[6]->CAD.SetCurrentFrame(int16(tens));
      PResult[6]->Show();
		PResult[7]->CAD.SetCurrentFrame(int16(ones));
      PResult[7]->Show();
	 }
	 else if(tenthou)
	 {
		PResult[0]->NoShow();
		PResult[1]->CAD.SetCurrentFrame(10);
      PResult[1]->Show();
		PResult[2]->CAD.SetCurrentFrame(int16(tenthou));
      PResult[2]->Show();
		PResult[3]->CAD.SetCurrentFrame(int16(thou));
      PResult[3]->Show();
		PResult[4]->CAD.SetCurrentFrame(int16(huns));
      PResult[4]->Show();
		PResult[5]->CAD.SetCurrentFrame(int16(tens));
      PResult[5]->Show();
		PResult[6]->CAD.SetCurrentFrame(int16(ones));
      PResult[6]->Show();
		PResult[7]->NoShow();
	 }
	 else if(thou)
	 {
		PResult[0]->NoShow();
		PResult[1]->NoShow();
		PResult[2]->CAD.SetCurrentFrame(10);
      PResult[2]->Show();
		PResult[3]->CAD.SetCurrentFrame(int16(thou));
      PResult[3]->Show();
		PResult[4]->CAD.SetCurrentFrame(int16(huns));
      PResult[4]->Show();
		PResult[5]->CAD.SetCurrentFrame(int16(tens));
      PResult[5]->Show();
		PResult[6]->CAD.SetCurrentFrame(int16(ones));
      PResult[6]->Show();
		PResult[7]->NoShow();
	 }
	 else if(huns)
	 {
		PResult[0]->NoShow();
		PResult[1]->NoShow();
		PResult[2]->CAD.SetCurrentFrame(10);
      PResult[2]->Show();
		PResult[3]->CAD.SetCurrentFrame(int16(huns));
      PResult[3]->Show();
		PResult[4]->CAD.SetCurrentFrame(int16(tens));
      PResult[4]->Show();
		PResult[5]->CAD.SetCurrentFrame(int16(ones));
      PResult[5]->Show();
		PResult[6]->NoShow();
		PResult[7]->NoShow();
	 }
	 else if(tens)
	 {
		PResult[0]->NoShow();
		PResult[1]->NoShow();
		PResult[2]->NoShow();
		PResult[3]->CAD.SetCurrentFrame(10);
      PResult[3]->Show();
		PResult[4]->CAD.SetCurrentFrame(int16(tens));
      PResult[4]->Show();
		PResult[5]->CAD.SetCurrentFrame(int16(ones));
      PResult[5]->Show();
		PResult[6]->NoShow();
		PResult[7]->NoShow();
	 }
	 else if(ones)
	 {
		PResult[0]->NoShow();
		PResult[1]->NoShow();
		PResult[2]->NoShow();
		PResult[3]->CAD.SetCurrentFrame(10);
      PResult[3]->Show();
		PResult[4]->CAD.SetCurrentFrame(int16(ones));
      PResult[4]->Show();
		PResult[5]->NoShow();
		PResult[6]->NoShow();
		PResult[7]->NoShow();
	 }
	 PResult[8]->CAD.SetCurrentFrame(0);
	 PResult[8]->Show();
    Update(GetAdjFUC());
	}
}
//*******************************************************************