//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  cksp.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0    03/23/96    A.Krist     moved inline functions into .cpp file.
//  2.0    09/17/97    M.Perry     32-bit conversion.
//********************************************************************
#include "ckplsp.h"
#include "oanm.h"
//*******************************************************************
void TKPlays::SetupAnms()
{
  PPlays = NULL;
  PPlays = GetAnm(0);
  if (PPlays == NULL) {AnmError("KPlays","Plays",0);}
  PPlays->CAD.ClearAutoStart();
  PPlays->CAD.ClearAutoStop();
  PPlays->CAD.SetDirStill();
}
//*******************************************************************
TKPlays::TKPlays(TOgleModeWindow *pmw,TFileMode NewFileMode)
:TSprite(pmw,NewFileMode)
{
  SetToManual();
  NoShow();
  SetupAnms();
}
//********************************************************************
TKPlays::TKPlays(TOgleModeWindow *pmw,TFileMode fm,void *psource)
:TSprite(pmw,fm,psource)
{
  SetToManual();
  NoShow();
  SetupAnms();
}
 //*******************************************************************
TKPlays::~TKPlays()
{
}
//*******************************************************************
void TKPlays::SetNum(int16 num)
{
	if(num <= 0)
	{
     PPlays->NoShow();
	}
	else
	{
	  switch(num)
	  {
		 case 1   : PPlays->CAD.SetCurrentFrame(0);break;
		 case 5   : PPlays->CAD.SetCurrentFrame(1);break;
		 case 10  : PPlays->CAD.SetCurrentFrame(2);break;
		 case 20  : PPlays->CAD.SetCurrentFrame(3);break;
		 case 50  : PPlays->CAD.SetCurrentFrame(4);break;
		 case 100 : PPlays->CAD.SetCurrentFrame(5);break;
		 default  : PPlays->CAD.SetCurrentFrame(0);break;
	  }
	  PPlays->Show();
	  Update(GetAdjFUC());
	}
}
//*******************************************************************