//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  cksp.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0    03/23/96    A.Krist     moved inline functions into .cpp file.
//  2.0    09/17/97    M.Perry     32-bit conversion.
//********************************************************************
#include "ckposp.h"
#include "oanm.h"
//*******************************************************************
void TKPayOff::SetupAnms()
{
  PPayOff = GetAnm(0);
  if (PPayOff == NULL) {AnmError("KPayOff","PayOff",0);}
  PPayOff->CAD.ClearAutoStart();
  PPayOff->CAD.ClearAutoStop();
  PPayOff->CAD.SetDirStill();
}
//*******************************************************************
TKPayOff::TKPayOff(TOgleModeWindow *pmw,TFileMode NewFileMode)
:TSprite(pmw,NewFileMode)
{
  SetToManual();
  NoShow();
  SetupAnms();
}
//********************************************************************
TKPayOff::TKPayOff(TOgleModeWindow *pmw,TFileMode fm,void *psource)
:TSprite(pmw,fm,psource)
{
  SetToManual();
  NoShow();
  SetupAnms();
}
 //*******************************************************************
TKPayOff::~TKPayOff()
{
}
//*******************************************************************
void TKPayOff::SetNum(TKenoGame type)
{
	switch(type)
	{
	  case kgNone         : PPayOff->NoShow();return;
	  case kg1Spot        : PPayOff->CAD.SetCurrentFrame(0);break;
	  case kg2Spot        : PPayOff->CAD.SetCurrentFrame(1);break;
	  case kg3Spot        : PPayOff->CAD.SetCurrentFrame(2);break;
	  case kg3SpotSpecial : PPayOff->CAD.SetCurrentFrame(3);break;
	  case kg4Spot        : PPayOff->CAD.SetCurrentFrame(4);break;
	  case kg4SpotSpecial : PPayOff->CAD.SetCurrentFrame(5);break;
	  case kg5Spot        : PPayOff->CAD.SetCurrentFrame(6);break;
	  case kg6Spot        : PPayOff->CAD.SetCurrentFrame(7);break;
	  case kg6SpotSpecial : PPayOff->CAD.SetCurrentFrame(8);break;
	  case kg7Spot        : PPayOff->CAD.SetCurrentFrame(9);break;
	  case kg8Spot        : PPayOff->CAD.SetCurrentFrame(10);break;
	  case kg9Spot        : PPayOff->CAD.SetCurrentFrame(11);break;
	  case kg10Spot       : PPayOff->CAD.SetCurrentFrame(12);break;
	  default             : PPayOff->CAD.SetCurrentFrame(0);break;
	}
	PPayOff->Show();
	Update(GetAdjFUC());
	return;
}
//*******************************************************************