//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  cksp.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0    03/23/96    A.Krist     moved inline functions into .cpp file.
//  2.0    09/17/97    M.Perry     32-bit conversion.
//********************************************************************
#include "cktimesp.h"
#include "oanm.h"
//*******************************************************************
void TKTime::SetupAnms()
{
  for(int16 i=0;i<4;i++)
  {
	 PTime[i] = GetAnm(i);
	 if (PTime[i] == NULL) {AnmError("KTime","Time",i);}
	 PTime[i]->CAD.ClearAutoStart();
	 PTime[i]->CAD.ClearAutoStop();
	 PTime[i]->CAD.SetDirStill();
  }
}
//*******************************************************************
TKTime::TKTime(TOgleModeWindow *pmw,TFileMode NewFileMode)
:TSprite(pmw,NewFileMode)
{
  SetToManual();
  NoShow();
  SetupAnms();
}
//********************************************************************
TKTime::TKTime(TOgleModeWindow *pmw,TFileMode fm,void *psource)
:TSprite(pmw,fm,psource)
{
  SetToManual();
  NoShow();
  SetupAnms();
}
 //*******************************************************************
TKTime::~TKTime()
{
}
//*******************************************************************
void TKTime::SetNum(int16 num)
{
  if(num<60)
  {
	 for(int i=0;i<4;i++)
	 {
		PTime[i]->NoShow();
	 }
	 return;
  }
  int x=0;
  x = (180-num);
  PTime[0]->CAD.SetCurrentFrame(int16(x/60));
  PTime[0]->Show();
  PTime[1]->CAD.SetCurrentFrame(0);
  PTime[1]->Show();
  PTime[2]->CAD.SetCurrentFrame(int16((x%60)/10));
  PTime[2]->Show();
  PTime[3]->CAD.SetCurrentFrame(int16(x%10));
  PTime[3]->Show();

}
//*******************************************************************