//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  betrange.cpp
//    Project Name:  Casino
// Original Author:  Adam Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     7/19/96    M.Perry    moved into cpp file.
//  2.0    09/19/97    M.Perry    32-bit conversion.
//********************************************************************
#include "betrange.h"
//*******************************************************************
TBetRange::TBetRange(int16 Num1,int16 Num2,TOgleModeWindow *pmw,const TFileMode &NewFileMode,
                     int16 code)
:TRBetSpot(pmw,NewFileMode,code)
{
  lowrange = Num1;
  highrange=Num2;
  if((Num2-Num1) == 2){SpotType = ThreeNum;}
  else if((Num2-Num1) == 5){SpotType = SixNum;}
  else if((Num2-Num1) == 11){SpotType = Dozen;}
  else if(Num2 == 36){SpotType = High;}
  else if(Num2 == 18){SpotType = Low;}
  else {SpotType = DefaultSpotType;}
}
//*******************************************************************
TBetRange::TBetRange(int16 Num1,int16 Num2,TOgleModeWindow *pmw,const TFileMode &NewFileMode,
                     void *psource,int16 code)
:TRBetSpot(pmw,NewFileMode,psource,code)
{
  lowrange = Num1;highrange=Num2;
  if((Num2-Num1) == 2){SpotType = ThreeNum;}
  else if((Num2-Num1) == 5){SpotType = SixNum;}
  else if((Num2-Num1) == 11){SpotType = Dozen;}
  else if(Num2 == 36){SpotType = High;}
  else if(Num2 == 18){SpotType = Low;}
  else {SpotType = DefaultSpotType;}
}
//*******************************************************************
TBetRange::~TBetRange()
{
}
//*******************************************************************
bool TBetRange::Winner(int16 WinNum)
{
  if(WinNum >= lowrange && WinNum <= highrange)
  {
    return true;
  }
  else
  {
    return false;
  }
}
//*******************************************************************
int32 TBetRange::Odds()
{
  int16 x;
  x = int16(highrange-lowrange);
  switch(x)
  {
    case 2  : return 11;
    case 5  : return 5;
    case 11 : return 2;
    case 17 : return 1;
    default : return 0;
  }
}
//*******************************************************************
