//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  cr1glspl.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     1/24/96    M.Perry    original baseline
//  2.0    09/18/97    M.Perry    32-bit conversion.
//********************************************************************
#include "cr1glspl.h"
#include "bethead.h"
#include "casbusp.h"
//*******************************************************************
TR1GLordSpriteList::TR1GLordSpriteList(TOgleModeWindow *pmw,const TFileMode &filemode,
                                       TGameObject *PGObj)
:TRGLordSpriteList(pmw,filemode,PGObj)
{
  #ifdef DEBUG_PMODEWIN_SPL
  if (PModeWin == NULL)
  {
    string s = "PModeWin == NULL in ";
    s += FileMode.Name;
    s += "'s ctor";
    ::MessageBox(NULL,s.c_str(),"Warning - TR1GLordSpriteList",MB_OK);
  }
  #endif
  Init(filemode,true,false);
}
//*******************************************************************
TR1GLordSpriteList::~TR1GLordSpriteList()
{
}
//*******************************************************************
bool TR1GLordSpriteList::compare(const string &s1,const string &s2)
{
  if (s1 == s2) {return true;}else{return false;}
}
//*******************************************************************
TSprite *TR1GLordSpriteList::CreateSprite(string spritename,int16 id,void *psource)
{
  if (psource == NULL) {return CreateSpriteAux(spritename,id);}

  TFileMode FM(spritename,fm_None,fm_None,FileMode.DirIndex);

  switch (id)
  {
    case 0:return new TSprite(PModeWin,FM,psource);
    case 1:return (new TRSound(PModeWin,FM,psource));
    case 2:return (new TBetUnitChips(PModeWin,FM,psource));
    case 3:return (new TCasMessageDisplay(PModeWin,FM,psource));
    case 4:return (new TCasCashDisplay(PModeWin,FM,psource));
    case 5:return (new TCasCashDisplay(PModeWin,FM,psource));
    case 6:return (new TRMarker(PModeWin,FM,psource));
    case 7:return (new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,100,TRect(566,455,584,479),ridOneChip,true,'9'));
    case 8:return (new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,100,TRect(548,455,564,479),ridFiveChip,true,'8'));
    case 9:return (new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,100,TRect(529,455,546,479),ridTwentyFiveChip,true,'7'));
    case 10:return (new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,100,TRect(510,455,527,479),ridOneHundredChip,true,'6'));
    case 11:return (new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,100,TRect(491,455,508,479),ridOneThouChip,true,'5'));
    case 12:return (new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,100,TRect(472,455,489,479),ridTenThouChip,true,'4'));
    case 13:return (new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,100,TRect(170,430,219,479),ridStatBar,true));
    case 14:return (new TRPayOff(PModeWin,FM,psource));
    case 15:return (new TRNumberHistory(PModeWin,FM,psource));
    case 16:return (new TCasChips(PModeWin,FM,psource));
    case 17:return (new TCasNamePlate(PModeWin,FM,psource));
    case 18:return (new TCasNamePlate(PModeWin,FM,psource));
    case 19:return (new TCasNamePlate(PModeWin,FM,psource));
    case 20:return (new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,100,TRect(223,464,258,479),ridMenuEsc,true));
    case 21:return (new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,100,TRect(416,454,468,479),ridButton1,true,'r'));
    case 22:return (new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,100,TRect(416,430,468,452),ridButton2,true,'c'));
    case 23:return (new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,100,TRect(376,464,412,479),ridButton3,true));
    case 24:return (new  TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,100,TRect(587,432,639,478),ridButton4,true,VK_RETURN));
    case 25:return (new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,100,TRect(1,430,50,479),ridAskExpert,true,'x'));
    case 26:return (new TBetRed(PModeWin,FM,psource,22));
    case 27:return (new TBetBlack(PModeWin,FM,psource,22));
    case 28:return (new TBetEven(PModeWin,FM,psource,21));
    case 29:return (new TBetOdd(PModeWin,FM,psource,21));
    case 30:return (new TBetRange(1,18,PModeWin,FM,psource,23));
    case 31:return (new TBetRange(19,36,PModeWin,FM,psource,23));
    case 32:return (new TBetRange(1,12,PModeWin,FM,psource,20));
    case 33:return (new TBetRange(13,24,PModeWin,FM,psource,20));
    case 34:return (new TBetRange(25,36,PModeWin,FM,psource,20));
    case 35:return (new TBetCol1(PModeWin,FM,psource,19));
    case 36:return (new TBetCol2(PModeWin,FM,psource,19));
    case 37:return (new TBetCol3(PModeWin,FM,psource,19));
    case 38:return (new TBetNum(1,PModeWin,FM,psource,13));
    case 39:return (new TBetNum(2,PModeWin,FM,psource,13));
    case 40:return (new TBetNum(3,PModeWin,FM,psource,13));
    case 41:return (new TBetNum(4,PModeWin,FM,psource,13));
    case 42:return (new TBetNum(5,PModeWin,FM,psource,13));
    case 43:return (new TBetNum(6,PModeWin,FM,psource,13));
    case 44:return (new TBetNum(7,PModeWin,FM,psource,13));
    case 45:return (new TBetNum(8,PModeWin,FM,psource,13));
    case 46:return (new TBetNum(9,PModeWin,FM,psource,13));
    case 47:return (new TBetNum(10,PModeWin,FM,psource,13));
    case 48:return (new TBetNum(11,PModeWin,FM,psource,13));
    case 49:return (new TBetNum(12,PModeWin,FM,psource,13));
    case 50:return (new TBetNum(13,PModeWin,FM,psource,13));
    case 51:return (new TBetNum(14,PModeWin,FM,psource,13));
    case 52:return (new TBetNum(15,PModeWin,FM,psource,13));
    case 53:return (new TBetNum(16,PModeWin,FM,psource,13));
    case 54:return (new TBetNum(17,PModeWin,FM,psource,13));
    case 55:return (new TBetNum(18,PModeWin,FM,psource,13));
    case 56:return (new TBetNum(19,PModeWin,FM,psource,13));
    case 57:return (new TBetNum(20,PModeWin,FM,psource,13));
    case 58:return (new TBetNum(21,PModeWin,FM,psource,13));
    case 59:return (new TBetNum(22,PModeWin,FM,psource,13));
    case 60:return (new TBetNum(23,PModeWin,FM,psource,13));
    case 61:return (new TBetNum(24,PModeWin,FM,psource,13));
    case 62:return (new TBetNum(25,PModeWin,FM,psource,13));
    case 63:return (new TBetNum(26,PModeWin,FM,psource,13));
    case 64:return (new TBetNum(27,PModeWin,FM,psource,13));
    case 65:return (new TBetNum(28,PModeWin,FM,psource,13));
    case 66:return (new TBetNum(29,PModeWin,FM,psource,13));
    case 67:return (new TBetNum(30,PModeWin,FM,psource,13));
    case 68:return (new TBetNum(31,PModeWin,FM,psource,13));
    case 69:return (new TBetNum(32,PModeWin,FM,psource,13));
    case 70:return (new TBetNum(33,PModeWin,FM,psource,13));
    case 71:return (new TBetNum(34,PModeWin,FM,psource,13));
    case 72:return (new TBetNum(35,PModeWin,FM,psource,13));
    case 73:return (new TBetNum(36,PModeWin,FM,psource,13));
    case 74:return (new TBetNum(0,PModeWin,FM,psource,13));
    case 75:return (new TBetNum(37,PModeWin,FM,psource,13));
    case 76:return (new TBetRange(1,3,PModeWin,FM,psource,15));
    case 77:return (new TBetRange(4,6,PModeWin,FM,psource,15));
    case 78:return (new TBetRange(7,9,PModeWin,FM,psource,15));
    case 79:return (new TBetRange(10,12,PModeWin,FM,psource,15));
    case 80:return (new TBetRange(13,15,PModeWin,FM,psource,15));
    case 81:return (new TBetRange(16,18,PModeWin,FM,psource,15));
    case 82:return (new TBetRange(19,21,PModeWin,FM,psource,15));
    case 83:return (new TBetRange(22,24,PModeWin,FM,psource,15));
    case 84:return (new TBetRange(25,27,PModeWin,FM,psource,15));
    case 85:return (new TBetRange(28,30,PModeWin,FM,psource,15));
    case 86:return (new TBetRange(31,33,PModeWin,FM,psource,15));
    case 87:return (new TBetRange(34,36,PModeWin,FM,psource,15));
    case 88:return (new TBetRange(1,6,PModeWin,FM,psource,18));
    case 89:return (new TBetRange(4,9,PModeWin,FM,psource,18));
    case 90:return (new TBetRange(7,12,PModeWin,FM,psource,18));
    case 91:return (new TBetRange(10,15,PModeWin,FM,psource,18));
    case 92:return (new TBetRange(13,18,PModeWin,FM,psource,18));
    case 93:return (new TBetRange(16,21,PModeWin,FM,psource,18));
    case 94:return (new TBetRange(19,24,PModeWin,FM,psource,18));
    case 95:return (new TBetRange(22,27,PModeWin,FM,psource,18));
    case 96:return (new TBetRange(25,30,PModeWin,FM,psource,18));
    case 97:return (new TBetRange(28,33,PModeWin,FM,psource,18));
    case 98:return (new TBetRange(31,36,PModeWin,FM,psource,18));
    case 99:return (new TBet4Num(1,2,4,5,PModeWin,FM,psource,16));
    case 100:return (new TBet4Num(2,3,5,6,PModeWin,FM,psource,16));
    case 101:return (new TBet4Num(4,5,7,8,PModeWin,FM,psource,16));
    case 102:return (new TBet4Num(5,6,8,9,PModeWin,FM,psource,16));
    case 103:return (new TBet4Num(7,8,10,11,PModeWin,FM,psource,16));
    case 104:return (new TBet4Num(8,9,11,12,PModeWin,FM,psource,16));
    case 105:return (new TBet4Num(10,11,13,14,PModeWin,FM,psource,16));
    case 106:return (new TBet4Num(11,12,14,15,PModeWin,FM,psource,16));
    case 107:return (new TBet4Num(13,14,16,17,PModeWin,FM,psource,16));
    case 108:return (new TBet4Num(14,15,17,18,PModeWin,FM,psource,16));
    case 109:return (new TBet4Num(16,17,19,20,PModeWin,FM,psource,16));
    case 110:return (new TBet4Num(17,18,20,21,PModeWin,FM,psource,16));
    case 111:return (new TBet4Num(19,20,22,23,PModeWin,FM,psource,16));
    case 112:return (new TBet4Num(20,21,23,24,PModeWin,FM,psource,16));
    case 113:return (new TBet4Num(22,23,25,26,PModeWin,FM,psource,16));
    case 114:return (new TBet4Num(23,24,26,27,PModeWin,FM,psource,16));
    case 115:return (new TBet4Num(25,26,28,29,PModeWin,FM,psource,16));
    case 116:return (new TBet4Num(26,27,29,30,PModeWin,FM,psource,16));
    case 117:return (new TBet4Num(28,29,31,32,PModeWin,FM,psource,16));
    case 118:return (new TBet4Num(29,30,32,33,PModeWin,FM,psource,16));
    case 119:return (new TBet4Num(31,32,34,35,PModeWin,FM,psource,16));
    case 120:return (new TBet4Num(32,33,35,36,PModeWin,FM,psource,16));
    case 121:return (new TBet2Num(0,37,PModeWin,FM,psource,14));
    case 122:return (new TBet2Num(0,1,PModeWin,FM,psource,14));
    case 123:return (new TBet2Num(3,37,PModeWin,FM,psource,14));
    case 124:return (new TBet2Num(1,2,PModeWin,FM,psource,14));
    case 125:return (new TBet2Num(2,3,PModeWin,FM,psource,14));
    case 126:return (new TBet2Num(1,4,PModeWin,FM,psource,14));
    case 127:return (new TBet2Num(2,5,PModeWin,FM,psource,14));
    case 128:return (new TBet2Num(3,6,PModeWin,FM,psource,14));
    case 129:return (new TBet2Num(4,5,PModeWin,FM,psource,14));
    case 130:return (new TBet2Num(5,6,PModeWin,FM,psource,14));
    case 131:return (new TBet2Num(4,7,PModeWin,FM,psource,14));
    case 132:return (new TBet2Num(5,8,PModeWin,FM,psource,14));
    case 133:return (new TBet2Num(6,9,PModeWin,FM,psource,14));
    case 134:return (new TBet2Num(7,8,PModeWin,FM,psource,14));
    case 135:return (new TBet2Num(8,9,PModeWin,FM,psource,14));
    case 136:return (new TBet2Num(7,10,PModeWin,FM,psource,14));
    case 137:return (new TBet2Num(8,11,PModeWin,FM,psource,14));
    case 138:return (new TBet2Num(9,12,PModeWin,FM,psource,14));
    case 139:return (new TBet2Num(10,11,PModeWin,FM,psource,14));
    case 140:return (new TBet2Num(11,12,PModeWin,FM,psource,14));
    case 141:return (new TBet2Num(10,13,PModeWin,FM,psource,14));
    case 142:return (new TBet2Num(11,14,PModeWin,FM,psource,14));
    case 143:return (new TBet2Num(12,15,PModeWin,FM,psource,14));
    case 144:return (new TBet2Num(13,14,PModeWin,FM,psource,14));
    case 145:return (new TBet2Num(14,15,PModeWin,FM,psource,14));
    case 146:return (new TBet2Num(13,16,PModeWin,FM,psource,14));
    case 147:return (new TBet2Num(14,17,PModeWin,FM,psource,14));
    case 148:return (new TBet2Num(15,18,PModeWin,FM,psource,14));
    case 149:return (new TBet2Num(16,17,PModeWin,FM,psource,14));
    case 150:return (new TBet2Num(17,18,PModeWin,FM,psource,14));
    case 151:return (new TBet2Num(16,19,PModeWin,FM,psource,14));
    case 152:return (new TBet2Num(17,20,PModeWin,FM,psource,14));
    case 153:return (new TBet2Num(18,21,PModeWin,FM,psource,14));
    case 154:return (new TBet2Num(19,20,PModeWin,FM,psource,14));
    case 155:return (new TBet2Num(20,21,PModeWin,FM,psource,14));
    case 156:return (new TBet2Num(19,22,PModeWin,FM,psource,14));
    case 157:return (new TBet2Num(20,23,PModeWin,FM,psource,14));
    case 158:return (new TBet2Num(21,24,PModeWin,FM,psource,14));
    case 159:return (new TBet2Num(22,23,PModeWin,FM,psource,14));
    case 160:return (new TBet2Num(23,24,PModeWin,FM,psource,14));
    case 161:return (new TBet2Num(22,25,PModeWin,FM,psource,14));
    case 162:return (new TBet2Num(23,26,PModeWin,FM,psource,14));
    case 163:return (new TBet2Num(24,27,PModeWin,FM,psource,14));
    case 164:return (new TBet2Num(25,26,PModeWin,FM,psource,14));
    case 165:return (new TBet2Num(26,27,PModeWin,FM,psource,14));
    case 166:return (new TBet2Num(25,28,PModeWin,FM,psource,14));
    case 167:return (new TBet2Num(26,29,PModeWin,FM,psource,14));
    case 168:return (new TBet2Num(27,30,PModeWin,FM,psource,14));
    case 169:return (new TBet2Num(28,29,PModeWin,FM,psource,14));
    case 170:return (new TBet2Num(29,30,PModeWin,FM,psource,14));
    case 171:return (new TBet2Num(28,31,PModeWin,FM,psource,14));
    case 172:return (new TBet2Num(29,32,PModeWin,FM,psource,14));
    case 173:return (new TBet2Num(30,33,PModeWin,FM,psource,14));
    case 174:return (new TBet2Num(31,32,PModeWin,FM,psource,14));
    case 175:return (new TBet2Num(32,33,PModeWin,FM,psource,14));
    case 176:return (new TBet2Num(31,34,PModeWin,FM,psource,14));
    case 177:return (new TBet2Num(32,35,PModeWin,FM,psource,14));
    case 178:return (new TBet2Num(33,36,PModeWin,FM,psource,14));
    case 179:return (new TBet2Num(34,35,PModeWin,FM,psource,14));
    case 180:return (new TBet2Num(35,36,PModeWin,FM,psource,14));
    case 181:return (new TBet5Num(PModeWin,FM,psource,17));
    default:return (new TSprite(PModeWin,FM,psource));
  }
}
//*******************************************************************

