//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  crdata.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     9/9/96     M.Perry    split up cplaydat file.
//  2.0    09/17/97    M.Perry    32-bit conversion.
//********************************************************************
#include "crdata.h"

//*******************************************************************
void TCRSession::ClearData()
{
  TCasinoSession::ClearData();
  SingleNumBets = 0;
  TwoNumBets = 0;
  ThreeNumBets = 0;
  FourNumBets = 0;
  FiveNumBets = 0;
  SixNumBets = 0;
  ColumnBets = 0;
  DozenBets = 0;
  RedBets = 0;
  BlackBets = 0;
  OddBets = 0;
  EvenBets = 0;
  HighBets = 0;
  LowBets = 0;
  SingleNumBetsTotalCashWL = 0;
  TwoNumBetsTotalCashWL = 0;
  ThreeNumBetsTotalCashWL = 0;
  FourNumBetsTotalCashWL = 0;
  FiveNumBetsTotalCashWL = 0;
  SixNumBetsTotalCashWL = 0;
  ColumnBetsTotalCashWL = 0;
  DozenBetsTotalCashWL = 0;
  RedBetsTotalCashWL = 0;
  BlackBetsTotalCashWL = 0;
  OddBetsTotalCashWL = 0;
  EvenBetsTotalCashWL = 0;
  HighBetsTotalCashWL = 0;
  LowBetsTotalCashWL = 0;
  for(int i = 0;i < 38;i++)
  {
	 MostFrequentNums[i] = 0;
  }
  OneRedInRow = 0;
  TwoRedInRow = 0;
  ThreeRedInRow = 0;
  FourRedInRow = 0;
  FivePlusRedInRow = 0;
  RedStreak = 0;
  CurrentRedStreak = 0;
  OneBlackInRow = 0;
  TwoBlackInRow = 0;
  ThreeBlackInRow = 0;
  FourBlackInRow = 0;
  FivePlusBlackInRow = 0;
  BlackStreak = 0;
  CurrentBlackStreak = 0;
  OneOddInRow = 0;
  TwoOddInRow = 0;
  ThreeOddInRow = 0;
  FourOddInRow = 0;
  FivePlusOddInRow = 0;
  OddStreak = 0;
  CurrentOddStreak = 0;
  OneEvenInRow = 0;
  TwoEvenInRow = 0;
  ThreeEvenInRow = 0;
  FourEvenInRow = 0;
  FivePlusEvenInRow = 0;
  EvenStreak = 0;
  CurrentEvenStreak = 0;
  OneHighInRow = 0;
  TwoHighInRow = 0;
  ThreeHighInRow = 0;
  FourHighInRow = 0;
  FivePlusHighInRow = 0;
  HighStreak = 0;
  CurrentHighStreak = 0;
  OneLowInRow = 0;
  TwoLowInRow = 0;
  ThreeLowInRow = 0;
  FourLowInRow = 0;
  FivePlusLowInRow = 0;
  LowStreak = 0;
  CurrentLowStreak = 0;
}
//*******************************************************************
TCRSession::TCRSession()
{
  ClearData();
}
//*******************************************************************
void TCRSession::StartSession(TMoney startingcash,int16 subgametype,TMoney denom)
{
  ClearData();
  TCasinoSession::StartSession(startingcash,subgametype,denom);
}
//*******************************************************************
void TCRSession::EndSession(TMoney endingcash)
{
  TCasinoSession::EndSession(endingcash);
}
//*******************************************************************
TCasinoRData::TCasinoRData()
{
  ClearData();
}
//*******************************************************************
void TCasinoRData::ClearData()
{
  TCasinoData::ClearData();
  Cumulative = 0;
  for (int i=0;i<NUMSESSIONS;i++)
  {
	 Sessions[i].ClearData();
  }
}
//*******************************************************************
void TCasinoRData::StartSession(TMoney startingcash,int16 subgametype,TMoney denom)
{
  IncCurrentSession();
  Sessions[CurrentSession].StartSession(startingcash,subgametype,denom);
}
//*******************************************************************
void TCasinoRData::EndSession(TMoney endingcash)
{
  Sessions[CurrentSession].EndSession(endingcash);
}
//*******************************************************************
void TCasinoRData::IncCurrentSession()
{
  if (CurrentSession == 0 && !Sessions[0].Valid)
  {
    CurrentSession = 0;
    return;
  }
  CurrentSession++;
  if (CurrentSession >= NUMSESSIONS) {CurrentSession = 0;}
}
//*******************************************************************
int16 TCasinoRData::GetFirstValidSession()
{
  // Sanity check on CurrentSession.
  if ((CurrentSession < 0) || (CurrentSession >= NUMSESSIONS)) {SessionIterator = -1;}
  else {SessionIterator = CurrentSession;}

  if (SessionIterator == -1) {return SessionIterator;}

  // Validity check on current session.
  if (!Sessions[SessionIterator].Valid)
  {
	 SessionIterator = -1;
	 return SessionIterator;
  }
  // currents session is valid, so start looping from current session to find oldest session.
  for (SessionIterator++;SessionIterator<NUMSESSIONS;SessionIterator++)
  {
	 if (Sessions[SessionIterator].Valid) {return SessionIterator;}
  }
  if (CurrentSession == 0) // we already checked all sessions and didn't find a valid one.
  {
	 if (Sessions[0].Valid) {SessionIterator = 0;}
	 else {SessionIterator = -1;}
	 return SessionIterator;
  }

  for (SessionIterator = 0;SessionIterator < CurrentSession;SessionIterator++)
  {
	 if (Sessions[SessionIterator].Valid) {return SessionIterator;}
  }
  SessionIterator = -1;
  return SessionIterator;
}
//*******************************************************************
int16 TCasinoRData::GetPrevValidSession()
{
  int16 prevsession = CurrentSession;
  prevsession--;
  if (prevsession <= 0) {prevsession = NUMSESSIONS - 1;}
  if (!Sessions[prevsession].Valid) {return -1;}
  return prevsession;
}
//*******************************************************************
int16 TCasinoRData::GetNextValidSession()
{
  // check if already found last valid session.
  if (SessionIterator == -1) {return SessionIterator;}
  // go to next session.
  SessionIterator++;
  // check for wraparound.
  if (SessionIterator >= NUMSESSIONS) {SessionIterator = 0;}
  // check if we went all the way around to beginning.
  if (SessionIterator == CurrentSession)
  {
	 SessionIterator = -1;
	 return CurrentSession;
  }
  // validity check on session.
  if (!Sessions[SessionIterator].Valid)
  {
	 SessionIterator = -1;
	 return SessionIterator;
  }
  return SessionIterator;
}
//*******************************************************************