 //*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  crpost.cpp
//    Project Name:  Casino
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     03/29/95   A. Krist    Original baseline
//  2.0     09/19/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "crpost.h" //payout
//*******************************************************************
TRPayOutState::TRPayOutState(TCasinoRGameLord *pNewRLord,int16 betspot,int16 slot)
:TRLordState(pNewRLord)
{
	 SetRunOrder(ess_Execute,ess_Execute,ess_Done,ess_Done,ess_Done);
	 StartingFUC  = 0;
	 FUCLength    = 0;
	 BetSpot      = betspot;
	 WaitOnResult = false;
	 Player       = slot;
	 WaitOnSound = false;
}
//*******************************************************************
TRPayOutState::~TRPayOutState()
{
}
//*******************************************************************
void TRPayOutState::ExecuteFirstTime()
{
  pOwnerLord->currentwinnings = 0l;
  if(pOwnerLord->Winner(BetSpot,Player))
  {
	 ExecuteWaiting = true;
	 ExecuteStatus    = ess_Execute;
	 StartingFUC = pOwnerLord->GetAdjFUC();
	 pOwnerLord->PayOff(StartingFUC,FUCLength);
	 WaitOnResult = true;
	 if(FUCLength < 12){FUCLength = 12;}
  }
  else
  {
	 ExecuteWaiting = false;
	 ExecuteStatus    = ess_Done;
  }

}
//*******************************************************************
void TRPayOutState::HandlePostUpdate(dword NewFUC)
{
  if (WaitOnResult)
  {
	 if((StartingFUC + FUCLength) <= NewFUC)
	 {
		pOwnerLord->BetSpot[BetSpot]->SetNum();
		pOwnerLord->PayOffSp->NoShow();
		pOwnerLord->BankCashDisplay->SetNum(pOwnerLord->GetCash(pOwnerLord->activeplayer));
		pOwnerLord->Chips->SetNum(pOwnerLord->GetCash(pOwnerLord->activeplayer));
		pOwnerLord->currentwinnings = 0l;
		WaitOnSound = true;
		WaitOnResult = false;
		pOwnerLord->MessageDisplay->NoShowDisplay();
	 }
  }
  if(WaitOnSound)
  {
	 if((StartingFUC + FUCLength + 6) <= NewFUC)
	 {
		ExecuteWaiting = false;
		WaitOnSound = false;
	 }
  }
}
//*******************************************************************
