//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  slgfw.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.2     4/17/97    M.Perry    modified framewin hierarchy.
//********************************************************************
#include "slgfw.h"
#include "slapp.h"
#include "cgametyp.h"
#include "slabt.rh"
#include "ogame.h"
#include "slmenu.rh"
#include "casnames.rh"
//*******************************************************************
TSLMenuEnable::TSLMenuEnable(BOOL setvalues)
:TCasinoMenuEnable(FALSE)
{
  if (setvalues)
  {
    SetAll(TRUE);
  }
  CurrentMode =  IDS_M_LOBBY_SLOTLITE;
  Lobby = FALSE;
}
//*******************************************************************
TSLMenuEnable::~TSLMenuEnable()
{
}
//*******************************************************************
void TSLMenuEnable::SetAll(BOOL value)
{
  TCasinoMenuEnable::SetAll(value);
}
//*******************************************************************
void TSLMenuEnable::SetModes(BOOL value)
{
  TCasinoMenuEnable::SetModes(value);

  Lobby = value;

  SlotsAladdin100 = value;
  SlotsAladdin1P = value;

  SlotsJungle1 = value;
  SlotsJungle2 = value;

  SlotsSpirit1000 = value;

  SlotsJokers5 = value;
  SlotsJokers25 = value;

  SlotsCherry1 = value;
  SlotsCherry2 = value;
  SlotsCherry5 = value;
}
//*******************************************************************
//*******************************************************************
DEFINE_RESPONSE_TABLE1(TSLGameFrameWindow,TCasinoGameFrameWindow)
  // lobby
  EV_COMMAND(CM_GAMELOBBY,CmGameLobby),
  EV_COMMAND_ENABLE(CM_GAMELOBBY,CeGameLobby),

  EV_COMMAND(CM_OPTIONSLOBBY_SHOWINTRO ,CmShowIntro),
  EV_COMMAND_ENABLE(CM_OPTIONSLOBBY_SHOWINTRO ,CeShowIntro),

  EV_COMMAND(CM_GAMESLOTSALADDIN1P,CmGameSlotsAladdin1P),
  EV_COMMAND_ENABLE(CM_GAMESLOTSALADDIN1P,CeGameSlotsAladdin1P),
  EV_COMMAND(CM_GAMESLOTSALADDIN100,CmGameSlotsAladdin100),
  EV_COMMAND_ENABLE(CM_GAMESLOTSALADDIN100,CeGameSlotsAladdin100),

  EV_COMMAND(CM_GAMESLOTSSPIRIT1000,CmGameSlotsSpirit1000),
  EV_COMMAND_ENABLE(CM_GAMESLOTSSPIRIT1000,CeGameSlotsSpirit1000),

  EV_COMMAND(CM_GAMESLOTSJOKERS5,CmGameSlotsJokers5),
  EV_COMMAND_ENABLE(CM_GAMESLOTSJOKERS5,CeGameSlotsJokers5),
  EV_COMMAND(CM_GAMESLOTSJOKERS25,CmGameSlotsJokers25),
  EV_COMMAND_ENABLE(CM_GAMESLOTSJOKERS25,CeGameSlotsJokers25),

  EV_COMMAND(CM_GAMESLOTSCHERRY1,CmGameSlotsCherry1),
  EV_COMMAND_ENABLE(CM_GAMESLOTSCHERRY1,CeGameSlotsCherry1),
  EV_COMMAND(CM_GAMESLOTSCHERRY2,CmGameSlotsCherry2),
  EV_COMMAND_ENABLE(CM_GAMESLOTSCHERRY2,CeGameSlotsCherry2),
  EV_COMMAND(CM_GAMESLOTSCHERRY5,CmGameSlotsCherry5),
  EV_COMMAND_ENABLE(CM_GAMESLOTSCHERRY5,CeGameSlotsCherry5),

  EV_COMMAND(CM_GAMESLOTSJUNGLE1,CmGameSlotsJungle1),
  EV_COMMAND_ENABLE(CM_GAMESLOTSJUNGLE1,CeGameSlotsJungle1),
  EV_COMMAND(CM_GAMESLOTSJUNGLE2,CmGameSlotsJungle2),
  EV_COMMAND_ENABLE(CM_GAMESLOTSJUNGLE2,CeGameSlotsJungle2),
END_RESPONSE_TABLE;
//*******************************************************************
TSLGameFrameWindow::TSLGameFrameWindow(TSLApp *pslapp,const char *szTitle)
:TCasinoGameFrameWindow(pslapp,szTitle,true,false)
{
  SetupModeStrings();
  FadeIn = FALSE;
  DoStyle();
  DoIcon();
  DoMenu();
  if (ShowIntro)
  {
    StartupModeIndex = GetPGame()->GetModeIndex(strIntro);//"s2intro");
  }
  else
  {
    StartupModeIndex = GetPGame()->GetModeIndex(strLobby);//TAppString(IDS_M_LOBBY_SLOTLITE));
  }
}
//*******************************************************************
TSLGameFrameWindow::~TSLGameFrameWindow()
{
}
//*******************************************************************
void TSLGameFrameWindow::CreateMenuEnable()
{
  PMenuEnable = new TSLMenuEnable(TRUE);
}
//*******************************************************************
int TSLGameFrameWindow::GetMenuID()
{
//  return IDM_CASINO_DEF;
  return IDM_SLOTLITE_DEF;
}
//*******************************************************************
int TSLGameFrameWindow::GetAboutID()
{
  return IDB_SLOTLITE_ABOUT_V1_0;
}
//*******************************************************************
void TSLGameFrameWindow::DoMenu()
{
//  AssignMenu(IDM_CASINO_DEF);
  AssignMenu(IDM_SLOTLITE_DEF);
}
//*******************************************************************
void TSLGameFrameWindow::SwitchGameModes(int modeindex)
{
  if (!IsValidModeIndex(modeindex))
  {
	 MessageBox("Internal error, no switch attempted","Switch Mode",MB_OK);
  }
  else
  {
	 if (!SwitchModes(modeindex))
	 {
		MessageBox("Internal error, switching to startup mode","Switch Mode",MB_OK);
		SwitchModes(GetModeIndex(strLobby));//TAppString(IDS_M_LOBBY_SLOTLITE)));
	 }
  }
}
//*******************************************************************
void TSLGameFrameWindow::CmGameLobby()
{
  SwitchGameModes(strLobby);//TAppString(IDS_M_LOBBY_SLOTLITE));
}
//*******************************************************************
void TSLGameFrameWindow::CeGameLobby(TCommandEnabler &enabler)
{
  enabler.Enable(GetSLMenuEnable()->Lobby);
  if (GetSLMenuEnable()->CurrentMode == IDS_M_LOBBY_SLOTLITE)
  {
    enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
    enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TSLGameFrameWindow::CmGameSlotsAladdin1P()
{
  SwitchGameModes(strSlotsAladdin1P);//TAppString(IDS_M_SL_ALADDIN1P));
}
//*******************************************************************
void TSLGameFrameWindow::CeGameSlotsAladdin1P(TCommandEnabler &enabler)
{
  enabler.Enable(GetSLMenuEnable()->SlotsAladdin1P);
  if (GetSLMenuEnable()->CurrentMode == IDS_M_SL_ALADDIN1P)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TSLGameFrameWindow::CmGameSlotsAladdin100()
{
  SwitchGameModes(strSlotsAladdin100);//TAppString(IDS_M_SL_ALADDIN100));
}
//*******************************************************************
void TSLGameFrameWindow::CeGameSlotsAladdin100(TCommandEnabler &enabler)
{
  enabler.Enable(GetSLMenuEnable()->SlotsAladdin100);
  if (GetSLMenuEnable()->CurrentMode == IDS_M_SL_ALADDIN100)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TSLGameFrameWindow::CmGameSlotsSpirit1000()
{
  SwitchGameModes(strSlotsSpirit1000);//TAppString(IDS_M_SL_SPIRIT1000));
}
//*******************************************************************
void TSLGameFrameWindow::CeGameSlotsSpirit1000(TCommandEnabler &enabler)
{
  enabler.Enable(GetSLMenuEnable()->SlotsSpirit1000);
  if (GetSLMenuEnable()->CurrentMode == IDS_M_SL_SPIRIT1000)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TSLGameFrameWindow::CmGameSlotsJokers5()
{
  SwitchGameModes(strSlotsJokers5);//TAppString(IDS_M_SL_JOKER5));
}
//*******************************************************************
void TSLGameFrameWindow::CeGameSlotsJokers5(TCommandEnabler &enabler)
{
  enabler.Enable(GetSLMenuEnable()->SlotsJokers5);
  if (GetSLMenuEnable()->CurrentMode == IDS_M_SL_JOKER5)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TSLGameFrameWindow::CmGameSlotsJokers25()
{
  SwitchGameModes(strSlotsJokers25);//TAppString(IDS_M_SL_JOKER25));
}
//*******************************************************************
void TSLGameFrameWindow::CeGameSlotsJokers25(TCommandEnabler &enabler)
{
  enabler.Enable(GetSLMenuEnable()->SlotsJokers25);
  if (GetSLMenuEnable()->CurrentMode == IDS_M_SL_JOKER25)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TSLGameFrameWindow::CmGameSlotsCherry1()
{
  SwitchGameModes(strSlotsCherry1);//TAppString(IDS_M_SL_CHERRY1));
}
//*******************************************************************
void TSLGameFrameWindow::CeGameSlotsCherry1(TCommandEnabler &enabler)
{
  enabler.Enable(GetSLMenuEnable()->SlotsCherry1);
  if (GetSLMenuEnable()->CurrentMode == IDS_M_SL_CHERRY1)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TSLGameFrameWindow::CmGameSlotsCherry2()
{
  SwitchGameModes(strSlotsCherry2);//TAppString(IDS_M_SL_CHERRY2));
}
//*******************************************************************
void TSLGameFrameWindow::CeGameSlotsCherry2(TCommandEnabler &enabler)
{
  enabler.Enable(GetSLMenuEnable()->SlotsCherry2);
  if (GetSLMenuEnable()->CurrentMode == IDS_M_SL_CHERRY2)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TSLGameFrameWindow::CmGameSlotsCherry5()
{
  SwitchGameModes(strSlotsCherry5);//TAppString(IDS_M_SL_CHERRY5));
}
//*******************************************************************
void TSLGameFrameWindow::CeGameSlotsCherry5(TCommandEnabler &enabler)
{
  enabler.Enable(GetSLMenuEnable()->SlotsCherry5);
  if (GetSLMenuEnable()->CurrentMode == IDS_M_SL_CHERRY5)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TSLGameFrameWindow::CmGameSlotsJungle1()
{
  SwitchGameModes(strSlotsJungle1);//TAppString(IDS_M_SL_JUNGLE1));
}
//*******************************************************************
void TSLGameFrameWindow::CeGameSlotsJungle1(TCommandEnabler &enabler)
{
  enabler.Enable(GetSLMenuEnable()->SlotsJungle1);
  if (GetSLMenuEnable()->CurrentMode == IDS_M_SL_JUNGLE1)
  {
    enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
    enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TSLGameFrameWindow::CmGameSlotsJungle2()
{
  SwitchGameModes(strSlotsJungle2);//TAppString(IDS_M_SL_JUNGLE2));
}
//*******************************************************************
void TSLGameFrameWindow::CeGameSlotsJungle2(TCommandEnabler &enabler)
{
  enabler.Enable(GetSLMenuEnable()->SlotsJungle2);
  if (GetSLMenuEnable()->CurrentMode == IDS_M_SL_JUNGLE2)
  {
    enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
    enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************

