//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  cassmw.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     8/30/96    M.Perry    original baseline
//  2.0    09/25/97    M.Perry    32-bit conversion.
//  2.3    07/12/99    M.Perry    gobjlist removal
//********************************************************************
#include "cassmw.h"
#include "csglord.h"
#include "chelpid.h"
#include "oloaddlg.h"
#include "slot_cm.rh"
//*******************************************************************
DEFINE_RESPONSE_TABLE1(TSlotsModeWin,TCasinoModeWin)
  EV_COMMAND(CM_OPTIONSSLOTS_50CREDITS ,CmOptions50Credits),
  EV_COMMAND_ENABLE(CM_OPTIONSSLOTS_50CREDITS ,CeOptions50Credits),
  EV_COMMAND(CM_OPTIONSSLOTS_100CREDITS ,CmOptions100Credits),
  EV_COMMAND_ENABLE(CM_OPTIONSSLOTS_100CREDITS ,CeOptions100Credits),
  EV_COMMAND(CM_OPTIONSSLOTS_200CREDITS ,CmOptions200Credits),
  EV_COMMAND_ENABLE(CM_OPTIONSSLOTS_200CREDITS ,CeOptions200Credits),
END_RESPONSE_TABLE;
//*******************************************************************
void TSlotsModeWin::CmOptions50Credits()
{
  if (GetCasGameLord() == NULL) {return;}
  GetCasGameLord()->AddCredits(50);
}
//*******************************************************************
void TSlotsModeWin::CeOptions50Credits(TCommandEnabler &enabler)
{
  enabler.Enable(bool(GetCasGameLord() != NULL));
//  if (GetCasGameLord() != NULL)
//  {
//    enabler.Enable(true);
//  }
//  else
//  {
//    enabler.Enable(false);
//  }
}
//*******************************************************************
void TSlotsModeWin::CmOptions100Credits()
{
  if (GetCasGameLord() == NULL) {return;}
  GetCasGameLord()->AddCredits(100);
}
//******************************************************* ************
void TSlotsModeWin::CeOptions100Credits(TCommandEnabler &enabler)
{
  enabler.Enable(bool(GetCasGameLord() != NULL));
//  if (GetCasGameLord() != NULL)
//  {
//    enabler.Enable(true);
//  }
//  else
//  {
//    enabler.Enable(false);
//  }
}
//*******************************************************************
void TSlotsModeWin::CmOptions200Credits()
{
  if (GetCasGameLord() == NULL) {return;}
  GetCasGameLord()->AddCredits(200);
}
//*******************************************************************
void TSlotsModeWin::CeOptions200Credits(TCommandEnabler &enabler)
{
  enabler.Enable(bool(GetCasGameLord() != NULL));
//  if (GetCasGameLord() != NULL)
//  {
//    enabler.Enable(true);
//  }
//  else
//  {
//    enabler.Enable(false);
//  }
}
//*******************************************************************
TSlotsModeWin::TSlotsModeWin(string modename,TPal *PPal,string title)
:TCasinoModeWin(modename,PPal,title)
{
  ModeHelpCommand = HELP_CONTEXT;
  ModeHelpData = IDH_CAS_SLOTS;
}
//*******************************************************************
TSlotsModeWin::~TSlotsModeWin()
{
}
//*******************************************************************
string TSlotsModeWin::GetDetName()
{
  return string("slots.det");
}
//*******************************************************************
int TSlotsModeWin::GetMenuID()
{
  return IDM_CASINO_SLOTS;
}
//*******************************************************************
void TSlotsModeWin::CreateGroupGaugeDlg()
{
  PGroupGaugeDlg = new TLoadDlg(this,
                                this,
                                new TBitmap(*GetOgleApp(),IDB_LOADING_V2),
                                bdRESIZE | bdIGNOREINPUT | bdOWNBITMAP,
                                TRect(20,160,300,175),
                                TColor::LtYellow);
  PGroupGaugeDlg->Create();
}
//*******************************************************************