//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  pp1spl.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     9/16/95    M.Perry     original baseline
//  2.0    09/25/97    M.Perry     32-bit conversion.
//********************************************************************
#include "pp1spl.h"
//*******************************************************************
TPlunder1SpriteList::TPlunder1SpriteList(TOgleModeWindow *pmw,const TFileMode &filemode,TGameObject *PGObj)
:TSGLordSpriteList(pmw,filemode,PGObj)
{
  Init(filemode,true,false);
}
//*******************************************************************
TPlunder1SpriteList::~TPlunder1SpriteList()
{
}
//*******************************************************************
#pragma argsused
TSprite *TPlunder1SpriteList::CreateSprite(string spritename,int16 id,void *psource)
{
	 TFileMode FM(spritename,fm_None,fm_None,FileMode.DirIndex);

    if (psource == NULL)
    {
      FM.SetRamImmed();
	 if (spritename == GetResString(IDS_MS_CHIPS_S_P1))       {return (new TCasChips(PModeWin,FM));}
	 if (spritename == GetResString(IDS_MS_REEL_S_P1))        {return (new TSReel(PModeWin,FM));}
	 if (spritename == GetResString(IDS_MS_COINSPLAYED_S_P1)) {return (new TSCoinsPlayed(PModeWin,FM));}
	 if (spritename == GetResString(IDS_MS_CREDITS_S_P1))     {return (new TSCredits(PModeWin,FM));}
	 if (spritename == GetResString(IDS_MS_WINPAID_S_P1))     {return (new TSWinPaid(PModeWin,FM));}
	 if (spritename == GetResString(IDS_MS_COINPAY_S_P1))
	 {
		return (new TSCoinPay(PModeWin,FM));
	 }
	 if (spritename == GetResString(IDS_MS_SOUNDS_S_P1))
	 {
		return (new TSSound(PModeWin,FM));
	 }
	 if (spritename == GetResString(IDS_MS_NP1_S_P1))
	 {
		return (new TCasNamePlate(PModeWin,FM));
	 }
	 if (spritename == GetResString(IDS_MS_NP2_S_P1))
	 {
		return (new TCasNamePlate(PModeWin,FM));
	 }
	 if (spritename == GetResString(IDS_MS_NP3_S_P1))
	 {
		return (new TCasNamePlate(PModeWin,FM));
	 }
	 if (spritename == GetResString(IDS_MS_B0_S_P1))
	 {
		return (new TCasButton(PModeWin,FM,(TCasinoGameLord *)POwnerGObj,100,TRect(1,430,50,479),idButton0,true,'x'));
	 }
	 if (spritename == GetResString(IDS_MS_B1_S_P1))
	 {
		return (new TCasButton(PModeWin,FM,(TCasinoGameLord *)POwnerGObj,100,TRect(170,430,219,479),idButton1,true));
	 }
	 if (spritename == GetResString(IDS_MS_B2_S_P1))
	 {
		return (new TCasButton(PModeWin,FM,(TCasinoGameLord *)POwnerGObj,100,TRect(223,464,258,479),idButton2,true));
	 }
	 if (spritename == GetResString(IDS_MS_B3_S_P1))
	 {
		return (new TCasButton(PModeWin,FM,(TCasinoGameLord *)POwnerGObj,100,TRect(376,464,412,479),idButton3,true));
	 }
	 if (spritename == GetResString(IDS_MS_B4_S_P1))
	 {
		return (new TCasButton(PModeWin,FM,(TCasinoGameLord *)POwnerGObj,125,TRect(416,430,468,479),idButton4,true,'c'));
	 }
	 if (spritename == GetResString(IDS_MS_B5_S_P1))
	 {
		return (new TCasButton(PModeWin,FM,(TCasinoGameLord *)POwnerGObj,125,TRect(470,430,522,479),idButton5,true,'b'));
	 }
	 if (spritename == GetResString(IDS_MS_B6_S_P1))
	 {
		return (new TCasButton(PModeWin,FM,(TCasinoGameLord *)POwnerGObj,125,TRect(533,430,585,479),idButton6,true,'m'));
	 }
	 if (spritename == GetResString(IDS_MS_B7_S_P1))
	 {
		return (new TCasButton(PModeWin,FM,(TCasinoGameLord *)POwnerGObj,125,TRect(587,432,639,478),idButton7,true,'d'));
	 }
	 if (spritename == GetResString(IDS_MS_BANKCASH_S_P1))//PCasNames->StatusBarName)
	 {
		return (new TCasCashDisplay(PModeWin,FM));
	 }
	 return (new TSprite(PModeWin,FM));
  }
  else
  {
	 if      (spritename == GetResString(IDS_MS_CHIPS_S_P1))       {return (new TCasChips(PModeWin,FM,psource));}
	 if (spritename == GetResString(IDS_MS_REEL_S_P1))        {return (new TSReel(PModeWin,FM,psource));}
	 if (spritename == GetResString(IDS_MS_COINSPLAYED_S_P1)) {return (new TSCoinsPlayed(PModeWin,FM,psource));}
	 if (spritename == GetResString(IDS_MS_CREDITS_S_P1))     {return (new TSCredits(PModeWin,FM,psource));}
	 if (spritename == GetResString(IDS_MS_WINPAID_S_P1))     {return (new TSWinPaid(PModeWin,FM,psource));}
	 if (spritename == GetResString(IDS_MS_COINPAY_S_P1))
	 {
		return (new TSCoinPay(PModeWin,FM,psource));
	 }
	 if (spritename == GetResString(IDS_MS_SOUNDS_S_P1))
	 {
		return (new TSSound(PModeWin,FM,psource));
	 }
	 if (spritename == GetResString(IDS_MS_NP1_S_P1))
	 {
		return (new TCasNamePlate(PModeWin,FM,psource));
	 }
	 if (spritename == GetResString(IDS_MS_NP2_S_P1))
	 {
		return (new TCasNamePlate(PModeWin,FM,psource));
	 }
	 if (spritename == GetResString(IDS_MS_NP3_S_P1))
	 {
		return (new TCasNamePlate(PModeWin,FM,psource));
	 }
	 if (spritename == GetResString(IDS_MS_B0_S_P1))
	 {
		return (new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,100,TRect(1,430,50,479),idButton0,true,'x'));
	 }
	 if (spritename == GetResString(IDS_MS_B1_S_P1))
	 {
		return (new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,100,TRect(170,430,219,479),idButton1,true));
	 }
	 if (spritename == GetResString(IDS_MS_B2_S_P1))
	 {
		return (new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,100,TRect(223,464,258,479),idButton2,true));
	 }
	 if (spritename == GetResString(IDS_MS_B3_S_P1))
	 {
		return (new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,100,TRect(376,464,412,479),idButton3,true));
	 }
	 if (spritename == GetResString(IDS_MS_B4_S_P1))
	 {
		return (new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,125,TRect(416,430,468,479),idButton4,true,'c'));
	 }
	 if (spritename == GetResString(IDS_MS_B5_S_P1))
	 {
		return (new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,125,TRect(470,430,522,479),idButton5,true,'b'));
	 }
	 if (spritename == GetResString(IDS_MS_B6_S_P1))
	 {
		return (new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,125,TRect(533,430,585,479),idButton6,true,'m'));
	 }
	 if (spritename == GetResString(IDS_MS_B7_S_P1))
	 {
		return (new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,125,TRect(587,432,639,478),idButton7,true,'d'));
	 }
	 if (spritename == GetResString(IDS_MS_BANKCASH_S_P1))//PCasNames->StatusBarName)
	 {
		return (new TCasCashDisplay(PModeWin,FM,psource));
	 }
	 return (new TSprite(PModeWin,FM,psource));
  }
}
//*******************************************************************
