//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  cccalc2.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     9/20/96    M.Perry    split into 2 cpp files.
//  2.0    09/17/97    M.Perry    32-bit conversion.
//********************************************************************
#include "cccalc.h"
#include "cstatdlg.h"
#include <stdio.h>
#include <classlib\time.h>

//*******************************************************************
TStatCalcCraps::TStatCalcCraps(TCasinoStatDlg *pstatdlg)
:TCasinoStatCalc(pstatdlg)
{
}
//*******************************************************************
TStatCalcCraps::~TStatCalcCraps()
{
}
//*******************************************************************
void TStatCalcCraps::GetSessionPtrs()
{
  if (PPlayerData == NULL) {return;}
  PData = &(PPlayerData->CData);

  LastSessionNum = -1;
  for (int sessioniterator = GetCData()->GetFirstValidSession();
       sessioniterator != -1;
       sessioniterator = GetCData()->GetNextValidSession())
  {
    LastSessionNum++;
    PSessions[LastSessionNum] = &(GetCData()->Sessions[sessioniterator]);
  }
}
//*******************************************************************
void TStatCalcCraps::LocalCalculate()
{
  TCasinoStatCalc::LocalCalculate();

  if (PPlayerData == NULL) {return;}

  Calc_CumulativeCashWL();
  Calc_TotalShoots();
  Calc_NumPassWins();
  Calc_NumNaturals();
  Calc_NumPtsMade();
  Calc_NumDontPassWins();
  Calc_NumCrapOuts();
  Calc_Num7Outs();
  Calc_LongestShoot();
  Calc_LongestPassStreak();
  Calc_LongestDontPassStreak();
  Calc_NumShootsBetRight();
  Calc_TotalCashBetRB();
  Calc_AvgCashBetPerShootRB();
  Calc_NumShootsWonCashRB();
  Calc_NumShootsLostCashRB();
  Calc_TotalCashWLRB();
  Calc_AvgCashWLPerShootRB();
  Calc_LongestWinStreakRB();
  Calc_MostCashWon1ShootRB();
  Calc_MostCashLost1ShootRB();
  Calc_NumShootsBetWrong();
  Calc_TotalCashBetWB();
  Calc_AvgCashBetPerShootWB();
  Calc_NumShootsWonCashWB();
  Calc_NumShootsLostCashWB();
  Calc_TotalCashWLWB();
  Calc_AvgCashWLPerShootWB();
  Calc_LongestWinStreakWB();
  Calc_MostCashWon1ShootWB();
  Calc_MostCashLost1ShootWB();
  Calc_PassBetsCash();
  Calc_PassFreeOddsBetsCash();
  Calc_DontPassBetsCash();
  Calc_DontPassFreeOddsBetsCash();
  Calc_ComeBetsCash();
  Calc_ComeFreeOddsBetsCash();
  Calc_DontComeBetsCash();
  Calc_DontComeFreeOddsBetsCash();
  Calc_FieldBetsCash();
  Calc_HardwayBetsCash();
  Calc_Big6Big8BetsCash();
  Calc_Buy4BetsCash();
  Calc_Place5BetsCash();
  Calc_Place6BetsCash();
  Calc_Place8BetsCash();
  Calc_Place9BetsCash();
  Calc_Buy10BetsCash();
  Calc_Place410BetsCash();
  Calc_Buy59BetsCash();
  Calc_Buy68BetsCash();
  Calc_Lay410BetsCash();
  Calc_Lay59BetsCash();
  Calc_Lay68BetsCash();
  Calc_PropositionBetsCash();
  Calc_TotalCashWon();
  Calc_TotalCashLost();
  Calc_PassBetsCashWL();
  Calc_PassFreeOddsBetsCashWL();
  Calc_DontPassBetsCashWL();
  Calc_DontPassFreeOddsBetsCashWL();
  Calc_ComeBetsCashWL();
  Calc_ComeFreeOddsBetsCashWL();
  Calc_DontComeBetsCashWL();
  Calc_DontComeFreeOddsBetsCashWL();
  Calc_FieldBetsCashWL();
  Calc_HardwayBetsCashWL();
  Calc_Big6Big8BetsCashWL();
  Calc_Buy4BetsCashWL();
  Calc_Place5BetsCashWL();
  Calc_Place6BetsCashWL();
  Calc_Place8BetsCashWL();
  Calc_Place9BetsCashWL();
  Calc_Buy10BetsCashWL();
  Calc_Place410BetsCashWL();
  Calc_Buy59BetsCashWL();
  Calc_Buy68BetsCashWL();
  Calc_Lay410BetsCashWL();
  Calc_Lay59BetsCashWL();
  Calc_Lay68BetsCashWL();
  Calc_PropositionBetsCashWL();
  Calc_PercRetPassBets();
  Calc_PercRetPassFreeOddsBets();
  Calc_PercRetDontPassBets();
  Calc_PercRetDontPassFreeOddsBets();
  Calc_PercRetComeBets();
  Calc_PercRetComeFreeOddsBets();
  Calc_PercRetDontComeBets();
  Calc_PercRetDontComeFreeOddsBets();
  Calc_PercRetFieldBets();
  Calc_PercRetHardwaysBets();
  Calc_PercRetBig6Big8Bets();
  Calc_PercRetBuy4Bets();
  Calc_PercRetPlace5Bets();
  Calc_PercRetPlace6Bets();
  Calc_PercRetPlace8Bets();
  Calc_PercRetPlace9Bets();
  Calc_PercRetBuy10Bets();
  Calc_PercRetPlace410Bets();
  Calc_PercRetBuy59Bets();
  Calc_PercRetBuy68Bets();
  Calc_PercRetLay410Bets();
  Calc_PercRetLay59Bets();
  Calc_PercRetLay68Bets();
  Calc_PercRetPropositionBets();
  Calc_NumHighPercBets();
  Calc_NumLowPercBets();
  Calc_PercPlayingAccuracy();
}
//*******************************************************************
void TStatCalcCraps::LocalMakeAllStrings()
{
  TCasinoStatCalc::LocalMakeAllStrings();

  if (PPlayerData == NULL) {return;}

  Make_CumulativeCashWLStrs();
  Make_TotalShootsStrs();
  Make_NumPassWinsStrs();
  Make_NumNaturalsStrs();
  Make_NumPtsMadeStrs();
  Make_NumDontPassWinsStrs();
  Make_NumCrapOutsStrs();
  Make_Num7OutsStrs();
  Make_LongestShootStrs();
  Make_LongestPassStreakStrs();
  Make_LongestDontPassStreakStrs();
  Make_NumShootsBetRightStrs();
  Make_TotalCashBetRBStrs();
  Make_AvgCashBetPerShootRBStrs();
  Make_NumShootsWonCashRBStrs();
  Make_NumShootsLostCashRBStrs();
  Make_TotalCashWLRBStrs();
  Make_AvgCashWLPerShootRBStrs();
  Make_LongestWinStreakRBStrs();
  Make_MostCashWon1ShootRBStrs();
  Make_MostCashLost1ShootRBStrs();
  Make_NumShootsBetWrongStrs();
  Make_TotalCashBetWBStrs();
  Make_AvgCashBetPerShootWBStrs();
  Make_NumShootsWonCashWBStrs();
  Make_NumShootsLostCashWBStrs();
  Make_TotalCashWLWBStrs();
  Make_AvgCashWLPerShootWBStrs();
  Make_LongestWinStreakWBStrs();
  Make_MostCashWon1ShootWBStrs();
  Make_MostCashLost1ShootWBStrs();
  Make_PassBetsCashStrs();
  Make_PassFreeOddsBetsCashStrs();
  Make_DontPassBetsCashStrs();
  Make_DontPassFreeOddsBetsCashStrs();
  Make_ComeBetsCashStrs();
  Make_ComeFreeOddsBetsCashStrs();
  Make_DontComeBetsCashStrs();
  Make_DontComeFreeOddsBetsCashStrs();
  Make_FieldBetsCashStrs();
  Make_HardwayBetsCashStrs();
  Make_Big6Big8BetsCashStrs();
  Make_Buy4BetsCashStrs();
  Make_Place5BetsCashStrs();
  Make_Place6BetsCashStrs();
  Make_Place8BetsCashStrs();
  Make_Place9BetsCashStrs();
  Make_Buy10BetsCashStrs();
  Make_Place410BetsCashStrs();
  Make_Buy59BetsCashStrs();
  Make_Buy68BetsCashStrs();
  Make_Lay410BetsCashStrs();
  Make_Lay59BetsCashStrs();
  Make_Lay68BetsCashStrs();
  Make_PropositionBetsCashStrs();
  Make_TotalCashWonStrs();
  Make_TotalCashLostStrs();
  Make_PassBetsCashWLStrs();
  Make_PassFreeOddsBetsCashWLStrs();
  Make_DontPassBetsCashWLStrs();
  Make_DontPassFreeOddsBetsCashWLStrs();
  Make_ComeBetsCashWLStrs();
  Make_ComeFreeOddsBetsCashWLStrs();
  Make_DontComeBetsCashWLStrs();
  Make_DontComeFreeOddsBetsCashWLStrs();
  Make_FieldBetsCashWLStrs();
  Make_HardwayBetsCashWLStrs();
  Make_Big6Big8BetsCashWLStrs();
  Make_Buy4BetsCashWLStrs();
  Make_Place5BetsCashWLStrs();
  Make_Place6BetsCashWLStrs();
  Make_Place8BetsCashWLStrs();
  Make_Place9BetsCashWLStrs();
  Make_Buy10BetsCashWLStrs();
  Make_Place410BetsCashWLStrs();
  Make_Buy59BetsCashWLStrs();
  Make_Buy68BetsCashWLStrs();
  Make_Lay410BetsCashWLStrs();
  Make_Lay59BetsCashWLStrs();
  Make_Lay68BetsCashWLStrs();
  Make_PropositionBetsCashWLStrs();
  Make_PercRetPassBetsStrs();
  Make_PercRetPassFreeOddsBetsStrs();
  Make_PercRetDontPassBetsStrs();
  Make_PercRetDontPassFreeOddsBetsStrs();
  Make_PercRetComeBetsStrs();
  Make_PercRetComeFreeOddsBetsStrs();
  Make_PercRetDontComeBetsStrs();
  Make_PercRetDontComeFreeOddsBetsStrs();
  Make_PercRetFieldBetsStrs();
  Make_PercRetHardwaysBetsStrs();
  Make_PercRetBig6Big8BetsStrs();
  Make_PercRetBuy4BetsStrs();
  Make_PercRetPlace5BetsStrs();
  Make_PercRetPlace6BetsStrs();
  Make_PercRetPlace8BetsStrs();
  Make_PercRetPlace9BetsStrs();
  Make_PercRetBuy10BetsStrs();
  Make_PercRetPlace410BetsStrs();
  Make_PercRetBuy59BetsStrs();
  Make_PercRetBuy68BetsStrs();
  Make_PercRetLay410BetsStrs();
  Make_PercRetLay59BetsStrs();
  Make_PercRetLay68BetsStrs();
  Make_PercRetPropositionBetsStrs();
  Make_NumHighPercBetsStrs();
  Make_NumLowPercBetsStrs();
  Make_PercPlayingAccuracyStrs();
}
//*******************************************************************
void TStatCalcCraps::LocalFillGrid()
{
  TCasinoStatCalc::LocalFillGrid();

  if (PPlayerData == NULL) {return;}

  for(int col = 0;col <= LastSessionNum;col++)
  {
    int c = col + 1;
    PStatDlg->cell[1][c] = DateStr[col];
    PStatDlg->cell[2][c] = HoursPlayedStr[col];
    PStatDlg->cell[3][c] = TypeGamePlayedStr[col];
    PStatDlg->cell[6][c] = TotalNumBetsStr[col];
    PStatDlg->cell[7][c] = TotalCashBetsStr[col];
    PStatDlg->cell[8][c] = AvgCashBetsStr[col];
    PStatDlg->cell[9][c] = StartingBankrollStr[col];
    PStatDlg->cell[10][c] = EndingBankrollStr[col];
    PStatDlg->cell[11][c] = TotalCashWLStr[col];
    PStatDlg->cell[12][c] = ReturnPercStr[col];
    PStatDlg->cell[13][c] = AvgWLPerHourStr[col];
    PStatDlg->cell[14][c] = TotalCashWLStr[col];
    PStatDlg->cell[15][c] = PeakCashWinLevelStr[col];
    PStatDlg->cell[16][c] = LowCashLostLevelStr[col];
    PStatDlg->cell[19][c] = TotalShootsStr[col];
    PStatDlg->cell[20][c] = NumPassWinsStr[col];
    PStatDlg->cell[21][c] = NumNaturalsStr[col];
    PStatDlg->cell[22][c] = NumPtsMadeStr[col];
    PStatDlg->cell[23][c] = NumDontPassWinsStr[col];
    PStatDlg->cell[24][c] = NumCrapOutsStr[col];
    PStatDlg->cell[25][c] = Num7OutsStr[col];
    PStatDlg->cell[26][c] = LongestShootStr[col];
    PStatDlg->cell[27][c] = LongestPassStreakStr[col];
    PStatDlg->cell[28][c] = LongestDontPassStreakStr[col];
    PStatDlg->cell[31][c] = NumShootsBetRightStr[col];
    PStatDlg->cell[32][c] = TotalCashBetRBStr[col];
    PStatDlg->cell[33][c] = AvgCashBetPerShootRBStr[col];
    PStatDlg->cell[34][c] = NumShootsWonCashRBStr[col];
    PStatDlg->cell[35][c] = NumShootsLostCashRBStr[col];
    PStatDlg->cell[36][c] = TotalCashWLRBStr[col];
    PStatDlg->cell[37][c] = AvgCashWLPerShootRBStr[col];
    PStatDlg->cell[38][c] = LongestWinStreakRBStr[col];
    PStatDlg->cell[39][c] = MostCashWon1ShootRBStr[col];
    PStatDlg->cell[40][c] = MostCashLost1ShootRBStr[col];
    PStatDlg->cell[43][c] = NumShootsBetWrongStr[col];
    PStatDlg->cell[44][c] = TotalCashBetWBStr[col];
    PStatDlg->cell[45][c] = AvgCashBetPerShootWBStr[col];
    PStatDlg->cell[46][c] = NumShootsWonCashWBStr[col];
    PStatDlg->cell[47][c] = NumShootsLostCashWBStr[col];
    PStatDlg->cell[48][c] = TotalCashWLWBStr[col];
    PStatDlg->cell[49][c] = AvgCashWLPerShootWBStr[col];
    PStatDlg->cell[50][c] = LongestWinStreakWBStr[col];
    PStatDlg->cell[51][c] = MostCashWon1ShootWBStr[col];
    PStatDlg->cell[52][c] = MostCashLost1ShootWBStr[col];
    PStatDlg->cell[55][c] = TotalCashBetsStr[col];
    PStatDlg->cell[56][c] = PassBetsCashStr[col];
    PStatDlg->cell[57][c] = PassFreeOddsBetsCashStr[col];
    PStatDlg->cell[58][c] = DontPassBetsCashStr[col];
    PStatDlg->cell[59][c] = DontPassFreeOddsBetsCashStr[col];
    PStatDlg->cell[60][c] = ComeBetsCashStr[col];
    PStatDlg->cell[61][c] = ComeFreeOddsBetsCashStr[col];
    PStatDlg->cell[62][c] = DontComeBetsCashStr[col];
    PStatDlg->cell[63][c] = DontComeFreeOddsBetsCashStr[col];
    PStatDlg->cell[64][c] = FieldBetsCashStr[col];
    PStatDlg->cell[65][c] = HardwayBetsCashStr[col];
    PStatDlg->cell[66][c] = Big6Big8BetsCashStr[col];
    PStatDlg->cell[67][c] = Buy4BetsCashStr[col];
    PStatDlg->cell[68][c] = Place5BetsCashStr[col];
    PStatDlg->cell[69][c] = Place6BetsCashStr[col];
    PStatDlg->cell[70][c] = Place8BetsCashStr[col];
    PStatDlg->cell[71][c] = Place9BetsCashStr[col];
    PStatDlg->cell[72][c] = Buy10BetsCashStr[col];
    PStatDlg->cell[73][c] = Place410BetsCashStr[col];
    PStatDlg->cell[74][c] = Buy59BetsCashStr[col];
    PStatDlg->cell[75][c] = Buy68BetsCashStr[col];
    PStatDlg->cell[76][c] = Lay410BetsCashStr[col];
    PStatDlg->cell[77][c] = Lay59BetsCashStr[col];
    PStatDlg->cell[78][c] = Lay68BetsCashStr[col];
    PStatDlg->cell[79][c] = PropositionBetsCashStr[col];
    PStatDlg->cell[82][c] = TotalCashWonStr[col];
    PStatDlg->cell[83][c] = TotalCashLostStr[col];
    PStatDlg->cell[84][c] = PassBetsCashWLStr[col];
    PStatDlg->cell[85][c] = PassFreeOddsBetsCashWLStr[col];
    PStatDlg->cell[86][c] = DontPassBetsCashWLStr[col];
    PStatDlg->cell[87][c] = DontPassFreeOddsBetsCashWLStr[col];
    PStatDlg->cell[88][c] = ComeBetsCashWLStr[col];
    PStatDlg->cell[89][c] = ComeFreeOddsBetsCashWLStr[col];
    PStatDlg->cell[90][c] = DontComeBetsCashWLStr[col];
    PStatDlg->cell[91][c] = DontComeFreeOddsBetsCashWLStr[col];
    PStatDlg->cell[92][c] = FieldBetsCashWLStr[col];
    PStatDlg->cell[93][c] = HardwayBetsCashWLStr[col];
    PStatDlg->cell[94][c] = Big6Big8BetsCashWLStr[col];
    PStatDlg->cell[95][c] = Buy4BetsCashWLStr[col];
    PStatDlg->cell[96][c] = Place5BetsCashWLStr[col];
    PStatDlg->cell[97][c] = Place6BetsCashWLStr[col];
    PStatDlg->cell[98][c] = Place8BetsCashWLStr[col];
    PStatDlg->cell[99][c] = Place9BetsCashWLStr[col];
    PStatDlg->cell[100][c] = Buy10BetsCashWLStr[col];
    PStatDlg->cell[101][c] = Place410BetsCashWLStr[col];
    PStatDlg->cell[102][c] = Buy59BetsCashWLStr[col];
    PStatDlg->cell[103][c] = Buy68BetsCashWLStr[col];
    PStatDlg->cell[104][c] = Lay410BetsCashWLStr[col];
    PStatDlg->cell[105][c] = Lay59BetsCashWLStr[col];
    PStatDlg->cell[106][c] = Lay68BetsCashWLStr[col];
    PStatDlg->cell[107][c] = PropositionBetsCashWLStr[col];
    PStatDlg->cell[110][c] = PercRetPassBetsStr[col];
    PStatDlg->cell[111][c] = PercRetPassFreeOddsBetsStr[col];
    PStatDlg->cell[112][c] = PercRetDontPassBetsStr[col];
    PStatDlg->cell[113][c] = PercRetDontPassFreeOddsBetsStr[col];
    PStatDlg->cell[114][c] = PercRetComeBetsStr[col];
    PStatDlg->cell[115][c] = PercRetComeFreeOddsBetsStr[col];
    PStatDlg->cell[116][c] = PercRetDontComeBetsStr[col];
    PStatDlg->cell[117][c] = PercRetDontComeFreeOddsBetsStr[col];
    PStatDlg->cell[118][c] = PercRetFieldBetsStr[col];
    PStatDlg->cell[119][c] = PercRetHardwaysBetsStr[col];
    PStatDlg->cell[120][c] = PercRetBig6Big8BetsStr[col];
    PStatDlg->cell[121][c] = PercRetBuy4BetsStr[col];
    PStatDlg->cell[122][c] = PercRetPlace5BetsStr[col];
    PStatDlg->cell[123][c] = PercRetPlace6BetsStr[col];
    PStatDlg->cell[124][c] = PercRetPlace8BetsStr[col];
    PStatDlg->cell[125][c] = PercRetPlace9BetsStr[col];
    PStatDlg->cell[126][c] = PercRetBuy10BetsStr[col];
    PStatDlg->cell[127][c] = PercRetPlace410BetsStr[col];
    PStatDlg->cell[128][c] = PercRetBuy59BetsStr[col];
    PStatDlg->cell[129][c] = PercRetBuy68BetsStr[col];
    PStatDlg->cell[130][c] = PercRetLay410BetsStr[col];
    PStatDlg->cell[131][c] = PercRetLay59BetsStr[col];
    PStatDlg->cell[132][c] = PercRetLay68BetsStr[col];
    PStatDlg->cell[133][c] = PercRetPropositionBetsStr[col];
    PStatDlg->cell[136][c] = NumHighPercBetsStr[col];
    PStatDlg->cell[137][c] = NumLowPercBetsStr[col];
    PStatDlg->cell[138][c] = PercPlayingAccuracyStr[col];
  }
  PStatDlg->totalcol[1] = Total_DateStr;
  PStatDlg->totalcol[2] = Total_HoursPlayedStr;
  PStatDlg->totalcol[3] = Total_TypeGamePlayedStr;
  PStatDlg->totalcol[6] = Total_TotalNumBetsStr;
  PStatDlg->totalcol[7] = Total_TotalCashBetsStr;
  PStatDlg->totalcol[8] = Total_AvgCashBetsStr;
  PStatDlg->totalcol[9] = Total_StartingBankrollStr;
  PStatDlg->totalcol[10] = Total_EndingBankrollStr;
  PStatDlg->totalcol[11] = Total_TotalCashWLStr;
  PStatDlg->totalcol[12] = Total_ReturnPercStr;
  PStatDlg->totalcol[13] = Total_AvgWLPerHourStr;
  PStatDlg->totalcol[14] = Total_TotalCashWLStr;
  PStatDlg->totalcol[15] = Total_PeakCashWinLevelStr;
  PStatDlg->totalcol[16] = Total_LowCashLostLevelStr;
  PStatDlg->totalcol[19] = Total_TotalShootsStr;
  PStatDlg->totalcol[20] = Total_NumPassWinsStr;
  PStatDlg->totalcol[21] = Total_NumNaturalsStr;
  PStatDlg->totalcol[22] = Total_NumPtsMadeStr;
  PStatDlg->totalcol[23] = Total_NumDontPassWinsStr;
  PStatDlg->totalcol[24] = Total_NumCrapOutsStr;
  PStatDlg->totalcol[25] = Total_Num7OutsStr;
  PStatDlg->totalcol[26] = Total_LongestShootStr;
  PStatDlg->totalcol[27] = Total_LongestPassStreakStr;
  PStatDlg->totalcol[28] = Total_LongestDontPassStreakStr;
  PStatDlg->totalcol[31] = Total_NumShootsBetRightStr;
  PStatDlg->totalcol[32] = Total_TotalCashBetRBStr;
  PStatDlg->totalcol[33] = Total_AvgCashBetPerShootRBStr;
  PStatDlg->totalcol[34] = Total_NumShootsWonCashRBStr;
  PStatDlg->totalcol[35] = Total_NumShootsLostCashRBStr;
  PStatDlg->totalcol[36] = Total_TotalCashWLRBStr;
  PStatDlg->totalcol[37] = Total_AvgCashWLPerShootRBStr;
  PStatDlg->totalcol[38] = Total_LongestWinStreakRBStr;
  PStatDlg->totalcol[39] = Total_MostCashWon1ShootRBStr;
  PStatDlg->totalcol[40] = Total_MostCashLost1ShootRBStr;
  PStatDlg->totalcol[43] = Total_NumShootsBetWrongStr;
  PStatDlg->totalcol[44] = Total_TotalCashBetWBStr;
  PStatDlg->totalcol[45] = Total_AvgCashBetPerShootWBStr;
  PStatDlg->totalcol[46] = Total_NumShootsWonCashWBStr;
  PStatDlg->totalcol[47] = Total_NumShootsLostCashWBStr;
  PStatDlg->totalcol[48] = Total_TotalCashWLWBStr;
  PStatDlg->totalcol[49] = Total_AvgCashWLPerShootWBStr;
  PStatDlg->totalcol[50] = Total_LongestWinStreakWBStr;
  PStatDlg->totalcol[51] = Total_MostCashWon1ShootWBStr;
  PStatDlg->totalcol[52] = Total_MostCashLost1ShootWBStr;
  PStatDlg->totalcol[55] = Total_TotalCashBetsStr;
  PStatDlg->totalcol[56] = Total_PassBetsCashStr;
  PStatDlg->totalcol[57] = Total_PassFreeOddsBetsCashStr;
  PStatDlg->totalcol[58] = Total_DontPassBetsCashStr;
  PStatDlg->totalcol[59] = Total_DontPassFreeOddsBetsCashStr;
  PStatDlg->totalcol[60] = Total_ComeBetsCashStr;
  PStatDlg->totalcol[61] = Total_ComeFreeOddsBetsCashStr;
  PStatDlg->totalcol[62] = Total_DontComeBetsCashStr;
  PStatDlg->totalcol[63] = Total_DontComeFreeOddsBetsCashStr;
  PStatDlg->totalcol[64] = Total_FieldBetsCashStr;
  PStatDlg->totalcol[65] = Total_HardwayBetsCashStr;
  PStatDlg->totalcol[66] = Total_Big6Big8BetsCashStr;
  PStatDlg->totalcol[67] = Total_Buy4BetsCashStr;
  PStatDlg->totalcol[68] = Total_Place5BetsCashStr;
  PStatDlg->totalcol[69] = Total_Place6BetsCashStr;
  PStatDlg->totalcol[70] = Total_Place8BetsCashStr;
  PStatDlg->totalcol[71] = Total_Place9BetsCashStr;
  PStatDlg->totalcol[72] = Total_Buy10BetsCashStr;
  PStatDlg->totalcol[73] = Total_Place410BetsCashStr;
  PStatDlg->totalcol[74] = Total_Buy59BetsCashStr;
  PStatDlg->totalcol[75] = Total_Buy68BetsCashStr;
  PStatDlg->totalcol[76] = Total_Lay410BetsCashStr;
  PStatDlg->totalcol[77] = Total_Lay59BetsCashStr;
  PStatDlg->totalcol[78] = Total_Lay68BetsCashStr;
  PStatDlg->totalcol[79] = Total_PropositionBetsCashStr;
  PStatDlg->totalcol[82] = Total_TotalCashWonStr;
  PStatDlg->totalcol[83] = Total_TotalCashLostStr;
  PStatDlg->totalcol[84] = Total_PassBetsCashWLStr;
  PStatDlg->totalcol[85] = Total_PassFreeOddsBetsCashWLStr;
  PStatDlg->totalcol[86] = Total_DontPassBetsCashWLStr;
  PStatDlg->totalcol[87] = Total_DontPassFreeOddsBetsCashWLStr;
  PStatDlg->totalcol[88] = Total_ComeBetsCashWLStr;
  PStatDlg->totalcol[89] = Total_ComeFreeOddsBetsCashWLStr;
  PStatDlg->totalcol[90] = Total_DontComeBetsCashWLStr;
  PStatDlg->totalcol[91] = Total_DontComeFreeOddsBetsCashWLStr;
  PStatDlg->totalcol[92] = Total_FieldBetsCashWLStr;
  PStatDlg->totalcol[93] = Total_HardwayBetsCashWLStr;
  PStatDlg->totalcol[94] = Total_Big6Big8BetsCashWLStr;
  PStatDlg->totalcol[95] = Total_Buy4BetsCashWLStr;
  PStatDlg->totalcol[96] = Total_Place5BetsCashWLStr;
  PStatDlg->totalcol[97] = Total_Place6BetsCashWLStr;
  PStatDlg->totalcol[98] = Total_Place8BetsCashWLStr;
  PStatDlg->totalcol[99] = Total_Place9BetsCashWLStr;
  PStatDlg->totalcol[100] = Total_Buy10BetsCashWLStr;
  PStatDlg->totalcol[101] = Total_Place410BetsCashWLStr;
  PStatDlg->totalcol[102] = Total_Buy59BetsCashWLStr;
  PStatDlg->totalcol[103] = Total_Buy68BetsCashWLStr;
  PStatDlg->totalcol[104] = Total_Lay410BetsCashWLStr;
  PStatDlg->totalcol[105] = Total_Lay59BetsCashWLStr;
  PStatDlg->totalcol[106] = Total_Lay68BetsCashWLStr;
  PStatDlg->totalcol[107] = Total_PropositionBetsCashWLStr;
  PStatDlg->totalcol[110] = Total_PercRetPassBetsStr;
  PStatDlg->totalcol[111] = Total_PercRetPassFreeOddsBetsStr;
  PStatDlg->totalcol[112] = Total_PercRetDontPassBetsStr;
  PStatDlg->totalcol[113] = Total_PercRetDontPassFreeOddsBetsStr;
  PStatDlg->totalcol[114] = Total_PercRetComeBetsStr;
  PStatDlg->totalcol[115] = Total_PercRetComeFreeOddsBetsStr;
  PStatDlg->totalcol[116] = Total_PercRetDontComeBetsStr;
  PStatDlg->totalcol[117] = Total_PercRetDontComeFreeOddsBetsStr;
  PStatDlg->totalcol[118] = Total_PercRetFieldBetsStr;
  PStatDlg->totalcol[119] = Total_PercRetHardwaysBetsStr;
  PStatDlg->totalcol[120] = Total_PercRetBig6Big8BetsStr;
  PStatDlg->totalcol[121] = Total_PercRetBuy4BetsStr;
  PStatDlg->totalcol[122] = Total_PercRetPlace5BetsStr;
  PStatDlg->totalcol[123] = Total_PercRetPlace6BetsStr;
  PStatDlg->totalcol[124] = Total_PercRetPlace8BetsStr;
  PStatDlg->totalcol[125] = Total_PercRetPlace9BetsStr;
  PStatDlg->totalcol[126] = Total_PercRetBuy10BetsStr;
  PStatDlg->totalcol[127] = Total_PercRetPlace410BetsStr;
  PStatDlg->totalcol[128] = Total_PercRetBuy59BetsStr;
  PStatDlg->totalcol[129] = Total_PercRetBuy68BetsStr;
  PStatDlg->totalcol[130] = Total_PercRetLay410BetsStr;
  PStatDlg->totalcol[131] = Total_PercRetLay59BetsStr;
  PStatDlg->totalcol[132] = Total_PercRetLay68BetsStr;
  PStatDlg->totalcol[133] = Total_PercRetPropositionBetsStr;
  PStatDlg->totalcol[136] = Total_NumHighPercBetsStr;
  PStatDlg->totalcol[137] = Total_NumLowPercBetsStr;
  PStatDlg->totalcol[138] = Total_PercPlayingAccuracyStr;
}
//*******************************************************************
//*******************************************************************
TCrapsGraph::TCrapsGraph(TCasinoStatDlg* pstatdlg,TStatCalcCraps *pstatcalc)
:TCasinoGraphDlg(pstatdlg,pstatcalc)
{
  strName = "Craps";
  StatTT[0] = TStatCalcCraps::cTotalNumBets;
  StatTT[1] = TStatCalcCraps::cTotalCashBets;
  StatTT[2] = TStatCalcCraps::cAvgCashBet;
  StatTT[3] = TStatCalcCraps::cTotalCashWL;
  StatTT[4] = TStatCalcCraps::cCumCashWL;
  StatTT[5] = TStatCalcCraps::cPeakCashWinLevel;
  StatTT[6] = TStatCalcCraps::cLowCashLossLevel;
  StatTT[7] = TStatCalcCraps::cNumPassWins;
  StatTT[8] = TStatCalcCraps::cNumNaturals;
  StatTT[9] = TStatCalcCraps::cNumPtsMade;
  StatTT[10] = TStatCalcCraps::cNumDontPassWins;
  StatTT[11] = TStatCalcCraps::cNumCrapOuts;
  StatTT[12] = TStatCalcCraps::cNum7Outs;
  StatTT[13] = TStatCalcCraps::cLongestShoot;
  StatTT[14] = TStatCalcCraps::cLongestPassStreak;
  StatTT[15] = TStatCalcCraps::cLongestDontPassStreak;

  LastStatIndex = 15;
  BaseStringID = CrapsLabel;
}
//*******************************************************************
TCrapsGraph::~TCrapsGraph()
{
}
//*******************************************************************