//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  vlintgld.cpp
//    Project Name:  VPLite                 
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.2     4/25/97    M.Perry     added intro mode.
//********************************************************************
#include "casgfw.h"
#include "vlintgld.h"
#include "vlintmw.h"
#include "ogame.h"
#include "orespond.h"
//*******************************************************************
TVLIntroGameLord::TVLIntroGameLord(TVLIntroModeWin *pmodewin,const TFileMode &fm)
:TCasinoGameLord(pmodewin,fm,0,0),
 PCasinoModeWin(pmodewin)
{
  LobbyModeIndex = GetOgleApp()->GetPGame()->GetModeIndex("i3vplite");
  TFileMode splfm(SpriteListName,fm_None,fm_Immed,FileMode.DirIndex);
  CreateAddSpriteList(splfm);

  PBigResponder = new TResponder(pmodewin,1,TRect(0,0,640,480),1,this,TRUE,'^');
  SetupSprites();
}
//*******************************************************************
TVLIntroGameLord::~TVLIntroGameLord()
{
  delete PBigResponder;
  PBigResponder = NULL;
}
//*******************************************************************
BOOL TVLIntroGameLord::Respond(TResponder &responder)
{
  if (responder.GetResponseEvent() == reLUp ||
      responder.GetResponseEvent() == reRUp ||
      responder.GetResponseEvent() == reChar)
  {
    PCasinoModeWin->PostSwitchToMode(LobbyModeIndex);
    return TRUE;
  }
  return FALSE;
}
//*******************************************************************
void TVLIntroGameLord::Update(DWORD fuc)
{
  TCasinoGameLord::Update(fuc);
  if (fuc >= EndFUC)
  {
    PCasinoModeWin->GetCasGFW()->SetFadeIn(TRUE);
    PCasinoModeWin->PostSwitchToMode(LobbyModeIndex);
  }
}
//*******************************************************************
void TVLIntroGameLord::SetupSprites()
{
  EndFUC = GetSpritePtr(0)->Get_FUC_Length();
  ActivateSpriteNow(GetSpritePtr(0));
}
//*******************************************************************
