//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  vplgfw2.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.2     4/17/97    M.Perry     modified app & fw hierarchy.
//********************************************************************
#include "vplgfw.h"
#include "cgametyp.h"

#include "vlmw.h"

//#include "dw1mw.h"
#include "vpldw1.h"
//#include "dw5mw.h"
#include "vpldw5.h"
//#include "dw25mw.h"
#include "vpldw25.h"
//#include "dw100mw.h"
#include "vpldw100.h"
//#include "jw100mw.h"
#include "vpljw100.h"
//#include "jb1mw.h"
#include "vpljb1.h"
//#include "jb5mw.h"
#include "vpljb5.h"
//#include "jb25mw.h"
#include "vpljb25.h"
//#include "jb100mw.h"
#include "vpljb100.h"
//#include "jb1pmw.h"
#include "vpljb1p.h"

#include "vlintmw.h"
#include "casnames.rh"
//*******************************************************************
void TVPLGameFrameWindow::SetupModeStrings()
{
  strIntro      = string("s3vintro");
  strLobby      = TAppString(IDS_M_LOBBY_VPLITE);
  strVPJack1    = TAppString(IDS_M_VP_JB1);
  strVPJack5    = TAppString(IDS_M_VP_JB5);
  strVPJack25   = TAppString(IDS_M_VP_JB25);
  strVPJack100  = TAppString(IDS_M_VP_JB100);
  strVPJack1P   = TAppString(IDS_M_VP_JB1P);
  strVPDWild1   = TAppString(IDS_M_VP_DW1);
  strVPDWild5   = TAppString(IDS_M_VP_DW5);
  strVPDWild25  = TAppString(IDS_M_VP_DW25);
  strVPDWild100 = TAppString(IDS_M_VP_DW100);
  strVPJWild100 = TAppString(IDS_M_VP_JW100);
}
//*******************************************************************
TWindow *TVPLGameFrameWindow::CreateModeWindow(int ModeIndex)
{
  GetVPLMenuEnable()->SetModes(TRUE);

  if (!IsValidModeIndex(ModeIndex)) {return PModeWin;}

  string modename = GetModeName(ModeIndex);

  if (modename == strIntro)//"s3vintro")
  {
    PModeWin = new TVLIntroModeWin(modename,GetOgleApp()->PMasterPalette,"Intro");
    GetVPLMenuEnable()->CurrentMode = -1;
    return PModeWin;
  }
  if (modename == strLobby)//TAppString(IDS_M_LOBBY_VPLITE))
  {
	 PModeWin = new TVLobby1ModeWin(modename,GetOgleApp()->PMasterPalette,"walkabout");
	 GetVPLMenuEnable()->CurrentMode = IDS_M_LOBBY_VPLITE;
	 GetVPLMenuEnable()->Lobby = FALSE;
	 return PModeWin;
  }
  if (modename == strVPJWild100)//TAppString(IDS_M_VP_JW100))
  {
//	 PModeWin = new TJW100ModeWin(modename,GetOgleApp()->PMasterPalette);
    PModeWin = new TVPLJW100ModeWin(modename,GetOgleApp()->PMasterPalette);
	 GetVPLMenuEnable()->CurrentMode = IDS_M_VP_JW100;
	 GetVPLMenuEnable()->VPJWild100 = FALSE;
	 return PModeWin;
  }
  if (modename == strVPDWild1)//TAppString(IDS_M_VP_DW1))
  {
//	 PModeWin = new TDW1ModeWin(modename,GetOgleApp()->PMasterPalette);
    PModeWin = new TVPLDW1ModeWin(modename,GetOgleApp()->PMasterPalette);
	 GetVPLMenuEnable()->CurrentMode = IDS_M_VP_DW1;
	 GetVPLMenuEnable()->VPDWild1 = FALSE;
	 return PModeWin;
  }
  if (modename == strVPDWild5)//TAppString(IDS_M_VP_DW5))
  {
//	 PModeWin = new TDW5ModeWin(modename,GetOgleApp()->PMasterPalette);
    PModeWin = new TVPLDW5ModeWin(modename,GetOgleApp()->PMasterPalette);
	 GetVPLMenuEnable()->CurrentMode = IDS_M_VP_DW5;
	 GetVPLMenuEnable()->VPDWild5 = FALSE;
	 return PModeWin;
  }
  if (modename == strVPDWild25)//TAppString(IDS_M_VP_DW25))
  {
//	 PModeWin = new TDW25ModeWin(modename,GetOgleApp()->PMasterPalette);
    PModeWin = new TVPLDW25ModeWin(modename,GetOgleApp()->PMasterPalette);
	 GetVPLMenuEnable()->CurrentMode = IDS_M_VP_DW25;
	 GetVPLMenuEnable()->VPDWild25 = FALSE;
	 return PModeWin;
  }
  if (modename == strVPDWild100)//TAppString(IDS_M_VP_DW100))
  {
//	 PModeWin = new TDW100ModeWin(modename,GetOgleApp()->PMasterPalette);
    PModeWin = new TVPLDW100ModeWin(modename,GetOgleApp()->PMasterPalette);
	 GetVPLMenuEnable()->CurrentMode = IDS_M_VP_DW100;
	 GetVPLMenuEnable()->VPDWild100 = FALSE;
	 return PModeWin;
  }

  if (modename == strVPJack1)//TAppString(IDS_M_VP_JB1))
  {
//	 PModeWin = new TJB1ModeWin(modename,GetOgleApp()->PMasterPalette);
    PModeWin = new TVPLJB1ModeWin(modename,GetOgleApp()->PMasterPalette);
	 GetVPLMenuEnable()->CurrentMode = IDS_M_VP_JB1;
	 GetVPLMenuEnable()->VPJack1 = FALSE;
	 return PModeWin;
  }
  if (modename == strVPJack5)//TAppString(IDS_M_VP_JB5))
  {
//	 PModeWin = new TJB5ModeWin(modename,GetOgleApp()->PMasterPalette);
    PModeWin = new TVPLJB5ModeWin(modename,GetOgleApp()->PMasterPalette);
	 GetVPLMenuEnable()->CurrentMode = IDS_M_VP_JB5;
	 GetVPLMenuEnable()->VPJack5 = FALSE;
	 return PModeWin;
  }
  if (modename == strVPJack100)//TAppString(IDS_M_VP_JB100))
  {
//	 PModeWin = new TJB100ModeWin(modename,GetOgleApp()->PMasterPalette);
    PModeWin = new TVPLJB100ModeWin(modename,GetOgleApp()->PMasterPalette);
	 GetVPLMenuEnable()->CurrentMode = IDS_M_VP_JB100;
	 GetVPLMenuEnable()->VPJack100 = FALSE;
	 return PModeWin;
  }
  if (modename == strVPJack25)//TAppString(IDS_M_VP_JB25))
  {
//	 PModeWin = new TJB25ModeWin(modename,GetOgleApp()->PMasterPalette);
    PModeWin = new TVPLJB25ModeWin(modename,GetOgleApp()->PMasterPalette);
	 GetVPLMenuEnable()->CurrentMode = IDS_M_VP_JB25;
	 GetVPLMenuEnable()->VPJack25 = FALSE;
	 return PModeWin;
  }
  if (modename == strVPJack1P)//TAppString(IDS_M_VP_JB1P))
  {
//	 PModeWin = new TJB1PModeWin(modename,GetOgleApp()->PMasterPalette);
    PModeWin = new TVPLJB1PModeWin(modename,GetOgleApp()->PMasterPalette);
	 GetVPLMenuEnable()->CurrentMode = IDS_M_VP_JB1P;
	 GetVPLMenuEnable()->VPJack1P = FALSE;
	 return PModeWin;
  }
  ::MessageBox(NULL,"Default Mode Window Created","Create Mode Window",MB_OK);
  PModeWin = new TCasinoModeWin(modename,GetOgleApp()->PMasterPalette,string("Default Casino ModeWin"));
  return PModeWin;
}
//*******************************************************************

