//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  cvpdata.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     9/9/96     M.Perry    split up cplaydat file
//  2.0    09/17/97    M.Perry    32-bit conversion.
//********************************************************************
#include "cvpdata.h"

//*******************************************************************
TCVPSession::TCVPSession()
{
  ClearData();
}
//*******************************************************************
void TCVPSession::ClearData()
{
  TCasinoSession::ClearData();
  GarbageHands = 0;
  HighPairs = 0;
  TwoPairs = 0;
  ThreeOfKinds = 0;
  Straights = 0;
  Flushes = 0;
  FullHouses = 0;
  FourOfKinds = 0;
  StraightFlushes = 0;
  NaturalRoyals = 0;
  WildRoyals = 0;
  FiveOfKinds = 0;
  FourDeuces = 0;
  TotalCashWon = 0;
  TotalHighPairCash = 0;
  TotalTwoPairCash = 0;
  TotalThreeOfKindCash = 0;
  TotalStraightCash = 0;
  TotalFlushCash = 0;
  TotalFullHouseCash = 0;
  TotalFourOfKindCash = 0;
  TotalStraightFlushCash = 0;
  TotalNaturalRoyalCash = 0;
  TotalWildRoyalCash = 0;
  TotalFiveOfKindCash = 0;
  TotalFourDeuceCash = 0;
  #if defined(ACVP_COMPILE)
  Pair6 = 0;
  PairJacks = 0;
  PairKings = 0;
  ThreeOfKinds5 = 0;
  ThreeOfKinds8 = 0;
  FlushDiamond = 0;
  FlushHeart = 0;
  FlushSpade = 0;
  FlushClub = 0;
  FlushAssault = 0;
  FourOfKinds5 = 0;
  FourOfKinds8 = 0;
  FourOfKinds7 = 0;
  FourOfKinds2_10 = 0;
  FourOfKindsFaces = 0;
  FourOfKindsFacesWAceOrFace = 0;
  FourOfKindsFacesWAce = 0;
  FourOfKindsAcesWFace = 0;
  FourOfKinds4_K = 0;
  FourOfKinds5_K = 0;
  FourOfKinds2_4 = 0;
  FourOfKindsAces = 0;
  StraightFlushesDiamond = 0;
  StraightFlushesHeart = 0;
  StraightFlushesSpade = 0;
  StraightFlushesClub = 0;
  RoyalFlushesHeart = 0;
  RoyalFlushesDiamond = 0;
  RoyalFlushesSpade = 0;
  RoyalFlushesClub = 0;
  FiveOfKinds6_K = 0;
  FiveOfKinds3_5 = 0;
  FiveOfKindsAces = 0;
  FourOfKinds2WAce = 0;
  FourOfKinds7WJoker = 0;
  FiveOfKindsJoker = 0;
  TotalPair6Cash = 0;
  TotalPairJacksCash = 0;
  TotalPairKingsCash = 0;
  TotalThreeOfKinds5Cash = 0;
  TotalThreeOfKinds8Cash = 0;
  TotalFlushDiamondCash = 0;
  TotalFlushHeartCash = 0;
  TotalFlushSpadeCash = 0;
  TotalFlushClubCash = 0;
  TotalFlushAssaultCash = 0;
  TotalFourOfKinds5Cash = 0;
  TotalFourOfKinds8Cash = 0;
  TotalFourOfKinds7Cash = 0;
  TotalFourOfKinds2_10Cash = 0;
  TotalFourOfKindsFacesCash = 0;
  TotalFourOfKindsFacesWAceOrFaceCash = 0;
  TotalFourOfKindsFacesWAceCash = 0;
  TotalFourOfKindsAcesWFaceCash = 0;
  TotalFourOfKinds4_KCash = 0;
  TotalFourOfKinds5_KCash = 0;
  TotalFourOfKinds2_4Cash = 0;
  TotalFourOfKindsAcesCash = 0;
  TotalStraightFlushesDiamondCash = 0;
  TotalStraightFlushesHeartCash = 0;
  TotalStraightFlushesSpadeCash = 0;
  TotalStraightFlushesClubCash = 0;
  TotalRoyalFlushesHeartCash = 0;
  TotalRoyalFlushesDiamondCash = 0;
  TotalRoyalFlushesSpadeCash = 0;
  TotalRoyalFlushesClubCash = 0;
  TotalFiveOfKinds6_KCash = 0;
  TotalFiveOfKinds3_5Cash = 0;
  TotalFiveOfKindsAcesCash = 0;
  TotalFourOfKinds2WAceCash = 0;
  TotalFourOfKinds7WJokerCash = 0;
  TotalFiveOfKindsJokerCash = 0;
  #endif
}
//*******************************************************************
void TCVPSession::StartSession(TMoney startingcash,int16 subgametype,TMoney denom)
{
  ClearData();
  TCasinoSession::StartSession(startingcash,subgametype,denom);
}
//*******************************************************************
void TCVPSession::EndSession(TMoney endingcash)
{
  TCasinoSession::EndSession(endingcash);
}
//*******************************************************************
//*******************************************************************
void TCasinoVPData::IncCurrentSession()
{
  if (CurrentSession == 0 && !Sessions[0].Valid)
  {
    CurrentSession = 0;
    return;
  }
  CurrentSession++;
  if (CurrentSession >= NUMSESSIONS) {CurrentSession = 0;}
}
//*******************************************************************
int16 TCasinoVPData::GetFirstValidSession()
{
  // Sanity check on CurrentSession.
  if ((CurrentSession < 0) || (CurrentSession >= NUMSESSIONS)) {SessionIterator = -1;}
  else {SessionIterator = CurrentSession;}

  if (SessionIterator == -1) {return SessionIterator;}

  // Validity check on current session.
  if (!Sessions[SessionIterator].Valid)
  {
    SessionIterator = -1;
    return SessionIterator;
  }
  // currents session is valid, so start looping from current session to find oldest session.
  for (SessionIterator++;SessionIterator<NUMSESSIONS;SessionIterator++)
  {
    if (Sessions[SessionIterator].Valid) {return SessionIterator;}
  }
  if (CurrentSession == 0) // we already checked all sessions and didn't find a valid one.
  {
    if (Sessions[0].Valid) {SessionIterator = 0;}
    else {SessionIterator = -1;}
    return SessionIterator;
  }

  for (SessionIterator = 0;SessionIterator < CurrentSession;SessionIterator++)
  {
    if (Sessions[SessionIterator].Valid) {return SessionIterator;}
  }
  SessionIterator = -1;
  return SessionIterator;
}
//*******************************************************************
int16 TCasinoVPData::GetNextValidSession()
{
  // check if already found last valid session.
  if (SessionIterator == -1) {return SessionIterator;}
  // go to next session.
  SessionIterator++;
  // check for wraparound.
  if (SessionIterator >= NUMSESSIONS) {SessionIterator = 0;}
  // check if we went all the way around to beginning.
  if (SessionIterator == CurrentSession)
  {
    SessionIterator = -1;
    return CurrentSession;
  }
  // validity check on session.
  if (!Sessions[SessionIterator].Valid)
  {
    SessionIterator = -1;
    return SessionIterator;
  }
  return SessionIterator;
}
//*******************************************************************
int16 TCasinoVPData::GetPrevValidSession()
{
  int16 prevsession = CurrentSession;
  prevsession--;
  if (prevsession <= 0) {prevsession = NUMSESSIONS - 1;}
  if (!Sessions[prevsession].Valid) {return -1;}
  return prevsession;
}
//*******************************************************************
void TCasinoVPData::StartSession(TMoney startingcash,int16 subgametype,TMoney denom)
{
  IncCurrentSession();
  Sessions[CurrentSession].StartSession(startingcash,subgametype,denom);
}
//*******************************************************************
void TCasinoVPData::EndSession(TMoney endingcash)
{
  Sessions[CurrentSession].EndSession(endingcash);
}
//*******************************************************************
TCasinoVPData::TCasinoVPData()
{
  ClearData();
}
//*******************************************************************
void TCasinoVPData::ClearData()
{
  TCasinoData::ClearData();
  Cumulative = 0;
  for (int i = 0;i<NUMSESSIONS;i++)
  {
	 Sessions[i].ClearData();
  }
}
//*******************************************************************