//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  cvpjpsp.cpp
//    Project Name:  Casino
// Original Author:  Adam Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     7/19/96    M.Perry     moved into cpp file.
//  2.0    09/25/97    M.Perry     32-bit conversion.
//********************************************************************
#include "cvpjpsp.h"
#include "oanm.h"
//*******************************************************************
TVPProgressive::TVPProgressive(TOgleModeWindow *pmw,const TFileMode &NewFileMode)
:TSprite(pmw,NewFileMode)
{
  SetupAnms();
  ones = 0;
  tens = 0;
  huns = 0;
  thou = 0;
  tenthou = 0;
  penn = 0;
  dime = 0;
  num = 0;
}
//*******************************************************************
TVPProgressive::TVPProgressive(TOgleModeWindow *pmw,const TFileMode &NewFileMode,void *psource)
:TSprite(pmw,NewFileMode,psource)
{
  SetupAnms();
}
//*******************************************************************
TVPProgressive::~TVPProgressive()
{
}
//*******************************************************************
TMoney TVPProgressive::GetNum()
{
  //int32 whatever=num;
  //return whatever/100;
//  return ((int32)num)/100;
  TMoney m(num);
  m /= 100;
  int32 x = (int32)m;
  return TMoney(x);
}
//*******************************************************************
void TVPProgressive::SetupAnms()
{
	 PProgressive[0] = GetAnm(0);
	 PProgressive[1] = GetAnm(1);
	 PProgressive[2] = GetAnm(2);
	 PProgressive[3] = GetAnm(3);
	 PProgressive[4] = GetAnm(4);
	 PProgressive[5] = GetAnm(5);
	 PProgressive[6] = GetAnm(6);

	 for (int16 j=0;j<7;j++)
	 {
		if (PProgressive[j] == NULL) {AnmError("Progressive","num",j);}
	 }

	 for (int16 i=0;i<7;i++)
	 {
		PProgressive[i]->CAD.ClearAutoStart();
		PProgressive[i]->CAD.ClearAutoStop();
		PProgressive[i]->CAD.SetDirStill();
	 }
}
//*******************************************************************
void TVPProgressive::SetNum(TMoney pro)
{
	// int32 pro = (int32)pro;
	// int32 Num = (int32)num;
	int32 Num = (pro*100)+penn+(dime*10);
	 Num++;
    num = Num;
	 if (PProgressive[0] == NULL) {return;}
	 if (PProgressive[1] == NULL) {return;}
	 if (PProgressive[2] == NULL) {return;}
	 if (PProgressive[3] == NULL) {return;}
	 if (PProgressive[4] == NULL) {return;}
	 if (PProgressive[5] == NULL) {return;}
	 if (PProgressive[6] == NULL) {return;}

	 penn    = Num % 10;
	 dime    = (Num / 10  ) % 10;
	 ones    = (Num / 100 ) % 10;
	 tens    = (Num / 1000) % 10;
	 huns    = (Num / 10000) % 10;
	 thou    = (Num / 100000l) % 10;
	 tenthou = (Num / 1000000l) % 10;
	 PProgressive[0]->CAD.SetCurrentFrame(int16(penn));
	 PProgressive[1]->CAD.SetCurrentFrame(int16(dime));
	 PProgressive[2]->CAD.SetCurrentFrame(int16(ones));
	 PProgressive[3]->CAD.SetCurrentFrame(int16(tens));
	 PProgressive[4]->CAD.SetCurrentFrame(int16(huns));
	 PProgressive[5]->CAD.SetCurrentFrame(int16(thou));
	 PProgressive[6]->CAD.SetCurrentFrame(int16(tenthou));
}
//*******************************************************************
