//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  cvpwrsp.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     7/19/96    M.Perry     moved into cpp file.
//  2.0    09/25/97    M.Perry     32-bit conversion.
//********************************************************************
#include "cvpwrsp.h"
#include "oanm.h"
//*******************************************************************
void TVPWinRatio::SetupAnms()
{
  for(int16 i=0;i<5;i++)   
  {
	 PWinRatio[i] = GetAnm(i);
	 if (PWinRatio[i] == NULL) {AnmError("WinRatio","Bar",i);}
	 PWinRatio[i]->CAD.ClearAutoStart();
	 PWinRatio[i]->CAD.ClearAutoStop();
	 PWinRatio[i]->CAD.SetDirStill();;
  }
}
//*******************************************************************
TVPWinRatio::TVPWinRatio(TOgleModeWindow *pmw,const TFileMode &NewFileMode)
:TSprite(pmw,NewFileMode)
{
  NoShow();
  SetToManual();
  SetupAnms();
}
//*******************************************************************
TVPWinRatio::TVPWinRatio(TOgleModeWindow *pmw,const TFileMode &NewFileMode,void *psource)
:TSprite(pmw,NewFileMode,psource)
{
  NoShow();
  SetToManual();
  SetupAnms();
}
//*******************************************************************
TVPWinRatio::~TVPWinRatio()
{
}
//*******************************************************************
void TVPWinRatio::ClearColumn()
{
  for(int16 i=0;i<5;i++)
  {
	 if (PWinRatio[i] == NULL) {return;}
	 PWinRatio[i]->CAD.SetCurrentFrame(0);
	 PWinRatio[i]->CAD.SetEndFrame(0);
	 PWinRatio[i]->Show();
  }
  Update(GetAdjFUC());
}
//*******************************************************************
void TVPWinRatio::SetColumn(int16 num)
{
  for(int16 i=0;i<5;i++)
  {
    PWinRatio[i]->NoShow();
  }
  if (PWinRatio[num] == NULL) {return;}
  PWinRatio[num]->Show();
  Update(GetAdjFUC());
}
//*******************************************************************
