//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  dw100spl.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0    09/25/97    M.Perry    32-bit conversion.
//********************************************************************
#include "dw100spl.h"
//*******************************************************************
TDW100SpriteList::TDW100SpriteList(TOgleModeWindow *pmw,const TFileMode &filemode,TGameObject *PGObj)
:TVPGLordSpriteList(pmw,filemode,PGObj)
{
  Init(filemode,true,false);
}
//*******************************************************************
TDW100SpriteList::~TDW100SpriteList()
{
}
//*******************************************************************
TSprite *TDW100SpriteList::CreateSprite(string spritename,int16 id,void *psource)
{
  TFileMode FM(spritename,fm_None,fm_None,FileMode.DirIndex);
  if (psource == NULL)
  {
    FM.SetRamImmed();
	 if (spritename == GetResString(IDS_MS_SOUNDS_VP_DW100))
	 {
		return (new TVPSound(PModeWin,FM));
	 }
	 if (spritename == GetResString(IDS_MS_VERTLITE_VP_DW100))
	 {
		return (new TVPVertLite(PModeWin,FM));
	 }
	 if (spritename == GetResString(IDS_MS_DRAWBACK_VP_DW100))
	 {
		return (new TVPDrawBack(PModeWin,FM));
	 }
	 if (spritename == GetResString(IDS_MS_COINPAY_VP_DW100))
	 {
		return (new TVPCoinPay(PModeWin,FM));
	 }
	 if (spritename == GetResString(IDS_MS_CHIPS_VP_DW100))
	 {
		return (new TCasChips(PModeWin,FM));
	 }
	 if (spritename == GetResString(IDS_MS_CARD1_VP_DW100))
	 {
		return (new TVPCard(PModeWin,FM));
	 }
	 if (spritename == GetResString(IDS_MS_CARD2_VP_DW100))
	 {
		return (new TVPCard(PModeWin,FM));
	 }
	 if (spritename == GetResString(IDS_MS_CARD3_VP_DW100))
	 {
		return (new TVPCard(PModeWin,FM));
	 }
	 if (spritename == GetResString(IDS_MS_CARD4_VP_DW100))
	 {
		return (new TVPCard(PModeWin,FM));
	 }
	 if (spritename == GetResString(IDS_MS_CARD5_VP_DW100))
	 {
		return (new TVPCard(PModeWin,FM));
	 }
	 if (spritename == GetResString(IDS_MS_NP1_VP_DW100))
	 {
		return (new TCasNamePlate(PModeWin,FM));
	 }
	 if (spritename == GetResString(IDS_MS_NP2_VP_DW100))
	 {
		return (new TCasNamePlate(PModeWin,FM));
	 }
	 if (spritename == GetResString(IDS_MS_NP3_VP_DW100))
	 {
		return (new TCasNamePlate(PModeWin,FM));
	 }
	 if (spritename == GetResString(IDS_MS_COINSPLAYED_VP_DW100))
	 {
		return (new TVPCoinsPlayed(PModeWin,FM));
	 }
	 if (spritename == GetResString(IDS_MS_CREDITS_VP_DW100))
	 {
		return (new TVPCredits(PModeWin,FM));
	 }
	 if (spritename == GetResString(IDS_MS_WINPAID_VP_DW100))
	 {
		return (new TVPWinPaid(PModeWin,FM));
	 }
	 if (spritename == GetResString(IDS_MS_B0_VP_DW100))
	 {
		return (new TCasButton(PModeWin,FM,(TCasinoGameLord *)POwnerGObj,100,TRect(1,430,50,479),idButton0,true,'x'));
	 }
	 if (spritename == GetResString(IDS_MS_B1_VP_DW100))
	 {
		return (new TCasButton(PModeWin,FM,(TCasinoGameLord *)POwnerGObj,100,TRect(170,430,219,479),idButton1,true));
	 }
	 if (spritename == GetResString(IDS_MS_B2_VP_DW100))
	 {
		return (new TCasButton(PModeWin,FM,(TCasinoGameLord *)POwnerGObj,100,TRect(223,464,258,479),idButton2,true));
	 }
	 if (spritename == GetResString(IDS_MS_B3_VP_DW100))
	 {
		return (new TCasButton(PModeWin,FM,(TCasinoGameLord *)POwnerGObj,100,TRect(376,464,412,479),idButton3,true));
	 }
	 if (spritename == GetResString(IDS_MS_B4_VP_DW100))
	 {
		return (new TCasButton(PModeWin,FM,(TCasinoGameLord *)POwnerGObj,125,TRect(416,430,468,479),idButton4,true,'c'));
	 }
	 if (spritename == GetResString(IDS_MS_B5_VP_DW100))
	 {
		return (new TCasButton(PModeWin,FM,(TCasinoGameLord *)POwnerGObj,125,TRect(470,430,522,479),idButton5,true,'b'));
	 }
	 if (spritename == GetResString(IDS_MS_B6_VP_DW100))
	 {
		return (new TCasButton(PModeWin,FM,(TCasinoGameLord *)POwnerGObj,125,TRect(533,430,585,479),idButton6,true,'m'));
	 }
	 if (spritename == GetResString(IDS_MS_B7_VP_DW100))
	 {
		return (new TCasButton(PModeWin,FM,(TCasinoGameLord *)POwnerGObj,125,TRect(587,432,639,478),idButton7,true,'d'));
	 }
	 if (spritename == GetResString(IDS_MS_B8_VP_DW100))
	 {
		return (new TCasButton(PModeWin,FM,(TCasinoGameLord *)POwnerGObj,100,TRect(587,432,639,478),idButton8,true,'w'));
	 }
	 if (spritename == GetResString(IDS_MS_WINRATIO_VP_DW100))
	 {
		return (new TVPWinRatio(PModeWin,FM));
	 }
	 if (spritename == GetResString(IDS_MS_BANKCASH_VP_DW100))//PCasNames->StatusBarName)
	 {
		return (new TCasCashDisplay(PModeWin,FM));
	 }
	 return (new TSprite(PModeWin,FM));
  }
  else
  {
    if (spritename == GetResString(IDS_MS_VERTLITE_VP_DW100))
	 {
		return (new TVPVertLite(PModeWin,FM,psource));
	 }
	 if (spritename == GetResString(IDS_MS_SOUNDS_VP_DW100))
	 {
		return (new TVPSound(PModeWin,FM,psource));
	 }
	 if (spritename == GetResString(IDS_MS_DRAWBACK_VP_DW100))
	 {
		return (new TVPDrawBack(PModeWin,FM,psource));
	 }
	 if (spritename == GetResString(IDS_MS_COINPAY_VP_DW100))
	 {
		return (new TVPCoinPay(PModeWin,FM,psource));
	 }
	 if (spritename == GetResString(IDS_MS_CHIPS_VP_DW100))
	 {
		return (new TCasChips(PModeWin,FM,psource));
	 }
	 if (spritename == GetResString(IDS_MS_CARD1_VP_DW100))
	 {
		return (new TVPCard(PModeWin,FM,psource));
	 }
	 if (spritename == GetResString(IDS_MS_CARD2_VP_DW100))
	 {
		return (new TVPCard(PModeWin,FM,psource));
	 }
	 if (spritename == GetResString(IDS_MS_CARD3_VP_DW100))
	 {
		return (new TVPCard(PModeWin,FM,psource));
	 }
	 if (spritename == GetResString(IDS_MS_CARD4_VP_DW100))
	 {
		return (new TVPCard(PModeWin,FM,psource));
	 }
	 if (spritename == GetResString(IDS_MS_CARD5_VP_DW100))
	 {
		return (new TVPCard(PModeWin,FM,psource));
	 }
	 if (spritename == GetResString(IDS_MS_NP1_VP_DW100))
	 {
		return (new TCasNamePlate(PModeWin,FM,psource));
	 }
	 if (spritename == GetResString(IDS_MS_NP2_VP_DW100))
	 {
		return (new TCasNamePlate(PModeWin,FM,psource));
	 }
	 if (spritename == GetResString(IDS_MS_NP3_VP_DW100))
	 {
		return (new TCasNamePlate(PModeWin,FM,psource));
	 }
	 if (spritename == GetResString(IDS_MS_COINSPLAYED_VP_DW100))
	 {
		return (new TVPCoinsPlayed(PModeWin,FM,psource));
	 }
	 if (spritename == GetResString(IDS_MS_CREDITS_VP_DW100))
	 {
		return (new TVPCredits(PModeWin,FM,psource));
	 }
	 if (spritename == GetResString(IDS_MS_WINPAID_VP_DW100))
	 {
		return (new TVPWinPaid(PModeWin,FM,psource));
	 }
	 if (spritename == GetResString(IDS_MS_B0_VP_DW100))
	 {
		return (new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,100,TRect(1,430,50,479),idButton0,true,'x'));
	 }
	 if (spritename == GetResString(IDS_MS_B1_VP_DW100))
	 {
		return (new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,100,TRect(170,430,219,479),idButton1,true));
	 }
	 if (spritename == GetResString(IDS_MS_B2_VP_DW100))
	 {
		return (new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,100,TRect(223,464,258,479),idButton2,true));
	 }
	 if (spritename == GetResString(IDS_MS_B3_VP_DW100))
	 {
		return (new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,100,TRect(376,464,412,479),idButton3,true));
	 }
	 if (spritename == GetResString(IDS_MS_B4_VP_DW100))
	 {
		return (new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,125,TRect(416,430,468,479),idButton4,true,'c'));
	 }
	 if (spritename == GetResString(IDS_MS_B5_VP_DW100))
	 {
		return (new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,125,TRect(470,430,522,479),idButton5,true,'b'));
	 }
	 if (spritename == GetResString(IDS_MS_B6_VP_DW100))
	 {
		return (new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,125,TRect(533,430,585,479),idButton6,true,'m'));
	 }
	 if (spritename == GetResString(IDS_MS_B7_VP_DW100))
	 {
		return (new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,125,TRect(587,432,639,478),idButton7,true,'d'));
	 }
	 if (spritename == GetResString(IDS_MS_B8_VP_DW100))
	 {
		return (new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,100,TRect(587,432,639,478),idButton8,true,'w'));
	 }
	 if (spritename == GetResString(IDS_MS_WINRATIO_VP_DW100))
	 {
		return (new TVPWinRatio(PModeWin,FM,psource));
	 }
	 if (spritename == GetResString(IDS_MS_BANKCASH_VP_DW100))//PCasNames->StatusBarName)
	 {
		return (new TCasCashDisplay(PModeWin,FM,psource));
	 }
	 return (new TSprite(PModeWin,FM,psource));
  }
}
//*******************************************************************