//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  vpdealst.cpp
//    Project Name:  Casino
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     09/29/95   A. Krist    Original baseline
//  2.0     09/25/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "vpdealst.h"
#include "otimers.h"
#include "cvpplay.h"
#include "casvpmw.h"
#include "hand.h"
//*******************************************************************
//TVPDealState::TVPDealState(TCasinoVPGameLord *pNewVPLord)
TVPDealState::TVPDealState(TACCVPGLord *pNewVPLord)
:TVPLordState(pNewVPLord)
{
  StartingFUC = 0;
}
//*******************************************************************
TVPDealState::~TVPDealState()
{
}
//*******************************************************************
void TVPDealState::ExecuteFirstTime()
{
  ExecuteWaiting = true;
  ExecuteStatus    = ess_Execute;
  pOwnerLord->pDeck->FirstDeal();
  for (int16 i=0;i<5;i++)
  {
    pOwnerLord->CardSprites[i]->Hold(false);
    pOwnerLord->CardSprites[i]->ShowFlip();
  }
  StartingFUC = pOwnerLord->GetAdjFUC();
}
//*******************************************************************
void TVPDealState::HandlePostUpdate(dword NewFUC)
{
  if (StartingFUC == 0) {return;}

  if ((StartingFUC + 1) == NewFUC)
  {
    for (int16 i=0;i<5;i++)
    {
      pOwnerLord->CardSprites[i]->ShowBack();
    }
  }
  else if ((StartingFUC + 2) == NewFUC)
  {
	 pOwnerLord->CardSprites[0]->ShowFlip();
	 pOwnerLord->VPSounds->PlaySound(31);
  }
  else if ((StartingFUC + 3) == NewFUC)
  {
    pOwnerLord->CardSprites[0]->ShowFace(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->cards[0].suit,
         pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->cards[0].name);
  }
  else if ((StartingFUC + 5) == NewFUC)
  {
	 pOwnerLord->CardSprites[1]->ShowFlip();
	 pOwnerLord->VPSounds->PlaySound(32);
  }
  else if ((StartingFUC + 6) == NewFUC)
  {
    pOwnerLord->CardSprites[1]->ShowFace(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->cards[1].suit,
         pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->cards[1].name);
  }
  else if ((StartingFUC + 8) == NewFUC)
  {
	 pOwnerLord->CardSprites[2]->ShowFlip();
	 pOwnerLord->VPSounds->PlaySound(33);
  }
  else if ((StartingFUC + 9) == NewFUC)
  {
    pOwnerLord->CardSprites[2]->ShowFace(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->cards[2].suit,
         pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->cards[2].name);
  }
  else if ((StartingFUC + 11) == NewFUC)
  {
	 pOwnerLord->CardSprites[3]->ShowFlip();
	 pOwnerLord->VPSounds->PlaySound(34);
  }
  else if ((StartingFUC + 12) == NewFUC)
  {
    pOwnerLord->CardSprites[3]->ShowFace(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->cards[3].suit,
         pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->cards[3].name);
  }
  else if ((StartingFUC + 14) == NewFUC)
  {
	 pOwnerLord->CardSprites[4]->ShowFlip();
	 pOwnerLord->VPSounds->PlaySound(35);
  }
  else if ((StartingFUC + 15) == NewFUC)
  {
     pOwnerLord->CardSprites[4]->ShowFace(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->cards[4].suit,
         pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->cards[4].name);
  }
  else if (NewFUC >= (StartingFUC + 16))
  {
    ExecuteWaiting = false;
  }
}
//*******************************************************************

