//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  vpwinst.cpp
//    Project Name:  Casino
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     09/29/95   A. Krist    Original baseline
//  2.0     09/25/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "vpwinst.h"
#include "otimers.h"
#include "orespond.h"
//*******************************************************************
//TVPWinState::TVPWinState(TCasinoVPGameLord *pNewVPLord)
TVPWinState::TVPWinState(TACCVPGLord *pNewVPLord)
:TVPLordState(pNewVPLord)
{
  wincount   = 0;
  SpeedClickResponder = NULL;
  wincountup = 0;
}
//*******************************************************************
TVPWinState::~TVPWinState()
{
}
//*******************************************************************
void TVPWinState::ExecuteFirstTime()
{
  ExecuteWaiting = true;
  ExecuteStatus    = ess_Execute;
  wincount = pOwnerLord->Winner();
  if((int32)wincount)
  {
	 pOwnerLord->Button4->ShowVoidUp();
  }
  pOwnerLord->WinPaid->SetNum(0);
  pOwnerLord->Credits->SetNum(pOwnerLord->credits);
}
//*******************************************************************
void TVPWinState::HandlePostUpdate(dword NewFUC)
{
  if (SpeedClickResponder != NULL)
  {
	 if (SpeedClickResponder->GetResponseEvent() != reChar)
	 {
		SpeedClickResponder->ClearPriority();
	 }
	 wincountup += wincount;
	 pOwnerLord->credits += wincount;
	 wincount = 0;
	 pOwnerLord->WinPaid->SetNum(wincountup);
	 pOwnerLord->Credits->SetNum(pOwnerLord->credits);
	 ExecuteWaiting = false;
	 pOwnerLord->Button5->ShowVoidUp();
	 pOwnerLord->Button6->ShowVoidUp();
	 pOwnerLord->Button7->ShowGray();
	 SpeedClickResponder = NULL;
	 return;
  }
  if (wincount > 0)
  {
	 if(wincount < pOwnerLord->coinsplayed)
	 {
		wincountup          += wincount;
		pOwnerLord->credits += wincount;
		wincount             = 0;
	 }
	 else
	 {
		wincount   -= pOwnerLord->coinsplayed;
		wincountup += pOwnerLord->coinsplayed;
		pOwnerLord->credits += pOwnerLord->coinsplayed;
	 }
	 pOwnerLord->WinPaid->SetNum(wincountup);
	 pOwnerLord->Credits->SetNum(pOwnerLord->credits);
  }
  else
  {
	 ExecuteWaiting = false;
	 pOwnerLord->Button5->ShowVoidUp();
	 pOwnerLord->Button6->ShowVoidUp();
	 pOwnerLord->Button7->ShowGray();

  }
  if(NewFUC){return;}
}
//*******************************************************************
bool TVPWinState::HandleSpeedClick(TResponder &responder)
{
  if (responder.GetResponseEvent() == reRUp)
  {
	 SpeedClickResponder = &responder;
  }

  if (responder.GetResponseEvent() == reRDown)
  {
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
	 SpeedClickResponder = &responder;
  }
  return true;
}
//*******************************************************************

