//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  acvpcdsp.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0    12/23/95    M.Perry    moved inline functions into .cpp file.
//  2.0    09/02/97    M.Perry    32-bit conversion.
//********************************************************************
#include "acvpcdsp.h"
#include "oanm.h"
#include <assert.h>
//*******************************************************************
TACCasCashDisplay::TACCasCashDisplay(TOgleModeWindow *pmw,TFileMode NewFileMode,void *psource)
  :TSprite(pmw,NewFileMode,psource)
{
  NoShow();
  SetToManual();
  SetupAnms();
  DelayEndFUC = 0;
  DELAY = false;
}
//*******************************************************************
TACCasCashDisplay::TACCasCashDisplay(TOgleModeWindow *pmw,TFileMode NewFileMode)
:TSprite(pmw,NewFileMode)
{
  NoShow();
  SetToManual();
  SetupAnms();
  DelayEndFUC = 0;
  DELAY = false;
}
//********************************************************************
TACCasCashDisplay::~TACCasCashDisplay()
{
}
//*******************************************************************
void TACCasCashDisplay::Update(dword NewFUC)
{
  if(DELAY)
  {
	 if(DelayEndFUC<=NewFUC)
	 {
		DELAY = false;
		DelayEndFUC = 0;
	 }
  }
  TSprite::Update(NewFUC);
}
//*******************************************************************
#pragma argsused
void TACCasCashDisplay::ShowMessageString(string str,long fuclen,int OffSet)
{
}
//*******************************************************************
#pragma argsused
void TACCasCashDisplay::ShowWinNum(TMoney money,long fuclen)
{
}
//*******************************************************************
#pragma argsused
void TACCasCashDisplay::ShowCashOut(TMoney money,long fuclen)
{
}
//*******************************************************************
#pragma argsused
void TACCasCashDisplay::ShowBetNum(TMoney money,long fuclen)
{
}
//*******************************************************************
#pragma argsused
void TACCasCashDisplay::NoShowDisplay(BOOL back)
{
}
//*******************************************************************
void TACCasCashDisplay::SetupAnms()
{
  int j=0;
  for(j=0;j<17;j++)
  {
    PDigits[16-j] = GetAnm(j);
	 PDigits[16-j]->CAD.ClearAutoStart();
	 PDigits[16-j]->CAD.ClearAutoStop();
	 PDigits[16-j]->CAD.SetDirStill();
	 assert(PDigits[16-j]);
  }
}
//*******************************************************************
#pragma argsused
int TACCasCashDisplay::SetNum(TMoney money,long fuclen)
{
  long num = (long)money;       //4.3 billion limit
  int framesused=10,i=0;
  bool found=false;
  long billion=0;
  long hunmill=0;
  long tenmill=0;
  long million=0;
  long hunthou=0;
  long tenthou=0;
  long thousan=0;
  long hun=0;
  long ten=0;
  long one=0;

  for(i=0;i<17;i++)
  {
	 PDigits[i]->CAD.SetX(PDigits[i]->SAD.GetX());
	 PDigits[i]->CAD.SetCurrentFrame(0);
	 PDigits[i]->NoShow();
  }
  PDigits[0]->CAD.SetCurrentFrame(int16(money.GetCents()%10));
  PDigits[0]->Show();
  PDigits[1]->CAD.SetCurrentFrame(int16(money.GetCents()/10));
  PDigits[1]->Show();
  PDigits[2]->CAD.SetCurrentFrame(12);
  PDigits[2]->Show();


  billion = (num/1000000000l) %10;
  if(!billion && !found){framesused--;}else{found=true;}

  hunmill = (num/100000000l) %10;
  if(!million && !found){framesused--;}else{found=true;}

  tenmill = (num/10000000l) %10;
  if(!million && !found){framesused--;}else{found=true;}

  million = (num/1000000l) %10;
  if(!million && !found){framesused--;}else{found=true;}

  hunthou = (num/100000l)  %10;
  if(!hunthou && !found){framesused--;}else{found=true;}

  tenthou = (num/10000)   %10;
  if(!tenthou && !found){framesused--;}else{found=true;}

  thousan = (num/1000)    %10;
  if(!thousan && !found){framesused--;}else{found=true;}

  hun     = (num/100)     %10;
  if(!hun && !found)    {framesused--;}else{found=true;}

  ten     = (num/10)      %10;
  if(!ten && !found)    {framesused--;}else{found=true;}

  one     = (num  )       %10;
  if(!one && !found)    {framesused--;}else{found=true;}

  if(framesused == 0)
  {
	 PDigits[3]->CAD.SetCurrentFrame(0);
    PDigits[3]->Show();
    //PDigits[4]->CAD.SetX(int16(PDigits[6]->SAD.GetX()+3));
    PDigits[4]->CAD.SetCurrentFrame(10);
    PDigits[4]->Show();
  }
  else if(framesused > 9)
  {
    PDigits[14]->CAD.SetCurrentFrame(11);
    PDigits[14]->Show();
    //PDigits[framesused+6]->CAD.SetX(int16(PDigits[framesused+3]->SAD.GetX()+3));
    PDigits[framesused+6]->CAD.SetCurrentFrame(10);
    PDigits[framesused+6]->Show();
  }
  else if(framesused > 6)
  {
    PDigits[10]->CAD.SetCurrentFrame(11);
    PDigits[10]->Show();
    //PDigits[framesused+5]->CAD.SetX(int16(PDigits[framesused+3]->SAD.GetX()+3));
    PDigits[framesused+5]->CAD.SetCurrentFrame(10);
    PDigits[framesused+5]->Show();
  }
  else if(framesused > 3)
  {
	 PDigits[6]->CAD.SetCurrentFrame(11);
    PDigits[6]->Show();
  //  PDigits[framesused+4]->CAD.SetX(int16(PDigits[framesused+3]->SAD.GetX()+3));
    PDigits[framesused+4]->CAD.SetCurrentFrame(10);
    PDigits[framesused+4]->Show();
  }
  else if(framesused > 0)
  {
    //PDigits[framesused+3]->CAD.SetX(int16(PDigits[framesused+3]->SAD.GetX()+3));
    PDigits[framesused+3]->CAD.SetCurrentFrame(10);
    PDigits[framesused+3]->Show();
  }

 // for(i=0;i<10;i++)
  //{
	// PDigits[i]->CAD.SetX(int16(PDigits[i]->CAD.GetX()-((6-(framesused/2))*8)));
 // }

  if(framesused > 0)
  {
    PDigits[3]->CAD.SetCurrentFrame(int16(one));
	 PDigits[3]->Show();
  }
  if(framesused > 1)
  {
	 PDigits[4]->CAD.SetCurrentFrame(int16(ten));
	 PDigits[4]->Show();
  }
  if(framesused > 2)
  {
	 PDigits[5]->CAD.SetCurrentFrame(int16(hun));
	 PDigits[5]->Show();
  }
  if(framesused > 3)
  {
	 PDigits[7]->CAD.SetCurrentFrame(int16(thousan));
	 PDigits[7]->Show();
  }
  if(framesused > 4)
  {
	 PDigits[8]->CAD.SetCurrentFrame(int16(tenthou));
	 PDigits[8]->Show();
  }
  if(framesused > 5)
  {
	 PDigits[9]->CAD.SetCurrentFrame(int16(hunthou));
	 PDigits[9]->Show();
  }
  if(framesused > 6)
  {
	 PDigits[11]->CAD.SetCurrentFrame(int16(million));
	 PDigits[11]->Show();
  }
  if(framesused > 7)
  {
	 PDigits[12]->CAD.SetCurrentFrame(int16(tenmill));
	 PDigits[12]->Show();
  }
  if(framesused > 8)
  {
	 PDigits[13]->CAD.SetCurrentFrame(int16(hunmill));
	 PDigits[13]->Show();
  }
  if(framesused > 9)
  {
	 PDigits[15]->CAD.SetCurrentFrame(int16(billion));
	 PDigits[15]->Show();
  }

  Update(GetAdjFUC());
  return framesused;
}
//*******************************************************************
