//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  acvpcost.cpp
//    Project Name:  Casino
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     09/29/95   A. Krist    Original baseline
//  2.0     09/25/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "acvpcost.h"
#include "cvpplay.h"
#include "casvpmw.h"
#include "orespond.h"
#include "owav.h"
#include "oanm.h"
//*******************************************************************
TACVPCashOutState::TACVPCashOutState(TACVPVPGLord *pNewVPLord)
:TVPLordState(pNewVPLord)
{
  SpeedClickResponder = NULL;
  Count = 0;
  FrameCount = 0;
  Start16 = false;
}
//*******************************************************************
TACVPCashOutState::~TACVPCashOutState()
{
}
//*******************************************************************
void TACVPCashOutState::ExecuteFirstTime()
{
  ExecuteWaiting = true;
  ExecuteStatus    = ess_Execute;
  pOwnerLord->CashOut();
  if(pOwnerLord->credits > 0)
  {
	 switch((long)pOwnerLord->credits)
	 {
		case 1  : pOwnerLord->CoinPay->CoinSound(0);FrameCount = 4;break;
		case 2  : pOwnerLord->CoinPay->CoinSound(1);FrameCount = 5;break;
		case 3  : pOwnerLord->CoinPay->CoinSound(2);FrameCount = 6;break;
		case 4  : pOwnerLord->CoinPay->CoinSound(3);FrameCount = 7;break;
		case 5  : pOwnerLord->CoinPay->CoinSound(4);FrameCount = 8;break;
		default : pOwnerLord->CoinPay->CoinSound(5);Start16 = true;break;
	 }
  }
}
//*******************************************************************
void TACVPCashOutState::HandlePostUpdate(dword NewFUC)
{
  if (SpeedClickResponder != NULL)
  {
	 if (SpeedClickResponder->GetResponseEvent() != reChar)
	 {
		SpeedClickResponder->ClearPriority();
	 }
	 if (pOwnerLord->credits > 0)
	 {
		pOwnerLord->CoinPay->SetTray(pOwnerLord->credits-1+Count);
		pOwnerLord->AddCash(pOwnerLord->activeplayer,pOwnerLord->coinsize*pOwnerLord->credits);
		pOwnerLord->credits = 0;
		pOwnerLord->Credits->SetNum(pOwnerLord->credits);
		pOwnerLord->CoinPay->StopAllSounds();
	 }
	 SpeedClickResponder = NULL;
	 ExecuteWaiting = false;
	 pOwnerLord->CoinPay->PlayRegSound();
	 return;
  }

  if (pOwnerLord->credits > 0 && ExecuteWaiting) //???
  {
	 Count++;
	 pOwnerLord->CoinPay->SetTray(int16(Count-1));
	 if(pOwnerLord->CoinPay->IsStopped(5) && Start16)
	 {
		pOwnerLord->CoinPay->CoinSound(5);
	 }
	 pOwnerLord->credits--;
	 pOwnerLord->AddCash(pOwnerLord->activeplayer,pOwnerLord->coinsize);
	 pOwnerLord->Credits->SetNum(pOwnerLord->credits);
  }
  else if(ExecuteWaiting && FrameCount <= 0)//???
  {
	 pOwnerLord->CoinPay->StopAllSounds();
	 ExecuteWaiting = false;
	 pOwnerLord->CoinPay->PlayRegSound();
  }
  FrameCount--;
  if(NewFUC){return;}
}
//*******************************************************************
bool TACVPCashOutState::HandleSpeedClick(TResponder &responder)
{
  if (responder.GetResponseEvent() == reRUp)
  {
	 SpeedClickResponder = &responder;
  }

  if (responder.GetResponseEvent() == reRDown)
  {
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
	 SpeedClickResponder = &responder;
  }
  return true;
}
//*******************************************************************

