//*******************************************************************
#include "acvpddst.h"
#include "acvpglrd.h"
#include "otimers.h"
#include "cvpplay.h"
#include "casvpmw.h"
#include "hand.h"
#include "orespond.h"
#include "owav.h"

//*******************************************************************
TACVPDoubleState::TACVPDoubleState(TACVPVPGLord *pNewVPLord)
:TVPLordState(pNewVPLord)
{
}
//*******************************************************************
TACVPDoubleState::~TACVPDoubleState()
{
}
//*******************************************************************
void TACVPDoubleState::ExecuteFirstTime()
{
  ExecuteWaiting = true;
  ExecuteStatus    = ess_Execute;
  pOwnerLord->pDeck->FirstDeal();
  pOwnerLord->CardSprite->PFlipSound[0]->Start();
  for (int16 i=0;i<5;i++)
  {
    pOwnerLord->CardSprite->Hold(false,i);
    pOwnerLord->CardSprite->ShowSilentFlip(i);
    pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->hold[i] = 0;
  }

  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->hold[0] = 1;
  StartingFUC = pOwnerLord->GetAdjFUC();
  NextCardNum = 1;
  NextFUC = 1;
  FirstFlip = true;
  Flipping = false;
  CardPicked = false;
  heldCardShow = false;
  heldNum = 0;
}
//*******************************************************************
void TACVPDoubleState::HandlePostUpdate(dword NewFUC)
{
  if(FirstFlip)
  {
    if ((StartingFUC + 1) == NewFUC)
    {
      for (int16 i=0;i<5;i++)
      {
        pOwnerLord->CardSprite->ShowBack(i);
      }
    }
    else if ((StartingFUC + 2) == NewFUC)
    {
  	   pOwnerLord->CardSprite->ShowFlip(0);
    }
    else if ((StartingFUC + 3) == NewFUC)
    {
      pOwnerLord->CardSprite->ShowFace(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->cards[0].suit,
       pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->cards[0].name,0);
      FirstFlip = false;
      for(int16 i=2;i<6;i++)
      {
	     pOwnerLord->Responders[i]->Add();
      }
    }
  }
  if(heldCardShow)
  {
    ExecuteWaiting = false;
    pOwnerLord->CardSprite->ShowFace(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->cards[heldNum].suit,
       pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->cards[heldNum].name,heldNum);
  }
  if(CardPicked)
  {
   for(int16 i=2;i<6;i++)
   {
	  pOwnerLord->Responders[i]->Remove();
   }
   if ((StartingFUC + NextFUC) == NewFUC)
   {
     if (Flipping)
     {
       int16 i;
       for (i = NextCardNum;i<5;i++)
       {
         if (!pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->hold[i])
         {
           NextCardNum = i;
   		  pOwnerLord->CardSprite->ShowFlip(i);
           NextFUC += 1;
           Flipping = false;
           break;
         }
       }
       if (i >= 5)
       {
         CardPicked = false;
         heldCardShow = true;
         pOwnerLord->CardSprite->ShowFlip(heldNum);
         NextFUC += 1;

         if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->cards[heldNum].name >
            pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->cards[0].name        )
         {
           pOwnerLord->IsDoubleWinner = true;
           pOwnerLord->IsDoubleTie = false;
         }
         else if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->cards[heldNum].name ==
                 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->cards[0].name         )
         {
           pOwnerLord->IsDoubleTie = true;
           pOwnerLord->IsDoubleWinner = false;
         }
         else
         {
           pOwnerLord->IsDoubleWinner = false;
           pOwnerLord->IsDoubleTie = false;
         }
       }
     }
     else
     {
       pOwnerLord->CardSprite->ShowFace(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->cards[NextCardNum].suit,
           pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->cards[NextCardNum].name,NextCardNum);
       NextCardNum++;
       NextFUC += 2;
       Flipping = true;
     }
   }
  }
}
//*******************************************************************
//*******************************************************************
bool TACVPDoubleState::HandleHoldCard1(TResponder &responder)
{
 if(!CardPicked)
 {
  if(responder.GetResponseEvent() == reLDown)
  {
	 responder.SetPriority();
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_PRESSING_FINGER_CURSOR));
	 return true;
  }
  if ((responder.GetResponseEvent() == reLUp    ) ||
		(responder.GetResponseEvent() == reLDblClk) ||
		(responder.GetResponseEvent() == reChar   )   )
  {
	 if(responder.GetIsPriority())
	 {
		responder.ClearPriority();
	 }
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_POINTING_FINGER_CURSOR));
	 if(responder.Contains(responder.GetPoint()) ||
		 responder.GetResponseEvent() == reChar)
	 {
		pOwnerLord->HoldCard(1);
      heldNum = 1;
      CardPicked = true;
      StartingFUC = pOwnerLord->GetAdjFUC();
      Flipping = true;
	 }
  }
 }
  return true;
}
//*******************************************************************
bool TACVPDoubleState::HandleHoldCard2(TResponder &responder)
{
 if(!CardPicked)
 {
  if(responder.GetResponseEvent() == reLDown)
  {
	 responder.SetPriority();
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_PRESSING_FINGER_CURSOR));
	 return true;
  }
  if ((responder.GetResponseEvent() == reLUp    ) ||
		(responder.GetResponseEvent() == reLDblClk) ||
		(responder.GetResponseEvent() == reChar   )   )
  {
	 if(responder.GetIsPriority())
	 {
		responder.ClearPriority();
	 }
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_POINTING_FINGER_CURSOR));
	 if(responder.Contains(responder.GetPoint()) ||
		 responder.GetResponseEvent() == reChar)
	 {
      CardPicked = true;
		pOwnerLord->HoldCard(2);
      heldNum = 2;
      StartingFUC = pOwnerLord->GetAdjFUC();
      Flipping = true;
	 }
  }
 }
  return true;
}
//*******************************************************************
bool TACVPDoubleState::HandleHoldCard3(TResponder &responder)
{
 if(!CardPicked)
 {
  if(responder.GetResponseEvent() == reLDown)
  {
	 responder.SetPriority();
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_PRESSING_FINGER_CURSOR));
	 return true;
  }
  if ((responder.GetResponseEvent() == reLUp    ) ||
		(responder.GetResponseEvent() == reLDblClk) ||
		(responder.GetResponseEvent() == reChar   )   )
  {
	 if(responder.GetIsPriority())
	 {
		responder.ClearPriority();
	 }
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_POINTING_FINGER_CURSOR));
	 if(responder.Contains(responder.GetPoint()) ||
		 responder.GetResponseEvent() == reChar)
	 {
      CardPicked = true;
		pOwnerLord->HoldCard(3);
      heldNum = 3;
      StartingFUC = pOwnerLord->GetAdjFUC();
      Flipping = true;
	 }
  }
 }
  return true;
}
//*******************************************************************
bool TACVPDoubleState::HandleHoldCard4(TResponder &responder)
{
 if(!CardPicked)
 {
  if(responder.GetResponseEvent() == reLDown)
  {
	 responder.SetPriority();
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_PRESSING_FINGER_CURSOR));
	 return true;
  }
  if ((responder.GetResponseEvent() == reLUp    ) ||
		(responder.GetResponseEvent() == reLDblClk) ||
		(responder.GetResponseEvent() == reChar   )   )
  {
	 if(responder.GetIsPriority())
	 {
		responder.ClearPriority();
	 }
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_POINTING_FINGER_CURSOR));
	 if(responder.Contains(responder.GetPoint()) ||
		 responder.GetResponseEvent() == reChar)
	 {
      CardPicked = true;
		pOwnerLord->HoldCard(4);
      heldNum = 4;
//      for (int16 i=0;i<5;i++)
 //     {
  //      if (!pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->hold[i])
   //     {
    //      pOwnerLord->CardSprite->ShowFlip(i);
    //    }
     // }
      StartingFUC = pOwnerLord->GetAdjFUC();
      Flipping = true;
	 }
  }
 }
  return true;
}

