//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  acvpdeck.cpp
//    Project Name:  Ogle
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     06/01/95   A. Krist    Original baseline
//  2.0     09/25/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "acvpdeck.h"
#include <stdlib.h>
#include "acvpglrd.h"
#include "cvpplay.h"
#include "casvpmw.h"
#include "owl\inputdia.h"

//*******************************************************************
TACVPDeck::TACVPDeck(TVideoPokerModeWin *pMWin)
{
  pmwin = pMWin;
  deck = new TCard[58];  //Joker deck
  top  = 0;
}
//*******************************************************************
TACVPDeck::~TACVPDeck()
{
  delete []deck;
  deck = NULL;
  top  = 0;
  pmwin = NULL;
}
//*******************************************************************
int16 TACVPDeck::RemoveJoker()
{
  int JCount=52;
  for(int16 i=0; i < 53; i++)
  {
	 if(deck[i].name == Joker)
	 {
		Swap(i,JCount);JCount++;
      i--;
	 }
  }
  return 1;
}
//*******************************************************************
int16 TACVPDeck::JokerShuffle()
{
  int16 count,x,y;
  count = 1000;

  for(int16 i=0; i < count; i++)
  {
	 x = int16(random(53));
	 y = int16(random(53));
	 Swap(x,y);
  }
  return 1;
}
//*******************************************************************
int16 TACVPDeck::Joker5Shuffle()
{
  int16 count,x,y;
  count = 1000;

  for(int16 i=0; i < count; i++)
  {
	 x = int16(random(57));
	 y = int16(random(57));
	 Swap(x,y);
  }
  return 1;
}
//*******************************************************************
int16 TACVPDeck::InitVPDeck()
{
  for(int16 i=0; i < 4 ;i++)
  {
	 for(int16 j=0; j < 13 ;j++)
	 {
		deck[(i*13)+j].name = (TCardName)(j+1);
		deck[(i*13)+j].suit = (TSuit)i;
	 }
  }
  deck[52].name = Joker;
  deck[52].suit = (TSuit)3;
  deck[53].name = Joker;
  deck[53].suit = (TSuit)3;
  deck[54].name = Joker;
  deck[54].suit = (TSuit)3;
  deck[55].name = Joker;
  deck[55].suit = (TSuit)3;
  deck[56].name = Joker;
  deck[56].suit = (TSuit)3;
  return 1;
}
//*******************************************************************
int16 TACVPDeck::GetActPlayer()
{
  return (((TACVPVPGLord *)(pmwin->GetVPGameLord()))->activeplayer);
}
//*******************************************************************
int16 TACVPDeck::FirstDeal()
{
  top = 0;
  if (((TACVPVPGLord *)pmwin->GetVPGameLord())->SubGameType == cvpDDrawJokerPoker ||
      ((TACVPVPGLord *)pmwin->GetVPGameLord())->SubGameType == cvpJokersWildProg  ||
      ((TACVPVPGLord *)pmwin->GetVPGameLord())->SubGameType == cvpRaiseJokersWild ||
      ((TACVPVPGLord *)pmwin->GetVPGameLord())->SubGameType == cvp7Wild1Joker       )
  {
	 JokerShuffle();
  }
  else if(((TACVPVPGLord *)pmwin->GetVPGameLord())->SubGameType == cvpJumpinJokers)
  {
    Joker5Shuffle();
  }
  else
  {
	 Shuffle();
  }
  #ifdef DEBUGCARD
  for(int16 i=0;i<5;i++)
  {
		pmwin->SetUpdatePause();
		char cardnum[5] = "";
		TInputDialog getcard(pmwin,"","card number",cardnum,5);
		getcard.Execute();
		char cardtype[5] = "";
		TInputDialog getcardtype(pmwin,"","card type",cardtype,5);
		getcardtype.Execute();
		pmwin->ClearUpdatePause();
		pmwin->GetCasPlayer(GetActPlayer())->pHand->cards[i].suit = atoi(cardtype);
		pmwin->GetCasPlayer(GetActPlayer())->pHand->cards[i].name = atoi(cardnum)%15;
		pmwin->GetCasPlayer(GetActPlayer())->pHand->cards[i].updown = Up;
		pmwin->GetCasPlayer(GetActPlayer())->pHand->inhand++;
  }
  #else
  for(int16 j=0;j<5;j++)
  {
	 pmwin->GetCasPlayer(GetActPlayer())->pHand->cards[j] = deck[top++];
	 pmwin->GetCasPlayer(GetActPlayer())->pHand->cards[j].updown = Up;
	 pmwin->GetCasPlayer(GetActPlayer())->pHand->inhand++;
  }
  #endif
  return 1;
}
//*******************************************************************
int16 TACVPDeck::FirstDealTop()
{
  top = 0;
  Shuffle();
  return 1;
}
//*******************************************************************
int16 TACVPDeck::FirstDealMid()
{
  top = 0;
  Shuffle();
  return 1;
}
//*******************************************************************
int16 TACVPDeck::ShowWinner(THand * h)
{
  for(int16 i=0; i < h->inhand ;i++)
  {
	 ShowCard(&h->cards[i]);
  }
  return 1;
}
//*******************************************************************
int16 TACVPDeck::DrawTriple(THand * h)
{
  #ifdef DEBUGCARD
  for(int16 i=0; i < h->inhand ;i++)
  {
	 if(h->hold[i] == 0)
	 {
		pmwin->SetUpdatePause();
		char cardnum[5] = "";
		TInputDialog getcard(pmwin,"","card number",cardnum,5);
		getcard.Execute();
		pmwin->ClearUpdatePause();
      if(atoi(cardnum) == 99)
      {
        h->cards[i].suit = 0;
		  h->cards[i].name = Joker;
      }
      else
      {
		  h->cards[i].suit = atoi(cardnum)/14;
		  h->cards[i].name = atoi(cardnum)%14;
      }
	 }
  }
  #else
  for(int16 i=0; i < h->inhand ;i++)
  {
	 if(pmwin->GetCasPlayer(GetActPlayer())->pHand->hold[i] == 0)
	 {
		h->cards[i] = deck[top++];
		h->cards[i].updown = Up;
	 }
  }
  for(int16 i=0;i<h->inhand;i++)
  {
    if(pmwin->GetCasPlayer(GetActPlayer())->pHand->hold[i] == 1)
	 {
      for(int16 j=0;j<h->inhand;j++)
      {
		  if(i!=j && h->cards[i].name == h->cards[j].name &&
           h->cards[i].suit == h->cards[j].suit           )
        {
          h->cards[j] = deck[top++];
		    h->cards[j].updown = Up;
        }
      }
	 }
  }
  #endif
  return 1;
}
//*******************************************************************
int16 TACVPDeck::Draw(THand * h)
{
  #ifdef DEBUGCARD
  for(int16 i=0; i < h->inhand ;i++)
  {
	 if(h->hold[i] == 0)
	 {
		pmwin->SetUpdatePause();
		char cardnum[5] = "";
		TInputDialog getcard(pmwin,"","card number",cardnum,5);
		getcard.Execute();
		pmwin->ClearUpdatePause();
      if(atoi(cardnum) == 99)
      {
        h->cards[i].suit = 0;
		  h->cards[i].name = Joker;
      }
      else
      {
		  h->cards[i].suit = atoi(cardnum)/14;
		  h->cards[i].name = atoi(cardnum)%14;
      }
	 }
  }
  #else
  for(int16 i=0; i < h->inhand ;i++)
  {
	 if(h->hold[i] == 0)
	 {
		h->cards[i] = deck[top++];
		h->cards[i].updown = Up;
	 }
  }
  #endif
  return 1;
}
//*******************************************************************
