//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  acvpdlst.cpp
//    Project Name:  Casino
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     09/29/95   A. Krist    Original baseline
//  2.0     09/25/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "acvpdlst.h"
#include "otimers.h"
#include "cvpplay.h"
#include "casvpmw.h"
#include "hand.h"
#include "owav.h"
//*******************************************************************
TACVPDealState::TACVPDealState(TACVPVPGLord *pNewVPLord)
:TVPLordState(pNewVPLord)
{
  StartingFUC = 0;
}
//*******************************************************************
TACVPDealState::~TACVPDealState()
{
}
//*******************************************************************
void TACVPDealState::ExecuteFirstTime()
{
  ExecuteWaiting = true;
  ExecuteStatus    = ess_Execute;
  pOwnerLord->pDeck->FirstDeal();
  if(pOwnerLord->SubGameType == cvpTriplePlay)
  {
    pOwnerLord->pTopDeck->FirstDealTop();
    pOwnerLord->pMidDeck->FirstDealMid();
    pOwnerLord->TripTopHand->inhand = 5;
    pOwnerLord->TripMidHand->inhand = 5;
  }
  pOwnerLord->CardSprite->PFlipSound[0]->Start();
  for (int16 i=0;i<5;i++)
  {
    pOwnerLord->CardSprite->Hold(false,i);
    pOwnerLord->CardSprite->ShowSilentFlip(i);
    if(pOwnerLord->SubGameType == cvpTriplePlay)
    {
      pOwnerLord->TopCardSprite->ShowSilentFlip(i);
      pOwnerLord->MidCardSprite->ShowSilentFlip(i);
    }
  }
  if(pOwnerLord->SubGameType == cvpFreeLook)
  {
    pOwnerLord->Look->ShowFlip();
  }
  StartingFUC = pOwnerLord->GetAdjFUC();
}
//*******************************************************************
void TACVPDealState::HandlePostUpdate(dword NewFUC)
{
  if (StartingFUC == 0) {return;}

  if ((StartingFUC + 1) == NewFUC)
  {
    for (int16 i=0;i<5;i++)
    {
      pOwnerLord->CardSprite->ShowBack(i);
      if(pOwnerLord->SubGameType == cvpTriplePlay)
      {
        pOwnerLord->TopCardSprite->ShowBack(i);
        pOwnerLord->MidCardSprite->ShowBack(i);
      }
    }
    if(pOwnerLord->SubGameType == cvpFreeLook)
    {
      pOwnerLord->Look->ShowBack();
    }
  }
  else if ((StartingFUC + 2) == NewFUC)
  {
	 pOwnerLord->CardSprite->ShowFlip(0);
//???	 pOwnerLord->VPSounds->PlaySound(31);
  }
  else if ((StartingFUC + 3) == NewFUC)
  {
    pOwnerLord->CardSprite->ShowFace(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->cards[0].suit,
         pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->cards[0].name,0);
  }
  else if ((StartingFUC + 5) == NewFUC)
  {
	 pOwnerLord->CardSprite->ShowFlip(1);
//???	 pOwnerLord->VPSounds->PlaySound(32);
  }
  else if ((StartingFUC + 6) == NewFUC)
  {
    pOwnerLord->CardSprite->ShowFace(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->cards[1].suit,
         pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->cards[1].name,1);
  }
  else if ((StartingFUC + 8) == NewFUC)
  {
	 pOwnerLord->CardSprite->ShowFlip(2);
	 //???pOwnerLord->VPSounds->PlaySound(33);
  }
  else if ((StartingFUC + 9) == NewFUC)
  {
    pOwnerLord->CardSprite->ShowFace(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->cards[2].suit,
         pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->cards[2].name,2);
  }
  else if ((StartingFUC + 11) == NewFUC)
  {
	 pOwnerLord->CardSprite->ShowFlip(3);
  }
  else if ((StartingFUC + 12) == NewFUC)
  {
    pOwnerLord->CardSprite->ShowFace(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->cards[3].suit,
         pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->cards[3].name,3);
  }
  else if ((StartingFUC + 14) == NewFUC)
  {
    if(pOwnerLord->SubGameType == cvpDDownStud)
    {
      ExecuteWaiting = false;
    }
    else
    {
	   pOwnerLord->CardSprite->ShowFlip(4);
    }
  }
  else if ((StartingFUC + 15) == NewFUC)
  {
     pOwnerLord->CardSprite->ShowFace(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->cards[4].suit,
         pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->cards[4].name,4);
  }
  else if (NewFUC >= (StartingFUC + 16))
  {
    if(pOwnerLord->SubGameType == cvpFreeLook)
    {
      if ((StartingFUC + 17) == NewFUC)
      {
        pOwnerLord->Look->ShowFlip();
      }
      else if((StartingFUC + 18) == NewFUC)
      {
        pOwnerLord->Look->ShowFace(pOwnerLord->pDeck->deck[pOwnerLord->pDeck->top].suit,
             pOwnerLord->pDeck->deck[pOwnerLord->pDeck->top].name);
      }
      else if (NewFUC >= (StartingFUC + 19))
      {
        ExecuteWaiting = false;
      }
    }
    else
    {
      ExecuteWaiting = false;
    }
  }
}
//*******************************************************************

