//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  acvpdwst.cpp
//    Project Name:  Casino
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     09/29/95   A. Krist    Original baseline
//  2.0     09/25/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "acvpdtst.h"
#include "acvpglrd.h"
#include "otimers.h"
#include "cvpplay.h"
#include "casvpmw.h"
#include "hand.h"
#include "owav.h"
//*******************************************************************
TACVPTripleDrawState::TACVPTripleDrawState(TACVPVPGLord *pNewVPLord)
:TVPLordState(pNewVPLord)
{
}
//*******************************************************************
TACVPTripleDrawState::~TACVPTripleDrawState()
{
}
//*******************************************************************
void TACVPTripleDrawState::ExecuteFirstTime()
{
  TopHand=true;
  MidHand=false;
  BotHand= false;
  ExecuteWaiting = true;
  ExecuteStatus    = ess_Execute;
  pOwnerLord->pDeck->Draw(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand);
  pOwnerLord->pTopDeck->DrawTriple(pOwnerLord->TripTopHand);
  pOwnerLord->pMidDeck->DrawTriple(pOwnerLord->TripMidHand);
  pOwnerLord->CardSprite->PFlipSound[0]->Start();
  for (int16 i=0;i<5;i++)
  {
    if (!pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->hold[i])
    {
      pOwnerLord->CardSprite->ShowSilentFlip(i);
      pOwnerLord->TopCardSprite->ShowSilentFlip(i);
      pOwnerLord->MidCardSprite->ShowSilentFlip(i);
    }
  }
  StartingFUC = pOwnerLord->GetAdjFUC();
  NextCardNum = 0;
  NextFUC = 2;
  Flipping = true;
}
//*******************************************************************
void TACVPTripleDrawState::HandlePostUpdate(dword NewFUC)
{
  if ((StartingFUC + 1) == NewFUC)
  {
    for (int16 i=0;i<5;i++)
    {
      if (!pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->hold[i])
      {
        pOwnerLord->CardSprite->ShowBack(i);
        pOwnerLord->TopCardSprite->ShowBack(i);
        pOwnerLord->MidCardSprite->ShowBack(i);
      }
    }
  }
  else if ((StartingFUC + NextFUC) == NewFUC && TopHand)
  {
    if (Flipping)
    {
      int16 i;
      for (i = NextCardNum;i<5;i++)
      {
        if (!pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->hold[i])
        {
          NextCardNum = i;
			 pOwnerLord->TopCardSprite->ShowFlip(i);
          NextFUC += 1;
          Flipping = false;
          break;
        }
      }
      if (i >= 5)
      {
          TopHand = false;
          MidHand = true;
          NextFUC += 1;
          Flipping = true;
           NextCardNum = 0;
      }
    }
    else
    {
      pOwnerLord->TopCardSprite->ShowFace(pOwnerLord->TripTopHand->cards[NextCardNum].suit,
                                          pOwnerLord->TripTopHand->cards[NextCardNum].name,NextCardNum);
      NextCardNum++;
      NextFUC += 2;
      Flipping = true;
    }
  }
  else if ((StartingFUC + NextFUC) == NewFUC && MidHand)
  {
    if (Flipping)
    {
      int16 i;
      for (i = NextCardNum;i<5;i++)
      {
        if (!pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->hold[i])
        {
          NextCardNum = i;
			 pOwnerLord->MidCardSprite->ShowFlip(i);
          NextFUC += 1;
          Flipping = false;
          break;
        }
      }
      if (i >= 5)
      {
          MidHand = false;
          BotHand = true;
           NextFUC += 1;
          Flipping = true;
           NextCardNum = 0;
      }
    }
    else
    {
      pOwnerLord->MidCardSprite->ShowFace(pOwnerLord->TripMidHand->cards[NextCardNum].suit,
                                          pOwnerLord->TripMidHand->cards[NextCardNum].name,NextCardNum);
      NextCardNum++;
      NextFUC += 2;
      Flipping = true;
    }
  }
  else if ((StartingFUC + NextFUC) == NewFUC && BotHand)
  {
    if (Flipping)
    {
      int16 i;
      for (i = NextCardNum;i<5;i++)
      {
        if (!pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->hold[i])
        {
          NextCardNum = i;
			 pOwnerLord->CardSprite->ShowFlip(i);
          NextFUC += 1;
          Flipping = false;
          break;
        }
      }
      if (i >= 5)
      {
          ExecuteWaiting = false;
          BotHand = false;
      }
    }
    else
    {
      pOwnerLord->CardSprite->ShowFace(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->cards[NextCardNum].suit,
         pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->cards[NextCardNum].name,NextCardNum);
      NextCardNum++;
      NextFUC += 2;
      Flipping = true;
    }
  }
}
//*******************************************************************
