//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  acvpjpsp.cpp
//    Project Name:  Casino
// Original Author:  Adam Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     7/19/96    M.Perry     moved into cpp file.
//  2.0    09/25/97    M.Perry     32-bit conversion.
//********************************************************************
#include "acvpjpsp.h"
#include "oanm.h"
//*******************************************************************
TACVPProgressive::TACVPProgressive(TOgleModeWindow *pmw,const TFileMode &NewFileMode)
:TSprite(pmw,NewFileMode)
{
  SetupAnms();
  ones = 0;
  tens = 0;
  huns = 0;
  thou = 0;
  tenthou = 0;
  hunthou = 0;
  million = 0;
  penn = 0;
  dime = 0;
  num = 0;
}
//*******************************************************************
TACVPProgressive::TACVPProgressive(TOgleModeWindow *pmw,const TFileMode &NewFileMode,void *psource)
:TSprite(pmw,NewFileMode,psource)
{
  SetupAnms();
  ones = 0;
  tens = 0;
  huns = 0;
  thou = 0;
  tenthou = 0;
  hunthou = 0;
  million = 0;
  penn = 0;
  dime = 0;
  num = 0;
}
//*******************************************************************
TACVPProgressive::~TACVPProgressive()
{
}
//*******************************************************************
TMoney TACVPProgressive::GetNum()
{
  return num/100;
}
//*******************************************************************
void TACVPProgressive::SetupAnms()
{
	 for(int i=0;i<13;i++)
    {
      PProgressive[i] = GetAnm(i);
      if (PProgressive[i] == NULL) {AnmError("Progressive","num",i);}
      PProgressive[i]->CAD.ClearAutoStart();
		PProgressive[i]->CAD.ClearAutoStop();
		PProgressive[i]->CAD.SetDirStill();
    }
}
//*******************************************************************
void TACVPProgressive::SetNum(TMoney money)
{
	 int32 Num = (int32)num;
	 Num++;
	 for(int i=0;i<13;i++)
    {
      if (PProgressive[i] == NULL) {return;}
    }

	 penn    =  money.GetCents() % 10;
	 dime    = (money.GetCents() / 10);
	 ones    = ((int32)money) % 10;
	 tens    = (((int32)money) / 10) % 10;
	 huns    = (((int32)money) / 100) % 10;
	 thou    = (((int32)money) / 1000) % 10;
	 tenthou = (((int32)money) / 10000l) % 10;
	 hunthou = (((int32)money) / 100000l) % 10;
	 million = (((int32)money) / 1000000l) % 10;

    PProgressive[6]->NoShow();
    PProgressive[2]->NoShow();

	 PProgressive[0]->CAD.SetCurrentFrame(10);
    PProgressive[0]->Show();
	 PProgressive[12]->CAD.SetCurrentFrame(int16(penn));
    PProgressive[12]->Show();
	 PProgressive[11]->CAD.SetCurrentFrame(int16(dime));
    PProgressive[11]->Show();
    PProgressive[10]->CAD.SetCurrentFrame(0);
    PProgressive[10]->Show();
	 PProgressive[9]->CAD.SetCurrentFrame(int16(ones));
    PProgressive[9]->Show();
	 if((int32)money/10)
    {
      PProgressive[8]->CAD.SetCurrentFrame(int16(tens));
      PProgressive[8]->Show();
    }
    else {PProgressive[8]->NoShow();}
	 if((int32)money/100)
    {
      PProgressive[7]->CAD.SetCurrentFrame(int16(huns));
      PProgressive[7]->Show();
    }
	 else {PProgressive[7]->NoShow();}
    if((int32)money/1000)
    {
      PProgressive[6]->CAD.SetCurrentFrame(0);
      PProgressive[6]->Show();
      PProgressive[5]->CAD.SetCurrentFrame(int16(thou));
      PProgressive[5]->Show();
    }
	 else {PProgressive[6]->NoShow();PProgressive[5]->NoShow();}
    if((int32)money/10000l)
    {
      PProgressive[4]->CAD.SetCurrentFrame(int16(tenthou));
      PProgressive[4]->Show();
    }
    else {PProgressive[4]->NoShow();}
    if((int32)money/100000l)
    {
      PProgressive[3]->CAD.SetCurrentFrame(int16(hunthou));
      PProgressive[3]->Show();
    }
    else {PProgressive[3]->NoShow();}
    if((int32)money/1000000l)
    {
      PProgressive[2]->CAD.SetCurrentFrame(0);
      PProgressive[2]->Show();
      PProgressive[1]->CAD.SetCurrentFrame(int16(million));
      PProgressive[1]->Show();
    }
    else {PProgressive[2]->NoShow();PProgressive[1]->NoShow();}
    Update(GetAdjFUC());
}
//*******************************************************************
