//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  vplordst.cpp
//    Project Name:  Ogle
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     06/01/95   A. Krist    Original baseline
//  2.0     09/25/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "acvpldst.h"
#include "acvpglrd.h"
#include <time.h>
//*******************************************************************
TVPLordState::TVPLordState(TACVPVPGLord *pNewVPLord)
{
  pOwnerLord = pNewVPLord;
}
//*******************************************************************
TVPLordState::~TVPLordState()
{
}
//*******************************************************************
void TVPLordState::HandleUpdate(dword NewFUC)
{
  if (pOwnerLord->SubGameType == cvpDeucesWildProg ||
      pOwnerLord->SubGameType == cvpJacksProgII    ||
      pOwnerLord->SubGameType == cvpJokersWildProg ||
      pOwnerLord->SubGameType == cvpTripleProg     ||
      pOwnerLord->SubGameType == cvpRoyalProg      ||
      pOwnerLord->SubGameType == cvpPowerProg        )
  {
	if(NewFUC%3600 == 0)
	{
	  if(random(300) == 1) {pOwnerLord->progressive1 = 4000*pOwnerLord->coinsize;}
	}
	if(pOwnerLord->progressive1 >= 9999995l) {pOwnerLord->progressive1 = 4000*pOwnerLord->coinsize;}
	pOwnerLord->Prog1->SetNum(pOwnerLord->progressive1);
	pOwnerLord->progressive1 += pOwnerLord->ProgressiveIncrement;
   //////////////////////////////////////////////////////////////
   if (pOwnerLord->SubGameType == cvpTripleProg)
   { /////////////////////////////////////////////////////////////////////
     if(NewFUC%3600 == 0)
	  {
	    if(random(300) == 1) {pOwnerLord->progressive2 = 600*pOwnerLord->coinsize;}
	  }
	  if(pOwnerLord->progressive2 >= 9999995l) {pOwnerLord->progressive2 = 600*pOwnerLord->coinsize;}
	  pOwnerLord->Prog2->SetNum(pOwnerLord->progressive2);
	  pOwnerLord->progressive2 += pOwnerLord->ProgressiveIncrement/2;
     ///////////////////////////////////////////////////////////////////
     if(NewFUC%3600 == 0)
	  {
	    if(random(300) == 1) {pOwnerLord->progressive3 = 350*pOwnerLord->coinsize;}
	  }
	  if(pOwnerLord->progressive3 >= 9999995l) {pOwnerLord->progressive3 = 350*pOwnerLord->coinsize;}
	  pOwnerLord->Prog3->SetNum(pOwnerLord->progressive3);
	  pOwnerLord->progressive3 += pOwnerLord->ProgressiveIncrement/3;
   }
   if (pOwnerLord->SubGameType == cvpRoyalProg)
   { /////////////////////////////////////////////////////////////////////
     if(NewFUC%3600 == 0)
	  {
	    if(random(300) == 1) {pOwnerLord->progressive2 = 4000*pOwnerLord->coinsize;}
	  }
	  if(pOwnerLord->progressive2 >= 9999995l) {pOwnerLord->progressive2 = 4000*pOwnerLord->coinsize;}
	  pOwnerLord->Prog2->SetNum(pOwnerLord->progressive2);
	  pOwnerLord->progressive2 += pOwnerLord->ProgressiveIncrement+pOwnerLord->IncAdd2;
     ///////////////////////////////////////////////////////////////////
     if(NewFUC%3600 == 0)
	  {
	    if(random(300) == 1) {pOwnerLord->progressive3 = 4000*pOwnerLord->coinsize;}
	  }
	  if(pOwnerLord->progressive3 >= 9999995l) {pOwnerLord->progressive3 = 4000*pOwnerLord->coinsize;}
	  pOwnerLord->Prog3->SetNum(pOwnerLord->progressive3);
	  pOwnerLord->progressive3 += pOwnerLord->ProgressiveIncrement+pOwnerLord->IncAdd3;
     ////////////////////////////////////////////////////////////////////
     if(NewFUC%3600 == 0)
	  {
	    if(random(300) == 1) {pOwnerLord->progressive4 = 4000*pOwnerLord->coinsize;}
	  }
	  if(pOwnerLord->progressive4 >= 9999995l) {pOwnerLord->progressive4 = 4000*pOwnerLord->coinsize;}
	  pOwnerLord->Prog4->SetNum(pOwnerLord->progressive4);
	  pOwnerLord->progressive4 += pOwnerLord->ProgressiveIncrement+pOwnerLord->IncAdd4;
     ///////////////////////////////////////////////////////////////////////////
   }

  }
  if(pOwnerLord->FlushAssaultOn)
  {
    if(TTime().Seconds() >= pOwnerLord->flushStartTime)
    {
      pOwnerLord->SetFlushAssault();
    }
  }
}
//*******************************************************************
bool TVPLordState::NamePlate(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TVPLordState *)PActiveSubState)->NamePlate(responder);
  }
  else
  {
	 return HandleNamePlate(responder);
  }
}
//*******************************************************************
bool TVPLordState::OneChip(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TVPLordState *)PActiveSubState)->OneChip(responder);
  }
  else
  {
	 return HandleOneChip(responder);
  }
}
//*******************************************************************
bool TVPLordState::FiveChip(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TVPLordState *)PActiveSubState)->FiveChip(responder);
  }
  else
  {
	 return HandleFiveChip(responder);
  }
}
//*******************************************************************
bool TVPLordState::TwentyFiveChip(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TVPLordState *)PActiveSubState)->TwentyFiveChip(responder);
  }
  else
  {
	 return HandleTwentyFiveChip(responder);
  }
}
//*******************************************************************
bool TVPLordState::OneHundredChip(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TVPLordState *)PActiveSubState)->OneHundredChip(responder);
  }
  else
  {
	 return HandleOneHundredChip(responder);
  }
}
//*******************************************************************
bool TVPLordState::OneThouChip(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TVPLordState *)PActiveSubState)->OneThouChip(responder);
  }
  else
  {
	 return HandleOneThouChip(responder);
  }
}
//*******************************************************************
bool TVPLordState::TenThouChip(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TVPLordState *)PActiveSubState)->TenThouChip(responder);
  }
  else
  {
	 return HandleTenThouChip(responder);
  }
}
//*******************************************************************
bool TVPLordState::StatBar(TResponder &responder)
{
  return HandleStatBar(responder);
}
//*******************************************************************
bool TVPLordState::Bet1Button(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
    return ((TVPLordState *)PActiveSubState)->Bet1Button(responder);
  }
  else
  {
    return HandleBet1(responder);
  }
}
//*******************************************************************
bool TVPLordState::MenuEscButton(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TVPLordState *)PActiveSubState)->MenuEscButton(responder);
  }
  else
  {
	 return HandleMenuEsc(responder);
  }
}
//*******************************************************************
bool TVPLordState::SpeedClick(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TVPLordState *)PActiveSubState)->SpeedClick(responder);
  }
  else
  {
	 return HandleSpeedClick(responder);
  }
}
//*******************************************************************
bool TVPLordState::BetMaxButton(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
    return ((TVPLordState *)PActiveSubState)->BetMaxButton(responder);
  }
  else
  {
    return HandleBetMax(responder);
  }
}
//*******************************************************************
bool TVPLordState::CashOut(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
    return ((TVPLordState *)PActiveSubState)->CashOut(responder);
  }
  else
  {
    return HandleCashOut(responder);
  }
}
//*******************************************************************
bool TVPLordState::DealDraw(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
    return ((TVPLordState *)PActiveSubState)->DealDraw(responder);
  }
  else
  {
    return HandleDealDraw(responder);
  }
}
//*******************************************************************
bool TVPLordState::AddCoin(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
    return ((TVPLordState *)PActiveSubState)->AddCoin(responder);
  }
  else
  {
    return HandleAddCoin(responder);
  }
}
//*******************************************************************
bool TVPLordState::AskExpert(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
    return ((TVPLordState *)PActiveSubState)->HandleAskExpert(responder);
  }
  else
  {
    return HandleAskExpert(responder);
  }
}
//*******************************************************************
bool TVPLordState::HoldCard0(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
    return ((TVPLordState *)PActiveSubState)->HoldCard0(responder);
  }
  else
  {
    return HandleHoldCard0(responder);
  }
}
//*******************************************************************
bool TVPLordState::HoldCard1(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
    return ((TVPLordState *)PActiveSubState)->HoldCard1(responder);
  }
  else
  {
    return HandleHoldCard1(responder);
  }
}
//*******************************************************************
bool TVPLordState::HoldCard2(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
    return ((TVPLordState *)PActiveSubState)->HoldCard2(responder);
  }
  else
  {
    return HandleHoldCard2(responder);
  }
}
//*******************************************************************
bool TVPLordState::HoldCard3(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
    return ((TVPLordState *)PActiveSubState)->HoldCard3(responder);
  }
  else
  {
    return HandleHoldCard3(responder);
  }
}
//*******************************************************************
bool TVPLordState::HoldCard4(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
    return ((TVPLordState *)PActiveSubState)->HoldCard4(responder);
  }
  else
  {
    return HandleHoldCard4(responder);
  }
}
//*******************************************************************
#pragma argsused
bool TVPLordState::HandleOneChip(TResponder &responder)
{
  return true;
}
//*******************************************************************
#pragma argsused
bool TVPLordState::HandleFiveChip(TResponder &responder)
{
  return true;
}
//*******************************************************************
#pragma argsused
bool TVPLordState::HandleTwentyFiveChip(TResponder &responder)
{
  return true;
}
//*******************************************************************
#pragma argsused
bool TVPLordState::HandleOneHundredChip(TResponder &responder)
{
  return true;
}
//*******************************************************************
#pragma argsused
bool TVPLordState::HandleOneThouChip(TResponder &responder)
{
  return true;
}
//*******************************************************************
#pragma argsused
bool TVPLordState::HandleTenThouChip(TResponder &responder)
{
  return true;
}
//*******************************************************************
#pragma argsused
bool TVPLordState::HandleSpeedClick(TResponder &responder)
{
  return false;
}
//*******************************************************************
#pragma argsused
bool TVPLordState::HandleMenuEsc(TResponder &responder)
{
  return true;
}
//*******************************************************************
#pragma argsused
bool TVPLordState::HandleBet1(TResponder &responder)
{
  return true;
}
//*******************************************************************
#pragma argsused
bool TVPLordState::HandleBetMax(TResponder &responder)
{
  return true;
}
//*******************************************************************
#pragma argsused
bool TVPLordState::HandleCashOut(TResponder &responder)
{
  return true;
}
//*******************************************************************
#pragma argsused
bool TVPLordState::HandleDealDraw(TResponder &responder)
{
  return true;
}
//*******************************************************************
#pragma argsused
bool TVPLordState::HandleAddCoin(TResponder &responder)
{
  return true;
}
//*******************************************************************
#pragma argsused
bool TVPLordState::HandleAskExpert(TResponder &responder)
{
  return true;
}
//*******************************************************************
#pragma argsused
bool TVPLordState::HandleHoldCard0(TResponder &responder)
{
  pOwnerLord->HoldCard(0);
  return true;
}
//*******************************************************************
#pragma argsused
bool TVPLordState::HandleHoldCard1(TResponder &responder)
{
  pOwnerLord->HoldCard(1);
  return true;
}
//*******************************************************************
#pragma argsused
bool TVPLordState::HandleHoldCard2(TResponder &responder)
{
  pOwnerLord->HoldCard(2);
  return true;
}
//*******************************************************************
#pragma argsused
bool TVPLordState::HandleHoldCard3(TResponder &responder)
{
  pOwnerLord->HoldCard(3);
  return true;
}
//*******************************************************************
#pragma argsused
bool TVPLordState::HandleHoldCard4(TResponder &responder)
{
  pOwnerLord->HoldCard(4);
  return true;
}
//*******************************************************************
#pragma argsused
bool TVPLordState::HandleStatBar(TResponder &responder)
{
  return true;
}
//*******************************************************************
#pragma argsused
bool TVPLordState::HandleNamePlate(TResponder &responder)
{
  if(pOwnerLord->GetNumActivePlayers() > 1)
  {
    return true;
  }
  return true;
}
//*******************************************************************
