//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  acvpwdst.cpp
//    Project Name:  Casino
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     09/29/95   A. Krist    Original baseline
//  2.0     09/25/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "acvpwdst.h"
#include "otimers.h"
#include "orespond.h"
//*******************************************************************
TACVPWinDoubleState::TACVPWinDoubleState(TACVPVPGLord *pNewVPLord)
:TVPLordState(pNewVPLord)
{
  SetRunOrder(ess_Execute,ess_Execute,ess_Done);
  wincount   = 0;
  SpeedClickResponder = NULL;
  wincountup = 0;
  multDelay = 0;
  tempWin = 0;
}
//*******************************************************************
TACVPWinDoubleState::~TACVPWinDoubleState()
{
  if(pOwnerLord->IsDoubleType)
  {
    pOwnerLord->Button8->PButtonResponder->Remove();
    pOwnerLord->Button9->PButtonResponder->Remove();
    pOwnerLord->Button8->NoShow();
    pOwnerLord->Button9->NoShow();
    pOwnerLord->BackG->NoShow();
  }
}
//*******************************************************************
void TACVPWinDoubleState::ExecuteFirstTime()
{
  ExecuteWaiting = true;
  ExecuteStatus    = ess_Execute;
  pOwnerLord->Responders[12]->Add();
  pOwnerLord->PreWinner();
  if(pOwnerLord->SubGameType == cvpWheelDeal ||
     pOwnerLord->SubGameType == cvpTreasureTrove ||
     pOwnerLord->SubGameType == cvpJackpotBonus)
  {
    multDelay = pOwnerLord->SetMult();
  }
  wincount = pOwnerLord->Winner();
  if((int32)wincount)
  {
	 pOwnerLord->Button0->ShowVoidUp();
  }
  pOwnerLord->WinPaid->SetNum(0);
  pOwnerLord->Credits->SetNum(pOwnerLord->credits);
  if(pOwnerLord->IsDoubleType && wincount > 0)
  {
    pOwnerLord->Button8->ShowVoidUp();
    pOwnerLord->Button9->ShowVoidUp();
    pOwnerLord->BackG->Show();
    pOwnerLord->WaitOnDoubleDown = true;
    pOwnerLord->Button8->PButtonResponder->Add();
    pOwnerLord->Button9->PButtonResponder->Add();
  }
}
//*******************************************************************
void TACVPWinDoubleState::EndSubState1()
{
  TState::EndSubState1();
  pOwnerLord->UnFreezeAllButtons();
  if(pOwnerLord->IsDoubleWinner)
  {
    ExecuteWaiting = true;
    wincountup *= 2;
    pOwnerLord->WinPaid->SetNum(wincountup);
    pOwnerLord->Button8->PlayChime();
  }
  else if(pOwnerLord->IsDoubleTie)
  {
    ExecuteWaiting = true;
  }
  else
  {
    pOwnerLord->WinPaid->SetNum(0);
    pOwnerLord->Button1->ShowVoidUp();
    pOwnerLord->Button2->ShowVoidUp();
    pOwnerLord->Button3->ShowGray();
    ExecuteWaiting = false;
  }
}
//*******************************************************************
void TACVPWinDoubleState::CreateSubState1()
{
  PActiveSubState = new TACVPDoubleState(pOwnerLord);
}
//*******************************************************************
void TACVPWinDoubleState::HandlePostUpdate(dword NewFUC)
{
    if(multDelay)
    {
      multDelay--;
      return;
    }
    if (SpeedClickResponder != NULL)
    {
	   if (SpeedClickResponder->GetResponseEvent() != reChar)
	   {
		  SpeedClickResponder->ClearPriority();
	   }
	   wincountup += wincount;
      pOwnerLord->Button8->Freeze = false;
      pOwnerLord->Button9->Freeze = false;
      wincount = 0;
	   pOwnerLord->WinPaid->SetNum(wincountup);
	   SpeedClickResponder = NULL;
	   //???return;
    }
    if (wincount > 0)
    {
      if(NewFUC%2==0)
      {
        if(NewFUC%4==0)
        {
          pOwnerLord->Title->Show();
        }
        else
        {
          pOwnerLord->Title->NoShow();
        }
      }
	   if(wincount < pOwnerLord->coinsplayed)
	   {
	 	 wincountup          += wincount;
	 	 wincount             = 0;
	   }
	   else
	   {
	   	wincount   -= pOwnerLord->coinsplayed;
	   	wincountup += pOwnerLord->coinsplayed;
	   }
	   pOwnerLord->WinPaid->SetNum(wincountup);
    }
    else
    {
      if(pOwnerLord->WaitOnDoubleDown && wincountup > 0)
      {
        pOwnerLord->Button8->Freeze = false;
        pOwnerLord->Button9->Freeze = false;
        if (pOwnerLord->ButtonHit[idButton8])
        {
		    pOwnerLord->FreezeAllButtons();
		    ExecuteWaiting = false;
		    ExecuteStatus = ess_StartSubState1;
	       pOwnerLord->ButtonClear(idButton8);
	       return;
        }
        if (pOwnerLord->ButtonHit[idButton9])
        {
         //??? ExecuteWaiting = false;
   	    pOwnerLord->Button1->ShowVoidUp();
   	    pOwnerLord->Button2->ShowVoidUp();
   	    pOwnerLord->Button3->ShowGray();
          pOwnerLord->WaitOnDoubleDown = false;
	       pOwnerLord->ButtonClear(idButton9);
          pOwnerLord->WinPaid->SetNum(wincountup);
          pOwnerLord->Button8->PlayChime();
	       return;
        }
      }
      else if(wincountup > 0)
      {
        pOwnerLord->credits += wincountup;
        pOwnerLord->Credits->SetNum(pOwnerLord->credits);
        ExecuteWaiting = false;
   	  pOwnerLord->Button1->ShowVoidUp();
   	  pOwnerLord->Button2->ShowVoidUp();
   	  pOwnerLord->Button3->ShowGray();
        return;
      }
      else
      {
        ExecuteWaiting = false;
   	  pOwnerLord->Button1->ShowVoidUp();
   	  pOwnerLord->Button2->ShowVoidUp();
   	  pOwnerLord->Button3->ShowGray();
        return;
      }
    }
  if(NewFUC){return;}
}
//*******************************************************************
bool TACVPWinDoubleState::HandleSpeedClick(TResponder &responder)
{
  if (responder.GetResponseEvent() == reRUp)
  {
	 SpeedClickResponder = &responder;
  }

  if (responder.GetResponseEvent() == reRDown)
  {
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
	 SpeedClickResponder = &responder;
  }
  return true;
}
//*******************************************************************