//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  acvpwnst.cpp
//    Project Name:  Casino
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     09/29/95   A. Krist    Original baseline
//  2.0     09/25/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "acvpwnst.h"
#include "otimers.h"
#include "orespond.h"
//*******************************************************************
TACVPWinNormalState::TACVPWinNormalState(TACVPVPGLord *pNewVPLord)
:TVPLordState(pNewVPLord)
{
  SetRunOrder(ess_Execute,ess_Execute,ess_Done);
  wincount   = 0;
  SpeedClickResponder = NULL;
  wincountup = 0;
  multDelay = 0;
  tempWin = 0;
}
//*******************************************************************
TACVPWinNormalState::~TACVPWinNormalState()
{
  if(pOwnerLord->IsDoubleType)
  {
    pOwnerLord->Button8->PButtonResponder->Remove();
    pOwnerLord->Button9->PButtonResponder->Remove();
    pOwnerLord->Button8->NoShow();
    pOwnerLord->Button9->NoShow();
    pOwnerLord->BackG->NoShow();
  }
}
//*******************************************************************
void TACVPWinNormalState::ExecuteFirstTime()
{
  ExecuteWaiting = true;
  ExecuteStatus    = ess_Execute;
  pOwnerLord->Responders[12]->Add();
  pOwnerLord->PreWinner();
  if(pOwnerLord->SubGameType == cvpWheelDeal ||
     pOwnerLord->SubGameType == cvpTreasureTrove ||
     pOwnerLord->SubGameType == cvpJackpotBonus)
  {
    multDelay = pOwnerLord->SetMult();
  }
  wincount = pOwnerLord->Winner();
  if((int32)wincount)
  {
	 pOwnerLord->Button0->ShowVoidUp();
  }
  pOwnerLord->WinPaid->SetNum(0);
  pOwnerLord->Credits->SetNum(pOwnerLord->credits);
  if(pOwnerLord->SubGameType == cvpSuperDJackpot)
  {
    if(pOwnerLord->DoGrid())
    {
      pOwnerLord->ActivateSpriteNow(pOwnerLord->GridWin);
      multDelay = 18;
      pOwnerLord->WinPaid->SetNum(250);
    }
  }
  if(pOwnerLord->IsDoubleType && wincount > 0)
  {
    pOwnerLord->Button8->ShowVoidUp();
    pOwnerLord->Button9->ShowVoidUp();
    pOwnerLord->BackG->Show();
    pOwnerLord->WaitOnDoubleDown = true;
    pOwnerLord->Button8->PButtonResponder->Add();
    pOwnerLord->Button9->PButtonResponder->Add();
  }
}
//*******************************************************************
void TACVPWinNormalState::EndSubState1()
{
  TState::EndSubState1();
  pOwnerLord->UnFreezeAllButtons();
  if(pOwnerLord->IsDoubleWinner)
  {
    ExecuteWaiting = true;
    wincountup *= 2;
    pOwnerLord->WinPaid->SetNum(wincountup);
    pOwnerLord->Button8->PlayChime();
  }
  else if(!pOwnerLord->IsDoubleTie)
  {
    pOwnerLord->WinPaid->SetNum(0);
    pOwnerLord->Button1->ShowVoidUp();
    pOwnerLord->Button2->ShowVoidUp();
    pOwnerLord->Button3->ShowGray();
    ExecuteWaiting = false;
  }
}
//*******************************************************************
void TACVPWinNormalState::CreateSubState1()
{
  PActiveSubState = new TACVPDoubleState(pOwnerLord);
}
//*******************************************************************
void TACVPWinNormalState::HandlePostUpdate(dword NewFUC)
{
  if(multDelay)
  {
    multDelay--;
    if(multDelay <= 0 && pOwnerLord->SubGameType == cvpSuperDJackpot)
    {
      pOwnerLord->ClearRowCol();
      pOwnerLord->credits += 250;
      pOwnerLord->Credits->SetNum(pOwnerLord->credits);
      pOwnerLord->WinPaid->SetNum(0);
    }
    return;
  }
  if(NewFUC%2==0)
  {
    if(NewFUC%4==0)
    {
      pOwnerLord->Title->Show();
    }
    else
    {
      pOwnerLord->Title->NoShow();
    }
  }
  if (SpeedClickResponder != NULL)
  {
    if (SpeedClickResponder->GetResponseEvent() != reChar)
    {
  	   SpeedClickResponder->ClearPriority();
    }
	 wincountup += wincount;
	 pOwnerLord->credits += wincount;
	 wincount = 0;
	 pOwnerLord->WinPaid->SetNum(wincountup);
	 pOwnerLord->Credits->SetNum(pOwnerLord->credits);
	 ExecuteWaiting = false;
	 pOwnerLord->Button1->ShowVoidUp();
	 pOwnerLord->Button2->ShowVoidUp();
	 pOwnerLord->Button3->ShowGray();
	 SpeedClickResponder = NULL;
	 return;
  }
  if (wincount > 0)
  {
	 if(wincount < pOwnerLord->coinsplayed)
	 {
		wincountup          += wincount;
		pOwnerLord->credits += wincount;
		wincount             = 0;
	 }
	 else
	 {
		wincount   -= pOwnerLord->coinsplayed;
		wincountup += pOwnerLord->coinsplayed;
		pOwnerLord->credits += pOwnerLord->coinsplayed;
	 }
	 pOwnerLord->WinPaid->SetNum(wincountup);
	 pOwnerLord->Credits->SetNum(pOwnerLord->credits);
  }
  else
  {
	 ExecuteWaiting = false;
	 pOwnerLord->Button1->ShowVoidUp();
	 pOwnerLord->Button2->ShowVoidUp();
	 pOwnerLord->Button3->ShowGray();

  }
  if(NewFUC){return;}
}
//*******************************************************************
bool TACVPWinNormalState::HandleSpeedClick(TResponder &responder)
{
  if (responder.GetResponseEvent() == reRUp)
  {
	 SpeedClickResponder = &responder;
  }

  if (responder.GetResponseEvent() == reRDown)
  {
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
	 SpeedClickResponder = &responder;
  }
  return true;
}
//*******************************************************************