//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  cvpwrsp.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     7/19/96    M.Perry     moved into cpp file.
//  2.0    09/25/97    M.Perry     32-bit conversion.
//********************************************************************
#include "acvpwrsp.h"
#include "oanm.h"
#include "owav.h"
//*******************************************************************
void TACVPWinRatio::SetupAnms()
{
	 PWinRatio = GetAnm(0);
	 if (PWinRatio == NULL) {AnmError("WinRatio","Bar",0);}
	 PWinRatio->CAD.ClearAutoStart();
	 PWinRatio->CAD.ClearAutoStop();
	 PWinRatio->CAD.SetDirStill();;
    for(int i=0;i<10;i++)
    {
      PWavs[i] = GetWav(i);
      if (PWavs[i] == NULL) {AnmError("WinRatio","wav",i);}
    }
    for(int i=10;i<16;i++)
    {
      PWavs[i] = GetWav(i);
      //if (PWavs[i] == NULL) {AnmError("WinRatio","wav",i);}
    }

}
//*******************************************************************
TACVPWinRatio::TACVPWinRatio(TOgleModeWindow *pmw,const TFileMode &NewFileMode)
:TSprite(pmw,NewFileMode)
{
  NoShow();
  SetToManual();
  SetupAnms();
  startFrame = 0;
}
//*******************************************************************
TACVPWinRatio::TACVPWinRatio(TOgleModeWindow *pmw,const TFileMode &NewFileMode,void *psource)
:TSprite(pmw,NewFileMode,psource)
{
  NoShow();
  SetToManual();
  SetupAnms();
  startFrame = 0;
}
//*******************************************************************
TACVPWinRatio::~TACVPWinRatio()
{
}
//*******************************************************************
void TACVPWinRatio::ClearColumn()
{
  {
	 if (PWinRatio == NULL) {return;}
	 //???PWinRatio->CAD.SetCurrentFrame(0);
	 //???PWinRatio->CAD.SetEndFrame(0);
	 PWinRatio->NoShow();
  }
  Update(GetAdjFUC());
}
//*******************************************************************
void TACVPWinRatio::PlaySound(int num)
{
  PWavs[num]->Start();
  Update(GetAdjFUC());
  //???startFrame = 0;
}
//*******************************************************************
void TACVPWinRatio::PlaySound(int num,int offSet)
{
  PWavs[num]->Start(GetAdjFUC()+offSet);
  Update(GetAdjFUC());
  startFrame = 0;
}
//*******************************************************************
void TACVPWinRatio::PlaySound(int num,bool IsCoin)
{
  if(IsCoin)
  {
    PWavs[num-startFrame]->Start();
  }
  else
  {
    PWavs[num-startFrame]->Start();
  }
  Update(GetAdjFUC());
  startFrame = num+1;
}
//*******************************************************************
void TACVPWinRatio::SetStartFrame(int num)
{
  startFrame = num;
}
//*******************************************************************
void TACVPWinRatio::SetColumn(int16 num)
{
  PWinRatio->NoShow();
  if (PWinRatio == NULL) {return;}
  PWinRatio->CAD.SetCurrentFrame(num-1);
  PWinRatio->Show();
  Update(GetAdjFUC());
}
//*******************************************************************
void TACVPWinRatio::SetColumn(int16 num,bool IsCoin)
{
  PWinRatio->NoShow();
  if (PWinRatio == NULL) {return;}
  PWinRatio->CAD.SetCurrentFrame(num-1);
  PWinRatio->Show();
  PlaySound(num-1,IsCoin);
  Update(GetAdjFUC());
}
//*******************************************************************
