//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  acvpwwst.cpp
//    Project Name:  Casino
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     09/29/95   A. Krist    Original baseline
//  2.0     09/25/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "acvpwwst.h"
#include "otimers.h"
#include "orespond.h"
#include "acvpdwst.h"
//*******************************************************************
TACVPWinDDrawState::TACVPWinDDrawState(TACVPVPGLord *pNewVPLord)
:TVPLordState(pNewVPLord)
{
  SetRunOrder(ess_Execute,ess_Execute,ess_Done);
  wincount   = 0;
  SpeedClickResponder = NULL;
  wincountup = 0;
  multDelay = 0;
  tempWin = 0;
  WaitForDoubleDraw = false;
  IgnoreCoach = false;
  WaitingOnWRCounter = 0;
}
//*******************************************************************
TACVPWinDDrawState::~TACVPWinDDrawState()
{
    pOwnerLord->Button1->SetCurrentGrayFrame(-1);
    pOwnerLord->Button2->SetCurrentGrayFrame(-1);
    pOwnerLord->Button1->SetCurrentUpFrame(0);
    pOwnerLord->Button1->SetCurrentDownFrame(1);
    pOwnerLord->Button2->SetCurrentUpFrame(0);
    pOwnerLord->Button2->SetCurrentDownFrame(1);
    pOwnerLord->Button3->SetCurrentUpFrame(0);
    pOwnerLord->Button3->SetCurrentDownFrame(1);
}
//*******************************************************************
void TACVPWinDDrawState::ExecuteFirstTime()
{
  ExecuteWaiting = true;
  ExecuteStatus    = ess_Execute;

  pOwnerLord->PreWinner();
  wincount = pOwnerLord->Winner();
  if((int32)wincount)
  {
	 pOwnerLord->Button0->ShowVoidUp();
    pOwnerLord->Responders[12]->Add();
  }
  else
  {
    pOwnerLord->Button1->SetCurrentGrayFrame(5);
    pOwnerLord->Button2->SetCurrentGrayFrame(5);
    pOwnerLord->Button1->SetCurrentUpFrame(6);
    pOwnerLord->Button1->SetCurrentDownFrame(7);
    pOwnerLord->Button2->SetCurrentUpFrame(6);
    pOwnerLord->Button2->SetCurrentDownFrame(7);
    pOwnerLord->Button3->SetCurrentUpFrame(6);
    pOwnerLord->Button3->SetCurrentDownFrame(7);
    pOwnerLord->Button2->ShowVoidUp();
    pOwnerLord->Button1->ShowVoidUp();
    pOwnerLord->Button3->ShowVoidUp();
    WaitForDoubleDraw = true;
    pOwnerLord->Button2->Freeze = false;
    pOwnerLord->Button1->Freeze = false;
    pOwnerLord->Button3->Freeze = false;
    for(int16 i=1;i<6;i++)
    {
	   pOwnerLord->Responders[i]->Add();
    }
  }
  pOwnerLord->WinPaid->SetNum(0);
  pOwnerLord->Credits->SetNum(pOwnerLord->credits);
}
//*******************************************************************
void TACVPWinDDrawState::EndSubState1()
{
  TState::EndSubState1();
  ExecuteWaiting = true;
  ExecuteStatus    = ess_Execute;
  WaitForDoubleDraw = false;
  pOwnerLord->ClearHand();
  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->inhand = 5;
  pOwnerLord->PreWinner();
  wincount = pOwnerLord->Winner();
  if((int32)wincount)
  {
	 pOwnerLord->Button0->ShowVoidUp();
    pOwnerLord->Responders[12]->Add();
  }
}
//*******************************************************************
void TACVPWinDDrawState::CreateSubState1()
{
  for(int16 i=1;i<6;i++)
  {
    pOwnerLord->Responders[i]->Remove();
  }
  pOwnerLord->coinsplayed = pOwnerLord->Dcoinsplayed;
  PActiveSubState = new TACVPDrawState(pOwnerLord);
}
//*******************************************************************
void TACVPWinDDrawState::HandlePostUpdate(dword NewFUC)
{
  if(WaitForDoubleDraw)
  {
    if (SpeedClickResponder != NULL)
    {
      SpeedClickResponder = NULL;
    }
    if (pOwnerLord->ButtonHit[idButton1])
    {
	   pOwnerLord->ButtonClear(idButton1);
	   if (pOwnerLord->coinsplayed > pOwnerLord->Dcoinsplayed)
	   {
        pOwnerLord->BetD1();
        if(pOwnerLord->Dcoinsplayed > 0)
        {
          pOwnerLord->Button3->SetCurrentUpFrame(3);
          pOwnerLord->Button3->SetCurrentDownFrame(4);
          pOwnerLord->Button3->ShowVoidUp();
        }
        if(pOwnerLord->Dcoinsplayed == pOwnerLord->coinsplayed)
        {
          pOwnerLord->Button1->ShowGray();
          pOwnerLord->Button2->ShowGray();
        }
	   }
      else
      {
        pOwnerLord->Button1->ShowGray();
        pOwnerLord->Button2->ShowGray();
      }
	   return;
    }
    if (pOwnerLord->ButtonHit[idButton2])
    {
	   pOwnerLord->ButtonClear(idButton2);
	   if (pOwnerLord->coinsplayed > pOwnerLord->Dcoinsplayed)
	   {
        WaitingOnWRCounter = pOwnerLord->BetDMax();
        if(WaitingOnWRCounter > 0)
        {
          pOwnerLord->Button3->Freeze = true;
        }
        if(pOwnerLord->Dcoinsplayed > 0)
        {
          pOwnerLord->Button3->SetCurrentUpFrame(3);
          pOwnerLord->Button3->SetCurrentDownFrame(4);
          pOwnerLord->Button3->ShowVoidUp();
        }
	   }
        pOwnerLord->Button1->ShowGray();
        pOwnerLord->Button2->ShowGray();
	   return;
    }
    if (pOwnerLord->ButtonHit[idButton3])
    {
      pOwnerLord->ButtonClear(idButton3);
      if(pOwnerLord->Dcoinsplayed > 0)
      {

		  pOwnerLord->FreezeAllButtons();
		  ExecuteWaiting = false;
		  ExecuteStatus = ess_StartSubState1;
        WaitForDoubleDraw = false;
		  pOwnerLord->shutdownstate = 1;
	     IgnoreCoach = false;
      }
      else
      {
        ExecuteWaiting = false;
        pOwnerLord->Button1->SetCurrentGrayFrame(-1);
        pOwnerLord->Button2->SetCurrentGrayFrame(-1);
        pOwnerLord->Button1->SetCurrentUpFrame(0);
        pOwnerLord->Button1->SetCurrentDownFrame(1);
        pOwnerLord->Button2->SetCurrentUpFrame(0);
        pOwnerLord->Button2->SetCurrentDownFrame(1);
        pOwnerLord->Button3->SetCurrentUpFrame(0);
        pOwnerLord->Button3->SetCurrentDownFrame(1);
       // pOwnerLord->Button2->ShowVoidUp();
        //pOwnerLord->Button1->ShowVoidUp();
        //pOwnerLord->Button3->ShowGray();
      }
	   return;
    }
    if (WaitingOnWRCounter)
    {
	   pOwnerLord->WinRatio->SetColumn(pOwnerLord->coinsplayed-WaitingOnWRCounter+1);
	   WaitingOnWRCounter--;
      if(WaitingOnWRCounter <= 0)
      {
        pOwnerLord->Button3->Freeze = false;
      }
    }
  }
  else
  {
    if (SpeedClickResponder != NULL)
    {
      if (SpeedClickResponder->GetResponseEvent() != reChar)
      {
  	     SpeedClickResponder->ClearPriority();
      }
	   wincountup += wincount;
	   pOwnerLord->credits += wincount;
	   wincount = 0;
	   pOwnerLord->WinPaid->SetNum(wincountup);
	   pOwnerLord->Credits->SetNum(pOwnerLord->credits);
	   ExecuteWaiting = false;
	   pOwnerLord->Button1->ShowVoidUp();
	   pOwnerLord->Button2->ShowVoidUp();
	   pOwnerLord->Button3->ShowGray();
	   SpeedClickResponder = NULL;
	   return;
    }
    if (wincount > 0)
    {
	   if(NewFUC%2==0)
      {
        if(NewFUC%4==0)
        {
          pOwnerLord->Title->Show();
        }
        else
        {
          pOwnerLord->Title->NoShow();
        }
      }
      if(wincount < pOwnerLord->coinsplayed)
	   {
		  wincountup          += wincount;
		  pOwnerLord->credits += wincount;
		  wincount             = 0;
	   }
	   else
	   {
		  wincount   -= pOwnerLord->coinsplayed;
		  wincountup += pOwnerLord->coinsplayed;
		  pOwnerLord->credits += pOwnerLord->coinsplayed;
	   }
	   pOwnerLord->WinPaid->SetNum(wincountup);
	   pOwnerLord->Credits->SetNum(pOwnerLord->credits);
    }
    else
    {
	   ExecuteWaiting = false;
	   pOwnerLord->Button1->ShowVoidUp();
	   pOwnerLord->Button2->ShowVoidUp();
	   pOwnerLord->Button3->ShowGray();
    }
  }

  if(NewFUC){return;}
}
//*******************************************************************
bool TACVPWinDDrawState::HandleSpeedClick(TResponder &responder)
{
  if (responder.GetResponseEvent() == reRUp)
  {
	 SpeedClickResponder = &responder;
    return true;
  }

  if (responder.GetResponseEvent() == reRDown)
  {
	 responder.SetPriority();
    return true;
  }

  if (responder.GetResponseEvent() == reChar)
  {
	 SpeedClickResponder = &responder;
    return true;
  }
  return false;
}
//*******************************************************************
//*******************************************************************
bool TACVPWinDDrawState::HandleHoldCard0(TResponder &responder)
{
  if(responder.GetResponseEvent() == reLDown)
  {
	 responder.SetPriority();
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_PRESSING_FINGER_CURSOR));
	 return true;
  }
  if ((responder.GetResponseEvent() == reLUp    ) ||
		(responder.GetResponseEvent() == reLDblClk) ||
		(responder.GetResponseEvent() == reChar   )   )
  {
	 if(responder.GetIsPriority())
	 {
		responder.ClearPriority();
	 }
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_POINTING_FINGER_CURSOR));
	 if(responder.Contains(responder.GetPoint()) ||
		 responder.GetResponseEvent() == reChar)
	 {
		pOwnerLord->HoldCard(0);
	 }
  }
  return true;
}
//*******************************************************************
bool TACVPWinDDrawState::HandleHoldCard1(TResponder &responder)
{
  if(responder.GetResponseEvent() == reLDown)
  {
	 responder.SetPriority();
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_PRESSING_FINGER_CURSOR));
	 return true;
  }
  if ((responder.GetResponseEvent() == reLUp    ) ||
		(responder.GetResponseEvent() == reLDblClk) ||
		(responder.GetResponseEvent() == reChar   )   )
  {
	 if(responder.GetIsPriority())
	 {
		responder.ClearPriority();
	 }
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_POINTING_FINGER_CURSOR));
	 if(responder.Contains(responder.GetPoint()) ||
		 responder.GetResponseEvent() == reChar)
	 {
		pOwnerLord->HoldCard(1);
	 }
  }
  return true;
}
//*******************************************************************
bool TACVPWinDDrawState::HandleHoldCard2(TResponder &responder)
{
  if(responder.GetResponseEvent() == reLDown)
  {
	 responder.SetPriority();
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_PRESSING_FINGER_CURSOR));
	 return true;
  }
  if ((responder.GetResponseEvent() == reLUp    ) ||
		(responder.GetResponseEvent() == reLDblClk) ||
		(responder.GetResponseEvent() == reChar   )   )
  {
	 if(responder.GetIsPriority())
	 {
		responder.ClearPriority();
	 }
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_POINTING_FINGER_CURSOR));
	 if(responder.Contains(responder.GetPoint()) ||
		 responder.GetResponseEvent() == reChar)
	 {
		pOwnerLord->HoldCard(2);
	 }
  }
  return true;
}
//*******************************************************************
bool TACVPWinDDrawState::HandleHoldCard3(TResponder &responder)
{
  if(responder.GetResponseEvent() == reLDown)
  {
	 responder.SetPriority();
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_PRESSING_FINGER_CURSOR));
	 return true;
  }
  if ((responder.GetResponseEvent() == reLUp    ) ||
		(responder.GetResponseEvent() == reLDblClk) ||
		(responder.GetResponseEvent() == reChar   )   )
  {
	 if(responder.GetIsPriority())
	 {
		responder.ClearPriority();
	 }
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_POINTING_FINGER_CURSOR));
	 if(responder.Contains(responder.GetPoint()) ||
		 responder.GetResponseEvent() == reChar)
	 {
		pOwnerLord->HoldCard(3);
	 }
  }
  return true;
}
//*******************************************************************
bool TACVPWinDDrawState::HandleHoldCard4(TResponder &responder)
{
  if(responder.GetResponseEvent() == reLDown)
  {
	 responder.SetPriority();
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_PRESSING_FINGER_CURSOR));
	 return true;
  }
  if ((responder.GetResponseEvent() == reLUp    ) ||
		(responder.GetResponseEvent() == reLDblClk) ||
		(responder.GetResponseEvent() == reChar   )   )
  {
	 if(responder.GetIsPriority())
	 {
		responder.ClearPriority();
	 }
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_POINTING_FINGER_CURSOR));
	 if(responder.Contains(responder.GetPoint()) ||
		 responder.GetResponseEvent() == reChar)
	 {
		pOwnerLord->HoldCard(4);
	 }
  }
  return true;
}
//*******************************************************************

