//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  acvplgld.cpp
//    Project Name:  acvp
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  2.5    10/14/99    M.Perry     Original baseline
//*******************************************************************
#include "acvplgld.h"
#include "acvlmst.h"
#include "ostate.h"
#include "caslmw.h"
#include "clplay.h"
#include "expert.h"
#include "cplaymgr.h"
#include "casapp.h"
#include "osndmgr.h"
#include <checks.h>
#include "orespond.h"
#include "oanm.h"
#include "ogamefw.h"
#include "owav.h"
#include "acvpname.rh"
#include "acvp_cm.rh"
#include "cas_cm.rh"

#define MAX_DURATION_SECS ((10 * 60))
#define HALF_DURATION_SECS (MAX_DURATION_SECS / 2)

#if defined(ACVP_QUERY_LOBBY)
  #include <owl\inputdia.h>
#endif
//*******************************************************************
string GetAppString(int16 id)
{
  return TAppString(id);
}
//*******************************************************************
dword TACVPLobbyGameLord::MineSec = 0;
dword TACVPLobbyGameLord::MineDurationSec = 0;
dword TACVPLobbyGameLord::LastLobbyEndSec = 0;
bool TACVPLobbyGameLord::MineOpen = true;
//*******************************************************************
TSprite *TACVPLobbyGameLord::CreateSprite(string spritename,int16 id,void *psource)
{
  TRect r1(20,377,68,400);
  TRect r2(5,464,143,476);
  TRect r3(227,176,272,215);

  TFileMode FM(spritename,
               TFileMode::fm_None,
               TFileMode::fm_None,
               FileMode.GetDirIndex());

  if (psource != NULL)
  {
    switch (id)
	 {
		case  0 : return new TSprite(PModeWin,FM,psource);
      case  1 : PMessageDisplay = new TCasLobbyMessageDisplay(PModeWin,FM,psource);
                return PMessageDisplay;
      case  2 : PNameSprite = new TOgleNameSprite(PModeWin,FM,psource);
                return PNameSprite;
      case  3 : PBankSprite = new TACVPSlotsCashDisplay(PModeWin,FM,psource);
                return PBankSprite;
      case  4 : PMenuEscButton = new TOgleButton(PModeWin,FM,psource,this,100,r1,idButton0,0,1,1,TOgleButton::bsUp);
                return PMenuEscButton;
      case  5 : PGamblerButton = new TOgleButton(PModeWin,FM,psource,this,100,r2,idButton1,0,-1,-1,TOgleButton::bsUp);
                return PGamblerButton;
      case  6 : PGoldPanButton = new TOgleButton(PModeWin,FM,psource,this,100,r3,idButton2,0,-1,-1,TOgleButton::bsUp);
                return PGoldPanButton;
      case  7 : POpenMine = new TSprite(PModeWin,FM,psource);
                return POpenMine;
      case  8 : PCloseMine = new TSprite(PModeWin,FM,psource);
                return PCloseMine;
      case  9 : PResults[0] = new TSprite(PModeWin,FM,psource);
                return PResults[0];
      case 10 : PResults[1] = new TSprite(PModeWin,FM,psource);
                return PResults[1];
      case 11 : PResults[2] = new TSprite(PModeWin,FM,psource);
                return PResults[2];
      case 12 : PResults[3] = new TSprite(PModeWin,FM,psource);
                return PResults[3];
      case 13 : PResults[4] = new TSprite(PModeWin,FM,psource);
                return PResults[4];
      case 14 : PResults[5] = new TSprite(PModeWin,FM,psource);
                return PResults[5];
      case 15 : PResults[6] = new TSprite(PModeWin,FM,psource);
                return PResults[6];
      case 16 : PResults[7] = new TSprite(PModeWin,FM,psource);
                return PResults[7];
      case 17 : PResults[8] = new TSprite(PModeWin,FM,psource);
                return PResults[8];
      case 18 : PResults[9] = new TSprite(PModeWin,FM,psource);
                return PResults[9];
      case 19 : PResults[10] = new TSprite(PModeWin,FM,psource);
                return PResults[10];
      case 20 : PResults[11] = new TSprite(PModeWin,FM,psource);
                return PResults[11];
      case 21 : PResults[12] = new TSprite(PModeWin,FM,psource);
                return PResults[12];
      case 22 : PResults[13] = new TSprite(PModeWin,FM,psource);
                return PResults[13];
      case 23 : PResults[14] = new TSprite(PModeWin,FM,psource);
                return PResults[14];
      case 24 : PResults[15] = new TSprite(PModeWin,FM,psource);
                return PResults[15];
      case 25 : PResults[16] = new TSprite(PModeWin,FM,psource);
                return PResults[16];
      case 26 : PResults[17] = new TSprite(PModeWin,FM,psource);
                return PResults[17];
      case 27 : PResults[18] = new TSprite(PModeWin,FM,psource);
                return PResults[18];
      case 28 : PResults[19] = new TSprite(PModeWin,FM,psource);
                return PResults[19];
      case 29 : PResults[20] = new TSprite(PModeWin,FM,psource);
                return PResults[20];
      case 30 : PResults[21] = new TSprite(PModeWin,FM,psource);
                return PResults[21];
      case 31 : PResults[22] = new TSprite(PModeWin,FM,psource);
                return PResults[22];
      default : return new TSprite(PModeWin,FM,psource);
	 }
  }
  else
  {
	 FM.SetRamImmed();
	 switch (id)
	 {
		case  0 : return new TSprite(PModeWin,FM);
      case  1 : PMessageDisplay = new TCasLobbyMessageDisplay(PModeWin,FM);
                return PMessageDisplay;
      case  2 : PNameSprite = new TOgleNameSprite(PModeWin,FM);
                return PNameSprite;
      case  3 : PBankSprite = new TACVPSlotsCashDisplay(PModeWin,FM);
                return PBankSprite;
      case  4 : PMenuEscButton = new TOgleButton(PModeWin,FM,this,100,r1,idButton0,0,1,1,TOgleButton::bsUp);
                return PMenuEscButton;
      case  5 : PGamblerButton = new TOgleButton(PModeWin,FM,this,100,r2,idButton1,0,-1,-1,TOgleButton::bsUp);
                return PGamblerButton;
      case  6 : PGoldPanButton = new TOgleButton(PModeWin,FM,this,100,r3,idButton2,0,-1,-1,TOgleButton::bsUp);
                return PGoldPanButton;
      case  7 : POpenMine = new TSprite(PModeWin,FM);
                return POpenMine;
      case  8 : PCloseMine = new TSprite(PModeWin,FM);
                return PCloseMine;
      case  9 : PResults[0] = new TSprite(PModeWin,FM);
                return PResults[0];
      case 10 : PResults[1] = new TSprite(PModeWin,FM);
                return PResults[1];
      case 11 : PResults[2] = new TSprite(PModeWin,FM);
                return PResults[2];
      case 12 : PResults[3] = new TSprite(PModeWin,FM);
                return PResults[3];
      case 13 : PResults[4] = new TSprite(PModeWin,FM);
                return PResults[4];
      case 14 : PResults[5] = new TSprite(PModeWin,FM);
                return PResults[5];
      case 15 : PResults[6] = new TSprite(PModeWin,FM);
                return PResults[6];
      case 16 : PResults[7] = new TSprite(PModeWin,FM);
                return PResults[7];
      case 17 : PResults[8] = new TSprite(PModeWin,FM);
                return PResults[8];
      case 18 : PResults[9] = new TSprite(PModeWin,FM);
                return PResults[9];
      case 19 : PResults[10] = new TSprite(PModeWin,FM);
                return PResults[10];
      case 20 : PResults[11] = new TSprite(PModeWin,FM);
                return PResults[11];
      case 21 : PResults[12] = new TSprite(PModeWin,FM);
                return PResults[12];
      case 22 : PResults[13] = new TSprite(PModeWin,FM);
                return PResults[13];
      case 23 : PResults[14] = new TSprite(PModeWin,FM);
                return PResults[14];
      case 24 : PResults[15] = new TSprite(PModeWin,FM);
                return PResults[15];
      case 25 : PResults[16] = new TSprite(PModeWin,FM);
                return PResults[16];
      case 26 : PResults[17] = new TSprite(PModeWin,FM);
                return PResults[17];
      case 27 : PResults[18] = new TSprite(PModeWin,FM);
                return PResults[18];
      case 28 : PResults[19] = new TSprite(PModeWin,FM);
                return PResults[19];
      case 29 : PResults[20] = new TSprite(PModeWin,FM);
                return PResults[20];
      case 30 : PResults[21] = new TSprite(PModeWin,FM);
                return PResults[21];
      case 31 : PResults[22] = new TSprite(PModeWin,FM);
                return PResults[22];
      default : return new TSprite(PModeWin,FM);
	 }
  }
}
//*******************************************************************
void TACVPLobbyGameLord::PlayLobbyGame()
{
  if ((ResultEndFUC != 0) ||
       (GetCash(activeplayer) < GameDenom) ||
       !MineOpen)
  {
    // hit too soon or don't have enough money to play or mine not open
    return;
  }

  int16 ndx = GetWinningReelStop();
  WinningReelStop = ndx;
  if (ndx >= 0 && ndx < NumReelStops)
  {
    SubCash(activeplayer,GameDenom);
    PBankSprite->SetNum(GetCash(activeplayer));
    Winnings = Win[ndx];
    ResultEndFUC = GetAdjFUC() + PResults[ndx]->Get_FUC_Length() - 1;
    if (MineDurationSec > 10)
    {
      MineDurationSec -= 10; //remove 10 seconds from playtime for every play of game.
    }
    ActivateSpriteNow(PResults[ndx]);
    if (PGoldPanButton != NULL)
    {
      PGoldPanButton->ShowGray();
    }
  }
  #if defined(ACVP_DEBUG_LOBBY)
  else
  {
    ::MessageBox(NULL,
                 "didn't find a matching symbol",
                 "Error! Winning Combo",
                 MB_OK | MB_TASKMODAL);
  }
  #endif
}
//*******************************************************************
#pragma argsused
bool TACVPLobbyGameLord::Respond(int16 id,int16 info,void *pdata)
{
  if(info == TOgleButton::bcNone) {return true;}

  switch(id)
  {
    case idButton0  : GetFW()->CmShowMenu();
                      break;
    case idButton1  : PModeWin->PostCommandToFW(CM_FILEGAMBLERMANAGEMENT);
                      break;
    case idButton2  : PlayLobbyGame();
                      break;
  }
  return true;
}
//*******************************************************************
bool TACVPLobbyGameLord::Respond(TResponder &responder)
{
  if (PState == NULL) {return true;}

  // get and stash away.
  int16 id = responder.GetID();

  TResponseEvent re = responder.GetResponseEvent();//reNone;

  if (id == idHotSpot39)
  {
    if (re == reLUp)
    {
      PModeWin->PostCommandToFW(CM_OPTIONS_LOBBY_CASINOCREDIT);
    }
    return true;
  }
  else if (id >= idHotSpot1 && id <= idHotSpotLast)
  {
    if (re == reEnterArea)
    {
      PMessageDisplay->Show();
      PMessageDisplay->ShowLobbyMessage(MsgCodes[id]);
    }
    else if (re == reLeaveArea)
    {
      PMessageDisplay->NoShow();
      GetOgleApp()->GetCursorMgr()->SetCursor(ctAction,0,0);
    }
    else if (re == reLUp)
    {
      int16 command = CmdCodes[id];
      if (command >= 0)
      {
        PModeWin->PostCommandToFW(command);
      }
    }
    return true;
  }

  if (id == idSpeed)
  {
    return true;
  }

  if (id == idButton0)
  {
    return true;
  }

  if (id == idButton1)
  {
    return true;
  }

  //temp until have a button
//  if (id == idButton2 && re == reLUp)
//  {
//    return Respond(idButton2,TOgleButton::bcLeft);
//  }
  if (id == idButton2)
  {
    return true;
  }

  return false;
}
//*******************************************************************
void TACVPLobbyGameLord::SetupResponders()
{
  TRect rects[NumResponders];
  rects[idHotSpot1] = TRect(115,357,184,443); //idHotSpot1
  rects[idHotSpot2] = TRect(203,357,272,443); //idHotSpot2
  rects[idHotSpot3] = TRect(291,357,360,443); //etc.
  rects[idHotSpot4] = TRect(378,357,447,443);
  rects[idHotSpot5] = TRect(466,357,535,443);
  rects[idHotSpot6] = TRect(554,357,623,443);
  rects[idHotSpot7] = TRect(33,232,81,290);
  rects[idHotSpot8] = TRect(85,232,132,290);
  rects[idHotSpot9] = TRect(137,232,185,290);
  rects[idHotSpot10] = TRect(366,270,414,328);
  rects[idHotSpot11] = TRect(424,270,472,328);
  rects[idHotSpot12] = TRect(483,270,531,328);
  rects[idHotSpot13] = TRect(447,208,495,266);
  rects[idHotSpot14] = TRect(499,208,547,266);
  rects[idHotSpot15] = TRect(110,83,141,125);
  rects[idHotSpot16] = TRect(144,83,175,125);
  rects[idHotSpot17] = TRect(177,83,208,125);
  rects[idHotSpot18] = TRect(211,83,242,125);
  rects[idHotSpot19] = TRect(245,83,276,125);
  rects[idHotSpot20] = TRect(278,83,309,125);
  rects[idHotSpot21] = TRect(339,94,370,136);
  rects[idHotSpot22] = TRect(379,94,410,136);
  rects[idHotSpot23] = TRect(419,94,450,136);
  rects[idHotSpot24] = TRect(495,83,526,125);
  rects[idHotSpot25] = TRect(531,83,562,125);
  rects[idHotSpot26] = TRect(568,83,599,125);
  rects[idHotSpot27] = TRect(159,50,184,79);
  rects[idHotSpot28] = TRect(188,50,214,79);
  rects[idHotSpot29] = TRect(218,50,244,79);
  rects[idHotSpot30] = TRect(248,50,274,79);
  rects[idHotSpot31] = TRect(278,50,304,79);
  rects[idHotSpot32] = TRect(308,50,334,79);
  rects[idHotSpot33] = TRect(338,50,364,79);
  rects[idHotSpot34] = TRect(368,50,394,79);
  rects[idHotSpot35] = TRect(398,50,424,79);
  rects[idHotSpot36] = TRect(428,50,454,79);
  rects[idHotSpot37] = TRect(458,50,484,79);
  rects[idHotSpot38] = TRect(488,50,514,79);
  rects[idHotSpot39] = TRect(567,31,624,63);

  TRect rBig(2,2,633,474);

  TCursorData spade_on(GetOgleApp(),ID_SPADE_ON_CURSOR);
  TCursorData spade_off(GetOgleApp(),ID_SPADE_OFF_CURSOR);

  //mrp - temp until rich makes button
//  Responders[0] = new TResponder(PModeWin,100,TRect(227,176,272,215),idButton2,this,true,'~',spade_on,true);

  for (int16 id = idHotSpot1;id <= idHotSpotLast;id++)
  {
    Responders[id] = new TResponder(PModeWin,100,rects[id],id,this,true,'~',spade_on,true);
  }

  Responders[idSpeed] = new TResponder(PModeWin,50,rBig,idSpeed,this,true,'~',spade_off,true);
}
//*******************************************************************
TACVPLobbyGameLord::TACVPLobbyGameLord(TLobbyModeWin *pmwin,const TFileMode &fm,
                                       int16 sgt,int16 did)
:TCasLobbyGameLord(pmwin,fm,sgt,did),
 PBankSprite(NULL),
 PNameSprite(NULL),
 PMessageDisplay(NULL),
 PMenuEscButton(NULL),
 PGamblerButton(NULL),
 PGoldPanButton(NULL),
 BoardsOnFUC(0),
 MinerOnFUC(0),
 POpenMine(NULL),
 PCloseMine(NULL),
 MinerOffFUC(0),
 ResultEndFUC(0),
 Winnings(0.0),
 WinningReelStop(-1)
{
  Chances[0] = 10;
  Chances[1] = 10;
  Chances[2] = 35;
  Chances[3] = 20;
  Chances[4] = 15;
  Chances[5] = 35;
  Chances[6] = 12;
  Chances[7] = 30;
  Chances[8] = 1;
  Chances[9] = 10;
  Chances[10] = 12;
  Chances[11] = 6;
  Chances[12] = 6;
  Chances[13] = 6;
  Chances[14] = 6;
  Chances[15] = 5;
  Chances[16] = 5;
  Chances[17] = 4;
  Chances[18] = 3;
  Chances[19] = 3;
  Chances[20] = 2;
  Chances[21] = 2;
  Chances[22] = 1;

  Win[0] = 0.0;
  Win[1] = 0.0;
  Win[2] = 0.0;
  Win[3] = 0.0;
  Win[4] = 0.0;
  Win[5] = 0.0;
  Win[6] = 0.0;
  Win[7] = 0.0;
  Win[8] = 0.0;
  Win[9] = 50.0;
  Win[10] = 100.0;
  Win[11] = 150.0;
  Win[12] = 150.0;
  Win[13] = 200.0;
  Win[14] = 200.0;
  Win[15] = 300.0;
  Win[16] = 300.0;
  Win[17] = 500.0;
  Win[18] = 750.0;
  Win[19] = 1000.0;
  Win[20] = 2000.0;
  Win[21] = 3000.0;
  Win[22] = 10000.0;

  PState = new TACVPLobbyMainState(this);

  ShuttingDownFlag = false;
  activeplayer = 0;

  SetupResponders();

//initialize arrays
  for (int16 i=0;i<NumResponders;i++)
  {
    MsgCodes[i] = 0;
    CmdCodes[i] = 0;
    Responders[i] = NULL;
  }

  // build hotspot to msg code table for quick lookup in Respond()
  for (int16 i = idHotSpot1;i <= idHotSpotLast;i++)
  {
    MsgCodes[i] = int16(i - 1);//anm actually provided in some kind of useful order, wow !
  }

  //build command code table for quick lookup in Respond()
  CmdCodes[idHotSpot1] = CM_GAME_ACVP_FREELOOK_DEF;
  CmdCodes[idHotSpot2] = CM_GAME_ACVP_RAISEDRAWJOKERPOKER_DEF;
  CmdCodes[idHotSpot3] = CM_GAME_ACVP_DDRAWJOKERPOKER_DEF;
  CmdCodes[idHotSpot4] = CM_GAME_ACVP_JACKSORBETTER96_DEF;
  CmdCodes[idHotSpot5] = CM_GAME_ACVP_DEUCESWILD_DEF;
  CmdCodes[idHotSpot6] = CM_GAME_ACVP_BONUSDELUXE_DEF;
  CmdCodes[idHotSpot7] = CM_GAME_ACVP_TENSORBETTER_DEF;
  CmdCodes[idHotSpot8] = CM_GAME_ACVP_TREASURETROVE_DEF;
  CmdCodes[idHotSpot9] = CM_GAME_ACVP_TRIPLEBONUS_DEF;
  CmdCodes[idHotSpot10] = CM_GAME_ACVP_TRIPLEPLAY_DEF;
  CmdCodes[idHotSpot11] = CM_GAME_ACVP_TRIPLEPROG_DEF;
  CmdCodes[idHotSpot12] = CM_GAME_ACVP_WHEELDEAL_DEF;
  CmdCodes[idHotSpot13] = CM_GAME_ACVP_SUPERSEVENS_DEF;
  CmdCodes[idHotSpot14] = CM_GAME_ACVP_CRYSTALPALACE_DEF;
  CmdCodes[idHotSpot15] = CM_GAME_ACVP_FIVESUP_DEF;
  CmdCodes[idHotSpot16] = CM_GAME_ACVP_CLUBBONUS_DEF;
  CmdCodes[idHotSpot17] = CM_GAME_ACVP_CRAZY8S_DEF;
  CmdCodes[idHotSpot18] = CM_GAME_ACVP_DDRAWJACKSORBETTER_DEF;
  CmdCodes[idHotSpot19] = CM_GAME_ACVP_DDOWNSTUD_DEF;
  CmdCodes[idHotSpot20] = CM_GAME_ACVP_DEUCESWILDBONUS_DEF;
  CmdCodes[idHotSpot21] = CM_GAME_ACVP_SUPERDJACKPOT_DEF;
  CmdCodes[idHotSpot22] = CM_GAME_ACVP_SPADEBONUS_DEF;
  CmdCodes[idHotSpot23] = CM_GAME_ACVP_SEVENSWILD1JOKER_DEF;
  CmdCodes[idHotSpot24] = CM_GAME_ACVP_DEUCESWILDPROG_DEF;
  CmdCodes[idHotSpot25] = CM_GAME_ACVP_DIAMONDBONUS_DEF;
  CmdCodes[idHotSpot26] = CM_GAME_ACVP_DBONUSPOKER_DEF;
  CmdCodes[idHotSpot27] = CM_GAME_ACVP_FLUSHASSAULT_DEF;
  CmdCodes[idHotSpot28] = CM_GAME_ACVP_GAMBLERSEDGE_DEF;
  CmdCodes[idHotSpot29] = CM_GAME_ACVP_HEARTBONUS_DEF;
  CmdCodes[idHotSpot30] = CM_GAME_ACVP_BLACKJACKS_DEF;
  CmdCodes[idHotSpot31] = CM_GAME_ACVP_JACKSORBETTERPROG_DEF;
  CmdCodes[idHotSpot32] = CM_GAME_ACVP_JACKPOTBONUS_DEF;
  CmdCodes[idHotSpot33] = CM_GAME_ACVP_JACKSORBETTER85_DEF;
  CmdCodes[idHotSpot34] = CM_GAME_ACVP_JACKSORBETTERDNOTHING_DEF;
  CmdCodes[idHotSpot35] = CM_GAME_ACVP_JOKERSWILDPROG_DEF;
  CmdCodes[idHotSpot36] = CM_GAME_ACVP_JUMPINJOKERS_DEF;
  CmdCodes[idHotSpot37] = CM_GAME_ACVP_ROYALSPROG_DEF;
  CmdCodes[idHotSpot38] = CM_GAME_ACVP_POWERHOUSEPROG_DEF;

  TFileMode splfm(SpriteListName,
                  TFileMode::fm_None,
                  TFileMode::fm_Immed,
                  FileMode.GetDirIndex());
  CreateAddSpriteList(splfm);

  SetupSprites();
}
//*******************************************************************
TACVPLobbyGameLord::~TACVPLobbyGameLord()
{
  if(PState != NULL)
  {
	 delete PState;
	 PState = NULL;
  }
  CleanupSprites();
  CleanupResponders();
}
//*******************************************************************
void TACVPLobbyGameLord::CleanupResponders()
{
  for(int16 i=0;i<NumResponders;i++)
  {
    if (Responders[i] != NULL)
    {
      delete Responders[i];
      Responders[i] = NULL;
    }
  }
}
//*******************************************************************
int16 TACVPLobbyGameLord::InitL()
{
  SetSparkle1Idle();
  SetSparkle2Idle();
  SetSparkle3Idle();
  SetSparkle4Idle();
  SetSparkle5Idle();
  SetLeftLampIdle();
  SetLight1Idle();
  SetLight2Idle();
  SetLight3Idle();
  SetLight4Idle();
  SetLight5Idle();
  SetLight6Idle();
  SetLakeIdle();
  SetRightLampIdle();
  SetChuteIdle();
  SetSound1Idle();
  SetSound2Idle();
  SetSound3Idle();

//  SetMinerIdle();
//  SetClosedIdle();
//  SetBoardsIdle();

  SetupActivePlayer(0);

  SetupMine();

 return 1;
}
//*******************************************************************
void TACVPLobbyGameLord::SetupMine()
{
  TTime now;

  if (LastLobbyEndSec == 0)
  {
    SetupMine(true); //let it handle all lowlevel crap
  }
  //withing 10 minutes of last lobby visit
  else if ((now.Seconds() - LastLobbyEndSec) <= MAX_DURATION_SECS)
  {
    SetupMine(MineOpen);
  }
  else
  {
    SetupMine(bool(random(100) > 50)); //50-50 chance at mine open/closed
  }
}
//*******************************************************************
void TACVPLobbyGameLord::SetupMine(bool open)
{
  TTime now;

  if (LastLobbyEndSec == 0) //start out open
  {
    MineOpen = true;
    MineSec = now.Seconds();
    LastLobbyEndSec = MineSec;
    MineDurationSec = HALF_DURATION_SECS + random(HALF_DURATION_SECS);
    SetMinerIdle();
    SetBoardsIdle(-1);
    SetClosedIdle(-1);
    if (PGoldPanButton != NULL)
    {
      PGoldPanButton->ShowUp();
    }
    return;
  }

  if (MineOpen)
  {
    if (open) //startup or switch back to lobby within 10 minutes. No FX
    {
      MineOpen = true;
      MineSec = now.Seconds();
      if (MineDurationSec == 0 || MineDurationSec > MAX_DURATION_SECS)
      {
        MineDurationSec = HALF_DURATION_SECS + random(HALF_DURATION_SECS);
      }
      SetMinerIdle();
      SetBoardsIdle(-1);
      SetClosedIdle(-1);
      if (PGoldPanButton != NULL)
      {
        PGoldPanButton->ShowUp();
      }
      return;
    }

    MineOpen = false;
    MineSec = now.Seconds();
    MineDurationSec = HALF_DURATION_SECS + random(HALF_DURATION_SECS);
    BoardsOnFUC = GetAdjFUC();
    if (PCloseMine != NULL)
    {
      ActivateSpriteNow(PCloseMine);
      if (PCloseMine->Get_FUC_Length() > 0)
      {
        BoardsOnFUC += PCloseMine->Get_FUC_Length() - 1;
      }
    }
    MinerOffFUC = GetAdjFUC() + 1;
    if (PGoldPanButton != NULL)
    {
      PGoldPanButton->NoShow();
    }
    return;
  }

  if (open) // was in lobby w/ closed mine that is now opening w/ full fx
  {
    MineSec = now.Seconds();
    MineDurationSec = HALF_DURATION_SECS + random(HALF_DURATION_SECS);
    MineOpen = true;
    MinerOnFUC = GetAdjFUC();
    SetBoardsIdle(-1);
    SetClosedIdle(-1);
    if (POpenMine != NULL)
    {
      ActivateSpriteNow(POpenMine);
      if (POpenMine->Get_FUC_Length() > 0)
      {
        MinerOnFUC += POpenMine->Get_FUC_Length() - 1;
      }
    }
    if (PGoldPanButton != NULL)
    {
      PGoldPanButton->ShowUp();
    }
    return;
  }
  //!open // switching to lobby after 10+ min away from lobby and w/out any random luck.
  MineOpen = false;
  MineSec = now.Seconds();
  MineDurationSec = HALF_DURATION_SECS + random(HALF_DURATION_SECS);
  SetMinerIdle(-1);
  SetBoardsIdle();
  SetClosedIdle();
  if (PGoldPanButton != NULL)
  {
    PGoldPanButton->NoShow();
  }
}
//*******************************************************************
void  TACVPLobbyGameLord::ShuttingDown()
{
//  if(shutdownstate == 0)
  if (!ShuttingDownFlag)
  {
	 if(GetCasPD(0))
	 {
		NotifyPlayerDeActivation(0);
	 }
    ShuttingDownFlag = true;
    TTime now;
    LastLobbyEndSec = now.Seconds();
    MineDurationSec -= (LastLobbyEndSec - MineSec);
    if (MineDurationSec > MAX_DURATION_SECS || MineDurationSec < 120)
    {
      MineDurationSec = HALF_DURATION_SECS + random(HALF_DURATION_SECS);
    }
  }
}
//*******************************************************************
#pragma argsused
void TACVPLobbyGameLord::NotifyPlayerActivation(int16 slotnum)
{
  SetupActivePlayer(slotnum);
}
//*******************************************************************
#pragma argsused
void TACVPLobbyGameLord::NotifyPlayerDeActivation(int16 slotnum)
{
  if (slotnum == activeplayer)
  {
    SetupActivePlayer(-1);
  }
}
//*******************************************************************
#pragma argsused
void TACVPLobbyGameLord::SetupActivePlayer(int16 slot)
{
  if (GetCasPD(slot))
  {
    PNameSprite->SetName(GetCasPD(slot)->GetName());
    PBankSprite->SetNum(GetCash(slot));
  }
  else
  {
    PNameSprite->SetName(string(""));
    PBankSprite->SetNum(0.0);
  }
  activeplayer = slot;
}
//*******************************************************************
int16 TACVPLobbyGameLord::GetWinningReelStop()
{
  #if defined(ACVP_QUERY_LOBBY)
  static char buffer[5];

  PModeWin->SetUpdatePause();

  TInputDialog id(PModeWin,"0-22","#",buffer,3);
  id.Execute();

  PModeWin->ClearUpdatePause();

  int16 i = int16(atoi(buffer));
  if (i < 0 || i >= NumReelStops)
  {
    return -1;
  }
  return i;
  #else
  int16 randomnum = int16(random(TotalChances));
  int16 accumulated = 0;
  for (int16 i=0;i<NumReelStops;i++)
  {
    accumulated += Chances[i];
    if (randomnum < accumulated)
    {
      return i;
    }
  }
  return -1;
  #endif
}
//*******************************************************************
void TACVPLobbyGameLord::Update(dword fuc)
{
  TTime now;

  if (ResultEndFUC != 0)
  {
    if (ResultEndFUC <= fuc)
    {
      ResultEndFUC = 0;
//      SubCash(activeplayer,GameDenom);
      AddCash(activeplayer,Winnings);
      PBankSprite->SetNum(GetCash(activeplayer));
      if (PGoldPanButton != NULL)
      {
        PGoldPanButton->ShowUp();
      }
    }
  }

  if (ResultEndFUC == 0) // only allow mine open/close when not waiting for results sprite.
  {
    if (MineSec != 0 && (MineSec + MineDurationSec) <= now.Seconds())
    {
      SetupMine(!MineOpen); // periodic timer.
    }
    if (BoardsOnFUC != 0 && BoardsOnFUC <= fuc)
    {
      BoardsOnFUC = 0;
      SetBoardsIdle();
      SetClosedIdle();
    }
    if (MinerOnFUC != 0 && MinerOnFUC <= fuc)
    {
      MinerOnFUC = 0;
      SetMinerIdle();
    }
    if (MinerOffFUC != 0 && MinerOffFUC <= fuc)
    {
      MinerOffFUC = 0;
      SetMinerIdle(-1);
    }
  }

  TCasLobbyGameLord::Update(fuc);
}
//*******************************************************************
void TACVPLobbyGameLord::TurnOnNext()
{
//  switch (GetTurnOffState())
//  {
//    case 1:SetWheel(0);
//           SetTurnOffState(0);
//           break;
//    case 2:SetEscalator(0);
//           SetTurnOffState(1);
//           break;
//    case 3:SetLight1(0);
//           SetLight2(0);
//           SetLight3(0);
//           SetLight4(0);
//           SetTurnOffState(2);
//           break;
//    case 4://SetProgSignIdle(0);        // don't turn back on because it look to obvious.
//           SetTurnOffState(3);
//           break;
//    case 5:SetKeno(0);
//           PLow1->GetAnm(0)->Stop();
//           SetTurnOffState(4);
//           break;
//    case 6:SetVPSignIdle(0);
//           PLow4->GetAnm(0)->Stop();
//           SetTurnOffState(5);
//           break;
//    case 7:SetSlotsIdle(0);
//           PLow3->GetAnm(0)->Stop();
//           SetTurnOffState(6);
//           break;
//    case 8:SetHorse(0);
//           PLow2->GetAnm(0)->Stop();
//           SetTurnOffState(7);
//           break;
//    case 9:SetRouletteIdle(0);
//           PLow6->GetAnm(0)->Stop();
//           SetTurnOffState(8);
//           break;
//    case 10:SetCrapIdle(0);
//           PLow7->GetAnm(0)->Stop();
//           SetTurnOffState(9);
//           break;
//    case 11:SetBJIdle(0);
//            PLow8->GetAnm(0)->Stop();
//            SetTurnOffState(10);
//            break;
//    case 12:SetFountainIdle(0);
//            SetTurnOffState(11);
//            break;
//  }
}
//*******************************************************************
void TACVPLobbyGameLord::TurnOffNext()
{
//  switch (GetTurnOffState())
//  {
//    case 0:SetWheel(-1);
//           SetTurnOffState(1);
//           break;
//    case 1:SetEscalator(-1);
//           SetTurnOffState(2);
//           break;
//    case 2:SetLight1(-1);
//           SetLight2(-1);
//           SetLight3(-1);
//           SetLight4(-1);
//           SetTurnOffState(3);
//           break;
//    case 3:if (!ProgSignKilled)
//           {
//             SetProgSignIdle(-1);
//             PLow5->GetAnm(0)->Start(GetFUC());
//             ProgSignKilled = true;
//           }
//           SetTurnOffState(4);
//           break;
//    case 4:SetKeno(-1);
//           PLow1->GetAnm(0)->Start(GetFUC());
//           SetTurnOffState(5);
//           break;
//    case 5:SetVPSignIdle(-1);
//           PLow4->GetAnm(0)->Start(GetFUC());
//           SetTurnOffState(6);
//           break;
//    case 6:SetSlotsIdle(-1);
//           PLow3->GetAnm(0)->Start(GetFUC());
//           SetTurnOffState(7);
//           break;
//    case 7:SetHorse(-1);
//           PLow2->GetAnm(0)->Start(GetFUC());
//           SetTurnOffState(8);
//           break;
//    case 8:SetRouletteIdle(-1);
//           PLow6->GetAnm(0)->Start(GetFUC());
//           SetTurnOffState(9);
//           break;
//    case 9:SetCrapIdle(-1);
//           PLow7->GetAnm(0)->Start(GetFUC());
//           SetTurnOffState(10);
//           break;
//    case 10:SetBJIdle(-1);
//            PLow8->GetAnm(0)->Start(GetFUC());
//            SetTurnOffState(11);
//            break;
//    case 11:SetFountainIdle(-1);
//            SetTurnOffState(12);
//            break;
//  }
}
//*******************************************************************
void TACVPLobbyGameLord::SetupSprites()
{
  if (PMessageDisplay == NULL)
  {
    SpriteError("MessageDisplay","unknown");
  }
  if (PNameSprite == NULL)
  {
    SpriteError("Name","unknown");
  }
  if (PBankSprite == NULL)
  {
    SpriteError("Bank","unknown");
  }
  if (PMenuEscButton == NULL)
  {
    SpriteError("Menu Button","unknown");
  }
  if (PGamblerButton == NULL)
  {
    SpriteError("Create/Delete Button","unknown");
  }
  if (PGoldPanButton == NULL)
  {
    SpriteError("Gold Pan Button","unknown");
    //::MessageBox(NULL,"where's my gold pan button?","Warning! Missing Sprite!",MB_OK | MB_TASKMODAL);
  }
  if (POpenMine == NULL)
  {
    SpriteError("Open Mine","unknown");
  }
  if (PCloseMine == NULL)
  {
    SpriteError("Close Mine","unknown");
  }
  //open and close mine sprites are treated as vanilla auto sprites
  //so they're not activated or started here.
  for (int16 i=0;i<NumReelStops;i++)
  {
    if (PResults[i] == NULL)
    {
      char buffer[50];
      itoa(i,buffer,10);
      string s = "Result Sprite # ";
      s += buffer;
      s += " missing";
      SpriteError(s,"unknown");
    }
  }

  dword curfuc = GetFUC();
  PMessageDisplay->Start(curfuc);
  PNameSprite->Start(curfuc);
  PBankSprite->Start(curfuc);

  if (GetFW()->GetHandleShowMenu())
  {
    ActivateSpriteNow(PMenuEscButton);
  }
  else
  {
    PMenuEscButton->Enable(false);
  }

  ActivateSpriteNow(PGamblerButton);

  if (PGoldPanButton != NULL)
  {
    ActivateSpriteNow(PGoldPanButton);
  }
}
//*******************************************************************
void TACVPLobbyGameLord::CleanupSprites()
{
}
//*******************************************************************

