//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  acvpvpmw.cpp
//    Project Name:  acvp
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  2.5    09/28/99    M.Perry    original baseline
//********************************************************************
#include "acvpvpmw.h"
#include "cvpplay.h"
#include "acvpglrd.h"
//#include "casglord.h"
#include "acvpmenu.rh"
#include "acvpname.rh"
//*******************************************************************
TACVPVPModeWin::TACVPVPModeWin(string modename,TPal *ppal,int16 sgt,int16 denomid,string title)
:TVideoPokerModeWin(modename,ppal,title),
 ModeSubGameType(sgt),
 ModeDenomID(denomid),
 idsGameLord(0),
 idsHuman0(0)
{
}
//*******************************************************************
TACVPVPModeWin::~TACVPVPModeWin()
{
}
//*******************************************************************
string TACVPVPModeWin::GetDetName()
{
  string s = TAppString::strEmpty;
  switch (ModeSubGameType)
  {
    case cvpFivesUp:s = "a2.det";break;
    case cvpBlackJacks:s = "c4.det";break;
    case cvpBonusDeluxe:s = "a3.det";break;
    case cvpClubBonus:s = "a4.det";break;
    case cvpCrazy8s:s = "a6.det";break;
    case cvpDDrawJB:s = "a7.det";break;
    case cvpDDrawJokerPoker:s = "a8.det";break;
    case cvpDDownStud:s = "a9.det";break;
    case cvpDeucesWildBonus:s = "b1.det";break;
    case cvpDeucesWildII:s = "b2.det";break;
    case cvpDeucesWildProg:s = "b3.det";break;
    case cvpDiamondBonus:s = "b4.det";break;
    case cvpDBonusPoker:s = "b5.det";break;
    case cvpFlushAssault:s = "b6.det";break;
    case cvpFreeLook:s = "b9.det";break;
    case cvpGamblersEdge:s = "c1.det";break;
    case cvpHeartBonus:s = "c2.det";break;
    case cvpJacksProgII:s = "c5.det";break;
    case cvpJackpotBonus:s = "c6.det";break;
    case cvp96JacksOrBetterII:s = "c7.det";break;
    case cvp85JacksOrBetter:s = "c8.det";break;
    case cvpDJacksOrBetter:s = "c9.det";break;
    case cvpJokersWildProg:s = "d1.det";break;
    case cvpJumpinJokers:s = "d2.det";break;
    case cvpTripleProg:s = "d3.det";break;
    case cvpRoyalProg:s = "d4.det";break;
    case cvpPowerProg:s = "d5.det";break;
    case cvpRaiseJokersWild:s = "d6.det";break;
    case cvpSpadeBonus:s = "d8.det";break;
    case cvpSuperDJackpot:s = "d9.det";break;
    case cvp7Wild1Joker:s = "e1.det";break;
    case cvpTensOrBetterII:s = "e2.det";break;
    case cvpTreasureTrove:s = "e3.det";break;
    case cvpTriplePlay:s = "e4.det";break;
    case cvpTripleBonus:s = "e5.det";break;
    case cvpWheelDeal:s = "e6.det";break;
    default:break;
  }
  return s;
//  return string("acvp.det");
}
//*******************************************************************
int TACVPVPModeWin::GetMenuID()
{
  return IDM_ACVP_VP;
//  return 0;
}
//*******************************************************************
void TACVPVPModeWin::SetupGObjIDS()
{
  if (GObjIDSInitialized) {return;}

  TVideoPokerModeWin::SetupGObjIDS();  //call up chain.

  switch (ModeSubGameType)
  {
    case cvpFivesUp           :idsGameLord = IDS_GL_ACVP_VP_FIVESUP;
                               idsHuman0 = IDS_H0_ACVP_VP_FIVESUP;
                               break;
    case cvpBlackJacks        :idsGameLord = IDS_GL_ACVP_VP_BLACKJACKS;
                               idsHuman0 = IDS_H0_ACVP_VP_BLACKJACKS;
                               break;
    case cvpBonusDeluxe       :idsGameLord = IDS_GL_ACVP_VP_BONUSDELUXE;
                               idsHuman0 = IDS_H0_ACVP_VP_BONUSDELUXE;
                               break;
    case cvpClubBonus         :idsGameLord = IDS_GL_ACVP_VP_CLUBBONUS;
                               idsHuman0 = IDS_H0_ACVP_VP_CLUBBONUS;
                               break;
    case cvpCrazy8s           :idsGameLord = IDS_GL_ACVP_VP_CRAZY8S;
                               idsHuman0 = IDS_H0_ACVP_VP_CRAZY8S;
                               break;
    case cvpDDrawJB           :idsGameLord = IDS_GL_ACVP_VP_DDRAWJACKSORBETTER;
                               idsHuman0 = IDS_H0_ACVP_VP_DDRAWJACKSORBETTER;
                               break;
    case cvpDDrawJokerPoker   :idsGameLord = IDS_GL_ACVP_VP_DDRAWJOKERPOKER;
                               idsHuman0 = IDS_H0_ACVP_VP_DDRAWJOKERPOKER;
                               break;
    case cvpDDownStud         :idsGameLord = IDS_GL_ACVP_VP_DDOWNSTUD;
                               idsHuman0 = IDS_H0_ACVP_VP_DDOWNSTUD;
                               break;
    case cvpDeucesWildBonus   :idsGameLord = IDS_GL_ACVP_VP_DEUCESWILDBONUS;
                               idsHuman0 = IDS_H0_ACVP_VP_DEUCESWILDBONUS;
                               break;
    case cvpDeucesWildII      :idsGameLord = IDS_GL_ACVP_VP_DEUCESWILD;
                               idsHuman0 = IDS_H0_ACVP_VP_DEUCESWILD;
                               break;
    case cvpDeucesWildProg    :idsGameLord = IDS_GL_ACVP_VP_DEUCESWILDPROG;
                               idsHuman0 = IDS_H0_ACVP_VP_DEUCESWILDPROG;
                               break;
    case cvpDiamondBonus      :idsGameLord = IDS_GL_ACVP_VP_DIAMONDBONUS;
                               idsHuman0 = IDS_H0_ACVP_VP_DIAMONDBONUS;
                               break;
    case cvpDBonusPoker       :idsGameLord = IDS_GL_ACVP_VP_DBONUSPOKER;
                               idsHuman0 = IDS_H0_ACVP_VP_DBONUSPOKER;
                               break;
    case cvpFlushAssault      :idsGameLord = IDS_GL_ACVP_VP_FLUSHASSAULT;
                               idsHuman0 = IDS_H0_ACVP_VP_FLUSHASSAULT;
                               break;
    case cvpFreeLook          :idsGameLord = IDS_GL_ACVP_VP_FREELOOK;
                               idsHuman0 = IDS_H0_ACVP_VP_FREELOOK;
                               break;
    case cvpGamblersEdge      :idsGameLord = IDS_GL_ACVP_VP_GAMBLERSEDGE;
                               idsHuman0 = IDS_H0_ACVP_VP_GAMBLERSEDGE;
                               break;
    case cvpHeartBonus        :idsGameLord = IDS_GL_ACVP_VP_HEARTBONUS;
                               idsHuman0 = IDS_H0_ACVP_VP_HEARTBONUS;
                               break;
    case cvpJacksProgII       :idsGameLord = IDS_GL_ACVP_VP_JACKSORBETTERPROG;
                               idsHuman0 = IDS_H0_ACVP_VP_JACKSORBETTERPROG;
                               break;
    case cvpJackpotBonus      :idsGameLord = IDS_GL_ACVP_VP_JACKPOTBONUS;
                               idsHuman0 = IDS_H0_ACVP_VP_JACKPOTBONUS;
                               break;
    case cvp96JacksOrBetterII :idsGameLord = IDS_GL_ACVP_VP_JACKSORBETTER96;
                               idsHuman0 = IDS_H0_ACVP_VP_JACKSORBETTER96;
                               break;
    case cvp85JacksOrBetter   :idsGameLord = IDS_GL_ACVP_VP_JACKSORBETTER85;
                               idsHuman0 = IDS_H0_ACVP_VP_JACKSORBETTER85;
                               break;
    case cvpDJacksOrBetter    :idsGameLord = IDS_GL_ACVP_VP_JACKSORBETTERDNOTHING;
                               idsHuman0 = IDS_H0_ACVP_VP_JACKSORBETTERDNOTHING;
                               break;
    case cvpJokersWildProg    :idsGameLord = IDS_GL_ACVP_VP_JOKERSWILDPROG;
                               idsHuman0 = IDS_H0_ACVP_VP_JOKERSWILDPROG;
                               break;
    case cvpJumpinJokers      :idsGameLord = IDS_GL_ACVP_VP_JUMPINJOKERS;
                               idsHuman0 = IDS_H0_ACVP_VP_JUMPINJOKERS;
                               break;
    case cvpTripleProg        :idsGameLord = IDS_GL_ACVP_VP_TRIPLEPROG;
                               idsHuman0 = IDS_H0_ACVP_VP_TRIPLEPROG;
                               break;
    case cvpRoyalProg         :idsGameLord = IDS_GL_ACVP_VP_ROYALSPROG;
                               idsHuman0 = IDS_H0_ACVP_VP_ROYALSPROG;
                               break;
    case cvpPowerProg         :idsGameLord = IDS_GL_ACVP_VP_POWERHOUSEPROG;
                               idsHuman0 = IDS_H0_ACVP_VP_POWERHOUSEPROG;
                               break;
    case cvpRaiseJokersWild   :idsGameLord = IDS_GL_ACVP_VP_RAISEDRAWJOKERPOKER;
                               idsHuman0 = IDS_H0_ACVP_VP_RAISEDRAWJOKERPOKER;
                               break;
    case cvpSpadeBonus        :idsGameLord = IDS_GL_ACVP_VP_SPADEBONUS;
                               idsHuman0 = IDS_H0_ACVP_VP_SPADEBONUS;
                               break;
    case cvpSuperDJackpot     :idsGameLord = IDS_GL_ACVP_VP_SUPERDJACKPOT;
                               idsHuman0 = IDS_H0_ACVP_VP_SUPERDJACKPOT;
                               break;
    case cvp7Wild1Joker       :idsGameLord = IDS_GL_ACVP_VP_SEVENSWILD1JOKER;
                               idsHuman0 = IDS_H0_ACVP_VP_SEVENSWILD1JOKER;
                               break;
    case cvpTreasureTrove     :idsGameLord = IDS_GL_ACVP_VP_TREASURETROVE;
                               idsHuman0 = IDS_H0_ACVP_VP_TREASURETROVE;
                               break;
    case cvpTriplePlay        :idsGameLord = IDS_GL_ACVP_VP_TRIPLEPLAY;
                               idsHuman0 = IDS_H0_ACVP_VP_TRIPLEPLAY;
                               break;
    case cvpTripleBonus       :idsGameLord = IDS_GL_ACVP_VP_TRIPLEBONUS;
                               idsHuman0 = IDS_H0_ACVP_VP_TRIPLEBONUS;
                               break;
    case cvpWheelDeal         :idsGameLord = IDS_GL_ACVP_VP_WHEELDEAL;
                               idsHuman0 = IDS_H0_ACVP_VP_WHEELDEAL;
                               break;
    case cvpTensOrBetterII    :idsGameLord = IDS_GL_ACVP_VP_TENSORBETTER;
                               idsHuman0 = IDS_H0_ACVP_VP_TENSORBETTER;
                               break;
 //   case cvpIntro             :idsGameLord = IDS_GL_ACVP_VP_;
 //                              idsHuman0 = IDS_H0_ACVP_VP_;
 //                              break;
 //   case cvpLobby             :idsGameLord = IDS_GL_ACVP_VP_;
 //                              idsHuman0 = IDS_H0_ACVP_VP_;
 //                              break;
    default:break;
  }
}
//*******************************************************************
void TACVPVPModeWin::SetupGObjStrings()
{
  if (GObjStringsInitialized) {return;}

  TVideoPokerModeWin::SetupGObjStrings();

  strGameLord = GetResString(idsGameLord);

  if (idsHuman0 > 0)
  {
    strHuman0 = GetResString(idsHuman0);
  }
}
//*******************************************************************
TGameObject *TACVPVPModeWin::CreateGObj(TFileMode &fm,int16 id,void *psource)
{
  #if defined(OGLE_DEBUG_GOBJ)
  if (!GObjInfoInitialized)
  {
    ::MessageBox(NULL,
                 "GObjInfoInitialized == false",
                 "Warning! TACCVPModeWin::CreateGObj()",
                 MB_OK | MB_TASKMODAL);
  }

  if (!TMoney().CheckDenomID(ModeDenomID))
  {
    ::MessageBox(NULL,
                 "Invalid denomination",
                 "Error! TACCVPModeWin::CreateGObj()",
                 MB_OK | MB_TASKMODAL);
  }

  if (fm == strGameLord && pLord != NULL)
  {
    ::MessageBox(NULL,
                 "GameLord already created",
                 "Error! TACCVPModeWin::CreateGObj()",
                 MB_OK | MB_TASKMODAL);
  }
  #endif

  if (fm == strHuman0)
  {
    GObj[0] = new TCasinoVPPlayer(this,fm,0);
    return GObj[0];
  }
  else if (fm == strGameLord && pLord == NULL)
  {
    pLord = new TACVPVPGLord(this,fm,ModeSubGameType,ModeDenomID);
    return pLord;
  }
  else
  {
    #if defined(OGLE_DEBUG_GOBJ)
    string s = "gobj failed match:";
    s += fm.Name.GetStr();
    s += "\nCreating default TGameObject";
    s += "\nstrGameLord:";
    s += strGameLord;
    ::MessageBox(NULL,s.c_str(),"Warning! TACCVPMW::CreateGObj()",MB_OK | MB_TASKMODAL);
    #endif
    // if all else fails, then create a generic gobj.
    return new TGameObject(this,fm);
  }
}
//*******************************************************************