//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  acvsa1st.cpp
//    Project Name:  acvp
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  2.5    10/17/99    M.Perry      Original baseline
//*******************************************************************
#include "acvsa1st.h"
#include "acvpsgld.h"
#include "acvscost.h"
#include "acvswst.h"
#include "orespond.h"
#include "owav.h"
#include "acvp_cm.rh"
//*******************************************************************
TACVPSlotsAct1State::TACVPSlotsAct1State(TACVPSlotsGameLord *plord)
:TACVPSlotsLordState(plord)
{
  SetRunOrder(ess_Execute,ess_Execute,ess_Execute,ess_Done);
  IgnoreCoach = false;
//  AddCoinResponder = NULL;
  WaitOnTray = false;
  DelayFUC = 0;
  StartFUC = 0;
  FUCLength = 0;
  Lock = false;
  StopReelTime = 0;
  WaitOnSpin = false;
  WaitingOnWRCounter = 0;
  pOwnerLord->winnerpaid = 0;
  pOwnerLord->coinsplayed = 0;
  askexpertflag = false;
  ZeroStart = 0;
  IsUp = false;
}
//*******************************************************************
TACVPSlotsAct1State::~TACVPSlotsAct1State()
{
}
//*******************************************************************
void TACVPSlotsAct1State::ExecuteFirstTime()
{
  pOwnerLord->Clear();
  ExecuteWaiting = true;
  ExecuteStatus = ess_Execute;
}
//*******************************************************************
void TACVPSlotsAct1State::CreateSubState1()
{
  PActiveSubState = new TACVPSlotsWinState(pOwnerLord);
}
//*******************************************************************
void TACVPSlotsAct1State::EndSubState1()
{
  TState::EndSubState1();
  pOwnerLord->Clear();
  StopReelTime = 0;
  Lock = false;
  ExecuteWaiting = true;
}
//*******************************************************************
void TACVPSlotsAct1State::CreateSubState2()
{
  PActiveSubState = new TACVPSlotsCashOutState(pOwnerLord);
}
//*******************************************************************
void TACVPSlotsAct1State::EndSubState2()
{
  TState::EndSubState2();
  ExecuteWaiting = true;
  pOwnerLord->BtnShowGray(0);
  pOwnerLord->UnFreezeAllButtons();
  DelayFUC = pOwnerLord->GetAdjFUC();
  WaitOnTray = true;
}
//*******************************************************************
void TACVPSlotsAct1State::HandlePostUpdate(dword NewFUC)
{
  if(pOwnerLord->BMNumOfCredits)
  {
//    pOwnerLord->PCoinsPlayed->PlayCreditsSound(pOwnerLord->BetMaxNumOfCredits);
    if (pOwnerLord->PColumn != NULL)
    {
      pOwnerLord->PColumn->PlayCreditsSound(pOwnerLord->BetMaxNumOfCredits);
    }
	 pOwnerLord->BMNumOfCredits = false;
  }
  if(pOwnerLord->BMNumOfCoins)
  {
//	 if(pOwnerLord->PCoinsPlayed->IsWaveStopped(int16(pOwnerLord->BetMaxNumOfCredits-1)) ||
//		(pOwnerLord->BetMaxNumOfCredits == 0))
//	 {
//      pOwnerLord->PCoinsPlayed->PlayCoinsSound(pOwnerLord->BetMaxNumOfCoins);
//		pOwnerLord->BMNumOfCoins = false;
//	 }
    if ((pOwnerLord->PColumn != NULL && pOwnerLord->PColumn->IsAllWavsStopped()) ||
        pOwnerLord->BetMaxNumOfCredits == 0)
    {
      if (pOwnerLord->PColumn != NULL)
      {
        pOwnerLord->PColumn->PlayCoinsSound(pOwnerLord->BetMaxNumOfCoins);
      }
      pOwnerLord->BMNumOfCoins = false;
    }
  }
  if(WaitOnTray)
  {
	 if(DelayFUC + 6 <= NewFUC)
	 {
		pOwnerLord->PBankCashDisplay->SetNum(pOwnerLord->GetCash(pOwnerLord->activeplayer));
		pOwnerLord->PCoinPay->ClearTray();
		WaitOnTray = false;
	 }
	 else
    {
      return;
    }
  }
  if (pOwnerLord->BtnGetHit(acvpsidButton1))
  {
	 pOwnerLord->ButtonClear(acvpsidButton1);
	 pOwnerLord->AddCredits(50);
	 return;
  }
  if (pOwnerLord->BtnGetHit(acvpsidButton0))
  {
	 pOwnerLord->FreezeAllButtons();
	 ExecuteWaiting = false;
	 ExecuteStatus = ess_StartSubState2;
	 pOwnerLord->ButtonClear(acvpsidButton0);
	 return;
  }
  if (pOwnerLord->BtnGetHit(acvpsidButton2))
  {
	 pOwnerLord->ButtonClear(acvpsidButton2);
  }
  if (pOwnerLord->BtnGetHit(acvpsidButton3))
  {
	 pOwnerLord->ButtonClear(acvpsidButton3);
	 pOwnerLord->Bet1();
	 if (pOwnerLord->coinsplayed == pOwnerLord->maxbet)
	 {
		WaitingOnWRCounter = 1;
      pOwnerLord->ChangeActivePlayersOk = false;
  	   ZeroStart = WaitingOnWRCounter;
	 }
	 else if(pOwnerLord->IsMultiPayline)
	 {
		pOwnerLord->PPayLine->SetPayLine(pOwnerLord->coinsplayed);
	 }
  }
  if (pOwnerLord->BtnGetHit(acvpsidButton4))
  {
	 pOwnerLord->ButtonClear(acvpsidButton4);
	 WaitingOnWRCounter = pOwnerLord->BetMax();
	 if(WaitingOnWRCounter > 0)
	 {
		pOwnerLord->ChangeActivePlayersOk = false;
		ZeroStart = WaitingOnWRCounter;
	 }
	 return;
  }
  if (pOwnerLord->BtnGetHit(acvpsidButton5))
  {
	 pOwnerLord->ButtonClear(acvpsidButton5);
	 if(pOwnerLord->coinsplayed > 0)
	 {
	   pOwnerLord->ChangeActivePlayersOk = false;
		pOwnerLord->Spin();
      pOwnerLord->PSounds->PlayStartSpin();
      pOwnerLord->PSounds->PlayReel3();
		pOwnerLord->FreezeAllButtons();
		WaitOnSpin = true;
      pOwnerLord->BtnShowGray(0);
      pOwnerLord->BtnShowGray(1);
      pOwnerLord->BtnShowGray(3);
      pOwnerLord->BtnShowGray(4);
      pOwnerLord->BtnShowGray(5);
		pOwnerLord->shutdownstate = 1;
	 }
	 return;
  }
  if (pOwnerLord->BtnGetHit(acvpsidButton6))
  {
    pOwnerLord->ButtonClear(acvpsidButton6);
    pOwnerLord->GetModeWin()->PostCommandToFW(CM_GAME_ACVP_LOBBY);
    return;
  }
  if (pOwnerLord->BtnGetHit(acvpsidButton7))
  {
    pOwnerLord->ButtonClear(acvpsidButton7);
    pOwnerLord->GetModeWin()->ModeHelp();
    return;
  }
  if(WaitOnSpin)
  {
	 if(StopReelTime == 2){pOwnerLord->SetReel();}
	 StopReelTime++;
	 if(StopReelTime == 7)
	 {
        pOwnerLord->PSounds->PlayReel2();
	 }
	 else if(StopReelTime == 10)
	 {
		pOwnerLord->PReel1->ShowReel();
      pOwnerLord->PSounds->StopSpin();
      pOwnerLord->PSounds->StopReel3();
	 }
	 else if(StopReelTime == 13)
	 {
        pOwnerLord->PSounds->PlayReel1();
	 }
	 else if(StopReelTime == 16)
	 {
		pOwnerLord->PReel2->ShowReel();
      pOwnerLord->PSounds->StopReel2();
	 }
	 else if(StopReelTime == 25)
	 {
		pOwnerLord->PReel3->ShowReel();
	 }
	 else if(StopReelTime == 27)
	 {
        pOwnerLord->PSounds->StopReel1();
		  WaitOnSpin = false;
		  if ((long)pOwnerLord->coinsplayed)
		  {                                //????
			 ExecuteWaiting = false;
			 ExecuteStatus = ess_StartSubState1;
		  }
		  else
		  {
			 pOwnerLord->Clear();
			 StopReelTime = 0;
			 Lock = false;
		  }
	 }
	 else if(StopReelTime >= 36)
	 {
		WaitOnSpin = false;
      pOwnerLord->PSounds->StopReel1();
		if ((long)pOwnerLord->coinsplayed)
		{                                //????
		  ExecuteWaiting = false;
		  ExecuteStatus = ess_StartSubState1;
		}
		else
		{
		  pOwnerLord->Clear();
		  StopReelTime = 0;
		  Lock = false;
		}
	 }
  }
//  if (AddCoinResponder != NULL)
//  {
//	 if (AddCoinResponder->GetResponseEvent() != reChar)
//	 {
//		AddCoinResponder->ClearPriority();
//	 }
//	 AddCoinResponder = NULL;
//	 pOwnerLord->BetX(pOwnerLord->coinsize);
//	 return;
//  }
  if (ZeroStart)
  {
	 WaitingOnWRCounter=0;
	 if(pOwnerLord->IsMultiPayline)
	 {
	   pOwnerLord->PPayLine->SetPayLine(pOwnerLord->coinsplayed);
	 }
	 pOwnerLord->ChangeActivePlayersOk = false;
	 pOwnerLord->Spin();
    pOwnerLord->PSounds->PlayStartSpin();
    pOwnerLord->PSounds->PlayReel3();
	 pOwnerLord->FreezeAllButtons();
	 WaitOnSpin = true;
    pOwnerLord->BtnShowGray(0);
    pOwnerLord->BtnShowGray(1);
    pOwnerLord->BtnShowGray(3);
    pOwnerLord->BtnShowGray(4);
    pOwnerLord->BtnShowGray(5);
	 pOwnerLord->shutdownstate = 1;
	 ZeroStart = 0;
	 return;
  }
}
//*******************************************************************
bool TACVPSlotsAct1State::HandleNamePlate(TResponder &responder)
{
  if(responder.GetResponseEvent() == reLDown)
  {
	 responder.SetPriority();
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_PRESSING_FINGER_CURSOR));
	 return true;
  }
  if ((responder.GetResponseEvent() == reLUp    ) ||
		(responder.GetResponseEvent() == reLDblClk) ||
		(responder.GetResponseEvent() == reChar   )   )
  {
	 if(responder.GetIsPriority())
	 {
		responder.ClearPriority();
	 }
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_POINTING_FINGER_CURSOR));
	 if(responder.Contains(responder.GetPoint()) ||
		 responder.GetResponseEvent() == reChar     )
	 {
		if(pOwnerLord->GetNumActivePlayers() > 1)
		{
		  pOwnerLord->CyclePlayers();
		}
	 }
  }
  return true;
}
//*******************************************************************
bool TACVPSlotsAct1State::HandleAddCoin(TResponder &responder)
{
  if(responder.GetResponseEvent() == reLDown)
  {
	 responder.SetPriority();
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_PRESSING_FINGER_CURSOR));
	 return true;
  }
  if ((responder.GetResponseEvent() == reLUp    ) ||
		(responder.GetResponseEvent() == reLDblClk) ||
		(responder.GetResponseEvent() == reChar   )   )
  {
	 if(responder.GetIsPriority())
	 {
		responder.ClearPriority();
	 }
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_POINTING_FINGER_CURSOR));
	 if(responder.Contains(responder.GetPoint()) ||
		 responder.GetResponseEvent() == reChar     )
	 {
//		pOwnerLord->BetX(pOwnerLord->coinsize);
      pOwnerLord->BetX(1);
//		if(pOwnerLord->maxbet == pOwnerLord->coinsplayed)
//		{
//        pOwnerLord->BtnShowGray(5);
//		}
	 }
  }
  return true;
}
//*******************************************************************

