//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  acvsodsp.cpp
//    Project Name:  acvp
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  2.5    10/17/99    M.Perry    original baseline
//********************************************************************
#include "acvsodsp.h"
#include "oanm.h"
//*******************************************************************
TACVPSlotsOdometer::TACVPSlotsOdometer(TOgleModeWindow *pmw,const TFileMode &NewFileMode)
:TSprite(pmw,NewFileMode)
{
  SetToManual();
  SetupAnms();
}
//*******************************************************************
TACVPSlotsOdometer::TACVPSlotsOdometer(TOgleModeWindow *pmw,const TFileMode &NewFileMode,void *psource)
:TSprite(pmw,NewFileMode,psource)
{
  SetToManual();
  SetupAnms();
}
//*******************************************************************
TACVPSlotsOdometer::~TACVPSlotsOdometer()
{
}
//*******************************************************************
void TACVPSlotsOdometer::SetupAnms()
  {
	 POdometer[0] = GetAnm(2);
	 POdometer[1] = GetAnm(1);
	 POdometer[2] = GetAnm(0);

	 for (int16 j=0;j<3;j++)
	 {
		if (POdometer[j] == NULL) {AnmError("Win Paid","num",j);}
	 }

	 for (int i=0;i<3;i++)
	 {
		POdometer[i]->CAD.ClearAutoStart();
		POdometer[i]->CAD.ClearAutoStop();
		POdometer[i]->CAD.SetDirStill();
	 }
}
//*******************************************************************
void TACVPSlotsOdometer::SetNum(int16 num)
{
	 if (POdometer[0] == NULL) {return;}
	 if (POdometer[1] == NULL) {return;}
	 if (POdometer[2] == NULL) {return;}

	 ones    =  num % 10;
	 tens    = (num / 10  )  % 10;
	 huns    = (num / 100 )  % 10;
	 POdometer[0]->CAD.SetCurrentFrame(int16(ones));
	 POdometer[1]->CAD.SetCurrentFrame(int16(tens));
	 POdometer[2]->CAD.SetCurrentFrame(int16(huns));
	 for (int j=0;j<3;j++)
	 {
		POdometer[j]->Show();
	 }
	 Update(GetAdjFUC());
}
//*******************************************************************
