//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  acvsposp.cpp
//    Project Name:  acvp
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  2.5    10/17/99    M.Perry     original baseline.
//********************************************************************
#include "acvsposp.h"
#include "oanm.h"
#include "owav.h"
//*******************************************************************
void TACVPSlotsCoinPay::PlayDrop(int16 numcoins)
{
  if (numcoins > 0 && numcoins <= 5)
  {
    int16 soundndx = int16(numcoins - 1);
    PlaySound(soundndx); // wave's 0-4
  }
  else if (numcoins > 5) // wave 5 plays a long time
  {
    PWavs[5]->LoopCount = -1; //loop forever
    PlaySound(5);
  }
}
//*******************************************************************
void TACVPSlotsCoinPay::PlayDump()
{
  PlaySound(6);
}
//*******************************************************************
void TACVPSlotsCoinPay::StopSounds()
{
  for(int i=0;i<7;i++)
  {
	 PWavs[i]->Stop();
  }
}
//*******************************************************************
void TACVPSlotsCoinPay::PlaySound(int16 sound)
{
  if (sound >= 0 && sound < 7)
  {
    PWavs[sound]->Start();
  }
}
//*******************************************************************
void TACVPSlotsCoinPay::SetupAnms()
{
  for(int16 i=0;i<8;i++)
  {
	 PCoinPay[i] = GetAnm(i);
	 if (PCoinPay[i] == NULL) {AnmError("CoinPay","Bar",i);}
	 PCoinPay[i]->CAD.ClearAutoStart();
	 PCoinPay[i]->CAD.ClearAutoStop();
	 PCoinPay[i]->CAD.SetDirStill();;
  }
  for(int16 z=0;z<7;z++)
  {
	 PWavs[z] = GetWav(z);
	 if (PWavs[z] == NULL) {AnmError("CoinPay (Drop) Sprite","sound",z);}
  }
}
//*******************************************************************
TACVPSlotsCoinPay::TACVPSlotsCoinPay(TOgleModeWindow *pmw,const TFileMode &NewFileMode)
:TSprite(pmw,NewFileMode)
{
  NoShow();
  SetToManual();
  SetupAnms();
}
//*******************************************************************
TACVPSlotsCoinPay::TACVPSlotsCoinPay(TOgleModeWindow *pmw,const TFileMode &NewFileMode,void *psource)
:TSprite(pmw,NewFileMode,psource)
{
  NoShow();
  SetToManual();
  SetupAnms();
}
//*******************************************************************
TACVPSlotsCoinPay::~TACVPSlotsCoinPay()
{
}
//*******************************************************************
void TACVPSlotsCoinPay::ClearTray()
{
  for(int i=0;i<8;i++)
  {
	 PCoinPay[i]->NoShow();
  }
}
//*******************************************************************
void TACVPSlotsCoinPay::SetTray(int32 num)
{
  if(num>=200)
  {
	 PCoinPay[7]->CAD.SetCurrentFrame(24);
	 PCoinPay[7]->Show();

  }
  else if(num>=175)
  {
	 PCoinPay[7]->CAD.SetCurrentFrame(int16(num - 175));
	 PCoinPay[7]->Show();
  }
  else if(num>=150)
  {
	 PCoinPay[6]->CAD.SetCurrentFrame(int16(num - 150));
	 PCoinPay[6]->Show();
  }
  else if(num>=125)
  {
	 PCoinPay[5]->CAD.SetCurrentFrame(int16(num - 125));
	 PCoinPay[5]->Show();
  }
  else if(num>=100)
  {
	 PCoinPay[4]->CAD.SetCurrentFrame(int16(num - 100));
	 PCoinPay[4]->Show();
  }
  else if(num>=75)
  {
	 PCoinPay[3]->CAD.SetCurrentFrame(int16(num - 75));
	 PCoinPay[3]->Show();
  }
  else if(num>=50)
  {
	 PCoinPay[2]->CAD.SetCurrentFrame(int16(num - 50));
	 PCoinPay[2]->Show();
  }
  else if(num>=25)
  {
	 PCoinPay[1]->CAD.SetCurrentFrame(int16(num - 25));
	 PCoinPay[1]->Show();
  }
  else if(num>=0)
  {
	 PCoinPay[0]->CAD.SetCurrentFrame(int16(num));
	 PCoinPay[0]->Show();
  }
  Update(GetAdjFUC());
}
//*******************************************************************
