//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  acvstrsp.cpp
//    Project Name:  acvp
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  2.5    10/17/99    M.Perry      original baseline
//********************************************************************
#include "acvstrsp.h"
#include "oanm.h"
#include "owav.h"
//*******************************************************************
TACVPSlotsTravel::TACVPSlotsTravel(TOgleModeWindow *pmw,const TFileMode &NewFileMode)
:TSprite(pmw,NewFileMode)
{
  SetToManual();
  NoShow();
  SetupAnms();
  MoveDone = true;
  NumOfMoveFrames = 0;
  StartFrame = 0;
  framecount = 0;
  MoveBack = false;
  LapIsDone = true;
  StartLapFrame = 0;
  LapInc = 0;
}
//*******************************************************************
TACVPSlotsTravel::TACVPSlotsTravel(TOgleModeWindow *pmw,const TFileMode &NewFileMode,void *psource)
:TSprite(pmw,NewFileMode,psource)
{
  SetToManual();
  NoShow();
  SetupAnms();
  MoveDone = true;
  NumOfMoveFrames = 0;
  StartFrame = 0;
  framecount = 0;
  MoveBack = false;
  LapIsDone = true;
  StartLapFrame = 0;
  LapInc = 0;
}
//*******************************************************************
TACVPSlotsTravel::~TACVPSlotsTravel()
{
}
//*******************************************************************
void TACVPSlotsTravel::PlayFlatWav()
{
  if (Flat != NULL)
  {
    Flat->Start();
    Update(GetAdjFUC());
  }
}
//*******************************************************************
int16 TACVPSlotsTravel::CurrentFrameIs()
{
  return PTravel->CAD.GetCurrentFrame();
}
//*******************************************************************
void TACVPSlotsTravel::DoLap()
{
  LapIsDone = false;
  StartLapFrame = PTravel->CAD.GetCurrentFrame();
  LapInc = 0;
}
//*******************************************************************
void TACVPSlotsTravel::MoveBackward(int16 framesbackward)
{
  if(framesbackward <= 0){return;}
  NumOfMoveFrames = framesbackward;
  MoveDone = false;
  MoveBack = true;
  StartFrame = PTravel->CAD.GetCurrentFrame();
  framecount = 0;
}
//*******************************************************************
void TACVPSlotsTravel::MoveForward(int16 framesforward)
{
  if(framesforward <= 0){return;}
  NumOfMoveFrames = framesforward;
  MoveDone = false;
  StartFrame = PTravel->CAD.GetCurrentFrame();
  framecount = 0;
}
//*******************************************************************
void TACVPSlotsTravel::SetNum(int16 frame)
{
  PTravel->CAD.SetCurrentFrame(int16(frame%38));
  PTravel->Show();
  Update(GetAdjFUC());
  return;
}
//*******************************************************************
void TACVPSlotsTravel::SetupAnms()
{
	PTravel = GetAnm(0);
	if (PTravel == NULL) {AnmError("Travel","Nums",0);}
	PTravel->CAD.ClearAutoStart();
	PTravel->CAD.ClearAutoStop();
	PTravel->CAD.SetDirStill();
	Flat = GetWav(0);
	Update(GetAdjFUC());
}
//*****************************************************************
void TACVPSlotsTravel::PostUpdate(dword NewFUC)
{
	if(!LapIsDone)
	{
	  LapInc++;
	  SetNum(int16((StartLapFrame + LapInc)%38));
	  if(LapInc >= 38){LapIsDone = true;}
	  return;
	}
	if(MoveBack)
	{
	  framecount++;
	  if(StartFrame-framecount < 0)
	  {
		 SetNum(37);
	  }
	  SetNum(int16(StartFrame-framecount));
	  if(framecount == NumOfMoveFrames)
	  {
		 MoveBack = false;
		 MoveDone = true;
	  }
	  return;
	}
	if(!MoveDone && !MoveBack)
	{
	  framecount++;
	  SetNum(int16(StartFrame+framecount));
	  if(framecount == NumOfMoveFrames)
	  {
		 MoveDone = true;
	  }
	}
	TSprite::PostUpdate(NewFUC);
}
//*******************************************************************

