//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  acvsvsp.cpp
//    Project Name:  acvp
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  2.5    10/17/99    M.Perry      original baseline
//********************************************************************
#include "acvsvsp.h"
#include "oanm.h"
#include "owav.h"
//*******************************************************************
TACVPSlotsValue::TACVPSlotsValue(TOgleModeWindow *pmw,const TFileMode &NewFileMode)
:TSprite(pmw,NewFileMode)
{
  SetToManual();
  SetupAnms();
}
//*******************************************************************
TACVPSlotsValue::TACVPSlotsValue(TOgleModeWindow *pmw,const TFileMode &NewFileMode,void *psource)
:TSprite(pmw,NewFileMode,psource)
{
  SetToManual();
  SetupAnms();
}
//*******************************************************************
TACVPSlotsValue::~TACVPSlotsValue()
{
}
//*******************************************************************
void TACVPSlotsValue::SetDenom(TMoney amount)
{
  if (PValue == NULL) {return;}

  int16 did = amount.GetDenomID();
  if (amount.CheckDenomID(did))
  {
    int16 framenum = -1;
    switch (did)
    {
      case TMoney::did_0_05:framenum = 0;break;
      case TMoney::did_0_10:framenum = 1;break;
      case TMoney::did_0_25:framenum = 2;break;
      case TMoney::did_1_00:framenum = 3;break;
      case TMoney::did_5_00:framenum = 4;break;
      case TMoney::did_10_00:framenum = 5;break;
      case TMoney::did_25_00:framenum = 6;break;
      case TMoney::did_50_00:framenum = 7;break;
      case TMoney::did_100_00:framenum = 8;break;
      case TMoney::did_500_00:framenum = 9;break;
      case TMoney::did_1000_00:framenum = 10;break;
    }
    // the following is just until Rich fixes the damn sprite.
    if (PValue->GetFrameNum() < 10)
    {
      if (framenum >= 5)
      {
        framenum++; //skip 50c and $2 frames
        framenum++;
      }
      else if (framenum >= 3)
      {
        framenum++; //skip 50c frame
      }
    }
    //end of Rich workaround
    if (PValue->IsValidFrame(framenum))
    {
      PValue->CAD.SetCurrentFrame(framenum);
      PValue->Show();
      Update(GetAdjFUC());
    }
    else
    {
      PValue->CAD.SetCurrentFrame(0);
      PValue->NoShow();
    }
  }
}
//*******************************************************************
void TACVPSlotsValue::ChangeDenom(TMoney amount,bool NoSound)
{
  if (!NoSound && PRockValue != NULL)
  {
    PRockValue->Start();
  }
  SetDenom(amount);
}
//*******************************************************************
void TACVPSlotsValue::SetupAnms()
{
	PValue = GetAnm(0);
	if (PValue == NULL) {AnmError("Value","Nums",0);}
	PValue->CAD.ClearAutoStart();
	PValue->CAD.ClearAutoStop();
	PValue->CAD.SetDirStill();
	PRockValue = GetWav(0);
//   #if defined(ACVP_DEBUG_SPRITES)
//   if (PRockValue == NULL)
//   {
//     ::MessageBox(NULL,
//                  "Rich, this is Mike, were is my denom wav?",
//                  "Warning! Missing Wav!",
//                  MB_OK | MB_TASKMODAL);
//   }
//   if (PValue->GetFrameNum() < 10)
//   {
//     ::MessageBox(NULL,
//                  "Rich, this is Mike, were is the CORRECT denom anm?",
//                  "Warning! Missing correct anm!",
//                  MB_OK | MB_TASKMODAL);
//   }
//   #endif
//	if (PRockValue == NULL) {AnmError("RockSound Sprite","sound",0);}
}
//*******************************************************************
