//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  acvswhsp.cpp
//    Project Name:  acvp
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  2.5    10/17/99    M.Perry    original baseline
//********************************************************************
#include "acvswhsp.h"
#include "oanm.h"
#include "owav.h"
//*******************************************************************
TACVPSlotsWinHighLight::TACVPSlotsWinHighLight(TOgleModeWindow *pmw,const TFileMode &NewFileMode)
:TSprite(pmw,NewFileMode),
 PTitle(NULL),
 CurrentSound(-1)
{
  SetToManual();
  SetupAnms();
}
//*******************************************************************
TACVPSlotsWinHighLight::TACVPSlotsWinHighLight(TOgleModeWindow *pmw,const TFileMode &NewFileMode,void *psource)
:TSprite(pmw,NewFileMode,psource),
 PTitle(NULL),
 CurrentSound(-1)
{
  SetToManual();
  SetupAnms();
}
//*******************************************************************
TACVPSlotsWinHighLight::~TACVPSlotsWinHighLight()
{
}
//********************************************************************
void TACVPSlotsWinHighLight::StopAll()
{
  for (int16 i=0;i<NumWaves;i++)
  {
    if (PWaves[i] != NULL && !IsWaveStopped(i))
    {
      PWaves[i]->Stop();
    }
  }
  CurrentSound = -1;
}
//********************************************************************
bool TACVPSlotsWinHighLight::IsCurrentWaveStopped()
{
  return IsWaveStopped(CurrentSound);
}
//********************************************************************
bool TACVPSlotsWinHighLight::IsWaveStopped(int16 ndx)
{
  if (ndx >= 0 &&
      ndx < NumWaves &&
      PWaves[ndx] != NULL &&
      PWaves[ndx]->GetStarted() &&
      !PWaves[ndx]->GetStopped())
  {
	 return false;
  }
  return true;
}
//*******************************************************************
void TACVPSlotsWinHighLight::PlaySound(int16 sound)
{
  if (sound >= 0 &&
      sound < NumWaves)
  {
    if (PWaves[sound] != NULL)
    {
    	 PWaves[sound]->Start();
   	 CurrentSound = sound;
       if (PTitle != NULL)
       {
    	   PTitle->Show();
       }
       Update(GetAdjFUC());
    }
    #if defined(ACVP_DEBUG_SPRITES)
    else
    {
      char buffer[50];
      itoa(sound,buffer,10);
      string s = "Rich, this is Mike, where's my payoff sound #";
      s += buffer;
      s += " for winhighlight (pays) ?",
      ::MessageBox(NULL,
                   s.c_str(),
                   "Warning! Missing Wav",
                   MB_OK | MB_TASKMODAL);
    }
    #endif
  }
}
//*******************************************************************
void TACVPSlotsWinHighLight::SetupAnms()
{
	PTitle = GetAnm(0);
	if (PTitle == NULL)
   {
//     #if defined(ACVP_DEBUG_SPRITES)
//     ::MessageBox(NULL,
//                  "Rich, this is Mike,where's the title anm for WinHighLight (pays)?",
//                  "Warning! Missing Anm!",
//                  MB_OK | MB_TASKMODAL);
////     #else
////     AnmError("WinHighLight","title",0);
//     #endif
   }
   else
   {
     PTitle->CAD.ClearAutoStart();
	  PTitle->CAD.ClearAutoStop();
	  PTitle->CAD.SetDirStill();
   }

	for(int16 i=0;i<NumWaves;i++)
	{
	  PWaves[i] = GetWav(i);
//     if (PWaves[i] == NULL)
//     {
//       count--;
//       WavError("WinHighLight (pays)","Wavs",i);
//     }
	}
}
//*******************************************************************
void TACVPSlotsWinHighLight::Update(dword NewFUC)
{
  if(CurrentSound >= 0)
  {
	 if(CurrentSound < NumWaves &&
       PWaves[CurrentSound] != NULL &&
       PWaves[CurrentSound]->GetStopped())
	 {
      CurrentSound = -1;
      if (PTitle != NULL) {PTitle->NoShow();}
	 }
	 else if(NewFUC%3 == 0)
	 {
      if (PTitle != NULL) {PTitle->Show();}
	 }
	 else
	 {
		if (PTitle != NULL) {PTitle->NoShow();}
	 }
  }
  TSprite::Update(NewFUC);
}
//*****************************************************************
