//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  acvswpsp.cpp
//    Project Name:  acvp
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  2.5    10/17/99    M.Perry      original baseline
//********************************************************************
#include "acvswpsp.h"
#include "oanm.h"
#include <assert.h>
//*******************************************************************
TACVPSlotsWinPaid::TACVPSlotsWinPaid(TOgleModeWindow *pmw,const TFileMode &NewFileMode)
:TSprite(pmw,NewFileMode)
{
  SetToManual();
  SetupAnms();
}
//*******************************************************************
TACVPSlotsWinPaid::TACVPSlotsWinPaid(TOgleModeWindow *pmw,const TFileMode &NewFileMode,void *psource)
:TSprite(pmw,NewFileMode,psource)
{
  SetToManual();
  SetupAnms();
}
//*******************************************************************
TACVPSlotsWinPaid::~TACVPSlotsWinPaid()
{
}
//*******************************************************************
void TACVPSlotsWinPaid::SetupAnms()
{

//	 PWinPaid[0] = GetAnm(4);
//	 PWinPaid[1] = GetAnm(3);
//	 PWinPaid[2] = GetAnm(2);
//	 PWinPaid[3] = GetAnm(1);
//	 PWinPaid[4] = GetAnm(0);

	 for (int16 i=0;i<NumDigits;i++)
	 {
      int16 ndx = int16(int16(MaxDigitsNDX) - i);
      PWinPaid[i] = GetAnm(ndx);
      if (PWinPaid[i] == NULL) {AnmError("Win Paid","num",ndx);}
		PWinPaid[i]->CAD.ClearAutoStart();
		PWinPaid[i]->CAD.ClearAutoStop();
		PWinPaid[i]->CAD.SetDirStill();
	 }
//	 for(int16 z=0;z<5;z++)
//	 {
//		PWinPaidSound[z] = GetWav(z);
//		if (PWinPaidSound[z] == NULL) {AnmError("WinPaidSound Sprite","sound",z);}
//	 }
}
//*******************************************************************
void TACVPSlotsWinPaid::SetNum(int16 num)
{
//	 if (PWinPaid[0] == NULL) {return;}
//	 if (PWinPaid[1] == NULL) {return;}
//	 if (PWinPaid[2] == NULL) {return;}
//	 if (PWinPaid[3] == NULL) {return;}
//	 if (PWinPaid[4] == NULL) {return;}
    assert(NumDigits >= 5);
    for (int16 i = 0;i<NumDigits;i++)
    {
      if (PWinPaid[i] == NULL) {return;}
    }


	 ones    =  num % 10;
	 tens    = (num / 10  )  % 10;
	 huns    = (num / 100 )  % 10;
	 thou    = (num / 1000)  % 10;
	 tenthou = (num / 10000) % 10;
	 PWinPaid[0]->CAD.SetCurrentFrame(int16(ones));
	 PWinPaid[1]->CAD.SetCurrentFrame(int16(tens));
	 PWinPaid[2]->CAD.SetCurrentFrame(int16(huns));
	 PWinPaid[3]->CAD.SetCurrentFrame(int16(thou));
	 PWinPaid[4]->CAD.SetCurrentFrame(int16(tenthou));
    for (int j=0;j<NumDigits;j++)
	 {
		PWinPaid[j]->Show();
	 }
    Update(GetAdjFUC());
}
//*******************************************************************

