//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  acvswst.cpp
//    Project Name:  acvp
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  2.5    10/17/99    M.Perry      Original baseline
//*******************************************************************
#include "acvswst.h"
#include "otimers.h"
#include "orespond.h"
//*******************************************************************
TACVPSlotsWinState::TACVPSlotsWinState(TACVPSlotsGameLord *plord)
:TACVPSlotsLordState(plord)
{
  wincount   = 0;
  SpeedClickResponder = NULL;
  wincountup = 0;
}
//*******************************************************************
TACVPSlotsWinState::~TACVPSlotsWinState()
{
}
//*******************************************************************
void TACVPSlotsWinState::ExecuteFirstTime()
{
  ExecuteWaiting = true;
  ExecuteStatus    = ess_Execute;
  wincount = pOwnerLord->Winner();
  pOwnerLord->PWinPaid->SetNum(0);  //start the count upwards.
  pOwnerLord->PCredits->SetNum(pOwnerLord->credits);
}
//*******************************************************************
void TACVPSlotsWinState::HandlePostUpdate(dword NewFUC)
{
  if (SpeedClickResponder != NULL)
  {
	 if (SpeedClickResponder->GetResponseEvent() != reChar)
	 {
		SpeedClickResponder->ClearPriority();
	 }
	 wincountup += wincount;
	 pOwnerLord->credits += wincount;
	 pOwnerLord->PWinPaid->SetNum(wincountup);
	 pOwnerLord->PCredits->SetNum(pOwnerLord->credits);
	 SpeedClickResponder = NULL;
	 if(pOwnerLord->PWinHighLight != NULL)
	 {
		pOwnerLord->PWinHighLight->StopAll();
	 }
	 wincount = 0;
	 return;
  }
  else if (wincount > 0)
  {
	 if(wincount < pOwnerLord->coinsplayed)
	 {
		wincountup          += wincount;
		pOwnerLord->credits += wincount;
		wincount             = 0;
	 }
	 else
	 {
		wincount   -= pOwnerLord->coinsplayed;
		wincountup += pOwnerLord->coinsplayed;
		pOwnerLord->credits += pOwnerLord->coinsplayed;
	 }
	 pOwnerLord->PWinPaid->SetNum(wincountup);
	 pOwnerLord->PCredits->SetNum(pOwnerLord->credits);
  }
  else
  {
    ExecuteWaiting = false;
    pOwnerLord->BtnShowVoidUp(3);
    pOwnerLord->BtnShowVoidUp(4);
    pOwnerLord->BtnShowGray(5);
    if (pOwnerLord->credits > 0)
    {
      pOwnerLord->BtnShowVoidUp(0);
    }
  }
}
//*******************************************************************
bool TACVPSlotsWinState::HandleSpeedClick(TResponder &responder)
{
  if (responder.GetResponseEvent() == reRUp)
  {
	 SpeedClickResponder = &responder;
  }

  if (responder.GetResponseEvent() == reRDown)
  {
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
	 SpeedClickResponder = &responder;
  }
  return true;
}
//*******************************************************************
