//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  casbusp.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0    12/23/95   M.Perry     moved inline header to cpp file.
//  2.0    08/02/97   M.Perry     32-bit conversion.
//********************************************************************
#include "casbusp.h"
#include "oanm.h"
//*******************************************************************
TBetUnitChips::TBetUnitChips(TOgleModeWindow *pmw,const TFileMode &NewFileMode)
:TSprite(pmw,NewFileMode)
{
  SetToManual();
  NoShow();
  SetupAnms();
}
//*******************************************************************
TBetUnitChips::TBetUnitChips(TOgleModeWindow *pmw,const TFileMode &NewFileMode,void *psource)
  :TSprite(pmw,NewFileMode,psource)
{
  SetToManual();
  NoShow();
  SetupAnms();
}
//*******************************************************************
TBetUnitChips::~TBetUnitChips()
{
}
//*******************************************************************
void TBetUnitChips::SetupAnms()
{
  for (int16 i=0;i<6;i++)
  {
	 PChips[i] = GetAnm(i);
	 if (PChips[i] == NULL) {AnmError("BetUnitChips","Chips",i);}
  }
  PWave = GetWav(0);
  for (int j=0;j<6;j++)
  {
	 PChips[j]->CAD.ClearAutoStart();
	 PChips[j]->CAD.ClearAutoStop();
	 PChips[j]->CAD.SetDirStill();
  }
}
//*******************************************************************
void TBetUnitChips::SetNum(TMoney money)
{
  int32 num = (int32)money;
  if(num == 0)
  {
	 int16 i=0;
	 for(i=0;i<6;i++)
	 {
		PChips[i]->NoShow();
	 }
	 return;
  }
  int32 col1,col2,col3,col4,col5,col6;
  col6 = (num%100000l)/10000;
  col5 = (num%10000)/1000;
  col4 = (num%1000)/100;
  col3 = (num%100)/25;
  col2 = (num%25)/5;
  col1 = (num%5);
	 if(col1)
	 {
		PChips[0]->CAD.SetCurrentFrame(int16(col1-1));
		PChips[0]->Show();
	 }
	 else
	 {
		PChips[0]->NoShow();
	 }
	 if(col2)
	 {
		PChips[1]->CAD.SetCurrentFrame(int16(col2-1));
		PChips[1]->Show();
	 }
	 else
	 {
		PChips[1]->NoShow();
	 }
	 if(col3)
	 {
		PChips[2]->CAD.SetCurrentFrame(int16(col3-1));
		PChips[2]->Show();
	 }
	 else
	 {
		PChips[2]->NoShow();
	 }
	 if(col4)
	 {
		PChips[3]->CAD.SetCurrentFrame(int16(col4-1));
		PChips[3]->Show();
	 }
	 else
	 {
		PChips[3]->NoShow();
	 }
	 if(col5)
	 {
		PChips[4]->CAD.SetCurrentFrame(int16(col5-1));
		PChips[4]->Show();
	 }
	 else
	 {
		PChips[4]->NoShow();
	 }
	 if(col6)
	 {
		PChips[5]->CAD.SetCurrentFrame(int16(col6-1));
		PChips[5]->Show();
	 }
	 else
	 {
		PChips[5]->NoShow();
	 }
}
//*******************************************************************
