//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  cascdsp.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0    12/23/95    M.Perry    moved inline functions into .cpp file.
//  2.0    09/02/97    M.Perry    32-bit conversion.
//********************************************************************
#include "cascdsp.h"
#include "oanm.h"
#include <assert.h>
//*******************************************************************
TCasCashDisplay::TCasCashDisplay(TOgleModeWindow *pmw,TFileMode NewFileMode,void *psource)
  :TSprite(pmw,NewFileMode,psource)
{
  NoShow();
  SetToManual();
  SetupAnms();
  DelayEndFUC = 0;
  DELAY = false;
}
//*******************************************************************
TCasCashDisplay::TCasCashDisplay(TOgleModeWindow *pmw,TFileMode NewFileMode)
:TSprite(pmw,NewFileMode)
{
  NoShow();
  SetToManual();
  SetupAnms();
  DelayEndFUC = 0;
  DELAY = false;
}
//********************************************************************
TCasCashDisplay::~TCasCashDisplay()
{
}
//*******************************************************************
void TCasCashDisplay::Update(dword NewFUC)
{
  if(DELAY)
  {
	 if(DelayEndFUC<=NewFUC)
	 {
		DELAY = false;
		DelayEndFUC = 0;
	 }
  }
  TSprite::Update(NewFUC);
}
//*******************************************************************
#pragma argsused
void TCasCashDisplay::ShowMessageString(string str,long fuclen,int OffSet)
{
}
//*******************************************************************
#pragma argsused
void TCasCashDisplay::ShowWinNum(TMoney money,long fuclen)
{
}
//*******************************************************************
#pragma argsused
void TCasCashDisplay::ShowCashOut(TMoney money,long fuclen)
{
}
//*******************************************************************
#pragma argsused
void TCasCashDisplay::ShowBetNum(TMoney money,long fuclen)
{
}
//*******************************************************************
#pragma argsused
void TCasCashDisplay::NoShowDisplay(BOOL back)
{
}
//*******************************************************************
void TCasCashDisplay::SetupAnms()
{
  int j=0;
  PDigits[10] = GetAnm(0);
  PDigits[9]  = GetAnm(1);
  PBillComma  = GetAnm(2);
  PDigits[8]  = GetAnm(3);
  PDigits[7]  = GetAnm(4);
  PDigits[6]  = GetAnm(5);
  PMillComma  = GetAnm(6);
  PDigits[5]  = GetAnm(7);
  PDigits[4]  = GetAnm(8);
  PDigits[3]  = GetAnm(9);
  PThouComma  = GetAnm(10);
  PDigits[2]  = GetAnm(11);
  PDigits[1]  = GetAnm(12);
  PDigits[0]  = GetAnm(13);

  for(j=0;j<11;j++)
  {
	 PDigits[j]->CAD.ClearAutoStart();
	 PDigits[j]->CAD.ClearAutoStop();
	 PDigits[j]->CAD.SetDirStill();
	 assert(PDigits[j]);
  }
  PThouComma->CAD.ClearAutoStart();
  PThouComma->CAD.ClearAutoStop();
  PThouComma->CAD.SetDirStill();
  assert(PThouComma);
  PMillComma->CAD.ClearAutoStart();
  PMillComma->CAD.ClearAutoStop();
  PMillComma->CAD.SetDirStill();
  assert(PMillComma);
  PBillComma->CAD.ClearAutoStart();
  PBillComma->CAD.ClearAutoStop();
  PBillComma->CAD.SetDirStill();
  assert(PBillComma);
}
//*******************************************************************
#pragma argsused
int TCasCashDisplay::SetNum(TMoney money,long fuclen)
{
  long num = (long)money;
  int framesused=13,i=0;
  bool found=false;
  long billion=0;
  long hunmil=0;
  long tenmil=0;
  long million=0;
  long hunthou=0;
  long tenthou=0;
  long thousan=0;
  long hun=0;
  long ten=0;
  long one=0;

  for(i=0;i<11;i++)
  {
	 PDigits[i]->CAD.SetX(PDigits[i]->SAD.GetX());
	 PDigits[i]->CAD.SetCurrentFrame(0);
	 PDigits[i]->NoShow();
  }
  PThouComma->CAD.SetX(PThouComma->SAD.GetX());
  PMillComma->CAD.SetX(PThouComma->SAD.GetX());
  PBillComma->CAD.SetX(PThouComma->SAD.GetX());
  PThouComma->CAD.SetCurrentFrame(0);
  PMillComma->CAD.SetCurrentFrame(0);
  PBillComma->CAD.SetCurrentFrame(0);
  PThouComma->NoShow();
  PMillComma->NoShow();
  PBillComma->NoShow();
  if( (num/1000) )
  {
	 PThouComma->Show();
  }
  else{PThouComma->NoShow();}
  if( (num/1000000l) )
  {
	 PMillComma->Show();
  }
  else{PMillComma->NoShow();}
  if( (num/1000000000l) )
  {
	 PBillComma->Show();
  }
  else{PBillComma->NoShow();}

  billion = (num/1000000000l)%10;
  if(!billion && !found){framesused-=2;}else{found=true;}

  hunmil  = (num/100000000l)%10;
  if(!hunmil && !found){framesused--;}else{found=true;}

  tenmil  = (num/10000000l)%10;
  if(!tenmil && !found){framesused--;}else{found=true;}

  million = (num/1000000l) %10;
  if(!million && !found){framesused-=2;}else{found=true;}

  hunthou = (num/100000l)  %10;
  if(!hunthou && !found){framesused--;}else{found=true;}

  tenthou = (num/10000)   %10;
  if(!tenthou && !found){framesused--;}else{found=true;}

  thousan = (num/1000)    %10;
  if(!thousan && !found)   {framesused-=2;}else{found=true;}

  hun     = (num/100)     %10;
  if(!hun && !found)    {framesused--;}else{found=true;}

  ten     = (num/10)      %10;
  if(!ten && !found)    {framesused--;}else{found=true;}

  one     = (num  )       %10;
  if(!one && !found)    {framesused--;}else{found=true;}

  if(framesused == 3)
  {
	 PDigits[3]->CAD.SetX(int16(PDigits[3]->SAD.GetX()+3));
  }
  if(framesused == 7)
  {
	 PDigits[6]->CAD.SetX(int16(PDigits[6]->SAD.GetX()+3));
  }
  if(framesused == 11)
  {
	 PDigits[9]->CAD.SetX(int16(PDigits[9]->SAD.GetX()+3));
  }
  for(i=0;i<11;i++)
  {
	 PDigits[i]->CAD.SetX(int16(PDigits[i]->CAD.GetX()-((6-(framesused/2))*8)));
  }
  PBillComma->CAD.SetX(int16(PBillComma->CAD.GetX()-((6-(framesused/2))*8)));
  PMillComma->CAD.SetX(int16(PMillComma->CAD.GetX()-((6-(framesused/2))*8)));
  PThouComma->CAD.SetX(int16(PThouComma->CAD.GetX()-((6-(framesused/2))*8)));
  PDigits[0]->CAD.SetCurrentFrame(int16(one+1));
  PDigits[0]->Show();

  if(framesused > 1)
  {
	 PDigits[1]->CAD.SetCurrentFrame(int16(ten+1));
	 PDigits[1]->Show();
  }
  else
  {
	 if(framesused == 0 || framesused == 1)
	 {
		PDigits[1]->CAD.SetCurrentFrame(0);
		PDigits[1]->Show();
	 }
	 else
	 {
		PDigits[1]->NoShow();
	 }
  }

  if(framesused > 2)
  {
	 PDigits[2]->CAD.SetCurrentFrame(int16(hun+1));
	 PDigits[2]->Show();
  }
  else
  {
	 if(framesused == 2)
	 {
		PDigits[2]->CAD.SetCurrentFrame(0);
		PDigits[2]->Show();
	 }
	 else
	 {
		PDigits[2]->NoShow();
	 }
  }

  if(framesused > 4)
  {
	 PDigits[3]->CAD.SetCurrentFrame(int16(thousan+1));
	 PDigits[3]->Show();
  }
  else
  {
	 if(framesused == 3)
	 {
		PDigits[3]->CAD.SetCurrentFrame(0);
		PDigits[3]->Show();
	 }
	 else
	 {
		PDigits[3]->NoShow();
	 }
  }

  if(framesused > 5)
  {
	 PDigits[4]->CAD.SetCurrentFrame(int16(tenthou+1));
	 PDigits[4]->Show();
  }
  else
  {
	 if(framesused == 5)
	 {
		PDigits[4]->CAD.SetCurrentFrame(0);
		PDigits[4]->Show();
	 }
	 else
	 {
		PDigits[4]->NoShow();
	 }
  }

  if(framesused > 6)
  {
	 PDigits[5]->CAD.SetCurrentFrame(int16(hunthou+1));
	 PDigits[5]->Show();
  }
  else
  {
	 if(framesused == 6)
	 {
		PDigits[5]->CAD.SetCurrentFrame(0);
		PDigits[5]->Show();
	 }
	 else
	 {
		PDigits[5]->NoShow();
	 }
  }

  if(framesused > 8)
  {
	 PDigits[6]->CAD.SetCurrentFrame(int16(million+1));
	 PDigits[6]->Show();
  }
  else
  {
	 if(framesused == 7)
	 {
		PDigits[6]->CAD.SetCurrentFrame(0);
		PDigits[6]->Show();
	 }
	 else
	 {
		PDigits[6]->NoShow();
	 }
  }

  if(framesused > 9)
  {
	 PDigits[7]->CAD.SetCurrentFrame(int16(tenmil+1));
	 PDigits[7]->Show();
  }
  else
  {
	 if(framesused == 9)
	 {
		PDigits[7]->CAD.SetCurrentFrame(0);
		PDigits[7]->Show();
	 }
	 else
	 {
		PDigits[7]->NoShow();
	 }
  }

  if(framesused > 10)
  {
	 PDigits[8]->CAD.SetCurrentFrame(int16(hunmil+1));
	 PDigits[8]->Show();
  }
  else
  {
	 if(framesused == 10)
	 {
		PDigits[8]->CAD.SetCurrentFrame(0);
		PDigits[8]->Show();
	 }
	 else
	 {
		PDigits[8]->NoShow();
	 }
  }
  if(framesused > 11)
  {
	 PDigits[9]->CAD.SetCurrentFrame(int16(billion+1));
	 PDigits[9]->Show();
  }
  else
  {
	 if(framesused == 11)
	 {
		PDigits[9]->CAD.SetCurrentFrame(0);
		PDigits[9]->Show();
	 }
	 else
	 {
		PDigits[9]->NoShow();
	 }
  }
  if(framesused > 13)
  {
	 PDigits[10]->CAD.SetCurrentFrame(int16(billion+1));
	 PDigits[10]->Show();
  }
  else
  {
	 if(framesused == 13)
	 {
		PDigits[10]->CAD.SetCurrentFrame(0);
		PDigits[10]->Show();
	 }
	 else
	 {
		PDigits[10]->NoShow();
	 }
  }

  Update(GetAdjFUC());
  return framesused;
}
//*******************************************************************
