//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  casglord.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     2/2/96     M.Perry    original baseline
//  2.0    08/31/97    M.Perry    32-bit conversion.
//********************************************************************
#include "casglord.h"
#include "cplaymgr.h"
#include "ogamefw.h"
#include "casctrl.h"
//*******************************************************************
TCasinoGameLord::TCasinoGameLord(TOgleModeWindow *PNewOwnerWindow,const TFileMode &fm,
                                 int16 subgametype,int16 denomid)
:TGameLord(PNewOwnerWindow,fm),
  SubGameType(subgametype),
  GameDenom(TMoney::ctorDenomID,denomid), //GameDenom(TMoney::DIDToMoney(denomid)),
  DenomID(denomid)
{
  activeplayer = 0;
  WaitOnButtonDown = false;
}
  //*******************************************************************
TCasinoGameLord::~TCasinoGameLord()
{
}
//*******************************************************************
int16 TCasinoGameLord::GetDenomID()
{
// darn it, coinsize is in children classes.
//  if (coinsize != GameDenom)
//  {
//    GameDenom = coinsize;
//  }
  return GameDenom.GetDenomID();
}
//*******************************************************************
TCasinoGameData *TCasinoGameLord::GetCasGameData()
{
  return ((TCasinoPlayerMgr *)GetFW()->GetPlayerMgr())->GetCasinoGameDataPtr();
}
//*******************************************************************
TCasinoPlayer *TCasinoGameLord::GetCasPlayer(int16 slotnum)
{
//  if (GetCasMW()->GObj == NULL) {return NULL;}
//  if(slotnum < 0){return NULL;}
//  if (slotnum >= GetCasMW()->NumPlayers) {return NULL;}
//  return ((TCasinoPlayer *)GetCasMW()->GObj[slotnum]);
  return (TCasinoPlayer *)GetCasMW()->GetPlayer(slotnum);
}
//*******************************************************************
TCasinoPlayerData *TCasinoGameLord::GetCasPD(int16 slotnum)
{
  if (GetCasPlayer(slotnum) != NULL) {return (GetCasPlayer(slotnum)->GetCasPD());}
  return NULL;
}
//*******************************************************************
void TCasinoGameLord::AddCash(int16 slotnum,TMoney cash)
{
  if (GetCasPD(slotnum) != NULL)
  {
    GetCasPD(slotnum)->AddCash(cash);
  }
}
//*******************************************************************
void TCasinoGameLord::SubCash(int16 slotnum,TMoney cash)
{
  if (GetCasPD(slotnum) != NULL)
  {
    GetCasPD(slotnum)->SubCash(cash);
  }
}
//*******************************************************************
TMoney TCasinoGameLord::GetCash(int16 slotnum)
{
  if (GetCasPD(slotnum) != NULL) {return (GetCasPD(slotnum)->Cash);}
  return 0l;
}
//*******************************************************************
void TCasinoGameLord::SetCash(int16 slotnum,TMoney cash)
{
  if (GetCasPD(slotnum) != NULL)
  {
    GetCasPD(slotnum)->Cash = cash;
    #if defined(ROUNDCASHTO5CENT)
    GetCasPD(slotnum)->Cash.RoundTo5Cent();
    #endif
  }
}
//*******************************************************************
int16 TCasinoGameLord::GetNumActivePlayers()
{
  int16 x=0;
  if(GetCasPD(0) != NULL)
  {
    x++;
  }
  if(GetCasPD(1) != NULL)
  {
    x++;
  }
  if(GetCasPD(2) != NULL)
  {
    x++;
  }
  return x;
}
//*******************************************************************
int16 TCasinoGameLord::NextSlotNum(int16 activeplayernum)
{
  if(GetCasPD(int16((activeplayernum+1)%3)) != NULL)
  {
    return int16((activeplayernum+1)%3);
  }
  if(GetCasPD(int16((activeplayernum+2)%3)) != NULL)
  {
    return int16((activeplayernum+2)%3);
  }
  if(GetCasPD(int16((activeplayernum+3)%3)) != NULL)
  {
    return int16((activeplayernum+3)%3);
  }
  return -1;
}
//*******************************************************************
