//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  GedApp.h
//    Project Name:  Game Editor
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     7/24/95    M.Perry    original baseline
//  2.0    10/29/97    M.Perry    32-bit conversion.
//********************************************************************
#if !defined(__gedapp_h)
#define __gedapp_h

#if !defined(__oapp_h)
#include "oapp.h"
#endif

#if !defined(__gframeed_h)
#include "gframeed.h"
#endif

#if !defined(__geddef_h)
#include "geddef.h"
#endif

class TGEdIniFile;
//*******************************************************************
class TVDFlags
{
protected:
  bool GameValid;
  bool ModeValid;
  bool GObjValid;
  bool SpriteValid;
  bool SkitCatValid;
  bool SkitValid;
  bool GameDirty;
  bool ModeDirty;
  bool GObjDirty;
  bool SpriteDirty;
  bool SkitCatDirty;
  bool SkitDirty;

public:
  TVDFlags();
  ~TVDFlags();
  void ClearAllValid();

  bool IsGameValid();
  void SetGameValid();
  void ClearGameValid();

  bool IsModeValid();
  void SetModeValid();
  void ClearModeValid();

  bool IsGObjValid();
  void SetGObjValid();
  void ClearGObjValid();

  bool IsSpriteValid();
  void SetSpriteValid();
  void ClearSpriteValid();

  bool IsSkitCatValid();
  void SetSkitCatValid();
  void ClearSkitCatValid();

  bool IsSkitValid();
  void SetSkitValid();
  void ClearSkitValid();

  bool IsGameDirty();
  void SetGameDirty();
  void ClearGameDirty();

  bool IsModeDirty();
  void SetModeDirty();
  void ClearModeDirty();

  bool IsGObjDirty();
  void SetGObjDirty();
  void ClearGObjDirty();

  bool IsSpriteDirty();
  void SetSpriteDirty();
  void ClearSpriteDirty();

  bool IsSkitCatDirty();
  void SetSkitCatDirty();
  void ClearSkitCatDirty();

  bool IsSkitDirty();
  void SetSkitDirty();
  void ClearSkitDirty();

  void ClearAllDirty();
};
//*******************************************************************
class GEDOWLCLASS TGameEditorApp:public TOgleApp
{
public:
  static TGameEditorApp *GetGEdApp() {return (TGameEditorApp *)GetOgleApp();}
  virtual void GetAppInfo(TOgleAppInfo &appinfo);
  TGEdIniFile *GetIniFile() {return (TGEdIniFile *)GetIniFile();}
  virtual void CreateIniFile();
  TGameEditorApp(string NewHDDrive,string NewHDDir,string NewAppName);
  virtual ~TGameEditorApp() {}
  virtual TOgleGameFrameWindow *CreateGameFrameWindow();
  virtual void CreateGameFile();
  TVDFlags VDFlags;
};
//*******************************************************************
//******************** TVDFlags inlines *****************************
//*******************************************************************
inline TVDFlags::TVDFlags()
{
  ClearAllValid();
  ClearAllDirty();
}
//*******************************************************************
inline TVDFlags::~TVDFlags()
{
  ClearAllValid();
  ClearAllDirty();
}
//*******************************************************************
inline void TVDFlags::ClearAllValid()
{
  ClearGameValid();
  ClearModeValid();
  ClearGObjValid();
  ClearSpriteValid();
  ClearSkitCatValid();
  ClearSkitValid();
}
//*******************************************************************
inline bool TVDFlags::IsGameValid()
{
  return GameValid;
}
//*******************************************************************
inline void TVDFlags::SetGameValid()
{
  GameValid = true;
}
//*******************************************************************
inline void TVDFlags::ClearGameValid()
{
  GameValid = false;
}
//*******************************************************************
inline bool TVDFlags::IsModeValid()
{
  return ModeValid;
}
//*******************************************************************
inline void TVDFlags::SetModeValid()
{
  ModeValid = true;
}
//*******************************************************************
inline void TVDFlags::ClearModeValid()
{
  ModeValid = false;
}
//*******************************************************************
inline bool TVDFlags::IsGObjValid()
{
  return GObjValid;
}
//*******************************************************************
inline void TVDFlags::SetGObjValid()
{
  GObjValid = true;
}
//*******************************************************************
inline void TVDFlags::ClearGObjValid()
{
  GObjValid = false;
}
//*******************************************************************
inline bool TVDFlags::IsSpriteValid()
{
  return SpriteValid;
}
//*******************************************************************
inline void TVDFlags::SetSpriteValid()
{
  SpriteValid = true;
}
//*******************************************************************
inline void TVDFlags::ClearSpriteValid()
{
  SpriteValid = false;
}
//*******************************************************************
inline bool TVDFlags::IsSkitCatValid()
{
  return SkitCatValid;
}
//*******************************************************************
inline void TVDFlags::SetSkitCatValid()
{
  SkitCatValid = true;
}
//*******************************************************************
inline void TVDFlags::ClearSkitCatValid()
{
  SkitCatValid = false;
}
//*******************************************************************
inline bool TVDFlags::IsSkitValid()
{
  return SkitValid;
}
//*******************************************************************
inline void TVDFlags::SetSkitValid()
{
  SkitValid = true;
}
//*******************************************************************
inline void TVDFlags::ClearSkitValid()
{
  SkitValid = false;
}
//*******************************************************************
inline bool TVDFlags::IsGameDirty()
{
  return GameDirty;
}
//*******************************************************************
inline void TVDFlags::SetGameDirty()
{
  GameDirty = true;
}
//*******************************************************************
inline void TVDFlags::ClearGameDirty()
{
  GameDirty = false;
}
//*******************************************************************
inline bool TVDFlags::IsModeDirty()
{
  return ModeDirty;
}
//*******************************************************************
inline void TVDFlags::SetModeDirty()
{
  ModeDirty = true;
  SetGameDirty();
}
//*******************************************************************
inline void TVDFlags::ClearModeDirty()
{
  ModeDirty = false;
}
//*******************************************************************
inline bool TVDFlags::IsGObjDirty()
{
  return GObjDirty;
}
//*******************************************************************
inline void TVDFlags::SetGObjDirty()
{
  GObjDirty = true;
  SetModeDirty();
}
//*******************************************************************
inline void TVDFlags::ClearGObjDirty()
{
  GObjDirty = false;
}
//*******************************************************************
inline bool TVDFlags::IsSpriteDirty()
{
  return SpriteDirty;
}
//*******************************************************************
inline void TVDFlags::SetSpriteDirty()
{
  SpriteDirty = true;
  SetGObjDirty();
}
//*******************************************************************
inline void TVDFlags::ClearSpriteDirty()
{
  SpriteDirty = false;
}
//*******************************************************************
inline bool TVDFlags::IsSkitCatDirty()
{
  return SkitCatDirty;
}
//*******************************************************************
inline void TVDFlags::SetSkitCatDirty()
{
  SkitCatDirty = true;
  SetGObjDirty();
}
//*******************************************************************
inline void TVDFlags::ClearSkitCatDirty()
{
  SkitCatDirty = false;
}
//*******************************************************************
inline bool TVDFlags::IsSkitDirty()
{
  return SkitDirty;
}
//*******************************************************************
inline void TVDFlags::SetSkitDirty()
{
  SkitDirty = true;
  SetGObjDirty();
}
//*******************************************************************
inline void TVDFlags::ClearSkitDirty()
{
  SkitDirty = false;
}
//*******************************************************************
inline void TVDFlags::ClearAllDirty()
{
  ClearGameDirty();
  ClearModeDirty();
  ClearGObjDirty();
  ClearSpriteDirty();
  ClearSkitCatDirty();
  ClearSkitDirty();
}
//*******************************************************************
#endif

