//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  gframeed.h
//    Project Name:  Game Editor
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//   1.0    7/24/95    M.Perry     original baseline
//   2.0   10/28/97    M.Perry     32-bit conversion.
//********************************************************************
#if !defined(__gframeed_h)
#define __gframeed_h

#if !defined(__gedapp_rh)
#include "gedapp.rh"
#endif

#if !defined(__ogamefw_h)
#include "ogamefw.h"
#endif

#if !defined(__gedmodew_h)
#include "gedmodew.h"
#endif

#if !defined(__gedskted_h)
#include "gedskted.h"
#endif

#if !defined(__gedspred_h)
#include "gedspred.h"
#endif

#if !defined(OWL_OPENSAVE_H)
#include <owl\opensave.h>
#endif

#if !defined(__omisc_h)
#include "omisc.h"
#endif

#if !defined(OWL_INPUTDIA_H)
#include <owl\inputdia.h>
#endif

#if !defined(__gedctrl_h)
#include "gedctrl.h"
#endif

#if !defined(__geddef_h)
#include "geddef.h"
#endif

class GEDOWLCLASS TGameEditorApp;
//*******************************************************************
class GEDOWLCLASS TEditFrameWin : public TOgleGameFrameWindow
{
protected:
  TGedControl *PControl;
  string UserName;
  string GetUserName();

public:
  virtual void CreateSplash();
  TVDFlags &GetVDFlags();
  void DoMenu();
  void DoAccel();

  TEditFrameWin(TOgleApp *papp,string title);
  virtual ~TEditFrameWin();

  virtual TWindow *CreateModeWindow(int16 ModeIndex);

  virtual void HandleSwitchClients(TOgleMsg &msg);
  virtual void HandleSwitchModes(TOgleMsg &msg);
  void HandleSwitchToSprPreview(TOgleMsg &msg);
  void HandleSwitchToSktPreview(TOgleMsg &msg);
  void HandleSwitchToSprEd(TOgleMsg &msg);
  void HandleSwitchToSktEd(TOgleMsg &msg);
  void HandleSwitchToMEd(TOgleMsg &msg);

  void SwitchToSpriteEditor();
  void SwitchToSkitEditor();

  TSpriteEditorClientWin *PSpriteEditorWin;
  TSkitEditorClientWin *PSkitEditorWin;

  virtual bool CanCloseClientW() {return true;}
  virtual void HandleOldClientW(bool IsMW,int16 mi,int16 action = 0);
  virtual TWindow *CreateNewClientW(bool IsMW,int16 mi,int16 action = 0);
  virtual void HandleNewClientW(bool IsMW,int16 mi,int16 action = 0);

  virtual void SetupWindow();

  void CmGameNewEnable(TCommandEnabler &commandHandler);
  void CmGameOpenEnable(TCommandEnabler &commandHandler);
  void CmGameSaveEnable(TCommandEnabler &commandHandler);
  void CmGameSaveAsEnable(TCommandEnabler &commandHandler);
  void CmGameEditPaletteEnable(TCommandEnabler &commandHandler);
  void CmGameEditSpriteTypeEnable(TCommandEnabler &commandHandler);
  void CmGameWads();
  void CeGameWads(TCommandEnabler &ce);
  void CmGameExitEnable(TCommandEnabler &commandHandler);
  void CmModeNewEnable(TCommandEnabler &commandHandler);
  void CmModeOpenEnable(TCommandEnabler &commandHandler);
  void CmModeDelete();
  void CeModeDelete(TCommandEnabler &ce);
  void CmModeOpenSaveAll();
  void CeModeOpenSaveAll(TCommandEnabler &ce);
  void CmGObjEditSpritesEnable(TCommandEnabler &commandHandler);
  void CmGObjEditSkitsEnable(TCommandEnabler &commandHandler);
  void CmHelpAboutEnable(TCommandEnabler &commandHandler);

  void CmGameNew();
  void ChangeToNewGame(string GameFullPathName);
  void CopyDefFiles(string NewGamePathName);
  void CmGameOpen();

  void ChangeToExistingGame(string GameFullPathName);
  void CmGameSave();
  void CmGameSaveAs();
  void CmGameEditPalette();
  void CmGameEditSpriteType();
  void CmGameExit();
  void ChangeToNewMode(string NewModeName);
  void CmModeNew();
  void ChangeToMode(string NewModeName);
  void CmModeOpen();
  void CmGObjEditSprites();
  void CmGObjEditSkits();
  void CmHelpAbout();

  DECLARE_RESPONSE_TABLE(TEditFrameWin);
};
//*******************************************************************
#endif

