//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  gedspm.cpp
//    Project Name:  GEd
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     8/17/95    M.Perry     original baseline
//  2.0    10/28/97    M.Perry     32-bit conversion.
//********************************************************************
#include "gedspm.h"
//*******************************************************************
TGEdModePreviewSpriteState::TGEdModePreviewSpriteState(TEditorModeWin *PNewModeWindow)
:TGEdModeState(PNewModeWindow)
{
  #ifdef STATEDEBUG
  strcpy(ClassName,"TGEdModePreviewSpriteState");
  #endif
  LBEvent = false;
}
//*******************************************************************
TGEdModePreviewSpriteState::~TGEdModePreviewSpriteState()
{
  GetGEdModeWin()->SpritePreviewDone = true;
}
//*******************************************************************
void TGEdModePreviewSpriteState::ExecuteFirstTime()
{
  ExecuteStatus = ess_Execute;
  LBEvent = false;
  JustStarted = true;
}
//*******************************************************************
void TGEdModePreviewSpriteState::Execute()
{
  if (JustStarted)
  {
    ExecuteWaiting = true;
    JustStarted = false;
  }

  if (ExecuteWaiting)
  {
    if (!LBEvent)
    {
      if (!(POwnerWindow->IsActiveSprite(GetGEdModeWin()->PreviewGObjIndex,
                                         GetGEdModeWin()->PreviewSpriteIndex)))
      {
//        dword CFUC = POwnerWindow->PTime->GetFrameUpdateCount();
//        CFUC += 2;
        dword CFUC = POwnerWindow->GetAdjFUC();
        POwnerWindow->ActivateSprite(GetGEdModeWin()->PreviewGObjIndex,
                                     GetGEdModeWin()->PreviewSpriteIndex,
                                     CFUC);
      }
    }
    else
    {
      if (!POwnerWindow->IsActiveSprite(GetGEdModeWin()->PreviewGObjIndex,
                                        GetGEdModeWin()->PreviewSpriteIndex))
      {
        ExecuteWaiting = false;
        ExecuteStatus = ess_Done;
      }
    }
  }
  else // !EventWaiting
  {
    ExecuteStatus = ess_Done;
  }
}
//*******************************************************************
#pragma argsused
bool TGEdModePreviewSpriteState::HandleLDown(uint modKeys, TPoint &point)
{
  LBEvent = true;
  return false;
}
//*******************************************************************
void TGEdModePreviewSpriteState::RecommendSibling()
{
  Status = ss_Done;
}
//*******************************************************************

