//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  gframeed.cpp
//    Project Name:  Game Editor
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     7/24/95    M.Perry     original baseline
//  2.0    10/28/97    M.Perry     32-bit conversion.
//********************************************************************
#if !defined(__gframeed_h)
#include "gframeed.h"
#endif

#if !defined(__gedapp_h)
#include "gedapp.h"
#endif

#if !defined(__odetlist_h)
#include "odetlist.h"
#endif

#if !defined(__ofilemgr_h)
#include "ofilemgr.h"
#endif

#if !defined(__ogame_h)
#include "ogame.h"
#endif

#if !defined(__omode_h)
#include "omode.h"
#endif

#if !defined(__ofilenam_h)
#include "ofilenam.h"
#endif

//#if !defined(__oversion_h)
//#include "oversion.h"
//#endif

#if !defined(__ogobjlst_h)
#include "ogobjlst.h"
#endif

#if !defined(__osmsgdlg_h)
#include "osmsgdlg.h"
#endif

// the following defines used by switchclientw().
#define aNone 0
#define aStartSprEd 1
#define aStartSktEd 2
#define aReturnSprEd 3
#define aReturnSktEd 4
#define aReturnMode 5
#define aPreviewMode 6
//*******************************************************************
DEFINE_RESPONSE_TABLE1(TEditFrameWin,TOgleGameFrameWindow)
  EV_COMMAND(CM_GAMENEW,CmGameNew),
  EV_COMMAND_ENABLE(CM_GAMENEW,CmGameNewEnable),
  EV_COMMAND(CM_GAMEOPEN,CmGameOpen),
  EV_COMMAND_ENABLE(CM_GAMEOPEN,CmGameOpenEnable),
  EV_COMMAND(CM_GAMESAVE,CmGameSave),
  EV_COMMAND_ENABLE(CM_GAMESAVE,CmGameSaveEnable),
  EV_COMMAND(CM_GAMESAVEAS,CmGameSaveAs),
  EV_COMMAND_ENABLE(CM_GAMESAVEAS,CmGameSaveAsEnable),
  EV_COMMAND(CM_GAMEEDITPALETTE,CmGameEditPalette),
  EV_COMMAND_ENABLE(CM_GAMEEDITPALETTE,CmGameEditPaletteEnable),
  EV_COMMAND(CM_GAMEEDITSPRITETYPE,CmGameEditSpriteType),
  EV_COMMAND_ENABLE(CM_GAMEEDITSPRITETYPE,CmGameEditSpriteTypeEnable),
  EV_COMMAND(CM_GAMEWADS,CmGameWads),
  EV_COMMAND_ENABLE(CM_GAMEWADS,CeGameWads),
  EV_COMMAND(CM_GAMEEXIT,CmGameExit),
  EV_COMMAND_ENABLE(CM_GAMEEXIT,CmGameExitEnable),
  EV_COMMAND(CM_MODENEW,CmModeNew),
  EV_COMMAND_ENABLE(CM_MODENEW,CmModeNewEnable),
  EV_COMMAND(CM_MODEOPEN,CmModeOpen),
  EV_COMMAND_ENABLE(CM_MODEOPEN,CmModeOpenEnable),
  EV_COMMAND(CM_MODEDELETE,CmModeDelete),
  EV_COMMAND_ENABLE(CM_MODEDELETE,CeModeDelete),
  EV_COMMAND(CM_MODEOPENSAVEALL,CmModeOpenSaveAll),
  EV_COMMAND_ENABLE(CM_MODEOPENSAVEALL,CeModeOpenSaveAll),
  EV_COMMAND(CM_GOBJEDITSPRITES,CmGObjEditSprites),
  EV_COMMAND_ENABLE(CM_GOBJEDITSPRITES,CmGObjEditSpritesEnable),
  EV_COMMAND(CM_GOBJEDITSKITS,CmGObjEditSkits),
  EV_COMMAND_ENABLE(CM_GOBJEDITSKITS,CmGObjEditSkitsEnable),
  EV_COMMAND(CM_HELPABOUTGED,CmHelpAbout),
  EV_COMMAND_ENABLE(CM_HELPABOUTGED,CmHelpAboutEnable),
END_RESPONSE_TABLE;
//*******************************************************************
void TEditFrameWin::HandleOldClientW(bool IsMW,int16 mi,int16 action)
{
  if (POldClientWin == NULL) {return;}

  if (IsMW)
  {
    if (action == aReturnMode)
    {
      if (POldClientWin == PSpriteEditorWin)
      {
        //delete PSpriteEditorWin;
        PSpriteEditorWin->Destroy();
        GetApplication()->Condemn(PSpriteEditorWin);

        PSpriteEditorWin = NULL;
        POldClientWin = NULL;
      }
      else if (POldClientWin == PSkitEditorWin)
      {
        //delete PSkitEditorWin;
        PSkitEditorWin->Destroy();
        GetApplication()->Condemn(PSkitEditorWin);
        PSkitEditorWin = NULL;
        POldClientWin = NULL;
      }
    }
    else if (action == aPreviewMode)
    {
      // do nothing.
    }
    else
    {
      TOgleGameFrameWindow::HandleOldClientW(IsMW,mi,action);
    }
  }
  else if (PModeWin != NULL) //switching to spr or skt ed.
  {
    PModeWin->SetUpdatePause();
    ((TEditorModeWin *)PModeWin)->ClearPreviews();
  }

  // whoever old client is... we're switching away, so, hide it.
  if (POldClientWin != NULL)
  {
    POldClientWin->Show(SW_HIDE);
  }
}
//*******************************************************************
TWindow *TEditFrameWin::CreateNewClientW(bool IsMW,int16 mi,int16 action)
{
  if (IsMW)
  {
    if ((action == aReturnMode) || (action == aPreviewMode))
    {
      return PModeWin;
    }
    else
    {
      return (TOgleGameFrameWindow::CreateNewClientW(IsMW,mi));
    }
  }
  else
  {
    // make sprite ed, or skit ed.
    switch (action)
    {
      case aStartSprEd:
      case aReturnSprEd:
      {
        if (PSpriteEditorWin == NULL)
          {
            PSpriteEditorWin = new TSpriteEditorClientWin;
          }
        return PSpriteEditorWin;
      }
      case aStartSktEd:
      case aReturnSktEd:
      {
        if (PSkitEditorWin == NULL)
          {
            PSkitEditorWin = new TSkitEditorClientWin;
          }
        return PSkitEditorWin;
      }
      default:return PModeWin;
    }
  }
}
//*******************************************************************
#pragma argsused
void TEditFrameWin::HandleNewClientW(bool IsMW,int16 mi,int16 action)
{
  if (IsMW)
  {
    if (PModeWin == NULL) {return;}

    PModeWin->Initialize(0);   // key step here. Also, If already inited, then nothing happens.

    if (action == aNone)
    {
      PModeWin->BeenSwitchedTo();
    }
    else if (action == aReturnMode)
    {
      PModeWin->BeenSwitchedTo();
    }
    else if (action == aPreviewMode)
    {
      PModeWin->ClearUpdatePause();
    }
  }
  else
  {
    switch (action)
    {
      case aStartSprEd:
      {
        PSpriteEditorWin->BeenSwitchedTo();
        break;
      }
      case aStartSktEd:
      {
        PSkitEditorWin->BeenSwitchedTo();
        break;
      }
      case aReturnSprEd:
      {
        PSpriteEditorWin->BackFromPreview();
        break;
      }
      case aReturnSktEd:
      {
        PSkitEditorWin->BackFromPreview();
        break;
      }
      default:break;
    }
  }
}
//*******************************************************************
void TEditFrameWin::DoMenu()
{
  AssignMenu(GED_MENU);
}
//*******************************************************************
void TEditFrameWin::DoAccel()
{
  Attr.AccelTable = TResId(ACCELERATORS_1);
}
//*******************************************************************
string TEditFrameWin::GetUserName()
{
  string name;
  bool out = false;
  while (!out)
  {
    char buffer[12] = "Biff";
    TInputDialog *pid = new TInputDialog(this,"Name -> ","Enter User Name",buffer,12);
    int result = pid->Execute();
    name = buffer;
    delete pid;
    if ((result == IDOK) && (name != "Biff") && (name != "")) {out = true;}
  }
  return name;
}
//*******************************************************************
TEditFrameWin::TEditFrameWin(TOgleApp *papp,string title)
:TOgleGameFrameWindow(papp,title)//,false) // MRP - 06/01/99 - ver2.2
{
  DoAccel();
  DoStyle();
  DoMenu();
  PSpriteEditorWin = NULL;
  PSkitEditorWin = NULL;
  PControl = NULL;
}
//*******************************************************************
TEditFrameWin::~TEditFrameWin()
{
  delete PSpriteEditorWin;
  PSpriteEditorWin = NULL;
  delete PSkitEditorWin;
  PSkitEditorWin = NULL;
  delete PControl;
  PControl = NULL;
}
//*******************************************************************
void TEditFrameWin::CreateSplash()
{
  TOgleGameFrameWindow::CreateSplash();
}
//*******************************************************************
TVDFlags &TEditFrameWin::GetVDFlags()
{
//  return (((TGameEditorApp *)GetOgleApp())->VDFlags);
  return TGameEditorApp::GetGEdApp()->VDFlags;
}
//*******************************************************************
void TEditFrameWin::CopyDefFiles(string NewGamePathName)
{
  string drive,dir,name,ext;
  TOgleFileName::SplitUp(NewGamePathName,drive,dir,name,ext);
  string destpal = drive + dir + "mpal.pal";
  string destbg = drive + dir + "mbg.bmp";
  string sourcepal = GetFileMgr()->GetCDRomPath(-1) + "mpal.pal";
  string sourcebg = GetFileMgr()->GetCDRomPath(-1) + "mbg.bmp";
  TOgleFileName::CopyFile(destpal,sourcepal);
  TOgleFileName::CopyFile(destbg,sourcebg);      
}
//*******************************************************************
void TEditFrameWin::ChangeToNewGame(string GameFullPathName)
{
  if (PControl != NULL)
  {
    delete PControl;  // mike - added during ctrl.
    PControl = NULL;
  }

  SwitchClientW(true,-2);
  GetOgleApp()->DestroyPalette();
  GetOgleApp()->DestroyGameFile();
  string drive,dir,name,ext;
  TOgleFileName::SplitUp(GameFullPathName,drive,dir,name,ext);

  CopyDefFiles(GameFullPathName);  // move default bg & pal to new game dir.

//  PFileMgr->SetCDRomDrive(drive);
  GetFileMgr()->PCD->SetDrive(drive);
//  PFileMgr->SetCDRomDir(dir);
  GetFileMgr()->PCD->SetDir(dir);
  GetOgleApp()->GameFileName = "";
  GetOgleApp()->CreateGameFile();
  GetOgleApp()->GetGame()->SetName(name);
  GetOgleApp()->CreatePalette();
  SwitchClientW(true,-1);
  GetVDFlags().SetGameValid();

  PControl = new TGedControl(drive,dir,name,UserName); // mike - added during ctrl.

  CmGameSave();
}
//*******************************************************************
void TEditFrameWin::ChangeToExistingGame(string GameFullPathName)
{
  delete PControl;
  PControl = NULL;

  SwitchClientW(true,-2);
  GetOgleApp()->DestroyPalette();
  GetOgleApp()->DestroyGameFile();
  string drive,dir,name,ext;
  TOgleFileName::SplitUp(GameFullPathName,drive,dir,name,ext);
//  PFileMgr->SetCDRomDrive(drive);
  GetFileMgr()->PCD->SetDrive(drive);
//  PFileMgr->SetCDRomDir(dir);
  GetFileMgr()->PCD->SetDir(dir);
  GetOgleApp()->GameFileName = name;
  GetOgleApp()->CreateGameFile();
  GetOgleApp()->CreatePalette();
  SwitchClientW(true,-1);
  GetVDFlags().SetGameValid();
  GetVDFlags().ClearGameDirty();

  PControl = new TGedControl(drive,dir,name,UserName); // mike - added during ctrl.
}
//*******************************************************************
void TEditFrameWin::CmGameNew()
{
  TOpenSaveDialog::TData FileData(OFN_PATHMUSTEXIST,
                                  "Game Files (*.g) | *.g |",
                                  0,
                                  "",
                                  "g");
  #if !defined(OGLEOWLVER2) && defined(BI_PLAT_WIN32)
  FileData.Flags &= (~OFN_EXPLORER);
  #endif

  TFileSaveDialog tfo(this,FileData,0,"Select dir & name for New Game");
  int retval = tfo.Execute();
  char FileTitle[TOgleFileName::MAXFILEPARTSIZE];

  if (retval == IDOK)
  {
    CmGameSave(); // mike - added during ctrl.
    tfo.GetFileTitle(FileData.FileName,FileTitle,TOgleFileName::MAXFILEPARTSIZE);
    string str = "Filename = ";
    str += FileData.FileName;
    str += "\n";
    str += "FileTitle = ";
    str += FileTitle;
    MessageBox(str.c_str(),"File Open Results",MB_OK);
    string gfn = FileData.FileName;
    ChangeToNewGame(gfn);
  }
}
//*******************************************************************
void TEditFrameWin::CmGameNewEnable(TCommandEnabler &commandHandler)
{
  commandHandler.Enable(true);
}
//*******************************************************************
void TEditFrameWin::CmGameOpen()
{
  TOpenSaveDialog::TData FileData(OFN_FILEMUSTEXIST,
                                  "Game Files (*.g) | *.g |",
                                  0,
                                  "",
                                  "g");

  #if !defined(OGLEOWLVER2) && defined(BI_PLAT_WIN32)
  FileData.Flags &= (~OFN_EXPLORER);
  #endif

  TFileOpenDialog fod(this,FileData,0,"Select existing game file");
  int retval = fod.Execute();
  char FileTitle[TOgleFileName::MAXFILEPARTSIZE];
  if (retval == IDOK)
  {
    fod.GetFileTitle(FileData.FileName,FileTitle,TOgleFileName::MAXFILEPARTSIZE);
    string str = "Filename = ";
    str += FileData.FileName;
    str += "\n";
    str += "FileTitle = ";
    str += FileTitle;
    MessageBox(str.c_str(),"File Open Results",MB_OK);
    string gfn = FileData.FileName;
    ChangeToExistingGame(gfn);
  }
}
//*******************************************************************
void TEditFrameWin::CmGameOpenEnable(TCommandEnabler &commandHandler)
{
  commandHandler.Enable(true);
}
//*******************************************************************
void TEditFrameWin::CmGameSave()
{
  if ((PModeWin != NULL) && GetVDFlags().IsModeValid()) // mike - changed during ctrl.
  {
    ((TEditorModeWin *)PModeWin)->SaveMode();
  }

  // if not master then don't save game file.
  if ((PControl != NULL) && PControl->IsMaster())  // mike - added during ctrl.
  {
//    GetOgleApp()->PGame->Write();
    GetGame()->Write();
    string str = "Game saved\n";
    str += /*POgleApp->*/GetGame()->FileMode.Name.GetStr();
    MessageBox(str.c_str(),"Game - Save",MB_OK);
  }
  else
  {
    string msg = "Game file (only) not saved, not the master user";
    MessageBox(msg.c_str(),"Game - Save",MB_OK);
  }
  GetVDFlags().ClearGameDirty();
}
//*******************************************************************
void TEditFrameWin::CmGameSaveEnable(TCommandEnabler &commandHandler)
{
  if ((GetVDFlags().IsGameDirty()) && (GetVDFlags().IsGameValid()))
  {
    commandHandler.Enable(true);
  }
  else
  {
    commandHandler.Enable(false);
  }
}
//*******************************************************************
void TEditFrameWin::CmGameSaveAs()
{
  MessageBox("Not Implemented Yet","Game - Save As",MB_OK);
}
//*******************************************************************
void TEditFrameWin::CmGameSaveAsEnable(TCommandEnabler &commandHandler)
{
  commandHandler.Enable(false);
}
//*******************************************************************
void TEditFrameWin::CmGameEditPalette()
{
  if (GetModeWin() == NULL || GetModeWin()->GetMode() == NULL)
  {
    ::MessageBox(NULL,
                 "PModeWin or PMode == NULL",
                 "Error - Edit Palette",
                 MB_OK|MB_TASKMODAL);
    return;
  }

  string str = GetOgleApp()->MasterPaletteFileName;

  TOpenSaveDialog::TData filedata(OFN_PATHMUSTEXIST,
                                  "Palette Files (*.pal) | *.pal",
                                  0,
                                  "",
                                  "pal");
  string title = "Select Palette - ";
  title += str;
  TFileOpenDialog tfo(this,filedata,0,title.c_str());
  int retval = tfo.Execute();
//  char FileTitle[16];

  if (retval == IDOK)
  {
//    tfo.GetFileTitle(PFileData->FileName,FileTitle,16);
    TOgleFileName ofn(filedata.FileName);
//    string str = "Filename = ";
//    str += PFileData->FileName;
//    str += "\n";
//    str += "FileTitle = ";
//    str += FileTitle;
//    MessageBox(str.c_str(),"File Open Results",MB_OK);

    // Move file to current CDRom base dir.
//    string DestStr = GetFileMgr()->GetCDRomPath(-1);
//    DestStr += FileTitle;

    TOgleFileName ofndest(GetFileMgr()->GetCDRomPath(-1));
    ofndest.SetFName(ofn.GetFName());
    ofndest.SetExt(ofn.GetExt());


//    string fpn = PFileData->FileName;
//    string drive,dir,name,ext;
//    TOgleFileName::SplitUp(fpn,drive,dir,name,ext);

//    string SourceStr = PFileData->FileName;

//    if (TOgleFileName::CopyFile(DestStr,SourceStr))
    if (ofn.CopyFile(ofndest))
    {
      // if copy success then switch palettes.
//      PModeWin->DeathScreen();
//      GetOgleApp()->ChangePalette(name);
      GetOgleApp()->ChangePalette(ofndest.GetFNameExt());
      PModeWin->GetMode()->NotifyMainPalChanged();
//      PModeWin->ResurrectScreen();
      GetVDFlags().SetGameDirty();
    }
    else
    {
      MessageBox("CopyFile failed","Editing Palette",MB_OK);
    }
  }
//  delete PFileData;
//  PFileData = NULL;
}
//*******************************************************************
void TEditFrameWin::CmGameEditPaletteEnable(TCommandEnabler &commandHandler)
{
  commandHandler.Enable(PControl != NULL &&
                        PControl->IsMaster() &&
                        GetVDFlags().IsGameValid() &&
                        GetModeWin() != NULL &&
                        GetModeWin()->GetMode() != NULL);
//  {
//    commandHandler.Enable(true);
//  }
//  else
//  {
//    commandHandler.Enable(false);
//  }
}
//*******************************************************************
void TEditFrameWin::CmGameEditSpriteType()
{
  MessageBox("Not Implemented Yet","Game - Edit Sprite Type",MB_OK);
}
//*******************************************************************
void TEditFrameWin::CmGameEditSpriteTypeEnable(TCommandEnabler &commandHandler)
{
  commandHandler.Enable(false);
}
//*******************************************************************
//void TEditFrameWin::CmGameWadsEditScript()
//{
//  TDet *PDet = new TDet;
//  string drive = PFileMgr->GetCDRomDrive();
//  string dir = PFileMgr->GetCDRomDir();
//  string filename = POgleApp->GameFileName;
//  PDet->Edit(drive,dir,filename);
//  delete PDet;
//}
//*******************************************************************
//void TEditFrameWin::CeGameWadsEditScript(TCommandEnabler &ce)
//{
//  if (GetVDFlags().IsGameValid())
//  {
//    ce.Enable(true);
//  }
//  else
//  {
//    ce.Enable(false);
//  }
//}
//*******************************************************************
//void TEditFrameWin::CmGameWadsCreateDews()
//{
//  char buffer[100];
//  buffer[0] = '\0';
//  TInputDialog *pid = new TInputDialog(this,"Full Path to dest ->","Create Wads",buffer,100);
//  if (pid->Execute() == IDOK)
//  {
//    string deststr = buffer;
//    string msgstr = "Faking creating files to: '" + deststr + "'";
//    MessageBox(msgstr.c_str(),"Create Dews",MB_OK);
//    string drive = PFileMgr->GetCDRomDrive();
//    string dir = PFileMgr->GetCDRomDir();
//    string filename = POgleApp->GameFileName;
//    TDet *PDet = new TDet;
//    PDet->Create(drive,dir,filename,deststr);
//    delete PDet;
//  }
//}
//*******************************************************************
//void TEditFrameWin::CeGameWadsCreateDews(TCommandEnabler &ce)
//{
//  if (GetVDFlags().IsGameValid())
//  {
//    ce.Enable(true);
//  }
//  else
//  {
//    ce.Enable(false);
//  }
//}
//*******************************************************************
void TEditFrameWin::CmGameWads()
{
  TDetList *pdetlist = new TDetList;
//  string drive = PFileMgr->GetCDRomDrive();
  string drive = GetFileMgr()->PCD->GetDrive();
//  string dir = PFileMgr->GetCDRomDir();
  string dir = GetFileMgr()->PCD->GetDir();
  string filename = GetOgleApp()->GameFileName;
  pdetlist->Edit(this,drive,dir,filename);
  delete pdetlist;
//  MessageBox("not imp yet","Game Wads",MB_OK);
}
//*******************************************************************
void TEditFrameWin::CeGameWads(TCommandEnabler &ce)
{
  if ((PControl != NULL) &&
      PControl->IsMaster() &&
      GetVDFlags().IsGameValid() &&
      !GetVDFlags().IsGameDirty())
  {
    ce.Enable(true);
  }
  else
  {
    ce.Enable(false);
  }
}
//*******************************************************************
void TEditFrameWin::CmGameExit()
{
//  if ((GetVDFlags().IsModeValid()) && (GetVDFlags().IsModeDirty()))
//  {
//    if (PModeWin != NULL) {((TEditorModeWin *)PModeWin)->SaveMode();}
//  }
//  if ((GetVDFlags().IsGameValid()) && (GetVDFlags().IsGameDirty()))
//  {
    CmGameSave();
//  }

  CloseWindow(0);
}
//*******************************************************************
void TEditFrameWin::CmGameExitEnable(TCommandEnabler &commandHandler)
{
  commandHandler.Enable(true);
}
//*******************************************************************
void TEditFrameWin::ChangeToNewMode(string NewModeName)
{
  if (GetVDFlags().IsModeValid() && PModeWin != NULL)
  {
    ((TEditorModeWin *)PModeWin)->SaveMode();
  }
  if (PControl != NULL) {PControl->ClearModeLock();} // mike - added during ctrl.

  SwitchClientW(true,-1);

  if (PModeWin == NULL ||
      PModeWin->GetMode() == NULL ||
      PModeWin->GetMode()->GetGObjList() == NULL)
  {
    MessageBox("modewin, or mode, or gobjlist was NULL","Error - Change to new mode",MB_OK);
    exit(EXIT_FAILURE);
  }

  GetVDFlags().SetGameDirty();
  GetVDFlags().ClearModeDirty();
  GetVDFlags().ClearModeValid();
  GetVDFlags().ClearGObjDirty();
  GetVDFlags().ClearGObjValid();
  GetVDFlags().ClearSpriteValid();
  GetVDFlags().ClearSpriteDirty();
  GetVDFlags().ClearSkitValid();
  GetVDFlags().ClearSkitDirty();
//  if (PModeWin->PMode->SetBaseName(NewModeName) == false)
//  PModeWin->PMode->FileMode.Name = NewModeName;
  PModeWin->GetMode()->FileMode.Name = NewModeName;
//  PModeWin->PMode->FileMode.Name.SetExt(PModeWin->PMode->AddExt());
  PModeWin->GetMode()->FileMode.Name.SetExt(PModeWin->GetMode()->AddExt());
//  {
//    MessageBox("Changing default Mode Window to named mode failed","Error - New Mode",MB_OK);
////    GetVDFlags().ClearModeDirty();
////    GetVDFlags().ClearModeValid();
//    return;
//  }
  PModeWin->ModeWindowFileName = NewModeName;
//  PModeWin->PMode->Write();

  PModeWin->GetMode()->GetGObjList()->FileMode.Name = NewModeName;
  PModeWin->GetMode()->GetGObjList()->FileMode.Name.SetExt(".gol");
  PModeWin->GetMode()->GObjListName =
                     PModeWin->GetMode()->GetGObjList()->FileMode.Name.GetStr();

  PModeWin->GetMode()->Write();
  string *PStr = new string(NewModeName);
  if (!(GetGame()->AddModeName(PStr)))
  {
    delete PStr;
    PStr = NULL;
    MessageBox("Error occurred adding mode name to game","Error - New Mode",MB_OK);
    return;
  }
//  GetVDFlags().ClearModeDirty();
  GetVDFlags().SetModeValid();

  if (PControl != NULL) {PControl->SetModeLock(NewModeName);}
}
//*******************************************************************
void TEditFrameWin::ChangeToMode(string NewModeName)
{
  if (GetVDFlags().IsModeValid())
  {
    ((TEditorModeWin *)PModeWin)->SaveMode();
  }

  if (PControl != NULL) {PControl->ClearModeLock();} // mike - added during ctrl.

  int16 ModeNum = GetGame()->GetModeIndex(NewModeName);
  SwitchClientW(true,ModeNum);

  GetVDFlags().SetModeValid();
  GetVDFlags().ClearModeDirty();
  GetVDFlags().ClearGObjValid();

  GetVDFlags().ClearSpriteValid();
  GetVDFlags().ClearSkitValid();
  GetVDFlags().ClearSpriteDirty();
  GetVDFlags().ClearSkitDirty();

  if (PControl != NULL) {PControl->SetModeLock(NewModeName);} // mike - added during ctrl.
}
//*******************************************************************
void TEditFrameWin::CmModeNew()
{
#if 0
 // saved in changetonewmode() so commented out here.
 // if (GetVDFlags().IsModeValid())
 // {
 //   ((TEditorModeWin *)PModeWin)->SaveMode();
 // }

  TOgleFileName ofn;
  char buffer[TOgleFileName::MAXFILEPARTSIZE] = "ModeName";
//  string NewModeName;
  string str = "Enter name without ext (" + PModeWin->ModeWindowFileName + ")";
  TInputDialog tid(this,
                   "Enter New Mode Name",
                   str.c_str(),
                   buffer,
                   TOgleFileName::MAXFILEPARTSIZE);
  int retval = tid.Execute();
  if (retval == IDOK)
  {
    ofn = string(buffer);

//    NewModeName = buffer;
//    size_t periodpos = NewModeName.find_first_of(".");
//    if (periodpos < NewModeName.length())
//    {
//      NewModeName.resize(periodpos);
//    }

    ofn.SetExt(GetModeWin()->GetMode()->AddExt());

//    if (GetGame()->GetModeIndex(NewModeName) >= 0)
    if (GetGame()->GetModeIndex(ofn.GetStr()) >= 0)
    {
//      string mestr = "New Mode Name '" + NewModeName + "' already exists.";
      string mestr = "New Mode Name '" + ofn.GetStr() + "' already exists.";
      MessageBox(mestr.c_str(),"Error - New Mode",MB_OK);
      return;
    }
//    string str = "New Mode Name -> " + NewModeName;
    string str = "New Mode Name -> " + ofn.GetStr();

    TOgleFileName ofn2;
    ofn2 = GetFileMgr()->GetCDRomPath(-1);
    ofn2 += ofn.GetStr();
    if (!ofn2.CreateDir())
    {
      MessageBox("couldn't create new dir","Error - Mode New",MB_OK);
      return;
    }

    MessageBox(str.c_str(),"Mode Name entered",MB_OK);
//    ChangeToNewMode(NewModeName);
    ChangeToNewMode(ofn.GetStr());
//    GetVDFlags().SetModeValid();
//    GetVDFlags().ClearModeDirty();
//    GetVDFlags().ClearGObjValid();
//    GetVDFlags().ClearSpriteValid();
//    GetVDFlags().SetGameDirty();
  }
#endif

  string strroot = GetFileMgr()->GetCDRomPath(-1);
  string str = "Mode Files (*.m) | *.m";
  char *pc = const_cast<char *>(str.c_str());
  char *pcinitialdir = const_cast<char *>(strroot.c_str());
  TOpenSaveDialog::TData newmodedata(0,
                                     pc,
                                     0,
                                     pcinitialdir);

  #if !defined(OGLEOWLVER2) && defined(BI_PLAT_WIN32)
  newmodedata.Flags &= (~OFN_EXPLORER);
  #endif

  TFileSaveDialog fsd(this,newmodedata);
  if (fsd.Execute() != IDOK) {return;}

  string s(newmodedata.FileName);
  s = s.strip(string::Both);
  s.to_lower();

  TOgleFileName ofn(s);
  ofn.SetExt(".m");

  if (ofn.FileExists())
  {
    MessageBox("Mode File already exists.",
               "Error - New Mode Name",
               MB_OK | MB_TASKMODAL);
    return;
  }

  TOgleFileName ofndir(ofn);

  if (!ofn.RemoveRoot(GetFileMgr()->GetCDRomPath(-1)))
  {
    MessageBox("New Mode path was not in logical root.",
               "Error - New Mode Name",
               MB_OK | MB_TASKMODAL);
    return;
  }

  if (!ofndir.CreateDir())
  {
    MessageBox("Couldn't create new mode path",
               "Error - New Mode Name",
               MB_OK | MB_TASKMODAL);
    return;
  }

  if (GetGame()->GetModeIndex(ofn.GetStr()) >= 0)
  {
    string mestr = "New Mode Name '" + ofn.GetStr() + "' already exists.";
    MessageBox(mestr.c_str(),"Error - New Mode",MB_OK | MB_TASKMODAL);
    return;
  }

  ChangeToNewMode(ofn.GetStr());
}
//*******************************************************************
void TEditFrameWin::CmModeNewEnable(TCommandEnabler &commandHandler)
{
  if ((PControl != NULL) && PControl->IsMaster() && GetVDFlags().IsGameValid())
  {
    commandHandler.Enable(true);
  }
  else
  {
    commandHandler.Enable(false);
  }
}
//*******************************************************************
void TEditFrameWin::CmModeOpen()
{
  string str = "Mode Open (" + PModeWin->ModeWindowFileName + ")";
  TSelectModeDlg smd(this,str,PModeWin->ModeWindowFileName);
  if (smd.Execute() == IDOK)
  {
    // gets saved in ChangeToMode() so commented out here.
    // if changing modes then save.
    //if (GetVDFlags().IsModeValid())
    //{
    //  ((TEditorModeWin *)PModeWin)->SaveMode();
    //}

    string NewModeName = smd.RetrieveSelection();
//    string str = "Mode name -> " + NewModeName;
//    MessageBox(str.c_str(),"Mode Name selected",MB_OK);

    if (PControl == NULL)    // mike - added during ctrl.
    {
      MessageBox("Control ptr is NULL","Error - Mode Lock",MB_OK);
      return;
    }
    else if (PControl->IsModeLocked(NewModeName))
    {
      string modelockmsg = "The mode '" + NewModeName;
      modelockmsg += "' is locked by '" + PControl->GetModeLockUserName(NewModeName) + "'";
      modelockmsg += "\nSwitch not attempted.";
      MessageBox(modelockmsg.c_str(),"Mode Lock",MB_OK);
      return;
    }
    ChangeToMode(NewModeName);
//    GetVDFlags().SetModeValid();
//    GetVDFlags().ClearModeDirty();
//    GetVDFlags().ClearGObjValid();
//    GetVDFlags().ClearSpriteValid();
  }
}
//*******************************************************************
void TEditFrameWin::CmModeOpenEnable(TCommandEnabler &commandHandler)
{
  if (GetVDFlags().IsGameValid())
  {
    commandHandler.Enable(true);
  }
  else
  {
    commandHandler.Enable(false);
  }
}
//*******************************************************************
void TEditFrameWin::CmModeDelete()
{
  if (PControl == NULL)
  {
    MessageBox("Control ptr is NULL","Error - Delete Mode",MB_OK);
    return;
  }
  if (!PControl->IsMaster())
  {
    MessageBox("Must be master user to delete mode","Error - Delete Mode",MB_OK);
    return;
  }
  TSelectModeDlg smd(this,string("Delete Mode"));
  if (smd.Execute() == IDOK)
  {
    string name = smd.RetrieveSelection();
    if ((PModeWin != NULL) && (PModeWin->ModeWindowFileName == name))
    {
      MessageBox("Can't delete current mode","Error - Delete Mode",MB_OK);
      return;
    }
    if (PControl->IsModeLocked(name))
    {
      MessageBox("Selected mode locked","Error - Delete Mode",MB_OK);
      return;
    }
    if (!PControl->WaitForLock())
    {
      MessageBox("Couldn't get control lock","Error - Delete Mode",MB_OK);
      return;
    }
    if (PControl->GetUserCount() > 1)
    {
      MessageBox("Somebody else working on project","Error - Delete Mode",MB_OK);
      PControl->ReleaseLock();
      return;
    }
    if (!GetGame()->RemoveModeName(name))
    {
      MessageBox("unknown error removing name from game file","Error - Delete Mode",MB_OK);
      PControl->ReleaseLock();
      return;
    }
    PControl->ReleaseLock();
    MessageBox("Mode Delete successful.\nRemember this doesn't delete files from drive.","Delete Mode",MB_OK);
  }
}
//*******************************************************************
void TEditFrameWin::CeModeDelete(TCommandEnabler &ce)
{
  if (GetVDFlags().IsGameValid() && (PControl != NULL) && PControl->IsMaster())
  {
    ce.Enable(true);
  }
  else
  {
    ce.Enable(false);
  }
}
//*******************************************************************
void TEditFrameWin::CmModeOpenSaveAll()
{
  int16 nummodes = GetGame()->GetNumModes();
  for (int16 i=0;i<nummodes;i++)
  {
    string modename = GetGame()->GetModeName(i);
    if (modename == "") {continue;}
    if (PControl->IsModeLocked(modename))
    {
      string s = "From: Open Save All\nMode: ";
      s += modename;
      s += " Locked.\nWill skip to next one.";
      MessageBox(s.c_str(),"Warning !!",MB_OK);
      continue;
    }
    ChangeToMode(modename);
    // mrp - v2.4 - added for catching any sprite id conflicts.
    if (GetModeWin() != NULL)
    {
      GetModeWin()->CheckSpriteIDConflict();
      GetModeWin()->CheckSpriteIDUsage();
    }
  }
}
//*******************************************************************
void TEditFrameWin::CeModeOpenSaveAll(TCommandEnabler &ce)
{
  if (GetVDFlags().IsGameValid())
  {
    ce.Enable(true);
  }
  else
  {
    ce.Enable(false);
  }
}
//*******************************************************************
void TEditFrameWin::CmGObjEditSprites()
{
  SwitchToSpriteEditor();
}
//*******************************************************************
void TEditFrameWin::CmGObjEditSpritesEnable(TCommandEnabler &commandHandler)
{
  if ((GetVDFlags().IsGameValid()) &&
      (GetVDFlags().IsModeValid()) &&
      (GetVDFlags().IsGObjValid()))
  {
    commandHandler.Enable(true);
  }
  else
  {
    commandHandler.Enable(false);
  }
}
//*******************************************************************
void TEditFrameWin::CmGObjEditSkits()
{
  SwitchToSkitEditor();
}
//*******************************************************************
void TEditFrameWin::CmGObjEditSkitsEnable(TCommandEnabler &commandHandler)
{
  if ((GetVDFlags().IsGameValid()) &&
      (GetVDFlags().IsModeValid()) &&
      (GetVDFlags().IsGObjValid()))
  {
    commandHandler.Enable(true);
  }
  else
  {
    commandHandler.Enable(false);
  }
}
//*******************************************************************
void TEditFrameWin::CmHelpAbout()
{
  string strmastername;//helpmsg = "Master User is: ";
  string strusername;
  bool ismaster;
  if (PControl == NULL)
  {
//    helpmsg += "'none'";
    strmastername = "none";
    strusername = "none";
    ismaster = true;
  }
  else
  {
//    helpmsg += PControl->GetMasterName();
    strmastername = PControl->GetMasterName();
    strusername = PControl->GetUserName();
    ismaster = PControl->IsMaster();
  }
//  MessageBox(helpmsg.c_str(),"Help - About",MB_OK);

  string strmsgarray[10];
  strmsgarray[0] = "Master User is: " + strmastername;
  strmsgarray[1] = "User Name is: " + strusername;
  string strbool = "true";
  if (!ismaster) {strbool = "false";}
  strmsgarray[2] = "Is Master: " + strbool;
  strmsgarray[3] = "GEd version: ";
  strmsgarray[3] += string(GED_VER_STR);
  strmsgarray[4] = "Ogle version: ";
  strmsgarray[4] += string(OGLE_VER_STR);
  strmsgarray[5] = "Date of Build: ";
  strmsgarray[5] += string(__DATE__);
  strmsgarray[6] = "Time of Build: ";
  strmsgarray[6] += string(__TIME__);

  #if defined(__DEBUG) || defined(_DEBUG)
  strmsgarray[7] = "Debug conditional defined";
  #else
  strmsgarray[7] = "Debug conditional not defined";
  #endif

  #if defined(ENB_FUC_STEPS)
  strmsgarray[8] = "F - FUC Single Step enabled";
  #else
  strmsgarray[8] = "F - FUC Single Step not enabled";
  #endif

  #if defined(DEBUGUPDATES)
  strmsgarray[9] = "T - Show Time enabled";
  #else
  strmsgarray[9] = "T - Show Time not enabled";
  #endif

  TScrollMsgDlg *psmd = new TScrollMsgDlg(this,
                                          string("Help - About"),
                                          strmsgarray,
                                          10);
  psmd->Execute();
  delete psmd;
}
//*******************************************************************
void TEditFrameWin::CmHelpAboutEnable(TCommandEnabler &commandHandler)
{
  commandHandler.Enable(true);
}
//*******************************************************************
TWindow *TEditFrameWin::CreateModeWindow(int16 ModeIndex)
{
  switch (ModeIndex)
  {
    case -2:break;//create nothing.
    case -1:PModeWin = new TEditorModeWin(GetOgleApp(),
                                          this,
                                          "defmode",
                                          GetOgleApp()->PMasterPalette,
                                          "Mode Editor");
            break;
    default:
    {
      if (IsValidModeIndex(ModeIndex))
      {
        string mstr = GetGame()->GetModeName(ModeIndex);
        PModeWin = new TEditorModeWin(GetOgleApp(),
                                      this,
                                      mstr,
                                      GetOgleApp()->PMasterPalette,
                                      "Mode Editor");
      }
      else
      {
        MessageBox("Not a valid Mode Index, creating default mode","Create Mode Window",MB_OK);
        PModeWin = new TEditorModeWin(GetOgleApp(),
                                      this,
                                      "defmode",
                                      GetOgleApp()->PMasterPalette,
                                      "Mode Editor");
      }
      break;
    }
  }
  return PModeWin;
}
//*******************************************************************
void TEditFrameWin::HandleSwitchClients(TOgleMsg &msg)
{
  BYTE smt = msg.GetSMT();
  if      (smt & ID_SMT1_SWITCHMODES)      {HandleSwitchModes(msg);}
  else if (smt & ID_SMT1_SWTO_SPR_PREVIEW) {HandleSwitchToSprPreview(msg);}
  else if (smt & ID_SMT1_SWTO_SKT_PREVIEW) {HandleSwitchToSktPreview(msg);}
  else if (smt & ID_SMT1_SWTO_SPRED)       {HandleSwitchToSprEd(msg);}
  else if (smt & ID_SMT1_SWTO_SKTED)       {HandleSwitchToSktEd(msg);}
  else if (smt & ID_SMT1_SWTO_MED)         {HandleSwitchToMEd(msg);}
  else
  {
    MessageBox("Unhandled switch clients","GEd Switch Clients",MB_OK | MB_SYSTEMMODAL);
  }
}
//*******************************************************************
#pragma argsused
void TEditFrameWin::HandleSwitchModes(TOgleMsg &msg)
{
  SwitchClientW(true,0,aReturnMode);
}
//*******************************************************************
#pragma argsused
void TEditFrameWin::HandleSwitchToSprPreview(TOgleMsg &msg)
{
  SwitchClientW(true,0,aPreviewMode);
}
//*******************************************************************
#pragma argsused
void TEditFrameWin::HandleSwitchToSktPreview(TOgleMsg &msg)
{
  SwitchClientW(true,0,aPreviewMode);
}
//*******************************************************************
#pragma argsused
void TEditFrameWin::HandleSwitchToSprEd(TOgleMsg &msg)
{
  SwitchClientW(false,0,aReturnSprEd);
}
//*******************************************************************
#pragma argsused
void TEditFrameWin::HandleSwitchToSktEd(TOgleMsg &msg)
{
  SwitchClientW(false,0,aReturnSktEd);
}
//*******************************************************************
#pragma argsused
void TEditFrameWin::HandleSwitchToMEd(TOgleMsg &msg)
{
  SwitchClientW(true,0,aReturnMode);
}
//*******************************************************************
void TEditFrameWin::SwitchToSpriteEditor()
{
  SwitchClientW(false,0,aStartSprEd);
}
//*******************************************************************
void TEditFrameWin::SwitchToSkitEditor()
{
  SwitchClientW(false,0,aStartSktEd);
}
//*******************************************************************
void TEditFrameWin::SetupWindow()
{
	TOgleGameFrameWindow::SetupWindow();
//	string strTitle = GetModule()->LoadString(IDS_GAME_TITLE);
//	SetWindowText(strTitle.c_str());
   UserName = GetUserName();
}
//*******************************************************************

