/////////////////////////////////////////////////////////////////////////////
//                                                                         //
// gridedit.h                                                              //
//                                                                         //
/////////////////////////////////////////////////////////////////////////////
//                                                                         //
// Grid control library - Version 1.50 - 25 nov 1995                       //
// TGrid - Copyright  1994,1995 H. Picot, All Rights Reserved.            //
//                                                                         //
/////////////////////////////////////////////////////////////////////////////

#ifndef GRIDEDIT_H
#define GRIDEDIT_H

class _GRIDCLASS TGEdit : public TEdit
   {
   friend TGrid;
   friend TGridColumn;

   COLOR_HEADER
   MOUSE_HANDLER_HEADER

   protected:
      TGrid *grid;
      TColor columnbkg;
      TValidator *savedValidator;

      TColor ColumnBkg () { return columnbkg; }

      virtual void DrawCell (TDC &dc, TRect &rc, const void *p, TGAlign align = Left);
      virtual void Init ();

      void EvChar (uint key, uint repeat, uint flags);
      uint EvGetDlgCode (MSG far *msg);
      void EvKeyDown (uint key, uint repeat, uint flags);
      void EvKeyUp (uint key, uint repeat, uint flags);
      void EvKillFocus (HWND hWndGetFocus);
      void EvSetFocus (HWND hWndLostFocus);
      bool PreProcessMsg (MSG &msg);

   public:
      TGEdit (TWindow* parent, int Id, const char far *text, int x, int y, int w, int h, uint textLen = 0,
              bool multiline = false, TModule* module = 0);
      TGEdit (TWindow *parent, uint resourceID, uint textLen = 0, TModule *module = 0);
     ~TGEdit ();

      virtual int Height () { return Attr.H; }
      virtual int  Width () { return Attr.W; }
      bool CanClose () { if (grid) return grid->CanClose (); else return TEdit::CanClose (); }
      bool Create ();
      void SetColors (TColor t, TColor b, TColor a);
      void SuspendValidator () { savedValidator = Validator; Validator = 0; }
      void RestoreValidator ()
         {
         if (Validator == 0)
            Validator = savedValidator;
         savedValidator = 0;
         }

      operator string ();
      string &operator = (string &s);

      DECLARE_RESPONSE_TABLE (TGEdit);
   };

#endif

// EOF

