create or replace package body PCreditCardDepTX as
//*******************************************************************
procedure Modify(ean IN,txid IN,mac IN,fi_approvalcode IN,ccdeptx OUT,ec OUT)
{
  Lock(txid,ccdeptx,ec);
  if (ec == EC_NONE)
  {
    ccdeptx.Modify(ean,mac,fi_approvalcode,ec);
    UnLock(ccdeptx,ec);
  }
}
//*******************************************************************
procedure Commit(ean IN,ec OUT)
{
  LockArray(ean,ccdeptx_array,ccdeptx_num,ec);
  for (int i=0;i<ccdeptx_num;i++)
  {
    ccdeptx_array[i].Commit();
  }
  UnLockArray(ccdeptx_array,ccdeptx_num,ec);
}
//*******************************************************************
procedure Cancel(ean IN,ec OUT)
{
  LockArray(ean,ccdeptx_array,ccdeptx_num,ec);
  for (int i=0;i<ccdeptx_num;i++)
  {
    ccdeptx_array[i].Cancel();
  }
  UnLockArray(ccdeptx_array,ccdeptx_num,ec);
}
//*******************************************************************
procedure Lock(txid IN,ccdeptx OUT,ec OUT)
{
  ec = EC_NONE;

  select from Tbl_CreditCardDepTX
  where rec.TXID == txid
  for update

  //ccdeptx = rec;

  if (!found)
  {
    ec = EC_TX_NOTFOUND;
  }
}
//*******************************************************************
procedure UnLock(ccdeptx IN,ec OUT)
{
  ec = EC_NONE;

  update Tbl_CreditCardDepTX
  where rec.TXID == ccdeptx.TXID;

  //rec = ccdeptx;
}
//*******************************************************************
procedure LockArray(ean IN,ccdeptx_array OUT,ccdeptx_num OUT,ec OUT)
{
  lock all from Tbl_CreditCardDepTX
  where rec.Current_EAN == ean
  for update
  and put into array
  incrementing num
}
//*******************************************************************
procedure UnLockArray(ccdeptx_array IN,ccdeptx_num IN,ec OUT)
{
  update Tbl_CreditCardDepTX
  using array
}
//*******************************************************************
procedure Create(ean IN,uan IN,bid IN,amount IN,noservfee IN,
                 complete IN,fi_approvalcode IN,ccdeptx OUT,ec OUT)
{
  ec = EC_NONE;

  servicefee TCurrency;

  if (noservfee)
  {
    servicefee = 0;
  }
  else
  {
    PCasCfg.CC_GetDepServiceFee(servicefee,ec);
  }

  fr_ean PDef.TEAN = 0;
  fr_date PDef.TDate = 0;
  fr_sc TStatusCode = 0;

  if (complete)
  {
    fr_ean = ean;
    fr_sc = SC_ACCEPTED;
    fr_date = SYSDATE;
  }

  ccdeptx TCreditCardDepTX = TCreditCardDepTX(TXID_Seq.Next(),
                                              uan,
                                              bid,
                                              !complete,
                                              0,
                                              fi_approvalcode,
                                              amount,
                                              servicefee,
                                              0,
                                              complete,
                                              ean,
                                              SYSDATE,
                                              0,
                                              fr_ean,
                                              fr_sc,
                                              fr_date,
                                              true,
                                              0,
                                              SC_NONE,
                                              0,
                                              true);
  ccdeptx.VerifyENB();
}
//*******************************************************************
procedure Add(ccdeptx IN,ec OUT)
{
  ec = EC_NONE;

  insert ccdeptx
  into Tbl_CreditCardDepTX
}
//*******************************************************************
procedure CreateAdd(ean IN,uan IN,bid IN,amount IN,noservfee IN TBool,
                    complete IN,fi_approvalcode IN,txid OUT,ec OUT)
{
  Create(ean,uan,bid,amount,noservfee,complete,fi_approvalcode,ccdeptx,ec);
  if (ec == EC_NONE)
  {
    txid = ccdeptx.TXID;
    Add(ccdeptx,ec);
  }
}
//*******************************************************************
procedure GetArray(filter IN,ccdeptx_array OUT,ccdeptx_num OUT,ec OUT)
{
  get all from Tbl_CreditCardDepTX
  where rec == filter options
  and put into array
  and don't lock 
}
//*******************************************************************
end;