create or replace package body PCheckDepTX as
//*******************************************************************
procedure Modify(ean IN PDef.TEAN,
                 txid IN TXID,
                 mac IN TMAC,
                 checkdeptx OUT TCheckDepTX)
{
  Lock(txid,checkdeptx,ec);

  if (ec == PDef.EC_NONE)
  {
    checkdeptx.Modify(ean,mac,ec);

    UnLock(checkdeptx,ec);
  }
}
//*******************************************************************
procedure Commit(ean IN,ec OUT)
{
  // get and lock all "open" checkwdtx's that are currently
  // being modified by ean.

  LockArray(ean,checkdeptx_array,checkdeptx_num,ec);
  for (int i = 0;i < chdeptx_num;i++)
  {
    checkdeptx_array[i].Commit();
  }
  UnLockArray(checkdeptx_array,checkdeptx_num,ec);
}
//*******************************************************************
procedure Cancel(ean IN,ec OUT)
{
  LockArray(ean,checkdeptx_array,checkdeptx_num,ec);
  for (int i=0;i < checkdeptx_num;i++)
  {
    checkdeptx_array[i].Cancel();
  }
  UnLockArray(checkdeptx_array,checkdeptx_num,ec);
}
//*******************************************************************
procedure Lock(txid IN TXID,
              checkdeptx IN OUT TCheckDepTX,
              ec OUT TErrorcode)
{
  ec = EC_NONE;

  select from Tbl_CheckDepTX
  where rec.TXID == txid
  for update

  //checkdeptx = rec;

  if (!found)
  {
    ec = EC_TX_NOTFOUND;
  }
}
//*******************************************************************
procedure UnLock(checkdeptx IN TCheckDepTX,ec OUT TErrorCode)
{
  update Tbl_CheckDepTX
  where rec.TXID == checkdeptx.TXID;

  //rec = checkdeptx;
}
//*******************************************************************
procedure LockArray(ean IN,checkdeptx_array OUT,checkdeptx_num OUT,ec OUT)
{
  // lock all from Tbl_CheckDepTX
  // where rec.Current_EAN == ean
  // and put into array
  // incrementing num
}
//*******************************************************************
procedure UnLockArray(checkdeptx_array IN,checkdeptx_num IN,ec OUT)
{
  // update Tbl_CheckDepTX
  // using array.
}
//*******************************************************************
procedure Create(ean IN,uan IN,bid IN,amount IN,checknum IN,dateoncheck IN,
                 noservfee IN,checkdeptx OUT,ec OUT)
{
  ec = EC_NONE;

  checkwdtx TCheckWDTX = TCheckWDTX(TXID_Seq.Next(),
                                    uan,
                                    bid,
                                    true,
                                    dateoncheck,
                                    checknum,
                                    amount,
                                    noservfee,
                                    0,
                                    0,
                                    ean,
                                    SYSDATE,
                                    0,
                                    SC_NONE,
                                    0,
                                    true,
                                    0,
                                    SC_NONE,
                                    0,
                                    true,
                                    0,
                                    SC_NONE,
                                    0,
                                    true,
                                    0,
                                    SC_NONE,
                                    0,
                                    true);

  checkwdtx.VerifyENB();
}
//*******************************************************************
procedure Add(checkdeptx IN,ec OUT)
{
  insert checkdeptx
  into Tbl_CheckDepTX;
}
//*******************************************************************
procedure CreateAdd(ean IN,uan IN,bid IN,amount IN,checknum IN,dateoncheck IN,
                    noservfee IN,txid OUT,ec OUT)
{
  Create(ean,uan,bid,amount,checknum,datenoncheck,noservfee,checkdeptx,ec);
  if (ec == EC_NONE)
  {
    txid = checkdeptx.TXID;
    Add(checkdeptx,ec);
  }
}
//*******************************************************************
procedure GetArray(filter IN TFilter,
                   checkdeptx_array OUT,checkdeptx_num OUT,ec OUT)
{
  //get all from Tbl_CheckDepTX
  //where rec == filter options
  //and put into array
  // don't lock
}
//*******************************************************************
end;