create or replace package body PEmpSecAcc as
//**********************************************
procedure Verify(ean IN,roles IN TRoles,privset IN TPrivSet,
                 priv IN TBitfield,ec OUT)
{
  ec = EC_NONE;
  PEmployee.Get(ean,employee,ec);
  OnShitList(ean,employee.Roles,privset,priv,ec);
  if (ec == EC_NONE)
  {
    GetPrivs(employee.Roles,privs,ec);
    if (ec == EC_NONE)
    {
      if (privset == PRIVSET_USER)
      {
        if (!privs.User.Contains(priv)) {ec = EC_SECURITY_ACCESS_DENIED;}
      }
      else if (privset == PRIVSET_WALLET)
      {
        if (!privs.Wallet.Contains(priv)) {ec = EC_SECURITY_ACCESS_DENIED;}
      }
      else if (privset == PRIVSET_EMP)
      {
        if (!privs.Employee.Contains(priv)) {ec = EC_SECURITY_ACCESS_DENIED;}
      }
      else if (privset == PRIVSET_LOBBY)
      {
        if (!privs.Lobby.Contains(priv)) {ec = EC_SECURITY_ACCESS_DENIED;}
      }
      else if (privset == PRIVSET_SUPPORT)
      {
        if (!privs.Support.Contains(priv)) {ec = EC_SECURITY_ACCESS_DENIED;}
      }
      else if (privset == PRIVSET_SLOTS)
      {
        if (!privs.Slots.Contains(priv)) {ec = EC_SECURITY_ACCESS_DENIED;}
      }
      else if (privset == PRIVSET_BJ)
      { 
        if (!privs.BJ.Contains(priv)) {ec = EC_SECURITY_ACCESS_DENIED;}
      }
      else if (privset == PRIVSET_ROULETTE)
      {
        if (!privs.Roulettee.Contains(priv)) {ec = EC_SECURITY_ACCESS_DENIED;}
      }
      else if (privset == PRIVSET_TX)
      {
        if (!privs.TX.Contains(priv)) {ec = EC_SECURITY_ACCESS_DENIED;}
      }
      else if (privset == PRIVSET_TX_WU)
      {  
        if (!privs.TX_WU.Contains(priv)) {ec = EC_SECURITY_ACCESS_DENIED;}
      }
      else if (privset == PRIVSET_TX_WT)
      {
        if (!privs.TX_WT.Contains(priv)) {ec = EC_SECURITY_ACCESS_DENIED;}
      }
      else if (privset == PRIVSET_TX_CC)
      { 
        if (!privs.TX_CC.Contains(priv)) {ec = EC_SECURITY_ACCESS_DENIED;}
      }
      else if (privset == PRIVSET_TX_CHECK)
      {
        if (!privs.TX_Check.Contains(priv)) {ec = EC_SECURITY_ACCESS_DENIED;]
      }
      else if (privset == PRIVSET_TX_ADJ)
      {
        if (!privs.TX_Adj.Contains(priv)) {ec = EC_SECURITY_ACCESS_DENIED;}
      }
      else if (privset == PRIVSET_CHIPS)
      {
        if (!privs.TX_Chips.Contains(priv)) {ec = EC_SECURITY_ACCESS_DENIED;}
      }
      else if (privset == PRIVSET_RATING)
      {
        if (!privs.TX_Rating.Contains(priv)) {ec = EC_SECURITY_ACCESS_DENIED;}
      }
      else 
      {
        ec = EC_PRIVSET_UNK;
      }
    }
  }
}
//***********************************************
procedure GetPrivs(roles IN TRoles,privs OUT TPrivSet,ec OUT)
{
  ec = EC_NONE;

  privs.Clear();

  // UserSupport Role.
  if (roles.UserSupport >= RANK_JR)
  {
    privs.User |= PDef.JR_USERSUPPORT_USER;
    privs.Wallet |= PDef.JR_USERSUPPORT_WALLET;
  }
  if (roles.UserSupport >= RANK_REG)
  {
    privs.User |= PDef.REG_USERSUPPORT_USER;
    privs.Wallet |= PDef.REG_USERSUPPORT_WALLET;
  }
  if (roles.UserSupport >= RANK_SR)
  {
    privs.User |= PDef.SR_USERSUPPORT_USER;
    privs.Wallet |= PDef.SR_USERSUPPORT_WALLET;
  }
  if (roles.UserSupport >= RANK_SUPER)
  {
    privs.User |= PDef.SUPER_USERSUPPORT_USER;
    privs.Wallet |= PDef.SUPER_USERSUPPORT_WALLET;
  }
  
  // Employee Role.
  if (roles.Employee >= PDef.RANK_JR)
  {
    privs.Employee |= PDef.JR_EMP_EMP;
  }
  if (roles.Employee >= PDef.RANK_REG)
  {
    privs.Employee |= PDef.REG_EMP_EMP;
  }
  if (roles.Employee >= PDef.RANK_SR)
  {
    privs.Employee |= PDef.SR_EMP_EMP;
  }
  if (roles.Employee >= PDef.RANK_SUPER)
  {
    privs.Employee |= PDef.SUPER_EMP_EMP;
  }

  // Accounting Role.
  if (roles.Accounting >= RANK_JR)
  {
    privs.TX        |= PDef.JR_ACC_TX;
    privs.TX_Check  |= PDef.JR_ACC_TX_CHECK;
    privs.TX_CC     |= PDef.JR_ACC_TX_CC;
    privs.TX_WT     |= PDef.JR_ACC_TX_WT;
    privs.TX_WU     |= PDef.JR_ACC_TX_WU;
    privs.TX_Adj    |= PDef.JR_ACC_TX_ADJ;
    privs.TX_Chips  |= PDef.JR_ACC_TX_CHIPS;
    privs.TX_Rating |= PDef.JR_ACC_TX_RATING;
  }
  if (roles.Accounting >= RANK_REG)
  {
    privs.TX       |= PDef.REG_ACC_TX;
    privs.TX_Check |= PDef.REG_ACC_TX_CHECK;
    privs.TX_CC    |= PDef.REG_ACC_TX_CC; 
    privs.TX_WT    |= PDef.REG_ACC_TX_WT;
    privs.TX_WU    |= PDef.REG_ACC_TX_WU;
    privs.TX_Adj   |= PDef.REG_ACC_TX_ADJ;
    privs.TX_Chips |= PDef.REG_ACC_TX_CHIPS;
  }
  if (roles.Accounting >= RANK_SR)
  {
    privs.TX        |= PDef.SR_ACC_TX;
    privs.TX_Check  |= PDef.SR_ACC_TX_CHECK;
    privs.TX_CC     |= PDef.SR_ACC_TX_CC;
    privs.TX_WT     |= PDef.SR_ACC_TX_WT;
    privs.TX_WU     |= PDef.SR_ACC_TX_WU;
    privs.TX_Adj    |= PDef.SR_ACC_TX_ADJ;
    privs.TX_Chips  |= PDef.SR_ACC_TX_CHIPS;
    privs.TX_RAting |= PDef.SR_ACC_TX_RATING;
  }
  if (roles.Accounting >= RANK_SUPER)
  {
    privs.TX_Check  |= PDef.SUPER_ACC_TX_CHECK;
    privs.TX_CC     |= PDef.SUPER_ACC_TX_CC;
    privs.TX_WT     |= PDef.SUPER_ACC_TX_WT;
    privs.TX_WU     |= PDef.SUPER_ACC_TX_WU;
    privs.TX_Adj    |= PDef.SUPER_ACC_TX_ADJ;
    privs.TX_Chips  |= PDef.SUPER_ACC_TX_CHIPS;
    privs.TX_Rating |= PDef.SUPER_ACC_TX_RATING;
  }

  // System Role.
  if (roles.System >= RANK_JR)
  {
    privs.Slots    |= PDef.JR_SYSTEM_SLOTS;
    privs.BJ       |= PDef.JR_SYSTEM_BJ;
    privs.VP       |= PDef.JR_SYSTEM_VP;
    privs.Roulette |= PDef.JR_SYSTEM_ROULETTE;
    privs.Lobby    |= PDef.JR_SYSTEM_LOBBY;
    privs.TX       |= PDef.JR_SYSTEM_TX;
    privs.TX_Check |= PDef.JR_SYSTEM_TX_CHECK;
    privs.TX_CC    |= PDef.JR_SYSTEM_TX_CC;
    privs.TX_WT    |= PDef.JR_SYSTEM_TX_WT;
    privs.TX_WU    |= PDef.JR_SYSTEM_TX_WU;
  }
  if (roles.System >= RANK_REG)
  {
    privs.Slots    |= PDef.REG_SYSTEM_SLOTS;
    privs.BJ       |= PDef.REG_SYSTEM_BJ;
    privs.VP       |= PDef.REG_SYSTEM_VP;
    privs.Roulette |= PDef.REG_SYSTEM_ROULETTE;
  }
  if (roles.System >= RANK_SR)
  {
    privs.User |= PDef.SR_SYSTEM_USER;
    privs.Lobby |= PDef.SR_SYSTEM_LOBBY;
  }
  if (roles.System >= RANK_SUPER)
  {
    privs.Slots    |= PDef.SUPER_SYSTEM_SLOTS;
    privs.BJ       |= PDef.SUPER_SYSTEM_BJ;
    privs.VP       |= PDef.SUPER_SYSTEM_VP;
    privs.Roulette |= PDef.SUPER_SYSTEM_ROULETTE;
    privs.Lobby    |= PDef.SUPER_SYSTEM_LOBBY;
    privs.TX       |= PDef.SUPER_SYSTEM_TX;
    privs.TX_Check |= PDef.SUPER_SYSTEM_TX_CHECK;
    privs.TX_CC    |= PDef.SUPER_SYSTEM_TX_CC;
    privs.TX_WU    |= PDef.SUPER_SYSTEM_TX_WU;
    privs.TX_WT    |= PDef.SUPER_SYSTEM_TX_WT;
  }
}
//**********************************************
end;