create or replace package body PPassword as
//*******************************************************************
procedure Lock(uan IN PDef.TUAN,
               password IN OUT TUserPassword,
               errorcode OUT PDef.TErrorCode)
{
  errorcode = PDef.EC_NONE;

  select from Tbl_Passwords
    rec.UAN == uan
  into password
  for update // lock it.

  if (not found)
  {
    errorcode = PDef.EC_PASSWORD_NOT_FOUND;
  }
}
//*****************************************************************
procedure UnLock(password IN TUserPassword)
{
  Update Tbl_Password
    rec = password
  where rec.UAN == password.UAN
}
//*****************************************************************
procedure Add(password IN OUT TPassword,errorcode OUT PDef.TErrorCode)
{
  Insert into Tbl_Password
   password

  //catch any storage space problems.
  errorcode = PDef.EC_NONE;
}
//*****************************************************************
procedure Create(uan IN PDef.TUAN,
                 pw IN TPWStr,
                 password IN OUT TPassword,
                 errorcode OUT PDef.TErrorCode)
{
  password = TPassword(uan,pw,0,false,0);
  errorcode = PDef.EC_NONE;
}
//*****************************************************************
procedure CreateAdd(uan IN PDef.TUAN,pw IN TPWStr,errorcode OUT PDef.TErrorCode)
{
  TPassword password;
  Create(uan,pw,password,errorcode);
  if (errorcode == PDef.EC_NONE)
  {
    Add(password,errorcode);
  }
}
//*******************************************************************
procedure Verify(password IN TPassword,pw IN TPWStr,
                 mustchange OUT TBool,ec OUT)
{
  if (password.Matches(pw))
  {
    if (password.ExceedsFailCount())
    {
      ec = EC_PASSWORD_FAILCOUNT;
    }
    else
    {
      password.ResetFailCount();
      mustchange = password.GetMustChange();
    }
  }
  else
  {
    password.IncFailCount();
    ec = EC_PASSWORD_INVALID;
  }
}
//*******************************************************************
end PPassword;