create or replace package body PRegion as
//*******************************************************************
procedure Set(???)
{
  // update table.
  PRegLock.UpdateAll(region,ec);
}
//*******************************************************************
procedure CheckLocks(rlcode IN,user IN,state IN,country IN,ec OUT)
{
  region TRegion;
  Get(state,country,region,ec);
  if (ec == EC_NONE)
  {
    if (region.HasLocks(rlcode))
    {
      PRegLock.CreateAdd(user,region,rlcode,ec);
    }
  }
}
//*******************************************************************
procedure PreProcessTX(user,tx,ec)
{
  account TAccount;
  region TRegion;

  ec = EC_NONE;
  if (tx.TXT == TXT_CHECK)
  {
    PAccount.Get(tx.BID,account,ec);
    if (ec == EC_NONE)
    {
      Get(account.Address.State,account,Address.Country,region,ec);
      if (ec == EC_NONE && !region.Check.AllowDep)
      {
        ec = EC_REGION_CHECK_NODEP;
      }
    }
  }
  else if (tx.TXT == TXT_CREDITCARD)
  {
    PAccount.Get(tx.BID,account,ec);
    Get(account.Address.State,account.Address.Country,region.ec);
    if (ec == EC_NONE && !region.CC.AllowDep)
    {
      ec = EC_REGION_CC_NODEP;
    }
  }
}
//*******************************************************************
procedure PostProcessTX(user,tx,ec)
{
  account TAccount;
  PAccount.Get(tx.BID,account,ec);
  region TRegion;
  Get(account.Address.State,account.Address.Country,region,ec);

  if (ec == EC_NONE)
  {
    if (tx.TXT == TXT_CHECK)
    {
      if (region.Check.HasLocks())
      {
        PRegLock.CreateAdd(user,region,RLC_CHECK,ec);
      }
    }
    else if (tx == TXT_CREDITCARD)
    {
      if (region.CC.HasLocks())
      {
        PRegLock.CreateAdd(user,region,RLC_CC,ec);
      }
    }
    else if (tx == TXT_WIRETRANSFER)
    {
      if (region.WT.HasLocks())
      {
        PRegLock.CreateAdd(user,region,RLC_WT,ec);
      }
    }
    else if (tx == TXT_WESTERNUNION)
    {
      if (region.WU.HasLocks())
      {
        PRegLock.CreateAdd(user,region,RLC_WU,ec);
      }
    }
  }
}
//*******************************************************************
procedure PreProcessCreateUser(state,country,ec)
{
  ec = EC_NONE;
  region TRegion;
  Get(state,country,region,ec);
  if (!region.MA.CashPlay && !region.MA.FreePlay)
  {
    ec = EC_REGION_LOCK;
  }
}
//*******************************************************************
procedure PostProcessCreateUser(rlcode,user,state,country,ec)
{
  CheckLocks(rlcode,user,state,country,ec);
}
//*******************************************************************
end;