create or replace package body PRegLock as
//*******************************************************************
procedure Add(user IN,region IN,rlcode IN,reglock IN,ec OUT)
{
  ec = EC_NONE;
  insert reglock into Tbl_RegLock;
  
  PUser.SetRegLocks(user,region,rlcode,ec);
}
//*******************************************************************
procedure Create(uan IN,regionid IN,rlcode IN,amount IN,txid IN,
                 reglock OUT,ec OUT)
{
  reglock = TRegLock(RegLock_Seq.Next(),
                     regionid,
                     uan,
                     true,
                     SYSDATE,
                     rlcode,
                     amount,
                     txid);
  ec = EC_NONE;
}
//*******************************************************************
procedure CreateAdd(user IN,region IN,rlcode IN,ec OUT)
{
  reglock TRegLock;
  Create(user.UAN,region.RegionID,rlcode,reglock,ec);
  if (ec == EC_NONE)
  {
    Add(user,region,rlcode,reglock,ec);
  }
}
//*******************************************************************
procedure UpdateAll(region IN,ec OUT)
{
  LockArray(region.RegionID,true,rl_array,rl_num,ec);
  if (ec == EC_NONE)
  {
    for (int i = 0;i < rl_num,i++)
    {
      if (rl_array[i].RLCode == RLC_MA && !region.MA.HasLocks())
      {
        rl_array[i].Active = false;
      }
      else if (rl_array[i].RLCode == RLC_CHECK && !region.Check.HasLocks())
      {
        rl_array[i].Active = false;
      }
      else if (rl_array[i].RLCode == RLC_CC && !region.CC.HasLocks())
      {
        rl_array[i].Active = false;
      }
      else if (rl_array[i].RLCode == RLC_WT && !region.WT.HasLocks())
      {
        rl_array[i].Active = false;
      }
      else if (rl_array[i].RLCode == RLC_WU && !region.WU.HasLocks())
      {
        rl_array[i].Active = false;
      }
    } // end for.
    UnLockArray(rl_array,rl_num,ec);
  }
}
//*******************************************************************
end;