create or replace package body PUser_Info as
//*******************************************************************
procedure Add(userinfo IN OUT TUser_Info,
              ec       OUT    PDef.TErrorCode)
{
  insert into Tbl_User_Info
    userinfo
  ec = PDef.EC_NONE;
}
//*****************************************************************
procedure Create(uan           IN     PDef.TUAN,
                 name          IN     TName,
                 address       IN     TAddress,
                 dayphone      IN     PDef.TNameStr,
                 eveningphone  IN     PDef.TNameStr,
                 email         IN     PDef.TNameStr,
                 dob           IN     PDef.TDate,
                 sex_male      IN     PDef.TBool,
                 mothersmaiden IN     PDef.TNameStr,
                 hometown      IN     PDef.TCityStr,
                 userinfo      IN OUT TUser_Info,
                 ec            OUT    PDef.TErrorCode)
{
  userinfo = TUser_Info(uan,name,address,dayphone,eveningphone,email,
                        dob,sex_male,mothersmaiden,hometown);
  ec = PDef.EC_NONE;
}
//*****************************************************************
procedure CreateAdd(uan           IN  PDef.TUAN,
                    name          IN  TName,
                    address       IN  TAddress,
                    dayphone      IN  PDef.TNameStr,
                    eveningphone  IN  PDef.TNameStr,
                    email         IN  PDef.TNameStr,
                    dob           IN  PDef.TDate,
                    sex_male      IN  PDef.TBool,
                    mothersmaiden IN  PDef.TNameStr,
                    hometown      IN  PDef.TCityStr,
                    ec            OUT PDef.TErrorCode)
{
  TUser_Info ui;
  Create(uan,name,address,dayphone,eveningphone,email,dob,sex_male,
         mothersmaiden,hometown,ui,ec);
  if (ec == ICAS.EC_NONE)
  {
    Add(ui,ec);
  }
}
//*******************************************************************
procedure Lock(uan IN,user_info OUT TUser_Info,ec OUT))
{
  ec = EC_NONE;

  select user_info from Tbl_User_Info
  where rec.UAN == uan
  for update;
  if (!found)
  {
    ec = EC_USER_INFO_NOTFOUND;
  }
}
//*******************************************************************
procedure UnLock(user_info IN TUser_Info,ec OUT)
{
  // note: might want to remove the state and country change check
  //       and just always call PRegion.CheckLocks() no matter what.

  TUser_Info user_info2;
  Get(user_info.UAN,user_info2,ec);

  // check region.
  if ((user_info.Address.State != user_info2.Address.State) ||
      (user_info.Address.Country != user_info2.Address.Country))
  {
    PUser.Lock(user_info.UAN,user,ec);

    PRegion.CheckLocks(RLC_MA,
                       user,
                       user_info.Address.State,
                       user_info.Address.Country,
                       ec);

    PUser.UnLock(user,ec);
  }

  // sql code.
  update Tbl_User_Info
  where rec.UAN == user_info.UAN
  rec = user_info;

  ec = EC_NONE;
}
//*******************************************************************
procedure Set(user_info IN,ec OUT)
{
// note: this proc does logging of changes for PAce.

  Lock(user_info.UAN,old_ui,ec);
  if (ec == EC_NONE)
  {
    if (old_ui.Name.FName != userinfo.Name.FName)
    {
      PLog.CreateAdd(ean,uan,LOG_USER_INFO_NAME_FNAME_WRITE,
                     old_ui.Name.FName,userinfo.Name.FName,ec);
    }
    if (old_ui.Name.LName != userinfo.Name.LName)
    {
      PLog.CreateAdd(ean,uan,LOG_USER_INFO_NAME_LNAME_WRITE,
                     old_ui.Name.LName,userinfo.Name.LName,ec);
    }
    if (old_ui.Address.Street != userinfo.Address.Street)
    {
      PLog.CreateAdd(ean,uan,LOG_USER_INFO_ADDRESS_STREET_WRITE,
                     old_ui.Address.Street,userinfo.Address.Street,ec);
    }
    if (old_ui.Address.City != userinfo.Address.City)
    {
      PLog.CreateAdd(ean,uan,LOG_USER_INFO_ADDRESS_CITY_WRITE,
                     old_ui.Address.City,userinfo.Address.City,ec);
    }
    if (old_ui.Address.State != userinfo.Address.State)
    {
      PLog.CreateAdd(ean,uan,LOG_USER_INFO_ADDRESS_STATE_WRITE,
                     old_ui.Address.State,userinfo.Address.State,ec);
    }
    if (old_ui.Address.Country != userinfo.Address.Country)
    {
      PLog.CreateAdd(ean,uan,LOG_USER_INFO_ADDRESS_COUNTRY_WRITE,
                     old_ui.Address.Country,userinfo.Address.Country,ec);
    }
    if (old_ui.Address.Zip != userinfo.Address.Zip)
    {
      PLog.CreateAdd(ean,uan,LOG_USER_INFO_ADDRESS_ZIP_WRITE,
                     old_ui.Address.Country,userinfo.Address.Country,ec);
    }
    if (old_ui.DayPhone != userinfo.DayPhone)
    {
      PLog.CreateAdd(ean,uan,LOG_USER_INFO_DAYPHONE_WRITE,
                     old_ui.DayPhone,userinfo.DayPhone,ec);
    }
    if (old_ui.EveningPhone != userinfo.EveningPhone)
    {
      PLog.CreateAdd(ean,uan,LOG_USER_INFO_EVENINGPHONE_WRITE,
                     old_ui.EveningPhone,userinfo.EveningPhone,ec);
    }
    if (old_ui.EMail != userinfo.EMail)
    {
      PLog.CreateAdd(ean,uan,LOG_USER_INFO_EMAIL_WRITE,
                     old_ui.EMail,userinfo.EMail,ec);
    }
    if (old_ui.DOB != userinfo.DOB)
    {
      PLog.CreateAdd(ean,uan,LOG_USER_INFO_DOB_WRITE,
                     old_ui.DOB,userinfo.DOB,ec);
    }
    if (old_ui.Sex_Male != userinfo.Sex_Male)
    {
      PLog.CreateAdd(ean,uan,LOG_USER_INFO_SEX_WRITE,
                     old_ui.Sex_Male,userinfo.Sex_Male,EC);
    }
    if (old_ui.MothersMaiden != userinfo.MothersMaiden)
    {
      PLog.CreateAdd(ean,uan,LOG_USER_INFO_MOTHERSMAIDEN_WRITE,
                     old_ui.MothersMaiden,userinfo.MothersMaiden,ec);
    }
    if (old_ui.Hometown != userinfo.Hometown)
    {
      PLog.CreateAdd(ean,uan,LOG_USER_INFO_HOMETOWN_WRITE,
                     old_ui.Hometown,userinfo.Hometown,ec);
    }
    old_ui.Set(user_info);
    UnLock(old_ui,ec);
  }
}
//*******************************************************************
end PUser_Info;
