create or replace package body PSlots_Instance as
//*******************************************************************
procedure Add(si IN OUT TSlots_Instance,ec OUT PDef.TErrorCode)
{
  insert si
  into Tbl_Instance

  ec = PDef.EC_NONE;
}
//*****************************************************************
procedure Create(mid IN PDef.TMID,
                 uan IN PDef.TUAN,
                 freeplay IN PDef.TBool,
                 si IN OUT TSlots_Instance,
                 ec OUT PDef.TErrorCode)
{
  ec = PDef.EC_NONE;

  TSlots_Round round = TSlots_Round(Seq_Instance.Next(),
                                    0,
                                    0,
                                    0,
                                    0,
                                    mid,
                                    0,
                                    0,
                                    0,
                                    0,
                                    false,
                                    false,
                                    false,
                                    uan);
  si = TSlots_Instance(round,
                       PDef.STATE_NONE,
                       SYSDATE,
                       SYSDATE,
                       0,
                       0,
                       freeplay,
                       true);
}
//*****************************************************************
procedure CreateAdd(mid IN PDef.TMID,
                    uan IN PDef.TUAN,
                    freeplay IN PDef.TBool,
                    si IN OUT TSlots_Instance,
                    ec OUT PDef.TErrorCode)
{
  Create(mid,uan,freeplay,si,ec);
  if (ec == PDef.EC_NONE)
  {
    Add(si,ec);
  }
}
//*****************************************************************
procedure Lock(iid IN PDef.TIID,
               si IN OUT TSlots_Instance,
               ec OUT PDef.TErrorCode)
{
  ec = PDef.EC_NONE;

  select si
  from Tbl_Slots_Instance
  where rec.Round.InstanceID == iid

  if (not found)
  {
    ec = PDef.EC_SLOTS_INSTANCE_NOTFOUND;
  }
}
//*****************************************************************
procedure UnLock(si IN OUT TSlots_Instance,ec OUT PDef.TErrorCode)
{
  ec = PDef.EC_NONE;

  update Tbl_Slots_Instance
  rec = si
  where rec.Round.InstanceID == si.Round.InstanceID
}
//*****************************************************************
end PSlots_Instance;