//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  brain.h
//    Project Name:  Ogle
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     06/01/95   A. Krist    Original baseline
//  2.0     08/26/97   M.Perry     32-bit conversion.
//*******************************************************************
#if !defined __brain_h
#define __brain_h

#include "action.h"
class TSmarts;
#include "smarts.h"
#include "hand.h"
#include "history.h"
#include "knowledge.h"
#include "game.h"
//*******************************************************************
class TBrain
{
public:
  TGame          *pGame;
  TAction        *pAction;
  TSmarts        *pSmarts;
  THand          *pHand;
  THistory       *pHistory;
  TKnowledge     *pKnow;

  int  agressive;
  int  tight;
  int  bluff;
  int  randomness;

  TBrain();
 ~TBrain();
  virtual bool Active();
  virtual bool Decision();
  virtual bool Implement();
  virtual bool Personalize();
  virtual TAction* GetActionPtr()=0;
  virtual THand* GetHandPtr()=0;
  virtual TSmarts* GetSmartsPtr()=0;
  virtual TKnowledge* GetKnowPtr()=0;
  virtual TGame* GetGamePtr()=0;
};
//*******************************************************************
#endif