//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  obdlg.h
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     12/19/96   M.Perry    original baseline
//  1.2     03/27/97   M.Perry    made into base class for dialog hierarchy.
//  2.0     08/26/97   M.Perry    32-bit conversion.
//********************************************************************
#if !defined(__obdlg_h)
#define __obdlg_h

#if !defined(__ogle_h)
#include "ogle.h"
#endif

#if !defined(OWL_DIALOG_H)
#include <owl\dialog.h>
#endif

#if !defined(OWL_BUTTON_H)
#include <owl\button.h>
#endif

#if !defined(__obdlg_rh)
#include "obdlg.rh"
#endif

#if !defined(__oflags_h)
#include "oflags.h"
#endif

class TBitmap;
//*******************************************************************
#define bdFIRST (fBit0)
#define bdSHOWOK (bdFIRST)
#define bdRESIZE ((WORD)(bdSHOWOK * 2))
#define bdIGNOREINPUT ((WORD)(bdRESIZE * 2))
#define bdOWNBITMAP ((WORD)(bdIGNOREINPUT * 2))
#define bdLAST (bdOWNBITMAP)
//*******************************************************************
class OGLEOWLCLASS TBitmapDlg:public TDialog
{
protected:
  void *POwner;   // object responsible for destroying this.
  TBitmap *PBitmap;
  TButton *POkBtn;
  TOgleWORDFlag Options;

public:
  TBitmapDlg(void *powner,TWindow *pwin,TBitmap *pbitmap,
             word options = 0,
             int dlgid = IDD_BITMAP,
             const char *title = 0);
  virtual ~TBitmapDlg();
  void EvPaint();
  bool EvEraseBkgnd(HDC hDC);
  void EvRButtonUp(uint modKeys,TPoint &point);
  void EvLButtonUp(uint modKeys,TPoint &point);
  virtual void Paint(TDC &dc,bool erase,TRect &rect);
  virtual void SetupWindow();
  void *GetOwner() {return POwner;}
  DECLARE_RESPONSE_TABLE(TBitmapDlg);
};
//*******************************************************************
#endif

