//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  obtnsp.h
//    Project Name:  ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  2.5    11/04/99    M.Perry     original baseline
//********************************************************************
#if !defined(__obtnsp_h)
#define __obtnsp_h

#include "osprite.h"
//#include "casglord.h"
//#include "oglord.h"
#include "ocurmgr.h"
//*******************************************************************
class TOgleButton:public TSprite
{
public:
  enum
  {
    bsNone = 0,
    bsUp,
    bsDown,
    bsGrayed,
    bsLite
  };
  enum
  {
    bcNone = 0,
    bcLeft,
    bcRight,
    bcLeftGray,
    bcRightGray,
    bcLeftLite,
    bcRightLite
  };
  enum
  {
    bwDownNDX = 0, //default values 
    bwUpNDX = 1,
    bwChimeNDX = 2
  };

protected:
  int16 UpInfo;
  int16 IDNum;
  bool HandleGrayClicks;
  bool HandleLiteClicks;
  bool HandleLeftClicks;
  bool HandleRightClicks;
  int16 CurrentButtonStatus; //bsNone,bsUp,bsDown,bsGrayed,bsLite
  bool LeftDown;
  bool RightDown;
  TCursorData DefaultActionCursor;
  TAnm *PButton;
  TWav *PDownWav;
  TWav *PUpWav;
  TWav *PChimeWav;
  TResponder *PButtonResponder;
  TOgleBase *POwnerBase;
  int16 CurrentDownFrame;
  int16 CurrentUpFrame;
  int16 CurrentGrayFrame;
  int16 CurrentLiteFrame;
  dword UpFUC;
  int16 UpWavNDX,DownWavNDX,ChimeWavNDX;

protected:
  void SetupButton();
  void SetupWavs();
  void SetupAnms();
  virtual void PostUpdate(dword NewFUC);
  virtual void Update(dword NewFUC);
  virtual bool Respond(TResponder &responder);
  virtual bool Respond(int16 Button,int16 Info,void *Ptr) {return true;}

public:
  TOgleButton(TOgleModeWindow *pmw,
             TFileMode NewFileMode,
             TOgleBase *pbase,
				 int16 ZOrder,
             const TRect &rect,
             int16 IdNum,
             int16 upframe = -1,
             int16 downframe = -1,
             int16 grayframe = -1,
             int16 startstate = bsUp,
             char Ch='~',
             const TCursorData &cd = TCursorData(TOgleApp::GetOgleApp(),ID_POINTING_FINGER_CURSOR),
             const TCursorData &dac = TCursorData(TOgleApp::GetOgleApp(),ID_PRESSING_FINGER_CURSOR));

  TOgleButton(TOgleModeWindow *pmw,
             TFileMode fm,
             void *psource,
             TOgleBase *pbase,
				 int16 ZOrder,
             const TRect &rect,
             int16 IdNum,
             int16 upframe = -1,
             int16 downframe = -1,
             int16 grayframe = -1,
             int16 startstate = bsUp,
             char Ch='~',
             const TCursorData &cd = TCursorData(TOgleApp::GetOgleApp(),ID_POINTING_FINGER_CURSOR),
             const TCursorData &dac = TCursorData(TOgleApp::GetOgleApp(),ID_PRESSING_FINGER_CURSOR));

  TOgleButton(TOgleModeWindow *pmw,TFileMode NewFileMode);

  TOgleButton(TOgleModeWindow *pmw,TFileMode fm,void *psource);

  virtual ~TOgleButton();

  void SetCurrentUpFrame(int16 Frame) {CurrentUpFrame = Frame;}
  void SetCurrentDownFrame(int16 Frame) {CurrentDownFrame = Frame;}
  void SetCurrentGrayFrame(int16 Frame) {CurrentGrayFrame = Frame;}
  void SetCurrentLiteFrame(int16 Frame) {CurrentLiteFrame = Frame;}
  void ShowGray();
  void ShowUp(bool actioncursor = false);
  void ShowLite();
  void ShowDown(bool actioncursor = false);
  void Enable(bool enable = true);
};
//*******************************************************************
#endif
