//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  odetdlg.h
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     4/28/96    M.Perry     original baseline
//  2.0     8/26/97    M.Perry     32-bit conversion.
//********************************************************************
#if !defined(__odetdlg_h)
#define __odetdlg_h

#if !defined(__ogle_h)
#include "ogle.h"
#endif

#if !defined(OWL_DIALOG_H)
#include <owl\dialog.h>
#endif
//#include <owl\listbox.h>
//#include <owl\button.h>
//#include <owl\edit.h>
//#include <owl\checkbox.h>
class TListBox;
class TButton;
class TEdit;
class TCheckBox;
class TStatic;

class TDetScript;
class TDetIncData;
class TDetExcData;
class TDetExcNameData;
//*******************************************************************
class OGLEOWLCLASS TDetIncDataDlg:public TDialog
{
protected:
  TCheckBox *PRecurseChB;
  TEdit *PDir;
  TListBox *PExtLB;
  TDetIncData &DetIncData;

public:
  TDetIncDataDlg(TWindow *pwin,TDetIncData &did);
  virtual ~TDetIncDataDlg();
  virtual void SetupWindow();
  void LoadExtLB();
  void UnLoadExtLB();
  void CmAddExt();
  void CmRemoveExt();
  void CmDone();

  DECLARE_RESPONSE_TABLE(TDetIncDataDlg);
};
//*******************************************************************
class OGLEOWLCLASS TDetExcDataDlg:public TDialog
{
protected:
  TEdit *PDir;
  TCheckBox *PRecurseChB;
  TDetExcData &DetExcData;

public:
  TDetExcDataDlg(TWindow *pwin,TDetExcData &ded);
  virtual ~TDetExcDataDlg();
  void CmDone();
  virtual void SetupWindow();

  DECLARE_RESPONSE_TABLE(TDetExcDataDlg);
};
//*******************************************************************
class OGLEOWLCLASS TDetExcNameDataDlg:public TDialog
{
protected:
  TEdit *PName_EB;
  TDetExcNameData &DetExcNameData;

public:
  TDetExcNameDataDlg(TWindow *pwin,TDetExcNameData &dend);
  virtual ~TDetExcNameDataDlg();
  void CmOk();
  virtual void SetupWindow();

  DECLARE_RESPONSE_TABLE(TDetExcNameDataDlg);
};
//*******************************************************************
class OGLEOWLCLASS TDetDlg:public TDialog
{
protected:
  TListBox *PIncDirLB;
  TListBox *PExcDirLB;
  TListBox *PExcName_LB;
  TStatic *PName;
  TStatic *PRoot;
  TDetScript *PDetScript;
  string Root;

public:
  TDetDlg(TDetScript *pdetscript,TWindow *parent,string &root);
  virtual ~TDetDlg();
  virtual void SetupWindow();
  void CmAddIncDir();
  void CmRemoveIncDir();
  void CmEditIncDir();
  void CmAddExcDir();
  void CmRemoveExcDir();
  void CmEditExcDir();
  void CmAddExcName();
  void CmRemoveExcName();
  void CmEditExcName();
  void CmDone();
  void LoadIncDirLB();
  void UnLoadIncDirLB();
  void LoadExcDirLB();
  void UnLoadExcDirLB();
  void LoadExcNameLB();
  void UnLoadExcNameLB();

  DECLARE_RESPONSE_TABLE(TDetDlg);
};
//*******************************************************************
#endif

