//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  ogame.h
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//   1.0    7/18/95    M.Perry    original baseline
//   2.0    8/24/97    M.Perry    32-bit conversion.
//   2.1    12/6/97    M.Perry    filename mod's.
//********************************************************************
#if !defined(__ogame_h)
#define __ogame_h

#if !defined(__obase_h)
#include "obase.h"
#endif

#if !defined(__osliq_h)
#include "osliq.h"
#endif
//*******************************************************************
class TOgleGame:public TOgleBase
{
public:
  string PaletteName;
  TSliq Modes;

protected:
  string *GetFirstMode();
  string *GetNextMode();

public:
  int16 GetNumModes();
  void SetName(string NewName);

  TOgleGame(string GameName);
  TOgleGame();
  virtual ~TOgleGame();

  virtual string AddExt(); 
  string GetPaletteName();
  void SetPaletteName(string &NewPaletteName);
  bool AddModeName(string *PModeName);
  bool RemoveModeName(string &modename);
  string GetModeName(int16 ModeNum);
  int16 GetModeIndex(string ModeName);
  virtual bool ReadLocal();
  virtual bool WriteLocal();
  bool ReadLocal1_0();
  bool ReadLocal2_0();
  void SortByName();
  virtual const char *GetIDChars() const;
  virtual void SetMajVer();
  virtual void SetMinVer();
};
//*******************************************************************
//**************** TOgleGame inlines ********************************
//*******************************************************************
inline string *TOgleGame::GetFirstMode()
{
  return (string *)Modes.LTravFirst();
}
//*******************************************************************
inline string *TOgleGame::GetNextMode()
{
  return (string *)Modes.LTravNext();
}
//*******************************************************************
inline int16 TOgleGame::GetNumModes()
{
  return Modes.GetRecCount();
}
//*******************************************************************
inline string TOgleGame::GetPaletteName()
{
  return PaletteName;
}
//*******************************************************************
inline void TOgleGame::SetPaletteName(string &NewPaletteName)
{
  PaletteName = NewPaletteName;
}
//*******************************************************************
inline bool TOgleGame::AddModeName(string *PModeName)
{
  return Modes.QFrontAdd(PModeName);
}
//*******************************************************************
#endif

