//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  ogamefw.h
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     02/27/95   M. Perry    original baseline
//  2.0     08/29/97   M.Perry     32-bit conversion.
//  2.2     06/01/99   M.Perry     fixed focus problem,
//          06/08/99   M.Perry     missing scanlines.
//  2.3     08/02/99   M.Perry     gobjlist removal,include sentries,etc.
//********************************************************************
#if !defined(__ogamefw_h)
#define __ogamefw_h)

#if !defined(__ogle_h)
#include "ogle.h"
#endif

#if !defined(OWL_FRAMEWIN_H)
#include <owl\framewin.h>
#endif

//#include "osplash.h" // MRP - 06/27/99 - v2.3 - moved to .cpp

#if !defined(__animicon_h)
#include "animicon.h"
#endif

#if !defined(__ocurmgr_h)
#include "ocurmgr.h"
#endif

#if !defined(__omsg_h)
#include "omsg.h"
#endif

#if !defined(__oapp_h)
#include "oapp.h"
#endif

class TSplashDlg;  // MRP - 06/27/99 - v2.3
class OGLEOWLCLASS TOgleApp;
class TOgleModeWindow;
class TPlayerMgr;
class TOgleGame;
class TOgleFileMgr;
class TOgleSoundMgr;
//*******************************************************************
class TOgleMenuEnable
{
protected:
  int16 PrevMode;
  int16 CurrentMode;
public:
  bool Exit;
  bool FX;
  bool Music;
  bool About;
  bool Contents;
  virtual void SetAll(bool value);
  virtual void SetModes(bool value = true);
  TOgleMenuEnable(bool setvalues = true);
  virtual ~TOgleMenuEnable();
  int16 GetCurrentMode() {return CurrentMode;}
  int16 GetPrevMode() {return PrevMode;}
  void SetCurrentMode(int16 curmode)
  {
    PrevMode = CurrentMode;
    CurrentMode = curmode;
  }
};
//*******************************************************************
class OGLEOWLCLASS TOgleGameFrameWindow : public TFrameWindow
{
protected:
//  TOgleGame *PGame;
//  TOgleApp *POgleApp;
  TOgleMenuEnable *PMenuEnable;
  TPlayerMgr *PlayerMgr;
  TOgleModeWindow *PModeWin;
  TWindow *POldClientWin;
//  TOgleFileMgr *PFileMgr;
  TOgleSoundMgr *PSoundMgr;
  TSplashDlg *PSplashScreen;
  TOgleAnimatedIcons animIcons;
  int16 StartupModeIndex;
  bool m_AllowIconAnimation;
  bool MenuShowing;
  bool HandleShowMenu;
  bool m_bIsMinimized;
  bool MaxFX;
  bool Active;
  bool Initialized;
  bool MenuLoopEntered;
  bool IntroUserSkipped;
  bool ModeInfoInitialized;
  bool ModeStringsInitialized;
  bool ModeIDSInitialized;
  bool ModeIndexesInitialized;

protected:
  void EvCompacting(uint compactRatio);
  void DoStyle();
  void DoIcon();
  void DoMenu();
  void DoAccel();
  void GetXYWH(int& X,int& Y,int& W,int& H);
  void EvGetMinMaxInfo(MINMAXINFO FAR& lpmmi);
  void GetRes(int& x_res,int& y_res);
  void SetRes();
  virtual void CreateMenuEnable();
  virtual void DestroyMenuEnable();
//  TOgleMenuEnable *GetMenuEnable(); // moved to public section.
  LRESULT EvEnterMenuLoop(WPARAM wparam,LPARAM lparam);
  LRESULT EvExitMenuLoop(WPARAM wparam,LPARAM lparam);
  virtual bool HandleEnterMenuLoop(bool ispopup);
  virtual bool HandleExitMenuLoop(bool ispopup);
  string GetDriveDir();
  virtual void CreatePlayerMgr();
  void DestroyPlayerMgr();

  // MRP - 06/27/99 - v2.3 - made protected.
  virtual void CreateSplash();
  virtual void DestroySplash();

public:
  // mrp - v2.4 - 09/14/99 - the following block added for 2000 re-releases.
  int16 idsIntro;
  TOgleMenuEnable *GetMenuEnable(); // changed to public
  void SetIntroUserSkipped(bool skipped = true) {IntroUserSkipped = skipped;}
  bool GetIntroUserSkipped() {return IntroUserSkipped;}
  // MRP
  bool FadeIn;
  void SetFadeIn(bool fade) {FadeIn = fade;}
  bool GetFadeIn() {return FadeIn;}

  virtual void NotifyDenomSwitch(TMoney denom);
  bool Help(uint command,uint32 data = 0);
  bool SwitchMenu(TResId resId,TModule *pmodule = NULL);
  virtual int GetMenuID();
  virtual TModule *GetMenuModule();
  void SetToDefMenu();

  TOgleApp *GetOgleApp();
  TOgleFileMgr *GetFileMgr();
  string GetResString(uint id);
  int MessageBox(HWND hWnd,const char far* text,const char far* caption,uint type);
  int MessageBox(const char far* text,const char far* caption,uint type);
  virtual void GetWindowClass(WNDCLASS& wndClass);
  void SetCursorData(TCursorData &cd,bool check = false);

  TPlayerMgr *GetPlayerMgr();
  bool IsPlayerChangeOk();
  void NotifyModePlayerActivation(int16 slotnum);
  void NotifyModePlayerDeActivation(int16 slotnum);

  bool GetHandleShowMenu();
  void CmShowMenu();
  void ShowMenu(bool show);

  void CmFMgrToggleHDBuffering();
  void CeFMgrToggleHDBuffering(TCommandEnabler &ce);
  void CmPlayerManagementDlg();
  virtual void DisplayExpert(string str,bool pause = true);
//  virtual void CreateSplash();
//  virtual void DestroySplash();
  void Maximize();
  void EvSize(uint sizeType, TSize&);
  void EvActivateApp(bool active,HTASK hTask);
  void Activate(bool mwCaller = false);
  void DeActivate(bool mwCaller = false);
  void EvTimer(uint timerId);
  void EvTimeChange();
  bool EvQueryNewPalette();
  void EvPaletteChanged(HWND hWndPalChg);
  void EvActivate(uint active,bool minimized,HWND hWndOther);
  void EvSetFocus(HWND hWndLostFocus);
  void EvKillFocus(HWND hWndGetFocus);
  bool EvEraseBkgnd(HDC hDC);
  virtual bool CanClose();
  void CmExit();
  TOgleGameFrameWindow(TOgleApp *papp,
                       string title,
							  bool shrinkToClient = true,
							  bool doResources = false);

  virtual ~TOgleGameFrameWindow();
  bool IsInitialized();
  virtual bool Initialize();
  virtual bool DeInitialize();
  bool IsSplashScreenActive();
  void GetScreenMetrics(int* x_res,int* y_res,int* winframe_x,int* winframe_y,
                        int* menu_ht,int* title_ht,int* scroll_x,int* scroll_y);
  virtual void SetupWindow();
  virtual void CleanupWindow();
  virtual void SetupVideo();
  virtual void CleanupVideo();
  virtual void CreateSoundMgr();
  virtual void TimeChanged();
  void DestroySoundMgr();
  TOgleSoundMgr *GetSoundMgr();

  virtual void SetupModeIDS();
  virtual void SetupModeStrings();
  virtual void SetupModeIndexes();
  virtual void SetupModeInfo(); // mrp - v2.5 - 09/23/99 - verified safe time to acces pgame's modelist.
  TOgleModeWindow *GetModeWin();
  virtual TWindow *CreateModeWindow(int16 ModeIndex);
  bool IsPGameValid();
//  TOgleGame *GetPGame();
  TOgleGame *GetGame();
  LRESULT ReceiveOgleMsg(WPARAM wparam,LPARAM lparam);
  virtual void HandleOgleMsg(TOgleMsg &msg);
  virtual void HandleSwitchClients(TOgleMsg &msg);
  virtual void HandleSwitchModes(TOgleMsg &msg);
  virtual void HandleSwitchModesIDCode(TSwToModeIDCodeMsg &msg);
  virtual void SwitchModesID(WORD idcode,WORD sidcode);
  bool SwitchModes(int16 modeindex);
  bool IsValidModeIndex(int16 NewModeIndex);

  virtual bool CanCloseClientW();
  virtual void SwitchClientW(bool IsMW,int16 mi,int16 action = 0);
  virtual void ReleaseClientW();
  virtual void HandleOldClientW(bool IsMW,int16 mi,int16 action = 0);
  virtual TWindow *CreateNewClientW(bool IsMW,int16 mi,int16 action = 0);
  virtual void SetClientW(TWindow *pw);
  virtual void HandleNewClientW(bool IsMW,int16 mi,int16 action = 0);
  DECLARE_RESPONSE_TABLE(TOgleGameFrameWindow);
};
//*******************************************************************
//***********************  inlines  *********************************
//*******************************************************************
inline int TOgleGameFrameWindow::MessageBox(const char far* text,
                                            const char far* caption,uint type)
{
  return TFrameWindow::MessageBox(text,caption,type);
}
//*******************************************************************
inline TOgleApp *TOgleGameFrameWindow::GetOgleApp()
{
//  return POgleApp;
  return TOgleApp::GetOgleApp();
}
//*******************************************************************
inline TOgleGame *TOgleGameFrameWindow::GetGame()
{
  return TOgleApp::GetOgleApp()->GetGame();
//  return PGame;
}
//*******************************************************************
inline TOgleFileMgr *TOgleGameFrameWindow::GetFileMgr()
{
//  return PFileMgr;
  return TOgleApp::GetOgleApp()->GetFileMgr();
}
//*******************************************************************
inline TPlayerMgr *TOgleGameFrameWindow::GetPlayerMgr()
{
  return PlayerMgr;
}
//*******************************************************************
inline TOgleMenuEnable *TOgleGameFrameWindow::GetMenuEnable()
{
  return PMenuEnable;
}
//*******************************************************************
inline bool TOgleGameFrameWindow::GetHandleShowMenu()
{
  return HandleShowMenu;
}
//*******************************************************************
inline bool TOgleGameFrameWindow::IsInitialized()
{
  return Initialized;
}
//*******************************************************************
inline TOgleSoundMgr *TOgleGameFrameWindow::GetSoundMgr()
{
  return PSoundMgr;
}
//*******************************************************************
inline TOgleModeWindow *TOgleGameFrameWindow::GetModeWin()
{
  return PModeWin;
}
//*******************************************************************
inline bool TOgleGameFrameWindow::IsSplashScreenActive()
{
  return bool(PSplashScreen != NULL);
}
//*******************************************************************
#endif

