//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  ogobjlst.h
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     6/24/95    M.Perry    original baseline
//  2.0     8/24/97    M.Perry    32-bit conversion.
//********************************************************************
#if !defined(__ogobjlst_h)         
#define __ogobjlst_h

#if !defined(__olist_h)
#include "olist.h"
#endif

#if !defined(__ogobj_h)
#include "ogobj.h"
#endif

#ifdef DEBUGSPRITES
  #include <iostream.h>
  #include <fstream.h>
#endif

//typedef char TName[_MAX_FNAME + _MAX_EXT];

class TOgleMode;
//*******************************************************************
class TGObjList:public TOgleList
{
protected:
  bool SetDefDir(int16 index,string name);
  TGameObject *CreateGObj(TFileMode &fm);
public:
  int16 NumNames;
  string *PNames;
  int16 *PIDs;
  TOgleMode *PMode;
  TOgleMode *GetMode() {return PMode;}
  void CreateNameArray(int16 numnames);
  void DestroyNameArray();
  virtual bool CreateGObjs(void *psource = NULL);
  void NotifyModeNumGObjs(int16 numgobjs);
  void PostRead();
  void SetIDs();
  virtual void SetMajVer();
  virtual bool ReadLocal();
  virtual bool WriteLocal();
  bool ReadLocal2_0();
  virtual string AddExt();
  virtual const char *GetIDChars() const;
  #ifdef DEBUGSPRITES
  void RTReport(ofstream &os);
  #endif
  #ifdef GED_COMPILE
  bool IsSpriteUsedBySkit(int16 gobjindex,int16 spriteindex,int16 &usedgi,int16 &usedskci,int16 &usedski);
  #endif
  #if defined(GED_COMPILE)
  bool CheckSpriteIDConflict();
  #endif
  #if defined(GED_COMPILE)
  bool CheckSpriteIDUsage();
  #endif
  virtual void ShuttingDown();
  virtual bool Save();
  virtual void Slenderize();
  TGObjList(TOgleModeWindow *pmw,TOgleMode *pmode);
  TGObjList(TOgleModeWindow *pmw,TOgleMode *pmode,TFileMode &fm);
  virtual ~TGObjList();

  virtual void Activate(dword StartFUC);
  virtual void DeActivate();

  // Start of Disabled functions.
  virtual bool IsActiveElement(int16 ElementNum);
  virtual bool IsActiveElement(TOgleBase *PBase);
  virtual bool ActivateElement(int16 ElementNum,dword StartFUC);
  virtual bool ActivateElement(TOgleBase *PBase,dword StartFUC);
  virtual void DeActivateElement(int16 ElementNum);
  virtual void DeActivateElement(TOgleBase *PBase);
  virtual void Show();
  virtual void NoShow();
  // End of disabled functions.

  virtual bool ActivateSkit(int16 GObjIndex,int16 SkitCatIndex,int16 SkitIndex,dword StartFUC);
  dword GetSkitLength(int16 GObjIndex,int16 SkitCatIndex,int16 SkitIndex);
  dword GetSpriteLength(int16 GObjIndex,int16 SpriteIndex);
  virtual bool ActivateSprite(int16 GObjIndex,int16 ListNum,dword StartFUC);
  virtual bool IsActiveSprite(int16 GObjIndex,int16 ListNum);
  virtual bool CanActivateSprite(int16 GObjIndex,int16 ListNum,dword StartFUC);

  virtual void Update(dword NewFUC);
  virtual void PostUpdate(dword NewFUC);
  virtual void RunState();
  virtual TGameObject *CreateNewElement(TFileMode NewFileMode);
//  virtual TGameObject *CreateGObj(TFileMode NewFileMode);
  TGameObject *CreateGObj(TFileMode &fm,int16 id,void *psource = NULL);
  TGameObject *CreateGObj(string name);
  bool DestroyGObj(TGameObject *pgobj);
  bool CreateAddGObj(TFileMode &fm,int16 id,void *psource = NULL);
  bool CreateAddGObj(TFileMode &fm);
  TGameObject *CreateAddGObj(string name);
  bool AddGObj(TGameObject *PGObj);
  bool AddGObj(string GObjName);
  TGameObject *RemoveGObj(int16 gi);
  bool DeleteGObj(int16 gi);
  TGameObject *GetGObjPtr(int16 GObjIndex);
  int16 GetGObjIndex(string GObjName);

  virtual void UpdateState(dword NewFUC);
  virtual void PostUpdateState(dword NewFUC);
  virtual void SetIndexes();
};
//*******************************************************************
//********************* TGObjList inlines ***************************
//*******************************************************************
inline TGameObject *TGObjList::GetGObjPtr(int16 GObjIndex)
{
//  if (GObjIndex > LastAddedElementNum) {return NULL;}
//  return ((TGameObject *)List[GObjIndex]);
  return (TGameObject *)GetElementPtr(GObjIndex);
}
//*******************************************************************
#endif

