//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  orow.h
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     6/20/95    M.Perry     original baseline
//  2.0     8/20/97    M.Perry     32-bit conversion.
//********************************************************************
#if !defined(__orow_h) 
#define __orow_h                     

#if !defined(__olist_h)
#include "olist.h"
#endif

#if !defined(__ocell_h)
#include "ocell.h"
#endif

#define MAXCELLS 8

#define BIT0 0
#define BIT1 1
#define BIT2 2
#define BIT3 3
#define BIT4 4
#define BIT5 5
#define BIT6 6
#define BIT7 7

//*******************************************************************
class TOgleRow:public TOgleList
{
public:
  byte Map;
public:
  virtual void SetIndexes();
  virtual bool ReadLocal();
  virtual bool WriteLocal();
  virtual const char *GetIDChars() const;
  TOgleRow(TOgleModeWindow *pmw);
  TOgleRow(TOgleModeWindow *pmw,TFileMode &fm);
  TOgleRow(TOgleModeWindow *pmw,void *PReadData,bool AutoRead = true);
  virtual ~TOgleRow();

  virtual TOgleCell *CreateNewCell();
  virtual TOgleCell *CreateNewCell(void *PSource);
  virtual bool AddCell(byte CellNum,TOgleCell *PCell);
  virtual bool ManualAddCell(byte CellNum,TOgleCell *PCell);
  virtual TOgleCell *RemoveCell(byte CellNum);
  void CreateLists(int16 RowNum);
  virtual int16 GetGrowSize();

  byte CellNumToByte(byte CellNum); //returns correct bit for cellnum
  bool CheckMap(byte CellNum);
  void SetMap(byte CellNum);
  void ClearMap(byte CellNum);

  virtual void Activate(dword StartFUC = 0);
  virtual bool IsActiveElement(int16 ElementNum);
  virtual bool IsActiveElement(TOgleBase *PBase);
  virtual bool ActivateElement(int16 ElementNum,dword StartFUC);
  virtual bool ActivateElement(TOgleBase *PBase,dword StartFUC);
  virtual void DeActivateElement(int16 ElementNum);
  virtual void DeActivateElement(TOgleBase *PBase);
  virtual void Show();
  virtual void NoShow();
  virtual void Update(dword NewFUC);
  virtual void PostUpdate(dword NewFUC);
  TOgleCell *GetCell(byte CellNum);
  virtual void Start(dword StartFUC);
  virtual void Start();
  virtual bool CanActivate(dword StartFUC);
};
//*******************************************************************
//********************  inlines  ************************************
//*******************************************************************
inline bool TOgleRow::CheckMap(byte CellNum)
{
  return (Map & CellNumToByte(CellNum));
}
//*******************************************************************
inline void TOgleRow::SetMap(byte CellNum)
{
  Map = Map | CellNumToByte(CellNum);
}
//*******************************************************************
inline void TOgleRow::ClearMap(byte CellNum)
{
  Map = Map & byte(~(CellNumToByte(CellNum)));
}
//*******************************************************************
inline TOgleCell *TOgleRow::GetCell(byte CellNum)
{
  if (!CheckMap(CellNum)) {return NULL;}
  return ((TOgleCell *)GetElementPtr(CellNum));
}
//*******************************************************************
#endif

