//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  oskitcat.h
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//   1.0   8/27/95     M.Perry    original baseline
//   1.2   03/27/97    M.Perry    changed load dialog subsystem.
//   2.0   8/24/97     M.Perry    32-bit conversion.
//   2.1   12/6/97     M.Perry    filename mod's
//********************************************************************
#if !defined(__oskitcat_h)
#define __oskitcat_h

#if !defined(__olist_h)
#include "olist.h"
#endif

#if !defined(__oskitlst_h)
#include "oskitlst.h"
#endif

class TGameObject;
//*******************************************************************
class TSkitCat:public TOgleList
{
public:
  #ifdef GED_COMPILE
  void ReportSpriteUsage(ofstream &os,int16 gobjindex,int16 skitcatindex,int16 skitindex,
                         int16 spriteindex);
  bool IsSpriteUsedBySkit(int16 gobjindex,int16 spriteindex,int16 &usedskci,int16 &usedski);
  void CriteriaReport(ofstream &os);
  #endif

  virtual void Slenderize();
  virtual void SetIndexes();
  TGObjSk *POwnerGObj;
  TSkitCat(TOgleModeWindow *pmw);
  TSkitCat(TOgleModeWindow *pmw,TFileMode NewFileMode,TGObjSk *PNewGObj,
           bool AutoRead = true,bool KeepBaseFile = false);
  virtual ~TSkitCat();
  virtual bool ReadLocal();
  bool ReadLocal1_0();
  bool ReadLocal2_0();
  virtual bool WriteLocal();
  virtual const char *GetIDChars() const;
  virtual void SetMajVer();
  virtual bool Save();
  TSkitList *CreateSkitList(const string &SkitListName);
  virtual string AddExt();
  int16 GetLastNumSkitLists();
  int16 GetNumSkitCats();
  TSkitList *GetSkitList(int16 SkitListIndex);
  TSkitList *GetSkitList(const string &SkitListName);
  int16 GetSkitListIndex(const string &SkitListName);
  string GetSkitCatName(int16 SkitCatIndex);
  bool ActivateSkit(int16 SkitCatIndex,int16 SkitIndex,dword StartFUC);
  dword GetSkitLength(int16 SkitCatIndex,int16 SkitIndex);
  bool CanActivateSkit(int16 SkitCatIndex,int16 SkitIndex,dword StartFUC);
  bool ChooseStartSkit(int16 SkitCatIndex,dword &StartFUC,dword &FUCLen,int16 &skitindex);
  bool ChooseStartSkit(string &skitcatname,dword &StartFUC,dword &FUCLen,int16 &skitindex);
  bool DeleteSkitCatList(string skitcatfname);
};
//*******************************************************************
//************** TSkitCat inlines ***********************************
//*******************************************************************
inline int16 TSkitCat::GetLastNumSkitLists()
{
  return LastAddedElementNum;
}
//*******************************************************************
inline int16 TSkitCat::GetNumSkitCats()
{
  return int16(LastAddedElementNum + 1);
}
//*******************************************************************
inline TSkitList *TSkitCat::GetSkitList(int16 SkitListIndex)
{
  return ((TSkitList *)GetElementPtr(SkitListIndex));
}
//*******************************************************************
inline TSkitList *TSkitCat::GetSkitList(const string &SkitListName)
{
  return ((TSkitList *)GetElementPtr(SkitListName));
}
//*******************************************************************
inline int16 TSkitCat::GetSkitListIndex(const string &SkitListName)
{
  return GetElementIndex(SkitListName);
}
//*******************************************************************
inline string TSkitCat::GetSkitCatName(int16 SkitCatIndex)
{
//  if (GetElementPtr(SkitCatIndex) == NULL) {return string();}
//  return GetElementPtr(SkitCatIndex)->GetFName();

  TOgleBase *pbase = GetElementPtr(SkitCatIndex);
  if (pbase == NULL) {return TAppString::strEmpty;}
  return pbase->FileMode.Name.GetStr();
}                             
//*******************************************************************
inline bool TSkitCat::ChooseStartSkit(string &skitcatname,dword &StartFUC,dword &FUCLen,int16 &skitindex)
{
  return ChooseStartSkit(GetSkitListIndex(skitcatname),StartFUC,FUCLen,skitindex);
}
//*******************************************************************
#endif

