//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  oskitrow.h
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     8/27/95    M.Perry    original baseline
//  2.0     8/24/97    M.Perry    32-bit conversion.
//********************************************************************
#if !defined(__oskitrow_h)
#define __oskitrow_h

#if !defined(__orow_h)
#include "orow.h"
#endif

#if !defined(__oskitcel_h)
#include "oskitcel.h"
#endif

class TGObjsk;
class TSkitDataList;
//*******************************************************************
class TSkitRow:public TOgleRow
{
public:
  TGObjSk *POwnerGObj;

public:
  int16 GetNumValidCells();
  void AddToDataList(TSkitDataList *pdatalist,int16 rownum);

  #ifdef GED_COMPILE
  void ReportSpriteUsage(ofstream &os,string &skitname,int16 gobjindex,int16 spriteindex);
  bool IsSpriteUsedBySkit(int16 gobjindex,int16 spriteindex);
  #endif

  TSkitRow(TOgleModeWindow *pmw,TFileMode &NewFileMode,TGObjSk *PNewGObj);
  TSkitRow(TOgleModeWindow *pmw,TFileMode &NewFileMode,TGObjSk *PNewGObj,
           void *PReadData,bool AutoRead = true);
  virtual ~TSkitRow();
  virtual TOgleCell *CreateNewCell();
  virtual TOgleCell *CreateNewCell(void *PSource);
  TSkitCell *GetSkitCell(byte CellIndex);
  void MakeCellIfNull(int16 CellNum);
  void ClearCellIfNotNull(int16 CellNum);
  virtual void Activate(dword StartFUC);
  dword GetCalcFUCLength(int16 RowNum);
  virtual void SetMinVer();
};
//*******************************************************************
//********************** TSkitRow inlines ***************************
//*******************************************************************
inline TSkitCell *TSkitRow::GetSkitCell(byte CellIndex)
{
  return ((TSkitCell *)GetCell(CellIndex));
}
//*******************************************************************
#endif

