//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  oskittbl.h
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     8/27/95    M.Perry    original baseline
//  2.0     8/24/97    M.Perry    32-bit conversion.
//********************************************************************
#if !defined(__oskittbl_h)
#define __oskittbl_h

#if !defined(__otable_h)
#include "otable.h"
#endif

#if !defined(__oskitrow_h)
#include "oskitrow.h"
#endif

class TGObjSk;
class TSkitDataList;
//*******************************************************************
class TSkitTable:public TOgleTable
{
public:
  TGObjSk *POwnerGObj;

public:
  int16 GetNumValidCells();
  void AddToDataList(TSkitDataList *pdatalist);

  #ifdef GED_COMPILE
  void ReportSpriteUsage(ofstream &os,string &skitname,int16 gobjindex,int16 spriteindex);
  bool IsSpriteUsedBySkit(int16 gobjindex,int16 spriteindex);
  #endif

  TSkitTable(TOgleModeWindow *pmw,TGObjSk *PNewGObj);
  TSkitTable(TOgleModeWindow *pmw,TFileMode &NewFileMode,TGObjSk *PNewGObj,
             void *PReadData,bool AutoRead = true);
  virtual ~TSkitTable();
  virtual TOgleRow *CreateNewRow();
  virtual TOgleRow *CreateNewRow(void *PSource);
  TSkitRow *GetSkitRow(int16 RowIndex);
  TSkitCell *GetSkitCell(int16 RowIndex,int16 CellIndex);
  virtual void Activate(dword StartFUC);
  virtual void Start(dword StartFUC);
  virtual void Start();
  bool CanActivate(dword StartFUC);
  dword GetCalcFUCLength();
  virtual void SetMinVer(); 
};
//*******************************************************************
//********************** TSkitTable inlines *************************
//*******************************************************************
inline TSkitRow *TSkitTable::GetSkitRow(int16 RowIndex)
{
  return ((TSkitRow *)GetElementPtr(RowIndex));
}
//*******************************************************************
#endif

