//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  osound.h
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//   1.0    5/14/95    M.Perry     original baseline
//   2.0    8/23/97    M.Perry     32-bit conversion.
//********************************************************************
#if !defined(__osound_h)
#define __osound_h

#if !defined(__obase_h)
#include "obase.h"
#endif

#define osndFIRST ((WORD)(obLAST * 2))
#define osndADDEDTOSNDMGR (osndFIRST)
#define osndLAST (osndADDEDTOSNDMGR) 

class TOgleSoundMgr;
//*******************************************************************
class TSound:public TOgleBase
{
private:
  TOgleSoundMgr *PSoundMgr;

public:
  TSound(TOgleModeWindow *pmw);
  TSound(TOgleModeWindow *pmw,const TFileMode &fm);
  virtual ~TSound();
  TOgleSoundMgr *FindSoundMgr();
  TOgleSoundMgr *GetSoundMgr();
  bool GetAddedToSndMgr();
  void SetAddedToSndMgr();
  void ClearAddedToSndMgr();
};
//*******************************************************************
//********************* inlines *************************************
//*******************************************************************
inline TOgleSoundMgr *TSound::GetSoundMgr()
{
  return PSoundMgr;
}
//*******************************************************************
inline bool TSound::GetAddedToSndMgr()
{
  return StatFlags.IsSet(osndADDEDTOSNDMGR);
}
//*******************************************************************
inline void TSound::SetAddedToSndMgr()
{
  StatFlags.Set(osndADDEDTOSNDMGR);
}
//*******************************************************************
inline void TSound::ClearAddedToSndMgr()
{
  StatFlags.Clear(osndADDEDTOSNDMGR);
}
//*******************************************************************
#endif
