//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  osys.h
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     5/30/96    M.Perry    original baseline
//  2.0     8/26/97    M.Perry    32-bit conversion.
//********************************************************************
#if !defined(__osys_h)
#define __osys_h

#if !defined(__ogle_h)
#include "ogle.h"
#endif

#if defined(BI_PLAT_WIN16) && !defined(__TOOLHELP_H)
  #include <toolhelp.h>
#endif
//*******************************************************************
class TSys
// win16,win32 dependent code.
{
protected:
  static bool Initialized;
  #if defined(BI_PLAT_WIN16)
  static MEMMANINFO mmi;
  static TIMERINFO ti;
  #else
  static MEMORYSTATUS ms;
  static dword StartMSec;
  static dword LastMSec;
  static dword MSConst;
  static bool MSWrapped;
  #endif

public:
  TSys();
  ~TSys();
  static void RequestDiscard();
  static dword GetSwapFileSizeBytes();
  static dword GetPhysicalSizeBytes();
  static void RefreshMemInfo();
  static dword GetMSec();

protected:
  static void InitSys();
  #if defined(BI_PLAT_WIN32)
  static void InitMSec();
  #endif
};
//*******************************************************************
//**********************  inlines for Win16**************************
//*******************************************************************
#if defined(BI_PLAT_WIN16)
inline dword TSys::GetMSec()
{
  TimerCount(&ti);
  return dword(ti.dwmsSinceStart);
}
#endif
//*******************************************************************
inline void TSys::RequestDiscard()
{
  #if defined(BI_PLAT_WIN16)
  ::GlobalCompact(-1);
  #else
  // can't do anything in Win32.
  #endif
}
//*******************************************************************
inline dword TSys::GetSwapFileSizeBytes()
{
  #if defined(BI_PLAT_WIN16)
  return dword(dword(mmi.dwSwapFilePages) * dword(mmi.wPageSize));
  #else
  RefreshMemInfo(); // win32 can grow swap file dynamically.
  return dword(ms.dwTotalPageFile);
  #endif
}
//*******************************************************************
inline dword TSys::GetPhysicalSizeBytes()
{
//  RefreshMemInfo();
  #if defined(BI_PLAT_WIN16)
  return dword(dword(mmi.dwTotalPages) * dword(mmi.wPageSize));
  #else
  return dword(ms.dwTotalPhys);
  #endif
}
//*******************************************************************
inline void TSys::RefreshMemInfo()
{
  #if defined(BI_PLAT_WIN16)
  MemManInfo(&mmi);
  #else
  GlobalMemoryStatus(&ms);
  #endif
}
//*******************************************************************
#endif

