//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  owingdll.h
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//   1.0    7/5/96     M.Perry    original baseline - idea from "Amazing 3D Games"
//   2.0    8/28/97    M.Perry    32-bit conversion.
//********************************************************************
#if !defined(__owingdll_h)
#define __owingdll_h

#if !defined(__odll_h)
#include "odll.h"
#endif

#if !defined(_INC_WING)
#include "wing.h"
#endif
//*******************************************************************
typedef HDC (WINAPI *wingCreateDC)( void );
typedef BOOL (WINAPI *wingRecommendDIBFormat)( BITMAPINFO FAR *pFormat );
typedef HBITMAP (WINAPI *wingCreateBitmap)( HDC WinGDC, BITMAPINFO const *pHeader,
        void *ppBits );
typedef void FAR *(WINAPI *wingGetDIBPointer)( HBITMAP WinGBitmap,
        BITMAPINFO FAR *pHeader );
typedef UINT (WINAPI *wingGetDIBColorTable)( HDC WinGDC, UINT StartIndex,
        UINT NumberOfEntries, RGBQUAD FAR *pColors );
typedef UINT (WINAPI *wingSetDIBColorTable)( HDC WinGDC, UINT StartIndex,
        UINT NumberOfEntries, RGBQUAD const FAR *pColors );
typedef HPALETTE (WINAPI *wingCreateHalftonePalette)( void );
typedef HBRUSH (WINAPI *wingCreateHalftoneBrush)( HDC, COLORREF,
            WING_DITHER_TYPE);
typedef BOOL (WINAPI *wingBitBlt)( HDC hdcDest, int nXOriginDest,
        int nYOriginDest, int nWidthDest, int nHeightDest, HDC hdcSrc,
        int nXOriginSrc, int nYOriginSrc );
typedef BOOL (WINAPI *wingStretchBlt)( HDC hdcDest, int nXOriginDest,
        int nYOriginDest, int nWidthDest, int nHeightDest, HDC hdcSrc,
        int nXOriginSrc, int nYOriginSrc, int nWidthSrc, int nHeightSrc );
//*******************************************************************
class TOgleWinG:public TOgleDll
{
protected:
   static TOgleWinG *POgleWinG;
   TOgleWinG();
   virtual ~TOgleWinG();

public:
   static TOgleWinG *Dll() {return POgleWinG;}
   static bool LoadDll();
   static bool UnLoadDll(bool ignoreRef = FALSE);

   virtual bool SetupProcs();
   virtual bool CleanupProcs();

   // function ptrs.
   wingCreateDC               CreateDC;
   wingRecommendDIBFormat     RecommendDIBFormat;
   wingCreateBitmap           CreateBitmap;
   wingGetDIBPointer          GetDIBPointer;
   wingGetDIBColorTable       GetDIBColorTable;
   wingSetDIBColorTable       SetDIBColorTable;
   wingCreateHalftonePalette  CreateHalftonePalette;
   wingCreateHalftoneBrush    CreateHalftoneBrush;
   wingBitBlt                 BitBlt;
   wingStretchBlt             StretchBlt;
};
//*******************************************************************
#endif

