//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  pokerdec.h
//    Project Name:  Ogle
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     06/01/95   A. Krist    Original baseline
//  2.0     08/26/97   M.Perry     32-bit conversion.
//*******************************************************************
#if !defined __pokerdeck_h
#define __pokerdeck_h

#include <iostream.h>
#include "card.h"
#include "pokerhan.h"
#include "deck.h"

const DECK  = 52;
const DECK2 = 104;
const DECK4 = 208;
const DECK6 = 312;
//*******************************************************************
class TPokerDeck : public TDeck
{
public:
  TPokerDeck();
  TPokerDeck(int16 num);
  virtual ~TPokerDeck();
  virtual int16 Shuffle();
  virtual int16 ShowDeck();
  int16 Swap(int16 x,int16 y);
  int16 InitDeck(int16 numofcards=DECK);
  virtual int16 InitTemp(){return 1;};
  virtual int16 ShowHand(THand * h);
  virtual int16 ShowWinner(THand *phand){return 1;};
  virtual int16 Draw(THand *hand) {return TDeck::Draw(hand);}
  int16 ShowCard(TCard *c);
  virtual int16 Discard(int16 i){return 1;};
  virtual int16 ShuffleTemp(){return 1;};
  virtual int16 AddLeftover(THand *hnd){return 1;};
  virtual int16 DealTemp(int16 i){return 1;};
  virtual TDeck* GetDiscards(){return this;};
};
//*******************************************************************
#endif

