//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  pokersma.h
//    Project Name:  Ogle
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     06/01/95   A. Krist    Original baseline
//  2.0     08/26/97   M.Perry     32-bit conversion.
//*******************************************************************
#if !defined __pokersmarts_h
#define __pokersmarts_h

#include "ogle.h"
#include "hand.h"
#include "smarts.h"
#include "pokerhan.h"
class OGLEOWLCLASS TOgleModeWindow;
//*******************************************************************
class TPokerSmarts : public TSmarts
{
public:
  TPokerSmarts();
  virtual ~TPokerSmarts();
  int16 Insert_Sort(TPokerHand *h);
  int16 Compare(TPokerHand *h1,TPokerHand *h2);
  int16 Arbitrate(TPokerHand *h1,TPokerHand *h2);
  int16 LowArb(TPokerHand *h1,TPokerHand *h2);
  int16 AceLoStraight(TPokerHand *h);
  int16 Straight(TPokerHand *h);
  int16 Flushing(TPokerHand *h);
  int16 Strip(TPokerHand *h);
  int16 LoPairs(TPokerHand *h);
  int16 Pairs(TPokerHand *h);
  virtual int16 Holding(THand *h){return 1;};
  virtual int16 Compare(THand *hnd,THand *hnd2);
  virtual int16 LowComp(THand *h1,THand *h2);
};
//*******************************************************************
#endif
