//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  ocurmgr.cpp
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     2/23/96    M.Perry    original baseline
//  2.0     8/26/97    M.Perry    32-bit conversion.
//********************************************************************
#if !defined(__ocurmgr_h)
#include "ocurmgr.h"
#endif

#if !defined(__oapp_h)
#include "oapp.h"
#endif

#if !defined(__ogamefw_h)
#include "ogamefw.h"
#endif
//*******************************************************************
TCursorMgr::TCursorMgr(TOgleApp *papp)
{
  POgleApp = papp;

  // could just use default ctor for the first 4.
  CursorData[ctHiPri] = TCursorData(0,0);
  CursorData[ctFileMgr] = TCursorData(0,0);
  CursorData[ctAction] = TCursorData(0,0);
  CursorData[ctArea] = TCursorData(0,0);
  CursorData[ctNormal] = TCursorData(0,IDC_ARROW);
}
//*******************************************************************
TCursorMgr::~TCursorMgr()
{
  POgleApp = NULL;
}
//*******************************************************************
void TCursorMgr::SetCursor()
{
  if (POgleApp != NULL && POgleApp->GetFW() != NULL)
  {
    POgleApp->GetFW()->SetCursorData(GetCursor(),true);
  }
  else
  {
    TCursorData &cd = GetCursor();
    if (cd.PModule) {::SetCursor(cd.PModule->LoadCursor(cd.ResId));}
    else {::SetCursor(::LoadCursor(0,cd.ResId));}
  }
}
//*******************************************************************
void TCursorMgr::SetCursor(TCursorTypes CT,TModule *pmodule,TResId resId,bool force)
{
  if (!CheckIndex(CT)) {return;}
  CursorData[CT].Set(pmodule,resId);
  if (force) {SetCursor();}
}
//*******************************************************************
void TCursorMgr::SetCursor(TCursorTypes CT,TCursorData &cd,bool force)
{
  if (!CheckIndex(CT)) {return;}
  CursorData[CT] = cd;
  if (force) {SetCursor();}
}
//*******************************************************************

