//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  ocell.cpp
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     6/20/95    M.Perry    original baseline
//********************************************************************
#include "ocell.h"

//*******************************************************************
void TOgleCell::ClearCell()
{
  CellFileName = TAppString::strEmpty;
}
//*******************************************************************
const char *TOgleCell::GetIDChars() const
{
  return "Cell";
}
//*******************************************************************
#pragma argsused
bool TOgleCell::CanActivate(dword StartFUC)
{
  return FALSE;
}
//*******************************************************************
TOgleCell::TOgleCell()
:TOgleBase(NULL),
 ListIndex(-1)
{
  FUC_Length = 0;
//  ListIndex = -1;
}
//*******************************************************************
TOgleCell::TOgleCell(TOgleModeWindow *pmw)
:TOgleBase(pmw),
 ListIndex(-1)
{
  FUC_Length = 0;
}
//*******************************************************************
TOgleCell::TOgleCell(TOgleModeWindow *pmw,TFileMode &fm)
:TOgleBase(pmw,TRUE,fm),
 ListIndex(-1)
{
  FUC_Length = 0;
}
//*******************************************************************
TOgleCell::TOgleCell(TOgleModeWindow *pmw,void *PReadData,bool AutoRead)
:TOgleBase(pmw),
 ListIndex(-1)
{
  Init(PReadData,AutoRead);
}
//*******************************************************************
TOgleCell::~TOgleCell()
{
}
//*******************************************************************
void TOgleCell::CreateLists(int16 RowNum)
{
  if (CellFileName.is_null()) {return;}

  AddToOwnersList(RowNum);
}
//*******************************************************************
#pragma argsused
TOgleBase *TOgleCell::CreateNewBase(int16 RowNum)
{
  return (new TOgleBase(PModeWin));
}
//*******************************************************************

