//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  orow.cpp
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     6/20/95    M.Perry    original baseline
//********************************************************************
#include "orow.h"

//*******************************************************************
int16 TOgleRow::GetGrowSize()
{
  return (int16)MAXCELLS;
}
//*******************************************************************
void TOgleRow::Start()
{
  TOgleList::Start();
}
//*******************************************************************
void TOgleRow::Show()
{
}
//*******************************************************************
void TOgleRow::NoShow()
{
}
//*******************************************************************
#pragma argsused
void TOgleRow::Update(dword NewFUC)
{
}
//*******************************************************************
#pragma argsused
void TOgleRow::PostUpdate(dword NewFUC)
{
}
//*******************************************************************
#pragma argsused
void TOgleRow::DeActivateElement(int16 ElementNum)
{
}
//*******************************************************************
#pragma argsused
void TOgleRow::DeActivateElement(TOgleBase *PBase)
{
}
//*******************************************************************
#pragma argsused
bool TOgleRow::ActivateElement(TOgleBase *PBase,dword StartFUC)
{
  return false;
}
//*******************************************************************
#pragma argsused
bool TOgleRow::IsActiveElement(int16 ElementNum)
{
  return false;
}
//*******************************************************************
#pragma argsused
bool TOgleRow::IsActiveElement(TOgleBase *PBase)
{
  return false;
}
//*******************************************************************
TOgleCell *TOgleRow::CreateNewCell()
{
  return new TOgleCell(GetModeWin());
}
//*******************************************************************
TOgleCell *TOgleRow::CreateNewCell(void *PSource)
{
  return new TOgleCell(GetModeWin(),PSource);
}
//*******************************************************************
bool TOgleRow::AddCell(byte CellNum,TOgleCell *PCell)
{
  List[CellNum] = PCell;
  return true;
}
//*******************************************************************
TOgleRow::~TOgleRow()
{
}
//*******************************************************************
const char *TOgleRow::GetIDChars() const
{
  return "ROW ";
}
//*******************************************************************
void TOgleRow::SetIndexes()
{
  for (int16 i =0;i<8;i++)
  {
    TOgleCell *pcell = GetCell(i);
    if (pcell != NULL) {pcell->SetIndexes();}
  }
}
//*******************************************************************
bool TOgleRow::ReadLocal()
{
  if (!(Readbyte(&Map))) {return false;}

  for (int16 i = 0;i<MAXCELLS;i++)
  {
    if (CheckMap(i))
    {
      TOgleCell *PCell = CreateNewCell(GetPtr());
      FileOffset += PCell->ReadSize;
      AddCell(i,PCell);
    }
  }
  return true;
}
//*******************************************************************
bool TOgleRow::WriteLocal()
{
  if (!Writebyte(&Map)) {return false;}

  for (int16 i=0;i<MAXCELLS;i++)
  {
    TOgleCell *pcell = GetCell(i);
    if (pcell != NULL)
    {
      if (!pcell->Write(PWriteBuf)) {return false;}
    }
  }
  return true;
}
//*******************************************************************
TOgleRow::TOgleRow(TOgleModeWindow *pmw,TFileMode &fm)
:TOgleList(pmw,true,fm),
 Map(0)
{
  for (int16 i=0;i<MAXCELLS;i++)
  {
    AddElement(NULL);
  }
}
//*******************************************************************
TOgleRow::TOgleRow(TOgleModeWindow *pmw)
:TOgleList(pmw),
  Map(0)
{
  for (int16 i=0;i<MAXCELLS;i++)
  {
    AddElement(NULL);
  }
}
//*******************************************************************
TOgleRow::TOgleRow(TOgleModeWindow *pmw,void *PReadData,bool AutoRead)
:TOgleList(pmw),
 Map(0)
{
  //List is filled with MAXCELL NULL ptrs
  for (int16 i=0;i<MAXCELLS;i++)
  {
    AddElement(NULL);
  }
  Init(PReadData,AutoRead);
}
//*******************************************************************
byte TOgleRow::CellNumToByte(byte CellNum)
{
  switch (CellNum)
  {
    case 0:return ((byte)1);
    case 1:return ((byte)2);
    case 2:return ((byte)4);
    case 3:return ((byte)8);
    case 4:return ((byte)16);
    case 5:return ((byte)32);
    case 6:return ((byte)64);
    case 7:return ((byte)128);
    default:return ((byte)0);
  }
}
//*******************************************************************'
bool TOgleRow::ManualAddCell(byte CellNum,TOgleCell *PCell)
{
  if (CheckMap(CellNum)) {return false;}
  if (List[CellNum] != NULL) {return false;}

  SetMap(CellNum);
  List[CellNum] = PCell;
  return true;
}
//*******************************************************************
TOgleCell *TOgleRow::RemoveCell(byte CellNum)
{
  if (!CheckMap(CellNum)) {return NULL;}

//  TOgleCell *PTempCell = (TOgleCell *)List[CellNum];
  TOgleCell *PTempCell = GetCell(CellNum);
  ClearMap(CellNum);
  List[CellNum] = NULL;
  return PTempCell;
}
//*******************************************************************
void TOgleRow::Activate(dword StartFUC)
{
  for (int16 i=0;i<MAXCELLS;i++)
  {
    if (CheckMap(i))
    {
       ActivateElement(i,StartFUC);
    }
  }
}
//*******************************************************************
bool TOgleRow::ActivateElement(int16 ElementNum,dword StartFUC)
{
  if (GetCell(ElementNum) == NULL) {return false;}
  GetCell(ElementNum)->Activate(StartFUC);
  return true;
}
//*******************************************************************
void TOgleRow::CreateLists(int16 RowNum)
{
  for (int16 i = 0;i < MAXCELLS;i++)
  {
    TOgleCell *pcell = GetCell(i);
    if (pcell != NULL) {pcell->CreateLists(RowNum);}
  }
}
//*******************************************************************
void TOgleRow::Start(dword StartFUC)
{
  Start();
  for (int16 i=0;i<MAXCELLS;i++)
  {
    TOgleCell *pcell = GetCell(i);
    if (pcell != NULL) {pcell->Start(StartFUC);}
  }
}
//*******************************************************************
bool TOgleRow::CanActivate(dword StartFUC)
{
  for (int16 i=0;i<8;i++)
  {
    if (CheckMap((byte)i))
    {
      if (!GetCell(i)->CanActivate(StartFUC)) {return false;}
    }
  }
  return true;
}
//*******************************************************************

