//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  obasef.cpp
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     3/2/95     M.Perry      original baseline
//********************************************************************
#if !defined(__obasef_h)
#include "obasef.h"
#endif

#if !defined(__ofilemgr_h)
#include "ofilemgr.h"
#endif

DIAG_DEFINE_GROUP(BaseFile,1,1);
//*******************************************************************
void TOgleBaseFile::IncTotalHDAllocated(dword size)
{
  if (GetFileMgr() != NULL) {GetFileMgr()->IncTotalHDAllocated(size);}
}
//*******************************************************************
void TOgleBaseFile::DecTotalHDAllocated(dword size)
{
  if (GetFileMgr() != NULL) {GetFileMgr()->DecTotalHDAllocated(size);}
}
//*******************************************************************
TOgleBaseFile::TOgleBaseFile()//TOgleApp *papp)
//:POgleApp(papp),
:Size(0),
 StatFlags(obfHDBUFFERING | obfSHAREABLE),
 Offset(0),
 RamPtr(NULL),
 OwnerCount(0),
 HDImmedCount(0),
 HDBGHiCount(0),
 HDBGMedCount(0),
 HDBGLoCount(0),
 HDNoneCount(0),
 RamImmedCount(0),
 RamBGHiCount(0),
 RamBGMedCount(0),
 RamBGLoCount(0),
 RamNoneCount(0),
 RamStatus(TFileMode::fm_None),
 HDStatus(TFileMode::fm_None),
 AllocFlags(GMEM_MOVEABLE),
 ListNum(-1)
{
  TRACEX(BaseFile,2,"CTor");
//  if (POgleApp == NULL)
//  {
//    POgleApp = TOgleApp::GetOgleApp(true);
//  }
}
//*******************************************************************
TOgleBaseFile::~TOgleBaseFile()
{
  TRACEX(BaseFile,2,"DTor");
  // if RamPtr assigned then delete RamPtr
  // Warning ! RamPtr should have been deleted by FileMgr or TOgleBase class.
  // It shouldn't be here when TOgleBaseFile is destructed.
  // This is just to prevent memory leakage.
  if (IsRamAvail())
  {
    UnLoadRam();
  }
  if (IsHDAvail())
  {
    UnLoadHD();
  }
}
//*******************************************************************
TLoadResult TOgleBaseFile::LoadRam()
{
  if (IsRamAvail()) {return lrOk;}

  if (IsHDAvail() && TOgleFileName::FileExists(GetHDName()))
  {
    if (!AllocRamPtr()) {return lrMemFail;}
//    if (LoadFileToBuffer(GetHDName(),RamPtr,GetSize())) {return lrOk;}
    if (TOgleFileName::LoadBuffer(GetHDName(),RamPtr,GetSize())) {return lrOk;}
//    if (LoadFileToBuffer(GetCDRomName(),RamPtr,GetSize(),GetOffset())) {return lrOk;}
    if (TOgleFileName::LoadBuffer(GetCDRomName(),RamPtr,GetSize(),GetOffset())) {return lrOk;}
    DeAllocRamPtr();
    return lrCDReadFail;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               }
  else
  {
    if (!TOgleFileName::FileExists(GetCDRomName())) {return lrCDReadFail;} // prevents ram alloc of 0 failure.
    if (!AllocRamPtr()) {return lrMemFail;}
//    if (LoadFileToBuffer(GetCDRomName(),RamPtr,GetSize(),GetOffset())) {return lrOk;}
    if (TOgleFileName::LoadBuffer(GetCDRomName(),RamPtr,GetSize(),GetOffset())) {return lrOk;}
    DeAllocRamPtr();
    return lrCDReadFail;
  }
}
//*******************************************************************
TLoadResult TOgleBaseFile::LoadHD()
{
  TRACEX(BaseFile,1,"Load HD"<<BaseFileName);
  if (IsHDAvail()) {return lrOk;}
  if (!IsRamAvail()) {return lrMemFail;}

//  if (WriteFileFromBuffer(GetHDName(),RamPtr,GetSize()))
  if (TOgleFileName::WriteBuffer(GetHDName(),RamPtr,GetSize()))
  {
    SetHDAvail();
    IncTotalHDAllocated(GetSize());
    return lrOk;
  }
  else
  {
    return lrHDWriteFail;
  }
}
//*******************************************************************
TFMStatus TOgleBaseFile::IncHDStatus(TFMStatus hdstatus)
{
  if (hdstatus == TFileMode::fm_Immed) {IncHDImmedCount();}
  else if (hdstatus == TFileMode::fm_BG_Hi) {IncHDBGHiCount();}
  else if (hdstatus == TFileMode::fm_BG_Med) {IncHDBGMedCount();}
  else if (hdstatus == TFileMode::fm_BG_Lo) {IncHDBGLoCount();}
  else {IncHDNoneCount();}
  return SetHDStatus();
}
//*******************************************************************
TFMStatus TOgleBaseFile::IncRamStatus(TFMStatus ramstatus)
{
  if (ramstatus == TFileMode::fm_Immed) {IncRamImmedCount();}
  else if (ramstatus == TFileMode::fm_BG_Hi) {IncRamBGHiCount();}
  else if (ramstatus == TFileMode::fm_BG_Med) {IncRamBGMedCount();}
  else if (ramstatus == TFileMode::fm_BG_Lo) {IncRamBGLoCount();}
  else {IncRamNoneCount();}
  return SetRamStatus();
}
//*******************************************************************
void TOgleBaseFile::IncStatus(TFMStatus hdstatus,TFMStatus ramstatus)
{
  if (hdstatus == TFileMode::fm_Immed) {IncHDImmedCount();}
  else if (hdstatus == TFileMode::fm_BG_Hi) {IncHDBGHiCount();}
  else if (hdstatus == TFileMode::fm_BG_Med) {IncHDBGMedCount();}
  else if (hdstatus == TFileMode::fm_BG_Lo) {IncHDBGLoCount();}
  else {IncHDNoneCount();}
  SetHDStatus();

  if (ramstatus == TFileMode::fm_Immed) {IncRamImmedCount();}
  else if (ramstatus == TFileMode::fm_BG_Hi) {IncRamBGHiCount();}
  else if (ramstatus == TFileMode::fm_BG_Med) {IncRamBGMedCount();}
  else if (ramstatus == TFileMode::fm_BG_Lo) {IncRamBGLoCount();}
  else {IncRamNoneCount();}
  SetRamStatus();
}
//*******************************************************************
TFMStatus TOgleBaseFile::DecHDStatus(TFMStatus hdstatus)
{
  if (hdstatus == TFileMode::fm_Immed) {DecHDImmedCount();}
  else if (hdstatus == TFileMode::fm_BG_Hi) {DecHDBGHiCount();}
  else if (hdstatus == TFileMode::fm_BG_Med) {DecHDBGMedCount();}
  else if (hdstatus == TFileMode::fm_BG_Lo) {DecHDBGLoCount();}
  else {DecHDNoneCount();}
  return SetHDStatus();
}
//*******************************************************************
TFMStatus TOgleBaseFile::DecRamStatus(TFMStatus ramstatus)
{
  if (ramstatus == TFileMode::fm_Immed) {DecRamImmedCount();}
  else if (ramstatus == TFileMode::fm_BG_Hi) {DecRamBGHiCount();}
  else if (ramstatus == TFileMode::fm_BG_Med) {DecRamBGMedCount();}
  else if (ramstatus == TFileMode::fm_BG_Lo) {DecRamBGLoCount();}
  else {DecRamNoneCount();}
  return SetRamStatus();
}
//*******************************************************************
void TOgleBaseFile::DecStatus(TFMStatus hdstatus,TFMStatus ramstatus)
{
  if (hdstatus == TFileMode::fm_Immed) {DecHDImmedCount();}
  else if (hdstatus == TFileMode::fm_BG_Hi) {DecHDBGHiCount();}
  else if (hdstatus == TFileMode::fm_BG_Med) {DecHDBGMedCount();}
  else if (hdstatus == TFileMode::fm_BG_Lo) {DecHDBGLoCount();}
  else {DecHDNoneCount();}
  SetHDStatus();

  if (ramstatus == TFileMode::fm_Immed) {DecRamImmedCount();}
  else if (ramstatus == TFileMode::fm_BG_Hi) {DecRamBGHiCount();}
  else if (ramstatus == TFileMode::fm_BG_Med) {DecRamBGMedCount();}
  else if (ramstatus == TFileMode::fm_BG_Lo) {DecRamBGLoCount();}
  else {DecRamNoneCount();}
  SetRamStatus();
}
//*******************************************************************
bool TOgleBaseFile::ReadData(int32 ByteOffset,byte *PDest,int32 NumBytes)
{
  byte huge *PD = PDest;
  byte huge *PS = (byte *)GetRamPtr();

  if ((PD == NULL) || (PS == NULL)) {return false;}

  if ((ByteOffset + NumBytes) > GetSizeRamPtr()) {return false;}

  PS += ByteOffset;

  hmemcpy(PD,PS,NumBytes);
  return true;
}
//*******************************************************************

