//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  olist.cpp
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     6/12/95    M.Perry    original baseline
//  1.2     03/27/97   M.Perry    changed load dialog subsystem.
//  2.0     8/20/97    M.Perry    32-bit conversion.
//********************************************************************
#if !defined(__olist_h)
#include "olist.h"
#endif

#if !defined(__omodewin_h)
#include "omodewin.h"
#endif

#if !defined(__ogamefw_h)
#include "ogamefw.h"
#endif

#if !defined(__ogaugdlg_h)
#include "ogaugdlg.h"
#endif
//*******************************************************************
dword TOgleList::GetLastFUC()
{
  dword EndingFUC = 0;
  dword sf;
  dword ef;

  for (int16 i=0;i<=LastAddedElementNum;i++)
  {
    TOgleBase *pbase = GetElementPtr(i);
    if (pbase != NULL)
    {
      sf = pbase->GetFUCOffset();
      ef = sf + pbase->Get_FUC_Length() - 1;
      if (ef > EndingFUC)
      {
        EndingFUC = ef;
      }
    }
  }
  return EndingFUC;
}
//*******************************************************************
void TOgleList::TimeChanged()
{
  for (int16 i=0;i<=LastAddedElementNum;i++)
  {
    if (GetElementPtr(i) != NULL)
    {
      GetElementPtrF(i)->TimeChanged();
    }
  }
}
//*******************************************************************
void TOgleList::LoadRamAll(TFMStatus ramstatus1,TFMStatus ramstatus2)
{
  for (int16 i=0;i<=LastAddedElementNum;i++)
  {
    if (GetElementPtr(i) != NULL)
    {
      GetElementPtrF(i)->LoadRam(ramstatus1);
      if (ramstatus1 != ramstatus2)
      {
        GetElementPtrF(i)->LoadRam(ramstatus2);
      }
    }
  }
}
//*******************************************************************
int _USERENTRY CompareFNames(const void *a,const void *b)
// used by RTL qsort.
{
  if (a == NULL || b == NULL) {return 1;}
//  return strcmp(((TOgleBase *)(*(TOgleBase **)a))->GetFName().c_str(),
//                ((TOgleBase *)(*(TOgleBase **)b))->GetFName().c_str());

  return strcmp(((TOgleBase *)(*(TOgleBase **)a))->FileMode.Name.GetStr().c_str(),
                ((TOgleBase *)(*(TOgleBase **)b))->FileMode.Name.GetStr().c_str());
}
//*******************************************************************
void TOgleList::SortByFName()
{
  qsort((void *)List,GetNumElements(),sizeof(TOgleBase *),CompareFNames);
}
//*******************************************************************
void TOgleList::Sort()
{
  if (GetNumElements() > 0)
  {
    SortByFName();
  }
  SetSorted();
}
//*******************************************************************
TOgleGroupGaugeDlg *TOgleList::GetGaugeDlg(string title)
{
  TOgleGroupGaugeDlg *pggd = NULL;
  if (PModeWin != NULL)
  {
    pggd = PModeWin->GetGroupGaugeDlg(); // see if modewin has a live gauge dlg.
  }
  if (pggd != NULL) {return pggd;}       // if so, then use it.
  return CreateGaugeDlg(title);          // if not, then make our own.
}
//*******************************************************************
TOgleGroupGaugeDlg *TOgleList::CreateGaugeDlg(string title)
{
  TGaugeDlg *pggd = new TGaugeDlg(this,PModeWin,title.c_str());
  pggd->Create();
  return pggd;
}
//*******************************************************************
void TOgleList::ReleaseGaugeDlg(TOgleGroupGaugeDlg *pggd)
{
  if (pggd->GetOwner() == this)  // if not this then mw probably created.
  {
    delete pggd;
  }
}
//*******************************************************************
void TOgleList::SetAllFUCOffsets(int16 offset)
{
  for (int16 i=0;i<=LastAddedElementNum;i++)
  {
    TOgleBase *pbase = GetElementPtrF(i);
    if (pbase != NULL) {pbase->SetFUCOffset(offset);}
  }
}
//*******************************************************************
bool TOgleList::IsActiveElement(int16 ElementNum)
{
  return (IsActiveElement(GetElementPtr(ElementNum)));
}
//*******************************************************************
bool TOgleList::IsActiveElement(TOgleBase *PBase)
{
  if (PBase == NULL) {return false;}
  return (PBase->IsActive());
}
//*******************************************************************
bool TOgleList::ActivateElement(int16 ElementNum,dword StartFUC)
{
  return (ActivateElement(GetElementPtr(ElementNum),StartFUC));
}
//*******************************************************************
bool TOgleList::ActivateElement(TOgleBase *PBase,dword StartFUC)
{
  if (PBase == NULL) {return false;}
  PBase->Activate(StartFUC);
  return true;
}
//*******************************************************************
void TOgleList::DeActivateElement(int16 ElementNum)
{
  DeActivateElement(GetElementPtr(ElementNum));
}
//*******************************************************************
void TOgleList::DeActivateElement(TOgleBase *PBase)
{
  if (PBase != NULL) {PBase->DeActivate();}
}
//*******************************************************************
// mrp - v2.3 - added temp change to lower case for comparisons.
//            - commented back out, relying on initial input to
//            - translate names to same case (lower).
int16 TOgleList::LinearSearch(const string &name)
{
  TOgleBase *pb = NULL;
//  string s1,s2(name);
//  s2.to_lower();
  for (int16 i=0;i<=LastAddedElementNum;i++)
  {
    pb = GetElementPtrF(i);
    if (pb != NULL)
    {
//       s1 = pb->FileMode.Name.GetStr();
//       s1.to_lower();

       if (name == pb->FileMode.Name.GetStr()) {return i;}

 //      if (s1 == s2)
//       {
//         return i;
//       }
    }
  }
  return -1;
}
//*******************************************************************
// mrp - v2.3 - added temp change to lower case for comparisons.
//            - commented back out
int16 TOgleList::BSCompareFName(const string &name,const TOgleBase *pb)
{
  if (pb == NULL) {return 1;}

  // the following will slow compares down, but must make compares
  // case-insensitive because of os file systems unreliability to not
  // change case on us.
//  string s1(name);
//  string s2(pb->FileMode.Name.GetStr());
//  s1.to_lower();
//  s2.to_lower();
  return int16(strcmp(name.c_str(),pb->FileMode.Name.GetStr().c_str()));
//  return int16(strcmp(s1.c_str(),s2.c_str()));
}
//*******************************************************************
int16 TOgleList::BinarySearch(const string &name)
{
  int16 low = 0;
  int16 high = GetLAEN();
  while (low <= high)
  {
    int16 mid = int16((low + high) / 2);
    int16 compareresult = BSCompareFName(name,GetElementPtrF(mid));
    if (compareresult < 0)
    {
      high = int16(mid - 1);
    }
    else if (compareresult > 0)
    {
      low = int16(mid + 1);
    }
    else
    {
      return mid;
    }
  }
  return -1;
}
//*******************************************************************
TOgleBase *TOgleList::GetElementPtr(const string &name)
{
  if (IsSorted())
  {
    int16 index = BinarySearch(name);
    if (index >= 0) {return GetElementPtr(index);}
  }
  return GetElementPtr(LinearSearch(name));
}
//*******************************************************************
int16 TOgleList::GetElementIndex(const string &name)
{
  if (IsSorted())
  {
    int16 index = BinarySearch(name);
    if (index >= 0) {return index;}
  }
  return LinearSearch(name);
}
//*******************************************************************
#if defined(DEBUG_PMODEWIN_LIST)
void TOgleList::CheckModeWinPtr(int ctornum)
{
  if (PModeWin == NULL)
  {
    char buffer[30];
    string s = "PModeWin == NULL in ";
    s += FileMode.Name;
    s += "'s ctor -> ";
    itoa(ctornum,buffer,10);
    s += buffer;
    ::MessageBox(NULL,s.c_str(),"Warning - TOgleList",MB_OK | MB_SYSTEMMODAL);
  }
}
#endif
//*******************************************************************
TOgleList::TOgleList(TOgleModeWindow *pmw)
:TOgleBase(pmw),
 List(NULL),
 LastAddedElementNum(-1),
 ArraySize(0)
{
  SetOwnListPtrs();
  
  #if defined(DEBUG_PMODEWIN_LIST)
  CheckModeWinPtr(1);
  #endif
}
//*******************************************************************
TOgleList::TOgleList(TOgleModeWindow *pmw,bool dummy,const TFileMode &fm)
:TOgleBase(pmw,dummy,fm),
 List(NULL),
 LastAddedElementNum(-1),
 ArraySize(0)
{
  SetOwnListPtrs();

  #ifdef DEBUG_PMODEWIN_LIST
  CheckModeWinPtr(2);
  #endif
}
//*******************************************************************
TOgleList::TOgleList()
:TOgleBase(NULL),
 List(NULL),
 LastAddedElementNum(-1),
 ArraySize(0)
{
  SetOwnListPtrs();

  #ifdef DEBUG_PMODEWIN_LIST
  CheckModeWinPtr(0);
  #endif
}
//*******************************************************************
TOgleList::~TOgleList()
{
  DeleteAll();
}
//*******************************************************************
void TOgleList::DeleteAll()
{
  for (int16 i = 0;i<=LastAddedElementNum;i++)
  {
    delete List[i];
  }
  delete [] List;
  List = NULL;
  LastAddedElementNum = -1;
}
//*******************************************************************
int16 TOgleList::GetGrowSize()
{
  return 1;
}
//*******************************************************************
bool TOgleList::GrowTo(int16 size)
{
  if (size <= ArraySize) {return false;}

  // allocate new array of pointers.
  TOgleBase **list = new TOgleBase *[size];

  // set the unused tail end of the array to NULL.
  for (int16 i = ArraySize;i<size;i++)
  {
    list[i] = NULL;
  }
  if (List != NULL)
  {
    // copy the used front end of old array over to new array.
    for (int16 j = 0;j<ArraySize;j++)
    {
      list[j] = List[j];
    }
    delete [] List;
  }
  List = list;
  ArraySize = size;
  return true;
}
//*******************************************************************
bool TOgleList::AddElement(TOgleBase *PNewBase)
{
  if ((LastAddedElementNum + 1) >= ArraySize)
  {
    if (!GrowBy(GetGrowSize())) {return false;}
  }
  LastAddedElementNum++;
  List[LastAddedElementNum] = PNewBase;
  SetSorted(false);
  return true;
}
//*******************************************************************
int16 TOgleList::AddPBase(TOgleBase *PNewBase)
{
  AddElement(PNewBase);
  return LastAddedElementNum;
}
//*******************************************************************
bool TOgleList::RemoveElement(int16 ElementNum)
{
  if (!CheckElementNum(ElementNum)) {return false;}

  if (GetIndexesSet())
  {
    if (GetOwnListPtrs())
    {
      delete List[ElementNum];
    }
    List[ElementNum] = NULL;
  }
  else
  {
    if (ElementNum == LastAddedElementNum)
    {
      if (GetOwnListPtrs())
      {
        delete List[LastAddedElementNum];
      }
      List[LastAddedElementNum] = NULL;
      LastAddedElementNum--;
    }
    else
    {
      TOgleBase *pb = List[ElementNum];
      List[ElementNum] = List[LastAddedElementNum];
      LastAddedElementNum--;
      if (GetOwnListPtrs())
      {
        delete pb;
      }
    }
  }
  SetSorted(false);
  return true;
}
//*******************************************************************
int16 TOgleList::IsElement(string *PName)
{
  for (int16 i=0;i<=LastAddedElementNum;i++)
  {
    TOgleBase *pbase = GetElementPtrF(i);
//    if (pbase != NULL && *PName == pbase->GetBaseName()) {return i;}
    if (pbase != NULL && *PName == pbase->FileMode.Name.GetStr()) {return i;}
  }
  return -1;
}
//*******************************************************************
void TOgleList::Start()
{
  TOgleBase::Start();
}
//*******************************************************************
void TOgleList::Start(dword StartFUC)
{
  for (int16 i=0;i<=LastAddedElementNum;i++)
  {
    TOgleBase *pbase = GetElementPtrF(i);
    if (pbase != NULL) {pbase->Start(StartFUC);}
  }
}
//*******************************************************************
void TOgleList::Stop()
{
  for (int16 i=0;i<=LastAddedElementNum;i++)
  {
    TOgleBase *pbase = GetElementPtrF(i);
    if (pbase != NULL) {pbase->Stop();}
  }
  TOgleBase::Stop();
}
//******************************************************************
void TOgleList::Activate(dword StartFUC)
{
  TOgleBase::Activate(StartFUC);
  for (int16 i=0;i<=LastAddedElementNum;i++)
  {
    ActivateElement(i,StartFUC);
  }
}
//*******************************************************************
void TOgleList::DeActivate()
{
  for (int16 i=0;i<=LastAddedElementNum;i++)
  {
    DeActivateElement(i);
  }
  TOgleBase::DeActivate();
}
//*******************************************************************
void TOgleList::Show()
{
  TOgleBase::Show();
  for (int16 i=0;i<=LastAddedElementNum;i++)
  {
    TOgleBase *pbase = GetElementPtrF(i);
    if (pbase != NULL) {pbase->Show();}
  }
}
//*******************************************************************
void TOgleList::NoShow()
{
  TOgleBase::NoShow();
  for (int16 i=0;i<=LastAddedElementNum;i++)
  {
    TOgleBase *pbase = GetElementPtrF(i);
    if (pbase != NULL) {pbase->NoShow();}
  }
}
//*******************************************************************
void TOgleList::Update(dword NewFUC)
{
  if (!GetStarted() || GetStopped()) {return;}
  for (int16 i=0;i<=LastAddedElementNum;i++)
  {
    TOgleBase *pbase = GetElementPtrF(i);
    if (pbase != NULL) {pbase->Update(NewFUC);}
  }
}
//*******************************************************************
void TOgleList::PostUpdate(dword NewFUC)
{
  if (!GetStarted() || GetStopped()) {return;}
  for (int16 i=0;i<=LastAddedElementNum;i++)
  {
    TOgleBase *pbase = GetElementPtrF(i);
    if (pbase != NULL) {pbase->PostUpdate(NewFUC);}
  }
}
//*******************************************************************

