//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  omdatdlg.cpp
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.3     6/6/97     M.Perry    original baseline
//  2.0    10/28/97    M.Perry    32-bit conversion.
//********************************************************************
#if !defined(__omdatdlg_h)
#include "omdatdlg.h"
#endif

#if !defined(__omdatdlg_rh)
#include "omdatdlg.rh"
#endif

#if !defined(OWL_STATIC_H)
#include <owl\static.h>
#endif

#if !defined(OWL_EDIT_H)
#include <owl\edit.h>
#endif

#if !defined(OWL_BUTTON_H)
#include <owl\button.h>
#endif

#if !defined(OWL_VALIDATE_H)
#include <owl\validate.h>
#endif

#if !defined(__omdat_h)
#include "omdat.h"
#endif
//*******************************************************************
DEFINE_RESPONSE_TABLE1(TMiscDataDlg,TDialog)
  EV_COMMAND(IDC_NUMARRAYS_APPLY_PB,CmNumArraysApply),
  EV_COMMAND(IDC_PREVARRAY_PB,CmPrevArray),
  EV_COMMAND(IDC_NEXTARRAY_PB,CmNextArray),
  EV_COMMAND(IDC_NUMINTS_APPLY_PB,CmNumIntsApply),
  EV_COMMAND(IDC_UP_INT_PB,CmUpInt),
  EV_COMMAND(IDC_DOWN_INT_PB,CmDownInt),
  EV_COMMAND(IDOK,CmOk),
END_RESPONSE_TABLE;
//*******************************************************************
TMiscDataDlg::TMiscDataDlg(TWindow *pwin,TMiscData *pmiscdata,string strgobjname)
:TDialog(pwin,IDD_MISCDATA),
 PMiscData(pmiscdata),
 strGObjName(strgobjname),
 CurArray(0),
 TopInt(0)
{
  CreateControls();
}
//*******************************************************************
TMiscDataDlg::~TMiscDataDlg()
{
  DestroyControls();
}
//*******************************************************************
void TMiscDataDlg::SetupWindow()
{
  TDialog::SetupWindow();
  PGObjName_STB->SetText(strGObjName.c_str());
  LoadInfo();
}
//*******************************************************************
void TMiscDataDlg::CreateControls()
{
  int editresid = IDC_INT_0_ETB;
  int staticresid = IDC_INT_0_STB;
  for (int16 i=0;i<NUM_INT_EDITS;i++,editresid++,staticresid++)
  {
    PInt_ETB[i] = new TEdit(this,editresid);
    PInt_ETB[i]->SetValidator(new TFilterValidator("0-9"));
    PInt_STB[i] = new TStatic(this,staticresid);
  }
  PGObjName_STB = new TStatic(this,IDC_GOBJNAME_STB);
  PNumArrays_ETB = new TEdit(this,IDC_NUMARRAYS_ETB);
  PCurrentArray_STB = new TStatic(this,IDC_CURRENTARRAY_STB);
  PNumInts_ETB = new TEdit(this,IDC_NUMINTS_ETB);
  PMaxInts_STB = new TStatic(this,IDC_MAXINTS_STB);
  PPrevArray_PB = new TButton(this,IDC_PREVARRAY_PB);
  PNextArray_PB = new TButton(this,IDC_NEXTARRAY_PB);
  PUp_PB = new TButton(this,IDC_UP_INT_PB);
  PDown_PB = new TButton(this,IDC_DOWN_INT_PB);
  POk_PB = new TButton(this,IDOK);
}
//*******************************************************************
void TMiscDataDlg::DestroyControls()
{
  for(int16 i=0;i<NUM_INT_EDITS;i++)
  {
    delete PInt_ETB[i];
    delete PInt_STB[i];
  }
  delete PGObjName_STB;
  delete PNumArrays_ETB;
  delete PCurrentArray_STB;
  delete PNumInts_ETB;
  delete PMaxInts_STB;
  delete PPrevArray_PB;
  delete PNextArray_PB;
  delete PUp_PB;
  delete PDown_PB;
  delete POk_PB;
}
//*******************************************************************
void TMiscDataDlg::CmNumArraysApply()
{
  SaveInfo();
  char buffer[33];
  PNumArrays_ETB->GetText(buffer,33);
  int16 na = (int16)atoi(buffer);
  PMiscData->GrowNumArraysTo(na);
  CurArray = 0;
  TopInt = 0;
  LoadInfo();
}
//*******************************************************************
void TMiscDataDlg::CmPrevArray()
{
  SaveInfo();
//  CurArray -= 1;
  CurArray--;
  if (CurArray < 0) {CurArray = 0;}
  TopInt = 0;
  LoadInfo();
}
//*******************************************************************
void TMiscDataDlg::CmNextArray()
{
  SaveInfo();
  if ((CurArray + 1) < PMiscData->GetNumArrays())
  {
//    CurArray += 1;
    CurArray++;
    TopInt = 0;
  }
  LoadInfo();
}
//*******************************************************************
void TMiscDataDlg::CmNumIntsApply()
{
  SaveInfo();
  char buffer[33];
  PNumInts_ETB->GetText(buffer,33);
  int16 ni = (int16)atoi(buffer);
  PMiscData->GrowArrayTo(CurArray,ni);
  TopInt = 0;
  LoadInfo();
}
//*******************************************************************
void TMiscDataDlg::CmUpInt()
{
  SaveInfo();
  TopInt -= int16(30);
  if (TopInt < 0) {TopInt = 0;}
  LoadInfo();
}
//*******************************************************************
void TMiscDataDlg::CmDownInt()
{
  SaveInfo();
  int16 ni = PMiscData->GetNumint16s(CurArray);
  if (ni > (TopInt + 30))
  {
    TopInt += int16(30);
  }
  LoadInfo();
}
//*******************************************************************
void TMiscDataDlg::CmOk()
{
  SaveInfo();
  TDialog::CmOk();
}
//*******************************************************************
void TMiscDataDlg::SaveInfo()
{
  char buffer[33];
  for (int16 i = TopInt;i<(TopInt + 30);i++)
  {
    int16 ndx = int16(i % 30);
    PInt_ETB[ndx]->GetText(buffer,33);
    int16 ni = (int16)atoi(buffer);
    PMiscData->Setint16(CurArray,i,ni);
  }
}
//*******************************************************************
void TMiscDataDlg::LoadInfo()
{
  char buffer[33];

  for (int16 i=TopInt;i< (TopInt + 30);i++)
  {
    int16 ndx = int16(i % 30);
    itoa(i,buffer,10);
    PInt_STB[ndx]->SetText(buffer);
    itoa(PMiscData->Getint16(CurArray,i),buffer,10);
    PInt_ETB[ndx]->SetText(buffer);
  }
  itoa(PMiscData->GetNumArrays(),buffer,10);
  PNumArrays_ETB->SetText(buffer);
  itoa(CurArray,buffer,10);
  PCurrentArray_STB->SetText(buffer);
  itoa(PMiscData->GetNumint16s(CurArray),buffer,10);
  PNumInts_ETB->SetText(buffer);
  PMaxInts_STB->SetText(buffer);

  if (PMiscData->GetNumArrays() > (CurArray + 1))
  {
    PNextArray_PB->EnableWindow(true);
  }
  else
  {
    if (GetFocus() == PNextArray_PB->HWindow)
    {
      POk_PB->SetFocus();
    }
    PNextArray_PB->EnableWindow(false);
  }

  if (CurArray == 0)
  {
    if (GetFocus() == PPrevArray_PB->HWindow)
    {
      POk_PB->SetFocus();
    }
    PPrevArray_PB->EnableWindow(false);
  }
  else
  {
    PPrevArray_PB->EnableWindow(true);
  }

  if ((TopInt + 30) >= PMiscData->GetNumint16s(CurArray))
  {
    if (GetFocus() == PDown_PB->HWindow)
    {
      POk_PB->SetFocus();
    }
    PDown_PB->EnableWindow(false);
  }
  else
  {
    PDown_PB->EnableWindow(true);
  }

  if (TopInt == 0)
  {
    if (GetFocus() == PUp_PB->HWindow)
    {
      POk_PB->SetFocus();
    }
    PUp_PB->EnableWindow(false);
  }
  else
  {
    PUp_PB->EnableWindow(true);
  }
  for (int16 j=0;j<30;j++)
  {
    bool enable = false;
    if (PMiscData->GetNumint16s(CurArray) > (TopInt + j))
    {
      enable = true;
    }
    int16 ndx = int16(TopInt + j);
    ndx %= int16(30);
    if (!enable && GetFocus() == PInt_ETB[ndx]->HWindow)
    {
      POk_PB->SetFocus();
    }
    PInt_ETB[ndx]->EnableWindow(enable);
  }
}
//*******************************************************************

