//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  hand.cpp
//    Project Name:  Ogle
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     06/01/95   A. Krist    Original baseline
//  2.0     08/26/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "hand.h"
//*******************************************************************
THand::THand()
{
  cards = new TCard[15];
  inhand           = 0;  // None in hand yet
  highcard         = 0;  // No card
  highcardsuit     = 0;
  lowcard          = -1; // Low pair/fullhouse value
  lowcardsuit      = 0;
  highhand         = 0;  // Type of hand, 0= high card,1=pair,ect...
  toflush          = 0;  // How many of same suit
  instrght         = 0;  // How many in a row, inside/outside
  outstrght        = 0;  // Outside = 0, inside = 1
  instrflsh        = 0;  // To a inside straight flush
  outstrflsh       = 0;  // Outside straight flush
  instrflshsuit    = 0;  // suit, To a inside straight flush
  outstrflshsuit   = 0;  // suit, Outside straight flush
  lohand           = 0;
  lohighcard       = 0;
  lolowcard        = 0;
  wildcount        = 0;  // Used in video poker, number of wild cards
}
//*******************************************************************
THand::~THand()
{
  delete []cards;
  cards = NULL;
  highhand       = 0;
  highcard       = 0;
  highcardsuit   = 0;
  lowcard        = 0;
  lowcardsuit    = 0;
  inhand         = 0;
  toflush        = 0;
  instrght       = 0;
  outstrght      = 0;
  instrflsh      = 0;
  outstrflsh     = 0;
  instrflshsuit  = 0;
  outstrflshsuit = 0;
  lohand         = 0;
  lohighcard     = 0;
  lolowcard      = 0;
}
//*******************************************************************

