//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  expert.cpp
//    Project Name:  Ogle
// Original Author:  Dave Anderson
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     ???       D.Anderson   original baseline.
//  2.0     08/26/97  M.Perry      32-bit conversion.
//********************************************************************
#if !defined(__expert_h)
#include "expert.h"
#endif

#if !defined(__oapp_h)
#include "oapp.h"
#endif

#if !defined(__oinifile_h)
#include "oinifile.h"
#endif
//*******************************************************************
TAskTheExpertDialog::TAskTheExpertDialog(string str,TWindow* parent, TResId resId)
:TDialog(parent,resId)
{
	box = new TEdit(this,IDC_OKEXPERT);
	box->EnableTransfer();
	m_str = str;
}
//*******************************************************************
TAskTheExpertDialog::~TAskTheExpertDialog()
{
	 delete box;
}
//*******************************************************************
void TAskTheExpertDialog::SetupWindow()
{
	TDialog::SetupWindow();
	//get dialog box parameters
	TRect rec = GetWindowRect();
	int dialogWidth  = rec.right-rec.left;
	int dialogHeight = rec.bottom-rec.top;
   int xRes=   ::GetSystemMetrics(SM_CXSCREEN);
	int yRes=   ::GetSystemMetrics(SM_CYSCREEN);

	TPoint pt;
	if (GetPreviousDialogPlacement(pt) && //use previous position if one in .INI
		  ((pt.x < xRes - dialogWidth) && (pt.y < yRes - dialogHeight)))
        //above line ensures it never ( harsh word) is off-screen when shown
	{
		MoveWindow(pt.x,pt.y,dialogWidth,dialogHeight);
	}
	else //just center
	{

		TRect rec = GetWindowRect();
		int dialogWidth  = rec.right-rec.left;
		int dialogHeight = rec.bottom-rec.top;

		MoveWindow((xRes - dialogWidth)/2,(yRes - dialogHeight)/2,
					dialogWidth,dialogHeight);
	}
	box->SetText(m_str.c_str());
}
//*******************************************************************
bool TAskTheExpertDialog::GetPreviousDialogPlacement(TPoint& ptPreviousLocation)
{
  TOgleApp *papp = TOgleApp::GetOgleApp();

  ptPreviousLocation.x = papp->GetIniFile()->ReadInt("Expert","X",0); // Mike added.
  ptPreviousLocation.y = papp->GetIniFile()->ReadInt("Expert","Y",0); // Mike added.

  if ((ptPreviousLocation.x > 0) && (ptPreviousLocation.y > 0))
	  return true;
  return false;
}
//*******************************************************************
bool TAskTheExpertDialog::CanClose()
{
	TRect rcAskExpertLocation = GetWindowRect();
	TPoint ptLocation;
	ptLocation.x = rcAskExpertLocation.left;
	ptLocation.y = rcAskExpertLocation.top;
	//save location of the dialog box here , i.e. ptLocation
	//write to .INI file here , read from .INI file in SetupWindow

   TOgleApp *papp = TOgleApp::GetOgleApp();

   papp->GetIniFile()->WriteInt("Expert","X",ptLocation.x); // Mike added.
   papp->GetIniFile()->WriteInt("Expert","Y",ptLocation.y); // Mike added.

	return true;
}
//*******************************************************************

