//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  odlg.cpp
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.3     6/27/97    M.Perry    orignal baseline
//  2.0     08/26/97   M.Perry    32-bit conversion.
//********************************************************************
#include "odlg.h"
//*******************************************************************
TOgleDialog::TOgleDialog(TWindow *pwin,TResId resid,bool docentering,TModule *pmodule)
:TDialog(pwin,resid,pmodule),
 DoCentering(docentering),
 ExecutingMethod(0),
 ExecuteAppModal(false)
{
}
//*******************************************************************
TOgleDialog::~TOgleDialog()
{
  if (HWindow) {Destroy();}
}
//*******************************************************************
void TOgleDialog::SetupWindow()
{
  TDialog::SetupWindow();
  if (!DoCentering) {return;}

  TRect rect = GetWindowRect();
  if (Parent == NULL)
  {
    int xres = ::GetSystemMetrics(SM_CXSCREEN);
    int yres = ::GetSystemMetrics(SM_CYSCREEN);
    MoveWindow((xres - rect.Width()) / 2,
               (yres - rect.Height()) / 2,
               rect.Width(),
               rect.Height());
  }
  else
  {
    TRect prect = Parent->GetWindowRect();
    int pcx = prect.left + (prect.Width() / 2);
    int pcy = prect.top + (prect.Height() / 2);
    MoveWindow(pcx - (rect.Width() / 2),
               pcy - (rect.Height() / 2),
               rect.Width(),
               rect.Height());
  }
}
//*******************************************************************
int TOgleDialog::Execute(int flags)
{
//  if (flags == 0) {return TDialog::Execute();}

  Create();
  ExecutingMethod = flags;
  ExecuteAppModal = true;
  if (!(TWindow::Attr.Style & WS_VISIBLE)) {Show(SW_SHOW);}
  TWindow *pmodalwin;
  if (flags & MB_SYSTEMMODAL)
  {
    pmodalwin = this;
  }
  else if (flags & MB_TASKMODAL)
  {
    pmodalwin = this;
  }
  else if (Parent == NULL)
  {
    flags = MB_TASKMODAL;
    pmodalwin = this;
  }
  else
  {
    pmodalwin = Parent;
  }
  return GetApplication()->BeginModal(pmodalwin,flags);
}
//*******************************************************************
void TOgleDialog::Destroy(int retvalue)
{
//  if (ExecutingMethod)
  if (ExecuteAppModal)
  {
    GetApplication()->EndModal(retvalue);
    ExecutingMethod = 0;
    ExecuteAppModal = false;
  }
  TDialog::Destroy(retvalue);
}
//*******************************************************************
void TOgleDialog::CloseWindow(int retvalue)
{
//  if (ExecutingMethod)
  if (ExecuteAppModal)
  {
    if (CanClose())
    {
      TransferData(tdGetData);
      Destroy(retvalue);
    }
  }
  else
  {
    TDialog::CloseWindow(retvalue);
  }
}
//*******************************************************************

