//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  og3dlg.cpp
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     11/15/96   M.Perry    original baseline
//  2.0     08/27/97   M.Perry    32-bit conversion.
//********************************************************************
#include "og3dlg.h"

//*******************************************************************
TG3Dlg::TG3Dlg(TWindow *parent,string title,string g1text,string g2text,string g3text,string text,string status)
:TDialog(parent,IDD_3G)
{
  G1Text = g1text;
  G2Text = g2text;
  G3Text = g3text;
  MainText = text;
  MainStatus = status;

  G1Value = 0;
  G2Value = 0;
  G3Value = 0;
  SetCaption(title.c_str());
  PDummy1 = new TControl(this,IDC_DUMMY1);
  PDummy2 = new TControl(this,IDC_DUMMY2);
  PDummy3 = new TControl(this,IDC_DUMMY3);
  PText_STB = new TStatic(this,IDC_3G_TEXT_STB,20);
  PStatus_STB = new TStatic(this,IDC_3G_STATUS_STB,20);
  PG1Text_STB = new TStatic(this,IDC_3G_G1_STB,20);
  PG2Text_STB = new TStatic(this,IDC_3G_G2_STB,20);
  PG3Text_STB = new TStatic(this,IDC_3G_G3_STB,20);
  PGauge1 = NULL;
  PGauge2 = NULL;
  PGauge3 = NULL;
}
//*******************************************************************
TG3Dlg::~TG3Dlg()
{
  delete PText_STB;
  delete PStatus_STB;
  delete PG1Text_STB;
  delete PG2Text_STB;
  delete PG3Text_STB;
  delete PGauge1;
  delete PGauge2;
  delete PGauge3;
}
//*******************************************************************
void TG3Dlg::SetupWindow()
{
  TDialog::SetupWindow();
  if (Parent != NULL)
  {
    TRect winrect = GetWindowRect();
    TRect parrect = Parent->GetWindowRect();
    int newleft = (parrect.Width() / 2) - (winrect.Width() / 2);
    newleft += parrect.left;
    int newtop = parrect.top + parrect.Height();
    newtop -= winrect.Height();
    newtop -= 10;
    TRect newrect = winrect;
    newrect.Offset(newleft - winrect.left,newtop - winrect.top);
    MoveWindow(newrect);
  }
  SetText(MainText);
  SetStatus(MainStatus);
  SetG1Text(G1Text);
  SetG2Text(G2Text);
  SetG3Text(G3Text);

  TRect rect = PDummy1->GetWindowRect();
  ScreenToClient(rect.TopLeft());
  ScreenToClient(rect.BottomRight());
  delete PDummy1;
  PGauge1 = new TGauge(this,"Num: %d",IDC_3G_G1_GAUGE,rect.left,rect.top,rect.Width(),rect.Height());
  rect = PDummy2->GetWindowRect();
  ScreenToClient(rect.TopLeft());
  ScreenToClient(rect.BottomRight());
  delete PDummy2;
  PGauge2 = new TGauge(this,"Num: %d",IDC_3G_G2_GAUGE,rect.left,rect.top,rect.Width(),rect.Height());
  rect = PDummy3->GetWindowRect();
  ScreenToClient(rect.TopLeft());
  ScreenToClient(rect.BottomRight());
  delete PDummy3;
  PGauge3 = new TGauge(this,"Num: %d",IDC_3G_G3_GAUGE,rect.left,rect.top,rect.Width(),rect.Height());
  PGauge1->Create();
  PGauge2->Create();
  PGauge3->Create();
}
//*******************************************************************
