//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  ogobjbas.cpp
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     2/5/96     M.Perry    original baseline
//  2.0     8/23/97    M.Perry    32-bit conversion.
//********************************************************************
#if !defined(__ogobjbas_h)
#include "ogobjbas.h"
#endif

#if !defined(__omodewin_h)
#include "omodewin.h"
#endif

#if !defined(__omdat_h)
#include "omdat.h"
#endif
//*******************************************************************
void TGObjBase::SetIndexes()
{
}
//*******************************************************************
void TGObjBase::ReleaseTables()
{
}
//*******************************************************************
string TGObjBase::AddExt()
{
  return string(".go");
}
//*******************************************************************
TGObjBase::TGObjBase(TOgleModeWindow *pmw)
:TOgleBase(pmw),
 PMiscData(NULL)
{
}
//*******************************************************************
TGObjBase::TGObjBase(TOgleModeWindow *pmw,const TFileMode &fm)
:TOgleBase(pmw,true,fm),
 PMiscData(NULL)
{
}
//*******************************************************************
TGObjBase::~TGObjBase()
{
  if (PMiscData != NULL)
  {
    delete PMiscData;
  }
}
//*******************************************************************
void TGObjBase::CreateState()
{
}
//*******************************************************************
void TGObjBase::DestroyState()
{
  delete PState;
  PState = NULL;
}
//*******************************************************************
void TGObjBase::ShuttingDown()
{
  if (ShutDownHandled) {return;}

  #if DEBUGGOBJ
  string msgstr = GetFName();
  msgstr += " shutting down";
  PModeWin->MessageBox(msgstr.c_str(),"GObj Debug Info",MB_OK);
  #endif

  ShutDownHandled = true;
}
//*******************************************************************
int16 TGObjBase::GetGObjIndex(string GObjName)
{
  return PModeWin->GetGObjIndex(GObjName);
}
//*******************************************************************
void TGObjBase::RunState()
{
  if (PState != NULL) {PState->Run();}
}
//*******************************************************************
void TGObjBase::UpdateState(dword NewFUC)
{
  if (PState != NULL) {PState->Update(NewFUC);}
}
//*******************************************************************
void TGObjBase::PostUpdateState(dword NewFUC)
{
  if (PState != NULL) {PState->PostUpdate(NewFUC);}
}
//*******************************************************************
int16 TGObjBase::AskCriteriaQuestion(int16 QuesNum)
{
  return PModeWin->AskCriteriaQuestion(QuesNum);
}
//*******************************************************************
TMiscData *TGObjBase::CreateMiscData(TFileMode &fm)
{
  return (new TMiscData(PModeWin,fm));
}
//*******************************************************************
void TGObjBase::CreateAddMiscData(TFileMode &fm)
{
  PMiscData = CreateMiscData(fm);
}
//*******************************************************************

