//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  oplayer.cpp
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     7/15/96    M.Perry     original baseline
//  2.0     8/23/97    M.Perry     32-bit conversion.
//********************************************************************
#if !defined(__oplayer_h)
#include "oplayer.h"
#endif

//#include "oapp.h"

#if !defined(__ogamefw_h)
#include "ogamefw.h"
#endif

#if !defined(__oplaymgr_h)
#include "oplaymgr.h"
#endif
//*******************************************************************
TPlayer::TPlayer(TOgleModeWindow *pmw,TFileMode &NewFileMode,int16 activeslotnum)
:TGameObject(true,pmw,NewFileMode),
 pd(NULL),
 ActiveSlotNum(activeslotnum)
{
}
//*******************************************************************
TPlayer::~TPlayer()
// don't delete pd because owned by playermgr.
{
}
//*******************************************************************
void TPlayer::ShuttingDown()
{
  if (!ShutDownHandled)
  {
    GetDataPtr();
    if (pd != NULL) {DeActivate();}
    TGameObject::ShuttingDown();
  }
}
//*******************************************************************
void TPlayer::Activate(dword StartFUC)
{
  TGameObject::Activate(StartFUC);
}
//*******************************************************************
void TPlayer::DeActivate()
{
  TGameObject::DeActivate();
}
//*******************************************************************
void TPlayer::NotifyPlayerActivation(int16 slotnum)
{
  if (slotnum == ActiveSlotNum)
  {
    GetDataPtr();
    Activate(GetAdjFUC());
  }
}
//*******************************************************************
void TPlayer::NotifyPlayerDeActivation(int16 slotnum)
{
  if (slotnum == ActiveSlotNum)
  {
    DeActivate();
    ClearDataPtr();  // should be NULL.
  }
}
//*******************************************************************
void TPlayer::GetDataPtr()
{
  TOgleGameFrameWindow *pgfw = GetFW();
  if (pgfw != NULL)
  {
    pd = pgfw->GetPlayerMgr()->GetActivePlayerDataPtr(ActiveSlotNum);
  }
}
//*******************************************************************
void TPlayer::ClearDataPtr()
{
  pd = NULL;
}
//*******************************************************************

