//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  ogobj.cpp
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     6/1/95     M.Perry     original baseline
//  2.0     8/23/97    M.Perry     32-bit conversion.
//  2.1     12/6/97    M.Perry     filename mod's.
//********************************************************************
#if !defined(__ogobj_h)
#include "ogobj.h"
#endif

#if !defined(__omodewin_h)
#include "omodewin.h"
#endif

#if !defined(__osprlist_h)
#include "osprlist.h"
#endif

#if !defined(__oskitcat_h)
#include "oskitcat.h"
#endif

#if !defined(__omdat_h)
#include "omdat.h"
#endif

#if !defined(__STDLIB_H)
#include <stdlib.h>
#endif
//*******************************************************************
void TGameObject::SetMinVer()
{
  MinVer = 1;
}
//*******************************************************************
void TGameObject::SetMajVer()
{
  MajVer = 2;
}
//*******************************************************************
const char *TGameObject::GetIDChars() const
{
  return "GOBJ";
}
//*******************************************************************
bool TGameObject::ReadLocal1_0()
{
  TOgleFileName ofn;
  if (!(ReadFNameString(SpriteListName))) {return false;}
  //add dir
  ofn.SetFName(SpriteListName);
  ofn.SetDirPath(FileMode.Name.GetFName());
  ofn.SetExt(".spl");
  SpriteListName = ofn.GetStr();

  if (!(ReadFNameString(SkitCatName))) {return false;}
  // add dir
  ofn.SetFName(SkitCatName);
  ofn.SetExt(".skc");
  SkitCatName = ofn.GetStr();

  ofn = SpriteListName;
  ofn.SetExt(".md");
  strMiscDataName = ofn.GetStr();
//  strMiscDataName = SpriteListName;
  
  // read it but don't do anything with it anymore, now in spritelist.
  int16 NumSpriteTypes;
  if (!Readint16(&NumSpriteTypes)) {return false;}
  for (int16 i = 0;(i<NumSpriteTypes);i++)
  {
    int16 NumDefSprites;
    if (!Readint16(&NumDefSprites)) {return false;}
    for (int16 j=0;j<NumDefSprites;j++)
    {
      string str;
      if (!ReadFNameString(str)) {return false;}
    }
  }
  return true;
}
//*******************************************************************
bool TGameObject::ReadLocal1_1()
{
  TOgleFileName ofn;
  if (!(ReadFNameString(SpriteListName))) {return false;}
  // add dir
  ofn.SetFName(SpriteListName);
//  ofn.SetDirPath(GetBaseName());
  ofn.SetDirPath(FileMode.Name.GetFName());
  ofn.SetExt(".spl");
  SpriteListName = ofn.GetStr();

//  ofn = SpriteListName;
  ofn.SetExt(".md");
  strMiscDataName = ofn.GetStr();
//  strMiscDataName = SpriteListName;

  if (!(ReadFNameString(SkitCatName))) {return false;}
  // add dir
  ofn.SetFName(SkitCatName);
  ofn.SetExt(".skc");
  SkitCatName = ofn.GetStr();

  return true;
}
//*******************************************************************
bool TGameObject::ReadLocal1_2()
{
  TOgleFileName ofn;
  if (!ReadFNameString(SpriteListName)) {return false;}
  // add dir
  ofn.SetFName(SpriteListName);
  ofn.SetDirPath(FileMode.Name.GetFName());
  ofn.SetExt(".spl");
  SpriteListName = ofn.GetStr();

  ofn.SetExt(".md");
  strMiscDataName = ofn.GetStr();
//  strMiscDataName = SpriteListName;

  if (!ReadFNameString(SkitCatName)) {return false;}
  // add dir
  ofn.SetFName(SkitCatName);
  ofn.SetExt(".skc");
  SkitCatName = ofn.GetStr();

  return true;
}
//*******************************************************************
bool TGameObject::ReadLocal2_0()
{
  if (!ReadFileName(SpriteListName)) {return false;}
  TOgleFileName ofn(SpriteListName);
  ofn.SetExt(".md");
  strMiscDataName = ofn.GetStr();
  if (!ReadFileName(SkitCatName)) {return false;}
  return true;
}
//*******************************************************************
bool TGameObject::ReadLocal2_1()
{
  if (!ReadFileName(SpriteListName)) {return false;}
  if (!ReadFileName(SkitCatName)) {return false;}
  if (!ReadFileName(strMiscDataName)) {return false;}
  if (!Readint16(&IDCode)) {return false;}
  return true;
}
//*******************************************************************
bool TGameObject::ReadLocal()
{
  switch (MajVer)
  {
    case 1:
           switch (MinVer)
           {
             case 0:return ReadLocal1_0();
             case 1:return ReadLocal1_1();
             case 2:return ReadLocal1_2();
             default:return false;
           }
    case 2:
           switch (MinVer)
           {
            case 0:return ReadLocal2_0();
            case 1:return ReadLocal2_1();
            default:return false;
           }
    default:return false;
  }
}
//*******************************************************************
bool TGameObject::WriteLocal()
{
  if (!WriteFileName(SpriteListName)) {return false;}
  if (!WriteFileName(SkitCatName)) {return false;}
  if (!WriteFileName(strMiscDataName)) {return false;}
  if (!Writeint16(&IDCode)) {return false;}
  return true;
}
//*******************************************************************
bool TGameObject::Save()
{
  if (!Write()) {return false;}

  if (GetSpriteList() != NULL) {GetSpriteList()->Save();}

  if (GetSkitCat() != NULL) {GetSkitCat()->Save();}

  if (GetMiscData() != NULL) {GetMiscData()->Write();}

  return true;
}
//*******************************************************************
TGameObject::TGameObject(TOgleModeWindow *pmw)
:TGObjSk(pmw)
{
  ShutDownHandled = false;
  PState = NULL;
  PSpriteList = new TSpriteList(PModeWin,this);
  PSkitCat = new TSkitCat(PModeWin);
  PMiscData = new TMiscData(PModeWin);
}
//*******************************************************************
#pragma argsused
TGameObject::TGameObject(bool Dummy,TOgleModeWindow *pmw,const TFileMode &NewFileMode)
:TGObjSk(pmw,NewFileMode)
// used by TPlayer.
{
  ShutDownHandled = false;
  PState = NULL;
//  SpriteListName = NewFileMode.Name.GetStr();
//  SkitCatName = NewFileMode.Name.GetStr();
//  strMiscDataName = NewFileMode.Name.GetStr();
  Init(NewFileMode,true,false);
}
//*******************************************************************
TGameObject::TGameObject(TOgleModeWindow *pmw,const TFileMode &NewFileMode,
                         bool AutoRead,bool KeepBaseFile)
:TGObjSk(pmw,NewFileMode)
{
  ShutDownHandled = false;
  PState = NULL;
//  SpriteListName = NewFileMode.Name.GetStr();
//  SkitCatName = NewFileMode.Name.GetStr();
//  strMiscDataName = NewFileMode.Name.GetStr();

  Init(NewFileMode,AutoRead,KeepBaseFile);

  TFileMode SPLFM(SpriteListName,TFileMode::fm_None,TFileMode::fm_Immed,FileMode.GetDirIndex());
  CreateAddSpriteList(SPLFM);

  TFileMode SKCFM(SkitCatName,TFileMode::fm_None,TFileMode::fm_Immed,FileMode.GetDirIndex());
  CreateAddSkitCat(SKCFM);

  if (MajVer == 1 && MinVer < 2)
  {
    TFileMode MDFM(strMiscDataName,TFileMode::fm_None,TFileMode::fm_None,FileMode.GetDirIndex());
    PMiscData = new TMiscData(true,PModeWin,MDFM);
  }
  else
  {
    TFileMode MDFM(strMiscDataName,TFileMode::fm_None,TFileMode::fm_Immed,FileMode.GetDirIndex());
    CreateAddMiscData(MDFM);
  }

}
//*******************************************************************
TGameObject::~TGameObject()
{
  delete PState;
  PState = NULL;
}
//*******************************************************************

