//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  obmpmono.cpp
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//   1.0    11/8/96    M.Perry    original baseline
//********************************************************************
#include "obmpmono.h"

//*******************************************************************
void TBmpMono::SetPixels(byte palindex)
{
  PalIndex = palindex;
  for (int16 i=0;i<BMPMONO_MAX_LINE_LENGTH;i++)
  {
    Pixels[i] = PalIndex;
  }
}
//*******************************************************************
TBmpMono::TBmpMono(TOgleModeWindow *pmw,TOgleRect &rect,byte palindex)
:TBmp(pmw),
 PalIndex(palindex)
{
  SetPixels(PalIndex);
  GrDrawData.ClearLinear();
  GrDrawData.SetVRect(rect);
}
//*******************************************************************
TBmpMono::~TBmpMono()
{
}
//*******************************************************************
bool TBmpMono::BltTo(TOgleVideoDC &vdc,TOgleRect &clipvrect)
{
  return TBmp::BltTo(vdc,clipvrect);
}
//*******************************************************************
bool TBmpMono::BltTo(TGr &gr,TOgleRect &clipvrect)
{
  byte huge *PDestBits = gr.GrDrawData.GetBits();
  if (PDestBits == NULL) {return false;}
  bool topdown = gr.GrDrawData.IsTopDown();
  byte huge *PSrc = NULL;
  byte huge *PDest = NULL;

  TOgleRect VRect = GrDrawData.GetVRect();
  TOgleRect DestVRect = gr.GrDrawData.GetVRect();
  TOgleRect isvrect = VRect.Intersect(clipvrect);

  if (isvrect.IsEmpty()) {return true;} // no intersection.

  int16 destwidth4 = NumScanBytes(DestVRect.GetWidth());

  for (int16 y = int16(isvrect.bottom - 1);
       y >= isvrect.top;
       y--)
  {
    int16 x = isvrect.left;
    PSrc = Pixels;
    PDest = GetPixelAddr(PDestBits,x,y,topdown,destwidth4,DestVRect.GetHeight());
    int16 xlen = isvrect.GetWidth();

    // don't go past our array boundary. -> won't be a problem changed to a setmem function.
    if (xlen > BMPMONO_MAX_LINE_LENGTH) {xlen = BMPMONO_MAX_LINE_LENGTH;}

    hmemcpy(PDest,PSrc,xlen);
  }
  return true;
}
//*******************************************************************

