//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  oskitcel.cpp
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     8/27/95    M.Perry    original baseline
//  2.0     8/24/97    M.Perry    32-bit conversion.
//  2.1     12/6/97    M.Perry    filename mod's.
//  2.4     08/16/99   M.Perry    added pmw to ctor's
//********************************************************************
#if !defined(__oskitcel_h)
#include "oskitcel.h"
#endif

#if !defined(__ogobjsk_h)
#include "ogobjsk.h"
#endif

#if !defined(__osktdlst_h)
#include "osktdlst.h"
#endif

#if !defined(__ofilemgr_h)
#include "ofilemgr.h"
#endif

#if !defined(__omodewin_h)
#include "omodewin.h"
#endif

#include <assert.h>
//*******************************************************************
#ifdef GED_COMPILE
void TSkitCell::ReportSpriteUsage(ofstream &os,string &skitname,int16 gobjindex,int16 spriteindex)
{
  if (gobjindex == GObjIndex && spriteindex == SpriteIndex)
  {
    os<<"used by skit: "<<skitname<<"\n";
  }
}
#endif
//*******************************************************************
#ifdef GED_COMPILE
bool TSkitCell::IsSpriteUsedBySkit(int16 gobjindex,int16 spriteindex)
{
  if (GObjIndex == gobjindex && SpriteIndex == spriteindex) {return true;}
  return false;
}
#endif
//*******************************************************************
//void TSkitCell::SetMinVer()
//{
//  MinVer = 2;
//}
//*******************************************************************
void TSkitCell::SetMajVer()
{
  MajVer = 2;
}
//*******************************************************************
void TSkitCell::AddToDataList(TSkitDataList *pdatalist,int16 rownum)
{
  assert(GObjIndex >= 0);
  assert(SpriteIndex >= 0);
  pdatalist->Add(GObjIndex,SpriteIndex,rownum);
}
//*******************************************************************
void TSkitCell::Start()
{
  TOgleCell::Start();
}
//*******************************************************************
void TSkitCell::Activate(dword StartFUC)
{
  Start(StartFUC);
}
//*******************************************************************
TSkitCell::TSkitCell()
:POwnerGObj(NULL),
 GObjIndex(-1),
 SpriteIndex(-1)
{
}
//*******************************************************************
//TSkitCell::TSkitCell(TFileMode &NewFileMode)
//:TOgleCell(NewFileMode),
// POwnerGObj(NULL),
// GObjIndex(-1),
// SpriteIndex(-1)
//{
//}
//*******************************************************************
// mrp - v2.4 - 08/16/99 - added pmw to ctor's
TSkitCell::TSkitCell(TOgleModeWindow *pmw,TFileMode &NewFileMode,TGObjSk *PNewGObj)
:TOgleCell(pmw,NewFileMode),
 POwnerGObj(PNewGObj),
 GObjIndex(-1),
 SpriteIndex(-1)
{
}
//*******************************************************************
// mrp - v2.4
TSkitCell::TSkitCell(TOgleModeWindow *pmw,TFileMode &NewFileMode,TGObjSk *PNewGObj,
                     void *PReadData,bool AutoRead)
:TOgleCell(pmw,NewFileMode),
 POwnerGObj(PNewGObj),
 GObjIndex(-1),
 SpriteIndex(-1)
{
  Init(PReadData,AutoRead);
}
//*******************************************************************
TSkitCell::~TSkitCell()
{
}
//*******************************************************************
bool TSkitCell::ReadLocal1_1()
{
  // start filename mod's - MRP v2.1
  TOgleFileName ofn;
  // end

  if (!ReadFNameString(GObjName)) {return false;}

  // start filename mod's - MRP v2.1
  ofn.SetDirPath(GObjName);  // filemgr's not set up for all gobj's yet, but,
  ofn.SetFName(GObjName);    // luckily, we have the dir name right here.
  ofn.SetExt(string(".go"));
  GObjName = ofn.GetStr();
  // end

  if (!ReadFNameString(SpriteName)) {return false;}

  // start filename mod's - MRP v2.1
  ofn.SetFName(SpriteName);  // dir already setup above.
  ofn.SetExt(string(".sp"));
  SpriteName = ofn.GetStr();
  // end

  return true;
}
//*******************************************************************
bool TSkitCell::ReadLocal1_2()
{
  // start filename mod's - MRP v2.1
  TOgleFileName ofn;
  // end

  if (!ReadFNameString(GObjName)) {return false;}

  // start filename mod's - MRP v2.1
  ofn.SetDirPath(GObjName); // filemgr's not set up for gobj's yet, but,
  ofn.SetFName(GObjName);   // luckily, we have dir name right here.
  ofn.SetExt(string(".go"));
  GObjName = ofn.GetStr();
  // end

  if (!ReadFNameString(SpriteName)) {return false;}

  // start filename mod's - MRP v2.1
  ofn.SetFName(SpriteName);
  ofn.SetExt(string(".sp"));
  SpriteName = ofn.GetStr();
  // end

  if (!Readint16(&GObjIndex)) {return false;}
  if (!Readint16(&SpriteIndex)) {return false;}
  if (!Readdword(&FUC_Length)) {return false;}
  return true;
}
//*******************************************************************
bool TSkitCell::ReadLocal2_0()
{
  if (!ReadFileName(GObjName)) {return false;}
  if (!ReadFileName(SpriteName)) {return false;}
  if (!Readint16(&GObjIndex)) {return false;}
  if (!Readint16(&SpriteIndex)) {return false;}
  if (!Readdword(&FUC_Length)) {return false;}
  return true;
}
//*******************************************************************
bool TSkitCell::ReadLocal()
{
  switch (MajVer)
  {
    case 1:
           switch (MinVer)
           {
             case 2:return ReadLocal1_2();
             default:return ReadLocal1_1();
           }
    case 2:return ReadLocal2_0();
    default:return false;
  }
}
//*******************************************************************
bool TSkitCell::WriteLocal()
{
//  if (!WriteFNameString(GObjName)) {return false;}
  if (!WriteFileName(GObjName)) {return false;}
//  if (!WriteFNameString(SpriteName)) {return false;}
  if (!WriteFileName(SpriteName)) {return false;}
  if (!Writeint16(&GObjIndex)) {return false;}
  if (!Writeint16(&SpriteIndex)) {return false;}
  if (!Writedword(&FUC_Length)) {return false;}
  return true;
}
//*******************************************************************
void TSkitCell::Start(dword StartFUC)
{
  Start();
  if (POwnerGObj == NULL) {return;}

  #if defined(OGLE_DEBUG_SKITS)
  bool ok =
  #endif
  POwnerGObj->ActivateSprite(GObjIndex,SpriteIndex,StartFUC);

  #if defined(OGLE_DEBUG_SKITS)
  if (!ok)
  {
//    char buffer[17];
//    string str = "Couldn't start skit cell, (GObj -> ";
//    #ifdef GED_COMPILE
//    str += GetGObjName();
//    str += ") (Sprite -> ";
//    str += GetSpriteName();
//    str += ")";
//    #else
//    itoa(GObjIndex,buffer,10);
//    str += "# ";
//    str += buffer;
//    str += ") (Sprite -> ";
//    itoa(SpriteIndex,buffer,10);
//    str += buffer;
//    str += ")";
//    #endif

    char buffer[50];
    string title = "Warning - TSkitCell";
    string pstrmsg[5];
    pstrmsg[0] = "Couldn't start skit cell.";
    pstrmsg[1] = "GObj Name: " + GetGObjName();
    itoa(GObjIndex,buffer,10);
    pstrmsg[2] = "GObj Index: ";
    pstrmsg[2] += buffer;
    pstrmsg[3] = "Sprite Name: " + GetSpriteName();
    itoa(SpriteIndex,buffer,10);
    pstrmsg[4] = "Sprite Index: ";
    pstrmsg[4] += buffer;

    if (GetModeWin() != NULL)
    {
      GetModeWin()->ScrollMsg(title,pstrmsg,5,true);
    }
    else
    {
      string s = "PModeWin == NULL \n";
      for (int16 i = 0;i<5;i++)
      {
        s += pstrmsg[i] + "\n";
      }
      ::MessageBox(NULL,s.c_str(),title.c_str(),MB_OK|MB_TASKMODAL);
    }
  }
  #endif
}
//*******************************************************************
bool TSkitCell::CanActivate(dword StartFUC)
{
  if (POwnerGObj == NULL) {return false;}
  return (POwnerGObj->CanActivateSprite(GObjIndex,SpriteIndex,StartFUC));
}
//*******************************************************************
dword TSkitCell::GetCalcFUCLength()
{
  #if defined(GED_COMPILE)
  if (POwnerGObj == NULL) {return 0;}
  return (POwnerGObj->GetSpriteLength(GObjIndex,SpriteIndex));
  #else
  return FUC_Length;
  #endif
}
//*******************************************************************
void TSkitCell::SetIndexes()
{
#if defined(GED_COMPILE)
  static count = 0;
  // right now gobjs are added to a linked list instead of an array so index subject to change.
  if (POwnerGObj != NULL)
  {
    GObjIndex = POwnerGObj->GetGObjIndex(GetGObjName());
    if (GObjIndex >= 0)
    {
      SpriteIndex = POwnerGObj->GetSpriteIndex(GObjIndex,GetSpriteName());
      if (SpriteIndex >= 0)
      {
        Set_FUC_Length(POwnerGObj->GetSpriteLength(GObjIndex,SpriteIndex));
      }
    }
  }
  #if defined(OGLE_DEBUG_SKITS)
  if (POwnerGObj == NULL || GObjIndex < 0 || SpriteIndex < 0)
  {
    char buffer[50];
    count++;
    string title = "Warning - TSkitCell";
    string pstrmsg[6];
    pstrmsg[0] = "TSkitCell::SetIndexes()";
    pstrmsg[1] = "POwnerGObj ";
    if (POwnerGObj == NULL)
    {
      pstrmsg[1] += "== NULL";
    }
    else
    {
      pstrmsg[1] += "!= NULL";
    }
    pstrmsg[2] = "GObjName: " + GetGObjName();
    itoa(GObjIndex,buffer,10);
    pstrmsg[3] = "GObjIndex: ";
    pstrmsg[3] += buffer;
    pstrmsg[4] = "SpriteName: " + GetSpriteName();
    itoa(SpriteIndex,buffer,10);
    pstrmsg[5] = "SpriteIndex: ";
    pstrmsg[5] += buffer;
    if (GetModeWin() != NULL)
    {
      GetModeWin()->ScrollMsg(title,pstrmsg,2,true);
    }
    else
    {
      string s = "PModeWin == NULL \n";
      for (int16 i = 0;i<6;i++)
      {
        s += pstrmsg[i] + "\n";
      }
      ::MessageBox(NULL,s.c_str(),title.c_str(),MB_OK | MB_TASKMODAL);
    }
  }
  #endif
#endif
}
//*******************************************************************

