//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  osndmgr.cpp
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0      3/2/95    M.Perry     original baseline
//  2.0     8/23/97    M.Perry     32-bit conversion.
//********************************************************************
#if !defined(__osndmgr_h)
#include "osndmgr.h"
#endif

#if !defined(__omusmci_h)
#include "omusmci.h"
#endif

#if !defined(__omidi_h)
#include "omidi.h"
#endif
//*******************************************************************
void TOgleSoundMgr::Activate()
{
  Active = true;
  if (PAudioMgr != NULL) {PAudioMgr->Activate();}
}
//*******************************************************************
void TOgleSoundMgr::DeActivate()
{
  Active = false;
  if (PAudioMgr != NULL) {PAudioMgr->DeActivate();}
}
//*******************************************************************
void TOgleSoundMgr::Pump()
{
  if (PAudioMgr != NULL) {PAudioMgr->Pump();}
}
//*******************************************************************
void TOgleSoundMgr::CreateAudioMgr()
{
  PAudioMgr = new TAudioWaveMix(PWin);
  if (!PAudioMgr->Initialize())
  {
    delete PAudioMgr;
    PAudioMgr = NULL;
    PWin->MessageBox("Error Initializing Audio","Error - Audio",MB_OK);
  }
}
//*******************************************************************
TOgleSoundMgr::TOgleSoundMgr(TWindow *pwin)
:PWin(pwin),
 PAudioMgr(NULL),
 PMusicMgr(NULL)
{
  // the following should be in initialize.
  CreateAudioMgr();
  PMusicMgr = new TMusicMCI(PWin);
}
//*******************************************************************
TOgleSoundMgr::~TOgleSoundMgr()
{
  delete PMusicMgr;
  PMusicMgr = NULL;

  delete PAudioMgr;
  PAudioMgr = NULL;
}
//*******************************************************************
void TOgleSoundMgr::Stop(bool notifystop)
{
  if (PMusicMgr != NULL) {PMusicMgr->Stop();}
  if (PAudioMgr != NULL) {PAudioMgr->Stop(notifystop);}
}
//*******************************************************************
bool TOgleSoundMgr::Play(TMidi* pmidi)
{
   if (PMusicMgr == NULL)
   {
     pmidi->SetStopped();
     return false;
   }
	PMusicMgr->Play(pmidi);
	return true;
}
//*******************************************************************
bool TOgleSoundMgr::DefPlay(TMidi* pmidi)
{
   if (PMusicMgr == NULL) {return false;}
   if (pmidi == NULL) {return PMusicMgr->SetDefaultMidiActive(false);}
	PMusicMgr->PlayMidiDefault(pmidi);
   return PMusicMgr->SetDefaultMidiActive(true);
}
//*******************************************************************
void TOgleSoundMgr::Report()
{
  PWin->MessageBox("report not imp right now","Report - SoundMgr",MB_OK);
}
//*******************************************************************

