//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  owavlst.cpp
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     6/20/95    M.Perry    original baseline
//  2.0     8/23/97    M.Perry    32-bit conversion.
//********************************************************************
#if !defined(__owavlst_h)
#include "owavlst.h"
#endif

#if !defined(__osprite_h)
#include "osprite.h"
#endif

#if !defined(__owav_h)
#include "owav.h"
#endif

#include <assert.h>
//*******************************************************************
#ifdef DEBUGSPRITES
void TWavList::RTReport(ofstream &os)
{
  os<<"********************************\n";
  os<<"Start of Wav List\n";
  os<<"Started: "<<GetStarted()<<"\n";
  os<<"Stopped: "<<GetStopped()<<"\n";
  os<<"Last Wav Index #: "<<LastAddedElementNum<<"\n";
  for(int16 i=0;i<=LastAddedElementNum;i++)
  {
    os<<"****************************************\n";
    os<<"Index #"<<i<<"\n";
    if (GetWavPtr(i) == NULL) {os<<"Wav Ptr was NULL\n";}
    else                      {GetWavPtr(i)->RTReport(os);}
  }
}
#endif
//*******************************************************************
#ifdef DEBUGREPORTS
void TWavList::Report(ofstream &os)
{
  os<<"Start of Wav List"<<"\n";
  os<<"Last Wav Index #: "<<LastAddedElementNum<<"\n";
  for (int16 i=0;i<=LastAddedElementNum;i++)
  {
    os<<"Index #"<<i<<"\n";
    TWav *pwav = GetWavPtr(i);
    if (pwav != NULL) {pwav->Report(os);}
    else              {os<<"Wav Ptr was NULL"<<"\n";}
  }
}
#endif
//*******************************************************************
TWavList::TWavList(TOgleModeWindow *pmw,TSprite *psprite)
:TOgleList(pmw),
 NotifyRef(0),
 PSprite(psprite)
{
}
//*******************************************************************
TWavList::~TWavList()
{
}
//*******************************************************************
bool TWavList::AddWav(TWav *PNewWav)
{
  if (PNewWav == NULL) {return false;}
  PNewWav->PWavList = this;
  return (AddElement(PNewWav));
}
//*******************************************************************
bool TWavList::AddWav(TFileMode NewFileMode,int16 NewFUCLength)
{
  TWav *PTempWav = new TWav(PModeWin,NewFileMode,NewFUCLength);
  PTempWav->PWavList = this;
  if (AddElement(PTempWav)) {return true;}
  delete PTempWav;
  return false;
}
//*******************************************************************
//dword TWavList::GetLastFUC()
//{
//  dword EndingFUC = 0;
//  dword sf;
//  dword ef;
//
//  for (int16 i=0;i<=LastAddedElementNum;i++)
//  {
//    TWav *pwav = GetWavPtr(i);
//    if (pwav != NULL)
//    {
//      sf = pwav->GetFUCOffset();
//      ef = sf + pwav->Get_FUC_Length();
//      if (ef > EndingFUC) {EndingFUC = ef;}
//    }
//  }
//  return EndingFUC;
//}
//*******************************************************************
void TWavList::Start(dword StartFUC)
{
  Start();
  TOgleList::Start(StartFUC);

  if (NotifyRef == 0) // either we were empty or we didn't get notified,
                      // either way we're done.
  {
    SetStopped();
    SpriteNotifyStop();
  }
}
//*******************************************************************
void TWavList::Start()
{
  NotifyRef = 0;
  TOgleList::Start();
}
//*******************************************************************
void TWavList::SpriteNotifyStop()
{
  if (PSprite != NULL) {PSprite->NotifyStop(this);}
}
//*******************************************************************
