//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  onamesp.h
//    Project Name:  ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  2.5    11/04/99    M.Perry     original baseline
//********************************************************************
#include "onamesp.h"
#include "oanm.h"
//*******************************************************************
void TOgleNameSprite::SetupAnms()
{
  for (int16 i=0;i<uint8_max;i++)
  {
    FrameNum[i] = -1;
  }

  uint8 delta = uint8('A') - uint8('a');
  uint8 counter = 0;
  for (uint8 ui8 = uint8('a');
       ui8 < uint8('z');
       ui8++,counter++)
  {
    FrameNum[ui8] = counter;
    FrameNum[uint8(ui8 + delta)] = counter;
  }
  counter = 26;
  for(uint8 ui8 = uint8('0');
      ui8 < uint8('9');
      ui8++,counter++)
  {
    FrameNum[ui8] = counter;
  }

  for (int16 i=NumAlphaAnms - 1;i>=0;i--)//,counter++)
  {
    PAlpha[i] = GetAnm(i);//counter);
    if (PAlpha[i] == NULL) {AnmError("Name Sprite","Alpha",i);}//counter);}
    PAlpha[i]->CAD.ClearAutoStart();
    PAlpha[i]->CAD.ClearAutoStop();
    PAlpha[i]->CAD.SetDirStill();
  }
}
//*******************************************************************
TOgleNameSprite::TOgleNameSprite(TOgleModeWindow *pmw,const TFileMode &NewFileMode)
:TSprite(pmw,NewFileMode)
{
  SetToManual();
  SetupAnms();
  NoShow();
}
//*******************************************************************
TOgleNameSprite::TOgleNameSprite(TOgleModeWindow *pmw,const TFileMode &NewFileMode,void *psource)
:TSprite(pmw,NewFileMode,psource)
{
  SetToManual();
  SetupAnms();
  NoShow();
}
//*******************************************************************
TOgleNameSprite::~TOgleNameSprite()
{
}
//*******************************************************************
void TOgleNameSprite::SetName(string &s)
{
  if (CurrentName == s) {return;} //quick out.
  CurrentName = s;

  NoShow();
  int16 len = int16(s.length());
  int16 start = int16((NumAlphaAnms - len)/2);
  int16 end = int16(start + len);
  for (int16 i=start;i<end;i++)
  {
    if (PAlpha[i] != NULL)
    {
      char ch = s.get_at(i - start);
      uint8 ui8 = uint8(ch);
      int16 framenum = FrameNum[ui8];
      if (framenum >= 0)
      {
        PAlpha[i]->CAD.SetCurrentFrame(framenum);
        PAlpha[i]->Show();
      }
      else
      {
        PAlpha[i]->NoShow();
      }
    }
  }
  Update(GetAdjFUC());//provides update for non-active but started sprite
}
//*******************************************************************
