//********************************************************************
//                    Confidential Material.
//  
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  ostate.cpp
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0    5/22/95     M.Perry     original baseline
//  1.0    6/29/95     A.Krist     Added 19 more substates for total of 25
//  2.0    08/27/97    M.Perry     32-bit conversion.
//********************************************************************
#if !defined(__ostate_h)
#include "ostate.h"
#endif

#if defined(STATEDEBUG)
#if !defined(__STDIO_H)
  #include <stdio.h>
#endif
#endif
//*******************************************************************
void TState::SetRunOrder(TExecuteStateStatus S0,TExecuteStateStatus S1,
								 TExecuteStateStatus S2,TExecuteStateStatus S3,
								 TExecuteStateStatus S4,TExecuteStateStatus S5,
								 TExecuteStateStatus S6,TExecuteStateStatus S7,
								 TExecuteStateStatus S8,TExecuteStateStatus S9,
								 TExecuteStateStatus S10,TExecuteStateStatus S11,
								 TExecuteStateStatus S12,TExecuteStateStatus S13,
								 TExecuteStateStatus S14,TExecuteStateStatus S15,
								 TExecuteStateStatus S16,TExecuteStateStatus S17,
								 TExecuteStateStatus S18,TExecuteStateStatus S19,
								 TExecuteStateStatus S20,TExecuteStateStatus S21,
								 TExecuteStateStatus S22,TExecuteStateStatus S23,
                         TExecuteStateStatus S24)
{
  SubStateRunOrder[0]  = S0;
  SubStateRunOrder[1]  = S1;
  SubStateRunOrder[2]  = S2;
  SubStateRunOrder[3]  = S3;
  SubStateRunOrder[4]  = S4;
  SubStateRunOrder[5]  = S5;
  SubStateRunOrder[6]  = S6;
  SubStateRunOrder[7]  = S7;
  SubStateRunOrder[8]  = S8;
  SubStateRunOrder[9]  = S9;
  SubStateRunOrder[10] = S10;
  SubStateRunOrder[11] = S11;
  SubStateRunOrder[12] = S12;
  SubStateRunOrder[13] = S13;
  SubStateRunOrder[14] = S14;
  SubStateRunOrder[15] = S15;
  SubStateRunOrder[16] = S16;
  SubStateRunOrder[17] = S17;
  SubStateRunOrder[18] = S18;
  SubStateRunOrder[19] = S19;
  SubStateRunOrder[20] = S20;
  SubStateRunOrder[21] = S21;
  SubStateRunOrder[22] = S22;
  SubStateRunOrder[23] = S23;
  SubStateRunOrder[24] = S24;
}
//*******************************************************************
void TState::SetHeedRecommend(bool S1,bool S2,bool S3,bool S4,bool S5,
										bool S6,bool S7,bool S8,bool S9,bool S10,
										bool S11,bool S12,bool S13,bool S14,bool S15,
										bool S16,bool S17,bool S18,bool S19,bool S20,
										bool S21,bool S22,bool S23,bool S24)
{
  HeedRecommend[0]  = false;
  HeedRecommend[1]  = S1;
  HeedRecommend[2]  = S2;
  HeedRecommend[3]  = S3;
  HeedRecommend[4]  = S4;
  HeedRecommend[5]  = S5;
  HeedRecommend[6]  = S6;
  HeedRecommend[7]  = S7;
  HeedRecommend[8]  = S8;
  HeedRecommend[9]  = S9;
  HeedRecommend[10] = S10;
  HeedRecommend[11] = S11;
  HeedRecommend[12] = S12;
  HeedRecommend[13] = S13;
  HeedRecommend[14] = S14;
  HeedRecommend[15] = S15;
  HeedRecommend[16] = S16;
  HeedRecommend[17] = S17;
  HeedRecommend[18] = S18;
  HeedRecommend[19] = S19;
  HeedRecommend[20] = S20;
  HeedRecommend[21] = S21;
  HeedRecommend[22] = S22;
  HeedRecommend[23] = S23;
  HeedRecommend[24] = S24;
}
//*******************************************************************
TState::TState()
{
  #if defined(STATEDEBUG)
  strcpy(ClassName,"TState");
  #endif

  Status = ss_Running;
  SubStateStatus = ss_Nothing;
  ExecuteStatus = ess_ExecuteFirstTime;
  PActiveSubState = NULL;
  ExecuteWaiting = false;
  SetRunOrder();
  SetHeedRecommend();
}
//*******************************************************************
TState::~TState()
{
  if (PActiveSubState != NULL)
  {
	 delete PActiveSubState;
	 PActiveSubState = NULL;
  }
  Status = ss_Nothing;
  ExecuteStatus = ess_Nothing;
  SubStateStatus = ss_Nothing;
  ExecuteWaiting = false;
}
//*******************************************************************
bool TState::ShuttingDown()
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState == NULL) {return HandleShuttingDown();}
  if (!PActiveSubState->ShuttingDown()) {return false;}
  return HandleShuttingDown();
}
//*******************************************************************
TStateStatus TState::Run()
{
  bool Out = false;
  if (Status == ss_Running)
  {
	 while (!Out)
	 {
		switch (ExecuteStatus)
		{
		  case ess_Error:              ErrorHandler();break;
		  case ess_ExecuteFirstTime:   ExecuteFirstTime();break;
		  case ess_Execute:            Execute(); break;
		  case ess_Done:               RecommendSibling();Out = true; break;
		  case ess_StartSubState1:     StartSubState1();break;
		  case ess_RunSubState1:       RunSubState1();break;
		  case ess_EndSubState1:       EndSubState1(); break;
		  case ess_StartSubState2:     StartSubState2();break;
		  case ess_RunSubState2:       RunSubState2();break;
		  case ess_EndSubState2:       EndSubState2();break;
		  case ess_StartSubState3:     StartSubState3();break;
		  case ess_RunSubState3:       RunSubState3();break;
		  case ess_EndSubState3:       EndSubState3();break;
		  case ess_StartSubState4:     StartSubState4();break;
		  case ess_RunSubState4:       RunSubState4();break;
		  case ess_EndSubState4:       EndSubState4();break;
		  case ess_StartSubState5:     StartSubState5();break;
		  case ess_RunSubState5:       RunSubState5();break;
		  case ess_EndSubState5:       EndSubState5();break;
		  case ess_StartSubState6:     StartSubState6();break;
		  case ess_RunSubState6:       RunSubState6();break;
		  case ess_EndSubState6:       EndSubState6();break;
		  case ess_StartSubState7:     StartSubState7();break;
		  case ess_RunSubState7:       RunSubState7();break;
		  case ess_EndSubState7:       EndSubState7(); break;
		  case ess_StartSubState8:     StartSubState8();break;
		  case ess_RunSubState8:       RunSubState8();break;
		  case ess_EndSubState8:       EndSubState8();break;
		  case ess_StartSubState9:     StartSubState9();break;
		  case ess_RunSubState9:       RunSubState9();break;
		  case ess_EndSubState9:       EndSubState9();break;
		  case ess_StartSubState10:    StartSubState10();break;
		  case ess_RunSubState10:      RunSubState10();break;
		  case ess_EndSubState10:      EndSubState10();break;
		  case ess_StartSubState11:    StartSubState11();break;
		  case ess_RunSubState11:      RunSubState11();break;
		  case ess_EndSubState11:      EndSubState11();break;
		  case ess_StartSubState12:    StartSubState12();break;
		  case ess_RunSubState12:      RunSubState12();break;
		  case ess_EndSubState12:      EndSubState12();break;
		  case ess_StartSubState13:     StartSubState13();break;
		  case ess_RunSubState13:       RunSubState13();break;
		  case ess_EndSubState13:       EndSubState13(); break;
		  case ess_StartSubState14:     StartSubState14();break;
		  case ess_RunSubState14:       RunSubState14();break;
		  case ess_EndSubState14:       EndSubState14();break;
		  case ess_StartSubState15:     StartSubState15();break;
		  case ess_RunSubState15:       RunSubState15();break;
		  case ess_EndSubState15:       EndSubState15();break;
		  case ess_StartSubState16:     StartSubState16();break;
		  case ess_RunSubState16:       RunSubState16();break;
		  case ess_EndSubState16:       EndSubState16();break;
		  case ess_StartSubState17:     StartSubState17();break;
		  case ess_RunSubState17:       RunSubState17();break;
		  case ess_EndSubState17:       EndSubState17();break;
		  case ess_StartSubState18:     StartSubState18();break;
		  case ess_RunSubState18:       RunSubState18();break;
		  case ess_EndSubState18:       EndSubState18();break;
		  case ess_StartSubState19:     StartSubState19();break;
		  case ess_RunSubState19:       RunSubState19();break;
		  case ess_EndSubState19:       EndSubState19(); break;
		  case ess_StartSubState20:     StartSubState20();break;
		  case ess_RunSubState20:       RunSubState20();break;
		  case ess_EndSubState20:       EndSubState20();break;
		  case ess_StartSubState21:     StartSubState21();break;
		  case ess_RunSubState21:       RunSubState21();break;
		  case ess_EndSubState21:       EndSubState21();break;
		  case ess_StartSubState22:    StartSubState22();break;
		  case ess_RunSubState22:      RunSubState22();break;
		  case ess_EndSubState22:      EndSubState22();break;
		  case ess_StartSubState23:    StartSubState23();break;
		  case ess_RunSubState23:      RunSubState23();break;
		  case ess_EndSubState23:      EndSubState23();break;
		  case ess_StartSubState24:    StartSubState24();break;
		  case ess_RunSubState24:      RunSubState24();break;
		  case ess_EndSubState24:      EndSubState24();break;
		  default:                    ErrorHandler();break;
		}//end switch

		if (ExecuteWaiting) {Out = true;}
		else if (SubStateStatus == ss_Running) {Out = true;}
	 }//end while
  }//end if
  return (Status);
}
//*******************************************************************
void TState::Execute()
{
  if (ExecuteWaiting)
  {
	 return;
  }
  else
  {
	 ExecuteStatus = ess_Done;
  }
}
//*******************************************************************
void TState::ExecuteFirstTime()
{
  ExecuteStatus = SubStateRunOrder[0];
}
//*******************************************************************
void TState::Update(dword NewFUC)
{
  if (PActiveSubState != NULL)
  {
    PActiveSubState->Update(NewFUC);
  }
  else
  {
    HandleUpdate(NewFUC);
  }
}
//*******************************************************************
void TState::PostUpdate(dword NewFUC)
{
  if (PActiveSubState != NULL)
  {
    PActiveSubState->PostUpdate(NewFUC);
  }
  else
  {
    HandlePostUpdate(NewFUC);
  }
}
//*******************************************************************
void TState::CreateSubState1()
{
  //PActiveSubState = new TState;
}
//*******************************************************************
void TState::StartSubState1()
{
  CreateSubState1();
  ExecuteStatus = ess_RunSubState1;
}
//*******************************************************************
void TState::RunSubState1()
{
  if (PActiveSubState == NULL)
  {
	 ExecuteStatus = ess_EndSubState1;
  }
  else
  {
	 SubStateStatus = PActiveSubState->Run();
	 if (SubStateStatus != ss_Running) {ExecuteStatus = ess_EndSubState1;}
  }
}
//*******************************************************************
void TState::EndSubState1()
{
  if (PActiveSubState != NULL)
  {
    delete PActiveSubState;
  }
  PActiveSubState = NULL;

  if (HeedRecommend[1])
  {
    SwitchToRecomSubState();
  }
  else
  {
	 ExecuteStatus = SubStateRunOrder[1];
  }
}
//*******************************************************************
void TState::CreateSubState2()
{
  //PActiveSubState = new TState;
}
//*******************************************************************
void TState::StartSubState2()
{
  CreateSubState2();
  ExecuteStatus = ess_RunSubState2;
}
//*******************************************************************
void TState::RunSubState2()
{
  if (PActiveSubState == NULL)
  {
	 ExecuteStatus = ess_EndSubState2;
  }
  else
  {
	 SubStateStatus = PActiveSubState->Run();
    if (SubStateStatus != ss_Running) {ExecuteStatus = ess_EndSubState2;}
  }
}
//*******************************************************************
void TState::EndSubState2()
{
  if (PActiveSubState != NULL)
  {
	 delete PActiveSubState;
  }
  PActiveSubState = NULL;

  if (HeedRecommend[2])
  {
	 SwitchToRecomSubState();
  }
  else
  {
	 ExecuteStatus = SubStateRunOrder[2];
  }
}
//*******************************************************************
void TState::CreateSubState3()
{
  //PActiveSubState = new TState;
}
//*******************************************************************
void TState::StartSubState3()
{
  CreateSubState3();
  ExecuteStatus = ess_RunSubState3;
}
//*******************************************************************
void TState::RunSubState3()
{
  if (PActiveSubState == NULL)
  {
	 ExecuteStatus = ess_EndSubState3;
  }
  else
  {
	 SubStateStatus = PActiveSubState->Run();
    if (SubStateStatus != ss_Running) {ExecuteStatus = ess_EndSubState3;}
  }
}
//*******************************************************************
void TState::EndSubState3()
{
  if (PActiveSubState != NULL)
  {
	 delete PActiveSubState;
  }
  PActiveSubState = NULL;

  if (HeedRecommend[3])
  {
	 SwitchToRecomSubState();
  }
  else
  {
	 ExecuteStatus = SubStateRunOrder[3];
  }
}
//*******************************************************************
void TState::CreateSubState4()
{
  //PActiveSubState = new TState;
}
//*******************************************************************
void TState::StartSubState4()
{
  CreateSubState4();
  ExecuteStatus = ess_RunSubState4;
}
//*******************************************************************
void TState::RunSubState4()
{
  if (PActiveSubState == NULL)
  {
	 ExecuteStatus = ess_EndSubState4;
  }
  else
  {
	 SubStateStatus = PActiveSubState->Run();
	 if (SubStateStatus != ss_Running) {ExecuteStatus = ess_EndSubState4;}
  }
}
//*******************************************************************
void TState::EndSubState4()
{
  if (PActiveSubState != NULL)
  {
	 delete PActiveSubState;
  }
  PActiveSubState = NULL;

  if (HeedRecommend[4])
  {
	 SwitchToRecomSubState();
  }
  else
  {
	 ExecuteStatus = SubStateRunOrder[4];
  }
}
//*******************************************************************
void TState::CreateSubState5()
{
  //PActiveSubState = new TState;
}
//*******************************************************************
void TState::StartSubState5()
{
  CreateSubState5();
  ExecuteStatus = ess_RunSubState5;
}
//*******************************************************************
void TState::RunSubState5()
{
  if (PActiveSubState == NULL)
  {
	 ExecuteStatus = ess_EndSubState5;
  }
  else
  {
	 SubStateStatus = PActiveSubState->Run();
	 if (SubStateStatus != ss_Running) {ExecuteStatus = ess_EndSubState5;}
  }
}
//*******************************************************************
void TState::EndSubState5()
{
  if (PActiveSubState != NULL)
  {
	 delete PActiveSubState;
  }
  PActiveSubState = NULL;

  if (HeedRecommend[5])
  {
	 SwitchToRecomSubState();
  }
  else
  {
	 ExecuteStatus = SubStateRunOrder[5];
  }
}
//*******************************************************************
void TState::CreateSubState6()
{
  //PActiveSubState = new TState;
}
//*******************************************************************
void TState::StartSubState6()
{
  CreateSubState6();
  ExecuteStatus = ess_RunSubState6;
}
//*******************************************************************
void TState::RunSubState6()
{
  if (PActiveSubState == NULL)
  {
	 ExecuteStatus = ess_EndSubState6;
  }
  else
  {
	 SubStateStatus = PActiveSubState->Run();
	 if (SubStateStatus != ss_Running) {ExecuteStatus = ess_EndSubState6;}
  }
}
//*******************************************************************
void TState::EndSubState6()
{
  if (PActiveSubState != NULL)
  {
	 delete PActiveSubState;
  }
  PActiveSubState = NULL;

  if (HeedRecommend[6])
  {
	 SwitchToRecomSubState();
  }
  else
  {
	 ExecuteStatus = SubStateRunOrder[6];
  }
}
//*******************************************************************
//*******************************************************************
void TState::CreateSubState7()
{
  //PActiveSubState = new TState;
}
//*******************************************************************
void TState::StartSubState7()
{
  CreateSubState7();
  ExecuteStatus = ess_RunSubState7;
}
//*******************************************************************
void TState::RunSubState7()
{
  if (PActiveSubState == NULL)
  {
	 ExecuteStatus = ess_EndSubState7;
  }
  else
  {
	 SubStateStatus = PActiveSubState->Run();
	 if (SubStateStatus != ss_Running) {ExecuteStatus = ess_EndSubState7;}
  }
}
//*******************************************************************
void TState::EndSubState7()
{
  if (PActiveSubState != NULL)
  {
    delete PActiveSubState;
  }
  PActiveSubState = NULL;

  if (HeedRecommend[7])
  {
	 SwitchToRecomSubState();
  }
  else
  {
	 ExecuteStatus = SubStateRunOrder[7];
  }
}
//*******************************************************************
void TState::CreateSubState8()
{
  //PActiveSubState = new TState;
}
//*******************************************************************
void TState::StartSubState8()
{
  CreateSubState8();
  ExecuteStatus = ess_RunSubState8;
}
//*******************************************************************
void TState::RunSubState8()
{
  if (PActiveSubState == NULL)
  {
	 ExecuteStatus = ess_EndSubState8;
  }
  else
  {
	 SubStateStatus = PActiveSubState->Run();
	 if (SubStateStatus != ss_Running) {ExecuteStatus = ess_EndSubState8;}
  }
}
//*******************************************************************
void TState::EndSubState8()
{
  if (PActiveSubState != NULL)
  {
	 delete PActiveSubState;
  }
  PActiveSubState = NULL;

  if (HeedRecommend[8])
  {
	 SwitchToRecomSubState();
  }
  else
  {
	 ExecuteStatus = SubStateRunOrder[8];
  }
}
//*******************************************************************
void TState::CreateSubState9()
{
  //PActiveSubState = new TState;
}
//*******************************************************************
void TState::StartSubState9()
{
  CreateSubState9();
  ExecuteStatus = ess_RunSubState9;
}
//*******************************************************************
void TState::RunSubState9()
{
  if (PActiveSubState == NULL)
  {
	 ExecuteStatus = ess_EndSubState9;
  }
  else
  {
	 SubStateStatus = PActiveSubState->Run();
	 if (SubStateStatus != ss_Running) {ExecuteStatus = ess_EndSubState9;}
  }
}
//*******************************************************************
void TState::EndSubState9()
{
  if (PActiveSubState != NULL)
  {
	 delete PActiveSubState;
  }
  PActiveSubState = NULL;

  if (HeedRecommend[9])
  {
	 SwitchToRecomSubState();
  }
  else
  {
	 ExecuteStatus = SubStateRunOrder[9];
  }
}
//*******************************************************************
void TState::CreateSubState10()
{
  //PActiveSubState = new TState;
}
//*******************************************************************
void TState::StartSubState10()
{
  CreateSubState10();
  ExecuteStatus = ess_RunSubState10;
}
//*******************************************************************
void TState::RunSubState10()
{
  if (PActiveSubState == NULL)
  {
	 ExecuteStatus = ess_EndSubState10;
  }
  else
  {
	 SubStateStatus = PActiveSubState->Run();
	 if (SubStateStatus != ss_Running) {ExecuteStatus = ess_EndSubState10;}
  }
}
//*******************************************************************
void TState::EndSubState10()
{
  if (PActiveSubState != NULL)
  {
	 delete PActiveSubState;
  }
  PActiveSubState = NULL;

  if (HeedRecommend[10])
  {
	 SwitchToRecomSubState();
  }
  else
  {
	 ExecuteStatus = SubStateRunOrder[10];
  }
}
//*******************************************************************
void TState::CreateSubState11()
{
  //PActiveSubState = new TState;
}
//*******************************************************************
void TState::StartSubState11()
{
  CreateSubState11();
  ExecuteStatus = ess_RunSubState11;
}
//*******************************************************************
void TState::RunSubState11()
{
  if (PActiveSubState == NULL)
  {
	 ExecuteStatus = ess_EndSubState11;
  }
  else
  {
	 SubStateStatus = PActiveSubState->Run();
	 if (SubStateStatus != ss_Running) {ExecuteStatus = ess_EndSubState11;}
  }
}
//*******************************************************************
void TState::EndSubState11()
{
  if (PActiveSubState != NULL)
  {
	 delete PActiveSubState;
  }
  PActiveSubState = NULL;

  if (HeedRecommend[11])
  {
	 SwitchToRecomSubState();
  }
  else
  {
	 ExecuteStatus = SubStateRunOrder[11];
  }
}
//*******************************************************************
//*******************************************************************
void TState::CreateSubState12()
{
  //PActiveSubState = new TState;
}
//*******************************************************************
void TState::StartSubState12()
{
  CreateSubState12();
  ExecuteStatus = ess_RunSubState12;
}
//*******************************************************************
void TState::RunSubState12()
{
  if (PActiveSubState == NULL)
  {
	 ExecuteStatus = ess_EndSubState12;
  }
  else
  {
	 SubStateStatus = PActiveSubState->Run();
	 if (SubStateStatus != ss_Running) {ExecuteStatus = ess_EndSubState12;}
  }
}
//*******************************************************************
void TState::EndSubState12()
{
  if (PActiveSubState != NULL)
  {
	 delete PActiveSubState;
  }
  PActiveSubState = NULL;

  if (HeedRecommend[12])
  {
	 SwitchToRecomSubState();
  }
  else
  {
	 ExecuteStatus = SubStateRunOrder[12];
  }
}
//*******************************************************************
void TState::CreateSubState13()
{
  //PActiveSubState = new TState;
}
//*******************************************************************
void TState::StartSubState13()
{
  CreateSubState13();
  ExecuteStatus = ess_RunSubState13;
}
//*******************************************************************
void TState::RunSubState13()
{
  if (PActiveSubState == NULL)
  {
	 ExecuteStatus = ess_EndSubState13;
  }
  else
  {
	 SubStateStatus = PActiveSubState->Run();
	 if (SubStateStatus != ss_Running) {ExecuteStatus = ess_EndSubState13;}
  }
}
//*******************************************************************
void TState::EndSubState13()
{
  if (PActiveSubState != NULL)
  {
    delete PActiveSubState;
  }
  PActiveSubState = NULL;

  if (HeedRecommend[13])
  {
    SwitchToRecomSubState();
  }
  else
  {
	 ExecuteStatus = SubStateRunOrder[13];
  }
}
//*******************************************************************
void TState::CreateSubState14()
{
  //PActiveSubState = new TState;
}
//*******************************************************************
void TState::StartSubState14()
{
  CreateSubState14();
  ExecuteStatus = ess_RunSubState14;
}
//*******************************************************************
void TState::RunSubState14()
{
  if (PActiveSubState == NULL)
  {
	 ExecuteStatus = ess_EndSubState14;
  }
  else
  {
	 SubStateStatus = PActiveSubState->Run();
	 if (SubStateStatus != ss_Running) {ExecuteStatus = ess_EndSubState14;}
  }
}
//*******************************************************************
void TState::EndSubState14()
{
  if (PActiveSubState != NULL)
  {
	 delete PActiveSubState;
  }
  PActiveSubState = NULL;

  if (HeedRecommend[14])
  {
	 SwitchToRecomSubState();
  }
  else
  {
	 ExecuteStatus = SubStateRunOrder[14];
  }
}
//*******************************************************************
void TState::CreateSubState15()
{
  //PActiveSubState = new TState;
}
//*******************************************************************
void TState::StartSubState15()
{
  CreateSubState15();
  ExecuteStatus = ess_RunSubState15;
}
//*******************************************************************
void TState::RunSubState15()
{
  if (PActiveSubState == NULL)
  {
	 ExecuteStatus = ess_EndSubState15;
  }
  else
  {
	 SubStateStatus = PActiveSubState->Run();
	 if (SubStateStatus != ss_Running) {ExecuteStatus = ess_EndSubState15;}
  }
}
//*******************************************************************
void TState::EndSubState15()
{
  if (PActiveSubState != NULL)
  {
	 delete PActiveSubState;
  }
  PActiveSubState = NULL;

  if (HeedRecommend[15])
  {
	 SwitchToRecomSubState();
  }
  else
  {
	 ExecuteStatus = SubStateRunOrder[15];
  }
}
//*******************************************************************
void TState::CreateSubState16()
{
  //PActiveSubState = new TState;
}
//*******************************************************************
void TState::StartSubState16()
{
  CreateSubState16();
  ExecuteStatus = ess_RunSubState16;
}
//*******************************************************************
void TState::RunSubState16()
{
  if (PActiveSubState == NULL)
  {
	 ExecuteStatus = ess_EndSubState16;
  }
  else
  {
	 SubStateStatus = PActiveSubState->Run();
	 if (SubStateStatus != ss_Running) {ExecuteStatus = ess_EndSubState16;}
  }
}
//*******************************************************************
void TState::EndSubState16()
{
  if (PActiveSubState != NULL)
  {
	 delete PActiveSubState;
  }
  PActiveSubState = NULL;

  if (HeedRecommend[16])
  {
	 SwitchToRecomSubState();
  }
  else
  {
	 ExecuteStatus = SubStateRunOrder[16];
  }
}
//*******************************************************************
void TState::CreateSubState17()
{
  //PActiveSubState = new TState;
}
//*******************************************************************
void TState::StartSubState17()
{
  CreateSubState17();
  ExecuteStatus = ess_RunSubState17;
}
//*******************************************************************
void TState::RunSubState17()
{
  if (PActiveSubState == NULL)
  {
	 ExecuteStatus = ess_EndSubState17;
  }
  else
  {
	 SubStateStatus = PActiveSubState->Run();
	 if (SubStateStatus != ss_Running) {ExecuteStatus = ess_EndSubState17;}
  }
}
//*******************************************************************
void TState::EndSubState17()
{
  if (PActiveSubState != NULL)
  {
	 delete PActiveSubState;
  }
  PActiveSubState = NULL;

  if (HeedRecommend[17])
  {
	 SwitchToRecomSubState();
  }
  else
  {
	 ExecuteStatus = SubStateRunOrder[17];
  }
}
//*******************************************************************
void TState::CreateSubState18()
{
  //PActiveSubState = new TState;
}
//*******************************************************************
void TState::StartSubState18()
{
  CreateSubState18();
  ExecuteStatus = ess_RunSubState18;
}
//*******************************************************************
void TState::RunSubState18()
{
  if (PActiveSubState == NULL)
  {
	 ExecuteStatus = ess_EndSubState18;
  }
  else
  {
	 SubStateStatus = PActiveSubState->Run();
	 if (SubStateStatus != ss_Running) {ExecuteStatus = ess_EndSubState18;}
  }
}
//*******************************************************************
void TState::EndSubState18()
{
  if (PActiveSubState != NULL)
  {
	 delete PActiveSubState;
  }
  PActiveSubState = NULL;

  if (HeedRecommend[18])
  {
	 SwitchToRecomSubState();
  }
  else
  {
	 ExecuteStatus = SubStateRunOrder[18];
  }
}
//*******************************************************************
//*******************************************************************
void TState::CreateSubState19()
{
  //PActiveSubState = new TState;
}
//*******************************************************************
void TState::StartSubState19()
{
  CreateSubState19();
  ExecuteStatus = ess_RunSubState19;
}
//*******************************************************************
void TState::RunSubState19()
{
  if (PActiveSubState == NULL)
  {
	 ExecuteStatus = ess_EndSubState19;
  }
  else
  {
	 SubStateStatus = PActiveSubState->Run();
	 if (SubStateStatus != ss_Running) {ExecuteStatus = ess_EndSubState19;}
  }
}
//*******************************************************************
void TState::EndSubState19()
{
  if (PActiveSubState != NULL)
  {
    delete PActiveSubState;
  }
  PActiveSubState = NULL;

  if (HeedRecommend[19])
  {
	 SwitchToRecomSubState();
  }
  else
  {
	 ExecuteStatus = SubStateRunOrder[19];
  }
}
//*******************************************************************
void TState::CreateSubState20()
{
  //PActiveSubState = new TState;
}
//*******************************************************************
void TState::StartSubState20()
{
  CreateSubState20();
  ExecuteStatus = ess_RunSubState20;
}
//*******************************************************************
void TState::RunSubState20()
{
  if (PActiveSubState == NULL)
  {
	 ExecuteStatus = ess_EndSubState20;
  }
  else
  {
	 SubStateStatus = PActiveSubState->Run();
	 if (SubStateStatus != ss_Running) {ExecuteStatus = ess_EndSubState20;}
  }
}
//*******************************************************************
void TState::EndSubState20()
{
  if (PActiveSubState != NULL)
  {
	 delete PActiveSubState;
  }
  PActiveSubState = NULL;

  if (HeedRecommend[20])
  {
	 SwitchToRecomSubState();
  }
  else
  {
	 ExecuteStatus = SubStateRunOrder[20];
  }
}
//*******************************************************************
void TState::CreateSubState21()
{
  //PActiveSubState = new TState;
}
//*******************************************************************
void TState::StartSubState21()
{
  CreateSubState21();
  ExecuteStatus = ess_RunSubState21;
}
//*******************************************************************
void TState::RunSubState21()
{
  if (PActiveSubState == NULL)
  {
	 ExecuteStatus = ess_EndSubState21;
  }
  else
  {
	 SubStateStatus = PActiveSubState->Run();
	 if (SubStateStatus != ss_Running) {ExecuteStatus = ess_EndSubState21;}
  }
}
//*******************************************************************
void TState::EndSubState21()
{
  if (PActiveSubState != NULL)
  {
	 delete PActiveSubState;
  }
  PActiveSubState = NULL;

  if (HeedRecommend[21])
  {
	 SwitchToRecomSubState();
  }
  else
  {
	 ExecuteStatus = SubStateRunOrder[21];
  }
}
//*******************************************************************
void TState::CreateSubState22()
{
  //PActiveSubState = new TState;
}
//*******************************************************************
void TState::StartSubState22()
{
  CreateSubState22();
  ExecuteStatus = ess_RunSubState22;
}
//*******************************************************************
void TState::RunSubState22()
{
  if (PActiveSubState == NULL)
  {
	 ExecuteStatus = ess_EndSubState22;
  }
  else
  {
	 SubStateStatus = PActiveSubState->Run();
	 if (SubStateStatus != ss_Running) {ExecuteStatus = ess_EndSubState22;}
  }
}
//*******************************************************************
void TState::EndSubState22()
{
  if (PActiveSubState != NULL)
  {
	 delete PActiveSubState;
  }
  PActiveSubState = NULL;

  if (HeedRecommend[22])
  {
	 SwitchToRecomSubState();
  }
  else
  {
	 ExecuteStatus = SubStateRunOrder[22];
  }
}
//*******************************************************************
void TState::CreateSubState23()
{
  //PActiveSubState = new TState;
}
//*******************************************************************
void TState::StartSubState23()
{
  CreateSubState23();
  ExecuteStatus = ess_RunSubState23;
}
//*******************************************************************
void TState::RunSubState23()
{
  if (PActiveSubState == NULL)
  {
	 ExecuteStatus = ess_EndSubState23;
  }
  else
  {
	 SubStateStatus = PActiveSubState->Run();
	 if (SubStateStatus != ss_Running) {ExecuteStatus = ess_EndSubState23;}
  }
}
//*******************************************************************
void TState::EndSubState23()
{
  if (PActiveSubState != NULL)
  {
	 delete PActiveSubState;
  }
  PActiveSubState = NULL;

  if (HeedRecommend[23])
  {
	 SwitchToRecomSubState();
  }
  else
  {
	 ExecuteStatus = SubStateRunOrder[23];
  }
}
//*******************************************************************
//*******************************************************************
void TState::CreateSubState24()
{
  //PActiveSubState = new TState;
}
//*******************************************************************
void TState::StartSubState24()
{
  CreateSubState24();
  ExecuteStatus = ess_RunSubState24;
}
//*******************************************************************
void TState::RunSubState24()
{
  if (PActiveSubState == NULL)
  {
	 ExecuteStatus = ess_EndSubState24;
  }
  else
  {
	 SubStateStatus = PActiveSubState->Run();
	 if (SubStateStatus != ss_Running) {ExecuteStatus = ess_EndSubState24;}
  }
}
//*******************************************************************
void TState::EndSubState24()
{
  if (PActiveSubState != NULL)
  {
	 delete PActiveSubState;
  }
  PActiveSubState = NULL;

  if (HeedRecommend[24])
  {
	 SwitchToRecomSubState();
  }
  else
  {
	 ExecuteStatus = SubStateRunOrder[24];
  }
}
//*******************************************************************
void TState::SwitchToRecomSubState()
{
  switch (SubStateStatus)
  {
	 case ss_Done:        ExecuteStatus = ess_Done;break;
	 case ss_DoneRecom1:  ExecuteStatus = ess_StartSubState1;break;
	 case ss_DoneRecom2:  ExecuteStatus = ess_StartSubState2;break;
	 case ss_DoneRecom3:  ExecuteStatus = ess_StartSubState3;break;
	 case ss_DoneRecom4:  ExecuteStatus = ess_StartSubState4;break;
	 case ss_DoneRecom5:  ExecuteStatus = ess_StartSubState5;break;
	 case ss_DoneRecom6:  ExecuteStatus = ess_StartSubState6;break;
	 case ss_DoneRecom7:  ExecuteStatus = ess_StartSubState7;break;
	 case ss_DoneRecom8:  ExecuteStatus = ess_StartSubState8;break;
	 case ss_DoneRecom9:  ExecuteStatus = ess_StartSubState9;break;
	 case ss_DoneRecom10: ExecuteStatus = ess_StartSubState10;break;
	 case ss_DoneRecom11: ExecuteStatus = ess_StartSubState11;break;
	 case ss_DoneRecom12: ExecuteStatus = ess_StartSubState12;break;
	 case ss_DoneRecom13: ExecuteStatus = ess_StartSubState13;break;
	 case ss_DoneRecom14: ExecuteStatus = ess_StartSubState14;break;
	 case ss_DoneRecom15: ExecuteStatus = ess_StartSubState15;break;
	 case ss_DoneRecom16: ExecuteStatus = ess_StartSubState16;break;
	 case ss_DoneRecom17: ExecuteStatus = ess_StartSubState17;break;
	 case ss_DoneRecom18: ExecuteStatus = ess_StartSubState18;break;
	 case ss_DoneRecom19: ExecuteStatus = ess_StartSubState19;break;
	 case ss_DoneRecom20: ExecuteStatus = ess_StartSubState20;break;
	 case ss_DoneRecom21: ExecuteStatus = ess_StartSubState21;break;
	 case ss_DoneRecom22: ExecuteStatus = ess_StartSubState22;break;
	 case ss_DoneRecom23: ExecuteStatus = ess_StartSubState23;break;
	 case ss_DoneRecom24: ExecuteStatus = ess_StartSubState24;break;
	 default:             ExecuteStatus = ess_Done;break;
  }
}
//*******************************************************************
void TState::RecommendSibling()
{
  Status = ss_Done;
}
//*******************************************************************
void TState::ErrorHandler()
{
  Status = ss_Done;
}
//*******************************************************************

