//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  omisc.cpp
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0      4/4/95    M.Perry     original baseline
//  2.0      8/26/97   M.Perry     32-bit conversion.
//********************************************************************
#include "omisc.h"
//*******************************************************************
#if 0
bool PullFirstDir(const string &pathname,string &first,string &rest)
{
//  size_t len = strlen(pathname.c_str());
  size_t firstslash = pathname.find_first_of("\\");
  if (firstslash == NPOS)
  {
    first = "";
    rest = pathname;
  }
  else
  {
    first = pathname;
    first.resize(firstslash + 1);
    rest = pathname.substr(firstslash + 1);
  }
  return true;
}
//*******************************************************************
bool IsCDRom(char Drive)
{
  return IsCDRom(ConvertDriveLetterToInt(Drive));
}
//*******************************************************************
bool IsCDRom(int Drive)
{
  #if defined(BI_PLAT_WIN16)
  word SaveAX,SaveBX;
  asm {
        mov cx,Drive;
        mov ax,0x150B;
        int 0x2F;
        mov SaveAX,ax;
        mov SaveBX,bx;
      }
  return ((SaveBX == 0xADAD) && (SaveAX != 0));
  #else
  return false;
  #endif
}
//*******************************************************************
void SplitUp(string NewFullPath,string &NewDrive,string &NewDir,
             string &NewFName,string &NewExt)
{
  char FullPath[_MAX_PATH];
  char Drive[_MAX_DRIVE];
  char Dir[_MAX_DIR];
  char FName[_MAX_FNAME];
  char Ext[_MAX_EXT];

  strcpy(FullPath,NewFullPath.c_str());
  _splitpath(FullPath,Drive,Dir,FName,Ext);
  NewDrive = Drive;
  NewDir = Dir;
  NewFName = FName;
  NewExt = Ext;
}
//*******************************************************************
string GetExt(string &pathname,bool stripperiod)
{
  string drive;
  string dir;
  string fname;
  string ext;
  SplitUp(pathname,drive,dir,fname,ext);
  if (stripperiod)
  {
    ext = ext.strip(string::Leading,'.');
  }
  return ext;
}
//*******************************************************************
string PullLastDir(string &PathStr)
{
  if (PathStr.is_null()) {return string();}

  // find last \\
  size_t LastSlashPos = PathStr.find_last_of("\\");
  // if none then bail.
  if (LastSlashPos == NPOS) {return string();}
  //if starting \\ then done
  if (LastSlashPos == 0) {return string();}

  // remove last \\
  PathStr.resize(LastSlashPos);
  // find starting point of substr
  LastSlashPos = PathStr.find_last_of("\\");
  //check if slash not found.
  if (LastSlashPos == NPOS)
  {
    if (PathStr.length() == 0) {return string();}
    // for some reason string::find_last_of() doesn't notice slash at pos 0.
    if (PathStr[0] == '\\') {LastSlashPos = 0;}
  }
  // Check if trying to inc past end of string.
  if ((LastSlashPos + 1) >= PathStr.length()) {return string();}
  // Position past slash.
  size_t DirPos = LastSlashPos + 1;
  // get a copy.
  string DirOnly = PathStr.substr(DirPos);
  // remove from PathStr.
  PathStr.resize(DirPos);
  // return Dir name found.
  return DirOnly;
}
//*******************************************************************
bool CreateDir(string NewDir)
// creates full path dir, one subdirectory at a time.
{
  char Drive[_MAX_DRIVE];
  char Path[_MAX_PATH];
  char FName[_MAX_FNAME];
  char Ext[_MAX_EXT];

  string StrArr[MAXDIRSINPATH];

  _splitpath(NewDir.c_str(),Drive,Path,FName,Ext);
  //if (!CheckDrive(Drive)) {return false;}

  string PathStr = Path;
  int LastStr = -1;
  // load up array with end dirs in earliest array positions.
  string Str = PullLastDir(PathStr);
  for (int i = 0;
       !Str.is_null();
       Str = PullLastDir(PathStr),i++)
  {
    StrArr[i] = Str;
    LastStr = i;
  }

  // if no dirs found in string then our job was too easy.
  if (LastStr == -1) {return true;}

  string PathArr[MAXDIRSINPATH];
  // Reorder string array with end dirs at latest array positions.
  int k = 0;
  for (int j = LastStr;
       j >= 0;
       j--,k++)
  {
    PathArr[k] = StrArr[j];
  }

  string tempstr = Drive;
  for (int l = 0;l <= LastStr;l++)
  {
    tempstr += "\\";  // put slashes back in string.
    tempstr += PathArr[l];
    if (!DirExists(tempstr)) // if already exists then ok.
    {
      // if not already exists then make the dir.
      if ((mkdir(tempstr.c_str())) != 0) {return false;}
    }
  }
  return true;
}
//*******************************************************************
int ConvertDriveLetterToInt(string DriveStr)
{
  if (DriveStr.is_null()) {return -1;}
  char D = DriveStr[0];
  return (ConvertDriveLetterToInt(D));
}
//*******************************************************************
int ConvertDriveLetterToInt(char DriveChar)
{
  char TempChar = toupper(DriveChar);
  if (!isalpha(TempChar)) {return -1;}

  int i = toascii(TempChar) - toascii('A') + 1;
  return (i);
}
//*******************************************************************
char ConvertIntToDriveLetter(int DriveInt)
{
  char buffer[17];
  if ((DriveInt > 26) || (DriveInt < 0)) {return 'a';}
  itoa(DriveInt,buffer,10);
  return buffer[0];
}
#endif
//*******************************************************************
#if 0
int32 GetFileSize(string FullPathName)
{
  int handle;
  int32 size;

  if ((handle = open(FullPathName.c_str(),O_RDONLY)) == -1) {return 0;}

  size = filelength(handle);
  close(handle);
  return size;
}
//*******************************************************************
bool CopyFile(string Dest,string Source)
{
  if (!FileExists(Source.c_str())) {return false;}

  int32 size = GetFileSize(Source);
  if (!size) {return false;}
  void *PTemp = GlobalAllocPtr(GMEM_MOVEABLE,size);
  if (PTemp == NULL) {return false;}
  OFSTRUCT ofstruct;
  HFILE SourceHandle;
  HFILE DestHandle;
  if ((SourceHandle = OpenFile(Source.c_str(),&ofstruct,OF_READ)) == HFILE_ERROR)
  {
    GlobalFreePtr(PTemp);
    return false;
  }
  if (_hread(SourceHandle,PTemp,size) != size)
  {
    GlobalFreePtr(PTemp);
    _lclose(SourceHandle);
    return false;
  }
  _lclose(SourceHandle);
  if ((DestHandle = _lcreat(Dest.c_str(),0)) == HFILE_ERROR)
  {
    GlobalFreePtr(PTemp);
    return false;
  }
  #if defined(BI_PLAT_WIN16)
  if (_hwrite(DestHandle,PTemp,size) != size)
  #else
  if (_hwrite(DestHandle,(const char *)PTemp,size) != size)
  #endif
  {
    GlobalFreePtr(PTemp);
    _lclose(DestHandle);
    return false;
  }
  _lclose(DestHandle);
  GlobalFreePtr(PTemp);
  return true;
}
#endif
//*******************************************************************
#if 0
bool DeleteFile(string FullPathName)
{
  return (remove(FullPathName.c_str()) == 0);
}
#endif
//*******************************************************************
#if 0
bool FileExists(const char *FullPathName)
// Tests for existence of file with fully qualified pathname.
{
  // Mike - verify that this works on files already open.
  OFSTRUCT tempOFSTRUCT;
  if (OpenFile(FullPathName,&tempOFSTRUCT,OF_EXIST) == -1)
  {
    return false;
  }
  else
  {
    return true;
  }
}
#endif
//*******************************************************************
#if 0
bool FileExists(string FullPathName)
// Tests for existence of file with fully qualified pathname.
{
  // Mike - verify that this works on files already open.
  OFSTRUCT tempOFSTRUCT;
  if (OpenFile(FullPathName.c_str(),&tempOFSTRUCT,OF_EXIST) == -1)
  {
    return false;
  }
  else
  {
    return true;
  }
}
//*******************************************************************
bool DirExists(string FullDirStr)
{
  string TestStr = FullDirStr;
  // Check if FName + Ext on end of string.
  size_t PeriodPos = TestStr.find(".");
  if (PeriodPos != NPOS)
  {
    size_t SlashPos = TestStr.find_last_of("\\");
    if ((SlashPos != NPOS) && (TestStr.length() > SlashPos))
    {
      TestStr.resize(SlashPos + 1);
    }
  }

  DIR *dir = NULL;
  if ((dir = opendir(TestStr.c_str())) == NULL)
  {
    return false;
  }

  closedir(dir);
  return true;
}
//*******************************************************************
int32 GetFileSize(const char *FileName)
{
  int handle;
  int32 size;

  if ((handle = open(FileName,O_RDONLY)) == -1) {return 0;}

  size = filelength(handle);
  close(handle);
  return size;
}
//*******************************************************************
void *LoadFile(const char *FileName)
{
  int32 size = GetFileSize(FileName);
  if (!size) {return NULL;}

  void *tempPtr = GlobalAllocPtr(GMEM_MOVEABLE,size);

  OFSTRUCT ofstruct;
  HFILE FH;

  if ((FH = OpenFile(FileName,&ofstruct,OF_READ)) == HFILE_ERROR)
  {
    GlobalFreePtr(tempPtr);
    return NULL;
  }

  if (_hread(FH,tempPtr,size) != size)
  {
    GlobalFreePtr(tempPtr);
    _lclose(FH);
    return NULL;
  }

  _lclose(FH);
  return tempPtr;
}
#endif
//*******************************************************************
#if 0
bool LoadFileToBuffer(string FileName,void *Ptr,int32 size,int32 offset)
{
  OFSTRUCT ofstruct;
  HFILE FH;

  if ((FH = OpenFile(FileName.c_str(),&ofstruct,OF_READ)) == HFILE_ERROR) {return false;}
  if (offset != 0)
  {
    _llseek(FH,offset,0);
  }

  if (_hread(FH,Ptr,size) != size)
  {
    _lclose(FH);
    return false;
  }

  _lclose(FH);
  return true;
}
#endif
//*******************************************************************
#if 0
bool WriteFileFromBuffer(string FileName,void *Ptr,int32 size)
{
//  OFSTRUCT ofstruct;
  HFILE HDHandle;

  if ((HDHandle = _lcreat(FileName.c_str(),0)) == HFILE_ERROR) {return false;}

  #if defined(BI_PLAT_WIN16)
  if (_hwrite(HDHandle,Ptr,size) != size)
  #else
  if (_hwrite(HDHandle,(const char *)Ptr,size) != size)
  #endif
  {
    _lclose(HDHandle);
    return false;
  }
  _lclose(HDHandle);
  return true;
}
#endif
//*******************************************************************
static int32 PopFileLength (int hFile)
{
  int32 lCurrentPos = _llseek (hFile, 0L, 1) ;
  int32 lFileLength = _llseek (hFile, 0L, 2) ;

  _llseek (hFile, lCurrentPos, 0) ;

  return lFileLength ;
}
//*******************************************************************
#pragma argsused
int AnyFileRead (HWND hwnd, LPSTR lpstrFileName,
                 HANDLE *hfileBuffer, int32 *fileLength, word bufFlag)
{
  int32   lLength ;
  int    hFile ;
  byte huge *bBuffer ;
  uint BytesRead;

  if (-1 == (hFile = _lopen (lpstrFileName, OF_READ | OF_SHARE_DENY_WRITE)))
    return (1);

  lLength = PopFileLength (hFile);

  if(bufFlag == 0)
    if (NULL == (*hfileBuffer = GlobalAlloc (GHND, lLength)))
    {
      _lclose (hFile);
      return (3);
    }
  if(bufFlag == 1)
    if (NULL == (*hfileBuffer = GlobalAlloc (GPTR, lLength)))
    {
      _lclose (hFile);
      return (3);
    }

    *fileLength = lLength;
    bBuffer = (byte huge *)GlobalLock (*hfileBuffer);
    while(lLength > 65534l)
    {
      BytesRead = _lread (hFile, bBuffer, 65534l);
      bBuffer += BytesRead;
      lLength -= BytesRead;
    }
    _lread (hFile, bBuffer, (word) lLength);
	 _lclose (hFile);

    GlobalUnlock (*hfileBuffer);

    return (0);
}
//*******************************************************************

