//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  ostr.cpp
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     5/3/96     M.Perry     original baseline
//  2.0     8/26/97    M.Perry     32-bit conversion.
//********************************************************************
#include "ostr.h"

//******************* friend functions ******************************
ostream &operator << (ostream &os,const TStr &s)
{
  return os << s.GetP();
}
//*******************************************************************
#if defined(DEBUGTSTR)
int32 TStr::AllocSize = 0;
#endif
//*******************************************************************
void TStr::Assign(const TStr &str)
{
  if (&str != this)
  {
    int16 size = int16(str.Length() + 1);
    FreeP();
    AllocP(size);
    strcpy(PChars,str.PChars);
  }
}
//*******************************************************************
void TStr::Assign(const string &s)
{
  int16 size = int16(strlen(s.c_str()) + 1);
  FreeP();
  AllocP(size);
  strcpy(PChars,s.c_str());
}
//*******************************************************************
void TStr::Assign(const char *pchars)
{
  if (pchars != PChars)
  {
    int16 size = int16(strlen(pchars) + 1);
    FreeP();
    AllocP(size);
    strcpy(PChars,pchars);
  }
}
//*******************************************************************
void TStr::Assign(const char character)
{
  FreeP();
  AllocP(2);
  PChars[0] = character;
  PChars[1] = '\0';
}
//*******************************************************************
void TStr::Append(const TStr &str)
{
  int16 size = int16(Length() + str.Length() + 1);
  char *ptemp = Alloc(size);
  strcpy(ptemp,PChars);
  strcat(ptemp,str.GetP());
  FreeP();
  PChars = ptemp;
}
//*******************************************************************
void TStr::Append(const string &s)
{
  int16 size = int16(Length() + strlen(s.c_str()) + 1);
  char *ptemp = Alloc(size);
  strcpy(ptemp,PChars);
  strcat(ptemp,s.c_str());
  FreeP();
  PChars = ptemp;
}
//*******************************************************************
void TStr::Append(const char *pchars)
{
  int16 size = int16(Length() + strlen(pchars) + 1);
  char *ptemp = Alloc(size);
  strcpy(ptemp,PChars);
  strcat(ptemp,pchars);
  FreeP();
  PChars = ptemp;
}
//*******************************************************************
void TStr::Append(const char character)
{
  int16 size = int16(Length() + 2);
  char *ptemp = Alloc(size);
  strcpy(ptemp,PChars);
  ptemp[Length()] = character;
  FreeP();
  PChars = ptemp;
}
//*******************************************************************
void TStr::Prepend(const TStr &str)
{
  int16 size = int16(Length() + str.Length() + 1);
  char *ptemp = Alloc(size);
  strcpy(ptemp,str.GetP());
  strcat(ptemp,GetP());
  FreeP();
  PChars = ptemp;
}
//*******************************************************************
void TStr::Prepend(const string &s)
{
  int16 size = int16(Length() + strlen(s.c_str()) + 1);
  char *ptemp = Alloc(size);
  strcpy(ptemp,s.c_str());
  strcat(ptemp,GetP());
  FreeP();
  PChars = ptemp;
}
//*******************************************************************
void TStr::Prepend(const char *pchars)
{
  int16 size = int16(Length() + strlen(pchars) + 1);
  char *ptemp = Alloc(size);
  strcpy(ptemp,pchars);
  strcat(ptemp,GetP());
  FreeP();
  PChars = ptemp;
}
//*******************************************************************
void TStr::Prepend(const char character)
{
  int16 size = int16(Length() + 2);
  char *ptemp = Alloc(size);
  ptemp[0] = character;
  ptemp[1] = '\0';
  strcat(ptemp,GetP());
  FreeP();
  PChars = ptemp;
}
//*******************************************************************
TStr::operator const string () const
{
    return string(GetP());
}
//*******************************************************************
TStr operator + (const TStr &str1,const TStr &str2)
{
  TStr str = str1;
  str += str2;
  return str;
}
//*******************************************************************
TStr operator + (const TStr &str1,const string &s2)
{
  TStr str = str1;
  str += s2;
  return str;
}
//*******************************************************************
TStr operator + (const TStr &str1,const char *pchars)
{
  TStr str = str1;
  str += pchars;
  return str;
}
//*******************************************************************
TStr operator + (const TStr &str1,const char character)
{
  TStr str = str1;
  str += character;
  return str;
}
//*******************************************************************

