//****************** **************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  osys.cpp
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  2.0     8/17/97   M.Perry     added win32 support and added cpp file.
//  2.0     8/26/97   M.Perry     32-bit conversion.
//********************************************************************
#if !defined(__osys_h)
#include "osys.h"
#endif

#if !defined(__STDLIB_H)
#include <stdlib.h>
#endif
//*******************************************************************
bool TSys::Initialized = false;
#if defined(BI_PLAT_WIN16)
TIMERINFO TSys::ti = {sizeof(TIMERINFO),0,0};
MEMMANINFO TSys::mmi = {sizeof(MEMMANINFO),0,0,0,0,0,0,0,0,0,0};
#else
MEMORYSTATUS TSys::ms = {sizeof(MEMORYSTATUS),0,0,0,0,0,0,0};
dword TSys::StartMSec = 0;
dword TSys::LastMSec = 0;
dword TSys::MSConst = 0;
bool TSys::MSWrapped = false;
#endif

TSys sysinitobj; // auto initialize class.
//*******************************************************************
void TSys::InitSys()
{
  if (!Initialized)
  {
    RefreshMemInfo();
    #if defined(BI_PLAT_WIN32)
    InitMSec();
    #endif
    Initialized = true;
  }
}
//#pragma startup TSys::InitSys
//*******************************************************************
TSys::TSys()
{
  InitSys(); //just in case startup code didn't work, we should still be ok.
}
//*******************************************************************
TSys::~TSys()
{
}
//*******************************************************************
#if defined(BI_PLAT_WIN32)
void TSys::InitMSec()
{
  StartMSec = ::GetTickCount();
  MSConst = StartMSec;
  LastMSec = StartMSec;
  MSWrapped = false;
  Initialized = true;
}
#endif
//*******************************************************************
#if defined(BI_PLAT_WIN32)
dword TSys::GetMSec()
// note: we start our's at 0 so we can run for 49 days. (dword capacity)
{
  dword ms = ::GetTickCount();
  if (ms >= LastMSec)
  {
    LastMSec = ms;
    if (!MSWrapped)
    {
      return (dword)(ms - MSConst); // normal equation.
    }
    else
    {
      return (dword)(ms + MSConst); // windows system counter wrapped.
    }
  }
  else // wrapped since last call !!
  {
    LastMSec = ms;
    if (ms < StartMSec)
    {
      MSWrapped = true;
      MSConst = (dword_max - StartMSec);
      return (dword)(ms + MSConst);
    }
    else
    {
      // pause all modewindows
      // throw time overflow exception.
      ::MessageBox(NULL,"time overflow","Error",MB_OK|MB_SYSTEMMODAL);
      exit(EXIT_FAILURE);
      return 0;  // dead code.
    }
  }
}
#endif
//*******************************************************************

