//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  odetlist.cpp
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     5/9/96     M.Perry     original baseline
//  2.0     8/26/97    M.Perry     32-bit conversion.
//********************************************************************
#if !defined(__odetlist_h)
#include "odetlist.h"
#endif

#if defined(GED_COMPILE)
#if !defined(__odetldlg_h)
  #include "odetldlg.h"
#endif
#endif

#if !defined(__odet_h)
#include "odet.h"
#endif
//*******************************************************************
TDetList::TDetList()
{
  #if defined(GED_COMPILE)
  PDetListScript = NULL;
  #endif
}
//*******************************************************************
TDetList::~TDetList()
{
}
//*******************************************************************
TDirEntry *TDetList::GetDirEntry(string &pathname)
{
  int16 numdets = GetNumDets();
  for (int16 i=0;i<numdets;i++)
  {
    TDet *pdet = GetDetPtr(i);
    if (pdet != NULL)
    {
      TDirEntry *pdirentry = pdet->GetDirEntry(pathname);
      if (pdirentry != NULL) {return pdirentry;}
    }
  }
  return NULL;
}
//*******************************************************************
void TDetList::ReleaseUnUsed()
// wrapped in while loop because if one removed then indexes change for
// rest of tdets in list, so we start over again when we remove one.
{
  bool out = false;
  while (!out)
  {
    bool removed = false;
    for (int16 i=0;i<GetNumDets();i++)
    {
      TDet *pdet = GetDetPtr(i);
      if (pdet != NULL)
      {
        if (pdet->GetUsage() == 0)
        {
          RemoveDet(i);
          removed = true; // do while loop again.
          break; // break out of for loop.
        }
      }
    }// for
    if (!removed) {out = true;} // if !removed then kick out of while loop.
  }// while
}
//*******************************************************************
#if defined(GED_COMPILE)
void TDetList::DoDlg(TWindow *pwin)
{
  TDetListDlg *pdld = new TDetListDlg(this,pwin);
  pdld->Execute();
  delete pdld;
  pdld = NULL;
}
#endif
//*******************************************************************
#if defined(GED_COMPILE)
void TDetList::Edit(TWindow *pwin,string &hddrive,string &hddir,string &appname)
{
  HDDrive = hddrive;
  HDDir = hddir;
  CreateDetListScript(hddrive,hddir,appname);
  DoDlg(pwin);
  DestroyDetListScript();
}
#endif
//*******************************************************************
#if defined(GED_COMPILE)
void TDetList::CreateDetListScript(string &hddrive,string &hddir,string &appname)
{
  PDetListScript = new TDetListScript(hddrive,hddir,appname);
  PDetListScript->Initialize();
}
#endif
//*******************************************************************
#if defined(GED_COMPILE)
void TDetList::DestroyDetListScript()
{
  if (PDetListScript != NULL)
  {
    PDetListScript->DeInitialize();
    delete PDetListScript;
    PDetListScript = NULL;
  }
}
#endif
//*******************************************************************
#if defined(GED_COMPILE)
void TDetList::CreateAll(TWindow *pwin)
{
  for (int16 i=0;i<GetNumNames();i++)
  {
    Create(pwin,i);
  }
}
#endif
//*******************************************************************
#if defined(GED_COMPILE)
void TDetList::CreateAll(TDetListDlg *pdlg)
{
  for (int16 i=0;i<GetNumNames();i++)
  {
    Create(pdlg,i);
  }
}
#endif
//*******************************************************************
#if defined(GED_COMPILE)
void TDetList::Create(TWindow *pwin,int16 index)
{
  string desname = GetName(index);
  string dest = GetDest();
  TDet *pdet = new TDet;
  pdet->Create(pwin,HDDrive,HDDir,desname,dest);
  delete pdet;
}
#endif
//*******************************************************************
#if defined(GED_COMPILE)
void TDetList::Create(TDetListDlg *pdlg,int16 index)
{
  string desname = GetName(index);
  string s = "Creating: ";
  s += desname;
  pdlg->SetStatus2(s);
  string dest = GetDest();
  TDet *pdet = new TDet;
  pdet->Create(pdlg,HDDrive,HDDir,desname,dest);
  delete pdet;
  s = "Done creating: ";
  s += desname;
  pdlg->SetStatus2(s);
}
#endif
//*******************************************************************
#if defined(GED_COMPILE)
void TDetList::EditDes(TWindow *pwin,int16 index)
{
  string desname = GetName(index);
  TDet *pdet = new TDet;
  pdet->Edit(pwin,HDDrive,HDDir,desname);
  delete pdet;
}
#endif
//*******************************************************************

