//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  odetlscr.cpp
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     5/9/96     M.Perry     original baseline
//  2.0     8/26/97    M.Perry     32-bit conversion.
//********************************************************************
#include "odetlscr.h"

#define DETLISTSCRIPTEXT ".dsl"
#define INFOSECTION "info"
#define NAMESSECTION "name"
#define NUMKEY "num"
#define DESTKEY "dest"
//*******************************************************************
TDetListScript::TDetListScript(string &hddrive,string &hddir,string &filename)
{
  HDDrive = hddrive;
  HDDrive.to_lower();
  HDDir = hddir;
  HDDir.to_lower();
  FileName = filename;
  FileName.to_lower();
  FileNameandExt = FileName + DETLISTSCRIPTEXT;
  PScript = NULL;
  Initialized = false;
  NumDets = 0;
  Source = HDDrive + HDDir;
}
//*******************************************************************
TDetListScript::~TDetListScript()
{
  if (Initialized) {DeInitialize();}
}
//*******************************************************************
void TDetListScript::Initialize()
{
  CreateScript();
  Read();
  Initialized = true;
}
//*******************************************************************
void TDetListScript::DeInitialize()
{
  if (Initialized) {Write();}
  DestroyScript();
  Initialized = false;
}
//*******************************************************************
bool TDetListScript::Read()
{
  ReadInfo();
  ReadNames();
  return true;
}
//*******************************************************************
bool TDetListScript::Write()
{
  WriteInfo();
  WriteNames();
  return true;
}
//*******************************************************************
bool TDetListScript::ReadInfo()
{
  Dest = PScript->ReadString(INFOSECTION,DESTKEY,"");
  NumDets = (int16)PScript->ReadInt(INFOSECTION,NUMKEY,0);
  return true;
}
//*******************************************************************
bool TDetListScript::WriteInfo()
{
  PScript->WriteString(INFOSECTION,DESTKEY,Dest);
  PScript->WriteInt(INFOSECTION,NUMKEY,NumDets);
  return true;
}
//*******************************************************************
bool TDetListScript::ReadNames()
{
  for (int16 i=0;i<NumDets;i++)
  {
    DetScriptNames[i] = PScript->ReadString(NAMESSECTION,i,"");
  }
  return true;
}
//*******************************************************************
bool TDetListScript::WriteNames()
{
  for (int16 i=0;i<NumDets;i++)
  {
    PScript->WriteString(NAMESSECTION,i,DetScriptNames[i]);
  }
  return true;
}
//*******************************************************************
void TDetListScript::CreateScript()
{
  PScript = new TIniFile(HDDrive,HDDir,FileNameandExt);
}
//*******************************************************************
void TDetListScript::DestroyScript()
{
  delete PScript;
  PScript = NULL;
}
//*******************************************************************
void TDetListScript::AddName(string &name)
{
  DetScriptNames[NumDets] = name;
  NumDets++;
}
//*******************************************************************
void TDetListScript::RemoveName(int16 index)
{
  string *tempnames = new string[100];
  int16 counter = 0;
  for (int16 i=0;i<NumDets;i++)
  {
    if (i != index)
    {
      tempnames[counter] = DetScriptNames[i];
      counter++;
    }
  }
  NumDets--;
  for (int16 j=0;j<NumDets;j++)
  {
    DetScriptNames[j] = tempnames[j];
  }
  delete [] tempnames;
}
//*******************************************************************

