//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  owmixdll.cpp
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     11/6/96    M.Perry     original baseline
//  2.0      8/23/97   M.Perry     32-bit conversion.
//********************************************************************
#include "owmixdll.h"
//*******************************************************************
TWaveMix *TWaveMix::PWaveMix = NULL;
//*******************************************************************
bool TWaveMix::LoadDll()
{
  if (Dll() == NULL) {PWaveMix = new TWaveMix;}
  if (PWaveMix->Load()) {return true;}
  delete PWaveMix;
  PWaveMix = NULL;
  return false;
}
//*******************************************************************
bool TWaveMix::UnLoadDll(bool ignoreRef)
{
  if (Dll() == NULL) {return true;}
  PWaveMix->UnLoad();

  if (PWaveMix->IsInitialized() && ignoreRef)
  {
    PWaveMix->DeInitialize();
  }
  if (!PWaveMix->IsInitialized())
  {
    delete PWaveMix;
    PWaveMix = NULL;
  }
  return true;
}
//*******************************************************************
TWaveMix::TWaveMix()
  #if defined(BI_PLAT_WIN32)
  :TOgleDll("owmix32.dll")
  #else
  :TOgleDll("wavmix16.dll")
  #endif
{
  CleanupProcs();
}
//*******************************************************************
TWaveMix::~TWaveMix()
{
}
//*******************************************************************
bool TWaveMix::SetupProcs()
{
  if (!CheckInstance()) {return false;}

  GetInfo = (wavemixgetinfo)GetProcAddress("WaveMixGetInfo");
  if (GetInfo == NULL) {return false;}

  Init = (wavemixinit)GetProcAddress("WaveMixInit");
  if (Init == NULL) {return false;}

  ConfigureInit = (wavemixconfigureinit)GetProcAddress("WaveMixConfigureInit");
  if (ConfigureInit == NULL) {return false;}

  Activate = (wavemixactivate)GetProcAddress("WaveMixActivate");
  if (Activate == NULL) {return false;}

  OpenWave = (wavemixopenwave)GetProcAddress("WaveMixOpenWave");
  if (OpenWave == NULL) {return false;}

  OpenChannel = (wavemixopenchannel)GetProcAddress("WaveMixOpenChannel");
  if (OpenChannel == NULL) {return false;}

  Play = (wavemixplay)GetProcAddress("WaveMixPlay");
  if (Play == NULL) {return false;}

  FlushChannel = (wavemixflushchannel)GetProcAddress("WaveMixFlushChannel");
  if (FlushChannel == NULL) {return false;}

  CloseChannel = (wavemixclosechannel)GetProcAddress("WaveMixCloseChannel");
  if (CloseChannel == NULL) {return false;}

  FreeWave = (wavemixfreewave)GetProcAddress("WaveMixFreeWave");
  if (FreeWave == NULL) {return false;}

  CloseSession = (wavemixclosesession)GetProcAddress("WaveMixCloseSession");
  if (CloseSession == NULL) {return false;}

  Pump = (wavemixpump)GetProcAddress("WaveMixPump");
  if (Pump == NULL) {return false;}

  return true;
}
//*******************************************************************
bool TWaveMix::CleanupProcs()
{
  GetInfo = NULL;
  Init = NULL;
  ConfigureInit = NULL;
  Activate = NULL;
  OpenWave = NULL;
  OpenChannel = NULL;
  Play = NULL;
  FlushChannel = NULL;
  CloseChannel = NULL;
  FreeWave = NULL;
  CloseSession = NULL;
  Pump = NULL;
  return true;
}
//*******************************************************************