//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  ogamefw.cpp
//    Project Name:  Ogle
// Original Author:  Michael R. Perry                   
//                                 
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     02/27/95   M. Perry    original baseline
//  2.0     08/29/97   M.Perry     32-bit conversion.
//  2.2     06/01/99   M.Perry     fixed focus problem,
//          06/08/99   M.Perry     missing scanlines
//********************************************************************
#if !defined(__ogamefw_h)
#include "ogamefw.h"
#endif

//#if !defined(__COMPLEX_H)
//#include <complex.h>
//#endif

#if !defined(__omodewin_h)
#include "omodewin.h"
#endif

#if !defined(__ofilemgr_h)
#include "ofilemgr.h"
#endif

#if !defined(__oplaymgr_h)
#include "oplaymgr.h"
#endif

//#if !defined(__oapp_h)
//#include "oapp.h"
//#endif

#if !defined(__oapp_rh)
#include "oapp.rh"
#endif

#if !defined(__osplash_rh)
#include "osplash.rh"
#endif

#if !defined(__osplash_h)
#include "osplash.h"  // MRP - 06/27/99 - v2.3 moved from .h
#endif

#if !defined(__expert_h)
#include "expert.h"
#endif

#if !defined(__osndmgr_h)
#include "osndmgr.h"
#endif

#if !defined(__omodewin_h)
#include "omodewin.h"
#endif

#if !defined(__oplaymgr_h)
#include "oplaymgr.h"
#endif

#if !defined(__ogame_h)
#include "ogame.h"
#endif

#if !defined(__owingdll_h)
#include "owingdll.h"
#endif
//*******************************************************************
void TOgleMenuEnable::SetAll(bool value)
{
  Exit = value;
  FX = value;
  Music = value;
  About = value;
  Contents = value;

  SetModes(value);
}
//*******************************************************************
#pragma argsused
void TOgleMenuEnable::SetModes(bool value)
{
  // do nothing.
}
//*******************************************************************
TOgleMenuEnable::TOgleMenuEnable(bool setvalues)
:CurrentMode(-1),
 PrevMode(-1)
{
  if (setvalues)
  {
    SetAll(true);
  }
}
//*******************************************************************
TOgleMenuEnable::~TOgleMenuEnable()
{
}
//*******************************************************************
//*******************************************************************
DEFINE_RESPONSE_TABLE1(TOgleGameFrameWindow,TFrameWindow)
  EV_MESSAGE(ID_OM_OGLEMSG,ReceiveOgleMsg),
  EV_MESSAGE(WM_ENTERMENULOOP,EvEnterMenuLoop),
  EV_MESSAGE(WM_EXITMENULOOP,EvExitMenuLoop),
  EV_WM_GETMINMAXINFO,
  EV_COMMAND(CM_SHOWMENU,CmShowMenu),
  EV_COMMAND(CM_FMGR_TOGGLEHDBUFFERING,CmFMgrToggleHDBuffering),
  EV_COMMAND_ENABLE(CM_FMGR_TOGGLEHDBUFFERING,CeFMgrToggleHDBuffering),
  EV_WM_ACTIVATE,
  EV_WM_SETFOCUS,
  EV_WM_KILLFOCUS,
  EV_WM_PALETTECHANGED,
  EV_WM_QUERYNEWPALETTE,
  EV_WM_SIZE,
  EV_WM_TIMER,
  EV_WM_COMPACTING,
  EV_WM_ACTIVATEAPP,
  EV_WM_ERASEBKGND,
  EV_WM_TIMECHANGE,
END_RESPONSE_TABLE;
//*******************************************************************
void TOgleGameFrameWindow::NotifyDenomSwitch(TMoney denom)
{
}
//*******************************************************************
void TOgleGameFrameWindow::CmExit()
{
  if (IsFlagSet(wfMainWindow))
  {
    CloseWindow();
  }
  else
  {
    DefaultProcessing();
  }
}
//*******************************************************************
#pragma argsused
LRESULT TOgleGameFrameWindow::EvEnterMenuLoop(WPARAM wparam,LPARAM lparam)
{
  MenuLoopEntered = true;
  bool result = HandleEnterMenuLoop((bool)wparam);
//  if (result) {return 0l;}
  return DefaultProcessing();
}
//*******************************************************************
#pragma argsused
LRESULT TOgleGameFrameWindow::EvExitMenuLoop(WPARAM wparam,LPARAM lparam)
{
  MenuLoopEntered = false;
  bool result = HandleExitMenuLoop((bool)wparam);
//  if (result) {return 0l;}
  return DefaultProcessing();
}
//*******************************************************************
#pragma argsused
bool TOgleGameFrameWindow::HandleEnterMenuLoop(bool ispopup)
{
  return true;
}
//*******************************************************************
#pragma argsused
bool TOgleGameFrameWindow::HandleExitMenuLoop(bool ispopup)
{
  return true;
}
//*******************************************************************
int TOgleGameFrameWindow::GetMenuID()
{
  return 0;
}
//*******************************************************************
TModule *TOgleGameFrameWindow::GetMenuModule()
{
//  return GetOgleApp();
  return TOgleApp::GetOgleApp();
}
//*******************************************************************
void TOgleGameFrameWindow::SetToDefMenu()
{
  SwitchMenu(GetMenuID(),GetMenuModule());
}
//*******************************************************************
//bool TOgleGameFrameWindow::IsPGameValid()
//{
//  return (POgleApp->PGame != NULL);
//  return bool(GetGame() != NULL);
//}
//*******************************************************************
//TOgleGame *TOgleGameFrameWindow::GetPGame()
//{
//  return POgleApp->PGame;
//  return GetGame();
//}
//*******************************************************************
void TOgleGameFrameWindow::SetCursorData(TCursorData &cd,bool check)
// could possibly take out check parameter, used by filemgr.
// or might still need when multiple modewin's are active at same time.
{
  if (MenuLoopEntered) {return;} // don't change cursor while in menu loop.

  if (PModeWin != NULL)
  {
    PModeWin->SetCursorData(cd,check);
  }
  else
  {
    if (check)
    {
      TPoint pt;
      GetCursorPos(pt);
      HWND hw = WindowFromPoint(pt);
      if (hw != HWindow) {return;}
    }
    if (!SetCursor(cd.PModule,cd.ResId))
    {
      ::SetCursor(HCursor);
    }
  }
}
//*******************************************************************
void TOgleGameFrameWindow::CreateMenuEnable()
{
  PMenuEnable = new TOgleMenuEnable(true);
}
//*******************************************************************
void TOgleGameFrameWindow::DestroyMenuEnable()
{
  if (PMenuEnable != NULL)
  {
    delete PMenuEnable;
    PMenuEnable = NULL;
  }
}
//*******************************************************************
void TOgleGameFrameWindow::EvTimeChange()
{
  TimeChanged();
}
//*******************************************************************
void TOgleGameFrameWindow::TimeChanged()
{
  if (GetModeWin() != NULL)
  {
    GetModeWin()->TimeChanged();
  }
}
//*******************************************************************
bool TOgleGameFrameWindow::Help(uint command,uint32 data)
{
  return GetOgleApp()->Help(command,data);
//  return TOgleApp::GetOgleApp()->Help(command,data);
}
//*******************************************************************
bool TOgleGameFrameWindow::SwitchMenu(TResId resId,TModule *pmodule)
{
  TModule *PModule = pmodule;
  if (PModule == NULL)
  {
    PModule = GetOgleApp();
//    PModule = TOgleApp::GetOgleApp();
  }

  if (resId != Attr.Menu) {
    if (Attr.Menu.IsString())
      delete (char far*)Attr.Menu;

    Attr.Menu = resId.IsString() ? strnewdup(resId) : (char far*)resId;
  }

  // if the window has been created then load and set the new menu and destroy
  // the old menu
  //
  if (!HWindow)
    return true;

  HMENU curMenu = GetMenu();
  HMENU newMenu = PModule->LoadMenu(Attr.Menu);

  if (!SetMenu(newMenu))
    return false;

  if (curMenu)
    ::DestroyMenu(curMenu);

  return true;
}
//*******************************************************************
void TOgleGameFrameWindow::ShowMenu(bool show)
{
  if (!HandleShowMenu) {return;}
  if (show != MenuShowing) {CmShowMenu();}
}
//*******************************************************************
string TOgleGameFrameWindow::GetResString(uint id)
{
//  return GetOgleApp()->LoadString(id);
  return TAppString(id);
}
//*******************************************************************
void TOgleGameFrameWindow::GetWindowClass(WNDCLASS& wndClass)
{
  TFrameWindow::GetWindowClass(wndClass);
  wndClass.hCursor = 0;
  #if !defined(GED_COMPILE)
  wndClass.style &= ~CS_DBLCLKS;
  #endif
}
//*******************************************************************
#pragma argsused
bool TOgleGameFrameWindow::EvEraseBkgnd(HDC hDC)
{
  if (!m_bIsMinimized) {return true;}
  return TFrameWindow::EvEraseBkgnd(hDC);
}
//*******************************************************************
#pragma argsused
void TOgleGameFrameWindow::EvActivateApp(bool active,HTASK hTask)
{
  if (active) {Activate();}
  else {DeActivate();}
}
//*******************************************************************
void TOgleGameFrameWindow::Activate(bool mwCaller)
{
  if (m_bIsMinimized) {return;}

  Active = true;
  if (!mwCaller)
  {
    SetRes();
    if (PModeWin != NULL) {PModeWin->Activate();}
    else
    {
      GetFileMgr()->Activate();
      if (GetSoundMgr() != NULL) {GetSoundMgr()->Activate();}
    }
  }
  else
  {
    GetFileMgr()->Activate();
    if (GetSoundMgr() != NULL) {GetSoundMgr()->Activate();}
  }
}
//*******************************************************************
void TOgleGameFrameWindow::DeActivate(bool mwCaller)
{
  Active = false;
  if (!mwCaller)
  {
    if (PModeWin != NULL) {PModeWin->DeActivate();}
    else
    {
      if (GetSoundMgr() != NULL) {GetSoundMgr()->DeActivate();}
      GetFileMgr()->DeActivate();
    }
  }
  else
  {
    if (GetSoundMgr() != NULL) {GetSoundMgr()->DeActivate();}
    GetFileMgr()->DeActivate();
  }
}
//*******************************************************************
LRESULT TOgleGameFrameWindow::ReceiveOgleMsg(WPARAM wparam,LPARAM lparam)
{
   TOgleMsg msg(wparam,lparam);
   HandleOgleMsg(msg);
   return (LRESULT)1;
}
//*******************************************************************
void TOgleGameFrameWindow::HandleOgleMsg(TOgleMsg &msg)
{
  switch (msg.GetMT())
  {
    case ID_MT_SWITCHCLIENTS:HandleSwitchClients(msg);break;
    default:break;
  }
}
//*******************************************************************
void TOgleGameFrameWindow::HandleSwitchClients(TOgleMsg &msg)
{
  if (msg.GetSMT() & ID_SMT1_SWITCHMODES)
  {
    HandleSwitchModes(msg);
  }
}
//*******************************************************************
void TOgleGameFrameWindow::HandleSwitchModes(TOgleMsg &msg)
{
  if (msg.GetSMT() & ID_SMT1_DATA_IDCODE)
  {
    HandleSwitchModesIDCode(TSwToModeIDCodeMsg(msg));
  }
  else
  {
    if (GetGame() == NULL) {return;}
    int16 modeindex;
    if (msg.GetSMT() & ID_SMT1_DATA_RESID)
    {
      string str = GetResString(uint(msg.GetData()));
      modeindex = GetGame()->GetModeIndex(str);
    }
    else
    {
      modeindex = (int16)msg.GetData();
    }
    SwitchModes(modeindex);
  }
}
//*******************************************************************
void TOgleGameFrameWindow::HandleSwitchModesIDCode(TSwToModeIDCodeMsg &msg)
{
  WORD idcode = msg.GetIDCode();
  WORD sidcode = msg.GetSIDCode();
  SwitchModesID(idcode,sidcode);
}
//*******************************************************************
void TOgleGameFrameWindow::SwitchModesID(WORD idcode,WORD sidcode)
{
  string s = "Unhandled SwitchModes.\nIDCode: ";
  char buffer[35];
  ultoa(idcode,buffer,10);
  s += buffer;
  ultoa(sidcode,buffer,10);
  s += "\nSIDCode: ";
  s += buffer;
  s += ".";
  MessageBox(s.c_str(),"Error - FrameWindow",MB_OK);
}
//*******************************************************************
void TOgleGameFrameWindow::EvCompacting(uint compactRatio)
{
  bool now = false;
  if (PModeWin != NULL) {now = PModeWin->GetUpdatePause();}
  GetFileMgr()->NotifyCompacting(compactRatio,now);
}
//*******************************************************************
void TOgleGameFrameWindow::DisplayExpert(string str,bool pause)
{
  if (pause && PModeWin != NULL) {PModeWin->SetUpdatePause();}

  TAskTheExpertDialog aed(str,this);
  aed.Execute();

  if (pause && PModeWin != NULL) {PModeWin->ClearUpdatePause();}
}
//*******************************************************************
bool TOgleGameFrameWindow::IsPlayerChangeOk()
{
  if (PModeWin == NULL) {return true;}
  return (PModeWin->IsPlayerChangeOk());
}
//*******************************************************************
void TOgleGameFrameWindow::NotifyModePlayerActivation(int16 slotnum)
{
  if (PModeWin == NULL) {return;}
  PModeWin->NotifyModePlayerActivation(slotnum);
}
//*******************************************************************
void TOgleGameFrameWindow::NotifyModePlayerDeActivation(int16 slotnum)
{
  if (PModeWin == NULL) {return;}
  PModeWin->NotifyModePlayerDeActivation(slotnum);
}
//*******************************************************************
bool TOgleGameFrameWindow::CanCloseClientW()
{
  TWindow *pw = GetClientWindow();
  if (pw == NULL) {return true;}
  return pw->CanClose();
}
//*******************************************************************
void TOgleGameFrameWindow::SwitchClientW(bool IsMW,int16 mi,int16 action)
{
  if (!CanCloseClientW()) {return;}
  ReleaseClientW();
  HandleOldClientW(IsMW,mi,action);
  TWindow *PWin = CreateNewClientW(IsMW,mi,action);
  SetClientW(PWin);
  HandleNewClientW(IsMW,mi,action);
}
//*******************************************************************
void TOgleGameFrameWindow::ReleaseClientW()
{
  POldClientWin = SetClientWindow(NULL);
}
//*******************************************************************
#pragma argsused
void TOgleGameFrameWindow::HandleOldClientW(bool IsMW,int16 mi,int16 action)
{
  if (POldClientWin == PModeWin && PModeWin != NULL)
  {
//    delete PModeWin;
    PModeWin->Destroy();                 // just added.
//    GetApplication()->Condemn(PModeWin);     // just added.
    GetOgleApp()->Condemn(PModeWin);

    PModeWin = NULL;
    POldClientWin = NULL;
  }
}
//*******************************************************************
#pragma argsused
TWindow *TOgleGameFrameWindow::CreateNewClientW(bool IsMW,int16 mi,int16 action)
{
  if (IsMW)
  {
    CreateModeWindow(mi);
	 return PModeWin;
  }
  return PModeWin;
}
//*******************************************************************
void TOgleGameFrameWindow::SetClientW(TWindow *pw)
{
  POldClientWin = SetClientWindow(pw);
}
//*******************************************************************
#pragma argsused
void TOgleGameFrameWindow::HandleNewClientW(bool IsMW,int16 mi,int16 action)
{
  if (IsMW)
  {
    ShowMenu(false);
    if (PModeWin != NULL)
    {
      PModeWin->Initialize(0); // Key step here. Also, if already init'd then nothing happens.
      PModeWin->BeenSwitchedTo();
    }
  }
}
//*******************************************************************
TOgleGameFrameWindow::TOgleGameFrameWindow(TOgleApp *papp,string title,
                                           bool shrinkToClient ,bool doResources)
:TFrameWindow(0,title.c_str(),0,shrinkToClient),
 PSplashScreen(NULL),
 PMenuEnable(NULL),
 MenuLoopEntered(false),
 IntroUserSkipped(false),
 idsIntro(0),
 ModeInfoInitialized(false),
 ModeStringsInitialized(false),
 ModeIDSInitialized(false),
 ModeIndexesInitialized(false)

// POgleApp(TOgleApp::GetOgleApp()),
// PFileMgr(NULL),
// PGame(NULL)
{
  Initialized = false;
//  POgleApp = papp;
//  if (POgleApp == NULL) {POgleApp = TOgleApp::GetOgleApp(true);}
//  PFileMgr = GetOgleApp()->GetFileMgr();
//  POgleApp = TOgleApp::GetOgleApp();

//  if (POgleApp != NULL)
//  {
//    PFileMgr = POgleApp->GetFileMgr();
//    PGame = POgleApp->GetGame();
//  }

	if (doResources)
	{
	  DoStyle();
	  DoIcon();
	  DoMenu();
	}
   MaxFX = false;//true;

   // MRP - 08/02/99 - v2.3 - future: do RT check for Win 3.x, "allow = is win3x"
	m_AllowIconAnimation = false;//true;//set to false to disable the animated minimized icon
   m_bIsMinimized = false;
	StartupModeIndex = -1;
	PSoundMgr = NULL;
	PModeWin = NULL;
	POldClientWin = NULL;
	Attr.AccelTable = TResId(ACCELERATORS_1);//the keys are hot
   MenuShowing = false;
   HandleShowMenu = true;
   FadeIn = false;
}//end constructor
//*******************************************************************
TOgleGameFrameWindow::~TOgleGameFrameWindow()
{
  DeInitialize();
}
//*******************************************************************
void TOgleGameFrameWindow::SetupModeStrings()
{
  ModeStringsInitialized = true;
}
//*******************************************************************
void TOgleGameFrameWindow::SetupModeIDS()
{
  ModeIDSInitialized = true;
}
//*******************************************************************
void TOgleGameFrameWindow::SetupModeIndexes()
{
  ModeIndexesInitialized = true;
}
//*******************************************************************
void TOgleGameFrameWindow::SetupModeInfo()
{
  if (ModeInfoInitialized) {return;}
  SetupModeIDS();
  SetupModeStrings();
  SetupModeIndexes();
  ModeInfoInitialized = true;
}
//*******************************************************************
bool TOgleGameFrameWindow::Initialize()
{
  if (IsInitialized()) {return true;}
  CreateMenuEnable();
  SetupModeInfo();
  int X,Y,W,H;
  GetXYWH(X,Y,W,H);//make screen 640 * 480 and centered
  Attr.X = X;
  Attr.Y = Y;
  Attr.W = W;
  Attr.H = H;
  Initialized = true;
  return true;
}
//*******************************************************************
bool TOgleGameFrameWindow::DeInitialize()
{
  if (!IsInitialized()) {return true;}
  DestroyMenuEnable();
  Initialized = false;
  return true;
  // do nothing for now.
}
//*******************************************************************
bool TOgleGameFrameWindow::SwitchModes(int16 modeindex)
{
  if (IsValidModeIndex(modeindex))
  {
    if (PModeWin != NULL) {PModeWin->UpdateWindow();} //clear up any menu residue before switch.

    SwitchClientW(true,modeindex);
    return true;
  }
  else
  {
	 return false;
  }
}
//*******************************************************************
#pragma argsused
TWindow *TOgleGameFrameWindow::CreateModeWindow(int16 ModeIndex)
{
  TOgleApp *papp = TOgleApp::GetOgleApp();
  TPal *ppal = NULL;
  if (papp != NULL) {ppal = papp->PMasterPalette;}
  PModeWin = new TOgleModeWindow(papp,
                                 this,
                                 "defmode",
											ppal,
											"Default Mode Window");
  return PModeWin;
}
//*******************************************************************
void TOgleGameFrameWindow::CreateSoundMgr()
{
  WARN((PSoundMgr != NULL),"Tried to create SoundMgr when already exists");
  if (PSoundMgr != NULL) {return;}
  PSoundMgr = new TOgleSoundMgr(this);
//  TOgleApp::GetOgleApp()->SetSoundMgr(PSoundMgr);
}
//*******************************************************************
void TOgleGameFrameWindow::DestroySoundMgr()
{
//  TOgleApp::GetOgleApp()->SetSoundMgr(NULL);
  delete PSoundMgr;
  PSoundMgr = NULL;
}
//*******************************************************************
string TOgleGameFrameWindow::GetDriveDir()
{
  string DriveDir = GetFileMgr()->PHDD->GetDrive();
  DriveDir += GetFileMgr()->PHDD->GetDir();
  return DriveDir;
}
//*******************************************************************
void TOgleGameFrameWindow::CreatePlayerMgr()
{
  PlayerMgr = new TPlayerMgr(this,GetDriveDir());
}
//*******************************************************************
void TOgleGameFrameWindow::DestroyPlayerMgr()
{
  delete PlayerMgr;
  PlayerMgr = NULL;
}
//*******************************************************************
bool TOgleGameFrameWindow::CanClose()
{
  TRACE("gfw: canclose start");
  bool rc = TFrameWindow::CanClose();
  #ifndef NOASKQUIT
  if (rc)
  {
    rc = (MessageBox(NULL,
                     "Are you sure you want to quit ?",
                     "Don't leave!!",
                     MB_YESNO | MB_ICONHAND | MB_SYSTEMMODAL)== IDYES);
  }
  #endif
  TRACE("gfw: canclose end");
  return rc;
}
//*******************************************************************
void TOgleGameFrameWindow::CmPlayerManagementDlg()
{
  if (PlayerMgr == NULL)
  {
    MessageBox("Player Manager doesn't exist","Error - Player Management",MB_OK);
    return;
  }

  // pause mw.
  bool waspaused = false;
  if (PModeWin != NULL)
  {
    waspaused = PModeWin->GetUpdatePause();
    PModeWin->SetUpdatePause();
    GetSoundMgr()->Stop(true);
  }

  PlayerMgr->DoManagementDialog();

  // if wasn't prev paused before then clear pause.
  if (PModeWin != NULL && !waspaused)
  {
    PModeWin->ClearUpdatePause();
  }
}
//*******************************************************************
void TOgleGameFrameWindow::CreateSplash()
{
   PSplashScreen = new TSplashDlg(IDB_SPLASH_FOR_1024x768,
                                  IDB_SPLASH_FOR_800x600,
                                  IDB_SPLASH_FOR_640x480);
   PSplashScreen->Create();
}
//*******************************************************************
void TOgleGameFrameWindow::DestroySplash()
{
  if (PSplashScreen != NULL)
  {
    PSplashScreen->Destroy();
    TOgleApp::GetOgleApp()->Condemn(PSplashScreen);
    PSplashScreen = NULL;
  }
}
//*******************************************************************
void TOgleGameFrameWindow::SetupVideo()
{
  TOgleWinG::LoadDll();
}
//*******************************************************************
void TOgleGameFrameWindow::CleanupVideo()
{
  TOgleWinG::UnLoadDll(true);
}
//*******************************************************************
void TOgleGameFrameWindow::SetupWindow()
{
  TFrameWindow::SetupWindow();

  CreateSplash();

  SetupVideo();

  CreatePlayerMgr();

  CreateSoundMgr();

  SwitchClientW(true,StartupModeIndex);

  DestroySplash(); // MRP - 06/27/99 - v2.3 moved from omw to here.
}
//*******************************************************************
void TOgleGameFrameWindow::CleanupWindow()
{
  // Make sure current client window is deleted.
  ReleaseClientW();
  HandleOldClientW(true,0,0);

  DestroySoundMgr();

//  DestroySplash(); // MRP - 06/27/99 - v2.3 removed because now called
                     //                  by this in Setupwindow() after
                     //                  mode creation.

  DestroyPlayerMgr();

  CleanupVideo();

  TFrameWindow::CleanupWindow();
}
//*******************************************************************
bool TOgleGameFrameWindow::IsValidModeIndex(int16 NewModeIndex)
{
  if (GetGame() == NULL || //!IsPGameValid() ||
      NewModeIndex < 0 ||
      NewModeIndex >= GetGame()->GetNumModes())
  {
    return false;
  }
  return true;
}
//*******************************************************************
void TOgleGameFrameWindow::DoStyle()
{
  Attr.Style |= WS_BORDER | WS_CAPTION | WS_CLIPCHILDREN |
                WS_MINIMIZEBOX | WS_SYSMENU | WS_VISIBLE;
  Attr.Style &= ~(WS_CHILD | WS_MAXIMIZEBOX | WS_THICKFRAME);
}
//*******************************************************************
void TOgleGameFrameWindow::DoIcon()
{
  SetIcon(GetApplication(), IDI_SDIAPPLICATION); //this is now the same as Genie00
}
//*******************************************************************
void TOgleGameFrameWindow::DoMenu()
{
//  AssignMenu(SDI_MENU);
}
//*******************************************************************
void TOgleGameFrameWindow::DoAccel()
{
	/*Attr.AccelTable = SDI_MENU;*/
}
//*******************************************************************
void TOgleGameFrameWindow::GetXYWH(int& X,int& Y,int& W,int& H)
{
  int x_res, y_res, winframe_x, winframe_y,menu_ht, title_ht, scroll_x, scroll_y;
 //get our windows parameters!!!!!!!
 //this is where we can control our window sizes and locations
 GetScreenMetrics(& x_res,& y_res,& winframe_x,& winframe_y,
                  &menu_ht,&title_ht,&scroll_x,&scroll_y);

 TSize clientsize;
 if (PModeWin != NULL)
 {
   clientsize.cx = PModeWin->Attr.W;
   clientsize.cy = PModeWin->Attr.H;
 }
 else
 {
   TOgleAppInfo appinfo;
   TOgleApp::GetOgleApp()->GetAppInfo(appinfo);
   clientsize = appinfo.MinDisplaySize;
 }

 X = ((x_res - clientsize.cx)/2) - winframe_x;
 Y = -(winframe_y + title_ht + /*added*/menu_ht) + ((y_res - clientsize.cy) / 2);
 W = clientsize.cx + (2 * winframe_x);
 H = clientsize.cy + menu_ht + title_ht + (2 * winframe_y);
}
//*******************************************************************
void TOgleGameFrameWindow::EvGetMinMaxInfo(MINMAXINFO far& lpmmi)
{
	//this fn will be called (by MS Windows) when the window is moved
	//we do not want the screen resolution to be a limit on our window size
	//as then can not move the window beyond the dimensions of the screen.
	//so we are overriding that default behavior
	int X,Y,W,H;
	GetXYWH(X,Y,W,H);
	lpmmi.ptMaxTrackSize.x = W;
	lpmmi.ptMaxTrackSize.y = H;
}
//*******************************************************************
void TOgleGameFrameWindow::GetScreenMetrics(int* x_res,int* y_res,
														  int* winframe_x,int* winframe_y,
	                                         int* menu_ht,int* title_ht,
                                            int* scroll_x,int* scroll_y)
{
	*x_res =      GetSystemMetrics(SM_CXSCREEN);
	*y_res =      GetSystemMetrics(SM_CYSCREEN);

  // MRP - 06/08/99 - ver2.2 - missing scanlines.
  //   *winframe_x = GetSystemMetrics(SM_CXBORDER);
  //   *winframe_y = GetSystemMetrics(SM_CYBORDER);

   *winframe_x = GetSystemMetrics(SM_CXDLGFRAME);
   *winframe_y = GetSystemMetrics(SM_CYDLGFRAME);

	*menu_ht =    GetSystemMetrics(SM_CYMENU);
	*title_ht=    GetSystemMetrics(SM_CYCAPTION);
	*scroll_x=    GetSystemMetrics(SM_CXHTHUMB);
	*scroll_y=    GetSystemMetrics(SM_CYVTHUMB);
}
//*******************************************************************
void TOgleGameFrameWindow::GetRes(int& x_res,int& y_res)
{
	x_res = GetSystemMetrics(SM_CXSCREEN);
	y_res = GetSystemMetrics(SM_CYSCREEN);
}
//*******************************************************************
void TOgleGameFrameWindow::SetRes()
{
  TSize ressize;
  int cx,cy;
  GetRes(cx,cy);
  ressize.cx = cx;
  ressize.cy = cy;
  TSize clientsize;
  TWindow *pwin = GetClientWindow();
  if (pwin != NULL)
  {
    clientsize.cx = pwin->Attr.W;
    clientsize.cy = pwin->Attr.H;
  }
  else
  {
    TOgleAppInfo appinfo;
    TOgleApp::GetOgleApp()->GetAppInfo(appinfo);
    clientsize = appinfo.MinDisplaySize;
  }
  if (ressize.cx <= clientsize.cx || ressize.cy <= clientsize.cy)
  {
    HandleShowMenu = true;
    TRect rect;
    GetWindowRect(rect);
    if (rect.top == 0)
    {
      MenuShowing = true;
    }
  }
  else
  {
    HandleShowMenu = false;
    MenuShowing = true;
  }
}
//*******************************************************************
void TOgleGameFrameWindow::CmFMgrToggleHDBuffering()
{
  if (GetFileMgr() == NULL) {return;}
  GetFileMgr()->ToggleHDBuffering();
}
//*******************************************************************
void TOgleGameFrameWindow::CeFMgrToggleHDBuffering(TCommandEnabler &ce)
{
  if (GetFileMgr() == NULL)
  {
    ce.Enable(false);
  }
  else
  {
    if (GetFileMgr()->IsGlobalHDBufferingOn())
    {
      ce.SetCheck(TCommandEnabler::Checked);
    }
    else
    {
      ce.SetCheck(TCommandEnabler::Unchecked);
    }
    ce.Enable(true);
  }
}
//*******************************************************************
void TOgleGameFrameWindow::CmShowMenu()
{  //if we are in 640 * 480 then we want to be able to hide or show
	//  the menu to allow greater screen utilization during the game
	//  the escape key is used to toggle the menu off or on-screen.
	//  the menu is always there. We just move the window up or down by
	//  the height of the menu bar + title bar to display it. This preserves
	//  the size of the client area at all times.
   if (!HandleShowMenu) {return;}

	int x_res,y_res;
	GetRes(x_res,y_res);

   TSize clientsize;
   TWindow *pwin = GetClientWindow();
   if (pwin != NULL)
   {
     clientsize.cx = pwin->Attr.W;
     clientsize.cy = pwin->Attr.H;
   }
   else
   {
     TOgleAppInfo appinfo;
     TOgleApp::GetOgleApp()->GetAppInfo(appinfo);
     clientsize = appinfo.MinDisplaySize;
   }

   if (x_res > clientsize.cx && y_res > clientsize.cy)
   {
     MenuShowing = true;
     return;
   }

	int X,Y,W,H;
	GetXYWH(X,Y,W,H);

	if (MenuShowing) //the menu is either showing or not.
	{
		  //this is setting up for menu not showing
		  MenuShowing = false;
		  MoveWindow(X,Y,W,H,true);
		  Invalidate();
		  return;
	}
	MenuShowing = true;
	//this is normal positioning
	MoveWindow(X,0,W,H,true);
	Invalidate();

}
//*******************************************************************
void TOgleGameFrameWindow::Maximize()
{
  if (!MaxFX) {return;}

  static int nCount = 0;
  if (nCount++==0) return;

  int mod = nCount % 3;
  if (mod==0)
  {
    TRect rc;
    GetWindowRect(rc);
    for (float i=0.0;i<6.28;i+=0.15)
    {
      MoveWindow(rc.left-(cos(6.28)*100) +  (cos(i)*100),//left
					  rc.top- (sin(6.28)*100)  + (sin(i)*100),//top
					  rc.right,//width
					  rc.bottom,//height
					  true);
      UpdateWindow();
    }
    for (float i=6.28;i>0.0;i-=0.15)
    {
      MoveWindow(rc.left+(cos(6.28)*100) -  (cos(i)*100),//left
					  rc.top+ (sin(6.28)*100)  - (sin(i)*100),//top
					  rc.right,//width
					  rc.bottom,//height
					  true);
      UpdateWindow();
    }
    MoveWindow(rc.left,//left
               rc.top, //top
					rc.right-rc.left,//width
					rc.bottom-rc.top,//height
					true);
    UpdateWindow();
    nCount++;
  }
}
//*******************************************************************
void TOgleGameFrameWindow::EvSize(uint sizeType, TSize&)
{
	if (sizeType == SIZE_MINIMIZED)//minimization has occurred- play icon animations
	{
      m_bIsMinimized = true;
      DeActivate();

      if (!m_AllowIconAnimation) {return;}

		animIcons.SetupTimer(this);
		animIcons.LoadIconIDs();

		//::MessageBox(NULL,"We need to capture current position here?","",MB_OK);
	}
	else//game has been restored to its normal window size
	{
      m_bIsMinimized = false;
      Activate();

      if (!m_AllowIconAnimation) {return;}

		KillTimer(2);
      Maximize();
	}
}
//*******************************************************************
void TOgleGameFrameWindow::EvTimer(uint timerId)
{  //Animate the icon
	if (timerId != 2)
		return;//in case more timers are used in this class
	animIcons.AnimateIcon((TFrameWindow*)this);
}
//*******************************************************************
bool TOgleGameFrameWindow::EvQueryNewPalette()
{
  if (PModeWin == NULL) {return false;}
  return PModeWin->EvQueryNewPalette();
}
//*******************************************************************
void TOgleGameFrameWindow::EvPaletteChanged(HWND hWndPalChg)
{
  if (hWndPalChg == HWindow) {return;} // we started it, so don't handle it.
  if (PModeWin != NULL) {PModeWin->EvPaletteChanged(hWndPalChg);}
}
//*******************************************************************
void TOgleGameFrameWindow::EvActivate(uint active,bool minimized,HWND hWndOther)
{
  if (active) {Activate();}
//  if (PModeWin != NULL) {PModeWin->EvActivate(active,minimized,hWndOther);}
  TFrameWindow::EvActivate(active,minimized,hWndOther); // makes sure child win gets focus.
}
//*******************************************************************
void TOgleGameFrameWindow::EvSetFocus(HWND hWndLostFocus)
// don't think we need to trap this.
{
  TRACE("gfw: evsetfocus");

  // MRP - 06/01/99 - ver2.2 - start of focus problem fix.
  if ((GetHWndRestoreFocus() == GetHandle() || !GetHWndRestoreFocus()) &&
      GetClientWindow())
  {
    SetHWndRestoreFocus(GetClientWindow()->GetHandle());
  }
  // end of focus problem fix.

  TFrameWindow::EvSetFocus(hWndLostFocus);
//  FixPalette(false);

}
//*******************************************************************
void TOgleGameFrameWindow::EvKillFocus(HWND hWndGetFocus)
// don't think we need to trap this.
{
  TRACE("gfw: evkillfocus");
  TFrameWindow::EvKillFocus(hWndGetFocus);
}
//*******************************************************************
int TOgleGameFrameWindow::MessageBox(HWND hWnd,
                                     const char far* text,
                                     const char far* caption,
                                     uint            type)
{
  if (GetApplication()->BWCCEnabled()) {
    static bool FAR PASCAL(*bwccMessageBox)(HWND, LPCSTR, LPCSTR, uint);
    if (!bwccMessageBox)
      (FARPROC)bwccMessageBox =
        GetApplication()->GetBWCCModule()->GetProcAddress("BWCCMessageBox");
    if (bwccMessageBox)
      return (*bwccMessageBox)(hWnd, text, caption, type);
    return 0;
  }
  else {
    GetApplication()->EnableCtl3dAutosubclass(true);
    int retValue = ::MessageBox(hWnd, text, caption, type);
    GetApplication()->EnableCtl3dAutosubclass(false);
    return retValue;
  }
}
//*******************************************************************

