//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  ovidwing.cpp
//    Project Name:  Ogle
// Original Author:  John Brooks
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     4/27/95    J.Brooks    original baseline
//          4/27/95    M.Perry     merged into Ogle
//          8/1/96     M.Perry     changed to old
//          8/22/96    M.Perry     complete revamped.
//  2.0     8/28/97    M.Perry     32-bit conversion.
//********************************************************************
#if !defined(__ovidwing_h)
#include "ovidwing.h"
#endif

#if !defined(__oanm_h)
#include "oanm.h"
#endif

#if !defined(__omodewin_h)
#include "omodewin.h"
#endif

#if !defined(__ovwpal_h)
#include "ovwpal.h"
#endif

#if !defined(__ovwbmp_h)
#include "ovwbmp.h"
#endif

#if !defined(__ovwingdc_h)
#include "ovwingdc.h"
#endif

DIAG_DECLARE_GROUP(VIDEO);
//*******************************************************************
TVideoWinG::TVideoWinG(TOgleModeWindow *pmw,TBmp &mbg,TPal &mpal,
                       TRenderMethod bgmethod,TRenderMethod grmethod)
:TOgleVideo(pmw,mbg,mpal,bgmethod,grmethod)
{
  TOgleWinG::LoadDll();
}
//*******************************************************************
TVideoWinG::~TVideoWinG()
{
  TOgleWinG::UnLoadDll();
}
//*******************************************************************
bool TVideoWinG::CreateVideoBmp()
{
  PVBmp = new TVideoWinGBmp(GetModeWin(),*PVDC,*PVPal,WinSize);
  return true;
}
//*******************************************************************
bool TVideoWinG::CreateVideoPal()
{
  PVPal = new TVideoWinGPal(GetModeWin(),*PMasterPal);
  PVPal->ClearSystemPalette();
  return true;
}
//*******************************************************************
bool TVideoWinG::CreateVideoDC()
{
  PVDC = new TVideoWinGDC;
  return true;
}
//*******************************************************************
void TVideoWinG::SetupVideoDC()
{
  PVDC->SelectBmp(*PVBmp);
  TOgleVideo::SetupVideoDC();
}
//*******************************************************************
void TVideoWinG::CleanupVideoDC()
{
  PVDC->RestoreBmp();
}
//*******************************************************************
TOglePaintDC *TVideoWinG::CreatePaintDC(TDC &dc)
{
  return (new TWinGPaintDC(dc));
}
//*******************************************************************

