//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  owingdll.cpp
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     7/5/96     M.Perry    original baseline
//  2.0     8/28/97    M.Perry    32-bit conversion
//********************************************************************
#include "owingdll.h"

//*******************************************************************
// static ptr to class.
TOgleWinG *TOgleWinG::POgleWinG = NULL;
//*******************************************************************
bool TOgleWinG::LoadDll()
{
  if (Dll() == NULL) {POgleWinG = new TOgleWinG;}
  if (POgleWinG->Load()) {return true;}
  // bad things, man.
  delete POgleWinG;
  POgleWinG = NULL;
  return false;
}
//*******************************************************************
bool TOgleWinG::UnLoadDll(bool ignoreRef)
{
  if (Dll() == NULL) {return true;}
  POgleWinG->UnLoad();

  // use ignoreRef with care,
  // intended to be used only when app is closing down, to prevent mem leaks.
  if (POgleWinG->IsInitialized() && ignoreRef)
  {
    POgleWinG->DeInitialize();
  }
  // if no body left needing it, then get rid of it.
  if (!POgleWinG->IsInitialized())
  {
    delete POgleWinG;
    POgleWinG = NULL;
  }
  return true;
}
//*******************************************************************
TOgleWinG::TOgleWinG()
  #if defined(WIN32) || defined(_WIN32)
  :TOgleDll("wing32.dll")
  #else
  :TOgleDll("wing.dll")
  #endif
{
  CleanupProcs();
}
//*******************************************************************
TOgleWinG::~TOgleWinG()
{
}
//*******************************************************************
bool TOgleWinG::SetupProcs()
{
  if (!CheckInstance()) {return false;}
  //link the DLL's functions to our function pointers.

  CreateDC = (wingCreateDC) GetProcAddress ("WinGCreateDC");
  if (CreateDC == NULL) {return false;}

  RecommendDIBFormat = (wingRecommendDIBFormat) GetProcAddress("WinGRecommendDIBFormat");
  if (RecommendDIBFormat == NULL) {return false;}

  CreateBitmap = (wingCreateBitmap) GetProcAddress("WinGCreateBitmap");
  if (CreateBitmap == NULL) {return false;}

  GetDIBPointer = (wingGetDIBPointer)GetProcAddress("WinGGetDIBPointer");
  if (GetDIBPointer == NULL) {return false;}

  GetDIBColorTable = (wingGetDIBColorTable)GetProcAddress("WinGGetDIBColorTable");
  if (GetDIBColorTable == NULL) {return false;}

  SetDIBColorTable = (wingSetDIBColorTable)GetProcAddress("WinGSetDIBColorTable");
  if (SetDIBColorTable == NULL) {return false;}

  CreateHalftonePalette = (wingCreateHalftonePalette)GetProcAddress("WinGCreateHalftonePalette");
  if (CreateHalftonePalette == NULL) {return false;}

  CreateHalftoneBrush = (wingCreateHalftoneBrush)GetProcAddress("WinGCreateHalftoneBrush");
  if (CreateHalftoneBrush == NULL) {return false;}

  BitBlt = (wingBitBlt) GetProcAddress("WinGBitBlt");
  if (BitBlt == NULL) {return false;}

  StretchBlt = (wingStretchBlt) GetProcAddress("WinGStretchBlt");
  if (StretchBlt == NULL) {return false;}

   return true;
}
//*******************************************************************
bool TOgleWinG::CleanupProcs()
{
  CreateDC = NULL;
  RecommendDIBFormat = NULL;
  CreateBitmap = NULL;
  GetDIBPointer = NULL;
  GetDIBColorTable = NULL;
  SetDIBColorTable = NULL;
  CreateHalftonePalette = NULL;
  CreateHalftoneBrush = NULL;
  BitBlt = NULL;
  StretchBlt = NULL;
  return true;
}
//*******************************************************************


