//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  ovwbmp.cpp
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     7/25/96    M.Perry    original baseline
//  2.0     8/28/97    M.Perry    32-bit conversion.
//********************************************************************
#if !defined(__ovwbmp_h)
#include "ovwbmp.h"
#endif

#if !defined(__ovwingdc_h)
#include "ovwingdc.h"
#endif

#if !defined(__owingdll_h)
#include "owingdll.h"
#endif
//*******************************************************************
TVideoWinGBmp::TVideoWinGBmp(TOgleModeWindow *pmw,TOgleVideoDC &vdc,TPal &pal,
                             TSize &size,bool userec,bool topdown)
:TVideoBmp(pmw,vdc)
{
  PBitmapInfo = new TBitmapInfo(256);
  *PBitmapInfo = pal;
  TOgleWinG::Dll()->RecommendDIBFormat(*PBitmapInfo);
  bool rec_topdown = PBitmapInfo->IsTopDown();
  PBitmapInfo->SetHeight(size.cy);
  PBitmapInfo->SetWidth(size.cx);
  GrDrawData.CalcVRect(int16(size.cx),int16(size.cy)); // this gives user gr's positive values.
  GrDrawData.SetLinear(true);

  if (userec)  // we're were told to set to recommended orientation.
  {
    PBitmapInfo->SetTopDown(rec_topdown);
    GrDrawData.SetTopDown(rec_topdown);
  }
  else  // we're were told what orientation.
  {
    PBitmapInfo->SetTopDown(topdown);
    GrDrawData.SetTopDown(topdown);
  }
  CreateHBITMAP();
}
//*******************************************************************
TVideoWinGBmp::~TVideoWinGBmp()
{
}
//*******************************************************************
bool TVideoWinGBmp::CreateHBITMAP()
{
  if (PVDC == NULL) {return false;}
  void *pbits = NULL;
  hBitmap = PVDC->CreateBitmap(*PBitmapInfo,&pbits);
  if (hBitmap != NULL) {GrDrawData.SetBits((byte *)pbits);}
  return (hBitmap != NULL);
}
//*******************************************************************

