//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  gedapp.cpp
//    Project Name:  Game Editor
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     7/24/95    M.Perry     original baseline
//  2.0    10/29/97    M.Perry     32-bit conversion.
//********************************************************************
#if !defined(__gedapp_h)
#include "gedapp.h"
#endif

#if !defined(__gedini_h)
#include "gedini.h"
#endif

#if !defined(__ogame_h)
#include "ogame.h"
#endif
//*******************************************************************
void TGameEditorApp::GetAppInfo(TOgleAppInfo &appinfo)
{
  TOgleApp::GetAppInfo(appinfo);
  appinfo.MainTitle = "GEd";
}
//*******************************************************************
//TGEdIniFile *TGameEditorApp::GetIniFile()
//{
//  return (TGEdIniFile *)PIniFile;
//}
//*******************************************************************
void TGameEditorApp::CreateIniFile()
{
  PIniFile = new TGEdIniFile(HDDrive,HDDir,AppName);
}
//*******************************************************************
TGameEditorApp::TGameEditorApp(string NewHDDrive,string NewHDDir,string NewAppName)
//:TOgleApp(NewAppName)
:TOgleApp(NewHDDrive,NewHDDir,NewAppName)
{
//  CreateCursorMgr();

//  PIniFile = new TGEdIniFile(NewHDDrive,NewHDDir,NewAppName);
  VDFlags.ClearAllDirty();
  VDFlags.ClearAllValid();
//  POgleApp = this;
//  SetHelpData();
//  CreateFileMgr();
//  SetHelpFileName();
//  CreateGameFile();
//  CreatePalette();
  MaxFX = false;
}
//*******************************************************************
void TGameEditorApp::CreateGameFile()
{
  if (GameFileName.is_null())
  {
    PGame = new TOgleGame();
    PGame->PaletteName = "mpal";
  }
  else
  {
    PGame = new TOgleGame(GameFileName);
  }
}

//*******************************************************************
TOgleGameFrameWindow *TGameEditorApp::CreateGameFrameWindow()
{
  TOgleAppInfo appinfo;
  GetAppInfo(appinfo);
  return (new TEditFrameWin(this,appinfo.MainTitle));
}
//*******************************************************************

