//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  gedmodew.h
//    Project Name:  Game Editor
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     7/24/95    M.Perry    original baseline
//  2.0    10/29/97    M.Perry    32-bit conversion.
//********************************************************************
#if !defined(__gedmodew_h)
#define __gedmodew_h

#if !defined(__gedmodew_rh)
#include "gedmodew.rh"
#endif

#if !defined(__omodewin_h)
#include "omodewin.h"
#endif

//#include "gedspmsg.h"
//#include "gedskmsg.h"

#if !defined(__geddlgs_h)
#include "geddlgs.h"
#endif

#if !defined(OWL_INPUTDIA_H)
#include <owl\inputdia.h>
#endif

class TVDFlags;
//*******************************************************************
class GEDOWLCLASS TEditorModeWin : public TOgleModeWindow
{
public:
   TVDFlags &GetVDFlags();
	TEditorModeWin(TOgleApp *papp,TOgleGameFrameWindow *pgfw,
                  string modename,TPal *PPal,string title = "");
	virtual ~TEditorModeWin();

   int16 CurrentGObjIndex;

   void SaveMode();
   void CmModeSave();
   void CmModeSaveEnable(TCommandEnabler &commandHandler);
   void CmModeSaveAs();
   void CmModeSaveAsEnable(TCommandEnabler &commandHandler);
   void CmModeEditBG();
   void CmModeEditBGEnable(TCommandEnabler &commandHandler);
   void CmModeEditGameID();
   void CmModeEditGameIDEnable(TCommandEnabler &commandHandler);
   void CmGameInfo();
   void CmGameInfoEnable(TCommandEnabler &commandHandler);

   bool ChangeToNewGObj(string NewGObjName);
   void ChangeToGObj(string NewGObjName);
   bool GetNewGObjFName(string &gobjfname);
   bool IsGObjInList(string NewGObjName);
   void CmGObjNew();
   void CmGObjNewEnable(TCommandEnabler &commandHandler);
   void CmGObjOpen();
   void CmGObjOpenEnable(TCommandEnabler &commandHandler);
   void CmGObjSave();
   void CmGObjSaveEnable(TCommandEnabler &commandHandler);
   void CmGObjSaveAs();
   void CmGObjSaveAsEnable(TCommandEnabler &commandHandler);
   void CmGObjDelete();
   void CmGObjDeleteEnable(TCommandEnabler &commandHandler);
   void CmGObjSkitCriteriaReport();
   void CeGObjSkitCriteriaReport(TCommandEnabler &enabler);
   void CmGObjEditIDCodeList();
   void CeGObjEditIDCodeList(TCommandEnabler &ce);
   void CmGObjMiscData();
   void CeGObjMiscData(TCommandEnabler &ce);

   virtual void CreateModeState();

   bool DoSpritePreview;
   bool DoSkitPreview;
   int16 PreviewGObjIndex;
   int16 PreviewSpriteIndex;
   int16 PreviewSkitCatIndex;
   int16 PreviewSkitIndex;
   bool SpritePreviewDone;
   bool SkitPreviewDone;

   bool GetPreviewSprite();
   bool GetPreviewSkit();
   void SetPreviewSprite(int16 NewPreviewGObjIndex,int16 NewPreviewSpriteIndex);
   void SetPreviewSkit(int16 NewPreviewGObjIndex,
                       int16 NewPreviewSkitCatIndex,
                       int16 NewPreviewSkitIndex);

   void ClearPreviews();
   virtual void BeenSwitchedTo();

	DECLARE_RESPONSE_TABLE(TEditorModeWin);
};
//*******************************************************************
//*****************  inlines ****************************************
//*******************************************************************
inline bool TEditorModeWin::GetPreviewSprite()
{
  return DoSpritePreview;
}
//*******************************************************************
inline bool TEditorModeWin::GetPreviewSkit()
{
  return DoSkitPreview;
}
//*******************************************************************
inline void TEditorModeWin::SetPreviewSprite(int16 NewPreviewGObjIndex,
                                             int16 NewPreviewSpriteIndex)
{
   DoSpritePreview = true;
   SpritePreviewDone = false;
   PreviewGObjIndex = NewPreviewGObjIndex;
   PreviewSpriteIndex = NewPreviewSpriteIndex;
}
//*******************************************************************
inline void TEditorModeWin::SetPreviewSkit(int16 NewPreviewGObjIndex,
                                           int16 NewPreviewSkitCatIndex,
                                           int16 NewPreviewSkitIndex)
{
  DoSkitPreview = true;
  SkitPreviewDone = false;
  PreviewGObjIndex = NewPreviewGObjIndex;
  PreviewSkitCatIndex = NewPreviewSkitCatIndex;
  PreviewSkitIndex = NewPreviewSkitIndex;
}
//*******************************************************************
#endif

