//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  gedskted.cpp
//    Project Name:  Game Editor
// Original Author:  Michael R. Perry
//                                                  
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     7/24/95    M.Perry     original baseline
//  2.0    10/29/97    M.Perry     32-bit conversion.
//  2.2    06/01/99    M.Perry     fixed scroller (debug ver)
//********************************************************************
#if !defined(__gedskted_h)
#include "gedskted.h"
#endif

#if !defined(__geddlgs_h)
#include "geddlgs.h"
#endif

#if !defined(__gedapp_h)
#include "gedapp.h"
#endif

#if !defined(__critdlg_h)
#include "critdlg.h"
#endif

#if !defined(__omode_h)
#include "omode.h"
#endif

#if !defined(__ofilemgr_h)
#include "ofilemgr.h"
#endif
//*******************************************************************
int TFrameIs8Tracks2::operator==(const TFrameIs8Tracks2& thisframe)const
{
	return (this == &thisframe);
}
//*******************************************************************
//*******************************************************************
DEFINE_RESPONSE_TABLE1(TSkitEditorClientWin,TGedWin)
  EV_WM_KEYDOWN,
  EV_WM_LBUTTONDBLCLK,
  EV_WM_RBUTTONDOWN,
  EV_WM_LBUTTONDOWN,
  EV_WM_LBUTTONUP,
  EV_COMMAND(CM_SKITCATNEW,CmSkitCatNew),
  EV_COMMAND_ENABLE(CM_SKITCATNEW,CmSkitCatNewEnable),
  EV_COMMAND(CM_SKITCATOPEN,CmSkitCatOpen),
  EV_COMMAND_ENABLE(CM_SKITCATOPEN,CmSkitCatOpenEnable),
  EV_COMMAND(CM_SKITCATDELETE,CmSkitCatDelete),
  EV_COMMAND_ENABLE(CM_SKITCATDELETE,CmSkitCatDeleteEnable),
  EV_COMMAND(CM_SKITCATPORTFOLIO,CmSkitCatPortfolio),
  EV_COMMAND_ENABLE(CM_SKITCATPORTFOLIO,CmSkitCatPortfolioEnable),
  EV_COMMAND(CM_SKITCATCRITERIAREPORT,CmSkitCatCriteriaReport),
  EV_COMMAND_ENABLE(CM_SKITCATCRITERIAREPORT,CeSkitCatCriteriaReport),
  EV_COMMAND(CM_SKITCATSPRITEUSAGE,CmSkitCatSpriteUsage),
  EV_COMMAND_ENABLE(CM_SKITCATSPRITEUSAGE,CeSkitCatSpriteUsage),
  EV_COMMAND(CM_SKITNEW,CmSkitNew),
  EV_COMMAND_ENABLE(CM_SKITNEW,CmSkitNewEnable),
  EV_COMMAND(CM_SKITOPEN,CmSkitOpen),
  EV_COMMAND_ENABLE(CM_SKITOPEN,CmSkitOpenEnable),
  EV_COMMAND(CM_SKITGET,CmSkitGet),
  EV_COMMAND_ENABLE(CM_SKITGET,CmSkitGetEnable),
  EV_COMMAND(CM_SKITSAVE,CmSkitSave),
  EV_COMMAND_ENABLE(CM_SKITSAVE,CmSkitSaveEnable),
  EV_COMMAND(CM_SKITSAVEAS,CmSkitSaveAs),
  EV_COMMAND_ENABLE(CM_SKITSAVEAS,CmSkitSaveAsEnable),
  EV_COMMAND(CM_SKITDELETE,CmSkitDelete),
  EV_COMMAND_ENABLE(CM_SKITDELETE,CmSkitDeleteEnable),
  EV_COMMAND(CM_SKITWIPE,CmSkitWipe),
  EV_COMMAND_ENABLE(CM_SKITWIPE,CmSkitWipeEnable),
  EV_COMMAND(CM_SKITADDFRAMES,CmSkitAddFrames),
  EV_COMMAND_ENABLE(CM_SKITADDFRAMES,CmSkitAddFramesEnable),
  EV_COMMAND(CM_SKITPREVIEW,CmSkitPreview),
  EV_COMMAND_ENABLE(CM_SKITPREVIEW,CmSkitPreviewEnable),
  EV_COMMAND(CM_SKITCRITERIA,CmSkitCriteria),
  EV_COMMAND_ENABLE(CM_SKITCRITERIA,CmSkitCriteriaEnable),
  EV_COMMAND(CM_SKITINFO,CmSkitInfo),
  EV_COMMAND_ENABLE(CM_SKITINFO,CmSkitInfoEnable),
  EV_COMMAND(CM_SKITEXIT,CmSkitExit),
  EV_COMMAND_ENABLE(CM_SKITEXIT,CmSkitExitEnable),
  EV_COMMAND(CM_SKITNULL,CmSkitNull),
  EV_COMMAND_ENABLE(CM_SKITNULL,CeSkitNull),
END_RESPONSE_TABLE;
//*******************************************************************
void TSkitEditorClientWin::ClearAllUICells()
{
  int16 RowCount = GetUIRowsCount();
  for (int16 i = 0;i < RowCount;i++)
  {
    for (int16 j = 0;j<8;j++)
    {
      ClearCell(&(dynframe[i]->cellptr[j]));
    }
  }
  Invalidate();
}
//*******************************************************************
//bool TSkitEditorClientWin::GetNewSkitCatFName(string &skitcatfname)
bool TSkitEditorClientWin::GetNewSkitCatName(string &skitcatname)
{
//  string gostr = GetGObjPtr()->GetFName();
  string gostr = GetGObjPtr()->FileMode.Name.GetFName();
  if (gostr.length() < 8)
  {
    MessageBox("GObj Name is too short","Error !! Skit Cat - New",MB_OK);
    return false;
  }
  string mgstr = gostr[0];
  mgstr += gostr[1];
  mgstr += gostr[6];
  mgstr += gostr[7];
  mgstr += "kc";
  string dstr = "Enter New Skit Cat Name(" + mgstr + ") + ";
  char namebuffer[3] = "xx";
  string str = "Enter Skit Cat Name (xx)";
  TInputDialog tid(this,dstr.c_str(),str.c_str(),namebuffer,3);
  int retval = tid.Execute();
  if (retval != IDOK) {return false;}
  if (strlen(namebuffer) < 2)
  {
    MessageBox("Name is too short","Error !! Skit Cat - New",MB_OK);
    return false;
  }
  string bufstr = namebuffer;
  skitcatname = mgstr + bufstr;
  if (skitcatname.length() != 8) {return false;}
  TOgleFileName ofn;
  ofn.SetDirPath(GetGObjPtr()->FileMode.Name.GetDirPath());
  ofn.SetFName(skitcatname);
  ofn.SetExt(string(".skl"));
  skitcatname = ofn.GetStr();
  return true;
}
//*******************************************************************
bool TSkitEditorClientWin::IsNameInSkitCats(string &skitcatname)
{
  if (GetSkitCat()->GetSkitList(skitcatname) == NULL)
  {
    return false;
  }
  else
  {
    return true;
  }
}
//*******************************************************************
void TSkitEditorClientWin::CmSkitCatNew()
{
  string NewSkitCatName;
  if (!GetNewSkitCatName(NewSkitCatName))
  {
    MessageBox("Error getting new skit cat name","Error !! Skit Cat - New",MB_OK);
    return;
  }
  if (IsNameInSkitCats(NewSkitCatName))
  {
    MessageBox("Skit Cat List Name already exists !","Error !! Skit Cat - New",MB_OK);
    return;
  }

  CheckSaveCurrentSkit();
  ClearAllUICells();
  CurrentSkitCatIndex = GetGObjPtr()->CreateAddSkitCat(NewSkitCatName);
  GetSkitCat()->Save();
  GetVDFlags().ClearSkitCatDirty();
  GetVDFlags().SetSkitCatValid();
  GetVDFlags().ClearSkitValid();
  GetVDFlags().ClearSkitDirty();

  #ifdef GEDMSGBOX
  MessageBox("New Skit Cat Added","Skit Cat - New",MB_OK);
  #endif
}
//*******************************************************************
void TSkitEditorClientWin::CmSkitCatNewEnable(TCommandEnabler &commandHandler)
{
  // don't switch cat's unless current skit has been saved first.
  if (GetVDFlags().IsSkitValid() && GetVDFlags().IsSkitDirty()) // just added.
  {
    commandHandler.Enable(false);
  }
  else
  {
    commandHandler.Enable(true);
  }
}
//*******************************************************************
void TSkitEditorClientWin::CmSkitCatOpen()
{
  string str = "Skit Cat Open";
  TSelectSkitCatDlg ssd(this,str);
  if (ssd.Execute() == IDOK)
  {
    CheckSaveCurrentSkit();
    CurrentSkitIndex = -1;  // just added.
    ClearAllUICells();
    string NewSkitCatName = ssd.RetrieveSelection();
    CurrentSkitCatIndex = GetSkitCat()->GetSkitListIndex(NewSkitCatName);
    GetVDFlags().ClearSkitDirty();
    GetVDFlags().ClearSkitValid(); // just added.
    GetVDFlags().SetSkitCatValid();
    #ifdef GEDMSGBOX
    MessageBox("Skit Cat Opened","Skit Cat - Open",MB_OK);
    #endif
  }
}
//*******************************************************************
void TSkitEditorClientWin::CmSkitCatOpenEnable(TCommandEnabler &commandHandler)
{
  // don't switch cat's unless current skit has been saved first.
  if (GetVDFlags().IsSkitValid() && GetVDFlags().IsSkitDirty()) // just added.
  {
    commandHandler.Enable(false);
  }
  else
  {
    commandHandler.Enable(true);
  }
}
//*******************************************************************
void TSkitEditorClientWin::CmSkitCatDelete()
{
  string str = "Skit Cat - Delete";
  TSelectSkitCatDlg sscd(this,str);
  if (sscd.Execute() == IDOK)
  {
    string SelSkitCatName = sscd.RetrieveSelection();
    int16 sci = GetSkitCat()->GetSkitListIndex(SelSkitCatName);
    if (sci == CurrentSkitCatIndex)
    {
      MessageBox("Can't delete current skit cat list","Error - Skit Cat Delete",MB_OK);
      return;
    }
    if (!GetSkitCat()->DeleteSkitCatList(SelSkitCatName))
    {
      MessageBox("Skit Cat List delete failed","Error - Skit Cat Delete",MB_OK);
      return;
    }
    GetSkitCat()->Save();
  }
}
//*******************************************************************
void TSkitEditorClientWin::CmSkitCatDeleteEnable(TCommandEnabler &commandHandler)
{
  if ((GetSkitCat()->GetLastNumSkitLists() < 0) ||
       (GetVDFlags().IsSkitValid() && GetVDFlags().IsSkitDirty()))
  {
    commandHandler.Enable(false);
  }
  else
  {
    commandHandler.Enable(true);
  }
}
//*******************************************************************
void TSkitEditorClientWin::CmSkitCatPortfolio()
{
  TSelectPortfolioListDlg *pspld = new TSelectPortfolioListDlg(this,
                                                               CurrentSkitCatIndex,
                                                               GetSkitList()->PSkitPortfolio,
//                                                               GetSkitList()->GetFName());
                                                               GetSkitList()->FileMode.Name.GetStr());
  pspld->Execute();
  delete pspld;
  GetVDFlags().SetSkitCatDirty();
}
//*******************************************************************
void TSkitEditorClientWin::CmSkitCatPortfolioEnable(TCommandEnabler &commandHandler)
{
  if (GetVDFlags().IsSkitCatValid())
  {
    commandHandler.Enable(true);
  }
  else
  {
    commandHandler.Enable(false);
  }
}
//*******************************************************************
void TSkitEditorClientWin::CmSkitCatCriteriaReport()
{
//  string str = "c:\\";
////  str += GetSkitList()->GetFName();
//  str += GetSkitList()->FileMode.Name.GetFName();
//  str += ".rpt";

  TOgleFileName ofn(GetFileMgr()->GetCDRomPath(-1));
  ofn.AppendDirPath("\\reports\\skitlists");
  ofn.AppendDirPath(GetSkitList()->FileMode.Name.GetDirPath());
  ofn.SetFName(GetSkitList()->FileMode.Name.GetFName());
  ofn.SetExt(".rpt");
  ofn.CreateDir();

//  ofstream os(str.c_str());
  ofstream os(ofn.GetStr().c_str());
  if (!os)
  {
    MessageBox("problem with output file","Error - SkitCriteria Report",MB_OK);
  }
  else
  {
    os<<"Report FileName: "<<ofn.GetStr().c_str()<<"\n";
    os<<"************************ Start of criteria report **************************\n";
    GetSkitList()->CriteriaReport(os);
    os<<"************************ End of criteria report ****************************\n";
    os.close();
    string s = "notepad.exe ";
    s += ofn.GetStr();
    WinExec(s.c_str(),SW_SHOWNORMAL);
  }
//  string msg = "Criteria report written to file: " + str;
//  MessageBox(msg.c_str(),"Criteria Report",MB_OK);
}
//*******************************************************************
void TSkitEditorClientWin::CeSkitCatCriteriaReport(TCommandEnabler &enabler)
{
  if (GetVDFlags().IsSkitCatValid())
  {
    enabler.Enable(true);
  }
  else
  {
    enabler.Enable(false);
  }
}
//*******************************************************************
void TSkitEditorClientWin::CmSkitCatSpriteUsage()
{
  TSpriteUsageDlg *psud = new TSpriteUsageDlg(this,GetGObjPtr(),CurrentGObjIndex);
  psud->Execute();
  delete psud;
}
//*******************************************************************
void TSkitEditorClientWin::CeSkitCatSpriteUsage(TCommandEnabler &enabler)
{
  if (GetGObjPtr() != NULL && CurrentGObjIndex >= 0)
  {
    enabler.Enable(true);
  }
  else
  {
    enabler.Enable(false);
  }
}
//*******************************************************************
void TSkitEditorClientWin::LoadTable()
{
  TSkit *PSkit = GetSkitPtrFromList();
//  string FName = PSkit->GetFName();
//  TFileMode SFM = PSkit->FileMode;
//
//  TFileMode FM(FName,
//               TFileMode::fm_Immed,
//               TFileMode::fm_Immed,
//               SFM.GetDirIndex(),
//               false/*SFM.GetShareable()*/);

  TFileMode FM = PSkit->FileMode;
  FM.SetRamImmed();
  FM.SetHDImmed();
  FM.SetNonShareable();

  TSkit *PNewSkit = new TSkit(PSkit->PModeWin,FM,GetGObjPtr());
  PNewSkit->SetIndexes();
  PCurrentSkit = PNewSkit;
  MakeEnoughUIRows();

  int16 fc = PNewSkit->GetTable()->GetFrameCount();
  for (int16 i=0;i < fc;i++)
  {
    for (int16 j=0;j < 8;j++)
    {
      CopyCell(&(dynframe[i]->cellptr[j]),
               PNewSkit->GetTable()->GetSkitCell(i,j));
    }
  }
  Invalidate();
}
//*******************************************************************
//bool TSkitEditorClientWin::GetNewSkitFName(string &skitfname)
bool TSkitEditorClientWin::GetNewSkitName(string &skitname)
{
//  string gostr = GetGObjPtr()->GetFName();
  string gostr = GetGObjPtr()->FileMode.Name.GetFName();
  if (gostr.length() < 8)
  {
    MessageBox("GObj Name is too short","Error !! Skit - New",MB_OK);
    return false;
  }

//  string scstr = GetSkitList()->GetFName();
  string scstr = GetSkitList()->FileMode.Name.GetFName();
  if (scstr.length() < 8)
  {
    MessageBox("Skit Cat List Name is too short","Error !! Skit - New",MB_OK);
    return false;
  }

  string mgstr = gostr[0];
  mgstr += gostr[1];
  mgstr += gostr[6];
  mgstr += gostr[7];
  mgstr += scstr[6];
  mgstr += scstr[7];

  string dstr = "Enter New Skit Name(" + mgstr + ") + ";
  char namebuffer[3] = "xx";
  string str = "Enter Skit Name (xx)";
  TInputDialog tid(this,dstr.c_str(),str.c_str(),namebuffer,3);
  int retval = tid.Execute();
  if (retval != IDOK) {return false;}
  if (strlen(namebuffer) < 2)
  {
    MessageBox("Name is too short","Error !! Skit - New",MB_OK);
    return false;
  }
  string bufstr = namebuffer;
  skitname = mgstr + bufstr;
  if (skitname.length() != 8) {return false;}
  TOgleFileName ofn;
  ofn.SetDirPath(GetGObjPtr()->FileMode.Name.GetDirPath());
  ofn.SetFName(skitname);
  ofn.SetExt(string(".sk"));
  skitname = ofn.GetStr();
  return true;
}
//*******************************************************************
bool TSkitEditorClientWin::IsNameInSkitList(string &skitname)
{
  if (GetSkitList()->GetSkitIndex(skitname) >= 0)
  {
    return true;
  }
  else
  {
    return false;
  }
}
//*******************************************************************
void TSkitEditorClientWin::CmSkitNew()
{
  string NewSkitName;
  if (!GetNewSkitName(NewSkitName))
  {
    MessageBox("Error getting skit name","Error !! Skit - New",MB_OK);
    return;
  }
  if (IsNameInSkitList(NewSkitName))
  {
    MessageBox("Skit Name already exists","Error !! Skit - New",MB_OK);
    return;
  }

  CheckSaveCurrentSkit();
  ClearAllUICells();
  CurrentSkitIndex = GetGObjPtr()->CreateAddSkit(NewSkitName,CurrentSkitCatIndex);
  GetSkitList()->Save();
  LoadTable();
  GetVDFlags().ClearSkitDirty();
  GetVDFlags().SetSkitValid();

  #ifdef GEDMSGBOX
  MessageBox("New Skit added to SkitList","Skit - New",MB_OK);
  #endif
}
//*******************************************************************
void TSkitEditorClientWin::CmSkitNewEnable(TCommandEnabler &commandHandler)
{
  if (GetVDFlags().IsSkitCatValid())
  {
    commandHandler.Enable(true);
  }
  else
  {
    commandHandler.Enable(false);
  }
}
//*******************************************************************
void TSkitEditorClientWin::CmSkitOpen()
{
  string str = "Skit Open";
  TSelectSkitDlg ssd(CurrentSkitCatIndex,this,str);
  if (ssd.Execute() == IDOK)
  {
    CheckSaveCurrentSkit();
    ClearAllUICells();
    string NewSkitFName = ssd.RetrieveSelection();
    CurrentSkitIndex = GetSkitList()->GetSkitIndex(NewSkitFName);
    LoadTable();
    GetVDFlags().ClearSkitDirty();
    GetVDFlags().SetSkitValid();
  }
}
//*******************************************************************
void TSkitEditorClientWin::CmSkitOpenEnable(TCommandEnabler &commandHandler)
{
  if (GetVDFlags().IsSkitCatValid())
  {
    commandHandler.Enable(true);
  }
  else
  {
    commandHandler.Enable(false);
  }
}
//*******************************************************************
void TSkitEditorClientWin::CmSkitGet()
{
  MessageBox("Not Implemented Yet","Skit - Get",MB_OK);
}
//*******************************************************************
void TSkitEditorClientWin::CmSkitGetEnable(TCommandEnabler &commandHandler)
{
  commandHandler.Enable(false);
}
//*******************************************************************
void TSkitEditorClientWin::CmSkitSave()
{
  SaveCurrentSkit();
}
//*******************************************************************
void TSkitEditorClientWin::CmSkitSaveEnable(TCommandEnabler &commandHandler)
{
  if ((GetVDFlags().IsSkitValid()) &&
      (GetVDFlags().IsSkitDirty()))
  {
    commandHandler.Enable(true);
  }
  else
  {
    commandHandler.Enable(false);
  }
}
//*******************************************************************
void TSkitEditorClientWin::CmSkitSaveAs()
{
  MessageBox("Not Implemented Yet","Skit - Save As",MB_OK);
}
//*******************************************************************
void TSkitEditorClientWin::CmSkitSaveAsEnable(TCommandEnabler &commandHandler)
{
  commandHandler.Enable(false);
}
//*******************************************************************
void TSkitEditorClientWin::CmSkitDelete()
{
  string str = "Skit Delete";
  TSelectSkitDlg ssd(CurrentSkitCatIndex,this,str);
  if (ssd.Execute() == IDOK)
  {
    string SelSkitFName = ssd.RetrieveSelection();
    int16 si = GetSkitList()->GetSkitIndex(SelSkitFName);
    if (si == CurrentSkitIndex)
    {
      MessageBox("Can't delete current skit","Error !! Skit - Delete",MB_OK);
      return;
    }
    if (!GetSkitList()->DeleteSkit(SelSkitFName))
    {
      MessageBox("Skit delete failed","Error !! Skit - Delete",MB_OK);
      return;
    }
    GetSkitList()->Save();
  }
}
//*******************************************************************
void TSkitEditorClientWin::CmSkitDeleteEnable(TCommandEnabler &commandHandler)
{
  if (GetVDFlags().IsSkitCatValid())
  {
    commandHandler.Enable(true);
  }
  else
  {
    commandHandler.Enable(false);
  }
}
//*******************************************************************
void TSkitEditorClientWin::CmSkitWipe()
{
  MessageBox("Not Implemented Yet","Skit - Wipe",MB_OK);
}
//*******************************************************************
void TSkitEditorClientWin::CmSkitWipeEnable(TCommandEnabler &commandHandler)
{
  commandHandler.Enable(false);
}
//*******************************************************************
void TSkitEditorClientWin::CmSkitAddFrames()
{
  Add10UIRows();
}
//*******************************************************************
void TSkitEditorClientWin::CmSkitAddFramesEnable(TCommandEnabler &commandHandler)
{
  commandHandler.Enable(true);
}
//*******************************************************************
void TSkitEditorClientWin::CmSkitPreview()
{
  if (GetVDFlags().IsSkitDirty())
  {
    int retval = MessageBox("You must save current skit before you can preview, Save ?",
                            "Skit - Preview",MB_YESNO | MB_ICONQUESTION);
    if (retval == IDYES)
    {
      SaveCurrentSkit();
    }
    else
    {
      MessageBox("Preview Cancelled","Skits - Preview",MB_OK);
      return;
    }
  }
  GetEditorModeWin()->SetPreviewSkit(CurrentGObjIndex,
                                     CurrentSkitCatIndex,
                                     CurrentSkitIndex);
  PostSwitchToModeWinPreview();
}
//*******************************************************************
void TSkitEditorClientWin::CmSkitPreviewEnable(TCommandEnabler &commandHandler)
{
  if (GetVDFlags().IsSkitValid())
  {
    commandHandler.Enable(true);
  }
  else
  {
    commandHandler.Enable(false);
  }
}
//*******************************************************************
void TSkitEditorClientWin::CmSkitCriteria()
{
  TSkitCriteria sc;
//  int strtableid = /*POgleApp->*/GetFW()->GetModeWin()->PMode->GetStringTableID();
  int strtableid = GetFW()->GetModeWin()->GetMode()->GetStringTableID();
  if (strtableid <= 0)
  {
    MessageBox("Error - You need to select a Game ID in the Mode Editor",
               "Skit - Criteria",
               MB_OK);
    return;
  }
  TSkitCriteria *PCurrentSkitCriteria = PCurrentSkit->GetSkitCriteria();
  sc = *PCurrentSkitCriteria;
  TCriteriaDialog cd(this,CRITERIA_DIALOG,strtableid,&sc);
  if (cd.Execute() == IDOK)
  {
    *PCurrentSkitCriteria = sc;
    GetVDFlags().SetSkitDirty();
  }
}
//*******************************************************************
void TSkitEditorClientWin::CmSkitCriteriaEnable(TCommandEnabler &commandHandler)
{
  if (GetVDFlags().IsSkitValid())
  {
    commandHandler.Enable(true);
  }
  else
  {
    commandHandler.Enable(false);
  }
}
//*******************************************************************
void TSkitEditorClientWin::CmSkitNull()
{
  if (GetVDFlags().IsSkitCatValid() && GetVDFlags().IsSkitValid() && (PCurrentSkit != NULL))
  {
    string msg = "Skit Known Null";
    if (PCurrentSkit->IsKnownEmptyTable()) {msg += " (yes)";}
    else {msg += " (no)";}
    int result = MessageBox(msg.c_str(),"Setting - Skit Null",MB_YESNOCANCEL);
    if (result == IDCANCEL) {return;}
    if (result == IDYES) {PCurrentSkit->SetKnownEmptyTable(true);}
    else {PCurrentSkit->SetKnownEmptyTable(false);}
    GetVDFlags().SetSkitDirty();
  }
  else
  {
    MessageBox("Something not valid","Warning - Skit Null",MB_OK);
  }
}
//*******************************************************************
void TSkitEditorClientWin::CeSkitNull(TCommandEnabler &commandHandler)
{
  if (GetVDFlags().IsSkitValid())
  {
    commandHandler.Enable(true);
  }
  else
  {
    commandHandler.Enable(false);
  }
}
//*******************************************************************
void TSkitEditorClientWin::CmSkitInfo()
{
  string scstr;
  string sstr;
  dword slen;
  string knownempty;
  if (GetVDFlags().IsSkitCatValid())
  {
//    scstr = GetSkitList()->GetFName();
    scstr = GetSkitList()->FileMode.Name.GetStr();
  }
  else
  {
    scstr = "None";
  }
  if ((GetVDFlags().IsSkitValid()) && (PCurrentSkit != NULL))
  {
//    sstr = PCurrentSkit->GetFName();
    sstr = PCurrentSkit->FileMode.Name.GetStr();
    slen = PCurrentSkit->Get_FUC_Length();
    if (PCurrentSkit->IsKnownEmptyTable()) {knownempty = "yes";}
    else {knownempty = "no";}
  }
  else
  {
    sstr = "None";
    slen = 0;
    knownempty = "n/a";
  }
  char buffer[9];
  string slenstr = itoa((int)slen,buffer,10);

  string msgstr = "Skit Cat Name -> " + scstr + "\n" +
                  "Skit Name -> " + sstr + "\n" +
                  "Skit FUC Length -> " + slenstr +
                  "\nNULL - " + knownempty;
  MessageBox(msgstr.c_str(),"Skit Info",MB_OK);
}
//*******************************************************************
void TSkitEditorClientWin::CmSkitInfoEnable(TCommandEnabler &commandHandler)
{
  commandHandler.Enable(true);
}
//*******************************************************************
void TSkitEditorClientWin::CmSkitExit()
{
  CheckSaveCurrentSkit();
  GetEditorModeWin()->ClearPreviews();
  GetVDFlags().ClearSkitValid();

  // if portfolio was edited.
  if (GetVDFlags().IsSkitCatDirty())
  {
    if (CurrentSkitCatIndex >= 0)
    {
      GetSkitList()->Save();
    }
    GetVDFlags().ClearSkitCatDirty();
  }

  GetVDFlags().ClearSkitCatValid();

  PostSwitchToModeWin();
}
//*******************************************************************
void TSkitEditorClientWin::CmSkitExitEnable(TCommandEnabler &commandHandler)
{
  commandHandler.Enable(true);
}
//*******************************************************************
TSkitEditorClientWin::TSkitEditorClientWin():
	  dynframe(MAX_FRAMES,MIN_FRAMES,FRAME_DELTA)
{
  // MRP - 06/01/99 - ver2.2
  Attr.W = 640;
  Attr.H = 480;

  //scroller may need to change when frame count increases
  Attr.Style |= WS_VSCROLL | WS_HSCROLL;
  m_screen_height = BEFORE_FRAMES + (NUM_FRAMES * FRAME_HEIGHT) +
						  ((NUM_FRAMES - 1) * FRAME_SEPARATION); //2160
  m_screen_width  = LEFT_BORDER + (FRAME_HEIGHT * NUM_TRACKS) +
						  ((NUM_TRACKS - 1) * FRAME_SEPARATION);//1790
  Scroller = new TScroller(this,1,1,m_screen_width,m_screen_height);
  Scroller->XLine = FRAME_HEIGHT + FRAME_SEPARATION;
  Scroller->YLine = FRAME_HEIGHT + FRAME_SEPARATION;

  // MRP - 06/02/99 - ver2.2 - following line moved to
  // SetupWindow() to fix debug version.
  // Scroller->ScrollTo(LEFT_BORDER,BEFORE_FRAMES);

  dragging = false;
  GetVDFlags().ClearSkitCatDirty();
  GetVDFlags().ClearSkitDirty();
  CurrentGObjIndex = -1;
  CurrentSkitCatIndex = -1;
  CurrentSkitIndex = -1;
}
//*******************************************************************
void TSkitEditorClientWin::BeenSwitchedTo()
{
  GetFW()->AssignMenu(SKITMENU);
  CurrentGObjIndex = GetEditorModeWin()->CurrentGObjIndex;
  dragging = false;
  PCurrentSkit = NULL;
  GetVDFlags().ClearSkitCatDirty();
  GetVDFlags().ClearSkitDirty();
  ClearAllUICells();
}
//*******************************************************************
void TSkitEditorClientWin::BackFromPreview()
{
  GetFW()->AssignMenu(SKITMENU);
  dragging = false;
  Invalidate();
}
//*******************************************************************
void TSkitEditorClientWin::EvKeyDown(uint key,uint,uint)
{
  switch (key)
  {
    case VK_F1:
      if (GetVDFlags().IsSkitValid())
      {
        CmSkitPreview();
      }
      else
      {
        MessageBox("Skit not valid","Skit - Preview",MB_OK);
      }
      break;
  }
}
//*******************************************************************
void TSkitEditorClientWin::MakeEnoughUIRows()
{
  int16 size = GetUIRowsCount();
  int16 count = GetTableFrameCount();
  if (size < count)
  {
    int16 delta = int16(count - size);
    int16 times = int16((delta / 10) + 1);
    Add10UIRows(times);
  }
}
//*******************************************************************
void TSkitEditorClientWin::Add10UIRows(int16 times)
{
  for (int16 i = 0;i <= times;i++)
  {
    Add10UIRows();
  }
}
//*******************************************************************
void TSkitEditorClientWin::Add10UIRows()
{
  for (int16 o = 0;o<10;o++)
  {
    dynframe.Add(new TFrameIs8Tracks2);
    TRect temp;
    for (int16 j =0;j<NUM_TRACKS;j++)
    {
      temp.left = LEFT_BORDER + j*(FRAME_HEIGHT + FRAME_SEPARATION);
      temp.right = temp.left + FRAME_HEIGHT;
      temp.top = BEFORE_FRAMES + (FRAME_HEIGHT + FRAME_SEPARATION) * num_frames;
      temp.bottom = temp.top + FRAME_HEIGHT;

      dynframe[num_frames]->track[j] = temp;
    }
    num_frames++;
  }
  m_screen_height = int16(BEFORE_FRAMES +
                         (num_frames * FRAME_HEIGHT) +
                         ((NUM_FRAMES - 1) * FRAME_SEPARATION));
  Scroller->SetRange(m_screen_width,m_screen_height);
  Invalidate();
}
//*******************************************************************
void TSkitEditorClientWin::LoadTableIntoCurrentSkit()
{
  int16 LastUINum = int16(GetUIValidRowsCount() - 1);
  int16 CurrentSkitLastRow = GetSkitTable()->GetLastNum();
  if (LastUINum < CurrentSkitLastRow)
  {
    RemoveEnoughSkitRows(LastUINum);
  }
  else if (LastUINum > CurrentSkitLastRow)
  {
    MakeEnoughCurrentSkitRows(LastUINum);
  }

  for (int16 i=0;i<=LastUINum;i++)
  {
    CopyUIRowToCurrentSkitRow(i);
  }

  Invalidate();
}
//*******************************************************************
void TSkitEditorClientWin::InsertCurrentSkit()
{
  GetSkitList()->SwapSkits(CurrentSkitIndex,PCurrentSkit);
}
//*******************************************************************
void TSkitEditorClientWin::ReloadCurrentSkit()
{
  LoadTable();
  GetVDFlags().ClearSkitDirty();
}
//*******************************************************************
void TSkitEditorClientWin::SaveCurrentSkit()
{
  SaveCurrentSkitBail();
  ReloadCurrentSkit();            
  SaveCurrentSkitBail();
  ReloadCurrentSkit();
}
//*******************************************************************
void TSkitEditorClientWin::SaveCurrentSkitBail()
{
  LoadTableIntoCurrentSkit();

  TSkit *PSkit = GetSkitPtrFromList();
  InsertCurrentSkit();
  PCurrentSkit->Save();
  delete PSkit;
  PCurrentSkit = NULL;
  GetVDFlags().ClearSkitDirty();
  ClearAllUICells();
  #ifdef GEDMSGBOX
  MessageBox("Skit saved to disk","Save",MB_OK | MB_ICONEXCLAMATION);
  #endif
}
//*******************************************************************
bool TSkitEditorClientWin::ScreenPointToFrameAndTrack(TPoint pt,
                                                      int16& frame_found,
                                                      int16& track_found)
{
	int16 nowX=(int16)Scroller->XPos;
	int16 nowY=(int16)Scroller->YPos;
	TPoint rectPoint;
	rectPoint.x = pt.x + nowX ;
	rectPoint.y = pt.y + nowY ;

	for (int16 i=0;i<num_frames;i++)
   {
     for (int16 j=0;j<NUM_TRACKS;j++)
     {
       if (dynframe[i]->track[j].Contains(rectPoint))
       {
         track_found = j;
         frame_found = i;
         return true;
       }
     }
   }
   MessageBox("Couldn't translate the mouse click to a cell","Error - Screen Point",MB_OK);
	return false;
}
//*******************************************************************
int16 TSkitEditorClientWin::GetUIRowsCount()
{
  return (int16)dynframe.GetItemsInContainer();
}
//*******************************************************************
int16 TSkitEditorClientWin::GetUIValidRowsCount()
{
  int16 Retval = 0;
  int16 UIRows = GetUIRowsCount();
  bool *PBarr = new bool [UIRows];
  for (int16 k=0;k<UIRows;k++)
  {
    PBarr[k] = false;
  }

  for (int16 i =0;i<UIRows;i++)
  {
    for (int16 j=0;j<8;j++)
    {
      if ((dynframe[i]->cellptr[j].GetGObjIndex() >= 0) &&
          (dynframe[i]->cellptr[j].GetSpriteIndex() >= 0))
      {
        PBarr[i] = true;
      }
    }
  }

  for (int16 m = int16(UIRows - 1);m >= 0;m--)
  {
    if (PBarr[m])
    {
      Retval = int16(m + 1);
      break;
    }
  }
  delete [] PBarr;
  PBarr = NULL;
  return Retval;
}
//*******************************************************************
void TSkitEditorClientWin::MakeEnoughCurrentSkitRows(int16 LastRow)
{
  int16 CurrentSkitLastNum = GetSkitTableLastNum();
  if (LastRow > CurrentSkitLastNum)
  {
    int16 delta = int16(LastRow - CurrentSkitLastNum);
    for (int16 i=0;i<delta;i++)
    {
      GetSkitTable()->AddRow();
    }
  }
}
//*******************************************************************
void TSkitEditorClientWin::RemoveEnoughSkitRows(int16 LastRow)
{
  int16 CurrentSkitLastRow = GetSkitTableLastNum();
  if (CurrentSkitLastRow > LastRow)
  {
    int16 delta = int16(CurrentSkitLastRow - LastRow);
    for (int16 i = 0;i < delta;i++)
    {
      GetSkitTable()->RemoveTopRow();
    }
  }
}
//*******************************************************************
void TSkitEditorClientWin::CopyUIRowToCurrentSkitRow(int16 RowNum)
{
  if (PCurrentSkit == NULL) {return;}

  TSkitRow *PSkitRow = GetSkitRow(RowNum);
  if (PSkitRow == NULL) {return;}

  for (int16 i=0;i<8;i++)
  {
    if ((dynframe[RowNum]->cellptr[i].GetGObjIndex() >= 0) &&
        (dynframe[RowNum]->cellptr[i].GetSpriteIndex() >= 0))
    {
      PSkitRow->MakeCellIfNull(i);
      CopyCell(PSkitRow->GetSkitCell(i),&(dynframe[RowNum]->cellptr[i]));
    }
    else
    {
      PSkitRow->ClearCellIfNotNull(i);
    }
  }
}
//*******************************************************************
void TSkitEditorClientWin::CopyCell(TSkitCell *PDestCell,TSkitCell *PSourceCell)
{
  if ((PDestCell == NULL) || (PSourceCell == NULL)) {return;}

  PDestCell->FileMode = PSourceCell->FileMode;
  PDestCell->SetGObjName(PSourceCell->GetGObjName());
  PDestCell->SetGObjIndex(PSourceCell->GetGObjIndex());
  PDestCell->SetSpriteName(PSourceCell->GetSpriteName());
  PDestCell->SetSpriteIndex(PSourceCell->GetSpriteIndex());
  PDestCell->Set_FUC_Length(PSourceCell->Get_FUC_Length());
}
//*******************************************************************
void TSkitEditorClientWin::ClearCell(TSkitCell *PCell)
{
  PCell->SetGObjName("");
  PCell->SetSpriteName("");
  PCell->SetGObjIndex(-1);
  PCell->SetSpriteIndex(-1);
}
//*******************************************************************
void TSkitEditorClientWin::StartDrag(TPoint &point)
{
  if (!dragging)
  {
    dragging = true;
    SetCapture();
    SetCursor(0,IDC_IBEAM);
    int16 frame_at = -1;
    int16 track_at = -1;
    if (ScreenPointToFrameAndTrack(point,frame_at,track_at))
    {
      CopyCell(&DragCell,&(dynframe[frame_at]->cellptr[track_at]));
      ClearCellContents(frame_at,track_at);
      old_frame = frame_at;
      old_track = track_at;
      GetVDFlags().SetSkitDirty();
      Invalidate();
    }
    else
    {
      dragging = false;
      ReleaseCapture();
      SetCursor(0,IDC_ARROW);
    }
  }
}
//*******************************************************************
void TSkitEditorClientWin::EndDrag(TPoint &point)
{
  if (dragging)
  {
    ReleaseCapture();
    int16 frame_at = -1;
    int16 track_at = -1;
    if (ScreenPointToFrameAndTrack(point,frame_at,track_at))
    {
      CopyCell(&(dynframe[frame_at]->cellptr[track_at]),&DragCell);
      GetVDFlags().SetSkitDirty();
    }
    else
    {
      CopyCell(&(dynframe[old_frame]->cellptr[old_track]),&DragCell);
    }
    dragging = false;
    SetCursor(0,IDC_ARROW);
    GetVDFlags().SetSkitDirty();
    Invalidate();
  }
}
//*******************************************************************
void TSkitEditorClientWin::EvLButtonDown(uint modKeys,TPoint &point)
{
  StartDrag(point);
  TWindow::EvLButtonDown(modKeys,point);
}
//*******************************************************************
void TSkitEditorClientWin::EvLButtonUp(uint,TPoint &point)
{
  EndDrag(point);
}
//*******************************************************************
void TSkitEditorClientWin::PromptClearCell(TPoint &point)
{
  int16 frame_at = -1;
  int16 track_at = -1;

  if (ScreenPointToFrameAndTrack(point,frame_at,track_at))
  {
    if (MessageBox("Clear cell contents ?","Danger",
                   MB_OKCANCEL|MB_ICONEXCLAMATION|MB_DEFBUTTON2) == IDOK)
    {
      ClearCellContents(frame_at,track_at);
      GetVDFlags().SetSkitDirty();
      Invalidate();
    }
  }
}
//*******************************************************************
void TSkitEditorClientWin::EvRButtonDown(uint,TPoint &point)
{
  PromptClearCell(point);
}
//*******************************************************************
string TSkitEditorClientWin::GetGObjName()
{
  string str = "Choose Game Object";
  TSelectGObjDlg sgd(this,str);
  if (sgd.Execute() == IDOK)
  {
    string NewGObjName = sgd.RetrieveSelection();
    return (NewGObjName);
  }
  else
  {
    return (string(""));
  }
}
//*******************************************************************
string TSkitEditorClientWin::GetSpriteName(int16 GObjIndex)
{
  string str = "Choose Sprite";
  TSelectSpriteDlg ssd(this,str,GObjIndex);
  if (ssd.Execute() == IDOK)
  {
    string NewSpriteName = ssd.RetrieveSelection();
    return (NewSpriteName);
  }
  else
  {
    return (string(""));
  }
}
//*******************************************************************
void TSkitEditorClientWin::FillCell(TPoint &point)
{
  if (PCurrentSkit == NULL) {return;}

  int16 frame_at = -1;
  int16 track_at = -1;
  if (!ScreenPointToFrameAndTrack(point,frame_at,track_at)) {return;}

  string GObjName = GetGObjName();
  if (GObjName == "") {return;}
  int16 GObjIndex = GetGObjIndex(GObjName);
  if (GObjIndex < 0)
  {
    MessageBox("GObj index was invalid","Error - Fill Cell",MB_OK);
    return;
  }
  string SpriteName = GetSpriteName(GObjIndex);
  if (SpriteName == "") {return;}
  int16 SpriteIndex = GetSpriteIndex(GObjIndex,SpriteName);
  if (SpriteIndex < 0)
  {
    MessageBox("Sprite index was invalid","Error - Fill Cell",MB_OK);
    return;
  }
  int16 SpriteLength = (int16)GetSpritePtr(GObjIndex,SpriteIndex)->Get_FUC_Length();

  dynframe[frame_at]->cellptr[track_at].SetGObjName(GObjName);
  dynframe[frame_at]->cellptr[track_at].SetGObjIndex(GObjIndex);
  dynframe[frame_at]->cellptr[track_at].SetSpriteName(SpriteName);
  dynframe[frame_at]->cellptr[track_at].SetSpriteIndex(SpriteIndex);
  dynframe[frame_at]->cellptr[track_at].Set_FUC_Length(SpriteLength);

  GetVDFlags().SetSkitDirty();

  Invalidate();
}
//*******************************************************************
void TSkitEditorClientWin::EvLButtonDblClk(uint,TPoint &point)
{
  FillCell(point);
}
//*******************************************************************
void TSkitEditorClientWin::ClearCellContents(int16 frame_at,int16 track_at)
{
  ClearCell(&(dynframe[frame_at]->cellptr[track_at]));
  GetVDFlags().SetSkitDirty();
  Invalidate();
}
//*******************************************************************
void TSkitEditorClientWin::SetupWindow()
{
  TGedWin::SetupWindow();

  TRect temp;
  num_frames = NUM_FRAMES;//initial frame count
  for(int16 i = 0; i < NUM_FRAMES; i++)
  {
    dynframe.Add(new TFrameIs8Tracks2);
    for (int16 j = 0; j < NUM_TRACKS; j++)
    {
      temp.left     = LEFT_BORDER + j*(FRAME_HEIGHT + FRAME_SEPARATION);
      temp.right    = temp.left + FRAME_HEIGHT;
      temp.top      = BEFORE_FRAMES + (FRAME_HEIGHT + FRAME_SEPARATION)*i;
      temp.bottom   = temp.top +  FRAME_HEIGHT;

      dynframe[i]->track[j] = temp;
    }
  }
  // MRP - 06/01/99 - ver2.2 - moved from ctor
  Scroller->ScrollTo(LEFT_BORDER,BEFORE_FRAMES);
}                                   
//*******************************************************************
void TSkitEditorClientWin::CheckSaveCurrentSkit()
{
  if (PCurrentSkit == NULL) {return;}
  if (GetVDFlags().IsSkitDirty())
  {
    int retval = MessageBox("Save Current Skit",
                            "Save Modified Skit",
                            MB_YESNO | MB_ICONQUESTION);
    if (retval == IDYES)
    {
      SaveCurrentSkitBail();
    }
  }
}
//*******************************************************************
TSkitEditorClientWin::~TSkitEditorClientWin()
{
  if (PCurrentSkit != NULL)
  {
    delete PCurrentSkit;
    PCurrentSkit = NULL;
    GetVDFlags().ClearSkitDirty();
  }
}
//*******************************************************************
void TSkitEditorClientWin::PaintRect(TDC &dc,int16 Frame,int16 Track)
{
  if ((dynframe[Frame]->cellptr[Track].GetGObjIndex() >= 0) &&
      (dynframe[Frame]->cellptr[Track].GetSpriteIndex() >= 0))
  {
    dc.SelectObject(TBrush(RGB(94,90,83)));
    dc.Rectangle(dynframe[Frame]->track[Track]);
    dc.RestoreBrush();
  }
  else
  {
    dc.Rectangle(dynframe[Frame]->track[Track]);
  }
}
//*******************************************************************
void TSkitEditorClientWin::PaintFrameTrackNum(TDC &dc,int16 Frame,int16 Track)
{
  SetFrameTrackStr(dc,Frame,Track);
  dc.TextOut(dynframe[Frame]->track[Track].left + GetSizeM(dc).cx,
             dynframe[Frame]->track[Track].top + GetOneLineSpacing(),FTStr);
}
//*******************************************************************
void TSkitEditorClientWin::PaintNames(TDC &dc,int16 Frame,int16 Track)
{
  string tempstring = dynframe[Frame]->cellptr[Track].GetGObjName();
  TRect temprect = dynframe[Frame]->track[Track];
  temprect.top += (2*GetOneLineSpacing());
  temprect.left += GetSizeM(dc).cx;
  dc.DrawText(tempstring.c_str(),-1,temprect,DT_WORDBREAK);

  tempstring = dynframe[Frame]->cellptr[Track].GetSpriteName();
  temprect.top += (2*GetOneLineSpacing());
//  temprect.left += GetSizeM(dc).cx;
  dc.DrawText(tempstring.c_str(),-1,temprect,DT_WORDBREAK);
}
//*******************************************************************
void TSkitEditorClientWin::PaintNotFilled(TDC &dc,int16 Frame,int16 Track)
{
//  TRect temp = dynframe[Frame]->track[Track];
//  temp.Inflate(-12,-12);
//  dc.FillRect(temp,TBrush(TColor::LtGray));
//  temp.Inflate(-5,-5);
//  dc.FillRect(temp,TBrush(TColor::LtBlue));
//  temp.Inflate(-5,-5);
//  dc.FillRect(temp,TBrush(TColor::Gray));
//
//  for (int16 lcv=0;lcv<16;lcv++)
//  {
//    temp.Inflate(-5,-5);
//    if ((Frame + Track)%2 == 0)
//    {
//      dc.FillRect(temp,TBrush(RGB(16*lcv,0,256-16*lcv)));
//    }
//    else
//    {
//      dc.FillRect(temp,TBrush(RGB(256-16*lcv,0,16*lcv)));
//    }
//  }
  TColor current_color = dc.SetTextColor(RGB(255,255,0));
  TColor current_bkcolor = dc.SetBkColor(RGB(200,0,25));
  dc.TextOut(dynframe[Frame]->track[Track].left + GetSizeM(dc).cx,
             dynframe[Frame]->track[Track].top + GetOneLineSpacing(),
             FTStr);
  dc.SetTextColor(current_color);
  dc.SetBkColor(current_bkcolor);
}
//*******************************************************************
void TSkitEditorClientWin::PaintFileType(TDC &dc,int16 Frame,int16 Track)
{
  if ((dynframe[Frame]->cellptr[Track].GetGObjIndex() >= 0) &&
      (dynframe[Frame]->cellptr[Track].GetSpriteIndex() >= 0))
  {
    PaintNames(dc,Frame,Track);
    char Temp[25];
    wsprintf(Temp,"frame count = %d",dynframe[Frame]->cellptr[Track].Get_FUC_Length());
    dc.TextOut(dynframe[Frame]->track[Track].left + GetSizeM(dc).cx,
               dynframe[Frame]->track[Track].top + (9 * GetOneLineSpacing()),
               Temp);
  }
  else
  {
    PaintNotFilled(dc,Frame,Track);
  }
}
//*******************************************************************
void TSkitEditorClientWin::Paint(TDC& dc, bool , TRect& )
{
  dc.TextOut(0,0,(const char far*)"Skit Editor");
  for(int16 i = 0; i < num_frames; i++)     //each column =  track
  {
    for (int16 j = 0; j < NUM_TRACKS; j++)//each row    =  frame
    {
      PaintRect(dc,i,j);
      PaintFrameTrackNum(dc,i,j);
      PaintFileType(dc,i,j);
    }
  }
}
//*******************************************************************

