//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  gedskted.h
//    Project Name:  Game Editor
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     7/24/95    M.Perry    original baseline
//  2.0    10/29/97    M.Perry    32-bit conversion.
//  2.2    06/01/99    M.Perry    fixed scroller (debug ver)
//********************************************************************
#if !defined(__gedskted_h)
#define __gedskted_h

#if !defined(__gedskted_rh)
#include "gedskted.rh"
#endif

#if !defined(__gedmodew_h)
#include "gedmodew.h"
#endif

#if !defined(__gedwin_h)
#include "gedwin.h"
#endif

//#include "gedskmsg.h"

#if !defined(__oskitcat_h)
#include "oskitcat.h"
#endif

#if !defined(__osktport_h)
#include "osktport.h"
#endif

#if !defined(__geddef_h)
#include "geddef.h"
#endif

#if !defined(__ogobj_h)
#include "ogobj.h"
#endif

class TSprite;
//*******************************************************************
class TFrameIs8Tracks2
{
public:
  enum {NUM_TRACKS = 8};
  TRect track[NUM_TRACKS];
  TSkitCell cellptr[NUM_TRACKS];
  int operator==(const TFrameIs8Tracks2& thisframe) const;
};
//*******************************************************************
class GEDOWLCLASS TSkitEditorClientWin: public TGedWin
{  //currently quite similar to TSpriteEditorWin, derive??
	enum {NUM_TRACKS = 8};
	enum {NUM_FRAMES = 10};//initial frame count
	enum {MAX_FRAMES =500};
	enum {MIN_FRAMES=0};
	enum {FRAME_DELTA=10};
	enum {FRAME_HEIGHT=200,FRAME_SEPARATION=15,BEFORE_FRAMES=25,LEFT_BORDER=85};
public:
	TSkitEditorClientWin();
   virtual ~TSkitEditorClientWin();

  protected:
  TSize GetSizeM(TDC &dc) {return (dc.GetTextExtent("M",1));}
  int GetOneLineSpacing() {return (FTNumSize.cy);}
  void SetFrameTrackStr(TDC &dc,int16 Frame,int16 Track)
  {
    wsprintf(FTStr,"F%d  T%d",Frame,Track);
    FTNumSize = dc.GetTextExtent(FTStr,sizeof(FTStr));
  }
  TSize FTNumSize;
  char FTStr[20];

  void PaintFileType(TDC &dc,int16 Frame,int16 Track);
  void PaintRect(TDC &dc,int16 Frame,int16 Track);
  void PaintFrameTrackNum(TDC &dc,int16 Frame,int16 Track);
  void PaintNames(TDC &dc,int16 Frame,int16 Track);
  void PaintNotFilled(TDC &dc,int16 Frame,int16 Track);
  void Paint(TDC &dc,bool erase,TRect &r);
  void EvLButtonDblClk(uint modKeys, TPoint& point);
  void EvRButtonDown(uint modKeys, TPoint& point);
  void EvLButtonDown(uint modKeys, TPoint& point);
  void EvLButtonUp(uint modKeys,TPoint& point);
  void EvKeyDown(uint key, uint repeat, uint flags);

  void StartDrag(TPoint &point);
  void EndDrag(TPoint &point);
  void PromptClearCell(TPoint &point);
  string GetGObjName();
  string GetSpriteName(int16 GObjIndex);
  void FillCell(TPoint &point);

public:
  void BackFromPreview();
   int16 CurrentGObjIndex;
   int16 CurrentSkitCatIndex;
   int16 CurrentSkitIndex;
   TSkit *PCurrentSkit;

   void LoadTable();

   TEditorModeWin *GetEditorModeWin()
   {
//     return ((TEditorModeWin *)POgleApp->GetFW()->PModeWin);
     return ((TEditorModeWin *)GetFW()->GetModeWin());
   }

   TSprite *GetSpritePtr(int16 GObjIndex,int16 SpriteIndex) {return (GetGObjPtr(GObjIndex)->GetSpritePtr(SpriteIndex));}
   TGameObject *GetGObjPtr(int16 GObjIndex) {return (GetEditorModeWin()->GetGObjPtr(GObjIndex));}
   TGameObject *GetGObjPtr() {return (GetEditorModeWin()->GetGObjPtr(CurrentGObjIndex));}
   int16 GetGObjIndex(string GObjName) {return (GetEditorModeWin()->GetGObjIndex(GObjName));}
   int16 GetSpriteIndex(int16 GObjIndex,string SpriteName) {return (GetGObjPtr(GObjIndex)->GetSpriteIndex(SpriteName));}
   TSkitTable *GetSkitTable() {return (PCurrentSkit->GetTable());}
   int16 GetTableFrameCount() {return (GetSkitTable()->GetFrameCount());}
   int16 GetSkitTableLastNum() {return (GetSkitTable()->GetLastNum());}
   TSkitRow *GetSkitRow(int16 RowNum) {return (GetSkitTable()->GetSkitRow(RowNum));}
   TSkitList *GetSkitList() {return (GetGObjPtr()->GetSkitList(CurrentSkitCatIndex));}
   TSkit *GetSkitPtrFromList() {return (GetSkitList()->GetSkitPtr(CurrentSkitIndex));}
   TSkitCat *GetSkitCat() {return (GetGObjPtr()->GetSkitCat());}

   void ClearAllUICells();
   void InsertCurrentSkit();
   void ReloadCurrentSkit();
   void SaveCurrentSkit();
   void SaveCurrentSkitBail();
   int16 GetUIRowsCount();
   int16 GetUIValidRowsCount();
   void LoadTableIntoCurrentSkit();
   void MakeEnoughCurrentSkitRows(int16 NumRows);
   void RemoveEnoughSkitRows(int16 LastRow);
   void CopyUIRowToCurrentSkitRow(int16 RowNum);
   void ClearCell(TSkitCell *PCell);
   void CopyCell(TSkitCell *PDestCell,TSkitCell *PSourceCell);
   void CheckSaveCurrentSkit();
   void MakeEnoughUIRows();
   void Add10UIRows(int16 times);
   void Add10UIRows();


   void CmSkitCatNew();
   void CmSkitCatNewEnable(TCommandEnabler &commandHandler);
   void CmSkitCatOpen();
   void CmSkitCatOpenEnable(TCommandEnabler &commandHandler);
   void CmSkitCatDelete();
   void CmSkitCatDeleteEnable(TCommandEnabler &commandHandler);
   void CmSkitCatPortfolio();
   void CmSkitCatPortfolioEnable(TCommandEnabler &commandHandler);
   void CmSkitCatCriteriaReport();
   void CeSkitCatCriteriaReport(TCommandEnabler &enabler);
   void CmSkitCatSpriteUsage();
   void CeSkitCatSpriteUsage(TCommandEnabler &enabler);
   void CmSkitNew();
   void CmSkitNewEnable(TCommandEnabler &commandHandler);
   void CmSkitOpen();
   void CmSkitOpenEnable(TCommandEnabler &commandHandler);
   void CmSkitGet();
   void CmSkitGetEnable(TCommandEnabler &commandHandler);
   void CmSkitSave();
   void CmSkitSaveEnable(TCommandEnabler &commandHandler);
   void CmSkitSaveAs();
   void CmSkitSaveAsEnable(TCommandEnabler &commandHandler);
   void CmSkitDelete();
   void CmSkitDeleteEnable(TCommandEnabler &commandHandler);
   void CmSkitWipe();
   void CmSkitWipeEnable(TCommandEnabler &commandHandler);
   void CmSkitAddFrames();
   void CmSkitAddFramesEnable(TCommandEnabler &commandHandler);
   void CmSkitPreview();
   void CmSkitPreviewEnable(TCommandEnabler &commandHandler);
   void CmSkitCriteria();
   void CmSkitCriteriaEnable(TCommandEnabler &commandHandler);
   void CmSkitInfo();
   void CmSkitInfoEnable(TCommandEnabler &commandHandler);
   void CmSkitExit();
   void CmSkitExitEnable(TCommandEnabler &commandHandler);
   void CmSkitNull();
   void CeSkitNull(TCommandEnabler &commandHandler);

protected:
	int16  num_frames;//current frame count
	virtual void SetupWindow();
   bool GetNewSkitCatName(string &skitcatname);
   bool IsNameInSkitCats(string &skitcatname);
   bool GetNewSkitName(string &skitname);
   bool IsNameInSkitList(string &skitname);
private:
	TIArrayAsVector<TFrameIs8Tracks2> dynframe;
	bool ScreenPointToFrameAndTrack(TPoint pt,int16& frame_found,int16& track_found);
	int16 m_screen_height,m_screen_width;
	bool dragging;
	int16 old_frame; int16 old_track;
	TSkitCell DragCell;
	void ClearCellContents(int16 frame_at,int16 track_at);

public:
   void PostSwitchToModeWin()
   {
  //   (new TGedSwitchFromSkitEdToModeEdMsg())->Post();
     TSwToMEdMsg().PostToFW();
   }

   void PostSwitchToModeWinPreview()
   {
//     (new TGedSwitchFromSkitEdToModeEdPreviewMsg())->Post();
     TSkitPreviewMsg().PostToFW();
   }

   virtual void BeenSwitchedTo();

	DECLARE_RESPONSE_TABLE(TSkitEditorClientWin);
};//end class TSkitEditorClientWin
//*******************************************************************
#endif

