//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  gedspred.cpp
//    Project Name:  Game Editor
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     7/24/95    M.Perry    original baseline
//  2.0    10/29/97    M.Perry    32-bit conversion.
//********************************************************************
#if !defined(__gedspred_h)
#include "gedspred.h"
#endif

#if !defined(__gedapp_h)
#include "gedapp.h"
#endif

#if !defined(__IOSTREAM_H)
#include <iostream.h>
#endif

#if !defined(__FSTREAM_H)
#include <fstream.h>
#endif

#if !defined(__ogobjlst_h)
#include "ogobjlst.h"
#endif

#if !defined(__ofilemgr_h)
#include "ofilemgr.h"
#endif

#if !defined(__gediddlg_h)
#include "gediddlg.h"
#endif

#if !defined(__osmsgdlg_h)
#include "osmsgdlg.h"
#endif

//#include "omisc.h"
//*******************************************************************
int TFrameIs8Tracks::operator==(const TFrameIs8Tracks& thisframe)const
{
	return (this == &thisframe);
}
//*******************************************************************
//*******************************************************************
DEFINE_RESPONSE_TABLE1(TSpriteEditorClientWin,TGedWin)
  EV_WM_KEYDOWN,
  EV_WM_LBUTTONDBLCLK,
  EV_WM_RBUTTONDOWN,
  EV_WM_LBUTTONDOWN,
  EV_WM_LBUTTONUP,
  EV_COMMAND(CM_SPRITENEW,CmSpriteNew),
  EV_COMMAND_ENABLE(CM_SPRITENEW,CmSpriteNewEnable),
  EV_COMMAND(CM_SPRITEOPEN,CmSpriteOpen),
  EV_COMMAND_ENABLE(CM_SPRITEOPEN,CmSpriteOpenEnable),
  EV_COMMAND(CM_SPRITEGET,CmSpriteGet),
  EV_COMMAND_ENABLE(CM_SPRITEGET,CmSpriteGetEnable),
  EV_COMMAND(CM_SPRITESAVE,CmSpriteSave),
  EV_COMMAND_ENABLE(CM_SPRITESAVE,CmSpriteSaveEnable),
  EV_COMMAND(CM_SPRITESAVEAS,CmSpriteSaveAs),
  EV_COMMAND_ENABLE(CM_SPRITESAVEAS,CmSpriteSaveAsEnable),
  EV_COMMAND(CM_SPRITEDELETE,CmSpriteDelete),
  EV_COMMAND_ENABLE(CM_SPRITEDELETE,CmSpriteDeleteEnable),
  EV_COMMAND(CM_SPRITEWIPE,CmSpriteWipe),
  EV_COMMAND_ENABLE(CM_SPRITEWIPE,CmSpriteWipeEnable),
  EV_COMMAND(CM_SPRITEADDFRAMES,CmSpriteAddFrames),
  EV_COMMAND_ENABLE(CM_SPRITEADDFRAMES,CmSpriteAddFramesEnable),
  EV_COMMAND(CM_SPRITEEDITSPRITETYPES,CmSpriteEditSpriteTypes),
  EV_COMMAND_ENABLE(CM_SPRITEEDITSPRITETYPES,CmSpriteEditSpriteTypesEnable),
  EV_COMMAND(CM_SPRITEEDITTYPE,CmSpriteEditType),
  EV_COMMAND_ENABLE(CM_SPRITEEDITTYPE,CmSpriteEditTypeEnable),
  EV_COMMAND(CM_SPRITEPREVIEW,CmSpritePreview),
  EV_COMMAND_ENABLE(CM_SPRITEPREVIEW,CmSpritePreviewEnable),
  EV_COMMAND(CM_SPRITEINFO,CmSpriteInfo),
  EV_COMMAND_ENABLE(CM_SPRITEINFO,CmSpriteInfoEnable),
  EV_COMMAND(CM_SPRITELENGTH,CmSpriteLength),
  EV_COMMAND_ENABLE(CM_SPRITELENGTH,CmSpriteLengthEnable),
  EV_COMMAND(CM_SPRITEEDITXYZ,CmSpriteEditXYZ),
  EV_COMMAND_ENABLE(CM_SPRITEEDITXYZ,CmSpriteEditXYZEnable),
  EV_COMMAND(CM_SPRITEEXIT,CmSpriteExit),
  EV_COMMAND_ENABLE(CM_SPRITEEXIT,CmSpriteExitEnable),
  EV_COMMAND(CM_SPRITEREPORT,CmSpriteReport),
  EV_COMMAND_ENABLE(CM_SPRITEREPORT,CeSpriteReport),
  EV_COMMAND(CM_SPRITE_IDCODE,CmSpriteIDCode),
  EV_COMMAND_ENABLE(CM_SPRITE_IDCODE,CeSpriteIDCode),
  EV_COMMAND(CM_SPRITEIDCONFLICT,CmSpriteIDConflict),
  EV_COMMAND_ENABLE(CM_SPRITEIDCONFLICT,CeSpriteIDConflict),
  EV_COMMAND(CM_SPRITEIDUSAGE,CmSpriteIDUsage),
  EV_COMMAND_ENABLE(CM_SPRITEIDUSAGE,CeSpriteIDUsage),
END_RESPONSE_TABLE;
//*******************************************************************
void TSpriteEditorClientWin::CmSpriteIDConflict()
{
  TSpriteList *pspl = GetSpriteList();
  if (pspl != NULL)
  {
    pspl->CheckSpriteIDConflicts(true);
  }
  else
  {
    MessageBox("PSpriteList == NULL","Warning - Sprites",MB_OK | MB_TASKMODAL);
  }
}
//*******************************************************************
void TSpriteEditorClientWin::CeSpriteIDConflict(TCommandEnabler &ce)
{
  ce.Enable(GetVDFlags().IsGObjValid());
}
//*******************************************************************
void TSpriteEditorClientWin::CmSpriteIDUsage()
{
  TSpriteList *pspl = GetSpriteList();
  if (pspl != NULL)
  {
    // check id conflicts first, then check for missing.
    pspl->CheckSpriteIDConflicts(false);

    // then do actual id code usage.
    pspl->CheckSpriteIDUsage(true);
  }
  else
  {
    MessageBox("PSpriteList == NULL","Warning - Sprites",MB_OK|MB_TASKMODAL);
  }
}
//*******************************************************************
void TSpriteEditorClientWin::CeSpriteIDUsage(TCommandEnabler &ce)
{
  ce.Enable(GetVDFlags().IsGObjValid());
}
//*******************************************************************
void TSpriteEditorClientWin::ClearAllUICells()
{
  int16 RowCount = GetUIRowsCount();
  for (int16 i = 0;i < RowCount;i++)
  {
    for (int16 j = 0;j < 8;j++)
    {
      ClearCell(&(dynframe[i]->cellptr[j]));
    }
  }
  Invalidate();
}
//*******************************************************************
bool TSpriteEditorClientWin::IsNameInSpriteList(string spritefname)
{
  if (GetSpriteList()->GetSpriteIndex(spritefname) >= 0) {return true;}
  else {return false;}
}
//*******************************************************************
bool TSpriteEditorClientWin::GetNewSpriteName(string &spritename)
{
  string strroot = GetFileMgr()->GetCDRomPath(-1);
  string str = "Sprite Files (*.sp) | *.sp";
  string strinitialdir = strroot;
  char *pidc = const_cast<char *>(strinitialdir.c_str());
  char *pc = const_cast<char *>(str.c_str());
  TOpenSaveDialog::TData sprsavedata(0,pc,0,pidc,"*");

  #if !defined(OGLEOWLVER2) && defined(BI_PLAT_WIN32)
  sprsavedata.Flags &= (~OFN_EXPLORER);
  #endif

  TFileSaveDialog osd(this,sprsavedata);
  if (osd.Execute() != IDOK)
  {
    return false;
  }
  string s = sprsavedata.FileName;
  s = s.strip(string::Both);
  s.to_lower();
  TOgleFileName ofnsave(s);
  ofnsave.SetExt(".sp");

  if (ofnsave.FileExists())
  {
    MessageBox("Dest file already existed","Error - New Sprite Name",MB_OK | MB_TASKMODAL);
    return false;
  }

  TOgleFileName ofndir(ofnsave);

  if (!ofnsave.RemoveRoot(GetFileMgr()->GetCDRomPath(-1)))
  {
    MessageBox("Dest file wasn't in logical root",
               "Error - New Sprite Name",
               MB_OK | MB_TASKMODAL);
    return false;
  }

  if (!ofndir.CreateDir())
  {
    MessageBox("Dest dir couldn't be created",
               "Error - New Sprite Name",
               MB_OK | MB_TASKMODAL);
    return false;
  }
  spritename = ofnsave.GetStr();
  return true;
}
//*******************************************************************
void TSpriteEditorClientWin::CmSpriteNew()
{
  string spritename;
  if (!GetNewSpriteName(spritename))
  {
    MessageBox("Error getting name","Sprite - New",MB_OK);
    return;
  }
  else
  {
    if (IsNameInSpriteList(spritename))
    {
      MessageBox("Sprite name already exists for this gobj","Error !! Sprite - New",MB_OK);
      return;
    }

    CheckSaveCurrentSprite();
    ClearAllUICells(); // note: just moved after checksave recently.

    CurrentSpriteIndex = GetGObjPtr()->CreateAddSprite(spritename);
    if (CurrentSpriteIndex < 0)
    {
      MessageBox("Couldn't add sprite to spritelist - Unknown reason","Error!! Sprite - New",MB_OK);
      return;
    }

    GetSpriteList()->Save();
    LoadTable();
    GetVDFlags().ClearSpriteDirty();
    GetVDFlags().SetSpriteValid();
    #ifdef GEDMSGBOX
    MessageBox("New Sprite added to Current GObj's spritelist","Sprite - New",MB_OK);
    #endif
  }
}
//*******************************************************************
void TSpriteEditorClientWin::CmSpriteNewEnable(TCommandEnabler &commandHandler)
{
  commandHandler.Enable(true);
}
//*******************************************************************
void TSpriteEditorClientWin::CmSpriteOpen()
{
  string str = "Sprite Open";
  TSelectSpriteDlg ssd(this,str);
  if (ssd.Execute() == IDOK)
  {
    CheckSaveCurrentSprite();
    ClearAllUICells();

    string NewSpriteName = ssd.RetrieveSelection();
    #ifdef GEDMSGBOX
    string mstr = "Sprite Name -> " + NewSpriteName;
    MessageBox(mstr.c_str(),"Sprite Name Selected",MB_OK);
    #endif
    CurrentSpriteIndex = GetSpriteIndex(NewSpriteName);
    LoadTable();
    GetVDFlags().ClearSpriteDirty();
    GetVDFlags().SetSpriteValid();
    #ifdef GEDMSGBOX
    MessageBox("Sprite Opened","Sprite - Open",MB_OK);
    #endif
  }
  #ifdef GEDMSGBOX
  else
  {
    MessageBox("Sprite Open cancelled","Sprite - Open",MB_OK);
  }
  #endif
}
//*******************************************************************
void TSpriteEditorClientWin::CmSpriteOpenEnable(TCommandEnabler &commandHandler)
{
  commandHandler.Enable(true);
}
//*******************************************************************
void TSpriteEditorClientWin::CmSpriteGet()
{
  MessageBox("Not Implemented Yet","Sprites - Get",MB_OK);
}
//*******************************************************************
void TSpriteEditorClientWin::CmSpriteGetEnable(TCommandEnabler &commandHandler)
{
  commandHandler.Enable(false);
}
//*******************************************************************
void TSpriteEditorClientWin::InsertCurrentSprite()
{
  GetSpriteList()->SwapSprites(CurrentSpriteIndex,PCurrentSprite);
}
//*******************************************************************
void TSpriteEditorClientWin::ReloadCurrentSprite()
{
  LoadTable();
  GetVDFlags().ClearSpriteDirty();
}
//*******************************************************************
void TSpriteEditorClientWin::SaveCurrentSprite()
{
  SaveCurrentSpriteBail();
  ReloadCurrentSprite();
  // for some reason must save twice.
  SaveCurrentSpriteBail();
  ReloadCurrentSprite();
}
//*******************************************************************
void TSpriteEditorClientWin::LoadTableIntoCurrentSprite()
{
  int16 LastUINum = int16(GetUIValidRowsCount() - 1);
  int16 CurrentSpriteLastRow = GetSpriteTable()->GetLastNum();
  if (LastUINum < CurrentSpriteLastRow)
  {
    RemoveEnoughSpriteRows(LastUINum);
  }
  else if (LastUINum > CurrentSpriteLastRow)
  {
    MakeEnoughCurrentSpriteRows(LastUINum);
  }
  for (int16 i=0; i<=LastUINum;i++)
  {
    CopyUIRowToCurrentSpriteRow(i);
  }

  Invalidate();
}
//*******************************************************************
void TSpriteEditorClientWin::SaveCurrentSpriteBail()
{
  LoadTableIntoCurrentSprite();

  TSprite *PSprite = GetSpritePtrFromList();
  InsertCurrentSprite();
  if (!(PCurrentSprite->Is_FUC_Override()))
  {
    PCurrentSprite->Set_FUC_Length(PCurrentSprite->GetCalcFUCLength());
  }
  PCurrentSprite->Save();
  delete PSprite;
  PCurrentSprite = NULL;
  GetVDFlags().ClearSpriteDirty();
  ClearAllUICells();
  #ifdef GEDMSGBOX
  MessageBox("Sprite saved to disk","Save",MB_OK | MB_ICONEXCLAMATION);
  #endif
}
//*******************************************************************
void TSpriteEditorClientWin::CmSpriteSave()
{
  SaveCurrentSprite();
}
//*******************************************************************
void TSpriteEditorClientWin::CmSpriteSaveEnable(TCommandEnabler &commandHandler)
{
  if ((GetVDFlags().IsSpriteDirty()) &&
      (GetVDFlags().IsSpriteValid()))
  {
    commandHandler.Enable(true);
  }
  else
  {
    commandHandler.Enable(false);
  }

}
//*******************************************************************
void TSpriteEditorClientWin::CmSpriteSaveAs()
{
  int16 x = GetSpritePtrFromList()->GetStartingX();
  int16 y = GetSpritePtrFromList()->GetStartingY();
  int16 z = GetSpritePtrFromList()->GetStartingZ();

  string NewSpriteFName;
  if (!GetNewSpriteName(NewSpriteFName))
  {
    MessageBox("Error getting name","Sprite - New",MB_OK);
    return;
  }
  else
  {
    if (IsNameInSpriteList(NewSpriteFName))
    {
      string s = "The name ";
      s += NewSpriteFName;
      s += "already exists";
      MessageBox(s.c_str(),"Save As Error",MB_OK);
      return;
    }
    CurrentSpriteIndex = GetGObjPtr()->CreateAddSprite(NewSpriteFName);
    GetSpriteList()->Save();
    GetSpritePtrFromList()->SetStartingXYZ(x,y,z);
    GetSpritePtrFromList()->Save();

    TFileMode FM = GetSpritePtrFromList()->FileMode;
    FM.SetRamImmed();
    FM.Name = GetSpritePtrFromList()->FileMode.Name;
    PCurrentSprite = new TSprite(GetSpriteList()->PModeWin,FM);
    SaveCurrentSprite();

    GetVDFlags().ClearSpriteDirty();
    GetSpriteList()->Save();
  }
}
//*******************************************************************
void TSpriteEditorClientWin::CmSpriteSaveAsEnable(TCommandEnabler &commandHandler)
{
  if ((GetVDFlags().IsSpriteValid()) && (!GetVDFlags().IsSpriteDirty()))
  {
    commandHandler.Enable(true);
  }
  else
  {
    commandHandler.Enable(false);
  }
}
//*******************************************************************
bool TSpriteEditorClientWin::IsSpriteUsedBySkit(int16 gobjindex,int16 spriteindex)
{
  TGameObject *pgobj = GetGObjList()->GetGObjPtr(gobjindex);
  if (pgobj == NULL) {return false;}
  TSprite *psprite = pgobj->GetSpritePtr(spriteindex);
  if (psprite == NULL) {return false;}

  int16 usedgi = -1;
  int16 usedskci = -1;
  int16 usedski = -1;
  string gname;
  string skcname;
  string skname;

  if (GetGObjList()->IsSpriteUsedBySkit(gobjindex,spriteindex,usedgi,usedskci,usedski))
  {
    TGameObject *pgobj = GetGObjList()->GetGObjPtr(usedgi);
    if (pgobj != NULL)
    {
      gname = pgobj->FileMode.Name.GetStr();
      TSkitList *pskitlist = pgobj->GetSkitList(usedskci);
      if (pskitlist != NULL)
      {
        skcname = pskitlist->FileMode.Name.GetStr();
        TSkit *pskit = pskitlist->GetSkitPtr(usedski);
        if (pskit != NULL)
        {
          skname = pskit->FileMode.Name.GetStr();
        }
      }
    }
    string s = "GObj: ";
    s += pgobj->FileMode.Name.GetStr();
    s += "     Sprite: ";
    s += psprite->FileMode.Name.GetStr();
    s += " used by ...\n\nGObj: ";
    s += gname;
    s += "\nSkitList: ";
    s += skcname;
    s += "\nSkit: ";
    s += skname;
    MessageBox(s.c_str(),"Sprite Being Used",MB_OK);
    return true;
  }
  return false;
}
//*******************************************************************
void TSpriteEditorClientWin::CmSpriteDelete()
// note: currently not deleting .sp file from cd dir, should get cddrive,cddir,name and
//       go delete the darn thing.
{
//  int retvalue = MessageBox("Unsafe delete,verify that no skits use sprite first","Warning",MB_OKCANCEL);
//  if (retvalue == IDCANCEL) {return;}

  string str = "Sprite Delete";
  TSelectSpriteDlg ssd(this,str);
  if (ssd.Execute() == IDOK)
  {
    string NewSpriteName = ssd.RetrieveSelection();
    int16 si = GetSpriteIndex(NewSpriteName);
    if (si == CurrentSpriteIndex)
    {
      MessageBox("Cannot delete current sprite","Sprite Delete",MB_OK);
      return;
    }

    if (IsSpriteUsedBySkit(CurrentGObjIndex,si)) {return;}

    if (!GetSpriteList()->DeleteSprite(NewSpriteName))
    {
      MessageBox("Delete Failed","Sprite Delete",MB_OK);
      return;
    }
    GetSpriteList()->Save();
  }
}
//*******************************************************************
void TSpriteEditorClientWin::CmSpriteDeleteEnable(TCommandEnabler &commandHandler)
{
  commandHandler.Enable(true);
}
//*******************************************************************
void TSpriteEditorClientWin::CmSpriteWipe()
{
  MessageBox("Not Implemented Yet","Sprites - Wipe",MB_OK);
}
//*******************************************************************
void TSpriteEditorClientWin::CmSpriteWipeEnable(TCommandEnabler &commandHandler)
{
  commandHandler.Enable(false);
}
//*******************************************************************
void TSpriteEditorClientWin::CmSpriteEditSpriteTypes()
{
  TEditSpriteTypesDlg *PESTD = new TEditSpriteTypesDlg(this);
  PESTD->Execute();
  delete PESTD;
  PESTD = NULL;
  GetSpriteList()->SetIndexes();
  GetVDFlags().SetGObjDirty();
}
//*******************************************************************
void TSpriteEditorClientWin::CmSpriteEditSpriteTypesEnable(TCommandEnabler &commandHandler)
{
  if (GetVDFlags().IsGObjValid())
  {
    commandHandler.Enable(true);
  }
  else
  {
    commandHandler.Enable(false);
  }
}
//*******************************************************************
void TSpriteEditorClientWin::CmSpriteEditType()
{
  string str = "Select Sprite Type";
  TSelectSpriteTypeDlg sstd(this,str);
  if (sstd.Execute() == IDOK)
  {
    int16 sprtypeIndex = (int16)sstd.RetrieveIndex();
    if (sprtypeIndex < 0) {sprtypeIndex = 0;}
    PCurrentSprite->SetType(sprtypeIndex);
    GetVDFlags().SetSpriteDirty();
  }
}
//*******************************************************************
void TSpriteEditorClientWin::CmSpriteEditTypeEnable(TCommandEnabler &commandHandler)
{
  if (GetVDFlags().IsSpriteValid())
  {
    commandHandler.Enable(true);
  }
  else
  {
    commandHandler.Enable(false);
  }
}
//*******************************************************************
void TSpriteEditorClientWin::CmSpritePreview()
{
  if (GetVDFlags().IsSpriteDirty())
  {
    int retval = MessageBox("You must save current sprite before you can preview, Save ?",
                            "Sprites - Preview",MB_YESNO | MB_ICONQUESTION);
    if (retval == IDYES)
    {
      SaveCurrentSprite();
    }
    else
    {
      MessageBox("Preview Cancelled","Sprites - Preview",MB_OK);
      return;
    }
  }

  #ifdef GEDMSGBOX
  MessageBox("About to switch to mode win","Sprites - Preview",MB_OK);
  #endif
  GetEditorModeWin()->SetPreviewSprite(CurrentGObjIndex,CurrentSpriteIndex);
  PostSwitchToModeWinPreview();
}
//*******************************************************************
void TSpriteEditorClientWin::CmSpritePreviewEnable(TCommandEnabler &commandHandler)
{
  if (GetVDFlags().IsSpriteValid())
  {
    commandHandler.Enable(true);
  }
  else
  {
    commandHandler.Enable(false);
  }
}
//*******************************************************************
void TSpriteEditorClientWin::CmSpriteInfo()
{
  string GObjName = GetGObjPtr()->FileMode.Name.GetStr();
  string SpriteName;
  string stridcode;
  int16 FUC_Length;
  string FUCStr;
  string SpriteTypeName;
  string strx;
  string stry;
  string strz;

  if (PCurrentSprite == NULL)
  {
    SpriteName = "?";
    stridcode = "?";
    FUCStr = "?";
    SpriteTypeName = "?";
    strx = "?";
    stry = "?";
    strz = "?";
  }
  else
  {
    char buffer[33];
    itoa(PCurrentSprite->GetIDCode(),buffer,10);
    SpriteName = PCurrentSprite->FileMode.Name.GetStr();
    stridcode = buffer;
    FUCStr = itoa((int)PCurrentSprite->Get_FUC_Length(),buffer,10);
    int16 sprtypeIndex = PCurrentSprite->GetType();
    SpriteTypeName = GetSpriteList()->GetTypeName(sprtypeIndex);
    strx = itoa(PCurrentSprite->GetStartingX(),buffer,10);
    stry = itoa(PCurrentSprite->GetStartingY(),buffer,10);
    strz = itoa(PCurrentSprite->GetStartingZ(),buffer,10);
  }

  string msg_str_array[6];
  msg_str_array[0] = "GObj name: " + GObjName;
  msg_str_array[1] = "Sprite name: " + SpriteName;
  msg_str_array[2] = "IDCode: " + stridcode;
  msg_str_array[3] = "Spr FUC length: " + FUCStr;
  msg_str_array[4] = "Spr Type name: " + SpriteTypeName;
  msg_str_array[5] = "Start XYZ: " + strx + "," + stry + "," + strz;

  TScrollMsgDlg *psmd = new TScrollMsgDlg(this,string("Sprite - Info"),msg_str_array,6);
  psmd->Execute();
  delete psmd;
}
//*******************************************************************
void TSpriteEditorClientWin::CmSpriteInfoEnable(TCommandEnabler &commandHandler)
{
  commandHandler.Enable(true);
}
//*******************************************************************
void TSpriteEditorClientWin::CmSpriteIDCode()
{
  if (PCurrentSprite == NULL) {return;}

  TOgleFileName ofn = GetFileMgr()->GetCDRomPath(-1);//GetGObjPtr()->FileMode.GetDirIndex());
  ofn.AppendDirPath(GetGObjPtr()->FileMode.Name.GetDirPath());
  ofn.SetFName(GetGObjPtr()->FileMode.Name.GetFName());
  ofn.SetExt(string(".idc"));

  TSelectIDNameDlg *pd = new TSelectIDNameDlg(this,
                                              ofn.GetStr(),//path,
                                              PCurrentSprite->GetIDCode(),
                                              PCurrentSprite->FileMode.Name.GetStr());
  int retvalue = pd->Execute();
  if (retvalue == IDOK)
  {
    int16 id = (int16)pd->GetSelectedIndex();
    PCurrentSprite->SetIDCode(id);
    GetVDFlags().SetSpriteDirty();
  }
}
//*******************************************************************
void TSpriteEditorClientWin::CeSpriteIDCode(TCommandEnabler &ce)
{
  if (PCurrentSprite != NULL)
  {
    ce.Enable(true);
  }
  else
  {
    ce.Enable(false);
  }
}
//*******************************************************************
void TSpriteEditorClientWin::CmSpriteLength()
{
  bool FUC_Length_Override = PCurrentSprite->Is_FUC_Override();
  int16 CalcLen = (int16)PCurrentSprite->GetCalcFUCLength();
  int16 len = (int16)PCurrentSprite->Get_FUC_Length();
  char buffer[50];
  string lenstr = itoa(len,buffer,10);
  string clenstr = itoa(CalcLen,buffer,10);
  int retval;
  if (FUC_Length_Override)
  {
    string str = "OVERRIDDEN (" + lenstr + ") \n";
    str += "Use calc'd length (" + clenstr + ") ?";
    retval = MessageBox(str.c_str(),
                        "Sprite - Length",MB_YESNO | MB_ICONQUESTION);
    if (retval == IDYES)
    {
      PCurrentSprite->Clear_FUC_Override();
      PCurrentSprite->Set_FUC_Length(CalcLen);
      GetVDFlags().SetSpriteDirty();
    }
  }
  else
  {
    string MsgStr = "Override Calculated  \n sprite length (" + lenstr + ") ?";
    retval = MessageBox(MsgStr.c_str(),"Sprite - Length",MB_YESNO | MB_ICONQUESTION);
    if (retval == IDYES)
    {
      string gistr = "Enter New Sprite Length (" + lenstr + ")";
      int16 NewFUCLen = (int16)GetInt(gistr.c_str());
      PCurrentSprite->Set_FUC_Override();
      PCurrentSprite->Set_FUC_Length(NewFUCLen);
      GetVDFlags().SetSpriteDirty();
    }
  }
}
//*******************************************************************
void TSpriteEditorClientWin::CmSpriteEditXYZ()
{
  if (PCurrentSprite == NULL) {return;}

  int16 enteredint;
  int16 tempint;
  string str;
  char buffer[50];

  // Get X
  tempint = PCurrentSprite->GetStartingX();
  str = "Edit Starting X (";
  str += itoa(tempint,buffer,10);
  str += ") ?";
  enteredint = (int16)GetInt(str.c_str());
  PCurrentSprite->SetStartingX(enteredint);

  // Get Y
  tempint = PCurrentSprite->GetStartingY();
  str = "Edit Starting Y (";
  str += itoa(tempint,buffer,10);
  str += ") ?";
  enteredint = (int16)GetInt(str.c_str());
  PCurrentSprite->SetStartingY(enteredint);

  // Get Z
  tempint = PCurrentSprite->GetStartingZ();
  str = "Edit Starting Z (";
  str += itoa(tempint,buffer,10);
  str += ") ?";
  enteredint = (int16)GetInt(str.c_str());
  PCurrentSprite->SetStartingZ(enteredint);
  GetVDFlags().SetSpriteDirty();
}
//*******************************************************************
void TSpriteEditorClientWin::CmSpriteEditXYZEnable(TCommandEnabler &commandHandler)
{
  if (GetVDFlags().IsSpriteValid())
  {
    commandHandler.Enable(true);
  }
  else
  {
    commandHandler.Enable(false);
  }
}
//*******************************************************************
void TSpriteEditorClientWin::CmSpriteLengthEnable(TCommandEnabler &commandHandler)
{
  if (GetVDFlags().IsSpriteValid())
  {
    commandHandler.Enable(true);
  }
  else
  {
    commandHandler.Enable(false);
  }
}
//*******************************************************************
void TSpriteEditorClientWin::CmSpriteExit()
{
  CheckSaveCurrentSprite();
  GetEditorModeWin()->ClearPreviews();
  GetVDFlags().ClearSpriteValid();

  #ifdef GEDMSGBOX
  MessageBox("About to switch to mode win","Sprites - Exit",MB_OK);
  #endif

  PostSwitchToModeWin();
}
//*******************************************************************
void TSpriteEditorClientWin::CmSpriteExitEnable(TCommandEnabler &commandHandler)
{
  commandHandler.Enable(true);
}
//*******************************************************************
void TSpriteEditorClientWin::LoadTable()
{
  TSprite *PSprite = GetSpritePtrFromList();

  TFileMode FM = PSprite->FileMode;
  FM.SetRamImmed();
  FM.SetHDImmed();

  FM.SetNonShareable();  //insure new copy of data used.

  TSprite *PNewSprite = new TSprite(PSprite->PModeWin,FM);
  PCurrentSprite = PNewSprite;
  MakeEnoughUIRows();

  int16 fc = PNewSprite->GetTable()->GetFrameCount();
  for (int16 i=0;i < fc;i++)
  {
    for (int16 j=0;j < 8;j++)
    {
      CopyCell(&(dynframe[i]->cellptr[j]),
               PNewSprite->GetTable()->GetSpriteCell(i,j));
    }
  }
  Invalidate();
}
//*******************************************************************
TSpriteEditorClientWin::TSpriteEditorClientWin()
    :dynframe(MAX_FRAMES,MIN_FRAMES,FRAME_DELTA)
{
  // MRP - 06/01/99 - ver2.2
  Attr.W = 640;
  Attr.H = 480;

  //scroller may need to change when frame count increases
  Attr.Style |= WS_VSCROLL | WS_HSCROLL;
  m_screen_height = BEFORE_FRAMES + (NUM_FRAMES * FRAME_HEIGHT) +
						  ((NUM_FRAMES - 1) * FRAME_SEPARATION); //2160
  m_screen_width  = LEFT_BORDER + (FRAME_WIDTH/*HEIGHT*/ * NUM_TRACKS) +
						  ((NUM_TRACKS - 1) * FRAME_SEPARATION);//1790
  Scroller = new TScroller(this,1,1,m_screen_width,m_screen_height);
  Scroller->XLine = FRAME_WIDTH/*HEIGHT*/ + FRAME_SEPARATION;
  Scroller->YLine = FRAME_HEIGHT + FRAME_SEPARATION;

  // MRP - 06/01/99 - ver 2.2
  // the following line moved to SetupWindow() to fix debug
  // exception, Scroller needs a valid HWND before this call.
  //  Scroller->ScrollTo(LEFT_BORDER,BEFORE_FRAMES);

  dragging = false;
  PCurrentSprite = NULL;
  GetVDFlags().ClearSpriteDirty();
  CurrentGObjIndex = -1;
  CurrentSpriteIndex = -1;
}//end ctor
//*******************************************************************
void TSpriteEditorClientWin::BeenSwitchedTo()
{
  GetFW()->AssignMenu(SPRITEMENU);
  CurrentGObjIndex = GetEditorModeWin()->CurrentGObjIndex;
  dragging = false;
  PCurrentSprite = NULL;
  GetVDFlags().ClearSpriteDirty();
  ClearAllUICells();
}
//*******************************************************************
void TSpriteEditorClientWin::BackFromPreview()
{
  GetFW()->AssignMenu(SPRITEMENU);
  dragging = false;
  Invalidate();
}
//*******************************************************************
void TSpriteEditorClientWin::EvKeyDown(uint key, uint, uint)
{
	switch(key)
	{
	  case VK_F1:
       if (GetVDFlags().IsSpriteValid())
       {
         CmSpritePreview();
       }
       else
       {
         MessageBox("Sprite not valid","Sprite - Preview",MB_OK);
       }
		  break;
	}
}
//*******************************************************************
void TSpriteEditorClientWin::MakeEnoughUIRows()
{
  int16 size = GetUIRowsCount();
  int16 count = GetTableFrameCount();
  if (size < count)
  {
    int16 delta = int16(count - size);
    int16 times = int16((delta / 10) + 1);
    Add10UIRows(times);
  }
}
//*******************************************************************
void TSpriteEditorClientWin::Add10UIRows(int16 times)
{
  for (int16 i = 0;i <= times;i++)
  {
    Add10UIRows();
  }
}
//*******************************************************************
void TSpriteEditorClientWin::Add10UIRows()
{
  for (int16 o = 0;o<10;o++)
	{
		dynframe.Add(new TFrameIs8Tracks);

		TRect temp;
		for (int16 j = 0; j < NUM_TRACKS; j++)
		{
			temp.left     = LEFT_BORDER + j*(FRAME_WIDTH/*HEIGHT*/ + FRAME_SEPARATION);
			temp.right    = temp.left + FRAME_WIDTH/*HEIGHT*/;
			temp.top      = BEFORE_FRAMES + (FRAME_HEIGHT + FRAME_SEPARATION)*num_frames;
			temp.bottom   = temp.top +  FRAME_HEIGHT;

			dynframe[num_frames]->track[j] = temp;
		}
		num_frames++;
	}
	m_screen_height = int16(BEFORE_FRAMES +
                          (num_frames * FRAME_HEIGHT) +
						        ((NUM_FRAMES - 1) * FRAME_SEPARATION));
	Scroller->SetRange(m_screen_width,m_screen_height);
	Invalidate();
}
//*******************************************************************
void TSpriteEditorClientWin::CmSpriteAddFrames() //adds ten frame rows at once
{
  Add10UIRows();
}
//*******************************************************************
void TSpriteEditorClientWin::CmSpriteAddFramesEnable(TCommandEnabler &commandHandler)
{
  commandHandler.Enable(true);
}
//*******************************************************************
void TSpriteEditorClientWin::CmSpriteReport()
{
//  string str = "c:\\";
//  str += GetSpriteList()->FileMode.Name.GetFName();
//  str += ".rpt";

  TOgleFileName ofn(GetFileMgr()->GetCDRomPath(-1));
  ofn.AppendDirPath("\\reports\\sprites");
  ofn.AppendDirPath(GetSpriteList()->FileMode.Name.GetDirPath());
  ofn.SetFName(GetSpriteList()->FileMode.Name.GetFName());
  ofn.SetExt(".rpt");
  ofn.CreateDir();

//  ofstream os(str.c_str());
  ofstream os(ofn.GetStr().c_str());
  if (!os) {MessageBox("problem with output file","Error - Sprite Report",MB_OK);}
  else
  {
    os<<"Sprite Report filename: "<<ofn.GetStr().c_str()<<"\n";
    #ifdef DEBUGREPORTS
    GetSpriteList()->Report(os);
//    string msg = "Sprite report written to file: ";
//    msg += str;
//    MessageBox(msg.c_str(),"Info - Sprite Report",MB_OK);
    #else
    os<<"Compiled without reports turned on.\n";
    #endif

    os.close();
    string s = "notepad.exe ";
    s += ofn.GetStr();
    WinExec(s.c_str(),SW_SHOWNORMAL);
  }
}
//*******************************************************************
void TSpriteEditorClientWin::CeSpriteReport(TCommandEnabler &ce)
{
  ce.Enable(true);
}
//*******************************************************************
bool TSpriteEditorClientWin::ScreenPointToFrameAndTrack(TPoint pt,
                                                        int16& frame_found,
                                                        int16& track_found)
{
	int16 nowX=(int16)Scroller->XPos;
	int16 nowY=(int16)Scroller->YPos;
	TPoint rectPoint;
	rectPoint.x = pt.x + nowX ;
	rectPoint.y = pt.y + nowY ;

	for (int16 i=0;i<num_frames;i++)
   {
     for (int16 j=0;j<NUM_TRACKS;j++)
     {
       if (dynframe[i]->track[j].Contains(rectPoint))
       {
         track_found = j;
         frame_found = i;
         return true;
       }
     }
   }
   MessageBox("Couldn't translate the mouse click to a cell","Error - Screen Point",MB_OK);
	return false;
}
//*******************************************************************
int16 TSpriteEditorClientWin::GetUIRowsCount()
{
  return (int16)dynframe.GetItemsInContainer();
}
//*******************************************************************
int16 TSpriteEditorClientWin::GetUIValidRowsCount()
{
  int16 Retval = 0;
  int16 UIRows = GetUIRowsCount();
  bool *PBarr = new bool [UIRows];
  for (int16 k=0;k<UIRows;k++)
  {
    PBarr[k] = false;
  }

  for (int16 i=0;i<UIRows;i++)
  {
    for (int16 j=0;j<8;j++)
    {
      if (!dynframe[i]->cellptr[j].CellFileName.is_null())
      {
        PBarr[i] = true;
      }
    }
  }

  for (int16 m = int16(UIRows - 1);m >= 0;m--)
  {
    if (PBarr[m])
    {
      Retval = int16(m + 1);
      break;
    }
  }
  delete [] PBarr;
  PBarr = NULL;
  return Retval;
}
//*******************************************************************
void TSpriteEditorClientWin::MakeEnoughCurrentSpriteRows(int16 LastRow)
{
  if (GetSpriteTable() == NULL) {return;}

  int16 CurrentSpriteLastNum = GetSpriteTableLastNum();
  if (LastRow > CurrentSpriteLastNum)
  {
    int16 delta = int16(LastRow - CurrentSpriteLastNum);
    for (int16 i=0;i<delta;i++)
    {
      GetSpriteTable()->AddRow();
    }
  }
}
//*******************************************************************
void TSpriteEditorClientWin::RemoveEnoughSpriteRows(int16 LastRow)
{
  if (GetSpriteTable() == NULL) {return;}

  int16 CurrentSpriteLastRow = GetSpriteTableLastNum();
  if (CurrentSpriteLastRow > LastRow)
  {
    int16 delta = int16(CurrentSpriteLastRow - LastRow);
    for (int16 i = 0;i < delta;i++)
    {
      GetSpriteTable()->RemoveTopRow();
    }
  }
}
//*******************************************************************
void TSpriteEditorClientWin::CopyUIRowToCurrentSpriteRow(int16 RowNum)
{
  if (PCurrentSprite == NULL) {return;}

  TSpriteRow *PSpriteRow = GetSpriteRow(RowNum);
  for (int16 i=0;i<8;i++)
  {
    if (!(dynframe[RowNum]->cellptr[i].CellFileName.is_null()))
    {
      PSpriteRow->MakeCellIfNull(i);
      CopyCell(PSpriteRow->GetSpriteCell(i),&(dynframe[RowNum]->cellptr[i]));
    }
    else
    {
      PSpriteRow->ClearCellIfNotNull(i);
    }
  }
}
//*******************************************************************
void TSpriteEditorClientWin::CopyCell(TSpriteCell *PDestCell,TSpriteCell *PSourceCell)
{
  if ((PDestCell == NULL) || (PSourceCell == NULL)) {return;}

//  PDestCell->FileMode = PSourceCell->FileMode;
//  PDestCell->SetIsAnm(PSourceCell->GetIsAnm());
//  PDestCell->SetType(PSourceCell->GetType());
//  PDestCell->Set_FUC_Length(PSourceCell->Get_FUC_Length());
//  PDestCell->CellFileName = PSourceCell->CellFileName;
//  PDestCell->SetIsForward(PSourceCell->GetIsForward());
//  PDestCell->OverrideDefaultXY = PSourceCell->OverrideDefaultXY;
//  PDestCell->SetX(PSourceCell->GetX());
//  PDestCell->SetY(PSourceCell->GetY());
//  PDestCell->SetZ(PSourceCell->GetZ());

  *PDestCell = *PSourceCell;
}
//*******************************************************************
void TSpriteEditorClientWin::ClearCell(TSpriteCell *PCell)
{
  if (PCell != NULL)
  {
    PCell->ClearCell();
  }
//  PCell->SetIsAnm();
//  PCell->SetType(0);
//  PCell->Set_FUC_Length(0);
//  PCell->CellFileName = "";
//  PCell->SetForward();
//  PCell->OverrideDefaultXY = false;
//  PCell->SetXYZ(0,0,0);
}
//*******************************************************************
void TSpriteEditorClientWin::StartDrag(TPoint &point)
{
  if (!dragging)
  {
    dragging = true;
    SetCapture();
    SetCursor(0,IDC_IBEAM);
    //here we need to find the relevant starting rect
    int16 frame_at =-1;int16 track_at = -1;
    if(ScreenPointToFrameAndTrack(point,frame_at,track_at))
    {
      //found a valid rect
      CopyCell(&DragCell,&(dynframe[frame_at]->cellptr[track_at]));
      //now clear contents of old cell
      ClearCellContents(frame_at,track_at);
      old_frame = frame_at;
      old_track = track_at;
      GetVDFlags().SetSpriteDirty();
      Invalidate();
    }
    else
    {
      dragging = false;
      ReleaseCapture();
      SetCursor(0,IDC_ARROW);
    }
  }
}
//*******************************************************************
void TSpriteEditorClientWin::EndDrag(TPoint &point)
{
  if (dragging)
  {
    ReleaseCapture();
    //is new location a relevant target rect, if so copy cell from source here
    int16 frame_at =-1;
    int16 track_at = -1;
    if(ScreenPointToFrameAndTrack(point,frame_at,track_at))
    {
      //found a valid target rect
      //overwrite
      CopyCell(&(dynframe[frame_at]->cellptr[track_at]),&DragCell);
      GetVDFlags().SetSpriteDirty();
    }
    else
    {
      CopyCell(&(dynframe[old_frame]->cellptr[old_track]),&DragCell);
    }
    dragging = false;
    SetCursor(0,IDC_ARROW);
    GetVDFlags().SetSpriteDirty();
    Invalidate();
  }
}
//*******************************************************************
void TSpriteEditorClientWin::EvLButtonDown(uint modKeys, TPoint& point)
{
  StartDrag(point);
  TWindow::EvLButtonDown(modKeys,point);
}
//*******************************************************************
void TSpriteEditorClientWin::EvLButtonUp(uint /*modKeys*/, TPoint& point)
{
  EndDrag(point);
}
//*******************************************************************
void TSpriteEditorClientWin::PromptClearCell(TPoint &point)
{
   int16 frame_at =-1;
   int16 track_at = -1;

	if (ScreenPointToFrameAndTrack(point,frame_at,track_at))
	{
		if (MessageBox("Clear cell contents?","DANGER",
                      MB_OKCANCEL|MB_ICONEXCLAMATION|MB_DEFBUTTON2)==IDOK)
		{
			ClearCellContents(frame_at,track_at);
         GetVDFlags().SetSpriteDirty();
			Invalidate();
		}
  }
}
//*******************************************************************
void TSpriteEditorClientWin::EditAnmCell(int16 frame,int16 track,bool creating)
{
  dynframe[frame]->cellptr[track].SetIsAnm();

  TDirection direction = dynframe[frame]->cellptr[track].GetDirection();
  int16 x = dynframe[frame]->cellptr[track].GetX();
  int16 y = dynframe[frame]->cellptr[track].GetY();
  int16 z = dynframe[frame]->cellptr[track].GetZ();
  dword fuclen = dynframe[frame]->cellptr[track].Get_FUC_Length();
  int16 startframenum = dynframe[frame]->cellptr[track].GetStartFrame();

  TEditAnmCellDlg eacd(this,x,y,z,direction,creating,fuclen,startframenum);
  int retval = eacd.Execute();

  if (retval == IDOK)
  {
    TDirection direction2 = eacd.GetDirection();
    dword fuclen2 = eacd.GetFUCLength();
    int16 startframenum2 = eacd.GetStartFrameNum();
    int16 x2 = eacd.GetX();
    int16 y2 = eacd.GetY();
    int16 z2 = eacd.GetZ();
    if (x != x2)
    {
      dynframe[frame]->cellptr[track].SetX(x2);
      dynframe[frame]->cellptr[track].OverrideDefaultXY = true;
      GetVDFlags().SetSpriteDirty();
    }
    if (y != y2)
    {
      dynframe[frame]->cellptr[track].SetY(y2);
      dynframe[frame]->cellptr[track].OverrideDefaultXY = true;
      GetVDFlags().SetSpriteDirty();
    }

    if (z != z2)
    {
      dynframe[frame]->cellptr[track].SetZ(z2);
      GetVDFlags().SetSpriteDirty();
    }

    if (direction != direction2)
    {
      dynframe[frame]->cellptr[track].SetDirection(direction2);
      GetVDFlags().SetSpriteDirty();
    }

    if (fuclen != fuclen2)
    {
      dynframe[frame]->cellptr[track].Set_FUC_Length(fuclen2);
      GetVDFlags().SetSpriteDirty();
    }

    if (startframenum != startframenum2)
    {
      dynframe[frame]->cellptr[track].SetStartFrame(startframenum2);
      GetVDFlags().SetSpriteDirty();
    }

    Invalidate();
  }
  else if (retval == IDNO)
  {
    ClearCellContents(frame,track);
    GetVDFlags().SetSpriteDirty();
    Invalidate();
  }
}
//*******************************************************************
void TSpriteEditorClientWin::EditWavCell(int16 frame,int16 track)
{
  dynframe[frame]->cellptr[track].SetIsWav();
  int16 fl = (int16)dynframe[frame]->cellptr[track].Get_FUC_Length();
  TEditWavCellDlg ewcd(this,fl);
  int rc = ewcd.Execute();
  if (rc == IDOK)
  {
    dynframe[frame]->cellptr[track].Set_FUC_Length(ewcd.GetWavFUCLength());
    GetVDFlags().SetSpriteDirty();
    Invalidate();
  }
  else if (rc == IDNO)
  {
    ClearCellContents(frame,track);
    GetVDFlags().SetSpriteDirty();
    Invalidate();
  }
  else // rc == IDCANCEL
  {
    // do nothing.
  }
}
//*******************************************************************
void TSpriteEditorClientWin::EvRButtonDown(uint /*modKeys*/, TPoint& point)
{
  int16 frame_at = -1;
  int16 track_at = -1;
  if (ScreenPointToFrameAndTrack(point,frame_at,track_at))
  {
    // MRP - v2.3 - added so that right click on empty cell will not do anything.
    if (dynframe[frame_at]->cellptr[track_at].CellFileName != TAppString::strEmpty)
    {
      if (dynframe[frame_at]->cellptr[track_at].GetIsAnm())
      {
        EditAnmCell(frame_at,track_at,false);
      }
      else  // is wav
      {
        EditWavCell(frame_at,track_at);
      }
    }
    else
    {
      ClearCellContents(frame_at,track_at);
    }
  }
}
//*******************************************************************
void TSpriteEditorClientWin::FillAnm(int16 Frame,int16 Track)
{
  EditAnmCell(Frame,Track,true);
}
//*******************************************************************
dword TSpriteEditorClientWin::GetEstWavFUCLen(const string &wavpathname)
{
  dword filesize = TOgleFileName::GetFileSize(wavpathname);
  return TWav::GetEstimateFUCLength(filesize);
}
//*******************************************************************
void TSpriteEditorClientWin::FillWav(int16 Frame,int16 Track,const string &wavpathname)
{
  dword wavfuclen = GetEstWavFUCLen(wavpathname);

  dynframe[Frame]->cellptr[Track].Set_FUC_Length(wavfuclen);
  EditWavCell(Frame,Track);
}
//*******************************************************************
void TSpriteEditorClientWin::FillCell(TPoint &point)
{
  if (PCurrentSprite == NULL) {return;}

  int16 frame_at =-1;
  int16 track_at = -1;
  if(!ScreenPointToFrameAndTrack(point,frame_at,track_at)) {return;}

  char *str =  "Animation Files (*.anm)|*.anm|Wave Files (*.wav)|*.wav|";
  TOpenSaveDialog::TData srcfilenameData(OFN_FILEMUSTEXIST |
                                         OFN_PATHMUSTEXIST |
                                         OFN_HIDEREADONLY,
                                         str/*.c_str()*/,
					                          0,"","*");

  #if !defined(OGLEOWLVER2) && defined(BI_PLAT_WIN32)
  srcfilenameData.Flags &= (~OFN_EXPLORER);
  #endif

  TFileOpenDialog tfo(this,srcfilenameData);
  if (tfo.Execute() == IDOK)
  {
    if (srcfilenameData.Error == 0) //no error
    {
      string s = srcfilenameData.FileName;
      s = s.strip(string::Both);
      TOgleFileName ofnsrc(s);
      ofnsrc.SetToLowerCase();

      string str_ext = ofnsrc.GetExt(false); //don't strip period.
//      str_ext.to_lower();

      string stranm = "Animation Files (*.anm) | ";
      string strwav = "Wave Files (*.wav) | ";
      char *pwhich = NULL;

      if (str_ext == ".anm")
      {
        stranm += ofnsrc.GetFNameExt();
        pwhich = const_cast<char *>(stranm.c_str());
      }
      else if (str_ext == ".wav")
      {
        strwav += ofnsrc.GetFNameExt();
        pwhich = const_cast<char *>(strwav.c_str());
      }
      else // initial check to see if source has valid extension, just
           // just in case openfile dialog returned invalid ext.
      {
        MessageBox("Invalid file extension",
                   "Error - Fill Cell",
                   MB_OK | MB_TASKMODAL);
        return;
      }

      TOpenSaveDialog::TData destfilenameData(0,
                                              pwhich,
                                              0,
                                              "",
                                              "*");

      #if !defined(OGLEOWLVER2) && defined(BI_PLAT_WIN32)
      destfilenameData.Flags &= (~OFN_EXPLORER);
      #endif

      TFileSaveDialog fs(this,destfilenameData);
      if (fs.Execute() == IDOK && destfilenameData.Error == 0)
      {
        string s = destfilenameData.FileName;
        s = s.strip(string::Both);
//        s = s.strip(string::Trailing,' ');
        TOgleFileName ofndest(s);
        ofndest.SetToLowerCase();
        string strsrcext = ofnsrc.GetExt();
//        strsrcext.to_lower();
        string strdestext = ofndest.GetExt();
//        strdestext.to_lower();
        if (strdestext == TAppString::strEmpty)
        {
          ofndest.SetExt(ofnsrc.GetExt());
        }
        else if (strsrcext != strdestext)
        {
          MessageBox("Source and dest files had different extensions.",
                     "Error - Fill Cell",
                     MB_OK | MB_TASKMODAL);
          return;
        }

        TOgleFileName ofnfinal(ofndest);
        if (!ofnfinal.RemoveRoot(GetFileMgr()->GetCDRomPath(-1)))
        {
          MessageBox("Dest file wasn't in logical root",
                     "Error - Fill Cell",
                     MB_OK | MB_TASKMODAL);
          return;
        }

        ofndest.CreateDir();
        if (!ofnsrc.CopyFile(ofndest))
        {
          MessageBox("Error Copying file",
                     "Copy File",
                     MB_OK | MB_TASKMODAL);
          return;
        }



        if (str_ext == ".anm")
        {
          FillAnm(frame_at,track_at);
        }
        else
        {
          // ofndest is fully qualified pathname to wav file, need to get filesize.
          FillWav(frame_at,track_at,ofndest.GetStr());//wavpathname);
        }
        dynframe[frame_at]->cellptr[track_at].SetCellFileName(ofnfinal.GetStr());

        GetVDFlags().SetSpriteDirty();
        Invalidate();
      }
    }
  }
}
//*******************************************************************
void TSpriteEditorClientWin::EvLButtonDblClk(uint /*modKeys*/, TPoint& point)
{
  FillCell(point);
}
//*******************************************************************
void TSpriteEditorClientWin::ClearCellContents(int16 frame_at,int16 track_at)
{
  ClearCell(&(dynframe[frame_at]->cellptr[track_at]));
  GetVDFlags().SetSpriteDirty();
  Invalidate();
}
//*******************************************************************
void TSpriteEditorClientWin::SetupWindow()
{
  TGedWin::SetupWindow();  //this wasn't being called until 2/19/96, why?

  TRect temp;
  num_frames = NUM_FRAMES;//initial frame count
  for(int16 i = 0; i < NUM_FRAMES; i++)
  {
    dynframe.Add(new TFrameIs8Tracks);
    for (int16 j = 0; j < NUM_TRACKS; j++)
    {
      temp.left     = LEFT_BORDER + j*(/*FRAME_HEIGHT*/FRAME_WIDTH + FRAME_SEPARATION);
      temp.right    = temp.left + /*FRAME_HEIGHT*/FRAME_WIDTH;
      temp.top      = BEFORE_FRAMES + (FRAME_HEIGHT + FRAME_SEPARATION)*i;
      temp.bottom   = temp.top +  FRAME_HEIGHT;

      dynframe[i]->track[j] = temp;
    }
  }
//  Scroller->ScrollTo(LEFT_BORDER,BEFORE_FRAMES); // moved from ctor.
  Scroller->ScrollTo(0,0);
}
//*******************************************************************
void TSpriteEditorClientWin::CheckSaveCurrentSprite()
{
  if (PCurrentSprite == NULL) {return;}
  if (GetVDFlags().IsSpriteDirty())
  {
    int retval = MessageBox("Save Current sprite",
                            "Save Modified Sprite",
                            MB_YESNO | MB_ICONQUESTION);
    if (retval == IDYES)
    {
      SaveCurrentSpriteBail();
    }
  }
}
//*******************************************************************
TSpriteEditorClientWin::~TSpriteEditorClientWin()
{
  // the following gpf's because we're in fw's dtor, and then we try to use fw's this
  // to get mainwindow.
  //if (POgleApp->GetFW()->GetClientWindow() == this)
  //{
  //  CheckSaveCurrentSprite();
  //}

  if (PCurrentSprite != NULL)
  {
    delete PCurrentSprite;
    PCurrentSprite = NULL;
    GetVDFlags().ClearSpriteDirty();
  }
}
//*******************************************************************
void TSpriteEditorClientWin::PaintRect(TDC &dc,int16 Frame,int16 Track)
{
  if (dynframe[Frame]->cellptr[Track].GetCellFileName().is_null()==0)
  {
    if (dynframe[Frame]->cellptr[Track].GetIsAnm())
    {
      dc.SelectObject(TBrush(RGB(15,130,150)));
      dc.Rectangle(dynframe[Frame]->track[Track]);
      dc.RestoreBrush();
    }
    else //it's a wav
    {
      dc.SelectObject(TBrush(RGB(120,40,125)));
      dc.Rectangle(dynframe[Frame]->track[Track]);
      dc.RestoreBrush();
    }
  }
  else
  {
    dc.Rectangle(dynframe[Frame]->track[Track]);
  }
}
//*******************************************************************
void TSpriteEditorClientWin::PaintFrameTrackNum(TDC &dc,int16 Frame,int16 Track)
{
  SetFrameTrackStr(dc,Frame,Track);

  dc.TextOut(dynframe[Frame]->track[Track].left + GetSizeM(dc).cx,
				 dynframe[Frame]->track[Track].top + GetOneLineSpacing(), FTStr);
}
//*******************************************************************
void TSpriteEditorClientWin::PaintFileName(TDC &dc,int16 Frame,int16 Track)
{
  //show filename selected
  string tempstring = dynframe[Frame]->cellptr[Track].GetCellFileName();
  for (int16 kkk=0;kkk<tempstring.length();kkk++)
  {
    if (tempstring.get_at(kkk)==('\\')) tempstring.insert(kkk+1," ");
  }
  TRect temprect = dynframe[Frame]->track[Track];
  temprect.top += (2*GetOneLineSpacing());
  temprect.left += GetSizeM(dc).cx;
  dc.DrawText(tempstring.c_str(),-1,temprect,DT_WORDBREAK);
}
//*******************************************************************
void TSpriteEditorClientWin::PaintFileWav(TDC &dc,int16 Frame,int16 Track)
{
  TColor current_color = dc.SetTextColor(RGB(255,255,0));
  TColor current_bkcolor = dc.SetBkColor(RGB(200,0,25));
  dc.TextOut(dynframe[Frame]->track[Track].left+ GetSizeM(dc).cx,
             dynframe[Frame]->track[Track].top + (4*GetOneLineSpacing()),
             "Wave file");
  dc.SetTextColor(current_color);
  dc.SetBkColor(current_bkcolor);
}
//*******************************************************************
void TSpriteEditorClientWin::PaintFileAnm(TDC &dc,int16 Frame,int16 Track)
{
  char buffer[50];

  dc.TextOut(dynframe[Frame]->track[Track].left+GetSizeM(dc).cx,
             dynframe[Frame]->track[Track].top+(4*GetOneLineSpacing()),
             "Anm file");
  //show direction.
  if (dynframe[Frame]->cellptr[Track].GetIsForward())
  {
    string strFor = "Dir: Forward,  StartFrame: ";
    strFor += itoa(dynframe[Frame]->cellptr[Track].GetStartFrame(),
                   buffer,
                   10);
    dc.TextOut(dynframe[Frame]->track[Track].left+GetSizeM(dc).cx,
               dynframe[Frame]->track[Track].top+(5*GetOneLineSpacing()),
               strFor.c_str());
  }
  else if (dynframe[Frame]->cellptr[Track].GetIsReverse())
  {
    string strRev = "Dir: Reverse,  StartFrame: ";
    strRev += itoa(dynframe[Frame]->cellptr[Track].GetStartFrame(),
                   buffer,
                   10);
    dc.TextOut(dynframe[Frame]->track[Track].left+GetSizeM(dc).cx,
               dynframe[Frame]->track[Track].top+(5*GetOneLineSpacing()),
               strRev.c_str());
  }
  else
  {
    string strStill = "Dir:Still,  StartFrame: ";
    strStill += itoa(dynframe[Frame]->cellptr[Track].GetStartFrame(),
                     buffer,
                     10);

    dc.TextOut(dynframe[Frame]->track[Track].left+GetSizeM(dc).cx,
               dynframe[Frame]->track[Track].top+(5*GetOneLineSpacing()),
               strStill.c_str());
  }

  string strOverride = "Override Def X,Y: ";
  if (dynframe[Frame]->cellptr[Track].GetOverrideDefaultXY())
  {
    strOverride += "true";
  }
  else
  {
    strOverride += "false";
  }
  dc.TextOut(dynframe[Frame]->track[Track].left + GetSizeM(dc).cx,
             dynframe[Frame]->track[Track].top + (6*GetOneLineSpacing()),
             strOverride.c_str());

  char temp[25];
  wsprintf(temp,"X = %d, Y = %d,Z = %d",
           dynframe[Frame]->cellptr[Track].GetX(),
           dynframe[Frame]->cellptr[Track].GetY(),
           dynframe[Frame]->cellptr[Track].GetZ());
  dc.TextOut(dynframe[Frame]->track[Track].left + GetSizeM(dc).cx,
             dynframe[Frame]->track[Track].top + (7*GetOneLineSpacing()),
             temp);
}
//*******************************************************************
void TSpriteEditorClientWin::PaintNotFilled(TDC &dc,int16 Frame,int16 Track)
{
  TColor current_color = dc.SetTextColor(RGB(255,255,0));
  TColor current_bkcolor = dc.SetBkColor(RGB(200,0,25));
  dc.TextOut(dynframe[Frame]->track[Track].left+GetSizeM(dc).cx,
             dynframe[Frame]->track[Track].top+GetOneLineSpacing(),
             FTStr);
  dc.SetTextColor(current_color);
  dc.SetBkColor(current_bkcolor);
}
//*******************************************************************
void TSpriteEditorClientWin::PaintFileType(TDC &dc,int16 Frame,int16 Track)
{
  if (dynframe[Frame]->cellptr[Track].GetCellFileName().is_null()==0)
  {
    if (dynframe[Frame]->cellptr[Track].GetIsWav())
    {
      PaintFileWav(dc,Frame,Track);
    }
    else if (dynframe[Frame]->cellptr[Track].GetIsAnm())
    {
      PaintFileAnm(dc,Frame,Track);
    }

    char Temp[25];
    wsprintf(Temp,"frame count = %d",dynframe[Frame]->cellptr[Track].Get_FUC_Length());
    dc.TextOut(dynframe[Frame]->track[Track].left+GetSizeM(dc).cx,
               dynframe[Frame]->track[Track].top+(9*GetOneLineSpacing()),
               Temp);
  }//end if a file
  else
  {
    PaintNotFilled(dc,Frame,Track);
  }
}
//*******************************************************************
void TSpriteEditorClientWin::Paint(TDC& dc, bool /*erase*/, TRect& /*r*/)
{
  string s;
  if (PCurrentSprite != NULL)
  {
    s = "Editing Sprite: ";
    s += PCurrentSprite->FileMode.Name.GetStr();
  }
  else
  {
    s = "Sprite Editor";
  }
  dc.TextOut(0,0,s.c_str());
  for(int16 i = 0; i < num_frames; i++)     //each column =  track
  {
    for (int16 j = 0; j < NUM_TRACKS; j++)//each row    =  frame
    {
      PaintRect(dc,i,j);
      PaintFrameTrackNum(dc,i,j);
      PaintFileName(dc,i,j);
      PaintFileType(dc,i,j);
    }//end for
  }
}
//*******************************************************************

