//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  cvpchsp.h
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     10/2/95    M.Perry    original baseline
//********************************************************************
#if !defined(__cvpchsp_h)
#define __cvpchsp_h

#include "osprite.h"
//#include "casnames.h"
//*******************************************************************
class TVPChips:public TSprite
{
  public:
  TAnm *PChips[6];
  BOOL NotFound;

  int  col1;
  int  col2;
  int  col3;
  int  col4;
  int  col5;
  int  col6;

  long oldnum;

  int GetCol1(){return col1;};
  int GetCol2(){return col2;};
  int GetCol3(){return col3;};
  int GetCol4(){return col4;};
  int GetCol5(){return col5;};
  int GetCol6(){return col6;};

//*******************************************************************
  void ShowCards()
  {
	 SetNum(oldnum);
  }
//*******************************************************************
  void NoShowCards()
  {
	 int i=0;
	 for(i=0;i<6;i++)
	 {
		PChips[i]->NoShow();
	 }
  }
//*******************************************************************

  void SetupCols(long cash,int a,int b,int c,int d,int e,int f)
  {
	 oldnum = cash;
	 col1 = a;
	 col2 = b;
	 col3 = c;
	 col4 = d;
	 col5 = e;
	 col6 = f;
  }
//*******************************************************************
  void SetupAnms()
  {
	 NotFound = FALSE;

	 for (int i=0;i<6;i++)
	 {
		PChips[i] = GetAnm(i);
		if (PChips[i] == NULL) {NotFound = TRUE;}
	 }

	 if (NotFound)
	 {
		::MessageBox(NULL,"Couldn't find anm","Chips - Setup Anms",MB_OK);
	 }
	 else
	 {
		for (int j=0;j<6;j++)
		{
		  PChips[j]->CAD.ClearAutoStart();
		  PChips[j]->CAD.ClearAutoStop();
		  PChips[j]->CAD.SetDirStill();
		}
	 }
  }
//*******************************************************************
  TVPChips(TFileMode NewFileMode):TSprite(NewFileMode)
  {
	 oldnum = 1000;
	 col1 = 5;
	 col2 = 4;
	 col3 = 3;
	 col4 = 9;
	 col5 = 0;
	 col6 = 0;

	 NoShow();
	 SetupAnms();
  }
//*******************************************************************
  virtual ~TVPChips() {}
//*******************************************************************
  void SetNum(long num)
  {
	 if (NotFound) {return;}

	 if(num > oldnum)
	 {
		AddChips(num);
	 }
	 else if(num < oldnum)
	 {
		SubChips(num);  //Make sure in state that you can subtract this much
	 }
	 else if(num == oldnum)
	 {
		if(col1)
		{
		  PChips[0]->CAD.SetCurrentFrame(col1-1);
		  PChips[0]->Show();
		}
		else
		{
		  PChips[0]->NoShow();
		}
		if(col2)
		{
		  PChips[1]->CAD.SetCurrentFrame(col2-1);
		  PChips[1]->Show();
		}
		else
		{
		  PChips[1]->NoShow();
		}
		if(col3)
		{
		  PChips[2]->CAD.SetCurrentFrame(col3-1);
		  PChips[2]->Show();
		}
		else
		{
		  PChips[2]->NoShow();
		}
		if(col4)
		{
		  PChips[3]->CAD.SetCurrentFrame(col4-1);
		  PChips[3]->Show();
		}
		else
		{
		  PChips[3]->NoShow();
		}
		if(col5)
		{
		  PChips[4]->CAD.SetCurrentFrame(col5-1);
		  PChips[4]->Show();
		}
		else
		{
		  PChips[4]->NoShow();
		}
		if(col6)
		{
		  PChips[5]->CAD.SetCurrentFrame(col6-1);
		  PChips[5]->Show();
		}
		else
		{
		  PChips[5]->NoShow();
		}
	 }
  }
//*******************************************************************
  void AddChips(long num)
  {
	 long diff=0;
	 int c1,c2,c3,c4,c5,c6;
	 diff = num - oldnum;
	 c6 = diff/10000;
	 c5 = (diff%10000)/1000;
	 c4 = (diff%1000)/100;
	 c3 = (diff%100)/25;
	 c2 = (diff%25)/5;
	 c1 = (diff%5);

	 if (c1)
	 {
		if(c1+col1 < 11)
		{
		  col1 += c1;
		  PChips[0]->CAD.SetCurrentFrame(col1-1);
		  PChips[0]->Show();
		}
		else
		{
		  col1 = c1+col1-5;
		  c2++;
		  PChips[0]->CAD.SetCurrentFrame(col1-1);
		  PChips[0]->Show();
		}
	 }

	 if (c2)
	 {
		if(c2+col2 < 11)
		{
		  col2 += c2;
		  PChips[1]->CAD.SetCurrentFrame(col2-1);
		  PChips[1]->Show();
		}
		else
		{
		  col2 = c2+col2-5;
		  c3++;
		  PChips[1]->CAD.SetCurrentFrame(col2-1);
		  PChips[1]->Show();
		}
	 }

	 if (c3)
	 {
		if(c3+col3 < 11)
		{
		  col3 += c3;
		  PChips[2]->CAD.SetCurrentFrame(col3-1);
		  PChips[2]->Show();
		}
		else
		{
		  col3 = c3+col3-4;
		  c4++;
		  PChips[2]->CAD.SetCurrentFrame(col3-1);
		  PChips[2]->Show();
		}
	 }

	 if (c4)
	 {
		if(c4+col4 < 11)
		{
		  col4 += c4;
		  PChips[3]->CAD.SetCurrentFrame(col4-1);
		  PChips[3]->Show();
		}
		else
		{
		  col4 = c4+col4-10;
		  c5++;
		  PChips[3]->CAD.SetCurrentFrame(col4-1);
		  PChips[3]->Show();
		}
	 }

	 if (c5)
	 {
		if(c5+col5 < 11)
		{
		  col5 += c5;
		  PChips[4]->CAD.SetCurrentFrame(col5-1);
		  PChips[4]->Show();
		}
		else
		{
		  col5 = c5+col5-10;
		  c6++;
		  PChips[4]->CAD.SetCurrentFrame(col5-1);
		  PChips[4]->Show();
		}
	 }

	 if (c6)
	 {
		if(c6+col6 < 11)
		{
		  col6 += c6;
		  PChips[5]->CAD.SetCurrentFrame(col6-1);
		  PChips[5]->Show();
		}
		else
		{
		  col6 = c6+col6-10;
		  PChips[5]->CAD.SetCurrentFrame(col6-1);
		  PChips[5]->Show();
		}
	 }
	 oldnum = num;
  }
//*******************************************************************
  int GetBorrow(long convertto)
  {
	 long convertfrom=0;
	 switch(convertto) {
	 case 1     :  if(col2 > 1)
						{
						  convertfrom=5;Convert(convertfrom,convertto);col2--;return 1;
						}
	 case 5     :  if(col3 > 1)
						{
						  convertfrom=25;Convert(convertfrom,convertto);col3--;return 1;
						}
	 case 25    :  if(col4 > 1)
						{
						  convertfrom=100;Convert(convertfrom,convertto);col4--;return 1;
						}
	 case 100   :  if(col5 > 1)
						{
						  convertfrom=1000;Convert(convertfrom,convertto);col5--;return 1;
						}
	 case 1000  :  if(col6 > 1)
						{
						  convertfrom=10000;Convert(convertfrom,convertto);col6--;return 1;
						}
	 case 10000 :  if(oldnum/100000)
						{
						  convertfrom=100000;Convert(convertfrom,convertto);return 1;
						}
	 }
	 switch(convertto) {
	 case 1     :  if(col2 == 1)
						{
						  convertfrom=5;Convert(convertfrom,convertto);col2--;return 1;
						}
	 case 5     :  if(col3 == 1)
						{
						  convertfrom=25;Convert(convertfrom,convertto);col3--;return 1;
						}
	 case 25    :  if(col4 == 1)
						{
						  convertfrom=100;Convert(convertfrom,convertto);col4--;return 1;
						}
	 case 100   :  if(col5 == 1)
						{
						  convertfrom=1000;Convert(convertfrom,convertto);col5--;return 1;
						}
	 case 1000  :  if(col6 == 1)
						{
						  convertfrom=10000;Convert(convertfrom,convertto);col6--;return 1;
						}
	 case 10000 :  if(oldnum/100000)
						{
						  convertfrom=100000;Convert(convertfrom,convertto);return 1;
						}
	 }

	 return 0;
  }
//*******************************************************************
  void Convert(long confrom,long conto)
  {
	 if(confrom == 100000)
	 {
		if(conto == 1)	   { col6+=9;col5+=9;col4+=9;col3+=3;col2+=4;col1+=5; }
		if(conto == 5)	   { col6+=9;col5+=9;col4+=9;col3+=3;col2+=5; }
		if(conto == 25)	{ col6+=9;col5+=9;col4+=9;col3+=4; }
		if(conto == 100)	{ col6+=9;col5+=9;col4+=10; }
		if(conto == 1000)	{ col6+=9;col5+=10; }
		if(conto == 10000){ col6+=10; }
	 }
	 if(confrom == 10000)
	 {
		if(conto == 1)	   { col5+=9;col4+=9;col3+=3;col2+=4;col1+=5; }
		if(conto == 5)	   { col5+=9;col4+=9;col3+=3;col2+=5; }
		if(conto == 25)	{ col5+=9;col4+=9;col3+=4; }
		if(conto == 100)	{ col5+=9;col4+=10; }
		if(conto == 1000)	{ col5+=10; }
	 }
	 if(confrom == 1000)
	 {
		if(conto == 1)	   { col4+=9;col3+=3;col2+=4;col1+=5; }
		if(conto == 5)	   { col4+=9;col3+=3;col2+=5; }
		if(conto == 25)	{ col4+=9;col3+=4; }
		if(conto == 100)	{ col4+=10; }
	 }
	 if(confrom == 100)
	 {
		if(conto == 1)	   { col3+=3;col2+=4;col1+=5; }
		if(conto == 5)	   { col3+=3;col2+=5; }
		if(conto == 25)	{ col3+=4; }
	 }
	 if(confrom == 25)
	 {
		if(conto == 1)	   { col2+=4;col1+=5; }
		if(conto == 5)	   { col2+=5; }
	 }
	 if(confrom == 5)
	 {
		if(conto == 1)	   { col1+=5; }
	 }

  }
//*******************************************************************
  void SubChips(long num)
  {
	 long diff=0;
	 int c1,c2,c3,c4,c5,c6;
	 diff = oldnum - num;
	 c6 = (diff%100000)/10000;
	 c5 = (diff%10000)/1000;
	 c4 = (diff%1000)/100;
	 c3 = (diff%100)/25;
	 c2 = (diff%25)/5;
	 c1 = (diff%5);

	 if (c1)
	 {
		if(col1-c1 > 0)
		{
		  col1 -= c1;
		  PChips[0]->CAD.SetCurrentFrame(col1-1);
		  PChips[0]->Show();
		}
		else
		{
		  if(GetBorrow(1))
		  {
			 col1 -= c1;
			 PChips[0]->CAD.SetCurrentFrame(col1-1);
			 PChips[0]->Show();
		  }
		  else
		  {
			 if(col1-c1 == 0)
			 {
				col1 = 0;
				PChips[0]->NoShow();
			 }
			 else
			 {
				return ;  //error
			 }
		  }
		}
	 }
	 else
	 {
		if(col1)
		{
		  PChips[0]->CAD.SetCurrentFrame(col1-1);
		  PChips[0]->Show();
		}
	 }

	 if (c2)
	 {
		if(col2-c2 > 0)
		{
		  col2 -= c2;
		  PChips[1]->CAD.SetCurrentFrame(col2-1);
		  PChips[1]->Show();
		}
		else
		{
		  if(GetBorrow(5))
		  {
			 col2 -= c2;
			 PChips[1]->CAD.SetCurrentFrame(col2-1);
			 PChips[1]->Show();
		  }
		  else
		  {
			 if(col2-c2 == 0)
			 {
				col2 = 0;
				PChips[1]->NoShow();
			 }
			 else
			 {
				return ;  //error
			 }
		  }
		}
	 }
	 else
	 {
		if(col2)
		{
		  PChips[1]->CAD.SetCurrentFrame(col2-1);
		  PChips[1]->Show();
		}
	 }

	 if (c3)
	 {
		if(col3-c3 > 0)
		{
		  col3 -= c3;
		  PChips[2]->CAD.SetCurrentFrame(col3-1);
		  PChips[2]->Show();
		}
		else
		{
		  if(GetBorrow(25))
		  {
			 col3 -= c3;
			 PChips[2]->CAD.SetCurrentFrame(col3-1);
			 PChips[2]->Show();
		  }
		  else
		  {
			 if(col3-c3 == 0)
			 {
				col3 = 0;
				PChips[2]->NoShow();
			 }
			 else
			 {
				return ;  //error
			 }
		  }
		}
	 }
	 else
	 {
		if(col3)
		{
		  PChips[2]->CAD.SetCurrentFrame(col3-1);
		  PChips[2]->Show();
		}
	 }

	 if (c4)
	 {
		if(col4-c4 > 0)
		{
		  col4 -= c4;
		  PChips[3]->CAD.SetCurrentFrame(col4-1);
		  PChips[3]->Show();
		}
		else
		{
		  if(GetBorrow(100))
		  {
			 col4 -= c4;
			 PChips[3]->CAD.SetCurrentFrame(col4-1);
			 PChips[3]->Show();
		  }
		  else
		  {
			 if(col4-c4 == 0)
			 {
				col4 = 0;
				PChips[3]->NoShow();
			 }
			 else
			 {
				return ;  //error
			 }
		  }
		}
	 }
	 else
	 {
		if(col4)
		{
		  PChips[3]->CAD.SetCurrentFrame(col4-1);
		  PChips[3]->Show();
		}
	 }

	 if (c5)
	 {
		if(col5-c5 > 0)
		{
		  col5 -= c5;
		  PChips[4]->CAD.SetCurrentFrame(col5-1);
		  PChips[4]->Show();
		}
		else
		{
		  if(GetBorrow(1000))
		  {
			 col5 -= c5;
			 PChips[4]->CAD.SetCurrentFrame(col5-1);
			 PChips[4]->Show();
		  }
		  else
		  {
			 if(col5-c5 == 0)
			 {
				col5 = 0;
				PChips[4]->NoShow();
			 }
			 else
			 {
				return ;  //error
			 }
		  }
		}
	 }
	 else
	 {
		if(col5)
		{
		  PChips[4]->CAD.SetCurrentFrame(col5-1);
		  PChips[4]->Show();
		}
	 }
	 if (c6)
	 {
		if(col6-c6 > 0)
		{
		  col6 -= c6;
		  PChips[5]->CAD.SetCurrentFrame(col6-1);
		  PChips[5]->Show();
		}
		else
		{
		  if(GetBorrow(10000))
		  {
			 col6 -= c6;
			 PChips[5]->CAD.SetCurrentFrame(col6-1);
			 PChips[5]->Show();
		  }
		  else
		  {
			 if(col6-c6 == 0)
			 {
				col6 = 0;
				PChips[5]->NoShow();
			 }
			 else
			 {
				return ;  //error
			 }
		  }
		}
	 }
    else
	 {
		if(col6)
		{
        PChips[5]->CAD.SetCurrentFrame(col6-1);
		  PChips[5]->Show();
		}
	 }
	 oldnum = num;
  }
};
//*******************************************************************
#endif

