//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  daccgfw.h
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.2     4/17/97    M.Perry    modified framewin hierarchy.
//********************************************************************
#if !defined(__daccgfw_h)
#define __daccgfw_h

#include "casgfw.h"
class TDACCApp;
//*******************************************************************
class TDACCMenuEnable:public TCasinoMenuEnable
{
public:
  BOOL Lobby;

  BOOL BlackJackOne,BlackJackTwo,BlackJackFour,BlackJackSix;

  BOOL Craps;
  BOOL Roulette;
  BOOL Keno;

  BOOL SlotsAladdin100,SlotsAladdin500,SlotsAladdin1P;

  BOOL SlotsParadise25,SlotsParadise50,SlotsParadise100;

  BOOL SlotsJungle1,SlotsJungle2,SlotsJungle100;

  BOOL SlotsPirate1,SlotsPirate2,SlotsPirate5,SlotsPirate10,SlotsPirate25,SlotsPirate50,SlotsPirate100;

  BOOL SlotsLucky1,SlotsLucky2,SlotsLucky5,SlotsLucky10,SlotsLucky25,SlotsLucky50;

  BOOL SlotsSpirit1000;

  BOOL SlotsJokers5,SlotsJokers10,SlotsJokers25,SlotsJokers50,SlotsJokers100;

  BOOL SlotsTotal1,SlotsTotal2,SlotsTotal5,SlotsTotal10,SlotsTotal500,SlotsTotal1000;

  BOOL SlotsCherry1,SlotsCherry2,SlotsCherry5,SlotsCherry10,SlotsCherry25,SlotsCherry50;

  BOOL VPJack1,VPJack5,VPJack25,VPJack100,VPJack1P;

  BOOL VPDWild1,VPDWild5,VPDWild25,VPDWild100;

  BOOL VPTen1,VPTen5,VPTen25,VPTen100;

  BOOL VPJWild1,VPJWild5,VPJWild25,VPJWild100;

public:
  TDACCMenuEnable(BOOL setvalues = TRUE);
  virtual ~TDACCMenuEnable();
  virtual void SetAll(BOOL value);
  virtual void SetModes(BOOL value = TRUE);
};
//*******************************************************************
class TDACCGameFrameWindow:public TCasinoGameFrameWindow
{
public:
//  int BJNumDecks;
  TDACCGameFrameWindow(TDACCApp *pdaccapp,const char *szTitle);
  virtual ~TDACCGameFrameWindow();
  virtual TWindow *CreateModeWindow(int ModeIndex);
  virtual int GetMenuID();
  virtual int GetAboutID();
  void DoMenu();
  virtual void SwitchGameModes(int modeindex);
  virtual void SwitchGameModes(string &name) {SwitchGameModes(GetModeIndex(name));}
protected:
  virtual void CreatePlayerMgr();
  TOgleModeWindow *CreateDACCVPMode();
  TOgleModeWindow *CreateDACCSlotMode();
  TDACCMenuEnable *GetDACCMenuEnable() {return (TDACCMenuEnable *)GetCasMenuEnable();}
  virtual void CreateMenuEnable();

  void CmGameLobby();
  void CeGameLobby(TCommandEnabler &enabler);

  // bj
//  void SwitchBJ(int numdecks);
  void CmGameBlackJackOne();
  void CeGameBlackJackOne(TCommandEnabler &enabler);
  void CmGameBlackJackTwo();
  void CeGameBlackJackTwo(TCommandEnabler &enabler);
  void CmGameBlackJackFour();
  void CeGameBlackJackFour(TCommandEnabler &enabler);
  void CmGameBlackJackSix();
  void CeGameBlackJackSix(TCommandEnabler &enabler);
  // craps
  void CmGameCraps();
  void CeGameCraps(TCommandEnabler &enabler);
  // keno
  void CmGameKeno();
  void CeGameKeno(TCommandEnabler &enabler);
  // roulette
  void CmGameRoulette();
  void CeGameRoulette(TCommandEnabler &enabler);

  // slots aladdin
  void CmGameSlotsAladdin100();
  void CeGameSlotsAladdin100(TCommandEnabler &enabler);
  void CmGameSlotsAladdin500();
  void CeGameSlotsAladdin500(TCommandEnabler &enabler);
  void CmGameSlotsAladdin1P();
  void CeGameSlotsAladdin1P(TCommandEnabler &enabler);
  // slots paradise
  void CmGameSlotsParadise25();
  void CeGameSlotsParadise25(TCommandEnabler &enabler);
  void CmGameSlotsParadise50();
  void CeGameSlotsParadise50(TCommandEnabler &enabler);
  void CmGameSlotsParadise100();
  void CeGameSlotsParadise100(TCommandEnabler &enabler);
  // slots pirate
  void CmGameSlotsPirate1();
  void CeGameSlotsPirate1(TCommandEnabler &enabler);
  void CmGameSlotsPirate2();
  void CeGameSlotsPirate2(TCommandEnabler &enabler);
  void CmGameSlotsPirate5();
  void CeGameSlotsPirate5(TCommandEnabler &enabler);
  void CmGameSlotsPirate10();
  void CeGameSlotsPirate10(TCommandEnabler &enabler);
  void CmGameSlotsPirate25();
  void CeGameSlotsPirate25(TCommandEnabler &enabler);
  void CmGameSlotsPirate50();
  void CeGameSlotsPirate50(TCommandEnabler &enabler);
  void CmGameSlotsPirate100();
  void CeGameSlotsPirate100(TCommandEnabler &enabler);
  // slots lucky
  void CmGameSlotsLucky1();
  void CeGameSlotsLucky1(TCommandEnabler &enabler);
  void CmGameSlotsLucky2();
  void CeGameSlotsLucky2(TCommandEnabler &enabler);
  void CmGameSlotsLucky5();
  void CeGameSlotsLucky5(TCommandEnabler &enabler);
  void CmGameSlotsLucky10();
  void CeGameSlotsLucky10(TCommandEnabler &enabler);
  void CmGameSlotsLucky25();
  void CeGameSlotsLucky25(TCommandEnabler &enabler);
  void CmGameSlotsLucky50();
  void CeGameSlotsLucky50(TCommandEnabler &enabler);
  // slots spirit
  void CmGameSlotsSpirit1000();
  void CeGameSlotsSpirit1000(TCommandEnabler &enabler);
  // slots jokers
  void CmGameSlotsJokers5();
  void CeGameSlotsJokers5(TCommandEnabler &enabler);
  void CmGameSlotsJokers10();
  void CeGameSlotsJokers10(TCommandEnabler &enabler);
  void CmGameSlotsJokers25();
  void CeGameSlotsJokers25(TCommandEnabler &enabler);
  void CmGameSlotsJokers50();
  void CeGameSlotsJokers50(TCommandEnabler &enabler);
  void CmGameSlotsJokers100();
  void CeGameSlotsJokers100(TCommandEnabler &enabler);
  // slots total
  void CmGameSlotsTotal1();
  void CeGameSlotsTotal1(TCommandEnabler &enabler);
  void CmGameSlotsTotal2();
  void CeGameSlotsTotal2(TCommandEnabler &enabler);
  void CmGameSlotsTotal5();
  void CeGameSlotsTotal5(TCommandEnabler &enabler);
  void CmGameSlotsTotal10();
  void CeGameSlotsTotal10(TCommandEnabler &enabler);
  void CmGameSlotsTotal500();
  void CeGameSlotsTotal500(TCommandEnabler &enabler);
  void CmGameSlotsTotal1000();
  void CeGameSlotsTotal1000(TCommandEnabler &enabler);
  // slots cherry
  void CmGameSlotsCherry1();
  void CeGameSlotsCherry1(TCommandEnabler &enabler);
  void CmGameSlotsCherry2();
  void CeGameSlotsCherry2(TCommandEnabler &enabler);
  void CmGameSlotsCherry5();
  void CeGameSlotsCherry5(TCommandEnabler &enabler);
  void CmGameSlotsCherry10();
  void CeGameSlotsCherry10(TCommandEnabler &enabler);
  void CmGameSlotsCherry25();
  void CeGameSlotsCherry25(TCommandEnabler &enabler);
  void CmGameSlotsCherry50();
  void CeGameSlotsCherry50(TCommandEnabler &enabler);
  // slots jungle
  void CmGameSlotsJungle1();
  void CeGameSlotsJungle1(TCommandEnabler &enabler);
  void CmGameSlotsJungle2();
  void CeGameSlotsJungle2(TCommandEnabler &enabler);
  void CmGameSlotsJungle100();
  void CeGameSlotsJungle100(TCommandEnabler &enabler);

  void CmGameVPJack1();
  void CeGameVPJack1(TCommandEnabler &enabler);
  void CmGameVPJack5();
  void CeGameVPJack5(TCommandEnabler &enabler);
  void CmGameVPJack100();
  void CeGameVPJack100(TCommandEnabler &enabler);
  void CmGameVPJack25();
  void CeGameVPJack25(TCommandEnabler &enabler);
  void CmGameVPJack1P();
  void CeGameVPJack1P(TCommandEnabler &enabler);
  void CmGameVPDWild1();
  void CeGameVPDWild1(TCommandEnabler &enabler);
  void CmGameVPDWild5();
  void CeGameVPDWild5(TCommandEnabler &enabler);
  void CmGameVPDWild100();
  void CeGameVPDWild100(TCommandEnabler &enabler);
  void CmGameVPDWild25();
  void CeGameVPDWild25(TCommandEnabler &enabler);
  void CmGameVPJWild100();
  void CeGameVPJWild100(TCommandEnabler &enabler);

  void CmGameVPTen1();
  void CeGameVPTen1(TCommandEnabler &enabler);
  void CmGameVPTen5();
  void CeGameVPTen5(TCommandEnabler &enabler);
  void CmGameVPTen100();
  void CeGameVPTen100(TCommandEnabler &enabler);
  void CmGameVPTen25();
  void CeGameVPTen25(TCommandEnabler &enabler);

  void CmGameVPJWild1();
  void CeGameVPJWild1(TCommandEnabler &enabler);
  void CmGameVPJWild5();
  void CeGameVPJWild5(TCommandEnabler &enabler);
  void CmGameVPJWild25();
  void CeGameVPJWild25(TCommandEnabler &enabler);

  void CmDemoEsc();

  DECLARE_RESPONSE_TABLE(TDACCGameFrameWindow);
};
//*******************************************************************
#endif