//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  slgfw.h
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.2     4/17/97    M.Perry    modified framewin hierarchy.
//********************************************************************
#if !defined(__slgfw_h)
#define __slgfw_h

#include "casgfw.h"
class TSLApp;
//*******************************************************************
class TSLMenuEnable:public TCasinoMenuEnable
{
public:
  BOOL Lobby;

  BOOL SlotsAladdin100,SlotsAladdin1P;

  BOOL SlotsJungle1,SlotsJungle2;

  BOOL SlotsSpirit1000;

  BOOL SlotsJokers5,SlotsJokers25;

  BOOL SlotsCherry1,SlotsCherry2,SlotsCherry5;

public:
  TSLMenuEnable(BOOL setvalues = TRUE);
  virtual ~TSLMenuEnable();
  virtual void SetAll(BOOL value);
  virtual void SetModes(BOOL value = TRUE);
};
//*******************************************************************
class TSLGameFrameWindow:public TCasinoGameFrameWindow
{
public:
  TSLGameFrameWindow(TSLApp *pslapp,const char *szTitle);
  virtual ~TSLGameFrameWindow();
  virtual TWindow *CreateModeWindow(int ModeIndex);
  virtual int GetMenuID();
  virtual int GetAboutID();
  void DoMenu();
  virtual void SwitchGameModes(int modeindex);
  virtual void SwitchGameModes(string &name) {SwitchGameModes(GetModeIndex(name));}

protected:
  TSLMenuEnable *GetSLMenuEnable() {return (TSLMenuEnable *)GetCasMenuEnable();}
  virtual void CreateMenuEnable();

  void CmGameLobby();
  void CeGameLobby(TCommandEnabler &enabler);

  // slots aladdin
  void CmGameSlotsAladdin100();
  void CeGameSlotsAladdin100(TCommandEnabler &enabler);
  void CmGameSlotsAladdin1P();
  void CeGameSlotsAladdin1P(TCommandEnabler &enabler);
  // slots spirit
  void CmGameSlotsSpirit1000();
  void CeGameSlotsSpirit1000(TCommandEnabler &enabler);
  // slots jokers
  void CmGameSlotsJokers5();
  void CeGameSlotsJokers5(TCommandEnabler &enabler);
  void CmGameSlotsJokers25();
  void CeGameSlotsJokers25(TCommandEnabler &enabler);
  // slots cherry
  void CmGameSlotsCherry1();
  void CeGameSlotsCherry1(TCommandEnabler &enabler);
  void CmGameSlotsCherry2();
  void CeGameSlotsCherry2(TCommandEnabler &enabler);
  void CmGameSlotsCherry5();
  void CeGameSlotsCherry5(TCommandEnabler &enabler);
  // slots jungle
  void CmGameSlotsJungle1();
  void CeGameSlotsJungle1(TCommandEnabler &enabler);
  void CmGameSlotsJungle2();
  void CeGameSlotsJungle2(TCommandEnabler &enabler);

private:
  void SetupModeStrings();
  string strIntro;
  string strLobby;
  string strSlotsAladdin100,strSlotsAladdin1P;
  string strSlotsJungle1,strSlotsJungle2;
  string strSlotsSpirit1000;
  string strSlotsJokers5,strSlotsJokers25;
  string strSlotsCherry1,strSlotsCherry2,strSlotsCherry5;

  DECLARE_RESPONSE_TABLE(TSLGameFrameWindow);
};
//*******************************************************************
#endif