//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  tefspl.h
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     9/16/95    M.Perry     original baseline
//********************************************************************
#if !defined(__tefspl_h)
#define __tefspl_h

#include "csglspl.h"
#include "casnames.rh"
#include "csnames.rh"
#include "csreelsp.h"
//*******************************************************************
class TEclipse500SpriteList:public TSGLordSpriteList
{
  public:
  TEclipse500SpriteList(TOgleModeWindow *pmw,TFileMode filemode,TGameObject *PGObj)
	 :TSGLordSpriteList(pmw,filemode,PGObj)
  {
	 Init(filemode,TRUE,FALSE);
  }

  virtual ~TEclipse500SpriteList() {}
  virtual TSprite *CreateSprite(const string &SpriteFName)
  {
	 TFileMode FM(SpriteFName,fm_None,fm_Immed,FileMode.DirIndex);

	 if      (SpriteFName == GetResString(IDS_MS_CHIPS_S_E500))       {return (new TCasChips(pOwnerWindow,FM));}
	 else if (SpriteFName == GetResString(IDS_MS_NP_S_E500))          {return (new TCasNamePlate(pOwnerWindow,FM));}
	 else if (SpriteFName == GetResString(IDS_MS_REEL_S_E500))        {return (new TSReel(pOwnerWindow,FM));}
	 else if (SpriteFName == GetResString(IDS_MS_COINSPLAYED_S_E500)) {return (new TSCoinsPlayed(pOwnerWindow,FM));}
	 else if (SpriteFName == GetResString(IDS_MS_CREDITS_S_E500))     {return (new TSCredits(pOwnerWindow,FM));}
	 else if (SpriteFName == GetResString(IDS_MS_WINPAID_S_E500))     {return (new TSWinPaid(pOwnerWindow,FM));}
	 else if (SpriteFName == GetResString(IDS_MS_B0_S_E500))          {return (new TSButton(pOwnerWindow,FM));}
	 else if (SpriteFName == GetResString(IDS_MS_B1_S_E500))          {return (new TSButton(pOwnerWindow,FM));}
	 else if (SpriteFName == GetResString(IDS_MS_B4_S_E500))          {return (new TSButton(pOwnerWindow,FM));}
	 else if (SpriteFName == GetResString(IDS_MS_B2_S_E500))          {return (new TSButton(pOwnerWindow,FM));}
	 else if (SpriteFName == GetResString(IDS_MS_B3_S_E500))          {return (new TSButton(pOwnerWindow,FM));}
	 else if (SpriteFName == GetResString(IDS_MS_B5_S_E500))          {return (new TSButton(pOwnerWindow,FM));}
	 else if (SpriteFName == GetResString(IDS_MS_SB_S_E500))          {return (new TCasStatusBar(pOwnerWindow,FM));}
	 else                                                             {return (new TSprite(pOwnerWindow,FM));}
  }
  virtual TSprite *CreateSprite(const string &SpriteFName,void *psource)
  {
	 TFileMode FM(SpriteFName,fm_None,fm_Immed,FileMode.DirIndex);

	 if      (SpriteFName == GetResString(IDS_MS_CHIPS_S_E500))       {return (new TCasChips(pOwnerWindow,FM,psource));}
	 else if (SpriteFName == GetResString(IDS_MS_NP_S_E500))          {return (new TCasNamePlate(pOwnerWindow,FM,psource));}
	 else if (SpriteFName == GetResString(IDS_MS_REEL_S_E500))        {return (new TSReel(pOwnerWindow,FM,psource));}
	 else if (SpriteFName == GetResString(IDS_MS_COINSPLAYED_S_E500)) {return (new TSCoinsPlayed(pOwnerWindow,FM,psource));}
	 else if (SpriteFName == GetResString(IDS_MS_CREDITS_S_E500))     {return (new TSCredits(pOwnerWindow,FM,psource));}
	 else if (SpriteFName == GetResString(IDS_MS_WINPAID_S_E500))     {return (new TSWinPaid(pOwnerWindow,FM,psource));}
	 else if (SpriteFName == GetResString(IDS_MS_B0_S_E500))          {return (new TSButton(pOwnerWindow,FM,psource));}
	 else if (SpriteFName == GetResString(IDS_MS_B1_S_E500))          {return (new TSButton(pOwnerWindow,FM,psource));}
	 else if (SpriteFName == GetResString(IDS_MS_B4_S_E500))          {return (new TSButton(pOwnerWindow,FM,psource));}
	 else if (SpriteFName == GetResString(IDS_MS_B2_S_E500))          {return (new TSButton(pOwnerWindow,FM,psource));}
	 else if (SpriteFName == GetResString(IDS_MS_B3_S_E500))          {return (new TSButton(pOwnerWindow,FM,psource));}
	 else if (SpriteFName == GetResString(IDS_MS_B5_S_E500))          {return (new TSButton(pOwnerWindow,FM,psource));}
	 else if (SpriteFName == GetResString(IDS_MS_SB_S_E500))          {return (new TCasStatusBar(pOwnerWindow,FM,psource));}
	 else                                                           {return (new TSprite(pOwnerWindow,FM,psource));}
  }
};
//*******************************************************************
#endif