//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  vplord.h
//    Project Name:  Ogle
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     07/2/95   A. Krist    Original baseline
//*******************************************************************
#if !defined _vplord_h
#define _vplord_h

#include "ogobj.h"
#include "vpdeck.h"
#include "vpsmarts.h"
class TVideoPokerModeWin;
class TVPLordMainState;
#include "cvpcrdsp.h"
#include "cvpcpsp.h"
#include "cvpb1sp.h"
#include "cvpbmsp.h"
#include "cvpddsp.h"
#include "cvpcosp.h"
#include "cvpwpsp.h"
#include "cvpwrsp.h"
#include "cvpcrsp.h"
#include "cvpchsp.h"
#include "casnames.h"

#define MAXBET 5
//*******************************************************************
enum TGLordRID
{
  idBet1,
  idBetMax,
  idCashOut,
  idAddCoins,
  idDealDraw,
  idHoldCard0,
  idHoldCard1,
  idHoldCard2,
  idHoldCard3,
  idHoldCard4,
  idAskExpert
};
#define NumResponders 11
//*******************************************************************
class TVPLord:public TGameObject
{
  public:
  TResponder *Responders[NumResponders];
  virtual BOOL Respond(TResponder &responder);
  void SetupResponders();
  void CleanupResponders() {for(int i=0;i<NumResponders;i++) {delete Responders[i];}}
  int credits;
  int machinenum;
  int coinsplayed;
  int coinsize;
  int winnerpaid;
  int activeplayer;
  int maxbet;
  int pot;
  int progressive;
  int numofsplits;
  int playersin;
  int game;    //which type video poker game.
  int r1;
  int r2;
  int r3;
  TPokerHand         *fake;
  TVideoPokerModeWin         *pMWin;
  TVPLord(TVideoPokerModeWin *pmwin,TFileMode NewFileMode,TVPGameType gametype,int coindenom);
  virtual TSpriteList *CreateSpriteList(TFileMode splfm);
  void SetupSprites();
  void CleanupSprites();
  TVPCard *CardSprites[5];
  TVPCoinsPlayed *CoinsPlayed;
  TVPBet1 *Bet1Button;
  TVPBetMax *BetMaxButton;
  TVPCashOut *CashOutButton;
  TVPDealDraw *DealDrawButton;
  TVPWinPaid *WinPaid;
  TVPCredits *Credits;
  TVPWinRatio *WinRatio;
  TVPChips *Chips;

  TVPDeck              *pDeck;
  TVPSmarts          *pSmarts;
 ~TVPLord();
  ShuffleCards();
  DrawCards();
  ShowReels();
  ShowWinner();
  GetBet();
  Bet1();
  BetMax();
  CashOut();
  FinalCashOut();
  Switch();
  AddCoins();
  int GoodToGo();
  InitVid();
  Vid1();
  DrawDeal();
  Winner();
  Clear();
  void ClearActions();
  void FinalClear();
  Discards();
  void HoldCard(int cardnum);
  PayOutJacks();
  PayOutTens();
  PayOutWild2();
  PayOutWildJoker();
  PayOutProgressive();
  Wild2();
  WildJoker();
  GetNumOfWildCards();
  GetPlayin() {return playersin;};
  ChangeGame();
};
//*******************************************************************
#endif