//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  acvplgld.h
//    Project Name:  acvp
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  2.5    10/14/94    M.Perry     original baseline
//********************************************************************
#if !defined(__acvplgld_h)
#define __acvplgld_h

#include "caslgld.h"
#include "cgametyp.h"
#include "obtnsp.h"
#include "clmessp.h"
#include "onamesp.h"
//#include "acvpcdsp.h"
#include "acvscdsp.h"
//*******************************************************************
class TACVPLobbyGameLord:public TCasLobbyGameLord
{
public:
  enum
  {
    idNone     = 0,
    idHotSpot1 = 1,
    idHotSpot2 = 2,
    idHotSpot3 = 3,
    idHotSpot4 = 4,
    idHotSpot5 = 5,
    idHotSpot6 = 6,
    idHotSpot7 = 7,
    idHotSpot8 = 8,
    idHotSpot9 = 9,
    idHotSpot10 = 10,
    idHotSpot11 = 11,
    idHotSpot12 = 12,
    idHotSpot13 = 13,
    idHotSpot14 = 14,
    idHotSpot15 = 15,
    idHotSpot16 = 16,
    idHotSpot17 = 17,
    idHotSpot18 = 18,
    idHotSpot19 = 19,
    idHotSpot20 = 20,
    idHotSpot21 = 21,
    idHotSpot22 = 22,
    idHotSpot23 = 23,
    idHotSpot24 = 24,
    idHotSpot25 = 25,
    idHotSpot26 = 26,
    idHotSpot27 = 27,
    idHotSpot28 = 28,
    idHotSpot29 = 29,
    idHotSpot30 = 30,
    idHotSpot31 = 31,
    idHotSpot32 = 32,
    idHotSpot33 = 33,
    idHotSpot34 = 34,
    idHotSpot35 = 35,
    idHotSpot36 = 36,
    idHotSpot37 = 37,
    idHotSpot38 = 38,
    idHotSpot39 = 39,
    idHotSpotLast = idHotSpot39,
    idHotSpotNum = idHotSpotLast + 1,
    idSpeed = 40,
    idButton0 = 41,
    idButton1 = 42,
    idButton2 = 43,
    idLast = idButton2,
    idNum = idLast + 1
  };
  enum //TLobbyIdleEnum
  {
    liNone = 0,
    liSparkle1 = 1,
    liSparkle2 = 2,
    liSparkle3 = 3,
    liSparkle4 = 4,
    liSparkle5 = 5,
    liLeftLamp = 6,
    liLight1 = 7,
    liLight2 = 8,
    liLight3 = 9,
    liLight4 = 10,
    liLight5 = 11,
    liLight6 = 12,
    liLake = 13,
    liRightLamp = 14,
    liName = 15,//?
    liBankroll = 16,//?
    liMenu = 17,//?
    liCrd1 = 18,//?
    liMiner = 19,
    liChute = 20,
    liSound1 = 21,
    liSound2 = 22,
    liSound3 = 23,
    liClosed = 24,
    liBoards = 25,
  };
  enum
  {
    NumResponders = idHotSpotNum + 1, //1 extra for idSpeed
    NumReelStops = 23,
    TotalChances = 239
  };

protected:
  static dword LastLobbyEndSec;
  static dword MineSec;
  static dword MineDurationSec;
  static bool MineOpen;
  dword BoardsOnFUC;
  dword MinerOnFUC;
  dword MinerOffFUC;
  int16 MsgCodes[NumResponders];
  int16 CmdCodes[NumResponders];
  TResponder *Responders[NumResponders];
  TOgleButton *PMenuEscButton;
  TOgleButton *PGamblerButton;
  TOgleButton *PGoldPanButton;
  TCasLobbyMessageDisplay *PMessageDisplay;
  TOgleNameSprite *PNameSprite;
//  TACCasCashDisplay *PBankSprite;
  TACVPSlotsCashDisplay *PBankSprite;
  TSprite *PCloseMine;
  TSprite *POpenMine;
  TSprite *PResults[NumReelStops];
  TMoney Win[NumReelStops];
  int16 Chances[NumReelStops];
  TMoney Winnings;
  dword ResultEndFUC;
  int16 WinningReelStop;
  bool ShuttingDownFlag;

protected:
  virtual TSprite *CreateSprite(string spritename,int16 id = 0,void *psource = NULL);
  virtual bool Respond(TResponder &responder);
  virtual bool Respond(int16 id,int16 info = 0,void *pdata = NULL);
  void SetupResponders();
  void CleanupResponders();

  bool SetSparkle1Idle(int16 set = 0);
  bool SetSparkle2Idle(int16 set = 0);
  bool SetSparkle3Idle(int16 set = 0);
  bool SetSparkle4Idle(int16 set = 0);
  bool SetSparkle5Idle(int16 set = 0);
  bool SetLeftLampIdle(int16 set = 0);
  bool SetLight1Idle(int16 set = 0);
  bool SetLight2Idle(int16 set = 0);
  bool SetLight3Idle(int16 set = 0);
  bool SetLight4Idle(int16 set = 0);
  bool SetLight5Idle(int16 set = 0);
  bool SetLight6Idle(int16 set = 0);
  bool SetLakeIdle(int16 set = 0);
  bool SetRightLampIdle(int16 set = 0);
  bool SetMinerIdle(int16 set = 0);
  bool SetChuteIdle(int16 set = 0);
  bool SetSound1Idle(int16 set = 0);
  bool SetSound2Idle(int16 set = 0);
  bool SetSound3Idle(int16 set = 0);
  bool SetClosedIdle(int16 set = 0);
  bool SetBoardsIdle(int16 set = 0);
  virtual void SetupActivePlayer(int16 slot);
  virtual void SetupSprites();
  virtual void CleanupSprites();
  virtual void Update(dword fuc);
  virtual void TurnOnNext();
  virtual void TurnOffNext();
  void SetupMine();
  void SetupMine(bool open);
  void PlayLobbyGame();
  int16 GetWinningReelStop();

public:
  TACVPLobbyGameLord(TLobbyModeWin *PNewOwnerWindow,const TFileMode &fm,int16 sgt,int16 did);
  virtual ~TACVPLobbyGameLord();
  int16 InitL();
  virtual void ShuttingDown();
  virtual void NotifyPlayerActivation(int16 slotnum);
  virtual void NotifyPlayerDeActivation(int16 slotnum);
};
//*******************************************************************
//*********************** inlines ***********************************
//*******************************************************************
inline bool TACVPLobbyGameLord::SetSparkle1Idle(int16 set)
{
  return SetCurrentSpriteSet(liSparkle1,set);
}
//*******************************************************************
inline bool TACVPLobbyGameLord::SetSparkle2Idle(int16 set)
{
  return SetCurrentSpriteSet(liSparkle2,set);
}
//*******************************************************************
inline bool TACVPLobbyGameLord::SetSparkle3Idle(int16 set)
{
  return SetCurrentSpriteSet(liSparkle3,set);
}
//*******************************************************************
inline bool TACVPLobbyGameLord::SetSparkle4Idle(int16 set)
{
  return SetCurrentSpriteSet(liSparkle4,set);
}
//*******************************************************************
inline bool TACVPLobbyGameLord::SetSparkle5Idle(int16 set)
{
  return SetCurrentSpriteSet(liSparkle5,set);
}
//*******************************************************************
inline bool TACVPLobbyGameLord::SetLeftLampIdle(int16 set)
{
  return SetCurrentSpriteSet(liLeftLamp,set);
}
//*******************************************************************
inline bool TACVPLobbyGameLord::SetLight1Idle(int16 set)
{
  return SetCurrentSpriteSet(liLight1,set);
}
//*******************************************************************
inline bool TACVPLobbyGameLord::SetLight2Idle(int16 set)
{
  return SetCurrentSpriteSet(liLight2,set);
}
//*******************************************************************
inline bool TACVPLobbyGameLord::SetLight3Idle(int16 set)
{
  return SetCurrentSpriteSet(liLight3,set);
}
//*******************************************************************
inline bool TACVPLobbyGameLord::SetLight4Idle(int16 set)
{
  return SetCurrentSpriteSet(liLight4,set);
}
//*******************************************************************
inline bool TACVPLobbyGameLord::SetLight5Idle(int16 set)
{
  return SetCurrentSpriteSet(liLight5,set);
}
//*******************************************************************
inline bool TACVPLobbyGameLord::SetLight6Idle(int16 set)
{
  return SetCurrentSpriteSet(liLight6,set);
}
//*******************************************************************
inline bool TACVPLobbyGameLord::SetLakeIdle(int16 set)
{
  return SetCurrentSpriteSet(liLake,set);
}
//*******************************************************************
inline bool TACVPLobbyGameLord::SetRightLampIdle(int16 set)
{
  return SetCurrentSpriteSet(liRightLamp,set);
}
//*******************************************************************
inline bool TACVPLobbyGameLord::SetMinerIdle(int16 set)
{
  return SetCurrentSpriteSet(liMiner,set);
}
//*******************************************************************
inline bool TACVPLobbyGameLord::SetChuteIdle(int16 set)
{
  return SetCurrentSpriteSet(liChute,set);
}
//*******************************************************************
inline bool TACVPLobbyGameLord::SetSound1Idle(int16 set)
{
  return SetCurrentSpriteSet(liSound1,set);
}
//*******************************************************************
inline bool TACVPLobbyGameLord::SetSound2Idle(int16 set)
{
  return SetCurrentSpriteSet(liSound2,set);
}
//*******************************************************************
inline bool TACVPLobbyGameLord::SetSound3Idle(int16 set)
{
  return SetCurrentSpriteSet(liSound3,set);
}
//*******************************************************************
inline bool TACVPLobbyGameLord::SetClosedIdle(int16 set)
{
  return SetCurrentSpriteSet(liClosed,set);
}
//*******************************************************************
inline bool TACVPLobbyGameLord::SetBoardsIdle(int16 set)
{
  return SetCurrentSpriteSet(liBoards,set);
}
//*******************************************************************
#endif
