                              //*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  betcome.h
//    Project Name:  Casino
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     08/18/95   A. Krist    Original baseline
//          12/21/96   M.Perry     added virtual functions that were hidden.
//  2.0     09/18/97   M.Perry     32-bit conversion.
//*******************************************************************
#if !defined _betcome_h
#define _betcome_h

#include "ccbssp.h"
//*******************************************************************
class TBetCome : public TCBetSpot
{
public:
  TBetCome(TOgleModeWindow *pmw,const TFileMode &NewFileMode,int16 MessageCode);
  TBetCome(TOgleModeWindow *pmw,const TFileMode &NewFileMode,void *psource,int16 MessageCode);
  virtual ~TBetCome();
  virtual bool IsValidAdd(int16 Slot,TMoney amount,bool ComeOut,int16 Point);  //
  virtual bool IsValidRemove(int16 Slot,TMoney amount,bool ComeOut,int16 Point);  //
  virtual TMoney SubBSCash(int16 Slot,bool ComeOut);   // remove and return cash from bet spot
  virtual TMoney AddBSCash(int16 Slot,TMoney amount,bool ComeOut,int16 point);  // add cash to bet spot
  virtual TMoney AddBSCash(int16 Slot,TMoney amount,bool ComeOut,int16 Point,bool Flag);
  virtual bool Winner(int16 FirstDice,int16 SecondDice,int16 Point,bool ComeOut);
  virtual bool Winner(int16 FirstDice,int16 SecondDice,int16 Point,bool ComeOut,
                      bool Buy4n10,bool Buy5n9,bool Buy6n8,bool ComeFreeOdds,
                      bool DoNotComeFreeOdds,bool BuyPlaceOn,bool HardWaysOn)
  {
    return TCBetSpot::Winner(FirstDice,SecondDice,Point,ComeOut,Buy4n10,Buy5n9,
                             Buy6n8,ComeFreeOdds,DoNotComeFreeOdds,BuyPlaceOn,HardWaysOn);
  }
  virtual bool Loser(int16 FirstDice,int16 SecondDice,int16 Point,bool ComeOut);
  virtual bool Loser(int16 FirstDice,int16 SecondDice,int16 Point,bool ComeOut,
                     bool Buy4n10,bool Buy5n9,bool Buy6n8,bool ComeFreeOdds,
                     bool DoNotComeFreeOdds,bool BuyPlaceOn,bool HardWaysOn)
  {
    return TCBetSpot::Loser(FirstDice,SecondDice,Point,ComeOut,Buy4n10,Buy5n9,
                            Buy6n8,ComeFreeOdds,DoNotComeFreeOdds,BuyPlaceOn,HardWaysOn);
  }
  virtual int32 Odds();
};
//*******************************************************************
#endif