//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  bjs4st.h    // split 4 state
//    Project Name:  Casino
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     06/28/95   A. Krist    Original baseline
//  2.0     09/24/97   M.Perry     32-bit conversion.
//*******************************************************************
#if !defined __bjs4st_h
#define __bjs4st_h

#include "cbjglord.h"
#include "bjlordst.h"
//*******************************************************************
class TBJSplit4State : public TBJLordState
{
public:
  dword       Stalling;
  dword       StartingFUC;
  dword       FUCLength;

  TResponder *RemoveDoubleResponder;
  TResponder *ClearNoInsureStandResponder;
  TResponder *SameYesInsureHitResponder;
  TResponder *DealSplitResponder;
  TResponder *AskExpertResponder;
  TResponder *MenuEscResponder;

  int16       split;
  bool        splitflag;
  bool        doubleflag;
  bool        splitbutton;
  bool        firsttwocards;
  bool        splitacesflag;
  bool        askexpertflag;
  bool        WaitOnSkit;

  bool        WaitOnHitCom;
  bool        WaitOnStandCom;
  bool        WaitOnDoubleCom;
  bool        WaitOnSplitCom;
  bool        FinishSplit;
  bool        FinishHit;
  bool        FinishStand;
  bool        FinishDouble;

public:
  TBJSplit4State(TCasinoBJGameLord *pNewBJLord,int16 Split);
  virtual ~TBJSplit4State();

  virtual void ExecuteFirstTime();
  virtual void CreateSubState1();
  virtual void CreateSubState2();
  virtual void EndSubState1();
  virtual void CreateSubState3();
  virtual void EndSubState3();
  virtual bool HandleRemoveDouble(TResponder &responder);
  virtual bool HandleClearNoInsureStand(TResponder &responder);
  virtual bool HandleSameYesInsureHit(TResponder &responder);
  virtual bool HandleDealSplit(TResponder &responder);
  virtual bool HandleAskExpert(TResponder &responder);
  virtual bool HandleMenuEsc(TResponder &responder);

  virtual void HandlePostUpdate(dword NewFUC);
};
//*******************************************************************
#endif