//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  bjs8st.h    // split 8 state
//    Project Name:  Casino
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     06/28/95   A. Krist    Original baseline
//  2.0     09/23/97   M.Perry     32-bit converson.
//*******************************************************************
#if !defined __bjs8st_h
#define __bjs8st_h

#include "cbjglord.h"
#include "bjlordst.h"
//*******************************************************************
class TBJSplit8State : public TBJLordState
{
public:
  dword       Stalling;
  dword       StartingFUC;
  dword       FUCLength;

  TResponder *RemoveDoubleResponder;
  TResponder *ClearNoInsureStandResponder;
  TResponder *SameYesInsureHitResponder;
  TResponder *AskExpertResponder;
  TResponder *MenuEscResponder;

  int16       split;
  bool        doubleflag;
  bool        firsttwocards;
  bool        splitacesflag;
  bool        askexpertflag;
  bool        WaitOnSkit;

  bool        WaitOnHitCom;
  bool        WaitOnStandCom;
  bool        WaitOnDoubleCom;
  bool        FinishHit;
  bool        FinishStand;
  bool        FinishDouble;

public:
  TBJSplit8State(TCasinoBJGameLord *pNewBJLord,int16 Split);
  virtual ~TBJSplit8State();

  virtual void ExecuteFirstTime();
  virtual void CreateSubState1();
  virtual void CreateSubState2();
  virtual void EndSubState1();
  virtual bool HandleRemoveDouble(TResponder &responder);
  virtual bool HandleClearNoInsureStand(TResponder &responder);
  virtual bool HandleSameYesInsureHit(TResponder &responder);
  virtual bool HandleAskExpert(TResponder &responder);
  virtual bool HandleMenuEsc(TResponder &responder);

  virtual void HandlePostUpdate(dword NewFUC);
};
//*******************************************************************
#endif