//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  caccgfw.h
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.2     4/11/97    M.Perry    modified framewin hierarchy.
//  2.0    09/17/97    M.Perry    32-bit conversion.
//********************************************************************
#if !defined(__caccgfw_h)
#define __caccgfw_h

#include "casgfw.h"

class TCasACCApp;
//*******************************************************************
class TACCMenuEnable:public TCasinoMenuEnable
{
public:
//  bool Lobby;

  bool BlackJackOne,BlackJackTwo,BlackJackFour,BlackJackSix;

  bool Craps;
  bool Roulette;
  bool Keno;

  bool SlotsAladdin100,SlotsAladdin500,SlotsAladdin1P;

  bool SlotsParadise25,SlotsParadise50,SlotsParadise100;

  bool SlotsJungle1,SlotsJungle2,SlotsJungle100;

  bool SlotsPirate1,SlotsPirate2,SlotsPirate5,SlotsPirate10,SlotsPirate25,SlotsPirate50,SlotsPirate100;

  bool SlotsLucky1,SlotsLucky2,SlotsLucky5,SlotsLucky10,SlotsLucky25,SlotsLucky50;

  bool SlotsSpirit1000;

  bool SlotsJokers5,SlotsJokers10,SlotsJokers25,SlotsJokers50,SlotsJokers100;

  bool SlotsTotal1,SlotsTotal2,SlotsTotal5,SlotsTotal10,SlotsTotal500,SlotsTotal1000;

  bool SlotsCherry1,SlotsCherry2,SlotsCherry5,SlotsCherry10,SlotsCherry25,SlotsCherry50;

  bool VPJack1,VPJack5,VPJack25,VPJack100,VPJack1P;

  bool VPDWild1,VPDWild5,VPDWild25,VPDWild100;

  bool VPTen1,VPTen5,VPTen25,VPTen100;

  bool VPJWild1,VPJWild5,VPJWild25,VPJWild100;

public:
  TACCMenuEnable(bool setvalues = true);
  virtual ~TACCMenuEnable();
  virtual void SetAll(bool value);
  virtual void SetModes(bool value = true);
};
//*******************************************************************
class TCasACCGameFrameWindow:public TCasinoGameFrameWindow
{
public:
  int BJNumDecks;
  TCasACCGameFrameWindow(TCasACCApp *pcasaccapp,const char *szTitle);
  virtual ~TCasACCGameFrameWindow();
  virtual TWindow *CreateModeWindow(int16 ModeIndex);
  virtual int GetMenuID();
  virtual int GetAboutID();
  void DoMenu();
  virtual void SwitchGameModes(int16 modeindex);
  virtual void SwitchGameModes(string &name);
protected:
  TACCMenuEnable *GetACCMenuEnable() {return (TACCMenuEnable *)GetCasMenuEnable();}
  virtual void CreateMenuEnable();

  virtual void SetupModeStrings();
  virtual void SetupModeIndexes();
  virtual void SetupModeIDS();

  void CmGameLobby();
  void CeGameLobby(TCommandEnabler &enabler);

  // bj
  void SwitchBJ(int numdecks);
  void CmGameBlackJackOne();
  void CeGameBlackJackOne(TCommandEnabler &enabler);
  void CmGameBlackJackTwo();
  void CeGameBlackJackTwo(TCommandEnabler &enabler);
  void CmGameBlackJackFour();
  void CeGameBlackJackFour(TCommandEnabler &enabler);
  void CmGameBlackJackSix();
  void CeGameBlackJackSix(TCommandEnabler &enabler);
  // craps
  void CmGameCraps();
  void CeGameCraps(TCommandEnabler &enabler);
  // keno
  void CmGameKeno();
  void CeGameKeno(TCommandEnabler &enabler);
  // roulette
  void CmGameRoulette();
  void CeGameRoulette(TCommandEnabler &enabler);

  // slots aladdin
  void CmGameSlotsAladdin100();
  void CeGameSlotsAladdin100(TCommandEnabler &enabler);
  void CmGameSlotsAladdin500();
  void CeGameSlotsAladdin500(TCommandEnabler &enabler);
  void CmGameSlotsAladdin1P();
  void CeGameSlotsAladdin1P(TCommandEnabler &enabler);
  // slots paradise
  void CmGameSlotsParadise25();
  void CeGameSlotsParadise25(TCommandEnabler &enabler);
  void CmGameSlotsParadise50();
  void CeGameSlotsParadise50(TCommandEnabler &enabler);
  void CmGameSlotsParadise100();
  void CeGameSlotsParadise100(TCommandEnabler &enabler);
  // slots pirate
  void CmGameSlotsPirate1();
  void CeGameSlotsPirate1(TCommandEnabler &enabler);
  void CmGameSlotsPirate2();
  void CeGameSlotsPirate2(TCommandEnabler &enabler);
  void CmGameSlotsPirate5();
  void CeGameSlotsPirate5(TCommandEnabler &enabler);
  void CmGameSlotsPirate10();
  void CeGameSlotsPirate10(TCommandEnabler &enabler);
  void CmGameSlotsPirate25();
  void CeGameSlotsPirate25(TCommandEnabler &enabler);
  void CmGameSlotsPirate50();
  void CeGameSlotsPirate50(TCommandEnabler &enabler);
  void CmGameSlotsPirate100();
  void CeGameSlotsPirate100(TCommandEnabler &enabler);
  // slots lucky
  void CmGameSlotsLucky1();
  void CeGameSlotsLucky1(TCommandEnabler &enabler);
  void CmGameSlotsLucky2();
  void CeGameSlotsLucky2(TCommandEnabler &enabler);
  void CmGameSlotsLucky5();
  void CeGameSlotsLucky5(TCommandEnabler &enabler);
  void CmGameSlotsLucky10();
  void CeGameSlotsLucky10(TCommandEnabler &enabler);
  void CmGameSlotsLucky25();
  void CeGameSlotsLucky25(TCommandEnabler &enabler);
  void CmGameSlotsLucky50();
  void CeGameSlotsLucky50(TCommandEnabler &enabler);
  // slots spirit
  void CmGameSlotsSpirit1000();
  void CeGameSlotsSpirit1000(TCommandEnabler &enabler);
  // slots jokers
  void CmGameSlotsJokers5();
  void CeGameSlotsJokers5(TCommandEnabler &enabler);
  void CmGameSlotsJokers10();
  void CeGameSlotsJokers10(TCommandEnabler &enabler);
  void CmGameSlotsJokers25();
  void CeGameSlotsJokers25(TCommandEnabler &enabler);
  void CmGameSlotsJokers50();
  void CeGameSlotsJokers50(TCommandEnabler &enabler);
  void CmGameSlotsJokers100();
  void CeGameSlotsJokers100(TCommandEnabler &enabler);
  // slots total
  void CmGameSlotsTotal1();
  void CeGameSlotsTotal1(TCommandEnabler &enabler);
  void CmGameSlotsTotal2();
  void CeGameSlotsTotal2(TCommandEnabler &enabler);
  void CmGameSlotsTotal5();
  void CeGameSlotsTotal5(TCommandEnabler &enabler);
  void CmGameSlotsTotal10();
  void CeGameSlotsTotal10(TCommandEnabler &enabler);
  void CmGameSlotsTotal500();
  void CeGameSlotsTotal500(TCommandEnabler &enabler);
  void CmGameSlotsTotal1000();
  void CeGameSlotsTotal1000(TCommandEnabler &enabler);
  // slots cherry
  void CmGameSlotsCherry1();
  void CeGameSlotsCherry1(TCommandEnabler &enabler);
  void CmGameSlotsCherry2();
  void CeGameSlotsCherry2(TCommandEnabler &enabler);
  void CmGameSlotsCherry5();
  void CeGameSlotsCherry5(TCommandEnabler &enabler);
  void CmGameSlotsCherry10();
  void CeGameSlotsCherry10(TCommandEnabler &enabler);
  void CmGameSlotsCherry25();
  void CeGameSlotsCherry25(TCommandEnabler &enabler);
  void CmGameSlotsCherry50();
  void CeGameSlotsCherry50(TCommandEnabler &enabler);
  // slots jungle
  void CmGameSlotsJungle1();
  void CeGameSlotsJungle1(TCommandEnabler &enabler);
  void CmGameSlotsJungle2();
  void CeGameSlotsJungle2(TCommandEnabler &enabler);
  void CmGameSlotsJungle100();
  void CeGameSlotsJungle100(TCommandEnabler &enabler);

  void CmGameVPJack1();
  void CeGameVPJack1(TCommandEnabler &enabler);
  void CmGameVPJack5();
  void CeGameVPJack5(TCommandEnabler &enabler);
  void CmGameVPJack100();
  void CeGameVPJack100(TCommandEnabler &enabler);
  void CmGameVPJack25();
  void CeGameVPJack25(TCommandEnabler &enabler);
  void CmGameVPJack1P();
  void CeGameVPJack1P(TCommandEnabler &enabler);
  void CmGameVPDWild1();
  void CeGameVPDWild1(TCommandEnabler &enabler);
  void CmGameVPDWild5();
  void CeGameVPDWild5(TCommandEnabler &enabler);
  void CmGameVPDWild100();
  void CeGameVPDWild100(TCommandEnabler &enabler);
  void CmGameVPDWild25();
  void CeGameVPDWild25(TCommandEnabler &enabler);
  void CmGameVPJWild100();
  void CeGameVPJWild100(TCommandEnabler &enabler);

  void CmGameVPTen1();
  void CeGameVPTen1(TCommandEnabler &enabler);
  void CmGameVPTen5();
  void CeGameVPTen5(TCommandEnabler &enabler);
  void CmGameVPTen100();
  void CeGameVPTen100(TCommandEnabler &enabler);
  void CmGameVPTen25();
  void CeGameVPTen25(TCommandEnabler &enabler);

  void CmGameVPJWild1();
  void CeGameVPJWild1(TCommandEnabler &enabler);
  void CmGameVPJWild5();
  void CeGameVPJWild5(TCommandEnabler &enabler);
  void CmGameVPJWild25();
  void CeGameVPJWild25(TCommandEnabler &enabler);

private:

//  int16 idsIntro;
//  int16 miIntro;
//  int16 idsLobby,miLobby;
  int16 idsBlackJack,miBlackJack;
  int16 idsCraps,miCraps;
  int16 idsRoulette,miRoulette;
  int16 idsKeno,miKeno;
  int16 idsSlotsAladdin100,miSlotsAladdin100,idsSlotsAladdin500,
        miSlotsAladdin500,idsSlotsAladdin1P,miSlotsAladdin1P;
  int16 idsSlotsParadise25,miSlotsParadise25,idsSlotsParadise50,
        miSlotsParadise50,idsSlotsParadise100,miSlotsParadise100;
  int16 idsSlotsJungle1,miSlotsJungle1,idsSlotsJungle2,miSlotsJungle2,
        idsSlotsJungle100,miSlotsJungle100;
  int16 idsSlotsPirate1,miSlotsPirate1,idsSlotsPirate2,miSlotsPirate2,
        idsSlotsPirate5,miSlotsPirate5,idsSlotsPirate10,miSlotsPirate10,
        idsSlotsPirate25,miSlotsPirate25,idsSlotsPirate50,miSlotsPirate50,
        idsSlotsPirate100,miSlotsPirate100;
  int16 idsSlotsLucky1,miSlotsLucky1,idsSlotsLucky2,miSlotsLucky2,
        idsSlotsLucky5,miSlotsLucky5,idsSlotsLucky10,miSlotsLucky10,
        idsSlotsLucky25,miSlotsLucky25,idsSlotsLucky50,miSlotsLucky50;
  int16 idsSlotsSpirit1000,miSlotsSpirit1000;
  int16 idsSlotsJokers5,miSlotsJokers5,idsSlotsJokers10,miSlotsJokers10,
        idsSlotsJokers25,miSlotsJokers25,idsSlotsJokers50,miSlotsJokers50,
        idsSlotsJokers100,miSlotsJokers100;
  int16 idsSlotsTotal1,miSlotsTotal1,idsSlotsTotal2,miSlotsTotal2,idsSlotsTotal5,
        miSlotsTotal5,idsSlotsTotal10,miSlotsTotal10,idsSlotsTotal500,
        miSlotsTotal500,idsSlotsTotal1000,miSlotsTotal1000;
  int16 idsSlotsCherry1,miSlotsCherry1,idsSlotsCherry2,miSlotsCherry2,
        idsSlotsCherry5,miSlotsCherry5,idsSlotsCherry10,miSlotsCherry10,
        idsSlotsCherry25,miSlotsCherry25,idsSlotsCherry50,miSlotsCherry50;
  int16 idsVPJack1,miVPJack1,idsVPJack5,miVPJack5,idsVPJack25,miVPJack25,
        idsVPJack100,miVPJack100,idsVPJack1P,miVPJack1P;
  int16 idsVPDWild1,miVPDWild1,idsVPDWild5,miVPDWild5,idsVPDWild25,miVPDWild25,
        idsVPDWild100,miVPDWild100;
  int16 idsVPTen1,miVPTen1,idsVPTen5,miVPTen5,idsVPTen25,miVPTen25,idsVPTen100,
         miVPTen100;
  int16 idsVPJWild1,miVPJWild1,idsVPJWild5,miVPJWild5,idsVPJWild25,miVPJWild25,
        idsVPJWild100,miVPJWild100;

//  string strIntro;
//  string strLobby;
  string strBlackJack;
  string strCraps;
  string strRoulette;
  string strKeno;
  string strSlotsAladdin100,strSlotsAladdin500,strSlotsAladdin1P;
  string strSlotsParadise25,strSlotsParadise50,strSlotsParadise100;
  string strSlotsJungle1,strSlotsJungle2,strSlotsJungle100;
  string strSlotsPirate1,strSlotsPirate2,strSlotsPirate5,strSlotsPirate10,
         strSlotsPirate25,strSlotsPirate50,strSlotsPirate100;
  string strSlotsLucky1,strSlotsLucky2,strSlotsLucky5,strSlotsLucky10,
         strSlotsLucky25,strSlotsLucky50;
  string strSlotsSpirit1000;
  string strSlotsJokers5,strSlotsJokers10,strSlotsJokers25,strSlotsJokers50,
         strSlotsJokers100;
  string strSlotsTotal1,strSlotsTotal2,strSlotsTotal5,strSlotsTotal10,
         strSlotsTotal500,strSlotsTotal1000;
  string strSlotsCherry1,strSlotsCherry2,strSlotsCherry5,strSlotsCherry10,
         strSlotsCherry25,strSlotsCherry50;
  string strVPJack1,strVPJack5,strVPJack25,strVPJack100,strVPJack1P;
  string strVPDWild1,strVPDWild5,strVPDWild25,strVPDWild100;
  string strVPTen1,strVPTen5,strVPTen25,strVPTen100;
  string strVPJWild1,strVPJWild5,strVPJWild25,strVPJWild100;

  DECLARE_RESPONSE_TABLE(TCasACCGameFrameWindow);
};
//*******************************************************************
#endif