//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  Casgfw.h
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     9/14/95    M.Perry    original baseline
//  2.0    08/31/97    M.Perry    32-bit conversion.
//********************************************************************
#if !defined(__casgfw_h)
#define __casgfw_h

#include "ogamefw.h"
#include "casdef.h"

class CASOWLCLASS TCasinoApp;
class TCasinoPlayerMgr;
//*******************************************************************
class TCasinoMenuEnable:public TOgleMenuEnable
{
public:
  bool GamblerManagement;
  bool Strategy;
  bool Statistics;
  bool Instruction;
  bool Recommendation;
  bool Lobby;
  TMoney Denom;

  TCasinoMenuEnable(bool setvalues = true);
  virtual ~TCasinoMenuEnable();
  virtual void SetAll(bool value);
  virtual void SetModes(bool value = true);
};
//*******************************************************************
//*******************************************************************
class CASOWLCLASS TCasinoGameFrameWindow:public TOgleGameFrameWindow
{
protected:
  string strIntro;
  int16 miIntro;
  string strLobby;
  int16 miLobby,idsLobby;
  
public:
  virtual void CreateMenuEnable();
  TCasinoMenuEnable *GetCasMenuEnable() {return (TCasinoMenuEnable *)GetMenuEnable();}
  bool ShowIntro;
  // MRP
//  bool FadeIn;
//  void SetFadeIn(bool fade) {FadeIn = fade;}
//  bool GetFadeIn() {return FadeIn;}
  void GetIniShowIntro();
  void SetIniShowIntro();
  void CmShowIntro();
  void CeShowIntro(TCommandEnabler &ce);
  TCasinoPlayerMgr *GetCasPlayerMgr() {return (TCasinoPlayerMgr *)PlayerMgr;}
  virtual int GetAboutID();
  TCasinoGameFrameWindow(TCasinoApp *pcasapp,const char *szTitle,bool shrinktoclient,bool doresources);
  virtual ~TCasinoGameFrameWindow();

  virtual void CreatePlayerMgr();
  virtual void SwitchGameModes(int16 modeindex);
  virtual void SwitchGameModes(string &name) {SwitchGameModes(GetModeIndex(name));}

  virtual TWindow *CreateModeWindow(int16 ModeIndex);

protected:
  int16 GetModeIndex(string &modename);
  string GetModeName(int16 mi);

public:
  void CmFileGamblerManagement();
  void CeFileGamblerManagement(TCommandEnabler &enabler);
  void CmFileExitGame();
  void CeFileExitGame(TCommandEnabler &enabler);

  void CmSoundFX();
  void CeSoundFX(TCommandEnabler &enabler);
  void CmSoundMusic();
  void CeSoundMusic(TCommandEnabler &enabler);

  void CmHelpContents();
  void CeHelpContents(TCommandEnabler &enabler);
  void CmHelpAbout();
  void CeHelpAbout(TCommandEnabler &enabler);

  DECLARE_RESPONSE_TABLE(TCasinoGameFrameWindow);
};
//*******************************************************************
#endif

