//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  cbjcalc.h
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     9/6/96     M.Perry    derived from Dave's code
//  2.0    09/17/97    M.Perry    32-bit conversion.
//********************************************************************
#if !defined(__cbjcalc_h)
#define __cbjcalc_h
                                        
#include "cstcalc.h"
//*******************************************************************
class TStatCalcBJ:public TCasinoStatCalc
{
public:
  enum {bjDate = 1,bjHoursPlayed = 2,bjGameType = 3,bjTotalNumBets = 6,bjTotalCashBets = 7,
        bjAvgCashBets = 8,bjStartingBankroll = 9,bjEndingBankroll = 10,bjTotalCashWL = 11,
        bjReturnPerc = 12,bjAvgWLPerHour = 13,bjCumCashWL = 14,bjHandsPlayed = 17,
        bjHandsWon = 18,bjHandsLost = 19,bjHandsPushed = 20,bjPercHandsWon = 21,
        bjPercHandsLost = 22,bjPercHandsPushed = 23,bjLongestWinStreak = 24,bjLongestLosingStreak = 25,
        bjLargestCashWin = 26,bjLargestCashLost = 27,bjPeakCashWinLevel = 28,bjLowCashLossLevel = 29,
        bjInsBetsWon = 31,bjInsBetsLost = 32,bjNumBJ = 33,bjNumDD = 34,bjNumSplits = 35,
        bjPercBJ = 36,bjPercDD = 37,bjPercSplits = 38,bjCashWLDD = 39,bjCashWLSplits = 40,
        bjPercBusts = 42,bjPercStand21 = 43,bjPercStand20 = 44,bjPercStand19 = 45,bjPercStand18 = 46,
        bjPercStand17 = 47,bjPercStandLT17 = 48,bjNumIncPlays = 51,bjPercAcc = 52,
        bjHandsPlus = 54,bjAvgBetPlus = 55,bjCashWLPlus = 56,bjHandsMinus = 57,bjAvgBetMinus = 58,
        bjCashWLMinus = 59};

  TStatCalcBJ(TCasinoStatDlg *pstatdlg);
  virtual ~TStatCalcBJ();
  virtual void LocalFillGrid();
  virtual void LocalCalculate();
  virtual void LocalMakeAllStrings();
  virtual void GetSessionPtrs();
  TCasinoBJData *GetBJData() {return (TCasinoBJData *)PData;}
  TCBJSession *GetBJSession(int i) {return (TCBJSession *)PSessions[i];}
  virtual bool GetValues(int statindex,float *values,int maxvalueindex);

private:
  virtual string MakeSubGameTypeStr(int subgametype,TMoney gamedenom);

  void Make_CumulativeCashWLStrs();
  void Calc_CumulativeCashWL();

  void Make_HandsPlayedStrs();
  void Calc_HandsPlayed();

  void Make_HandsPushedStrs();
  void Calc_HandsPushed();
  string HandsPushedStr[NUMSESSIONS];
  string Total_HandsPushedStr;
  long Total_HandsPushed;

  void Make_PercHandsPushedStrs();
  void Calc_PercHandsPushed();
  string PercHandsPushedStr[NUMSESSIONS];
  string Total_PercHandsPushedStr;
  float Total_PercHandsPushed;
  float PercHandsPushed[NUMSESSIONS];

  void Make_InsuranceBetsWonStrs();
  void Calc_InsuranceBetsWon();
  string InsuranceBetsWonStr[NUMSESSIONS];
  string Total_InsuranceBetsWonStr;
  long Total_InsuranceBetsWon;

  void Make_InsuranceBetsLostStrs();
  void Calc_InsuranceBetsLost();
  string InsuranceBetsLostStr[NUMSESSIONS];
  string Total_InsuranceBetsLostStr;
  long Total_InsuranceBetsLost;

  void Make_NumBJStrs();
  void Calc_NumBJ();
  string NumBJStr[NUMSESSIONS];
  string Total_NumBJStr;
  long Total_NumBJ;
  bool GetNumBJ(float *values,int num);

  void Make_NumDDStrs();
  void Calc_NumDD();
  string NumDDStr[NUMSESSIONS];
  string Total_NumDDStr;
  long Total_NumDD;
  bool GetNumDD(float *values,int num);

  void Make_NumSplitsStrs();
  void Calc_NumSplits();
  string NumSplitsStr[NUMSESSIONS];
  string Total_NumSplitsStr;
  long Total_NumSplits;

  void Make_PercBJStrs();
  void Calc_PercBJ();
  string PercBJStr[NUMSESSIONS];
  string Total_PercBJStr;
  float PercBJ[NUMSESSIONS];
  float Total_PercBJ;

  void Make_PercDDStrs();
  void Calc_PercDD();
  string PercDDStr[NUMSESSIONS];
  string Total_PercDDStr;
  float PercDD[NUMSESSIONS];
  float Total_PercDD;

  void Make_PercSplitsStrs();
  void Calc_PercSplits();
  string PercSplitsStr[NUMSESSIONS];
  string Total_PercSplitsStr;
  float PercSplits[NUMSESSIONS];
  float Total_PercSplits;

  void Make_CashWLDDStrs();
  void Calc_CashWLDD();
  string CashWLDDStr[NUMSESSIONS];
  string Total_CashWLDDStr;
  TMoney Total_CashWLDD;

  void Make_CashWLSplitsStrs();
  void Calc_CashWLSplits();
  string CashWLSplitsStr[NUMSESSIONS];
  string Total_CashWLSplitsStr;
  TMoney Total_CashWLSplits;

  void Calc_NumBusts();
  long Total_NumBusts;

  void Make_PercBustsStrs();
  void Calc_PercBusts();
  string PercBustsStr[NUMSESSIONS];
  string Total_PercBustsStr;
  float PercBusts[NUMSESSIONS];
  float Total_PercBusts;

  void Calc_NumStand21();
  long Total_NumStand21;

  void Make_PercStand21Strs();
  void Calc_PercStand21();
  string PercStand21Str[NUMSESSIONS];
  string Total_PercStand21Str;
  float PercStand21[NUMSESSIONS];
  float Total_PercStand21;

  void Calc_NumStand20();
  long Total_NumStand20;

  void Make_PercStand20Strs();
  void Calc_PercStand20();
  string PercStand20Str[NUMSESSIONS];
  string Total_PercStand20Str;
  float PercStand20[NUMSESSIONS];
  float Total_PercStand20;

  void Calc_NumStand19();
  long Total_NumStand19;

  void Make_PercStand19Strs();
  void Calc_PercStand19();
  string PercStand19Str[NUMSESSIONS];
  string Total_PercStand19Str;
  float PercStand19[NUMSESSIONS];
  float Total_PercStand19;

  void Calc_NumStand18();
  long Total_NumStand18;

  void Make_PercStand18Strs();
  void Calc_PercStand18();
  string PercStand18Str[NUMSESSIONS];
  string Total_PercStand18Str;
  float PercStand18[NUMSESSIONS];
  float Total_PercStand18;

  void Calc_NumStand17();
  long Total_NumStand17;

  void Make_PercStand17Strs();
  void Calc_PercStand17();
  string PercStand17Str[NUMSESSIONS];
  string Total_PercStand17Str;
  float PercStand17[NUMSESSIONS];
  float Total_PercStand17;

  void Calc_NumStandLT17();
  long Total_NumStandLT17;

  void Make_PercStandLT17Strs();
  void Calc_PercStandLT17();
  string PercStandLT17Str[NUMSESSIONS];
  string Total_PercStandLT17Str;
  float PercStandLT17[NUMSESSIONS];
  float Total_PercStandLT17;

  void Make_NumBadStrategyPlaysStrs();
  void Calc_NumBadStrategyPlays();
  string NumBadStrategyPlaysStr[NUMSESSIONS];
  string Total_NumBadStrategyPlaysStr;
  long Total_NumBadStrategyPlays;
  bool GetNumIncPlays(float *values,int num);

  void Make_PercPlayingAccuracyStrs();
  void Calc_PercPlayingAccuracy();
  string PercPlayingAccuracyStr[NUMSESSIONS];
  string Total_PercPlayingAccuracyStr;
  float PercPlayingAccuracy[NUMSESSIONS];
  float Total_PercPlayingAccuracy;
  bool GetPercAccuracy(float *values,int num);

  void Make_HandsPlusCountStrs();
  void Calc_HandsPlusCount();
  string HandsPlusCountStr[NUMSESSIONS];
  string Total_HandsPlusCountStr;
  long Total_HandsPlusCount;
  bool GetHandsPlus(float *values,int num);

  TMoney Total_TotalBetsCashPlusCount;

  void Make_AvgBetPlusCountStrs();
  void Calc_AvgBetPlusCount();
  string AvgBetPlusCountStr[NUMSESSIONS];
  string Total_AvgBetPlusCountStr;
  float AvgBetPlusCount[NUMSESSIONS];
  float Total_AvgBetPlusCount;

  void Make_CashWLPlusCountStrs();
  void Calc_CashWLPlusCount();
  string CashWLPlusCountStr[NUMSESSIONS];
  string Total_CashWLPlusCountStr;
  TMoney Total_CashWLPlusCount;
  bool GetCashWLPlus(float *values,int num);

  void Make_HandsZMinusCountStrs();
  void Calc_HandsZMinusCount();
  string HandsZMinusCountStr[NUMSESSIONS];
  string Total_HandsZMinusCountStr;
  long HandsZMinusCount[NUMSESSIONS];
  long Total_HandsZMinusCount;
  bool GetHandsMinus(float *values,int num);

  void Make_AvgBetZMinusCountStrs();
  void Calc_AvgBetZMinusCount();
  string AvgBetZMinusCountStr[NUMSESSIONS];
  string Total_AvgBetZMinusCountStr;
  float AvgBetZMinusCount[NUMSESSIONS];
  float Total_AvgBetZMinusCount;

  void Make_CashWLZMinusCountStrs();
  void Calc_CashWLZMinusCount();
  string CashWLZMinusCountStr[NUMSESSIONS];
  string Total_CashWLZMinusCountStr;
  TMoney Total_CashWLZMinusCount;
  TMoney CashWLZMinusCount[NUMSESSIONS];
  bool GetCashWLMinus(float *values,int num);
};
//*******************************************************************
class TBJGraph:public TCasinoGraphDlg
{
public:
  TBJGraph(TCasinoStatDlg* pstatdlg,TStatCalcBJ *pstatcalc);
  virtual ~TBJGraph();
};
//*******************************************************************
#endif
