//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  cbjdata.h
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0    9/9/96      M.Perry    split up cplaydat file.
//  2.0   09/17/97     M.Perry    32-bit conversion.
//********************************************************************
#if !defined(__cbjdata_h)
#define __cbjdata_h

#include "casdata.h"
//*******************************************************************
struct TCBJSession : public TCasinoSession
{
  int16 HandsPlayedCGT1;
  int16 HandsPlayedCLT2;
  TMoney TotalBetsCashCGT1;
  TMoney TotalBetsCashCLT2;
  TMoney TotalCashWLCGT1;
  TMoney TotalCashWLCLT1;
  TMoney DDWinnings;
  int16 InsureWon;
  int16 InsureLost;
  TMoney DDownWL;
  TMoney SplitsWL;
  int16 Player21;
  int16 Player20;
  int16 Player19;
  int16 Player18;
  int16 Player17;
  int16 Player16Less;
  int16 BJWins;
  int16 DDWins;
  int16 WinsCGT1;
  int16 WinsCLT2;
  int16 Pushes;
  int16 Splits;
  int16 DDowns;
  int16 Busts;
  int16 DealerBusts;
  int16 DealerBJ;
  TCBJSession();
  void ClearData();
  void StartSession(TMoney startingcash,int16 subgametype,TMoney denom);
  void EndSession(TMoney endingcash);
};
//*******************************************************************
struct TCasinoBJData : public TCasinoData
{
  TCBJSession Sessions[NUMSESSIONS];
  dword LastBJSessionEndTime;
  bool  FirstPlayerBJHandEver;
  TMoney Cumulative;

  TCasinoBJData();
  void ClearData();
  void StartSession(TMoney startingcash,int16 subgametype,
                    TMoney denom = TMoney(TMoney::ctorDenomID,TMoney::did_1_00));//cd1);
  void EndSession(TMoney endingcash);
  int16 GetFirstValidSession();
  int16 GetNextValidSession();
  void IncCurrentSession();
  int16 GetPrevValidSession();
};
//*******************************************************************
#endif
