//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  cbjglord.h
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     10/15/95   M.Perry     original baseline
//  2.0     09/20/97   M.Perry     32-bit conversion.
//********************************************************************
#if !defined(__cbjglord_h)
#define __cbjglord_h

#include "casglord.h"
#include "cascdsp.h"    //Cash Display
#include "casmessp.h"   //Message Display
#include "circlesp.h"   //Circle
#include "casbutsp.h"  // Button
#include "casbusp.h"    // Bet Unit
#include "cbjsdsp.h"

class TBJDeck;
class TBJAsk;

#include "bjsmarts.h"

class TBlackJackModeWin;
class TBJLordMainState;
class TCasinoBJPlayer;

#include "cbjdspsp.h"  // dealer spot
#include "cbjbssp.h"
#include "caschsp.h"
#include "cbjdlrsp.h"
#include "bjhand.h"
#include "cbjrksp.h"
#include "cbjsgsp.h"
#include "cnamesp.h"
//*******************************************************************
enum TBJGLordRID
{
  bjidButton0,bjidButton1,bjidButton2,bjidButton3,bjidButton4,bjidButton5,bjidButton6,bjidButton7,
  bjidButton8,bjidButton9,bjidButton10,bjidButton11,bjidButton12,bjidButton13,bjidButton14,bjidButton15,
  bjidButton16,bjidButton17,bjidButton18,
  bjidBetSpot0,
  bjidBetSpot1,
  bjidBetSpot2,
  bjidBetSpot3,
  bjidBetSpot4,
  bjidBetSpot5,
  bjidBetSpot6,

  bjidDealer,
  bjidDealerSpot,

  bjidNamePlate,
  bjidStatBar,
  bjidFeltCursor
};
//*******************************************************************
enum TBJNumLet
{
  bjnl1A,bjnl1B,bjnl1C,
  bjnl2C,bjnl2D,bjnl2E,
  bjnl3E,bjnl3F,bjnl3G,
  bjnl0D,bjnl0U
};
//*******************************************************************
enum TBJLookFromTo
{
  bjlf0To1,bjlf0To2,bjlf0To3,
  bjlf1To2,bjlf1To3,bjlf2To3,
  bjlf1To0,bjlf2To0,bjlf3To0,
  bjlf3To2,bjlf3To1,bjlf2To1,
  bjlf0To0
};
//*******************************************************************
enum TBJBodyIdle
{
  bjbiDealer = 0,
  bjbiP1 = 1,
  bjbiP2 = 2,
  bjbiP3 = 3
};
//*******************************************************************
class TCasinoBJGameLord:public TCasinoGameLord
{
public:
  enum {NUMBEROFPLAYERS = 3,NumResponders = 5,NUMOFBUTTONS = 19,STALLDELAY = 78};

  TBlackJackModeWin      *pMWin;
  TBJSound               *BJSounds;
  TBJDeck                *pDeck;
  TBJSmarts              *pSmarts;
  TBJHand                *pHand;
  TBJAsk                 *pAskExpert;
  TBJRack                *Rack;
  TBJSign                *Sign;
  TBJBetSpot             *BetSpot[7];
  TBJDealer              *Dealer;
  TBJDealerSpot          *DealerSpot;
  TCasChips              *Chips;
  TCasNamePlate          *NamePlate1;
  TCasNamePlate          *NamePlate2;
  TCasNamePlate          *NamePlate3;
  TCircle                *Circle1;
  TCircle                *Circle2;
  TCircle                *Circle3;
  TCasButton             *Button0;
  TCasButton             *Button1;
  TCasButton             *Button2;
  TCasButton             *Button3;
  TCasButton             *Button4;
  TCasButton             *Button5;
  TCasButton             *Button6;
  TCasButton             *Button7;
  TCasButton             *Button8;
  TCasButton             *Button9;
  TCasButton             *Button10;
  TCasButton             *Button11;
  TCasButton             *Button12;
  TCasButton             *Button13;
  TCasButton             *Button14;
  TCasButton             *Button15;
  TCasButton             *Button16;
  TCasButton             *Button17;
  TCasButton             *Button18;
  TCasMessageDisplay     *MessageDisplay;
  TCasCashDisplay        *BankCashDisplay;
  TCasCashDisplay        *BetAmountDisplay;
  TResponder *Responders[NumResponders];

  TMoney credits;
  TMoney coinsplayed;
  TMoney coinsize;
  TMoney winnerpaid;
  TMoney maxbet;

  TBJNumLet LookingAt;

  int16 BJSkitIndex[11];
  int16 ButtonInfo;

  // skits
  int16 greetplayers,shuffle,placebets,predealcom,declareplayer1bj,declareplayer2bj,declareplayer3bj,
		promptinsurance,dealerbj,dealernobj,stalling1a,stalling1b,stalling1c,stalling2c,stalling2d,stalling2e,
		stalling3e,stalling3f,stalling3g,doublecomplayer1,doublecomplayer2,doublecomplayer3,
		hitcomplayer1,hitcomplayer2,hitcomplayer3,standcomplayer1,standcomplayer2,standcomplayer3,
		announcedealertotal,announceplayer1total,announceplayer2total,announceplayer3total,
		announcedealerbust,player1bust,player2bust,player3bust,accepttipplayer1,accepttipplayer2,
		accepttipplayer3,winner1,winner2,winner3,push1,push2,push3,loser1,loser2,loser3,
		postreconcilecom,gettraydiscards,evenmoneyplayer1,evenmoneyplayer2,evenmoneyplayer3,
		splitcomplayer1,splitcomplayer2,splitcomplayer3,getcards1,getcards2,getcards3;

  // sprites
  int16 dealcard1a,dealcard1b,dealcard1c,dealcard2c,dealcard2d,dealcard2e,dealcard3e,dealcard3f,
		dealcard3g,dealerdown,dealerup,dealercheckholecard,dealerexposeholecard,lookfrom0to1,
		lookfrom0to2,lookfrom0to3,lookfrom1to2,lookfrom1to3,lookfrom2to3,lookfrom1to0,lookfrom2to0,
		lookfrom3to0,lookfrom3to1,lookfrom3to2,lookfrom2to1,promptaction1a,promptaction1b,
		promptaction1c,promptaction2c,promptaction2d,promptaction2e,promptaction3e,promptaction3f,
		promptaction3g,hitfingersm1a,hitfingersm1b,hitfingersm1c,hitfingersm2c,hitfingersm2d,
		hitfingersm2e,hitfingersm3e,hitfingersm3f,hitfingersm3g,hitfingersf1a,hitfingersf1b,
		hitfingersf1c,hitfingersf2c,hitfingersf2d,hitfingersf2e,hitfingersf3e,hitfingersf3f,
		hitfingersf3g,standfingersm1a,standfingersm1b,standfingersm1c,standfingersm2c,
		standfingersm2d,standfingersm2e,standfingersm3e,standfingersm3f,standfingersm3g,
		standfingersf1a,standfingersf1b,standfingersf1c,standfingersf2c,standfingersf2d,
		standfingersf2e,standfingersf3e,standfingersf3f,standfingersf3g,removedealercards;

  int16 BetSpotUse[7];
  int16 machinenum;
  int16 pot;
  int16 playersin;
  int16 totaldecks;
  int16 halfdecksplayed;
  int16 halfdecksleft;
  int16 truecount;
  int16 runningcount;
  int16 StartTC;
  int16 acecount;
  int16 cardsplayed;
  int16 newdeal;
  int16 numofdecks;
  int16 newdeckcount;
  int16 decksflag;
  int16 shutdownstate;
  int16 StallsInRow;
  int16  ThreeBets,ThreePreviousBets;

  bool InsuranceBetMade;
  bool SwitchDeckNowFlag;
  bool ALLHANDSWON;
  bool ALLPREVIOUSHANDSWON;
  bool PlaceBetsMode;
  bool  ButtonHit[NUMOFBUTTONS];
  bool splitwait;

public:
  TCasinoBJGameLord(TBlackJackModeWin *PNewOwnerWindow,const TFileMode &fm);
  virtual ~TCasinoBJGameLord();
  virtual void SetupSkits() {}
  #if defined(SUPPORT_OLD_VER)
  string strSounds,strSign,strRack,strCircle1,strCircle2,strCircle3,
         strNP1,strNP2,strNP3,strMsgDisplay,strBankCash,strBetAmount,
         strButton0,strButton1,strButton2,strButton3,strButton4,strButton5,
         strButton6,strButton7,strButton8,strButton9,strButton10,strButton11,
         strButton12,strButton13,strButton14,strButton15,strButton16,strButton17,
         strButton18,strBetSpot0,strBetSpot1,strBetSpot2,strBetSpot3,strBetSpot4,
         strBetSpot5,strBetSpot6,strDealerSpot,strChips;
  virtual void SetupUniqueIDStrings();
  virtual int16 GetUniqueID(const string &s);
  #endif
  virtual TSprite *CreateSprite(string spritename,int16 id = 0,void *psource = NULL);
  virtual bool Respond(int16 Button,int16 info = 0,void *pdata = NULL);
  TBlackJackModeWin *GetBJMW();
  TCasinoBJPlayer *GetBJPlayer(int16 slotnum);
  void EnableAllButtons();
  void DisEnableAllButtons();
  void FreezeAllButtons();
  void UnFreezeAllButtons();
  virtual bool Respond(TResponder &responder);
  void SetupResponders();
  void CleanupResponders();
  virtual int16 AskCriteriaQuestion(int16 QNum);
  // idles
  bool SetBodyIdle();
  bool BodyIdle(TBJBodyIdle bodyidle);

  // skits
  bool Stalling(dword &StartFUC,dword &FUCLength);
  bool GreetPlayers(dword &StartFUC,dword &FUCLength);
  bool Shuffle(dword &StartFUC,dword &FUCLength);
  bool PlaceBets(dword &StartFUC,dword &FUCLength);
  bool PreDealCom(dword &StartFUC,dword &FUCLength);
  bool DeclarePlayer1BJ(dword &StartFUC,dword &FUCLength);
  bool DeclarePlayer2BJ(dword &StartFUC,dword &FUCLength);
  bool DeclarePlayer3BJ(dword &StartFUC,dword &FUCLength);
  bool PromptInsurance(dword &StartFUC,dword &FUCLength);
  bool EvenMoneyPlayer1(dword &StartFUC,dword &FUCLength);
  bool EvenMoneyPlayer2(dword &StartFUC,dword &FUCLength);
  bool EvenMoneyPlayer3(dword &StartFUC,dword &FUCLength);
  bool DealerBJ(dword &StartFUC,dword &FUCLength,int16 &RemoveBack,int16 &ShowFace);
  bool DealerNoBJ(dword &StartFUC,dword &FUCLength);
  bool DoubleComPlayer1(dword &StartFUC,dword &FUCLength);
  bool DoubleComPlayer2(dword &StartFUC,dword &FUCLength);
  bool DoubleComPlayer3(dword &StartFUC,dword &FUCLength);
  bool HitComPlayer1(dword &StartFUC,dword &FUCLength);
  bool HitComPlayer2(dword &StartFUC,dword &FUCLength);
  bool HitComPlayer3(dword &StartFUC,dword &FUCLength);
  bool StandComPlayer1(dword &StartFUC,dword &FUCLength);
  bool StandComPlayer2(dword &StartFUC,dword &FUCLength);
  bool StandComPlayer3(dword &StartFUC,dword &FUCLength);
  bool SplitComPlayer1(dword &StartFUC,dword &FUCLength);
  bool SplitComPlayer2(dword &StartFUC,dword &FUCLength);
  bool SplitComPlayer3(dword &StartFUC,dword &FUCLength);
  bool AnnounceDealerTotal(dword &StartFUC,dword &FUCLength);
  bool AnnouceDealerBust(dword &StartFUC,dword &FUCLength);
  bool AnnouncePlayer1Total(dword &StartFUC,dword &FUCLength);
  bool AnnouncePlayer2Total(dword &StartFUC,dword &FUCLength);
  bool AnnouncePlayer3Total(dword &StartFUC,dword &FUCLength);
  bool Player1Bust(dword &StartFUC,dword &FUCLength);
  bool Player2Bust(dword &StartFUC,dword &FUCLength);
  bool Player3Bust(dword &StartFUC,dword &FUCLength);
  bool AcceptTipPlayer1(dword &StartFUC,dword &FUCLength);
  bool AcceptTipPlayer2(dword &StartFUC,dword &FUCLength);
  bool AcceptTipPlayer3(dword &StartFUC,dword &FUCLength);
  bool Winner1(dword &StartFUC,dword &FUCLength);
  bool Winner2(dword &StartFUC,dword &FUCLength);
  bool Winner3(dword &StartFUC,dword &FUCLength);
  bool Push1(dword &StartFUC,dword &FUCLength);
  bool Push2(dword &StartFUC,dword &FUCLength);
  bool Push3(dword &StartFUC,dword &FUCLength);
  bool Loser1(dword &StartFUC,dword &FUCLength);
  bool Loser2(dword &StartFUC,dword &FUCLength);
  bool Loser3(dword &StartFUC,dword &FUCLength);
  bool PostReconcileCom(dword &StartFUC,dword &FUCLength);
  bool GetTrayDiscards(dword &StartFUC,dword &FUCLength);
  bool GetCards(dword &StartFUC,dword &FUCLength,int16 &Remove,int16 &Show);

  // sprites
  bool DealCard(int16 dealto,dword &StartFUC,dword &FUCLength,dword &CardFUC);
  // the following temp until Adam switches over.
  bool DealCard(int16 dealto,dword &StartFUC,dword &FUCLength);
  bool CheckHoleCard(dword &StartFUC,dword &FUCLength,int16 &Remove,int16 &Show);
  bool RemoveDealerCards(dword &StartFUC,dword &FUCLength,int16 &Remove,int16 &Show);
  bool ExposeHoleCard(dword &StartFUC,dword &FUCLength,int16 &Remove,int16 &Show);
  bool LookFromTo(TBJLookFromTo lookfromto,dword &StartFUC,dword &FUCLength,bool AnmOn=true);
  bool PromptAction(int16 promptwho,dword &StartFUC,dword &FUCLength);
  bool HitFingers(bool SexMale,int16 hitwho,dword &StartFUC,dword &FUCLength);
  bool StandFingers(bool SexMale,int16 standwho,dword &StartFUC,dword &FUCLength);

//  virtual TSpriteList *CreateSpriteList(TFileMode splfm);
  virtual void SetupSprites();
  virtual void CleanupSprites();

  int16 ShuffleCards();
  int16 SwitchDecks();

  void AskBetExpert();
  void AskFirstTwoCardsExpert(int16 handNum,bool Show=true);
  void AskAfterFirstTwoCardsExpert(int16 handNum,bool Show=true);
  void AskInsuranceExpert();

  int16 DoubleDown(int16 x);

  int16 ShowHands();
  int16 ShowWinner();
  int16 GetBet();
  int16 ClearBet();
  int16 Bet1(TMoney betsize);
  int16 UnBet1(TMoney betsize);
  int16 BetMax();
  int16 CashOut();
  int16 GoodToGo();
  int16 InitBJ();
  int16 DrawDeal();
  int16 DealerDraw();
  TMoney Winner(int16 winner);
  int16 Pusher(int16 pusher);
  int16 Loser(int16  loser);
  int16 Clear();
  int16 PlaceBet(int16 x);
  int16 RemoveBet(int16 x);
  int16 RemoveInsure(int16 x);
  int16 PlaceInsure(int16 x);
  int16 DealerBlackJack(int16 x);
  int16 SetBlackJack();
  int16 Count(TCard *card);
  int16 PlayerHas(int16 Total);
  int16 PlayerHas777();
  int16 PlayerBet1000();
  int16 PlayerBetGT(int32 Amount);
  int16 OneHumanPlayer();
  int16 RandomLT(int16 num);
  int16 OneAndOnlyPlayerHandBJ();
  int16 AllHandsWon();
  int16 BetweenDec22_Dec25();
  int16 BetweenDec31_Jan2();
  int16 ValentinesDay();
  int16 StPatricksDay();
  int16 TwoHumanPlayers();
  int16 ThreeHumanPlayers();
  int16 AllPlayersMale();
  int16 AllPlayersFemale();
  int16 OneAndOnlyPlayerGT20000();
  int16 BJ10HandsPlayed();
  int16 PlayerBust();
  int16 PlayerHasSoft(int16 Total);
  int16 DealerHas(int16 Total);
  int16 DealerUpcard(int16 name);
  int16 DealerBust();
  int16 GTWeekPlayersLastPlayed();
  int16 PlayersFirstBJHandEver();
  int16 FirstBJHandSinceInStall();
  int16 NumOfCoins(TMoney money);
  int16 GetPlayin() {return playersin;};
  bool BetMade(int16 Player);
  int16 BetLast();
  void  SwitchToPlayer(int16 player);
  void  CyclePlayers();
  void  SwitchDeckNow();
  TMoney SplitMoney(TMoney Amount);
  virtual void  SetupActivePlayer(int16 slot);
  virtual void NotifyPlayerActivation(int16 slotnum);
  virtual void NotifyPlayerDeActivation(int16 slotnum);
  virtual void ShuttingDown();
  void EnableButton(int16 button);
  void DisEnableButton(int16 button);
  void ButtonClear(int16 button);
  int16 IsMale();
  int16 IsFemale();
  int16 NumOfDecks(int16 decks);
  int16 ThreePreviousWin();
  int16 ThreeBetsWin();
  int16 AnyBetGT5000();
  int16 HandHas(int16 cards);
  int16 HandHasGT(int16 cards);
  int16 Stalls(int16 num);
  int16 Stalls0Or1();
  int16 StallsGT(int16 num);
  int16 PlayerHasBJ();
  int16 TopCard(int16 num);
  int16 DealerStood2Cards();
  int16 AnyInsuranceBetMade();
  int16 PlayerInsuranceDealerBJ();
  int16 PlayerTotal();//message display helper function
  int16 DealerTotal();//message display helper function
  #ifdef DEBUGIDLES
  TSprite *DealerPos;
  TSprite *Pos1;
  TSprite *Pos2;
  TSprite *Pos3;
  #endif
};
//*******************************************************************
//***********************  inlines  *********************************
//*******************************************************************
inline TBlackJackModeWin *TCasinoBJGameLord::GetBJMW()
{
  return (TBlackJackModeWin *)PModeWin;
}
//*******************************************************************
inline TCasinoBJPlayer *TCasinoBJGameLord::GetBJPlayer(int16 slotnum)
{
  return ((TCasinoBJPlayer *)GetCasPlayer(slotnum));
}
//*******************************************************************
inline bool TCasinoBJGameLord::BodyIdle(TBJBodyIdle bodyidle)
{
  return SetCurrentSpriteSet(1,int16(bodyidle));
}
//*******************************************************************
inline bool TCasinoBJGameLord::GreetPlayers(dword &StartFUC,dword &FUCLength)
{
  return ChooseStartSkit(greetplayers,StartFUC,FUCLength);
}
//*******************************************************************
inline bool TCasinoBJGameLord::Shuffle(dword &StartFUC,dword &FUCLength)
{
  return ChooseStartSkit(shuffle,StartFUC,FUCLength);
}
//*******************************************************************
inline bool TCasinoBJGameLord::PlaceBets(dword &StartFUC,dword &FUCLength)
{
  return ChooseStartSkit(placebets,StartFUC,FUCLength);
}
//*******************************************************************
inline bool TCasinoBJGameLord::PreDealCom(dword &StartFUC,dword &FUCLength)
{
  return ChooseStartSkit(predealcom,StartFUC,FUCLength);
}
//*******************************************************************
inline bool TCasinoBJGameLord::DeclarePlayer1BJ(dword &StartFUC,dword &FUCLength)
{
  return ChooseStartSkit(declareplayer1bj,StartFUC,FUCLength);
}
//*******************************************************************
inline bool TCasinoBJGameLord::DeclarePlayer2BJ(dword &StartFUC,dword &FUCLength)
{
  return ChooseStartSkit(declareplayer2bj,StartFUC,FUCLength);
}
//*******************************************************************
inline bool TCasinoBJGameLord::DeclarePlayer3BJ(dword &StartFUC,dword &FUCLength)
{
  return ChooseStartSkit(declareplayer3bj,StartFUC,FUCLength);
}
//*******************************************************************
inline bool TCasinoBJGameLord::PromptInsurance(dword &StartFUC,dword &FUCLength)
{
  return ChooseStartSkit(promptinsurance,StartFUC,FUCLength);
}
//*******************************************************************
inline bool TCasinoBJGameLord::EvenMoneyPlayer1(dword &StartFUC,dword &FUCLength)
{
  return ChooseStartSkit(evenmoneyplayer1,StartFUC,FUCLength);
}
//*******************************************************************
inline bool TCasinoBJGameLord::EvenMoneyPlayer2(dword &StartFUC,dword &FUCLength)
{
  return ChooseStartSkit(evenmoneyplayer2,StartFUC,FUCLength);
}
//*******************************************************************
inline bool TCasinoBJGameLord::EvenMoneyPlayer3(dword &StartFUC,dword &FUCLength)
{
  return ChooseStartSkit(evenmoneyplayer3,StartFUC,FUCLength);
}
//*******************************************************************
inline bool TCasinoBJGameLord::DealerNoBJ(dword &StartFUC,dword &FUCLength)
{
  return ChooseStartSkit(dealernobj,StartFUC,FUCLength);
}
//*******************************************************************
inline bool TCasinoBJGameLord::DoubleComPlayer1(dword &StartFUC,dword &FUCLength)
{
  return ChooseStartSkit(doublecomplayer1,StartFUC,FUCLength);
}
//*******************************************************************
inline bool TCasinoBJGameLord::DoubleComPlayer2(dword &StartFUC,dword &FUCLength)
{
  return ChooseStartSkit(doublecomplayer2,StartFUC,FUCLength);
}
//*******************************************************************
inline bool TCasinoBJGameLord::DoubleComPlayer3(dword &StartFUC,dword &FUCLength)
{
  return ChooseStartSkit(doublecomplayer3,StartFUC,FUCLength);
}
//*******************************************************************
inline bool TCasinoBJGameLord::HitComPlayer1(dword &StartFUC,dword &FUCLength)
{
  return ChooseStartSkit(hitcomplayer1,StartFUC,FUCLength);
}
//*******************************************************************
inline bool TCasinoBJGameLord::HitComPlayer2(dword &StartFUC,dword &FUCLength)
{
  return ChooseStartSkit(hitcomplayer2,StartFUC,FUCLength);
}
//*******************************************************************
inline bool TCasinoBJGameLord::HitComPlayer3(dword &StartFUC,dword &FUCLength)
{
  return ChooseStartSkit(hitcomplayer3,StartFUC,FUCLength);
}
//*******************************************************************
inline bool TCasinoBJGameLord::StandComPlayer1(dword &StartFUC,dword &FUCLength)
{
  return ChooseStartSkit(standcomplayer1,StartFUC,FUCLength);
}
//*******************************************************************
inline bool TCasinoBJGameLord::StandComPlayer2(dword &StartFUC,dword &FUCLength)
{
  return ChooseStartSkit(standcomplayer2,StartFUC,FUCLength);
}
//*******************************************************************
inline bool TCasinoBJGameLord::StandComPlayer3(dword &StartFUC,dword &FUCLength)
{
  return ChooseStartSkit(standcomplayer3,StartFUC,FUCLength);
}
//*******************************************************************
inline bool TCasinoBJGameLord::SplitComPlayer1(dword &StartFUC,dword &FUCLength)
{
  return ChooseStartSkit(splitcomplayer1,StartFUC,FUCLength);
}
//*******************************************************************
inline bool TCasinoBJGameLord::SplitComPlayer2(dword &StartFUC,dword &FUCLength)
{
  return ChooseStartSkit(splitcomplayer2,StartFUC,FUCLength);
}
//*******************************************************************
inline bool TCasinoBJGameLord::SplitComPlayer3(dword &StartFUC,dword &FUCLength)
{
  return ChooseStartSkit(splitcomplayer3,StartFUC,FUCLength);
}
//*******************************************************************
inline bool TCasinoBJGameLord::AnnounceDealerTotal(dword &StartFUC,dword &FUCLength)
{
  return ChooseStartSkit(announcedealertotal,StartFUC,FUCLength);
}
//*******************************************************************
inline bool TCasinoBJGameLord::AnnouceDealerBust(dword &StartFUC,dword &FUCLength)
{
  return ChooseStartSkit(announcedealerbust,StartFUC,FUCLength);
}
//*******************************************************************
inline bool TCasinoBJGameLord::AnnouncePlayer1Total(dword &StartFUC,dword &FUCLength)
{
  return ChooseStartSkit(announceplayer1total,StartFUC,FUCLength);
}
//*******************************************************************
inline bool TCasinoBJGameLord::AnnouncePlayer2Total(dword &StartFUC,dword &FUCLength)
{
  return ChooseStartSkit(announceplayer2total,StartFUC,FUCLength);
}
//*******************************************************************
inline bool TCasinoBJGameLord::AnnouncePlayer3Total(dword &StartFUC,dword &FUCLength)
{
  return ChooseStartSkit(announceplayer3total,StartFUC,FUCLength);
}
//*******************************************************************
inline bool TCasinoBJGameLord::Player1Bust(dword &StartFUC,dword &FUCLength)
{
  return ChooseStartSkit(player1bust,StartFUC,FUCLength);
}
//*******************************************************************
inline bool TCasinoBJGameLord::Player2Bust(dword &StartFUC,dword &FUCLength)
{
  return ChooseStartSkit(player2bust,StartFUC,FUCLength);
}
//*******************************************************************
inline bool TCasinoBJGameLord::Player3Bust(dword &StartFUC,dword &FUCLength)
{
  return ChooseStartSkit(player3bust,StartFUC,FUCLength);
}
//*******************************************************************
inline bool TCasinoBJGameLord::AcceptTipPlayer1(dword &StartFUC,dword &FUCLength)
{
  return ChooseStartSkit(accepttipplayer1,StartFUC,FUCLength);
}
//*******************************************************************
inline bool TCasinoBJGameLord::AcceptTipPlayer2(dword &StartFUC,dword &FUCLength)
{
  return ChooseStartSkit(accepttipplayer2,StartFUC,FUCLength);
}
//*******************************************************************
inline bool TCasinoBJGameLord::AcceptTipPlayer3(dword &StartFUC,dword &FUCLength)
{
  return ChooseStartSkit(accepttipplayer3,StartFUC,FUCLength);
}
//*******************************************************************
inline bool TCasinoBJGameLord::Winner1(dword &StartFUC,dword &FUCLength)
{
  return ChooseStartSkit(winner1,StartFUC,FUCLength);
}
//*******************************************************************
inline bool TCasinoBJGameLord::Winner2(dword &StartFUC,dword &FUCLength)
{
  return ChooseStartSkit(winner2,StartFUC,FUCLength);
}
//*******************************************************************
inline bool TCasinoBJGameLord::Winner3(dword &StartFUC,dword &FUCLength)
{
  return ChooseStartSkit(winner3,StartFUC,FUCLength);
}
//*******************************************************************
inline bool TCasinoBJGameLord::Push1(dword &StartFUC,dword &FUCLength)
{
  return ChooseStartSkit(push1,StartFUC,FUCLength);
}
//*******************************************************************
inline bool TCasinoBJGameLord::Push2(dword &StartFUC,dword &FUCLength)
{
  return ChooseStartSkit(push2,StartFUC,FUCLength);
}
//*******************************************************************
inline bool TCasinoBJGameLord::Push3(dword &StartFUC,dword &FUCLength)
{
  return ChooseStartSkit(push3,StartFUC,FUCLength);
}
//*******************************************************************
inline bool TCasinoBJGameLord::Loser1(dword &StartFUC,dword &FUCLength)
{
  return ChooseStartSkit(loser1,StartFUC,FUCLength);
}
//*******************************************************************
inline bool TCasinoBJGameLord::Loser2(dword &StartFUC,dword &FUCLength)
{
  return ChooseStartSkit(loser2,StartFUC,FUCLength);
}
//*******************************************************************
inline bool TCasinoBJGameLord::Loser3(dword &StartFUC,dword &FUCLength)
{
  return ChooseStartSkit(loser3,StartFUC,FUCLength);
}
//*******************************************************************
inline bool TCasinoBJGameLord::PostReconcileCom(dword &StartFUC,dword &FUCLength)
{
  return ChooseStartSkit(postreconcilecom,StartFUC,FUCLength);
}
//*******************************************************************
inline bool TCasinoBJGameLord::GetTrayDiscards(dword &StartFUC,dword &FUCLength)
{
  return ChooseStartSkit(gettraydiscards,StartFUC,FUCLength);
}
//*******************************************************************
inline bool TCasinoBJGameLord::DealCard(int16 dealto,dword &StartFUC,dword &FUCLength)
{
  dword cardfuc;
  return DealCard(dealto,StartFUC,FUCLength,cardfuc);
}
//*******************************************************************
#endif
