//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  ccboptd.h
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     12/10/96   M.Perry    original baseline
//  2.0     09/18/97   M.Perry    32-bit conversion.
//********************************************************************
#if !defined(__ccboptd_h)
#define __ccboptd_h

#include "ogle.h"
#include "ccboptd.rh"
#include "cplaydat.h"
#include <owl\dialog.h>
#include <owl\checkbox.h>
#include <owl\radiobut.h>
#include <owl\groupbox.h>
//*******************************************************************
class TCasinoCrapsBetOptionsDlg:public TDialog
{
protected:
  TCasinoPlayerData *PPlayerData;
  TRadioButton *PBuy4and10_RB;
  TRadioButton *PPlace4and10_RB;
  TRadioButton *PBuy5and9_RB;
  TRadioButton *PPlace5and9_RB;
  TRadioButton *PBuy6and8_RB;
  TRadioButton *PPlace6and8_RB;
  TCheckBox *PComeBetFreeOdds_ChB;
  TCheckBox *PDontComeBetFreeOdds_ChB;
  TCheckBox *PBuyandPlaceBets_ChB;
  TCheckBox *PHardwayBets_ChB;

  bool GetBuy4and10() {return PPlayerData->CData.Buy4and10;}
  void SetBuy4and10(bool buy) {PPlayerData->CData.Buy4and10 = buy;}
  bool GetBuy4and10Def() {return PPlayerData->CData.GetBuy4and10Def();}
  bool GetBuy5and9() {return PPlayerData->CData.Buy5and9;}
  void SetBuy5and9(bool buy) {PPlayerData->CData.Buy5and9 = buy;}
  bool GetBuy5and9Def() {return PPlayerData->CData.GetBuy5and9Def();}
  bool GetBuy6and8() {return PPlayerData->CData.Buy6and8;}
  void SetBuy6and8(bool buy) {PPlayerData->CData.Buy6and8 = buy;}
  bool GetBuy6and8Def() {return PPlayerData->CData.GetBuy6and8Def();}
  bool GetComeBetFreeOddsOn() {return PPlayerData->CData.FreeOddsOn;}
  void SetComeBetFreeOddsOn(bool on) {PPlayerData->CData.FreeOddsOn = on;}
  bool GetComeBetFreeOddsOnDef() {return PPlayerData->CData.GetFreeOddsDef();}
  bool GetDontComeBetFreeOddsOn() {return PPlayerData->CData.DoNotFreeOddsOn;}
  void SetDontComeBetFreeOddsOn(bool on) {PPlayerData->CData.DoNotFreeOddsOn = on;}
  bool GetDontComeBetFreeOddsOnDef() {return PPlayerData->CData.GetDoNotFreeOddsDef();}
  bool GetBuyandPlaceOn() {return PPlayerData->CData.BuyandPlaceOn;}
  void SetBuyandPlaceOn(bool on) {PPlayerData->CData.BuyandPlaceOn = on;}
  bool GetBuyandPlaceOnDef() {return PPlayerData->CData.GetBuyandPlaceDef();}
  bool GetHardwayOn() {return PPlayerData->CData.HardwayOn;}
  void SetHardwayOn(bool on) {PPlayerData->CData.HardwayOn = on;}
  bool GetHardwayOnDef() {return PPlayerData->CData.GetHardwayDef();}

public:

  bool IsBuy4and10Checked() {return (PBuy4and10_RB->GetCheck() == BF_CHECKED);}
  void SetBuy4and10Check(bool check)
  {
    if (check) {PBuy4and10_RB->Check();}
    else       {PBuy4and10_RB->Uncheck();}
  }
  bool IsPlace4and10Checked() {return (PPlace4and10_RB->GetCheck() == BF_CHECKED);}
  void SetPlace4and10Check(bool check)
  {
    if (check) {PPlace4and10_RB->Check();}
    else       {PPlace4and10_RB->Uncheck();}
  }
  bool IsBuy5and9Checked() {return (PBuy5and9_RB->GetCheck() == BF_CHECKED);}
  void SetBuy5and9Check(bool check)
  {
    if (check) {PBuy5and9_RB->Check();}
    else       {PBuy5and9_RB->Uncheck();}
  }

  bool IsPlace5and9Checked() {return (PPlace5and9_RB->GetCheck() == BF_CHECKED);}
  void SetPlace5and9Check(bool check)
  {
    if (check) {PPlace5and9_RB->Check();}
    else       {PPlace5and9_RB->Uncheck();}
  }
  bool IsBuy6and8Checked() {return (PBuy6and8_RB->GetCheck() == BF_CHECKED);}
  void SetBuy6and8Check(bool check)
  {
    if (check) {PBuy6and8_RB->Check();}
    else       {PBuy6and8_RB->Uncheck();}
  }
  bool IsPlace6and8Checked() {return (PPlace6and8_RB->GetCheck() == BF_CHECKED);}
  void SetPlace6and8Check(bool check)
  {
    if (check) {PPlace6and8_RB->Check();}
    else       {PPlace6and8_RB->Uncheck();}
  }
  bool IsComeBetFreeOddsChecked() {return (PComeBetFreeOdds_ChB->GetCheck() == BF_CHECKED);}
  void SetComeBetFreeOddsCheck(bool check)
  {
    if (check) {PComeBetFreeOdds_ChB->Check();}
    else       {PComeBetFreeOdds_ChB->Uncheck();}
  }
  bool IsDontComeBetFreeOddsChecked() {return (PDontComeBetFreeOdds_ChB->GetCheck() == BF_CHECKED);}
  void SetDontComeBetFreeOddsCheck(bool check)
  {
    if (check) {PDontComeBetFreeOdds_ChB->Check();}
    else       {PDontComeBetFreeOdds_ChB->Uncheck();}
  }
  bool IsBuyandPlaceBetsChecked() {return (PBuyandPlaceBets_ChB->GetCheck() == BF_CHECKED);}
  void SetBuyandPlaceBetsCheck(bool check)
  {
    if (check) {PBuyandPlaceBets_ChB->Check();}
    else       {PBuyandPlaceBets_ChB->Uncheck();}
  }
  bool IsHardwayBetsChecked() {return (PHardwayBets_ChB->GetCheck() == BF_CHECKED);}
  void SetHardwayBetsCheck(bool check)
  {
    if (check) {PHardwayBets_ChB->Check();}
    else       {PHardwayBets_ChB->Uncheck();}
  }

  TCasinoCrapsBetOptionsDlg(TWindow *pwin,TCasinoPlayerData *pdat);
  virtual ~TCasinoCrapsBetOptionsDlg();
  void CmResetOptions();
  void CmCancelOptions();
  void CmAcceptOptions();
  void CmBuy4and10();
  void CmPlace4and10();
  void CmBuy5and9();
  void CmPlace5and9();
  void CmBuy6and8();
  void CmPlace6and8();
  virtual void SetupWindow();

  DECLARE_RESPONSE_TABLE(TCasinoCrapsBetOptionsDlg);
};
//*******************************************************************
#endif