//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  cccalc.h                          
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     9/6/96     M.Perry    derived from Dave's code
//  2.0    09/17/97    M.Perry    32-bit conversion.
//********************************************************************
#if !defined(__cccalc_h)
#define __cccalc_h

#include "cstcalc.h"
//*******************************************************************
class TStatCalcCraps:public TCasinoStatCalc
{
public:
  enum{cDate = 1,cHoursPlayed = 2,cGameType = 3,cTotalNumBets = 6,cTotalCashBets = 7,
       cAvgCashBet = 8,cStartingBankroll = 9,cEndingBankroll = 10,cTotalCashWL = 11,
       cRetPerc = 12,cAvgCashWLPerHour = 13,cCumCashWL = 14,cPeakCashWinLevel = 15,
       cLowCashLossLevel = 16,cTotalShoots = 19,cNumPassWins = 20,cNumNaturals = 21,
       cNumPtsMade = 22,cNumDontPassWins = 23,cNumCrapOuts = 24,cNum7Outs = 25,cLongestShoot = 26,
       cLongestPassStreak = 27,cLongestDontPassStreak = 28,cNumShootsRB = 31,cTotalCashBetsRB = 32,
       cAvgCashBetPerShootRB = 33,cNumShootsWonCashRB = 34,cNumShootsLostCashRB = 35,cTotalCashWLRB = 36,
       cAvgCashWLRB = 37,cLongestWinStreakRB = 38,cMostCashWonRB = 39,cMostCashLostRB = 40,
       cNumShootsWB = 43,cTotalCashBetsWB = 44,cAvgCashBetWB = 45,cNumShootsWonCashWB = 46,
       cNumShootsLostCashWB = 47,cTotalCashWLWB = 48,cAvgCashWLWB = 49,cLongestWinStreakWB = 50,
       cMostCashWonWB = 51,cMostCashLostWB = 52,cTotalCashBets2 = 55,cPassBetsCash = 56,
       cPassFreeOddsBetsCash = 57,cDontPassBetsCash = 58,cDontPassFreeOddsBetsCash = 59,
       cComeBetsCash = 60,cComeFreeOddsBetsCash = 61,cDontComeBetsCash = 62,cDontComeFreeOddsBetsCash = 63,
       cFieldBetsCash = 64,cHardwaysBetsCash = 65,cBig6Big8BetsCash = 66,cBuy4BetsCash = 67,
       cPlace5BetsCash = 68,cPlace6BetsCash = 69,cPlace8BetsCash = 70,cPlace9BetsCash = 71,
       cBuy10BetsCash = 72,cPlace410BetsCash = 73,cBuy59BetsCash = 74,cBuy68BetsCash = 75,
       cLay410BetsCash = 76,cLay59BetsCash = 77,cLay68BetsCash = 78,cPropositionBetsCash = 79,
       cTotalCashWon = 82,cTotalCashLost = 83,cPassBetsCashWL = 84,cPassFreeOddsBetsCashWL = 85,
       cDontPassBetsCashWL = 86,cDontPassFreeOddsBetsCashWL = 87,cComeBetsCashWL = 88,
       cComeFreeOddsBetsCashWL = 89,cDontComeBetsCashWL = 90,cDontComeFreeOddsBetsCashWL = 91,
       cFieldBetsCashWL = 92,cHardwaysBetsCashWL = 93,cBig6Big8BetsCashWL = 94,cBuy4BetsCashWL = 95,
       cPlace5BetsCashWL = 96,cPlace6BetsCashWL = 97,cPlace8BetsCashWL = 98,cPlace9BetsCashWL = 99,
       cBuy10BetsCashWL = 100,cPlace410BetsCashWL = 101,cBuy59BetsCashWL = 102,cBuy68BetsCashWL = 103,
       cLay410BetsCashWL = 104,cLay59BetsCashWL = 105,cLay68BetsCashWL = 106,cPropositionBetsCashWL = 107,
       cPercRetPassBets = 110,cPercRetPassFreeOddsBets = 111,cPercRetDontPassBets = 112,
       cPercRetDontPassFreeOddsBets = 113,cPercRetComeBets = 114,cPercRetComeFreeOddsBets = 115,
       cPercRetDontComeBets = 116,cPercRetDontComeFreeOddsBets = 117,cPercRetFieldBets = 118,
       cPercRetHardwaysBets = 119,cPercRetBig6Big8Bets = 120,cPercRetBuy4Bets = 121,cPercRetPlace5Bets = 122,
       cPercRetPlace6Bets = 123,cPercRetPlace8Bets = 124,cPercRetPlace9Bets = 125,cPercRetBuy10Bets = 126,
       cPercRetPlace410Bets = 127,cPercRetBuy59Bets = 128,cPercRetBuy68Bets = 129,cPercRetLay410Bets = 130,
       cPercRetLay59Bets = 131,cPercRetLay68Bets = 132,cPercRetPropositionBets = 133,
       cNumHighPercBets = 136,cNumLowPercBets = 137,cPercPlayingAccuracy = 138};

  TStatCalcCraps(TCasinoStatDlg *pstatdlg);
  virtual ~TStatCalcCraps();
  virtual void LocalCalculate();
  virtual void LocalMakeAllStrings();
  virtual void LocalFillGrid();
  virtual void GetSessionPtrs();
  TCasinoCData *GetCData() {return (TCasinoCData *)PData;}
  TCCSession *GetCSession(int i) {return (TCCSession *)PSessions[i];}
  virtual bool GetValues(int statindex,float *values,int maxvalues);

private:
  virtual string MakeSubGameTypeStr(int subgametype,TMoney gamedenom);
  virtual void Calc_TotalNumBets();

  void Make_CumulativeCashWLStrs();
  void Calc_CumulativeCashWL();

  void Make_TotalShootsStrs();
  void Calc_TotalShoots();
  string TotalShootsStr[NUMSESSIONS];
  string Total_TotalShootsStr;
  long Total_TotalShoots;

  void Make_NumPassWinsStrs();
  void Calc_NumPassWins();
  string NumPassWinsStr[NUMSESSIONS];
  string Total_NumPassWinsStr;
  long Total_NumPassWins;
  bool GetNumPassWins(float *values,int num);

  void Make_NumNaturalsStrs();
  void Calc_NumNaturals();
  string NumNaturalsStr[NUMSESSIONS];
  string Total_NumNaturalsStr;
  long Total_NumNaturals;
  bool GetNumNaturals(float *values,int num);

  void Make_NumPtsMadeStrs();
  void Calc_NumPtsMade();
  string NumPtsMadeStr[NUMSESSIONS];
  string Total_NumPtsMadeStr;
  long Total_NumPtsMade;
  bool GetNumPtsMade(float *values,int num);

  void Make_NumDontPassWinsStrs();
  void Calc_NumDontPassWins();
  string NumDontPassWinsStr[NUMSESSIONS];
  string Total_NumDontPassWinsStr;
  long Total_NumDontPassWins;
  bool GetNumDontPassWins(float *values,int num);

  void Make_NumCrapOutsStrs();
  void Calc_NumCrapOuts();
  string NumCrapOutsStr[NUMSESSIONS];
  string Total_NumCrapOutsStr;
  long Total_NumCrapOuts;
  bool GetNumCrapOuts(float *values,int num);

  void Make_Num7OutsStrs();
  void Calc_Num7Outs();
  string Num7OutsStr[NUMSESSIONS];
  string Total_Num7OutsStr;
  long Total_Num7Outs;
  bool GetNum7Outs(float *values,int num);

  void Make_LongestShootStrs();
  void Calc_LongestShoot();
  string LongestShootStr[NUMSESSIONS];
  string Total_LongestShootStr;
  long Total_LongestShoot;
  bool GetLongestShoot(float *values,int num);

  void Make_LongestPassStreakStrs();
  void Calc_LongestPassStreak();
  string LongestPassStreakStr[NUMSESSIONS];
  string Total_LongestPassStreakStr;
  long Total_LongestPassStreak;
  bool GetLongestPassStreak(float *values,int num);

  void Make_LongestDontPassStreakStrs();
  void Calc_LongestDontPassStreak();
  string LongestDontPassStreakStr[NUMSESSIONS];
  string Total_LongestDontPassStreakStr;
  long Total_LongestDontPassStreak;
  bool GetLongestDontPassStreak(float *values,int num);

  void Make_NumShootsBetRightStrs();
  void Calc_NumShootsBetRight();
  string NumShootsBetRightStr[NUMSESSIONS];
  string Total_NumShootsBetRightStr;
  long Total_NumShootsBetRight;

  void Make_TotalCashBetRBStrs();
  void Calc_TotalCashBetRB();
  string TotalCashBetRBStr[NUMSESSIONS];
  string Total_TotalCashBetRBStr;
  TMoney Total_TotalCashBetRB;

  void Make_AvgCashBetPerShootRBStrs();
  void Calc_AvgCashBetPerShootRB();
  string AvgCashBetPerShootRBStr[NUMSESSIONS];
  string Total_AvgCashBetPerShootRBStr;
  float Total_AvgCashBetPerShootRB;

  void Make_NumShootsWonCashRBStrs();
  void Calc_NumShootsWonCashRB();
  string NumShootsWonCashRBStr[NUMSESSIONS];
  string Total_NumShootsWonCashRBStr;
  long Total_NumShootsWonCashRB;

  void Make_NumShootsLostCashRBStrs();
  void Calc_NumShootsLostCashRB();
  string NumShootsLostCashRBStr[NUMSESSIONS];
  string Total_NumShootsLostCashRBStr;
  long Total_NumShootsLostCashRB;

  void Make_TotalCashWLRBStrs();
  void Calc_TotalCashWLRB();
  string TotalCashWLRBStr[NUMSESSIONS];
  string Total_TotalCashWLRBStr;
  TMoney Total_TotalCashWLRB;

  void Make_AvgCashWLPerShootRBStrs();
  void Calc_AvgCashWLPerShootRB();
  string AvgCashWLPerShootRBStr[NUMSESSIONS];
  string Total_AvgCashWLPerShootRBStr;
  float AvgCashWLPerShootRB[NUMSESSIONS];
  float Total_AvgCashWLPerShootRB;

  void Make_LongestWinStreakRBStrs();
  void Calc_LongestWinStreakRB();
  string LongestWinStreakRBStr[NUMSESSIONS];
  string Total_LongestWinStreakRBStr;
  long Total_LongestWinStreakRB;

  void Make_MostCashWon1ShootRBStrs();
  void Calc_MostCashWon1ShootRB();
  string MostCashWon1ShootRBStr[NUMSESSIONS];
  string Total_MostCashWon1ShootRBStr;
  TMoney Total_MostCashWon1ShootRB;

  void Make_MostCashLost1ShootRBStrs();
  void Calc_MostCashLost1ShootRB();
  string MostCashLost1ShootRBStr[NUMSESSIONS];
  string Total_MostCashLost1ShootRBStr;
  TMoney Total_MostCashLost1ShootRB;

  void Make_NumShootsBetWrongStrs();
  void Calc_NumShootsBetWrong();
  string NumShootsBetWrongStr[NUMSESSIONS];
  string Total_NumShootsBetWrongStr;
  long Total_NumShootsBetWrong;

  void Make_TotalCashBetWBStrs();
  void Calc_TotalCashBetWB();
  string TotalCashBetWBStr[NUMSESSIONS];
  string Total_TotalCashBetWBStr;
  TMoney Total_TotalCashBetWB;

  void Make_AvgCashBetPerShootWBStrs();
  void Calc_AvgCashBetPerShootWB();
  string AvgCashBetPerShootWBStr[NUMSESSIONS];
  string Total_AvgCashBetPerShootWBStr;
  float AvgCashBetPerShootWB[NUMSESSIONS];
  float Total_AvgCashBetPerShootWB;

  void Make_NumShootsWonCashWBStrs();
  void Calc_NumShootsWonCashWB();
  string NumShootsWonCashWBStr[NUMSESSIONS];
  string Total_NumShootsWonCashWBStr;
  long Total_NumShootsWonCashWB;

  void Make_NumShootsLostCashWBStrs();
  void Calc_NumShootsLostCashWB();
  string NumShootsLostCashWBStr[NUMSESSIONS];
  string Total_NumShootsLostCashWBStr;
  long Total_NumShootsLostCashWB;

  void Make_TotalCashWLWBStrs();
  void Calc_TotalCashWLWB();
  string TotalCashWLWBStr[NUMSESSIONS];
  string Total_TotalCashWLWBStr;
  TMoney Total_TotalCashWLWB;

  void Make_AvgCashWLPerShootWBStrs();
  void Calc_AvgCashWLPerShootWB();
  string AvgCashWLPerShootWBStr[NUMSESSIONS];
  string Total_AvgCashWLPerShootWBStr;
  float AvgCashWLPerShootWB[NUMSESSIONS];
  float Total_AvgCashWLPerShootWB;

  void Make_LongestWinStreakWBStrs();
  void Calc_LongestWinStreakWB();
  string LongestWinStreakWBStr[NUMSESSIONS];
  string Total_LongestWinStreakWBStr;
  long Total_LongestWinStreakWB;

  void Make_MostCashWon1ShootWBStrs();
  void Calc_MostCashWon1ShootWB();
  string MostCashWon1ShootWBStr[NUMSESSIONS];
  string Total_MostCashWon1ShootWBStr;
  TMoney Total_MostCashWon1ShootWB;

  void Make_MostCashLost1ShootWBStrs();
  void Calc_MostCashLost1ShootWB();
  string MostCashLost1ShootWBStr[NUMSESSIONS];
  string Total_MostCashLost1ShootWBStr;
  TMoney Total_MostCashLost1ShootWB;

  void Make_PassBetsCashStrs();
  void Calc_PassBetsCash();
  string PassBetsCashStr[NUMSESSIONS];
  string Total_PassBetsCashStr;
  TMoney Total_PassBetsCash;

  void Make_PassFreeOddsBetsCashStrs();
  void Calc_PassFreeOddsBetsCash();
  string PassFreeOddsBetsCashStr[NUMSESSIONS];
  string Total_PassFreeOddsBetsCashStr;
  TMoney Total_PassFreeOddsBetsCash;

  void Make_DontPassBetsCashStrs();
  void Calc_DontPassBetsCash();
  string DontPassBetsCashStr[NUMSESSIONS];
  string Total_DontPassBetsCashStr;
  TMoney Total_DontPassBetsCash;

  void Make_DontPassFreeOddsBetsCashStrs();
  void Calc_DontPassFreeOddsBetsCash();
  string DontPassFreeOddsBetsCashStr[NUMSESSIONS];
  string Total_DontPassFreeOddsBetsCashStr;
  TMoney Total_DontPassFreeOddsBetsCash;

  void Make_ComeBetsCashStrs();
  void Calc_ComeBetsCash();
  string ComeBetsCashStr[NUMSESSIONS];
  string Total_ComeBetsCashStr;
  TMoney Total_ComeBetsCash;

  void Make_ComeFreeOddsBetsCashStrs();
  void Calc_ComeFreeOddsBetsCash();
  string ComeFreeOddsBetsCashStr[NUMSESSIONS];
  string Total_ComeFreeOddsBetsCashStr;
  TMoney Total_ComeFreeOddsBetsCash;

  void Make_DontComeBetsCashStrs();
  void Calc_DontComeBetsCash();
  string DontComeBetsCashStr[NUMSESSIONS];
  string Total_DontComeBetsCashStr;
  TMoney Total_DontComeBetsCash;

  void Make_DontComeFreeOddsBetsCashStrs();
  void Calc_DontComeFreeOddsBetsCash();
  string DontComeFreeOddsBetsCashStr[NUMSESSIONS];
  string Total_DontComeFreeOddsBetsCashStr;
  TMoney Total_DontComeFreeOddsBetsCash;

  void Make_FieldBetsCashStrs();
  void Calc_FieldBetsCash();
  string FieldBetsCashStr[NUMSESSIONS];
  string Total_FieldBetsCashStr;
  TMoney Total_FieldBetsCash;

  void Make_HardwayBetsCashStrs();
  void Calc_HardwayBetsCash();
  string HardwayBetsCashStr[NUMSESSIONS];
  string Total_HardwayBetsCashStr;
  TMoney Total_HardwayBetsCash;

  void Make_Big6Big8BetsCashStrs();
  void Calc_Big6Big8BetsCash();
  string Big6Big8BetsCashStr[NUMSESSIONS];
  string Total_Big6Big8BetsCashStr;
  TMoney Total_Big6Big8BetsCash;

  void Make_Buy4BetsCashStrs();
  void Calc_Buy4BetsCash();
  string Buy4BetsCashStr[NUMSESSIONS];
  string Total_Buy4BetsCashStr;
  TMoney Total_Buy4BetsCash;

  void Make_Place5BetsCashStrs();
  void Calc_Place5BetsCash();
  string Place5BetsCashStr[NUMSESSIONS];
  string Total_Place5BetsCashStr;
  TMoney Total_Place5BetsCash;

  void Make_Place6BetsCashStrs();
  void Calc_Place6BetsCash();
  string Place6BetsCashStr[NUMSESSIONS];
  string Total_Place6BetsCashStr;
  TMoney Total_Place6BetsCash;

  void Make_Place8BetsCashStrs();
  void Calc_Place8BetsCash();
  string Place8BetsCashStr[NUMSESSIONS];
  string Total_Place8BetsCashStr;
  TMoney Total_Place8BetsCash;

  void Make_Place9BetsCashStrs();
  void Calc_Place9BetsCash();
  string Place9BetsCashStr[NUMSESSIONS];
  string Total_Place9BetsCashStr;
  TMoney Total_Place9BetsCash;

  void Make_Buy10BetsCashStrs();
  void Calc_Buy10BetsCash();
  string Buy10BetsCashStr[NUMSESSIONS];
  string Total_Buy10BetsCashStr;
  TMoney Total_Buy10BetsCash;

  void Make_Place410BetsCashStrs();
  void Calc_Place410BetsCash();
  string Place410BetsCashStr[NUMSESSIONS];
  string Total_Place410BetsCashStr;
  TMoney Total_Place410BetsCash;

  void Make_Buy59BetsCashStrs();
  void Calc_Buy59BetsCash();
  string Buy59BetsCashStr[NUMSESSIONS];
  string Total_Buy59BetsCashStr;
  TMoney Total_Buy59BetsCash;

  void Make_Buy68BetsCashStrs();
  void Calc_Buy68BetsCash();
  string Buy68BetsCashStr[NUMSESSIONS];
  string Total_Buy68BetsCashStr;
  TMoney Total_Buy68BetsCash;

  void Make_Lay410BetsCashStrs();
  void Calc_Lay410BetsCash();
  string Lay410BetsCashStr[NUMSESSIONS];
  string Total_Lay410BetsCashStr;
  TMoney Total_Lay410BetsCash;

  void Make_Lay59BetsCashStrs();
  void Calc_Lay59BetsCash();
  string Lay59BetsCashStr[NUMSESSIONS];
  string Total_Lay59BetsCashStr;
  TMoney Total_Lay59BetsCash;

  void Make_Lay68BetsCashStrs();
  void Calc_Lay68BetsCash();
  string Lay68BetsCashStr[NUMSESSIONS];
  string Total_Lay68BetsCashStr;
  TMoney Total_Lay68BetsCash;

  void Make_PropositionBetsCashStrs();
  void Calc_PropositionBetsCash();
  string PropositionBetsCashStr[NUMSESSIONS];
  string Total_PropositionBetsCashStr;
  TMoney Total_PropositionBetsCash;

  void Make_TotalCashWonStrs();
  void Calc_TotalCashWon();
  string TotalCashWonStr[NUMSESSIONS];
  string Total_TotalCashWonStr;
  TMoney Total_TotalCashWon;

  void Make_TotalCashLostStrs();
  void Calc_TotalCashLost();
  string TotalCashLostStr[NUMSESSIONS];
  string Total_TotalCashLostStr;
  TMoney Total_TotalCashLost;

  void Make_PassBetsCashWLStrs();
  void Calc_PassBetsCashWL();
  string PassBetsCashWLStr[NUMSESSIONS];
  string Total_PassBetsCashWLStr;
  TMoney Total_PassBetsCashWL;

  void Make_PassFreeOddsBetsCashWLStrs();
  void Calc_PassFreeOddsBetsCashWL();
  string PassFreeOddsBetsCashWLStr[NUMSESSIONS];
  string Total_PassFreeOddsBetsCashWLStr;
  TMoney Total_PassFreeOddsBetsCashWL;

  void Make_DontPassBetsCashWLStrs();
  void Calc_DontPassBetsCashWL();
  string DontPassBetsCashWLStr[NUMSESSIONS];
  string Total_DontPassBetsCashWLStr;
  TMoney Total_DontPassBetsCashWL;

  void Make_DontPassFreeOddsBetsCashWLStrs();
  void Calc_DontPassFreeOddsBetsCashWL();
  string DontPassFreeOddsBetsCashWLStr[NUMSESSIONS];
  string Total_DontPassFreeOddsBetsCashWLStr;
  TMoney Total_DontPassFreeOddsBetsCashWL;

  void Make_ComeBetsCashWLStrs();
  void Calc_ComeBetsCashWL();
  string ComeBetsCashWLStr[NUMSESSIONS];
  string Total_ComeBetsCashWLStr;
  TMoney Total_ComeBetsCashWL;

  void Make_ComeFreeOddsBetsCashWLStrs();
  void Calc_ComeFreeOddsBetsCashWL();
  string ComeFreeOddsBetsCashWLStr[NUMSESSIONS];
  string Total_ComeFreeOddsBetsCashWLStr;
  TMoney Total_ComeFreeOddsBetsCashWL;

  void Make_DontComeBetsCashWLStrs();
  void Calc_DontComeBetsCashWL();
  string DontComeBetsCashWLStr[NUMSESSIONS];
  string Total_DontComeBetsCashWLStr;
  TMoney Total_DontComeBetsCashWL;

  void Make_DontComeFreeOddsBetsCashWLStrs();
  void Calc_DontComeFreeOddsBetsCashWL();
  string DontComeFreeOddsBetsCashWLStr[NUMSESSIONS];
  string Total_DontComeFreeOddsBetsCashWLStr;
  TMoney Total_DontComeFreeOddsBetsCashWL;

  void Make_FieldBetsCashWLStrs();
  void Calc_FieldBetsCashWL();
  string FieldBetsCashWLStr[NUMSESSIONS];
  string Total_FieldBetsCashWLStr;
  TMoney Total_FieldBetsCashWL;

  void Make_HardwayBetsCashWLStrs();
  void Calc_HardwayBetsCashWL();
  string HardwayBetsCashWLStr[NUMSESSIONS];
  string Total_HardwayBetsCashWLStr;
  TMoney Total_HardwayBetsCashWL;

  void Make_Big6Big8BetsCashWLStrs();
  void Calc_Big6Big8BetsCashWL();
  string Big6Big8BetsCashWLStr[NUMSESSIONS];
  string Total_Big6Big8BetsCashWLStr;
  TMoney Total_Big6Big8BetsCashWL;

  void Make_Buy4BetsCashWLStrs();
  void Calc_Buy4BetsCashWL();
  string Buy4BetsCashWLStr[NUMSESSIONS];
  string Total_Buy4BetsCashWLStr;
  TMoney Total_Buy4BetsCashWL;

  void Make_Place5BetsCashWLStrs();
  void Calc_Place5BetsCashWL();
  string Place5BetsCashWLStr[NUMSESSIONS];
  string Total_Place5BetsCashWLStr;
  TMoney Total_Place5BetsCashWL;

  void Make_Place6BetsCashWLStrs();
  void Calc_Place6BetsCashWL();
  string Place6BetsCashWLStr[NUMSESSIONS];
  string Total_Place6BetsCashWLStr;
  TMoney Total_Place6BetsCashWL;

  void Make_Place8BetsCashWLStrs();
  void Calc_Place8BetsCashWL();
  string Place8BetsCashWLStr[NUMSESSIONS];
  string Total_Place8BetsCashWLStr;
  TMoney Total_Place8BetsCashWL;

  void Make_Place9BetsCashWLStrs();
  void Calc_Place9BetsCashWL();
  string Place9BetsCashWLStr[NUMSESSIONS];
  string Total_Place9BetsCashWLStr;
  TMoney Total_Place9BetsCashWL;

  void Make_Buy10BetsCashWLStrs();
  void Calc_Buy10BetsCashWL();
  string Buy10BetsCashWLStr[NUMSESSIONS];
  string Total_Buy10BetsCashWLStr;
  TMoney Total_Buy10BetsCashWL;

  void Make_Place410BetsCashWLStrs();
  void Calc_Place410BetsCashWL();
  string Place410BetsCashWLStr[NUMSESSIONS];
  string Total_Place410BetsCashWLStr;
  TMoney Total_Place410BetsCashWL;

  void Make_Buy59BetsCashWLStrs();
  void Calc_Buy59BetsCashWL();
  string Buy59BetsCashWLStr[NUMSESSIONS];
  string Total_Buy59BetsCashWLStr;
  TMoney Total_Buy59BetsCashWL;

  void Make_Buy68BetsCashWLStrs();
  void Calc_Buy68BetsCashWL();
  string Buy68BetsCashWLStr[NUMSESSIONS];
  string Total_Buy68BetsCashWLStr;
  TMoney Total_Buy68BetsCashWL;

  void Make_Lay410BetsCashWLStrs();
  void Calc_Lay410BetsCashWL();
  string Lay410BetsCashWLStr[NUMSESSIONS];
  string Total_Lay410BetsCashWLStr;
  TMoney Total_Lay410BetsCashWL;

  void Make_Lay59BetsCashWLStrs();
  void Calc_Lay59BetsCashWL();
  string Lay59BetsCashWLStr[NUMSESSIONS];
  string Total_Lay59BetsCashWLStr;
  TMoney Total_Lay59BetsCashWL;

  void Make_Lay68BetsCashWLStrs();
  void Calc_Lay68BetsCashWL();
  string Lay68BetsCashWLStr[NUMSESSIONS];
  string Total_Lay68BetsCashWLStr;
  TMoney Total_Lay68BetsCashWL;

  void Make_PropositionBetsCashWLStrs();
  void Calc_PropositionBetsCashWL();
  string PropositionBetsCashWLStr[NUMSESSIONS];
  string Total_PropositionBetsCashWLStr;
  TMoney Total_PropositionBetsCashWL;

  void Make_PercRetPassBetsStrs();
  void Calc_PercRetPassBets();
  string PercRetPassBetsStr[NUMSESSIONS];
  string Total_PercRetPassBetsStr;
  float PercRetPassBets[NUMSESSIONS];
  float Total_PercRetPassBets;

  void Make_PercRetPassFreeOddsBetsStrs();
  void Calc_PercRetPassFreeOddsBets();
  string PercRetPassFreeOddsBetsStr[NUMSESSIONS];
  string Total_PercRetPassFreeOddsBetsStr;
  float PercRetPassFreeOddsBets[NUMSESSIONS];
  float Total_PercRetPassFreeOddsBets;

  void Make_PercRetDontPassBetsStrs();
  void Calc_PercRetDontPassBets();
  string PercRetDontPassBetsStr[NUMSESSIONS];
  string Total_PercRetDontPassBetsStr;
  float PercRetDontPassBets[NUMSESSIONS];
  float Total_PercRetDontPassBets;

  void Make_PercRetDontPassFreeOddsBetsStrs();
  void Calc_PercRetDontPassFreeOddsBets();
  string PercRetDontPassFreeOddsBetsStr[NUMSESSIONS];
  string Total_PercRetDontPassFreeOddsBetsStr;
  float PercRetDontPassFreeOddsBets[NUMSESSIONS];
  float Total_PercRetDontPassFreeOddsBets;

  void Make_PercRetComeBetsStrs();
  void Calc_PercRetComeBets();
  string PercRetComeBetsStr[NUMSESSIONS];
  string Total_PercRetComeBetsStr;
  float PercRetComeBets[NUMSESSIONS];
  float Total_PercRetComeBets;

  void Make_PercRetDontComeBetsStrs();
  void Calc_PercRetDontComeBets();
  string PercRetDontComeBetsStr[NUMSESSIONS];
  string Total_PercRetDontComeBetsStr;
  float PercRetDontComeBets[NUMSESSIONS];
  float Total_PercRetDontComeBets;

  void Make_PercRetComeFreeOddsBetsStrs();
  void Calc_PercRetComeFreeOddsBets();
  string PercRetComeFreeOddsBetsStr[NUMSESSIONS];
  string Total_PercRetComeFreeOddsBetsStr;
  float PercRetComeFreeOddsBets[NUMSESSIONS];
  float Total_PercRetComeFreeOddsBets;

  void Make_PercRetDontComeFreeOddsBetsStrs();
  void Calc_PercRetDontComeFreeOddsBets();
  string PercRetDontComeFreeOddsBetsStr[NUMSESSIONS];
  string Total_PercRetDontComeFreeOddsBetsStr;
  float PercRetDontComeFreeOddsBets[NUMSESSIONS];
  float Total_PercRetDontComeFreeOddsBets;

  void Make_PercRetFieldBetsStrs();
  void Calc_PercRetFieldBets();
  string PercRetFieldBetsStr[NUMSESSIONS];
  string Total_PercRetFieldBetsStr;
  float PercRetFieldBets[NUMSESSIONS];
  float Total_PercRetFieldBets;

  void Make_PercRetHardwaysBetsStrs();
  void Calc_PercRetHardwaysBets();
  string PercRetHardwaysBetsStr[NUMSESSIONS];
  string Total_PercRetHardwaysBetsStr;
  float PercRetHardwaysBets[NUMSESSIONS];
  float Total_PercRetHardwaysBets;

  void Make_PercRetBig6Big8BetsStrs();
  void Calc_PercRetBig6Big8Bets();
  string PercRetBig6Big8BetsStr[NUMSESSIONS];
  string Total_PercRetBig6Big8BetsStr;
  float PercRetBig6Big8Bets[NUMSESSIONS];
  float Total_PercRetBig6Big8Bets;

  void Make_PercRetBuy4BetsStrs();
  void Calc_PercRetBuy4Bets();
  string PercRetBuy4BetsStr[NUMSESSIONS];
  string Total_PercRetBuy4BetsStr;
  float PercRetBuy4Bets[NUMSESSIONS];
  float Total_PercRetBuy4Bets;

  void Make_PercRetPlace5BetsStrs();
  void Calc_PercRetPlace5Bets();
  string PercRetPlace5BetsStr[NUMSESSIONS];
  string Total_PercRetPlace5BetsStr;
  float PercRetPlace5Bets[NUMSESSIONS];
  float Total_PercRetPlace5Bets;

  void Make_PercRetPlace6BetsStrs();
  void Calc_PercRetPlace6Bets();
  string PercRetPlace6BetsStr[NUMSESSIONS];
  string Total_PercRetPlace6BetsStr;
  float PercRetPlace6Bets[NUMSESSIONS];
  float Total_PercRetPlace6Bets;

  void Make_PercRetPlace8BetsStrs();
  void Calc_PercRetPlace8Bets();
  string PercRetPlace8BetsStr[NUMSESSIONS];
  string Total_PercRetPlace8BetsStr;
  float PercRetPlace8Bets[NUMSESSIONS];
  float Total_PercRetPlace8Bets;

  void Make_PercRetPlace9BetsStrs();
  void Calc_PercRetPlace9Bets();
  string PercRetPlace9BetsStr[NUMSESSIONS];
  string Total_PercRetPlace9BetsStr;
  float PercRetPlace9Bets[NUMSESSIONS];
  float Total_PercRetPlace9Bets;

  void Make_PercRetBuy10BetsStrs();
  void Calc_PercRetBuy10Bets();
  string PercRetBuy10BetsStr[NUMSESSIONS];
  string Total_PercRetBuy10BetsStr;
  float PercRetBuy10Bets[NUMSESSIONS];
  float Total_PercRetBuy10Bets;

  void Make_PercRetPlace410BetsStrs();
  void Calc_PercRetPlace410Bets();
  string PercRetPlace410BetsStr[NUMSESSIONS];
  string Total_PercRetPlace410BetsStr;
  float PercRetPlace410Bets[NUMSESSIONS];
  float Total_PercRetPlace410Bets;

  void Make_PercRetBuy59BetsStrs();
  void Calc_PercRetBuy59Bets();
  string PercRetBuy59BetsStr[NUMSESSIONS];
  string Total_PercRetBuy59BetsStr;
  float PercRetBuy59Bets[NUMSESSIONS];
  float Total_PercRetBuy59Bets;

  void Make_PercRetBuy68BetsStrs();
  void Calc_PercRetBuy68Bets();
  string PercRetBuy68BetsStr[NUMSESSIONS];
  string Total_PercRetBuy68BetsStr;
  float PercRetBuy68Bets[NUMSESSIONS];
  float Total_PercRetBuy68Bets;

  void Make_PercRetLay410BetsStrs();
  void Calc_PercRetLay410Bets();
  string PercRetLay410BetsStr[NUMSESSIONS];
  string Total_PercRetLay410BetsStr;
  float PercRetLay410Bets[NUMSESSIONS];
  float Total_PercRetLay410Bets;

  void Make_PercRetLay59BetsStrs();
  void Calc_PercRetLay59Bets();
  string PercRetLay59BetsStr[NUMSESSIONS];
  string Total_PercRetLay59BetsStr;
  float PercRetLay59Bets[NUMSESSIONS];
  float Total_PercRetLay59Bets;

  void Make_PercRetLay68BetsStrs();
  void Calc_PercRetLay68Bets();
  string PercRetLay68BetsStr[NUMSESSIONS];
  string Total_PercRetLay68BetsStr;
  float PercRetLay68Bets[NUMSESSIONS];
  float Total_PercRetLay68Bets;

  void Make_PercRetPropositionBetsStrs();
  void Calc_PercRetPropositionBets();
  string PercRetPropositionBetsStr[NUMSESSIONS];
  string Total_PercRetPropositionBetsStr;
  float PercRetPropositionBets[NUMSESSIONS];
  float Total_PercRetPropositionBets;

  void Make_NumHighPercBetsStrs();
  void Calc_NumHighPercBets();
  string NumHighPercBetsStr[NUMSESSIONS];
  string Total_NumHighPercBetsStr;
  long Total_NumHighPercBets;

  void Make_NumLowPercBetsStrs();
  void Calc_NumLowPercBets();
  string NumLowPercBetsStr[NUMSESSIONS];
  string Total_NumLowPercBetsStr;
  long Total_NumLowPercBets;

  void Make_PercPlayingAccuracyStrs();
  void Calc_PercPlayingAccuracy();
  string PercPlayingAccuracyStr[NUMSESSIONS];
  string Total_PercPlayingAccuracyStr;
  float Total_PercPlayingAccuracy;
  float PercPlayingAccuracy[NUMSESSIONS];
};
//*******************************************************************
//*******************************************************************
class TCrapsGraph:public TCasinoGraphDlg
{
public:
  TCrapsGraph(TCasinoStatDlg* pstatdlg,TStatCalcCraps *pstatcalc);
  virtual ~TCrapsGraph();
};
//*******************************************************************
#endif