//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  ccglord.h
//    Project Name:  Casino
// Original Author:  Adam k. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     3/24/96   A.Krist      original baseline
//  2.0    09/18/97   M.Perry      32-bit conversion.
//  2.3    07/14/99    M.Perry    gobjlist removal
//********************************************************************
#if !defined(__ccglord_h)
#define __ccglord_h

#include "casglord.h"

class TCAsk;
class TCrapsModeWin;
class TCLordMainState;
class TCasinoCPlayer;

#include "ccbssp.h"
#include "crsdsp.h"   //Sounds Sprite
#include "ccdicesp.h"
#include "ccbpsp.h"
#include "ccpucksp.h"
#include "caschsp.h"
#include "ccbdsp.h"
#include "cnamesp.h"
#include "ccposp.h"
#include "cascdsp.h"    //Cash Display
#include "casmessp.h"   //Message Display
#include "cccirsp.h"   //Circle
#include "casbutsp.h"  // Button
#include "casbusp.h"    // Bet Unit
//*******************************************************************
enum TCLordRID
{
  cidButton0,cidButton1,cidButton2,cidButton3,cidButton4,cidButton5,cidButton6,
  cidButton7,cidButton8,cidButton9,cidButton10,cidButton11,cidButton12,
  cidButton13,cidOneChip,cidFiveChip,cidTwentyFiveChip,cidOneHundredChip,
  cidOneThouChip,cidTenThouChip,cidNamePlate,cidDealer,
  cidBetSpot0,cidBetSpot1,cidBetSpot2,cidBetSpot3,cidBetSpot4,cidBetSpot5,
  cidBetSpot6,cidBetSpot7,cidBetSpot8,cidBetSpot9,cidBetSpot10,cidBetSpot11,
  cidBetSpot12,cidBetSpot13,cidBetSpot14,cidBetSpot15,cidBetSpot16,cidBetSpot17,
  cidBetSpot18,cidBetSpot19,cidBetSpot20,cidBetSpot21,cidBetSpot22,cidBetSpot23,
  cidBetSpot24,cidBetSpot25,cidBetSpot26,cidBetSpot27,cidBetSpot28,cidBetSpot29,
  cidBetSpot30,cidBetSpot31,cidBetSpot32,cidBetSpot33,cidBetSpot34,cidBetSpot35,
  cidBetSpot36,cidBetSpot37,cidBetSpot38,cidBetSpot39,cidBetSpot40,cidBetSpot41,
  cidBetSpot42,cidBetSpot43,cidBetSpot44,cidBetSpot45,cidBetSpot46, cidBetSpot47,
  cidBetSpot48,cidBetSpot49,cidBetSpot50,cidBetSpot51,
  cidFeltCursor
};
//*******************************************************************
class TCasinoCGameLord:public TCasinoGameLord
{
public:
  enum {NUMOFBUTTONS = 14,NumResponders = 52,STALLDELAY = 130};
  TCrapsModeWin       *pMWin;
  TRSound                *Sounds;
  TCAsk                  *pAskExpert;
  TCDice                 *DiceA;
  TCDice                 *DiceB;
  TCDice                 *DiceC;
  TCDice                 *DiceD;
  TCPuck                 *Puck;
  TCBetPayOff            *BetPayOff;
  TCBetSpot              *BetSpot[53];
  TCPayOff               *PayOffSp;
  TCBigDice              *BigDice1;
  TCBigDice              *BigDice2;
  TCBigDice              *BigDice3;
  TCBigDice              *BigDice4;
  TCBigDice              *BigDice5;
  TCBigDice              *BigDice6;
  TCasNamePlate          *NamePlate1;
  TCasNamePlate          *NamePlate2;
  TCasNamePlate          *NamePlate3;
  TCasButton             *Button0;
  TCasButton             *Button1;
  TCasButton             *Button2;
  TCasButton             *Button3;
  TCasButton             *Button4;
  TCasButton             *Button5;
  TCasButton             *Button6;
  TCasButton             *Button7;
  TCasButton             *Button8;
  TCasButton             *Button9;
  TCasButton             *Button10;
  TCasButton             *Button11;
  TCasButton             *Button12;
  TCasButton             *Button13;
  TCasMessageDisplay     *MessageDisplay;
  TCasCashDisplay        *BankCashDisplay;
  TCasCashDisplay        *BetAmountDisplay;
  TCasChips              *Chips;
  
  TResponder *Responders[NumResponders];
  
  TMoney credits;
  TMoney coinsplayed;
  TMoney coinsize;
  TMoney winnerpaid;
  TMoney maxbet;
  TMoney currentwinnings;

  int16   ShootLength;
  int16   SparkOff;
  int16   Passes;
  int16   CurrentBetPaid;
  int16   Style;
  int16   ShakeInRow;
  int16   StallsInRow;
  int16   messagestate;
  int16   NumOfRolls;
  int16 ButtonInfo;

  // skits
  int16 greetplayers,placebets,prespincom,winner,loser,postreconcilecom,result,payoffcom,
		advbets,shakea,shakeb,shakec,throwa,throwb,throwc,dicelanda,dicelandb,dicelandc,
		stalla,stallb,stallc,placemark,getmark,result1,result2,result3,result4,result5,result6,
		result7,result8,result9,resulta,resultb,resultc,resultd,resulte,resultf,resultg,resulth,resulti,
		resultj,resultk,resultl,resultm,nocomecoma,nocomecomb,nocomecomc,givedicea,givediceb,givedicec,
		comecom,pointcom4,pointcom5,pointcom6,pointcom8,pointcom9,pointcoma,eshakea,eshakeb,
		eshakec,resultn,resulto,resultp,resultq,resultr,results;

  // sprites
  int16 mpickupdicea,fpickupdicea,mpickupdiceb,fpickupdiceb,mpickupdicec,fpickupdicec,returnodds;

  int16 Shooter;
  int16 DicePos;
  int16 Dice1,Dice2,PDice1,PDice2,PPDice1,PPDice2;
  int16 Point;
  int16 winnum;
  int16 pot;
  int16 playersin;
  int16 shutdownstate;

  bool ALLHANDSWON;
  bool COMEOUT;
  bool  OnOffFlags[7];
  bool  PlaceBetsMode;
  bool BetSpotsOn;
  bool  ExpertLite;
  bool  NShooter;
  bool  HDice;
  bool  FirstRoll;
  bool  COMEOUTWINNER;
  bool  ButtonHit[NUMOFBUTTONS];
  bool splitwait;

public:
  void EnableStateButtons(bool onoff);
  void SetOnOffFlags();
  TCasinoCGameLord(TCrapsModeWin *PNewOwnerWindow,const TFileMode &NewFileMode);
  virtual ~TCasinoCGameLord();
  virtual void SetupSkits();
  virtual TSprite *CreateSprite(string spritename,int16 id = 0,void *psource = NULL);
  virtual bool Respond(int16 Button,int16 info = 0,void *pdata = NULL);
  void EnableAllButtons();
  void DisEnableAllButtons();
  void EnableButton(int16 button);
  void DisEnableButton(int16 button);
  void ButtonClear(int16 button);


  TCrapsModeWin *GetCMW() {return (TCrapsModeWin *)PModeWin;}
  TCasinoCPlayer *GetCPlayer(int16 slotnum)
  {
	 return ((TCasinoCPlayer *)GetCasPlayer(slotnum));
  }

  virtual bool Respond(TResponder &responder);
  void SetupResponders();
  void CleanupResponders();
  virtual int16 AskCriteriaQuestion(int16 QNum);
  // idles
  bool SetBodyIdle() {return SetCurrentSpriteSet(1,0);}
  // skits
  bool GreetPlayers(dword &StartFUC,dword &FUCLength){return ChooseStartSkit(greetplayers,StartFUC,FUCLength);};
  bool PlaceBets(dword &StartFUC,dword &FUCLength){ return ChooseStartSkit(placebets,StartFUC,FUCLength); };
  bool PreSpinCom(dword &StartFUC,dword &FUCLength){ return ChooseStartSkit(prespincom,StartFUC,FUCLength); };
  bool Winner(dword &StartFUC,dword &FUCLength){ return ChooseStartSkit(winner,StartFUC,FUCLength); };
  bool Loser(dword &StartFUC,dword &FUCLength){ return ChooseStartSkit(loser,StartFUC,FUCLength); };
  bool PostReconcileCom(dword &StartFUC,dword &FUCLength){ return ChooseStartSkit(postreconcilecom,StartFUC,FUCLength); };
  bool Result(dword &StartFUC,dword &FUCLength);
  bool PayOffCom(dword &StartFUC,dword &FUCLength){ return ChooseStartSkit(payoffcom,StartFUC,FUCLength); };
  bool AdvBets(dword &StartFUC,dword &FUCLength){ return ChooseStartSkit(advbets,StartFUC,FUCLength); };
  bool ShakeA(dword &StartFUC,dword &FUCLength){ return ChooseStartSkit(shakea,StartFUC,FUCLength); };
  bool ShakeB(dword &StartFUC,dword &FUCLength){ return ChooseStartSkit(shakeb,StartFUC,FUCLength); };
  bool ShakeC(dword &StartFUC,dword &FUCLength){ return ChooseStartSkit(shakec,StartFUC,FUCLength); };
  bool EShakeA(dword &StartFUC,dword &FUCLength){ return ChooseStartSkit(eshakea,StartFUC,FUCLength); };
  bool EShakeB(dword &StartFUC,dword &FUCLength){ return ChooseStartSkit(eshakeb,StartFUC,FUCLength); };
  bool EShakeC(dword &StartFUC,dword &FUCLength){ return ChooseStartSkit(eshakec,StartFUC,FUCLength); };
  bool ThrowA(dword &StartFUC,dword &FUCLength){ return ChooseStartSkit(throwa,StartFUC,FUCLength); };
  bool ThrowB(dword &StartFUC,dword &FUCLength){ return ChooseStartSkit(throwb,StartFUC,FUCLength); };
  bool ThrowC(dword &StartFUC,dword &FUCLength){ return ChooseStartSkit(throwc,StartFUC,FUCLength); };
  bool DiceLandA(dword &StartFUC,dword &FUCLength){ return ChooseStartSkit(dicelanda,StartFUC,FUCLength); };
  bool DiceLandB(dword &StartFUC,dword &FUCLength){ return ChooseStartSkit(dicelandb,StartFUC,FUCLength); };
  bool DiceLandC(dword &StartFUC,dword &FUCLength){ return ChooseStartSkit(dicelandc,StartFUC,FUCLength); };
  bool StallA(dword &StartFUC,dword &FUCLength){ return ChooseStartSkit(stalla,StartFUC,FUCLength); };
  bool StallB(dword &StartFUC,dword &FUCLength){ return ChooseStartSkit(stallb,StartFUC,FUCLength); };
  bool StallC(dword &StartFUC,dword &FUCLength){ return ChooseStartSkit(stallc,StartFUC,FUCLength); };
  bool GiveDiceA(dword &StartFUC,dword &FUCLength){ return ChooseStartSkit(givedicea,StartFUC,FUCLength); };
  bool GiveDiceB(dword &StartFUC,dword &FUCLength){ return ChooseStartSkit(givediceb,StartFUC,FUCLength); };
  bool GiveDiceC(dword &StartFUC,dword &FUCLength){ return ChooseStartSkit(givedicec,StartFUC,FUCLength); };
  bool NoComeComA(dword &StartFUC,dword &FUCLength){ return ChooseStartSkit(nocomecoma,StartFUC,FUCLength); };
  bool NoComeComB(dword &StartFUC,dword &FUCLength){ return ChooseStartSkit(nocomecomb,StartFUC,FUCLength); };
  bool NoComeComC(dword &StartFUC,dword &FUCLength){ return ChooseStartSkit(nocomecomc,StartFUC,FUCLength); };
  bool ComeCom(dword &StartFUC,dword &FUCLength){ return ChooseStartSkit(comecom,StartFUC,FUCLength); };
  bool PointCom4(dword &StartFUC,dword &FUCLength){ return ChooseStartSkit(pointcom4,StartFUC,FUCLength); };
  bool PointCom5(dword &StartFUC,dword &FUCLength){ return ChooseStartSkit(pointcom5,StartFUC,FUCLength); };
  bool PointCom6(dword &StartFUC,dword &FUCLength){ return ChooseStartSkit(pointcom6,StartFUC,FUCLength); };
  bool PointCom8(dword &StartFUC,dword &FUCLength){ return ChooseStartSkit(pointcom8,StartFUC,FUCLength); };
  bool PointCom9(dword &StartFUC,dword &FUCLength){ return ChooseStartSkit(pointcom9,StartFUC,FUCLength); };
  bool PointComA(dword &StartFUC,dword &FUCLength){ return ChooseStartSkit(pointcoma,StartFUC,FUCLength); };
  bool PlaceMark(dword &StartFUC,dword &FUCLength,dword &MarkFUC);
  bool GetMark(dword &StartFUC,dword &FUCLength){ return ChooseStartSkit(getmark,StartFUC,FUCLength); };
  bool GiveDice(dword &StartFUC,dword &FUCLength);
  bool Shake(dword &StartFUC,dword &FUCLength);
  bool EShake(dword &StartFUC,dword &FUCLength);
  bool Throw(dword &StartFUC,dword &FUCLength);
  bool DiceLand(dword &StartFUC,dword &FUCLength);
  bool Stall(dword &StartFUC,dword &FUCLength);
  bool NoComeCom(dword &StartFUC,dword &FUCLength);
  bool PointCom(dword &StartFUC,dword &FUCLength);
  void BigDice();
  void ClearBigDice();

  // sprites
  bool PickUpDice(dword &StartFUC,dword &FUCLength);
  bool ReturnOdds(dword &StartFUC,dword &FUCLength);

  //virtual TSpriteList *CreateSpriteList(TFileMode splfm);
  virtual void SetupSprites();
  virtual void CleanupSprites();

  void AskBetExpert(int16 Spot);
  void AskOddsExpert();
  void AskExpert();
  int16 BetNoGood(int16 Spot);
  int16 NoFreeOdds();

  void NoShowTableDice();
  void ShowTableDice();
  bool ComeOutBetMade();
  void PreRollStats();
  void PostRollStats();
  int16 ShowWinner();
  bool BetMade();
  bool BetMade(int16 Player);
  void Roll();
  int16 BetLast();
  int16 GetBet();
  int16 ClearBet();
  int16 Bet1(TMoney Money);
  int16 UnBet1(TMoney Money);
  int16 BetMax();
  int16 GoodToGo();
  int16 InitCraps();
  bool Winner(int16 winner);
  bool MarkComeOut();
  bool ClearMark();
  int16 Loser(int16  loser);
  int16 Clear();
  int16 PlaceBet(int16 x);
  int16 RemoveBet(int16 x);
  void ShowMarker();
  void ShowMessageOdds(int16 Spot);

  int16 FirstGamePlayer(); //activeplayer
  int16 OneHumanPlayer();
  int16 TwoHumanPlayers();
  int16 ThreeHumanPlayers();
  int16 AllPlayersMale();
  int16 AllPlayersFemale();
  int16 RandomLT(int16 num);
  int16 BetweenDec22_Jan2();
  int16 IsMale();
  int16 IsFemale();
  int16 FirstCrapOfDayAllPlayers();
  int16 TotalRolls(int16 Total);
  int16 IsComeOut();
  int16 NewShooter();
  int16 SameShooter();
  int16 PreviousRoll(int16 Roll);
  int16 HardPreviousRoll();
  int16 TwoPreviousRolls7();
  int16 CurrentRoll(int16 Roll);
  int16 HardCurrentRoll();
  int16 LeastFourBets();
  int16 ShooterPassBet();
  int16 LeastOneBetPass();
  int16 LeastOneBetGT5000();
  int16 Shooter200Pass();
  int16 ShooterNotPass();
  int16 LeastOneNotPass();
  int16 LeastOneCome();
  int16 LeastOneNotCome();
  int16 LeastPointBet(int16 Num);
  int16 LeastOneHardBet();
  int16 LeastTwoHardBet();
  int16 ShooterHardBet(int16 Num);
  int16 AllHardBet(int16 Num);
  int16 LeastOne1000Hard(int16 NumBetHard);
  int16 LeastOneField();
  int16 LeastOneGT5000Field();
  int16 LeastOneProp3();
  int16 LeastOneCE();
  int16 LeastOneCraps();
  int16 DicePos1();
  int16 DicePos2();
  int16 DicePos3();
  int16 HasDice();
  int16 StallInRow(int16 Stalls);
  int16 LeastStallInRow(int16 Stalls);
  int16 ShakeStyle(int16 Style);
  int16 ShakeInARowLess(int16 Shakes);
  int16 IsPoint(int16 Point);
  int16 OneWin();
  int16 LeastOneWin();
  int16 LeastTwoWin();
  int16 WinPaidGT100Thou();
  int16 FieldWinLeast10000();
  int16 HardWinLeast50000();
  int16 OneLoser();
  int16 LeastOneLoser();
  int16 LeastTwoLoser();
  int16 LeastSevenLoser();
  int16 Shoot10Long();
  int16 Least4Passes();
  int16 LT6Passes();
  int16 PassesInRow(int16 Passes);
  int16 GT20Passes();
  int16 NumOfCoins(TMoney Money);

  int16 GetPlayin() {return playersin;};
  bool IsWinner();
  bool CoachIsOn();
  bool ReturnFreeOdds();
  void ClearLosers();
  void  SwitchToPlayer(int16 player);
  void  CyclePlayers();
  void MoveComeBets();
  void EnableOddsMessage();
  void DisEnableOddsMessage();
  virtual void SetupActivePlayer(int16 slot);
  virtual void NotifyPlayerActivation(int16 slotnum);
  virtual void NotifyPlayerDeActivation(int16 slotnum);
  virtual void ShuttingDown();
  #if defined(SUPPORT_OLD_VER)
  virtual void SetupUniqueIDStrings();
  virtual int16 GetUniqueID(const string &s);
  string strSounds,strNP1,strNP2,strNP3,strMsgDisplay,strBankCashDisplay,strBetAmount,
         strButton0,strButton1,strButton2,strButton3,strButton4,strButton5,
         strButton6,strButton7,strButton8,strButton9,strButton10,strButton11,
         strButton12,strButton13,strBetPayoff,strPuck,strDiceA,strDiceB,
         strDiceC,strBigDice1,strBigDice2,strBigDice3,strBigDice4,strBigDice5,
         strBigDice6,strChips,strBS0,strBS1,strBS2,strBS3,strBS4,strBS5,strBS6,
         strBS7,strBS8,strBS9,strBS10,strBS11,strBS12,strBS13,strBS14,strBS15,
         strBS16,strBS17,strBS18,strBS19,strBS20,strBS21,strBS22,strBS23,strBS24,
         strBS25,strBS26,strBS27,strBS28,strBS29,strBS30,strBS31,strBS32,strBS33,
         strBS34,strBS35,strBS36,strBS37,strBS38,strBS39,strBS40,strBS41,strBS42;
  #endif
};
//*******************************************************************
#endif