//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  ckcalc.h
//    Project Name:  Casino              
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     9/6/96     M.Perry    derived from Dave's code.
//  2.0    09/17/97    M.Perry    32-bit conversion.
//********************************************************************
#if !defined(__ckcalc_h)
#define __ckcalc_h

#include "cstcalc.h"
//*******************************************************************
class TStatCalcKeno:public TCasinoStatCalc
{
public:
  enum{kData = 1,kHoursPlayed = 2,kGameType = 3,kTotalNumBets = 6,kTotalCashBets = 7,
       kAvgCashBet = 8,kStartingBankroll = 9,kEndingBankroll = 10,kTotalCashWL = 11,
       kRetPerc = 12,kAvgWLPerHour = 13,kCumCashWL = 14,kTotalNumBets2 = 17,kBetsWon = 18,
       kBetsLost = 19,kPercBetsWon = 20,kPercBetsLost = 21,kLongestWinStreak = 22,
       kLongestLosingStreak = 23,kLargestCashWin = 24,kLargestCashLoss = 25,kPeakCashWinLevel = 26,
       kLowCashLossLevel = 27,kNum1SpotBets = 30,kNum2SpotBets = 31,kNum3SpotBets = 32,kNum4SpotBets = 33,
       kNum5SpotBets = 34,kNum6SpotBets = 35,kNum7SpotBets = 36,kNum8SpotBets = 37,kNum9SpotBets = 38,
       kNum10SpotBets = 39,kNum3SpotSpecBets = 40,kNum4SpotSpecBets = 41,kNum6SpotSpecBets = 42,
       kTotalCashWL1SpotBets = 47,kTotalCashWL2SpotBets = 48,kTotalCashWL3SpotBets = 49,
       kTotalCashWL4SpotBets = 50,kTotalCashWL5SpotBets = 51,kTotalCashWL6SpotBets = 52,
       kTotalCashWL7SpotBets = 53,kTotalCashWL8SpotBets = 54,kTotalCashWL9SpotBets = 55,
       kTotalCashWL10SpotBets = 56,kTotalCashWL3SpotSpecBets = 57,kTotalCashWL4SpotSpecBets = 58,
       kTotalCashWL6SpotSpecBets = 59,kPercRet1SpotBets = 64,kPercRet2SpotBets = 65,
       kPercRet3SpotBets = 66,kPercRet4SpotBets = 67,kPercRet5SpotBets = 68,kPercRet6SpotBets = 69,
       kPercRet7SpotBets = 70,kPercRet8SpotBets = 71,kPercRet9SpotBets = 72,kPercRet10SpotBets = 73,
       kPercRet3SpotSpecBets = 74,kPercRet4SpotSpecBets = 75,kPercRet6SpotSpecBets = 76,
       kTotalGames = 81,kMostFreqNum1 = 82,kMostFreqNum1Occ = 83,kMostFreqNum2 = 84,kMostFreqNum2Occ = 85,
       kMostFreqNum3 = 86,kMostFreqNum3Occ = 87,kMostFreqNum4 = 88,kMostFreqNum4Occ = 89,
       kMostFreqNum5 = 90,kMostFreqNum5Occ = 91,kLeastFreqNum1 = 92,kLeastFreqNum1Occ = 93,
       kLeastFreqNum2 = 94,kLeastFreqNum2Occ = 95,kLeastFreqNum3 = 96,kLeastFreqNum3Occ = 97,
       kLeastFreqNum4 = 98,kLeastFreqNum4Occ = 99,kLeastFreqNum5 = 100,kLeastFreqNum5Occ = 101};

  TStatCalcKeno(TCasinoStatDlg *pstatdlg);
  virtual ~TStatCalcKeno();
  virtual void LocalFillGrid();
  virtual void LocalCalculate();
  virtual void LocalMakeAllStrings();
  virtual void GetSessionPtrs();
  TCasinoKData *GetKData() {return (TCasinoKData *)PData;}
  TCKSession *GetKSession(int i) {return (TCKSession *)PSessions[i];}
  virtual bool GetValues(int statindex,float *values,int maxvalueindex);
private:
  virtual string MakeSubGameTypeStr(int subgametype,TMoney gamedenom);

  void Make_CumulativeCashWLStrs();
  void Calc_CumulativeCashWL();

  void Make_Num1SpotBetsStrs();
  void Calc_Num1SpotBets();
  string Num1SpotBetsStr[NUMSESSIONS];
  string Total_Num1SpotBetsStr;
  long Total_Num1SpotBets;

  void Make_Num2SpotBetsStrs();
  void Calc_Num2SpotBets();
  string Num2SpotBetsStr[NUMSESSIONS];
  string Total_Num2SpotBetsStr;
  long Total_Num2SpotBets;

  void Make_Num3SpotBetsStrs();
  void Calc_Num3SpotBets();
  string Num3SpotBetsStr[NUMSESSIONS];
  string Total_Num3SpotBetsStr;
  long Total_Num3SpotBets;

  void Make_Num4SpotBetsStrs();
  void Calc_Num4SpotBets();
  string Num4SpotBetsStr[NUMSESSIONS];
  string Total_Num4SpotBetsStr;
  long Total_Num4SpotBets;

  void Make_Num5SpotBetsStrs();
  void Calc_Num5SpotBets();
  string Num5SpotBetsStr[NUMSESSIONS];
  string Total_Num5SpotBetsStr;
  long Total_Num5SpotBets;

  void Make_Num6SpotBetsStrs();
  void Calc_Num6SpotBets();
  string Num6SpotBetsStr[NUMSESSIONS];
  string Total_Num6SpotBetsStr;
  long Total_Num6SpotBets;

  void Make_Num7SpotBetsStrs();
  void Calc_Num7SpotBets();
  string Num7SpotBetsStr[NUMSESSIONS];
  string Total_Num7SpotBetsStr;
  long Total_Num7SpotBets;

  void Make_Num8SpotBetsStrs();
  void Calc_Num8SpotBets();
  string Num8SpotBetsStr[NUMSESSIONS];
  string Total_Num8SpotBetsStr;
  long Total_Num8SpotBets;

  void Make_Num9SpotBetsStrs();
  void Calc_Num9SpotBets();
  string Num9SpotBetsStr[NUMSESSIONS];
  string Total_Num9SpotBetsStr;
  long Total_Num9SpotBets;

  void Make_Num10SpotBetsStrs();
  void Calc_Num10SpotBets();
  string Num10SpotBetsStr[NUMSESSIONS];
  string Total_Num10SpotBetsStr;
  long Total_Num10SpotBets;

  void Make_Num3SpotSpecBetsStrs();
  void Calc_Num3SpotSpecBets();
  string Num3SpotSpecBetsStr[NUMSESSIONS];
  string Total_Num3SpotSpecBetsStr;
  long Total_Num3SpotSpecBets;

  void Make_Num4SpotSpecBetsStrs();
  void Calc_Num4SpotSpecBets();
  string Num4SpotSpecBetsStr[NUMSESSIONS];
  string Total_Num4SpotSpecBetsStr;
  long Total_Num4SpotSpecBets;

  void Make_Num6SpotSpecBetsStrs();
  void Calc_Num6SpotSpecBets();
  string Num6SpotSpecBetsStr[NUMSESSIONS];
  string Total_Num6SpotSpecBetsStr;
  long Total_Num6SpotSpecBets;

  void Make_TotalCashWL1SpotBetsStrs();
  void Calc_TotalCashWL1SpotBets();
  string TotalCashWL1SpotBetsStr[NUMSESSIONS];
  string Total_TotalCashWL1SpotBetsStr;
  TMoney Total_TotalCashWL1SpotBets;

  void Make_TotalCashWL2SpotBetsStrs();
  void Calc_TotalCashWL2SpotBets();
  string TotalCashWL2SpotBetsStr[NUMSESSIONS];
  string Total_TotalCashWL2SpotBetsStr;
  TMoney Total_TotalCashWL2SpotBets;

  void Make_TotalCashWL3SpotBetsStrs();
  void Calc_TotalCashWL3SpotBets();
  string TotalCashWL3SpotBetsStr[NUMSESSIONS];
  string Total_TotalCashWL3SpotBetsStr;
  TMoney Total_TotalCashWL3SpotBets;

  void Make_TotalCashWL4SpotBetsStrs();
  void Calc_TotalCashWL4SpotBets();
  string TotalCashWL4SpotBetsStr[NUMSESSIONS];
  string Total_TotalCashWL4SpotBetsStr;
  TMoney Total_TotalCashWL4SpotBets;

  void Make_TotalCashWL5SpotBetsStrs();
  void Calc_TotalCashWL5SpotBets();
  string TotalCashWL5SpotBetsStr[NUMSESSIONS];
  string Total_TotalCashWL5SpotBetsStr;
  TMoney Total_TotalCashWL5SpotBets;

  void Make_TotalCashWL6SpotBetsStrs();
  void Calc_TotalCashWL6SpotBets();
  string TotalCashWL6SpotBetsStr[NUMSESSIONS];
  string Total_TotalCashWL6SpotBetsStr;
  TMoney Total_TotalCashWL6SpotBets;

  void Make_TotalCashWL7SpotBetsStrs();
  void Calc_TotalCashWL7SpotBets();
  string TotalCashWL7SpotBetsStr[NUMSESSIONS];
  string Total_TotalCashWL7SpotBetsStr;
  TMoney Total_TotalCashWL7SpotBets;

  void Make_TotalCashWL8SpotBetsStrs();
  void Calc_TotalCashWL8SpotBets();
  string TotalCashWL8SpotBetsStr[NUMSESSIONS];
  string Total_TotalCashWL8SpotBetsStr;
  TMoney Total_TotalCashWL8SpotBets;

  void Make_TotalCashWL9SpotBetsStrs();
  void Calc_TotalCashWL9SpotBets();
  string TotalCashWL9SpotBetsStr[NUMSESSIONS];
  string Total_TotalCashWL9SpotBetsStr;
  TMoney Total_TotalCashWL9SpotBets;

  void Make_TotalCashWL10SpotBetsStrs();
  void Calc_TotalCashWL10SpotBets();
  string TotalCashWL10SpotBetsStr[NUMSESSIONS];
  string Total_TotalCashWL10SpotBetsStr;
  TMoney Total_TotalCashWL10SpotBets;

  void Make_TotalCashWL3SpotSpecBetsStrs();
  void Calc_TotalCashWL3SpotSpecBets();
  string TotalCashWL3SpotSpecBetsStr[NUMSESSIONS];
  string Total_TotalCashWL3SpotSpecBetsStr;
  TMoney Total_TotalCashWL3SpotSpecBets;

  void Make_TotalCashWL4SpotSpecBetsStrs();
  void Calc_TotalCashWL4SpotSpecBets();
  string TotalCashWL4SpotSpecBetsStr[NUMSESSIONS];
  string Total_TotalCashWL4SpotSpecBetsStr;
  TMoney Total_TotalCashWL4SpotSpecBets;

  void Make_TotalCashWL6SpotSpecBetsStrs();
  void Calc_TotalCashWL6SpotSpecBets();
  string TotalCashWL6SpotSpecBetsStr[NUMSESSIONS];
  string Total_TotalCashWL6SpotSpecBetsStr;
  TMoney Total_TotalCashWL6SpotSpecBets;

  void Calc_TotalCash1SpotBets();
  TMoney Total_TotalCash1SpotBets;

  void Calc_TotalCash2SpotBets();
  TMoney Total_TotalCash2SpotBets;

  void Calc_TotalCash3SpotBets();
  TMoney Total_TotalCash3SpotBets;

  void Calc_TotalCash4SpotBets();
  TMoney Total_TotalCash4SpotBets;

  void Calc_TotalCash5SpotBets();
  TMoney Total_TotalCash5SpotBets;

  void Calc_TotalCash6SpotBets();
  TMoney Total_TotalCash6SpotBets;

  void Calc_TotalCash7SpotBets();
  TMoney Total_TotalCash7SpotBets;

  void Calc_TotalCash8SpotBets();
  TMoney Total_TotalCash8SpotBets;

  void Calc_TotalCash9SpotBets();
  TMoney Total_TotalCash9SpotBets;

  void Calc_TotalCash10SpotBets();
  TMoney Total_TotalCash10SpotBets;

  void Calc_TotalCash3SpotSpecBets();
  TMoney Total_TotalCash3SpotSpecBets;

  void Calc_TotalCash4SpotSpecBets();
  TMoney Total_TotalCash4SpotSpecBets;

  void Calc_TotalCash6SpotSpecBets();
  TMoney Total_TotalCash6SpotSpecBets;

  void Make_PercRet1SpotBetsStrs();
  void Calc_PercRet1SpotBets();
  string PercRet1SpotBetsStr[NUMSESSIONS];
  string Total_PercRet1SpotBetsStr;
  float PercRet1SpotBets[NUMSESSIONS];
  float Total_PercRet1SpotBets;

  void Make_PercRet2SpotBetsStrs();
  void Calc_PercRet2SpotBets();
  string PercRet2SpotBetsStr[NUMSESSIONS];
  string Total_PercRet2SpotBetsStr;
  float PercRet2SpotBets[NUMSESSIONS];
  float Total_PercRet2SpotBets;

  void Make_PercRet3SpotBetsStrs();
  void Calc_PercRet3SpotBets();
  string PercRet3SpotBetsStr[NUMSESSIONS];
  string Total_PercRet3SpotBetsStr;
  float PercRet3SpotBets[NUMSESSIONS];
  float Total_PercRet3SpotBets;

  void Make_PercRet4SpotBetsStrs();
  void Calc_PercRet4SpotBets();
  string PercRet4SpotBetsStr[NUMSESSIONS];
  string Total_PercRet4SpotBetsStr;
  float PercRet4SpotBets[NUMSESSIONS];
  float Total_PercRet4SpotBets;

  void Make_PercRet5SpotBetsStrs();
  void Calc_PercRet5SpotBets();
  string PercRet5SpotBetsStr[NUMSESSIONS];
  string Total_PercRet5SpotBetsStr;
  float PercRet5SpotBets[NUMSESSIONS];
  float Total_PercRet5SpotBets;

  void Make_PercRet6SpotBetsStrs();
  void Calc_PercRet6SpotBets();
  string PercRet6SpotBetsStr[NUMSESSIONS];
  string Total_PercRet6SpotBetsStr;
  float PercRet6SpotBets[NUMSESSIONS];
  float Total_PercRet6SpotBets;

  void Make_PercRet7SpotBetsStrs();
  void Calc_PercRet7SpotBets();
  string PercRet7SpotBetsStr[NUMSESSIONS];
  string Total_PercRet7SpotBetsStr;
  float PercRet7SpotBets[NUMSESSIONS];
  float Total_PercRet7SpotBets;

  void Make_PercRet8SpotBetsStrs();
  void Calc_PercRet8SpotBets();
  string PercRet8SpotBetsStr[NUMSESSIONS];
  string Total_PercRet8SpotBetsStr;
  float PercRet8SpotBets[NUMSESSIONS];
  float Total_PercRet8SpotBets;

  void Make_PercRet9SpotBetsStrs();
  void Calc_PercRet9SpotBets();
  string PercRet9SpotBetsStr[NUMSESSIONS];
  string Total_PercRet9SpotBetsStr;
  float PercRet9SpotBets[NUMSESSIONS];
  float Total_PercRet9SpotBets;

  void Make_PercRet10SpotBetsStrs();
  void Calc_PercRet10SpotBets();
  string PercRet10SpotBetsStr[NUMSESSIONS];
  string Total_PercRet10SpotBetsStr;
  float PercRet10SpotBets[NUMSESSIONS];
  float Total_PercRet10SpotBets;

  void Make_PercRet3SpotSpecBetsStrs();
  void Calc_PercRet3SpotSpecBets();
  string PercRet3SpotSpecBetsStr[NUMSESSIONS];
  string Total_PercRet3SpotSpecBetsStr;
  float PercRet3SpotSpecBets[NUMSESSIONS];
  float Total_PercRet3SpotSpecBets;

  void Make_PercRet4SpotSpecBetsStrs();
  void Calc_PercRet4SpotSpecBets();
  string PercRet4SpotSpecBetsStr[NUMSESSIONS];
  string Total_PercRet4SpotSpecBetsStr;
  float PercRet4SpotSpecBets[NUMSESSIONS];
  float Total_PercRet4SpotSpecBets;

  void Make_PercRet6SpotSpecBetsStrs();
  void Calc_PercRet6SpotSpecBets();
  string PercRet6SpotSpecBetsStr[NUMSESSIONS];
  string Total_PercRet6SpotSpecBetsStr;
  float PercRet6SpotSpecBets[NUMSESSIONS];
  float Total_PercRet6SpotSpecBets;

  void Make_TotalGamesStrs();
  void Calc_TotalGames();
  string TotalGamesStr[NUMSESSIONS];
  string Total_TotalGamesStr;
  long Total_TotalGames;

  void Calc_TotalMostFreqNums();
  long TotalMostFreqNums[MAX_KENO_SPOTS];

  void Make_MostFreqNum1Strs();
  void Calc_MostFreqNum1();
  string MostFreqNum1Str[NUMSESSIONS];
  string Total_MostFreqNum1Str;
  int MostFreqNum1Index[NUMSESSIONS];
  int Total_MostFreqNum1Index;

  void Make_MostFreqNum2Strs();
  void Calc_MostFreqNum2();
  string MostFreqNum2Str[NUMSESSIONS];
  string Total_MostFreqNum2Str;
  int MostFreqNum2Index[NUMSESSIONS];
  int Total_MostFreqNum2Index;

  void Make_MostFreqNum3Strs();
  void Calc_MostFreqNum3();
  string MostFreqNum3Str[NUMSESSIONS];
  string Total_MostFreqNum3Str;
  int MostFreqNum3Index[NUMSESSIONS];
  int Total_MostFreqNum3Index;

  void Make_MostFreqNum4Strs();
  void Calc_MostFreqNum4();
  string MostFreqNum4Str[NUMSESSIONS];
  string Total_MostFreqNum4Str;
  int MostFreqNum4Index[NUMSESSIONS];
  int Total_MostFreqNum4Index;

  void Make_MostFreqNum5Strs();
  void Calc_MostFreqNum5();
  string MostFreqNum5Str[NUMSESSIONS];
  string Total_MostFreqNum5Str;
  int MostFreqNum5Index[NUMSESSIONS];
  int Total_MostFreqNum5Index;

  void Make_LeastFreqNum1Strs();
  void Calc_LeastFreqNum1();
  string LeastFreqNum1Str[NUMSESSIONS];
  string Total_LeastFreqNum1Str;
  int LeastFreqNum1Index[NUMSESSIONS];
  int Total_LeastFreqNum1Index;

  void Make_LeastFreqNum2Strs();
  void Calc_LeastFreqNum2();
  string LeastFreqNum2Str[NUMSESSIONS];
  string Total_LeastFreqNum2Str;
  int LeastFreqNum2Index[NUMSESSIONS];
  int Total_LeastFreqNum2Index;

  void Make_LeastFreqNum3Strs();
  void Calc_LeastFreqNum3();
  string LeastFreqNum3Str[NUMSESSIONS];
  string Total_LeastFreqNum3Str;
  int LeastFreqNum3Index[NUMSESSIONS];
  int Total_LeastFreqNum3Index;

  void Make_LeastFreqNum4Strs();
  void Calc_LeastFreqNum4();
  string LeastFreqNum4Str[NUMSESSIONS];
  string Total_LeastFreqNum4Str;
  int LeastFreqNum4Index[NUMSESSIONS];
  int Total_LeastFreqNum4Index;

  void Make_LeastFreqNum5Strs();
  void Calc_LeastFreqNum5();
  string LeastFreqNum5Str[NUMSESSIONS];
  string Total_LeastFreqNum5Str;
  int LeastFreqNum5Index[NUMSESSIONS];
  int Total_LeastFreqNum5Index;

  void Make_MostFreqNumOcc1Strs();
  void Calc_MostFreqNumOcc1();
  string MostFreqNumOcc1Str[NUMSESSIONS];
  string Total_MostFreqNumOcc1Str;
  long Total_MostFreqNumOcc1;

  void Make_MostFreqNumOcc2Strs();
  void Calc_MostFreqNumOcc2();
  string MostFreqNumOcc2Str[NUMSESSIONS];
  string Total_MostFreqNumOcc2Str;
  long Total_MostFreqNumOcc2;

  void Make_MostFreqNumOcc3Strs();
  void Calc_MostFreqNumOcc3();
  string MostFreqNumOcc3Str[NUMSESSIONS];
  string Total_MostFreqNumOcc3Str;
  long Total_MostFreqNumOcc3;

  void Make_MostFreqNumOcc4Strs();
  void Calc_MostFreqNumOcc4();
  string MostFreqNumOcc4Str[NUMSESSIONS];
  string Total_MostFreqNumOcc4Str;
  long Total_MostFreqNumOcc4;

  void Make_MostFreqNumOcc5Strs();
  void Calc_MostFreqNumOcc5();
  string MostFreqNumOcc5Str[NUMSESSIONS];
  string Total_MostFreqNumOcc5Str;
  long Total_MostFreqNumOcc5;

  void Make_LeastFreqNumOcc1Strs();
  void Calc_LeastFreqNumOcc1();
  string LeastFreqNumOcc1Str[NUMSESSIONS];
  string Total_LeastFreqNumOcc1Str;
  long Total_LeastFreqNumOcc1;

  void Make_LeastFreqNumOcc2Strs();
  void Calc_LeastFreqNumOcc2();
  string LeastFreqNumOcc2Str[NUMSESSIONS];
  string Total_LeastFreqNumOcc2Str;
  long Total_LeastFreqNumOcc2;

  void Make_LeastFreqNumOcc3Strs();
  void Calc_LeastFreqNumOcc3();
  string LeastFreqNumOcc3Str[NUMSESSIONS];
  string Total_LeastFreqNumOcc3Str;
  long Total_LeastFreqNumOcc3;

  void Make_LeastFreqNumOcc4Strs();
  void Calc_LeastFreqNumOcc4();
  string LeastFreqNumOcc4Str[NUMSESSIONS];
  string Total_LeastFreqNumOcc4Str;
  long Total_LeastFreqNumOcc4;

  void Make_LeastFreqNumOcc5Strs();
  void Calc_LeastFreqNumOcc5();
  string LeastFreqNumOcc5Str[NUMSESSIONS];
  string Total_LeastFreqNumOcc5Str;
  long Total_LeastFreqNumOcc5;
};
//*******************************************************************
//*******************************************************************
class TKenoGraph:public TCasinoGraphDlg
{
public:
  TKenoGraph(TCasinoStatDlg* pstatdlg,TStatCalcKeno *pstatcalc);
  virtual ~TKenoGraph();
};
//*******************************************************************
#endif