//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  ckglord.h
//    Project Name:  Casino
// Original Author:  Adam k. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     5/24/96   A.Krist      original baseline
//  2.0    09/17/97   M.Perry      32-bit conversion.
//  2.3    07/14/99    M.Perry    gobjlist removal
//********************************************************************
#if !defined(__ckglord_h)
#define __ckglord_h

#include "casglord.h"
#include "casbutsp.h"
#include "cascdsp.h"

class TKenoModeWin;
class TKLordMainState;
class TCasinoKPlayer;
class TKLordState;

#include "caschsp.h"
#include "ckarowsp.h" //arrows
#include "ckgenisp.h" //genie
#include "ckmdsp.h"   //main display
#include "ckcksp.h"   //checks
#include "ckhdsp.h"   //history display
#include "ckposp.h"   //payoff schedule
#include "ckoldsp.h"  //old ticket results, diagonal across ticket
#include "ckhnsp.h"   //history game number
#include "cktimesp.h" //clock
#include "ckgnsp.h"   //current game number
#include "ckplsp.h"   //number of plays/games good for
#include "ckgtsp.h"   //game type 1spot,...
#include "ckbasp.h"   //bet amount per
#include "ckvgsp.h"   //valid games
#include "cnamesp.h"
#include "cksdsp.h"

//*******************************************************************
enum TKLordRID
{
  kidHistoryLeft,
  kidHistoryRight,
  kidTicketLeft,
  kidTicketRight,
  kidPlays,
  kidGames,
  kidBetAmount,

  kidButton0,
  kidButton1,
  kidButton2,
  kidButton3,
  kidButton4,
  kidButton5,
  kidButton6,
  kidButton7,

  kidNamePlate,
  kidStatBar,

  kidNum0,kidNum1,kidNum2,kidNum3,kidNum4,kidNum5,kidNum6,kidNum7,kidNum8,kidNum9,
  kidNum10,kidNum11,kidNum12,kidNum13,kidNum14,kidNum15,kidNum16,kidNum17,kidNum18,kidNum19,
  kidNum20,kidNum21,kidNum22,kidNum23,kidNum24,kidNum25,kidNum26,kidNum27,kidNum28,kidNum29,
  kidNum30,kidNum31,kidNum32,kidNum33,kidNum34,kidNum35,kidNum36,kidNum37,kidNum38,kidNum39,
  kidNum40,kidNum41,kidNum42,kidNum43,kidNum44,kidNum45,kidNum46,kidNum47,kidNum48,kidNum49,
  kidNum50,kidNum51,kidNum52,kidNum53,kidNum54,kidNum55,kidNum56,kidNum57,kidNum58,kidNum59,
  kidNum60,kidNum61,kidNum62,kidNum63,kidNum64,kidNum65,kidNum66,kidNum67,kidNum68,kidNum69,
  kidNum70,kidNum71,kidNum72,kidNum73,kidNum74,kidNum75,kidNum76,kidNum77,kidNum78,kidNum79,
  kidBlanket,kidTicketTemplate,

};
//*******************************************************************
class TCasinoKGameLord:public TCasinoGameLord
{
public:
  enum {NUMOFBUTTONS = 19,STALLDELAY = 78,NumResponders = 90};

  TKSound          *Sounds;
  TKenoModeWin     *pMWin;
  TCasNamePlate    *NamePlate1;
  TCasNamePlate    *NamePlate2;
  TCasNamePlate    *NamePlate3;
  TCasButton       *Button0;     //ask
  TCasButton       *Button1;     //stat
  TCasButton       *Button2;     //menu
  TCasButton       *Button3;     //help
  TCasButton       *Button4;     //trash
  TCasButton       *Button5;     //replay
  TCasButton       *Button6;     //new
  TCasButton       *Button7;     //play
  TCasCashDisplay  *BankCashDisplay;
  TCasChips        *Chips;
  TKArrow          *HistoryLeft;
  TKArrow          *HistoryRight;
  TKArrow          *TicketLeft;
  TKArrow          *TicketRight;
  TKMainDisplay    *MainDisplay;
  TKGenie          *Genie;
  TKHistoryDisplay *HistoryDisplay;
  TKCheck          *Checks;
  TKPayOff         *PayOff;
  TKResult         *Result;
  TKHistoryNums    *HistoryNums;
  TKTime           *Time;
  TKGameNum        *GameNum;
  TKPlays          *Plays;
  TKGameType       *GameType;
  TKBetAmount      *BetAmount;
  TKValidGames     *ValidGames;
  TResponder *Responders[NumResponders];
  int32 currenthistory;
  int32 currentgame;
  dword LastTime;
  TMoney credits;
  TMoney coinsplayed;
  TMoney coinsize;
  TMoney winnerpaid;
  TMoney maxbet;
  TMoney currentwinnings;
  TKenoGame numofspots;
  int16 LoserType;
  int16 ButtonInfo;
  int16 trash;
  int16 numofplays;
  int16 amountbet;
  int16 playersin;
  int16 shutdownstate;
  int16 KenoArray[80];
  int16 currentticketnum[3];
  TKenoTicket  CurrentTicket;
  bool ShowWin;
  bool GoodX;
  bool  ButtonHit[NUMOFBUTTONS];
  bool PayOffOn;

public:
  TKLordState *GetKLordState() {return (TKLordState *)PState;}
  void EnableAllButtons();
  virtual void TimeChanged();
  void DisEnableAllButtons();
  virtual bool Respond(int16 Button,int16 info = 0,void *pdata = NULL);
  TMoney Pay1Spot();
  TMoney Pay2Spot();
  TMoney Pay3Spot();
  TMoney Pay3SpotSpecial();
  TMoney Pay4Spot();
  TMoney Pay4SpotSpecial();
  TMoney Pay5Spot();
  TMoney Pay6Spot();
  TMoney Pay6SpotSpecial();
  TMoney Pay7Spot();
  TMoney Pay8Spot();
  TMoney Pay9Spot();
  TMoney Pay10Spot();
  TMoney PayOut();
  int16 Matches(int32 gameNumber);
  bool GameCheckMatch();
  int16 NumOfSpots();
  bool NewTicket();
  bool ReplayTicket();
  void PlayTicket();

  bool GetStartTicket();
  bool DisplayTicket();
  bool DisplayTicketForward();
  bool DisplayTicketBackward();
  bool DisplayHistory();
  bool DisplayHistoryForward(int32 Amount);
  bool DisplayHistoryBackward(int32 Amount);
  TCasinoKGameLord(TKenoModeWin *PNewOwnerWindow,const TFileMode &NewFileMode);
  virtual ~TCasinoKGameLord();
  virtual TSprite *CreateSprite(string spritename,int16 id = 0,void *psource = NULL);
  virtual void SetupSkits() {}
  TKenoModeWin *GetKMW() {return (TKenoModeWin *)PModeWin;}
  TCasinoKPlayer *GetKPlayer(int16 slotnum)
  {
	 return ((TCasinoKPlayer *)GetCasPlayer(slotnum));
  }

  virtual bool Respond(TResponder &responder);
  void SetupResponders();
  void CleanupResponders();
  virtual int16 AskCriteriaQuestion(int16 QNum);
  bool TrashTicket(dword &StartFUC,dword &FUCLength);//

  virtual void SetupSprites() {}
  virtual void CleanupSprites() {}

  void AskBetExpert();
  void AskSpotExpert(int16 Spots);
  void BetUp();
  void PlayUp();
  void GameUp();
  void PreStats();
  void PostStats(TMoney Won,int16 TicNum);
  int16 ShowWinner();
  int16 BetLast();
  int16 GetBet();
  int16 ClearBet();
  int16 Bet1(TMoney betsize);
  int16 UnBet1(TMoney betsize);
  int16 BetMax();
  int16 InitKeno();
  void UpdateMain();
  void InitHistoryDisplay();
  bool Winner();
  int16 Loser(int16 loser);
  int16 Clear();
  int16 PlaceBet(int16 x);
  int16 RemoveBet(int16 x);

  int16 FirstGamePlayer(); //activeplayer
  int16 Morning();
  int16 Afternoon();
  int16 Evening();
  int16 IsAWinningNumber();
  int16 IsNumber(int16 X);

  int16 PlayerBet1000();
  int16 PlayerBetGT(TMoney Amount);
  int16 OneHumanPlayer();
  int16 RandomLT(int16 num);
  int16 BetweenDec22_Dec25();
  int16 BetweenDec31_Jan2();
  int16 ValentinesDay();
  int16 StPatricksDay();
  int16 TwoHumanPlayers();
  int16 ThreeHumanPlayers();
  int16 AllPlayersMale();
  int16 AllPlayersFemale();
  int16 OneAndOnlyPlayerGT20000();
  int16 R10HandsPlayed();
  int16 GTWeekPlayersLastPlayed();
  GetPlayin() {return playersin;};
  bool IsWinner();
  void  SwitchToPlayer(int16 player);
  void  CyclePlayers();
  virtual void SetupActivePlayer(int16 slot);
  virtual void NotifyPlayerActivation(int16 slotnum);
  virtual void NotifyPlayerDeActivation(int16 slotnum);
  virtual void ShuttingDown();
  void EnableButton(int16 button);
  void DisEnableButton(int16 button);
  void ButtonClear(int16 button);
  void DeleteTicket(int16 Ticket);
  int16  HasBlankTicket();
  void HasTwoBlankTickets();
  bool HasTicket();
  void NewTicketCheck();

  #if defined(SUPPORT_OLD_VER)
  virtual void SetupUniqueIDStrings();
  virtual int16 GetUniqueID(const string &s);
  string strTicketLeft,strTicketRight,strHistoryLeft,strHistoryRight,
         strButton0,strButton1,strButton2,strButton3,strButton4,strButton5,
         strButton6,strButton7,strBetAmount,strChips,strTime,strChecks,
         strGenie,strGameNum,strGameType,strHistoryNums,strMainDisplay,
         strNP1,strNP2,strNP3,strHistoryDisplay,strPlays,strResult,
         strSounds,strPayoff,strValidGames,strBankCashDisplay;
  #endif
};
//*******************************************************************
#endif