//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  cklordst.h
//    Project Name:  Ogle
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     06/01/95   A. Krist    Original baseline
//  2.0     09/17/97   M.Perry     32-bit conversion.
//*******************************************************************

#if !defined _cklordst_h
#define _cklordst_h

#include "ostate.h"
#include "ckglord.h"

#define EXPERTDELAY 12

class TCasinoKGameLord;
class TResponder;
//*******************************************************************
class TKLordState : public TState
{
public:
  bool LockButtons;
  bool LockHit;
  bool IgnoreCoach;
  bool HitTotal;
  dword ExpertDelayStart;
  TCasinoKGameLord *pOwnerLord;
  TKLordState(TCasinoKGameLord *pNewKLord);
  virtual ~TKLordState();

  bool MenuEscButton(TResponder &responder);
  virtual bool HandleMenuEsc(TResponder &responder) {return true;}

  bool BetSpot(TResponder &responder,int16 Spot);
  virtual bool HandleBetSpot(TResponder &responder,int16 Spot) {return true;}

  bool HistoryLeft(TResponder &responder);
  virtual bool HandleHistoryLeft(TResponder &responder) {return true;}

  bool HistoryRight(TResponder &responder);
  virtual bool HandleHistoryRight(TResponder &responder) {return true;}

  bool TicketLeft(TResponder &responder);
  virtual bool HandleTicketLeft(TResponder &responder) {return true;}

  bool TicketRight(TResponder &responder);
  virtual bool HandleTicketRight(TResponder &responder) {return true;}

  bool BetAmount(TResponder &responder);
  virtual bool HandleBetAmount(TResponder &responder) {return true;}

  bool Plays(TResponder &responder);
  virtual bool HandlePlays(TResponder &responder) {return true;}

  bool Games(TResponder &responder);
  virtual bool HandleGames(TResponder &responder) {return true;}

  bool AskExpertButton(TResponder &responder);
  virtual bool HandleAskExpert(TResponder &responder) {return true;}

  bool Button1(TResponder &responder);
  virtual bool HandleButton1(TResponder &responder) {return true;}

  bool Button2(TResponder &responder);
  virtual bool HandleButton2(TResponder &responder) {return true;}

  bool Button3(TResponder &responder);
  virtual bool HandleButton3(TResponder &responder) {return true;}

  bool Button4(TResponder &responder);
  virtual bool HandleButton4(TResponder &responder) {return true;}

  bool StatBar(TResponder &responder);
  virtual bool HandleStatBar(TResponder &responder) {return true;}

  bool NamePlate(TResponder &responder);
  virtual bool HandleNamePlate(TResponder &responder) {return true;}
};
//*******************************************************************
#endif