//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  crbssp.h   // BetSpot
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     10/2/95    A. Krist    original baseline
//  2.0     09/19/97   M.Perry     32-bit conversion.
//********************************************************************
#if !defined(__crbssp_h)
#define __crbssp_h

#include "osprite.h"
//*******************************************************************
enum  TRSpotType {DefaultSpotType,SingleNum,TwoNum,ThreeNum,FourNum,FiveNum,
                  SixNum,Column,Dozen,Red,Black,Odd,Even,High,Low};

enum  TRSpot {BETRED,BETBLACK,BETEVEN,BETODD,BET1ST18,BET2ND18,BET1ST12,
				  BET2ND12,BET3RD12,BETCOL1,BETCOL2,BETCOL3,BET1,BET2,BET3,
				  BET4,BET5,BET6,BET7,BET8,BET9,BET10,BET11,BET12,BET13,BET14,
				  BET15,BET16,BET17,BET18,BET19,BET20,BET21,BET22,BET23,BET24,
				  BET25,BET26,BET27,BET28,BET29,BET30,BET31,BET32,BET33,BET34,
				  BET35,BET36,BET0,BET00,BET1ST3,BET2ND3,BET3RD3,BET4TH3,
				  BET5TH3,BET6TH3,BET7TH3,BET8TH3,BET9TH3,BET10TH3,BET11TH3,
				  BET12TH3,BET1ST6,BET2ND6,BET3RD6,BET4TH6,BET5TH6,BET6TH6,
				  BET7TH6,BET8TH6,BET9TH6,BET10TH6,BET11TH6,BET1ST4,BET2ND4,
				  BET3RD4,BET4TH4,BET5TH4,BET6TH4,BET7TH4,BET8TH4,BET9TH4,
				  BET10TH4,BET11TH4,BET12TH4,BET13TH4,BET14TH4,BET15TH4,BET16TH4,
				  BET17TH4,BET18TH4,BET19TH4,BET20TH4,BET21TH4,BET22TH4,BET1ST2,
				  BET2ND2,BET3RD2,BET4TH2,BET5TH2,BET6TH2,BET7TH2,BET8TH2,
				  BET9TH2,BET10TH2,BET11TH2,BET12TH2,BET13TH2,BET14TH2,BET15TH2,
				  BET16TH2,BET17TH2,BET18TH2,BET19TH2,BET20TH2,BET21TH2,BET22TH2,
				  BET23TH2,BET24TH2,BET25TH2,BET26TH2,BET27TH2,BET28TH2,BET29TH2,
				  BET30TH2,BET31TH2,BET32TH2,BET33TH2,BET34TH2,BET35TH2,BET36TH2,
				  BET37TH2,BET38TH2,BET39TH2,BET40TH2,BET41TH2,BET42TH2,BET43TH2,
				  BET44TH2,BET45TH2,BET46TH2,BET47TH2,BET48TH2,BET49TH2,BET50TH2,
				  BET51TH2,BET52TH2,BET53TH2,BET54TH2,BET55TH2,BET56TH2,BET57TH2,
				  BET58TH2,BET59TH2,BET60TH2,BET5NUM};
//*******************************************************************
class TRBetSpot:public TSprite
{
public:
  TRSpotType  SpotType;
  int16 MessageCode;
  TAnm *PChips[3][6];
  TAnm *PSpark;
  bool NotFound;
  int16  TopY,TopZ;
  TMoney BetAmount[3];
  void SetupAnms();
  TRBetSpot(TOgleModeWindow *pmw,const TFileMode &NewFileMode,int16 messagecode = 13);
  TRBetSpot(TOgleModeWindow *pmw,const TFileMode &fm,void *psource,int16 messagecode = 13);
  virtual ~TRBetSpot();
  void ShowSpark();
  void NoShowSpark();
  void NoShowChips();
  virtual bool Winner(int16 WinNum);
  virtual bool Winner(int16 WinNum,int16 Player);
  virtual int32 Odds();
  TMoney GetBSCash(int16 Slot);  // return amount of cash on bet spot
  TMoney SubBSCash(int16 Slot);   // remove and return cash from bet spot
  void AddBSCash(int16 Slot,TMoney amount);  // add cash to bet spot
  void ClearGlowChips(int16 slot); //remove top glowing chips
  bool HasBSBet(int16 Slot); // Player has Money on bet spot?
  bool IsBSBet(); // Any Money on bet spot?
  TMoney WinBSCash(int16 slot,int16 WinNum); // Give odds and remove cash, make chips glow
  TMoney StatWinBSCash(int16 slot,int16 WinNum); // Give odds plus bet
  void ClearSpot();
  void SetSpot();
  void SetNum();
};
//*******************************************************************
#endif