//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  crglord.h
//    Project Name:  Casino
// Original Author:  Adam k. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     3/24/96   A.Krist      original baseline
//  2.0    09/18/97   M.Perry      32-bit conversion.
//********************************************************************
#if !defined(__crglord_h)
#define __crglord_h

#include "casglord.h"

class TRAsk;
class TRouletteModeWin;
class TRLordMainState;
class TCasinoRPlayer;

//#include "crglspl.h"

#include "crbssp.h"
#include "casbutsp.h"
#include "casbusp.h"
#include "caschsp.h"
#include "cascdsp.h"    //Cash Display
#include "casmessp.h"   //Message Display
#include "crsdsp.h"   //Sounds Sprite
#include "crmksp.h"
#include "cnamesp.h"
#include "crnhsp.h"
#include "crposp.h"
//*******************************************************************
enum TRLordRID
{
  ridOneChip,
  ridFiveChip,
  ridTwentyFiveChip,
  ridOneHundredChip,
  ridOneThouChip,
  ridTenThouChip,

  ridButton1,
  ridButton2,
  ridButton3,
  ridButton4,

  ridMenuEsc,
  ridAskExpert,
  ridNamePlate,
  ridStatBar,

  ridBetSpot0,ridBetSpot1,ridBetSpot2,ridBetSpot3,ridBetSpot4,ridBetSpot5,
  ridBetSpot6,ridBetSpot7,ridBetSpot8,ridBetSpot9,ridBetSpot10,ridBetSpot11,
  ridBetSpot12,ridBetSpot13,ridBetSpot14,ridBetSpot15,ridBetSpot16,ridBetSpot17,
  ridBetSpot18,ridBetSpot19,ridBetSpot20,ridBetSpot21,ridBetSpot22,ridBetSpot23,
  ridBetSpot24,ridBetSpot25,ridBetSpot26,ridBetSpot27,ridBetSpot28,ridBetSpot29,
  ridBetSpot30,ridBetSpot31,ridBetSpot32,ridBetSpot33,ridBetSpot34,ridBetSpot35,
  ridBetSpot36,ridBetSpot37,ridBetSpot38,ridBetSpot39,ridBetSpot40,ridBetSpot41,
  ridBetSpot42,ridBetSpot43,ridBetSpot44,ridBetSpot45,ridBetSpot46,ridBetSpot47,
  ridBetSpot48,ridBetSpot49,ridBetSpot50,ridBetSpot51,ridBetSpot52,ridBetSpot53,
  ridBetSpot54,ridBetSpot55,ridBetSpot56,ridBetSpot57,ridBetSpot58,ridBetSpot59,
  ridBetSpot60,ridBetSpot61,ridBetSpot62,ridBetSpot63,ridBetSpot64,ridBetSpot65,
  ridBetSpot66,ridBetSpot67,ridBetSpot68,ridBetSpot69,ridBetSpot70,ridBetSpot71,
  ridBetSpot72,ridBetSpot73,ridBetSpot74,ridBetSpot75,ridBetSpot76,ridBetSpot77,
  ridBetSpot78,ridBetSpot79,ridBetSpot80,ridBetSpot81,ridBetSpot82,ridBetSpot83,
  ridBetSpot84,ridBetSpot85,ridBetSpot86,ridBetSpot87,ridBetSpot88,ridBetSpot89,
  ridBetSpot90,ridBetSpot91,ridBetSpot92,ridBetSpot93,ridBetSpot94,ridBetSpot95,
  ridBetSpot96,ridBetSpot97,ridBetSpot98,ridBetSpot99,ridBetSpot100,ridBetSpot101,
  ridBetSpot102,ridBetSpot103,ridBetSpot104,ridBetSpot105,ridBetSpot106,ridBetSpot107,
  ridBetSpot108,ridBetSpot109,ridBetSpot110,ridBetSpot111,ridBetSpot112,ridBetSpot113,
  ridBetSpot114,ridBetSpot115,ridBetSpot116,ridBetSpot117,ridBetSpot118,ridBetSpot119,
  ridBetSpot120,ridBetSpot121,ridBetSpot122,ridBetSpot123,ridBetSpot124,ridBetSpot125,
  ridBetSpot126,ridBetSpot127,ridBetSpot128,ridBetSpot129,ridBetSpot130,ridBetSpot131,
  ridBetSpot132,ridBetSpot133,ridBetSpot134,ridBetSpot135,ridBetSpot136,ridBetSpot137,
  ridBetSpot138,ridBetSpot139,ridBetSpot140,ridBetSpot141,ridBetSpot142,ridBetSpot143,
  ridBetSpot144,ridBetSpot145,ridBetSpot146,ridBetSpot147,ridBetSpot148,ridBetSpot149,
  ridBetSpot150,ridBetSpot151,ridBetSpot152,ridBetSpot153,ridBetSpot154,ridBetSpot155,
  ridFeltCursor

};
//*******************************************************************
class TCasinoRGameLord:public TCasinoGameLord
{
public:
  enum {NUMOFBUTTONS = 14,STALLDELAY = 78,NumResponders = 158};

  TRouletteModeWin       *pMWin;
  TRAsk                  *pAskExpert;
  TRSound                *RSounds;
  TRBetSpot              *BetSpot[156];
  TRMarker               *Marker;
  TCasButton             *Button1;
  TCasButton             *Button2;
  TCasButton             *Button3;
  TCasButton             *Button4;
  TCasButton             *ButtonChip10000;
  TCasButton             *ButtonChip1000;
  TCasButton             *ButtonChip100;
  TCasButton             *ButtonChip25;
  TCasButton             *ButtonChip5;
  TCasButton             *ButtonChip1;
  TCasChips              *Chips;
  TCasNamePlate          *NamePlate1;
  TCasNamePlate          *NamePlate2;
  TCasNamePlate          *NamePlate3;
  TRPayOff               *PayOffSp;
  TRNumberHistory        *NumberHistory;
  TCasButton             *CasStatusBar;
  TCasButton             *MenuEscButton;
  TCasButton             *AskExpertButton;
  TCasMessageDisplay     *MessageDisplay;
  TCasCashDisplay        *BankCashDisplay;
  TCasCashDisplay        *BetAmountDisplay;
  TSprite *BallIdle;
  TSprite *WheelIdle;

  TResponder *Responders[NumResponders];

  TMoney credits;
  TMoney coinsplayed;
  TMoney coinsize;
  TMoney winnerpaid;
  TMoney maxbet;
  TMoney currentwinnings;

  // skits
  int16 greetplayers,placebets,prespincom,winbetscom,spincom,winner,loser,
		postreconcilecom,result,finalresult,payoff;

  // sprites
  int16 placemarker1,placemarker2,placemarker3,placemarker4,placemarker5,placemarker6,placemarker7,
		removemarker1,removechips,removemarker2,removemarker3,removemarker4,removemarker5,
		dealerspin1,dealerspin2,dealerspin3,ballspin,ballhand,spinsound;
  int16 BallDrops[38];
  //

  int16   messagestate;
  int16 ExpertCode;
  int16 startresult;
  int16 winnum;
  int16 machinenum;
  int16 pot;
  int16 playersin;
  int16 shutdownstate;
  int16 ButtonInfo;
  int16 numofspins;

  bool ALLHANDSWON;
  bool BetSpotsOn;
  bool PlaceBetsMode;
  bool  ButtonHit[NUMOFBUTTONS];
  bool splitwait;

public:
  TCasinoRGameLord(TRouletteModeWin *PNewOwnerWindow,const TFileMode &fm);
  virtual ~TCasinoRGameLord();

  virtual bool Respond(int16 Button,int16 info = 0,void *pdata = NULL);
  virtual void SetupSkits() {}

  virtual TSprite *CreateSprite(string spritename,int16 id = 0,void *psource = NULL);
  TSprite *CreateSpriteAux(string spritename,int16 id);

  TRouletteModeWin *GetRMW() {return (TRouletteModeWin *)PModeWin;}
  TCasinoRPlayer *GetRPlayer(int16 slotnum) {return ((TCasinoRPlayer *)GetCasPlayer(slotnum));}

  virtual bool Respond(TResponder &responder);
  void SetupResponders();
  void CleanupResponders();
  virtual int16 AskCriteriaQuestion(int16 QNum);
  // idles
  bool SetBodyIdle() {return SetCurrentSpriteSet(1,0);}
  bool SetWheelIdle() {return SetCurrentSpriteSet(3,2);}
  bool SetBallIdle() {return SetCurrentSpriteSet(2,2);}
  // skits
  bool GreetPlayers(dword &StartFUC,dword &FUCLength){return ChooseStartSkit(greetplayers,StartFUC,FUCLength);};
  bool PlaceBets(dword &StartFUC,dword &FUCLength){ return ChooseStartSkit(placebets,StartFUC,FUCLength); };
  bool PreSpinCom(dword &StartFUC,dword &FUCLength){ return ChooseStartSkit(prespincom,StartFUC,FUCLength); };
  bool SpinCom(dword &StartFUC,dword &FUCLength){ return ChooseStartSkit(spincom,StartFUC,FUCLength); };
  bool Winner(dword &StartFUC,dword &FUCLength){ return ChooseStartSkit(winner,StartFUC,FUCLength); };
  bool WinBetsCom(dword &StartFUC,dword &FUCLength){ return ChooseStartSkit(winbetscom,StartFUC,FUCLength); };
  bool Loser(dword &StartFUC,dword &FUCLength){ return ChooseStartSkit(loser,StartFUC,FUCLength); };
  bool PostReconcileCom(dword &StartFUC,dword &FUCLength){ return ChooseStartSkit(postreconcilecom,StartFUC,FUCLength); };
  bool Result(dword &StartFUC,dword &FUCLength){ return ChooseStartSkit(result,StartFUC,FUCLength); };
  bool FinalResult(dword &StartFUC,dword &FUCLength){ return ChooseStartSkit(finalresult,StartFUC,FUCLength); };
  bool PayOff(dword &StartFUC,dword &FUCLength){ return ChooseStartSkit(payoff,StartFUC,FUCLength); };
  // sprites
  bool PlaceMarker(dword &StartFUC,dword &FUCLength,dword &MarkerFUC);
  bool RemoveMarker(dword &StartFUC,dword &FUCLength,dword &MarkerFUC);
  bool DealerSpin(dword &StartFUC,dword &FUCLength,int16 &IdleOff,int16 &BallOn,int16 frame);
  bool BallSpin(dword &StartFUC,dword &FUCLength);
  bool BallHand(dword &StartFUC,dword &FUCLength);
  bool BallDrop(dword &StartFUC,dword &FUCLength,dword &SpinStop);
  bool RemoveChips(dword &StartFUC,dword &FUCLength);


  virtual void SetupSprites() {}
  virtual void CleanupSprites() {}

  void AskBetExpert();
  void AskCoach();
  void EnableOddsMessage();
  void DisEnableOddsMessage();

  bool IsLoser();
  bool IsRed();
  bool IsBlack();
  void PreSpinStats();
  void PostSpinStats();
  int16 CalcWheelPos(int16 FrameLength,int16 StillBucket);
  int16 WinBucket(int16 RandNum);
  int16 ShowWinner();
  bool BetMade();
  bool BetMade(int16 Player);
  int16 BetLast();
  int16 GetBet();
  int16 ClearBet();
  int16 Bet1(TMoney betsize);
  int16 UnBet1(TMoney betsize);
  int16 BetMax();
  int16 GoodToGo();
  int16 InitRoulette();
  int16 Spin();
  bool Winner(int16 winner,int16 Player);
  int16 Loser(int16  loser);
  int16 Clear();
  int16 PlaceBet(int16 x);
  int16 RemoveBet(int16 x);
  void ShowMarker();
  void NoShowMarker();
  void InitBall();

  int16 FirstGamePlayer(); //activeplayer
  int16 Morning();
  int16 Afternoon();
  int16 Evening();
  int16 IsAWinningNumber();
  int16 IsNumber(int16 X);

  void DisableAllButtons();
  void EnableAllButtons();
  int16 NumOfCoins(TMoney Cash);
  int16 NumOfBankCoins(TMoney Cash);
  int16 PlayerBet1000();
  int16 PlayerBetGT(TMoney Amount);
  int16 OneHumanPlayer();
  int16 RandomLT(int16 num);
  int16 BetweenDec22_Dec25();
  int16 BetweenDec31_Jan2();
  int16 ValentinesDay();
  int16 StPatricksDay();
  int16 TwoHumanPlayers();
  int16 ThreeHumanPlayers();
  int16 AllPlayersMale();
  int16 AllPlayersFemale();
  int16 OneAndOnlyPlayerGT20000();
  int16 R10HandsPlayed();
  int16 GTWeekPlayersLastPlayed();
  int16 TwentyBets();
  int16 Laps(int16 laps);
  int16 AllLose();
  int16 OneWin();
  int16 Wins();
  int16 AllWin();
  int16 OneLoss();
  int16 Losses();
  int16 Bets();
  int16 AllWinOne();
  int16 ElevenPlusWins();
  int16 Win5001Plus();
  int16 WinLess10();
  int16 GetPlayin() {return playersin;};
  bool IsWinner();
  void ClearLosers();
  void  SwitchToPlayer(int16 player);
  void  CyclePlayers();
  void  SetExpertCode(int16 BetSpot);
  virtual void SetupActivePlayer(int16 slot);
  virtual void NotifyPlayerActivation(int16 slotnum);
  virtual void NotifyPlayerDeActivation(int16 slotnum);
  virtual void ShuttingDown();
  void ButtonClear(int16 button);

  #if defined(SUPPORT_OLD_VER)
  enum {NUM_BS = 156};
  virtual void SetupUniqueIDStrings();
  virtual int16 GetUniqueID(const string &s);
  string strSound,strBetAmount,strMsgDisplay,strCashDisplay,strMarker,
         strButtonChip1,strButtonChip5,strButtonChip25,strButtonChip100,
         strButtonChip1000,strButtonChip10000,strStatusBar,strPayoff,
         strNumHistory,strChips,strNP1,strNP2,strNP3,strButton0,strButton1,
         strButton2,strButton3,strButton4,strButton5;
  string strBS[NUM_BS];
  #endif

  #ifdef DEBUGIDLES
  TSprite *DealerPos;
  TSprite *Pos1;
  TSprite *Pos2;
  TSprite *Pos3;
  #endif
};
//*******************************************************************
#endif