//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  csalgdlg.h
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.3    6/23/97     M.Perry    original baseline
//  2.0    08/31/97    M.Perry    32-bit conversion.
//********************************************************************
#if !defined(__csalgdlg_h)
#define __csalgdlg_h

#include "ogle.h"
#include "odlg.h"
#include "csalgdlg.rh"

class TCasinoPlayerMgr;
class _OWLCLASS TListBox;
class _OWLCLASS TButton;
class _OWLCLASS TRadioButton;
class _OWLCLASS TEdit;
class _OWLCLASS TStatic;
//*******************************************************************
class TSalariedGamblerDlg:public TOgleDialog
{
private:
  dword HelpID;
  int16 SexStart;
  int16 BankrollStart;
  int16 SalaryStart;
  int16 DebtStart;
  int16 BornStart;
  int16 *PSavedNumsTT;
  int16 *PActiveNumsTT;
  int16 NumPlayersAllowed;
  int16 NumActiveAllowed;
  int16 LastActiveIndex;
  int16 LastSavedIndex;
  TCasinoPlayerMgr *PCasinoPlayerMgr;
  TButton *PActivate_Btn;
  TButton *PDeActivate_Btn;
  TButton *PCreate_Btn;
  TButton *PDelete_Btn;
  TButton *PStatistics_Btn;
  TButton *PDone_Btn;
  TButton *PHelp_Btn;
  TListBox *PActivePlayers_LB;
  TListBox *PSavedPlayers_LB;

protected:
  string MakeStringOfSpaces(int16 numspaces);
  string MakePlayerInfoString(int16 playernum);
  bool CheckActiveIndex(int16 index)
  {
    if (index >= 0 && index <= LastActiveIndex) {return true;}
    return false;
  }
  int16 TranslateActive2PN(int16 index)
  {
    if (!CheckActiveIndex(index)) {return -1;}
    return PActiveNumsTT[index];
  }
  bool CheckSavedIndex(int16 index)
  {
    if (index >= 0 && index <= LastSavedIndex) {return true;}
    return false;
  }
  int16 TranslateSaved2PN(int16 index)
  {
    if (!CheckSavedIndex(index)) {return -1;}
    return PSavedNumsTT[index];
  }
  bool IsActive(int16 playernum);
  void LoadSavedTT();
  void UnLoadSavedTT();
  void LoadSaved_LB();
  void UnLoadSaved_LB();
  void LoadActiveTT();
  void UnLoadActiveTT();
  void LoadActive_LB();
  void UnLoadActive_LB();
  void HandleButtonStatus();
  void Refresh()
  {
    LoadSaved_LB();
    LoadActive_LB();
    HandleButtonStatus();
  }

public:
  TSalariedGamblerDlg(TWindow *parent,TCasinoPlayerMgr *pplayermgr,TResId dlgid,dword helpid);
  virtual ~TSalariedGamblerDlg();
  virtual void SetupWindow();
  void CmActivate();
  void CmDeActivate();
  void CmCreate();
  void CmDelete();
  void CmStatistics();
  void CmHelp();
  void CmDone();
  void CmActiveLBSelChange();
  void CmActiveLBDblClk();
  void CmSavedLBSelChange();
  void CmSavedLBDblClk();

  DECLARE_RESPONSE_TABLE(TSalariedGamblerDlg);
};
//*******************************************************************
class TSalariedGamblerCreateDlg:public TOgleDialog
{
protected:
  bool bCheater;
  dword HelpID;
  TCasinoPlayerMgr *PCasinoPlayerMgr;
  TRadioButton *PSexMale_RB;
  TRadioButton *PSexFemale_RB;
  TRadioButton *PBankroll200_RB;
  TRadioButton *PBankroll500_RB;
  TRadioButton *PBankroll2500_RB;
  TRadioButton *PBankroll5000_RB;
  TRadioButton *PSalary0_RB;
  TRadioButton *PSalary200_RB;
  TRadioButton *PSalary500_RB;
  TRadioButton *PSalary2500_RB;
  TEdit *PName_ETB;
  TButton *PCancel_PB;
  TButton *PHelp_PB;
  TButton *PCreate_PB;
  string GetName();
  bool IsNameOk(string name);
  TMoney GetBankroll();
  bool GetSex();
  TMoney GetSalary();
  virtual void SetupWindow();

public:
  TSalariedGamblerCreateDlg(TWindow *parent,TCasinoPlayerMgr *pplayermgr,TResId dlgid,dword helpid);
  virtual ~TSalariedGamblerCreateDlg();
  void Cheat();
  void CmSexMale();
  void CmSexFemale();
  void CmBankroll200();
  void CmBankroll500();
  void CmBankroll2500();
  void CmBankroll5000();
  void CmSalary0();
  void CmSalary200();
  void CmSalary500();
  void CmSalary2500();
  void CmCancel();
  void CmHelp();
  void CmCreate();
  virtual bool PreProcessMsg(MSG& msg);

  DECLARE_RESPONSE_TABLE(TSalariedGamblerCreateDlg);
};
//*******************************************************************
class TSalariedGamblerMsgDlg:public TOgleDialog
{
protected:
  TButton *PDone_PB;
  TStatic *PText_STB;
  string strText;
  string strTitle;

public:
  TSalariedGamblerMsgDlg(TWindow *parent,TResId dlgid,string text,string title = "");
  virtual ~TSalariedGamblerMsgDlg();
  virtual void SetupWindow();
  void CmDone();

  DECLARE_RESPONSE_TABLE(TSalariedGamblerMsgDlg);
};
//*******************************************************************
class TSalariedGamblerDeleteDlg:public TOgleDialog
{
protected:
  dword HelpID;
  int16 PlayerNum;
  TCasinoPlayerMgr *PCasinoPlayerMgr;
  TButton *PHelp_PB;
  TButton *PCancel_PB;
  TButton *PDelete_PB;
  TStatic *PMsg_STB;

public:
  TSalariedGamblerDeleteDlg(TWindow *parent,TCasinoPlayerMgr *pplayermgr,TResId dlgid,dword helpid,int16 playernum);
  virtual ~TSalariedGamblerDeleteDlg();
  virtual void SetupWindow();
  void CmHelp();
  void CmCancel();
  void CmDelete();

  DECLARE_RESPONSE_TABLE(TSalariedGamblerDeleteDlg);
};
//*******************************************************************
#endif
