//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  cstatdlg.h
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     9/6/96     M.Perry     derived from Dave's code.
//********************************************************************
#if !defined(__cstatdlg_h)
#define __cstatdlg_h

#include "ogle.h"
#include "cstats.rh"
#include <owl\dialog.h>
#include <owl\button.h>
#include <owl\combobox.h>
#include "cplaydat.h"
#include "cgametyp.h"
#include "casdef.h"
//#if defined(CASINO_COMPILE)
//  #define NUM_STAT_GAMES 1
//#else
//  #define NUM_STAT_GAMES 7
//#endif
#if (NUM_STAT_GAMES > 1)
  #define GAMES_COMBOBOX
#else
  #define GAMES_STATICBOX
  #include <owl\static.h>
#endif

class TCasinoPlayerMgr;

#if defined(VP_COMPILE)
  class TStatCalcVP;
#endif

#if defined(SLOTS_COMPILE)
  class TStatCalcSlots;
#endif

#if defined(KENO_COMPILE)
  class TStatCalcKeno;
#endif

#if defined(BJ_COMPILE)
  class TStatCalcBJ;
#endif

#if defined(CRAPS_COMPILE)
  class TStatCalcCraps;
#endif

#if defined(ROULETTE_COMPILE)
  class TStatCalcRoulette;
#endif

#if defined(OVERALL_COMPILE)
  class TStatCalcOverall;
#endif
//*******************************************************************
class CASOWLCLASS TCasinoStatDlg:public TDialog
{
public:
  TCasinoStatDlg(TWindow *parent,TCasinoPlayerMgr *pplayermgr,int16 playernum = -1);
  virtual ~TCasinoStatDlg();
  TCasinoPlayerMgr *PPlayerMgr;
  TCasinoPlayerData *PPlayerData;
  TCasinoPlayerData *GetPlayerData() {return PPlayerData;}
  #if defined(BJ_COMPILE)
  TStatCalcBJ *PBJStats;
  #endif
  #if defined(CRAPS_COMPILE)
  TStatCalcCraps *PCrapsStats;
  #endif
  #if defined(ROULETTE_COMPILE)
  TStatCalcRoulette *PRouletteStats;
  #endif
  #if defined(OVERALL_COMPILE)
  TStatCalcOverall *POverallStats;
  #endif
  #if defined(KENO_COMPILE)
  TStatCalcKeno *PKenoStats;
  #endif
  #if defined(SLOTS_COMPILE)
  TStatCalcSlots *PSlotsStats;
  #endif
  #if defined(VP_COMPILE)
  TStatCalcVP *PVPStats;
  #endif

  string cell[NUMCACHEROWS][NUMCACHECOLS];
  string totalcol[NUMCACHEROWS];
  const int m_NUMCOLS;

protected:
  int16 *PlayerNumTT;
  int16 PlayerNumTTSize;
  int16 LastPlayerTTNum;
  int16 PlayerTTIndex;
  int16 GameType;

  void SetupPlayerNumTT();
  void SetupPlayerData();
  string GetPlayerName();

  const int m_NUMROWS;
  const int m_CELLWIDTH; //COLUMNS > ZERO , hold  9  characters
  const int m_LABELWIDTH;//COLUMN ZERO    , hold  17 characters

  #if defined(BJ_COMPILE)
  const int m_NUMBLACKJACKROWS;
  void ScrollUpBJ();
  void ScrollDownBJ();
  void OutputRowLabelsBJ();
  string GetBlackjackLabel(int row);
  void CmBlackjack();
  string strBlackJack;
  #endif
  #if defined(CRAPS_COMPILE)
  const int m_NUMCRAPSROWS;
  void ScrollUpCraps();
  void ScrollDownCraps();
  void OutputRowLabelsCraps();
  string GetCrapsLabel(int row);
  void CmCraps();
  string strCraps;
  #endif
  #if defined(KENO_COMPILE)
  const int m_NUMKENOROWS;
  void ScrollUpKeno();
  void ScrollDownKeno();
  void OutputRowLabelsKeno();
  string GetKenoLabel(int row);
  void CmKeno();
  string strKeno;
  #endif
  #if defined(ROULETTE_COMPILE)
  const int m_NUMROULETTEROWS;
  void ScrollUpRoulette();
  void ScrollDownRoulette();
  void OutputRowLabelsRoulette();
  string GetRouletteLabel(int row);
  void CmRoulette();
  string strRoulette;
  #endif
  #if defined(SLOTS_COMPILE)
  const int m_NUMSLOTSROWS;
  void ScrollUpSlots();
  void ScrollDownSlots();
  void OutputRowLabelsSlots();
  string GetSlotsLabel(int row);
  void CmSlots();
  string strSlots;
  #endif
  #if defined(VP_COMPILE)
  const int m_NUMVIDEOPOKERROWS;
  void ScrollUpVP();
  void ScrollDownVP();
  void OutputRowLabelsVP();
  string GetVideoPokerLabel(int row);
  void CmVideoPoker();
  string strVideoPoker;
  #endif
  #if defined(OVERALL_COMPILE)
  const int m_NUMOVERALLROWS;
  void ScrollUpOverall();
  void ScrollDownOverall();
  void OutputRowLabelsOverall();
  string GetOverallLabel(int row);
  void CmOverall();
  string strOverall;
  #endif

  int m_currentX,m_currentY,m_nCurrentRow;
  void ResetX(int newX,string topLeftCorner);
  void EmptyAllCells(void);
  void EmptyCacheAndTotals();
  void PaintTotalCell(int row);
  void PaintRowCells(int row);
  void PaintCacheRowCells(int row);
  void PaintGrid();

  void ScrollUp();
  void ScrollDown();
  void ScrollLeft();
  void ScrollRight();
  int  GetID(int row, int col) {return( 10000 + row * m_NUMCOLS + col);}
  void SetTitleToNameAndGame();

  bool OutputRowLabels();
  int16 GetGameType() {return GameType;}
  void SetGameType(int16 gametype) {GameType = gametype;}
  int  GetGamesRowCount();
  void SetSessionHeadingNumbers();

  bool m_bSound;
  void SetupWindow();
  void CmGraph();
  TButton* m_btnGraph;

  #if defined(GAMES_COMBOBOX)
  TComboBox *PGames_CB;
  #else
  TStatic *PGames_STB;
  #endif
  TComboBox *PNames_CB;
  int16 GameTT[NUM_STAT_GAMES];
  bool CheckGameIndex(int16 index) {return (index >= 0 && index <NUM_STAT_GAMES)?true:false;}
  int16 GetGameTTIndex(int16 gametype);
  void SetupGameTT();
  void LoadGamesCB();
  void LoadNamesCB();
  #if defined(GAMES_COMBOBOX)
  void EvGameChange();
  #endif
  void EvNameChange();

private:
  string strEmpty;
  string strGameStatsContinued;
  string strTotalCashBetContinued;
  string strTotalCashWLContinued;
  string strTrendAnalysisContinued;
  string strPercRetContinued;

  string strStatistics;
  string strfor;
  string strCumulative;
  string strSpace;

  DECLARE_RESPONSE_TABLE(TCasinoStatDlg);
};
//*******************************************************************
#endif