//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  hsglord.h
//    Project Name:  Casino
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     5/11/97   A.Krist      original baseline
//  2.0    09/02/97   M.Perry      32-bit conversion.
//********************************************************************
#if !defined(__hsglord_h)
#define __hsglord_h

#include "casglord.h"
#include "casbutsp.h"  // Button
#include "hscdsp.h"    //Cash Display
#include "hsposp.h"  // payoff in coins

class THunSlotsModeWin;
class THSLordMainState;

#include "hscpsp.h"
#include "cgametyp.h"
#include "hswpsp.h"
#include "hswhsp.h"
#include "hscrsp.h"
#include "hsjpsp.h"
#include "hsmtsp.h"
#include "hsodsp.h"
#include "hszssp.h"
#include "hsnmsp.h"
#include "hsreelsp.h"
#include "hssdsp.h"
#include "hsplsp.h"
#include "hsvsp.h"
#include "hsmusp.h"
#include "hsmdsp.h"
#include "hstrsp.h"
#include "hslapsp.h"
#include "hsmmsp.h"
#include "omdat.h"
#include "cashsmw.h"
//*******************************************************************
enum TGLordHSID
{
  HSidButton0,
  HSidButton1,
  HSidButton2,
  HSidButton3,
  HSidButton4,
  HSidButton5,
  HSidButton6,
  HSidButton7,

  HSidAddCoins,

  HSidSpeedClick,

  HSidNamePlate,
  HSidDenom,
  HSidProgressive
};
//*******************************************************************
class TCasinoHSGameLord:public TCasinoGameLord
{
public:
  enum {MAXBET = 3,NUMOFBUTTONS = 7,NumResponders = 3};

  TResponder *Responders[NumResponders];

  THunSlotsModeWin         *pMWin;

  THSTravel       *Travel;
  THSMileMarker   *MileMarker;
  THSOdometer     *Odometer;
  THSTitle        *Title;
  THSZodiacSign   *ZodiacSign;
  THSMultiplier   *MultiplierAnm;
  THSMedalion     *Medalion;
  THSSound        *Sounds;
  THSCoinsPlayed  *CoinsPlayed;
  THSWinPaid      *WinPaid;
  THSCredits      *Credits;
  THSReel         *Reel1;
  THSReel         *Reel2;
  THSReel         *Reel3;
  THSReel         *Reel4;
  THSLaps         *Laps;
  THSNamePlate    *NamePlate1;
  THSNamePlate    *NamePlate2;
  THSNamePlate    *NamePlate3;
  THSProgressive  *Progressive;
  TCasButton      *Button0;     //BetOne
  TCasButton      *Button1;     //BetMax
  TCasButton      *Button2;     //Spin
  TCasButton      *Button3;     //Add Credits
  TCasButton      *Button4;     //Menu
  TCasButton      *Button5;     //CashOut
  TCasButton      *Button6;     //Zodiac sign
  THSCashDisplay  *BankCashDisplay;
  THSCoinPay      *CoinPay;
  THSPayLine      *PayLine;
  THSValue        *Value;
  THSWinHighLight *WinHighLight;

  dword StartFUC;
  dword FUCLength;

  TMoney Denom[11];
  TMoney credits;
  TMoney ProgressiveIncrement;
  TMoney coinsplayed;
  TMoney coinsize;
  TMoney winnerpaid;
  TMoney maxbet;
  TMoney pot;
  TMoney ProgressiveBaseAmount;
  TMoney ProgressiveMaxAmount;
  TMoney progressive;

  int16 MedalionColor;
  int16 BetMaxNumOfCredits;
  int16 BetMaxNumOfCoins;
  int16 AdvanceNumOfFrames;
  int16 CurrentRRFrame;
  int16 TotalMiles;
  int16 Multiplier;
  int16 ButtonInfo;
  int16 Strike1,Strike2,Strike3,Strike4,Strike5,Strike6;
  int16 Crash1,Crash2,Crash3,Crash4,Crash5,Flat1,Flat2,Flat3,Flat4,Flat5,FinishLine;//RoadRallyII
  int16 machinenum;
  int16 PayOffSound;
  int16 playersin;
  int16 r1;
  int16 r2;
  int16 r3;
  int16 Song;
  int16 shutdownstate;
  int16  NumOfDenoms;
  int16  CurrentDenomNum;

  bool IsFlat;
  bool IsAccident;
  bool MaxOnly;
  bool BMNumOfCredits;
  bool BMNumOfCoins;
  bool IsCycle;
  bool IsShootMoon;
  bool IsLightStrike;
  bool HoldMultiplier;
  bool  ButtonHit[NUMOFBUTTONS];
  bool Is4Reel;
  bool IsMultiPayline;

public:
  TCasinoHSGameLord(THunSlotsModeWin *PNewOwnerWindow,const TFileMode &fm,
						  int16 subgametype,TMoney coindenom);
  virtual ~TCasinoHSGameLord();

  TMiscData *GetReelDataPtr() {return GetMiscData();}
  virtual bool SwitchDenom(TMoney Denom);
  virtual TMoney PayLine1();
  virtual TMoney PayLine2();
  virtual TMoney PayLine3();
  virtual TMoney PayLine4();
  virtual TMoney PayLine5();
  virtual TSprite *CreateSprite(string spritename,int16 id = 0,void *psource = NULL);
  virtual bool AddCredits(int16 AddCredits);
  void EnableAllButtons();
  void FreezeAllButtons();
  void UnFreezeAllButtons();
  void DisEnableAllButtons();
  void EnableButton(int16 button);
  void DisEnableButton(int16 button);
  void ButtonClear(int16 button);
  virtual bool Respond(int16 Button,int16 info = 0,void *pdata = NULL);
  virtual bool Respond(TResponder &responder);
  void SetupResponders();
  void CleanupResponders();
  int16 ShowWinner();
  int16 GetBet();
  int16 Bet1();
  TMoney BetX(TMoney x);
  int16 BetMax();
  int16 CashOut();
  int16 Spin();
  virtual void SetReel();
  virtual void CycleDenom();
  int16 Switch();
  int16 AddCoins();
  int GoodToGo();
  TMoney Winner();
  virtual void Clear();
  int16 InitS();
  void ClearActions();
  int16 PayOutProgressive();
  virtual TMoney PayOut();
  int16 GetPlayin() {return playersin;};
  int16 ChangeGame();
  void  SwitchToPlayer(int16 player);
  void  CyclePlayers();
  virtual void SetupActivePlayer(int16 slot);
  virtual void ShuttingDown();
  virtual void NotifyPlayerActivation(int16 slotnum);
  virtual void NotifyPlayerDeActivation(int16 slotnum);
  virtual void SetupSprites();
  virtual void CleanupSprites();
  
protected:
  string strBankruptTitle;
  string strPlayCheaperCreditYes;
  string strPlayCheaperCreditNo;
  string strBrokeCreditYes;
  string strBrokeCreditNo;
  string strHasCoinsPlayedCreditYes;
  string strHasCoinsPlayedCreditNo;
};
//*******************************************************************
#endif
