//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  sact1st.h    // input
//    Project Name:  Casino
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     06/28/95   A. Krist    Original baseline
//  2.0     09/25/97   M.Perry     32-bit conversion.
//*******************************************************************
#if !defined _sact1st_h
#define _sact1st_h

#include "csglord.h"
#include "slordst.h"
//*******************************************************************
class TSAct1State : public TSLordState
{
public:
  TResponder *Bet1Responder;
  TResponder *CashOutResponder;
  TResponder *BetMaxResponder;
  TResponder *SpinResponder;
  TResponder *MenuEscResponder;
  TResponder *AskExpertResponder;
  TResponder *OneChipResponder;
  TResponder *FiveChipResponder;
  TResponder *TwentyFiveChipResponder;
  TResponder *OneHundredChipResponder;
  TResponder *OneThouChipResponder;
  TResponder *TenThouChipResponder;
  TResponder *AddCoinResponder;
  dword DelayFUC;
  int16 WaitingOnWRCounter;
  int16	 StopReelTime;
  bool WaitOnTray;
  bool IgnoreCoach;
  bool askexpertflag,Lock,WaitOnSpin;

public:
  TSAct1State(TCasinoSGameLord *pNewSLord);
  virtual ~TSAct1State();
  virtual void ExecuteFirstTime();
  virtual void CreateSubState1();
  virtual void EndSubState1();
  virtual void CreateSubState2();
  virtual void EndSubState2();
  virtual bool HandleAddCoin(TResponder &responder);
  virtual bool HandleOneChip(TResponder &responder);
  virtual bool HandleFiveChip(TResponder &responder);
  virtual bool HandleTwentyFiveChip(TResponder &responder);
  virtual bool HandleOneHundredChip(TResponder &responder);
  virtual bool HandleOneThouChip(TResponder &responder);
  virtual bool HandleTenThouChip(TResponder &responder);
  virtual bool HandleBet1(TResponder &responder);
  virtual bool HandleAskExpert(TResponder &responder);
  virtual bool HandleMenuEsc(TResponder &responder);
  virtual bool HandleBetMax(TResponder &responder);
  virtual bool HandleCashOut(TResponder &responder);
  virtual bool HandleSpin(TResponder &responder);
  virtual void HandlePostUpdate(dword NewFUC);
  virtual bool HandleNamePlate(TResponder &responder);
};
//*******************************************************************
#endif
