//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  caccgfw2.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.2     4/13/97    M.Perry     modified app & fw hierarchy.
//  2.0    09/17/97    M.Perry     32-bit conversion.
//********************************************************************
#include "caccgfw.h"
#include "cgametyp.h"

#include "lmw.h"
#include "ccredmw.h"

#include "csalfmw.h"
#include "cs10mw.h"
#include "cs25mw.h"
#include "cs50mw.h"
#include "te1mw.h"
#include "te2mw.h"
#include "te5mw.h"
#include "te10mw.h"
#include "te500mw.h"
#include "tetmw.h"
#include "pp1mw.h"
#include "pp2mw.h"
#include "pp5mw.h"
#include "pp10mw.h"
#include "pp25mw.h"
#include "pp50mw.h"
#include "pp100mw.h"
#include "jj100mw.h"
#include "ll1mw.h"
#include "ll2mw.h"
#include "ll5mw.h"
#include "ll10mw.h"
#include "ll25mw.h"
#include "ll50mw.h"
#include "wj10mw.h"
#include "wj50mw.h"
#include "wj100mw.h"
#include "pd25mw.h"
#include "pd50mw.h"
#include "pd100mw.h"

#include "csalmw.h"
#include "csalhmw.h"
#include "cs1mw.h"
#include "cs2mw.h"
#include "cs5mw.h"
#include "jj1mw.h"
#include "jj2mw.h"
#include "wj5mw.h"
#include "wj25mw.h"
#include "s76tmw.h"

#include "accvpmw.h"
//#include "jw1mw.h"
//#include "jw5mw.h"
//#include "jw25mw.h"
//#include "tb1mw.h"
//#include "tb5mw.h"
//#include "tb25mw.h"
//#include "tb100mw.h"

//#include "dw1mw.h"
//#include "dw5mw.h"
//#include "dw25mw.h"
//#include "dw100mw.h"
//#include "jw100mw.h"
//#include "jb1mw.h"
//#include "jb5mw.h"
//#include "jb25mw.h"
//#include "jb100mw.h"
//#include "jb1pmw.h"

#include "bj1mw.h"
#include "cr1mw.h"
#include "cc1mw.h"

#include "ck1mw.h"

#include "casnames.rh"
//*******************************************************************
string GetAppString(int16 ids)
{
  string s = TAppString(ids);
  return s;
}
//*******************************************************************
void TCasACCGameFrameWindow::SetupModeIDS()
{
  if (ModeIDSInitialized) {return;}

  idsIntro = IDS_M_INTRO;
  idsVPJack1 = IDS_M_VP_JB1;
  idsVPJack5 = IDS_M_VP_JB5;
  idsVPJack25 = IDS_M_VP_JB25;
  idsVPJack100 = IDS_M_VP_JB100;
  idsVPJack1P = IDS_M_VP_JB1P;
  idsVPDWild1 = IDS_M_VP_DW1;
  idsVPDWild5 = IDS_M_VP_DW5;
  idsVPDWild25 = IDS_M_VP_DW25;
  idsVPDWild100 = IDS_M_VP_DW100;
  idsVPTen1 = IDS_M_VP_TB1;
  idsVPTen5 = IDS_M_VP_TB5;
  idsVPTen25 = IDS_M_VP_TB25;
  idsVPTen100 = IDS_M_VP_TB100;
  idsVPJWild1 = IDS_M_VP_JW1;
  idsVPJWild5 = IDS_M_VP_JW5;
  idsVPJWild25 = IDS_M_VP_JW25;
  idsVPJWild100 = IDS_M_VP_JW100;

  TCasinoGameFrameWindow::SetupModeIDS();
}
//*******************************************************************
void TCasACCGameFrameWindow::SetupModeStrings()
{
  if (ModeStringsInitialized) {return;}

//  strIntro = string("s1intro.m");
  strIntro = GetAppString(IDS_M_INTRO);
  strLobby = GetAppString(IDS_M_LOBBY);
  strBlackJack = GetAppString(IDS_M_BJ1);
  strCraps = GetAppString(IDS_M_CRAPS);
  strRoulette = GetAppString(IDS_M_ROULETTE);
  strKeno = GetAppString(IDS_M_KENO);
  strSlotsAladdin100 = GetAppString(IDS_M_SL_ALADDIN100);
  strSlotsAladdin500 = GetAppString(IDS_M_SL_ALADDIN500);
  strSlotsAladdin1P = GetAppString(IDS_M_SL_ALADDIN1P);
  strSlotsParadise25 = GetAppString(IDS_M_SL_PARADISE25);
  strSlotsParadise50 = GetAppString(IDS_M_SL_PARADISE50);
  strSlotsParadise100 = GetAppString(IDS_M_SL_PARADISE100);
  strSlotsJungle1 = GetAppString(IDS_M_SL_JUNGLE1);
  strSlotsJungle2 = GetAppString(IDS_M_SL_JUNGLE2);
  strSlotsJungle100 = GetAppString(IDS_M_SL_JUNGLE100);
  strSlotsPirate1 = GetAppString(IDS_M_SL_PIRATE1);
  strSlotsPirate2 = GetAppString(IDS_M_SL_PIRATE2);
  strSlotsPirate5 = GetAppString(IDS_M_SL_PIRATE5);
  strSlotsPirate10 = GetAppString(IDS_M_SL_PIRATE10);
  strSlotsPirate25 = GetAppString(IDS_M_SL_PIRATE25);
  strSlotsPirate50 = GetAppString(IDS_M_SL_PIRATE50);
  strSlotsPirate100 = GetAppString(IDS_M_SL_PIRATE100);
  strSlotsLucky1 = GetAppString(IDS_M_SL_LUCKY1);
  strSlotsLucky2 = GetAppString(IDS_M_SL_LUCKY2);
  strSlotsLucky5 = GetAppString(IDS_M_SL_LUCKY5);
  strSlotsLucky10 = GetAppString(IDS_M_SL_LUCKY10);
  strSlotsLucky25 = GetAppString(IDS_M_SL_LUCKY25);
  strSlotsLucky50 = GetAppString(IDS_M_SL_LUCKY50);
  strSlotsSpirit1000 = GetAppString(IDS_M_SL_SPIRIT1000);
  strSlotsJokers5 = GetAppString(IDS_M_SL_JOKER5);
  strSlotsJokers10 = GetAppString(IDS_M_SL_JOKER10);
  strSlotsJokers25 = GetAppString(IDS_M_SL_JOKER25);
  strSlotsJokers50 = GetAppString(IDS_M_SL_JOKER50);
  strSlotsJokers100 = GetAppString(IDS_M_SL_JOKER100);
  strSlotsTotal1 = GetAppString(IDS_M_SL_TOTAL1);
  strSlotsTotal2 = GetAppString(IDS_M_SL_TOTAL2);
  strSlotsTotal5 = GetAppString(IDS_M_SL_TOTAL5);
  strSlotsTotal10 = GetAppString(IDS_M_SL_TOTAL10);
  strSlotsTotal500 = GetAppString(IDS_M_SL_TOTAL500);
  strSlotsTotal1000 = GetAppString(IDS_M_SL_TOTAL1000);
  strSlotsCherry1 = GetAppString(IDS_M_SL_CHERRY1);
  strSlotsCherry2 = GetAppString(IDS_M_SL_CHERRY2);
  strSlotsCherry5 = GetAppString(IDS_M_SL_CHERRY5);
  strSlotsCherry10 = GetAppString(IDS_M_SL_CHERRY10);
  strSlotsCherry25 = GetAppString(IDS_M_SL_CHERRY25);
  strSlotsCherry50 = GetAppString(IDS_M_SL_CHERRY50);
  strVPJack1 = GetAppString(IDS_M_VP_JB1);
  strVPJack5 = GetAppString(IDS_M_VP_JB5);
  strVPJack25 = GetAppString(IDS_M_VP_JB25);
  strVPJack100 = GetAppString(IDS_M_VP_JB100);
  strVPJack1P = GetAppString(IDS_M_VP_JB1P);
  strVPDWild1 = GetAppString(IDS_M_VP_DW1);
  strVPDWild5 = GetAppString(IDS_M_VP_DW5);
  strVPDWild25 = GetAppString(IDS_M_VP_DW25);
  strVPDWild100 = GetAppString(IDS_M_VP_DW100);
  strVPTen1 = GetAppString(IDS_M_VP_TB1);
  strVPTen5 = GetAppString(IDS_M_VP_TB5);
  strVPTen25 = GetAppString(IDS_M_VP_TB25);
  strVPTen100 = GetAppString(IDS_M_VP_TB100);
  strVPJWild1 = GetAppString(IDS_M_VP_JW1);
  strVPJWild5 = GetAppString(IDS_M_VP_JW5);
  strVPJWild25 = GetAppString(IDS_M_VP_JW25);
  strVPJWild100 = GetAppString(IDS_M_VP_JW100);

  TCasinoGameFrameWindow::SetupModeStrings(); // call up chain.
}
//*******************************************************************
void TCasACCGameFrameWindow::SetupModeIndexes()
{
  if (ModeIndexesInitialized) {return;}

  miIntro = GetModeIndex(strIntro);
  miLobby = GetModeIndex(strLobby);

//  string s = strLobby;
//  if (ShowIntro) {s = strIntro;}
//  StartupModeIndex = GetModeIndex(s);
  StartupModeIndex = ShowIntro ? miIntro : miLobby;
//  if (ShowIntro) {StartupModeIndex = miIntro;}

  miBlackJack = GetModeIndex(strBlackJack);
  miCraps = GetModeIndex(strCraps);
  miRoulette = GetModeIndex(strRoulette);
  miKeno = GetModeIndex(strKeno);
  miSlotsAladdin100 = GetModeIndex(strSlotsAladdin100);
  miSlotsAladdin500 = GetModeIndex(strSlotsAladdin500);
  miSlotsAladdin1P = GetModeIndex(strSlotsAladdin1P);
  miSlotsParadise25 = GetModeIndex(strSlotsParadise25);
  miSlotsParadise50 = GetModeIndex(strSlotsParadise50);
  miSlotsParadise100 = GetModeIndex(strSlotsParadise100);
  miSlotsJungle1 = GetModeIndex(strSlotsJungle1);
  miSlotsJungle2 = GetModeIndex(strSlotsJungle2);
  miSlotsJungle100 = GetModeIndex(strSlotsJungle100);
  miSlotsPirate1 = GetModeIndex(strSlotsPirate1);
  miSlotsPirate2 = GetModeIndex(strSlotsPirate2);
  miSlotsPirate5 = GetModeIndex(strSlotsPirate5);
  miSlotsPirate10 = GetModeIndex(strSlotsPirate10);
  miSlotsPirate25 = GetModeIndex(strSlotsPirate25);
  miSlotsPirate50 = GetModeIndex(strSlotsPirate50);
  miSlotsPirate100 = GetModeIndex(strSlotsPirate100);
  miSlotsLucky1 = GetModeIndex(strSlotsLucky1);
  miSlotsLucky2 = GetModeIndex(strSlotsLucky2);
  miSlotsLucky5 = GetModeIndex(strSlotsLucky5);
  miSlotsLucky10 = GetModeIndex(strSlotsLucky10);
  miSlotsLucky25 = GetModeIndex(strSlotsLucky25);
  miSlotsLucky50 = GetModeIndex(strSlotsLucky50);
  miSlotsSpirit1000 = GetModeIndex(strSlotsSpirit1000);
  miSlotsJokers5 = GetModeIndex(strSlotsJokers5);
  miSlotsJokers10 = GetModeIndex(strSlotsJokers10);
  miSlotsJokers25 = GetModeIndex(strSlotsJokers25);
  miSlotsJokers50 = GetModeIndex(strSlotsJokers50);
  miSlotsJokers100 = GetModeIndex(strSlotsJokers100);
  miSlotsTotal1 = GetModeIndex(strSlotsTotal1);
  miSlotsTotal2 = GetModeIndex(strSlotsTotal2);
  miSlotsTotal5 = GetModeIndex(strSlotsTotal5);
  miSlotsTotal10 = GetModeIndex(strSlotsTotal10);
  miSlotsTotal500 = GetModeIndex(strSlotsTotal500);
  miSlotsTotal1000 = GetModeIndex(strSlotsTotal1000);
  miSlotsCherry1 = GetModeIndex(strSlotsCherry1);
  miSlotsCherry2 = GetModeIndex(strSlotsCherry2);
  miSlotsCherry5 = GetModeIndex(strSlotsCherry5);
  miSlotsCherry10 = GetModeIndex(strSlotsCherry10);
  miSlotsCherry25 = GetModeIndex(strSlotsCherry25);
  miSlotsCherry50 = GetModeIndex(strSlotsCherry50);
  miVPJack1 = GetModeIndex(strVPJack1);
  miVPJack5 = GetModeIndex(strVPJack5);
  miVPJack25 = GetModeIndex(strVPJack25);
  miVPJack100 = GetModeIndex(strVPJack100);
  miVPJack1P = GetModeIndex(strVPJack1P);
  miVPDWild1 = GetModeIndex(strVPDWild1);
  miVPDWild5 = GetModeIndex(strVPDWild5);
  miVPDWild25 = GetModeIndex(strVPDWild25);
  miVPDWild100 = GetModeIndex(strVPDWild100);
  miVPTen1 = GetModeIndex(strVPTen1);
  miVPTen5 = GetModeIndex(strVPTen5);
  miVPTen25 = GetModeIndex(strVPTen25);
  miVPTen100 = GetModeIndex(strVPTen100);
  miVPJWild1 = GetModeIndex(strVPJWild1);
  miVPJWild5 = GetModeIndex(strVPJWild5);
  miVPJWild25 = GetModeIndex(strVPJWild25);
  miVPJWild100 = GetModeIndex(strVPJWild100);

  TCasinoGameFrameWindow::SetupModeIndexes();
}
//*******************************************************************
void TCasACCGameFrameWindow::SwitchBJ(int numdecks)
{
  BJNumDecks = numdecks;
  bool BJPresent = false;
  if (PModeWin == NULL)
  {
    BJPresent = false;
  }
  else if (PModeWin->ModeWindowFileName == strBlackJack)//TAppString(IDS_M_BJ1))
  {
    BJPresent = true;
  }

  if (BJPresent)
  {
	 ((TBlackJackModeWin *)PModeWin)->ChangeDeckNum(int16(numdecks));
	 GetACCMenuEnable()->SetModes(true);
	 switch (BJNumDecks)
	 {
		case 2:  GetACCMenuEnable()->BlackJackTwo = false;break;
		case 4:  GetACCMenuEnable()->BlackJackFour = false;break;
		case 6:  GetACCMenuEnable()->BlackJackSix = false;break;
		default: GetACCMenuEnable()->BlackJackOne = false;break;
	 }
  }
  else
  {
	 SwitchGameModes(strBlackJack);//TAppString(IDS_M_BJ1));
  }
}
//*******************************************************************
//future: CreateModeWindow(int16 ndx,TIndexType ndxtype = ndxtOWNERLISTNDX or
//                                                        ndxtRESOURCEIDS or
//                                                        ndxtUNIQUEID
//      note: ndxtype will be an enum, not a bitflagintx
TWindow *TCasACCGameFrameWindow::CreateModeWindow(int16 ModeIndex)
{
  GetACCMenuEnable()->SetModes(true);

  if (!IsValidModeIndex(ModeIndex)) {return PModeWin;}

  string modename = GetModeName(ModeIndex);
//  if (modename == strLobby)
  if (ModeIndex == miLobby)
  {
	 PModeWin = new TLobby1ModeWin(modename,GetOgleApp()->PMasterPalette,"walkabout");
	 GetACCMenuEnable()->SetCurrentMode(IDS_M_LOBBY);
	 GetACCMenuEnable()->Lobby = false;
	 return PModeWin;
  }
//  if (modename == strIntro)
  if (ModeIndex == miIntro)
  {
    PModeWin = new TCreditsModeWin(modename,GetOgleApp()->PMasterPalette,"Credits");
    GetACCMenuEnable()->SetCurrentMode(IDS_M_INTRO);
    return PModeWin;
  }
//  if (modename == strBlackJack)
  if (ModeIndex == miBlackJack)
  {
    //BJNumDecks set by SwitchBJ & ctor.
    PModeWin = new TBJ1ModeWin(modename,GetOgleApp()->PMasterPalette,int16(BJNumDecks));
    GetACCMenuEnable()->SetCurrentMode(IDS_M_BJ1);
    switch (BJNumDecks)
    {
      case 2: GetACCMenuEnable()->BlackJackTwo = false;break;
      case 4: GetACCMenuEnable()->BlackJackFour = false;break;
      case 6: GetACCMenuEnable()->BlackJackSix = false;break;
      default:GetACCMenuEnable()->BlackJackOne = false;break;
    }
    return PModeWin;
  }
//  if (modename == strRoulette)
  if (ModeIndex == miRoulette)
  {
    PModeWin = new TR1ModeWin(modename,GetOgleApp()->PMasterPalette);
    GetACCMenuEnable()->SetCurrentMode(IDS_M_ROULETTE);
    GetACCMenuEnable()->Roulette = false;
    return PModeWin;
  }
//  if (modename == strCraps)
  if (ModeIndex == miCraps)
  {
    PModeWin = new TC1ModeWin(modename,GetOgleApp()->PMasterPalette);
    GetACCMenuEnable()->SetCurrentMode(IDS_M_CRAPS);
    GetACCMenuEnable()->Craps = false;
    return PModeWin;
  }
//  if (modename == strSlotsAladdin1P)
  if (ModeIndex == miSlotsAladdin1P)
  {
	 PModeWin = new TAladinModeWin(modename,GetOgleApp()->PMasterPalette);
	 GetACCMenuEnable()->SetCurrentMode(IDS_M_SL_ALADDIN1P);
	 GetACCMenuEnable()->SlotsAladdin1P = false;
	 return PModeWin;
  }
//  if (modename == strSlotsAladdin100)
  if (ModeIndex == miSlotsAladdin100)
  {
	 PModeWin = new TAladin100ModeWin(modename,GetOgleApp()->PMasterPalette);
	 GetACCMenuEnable()->SetCurrentMode(IDS_M_SL_ALADDIN100);
	 GetACCMenuEnable()->SlotsAladdin100 = false;
	 return PModeWin;
  }
//  if (modename == strSlotsAladdin500)
  if (ModeIndex == miSlotsAladdin500)
  {
	 PModeWin = new TAladin500ModeWin(modename,GetOgleApp()->PMasterPalette);
	 GetACCMenuEnable()->SetCurrentMode(IDS_M_SL_ALADDIN500);
	 GetACCMenuEnable()->SlotsAladdin500 = false;
	 return PModeWin;
  }
//  if (modename == strSlotsParadise25)
  if (ModeIndex == miSlotsParadise25)
  {
	 PModeWin = new TDreamin25ModeWin(modename,GetOgleApp()->PMasterPalette);
	 GetACCMenuEnable()->SetCurrentMode(IDS_M_SL_PARADISE25);
	 GetACCMenuEnable()->SlotsParadise25 = false;
	 return PModeWin;
  }
//  if (modename == strSlotsParadise50)
  if (ModeIndex == miSlotsParadise50)
  {
	 PModeWin = new TDreamin50ModeWin(modename,GetOgleApp()->PMasterPalette);
	 GetACCMenuEnable()->SetCurrentMode(IDS_M_SL_PARADISE50);
	 GetACCMenuEnable()->SlotsParadise50 = false;
	 return PModeWin;
  }
//  if (modename == strSlotsParadise100)
  if (ModeIndex == miSlotsParadise100)
  {
	 PModeWin = new TDreamin100ModeWin(modename,GetOgleApp()->PMasterPalette);
	 GetACCMenuEnable()->SetCurrentMode(IDS_M_SL_PARADISE100);
	 GetACCMenuEnable()->SlotsParadise100 = false;
	 return PModeWin;
  }
//  if (modename == strSlotsPirate1)
  if (ModeIndex == miSlotsPirate1)
  {
	 PModeWin = new TPlunder1ModeWin(modename,GetOgleApp()->PMasterPalette);
	 GetACCMenuEnable()->SetCurrentMode(IDS_M_SL_PIRATE1);
	 GetACCMenuEnable()->SlotsPirate1 = false;
	 return PModeWin;
  }
//  if (modename == strSlotsPirate2)
  if (ModeIndex == miSlotsPirate2)
  {
	 PModeWin = new TPlunder2ModeWin(modename,GetOgleApp()->PMasterPalette);
	 GetACCMenuEnable()->SetCurrentMode(IDS_M_SL_PIRATE2);
	 GetACCMenuEnable()->SlotsPirate2 = false;
	 return PModeWin;
  }
//  if (modename == strSlotsPirate5)
  if (ModeIndex == miSlotsPirate5)
  {
	 PModeWin = new TPlunder5ModeWin(modename,GetOgleApp()->PMasterPalette);
	 GetACCMenuEnable()->SetCurrentMode(IDS_M_SL_PIRATE5);
	 GetACCMenuEnable()->SlotsPirate5 = false;
	 return PModeWin;
  }
//  if (modename == strSlotsPirate10)
  if (ModeIndex == miSlotsPirate10)
  {
	 PModeWin = new TPlunder10ModeWin(modename,GetOgleApp()->PMasterPalette);
	 GetACCMenuEnable()->SetCurrentMode(IDS_M_SL_PIRATE10);
	 GetACCMenuEnable()->SlotsPirate10 = false;
	 return PModeWin;
  }
//  if (modename == strSlotsPirate25)
  if (ModeIndex == miSlotsPirate25)
  {
	 PModeWin = new TPlunder25ModeWin(modename,GetOgleApp()->PMasterPalette);
	 GetACCMenuEnable()->SetCurrentMode(IDS_M_SL_PIRATE25);
	 GetACCMenuEnable()->SlotsPirate25 = false;
	 return PModeWin;
  }
//  if (modename == strSlotsPirate50)
  if (ModeIndex == miSlotsPirate50)
  {
	 PModeWin = new TPlunder50ModeWin(modename,GetOgleApp()->PMasterPalette);
	 GetACCMenuEnable()->SetCurrentMode(IDS_M_SL_PIRATE50);
	 GetACCMenuEnable()->SlotsPirate50 = false;
	 return PModeWin;
  }
//  if (modename == strSlotsPirate100)
  if (ModeIndex == miSlotsPirate100)
  {
	 PModeWin = new TPlunder100ModeWin(modename,GetOgleApp()->PMasterPalette);
	 GetACCMenuEnable()->SetCurrentMode(IDS_M_SL_PIRATE100);
	 GetACCMenuEnable()->SlotsPirate100 = false;
	 return PModeWin;
  }
//  if (modename == strSlotsLucky1)
  if (ModeIndex == miSlotsLucky1)
  {
	 PModeWin = new TLucky1ModeWin(modename,GetOgleApp()->PMasterPalette);
	 GetACCMenuEnable()->SetCurrentMode(IDS_M_SL_LUCKY1);
	 GetACCMenuEnable()->SlotsLucky1 = false;
	 return PModeWin;
  }
//  if (modename == strSlotsLucky2)
  if (ModeIndex == miSlotsLucky2)
  {
	 PModeWin = new TLucky2ModeWin(modename,GetOgleApp()->PMasterPalette);
	 GetACCMenuEnable()->SetCurrentMode(IDS_M_SL_LUCKY2);
	 GetACCMenuEnable()->SlotsLucky2 = false;
	 return PModeWin;
  }
//  if (modename == strSlotsLucky5)
  if (ModeIndex == miSlotsLucky5)
  {
	 PModeWin = new TLucky5ModeWin(modename,GetOgleApp()->PMasterPalette);
	 GetACCMenuEnable()->SetCurrentMode(IDS_M_SL_LUCKY5);
	 GetACCMenuEnable()->SlotsLucky5 = false;
	 return PModeWin;
  }
//  if (modename == strSlotsLucky10)
  if (ModeIndex == miSlotsLucky10)
  {
	 PModeWin = new TLucky10ModeWin(modename,GetOgleApp()->PMasterPalette);
	 GetACCMenuEnable()->SetCurrentMode(IDS_M_SL_LUCKY10);
	 GetACCMenuEnable()->SlotsLucky10 = false;
	 return PModeWin;
  }
//  if (modename == strSlotsLucky25)
  if (ModeIndex == miSlotsLucky25)
  {
	 PModeWin = new TLucky25ModeWin(modename,GetOgleApp()->PMasterPalette);
	 GetACCMenuEnable()->SetCurrentMode(IDS_M_SL_LUCKY25);
	 GetACCMenuEnable()->SlotsLucky25 = false;
	 return PModeWin;
  }
//  if (modename == strSlotsLucky50)
  if (ModeIndex == miSlotsLucky50)
  {
	 PModeWin = new TLucky50ModeWin(modename,GetOgleApp()->PMasterPalette);
	 GetACCMenuEnable()->SetCurrentMode(IDS_M_SL_LUCKY50);
	 GetACCMenuEnable()->SlotsLucky50 = false;
	 return PModeWin;
  }
//  if (modename == strSlotsSpirit1000)
  if (ModeIndex == miSlotsSpirit1000)
  {
	 PModeWin = new TSpirit76ModeWin(modename,GetOgleApp()->PMasterPalette);
	 GetACCMenuEnable()->SetCurrentMode(IDS_M_SL_SPIRIT1000);
	 GetACCMenuEnable()->SlotsSpirit1000 = false;
	 return PModeWin;
  }
//  if (modename == strSlotsJokers5)
  if (ModeIndex == miSlotsJokers5)
  {
	 PModeWin = new TWildJoke5ModeWin(modename,GetOgleApp()->PMasterPalette);
	 GetACCMenuEnable()->SetCurrentMode(IDS_M_SL_JOKER5);
	 GetACCMenuEnable()->SlotsJokers5 = false;
	 return PModeWin;
  }
//  if (modename == strSlotsJokers10)
  if (ModeIndex == miSlotsJokers10)
  {
	 PModeWin = new TWildJoke10ModeWin(modename,GetOgleApp()->PMasterPalette);
	 GetACCMenuEnable()->SetCurrentMode(IDS_M_SL_JOKER10);
	 GetACCMenuEnable()->SlotsJokers10 = false;
	 return PModeWin;
  }
//  if (modename == strSlotsJokers25)
  if (ModeIndex == miSlotsJokers25)
  {
	 PModeWin = new TWildJoke25ModeWin(modename,GetOgleApp()->PMasterPalette);
	 GetACCMenuEnable()->SetCurrentMode(IDS_M_SL_JOKER25);
	 GetACCMenuEnable()->SlotsJokers25 = false;
	 return PModeWin;
  }
//  if (modename == strSlotsJokers50)
  if (ModeIndex == miSlotsJokers50)
  {
	 PModeWin = new TWildJoke50ModeWin(modename,GetOgleApp()->PMasterPalette);
	 GetACCMenuEnable()->SetCurrentMode(IDS_M_SL_JOKER50);
	 GetACCMenuEnable()->SlotsJokers50 = false;
	 return PModeWin;
  }
//  if (modename == strSlotsJokers100)
  if (ModeIndex == miSlotsJokers100)
  {
	 PModeWin = new TWildJoke100ModeWin(modename,GetOgleApp()->PMasterPalette);
	 GetACCMenuEnable()->SetCurrentMode(IDS_M_SL_JOKER100);
	 GetACCMenuEnable()->SlotsJokers100 = false;
	 return PModeWin;
  }
//  if (modename == strSlotsTotal1)
  if (ModeIndex == miSlotsTotal1)
  {
	 PModeWin = new TEclipse1ModeWin(modename,GetOgleApp()->PMasterPalette);
	 GetACCMenuEnable()->SetCurrentMode(IDS_M_SL_TOTAL1);
	 GetACCMenuEnable()->SlotsTotal1 = false;
	 return PModeWin;
  }
//  if (modename == strSlotsTotal2)
  if (ModeIndex == miSlotsTotal2)
  {
	 PModeWin = new TEclipse2ModeWin(modename,GetOgleApp()->PMasterPalette);
	 GetACCMenuEnable()->SetCurrentMode(IDS_M_SL_TOTAL2);
	 GetACCMenuEnable()->SlotsTotal2 = false;
	 return PModeWin;
  }
//  if (modename == strSlotsTotal5)
  if (ModeIndex == miSlotsTotal5)
  {
	 PModeWin = new TEclipse5ModeWin(modename,GetOgleApp()->PMasterPalette);
	 GetACCMenuEnable()->SetCurrentMode(IDS_M_SL_TOTAL5);
	 GetACCMenuEnable()->SlotsTotal5 = false;
	 return PModeWin;
  }
//  if (modename == strSlotsTotal10)
  if (ModeIndex == miSlotsTotal10)
  {
	 PModeWin = new TEclipse10ModeWin(modename,GetOgleApp()->PMasterPalette);
	 GetACCMenuEnable()->SetCurrentMode(IDS_M_SL_TOTAL10);
	 GetACCMenuEnable()->SlotsTotal10 = false;
	 return PModeWin;
  }
//  if (modename == strSlotsTotal500)
  if (ModeIndex == miSlotsTotal500)
  {
	 PModeWin = new TEclipse500ModeWin(modename,GetOgleApp()->PMasterPalette);
	 GetACCMenuEnable()->SetCurrentMode(IDS_M_SL_TOTAL500);
	 GetACCMenuEnable()->SlotsTotal500 = false;
	 return PModeWin;
  }
//  if (modename == strSlotsTotal1000)
  if (ModeIndex == miSlotsTotal1000)
  {
	 PModeWin = new TEclipse1000ModeWin(modename,GetOgleApp()->PMasterPalette);
	 GetACCMenuEnable()->SetCurrentMode(IDS_M_SL_TOTAL1000);
	 GetACCMenuEnable()->SlotsTotal1000 = false;
	 return PModeWin;
  }
//  if (modename == strSlotsCherry1)
  if (ModeIndex == miSlotsCherry1)
  {
	 PModeWin = new TCherry1ModeWin(modename,GetOgleApp()->PMasterPalette);
	 GetACCMenuEnable()->SetCurrentMode(IDS_M_SL_CHERRY1);
	 GetACCMenuEnable()->SlotsCherry1 = false;
	 return PModeWin;
  }
//  if (modename == strSlotsCherry2)
  if (ModeIndex == miSlotsCherry2)
  {
	 PModeWin = new TCherry2ModeWin(modename,GetOgleApp()->PMasterPalette);
	 GetACCMenuEnable()->SetCurrentMode(IDS_M_SL_CHERRY2);
	 GetACCMenuEnable()->SlotsCherry2 = false;
	 return PModeWin;
  }
//  if (modename == strSlotsCherry5)
  if (ModeIndex == miSlotsCherry5)
  {
	 PModeWin = new TCherry5ModeWin(modename,GetOgleApp()->PMasterPalette);
	 GetACCMenuEnable()->SetCurrentMode(IDS_M_SL_CHERRY5);
	 GetACCMenuEnable()->SlotsCherry5 = false;
	 return PModeWin;
  }
//  if (modename == strSlotsCherry10)
  if (ModeIndex == miSlotsCherry10)
  {
	 PModeWin = new TCherry10ModeWin(modename,GetOgleApp()->PMasterPalette);
	 GetACCMenuEnable()->SetCurrentMode(IDS_M_SL_CHERRY10);
	 GetACCMenuEnable()->SlotsCherry10 = false;
	 return PModeWin;
  }
//  if (modename == strSlotsCherry25)
  if (ModeIndex == miSlotsCherry25)
  {
	 PModeWin = new TCherry25ModeWin(modename,GetOgleApp()->PMasterPalette);
	 GetACCMenuEnable()->SetCurrentMode(IDS_M_SL_CHERRY25);
	 GetACCMenuEnable()->SlotsCherry25 = false;
	 return PModeWin;
  }
//  if (modename == strSlotsCherry50)
  if (ModeIndex == miSlotsCherry50)
  {
	 PModeWin = new TCherry50ModeWin(modename,GetOgleApp()->PMasterPalette);
	 GetACCMenuEnable()->SetCurrentMode(IDS_M_SL_CHERRY50);
	 GetACCMenuEnable()->SlotsCherry50 = false;
	 return PModeWin;
  }
//  if (modename == strSlotsJungle1)
  if (ModeIndex == miSlotsJungle1)
  {
	 PModeWin = new TJungle1ModeWin(modename,GetOgleApp()->PMasterPalette);
	 GetACCMenuEnable()->SetCurrentMode(IDS_M_SL_JUNGLE1);
	 GetACCMenuEnable()->SlotsJungle1 = false;
	 return PModeWin;
  }
//  if (modename == strSlotsJungle2)
  if (ModeIndex == miSlotsJungle2)
  {
	 PModeWin = new TJungle2ModeWin(modename,GetOgleApp()->PMasterPalette);
	 GetACCMenuEnable()->SetCurrentMode(IDS_M_SL_JUNGLE2);
	 GetACCMenuEnable()->SlotsJungle2 = false;
	 return PModeWin;
  }
//  if (modename == strSlotsJungle100)
  if (ModeIndex == miSlotsJungle100)
  {
	 PModeWin = new TJungle100ModeWin(modename,GetOgleApp()->PMasterPalette);
	 GetACCMenuEnable()->SetCurrentMode(IDS_M_SL_JUNGLE100);
	 GetACCMenuEnable()->SlotsJungle100 = false;
	 return PModeWin;
  }
//  if (modename == strKeno)
  if (ModeIndex == miKeno)
  {
	 PModeWin = new TK1ModeWin(modename,GetOgleApp()->PMasterPalette);
	 GetACCMenuEnable()->SetCurrentMode(IDS_M_KENO);
	 GetACCMenuEnable()->Keno = false;
	 return PModeWin;
  }

  // mrp - v2.5 - 09/23/99 - the following vp stuff should be last
//  int16 vpids = 0;
  int16 vpsgt = 0;
  int16 vpdenom = TMoney::did_1_00;

  if (ModeIndex == miVPJWild1)
  {
    vpsgt = cvpJokersWild;
    vpdenom = TMoney::did_1_00;
	 GetACCMenuEnable()->SetCurrentMode(IDS_M_VP_JW1);
	 GetACCMenuEnable()->VPJWild1 = false;
  }
  if (ModeIndex == miVPJWild5)
  {
    vpsgt = cvpJokersWild;
    vpdenom = TMoney::did_5_00;
	 GetACCMenuEnable()->SetCurrentMode(IDS_M_VP_JW5);
	 GetACCMenuEnable()->VPJWild5 = false;
  }
  if (ModeIndex == miVPJWild25)
  {
    vpsgt = cvpJokersWild;
    vpdenom = TMoney::did_25_00;
	 GetACCMenuEnable()->SetCurrentMode(IDS_M_VP_JW25);
	 GetACCMenuEnable()->VPJWild25 = false;
  }
  if (ModeIndex == miVPJWild100)
  {
    vpsgt = cvpJokersWild;
    vpdenom = TMoney::did_100_00;
	 GetACCMenuEnable()->SetCurrentMode(IDS_M_VP_JW100);
	 GetACCMenuEnable()->VPJWild100 = false;
  }
  if (ModeIndex == miVPDWild1)
  {
    vpsgt = cvpDeucesWild;
    vpdenom = TMoney::did_1_00;
	 GetACCMenuEnable()->SetCurrentMode(IDS_M_VP_DW1);
	 GetACCMenuEnable()->VPDWild1 = false;
  }
  if (ModeIndex == miVPDWild5)
  {
    vpsgt = cvpDeucesWild;
    vpdenom = TMoney::did_5_00;
	 GetACCMenuEnable()->SetCurrentMode(IDS_M_VP_DW5);
	 GetACCMenuEnable()->VPDWild5 = false;
  }
  if (ModeIndex == miVPDWild25)
  {
    vpsgt = cvpDeucesWild;
    vpdenom = TMoney::did_25_00;
	 GetACCMenuEnable()->SetCurrentMode(IDS_M_VP_DW25);
	 GetACCMenuEnable()->VPDWild25 = false;
  }
  if (ModeIndex == miVPDWild100)
  {
    vpsgt = cvpDeucesWild;
    vpdenom = TMoney::did_100_00;
	 GetACCMenuEnable()->SetCurrentMode(IDS_M_VP_DW100);
	 GetACCMenuEnable()->VPDWild100 = false;
  }
  if (ModeIndex == miVPTen1)
  {
    vpsgt = cvpTensOrBetter;
    vpdenom = TMoney::did_1_00;
	 GetACCMenuEnable()->SetCurrentMode(IDS_M_VP_TB1);
	 GetACCMenuEnable()->VPTen1 = false;
  }
  if (ModeIndex == miVPTen5)
  {
    vpsgt = cvpTensOrBetter;
    vpdenom = TMoney::did_5_00;
	 GetACCMenuEnable()->SetCurrentMode(IDS_M_VP_TB5);
	 GetACCMenuEnable()->VPTen5 = false;
  }
  if (ModeIndex == miVPTen25)
  {
    vpsgt = cvpTensOrBetter;
    vpdenom = TMoney::did_25_00;
	 GetACCMenuEnable()->SetCurrentMode(IDS_M_VP_TB25);
	 GetACCMenuEnable()->VPTen25 = false;
  }
  if (ModeIndex == miVPTen100)
  {
    vpsgt = cvpTensOrBetter;
    vpdenom = TMoney::did_100_00;
	 GetACCMenuEnable()->SetCurrentMode(IDS_M_VP_TB100);
	 GetACCMenuEnable()->VPTen100 = false;
  }
  if (ModeIndex == miVPJack1)
  {
    vpsgt = cvpJacksOrBetter;
    vpdenom = TMoney::did_1_00;
	 GetACCMenuEnable()->SetCurrentMode(IDS_M_VP_JB1);
	 GetACCMenuEnable()->VPJack1 = false;
  }
  if (ModeIndex == miVPJack5)
  {
    vpsgt = cvpJacksOrBetter;
    vpdenom = TMoney::did_5_00;
	 GetACCMenuEnable()->SetCurrentMode(IDS_M_VP_JB5);
	 GetACCMenuEnable()->VPJack5 = false;
  }
  if (ModeIndex == miVPJack100)
  {
    vpsgt = cvpJacksOrBetter;
    vpdenom = TMoney::did_100_00;
	 GetACCMenuEnable()->SetCurrentMode(IDS_M_VP_JB100);
	 GetACCMenuEnable()->VPJack100 = false;
  }
  if (ModeIndex == miVPJack25)
  {
    vpsgt = cvpJacksOrBetter;
    vpdenom = TMoney::did_25_00;
	 GetACCMenuEnable()->SetCurrentMode(IDS_M_VP_JB25);
	 GetACCMenuEnable()->VPJack25 = false;
  }
  if (ModeIndex == miVPJack1P)
  {
    vpsgt = cvpJacksProgressive;
    vpdenom = TMoney::did_1_00;
	 GetACCMenuEnable()->SetCurrentMode(IDS_M_VP_JB1P);
	 GetACCMenuEnable()->VPJack1P = false;
  }
  if (vpsgt > 0)
  {
    PModeWin = new TACCVPModeWin(modename,
                                 GetOgleApp()->PMasterPalette,
                                 vpsgt,
                                 vpdenom);
    return PModeWin;
  }

  ::MessageBox(NULL,"Default Mode Window Created","Create Mode Window",MB_OK | MB_TASKMODAL);
  PModeWin = new TCasinoModeWin(modename,GetOgleApp()->PMasterPalette,string("Default Casino ModeWin"));
  GetACCMenuEnable()->SetCurrentMode(-1);
  return PModeWin;
}
//*******************************************************************

