//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  casapp.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     9/14/95    M.Perry     original baseline
//  2.0    08/31/97    M.Perry     32-bit conversion.
//  2.3    07/14/99    M.Perry    retrofit to Ogle
//********************************************************************
#include "casapp.h"
#include "casnames.rh"
#include "cgametyp.h"
#include "ogame.h"
//*******************************************************************
void TCasinoApp::GetAppInfo(TOgleAppInfo &appinfo)
{
  TOgleApp::GetAppInfo(appinfo);

  appinfo.MainTitle = "Casino's Frame Window";
}
//*******************************************************************
int16 TCasinoApp::GetAppType()
{
  return catCasino;
}
//*******************************************************************
void TCasinoApp::CreateIniFile()
{
  PIniFile = new TCasinoIniFile(HDDrive,HDDir,AppName);
}
//*******************************************************************
string TCasinoApp::GetDetName()
{
  string s = AppName;
  s += ".det";
  return s;
}
//*******************************************************************
TCasinoApp::TCasinoApp(string NewHDDrive,string NewHDDir,string NewAppName)
:TOgleApp(NewHDDrive,NewHDDir,NewAppName)
{
}
//*******************************************************************
TCasinoApp::~TCasinoApp()
{
}
//*******************************************************************
TOgleGameFrameWindow *TCasinoApp::CreateGameFrameWindow()
{
  TOgleAppInfo appinfo;
  GetAppInfo(appinfo);
  return (new TCasinoGameFrameWindow(this,appinfo.MainTitle.c_str(),true,false));
}
//*******************************************************************
void TCasinoApp::CreateGameFile()
{
  GameFileName = LoadString(IDS_G_CASINO);
  PGame = new TOgleGame(GameFileName);
}
//*******************************************************************

