//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  bjlord.cpp
//    Project Name:  Ogle
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     08/2/95   A. Krist    Original baseline
//  1.01    10/4/95   A. Krist    "windowize"
//*******************************************************************
#include "bjlord.h"
#include "bjlordst.h"
#include "bjlordmst.h"
#include "ostate.h"
#include <time.h>   //To Set Random Number Generator
#include "bjdeck.h"
#define  NUMBEROFPLAYERS 3
#define  BET1  5
#include <iostream.h>
#include <stdlib.h> //For Random Number Generator
#include <conio.h>
#include "cbjglspl.h"
#include "casbjmw.h"
#include "cassbsp.h"
//#include "cbjdlrsp.h"
#include "oskitcat.h"
#include "bjgobj.h"
//*******************************************************************
BOOL TBJLord::Respond(TResponder &responder)
{
  if (PState == NULL) {return TRUE;}

  switch (responder.GetID())
  {
	 case idBetSpot1           :  return (((TBJLordState *)PState)->BetSpot1(responder));
	 case idBetSpot2           :  return (((TBJLordState *)PState)->BetSpot2(responder));
	 case idBetSpot3           :  return (((TBJLordState *)PState)->BetSpot3(responder));

	 case idOneChip            :  return (((TBJLordState *)PState)->OneChip(responder));
	 case idFiveChip           :  return (((TBJLordState *)PState)->FiveChip(responder));
	 case idTwentyFiveChip     :  return (((TBJLordState *)PState)->TwentyFiveChip(responder));
	 case idOneHundredChip     :  return (((TBJLordState *)PState)->OneHundredChip(responder));
	 case idOneThouChip        :  return (((TBJLordState *)PState)->OneThouChip(responder));
	 case idTenThouChip        :  return (((TBJLordState *)PState)->TenThouChip(responder));

	 case idRemoveDouble       :  return (((TBJLordState *)PState)->RemoveDouble(responder));
	 case idClearNoInsureStand :  return (((TBJLordState *)PState)->ClearNoInsureStand(responder));
	 case idSameYesInsureHit   :  return (((TBJLordState *)PState)->SameYesInsureHit(responder));
	 case idDealSplit          :  return (((TBJLordState *)PState)->DealSplit(responder));

	 case idAskExpert          :  return (((TBJLordState *)PState)->AskExpert(responder));
	 default                   :  return TRUE;
  }
}
//*******************************************************************
void TBJLord::SetupResponders()
{
  Responders[0]  = new TResponder(100,TRect(473,396,569,428),idBetSpot1          ,this,TRUE,'a');
  Responders[1]  = new TResponder(100,TRect(282,398,359,427),idBetSpot2          ,this,TRUE,'b');
  Responders[2]  = new TResponder(100,TRect(69,393,169,428) ,idBetSpot3          ,this,TRUE,'c');
  Responders[3]  = new TResponder(100,TRect(394,431,424,463),idOneChip           ,this,TRUE,'1');
  Responders[4]  = new TResponder(100,TRect(358,431,390,463),idFiveChip          ,this,TRUE,'2');
  Responders[5]  = new TResponder(100,TRect(323,431,354,463),idTwentyFiveChip    ,this,TRUE,'3');
  Responders[6]  = new TResponder(100,TRect(288,431,320,463),idOneHundredChip    ,this,TRUE,'4');
  Responders[7]  = new TResponder(100,TRect(253,431,285,463),idOneThouChip       ,this,TRUE,'5');
  Responders[8]  = new TResponder(100,TRect(219,431,250,463),idTenThouChip       ,this,TRUE,'6');
  Responders[9]  = new TResponder(100,TRect(60,434,132,477) ,idRemoveDouble      ,this,TRUE,'r');
  Responders[9]  = new TResponder(100,TRect(137,434,208,477),idClearNoInsureStand,this,TRUE,'k');
  Responders[9]  = new TResponder(100,TRect(432,434,502,476),idSameYesInsureHit  ,this,TRUE,'s');
  Responders[9]  = new TResponder(100,TRect(508,434,582,476),idDealSplit         ,this,TRUE,'d');
  Responders[10] = new TResponder(100,TRect(590,434,636,476),idAskExpert         ,this,TRUE);
}
//*******************************************************************
TSpriteList *TBJLord::CreateSpriteList(TFileMode splfm)
{
  return (new TBJGLordSpriteList(splfm,this));
}
//*******************************************************************
void TBJLord::SetupSprites()
{
  Dealer            = NULL;
  DealerSpot        = NULL;
  BetSpot[0]        = NULL;
  BetSpot[1]        = NULL;
  BetSpot[2]        = NULL;
  BetSpot[3]        = NULL;
  BetSpot[4]        = NULL;
  BetSpot[5]        = NULL;
  BetSpot[6]        = NULL;

  RemoveDouble       = NULL;
  ClearNoInsureStand = NULL;
  SameYesInsureHit   = NULL;
  DealSplit          = NULL;
  Chips              = NULL;
  CasStatusBar       = NULL;

 // Dealer             = (TBJDealer  *)            GetSpritePtr(BJDealer);
 // DealerSpot         = (TBJDealer  *)            GetSpritePtr(BJDealer);
 // BetSpot[0]         = (TBJBetSpot *)            GetSpritePtr(BJBetSpot0);
  BetSpot[1]         = (TBJBetSpot *)            GetSpritePtr(BJBetSpot1);
  BetSpot[2]         = (TBJBetSpot *)            GetSpritePtr(BJBetSpot2);
  BetSpot[3]         = (TBJBetSpot *)            GetSpritePtr(BJBetSpot3);
//  BetSpot[4]         = (TBJBetSpot *)            GetSpritePtr(BJBetSpot4);
//  BetSpot[5]         = (TBJBetSpot *)            GetSpritePtr(BJBetSpot5);
//  BetSpot[6]         = (TBJBetSpot *)            GetSpritePtr(BJBetSpot6);

  RemoveDouble       = (TBJRemoveDouble       *) GetSpritePtr(BJRemoveDouble);
  ClearNoInsureStand = (TBJClearNoInsureStand *) GetSpritePtr(BJClearNoInsureStand);
  SameYesInsureHit   = (TBJSameYesInsureHit   *) GetSpritePtr(BJSameYesInsureHit);
  DealSplit          = (TBJDealSplit          *) GetSpritePtr(BJDealSplit);

//  CasStatusBar       = (TCasStatusBar *)         GetSpritePtr(CasStatusBar);// change in casnames
  Chips              = (TBJChips      *)         GetSpritePtr(BJChips);

 // if (CardSprites[0] == NULL) {SpriteError("Card Sprite 1",BJCard1);}
//  if (CardSprites[1] == NULL) {SpriteError("Card Sprite 2",BJCard2);}
//  if (CardSprites[2] == NULL) {SpriteError("Card Sprite 3",BJCard3);}
//  if (CardSprites[3] == NULL) {SpriteError("Card Sprite 4",BJCard4);}
//  if (CardSprites[4] == NULL) {SpriteError("Card Sprite 5",BJCard5);}
  if (BetSpot[0] == NULL)         {SpriteError("Bet Spot 1",        BJBetSpot1);}
  if (BetSpot[1] == NULL)         {SpriteError("Bet Spot 2",        BJBetSpot2);}
  if (BetSpot[2] == NULL)         {SpriteError("Bet Spot 3",        BJBetSpot3);}
  if (RemoveDouble == NULL)       {SpriteError("RemoveDouble",      BJRemoveDouble);}
  if (ClearNoInsureStand == NULL) {SpriteError("ClearNoInsureStand",BJClearNoInsureStand);}
  if (SameYesInsureHit == NULL)   {SpriteError("SameYesInsureHit",  BJSameYesInsureHit);}
  if (DealSplit == NULL)          {SpriteError("DealSplit",         BJDealSplit);}
  if (Chips == NULL)              {SpriteError("Chip Stacks",       BJChips);}
 // if (CasStatusBar == NULL)          {SpriteError("CasStatusBar",         BJBetAmount);}

  ActivateSpriteNow(Dealer);
  ActivateSpriteNow(DealerSpot);
  ActivateSpriteNow(BetSpot[0]);
  ActivateSpriteNow(BetSpot[1]);
  ActivateSpriteNow(BetSpot[2]);
  ActivateSpriteNow(BetSpot[3]);
  ActivateSpriteNow(BetSpot[4]);
  ActivateSpriteNow(BetSpot[5]);
  ActivateSpriteNow(BetSpot[6]);
  ActivateSpriteNow(RemoveDouble);
  ActivateSpriteNow(ClearNoInsureStand);
  ActivateSpriteNow(SameYesInsureHit);
  ActivateSpriteNow(DealSplit);
  ActivateSpriteNow(Chips);
  ActivateSpriteNow(CasStatusBar);
//  for (int j=0;j<5;j++)
//  {
//	 ActivateSpriteNow(CardSprites[j]);
//  }

}
//*******************************************************************
void TBJLord::CleanupSprites()
{
  //CoinsPlayed->NoShow();
}
//*******************************************************************
TBJLord::TBJLord(TBJModeWin *pmwin,TFileMode NewFileMode,int gametype,int coindenom)
  :TGameObject(TRUE,pmwin,NewFileMode)
{
  TFileMode splfm(SpriteListName,fm_HD_Immed,fm_Ram_Immed,FileMode.DirIndex);
  AddElement(CreateSpriteList(splfm));

  TFileMode skcfm(SkitCatName,fm_HD_Immed,fm_Ram_Immed,FileMode.DirIndex);
  AddElement(CreateSkitCat(skcfm));

  TCasStatusBar  Status();
  int i=0;
  pState   = new TBJLordMainState(this);
  pDeck    = new TBJDeck;
  pSmarts  = new TBJSmarts;
  pHand    = new TBJHand;

  numofdecks       = gametype;
  ((TBJDeck *)pDeck)->InitDeck(numofdecks);
  for(i=0;i<7;i++)
  {
	 BetSpotUse[i] = -1;
  }
  pMWin            = pmwin;
  pDeck->Shuffler(numofdecks );
  maxbet           = 3;
  credits          = 0;
  coinsize         = coindenom;
  activeplayer     = 0;
  machinenum       = 0;
  playersin        = 1;
  game             = gametype;
  coinsplayed      = 0;
  totaldecks       = 1;
  halfdecksplayed  = 0;
  halfdecksleft    = 0;
  truecount        = 0;
  runningcount     = 0;
  acecount         = 0;
  cardsplayed      = 0;
  newdeal          = 0;
  decksflag        = 0;
  newdeckcount     = DECK;

  SetupResponders();

  SetupSprites();
}
//*******************************************************************
TBJLord::~TBJLord()
{
  if(pState != NULL)
  {
	 delete pState;
	 pState = NULL;
  }
  if(pSmarts != NULL)
  {
	 delete pSmarts;
	 pSmarts = NULL;
  }
  if(pDeck != NULL)
  {
	 delete pDeck;
	 pDeck = NULL;
  }
  CleanupResponders();
}
//*******************************************************************
TBJLord::DoubleDown(int x)
{
  switch(x) {
  case 0:   pMWin->GObj[BetSpotUse[0]]->cash -= pMWin->GObj[BetSpotUse[0]]->coinsplayedhand0;
				pMWin->GObj[BetSpotUse[0]]->coinsplayedhand0 += pMWin->GObj[BetSpotUse[0]]->coinsplayedhand0;
				((TBJDeck *)pDeck)->Draw(pMWin->GObj[BetSpotUse[0]]->pHand0,pMWin);break;
  case 1:   pMWin->GObj[BetSpotUse[1]]->cash -= pMWin->GObj[BetSpotUse[1]]->coinsplayedhand1;
				pMWin->GObj[BetSpotUse[1]]->coinsplayedhand1 += pMWin->GObj[BetSpotUse[1]]->coinsplayedhand1;
				((TBJDeck *)pDeck)->Draw(pMWin->GObj[BetSpotUse[1]]->pHand1,pMWin);break;
  case 2:   pMWin->GObj[BetSpotUse[2]]->cash -= pMWin->GObj[BetSpotUse[2]]->coinsplayedhand2;
				pMWin->GObj[BetSpotUse[2]]->coinsplayedhand2 += pMWin->GObj[BetSpotUse[2]]->coinsplayedhand2;
				((TBJDeck *)pDeck)->Draw(pMWin->GObj[BetSpotUse[2]]->pHand2,pMWin);break;
  case 3:   pMWin->GObj[BetSpotUse[3]]->cash -= pMWin->GObj[BetSpotUse[3]]->coinsplayedhand3;
				pMWin->GObj[BetSpotUse[3]]->coinsplayedhand3 += pMWin->GObj[BetSpotUse[3]]->coinsplayedhand3;
				((TBJDeck *)pDeck)->Draw(pMWin->GObj[BetSpotUse[3]]->pHand3,pMWin);break;
  case 4:   pMWin->GObj[BetSpotUse[4]]->cash -= pMWin->GObj[BetSpotUse[4]]->coinsplayedhand4;
				pMWin->GObj[BetSpotUse[4]]->coinsplayedhand4 += pMWin->GObj[BetSpotUse[4]]->coinsplayedhand4;
				((TBJDeck *)pDeck)->Draw(pMWin->GObj[BetSpotUse[4]]->pHand4,pMWin);break;
  case 5:   pMWin->GObj[BetSpotUse[5]]->cash -= pMWin->GObj[BetSpotUse[5]]->coinsplayedhand5;
				pMWin->GObj[BetSpotUse[5]]->coinsplayedhand5 += pMWin->GObj[BetSpotUse[5]]->coinsplayedhand5;
				((TBJDeck *)pDeck)->Draw(pMWin->GObj[BetSpotUse[5]]->pHand5,pMWin);break;
  case 6:   pMWin->GObj[BetSpotUse[6]]->cash -= pMWin->GObj[BetSpotUse[6]]->coinsplayedhand6;
				pMWin->GObj[BetSpotUse[6]]->coinsplayedhand6 += pMWin->GObj[BetSpotUse[6]]->coinsplayedhand6;
				((TBJDeck *)pDeck)->Draw(pMWin->GObj[BetSpotUse[6]]->pHand6,pMWin);break;
  default : break;
  }
  return 1;
}
//*******************************************************************
TBJLord::SwitchDecks()
{
//  int x=0;
//  cout << "How many decks(1,2,4,6)-> ";
//  cin >> x;
//  if(x*52 == numofdecks)
//  {
//	 cout << "That is the current setting->Dipshit->" << endl;
//	 return 0;
//  }
  switch(game) {
	case 1 : newdeckcount = DECK;
	case 2 : newdeckcount = DECK2;
	case 4 : newdeckcount = DECK4;
	case 6 : newdeckcount = DECK6;
  }
  decksflag = 1;
  newdeal   = 1;
}
//*******************************************************************
TBJLord::Count(TCard *card)
{
  if(card->name > Nine && card->name < AceHi)
  {
	 runningcount --;
  }
  else
  {
	 if(card->name > Two && card->name < Seven)
	 {
		runningcount++;
	 }
  }
  if(card->name == AceHi)
  {
	 acecount++;
  }
  cardsplayed++;
  halfdecksplayed = cardsplayed/26;
  if(cardsplayed%26 > 13)
  {
	halfdecksplayed++;
  }
  halfdecksleft = (totaldecks*2) - halfdecksplayed;
  if(halfdecksleft == 0){halfdecksleft++;}
  truecount = runningcount/halfdecksleft;
//  cout << "HDLeft-> " << halfdecksleft;
//  cout << " HDplayed-> " << halfdecksplayed;
//  cout << " delt-> " << cardsplayed;
//  cout << " Run-> " << runningcount;
//  cout << " True-> " << truecount << endl;
  return 1;
}
//*******************************************************************
TBJLord::Clear()
{
  int i=0;
  for(i=0;i<3;i++)
  {
	 pMWin->GObj[i]->coinsplayedhand0 = 0;
	 pMWin->GObj[i]->coinsplayedhand1 = 0;
	 pMWin->GObj[i]->coinsplayedhand2 = 0;
	 pMWin->GObj[i]->coinsplayedhand3 = 0;
	 pMWin->GObj[i]->coinsplayedhand4 = 0;
	 pMWin->GObj[i]->coinsplayedhand5 = 0;
	 pMWin->GObj[i]->coinsplayedhand6 = 0;
	 if(pMWin->GObj[i]->pHand0 != NULL)
	 {
		delete pMWin->GObj[i]->pHand0;
		pMWin->GObj[i]->pHand0 = NULL;
	 }
	 if(pMWin->GObj[i]->pHand1 != NULL)
	 {
		delete pMWin->GObj[i]->pHand1;
		pMWin->GObj[i]->pHand1 = NULL;
	 }
	 if(pMWin->GObj[i]->pHand2 != NULL)
	 {
		delete pMWin->GObj[i]->pHand2;
		pMWin->GObj[i]->pHand2 = NULL;
	 }
	 if(pMWin->GObj[i]->pHand3 != NULL)
	 {
		delete pMWin->GObj[i]->pHand3;
		pMWin->GObj[i]->pHand3 = NULL;
	 }
	 if(pMWin->GObj[i]->pHand4 != NULL)
	 {
		delete pMWin->GObj[i]->pHand4;
		pMWin->GObj[i]->pHand4 = NULL;
	 }
	 if(pMWin->GObj[i]->pHand5 != NULL)
	 {
		delete pMWin->GObj[i]->pHand5;
		pMWin->GObj[i]->pHand5 = NULL;
	 }
	 if(pMWin->GObj[i]->pHand6 != NULL)
	 {
		delete pMWin->GObj[i]->pHand6;
		pMWin->GObj[i]->pHand6 = NULL;
	 }
	 pMWin->GObj[i]->numsplitshand1 = 0;
	 pMWin->GObj[i]->numsplitshand3 = 0;
	 pMWin->GObj[i]->numsplitshand5 = 0;
  }
  for(i=0;i<7;i++)
  {
	 BetSpotUse[i] = -1;
  }
  pHand->inhand   = 0;
  pHand->highhand = 0;
  pHand->bj       = 0;
  activeplayer    = 0;
  playersin       = 1;
  coinsplayed     = 0;
  //cout << "top-> " << pDeck->top;
 // cout << "Decks-> " << numofdecks << endl;
  if(pDeck->top >= (numofdecks - 31))
  {
	 newdeal =1;         //check it bonehead
  }
  if(newdeal)
  {
	 if(decksflag)
	 {
		numofdecks = newdeckcount;
		((TBJDeck *)pDeck)->ChangeDecks(numofdecks);
		decksflag = 0;
		totaldecks = numofdecks/52;
	 }
	 ((TBJDeck *)pDeck)->Shuffler(numofdecks);
	 runningcount    = 0;
	 truecount       = 0;
	 halfdecksleft   = 0;
	 halfdecksplayed = 0;
	 cardsplayed     = 0;
	 acecount        = 0;
	 newdeal         = 0;
	 ((TBJDeck *)pDeck)->top   = 0;
  }
//  cout << "top-> " << pDeck->top << endl;
  return 1;
}
//*******************************************************************
TBJLord::PlaceBet(int x)
{
 // int x=0;

 // cout << "Place bet on spot 1,3,or 5? " << endl;
//  cin >> x;
  if(BetSpotUse[x] == -1 || BetSpotUse[x] == activeplayer)
  {
    pMWin->GObj[activeplayer]->lastbet = coinsplayed;
	 if(x == 1)
	 {
		pMWin->GObj[activeplayer]->pHand1 = new TBJHand;
		pMWin->GObj[activeplayer]->coinsplayedhand1 += coinsplayed;
		coinsplayed = 0;
		BetSpotUse[x] = activeplayer;
	 }
	 if(x == 3)
	 {
		pMWin->GObj[activeplayer]->pHand3 = new TBJHand;
		pMWin->GObj[activeplayer]->coinsplayedhand3 += coinsplayed;
		coinsplayed = 0;
		BetSpotUse[x] = activeplayer;
	 }
	 if(x == 5)
	 {
		pMWin->GObj[activeplayer]->pHand5 = new TBJHand;
		pMWin->GObj[activeplayer]->coinsplayedhand5 += coinsplayed;
		coinsplayed = 0;
		BetSpotUse[x] = activeplayer;
	 }
  }
  else
  {
	// cout << "Spot in use " << endl;
	 return 0;
  }
  return 1;
}
//*******************************************************************
TBJLord::RemoveBet(int x)
{
  if(BetSpotUse[x] > -1 && BetSpotUse[x] == activeplayer)
  {
	 if(x == 1)
	 {
		delete pMWin->GObj[activeplayer]->pHand1;
		pMWin->GObj[activeplayer]->cash += pMWin->GObj[activeplayer]->coinsplayedhand1;
		pMWin->GObj[activeplayer]->coinsplayedhand1 = 0;
		BetSpotUse[x] = -1;
		pMWin->GObj[activeplayer]->pHand1 = NULL;
	 }
	 if(x == 3)
	 {
		delete pMWin->GObj[activeplayer]->pHand3;
		pMWin->GObj[activeplayer]->cash += pMWin->GObj[activeplayer]->coinsplayedhand3;
		pMWin->GObj[activeplayer]->coinsplayedhand3 = 0;
		BetSpotUse[x] = -1;
		pMWin->GObj[activeplayer]->pHand3 = NULL;
	 }
	 if(x == 5)
	 {
		delete pMWin->GObj[activeplayer]->pHand5;
		pMWin->GObj[activeplayer]->cash += pMWin->GObj[activeplayer]->coinsplayedhand5;
		pMWin->GObj[activeplayer]->coinsplayedhand5 = 0;
		BetSpotUse[x] = -1;
		pMWin->GObj[activeplayer]->pHand5 = NULL;
	 }
  }
  else
  {
	 return 0;
  }
  return 1;
}
//*******************************************************************
TBJLord::Winner()
{
  winnerpaid = 0;
  if(pMWin->GObj[BetSpotUse[0]]->pHand0 != NULL && BetSpotUse[0] != -1)
  {
  //	 ((TBJDeck*)pDeck)->ShowHand(pMWin->GObj[BetSpotUse[0]]->pHand0);
 //	 cout << "Total-> " << pMWin->GObj[BetSpotUse[0]]->pHand0->highhand << endl;
	 if(pMWin->GObj[BetSpotUse[0]]->pHand0->highhand > pHand->highhand ||
		 pHand->highhand > 21)
	 {
		pMWin->GObj[BetSpotUse[0]]->cash += (pMWin->GObj[BetSpotUse[0]]->coinsplayedhand0)*2;
	  //	cout << "Hand0->.-> WINNER!!!" << endl;
	 }
	 else
	 {
		if(pMWin->GObj[BetSpotUse[0]]->pHand0->highhand == pHand->highhand)
		{
		  pMWin->GObj[BetSpotUse[0]]->cash += pMWin->GObj[BetSpotUse[0]]->coinsplayedhand0;
		 // cout << "Hand0->.-> PUSH->" << endl;
		}
		else
		{
		 // cout << "Hand0->.-> LOSER,LOSER->LOSER LOSER LOSER,LueWHOsir!!!->" << endl;
		}
	 }
  }
  if(pMWin->GObj[BetSpotUse[1]]->pHand1 != NULL && BetSpotUse[1] != -1)
  {
	// ((TBJDeck*)pDeck)->ShowHand(pMWin->GObj[BetSpotUse[1]]->pHand1);
	// cout << "Total-> " << pMWin->GObj[BetSpotUse[1]]->pHand1->highhand << endl;

	 if(pMWin->GObj[BetSpotUse[1]]->pHand1->highhand > pHand->highhand ||
		 pHand->highhand > 21)
	 {
		pMWin->GObj[BetSpotUse[1]]->cash += (pMWin->GObj[BetSpotUse[1]]->coinsplayedhand1)*2;
	 //	cout << "Hand1->.-> WINNER!!!" << endl;
	 }
	 else
	 {
		if(pMWin->GObj[BetSpotUse[1]]->pHand1->highhand == pHand->highhand)
		{
		  pMWin->GObj[BetSpotUse[1]]->cash += pMWin->GObj[BetSpotUse[1]]->coinsplayedhand1;
	  //	  cout << "Hand1->.-> PUSH->" << endl;
		}
		else
		{
		 // cout << "Hand1->.-> LOSER,LOSER->LOSER LOSER LOSER,LueWHOsir!!!->" << endl;
		}
	 }
  }
  if(pMWin->GObj[BetSpotUse[2]]->pHand2 != NULL && BetSpotUse[2] != -1)
  {
	// ((TBJDeck*)pDeck)->ShowHand(pMWin->GObj[BetSpotUse[2]]->pHand2);
	// cout << "Total-> " << pMWin->GObj[BetSpotUse[2]]->pHand2->highhand << endl;

	 if(pMWin->GObj[BetSpotUse[2]]->pHand2->highhand > pHand->highhand ||
		 pHand->highhand > 21)
	 {
		pMWin->GObj[BetSpotUse[2]]->cash += (pMWin->GObj[BetSpotUse[2]]->coinsplayedhand2)*2;
		//cout << "Hand2->.-> WINNER!!!" << endl;
	 }
	 else
	 {
		if(pMWin->GObj[BetSpotUse[2]]->pHand2->highhand == pHand->highhand)
		{
		  pMWin->GObj[BetSpotUse[2]]->cash += pMWin->GObj[BetSpotUse[2]]->coinsplayedhand2;
		//  cout << "Hand2->.-> PUSH->" << endl;
		}
		else
		{
		 // cout << "Hand2->.-> LOSER,LOSER->LOSER LOSER LOSER,LueWHOsir!!!->" << endl;
		}
	 }
  }
  if(pMWin->GObj[BetSpotUse[3]]->pHand3 != NULL && BetSpotUse[3] != -1)
  {
	 //((TBJDeck*)pDeck)->ShowHand(pMWin->GObj[BetSpotUse[3]]->pHand3);
	// cout << "Total-> " << pMWin->GObj[BetSpotUse[3]]->pHand3->highhand << endl;

	 if(pMWin->GObj[BetSpotUse[3]]->pHand3->highhand > pHand->highhand ||
		 pHand->highhand > 21)
	 {
		pMWin->GObj[BetSpotUse[3]]->cash += (pMWin->GObj[BetSpotUse[3]]->coinsplayedhand3)*2;
		//cout << "Hand3->.-> WINNER!!!" << endl;
	 }
	 else
	 {
		if(pMWin->GObj[BetSpotUse[3]]->pHand3->highhand == pHand->highhand)
		{
		  pMWin->GObj[BetSpotUse[3]]->cash += pMWin->GObj[BetSpotUse[3]]->coinsplayedhand3;
		  //cout << "Hand3->.-> PUSH->" << endl;
		}
		else
		{
		 // cout << "Hand3->.-> LOSER,LOSER->LOSER LOSER LOSER,LueWHOsir!!!->" << endl;
		}
	 }
  }
  if(pMWin->GObj[BetSpotUse[4]]->pHand4 != NULL && BetSpotUse[4] != -1)
  {
	// ((TBJDeck*)pDeck)->ShowHand(pMWin->GObj[BetSpotUse[4]]->pHand4);
	// cout << "Total-> " << pMWin->GObj[BetSpotUse[4]]->pHand4->highhand << endl;

	 if(pMWin->GObj[BetSpotUse[4]]->pHand4->highhand > pHand->highhand ||
		 pHand->highhand > 21)
	 {
		pMWin->GObj[BetSpotUse[4]]->cash += (pMWin->GObj[BetSpotUse[4]]->coinsplayedhand4)*2;
	  //	cout << "Hand4->.-> WINNER!!!" << endl;
	 }
	 else
	 {
		if(pMWin->GObj[BetSpotUse[4]]->pHand4->highhand == pHand->highhand)
		{
		  pMWin->GObj[BetSpotUse[4]]->cash += pMWin->GObj[BetSpotUse[4]]->coinsplayedhand4;
		 // cout << "Hand4->.-> PUSH->" << endl;
		}
		else
		{
		  //cout << "Hand4->.-> LOSER,LOSER->LOSER LOSER LOSER,LueWHOsir!!!->" << endl;
		}
	 }
  }
  if(pMWin->GObj[BetSpotUse[5]]->pHand5 != NULL && BetSpotUse[5] != -1)
  {
	// ((TBJDeck*)pDeck)->ShowHand(pMWin->GObj[BetSpotUse[5]]->pHand5);
  //	 cout << "Total-> " << pMWin->GObj[BetSpotUse[5]]->pHand5->highhand << endl;

	 if(pMWin->GObj[BetSpotUse[5]]->pHand5->highhand > pHand->highhand ||
		 pHand->highhand > 21)
	 {
		pMWin->GObj[BetSpotUse[5]]->cash += (pMWin->GObj[BetSpotUse[5]]->coinsplayedhand5)*2;
	  //	cout << "Hand5->.-> WINNER!!!" << endl;
	 }
	 else
	 {
		if(pMWin->GObj[BetSpotUse[5]]->pHand5->highhand == pHand->highhand)
		{
		  pMWin->GObj[BetSpotUse[5]]->cash += pMWin->GObj[BetSpotUse[5]]->coinsplayedhand5;
	  //	  cout << "Hand5->.-> PUSH->" << endl;
		}
		else
		{
		  //cout << "Hand5->.-> LOSER,LOSER->LOSER LOSER LOSER,LueWHOsir!!!->" << endl;
		}
	 }
  }
  if(pMWin->GObj[BetSpotUse[6]]->pHand6 != NULL && BetSpotUse[6] != -1)
  {
	// ((TBJDeck*)pDeck)->ShowHand(pMWin->GObj[BetSpotUse[6]]->pHand6);
	// cout << "Total-> " << pMWin->GObj[BetSpotUse[6]]->pHand6->highhand << endl;

	 if(pMWin->GObj[BetSpotUse[6]]->pHand6->highhand > pHand->highhand ||
	    pHand->highhand > 21)
	 {
		pMWin->GObj[BetSpotUse[6]]->cash += (pMWin->GObj[BetSpotUse[6]]->coinsplayedhand6)*2;
	 //	cout << "Hand6->.-> WINNER!!!" << endl;
	 }
	 else
	 {
		if(pMWin->GObj[BetSpotUse[6]]->pHand6->highhand == pHand->highhand)
		{
		  pMWin->GObj[BetSpotUse[6]]->cash += pMWin->GObj[BetSpotUse[6]]->coinsplayedhand6;
		//  cout << "Hand6... PUSH." << endl;
		}
		else
		{
		 // cout << "Hand6... LOSER,LOSER->LOSER LOSER LOSER,LueWHOsir!!!->" << endl;
		}
	 }
  }
 // ((TBJDeck*)pDeck)->ShowHand(pHand);
 //	 cout << "Total-> " << pHand->highhand << endl;
 // cout << "Player " << (activeplayer+1) << " you have " <<
			//  pMWin->GObj[activeplayer]->cash << " bucks->" << endl;
  return 1;
}// winner
//*******************************************************************
TBJLord::InitBJ()
{
  int i=0;
  for(i=0;i<NUMBEROFPLAYERS;i++)
  {
  }
  activeplayer = 0;
  credits = 0;
  coinsplayed = 0;
  winnerpaid = 0;
  return 1;
}
//*******************************************************************
TBJLord::BlackJack()
{
  if(pHand != NULL)
  {
	((TBJDeck *)pDeck)->BlackJack(pHand);
  }
  if(BetSpotUse[1] != -1)
  {
	((TBJDeck *)pDeck)->BlackJack(((TBJHand *)pMWin->GObj[BetSpotUse[1]]->pHand1));
  }
  if(BetSpotUse[3] != -1)
  {
	((TBJDeck *)pDeck)->BlackJack(((TBJHand *)pMWin->GObj[BetSpotUse[3]]->pHand3));
  }
  if(BetSpotUse[5] != -1)
  {
	((TBJDeck *)pDeck)->BlackJack(((TBJHand *)pMWin->GObj[BetSpotUse[5]]->pHand5));
  }

  if(pHand->bj == 1)
  {
	 if(BetSpotUse[1] != -1)
	 {
		if(pMWin->GObj[BetSpotUse[1]]->pHand1->insurance)
		{
		  pMWin->GObj[BetSpotUse[1]]->cash +=
			 (pMWin->GObj[BetSpotUse[1]]->pHand1->insurance * 2);
		 // cout << "Insurance payes 2 to 1 " << endl;
		}
		else
		{
		  pMWin->GObj[BetSpotUse[1]]->pHand1->insurance = 0; //remove insurance
		}
		if(((TBJHand *)pMWin->GObj[BetSpotUse[1]]->pHand1)->bj == 1)
		{
		  //cout << "Hand1->.-> Push " << endl;
		  pMWin->GObj[BetSpotUse[1]]->cash +=
		  pMWin->GObj[BetSpotUse[1]]->coinsplayedhand1; // Give money back
		  delete pMWin->GObj[BetSpotUse[1]]->pHand1;
		  pMWin->GObj[BetSpotUse[1]]->pHand1 = NULL;
		  BetSpotUse[1] = -1;
		}
		else
		{
		//  cout << "Hand1->.-> Loser " << endl;
		  pMWin->GObj[BetSpotUse[1]]->coinsplayedhand1 = 0;
        delete pMWin->GObj[BetSpotUse[1]]->pHand1;
		  pMWin->GObj[BetSpotUse[1]]->pHand1 = NULL;
		  BetSpotUse[1] = -1;
		}
	 }
	 if(BetSpotUse[3] != -1)
	 {
		if(pMWin->GObj[BetSpotUse[3]]->pHand3->insurance)
		{
		  pMWin->GObj[BetSpotUse[3]]->cash +=
			 (pMWin->GObj[BetSpotUse[3]]->pHand3->insurance * 2);
		//  cout << "Insurance payes 2 to 1 " << endl;
		}
		else
		{
		  pMWin->GObj[BetSpotUse[3]]->pHand3->insurance = 0; //remove insurance
		}
		if(((TBJHand *)pMWin->GObj[BetSpotUse[3]]->pHand3)->bj == 1)
		{
		 // cout << "Hand3->.-> Push " << endl;
		  pMWin->GObj[BetSpotUse[3]]->cash +=
		  pMWin->GObj[BetSpotUse[3]]->coinsplayedhand3;
		  delete pMWin->GObj[BetSpotUse[3]]->pHand3;
		  pMWin->GObj[BetSpotUse[3]]->pHand3 = NULL;
		  BetSpotUse[3] = -1;
		}
		else
		{
		 // cout << "Hand3->.-> Loser " << endl;
		  pMWin->GObj[BetSpotUse[3]]->coinsplayedhand3 = 0;
		  delete pMWin->GObj[BetSpotUse[3]]->pHand3;
		  pMWin->GObj[BetSpotUse[3]]->pHand3 = NULL;
		  BetSpotUse[3] = -1;
		}
	 }
	 if(BetSpotUse[5] != -1)
	 {
		if(pMWin->GObj[BetSpotUse[5]]->pHand5->insurance)
		{
		  pMWin->GObj[BetSpotUse[5]]->cash +=
			 (pMWin->GObj[BetSpotUse[5]]->pHand5->insurance * 2);
		//  cout << "Insurance payes 2 to 1 " << endl;
		}
		else
		{
		  pMWin->GObj[BetSpotUse[5]]->pHand5->insurance = 0; //remove insurance
		}
		if(((TBJHand *)pMWin->GObj[BetSpotUse[5]]->pHand5)->bj == 1)
		{
		 // cout << "Hand5->.-> Push " << endl;
		  pMWin->GObj[BetSpotUse[5]]->cash +=
		  pMWin->GObj[BetSpotUse[5]]->coinsplayedhand5;
		  delete pMWin->GObj[BetSpotUse[5]]->pHand5;
		  pMWin->GObj[BetSpotUse[5]]->pHand5 = NULL;
		  BetSpotUse[5] = -1;
		}
		else
		{
		 // cout << "Hand5->.-> Loser " << endl;
		  pMWin->GObj[BetSpotUse[5]]->coinsplayedhand5 = 0;
		  delete pMWin->GObj[BetSpotUse[5]]->pHand5;
		  pMWin->GObj[BetSpotUse[5]]->pHand5 = NULL;
		  BetSpotUse[5] = -1;
		}
	 }
	 return 1;
  }
  else
  {
    if(BetSpotUse[1] != -1)
	 {
		if(((TBJHand *)pMWin->GObj[BetSpotUse[1]]->pHand1)->bj == 1)
		{
		 // cout << "Hand1->.-> BlackJack!!! " << endl;
		  pMWin->GObj[BetSpotUse[1]]->cash +=
		  ((pMWin->GObj[BetSpotUse[1]]->coinsplayedhand1)*5)/2; // 1 1/2 payoff
        delete pMWin->GObj[BetSpotUse[1]]->pHand1;
		  pMWin->GObj[BetSpotUse[1]]->pHand1 = NULL;
		  BetSpotUse[1] = -1;
		}
	 }
	 if(BetSpotUse[3] != -1)
	 {
		if(((TBJHand *)pMWin->GObj[BetSpotUse[3]]->pHand3)->bj == 1)
		{
		//  cout << "Hand3->.-> BlackJack!!! " << endl;
		  pMWin->GObj[BetSpotUse[3]]->cash +=
		  ((pMWin->GObj[BetSpotUse[3]]->coinsplayedhand3)*5)/2;
		  delete pMWin->GObj[BetSpotUse[3]]->pHand3;
		  pMWin->GObj[BetSpotUse[3]]->pHand3 = NULL;
		  BetSpotUse[3] = -1;
		}
	 }
	 if(BetSpotUse[5] != -1)
	 {
		if(((TBJHand *)pMWin->GObj[BetSpotUse[5]]->pHand5)->bj == 1)
		{
	  //	  cout << "Hand5->.-> BlackJack " << endl;
		  pMWin->GObj[BetSpotUse[5]]->cash +=
		  ((pMWin->GObj[BetSpotUse[5]]->coinsplayedhand5)*5)/2;
		  delete pMWin->GObj[BetSpotUse[5]]->pHand5;
		  pMWin->GObj[BetSpotUse[5]]->pHand5 = NULL;
		  BetSpotUse[5] = -1;
		}
	 }
	 return 0;
  }
}
/*
//*******************************************************************
TBJLord::GetBet()
{
 int z=1;
 coinsplayed = 0;
 winnerpaid = 0;
 while(z != 0)
 {
  if(coinsplayed < maxbet)
  {
	 cout << "Enter 1 to 'BET 1' ";
  }
  if(coinsplayed < maxbet && (pMWin->GObj[activeplayer]->cash > coinsize))
  {
	 cout << "Enter 2 to 'BET MAX' ";
  }
  if(activeplayer == playersin-1)
  {
	 cout << "Enter 3 to 'DEAL' ";
  }
  if(coinsplayed && (BetSpotUse[1] == -1 || BetSpotUse[3] == -1 || BetSpotUse[5] == -1))
  {
	 cout << "Enter 4 to 'PLACE BET' ";
  }
  if(activeplayer < playersin-1)
  {
	 cout << "Enter 5 to 'NEXT PLAYER' ";
  }

  cout << "Enter 6 to 'QUIT' ";
  cout << "Enter 7 to 'SWITCHDECKS' ";
  cin >> z;
  switch (z) {
	 case 1 :  Bet1();break;
	 case 2 :  BetMax();break;
	 case 3 :  return 1;  // Deal
	 case 4 :  PlaceBet();break;
	 case 5 :  activeplayer++;break;
	 case 6 :  return 0;
	 case 7 :  SwitchDecks();break;
	 default : return 0;  // Quit
  }
 }
 return 0;
} */
//*******************************************************************
TBJLord::CashOut()
{
  for(;credits>0;credits--)
  {
	 pMWin->GObj[activeplayer]->cash += coinsize;
	// cout << pMWin->GObj[activeplayer]->cash << endl;
  }
  return 1;
}
//*******************************************************************
TBJLord::Bet1(int betsize)
{
  if(pMWin->GObj[activeplayer]->cash > betsize)
  {
	 pMWin->GObj[activeplayer]->cash -= betsize;
	 coinsplayed += betsize;
	 pMWin->GObj[activeplayer]->coinsplayed += betsize;

	 CasStatusBar->ShowBetNum(coinsplayed,6);
	 Chips->SetNum(pMWin->GObj[activeplayer]->cash);
  }
  return 1;
}
//*******************************************************************
TBJLord::BetLast()
{
  if(pMWin->GObj[activeplayer]->cash > pMWin->GObj[activeplayer]->lastbet)
  {
	 pMWin->GObj[activeplayer]->cash -= pMWin->GObj[activeplayer]->lastbet;
	 coinsplayed += pMWin->GObj[activeplayer]->lastbet;
	 pMWin->GObj[activeplayer]->coinsplayed += pMWin->GObj[activeplayer]->lastbet;

	 CasStatusBar->ShowBetNum(coinsplayed,6);
	 Chips->SetNum(pMWin->GObj[activeplayer]->cash);
  }
  return 1;
}
//*******************************************************************
TBJLord::UnBet1(int betsize)
{
  if(coinsplayed >= betsize)
  {
	 pMWin->GObj[activeplayer]->cash += betsize;
	 coinsplayed -= betsize;
	 pMWin->GObj[activeplayer]->coinsplayed -= betsize;

    Chips->SetNum(pMWin->GObj[activeplayer]->cash);
  }
  CasStatusBar->ShowBetNum(coinsplayed,6);

  return 1;
}
//*******************************************************************
TBJLord::ClearBet()
{
  if(coinsplayed > 0)
  {
	 pMWin->GObj[activeplayer]->cash += coinsplayed;
	 coinsplayed = 0;
	 pMWin->GObj[activeplayer]->coinsplayed = 0;

	 Chips->SetNum(pMWin->GObj[activeplayer]->cash);
  }
  CasStatusBar->ShowBetNum(coinsplayed,6);

  return 1;
}
//*******************************************************************
TBJLord::BetMax()
{
  if(pMWin->GObj[activeplayer]->cash > (maxbet-coinsplayed)*coinsize)
  {
	 pMWin->GObj[activeplayer]->cash -= (maxbet-coinsplayed)*coinsize;
	 coinsplayed = maxbet;
  }
  else
  {
	 coinsplayed += (pMWin->GObj[activeplayer]->cash)/(coinsize);
	 pMWin->GObj[activeplayer]->cash = pMWin->GObj[activeplayer]->cash%coinsize;
  }
  return 1;
}
//*******************************************************************
TBJLord::ShowHands()
{
  return 1;
}
//*******************************************************************
TBJLord::ShowWinner()
{
//  cout << "You won " << winnerpaid*coinsize << " bucks->";
  credits += (winnerpaid)/(coinsize);
//  cout << "You have " << pMWin->GObj[activeplayer]->cash << " bucks->";
//  cout << "You have " << credits << " credits->";

  return 1;
}
//*******************************************************************
TBJLord::DealerDraw()
{
  int action=0;
  if(BetSpotUse[0] == -1 && BetSpotUse[1] == -1 && BetSpotUse[2] == -1 &&
	  BetSpotUse[3] == -1 && BetSpotUse[4] == -1 && BetSpotUse[5] == -1 &&
	  BetSpotUse[6] == -1)
  {
	 return -1;
  }
  while(((TBJDeck *)pDeck)->Busted(pHand) == 0 && action != 7)
  {
	 if(pHand->highhand >= 17)
	 {
		return 1;
	 }
	 ((TBJDeck *)pDeck)->Draw(pHand,pMWin);
  }
  return 0;
}
//*******************************************************************
TBJLord::DrawCards1()
{
  int action=0;
  if(BetSpotUse[1] != -1)
  {
	 while(((TBJDeck *)pDeck)->Busted(pMWin->GObj[BetSpotUse[1]]->pHand1) == 0 && action != 7)
	 {
	  //	cout << "1->Hit,2->Stand";
		if(pMWin->GObj[BetSpotUse[1]]->pHand1->inhand < 3)
		{
		  //cout << ",3->DoublDown";
		}
		if((BetSpotUse[0] == -1 || BetSpotUse[2] == -1) &&
			 pMWin->GObj[BetSpotUse[1]]->numsplitshand1 < 2 &&
			 pMWin->GObj[BetSpotUse[1]]->pHand1->inhand < 3 &&
		  ((pMWin->GObj[BetSpotUse[1]]->pHand1->cards[0].name ==
			 pMWin->GObj[BetSpotUse[1]]->pHand1->cards[1].name) ||
			(pMWin->GObj[BetSpotUse[1]]->pHand1->cards[0].name >= Ten) &&
			(pMWin->GObj[BetSpotUse[1]]->pHand1->cards[1].name >= Ten)) )
		{
		  //cout << ",4->Split " << endl;
		}
		else
		{
		  cout << endl;
		}
		cin >> action;
		switch(action) {
		case 1:  ((TBJDeck *)pDeck)->Draw(pMWin->GObj[BetSpotUse[1]]->pHand1,pMWin);break;
		case 2:  return 2;
		case 3:  DoubleDown(1);
					if(((TBJDeck *)pDeck)->Busted(pMWin->GObj[BetSpotUse[1]]->pHand1))
					{
					  break;
					}
					else
					{
					  return 3;
					}
		case 4:  pMWin->GObj[BetSpotUse[1]]->numsplitshand1++;
					if(pMWin->GObj[BetSpotUse[1]]->numsplitshand1 == 2)
					{
					  Split3();
					}
					else
					{
					  Split1();
					}
					((TBJDeck *)pDeck)->Draw(pMWin->GObj[BetSpotUse[1]]->pHand1,pMWin);
					if(pMWin->GObj[BetSpotUse[1]]->pHand1->cards[0].name == AceHi)
					{
					  ((TBJDeck *)pDeck)->Busted(pMWin->GObj[BetSpotUse[1]]->pHand1);
					  return 4;
					}
					else
					{
					  break;
					}
		default : break;
		}
	 }
  //	 cout << "Stone Cold Busted!" << endl;
	 pMWin->GObj[BetSpotUse[1]]->coinsplayedhand1 = 0;
	 if(pMWin->GObj[BetSpotUse[1]]->pHand1 != NULL)
	 {
		delete pMWin->GObj[BetSpotUse[1]]->pHand1;
		pMWin->GObj[BetSpotUse[1]]->pHand1 = NULL;
	 }
	 BetSpotUse[1] = -1;
  }
  return 1;
}
//*******************************************************************
TBJLord::Split1()
{
  pMWin->GObj[BetSpotUse[1]]->pHand0 = new TBJHand;
  BetSpotUse[0] = BetSpotUse[1];
  pMWin->GObj[BetSpotUse[0]]->coinsplayedhand0 = pMWin->GObj[BetSpotUse[1]]->coinsplayedhand1;
  pMWin->GObj[BetSpotUse[0]]->cash -= pMWin->GObj[BetSpotUse[0]]->coinsplayedhand0;
  pMWin->GObj[BetSpotUse[0]]->pHand0->cards[0] =
											  pMWin->GObj[BetSpotUse[1]]->pHand1->cards[0];
  pMWin->GObj[BetSpotUse[0]]->pHand0->inhand++;
  pMWin->GObj[BetSpotUse[1]]->pHand1->inhand--;
  ((TBJDeck *)pDeck)->Draw(pMWin->GObj[BetSpotUse[0]]->pHand0,pMWin);
  /*********/
  if(pMWin->GObj[BetSpotUse[0]]->pHand0->cards[0].name == AceHi)
  {
	 ((TBJDeck *)pDeck)->Busted(pMWin->GObj[BetSpotUse[0]]->pHand0);
	 return 1;
  }
  int action=0;
  while(((TBJDeck *)pDeck)->Busted(pMWin->GObj[BetSpotUse[0]]->pHand0) == 0 && action != 7)
  {
  //	cout << "1->Hit,2->Stand";
	if(pMWin->GObj[BetSpotUse[0]]->pHand0->inhand < 3)
	{
	 // cout << ",3->DoublDown";
	}
	if(BetSpotUse[2] == -1 && pMWin->GObj[BetSpotUse[0]]->pHand0->inhand < 3 &&
	  ((pMWin->GObj[BetSpotUse[0]]->pHand0->cards[0].name ==
		 pMWin->GObj[BetSpotUse[0]]->pHand0->cards[1].name) ||
		(pMWin->GObj[BetSpotUse[0]]->pHand0->cards[0].name >= Ten) &&
		(pMWin->GObj[BetSpotUse[0]]->pHand0->cards[1].name >= Ten)) )
	{
	 // cout << ",4->Split " << endl;
	}
	else
	{
	  //cout << endl;
	}
	//cin >> action;
	switch(action) {
	 case 1:  ((TBJDeck *)pDeck)->Draw(pMWin->GObj[BetSpotUse[0]]->pHand0,pMWin);break;
	 case 2:  return 2;
	 case 3:  DoubleDown(0);
				 if(((TBJDeck *)pDeck)->Busted(pMWin->GObj[BetSpotUse[0]]->pHand0))
             {
					 break;
				 }
				 else
				 {
					return 3;
				 }
	 case 4:  pMWin->GObj[BetSpotUse[1]]->numsplitshand1++;
				 Split2();
				 ((TBJDeck *)pDeck)->Draw(pMWin->GObj[BetSpotUse[0]]->pHand0,pMWin);
	 default : break;
	}
  }//while
 // cout << "Stone Cold Busted!" << endl;
  pMWin->GObj[BetSpotUse[0]]->coinsplayedhand0 = 0;
  if(pMWin->GObj[BetSpotUse[0]]->pHand0 != NULL)
  {
	 delete pMWin->GObj[BetSpotUse[0]]->pHand0;
	 pMWin->GObj[BetSpotUse[0]]->pHand0 = NULL;
  }
  BetSpotUse[0] = -1;
  return 1;
}
//*******************************************************************
TBJLord::Split2()
{
  pMWin->GObj[BetSpotUse[0]]->pHand2 = new TBJHand;
  BetSpotUse[2] = BetSpotUse[0];
  pMWin->GObj[BetSpotUse[2]]->coinsplayedhand2 = pMWin->GObj[BetSpotUse[0]]->coinsplayedhand0;
  pMWin->GObj[BetSpotUse[2]]->cash -= pMWin->GObj[BetSpotUse[2]]->coinsplayedhand2;
  pMWin->GObj[BetSpotUse[2]]->pHand2->cards[0] =
											  pMWin->GObj[BetSpotUse[0]]->pHand0->cards[0];
  pMWin->GObj[BetSpotUse[2]]->pHand2->inhand++;
  pMWin->GObj[BetSpotUse[0]]->pHand0->inhand--;
  ((TBJDeck *)pDeck)->Draw(pMWin->GObj[BetSpotUse[2]]->pHand2,pMWin);
  if(pMWin->GObj[BetSpotUse[2]]->pHand2->cards[0].name == AceHi)
  {
	 ((TBJDeck *)pDeck)->Busted(pMWin->GObj[BetSpotUse[2]]->pHand2);
	 return 1;
  }
  /*********/
  int action=0;
  while(((TBJDeck *)pDeck)->Busted(pMWin->GObj[BetSpotUse[2]]->pHand2) == 0 && action != 7)
  {
	//cout << "1->Hit,2->Stand";
	if(pMWin->GObj[BetSpotUse[2]]->pHand2->inhand < 3)
	{
	 // cout << ",3->DoublDown";
	}
	else
	{
	 // cout << endl;
	}
  //	cin >> action;
	switch(action) {
	 case 1:  ((TBJDeck *)pDeck)->Draw(pMWin->GObj[BetSpotUse[2]]->pHand2,pMWin);break;
	 case 2:  return 2;
	 case 3:  DoubleDown(2);
				 if(((TBJDeck *)pDeck)->Busted(pMWin->GObj[BetSpotUse[2]]->pHand2))
             {
					break;
				 }
				 else
				 {
					return 3;
				 }
	 default : break;
	}
  }//while
//  cout << "Stone Cold Busted!" << endl;
  pMWin->GObj[BetSpotUse[2]]->coinsplayedhand2 = 0;
  if(pMWin->GObj[BetSpotUse[2]]->pHand2 != NULL)
  {
	 delete pMWin->GObj[BetSpotUse[2]]->pHand2;
	 pMWin->GObj[BetSpotUse[2]]->pHand2 = NULL;
  }
  BetSpotUse[2] = -1;
  return 1;
}
//*******************************************************************
TBJLord::Split3()
{
  pMWin->GObj[BetSpotUse[1]]->pHand2 = new TBJHand;
  BetSpotUse[2] = BetSpotUse[1];
  pMWin->GObj[BetSpotUse[2]]->coinsplayedhand2 = pMWin->GObj[BetSpotUse[1]]->coinsplayedhand1;
  pMWin->GObj[BetSpotUse[2]]->cash -= pMWin->GObj[BetSpotUse[2]]->coinsplayedhand2;
  pMWin->GObj[BetSpotUse[2]]->pHand2->cards[0] =
											  pMWin->GObj[BetSpotUse[1]]->pHand1->cards[0];
  pMWin->GObj[BetSpotUse[2]]->pHand2->inhand++;
  pMWin->GObj[BetSpotUse[1]]->pHand1->inhand--;
  ((TBJDeck *)pDeck)->Draw(pMWin->GObj[BetSpotUse[2]]->pHand2,pMWin);
  if(pMWin->GObj[BetSpotUse[2]]->pHand2->cards[0].name == AceHi)
  {
	 ((TBJDeck *)pDeck)->Busted(pMWin->GObj[BetSpotUse[2]]->pHand2);
	 return 1;
  }
  /*********/
  int action=0;
  while(((TBJDeck *)pDeck)->Busted(pMWin->GObj[BetSpotUse[2]]->pHand2) == 0 && action != 7)
  {
	//cout << "1->Hit,2->Stand";
	if(pMWin->GObj[BetSpotUse[2]]->pHand2->inhand < 3)
	{
	 // cout << ",3->DoublDown";
	}
	else
	{
	  //cout << endl;
	}
  //	cin >> action;
	switch(action) {
	 case 1:  ((TBJDeck *)pDeck)->Draw(pMWin->GObj[BetSpotUse[2]]->pHand2,pMWin);break;
	 case 2:  return 2;
	 case 3:  DoubleDown(2);
				 if(((TBJDeck *)pDeck)->Busted(pMWin->GObj[BetSpotUse[2]]->pHand2))
             {
					break;
				 }
				 else
				 {
					return 3;
				 }
	 default : break;
	}
  }//while
//  cout << "Stone Cold Busted!" << endl;
  pMWin->GObj[BetSpotUse[2]]->coinsplayedhand2 = 0;
  if(pMWin->GObj[BetSpotUse[2]]->pHand2 != NULL)
  {
	 delete pMWin->GObj[BetSpotUse[2]]->pHand2;
	 pMWin->GObj[BetSpotUse[2]]->pHand2 = NULL;
  }
  BetSpotUse[2] = -1;
  return 1;
}
//*******************************************************************
TBJLord::DrawCards3()
{
  int action=0;
  if(BetSpotUse[3] != -1)
  {
	 while(((TBJDeck *)pDeck)->Busted(pMWin->GObj[BetSpotUse[3]]->pHand3) == 0 && action != 7)
	 {
		//cout << "1->Hit,2->Stand";
		if(pMWin->GObj[BetSpotUse[3]]->pHand3->inhand < 3)
		{
		 // cout << ",3->DoublDown";
		}
		if(((BetSpotUse[2] == -1 || BetSpotUse[4] == -1) &&
			 pMWin->GObj[BetSpotUse[3]]->numsplitshand3 < 2) &&
			 pMWin->GObj[BetSpotUse[3]]->pHand3->inhand < 3 &&
		  ((pMWin->GObj[BetSpotUse[3]]->pHand3->cards[0].name ==
			 pMWin->GObj[BetSpotUse[3]]->pHand3->cards[1].name) ||
			(pMWin->GObj[BetSpotUse[3]]->pHand3->cards[0].name >= Ten) &&
			(pMWin->GObj[BetSpotUse[3]]->pHand3->cards[1].name >= Ten)) )
		{
		 // cout << ",4->Split " << endl;
		}
		else
		{
		  //cout << endl;
		}
	  //	cin >> action;
		switch(action) {
		case 1:  ((TBJDeck *)pDeck)->Draw(pMWin->GObj[BetSpotUse[3]]->pHand3,pMWin);break;
		case 2:  return 2;
		case 3:  DoubleDown(3);
					if(((TBJDeck *)pDeck)->Busted(pMWin->GObj[BetSpotUse[3]]->pHand3))
               {
					  break;
					}
					else
					{
					  return 3;
					}
		case 4:  pMWin->GObj[BetSpotUse[3]]->numsplitshand3++;
					if(pMWin->GObj[BetSpotUse[3]]->numsplitshand3 == 2 || BetSpotUse[2] >= 0)
					{
					  Split6();
					  ((TBJDeck *)pDeck)->DontSplitDraw(pMWin->GObj[BetSpotUse[3]]->pHand3,pMWin,numofdecks);
					}
					else
					{
					  Split4();
					  ((TBJDeck *)pDeck)->Draw(pMWin->GObj[BetSpotUse[3]]->pHand3,pMWin);
					}
					if(pMWin->GObj[BetSpotUse[3]]->pHand3->cards[0].name == AceHi)
					{
					  ((TBJDeck *)pDeck)->Busted(pMWin->GObj[BetSpotUse[3]]->pHand3);
					  return 4;
					}
					else
					{
					  break;
					}
		default : break;
		}
	 }
	 //cout << "Stone Cold Busted!" << endl;
	 pMWin->GObj[BetSpotUse[3]]->coinsplayedhand3 = 0;
	 if(pMWin->GObj[BetSpotUse[3]]->pHand3 != NULL)
	 {
		delete pMWin->GObj[BetSpotUse[3]]->pHand3;
		pMWin->GObj[BetSpotUse[3]]->pHand3 = NULL;
	 }
	 BetSpotUse[3] = -1;
  }
  return 1;
}
//*******************************************************************
TBJLord::Split4()
{
  pMWin->GObj[BetSpotUse[3]]->pHand2 = new TBJHand;
  BetSpotUse[2] = BetSpotUse[3];
  pMWin->GObj[BetSpotUse[2]]->coinsplayedhand2 = pMWin->GObj[BetSpotUse[3]]->coinsplayedhand3;
  pMWin->GObj[BetSpotUse[2]]->cash -= pMWin->GObj[BetSpotUse[2]]->coinsplayedhand2;
  pMWin->GObj[BetSpotUse[2]]->pHand2->cards[0] =
											  pMWin->GObj[BetSpotUse[3]]->pHand3->cards[0];
  pMWin->GObj[BetSpotUse[2]]->pHand2->inhand++;
  pMWin->GObj[BetSpotUse[3]]->pHand3->inhand--;
  ((TBJDeck *)pDeck)->Draw(pMWin->GObj[BetSpotUse[2]]->pHand2,pMWin);
  /*********/
  if(pMWin->GObj[BetSpotUse[2]]->pHand2->cards[0].name == AceHi)
  {
	 ((TBJDeck *)pDeck)->Busted(pMWin->GObj[BetSpotUse[2]]->pHand2);
	 return 1;
  }
  int action=0;
  while(((TBJDeck *)pDeck)->Busted(pMWin->GObj[BetSpotUse[2]]->pHand2) == 0 && action != 7)
  {
 //	cout << "1->Hit,2->Stand";
	if(pMWin->GObj[BetSpotUse[2]]->pHand2->inhand < 3)
	{
	//  cout << ",3->DoublDown";
	}
	if(BetSpotUse[4] == -1 && pMWin->GObj[BetSpotUse[2]]->pHand2->inhand < 3 &&
	  ((pMWin->GObj[BetSpotUse[2]]->pHand2->cards[0].name ==
		 pMWin->GObj[BetSpotUse[2]]->pHand2->cards[1].name) ||
		(pMWin->GObj[BetSpotUse[2]]->pHand2->cards[0].name >= Ten) &&
		(pMWin->GObj[BetSpotUse[2]]->pHand2->cards[1].name >= Ten)) )
	{
	//  cout << ",4->Split " << endl;
	}
	else
	{
	 // cout << endl;
	}
  //	cin >> action;
	switch(action) {
	 case 1:  ((TBJDeck *)pDeck)->Draw(pMWin->GObj[BetSpotUse[2]]->pHand2,pMWin);break;
	 case 2:  return 2;
	 case 3:  DoubleDown(2);
				 if(((TBJDeck *)pDeck)->Busted(pMWin->GObj[BetSpotUse[2]]->pHand2))
             {
					break;
				 }
				 else
				 {
					return 3;
				 }
	 case 4:  pMWin->GObj[BetSpotUse[3]]->numsplitshand3++;
				 Split5();
				 ((TBJDeck *)pDeck)->Draw(pMWin->GObj[BetSpotUse[2]]->pHand2,pMWin);
	 default : break;
	}
  }//while
 // cout << "Stone Cold Busted!" << endl;
  pMWin->GObj[BetSpotUse[2]]->coinsplayedhand2 = 0;
  if(pMWin->GObj[BetSpotUse[2]]->pHand2 != NULL)
  {
	 delete pMWin->GObj[BetSpotUse[2]]->pHand2;
	 pMWin->GObj[BetSpotUse[2]]->pHand2 = NULL;
  }
  BetSpotUse[2] = -1;
  return 1;
}
//*******************************************************************
TBJLord::Split5()
{
  pMWin->GObj[BetSpotUse[2]]->pHand4 = new TBJHand;
  BetSpotUse[4] = BetSpotUse[2];
  pMWin->GObj[BetSpotUse[4]]->coinsplayedhand4 = pMWin->GObj[BetSpotUse[2]]->coinsplayedhand2;
  pMWin->GObj[BetSpotUse[4]]->cash -= pMWin->GObj[BetSpotUse[4]]->coinsplayedhand4;
  pMWin->GObj[BetSpotUse[4]]->pHand4->cards[0] =
											  pMWin->GObj[BetSpotUse[2]]->pHand2->cards[0];
  pMWin->GObj[BetSpotUse[4]]->pHand4->inhand++;
  pMWin->GObj[BetSpotUse[2]]->pHand2->inhand--;
  ((TBJDeck *)pDeck)->Draw(pMWin->GObj[BetSpotUse[4]]->pHand4,pMWin);
  if(pMWin->GObj[BetSpotUse[4]]->pHand4->cards[0].name == AceHi)
  {
	 ((TBJDeck *)pDeck)->Busted(pMWin->GObj[BetSpotUse[4]]->pHand4);
	 return 1;
  }
  /*********/
  int action=0;
  while(((TBJDeck *)pDeck)->Busted(pMWin->GObj[BetSpotUse[4]]->pHand4) == 0 && action != 7)
  {
 //	cout << "1->Hit,2->Stand";
	if(pMWin->GObj[BetSpotUse[4]]->pHand4->inhand < 3)
	{
	//  cout << ",3->DoublDown";
	}
	else
	{
	//  cout << endl;
	}
	//cin >> action;
	switch(action) {
	 case 1:  ((TBJDeck *)pDeck)->Draw(pMWin->GObj[BetSpotUse[4]]->pHand4,pMWin);break;
	 case 2:  return 2;
	 case 3:  DoubleDown(4);
				 if(((TBJDeck *)pDeck)->Busted(pMWin->GObj[BetSpotUse[4]]->pHand4))
             {
					break;
				 }
				 else
				 {
					return 3;
				 }
	 default : break;
	}
  }//while
 // cout << "Stone Cold Busted!" << endl;
  pMWin->GObj[BetSpotUse[4]]->coinsplayedhand4 = 0;
  if(pMWin->GObj[BetSpotUse[4]]->pHand4 != NULL)
  {
	 delete pMWin->GObj[BetSpotUse[4]]->pHand4;
	 pMWin->GObj[BetSpotUse[4]]->pHand4 = NULL;
  }
  BetSpotUse[4] = -1;
  return 1;
}
//*******************************************************************
TBJLord::Split6()
{
  pMWin->GObj[BetSpotUse[3]]->pHand4 = new TBJHand;
  BetSpotUse[4] = BetSpotUse[3];
  pMWin->GObj[BetSpotUse[4]]->coinsplayedhand4 = pMWin->GObj[BetSpotUse[3]]->coinsplayedhand3;
  pMWin->GObj[BetSpotUse[4]]->cash -= pMWin->GObj[BetSpotUse[4]]->coinsplayedhand4;
  pMWin->GObj[BetSpotUse[4]]->pHand4->cards[0] =
											  pMWin->GObj[BetSpotUse[3]]->pHand3->cards[0];
  pMWin->GObj[BetSpotUse[4]]->pHand4->inhand++;
  pMWin->GObj[BetSpotUse[3]]->pHand3->inhand--;
  //((TBJDeck *)pDeck)->Draw(pMWin->GObj[BetSpotUse[4]]->pHand4,pMWin);
  ((TBJDeck *)pDeck)->DontSplitDraw(pMWin->GObj[BetSpotUse[4]]->pHand4,pMWin,numofdecks);
  if(pMWin->GObj[BetSpotUse[4]]->pHand4->cards[0].name == AceHi)
  {
	 ((TBJDeck *)pDeck)->Busted(pMWin->GObj[BetSpotUse[4]]->pHand4);
	 return 1;
  }
  /*********/
  int action=0;
  while(((TBJDeck *)pDeck)->Busted(pMWin->GObj[BetSpotUse[4]]->pHand4) == 0 && action != 7)
  {
	//cout << "1->Hit,2->Stand";
	if(pMWin->GObj[BetSpotUse[4]]->pHand4->inhand < 3)
	{
	 // cout << ",3->DoublDown";
	}
	else
	{
	 // cout << endl;
	}
  //	cin >> action;
	switch(action) {
	 case 1:  ((TBJDeck *)pDeck)->Draw(pMWin->GObj[BetSpotUse[4]]->pHand4,pMWin);break;
	 case 2:  return 2;
	 case 3:  DoubleDown(4);
				 if(((TBJDeck *)pDeck)->Busted(pMWin->GObj[BetSpotUse[4]]->pHand4))
             {
					break;
				 }
				 else
				 {
					return 3;
				 }
	 default : break;
	}
  }//while
  //cout << "Stone Cold Busted!" << endl;
  pMWin->GObj[BetSpotUse[4]]->coinsplayedhand4 = 0;
  if(pMWin->GObj[BetSpotUse[4]]->pHand4 != NULL)
  {
	 delete pMWin->GObj[BetSpotUse[4]]->pHand4;
	 pMWin->GObj[BetSpotUse[4]]->pHand4 = NULL;
  }
  BetSpotUse[4] = -1;
  return 1;
}
//*******************************************************************
TBJLord::DrawCards5()
{
  int action=0;
  if(BetSpotUse[5] != -1)
  {
	 while(((TBJDeck *)pDeck)->Busted(pMWin->GObj[BetSpotUse[5]]->pHand5) == 0 && action != 7)
	 {
	 //	cout << "1->Hit,2->Stand";
		if(pMWin->GObj[BetSpotUse[5]]->pHand5->inhand < 3)
		{
		  //cout << ",3->DoublDown";
		}
		if(((BetSpotUse[4] == -1 || BetSpotUse[6] == -1) &&
			 pMWin->GObj[BetSpotUse[5]]->numsplitshand3 < 2) &&
			 pMWin->GObj[BetSpotUse[5]]->pHand5->inhand < 3 &&
		  ((pMWin->GObj[BetSpotUse[5]]->pHand5->cards[0].name ==
			 pMWin->GObj[BetSpotUse[5]]->pHand5->cards[1].name) ||
			(pMWin->GObj[BetSpotUse[5]]->pHand5->cards[0].name >= Ten) &&
			(pMWin->GObj[BetSpotUse[5]]->pHand5->cards[1].name >= Ten)) )
		{
		 // cout << ",4->Split " << endl;
		}
		else
		{
		 // cout << endl;
		}
	  //	cin >> action;
		switch(action) {
		case 1:  ((TBJDeck *)pDeck)->Draw(pMWin->GObj[BetSpotUse[5]]->pHand5,pMWin);break;
		case 2:  return 2;
		case 3:  DoubleDown(5);
					if(((TBJDeck *)pDeck)->Busted(pMWin->GObj[BetSpotUse[5]]->pHand5))
               {
					  break;
					}
					else
					{
					  return 3;
					}
		case 4:  pMWin->GObj[BetSpotUse[5]]->numsplitshand5++;
					if(pMWin->GObj[BetSpotUse[5]]->numsplitshand5 == 2 || BetSpotUse[4] >= 0)
					{
					  Split9();
					  ((TBJDeck *)pDeck)->DontSplitDraw(pMWin->GObj[BetSpotUse[3]]->pHand3,pMWin,numofdecks);
					}
					else
					{
					  Split7();
                 ((TBJDeck *)pDeck)->Draw(pMWin->GObj[BetSpotUse[3]]->pHand3,pMWin);
					}
					if(pMWin->GObj[BetSpotUse[5]]->pHand5->cards[0].name == AceHi)
					{
					  ((TBJDeck *)pDeck)->Busted(pMWin->GObj[BetSpotUse[5]]->pHand5);
					  return 4;
					}
					else
					{
					  break;
					}
		default : break;
		}
	 }
	// cout << "Stone Cold Busted!" << endl;
	 pMWin->GObj[BetSpotUse[5]]->coinsplayedhand5 = 0;
	 if(pMWin->GObj[BetSpotUse[5]]->pHand5 != NULL)
	 {
		delete pMWin->GObj[BetSpotUse[5]]->pHand5;
		pMWin->GObj[BetSpotUse[5]]->pHand5 = NULL;
	 }
	 BetSpotUse[5] = -1;
  }
  return 1;
}
//*******************************************************************
TBJLord::Split7()
{
  pMWin->GObj[BetSpotUse[5]]->pHand4 = new TBJHand;
  BetSpotUse[4] = BetSpotUse[5];
  pMWin->GObj[BetSpotUse[4]]->coinsplayedhand4 = pMWin->GObj[BetSpotUse[5]]->coinsplayedhand5;
  pMWin->GObj[BetSpotUse[4]]->cash -= pMWin->GObj[BetSpotUse[4]]->coinsplayedhand4;
  pMWin->GObj[BetSpotUse[4]]->pHand4->cards[0] =
											  pMWin->GObj[BetSpotUse[5]]->pHand5->cards[0];
  pMWin->GObj[BetSpotUse[4]]->pHand4->inhand++;
  pMWin->GObj[BetSpotUse[5]]->pHand5->inhand--;
  ((TBJDeck *)pDeck)->Draw(pMWin->GObj[BetSpotUse[4]]->pHand4,pMWin);
  /*********/
  if(pMWin->GObj[BetSpotUse[4]]->pHand4->cards[0].name == AceHi)
  {
	 ((TBJDeck *)pDeck)->Busted(pMWin->GObj[BetSpotUse[4]]->pHand4);
	 return 1;
  }
  int action=0;
  while(((TBJDeck *)pDeck)->Busted(pMWin->GObj[BetSpotUse[4]]->pHand4) == 0 && action != 7)
  {
  //	cout << "1->Hit,2->Stand";
	if(pMWin->GObj[BetSpotUse[4]]->pHand4->inhand < 3)
	{
	 // cout << ",3->DoublDown";
	}
	if(BetSpotUse[6] == -1 && pMWin->GObj[BetSpotUse[4]]->pHand4->inhand < 3 &&
	  ((pMWin->GObj[BetSpotUse[4]]->pHand4->cards[0].name ==
		 pMWin->GObj[BetSpotUse[4]]->pHand4->cards[1].name) ||
		(pMWin->GObj[BetSpotUse[4]]->pHand4->cards[0].name >= Ten) &&
		(pMWin->GObj[BetSpotUse[4]]->pHand4->cards[1].name >= Ten)) )
	{
	 // cout << ",4->Split " << endl;
	}
	else
	{
	  //cout << endl;
	}
	//cin >> action;
	switch(action) {
	 case 1:  ((TBJDeck *)pDeck)->Draw(pMWin->GObj[BetSpotUse[4]]->pHand4,pMWin);break;
	 case 2:  return 2;
	 case 3:  DoubleDown(4);
				 if(((TBJDeck *)pDeck)->Busted(pMWin->GObj[BetSpotUse[4]]->pHand4))
             {
					break;
				 }
				 else
				 {
					return 3;
				 }
	 case 4:  Split8();
				 ((TBJDeck *)pDeck)->Draw(pMWin->GObj[BetSpotUse[4]]->pHand4,pMWin);
	 default : break;
	}
  }//while
//  cout << "Stone Cold Busted!" << endl;
  pMWin->GObj[BetSpotUse[4]]->coinsplayedhand4 = 0;
  if(pMWin->GObj[BetSpotUse[4]]->pHand4 != NULL)
  {
	 delete pMWin->GObj[BetSpotUse[4]]->pHand4;
	 pMWin->GObj[BetSpotUse[4]]->pHand4 = NULL;
  }
  BetSpotUse[4] = -1;
  return 1;
}
//*******************************************************************
TBJLord::Split8()
{
  pMWin->GObj[BetSpotUse[4]]->pHand6 = new TBJHand;
  BetSpotUse[6] = BetSpotUse[4];
  pMWin->GObj[BetSpotUse[6]]->coinsplayedhand6 = pMWin->GObj[BetSpotUse[4]]->coinsplayedhand4;
  pMWin->GObj[BetSpotUse[6]]->cash -= pMWin->GObj[BetSpotUse[6]]->coinsplayedhand6;
  pMWin->GObj[BetSpotUse[6]]->pHand6->cards[0] =
											  pMWin->GObj[BetSpotUse[4]]->pHand4->cards[0];
  pMWin->GObj[BetSpotUse[6]]->pHand6->inhand++;
  pMWin->GObj[BetSpotUse[4]]->pHand4->inhand--;
  ((TBJDeck *)pDeck)->Draw(pMWin->GObj[BetSpotUse[6]]->pHand6,pMWin);
  /*********/
  if(pMWin->GObj[BetSpotUse[6]]->pHand6->cards[0].name == AceHi)
  {
	 ((TBJDeck *)pDeck)->Busted(pMWin->GObj[BetSpotUse[6]]->pHand6);
	 return 1;
  }

  int action=0;
  while(((TBJDeck *)pDeck)->Busted(pMWin->GObj[BetSpotUse[6]]->pHand6) == 0 && action != 7)
  {
  //	cout << "1->Hit,2->Stand";
	if(pMWin->GObj[BetSpotUse[6]]->pHand6->inhand < 3)
	{
	//  cout << ",3->DoublDown";
	}
	else
	{
	 // cout << endl;
	}
 //	cin >> action;
	switch(action) {
	 case 1:  ((TBJDeck *)pDeck)->Draw(pMWin->GObj[BetSpotUse[6]]->pHand6,pMWin);break;
	 case 2:  return 2;
	 case 3:  DoubleDown(6);
				 if(((TBJDeck *)pDeck)->Busted(pMWin->GObj[BetSpotUse[6]]->pHand6))
             {
					break;
				 }
				 else
				 {
					return 3;
				 }
	 default : break;
	}
  }//while
 // cout << "Stone Cold Busted!" << endl;
  pMWin->GObj[BetSpotUse[6]]->coinsplayedhand6 = 0;
  if(pMWin->GObj[BetSpotUse[6]]->pHand6 != NULL)
  {
	 delete pMWin->GObj[BetSpotUse[6]]->pHand6;
	 pMWin->GObj[BetSpotUse[6]]->pHand6 = NULL;
  }
  BetSpotUse[6] = -1;
  return 1;
}
//*******************************************************************
TBJLord::Split9()
{
  pMWin->GObj[BetSpotUse[5]]->pHand6 = new TBJHand;
  BetSpotUse[6] = BetSpotUse[5];
  pMWin->GObj[BetSpotUse[6]]->coinsplayedhand6 = pMWin->GObj[BetSpotUse[5]]->coinsplayedhand5;
  pMWin->GObj[BetSpotUse[6]]->cash -= pMWin->GObj[BetSpotUse[6]]->coinsplayedhand6;
  pMWin->GObj[BetSpotUse[6]]->pHand6->cards[0] =
											  pMWin->GObj[BetSpotUse[5]]->pHand5->cards[0];
  pMWin->GObj[BetSpotUse[6]]->pHand6->inhand++;
  pMWin->GObj[BetSpotUse[5]]->pHand5->inhand--;
  //((TBJDeck *)pDeck)->Draw(pMWin->GObj[BetSpotUse[6]]->pHand6,pMWin);
  ((TBJDeck *)pDeck)->DontSplitDraw(pMWin->GObj[BetSpotUse[6]]->pHand6,pMWin,numofdecks);
  /*********/
  if(pMWin->GObj[BetSpotUse[6]]->pHand6->cards[0].name == AceHi)
  {
	 ((TBJDeck *)pDeck)->Busted(pMWin->GObj[BetSpotUse[6]]->pHand6);
	 return 1;
  }
  int action=0;
  while(((TBJDeck *)pDeck)->Busted(pMWin->GObj[BetSpotUse[6]]->pHand6) == 0 && action != 7)
  {
 ////	cout << "1->Hit,2->Stand";
	if(pMWin->GObj[BetSpotUse[6]]->pHand6->inhand < 3)
	{
	 // cout << ",3->DoublDown";
	}
	else
	{
	 // cout << endl;
	}
	//cin >> action;
	switch(action) {
	 case 1:  ((TBJDeck *)pDeck)->Draw(pMWin->GObj[BetSpotUse[6]]->pHand6,pMWin);break;
	 case 2:  return 2;
	 case 3:  DoubleDown(6);
				 if(((TBJDeck *)pDeck)->Busted(pMWin->GObj[BetSpotUse[6]]->pHand6))
             {
					break;
				 }
				 else
				 {
					return 3;
				 }
	 default : break;
	}
  }//while
//  cout << "Stone Cold Busted!" << endl;
  pMWin->GObj[BetSpotUse[6]]->coinsplayedhand6 = 0;
  if(pMWin->GObj[BetSpotUse[6]]->pHand6 != NULL)
  {
	 delete pMWin->GObj[BetSpotUse[6]]->pHand6;
	 pMWin->GObj[BetSpotUse[6]]->pHand6 = NULL;
  }
  BetSpotUse[6] = -1;
  return 1;
}
