//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  bjstate.cpp    // discard
//    Project Name:  Ogle
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     06/22/95   A. Krist    Original baseline
//  2.0     09/24/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "bjbs1st.h"
#include "cbjglord.h"
#include "otimers.h"
#include "bjdealst.h"
#include "bjbustst.h"
#include "cbjplay.h"
#include "bjdeck.h"
#include "bjs1st.h"
#include "bjs2st.h"
//#include "cbjglspl.h"
#include <iostream.h>
#include "orespond.h"
//*******************************************************************
TBJBetSpot1State::TBJBetSpot1State(TCasinoBJGameLord *pNewBJLord)
:TBJLordState(pNewBJLord)
{
  SetRunOrder(ess_Execute,ess_StartSubState4,ess_Done,
				  ess_Done,ess_Execute,ess_StartSubState2);
  RemoveDoubleResponder       = NULL;
  ClearNoInsureStandResponder = NULL;
  SameYesInsureHitResponder   = NULL;
  DealSplitResponder          = NULL;
  MenuEscResponder            = NULL;
  AskExpertResponder          = NULL;

  askexpertflag               = false;
  splitflag                   = false;
  doubleflag                  = false;
  splitbutton                 = false;
  firsttwocards               = true;
  StartingFUC = 0;
  FUCLength   = 0;
  WaitOnSkit  = false;
  pOwnerLord->splitwait       = false;
  FinishHit    = false;
  FinishStand  = false;
//  FinishSplit  = false;
  FinishDouble = false;
  WaitOnHitCom    = false;
  WaitOnStandCom  = false;
  WaitOnDoubleCom = false;
 // WaitOnSplitCom  = false;
}
//*******************************************************************
TBJBetSpot1State::~TBJBetSpot1State()
{
  //pOwnerLord->CasStatusBar->NoShowStatusBar();
  pOwnerLord->Circle1->NoShow();
  pOwnerLord->FreezeAllButtons();
}
//*******************************************************************
void TBJBetSpot1State::HandlePostUpdate(dword NewFUC)
{
  if(ExpertDelayStart)
  {
	 if(ExpertDelayStart + EXPERTDELAY <= NewFUC)
	 {
		ExpertDelayStart = 0;
		//pOwnerLord->AskExpertButton->Release();
	 }
  }
  if(WaitOnSkit)
  {
	 if((StartingFUC != 0) && ((StartingFUC + FUCLength) <= NewFUC))
	 {
		StartingFUC = 0;
		FUCLength   = 0;
		WaitOnSkit  = false;
		if(!FinishHit && !FinishStand && !FinishDouble)
		{
		  pOwnerLord->UnFreezeAllButtons();
		}
		if(LockHit)
		{
		  LockHit = false;
		  LockButtons = false;
		}
		if(HitTotal)
		{
		  if(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand1->highhand == 21 ||
			  pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand1->lohand == 21)
		  {
			 ExecuteWaiting = false;
			 ExecuteStatus  = ess_StartSubState2;
		  }
		  HitTotal = false;
		}
	 }
	 //???return;//?
  }
  if(!WaitOnSkit && WaitOnHitCom)
  {
//	 StartingFUC = PTimePtr->GetFrameUpdateCount() + 1;
	 StartingFUC = pOwnerLord->GetAdjFUC();
	 pOwnerLord->FreezeAllButtons();
	 pOwnerLord->HitComPlayer1(StartingFUC,FUCLength);
	 WaitOnSkit    = true;
	 WaitOnHitCom  = false;
	 FinishHit     = true;
  }
  if(!WaitOnSkit && FinishHit)
  {
	 ExecuteWaiting = false;
	 ExecuteStatus  = ess_StartSubState4;
	 FinishHit = false;
  }
  if(!WaitOnSkit && WaitOnStandCom)
  {
//	 StartingFUC = PTimePtr->GetFrameUpdateCount() + 1;
	 StartingFUC = pOwnerLord->GetAdjFUC();
	 pOwnerLord->FreezeAllButtons();
	 pOwnerLord->StandComPlayer1(StartingFUC,FUCLength);
	 WaitOnSkit    = true;
	 WaitOnStandCom  = false;
	 FinishStand     = true;
  }
  if(!WaitOnSkit && FinishStand)
  {
	 ExecuteWaiting = false;
	 ExecuteStatus  = ess_StartSubState2;
	 FinishStand = false;
  }
  if(!WaitOnSkit && WaitOnDoubleCom)
  {
//	 StartingFUC = PTimePtr->GetFrameUpdateCount() + 1;
	 StartingFUC = pOwnerLord->GetAdjFUC();
	 pOwnerLord->FreezeAllButtons();
	 pOwnerLord->DoubleComPlayer1(StartingFUC,FUCLength);
	 WaitOnSkit    = true;
	 WaitOnDoubleCom  = false;
	 FinishDouble     = true;
  }
  if(!WaitOnSkit && FinishDouble)
  {
	 ExecuteWaiting = false;
	 ExecuteStatus  = ess_StartSubState4;
	 FinishDouble = false;
  }
  if((Stalling + TCasinoBJGameLord::STALLDELAY) <= NewFUC)
  {
	 StartingFUC = pOwnerLord->GetAdjFUC();
	 pOwnerLord->FreezeAllButtons();
	 pOwnerLord->Stalling(StartingFUC,FUCLength);
	 WaitOnSkit    = true;
	 Stalling      = NewFUC + FUCLength;
  }
  if(pOwnerLord->ButtonHit[bjidButton16])
  {
	 if(StartingFUC == 0)
	 {
		CoachStats(1,bjStand,firsttwocards);
		Coach(1,bjStand);
	 }
	 if(IgnoreCoach)
	 {
		LockHit = false;
		pOwnerLord->ButtonClear(bjidButton16);
	  //	CoachStats(1,bjStand,firsttwocards);
	  //	Coach(1,bjStand);
		Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
      pOwnerLord->StallsInRow = 0;
		LockButtons = false;
		return;
	 }
	 if(StartingFUC)
	 {
		if(StartingFUC + FUCLength == NewFUC)
		{
		  WaitOnStandCom = true;
		  LockHit = false;
		  pOwnerLord->ButtonClear(bjidButton16);
		  Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
        pOwnerLord->StallsInRow = 0;
		  LockButtons = false;
		  StartingFUC = 0;
		  FUCLength   = 0;
		  return;
		}
	 }
	 else
	 {
		StartingFUC = pOwnerLord->GetAdjFUC();
		bool mf=true;
		pOwnerLord->FreezeAllButtons();
		pOwnerLord->StandFingers(mf,bjnl1B,StartingFUC,FUCLength);
	 }
	 return;
  }
  if(pOwnerLord->ButtonHit[bjidButton3])
  {
	 pOwnerLord->ButtonClear(bjidButton3);
	 return;
  }
  if(pOwnerLord->ButtonHit[bjidButton1])
  {
	 pOwnerLord->ButtonClear(bjidButton1);
	 return;
  }
  if(pOwnerLord->ButtonHit[bjidButton14])
  {
	 if(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand1->inhand < 3)
	 {
      CoachStats(1,bjDouble,firsttwocards);
		Coach(1,bjDouble);
		if(IgnoreCoach)
		{
		  pOwnerLord->ButtonClear(bjidButton14);
		  LockButtons = false;
		  return;
		}

		LockHit = false;
		pOwnerLord->ButtonClear(bjidButton14);
		pOwnerLord->DoubleDown(1);
		doubleflag = true;
		Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
      pOwnerLord->StallsInRow = 0;
		WaitOnDoubleCom = true;
		pOwnerLord->FreezeAllButtons();
	 }

	 return;
  }
  if(pOwnerLord->ButtonHit[bjidButton13])
  {
	 if(!LockButtons && pOwnerLord->GetCash(pOwnerLord->activeplayer) >=
	 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->coinsplayedhand1)
	 {
		if((pOwnerLord->BetSpotUse[0] == -1 || pOwnerLord->BetSpotUse[2] == -1) &&
		  pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->numsplitshand1 < 2 &&
		  pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand1->inhand < 3 &&
		((pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand1->cards[0].name ==
		  pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand1->cards[1].name) ||
		 (pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand1->cards[0].name >= Ten &&
		  pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand1->cards[0].name < AceHi) &&
		 (pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand1->cards[1].name >= Ten &&
		  pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand1->cards[1].name < AceHi)) )
		{
			 CoachStats(1,bjSplit,firsttwocards);
			 Coach(1,bjSplit);
			 if(IgnoreCoach)
			 {
				pOwnerLord->ButtonClear(bjidButton13);
				LockButtons = false;
				return;
			 }
			 if (pOwnerLord->BetSpotUse[0] == -1)
			 {
				pOwnerLord->FreezeAllButtons();
				ExecuteWaiting = false;
				LockButtons = false;
				ExecuteStatus = ess_StartSubState1;
				splitflag = true;
				pOwnerLord->BetSpot[1]->NoShowCard(1);
				pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->numsplitshand1++;
			 }
			 else if (pOwnerLord->BetSpotUse[2] == -1)
			 {
				pOwnerLord->FreezeAllButtons();
				ExecuteWaiting = false;
				ExecuteStatus = ess_StartSubState4;
				pOwnerLord->splitwait = true;
				splitflag = true;
				pOwnerLord->BetSpot[1]->NoShowCard(1);
				pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->numsplitshand1++;

				pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand2 = new TBJHand;
				pOwnerLord->BetSpotUse[2] = pOwnerLord->BetSpotUse[1];
				pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->coinsplayedhand2
				=  pOwnerLord->SplitMoney(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->coinsplayedhand1);

				pOwnerLord->BetSpot[2]->
					SetNum(pOwnerLord->GetBJPlayer(pOwnerLord->activeplayer)->coinsplayedhand2);

				pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->pHand2->cards[0] =
				pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand1->cards[1];
				pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->pHand2->inhand++;
				pOwnerLord->BetSpot[2]->ShowFace(
						  pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->pHand2);

				pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand1->inhand--;
            pOwnerLord->Button13->ShowGray();
			}
			Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
         pOwnerLord->StallsInRow = 0;
			pOwnerLord->ButtonClear(bjidButton13);
		}
	 }
	 LockHit = false;
	 Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	 pOwnerLord->ButtonClear(bjidButton13);
	 return;
  }
  if(pOwnerLord->ButtonHit[bjidButton15])
  {
	 if(StartingFUC == 0)
	 {
		CoachStats(1,bjHit,firsttwocards);
		Coach(1,bjHit);
	 }
    if(IgnoreCoach)
	 {
		Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
      pOwnerLord->StallsInRow = 0;
		pOwnerLord->ButtonClear(bjidButton15);
		LockButtons = false;
		return;
	 }
	 if(StartingFUC)
	 {
		if(StartingFUC + FUCLength <= NewFUC)
		{
		  WaitOnHitCom = true;
        Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
        pOwnerLord->StallsInRow = 0;
		  pOwnerLord->ButtonClear(bjidButton15);
		  StartingFUC = 0;
		  FUCLength   = 0;
		  return;
		}
	 }
	 else
	 {
		pOwnerLord->Button14->ShowGray();
		pOwnerLord->Button13->ShowGray();
		firsttwocards = false;
		StartingFUC = pOwnerLord->GetAdjFUC();
		bool mf=true;
		pOwnerLord->FreezeAllButtons();
		pOwnerLord->HitFingers(mf,bjnl1B,StartingFUC,FUCLength);
	 }
	 //LockHit = false;
	// Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;pOwnerLord->StallsInRow = 0;
	// pOwnerLord->ButtonClear(bjidButton15);
	 return;
  }
  if(pOwnerLord->ButtonHit[bjidButton2])
  {
	 LockHit = false;
	 Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	 pOwnerLord->ButtonClear(bjidButton2);
	 return;
  }
  if(pOwnerLord->ButtonHit[bjidButton0])
  {
    if(!askexpertflag)
	 {
		askexpertflag = true;
	 }
	 else
	 {
		if(firsttwocards)
		{
		  pOwnerLord->AskFirstTwoCardsExpert(1);
		}
		else
		{
		  pOwnerLord->AskAfterFirstTwoCardsExpert(1);
		}
		pOwnerLord->ButtonClear(bjidButton0);
		askexpertflag = false;
	 }
	 LockHit = false;
	 Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	 return;
  }

}
//*******************************************************************
bool TBJBetSpot1State::HandleRemoveDouble(TResponder &responder)
{
 if(!LockButtons && pOwnerLord->GetCash(pOwnerLord->activeplayer) > 0)
 {
  if(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand1->inhand < 3)
  {
	 if (responder.GetResponseEvent() == reLUp)
	 {
		CoachStats(1,bjDouble,firsttwocards);
		Coach(1,bjDouble);
		LockButtons = true;
		RemoveDoubleResponder = &responder;
	 }

	 if (responder.GetResponseEvent() == reLDown)
	 {
//		Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
		Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
      pOwnerLord->StallsInRow = 0;
  //		pOwnerLord->RemoveDouble->ShowDoubleDown();
		responder.SetPriority();
	 }

	 if (responder.GetResponseEvent() == reChar)
	 {
//		Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
		Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
      pOwnerLord->StallsInRow = 0;
	 //	pOwnerLord->RemoveDouble->ShowDoubleDown();
		RemoveDoubleResponder = &responder;
	 }
  }
 }
 return true;
}
//*******************************************************************
bool TBJBetSpot1State::HandleClearNoInsureStand(TResponder &responder)
{
 if(!LockButtons)
 {
  if (responder.GetResponseEvent() == reLUp)
  {
	 CoachStats(1,bjStand,firsttwocards);
	 Coach(1,bjStand);
	 LockButtons = true;
	 ClearNoInsureStandResponder = &responder;
  }

  if (responder.GetResponseEvent() == reLDown)
  {
//	 Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
	 Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
 //	 pOwnerLord->ClearNoInsureStand->ShowStandDown();
 //	 pOwnerLord->RemoveDouble->ShowDouble();
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
//	 Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
	 Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	 //pOwnerLord->ClearNoInsureStand->ShowStandDown();
	// pOwnerLord->RemoveDouble->ShowDouble();
	 ClearNoInsureStandResponder = &responder;
  }
 }
 return true;
}
//*******************************************************************
bool TBJBetSpot1State::HandleSameYesInsureHit(TResponder &responder)
{
 if(!LockButtons)
 {
  if (responder.GetResponseEvent() == reLUp)
  {
	 CoachStats(1,bjHit,firsttwocards);
	 Coach(1,bjHit);
	 LockButtons = true;
	 SameYesInsureHitResponder = &responder;
  }

  if (responder.GetResponseEvent() == reLDown)
  {
//	 Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
	 Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	/// pOwnerLord->SameYesInsureHit->ShowHitDown();
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
//	 Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
	 Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	// pOwnerLord->SameYesInsureHit->ShowHitDown();
	 SameYesInsureHitResponder = &responder;
  }
 }
 return true;
}
//*******************************************************************
bool TBJBetSpot1State::HandleDealSplit(TResponder &responder)
{
 if(!LockButtons && pOwnerLord->GetCash(pOwnerLord->activeplayer) >=
	 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->coinsplayedhand1)
 {
  if((pOwnerLord->BetSpotUse[0] == -1 || pOwnerLord->BetSpotUse[2] == -1) &&
		pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->numsplitshand1 < 2 &&
		pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand1->inhand < 3 &&
	 ((pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand1->cards[0].name ==
		pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand1->cards[1].name) ||
	  (pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand1->cards[0].name >= Ten &&
		pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand1->cards[0].name < AceHi) &&
	  (pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand1->cards[1].name >= Ten &&
		pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand1->cards[1].name < AceHi)) )
  {
	 if (responder.GetResponseEvent() == reLUp)
	 {
		CoachStats(1,bjSplit,firsttwocards);
		Coach(1,bjSplit);
		LockButtons = true;
		DealSplitResponder = &responder;
	 }

	 if (responder.GetResponseEvent() == reLDown)
	 {
//		Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
		Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
      pOwnerLord->StallsInRow = 0;
	 //	pOwnerLord->DealSplit->ShowSplitDown();
		responder.SetPriority();
	 }

	 if (responder.GetResponseEvent() == reChar)
	 {
//		Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
		Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
      pOwnerLord->StallsInRow = 0;
  //		pOwnerLord->DealSplit->ShowSplitDown();
		DealSplitResponder = &responder;
	 }
  }
 }
 return true;
}
//*******************************************************************
void TBJBetSpot1State::ExecuteFirstTime()
{
  pOwnerLord->Circle1->SetCircle(pOwnerLord->activeplayer,bjnl1B);
  ExecuteWaiting = true;
  ExecuteStatus    = ess_Execute;
 // pOwnerLord->Button12->Enabled = false;
  pOwnerLord->Button16->ShowVoidUp();
  pOwnerLord->Button15->ShowVoidUp();
  pOwnerLord->/*((TBJDeck *)*/pDeck->
	  Busted(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand1);
  if(pOwnerLord->GetCash(pOwnerLord->activeplayer) > 0)
  {
	 pOwnerLord->Button14->ShowVoidUp();
	 if(pOwnerLord->GetCash(pOwnerLord->activeplayer) <
		 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->coinsplayedhand1)
	 {
		pOwnerLord->Button13->ShowGray();
	 }
	 else if((pOwnerLord->BetSpotUse[0] == -1 || pOwnerLord->BetSpotUse[2] == -1) &&
			 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->numsplitshand1 < 2 &&
			 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand1->inhand < 3 &&
		  ((pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand1->cards[0].name ==
			 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand1->cards[1].name) ||
			(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand1->cards[0].name >= Ten &&
			 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand1->cards[0].name < AceHi) &&
			(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand1->cards[1].name >= Ten &&
			 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand1->cards[1].name < AceHi)) )
	 {
		pOwnerLord->Button13->ShowVoidUp();
	 }
	 else
	 {
		pOwnerLord->Button13->ShowGray();
	 }
  }
  else
  {
	 pOwnerLord->Button14->ShowGray();
	 pOwnerLord->Button13->ShowGray();
  }
  pOwnerLord->SwitchToPlayer(pOwnerLord->BetSpotUse[1]);
  pOwnerLord->pDeck->Busted(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand1);
  pOwnerLord->MessageDisplay->ShowBJMessage(pOwnerLord->PlayerTotal());
  PlayerTotalMessage(1);
  Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
  pOwnerLord->StallsInRow = 0;
  FinishHit    = false;
  FinishStand  = false;
  FinishDouble = false;
  WaitOnHitCom    = false;
  WaitOnStandCom  = false;
  WaitOnDoubleCom = false;
  pOwnerLord->UnFreezeAllButtons();
}
//*******************************************************************
void TBJBetSpot1State::CreateSubState1()
{
  ((TBJHand *)pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand1)->IsSplitHand = true;
  pOwnerLord->Circle1->SetPart(pOwnerLord->activeplayer,bjnl1A);
  PActiveSubState = new TBJSplit1State(pOwnerLord);
}
//*******************************************************************
void TBJBetSpot1State::EndSubState1()
{
  TState::EndSubState1();
  if(pOwnerLord->BetSpotUse[1] != -1)
  {
	 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand1->inhand--;
	 pOwnerLord->pDeck->Busted(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand1);
	 pOwnerLord->MessageDisplay->ShowBJMessage(pOwnerLord->PlayerTotal());
  }
  Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
  pOwnerLord->StallsInRow = 0;

  splitbutton = true;
  if(pOwnerLord->GetCash(pOwnerLord->activeplayer) > 0)
  {
	 pOwnerLord->Button14->ShowVoidUp();
  }
  pOwnerLord->Circle1->SetPart(pOwnerLord->activeplayer,bjnl1B);
  pOwnerLord->FreezeAllButtons();
}
//*******************************************************************
void TBJBetSpot1State::CreateSubState2()
{
  if(pOwnerLord->splitwait)
  {
    ((TBJHand *)pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->pHand2)->IsSplitHand = true;
	 pOwnerLord->Circle1->SetCircle(pOwnerLord->activeplayer,bjnl1C);
	 PActiveSubState = new TBJSplit2State(pOwnerLord,1);
  }
}
//*******************************************************************
void TBJBetSpot1State::EndSubState2()
{
  TState::EndSubState2();
  if(pOwnerLord->BetSpotUse[1] != -1)
  {
	 pOwnerLord->pDeck->Busted(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand1);
	 pOwnerLord->MessageDisplay->ShowBJMessage(pOwnerLord->PlayerTotal());
  }
  Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
  pOwnerLord->StallsInRow = 0;
  ExecuteWaiting   = false;
  pOwnerLord->splitwait = false;
  pOwnerLord->FreezeAllButtons();
}
//*******************************************************************
void TBJBetSpot1State::CreateSubState3()
{
  //PActiveSubState = new TBJBustedState(pOwnerLord);
}
//*******************************************************************
void TBJBetSpot1State::CreateSubState4()
{
  pOwnerLord->FreezeAllButtons();
  PActiveSubState = new TBJDealState(pOwnerLord,1);
}
//*******************************************************************
void TBJBetSpot1State::EndSubState4()
{
  TState::EndSubState4();
  if(pOwnerLord->/*((TBJDeck *)*/pDeck->
	  Busted(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand1) == 1)
  {
    pOwnerLord->FreezeAllButtons();
	 ExecuteStatus = ess_StartSubState5;
  }
  else if(doubleflag == true)
  {
	 doubleflag = false;
	 ExecuteStatus = ess_StartSubState2;
	 ExecuteWaiting = false;   //gets set to true below, fool.
  }
  else
  {
	 if(splitflag == true && pOwnerLord->
		 GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand1->cards[0].name == AceHi)
	 {
		splitflag = false;
		ExecuteStatus = ess_StartSubState2;
	 }
	 else
	 {
		splitflag = false;
	 }
  }
  ExecuteWaiting = true;
  PlayerTotalMessage(1);
  if(ExecuteStatus != ess_StartSubState2 && ExecuteStatus != ess_StartSubState5)
  {
	 StartingFUC = pOwnerLord->GetAdjFUC();
	 pOwnerLord->AnnouncePlayer1Total(StartingFUC,FUCLength);
    pOwnerLord->FreezeAllButtons();
	 WaitOnSkit    = true;
	 LockHit = true;
	 HitTotal = true;
  }
  if(splitbutton)
  {
	 LockButtons = false;
	 splitbutton = false;
	 if((pOwnerLord->BetSpotUse[0] == -1 || pOwnerLord->BetSpotUse[2] == -1)  &&
		pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->numsplitshand1 < 2 &&
		pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand1->inhand < 3 &&
		pOwnerLord->GetCash(pOwnerLord->activeplayer) >=
		pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->coinsplayedhand1   &&
	 ((pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand1->cards[0].name ==
		pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand1->cards[1].name) ||
	  (pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand1->cards[0].name >= Ten &&
		pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand1->cards[0].name < AceHi) &&
	  (pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand1->cards[1].name >= Ten &&
		pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand1->cards[1].name < AceHi)) )
	 {
		pOwnerLord->Button13->ShowVoidUp();
	 }
	 else
	 {
		pOwnerLord->Button13->ShowGray();
	 }
  }
  Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
  pOwnerLord->StallsInRow = 0;
}
//*******************************************************************
void TBJBetSpot1State::CreateSubState5()
{
  PActiveSubState = new TBJBustState(pOwnerLord,1);
}
//*******************************************************************
bool TBJBetSpot1State::HandleMenuEsc(TResponder &responder)
{
	if (responder.GetResponseEvent() == reLUp)
  {
	 MenuEscResponder = &responder;
  }

  if (responder.GetResponseEvent() == reLDown)
  {
//	 Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
	 Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
 ///	 pOwnerLord->MenuEscButton->Depress();
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
//	 Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
	 Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
  //	 pOwnerLord->MenuEscButton->Depress();
	 MenuEscResponder = &responder;
  }

  return true;
}
//*******************************************************************
bool TBJBetSpot1State::HandleAskExpert(TResponder &responder)
{
	if (responder.GetResponseEvent() == reLUp)
  {
	 AskExpertResponder = &responder;
  }

  if (responder.GetResponseEvent() == reLDown)
  {
//	 Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
	 Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
  //	 pOwnerLord->AskExpertButton->Depress();
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
//	 Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
	 Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	// pOwnerLord->AskExpertButton->Depress();
	 AskExpertResponder = &responder;
  }

  return true;
}

//*******************************************************************
