//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  bjbs2st.cpp    // bet spot 2 state
//    Project Name:  Ogle
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     06/22/95   A. Krist    Original baseline
//  2.0     09/24/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "bjbs2st.h"
#include "cbjglord.h"
#include "otimers.h"
#include "bjdealst.h"
#include "bjbustst.h"
#include "cbjplay.h"
#include "bjdeck.h"
#include "bjs3st.h"
#include "bjs4st.h"
#include "bjaskex.h"
//#include "cbjglspl.h"
#include <iostream.h>
#include "orespond.h"
//*******************************************************************
TBJBetSpot2State::TBJBetSpot2State(TCasinoBJGameLord *pNewBJLord)
:TBJLordState(pNewBJLord)
{
  SetRunOrder(ess_Execute,ess_StartSubState4,ess_Done,
				  ess_Done,ess_Execute,ess_StartSubState2);
  RemoveDoubleResponder       = NULL;
  ClearNoInsureStandResponder = NULL;
  SameYesInsureHitResponder   = NULL;
  DealSplitResponder          = NULL;
  MenuEscResponder            = NULL;
  AskExpertResponder          = NULL;

  firsttwocards               = true;
  askexpertflag               = false;
  splitflag                   = false;
  doubleflag                  = false;
  pOwnerLord->splitwait       = false;
  splitbutton                 = false;
  StartingFUC = 0;
  FUCLength   = 0;
  WaitOnSkit  = false;
  FinishHit    = false;
  FinishStand  = false;
  FinishSplit  = false;
  FinishDouble = false;
  WaitOnHitCom    = false;
  WaitOnStandCom  = false;
  WaitOnDoubleCom = false;
  WaitOnSplitCom  = false;
}
//*******************************************************************
TBJBetSpot2State::~TBJBetSpot2State()
{
 // pOwnerLord->CasStatusBar->NoShowStatusBar();
  pOwnerLord->FreezeAllButtons();
  pOwnerLord->Circle2->NoShow();
}
//*******************************************************************
void TBJBetSpot2State::HandlePostUpdate(dword NewFUC)
{
  if(pOwnerLord->ButtonHit[bjidButton2])
  {
	 LockHit = false;
	 Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	 pOwnerLord->ButtonClear(bjidButton2);
	 return;
  }
  if(pOwnerLord->ButtonHit[bjidButton3])
  {
	 pOwnerLord->ButtonClear(bjidButton3);
	 return;
  }
  if(pOwnerLord->ButtonHit[bjidButton1])
  {
	 pOwnerLord->ButtonClear(bjidButton1);
	 return;
  }
  if(pOwnerLord->ButtonHit[bjidButton0])
  {
	 if(!askexpertflag)
	 {
		askexpertflag = true;
	 }
	 else
	 {
		if(firsttwocards)
		{
		  pOwnerLord->AskFirstTwoCardsExpert(3);
		}
		else
		{
		  pOwnerLord->AskAfterFirstTwoCardsExpert(3);
		}
		pOwnerLord->ButtonClear(bjidButton0);
		askexpertflag = false;
	 }
	 LockHit = false;
	 Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	 return;
  }
  if(ExpertDelayStart)
  {
	 if(ExpertDelayStart + EXPERTDELAY <= NewFUC)
	 {
		ExpertDelayStart = 0;
	 //	pOwnerLord->AskExpertButton->Release();
	 }
  }
  if(WaitOnSkit)
  {
	 if((StartingFUC != 0) && ((StartingFUC + FUCLength) <= NewFUC))
	 {
		StartingFUC = 0;
		FUCLength   = 0;
		WaitOnSkit  = false;
		if(!FinishHit && !FinishStand && !FinishDouble && !FinishSplit)
		{
		  pOwnerLord->UnFreezeAllButtons();
		}
		if(LockHit)
		{
		  LockHit = false;
		  LockButtons = false;
		}
      if(HitTotal)
		{
		  if(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3->highhand == 21 ||
			  pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3->lohand == 21)
		  {
          ExecuteWaiting = false;
	       ExecuteStatus  = ess_StartSubState2;
		  }
		  HitTotal = false;
		}
	 }
	//?/ return;//?
  }
  if(!WaitOnSkit && WaitOnHitCom)
  {
//	 StartingFUC = PTimePtr->GetFrameUpdateCount() + 1;
    StartingFUC = pOwnerLord->GetAdjFUC();
	 pOwnerLord->HitComPlayer2(StartingFUC,FUCLength);
    pOwnerLord->FreezeAllButtons();
	 WaitOnSkit    = true;
	 WaitOnHitCom  = false;
	 FinishHit     = true;
  }
  if(!WaitOnSkit && FinishHit)
  {
	 ExecuteWaiting = false;
	 ExecuteStatus  = ess_StartSubState4;
	 FinishHit = false;
  }
  if(!WaitOnSkit && WaitOnStandCom)
  {
//	 StartingFUC = PTimePtr->GetFrameUpdateCount() + 1;
    StartingFUC = pOwnerLord->GetAdjFUC();
	 pOwnerLord->StandComPlayer2(StartingFUC,FUCLength);
    pOwnerLord->FreezeAllButtons();
	 WaitOnSkit    = true;
	 WaitOnStandCom  = false;
	 FinishStand     = true;
  }
  if(!WaitOnSkit && FinishStand)
  {
	 ExecuteWaiting = false;
	 ExecuteStatus  = ess_StartSubState2;
	 FinishStand = false;
  }
  if(!WaitOnSkit && WaitOnDoubleCom)
  {
//	 StartingFUC = PTimePtr->GetFrameUpdateCount() + 1;
    StartingFUC = pOwnerLord->GetAdjFUC();
	 pOwnerLord->DoubleComPlayer2(StartingFUC,FUCLength);
    pOwnerLord->FreezeAllButtons();
	 WaitOnSkit    = true;
	 WaitOnDoubleCom  = false;
	 FinishDouble     = true;
  }
  if(!WaitOnSkit && FinishDouble)
  {
	 ExecuteWaiting = false;
	 ExecuteStatus  = ess_StartSubState4;
	 FinishDouble = false;
  }
  if(!WaitOnSkit && FinishSplit)
  {
	 FinishSplit = false;
	 if (pOwnerLord->BetSpotUse[2] == -1)
	 {
		LockButtons = false;
		pOwnerLord->Button13->ShowVoidUp();
		ExecuteWaiting = false;
		ExecuteStatus = ess_StartSubState1;
		splitflag = true;
		pOwnerLord->BetSpot[3]->NoShowCard(1);
		pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->numsplitshand3++;
	 }
	 else if (pOwnerLord->BetSpotUse[4] == -1)
	 {
		pOwnerLord->Button13->ShowGray();
		ExecuteWaiting = false;
		ExecuteStatus = ess_StartSubState4;
		pOwnerLord->splitwait = true;
		splitflag = true;
		pOwnerLord->BetSpot[3]->NoShowCard(1);
		pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->numsplitshand3++;

		pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand4 = new TBJHand;
		pOwnerLord->BetSpotUse[4] = pOwnerLord->BetSpotUse[3];
		pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->coinsplayedhand4
			= pOwnerLord->SplitMoney(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->coinsplayedhand3);
		pOwnerLord->BetSpot[4]->
			 SetNum(pOwnerLord->GetBJPlayer(pOwnerLord->activeplayer)->coinsplayedhand4);

		pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->cards[0] =
			  pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3->cards[1];
		pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->inhand++;
		pOwnerLord->BetSpot[4]->ShowFace(
						  pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4);

		pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3->inhand--;
	 }
  }
  if((Stalling + TCasinoBJGameLord::STALLDELAY) <= NewFUC)
  {
//	 StartingFUC = PTimePtr->GetFrameUpdateCount() + 1;
    StartingFUC = pOwnerLord->GetAdjFUC();
	 pOwnerLord->Stalling(StartingFUC,FUCLength);
	 pOwnerLord->FreezeAllButtons();
	 WaitOnSkit    = true;
	 Stalling      = NewFUC + FUCLength;
  }
  if(pOwnerLord->ButtonHit[bjidButton16])
  {
	 if(StartingFUC == 0)
	 {
		CoachStats(3,bjStand,firsttwocards);
		Coach(3,bjStand);
	 }
	 if(IgnoreCoach)
	 {
		LockHit = false;
		pOwnerLord->ButtonClear(bjidButton16);
	  //	CoachStats(1,bjStand,firsttwocards);
	  //	Coach(1,bjStand);
		Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
      pOwnerLord->StallsInRow = 0;
		LockButtons = false;
		return;
	 }
	 if(StartingFUC)
	 {
		if(StartingFUC + FUCLength == NewFUC)
		{
		  WaitOnStandCom = true;
		  LockHit = false;
		  pOwnerLord->ButtonClear(bjidButton16);
		  Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
        pOwnerLord->StallsInRow = 0;
		  LockButtons = false;
		  StartingFUC = 0;
		  FUCLength   = 0;
		  return;
		}
	 }
	 else
	 {
		StartingFUC = pOwnerLord->GetAdjFUC();
		bool mf=true;
		pOwnerLord->FreezeAllButtons();
		pOwnerLord->StandFingers(mf,bjnl2D,StartingFUC,FUCLength);
	 }
	 return;
  }
  if(pOwnerLord->ButtonHit[bjidButton14])
  {
	 if(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3->inhand < 3)
	 {
		CoachStats(3,bjDouble,firsttwocards);
		Coach(3,bjDouble);
		if(IgnoreCoach)
		{
		  pOwnerLord->ButtonClear(bjidButton14);
		  LockButtons = false;
		  return;
		}

		LockHit = false;
		pOwnerLord->ButtonClear(bjidButton14);
		pOwnerLord->DoubleDown(3);
		doubleflag = true;
		Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
      pOwnerLord->StallsInRow = 0;
		WaitOnDoubleCom = true;
		pOwnerLord->FreezeAllButtons();
	 }

	 return;
  }
  if(pOwnerLord->ButtonHit[bjidButton13])
  {
	 if(!LockButtons && pOwnerLord->GetCash(pOwnerLord->activeplayer) >=
	 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->coinsplayedhand3)
	 {
		if((pOwnerLord->BetSpotUse[4] == -1 || pOwnerLord->BetSpotUse[2] == -1) &&
		pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->numsplitshand3 < 2 &&
		pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3->inhand < 3 &&
	 ((pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3->cards[0].name ==
		pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3->cards[1].name) ||
	  (pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3->cards[0].name >= Ten &&
		pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3->cards[0].name < AceHi) &&
	  (pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3->cards[1].name >= Ten &&
		pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3->cards[1].name < AceHi) ) )
	  {
		 CoachStats(3,bjSplit,firsttwocards);
		 Coach(3,bjSplit);
		 if(IgnoreCoach)
		 {
			pOwnerLord->ButtonClear(bjidButton13);
			LockButtons = false;
			return;
		 }
		 if(pOwnerLord->BetSpotUse[2] == -1 || pOwnerLord->BetSpotUse[4] == -1)
		 {
			FUCLength = 0;
			StartingFUC = pOwnerLord->GetAdjFUC();
			pOwnerLord->SplitComPlayer2(StartingFUC,FUCLength);
         pOwnerLord->FreezeAllButtons();
			WaitOnSkit    = true;
			FinishSplit   = true;
		 }
       Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
       pOwnerLord->StallsInRow = 0;
		 pOwnerLord->ButtonClear(bjidButton13);
	  }
	 }
    Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	 pOwnerLord->ButtonClear(bjidButton13);
	 return;
  }

  if(pOwnerLord->ButtonHit[bjidButton15])
  {
	 if(StartingFUC == 0)
	 {
		CoachStats(3,bjHit,firsttwocards);
		Coach(3,bjHit);
	 }
	 if(IgnoreCoach)
	 {
		Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
      pOwnerLord->StallsInRow = 0;
		pOwnerLord->ButtonClear(bjidButton15);
		LockButtons = false;
		return;
	 }
    if(StartingFUC)
	 {
		if(StartingFUC + FUCLength <= NewFUC)
		{
		  WaitOnHitCom = true;
        Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
        pOwnerLord->StallsInRow = 0;
		  pOwnerLord->ButtonClear(bjidButton15);
		  StartingFUC = 0;
		  FUCLength   = 0;
		  return;
		}
	 }
	 else
	 {
		pOwnerLord->Button14->ShowGray();
		pOwnerLord->Button13->ShowGray();
		firsttwocards = false;
		StartingFUC = pOwnerLord->GetAdjFUC();
		bool mf=true;
		pOwnerLord->FreezeAllButtons();
		pOwnerLord->HitFingers(mf,bjnl2D,StartingFUC,FUCLength);
	 }
	 //LockHit = false;
	// Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;pOwnerLord->StallsInRow = 0;
	// pOwnerLord->ButtonClear(bjidButton15);
	 return;
  }

}
//*******************************************************************
bool TBJBetSpot2State::HandleRemoveDouble(TResponder &responder)
{
 if(!LockButtons && pOwnerLord->GetCash(pOwnerLord->activeplayer) > 0)
 {
	if(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3->inhand < 3)
	{
	 if (responder.GetResponseEvent() == reLUp)
	 {
		CoachStats(3,bjDouble,firsttwocards);
		Coach(3,bjDouble);
		LockButtons = true;
		RemoveDoubleResponder = &responder;
	 }

	 if (responder.GetResponseEvent() == reLDown)
	 {
//		Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
      Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
      pOwnerLord->StallsInRow = 0;
//		pOwnerLord->RemoveDouble->ShowDoubleDown();
		responder.SetPriority();
	 }

	 if (responder.GetResponseEvent() == reChar)
	 {
//		Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
      Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
      pOwnerLord->StallsInRow = 0;
  //		pOwnerLord->RemoveDouble->ShowDoubleDown();
		RemoveDoubleResponder = &responder;
	 }
  }
 }
 return true;

}
//*******************************************************************
bool TBJBetSpot2State::HandleClearNoInsureStand(TResponder &responder)
{
  if(!LockButtons)
  {
	 if (responder.GetResponseEvent() == reLUp)
	 {
		CoachStats(3,bjStand,firsttwocards);
		Coach(3,bjStand);
		LockButtons = true;
		ClearNoInsureStandResponder = &responder;
	 }
	 if (responder.GetResponseEvent() == reLDown)
	 {
//		Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
      Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
      pOwnerLord->StallsInRow = 0;
 //		pOwnerLord->ClearNoInsureStand->ShowStandDown();
  //		pOwnerLord->RemoveDouble->ShowDouble();
		responder.SetPriority();
	 }
	 if (responder.GetResponseEvent() == reChar)
	 {
//		Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
      Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
      pOwnerLord->StallsInRow = 0;
	  //	pOwnerLord->ClearNoInsureStand->ShowStandDown();
	 //	pOwnerLord->RemoveDouble->ShowDouble();
		ClearNoInsureStandResponder = &responder;
	 }
 }
 return true;
}
//*******************************************************************
bool TBJBetSpot2State::HandleSameYesInsureHit(TResponder &responder)
{
 if(!LockButtons)
 {
	 if (responder.GetResponseEvent() == reLUp)
	 {
		CoachStats(3,bjHit,firsttwocards);
      Coach(3,bjHit);
		LockButtons = true;
		SameYesInsureHitResponder = &responder;
	 }
	 if (responder.GetResponseEvent() == reLDown)
	 {
//		Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
      Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
      pOwnerLord->StallsInRow = 0;
	  //	pOwnerLord->SameYesInsureHit->ShowHitDown();
		responder.SetPriority();
	 }
	 if (responder.GetResponseEvent() == reChar)
	 {
//		Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
      Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
      pOwnerLord->StallsInRow = 0;
	  //	pOwnerLord->SameYesInsureHit->ShowHitDown();
		SameYesInsureHitResponder = &responder;
	 }
 }
 return true;
}
//*******************************************************************
bool TBJBetSpot2State::HandleDealSplit(TResponder &responder)
{
 if(!LockButtons && pOwnerLord->GetCash(pOwnerLord->activeplayer) >=
	 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->coinsplayedhand3)
 {
	 if((pOwnerLord->BetSpotUse[4] == -1 || pOwnerLord->BetSpotUse[2] == -1) &&
		pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->numsplitshand3 < 2 &&
		pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3->inhand < 3 &&
	 ((pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3->cards[0].name ==
		pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3->cards[1].name) ||
	  (pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3->cards[0].name >= Ten &&
		pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3->cards[0].name < AceHi) &&
	  (pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3->cards[1].name >= Ten &&
		pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3->cards[1].name < AceHi) ) )
  {
	 if (responder.GetResponseEvent() == reLUp)
	 {
		CoachStats(3,bjSplit,firsttwocards);
		Coach(3,bjSplit);
		LockButtons = true;
		DealSplitResponder = &responder;
	 }

	 if (responder.GetResponseEvent() == reLDown)
	 {
//		Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
      Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
      pOwnerLord->StallsInRow = 0;
	  //	pOwnerLord->DealSplit->ShowSplitDown();
		responder.SetPriority();
	 }

	 if (responder.GetResponseEvent() == reChar)
	 {
//		Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
      Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
      pOwnerLord->StallsInRow = 0;
  //		pOwnerLord->DealSplit->ShowSplitDown();
		DealSplitResponder = &responder;
	 }
  }
 }
 return true;
}
//*******************************************************************
void TBJBetSpot2State::ExecuteFirstTime()
{
  pOwnerLord->Circle2->SetCircle(pOwnerLord->activeplayer,bjnl2D);
  pOwnerLord->pDeck->Busted(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3);
  pOwnerLord->MessageDisplay->ShowBJMessage(pOwnerLord->PlayerTotal());
  ExecuteWaiting = true;
  ExecuteStatus    = ess_Execute;
  pOwnerLord->Button15->ShowVoidUp();
  pOwnerLord->Button16->ShowVoidUp();
  PlayerTotalMessage(3);
  if(pOwnerLord->GetCash(pOwnerLord->activeplayer) > 0)
  {
	 pOwnerLord->Button14->ShowVoidUp();
	 if(pOwnerLord->GetCash(pOwnerLord->activeplayer) <
		 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->coinsplayedhand3)
	 {
		pOwnerLord->Button13->ShowGray();
	 }
	 else if((pOwnerLord->BetSpotUse[4] == -1 || pOwnerLord->BetSpotUse[2] == -1) &&
			 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->numsplitshand3 < 2 &&
			 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3->inhand < 3 &&
		  ((pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3->cards[0].name ==
			 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3->cards[1].name) ||
			(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3->cards[0].name >= Ten &&
			 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3->cards[0].name < AceHi) &&
			(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3->cards[1].name >= Ten &&
			 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3->cards[1].name < AceHi)) )
	 {
		pOwnerLord->Button13->ShowVoidUp();
	 }
	 else
	 {
		pOwnerLord->Button13->ShowGray();
	 }
  }
  else
  {
	 pOwnerLord->Button14->ShowGray();
	 pOwnerLord->Button13->ShowGray();
  }
  pOwnerLord->SwitchToPlayer(pOwnerLord->BetSpotUse[3]);
  Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
  pOwnerLord->StallsInRow = 0;
  pOwnerLord->UnFreezeAllButtons();
}
//*******************************************************************
void TBJBetSpot2State::CreateSubState1()
{
  ((TBJHand *)pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3)->IsSplitHand = true;
  pOwnerLord->Circle2->SetPart(pOwnerLord->activeplayer,bjnl2C);
  PActiveSubState = new TBJSplit3State(pOwnerLord);
}
//*******************************************************************
void TBJBetSpot2State::EndSubState1()
{
  TState::EndSubState1();
//  Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
  Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
  pOwnerLord->StallsInRow = 0;
  splitbutton = true;
  pOwnerLord->Circle2->SetPart(pOwnerLord->activeplayer,bjnl2D);
  if(pOwnerLord->BetSpotUse[3] != -1)
  {
	 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3->inhand--;
	 pOwnerLord->pDeck->Busted(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3);
	 pOwnerLord->MessageDisplay->ShowBJMessage(pOwnerLord->PlayerTotal());
  }
  if(pOwnerLord->GetCash(pOwnerLord->activeplayer) > 0)
  {
	 pOwnerLord->Button14->ShowVoidUp();
  }
  pOwnerLord->FreezeAllButtons();
}
//*******************************************************************
void TBJBetSpot2State::CreateSubState2()
{
  if(pOwnerLord->splitwait)
  {
	 ((TBJHand *)pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4)->IsSplitHand = true;
	 pOwnerLord->Circle2->SetPart(pOwnerLord->activeplayer,bjnl2E);
	 PActiveSubState = new TBJSplit4State(pOwnerLord,1);
  }
}
//*******************************************************************
void TBJBetSpot2State::EndSubState2()
{
  TState::EndSubState2();
  ExecuteWaiting   = false;
//  Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
  Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
  pOwnerLord->StallsInRow = 0;
  if(pOwnerLord->BetSpotUse[3] != -1)
  {
	 pOwnerLord->pDeck->Busted(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3);
	 pOwnerLord->MessageDisplay->ShowBJMessage(pOwnerLord->PlayerTotal());
  }
  pOwnerLord->splitwait = false;
  pOwnerLord->FreezeAllButtons();
}
//*******************************************************************
void TBJBetSpot2State::CreateSubState3()
{
  //PActiveSubState = new TBJBustedState(pOwnerLord);
}
//*******************************************************************
void TBJBetSpot2State::CreateSubState4()
{
  pOwnerLord->FreezeAllButtons();
  PActiveSubState = new TBJDealState(pOwnerLord,4);
}
//*******************************************************************
void TBJBetSpot2State::EndSubState4()
{
  TState::EndSubState4();
  if(pOwnerLord->/*((TBJDeck *)*/pDeck->
	  Busted(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3) == 1)
  {
	 pOwnerLord->FreezeAllButtons();
	 ExecuteStatus = ess_StartSubState5;
  }
  else if(doubleflag == true)
  {
	 doubleflag = false;
	 ExecuteStatus = ess_StartSubState2;
	 ExecuteWaiting = false;
  }
  else
  {
	 if(splitflag == true && pOwnerLord->
		 GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3->cards[0].name == AceHi)
	 {
		splitflag = false;
		ExecuteStatus = ess_StartSubState2;
	 }
	 else
	 {
		splitflag = false;
	 }
  }
  ExecuteWaiting = true;
  PlayerTotalMessage(3);
  if(ExecuteStatus != ess_StartSubState2 && ExecuteStatus != ess_StartSubState5)
  {
	 StartingFUC = pOwnerLord->GetAdjFUC();
	 FUCLength = 0;
	 pOwnerLord->AnnouncePlayer2Total(StartingFUC,FUCLength);
    pOwnerLord->FreezeAllButtons();
	 WaitOnSkit    = true;
	 LockHit = true;
	 HitTotal = true;
  }
  if(splitbutton)
  {
	 LockButtons = false;
	 splitbutton = false;
	 if((pOwnerLord->BetSpotUse[4] == -1 || pOwnerLord->BetSpotUse[2] == -1) &&
			 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->numsplitshand3 < 2 &&
			 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3->inhand < 3 &&
			 pOwnerLord->GetCash(pOwnerLord->activeplayer) >=
			 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->coinsplayedhand3   &&
		  ((pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3->cards[0].name ==
			 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3->cards[1].name) ||
			(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3->cards[0].name >= Ten &&
			 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3->cards[0].name < AceHi) &&
			(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3->cards[1].name >= Ten &&
			 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3->cards[1].name < AceHi)) )
	 {
		pOwnerLord->Button13->ShowVoidUp();
	 }
	 else
	 {
		pOwnerLord->Button13->ShowGray();
	 }
  }
  Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
  pOwnerLord->StallsInRow = 0;
}
//*******************************************************************
void TBJBetSpot2State::CreateSubState5()
{
  PActiveSubState = new TBJBustState(pOwnerLord,4);
}
//*******************************************************************
bool TBJBetSpot2State::HandleMenuEsc(TResponder &responder)
{
	if (responder.GetResponseEvent() == reLUp)
  {
	 MenuEscResponder = &responder;
  }

  if (responder.GetResponseEvent() == reLDown)
  {
//	 Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
	 Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	// pOwnerLord->MenuEscButton->Depress();
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)               
  {
//	 Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
	 Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	// pOwnerLord->MenuEscButton->Depress();
	 MenuEscResponder = &responder;
  }

  return true;
}
//*******************************************************************
bool TBJBetSpot2State::HandleAskExpert(TResponder &responder)
{
	if (responder.GetResponseEvent() == reLUp)
  {
	 AskExpertResponder = &responder;
  }

  if (responder.GetResponseEvent() == reLDown)
  {
//	 Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
	 Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	 //pOwnerLord->AskExpertButton->Depress();
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
//	 Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
	 Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	// pOwnerLord->AskExpertButton->Depress();
	 AskExpertResponder = &responder;
  }

  return true;
}

//*******************************************************************//*******************************************************************
