//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  bjbustst.cpp
//    Project Name:  Ogle
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     06/22/95   A. Krist    Original baseline
//  2.0     09/23/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "bjbustst.h"
#include "cbjglord.h"
#include "otimers.h"
#include "bjgobj.h"
#include "casbjmw.h"
#include "cbjdlrsp.h"
#include "cbjbssp.h"  // bet spot
#include "cbjdspsp.h"  // dealer spot
#include <iostream.h>
//*******************************************************************
TBJBustState::TBJBustState(TCasinoBJGameLord *pNewBJLord,int16 BustTo)
:TBJLordState(pNewBJLord)
{
  bustto = BustTo;
  FUCLength = 0;
  StartingFUC = 0;
  WaitOnSkit = false;
  WaitOnDealerBJ = false;
  FinishDealerBJ = false;
  WaitOnPlayer = false;
  FinishPlayer = false;
  FirstTime = false;
  remove = 0;
  show = 0;
  discards = 0;
}
//*******************************************************************
TBJBustState::~TBJBustState()
{
}
//*******************************************************************
void TBJBustState::ExecuteFirstTime()
{
  switch(bustto) {
	 case 0  : discards = pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[0])->pHand0->inhand;break;
	 case 1  : discards = pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand1->inhand;break;
	 case 2  : discards = pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->pHand2->inhand;break;
	 case 3  : discards = pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->pHand2->inhand;break;
	 case 4  : discards = pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3->inhand;break;
	 case 5  : discards = pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->inhand;break;
	 case 6  : discards = pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->inhand;break;
	 case 7  : discards = pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->pHand5->inhand;break;
	 case 8  : discards = pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[6])->pHand6->inhand;break;
	 case 9  : discards = pOwnerLord->pHand->inhand;break;
	 case 10 : discards = pOwnerLord->pHand->inhand;break;
  }

  int bsi;
  switch (bustto)
  {
    case 0:bsi = 0;break;
    case 1:bsi = 1;break;
    case 2:bsi = 2;break;
    case 3:bsi = 3;break;
    case 4:bsi = 3;break;
    case 5:bsi = 4;break;
    case 6:bsi = 4;break;
    case 7:bsi = 5;break;
    case 8:bsi = 6;break;
  }
  int16 session = pOwnerLord->GetCasPD(pOwnerLord->BetSpotUse[bsi])->BJData.CurrentSession;
  TCBJSession &cs = pOwnerLord->GetCasPD(pOwnerLord->BetSpotUse[bsi])->BJData.Sessions[session];

  switch(bustto)
  {                             //coinsplayedhandX gets cleared in clear function
    case 0:
			  cs.Busts++;
			  cs.CurrentWinStreak = 0;
			  cs.CurrentLosingStreak++;
			  if(pOwnerLord->StartTC > 0)
			  {
			    cs.TotalCashWLCGT1 -= pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[0])->coinsplayedhand0;
           }
           if(pOwnerLord->StartTC < 1)
           {
             cs.TotalCashWLCLT1 -= pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[0])->coinsplayedhand0;
           }
           if(cs.CurrentLosingStreak > cs.LosingStreak)
           {
             cs.LosingStreak = cs.CurrentLosingStreak;
           }
           if(cs.LargestLoss < pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[0])->coinsplayedhand0)
           {
             cs.LargestLoss = pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[0])->coinsplayedhand0;
           }
           if(((TBJHand *)pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[0])->pHand0)->IsDDHand)
           {
             cs.DDWinnings -= pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[0])->coinsplayedhand0;
           }
           cs.Losses++;
           cs.SplitsWL -= pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[0])->coinsplayedhand0;
           pOwnerLord->BetSpotUse[bustto] = -1;
           break;
    case 1:
           cs.Busts++;
           cs.CurrentWinStreak = 0;
           cs.CurrentLosingStreak++;
           if(pOwnerLord->StartTC > 0)
           {
             cs.TotalCashWLCGT1 -= pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->coinsplayedhand1;
           }
           if(pOwnerLord->StartTC < 1)
           {
             cs.TotalCashWLCLT1 -= pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->coinsplayedhand1;
           }
           if (cs.CurrentLosingStreak > cs.LosingStreak)
           {
             cs.LosingStreak = cs.CurrentLosingStreak;
           }
           if (cs.LargestLoss < pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->coinsplayedhand1)
           {
             cs.LargestLoss = pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->coinsplayedhand1;
           }
           cs.Losses++;
           if(((TBJHand *)pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand1)->IsDDHand)
           {
             cs.DDWinnings -= pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->coinsplayedhand1;
           }
           if(((TBJHand *)pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand1)->IsSplitHand)
           {
             cs.SplitsWL -= pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->coinsplayedhand1;
           }
           pOwnerLord->BetSpotUse[bustto] = -1;
           break;
    case 2:
           pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[bustto])->hand2owner = 0;
           cs.Busts++;
           cs.CurrentWinStreak = 0;
           cs.CurrentLosingStreak++;
           if(pOwnerLord->StartTC > 0)
           {
             cs.TotalCashWLCGT1 -= pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->coinsplayedhand2;
           }
           if(pOwnerLord->StartTC < 1)
           {
             cs.TotalCashWLCLT1 -= pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->coinsplayedhand2;
           }
           if (cs.CurrentLosingStreak > cs.LosingStreak)
           {
             cs.LosingStreak = cs.CurrentLosingStreak;
           }
           if (cs.LargestLoss < pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->coinsplayedhand2)
           {
             cs.LargestLoss = pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->coinsplayedhand2;
           }
           cs.Losses++;
           if(((TBJHand *)pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->pHand2)->IsDDHand)
           {
             cs.DDWinnings -= pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->coinsplayedhand2;
           }
           cs.SplitsWL -= pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->coinsplayedhand2;
           pOwnerLord->BetSpotUse[bustto] = -1;
           break;
    case 3:
           pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[bustto-1])->hand2owner = 0;
           cs.Busts++;
           cs.CurrentWinStreak = 0;
           cs.CurrentLosingStreak++;
           if(pOwnerLord->StartTC > 0)
           {
             cs.TotalCashWLCGT1 -= pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->coinsplayedhand2;
           }
           if(pOwnerLord->StartTC < 1)
           {
             cs.TotalCashWLCLT1 -= pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->coinsplayedhand2;
           }
           if (cs.CurrentLosingStreak > cs.LosingStreak)
           {
             cs.LosingStreak = cs.CurrentLosingStreak;
           }
           if (cs.LargestLoss < pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->coinsplayedhand2)
           {
             cs.LargestLoss = pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->coinsplayedhand2;
           }
           cs.Losses++;
           if(((TBJHand *)pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->pHand2)->IsDDHand)
           {
             cs.DDWinnings -= pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->coinsplayedhand2;
           }
           cs.SplitsWL -= pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->coinsplayedhand2;
           pOwnerLord->BetSpotUse[bustto-1] = -1;
           break;
    case 4:
           cs.Busts++;
           cs.CurrentWinStreak = 0;
           cs.CurrentLosingStreak++;
           if(pOwnerLord->StartTC > 0)
           {
             cs.TotalCashWLCGT1 -= pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->coinsplayedhand3;
           }
           if(pOwnerLord->StartTC < 1)
           {
             cs.TotalCashWLCLT1 -= pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->coinsplayedhand3;
           }
           if (cs.CurrentLosingStreak > cs.LosingStreak)
           {
             cs.LosingStreak = cs.CurrentLosingStreak;
           }
           if (cs.LargestLoss < pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->coinsplayedhand3)
           {
             cs.LargestLoss = pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->coinsplayedhand3;
           }
           cs.Losses++;
           if(((TBJHand *)pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3)->IsDDHand)
           {
             cs.DDWinnings -= pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->coinsplayedhand3;
           }
           if(((TBJHand *)pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3)->IsSplitHand)
           {
             cs.SplitsWL -= pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->coinsplayedhand3;
           }
           pOwnerLord->BetSpotUse[bustto-1] = -1;
           break;
    case 5:
           pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[bustto-1])->hand4owner = 0;
           cs.Busts++;
           cs.CurrentWinStreak = 0;
           cs.CurrentLosingStreak++;
           if(pOwnerLord->StartTC > 0)
           {
             cs.TotalCashWLCGT1 -= pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->coinsplayedhand4;
           }
           if(pOwnerLord->StartTC < 1)
           {
             cs.TotalCashWLCLT1 -= pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->coinsplayedhand4;
           }
           if (cs.CurrentLosingStreak > cs.LosingStreak)
           {
             cs.LosingStreak = cs.CurrentLosingStreak;
           }
           if (cs.LargestLoss < pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->coinsplayedhand4)
           {
             cs.LargestLoss = pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->coinsplayedhand4;
           }
           cs.Losses++;
           if(((TBJHand *)pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4)->IsDDHand)
           {
             cs.DDWinnings -= pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->coinsplayedhand4;
           }
           cs.SplitsWL -= pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->coinsplayedhand4;
           pOwnerLord->BetSpotUse[bustto-1] = -1;
           break;
    case 6:
           pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[bustto-2])->hand4owner = 0;
           cs.Busts++;
           cs.CurrentWinStreak = 0;
           cs.CurrentLosingStreak++;
           if(pOwnerLord->StartTC > 0)
           {
             cs.TotalCashWLCGT1 -= pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->coinsplayedhand4;
           }
           if(pOwnerLord->StartTC < 1)
           {
             cs.TotalCashWLCLT1 -= pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->coinsplayedhand4;
           }
           if (cs.CurrentLosingStreak > cs.LosingStreak)
           {
             cs.LosingStreak = cs.CurrentLosingStreak;
           }
           if (cs.LargestLoss < pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->coinsplayedhand4)
           {
             cs.LargestLoss = pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->coinsplayedhand4;
           }
           cs.Losses++;
           if(((TBJHand *)pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4)->IsDDHand)
           {
             cs.DDWinnings -= pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->coinsplayedhand4;
           }
           cs.SplitsWL -= pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->coinsplayedhand4;
           pOwnerLord->BetSpotUse[bustto-2] = -1;
           break;
    case 7:
           cs.Busts++;
           cs.CurrentWinStreak = 0;
           cs.CurrentLosingStreak++;
           if(pOwnerLord->StartTC > 0)
           {
             cs.TotalCashWLCGT1 -= pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->coinsplayedhand5;
           }
           if(pOwnerLord->StartTC < 1)
           {
             cs.TotalCashWLCLT1 -= pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->coinsplayedhand5;
           }
           if (cs.CurrentLosingStreak > cs.LosingStreak)
           {
             cs.LosingStreak = cs.CurrentLosingStreak;
           }
           if (cs.LargestLoss < pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->coinsplayedhand5)
           {
             cs.LargestLoss = pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->coinsplayedhand5;
           }
           cs.Losses++;
           if(((TBJHand *)pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->pHand5)->IsDDHand)
           {
             cs.DDWinnings -= pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->coinsplayedhand5;
           }
           if(((TBJHand *)pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->pHand5)->IsSplitHand)
           {
             cs.SplitsWL -= pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->coinsplayedhand5;
           }
           pOwnerLord->BetSpotUse[bustto-2] = -1;
           break;
    case 8:
           cs.Busts++;
           cs.CurrentWinStreak = 0;
           cs.CurrentLosingStreak++;
           if(pOwnerLord->StartTC > 0)
           {
             cs.TotalCashWLCGT1 -= pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[6])->coinsplayedhand6;
           }
           if(pOwnerLord->StartTC < 1)
           {
             cs.TotalCashWLCLT1 -= pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[6])->coinsplayedhand6;
           }
           if (cs.CurrentLosingStreak > cs.LosingStreak)
           {
             cs.LosingStreak = cs.CurrentLosingStreak;
           }
           if (cs.LargestLoss < pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[6])->coinsplayedhand6                   )
           {
             cs.LargestLoss = pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[6])->coinsplayedhand6;
           }
           cs.Losses++;
           if(((TBJHand *)pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[6])->pHand6)->IsDDHand)
           {
             cs.DDWinnings -= pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[6])->coinsplayedhand6;
           }
           cs.SplitsWL -= pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[6])->coinsplayedhand6;
           pOwnerLord->BetSpotUse[bustto-2] = -1;
           break;
  }
  ExecuteWaiting = true;
  ExecuteStatus    = ess_Execute;
  StartingFUC = pOwnerLord->GetAdjFUC();
  switch(bustto) {
  case 0  : pOwnerLord->Player1Bust(StartingFUC,FUCLength);pOwnerLord->ALLHANDSWON = false;break;
  case 1  : pOwnerLord->Player1Bust(StartingFUC,FUCLength);pOwnerLord->ALLHANDSWON = false;break;
  case 2  : pOwnerLord->Player1Bust(StartingFUC,FUCLength);pOwnerLord->ALLHANDSWON = false;break;
  case 3  : pOwnerLord->Player2Bust(StartingFUC,FUCLength);pOwnerLord->ALLHANDSWON = false;break;
  case 4  : pOwnerLord->Player2Bust(StartingFUC,FUCLength);pOwnerLord->ALLHANDSWON = false;break;
  case 5  : pOwnerLord->Player2Bust(StartingFUC,FUCLength);pOwnerLord->ALLHANDSWON = false;break;
  case 6  : pOwnerLord->Player3Bust(StartingFUC,FUCLength);pOwnerLord->ALLHANDSWON = false;break;
  case 7  : pOwnerLord->Player3Bust(StartingFUC,FUCLength);pOwnerLord->ALLHANDSWON = false;break;
  case 8  : pOwnerLord->Player3Bust(StartingFUC,FUCLength);pOwnerLord->ALLHANDSWON = false;break;
  case 9  : pOwnerLord->AnnouceDealerBust(StartingFUC,FUCLength);break;
  case 10 : pOwnerLord->AnnouceDealerBust(StartingFUC,FUCLength);break;
  }
  FirstTime = true;
}
//*******************************************************************
void TBJBustState::HandlePostUpdate(dword NewFUC)
{
  if ((StartingFUC + FUCLength) <= NewFUC && FirstTime)
  {
	 switch(bustto) {
	 case 0 :WaitOnPlayer = true;break;
	 case 1 :WaitOnPlayer = true;break;
	 case 2 :WaitOnPlayer = true;break;
	 case 3 :WaitOnPlayer = true;break;
	 case 4 :WaitOnPlayer = true;break;
	 case 5 :WaitOnPlayer = true;break;
	 case 6 :WaitOnPlayer = true;break;
	 case 7 :WaitOnPlayer = true;break;
	 case 8 :WaitOnPlayer = true;break;
	 case 9 :WaitOnDealerBJ = true;break;
	 case 10:WaitOnDealerBJ = true;break;
	 }
	 if(!WaitOnDealerBJ && !WaitOnPlayer)
	 {
	  ExecuteWaiting = false;
	  ExecuteStatus    = ess_Done;
	  FUCLength = 0;
	 }
	 FirstTime = false;
  }
  if(WaitOnDealerBJ)
  {
	 StartingFUC = pOwnerLord->GetAdjFUC();
	 pOwnerLord->RemoveDealerCards(StartingFUC,FUCLength,remove,show);
	 WaitOnDealerBJ = false;
	 FinishDealerBJ = true;
  }
  if(FinishDealerBJ)
  {
	 if(StartingFUC + remove == NewFUC)
	 {
		pOwnerLord->DealerSpot->NoShow();
	 }
	 if(StartingFUC + FUCLength <= NewFUC)
	 {
		pOwnerLord->Rack->ShowBJRack(discards);
		FinishDealerBJ = false;
		remove = 0;show = 0;
		ExecuteWaiting = false;
		ExecuteStatus = ess_Done;
	 }
  }
  if(WaitOnPlayer)
  {
	 StartingFUC = pOwnerLord->GetAdjFUC();
	 pOwnerLord->GetCards(StartingFUC,FUCLength,remove,show);
	 WaitOnPlayer = false;
	 FinishPlayer = true;
  }
  if(FinishPlayer)
  {
	 if(StartingFUC + remove == NewFUC || FUCLength == 0)
	 {
		  switch(bustto) {
		  case 0  : pOwnerLord->BetSpot[0]->NoShow();break;
		  case 1  : pOwnerLord->BetSpot[1]->NoShow();break;
		  case 2  : pOwnerLord->BetSpot[2]->NoShow();break;
		  case 3  : pOwnerLord->BetSpot[2]->NoShow();break;
		  case 4  : pOwnerLord->BetSpot[3]->NoShow();break;
		  case 5  : pOwnerLord->BetSpot[4]->NoShow();break;
		  case 6  : pOwnerLord->BetSpot[4]->NoShow();break;
		  case 7  : pOwnerLord->BetSpot[5]->NoShow();break;
		  case 8  : pOwnerLord->BetSpot[6]->NoShow();break;
		  }
	 }
	 if(StartingFUC + show == NewFUC || FUCLength == 0)
	 {
		pOwnerLord->Rack->ShowBJRack(discards);
	 }
	 if(StartingFUC + FUCLength <= NewFUC)
	 {
		FinishPlayer = false;
		remove = 0;show = 0;
		ExecuteWaiting = false;
		ExecuteStatus = ess_Done;
	 }
  }

}
//*******************************************************************
