//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  bjddst.cpp    // dealer draw state
//    Project Name:  Ogle
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     06/22/95   A. Krist    Original baseline
//  2.0     09/23/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "bjddst.h"   // dealer draw state
#include "cbjglord.h"
#include "otimers.h"
#include "bjgobj.h"
#include "casbjmw.h"
#include "hand.h"
#include "bjdealst.h"
#include "bjdeck.h"
#include <iostream.h>
//*******************************************************************
TBJDealerDrawState::TBJDealerDrawState(TCasinoBJGameLord *pNewBJLord)
:TBJLordState(pNewBJLord)
{
  SetRunOrder(ess_StartSubState1,ess_StartSubState1,ess_Done);
  FirstCard = true;
  WaitOnSkit = false;
  FUCLength = 0;
  StartingFUC = 0;
}
//*******************************************************************
TBJDealerDrawState::~TBJDealerDrawState()
{
}
//*******************************************************************
void TBJDealerDrawState::StartSubState1()
{
  CreateSubState1();
  //ExecuteStatus = ess_RunSubState1;
}
//*******************************************************************
void TBJDealerDrawState::CreateSubState1()
{
  if(/*(TBJDeck *)*/pOwnerLord->pDeck->Busted(pOwnerLord->pHand) == 0)
  {
	 pOwnerLord->MessageDisplay->ShowBJMessage(pOwnerLord->DealerTotal());
	 if(pOwnerLord->pHand->highhand < 17)
	 {
		PActiveSubState = new TBJDealState(pOwnerLord,10);
		ExecuteStatus   = ess_RunSubState1;                  // BIG CHANGE in state order?
	 }
	 else
	 {
//      StartingFUC = PTimePtr->GetFrameUpdateCount() + 1;
      StartingFUC = pOwnerLord->GetAdjFUC();
		pOwnerLord->AnnounceDealerTotal(StartingFUC,FUCLength);
		WaitOnSkit = true;
		ExecuteStatus  = ess_Execute;
		ExecuteWaiting = true;
	 }
  }
  else
  {
//	 StartingFUC = PTimePtr->GetFrameUpdateCount() + 1;
    StartingFUC = pOwnerLord->GetAdjFUC();
	 pOwnerLord->AnnouceDealerBust(StartingFUC,FUCLength);
	 WaitOnSkit = true;
	 ExecuteStatus  = ess_Execute;
	 ExecuteWaiting = true;
  }

}
//*******************************************************************
void TBJDealerDrawState::HandlePostUpdate(dword NewFUC)
{
  if(WaitOnSkit)
  {
	 if((StartingFUC + FUCLength) <= NewFUC)
	 {
		StartingFUC = 0;
		FUCLength   = 0;
		WaitOnSkit  = false;
      ExecuteStatus  = ess_Done;
		ExecuteWaiting = false;
	 }
	 return;//?
  }

}
//*******************************************************************

