//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  bjExpost.cpp    // dealer Expo hole card state
//    Project Name:  Ogle
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     06/22/95   A. Krist    Original baseline
//  2.0     09/23/97   M.Perry     32-bit conversio.
//*******************************************************************
#include "bjexpost.h"   // dealer draw state
#include "cbjglord.h"
#include "otimers.h"
#include "bjgobj.h"
#include "casbjmw.h"
#include "hand.h"
#include "bjdealst.h"
#include "bjdeck.h"
#include <iostream.h>
//*******************************************************************
TBJDealerExpoState::TBJDealerExpoState(TCasinoBJGameLord *pNewBJLord)
:TBJLordState(pNewBJLord)
{
  SetRunOrder(ess_StartSubState1,ess_Done);
  StartingFUC = 0;
  FUCLength   = 0;
  WaitOnSkit  = true;
  ExpoHole    = true;
  RemoveBackFUC = 0;
  ShowBackFUC = 0;
}
//*******************************************************************
TBJDealerExpoState::~TBJDealerExpoState()
{
}
//*******************************************************************
void TBJDealerExpoState::CreateSubState1()
{
}
//*******************************************************************
void TBJDealerExpoState::ExecuteFirstTime()
{
  ExecuteWaiting = true;
  ExecuteStatus  = ess_Execute;

  StartingFUC = pOwnerLord->GetAdjFUC();
  switch(pOwnerLord->LookingAt) {
	 case bjnl1A : pOwnerLord->LookFromTo(bjlf1To0,StartingFUC,FUCLength);break;
	 case bjnl1B : pOwnerLord->LookFromTo(bjlf1To0,StartingFUC,FUCLength);break;
	 case bjnl1C : pOwnerLord->LookFromTo(bjlf1To0,StartingFUC,FUCLength);break;
	 case bjnl2C : pOwnerLord->LookFromTo(bjlf2To0,StartingFUC,FUCLength);break;
	 case bjnl2D : pOwnerLord->LookFromTo(bjlf2To0,StartingFUC,FUCLength);break;
	 case bjnl2E : pOwnerLord->LookFromTo(bjlf2To0,StartingFUC,FUCLength);break;
	 case bjnl3E : pOwnerLord->LookFromTo(bjlf3To0,StartingFUC,FUCLength);break;
	 case bjnl3F : pOwnerLord->LookFromTo(bjlf3To0,StartingFUC,FUCLength);break;
	 case bjnl3G : pOwnerLord->LookFromTo(bjlf3To0,StartingFUC,FUCLength);break;
  }
  pOwnerLord->LookingAt = bjnl0U;
  pOwnerLord->SetBodyIdle();
}
//*******************************************************************
void TBJDealerExpoState::HandlePostUpdate(dword NewFUC)
{
  if(WaitOnSkit)
  {
	 if((StartingFUC + FUCLength) <= NewFUC)
	 {
		StartingFUC = 0;
		FUCLength   = 0;
		WaitOnSkit  = false;
	 }
	 return;//?
  }
  if(!WaitOnSkit && ExpoHole)
  {
    StartingFUC = pOwnerLord->GetAdjFUC();
	 pOwnerLord->ExposeHoleCard(StartingFUC,FUCLength,RemoveBackFUC,ShowBackFUC);
	 ExpoHole   = false;
	 return;
  }
  if(!ExpoHole)
  {
	 if((StartingFUC + RemoveBackFUC) == NewFUC)
	 {
		pOwnerLord->DealerSpot->NoShowBack();
	 }
	 if((StartingFUC + ShowBackFUC) == NewFUC)
	 {
		pOwnerLord->DealerSpot->ShowHoleCard(pOwnerLord->pHand);
	 }
	 if((StartingFUC + FUCLength) <= NewFUC)
	 {
		ExecuteWaiting = false;
	 }
	 return;
  }
}
//*******************************************************************
