//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  bjfdst.cpp
//    Project Name:  Ogle
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     06/22/95   A. Krist    Original baseline
//  2.0     09/24/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "bjfdst.h"
#include "cbjglord.h"
#include "otimers.h"
#include "cplaymgr.h"
#include "bjgobj.h"
#include "casbjmw.h"
#include "hand.h"
#include "bjdealst.h"
#include "bjdeck.h"
#include "bjhand.h"
#include <iostream.h>
#include "ogamefw.h"
//*******************************************************************
TBJFirstDealState::TBJFirstDealState(TCasinoBJGameLord *pNewBJLord)
:TBJLordState(pNewBJLord)
{
  SetRunOrder(ess_StartSubState1,ess_StartSubState2,ess_StartSubState3,
				  ess_StartSubState4,ess_StartSubState5,ess_Execute,
				  ess_Execute,ess_Execute,ess_Done);
  StartingFUC = 0;
  FUCLength = 0;
  WaitOnSkit = false;
  Start6 = false;
  Start7 = false;
  Start8 = false;

}
//*******************************************************************
TBJFirstDealState::~TBJFirstDealState()
{
  pOwnerLord->UnFreezeAllButtons();
}
//*******************************************************************
void TBJFirstDealState::HandlePostUpdate(dword NewFUC)
{
  if(WaitOnSkit)
  {
	 if((StartingFUC != 0) && ((StartingFUC + FUCLength) <= NewFUC))
	 {
		StartingFUC = 0;
		FUCLength   = 0;
		WaitOnSkit  = false;
	 }
	 return;//?
  }
  if(!WaitOnSkit && Start6)
  {
	 Start6  = false;
	 ExecuteWaiting = false;
	 ExecuteStatus = ess_StartSubState6;
  }
  if(!WaitOnSkit && Start7)
  {
	 Start7  = false;
	 ExecuteWaiting = false;
	 ExecuteStatus = ess_StartSubState7;
  }
  if(!WaitOnSkit && Start8)
  {
	 Start8  = false;
	 ExecuteWaiting = false;
	 ExecuteStatus = ess_StartSubState8;
  }
}
//*******************************************************************
void TBJFirstDealState::CreateSubState1()
{
  if(pOwnerLord->BetSpotUse[1] >= 0)
  {
    TCasinoBJData &cd = pOwnerLord->GetCasPD(pOwnerLord->BetSpotUse[1])->BJData;
    int16 session = cd.CurrentSession;
    TCBJSession &cs = cd.Sessions[session];

	 ((TCasinoPlayerMgr *)pOwnerLord->GetFW()->GetPlayerMgr())->GetCasinoGameDataPtr()->FirstBJHandEver = false;
	 cd.FirstPlayerBJHandEver = false;
	 cs.HandsPlayed++;
	 cs.TotalBetsCash += pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->coinsplayedhand1;
	 if(pOwnerLord->StartTC > 0)
	 {
		cs.TotalBetsCashCGT1 += pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->coinsplayedhand1;
		cs.HandsPlayedCGT1++;
	 }
	 if(pOwnerLord->StartTC < 1)
	 {
		cs.TotalBetsCashCLT2 += pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->coinsplayedhand1;
		cs.HandsPlayedCLT2++;
	 }
	 if(pOwnerLord->PModeWin->GetDetailLevel() == 0)
	 {
		PActiveSubState = new TBJDealState(pOwnerLord,1,false,false);
	 }
	 else
	 {
		PActiveSubState = new TBJDealState(pOwnerLord,1,false);
	 }
  }
}
//*******************************************************************
void TBJFirstDealState::CreateSubState2()
{
  if(pOwnerLord->BetSpotUse[3] >= 0)
  {
    TCasinoBJData &cd = pOwnerLord->GetCasPD(pOwnerLord->BetSpotUse[3])->BJData;
    int16 session = cd.CurrentSession;
    TCBJSession &cs = cd.Sessions[session];

	 ((TCasinoPlayerMgr *)pOwnerLord->GetFW()->GetPlayerMgr())->GetCasinoGameDataPtr()->FirstBJHandEver = false;
	 cd.FirstPlayerBJHandEver = false;
	 cs.HandsPlayed++;
	 cs.TotalBetsCash += pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->coinsplayedhand3;
	 if(pOwnerLord->StartTC > 0)
	 {
		cs.TotalBetsCashCGT1 += pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->coinsplayedhand3;
		cs.HandsPlayedCGT1++;
	 }
	 if(pOwnerLord->StartTC < 1)
	 {                                                                             //duh
		cs.TotalBetsCashCLT2 += pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->coinsplayedhand3;
		cs.HandsPlayedCLT2++;
	 }
	 if(pOwnerLord->PModeWin->GetDetailLevel() == 0)
	 {
		PActiveSubState = new TBJDealState(pOwnerLord,4,false,false);
	 }
	 else
	 {
		PActiveSubState = new TBJDealState(pOwnerLord,4,false);
	 }
  }
}
//*******************************************************************
void TBJFirstDealState::CreateSubState3()
{
  if(pOwnerLord->BetSpotUse[5] >= 0)
  {
    TCasinoBJData &cd = pOwnerLord->GetCasPD(pOwnerLord->BetSpotUse[5])->BJData;
    int16 session = cd.CurrentSession;
    TCBJSession &cs = cd.Sessions[session];

	 ((TCasinoPlayerMgr *)pOwnerLord->GetFW()->GetPlayerMgr())->GetCasinoGameDataPtr()->FirstBJHandEver = false;
	 cd.FirstPlayerBJHandEver = false;
	 cs.HandsPlayed++;
	 cs.TotalBetsCash += pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->coinsplayedhand5;
	 if(pOwnerLord->StartTC > 0)
	 {
		cs.TotalBetsCashCGT1 += pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->coinsplayedhand5;
		cs.HandsPlayedCGT1++;
	 }
	 if(pOwnerLord->StartTC < 1)
	 {
		cs.TotalBetsCashCLT2 += pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->coinsplayedhand5;
		cs.HandsPlayedCLT2++;
	 }
	 if(pOwnerLord->PModeWin->GetDetailLevel() == 0)
	 {
		PActiveSubState = new TBJDealState(pOwnerLord,7,false,false);
	 }
	 else
	 {
		PActiveSubState = new TBJDealState(pOwnerLord,7,false);
	 }
  }
}
//*******************************************************************
void TBJFirstDealState::CreateSubState4()
{
  if(pOwnerLord->PModeWin->GetDetailLevel() == 0)
	 {
		PActiveSubState = new TBJDealState(pOwnerLord,10,false,false);
	 }
	 else
	 {
		PActiveSubState = new TBJDealState(pOwnerLord,10,false);
	 }
}
//*******************************************************************
void TBJFirstDealState::CreateSubState5()
{
  if(pOwnerLord->BetSpotUse[1] >= 0)
  {
	 if(pOwnerLord->PModeWin->GetDetailLevel() == 0)
	 {
		PActiveSubState = new TBJDealState(pOwnerLord,1,false,false);
	 }
	 else
	 {
		PActiveSubState = new TBJDealState(pOwnerLord,1,false);
	 }
  }
}
//*******************************************************************
void TBJFirstDealState::EndSubState5()
{
  TState::EndSubState5();
  if(pOwnerLord->BetSpotUse[1] >= 0)
  {
	 if(!BJCom(1))
	 {
		ExecuteStatus = ess_StartSubState6;
		ExecuteWaiting = false;
	 }
	 else
	 {
		ExecuteWaiting = true;
	 }
  }
  else
  {
	 ExecuteStatus = ess_StartSubState6;
	 ExecuteWaiting = false;
  }
}
//*******************************************************************
void TBJFirstDealState::CreateSubState6()
{
  if(pOwnerLord->BetSpotUse[3] >= 0)
  {
	 if(pOwnerLord->PModeWin->GetDetailLevel() == 0)
	 {
		PActiveSubState = new TBJDealState(pOwnerLord,4,false,false);
	 }
	 else
	 {
		PActiveSubState = new TBJDealState(pOwnerLord,4,false);
	 }
  }
}
//*******************************************************************
void TBJFirstDealState::EndSubState6()
{
  TState::EndSubState6();
  if(pOwnerLord->BetSpotUse[3] >= 0)
  {
	 if(!BJCom(3))
	 {
		ExecuteStatus = ess_StartSubState7;
		ExecuteWaiting = false;
	 }
	 else
	 {
		ExecuteWaiting = true;
	 }
  }
  else
  {
	 ExecuteStatus = ess_StartSubState7;
	 ExecuteWaiting = false;
  }
}
//*******************************************************************
void TBJFirstDealState::CreateSubState7()
{
  if(pOwnerLord->BetSpotUse[5] >= 0)
  {
	 if(pOwnerLord->PModeWin->GetDetailLevel() == 0)
	 {
		PActiveSubState = new TBJDealState(pOwnerLord,7,false,false);
	 }
	 else
	 {
		PActiveSubState = new TBJDealState(pOwnerLord,7,false);
	 }
  }
}
//*******************************************************************
void TBJFirstDealState::EndSubState7()
{
  TState::EndSubState7();
  if(pOwnerLord->BetSpotUse[5] >= 0)
  {
	 if(!BJCom(5))
	 {
		ExecuteStatus = ess_StartSubState8;
		ExecuteWaiting = false;
	 }
	 else
	 {
		ExecuteWaiting = true;
	 }
  }
  else
  {
	 ExecuteStatus = ess_StartSubState8;
	 ExecuteWaiting = false;
  }
}
//*******************************************************************
void TBJFirstDealState::CreateSubState8()
{
  if(pOwnerLord->PModeWin->GetDetailLevel() == 0)
	 {
		PActiveSubState = new TBJDealState(pOwnerLord,9,false,false);
	 }
	 else
	 {
		PActiveSubState = new TBJDealState(pOwnerLord,9,false);
	 }
}
//*******************************************************************
bool TBJFirstDealState::BJCom(int16 spot)
{
//  StartingFUC = PTimePtr->GetFrameUpdateCount() + 1;
  StartingFUC = pOwnerLord->GetAdjFUC();
  //pOwnerLord->SetBodyIdle();
  if(pOwnerLord->PModeWin->GetDetailLevel() != 0)
  {
	 switch(spot) {
	 case 1 : pOwnerLord->pDeck->BlackJack((TBJHand *)pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand1);
			  if(((TBJHand *)pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[spot])->pHand1)->bj)
			  {
				 pOwnerLord->DeclarePlayer1BJ(StartingFUC,FUCLength);
				 Start6 = true;WaitOnSkit = true;
				 return true;
			  }
			  return false;
	 case 3 : pOwnerLord->pDeck->BlackJack((TBJHand *)pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3);
			  if(((TBJHand *)pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[spot])->pHand3)->bj)
			  {
				 pOwnerLord->DeclarePlayer2BJ(StartingFUC,FUCLength);
				 Start7 = true;WaitOnSkit = true;
				 return true;
			  }
			  return false;
	 case 5 : pOwnerLord->pDeck->BlackJack((TBJHand *)pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->pHand5);
			  if(((TBJHand *)pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[spot])->pHand5)->bj)
			  {
				 pOwnerLord->DeclarePlayer3BJ(StartingFUC,FUCLength);
				 Start8 = true;WaitOnSkit = true;
				 return true;
			  }
			  return false;
	 }
  }
  return false;
}
//*******************************************************************
