//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  bjisst.cpp    // insure state
//    Project Name:  Ogle
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     10/20/95   A. Krist    Original baseline
//  2.0     09/23/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "bjisst.h"
#include "cbjglord.h"
#include "otimers.h"
#include "cbjplay.h"
#include <iostream.h>
//#include "cbjglspl.h"
#include "orespond.h"
//*******************************************************************
TBJInsureState::TBJInsureState(TCasinoBJGameLord *pNewBJLord,int16 InsureTo)
:TBJLordState(pNewBJLord)
{
  insureto = InsureTo;
  SetRunOrder(ess_StartSubState1,ess_StartSubState2,ess_StartSubState3,ess_Done);
  ClearNoInsureStandResponder = NULL;
  SameYesInsureHitResponder   = NULL;
  MenuEscResponder            = NULL;
  AskExpertResponder          = NULL;
  WaitOnSkit                  = false;
  WaitOnEvenMoney             = false;
  WaitOnChips                 = false;
  askexpertflag               = false;
  FUCLength   = 0;
  StartingFUC = 0;
}
//*******************************************************************
TBJInsureState::~TBJInsureState()
{
  pOwnerLord->DisEnableButton(17);
  pOwnerLord->DisEnableButton(18);
  pOwnerLord->BJSounds->NoShowTwoBack();
  pOwnerLord->Circle1->NoShow();
  pOwnerLord->Circle2->NoShow();
  pOwnerLord->Circle3->NoShow();
  pOwnerLord->FreezeAllButtons();
}
//*******************************************************************
bool TBJInsureState::HandleMenuEsc(TResponder &responder)
{
	if (responder.GetResponseEvent() == reLUp)
  {
	 MenuEscResponder = &responder;
  }

  if (responder.GetResponseEvent() == reLDown)
  {
 ///	 pOwnerLord->MenuEscButton->Depress();
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
  //	 pOwnerLord->MenuEscButton->Depress();
	 MenuEscResponder = &responder;
  }

  return true;
}
//*******************************************************************
bool TBJInsureState::HandleAskExpert(TResponder &responder)
{
	if (responder.GetResponseEvent() == reLUp)
  {
	 AskExpertResponder = &responder;
  }

  if (responder.GetResponseEvent() == reLDown)
  {
  //	 pOwnerLord->AskExpertButton->Depress();
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
	// pOwnerLord->AskExpertButton->Depress();
	 AskExpertResponder = &responder;
  }

  return true;
}
//*******************************************************************
void TBJInsureState::ExecuteFirstTime()
{
  pOwnerLord->BJSounds->ShowTwoBack();
  if(pOwnerLord->GetCash(pOwnerLord->BetSpotUse[insureto]) > 0)
  {
	 pOwnerLord->EnableButton(18);
  }
  else if(insureto)
  {
	 switch(insureto) {
	  case 1 : if(((TBJHand *)pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand1)->bj)
				  {pOwnerLord->EnableButton(18);}break;
	  case 3 : if(((TBJHand *)pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3)->bj)
				  {pOwnerLord->EnableButton(18);}break;
	  case 5 : if(((TBJHand *)pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->pHand5)->bj)
				  {pOwnerLord->EnableButton(18);}break;
	  }
  }
  else
  {
	 pOwnerLord->Button18->ShowGray();
  }
  pOwnerLord->EnableButton(17);
  ExecuteWaiting = true;
  ExecuteStatus    = ess_Execute;
  StartingFUC = pOwnerLord->GetAdjFUC();
  pOwnerLord->LookFromTo(Looking(int16(pOwnerLord->LookingAt),insureto),StartingFUC,FUCLength);
  pOwnerLord->SetBodyIdle();
  WaitOnSkit = true;
}
//*******************************************************************
TBJLookFromTo TBJInsureState::Looking(int16 lookingat,int16 lookto)
{
  switch(lookingat) {
  case bjnl1B : if(lookto == 1)
					 {
						return bjlf0To0;
					 }
					 else if(lookto ==3)
					 {
					  //	pOwnerLord->LookingAt = bjnl2D;
						pOwnerLord->LookingAt = bjnl2D;
						return bjlf1To2;
					 }
					 else if(lookto == 5)
					 {
						//pOwnerLord->LookingAt = bjnl3F;
						pOwnerLord->LookingAt = bjnl3F;
						return bjlf1To3;
					 }
					 else if(lookto == 9 || lookto == 10)
					 {
						//pOwnerLord->LookingAt = bjnl0D;
						pOwnerLord->LookingAt = bjnl0U;
						return bjlf1To0;
					 }
  case bjnl2D : if(lookto == 1)
					 {
						return bjlf0To0;
					 }
					 else if(lookto == 3)
					 {
						return bjlf0To0;
					 }
					 else if(lookto == 5)
					 {
						pOwnerLord->LookingAt = bjnl3F;
						return bjlf2To3;
					 }
					 else if(lookto == 9 || lookto == 10)
					 {
						pOwnerLord->LookingAt = bjnl0D;
						return bjlf2To0;
					 }
  case bjnl3F : if(lookto == 1)
					 {
						return bjlf0To0;
					 }
					 else if(lookto == 3)
					 {
						return bjlf0To0;
					 }
					 else if(lookto == 5)
					 {
						return bjlf0To0;
					 }
					 else if(lookto == 9 || lookto == 10)
					 {
						pOwnerLord->LookingAt = bjnl0D;
						return bjlf3To0;
					 }
  case bjnl0D : if(lookto == 1)
					 {
						pOwnerLord->LookingAt = bjnl1B;
						return bjlf0To1;
					 }
					 else if(lookto == 3)
					 {
						pOwnerLord->LookingAt = bjnl2D;
						return bjlf0To2;
					 }
					 else if(lookto == 5)
					 {
						pOwnerLord->LookingAt = bjnl3F;
						return bjlf0To3;
					 }
					 else if(lookto == 9)
					 {
						return bjlf0To0;
					 }
					 else if(lookto == 10)
					 {
						return bjlf0To0;
					 }
	case bjnl0U: if(lookto == 1)
					 {
						pOwnerLord->LookingAt = bjnl1B;
						return bjlf0To1;
					 }
					 else if(lookto == 3)
					 {
						pOwnerLord->LookingAt = bjnl2D;
						return bjlf0To2;
					 }
					 else if(lookto == 5)
					 {
						pOwnerLord->LookingAt = bjnl3F;
						return bjlf0To3;
					 }
					 else if(lookto == 9 || lookto == 10)
					 {
						return bjlf0To0;
					 }
  }
  return bjlf0To0;
}
//*******************************************************************
void TBJInsureState::HandlePostUpdate(dword NewFUC)
{
  if(WaitOnSkit)
  {
	 if((StartingFUC + FUCLength) <= NewFUC)
	 {
		StartingFUC = 0;
		FUCLength   = 0;
		WaitOnSkit  = false;
		ExecuteStatus = ess_Execute;
		ExecuteWaiting = true;
		pOwnerLord->UnFreezeAllButtons();
	 }
	 return;//?
  }
  if(WaitOnEvenMoney)
  {
	 if((StartingFUC + 1/*FUCLength*/) == NewFUC)
	 {
		pOwnerLord->PlaceInsure(insureto);
		switch(insureto) {
		  case 1  : pOwnerLord->BetSpot[1]->NoShowCards();break;
		  case 3  : pOwnerLord->BetSpot[3]->NoShowCards();break;
		  case 5  : pOwnerLord->BetSpot[5]->NoShowCards();break;
		}
	 }
	 if((StartingFUC + FUCLength) <= NewFUC)
	 {
		//StartingFUC = 0;
		//FUCLength   = 0;
		WaitOnEvenMoney  = false;
		WaitOnChips = true;
		//ExecuteStatus = ess_Done;
		//ExecuteWaiting = false;
	 }
	 return;//?
  }
  if(WaitOnChips)
  {
	 if((StartingFUC + FUCLength + 5) <= NewFUC)
	 {
		StartingFUC = 0;
		FUCLength   = 0;
		pOwnerLord->BetSpot[insureto]->NoShowEvenMoneyChips();
      pOwnerLord->BetSpot[insureto]->NoShowBetChips();
		pOwnerLord->BetSpotUse[insureto] = -1;
		WaitOnChips = false;
		ExecuteStatus = ess_Done;
		ExecuteWaiting = false;
	 }
	 return;//?
  }
  if(pOwnerLord->ButtonHit[bjidButton2])
  {
	 pOwnerLord->ButtonClear(bjidButton2);
	 LockHit = false;
	 return;
  }
  if(pOwnerLord->ButtonHit[bjidButton1])
  {
	 pOwnerLord->ButtonClear(bjidButton1);
	 LockHit = false;
	 return;
  }
  if(pOwnerLord->ButtonHit[bjidButton3])
  {
	 pOwnerLord->ButtonClear(bjidButton3);
	 LockHit = false;
	 return;
  }
  if(pOwnerLord->ButtonHit[bjidButton0])
  {
	 pOwnerLord->ButtonClear(bjidButton0);
	 LockHit = false;
	 pOwnerLord->AskInsuranceExpert();
	 askexpertflag = false;
	 return;
  }
  if(pOwnerLord->ButtonHit[bjidButton17])
  {
	 pOwnerLord->ButtonClear(bjidButton17);
	 LockHit = false;
	 ExecuteWaiting = false;
	 ExecuteStatus = ess_Done;
	 return;
  }
  if(pOwnerLord->ButtonHit[bjidButton18])
  {
	 pOwnerLord->ButtonClear(bjidButton18);
	 LockHit = false;
	 switch(insureto) {
	  case 1 : if(((TBJHand *)pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[insureto])->pHand1)->bj)
				  {
					 FUCLength = 0;
					 StartingFUC = pOwnerLord->GetAdjFUC();
					 pOwnerLord->EvenMoneyPlayer1(StartingFUC,FUCLength);
					 WaitOnEvenMoney = true;
					 pOwnerLord->FreezeAllButtons();
				  }
				  else
				  {
					 pOwnerLord->PlaceInsure(insureto);
					 ExecuteWaiting = false;
					 ExecuteStatus  = ess_Done;
				  }
				  break;
		case 3 : if(((TBJHand *)pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[insureto])->pHand3)->bj)
				  {
					 FUCLength = 0;
					 StartingFUC = pOwnerLord->GetAdjFUC();
					 pOwnerLord->EvenMoneyPlayer2(StartingFUC,FUCLength);
					 pOwnerLord->FreezeAllButtons();
					 WaitOnEvenMoney = true;
				  }
				  else
				  {
					 pOwnerLord->PlaceInsure(insureto);
					 ExecuteWaiting = false;
					 ExecuteStatus  = ess_Done;
				  }
				  break;
	  case 5 : if(((TBJHand *)pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[insureto])->pHand5)->bj)
				  {
					 FUCLength = 0;
					 StartingFUC = pOwnerLord->GetAdjFUC();
					 pOwnerLord->EvenMoneyPlayer3(StartingFUC,FUCLength);
					 pOwnerLord->FreezeAllButtons();
					 WaitOnEvenMoney = true;
				  }
				  else
				  {
					 pOwnerLord->PlaceInsure(insureto);
					 ExecuteWaiting = false;
					 ExecuteStatus  = ess_Done;
				  }
				  break;
	 }
	 return;
  }
}
//*******************************************************************
bool TBJInsureState::HandleClearNoInsureStand(TResponder &responder)
{
  if (responder.GetResponseEvent() == reLUp)
  {
	 ClearNoInsureStandResponder = &responder;
  }

  if (responder.GetResponseEvent() == reLDown)
  {
	// pOwnerLord->ClearNoInsureStand->ShowNoDown();
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
	// pOwnerLord->ClearNoInsureStand->ShowNoDown();
	 ClearNoInsureStandResponder = &responder;
  }
  return true;
}
//*******************************************************************
bool TBJInsureState::HandleSameYesInsureHit(TResponder &responder)
{
  bool yesflag=false;
  if(pOwnerLord->GetCash(pOwnerLord->BetSpotUse[insureto]) > 0)
  {
	 yesflag = true;
  }
  switch(insureto) {
	 case 1 : if(((TBJHand *)pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand1)->bj)
				  {yesflag = true;}break;
	 case 3 : if(((TBJHand *)pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3)->bj)
				  {yesflag = true;}break;
	 case 5 : if(((TBJHand *)pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->pHand5)->bj)
				  {yesflag = true;}break;
  }
  if(yesflag)
  {
	if (responder.GetResponseEvent() == reLUp)
	{
	 SameYesInsureHitResponder = &responder;
	}

	if (responder.GetResponseEvent() == reLDown)
	{
	 //pOwnerLord->SameYesInsureHit->ShowYesDown();
	 responder.SetPriority();
	}

	if (responder.GetResponseEvent() == reChar)
	{
	 //pOwnerLord->SameYesInsureHit->ShowYesDown();
	 SameYesInsureHitResponder = &responder;
	}
  }
  return true;
}
//*******************************************************************
void TBJInsureState::CreateSubState1()
{
}
//*******************************************************************
void TBJInsureState::CreateSubState2()
{
}
//*******************************************************************
void TBJInsureState::CreateSubState3()
{
}
//*******************************************************************
