//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  bjpist.cpp    // pay insurance state
//    Project Name:  Ogle
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     10/20/95   A. Krist    Original baseline
//  2.0     09/23/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "bjpist.h"
#include "cbjglord.h"
#include "otimers.h"
#include "cbjplay.h"
#include "bjhand.h"
#include <iostream.h>
//*******************************************************************
TBJPayInsureState::TBJPayInsureState(TCasinoBJGameLord *pNewBJLord,int16 PayInsureTo)
:TBJLordState(pNewBJLord)
{
  payinsureto = PayInsureTo;
  discards = 0;
  WaitOnSkit = false;
  SetRunOrder(ess_StartSubState1,ess_StartSubState2,ess_StartSubState3,ess_Done);
}
//*******************************************************************
TBJPayInsureState::~TBJPayInsureState()
{
}
//*******************************************************************
void TBJPayInsureState::ExecuteFirstTime()
{
 // pOwnerLord->RemoveDouble->ShowGrayRemove();
 // pOwnerLord->DealSplit->ShowGrayDeal();
 // pOwnerLord->ClearNoInsureStand->ShowNo();
 // pOwnerLord->SameYesInsureHit->ShowYes();
  ExecuteWaiting = true;
  FUCLength = 0;
  ExecuteStatus  = ess_Execute;
//  StartingFUC    = PTimePtr->GetFrameUpdateCount()+1;
  StartingFUC = pOwnerLord->GetAdjFUC();
  pOwnerLord->LookFromTo(Looker(int16(pOwnerLord->LookingAt),payinsureto),StartingFUC,FUCLength);
  pOwnerLord->SetBodyIdle();
  switch(payinsureto) {
	 case 1  : discards = pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand1->inhand;break;
	 case 4  : discards = pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3->inhand;break;
	 case 7  : discards = pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->pHand5->inhand;break;
  }
}
//*******************************************************************
void TBJPayInsureState::HandlePostUpdate(dword NewFUC)
{
  if ((StartingFUC + FUCLength) == NewFUC && !WaitOnSkit)
  {
	if(payinsureto == 1)
	{
	 int16 session = pOwnerLord->GetCasPD(pOwnerLord->BetSpotUse[1])->BJData.CurrentSession;
    TCBJSession &cs = pOwnerLord->GetCasPD(pOwnerLord->BetSpotUse[1])->BJData.Sessions[session];
	 if((bool)pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand1->insurance ||
		 ((TBJHand *)pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand1)->bj)
	 {
		StartingFUC = 0;
		FUCLength = 0;
//		StartingFUC    = PTimePtr->GetFrameUpdateCount()+1;
		StartingFUC = pOwnerLord->GetAdjFUC();
		pOwnerLord->Push1(StartingFUC,FUCLength);
		WaitOnSkit = true;
		if((bool)pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand1->insurance)
		{
		  cs.InsureWon++;
		  cs.Losses++;
		  cs.CurrentWinStreak = 0;
		  cs.CurrentLosingStreak++;
		  if(cs.CurrentLosingStreak > cs.LosingStreak)
		  {
				cs.LosingStreak = cs.CurrentLosingStreak;
		  }
		  if (cs.LargestLoss < pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->coinsplayedhand1)
		  {
				cs.LargestLoss = pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->coinsplayedhand1;
		  }
		}
		else
		{
		  cs.Pushes++;
		  cs.BJWins++;
		}
	 }
	 else
	 {
		cs.CurrentWinStreak = 0;
		cs.CurrentLosingStreak++;
		if (cs.CurrentLosingStreak > cs.LosingStreak)
		{
		 cs.LosingStreak = cs.CurrentLosingStreak;
		}
		if (cs.LargestLoss < pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->coinsplayedhand1)
		{
		  cs.LargestLoss = pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->coinsplayedhand1;
		}
		cs.Losses++;
		StartingFUC = 0;
		FUCLength = 0;
//		StartingFUC    = PTimePtr->GetFrameUpdateCount()+1;
		StartingFUC = pOwnerLord->GetAdjFUC();
		pOwnerLord->Loser1(StartingFUC,FUCLength);
		WaitOnSkit = true;
	 }
	}
	if(payinsureto == 4)
	{
	 int16 session = pOwnerLord->GetCasPD(pOwnerLord->BetSpotUse[3])->BJData.CurrentSession;
    TCBJSession &cs = pOwnerLord->GetCasPD(pOwnerLord->BetSpotUse[3])->BJData.Sessions[session];

	 if((bool)pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3->insurance ||
		 ((TBJHand *)pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3)->bj)
	 {
		StartingFUC = 0;
		FUCLength = 0;
//		StartingFUC    = PTimePtr->GetFrameUpdateCount()+1;
		StartingFUC = pOwnerLord->GetAdjFUC();
		pOwnerLord->Push2(StartingFUC,FUCLength);
		WaitOnSkit = true;
		if((bool)pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3->insurance)
		{
		  cs.CurrentWinStreak = 0;
		  cs.CurrentLosingStreak++;
		  if (cs.CurrentLosingStreak > cs.LosingStreak)
		  {
				cs.LosingStreak = cs.CurrentLosingStreak;
		  }
		  if (cs.LargestLoss < pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->coinsplayedhand3)
		  {
				cs.LargestLoss = pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->coinsplayedhand3;
		  }
		  cs.Losses++;
		  cs.InsureWon++;
		}
		else
		{
		  cs.Pushes++;
		  cs.BJWins++;
		}
	 }
	 else
	 {
		cs.CurrentWinStreak = 0;
		cs.CurrentLosingStreak++;
		if (cs.CurrentLosingStreak > cs.LosingStreak)
		{
		  cs.LosingStreak = cs.CurrentLosingStreak;
		}
		if (cs.LargestLoss < pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->coinsplayedhand3)
		{
		 cs.LargestLoss = pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->coinsplayedhand3;
		}
		StartingFUC = 0;
		FUCLength = 0;
//		StartingFUC    = PTimePtr->GetFrameUpdateCount()+1;
		cs.Losses++;
		StartingFUC = pOwnerLord->GetAdjFUC();
		pOwnerLord->Loser2(StartingFUC,FUCLength);
		WaitOnSkit = true;
	 }
	}
	if(payinsureto == 7)
	{
	 int16 session = pOwnerLord->GetCasPD(pOwnerLord->BetSpotUse[5])->BJData.CurrentSession;
    TCBJSession &cs = pOwnerLord->GetCasPD(pOwnerLord->BetSpotUse[5])->BJData.Sessions[session];

	 if((bool)pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->pHand5->insurance ||
		 ((TBJHand *)pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->pHand5)->bj)
	 {
		StartingFUC = 0;
		FUCLength = 0;
//		StartingFUC    = PTimePtr->GetFrameUpdateCount()+1;
		StartingFUC = pOwnerLord->GetAdjFUC();
		pOwnerLord->Push3(StartingFUC,FUCLength);
		WaitOnSkit = true;
		if((bool)pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->pHand5->insurance)
		{
		  cs.CurrentWinStreak = 0;
		  cs.CurrentLosingStreak++;
		  if (cs.CurrentLosingStreak > cs.LosingStreak)
		  {
          cs.LosingStreak = cs.CurrentLosingStreak;
		  }
		  if (cs.LargestLoss < pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->coinsplayedhand5)
		  {
          cs.LargestLoss = pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->coinsplayedhand5;
		  }
		  cs.Losses++;
		  cs.InsureWon++;
		}
		else
		{
		  cs.Pushes++;
		  cs.BJWins++;
		}
	 }
	 else
	 {
		cs.CurrentWinStreak = 0;
		cs.CurrentLosingStreak++;
		if (cs.CurrentLosingStreak > cs.LosingStreak)
		{
		 cs.LosingStreak = cs.CurrentLosingStreak;
		}
		if (cs.LargestLoss < pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->coinsplayedhand5)
		{
		  cs.LargestLoss = pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->coinsplayedhand5;
		}
		cs.Losses++;
		StartingFUC = 0;
		FUCLength = 0;
//		StartingFUC    = PTimePtr->GetFrameUpdateCount()+1;
		StartingFUC = pOwnerLord->GetAdjFUC();
		pOwnerLord->Loser3(StartingFUC,FUCLength);
		WaitOnSkit = true;
	 }
	}

  }
  else if ((StartingFUC + FUCLength - 5) == NewFUC && WaitOnSkit)
  {
	 switch(payinsureto) {
		  case 1  : pOwnerLord->BetSpot[1]->NoShowCards();break;
		  case 4  : pOwnerLord->BetSpot[3]->NoShowCards();break;
		  case 7  : pOwnerLord->BetSpot[5]->NoShowCards();break;
	 }
  }
  else if ((StartingFUC + FUCLength - 2) == NewFUC && WaitOnSkit)
  {
	 pOwnerLord->DealerBlackJack(payinsureto);

	 return;
  }
  else if ((StartingFUC + FUCLength) <= NewFUC)
  {
	 pOwnerLord->Rack->ShowBJRack(discards);
	 FUCLength = 0;
	 WaitOnSkit = false;
	 ExecuteWaiting = false;
    switch(payinsureto) {
		  case 1  : pOwnerLord->BetSpot[1]->NoShow();break;
		  case 4  : pOwnerLord->BetSpot[3]->NoShow();break;
		  case 7  : pOwnerLord->BetSpot[5]->NoShow();break;
	 }
  }
}
//*******************************************************************
void TBJPayInsureState::CreateSubState1()
{
}
//*******************************************************************
void TBJPayInsureState::CreateSubState2()
{
}
//*******************************************************************
void TBJPayInsureState::CreateSubState3()
{
}
//*******************************************************************