//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  bjs1st.cpp    // split 1 state
//    Project Name:  Ogle
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     06/22/95   A. Krist    Original baseline
//  2.0     09/24/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "bjs1st.h"
#include "cbjglord.h"
//#include "otimers.h"
#include "bjdealst.h"
#include "bjbustst.h"
#include "cbjplay.h"
#include "bjdeck.h"
#include "bjs2st.h"
//#include "cbjglspl.h"
#include <iostream.h>
#include "orespond.h"
//*******************************************************************
TBJSplit1State::TBJSplit1State(TCasinoBJGameLord *pNewBJLord)
:TBJLordState(pNewBJLord)
{
  SetRunOrder(ess_Execute,ess_StartSubState2,ess_Execute,ess_Done);
  RemoveDoubleResponder       = NULL;
  ClearNoInsureStandResponder = NULL;
  SameYesInsureHitResponder   = NULL;
  DealSplitResponder          = NULL;
  splitflag                   = false;
  doubleflag                  = false;
  splitacesflag               = false;
  splitbutton                 = false;
  StartingFUC = 0;
  FUCLength   = 0;
  MenuEscResponder            = NULL;
  AskExpertResponder          = NULL;

  askexpertflag               = false;
  firsttwocards               = true;
  WaitOnSkit  = false;
}
//*******************************************************************
TBJSplit1State::~TBJSplit1State()
{
 // pOwnerLord->AskExpertButton->Release();
 // pOwnerLord->CasStatusBar->NoShowStatusBar();
  pOwnerLord->FreezeAllButtons();
}
//*******************************************************************
void TBJSplit1State::HandlePostUpdate(dword NewFUC)
{
  if(ExpertDelayStart)
  {
	 if(ExpertDelayStart + EXPERTDELAY <= NewFUC)
	 {
		ExpertDelayStart = 0;
	  //	pOwnerLord->AskExpertButton->Release();
	 }
  }
  if(WaitOnSkit)
  {
	 if((StartingFUC != 0) && ((StartingFUC + FUCLength) <= NewFUC))
	 {
		StartingFUC = 0;
		FUCLength   = 0;
		WaitOnSkit  = false;
      if(!FinishHit && !FinishStand && !FinishDouble)
		{
		  pOwnerLord->UnFreezeAllButtons();
		}
		if(LockHit)
		{
		  LockHit = false;
		  LockButtons = false;
		}
      if(HitTotal)
		{
		  if(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[0])->pHand0->highhand == 21 ||
			  pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[0])->pHand0->lohand == 21)
		  {
			 ExecuteStatus = ess_Done;
			 ExecuteWaiting = false;
		  }
		  HitTotal = false;
		}
	 }
	//? return;//?
  }
  if(!WaitOnSkit && WaitOnHitCom)
  {
//	 StartingFUC = PTimePtr->GetFrameUpdateCount() + 1;
    StartingFUC = pOwnerLord->GetAdjFUC();
	 pOwnerLord->HitComPlayer1(StartingFUC,FUCLength);
    pOwnerLord->FreezeAllButtons();
	 WaitOnSkit    = true;
	 WaitOnHitCom  = false;
	 FinishHit     = true;
  }
  if(!WaitOnSkit && FinishHit)
  {
	 ExecuteWaiting = false;
	 ExecuteStatus  = ess_StartSubState2;
	 FinishHit = false;
  }
  if(!WaitOnSkit && WaitOnStandCom)
  {
	 StartingFUC = pOwnerLord->GetAdjFUC();
	 pOwnerLord->StandComPlayer1(StartingFUC,FUCLength);
	 WaitOnSkit    = true;
    pOwnerLord->FreezeAllButtons();
	 WaitOnStandCom  = false;
	 FinishStand     = true;
  }
  if(!WaitOnSkit && FinishStand)
  {
	 ExecuteWaiting = false;
	 ExecuteStatus  = ess_Done;
	 FinishStand = false;
  }
  if(!WaitOnSkit && WaitOnDoubleCom)
  {
	 StartingFUC = pOwnerLord->GetAdjFUC();
	 pOwnerLord->DoubleComPlayer1(StartingFUC,FUCLength);
	 WaitOnSkit    = true;
	 pOwnerLord->FreezeAllButtons();
	 WaitOnDoubleCom  = false;
	 FinishDouble     = true;
  }
  if(!WaitOnSkit && FinishDouble)
  {
	 ExecuteWaiting = false;
	 ExecuteStatus  = ess_StartSubState2;
	 FinishDouble = false;
  }

  if((Stalling + TCasinoBJGameLord::STALLDELAY) <= NewFUC)
  {
	 StartingFUC = pOwnerLord->GetAdjFUC();        
	 pOwnerLord->Stalling(StartingFUC,FUCLength);
	 WaitOnSkit    = true;
    pOwnerLord->FreezeAllButtons();
	 Stalling      = NewFUC + FUCLength;
  }
  if(pOwnerLord->ButtonHit[bjidButton2])
  {
	 LockHit = false;
	 Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	 pOwnerLord->ButtonClear(bjidButton2);
	 return;
  }
  if(pOwnerLord->ButtonHit[bjidButton3])
  {
	 pOwnerLord->ButtonClear(bjidButton3);
	 return;
  }
  if(pOwnerLord->ButtonHit[bjidButton1])
  {
	 pOwnerLord->ButtonClear(bjidButton1);
	 return;
  }
  if(pOwnerLord->ButtonHit[bjidButton0])
  {
	 if(!askexpertflag)
	 {
		askexpertflag = true;
	 }
	 else
	 {
		if(firsttwocards)
		{
		  pOwnerLord->AskFirstTwoCardsExpert(0);
		}
		else
		{
		  pOwnerLord->AskAfterFirstTwoCardsExpert(0);
		}
		pOwnerLord->ButtonClear(bjidButton0);
		askexpertflag = false;
	 }
	 LockHit = false;
	 Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	 return;
  }
  if(pOwnerLord->ButtonHit[bjidButton16])
  {
	 if(StartingFUC == 0)
	 {
		CoachStats(0,bjStand,firsttwocards);
		Coach(0,bjStand);
	 }
	 if(IgnoreCoach)
	 {
		LockHit = false;
		pOwnerLord->ButtonClear(bjidButton16);
	  //	CoachStats(1,bjStand,firsttwocards);
	  //	Coach(1,bjStand);
		Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
      pOwnerLord->StallsInRow = 0;
		LockButtons = false;
		return;
	 }
	 if(StartingFUC)
	 {
		if(StartingFUC + FUCLength == NewFUC)
		{
		  WaitOnStandCom = true;
		  LockHit = false;
		  pOwnerLord->ButtonClear(bjidButton16);
		  Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
        pOwnerLord->StallsInRow = 0;
		  LockButtons = false;
		  StartingFUC = 0;
		  FUCLength   = 0;
		  return;
		}
	 }
	 else
	 {
		StartingFUC = pOwnerLord->GetAdjFUC();
		bool mf=true;
      pOwnerLord->FreezeAllButtons();
		pOwnerLord->StandFingers(mf,bjnl1A,StartingFUC,FUCLength);
	 }
	 return;
  }
  if(pOwnerLord->ButtonHit[bjidButton14])
  {
	 if(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[0])->pHand0->inhand < 3)
	 {
		CoachStats(0,bjDouble,firsttwocards);
		Coach(0,bjDouble);
		if(IgnoreCoach)
		{
		  pOwnerLord->ButtonClear(bjidButton14);
		  LockButtons = false;
		  return;
		}

		LockHit = false;
		pOwnerLord->ButtonClear(bjidButton14);
		pOwnerLord->DoubleDown(0);
		doubleflag = true;
		Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
      pOwnerLord->StallsInRow = 0;
		WaitOnDoubleCom = true;
		pOwnerLord->FreezeAllButtons();
	 }

	 return;
  }
  if(pOwnerLord->ButtonHit[bjidButton13])
  {
	 if(!LockButtons && pOwnerLord->GetCash(pOwnerLord->activeplayer) >=
	 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[0])->coinsplayedhand0)
	 {
		if(pOwnerLord->BetSpotUse[2] == -1 && pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[0])->pHand0->inhand < 3 &&
		((pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[0])->pHand0->cards[0].name ==
		  pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[0])->pHand0->cards[1].name) ||
		 (pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[0])->pHand0->cards[0].name >= Ten &&
		  pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[0])->pHand0->cards[0].name < AceHi) &&
		 (pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[0])->pHand0->cards[1].name >= Ten &&
		  pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[0])->pHand0->cards[1].name < AceHi)) )
		{
		  CoachStats(0,bjSplit,firsttwocards);
		  Coach(0,bjSplit);
		  if(IgnoreCoach)
		  {
			 pOwnerLord->ButtonClear(bjidButton13);
			 LockButtons = false;
			 return;
		  }
		  if (pOwnerLord->BetSpotUse[2] == -1)
		  {
			 LockButtons = false;
			 ExecuteWaiting = true;
			 ExecuteStatus = ess_StartSubState1;
			 pOwnerLord->splitwait = true;
			 splitflag = true;
			 pOwnerLord->BetSpot[0]->NoShowCard(1);
			 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->numsplitshand1++;

			 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand2 = new TBJHand;
			 pOwnerLord->BetSpotUse[2] = pOwnerLord->BetSpotUse[1];
			 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->coinsplayedhand2
				= pOwnerLord->SplitMoney(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->coinsplayedhand0);

			 pOwnerLord->BetSpot[2]->
				 SetNum(pOwnerLord->GetBJPlayer(pOwnerLord->activeplayer)->coinsplayedhand2);

			 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->pHand2->cards[0] =
				  pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand0->cards[1];
			 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->pHand2->inhand++;
			 pOwnerLord->BetSpot[2]->ShowFace(
						  pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->pHand2);

			 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[0])->pHand0->inhand--;
			 pOwnerLord->FreezeAllButtons();
		  }
		  Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
        pOwnerLord->StallsInRow = 0;
		  pOwnerLord->ButtonClear(bjidButton13);
		}
	  }
	  Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
     pOwnerLord->StallsInRow = 0;
	  pOwnerLord->ButtonClear(bjidButton13);
	  return;
  }
  if(pOwnerLord->ButtonHit[bjidButton15])
  {
	 if(StartingFUC == 0)
	 {
		CoachStats(0,bjHit,firsttwocards);
		Coach(0,bjHit);
	 }
    if(IgnoreCoach)
	 {
		Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
      pOwnerLord->StallsInRow = 0;
		pOwnerLord->ButtonClear(bjidButton15);
		LockButtons = false;
		return;
	 }
    if(StartingFUC)
	 {
		if(StartingFUC + FUCLength <= NewFUC)
		{
		  WaitOnHitCom = true;
        Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
        pOwnerLord->StallsInRow = 0;
		  pOwnerLord->ButtonClear(bjidButton15);
		  StartingFUC = 0;
		  FUCLength   = 0;
		  return;
		}
	 }
	 else
	 {
		pOwnerLord->Button13->ShowGray();
		pOwnerLord->Button14->ShowGray();
		firsttwocards = false;
		StartingFUC = pOwnerLord->GetAdjFUC();
		bool mf=true;
      pOwnerLord->FreezeAllButtons();
		pOwnerLord->HitFingers(mf,bjnl1A,StartingFUC,FUCLength);
	 }
	 //LockHit = false;
	// Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;pOwnerLord->StallsInRow = 0;
	// pOwnerLord->ButtonClear(bjidButton15);
	 return;
  }

}
//*******************************************************************
bool TBJSplit1State::HandleRemoveDouble(TResponder &responder)
{
 if(!LockButtons && pOwnerLord->GetCash(pOwnerLord->activeplayer) > 0)
 {
  if(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[0])->pHand0->inhand < 3)
  {
	 if (responder.GetResponseEvent() == reLUp)
	 {
		CoachStats(0,bjDouble,firsttwocards);
		Coach(0,bjDouble);
		RemoveDoubleResponder = &responder;
		LockButtons = true;
	 }

	 if (responder.GetResponseEvent() == reLDown)
	 {
//		Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
      Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
      pOwnerLord->StallsInRow = 0;
 //		pOwnerLord->RemoveDouble->ShowDoubleDown();
		responder.SetPriority();
	 }

	 if (responder.GetResponseEvent() == reChar)
	 {
//		Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
      Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
      pOwnerLord->StallsInRow = 0;
	 //	pOwnerLord->RemoveDouble->ShowDoubleDown();
		RemoveDoubleResponder = &responder;
	 }
  }
 }
 return true;
}
//*******************************************************************
bool TBJSplit1State::HandleClearNoInsureStand(TResponder &responder)
{
 if(!LockButtons)
 {
  if (responder.GetResponseEvent() == reLUp)
  {
	 CoachStats(0,bjStand,firsttwocards);
	 Coach(0,bjStand);
	 ClearNoInsureStandResponder = &responder;
	 LockButtons = true;
  }

  if (responder.GetResponseEvent() == reLDown)
  {
//	 Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
    Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	 //pOwnerLord->ClearNoInsureStand->ShowStandDown();
	// pOwnerLord->RemoveDouble->ShowDouble();
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
//	 Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
    Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	// pOwnerLord->ClearNoInsureStand->ShowStandDown();
	// pOwnerLord->RemoveDouble->ShowDouble();
	 ClearNoInsureStandResponder = &responder;
  }
 }
 return true;
}
//*******************************************************************
bool TBJSplit1State::HandleSameYesInsureHit(TResponder &responder)
{
 if(!LockButtons)
 {
  if (responder.GetResponseEvent() == reLUp)
  {
	 CoachStats(0,bjHit,firsttwocards);
	 Coach(0,bjHit);
	 SameYesInsureHitResponder = &responder;
	 LockButtons = true;
  }

  if (responder.GetResponseEvent() == reLDown)
  {
//	 Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
    Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
  //	 pOwnerLord->SameYesInsureHit->ShowHitDown();
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
//	 Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
    Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	// pOwnerLord->SameYesInsureHit->ShowHitDown();
	 SameYesInsureHitResponder = &responder;
  }
 }
 return true;
}
//*******************************************************************
bool TBJSplit1State::HandleDealSplit(TResponder &responder)
{
 if(!LockButtons && pOwnerLord->GetCash(pOwnerLord->activeplayer) >=
	 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[0])->coinsplayedhand0)
 {
	if(pOwnerLord->BetSpotUse[2] == -1 && pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[0])->pHand0->inhand < 3 &&
	  ((pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[0])->pHand0->cards[0].name ==
		 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[0])->pHand0->cards[1].name) ||
		(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[0])->pHand0->cards[0].name >= Ten &&
		 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[0])->pHand0->cards[0].name < AceHi) &&
		(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[0])->pHand0->cards[1].name >= Ten &&
		 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[0])->pHand0->cards[1].name < AceHi)) )
	{
	  if (responder.GetResponseEvent() == reLUp)
	  {
		 CoachStats(0,bjSplit,firsttwocards);
		 Coach(0,bjSplit);
		 DealSplitResponder = &responder;
		 LockButtons = true;
	  }

	 if (responder.GetResponseEvent() == reLDown)
	 {
//		Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
      Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
      pOwnerLord->StallsInRow = 0;
	//	pOwnerLord->DealSplit->ShowSplitDown();
		responder.SetPriority();
	 }

	 if (responder.GetResponseEvent() == reChar)
	 {
//		Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
      Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
      pOwnerLord->StallsInRow = 0;
	  //	pOwnerLord->DealSplit->ShowSplitDown();
		DealSplitResponder = &responder;
	 }
  }
 }
 return true;
}
//*******************************************************************
void TBJSplit1State::ExecuteFirstTime()
{
  pOwnerLord->Button0->ShowVoidUp();
  pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand0 = new TBJHand;
  pOwnerLord->BetSpotUse[0] = pOwnerLord->BetSpotUse[1];
  pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[0])->coinsplayedhand0 =
    pOwnerLord->SplitMoney(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->coinsplayedhand1);
  pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[0])->pHand0->cards[0] =
											  pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand1->cards[1];
  pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[0])->pHand0->inhand++;
  pOwnerLord->BetSpot[0]->ShowFace(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[0])->pHand0);
  pOwnerLord->BetSpot[0]->SetNum(pOwnerLord->GetBJPlayer(pOwnerLord->activeplayer)->coinsplayedhand0);
  /*********/
  pOwnerLord->/*((TBJDeck *)*/pDeck->
	  Busted(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[0])->pHand0);
  if(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[0])->pHand0->cards[0].name == AceHi)
  {
	 splitacesflag = true;
  }
  if(pOwnerLord->GetCash(pOwnerLord->activeplayer) > 0)
  {
	 pOwnerLord->Button14->ShowVoidUp();
  }
  else
  {
	 pOwnerLord->Button13->ShowGray();
	 pOwnerLord->Button14->ShowGray();
  }
  if(pOwnerLord->GetCash(pOwnerLord->activeplayer) <
		 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[0])->coinsplayedhand0)
  {
	 pOwnerLord->Button13->ShowGray();
  }
  int session=0;
  session = pOwnerLord->GetCasPD(pOwnerLord->BetSpotUse[0])->BJData.CurrentSession;
  TCBJSession &cs = pOwnerLord->GetCasPD(pOwnerLord->BetSpotUse[0])->BJData.Sessions[session];

  cs.HandsPlayed++;
  cs.Splits++;
  cs.TotalBetsCash += pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[0])->coinsplayedhand0;

  ExecuteWaiting = true;
  ExecuteStatus    = ess_StartSubState2;
  pOwnerLord->Button16->ShowVoidUp();
  pOwnerLord->Button15->ShowVoidUp();
  PlayerTotalMessage(0);
  pOwnerLord->pDeck->Busted(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[0])->pHand0);
  pOwnerLord->MessageDisplay->ShowBJMessage(pOwnerLord->PlayerTotal());
  splitbutton = true;
  FinishHit    = false;
  FinishStand  = false;
  FinishDouble = false;
  WaitOnHitCom    = false;
  WaitOnStandCom  = false;
  WaitOnDoubleCom = false;
  Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
  pOwnerLord->StallsInRow = 0;
  pOwnerLord->UnFreezeAllButtons();
}
//*******************************************************************
void TBJSplit1State::CreateSubState1()
{
  //PActiveSubState = new TBJSplit2State(pOwnerLord,2);
}
//*******************************************************************
void TBJSplit1State::EndSubState1()
{
  TState::EndSubState1();
  splitbutton = true;
}
//*******************************************************************
void TBJSplit1State::CreateSubState2()
{
  pOwnerLord->FreezeAllButtons();
  PActiveSubState = new TBJDealState(pOwnerLord,0);
}
//*******************************************************************
void TBJSplit1State::EndSubState2()
{
  TState::EndSubState2();
  if(splitacesflag)
  {
	 ExecuteStatus = ess_Done;
	 ExecuteWaiting = false;
	 splitacesflag = false;
  }
  else if(pOwnerLord->/*((TBJDeck *)*/pDeck->
	  Busted(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[0])->pHand0) == 1)
  {
	 pOwnerLord->FreezeAllButtons();
	 ExecuteStatus = ess_StartSubState3;
  }
  else if(doubleflag == true)
  {
	 doubleflag = false;
	 ExecuteStatus = ess_Done;
	 ExecuteWaiting = false;
  }
  else
  {
	 if(splitflag == true && pOwnerLord->
		 GetBJPlayer(pOwnerLord->BetSpotUse[0])->pHand0->cards[0].name == AceHi)
	 {
		splitflag = false;
		ExecuteStatus = ess_Done;
	 }
	 else
	 {
		splitflag = false;
	 }
  }
  ExecuteWaiting = true;
  PlayerTotalMessage(0);
  if(ExecuteStatus != ess_StartSubState3 && ExecuteStatus != ess_Done)
  {
	 StartingFUC = pOwnerLord->GetAdjFUC();
	 pOwnerLord->AnnouncePlayer1Total(StartingFUC,FUCLength);
	 WaitOnSkit    = true;
	 pOwnerLord->FreezeAllButtons();
	 LockHit = true;
	 HitTotal = true;
  }
  if(splitbutton)
  {
	 LockButtons = false;
	 splitbutton = false;
	 if(pOwnerLord->BetSpotUse[2] == -1 &&
		 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[0])->pHand0->inhand < 3 &&
		 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[0])->numsplitshand1 < 2 &&
		 pOwnerLord->GetCash(pOwnerLord->activeplayer) >=
		 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[0])->coinsplayedhand0   &&
	  ((pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[0])->pHand0->cards[0].name ==
		 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[0])->pHand0->cards[1].name) ||
		(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[0])->pHand0->cards[0].name >= Ten &&
		 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[0])->pHand0->cards[0].name < AceHi) &&
		(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[0])->pHand0->cards[1].name >= Ten &&
		 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[0])->pHand0->cards[1].name < AceHi)) )
	 {
		pOwnerLord->Button13->ShowVoidUp();
	 }
	 else
	 {
		pOwnerLord->Button13->ShowGray();
	 }
  }
}
//*******************************************************************
void TBJSplit1State::CreateSubState3()
{
  PActiveSubState = new TBJBustState(pOwnerLord,0);
}
//*******************************************************************
bool TBJSplit1State::HandleMenuEsc(TResponder &responder)
{
	if (responder.GetResponseEvent() == reLUp)
  {
	 MenuEscResponder = &responder;
  }

  if (responder.GetResponseEvent() == reLDown)
  {
//	 Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
	 Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	 //	pOwnerLord->MenuEscButton->Depress();
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
//	 Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
    Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
  //	 pOwnerLord->MenuEscButton->Depress();
	 MenuEscResponder = &responder;
  }

  return true;
}
//*******************************************************************
bool TBJSplit1State::HandleAskExpert(TResponder &responder)
{
	if (responder.GetResponseEvent() == reLUp)
  {
	 AskExpertResponder = &responder;
  }

  if (responder.GetResponseEvent() == reLDown)
  {
//	 Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
    Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	  //	pOwnerLord->AskExpertButton->Depress();
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
//	 Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
    Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	  //	pOwnerLord->AskExpertButton->Depress();
	 AskExpertResponder = &responder;
  }

  return true;
}

//*******************************************************************//*******************************************************************
