//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  bjs6st.cpp    // split 6 state
//    Project Name:  Ogle
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     06/22/95   A. Krist    Original baseline
//  2.0     09/23/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "bjs6st.h"
#include "bjs8st.h"
#include "cbjglord.h"
#include "otimers.h"
#include "bjdealst.h"
#include "bjbustst.h"
#include "cbjplay.h"
#include "bjdeck.h"
//#include "cbjglspl.h"
#include <iostream.h>
#include "orespond.h"
//*******************************************************************
TBJSplit6State::TBJSplit6State(TCasinoBJGameLord *pNewBJLord,int16 Split)
:TBJLordState(pNewBJLord)
{
  SetRunOrder(ess_Execute,ess_Execute,ess_Done,ess_StartSubState1);
  RemoveDoubleResponder       = NULL;
  ClearNoInsureStandResponder = NULL;
  SameYesInsureHitResponder   = NULL;
  DealSplitResponder          = NULL;
  doubleflag                  = false;
  splitflag                   = false;
  splitbutton                 = false;
  pOwnerLord->splitwait       = false;
  splitacesflag               = false;
  split                       = Split;
  StartingFUC = 0;
  FUCLength   = 0;
  FinishHit    = false;
  FinishSplit  = false;
  FinishStand  = false;
  FinishDouble = false;
  WaitOnHitCom    = false;
  WaitOnStandCom  = false;
  WaitOnDoubleCom = false;
  MenuEscResponder            = NULL;
  AskExpertResponder          = NULL;
  askexpertflag               = false;
  firsttwocards               = true;
  WaitOnSkit                  = false;
}
//*******************************************************************
TBJSplit6State::~TBJSplit6State()
{
 // pOwnerLord->CasStatusBar->NoShowStatusBar();
  pOwnerLord->Button0->ShowVoidUp();
  pOwnerLord->FreezeAllButtons();
}
//*******************************************************************
void TBJSplit6State::HandlePostUpdate(dword NewFUC)
{
  if(pOwnerLord->ButtonHit[bjidButton2])
  {
	 LockHit = false;
	 Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	 pOwnerLord->ButtonClear(bjidButton2);
	 return;
  }
  if(pOwnerLord->ButtonHit[bjidButton3])
  {
	 pOwnerLord->ButtonClear(bjidButton3);
	 return;
  }
  if(pOwnerLord->ButtonHit[bjidButton1])
  {
	 pOwnerLord->ButtonClear(bjidButton1);
	 return;
  }
  if(pOwnerLord->ButtonHit[bjidButton0])
  {
	 if(!askexpertflag)
	 {
		askexpertflag = true;
	 }
	 else
	 {
		if(firsttwocards)
		{
		  pOwnerLord->AskFirstTwoCardsExpert(6);
		}
		else
		{
		  pOwnerLord->AskAfterFirstTwoCardsExpert(6);
		}
		pOwnerLord->ButtonClear(bjidButton0);
		askexpertflag = false;
	 }
	 LockHit = false;
	 Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	 return;
  }
  if(ExpertDelayStart)
  {
	 if(ExpertDelayStart + EXPERTDELAY <= NewFUC)
	 {
		ExpertDelayStart = 0;
		pOwnerLord->Button0->ShowVoidUp();
	 }
  }
  if(WaitOnSkit)
  {
	 if((StartingFUC != 0) && ((StartingFUC + FUCLength) <= NewFUC))
	 {
		StartingFUC = 0;
		FUCLength   = 0;
		WaitOnSkit  = false;
		if(!FinishHit && !FinishStand && !FinishDouble && !FinishSplit)
		{
		  pOwnerLord->UnFreezeAllButtons();
		}
		if(LockHit)
		{
		  LockHit = false;
		  LockButtons = false;
		}
		if(HitTotal)
		{
		  if(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[6])->pHand6->highhand == 21 ||
			  pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[6])->pHand6->lohand == 21)
		  {
			 ExecuteStatus = ess_Done;
			 ExecuteWaiting = false;
		  }
		  HitTotal = false;
		}
	 }
	//?? return;//?
  }
  if(!WaitOnSkit && WaitOnHitCom)
  {
//	 StartingFUC = PTimePtr->GetFrameUpdateCount() + 1;
    StartingFUC = pOwnerLord->GetAdjFUC();
	 pOwnerLord->HitComPlayer3(StartingFUC,FUCLength);
	 WaitOnSkit    = true;
    pOwnerLord->FreezeAllButtons();
	 WaitOnHitCom  = false;
	 FinishHit     = true;
  }
  if(!WaitOnSkit && FinishHit)
  {
	 ExecuteWaiting = false;
	 ExecuteStatus  = ess_StartSubState1;
	 FinishHit = false;
  }
  if(!WaitOnSkit && WaitOnStandCom)
  {
//	 StartingFUC = PTimePtr->GetFrameUpdateCount() + 1;
    StartingFUC = pOwnerLord->GetAdjFUC();
	 pOwnerLord->StandComPlayer3(StartingFUC,FUCLength);
	 WaitOnSkit    = true;
    pOwnerLord->FreezeAllButtons();
	 WaitOnStandCom  = false;
	 FinishStand     = true;
  }
  if(!WaitOnSkit && FinishStand)
  {
	 ExecuteWaiting = false;
	 ExecuteStatus  = ess_Done;
	 FinishStand = false;
  }
  if(!WaitOnSkit && WaitOnDoubleCom)
  {
//	 StartingFUC = PTimePtr->GetFrameUpdateCount() + 1;
    StartingFUC = pOwnerLord->GetAdjFUC();
	 pOwnerLord->DoubleComPlayer3(StartingFUC,FUCLength);
	 WaitOnSkit    = true;
    pOwnerLord->FreezeAllButtons();
	 WaitOnDoubleCom  = false;
	 FinishDouble     = true;
  }
  if(!WaitOnSkit && FinishDouble)
  {
	 ExecuteWaiting = false;
	 ExecuteStatus  = ess_StartSubState1;
	 FinishDouble = false;
  }
  if(!WaitOnSkit && FinishSplit)
  {
	 FinishSplit = false;
	 if (pOwnerLord->BetSpotUse[5] == -1)
	 {
		LockButtons = false;
	  //	pOwnerLord->DealSplit->ShowSplit();
		ExecuteWaiting = false;
		ExecuteStatus = ess_StartSubState3;
		splitflag = true;
		pOwnerLord->BetSpot[6]->NoShowCard(1);
		pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[6])->numsplitshand5++;
	 }
  }

  if((Stalling + TCasinoBJGameLord::STALLDELAY) <= NewFUC)
  {
//	 StartingFUC = PTimePtr->GetFrameUpdateCount() + 1;
    StartingFUC = pOwnerLord->GetAdjFUC();
	 pOwnerLord->Stalling(StartingFUC,FUCLength);
	 WaitOnSkit    = true;
    pOwnerLord->FreezeAllButtons();
	 Stalling      = NewFUC + FUCLength;
  }
  if(pOwnerLord->ButtonHit[bjidButton16])
  {
	 if(StartingFUC == 0)
	 {
		CoachStats(6,bjStand,firsttwocards);
		Coach(6,bjStand);
	 }
	 if(IgnoreCoach)
	 {
		LockHit = false;
		pOwnerLord->ButtonClear(bjidButton16);
	  //	CoachStats(1,bjStand,firsttwocards);
	  //	Coach(1,bjStand);
		Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
      pOwnerLord->StallsInRow = 0;
		LockButtons = false;
		return;
	 }
	 if(StartingFUC)
	 {
		if(StartingFUC + FUCLength == NewFUC)
		{
		  WaitOnStandCom = true;
		  LockHit = false;
		  pOwnerLord->ButtonClear(bjidButton16);
		  Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
        pOwnerLord->StallsInRow = 0;
		  LockButtons = false;
		  StartingFUC = 0;
		  FUCLength   = 0;
		  return;
		}
	 }
	 else
	 {
		StartingFUC = pOwnerLord->GetAdjFUC();
		bool mf=true;
      pOwnerLord->FreezeAllButtons();
		pOwnerLord->StandFingers(mf,bjnl3G,StartingFUC,FUCLength);
	 }
	 return;
  }
  if(pOwnerLord->ButtonHit[bjidButton14])
  {
	 if(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[6])->pHand6->inhand < 3)
	 {
		CoachStats(6,bjDouble,firsttwocards);
		Coach(6,bjDouble);
		if(IgnoreCoach)
		{
		  pOwnerLord->ButtonClear(bjidButton14);
		  LockButtons = false;
		  return;
		}

		LockHit = false;
		pOwnerLord->ButtonClear(bjidButton14);
		pOwnerLord->DoubleDown(6);
		doubleflag = true;
		Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
      pOwnerLord->StallsInRow = 0;
		WaitOnDoubleCom = true;
		pOwnerLord->FreezeAllButtons();
	 }
	 return;
  }
  if(pOwnerLord->ButtonHit[bjidButton13])
  {
	 if(!LockButtons && pOwnerLord->GetCash(pOwnerLord->activeplayer) >=
	 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[6])->coinsplayedhand6)
	 {
		 TCasinoBJPlayer *player;
		 player = pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[6]);
		 if((pOwnerLord->BetSpotUse[5] == -1) &&
			player->numsplitshand5 < 2 &&
			player->pHand6->inhand < 3 &&
		 ((player->pHand6->cards[0].name ==
			player->pHand6->cards[1].name) ||
		  (player->pHand6->cards[0].name >= Ten &&
			player->pHand6->cards[0].name < AceHi) &&
		  (player->pHand6->cards[1].name >= Ten &&
			player->pHand6->cards[1].name < AceHi) ) )
		 {
			CoachStats(6,bjSplit,firsttwocards);
			Coach(6,bjSplit);
			if(IgnoreCoach)
			{
			  pOwnerLord->ButtonClear(bjidButton13);
			  LockButtons = false;
			  return;
			}
			if(pOwnerLord->BetSpotUse[5] == -1)
			{
			  FUCLength = 0;
			  StartingFUC = pOwnerLord->GetAdjFUC();
			  pOwnerLord->SplitComPlayer3(StartingFUC,FUCLength);
			  WaitOnSkit    = true;
           pOwnerLord->FreezeAllButtons();
			  FinishSplit   = true;
			  pOwnerLord->FreezeAllButtons();
			}
         Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
         pOwnerLord->StallsInRow = 0;
			pOwnerLord->ButtonClear(bjidButton13);
		 }
	 }
    Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	 pOwnerLord->ButtonClear(bjidButton13);
	 return;
  }
  if(pOwnerLord->ButtonHit[bjidButton15])
  {
	 if(StartingFUC == 0)
	 {
		CoachStats(6,bjHit,firsttwocards);
		Coach(6,bjHit);
	 }
    if(IgnoreCoach)
	 {
		Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
      pOwnerLord->StallsInRow = 0;
		pOwnerLord->ButtonClear(bjidButton15);
		LockButtons = false;
		return;
	 }
    if(StartingFUC)
	 {
		if(StartingFUC + FUCLength <= NewFUC)
		{
		  WaitOnHitCom = true;
        Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
        pOwnerLord->StallsInRow = 0;
		  pOwnerLord->ButtonClear(bjidButton15);
		  StartingFUC = 0;
		  FUCLength   = 0;
		  return;
		}
	 }
	 else
	 {
		pOwnerLord->Button14->ShowGray();
      pOwnerLord->Button13->ShowGray();
		firsttwocards = false;
		StartingFUC = pOwnerLord->GetAdjFUC();
		bool mf=true;
      pOwnerLord->FreezeAllButtons();
		pOwnerLord->HitFingers(mf,bjnl3G,StartingFUC,FUCLength);
	 }
	 //LockHit = false;
	// Stalling = pOwnerLord->GetFUC() + STALLDELAY;pOwnerLord->StallsInRow = 0;
	// pOwnerLord->ButtonClear(bjidButton15);
	 return;
  }

}
//*******************************************************************
bool TBJSplit6State::HandleRemoveDouble(TResponder &responder)
{
 if(!LockButtons && pOwnerLord->GetCash(pOwnerLord->activeplayer) > 0)
 {
  if(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[6])->pHand6->inhand < 3)
  {
	 if (responder.GetResponseEvent() == reLUp)
	 {
		CoachStats(6,bjDouble,firsttwocards);
		Coach(6,bjDouble);
		RemoveDoubleResponder = &responder;
		LockButtons = true;
	 }

	 if (responder.GetResponseEvent() == reLDown)
	 {
//		Stalling = PTimePtr->GetFrameUpdateCount() + STALLDELAY;
      Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
      pOwnerLord->StallsInRow = 0;
		//pOwnerLord->Button14->ShowDown();
		responder.SetPriority();
	 }

	 if (responder.GetResponseEvent() == reChar)
	 {
//		Stalling = PTimePtr->GetFrameUpdateCount() + STALLDELAY;
		Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
      pOwnerLord->StallsInRow = 0;
	 //	pOwnerLord->Button14->ShowDown();
		RemoveDoubleResponder = &responder;
	 }
  }
 }
 return true;
}
//*******************************************************************
bool TBJSplit6State::HandleClearNoInsureStand(TResponder &responder)
{
 if(!LockButtons)
 {
  if (responder.GetResponseEvent() == reLUp)
  {
	 CoachStats(6,bjStand,firsttwocards);
	 Coach(6,bjStand);
	 ClearNoInsureStandResponder = &responder;
	 LockButtons = true;
  }

  if (responder.GetResponseEvent() == reLDown)
  {
//	 Stalling = PTimePtr->GetFrameUpdateCount() + STALLDELAY;
    Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
		//pOwnerLord->ClearNoInsureStand->ShowStandDown();
		//pOwnerLord->RemoveDouble->ShowDouble();
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
//	 Stalling = PTimePtr->GetFrameUpdateCount() + STALLDELAY;
    Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	 //	pOwnerLord->ClearNoInsureStand->ShowStandDown();
	 //  pOwnerLord->RemoveDouble->ShowDouble();
	 ClearNoInsureStandResponder = &responder;
  }
 }
 return true;
}
//*******************************************************************
bool TBJSplit6State::HandleSameYesInsureHit(TResponder &responder)
{
 if(!LockButtons)
 {
  if (responder.GetResponseEvent() == reLUp)
  {
	 CoachStats(6,bjHit,firsttwocards);
	 Coach(6,bjHit);
	 SameYesInsureHitResponder = &responder;
	 LockButtons = true;
  }

  if (responder.GetResponseEvent() == reLDown)
  {
//	 Stalling = PTimePtr->GetFrameUpdateCount() + STALLDELAY;
    Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	 //pOwnerLord->Button15->ShowDown();
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
//	 Stalling = PTimePtr->GetFrameUpdateCount() + STALLDELAY;
	 Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	 //pOwnerLord->Button15->ShowDown();
	 SameYesInsureHitResponder = &responder;
  }
 }
 return true;
}
//*******************************************************************
bool TBJSplit6State::HandleDealSplit(TResponder &responder)
{
 if(!LockButtons && pOwnerLord->GetCash(pOwnerLord->activeplayer) >=
	 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[6])->coinsplayedhand6)
 {
	 TCasinoBJPlayer *player;
	 player = pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[6]);
	 if((pOwnerLord->BetSpotUse[5] == -1) &&
		player->numsplitshand5 < 2 &&
		player->pHand6->inhand < 3 &&
	 ((player->pHand6->cards[0].name ==
		player->pHand6->cards[1].name) ||
	  (player->pHand6->cards[0].name >= Ten &&
		player->pHand6->cards[0].name < AceHi) &&
	  (player->pHand6->cards[1].name >= Ten &&
		player->pHand6->cards[1].name < AceHi) ) )
  {
	 if (responder.GetResponseEvent() == reLUp)
	 {
		CoachStats(5,bjSplit,firsttwocards);
		Coach(5,bjSplit);
		LockButtons = true;
		DealSplitResponder = &responder;
	 }

	 if (responder.GetResponseEvent() == reLDown)
	 {
//		Stalling = PTimePtr->GetFrameUpdateCount() + STALLDELAY;
      Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
      pOwnerLord->StallsInRow = 0;
	//	pOwnerLord->Button13->ShowDown();
		responder.SetPriority();
	 }

	 if (responder.GetResponseEvent() == reChar)
	 {
//		Stalling = PTimePtr->GetFrameUpdateCount() + STALLDELAY;
      Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
      pOwnerLord->StallsInRow = 0;
	  //	pOwnerLord->Button13->ShowDown();
		DealSplitResponder = &responder;
	 }
  }
 }
 return true;
}
//*******************************************************************
void TBJSplit6State::ExecuteFirstTime()
{
  pOwnerLord->Button0->ShowVoidUp();
  if(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[6])->pHand6->cards[0].name == AceHi)
  {
	 splitacesflag = true;
  }
  int session=0;
  session = pOwnerLord->GetCasPD(pOwnerLord->BetSpotUse[6])->BJData.CurrentSession;
  pOwnerLord->GetCasPD(pOwnerLord->BetSpotUse[6])->BJData.Sessions[session].HandsPlayed++;
  pOwnerLord->GetCasPD(pOwnerLord->BetSpotUse[6])->BJData.Sessions[session].Splits++;
  pOwnerLord->GetCasPD(pOwnerLord->BetSpotUse[6])->BJData.Sessions[session].TotalBetsCash +=
	 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[6])->coinsplayedhand6;

  ExecuteWaiting = true;
  ExecuteStatus    = ess_StartSubState1;
//  int x = pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[6])->numsplitshand5;
//  int y = pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[6])->pHand6->inhand;
//  int z = pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[6])->pHand6->cards[0].name;
//  int w = pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[6])->pHand6->cards[1].name;
/*  if((pOwnerLord->BetSpotUse[5] == -1) &&
			 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[6])->numsplitshand5 < 2 &&
			 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[6])->pHand6->inhand < 3 &&
		  ((pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[6])->pHand6->cards[0].name ==
			 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[6])->pHand6->cards[1].name) ||
			(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[6])->pHand6->cards[0].name >= Ten &&
			 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[6])->pHand6->cards[0].name < AceHi) &&
			(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[6])->pHand6->cards[1].name >= Ten &&
			 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[6])->pHand6->cards[1].name < AceHi)) )
  {
	 pOwnerLord->Button13->ShowVoidUp();
  }*/
  if(pOwnerLord->GetCash(pOwnerLord->activeplayer) > 0)
  {
	 pOwnerLord->Button14->ShowVoidUp();
  }
  else
  {
	 pOwnerLord->Button13->ShowGray();
	 pOwnerLord->Button14->ShowGray();
  }
  if(pOwnerLord->GetCash(pOwnerLord->activeplayer) <
		 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[6])->coinsplayedhand6)
  {
	 pOwnerLord->Button13->ShowGray();
  }
  splitbutton = true;
  pOwnerLord->Button16->ShowVoidUp();
  pOwnerLord->Button15->ShowVoidUp();
  pOwnerLord->pDeck->Busted(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[6])->pHand6);
  pOwnerLord->MessageDisplay->ShowBJMessage(pOwnerLord->PlayerTotal());
  PlayerTotalMessage(6);
  Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
  pOwnerLord->StallsInRow = 0;
  pOwnerLord->UnFreezeAllButtons();
}
//*******************************************************************
void TBJSplit6State::CreateSubState3()
{
  pOwnerLord->Circle3->SetPart(pOwnerLord->activeplayer,bjnl3F);
  PActiveSubState = new TBJSplit8State(pOwnerLord,1);
}
//*******************************************************************
void TBJSplit6State::EndSubState3()
{
  TState::EndSubState3();
//  Stalling = PTimePtr->GetFrameUpdateCount() + STALLDELAY;
  Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
  pOwnerLord->StallsInRow = 0;
  pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[6])->pHand6->inhand--;
  splitbutton = true;
}
//*******************************************************************
void TBJSplit6State::CreateSubState1()
{
  pOwnerLord->FreezeAllButtons();
  PActiveSubState = new TBJDealState(pOwnerLord,8);
}
//*******************************************************************
void TBJSplit6State::EndSubState1()
{
  TState::EndSubState1();
  if(splitacesflag)
  {
	 ExecuteStatus  = ess_Done;
	 ExecuteWaiting = false;
	 splitacesflag  = false;
  }
  else if(pOwnerLord->/*((TBJDeck *)*/pDeck->
	  Busted(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[6])->pHand6) == 1)
  {
    pOwnerLord->FreezeAllButtons();
	 ExecuteStatus = ess_StartSubState2;
  }
  else if(doubleflag == true)
  {
	 doubleflag = false;
	 ExecuteStatus = ess_Done;
	 ExecuteWaiting = false;
  }
  ExecuteWaiting = true;    //What the hell is this doing here...
  PlayerTotalMessage(6);
  if(ExecuteStatus != ess_StartSubState2 && ExecuteStatus != ess_Done)
  {
//	 StartingFUC = PTimePtr->GetFrameUpdateCount() + 1;
    StartingFUC = pOwnerLord->GetAdjFUC();
	 pOwnerLord->AnnouncePlayer3Total(StartingFUC,FUCLength);
	 WaitOnSkit    = true;
    pOwnerLord->FreezeAllButtons();
	 LockHit = true;
	 HitTotal = true;
  }
  if(splitbutton)
  {
	 LockButtons = false;
	 splitbutton = false;
	 if((pOwnerLord->BetSpotUse[5] == -1) &&
			 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[6])->numsplitshand5 < 2 &&
			 pOwnerLord->GetCash(pOwnerLord->activeplayer) >=
			 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->coinsplayedhand6   &&
			 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[6])->pHand6->inhand < 3 &&
		  ((pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[6])->pHand6->cards[0].name ==
			 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[6])->pHand6->cards[1].name) ||
			(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[6])->pHand6->cards[0].name >= Ten &&
			 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[6])->pHand6->cards[0].name < AceHi) &&
			(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[6])->pHand6->cards[1].name >= Ten &&
			 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[6])->pHand6->cards[1].name < AceHi)) )
	 {
		pOwnerLord->Button13->ShowVoidUp();
	 }
	 else
	 {
		pOwnerLord->Button13->ShowGray();
	 }
  }
  Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
  pOwnerLord->StallsInRow = 0;
}
//*******************************************************************
void TBJSplit6State::CreateSubState2()
{
  PActiveSubState = new TBJBustState(pOwnerLord,8);
}
//*******************************************************************
bool TBJSplit6State::HandleMenuEsc(TResponder &responder)
{
	if (responder.GetResponseEvent() == reLUp)
  {
	 MenuEscResponder = &responder;
  }

  if (responder.GetResponseEvent() == reLDown)
  {
//	 Stalling = PTimePtr->GetFrameUpdateCount() + STALLDELAY;
    Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	 //	pOwnerLord->MenuEscButton->Depress();
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
//	 Stalling = PTimePtr->GetFrameUpdateCount() + STALLDELAY;
    Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	  //	pOwnerLord->MenuEscButton->Depress();
	 MenuEscResponder = &responder;
  }

  return true;
}
//*******************************************************************
bool TBJSplit6State::HandleAskExpert(TResponder &responder)
{
	if (responder.GetResponseEvent() == reLUp)
  {
	 AskExpertResponder = &responder;
  }

  if (responder.GetResponseEvent() == reLDown)
  {
//	 Stalling = PTimePtr->GetFrameUpdateCount() + STALLDELAY;
    Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	 //	pOwnerLord->AskExpertButton->Depress();
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
//	 Stalling = PTimePtr->GetFrameUpdateCount() + STALLDELAY;
    Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	  //	pOwnerLord->AskExpertButton->Depress();
	 AskExpertResponder = &responder;
  }

  return true;
}

//*******************************************************************//*******************************************************************
