//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  bjs7st.cpp    // split 7 state
//    Project Name:  Ogle
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     3/22/96   A. Krist    Original baseline
//  2.0    09/23/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "bjs7st.h"
#include "cbjglord.h"
#include "otimers.h"
#include "bjdealst.h"
#include "bjbustst.h"
#include "cbjplay.h"
#include "bjdeck.h"
//#include "cbjglspl.h"
#include <iostream.h>
#include "orespond.h"
//*******************************************************************
TBJSplit7State::TBJSplit7State(TCasinoBJGameLord *pNewBJLord,int16 Split)
:TBJLordState(pNewBJLord)
{
  SetRunOrder(ess_Execute,ess_Execute,ess_Done);
  RemoveDoubleResponder       = NULL;
  ClearNoInsureStandResponder = NULL;
  SameYesInsureHitResponder   = NULL;
  doubleflag                  = false;
  splitacesflag               = false;
  split                       = Split;
  StartingFUC = 0;
  FUCLength   = 0;
  MenuEscResponder            = NULL;
  AskExpertResponder         = NULL;

  askexpertflag               = false;
  firsttwocards               = true;
  WaitOnSkit  = false;

}
//*******************************************************************
TBJSplit7State::~TBJSplit7State()
{
  //pOwnerLord->CasStatusBar->NoShowStatusBar();
 // pOwnerLord->AskExpertButton->Release();
  pOwnerLord->FreezeAllButtons();
}
//*******************************************************************
void TBJSplit7State::HandlePostUpdate(dword NewFUC)
{
  if(pOwnerLord->ButtonHit[bjidButton2])
  {
	 LockHit = false;
	 Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	 pOwnerLord->ButtonClear(bjidButton2);
	 return;
  }
  if(pOwnerLord->ButtonHit[bjidButton3])
  {
	 pOwnerLord->ButtonClear(bjidButton3);
	 return;
  }
  if(pOwnerLord->ButtonHit[bjidButton1])
  {
	 pOwnerLord->ButtonClear(bjidButton1);
	 return;
  }
  if(pOwnerLord->ButtonHit[bjidButton0])
  {
	 if(!askexpertflag)
	 {
		askexpertflag = true;
	 }
	 else
	 {
		if(firsttwocards)
		{
		  pOwnerLord->AskFirstTwoCardsExpert(3);
		}
		else
		{
		  pOwnerLord->AskAfterFirstTwoCardsExpert(3);
		}
		pOwnerLord->ButtonClear(bjidButton0);
		askexpertflag = false;
	 }
	 LockHit = false;
	 Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	 return;
  }
  if(ExpertDelayStart)
  {
	 if(ExpertDelayStart + EXPERTDELAY <= NewFUC)
	 {
		ExpertDelayStart = 0;
		//pOwnerLord->AskExpertButton->Release();
	 }
  }
  if(WaitOnSkit)
  {
	 if((StartingFUC != 0) && ((StartingFUC + FUCLength) <= NewFUC))
	 {
		StartingFUC = 0;
		FUCLength   = 0;
		WaitOnSkit  = false;
		if(!FinishHit && !FinishStand && !FinishDouble)
		{
		  pOwnerLord->UnFreezeAllButtons();
		}
		if(LockHit)
		{
		  LockHit = false;
		  LockButtons = false;
		}
      if(HitTotal)
		{
		  if(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3->highhand == 21 ||
			  pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3->lohand == 21)
		  {
			 ExecuteStatus = ess_Done;
			 ExecuteWaiting = false;
		  }
		  HitTotal = false;
		}
	 }
	//??? return;//?
  }
  if(!WaitOnSkit && WaitOnHitCom)
  {
//	 StartingFUC = PTimePtr->GetFrameUpdateCount() + 1;
    StartingFUC = pOwnerLord->GetAdjFUC();
	 pOwnerLord->HitComPlayer2(StartingFUC,FUCLength);
	 WaitOnSkit    = true;
    pOwnerLord->FreezeAllButtons();
	 WaitOnHitCom  = false;
	 FinishHit     = true;
  }
  if(!WaitOnSkit && FinishHit)
  {
	 ExecuteWaiting = false;
	 ExecuteStatus  = ess_StartSubState1;
	 FinishHit = false;
  }
  if(!WaitOnSkit && WaitOnStandCom)
  {
//	 StartingFUC = PTimePtr->GetFrameUpdateCount() + 1;
    StartingFUC = pOwnerLord->GetAdjFUC();
	 pOwnerLord->StandComPlayer2(StartingFUC,FUCLength);
	 WaitOnSkit    = true;
    pOwnerLord->FreezeAllButtons();
	 WaitOnStandCom  = false;
	 FinishStand     = true;
  }
  if(!WaitOnSkit && FinishStand)
  {
	 ExecuteWaiting = false;
	 ExecuteStatus  = ess_Done;
	 FinishStand = false;
  }
  if(!WaitOnSkit && WaitOnDoubleCom)
  {
//	 StartingFUC = PTimePtr->GetFrameUpdateCount() + 1;
    StartingFUC = pOwnerLord->GetAdjFUC();
	 pOwnerLord->DoubleComPlayer2(StartingFUC,FUCLength);
	 WaitOnSkit    = true;
    pOwnerLord->FreezeAllButtons();
	 WaitOnDoubleCom  = false;
	 FinishDouble     = true;
  }
  if(!WaitOnSkit && FinishDouble)
  {
	 ExecuteWaiting = false;
	 ExecuteStatus  = ess_StartSubState1;
	 FinishDouble = false;
  }

  if((Stalling + TCasinoBJGameLord::STALLDELAY) <= NewFUC)
  {
//	 StartingFUC = PTimePtr->GetFrameUpdateCount() + 1;
    StartingFUC = pOwnerLord->GetAdjFUC();
	 pOwnerLord->Stalling(StartingFUC,FUCLength);
	 WaitOnSkit    = true;
    pOwnerLord->FreezeAllButtons();
	 Stalling      = NewFUC + FUCLength;
  }
  if(pOwnerLord->ButtonHit[bjidButton16])
  {
	 if(StartingFUC == 0)
	 {
		CoachStats(3,bjStand,firsttwocards);
		Coach(3,bjStand);
	 }
	 if(IgnoreCoach)
	 {
		LockHit = false;
		pOwnerLord->ButtonClear(bjidButton16);
	  //	CoachStats(1,bjStand,firsttwocards);
	  //	Coach(1,bjStand);
		Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
      pOwnerLord->StallsInRow = 0;
		LockButtons = false;
		return;
	 }
	 if(StartingFUC)
	 {
		if(StartingFUC + FUCLength == NewFUC)
		{
		  WaitOnStandCom = true;
		  LockHit = false;
		  pOwnerLord->ButtonClear(bjidButton16);
		  Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
        pOwnerLord->StallsInRow = 0;
		  LockButtons = false;
		  StartingFUC = 0;
		  FUCLength   = 0;
		  return;
		}
	 }
	 else
	 {
		StartingFUC = pOwnerLord->GetAdjFUC();
		bool mf=true;
      pOwnerLord->FreezeAllButtons();
		pOwnerLord->StandFingers(mf,bjnl2D,StartingFUC,FUCLength);
	 }
	 return;
  }
  if(pOwnerLord->ButtonHit[bjidButton14])
  {
	 if(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3->inhand < 3)
	 {
		CoachStats(3,bjDouble,firsttwocards);
		Coach(3,bjDouble);
		if(IgnoreCoach)
		{
		  pOwnerLord->ButtonClear(bjidButton14);
		  LockButtons = false;
		  return;
		}

		LockHit = false;
		pOwnerLord->ButtonClear(bjidButton14);
		pOwnerLord->DoubleDown(3);
		doubleflag = true;
		Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
      pOwnerLord->StallsInRow = 0;
		WaitOnDoubleCom = true;
      pOwnerLord->FreezeAllButtons();
	 }

	 return;
  }
  if(pOwnerLord->ButtonHit[bjidButton15])
  {
	 if(StartingFUC == 0)
	 {
		CoachStats(3,bjHit,firsttwocards);
		Coach(3,bjHit);
	 }
	 if(IgnoreCoach)
	 {
		Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
      pOwnerLord->StallsInRow = 0;
		pOwnerLord->ButtonClear(bjidButton15);
		LockButtons = false;
		return;
	 }
    if(StartingFUC)
	 {
		if(StartingFUC + FUCLength <= NewFUC)
		{
		  WaitOnHitCom = true;
        Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
        pOwnerLord->StallsInRow = 0;
		  pOwnerLord->ButtonClear(bjidButton15);
		  StartingFUC = 0;
		  FUCLength   = 0;
		  return;
		}
	 }
	 else
	 {
		pOwnerLord->Button14->ShowGray();
      pOwnerLord->Button13->ShowGray();
		firsttwocards = false;
		StartingFUC = pOwnerLord->GetAdjFUC();
		bool mf=true;
      pOwnerLord->FreezeAllButtons();
		pOwnerLord->HitFingers(mf,bjnl2D,StartingFUC,FUCLength);
	 }
	 //LockHit = false;
	// Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;pOwnerLord->StallsInRow = 0;
	// pOwnerLord->ButtonClear(bjidButton15);
	 return;
  }

}
//*******************************************************************
bool TBJSplit7State::HandleRemoveDouble(TResponder &responder)
{
 if(!LockButtons && pOwnerLord->GetCash(pOwnerLord->activeplayer) > 0)
 {
  if(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3->inhand < 3)
  {
	 if (responder.GetResponseEvent() == reLUp)
	 {
		CoachStats(3,bjDouble,firsttwocards);
		Coach(3,bjDouble);
		RemoveDoubleResponder = &responder;
		LockButtons = true;
	 }

	 if (responder.GetResponseEvent() == reLDown)
	 {
//		Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
      Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
      pOwnerLord->StallsInRow = 0;
	 //	pOwnerLord->RemoveDouble->ShowDoubleDown();
		responder.SetPriority();
	 }

	 if (responder.GetResponseEvent() == reChar)
	 {
//		Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
      Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
      pOwnerLord->StallsInRow = 0;
	  //	pOwnerLord->RemoveDouble->ShowDoubleDown();
		RemoveDoubleResponder = &responder;
	 }
  }
 }
 return true;
}
//*******************************************************************
bool TBJSplit7State::HandleClearNoInsureStand(TResponder &responder)
{
 if(!LockButtons)
 {
  if (responder.GetResponseEvent() == reLUp)
  {
	 CoachStats(3,bjStand,firsttwocards);
	 Coach(3,bjStand);
	 ClearNoInsureStandResponder = &responder;
	 LockButtons = true;
  }

  if (responder.GetResponseEvent() == reLDown)
  {
//	 Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
    Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	  //	pOwnerLord->ClearNoInsureStand->ShowStandDown();
	  //	pOwnerLord->RemoveDouble->ShowDouble();
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
//	 Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
    Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	  //	pOwnerLord->ClearNoInsureStand->ShowStandDown();
	 //	pOwnerLord->RemoveDouble->ShowDouble();
	 ClearNoInsureStandResponder = &responder;
  }
 }
 return true;
}
//*******************************************************************
bool TBJSplit7State::HandleSameYesInsureHit(TResponder &responder)
{
 if(!LockButtons)
 {
  if (responder.GetResponseEvent() == reLUp)
  {
	 CoachStats(3,bjHit,firsttwocards);
	 Coach(3,bjHit);
	 SameYesInsureHitResponder = &responder;
	 LockButtons = true;
  }

  if (responder.GetResponseEvent() == reLDown)
  {
//	 Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
    Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	// pOwnerLord->SameYesInsureHit->ShowHitDown();
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
//	 Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
    Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	 //pOwnerLord->SameYesInsureHit->ShowHitDown();
	 SameYesInsureHitResponder = &responder;
  }
 }
 return true;
}
//*******************************************************************
void TBJSplit7State::ExecuteFirstTime()
{
  pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand3 = new TBJHand;
  pOwnerLord->BetSpotUse[3] = pOwnerLord->BetSpotUse[4];
  pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->coinsplayedhand3 =
	 pOwnerLord->SplitMoney(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->coinsplayedhand4);
  pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3->cards[0] =
											  pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->cards[1];
  pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3->inhand++;
  pOwnerLord->BetSpot[3]->ShowFace(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3);
  pOwnerLord->BetSpot[3]->SetNum(pOwnerLord->GetBJPlayer(pOwnerLord->activeplayer)->coinsplayedhand3);
  /*********/
  pOwnerLord->Button0->ShowVoidUp();
  if(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3->cards[0].name == AceHi)
  {
	 splitacesflag = true;
  }
  int session=0;
  session = pOwnerLord->GetCasPD(pOwnerLord->BetSpotUse[3])->BJData.CurrentSession;
  TCBJSession &cs = pOwnerLord->GetCasPD(pOwnerLord->BetSpotUse[3])->BJData.Sessions[session];

  cs.HandsPlayed++;
  cs.Splits++;
  cs.TotalBetsCash += pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->coinsplayedhand3;
  ExecuteWaiting = true;
  ExecuteStatus    = ess_StartSubState1;
  if(pOwnerLord->GetCash(pOwnerLord->activeplayer) > 0)
  {
	 pOwnerLord->Button14->ShowVoidUp();
  }
  else
  {
	 pOwnerLord->Button13->ShowGray();
	 pOwnerLord->Button14->ShowGray();
  }
  if(pOwnerLord->GetCash(pOwnerLord->activeplayer) <
		 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->coinsplayedhand3)
  {
	 pOwnerLord->Button13->ShowGray();
  }
  pOwnerLord->Button16->ShowVoidUp();
  pOwnerLord->Button15->ShowVoidUp();
  pOwnerLord->Button13->ShowGray();
  pOwnerLord->pDeck->Busted(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3);
  pOwnerLord->MessageDisplay->ShowBJMessage(pOwnerLord->PlayerTotal());
  PlayerTotalMessage(3);
  FinishHit    = false;
  FinishStand  = false;
  FinishDouble = false;
  WaitOnHitCom    = false;
  WaitOnStandCom  = false;
  WaitOnDoubleCom = false;
  Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
  pOwnerLord->StallsInRow = 0;
  pOwnerLord->UnFreezeAllButtons();
}
//*******************************************************************
void TBJSplit7State::CreateSubState1()
{
  pOwnerLord->FreezeAllButtons();
  PActiveSubState = new TBJDealState(pOwnerLord,4);
}
//*******************************************************************
void TBJSplit7State::EndSubState1()
{
  TState::EndSubState1();
  if(splitacesflag)
  {
	 ExecuteStatus  = ess_Done;
	 ExecuteWaiting = false;
	 splitacesflag  = false;
  }
  else if(pOwnerLord->/*((TBJDeck *)*/pDeck->
	  Busted(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3) == 1)
  {
	 pOwnerLord->FreezeAllButtons();
	 ExecuteStatus = ess_StartSubState2;
  }
  else if(doubleflag == true)
  {
	 doubleflag = false;
	 ExecuteStatus = ess_Done;
	 ExecuteWaiting = false;
  }
  ExecuteWaiting = true;    //What the hell is this doing here...
  PlayerTotalMessage(3);
  if(ExecuteStatus != ess_StartSubState2 && ExecuteStatus != ess_Done)
  {
    StartingFUC = pOwnerLord->GetAdjFUC();
	 pOwnerLord->AnnouncePlayer2Total(StartingFUC,FUCLength);
	 WaitOnSkit    = true;
	 pOwnerLord->FreezeAllButtons();
	 LockHit = true;
	 HitTotal = true;
  }

}
//*******************************************************************
void TBJSplit7State::CreateSubState2()
{
  PActiveSubState = new TBJBustState(pOwnerLord,4);
}
//*******************************************************************
bool TBJSplit7State::HandleMenuEsc(TResponder &responder)
{
	if (responder.GetResponseEvent() == reLUp)
  {
	 MenuEscResponder = &responder;
  }

  if (responder.GetResponseEvent() == reLDown)
  {
//	 Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
    Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	 //	pOwnerLord->MenuEscButton->Depress();
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
//	 Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
    Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	  //	pOwnerLord->MenuEscButton->Depress();
	 MenuEscResponder = &responder;
  }

  return true;
}
//*******************************************************************
bool TBJSplit7State::HandleAskExpert(TResponder &responder)
{
	if (responder.GetResponseEvent() == reLUp)
  {
	 AskExpertResponder = &responder;
  }

  if (responder.GetResponseEvent() == reLDown)
  {
//	 Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
    Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	 //	pOwnerLord->AskExpertButton->Depress();
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
//	 Stalling = PTimePtr->GetFrameUpdateCount() + TCasinoBJGameLord::STALLDELAY;
	 Stalling = pOwnerLord->GetFUC() + TCasinoBJGameLord::STALLDELAY;
    pOwnerLord->StallsInRow = 0;
	 //	pOwnerLord->AskExpertButton->Depress();
	 AskExpertResponder = &responder;
  }

  return true;
}

//*******************************************************************
