//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  bjwinst.cpp
//    Project Name:  Ogle
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     06/22/95   A. Krist    Original baseline
//  2.0     09/24/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "bjwinst.h"
#include "cbjglord.h"
#include "otimers.h"
#include "bjgobj.h"
#include "casbjmw.h"
#include "hand.h"
#include "bjdealst.h"
#include "bjwst.h"
#include "bjlst.h"
#include "bjpst.h"
#include "bjdeck.h"

class TBJHand;

#include <iostream.h>
//*******************************************************************
TBJWinnerState::TBJWinnerState(TCasinoBJGameLord *pNewBJLord)
:TBJLordState(pNewBJLord)
{
  SetRunOrder(ess_Execute,ess_Execute,ess_Execute,
				  ess_Execute,ess_Execute,ess_Execute,
				  ess_Execute,ess_Execute,ess_Done);
  StartingFUC = 0;
  FUCLength = 0;
  WaitOnSkit = false;
  Start1 = false;
  Start2 = false;
  Start3 = false;
  Start4 = false;
  Start5 = false;
  Start6 = false;
  Start7 = false;
  Start8 = false;

}
//*******************************************************************
TBJWinnerState::~TBJWinnerState()
{
}
//*******************************************************************
void TBJWinnerState::ExecuteFirstTime()
{
  LookToNextWinner(7);
}
//*******************************************************************
void TBJWinnerState::HandlePostUpdate(dword NewFUC)
{
  if(WaitOnSkit)
  {
	 if((StartingFUC != 0) && ((StartingFUC + FUCLength) <= NewFUC))
	 {
		StartingFUC = 0;
		FUCLength   = 0;
		WaitOnSkit  = false;
	 }
	 return;//?
  }
  if(!WaitOnSkit && Start1)
  {
	 Start1  = false;
	 ExecuteWaiting = false;
	 ExecuteStatus = ess_StartSubState1;
  }
  if(!WaitOnSkit && Start2)
  {
	 Start2  = false;
	 ExecuteWaiting = false;
	 ExecuteStatus = ess_StartSubState2;
  }
  if(!WaitOnSkit && Start3)
  {
	 Start3  = false;
	 ExecuteWaiting = false;
	 ExecuteStatus = ess_StartSubState3;
  }
  if(!WaitOnSkit && Start4)
  {
	 Start4  = false;
	 ExecuteWaiting = false;
	 ExecuteStatus = ess_StartSubState4;
  }
  if(!WaitOnSkit && Start5)
  {
	 Start5  = false;
	 ExecuteWaiting = false;
	 ExecuteStatus = ess_StartSubState5;
  }
  if(!WaitOnSkit && Start6)
  {
	 Start6  = false;
	 ExecuteWaiting = false;
	 ExecuteStatus = ess_StartSubState6;
  }
  if(!WaitOnSkit && Start7)
  {
	 Start7  = false;
	 ExecuteWaiting = false;
	 ExecuteStatus = ess_StartSubState7;
  }
  if(!WaitOnSkit && Start8)
  {
	 Start8  = false;
	 ExecuteWaiting = false;
	 ExecuteStatus = ess_StartSubState8;
  }

}
//*******************************************************************
void TBJWinnerState::CreateSubState1()
{
  if(pOwnerLord->BetSpotUse[0] >= 0)
  {
    int16 session = pOwnerLord->GetCasPD(pOwnerLord->BetSpotUse[0])->BJData.CurrentSession;
    TCBJSession &cs = pOwnerLord->GetCasPD(pOwnerLord->BetSpotUse[0])->BJData.Sessions[session];

	 pOwnerLord->SwitchToPlayer(pOwnerLord->BetSpotUse[0]);
	 pOwnerLord->pDeck->Busted(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[0])->pHand0);
	 switch(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[0])->pHand0->highhand)
	 {
		case 21 : cs.Player21++;break;
		case 20 : cs.Player20++;break;
		case 19 : cs.Player19++;break;
		case 18 : cs.Player18++;break;
		case 17 : cs.Player17++;break;
		default : cs.Player16Less++;break;
	 }
	 if(pOwnerLord->pHand->highhand <
		 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[0])->pHand0->highhand ||
		 pOwnerLord->pHand->highhand > 21  ||
		 ((TBJHand *)pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[0])->pHand0)->bj)
	 {
		if(pOwnerLord->pHand->highhand > 21)
		{
		  cs.DealerBusts++;
		}
		PActiveSubState = new TBJWinState(pOwnerLord,0);
	 }
	 else if(pOwnerLord->pHand->highhand >
				pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[0])->pHand0->highhand)
	 {
		PActiveSubState = new TBJLoseState(pOwnerLord,0);
	 }
	 else if(pOwnerLord->pHand->highhand ==
				pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[0])->pHand0->highhand)
	 {
		PActiveSubState = new TBJPushState(pOwnerLord,0);
	 }

  }
}
//*******************************************************************
void TBJWinnerState::CreateSubState2()
{
  if(pOwnerLord->BetSpotUse[1] >= 0)
  {
	 int16 session = pOwnerLord->GetCasPD(pOwnerLord->BetSpotUse[1])->BJData.CurrentSession;
    TCBJSession &cs = pOwnerLord->GetCasPD(pOwnerLord->BetSpotUse[1])->BJData.Sessions[session];

	 pOwnerLord->SwitchToPlayer(pOwnerLord->BetSpotUse[1]);
	 pOwnerLord->pDeck->Busted(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand1);

	 switch(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand1->highhand)
	 {
		case 21 : cs.Player21++;break;
		case 20 : cs.Player20++;break;
		case 19 : cs.Player19++;break;
		case 18 : cs.Player18++;break;
		case 17 : cs.Player17++;break;
		default : cs.Player16Less++;break;
	 }
	 if(pOwnerLord->pHand->highhand <
		 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand1->highhand ||
		 pOwnerLord->pHand->highhand > 21 ||
		 ((TBJHand *)pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand1)->bj)
	 {
		if(pOwnerLord->pHand->highhand > 21)
		{
		  cs.DealerBusts++;
		}
		PActiveSubState = new TBJWinState(pOwnerLord,1);
	 }
	 else if(pOwnerLord->pHand->highhand >
				pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand1->highhand)
	 {
		PActiveSubState = new TBJLoseState(pOwnerLord,1);
	 }
	 else if(pOwnerLord->pHand->highhand ==
				pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand1->highhand)
	 {
		PActiveSubState = new TBJPushState(pOwnerLord,1);
	 }

  }
}
//*******************************************************************
void TBJWinnerState::EndSubState1()
{
  TState::EndSubState1();
  LookToNextWinner(0);
  ExecuteWaiting = true;
}
//*******************************************************************
void TBJWinnerState::EndSubState2()
{
  TState::EndSubState2();
  LookToNextWinner(1);
  ExecuteWaiting = true;
}
//*******************************************************************
void TBJWinnerState::EndSubState3()
{
  TState::EndSubState3();
  LookToNextWinner(2);
  ExecuteWaiting = true;
}
//*******************************************************************
void TBJWinnerState::EndSubState4()
{
  TState::EndSubState4();
  LookToNextWinner(3);
  ExecuteWaiting = true;
}
//*******************************************************************
void TBJWinnerState::EndSubState5()
{
  TState::EndSubState5();
  LookToNextWinner(4);
  ExecuteWaiting = true;
}
//*******************************************************************
void TBJWinnerState::EndSubState6()
{
  TState::EndSubState6();
  LookToNextWinner(5);
  ExecuteWaiting = true;
}
//*******************************************************************
void TBJWinnerState::EndSubState7()
{
  TState::EndSubState7();
  LookToNextWinner(6);
  ExecuteWaiting = true;
}
//*******************************************************************
void TBJWinnerState::CreateSubState3()
{
  if(pOwnerLord->BetSpotUse[2] >= 0)
  {
	 int16 session = pOwnerLord->GetCasPD(pOwnerLord->BetSpotUse[2])->BJData.CurrentSession;
    TCBJSession &cs = pOwnerLord->GetCasPD(pOwnerLord->BetSpotUse[2])->BJData.Sessions[session];

	 pOwnerLord->SwitchToPlayer(pOwnerLord->BetSpotUse[2]);
	 pOwnerLord->pDeck->Busted(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->pHand2);

	 switch(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->pHand2->highhand)
	 {
		case 21 : cs.Player21++;break;
		case 20 : cs.Player20++;break;
		case 19 : cs.Player19++;break;
		case 18 : cs.Player18++;break;
		case 17 : cs.Player17++;break;
		default : cs.Player16Less++;break;
	 }
	 if(pOwnerLord->pHand->highhand <
		 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->pHand2->highhand ||
		 pOwnerLord->pHand->highhand > 21 ||
		 ((TBJHand *)pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->pHand2)->bj)
	 {
      if(pOwnerLord->pHand->highhand > 21)
		{
		  cs.DealerBusts++;
		}
		if(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->hand2owner == 1)
		{
		  PActiveSubState = new TBJWinState(pOwnerLord,2);
		}
		else if(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->hand2owner == 2)
		{
		  PActiveSubState = new TBJWinState(pOwnerLord,3);
		}
	 }
	 else if(pOwnerLord->pHand->highhand >
				pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->pHand2->highhand)
	 {
		if(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->hand2owner == 1)
		{
		  PActiveSubState = new TBJLoseState(pOwnerLord,2);
		}
		else if(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->hand2owner == 2)
		{
		  PActiveSubState = new TBJLoseState(pOwnerLord,3);
		}
	 }
	 else if(pOwnerLord->pHand->highhand ==
				pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->pHand2->highhand)
	 {
		if(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->hand2owner == 1)
		{
		  PActiveSubState = new TBJPushState(pOwnerLord,2);
		}
		else if(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->hand2owner == 2)
		{
		  PActiveSubState = new TBJPushState(pOwnerLord,3);
		}
	 }

  }
}
//*******************************************************************
void TBJWinnerState::CreateSubState4()
{
  if(pOwnerLord->BetSpotUse[3] >= 0)
  {
	 int16 session = pOwnerLord->GetCasPD(pOwnerLord->BetSpotUse[3])->BJData.CurrentSession;
    TCBJSession &cs = pOwnerLord->GetCasPD(pOwnerLord->BetSpotUse[3])->BJData.Sessions[session];

	 pOwnerLord->SwitchToPlayer(pOwnerLord->BetSpotUse[3]);
	 pOwnerLord->pDeck->Busted(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3);

	 switch(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3->highhand)
	 {
		case 21 : cs.Player21++;break;
		case 20 : cs.Player20++;break;
		case 19 : cs.Player19++;break;
		case 18 : cs.Player18++;break;
		case 17 : cs.Player17++;break;
		default : cs.Player16Less++;break;
	 }
	 if(pOwnerLord->pHand->highhand <
		 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3->highhand ||
		 pOwnerLord->pHand->highhand > 21 ||
		 ((TBJHand *)pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3)->bj)
	 {
		  if(pOwnerLord->pHand->highhand > 21)
		  {
			 cs.DealerBusts++;
		  }
		  PActiveSubState = new TBJWinState(pOwnerLord,4);
	 }
	 else if(pOwnerLord->pHand->highhand >
				pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3->highhand)
	 {
		PActiveSubState = new TBJLoseState(pOwnerLord,4);
	 }
	 else if(pOwnerLord->pHand->highhand ==
				pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3->highhand)
	 {
		PActiveSubState = new TBJPushState(pOwnerLord,4);
	 }

  }
}
//*******************************************************************
void TBJWinnerState::CreateSubState5()
{
  if(pOwnerLord->BetSpotUse[4] >= 0)
  {
	 int16 session = pOwnerLord->GetCasPD(pOwnerLord->BetSpotUse[4])->BJData.CurrentSession;
    TCBJSession &cs = pOwnerLord->GetCasPD(pOwnerLord->BetSpotUse[4])->BJData.Sessions[session];

	 pOwnerLord->SwitchToPlayer(pOwnerLord->BetSpotUse[4]);
	 pOwnerLord->pDeck->Busted(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4);

	 switch(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->highhand)
	 {
		case 21 : cs.Player21++;break;
		case 20 : cs.Player20++;break;
		case 19 : cs.Player19++;break;
		case 18 : cs.Player18++;break;
		case 17 : cs.Player17++;break;
		default : cs.Player16Less++;break;
	 }
	 if(pOwnerLord->pHand->highhand <
		 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->highhand ||
		 pOwnerLord->pHand->highhand > 21 ||
		 ((TBJHand *)pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4)->bj)
	 {
      if(pOwnerLord->pHand->highhand > 21)
		 {
		  cs.DealerBusts++;
		}
		if(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->hand4owner == 2)
		{
		  PActiveSubState = new TBJWinState(pOwnerLord,5);
		}
		else if(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->hand4owner == 3)
		{
		  PActiveSubState = new TBJWinState(pOwnerLord,6);
		}
	 }
	 else if(pOwnerLord->pHand->highhand >
				pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->highhand)
	 {
		if(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->hand4owner == 2)
		{
		  PActiveSubState = new TBJLoseState(pOwnerLord,5);
		}
		else if(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->hand4owner == 3)
		{
		  PActiveSubState = new TBJLoseState(pOwnerLord,6);
		}
	 }
	 else if(pOwnerLord->pHand->highhand ==
				pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->highhand)
	 {
		if(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->hand4owner == 2)
		{
		  PActiveSubState = new TBJPushState(pOwnerLord,5);
		}
		else if(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->hand4owner == 3)
		{
		  PActiveSubState = new TBJPushState(pOwnerLord,6);
		}
	 }

  }
}
//*******************************************************************
void TBJWinnerState::CreateSubState6()
{
  if(pOwnerLord->BetSpotUse[5] >= 0)
  {
	 int16 session = pOwnerLord->GetCasPD(pOwnerLord->BetSpotUse[5])->BJData.CurrentSession;
    TCBJSession &cs = pOwnerLord->GetCasPD(pOwnerLord->BetSpotUse[5])->BJData.Sessions[session];

	 pOwnerLord->SwitchToPlayer(pOwnerLord->BetSpotUse[5]);
	 pOwnerLord->pDeck->Busted(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->pHand5);

	 switch(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->pHand5->highhand)
	 {
		case 21 : cs.Player21++;break;
		case 20 : cs.Player20++;break;
		case 19 : cs.Player19++;break;
		case 18 : cs.Player18++;break;
		case 17 : cs.Player17++;break;
		default : cs.Player16Less++;break;
	 }
	 if(pOwnerLord->pHand->highhand <
		 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->pHand5->highhand ||
		 pOwnerLord->pHand->highhand > 21 ||
		 ((TBJHand *)pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->pHand5)->bj)
	 {
		if(pOwnerLord->pHand->highhand > 21)
		{
		  cs.DealerBusts++;
		}
		PActiveSubState = new TBJWinState(pOwnerLord,7);
	 }
	 else if(pOwnerLord->pHand->highhand >
				pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->pHand5->highhand)
	 {
		PActiveSubState = new TBJLoseState(pOwnerLord,7);
	 }
	 else if(pOwnerLord->pHand->highhand ==
				pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->pHand5->highhand)
	 {
		PActiveSubState = new TBJPushState(pOwnerLord,7);
	 }

  }
}
//*******************************************************************
void TBJWinnerState::CreateSubState7()
{
  if(pOwnerLord->BetSpotUse[6] >= 0)
  {
	 int16 session = pOwnerLord->GetCasPD(pOwnerLord->BetSpotUse[6])->BJData.CurrentSession;
    TCBJSession &cs = pOwnerLord->GetCasPD(pOwnerLord->BetSpotUse[6])->BJData.Sessions[session];

	 pOwnerLord->SwitchToPlayer(pOwnerLord->BetSpotUse[6]);
	 pOwnerLord->pDeck->Busted(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[6])->pHand6);

	 switch(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[6])->pHand6->highhand)
	 {
		case 21 : cs.Player21++;break;
		case 20 : cs.Player20++;break;
		case 19 : cs.Player19++;break;
		case 18 : cs.Player18++;break;
		case 17 : cs.Player17++;break;
		default : cs.Player16Less++;break;
	 }
	 if(pOwnerLord->pHand->highhand <
		 pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[6])->pHand6->highhand ||
		 pOwnerLord->pHand->highhand > 21 ||
		 ((TBJHand *)pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[6])->pHand6)->bj)
	 {
		if(pOwnerLord->pHand->highhand > 21)
		{
		  cs.DealerBusts++;
		}
		PActiveSubState = new TBJWinState(pOwnerLord,8);
	 }
	 else if(pOwnerLord->pHand->highhand >
				pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[6])->pHand6->highhand)
	 {
		PActiveSubState = new TBJLoseState(pOwnerLord,8);
	 }
	 else if(pOwnerLord->pHand->highhand ==
				pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[6])->pHand6->highhand)
	 {
		PActiveSubState = new TBJPushState(pOwnerLord,8);
	 }

  }
}
//*******************************************************************
void TBJWinnerState::CreateSubState8()
{
}
//*******************************************************************
void TBJWinnerState::CreateSubState9()
{
}
//*******************************************************************
TBJLookFromTo TBJWinnerState::NextWinner(int16 from)
{
  switch(from) {
  case 0 : Start8=true;pOwnerLord->LookingAt = bjnl0U;return bjlf1To0;
  case 1 : if (pOwnerLord->BetSpotUse[0] >= 0)
           {
             pOwnerLord->LookingAt = bjnl1A;
             Start1=true;
             return bjlf0To0;
           }
			  Start8=true;
			  pOwnerLord->LookingAt = bjnl0U;
			  return bjlf1To0;
  case 2 : if (pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->hand2owner == 2)
			  {
				 if(pOwnerLord->BetSpotUse[1] >= 0)
             {
               pOwnerLord->LookingAt = bjnl1B;
               Start2=true;
               return bjlf2To1;
             }
				 if (pOwnerLord->BetSpotUse[0] >= 0)
             {
               pOwnerLord->LookingAt = bjnl1A;
               Start1=true;
               return bjlf2To1;
             }
				 Start8=true;
				 pOwnerLord->LookingAt = bjnl0U;
				 return bjlf2To0;
			  }
			  else
			  {
				 if (pOwnerLord->BetSpotUse[1] >= 0)
             {
               pOwnerLord->LookingAt = bjnl1B;
               Start2=true;
               return bjlf0To0;
             }
				 if (pOwnerLord->BetSpotUse[0] >= 0)
             {
               pOwnerLord->LookingAt = bjnl1A;
               Start1=true;
               return bjlf0To0;
             }
				 Start8=true;
				 pOwnerLord->LookingAt = bjnl0U;
				 return bjlf1To0;
			  }
  case 3 : if(pOwnerLord->BetSpotUse[2] >= 0)
			  {
				 Start3=true;
				 if(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->hand2owner == 2)
				 {
					pOwnerLord->LookingAt = bjnl2C;
					return bjlf0To0;
				 }
				 else
				 {
					pOwnerLord->LookingAt = bjnl1C;
					return bjlf2To1;
				 }
			  }
			  if (pOwnerLord->BetSpotUse[1] >= 0)
           {
             pOwnerLord->LookingAt = bjnl1B;
             Start2=true;
             return bjlf0To1;
           }
			  if (pOwnerLord->BetSpotUse[0] >= 0)
           {
             pOwnerLord->LookingAt = bjnl1A;
             Start1=true;
             return bjlf0To1;
           }
			  Start8=true;
			  pOwnerLord->LookingAt = bjnl0U;
			  return bjlf2To0;
  case 4 : if (pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->hand4owner == 3)
			  {
				 if (pOwnerLord->BetSpotUse[3] >= 0)
             {
               pOwnerLord->LookingAt = bjnl2D;
               Start4=true;
               return bjlf3To2;
             }
				 if (pOwnerLord->BetSpotUse[2] >= 0)
				 {
					Start3=true;
					if (pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->hand2owner == 2)
					{
					  pOwnerLord->LookingAt = bjnl2C;
					  return bjlf3To2;
					}
					else
					{
					  pOwnerLord->LookingAt = bjnl1C;
					  return bjlf3To1;
					}
				 }
				 if(pOwnerLord->BetSpotUse[1] >= 0)
             {
               pOwnerLord->LookingAt = bjnl1B;
               Start2=true;
               return bjlf3To1;
             }
				 if (pOwnerLord->BetSpotUse[0] >= 0)
             {
               pOwnerLord->LookingAt = bjnl1A;
               Start1=true;
               return bjlf3To1;
             }
			  }
			  else
			  {
				 if (pOwnerLord->BetSpotUse[3] >= 0)
             {
               pOwnerLord->LookingAt = bjnl2D;
               Start4=true;
               return bjlf0To0;
             }
				 if (pOwnerLord->BetSpotUse[2] >= 0)
				 {
					Start3=true;
					if(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->hand2owner == 2)
					{
					  pOwnerLord->LookingAt = bjnl2C;
					  return bjlf0To0;
					}
					else
					{
					  pOwnerLord->LookingAt = bjnl1C;
					  return bjlf2To1;
					}
				 }
				 if (pOwnerLord->BetSpotUse[1] >= 0)
             {
               pOwnerLord->LookingAt = bjnl1B;
               Start2=true;
               return bjlf2To1;
             }
				 if (pOwnerLord->BetSpotUse[0] >= 0)
             {
               pOwnerLord->LookingAt = bjnl1A;
               Start1=true;
               return bjlf2To1;
             }
			  }
			  Start8=true;
			  pOwnerLord->LookingAt = bjnl0U;
			  return bjlf3To0;

case 5 : if(pOwnerLord->BetSpotUse[4] >= 0)
			  {
				 Start5=true;
				 if(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->hand4owner == 2)
				 {
					pOwnerLord->LookingAt = bjnl2E;
					return bjlf3To2;
				 }
				 else
				 {
					pOwnerLord->LookingAt = bjnl3E;
					return bjlf0To0;
				 }
			  }
			  if(pOwnerLord->BetSpotUse[3] >= 0)
           {
             pOwnerLord->LookingAt = bjnl2D;
             Start4=true;
             return bjlf3To2;
           }
			  if(pOwnerLord->BetSpotUse[2] >= 0)
			  {
				 Start3=true;
				 if(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->hand2owner == 2)
				 {
					pOwnerLord->LookingAt = bjnl2C;
					return bjlf3To2;
				 }
				 else
				 {
					pOwnerLord->LookingAt = bjnl1C;
					return bjlf3To1;
				 }

			  }
			  if(pOwnerLord->BetSpotUse[1] >= 0)
           {
             pOwnerLord->LookingAt = bjnl1B;
             Start2=true;
             return bjlf3To1;
           }
			  if(pOwnerLord->BetSpotUse[0] >= 0)
           {
             pOwnerLord->LookingAt = bjnl1A;
             Start1=true;
             return bjlf3To1;
           }
			  Start8=true;
			  pOwnerLord->LookingAt = bjnl0U;
			  return bjlf3To0;
case 6 :   if(pOwnerLord->BetSpotUse[5] >= 0)
           {
             pOwnerLord->LookingAt = bjnl3F;
             Start6=true;
             return bjlf0To0;
           }
			  if(pOwnerLord->BetSpotUse[4] >= 0)
			  {
				 Start5=true;
				 if(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->hand4owner == 2)
				 {
					pOwnerLord->LookingAt = bjnl2E;
					return bjlf3To2;
				 }
				 else
				 {
					pOwnerLord->LookingAt = bjnl3E;
					return bjlf0To0;
				 }
			  }
			  if (pOwnerLord->BetSpotUse[3] >= 0)
           {
             pOwnerLord->LookingAt = bjnl2D;
             Start4=true;
             return bjlf3To2;
           }
			  if (pOwnerLord->BetSpotUse[2] >= 0)
			  {
				 Start3=true;
				 if(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->hand2owner == 2)
				 {
					pOwnerLord->LookingAt = bjnl2C;
					return bjlf3To2;
				 }
				 else
				 {
					pOwnerLord->LookingAt = bjnl1C;
					return bjlf3To1;
				 }
			  }
			  if (pOwnerLord->BetSpotUse[1] >= 0)
           {
             pOwnerLord->LookingAt = bjnl1B;
             Start2=true;
             return bjlf3To1;
           }
			  if (pOwnerLord->BetSpotUse[0] >= 0)
           {
             pOwnerLord->LookingAt = bjnl1A;
             Start1=true;
             return bjlf3To1;
           }
			  Start8=true;
			  pOwnerLord->LookingAt = bjnl0U;
			  return bjlf3To0;
  case 7 : if (pOwnerLord->BetSpotUse[6] >= 0)
           {
             pOwnerLord->LookingAt = bjnl3G;
             Start7=true;
             return bjlf0To3;
           }
			  if (pOwnerLord->BetSpotUse[5] >= 0)
           {
             pOwnerLord->LookingAt = bjnl3F;
             Start6=true;
             return bjlf0To3;
           }
			  if (pOwnerLord->BetSpotUse[4] >= 0)
			  {
				 Start5=true;
				 if(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->hand4owner == 2)
				 {
					pOwnerLord->LookingAt = bjnl2E;
					return bjlf0To2;
				 }
				 else
				 {
					pOwnerLord->LookingAt = bjnl3E;
					return bjlf0To3;
				 }
			  }
			  if (pOwnerLord->BetSpotUse[3] >= 0)
           {
             pOwnerLord->LookingAt = bjnl2D;
             Start4=true;
             return bjlf0To2;
           }
			  if (pOwnerLord->BetSpotUse[2] >= 0)
			  {
				 Start3=true;
				 if(pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->hand2owner == 1)
				 {
					pOwnerLord->LookingAt = bjnl1C;
					return bjlf0To1;
				 }
				 else
				 {
					pOwnerLord->LookingAt = bjnl2C;
					return bjlf0To2;
				 }
			  }
			  if (pOwnerLord->BetSpotUse[1] >= 0)
           {
             pOwnerLord->LookingAt = bjnl1B;
             Start2=true;
             return bjlf0To1;
           }
			  if (pOwnerLord->BetSpotUse[0] >= 0)
           {
             pOwnerLord->LookingAt = bjnl1A;
             Start1=true;
             return bjlf0To1;
           }
			  Start8=true;
			  pOwnerLord->LookingAt = bjnl0U;
			  return bjlf0To0;
  }
  pOwnerLord->LookingAt = bjnl0U;
  return bjlf0To0;
}
//*******************************************************************
void TBJWinnerState::LookToNextWinner(int16 from)
{
//  StartingFUC = PTimePtr->GetFrameUpdateCount() + 1;
  StartingFUC = pOwnerLord->GetAdjFUC();
  pOwnerLord->LookFromTo(NextWinner(from),StartingFUC,FUCLength);
  pOwnerLord->SetBodyIdle();
  ExecuteWaiting = true;
  ExecuteStatus = ess_Execute;
  WaitOnSkit        = true;
}
//*******************************************************************
