//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  bjwst.cpp    // win state
//    Project Name:  Ogle
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     10/20/95   A. Krist    Original baseline
//  2.0     09/23/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "bjwst.h"
#include "cbjglord.h"
#include "cbjplay.h"
#include "otimers.h"
#include "bjdeck.h"
#include <iostream.h>
//*******************************************************************
TBJWinState::TBJWinState(TCasinoBJGameLord *pNewBJLord,int16 WinTo)
:TBJLordState(pNewBJLord)
{
  winto = WinTo;
  Tip = 0;
  DoTip = false;
  FinishTip = false;
  discards = 0;
  StartingFUC = 0;
  FUCLength = 0;
  SetRunOrder(ess_StartSubState1,ess_StartSubState2,ess_StartSubState3,ess_Done);
}
//*******************************************************************
TBJWinState::~TBJWinState()
{
}
//*******************************************************************
void TBJWinState::ExecuteFirstTime()
{
  switch(winto) {
	 case 0  : discards = pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[0])->pHand0->inhand;break;
	 case 1  : discards = pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[1])->pHand1->inhand;break;
	 case 2  : discards = pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->pHand2->inhand;break;
	 case 3  : discards = pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[2])->pHand2->inhand;break;
	 case 4  : discards = pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[3])->pHand3->inhand;break;
	 case 5  : discards = pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->inhand;break;
	 case 6  : discards = pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[4])->pHand4->inhand;break;
	 case 7  : discards = pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[5])->pHand5->inhand;break;
	 case 8  : discards = pOwnerLord->GetBJPlayer(pOwnerLord->BetSpotUse[6])->pHand6->inhand;break;
  }
  ExecuteWaiting = true;
  ExecuteStatus  = ess_Execute;
  StartingFUC = pOwnerLord->GetAdjFUC();
  switch(winto) {
    case 0  : pOwnerLord->Winner1(StartingFUC,FUCLength);break;
    case 1  : pOwnerLord->Winner1(StartingFUC,FUCLength);break;
    case 2  : pOwnerLord->Winner1(StartingFUC,FUCLength);break;
    case 3  : pOwnerLord->Winner2(StartingFUC,FUCLength);break;
    case 4  : pOwnerLord->Winner2(StartingFUC,FUCLength);break;
    case 5  : pOwnerLord->Winner2(StartingFUC,FUCLength);break;
    case 6  : pOwnerLord->Winner3(StartingFUC,FUCLength);break;
    case 7  : pOwnerLord->Winner3(StartingFUC,FUCLength);break;
    case 8  : pOwnerLord->Winner3(StartingFUC,FUCLength);break;
    case 9  : pOwnerLord->AnnounceDealerTotal(StartingFUC,FUCLength);break;
    case 10 : pOwnerLord->AnnounceDealerTotal(StartingFUC,FUCLength);break;
  }
}
//*******************************************************************
void TBJWinState::HandlePostUpdate(dword NewFUC)
{
  if((StartingFUC + FUCLength - 8) == NewFUC && !DoTip && !FinishTip)
  {
	 Tip = pOwnerLord->Winner(winto);
  }
  if((StartingFUC + FUCLength - 8) == NewFUC && !DoTip && !FinishTip)
  {
	 switch(winto) {
	   case 0  : pOwnerLord->BetSpot[0]->NoShowCards();break;
	   case 1  : pOwnerLord->BetSpot[1]->NoShowCards();break;
	   case 2  : pOwnerLord->BetSpot[2]->NoShowCards();break;
	   case 3  : pOwnerLord->BetSpot[2]->NoShowCards();break;
	   case 4  : pOwnerLord->BetSpot[3]->NoShowCards();break;
	   case 5  : pOwnerLord->BetSpot[4]->NoShowCards();break;
	   case 6  : pOwnerLord->BetSpot[4]->NoShowCards();break;
	   case 7  : pOwnerLord->BetSpot[5]->NoShowCards();break;
	   case 8  : pOwnerLord->BetSpot[6]->NoShowCards();break;
	 }

  }
  if ((StartingFUC + FUCLength-2) <= NewFUC && !DoTip && !FinishTip)
  {
	 pOwnerLord->Rack->ShowBJRack(discards);
  }
  if ((StartingFUC + FUCLength) <= NewFUC && !DoTip && !FinishTip)
  {
	 FUCLength = 0;
	 if(Tip != -1 && Tip%2)
	 {
		DoTip = true;
	 }
	 else
	 {
      ExecuteWaiting = false;
		ExecuteStatus  = ess_Done;
	 }
	 switch(winto)
	 {
		case 0  : pOwnerLord->BetSpot[0]->NoShow();break;
		case 1  : pOwnerLord->BetSpot[1]->NoShow();break;
		case 2  : pOwnerLord->BetSpot[2]->NoShow();break;
		case 3  : pOwnerLord->BetSpot[2]->NoShow();break;
		case 4  : pOwnerLord->BetSpot[3]->NoShow();break;
		case 5  : pOwnerLord->BetSpot[4]->NoShow();break;
		case 6  : pOwnerLord->BetSpot[4]->NoShow();break;
		case 7  : pOwnerLord->BetSpot[5]->NoShow();break;
		case 8  : pOwnerLord->BetSpot[6]->NoShow();break;
	 }
	 pOwnerLord->MessageDisplay->NoShowDisplay();
  }
  if (DoTip)
  {
	 FinishTip = true;
	 DoTip = false;
	 StartingFUC = pOwnerLord->GetAdjFUC();
	 switch(winto)
	 {
		case 0  : pOwnerLord->AcceptTipPlayer1(StartingFUC,FUCLength);break;
		case 1  : pOwnerLord->AcceptTipPlayer1(StartingFUC,FUCLength);break;
		case 2  : pOwnerLord->AcceptTipPlayer1(StartingFUC,FUCLength);break;
		case 3  : pOwnerLord->AcceptTipPlayer2(StartingFUC,FUCLength);break;
		case 4  : pOwnerLord->AcceptTipPlayer2(StartingFUC,FUCLength);break;
		case 5  : pOwnerLord->AcceptTipPlayer2(StartingFUC,FUCLength);break;
		case 6  : pOwnerLord->AcceptTipPlayer3(StartingFUC,FUCLength);break;
		case 7  : pOwnerLord->AcceptTipPlayer3(StartingFUC,FUCLength);break;
		case 8  : pOwnerLord->AcceptTipPlayer3(StartingFUC,FUCLength);break;
	 }
  }
  if(FinishTip)
  {
	 if ((StartingFUC + FUCLength) <= NewFUC)
	 {
		//???FinishTip = false;
		ExecuteWaiting = false;
		ExecuteStatus  = ess_Done;
	 }
  }
}
//*******************************************************************
void TBJWinState::CreateSubState1()
{
}
//*******************************************************************
void TBJWinState::CreateSubState2()
{
}
//*******************************************************************
void TBJWinState::CreateSubState3()
{
}
//*******************************************************************