//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  cbjbssp.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0    12/23/95    M.Perry    moved inline functions into .cpp file.
//  2.0    09/23/97    M.Perry    32-bit conversion.
//********************************************************************
#include "cbjbssp.h"
#include "hand.h"
#include "oanm.h"
//*******************************************************************
void TBJBetSpot::SetupAnms()
{
  for (int16 i=0;i<6;i++)
  {
    PCards[i] = GetAnm(i);
	 if (PCards[i] == NULL) {AnmError("BJBetSpot","Cards",i);}
  }
  for (int16 i = 6;i<12;i++)
  {
	 PChips[i-6] = GetAnm(i);
	 if (PChips[i-6] == NULL) {AnmError("BJBetSpot","Chips",i);}
	 PChips1[i-6] = GetAnm(int16(i+6));
	 if (PChips1[i-6] == NULL) {AnmError("BJBetSpot","Chips1",int16(i+6));}
	 PChips2[i-6] = GetAnm(int16(i+12));
	 if (PChips2[i-6] == NULL) {AnmError("BJBetSpot","Chips2",int16(i+12));}
	 PChips3[i-6] = GetAnm(int16(i+18));
	 if (PChips3[i-6] == NULL) {AnmError("BJBetSpot","Chips3",int16(i+18));}
	 PChips4[i-6] = GetAnm(int16(i+24));
	 if (PChips4[i-6] == NULL) {AnmError("BJBetSpot","Chips4",int16(i+24));}
	 PChips5[i-6] = GetAnm(int16(i+30));
	 if (PChips5[i-6] == NULL) {AnmError("BJBetSpot","Chips5",int16(i+30));}
  }
  int16 i = 12;
  PBJ50Cent = GetAnm(int16(i+30)); // 'i' is one more
  PBJ50Cent->CAD.ClearAutoStart();
  PBJ50Cent->CAD.ClearAutoStop();
  PBJ50Cent->CAD.SetDirStill();

  PInsure50Cent = GetAnm(int16(i+31));
  PInsure50Cent->CAD.ClearAutoStart();
  PInsure50Cent->CAD.ClearAutoStop();
  PInsure50Cent->CAD.SetDirStill();

  for (int16 j=0;j<6;j++)
  {
	 PChips[j]->CAD.ClearAutoStart();
	 PChips[j]->CAD.ClearAutoStop();
	 PChips[j]->CAD.SetDirStill();

	 PChips1[j]->CAD.ClearAutoStart();
	 PChips1[j]->CAD.ClearAutoStop();
	 PChips1[j]->CAD.SetDirStill();

	 PChips2[j]->CAD.ClearAutoStart();
	 PChips2[j]->CAD.ClearAutoStop();
	 PChips2[j]->CAD.SetDirStill();

	 PChips3[j]->CAD.ClearAutoStart();
	 PChips3[j]->CAD.ClearAutoStop();
	 PChips3[j]->CAD.SetDirStill();

	 PChips4[j]->CAD.ClearAutoStart();
	 PChips4[j]->CAD.ClearAutoStop();
	 PChips4[j]->CAD.SetDirStill();

	 PChips5[j]->CAD.ClearAutoStart();
	 PChips5[j]->CAD.ClearAutoStop();
	 PChips5[j]->CAD.SetDirStill();

  }
  for (int16 j=0;j<6;j++)
  {
	 PCards[j]->CAD.ClearAutoStart();
	 PCards[j]->CAD.ClearAutoStop();
	 PCards[j]->CAD.SetDirStill();
  }
}
//*******************************************************************
TBJBetSpot::TBJBetSpot(TOgleModeWindow *pmw,const TFileMode &NewFileMode)
:TSprite(pmw,NewFileMode)
{
  SetToManual();
  NotFound = false;
  betamount = 0;
  NoShow();
  SetupAnms();
}
//********************************************************************
TBJBetSpot::TBJBetSpot(TOgleModeWindow *pmw,const TFileMode &fm,void *psource)
:TSprite(pmw,fm,psource)
{
  SetToManual();
  NotFound = false;
  betamount = 0;
  NoShow();
  SetupAnms();
}
 //*******************************************************************
TBJBetSpot::~TBJBetSpot()
{
}
//*******************************************************************
void TBJBetSpot::ShowBJChips()
{
  if (NotFound) {return;}
  int16  yoffset,zoffset;
  int32 num;
  num = (int32)betamount;
  num = num%100001l;
  yoffset   = PChips2[0]->SAD.GetY();
  zoffset   = PChips2[0]->SAD.GetZ();

  int32 tenthous = num / 10000;
  int32 tenthousvalue = tenthous * 10000;
  int32 thous = (num - tenthousvalue) / 1000;
  int32 thousvalue = thous * 1000;
  int32 huns = (num - tenthousvalue - thousvalue) / 100;
  int32 hunsvalue = huns * 100;
  int32 twfive = (num - tenthousvalue - thousvalue - hunsvalue) / 25;
  int32 twfivevalue = twfive * 25;
  int32 fives = (num - tenthousvalue - thousvalue - hunsvalue - twfivevalue) / 5;
  int32 fivesvalue = fives * 5;
  int32 ones = (num - tenthousvalue - thousvalue - hunsvalue - twfivevalue - fivesvalue);


  if (tenthous)
  {
	 PChips2[5]->CAD.SetY(yoffset);
	 PChips2[5]->CAD.SetZ(zoffset);

	 PChips2[5]->CAD.SetCurrentFrame(int16(tenthous - 1));
	 PChips2[5]->Show();
  }
  else {PChips2[5]->NoShow();}
  yoffset -= int16(2*tenthous);
  zoffset += int16(tenthous);

  if (thous)
  {
	 PChips2[4]->CAD.SetY(yoffset);
	 PChips2[4]->CAD.SetZ(zoffset);

	 PChips2[4]->CAD.SetCurrentFrame(int16(thous - 1));
	 PChips2[4]->Show();
  }
  else {PChips2[4]->NoShow();}
  yoffset -= int16(2*thous);
  zoffset += int16(thous);

  if (huns)
  {
	 PChips2[3]->CAD.SetY(yoffset);
	 PChips2[3]->CAD.SetZ(zoffset);

	 PChips2[3]->CAD.SetCurrentFrame(int16(huns - 1));
	 PChips2[3]->Show();
  }
  else {PChips2[3]->NoShow();}
  yoffset -= int16(2*huns);
  zoffset += int16(huns);

  if (twfive)
  {
	 PChips2[2]->CAD.SetY(yoffset);
	 PChips2[2]->CAD.SetZ(zoffset);

	 PChips2[2]->CAD.SetCurrentFrame(int16(twfive - 1));
	 PChips2[2]->Show();
  }
  else {PChips2[2]->NoShow();}
  yoffset -= int16(2*twfive);
  zoffset += int16(twfive);

  if (fives)
  {
	 PChips2[1]->CAD.SetY(yoffset);
	 PChips2[1]->CAD.SetZ(zoffset);

	 PChips2[1]->CAD.SetCurrentFrame(int16(fives - 1));
	 PChips2[1]->Show();
  }
  else {PChips2[1]->NoShow();}
  yoffset -= int16(2*fives);
  zoffset += int16(fives);

  if (ones)
  {
	 PChips2[0]->CAD.SetY(yoffset);
	 PChips2[0]->CAD.SetZ(zoffset);

	 PChips2[0]->CAD.SetCurrentFrame(int16(ones - 1));
	 PChips2[0]->Show();
  }
  else {PChips2[0]->NoShow();}

  num = betamount/2;

  tenthous = num / 10000;
  tenthousvalue = tenthous * 10000;
  thous = (num - tenthousvalue) / 1000;
  thousvalue = thous * 1000;
  huns = (num - tenthousvalue - thousvalue) / 100;
  hunsvalue = huns * 100;
  twfive = (num - tenthousvalue - thousvalue - hunsvalue) / 25;
  twfivevalue = twfive * 25;
  fives = (num - tenthousvalue - thousvalue - hunsvalue - twfivevalue) / 5;
  fivesvalue = fives * 5;
  ones = (num - tenthousvalue - thousvalue - hunsvalue - twfivevalue - fivesvalue);


  if (tenthous)
  {
	 PChips4[5]->CAD.SetY(yoffset);
	 PChips4[5]->CAD.SetZ(zoffset);

	 PChips4[5]->CAD.SetCurrentFrame(int16(tenthous - 1));
	 PChips4[5]->Show();
  }
  else {PChips4[5]->NoShow();}
  yoffset -= int16(2*tenthous);
  zoffset += int16(tenthous);

  if (thous)
  {
	 PChips4[4]->CAD.SetY(yoffset);
	 PChips4[4]->CAD.SetZ(zoffset);

	 PChips4[4]->CAD.SetCurrentFrame(int16(thous - 1));
	 PChips4[4]->Show();
  }
  else {PChips4[4]->NoShow();}
  yoffset -= int16(2*thous);
  zoffset += int16(thous);

  if (huns)
  {
	 PChips4[3]->CAD.SetY(yoffset);
	 PChips4[3]->CAD.SetZ(zoffset);

	 PChips4[3]->CAD.SetCurrentFrame(int16(huns - 1));
	 PChips4[3]->Show();
  }
  else {PChips4[3]->NoShow();}
  yoffset -= int16(2*huns);
  zoffset += int16(huns);

  if (twfive)
  {
	 PChips4[2]->CAD.SetY(yoffset);
	 PChips4[2]->CAD.SetZ(zoffset);

	 PChips4[2]->CAD.SetCurrentFrame(int16(twfive - 1));
	 PChips4[2]->Show();
  }
  else {PChips4[2]->NoShow();}
  yoffset -= int16(2*twfive);
  zoffset += int16(twfive);

  if (fives)
  {
	 PChips4[1]->CAD.SetY(yoffset);
	 PChips4[1]->CAD.SetZ(zoffset);

	 PChips4[1]->CAD.SetCurrentFrame(int16(fives - 1));
	 PChips4[1]->Show();
  }
  else {PChips4[1]->NoShow();}
  yoffset -= int16(2*fives);
  zoffset += int16(fives);

  if (ones)
  {
	 PChips4[0]->CAD.SetY(yoffset);
	 PChips4[0]->CAD.SetZ(zoffset);

	 PChips4[0]->CAD.SetCurrentFrame(int16(ones - 1));
	 PChips4[0]->Show();
  }
  else {PChips4[0]->NoShow();}
  yoffset -= int16(2*ones);
  zoffset += int16(ones);
  if(((int32)betamount)%2)
  {
	 PBJ50Cent->CAD.SetY(yoffset);
	 PBJ50Cent->CAD.SetZ(zoffset);
	 PBJ50Cent->CAD.SetCurrentFrame(0);
	 PBJ50Cent->Show();
  }
  Update(GetAdjFUC());
}
//*******************************************************************
void TBJBetSpot::NoShowBJChips()
{
  for(int16 i=0;i<6;i++)
  {
	 PChips4[i]->NoShow();
  }
  PBJ50Cent->NoShow();
}
//*******************************************************************
void TBJBetSpot::ShowInsureChips(TMoney insureamount)
{
  if (NotFound) {return;}
  int16  yoffset,zoffset;
  int32 num;
  insuranceamount = insureamount;
  num = (int32)insureamount;
  num = num%100001l;
  yoffset   = PChips5[0]->SAD.GetY();
  zoffset   = PChips5[0]->SAD.GetZ();

  int32 tenthous = num / 10000;
  int32 tenthousvalue = tenthous * 10000;
  int32 thous = (num - tenthousvalue) / 1000;
  int32 thousvalue = thous * 1000;
  int32 huns = (num - tenthousvalue - thousvalue) / 100;
  int32 hunsvalue = huns * 100;
  int32 twfive = (num - tenthousvalue - thousvalue - hunsvalue) / 25;
  int32 twfivevalue = twfive * 25;
  int32 fives = (num - tenthousvalue - thousvalue - hunsvalue - twfivevalue) / 5;
  int32 fivesvalue = fives * 5;
  int32 ones = (num - tenthousvalue - thousvalue - hunsvalue - twfivevalue - fivesvalue);


  if (tenthous)
  {
	 PChips5[5]->CAD.SetY(yoffset);
	 PChips5[5]->CAD.SetZ(zoffset);

	 PChips5[5]->CAD.SetCurrentFrame(int16(tenthous - 1));
	 PChips5[5]->Show();
  }
  else {PChips5[5]->NoShow();}
  yoffset -= int16(2*tenthous);
  zoffset += int16(tenthous);

  if (thous)
  {
	 PChips5[4]->CAD.SetY(yoffset);
	 PChips5[4]->CAD.SetZ(zoffset);

	 PChips5[4]->CAD.SetCurrentFrame(int16(thous - 1));
	 PChips5[4]->Show();
  }
  else {PChips5[4]->NoShow();}
  yoffset -= int16(2*thous);
  zoffset += int16(thous);

  if (huns)
  {
	 PChips5[3]->CAD.SetY(yoffset);
	 PChips5[3]->CAD.SetZ(zoffset);

	 PChips5[3]->CAD.SetCurrentFrame(int16(huns - 1));
	 PChips5[3]->Show();
  }
  else {PChips5[3]->NoShow();}
  yoffset -= int16(2*huns);
  zoffset += int16(huns);

  if (twfive)
  {
	 PChips5[2]->CAD.SetY(yoffset);
	 PChips5[2]->CAD.SetZ(zoffset);

	 PChips5[2]->CAD.SetCurrentFrame(int16(twfive - 1));
	 PChips5[2]->Show();
  }
  else {PChips5[2]->NoShow();}
  yoffset -= int16(2*twfive);
  zoffset += int16(twfive);

  if (fives)
  {
	 PChips5[1]->CAD.SetY(yoffset);
	 PChips5[1]->CAD.SetZ(zoffset);

	 PChips5[1]->CAD.SetCurrentFrame(int16(fives - 1));
	 PChips5[1]->Show();
  }
  else {PChips5[1]->NoShow();}
  yoffset -= int16(2*fives);
  zoffset += int16(fives);

  if (ones)
  {
	 PChips5[0]->CAD.SetY(yoffset);
	 PChips5[0]->CAD.SetZ(zoffset);

	 PChips5[0]->CAD.SetCurrentFrame(int16(ones - 1));
	 PChips5[0]->Show();
  }
  else {PChips5[0]->NoShow();}
  yoffset -= int16(2*ones);
  zoffset += int16(ones);

  if(((int32)betamount)%2)
  {
	PInsure50Cent->CAD.SetY(yoffset);
	PInsure50Cent->CAD.SetZ(zoffset);
	PInsure50Cent->Show();
  }
  Update(GetAdjFUC());
}
//*******************************************************************
void TBJBetSpot::NoShowInsureChips()
{
  for(int16 i=0;i<6;i++)
  {
	 PChips5[i]->NoShow();
  }
  PInsure50Cent->NoShow();
}
//*******************************************************************
void TBJBetSpot::ShowWinChips()
{
  if (NotFound) {return;}
  int16  yoffset,zoffset;
  int32 num;
  num = (int32)betamount;
  num = num%100001l;
  yoffset   = PChips1[0]->SAD.GetY();
  zoffset   = PChips1[0]->SAD.GetZ();

  int32 tenthous = num / 10000;
  int32 tenthousvalue = tenthous * 10000;
  int32 thous = (num - tenthousvalue) / 1000;
  int32 thousvalue = thous * 1000;
  int32 huns = (num - tenthousvalue - thousvalue) / 100;
  int32 hunsvalue = huns * 100;
  int32 twfive = (num - tenthousvalue - thousvalue - hunsvalue) / 25;
  int32 twfivevalue = twfive * 25;
  int32 fives = (num - tenthousvalue - thousvalue - hunsvalue - twfivevalue) / 5;
  int32 fivesvalue = fives * 5;
  int32 ones = (num - tenthousvalue - thousvalue - hunsvalue - twfivevalue - fivesvalue);


  if (tenthous)
  {
	 PChips1[5]->CAD.SetY(yoffset);
	 PChips1[5]->CAD.SetZ(zoffset);

	 PChips1[5]->CAD.SetCurrentFrame(int16(tenthous - 1));
	 PChips1[5]->Show();
  }
  else {PChips1[5]->NoShow();}
  yoffset -= int16(2*tenthous);
  zoffset += int16(tenthous);

  if (thous)
  {
	 PChips1[4]->CAD.SetY(yoffset);
	 PChips1[4]->CAD.SetZ(zoffset);

	 PChips1[4]->CAD.SetCurrentFrame(int16(thous - 1));
	 PChips1[4]->Show();
  }
  else {PChips1[4]->NoShow();}
  yoffset -= int16(2*thous);
  zoffset += int16(thous);

  if (huns)
  {
	 PChips1[3]->CAD.SetY(yoffset);
	 PChips1[3]->CAD.SetZ(zoffset);

	 PChips1[3]->CAD.SetCurrentFrame(int16(huns - 1));
	 PChips1[3]->Show();
  }
  else {PChips1[3]->NoShow();}
  yoffset -= int16(2*huns);
  zoffset += int16(huns);

  if (twfive)
  {
	 PChips1[2]->CAD.SetY(yoffset);
	 PChips1[2]->CAD.SetZ(zoffset);

	 PChips1[2]->CAD.SetCurrentFrame(int16(twfive - 1));
	 PChips1[2]->Show();
  }
  else {PChips1[2]->NoShow();}
  yoffset -= int16(2*twfive);
  zoffset += int16(twfive);

  if (fives)
  {
	 PChips1[1]->CAD.SetY(yoffset);
	 PChips1[1]->CAD.SetZ(zoffset);

	 PChips1[1]->CAD.SetCurrentFrame(int16(fives - 1));
	 PChips1[1]->Show();
  }
  else {PChips1[1]->NoShow();}
  yoffset -= int16(2*fives);
  zoffset += int16(fives);

  if (ones)
  {
	 PChips1[0]->CAD.SetY(yoffset);
	 PChips1[0]->CAD.SetZ(zoffset);

	 PChips1[0]->CAD.SetCurrentFrame(int16(ones - 1));
	 PChips1[0]->Show();
  }
  else {PChips1[0]->NoShow();}
  Update(GetAdjFUC());
}
//*******************************************************************
void TBJBetSpot::NoShowWinChips()
{
  for(int16 i=0;i<6;i++)
  {
	 PChips1[i]->NoShow();
  }
}
//*******************************************************************
void TBJBetSpot::ShowDoubleDownWinChips()
{
  if (NotFound) {return;}
  int16  yoffset,zoffset;
  int32 num;
  num = (int32)doubledownamount;
  num = num%100001l;
  yoffset   = PChips3[0]->SAD.GetY();
  zoffset   = PChips3[0]->SAD.GetZ();

  int32 tenthous = num / 10000;
  int32 tenthousvalue = tenthous * 10000;
  int32 thous = (num - tenthousvalue) / 1000;
  int32 thousvalue = thous * 1000;
  int32 huns = (num - tenthousvalue - thousvalue) / 100;
  int32 hunsvalue = huns * 100;
  int32 twfive = (num - tenthousvalue - thousvalue - hunsvalue) / 25;
  int32 twfivevalue = twfive * 25;
  int32 fives = (num - tenthousvalue - thousvalue - hunsvalue - twfivevalue) / 5;
  int32 fivesvalue = fives * 5;
  int32 ones = (num - tenthousvalue - thousvalue - hunsvalue - twfivevalue - fivesvalue);


  if (tenthous)
  {
	 PChips3[5]->CAD.SetY(yoffset);
	 PChips3[5]->CAD.SetZ(zoffset);

	 PChips3[5]->CAD.SetCurrentFrame(int16(tenthous - 1));
	 PChips3[5]->Show();
  }
  else {PChips3[5]->NoShow();}
  yoffset -= int16(2*tenthous);
  zoffset += int16(tenthous);

  if (thous)
  {
	 PChips3[4]->CAD.SetY(yoffset);
	 PChips3[4]->CAD.SetZ(zoffset);

	 PChips3[4]->CAD.SetCurrentFrame(int16(thous - 1));
	 PChips3[4]->Show();
  }
  else {PChips3[4]->NoShow();}
  yoffset -= int16(2*thous);
  zoffset += int16(thous);

  if (huns)
  {
	 PChips3[3]->CAD.SetY(yoffset);
	 PChips3[3]->CAD.SetZ(zoffset);

	 PChips3[3]->CAD.SetCurrentFrame(int16(huns - 1));
	 PChips3[3]->Show();
  }
  else {PChips3[3]->NoShow();}
  yoffset -= int16(2*huns);
  zoffset += int16(huns);

  if (twfive)
  {
	 PChips3[2]->CAD.SetY(yoffset);
	 PChips3[2]->CAD.SetZ(zoffset);

	 PChips3[2]->CAD.SetCurrentFrame(int16(twfive - 1));
	 PChips3[2]->Show();
  }
  else {PChips3[2]->NoShow();}
  yoffset -= int16(2*twfive);
  zoffset += int16(twfive);

  if (fives)
  {
	 PChips3[1]->CAD.SetY(yoffset);
	 PChips3[1]->CAD.SetZ(zoffset);

	 PChips3[1]->CAD.SetCurrentFrame(int16(fives - 1));
	 PChips3[1]->Show();
  }
  else {PChips3[1]->NoShow();}
  yoffset -= int16(2*fives);
  zoffset += int16(fives);

  if (ones)
  {
	 PChips3[0]->CAD.SetY(yoffset);
	 PChips3[0]->CAD.SetZ(zoffset);

	 PChips3[0]->CAD.SetCurrentFrame(int16(ones - 1));
	 PChips3[0]->Show();
  }
  else {PChips3[0]->NoShow();}
  Update(GetAdjFUC());
}
//*******************************************************************
void TBJBetSpot::ShowInsureWinChips()
{
  if (NotFound) {return;}
  int16  yoffset,zoffset;
  int32 num;
  num = (int32)insuranceamount;
  num = num%100001l;
  yoffset   = PChips3[0]->SAD.GetY();
  zoffset   = PChips3[0]->SAD.GetZ();

  int32 tenthous = num / 10000;
  int32 tenthousvalue = tenthous * 10000;
  int32 thous = (num - tenthousvalue) / 1000;
  int32 thousvalue = thous * 1000;
  int32 huns = (num - tenthousvalue - thousvalue) / 100;
  int32 hunsvalue = huns * 100;
  int32 twfive = (num - tenthousvalue - thousvalue - hunsvalue) / 25;
  int32 twfivevalue = twfive * 25;
  int32 fives = (num - tenthousvalue - thousvalue - hunsvalue - twfivevalue) / 5;
  int32 fivesvalue = fives * 5;
  int32 ones = (num - tenthousvalue - thousvalue - hunsvalue - twfivevalue - fivesvalue);


  if (tenthous)
  {
	 PChips3[5]->CAD.SetY(yoffset);
	 PChips3[5]->CAD.SetZ(zoffset);

	 PChips3[5]->CAD.SetCurrentFrame(int16(tenthous - 1));
	 PChips3[5]->Show();
  }
  else {PChips3[5]->NoShow();}
  yoffset -= int16(2*tenthous);
  zoffset += int16(tenthous);

  if (thous)
  {
	 PChips3[4]->CAD.SetY(yoffset);
	 PChips3[4]->CAD.SetZ(zoffset);

	 PChips3[4]->CAD.SetCurrentFrame(int16(thous - 1));
	 PChips3[4]->Show();
  }
  else {PChips3[4]->NoShow();}
  yoffset -= int16(2*thous);
  zoffset += int16(thous);

  if (huns)
  {
	 PChips3[3]->CAD.SetY(yoffset);
	 PChips3[3]->CAD.SetZ(zoffset);

	 PChips3[3]->CAD.SetCurrentFrame(int16(huns - 1));
	 PChips3[3]->Show();
  }
  else {PChips3[3]->NoShow();}
  yoffset -= int16(2*huns);
  zoffset += int16(huns);

  if (twfive)
  {
	 PChips3[2]->CAD.SetY(yoffset);
	 PChips3[2]->CAD.SetZ(zoffset);

	 PChips3[2]->CAD.SetCurrentFrame(int16(twfive - 1));
	 PChips3[2]->Show();
  }
  else {PChips3[2]->NoShow();}
  yoffset -= int16(2*twfive);
  zoffset += int16(twfive);

  if (fives)
  {
	 PChips3[1]->CAD.SetY(yoffset);
	 PChips3[1]->CAD.SetZ(zoffset);

	 PChips3[1]->CAD.SetCurrentFrame(int16(fives - 1));
	 PChips3[1]->Show();
  }
  else {PChips3[1]->NoShow();}
  yoffset -= int16(2*fives);
  zoffset += int16(fives);

  if (ones)
  {
	 PChips3[0]->CAD.SetY(yoffset);
	 PChips3[0]->CAD.SetZ(zoffset);

	 PChips3[0]->CAD.SetCurrentFrame(int16(ones - 1));
	 PChips3[0]->Show();
  }
  else {PChips3[0]->NoShow();}
  Update(GetAdjFUC());
}
//*******************************************************************
void TBJBetSpot::NoShowDoubleDownWinChips()
{
  for(int16 i=0;i<6;i++)
  {
    PChips3[i]->NoShow();
  }
  doubledownamount = 0;
}
//*******************************************************************
void TBJBetSpot::NoShowInsureWinChips()
{
  for(int16 i=0;i<6;i++)
  {
	 PChips3[i]->NoShow();
  }
}
//*******************************************************************
void TBJBetSpot::NoShowBetChips()
{
  for(int16 i=0;i<6;i++)
  {
	 PChips[i]->NoShow();
  }
}
//*******************************************************************
void TBJBetSpot::NoShowEvenMoneyChips()
{
  for(int16 i=0;i<6;i++)
  {
	 PChips1[i]->NoShow();
  }
}
//*******************************************************************
void TBJBetSpot::ShowDoubleDownChips(TMoney ba) // doubledown betamount i.e. for less
{
  if (NotFound) {return;}
  int16  yoffset,zoffset;
  int32 num;
  num = (int32)ba;
  num = num%100001l;
  doubledownamount = ba;
  yoffset   = PChips2[0]->SAD.GetY();
  zoffset   = PChips2[0]->SAD.GetZ();

  int32 tenthous = num / 10000;
  int32 tenthousvalue = tenthous * 10000;
  int32 thous = (num - tenthousvalue) / 1000;
  int32 thousvalue = thous * 1000;
  int32 huns = (num - tenthousvalue - thousvalue) / 100;
  int32 hunsvalue = huns * 100;
  int32 twfive = (num - tenthousvalue - thousvalue - hunsvalue) / 25;
  int32 twfivevalue = twfive * 25;
  int32 fives = (num - tenthousvalue - thousvalue - hunsvalue - twfivevalue) / 5;
  int32 fivesvalue = fives * 5;
  int32 ones = (num - tenthousvalue - thousvalue - hunsvalue - twfivevalue - fivesvalue);


  if (tenthous)
  {
	 PChips2[5]->CAD.SetY(yoffset);
	 PChips2[5]->CAD.SetZ(zoffset);

	 PChips2[5]->CAD.SetCurrentFrame(int16(tenthous - 1));
    PChips2[5]->Show();
  }
  else {PChips2[5]->NoShow();}
  yoffset -= int16(2*tenthous);
  zoffset += int16(tenthous);

  if (thous)
  {
	 PChips2[4]->CAD.SetY(yoffset);
	 PChips2[4]->CAD.SetZ(zoffset);

    PChips2[4]->CAD.SetCurrentFrame(int16(thous - 1));
    PChips2[4]->Show();
  }
  else {PChips2[4]->NoShow();}
  yoffset -= int16(2*thous);
  zoffset += int16(thous);

  if (huns)
  {
    PChips2[3]->CAD.SetY(yoffset);
    PChips2[3]->CAD.SetZ(zoffset);

    PChips2[3]->CAD.SetCurrentFrame(int16(huns - 1));
    PChips2[3]->Show();
  }
  else {PChips2[3]->NoShow();}
  yoffset -= int16(2*huns);
  zoffset += int16(huns);

  if (twfive)
  {
    PChips2[2]->CAD.SetY(yoffset);
    PChips2[2]->CAD.SetZ(zoffset);

    PChips2[2]->CAD.SetCurrentFrame(int16(twfive - 1));
    PChips2[2]->Show();
  }
  else {PChips2[2]->NoShow();}
  yoffset -= int16(2*twfive);
  zoffset += int16(twfive);

  if (fives)
  {
	 PChips2[1]->CAD.SetY(yoffset);
	 PChips2[1]->CAD.SetZ(zoffset);

    PChips2[1]->CAD.SetCurrentFrame(int16(fives - 1));
    PChips2[1]->Show();
  }
  else {PChips2[1]->NoShow();}
  yoffset -= int16(2*fives);
  zoffset += int16(fives);

  if (ones)
  {
    PChips2[0]->CAD.SetY(yoffset);
    PChips2[0]->CAD.SetZ(zoffset);

    PChips2[0]->CAD.SetCurrentFrame(int16(ones - 1));
    PChips2[0]->Show();
  }
  else {PChips2[0]->NoShow();}
  Update(GetAdjFUC());
}
//*******************************************************************
void TBJBetSpot::NoShowDoubleDownChips()
{
  for(int16 i=0;i<6;i++)
  {
    PChips2[i]->NoShow();
  }
}
//*******************************************************************
void TBJBetSpot::NoShowChips()
{
  for(int16 i=0;i<6;i++)
  {
    PChips[i]->NoShow();
    PChips1[i]->NoShow();
    PChips2[i]->NoShow();
    PChips3[i]->NoShow();
    PChips4[i]->NoShow();
  }
}
//*******************************************************************
void TBJBetSpot::NoShowCards()
{
  for(int16 i=0;i<6;i++)
  {
    PCards[i]->NoShow();
  }
}
//*******************************************************************
void TBJBetSpot::ShowFace(THand *hand)
{
  int16 cardname=0;
  int16 num = 0;
  if (PCards == NULL) {return;}

  if (hand->cards[hand->inhand-1].name > Joker) {return;}
  if (hand->cards[hand->inhand-1].suit > Spade) {return;}
  if (hand->cards[hand->inhand-1].name == AceHi)
  {
    cardname = AceLo;
  }
  else
  {
    cardname = int16(hand->cards[hand->inhand-1].name);
  }

  if (hand->cards[hand->inhand-1].name == Joker)
  {
    num = 52;
  }
  else
  {
    num = int16((hand->cards[hand->inhand-1].suit * 13) + cardname);
  }
  int16 xx = int16(hand->inhand-1);
  if(xx > 5){xx = 5;}
  PCards[xx]->CAD.SetCurrentFrame(num);
  PCards[xx]->Show();
  Update(GetAdjFUC());
}
//*******************************************************************
void TBJBetSpot::SetNum(TMoney money)
{
  int32 num = (int32)money;
  if (NotFound) {return;}
  int16 yoffset,zoffset;
  betamount = money;
  num = num%100001l;
  yoffset   = PChips[0]->SAD.GetY();
  zoffset   = PChips[0]->SAD.GetZ();

  int32 tenthous = num / 10000;
  int32 tenthousvalue = tenthous * 10000;
  int32 thous = (num - tenthousvalue) / 1000;
  int32 thousvalue = thous * 1000;
  int32 huns = (num - tenthousvalue - thousvalue) / 100;
  int32 hunsvalue = huns * 100;
  int32 twfive = (num - tenthousvalue - thousvalue - hunsvalue) / 25;
  int32 twfivevalue = twfive * 25;
  int32 fives = (num - tenthousvalue - thousvalue - hunsvalue - twfivevalue) / 5;
  int32 fivesvalue = fives * 5;
  int32 ones = (num - tenthousvalue - thousvalue - hunsvalue - twfivevalue - fivesvalue);


  if (tenthous)
  {
	 PChips[5]->CAD.SetY(yoffset);
	 PChips[5]->CAD.SetZ(zoffset);

	 PChips[5]->CAD.SetCurrentFrame(int16(tenthous - 1));
    PChips[5]->Show();
  }
  else {PChips[5]->NoShow();}
  yoffset -= int16(2*tenthous);
  zoffset += int16(tenthous);

  if (thous)
  {
	 PChips[4]->CAD.SetY(yoffset);
	 PChips[4]->CAD.SetZ(zoffset);

    PChips[4]->CAD.SetCurrentFrame(int16(thous - 1));
    PChips[4]->Show();
  }
  else {PChips[4]->NoShow();}
  yoffset -= int16(2*thous);
  zoffset += int16(thous);

  if (huns)
  {
    PChips[3]->CAD.SetY(yoffset);
    PChips[3]->CAD.SetZ(zoffset);

    PChips[3]->CAD.SetCurrentFrame(int16(huns - 1));
    PChips[3]->Show();
  }
  else {PChips[3]->NoShow();}
  yoffset -= int16(2*huns);
  zoffset += int16(huns);

  if (twfive)
  {
    PChips[2]->CAD.SetY(yoffset);
    PChips[2]->CAD.SetZ(zoffset);

    PChips[2]->CAD.SetCurrentFrame(int16(twfive - 1));
	 PChips[2]->Show();
  }
  else {PChips[2]->NoShow();}
  yoffset -= int16(2*twfive);
  zoffset += int16(twfive);

  if (fives)
  {
    PChips[1]->CAD.SetY(yoffset);
    PChips[1]->CAD.SetZ(zoffset);

    PChips[1]->CAD.SetCurrentFrame(int16(fives - 1));
    PChips[1]->Show();
  }
  else {PChips[1]->NoShow();}
  yoffset -= int16(2*fives);
  zoffset += int16(fives);

  if (ones)
  {
    PChips[0]->CAD.SetY(yoffset);
    PChips[0]->CAD.SetZ(zoffset);

    PChips[0]->CAD.SetCurrentFrame(int16(ones - 1));
    PChips[0]->Show();
  }
  else {PChips[0]->NoShow();}
  Update(GetAdjFUC());
}
//*******************************************************************
void TBJBetSpot::NoShowCard(int16 num)
{
  PCards[num]->NoShow();
}
//*******************************************************************
