//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  cbjdspsp.cpp
//    Project Name:  Casino
// Original Author:  Adam Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//   1.0   07/19/96    M.Perry     moved functions into cpp file.
//   2.0   09/23/97    M.Perry     32-bit conversion.
//********************************************************************
#include "cbjdspsp.h"
#include "oanm.h"
//*******************************************************************
TBJDealerSpot::TBJDealerSpot(TOgleModeWindow *pmw,const TFileMode &NewFileMode)
:TSprite(pmw,NewFileMode)
{
  SetToManual();
  NoShow();
  SetupAnms();
}
//*******************************************************************
TBJDealerSpot::TBJDealerSpot(TOgleModeWindow *pmw,const TFileMode &fm,void *psource)
:TSprite(pmw,fm,psource)
{
  SetToManual();
  NoShow();
  SetupAnms();
}
//*******************************************************************
TBJDealerSpot::~TBJDealerSpot()
{
}
//*******************************************************************
void TBJDealerSpot::SetupAnms()
{
	 PCards[0] = GetAnm(1);
	 if (PCards[0] == NULL) {AnmError("Dealer Spot","Cards",1);}
	 PCards[1] = GetAnm(0);
	 if (PCards[1] == NULL) {AnmError("Dealer Spot","Cards",0);}
	 for (int16 i=2;i<6;i++)
	 {
		PCards[i] = GetAnm(i);
		if (PCards[i] == NULL) {AnmError("Dealer Spot","Cards",i);}
	 }

	 PBack = GetAnm(6);
	 if (PBack == NULL) {AnmError("Dealer Spot","Back",6);}

	 for (int16 i=0;i<6;i++)
	 {
		PCards[i]->CAD.ClearAutoStart();
		PCards[i]->CAD.ClearAutoStop();
		PCards[i]->CAD.SetDirStill();
	 }
	 PBack->CAD.ClearAutoStart();
	 PBack->CAD.ClearAutoStop();
	 PBack->CAD.SetDirStill();
}
//*******************************************************************
void TBJDealerSpot::NoShowCards()
{
  for(int16 i=0;i<6;i++)
  {
    PCards[i]->NoShow();
  }
}
//*******************************************************************
void TBJDealerSpot::ShowFace(THand *hand)
{
  int16 cardname=0;
  int16 num = 0;
  if (PCards == NULL) {return;}
  if (hand->cards[hand->inhand-1].name > Joker) {return;}
  if (hand->cards[hand->inhand-1].suit > Spade) {return;}
  if (hand->cards[hand->inhand-1].name == AceHi)
  {
    cardname = AceLo;
  }
  else
  {
    cardname = int16(hand->cards[hand->inhand-1].name);
  }

  if (hand->cards[hand->inhand-1].name == Joker)
  {
    num = 52;
  }
  else
  {
    num = int16((hand->cards[hand->inhand-1].suit * 13) + cardname);
  }
  int16 xx = int16(hand->inhand-1);
  if(xx > 5){xx = 5;}
  PCards[xx]->CAD.SetCurrentFrame(num);
  PCards[xx]->Show();
  Update(GetAdjFUC());
}
//*******************************************************************
void TBJDealerSpot::ShowHoleCard(THand *hand)
{
  int16 cardname=0;
  int16 num = 0;
  if (PCards == NULL) {return;}

  if (hand->cards[1].name > Joker) {return;}
  if (hand->cards[1].suit > Spade) {return;}
  if (hand->cards[1].name == AceHi)
  {
    cardname = AceLo;
  }
  else
  {
    cardname = int16(hand->cards[1].name);
  }
  if (hand->cards[1].name == Joker)
  {
    num = 52;
  }
  else
  {
    num = int16((hand->cards[1].suit * 13) + cardname);
  }
  PCards[1]->CAD.SetCurrentFrame(num);
  PCards[1]->Show();
  Update(GetAdjFUC());
}
//*******************************************************************
void TBJDealerSpot::ShowBack()
{
  if (PBack != NULL) {PBack->Show();}
}
//*******************************************************************
void TBJDealerSpot::NoShowBack()
{
  if (PBack != NULL) {PBack->NoShow();}
}
//*******************************************************************
