//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  cvpglord.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     10/11/95   M.Perry    Original baseline
//  2.0     09/20/97   M.Perry    32-bit conversion.
//*******************************************************************
#include "cbjglord.h"
//#include "cbjglspl.h"
#include "bjlordst.h"
#include "bjlordms.h"
#include "ostate.h"
#include <assert.h>
#include <time.h>   //To Set Random Number Generator
#include "bjdeck.h"
#include "bjaskex.h"
#include <stdlib.h> //For Random Number Generator
#include "oskitcat.h"
#include "cplaymgr.h"
#include "cbjplay.h"
#include "casnames.rh"
#include "ogamefw.h"
#include "casapp.h"
#include <owl\dialog.h>
#include "owl\inputdia.h"
#include "orespond.h"
#include "oanm.h"
#include "cas_cm.rh"
#include "cbjnames.rh"
//*******************************************************************
/*#define FUC_DEALCARD1A 1
#define FUC_DEALCARD1B 1
#define FUC_DEALCARD1C 1
#define FUC_DEALCARD2C 1
#define FUC_DEALCARD2D 1
#define FUC_DEALCARD2E 1
#define FUC_DEALCARD3E 1
#define FUC_DEALCARD3F 1
#define FUC_DEALCARD3G 1
#define FUC_DEALERUP 2
#define FUC_DEALERDOWN 3
#define FUC_SHOWBACK   5
#define FUC_REMOVEBACK 2
#define FUC_REMOVEBJBACK 3
#define FUC_SHOWBJFACE   6
#define FUC_SHOWFACE   5  */
//*******************************************************************
string GetAppString(int16 id)
{
  return TAppString(id);
}
//*******************************************************************
#if defined(SUPPORT_OLD_VER)
void TCasinoBJGameLord::SetupUniqueIDStrings()
{
  strSounds = GetAppString(IDS_MS_SOUNDS_BJ1);
  strSign = GetAppString(IDS_MS_SIGN_BJ1);
  strRack = GetAppString(IDS_MS_RACK_BJ1);
  strCircle1 = GetAppString(IDS_MS_CIRCLE1_BJ1);
  strCircle2 = GetAppString(IDS_MS_CIRCLE2_BJ1);
  strCircle3 = GetAppString(IDS_MS_CIRCLE3_BJ1);
  strNP1 = GetAppString(IDS_MS_NP1_BJ1);
  strNP2 = GetAppString(IDS_MS_NP2_BJ1);
  strNP3 = GetAppString(IDS_MS_NP3_BJ1);
  strMsgDisplay = GetAppString(IDS_MS_MESS_BJ1);
  strBankCash = GetAppString(IDS_MS_BANKCASH_BJ1);
  strBetAmount = GetAppString(IDS_MS_UNITCASH_BJ1);
  strButton0 = GetAppString(IDS_MS_B0_BJ1);
  strButton1 = GetAppString(IDS_MS_B1_BJ1);
  strButton2 = GetAppString(IDS_MS_B2_BJ1);
  strButton3 = GetAppString(IDS_MS_B3_BJ1);
  strButton4 = GetAppString(IDS_MS_B4_BJ1);
  strButton5 = GetAppString(IDS_MS_B5_BJ1);
  strButton6 = GetAppString(IDS_MS_B6_BJ1);
  strButton7 = GetAppString(IDS_MS_B7_BJ1);
  strButton8 = GetAppString(IDS_MS_B8_BJ1);
  strButton9 = GetAppString(IDS_MS_B9_BJ1);
  strButton10 = GetAppString(IDS_MS_B10_BJ1);
  strButton11 = GetAppString(IDS_MS_B11_BJ1);
  strButton12 = GetAppString(IDS_MS_B12_BJ1);
  strButton13 = GetAppString(IDS_MS_B13_BJ1);
  strButton14 = GetAppString(IDS_MS_B14_BJ1);
  strButton15 = GetAppString(IDS_MS_B15_BJ1);
  strButton16 = GetAppString(IDS_MS_B16_BJ1);
  strButton17 = GetAppString(IDS_MS_B17_BJ1);
  strButton18 = GetAppString(IDS_MS_B18_BJ1);
  strBetSpot0 = GetAppString(IDS_MS_BS0_BJ1);
  strBetSpot1 = GetAppString(IDS_MS_BS1_BJ1);
  strBetSpot2 = GetAppString(IDS_MS_BS2_BJ1);
  strBetSpot3 = GetAppString(IDS_MS_BS3_BJ1);
  strBetSpot4 = GetAppString(IDS_MS_BS4_BJ1);
  strBetSpot5 = GetAppString(IDS_MS_BS5_BJ1);
  strBetSpot6 = GetAppString(IDS_MS_BS6_BJ1);
  strDealerSpot = GetAppString(IDS_MS_DS_BJ1);
  strChips = GetAppString(IDS_MS_CHIPS_BJ1);
}
#endif
//*******************************************************************
#if defined(SUPPORT_OLD_VER)
int16 TCasinoBJGameLord::GetUniqueID(const string &s)
{
  if (s == strSounds) {return 1;}
  if (s == strSign) {return 2;}
  if (s == strRack) {return 3;}
  if (s == strCircle1) {return 4;}
  if (s == strCircle2) {return 5;}
  if (s == strCircle3) {return 6;}
  if (s == strNP1) {return 7;}
  if (s == strNP2) {return 8;}
  if (s == strNP3) {return 9;}
  if (s == strMsgDisplay) {return 11;}
  if (s == strBankCash) {return 12;}
  if (s == strBetAmount) {return 13;}
  if (s == strButton0) {return 14;}
  if (s == strButton1) {return 15;}
  if (s == strButton2) {return 16;}
  if (s == strButton3) {return 17;}
  if (s == strButton4) {return 18;}
  if (s == strButton5) {return 19;}
  if (s == strButton6) {return 20;}
  if (s == strButton7) {return 21;}
  if (s == strButton8) {return 22;}
  if (s == strButton9) {return 23;}
  if (s == strButton10) {return 24;}
  if (s == strButton11) {return 25;}
  if (s == strButton12) {return 26;}
  if (s == strButton13) {return 27;}
  if (s == strButton14) {return 28;}
  if (s == strButton15) {return 29;}
  if (s == strButton16) {return 30;}
  if (s == strButton17) {return 31;}
  if (s == strButton18) {return 32;}
  if (s == strBetSpot0) {return 33;}
  if (s == strBetSpot1) {return 34;}
  if (s == strBetSpot2) {return 35;}
  if (s == strBetSpot3) {return 36;}
  if (s == strBetSpot4) {return 37;}
  if (s == strBetSpot5) {return 38;}
  if (s == strBetSpot6) {return 39;}
  if (s == strDealerSpot) {return 40;}
  if (s == strChips) {return 41;}
  return 0;
}
#endif
//*******************************************************************
TSprite *TCasinoBJGameLord::CreateSprite(string spritename,int16 id,void *psource)
{
  TFileMode FM(spritename,
               TFileMode::fm_None,
               TFileMode::fm_None,
               FileMode.GetDirIndex());
  if (psource != NULL)
  {
    switch (id)
	 {
		case  0 : return new TSprite(PModeWin,FM,psource);
      case  1 : BJSounds = new TBJSound(PModeWin,FM,psource);return BJSounds;
		case  2 : Sign = new TBJSign(PModeWin,FM,psource);return Sign;
		case  3 : Rack = new TBJRack(PModeWin,FM,psource);return Rack;
		case  4 : Circle1 = new TCircle(PModeWin,FM,psource);return Circle1;
		case  5 : Circle2 = new TCircle(PModeWin,FM,psource);return Circle2;
		case  6 : Circle3 = new TCircle(PModeWin,FM,psource);return Circle3;
      case  7 : NamePlate1 = new TCasNamePlate(PModeWin,FM,psource);return NamePlate1;
		case  8 : NamePlate2 = new TCasNamePlate(PModeWin,FM,psource);return NamePlate2;
		case  9 : NamePlate3 = new TCasNamePlate(PModeWin,FM,psource);return NamePlate3;
	  //	case 10 : = new TBetUnitChips(PModeWin,FM);
		case 11 : MessageDisplay = new TCasMessageDisplay(PModeWin,FM,psource);return MessageDisplay;
		case 12 : BankCashDisplay = new TCasCashDisplay(PModeWin,FM,psource);return BankCashDisplay;
		case 13 : BetAmountDisplay = new TCasCashDisplay(PModeWin,FM,psource);return BetAmountDisplay;
		case 14 : Button0  = new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)this,100,TRect(1,430,50,479),bjidButton0,true,'x');return Button0;
		case 15 : Button1  = new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)this,100,TRect(170,430,219,479),bjidButton1,true);return Button1;
		case 16 : Button2  = new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)this,100,TRect(223,464,258,479),bjidButton2,true);return Button2;
		case 17 : Button3  = new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)this,100,TRect(376,464,412,479),bjidButton3,true);return Button3;
		case 18 : Button4  = new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)this,100,TRect(416,430,468,452),bjidButton4,true,'c');return Button4;
		case 19 : Button5  = new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)this,100,TRect(416,454,468,479),bjidButton5,true,'r');return Button5;
		case 20 : Button6  = new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)this,100,TRect(472,455,489,479),bjidButton6,true,'4');return Button6;
		case 21 : Button7  = new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)this,100,TRect(491,455,508,479),bjidButton7,true,'5');return Button7;
		case 22 : Button8  = new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)this,100,TRect(510,455,527,479),bjidButton8,true,'6');return Button8;
		case 23 : Button9  = new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)this,100,TRect(529,455,546,479),bjidButton9,true,'7');return Button9;
		case 24 : Button10 = new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)this,100,TRect(548,455,564,479),bjidButton10,true,'8');return Button10;
		case 25 : Button11 = new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)this,100,TRect(566,455,584,479),bjidButton11,true,'9');return Button11;
		case 26 : Button12 = new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)this,100,TRect(587,432,639,478),bjidButton12,true);return Button12;
		case 27 : Button13 = new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)this,125,TRect(416,430,468,479),bjidButton13,true,'p');return Button13;
		case 28 : Button14 = new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)this,125,TRect(470,430,522,479	),bjidButton14,true,'d');return Button14;
		case 29 : Button15 = new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)this,250,TRect(533,430,585,479),bjidButton15,true,'h');return Button15;
		case 30 : Button16 = new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)this,250,TRect(587,432,639,478),bjidButton16,true,'s');return Button16;
		case 31 : Button17 = new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)this,250,TRect(416,430,522,479),bjidButton17,true,'n');return Button17;
      case 32 : Button18 = new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)this,250,TRect(533,430,639,478),bjidButton18,true,'y');return Button18;
		case 33 : BetSpot[0] = new TBJBetSpot(PModeWin,FM,psource);return BetSpot[0];
		case 34 : BetSpot[1] = new TBJBetSpot(PModeWin,FM,psource);return BetSpot[1];
		case 35 : BetSpot[2] = new TBJBetSpot(PModeWin,FM,psource);return BetSpot[2];
		case 36 : BetSpot[3] = new TBJBetSpot(PModeWin,FM,psource);return BetSpot[3];
      case 37 : BetSpot[4] = new TBJBetSpot(PModeWin,FM,psource);return BetSpot[4];
		case 38 : BetSpot[5] = new TBJBetSpot(PModeWin,FM,psource);return BetSpot[5];
		case 39 : BetSpot[6] = new TBJBetSpot(PModeWin,FM,psource);return BetSpot[6];
		case 40 : DealerSpot = new TBJDealerSpot(PModeWin,FM,psource);return DealerSpot;
		case 41 : Chips = new TCasChips(PModeWin,FM,psource);return Chips;
		default : return new TSprite(PModeWin,FM,psource);
	 }
  }
  else
  {
	 FM.SetRamImmed();
	 switch (id)
	 {
		case  0 : return new TSprite(PModeWin,FM);
      case  1 : BJSounds = new TBJSound(PModeWin,FM);return BJSounds;
		case  2 : Sign = new TBJSign(PModeWin,FM);return Sign;
		case  3 : Rack = new TBJRack(PModeWin,FM);return Rack;
		case  4 : Circle1 = new TCircle(PModeWin,FM);return Circle1;
		case  5 : Circle2 = new TCircle(PModeWin,FM);return Circle2;
		case  6 : Circle3 = new TCircle(PModeWin,FM);return Circle3;
      case  7 : NamePlate1 = new TCasNamePlate(PModeWin,FM);return NamePlate1;
		case  8 : NamePlate2 = new TCasNamePlate(PModeWin,FM);return NamePlate2;
		case  9 : NamePlate3 = new TCasNamePlate(PModeWin,FM);return NamePlate3;
	  //	case 10 : = new TBetUnitChips(PModeWin,FM);
		case 11 : MessageDisplay = new TCasMessageDisplay(PModeWin,FM);return MessageDisplay;
		case 12 : BankCashDisplay = new TCasCashDisplay(PModeWin,FM);return BankCashDisplay;
		case 13 : BetAmountDisplay = new TCasCashDisplay(PModeWin,FM);return BetAmountDisplay;
		case 14 : Button0  = new TCasButton(PModeWin,FM,(TCasinoGameLord *)this,100,TRect(1,430,50,479),bjidButton0,true,'x');return Button0;
		case 15 : Button1  = new TCasButton(PModeWin,FM,(TCasinoGameLord *)this,100,TRect(170,430,219,479),bjidButton1,true);return Button1;
		case 16 : Button2  = new TCasButton(PModeWin,FM,(TCasinoGameLord *)this,100,TRect(223,464,258,479),bjidButton2,true);return Button2;
		case 17 : Button3  = new TCasButton(PModeWin,FM,(TCasinoGameLord *)this,100,TRect(376,464,412,479),bjidButton3,true);return Button3;
		case 18 : Button4  = new TCasButton(PModeWin,FM,(TCasinoGameLord *)this,100,TRect(416,430,468,452),bjidButton4,true,'c');return Button4;
		case 19 : Button5  = new TCasButton(PModeWin,FM,(TCasinoGameLord *)this,100,TRect(416,454,468,479),bjidButton5,true,'r');return Button5;
		case 20 : Button6  = new TCasButton(PModeWin,FM,(TCasinoGameLord *)this,100,TRect(472,455,489,479),bjidButton6,true,'4');return Button6;
		case 21 : Button7  = new TCasButton(PModeWin,FM,(TCasinoGameLord *)this,100,TRect(491,455,508,479),bjidButton7,true,'5');return Button7;
		case 22 : Button8  = new TCasButton(PModeWin,FM,(TCasinoGameLord *)this,100,TRect(510,455,527,479),bjidButton8,true,'6');return Button8;
		case 23 : Button9  = new TCasButton(PModeWin,FM,(TCasinoGameLord *)this,100,TRect(529,455,546,479),bjidButton9,true,'7');return Button9;
		case 24 : Button10 = new TCasButton(PModeWin,FM,(TCasinoGameLord *)this,100,TRect(548,455,564,479),bjidButton10,true,'8');return Button10;
		case 25 : Button11 = new TCasButton(PModeWin,FM,(TCasinoGameLord *)this,100,TRect(566,455,584,479),bjidButton11,true,'9');return Button11;
		case 26 : Button12 = new TCasButton(PModeWin,FM,(TCasinoGameLord *)this,100,TRect(587,432,639,478),bjidButton12,true);return Button12;
		case 27 : Button13 = new TCasButton(PModeWin,FM,(TCasinoGameLord *)this,125,TRect(416,430,468,479),bjidButton13,true,'p');return Button13;
		case 28 : Button14 = new TCasButton(PModeWin,FM,(TCasinoGameLord *)this,125,TRect(470,430,522,479	),bjidButton14,true,'d');return Button14;
		case 29 : Button15 = new TCasButton(PModeWin,FM,(TCasinoGameLord *)this,250,TRect(533,430,585,479),bjidButton15,true,'h');return Button15;
		case 30 : Button16 = new TCasButton(PModeWin,FM,(TCasinoGameLord *)this,250,TRect(587,432,639,478),bjidButton16,true,'s');return Button16;
		case 31 : Button17 = new TCasButton(PModeWin,FM,(TCasinoGameLord *)this,250,TRect(416,430,522,479),bjidButton17,true,'n');return Button17;
      case 32 : Button18 = new TCasButton(PModeWin,FM,(TCasinoGameLord *)this,250,TRect(533,430,639,478),bjidButton18,true,'y');return Button18;
		case 33 : BetSpot[0] = new TBJBetSpot(PModeWin,FM);return BetSpot[0];
		case 34 : BetSpot[1] = new TBJBetSpot(PModeWin,FM);return BetSpot[1];
		case 35 : BetSpot[2] = new TBJBetSpot(PModeWin,FM);return BetSpot[2];
		case 36 : BetSpot[3] = new TBJBetSpot(PModeWin,FM);return BetSpot[3];
      case 37 : BetSpot[4] = new TBJBetSpot(PModeWin,FM);return BetSpot[4];
		case 38 : BetSpot[5] = new TBJBetSpot(PModeWin,FM);return BetSpot[5];
		case 39 : BetSpot[6] = new TBJBetSpot(PModeWin,FM);return BetSpot[6];
		case 40 : DealerSpot = new TBJDealerSpot(PModeWin,FM);return DealerSpot;
		case 41 : Chips = new TCasChips(PModeWin,FM);return Chips;default : return new TSprite(PModeWin,FM);
	 }
  }
}
//*******************************************************************
void TCasinoBJGameLord::FreezeAllButtons()
{
  Button0->Freeze = true;
  Button1->Freeze = true;
  Button2->Freeze = true;
  Button3->Freeze = true;
  Button4->Freeze = true;
  Button5->Freeze = true;
  Button6->Freeze = true;
  Button7->Freeze = true;
  Button8->Freeze = true;
  Button9->Freeze = true;
  Button10->Freeze = true;
  Button11->Freeze = true;
  Button12->Freeze = true;
  Button13->Freeze = true;
  Button14->Freeze = true;
  Button15->Freeze = true;
  Button16->Freeze = true;
  Button17->Freeze = true;
  Button18->Freeze = true;
}
//*******************************************************************
void TCasinoBJGameLord::UnFreezeAllButtons()
{
  Button0->Freeze = false;
  Button1->Freeze = false;
  Button2->Freeze = false;
  Button3->Freeze = false;
  Button4->Freeze = false;
  Button5->Freeze = false;
  Button6->Freeze = false;
  Button7->Freeze = false;
  Button8->Freeze = false;
  Button9->Freeze = false;
  Button10->Freeze = false;
  Button11->Freeze = false;
  Button12->Freeze = false;
  Button13->Freeze = false;
  Button14->Freeze = false;
  Button15->Freeze = false;
  Button16->Freeze = false;
  Button17->Freeze = false;
  Button18->Freeze = false;

}
//*******************************************************************
int16 TCasinoBJGameLord::PlayerTotal()
{
  for(int16 i=4;i<22;i++)
  {
	 if(PlayerHas(i) == 1){return(i);}
  }
  for(int16 i=12;i<21;i++)
  {
	 if(PlayerHasSoft(i) == 1){return int16(i+10);}
  }
  return 31;//bust
}
//*******************************************************************
int16 TCasinoBJGameLord::DealerTotal()
{
  for(int16 i=4;i<22;i++)
  {
	 if(DealerHas(i) == 1){return int16(i+28);}
  }
  return 50;//dealer bust
}
//*******************************************************************
bool TCasinoBJGameLord::GetCards(dword &StartFUC,dword &FUCLength,int16 &Remove,int16 &Show)
{
  switch(LookingAt)
  {
	 case bjnl1A : Remove = 6;Show = 13;return ChooseStartSkit(getcards1,StartFUC,FUCLength);
	 case bjnl1B : Remove = 6;Show = 13;return ChooseStartSkit(getcards1,StartFUC,FUCLength);
	 case bjnl1C : Remove = 6;Show = 13;return ChooseStartSkit(getcards1,StartFUC,FUCLength);
	 case bjnl2C : Remove = 5;Show = 12;return ChooseStartSkit(getcards2,StartFUC,FUCLength);
	 case bjnl2D : Remove = 5;Show = 12;return ChooseStartSkit(getcards2,StartFUC,FUCLength);
	 case bjnl2E : Remove = 5;Show = 12;return ChooseStartSkit(getcards2,StartFUC,FUCLength);
	 case bjnl3E : Remove = 6;Show = 11;return ChooseStartSkit(getcards3,StartFUC,FUCLength);
	 case bjnl3F : Remove = 6;Show = 11;return ChooseStartSkit(getcards3,StartFUC,FUCLength);
	 case bjnl3G : Remove = 6;Show = 11;return ChooseStartSkit(getcards3,StartFUC,FUCLength);
  }
  // MRP 12/21/96
  // shouldn't hit this.
  assert(false);
  return false;
}
//*******************************************************************
void TCasinoBJGameLord::EnableButton(int16 button)
{
  switch(button)
  {
	 case 0  : Button0->Enabled = true;break;
	 case 1  : Button1->Enabled = true;break;
	 case 2  : Button2->Enabled = true;break;
	 case 3  : Button3->Enabled = true;break;
	 case 4  : Button4->Enabled = true;break;
	 case 5  : Button5->Enabled = true;break;
	 case 6  : Button6->Enabled = true;break;
	 case 7  : Button7->Enabled = true;break;
	 case 8  : Button8->Enabled = true;break;
	 case 9  : Button9->Enabled = true;break;
	 case 10 : Button10->Enabled = true;break;
	 case 11 : Button11->Enabled = true;break;
	 case 12 : Button12->Enabled = true;break;
	 case 13 : Button13->Enabled = true;break;
	 case 14 : Button14->Enabled = true;break;
	 case 15 : Button15->Enabled = true;break;
	 case 16 : Button16->Enabled = true;break;
	 case 17 : Button17->Enabled = true;break;
	 case 18 : Button18->Enabled = true;break;
  }
}
//*******************************************************************
void TCasinoBJGameLord::DisEnableButton(int16 button)
{
  switch(button)
  {
	 case 0  : Button0->Enabled = false;break;
	 case 1  : Button1->Enabled = false;break;
	 case 2  : Button2->Enabled = false;break;
	 case 3  : Button3->Enabled = false;break;
	 case 4  : Button4->Enabled = false;break;
	 case 5  : Button5->Enabled = false;break;
	 case 6  : Button6->Enabled = false;break;
	 case 7  : Button7->Enabled = false;break;
	 case 8  : Button8->Enabled = false;break;
	 case 9  : Button9->Enabled = false;break;
	 case 10 : Button10->Enabled = false;break;
	 case 11 : Button11->Enabled = false;break;
	 case 12 : Button12->Enabled = false;break;
	 case 13 : Button13->Enabled = false;break;
	 case 14 : Button14->Enabled = false;break;
	 case 15 : Button15->Enabled = false;break;
	 case 16 : Button16->Enabled = false;break;
	 case 17 : Button17->Enabled = false;break;
	 case 18 : Button18->Enabled = false;break;
  }
}
//*******************************************************************
void TCasinoBJGameLord::EnableAllButtons()
{
  Button0->Enabled = true;
  Button1->Enabled = true;
  Button2->Enabled = true;
  Button3->Enabled = true;
  Button4->Enabled = true;
  Button5->Enabled = true;
  Button6->Enabled = true;
  Button7->Enabled = true;
  Button8->Enabled = true;
  Button9->Enabled = true;
  Button10->Enabled = true;
  Button11->Enabled = true;
  Button12->Enabled = true;
  Button13->Enabled = true;
  Button14->Enabled = true;
  Button15->Enabled = true;
  Button16->Enabled = true;
  Button17->Enabled = true;
  Button18->Enabled = true;
}
//*******************************************************************
void TCasinoBJGameLord::DisEnableAllButtons()
{
  Button0->Enabled = false;
  Button1->Enabled = false;
  Button2->Enabled = false;
  Button3->Enabled = false;
  Button4->Enabled = false;
  Button5->Enabled = false;
  Button6->Enabled = false;
  Button7->Enabled = false;
  Button8->Enabled = false;
  Button9->Enabled = false;
  Button10->Enabled = false;
  Button11->Enabled = false;
  Button12->Enabled = false;
  Button13->Enabled = false;
  Button14->Enabled = false;
  Button15->Enabled = false;
  Button16->Enabled = false;
  Button17->Enabled = false;
  Button18->Enabled = false;
}
//*******************************************************************
#pragma argsused
bool TCasinoBJGameLord::Respond(int16 button,int16 info,void *pdata)
{
  if(info == -5)//gray button hit
  {
	 if(shutdownstate == 0){return false;}
	 if(button == bjidButton12 || button == bjidButton13 ||
		 button == bjidButton14 || button == bjidButton18   )
	 {
		switch(button)
		{
		  case bjidButton12 : if(GetCash(activeplayer) == 0)
									 {
										if(GetCasPD(activeplayer)->IsActiveKenoTicket())
										{
										  PModeWin->MessageBox("You're out of money and may not bet. Your only hope is that one of your Keno tickets pays off.","Out of Cash",MB_OK);
										}
										else
										{
										  PModeWin->MessageBox("You've hit rock bottom. Your gambler is bankrupt. Select Create/Delete under the FILE menu to create or select a new gambler.","Bankrupt!",MB_OK);
										}
									 }
									 break;
		  case bjidButton13 : if(GetCash(activeplayer) == 0)
									 {
										PModeWin->MessageBox("You're out of money and may not split.","Out of Cash",MB_OK);
									 }
									 else
									 {
										int32 betCash=0;
										switch(LookingAt)
										{
										  case bjnl1A : betCash = GetBJPlayer(activeplayer)->coinsplayedhand0;break;
										  case bjnl1B : betCash = GetBJPlayer(activeplayer)->coinsplayedhand1;break;
										  case bjnl1C : betCash = GetBJPlayer(activeplayer)->coinsplayedhand2;break;
										  case bjnl2C : betCash = GetBJPlayer(activeplayer)->coinsplayedhand2;break;
										  case bjnl2D : betCash = GetBJPlayer(activeplayer)->coinsplayedhand3;break;
										  case bjnl2E : betCash = GetBJPlayer(activeplayer)->coinsplayedhand4;break;
										  case bjnl3E : betCash = GetBJPlayer(activeplayer)->coinsplayedhand4;break;
										  case bjnl3F : betCash = GetBJPlayer(activeplayer)->coinsplayedhand5;break;
										  case bjnl3G : betCash = GetBJPlayer(activeplayer)->coinsplayedhand6;break;
										}
										if(GetCash(activeplayer) < betCash)
										{
										  PModeWin->MessageBox("You don't have enough money to split.","Not enough Cash",MB_OK);
										}
									 }
									 break;
		  case bjidButton14 : if(GetCash(activeplayer) == 0)
									 {
										PModeWin->MessageBox("You're out of money and may not double down.","Out of Cash",MB_OK);
									 }
									 break;
		  case bjidButton18 : if(GetCash(activeplayer) == 0)
									 {
										PModeWin->MessageBox("You're out of money and may not buy insurance.","Out of Cash",MB_OK);
									 }
									 break;
		}
	 }
	 return true;
  }
  ButtonInfo = info;
  if(info != -1)
  {
	 switch(button)
	 {
	 case bjidButton0  : ButtonHit[bjidButton0]=true;break;
	 case bjidButton1  : TCmMsg(CM_ASKEXPERTSTATISTICS).PostToFW();ButtonHit[bjidButton1]=true;break;
	 case bjidButton2  : ButtonHit[bjidButton2]=true;break;
	 case bjidButton3  : ButtonHit[bjidButton3]=true;break;
	 case bjidButton4  : ButtonHit[bjidButton4]=true;break;
	 case bjidButton5  : ButtonHit[bjidButton5]=true;break;
	 case bjidButton6  : ButtonHit[bjidButton6]=true;break;
	 case bjidButton7  : ButtonHit[bjidButton7]=true;break;
	 case bjidButton8  : ButtonHit[bjidButton8]=true;break;
	 case bjidButton9  : ButtonHit[bjidButton9]=true;break;
	 case bjidButton10 : ButtonHit[bjidButton10]=true;break;
	 case bjidButton11 : ButtonHit[bjidButton11]=true;break;
	 case bjidButton12 : ButtonHit[bjidButton12]=true;break;
	 case bjidButton13 : ButtonHit[bjidButton13]=true;break;
	 case bjidButton14 : ButtonHit[bjidButton14]=true;break;
	 case bjidButton15 : ButtonHit[bjidButton15]=true;break;
	 case bjidButton16 : ButtonHit[bjidButton16]=true;break;
	 case bjidButton17 : ButtonHit[bjidButton17]=true;break;
	 case bjidButton18 : ButtonHit[bjidButton18]=true;break;
	 default           : WaitOnButtonDown = false;break;
	 }
#ifdef DEBUGCRITERIA
/*  if(button == bjidButton2)
  {
	 int crynum=0,cryanswer=0;
	 PModeWin->SetUpdatePause();
	 char criterianum[3] = "";
	 char cryer[10] = "";
	 TInputDialog getcriteria(PModeWin,"","criteria number",criterianum,3);
	 getcriteria.Execute();
	 crynum = atoi(criterianum);
	 cryanswer = AskCriteriaQuestion(crynum);
	 itoa(cryanswer,cryer,10);
	 PModeWin->MessageBox(cryer,criterianum,MB_OK);
	 PModeWin->ClearUpdatePause();
  }                       */
  if(button == bjidButton2)
  {
	 int i,x=0;
	 char retval[5];
	 char question[7];
	 string CriteriaReport;
	 for(i=0;i<130;i++)
	 {
		x = AskCriteriaQuestion(i);
		itoa(x,retval,10);
		itoa(i,question,10);
		CriteriaReport += question;
		CriteriaReport += "-> ";
		CriteriaReport += retval;
		if(x < 0)     {CriteriaReport += "                                                ";}
		else          {CriteriaReport += "                                                 ";}
		if(i<9)       {CriteriaReport += "  ";}
		else if(i<100){CriteriaReport += " ";}
	 }
	 GetFW()->DisplayExpert(CriteriaReport);
  }
#endif

  }
  return true;
}
//*******************************************************************
void TCasinoBJGameLord::ButtonClear(int16 button)
{
  switch(button)
  {
	 case bjidButton0  : ButtonHit[bjidButton0]=false;break;
	 case bjidButton1  : ButtonHit[bjidButton1]=false;break;
	 case bjidButton2  : ButtonHit[bjidButton2]=false;GetFW()->CmShowMenu();break;
	 case bjidButton3  : ButtonHit[bjidButton3]=false;PModeWin->ModeHelp();break;
	 case bjidButton4  : ButtonHit[bjidButton4]=false;break;
	 case bjidButton5  : ButtonHit[bjidButton5]=false;break;
	 case bjidButton6  : ButtonHit[bjidButton6]=false;break;
	 case bjidButton7  : ButtonHit[bjidButton7]=false;break;
	 case bjidButton8  : ButtonHit[bjidButton8]=false;break;
	 case bjidButton9  : ButtonHit[bjidButton9]=false;break;
	 case bjidButton10 : ButtonHit[bjidButton10]=false;break;
	 case bjidButton11 : ButtonHit[bjidButton11]=false;break;
	 case bjidButton12 : ButtonHit[bjidButton12]=false;break;
	 case bjidButton13 : ButtonHit[bjidButton13]=false;
								if(GetCash(activeplayer) < GetBJPlayer(activeplayer)->lastbet)
								{
								  GetBJPlayer(activeplayer)->lastbet = GetCash(activeplayer);
								  BetAmountDisplay->SetNum(GetBJPlayer(activeplayer)->lastbet);
								}
								break;
	 case bjidButton14 : ButtonHit[bjidButton14]=false;
								if(GetCash(activeplayer) < GetBJPlayer(activeplayer)->lastbet)
								{
								  GetBJPlayer(activeplayer)->lastbet = GetCash(activeplayer);
								  BetAmountDisplay->SetNum(GetBJPlayer(activeplayer)->lastbet);
								}
								break;
	 case bjidButton15 : ButtonHit[bjidButton15]=false;break;
	 case bjidButton16 : ButtonHit[bjidButton16]=false;break;
	 case bjidButton17 : ButtonHit[bjidButton17]=false;break;
	 case bjidButton18 : ButtonHit[bjidButton18]=false;break;
	 default           : WaitOnButtonDown = false;break;
  }
  WaitOnButtonDown = false;
  return;
}
//*******************************************************************
void TCasinoBJGameLord::CleanupResponders()
{
  for(int16 i=0;i<NumResponders;i++)
  {
	 delete Responders[i];
  }
}
//*******************************************************************
bool TCasinoBJGameLord::DealerBJ(dword &StartFUC,dword &FUCLength,int16 &RemoveBack,int16 &ShowFace)
{
  ALLHANDSWON = false;
  bool retValue = false;
  int16 dbjIndex=-1;

  retValue = ChooseStartSkit(dealerbj,StartFUC,FUCLength,dbjIndex);
  switch(BJSkitIndex[dbjIndex])
  {
	 case 0  : RemoveBack=13;ShowFace=17;break;
	 case 1  : RemoveBack=13;ShowFace=17;break;
	 case 2  : RemoveBack=7;ShowFace=11;break;
	 case 3  : RemoveBack=8;ShowFace=12;break;
	 case 4  : RemoveBack=8;ShowFace=12;break;
	 case 5  : RemoveBack=2;ShowFace=6;break;
	 case 6  : RemoveBack=2;ShowFace=6;break;
	 case 7  : RemoveBack=2;ShowFace=6;break;
	 case 8  : RemoveBack=2;ShowFace=6;break;
	 case 9  : RemoveBack=2;ShowFace=6;break;
	 case 10 : RemoveBack=2;ShowFace=6;break;
	 default : RemoveBack=2;ShowFace=6;break;
  }
  return retValue;
}
//*******************************************************************
bool TCasinoBJGameLord::Respond(TResponder &responder)
{
  if (PState == NULL) {return true;}

  switch (responder.GetID())
  {
	 case bjidBetSpot1   :  if(responder.GetResponseEvent() == reLeaveArea)
									{
									  GetOgleApp()->GetCursorMgr()->SetCursor(ctAction,0,0);
									  return true;
									}
									else if(responder.GetResponseEvent() == reEnterArea)
									{
									  if(coinsplayed > 0 && PlaceBetsMode &&
										 (BetSpotUse[1] == -1 ||
										  BetSpotUse[1] == activeplayer)     )
									  {
										 GetOgleApp()->GetCursorMgr()->SetCursor(ctAction,GetOgleApp(),ID_WHITE_CHIPS_CURSOR);
									  }
									  else if(!PlaceBetsMode && BetSpotUse[1] == activeplayer)
									  {
										 GetOgleApp()->GetCursorMgr()->SetCursor(ctAction,GetOgleApp(),ID_WHITE_REMOVE_CURSOR);
									  }
									  else if(coinsplayed == 0 && GetBJPlayer(activeplayer)->lastbet > 0 &&
												 GetBJPlayer(activeplayer)->lastbet <= GetCash(activeplayer) &&
												 PlaceBetsMode &&
												(BetSpotUse[1] == -1 ||
												 BetSpotUse[1] == activeplayer)     )
									  {
										 GetOgleApp()->GetCursorMgr()->SetCursor(ctAction,GetOgleApp(),ID_WHITE_CHIPS_CURSOR);
									  }
									  else
									  {
										 if((coinsplayed > 0 ||
											 (GetBJPlayer(activeplayer)->lastbet > 0 &&
											  GetBJPlayer(activeplayer)->lastbet <= GetCash(activeplayer))) &&
											  PlaceBetsMode)
										 {
											GetOgleApp()->GetCursorMgr()->SetCursor(ctAction,GetOgleApp(),ID_BLACK_CHIPS_CURSOR);
										 }
										 else if(!PlaceBetsMode)
										 {
											GetOgleApp()->GetCursorMgr()->SetCursor(ctAction,GetOgleApp(),ID_BLACK_REMOVE_CURSOR);
										 }
									  }
									  return true;
									}
									return (((TBJLordState *)PState)->BetSpot1(responder));
	 case bjidBetSpot2   :  if(responder.GetResponseEvent() == reLeaveArea)
									{
									  GetOgleApp()->GetCursorMgr()->SetCursor(ctAction,0,0);
									  return true;
									}
									else if(responder.GetResponseEvent() == reEnterArea)
									{
									  if(coinsplayed > 0 && PlaceBetsMode &&
										 (BetSpotUse[3] == -1 ||
										  BetSpotUse[3] == activeplayer)     )
									  {
										 GetOgleApp()->GetCursorMgr()->SetCursor(ctAction,GetOgleApp(),ID_WHITE_CHIPS_CURSOR);
									  }
									  else if(!PlaceBetsMode && BetSpotUse[3] == activeplayer)
									  {
										 GetOgleApp()->GetCursorMgr()->SetCursor(ctAction,GetOgleApp(),ID_WHITE_REMOVE_CURSOR);
									  }
									  else if(coinsplayed == 0 && GetBJPlayer(activeplayer)->lastbet > 0 &&
												 GetBJPlayer(activeplayer)->lastbet <= GetCash(activeplayer) &&
												 PlaceBetsMode &&
												(BetSpotUse[3] == -1 ||
												 BetSpotUse[3] == activeplayer)     )
									  {
										 GetOgleApp()->GetCursorMgr()->SetCursor(ctAction,GetOgleApp(),ID_WHITE_CHIPS_CURSOR);
									  }
									  else
									  {
                               if((coinsplayed > 0 ||
											 (GetBJPlayer(activeplayer)->lastbet > 0 &&
											  GetBJPlayer(activeplayer)->lastbet <= GetCash(activeplayer))) &&
											  PlaceBetsMode)
										 {
											GetOgleApp()->GetCursorMgr()->SetCursor(ctAction,GetOgleApp(),ID_BLACK_CHIPS_CURSOR);
										 }
										 else if(!PlaceBetsMode)
										 {
											GetOgleApp()->GetCursorMgr()->SetCursor(ctAction,GetOgleApp(),ID_BLACK_REMOVE_CURSOR);
										 }
									  }
									  return true;
									}
									return (((TBJLordState *)PState)->BetSpot2(responder));
	 case bjidBetSpot3   :  if(responder.GetResponseEvent() == reLeaveArea)
									{
									  GetOgleApp()->GetCursorMgr()->SetCursor(ctAction,0,0);
									  return true;
									}
									else if(responder.GetResponseEvent() == reEnterArea)
									{
									  if(coinsplayed > 0 && PlaceBetsMode &&
										 (BetSpotUse[5] == -1 ||
										  BetSpotUse[5] == activeplayer)     )
									  {
										 GetOgleApp()->GetCursorMgr()->SetCursor(ctAction,GetOgleApp(),ID_WHITE_CHIPS_CURSOR);
									  }
									  else if(!PlaceBetsMode && BetSpotUse[5] == activeplayer)
									  {
										 GetOgleApp()->GetCursorMgr()->SetCursor(ctAction,GetOgleApp(),ID_WHITE_REMOVE_CURSOR);
									  }
									  else if(coinsplayed == 0 && GetBJPlayer(activeplayer)->lastbet > 0 &&
												 GetBJPlayer(activeplayer)->lastbet <= GetCash(activeplayer) &&
												 PlaceBetsMode &&
												(BetSpotUse[5] == -1 ||
												 BetSpotUse[5] == activeplayer)     )
									  {
										 GetOgleApp()->GetCursorMgr()->SetCursor(ctAction,GetOgleApp(),ID_WHITE_CHIPS_CURSOR);
									  }
									  else
									  {
										 if((coinsplayed > 0 ||
											 (GetBJPlayer(activeplayer)->lastbet > 0 &&
											  GetBJPlayer(activeplayer)->lastbet <= GetCash(activeplayer))) &&
											  PlaceBetsMode)
										 {
											GetOgleApp()->GetCursorMgr()->SetCursor(ctAction,GetOgleApp(),ID_BLACK_CHIPS_CURSOR);
										 }
										 else if(!PlaceBetsMode)
										 {
											GetOgleApp()->GetCursorMgr()->SetCursor(ctAction,GetOgleApp(),ID_BLACK_REMOVE_CURSOR);
										 }
									  }
									  return true;
									}
									return (((TBJLordState *)PState)->BetSpot3(responder));
	 case bjidNamePlate  :  return (((TBJLordState *)PState)->NamePlate(responder));
	 case bjidFeltCursor :  if(responder.GetResponseEvent() == reLeaveArea)
									{
									  GetOgleApp()->GetCursorMgr()->SetCursor(ctAction,0,0);
									}
									else if(responder.GetResponseEvent() == reEnterArea)
									{
									  if((coinsplayed > 0 ||
										  (GetBJPlayer(activeplayer)->lastbet > 0 &&
											GetBJPlayer(activeplayer)->lastbet <= GetCash(activeplayer))) &&
											PlaceBetsMode)
									  {
										 GetOgleApp()->GetCursorMgr()->SetCursor(ctAction,GetOgleApp(),ID_BLACK_CHIPS_CURSOR);
									  }
									  else if(!PlaceBetsMode)
									  {
										 GetOgleApp()->GetCursorMgr()->SetCursor(ctAction,GetOgleApp(),ID_BLACK_REMOVE_CURSOR);
									  }
									}
									return true;
	 default             :  return true;
  }
}
//*******************************************************************
void TCasinoBJGameLord::SetupResponders()
{
  Responders[0]  = NULL;
  Responders[1]  = NULL;
  Responders[2]  = NULL;
  Responders[3]  = NULL;
  Responders[4]  = NULL;
  Responders[0]  = new TResponder(PModeWin,100,TRect(463,386,569,428),bjidBetSpot1  ,this,true,'3');
  Responders[1]  = new TResponder(PModeWin,100,TRect(272,388,359,427),bjidBetSpot2  ,this,true,'2');
  Responders[2]  = new TResponder(PModeWin,100,TRect(59,383,169,428) ,bjidBetSpot3  ,this,true,'1');
  Responders[3]  = new TResponder(PModeWin,100,TRect(260,465,375,477),bjidNamePlate ,this,true,VK_TAB,TCursorData(GetOgleApp(),ID_POINTING_FINGER_CURSOR));
  Responders[4]  = new TResponder(PModeWin,50,TRect(1,262,635,428),bjidFeltCursor,this,true);

}
//*******************************************************************
TCasinoBJGameLord::TCasinoBJGameLord(TBlackJackModeWin *pmwin,const TFileMode &fm)
:TCasinoGameLord(pmwin,fm,pmwin->GetNumDecks(),TMoney::did_1_00)//cd1)
{
  randomize();
  Rack       = NULL;Sign       = NULL;Dealer     = NULL;DealerSpot = NULL;
  BetSpot[0] = NULL;BetSpot[1] = NULL;BetSpot[2] = NULL;BetSpot[3] = NULL;
  BetSpot[4] = NULL;BetSpot[5] = NULL;BetSpot[6] = NULL;
  BJSounds = NULL;Chips = NULL;NamePlate1 = NULL;NamePlate2 = NULL;
  NamePlate3 = NULL;Circle1 = NULL;Circle2 = NULL;Circle3 = NULL;
  Button0 = NULL;Button1 = NULL;Button2 = NULL;Button3 = NULL;
  Button4 = NULL;Button5 = NULL;Button6 = NULL;Button7 = NULL;
  Button8 = NULL;Button9 = NULL;Button10 = NULL;Button11 = NULL;
  Button12 = NULL;Button13 = NULL;Button14 = NULL;Button15 = NULL;
  Button16 = NULL;Button17 = NULL;Button18 = NULL;
  MessageDisplay   = NULL;
  BankCashDisplay  = NULL;
  BetAmountDisplay = NULL;
  splitwait = false;

  PlaceBetsMode = true;
  PState        = new TBJLordMainState(this);
//  numofdecks = pmwin->GetNumDecks(); // get starting num of decks from modewin.
  numofdecks = SubGameType;
  pDeck         = new TBJDeck(numofdecks);
  pSmarts       = new TBJSmarts;
  pHand         = new TBJHand;
  pAskExpert    = new TBJAsk(this);
  SwitchDeckNowFlag = false;
//  numofdecks       = gtDeck1*52;    //gametype;
//  numofdecks = pmwin->GetNumDecks(); // get starting num of decks from modewin.
  numofdecks *= int16(52);

  ((TBJDeck *)pDeck)->InitDeck(numofdecks);
  for(int16 i=0;i<7;i++)
  {
	 BetSpotUse[i] = -1;
  }
  ALLHANDSWON      = true;
  LookingAt        = bjnl0D;
  pMWin            = pmwin;
  pDeck->Shuffler(numofdecks );
  maxbet           = 3;
  credits          = 0;
  coinsize         = GameDenom;
  activeplayer     = -1;
  machinenum       = 0;
  playersin        = 1;
//  game             = gtDeck1;  //gametype;
//  game             = pmwin->GetNumDecks();
  coinsplayed      = 0;
//  totaldecks       = 1;
//  totaldecks       = pmwin->GetNumDecks();
  totaldecks       = SubGameType;
  halfdecksplayed  = 0;
  halfdecksleft    = int16((numofdecks*2)/52);
  truecount        = 0;
  runningcount     = 0;
  StartTC          = 0;
  acecount         = 0;
  cardsplayed      = 0;
  newdeal          = 0;
  decksflag        = 0;
  newdeckcount     = DECK;
  shutdownstate    = 0;
  ButtonInfo = 0;
  StallsInRow = 0;
  InsuranceBetMade = false;
  ALLPREVIOUSHANDSWON = false;
  ThreeBets = 0;
  ThreePreviousBets = 0;
  for(int16 i=0;i<NUMOFBUTTONS;i++)
  {
    ButtonHit[i] = false;
  }
  for(int16 i=0;i<11;i++)
  {
	 BJSkitIndex[i] = -1;
  }
  #ifdef DEBUGIDLES
  DealerPos = NULL;
  Pos1 = NULL;
  Pos2 = NULL;
  Pos3 = NULL;
  #endif
  SetupResponders();
}
//*******************************************************************
TCasinoBJGameLord::~TCasinoBJGameLord()
{
  DestroyState();

  delete pSmarts;
  pSmarts = NULL;
  delete pDeck;
  pDeck = NULL;
  delete pAskExpert;
  pAskExpert = NULL;
  delete pHand;
  pHand = NULL;
  CleanupResponders();
}
//*******************************************************************
void  TCasinoBJGameLord::ShuttingDown()
{
  for(int16 i=0;i<3;i++)
  {
	 if(GetCasPD(i))
	 {
		int16 session = GetCasPD(i)->BJData.CurrentSession;
      TCBJSession &cs = GetCasPD(i)->BJData.Sessions[session];

		if(cs.PeakWin < GetCash(i))
		{
        cs.PeakWin = GetCash(i);
      }
		if(cs.PeakLoss > GetCash(i))
		{
        cs.PeakLoss = GetCash(i);
      }
	 }
  }
  if(shutdownstate == 0)
  {
	 if(GetCasPD(0))
	 {
		NotifyPlayerDeActivation(0);
	 }
	 if(GetCasPD(1))
	 {
		NotifyPlayerDeActivation(1);
	 }
	 if(GetCasPD(2))
	 {
		NotifyPlayerDeActivation(2);
	 }
  }
  else if(shutdownstate == 1)
  {
	 if(GetCasPD(0))
	 {
		GetCasPD(0)->EndBJSession();
	 }
	 if(GetCasPD(1))
	 {
		GetCasPD(1)->EndBJSession();
	 }
	 if(GetCasPD(2))
	 {
		GetCasPD(2)->EndBJSession();
	 }
  }

}
//*******************************************************************
void  TCasinoBJGameLord::SwitchToPlayer(int16 player)
{
  if(GetCasPD(player))
  {
	 if(activeplayer != player && activeplayer != -1)
	 {
	  //	GetCasPD(activeplayer)->Cash += coinsplayed;
		coinsplayed = 0;
		GetBJPlayer(activeplayer)->coinsplayed = 0;
		GetCasPD(activeplayer)->Columns[0] = Chips->col1;
		GetCasPD(activeplayer)->Columns[1] = Chips->col2;
		GetCasPD(activeplayer)->Columns[2] = Chips->col3;
		GetCasPD(activeplayer)->Columns[3] = Chips->col4;
		GetCasPD(activeplayer)->Columns[4] = Chips->col5;
		GetCasPD(activeplayer)->Columns[5] = Chips->col6;
	 }

	 if(activeplayer != player)
	 {
		switch(activeplayer)
		{
			 case 0 : NamePlate1->NoShowNamePlate();break;
			 case 1 : NamePlate2->NoShowNamePlate();break;
			 case 2 : NamePlate3->NoShowNamePlate();break;
		}
		activeplayer = player;
		if(!BetMade(activeplayer)){Button5->ShowGray();}
		else{Button5->ShowVoidUp();}
		if(GetCash(activeplayer) > GetBJPlayer(activeplayer)->lastbet)
		{
		  coinsplayed += GetBJPlayer(activeplayer)->lastbet;
		  GetBJPlayer(activeplayer)->coinsplayed += GetBJPlayer(activeplayer)->lastbet;
		  BetAmountDisplay->SetNum(GetBJPlayer(activeplayer)->lastbet);
		  //BetUnitChips->SetNum(GetBJPlayer(activeplayer)->lastbet);
		}
		else
		{
		  coinsplayed = 0;
		  GetBJPlayer(activeplayer)->coinsplayed = 0;
		  GetBJPlayer(activeplayer)->lastbet = 0;
		  BetAmountDisplay->SetNum(0);
	  //	  BetUnitChips->SetNum(0);
		}
		BankCashDisplay->SetNum(GetCash(activeplayer));
		Chips->SetupCols(GetCasPD(player)->Cash,GetCasPD(player)->Columns[0],
						  GetCasPD(player)->Columns[1],GetCasPD(player)->Columns[2],
						  GetCasPD(player)->Columns[3],GetCasPD(player)->Columns[4],
						  GetCasPD(player)->Columns[5],false);
		if(GetNumActivePlayers() > 1)
		{
		  string name;
		  name = GetCasPD(player)->GetName();
		  switch(player)
		  {
			 case 0 : NamePlate1->ShowNamePlateString(name);break;
			 case 1 : NamePlate2->ShowNamePlateString(name);break;
			 case 2 : NamePlate3->ShowNamePlateString(name);break;
		  }
		}
	 }
  }
}
//*******************************************************************
void  TCasinoBJGameLord::CyclePlayers()
{
  if(activeplayer != -1)
  {
	 SwitchToPlayer(NextSlotNum(activeplayer));
  }
}
//*******************************************************************
void TCasinoBJGameLord::NotifyPlayerActivation(int16 slotnum)
{
  if(GetCasPD(slotnum))
  {
	 GetCasPD(slotnum)->StartBJSession(SubGameType,GameDenom);
//	 int session = GetCasPD(slotnum)->BJData.CurrentSession;
//	 GetCasPD(slotnum)->BJData.Sessions[session].GameName = (TGameName)game;
	 if(GetCash(slotnum) >= 5)
	 {
		GetBJPlayer(slotnum)->lastbet = 5;
	 }
	 if(activeplayer == -1)
	 {
	  activeplayer = slotnum;
	  Button5->ShowGray();
	  Chips->SetupCols(GetCasPD(slotnum)->Cash,
                      GetCasPD(slotnum)->Columns[0],
						    GetCasPD(slotnum)->Columns[1],
                      GetCasPD(slotnum)->Columns[2],
						    GetCasPD(slotnum)->Columns[3],
                      GetCasPD(slotnum)->Columns[4],
						    GetCasPD(slotnum)->Columns[5],
                      false);
		string name;
		BankCashDisplay->SetNum(GetCash(activeplayer));
		BetAmountDisplay->SetNum(0);
		name = GetCasPD(slotnum)->GetName();
		switch(slotnum)
		  {
			 case 0 : NamePlate1->ShowNamePlateString(name);break;
			 case 1 : NamePlate2->ShowNamePlateString(name);break;
			 case 2 : NamePlate3->ShowNamePlateString(name);break;
		  }
	 }
	 //SetupSessionData(activeplayer);
  }
}
//*******************************************************************
void TCasinoBJGameLord::NotifyPlayerDeActivation(int16 slotnum)
{
  if(GetCasPD(slotnum))
  {
	 switch(slotnum)
	 {
			 case 0 : NamePlate1->NoShowNamePlate();break;
			 case 1 : NamePlate2->NoShowNamePlate();break;
			 case 2 : NamePlate3->NoShowNamePlate();break;
	 }
	 for(int16 i=0;i<7;i++)
	 {
		if(BetSpotUse[i] == slotnum)
		{
		  switch(i) {
			 case 0 : GetCasPD(slotnum)->Cash += GetBJPlayer(slotnum)->coinsplayedhand0;
						 BetSpotUse[0] = -1;
                   BetSpot[0]->NoShow();
                   break;
			 case 1 : GetCasPD(slotnum)->Cash += GetBJPlayer(slotnum)->coinsplayedhand1;
						 BetSpotUse[1] = -1;
                   BetSpot[1]->NoShow();
                   break;
			 case 2 : GetCasPD(slotnum)->Cash += GetBJPlayer(slotnum)->coinsplayedhand2;
						 BetSpotUse[2] = -1;
                   BetSpot[2]->NoShow();
                   break;
			 case 3 : GetCasPD(slotnum)->Cash += GetBJPlayer(slotnum)->coinsplayedhand3;
						 BetSpotUse[3] = -1;
                   BetSpot[3]->NoShow();
                   break;
			 case 4 : GetCasPD(slotnum)->Cash += GetBJPlayer(slotnum)->coinsplayedhand4;
						 BetSpotUse[4] = -1;
                   BetSpot[4]->NoShow();
                   break;
			 case 5 : GetCasPD(slotnum)->Cash += GetBJPlayer(slotnum)->coinsplayedhand5;
						 BetSpotUse[5] = -1;
                   BetSpot[5]->NoShow();
                   break;
			 case 6 : GetCasPD(slotnum)->Cash += GetBJPlayer(slotnum)->coinsplayedhand6;
						 BetSpotUse[6] = -1;
                   BetSpot[6]->NoShow();
                   break;
		  }
		}
	 }
	 if(activeplayer == slotnum)
	 {
		//GetCasPD(activeplayer)->Cash += coinsplayed;
		coinsplayed = 0;
		GetCasPD(slotnum)->Columns[0] = Chips->col1;
		GetCasPD(slotnum)->Columns[1] = Chips->col2;
		GetCasPD(slotnum)->Columns[2] = Chips->col3;
		GetCasPD(slotnum)->Columns[3] = Chips->col4;
		GetCasPD(slotnum)->Columns[4] = Chips->col5;
		GetCasPD(slotnum)->Columns[5] = Chips->col6;
	 }
	 if(GetNumActivePlayers() == 1)
	 {
		Chips->NoShow();
		Button5->ShowGray();
		NamePlate1->NoShow();NamePlate2->NoShow();NamePlate3->NoShow();
		coinsplayed = 0;
		if(GetBJPlayer(activeplayer))
		{
		  GetBJPlayer(activeplayer)->coinsplayed = 0;
		  GetBJPlayer(activeplayer)->lastbet = 0;
		}
		BetAmountDisplay->SetNum(0);
  //		BetUnitChips->SetNum(0);
		BankCashDisplay->SetNum(0);
		activeplayer = -1;
	 }
	 if(GetNumActivePlayers() > 1 && activeplayer == slotnum)
	 {
		int16 newplayer=-1;
		newplayer = NextSlotNum(slotnum);
		activeplayer = newplayer;
		if(!BetMade(activeplayer)){Button5->ShowGray();}
		else{Button5->ShowVoidUp();}

		Chips->SetupCols(GetCasPD(newplayer)->Cash,
                       GetCasPD(newplayer)->Columns[0],
							  GetCasPD(newplayer)->Columns[1],
                       GetCasPD(newplayer)->Columns[2],
							  GetCasPD(newplayer)->Columns[3],
                       GetCasPD(newplayer)->Columns[4],
							  GetCasPD(newplayer)->Columns[5],
                       false);
		string name;
		name = GetCasPD(newplayer)->GetName();
		if(GetCash(activeplayer) > GetBJPlayer(activeplayer)->lastbet)
		{
		  coinsplayed += GetBJPlayer(activeplayer)->lastbet;
		  GetBJPlayer(activeplayer)->coinsplayed += GetBJPlayer(activeplayer)->lastbet;
		  BetAmountDisplay->SetNum(GetBJPlayer(activeplayer)->lastbet);
		//  BetUnitChips->SetNum(GetBJPlayer(activeplayer)->lastbet);
		}
		else
		{
		  BetAmountDisplay->SetNum(0);
	  //	  BetUnitChips->SetNum(0);
		}
		BankCashDisplay->SetNum(GetCash(activeplayer));
		switch(newplayer)
		{
			 case 0 : NamePlate1->ShowNamePlateString(name);break;
			 case 1 : NamePlate2->ShowNamePlateString(name);break;
			 case 2 : NamePlate3->ShowNamePlateString(name);break;
		}

	 }
	 GetCasPD(slotnum)->EndBJSession();
  }
}
//*******************************************************************
void TCasinoBJGameLord::SetupActivePlayer(int16 slot)
{
  if(GetCasPD(slot))
  {
	 activeplayer = slot;
	 Chips->SetupCols(GetCasPD(slot)->Cash,
                     GetCasPD(slot)->Columns[0],
						   GetCasPD(slot)->Columns[1],
                     GetCasPD(slot)->Columns[2],
						   GetCasPD(slot)->Columns[3],
                     GetCasPD(slot)->Columns[4],
						   GetCasPD(slot)->Columns[5],
                     false);
	 if(GetNumActivePlayers() > 1)
	 {
		string name;
		name = GetCasPD(slot)->GetName();
		switch(slot)
		  {
			 case 0 : NamePlate1->ShowNamePlateString(name);break;
			 case 1 : NamePlate2->ShowNamePlateString(name);break;
			 case 2 : NamePlate3->ShowNamePlateString(name);break;
		  }
	 }
  }
}
//*******************************************************************
void TCasinoBJGameLord::AskBetExpert()
{
  pAskExpert->AskBetExpert();
}
//*******************************************************************
void TCasinoBJGameLord::AskFirstTwoCardsExpert(int16 handNum,bool show)
{
  switch(handNum)
  {
	 case 0 : ((TBJDeck *)pDeck)->Busted((TBJHand *)GetBJPlayer(activeplayer)->pHand0);
				 pAskExpert->AskFirstTwoCardsExpert((TBJHand *)GetBJPlayer(activeplayer)->pHand0,totaldecks,show);break;
	 case 1 : ((TBJDeck *)pDeck)->Busted((TBJHand *)GetBJPlayer(activeplayer)->pHand1);
				 pAskExpert->AskFirstTwoCardsExpert((TBJHand *)GetBJPlayer(activeplayer)->pHand1,totaldecks,show);break;
	 case 2 : ((TBJDeck *)pDeck)->Busted((TBJHand *)GetBJPlayer(activeplayer)->pHand2);
				 pAskExpert->AskFirstTwoCardsExpert((TBJHand *)GetBJPlayer(activeplayer)->pHand2,totaldecks,show);break;
	 case 3 : ((TBJDeck *)pDeck)->Busted((TBJHand *)GetBJPlayer(activeplayer)->pHand3);
				 pAskExpert->AskFirstTwoCardsExpert((TBJHand *)GetBJPlayer(activeplayer)->pHand3,totaldecks,show);break;
	 case 4 : ((TBJDeck *)pDeck)->Busted((TBJHand *)GetBJPlayer(activeplayer)->pHand4);
				 pAskExpert->AskFirstTwoCardsExpert((TBJHand *)GetBJPlayer(activeplayer)->pHand4,totaldecks,show);break;
	 case 5 : ((TBJDeck *)pDeck)->Busted((TBJHand *)GetBJPlayer(activeplayer)->pHand5);
				 pAskExpert->AskFirstTwoCardsExpert((TBJHand *)GetBJPlayer(activeplayer)->pHand5,totaldecks,show);break;
	 case 6 : ((TBJDeck *)pDeck)->Busted((TBJHand *)GetBJPlayer(activeplayer)->pHand6);
				 pAskExpert->AskFirstTwoCardsExpert((TBJHand *)GetBJPlayer(activeplayer)->pHand6,totaldecks,show);break;
  }
}
//*******************************************************************
void TCasinoBJGameLord::AskAfterFirstTwoCardsExpert(int16 handNum,bool show)
{
  switch(handNum){
	 case 0 : ((TBJDeck *)pDeck)->Busted((TBJHand *)GetBJPlayer(activeplayer)->pHand0);
				 pAskExpert->AskAfterFirstTwoCardsExpert((TBJHand *)GetBJPlayer(activeplayer)->pHand0,totaldecks,show);break;
	 case 1 : ((TBJDeck *)pDeck)->Busted((TBJHand *)GetBJPlayer(activeplayer)->pHand1);
				 pAskExpert->AskAfterFirstTwoCardsExpert((TBJHand *)GetBJPlayer(activeplayer)->pHand1,totaldecks,show);break;
	 case 2 : ((TBJDeck *)pDeck)->Busted((TBJHand *)GetBJPlayer(activeplayer)->pHand2);
				 pAskExpert->AskAfterFirstTwoCardsExpert((TBJHand *)GetBJPlayer(activeplayer)->pHand2,totaldecks,show);break;
	 case 3 : ((TBJDeck *)pDeck)->Busted((TBJHand *)GetBJPlayer(activeplayer)->pHand3);
				 pAskExpert->AskAfterFirstTwoCardsExpert((TBJHand *)GetBJPlayer(activeplayer)->pHand3,totaldecks,show);break;
	 case 4 : ((TBJDeck *)pDeck)->Busted((TBJHand *)GetBJPlayer(activeplayer)->pHand4);
				 pAskExpert->AskAfterFirstTwoCardsExpert((TBJHand *)GetBJPlayer(activeplayer)->pHand4,totaldecks,show);break;
	 case 5 : ((TBJDeck *)pDeck)->Busted((TBJHand *)GetBJPlayer(activeplayer)->pHand5);
				 pAskExpert->AskAfterFirstTwoCardsExpert((TBJHand *)GetBJPlayer(activeplayer)->pHand5,totaldecks,show);break;
	 case 6 : ((TBJDeck *)pDeck)->Busted((TBJHand *)GetBJPlayer(activeplayer)->pHand6);
				 pAskExpert->AskAfterFirstTwoCardsExpert((TBJHand *)GetBJPlayer(activeplayer)->pHand6,totaldecks,show);break;
  }
}
//*******************************************************************
int16 TCasinoBJGameLord::PlayerHas(int16 total)
{
  TBJHand *player;
  player = (TBJHand *)GetBJPlayer(activeplayer);
  if(player == NULL)
  {return -1;}
  switch(LookingAt) {
	case bjnl1A : if(((TBJHand *)GetBJPlayer(activeplayer)->pHand0)->highhand == total &&
						 (((TBJHand *)GetBJPlayer(activeplayer)->pHand0)->lohand   == total || total == 21))
					  {return 1;}
					  else
					  {return -1;}
	case bjnl1B : if(((TBJHand *)GetBJPlayer(activeplayer)->pHand1)->highhand == total &&
						  (((TBJHand *)GetBJPlayer(activeplayer)->pHand1)->lohand   == total || total == 21))
					  {return 1;}
					  else
					  {return -1;}
	case bjnl1C : if(((TBJHand *)GetBJPlayer(activeplayer)->pHand2)->highhand == total &&
						  (((TBJHand *)GetBJPlayer(activeplayer)->pHand2)->lohand   == total || total == 21))
					  {return 1;}
					  else
					  {return -1;}
	case bjnl2C : if(((TBJHand *)GetBJPlayer(activeplayer)->pHand2)->highhand == total &&
						  (((TBJHand *)GetBJPlayer(activeplayer)->pHand2)->lohand   == total || total == 21))
					  {return 1;}
					  else
					  {return -1;}
	case bjnl2D : //stuff = ((TBJHand *)GetBJPlayer(activeplayer)->pHand3)->lohand;
					  if(((TBJHand *)GetBJPlayer(activeplayer)->pHand3)->highhand == total &&
						  (((TBJHand *)GetBJPlayer(activeplayer)->pHand3)->lohand   == total || total == 21))
					  {return 1;}
					  else
					  {return -1;}
	case bjnl2E : if(((TBJHand *)GetBJPlayer(activeplayer)->pHand4)->highhand == total &&
						  (((TBJHand *)GetBJPlayer(activeplayer)->pHand4)->lohand   == total || total == 21))
					  {return 1;}
					  else
					  {return -1;}
	case bjnl3E : if(((TBJHand *)GetBJPlayer(activeplayer)->pHand4)->highhand == total &&
						  (((TBJHand *)GetBJPlayer(activeplayer)->pHand4)->lohand   == total || total == 21))
					  {return 1;}
					  else
					  {return -1;}
	case bjnl3F : if(((TBJHand *)GetBJPlayer(activeplayer)->pHand5)->highhand == total &&
						  (((TBJHand *)GetBJPlayer(activeplayer)->pHand5)->lohand   == total || total == 21))
					  {return 1;}
					  else
					  {return -1;}
	case bjnl3G : if(((TBJHand *)GetBJPlayer(activeplayer)->pHand6)->highhand == total &&
						  (((TBJHand *)GetBJPlayer(activeplayer)->pHand6)->lohand   == total || total == 21))
					  {return 1;}
					  else
					  {return -1;}
  }
  return 0;
}
//*******************************************************************
int16 TCasinoBJGameLord::PlayerBust()
{
  TBJHand *player;
  player = (TBJHand *)GetBJPlayer(activeplayer);
  if(player == NULL)
  {return -1;}
  ALLHANDSWON = false;
  switch(LookingAt) {
	case bjnl1A : if(GetBJPlayer(activeplayer)->pHand0 == NULL)
					  {return 1;}
					  else
					  {return -1;}
	case bjnl1B : if(GetBJPlayer(activeplayer)->pHand1 == NULL)
					  {return 1;}
					  else
					  {return -1;}
	case bjnl1C : if(GetBJPlayer(activeplayer)->pHand2 == NULL)
					  {return 1;}
					  else
					  {return -1;}
	case bjnl2C : if(GetBJPlayer(activeplayer)->pHand2 == NULL)
					  {return 1;}
					  else
					  {return -1;}
	case bjnl2D : if(GetBJPlayer(activeplayer)->pHand3 == NULL)
					  {return 1;}
					  else
					  {return -1;}
	case bjnl2E : if(GetBJPlayer(activeplayer)->pHand4 == NULL)
					  {return 1;}
					  else
					  {return -1;}
	case bjnl3E : if(GetBJPlayer(activeplayer)->pHand4 == NULL)
					  {return 1;}
					  else
					  {return -1;}
	case bjnl3F : if(GetBJPlayer(activeplayer)->pHand5 == NULL)
					  {return 1;}
					  else
					  {return -1;}
	case bjnl3G : if(GetBJPlayer(activeplayer)->pHand6 == NULL)
					  {return 1;}
					  else
					  {return -1;}
  }
  return 0;
}
//*******************************************************************
int16 TCasinoBJGameLord::PlayerHasSoft(int16 total)
{
  TBJHand *player;
  player = (TBJHand *)GetBJPlayer(activeplayer);
  if(player == NULL)
  {return -1;}

  switch(LookingAt) {
	case bjnl1A : if(((TBJHand *)GetBJPlayer(activeplayer)->pHand0)->lohand+10 == total &&
						  ((TBJHand *)GetBJPlayer(activeplayer)->pHand0)->lohand !=
						  ((TBJHand *)GetBJPlayer(activeplayer)->pHand0)->highhand)
					  {return 1;}
					  else
					  {return -1;}
	case bjnl1B : if(((TBJHand *)GetBJPlayer(activeplayer)->pHand1)->lohand+10 == total &&
						  ((TBJHand *)GetBJPlayer(activeplayer)->pHand1)->lohand !=
						  ((TBJHand *)GetBJPlayer(activeplayer)->pHand1)->highhand)
					  {return 1;}
					  else
					  {return -1;}
	case bjnl1C : if(((TBJHand *)GetBJPlayer(activeplayer)->pHand2)->lohand+10 == total &&
						  ((TBJHand *)GetBJPlayer(activeplayer)->pHand2)->lohand !=
						  ((TBJHand *)GetBJPlayer(activeplayer)->pHand2)->highhand)
					  {return 1;}
					  else
					  {return -1;}
	case bjnl2C : if(((TBJHand *)GetBJPlayer(activeplayer)->pHand2)->lohand+10 == total &&
						  ((TBJHand *)GetBJPlayer(activeplayer)->pHand2)->lohand !=
						  ((TBJHand *)GetBJPlayer(activeplayer)->pHand2)->highhand)
					  {return 1;}
					  else
					  {return -1;}
	case bjnl2D : if(((TBJHand *)GetBJPlayer(activeplayer)->pHand3)->lohand+10 == total &&
						  ((TBJHand *)GetBJPlayer(activeplayer)->pHand3)->lohand !=
						  ((TBJHand *)GetBJPlayer(activeplayer)->pHand3)->highhand)
					  {return 1;}
					  else
					  {return -1;}
	case bjnl2E : if(((TBJHand *)GetBJPlayer(activeplayer)->pHand4)->lohand+10 == total &&
						  ((TBJHand *)GetBJPlayer(activeplayer)->pHand4)->lohand !=
						  ((TBJHand *)GetBJPlayer(activeplayer)->pHand4)->highhand)
					  {return 1;}
					  else
					  {return -1;}
	case bjnl3E : if(((TBJHand *)GetBJPlayer(activeplayer)->pHand4)->lohand+10 == total &&
						  ((TBJHand *)GetBJPlayer(activeplayer)->pHand4)->lohand !=
						  ((TBJHand *)GetBJPlayer(activeplayer)->pHand4)->highhand)
					  {return 1;}
					  else
					  {return -1;}
	case bjnl3F : if(((TBJHand *)GetBJPlayer(activeplayer)->pHand5)->lohand+10 == total &&
						  ((TBJHand *)GetBJPlayer(activeplayer)->pHand5)->lohand !=
						  ((TBJHand *)GetBJPlayer(activeplayer)->pHand5)->highhand)
					  {return 1;}
					  else
					  {return -1;}
	case bjnl3G : if(((TBJHand *)GetBJPlayer(activeplayer)->pHand6)->lohand+10 == total &&
						  ((TBJHand *)GetBJPlayer(activeplayer)->pHand6)->lohand !=
						  ((TBJHand *)GetBJPlayer(activeplayer)->pHand6)->highhand)
					  {return 1;}
					  else
					  {return -1;}
  }
  return 0;
}
//*******************************************************************
int16 TCasinoBJGameLord::PlayerHas777()
{
  TBJHand *player;
  player = (TBJHand *)GetBJPlayer(activeplayer);
  if(player == NULL)
  {return -1;}

  switch(LookingAt) {
	case bjnl1A : if(((TBJHand *)GetBJPlayer(activeplayer)->pHand0)->inhand == 3 &&
						  ((TBJHand *)GetBJPlayer(activeplayer)->pHand0)->cards[0].name == Seven &&
						  ((TBJHand *)GetBJPlayer(activeplayer)->pHand0)->cards[1].name == Seven &&
						  ((TBJHand *)GetBJPlayer(activeplayer)->pHand0)->cards[2].name == Seven)
					  {return 1;}
					  else
					  {return -1;}
	case bjnl1B : if(((TBJHand *)GetBJPlayer(activeplayer)->pHand1)->inhand == 3 &&
						  ((TBJHand *)GetBJPlayer(activeplayer)->pHand1)->cards[0].name == Seven &&
						  ((TBJHand *)GetBJPlayer(activeplayer)->pHand1)->cards[1].name == Seven &&
						  ((TBJHand *)GetBJPlayer(activeplayer)->pHand1)->cards[2].name == Seven)
					  {return 1;}
					  else
					  {return -1;}
	case bjnl1C : if(((TBJHand *)GetBJPlayer(activeplayer)->pHand2)->inhand == 3 &&
						  ((TBJHand *)GetBJPlayer(activeplayer)->pHand2)->cards[0].name == Seven &&
						  ((TBJHand *)GetBJPlayer(activeplayer)->pHand2)->cards[1].name == Seven &&
						  ((TBJHand *)GetBJPlayer(activeplayer)->pHand2)->cards[2].name == Seven)
					  {return 1;}
					  else
					  {return -1;}
	case bjnl2C : if(((TBJHand *)GetBJPlayer(activeplayer)->pHand2)->inhand == 3 &&
						  ((TBJHand *)GetBJPlayer(activeplayer)->pHand2)->cards[0].name == Seven &&
						  ((TBJHand *)GetBJPlayer(activeplayer)->pHand2)->cards[1].name == Seven &&
						  ((TBJHand *)GetBJPlayer(activeplayer)->pHand2)->cards[2].name == Seven)
					  {return 1;}
					  else
					  {return -1;}
	case bjnl2D : if(((TBJHand *)GetBJPlayer(activeplayer)->pHand3)->inhand == 3 &&
						  ((TBJHand *)GetBJPlayer(activeplayer)->pHand3)->cards[0].name == Seven &&
						  ((TBJHand *)GetBJPlayer(activeplayer)->pHand3)->cards[1].name == Seven &&
						  ((TBJHand *)GetBJPlayer(activeplayer)->pHand3)->cards[2].name == Seven)
					  {return 1;}
					  else
					  {return -1;}
	case bjnl2E : if(((TBJHand *)GetBJPlayer(activeplayer)->pHand4)->inhand == 3 &&
						  ((TBJHand *)GetBJPlayer(activeplayer)->pHand4)->cards[0].name == Seven &&
						  ((TBJHand *)GetBJPlayer(activeplayer)->pHand4)->cards[1].name == Seven &&
						  ((TBJHand *)GetBJPlayer(activeplayer)->pHand4)->cards[2].name == Seven)
					  {return 1;}
					  else
					  {return -1;}
	case bjnl3E : if(((TBJHand *)GetBJPlayer(activeplayer)->pHand4)->inhand == 3 &&
						  ((TBJHand *)GetBJPlayer(activeplayer)->pHand4)->cards[0].name == Seven &&
						  ((TBJHand *)GetBJPlayer(activeplayer)->pHand4)->cards[1].name == Seven &&
						  ((TBJHand *)GetBJPlayer(activeplayer)->pHand4)->cards[2].name == Seven)
					  {return 1;}
					  else
					  {return -1;}
	case bjnl3F : if(((TBJHand *)GetBJPlayer(activeplayer)->pHand5)->inhand == 3 &&
						  ((TBJHand *)GetBJPlayer(activeplayer)->pHand5)->cards[0].name == Seven &&
						  ((TBJHand *)GetBJPlayer(activeplayer)->pHand5)->cards[1].name == Seven &&
						  ((TBJHand *)GetBJPlayer(activeplayer)->pHand5)->cards[2].name == Seven)
					  {return 1;}
					  else
					  {return -1;}
	case bjnl3G : if(((TBJHand *)GetBJPlayer(activeplayer)->pHand6)->inhand == 3 &&
						  ((TBJHand *)GetBJPlayer(activeplayer)->pHand6)->cards[0].name == Seven &&
						  ((TBJHand *)GetBJPlayer(activeplayer)->pHand6)->cards[1].name == Seven &&
						  ((TBJHand *)GetBJPlayer(activeplayer)->pHand6)->cards[2].name == Seven)
					  {return 1;}
					  else
					  {return -1;}
  }
  return 0;
}
//*******************************************************************
int16 TCasinoBJGameLord::PlayerBet1000()
{
  TCasinoBJPlayer *player;
  player = GetBJPlayer(activeplayer);
  if(player == NULL)
  {return -1;}

  switch(LookingAt) {
	case bjnl1A : if(player->coinsplayedhand0 == 1000)
					  {return 1;}
					  else
					  {return -1;}
	case bjnl1B : if(player->coinsplayedhand1 == 1000)
					  {return 1;}
					  else
					  {return -1;}
	case bjnl1C : if(player->coinsplayedhand2 == 1000)
					  {return 1;}
					  else
					  {return -1;}
	case bjnl2C : if(player->coinsplayedhand2 == 1000)
					  {return 1;}
					  else
					  {return -1;}
	case bjnl2D : if(player->coinsplayedhand3 == 1000)
					  {return 1;}
					  else
					  {return -1;}
	case bjnl2E : if(player->coinsplayedhand4 == 1000)
					  {return 1;}
					  else
					  {return -1;}
	case bjnl3E : if(player->coinsplayedhand4 == 1000)
					  {return 1;}
					  else
					  {return -1;}
	case bjnl3F : if(player->coinsplayedhand5 == 1000)
					  {return 1;}
					  else
					  {return -1;}
	case bjnl3G : if(player->coinsplayedhand6 == 1000)
					  {return 1;}
					  else
					  {return -1;}
  }
  return 0;
}
//*******************************************************************
int16 TCasinoBJGameLord::PlayerBetGT(int32 amount)
{
  TCasinoBJPlayer *player;
  player = GetBJPlayer(activeplayer);
  if(player == NULL)
  {return -1;}

  switch(LookingAt) {
	case bjnl1A : if(player->coinsplayedhand0 > amount)
					  {return 1;}
					  else
					  {return -1;}
	case bjnl1B : if(player->coinsplayedhand1 > amount)
					  {return 1;}
					  else
					  {return -1;}
	case bjnl1C : if(player->coinsplayedhand2 > amount)
					  {return 1;}
					  else
					  {return -1;}
	case bjnl2C : if(player->coinsplayedhand2 > amount)
					  {return 1;}
					  else
					  {return -1;}
	case bjnl2D : if(player->coinsplayedhand3 > amount)
					  {return 1;}
					  else
					  {return -1;}
	case bjnl2E : if(player->coinsplayedhand4 > amount)
					  {return 1;}
					  else
					  {return -1;}
	case bjnl3E : if(player->coinsplayedhand4 > amount)
					  {return 1;}
					  else
					  {return -1;}
	case bjnl3F : if(player->coinsplayedhand5 > amount)
					  {return 1;}
					  else
					  {return -1;}
	case bjnl3G : if(player->coinsplayedhand6 > amount)
					  {return 1;}
					  else
					  {return -1;}
  }
  return 0;
}
//*******************************************************************
int16 TCasinoBJGameLord::BJ10HandsPlayed()
{
  int session;
  if(GetCasPD(0))
  {
	 session = GetCasPD(0)->BJData.CurrentSession;
	 if(GetCasPD(0)->BJData.Sessions[session].HandsPlayed >= 10)
	 {return 1;}
  }
  if(GetCasPD(1))
  {
	 session = GetCasPD(1)->BJData.CurrentSession;
	 if(GetCasPD(1)->BJData.Sessions[session].HandsPlayed >= 10)
	 {return 1;}
  }
  if(GetCasPD(2))
  {
	 session = GetCasPD(2)->BJData.CurrentSession;
	 if(GetCasPD(2)->BJData.Sessions[session].HandsPlayed >= 10)
	 {return 1;}
  }

  return -1;
}
//*******************************************************************
int16 TCasinoBJGameLord::OneAndOnlyPlayerGT20000()
{
  if(GetNumActivePlayers() != 1){return -1;}
  if(GetBJPlayer(activeplayer) == NULL){return -1;}
  if(GetCash(activeplayer) > 20000l)
  {return 1;}
  else {return -1;}
}
//*******************************************************************
int16 TCasinoBJGameLord::OneHumanPlayer()
{
  if(GetNumActivePlayers() == 1){return 1;}else {return -1;}
}
//*******************************************************************
int16 TCasinoBJGameLord::TwoHumanPlayers()
{
  if(GetNumActivePlayers() == 2){return 1;}else {return -1;}
}
//*******************************************************************
int16 TCasinoBJGameLord::ThreeHumanPlayers()
{
  if(GetNumActivePlayers() == 3){return 1;}else {return -1;}
}
//*******************************************************************
int16 TCasinoBJGameLord::AllPlayersMale()
{
  if(GetCasPD(0) != NULL && !GetCasPD(0)->Male)
  {return -1;}
  if(GetCasPD(1) != NULL && !GetCasPD(1)->Male)
  {return -1;}
  if(GetCasPD(2) != NULL && !GetCasPD(2)->Male)
  {return -1;}
  if(GetCasPD(2) == NULL && GetCasPD(1) == NULL && GetCasPD(0) == NULL)
  {return -1;}
  return 1;
}
//*******************************************************************
int16 TCasinoBJGameLord::AllPlayersFemale()
{
  if(GetCasPD(0) != NULL && GetCasPD(0)->Male)
  {return -1;}
  if(GetCasPD(1) != NULL && GetCasPD(1)->Male)
  {return -1;}
  if(GetCasPD(2) != NULL && GetCasPD(2)->Male)
  {return -1;}
  if(GetCasPD(2) == NULL && GetCasPD(1) == NULL && GetCasPD(0) == NULL)
  {return -1;}
  return 1;
}
//*******************************************************************
int16 TCasinoBJGameLord::RandomLT(int16 num)
{
  if(random(100) < num)
  {return 1;}
  return -1;
}
//*******************************************************************
void TCasinoBJGameLord::AskInsuranceExpert()
{
  pAskExpert->AskInsuranceExpert();
}
//*******************************************************************
int16 TCasinoBJGameLord::DealerHas(int16 total)
{
  if(pHand == NULL)
  {return -1;}

  if(total == pHand->highhand)
  {
	 return 1;
  }
  else {return -1;}
}
//*******************************************************************
int16 TCasinoBJGameLord::DealerUpcard(int16 name)
{
  if(pHand == NULL)
  {return -1;}

  if(pHand->cards[0].name == name)
  {
	 return 1;
  }
  else {return -1;}
}
//*******************************************************************
int16 TCasinoBJGameLord::BetweenDec22_Dec25()
{
  TDate today;
  if(today.Month() == 12)
  {
	 if(today.DayOfMonth() > 21 && today.DayOfMonth() < 26)
	 {
		return 1;
	 }
  }
  return -1;
}
//*******************************************************************
int16 TCasinoBJGameLord::BetweenDec31_Jan2()
{
  TDate today;
  if(today.Month() == 12 && today.DayOfMonth() > 30)
  {
	 return 1;
  }
  if(today.Month() == 1 && today.DayOfMonth() < 3)
  {
	 return 1;
  }
  return -1;
}
//*******************************************************************
int16 TCasinoBJGameLord::ValentinesDay()
{
  TDate today;
  if(today.Month() == 2 && today.DayOfMonth() == 14)
  {
	 return 1;
  }
  return -1;
}
//*******************************************************************
int16 TCasinoBJGameLord::StPatricksDay()
{
  TDate today;
  if(today.Month() == 3 && today.DayOfMonth() == 17)
  {
	 return 1;
  }
  return -1;
}
//*******************************************************************
int16 TCasinoBJGameLord::DealerBust()
{
  if(pHand == NULL)
  {return -1;}

  if(((TBJDeck *)pDeck)->Busted(pHand) == 0)
  {
	 return -1;
  }
  else
  {
	 return 1;
  }
}
//*******************************************************************
int16 TCasinoBJGameLord::OneAndOnlyPlayerHandBJ()
{
  if(GetNumActivePlayers() > 1)
  {return -1;}

  if(BetSpotUse[1] != -1 && (BetSpotUse[3] != -1 || BetSpotUse[5] != -1))
  {return -1;}
  if(BetSpotUse[3] != -1 && (BetSpotUse[1] != -1 || BetSpotUse[5] != -1))
  {return -1;}
  if(BetSpotUse[5] != -1 && (BetSpotUse[3] != -1 || BetSpotUse[1] != -1))
  {return -1;}
  if(BetSpotUse[1] != -1)
  {
	 if(((TBJHand *)GetBJPlayer(activeplayer)->pHand1)->bj)
	 {return 1;}else {return -1;}
  }
  if(BetSpotUse[3] != -1)
  {
	 if(((TBJHand *)GetBJPlayer(activeplayer)->pHand3)->bj)
	 {return 1;}else {return -1;}
  }
  if(BetSpotUse[5] != -1)
  {
	 if(((TBJHand *)GetBJPlayer(activeplayer)->pHand5)->bj)
	 {return 1;}else {return -1;}
  }
  return -1;
}
//*******************************************************************
int16 TCasinoBJGameLord::AllHandsWon()
{
  if(ALLHANDSWON)
  {return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoBJGameLord::PlayersFirstBJHandEver()
{
  if(GetCasPD(activeplayer)->BJData.FirstPlayerBJHandEver)
  {return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoBJGameLord::FirstBJHandSinceInStall()
{
  if(((TCasinoPlayerMgr *)GetFW()->GetPlayerMgr())->GetCasinoGameDataPtr()->FirstBJHandEver)
  {return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoBJGameLord::GTWeekPlayersLastPlayed()
{
  const dword Week=604800l;
  int session;

  if(GetCasPD(0) != NULL)
  {
	 session = GetCasPD(0)->BJData.CurrentSession;
	 if((GetCasPD(0)->BJData.Sessions[session].StartingTime -
		  GetCasPD(0)->BJData.LastBJSessionEndTime) < Week)
	 {return -1;}
  }
  if(GetCasPD(1) != NULL)
  {
	 session = GetCasPD(1)->BJData.CurrentSession;
	 if((GetCasPD(1)->BJData.Sessions[session].StartingTime -
		  GetCasPD(1)->BJData.LastBJSessionEndTime) < Week)
	 {return -1;}
  }
  if(GetCasPD(2) != NULL)
  {
	 session = GetCasPD(2)->BJData.CurrentSession;
	 if((GetCasPD(2)->BJData.Sessions[session].StartingTime -
		  GetCasPD(2)->BJData.LastBJSessionEndTime) < Week)
	 {return -1;}
  }
  return 1;
}
//*******************************************************************
int16 TCasinoBJGameLord::IsMale()
{
  if(GetCasPD(activeplayer) != NULL && GetCasPD(activeplayer)->Male)
  {return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoBJGameLord::IsFemale()
{
  if(GetCasPD(activeplayer) != NULL && !GetCasPD(activeplayer)->Male)
  {return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoBJGameLord::NumOfDecks(int16 decks)
{
  if(decks == (numofdecks/52))
  {return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoBJGameLord::ThreePreviousWin()
{
  if(ALLPREVIOUSHANDSWON && ThreePreviousBets > 2)
  {return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoBJGameLord::ThreeBetsWin()
{
  if(ALLHANDSWON && ThreeBets > 2)
  {return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoBJGameLord::AnyBetGT5000()
{

  if(GetBJPlayer(0) == NULL && GetBJPlayer(0) == NULL &&GetBJPlayer(0) == NULL)
  {return -1;}
  TCasinoBJPlayer *player;
  player = GetBJPlayer(0);
  if(player != NULL)
  {
	 if(player->coinsplayedhand0 > 5000)
	 {return 1;}
	 if(player->coinsplayedhand1 > 5000)
	 {return 1;}
	 if(player->coinsplayedhand2 > 5000)
	 {return 1;}
	 if(player->coinsplayedhand3 > 5000)
	 {return 1;}
	 if(player->coinsplayedhand4 > 5000)
	 {return 1;}
	 if(player->coinsplayedhand5 > 5000)
	 {return 1;}
	 if(player->coinsplayedhand6 > 5000)
	 {return 1;}
  }
  player = GetBJPlayer(1);
  if(player != NULL)
  {
	 if(player->coinsplayedhand0 > 5000)
	 {return 1;}
	 if(player->coinsplayedhand1 > 5000)
	 {return 1;}
	 if(player->coinsplayedhand2 > 5000)
	 {return 1;}
	 if(player->coinsplayedhand3 > 5000)
	 {return 1;}
	 if(player->coinsplayedhand4 > 5000)
	 {return 1;}
	 if(player->coinsplayedhand5 > 5000)
	 {return 1;}
	 if(player->coinsplayedhand6 > 5000)
	 {return 1;}
  }
  player = GetBJPlayer(2);
  if(player != NULL)
  {
	 if(player->coinsplayedhand0 > 5000)
	 {return 1;}
	 if(player->coinsplayedhand1 > 5000)
	 {return 1;}
	 if(player->coinsplayedhand2 > 5000)
	 {return 1;}
	 if(player->coinsplayedhand3 > 5000)
	 {return 1;}
	 if(player->coinsplayedhand4 > 5000)
	 {return 1;}
	 if(player->coinsplayedhand5 > 5000)
	 {return 1;}
	 if(player->coinsplayedhand6 > 5000)
	 {return 1;}
  }
  return -1;
}
//*******************************************************************
int16 TCasinoBJGameLord::HandHas(int16 cards)
{
  TCasinoBJPlayer *player;
  player = GetBJPlayer(activeplayer);
  if(player != NULL)
  {
	 switch(LookingAt) {
	 case bjnl1A : if(player->pHand0->inhand == cards)
					  {return 1;}
					  else
					  {return -1;}
	 case bjnl1B : if(player->pHand1->inhand == cards)
					  {return 1;}
					  else
					  {return -1;}
	 case bjnl1C : if(player->pHand2->inhand == cards)
					  {return 1;}
					  else
					  {return -1;}
	 case bjnl2C : if(player->pHand2->inhand == cards)
					  {return 1;}
					  else
					  {return -1;}
	 case bjnl2D : if(player->pHand3->inhand == cards)
					  {return 1;}
					  else
					  {return -1;}
	 case bjnl2E : if(player->pHand4->inhand == cards)
					  {return 1;}
					  else
					  {return -1;}
	 case bjnl3E : if(player->pHand4->inhand == cards)
					  {return 1;}
					  else
					  {return -1;}
	 case bjnl3F : if(player->pHand5->inhand == cards)
					  {return 1;}
					  else
					  {return -1;}
	 case bjnl3G : if(player->pHand6->inhand == cards)
					  {return 1;}
					  else
					  {return -1;}
	 }
  }
  return -1;
}
//*******************************************************************
int16 TCasinoBJGameLord::HandHasGT(int16 cards)
{
  TCasinoBJPlayer *player;
  player = GetBJPlayer(activeplayer);
  if(player != NULL)
  {
	 switch(LookingAt) {
	 case bjnl1A : if(player->pHand0->inhand > cards)
					  {return 1;}
					  else
					  {return -1;}
	 case bjnl1B : if(player->pHand1->inhand > cards)
					  {return 1;}
					  else
					  {return -1;}
	 case bjnl1C : if(player->pHand2->inhand > cards)
					  {return 1;}
					  else
					  {return -1;}
	 case bjnl2C : if(player->pHand2->inhand > cards)
					  {return 1;}
					  else
					  {return -1;}
	 case bjnl2D : if(player->pHand3->inhand > cards)
					  {return 1;}
					  else
					  {return -1;}
	 case bjnl2E : if(player->pHand4->inhand > cards)
					  {return 1;}
					  else
					  {return -1;}
	 case bjnl3E : if(player->pHand4->inhand > cards)
					  {return 1;}
					  else
					  {return -1;}
	 case bjnl3F : if(player->pHand5->inhand > cards)
					  {return 1;}
					  else
					  {return -1;}
	 case bjnl3G : if(player->pHand6->inhand > cards)
					  {return 1;}
					  else
					  {return -1;}
	 }
  }
  return -1;
}
//*******************************************************************
int16 TCasinoBJGameLord::Stalls(int16 num)
{
  if(StallsInRow == num)
  {return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoBJGameLord::Stalls0Or1()
{
  if(StallsInRow < 2)
  {return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoBJGameLord::StallsGT(int16 num)
{
//  if(StallsInRow > 3)
  if (StallsInRow > num)  {return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoBJGameLord::PlayerHasBJ()
{
  TCasinoBJPlayer *player;
  player = GetBJPlayer(activeplayer);
  if(player != NULL)
  {
	 switch(LookingAt) {
	 case bjnl1A : if(((TBJHand * )player->pHand0)->bj)
					  {return 1;}
					  else
					  {return -1;}
	 case bjnl1B : if(((TBJHand * )player->pHand1)->bj)
					  {return 1;}
					  else
					  {return -1;}
	 case bjnl1C : if(((TBJHand * )player->pHand2)->bj)
					  {return 1;}
					  else
					  {return -1;}
	 case bjnl2C : if(((TBJHand * )player->pHand2)->bj)
					  {return 1;}
					  else
					  {return -1;}
	 case bjnl2D : if(((TBJHand * )player->pHand3)->bj)
					  {return 1;}
					  else
					  {return -1;}
	 case bjnl2E : if(((TBJHand * )player->pHand4)->bj)
					  {return 1;}
					  else
					  {return -1;}
	 case bjnl3E : if(((TBJHand * )player->pHand4)->bj)
					  {return 1;}
					  else
					  {return -1;}
	 case bjnl3F : if(((TBJHand * )player->pHand5)->bj)
					  {return 1;}
					  else
					  {return -1;}
	 case bjnl3G : if(((TBJHand * )player->pHand6)->bj)
					  {return 1;}
					  else
					  {return -1;}
	 }
  }
  return -1;
}
//*******************************************************************
int16 TCasinoBJGameLord::TopCard(int16 num)
{
  TCasinoBJPlayer *player;
  player = GetBJPlayer(activeplayer);
  if(player != NULL)
  {
	 if(num > 8 && num < 13)
	 {
		switch(LookingAt) {
		case bjnl1A : if(player->pHand0->cards[player->pHand0->inhand-1].name > 8 &&  player->pHand0->cards[player->pHand0->inhand-1].name < 13)
					  {return 1;}
					  else
					  {return -1;}
		case bjnl1B : if(player->pHand1->cards[player->pHand1->inhand-1].name > 8 &&  player->pHand1->cards[player->pHand1->inhand-1].name < 13)
					  {return 1;}
					  else
					  {return -1;}
		case bjnl1C : if(player->pHand2->cards[player->pHand2->inhand-1].name > 8 &&  player->pHand2->cards[player->pHand2->inhand-1].name < 13)
					  {return 1;}
					  else
					  {return -1;}
		case bjnl2C : if(player->pHand2->cards[player->pHand2->inhand-1].name > 8 &&  player->pHand2->cards[player->pHand2->inhand-1].name < 13)
					  {return 1;}
					  else
					  {return -1;}
		case bjnl2D : if(player->pHand3->cards[player->pHand3->inhand-1].name > 8 &&  player->pHand3->cards[player->pHand3->inhand-1].name < 13)
					  {return 1;}
					  else
					  {return -1;}
		case bjnl2E : if(player->pHand4->cards[player->pHand4->inhand-1].name > 8 &&  player->pHand4->cards[player->pHand4->inhand-1].name < 13)
					  {return 1;}
					  else
					  {return -1;}
		case bjnl3E : if(player->pHand4->cards[player->pHand4->inhand-1].name > 8 &&  player->pHand4->cards[player->pHand4->inhand-1].name < 13)
					  {return 1;}
					  else
					  {return -1;}
		case bjnl3F : if(player->pHand5->cards[player->pHand5->inhand-1].name > 8 &&  player->pHand5->cards[player->pHand5->inhand-1].name < 13)
					  {return 1;}
					  else
					  {return -1;}
		case bjnl3G : if(player->pHand6->cards[player->pHand6->inhand-1].name > 8 &&  player->pHand6->cards[player->pHand6->inhand-1].name < 13)
					  {return 1;}
					  else
					  {return -1;}
		}
	 }
	 switch(LookingAt) {
	 case bjnl1A : if(player->pHand0->cards[player->pHand0->inhand-1].name == num)
					  {return 1;}
					  else
					  {return -1;}
	 case bjnl1B : if(player->pHand1->cards[player->pHand1->inhand-1].name == num)
					  {return 1;}
					  else
					  {return -1;}
	 case bjnl1C : if(player->pHand2->cards[player->pHand2->inhand-1].name == num)
					  {return 1;}
					  else
					  {return -1;}
	 case bjnl2C : if(player->pHand2->cards[player->pHand2->inhand-1].name == num)
					  {return 1;}
					  else
					  {return -1;}
	 case bjnl2D : if(player->pHand3->cards[player->pHand3->inhand-1].name == num)
					  {return 1;}
					  else
					  {return -1;}
	 case bjnl2E : if(player->pHand4->cards[player->pHand4->inhand-1].name == num)
					  {return 1;}
					  else
					  {return -1;}
	 case bjnl3E : if(player->pHand4->cards[player->pHand4->inhand-1].name == num)
					  {return 1;}
					  else
					  {return -1;}
	 case bjnl3F : if(player->pHand5->cards[player->pHand5->inhand-1].name == num)
					  {return 1;}
					  else
					  {return -1;}
	 case bjnl3G : if(player->pHand6->cards[player->pHand6->inhand-1].name == num)
					  {return 1;}
					  else
					  {return -1;}
	 }
  }
  return -1;
}
//*******************************************************************
int16 TCasinoBJGameLord::DealerStood2Cards()
{
  if(pHand == NULL){return -1;}
  if(pHand->inhand == 2)
  {return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoBJGameLord::AnyInsuranceBetMade()
{
  if(InsuranceBetMade)
  {return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoBJGameLord::PlayerInsuranceDealerBJ()
{
  TCasinoBJPlayer *player;
  player = GetBJPlayer(activeplayer);
  if(player != NULL)
  {
	 switch(LookingAt) {
	 case bjnl1B : if(player->pHand1->insurance > 0 && pHand->bj)
					  {return 1;}
					  else
					  {return -1;}
	 case bjnl2D : if(player->pHand3->insurance > 0 && pHand->bj)
					  {return 1;}
					  else
					  {return -1;}
	 case bjnl3F : if(player->pHand5->insurance > 0 && pHand->bj)
					  {return 1;}
					  else
					  {return -1;}
	 }
  }
  return -1;
}
//*******************************************************************
int16 TCasinoBJGameLord::AskCriteriaQuestion(int16 QNum)
{
  switch (QNum)
  {
	 case 0  : return PlayerHas(4);
	 case 1  : return PlayerHas(5);
	 case 2  : return PlayerHas(6);
	 case 3  : return PlayerHas(7);
	 case 4  : return PlayerHas(8);
	 case 5  : return PlayerHas(9);
	 case 6  : return PlayerHas(10);
	 case 7  : return PlayerHas(11);
	 case 8  : return PlayerHas(12);
	 case 9  : return PlayerHas(13);
	 case 10 : return PlayerHas(14);
	 case 11 : return PlayerHas(15);
	 case 12 : return PlayerHas(16);
	 case 13 : return PlayerHas(17);
	 case 14 : return PlayerHas(18);
	 case 15 : return PlayerHas(19);
	 case 16 : return PlayerHas(20);
	 case 17 : if(PlayerHas(21) == -1){return PlayerHasBJ();}
				  else {return PlayerHas(21);}
	 case 18 : return PlayerHas(22);
	 case 19 : return PlayerHas(23);
	 case 20 : return PlayerHas(24);
	 case 21 : return PlayerHas(25);
	 case 22 : return PlayerHas(26);
	 case 23 : return PlayerHasSoft(12);
	 case 24 : return PlayerHasSoft(13);
	 case 25 : return PlayerHasSoft(14);
	 case 26 : return PlayerHasSoft(15);
	 case 27 : return PlayerHasSoft(16);
	 case 28 : return PlayerHasSoft(17);
	 case 29 : return PlayerHasSoft(18);
	 case 30 : return PlayerHasSoft(19);
	 case 31 : return PlayerHasSoft(20);
	 case 32 : return PlayerHas777();
	 case 33 : return PlayerBust();
	 case 34 : return DealerUpcard(1);
	 case 35 : return DealerUpcard(2);
	 case 36 : return DealerUpcard(3);
	 case 37 : return DealerUpcard(4);
	 case 38 : return DealerUpcard(5);
	 case 39 : return DealerUpcard(6);
	 case 40 : return DealerUpcard(7);
	 case 41 : return DealerUpcard(8);
	 case 42 : return DealerUpcard(9);
	 case 43 : return DealerUpcard(13); //ace
	 case 44 : return DealerHas(4);
	 case 45 : return DealerHas(5);
	 case 46 : return DealerHas(6);
	 case 47 : return DealerHas(7);
	 case 48 : return DealerHas(8);
	 case 49 : return DealerHas(9);
	 case 50 : return DealerHas(10);
	 case 51 : return DealerHas(11);
	 case 52 : return DealerHas(12);
	 case 53 : return DealerHas(13);
	 case 54 : return DealerHas(14);
	 case 55 : return DealerHas(15);
	 case 56 : return DealerHas(16);
	 case 57 : return DealerHas(17);
	 case 58 : return DealerHas(18);
	 case 59 : return DealerHas(19);
	 case 60 : return DealerHas(20);
	 case 61 : return DealerHas(21);
	 case 62 : return DealerHas(22);
	 case 63 : return DealerHas(23);
	 case 64 : return DealerHas(24);
	 case 65 : return DealerHas(25);
	 case 66 : return DealerHas(26);
	 case 67 : return DealerBust();
	 case 68 : return PlayerBet1000();
	 case 69 : return PlayerBetGT(5000);
	 case 70 : return OneAndOnlyPlayerHandBJ();
	 case 71 : return AllHandsWon();
	 case 72 : return AllPlayersMale();
	 case 73 : return AllPlayersFemale();
	 case 74 : return BJ10HandsPlayed();
	 case 75 : return OneHumanPlayer();
	 case 76 : return TwoHumanPlayers();
	 case 77 : return ThreeHumanPlayers();
	 case 78 : return GTWeekPlayersLastPlayed();// all of them
	 case 79 : return BetweenDec22_Dec25();
	 case 80 : return BetweenDec31_Jan2();
	 case 81 : return ValentinesDay();
	 case 82 : return StPatricksDay();
	 case 83 : return OneAndOnlyPlayerGT20000();
	 case 84 : return PlayersFirstBJHandEver();
	 case 85 : return FirstBJHandSinceInStall();
	 case 86 : return RandomLT(5);
	 case 87 : return RandomLT(10);
	 case 88 : return RandomLT(20);
	 case 89 : return RandomLT(50);
	 case 90 : return RandomLT(75);
	 case 91 : return IsMale();
	 case 92 : return IsFemale();
	 case 93 : return NumOfDecks(1);
	 case 94 : return NumOfDecks(2);
	 case 95 : return NumOfDecks(4);
	 case 96 : return NumOfDecks(6);
	 case 97 : return ThreePreviousWin();
	 case 98 : return ThreeBetsWin();
	 case 99 : return AnyBetGT5000();
	 case 100 : return HandHas(2);
	 case 101 : return HandHas(3);
	 case 102 : return HandHas(4);
	 case 103 : return HandHasGT(4);
	 case 104 : return Stalls(0);
	 case 105 : return Stalls(1);
	 case 106 : return Stalls0Or1();
	 case 107 : return StallsGT(3);
	 case 108 : return PlayerHasBJ();
	 case 109 : return TopCard(1);
	 case 110 : return TopCard(2);
	 case 111 : return TopCard(3);
	 case 112 : return TopCard(4);
	 case 113 : return TopCard(5);
	 case 114 : return TopCard(6);
	 case 115 : return TopCard(7);
	 case 116 : return TopCard(8);
	 case 117 : return TopCard(9);
	 case 118 : return TopCard(13); // ace
	 case 119 : return DealerStood2Cards();
	 case 120 : return AnyInsuranceBetMade();
	 case 121 : return PlayerInsuranceDealerBJ();
    case 122 : return int16((PModeWin->GetDetailLevel() >= 2)?1:-1);
    case 123 : return int16((PModeWin->GetDetailLevel() >= 1)?1:-1);
    case 124 : return int16((PModeWin->GetDetailLevel() >= 3)?1:-1);
  }
  return 0;
}
//*******************************************************************
int16 TCasinoBJGameLord::Bet1(TMoney betsize)
{
  if(GetCash(activeplayer) == 0)
  {
	 if(BetSpotUse[1] == activeplayer ||
		 BetSpotUse[3] == activeplayer ||
		 BetSpotUse[5] == activeplayer   )
	 {
		  PModeWin->MessageBox("You're out of money and may not make additional bets. Your current bets are your only hope.","Out of Cash",MB_OK);
	 }
	 else if(GetCasPD(activeplayer)->IsActiveKenoTicket())
	 {
		PModeWin->MessageBox("You're out of money and may not bet. Your only hope is that one of your Keno tickets pays off.","Out of Cash",MB_OK);
	 }
	 else
	 {
		PModeWin->MessageBox("You've hit rock bottom. Your gambler is bankrupt. Select Create/Delete under the FILE menu to create or select a new gambler.","Bankrupt!",MB_OK);
	 }
	 return 1;
  }
  if(GetBJPlayer(activeplayer)->coinsplayed+betsize > 100000l)
  {
	 PModeWin->MessageBox("You may bet no more than $100,000 on any single bet spot.","Table Limit",MB_OK);
	 return 0;
  }
  if(GetCash(activeplayer) >= betsize+coinsplayed && GetBJPlayer(activeplayer)->coinsplayed+betsize < 100001l)
  {
	 coinsplayed += betsize;
	 GetBJPlayer(activeplayer)->coinsplayed += betsize;
	 BetAmountDisplay->SetNum(GetBJPlayer(activeplayer)->coinsplayed);
	// BetUnitChips->SetNum(GetBJPlayer(activeplayer)->coinsplayed);
	 if(coinsplayed == GetCash(activeplayer)){BJSounds->PlaySound(4);}
  }
  else
  {
	 if(coinsplayed == GetCash(activeplayer) || GetCash(activeplayer) == 0){BJSounds->PlaySound(5);}
	 else
	 {
		if(GetBJPlayer(activeplayer)->coinsplayed+betsize < 100001l)
		{
		  coinsplayed = GetCash(activeplayer);
		  GetBJPlayer(activeplayer)->coinsplayed = GetCash(activeplayer);
		  BetAmountDisplay->SetNum(GetBJPlayer(activeplayer)->coinsplayed);
	  //	  BetUnitChips->SetNum(GetBJPlayer(activeplayer)->coinsplayed);
		  BJSounds->PlaySound(4);
		}
	 }
  }
  return 1;
}
//*******************************************************************
int16 TCasinoBJGameLord::BetLast()
{
  if(GetCash(activeplayer) >= GetBJPlayer(activeplayer)->lastbet)
  {
	 coinsplayed += GetBJPlayer(activeplayer)->lastbet;
	 GetBJPlayer(activeplayer)->coinsplayed += GetBJPlayer(activeplayer)->lastbet;
  }
  return 1;
}
//*******************************************************************
int16 TCasinoBJGameLord::UnBet1(TMoney betsize)
{
  if(coinsplayed >= betsize)
  {
	 coinsplayed -= betsize;
	 GetBJPlayer(activeplayer)->coinsplayed -= betsize;
	 BetAmountDisplay->SetNum(coinsplayed);
	// BetUnitChips->SetNum(GetBJPlayer(activeplayer)->coinsplayed);
  }
  return 1;
}
//*******************************************************************
int16 TCasinoBJGameLord::ClearBet()
{
  coinsplayed = 0;
  GetBJPlayer(activeplayer)->coinsplayed = 0;
  GetBJPlayer(activeplayer)->lastbet = 0;
  BetAmountDisplay->SetNum(0);
//  BetUnitChips->SetNum(0);
  return 1;
}
//*******************************************************************
int16 TCasinoBJGameLord::BetMax()
{
  if(GetCash(activeplayer) > (maxbet-coinsplayed)*coinsize)
  {
	 SubCash(activeplayer,(maxbet-coinsplayed)*coinsize);
	 coinsplayed = maxbet;
  }
  else
  {
	 coinsplayed += (GetCash(activeplayer))/(coinsize);
	 SetCash(activeplayer,GetCash(activeplayer)%coinsize);
  }
  return 1;
}
//*******************************************************************
int16 TCasinoBJGameLord::ShowHands()
{
  return 1;
}
//*******************************************************************
int16 TCasinoBJGameLord::ShowWinner()
{
//  cout << "You won " << winnerpaid*coinsize << " bucks->";
  credits += (winnerpaid)/(coinsize);
//  cout << "You have " << pMWin->GObj[activeplayer]->cash << " bucks->";
//  cout << "You have " << credits << " credits->";

  return 1;
}
//*******************************************************************
int16 TCasinoBJGameLord::DealerDraw()
{
  int16 action=0;
  if(BetSpotUse[0] == -1 && BetSpotUse[1] == -1 && BetSpotUse[2] == -1 &&
	  BetSpotUse[3] == -1 && BetSpotUse[4] == -1 && BetSpotUse[5] == -1 &&
	  BetSpotUse[6] == -1)
  {
	 return -1;
  }
  while(((TBJDeck *)pDeck)->Busted(pHand) == 0 && action != 7)
  {
	 if(pHand->highhand >= 17)
	 {
		return 1;
	 }
	 ((TBJDeck *)pDeck)->Draw(pHand,pMWin);
  }
  return 0;
}
//*******************************************************************
int16 TCasinoBJGameLord::DealerBlackJack(int16 x)
{
  if(x == 1)
  {
	 if(BetSpotUse[1] != -1)
	 {
		if((bool)GetBJPlayer(BetSpotUse[1])->pHand1->insurance)
		{
		  AddCash(BetSpotUse[1],GetBJPlayer(BetSpotUse[1])->pHand1->insurance * 3);
		 // BetSpot[1]->ShowInsureWinChips();//GetBJPlayer(BetSpotUse[1])->pHand1->insurance * 2);
		}
		if(((TBJHand *)GetBJPlayer(BetSpotUse[1])->pHand1)->bj == 1)
		{
		  AddCash(BetSpotUse[1],GetBJPlayer(BetSpotUse[1])->coinsplayedhand1); // Give money back
		  delete GetBJPlayer(BetSpotUse[1])->pHand1;
		  GetBJPlayer(BetSpotUse[1])->pHand1 = NULL;
		 // BetSpotUse[1] = -1;
		}
		else
		{
		  GetBJPlayer(BetSpotUse[1])->coinsplayedhand1 = 0;
		  delete GetBJPlayer(BetSpotUse[1])->pHand1;
		  GetBJPlayer(BetSpotUse[1])->pHand1 = NULL;
		  BetSpot[1]->NoShowBetChips();
		 // BetSpotUse[1] = -1;
		}
	 }
  }
  if(x == 4)
  {
	 if(BetSpotUse[3] != -1)
	 {
		if((bool)GetBJPlayer(BetSpotUse[3])->pHand3->insurance)
		{
		  AddCash(BetSpotUse[3],GetBJPlayer(BetSpotUse[3])->pHand3->insurance * 3);
		 // BetSpot[3]->ShowInsureWinChips();//GetBJPlayer(BetSpotUse[3])->pHand3->insurance * 2);
		}
		if(((TBJHand *)GetBJPlayer(BetSpotUse[3])->pHand3)->bj == 1)
		{
		  AddCash(BetSpotUse[3],GetBJPlayer(BetSpotUse[3])->coinsplayedhand3);
		  delete GetBJPlayer(BetSpotUse[3])->pHand3;
		  GetBJPlayer(BetSpotUse[3])->pHand3 = NULL;
		  //BetSpotUse[3] = -1;
		}
		else
		{
		  GetBJPlayer(BetSpotUse[3])->coinsplayedhand3 = 0;
		  delete GetBJPlayer(BetSpotUse[3])->pHand3;
		  GetBJPlayer(BetSpotUse[3])->pHand3 = NULL;
		  BetSpot[3]->NoShowBetChips();
		//  BetSpotUse[3] = -1;
		}
	 }
  }
  if(x == 7)
  {
	 if(BetSpotUse[5] != -1)
	 {
		if((bool)GetBJPlayer(BetSpotUse[5])->pHand5->insurance)
		{
		  AddCash(BetSpotUse[5],GetBJPlayer(BetSpotUse[5])->pHand5->insurance * 3);
		 // BetSpot[1]->ShowInsureWinChips();//GetBJPlayer(BetSpotUse[1])->pHand1->insurance * 2);
		}
		if(((TBJHand *)GetBJPlayer(BetSpotUse[5])->pHand5)->bj == 1)
		{
		  AddCash(BetSpotUse[5],GetBJPlayer(BetSpotUse[5])->coinsplayedhand5);
		  delete GetBJPlayer(BetSpotUse[5])->pHand5;
		  GetBJPlayer(BetSpotUse[5])->pHand5 = NULL;
		  //BetSpotUse[5] = -1;
		}
		else
		{
		  GetBJPlayer(BetSpotUse[5])->coinsplayedhand5 = 0;
		  delete GetBJPlayer(BetSpotUse[5])->pHand5;
		  GetBJPlayer(BetSpotUse[5])->pHand5 = NULL;
		  BetSpot[5]->NoShowBetChips();
		  //BetSpotUse[5] = -1;
		}
	 }
  }
  Chips->SetNum(GetCash(activeplayer));
  BankCashDisplay->SetNum(GetCash(activeplayer));
  return 1;
}
//*******************************************************************
int16 TCasinoBJGameLord::CashOut()
{
  for(;credits>0;credits--)
  {
	 AddCash(activeplayer,coinsize);
  }
  return 1;
}
//*******************************************************************
int16 TCasinoBJGameLord::PlaceInsure(int16 x)
{
  InsuranceBetMade = true;
  if(x == 1)
  {
	 if(BetSpotUse[1] != -1)
	 {
		if(((TBJHand *)GetBJPlayer(BetSpotUse[1])->pHand1)->bj)
		{
		  int session = GetCasPD(BetSpotUse[1])->BJData.CurrentSession;
		  GetCasPD(BetSpotUse[1])->BJData.Sessions[session].Wins++;
		  AddCash(BetSpotUse[1],GetBJPlayer(BetSpotUse[1])->coinsplayedhand1*2);
		  BetSpot[1]->ShowEvenMoneyChips();
		  delete GetBJPlayer(BetSpotUse[1])->pHand1;
		  GetBJPlayer(BetSpotUse[1])->pHand1 = NULL;
		  //BetSpotUse[1] = -1;
		}
		else
		{
		  if(GetCash(BetSpotUse[1]) >= GetBJPlayer(BetSpotUse[1])->coinsplayedhand1/2)
		  {
			 GetBJPlayer(BetSpotUse[1])->pHand1->insurance = GetBJPlayer(BetSpotUse[1])->coinsplayedhand1/2;
		  }
		  else
		  {
			 GetBJPlayer(BetSpotUse[1])->pHand1->insurance = GetCash(BetSpotUse[1]);
		  }
		  BetSpot[1]->ShowInsureChips(GetBJPlayer(BetSpotUse[1])->pHand1->insurance);
		  SubCash(BetSpotUse[1],GetBJPlayer(BetSpotUse[1])->pHand1->insurance);
		}
	 }
  }
  if(x == 3)
  {
	 if(BetSpotUse[3] != -1)
	 {
		if(((TBJHand *)GetBJPlayer(BetSpotUse[3])->pHand3)->bj)
		{
		  int session = GetCasPD(BetSpotUse[3])->BJData.CurrentSession;
		  GetCasPD(BetSpotUse[3])->BJData.Sessions[session].Wins++;
		  AddCash(BetSpotUse[3],GetBJPlayer(BetSpotUse[3])->coinsplayedhand3*2);
		  BetSpot[3]->ShowEvenMoneyChips();
		  delete GetBJPlayer(BetSpotUse[3])->pHand3;
		  GetBJPlayer(BetSpotUse[3])->pHand3 = NULL;
		  //BetSpotUse[3] = -1;
		}
		else
		{
		  if(GetCash(BetSpotUse[3]) >= GetBJPlayer(BetSpotUse[3])->coinsplayedhand3/2)
		  {
			 GetBJPlayer(BetSpotUse[3])->pHand3->insurance = GetBJPlayer(BetSpotUse[3])->coinsplayedhand3/2;
		  }
		  else
		  {
			 GetBJPlayer(BetSpotUse[3])->pHand3->insurance = GetCash(BetSpotUse[3]);
		  }
		  BetSpot[3]->ShowInsureChips(GetBJPlayer(BetSpotUse[3])->pHand3->insurance);
		  SubCash(BetSpotUse[3],GetBJPlayer(BetSpotUse[3])->pHand3->insurance);
		}
	 }
  }
  if(x == 5)
  {
	 if(BetSpotUse[5] != -1)
	 {
		if(((TBJHand *)GetBJPlayer(BetSpotUse[5])->pHand5)->bj)
		{
		  int session = GetCasPD(BetSpotUse[5])->BJData.CurrentSession;
		  GetCasPD(BetSpotUse[5])->BJData.Sessions[session].Wins++;
		  AddCash(BetSpotUse[5],GetBJPlayer(BetSpotUse[5])->coinsplayedhand5*2);
		  BetSpot[5]->ShowEvenMoneyChips();
		  delete GetBJPlayer(BetSpotUse[5])->pHand5;
		  GetBJPlayer(BetSpotUse[5])->pHand5 = NULL;
		  //BetSpotUse[5] = -1;
		}
		else
		{
		  if(GetCash(BetSpotUse[5]) >= GetBJPlayer(BetSpotUse[5])->coinsplayedhand5/2)
		  {
			 GetBJPlayer(BetSpotUse[5])->pHand5->insurance = GetBJPlayer(BetSpotUse[5])->coinsplayedhand5/2;
		  }
		  else
		  {
			 GetBJPlayer(BetSpotUse[5])->pHand5->insurance = GetCash(BetSpotUse[5]);
		  }
		  BetSpot[5]->ShowInsureChips(GetBJPlayer(BetSpotUse[5])->pHand5->insurance);
		  SubCash(BetSpotUse[5],GetBJPlayer(BetSpotUse[5])->pHand5->insurance);
		}
	 }
  }
  Chips->SetNum(GetCash(activeplayer));
  BankCashDisplay->SetNum(GetCash(activeplayer));
  return 1;
}
//*******************************************************************
int16 TCasinoBJGameLord::RemoveInsure(int16 x)
{
  if(x == 1)
  {
	 if(BetSpotUse[1] != -1)
	 {
		if((bool)GetBJPlayer(BetSpotUse[1])->pHand1->insurance)
		{
		  int session = GetCasPD(BetSpotUse[1])->BJData.CurrentSession;
		  GetCasPD(BetSpotUse[1])->BJData.Sessions[session].InsureLost++;
		  BetSpot[1]->NoShowInsureChips();
		}
	 }
  }
  if(x == 3)
  {
	 if(BetSpotUse[3] != -1)
	 {
		if((bool)GetBJPlayer(BetSpotUse[3])->pHand3->insurance)
		{
		  int session = GetCasPD(BetSpotUse[3])->BJData.CurrentSession;
		  GetCasPD(BetSpotUse[3])->BJData.Sessions[session].InsureLost++;
		  BetSpot[3]->NoShowInsureChips();
		}
	 }
  }
  if(x == 5)
  {
	 if(BetSpotUse[5] != -1)
	 {
		if((bool)GetBJPlayer(BetSpotUse[5])->pHand5->insurance)
		{
		  int session = GetCasPD(BetSpotUse[5])->BJData.CurrentSession;
		  GetCasPD(BetSpotUse[5])->BJData.Sessions[session].InsureLost++;
		  BetSpot[5]->NoShowInsureChips();
		}
	 }
  }
  return 1;
}
//*******************************************************************

