//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  cbjsgsp.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0    1/23/96    A.Krist     moved inline functions into .cpp file.
//  2.0   09/23/97    M.Perry     32-bit conversion.
//********************************************************************
#include "cbjsgsp.h"
#include "oanm.h"
//*******************************************************************
void TBJSign::SetupAnms()
{
  NotFound = false;

  PSign = GetAnm(0);
  if (PSign == NULL) {AnmError("Sign","sign",0);}

  PSign->CAD.ClearAutoStart();
  PSign->CAD.ClearAutoStop();
  PSign->CAD.SetDirStill();
}
//*******************************************************************
TBJSign::TBJSign(TOgleModeWindow *pmw,TFileMode NewFileMode)
:TSprite(pmw,NewFileMode)
{
  SetToManual();
  numofdecks = 0;
  NoShow();
  SetupAnms();
}
//*******************************************************************
TBJSign::TBJSign(TOgleModeWindow *pmw,TFileMode fm,void *psource)
:TSprite(pmw,fm,psource)
{
  SetToManual();
  numofdecks = 0;
  NoShow();
  SetupAnms();
}
//*******************************************************************
TBJSign::~TBJSign()
{
}
//*******************************************************************
void TBJSign::ShowBJSign(int16 decks)
{
  if (NotFound) {return;}
  numofdecks = decks;
  if(decks == 1)
  {
	 PSign->CAD.SetCurrentFrame(0);
  }
  else
  {
	 PSign->CAD.SetCurrentFrame(int16((decks/2)%4));
  }
  PSign->Show();
  Update(GetAdjFUC());
}
//*******************************************************************
void TBJSign::NoShowBJSign()
{
  PSign->NoShow();
}
//*******************************************************************
