//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  betlay.cpp
//    Project Name:  Ogle
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     05/18/96   A. Krist    Original baseline
//  2.0     09/18/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "betlay.h"
//*******************************************************************
TBetLay::TBetLay(TOgleModeWindow *pmw,const TFileMode &NewFileMode,int16 point,
                 int16 MessageCode)
:TCBetSpot(pmw,NewFileMode,MessageCode)
{
  SpotType = Lay;
  LayPoint = point;
}
//*******************************************************************
TBetLay::TBetLay(TOgleModeWindow *pmw,const TFileMode &NewFileMode,void *psource,
                 int16 point,int16 MessageCode)
:TCBetSpot(pmw,NewFileMode,psource,MessageCode)
{
  SpotType = Lay;
  LayPoint = point;
}
//*******************************************************************
TBetLay::~TBetLay()
{
}
//*******************************************************************
TMoney TBetLay::TrueOdds(TMoney amount,int16 winnum)
{
  return TCBetSpot::TrueOdds(amount,winnum);
}
//*******************************************************************
int32 TBetLay::Odds()
{
  return 1;
}
//*******************************************************************
TMoney TBetLay::WinBSCash(int16 slot,int16 winnum)
{
  TMoney x=0l;
  x = TrueOdds(BetAmount[slot],winnum,slot)+BetAmount[slot];
  BetAmount[slot] = 0l;
  return x;
}
//*******************************************************************
TMoney TBetLay::WinBSPayOff(int16 slot,int16 winnum)
{
  TMoney x=0l;
  x = TrueOdds(BetAmount[slot],winnum,slot);
  return x;
}
//*******************************************************************
#pragma argsused
TMoney TBetLay::TrueOdds(TMoney amount,int16 winnum,int16 slot)
{
  int32 to,num;
  TMoney winnings=0l;
  switch(LayPoint)
  {
	 case 2  :  num = 1;to = 2;break;
	 case 3  :  num = 2;to = 3;break;
	 case 4  :  num = 5;to = 6;break;
	 case 6  :  num = 5;to = 6;break;
	 case 7  :  num = 2;to = 3;break;
	 case 8  :  num = 1;to = 2;break;
	 default :  num = 0;to = 1;break;
  }
  winnings = ((amount*num*20l)-(amount*to))/(to*20l);
  return winnings;
}
//*******************************************************************
#pragma argsused
bool TBetLay::Winner(int16 FirstDice,int16 SecondDice,int16 Point,bool ComeOut)
  {
	  if( (FirstDice+SecondDice) == 5 )
	  {
		 return true;
	  }
	  else
	  {
		 return false;
	  }
  }
//*******************************************************************
#pragma argsused
bool TBetLay::Loser(int16 FirstDice,int16 SecondDice,int16 Point,bool ComeOut)
  {
	  if( (FirstDice+SecondDice) == LayPoint )
	  {
		 return true;
	  }
	  else
	  {
		 return false;
	  }
  }
//*******************************************************************