//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  betpass.cpp
//    Project Name:  Ogle
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     08/18/95   A. Krist    Original baseline
//  2.0     09/18/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "betpass.h"
#include "oanm.h"
//*******************************************************************
TBetPass::TBetPass(TOgleModeWindow *pmw,const TFileMode &NewFileMode,int16 MessageCode)
:TCBetSpot(pmw,NewFileMode,MessageCode)
{
  SpotType = Pass;
  FreeOdds[0]=0l;
  FreeOdds[1]=0l;
  FreeOdds[2]=0l;
  Setup();
}
//*******************************************************************
TBetPass::TBetPass(TOgleModeWindow *pmw,const TFileMode &NewFileMode,void *psource,int16 MessageCode)
:TCBetSpot(pmw,NewFileMode,psource,MessageCode)
{
  SpotType = Pass;
  FreeOdds[0]=0l;
  FreeOdds[1]=0l;
  FreeOdds[2]=0l;
  Setup();
}
//*******************************************************************
TBetPass::~TBetPass()
{
}
//*******************************************************************
TMoney TBetPass::AddBSCash(int16 Slot,TMoney money,bool ComeOut,int16 Point,bool Flag)
{
  return TCBetSpot::AddBSCash(Slot,money,ComeOut,Point,Flag);
}
//*******************************************************************
TMoney TBetPass::TrueOdds(TMoney money,int16 winnum,int16 slot)
{
  return TCBetSpot::TrueOdds(money,winnum,slot);
}
//*******************************************************************
int16 TBetPass::MessCode(int16 player)
{
  if((int32)FreeOdds[player]){return int16(MessageCode+100);}
  return MessageCode;
}
//*******************************************************************
TMoney TBetPass::GetBSFreeOdds(int16 slot)
{
  return FreeOdds[slot];
}
//*******************************************************************
#pragma argsused
bool TBetPass::IsValidAdd(int16 slot,TMoney money,bool comeout,int16 point)
{
//  int32 amount = (int32)money;
  if(comeout)
  {
	 return true;
  }
  else
  {
	 if((point == 4 || point == 6) && ((BetAmount[slot]%2) == 0) && BetAmount[slot] > 0l)
	 {
		if( ((BetAmount[slot]*2l)-FreeOdds[slot]+BetAmount[slot]/2l) > 0l)
		{
		  return true;
		}
	 }
	 else
	 {
		if( ((BetAmount[slot]*2l)-FreeOdds[slot]) > 0l)
		{
		  return true;
		}
	 }
  }
  return false;
}
//*******************************************************************
#pragma argsused
bool TBetPass::IsValidRemove(int16 slot,TMoney money,bool comeout,int16 point)
{
//  int32 amount = (int32)money;
  if(comeout)
  {
	 if(BetAmount[slot] > 0l){return true;}
  }
  else
  {
	 if(FreeOdds[slot] > 0l){return true;}
  }
  return false;
}
//*******************************************************************
void TBetPass::ClearSpot()
{
  BetAmount[0] = 0l;
  BetAmount[1] = 0l;
  BetAmount[2] = 0l;
  FreeOdds[0]  = 0l;
  FreeOdds[1]  = 0l;
  FreeOdds[2]  = 0l;
  NoShow();
}
//*******************************************************************
TMoney TBetPass::TrueOdds(TMoney money,int16 winnum)
{
  int32 amount = (int32)money;
  int32 to,num,units;
  TMoney winnings=0l;
  switch(winnum)
  {
	 case 2  :  num = 2;to = 1;break;
	 case 3  :  num = 3;to = 2;break;
	 case 4  :  num = 6;to = 5;break;
	 case 6  :  num = 6;to = 5;break;
	 case 7  :  num = 3;to = 2;break;
	 case 8  :  num = 2;to = 1;break;
	 default :  num = 0;to = 1;break;
  }
  units =  amount/to;
  winnings = (units*num) + (amount%to);
  return winnings;
}
//*******************************************************************
TMoney TBetPass::WinBSCash(int16 slot,int16 winnum)
{
  TMoney x=0l;
	 x = (BetAmount[slot]*Odds())+BetAmount[slot]+(TrueOdds(FreeOdds[slot],winnum))+FreeOdds[slot];
	 BetAmount[slot] = 0l;
	 FreeOdds[slot] = 0l;
	 return x;
}
//*******************************************************************
TMoney TBetPass::WinBSPayOff(int16 slot,int16 winnum)
{
  TMoney x=0l;
  x = (BetAmount[slot]*Odds())+(TrueOdds(FreeOdds[slot],winnum));
  return x;
}
//*******************************************************************
void TBetPass::SetFree(int16 yoff,int16 slot)
{
  if (NotFound) {return;}
  int16 yoffset,zoffset;
  int32 num;
  yoffset   = yoff;
  zoffset   = PFreeChips[slot][0]->SAD.GetZ();
  num = (int32)FreeOdds[slot];
  num = num%100000l;
  int32 tenthous = num / 10000;
  int32 tenthousvalue = tenthous * 10000;
  int32 thous = (num - tenthousvalue) / 1000;
  int32 thousvalue = thous * 1000;
  int32 huns = (num - tenthousvalue - thousvalue) / 100;
  int32 hunsvalue = huns * 100;
  int32 twfive = (num - tenthousvalue - thousvalue - hunsvalue) / 25;
  int32 twfivevalue = twfive * 25;
  int32 fives = (num - tenthousvalue - thousvalue - hunsvalue - twfivevalue) / 5;
  int32 fivesvalue = fives * 5;
  int32 ones = (num - tenthousvalue - thousvalue - hunsvalue - twfivevalue - fivesvalue);

  if (tenthous)
  {
  	PFreeChips[slot][5]->CAD.SetY(yoffset);
  	PFreeChips[slot][5]->CAD.SetZ(zoffset);

  	PFreeChips[slot][5]->CAD.SetCurrentFrame(int16(tenthous - 1));
  	PFreeChips[slot][5]->Show();
  }
  else {PFreeChips[slot][5]->NoShow();}
  yoffset -= int16(2*tenthous);
  zoffset += int16(tenthous);

  if (thous)
  {
  	PFreeChips[slot][4]->CAD.SetY(yoffset);
  	PFreeChips[slot][4]->CAD.SetZ(zoffset);

  	PFreeChips[slot][4]->CAD.SetCurrentFrame(int16(thous - 1));
  	PFreeChips[slot][4]->Show();
  }
  else {PFreeChips[slot][4]->NoShow();}
  yoffset -= int16(2*thous);
  zoffset += int16(thous);

  if (huns)
  {
  	PFreeChips[slot][3]->CAD.SetY(yoffset);
  	PFreeChips[slot][3]->CAD.SetZ(zoffset);

  	PFreeChips[slot][3]->CAD.SetCurrentFrame(int16(huns - 1));
  	PFreeChips[slot][3]->Show();
  }
  else {PFreeChips[slot][3]->NoShow();}
  yoffset -= int16(2*huns);
  zoffset += int16(huns);

  if (twfive)
  {
		PFreeChips[slot][2]->CAD.SetY(yoffset);
		PFreeChips[slot][2]->CAD.SetZ(zoffset);

		PFreeChips[slot][2]->CAD.SetCurrentFrame(int16(twfive - 1));
		PFreeChips[slot][2]->Show();
	 }
	 else {PFreeChips[slot][2]->NoShow();}
	 yoffset -= int16(2*twfive);
	 zoffset += int16(twfive);

	 if (fives)
	 {
		PFreeChips[slot][1]->CAD.SetY(yoffset);
		PFreeChips[slot][1]->CAD.SetZ(zoffset);

		PFreeChips[slot][1]->CAD.SetCurrentFrame(int16(fives - 1));
		PFreeChips[slot][1]->Show();
	 }
	 else {PFreeChips[slot][1]->NoShow();}
	 yoffset -= int16(2*fives);
	 zoffset += int16(fives);

	 if (ones)
	 {
		PFreeChips[slot][0]->CAD.SetY(yoffset);
		PFreeChips[slot][0]->CAD.SetZ(zoffset);

		PFreeChips[slot][0]->CAD.SetCurrentFrame(int16(ones - 1));
		PFreeChips[slot][0]->Show();
	 }
	 else {PFreeChips[slot][0]->NoShow();}
	 yoffset -= int16(2*ones);
	 zoffset += int16(ones);
	 if(slot==0)
	 {TopAY = yoffset;TopAZ = zoffset;}
	 else if(slot==1)
	 {TopBY = yoffset;TopBZ = zoffset;}
	 else if(slot==2)
	 {TopCY = yoffset;TopCZ = zoffset;}
	 TopY = yoffset;
	 TopZ = zoffset;
}
//*******************************************************************
void TBetPass::SetNum()
{
  if (NotFound) {return;}
  int16 xoffset,yoffset,zoffset,i;
  int32 num;
  yoffset   = PChips[0][0]->SAD.GetY();
  zoffset   = PChips[0][0]->SAD.GetZ();
  xoffset   = PChips[0][0]->SAD.GetX();
	for(i=0;i<3;i++)
  {
	 if(xoffset != PChips[i][0]->SAD.GetX())
	 {
		yoffset = PChips[i][0]->SAD.GetY();
		zoffset = PChips[i][0]->SAD.GetZ();
	 }
	 num = (int32)BetAmount[i];
	 num = num%100001l;
	 zoffset += i;
	 int32 tenthous = num / 10000;
	 int32 tenthousvalue = tenthous * 10000;
	 int32 thous = (num - tenthousvalue) / 1000;
	 int32 thousvalue = thous * 1000;
	 int32 huns = (num - tenthousvalue - thousvalue) / 100;
	 int32 hunsvalue = huns * 100;
	 int32 twfive = (num - tenthousvalue - thousvalue - hunsvalue) / 25;
	 int32 twfivevalue = twfive * 25;
	 int32 fives = (num - tenthousvalue - thousvalue - hunsvalue - twfivevalue) / 5;
	 int32 fivesvalue = fives * 5;
	 int32 ones = (num - tenthousvalue - thousvalue - hunsvalue - twfivevalue - fivesvalue);


	 if (tenthous)
	 {
		PChips[i][5]->CAD.SetY(yoffset);
		PChips[i][5]->CAD.SetZ(zoffset);

		PChips[i][5]->CAD.SetCurrentFrame(int16(tenthous - 1));
		PChips[i][5]->Show();
	 }
	 else {PChips[i][5]->NoShow();}
	 yoffset -= int16(2*tenthous);
	 zoffset += int16(tenthous);

	 if (thous)
	 {
		PChips[i][4]->CAD.SetY(yoffset);
		PChips[i][4]->CAD.SetZ(zoffset);

		PChips[i][4]->CAD.SetCurrentFrame(int16(thous - 1));
		PChips[i][4]->Show();
	 }
	 else {PChips[i][4]->NoShow();}
	 yoffset -= int16(2*thous);
	 zoffset += int16(thous);

	 if (huns)
	 {
		PChips[i][3]->CAD.SetY(yoffset);
		PChips[i][3]->CAD.SetZ(zoffset);

		PChips[i][3]->CAD.SetCurrentFrame(int16(huns - 1));
		PChips[i][3]->Show();
	 }
	 else {PChips[i][3]->NoShow();}
	 yoffset -= int16(2*huns);
	 zoffset += int16(huns);

	 if (twfive)
	 {
		PChips[i][2]->CAD.SetY(yoffset);
		PChips[i][2]->CAD.SetZ(zoffset);

		PChips[i][2]->CAD.SetCurrentFrame(int16(twfive - 1));
		PChips[i][2]->Show();
	 }
	 else {PChips[i][2]->NoShow();}
	 yoffset -= int16(2*twfive);
	 zoffset += int16(twfive);

	 if (fives)
	 {
		PChips[i][1]->CAD.SetY(yoffset);
		PChips[i][1]->CAD.SetZ(zoffset);

		PChips[i][1]->CAD.SetCurrentFrame(int16(fives - 1));
		PChips[i][1]->Show();
	 }
	 else {PChips[i][1]->NoShow();}
	 yoffset -= int16(2*fives);
	 zoffset += int16(fives);

	 if (ones)
	 {
		PChips[i][0]->CAD.SetY(yoffset);
		PChips[i][0]->CAD.SetZ(zoffset);

		PChips[i][0]->CAD.SetCurrentFrame(int16(ones - 1));
		PChips[i][0]->Show();
	 }
	 else {PChips[i][0]->NoShow();}
	 yoffset -= int16(2*ones);
	 zoffset += int16(ones);

	 SetFree(yoffset,i);
	 Update(GetFUC());
//	 TopZ = zoffset;
  }

}
//*******************************************************************
void TBetPass::Setup()
{
  for(int16 j=0;j<3;j++)
  {
	 for (int16 i=0;i<6;i++)
	 {
		PFreeChips[j][i] = NULL;
		PFreeChips[j][i] = GetAnm(int16(i+(j*6)+22));
		if (PFreeChips[j][i] == NULL) {AnmError("CBetSpot","FreeChips",int16(i+(j*6)+22));}
		PFreeChips[j][i]->CAD.ClearAutoStart();
		PFreeChips[j][i]->CAD.ClearAutoStop();
		PFreeChips[j][i]->CAD.SetDirStill();
	 }
  }
}
//*******************************************************************
TMoney TBetPass::SubBSCash(int16 slot,bool comeout)
{
  TMoney temp=0l;
  if(comeout)
  {
	 temp = BetAmount[slot];
	 BetAmount[slot] = 0l;
  }
  else
  {
	 temp = FreeOdds[slot];
	 FreeOdds[slot] = 0l;
  }
  SetNum();
  return temp;
}
//*******************************************************************
TMoney TBetPass::AddBSCash(int16 slot,TMoney amount,bool comeout,int16 point)
{
  if(comeout)
  {
	 BetAmount[slot] += amount;
	 SetNum();
	 return 0l;
  }
  else
  {
	 if(BetAmount[slot] == 0l){return amount;}
	 if((point == 4 || point == 6) && ((BetAmount[slot]%2l) == 0l))
	 {
		if( ((BetAmount[slot]*2l)-FreeOdds[slot]+BetAmount[slot]/2l) >= amount)
		{
		  FreeOdds[slot] += amount;
		  SetNum();
		  return 0l;
		}
		else
		{
		  if(FreeOdds[slot] == 0l)
		  {
			 FreeOdds[slot] = (BetAmount[slot]*2l)+(BetAmount[slot]/2l);
			 SetNum();
			 return (amount-(BetAmount[slot]*2l)+(BetAmount[slot]/2l));
		  }
		  else
		  {
			 TMoney x = FreeOdds[slot];
			 FreeOdds[slot] = (BetAmount[slot]*2l)+(BetAmount[slot]/2l);
			 SetNum();
			 return (amount+x-((BetAmount[slot]*2l)+(BetAmount[slot]/2l)));
		  }
		}
	 }
	 else
	 {
		if( ((BetAmount[slot]*2l)-FreeOdds[slot]) >= amount)
		{
		  FreeOdds[slot] += amount;
		  SetNum();
		  return 0l;
		}
		else
		{
		  if(FreeOdds[slot] == 0l)
		  {
			 FreeOdds[slot] = BetAmount[slot]*2l;
			 SetNum();
			 return (amount-(BetAmount[slot]*2l));
		  }
		  else
		  {
			 int32 x = FreeOdds[slot];
			 FreeOdds[slot] = BetAmount[slot]*2l;
			 SetNum();
			 return (amount+x-(BetAmount[slot]*2l));
		  }
		}
	 }
  }
}
//*******************************************************************
bool TBetPass::Winner(int16 FirstDice,int16 SecondDice,int16 Point,bool ComeOut)
  {
	if(ComeOut)
	{
	  if(FirstDice+SecondDice == 5 || FirstDice+SecondDice == 9)
	  {
		 return true;
	  }
	  else
	  {
		 return false;
	  }
	}
	else
	{
	  if(FirstDice+SecondDice == Point)
	  {return true;}
	  else
	  {return false;}
	}
  }
//*******************************************************************
#pragma argsused
bool TBetPass::Loser(int16 FirstDice,int16 SecondDice,int16 Point,bool ComeOut)
{
  if(ComeOut)
  {
	 if(FirstDice+SecondDice == 0 || FirstDice+SecondDice == 1 || FirstDice+SecondDice == 10)
	 {
		return true;
	 }
	 else
	 {
		return false;
	 }
  }
  else
  {
	 if(FirstDice+SecondDice == 5)
	 {
		return true;
	 }
	 else
	 {
		return false;
	 }
  }
}
//*******************************************************************
