//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  cascmw.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     8/30/96    M.Perry    original baseline
//  2.0    09/18/97    M.Perry    32-bit conversion.
//********************************************************************
#include "cascmw.h"
#include "cplaymgr.h"
#include "ccboptd.h"
#include "chelpid.h"
#include "accmenu.rh"
#include "osndmgr.h"
//*******************************************************************
DEFINE_RESPONSE_TABLE1(TCrapsModeWin,TCasinoModeWin)
  EV_COMMAND(CM_OPTIONSCRAPS_BETOPTIONS,CmOptionsBetOptions),
  EV_COMMAND_ENABLE(CM_OPTIONSCRAPS_BETOPTIONS,CeOptionsBetOptions),
END_RESPONSE_TABLE;
//*******************************************************************
void TCrapsModeWin::CmOptionsBetOptions()
{
  bool waspaused = GetUpdatePause();
  SetUpdatePause();
  GetSoundMgr()->Stop(true);
  if (GetCasGameLord() == NULL)
  {
    MessageBox("Craps not setup properly","Error - Bet Options",MB_OK);
  }
  else
  {
    int16 slotnum = GetCasGameLord()->GetActivePlayer();
    TCasinoPlayerData *pdat = GetCasPlayerMgr()->GetActiveCasinoPlayerDataPtr(slotnum);
    if (pdat == NULL)
    {
      MessageBox("Active player not found.","Error - Bet Options",MB_OK);
    }
    else
    {
      TCasinoCrapsBetOptionsDlg *pccbod = new TCasinoCrapsBetOptionsDlg(this,pdat);
      pccbod->Execute();
      delete pccbod;
    }
  }
  if (!waspaused) {ClearUpdatePause();}
}
//*******************************************************************
void TCrapsModeWin::CeOptionsBetOptions(TCommandEnabler &ce)
{
  if (GetCasGameLord() == NULL)
  {
    ce.Enable(false);
  }
  else
  {
    ce.Enable(true);
  }
}
//*******************************************************************
TCrapsModeWin::TCrapsModeWin(string modename,TPal *PPal,string title)
:TCasinoModeWin(modename,PPal,title)
{
  strModeName = "Craps";
  ModeHelpCommand = HELP_CONTEXT;
  ModeHelpData = IDH_CAS_CRAPS;
}
//*******************************************************************
TCrapsModeWin::~TCrapsModeWin()
{
}
//*******************************************************************
string TCrapsModeWin::GetDetName()
{
  return string("craps");
}
//*******************************************************************
int TCrapsModeWin::GetMenuID()
{
  return IDM_CASINO_CRAPS;
}
//*******************************************************************