//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  cc1glspl.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     1/24/96    M.Perry    original baseline
//  2.0    09/18/97    M.Perry    32-bit conversion.
//********************************************************************
#include "cc1glspl.h"
#include "casnames.rh"
#include "ccnames.rh"
#include "ccbdsp.h"
#include "ccpucksp.h"
#include "ccdicesp.h"
#include "ccbpsp.h"
#include "betpass.h"
#include "betce.h"
#include "betanyc.h"
#include "bethard.h"
#include "betdpass.h"
#include "betbig.h"
#include "betfield.h"
#include "betcome.h"
#include "betbuy.h"
#include "betdcome.h"
#include "betcnum.h"
#include "betlay.h"
#include "betdcnum.h"
#include "bet1roll.h"
//*******************************************************************
TC1GLordSpriteList::TC1GLordSpriteList(TOgleModeWindow *pmw,const TFileMode &filemode,TGameObject *PGObj)
:TCGLordSpriteList(pmw,filemode,PGObj)
{
  Init(filemode,true,false);
}
//*******************************************************************
TC1GLordSpriteList::~TC1GLordSpriteList()
{
}
//*******************************************************************
bool TC1GLordSpriteList::compare(const string &s1,const string &s2)
{
  if (s1 == s2) {return true;}
  return false;
}
//*******************************************************************
#pragma argsused
TSprite *TC1GLordSpriteList::CreateSprite(string spritename,int16 id,void *psource)
{
  TFileMode FM(spritename,fm_None,fm_None,FileMode.DirIndex);
  if (psource == NULL)
  {
    FM.SetRamImmed();
    switch (id)
    {
      case 0:return (new TSprite(PModeWin,FM));
      case 1:return (new TRSound(PModeWin,FM));
      case 2:return (new TCrapsCircle(PModeWin,FM));
      case 3:return (new TCasNamePlate(PModeWin,FM));
      case 4:return (new TCasNamePlate(PModeWin,FM));
      case 5:return (new TCasNamePlate(PModeWin,FM));
      case 6:return (new TCasMessageDisplay(PModeWin,FM));
      case 7:return (new TCasCashDisplay(PModeWin,FM));
      case 8:return (new TCasCashDisplay(PModeWin,FM));
      case 9:return (new TCasButton(PModeWin,FM,(TCasinoGameLord *)POwnerGObj,100,TRect(1,430,50,479),cidButton0,true,'x'));
      case 10:return (new TCasButton(PModeWin,FM,(TCasinoGameLord *)POwnerGObj,100,TRect(170,430,219,479),cidButton1,true));
      case 11:return (new TCasButton(PModeWin,FM,(TCasinoGameLord *)POwnerGObj,100,TRect(223,464,258,479),cidButton2,true));
      case 12:return (new TCasButton(PModeWin,FM,(TCasinoGameLord *)POwnerGObj,100,TRect(376,464,412,479),cidButton3,true));
      case 13:return (new  TCasButton(PModeWin,FM,(TCasinoGameLord *)POwnerGObj,100,TRect(416,430,468,452),cidButton4,true,'c'));
      case 14:return (new TCasButton(PModeWin,FM,(TCasinoGameLord *)POwnerGObj,100,TRect(416,454,468,479),cidButton5,true,'r'));
      case 15:return (new TCasButton(PModeWin,FM,(TCasinoGameLord *)POwnerGObj,100,TRect(472,455,489,479),cidButton6,true,'4'));
      case 16:return (new TCasButton(PModeWin,FM,(TCasinoGameLord *)POwnerGObj,100,TRect(491,455,508,479),cidButton7,true,'5'));
      case 17:return (new TCasButton(PModeWin,FM,(TCasinoGameLord *)POwnerGObj,100,TRect(510,455,527,479),cidButton8,true,'6'));
      case 18:return (new TCasButton(PModeWin,FM,(TCasinoGameLord *)POwnerGObj,100,TRect(529,455,546,479),cidButton9,true,'7'));
      case 19:return (new TCasButton(PModeWin,FM,(TCasinoGameLord *)POwnerGObj,100,TRect(548,455,564,479),cidButton10,true,'8'));
      case 20:return (new TCasButton(PModeWin,FM,(TCasinoGameLord *)POwnerGObj,100,TRect(566,455,584,479),cidButton11,true,'9'));
      case 21:return (new TCasButton(PModeWin,FM,(TCasinoGameLord *)POwnerGObj,100,TRect(587,432,639,460),cidButton12,true));
      case 22:return (new TCasButton(PModeWin,FM,(TCasinoGameLord *)POwnerGObj,125,TRect(587,462,639,479),cidButton13,true,'p'));
      case 23:return (new TCBetPayOff(PModeWin,FM));
      case 24:return (new TCPuck(PModeWin,FM));
      case 25:return (new TCDice(PModeWin,FM));
      case 26:return (new TCDice(PModeWin,FM));
      case 27:return (new TCDice(PModeWin,FM));
      case 28:return (new TSprite(PModeWin,FM)); // ??? not used ???
      case 29:return (new TCBigDice(PModeWin,FM));
      case 30:return (new TCBigDice(PModeWin,FM));
      case 31:return (new TCBigDice(PModeWin,FM));
      case 32:return (new TCBigDice(PModeWin,FM));
      case 33:return (new TCBigDice(PModeWin,FM));
      case 34:return (new TCBigDice(PModeWin,FM));
      case 35:return (new TCasChips(PModeWin,FM));
      case 36:return (new TBetPass(PModeWin,FM,52));
      case 37:return (new TBetDoNotPass(PModeWin,FM,53));
      case 38:return (new TBetCome(PModeWin,FM,54));
      case 39:return (new TBetDoNotCome(PModeWin,FM,55));
      case 40:return (new TBetField(PModeWin,FM,62));
      case 41:return (new TBetBig(PModeWin,FM,4,60));
      case 42:return (new TBetBig(PModeWin,FM,6,61));
      case 43:return (new TBetAnyCraps(PModeWin,FM,86));
      case 44:return (new TBet1Roll(PModeWin,FM,5,85));
      case 45:return (new TBet1Roll(PModeWin,FM,0,87));
      case 46:return (new TBet1Roll(PModeWin,FM,1,88));
      case 47:return (new TBet1Roll(PModeWin,FM,9,89));
      case 48:return (new TBet1Roll(PModeWin,FM,10,90));
      case 49:return (new TBetHard(PModeWin,FM,2,81));
      case 50:return (new TBetHard(PModeWin,FM,4,82));
      case 51:return (new TBetHard(PModeWin,FM,6,83));
      case 52:return (new TBetHard(PModeWin,FM,8,84));
      case 53:return (new TBetBuy(PModeWin,FM,2,63));
      case 54:return (new TBetBuy(PModeWin,FM,3,64));
      case 55:return (new TBetBuy(PModeWin,FM,4,65));
      case 56:return (new TBetBuy(PModeWin,FM,6,66));
      case 57:return (new TBetBuy(PModeWin,FM,7,67));
      case 58:return (new TBetBuy(PModeWin,FM,8,68));
      case 59:return (new TBetComeNum(PModeWin,FM,2,54));
      case 60:return (new TBetComeNum(PModeWin,FM,3,54));
      case 61:return (new TBetComeNum(PModeWin,FM,4,54));
      case 62:return (new TBetComeNum(PModeWin,FM,6,54));
      case 63:return (new TBetComeNum(PModeWin,FM,7,54));
      case 64:return (new TBetComeNum(PModeWin,FM,8,54));
      case 65:return (new TBetLay(PModeWin,FM,2,75));
      case 66:return (new TBetLay(PModeWin,FM,3,76));
      case 67:return (new TBetLay(PModeWin,FM,4,77));
      case 68:return (new TBetLay(PModeWin,FM,6,78));
      case 69:return (new TBetLay(PModeWin,FM,7,79));
      case 70:return (new TBetLay(PModeWin,FM,8,80));
      case 71:return (new TBetDoNotComeNum(PModeWin,FM,2,55));
      case 72:return (new TBetDoNotComeNum(PModeWin,FM,3,55));
      case 73:return (new TBetDoNotComeNum(PModeWin,FM,4,55));
      case 74:return (new TBetDoNotComeNum(PModeWin,FM,6,55));
      case 75:return (new TBetDoNotComeNum(PModeWin,FM,7,55));
      case 76:return (new TBetDoNotComeNum(PModeWin,FM,8,55));
      case 77:return (new TBetCraps11(PModeWin,FM,92,false));
      case 78:return (new TBetCraps11(PModeWin,FM,91,true));
      default:return (new TSprite(PModeWin,FM));
    }
  }
  else
  {
    switch (id)
    {
      case 0:return (new TSprite(PModeWin,FM,psource));
      case 1:return (new TRSound(PModeWin,FM,psource));
      case 2:return (new TCrapsCircle(PModeWin,FM,psource));
      case 3:return (new TCasNamePlate(PModeWin,FM,psource));
      case 4:return (new TCasNamePlate(PModeWin,FM,psource));
      case 5:return (new TCasNamePlate(PModeWin,FM,psource));
      case 6:return (new TCasMessageDisplay(PModeWin,FM,psource));
      case 7:return (new TCasCashDisplay(PModeWin,FM,psource));
      case 8:return (new TCasCashDisplay(PModeWin,FM,psource));
      case 9:return (new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,100,TRect(1,430,50,479),cidButton0,true,'x'));
      case 10:return (new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,100,TRect(170,430,219,479),cidButton1,true));
      case 11:return (new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,100,TRect(223,464,258,479),cidButton2,true));
      case 12:return (new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,100,TRect(376,464,412,479),cidButton3,true));
      case 13:return (new  TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,100,TRect(416,430,468,452),cidButton4,true,'c'));
      case 14:return (new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,100,TRect(416,454,468,479),cidButton5,true,'r'));
      case 15:return (new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,100,TRect(472,455,489,479),cidButton6,true,'4'));
      case 16:return (new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,100,TRect(491,455,508,479),cidButton7,true,'5'));
      case 17:return (new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,100,TRect(510,455,527,479),cidButton8,true,'6'));
      case 18:return (new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,100,TRect(529,455,546,479),cidButton9,true,'7'));
      case 19:return (new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,100,TRect(548,455,564,479),cidButton10,true,'8'));
      case 20:return (new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,100,TRect(566,455,584,479),cidButton11,true,'9'));
      case 21:return (new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,100,TRect(587,432,639,460),cidButton12,true));
      case 22:return (new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,125,TRect(587,462,639,479),cidButton13,true,'p'));
      case 23:return (new TCBetPayOff(PModeWin,FM,psource));
      case 24:return (new TCPuck(PModeWin,FM,psource));
      case 25:return (new TCDice(PModeWin,FM,psource));
      case 26:return (new TCDice(PModeWin,FM,psource));
      case 27:return (new TCDice(PModeWin,FM,psource));
      case 28:return (new TSprite(PModeWin,FM,psource)); // ??? not used ???
      case 29:return (new TCBigDice(PModeWin,FM,psource));
      case 30:return (new TCBigDice(PModeWin,FM,psource));
      case 31:return (new TCBigDice(PModeWin,FM,psource));
      case 32:return (new TCBigDice(PModeWin,FM,psource));
      case 33:return (new TCBigDice(PModeWin,FM,psource));
      case 34:return (new TCBigDice(PModeWin,FM,psource));
      case 35:return (new TCasChips(PModeWin,FM,psource));
      case 36:return (new TBetPass(PModeWin,FM,psource,52));
      case 37:return (new TBetDoNotPass(PModeWin,FM,psource,53));
      case 38:return (new TBetCome(PModeWin,FM,psource,54));
      case 39:return (new TBetDoNotCome(PModeWin,FM,psource,55));
      case 40:return (new TBetField(PModeWin,FM,psource,62));
      case 41:return (new TBetBig(PModeWin,FM,psource,4,60));
      case 42:return (new TBetBig(PModeWin,FM,psource,6,61));
      case 43:return (new TBetAnyCraps(PModeWin,FM,psource,86));
      case 44:return (new TBet1Roll(PModeWin,FM,psource,5,85));
      case 45:return (new TBet1Roll(PModeWin,FM,psource,0,87));
      case 46:return (new TBet1Roll(PModeWin,FM,psource,1,88));
      case 47:return (new TBet1Roll(PModeWin,FM,psource,9,89));
      case 48:return (new TBet1Roll(PModeWin,FM,psource,10,90));
      case 49:return (new TBetHard(PModeWin,FM,psource,2,81));
      case 50:return (new TBetHard(PModeWin,FM,psource,4,82));
      case 51:return (new TBetHard(PModeWin,FM,psource,6,83));
      case 52:return (new TBetHard(PModeWin,FM,psource,8,84));
      case 53:return (new TBetBuy(PModeWin,FM,psource,2,63));
      case 54:return (new TBetBuy(PModeWin,FM,psource,3,64));
      case 55:return (new TBetBuy(PModeWin,FM,psource,4,65));
      case 56:return (new TBetBuy(PModeWin,FM,psource,6,66));
      case 57:return (new TBetBuy(PModeWin,FM,psource,7,67));
      case 58:return (new TBetBuy(PModeWin,FM,psource,8,68));
      case 59:return (new TBetComeNum(PModeWin,FM,psource,2,54));
      case 60:return (new TBetComeNum(PModeWin,FM,psource,3,54));
      case 61:return (new TBetComeNum(PModeWin,FM,psource,4,54));
      case 62:return (new TBetComeNum(PModeWin,FM,psource,6,54));
      case 63:return (new TBetComeNum(PModeWin,FM,psource,7,54));
      case 64:return (new TBetComeNum(PModeWin,FM,psource,8,54));
      case 65:return (new TBetLay(PModeWin,FM,psource,2,75));
      case 66:return (new TBetLay(PModeWin,FM,psource,3,76));
      case 67:return (new TBetLay(PModeWin,FM,psource,4,77));
      case 68:return (new TBetLay(PModeWin,FM,psource,6,78));
      case 69:return (new TBetLay(PModeWin,FM,psource,7,79));
      case 70:return (new TBetLay(PModeWin,FM,psource,8,80));
      case 71:return (new TBetDoNotComeNum(PModeWin,FM,psource,2,55));
      case 72:return (new TBetDoNotComeNum(PModeWin,FM,psource,3,55));
      case 73:return (new TBetDoNotComeNum(PModeWin,FM,psource,4,55));
      case 74:return (new TBetDoNotComeNum(PModeWin,FM,psource,6,55));
      case 75:return (new TBetDoNotComeNum(PModeWin,FM,psource,7,55));
      case 76:return (new TBetDoNotComeNum(PModeWin,FM,psource,8,55));
      case 77:return (new TBetCraps11(PModeWin,FM,psource,92,false));
      case 78:return (new TBetCraps11(PModeWin,FM,psource,91,true));
      default:return (new TSprite(PModeWin,FM,psource));
    }
  }
}
//*******************************************************************
