//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  ccboptd.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     12/10/96   M.Perry     original baseline
//  2.0     09/18/97   M.Perry     32-bit conversion.
//********************************************************************
#include "ccboptd.h"
#include <assert.h>
//*******************************************************************
DEFINE_RESPONSE_TABLE1(TCasinoCrapsBetOptionsDlg,TDialog)
  EV_COMMAND(IDC_RESETDEFAULTS_PB,CmResetOptions),
  EV_COMMAND(IDC_CANCEL_PB,CmCancelOptions),
  EV_COMMAND(IDC_ACCEPT_PB,CmAcceptOptions),
  EV_COMMAND(IDC_BUY4AND10_RB,CmBuy4and10),
  EV_COMMAND(IDC_PLACE4AND10_RB,CmPlace4and10),
  EV_COMMAND(IDC_BUY5AND9_RB,CmBuy5and9),
  EV_COMMAND(IDC_PLACE5AND9_RB,CmPlace5and9),
  EV_COMMAND(IDC_BUY6AND8_RB,CmBuy6and8),
  EV_COMMAND(IDC_PLACE6AND8_RB,CmPlace6and8),
END_RESPONSE_TABLE;
//*******************************************************************
TCasinoCrapsBetOptionsDlg::TCasinoCrapsBetOptionsDlg(TWindow *pwin,TCasinoPlayerData *pdat)
:TDialog(pwin,IDD_CRAPSBETOPTIONS),
 PPlayerData(pdat)
{
  assert(PPlayerData);

  PBuy4and10_RB = new TRadioButton(this,IDC_BUY4AND10_RB);
  PPlace4and10_RB = new TRadioButton(this,IDC_PLACE4AND10_RB);

  PBuy5and9_RB = new TRadioButton(this,IDC_BUY5AND9_RB);
  PPlace5and9_RB = new TRadioButton(this,IDC_PLACE5AND9_RB);

  PBuy6and8_RB = new TRadioButton(this,IDC_BUY6AND8_RB);
  PPlace6and8_RB = new TRadioButton(this,IDC_PLACE6AND8_RB);

  PComeBetFreeOdds_ChB = new TCheckBox(this,IDC_COMEBETFREEODDS_CHB);
  PDontComeBetFreeOdds_ChB = new TCheckBox(this,IDC_DONTCOMEBETFREEODDS_CHB);
  PBuyandPlaceBets_ChB = new TCheckBox(this,IDC_BUYANDPLACEBETS_CHB);
  PHardwayBets_ChB = new TCheckBox(this,IDC_HARDWAYBETS_CHB);
}
//*******************************************************************
TCasinoCrapsBetOptionsDlg::~TCasinoCrapsBetOptionsDlg()
{
  delete PBuy4and10_RB;
  delete PPlace4and10_RB;
  delete PBuy5and9_RB;
  delete PPlace5and9_RB;
  delete PBuy6and8_RB;
  delete PPlace6and8_RB;
  delete PComeBetFreeOdds_ChB;
  delete PDontComeBetFreeOdds_ChB;
  delete PBuyandPlaceBets_ChB;
  delete PHardwayBets_ChB;
}
//*******************************************************************
void TCasinoCrapsBetOptionsDlg::SetupWindow()
{
  TDialog::SetupWindow();

  if (GetBuy4and10())
  {
    SetBuy4and10Check(true);
  }
  else
  {
    SetPlace4and10Check(true);
  }

  if (GetBuy5and9())
  {
    SetBuy5and9Check(true);
  }
  else
  {
    SetPlace5and9Check(true);
  }

  if (GetBuy6and8())
  {
    SetBuy6and8Check(true);
  }
  else
  {
    SetPlace6and8Check(true);
  }

  SetComeBetFreeOddsCheck(GetComeBetFreeOddsOn());
  SetDontComeBetFreeOddsCheck(GetDontComeBetFreeOddsOn());
  SetBuyandPlaceBetsCheck(GetBuyandPlaceOn());
  SetHardwayBetsCheck(GetHardwayOn());
}
//*******************************************************************
void TCasinoCrapsBetOptionsDlg::CmResetOptions()
{
  if (GetBuy4and10Def())
  {
    SetBuy4and10Check(true);
    SetPlace4and10Check(false);
  }
  else
  {
    SetBuy4and10Check(false);
    SetPlace4and10Check(true);
  }
  if (GetBuy5and9Def())
  {
    SetBuy5and9Check(true);
    SetPlace5and9Check(false);
  }
  else
  {
    SetBuy5and9Check(false);
    SetPlace5and9Check(true);
  }
  if (GetBuy6and8Def())
  {
    SetBuy6and8Check(true);
    SetPlace6and8Check(false);
  }
  else
  {
    SetBuy6and8Check(false);
    SetPlace6and8Check(true);
  }
  SetComeBetFreeOddsCheck(GetComeBetFreeOddsOnDef());
  SetDontComeBetFreeOddsCheck(GetDontComeBetFreeOddsOnDef());
  SetBuyandPlaceBetsCheck(GetBuyandPlaceOnDef());
  SetHardwayBetsCheck(GetHardwayOnDef());
}
//*******************************************************************
void TCasinoCrapsBetOptionsDlg::CmCancelOptions()
{
  CmCancel();
}
//*******************************************************************
void TCasinoCrapsBetOptionsDlg::CmAcceptOptions()
{
  SetBuy4and10(IsBuy4and10Checked());
  SetBuy5and9(IsBuy5and9Checked());
  SetBuy6and8(IsBuy6and8Checked());
  SetComeBetFreeOddsOn(IsComeBetFreeOddsChecked());
  SetDontComeBetFreeOddsOn(IsDontComeBetFreeOddsChecked());
  SetBuyandPlaceOn(IsBuyandPlaceBetsChecked());
  SetHardwayOn(IsHardwayBetsChecked());
  CmOk();
}
//*******************************************************************
void TCasinoCrapsBetOptionsDlg::CmBuy4and10()
{
  SetBuy4and10Check(true);
  SetPlace4and10Check(false);
}
//*******************************************************************
void TCasinoCrapsBetOptionsDlg::CmPlace4and10()
{
  SetBuy4and10Check(false);
  SetPlace4and10Check(true);
}
//*******************************************************************
void TCasinoCrapsBetOptionsDlg::CmBuy5and9()
{
  SetBuy5and9Check(true);
  SetPlace5and9Check(false);
}
//*******************************************************************
void TCasinoCrapsBetOptionsDlg::CmPlace5and9()
{
  SetBuy5and9Check(false);
  SetPlace5and9Check(true);
}
//*******************************************************************
void TCasinoCrapsBetOptionsDlg::CmBuy6and8()
{
  SetBuy6and8Check(true);
  SetPlace6and8Check(false);
}
//*******************************************************************
void TCasinoCrapsBetOptionsDlg::CmPlace6and8()
{
  SetBuy6and8Check(false);
  SetPlace6and8Check(true);
}
//*******************************************************************

