//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  crbpsp.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0    05/23/96    A.Krist     moved inline functions into .cpp file.
//  2.0    09/18/97    M.Perry     32-bit conversion.
//********************************************************************
#include "ccbpsp.h"
#include "oanm.h"
//*******************************************************************
void TCBetPayOff::SetupAnms()
{
  for(int16 j=0;j<3;j++)
  {
	 for (int16 i=0;i<6;i++)
	 {
		PChips[j][i] = GetAnm(int16(i+(j*6)));
		if (PChips[j][i] == NULL) {AnmError("CBetPayOff","Chips",int16(i+(j*6)));}
		PChips[j][i]->CAD.ClearAutoStart();
		PChips[j][i]->CAD.ClearAutoStop();
		PChips[j][i]->CAD.SetDirStill();
	 }
  }
}
//*******************************************************************
TCBetPayOff::TCBetPayOff(TOgleModeWindow *pmw,TFileMode NewFileMode)
:TSprite(pmw,NewFileMode)
{
  SetToManual();
  NotFound = false;
  NoShow();
  SetupAnms();
}
//********************************************************************
TCBetPayOff::TCBetPayOff(TOgleModeWindow *pmw,TFileMode fm,void *psource)
:TSprite(pmw,fm,psource)
{
  SetToManual();
  NotFound = false;
  NoShow();
  SetupAnms();
}
 //*******************************************************************
TCBetPayOff::~TCBetPayOff()
{
}
//*******************************************************************
void TCBetPayOff::SetNum(int16 pos,TMoney money)
{
  int32 amount = (int32)money;
  if (NotFound) {return;}
  int16 xoffset,yoffset,zoffset;//,i;
  if(pos == 0){pos = 1;}
  else if(pos == 1){pos = 0;}
  int32 num;
  yoffset   = PChips[pos][0]->SAD.GetY();
  zoffset   = PChips[pos][0]->SAD.GetZ();
  xoffset   = PChips[pos][0]->SAD.GetX();
  if(xoffset != PChips[pos][0]->SAD.GetX())
  {
    yoffset = PChips[pos][0]->SAD.GetY();
	 zoffset = PChips[pos][0]->SAD.GetZ();
  }
	 num = amount;
	 num = num%100000l;
	 int32 tenthous = num / 10000;
	 int32 tenthousvalue = tenthous * 10000;
	 int32 thous = (num - tenthousvalue) / 1000;
	 int32 thousvalue = thous * 1000;
	 int32 huns = (num - tenthousvalue - thousvalue) / 100;
	 int32 hunsvalue = huns * 100;
	 int32 twfive = (num - tenthousvalue - thousvalue - hunsvalue) / 25;
	 int32 twfivevalue = twfive * 25;
	 int32 fives = (num - tenthousvalue - thousvalue - hunsvalue - twfivevalue) / 5;
	 int32 fivesvalue = fives * 5;
	 int32 ones = (num - tenthousvalue - thousvalue - hunsvalue - twfivevalue - fivesvalue);


	 if (tenthous)
	 {
		PChips[pos][5]->CAD.SetY(yoffset);
		PChips[pos][5]->CAD.SetZ(zoffset);

		PChips[pos][5]->CAD.SetCurrentFrame(int16(tenthous - 1));
		PChips[pos][5]->Show();
	 }
	 else {PChips[pos][5]->NoShow();}
	 yoffset -= int16(2*tenthous);
	 zoffset += int16(tenthous);

	 if (thous)
	 {
		PChips[pos][4]->CAD.SetY(yoffset);
		PChips[pos][4]->CAD.SetZ(zoffset);

		PChips[pos][4]->CAD.SetCurrentFrame(int16(thous - 1));
		PChips[pos][4]->Show();
	 }
	 else {PChips[pos][4]->NoShow();}
	 yoffset -= int16(2*thous);
	 zoffset += int16(thous);

	 if (huns)
	 {
		PChips[pos][3]->CAD.SetY(yoffset);
		PChips[pos][3]->CAD.SetZ(zoffset);

		PChips[pos][3]->CAD.SetCurrentFrame(int16(huns - 1));
		PChips[pos][3]->Show();
	 }
	 else {PChips[pos][3]->NoShow();}
	 yoffset -= int16(2*huns);
	 zoffset += int16(huns);

	 if (twfive)
	 {
		PChips[pos][2]->CAD.SetY(yoffset);
		PChips[pos][2]->CAD.SetZ(zoffset);

		PChips[pos][2]->CAD.SetCurrentFrame(int16(twfive - 1));
		PChips[pos][2]->Show();
	 }
	 else {PChips[pos][2]->NoShow();}
	 yoffset -= int16(2*twfive);
	 zoffset += int16(twfive);

	 if (fives)
	 {
		PChips[pos][1]->CAD.SetY(yoffset);
		PChips[pos][1]->CAD.SetZ(zoffset);

		PChips[pos][1]->CAD.SetCurrentFrame(int16(fives - 1));
		PChips[pos][1]->Show();
	 }
	 else {PChips[pos][1]->NoShow();}
	 yoffset -= int16(2*fives);
	 zoffset += int16(fives);

	 if (ones)
	 {
		PChips[pos][0]->CAD.SetY(yoffset);
		PChips[pos][0]->CAD.SetZ(zoffset);

		PChips[pos][0]->CAD.SetCurrentFrame(int16(ones - 1));
		PChips[pos][0]->Show();
	 }
	 else {PChips[pos][0]->NoShow();}
	 yoffset -= int16(2*ones);
	 zoffset += int16(ones);
    Update(GetAdjFUC());
}
//*******************************************************************