//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  ccdata.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry          
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     9/9/96     M.Perry     split up cplaydat file.
//  2.0    09/17/97    M.Perry     32-bit conversion.
//********************************************************************
#include "ccdata.h"

//*******************************************************************
TCCSession::TCCSession()
{
  ClearData();
}
//*******************************************************************
void TCCSession::ClearData()
{
 TCasinoSession::ClearData();
 RightBetCurrentShoot = false;
 WrongBetCurrentShoot = false;
 CurrentTotalShootCashWLRB=0;
 CurrentTotalShootCashWLWB=0;
 CurrentWinningStreakRB=0;
 CurrentWinningStreakWB=0;
 CurrentLongestShoot=0;
 CurrentLongestPassStreak=0;
 CurrentLongestDoNotPassStreak=0;
 TotalShoots=0;
 Numpasswins=0;
 Numnaturals=0;
 Numpointsmade=0;
 Numdontpasswins=0;
 Numcrapouts=0;
 Numsevenouts=0;
 LongestShootNumRolls=0;
 LongestPassStreak=0;
 LongestDontPassStreak=0;
 NumShootsBettingRight=0;
 TotalCashBetRightBettor=0;
 AverageCashBetperShootRightBettor=0;
 NumShootsWonCashRightBettor=0;
 NumShootsLostCashRightBettor=0;
 TotalCashWonLostRightBettor=0;
 AvgCashWonLostperShootRightBettor=0;
 LongestWinStreakRightBettor=0;
 MostCashWon1ShootRightBettor=0;
 MostCashLost1ShootRightBettor=0;
 NumShootsBettingWrong=0;
 TotalCashBetWrongBettor=0;
 AverageCashBetperShootWrongBettor=0;
 NumShootsThatWonCashWrongBettor=0;
 NumShootsThatLostCashWrongBettor=0;
 TotalCashWonLostWrongBettor=0;
 AvgCashWonLostperShootWrongBettor=0;
 LongestWinStreakWrongBettor=0;
 MostCashWon1ShootWrongBettor=0;
 MostCashLost1ShootWrongBettor=0;
 PassBetsCash=0;
 PassFreeOddsBetsCash=0;
 DontPassBetsCash=0;
 DontPassFreeOddsBetsCash=0;
 ComeBetsCash=0;
 ComeFreeOddsBetsCash=0;
 DontComeBetsCash=0;
 DontComeFreeOddsBetsCash=0;
 FieldBetsCash=0;
 HardwaysBetsCash=0;
 Big6Big8BetsCash=0;
 Buy4BetsCash=0;
 Place5BetsCash=0;
 Place6BetsCash=0;
 Place8BetsCash=0;
 Place9BetsCash=0;
 Buy10BetsCash=0;
 Place410BetsCash=0;
 Buy59BetsCash=0;
 Buy68BetsCash=0;
 Lay410BetsCash=0;
 Lay59BetsCash=0;
 Lay68BetsCash=0;
 PropositionBetsCash=0;
 TotalCashWon=0;
 TotalCashLost=0;
 PassBetsCashWL=0;
 PassFreeOddsBetsCashWL=0;
 DontPassBetsCashWL=0;
 PassFreeOddsBetsCashWL87=0;
 ComeBetsCashWL=0;
 ComeFreeOddsBetsCashWL=0;
 DontComeBetsCashWL=0;
 DontComeFreeOddsBetsCashWL=0;
 FieldBetsCashWL=0;
 HardwaysBetsCashWL=0;
 Big6Big8BetsCashWL=0;
 Buy4BetsCashWL=0;
 Place5BetsCashWL=0;
 Place6BetsCashWL=0;
 Place8BetsCashWL=0;
 Place9BetsCashWL=0;
 Buy10BetsCashWL=0;
 Place410BetsCashWL=0;
 Buy59BetsCashWL=0;
 Buy68BetsCashWL=0;
 Lay410BetsCashWL=0;
 Lay59BetsCashWL=0;
 Lay68BetsCashWL=0;
 PropositionBetsCashWL=0;
 NumHighPercentageBets=0;
 NumLowPercentageBets=0;
}
//*******************************************************************
void TCCSession::StartSession(TMoney startingcash,int16 subgametype,TMoney denom)
{
  ClearData();
  TCasinoSession::StartSession(startingcash,subgametype,denom);
}
//*******************************************************************
void TCCSession::EndSession(TMoney endingcash)
{
  TCasinoSession::EndSession(endingcash);
}
//*******************************************************************
void TCasinoCData::IncCurrentSession()
{
  if (CurrentSession == 0 && !Sessions[0].Valid)
  {
	 CurrentSession = 0;
	 return;
  }
  CurrentSession++;
  if (CurrentSession >= NUMSESSIONS) {CurrentSession = 0;}
}
//*******************************************************************
int16 TCasinoCData::GetFirstValidSession()
{
  // Sanity check on CurrentSession.
  if ((CurrentSession < 0) || (CurrentSession >= NUMSESSIONS)) {SessionIterator = -1;}
  else {SessionIterator = CurrentSession;}

  if (SessionIterator == -1) {return SessionIterator;}

  // Validity check on current session.
  if (!Sessions[SessionIterator].Valid)
  {
	 SessionIterator = -1;
	 return SessionIterator;
  }
  // currents session is valid, so start looping from current session to find oldest session.
  for (SessionIterator++;SessionIterator<NUMSESSIONS;SessionIterator++)
  {
	 if (Sessions[SessionIterator].Valid) {return SessionIterator;}
  }
  if (CurrentSession == 0) // we already checked all sessions and didn't find a valid one.
  {
	 if (Sessions[0].Valid) {SessionIterator = 0;}
	 else {SessionIterator = -1;}
	 return SessionIterator;
  }

  for (SessionIterator = 0;SessionIterator < CurrentSession;SessionIterator++)
  {
	 if (Sessions[SessionIterator].Valid) {return SessionIterator;}
  }
  SessionIterator = -1;
  return SessionIterator;
}
//*******************************************************************
int16 TCasinoCData::GetPrevValidSession()
{
  int16 prevsession = CurrentSession;
  prevsession--;
  if (prevsession <= 0) {prevsession = NUMSESSIONS - 1;}
  if (!Sessions[prevsession].Valid) {return -1;}
  return prevsession;
}
//*******************************************************************
int16 TCasinoCData::GetNextValidSession()
{
  // check if already found last valid session.
  if (SessionIterator == -1) {return SessionIterator;}
  // go to next session.
  SessionIterator++;
  // check for wraparound.
  if (SessionIterator >= NUMSESSIONS) {SessionIterator = 0;}
  // check if we went all the way around to beginning.
  if (SessionIterator == CurrentSession)
  {
	 SessionIterator = -1;
	 return CurrentSession;
  }
  // validity check on session.
  if (!Sessions[SessionIterator].Valid)
  {
	 SessionIterator = -1;
	 return SessionIterator;
  }
  return SessionIterator;
}
//*******************************************************************
TCasinoCData::TCasinoCData()
{
  ClearData();
}
//*******************************************************************
void TCasinoCData::SetOddsToDefault()
{
  Buy4and10       = GetBuy4and10Def();
  Buy5and9        = GetBuy5and9Def();
  Buy6and8        = GetBuy6and8Def();
  FreeOddsOn      = GetFreeOddsDef();
  DoNotFreeOddsOn = GetDoNotFreeOddsDef();
  BuyandPlaceOn   = GetBuyandPlaceDef();
  HardwayOn       = GetHardwayDef();
}
//*******************************************************************
void TCasinoCData::ClearData()
{
  TCasinoData::ClearData();
  Cumulative = 0;
  SetOddsToDefault();
  for (int i=0;i<NUMSESSIONS;i++)
  {
	 Sessions[i].ClearData();
  }
}
//*******************************************************************
void TCasinoCData::StartSession(TMoney startingcash,int16 subgametype,TMoney denom)
{
  IncCurrentSession();
  Sessions[CurrentSession].StartSession(startingcash,subgametype,denom);
}
//*******************************************************************
void TCasinoCData::EndSession(TMoney endingcash)
{
  Sessions[CurrentSession].EndSession(endingcash);
}
//*******************************************************************

