//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  crdicesp.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0    03/23/96    A.Krist     moved inline functions into .cpp file.
//  2.0    09/18/97    M.Perry     32-bit conversion.
//********************************************************************
#include "ccdicesp.h"
#include "oanm.h"
//*******************************************************************
void TCDice::SetupAnms()
{
  PDice = GetAnm(0);
  if (PDice == NULL) {AnmError("CDice","Dice",0);}
  PDice->CAD.ClearAutoStart();
  PDice->CAD.ClearAutoStop();
  PDice->CAD.SetDirStill();
}
//*******************************************************************
TCDice::TCDice(TOgleModeWindow *pmw,TFileMode NewFileMode)
:TSprite(pmw,NewFileMode)
{
  SetToManual();
  NotFound = false;
  NoShow();
  SetupAnms();
}
//********************************************************************
TCDice::TCDice(TOgleModeWindow *pmw,TFileMode fm,void *psource)
:TSprite(pmw,fm,psource)
{
  SetToManual();
  NotFound = false;
  NoShow();
  SetupAnms();
}
 //*******************************************************************
TCDice::~TCDice()
{
}
//*******************************************************************
void TCDice::ShowDice()
{
  if (NotFound) {return;}
  PDice->CAD.SetCurrentFrame(0);
  PDice->Show();
  Update(GetAdjFUC());
}
//*******************************************************************