//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  ccglord.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     3/26/96   A.Krist      Original baseline
//  2.0    09/18/97   M.Perry      32-bit conversion.
//*******************************************************************
#include "betbuy.h"
#include "betlay.h"
#include "ccglord.h"
#include "cclordst.h"
#include "cclrdmst.h"
#include "ostate.h"
#include <assert.h>
#include <time.h>   //To Set Random Number Generator
#include "ccaskex.h"
#include <stdlib.h> //For Random Number Generator
#include "cascmw.h"
#include "oskitcat.h"
#include "cplaymgr.h"
#include "ccplay.h"
#include "casnames.rh"
#include "casapp.h"
#include "betpass.h"
#include "betdpass.h"
#include "betcnum.h"
#include "betdcnum.h"
#include <owl\dialog.h>
#include "owl\inputdia.h"
#include "orespond.h"
#include "oanm.h"
//*******************************************************************
bool TCasinoCGameLord::PlaceMark(dword &StartFUC,dword &FUCLength,dword &MarkFUC)
{
  switch(Point)
  {
    case 2 : MarkFUC = 7;break;
    case 3 : MarkFUC = 8;break;
    case 4 : MarkFUC = 8;break;
    case 6 : MarkFUC = 9;break;
    case 7 : MarkFUC = 9;break;
    case 8 : MarkFUC = 10;break;
  }
  return ChooseStartSkit(placemark,StartFUC,FUCLength);
};
//*******************************************************************
bool TCasinoCGameLord::BetMade(int16 player)
{
  if(player == -1){return false;}
  for(int16 i=0;i<43;i++)//???
  {
	 if(BetSpot[i]->HasBSBet(player)) {return true;}
  }
  return false;
}
//*******************************************************************
bool TCasinoCGameLord::BetMade()
{
  for(int16 i=0;i<43;i++)//???
  {
	 if(BetSpot[i]->IsBSBet()) {return true;}
  }
  return false;
}
//*******************************************************************
void TCasinoCGameLord::PreRollStats()
{
  return;
}
//*******************************************************************
void TCasinoCGameLord::PostRollStats()
{
  int16 i,j,currentplayer=0;
  currentplayer = activeplayer;
  TCasinoPlayerData *player;
  for(j=0;j<3;j++)
  {
	 player = GetCasPD(j);
	 if(player)
	 {
		activeplayer = j;
		int16 session = player->CData.CurrentSession;
      TCCSession &cs = player->CData.Sessions[session];  // MRP 8/14/97 - added to save code size.
		SetOnOffFlags();
		for(i=0;i<43;i++)//???
		{
		  if(BetSpot[i]->HasBSBet(j))
		  {
			 if(BetSpot[i]->Winner(Dice1,Dice2,Point,COMEOUT,OnOffFlags[0],
                                OnOffFlags[1],OnOffFlags[2],OnOffFlags[3],
                                OnOffFlags[4],OnOffFlags[5],OnOffFlags[6]))
			 {
           cs.Wins++;
           cs.HandsPlayed++;
           cs.TotalBetsCash += BetSpot[i]->GetBSCash(j)+BetSpot[i]->GetBSFreeOdds(j);
           cs.TotalCashWon += BetSpot[i]->WinBSPayOff(j,int16(Dice1+Dice2));
			  switch(BetSpot[i]->SpotType)
			  {
				 case Pass         : cs.PassBetsCash += BetSpot[i]->GetBSCash(j);
											if(BetSpot[i]->GetBSFreeOdds(j) != 0)
											{
                                   cs.Wins++;
                                   cs.HandsPlayed++;
											}
											cs.PassFreeOddsBetsCash += BetSpot[i]->GetBSFreeOdds(j);
											cs.PassBetsCashWL += BetSpot[i]->GetBSCash(j)*BetSpot[i]->Odds();
											cs.PassFreeOddsBetsCashWL += BetSpot[i]->TrueOdds(BetSpot[i]->GetBSFreeOdds(j),int16(Dice1+Dice2));
                                 cs.NumHighPercentageBets++;
											if(BetSpot[i]->GetBSFreeOdds(j) > 0l)
											{
                                   cs.NumHighPercentageBets++;
                                 }
                                 cs.RightBetCurrentShoot = true;
                                 cs.TotalCashBetRightBettor += BetSpot[i]->GetBSCash(j)+BetSpot[i]->GetBSFreeOdds(j);
											cs.TotalCashWonLostRightBettor += BetSpot[i]->WinBSPayOff(j,int16(Dice1+Dice2));
											cs.CurrentTotalShootCashWLRB += BetSpot[i]->WinBSPayOff(j,int16(Dice1+Dice2));
											break;
				 case PassNot      : cs.DontPassBetsCash += BetSpot[i]->GetBSCash(j);
											if(BetSpot[i]->GetBSFreeOdds(j) != 0)
											{
                                   cs.Wins++;
                                   cs.HandsPlayed++;
											}
											cs.DontPassFreeOddsBetsCash += BetSpot[i]->GetBSFreeOdds(j);
											cs.DontPassBetsCashWL += BetSpot[i]->GetBSCash(j)*BetSpot[i]->Odds();
											cs.PassFreeOddsBetsCashWL87 += BetSpot[i]->TrueOdds(BetSpot[i]->GetBSFreeOdds(j),int16(Dice1+Dice2));
                                 cs.NumHighPercentageBets++;
											if(BetSpot[i]->GetBSFreeOdds(j) > 0l)
											{
                                   cs.NumHighPercentageBets++;
                                 }
                                 cs.WrongBetCurrentShoot = true;
											cs.TotalCashBetWrongBettor += BetSpot[i]->GetBSCash(j)+BetSpot[i]->GetBSFreeOdds(j);
											cs.TotalCashWonLostWrongBettor += BetSpot[i]->WinBSPayOff(j,int16(Dice1+Dice2));
											cs.CurrentTotalShootCashWLWB += BetSpot[i]->WinBSPayOff(j,int16(Dice1+Dice2));
											break;
				 case Come         : cs.ComeBetsCash += BetSpot[i]->GetBSCash(j);
											cs.ComeBetsCashWL += BetSpot[i]->GetBSCash(j)*BetSpot[i]->Odds();
                                 cs.NumHighPercentageBets++;
                                 cs.RightBetCurrentShoot = true;
											cs.TotalCashBetRightBettor += BetSpot[i]->GetBSCash(j)+BetSpot[i]->GetBSFreeOdds(j);
											cs.TotalCashWonLostRightBettor += BetSpot[i]->WinBSPayOff(j,int16(Dice1+Dice2));
											cs.CurrentTotalShootCashWLRB += BetSpot[i]->WinBSPayOff(j,int16(Dice1+Dice2));
											break;
				 case ComeNum      : cs.ComeBetsCash += BetSpot[i]->GetBSCash(j);
											if(BetSpot[i]->GetBSFreeOdds(j) != 0)
											{
                                   cs.Wins++;
                                   cs.HandsPlayed++;
											}
											cs.ComeFreeOddsBetsCash += BetSpot[i]->GetBSFreeOdds(j);
											cs.ComeBetsCashWL += BetSpot[i]->GetBSCash(j)*BetSpot[i]->Odds();
											cs.ComeFreeOddsBetsCashWL += BetSpot[i]->TrueOdds(BetSpot[i]->GetBSFreeOdds(j),int16(Dice1+Dice2));
                                 cs.NumHighPercentageBets++;
											if(BetSpot[i]->GetBSFreeOdds(j) > 0l)
											{
                                   cs.NumHighPercentageBets++;
                                 }
                                 cs.RightBetCurrentShoot = true;
											cs.TotalCashBetRightBettor += BetSpot[i]->GetBSCash(j)+BetSpot[i]->GetBSFreeOdds(j);
											cs.TotalCashWonLostRightBettor += BetSpot[i]->WinBSPayOff(j,int16(Dice1+Dice2));
											cs.CurrentTotalShootCashWLRB += BetSpot[i]->WinBSPayOff(j,int16(Dice1+Dice2));
											break;
				 case ComeNot      : cs.DontComeBetsCash += BetSpot[i]->GetBSCash(j);
											cs.DontComeBetsCashWL += BetSpot[i]->GetBSCash(j)*BetSpot[i]->Odds();
                                 cs.NumHighPercentageBets++;
                                 cs.WrongBetCurrentShoot = true;
											cs.TotalCashBetWrongBettor += BetSpot[i]->GetBSCash(j)+BetSpot[i]->GetBSFreeOdds(j);
											cs.TotalCashWonLostWrongBettor += BetSpot[i]->WinBSPayOff(j,int16(Dice1+Dice2));
											cs.CurrentTotalShootCashWLWB += BetSpot[i]->WinBSPayOff(j,int16(Dice1+Dice2));
											break;
				 case DoNotComeNum : cs.DontComeBetsCash += BetSpot[i]->GetBSCash(j);
											if(BetSpot[i]->GetBSFreeOdds(j) != 0)
											{
                                   cs.Wins++;
                                   cs.HandsPlayed++;
											}
											cs.DontComeFreeOddsBetsCash += BetSpot[i]->GetBSFreeOdds(j);
											cs.DontComeBetsCashWL += BetSpot[i]->GetBSCash(j)*BetSpot[i]->Odds();
											cs.DontComeFreeOddsBetsCashWL += BetSpot[i]->TrueOdds(BetSpot[i]->GetBSFreeOdds(j),int16(Dice1+Dice2));
                                 cs.NumHighPercentageBets++;
											if(BetSpot[i]->GetBSFreeOdds(j) > 0l)
											{
                                   cs.NumHighPercentageBets++;
                                 }
                                 cs.WrongBetCurrentShoot = true;
											cs.TotalCashBetWrongBettor += BetSpot[i]->GetBSCash(j)+BetSpot[i]->GetBSFreeOdds(j);
											cs.TotalCashWonLostWrongBettor += BetSpot[i]->WinBSPayOff(j,int16(Dice1+Dice2));
											cs.CurrentTotalShootCashWLWB += BetSpot[i]->WinBSPayOff(j,int16(Dice1+Dice2));
											break;
				 case Hard         : cs.HardwaysBetsCash += BetSpot[i]->GetBSCash(j);
											cs.HardwaysBetsCashWL += BetSpot[i]->GetBSCash(j)*BetSpot[i]->Odds();
                                 cs.NumLowPercentageBets++;
											break;
				 case Field        : cs.FieldBetsCash += BetSpot[i]->GetBSCash(j);
											cs.FieldBetsCashWL += BetSpot[i]->GetBSCash(j)*BetSpot[i]->Odds();
                                 cs.NumLowPercentageBets++;
											break;
				 case Big          : cs.Big6Big8BetsCash += BetSpot[i]->GetBSCash(j);
											cs.Big6Big8BetsCashWL += BetSpot[i]->GetBSCash(j)*BetSpot[i]->Odds();
                                 cs.NumLowPercentageBets++;
                                 cs.RightBetCurrentShoot = true;
											cs.TotalCashBetRightBettor += BetSpot[i]->GetBSCash(j)+BetSpot[i]->GetBSFreeOdds(j);
											cs.TotalCashWonLostRightBettor += BetSpot[i]->WinBSPayOff(j,int16(Dice1+Dice2));
											cs.CurrentTotalShootCashWLRB += BetSpot[i]->WinBSPayOff(j,int16(Dice1+Dice2));
											break;
				 case Buy          : if(((TBetBuy *)BetSpot[i])->Bought[j])
											{
                                   cs.NumLowPercentageBets++;
											  if(((TBetBuy *)BetSpot[i])->BuyPoint == 2)//4
											  {
												 cs.Buy4BetsCash += BetSpot[i]->GetBSCash(j);
												 cs.Buy4BetsCashWL += BetSpot[i]->WinBSPayOff(j,int16(Dice1+Dice2));
											  }
											  else if(((TBetBuy *)BetSpot[i])->BuyPoint == 8)//10
											  {
												 cs.Buy10BetsCash += BetSpot[i]->GetBSCash(j);
												 cs.Buy10BetsCashWL += BetSpot[i]->WinBSPayOff(j,int16(Dice1+Dice2));
											  }
											  else if(((TBetBuy *)BetSpot[i])->BuyPoint == 3 ||
														 ((TBetBuy *)BetSpot[i])->BuyPoint == 7   )//5or9
											  {
												 cs.Buy59BetsCash += BetSpot[i]->GetBSCash(j);
												 cs.Buy59BetsCashWL += BetSpot[i]->WinBSPayOff(j,int16(Dice1+Dice2));
											  }
											  else if(((TBetBuy *)BetSpot[i])->BuyPoint == 4 ||
														 ((TBetBuy *)BetSpot[i])->BuyPoint == 6   )//6or8
											  {
												 cs.Buy68BetsCash += BetSpot[i]->GetBSCash(j);
												 cs.Buy68BetsCashWL += BetSpot[i]->WinBSPayOff(j,int16(Dice1+Dice2));
											  }
											}
											else
											{
											  if(((TBetBuy *)BetSpot[i])->BuyPoint == 3)//5
											  {
												 cs.Place5BetsCash += BetSpot[i]->GetBSCash(j);
												 cs.Place5BetsCashWL += BetSpot[i]->WinBSPayOff(j,int16(Dice1+Dice2));
                                     cs.NumLowPercentageBets++;
											  }
											  else if(((TBetBuy *)BetSpot[i])->BuyPoint == 4)//6
											  {
												 cs.Place6BetsCash += BetSpot[i]->GetBSCash(j);
												 cs.Place6BetsCashWL += BetSpot[i]->WinBSPayOff(j,int16(Dice1+Dice2));
                                     cs.NumHighPercentageBets++;
											  }
											  else if(((TBetBuy *)BetSpot[i])->BuyPoint == 6)//8
											  {
												 cs.Place8BetsCash += BetSpot[i]->GetBSCash(j);
												 cs.Place8BetsCashWL += BetSpot[i]->WinBSPayOff(j,int16(Dice1+Dice2));
                                     cs.NumHighPercentageBets++;
											  }
											  else if(((TBetBuy *)BetSpot[i])->BuyPoint == 7)//9
											  {
												 cs.Place9BetsCash += BetSpot[i]->GetBSCash(j);
												 cs.Place9BetsCashWL += BetSpot[i]->WinBSPayOff(j,int16(Dice1+Dice2));
                                     cs.NumLowPercentageBets++;
											  }
											  else if(((TBetBuy *)BetSpot[i])->BuyPoint == 2 ||
														 ((TBetBuy *)BetSpot[i])->BuyPoint == 8   )//4or10
											  {
												 cs.Place410BetsCash += BetSpot[i]->GetBSCash(j);
												 cs.Place410BetsCashWL += BetSpot[i]->WinBSPayOff(j,int16(Dice1+Dice2));
                                     cs.NumLowPercentageBets++;
											  }
											}
                                 cs.RightBetCurrentShoot = true;
											cs.TotalCashBetRightBettor += BetSpot[i]->GetBSCash(j)+BetSpot[i]->GetBSFreeOdds(j);
											cs.TotalCashWonLostRightBettor += BetSpot[i]->WinBSPayOff(j,int16(Dice1+Dice2));
											cs.CurrentTotalShootCashWLRB += BetSpot[i]->WinBSPayOff(j,int16(Dice1+Dice2));
											break;
				 case Lay          : if(((TBetLay *)BetSpot[i])->LayPoint == 2 ||
												((TBetLay *)BetSpot[i])->LayPoint == 8   )//4or10
											{
												 cs.Lay410BetsCash += BetSpot[i]->GetBSCash(j);
												 cs.Lay410BetsCashWL += BetSpot[i]->WinBSPayOff(j,int16(Dice1+Dice2));
											}
											else if(((TBetBuy *)BetSpot[i])->BuyPoint == 3 ||
													  ((TBetBuy *)BetSpot[i])->BuyPoint == 7   )//5or9
											{
												 cs.Lay59BetsCash += BetSpot[i]->GetBSCash(j);
												 cs.Lay59BetsCashWL += BetSpot[i]->WinBSPayOff(j,int16(Dice1+Dice2));
											}
											else if(((TBetBuy *)BetSpot[i])->BuyPoint == 4 ||
													  ((TBetBuy *)BetSpot[i])->BuyPoint == 6   )//6or8
											{
												 cs.Lay68BetsCash += BetSpot[i]->GetBSCash(j);
												 cs.Lay68BetsCashWL += BetSpot[i]->WinBSPayOff(j,int16(Dice1+Dice2));
											}
                                 cs.NumLowPercentageBets++;
                                 cs.WrongBetCurrentShoot = true;
											cs.TotalCashBetWrongBettor += BetSpot[i]->GetBSCash(j)+BetSpot[i]->GetBSFreeOdds(j);
											cs.TotalCashWonLostWrongBettor += BetSpot[i]->WinBSPayOff(j,int16(Dice1+Dice2));
											cs.CurrentTotalShootCashWLWB += BetSpot[i]->WinBSPayOff(j,int16(Dice1+Dice2));
											break;
				 default           : cs.PropositionBetsCash += BetSpot[i]->GetBSCash(j);
											cs.PropositionBetsCashWL += BetSpot[i]->WinBSPayOff(j,int16(Dice1+Dice2));
                                 cs.NumLowPercentageBets++;
											break;
			  }
			 }
			 else if(BetSpot[i]->Loser(Dice1,Dice2,Point,COMEOUT,OnOffFlags[0],OnOffFlags[1],OnOffFlags[2],OnOffFlags[3],OnOffFlags[4],OnOffFlags[5],OnOffFlags[6]))
			 {
           cs.Losses++;
           cs.HandsPlayed++;
			  cs.TotalBetsCash += BetSpot[i]->GetBSCash(j)+BetSpot[i]->GetBSFreeOdds(j);
			  cs.TotalCashLost += BetSpot[i]->GetBSCash(j)+BetSpot[i]->GetBSFreeOdds(j);;
			  switch(BetSpot[i]->SpotType)
			  {
				 case Pass         : cs.PassBetsCash += BetSpot[i]->GetBSCash(j);
											if(BetSpot[i]->GetBSFreeOdds(j) != 0)
											{
                                   cs.Losses++;
                                   cs.HandsPlayed++;
											}
											cs.PassFreeOddsBetsCash += BetSpot[i]->GetBSFreeOdds(j);
											cs.PassBetsCashWL -= BetSpot[i]->GetBSCash(j);
											cs.PassFreeOddsBetsCashWL -= BetSpot[i]->GetBSFreeOdds(j);
                                 cs.NumHighPercentageBets++;
											if(BetSpot[i]->GetBSFreeOdds(j) > 0l)
											{
                                   cs.NumHighPercentageBets++;
                                 }
                                 cs.RightBetCurrentShoot = true;
											cs.TotalCashBetRightBettor += BetSpot[i]->GetBSCash(j)+BetSpot[i]->GetBSFreeOdds(j);
											cs.TotalCashWonLostRightBettor -= BetSpot[i]->GetBSCash(j)+BetSpot[i]->GetBSFreeOdds(j);
											cs.CurrentTotalShootCashWLRB -= BetSpot[i]->GetBSCash(j)+BetSpot[i]->GetBSFreeOdds(j);
											break;
				 case PassNot      : cs.DontPassBetsCash += BetSpot[i]->GetBSCash(j);
											if(BetSpot[i]->GetBSFreeOdds(j) != 0)
											{
                                   cs.Losses++;
                                   cs.HandsPlayed++;
											}
											cs.DontPassFreeOddsBetsCash += BetSpot[i]->GetBSFreeOdds(j);
											cs.DontPassBetsCashWL -= BetSpot[i]->GetBSCash(j);
											cs.PassFreeOddsBetsCashWL87 -= BetSpot[i]->GetBSFreeOdds(j);
                                 cs.NumHighPercentageBets++;
											if(BetSpot[i]->GetBSFreeOdds(j) > 0l)
											{
                                   cs.NumHighPercentageBets++;
                                 }
                                 cs.WrongBetCurrentShoot = true;
											cs.TotalCashBetWrongBettor += BetSpot[i]->GetBSCash(j)+BetSpot[i]->GetBSFreeOdds(j);
											cs.TotalCashWonLostWrongBettor -= BetSpot[i]->GetBSCash(j)+BetSpot[i]->GetBSFreeOdds(j);
											cs.CurrentTotalShootCashWLWB -= BetSpot[i]->GetBSCash(j)+BetSpot[i]->GetBSFreeOdds(j);
											break;
				 case Come         : cs.ComeBetsCash += BetSpot[i]->GetBSCash(j);
											cs.ComeBetsCashWL -= BetSpot[i]->GetBSCash(j);
                                 cs.NumHighPercentageBets++;
                                 cs.RightBetCurrentShoot = true;
											cs.TotalCashBetRightBettor += BetSpot[i]->GetBSCash(j)+BetSpot[i]->GetBSFreeOdds(j);
											cs.TotalCashWonLostRightBettor -= BetSpot[i]->GetBSCash(j)+BetSpot[i]->GetBSFreeOdds(j);
											cs.CurrentTotalShootCashWLRB -= BetSpot[i]->GetBSCash(j)+BetSpot[i]->GetBSFreeOdds(j);
											break;
				 case ComeNum      : cs.ComeBetsCash += BetSpot[i]->GetBSCash(j);
											if(BetSpot[i]->GetBSFreeOdds(j) != 0)
											{
                                   cs.Losses++;
                                   cs.HandsPlayed++;
											}
											cs.ComeFreeOddsBetsCash += BetSpot[i]->GetBSFreeOdds(j);
											cs.ComeBetsCashWL -= BetSpot[i]->GetBSCash(j)*BetSpot[i]->Odds();
											cs.ComeFreeOddsBetsCashWL -= BetSpot[i]->GetBSFreeOdds(j);
                                 cs.NumHighPercentageBets++;
											if(BetSpot[i]->GetBSFreeOdds(j) > 0l)
											{
                                   cs.NumHighPercentageBets++;
                                 }
                                 cs.RightBetCurrentShoot = true;
											cs.TotalCashBetRightBettor += BetSpot[i]->GetBSCash(j)+BetSpot[i]->GetBSFreeOdds(j);
											cs.TotalCashWonLostRightBettor -= BetSpot[i]->GetBSCash(j)+BetSpot[i]->GetBSFreeOdds(j);
											cs.CurrentTotalShootCashWLRB -= BetSpot[i]->GetBSCash(j)+BetSpot[i]->GetBSFreeOdds(j);
											break;
				 case ComeNot      : cs.DontComeBetsCash += BetSpot[i]->GetBSCash(j);
                                 cs.DontComeBetsCashWL -= BetSpot[i]->GetBSCash(j);
                                 cs.NumHighPercentageBets++;
                                 cs.WrongBetCurrentShoot = true;
                                 cs.TotalCashBetWrongBettor += BetSpot[i]->GetBSCash(j)+BetSpot[i]->GetBSFreeOdds(j);
                                 cs.TotalCashWonLostWrongBettor -= BetSpot[i]->GetBSCash(j)+BetSpot[i]->GetBSFreeOdds(j);
                                 cs.CurrentTotalShootCashWLWB -= BetSpot[i]->GetBSCash(j)+BetSpot[i]->GetBSFreeOdds(j);
											break;
				 case DoNotComeNum : cs.DontComeBetsCash += BetSpot[i]->GetBSCash(j);
											if(BetSpot[i]->GetBSFreeOdds(j) != 0)
											{
                                   cs.Losses++;
                                   cs.HandsPlayed++;
											}
                                 cs.DontComeFreeOddsBetsCash += BetSpot[i]->GetBSFreeOdds(j);
                                 cs.DontComeBetsCashWL -= BetSpot[i]->GetBSCash(j);
                                 cs.DontComeFreeOddsBetsCashWL -= BetSpot[i]->GetBSFreeOdds(j);
                                 cs.NumHighPercentageBets++;
											if(BetSpot[i]->GetBSFreeOdds(j) > 0l)
											{
                                   cs.NumHighPercentageBets++;
                                 }
                                 cs.WrongBetCurrentShoot = true;
                                 cs.TotalCashBetWrongBettor += BetSpot[i]->GetBSCash(j)+BetSpot[i]->GetBSFreeOdds(j);
                                 cs.TotalCashWonLostWrongBettor -= BetSpot[i]->GetBSCash(j)+BetSpot[i]->GetBSFreeOdds(j);
                                 cs.CurrentTotalShootCashWLWB -= BetSpot[i]->GetBSCash(j)+BetSpot[i]->GetBSFreeOdds(j);
											break;
				 case Hard         : cs.HardwaysBetsCash += BetSpot[i]->GetBSCash(j);
                                 cs.HardwaysBetsCashWL -= BetSpot[i]->GetBSCash(j);
                                 cs.NumLowPercentageBets++;
											break;
				 case Field        : cs.FieldBetsCash += BetSpot[i]->GetBSCash(j);
                                 cs.FieldBetsCashWL -= BetSpot[i]->GetBSCash(j);
                                 cs.NumLowPercentageBets++;
											break;
				 case Big          : cs.Big6Big8BetsCash += BetSpot[i]->GetBSCash(j);
                                 cs.Big6Big8BetsCashWL -= BetSpot[i]->GetBSCash(j);
                                 cs.NumLowPercentageBets++;
                                 cs.RightBetCurrentShoot = true;
                                 cs.TotalCashBetRightBettor += BetSpot[i]->GetBSCash(j)+BetSpot[i]->GetBSFreeOdds(j);
                                 cs.TotalCashWonLostRightBettor -= BetSpot[i]->GetBSCash(j);
                                 cs.CurrentTotalShootCashWLRB -= BetSpot[i]->GetBSCash(j);
											break;
				 case Buy          : if(((TBetBuy *)BetSpot[i])->Bought[j])
											{
                                   cs.NumLowPercentageBets++;
											  if(((TBetBuy *)BetSpot[i])->BuyPoint == 2)//4
											  {
                                     cs.Buy4BetsCash += BetSpot[i]->GetBSCash(j);
                                     cs.Buy4BetsCashWL -= BetSpot[i]->GetBSCash(j);
											  }
											  else if(((TBetBuy *)BetSpot[i])->BuyPoint == 8)//10
											  {
                                     cs.Buy10BetsCash += BetSpot[i]->GetBSCash(j);
                                     cs.Buy10BetsCashWL -= BetSpot[i]->GetBSCash(j);
											  }
											  else if(((TBetBuy *)BetSpot[i])->BuyPoint == 3 ||
														 ((TBetBuy *)BetSpot[i])->BuyPoint == 7   )//5or9
											  {
                                     cs.Buy59BetsCash += BetSpot[i]->GetBSCash(j);
                                     cs.Buy59BetsCashWL -= BetSpot[i]->GetBSCash(j);
											  }
											  else if(((TBetBuy *)BetSpot[i])->BuyPoint == 4 ||
														 ((TBetBuy *)BetSpot[i])->BuyPoint == 6   )//6or8
											  {
                                     cs.Buy68BetsCash += BetSpot[i]->GetBSCash(j);
                                     cs.Buy68BetsCashWL -= BetSpot[i]->GetBSCash(j);
											  }
											}
											else
											{
											  if(((TBetBuy *)BetSpot[i])->BuyPoint == 3)//5
											  {
                                     cs.Place5BetsCash += BetSpot[i]->GetBSCash(j);
                                     cs.Place5BetsCashWL -= BetSpot[i]->GetBSCash(j);
                                     cs.NumLowPercentageBets++;
											  }
											  else if(((TBetBuy *)BetSpot[i])->BuyPoint == 4)//6
											  {
                                     cs.Place6BetsCash += BetSpot[i]->GetBSCash(j);
                                     cs.Place6BetsCashWL -= BetSpot[i]->GetBSCash(j); // MRP 8/14/97 - found probable typo, was sub nhpbets++,ha!
                                     cs.NumHighPercentageBets++;
											  }
											  else if(((TBetBuy *)BetSpot[i])->BuyPoint == 6)//8
											  {
                                     cs.Place8BetsCash += BetSpot[i]->GetBSCash(j);
                                     cs.NumHighPercentageBets++;
                                     cs.Place8BetsCashWL -= BetSpot[i]->GetBSCash(j);
											  }
											  else if(((TBetBuy *)BetSpot[i])->BuyPoint == 7)//9
											  {
                                     cs.Place9BetsCash += BetSpot[i]->GetBSCash(j);
                                     cs.Place9BetsCashWL -= BetSpot[i]->GetBSCash(j);
                                     cs.NumLowPercentageBets++;
											  }
											  else if(((TBetBuy *)BetSpot[i])->BuyPoint == 2 ||
														 ((TBetBuy *)BetSpot[i])->BuyPoint == 8   )//4or10
											  {
                                     cs.Place410BetsCash += BetSpot[i]->GetBSCash(j);
                                     cs.Place410BetsCashWL -= BetSpot[i]->GetBSCash(j);
                                     cs.NumLowPercentageBets++;
											  }
											}
                                 cs.RightBetCurrentShoot = true;
                                 cs.TotalCashBetRightBettor += BetSpot[i]->GetBSCash(j)+BetSpot[i]->GetBSFreeOdds(j);
                                 cs.TotalCashWonLostRightBettor -= BetSpot[i]->GetBSCash(j)+BetSpot[i]->GetBSFreeOdds(j);
                                 cs.CurrentTotalShootCashWLRB -= BetSpot[i]->GetBSCash(j)+BetSpot[i]->GetBSFreeOdds(j);
											break;
				 case Lay          : if(((TBetLay *)BetSpot[i])->LayPoint == 2 ||
												((TBetLay *)BetSpot[i])->LayPoint == 8   )//4or10
											{
                                     cs.Lay410BetsCash += BetSpot[i]->GetBSCash(j);
                                     cs.Lay410BetsCashWL -= BetSpot[i]->GetBSCash(j);
											}
											else if(((TBetBuy *)BetSpot[i])->BuyPoint == 3 ||
													  ((TBetBuy *)BetSpot[i])->BuyPoint == 7   )//5or9
											{
                                     cs.Lay59BetsCash += BetSpot[i]->GetBSCash(j);
                                     cs.Lay59BetsCashWL -= BetSpot[i]->GetBSCash(j);
											}
											else if(((TBetBuy *)BetSpot[i])->BuyPoint == 4 ||
													  ((TBetBuy *)BetSpot[i])->BuyPoint == 6   )//6or8
											{
                                     cs.Lay68BetsCash += BetSpot[i]->GetBSCash(j);
                                     cs.Lay68BetsCashWL -= BetSpot[i]->GetBSCash(j);
											}
                                 cs.NumLowPercentageBets++;
                                 cs.WrongBetCurrentShoot = true;
                                 cs.TotalCashBetWrongBettor += BetSpot[i]->GetBSCash(j)+BetSpot[i]->GetBSFreeOdds(j);
                                 cs.TotalCashWonLostWrongBettor -= BetSpot[i]->GetBSCash(j)+BetSpot[i]->GetBSFreeOdds(j);
                                 cs.CurrentTotalShootCashWLWB -= BetSpot[i]->GetBSCash(j)+BetSpot[i]->GetBSFreeOdds(j);
											break;
				 default           : cs.PropositionBetsCash += BetSpot[i]->GetBSCash(j);
                                 cs.PropositionBetsCashWL -= BetSpot[i]->GetBSCash(j);
                                 cs.NumLowPercentageBets++;
											break;
			  }
			 }

		  }
		}
	 }
  }
  activeplayer = currentplayer;
  SetOnOffFlags();
  return;
}
//*******************************************************************
void TCasinoCGameLord::ShowMarker()
{
	return;
}
//*******************************************************************
void  TCasinoCGameLord::ShuttingDown()
{
  if(shutdownstate == 0)
  {
	 if(GetCasPD(0))
	 {
		NotifyPlayerDeActivation(0);
	 }
	 if(GetCasPD(1))
	 {
		NotifyPlayerDeActivation(1);
	 }
	 if(GetCasPD(2))
	 {
		NotifyPlayerDeActivation(2);
	 }
  }
  else if(shutdownstate == 1)
  {
	 if(GetCasPD(0))
	 {
		GetCasPD(0)->EndCSession();
	 }
	 if(GetCasPD(1))
	 {
		GetCasPD(1)->EndCSession();
	 }
	 if(GetCasPD(2))
	 {
		GetCasPD(2)->EndCSession();
	 }
  }

}
//*******************************************************************
void  TCasinoCGameLord::SwitchToPlayer(int16 player)
{
  if(GetCasPD(player))
  {
	 if(activeplayer != player && activeplayer != -1)
	 {
		coinsplayed = 0l;
		GetCPlayer(activeplayer)->coinsplayed = 0l;
		GetCasPD(activeplayer)->Columns[0] = Chips->col1;
		GetCasPD(activeplayer)->Columns[1] = Chips->col2;
		GetCasPD(activeplayer)->Columns[2] = Chips->col3;
		GetCasPD(activeplayer)->Columns[3] = Chips->col4;
		GetCasPD(activeplayer)->Columns[4] = Chips->col5;
		GetCasPD(activeplayer)->Columns[5] = Chips->col6;
	 }

	 if(activeplayer != player)
	 {
		switch(activeplayer)
		{
			 case 0 : NamePlate1->NoShowNamePlate();break;
			 case 1 : NamePlate2->NoShowNamePlate();break;
			 case 2 : NamePlate3->NoShowNamePlate();break;
		}
		activeplayer = player;
		if(!BetMade(activeplayer)){Button5->ShowGray();}
		else{Button5->ShowVoidUp();}
		if(GetCash(activeplayer) > GetCPlayer(activeplayer)->lastbet)
		{
		  coinsplayed += GetCPlayer(activeplayer)->lastbet;
		  GetCPlayer(activeplayer)->coinsplayed += GetCPlayer(activeplayer)->lastbet;
		  BetAmountDisplay->SetNum(GetCPlayer(activeplayer)->lastbet);
		}
		else
		{
		  coinsplayed = 0;
		  GetCPlayer(activeplayer)->coinsplayed = 0l;
		  GetCPlayer(activeplayer)->lastbet = 0l;
		  BetAmountDisplay->SetNum(0l);
		}
		BankCashDisplay->SetNum(GetCash(activeplayer));
		Chips->SetupCols(GetCasPD(player)->Cash,GetCasPD(player)->Columns[0],
						  GetCasPD(player)->Columns[1],GetCasPD(player)->Columns[2],
						  GetCasPD(player)->Columns[3],GetCasPD(player)->Columns[4],
						  GetCasPD(player)->Columns[5],false);
		if(GetNumActivePlayers() > 1)
		{
		  string name;
		  name = GetCasPD(player)->GetName();
		  switch(player)
		  {
			 case 0 : NamePlate1->ShowNamePlateString(name);break;
			 case 1 : NamePlate2->ShowNamePlateString(name);break;
			 case 2 : NamePlate3->ShowNamePlateString(name);break;
		  }
		}
	 }
  }
}
//*******************************************************************
void  TCasinoCGameLord::CyclePlayers()
{
  if(activeplayer != -1)
  {
	 SwitchToPlayer(NextSlotNum(activeplayer));
  }
}
//*******************************************************************
bool TCasinoCGameLord::IsWinner()
{
  SetOnOffFlags();
  for(int16 i=0;i<43;i++)//???
  {
	 if(BetSpot[i]->Winner(Dice1,Dice2,Point,COMEOUT,OnOffFlags[0],OnOffFlags[1],OnOffFlags[2],OnOffFlags[3],OnOffFlags[4],OnOffFlags[5],OnOffFlags[6]) && BetSpot[i]->IsBSBet())
	 {
		CurrentBetPaid = i;return true;
	 }
  }
  return false;
}
//*******************************************************************
void TCasinoCGameLord::NotifyPlayerActivation(int16 slotnum)
{
  if(GetCasPD(slotnum))
  {
	 GetCasPD(slotnum)->StartCSession(SubGameType,GameDenom);
	 if(GetCash(slotnum) >= 5l)
	 {
		GetCPlayer(slotnum)->lastbet = 5l;
	 }

	 if(activeplayer == -1)
	 {
	  activeplayer = slotnum;
	  Button5->ShowGray();
	  Shooter = slotnum;
	  Chips->SetupCols(GetCasPD(slotnum)->Cash,GetCasPD(slotnum)->Columns[0],
						  GetCasPD(slotnum)->Columns[1],GetCasPD(slotnum)->Columns[2],
						  GetCasPD(slotnum)->Columns[3],GetCasPD(slotnum)->Columns[4],
						  GetCasPD(slotnum)->Columns[5],false);
	  BankCashDisplay->SetNum(GetCash(activeplayer));
		string name;
		name = GetCasPD(activeplayer)->GetName();
		switch(slotnum)
		  {
			 case 0 : NamePlate1->ShowNamePlateString(name);break;
			 case 1 : NamePlate2->ShowNamePlateString(name);break;
			 case 2 : NamePlate3->ShowNamePlateString(name);break;
		  }
	 }
  }
}
//*******************************************************************
void TCasinoCGameLord::NotifyPlayerDeActivation(int16 slotnum)
{
  if(GetCasPD(slotnum))
  {
	 int16 i=0;
	 switch(slotnum)
	 {
			 case 0 : NamePlate1->NoShowNamePlate();break;
			 case 1 : NamePlate2->NoShowNamePlate();break;
			 case 2 : NamePlate3->NoShowNamePlate();break;
	 }
	 for(i=0;i<43;i++)
	 {
		 GetCasPD(slotnum)->Cash += BetSpot[i]->SubBSCash(slotnum,COMEOUT);
	 }
	 for(i=0;i<43;i++)
	 {
		BetSpot[i]->WinBSCash(slotnum,2); //Clear bets lost due to deactivation
		BetSpot[i]->SetNum();
	 }
	 if(activeplayer == slotnum)
	 {
		coinsplayed = 0l;
		GetCasPD(slotnum)->Columns[0] = Chips->col1;
		GetCasPD(slotnum)->Columns[1] = Chips->col2;
		GetCasPD(slotnum)->Columns[2] = Chips->col3;
		GetCasPD(slotnum)->Columns[3] = Chips->col4;
		GetCasPD(slotnum)->Columns[4] = Chips->col5;
		GetCasPD(slotnum)->Columns[5] = Chips->col6;
	 }
	 if(GetNumActivePlayers() == 1)
	 {
		Chips->NoShow();
		Button5->ShowGray();
		NamePlate1->NoShow();NamePlate2->NoShow();NamePlate3->NoShow();
		coinsplayed = 0l;
		if(GetCPlayer(activeplayer))
		{
		  GetCPlayer(activeplayer)->coinsplayed = 0l;
		  GetCPlayer(activeplayer)->lastbet = 0l;
		}
		BetAmountDisplay->SetNum(0l);
		BankCashDisplay->SetNum(0l);
		activeplayer = -1;
		Shooter = -1;
	 }
	 if(GetNumActivePlayers() > 1)
	 {
		int16 newplayer = NextSlotNum(slotnum);

		if(slotnum == Shooter)
		{
		  Shooter = newplayer;
		  ShowTableDice();
		}
		if(activeplayer == slotnum)
		{
		  activeplayer = newplayer;
		  if(!BetMade(activeplayer)){Button5->ShowGray();}
		  else{Button5->ShowVoidUp();}
		  Chips->SetupCols(GetCasPD(newplayer)->Cash,GetCasPD(newplayer)->Columns[0],
							  GetCasPD(newplayer)->Columns[1],GetCasPD(newplayer)->Columns[2],
							  GetCasPD(newplayer)->Columns[3],GetCasPD(newplayer)->Columns[4],
							  GetCasPD(newplayer)->Columns[5],false);
		  string name;
		  name = GetCasPD(newplayer)->GetName();
		  if(GetCash(activeplayer) > GetCPlayer(activeplayer)->lastbet)
		  {
			 coinsplayed += GetCPlayer(activeplayer)->lastbet;
			 GetCPlayer(activeplayer)->coinsplayed += GetCPlayer(activeplayer)->lastbet;
			 BetAmountDisplay->SetNum(GetCPlayer(activeplayer)->lastbet);
		  }
		  else
		  {
			 BetAmountDisplay->SetNum(0l);
		  }
		  BankCashDisplay->SetNum(GetCash(activeplayer));
		  switch(newplayer)
		  {
			 case 0 : NamePlate1->ShowNamePlateString(name);break;
			 case 1 : NamePlate2->ShowNamePlateString(name);break;
			 case 2 : NamePlate3->ShowNamePlateString(name);break;
		  }

		}
	 }
	 GetCasPD(slotnum)->EndCSession();
  }
}
//*******************************************************************
void TCasinoCGameLord::SetupActivePlayer(int16 slot)
{
  if(GetCasPD(slot))
  {
	 activeplayer = slot;
	 Chips->SetupCols(GetCasPD(slot)->Cash,GetCasPD(slot)->Columns[0],
						  GetCasPD(slot)->Columns[1],GetCasPD(slot)->Columns[2],
						  GetCasPD(slot)->Columns[3],GetCasPD(slot)->Columns[4],
						  GetCasPD(slot)->Columns[5],false);
	 if(GetNumActivePlayers() > 1)
	 {
		string name;
		name = GetCasPD(slot)->GetName();
		switch(slot)
		  {
			 case 0 : NamePlate1->ShowNamePlateString(name);break;
			 case 1 : NamePlate2->ShowNamePlateString(name);break;
			 case 2 : NamePlate3->ShowNamePlateString(name);break;
		  }
	 }
  }
}
//*******************************************************************
int16 TCasinoCGameLord::OneHumanPlayer()
{
  if(GetNumActivePlayers() == 1){return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoCGameLord::TwoHumanPlayers()
{
  if(GetNumActivePlayers() == 2){return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoCGameLord::ThreeHumanPlayers()
{
  if(GetNumActivePlayers() == 3){return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoCGameLord::IsMale()
{
  if(GetCasPD(Shooter) != NULL && !GetCasPD(Shooter)->Male) {return -1;}
  return 1;
}
//*******************************************************************
int16 TCasinoCGameLord::IsFemale()
{
  if(GetCasPD(Shooter) != NULL && GetCasPD(Shooter)->Male) {return -1;}
  return 1;
}
//*******************************************************************
int16 TCasinoCGameLord::AllPlayersMale()
{
  if(GetCasPD(0) != NULL && !GetCasPD(0)->Male) {return -1;}
  if(GetCasPD(1) != NULL && !GetCasPD(1)->Male) {return -1;}
  if(GetCasPD(2) != NULL && !GetCasPD(2)->Male) {return -1;}
  return 1;
}
//*******************************************************************
int16 TCasinoCGameLord::AllPlayersFemale()
{
  if(GetCasPD(0) != NULL && GetCasPD(0)->Male) {return -1;}
  if(GetCasPD(1) != NULL && GetCasPD(1)->Male) {return -1;}
  if(GetCasPD(2) != NULL && GetCasPD(2)->Male) {return -1;}
  return 1;
}
//*******************************************************************
int16 TCasinoCGameLord::RandomLT(int16 num)
{
  if(random(100) < num) {return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoCGameLord::BetweenDec22_Jan2()
{
  TDate today;
  if(today.Month() == 12 && today.DayOfMonth() > 21) {return 1;}
  if(today.Month() == 1 && today.DayOfMonth() < 3) {return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoCGameLord::IsPoint(int16 x)
{
  if(Point+2 == x) {return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoCGameLord::FirstCrapOfDayAllPlayers()
{
  return 1;
}
//*******************************************************************
int16 TCasinoCGameLord::ShooterPassBet()
{
  if(BetSpot[0]->HasBSBet(Shooter)){return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoCGameLord::LeastFourBets()
{
  int16 total=0;
  for(int16 i=0;i<43;i++)
  {
	 if(BetSpot[i]->IsBSBet()){total++;}
	 if(total >= 4){return 1;}
  }
  return -1;
}
//*******************************************************************
int16 TCasinoCGameLord::HardCurrentRoll()
{
  if(Dice1 == Dice2 && Dice1 != 0 && Dice1 != 5){return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoCGameLord::CurrentRoll(int16 roll)
{
  if(Dice1+Dice2+2 == roll){return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoCGameLord::TwoPreviousRolls7()
{
  if(PDice1+PDice2+2 == 7 && PPDice1+PPDice2+2 == 7){return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoCGameLord::HardPreviousRoll()
{
  if(PDice1 == PDice2 && PDice1 != 0 && PDice1 != 5){return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoCGameLord::PreviousRoll(int16 roll)
{
  if(PDice1+PDice2+2 == roll){return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoCGameLord::SameShooter()
{
  if(COMEOUT && !NShooter){return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoCGameLord::NewShooter()
{
  if(NShooter){return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoCGameLord::IsComeOut()
{
  if(COMEOUT){return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoCGameLord::TotalRolls(int16 rolls)
{
  if(rolls <= NumOfRolls){return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoCGameLord::AllHardBet(int16 bet)
{
  bool P0=false,P1=false,P2=false;
  if(GetCasPD(0)) {P0 = true;}
  if(GetCasPD(1)) {P1 = true;}
  if(GetCasPD(2)) {P2 = true;}
  switch(bet)
  {
	 case 4  : if((P0 && !BetSpot[13]->HasBSBet(0)) ||
					  (P1 && !BetSpot[13]->HasBSBet(1)) ||
					  (P2 && !BetSpot[13]->HasBSBet(2))   )
				  {return -1;}
				  else {return 1;}
	 case 6  : if((P0 && !BetSpot[14]->HasBSBet(0)) ||
					  (P1 && !BetSpot[14]->HasBSBet(1)) ||
					  (P2 && !BetSpot[14]->HasBSBet(2))   )
				  {return -1;}
				  else {return 1;}
	 case 8  : if((P0 && !BetSpot[15]->HasBSBet(0)) ||
					  (P1 && !BetSpot[15]->HasBSBet(1)) ||
					  (P2 && !BetSpot[15]->HasBSBet(2))   )
				  {return -1;}
				  else {return 1;}
	 case 10 : if((P0 && !BetSpot[16]->HasBSBet(0)) ||
					  (P1 && !BetSpot[16]->HasBSBet(1)) ||
					  (P2 && !BetSpot[16]->HasBSBet(2))   )
				  {return -1;}
				  else {return 1;}
  }
  return -1;
}
//*******************************************************************
int16 TCasinoCGameLord::ShooterHardBet(int16 bet)
{
  switch(bet)
  {
	 case 4  : if(BetSpot[13]->HasBSBet(Shooter)){return 1;}break;
	 case 6  : if(BetSpot[14]->HasBSBet(Shooter)){return 1;}break;
	 case 8  : if(BetSpot[15]->HasBSBet(Shooter)){return 1;}break;
	 case 10 : if(BetSpot[16]->HasBSBet(Shooter)){return 1;}break;
  }
  return -1;
}
//*******************************************************************
int16 TCasinoCGameLord::LeastTwoHardBet()
{
  int16 total=0;
  for(int16 i=0;i<3;i++)
  {
	 for(int16 j=13;j<17;j++)
	 {
		if(BetSpot[j]->HasBSBet(i)){total++;}
	 }
  }
  if(total >= 2){return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoCGameLord::LeastOneHardBet()
{
  for(int16 i=0;i<3;i++)
  {
	 for(int16 j=13;j<17;j++)
	 {
		if(BetSpot[j]->HasBSBet(i)){return 1;}
	 }
  }
  return -1;
}
//*******************************************************************
int16 TCasinoCGameLord::LeastOneNotCome()
{
  if(BetSpot[3]->HasBSBet(0)){return 1;}
  if(BetSpot[3]->HasBSBet(1)){return 1;}
  if(BetSpot[3]->HasBSBet(2)){return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoCGameLord::LeastOneCome()
{
  if(BetSpot[2]->HasBSBet(0)){return 1;}
  if(BetSpot[2]->HasBSBet(1)){return 1;}
  if(BetSpot[2]->HasBSBet(2)){return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoCGameLord::LeastPointBet(int16 num)
{
  int16 total=0;
  for(int16 i=0;i<3;i++)
  {
	 for(int16 j=17;j<29;j++)
	 {
		if(BetSpot[j]->HasBSBet(i)){total++;}
	 }
  }
  if(total >= num){return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoCGameLord::LeastOneNotPass()
{
  if(BetSpot[1]->HasBSBet(0)){return 1;}
  if(BetSpot[1]->HasBSBet(1)){return 1;}
  if(BetSpot[1]->HasBSBet(2)){return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoCGameLord::ShooterNotPass()
{
  if(BetSpot[1]->HasBSBet(Shooter)) {return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoCGameLord::Shooter200Pass()
{
  if(BetSpot[0]->HasBSBet(Shooter))
  {
	 if(BetSpot[0]->GetBSCash(Shooter) == 200){return 1;}
  }
  return -1;
}
//*******************************************************************
int16 TCasinoCGameLord::LeastOneBetGT5000()
{
  if(BetSpot[0]->HasBSBet(0))
  {
	 if(BetSpot[0]->GetBSCash(0) > 5000l){return 1;}
  }
  if(BetSpot[0]->HasBSBet(1))
  {
	 if(BetSpot[0]->GetBSCash(1) > 5000l){return 1;}
  }
  if(BetSpot[0]->HasBSBet(2))
  {
	 if(BetSpot[0]->GetBSCash(2) > 5000l){return 1;}
  }
  return -1;
}
//*******************************************************************
int16 TCasinoCGameLord::LeastOneBetPass()
{
  if(BetSpot[0]->HasBSBet(0)){return 1;}
  if(BetSpot[0]->HasBSBet(1)){return 1;}
  if(BetSpot[0]->HasBSBet(2)){return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoCGameLord::FieldWinLeast10000()
{
  if(CurrentBetPaid == 4 &&
     BetSpot[CurrentBetPaid]->WinBSPayOff(activeplayer,int16(Dice1+Dice2)) > 10000l)
  {
    return 1;
  }
  return -1;
}
//*******************************************************************
int16 TCasinoCGameLord::WinPaidGT100Thou()
{
  if(BetSpot[CurrentBetPaid]->WinBSPayOff(activeplayer,int16(Dice1+Dice2)) > 100000l){return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoCGameLord::LeastTwoWin()
{
  int16 total=0;
  SetOnOffFlags();
  for(int16 i=0;i<43;i++)
  {
	 if(BetSpot[i]->Winner(Dice1,Dice2,Point,COMEOUT,
                          OnOffFlags[0],OnOffFlags[1],OnOffFlags[2],
                          OnOffFlags[3],OnOffFlags[4],OnOffFlags[5],
                          OnOffFlags[6]) &&
       BetSpot[i]->IsBSBet())
	 {
		total++;
	 }
  }
  if(total >= 2){return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoCGameLord::LeastOneWin()
{
  int16 total=0,curplayer = activeplayer;
  for(int16 j=0;j<3;j++)
  {
	 if(GetCasPD(j))
	 {
		activeplayer = j;
		SetOnOffFlags();
		for(int16 i=0;i<43;i++)
		{
		  if(BetSpot[i]->Winner(Dice1,Dice2,Point,COMEOUT,
                              OnOffFlags[0],OnOffFlags[1],OnOffFlags[2],
                              OnOffFlags[3],OnOffFlags[4],OnOffFlags[5],
                              OnOffFlags[6]) &&
           BetSpot[i]->HasBSBet(activeplayer))
		  {
			 total++;
		  }
		}
	 }
  }
  activeplayer = curplayer;
  if(total >= 1){return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoCGameLord::OneWin()
{
  int16 curplayer = activeplayer,total=0;
  for(int16 j=0;j<3;j++)
  {
	 if(GetCasPD(j))
	 {
		activeplayer = j;
		SetOnOffFlags();
		for(int16 i=0;i<43;i++)
		{
		  if(BetSpot[i]->Winner(Dice1,Dice2,Point,COMEOUT,
                              OnOffFlags[0],OnOffFlags[1],OnOffFlags[2],
                              OnOffFlags[3],OnOffFlags[4],OnOffFlags[5],
                              OnOffFlags[6]) &&
           BetSpot[i]->HasBSBet(activeplayer))
		  {
			 total++;
		  }
		}
	 }
  }
  activeplayer = curplayer;
  if(total == 1){return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoCGameLord::ShakeStyle(int16 style)
{
  if(Style == style){return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoCGameLord::ShakeInARowLess(int16 shakes)
{
  if(ShakeInRow <= shakes){return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoCGameLord::LeastStallInRow(int16 stalls)
{
  if(StallsInRow >= stalls){return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoCGameLord::StallInRow(int16 stalls)
{
  if(StallsInRow == stalls){return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoCGameLord::HasDice()
{
  if(HDice){return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoCGameLord::DicePos3()
{
  if(DicePos == 3){return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoCGameLord::DicePos2()
{
  if(DicePos == 2){return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoCGameLord::DicePos1()
{
  if(DicePos == 1){return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoCGameLord::LeastOneCraps()
{
  if(BetSpot[7]->HasBSBet(0)){return 1;}
  if(BetSpot[7]->HasBSBet(1)){return 1;}
  if(BetSpot[7]->HasBSBet(2)){return 1;}
  return 1;
}
//*******************************************************************
int16 TCasinoCGameLord::LeastOneCE()
{
  if(BetSpot[41]->HasBSBet(0)){return 1;}
  if(BetSpot[41]->HasBSBet(1)){return 1;}
  if(BetSpot[41]->HasBSBet(2)){return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoCGameLord::LeastOneProp3()
{
  if(BetSpot[10]->HasBSBet(0)){return 1;}
  if(BetSpot[10]->HasBSBet(1)){return 1;}
  if(BetSpot[10]->HasBSBet(2)){return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoCGameLord::LeastOneGT5000Field()
{
  if(BetSpot[4]->GetBSCash(0) > 5000l){return 1;}
  if(BetSpot[4]->GetBSCash(1) > 5000l){return 1;}
  if(BetSpot[4]->GetBSCash(2) > 5000l){return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoCGameLord::LeastOneField()
{
  if(BetSpot[4]->HasBSBet(0)){return 1;}
  if(BetSpot[4]->HasBSBet(1)){return 1;}
  if(BetSpot[4]->HasBSBet(2)){return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoCGameLord::LeastOne1000Hard(int16 point)
{
  switch(point)
  {
  case 4  : if(BetSpot[13]->GetBSCash(0) > 1000l ||
               BetSpot[13]->GetBSCash(1) > 1000l ||
               BetSpot[13]->GetBSCash(2) > 1000l)
				{return 1;}
  case 6  : if(BetSpot[14]->GetBSCash(0) > 1000l ||
               BetSpot[14]->GetBSCash(1) > 1000l ||
               BetSpot[14]->GetBSCash(2) > 1000l)
				{return 1;}
  case 8  : if(BetSpot[15]->GetBSCash(0) > 1000l ||
               BetSpot[15]->GetBSCash(1) > 1000l ||
               BetSpot[15]->GetBSCash(2) > 1000l)
				{return 1;}
  case 10 : if(BetSpot[16]->GetBSCash(0) > 1000l ||
               BetSpot[16]->GetBSCash(1) > 1000l ||
               BetSpot[16]->GetBSCash(2) > 1000l)
				{return 1;}
  }
  return -1;
}
//*******************************************************************
int16 TCasinoCGameLord::GT20Passes()
{
  if(Passes > 20){return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoCGameLord::PassesInRow(int16 passes)
{
  if(Passes == passes){return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoCGameLord::LT6Passes()
{
  if(Passes < 6){return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoCGameLord::Least4Passes()
{
  if(Passes > 3){return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoCGameLord::Shoot10Long()
{
  if(ShootLength > 9){return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoCGameLord::LeastSevenLoser()
{
  int16 curplayer = activeplayer,total=0;
  for(int16 j=0;j<3;j++)
  {
	 if(GetCasPD(j))
	 {
		activeplayer = j;
		SetOnOffFlags();
		for(int16 i=0;i<43;i++)
		{
		  if(BetSpot[i]->Loser(Dice1,Dice2,Point,COMEOUT,
                             OnOffFlags[0],OnOffFlags[1],OnOffFlags[2],
                             OnOffFlags[3],OnOffFlags[4],OnOffFlags[5],
                             OnOffFlags[6]) &&
           BetSpot[i]->HasBSBet(activeplayer))
		  {
			 total++;
		  }
		}
	 }
  }
  activeplayer = curplayer;
  if(total >= 7){return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoCGameLord::LeastTwoLoser()
{
  int16 curplayer = activeplayer,total=0;

  for(int16 j=0;j<3;j++)
  {
	 if(GetCasPD(j))
	 {
		activeplayer = j;
		SetOnOffFlags();
		for(int16 i=0;i<43;i++)
		{
		  if(BetSpot[i]->Loser(Dice1,Dice2,Point,COMEOUT,
                             OnOffFlags[0],OnOffFlags[1],OnOffFlags[2],
                             OnOffFlags[3],OnOffFlags[4],OnOffFlags[5],
                             OnOffFlags[6]) &&
           BetSpot[i]->HasBSBet(activeplayer))
		  {
			 total++;
		  }
		}
	 }
  }
  activeplayer = curplayer;
  if(total >= 2){return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoCGameLord::LeastOneLoser()
{
  int16 curplayer = activeplayer,total=0;
  TRACE("AdamSet7  " << activeplayer);

  for(int16 j=0;j<3;j++)
  {
	 if(GetCasPD(j))
	 {
		activeplayer = j;
		SetOnOffFlags();
		for(int16 i=0;i<43;i++)
		{
		  if(BetSpot[i]->Loser(Dice1,Dice2,Point,COMEOUT,
                             OnOffFlags[0],OnOffFlags[1],OnOffFlags[2],
                             OnOffFlags[3],OnOffFlags[4],OnOffFlags[5],
                             OnOffFlags[6]) &&
           BetSpot[i]->HasBSBet(activeplayer))
		  {
			 total++;
		  }
		}
	 }
  }
  activeplayer = curplayer;
  if(total >= 1){return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoCGameLord::OneLoser()
{
  int16 curplayer = activeplayer,total=0;
  for(int16 j=0;j<3;j++)
  {
	 if(GetCasPD(j))
	 {
		activeplayer = j;
		SetOnOffFlags();
		for(int16 i=0;i<43;i++)
		{
		  if(BetSpot[i]->Loser(Dice1,Dice2,Point,COMEOUT,OnOffFlags[0],OnOffFlags[1],OnOffFlags[2],OnOffFlags[3],OnOffFlags[4],OnOffFlags[5],OnOffFlags[6])
			  && BetSpot[i]->HasBSBet(activeplayer))
		  {
			 total++;
		  }
		}
	 }
  }
  activeplayer = curplayer;
  if(total == 1){return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoCGameLord::HardWinLeast50000()
{
  if((CurrentBetPaid > 12 && CurrentBetPaid < 17)
		&& BetSpot[CurrentBetPaid]->WinBSPayOff(activeplayer,int16(Dice1+Dice2)) > 50000l){return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoCGameLord::AskCriteriaQuestion(int16 QNum)
{
  switch (QNum)
  {
	 case 0   : return OneHumanPlayer();
	 case 1   : return TwoHumanPlayers();
	 case 2   : return ThreeHumanPlayers();
	 case 3   : return BetweenDec22_Jan2();  //combine
	 case 4   : return AllPlayersMale();
	 case 5   : return AllPlayersFemale();
	 case 6   : return IsMale();
	 case 7   : return IsFemale();
	 case 8   : return FirstCrapOfDayAllPlayers(); //activeplayer
	 case 9   : return TotalRolls(8);
	 case 10  : return IsComeOut();
	 case 11  : return NewShooter();
	 case 12  : return SameShooter();
	 case 13  : return IsPoint(4);
	 case 14  : return IsPoint(5);
	 case 15  : return IsPoint(6);
	 case 16  : return IsPoint(8);
	 case 17  : return IsPoint(9);
	 case 18  : return IsPoint(10);
	 case 19  : return PreviousRoll(2);
	 case 20  : return PreviousRoll(3);
	 case 21  : return PreviousRoll(4);
	 case 22  : return PreviousRoll(5);
	 case 23  : return PreviousRoll(6);
	 case 24  : return PreviousRoll(7);
	 case 25  : return PreviousRoll(8);
	 case 26  : return PreviousRoll(9);
	 case 27  : return PreviousRoll(10);
	 case 28  : return PreviousRoll(11);
	 case 29  : return PreviousRoll(12);
	 case 30  : return HardPreviousRoll();
	 case 31  : return TwoPreviousRolls7();
	 case 32  : return CurrentRoll(2);
	 case 33  : return CurrentRoll(3);
	 case 34  : return CurrentRoll(4);
	 case 35  : return CurrentRoll(5);
	 case 36  : return CurrentRoll(6);
	 case 37  : return CurrentRoll(7);
	 case 38  : return CurrentRoll(8);
	 case 39  : return CurrentRoll(9);
	 case 40  : return CurrentRoll(10);
	 case 41  : return CurrentRoll(11);
	 case 42  : return CurrentRoll(12);
	 case 43  : return HardCurrentRoll();
	 case 44  : return LeastFourBets();
	 case 45  : return ShooterPassBet();
	 case 46  : return LeastOneBetPass();
	 case 47  : return LeastOneBetPass();
	 case 48  : return LeastOneBetGT5000();
	 case 49  : return Shooter200Pass();
	 case 50  : return ShooterNotPass();
	 case 51  : return LeastOneNotPass();
	 case 52  : return LeastPointBet(2);
	 case 53  : return LeastOneCome();
	 case 54  : return LeastOneNotCome();
	 case 55  : return LeastPointBet(3);
	 case 56  : return LeastPointBet(4);
	 case 57  : return LeastOneHardBet();
	 case 58  : return LeastTwoHardBet();
	 case 59  : return ShooterHardBet(4);
	 case 60  : return ShooterHardBet(6);
	 case 61  : return ShooterHardBet(8);
	 case 62  : return ShooterHardBet(10);
	 case 63  : return AllHardBet(4);
	 case 64  : return AllHardBet(6);
	 case 65  : return AllHardBet(8);
	 case 66  : return AllHardBet(10);
	 case 67  : return LeastOne1000Hard(4);
	 case 68  : return LeastOne1000Hard(6);
	 case 69  : return LeastOne1000Hard(8);
	 case 70  : return LeastOne1000Hard(10);
	 case 71  : return LeastOneField();
	 case 72  : return LeastOneGT5000Field();
	 case 73  : return LeastOneProp3();
	 case 74  : return LeastOneCE();
	 case 75  : return LeastOneCraps();
	 case 76  : return DicePos1();
	 case 77  : return DicePos2();
	 case 78  : return DicePos3();
	 case 79  : return HasDice();
	 case 80  : return StallInRow(0);
	 case 81  : return StallInRow(1);
	 case 82  : return StallInRow(2);
	 case 83  : return StallInRow(3);
	 case 84  : return LeastStallInRow(4);
	 case 85  : return ShakeStyle(0);
	 case 86  : return ShakeStyle(1);
	 case 87  : return ShakeStyle(2);
	 case 88  : return RandomLT(5);
	 case 89  : return RandomLT(10);
	 case 90  : return RandomLT(20);
	 case 91  : return RandomLT(30);
	 case 92  : return RandomLT(40);
	 case 93  : return RandomLT(50);
	 case 94  : return RandomLT(75);
	 case 95  : return IsPoint(4);
	 case 96  : return IsPoint(5);
	 case 97  : return IsPoint(6);
	 case 98  : return IsPoint(8);
	 case 99  : return IsPoint(9);
	 case 100 : return IsPoint(10);
	 case 101 : return OneWin();
	 case 102 : return LeastOneWin();
	 case 103 : return LeastTwoWin();
	 case 104 : return WinPaidGT100Thou();
	 case 105 : return FieldWinLeast10000();
	 case 106 : return HardWinLeast50000();
	 case 107 : return OneLoser();
	 case 108 : return LeastOneLoser();
	 case 109 : return LeastTwoLoser();
	 case 110 : return LeastSevenLoser();
	 case 111 : return Shoot10Long();
	 case 112 : return Least4Passes();
	 case 113 : return LT6Passes();
	 case 114 : return PassesInRow(6);
	 case 115 : return PassesInRow(7);
	 case 116 : return PassesInRow(8);
	 case 117 : return PassesInRow(9);
	 case 118 : return PassesInRow(10);
	 case 119 : return PassesInRow(11);
	 case 120 : return PassesInRow(12);
	 case 121 : return PassesInRow(13);
	 case 122 : return PassesInRow(14);
	 case 123 : return PassesInRow(15);
	 case 124 : return PassesInRow(16);
	 case 125 : return PassesInRow(17);
	 case 126 : return PassesInRow(18);
	 case 127 : return PassesInRow(19);
	 case 128 : return PassesInRow(20);
	 case 129 : return GT20Passes();
	 case 130 : return ShakeStyle(0);
	 case 131 : return ShakeStyle(1);
	 case 132 : return ShakeStyle(2);
	 case 133 : return ShakeStyle(3);
	 case 134 : return ShakeInARowLess(1);
	 case 135 : return ShakeInARowLess(11);
    case 136 : return (PModeWin->GetDetailLevel() >= 2)?int16(1):int16(-1);
    case 137 : return (PModeWin->GetDetailLevel() >= 1)?int16(1):int16(-1);
    case 138 : return (PModeWin->GetDetailLevel() >= 3)?int16(1):int16(-1);
  }
  return 0;
}
//*******************************************************************
int16 TCasinoCGameLord::Clear()
{
  int16 ii=0;
  TCasinoPlayerData *player;
  SparkOff = 0;
  CurrentBetPaid = 0;
  ShakeInRow = 0;
  EnableOddsMessage();
  EnableStateButtons(true);
  messagestate = 1;
  HDice = false;
  ALLHANDSWON = true;
  shutdownstate    = 0;
  ChangeActivePlayersOk = true;
  playersin       = 1;
  coinsplayed     = 0l;
 for(ii=0;ii<3;ii++)
 {
	if(GetCasPD(ii))
	{
	 player = GetCasPD(ii);
	 if(player)
	 {
		int16 session = player->CData.CurrentSession;
		if(GetCash(ii) > player->CData.Sessions[session].PeakWin)
		{
		  player->CData.Sessions[session].PeakWin = GetCash(ii);
		}
		if(GetCash(ii) < player->CData.Sessions[session].PeakLoss)
		{
		  player->CData.Sessions[session].PeakLoss = GetCash(ii);
		}
		if(GetCash(ii) < GetCPlayer(ii)->lastbet)
		{
		  GetCPlayer(ii)->lastbet = GetCash(ii);
		}
		if(activeplayer == ii)
		{
		  BetAmountDisplay->SetNum(GetCPlayer(ii)->lastbet);
		}
	 }
	 GetCPlayer(ii)->coinsplayed = 0l;
	}
 }
  if(COMEOUT)
  {
	 int16 i=0;
	 ShootLength = 0;
	 for(int16 i=0;i<3;i++)
	 {
		if(GetCasPD(i))
		{
		  player = GetCasPD(i);
		  int16 session = player->CData.CurrentSession;
        TCCSession &cursession = player->CData.Sessions[session];

		  cursession.TotalShoots++;
		  if(cursession.RightBetCurrentShoot)
		  {
			 cursession.NumShootsBettingRight++;
			 cursession.RightBetCurrentShoot = false;
		  }
		  if(cursession.WrongBetCurrentShoot)
		  {
			 cursession.NumShootsBettingWrong++;
			 cursession.WrongBetCurrentShoot = false;
		  }
		  if(cursession.CurrentTotalShootCashWLWB > 0l)
		  {
			 cursession.NumShootsThatWonCashWrongBettor++;
			 cursession.CurrentWinningStreakWB++;
		  }
		  else if(cursession.CurrentTotalShootCashWLWB < 0l)
		  {
			 cursession.NumShootsThatLostCashWrongBettor++;
			 cursession.CurrentWinningStreakWB = 0;
		  }
		  if(cursession.CurrentWinningStreakWB > cursession.LongestWinStreakWrongBettor)
		  {
			 cursession.LongestWinStreakWrongBettor = cursession.CurrentWinningStreakWB;
		  }
		  if(cursession.CurrentTotalShootCashWLWB > cursession.MostCashWon1ShootWrongBettor)
		  {
			 cursession.MostCashWon1ShootWrongBettor = cursession.CurrentTotalShootCashWLWB;
		  }
		  if(cursession.CurrentTotalShootCashWLWB < cursession.MostCashLost1ShootWrongBettor)
		  {
			 cursession.MostCashLost1ShootWrongBettor = cursession.CurrentTotalShootCashWLWB;
		  }
		  cursession.CurrentTotalShootCashWLWB = 0l;
		  if(cursession.CurrentTotalShootCashWLRB > 0l)
		  {
			 cursession.NumShootsWonCashRightBettor++;
			 cursession.CurrentWinningStreakRB++;
		  }
		  else if(cursession.CurrentTotalShootCashWLRB < 0l)
		  {
			 cursession.NumShootsLostCashRightBettor++;
			 cursession.CurrentWinningStreakRB = 0;
		  }
		  if(cursession.CurrentWinningStreakRB > cursession.LongestWinStreakRightBettor)
		  {
			 cursession.LongestWinStreakRightBettor = cursession.CurrentWinningStreakRB;
		  }
		  if(cursession.CurrentTotalShootCashWLRB > cursession.MostCashWon1ShootRightBettor)
		  {
			 cursession.MostCashWon1ShootRightBettor = cursession.CurrentTotalShootCashWLRB;
		  }
		  if(cursession.CurrentTotalShootCashWLRB < cursession.MostCashLost1ShootRightBettor)
		  {
			 cursession.MostCashLost1ShootRightBettor = cursession.CurrentTotalShootCashWLRB;
		  }
		  cursession.CurrentTotalShootCashWLRB = 0l;
		  if(cursession.CurrentLongestShoot > cursession.LongestShootNumRolls )
		  {
			 cursession.LongestShootNumRolls = cursession.CurrentLongestShoot;
			 cursession.CurrentLongestShoot = 0;
		  }
		  if(COMEOUTWINNER && (Dice1+Dice2 == 5 || Dice1+Dice2 == 9))
		  {
			 cursession.Numpasswins++;
			 cursession.Numnaturals++;
			 cursession.CurrentLongestPassStreak++;
			 cursession.CurrentLongestDoNotPassStreak = 0;
		  }
		  else
		  {
			 if((Dice1+Dice2 != 5 && Dice1+Dice2 != 1 && Dice1+Dice2 != 0 && Dice1+Dice2 != 10) &&
				 (Point == -1) && (Dice1 != -1))
			 {
				cursession.Numpasswins++;
				cursession.Numpointsmade++;
				cursession.CurrentLongestPassStreak++;
				cursession.CurrentLongestDoNotPassStreak = 0;
			 }
		  }
		  if(COMEOUTWINNER && (Dice1+Dice2 == 0 || Dice1+Dice2 == 1 || Dice1+Dice2 == 10))
		  {
			 cursession.CurrentLongestPassStreak = 0;
			 if(Dice1+Dice2 != 10)
			 {
				cursession.CurrentLongestDoNotPassStreak++;
			 }
		  }
		  else
		  {
			 if(Dice1+Dice2 == 5 && !COMEOUTWINNER)
			 {
				cursession.CurrentLongestPassStreak = 0;
				cursession.CurrentLongestDoNotPassStreak++;
			 }
		  }
		  if(COMEOUTWINNER && (Dice1+Dice2 == 0 || Dice1+Dice2 == 1))
		  {
			 cursession.Numdontpasswins++;
			 cursession.Numcrapouts++;
		  }
		  else
		  {
			 if(Dice1+Dice2 == 5 && !COMEOUTWINNER)
			 {
				cursession.Numdontpasswins++;
				cursession.Numsevenouts++;
			 }
		  }
		  if(cursession.CurrentLongestPassStreak > cursession.LongestPassStreak)
		  {
			 cursession.LongestPassStreak = cursession.CurrentLongestPassStreak;
		  }
		  if(cursession.CurrentLongestDoNotPassStreak > cursession.LongestDontPassStreak)
		  {
			 cursession.LongestDontPassStreak = cursession.CurrentLongestDoNotPassStreak;
		  }
		  if(Dice1 == -1 && Dice2 == -1)
		  {
			 cursession.TotalShoots--;
		  }
		}
	 }
	 if(Dice1 == -1 && Dice2 == -1)
	 {
		Dice1 = 0;Dice2 = 0;
	 }
  }
  else
  {
	 ShootLength++;
	 for(int16 i=0;i<3;i++)
	 {
		if(GetCasPD(i))
		{
		  player = GetCasPD(i);
		  int16 session = player->CData.CurrentSession;
		  player->CData.Sessions[session].CurrentLongestShoot++;
		}
	 }
  }
  PPDice1 = PDice1;
  PPDice2 = PDice2;
  PDice1 = Dice1;
  PDice2 = Dice2;
  if(COMEOUT && Dice1 + Dice2 == 5 && !COMEOUTWINNER)
  {
	 SwitchToPlayer(NextSlotNum(Shooter));
	 Shooter = activeplayer;
	 NShooter = true;
	 Passes = 0;
  }
  else
  {
	 if(COMEOUT)
	 {
		Passes++;
	 }
	 if(!FirstRoll)
	 {
		NShooter = false;
	 }

	 SwitchToPlayer(Shooter);
  }
  COMEOUTWINNER = COMEOUT;
  winnerpaid      = 0l;
  currentwinnings = 0l;
  if(!BetMade())
  {
	 Button12->ShowGray();
  }
  else{Button12->ShowVoidUp();}
  return 1;
}
//*******************************************************************
void TCasinoCGameLord::ClearLosers()
{
  int16 i=0;

  SetOnOffFlags();
  for(i=0;i<43;i++)//???
  {
	 if(BetSpot[i]->Loser(Dice1,Dice2,Point,COMEOUT,
                         OnOffFlags[0],OnOffFlags[1],OnOffFlags[2],
                         OnOffFlags[3],OnOffFlags[4],OnOffFlags[5],
                         OnOffFlags[6]))
	 {
		BetSpot[i]->ClearSpot();
	 }
  }
}
//*******************************************************************
int16 TCasinoCGameLord::NumOfCoins(TMoney money)
{
	 int32 cash = (int32) money;
	 int32 coins=0;
	 cash = cash%100001l;
	 int32 tenthous = cash / 10000;
	 int32 tenthousvalue = tenthous * 10000;
	 int32 thous = (cash - tenthousvalue) / 1000;
	 int32 thousvalue = thous * 1000;
	 int32 huns = (cash - tenthousvalue - thousvalue) / 100;
	 int32 hunsvalue = huns * 100;
	 int32 twfive = (cash - tenthousvalue - thousvalue - hunsvalue) / 25;
	 int32 twfivevalue = twfive * 25;
	 int32 fives = (cash - tenthousvalue - thousvalue - hunsvalue - twfivevalue) / 5;
	 int32 fivesvalue = fives * 5;
	 int32 ones = (cash - tenthousvalue - thousvalue - hunsvalue - twfivevalue - fivesvalue);
	 coins = tenthous+thous+huns+twfive+fives+ones;
	 if(coins == 0){return 5;}
	 if(coins == 1){return 1;}
	 if(coins >= 2 && coins <= 4){return 2;}
	 if(coins >= 5){return 3;}
	 // MRP 12/21/96
	 // I assume you shouldn't hit this.
	 // AKK 5/5/97
	 // I assume you are correct
	 assert(false);
	 return 0;
}
//*******************************************************************
int16 TCasinoCGameLord::PlaceBet(int16 x)
{
  int32 z;
  if((COMEOUT && x != 2 && x != 3) || !COMEOUT)
  {
	 if(coinsplayed==0l)
	 {
		BetLast();
	 }
	 if(GetCash(activeplayer) == 0l && coinsplayed == 0l)
	 {
		if(activeplayer != -1 && BetMade(activeplayer))
		{
		  PModeWin->MessageBox("You're out of money and may not make additional bets. Your current bets are your only hope.","Out of Cash",MB_OK);
		}
		else if(GetCasPD(activeplayer)->IsActiveKenoTicket())
		{
		  PModeWin->MessageBox("You're out of money and may not bet. Your only hope is that one of your Keno tickets pays off.","Out of Cash",MB_OK);
		}
		else
		{
		  PModeWin->MessageBox("You've hit rock bottom. Your gambler is bankrupt. Select Create/Delete under the FILE menu to create or select a new gambler.","Bankrupt!",MB_OK);
		}
	 }
	 if(coinsplayed+BetSpot[x]->GetBSCash(activeplayer) > 100000l)
	 {
		PModeWin->MessageBox("You may bet no more than $100,000 on any single bet spot.","Table Limit",MB_OK);
		return 0;
	 }
	 GetCPlayer(activeplayer)->lastbet = coinsplayed;
	 SubCash(activeplayer,coinsplayed);

	 SetOnOffFlags();
	 if(x==17) // Place/Buy bets
	 {z = BetSpot[x]->AddBSCash(activeplayer,coinsplayed,COMEOUT,Point,OnOffFlags[0]);}
	 else if(x==18)
	 {z = BetSpot[x]->AddBSCash(activeplayer,coinsplayed,COMEOUT,Point,OnOffFlags[1]);}
	 else if(x==19)
	 {z = BetSpot[x]->AddBSCash(activeplayer,coinsplayed,COMEOUT,Point,OnOffFlags[2]);}
	 else if(x==20)
	 {z = BetSpot[x]->AddBSCash(activeplayer,coinsplayed,COMEOUT,Point,OnOffFlags[2]);}
	 else if(x==21)
	 {z = BetSpot[x]->AddBSCash(activeplayer,coinsplayed,COMEOUT,Point,OnOffFlags[1]);}
	 else if(x==22)
	 {z = BetSpot[x]->AddBSCash(activeplayer,coinsplayed,COMEOUT,Point,OnOffFlags[0]);}
	 else
	 {
		z = BetSpot[x]->AddBSCash(activeplayer,coinsplayed,COMEOUT,Point);
	 }
	 Sounds->PlaySound(NumOfCoins(coinsplayed));
	 coinsplayed = 0l;
	 GetCPlayer(activeplayer)->coinsplayed = 0l;
	 AddCash(activeplayer,z);
	 BankCashDisplay->SetNum(GetCash(activeplayer));
  }
  if(!BetMade()){Button12->ShowGray();}
  else{Button12->ShowVoidUp();}
  if(!BetMade(activeplayer)){Button5->ShowGray();}
  else{Button5->ShowVoidUp();}
  if(GetCash(activeplayer) < GetCPlayer(activeplayer)->lastbet)
  {
	 GetCPlayer(activeplayer)->lastbet = GetCash(activeplayer);
	 BetAmountDisplay->SetNum(GetCPlayer(activeplayer)->lastbet);
  }
  Chips->SetNum(GetCash(activeplayer));
  return 1;
}
//*******************************************************************
int16 TCasinoCGameLord::RemoveBet(int16 x)
{
  if(BetSpot[x]->HasBSBet(activeplayer))
  {
	 AddCash(activeplayer,BetSpot[x]->SubBSCash(activeplayer,COMEOUT));
  }
  PModeWin->ReSendEnterArea();
  BankCashDisplay->SetNum(GetCash(activeplayer));
  if(!BetMade()){Button12->ShowGray();}
  else{Button12->ShowVoidUp();}
  if(!BetMade(activeplayer)){Button5->ShowGray();}
  Chips->SetNum(GetCash(activeplayer));
  return 1;
}
//*******************************************************************
bool TCasinoCGameLord::Winner(int16 winner)
{
  //clear win stacks here
  BetSpot[winner]->ShowSpark();
  Sounds->PlaySound(0);
  ShowMarker();
  if(BetSpot[winner]->HasBSBet(2))
  {
	 SwitchToPlayer(2);
  }
  else if(BetSpot[winner]->HasBSBet(1))
  {
	 SwitchToPlayer(1);
  }
  else if(BetSpot[winner]->HasBSBet(0))
  {
	 SwitchToPlayer(0);
  }
  else
  {
	 return false;
  }
//  int session;
  BetPayOff->SetNum(activeplayer,BetSpot[winner]->WinBSPayOff(activeplayer,int16(Dice1+Dice2)));
  MessageDisplay->ShowCrapsMessage(BetSpot[winner]->MessCode(activeplayer),BetSpot[winner]->WinBSPayOff(activeplayer,int16(Dice1+Dice2)),Point);
  currentwinnings = BetSpot[winner]->WinBSCash(activeplayer,int16(Dice1+Dice2));
//  session = GetCasPD(activeplayer)->CData.CurrentSession;
  AddCash(activeplayer,currentwinnings);
  if(activeplayer == Shooter && currentwinnings > 0l)
  {
	 winnerpaid = currentwinnings;
  }
  Chips->SetNum(GetCash(activeplayer));
  TCasinoPlayerData *player;
  player = GetCasPD(activeplayer);
  if(player)
  {
	 int16 session = player->CData.CurrentSession;
	 if(GetCash(activeplayer) > player->CData.Sessions[session].PeakWin)
	 {
		player->CData.Sessions[session].PeakWin = GetCash(activeplayer);
	 }
  }
  return true;
}// winner
//*******************************************************************
#pragma argsused
int16 TCasinoCGameLord::Loser(int16 loser)
{
//  int session=0;
//  session = GetCasPD(activeplayer)->CData.CurrentSession;
  return 1;
}// loser
//*******************************************************************

