//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  ccglord.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     3/26/96   A.Krist      Original baseline
//  2.0    09/18/97   M.Perry      32-bit conversion.
//  2.3    07/14/99    M.Perry    gobjlist removal
//*******************************************************************
#include "betbuy.h"
#include "betlay.h"
#include "ccglord.h"
#include "cclordst.h"
#include "cclrdmst.h"
#include "ostate.h"
#include <assert.h>
#include <time.h>   //To Set Random Number Generator
#include "ccaskex.h"
//#define  NUMBEROFPLAYERS 3
#include <stdlib.h> //For Random Number Generator
#include "cascmw.h"
#include "oskitcat.h"
#include "cplaymgr.h"
#include "ccplay.h"
#include "casnames.rh"
#include "casapp.h"
#include "betpass.h"
#include "betdpass.h"
#include "betcnum.h"
#include "betdcnum.h"

#if defined(CRAPDEBUG)
  #include <owl\dialog.h>
  #include "owl\inputdia.h"
#endif

#include "orespond.h"
#include "oanm.h"
#include "cas_cm.rh"
#include "ccbdsp.h"
#include "ccpucksp.h"
#include "ccdicesp.h"
#include "ccbpsp.h"
//#include "betpass.h"
#include "betce.h"
#include "betanyc.h"
#include "bethard.h"
//#include "betdpass.h"
#include "betbig.h"
#include "betfield.h"
#include "betcome.h"
//#include "betbuy.h"
#include "betdcome.h"
//#include "betcnum.h"
//#include "betlay.h"
//#include "betdcnum.h"
#include "bet1roll.h"
#include "ccnames.rh"
//*******************************************************************
string GetResString(int16 id)
{
  return TAppString(id);
}
//*******************************************************************
#if defined(SUPPORT_OLD_VER)
void TCasinoCGameLord::SetupUniqueIDStrings()
{
  strSounds = GetResString(IDS_MS_SOUNDS_C1);
  strNP1 = GetResString(IDS_MS_NP1_C1);
  strNP2 = GetResString(IDS_MS_NP2_C1);
  strNP3 = GetResString(IDS_MS_NP3_C1);
  strMsgDisplay = GetResString(IDS_MS_MESS_C1);
  strBankCashDisplay = GetResString(IDS_MS_BANKCASH_C1);
  strBetAmount = GetResString(IDS_MS_UNITCASH_C1);
  strButton0 = GetResString(IDS_MS_B0_C1);
  strButton1 = GetResString(IDS_MS_B1_C1);
  strButton2 = GetResString(IDS_MS_B2_C1);
  strButton3 = GetResString(IDS_MS_B3_C1);
  strButton4 = GetResString(IDS_MS_B4_C1);
  strButton5 = GetResString(IDS_MS_B5_C1);
  strButton6 = GetResString(IDS_MS_B6_C1);
  strButton7 = GetResString(IDS_MS_B7_C1);
  strButton8 = GetResString(IDS_MS_B8_C1);
  strButton9 = GetResString(IDS_MS_B9_C1);
  strButton10 = GetResString(IDS_MS_B10_C1);
  strButton11 = GetResString(IDS_MS_B11_C1);
  strButton12 = GetResString(IDS_MS_B12_C1);
  strButton13 = GetResString(IDS_MS_B13_C1);
  strBetPayoff = GetResString(IDS_MS_BETPAYOFF_C1);
  strPuck = GetResString(IDS_MS_PUCK_C1);
  strDiceA = GetResString(IDS_MS_DICEA_C1);
  strDiceB = GetResString(IDS_MS_DICEB_C1);
  strDiceC = GetResString(IDS_MS_DICEC_C1);
  strBigDice1 = GetResString(IDS_MS_BIGDICE1_C1);
  strBigDice2 = GetResString(IDS_MS_BIGDICE2_C1);
  strBigDice3 = GetResString(IDS_MS_BIGDICE3_C1);
  strBigDice4 = GetResString(IDS_MS_BIGDICE4_C1);
  strBigDice5 = GetResString(IDS_MS_BIGDICE5_C1);
  strBigDice6 = GetResString(IDS_MS_BIGDICE6_C1);
  strChips = GetResString(IDS_MS_CHIPS_C1);
  strBS0 = GetResString(IDS_MS_BS0_C1);
  strBS1 = GetResString(IDS_MS_BS1_C1);
  strBS2 = GetResString(IDS_MS_BS2_C1);
  strBS3 = GetResString(IDS_MS_BS3_C1);
  strBS4 = GetResString(IDS_MS_BS4_C1);
  strBS5 = GetResString(IDS_MS_BS5_C1);
  strBS6 = GetResString(IDS_MS_BS6_C1);
  strBS7 = GetResString(IDS_MS_BS7_C1);
  strBS8 = GetResString(IDS_MS_BS8_C1);
  strBS9 = GetResString(IDS_MS_BS9_C1);
  strBS10 = GetResString(IDS_MS_BS10_C1);
  strBS11 = GetResString(IDS_MS_BS11_C1);
  strBS12 = GetResString(IDS_MS_BS12_C1);
  strBS13 = GetResString(IDS_MS_BS13_C1);
  strBS14 = GetResString(IDS_MS_BS14_C1);
  strBS15 = GetResString(IDS_MS_BS15_C1);
  strBS16 = GetResString(IDS_MS_BS16_C1);
  strBS17 = GetResString(IDS_MS_BS17_C1);
  strBS18 = GetResString(IDS_MS_BS18_C1);
  strBS19 = GetResString(IDS_MS_BS19_C1);
  strBS20 = GetResString(IDS_MS_BS20_C1);
  strBS21 = GetResString(IDS_MS_BS21_C1);
  strBS22 = GetResString(IDS_MS_BS22_C1);
  strBS23 = GetResString(IDS_MS_BS23_C1);
  strBS24 = GetResString(IDS_MS_BS24_C1);
  strBS25 = GetResString(IDS_MS_BS25_C1);
  strBS26 = GetResString(IDS_MS_BS26_C1);
  strBS27 = GetResString(IDS_MS_BS27_C1);
  strBS28 = GetResString(IDS_MS_BS28_C1);
  strBS29 = GetResString(IDS_MS_BS29_C1);
  strBS30 = GetResString(IDS_MS_BS30_C1);
  strBS31 = GetResString(IDS_MS_BS31_C1);
  strBS32 = GetResString(IDS_MS_BS32_C1);
  strBS33 = GetResString(IDS_MS_BS33_C1);
  strBS34 = GetResString(IDS_MS_BS34_C1);
  strBS35 = GetResString(IDS_MS_BS35_C1);
  strBS36 = GetResString(IDS_MS_BS36_C1);
  strBS37 = GetResString(IDS_MS_BS37_C1);
  strBS38 = GetResString(IDS_MS_BS38_C1);
  strBS39 = GetResString(IDS_MS_BS39_C1);
  strBS40 = GetResString(IDS_MS_BS40_C1);
  strBS41 = GetResString(IDS_MS_BS41_C1);
  strBS42 = GetResString(IDS_MS_BS42_C1);
}
#endif
//*******************************************************************
#if defined(SUPPORT_OLD_VER)
int16 TCasinoCGameLord::GetUniqueID(const string &s)
{
  if (s == strSounds) {return 1;}
  if (s == strNP1) {return 3;}
  if (s == strNP2) {return 4;}
  if (s == strNP3) {return 5;}
  if (s == strMsgDisplay) {return 6;}
  if (s == strBankCashDisplay) {return 7;}
  if (s == strBetAmount) {return 8;}
  if (s == strButton0) {return 9;}
  if (s == strButton1) {return 10;}
  if (s == strButton2) {return 11;}
  if (s == strButton3) {return 12;}
  if (s == strButton4) {return 13;}
  if (s == strButton5) {return 14;}
  if (s == strButton6) {return 15;}
  if (s == strButton7) {return 16;}
  if (s == strButton8) {return 17;}
  if (s == strButton9) {return 18;}
  if (s == strButton10) {return 19;}
  if (s == strButton11) {return 20;}
  if (s == strButton12) {return 21;}
  if (s == strButton13) {return 22;}
  if (s == strBetPayoff) {return 23;}
  if (s == strPuck) {return 24;}
  if (s == strDiceA) {return 25;}
  if (s == strDiceB) {return 26;}
  if (s == strDiceC) {return 27;}
  if (s == strBigDice1) {return 29;}
  if (s == strBigDice2) {return 30;}
  if (s == strBigDice3) {return 31;}
  if (s == strBigDice4) {return 32;}
  if (s == strBigDice5) {return 33;}
  if (s == strBigDice6) {return 34;}
  if (s == strChips) {return 35;}
  if (s == strBS0) {return 36;}
  if (s == strBS1) {return 37;}
  if (s == strBS2) {return 38;}
  if (s == strBS3) {return 39;}
  if (s == strBS4) {return 40;}
  if (s == strBS5) {return 41;}
  if (s == strBS6) {return 42;}
  if (s == strBS7) {return 43;}
  if (s == strBS8) {return 44;}
  if (s == strBS9) {return 45;}
  if (s == strBS10) {return 46;}
  if (s == strBS11) {return 47;}
  if (s == strBS12) {return 48;}
  if (s == strBS13) {return 49;}
  if (s == strBS14) {return 50;}
  if (s == strBS15) {return 51;}
  if (s == strBS16) {return 52;}
  if (s == strBS17) {return 53;}
  if (s == strBS18) {return 54;}
  if (s == strBS19) {return 55;}
  if (s == strBS20) {return 56;}
  if (s == strBS21) {return 57;}
  if (s == strBS22) {return 58;}
  if (s == strBS23) {return 59;}
  if (s == strBS24) {return 60;}
  if (s == strBS25) {return 61;}
  if (s == strBS26) {return 62;}
  if (s == strBS27) {return 63;}
  if (s == strBS28) {return 64;}
  if (s == strBS29) {return 65;}
  if (s == strBS30) {return 66;}
  if (s == strBS31) {return 67;}
  if (s == strBS32) {return 68;}
  if (s == strBS33) {return 69;}
  if (s == strBS34) {return 70;}
  if (s == strBS35) {return 71;}
  if (s == strBS36) {return 72;}
  if (s == strBS37) {return 73;}
  if (s == strBS38) {return 74;}
  if (s == strBS39) {return 75;}
  if (s == strBS40) {return 76;}
  if (s == strBS41) {return 77;}
  if (s == strBS42) {return 78;}
  return 0;
}
#endif
//*******************************************************************
TSprite *TCasinoCGameLord::CreateSprite(string spritename,int16 id,void *psource)
{
  TFileMode FM(spritename,
               TFileMode::fm_None,
               TFileMode::fm_None,
               FileMode.GetDirIndex());
  if (psource != NULL)
  {
    switch (id)
	 {
		case  0 : return new TSprite(PModeWin,FM,psource);
		case 1: Sounds = (new TRSound(PModeWin,FM,psource));
              return Sounds;
     // case 2: = (new TCrapsCircle(PModeWin,FM));  //  taken out!?
       //       return ;
      case 3: NamePlate1= (new TCasNamePlate(PModeWin,FM,psource));
              return NamePlate1;
      case 4: NamePlate2 = (new TCasNamePlate(PModeWin,FM,psource));
              return NamePlate2;
      case 5: NamePlate3 = (new TCasNamePlate(PModeWin,FM,psource));
              return NamePlate3;
      case 6: MessageDisplay = (new TCasMessageDisplay(PModeWin,FM,psource));
              return MessageDisplay;
      case 7: BankCashDisplay = (new TCasCashDisplay(PModeWin,FM,psource));
              return BankCashDisplay;
      case 8: BetAmountDisplay = (new TCasCashDisplay(PModeWin,FM,psource));
              return BetAmountDisplay;
      case 9: Button0 = (new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)this,100,TRect(1,430,50,479),cidButton0,true,'x'));
              return Button0;
      case 10: Button1 = (new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)this,100,TRect(170,430,219,479),cidButton1,true));
               return Button1;
      case 11: Button2 = (new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)this,100,TRect(223,464,258,479),cidButton2,true));
               return Button2;
      case 12: Button3 = (new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)this,100,TRect(376,464,412,479),cidButton3,true));
               return Button3;
      case 13: Button4 = (new  TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)this,100,TRect(416,430,468,452),cidButton4,true,'c'));
               return Button4;
      case 14: Button5 = (new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)this,100,TRect(416,454,468,479),cidButton5,true,'r'));
               return Button5;
      case 15: Button6 = (new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)this,100,TRect(472,455,489,479),cidButton6,true,'4'));
               return Button6;
      case 16: Button7 = (new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)this,100,TRect(491,455,508,479),cidButton7,true,'5'));
               return Button7;
      case 17: Button8 = (new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)this,100,TRect(510,455,527,479),cidButton8,true,'6'));
               return Button8;
      case 18: Button9 = (new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)this,100,TRect(529,455,546,479),cidButton9,true,'7'));
               return Button9;
      case 19: Button10 = (new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)this,100,TRect(548,455,564,479),cidButton10,true,'8'));
               return Button10;
      case 20: Button11 = (new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)this,100,TRect(566,455,584,479),cidButton11,true,'9'));
               return Button11;
      case 21: Button12 = (new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)this,100,TRect(587,432,639,460),cidButton12,true,VK_RETURN));//??? ak 8/10/99 wtf vk-return
               return Button12;
      case 22: Button13 = (new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)this,125,TRect(587,462,639,479),cidButton13,true,'p'));
               return Button13;
      case 23: BetPayOff = (new TCBetPayOff(PModeWin,FM,psource));
               return BetPayOff;
      case 24: Puck = (new TCPuck(PModeWin,FM,psource));
               return Puck;
      case 25: DiceA = (new TCDice(PModeWin,FM,psource));
               return DiceA;
      case 26: DiceB = (new TCDice(PModeWin,FM,psource));
               return DiceB;
      case 27: DiceC = (new TCDice(PModeWin,FM,psource));
               return DiceC;
      //case 28: DiceD = (new TSprite(PModeWin,FM)); // ??? not used ???
      //         return DiceD;
      case 29: BigDice1= (new TCBigDice(PModeWin,FM,psource));
               return BigDice1;
      case 30: BigDice2= (new TCBigDice(PModeWin,FM,psource));
               return BigDice2;
      case 31: BigDice3= (new TCBigDice(PModeWin,FM,psource));
               return BigDice3;
      case 32: BigDice4= (new TCBigDice(PModeWin,FM,psource));
               return BigDice4;
      case 33: BigDice5= (new TCBigDice(PModeWin,FM,psource));
               return BigDice5;
      case 34: BigDice6= (new TCBigDice(PModeWin,FM,psource));
               return BigDice6;
      case 35: Chips = (new TCasChips(PModeWin,FM,psource));
               return Chips;
      case 36: BetSpot[0] = (new TBetPass(PModeWin,FM,psource,52));
               return BetSpot[0] ;
      case 37: BetSpot[1] = (new TBetDoNotPass(PModeWin,FM,psource,53));
               return BetSpot[1] ;
      case 38: BetSpot[2] = (new TBetCome(PModeWin,FM,psource,54));
               return BetSpot[2] ;
      case 39: BetSpot[3] = (new TBetDoNotCome(PModeWin,FM,psource,55));
               return BetSpot[3] ;
      case 40: BetSpot[4] = (new TBetField(PModeWin,FM,psource,62));
               return BetSpot[4] ;
      case 41: BetSpot[5] = (new TBetBig(PModeWin,FM,psource,4,60));
               return BetSpot[5] ;
      case 42: BetSpot[6] = (new TBetBig(PModeWin,FM,psource,6,61));
               return BetSpot[6] ;
      case 43: BetSpot[7] = (new TBetAnyCraps(PModeWin,FM,psource,86));
               return BetSpot[7] ;
      case 44: BetSpot[8] = (new TBet1Roll(PModeWin,FM,psource,5,85));
               return BetSpot[8] ;
      case 45: BetSpot[9] = (new TBet1Roll(PModeWin,FM,psource,0,87));
               return BetSpot[9] ;
      case 46: BetSpot[10] = (new TBet1Roll(PModeWin,FM,psource,1,88));
               return BetSpot[10] ;
      case 47: BetSpot[11] = (new TBet1Roll(PModeWin,FM,psource,9,89));
               return BetSpot[11] ;
      case 48: BetSpot[12] = (new TBet1Roll(PModeWin,FM,psource,10,90));
               return BetSpot[12] ;
      case 49: BetSpot[13] = (new TBetHard(PModeWin,FM,psource,2,81));
               return BetSpot[13] ;
      case 50: BetSpot[14] = (new TBetHard(PModeWin,FM,psource,4,82));
               return BetSpot[14] ;
      case 51: BetSpot[15] = (new TBetHard(PModeWin,FM,psource,6,83));
               return BetSpot[15] ;
      case 52: BetSpot[16] = (new TBetHard(PModeWin,FM,psource,8,84));
               return BetSpot[16] ;
      case 53: BetSpot[17] = (new TBetBuy(PModeWin,FM,psource,2,63));
               return BetSpot[17] ;
      case 54: BetSpot[18] = (new TBetBuy(PModeWin,FM,psource,3,64));
               return BetSpot[18] ;
      case 55: BetSpot[19] = (new TBetBuy(PModeWin,FM,psource,4,65));
               return BetSpot[19] ;
      case 56: BetSpot[20] = (new TBetBuy(PModeWin,FM,psource,6,66));
               return BetSpot[20] ;
      case 57: BetSpot[21] = (new TBetBuy(PModeWin,FM,psource,7,67));
               return BetSpot[21] ;
      case 58: BetSpot[22] = (new TBetBuy(PModeWin,FM,psource,8,68));
               return BetSpot[22] ;
      case 59: BetSpot[23] = (new TBetComeNum(PModeWin,FM,psource,2,54));
               return BetSpot[23] ;
      case 60: BetSpot[24] = (new TBetComeNum(PModeWin,FM,psource,3,54));
               return BetSpot[24] ;
      case 61: BetSpot[25] = (new TBetComeNum(PModeWin,FM,psource,4,54));
               return BetSpot[25] ;
      case 62: BetSpot[26] = (new TBetComeNum(PModeWin,FM,psource,6,54));
               return BetSpot[26] ;
      case 63: BetSpot[27] = (new TBetComeNum(PModeWin,FM,psource,7,54));
               return BetSpot[27] ;
      case 64: BetSpot[28] = (new TBetComeNum(PModeWin,FM,psource,8,54));
               return BetSpot[28] ;
      case 65: BetSpot[29] = (new TBetLay(PModeWin,FM,psource,2,75));
               return BetSpot[29] ;
      case 66: BetSpot[30] = (new TBetLay(PModeWin,FM,psource,3,76));
               return BetSpot[30] ;
      case 67: BetSpot[31] = (new TBetLay(PModeWin,FM,psource,4,77));
               return BetSpot[31] ;
      case 68: BetSpot[32] = (new TBetLay(PModeWin,FM,psource,6,78));
               return BetSpot[32] ;
      case 69: BetSpot[33] = (new TBetLay(PModeWin,FM,psource,7,79));
               return BetSpot[33] ;
      case 70: BetSpot[34] = (new TBetLay(PModeWin,FM,psource,8,80));
               return BetSpot[34] ;
      case 71: BetSpot[35] = (new TBetDoNotComeNum(PModeWin,FM,psource,2,55));
               return BetSpot[35] ;
      case 72: BetSpot[36] = (new TBetDoNotComeNum(PModeWin,FM,psource,3,55));
               return BetSpot[36] ;
      case 73: BetSpot[37] = (new TBetDoNotComeNum(PModeWin,FM,psource,4,55));
               return BetSpot[37] ;
      case 74: BetSpot[38] = (new TBetDoNotComeNum(PModeWin,FM,psource,6,55));
               return BetSpot[38] ;
      case 75: BetSpot[39] = (new TBetDoNotComeNum(PModeWin,FM,psource,7,55));
               return BetSpot[39] ;
      case 76: BetSpot[40] = (new TBetDoNotComeNum(PModeWin,FM,psource,8,55));
               return BetSpot[40] ;
      case 77: BetSpot[41] = (new TBetCraps11(PModeWin,FM,psource,92,false));
               return BetSpot[41] ;
      case 78: BetSpot[42] = (new TBetCraps11(PModeWin,FM,psource,91,true));
               return BetSpot[42] ;
      default : return new TSprite(PModeWin,FM,psource);
	 }
  }
  else
  {
	 FM.SetRamImmed();
	 switch (id)
	 {
		case  0 : return new TSprite(PModeWin,FM);
      case 1: Sounds = (new TRSound(PModeWin,FM));
              return Sounds;
     // case 2: = (new TCrapsCircle(PModeWin,FM));  //  taken out!?
       //       return ;
      case 3: NamePlate1= (new TCasNamePlate(PModeWin,FM));
              return NamePlate1;
      case 4: NamePlate2 = (new TCasNamePlate(PModeWin,FM));
              return NamePlate2;
      case 5: NamePlate3 = (new TCasNamePlate(PModeWin,FM));
              return NamePlate3;
      case 6: MessageDisplay = (new TCasMessageDisplay(PModeWin,FM));
              return MessageDisplay;
      case 7: BankCashDisplay = (new TCasCashDisplay(PModeWin,FM));
              return BankCashDisplay;
      case 8: BetAmountDisplay = (new TCasCashDisplay(PModeWin,FM));
              return BetAmountDisplay;
      case 9: Button0 = (new TCasButton(PModeWin,FM,(TCasinoGameLord *)this,100,TRect(1,430,50,479),cidButton0,true,'x'));
              return Button0;
      case 10: Button1 = (new TCasButton(PModeWin,FM,(TCasinoGameLord *)this,100,TRect(170,430,219,479),cidButton1,true));
               return Button1;
      case 11: Button2 = (new TCasButton(PModeWin,FM,(TCasinoGameLord *)this,100,TRect(223,464,258,479),cidButton2,true));
               return Button2;
      case 12: Button3 = (new TCasButton(PModeWin,FM,(TCasinoGameLord *)this,100,TRect(376,464,412,479),cidButton3,true));
               return Button3;
      case 13: Button4 = (new  TCasButton(PModeWin,FM,(TCasinoGameLord *)this,100,TRect(416,430,468,452),cidButton4,true,'c'));
               return Button4;
      case 14: Button5 = (new TCasButton(PModeWin,FM,(TCasinoGameLord *)this,100,TRect(416,454,468,479),cidButton5,true,'r'));
               return Button5;
      case 15: Button6 = (new TCasButton(PModeWin,FM,(TCasinoGameLord *)this,100,TRect(472,455,489,479),cidButton6,true,'4'));
               return Button6;
      case 16: Button7 = (new TCasButton(PModeWin,FM,(TCasinoGameLord *)this,100,TRect(491,455,508,479),cidButton7,true,'5'));
               return Button7;
      case 17: Button8 = (new TCasButton(PModeWin,FM,(TCasinoGameLord *)this,100,TRect(510,455,527,479),cidButton8,true,'6'));
               return Button8;
      case 18: Button9 = (new TCasButton(PModeWin,FM,(TCasinoGameLord *)this,100,TRect(529,455,546,479),cidButton9,true,'7'));
               return Button9;
      case 19: Button10 = (new TCasButton(PModeWin,FM,(TCasinoGameLord *)this,100,TRect(548,455,564,479),cidButton10,true,'8'));
               return Button10;
      case 20: Button11 = (new TCasButton(PModeWin,FM,(TCasinoGameLord *)this,100,TRect(566,455,584,479),cidButton11,true,'9'));
               return Button11;
      case 21: Button12 = (new TCasButton(PModeWin,FM,(TCasinoGameLord *)this,100,TRect(587,432,639,460),cidButton12,true,VK_RETURN));
               return Button12;
      case 22: Button13 = (new TCasButton(PModeWin,FM,(TCasinoGameLord *)this,125,TRect(587,462,639,479),cidButton13,true,'p'));
               return Button13;
      case 23: BetPayOff = (new TCBetPayOff(PModeWin,FM));
               return BetPayOff;
      case 24: Puck = (new TCPuck(PModeWin,FM));
               return Puck;
      case 25: DiceA = (new TCDice(PModeWin,FM));
               return DiceA;
      case 26: DiceB = (new TCDice(PModeWin,FM));
               return DiceB;
      case 27: DiceC = (new TCDice(PModeWin,FM));
               return DiceC;
      //case 28: DiceD = (new TSprite(PModeWin,FM)); // ??? not used ???
      //         return DiceD;
      case 29: BigDice1= (new TCBigDice(PModeWin,FM));
               return BigDice1;
      case 30: BigDice2= (new TCBigDice(PModeWin,FM));
               return BigDice2;
      case 31: BigDice3= (new TCBigDice(PModeWin,FM));
               return BigDice3;
      case 32: BigDice4= (new TCBigDice(PModeWin,FM));
               return BigDice4;
      case 33: BigDice5= (new TCBigDice(PModeWin,FM));
               return BigDice5;
      case 34: BigDice6= (new TCBigDice(PModeWin,FM));
               return BigDice6;
      case 35: Chips = (new TCasChips(PModeWin,FM));
               return Chips;
      case 36: BetSpot[0] = (new TBetPass(PModeWin,FM,52));
               return BetSpot[0] ;
      case 37: BetSpot[1] = (new TBetDoNotPass(PModeWin,FM,53));
               return BetSpot[1] ;
      case 38: BetSpot[2] = (new TBetCome(PModeWin,FM,54));
               return BetSpot[2] ;
      case 39: BetSpot[3] = (new TBetDoNotCome(PModeWin,FM,55));
               return BetSpot[3] ;
      case 40: BetSpot[4] = (new TBetField(PModeWin,FM,62));
               return BetSpot[4] ;
      case 41: BetSpot[5] = (new TBetBig(PModeWin,FM,4,60));
               return BetSpot[5] ;
      case 42: BetSpot[6] = (new TBetBig(PModeWin,FM,6,61));
               return BetSpot[6] ;
      case 43: BetSpot[7] = (new TBetAnyCraps(PModeWin,FM,86));
               return BetSpot[7] ;
      case 44: BetSpot[8] = (new TBet1Roll(PModeWin,FM,5,85));
               return BetSpot[8] ;
      case 45: BetSpot[9] = (new TBet1Roll(PModeWin,FM,0,87));
               return BetSpot[9] ;
      case 46: BetSpot[10] = (new TBet1Roll(PModeWin,FM,1,88));
               return BetSpot[10] ;
      case 47: BetSpot[11] = (new TBet1Roll(PModeWin,FM,9,89));
               return BetSpot[11] ;
      case 48: BetSpot[12] = (new TBet1Roll(PModeWin,FM,10,90));
               return BetSpot[12] ;
      case 49: BetSpot[13] = (new TBetHard(PModeWin,FM,2,81));
               return BetSpot[13] ;
      case 50: BetSpot[14] = (new TBetHard(PModeWin,FM,4,82));
               return BetSpot[14] ;
      case 51: BetSpot[15] = (new TBetHard(PModeWin,FM,6,83));
               return BetSpot[15] ;
      case 52: BetSpot[16] = (new TBetHard(PModeWin,FM,8,84));
               return BetSpot[16] ;
      case 53: BetSpot[17] = (new TBetBuy(PModeWin,FM,2,63));
               return BetSpot[17] ;
      case 54: BetSpot[18] = (new TBetBuy(PModeWin,FM,3,64));
               return BetSpot[18] ;
      case 55: BetSpot[19] = (new TBetBuy(PModeWin,FM,4,65));
               return BetSpot[19] ;
      case 56: BetSpot[20] = (new TBetBuy(PModeWin,FM,6,66));
               return BetSpot[20] ;
      case 57: BetSpot[21] = (new TBetBuy(PModeWin,FM,7,67));
               return BetSpot[21] ;
      case 58: BetSpot[22] = (new TBetBuy(PModeWin,FM,8,68));
               return BetSpot[22] ;
      case 59: BetSpot[23] = (new TBetComeNum(PModeWin,FM,2,54));
               return BetSpot[23] ;
      case 60: BetSpot[24] = (new TBetComeNum(PModeWin,FM,3,54));
               return BetSpot[24] ;
      case 61: BetSpot[25] = (new TBetComeNum(PModeWin,FM,4,54));
               return BetSpot[25] ;
      case 62: BetSpot[26] = (new TBetComeNum(PModeWin,FM,6,54));
               return BetSpot[26] ;
      case 63: BetSpot[27] = (new TBetComeNum(PModeWin,FM,7,54));
               return BetSpot[27] ;
      case 64: BetSpot[28] = (new TBetComeNum(PModeWin,FM,8,54));
               return BetSpot[28] ;
      case 65: BetSpot[29] = (new TBetLay(PModeWin,FM,2,75));
               return BetSpot[29] ;
      case 66: BetSpot[30] = (new TBetLay(PModeWin,FM,3,76));
               return BetSpot[30] ;
      case 67: BetSpot[31] = (new TBetLay(PModeWin,FM,4,77));
               return BetSpot[31] ;
      case 68: BetSpot[32] = (new TBetLay(PModeWin,FM,6,78));
               return BetSpot[32] ;
      case 69: BetSpot[33] = (new TBetLay(PModeWin,FM,7,79));
               return BetSpot[33] ;
      case 70: BetSpot[34] = (new TBetLay(PModeWin,FM,8,80));
               return BetSpot[34] ;
      case 71: BetSpot[35] = (new TBetDoNotComeNum(PModeWin,FM,2,55));
               return BetSpot[35] ;
      case 72: BetSpot[36] = (new TBetDoNotComeNum(PModeWin,FM,3,55));
               return BetSpot[36] ;
      case 73: BetSpot[37] = (new TBetDoNotComeNum(PModeWin,FM,4,55));
               return BetSpot[37] ;
      case 74: BetSpot[38] = (new TBetDoNotComeNum(PModeWin,FM,6,55));
               return BetSpot[38] ;
      case 75: BetSpot[39] = (new TBetDoNotComeNum(PModeWin,FM,7,55));
               return BetSpot[39] ;
      case 76: BetSpot[40] = (new TBetDoNotComeNum(PModeWin,FM,8,55));
               return BetSpot[40] ;
      case 77: BetSpot[41] = (new TBetCraps11(PModeWin,FM,92,false));
               return BetSpot[41] ;
      case 78: BetSpot[42] = (new TBetCraps11(PModeWin,FM,91,true));
               return BetSpot[42] ;
      default : return new TSprite(PModeWin,FM);
	 }
  }
}
//*******************************************************************
void TCasinoCGameLord::Roll()
{
#ifdef CRAPDEBUG
  pMWin->SetUpdatePause();
  char dice1num[5] = "";
  TInputDialog getdice1(pMWin,"","dice number",dice1num,5);
  getdice1.Execute();
  char dice2num[5] = "";
  TInputDialog getdice2(pMWin,"","dice number",dice2num,5);
  getdice2.Execute();
  pMWin->ClearUpdatePause();
  Dice1 = atoi(dice1num);
  Dice2 = atoi(dice2num);
#else
  Dice1 = int16(random(6));
  Dice2 = int16(random(6));
#endif
  NumOfRolls++;
}
//*******************************************************************
bool TCasinoCGameLord::ReturnFreeOdds()
{
  if(COMEOUT)
  {
	 int16 x=0,y=0;
	 TMoney freeodds=0l;
	 for(y=2;y>-1;y--)
	 {
		if(GetCasPD(y))
		{
		  SwitchToPlayer(y);
		  SetOnOffFlags();
		  if(!OnOffFlags[3])
		  {
			 for(x=23;x<29;x++)
			 {
				freeodds = BetSpot[x]->ReturnFree(y,Dice1,Dice2);
				if((int32)freeodds)
				{
				  BetSpot[x]->ShowFreeOddsSpark(y);
				  AddCash(activeplayer,freeodds);
				  SparkOff = x;
				  MessageDisplay->ShowCrapsMessage(93);
				  BankCashDisplay->SetNum(GetCash(activeplayer));
				  return true;
				}
			 }
		  }
		  if(!OnOffFlags[4])
		  {
			 for(x=35;x<41;x++)
			 {
				freeodds = BetSpot[x]->ReturnFree(y,Dice1,Dice2);
				if((int32)freeodds)
				{
				  BetSpot[x]->ShowFreeOddsSpark(y);
				  AddCash(activeplayer,freeodds);
				  SparkOff = x;
				  MessageDisplay->ShowCrapsMessage(93);
				  BankCashDisplay->SetNum(GetCash(activeplayer));
				  return true;
				}
			 }
		  }
		}
	 }
  }
  return false;
}
//*******************************************************************
bool TCasinoCGameLord::CoachIsOn()
{
  for(int16 x=0;x<3;x++)
  {
	 if(GetCasPD(x) && GetCasPD(x)->CoachOn) {return true;}
  }
  return false;
}
//*******************************************************************
void TCasinoCGameLord::AskBetExpert(int16 spot)
{
  pAskExpert->AskBadBetExpert(BetNoGood(spot));
}
//*******************************************************************
void TCasinoCGameLord::AskOddsExpert()
{
  pAskExpert->AskOddsExpert(NoFreeOdds());
}
//*******************************************************************
void TCasinoCGameLord::AskExpert()
{
  pAskExpert->AskBetExpert();
}
//*******************************************************************
int16 TCasinoCGameLord::NoFreeOdds()
{
  int16 x=0,y=0;
  if(COMEOUT){return 0;}
  for(x=0;x<3;x++)
  {
	 if(GetCasPD(x) && GetCasPD(x)->CoachOn)
	 {
		for(y=0;y<6;y++)
		{
		  if(BetSpot[y+23]->BetAmount[x] > 0l &&
           ((TBetComeNum *)BetSpot[y+23])->FreeOdds[x] == 0l)
		  {
          return 1;
        }
		  if(BetSpot[y+35]->BetAmount[x] > 0l &&
           ((TBetDoNotComeNum *)BetSpot[y+35])->FreeOdds[x] == 0l)
		  {
          return 2;
        }
		}
		if(BetSpot[0]->BetAmount[x] > 0l && ((TBetPass *)BetSpot[0])->FreeOdds[x] == 0l)
		{
        return 3;
      }
		if(BetSpot[1]->BetAmount[x] > 0l && ((TBetDoNotPass *)BetSpot[1])->FreeOdds[x] == 0l)
		{
        return 4;
      }
	 }
  }
  for(x=0;x<3;x++)
  {
	 if(GetCasPD(x) && GetCasPD(x)->CoachOn)
	 {
		if(Point == 4 || Point == 6)
		{
		  if((BetSpot[0]->BetAmount[x]%2l > 0l) &&
			  (BetSpot[0]->BetAmount[x] > 0l) &&
			  (((TBetPass *)BetSpot[0])->FreeOdds[x] < (int32)(BetSpot[0]->BetAmount[x]*2l)))
		  {
          return 5;
        }
		  if(((int32)(BetSpot[0]->BetAmount[x]%2l) == 0l) &&
			  (BetSpot[0]->BetAmount[x] > 0l) &&
			  ( ((TBetPass *)BetSpot[0])->FreeOdds[x] <
				 (int32)((BetSpot[0]->BetAmount[x]*2l)+(BetSpot[0]->BetAmount[x]/2l)) ))
		  {
          return 5;
        }
		  if(((int32)(BetSpot[1]->BetAmount[x]%2l) > 0l) &&
			  (BetSpot[1]->BetAmount[x] > 0l) &&
			  ( ((TBetDoNotPass *)BetSpot[1])->FreeOdds[x] <
					(int32)(BetSpot[1]->BetAmount[x]*2l)) )
		  {
          return 5;
        }
		  if(((int32)(BetSpot[1]->BetAmount[x]%2l) == 0l) &&
			  (BetSpot[1]->BetAmount[x] > 0l) &&
			  ( ((TBetDoNotPass *)BetSpot[1])->FreeOdds[x] <
				 (int32)((BetSpot[1]->BetAmount[x]*2l)+(BetSpot[1]->BetAmount[x]/2l)) ))
		  {
          return 5;
        }
		}
		for(y=0;y<6;y++)
		{
		  if(BetSpot[y+23]->BetAmount[x] > 0l &&
			 ((TBetComeNum *)BetSpot[y+23])->FreeOdds[x] < BetSpot[y+23]->BetAmount[x]*2l)
		  {
          return 5;
        }
		  if(BetSpot[y+35]->BetAmount[x] > 0l &&
			 ((TBetDoNotComeNum *)BetSpot[y+35])->FreeOdds[x] < BetSpot[y+35]->BetAmount[x]*2l)
		  {
          return 5;
        }
		}
		if(BetSpot[0]->BetAmount[x] > 0l &&
		  ((TBetPass *)BetSpot[0])->FreeOdds[x] < BetSpot[0]->BetAmount[x]*2l)
		{
        return 5;
      }
		if(BetSpot[1]->BetAmount[x] > 0l &&
		  ((TBetDoNotPass *)BetSpot[1])->FreeOdds[x] < BetSpot[1]->BetAmount[x]*2l)
		{
        return 5;
      }

		if((BetSpot[25]->BetAmount[x]%2l > 0l) && (BetSpot[25]->BetAmount[x] > 0l) &&
         (((TBetComeNum *)BetSpot[25])->FreeOdds[x] < BetSpot[25]->BetAmount[x]*2l))
		{
        return 5;
      }
		if((BetSpot[25]->BetAmount[x]%2l == 0l) && (BetSpot[25]->BetAmount[x] > 0l) &&
      (((TBetComeNum *)BetSpot[25])->FreeOdds[x] <
         ((BetSpot[25]->BetAmount[x]*2l)+(BetSpot[25]->BetAmount[x]/2l))))
		{
        return 5;
      }
		if((BetSpot[37]->BetAmount[x]%2l > 0l) &&
         (BetSpot[37]->BetAmount[x] > 0l) &&
         (((TBetDoNotComeNum *)BetSpot[37])->FreeOdds[x] < BetSpot[37]->BetAmount[x]*2l))
		{
        return 5;
      }
		if((BetSpot[37]->BetAmount[x]%2l == 0l) &&
         (BetSpot[37]->BetAmount[x] > 0l) &&
         (((TBetDoNotComeNum *)BetSpot[37])->FreeOdds[x] <
          ((BetSpot[37]->BetAmount[x]*2)+(BetSpot[37]->BetAmount[x]/2l))))
		{
        return 5;
      }
		if((BetSpot[26]->BetAmount[x]%2l > 0l) &&
         (BetSpot[26]->BetAmount[x] > 0l) &&
         (((TBetComeNum *)BetSpot[26])->FreeOdds[x] < BetSpot[26]->BetAmount[x]*2l))
		{
        return 5;
      }
		if((BetSpot[26]->BetAmount[x]%2l == 0l) &&
         (BetSpot[26]->BetAmount[x] > 0l) &&
         (((TBetComeNum *)BetSpot[26])->FreeOdds[x] <
         ((BetSpot[26]->BetAmount[x]*2l)+(BetSpot[26]->BetAmount[x]/2l))))
		{
        return 5;
      }
		if((BetSpot[38]->BetAmount[x]%2l > 0l) &&
         (BetSpot[38]->BetAmount[x] > 0l) &&
         (((TBetDoNotComeNum *)BetSpot[38])->FreeOdds[x] < BetSpot[38]->BetAmount[x]*2l))
		{
        return 5;
      }
		if((BetSpot[38]->BetAmount[x]%2l == 0l) &&
         (BetSpot[38]->BetAmount[x] > 0l) &&
         (((TBetDoNotComeNum *)BetSpot[38])->FreeOdds[x] <
         ((BetSpot[38]->BetAmount[x]*2l)+(BetSpot[38]->BetAmount[x]/2l))))
		{
        return 5;
      }
	 }
  }
  return 0;
}
//*******************************************************************
int16 TCasinoCGameLord::BetNoGood(int16 spot)
{
  int16 x=0;
  for(x=0;x<3;x++)
  {
	 if(BetSpot[0]->BetAmount[x] > 0l && spot == 1){return 13;}
	 if(BetSpot[1]->BetAmount[x] > 0l && spot == 0){return 13;}

	 if(BetSpot[0]->BetAmount[x] > 0l && spot == 3){return 14;}
	 if(BetSpot[35]->BetAmount[x] > 0l && spot == 0){return 14;}
	 if(BetSpot[36]->BetAmount[x] > 0l && spot == 0){return 14;}
	 if(BetSpot[37]->BetAmount[x] > 0l && spot == 0){return 14;}
	 if(BetSpot[38]->BetAmount[x] > 0l && spot == 0){return 14;}
	 if(BetSpot[39]->BetAmount[x] > 0l && spot == 0){return 14;}
	 if(BetSpot[40]->BetAmount[x] > 0l && spot == 0){return 14;}

	 if(BetSpot[1]->BetAmount[x] > 0l && spot == 2){return 15;}
	 if(BetSpot[23]->BetAmount[x] > 0l && spot == 1){return 15;}
	 if(BetSpot[24]->BetAmount[x] > 0l && spot == 1){return 15;}
	 if(BetSpot[25]->BetAmount[x] > 0l && spot == 1){return 15;}
	 if(BetSpot[26]->BetAmount[x] > 0l && spot == 1){return 15;}
	 if(BetSpot[27]->BetAmount[x] > 0l && spot == 1){return 15;}
	 if(BetSpot[28]->BetAmount[x] > 0l && spot == 1){return 15;}

	 if(BetSpot[35]->BetAmount[x] > 0l && spot == 2){return 16;}
	 if(BetSpot[36]->BetAmount[x] > 0l && spot == 2){return 16;}
	 if(BetSpot[37]->BetAmount[x] > 0l && spot == 2){return 16;}
	 if(BetSpot[38]->BetAmount[x] > 0l && spot == 2){return 16;}
	 if(BetSpot[39]->BetAmount[x] > 0l && spot == 2){return 16;}
	 if(BetSpot[40]->BetAmount[x] > 0l && spot == 2){return 16;}
	 if(BetSpot[23]->BetAmount[x] > 0l && spot == 3){return 16;}
	 if(BetSpot[24]->BetAmount[x] > 0l && spot == 3){return 16;}
	 if(BetSpot[25]->BetAmount[x] > 0l && spot == 3){return 16;}
	 if(BetSpot[26]->BetAmount[x] > 0l && spot == 3){return 16;}
	 if(BetSpot[27]->BetAmount[x] > 0l && spot == 3){return 16;}
	 if(BetSpot[28]->BetAmount[x] > 0l && spot == 3){return 16;}

  }
  int16 countP=0,countM=0;
  for(x=0;x<3;x++)
  {
	 if(spot == 2)
	 {
		if(BetSpot[0]->BetAmount[x] > 0l){countP++;}
		if(BetSpot[23]->BetAmount[x] > 0l){countP++;}
		if(BetSpot[24]->BetAmount[x] > 0l){countP++;}
		if(BetSpot[25]->BetAmount[x] > 0l){countP++;}
		if(BetSpot[26]->BetAmount[x] > 0l){countP++;}
		if(BetSpot[27]->BetAmount[x] > 0l){countP++;}
		if(BetSpot[28]->BetAmount[x] > 0l){countP++;}
		if(countP > 2){return 17;}
	 }
	 else if(spot == 3)
	 {
		if(BetSpot[1]->BetAmount[x] > 0l){countM++;}
		if(BetSpot[35]->BetAmount[x] > 0l){countM++;}
		if(BetSpot[36]->BetAmount[x] > 0l){countM++;}
		if(BetSpot[37]->BetAmount[x] > 0l){countM++;}
		if(BetSpot[38]->BetAmount[x] > 0l){countM++;}
		if(BetSpot[39]->BetAmount[x] > 0l){countM++;}
		if(BetSpot[40]->BetAmount[x] > 0l){countM++;}
		if(countM > 2){return 18;}
	 }
	 countP = 0;countM = 0;
  }
  switch(spot)
  {
	 case 4  : return 1;
	 case 5  : return 2;
	 case 6  : return 2;
	 case 7  : return 3;
	 case 8  : return 7;
	 case 9  : return 4;
	 case 10 : return 5;
	 case 11 : return 5;
	 case 12 : return 4;
	 case 13 : return 10;
	 case 14 : return 9;
	 case 15 : return 9;
	 case 16 : return 10;
	 case 17 : return 11;
	 case 18 : return 12;
	 case 21 : return 12;
	 case 22 : return 11;
	 case 41 : return 6;
	 case 42 : return 8;
	 default : return 0;
  }
}
//*******************************************************************
void TCasinoCGameLord::EnableOddsMessage()
{
  for(int16 i=0;i<35;i++)
  {
	 Responders[i]->SetEnterLeave(true);
  }
  Responders[41]->SetEnterLeave(true);
  Responders[43]->SetEnterLeave(true);
  Responders[44]->SetEnterLeave(true);
  Responders[45]->SetEnterLeave(true);
  Responders[46]->SetEnterLeave(true);
  Responders[47]->SetEnterLeave(true);
  Responders[48]->SetEnterLeave(true);
  Responders[49]->SetEnterLeave(true);

}
//*******************************************************************
void TCasinoCGameLord::DisEnableOddsMessage()
{
  for(int16 i=0;i<35;i++)
  {
	 Responders[i]->SetEnterLeave(false);
  }
  Responders[41]->SetEnterLeave(false);
  Responders[43]->SetEnterLeave(false);
  Responders[44]->SetEnterLeave(false);
  Responders[45]->SetEnterLeave(false);
  Responders[46]->SetEnterLeave(false);
  Responders[47]->SetEnterLeave(false);
  Responders[48]->SetEnterLeave(false);
  Responders[49]->SetEnterLeave(false);
}
//*******************************************************************
void TCasinoCGameLord::EnableButton(int16 button)
{
  switch(button)
  {
	 case 0  : Button0->Enabled = true;break;
	 case 1  : Button1->Enabled = true;break;
	 case 2  : Button2->Enabled = true;break;
	 case 3  : Button3->Enabled = true;break;
	 case 4  : Button4->Enabled = true;break;
	 case 5  : Button5->Enabled = true;break;
	 case 6  : Button6->Enabled = true;break;
	 case 7  : Button7->Enabled = true;break;
	 case 8  : Button8->Enabled = true;break;
	 case 9  : Button9->Enabled = true;break;
	 case 10 : Button10->Enabled = true;break;
	 case 11 : Button11->Enabled = true;break;
	 case 12 : Button12->Enabled = true;break;
	 case 13 : Button13->Enabled = true;break;
  }
}
//*******************************************************************
void TCasinoCGameLord::DisEnableButton(int16 button)
{
  switch(button)
  {
	 case 0  : Button0->Enabled = false;break;
	 case 1  : Button1->Enabled = false;break;
	 case 2  : Button2->Enabled = false;break;
	 case 3  : Button3->Enabled = false;break;
	 case 4  : Button4->Enabled = false;break;
	 case 5  : Button5->Enabled = false;break;
	 case 6  : Button6->Enabled = false;break;
	 case 7  : Button7->Enabled = false;break;
	 case 8  : Button8->Enabled = false;break;
	 case 9  : Button9->Enabled = false;break;
	 case 10 : Button10->Enabled = false;break;
	 case 11 : Button11->Enabled = false;break;
	 case 12 : Button12->Enabled = false;break;
	 case 13 : Button13->Enabled = false;break;
  }
}
//*******************************************************************
void TCasinoCGameLord::EnableStateButtons(bool onoff)
{
  Button4->Enabled = onoff;
  Button5->Enabled = onoff;
  Button6->Enabled = onoff;
  Button7->Enabled = onoff;
  Button8->Enabled = onoff;
  Button9->Enabled = onoff;
  Button10->Enabled = onoff;
  Button11->Enabled = onoff;
  Button12->Enabled = onoff;
  Button13->Enabled = onoff;
}
//*******************************************************************
void TCasinoCGameLord::EnableAllButtons()
{
  Button0->Enabled = true;
  Button1->Enabled = true;
  Button2->Enabled = true;
  Button3->Enabled = true;
  Button4->Enabled = true;
  Button5->Enabled = true;
  Button6->Enabled = true;
  Button7->Enabled = true;
  Button8->Enabled = true;
  Button9->Enabled = true;
  Button10->Enabled = true;
  Button11->Enabled = true;
  Button12->Enabled = true;
  Button13->Enabled = true;
}
//*******************************************************************
void TCasinoCGameLord::DisEnableAllButtons()
{
  Button0->Enabled = false;
  Button1->Enabled = false;
  Button2->Enabled = false;
  Button3->Enabled = false;
  Button4->Enabled = false;
  Button5->Enabled = false;
  Button6->Enabled = false;
  Button7->Enabled = false;
  Button8->Enabled = false;
  Button9->Enabled = false;
  Button10->Enabled = false;
  Button11->Enabled = false;
  Button12->Enabled = false;
  Button13->Enabled = false;
}
//*******************************************************************
#pragma argsused
bool TCasinoCGameLord::Respond(int16 button,int16 info,void *pdata)
{
  if(info == -5)//gray button hit
  {
	 if(button == cidButton12 && GetCash(activeplayer) == 0l)
	 {
		if(activeplayer != -1 && BetMade(activeplayer))
		{
		  PModeWin->MessageBox("You're out of money and may not make additional bets. Your current bets are your only hope.","Out of Cash",MB_OK);
		}
		else if(GetCasPD(activeplayer)->IsActiveKenoTicket())
		{
		  PModeWin->MessageBox("You're out of money and may not bet. Your only hope is that one of your Keno tickets pays off.","Out of Cash",MB_OK);
		}
		else
		{
		  PModeWin->MessageBox("You've hit rock bottom. Your gambler is bankrupt. Select Create/Delete under the FILE menu to create or select a new gambler.","Bankrupt!",MB_OK);
		}
	 }
	 return true;
  }
  if((button == -2 || button == cidButton12) && (info == 0 || info == 1))
  {
	 ButtonInfo = -2;
	 WaitOnButtonDown = false;
	 return true;
  }
  ButtonInfo = info;
  if(info != -1)
  {
	 switch(button)
	 {
		case cidButton0  : ButtonHit[cidButton0]=true;
                         break;
		case cidButton1  : TCmMsg(CM_ASKEXPERTSTATISTICS).PostToFW();
                         ButtonHit[cidButton1]=true;
                         break;
		case cidButton2  : ButtonHit[cidButton2]=true;
                         break;
		case cidButton3  : ButtonHit[cidButton3]=true;
                         break;
		case cidButton4  : ButtonHit[cidButton4]=true;
                         break;
		case cidButton5  : ButtonHit[cidButton5]=true;
                         break;
		case cidButton6  : ButtonHit[cidButton6]=true;
                         break;
		case cidButton7  : ButtonHit[cidButton7]=true;
                         break;
		case cidButton8  : ButtonHit[cidButton8]=true;
                         break;
		case cidButton9  : ButtonHit[cidButton9]=true;
                         break;
		case cidButton10 : ButtonHit[cidButton10]=true;
                         break;
		case cidButton11 : ButtonHit[cidButton11]=true;
                         break;
		case cidButton12 : if(BetMade()){DisEnableButton(12);}
                         WaitOnButtonDown = false;
                         break;
		case cidButton13 : ButtonHit[cidButton13]=true;
                         break;
		default          : WaitOnButtonDown = false;
                         break;
	 }
#ifdef DEBUGCRITERIA
 /* if(button == cidButton2)
  {
	 int crynum=0,cryanswer=0;
	 PModeWin->SetUpdatePause();
	 char criterianum[3] = "";
	 char cryer[10] = "";
	 TInputDialog getcriteria(PModeWin,"","criteria number",criterianum,3);
	 getcriteria.Execute();
	 crynum = atoi(criterianum);
	 cryanswer = AskCriteriaQuestion(crynum);
	 itoa(cryanswer,cryer,10);
	 PModeWin->MessageBox(cryer,criterianum,MB_OK);
	 PModeWin->ClearUpdatePause();
  }*/
  if(button == cidButton2)
  {
	 int16 i,x=0;
	 char retval[5];
	 char question[7];
	 string CriteriaReport;
	 for(i=0;i<136;i++)
	 {
		x = AskCriteriaQuestion(i);
		itoa(x,retval,10);
		itoa(i,question,10);
		CriteriaReport += question;
		CriteriaReport += "-> ";
		CriteriaReport += retval;
		if(x < 0)     {CriteriaReport += "                                                ";}
		else          {CriteriaReport += "                                                 ";}
		if(i<9)       {CriteriaReport += "  ";}
		else if(i<100){CriteriaReport += " ";}
	 }
	 GetFW()->DisplayExpert(CriteriaReport);
  }
#endif
  }
  else
  {
	 if(button == cidButton12 && BetMade())
	 {
		ButtonHit[cidButton12]=true;
	 }
  }
  return true;
}
//*******************************************************************
void TCasinoCGameLord::ButtonClear(int16 button)
{
  switch(button)
  {
	 case cidButton0  : ButtonHit[cidButton0]=false;break;
	 case cidButton1  : ButtonHit[cidButton1]=false;break;
	 case cidButton2  : ButtonHit[cidButton2]=false;GetFW()->CmShowMenu();break;
	 case cidButton3  : ButtonHit[cidButton3]=false;PModeWin->ModeHelp();break;
	 case cidButton4  : ButtonHit[cidButton4]=false;break;
	 case cidButton5  : ButtonHit[cidButton5]=false;break;
	 case cidButton6  : ButtonHit[cidButton6]=false;break;
	 case cidButton7  : ButtonHit[cidButton7]=false;break;
	 case cidButton8  : ButtonHit[cidButton8]=false;break;
	 case cidButton9  : ButtonHit[cidButton9]=false;break;
	 case cidButton10 : ButtonHit[cidButton10]=false;break;
	 case cidButton11 : ButtonHit[cidButton11]=false;break;
	 case cidButton12 : ButtonHit[cidButton12]=false;break;
	 case cidButton13 : ButtonHit[cidButton13]=false;
                       Style = int16((Style+1)%4);
                       break;
	 default          : WaitOnButtonDown = false;break;
  }
  WaitOnButtonDown = false;
  return;
}
//*******************************************************************
void TCasinoCGameLord::SetupSkits()
{
}
//*******************************************************************
//TSpriteList *TCasinoCGameLord::CreateSpriteList(TFileMode splfm)
//{
//  return NULL;
//}
//*******************************************************************
void TCasinoCGameLord::SetupSprites()
{
}
//*******************************************************************
void TCasinoCGameLord::CleanupSprites()
{
}
//*******************************************************************
void TCasinoCGameLord::MoveComeBets()
{
  for(int16 i=0;i<3;i++)
  {
	 switch(Dice1+Dice2)
	 {
		case 2  : BetSpot[23]->AddCome(i,BetSpot[2]->SubBSCash(i,COMEOUT));
					 BetSpot[35]->AddCome(i,BetSpot[3]->SubBSCash(i,COMEOUT));break;
		case 3  : BetSpot[24]->AddCome(i,BetSpot[2]->SubBSCash(i,COMEOUT));
					 BetSpot[36]->AddCome(i,BetSpot[3]->SubBSCash(i,COMEOUT));break;
		case 4  : BetSpot[25]->AddCome(i,BetSpot[2]->SubBSCash(i,COMEOUT));
					 BetSpot[37]->AddCome(i,BetSpot[3]->SubBSCash(i,COMEOUT));break;
		case 6  : BetSpot[26]->AddCome(i,BetSpot[2]->SubBSCash(i,COMEOUT));
					 BetSpot[38]->AddCome(i,BetSpot[3]->SubBSCash(i,COMEOUT));break;
		case 7  : BetSpot[27]->AddCome(i,BetSpot[2]->SubBSCash(i,COMEOUT));
					 BetSpot[39]->AddCome(i,BetSpot[3]->SubBSCash(i,COMEOUT));break;
		case 8  : BetSpot[28]->AddCome(i,BetSpot[2]->SubBSCash(i,COMEOUT));
					 BetSpot[40]->AddCome(i,BetSpot[3]->SubBSCash(i,COMEOUT));break;
		default : break;
	 }
  }
}
//*******************************************************************
void TCasinoCGameLord::NoShowTableDice()
{
  DiceA->NoShow();
  DiceB->NoShow();
  DiceC->NoShow();
}
//*******************************************************************
void TCasinoCGameLord::ShowTableDice()
{
  switch(Shooter)
  {
	 case 0 : DiceB->ShowDice();DiceA->NoShow();DiceC->NoShow();break;
	 case 1 : DiceA->ShowDice();DiceB->NoShow();DiceC->NoShow();break;
	 case 2 : DiceC->ShowDice();DiceA->NoShow();DiceB->NoShow();break;
	 default: break;
  }
}
//*******************************************************************
bool TCasinoCGameLord::ComeOutBetMade()
{
  if(BetSpot[0]->HasBSBet(0)) {return true;}
  else if(BetSpot[1]->HasBSBet(0)) {return true;}
  else if(BetSpot[0]->HasBSBet(1)) {return true;}
  else if(BetSpot[1]->HasBSBet(1)) {return true;}
  else if(BetSpot[0]->HasBSBet(2)) {return true;}
  else if(BetSpot[1]->HasBSBet(2)) {return true;}
  return false;
}
//*******************************************************************
bool TCasinoCGameLord::PickUpDice(dword &StartFUC,dword &FUCLength)
{
  int16 ListNum = -1;
  SwitchToPlayer(Shooter);
  EnableStateButtons(false);
  EnableButton(12);
  MessageDisplay->NoShow();
  DisEnableOddsMessage();
  ChangeActivePlayersOk = false;
  if (GetCasPD(Shooter)->Male)
  {
	 switch (Shooter)
	 {
		case 0 : ListNum = mpickupdiceb;break;
		case 1 : ListNum = mpickupdicea;break;
		case 2 : ListNum = mpickupdicec;break;
		default:return false;
	 }
  }
  else
  {
	 switch (Shooter)
	 {
		case 0 : ListNum = fpickupdiceb;break;
		case 1 : ListNum = fpickupdicea;break;
		case 2 : ListNum = fpickupdicec;break;
		default:return false;
	 }
  }
  return (ActivateSprite(ListNum,StartFUC,FUCLength));
}
//*******************************************************************
bool TCasinoCGameLord::ReturnOdds(dword &StartFUC,dword &FUCLength)
{
  return (ActivateSprite(returnodds,StartFUC,FUCLength));
}
//*******************************************************************
bool TCasinoCGameLord::GiveDice(dword &StartFUC,dword &FUCLength)
{
	 HDice = true;
	 switch (Shooter)
	 {
		case 0 : return GiveDiceB(StartFUC,FUCLength);
		case 1 : return GiveDiceA(StartFUC,FUCLength);
		case 2 : return GiveDiceC(StartFUC,FUCLength);
		default: return false;
	 }
}
//*******************************************************************
void TCasinoCGameLord::ClearBigDice()
{
  if(DicePos == 3)
  {
	 BigDice5->NoShow();
	 BigDice6->NoShow();
  }
  else if(DicePos == 2)
  {
	 BigDice3->NoShow();
	 BigDice4->NoShow();
  }
  else
  {
	 BigDice1->NoShow();
	 BigDice2->NoShow();
  }
}
//*******************************************************************
bool TCasinoCGameLord::Shake(dword &StartFUC,dword &FUCLength)
{
  if(Shooter == 0)
  {
	 return ShakeB(StartFUC,FUCLength);
  }
  if(Shooter == 1)
  {
	 return ShakeA(StartFUC,FUCLength);
  }
  if(Shooter == 2)
  {
	 return ShakeC(StartFUC,FUCLength);
  }
  return false;
}
//*******************************************************************
bool TCasinoCGameLord::EShake(dword &StartFUC,dword &FUCLength)
{
  if(Shooter == 0)
  {
	 return EShakeB(StartFUC,FUCLength);
  }
  if(Shooter == 1)
  {
	 return EShakeA(StartFUC,FUCLength);
  }
  if(Shooter == 2)
  {
	 return EShakeC(StartFUC,FUCLength);
  }
  return false;
}
//*******************************************************************
bool TCasinoCGameLord::NoComeCom(dword &StartFUC,dword &FUCLength)
{
  if(Shooter == 0)
  {
	 return NoComeComB(StartFUC,FUCLength);
  }
  if(Shooter == 1)
  {
	 return NoComeComA(StartFUC,FUCLength);
  }
  if(Shooter == 2)
  {
	 return NoComeComC(StartFUC,FUCLength);
  }
  return false;
}
//*******************************************************************
bool TCasinoCGameLord::Stall(dword &StartFUC,dword &FUCLength)
{
  StallsInRow++;
  if(Shooter == 0)
  {
	 return StallB(StartFUC,FUCLength);
  }
  if(Shooter == 1)
  {
	 return StallA(StartFUC,FUCLength);
  }
  if(Shooter == 2)
  {
	 return StallC(StartFUC,FUCLength);
  }
  return false;
}
//*******************************************************************
bool TCasinoCGameLord::Throw(dword &StartFUC,dword &FUCLength)
{
  if(Shooter == 0)
  {
	 return ThrowB(StartFUC,FUCLength);
  }
  if(Shooter == 1)
  {
	 return ThrowA(StartFUC,FUCLength);
  }
  if(Shooter == 2)
  {
	 return ThrowC(StartFUC,FUCLength);
  }
  return false;
}
//*******************************************************************
void TCasinoCGameLord::BigDice()
{
  if(DicePos == 3)
  {
	 BigDice5->ShowNum(Dice1);
	 BigDice6->ShowNum(Dice2);
  }
  else if(DicePos == 2)
  {
	 BigDice3->ShowNum(Dice1);
	 BigDice4->ShowNum(Dice2);
  }
  else
  {
	 BigDice1->ShowNum(Dice1);
	 BigDice2->ShowNum(Dice2);
  }
}
//*******************************************************************
bool TCasinoCGameLord::DiceLand(dword &StartFUC,dword &FUCLength)
{
  int16 x;
  x = (int16)random(100);
  if(x == 99)
  {
	 DicePos = 3;
	 return DiceLandC(StartFUC,FUCLength);
  }
  else if(x > 50)
  {
	 DicePos = 2;
	 return DiceLandB(StartFUC,FUCLength);
  }
  else
  {
	 DicePos = 1;
	 return DiceLandA(StartFUC,FUCLength);
  }
}
//*******************************************************************
bool TCasinoCGameLord::MarkComeOut()
{
  if((Dice1+Dice2) != 0 && (Dice1+Dice2) != 1 && (Dice1+Dice2) != 5 &&
	  (Dice1+Dice2) != 9 && (Dice1+Dice2) != 10)
  {
	 Point = int16(Dice1 + Dice2);
	 return 1;
  }
  return 0;
}
//*******************************************************************
bool TCasinoCGameLord::ClearMark()
{
  if((Dice1+Dice2) == 5 || (Dice1+Dice2) == Point)
  {
	 COMEOUT = true;
	// Point = -1;
	 return 1;
  }
  return 0;
}
//*******************************************************************
bool TCasinoCGameLord::PointCom(dword &StartFUC,dword &FUCLength)
{
	 switch(Point)
	 {
		case 2  : return ChooseStartSkit(pointcom4,StartFUC,FUCLength);
		case 3  : return ChooseStartSkit(pointcom5,StartFUC,FUCLength);
		case 4  : return ChooseStartSkit(pointcom6,StartFUC,FUCLength);
		case 6  : return ChooseStartSkit(pointcom8,StartFUC,FUCLength);
		case 7  : return ChooseStartSkit(pointcom9,StartFUC,FUCLength);
		case 8  : return ChooseStartSkit(pointcoma,StartFUC,FUCLength);
	 }
	 return false;
}
//*******************************************************************
bool TCasinoCGameLord::Result(dword &StartFUC,dword &FUCLength)
{
  if(COMEOUT)
  {
	 switch(Dice1+Dice2)
	 {
		case 0  : return ChooseStartSkit(result1,StartFUC,FUCLength);
		case 1  : return ChooseStartSkit(result3,StartFUC,FUCLength);
		case 2  : return ChooseStartSkit(result5,StartFUC,FUCLength);
		case 3  : return ChooseStartSkit(result8,StartFUC,FUCLength);
		case 4  : return ChooseStartSkit(resultb,StartFUC,FUCLength);
		case 5  : return ChooseStartSkit(resulte,StartFUC,FUCLength);
		case 6  : return ChooseStartSkit(resultg,StartFUC,FUCLength);
		case 7  : return ChooseStartSkit(resultj,StartFUC,FUCLength);
		case 8  : return ChooseStartSkit(resultm,StartFUC,FUCLength);
		case 9  : return ChooseStartSkit(resultp,StartFUC,FUCLength);
		case 10 : return ChooseStartSkit(resultr,StartFUC,FUCLength);
	 }
  }
  else
  {
	 if(Point == Dice1+Dice2)
	 {
		switch(Dice1+Dice2)
		{
		  case 2  : return ChooseStartSkit(result6,StartFUC,FUCLength);
		  case 3  : return ChooseStartSkit(result9,StartFUC,FUCLength);
		  case 4  : return ChooseStartSkit(resultc,StartFUC,FUCLength);
		  case 6  : return ChooseStartSkit(resulth,StartFUC,FUCLength);
		  case 7  : return ChooseStartSkit(resultk,StartFUC,FUCLength);
		  case 8  : return ChooseStartSkit(resultn,StartFUC,FUCLength);
		}
	 }
	 else
	 {
		switch(Dice1+Dice2)
		{
		  case 0  : return ChooseStartSkit(result2,StartFUC,FUCLength);
		  case 1  : return ChooseStartSkit(result4,StartFUC,FUCLength);
		  case 2  : return ChooseStartSkit(result7,StartFUC,FUCLength);
		  case 3  : return ChooseStartSkit(resulta,StartFUC,FUCLength);
		  case 4  : return ChooseStartSkit(resultd,StartFUC,FUCLength);
		  case 5  : return ChooseStartSkit(resultf,StartFUC,FUCLength);
		  case 6  : return ChooseStartSkit(resulti,StartFUC,FUCLength);
		  case 7  : return ChooseStartSkit(resultl,StartFUC,FUCLength);
		  case 8  : return ChooseStartSkit(resulto,StartFUC,FUCLength);
		  case 9  : return ChooseStartSkit(resultq,StartFUC,FUCLength);
		  case 10 : return ChooseStartSkit(results,StartFUC,FUCLength);
		}
	 }
  }
  return false;
}
//*******************************************************************
void TCasinoCGameLord::CleanupResponders()
{
  for(int16 i=0;i<NumResponders;i++) {delete Responders[i];}
}
//*******************************************************************
void TCasinoCGameLord::ShowMessageOdds(int16 spot)
{
  if(spot == 0)
  {
	 switch(Point)
	 {
		case 2  : MessageDisplay->ShowCrapsMessage(7);break;
		case 3  : MessageDisplay->ShowCrapsMessage(8);break;
		case 4  : MessageDisplay->ShowCrapsMessage(9);break;
		case 6  : MessageDisplay->ShowCrapsMessage(9);break;
		case 7  : MessageDisplay->ShowCrapsMessage(8);break;
		case 8  : MessageDisplay->ShowCrapsMessage(7);break;
	 }
  }
  else if(spot == 1)
  {
	 switch(Point)
	 {
		case 2  : MessageDisplay->ShowCrapsMessage(10);break;
		case 3  : MessageDisplay->ShowCrapsMessage(11);break;
		case 4  : MessageDisplay->ShowCrapsMessage(12);break;
		case 6  : MessageDisplay->ShowCrapsMessage(12);break;
		case 7  : MessageDisplay->ShowCrapsMessage(11);break;
		case 8  : MessageDisplay->ShowCrapsMessage(10);break;
	 }
  }
  else if(spot >= 2 && spot <= 7)
  {
	 switch(spot)
	 {
		case 2  : MessageDisplay->ShowCrapsMessage(13);break;
		case 3  : MessageDisplay->ShowCrapsMessage(14);break;
		case 4  : MessageDisplay->ShowCrapsMessage(15);break;
		case 5  : MessageDisplay->ShowCrapsMessage(15);break;
		case 6  : MessageDisplay->ShowCrapsMessage(14);break;
		case 7  : MessageDisplay->ShowCrapsMessage(13);break;
	 }
  }
  else if(spot >= 8)
  {
	 switch(spot)
	 {
		case 8  : MessageDisplay->ShowCrapsMessage(16);break;
		case 9  : MessageDisplay->ShowCrapsMessage(17);break;
		case 10 : MessageDisplay->ShowCrapsMessage(18);break;
		case 11 : MessageDisplay->ShowCrapsMessage(18);break;
		case 12 : MessageDisplay->ShowCrapsMessage(17);break;
		case 13 : MessageDisplay->ShowCrapsMessage(16);break;
	 }
  }
  return;
}
//*******************************************************************
bool TCasinoCGameLord::Respond(TResponder &responder)
{
  if (PState == NULL) {return true;}
  if((responder.GetResponseEvent() == reEnterArea ||
		responder.GetResponseEvent() == reLeaveArea  ) &&
		responder.GetID() != cidFeltCursor && responder.GetID() != cidNamePlate)
  {
	 if(responder.GetResponseEvent() == reEnterArea)
	 {
		SetOnOffFlags();
		switch (responder.GetID())
		{
		  case cidBetSpot0           :  if(COMEOUT){MessageDisplay->ShowCrapsMessage(3);}
												  else{ShowMessageOdds(0);}break;
		  case cidBetSpot1           :  if(COMEOUT){MessageDisplay->ShowCrapsMessage(4);}
												  else{ShowMessageOdds(1);}break;
		  case cidBetSpot2           :  if(!COMEOUT){MessageDisplay->ShowCrapsMessage(5);}break;
		  case cidBetSpot3           :  if(!COMEOUT){MessageDisplay->ShowCrapsMessage(6);}break;
		  case cidBetSpot4           :  MessageDisplay->ShowCrapsMessage(21);break;
		  case cidBetSpot5           :  MessageDisplay->ShowCrapsMessage(19);break;
		  case cidBetSpot6           :  MessageDisplay->ShowCrapsMessage(20);break;
		  case cidBetSpot7           :  MessageDisplay->ShowCrapsMessage(45);break;
		  case cidBetSpot8           :  MessageDisplay->ShowCrapsMessage(44);break;
		  case cidBetSpot9           :  MessageDisplay->ShowCrapsMessage(46);break;
		  case cidBetSpot10          :  MessageDisplay->ShowCrapsMessage(47);break;
		  case cidBetSpot11          :  MessageDisplay->ShowCrapsMessage(48);break;
		  case cidBetSpot12          :  MessageDisplay->ShowCrapsMessage(49);break;
		  case cidBetSpot13          :  MessageDisplay->ShowCrapsMessage(40);break;
		  case cidBetSpot14          :  MessageDisplay->ShowCrapsMessage(41);break;
		  case cidBetSpot15          :  MessageDisplay->ShowCrapsMessage(42);break;
		  case cidBetSpot16          :  MessageDisplay->ShowCrapsMessage(43);break;
		  case cidBetSpot17          :  if(OnOffFlags[0]){MessageDisplay->ShowCrapsMessage(22);}
												  else{MessageDisplay->ShowCrapsMessage(28);}break;
		  case cidBetSpot18          :  if(OnOffFlags[1]){MessageDisplay->ShowCrapsMessage(23);}
												  else{MessageDisplay->ShowCrapsMessage(29);}break;
		  case cidBetSpot19          :  if(OnOffFlags[2]){MessageDisplay->ShowCrapsMessage(24);}
												  else{MessageDisplay->ShowCrapsMessage(30);}break;
		  case cidBetSpot20          :  if(OnOffFlags[2]){MessageDisplay->ShowCrapsMessage(25);}
												  else{MessageDisplay->ShowCrapsMessage(31);}break;
		  case cidBetSpot21          :  if(OnOffFlags[1]){MessageDisplay->ShowCrapsMessage(26);}
												  else{MessageDisplay->ShowCrapsMessage(32);}break;
		  case cidBetSpot22          :  if(OnOffFlags[0]){MessageDisplay->ShowCrapsMessage(27);}
												  else{MessageDisplay->ShowCrapsMessage(33);}break;
		  case cidBetSpot23          :  if(!COMEOUT){ShowMessageOdds(2);}break;
		  case cidBetSpot24          :  if(!COMEOUT){ShowMessageOdds(3);}break;
		  case cidBetSpot25          :  if(!COMEOUT){ShowMessageOdds(4);}break;
		  case cidBetSpot26          :  if(!COMEOUT){ShowMessageOdds(5);}break;
		  case cidBetSpot27          :  if(!COMEOUT){ShowMessageOdds(6);}break;
		  case cidBetSpot28          :  if(!COMEOUT){ShowMessageOdds(7);}break;
		  case cidBetSpot29          :  MessageDisplay->ShowCrapsMessage(34);break;
		  case cidBetSpot30          :  MessageDisplay->ShowCrapsMessage(35);break;
		  case cidBetSpot31          :  MessageDisplay->ShowCrapsMessage(36);break;
		  case cidBetSpot32          :  MessageDisplay->ShowCrapsMessage(37);break;
		  case cidBetSpot33          :  MessageDisplay->ShowCrapsMessage(38);break;
		  case cidBetSpot34          :  MessageDisplay->ShowCrapsMessage(39);break;
		  case cidBetSpot35          :  if(!COMEOUT){ShowMessageOdds(8);}break;
		  case cidBetSpot36          :  if(!COMEOUT){ShowMessageOdds(9);}break;
		  case cidBetSpot37          :  if(!COMEOUT){ShowMessageOdds(10);}break;
		  case cidBetSpot38          :  if(!COMEOUT){ShowMessageOdds(11);}break;
		  case cidBetSpot39          :  if(!COMEOUT){ShowMessageOdds(12);}break;
		  case cidBetSpot40          :  if(!COMEOUT){ShowMessageOdds(13);}break;
		  case cidBetSpot41          :  MessageDisplay->ShowCrapsMessage(51);break;
		  case cidBetSpot42          :  MessageDisplay->ShowCrapsMessage(50);break;
		  case cidBetSpot43          :  if(COMEOUT){MessageDisplay->ShowCrapsMessage(3);}
												  else{ShowMessageOdds(0);}break;
		  case cidBetSpot44          :  if(COMEOUT){MessageDisplay->ShowCrapsMessage(3);}
												  else{ShowMessageOdds(0);}break;
		  case cidBetSpot45          :  if(COMEOUT){MessageDisplay->ShowCrapsMessage(4);}
												  else{ShowMessageOdds(1);}break;
		  case cidBetSpot46          :  if(COMEOUT){MessageDisplay->ShowCrapsMessage(4);}
												  else{ShowMessageOdds(1);}break;
		  case cidBetSpot47          :  if(COMEOUT){MessageDisplay->ShowCrapsMessage(4);}
												  else{ShowMessageOdds(1);}break;
		  case cidBetSpot48          :  if(COMEOUT){MessageDisplay->ShowCrapsMessage(4);}
												  else{ShowMessageOdds(1);}break;
		  case cidBetSpot49          :  if(!COMEOUT){MessageDisplay->ShowCrapsMessage(6);}break;
		  default                    :  break;
		}
	 }
	 else
	 {MessageDisplay->ShowCrapsMessage(messagestate);}
	 if(!BetSpotsOn){return true;}
	 if(responder.GetResponseEvent() == reLeaveArea)
	 {
		GetOgleApp()->GetCursorMgr()->SetCursor(ctAction,0,0);
		return true;
	 }
	 else if(responder.GetResponseEvent() == reEnterArea)
	 {
		int16 numX=responder.GetID();
		if     (numX == 65 || numX == 66)
		{numX = 0;}
		else if(numX == 67 || numX == 68 || numX == 69 || numX == 70)
		{numX = 1;}
		else if(numX == 71)
		{numX = 3;}
		else
		{numX -= int16(22);}
		 if(coinsplayed > 0l && PlaceBetsMode &&
			 BetSpot[numX]->IsValidAdd(activeplayer,2,COMEOUT,Point))
		 {
			GetOgleApp()->GetCursorMgr()->SetCursor(ctAction,GetOgleApp(),ID_WHITE_CHIPS_CURSOR);
		 }
		 else if(!PlaceBetsMode &&
					 BetSpot[numX]->IsValidRemove(activeplayer,2,COMEOUT,Point))
		 {
		  GetOgleApp()->GetCursorMgr()->SetCursor(ctAction,GetOgleApp(),ID_WHITE_REMOVE_CURSOR);
		 }
		 else if(coinsplayed == 0 && GetCPlayer(activeplayer)->lastbet > 0l &&
				  GetCPlayer(activeplayer)->lastbet <= GetCash(activeplayer) &&
				  PlaceBetsMode &&
				  BetSpot[numX]->IsValidAdd(activeplayer,2,COMEOUT,Point))
		 {
		  GetOgleApp()->GetCursorMgr()->SetCursor(ctAction,GetOgleApp(),ID_WHITE_CHIPS_CURSOR);
		 }
		 else
		 {
		  if((coinsplayed > 0l ||
			  (GetCPlayer(activeplayer)->lastbet > 0l &&
				GetCPlayer(activeplayer)->lastbet <= GetCash(activeplayer))) &&
				PlaceBetsMode)
		  {
			 GetOgleApp()->GetCursorMgr()->SetCursor(ctAction,GetOgleApp(),ID_BLACK_CHIPS_CURSOR);
		  }
		  else if(!PlaceBetsMode)
		  {
			 GetOgleApp()->GetCursorMgr()->SetCursor(ctAction,GetOgleApp(),ID_BLACK_REMOVE_CURSOR);
		  }
		}
		return true;
	 }
  }
  else
  {
	 switch (responder.GetID())
	 {
	 case cidNamePlate          :  return (((TCLordState *)PState)->NamePlate(responder));
	 case cidFeltCursor :   if(responder.GetResponseEvent() == reLeaveArea)
									{
									  GetOgleApp()->GetCursorMgr()->SetCursor(ctAction,0,0);
									}
									else if(responder.GetResponseEvent() == reEnterArea)
									{
									  if((coinsplayed > 0l ||
										  (GetCPlayer(activeplayer)->lastbet > 0l &&
											GetCPlayer(activeplayer)->lastbet <= GetCash(activeplayer))) &&
											PlaceBetsMode)
									  {
										 GetOgleApp()->GetCursorMgr()->SetCursor(ctAction,GetOgleApp(),ID_BLACK_CHIPS_CURSOR);
									  }
									  else if(!PlaceBetsMode)
									  {
										 GetOgleApp()->GetCursorMgr()->SetCursor(ctAction,GetOgleApp(),ID_BLACK_REMOVE_CURSOR);
									  }
									}
									return true;

	 case cidBetSpot0           :  return (((TCLordState *)PState)->BetSpot(responder,0));
	 case cidBetSpot1           :  return (((TCLordState *)PState)->BetSpot(responder,1));
	 case cidBetSpot2           :  return (((TCLordState *)PState)->BetSpot(responder,2));
	 case cidBetSpot3           :  return (((TCLordState *)PState)->BetSpot(responder,3));
	 case cidBetSpot4           :  return (((TCLordState *)PState)->BetSpot(responder,4));
	 case cidBetSpot5           :  return (((TCLordState *)PState)->BetSpot(responder,5));
	 case cidBetSpot6           :  return (((TCLordState *)PState)->BetSpot(responder,6));
	 case cidBetSpot7           :  return (((TCLordState *)PState)->BetSpot(responder,7));
	 case cidBetSpot8           :  return (((TCLordState *)PState)->BetSpot(responder,8));
	 case cidBetSpot9           :  return (((TCLordState *)PState)->BetSpot(responder,9));
	 case cidBetSpot10          :  return (((TCLordState *)PState)->BetSpot(responder,10));
	 case cidBetSpot11          :  return (((TCLordState *)PState)->BetSpot(responder,11));
	 case cidBetSpot12          :  return (((TCLordState *)PState)->BetSpot(responder,12));
	 case cidBetSpot13          :  return (((TCLordState *)PState)->BetSpot(responder,13));
	 case cidBetSpot14          :  return (((TCLordState *)PState)->BetSpot(responder,14));
	 case cidBetSpot15          :  return (((TCLordState *)PState)->BetSpot(responder,15));
	 case cidBetSpot16          :  return (((TCLordState *)PState)->BetSpot(responder,16));
	 case cidBetSpot17          :  return (((TCLordState *)PState)->BetSpot(responder,17));
	 case cidBetSpot18          :  return (((TCLordState *)PState)->BetSpot(responder,18));
	 case cidBetSpot19          :  return (((TCLordState *)PState)->BetSpot(responder,19));
	 case cidBetSpot20          :  return (((TCLordState *)PState)->BetSpot(responder,20));
	 case cidBetSpot21          :  return (((TCLordState *)PState)->BetSpot(responder,21));
	 case cidBetSpot22          :  return (((TCLordState *)PState)->BetSpot(responder,22));
	 case cidBetSpot23          :  return (((TCLordState *)PState)->BetSpot(responder,23));
	 case cidBetSpot24          :  return (((TCLordState *)PState)->BetSpot(responder,24));
	 case cidBetSpot25          :  return (((TCLordState *)PState)->BetSpot(responder,25));
	 case cidBetSpot26          :  return (((TCLordState *)PState)->BetSpot(responder,26));
	 case cidBetSpot27          :  return (((TCLordState *)PState)->BetSpot(responder,27));
	 case cidBetSpot28          :  return (((TCLordState *)PState)->BetSpot(responder,28));
	 case cidBetSpot29          :  return (((TCLordState *)PState)->BetSpot(responder,29));
	 case cidBetSpot30          :  return (((TCLordState *)PState)->BetSpot(responder,30));
	 case cidBetSpot31          :  return (((TCLordState *)PState)->BetSpot(responder,31));
	 case cidBetSpot32          :  return (((TCLordState *)PState)->BetSpot(responder,32));
	 case cidBetSpot33          :  return (((TCLordState *)PState)->BetSpot(responder,33));
	 case cidBetSpot34          :  return (((TCLordState *)PState)->BetSpot(responder,34));
	 case cidBetSpot35          :  return (((TCLordState *)PState)->BetSpot(responder,35));
	 case cidBetSpot36          :  return (((TCLordState *)PState)->BetSpot(responder,36));
	 case cidBetSpot37          :  return (((TCLordState *)PState)->BetSpot(responder,37));
	 case cidBetSpot38          :  return (((TCLordState *)PState)->BetSpot(responder,38));
	 case cidBetSpot39          :  return (((TCLordState *)PState)->BetSpot(responder,39));
	 case cidBetSpot40          :  return (((TCLordState *)PState)->BetSpot(responder,40));
	 case cidBetSpot41          :  return (((TCLordState *)PState)->BetSpot(responder,41));
	 case cidBetSpot42          :  return (((TCLordState *)PState)->BetSpot(responder,42));
	 case cidBetSpot43          :  return (((TCLordState *)PState)->BetSpot(responder,0));
	 case cidBetSpot44          :  return (((TCLordState *)PState)->BetSpot(responder,0));
	 case cidBetSpot45          :  return (((TCLordState *)PState)->BetSpot(responder,1));
	 case cidBetSpot46          :  return (((TCLordState *)PState)->BetSpot(responder,1));
	 case cidBetSpot47          :  return (((TCLordState *)PState)->BetSpot(responder,1));
	 case cidBetSpot48          :  return (((TCLordState *)PState)->BetSpot(responder,1));
	 case cidBetSpot49          :  return (((TCLordState *)PState)->BetSpot(responder,3));

	 default                    :  return true;
	 }
  }
  return true; // MRP 12/21/96
}
//*******************************************************************
void TCasinoCGameLord::SetupResponders()
{
  Responders[50]  = new TResponder(PModeWin,100,TRect(260,465,375,477)  ,cidNamePlate,this,true,VK_TAB,TCursorData(GetOgleApp(),ID_POINTING_FINGER_CURSOR));
  Responders[51]  = new TResponder(PModeWin,50,TRect(1,210,635,428),cidFeltCursor,this,true);
  Responders[43]  = new TResponder(PModeWin,100,TRect(593,319,634,389),cidBetSpot43,this,true);
  Responders[44]  = new TResponder(PModeWin,100,TRect(578,260,601,312),cidBetSpot44,this,true);
  Responders[45]  = new TResponder(PModeWin,100,TRect(562,316,584,335),cidBetSpot45,this,true);
  Responders[46]  = new TResponder(PModeWin,100,TRect(555,294,574,311),cidBetSpot46,this,true);
  Responders[47]  = new TResponder(PModeWin,100,TRect(542,272,563,288),cidBetSpot47,this,true);
  Responders[48]  = new TResponder(PModeWin,100,TRect(534,255,555,267),cidBetSpot48,this,true);
  Responders[49]  = new TResponder(PModeWin,100,TRect(493,247,531,269),cidBetSpot49,this,true);

  Responders[0]  = new TResponder(PModeWin,100,TRect(234,395,607,417),cidBetSpot0          ,this,true);
  Responders[1]  = new TResponder(PModeWin,100,TRect(238,374,529,390),cidBetSpot1          ,this,true);
  Responders[2]  = new TResponder(PModeWin,100,TRect(245,320,548,336),cidBetSpot2          ,this,true);
  Responders[3]  = new TResponder(PModeWin,100,TRect(498,273,539,300),cidBetSpot3          ,this,true);
  Responders[4]  = new TResponder(PModeWin,100,TRect(243,342,524,369),cidBetSpot4          ,this,true);
  Responders[5]  = new TResponder(PModeWin,100,TRect(531,365,567,392),cidBetSpot5          ,this,true);
  Responders[6]  = new TResponder(PModeWin,100,TRect(559,340,589,360),cidBetSpot6          ,this,true);
  Responders[7]  = new TResponder(PModeWin,100,TRect(3,403,176,418),cidBetSpot7          ,this,true);
  Responders[8]  = new TResponder(PModeWin,100,TRect(35,332,193,343),cidBetSpot8          ,this,true);
  Responders[9]  = new TResponder(PModeWin,100,TRect(31,348,92,368),cidBetSpot9          ,this,true);
  Responders[10]  = new TResponder(PModeWin,100,TRect(19,377,80,396),cidBetSpot10          ,this,true);
  Responders[11]  = new TResponder(PModeWin,100,TRect(113,379,174,398),cidBetSpot11          ,this,true);
  Responders[12]  = new TResponder(PModeWin,100,TRect(121,349,182,367),cidBetSpot12          ,this,true);
  Responders[13]  = new TResponder(PModeWin,100,TRect(55,297,116,316),cidBetSpot13          ,this,true);
  Responders[14]  = new TResponder(PModeWin,100,TRect(64,273,125,292),cidBetSpot14          ,this,true);
  Responders[15]  = new TResponder(PModeWin,100,TRect(138,274,199,292),cidBetSpot15          ,this,true);
  Responders[16]  = new TResponder(PModeWin,100,TRect(134,297,195,316),cidBetSpot16          ,this,true);
  Responders[17]  = new TResponder(PModeWin,100,TRect(224,296,266,311),cidBetSpot17          ,this,true);
  Responders[18]  = new TResponder(PModeWin,100,TRect(271,296,313,311),cidBetSpot18          ,this,true);
  Responders[19]  = new TResponder(PModeWin,100,TRect(317,296,359,311),cidBetSpot19          ,this,true);
  Responders[20]  = new TResponder(PModeWin,100,TRect(364,296,406,311),cidBetSpot20          ,this,true);
  Responders[21]  = new TResponder(PModeWin,100,TRect(410,296,454,311),cidBetSpot21          ,this,true);
  Responders[22]  = new TResponder(PModeWin,100,TRect(452,296,496,311),cidBetSpot22          ,this,true);
  Responders[23]  = new TResponder(PModeWin,100,TRect(227,268,267,281),cidBetSpot23          ,this,true);
  Responders[24]  = new TResponder(PModeWin,100,TRect(272,268,312,281),cidBetSpot24          ,this,true);
  Responders[25]  = new TResponder(PModeWin,100,TRect(317,268,357,281),cidBetSpot25          ,this,true);
  Responders[26]  = new TResponder(PModeWin,100,TRect(362,268,402,281),cidBetSpot26          ,this,true);
  Responders[27]  = new TResponder(PModeWin,100,TRect(407,268,447,281),cidBetSpot27          ,this,true);
  Responders[28]  = new TResponder(PModeWin,100,TRect(450,268,490,281),cidBetSpot28          ,this,true);
  Responders[29]  = new TResponder(PModeWin,100,TRect(228,261,270,267),cidBetSpot29          ,this,true);
  Responders[30]  = new TResponder(PModeWin,100,TRect(272,261,314,267),cidBetSpot30          ,this,true);
  Responders[31]  = new TResponder(PModeWin,100,TRect(316,261,358,267),cidBetSpot31          ,this,true);
  Responders[32]  = new TResponder(PModeWin,100,TRect(360,261,402,267),cidBetSpot32          ,this,true);
  Responders[33]  = new TResponder(PModeWin,100,TRect(405,261,447,267),cidBetSpot33          ,this,true);
  Responders[34]  = new TResponder(PModeWin,100,TRect(449,261,490,267),cidBetSpot34          ,this,true);
  Responders[35]  = new TResponder(PModeWin,100,TRect(231,251,270,257),cidBetSpot35          ,this,true);
  Responders[36]  = new TResponder(PModeWin,100,TRect(273,251,313,257),cidBetSpot36          ,this,true);
  Responders[37]  = new TResponder(PModeWin,100,TRect(317,251,356,257),cidBetSpot37          ,this,true);
  Responders[38]  = new TResponder(PModeWin,100,TRect(360,251,398,257),cidBetSpot38          ,this,true);
  Responders[39]  = new TResponder(PModeWin,100,TRect(402,251,442,257),cidBetSpot39          ,this,true);
  Responders[40]  = new TResponder(PModeWin,100,TRect(446,251,484,257),cidBetSpot40          ,this,true);
  Responders[41]  = new TResponder(PModeWin,100,TRect(202,310,227,419),cidBetSpot41          ,this,true);
  Responders[42]  = new TResponder(PModeWin,100,TRect(93,361,111,385),cidBetSpot42          ,this,true);

}
//*******************************************************************
TCasinoCGameLord::TCasinoCGameLord(TCrapsModeWin *pmwin,const TFileMode &NewFileMode)
:TCasinoGameLord(pmwin,NewFileMode,cc1,TMoney::did_1_00)//cd1)
{
  randomize();
  for(int16 i=0;i<47;i++)
  {
	 BetSpot[i]        = NULL;
  }
  Sounds            = NULL;
  Button0       = NULL;
  Button1       = NULL;
  Button2       = NULL;
  Button3       = NULL;
  Button4       = NULL;
  Button5       = NULL;
  Button6       = NULL;
  Button7       = NULL;
  Button8       = NULL;
  Button9       = NULL;
  Button10      = NULL;
  Button11      = NULL;
  Button12      = NULL;
  Button13      = NULL;
  MessageDisplay   = NULL;
  BankCashDisplay  = NULL;
  BetAmountDisplay = NULL;
  Chips              = NULL;
  NamePlate1         = NULL;
  NamePlate2         = NULL;
  NamePlate3         = NULL;
//  Circle             = NULL;
  BetPayOff          = NULL;

  BigDice1           = NULL;
  BigDice2           = NULL;
  BigDice3           = NULL;
  BigDice4           = NULL;
  BigDice5           = NULL;
  BigDice6           = NULL;

  Puck               = NULL;
  DiceA = NULL;
  DiceB = NULL;
  DiceC = NULL;
  DiceD = NULL;
  PState        = new TCLordMainState(this);
  pAskExpert    = new TCAsk(this);
  ALLHANDSWON      = true;
  pMWin            = pmwin;
  maxbet           = 3l;
  credits          = 0l;
  coinsize         = (int32)GameDenom;
  activeplayer     = -1;
  playersin        = 1;
  coinsplayed      = 0l;
  shutdownstate    = 0;
  winnum           = -1;
  currentwinnings  = 0l;
  winnerpaid       = 0l;
  COMEOUT          = true;
  Dice1            = -1;
  Dice2            = -1;
  PDice1           = 0;
  PDice2           = 0;
  Point            = -1;
  Shooter          = 0;
  HDice          = false;
  COMEOUTWINNER    = false;
  ButtonInfo = 0;
  ExpertLite = false;
  messagestate     = 0;
  NumOfRolls = 0;
  NShooter = true;
  FirstRoll  = true;
  DicePos  = 0;
  StallsInRow = 0;
  Style = 3;
  CurrentBetPaid = 0;
  ShootLength   = 0;
  Passes = 0;
  ShakeInRow = 0;
  for(int16 j=0;j<NUMOFBUTTONS;j++)
  {
	 ButtonHit[j] = false;
  }

  SetupResponders();
}
//*******************************************************************
TCasinoCGameLord::~TCasinoCGameLord()
{
  DestroyState();

  delete pAskExpert;
  pAskExpert = NULL;
  CleanupResponders();
}
//*******************************************************************
void TCasinoCGameLord::SetOnOffFlags()
{
  OnOffFlags[0] = GetCasPD(activeplayer)->CData.Buy4and10;
  OnOffFlags[1] = GetCasPD(activeplayer)->CData.Buy5and9;
  OnOffFlags[2] = GetCasPD(activeplayer)->CData.Buy6and8;
  OnOffFlags[3] = GetCasPD(activeplayer)->CData.FreeOddsOn;
  OnOffFlags[4] = GetCasPD(activeplayer)->CData.DoNotFreeOddsOn;
  OnOffFlags[5] = GetCasPD(activeplayer)->CData.BuyandPlaceOn;
  OnOffFlags[6] = GetCasPD(activeplayer)->CData.HardwayOn;
  return;
}
//*******************************************************************
int16 TCasinoCGameLord::InitCraps()
{
  Button13->SetCurrentUpFrame(11);
  Button13->ShowVoidUp();
  for(int16 i=0;i<43;i++)
  {
	 Responders[i]->SetEnterLeave();
  }
  Responders[51]->SetEnterLeave();
  Responders[43]->SetEnterLeave();
  Responders[44]->SetEnterLeave();
  Responders[45]->SetEnterLeave();
  Responders[46]->SetEnterLeave();
  Responders[47]->SetEnterLeave();
  Responders[48]->SetEnterLeave();
  Responders[49]->SetEnterLeave();EnableOddsMessage();
  PlaceBetsMode = true;
  BetSpotsOn = true;
  NamePlate1->NoShow();NamePlate2->NoShow();NamePlate3->NoShow();
  string name;
  SetBodyIdle();
  SetupActivePlayer(NextSlotNum(-1)); // -1 because order of checking
  Shooter = activeplayer;
  if(GetCasPD(0))
  {
	 name = GetCasPD(0)->GetName();
	 NamePlate1->ShowNamePlateString(name);
	 BankCashDisplay->SetNum(GetCash(0));
  }
  else if(GetCasPD(1))
  {
	 name = GetCasPD(1)->GetName();
	 NamePlate2->ShowNamePlateString(name);
	 BankCashDisplay->SetNum(GetCash(1));
  }
  else if(GetCasPD(2))
  {
	 name = GetCasPD(2)->GetName();
	 NamePlate3->ShowNamePlateString(name);
	 BankCashDisplay->SetNum(GetCash(2));
  }
  else
  {
	 BankCashDisplay->SetNum(0l);
  }
  if(GetCasPD(0))
  {
	 GetCasPD(0)->StartCSession(SubGameType,GameDenom);
	 if(GetCash(0) >= 5l)
	 {
		GetCPlayer(0)->lastbet = 5l;
	 }
  }
  if(GetCasPD(1))
  {
	 GetCasPD(1)->StartCSession(SubGameType,GameDenom);
	 if(GetCash(1) >= 5l)
	 {
		GetCPlayer(1)->lastbet = 5l;
	 }
  }
  if(GetCasPD(2))
  {
	 GetCasPD(2)->StartCSession(SubGameType,GameDenom);
	 if(GetCash(2) >= 5l)
	 {
		GetCPlayer(2)->lastbet = 5l;
	 }
  }
  BetAmountDisplay->SetNum(0);
  credits = 0l;
  coinsplayed = 0l;
  winnerpaid = 0l;
  DicePos = 2;
  BigDice3->ShowNum(int16(random(6)));
  BigDice4->ShowNum(int16(random(6)));
  if(activeplayer != -1 && GetCash(activeplayer) >= 5l)
  {
	 GetCPlayer(activeplayer)->lastbet = 5l;
	 BetAmountDisplay->SetNum(GetCPlayer(activeplayer)->lastbet);
  }
  SetOnOffFlags();
  Button5->ShowGray();
  if (!GetFW()->GetHandleShowMenu())
  {
	 Button2->PButton->CAD.SetCurrentFrame(3);
	 Button2->PButton->Show();
	 Button2->PButtonResponder->Remove();
  }
  return 1;
}
//*******************************************************************
int16 TCasinoCGameLord::Bet1(TMoney betsize)
{
  if(GetCash(activeplayer) == 0l)
  {
	 if(activeplayer != -1 && BetMade(activeplayer))
	 {
		  PModeWin->MessageBox("You're out of money and may not make additional bets. Your current bets are your only hope.","Out of Cash",MB_OK);
	 }
	 else if(GetCasPD(activeplayer)->IsActiveKenoTicket())
	 {
		PModeWin->MessageBox("You're out of money and may not bet. Your only hope is that one of your Keno tickets pays off.","Out of Cash",MB_OK);
	 }
	 else
	 {
		PModeWin->MessageBox("You've hit rock bottom. Your gambler is bankrupt. Select Create/Delete under the FILE menu to create or select a new gambler.","Bankrupt!",MB_OK);
	 }
  }
  if(GetCPlayer(activeplayer)->coinsplayed+betsize >= 100001l)
  {
	 PModeWin->MessageBox("You may bet no more than $100,000 on any single bet spot.","Table Limit",MB_OK);
	 return 0;
  }
  if(GetCash(activeplayer) >= betsize+coinsplayed && GetCPlayer(activeplayer)->coinsplayed+betsize < 100001l)
  {
	 coinsplayed += betsize;
	 GetCPlayer(activeplayer)->coinsplayed += betsize;
	 BetAmountDisplay->SetNum(GetCPlayer(activeplayer)->coinsplayed);
	 if(coinsplayed == GetCash(activeplayer)){Sounds->PlaySound(4);}
  }
  else
  {
	 if(coinsplayed == GetCash(activeplayer) || GetCash(activeplayer) == 0l){Sounds->PlaySound(5);}
	 else
	 {
		if(GetCPlayer(activeplayer)->coinsplayed+betsize < 100001l)
		{
		  coinsplayed = GetCash(activeplayer);
		  GetCPlayer(activeplayer)->coinsplayed = GetCash(activeplayer);
		  BetAmountDisplay->SetNum(GetCPlayer(activeplayer)->coinsplayed);
		  Sounds->PlaySound(4);
		}
	 }
  }
  return 1;
}
//*******************************************************************
int16 TCasinoCGameLord::BetLast()
{
  if(GetCash(activeplayer) >= GetCPlayer(activeplayer)->lastbet)
  {
	 coinsplayed += GetCPlayer(activeplayer)->lastbet;
	 GetCPlayer(activeplayer)->coinsplayed += GetCPlayer(activeplayer)->lastbet;
  }
  return 1;
}
//*******************************************************************
int16 TCasinoCGameLord::UnBet1(TMoney betsize)
{
  if(coinsplayed >= betsize)
  {
	 coinsplayed -= betsize;
	 GetCPlayer(activeplayer)->coinsplayed -= betsize;
	 BetAmountDisplay->SetNum(coinsplayed);
  }
  return 1;
}
//*******************************************************************
int16 TCasinoCGameLord::ClearBet()
{
  coinsplayed = 0l;
  GetCPlayer(activeplayer)->coinsplayed = 0l;
  GetCPlayer(activeplayer)->lastbet = 0l;
  BetAmountDisplay->SetNum(0l);
  return 1;
}
//*******************************************************************
int16 TCasinoCGameLord::BetMax()
{
  if(GetCash(activeplayer) > (maxbet-coinsplayed)*coinsize)
  {
	 SubCash(activeplayer,(maxbet-coinsplayed)*coinsize);
	 coinsplayed = maxbet;
  }
  else
  {
	 coinsplayed += (GetCash(activeplayer))/(coinsize);
	 SetCash(activeplayer,GetCash(activeplayer)%coinsize);
  }
  return 1;
}
//*******************************************************************
