 //*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  crpost.cpp
//    Project Name:  Casino
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     03/29/95   A. Krist    Original baseline
//  2.0     09/18/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "ccpost.h" //payout
//*******************************************************************
TCPayOutState::TCPayOutState(TCasinoCGameLord *pNewCLord,int16 betspot)
:TCLordState(pNewCLord)
{
	 SetRunOrder(ess_Execute,ess_Execute,ess_Done,ess_Done,ess_Done);
	 StartingFUC = 0;
	 FUCLength = 0;
	 BetSpot = betspot;
	 WaitOnResult = false;
}
//*******************************************************************
TCPayOutState::~TCPayOutState()
{
}
//*******************************************************************
void TCPayOutState::ExecuteFirstTime()
{
//  pOwnerLord->SetBodyIdle();
  pOwnerLord->CurrentBetPaid = BetSpot;
  pOwnerLord->currentwinnings = 0l;
  if(pOwnerLord->Winner(BetSpot))
  {
	 ExecuteWaiting = true;
	 ExecuteStatus    = ess_Execute;
	 StartingFUC = pOwnerLord->GetAdjFUC();
	 pOwnerLord->PayOffCom(StartingFUC,FUCLength);
	 WaitOnResult = true;
  }
  else
  {
	 ExecuteWaiting = false;
	 ExecuteStatus    = ess_Done;
  }

}
//*******************************************************************
void TCPayOutState::HandlePostUpdate(dword NewFUC)
{
  if (WaitOnResult)
  {
	 if((StartingFUC + FUCLength + 11) <= NewFUC)
	 {
		pOwnerLord->BetSpot[BetSpot]->SetNum();
		pOwnerLord->BetPayOff->NoShow();
		pOwnerLord->BankCashDisplay->SetNum(pOwnerLord->GetCash(pOwnerLord->activeplayer));
		pOwnerLord->Chips->SetNum(pOwnerLord->GetCash(pOwnerLord->activeplayer));
		pOwnerLord->currentwinnings = 0l;
		WaitOnResult = false;
		pOwnerLord->MessageDisplay->NoShowDisplay();
		ExecuteWaiting = false;
		ExecuteStatus    = ess_Done;
	 }
  }
}
//*******************************************************************