//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  crpucksp.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0    03/23/96    A.Krist     moved inline functions into .cpp file.
//  2.0    09/18/97    M.Perry     32-bit conversion.
//********************************************************************
#include "ccpucksp.h"
#include "oanm.h"
//*******************************************************************
void TCPuck::SetupAnms()
{
  PPuck = GetAnm(0);
  if (PPuck == NULL) {AnmError("CPuck","Puck",0);}
  PPuck->CAD.ClearAutoStart();
  PPuck->CAD.ClearAutoStop();
  PPuck->CAD.SetDirStill();
}
//*******************************************************************
TCPuck::TCPuck(TOgleModeWindow *pmw,const TFileMode &NewFileMode)
:TSprite(pmw,NewFileMode)
{
  SetToManual();
  NotFound = false;
  NoShow();
  SetupAnms();
}
//********************************************************************
TCPuck::TCPuck(TOgleModeWindow *pmw,const TFileMode &fm,void *psource)
:TSprite(pmw,fm,psource)
{
  SetToManual();
  NotFound = false;
  NoShow();
  SetupAnms();
}
 //*******************************************************************
TCPuck::~TCPuck()
{
}
//*******************************************************************
void TCPuck::SetNum(int16 num)
{
  switch(num)
  {
	case 2  : PPuck->CAD.SetCurrentFrame(1);
				 PPuck->Show();break;
	case 3  : PPuck->CAD.SetCurrentFrame(2);
				 PPuck->Show();break;
	case 4  : PPuck->CAD.SetCurrentFrame(3);
				 PPuck->Show();break;
	case 6  : PPuck->CAD.SetCurrentFrame(4);
				 PPuck->Show();break;
	case 7  : PPuck->CAD.SetCurrentFrame(5);
				 PPuck->Show();break;
	case 8  : PPuck->CAD.SetCurrentFrame(6);
				 PPuck->Show();break;
	default : PPuck->CAD.SetCurrentFrame(0);
				 PPuck->Show();break;
  }
  Update(GetAdjFUC());
}
//*******************************************************************