//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  ccredgld.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     12/16/96   M.Perry     original baseline
//  2.0     09/17/97   M.Perry     32-bit conversion.
//  2.3    07/14/99    M.Perry    gobjlist removal
//********************************************************************
#include "casgfw.h"
#include "ccredgld.h"
#include "ccredmw.h"
#include "orespond.h"
#include "oanm.h"
#include "accmenu.rh"
//*******************************************************************
TCreditsGameLord::TCreditsGameLord(TCreditsModeWin *pmodewin,const TFileMode &fm)
:TCasinoGameLord(pmodewin,fm,ciNone,TMoney::did_0_00),
 PCasinoModeWin(pmodewin)
{
  TFileMode splfm(SpriteListName,
                  TFileMode::fm_None,
                  TFileMode::fm_Immed,
                  FileMode.GetDirIndex());
  CreateAddSpriteList(splfm);

  PBigResponder = new TResponder(pmodewin,1,TRect(0,0,640,480),1,this,true,'^');
  SetupSprites();
}
//*******************************************************************
TCreditsGameLord::~TCreditsGameLord()
{
  delete PBigResponder;
  PBigResponder = NULL;
}
//*******************************************************************
bool TCreditsGameLord::Respond(TResponder &responder)
{
  if (responder.GetResponseEvent() == reLUp ||
      responder.GetResponseEvent() == reRUp ||
      responder.GetResponseEvent() == reChar)
  {
    TOgleGameFrameWindow *pgfw = GetFW();
    if (pgfw != NULL)
    {
      pgfw->SetIntroUserSkipped();
    }
    PModeWin->PostCommandToFW(CM_GAMELOBBY);
    return true;
  }
  return false;
}
//*******************************************************************
void TCreditsGameLord::SetupSprites()
{
  StillAnmIndex = 1;
  PSprite0 = GetSpritePtr(0);
  PSprite1 = GetSpritePtr(1);
  Start1 = PSprite0->Get_FUC_Length();
  StillStart = 40;
  StillStop = Start1 + 103;
  EndFUC = Start1 + PSprite1->Get_FUC_Length();
  PSprite0->GetAnm(StillAnmIndex)->CAD.SetDirStill();
  PSprite0->GetAnm(StillAnmIndex)->NoShow();
  if (TOgleMemMgr::GetWorkingSize() > 4000000l ||
      PSprite0->GetAnm(StillAnmIndex)->GetHDBuffering())
  // if (decent amount of ram or hd buffering) then load now, otherwise load when activated.
  {
    PSprite1->LoadRamWavList(TFileMode::fm_Immed,TFileMode::fm_BG_Med);  // least important first,then relax status.
    PSprite1->LoadRamAnmList(TFileMode::fm_Immed,TFileMode::fm_BG_Med);
  }
  ActivateSpriteNow(PSprite0);
}
//*******************************************************************
void TCreditsGameLord::Update(dword fuc)
{
  if (fuc == Start1)  // start 2nd sprite.
  {
    ActivateSpriteNow(PSprite1);
  }
  else if (fuc == StillStart) // start showing bumper sticker.
  {
    PSprite0->GetAnm(StillAnmIndex)->Show();
  }
  else if (fuc == StillStop)  // stop showing bumper sticker.
  {
    PSprite0->GetAnm(StillAnmIndex)->CAD.SetDirFor();
  }
  else if (fuc == EndFUC)  // 2nd sprite ended, go to lobby.
  {
//    GetCasMW()->GetCasGFW()->SetFadeIn(true); // mrp - v2.4 - 09/13/99 - commented out
    PModeWin->PostCommandToFW(CM_GAMELOBBY);
  }

  TCasinoGameLord::Update(fuc);
}
//*******************************************************************
