//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  casmw.cpp
//    Project Name:  Casino                         
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     10/12/95   M.Perry      original baseline
//  1.1     11/10/96   A.Krist      Added PostSwitchToLobby(int HotSpot)
//                                    Switches to game of corasponding hotspot.
//  2.0     08/31/97   M.Perry      32-bit conversion.
//  2.3     07/14/99   M.Perry      retrofit to ogle.
//********************************************************************
#include "casmw.h"
#include "oapp.h"
#include "casgfw.h"
#include "casglord.h"
#include "expert.h"
#include "cplaymgr.h"
#include "ogame.h"
#include "cas_cm.rh"
#include "osndmgr.h"
//*******************************************************************
DEFINE_RESPONSE_TABLE1(TCasinoModeWin,TOgleModeWindow)
  EV_COMMAND(CM_ASKEXPERTSTATISTICS,CmAskExpertStatistics),
  EV_COMMAND_ENABLE(CM_ASKEXPERTSTATISTICS,CeAskExpertStatistics),
  EV_COMMAND(CM_ASKEXPERTINSTRUCTION,CmAskExpertInstruction),
  EV_COMMAND_ENABLE(CM_ASKEXPERTINSTRUCTION,CeAskExpertInstruction),
  EV_COMMAND(CM_ASKEXPERTRECOMMENDATION,CmAskExpertRecommendation),
  EV_COMMAND_ENABLE(CM_ASKEXPERTRECOMMENDATION,CeAskExpertRecommendation),
END_RESPONSE_TABLE;
//*******************************************************************
void TCasinoModeWin::CmAskExpertStatistics()
{
  // get active player and give to playermgr.
  int16 slotnum = -1;
  if (GetCasGameLord() != NULL) {slotnum = GetCasGameLord()->GetActivePlayer();}
  int16 playernum = GetPlayerMgr()->GetActivePlayerNum(slotnum);

  bool waspaused = GetUpdatePause();
  SetUpdatePause();
  GetSoundMgr()->Stop(true);

  GetPlayerMgr()->DoStatisticsDialog(playernum);

  if (!waspaused) {ClearUpdatePause();}
}
//*******************************************************************
void TCasinoModeWin::CeAskExpertStatistics(TCommandEnabler &enabler)
{
  enabler.Enable(GetCasGFW()->GetCasMenuEnable()->Statistics);
}
//*******************************************************************
void TCasinoModeWin::CmAskExpertInstruction()
{
  if (GetCasGameLord() == NULL) {return;}
  int16 slotnum = GetCasGameLord()->GetActivePlayer();
  TCasinoPlayerData *pdat = GetCasPlayerMgr()->GetActiveCasinoPlayerDataPtr(slotnum);
  if (pdat == NULL) {return;}
  pdat->ToggleCoach();
}
//*******************************************************************
void TCasinoModeWin::CeAskExpertInstruction(TCommandEnabler &enabler)
{
  if (!GetCasGFW()->GetCasMenuEnable()->Instruction)
  {
    enabler.Enable(FALSE);
    enabler.SetCheck(TCommandEnabler::Unchecked);
    return;
  }

  if (GetCasGameLord() == NULL)
  {
    enabler.Enable(FALSE);
    enabler.SetCheck(TCommandEnabler::Unchecked);
    return;
  }
  int16 slotnum = GetCasGameLord()->GetActivePlayer();
  TCasinoPlayerData *pdat = GetCasPlayerMgr()->GetActiveCasinoPlayerDataPtr(slotnum);
  if (pdat == NULL)
  {
    enabler.Enable(FALSE);
    enabler.SetCheck(TCommandEnabler::Unchecked);
    return;
  }
  enabler.Enable(TRUE);
  if (pdat->CoachOn) {enabler.SetCheck(TCommandEnabler::Checked);}
  else               {enabler.SetCheck(TCommandEnabler::Unchecked);}
}
//*******************************************************************
void TCasinoModeWin::CmAskExpertRecommendation()
{
   if (GetCasGameLord() == NULL) {return;}
   GetCasGameLord()->Recommendation();
}
//*******************************************************************
void TCasinoModeWin::CeAskExpertRecommendation(TCommandEnabler &enabler)
{
  if (!GetCasGFW()->GetCasMenuEnable()->Recommendation)
  {
    enabler.Enable(FALSE);
    return;
  }
  if (GetCasGameLord() == NULL)
  {
    enabler.Enable(FALSE);
    return;
  }
  enabler.Enable(TRUE);
}
//*******************************************************************
TCasinoModeWin::TCasinoModeWin(string modename,TPal *PPal,string title)
:TOgleModeWindow(TOgleApp::GetOgleApp(),TOgleApp::GetOgleApp()->GetFW(),modename,PPal,title)
{
  CreatePlayerList(PLAYERMGR_NUMACTIVEPLAYERS);
}
//*******************************************************************
TCasinoModeWin::~TCasinoModeWin()
{
}
//*******************************************************************
void TCasinoModeWin::SetupGObjs()
{
  if (pLord == NULL)
  {
    GObjError(string("GameLord"),string("unknown"));
  }

  if (GObj == NULL && NumPlayers > 0)
  {
    GObjError(string("GObjs array not alloc'd"),string("unknown"));
  }

  char buffer[50];
  if (GObj != NULL)
  {
    for (int16 i = 0;i<NumPlayers;i++)
    {
      if (GObj[i] == NULL)
      {
        itoa(i,buffer,10);
        string s = "Human Slot ";
        s += buffer;
        GObjError(s,string("unknown"));
      }
    }
  }
}
//*******************************************************************
//void TCasinoModeWin::CreatePlayerList()
//{
//  NumPlayers = PLAYERMGR_NUMACTIVEPLAYERS;
//  GObj = new TPlayer *[NumPlayers];
//  for(int16 i=0;i<NumPlayers;i++)
//  {
//    GObj[i] = NULL;
//  }
//}
//*******************************************************************
void TCasinoModeWin::ShuttingDown()
{
  if (pLord != NULL) {pLord->ShuttingDown();}
  if (GObj != NULL)
  {
    for (int16 i=0;i<NumPlayers;i++)
    {
      if (GObj[i] != NULL) {GObj[i]->ShuttingDown();}
    }
  }
  TOgleModeWindow::ShuttingDown();
}
//*******************************************************************
TCasinoGameFrameWindow *TCasinoModeWin::GetCasGFW()
{
  return ((TCasinoGameFrameWindow *)GetFW());
}
//*******************************************************************
TCasinoPlayerMgr *TCasinoModeWin::GetCasPlayerMgr()
{
  return ((TCasinoPlayerMgr *)GetCasGFW()->GetPlayerMgr());
}
//*******************************************************************
//TCasinoGameLord *TCasinoModeWin::GetCasGameLord()
//{
//  return ((TCasinoGameLord *)pLord);
//}
//*******************************************************************
int16 TCasinoModeWin::AskCriteriaQuestion(int16 QNum)
{
  return (GetCasGameLord()->AskCriteriaQuestion(QNum));
}
//*******************************************************************

