//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  daccgfw.cpp                    
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.2     4/17/97    M.Perry    modified framewin hierarchy.
//********************************************************************
#include "daccgfw.h"
#include "daccapp.h"
#include "cgametyp.h"
#include "daccat.rh"
#include "cplaymgr.h"
#include "daccabt.rh"
//*******************************************************************
TDACCMenuEnable::TDACCMenuEnable(BOOL setvalues)
:TCasinoMenuEnable(FALSE)
{
  if (setvalues)
  {
    SetAll(TRUE);
  }
  CurrentMode =  IDS_M_LOBBY;
  Lobby = FALSE;
}
//*******************************************************************
TDACCMenuEnable::~TDACCMenuEnable()
{
}
//*******************************************************************
void TDACCMenuEnable::SetAll(BOOL value)
{
  TCasinoMenuEnable::SetAll(value);
}
//*******************************************************************
void TDACCMenuEnable::SetModes(BOOL value)
{
  TCasinoMenuEnable::SetModes(value);

  Lobby = value;

  BlackJackOne = value;
  BlackJackTwo = FALSE;
  BlackJackFour = FALSE;
  BlackJackSix = FALSE;

  Craps = value;

  Roulette = value;

  Keno = value;

  SlotsAladdin100 = FALSE;
  SlotsAladdin500 = FALSE;
  SlotsAladdin1P = FALSE;

  SlotsParadise25 = FALSE;
  SlotsParadise50 = FALSE;
  SlotsParadise100 = FALSE;

  SlotsJungle1 = FALSE;
  SlotsJungle2 = FALSE;
  SlotsJungle100 = FALSE;

  SlotsPirate1 = value;  // this one active.
  SlotsPirate2 = FALSE;
  SlotsPirate5 = FALSE;
  SlotsPirate10 = FALSE;
  SlotsPirate25 = FALSE;
  SlotsPirate50 = FALSE;
  SlotsPirate100 = FALSE;

  SlotsLucky1 = FALSE;
  SlotsLucky2 = FALSE;
  SlotsLucky5 = FALSE;
  SlotsLucky10 = FALSE;
  SlotsLucky25 = FALSE;
  SlotsLucky50 = FALSE;

  SlotsSpirit1000 = FALSE;

  SlotsJokers5 = FALSE;
  SlotsJokers10 = FALSE;
  SlotsJokers25 = FALSE;
  SlotsJokers50 = FALSE;
  SlotsJokers100 = FALSE;

  SlotsTotal1 = FALSE;
  SlotsTotal2 = FALSE;
  SlotsTotal5 = FALSE;
  SlotsTotal10 = FALSE;
  SlotsTotal500 = FALSE;
  SlotsTotal1000 = FALSE;

  SlotsCherry1 = FALSE;
  SlotsCherry2 = FALSE;
  SlotsCherry5 = FALSE;
  SlotsCherry10 = FALSE;
  SlotsCherry25 = FALSE;
  SlotsCherry50 = FALSE;

  VPJack1 = FALSE;
  VPJack5 = FALSE;
  VPJack25 = FALSE;
  VPJack100 = FALSE;
  VPJack1P = value;  // this one active.

  VPDWild1 = FALSE;
  VPDWild5 = FALSE;
  VPDWild25 = FALSE;
  VPDWild100 = FALSE;

  VPTen1 = FALSE;
  VPTen5 = FALSE;
  VPTen25 = FALSE;
  VPTen100 = FALSE;

  VPJWild1 = FALSE;
  VPJWild5 = FALSE;
  VPJWild25 = FALSE;
  VPJWild100 = FALSE;
}
//*******************************************************************
//*******************************************************************
DEFINE_RESPONSE_TABLE1(TDACCGameFrameWindow,TCasinoGameFrameWindow)
  // lobby
  EV_COMMAND(CM_GAMELOBBY,CmGameLobby),
  EV_COMMAND_ENABLE(CM_GAMELOBBY,CeGameLobby),

  // bj
  EV_COMMAND(CM_GAMEBLACKJACKONE,CmGameBlackJackOne),
  EV_COMMAND_ENABLE(CM_GAMEBLACKJACKONE,CeGameBlackJackOne),
  EV_COMMAND(CM_GAMEBLACKJACKTWO,CmGameBlackJackTwo),
  EV_COMMAND_ENABLE(CM_GAMEBLACKJACKTWO,CeGameBlackJackTwo),
  EV_COMMAND(CM_GAMEBLACKJACKFOUR,CmGameBlackJackFour),
  EV_COMMAND_ENABLE(CM_GAMEBLACKJACKFOUR,CeGameBlackJackFour),
  EV_COMMAND(CM_GAMEBLACKJACKSIX,CmGameBlackJackSix),
  EV_COMMAND_ENABLE(CM_GAMEBLACKJACKSIX,CeGameBlackJackSix),
  // craps
  EV_COMMAND(CM_GAMECRAPS,CmGameCraps),
  EV_COMMAND_ENABLE(CM_GAMECRAPS,CeGameCraps),
  // keno
  EV_COMMAND(CM_GAMEKENO,CmGameKeno),
  EV_COMMAND_ENABLE(CM_GAMEKENO,CeGameKeno),
  // roulette
  EV_COMMAND(CM_GAMEROULETTE,CmGameRoulette),
  EV_COMMAND_ENABLE(CM_GAMEROULETTE,CeGameRoulette),

//  EV_COMMAND(CM_OPTIONSLOBBY_SHOWINTRO ,CmShowIntro),
//  EV_COMMAND_ENABLE(CM_OPTIONSLOBBY_SHOWINTRO ,CeShowIntro),

  // vp tb
  EV_COMMAND(CM_GAMEVPTEN1,CmGameVPTen1),
  EV_COMMAND_ENABLE(CM_GAMEVPTEN1,CeGameVPTen1),
  EV_COMMAND(CM_GAMEVPTEN5,CmGameVPTen5),
  EV_COMMAND_ENABLE(CM_GAMEVPTEN5,CeGameVPTen5),
  EV_COMMAND(CM_GAMEVPTEN100,CmGameVPTen100),
  EV_COMMAND_ENABLE(CM_GAMEVPTEN100,CeGameVPTen100),
  EV_COMMAND(CM_GAMEVPTEN25,CmGameVPTen25),
  EV_COMMAND_ENABLE(CM_GAMEVPTEN25,CeGameVPTen25),
  // vp jb
  EV_COMMAND(CM_GAMEVPJACK1,CmGameVPJack1),
  EV_COMMAND_ENABLE(CM_GAMEVPJACK1,CeGameVPJack1),
  EV_COMMAND(CM_GAMEVPJACK5,CmGameVPJack5),
  EV_COMMAND_ENABLE(CM_GAMEVPJACK5,CeGameVPJack5),
  EV_COMMAND(CM_GAMEVPJACK100,CmGameVPJack100),
  EV_COMMAND_ENABLE(CM_GAMEVPJACK100,CeGameVPJack100),
  EV_COMMAND(CM_GAMEVPJACK25,CmGameVPJack25),
  EV_COMMAND_ENABLE(CM_GAMEVPJACK25,CeGameVPJack25),
  EV_COMMAND(CM_GAMEVPJACK1P,CmGameVPJack1P),
  EV_COMMAND_ENABLE(CM_GAMEVPJACK1P,CeGameVPJack1P),
  // vp dw
  EV_COMMAND(CM_GAMEVPDWILD1,CmGameVPDWild1),
  EV_COMMAND_ENABLE(CM_GAMEVPDWILD1,CeGameVPDWild1),
  EV_COMMAND(CM_GAMEVPDWILD5,CmGameVPDWild5),
  EV_COMMAND_ENABLE(CM_GAMEVPDWILD5,CeGameVPDWild5),
  EV_COMMAND(CM_GAMEVPDWILD100,CmGameVPDWild100),
  EV_COMMAND_ENABLE(CM_GAMEVPDWILD100,CeGameVPDWild100),
  EV_COMMAND(CM_GAMEVPDWILD25,CmGameVPDWild25),
  EV_COMMAND_ENABLE(CM_GAMEVPDWILD25,CeGameVPDWild25),
  // vp jw
  EV_COMMAND(CM_GAMEVPJWILD1,CmGameVPJWild1),
  EV_COMMAND_ENABLE(CM_GAMEVPJWILD1,CeGameVPJWild1),
  EV_COMMAND(CM_GAMEVPJWILD5,CmGameVPJWild5),
  EV_COMMAND_ENABLE(CM_GAMEVPJWILD5,CeGameVPJWild5),
  EV_COMMAND(CM_GAMEVPJWILD25,CmGameVPJWild25),
  EV_COMMAND_ENABLE(CM_GAMEVPJWILD25,CeGameVPJWild25),
  EV_COMMAND(CM_GAMEVPJWILD100,CmGameVPJWild100),
  EV_COMMAND_ENABLE(CM_GAMEVPJWILD100,CeGameVPJWild100),

  EV_COMMAND(CM_GAMESLOTSALADDIN500,CmGameSlotsAladdin500),
  EV_COMMAND_ENABLE(CM_GAMESLOTSALADDIN500,CeGameSlotsAladdin500),

  EV_COMMAND(CM_GAMESLOTSPARADISE25,CmGameSlotsParadise25),
  EV_COMMAND_ENABLE(CM_GAMESLOTSPARADISE25,CeGameSlotsParadise25),
  EV_COMMAND(CM_GAMESLOTSPARADISE50,CmGameSlotsParadise50),
  EV_COMMAND_ENABLE(CM_GAMESLOTSPARADISE50,CeGameSlotsParadise50),
  EV_COMMAND(CM_GAMESLOTSPARADISE100,CmGameSlotsParadise100),
  EV_COMMAND_ENABLE(CM_GAMESLOTSPARADISE100,CeGameSlotsParadise100),

  EV_COMMAND(CM_GAMESLOTSPIRATE1,CmGameSlotsPirate1),
  EV_COMMAND_ENABLE(CM_GAMESLOTSPIRATE1,CeGameSlotsPirate1),
  EV_COMMAND(CM_GAMESLOTSPIRATE2,CmGameSlotsPirate2),
  EV_COMMAND_ENABLE(CM_GAMESLOTSPIRATE2,CeGameSlotsPirate2),
  EV_COMMAND(CM_GAMESLOTSPIRATE5,CmGameSlotsPirate5),
  EV_COMMAND_ENABLE(CM_GAMESLOTSPIRATE5,CeGameSlotsPirate5),
  EV_COMMAND(CM_GAMESLOTSPIRATE10,CmGameSlotsPirate10),
  EV_COMMAND_ENABLE(CM_GAMESLOTSPIRATE10,CeGameSlotsPirate10),
  EV_COMMAND(CM_GAMESLOTSPIRATE25,CmGameSlotsPirate25),
  EV_COMMAND_ENABLE(CM_GAMESLOTSPIRATE25,CeGameSlotsPirate25),
  EV_COMMAND(CM_GAMESLOTSPIRATE50,CmGameSlotsPirate50),
  EV_COMMAND_ENABLE(CM_GAMESLOTSPIRATE50,CeGameSlotsPirate50),
  EV_COMMAND(CM_GAMESLOTSPIRATE100,CmGameSlotsPirate100),
  EV_COMMAND_ENABLE(CM_GAMESLOTSPIRATE100,CeGameSlotsPirate100),

  EV_COMMAND(CM_GAMESLOTSLUCKY1,CmGameSlotsLucky1),
  EV_COMMAND_ENABLE(CM_GAMESLOTSLUCKY1,CeGameSlotsLucky1),
  EV_COMMAND(CM_GAMESLOTSLUCKY2,CmGameSlotsLucky2),
  EV_COMMAND_ENABLE(CM_GAMESLOTSLUCKY2,CeGameSlotsLucky2),
  EV_COMMAND(CM_GAMESLOTSLUCKY5,CmGameSlotsLucky5),
  EV_COMMAND_ENABLE(CM_GAMESLOTSLUCKY5,CeGameSlotsLucky5),
  EV_COMMAND(CM_GAMESLOTSLUCKY10,CmGameSlotsLucky10),
  EV_COMMAND_ENABLE(CM_GAMESLOTSLUCKY10,CeGameSlotsLucky10),
  EV_COMMAND(CM_GAMESLOTSLUCKY25,CmGameSlotsLucky25),
  EV_COMMAND_ENABLE(CM_GAMESLOTSLUCKY25,CeGameSlotsLucky25),
  EV_COMMAND(CM_GAMESLOTSLUCKY50,CmGameSlotsLucky50),
  EV_COMMAND_ENABLE(CM_GAMESLOTSLUCKY50,CeGameSlotsLucky50),

  EV_COMMAND(CM_GAMESLOTSJOKERS10,CmGameSlotsJokers10),
  EV_COMMAND_ENABLE(CM_GAMESLOTSJOKERS10,CeGameSlotsJokers10),
  EV_COMMAND(CM_GAMESLOTSJOKERS50,CmGameSlotsJokers50),
  EV_COMMAND_ENABLE(CM_GAMESLOTSJOKERS50,CeGameSlotsJokers50),
  EV_COMMAND(CM_GAMESLOTSJOKERS100,CmGameSlotsJokers100),
  EV_COMMAND_ENABLE(CM_GAMESLOTSJOKERS100,CeGameSlotsJokers100),

  EV_COMMAND(CM_GAMESLOTSTOTAL1,CmGameSlotsTotal1),
  EV_COMMAND_ENABLE(CM_GAMESLOTSTOTAL1,CeGameSlotsTotal1),
  EV_COMMAND(CM_GAMESLOTSTOTAL2,CmGameSlotsTotal2),
  EV_COMMAND_ENABLE(CM_GAMESLOTSTOTAL2,CeGameSlotsTotal2),
  EV_COMMAND(CM_GAMESLOTSTOTAL5,CmGameSlotsTotal5),
  EV_COMMAND_ENABLE(CM_GAMESLOTSTOTAL5,CeGameSlotsTotal5),
  EV_COMMAND(CM_GAMESLOTSTOTAL10,CmGameSlotsTotal10),
  EV_COMMAND_ENABLE(CM_GAMESLOTSTOTAL10,CeGameSlotsTotal10),
  EV_COMMAND(CM_GAMESLOTSTOTAL500,CmGameSlotsTotal500),
  EV_COMMAND_ENABLE(CM_GAMESLOTSTOTAL500,CeGameSlotsTotal500),
  EV_COMMAND(CM_GAMESLOTSTOTAL1000,CmGameSlotsTotal1000),
  EV_COMMAND_ENABLE(CM_GAMESLOTSTOTAL1000,CeGameSlotsTotal1000),

  EV_COMMAND(CM_GAMESLOTSCHERRY10,CmGameSlotsCherry10),
  EV_COMMAND_ENABLE(CM_GAMESLOTSCHERRY10,CeGameSlotsCherry10),
  EV_COMMAND(CM_GAMESLOTSCHERRY25,CmGameSlotsCherry25),
  EV_COMMAND_ENABLE(CM_GAMESLOTSCHERRY25,CeGameSlotsCherry25),
  EV_COMMAND(CM_GAMESLOTSCHERRY50,CmGameSlotsCherry50),
  EV_COMMAND_ENABLE(CM_GAMESLOTSCHERRY50,CeGameSlotsCherry50),

  EV_COMMAND(CM_GAMESLOTSJUNGLE100,CmGameSlotsJungle100),
  EV_COMMAND_ENABLE(CM_GAMESLOTSJUNGLE100,CeGameSlotsJungle100),

  EV_COMMAND(CM_GAMESLOTSALADDIN1P,CmGameSlotsAladdin1P),
  EV_COMMAND_ENABLE(CM_GAMESLOTSALADDIN1P,CeGameSlotsAladdin1P),
  EV_COMMAND(CM_GAMESLOTSALADDIN100,CmGameSlotsAladdin100),
  EV_COMMAND_ENABLE(CM_GAMESLOTSALADDIN100,CeGameSlotsAladdin100),

  EV_COMMAND(CM_GAMESLOTSSPIRIT1000,CmGameSlotsSpirit1000),
  EV_COMMAND_ENABLE(CM_GAMESLOTSSPIRIT1000,CeGameSlotsSpirit1000),

  EV_COMMAND(CM_GAMESLOTSJOKERS5,CmGameSlotsJokers5),
  EV_COMMAND_ENABLE(CM_GAMESLOTSJOKERS5,CeGameSlotsJokers5),

  EV_COMMAND(CM_GAMESLOTSJOKERS25,CmGameSlotsJokers25),
  EV_COMMAND_ENABLE(CM_GAMESLOTSJOKERS25,CeGameSlotsJokers25),

  EV_COMMAND(CM_GAMESLOTSCHERRY1,CmGameSlotsCherry1),
  EV_COMMAND_ENABLE(CM_GAMESLOTSCHERRY1,CeGameSlotsCherry1),
  EV_COMMAND(CM_GAMESLOTSCHERRY2,CmGameSlotsCherry2),
  EV_COMMAND_ENABLE(CM_GAMESLOTSCHERRY2,CeGameSlotsCherry2),
  EV_COMMAND(CM_GAMESLOTSCHERRY5,CmGameSlotsCherry5),
  EV_COMMAND_ENABLE(CM_GAMESLOTSCHERRY5,CeGameSlotsCherry5),

  EV_COMMAND(CM_GAMESLOTSJUNGLE1,CmGameSlotsJungle1),
  EV_COMMAND_ENABLE(CM_GAMESLOTSJUNGLE1,CeGameSlotsJungle1),
  EV_COMMAND(CM_GAMESLOTSJUNGLE2,CmGameSlotsJungle2),
  EV_COMMAND_ENABLE(CM_GAMESLOTSJUNGLE2,CeGameSlotsJungle2),

  EV_COMMAND(CM_DEMOESC,CmDemoEsc),
END_RESPONSE_TABLE;
//*******************************************************************
TDACCGameFrameWindow::TDACCGameFrameWindow(TDACCApp *pdaccapp,const char *szTitle)
:TCasinoGameFrameWindow(pdaccapp,szTitle,true,false)
{
  FadeIn = FALSE;
  DoStyle();
  DoIcon();
  DoMenu();
  Attr.AccelTable = TResId(ID_ACCEL_DACC);
//  BJNumDecks = cbj1Deck;
  StartupModeIndex = GetPGame()->GetModeIndex(GetPGame()->GetResString(IDS_M_LOBBY));
}
//*******************************************************************
TDACCGameFrameWindow::~TDACCGameFrameWindow()
{
}
//*******************************************************************
void TDACCGameFrameWindow::CreateMenuEnable()
{
  PMenuEnable = new TDACCMenuEnable(TRUE);
}
//*******************************************************************
int TDACCGameFrameWindow::GetMenuID()
{
  return IDM_CASINO_DEF;
}
//*******************************************************************
int TDACCGameFrameWindow::GetAboutID()
{
  return IDB_DACC_ABOUT_V1_2;
}
//*******************************************************************
void TDACCGameFrameWindow::DoMenu()
{
  AssignMenu(IDM_CASINO_DEF);
}
//*******************************************************************
void TDACCGameFrameWindow::CmDemoEsc()
{
  if (GetDACCMenuEnable()->CurrentMode == IDS_M_LOBBY)
  {
    CmExit();
  }
  else
  {
    SwitchGameModes(GetModeIndex(TAppString(IDS_M_LOBBY)));
  }
}
//*******************************************************************
void TDACCGameFrameWindow::CreatePlayerMgr()
{
  PlayerMgr = new TCasinoPlayerMgr(this,GetDriveDir(),true);
}
//*******************************************************************
void TDACCGameFrameWindow::SwitchGameModes(int modeindex)
{
  if (!IsValidModeIndex(modeindex))
  {
	 MessageBox("Internal error, no switch attempted","Switch Mode",MB_OK);
  }
  else
  {
	 if (!SwitchModes(modeindex))
	 {
		MessageBox("Internal error, switching to startup mode","Switch Mode",MB_OK);
		SwitchModes(GetModeIndex(GetPGame()->GetResString(IDS_M_LOBBY)));
	 }
  }
}
//*******************************************************************
void TDACCGameFrameWindow::CmGameLobby()
{
  SwitchGameModes(GetPGame()->GetResString(IDS_M_LOBBY));
}
//*******************************************************************
void TDACCGameFrameWindow::CeGameLobby(TCommandEnabler &enabler)
{
  enabler.Enable(GetDACCMenuEnable()->Lobby);
  if (GetDACCMenuEnable()->CurrentMode == IDS_M_LOBBY)
  {
    enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
    enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TDACCGameFrameWindow::CmGameBlackJackOne()
{
//  SwitchBJ(cbj1Deck);
  SwitchGameModes(TAppString(IDS_M_BJ1));
}
//*******************************************************************
void TDACCGameFrameWindow::CeGameBlackJackOne(TCommandEnabler &enabler)
{
  enabler.Enable(GetDACCMenuEnable()->BlackJackOne);
  if (GetDACCMenuEnable()->CurrentMode == IDS_M_BJ1)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TDACCGameFrameWindow::CmGameBlackJackTwo()
{
//  SwitchBJ(cbj2Deck);
  SwitchGameModes(TAppString(IDS_M_BJ1));
}
//*******************************************************************
void TDACCGameFrameWindow::CeGameBlackJackTwo(TCommandEnabler &enabler)
{
  enabler.Enable(GetDACCMenuEnable()->BlackJackTwo);
//  if (GetDACCMenuEnable()->CurrentMode == IDS_M_BJ1 && BJNumDecks == cbj2Deck)
//  {
//	 enabler.SetCheck(TCommandEnabler::Checked);
//  }
//  else
//  {
//	 enabler.SetCheck(TCommandEnabler::Unchecked);
//  }
}
//*******************************************************************
void TDACCGameFrameWindow::CmGameBlackJackFour()
{
//  SwitchBJ(cbj4Deck);
  SwitchGameModes(TAppString(IDS_M_BJ1));
}
//*******************************************************************
void TDACCGameFrameWindow::CeGameBlackJackFour(TCommandEnabler &enabler)
{
  enabler.Enable(GetDACCMenuEnable()->BlackJackFour);
//  if (GetDACCMenuEnable()->CurrentMode == IDS_M_BJ1 && BJNumDecks == cbj4Deck)
//  {
//	 enabler.SetCheck(TCommandEnabler::Checked);
//  }
//  else
//  {
//	 enabler.SetCheck(TCommandEnabler::Unchecked);
//  }
}
//*******************************************************************
void TDACCGameFrameWindow::CmGameBlackJackSix()
{
//  SwitchBJ(cbj6Deck);
  SwitchGameModes(TAppString(IDS_M_BJ1));
}
//*******************************************************************
void TDACCGameFrameWindow::CeGameBlackJackSix(TCommandEnabler &enabler)
{
  enabler.Enable(GetDACCMenuEnable()->BlackJackSix);
//  if (GetDACCMenuEnable()->CurrentMode == IDS_M_BJ1 && BJNumDecks == cbj6Deck)
//  {
//	 enabler.SetCheck(TCommandEnabler::Checked);
//  }
//  else
//  {
//	 enabler.SetCheck(TCommandEnabler::Unchecked);
//  }
}
//*******************************************************************
void TDACCGameFrameWindow::CmGameCraps()
{
  SwitchGameModes(GetPGame()->GetResString(IDS_M_CRAPS));
}
//*******************************************************************
void TDACCGameFrameWindow::CeGameCraps(TCommandEnabler &enabler)
{
  enabler.Enable(GetDACCMenuEnable()->Craps);
  if (GetDACCMenuEnable()->CurrentMode == IDS_M_CRAPS)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TDACCGameFrameWindow::CmGameKeno()
{
  SwitchGameModes(GetPGame()->GetResString(IDS_M_KENO));
}
//*******************************************************************
void TDACCGameFrameWindow::CeGameKeno(TCommandEnabler &enabler)
{
  enabler.Enable(GetDACCMenuEnable()->Keno);
  if (GetDACCMenuEnable()->CurrentMode == IDS_M_KENO)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TDACCGameFrameWindow::CmGameRoulette()
{
  SwitchGameModes(GetPGame()->GetResString(IDS_M_ROULETTE));
}
//*******************************************************************
void TDACCGameFrameWindow::CeGameRoulette(TCommandEnabler &enabler)
{
  enabler.Enable(GetDACCMenuEnable()->Roulette);
  if (GetDACCMenuEnable()->CurrentMode == IDS_M_ROULETTE)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TDACCGameFrameWindow::CmGameSlotsAladdin1P()
{
  SwitchGameModes(GetPGame()->GetResString(IDS_M_SL_ALADDIN1P));
}
//*******************************************************************
void TDACCGameFrameWindow::CeGameSlotsAladdin1P(TCommandEnabler &enabler)
{
  enabler.Enable(GetDACCMenuEnable()->SlotsAladdin1P);
  if (GetDACCMenuEnable()->CurrentMode == IDS_M_SL_ALADDIN1P)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TDACCGameFrameWindow::CmGameSlotsAladdin100()
{
  SwitchGameModes(GetPGame()->GetResString(IDS_M_SL_ALADDIN100));
}
//*******************************************************************
void TDACCGameFrameWindow::CeGameSlotsAladdin100(TCommandEnabler &enabler)
{
  enabler.Enable(GetDACCMenuEnable()->SlotsAladdin100);
  if (GetDACCMenuEnable()->CurrentMode == IDS_M_SL_ALADDIN100)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TDACCGameFrameWindow::CmGameSlotsAladdin500()
{
  SwitchGameModes(GetPGame()->GetResString(IDS_M_SL_ALADDIN500));
}
//*******************************************************************
void TDACCGameFrameWindow::CeGameSlotsAladdin500(TCommandEnabler &enabler)
{
  enabler.Enable(GetDACCMenuEnable()->SlotsAladdin500);
  if (GetDACCMenuEnable()->CurrentMode == IDS_M_SL_ALADDIN500)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TDACCGameFrameWindow::CmGameSlotsParadise25()
{
  SwitchGameModes(GetPGame()->GetResString(IDS_M_SL_PARADISE25));
}
//*******************************************************************
void TDACCGameFrameWindow::CeGameSlotsParadise25(TCommandEnabler &enabler)
{
  enabler.Enable(GetDACCMenuEnable()->SlotsParadise25);
  if (GetDACCMenuEnable()->CurrentMode == IDS_M_SL_PARADISE25)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TDACCGameFrameWindow::CmGameSlotsParadise50()
{
  SwitchGameModes(GetPGame()->GetResString(IDS_M_SL_PARADISE50));
}
//*******************************************************************
void TDACCGameFrameWindow::CeGameSlotsParadise50(TCommandEnabler &enabler)
{
  enabler.Enable(GetDACCMenuEnable()->SlotsParadise50);
  if (GetDACCMenuEnable()->CurrentMode == IDS_M_SL_PARADISE50)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TDACCGameFrameWindow::CmGameSlotsParadise100()
{
  SwitchGameModes(GetPGame()->GetResString(IDS_M_SL_PARADISE100));
}
//*******************************************************************
void TDACCGameFrameWindow::CeGameSlotsParadise100(TCommandEnabler &enabler)
{
  enabler.Enable(GetDACCMenuEnable()->SlotsParadise100);
  if (GetDACCMenuEnable()->CurrentMode == IDS_M_SL_PARADISE100)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TDACCGameFrameWindow::CmGameSlotsPirate1()
{
  SwitchGameModes(GetPGame()->GetResString(IDS_M_SL_PIRATE1));
}
//*******************************************************************
void TDACCGameFrameWindow::CeGameSlotsPirate1(TCommandEnabler &enabler)
{
  enabler.Enable(GetDACCMenuEnable()->SlotsPirate1);
  if (GetDACCMenuEnable()->CurrentMode == IDS_M_SL_PIRATE1)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TDACCGameFrameWindow::CmGameSlotsPirate2()
{
  SwitchGameModes(GetPGame()->GetResString(IDS_M_SL_PIRATE2));
}
//*******************************************************************
void TDACCGameFrameWindow::CeGameSlotsPirate2(TCommandEnabler &enabler)
{
  enabler.Enable(GetDACCMenuEnable()->SlotsPirate2);
  if (GetDACCMenuEnable()->CurrentMode == IDS_M_SL_PIRATE2)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TDACCGameFrameWindow::CmGameSlotsPirate5()
{
  SwitchGameModes(GetPGame()->GetResString(IDS_M_SL_PIRATE5));
}
//*******************************************************************
void TDACCGameFrameWindow::CeGameSlotsPirate5(TCommandEnabler &enabler)
{
  enabler.Enable(GetDACCMenuEnable()->SlotsPirate5);
  if (GetDACCMenuEnable()->CurrentMode == IDS_M_SL_PIRATE5)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TDACCGameFrameWindow::CmGameSlotsPirate10()
{
  SwitchGameModes(GetPGame()->GetResString(IDS_M_SL_PIRATE10));
}
//*******************************************************************
void TDACCGameFrameWindow::CeGameSlotsPirate10(TCommandEnabler &enabler)
{
  enabler.Enable(GetDACCMenuEnable()->SlotsPirate10);
  if (GetDACCMenuEnable()->CurrentMode == IDS_M_SL_PIRATE10)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TDACCGameFrameWindow::CmGameSlotsPirate25()
{
  SwitchGameModes(GetPGame()->GetResString(IDS_M_SL_PIRATE25));
}
//*******************************************************************
void TDACCGameFrameWindow::CeGameSlotsPirate25(TCommandEnabler &enabler)
{
  enabler.Enable(GetDACCMenuEnable()->SlotsPirate25);
  if (GetDACCMenuEnable()->CurrentMode == IDS_M_SL_PIRATE25)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TDACCGameFrameWindow::CmGameSlotsPirate50()
{
  SwitchGameModes(GetPGame()->GetResString(IDS_M_SL_PIRATE50));
}
//*******************************************************************
void TDACCGameFrameWindow::CeGameSlotsPirate50(TCommandEnabler &enabler)
{
  enabler.Enable(GetDACCMenuEnable()->SlotsPirate50);
  if (GetDACCMenuEnable()->CurrentMode == IDS_M_SL_PIRATE50)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TDACCGameFrameWindow::CmGameSlotsPirate100()
{
  SwitchGameModes(GetPGame()->GetResString(IDS_M_SL_PIRATE100));
}
//*******************************************************************
void TDACCGameFrameWindow::CeGameSlotsPirate100(TCommandEnabler &enabler)
{
  enabler.Enable(GetDACCMenuEnable()->SlotsPirate100);
  if (GetDACCMenuEnable()->CurrentMode == IDS_M_SL_PIRATE100)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TDACCGameFrameWindow::CmGameSlotsLucky1()
{
  SwitchGameModes(GetPGame()->GetResString(IDS_M_SL_LUCKY1));
}
//*******************************************************************
void TDACCGameFrameWindow::CeGameSlotsLucky1(TCommandEnabler &enabler)
{
  enabler.Enable(GetDACCMenuEnable()->SlotsLucky1);
  if (GetDACCMenuEnable()->CurrentMode == IDS_M_SL_LUCKY1)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TDACCGameFrameWindow::CmGameSlotsLucky2()
{
  SwitchGameModes(GetPGame()->GetResString(IDS_M_SL_LUCKY2));
}
//*******************************************************************
void TDACCGameFrameWindow::CeGameSlotsLucky2(TCommandEnabler &enabler)
{
  enabler.Enable(GetDACCMenuEnable()->SlotsLucky2);
  if (GetDACCMenuEnable()->CurrentMode == IDS_M_SL_LUCKY2)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TDACCGameFrameWindow::CmGameSlotsLucky5()
{
  SwitchGameModes(GetPGame()->GetResString(IDS_M_SL_LUCKY5));
}
//*******************************************************************
void TDACCGameFrameWindow::CeGameSlotsLucky5(TCommandEnabler &enabler)
{
  enabler.Enable(GetDACCMenuEnable()->SlotsLucky5);
  if (GetDACCMenuEnable()->CurrentMode == IDS_M_SL_LUCKY5)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TDACCGameFrameWindow::CmGameSlotsLucky10()
{
  SwitchGameModes(GetPGame()->GetResString(IDS_M_SL_LUCKY10));
}
//*******************************************************************
void TDACCGameFrameWindow::CeGameSlotsLucky10(TCommandEnabler &enabler)
{
  enabler.Enable(GetDACCMenuEnable()->SlotsLucky10);
  if (GetDACCMenuEnable()->CurrentMode == IDS_M_SL_LUCKY10)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TDACCGameFrameWindow::CmGameSlotsLucky25()
{
  SwitchGameModes(GetPGame()->GetResString(IDS_M_SL_LUCKY25));
}
//*******************************************************************
void TDACCGameFrameWindow::CeGameSlotsLucky25(TCommandEnabler &enabler)
{
  enabler.Enable(GetDACCMenuEnable()->SlotsLucky25);
  if (GetDACCMenuEnable()->CurrentMode == IDS_M_SL_LUCKY25)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TDACCGameFrameWindow::CmGameSlotsLucky50()
{
  SwitchGameModes(GetPGame()->GetResString(IDS_M_SL_LUCKY50));
}
//*******************************************************************
void TDACCGameFrameWindow::CeGameSlotsLucky50(TCommandEnabler &enabler)
{
  enabler.Enable(GetDACCMenuEnable()->SlotsLucky50);
  if (GetDACCMenuEnable()->CurrentMode == IDS_M_SL_LUCKY50)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TDACCGameFrameWindow::CmGameSlotsSpirit1000()
{
  SwitchGameModes(GetPGame()->GetResString(IDS_M_SL_SPIRIT1000));
}
//*******************************************************************
void TDACCGameFrameWindow::CeGameSlotsSpirit1000(TCommandEnabler &enabler)
{
  enabler.Enable(GetDACCMenuEnable()->SlotsSpirit1000);
  if (GetDACCMenuEnable()->CurrentMode == IDS_M_SL_SPIRIT1000)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TDACCGameFrameWindow::CmGameSlotsJokers5()
{
  SwitchGameModes(GetPGame()->GetResString(IDS_M_SL_JOKER5));
}
//*******************************************************************
void TDACCGameFrameWindow::CeGameSlotsJokers5(TCommandEnabler &enabler)
{
  enabler.Enable(GetDACCMenuEnable()->SlotsJokers5);
  if (GetDACCMenuEnable()->CurrentMode == IDS_M_SL_JOKER5)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TDACCGameFrameWindow::CmGameSlotsJokers10()
{
  SwitchGameModes(GetPGame()->GetResString(IDS_M_SL_JOKER10));
}
//*******************************************************************
void TDACCGameFrameWindow::CeGameSlotsJokers10(TCommandEnabler &enabler)
{
  enabler.Enable(GetDACCMenuEnable()->SlotsJokers10);
  if (GetDACCMenuEnable()->CurrentMode == IDS_M_SL_JOKER10)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TDACCGameFrameWindow::CmGameSlotsJokers25()
{
  SwitchGameModes(GetPGame()->GetResString(IDS_M_SL_JOKER25));
}
//*******************************************************************
void TDACCGameFrameWindow::CeGameSlotsJokers25(TCommandEnabler &enabler)
{
  enabler.Enable(GetDACCMenuEnable()->SlotsJokers25);
  if (GetDACCMenuEnable()->CurrentMode == IDS_M_SL_JOKER25)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TDACCGameFrameWindow::CmGameSlotsJokers50()
{
  SwitchGameModes(GetPGame()->GetResString(IDS_M_SL_JOKER50));
}
//*******************************************************************
void TDACCGameFrameWindow::CeGameSlotsJokers50(TCommandEnabler &enabler)
{
  enabler.Enable(GetDACCMenuEnable()->SlotsJokers50);
  if (GetDACCMenuEnable()->CurrentMode == IDS_M_SL_JOKER50)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TDACCGameFrameWindow::CmGameSlotsJokers100()
{
  SwitchGameModes(GetPGame()->GetResString(IDS_M_SL_JOKER100));
}
//*******************************************************************
void TDACCGameFrameWindow::CeGameSlotsJokers100(TCommandEnabler &enabler)
{
  enabler.Enable(GetDACCMenuEnable()->SlotsJokers100);
  if (GetDACCMenuEnable()->CurrentMode == IDS_M_SL_JOKER100)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TDACCGameFrameWindow::CmGameSlotsTotal1()
{
  SwitchGameModes(GetPGame()->GetResString(IDS_M_SL_TOTAL1));
}
//*******************************************************************
void TDACCGameFrameWindow::CeGameSlotsTotal1(TCommandEnabler &enabler)
{
  enabler.Enable(GetDACCMenuEnable()->SlotsTotal1);
  if (GetDACCMenuEnable()->CurrentMode == IDS_M_SL_TOTAL1)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TDACCGameFrameWindow::CmGameSlotsTotal2()
{
  SwitchGameModes(GetPGame()->GetResString(IDS_M_SL_TOTAL2));
}
//*******************************************************************
void TDACCGameFrameWindow::CeGameSlotsTotal2(TCommandEnabler &enabler)
{
  enabler.Enable(GetDACCMenuEnable()->SlotsTotal2);
  if (GetDACCMenuEnable()->CurrentMode == IDS_M_SL_TOTAL2)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TDACCGameFrameWindow::CmGameSlotsTotal5()
{
  SwitchGameModes(GetPGame()->GetResString(IDS_M_SL_TOTAL5));
}
//*******************************************************************
void TDACCGameFrameWindow::CeGameSlotsTotal5(TCommandEnabler &enabler)
{
  enabler.Enable(GetDACCMenuEnable()->SlotsTotal5);
  if (GetDACCMenuEnable()->CurrentMode == IDS_M_SL_TOTAL5)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TDACCGameFrameWindow::CmGameSlotsTotal10()
{
  SwitchGameModes(GetPGame()->GetResString(IDS_M_SL_TOTAL10));
}
//*******************************************************************
void TDACCGameFrameWindow::CeGameSlotsTotal10(TCommandEnabler &enabler)
{
  enabler.Enable(GetDACCMenuEnable()->SlotsTotal10);
  if (GetDACCMenuEnable()->CurrentMode == IDS_M_SL_TOTAL10)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TDACCGameFrameWindow::CmGameSlotsTotal500()
{
  SwitchGameModes(GetPGame()->GetResString(IDS_M_SL_TOTAL500));
}
//*******************************************************************
void TDACCGameFrameWindow::CeGameSlotsTotal500(TCommandEnabler &enabler)
{
  enabler.Enable(GetDACCMenuEnable()->SlotsTotal500);
  if (GetDACCMenuEnable()->CurrentMode == IDS_M_SL_TOTAL500)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TDACCGameFrameWindow::CmGameSlotsTotal1000()
{
  SwitchGameModes(GetPGame()->GetResString(IDS_M_SL_TOTAL1000));
}
//*******************************************************************
void TDACCGameFrameWindow::CeGameSlotsTotal1000(TCommandEnabler &enabler)
{
  enabler.Enable(GetDACCMenuEnable()->SlotsTotal1000);
  if (GetDACCMenuEnable()->CurrentMode == IDS_M_SL_TOTAL1000)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TDACCGameFrameWindow::CmGameSlotsCherry1()
{
  SwitchGameModes(GetPGame()->GetResString(IDS_M_SL_CHERRY1));
}
//*******************************************************************
void TDACCGameFrameWindow::CeGameSlotsCherry1(TCommandEnabler &enabler)
{
  enabler.Enable(GetDACCMenuEnable()->SlotsCherry1);
  if (GetDACCMenuEnable()->CurrentMode == IDS_M_SL_CHERRY1)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TDACCGameFrameWindow::CmGameSlotsCherry2()
{
  SwitchGameModes(GetPGame()->GetResString(IDS_M_SL_CHERRY2));
}
//*******************************************************************
void TDACCGameFrameWindow::CeGameSlotsCherry2(TCommandEnabler &enabler)
{
  enabler.Enable(GetDACCMenuEnable()->SlotsCherry2);
  if (GetDACCMenuEnable()->CurrentMode == IDS_M_SL_CHERRY2)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TDACCGameFrameWindow::CmGameSlotsCherry5()
{
  SwitchGameModes(GetPGame()->GetResString(IDS_M_SL_CHERRY5));
}
//*******************************************************************
void TDACCGameFrameWindow::CeGameSlotsCherry5(TCommandEnabler &enabler)
{
  enabler.Enable(GetDACCMenuEnable()->SlotsCherry5);
  if (GetDACCMenuEnable()->CurrentMode == IDS_M_SL_CHERRY5)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TDACCGameFrameWindow::CmGameSlotsCherry10()
{
  SwitchGameModes(GetPGame()->GetResString(IDS_M_SL_CHERRY10));
}
//*******************************************************************
void TDACCGameFrameWindow::CeGameSlotsCherry10(TCommandEnabler &enabler)
{
  enabler.Enable(GetDACCMenuEnable()->SlotsCherry10);
  if (GetDACCMenuEnable()->CurrentMode == IDS_M_SL_CHERRY10)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TDACCGameFrameWindow::CmGameSlotsCherry25()
{
  SwitchGameModes(GetPGame()->GetResString(IDS_M_SL_CHERRY25));
}
//*******************************************************************
void TDACCGameFrameWindow::CeGameSlotsCherry25(TCommandEnabler &enabler)
{
  enabler.Enable(GetDACCMenuEnable()->SlotsCherry25);
  if (GetDACCMenuEnable()->CurrentMode == IDS_M_SL_CHERRY25)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TDACCGameFrameWindow::CmGameSlotsCherry50()
{
  SwitchGameModes(GetPGame()->GetResString(IDS_M_SL_CHERRY50));
}
//*******************************************************************
void TDACCGameFrameWindow::CeGameSlotsCherry50(TCommandEnabler &enabler)
{
  enabler.Enable(GetDACCMenuEnable()->SlotsCherry50);
  if (GetDACCMenuEnable()->CurrentMode == IDS_M_SL_CHERRY50)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TDACCGameFrameWindow::CmGameSlotsJungle1()
{
  SwitchGameModes(GetPGame()->GetResString(IDS_M_SL_JUNGLE1));
}
//*******************************************************************
void TDACCGameFrameWindow::CeGameSlotsJungle1(TCommandEnabler &enabler)
{
  enabler.Enable(GetDACCMenuEnable()->SlotsJungle1);
  if (GetDACCMenuEnable()->CurrentMode == IDS_M_SL_JUNGLE1)
  {
    enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
    enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TDACCGameFrameWindow::CmGameSlotsJungle2()
{
  SwitchGameModes(GetPGame()->GetResString(IDS_M_SL_JUNGLE2));
}
//*******************************************************************
void TDACCGameFrameWindow::CeGameSlotsJungle2(TCommandEnabler &enabler)
{
  enabler.Enable(GetDACCMenuEnable()->SlotsJungle2);
  if (GetDACCMenuEnable()->CurrentMode == IDS_M_SL_JUNGLE2)
  {
    enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
    enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TDACCGameFrameWindow::CmGameSlotsJungle100()
{
  SwitchGameModes(GetPGame()->GetResString(IDS_M_SL_JUNGLE100));
}
//*******************************************************************
void TDACCGameFrameWindow::CeGameSlotsJungle100(TCommandEnabler &enabler)
{
  enabler.Enable(GetDACCMenuEnable()->SlotsJungle100);
  if (GetDACCMenuEnable()->CurrentMode == IDS_M_SL_JUNGLE100)
  {
    enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
    enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TDACCGameFrameWindow::CmGameVPTen1()
{
  SwitchGameModes(GetPGame()->GetResString(IDS_M_VP_TB1));
}
//*******************************************************************
void TDACCGameFrameWindow::CeGameVPTen1(TCommandEnabler &enabler)
{
  enabler.Enable(GetDACCMenuEnable()->VPTen1);
  if (GetDACCMenuEnable()->CurrentMode == IDS_M_VP_TB1)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TDACCGameFrameWindow::CmGameVPTen5()
{
  SwitchGameModes(GetPGame()->GetResString(IDS_M_VP_TB5));
}
//*******************************************************************
void TDACCGameFrameWindow::CeGameVPTen5(TCommandEnabler &enabler)
{
  enabler.Enable(GetDACCMenuEnable()->VPTen5);
  if (GetDACCMenuEnable()->CurrentMode == IDS_M_VP_TB5)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TDACCGameFrameWindow::CmGameVPTen100()
{
  SwitchGameModes(GetPGame()->GetResString(IDS_M_VP_TB100));
}
//*******************************************************************
void TDACCGameFrameWindow::CeGameVPTen100(TCommandEnabler &enabler)
{
  enabler.Enable(GetDACCMenuEnable()->VPTen100);
  if (GetDACCMenuEnable()->CurrentMode == IDS_M_VP_TB100)
  {
    enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
    enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TDACCGameFrameWindow::CmGameVPTen25()
{
  SwitchGameModes(GetPGame()->GetResString(IDS_M_VP_TB25));
}
//*******************************************************************
void TDACCGameFrameWindow::CeGameVPTen25(TCommandEnabler &enabler)
{
  enabler.Enable(GetDACCMenuEnable()->VPTen25);
  if (GetDACCMenuEnable()->CurrentMode == IDS_M_VP_TB25)
  {
    enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
    enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TDACCGameFrameWindow::CmGameVPJack1()
{
  SwitchGameModes(GetPGame()->GetResString(IDS_M_VP_JB1));
}
//*******************************************************************
void TDACCGameFrameWindow::CeGameVPJack1(TCommandEnabler &enabler)
{
  enabler.Enable(GetDACCMenuEnable()->VPJack1);
  if (GetDACCMenuEnable()->CurrentMode == IDS_M_VP_JB1)
  {
    enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
    enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TDACCGameFrameWindow::CmGameVPJack5()
{
  SwitchGameModes(GetPGame()->GetResString(IDS_M_VP_JB5));
}
//*******************************************************************
void TDACCGameFrameWindow::CeGameVPJack5(TCommandEnabler &enabler)
{
  enabler.Enable(GetDACCMenuEnable()->VPJack5);
  if (GetDACCMenuEnable()->CurrentMode == IDS_M_VP_JB5)
  {
    enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
    enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TDACCGameFrameWindow::CmGameVPJack100()
{
  SwitchGameModes(GetPGame()->GetResString(IDS_M_VP_JB100));
}
//*******************************************************************
void TDACCGameFrameWindow::CeGameVPJack100(TCommandEnabler &enabler)
{
  enabler.Enable(GetDACCMenuEnable()->VPJack100);
  if (GetDACCMenuEnable()->CurrentMode == IDS_M_VP_JB100)
  {
    enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
    enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TDACCGameFrameWindow::CmGameVPJack25()
{
  SwitchGameModes(GetPGame()->GetResString(IDS_M_VP_JB25));
}
//*******************************************************************
void TDACCGameFrameWindow::CeGameVPJack25(TCommandEnabler &enabler)
{
  enabler.Enable(GetDACCMenuEnable()->VPJack25);
  if (GetDACCMenuEnable()->CurrentMode == IDS_M_VP_JB25)
  {
    enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
    enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TDACCGameFrameWindow::CmGameVPJack1P()
{
  SwitchGameModes(GetPGame()->GetResString(IDS_M_VP_JB1P));
}
//*******************************************************************
void TDACCGameFrameWindow::CeGameVPJack1P(TCommandEnabler &enabler)
{
  enabler.Enable(GetDACCMenuEnable()->VPJack1P);
  if (GetDACCMenuEnable()->CurrentMode == IDS_M_VP_JB1P)
  {
    enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
    enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TDACCGameFrameWindow::CmGameVPDWild1()
{
  SwitchGameModes(GetPGame()->GetResString(IDS_M_VP_DW1));
}
//*******************************************************************
void TDACCGameFrameWindow::CeGameVPDWild1(TCommandEnabler &enabler)
{
  enabler.Enable(GetDACCMenuEnable()->VPDWild1);
  if (GetDACCMenuEnable()->CurrentMode == IDS_M_VP_DW1)
  {
    enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
    enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TDACCGameFrameWindow::CmGameVPDWild5()
{
  SwitchGameModes(GetPGame()->GetResString(IDS_M_VP_DW5));
}
//*******************************************************************
void TDACCGameFrameWindow::CeGameVPDWild5(TCommandEnabler &enabler)
{
  enabler.Enable(GetDACCMenuEnable()->VPDWild5);
  if (GetDACCMenuEnable()->CurrentMode == IDS_M_VP_DW5)
  {
    enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
    enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TDACCGameFrameWindow::CmGameVPDWild100()
{
  SwitchGameModes(GetPGame()->GetResString(IDS_M_VP_DW100));
}
//*******************************************************************
void TDACCGameFrameWindow::CeGameVPDWild100(TCommandEnabler &enabler)
{
  enabler.Enable(GetDACCMenuEnable()->VPDWild100);
  if (GetDACCMenuEnable()->CurrentMode == IDS_M_VP_DW100)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
    enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TDACCGameFrameWindow::CmGameVPDWild25()
{
  SwitchGameModes(GetPGame()->GetResString(IDS_M_VP_DW25));
}
//*******************************************************************
void TDACCGameFrameWindow::CeGameVPDWild25(TCommandEnabler &enabler)
{
  enabler.Enable(GetDACCMenuEnable()->VPDWild25);
  if (GetDACCMenuEnable()->CurrentMode == IDS_M_VP_DW25)
  {
    enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
    enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TDACCGameFrameWindow::CmGameVPJWild1()
{
  SwitchGameModes(GetPGame()->GetResString(IDS_M_VP_JW1));
}
//*******************************************************************
void TDACCGameFrameWindow::CeGameVPJWild1(TCommandEnabler &enabler)
{
  enabler.Enable(GetDACCMenuEnable()->VPJWild1);
  if (GetDACCMenuEnable()->CurrentMode == IDS_M_VP_JW1)
  {
    enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
    enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TDACCGameFrameWindow::CmGameVPJWild5()
{
  SwitchGameModes(GetPGame()->GetResString(IDS_M_VP_JW5));
}
//*******************************************************************
void TDACCGameFrameWindow::CeGameVPJWild5(TCommandEnabler &enabler)
{
  enabler.Enable(GetDACCMenuEnable()->VPJWild5);
  if (GetDACCMenuEnable()->CurrentMode == IDS_M_VP_JW5)
  {
    enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TDACCGameFrameWindow::CmGameVPJWild25()
{
  SwitchGameModes(GetPGame()->GetResString(IDS_M_VP_JW25));
}
//*******************************************************************
void TDACCGameFrameWindow::CeGameVPJWild25(TCommandEnabler &enabler)
{
  enabler.Enable(GetDACCMenuEnable()->VPJWild25);
  if (GetDACCMenuEnable()->CurrentMode == IDS_M_VP_JW25)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TDACCGameFrameWindow::CmGameVPJWild100()
{
  SwitchGameModes(GetPGame()->GetResString(IDS_M_VP_JW100));
}
//*******************************************************************
void TDACCGameFrameWindow::CeGameVPJWild100(TCommandEnabler &enabler)
{
  enabler.Enable(GetDACCMenuEnable()->VPJWild100);
  if (GetDACCMenuEnable()->CurrentMode == IDS_M_VP_JW100)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
