//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  daccgfw2.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.2     4/17/97    M.Perry     modified app & fw hierarchy.
//********************************************************************
#include "daccgfw.h"
#include "cgametyp.h"

#include "dacclmw.h"
#include "daccpp1.h"
#include "daccjb1p.h"
#include "daccbj.h"
#include "dacck.h"
#include "daccc.h"
#include "daccr.h"
//*******************************************************************
TOgleModeWindow *TDACCGameFrameWindow::CreateDACCVPMode()
{
//  PModeWin = new TJB1PModeWin(TAppString(IDS_M_VP_JB1P),GetOgleApp()->PMasterPalette);
  PModeWin = new TDACCJB1PModeWin(TAppString(IDS_M_VP_JB1P),GetOgleApp()->PMasterPalette);
  GetDACCMenuEnable()->CurrentMode = IDS_M_VP_JB1P;
  GetDACCMenuEnable()->VPJack1P = FALSE;
  return PModeWin;
}
//*******************************************************************
TOgleModeWindow *TDACCGameFrameWindow::CreateDACCSlotMode()
{
//  PModeWin = new TPlunder1ModeWin(TAppString(IDS_M_SL_PIRATE1),GetOgleApp()->PMasterPalette);
  PModeWin = new TDACCPP1ModeWin(TAppString(IDS_M_SL_PIRATE1),GetOgleApp()->PMasterPalette);
  GetDACCMenuEnable()->CurrentMode = IDS_M_SL_PIRATE1;
  GetDACCMenuEnable()->SlotsPirate1 = FALSE;
  return PModeWin;
}
//*******************************************************************
TWindow *TDACCGameFrameWindow::CreateModeWindow(int ModeIndex)
{
  GetDACCMenuEnable()->SetModes(TRUE);

  if (!IsValidModeIndex(ModeIndex)) {return PModeWin;}

  string modename = GetModeName(ModeIndex);
  if (modename == GetPGame()->GetResString(IDS_M_LOBBY))
  {
//	 PModeWin = new TLobby1ModeWin(modename,GetOgleApp()->PMasterPalette,"walkabout");
    PModeWin = new TDACCLobbyModeWin(modename,GetOgleApp()->PMasterPalette,"walkabout");
	 GetDACCMenuEnable()->CurrentMode = IDS_M_LOBBY;
	 GetDACCMenuEnable()->Lobby = FALSE;
	 return PModeWin;
  }
  if (modename == GetPGame()->GetResString(IDS_M_BJ1))
  {
//    PModeWin = new TCasinoModeWin(modename,GetOgleApp()->PMasterPalette,"Black Jack Demo Mode");
//    PModeWin = new TDACCBJModeWin(modename,GetOgleApp()->PMasterPalette,"Black Jack Demo Mode");
    PModeWin = new TDACCBJModeWin("e2bjdemo",GetOgleApp()->PMasterPalette,"Black Jack Demo Mode");
    GetDACCMenuEnable()->CurrentMode = IDS_M_BJ1;
    GetDACCMenuEnable()->BlackJackOne = FALSE;
    return PModeWin;
  }
  if (modename == GetPGame()->GetResString(IDS_M_ROULETTE))
  {
//    PModeWin = new TCasinoModeWin(modename,GetOgleApp()->PMasterPalette,"Roulette Demo Mode");
//    PModeWin = new TDACCRouletteModeWin(modename,GetOgleApp()->PMasterPalette,"Roulette Demo Mode");
    PModeWin = new TDACCRouletteModeWin("g2rdemo",GetOgleApp()->PMasterPalette,"Roulette Demo Mode");
    GetDACCMenuEnable()->CurrentMode = IDS_M_ROULETTE;
    GetDACCMenuEnable()->Roulette = FALSE;
    return PModeWin;
  }
  if (modename == GetPGame()->GetResString(IDS_M_CRAPS))
  {
//    PModeWin = new TCasinoModeWin(modename,GetOgleApp()->PMasterPalette,"Craps Demo Mode");
//    PModeWin = new TDACCCrapsModeWin(modename,GetOgleApp()->PMasterPalette,"Craps Demo Mode");
    PModeWin = new TDACCCrapsModeWin("f2cdemo",GetOgleApp()->PMasterPalette,"Craps Demo Mode");
    GetDACCMenuEnable()->CurrentMode = IDS_M_CRAPS;
    GetDACCMenuEnable()->Craps = FALSE;
    return PModeWin;
  }
  if (modename == GetPGame()->GetResString(IDS_M_SL_ALADDIN1P))
  {
    return CreateDACCSlotMode();
  }
  if (modename == GetPGame()->GetResString(IDS_M_SL_ALADDIN100))
  {
    return CreateDACCSlotMode();
  }
  if (modename == GetPGame()->GetResString(IDS_M_SL_ALADDIN500))
  {
    return CreateDACCSlotMode();
  }
  if (modename == GetPGame()->GetResString(IDS_M_SL_PARADISE25))
  {
    return CreateDACCSlotMode();
  }
  if (modename == GetPGame()->GetResString(IDS_M_SL_PARADISE50))
  {
    return CreateDACCSlotMode();
  }
  if (modename == GetPGame()->GetResString(IDS_M_SL_PARADISE100))
  {
    return CreateDACCSlotMode();
  }
  if (modename == GetPGame()->GetResString(IDS_M_SL_PIRATE1))
  {
    return CreateDACCSlotMode();
  }
  if (modename == GetPGame()->GetResString(IDS_M_SL_PIRATE2))
  {
    return CreateDACCSlotMode();
  }
  if (modename == GetPGame()->GetResString(IDS_M_SL_PIRATE5))
  {
    return CreateDACCSlotMode();
  }
  if (modename == GetPGame()->GetResString(IDS_M_SL_PIRATE10))
  {
    return CreateDACCSlotMode();
  }
  if (modename == GetPGame()->GetResString(IDS_M_SL_PIRATE25))
  {
    return CreateDACCSlotMode();
  }
  if (modename == GetPGame()->GetResString(IDS_M_SL_PIRATE50))
  {
    return CreateDACCSlotMode();
  }
  if (modename == GetPGame()->GetResString(IDS_M_SL_PIRATE100))
  {
    return CreateDACCSlotMode();
  }
  if (modename == GetPGame()->GetResString(IDS_M_SL_LUCKY1))
  {
    return CreateDACCSlotMode();
  }
  if (modename == GetPGame()->GetResString(IDS_M_SL_LUCKY2))
  {
    return CreateDACCSlotMode();
  }
  if (modename == GetPGame()->GetResString(IDS_M_SL_LUCKY5))
  {
    return CreateDACCSlotMode();
  }
  if (modename == GetPGame()->GetResString(IDS_M_SL_LUCKY10))
  {
    return CreateDACCSlotMode();
  }
  if (modename == GetPGame()->GetResString(IDS_M_SL_LUCKY25))
  {
    return CreateDACCSlotMode();
  }
  if (modename == GetPGame()->GetResString(IDS_M_SL_LUCKY50))
  {
    return CreateDACCSlotMode();
  }
  if (modename == GetPGame()->GetResString(IDS_M_SL_SPIRIT1000))
  {
    return CreateDACCSlotMode();
  }
  if (modename == GetPGame()->GetResString(IDS_M_SL_JOKER5))
  {
    return CreateDACCSlotMode();
  }
  if (modename == GetPGame()->GetResString(IDS_M_SL_JOKER10))
  {
    return CreateDACCSlotMode();
  }
  if (modename == GetPGame()->GetResString(IDS_M_SL_JOKER25))
  {
    return CreateDACCSlotMode();
  }
  if (modename == GetPGame()->GetResString(IDS_M_SL_JOKER50))
  {
    return CreateDACCSlotMode();
  }
  if (modename == GetPGame()->GetResString(IDS_M_SL_JOKER100))
  {
    return CreateDACCSlotMode();
  }
  if (modename == GetPGame()->GetResString(IDS_M_SL_TOTAL1))
  {
    return CreateDACCSlotMode();
  }
  if (modename == GetPGame()->GetResString(IDS_M_SL_TOTAL2))
  {
    return CreateDACCSlotMode();
  }
  if (modename == GetPGame()->GetResString(IDS_M_SL_TOTAL5))
  {
    return CreateDACCSlotMode();
  }
  if (modename == GetPGame()->GetResString(IDS_M_SL_TOTAL10))
  {
    return CreateDACCSlotMode();
  }
  if (modename == GetPGame()->GetResString(IDS_M_SL_TOTAL500))
  {
    return CreateDACCSlotMode();
  }
  if (modename == GetPGame()->GetResString(IDS_M_SL_TOTAL1000))
  {
    return CreateDACCSlotMode();
  }
  if (modename == GetPGame()->GetResString(IDS_M_SL_CHERRY1))
  {
    return CreateDACCSlotMode();
  }
  if (modename == GetPGame()->GetResString(IDS_M_SL_CHERRY2))
  {
    return CreateDACCSlotMode();
  }
  if (modename == GetPGame()->GetResString(IDS_M_SL_CHERRY5))
  {
    return CreateDACCSlotMode();
  }
  if (modename == GetPGame()->GetResString(IDS_M_SL_CHERRY10))
  {
    return CreateDACCSlotMode();
  }
  if (modename == GetPGame()->GetResString(IDS_M_SL_CHERRY25))
  {
    return CreateDACCSlotMode();
  }
  if (modename == GetPGame()->GetResString(IDS_M_SL_CHERRY50))
  {
    return CreateDACCSlotMode();
  }
  if (modename == GetPGame()->GetResString(IDS_M_SL_JUNGLE1))
  {
    return CreateDACCSlotMode();
  }
  if (modename == GetPGame()->GetResString(IDS_M_SL_JUNGLE2))
  {
    return CreateDACCSlotMode();
  }
  if (modename == GetPGame()->GetResString(IDS_M_SL_JUNGLE100))
  {
    return CreateDACCSlotMode();
  }
  if (modename == GetPGame()->GetResString(IDS_M_KENO))
  {
//	 PModeWin = new TK1ModeWin(modename,GetOgleApp()->PMasterPalette);
//    PModeWin = new TCasinoModeWin(modename,GetOgleApp()->PMasterPalette,"Keno Demo Mode");
//    PModeWin = new TDACCKenoModeWin(modename,GetOgleApp()->PMasterPalette,"Keno Demo Mode");
    PModeWin = new TDACCKenoModeWin("h2kdemo",GetOgleApp()->PMasterPalette,"Keno Demo Mode");
	 GetDACCMenuEnable()->CurrentMode = IDS_M_KENO;
	 GetDACCMenuEnable()->Keno = FALSE;
	 return PModeWin;
  }
  if (modename == GetPGame()->GetResString(IDS_M_VP_JW1))
  {
    return CreateDACCVPMode();
  }
  if (modename == GetPGame()->GetResString(IDS_M_VP_JW5))
  {
    return CreateDACCVPMode();
  }
  if (modename == GetPGame()->GetResString(IDS_M_VP_JW25))
  {
    return CreateDACCVPMode();
  }
  if (modename == GetPGame()->GetResString(IDS_M_VP_JW100))
  {
    return CreateDACCVPMode();
  }
  if (modename == GetPGame()->GetResString(IDS_M_VP_DW1))
  {
    return CreateDACCVPMode();
  }
  if (modename == GetPGame()->GetResString(IDS_M_VP_DW5))
  {
    return CreateDACCVPMode();
  }
  if (modename == GetPGame()->GetResString(IDS_M_VP_DW25))
  {
    return CreateDACCVPMode();
  }
  if (modename == GetPGame()->GetResString(IDS_M_VP_DW100))
  {
    return CreateDACCVPMode();
  }
  if (modename == GetPGame()->GetResString(IDS_M_VP_TB1))
  {
    return CreateDACCVPMode();
  }
  if (modename == GetPGame()->GetResString(IDS_M_VP_TB5))
  {
    return CreateDACCVPMode();
  }
  if (modename == GetPGame()->GetResString(IDS_M_VP_TB25))
  {
    return CreateDACCVPMode();
  }
  if (modename == GetPGame()->GetResString(IDS_M_VP_TB100))
  {
    return CreateDACCVPMode();
  }
  if (modename == GetPGame()->GetResString(IDS_M_VP_JB1))
  {
    return CreateDACCVPMode();
  }
  if (modename == GetPGame()->GetResString(IDS_M_VP_JB5))
  {
    return CreateDACCVPMode();
  }
  if (modename == GetPGame()->GetResString(IDS_M_VP_JB100))
  {
    return CreateDACCVPMode();
  }
  if (modename == GetPGame()->GetResString(IDS_M_VP_JB25))
  {
    return CreateDACCVPMode();
  }
  if (modename == GetPGame()->GetResString(IDS_M_VP_JB1P))
  {
    return CreateDACCVPMode();
  }
  ::MessageBox(NULL,"Default Mode Window Created","Create Mode Window",MB_OK);
  PModeWin = new TCasinoModeWin(modename,GetOgleApp()->PMasterPalette,string("Default Casino ModeWin"));
  return PModeWin;
}
//*******************************************************************

