//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  hsact1st.cpp
//    Project Name:  Casino
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     06/29/95   A. Krist    Original baseline
//  2.0     09/04/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "hsact1st.h"
#include "hsglord.h"
#include "hscoutst.h"
#include "hsplay.h"
#include "hswinst.h"
#include "cashsmw.h"
#include "orespond.h"
#include "oanm.h"
#include "owav.h"
//*******************************************************************
THSAct1State::THSAct1State(TCasinoHSGameLord *pNewHSLord)
:THSLordState(pNewHSLord)
{
	 SetRunOrder(ess_Execute,ess_Execute,ess_Execute,ess_Done);
	 IgnoreCoach = false;

	 AddCoinResponder            = NULL;
	 WaitOnTray          = false;
	 DelayFUC = 0;
	 StartFUC = 0;
	 FUCLength = 0;

	 Lock      = false;
	 StopReelTime = 0;
	 WaitOnSpin = false;
	 WaitingOnWRCounter = 0;
	 pOwnerLord->winnerpaid = 0;
	 pOwnerLord->coinsplayed = 0;
	 askexpertflag = false;
	 ZeroStart = 0;
	 Advance1 = false;
	 Advance2 = false;
    Advance3 = false;
	 Is4      = false;
	 IsUp     = false;
	 WaitOnLightning = false;
	 AdvanceFUC = 0;
}
//*******************************************************************
THSAct1State::~THSAct1State()
{
}
//*******************************************************************
void THSAct1State::ExecuteFirstTime()
{
  pOwnerLord->Clear();
  ExecuteWaiting = true;
  ExecuteStatus    = ess_Execute;
}
//*******************************************************************
void THSAct1State::CreateSubState1()
{
  PActiveSubState = new THSWinState(pOwnerLord);
}
//*******************************************************************
void THSAct1State::EndSubState1()
{
  TState::EndSubState1();
  pOwnerLord->Clear();
  StopReelTime = 0;
  Lock = false;
  ExecuteWaiting = true;
}
//*******************************************************************
void THSAct1State::CreateSubState2()
{
  PActiveSubState = new THSCashOutState(pOwnerLord);
}
//*******************************************************************
void THSAct1State::EndSubState2()
{
  TState::EndSubState2();
  ExecuteWaiting = true;
  pOwnerLord->Button0->ShowGray();
  pOwnerLord->UnFreezeAllButtons();
  DelayFUC = pOwnerLord->GetAdjFUC();
  WaitOnTray = true;
}
//*******************************************************************
void THSAct1State::HandlePostUpdate(dword NewFUC)
{
  if((pOwnerLord->Travel != NULL && !(pOwnerLord->Travel->IsDone()))
	  || pOwnerLord->IsAccident || pOwnerLord->IsFlat)
  {
	 return;
  }
  if(pOwnerLord->BMNumOfCredits)
  {
	 switch(pOwnerLord->BetMaxNumOfCredits)
	 {
		case 1  : pOwnerLord->CoinsPlayed->PlaySound(0);break;
		case 2  : pOwnerLord->CoinsPlayed->PlaySound(1);break;
		case 3  : pOwnerLord->CoinsPlayed->PlaySound(2);break;
		case 4  : pOwnerLord->CoinsPlayed->PlaySound(3);break;
		case 5  : pOwnerLord->CoinsPlayed->PlaySound(4);break;
		default : pOwnerLord->CoinsPlayed->PlaySound(4);
	 }
	 pOwnerLord->BMNumOfCredits = false;
	 //AdvanceFUC = NewFUC;
	// return;
  }
  if(pOwnerLord->BMNumOfCoins)
  {
	 if(pOwnerLord->CoinsPlayed->IsWaveStopped(int16(pOwnerLord->BetMaxNumOfCredits-1)) ||
		(pOwnerLord->BetMaxNumOfCredits == 0))
	 {
		switch(pOwnerLord->BetMaxNumOfCoins)
		{
		  case 1  : pOwnerLord->CoinsPlayed->PlaySound(5);break;
		  case 2  : pOwnerLord->CoinsPlayed->PlaySound(6);break;
		  case 3  : pOwnerLord->CoinsPlayed->PlaySound(7);break;
		  case 4  : pOwnerLord->CoinsPlayed->PlaySound(8);break;
		  case 5  : pOwnerLord->CoinsPlayed->PlaySound(9);break;
		  default : pOwnerLord->CoinsPlayed->PlaySound(9);
		}
		pOwnerLord->BMNumOfCoins = false;
	  // AdvanceFUC = NewFUC;
	 }
	 //else
	 ////{
	 //	return;
	// }
  }
  if(WaitOnLightning)
  {
	 if(AdvanceFUC+2 == NewFUC)
	 {
		 int x = random(100);
		 StartFUC = NewFUC+1;
		 FUCLength = 0;
		 if(x < 48)
		 {
			pOwnerLord->ActivateSprite(pOwnerLord->Strike1,StartFUC,FUCLength);
			pOwnerLord->Multiplier = 1;
			pOwnerLord->MultiplierAnm->SetNum(0);
		 }
		 else if(x < 68)
		 {
			pOwnerLord->ActivateSprite(pOwnerLord->Strike2,StartFUC,FUCLength);
			pOwnerLord->Multiplier = 2;
			pOwnerLord->MultiplierAnm->SetNum(1);
		 }
		 else if(x < 80)
		 {
			pOwnerLord->ActivateSprite(pOwnerLord->Strike3,StartFUC,FUCLength);
			pOwnerLord->Multiplier = 3;
			pOwnerLord->MultiplierAnm->SetNum(2);
		 }
		 else if(x < 90)
		 {
			pOwnerLord->ActivateSprite(pOwnerLord->Strike4,StartFUC,FUCLength);
			pOwnerLord->Multiplier = 5;
			pOwnerLord->MultiplierAnm->SetNum(3);
		 }
		 else if(x < 96)
		 {
			pOwnerLord->ActivateSprite(pOwnerLord->Strike5,StartFUC,FUCLength);
			pOwnerLord->Multiplier = 10;
			pOwnerLord->MultiplierAnm->SetNum(4);
		 }
		 else if(x < 100)
		 {
			pOwnerLord->ActivateSprite(pOwnerLord->Strike6,StartFUC,FUCLength);
			pOwnerLord->Multiplier = 25;
			pOwnerLord->MultiplierAnm->SetNum(5);
		 }

	 }
	 if(AdvanceFUC+6 == NewFUC)
	 {
		WaitOnLightning = false;
		ZeroStart = WaitingOnWRCounter;
	 }
	 else
	 {
		return;
	 }
  }
  if(WaitOnTray)
  {
	 if(DelayFUC + 6 <= NewFUC)
	 {
		pOwnerLord->BankCashDisplay->SetNum(pOwnerLord->GetCash(pOwnerLord->activeplayer));
		pOwnerLord->CoinPay->ClearTray();
		WaitOnTray = false;
	 }
	 else{return;}
  }
  if (pOwnerLord->ButtonHit[HSidButton6])
  {
	 pOwnerLord->ZodiacSign->Cycle();
	 pOwnerLord->ButtonClear(HSidButton6);

  }
  if (pOwnerLord->ButtonHit[HSidButton1])
  {
	 pOwnerLord->ButtonClear(HSidButton1);
	 pOwnerLord->AddCredits(50);
	 return;
  }
  if (pOwnerLord->ButtonHit[HSidButton0])
  {
	 pOwnerLord->FreezeAllButtons();
	 ExecuteWaiting = false;
	 ExecuteStatus = ess_StartSubState2;
	 pOwnerLord->ButtonClear(HSidButton0);
	 return;
  }
  if (pOwnerLord->ButtonHit[HSidButton2])
  {
	 pOwnerLord->ButtonClear(HSidButton2);
  }
  if (pOwnerLord->ButtonHit[HSidButton3])
  {
	 pOwnerLord->ButtonClear(HSidButton3);
	 pOwnerLord->Bet1();
	 if (pOwnerLord->coinsplayed == pOwnerLord->maxbet)
	 {
		WaitingOnWRCounter = 1;
      pOwnerLord->ChangeActivePlayersOk = false;
		if(pOwnerLord->IsLightStrike)
		{
		  WaitOnLightning = true;
		  AdvanceFUC = NewFUC;
		  return;
		}
		else
		{
		  ZeroStart = WaitingOnWRCounter;
		}
	 }
	 else if(pOwnerLord->IsMultiPayline)
	 {
		pOwnerLord->PayLine->SetPayLine(pOwnerLord->coinsplayed);
	 }
  }
  if (pOwnerLord->ButtonHit[HSidButton4])
  {
	 pOwnerLord->ButtonClear(HSidButton4);
	 WaitingOnWRCounter = pOwnerLord->BetMax();
	 if(WaitingOnWRCounter > 0)
	 {
		pOwnerLord->ChangeActivePlayersOk = false;
		if(pOwnerLord->IsLightStrike)
		{
		  WaitOnLightning = true;
		  AdvanceFUC = NewFUC;
		}
		else
		{
		  ZeroStart = WaitingOnWRCounter;
		}
	 }
	 return;
  }
  if (pOwnerLord->ButtonHit[HSidButton5])
  {
	 pOwnerLord->ButtonClear(HSidButton5);
	 if(pOwnerLord->coinsplayed > 0)
	 {
		if(pOwnerLord->IsLightStrike)
		{
		  WaitOnLightning = true;
		  AdvanceFUC = NewFUC;
		  WaitingOnWRCounter = 1;
		  return;
		}
		else
		{
		  pOwnerLord->ChangeActivePlayersOk = false;
		  pOwnerLord->Spin();
		  pOwnerLord->Sounds->PlaySound(0);
		  if(pOwnerLord->Is4Reel)
		  {
			 pOwnerLord->Sounds->PlaySound(1);
		  }
		  else
		  {
			 pOwnerLord->Sounds->PlaySound(2);
		  }
		  pOwnerLord->FreezeAllButtons();
		  WaitOnSpin = true;
		  pOwnerLord->Button0->ShowGray();
		  pOwnerLord->Button1->ShowGray();
		  if(pOwnerLord->Button3){pOwnerLord->Button3->ShowGray();}
		  pOwnerLord->Button4->ShowGray();
		  if(pOwnerLord->Button5){pOwnerLord->Button5->ShowGray();}
		  pOwnerLord->shutdownstate = 1;
		}
	 }
	 return;
  }
  if(Advance1)
  {
	 if(AdvanceFUC+6 == NewFUC)
	 {
		if(IsUp)
		{
		  pOwnerLord->Reel1->SetNum(int16(pOwnerLord->Reel1->GetCurrentAnmFrame(1)+1));
		  pOwnerLord->Reel1->ShowReel();
		}
		else
		{
		  pOwnerLord->Reel1->SetNum(int16(pOwnerLord->Reel1->GetCurrentAnmFrame(1)-1));
		  pOwnerLord->Reel1->ShowReel();
		}
	 }
	 if(AdvanceFUC+12 == NewFUC)
	 {
		if(IsUp)
		{
		  pOwnerLord->Reel1->SetNum(int16(pOwnerLord->Reel1->GetCurrentAnmFrame(1)+1));
		  pOwnerLord->Reel1->ShowReel();
		}
		else
		{
		  pOwnerLord->Reel1->SetNum(int16(pOwnerLord->Reel1->GetCurrentAnmFrame(1)-1));
		  pOwnerLord->Reel1->ShowReel();
		}
		if(Is4)
		{
		  AdvanceFUC = NewFUC+1;
		  Is4 = false;
		}
		else
		{
		  Advance1 = false;
		}
	 }
	 return;
  }
  if(Advance2)
  {
	 if(AdvanceFUC+6 == NewFUC)
	 {
		if(IsUp)
		{
		  pOwnerLord->Reel2->SetNum(int16(pOwnerLord->Reel2->GetCurrentAnmFrame(1)+1));
		  pOwnerLord->Reel2->ShowReel();
		}
		else
		{
		  pOwnerLord->Reel2->SetNum(int16(pOwnerLord->Reel2->GetCurrentAnmFrame(1)-1));
		  pOwnerLord->Reel2->ShowReel();
		}
	 }
	 if(AdvanceFUC+12 == NewFUC)
	 {
		if(IsUp)
		{
		  pOwnerLord->Reel2->SetNum(int16(pOwnerLord->Reel2->GetCurrentAnmFrame(1)+1));
		  pOwnerLord->Reel2->ShowReel();
		}
		else
		{
		  pOwnerLord->Reel2->SetNum(int16(pOwnerLord->Reel2->GetCurrentAnmFrame(1)-1));
		  pOwnerLord->Reel2->ShowReel();
		}
		if(Is4)
		{
		  AdvanceFUC = NewFUC+1;
		  Is4 = false;
		}
		else
		{
		  Advance2 = false;
		}
	 }
	 return;
  }
  if(Advance3)
  {
	 if(AdvanceFUC+6 == NewFUC)
	 {
		if(IsUp)
		{
		  pOwnerLord->Reel3->SetNum(int16(pOwnerLord->Reel3->GetCurrentAnmFrame(1)+1));
		  pOwnerLord->Reel3->ShowReel();
		}
		else
		{
		  pOwnerLord->Reel3->SetNum(int16(pOwnerLord->Reel3->GetCurrentAnmFrame(1)-1));
		  pOwnerLord->Reel3->ShowReel();
		}
	 }
	 if(AdvanceFUC+12 == NewFUC)
	 {
		if(IsUp)
		{
		  pOwnerLord->Reel3->SetNum(int16(pOwnerLord->Reel3->GetCurrentAnmFrame(1)+1));
		  pOwnerLord->Reel3->ShowReel();
		}
		else
		{
		  pOwnerLord->Reel3->SetNum(int16(pOwnerLord->Reel3->GetCurrentAnmFrame(1)-1));
		  pOwnerLord->Reel3->ShowReel();
		}
		if(Is4)
		{
		  AdvanceFUC = NewFUC+1;
		  Is4 = false;
		}
		else
		{
		  Advance3 = false;
		}
	 }
	 return;
  }
  if(pOwnerLord->IsShootMoon && WaitOnSpin && !Advance1 && !Advance2 && !Advance3)
  {
	 if(StopReelTime == 2){pOwnerLord->SetReel();}
	 StopReelTime++;
	 if(StopReelTime == 7)
	 {
		  pOwnerLord->Sounds->PlaySound(3);
	 }
	 else if(StopReelTime == 10)
	 {
		pOwnerLord->Reel1->ShowReel();
		pOwnerLord->Sounds->Sounds[0]->Stop();
		pOwnerLord->Sounds->Sounds[2]->Stop();
		Advance1 = true;
		AdvanceFUC = NewFUC;
		switch(pOwnerLord->Reel1->GetCurrentAnmFrame(1))
		{
		  case 4  : IsUp = true;Is4 = true;break;
		  case 6  : IsUp = true;break;
		  case 15 : IsUp = false;break;
		  case 19 : IsUp = true;break;
		  case 20 : IsUp = false;break;
		  default : Advance1 = false;
		}
	 }
	 else if(StopReelTime == 13)
	 {
		  pOwnerLord->Sounds->PlaySound(4);
	 }
	 else if(StopReelTime == 16)
	 {
		pOwnerLord->Reel2->ShowReel();
		pOwnerLord->Sounds->Sounds[3]->Stop();
		Advance2 = true;
		AdvanceFUC = NewFUC;
		switch(pOwnerLord->Reel2->GetCurrentAnmFrame(1))
		{
		  case 4  : IsUp = true;Is4 = true;break;
		  case 6  : IsUp = true;break;
		  case 15 : IsUp = false;break;
		  case 19 : IsUp = true;break;
		  case 20 : IsUp = false;break;
		  default : Advance2 = false;
		}
	 }
	 else if(StopReelTime == 25)
	 {
		pOwnerLord->Reel3->ShowReel();
		Advance3 = true;
		AdvanceFUC = NewFUC;
		switch(pOwnerLord->Reel3->GetCurrentAnmFrame(1))
		{
		  case 4  : IsUp = true;Is4 = true;break;
		  case 6  : IsUp = true;break;
		  case 15 : IsUp = false;break;
		  case 19 : IsUp = true;break;
		  case 20 : IsUp = false;break;
		  default : Advance3 = false;
		}
	 }
	 else if(StopReelTime == 27)
	 {
		pOwnerLord->Sounds->Sounds[4]->Stop();
		  WaitOnSpin = false;
		  if ((long)pOwnerLord->coinsplayed)
		  {                                //????
			 ExecuteWaiting = false;
			 ExecuteStatus = ess_StartSubState1;
		  }
		  else
		  {
			 pOwnerLord->Clear();
			 StopReelTime = 0;
			 Lock = false;
		  }
	 }
  }
  if(WaitOnSpin && !pOwnerLord->IsShootMoon)
  {
	 if(StopReelTime == 2){pOwnerLord->SetReel();}
	 StopReelTime++;
	 if(StopReelTime == 7)
	 {
		if(pOwnerLord->Is4Reel)
		{
		  pOwnerLord->Sounds->PlaySound(2);
		}
		else
		{
		  pOwnerLord->Sounds->PlaySound(3);
		}
	 }
	 else if(StopReelTime == 10)
	 {
		pOwnerLord->Reel1->ShowReel();
		pOwnerLord->Sounds->Sounds[0]->Stop();
		if(pOwnerLord->Is4Reel)
		{
		  pOwnerLord->Sounds->Sounds[1]->Stop();
		 // pOwnerLord->Sounds->PlaySound(2);
		}
		else
		{
		  pOwnerLord->Sounds->Sounds[2]->Stop();
		  //pOwnerLord->Sounds->PlaySound(3);
		}
	 }
	 else if(StopReelTime == 13)
	 {
		if(pOwnerLord->Is4Reel)
		{
		  pOwnerLord->Sounds->PlaySound(3);
		}
		else
		{
		  pOwnerLord->Sounds->PlaySound(4);
		}
	 }
	 else if(StopReelTime == 16)
	 {
		pOwnerLord->Reel2->ShowReel();
		if(pOwnerLord->Is4Reel)
		{
		  pOwnerLord->Sounds->Sounds[2]->Stop();
	  //	  pOwnerLord->Sounds->PlaySound(3);
		}
		else
		{
		  pOwnerLord->Sounds->Sounds[3]->Stop();
		//  pOwnerLord->Sounds->PlaySound(4);
		}
	 }
	 else if(StopReelTime == 22)
	 {
		if(pOwnerLord->Is4Reel)
		{
		  pOwnerLord->Sounds->PlaySound(4);
		}
	 }
	 else if(StopReelTime == 25)
	 {
		pOwnerLord->Reel3->ShowReel();
	 }
	 else if(StopReelTime == 27)
	 {
	 //	pOwnerLord->Reel3->ShowReel();
		if(pOwnerLord->Is4Reel)
		{
		  pOwnerLord->Sounds->Sounds[3]->Stop();
		  //pOwnerLord->Sounds->PlaySound(4);
		}
		else
		{
		  pOwnerLord->Sounds->Sounds[4]->Stop();
		}
		if(!pOwnerLord->Is4Reel)
		{
		  WaitOnSpin = false;
		  if ((long)pOwnerLord->coinsplayed)
		  {                                //????
			 ExecuteWaiting = false;
			 ExecuteStatus = ess_StartSubState1;
		  }
		  else
		  {
			 pOwnerLord->Clear();
			 StopReelTime = 0;
			 Lock = false;
		  }
		}
	 }
	 else if(StopReelTime == 34)
	 {
		pOwnerLord->Reel4->ShowReel();
	 }
	 else if(StopReelTime >= 36)
	 {
		WaitOnSpin = false;
		//pOwnerLord->Reel4->ShowReel();
		pOwnerLord->Sounds->Sounds[4]->Stop();
		if ((long)pOwnerLord->coinsplayed)
		{                                //????
		  ExecuteWaiting = false;
		  ExecuteStatus = ess_StartSubState1;
		}
		else
		{
		  pOwnerLord->Clear();
		  StopReelTime = 0;
		  Lock = false;
		}
	 }
  }
  if (AddCoinResponder != NULL)
  {
	 if (AddCoinResponder->GetResponseEvent() != reChar)
	 {
		AddCoinResponder->ClearPriority();
	 }
	 AddCoinResponder = NULL;
	 pOwnerLord->BetX(pOwnerLord->coinsize);
	 return;
  }
  if (ZeroStart)
  {
	 WaitingOnWRCounter=0;
	 //if (WaitingOnWRCounter <= 0 && pOwnerLord->coinsplayed > 0 &&
		//  pOwnerLord->CoinsPlayed->IsWaveStopped())
	// {
		if(pOwnerLord->IsMultiPayline)
		{
		  pOwnerLord->PayLine->SetPayLine(pOwnerLord->coinsplayed);
		}
		pOwnerLord->ChangeActivePlayersOk = false;
		pOwnerLord->Spin();
		pOwnerLord->Sounds->PlaySound(0);
		if(pOwnerLord->Is4Reel)
		{
		 pOwnerLord->Sounds->PlaySound(1);
		}
		else
		{
		  pOwnerLord->Sounds->PlaySound(2);
		}
		pOwnerLord->FreezeAllButtons();
		WaitOnSpin = true;
		pOwnerLord->Button0->ShowGray();
		pOwnerLord->Button1->ShowGray();
		if(pOwnerLord->Button3){pOwnerLord->Button3->ShowGray();}
		pOwnerLord->Button4->ShowGray();
		if(pOwnerLord->Button5){pOwnerLord->Button5->ShowGray();}
		pOwnerLord->shutdownstate = 1;
		ZeroStart = 0;
	 //}
	 return;
  }
}
//*******************************************************************
bool THSAct1State::HandleNamePlate(TResponder &responder)
{
  if(responder.GetResponseEvent() == reLDown)
  {
	 responder.SetPriority();
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_PRESSING_FINGER_CURSOR));
	 return true;
  }
  if ((responder.GetResponseEvent() == reLUp    ) ||
		(responder.GetResponseEvent() == reLDblClk) ||
		(responder.GetResponseEvent() == reChar   )   )
  {
	 if(responder.GetIsPriority())
	 {
		responder.ClearPriority();
	 }
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_POINTING_FINGER_CURSOR));
	 if(responder.Contains(responder.GetPoint()) ||
		 responder.GetResponseEvent() == reChar     )
	 {
		if(pOwnerLord->GetNumActivePlayers() > 1)
		{
		  pOwnerLord->CyclePlayers();
		}
	 }
  }
  return true;
}
//*******************************************************************
bool THSAct1State::HandleAddCoin(TResponder &responder)
{
  if(responder.GetResponseEvent() == reLDown)
  {
	 responder.SetPriority();
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_PRESSING_FINGER_CURSOR));
	 return true;
  }
  if ((responder.GetResponseEvent() == reLUp    ) ||
		(responder.GetResponseEvent() == reLDblClk) ||
		(responder.GetResponseEvent() == reChar   )   )
  {
	 if(responder.GetIsPriority())
	 {
		responder.ClearPriority();
	 }
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_POINTING_FINGER_CURSOR));
	 if(responder.Contains(responder.GetPoint()) ||
		 responder.GetResponseEvent() == reChar     )
	 {
		pOwnerLord->BetX(pOwnerLord->coinsize);
		if(pOwnerLord->maxbet == pOwnerLord->coinsplayed)
		{
		  if(pOwnerLord->Button5){pOwnerLord->Button5->ShowGray();}
		  //pOwnerLord->Button6->ShowGray();
		}
	 }
  }
  return true;
}
//*******************************************************************

