//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  cvpglord.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     10/11/95   M.Perry    Original baseline
//  2.0     09/02/97   M.Perry    32-bit conversion.
//*******************************************************************
#include "hsglord.h"
#include "hslordst.h"
#include "hslrdmst.h"
#include "ostate.h"
#include <time.h>   //To Set Random Number Generator
#include <stdlib.h> //For Random Number Generator
#include "cashsmw.h"
#include "hscpsp.h"
#include "oskitcat.h"
#include "hsplay.h"
#include "expert.h"
#include "cplaymgr.h"
#include "casapp.h"
#include "owl\inputdia.h"
#include "orespond.h"
#include "oanm.h"
#include "cas_cm.rh"
#include <stdio.h>
#include "hsmsg.h"
//*******************************************************************
void TCasinoHSGameLord::SetReel()
{
}
//*******************************************************************
TMoney TCasinoHSGameLord::PayOut()
{
  return 0.0;
}
//*******************************************************************
void TCasinoHSGameLord::SetupSprites()
{
  if (Sounds  == NULL) {SpriteError("Slots Sounds","sounds");}
  Sounds->Start(GetFUC());

  //if (WinHighLight    == NULL) {SpriteError("WinHigh","WinHigh");}
  if (Value           == NULL) {SpriteError("Value","value");}
  if (PayLine         == NULL) {SpriteError("PayLine","line");}
  if (CoinsPlayed     == NULL) {SpriteError("Coins Played Nums","cp00");}
  if (WinPaid         == NULL) {SpriteError("Win Paid Nums","wp00");}
  if (Credits         == NULL) {SpriteError("Credits Nums","cr00");}
  if (Reel1           == NULL) {SpriteError("Reel1","rel1");}
  if (Reel2           == NULL) {SpriteError("Reel2","rel2");}
  if (Reel3           == NULL) {SpriteError("Reel3","rel3");}
  if (Reel4           == NULL)
  {Is4Reel = false;}
  else
  {Is4Reel = true;}
  if (BankCashDisplay == NULL)    {SpriteError("BankCashDisplay","bank");}
  if (Button0 == NULL)       {SpriteError("Button0","cash"      );}
  if (Button1 == NULL)       {SpriteError("Button1","addc"      );}
  if (Button2 == NULL)       {SpriteError("Button2","menu"      );}
 // if (Button3 == NULL)       {SpriteError("Button3","bet1"      );}
  if (Button4 == NULL)       {SpriteError("Button4","betm"      );}
 // if (Button5 == NULL)       {SpriteError("Button5","spin"      );}
 // if (Button6 == NULL)       {SpriteError("Button6","zodiacsign"      );}
  if (CoinPay       == NULL) {SpriteError("CoinPay","fall");}
  if (NamePlate1 == NULL)    {SpriteError("NamePlate1","name"        );}
  CoinsPlayed->Start(GetFUC());
  PayLine->Start(GetFUC());
  Value->Start(GetFUC());
  Credits->Start(GetFUC());
  WinPaid->Start(GetFUC());
  if(Progressive != NULL)
  {
	 Progressive->Start(GetFUC());
  }
  if(WinHighLight)
  {
	 ActivateSpriteNow(WinHighLight);
    WinHighLight->NoShow();
  }
  if(Button6 != NULL)
  {
	 ActivateSpriteNow(Button6);
  }
  if(ZodiacSign != NULL)
  {
	 ActivateSpriteNow(ZodiacSign);
  }
  if(MultiplierAnm != NULL)
  {
	 ActivateSpriteNow(MultiplierAnm);
  }
  if(Medalion != NULL)
  {
	 ActivateSpriteNow(Medalion);
  }
  if(Laps != NULL)
  {
	 ActivateSpriteNow(Laps);
  }
  if(MileMarker != NULL)
  {
	 ActivateSpriteNow(MileMarker);
  }
  if(Travel != NULL)
  {
	 ActivateSpriteNow(Travel);
	 Travel->SetNum(0);
  }
  if(Odometer != NULL)
  {
	 ActivateSpriteNow(Odometer);
  }

  ActivateSpriteNow(Reel1);
  ActivateSpriteNow(Reel2);
  ActivateSpriteNow(Reel3);
  if(Is4Reel)
  {
	 ActivateSpriteNow(Reel4);
  }
  CoinPay->Start(GetFUC());
  BankCashDisplay->Start(GetFUC());
  ActivateSpriteNow(Button0);
  if(Button1)
  {
	 ActivateSpriteNow(Button1);
  }
  if(Button2 && GetFW()->GetHandleShowMenu())
  {
	 ActivateSpriteNow(Button2);
  }
  else if(Button2)
  {
	 //Button2->PButton->CAD.SetCurrentFrame(1);
	 //Button2->NoShow();
	 Button2->PButtonResponder->Remove();
  }
  if(Button3)
  {
	 ActivateSpriteNow(Button3);
  }
  ActivateSpriteNow(Button4);
  if(Button5)
  {
	 ActivateSpriteNow(Button5);
  }
  NamePlate1->Start(GetFUC());

}
//*******************************************************************
void TCasinoHSGameLord::CleanupSprites()
{
}
//*******************************************************************
bool TCasinoHSGameLord::Respond(TResponder &responder)
{
  if (PState == NULL) {return true;}

  switch (responder.GetID())
  {
	 case HSidAddCoins  : return true;
								 /* if(shutdownstate == 1)
								{return true;}
								return (((THSLordState *)PState)->AddCoin(responder));*/
	 case HSidSpeedClick:         if(IsCycle)
											{
											  SwitchDenom(Denom[CurrentDenomNum]);// IsCycle set to false in SwitchDenom()
											  //GameDenom = coinsize;
											  GetFW()->NotifyDenomSwitch(coinsize);
											  return false;
											}
											return (((THSLordState *)PState)->SpeedClick(responder));

	 case HSidDenom            :  if(ChangeActivePlayersOk)
											{
											 if(responder.GetResponseEvent() == reLUp)
											 {
											  IsCycle = false;
											  CycleDenom();
											  GameDenom = coinsize;
											  GetFW()->NotifyDenomSwitch(coinsize);
											  IsCycle = true;
											  if(Odometer != NULL)
											  {
												 TotalMiles=0;
												 Odometer->SetNum(0);
												 MileMarker->SetNum(0);
												 Travel->SetNum(0);
												 CurrentRRFrame = 0;
												 Laps->SetNum(0);
											  }
											  if(MultiplierAnm != 0)
											  {
												 Multiplier = 1;
												 MultiplierAnm->SetNum(int16(Multiplier-1));
											  }
											  if(Medalion != NULL)
											  {
												 MedalionColor = 0;
												 Medalion->SetNum(0);
											  }
											 }
											}
											return true;
	 //case HSidNamePlate          :  if(shutdownstate){return true;}
	//										return (((THSLordState *)PState)->NamePlate(responder));
	 default     :  return true;
  }
}
//*******************************************************************
void TCasinoHSGameLord::SetupResponders()
{
  TRect r0(543,370,617,393);
  TCursorData curdata0(0,0);

  TRect r1(17,246,88,390);
  TCursorData curdata1(GetOgleApp(),ID_POINTING_FINGER_CURSOR);

  TRect r2(5,5,635,475);
  TCursorData curdata2(0,0);

  Responders[0] = new TResponder(PModeWin,100,r0,HSidAddCoins,this,true,'~',curdata0);
  Responders[1] = new TResponder(PModeWin,300,r1,HSidDenom,this,true,'~',curdata1);
  Responders[2] = new TResponder(PModeWin,200,r2,HSidSpeedClick,this,true,'^',curdata2);

 // Responders[3]  = new TResponder(PModeWin,100,TRect(260,465,375,477),HSidNamePlate,this,true,VK_TAB,TCursorData(GetOgleApp(),ID_POINTING_FINGER_CURSOR));
}
//*******************************************************************
TCasinoHSGameLord::TCasinoHSGameLord(THunSlotsModeWin *pmwin,const TFileMode &fm,
                                     int16 subgametype,TMoney coindenom)
:TCasinoGameLord(pmwin,fm,subgametype,coindenom.GetDenomID())
{
  PState   = new THSLordMainState(this);

  shutdownstate    = 0;
  progressive = 20000.0;
  pMWin  = pmwin;
 // maxbet=3;  // put in *1gld.cpp constructors
  credits = 0l;
//  coinsize = pMWin->StartDenom;
  coinsize = GameDenom; //mrp - v2.5 - 09/29/99
  r1=0;
  r2=0;
  r3=0;
  activeplayer = 0;
  machinenum = 0;
  playersin=0;
  coinsplayed = 0l;
  winnerpaid = 0l;
  ButtonInfo = 0;
  Is4Reel = false;
  for(int i=0;i<NUMOFBUTTONS;i++)
  {
	 ButtonHit[i] = false;
  }
  Sounds  = NULL;
  Value   = NULL;
  PayLine = NULL;
  Button0 = NULL;
  Button1 = NULL;
  Button2 = NULL;
  Button3 = NULL;
  Button4 = NULL;
  Button5 = NULL;
  Button6 = NULL;
  ZodiacSign = NULL;
  MultiplierAnm = NULL;
  Medalion = NULL;
  BankCashDisplay = NULL;
  CoinPay         = NULL;
  Reel1           = NULL;
  Reel2           = NULL;
  Reel3           = NULL;
  Reel4           = NULL;
  CoinsPlayed     = NULL;
  WinPaid         = NULL;
  Credits         = NULL;
  NamePlate1      = NULL;
  Progressive     = NULL;
  WinHighLight    = NULL;
  Odometer        = NULL;
  Travel          = NULL;
  MileMarker      = NULL;
  Laps            = NULL;
  SetupResponders();
  PayOffSound = -1;
  IsCycle = false;
  ProgressiveIncrement = 0.13;
  IsMultiPayline = false;
  TotalMiles  = 0;
  Multiplier = 1;
  for(int j=0;j<11;j++)
  {
	 Denom[j] = 0.0;
  }
  IsShootMoon = false;
  HoldMultiplier = false;
  IsLightStrike = false;
  Strike1 = 0;
  Strike2 = 0;
  Strike3 = 0;
  Strike4 = 0;
  Strike5 = 0;
  Strike6 = 0;
  Crash1=0;Crash2=0;Crash3=0;Crash4=0;Crash5=0;Flat1=0;Flat2=0;Flat3=0;Flat4=0;Flat5=0;FinishLine=0;
  BetMaxNumOfCredits = 0;
  BetMaxNumOfCoins = 0;
  BMNumOfCredits = false;
  BMNumOfCoins = false;
  IsAccident = false;
  IsFlat = false;
  MaxOnly = false;

  // start of MRP 7/29/97
  strBankruptTitle = "Bankrupt";

  strPlayCheaperCreditYes = "You do not have enough money to play this slot machine.";
  strPlayCheaperCreditYes += " You can either select a more affordable slot machine, or perhaps";
  strPlayCheaperCreditYes += " you would like to visit the Casino Credit department and take out a loan.";
  strPlayCheaperCreditYes += "\nTo get casino credit, return to the lobby and select Casino Credit from the Options menu.";

  strPlayCheaperCreditNo = "You do not have enough money to play this slot machine.";
  strPlayCheaperCreditNo += " Unfortunately, you have no more Casino Credit available.";
  strPlayCheaperCreditNo += " You must either select a less expensive slot machine or create a new gambler.";
  strPlayCheaperCreditNo += "\nTo create a new gambler, select Create/Delete gambler from the File menu.";

  strBrokeCreditYes = "You're so poor that you can't even afford to play a nickel slot.";
  strBrokeCreditYes += " You can either take a loan from the Casino Credit department or create a new gambler";
  strBrokeCreditYes += "\nTo get casino credit, select Casino Credit from the Lobby Options menu.";
  strBrokeCreditYes += "\nTo create a new gambler, select Create/Delete Gambler from the File menu.";

  strBrokeCreditNo = "You've hit rock bottom. You are broke and have no more casino credit available.";
  strBrokeCreditNo += " You should create a new gambler.";
  strBrokeCreditNo += "\nTo create a new gambler, select Create/Delete Gambler from the File menu.";

  strHasCoinsPlayedCreditYes = "You do not have enough money to play additional coins in this slot machine.";
  strHasCoinsPlayedCreditYes += " You can play the coin(s) you've already inserted, select a more";
  strHasCoinsPlayedCreditYes += " affordable slot machine, or perhaps you would like to visit the Casino";
  strHasCoinsPlayedCreditYes += " Credit department and take out a loan.";
  strHasCoinsPlayedCreditYes += "\nTo get casino credit, return to the lobby and select Casino Credit from the Options menu.";

  strHasCoinsPlayedCreditNo = "You do not have enough money to play additional coins in this slot machine.";
  strHasCoinsPlayedCreditNo += " Unfortunately, you have no more Casino Credit available. You can either";
  strHasCoinsPlayedCreditNo += " play the coin(s) you've already inserted, select a less expensive slot machine";
  strHasCoinsPlayedCreditNo += " or create a new gambler.";
  strHasCoinsPlayedCreditNo += "\nTo Create a new gambler, select Create/Delete Gambler from the File menu.";
  // end of MRP 7/29/97
}
//*******************************************************************
TCasinoHSGameLord::~TCasinoHSGameLord()
{
  if(PState != NULL)
  {
	 delete PState;
	 PState = NULL;
  }
  CleanupResponders();
}
//*******************************************************************
void TCasinoHSGameLord::CleanupResponders()
{
  for(int16 i=0;i<NumResponders;i++) {delete Responders[i];}
}
//*******************************************************************
int16 TCasinoHSGameLord::Spin()
{
  int16 session = GetCasPD(activeplayer)->SData.CurrentSession;
  GetCasPD(activeplayer)->SData.Sessions[session].HandsPlayed++;
  Reel1->Blur();
  Reel2->Blur();
  Reel3->Blur();
  if(Is4Reel)
  {
	 Reel4->Blur();
  }
  return 0; // to get rid of warning.
}
//*******************************************************************
int16 TCasinoHSGameLord::InitS()
{
  TCasinoGameData *pgamedata = GetCasGameData();

  ActivateSprite(Song,GetAdjFUC());
  if(Medalion != NULL)
  {
	 Medalion->SetNum(MedalionColor);
  }
  if(Button5 != NULL)
  {
	 Button5->PButtonResponder->SetCh2(VK_RETURN);
	 Button5->PButtonResponder->SetCh('s');
  }
  else
  {
	 Button4->PButtonResponder->SetCh2(VK_RETURN);
	 Button4->PButtonResponder->SetCh('p');
  }
  if(Button3){Button3->PButtonResponder->SetCh('o');}
  Button0->SetCurrentUpFrame(50);
  Button0->SetCurrentGrayFrame(-1);
  Button1->SetCurrentUpFrame(50);
  Button1->SetCurrentGrayFrame(-1);
  Button2->SetCurrentUpFrame(50);
  Button2->SetCurrentGrayFrame(-1);
  if (GetFW()->GetHandleShowMenu())
  {Button2->ShowVoidUp();}
  if(Button3){Button3->SetCurrentUpFrame(50);}
  if(Button3){Button3->SetCurrentGrayFrame(-1);}
  Button4->SetCurrentUpFrame(50);
  Button4->SetCurrentGrayFrame(-1);
  if(Button5){Button5->SetCurrentUpFrame(50);}
  if(Button5){Button5->SetCurrentGrayFrame(-1);}
  if(Button6 != NULL)
  {
	// Button6->SetCurrentUpFrame(50);
	 Button6->SetCurrentGrayFrame(-1);
	 ZodiacSign->Cycle();
	 ZodiacSign->Cycle();
	 ZodiacSign->Cycle();
	 ZodiacSign->Cycle();
  }
  Reel1->SetNum(int16(random(10)));
  Reel2->SetNum(int16(random(10)));
  Reel3->SetNum(int16(random(10)));
  Reel1->SetReel();
  Reel2->SetReel();
  Reel3->SetReel();
  if(Is4Reel)
  {
	 Reel4->SetNum(int16(random(10)));
	 Reel4->SetReel();
  }
  if (SubGameType == cslMonkeyMadness ||
		SubGameType == cslAlienInvasion ||
		SubGameType == cslSuperJackpot   )
  {
	 dword interval=0;
	 if(SubGameType == cslMonkeyMadness)
	 {
		ProgressiveBaseAmount = double(coinsize * 3000.0);
		if(coinsize == 0.05)
		{
		  progressive = pgamedata->ProgressiveHSMM005Amount;
		  interval = TTime().Seconds() - pgamedata->ProgressiveHSMM005EndTime;
		}
		if(coinsize == 0.10)
		{
		  progressive = pgamedata->ProgressiveHSMM010Amount;
		  interval = TTime().Seconds() - pgamedata->ProgressiveHSMM010EndTime;
		}
		if(coinsize == 0.25)
		{
		  progressive = pgamedata->ProgressiveHSMM025Amount;
		  interval = TTime().Seconds() - pgamedata->ProgressiveHSMM025EndTime;
		}

	 }
	 else if(SubGameType == cslAlienInvasion)
	 {
		ProgressiveBaseAmount = double(coinsize * 2250.0);
		if(coinsize == 0.25)
		{
		  progressive = pgamedata->ProgressiveHSAI025Amount;
		  interval = TTime().Seconds() - pgamedata->ProgressiveHSAI025EndTime;
		}
		if(coinsize == 1.0)
		{
		  progressive = pgamedata->ProgressiveHSAI1Amount;
		  interval = TTime().Seconds() - pgamedata->ProgressiveHSAI1EndTime;
		}
	 }
	 else if(SubGameType == cslSuperJackpot)
	 {
		ProgressiveBaseAmount = double(coinsize * 30000.0);
		if(coinsize == 10.0)
		{
		  progressive = pgamedata->ProgressiveHSSJ10Amount;
		  interval = TTime().Seconds() - pgamedata->ProgressiveHSSJ10EndTime;
		}
		if(coinsize == 100.0)
		{
		  progressive = pgamedata->ProgressiveHSSJ100Amount;
		  interval = TTime().Seconds() - pgamedata->ProgressiveHSSJ100EndTime;
		}
	 }
	 ProgressiveMaxAmount  = 9999995.0;
	 ProgressiveIncrement = double(coinsize / 201);
	 if(interval < 600 && interval > 0)
	 {
		int i=0;
		interval = interval/17;
		for(i=0;i<interval;i++)
		{
		  progressive += coinsize;
		  if(progressive > ProgressiveMaxAmount){progressive = ProgressiveBaseAmount;}
		}
		if(random(300) == 1){progressive = ProgressiveBaseAmount;}
	 }
	 else if(interval < 600000l && interval > 0)
	 {
		int i=0;
		interval = interval/600;
		for(i=0;i<interval;i++)
		{
		  if(random(300) == 1)
		  {progressive = ProgressiveBaseAmount;}
		  progressive += coinsize;
		  if(progressive > ProgressiveMaxAmount){progressive = ProgressiveBaseAmount;}
		}
	 }
	 else
	 {
		progressive = double(ProgressiveBaseAmount + int32(random(int(ProgressiveBaseAmount))));
	 }
  }
  SetupActivePlayer(NextSlotNum(-1)); // -1 because order of checking
  if(GetCasPD(0))
  {
	 GetCasPD(0)->StartSSession(SubGameType,GameDenom);
  }
  credits = 0l;
  coinsplayed = 0l;
  winnerpaid = 0l;
  if(credits != 0l){Button0->ShowVoidUp();}
  else{Button0->ShowGray();}
 /* if (!GetFW()->GetHandleShowMenu())
  {
	 Button2->PButton->NoShow();
	 Button2->PButtonResponder->Remove();
  } */
  return 1;
}
//*******************************************************************
void TCasinoHSGameLord::SwitchToPlayer(int16 player)
{
  if(GetCasPD(player))
  {
	 if(activeplayer != player && activeplayer != -1)
	 {
		credits += coinsplayed;
		coinsplayed = 0l;
		CoinsPlayed->SetNum(0);
		GetCasPlayer(activeplayer)->credit = credits;
		credits = 0l;
		//Button7->ShowGray();
	/*	GetCasPD(activeplayer)->Columns[0] = Chips->col1;
		GetCasPD(activeplayer)->Columns[1] = Chips->col2;
		GetCasPD(activeplayer)->Columns[2] = Chips->col3;
		GetCasPD(activeplayer)->Columns[3] = Chips->col4;
		GetCasPD(activeplayer)->Columns[4] = Chips->col5;
		GetCasPD(activeplayer)->Columns[5] = Chips->col6;*/
	 }

	 if(activeplayer != player)
	 {
		switch(activeplayer)
		{
			 case 0 : NamePlate1->NoShowNamePlate();break;
			 case 1 : NamePlate2->NoShowNamePlate();break;
			 case 2 : NamePlate3->NoShowNamePlate();break;
		}
		activeplayer = player;
		BankCashDisplay->SetNum(GetCash(activeplayer));
	 /*	Chips->SetupCols(GetCasPD(player)->Cash,GetCasPD(player)->Columns[0],
						  GetCasPD(player)->Columns[1],GetCasPD(player)->Columns[2],
						  GetCasPD(player)->Columns[3],GetCasPD(player)->Columns[4],
						  GetCasPD(player)->Columns[5],false);*/
		credits = GetCasPlayer(player)->credit;
		GetCasPlayer(player)->credit = 0l;
		Credits->SetNum(credits);
		if(GetCasPD(player)->Cash != 0)
		{
		  if(Button5){Button5->ShowVoidUp();}
		  //Button6->ShowVoidUp();
		}
		else
		{
		  if(Button5){Button5->ShowGray();}
		  //Button6->ShowGray();
		}
		if(GetNumActivePlayers() > 1)
		{
		  string name;
		  name = GetCasPD(player)->GetName();
		  switch(player)
		  {
			 case 0 : NamePlate1->ShowNamePlateString(name);break;
			 case 1 : NamePlate2->ShowNamePlateString(name);break;
			 case 2 : NamePlate3->ShowNamePlateString(name);break;
		  }
		}
	 }
	 if(credits != 0)
	 {
		Button4->ShowVoidUp();
	 }
	 else
	 {
		Button4->ShowGray();
	 }
  }
}
//*******************************************************************
void TCasinoHSGameLord::CyclePlayers()
{
  if(activeplayer != -1)
  {
	 SwitchToPlayer(NextSlotNum(activeplayer));
  }
}
//*******************************************************************
void  TCasinoHSGameLord::ShuttingDown()
{
  TCasinoGameData *pgamedata = GetCasGameData();

  if(GetCasPD(0))
  {
	 NotifyPlayerDeActivation(0);
  }
  if (SubGameType == cslSuperJackpot)
  {
	 if(coinsize == 10.0)
	 {
		pgamedata->ProgressiveHSSJ10Amount = progressive;
		pgamedata->ProgressiveHSSJ10EndTime = TTime().Seconds();
	 }
	 else if(coinsize == 100.0)
	 {
		pgamedata->ProgressiveHSSJ100Amount = progressive;
		pgamedata->ProgressiveHSSJ100EndTime = TTime().Seconds();
	 }
  }
  else if (SubGameType == cslAlienInvasion)
  {
	 if(coinsize == 0.25)
	 {
		pgamedata->ProgressiveHSAI025Amount = progressive;
		pgamedata->ProgressiveHSAI025EndTime = TTime().Seconds();
	 }
	 else if(coinsize == 1.0)
	 {
		pgamedata->ProgressiveHSAI1Amount = progressive;
		pgamedata->ProgressiveHSAI1EndTime = TTime().Seconds();
	 }
  }
  else if (SubGameType == cslMonkeyMadness)
  {
	 if(coinsize == 0.05)
	 {
		pgamedata->ProgressiveHSMM005Amount = progressive;
		pgamedata->ProgressiveHSMM005EndTime = TTime().Seconds();
	 }
	 else if(coinsize == 0.10)
	 {
		pgamedata->ProgressiveHSMM010Amount = progressive;
		pgamedata->ProgressiveHSMM010EndTime = TTime().Seconds();
	 }
	 else if(coinsize == 0.25)
	 {
		pgamedata->ProgressiveHSMM025Amount = progressive;
		pgamedata->ProgressiveHSMM025EndTime = TTime().Seconds();
	 }
  }
}
//*******************************************************************
void TCasinoHSGameLord::NotifyPlayerActivation(int16 slotnum)
{
  if(GetCasPD(slotnum))
  {
	 GameDenom = coinsize;
	 GetFW()->NotifyDenomSwitch(coinsize);
	 GetCasPD(slotnum)->StartSSession(SubGameType,GameDenom);
	// int session = GetCasPD(slotnum)->SData.CurrentSession;
	// GetCasPD(slotnum)->SData.Sessions[session].GameName = (TGameName)game;
	 if(activeplayer == -1)
	 {
	  activeplayer = slotnum;
	  BankCashDisplay->SetNum(GetCash(activeplayer));
	  if(GetCasPD(slotnum)->Cash >= coinsize)
	  {
		 if(Button3){Button3->ShowVoidUp();}
		 Button4->ShowVoidUp();
	  }
	  else
	  {
		 if(Button3){Button3->ShowGray();}
		 Button4->ShowGray();
	  }
		string name;
		name = GetCasPD(activeplayer)->GetName();
		NamePlate1->ShowNamePlateString(name);
	 }
	// SetupSessionData(activeplayer);
  }
}
//*******************************************************************
void TCasinoHSGameLord::NotifyPlayerDeActivation(int16 slotnum)
{
  if(GetCasPD(slotnum))
  {
	 if(Odometer != NULL)
	 {
		TotalMiles=0;
		Odometer->SetNum(0);
		MileMarker->SetNum(0);
      Laps->SetNum(0);
		Travel->SetNum(0);
		CurrentRRFrame = 0;
	 }
	 if(MultiplierAnm != 0)
	 {
		Multiplier = 1;
		MultiplierAnm->SetNum(int16(Multiplier-1));
	 }
	 if(Medalion != NULL)
	 {
		MedalionColor = 0;
		Medalion->SetNum(0);
	 }
	 NamePlate1->NoShowNamePlate();
	 GetCasPD(slotnum)->Cash += double(GetCasPlayer(slotnum)->credit * coinsize);
	 GetCasPlayer(slotnum)->credit = 0;
	 if(activeplayer == slotnum)
	 {
		if(shutdownstate == 0)
		{
		  GetCasPD(slotnum)->Cash += double(coinsplayed * coinsize);
		}
		coinsplayed = 0;
		GetCasPD(slotnum)->Cash += double(credits * coinsize);
		credits = 0;
		if(Button5){Button5->ShowGray();}
		CoinsPlayed->SetNum(0);
	 }
	 if(GetNumActivePlayers() == 1)
	 {
		activeplayer = -1;
		Credits->SetNum(0);
		credits = 0;
		CoinsPlayed->SetNum(0);
		NamePlate1->NoShow();
		if(Button5){Button5->ShowGray();}
		BankCashDisplay->SetNum(0);
	 }
	 if(GetNumActivePlayers() > 1 && activeplayer == slotnum)
	 {
		int16 newplayer=-1;
		newplayer = NextSlotNum(slotnum);
		activeplayer = newplayer;
		credits = GetCasPlayer(newplayer)->credit;
		GetCasPlayer(newplayer)->credit = 0;
		Credits->SetNum(credits);
		CoinsPlayed->SetNum(0);
		BankCashDisplay->SetNum(GetCash(activeplayer));
		if(GetCasPD(activeplayer)->Cash >= coinsize || credits > 0)
		{
		  if(Button3){Button3->ShowVoidUp();}
		  Button4->ShowVoidUp();
		}
		else
		{
		  if(Button3){Button3->ShowGray();}
		  Button4->ShowGray();
		}
		if(Button5){Button5->ShowGray();}
		string name;
		name = GetCasPD(newplayer)->GetName();
		switch(newplayer)
		{
			 case 0 : NamePlate1->ShowNamePlateString(name);break;
		}
	 }
	 GetCasPD(slotnum)->EndSSession();
  }
}
//*******************************************************************
void TCasinoHSGameLord::SetupActivePlayer(int16 slot)
{
  if(GetCasPD(slot))
  {
	 activeplayer = slot;
	 string name;
	 name = GetCasPD(slot)->GetName();
	 NamePlate1->ShowNamePlateString(name);
	 BankCashDisplay->SetNum(GetCash(activeplayer));
  }
}
//*******************************************************************
int16 TCasinoHSGameLord::PayOutProgressive()
{
  return 1;
}
//*******************************************************************
void TCasinoHSGameLord::Clear()
{
  if(Laps != NULL)
  {
	 Laps->SetNum(TotalMiles);
  }
  if(Medalion != NULL)
  {
	 if(MedalionColor == 4){MedalionColor=0;}
	 Medalion->SetNum(MedalionColor);
  }
  if(Button5 != NULL)
  {
	 Button5->ShowGray();
  }
  PayOffSound = -1;
  BetMaxNumOfCredits = 0;
  BetMaxNumOfCoins = 0;
  WaitOnButtonDown = false;
  UnFreezeAllButtons();
  shutdownstate    = 0;
  ChangeActivePlayersOk = true;
  coinsplayed = 0;
  if(credits > 0)
  {
	 Button0->ShowVoidUp();
  }
  else
  {
	 Button0->ShowGray();
  }
  if(activeplayer > -1 && (GetCash(activeplayer) >= coinsize || credits > 0))
  {
	 if(GetCash(activeplayer) >= double(coinsize * 50))
	 {
		Button1->ShowVoidUp();
	 }
	 if(Button3){Button3->ShowVoidUp();}
	 Button4->ShowVoidUp();
  }
  if(activeplayer > -1){BankCashDisplay->SetNum(GetCash(activeplayer));}
}
//*******************************************************************
TMoney TCasinoHSGameLord::Winner()
{
#ifdef DEBUGSLOT
  int w,x,y,z;
  pMWin->SetUpdatePause();
  char cardnum1[5] = "";
  char cardnum2[5] = "";
  char cardnum3[5] = "";
  char cardnum4[5] = "";
  TInputDialog getcard1(pMWin,"","#",cardnum1,5);
  getcard1.Execute();
  TInputDialog getcard2(pMWin,"","#",cardnum2,5);
  getcard2.Execute();
  TInputDialog getcard3(pMWin,"","#",cardnum3,5);
  getcard3.Execute();
  if(Is4Reel)
  {
	 TInputDialog getcard4(pMWin,"","#",cardnum4,5);
	 getcard4.Execute();
  }
  pMWin->ClearUpdatePause();
  w = atoi(cardnum1);
  x = atoi(cardnum2);
  y = atoi(cardnum3);
  if(Is4Reel)
  {
	 z = atoi(cardnum4);
  }
  Reel1->SetNum(w);
  Reel2->SetNum(x);
  Reel3->SetNum(y);
  if(Is4Reel)
  {
	 Reel4->SetNum(z);
  }
  Reel1->ShowReel();
  Reel2->ShowReel();
  Reel3->ShowReel();
  if(Is4Reel)
  {
	 Reel4->ShowReel();
  }
#endif
  winnerpaid = (double)PayOut();
  if(TotalMiles >= 500)
  {
	 winnerpaid += 500;
   // Laps->SetNum(500);
  }
  if(Medalion != NULL)
  {
	 if(MedalionColor == 4)
	 {
		Medalion->SetNum(MedalionColor);
	 }
  }
  int session = GetCasPD(activeplayer)->SData.CurrentSession;
  TCasinoSData &curdata = GetCasPD(activeplayer)->SData;
  TCSSession &cursession = curdata.Sessions[session];

  if(winnerpaid == 0)
  {
	 curdata.Cumulative -= double(coinsplayed * coinsize);
	 cursession.CurrentLosingStreak++;
	 cursession.CurrentWinStreak = 0;
	 cursession.Losses++;
	 if(cursession.CurrentLosingStreak > cursession.LosingStreak)
	 {
		cursession.LosingStreak = cursession.CurrentLosingStreak;
	 }
	 if((GetCash(activeplayer)+(credits * coinsize)) < cursession.PeakLoss)
	 {
		cursession.PeakLoss = double(GetCash(activeplayer) + (credits * coinsize));
	 }
  }
  else
  {
	 curdata.Cumulative += double(winnerpaid * coinsize);
	 cursession.CurrentWinStreak++;
	 cursession.CurrentLosingStreak = 0;
	 cursession.Wins++;  //???
	 if(cursession.CurrentWinStreak > cursession.WinStreak)
	 {
		cursession.WinStreak = cursession.CurrentWinStreak;
	 }
	 if(winnerpaid*coinsize > cursession.LargestWin)
	 {
		cursession.LargestWin = double(winnerpaid * coinsize);
	 }
	 if(GetCash(activeplayer)+(credits*coinsize)+winnerpaid*coinsize > cursession.PeakWin)
	 {
		cursession.PeakWin = double(GetCash(activeplayer) +
                                  (credits * coinsize) +
                                  (winnerpaid * coinsize));
	 }
	 if(winnerpaid > 18)
	 {
		cursession.nHiPayoffs++;
	 }
	 else
	 {
      cursession.nLowPayoffs++;
	 }
  }
  if(WinHighLight != NULL)
  {
	 switch(PayOffSound)
	 {
		case 0  : WinHighLight->PlaySound(0);break;
		case 1  : WinHighLight->PlaySound(1);break;
		case 2  : WinHighLight->PlaySound(2);break;
		case 3  : WinHighLight->PlaySound(3);break;
		case 4  : WinHighLight->PlaySound(4);break;
		case 5  : WinHighLight->PlaySound(5);break;
		case 6  : WinHighLight->PlaySound(6);break;
		case 7  : WinHighLight->PlaySound(7);break;
		case 8  : WinHighLight->PlaySound(8);break;
	 }
  }
  return winnerpaid;
}// winner
//*******************************************************************
int16 TCasinoHSGameLord::AddCoins()
{
  if (GetCasPD(activeplayer) != NULL) {GetCasPD(activeplayer)->Cash.RoundTo5Cent();}
  if(GetCash(activeplayer) == 0 && credits == 0)
  {
	 if(coinsplayed > 0)
	 {
		  PModeWin->MessageBox("You're out of money and may not make additional bets. Your current bets are your only hope.","Out of Cash",MB_OK);
	 }
	 else
	 {
		PModeWin->MessageBox("You've hit rock bottom. Your gambler is bankrupt. Select Create/Delete under the FILE menu to create or select a new gambler.","Bankrupt!",MB_OK);
	 }
	 return 1;
  }
  if(coinsplayed < maxbet)
  {
	 SubCash(activeplayer,coinsize);
	 coinsplayed++;
  }
  else
  {
	 if(coinsplayed == maxbet)   // Not a needed check, oh well...
	 {
		SubCash(activeplayer,coinsize);
		credits++;
	 }
  }
  return 1;
}
//*******************************************************************
int16 TCasinoHSGameLord::CashOut()
{
  return 1;
}
//*******************************************************************
int16 TCasinoHSGameLord::Bet1()
{
  if (GetCasPD(activeplayer) != NULL) {GetCasPD(activeplayer)->Cash.RoundTo5Cent();}
  if((GetCash(activeplayer) == 0.0 || GetCash(activeplayer) < coinsize) && credits == 0.0)
  {
    // start of MRP 7/29/97
    if (coinsplayed > 0.0)
    {
      if (GetCasPD(activeplayer)->CreditCheck())
      {
        TBankruptMsgDlg *pbmd = new TBankruptMsgDlg(PModeWin,strHasCoinsPlayedCreditYes,strBankruptTitle);
        pbmd->Execute();
        delete pbmd;
      }
      else
      {
        TBankruptMsgDlg *pbmd = new TBankruptMsgDlg(PModeWin,strHasCoinsPlayedCreditNo,strBankruptTitle);
        pbmd->Execute();
        delete pbmd;
      }
    }
    else if (GetCash(activeplayer) < 0.05)
    {
      if (GetCasPD(activeplayer)->CreditCheck())
      {
        TBankruptMsgDlg *pbmd = new TBankruptMsgDlg(PModeWin,strBrokeCreditYes,strBankruptTitle);
        pbmd->Execute();
        delete pbmd;
      }
      else
      {
        TBankruptMsgDlg *pbmd = new TBankruptMsgDlg(PModeWin,strBrokeCreditNo,strBankruptTitle);
        pbmd->Execute();
        delete pbmd;
      }
    }
    else if (GetCash(activeplayer) < coinsize)
    {
      if (GetCasPD(activeplayer)->CreditCheck())
      {
        TBankruptMsgDlg *pbmd = new TBankruptMsgDlg(PModeWin,strPlayCheaperCreditYes,strBankruptTitle);
        pbmd->Execute();
        delete pbmd;
      }
      else
      {
        TBankruptMsgDlg *pbmd = new TBankruptMsgDlg(PModeWin,strPlayCheaperCreditNo,strBankruptTitle);
        pbmd->Execute();
        delete pbmd;
      }
    }

    // end MRP 7/29/97
	 return 0;
  }
  int session = GetCasPD(activeplayer)->SData.CurrentSession;
  TCasinoSData &curdata = GetCasPD(activeplayer)->SData;
  TCSSession &cursession = curdata.Sessions[session];

	if(credits > 0.0)
	{
	  credits--;
	  CoinsPlayed->PlaySound(0);
	  coinsplayed++;
	  CoinsPlayed->SetNum(coinsplayed);
	  BankCashDisplay->SetNum(GetCash(activeplayer));
	  Credits->SetNum(credits);
	  if(Button5){Button5->ShowVoidUp();}
	  cursession.TotalBetsCash += coinsize;

	  if(credits == 0)
	  {
		 Button0->ShowGray();
	  }
	  WinPaid->SetNum(0);
	  BankCashDisplay->SetNum(GetCash(activeplayer));
	  return 1;
	}
	if (GetCash(activeplayer) >= coinsize)
	{
	  SubCash(activeplayer,coinsize);
	  CoinsPlayed->PlaySound(5);
	  coinsplayed++;
	  cursession.TotalBetsCash += coinsize;
	  CoinsPlayed->SetNum(coinsplayed);
	  Credits->SetNum(credits);
	  if(Button5){Button5->ShowVoidUp();}
	  WinPaid->SetNum(0);
	  BankCashDisplay->SetNum(GetCash(activeplayer));
	}
	return 1;
}
//*******************************************************************
TMoney TCasinoHSGameLord::BetX(TMoney x)
{
  if (GetCasPD(activeplayer) != NULL) {GetCasPD(activeplayer)->Cash.RoundTo5Cent();}
  if(GetCash(activeplayer) == 0.0 && credits == 0.0)
  {
	 if(coinsplayed > 0.0)
	 {
		  PModeWin->MessageBox("You're out of money and may not make additional bets. Your current bets are your only hope.","Out of Cash",MB_OK);
	 }
	 else
	 {
		PModeWin->MessageBox("You've hit rock bottom. Your gambler is bankrupt. Select Create/Delete under the FILE menu to create or select a new gambler.","Bankrupt!",MB_OK);
	 }
	 return 0;//true; // MRP 7/29/97
  }
	TMoney bm=0,returnvalue=0;
	bm = double(x / coinsize);
	int session = GetCasPD(activeplayer)->SData.CurrentSession;
   TCasinoSData &curdata = GetCasPD(activeplayer)->SData;
   TCSSession &cursession = curdata.Sessions[session];

	if (GetCash(activeplayer) >= x && bm > 0.0)
	{
	  SubCash(activeplayer,(coinsize * bm));
	  cursession.TotalBetsCash += double(coinsize * bm);
	  BankCashDisplay->SetNum(GetCash(activeplayer));
	  if(coinsplayed == maxbet)
	  {
		 credits += bm;
		 Credits->SetNum(credits);
		 Button4->ShowVoidUp();
		 returnvalue = 0;
	  }
	  else if (coinsplayed+bm < double(maxbet+1))
	  {
		 returnvalue = bm;
		 coinsplayed += bm;
		 CoinsPlayed->SetNum(coinsplayed);
		 switch((long)bm)
		 {
			case 1  : CoinsPlayed->PlaySound(5);break;
			case 2  : CoinsPlayed->PlaySound(6);break;
			case 3  : CoinsPlayed->PlaySound(7);break;
			case 4  : CoinsPlayed->PlaySound(8);break;
			case 5  : CoinsPlayed->PlaySound(9);break;
			default : if(bm > 5) {CoinsPlayed->PlaySound(9);;}
		 }
	  }
	  else if(coinsplayed+bm > maxbet)
	  {
		 switch((long)bm)
		 {
			case 1  : CoinsPlayed->PlaySound(5);break;
			case 2  : CoinsPlayed->PlaySound(6);break;
			case 3  : CoinsPlayed->PlaySound(7);break;
			case 4  : CoinsPlayed->PlaySound(8);break;
			case 5  : CoinsPlayed->PlaySound(9);break;
			default : if(bm > 5) {CoinsPlayed->PlaySound(9);;}
		 }
		 returnvalue = double(maxbet - coinsplayed);
		 bm -= double(maxbet - coinsplayed);
		 credits += bm;
		 Credits->SetNum(credits);
		 coinsplayed = maxbet;
		 CoinsPlayed->SetNum(coinsplayed);
		 Button4->ShowVoidUp();
	  }
	  WinPaid->SetNum(0);
	  BankCashDisplay->SetNum(GetCash(activeplayer));
	  if(Button5){Button5->ShowVoidUp();}
	  if(credits != 0){Button0->ShowVoidUp();}
	}
	return returnvalue;
}
//*******************************************************************
int16 TCasinoHSGameLord::BetMax()
{
  if (GetCasPD(activeplayer) != NULL) {GetCasPD(activeplayer)->Cash.RoundTo5Cent();}
  if((GetCash(activeplayer) == 0.0 || GetCash(activeplayer) < coinsize) && credits == 0.0)
  {
	 Button4->ShowGray();

    // start of MRP 7/29/97
    if (coinsplayed > 0.0)
    {
      if (GetCasPD(activeplayer)->CreditCheck())
      {
        TBankruptMsgDlg *pbmd = new TBankruptMsgDlg(PModeWin,strHasCoinsPlayedCreditYes,strBankruptTitle);
        pbmd->Execute();
        delete pbmd;
      }
      else
      {
        TBankruptMsgDlg *pbmd = new TBankruptMsgDlg(PModeWin,strHasCoinsPlayedCreditNo,strBankruptTitle);
        pbmd->Execute();
        delete pbmd;
      }
    }
    else if (GetCash(activeplayer) < 0.05)
    {
      if (GetCasPD(activeplayer)->CreditCheck())
      {
        TBankruptMsgDlg *pbmd = new TBankruptMsgDlg(PModeWin,strBrokeCreditYes,strBankruptTitle);
        pbmd->Execute();
        delete pbmd;
      }
      else
      {
        TBankruptMsgDlg *pbmd = new TBankruptMsgDlg(PModeWin,strBrokeCreditNo,strBankruptTitle);
        pbmd->Execute();
        delete pbmd;
      }
    }
    else if (GetCash(activeplayer) < coinsize)
    {
      if (GetCasPD(activeplayer)->CreditCheck())
      {
        TBankruptMsgDlg *pbmd = new TBankruptMsgDlg(PModeWin,strPlayCheaperCreditYes,strBankruptTitle);
        pbmd->Execute();
        delete pbmd;
      }
      else
      {
        TBankruptMsgDlg *pbmd = new TBankruptMsgDlg(PModeWin,strPlayCheaperCreditNo,strBankruptTitle);
        pbmd->Execute();
        delete pbmd;
      }
    }
    // end MRP 7/29/97
	 return 0;
  }
  if(MaxOnly)
  {
	 if((GetCash(activeplayer)/coinsize)+credits < maxbet)
	 {
		  Button4->ShowGray();
        // start MRP 7/29/97
        if (GetCasPD(activeplayer)->CreditCheck())
        {
          TBankruptMsgDlg *pbmd = new TBankruptMsgDlg(PModeWin,strPlayCheaperCreditYes,strBankruptTitle);
          pbmd->Execute();
          delete pbmd;
        }
        else
        {
          TBankruptMsgDlg *pbmd = new TBankruptMsgDlg(PModeWin,strPlayCheaperCreditNo,strBankruptTitle);
          pbmd->Execute();
          delete pbmd;
        }
        // end MRP 7/29/97
		return 0;
	 }
  }
  TMoney cpp = 0.0;
  TMoney cp = coinsplayed;

  int session = GetCasPD(activeplayer)->SData.CurrentSession;
  TCasinoSData &curdata = GetCasPD(activeplayer)->SData;
  TCSSession &cursession = curdata.Sessions[session];

  BMNumOfCoins     = false;
  BetMaxNumOfCoins = false;
  if(credits >= double(maxbet-coinsplayed))
  {
	 credits -= double(maxbet-coinsplayed);
	 BetMaxNumOfCredits = maxbet - coinsplayed;
	 BMNumOfCredits = true;
	 cursession.TotalBetsCash += double((maxbet-coinsplayed)*coinsize);

	 coinsplayed = maxbet;
	 CoinsPlayed->SetNum(coinsplayed);
	 Credits->SetNum(credits);
	 if(Button5){Button5->ShowVoidUp();}
	 if(credits == 0)
	 {
		Button0->ShowGray();
	 }
	 if(Button3){Button3->ShowGray();}
	 Button4->ShowGray();
	 WinPaid->SetNum(0);
	 BankCashDisplay->SetNum(GetCash(activeplayer));
	 return (coinsplayed - cp);
  }
  else
  {
	 if(credits > 0.0)
	 {
		coinsplayed += credits;
		cursession.TotalBetsCash += double(credits*coinsize);
		if(Button5){Button5->ShowVoidUp();}
		BetMaxNumOfCredits = credits;
		BMNumOfCredits = true;;
	 }
	 if(Button3){Button3->ShowGray();}
	 Button4->ShowGray();
	 if(Button5){Button5->ShowGray();}
	 credits = 0;                          // Could make a little faster
  }

  if (GetCash(activeplayer) > double((maxbet - coinsplayed) * coinsize))
  {
	 SubCash(activeplayer,(maxbet - coinsplayed) * coinsize);
	 cursession.TotalBetsCash += double((maxbet-coinsplayed)*coinsize);
	 BetMaxNumOfCoins = maxbet - coinsplayed;
	 BMNumOfCoins = true;
	 coinsplayed = maxbet;
	 CoinsPlayed->SetNum(coinsplayed);
	 Credits->SetNum(credits);
	 if(Button5){Button5->ShowVoidUp();}
	 BankCashDisplay->SetNum(GetCash(activeplayer));
  }
  else
  {
	 int16 x=0;
	 x = GetCash(activeplayer) / coinsize;
	 cpp = x;
	 coinsplayed += x;
	 BetMaxNumOfCoins = x;
	 SubCash(activeplayer,coinsize*x);
	 cursession.TotalBetsCash += double(coinsize*x);
	 CoinsPlayed->SetNum(coinsplayed);
	 Credits->SetNum(credits);
	 BankCashDisplay->SetNum(GetCash(activeplayer));
	 if(x>0)
	 {
		if(Button5)
		{
		  Button5->ShowVoidUp();
		}
	 }
  }
  if(coinsplayed > cp)
  {
	 if(cpp>0){BMNumOfCoins = true;}
	 WinPaid->SetNum(0);
	 BankCashDisplay->SetNum(GetCash(activeplayer));
  }
  else if(coinsplayed == cp)
  {
  BankCashDisplay->SetNum(GetCash(activeplayer));
  }
  return (coinsplayed - cp);
}
//*******************************************************************
int16 TCasinoHSGameLord::ShowWinner()
{
  credits += double(winnerpaid / coinsize);
  return 1;
}
//*******************************************************************

