//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  cvpglord.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     10/11/95   M.Perry    Original baseline
//  2.0     09/02/97   M.Perry    32-bit conversion.
//*******************************************************************
#include "hsglord.h"
#include "hslordst.h"
#include "hslrdmst.h"
#include "ostate.h"
#include <time.h>   //To Set Random Number Generator
#include <stdlib.h> //For Random Number Generator
#include "cashsmw.h"
#include "hscpsp.h"
#include "oskitcat.h"
#include "hsplay.h"
#include "expert.h"
#include "cplaymgr.h"
#include "casapp.h"
#include "owl\inputdia.h"
#include "orespond.h"
#include "oanm.h"
#include "cas_cm.rh"
#include "hsmsg.h"
//*******************************************************************
void TCasinoHSGameLord::CycleDenom()
{
  GetCasPlayer(activeplayer)->credit = 0;
  if(coinsplayed > 0 || credits > 0)
  {
	 CoinPay->PlaySound(6);
  }
  if(shutdownstate == 0)
  {
	 GetCasPD(activeplayer)->Cash += double(coinsplayed*coinsize);
  }
  coinsplayed = 0;
  GetCasPD(activeplayer)->Cash += double(credits*coinsize);
  credits = 0;
  if(Button5){Button5->ShowGray();}
  Button0->ShowGray();
  Credits->SetNum(0);
  CoinsPlayed->SetNum(0);
  BankCashDisplay->SetNum(GetCash(activeplayer));

  CurrentDenomNum++;
  if(CurrentDenomNum >= NumOfDenoms){CurrentDenomNum = 0;}
  Value->ChangeDenom(Denom[CurrentDenomNum],IsCycle);
  if(GetCasPD(0)->Cash >= Denom[CurrentDenomNum])
  {
	 if(Button3)
	 {
		Button3->ShowVoidUp();
	 }
	 Button4->ShowVoidUp();
  }
  else
  {
	 if(Button3)
	 {
		Button3->ShowGray();
	 }
	 Button4->ShowGray();
  }

}
//*******************************************************************
bool TCasinoHSGameLord::SwitchDenom(TMoney denom)
{
  TCasinoGameData *pgamedata = GetCasGameData();

  if (SubGameType == cslSuperJackpot)
  {
	 if(coinsize == 10.0)
	 {
		pgamedata->ProgressiveHSSJ10Amount = progressive;
		pgamedata->ProgressiveHSSJ10EndTime = TTime().Seconds();
	 }
	 else if(coinsize == 100.0)
	 {
		pgamedata->ProgressiveHSSJ100Amount = progressive;
		pgamedata->ProgressiveHSSJ100EndTime = TTime().Seconds();
	 }
  }
  else if (SubGameType == cslAlienInvasion)
  {
	 if(coinsize == 0.25)
	 {
		pgamedata->ProgressiveHSAI025Amount = progressive;
		pgamedata->ProgressiveHSAI025EndTime = TTime().Seconds();
	 }
	 else if(coinsize == 1.0)
	 {
		pgamedata->ProgressiveHSAI1Amount = progressive;
		pgamedata->ProgressiveHSAI1EndTime = TTime().Seconds();
	 }
  }
  else if (SubGameType == cslMonkeyMadness)
  {
	 if(coinsize == 0.05)
	 {
		pgamedata->ProgressiveHSMM005Amount = progressive;
		pgamedata->ProgressiveHSMM005EndTime = TTime().Seconds();
	 }
	 else if(coinsize == 0.10)
	 {
		pgamedata->ProgressiveHSMM010Amount = progressive;
		pgamedata->ProgressiveHSMM010EndTime = TTime().Seconds();
	 }
	 else if(coinsize == 0.25)
	 {
		pgamedata->ProgressiveHSMM025Amount = progressive;
		pgamedata->ProgressiveHSMM025EndTime = TTime().Seconds();
	 }
  }
  GetCasPlayer(activeplayer)->credit = 0;
  if(coinsplayed > 0 || credits > 0)
  {
	 CoinPay->PlaySound(6);
  }
  if(shutdownstate == 0)
  {
	 GetCasPD(activeplayer)->Cash += double(coinsplayed*coinsize);
  }
  coinsplayed = 0;
  GetCasPD(activeplayer)->Cash += double(credits*coinsize);
  credits = 0;
  if(Button5){Button5->ShowGray();}
  Button0->ShowGray();
  Credits->SetNum(0);
  CoinsPlayed->SetNum(0);
  BankCashDisplay->SetNum(GetCash(activeplayer));

  while(denom != Denom[CurrentDenomNum])
  {
	 CurrentDenomNum++;
	 if(CurrentDenomNum >= NumOfDenoms){CurrentDenomNum = 0;}
  }
  Value->ChangeDenom(Denom[CurrentDenomNum],IsCycle);
  NotifyPlayerDeActivation(0);
  coinsize = Denom[CurrentDenomNum];
  NotifyPlayerActivation(0);
  IsCycle = false;
  if (SubGameType == cslMonkeyMadness ||
		SubGameType == cslAlienInvasion ||
		SubGameType == cslSuperJackpot   )
  {
	 dword interval=0;
	 if(SubGameType == cslMonkeyMadness)
	 {
		ProgressiveBaseAmount = double(coinsize * 3000.0);
		if(coinsize == 0.05)
		{
		  progressive = pgamedata->ProgressiveHSMM005Amount;
		  interval = TTime().Seconds() - pgamedata->ProgressiveHSMM005EndTime;
		}
		if(coinsize == 0.10)
		{
		  progressive = pgamedata->ProgressiveHSMM010Amount;
		  interval = TTime().Seconds() - pgamedata->ProgressiveHSMM010EndTime;
		}
		if(coinsize == 0.25)
		{
		  progressive = pgamedata->ProgressiveHSMM025Amount;
		  interval = TTime().Seconds() - pgamedata->ProgressiveHSMM025EndTime;
		}

	 }
	 else if(SubGameType == cslAlienInvasion)
	 {
		ProgressiveBaseAmount = double(coinsize * 2250.0);
		if(coinsize == 0.25)
		{
		  progressive = pgamedata->ProgressiveHSAI025Amount;
		  interval = TTime().Seconds() - pgamedata->ProgressiveHSAI025EndTime;
		}
		if(coinsize == 1.0)
		{
		  progressive = pgamedata->ProgressiveHSAI1Amount;
		  interval = TTime().Seconds() - pgamedata->ProgressiveHSAI1EndTime;
		}
	 }
	 else if(SubGameType == cslSuperJackpot)
	 {
		ProgressiveBaseAmount = double(coinsize * 30000.0);
		if(coinsize == 10.0)
		{
		  progressive = pgamedata->ProgressiveHSSJ10Amount;
		  interval = TTime().Seconds() - pgamedata->ProgressiveHSSJ10EndTime;
		}
		if(coinsize == 100.0)
		{
		  progressive = pgamedata->ProgressiveHSSJ100Amount;
		  interval = TTime().Seconds() - pgamedata->ProgressiveHSSJ100EndTime;
		}
	 }
	 ProgressiveMaxAmount  = 9999995.0;
	 ProgressiveIncrement = double(coinsize / 201);
	 if(interval < 600 && interval > 0)
	 {
		int i=0;
		interval = interval/17;
		for(i=0;i<interval;i++)
		{
		  progressive += coinsize;
		  if(progressive > ProgressiveMaxAmount){progressive = ProgressiveBaseAmount;}
		}
		if(random(300) == 1){progressive = ProgressiveBaseAmount;}
	 }
	 else if(interval < 600000l && interval > 0)
	 {
		int i=0;
		interval = interval/600;
		for(i=0;i<interval;i++)
		{
		  if(random(300) == 1)
		  {progressive = ProgressiveBaseAmount;}
		  progressive += coinsize;
		  if(progressive > ProgressiveMaxAmount){progressive = ProgressiveBaseAmount;}
		}
	 }
	 else
	 {
		progressive = double(ProgressiveBaseAmount + random(ProgressiveBaseAmount));
	 }
  }
  GameDenom = coinsize;
  if(GetCasPD(activeplayer)->Cash < coinsize)
  {
	 if(Button3 != NULL){Button3->ShowGray();}
	 Button4->ShowGray();
  }
  else
  {
	 if(Button3 != NULL){Button3->ShowVoidUp();}
	 Button4->ShowVoidUp();
  }
  if(Odometer != NULL)
  {
	 TotalMiles=0;
	 Odometer->SetNum(0);
	 MileMarker->SetNum(0);
	 Travel->SetNum(0);
	 CurrentRRFrame = 0;
	 Laps->SetNum(0);
  }
  if(MultiplierAnm != 0)
  {
	 Multiplier = 1;
	 MultiplierAnm->SetNum(int16(Multiplier-1));
  }
  if(Medalion != NULL)
  {
	 MedalionColor = 0;
	 Medalion->SetNum(0);
  }
  return true;
}
//*******************************************************************
TMoney TCasinoHSGameLord::PayLine1()
{
  return 0;
}
//*******************************************************************
TMoney TCasinoHSGameLord::PayLine2()
{
  return 0;
}
//*******************************************************************
TMoney TCasinoHSGameLord::PayLine3()
{
  return 0;
}
//*******************************************************************
TMoney TCasinoHSGameLord::PayLine4()
{
  return 0;
}
//*******************************************************************
TMoney TCasinoHSGameLord::PayLine5()
{
  return 0;
}
//*******************************************************************
TSprite *TCasinoHSGameLord::CreateSprite(string spritename,int16 id,void *psource)
{
  // the following added because of new C++ rule about
  // passing temp's as parameters.
  
  static TRect b0rect(1,399,82,457);
  static TRect b1rect(1,464,86,478);
  static TRect b2rect(92,464,176,478);
  static TRect b3rect(393,398,472,456);
  static TRect b4rect(476,398,548,456);
  static TRect b5rect(557,398,629,456);
  static TRect b6rect(450,464,635,478);

  static TRect b4rect_2(393,398,629,456);

  TFileMode FM(spritename,
               TFileMode::fm_None,
               TFileMode::fm_None,
               FileMode.GetDirIndex());

  if (psource != NULL)
  {
    switch (id)
	 {
		case  0 : return new TSprite(PModeWin,FM,psource);
		case  1 : Reel1 = new THSReel(PModeWin,FM,psource);
					 return Reel1;
		case  2 : Reel2 = new THSReel(PModeWin,FM,psource);
					 return Reel2;
		case  3 : Reel3 = new THSReel(PModeWin,FM,psource);
					 return Reel3;
		case  4 : Sounds = new THSSound(PModeWin,FM,psource);
					 return Sounds;
		case  5 : Value = new THSValue(PModeWin,FM,psource);
					 return Value;
		case  6 : PayLine = new THSPayLine(PModeWin,FM,psource);
					 return PayLine;
		case  7 : WinPaid = new THSWinPaid(PModeWin,FM,psource);
					 return WinPaid;
		case  8 : Credits = new THSCredits(PModeWin,FM,psource);
					 return Credits;
		case  9 : CoinsPlayed = new THSCoinsPlayed(PModeWin,FM,psource);
					 return CoinsPlayed;
		case  10: Progressive = new THSProgressive(PModeWin,FM,psource);
					 return Progressive;
		case  11: NamePlate1 = new THSNamePlate(PModeWin,FM,psource);
					 return NamePlate1;
		case  12: BankCashDisplay = new THSCashDisplay(PModeWin,FM,psource);
					 return BankCashDisplay;
		case  13: CoinPay = new THSCoinPay(PModeWin,FM,psource);
					 return CoinPay;
		case  14: Button3 = new TCasButton(PModeWin,FM,psource,this,125,b3rect,HSidButton3,true,'b');
					 return Button3;
		case  15: Button4 = new TCasButton(PModeWin,FM,psource,this,125,b4rect,HSidButton4,true,'m');
					 return Button4;
		case  16: Button5 = new TCasButton(PModeWin,FM,psource,this,125,b5rect,HSidButton5,true,'s');
					 return Button5;
		case  17: Button1 = new TCasButton(PModeWin,FM,psource,this,100,b1rect,HSidButton1,true);
					 return Button1;
		case  18: Button2 = new TCasButton(PModeWin,FM,psource,this,125,b2rect,HSidButton2,true);
					 return Button2;
		case  19: Button0 = new TCasButton(PModeWin,FM,psource,this,125,b0rect,HSidButton0,true,'c');
					 return Button0;
		case  20: WinHighLight = new THSWinHighLight(PModeWin,FM,psource);
					 return WinHighLight;
		case  21: return new TSprite(PModeWin,FM,psource);//break;//return new (PModeWin,FM));
		case  22: Reel4 = new THSReel(PModeWin,FM,psource);
					 return Reel4;
		case  23: Button6 = new TCasButton(PModeWin,FM,psource,this,100,b6rect,HSidButton6,true);
					 return Button6;
		case  24: ZodiacSign = new THSZodiacSign(PModeWin,FM,psource);
					 return ZodiacSign;
		case  25: MultiplierAnm = new THSMultiplier(PModeWin,FM,psource);
					 return MultiplierAnm;
		case  26: Button4 = new TCasButton(PModeWin,FM,psource,this,125,b4rect_2,HSidButton4,true,'m');
					 return Button4;
		case  33: Button4 = new TCasButton(PModeWin,FM,psource,this,125,b4rect_2,HSidButton4,true,'m');
					 return Button4;
		case  34: Medalion = new THSMedalion(PModeWin,FM,psource);
					 return Medalion;
		case  45: MileMarker = new THSMileMarker(PModeWin,FM,psource);
					 return MileMarker;
		case  46: Odometer = new THSOdometer(PModeWin,FM,psource);
					 return Odometer;
		case  47: Button4 = new TCasButton(PModeWin,FM,psource,this,125,b4rect_2,HSidButton4,true,'m');
					 return Button4;
		case  48: Travel = new THSTravel(PModeWin,FM,psource);
					 return Travel;
		case  89: Laps = new THSLaps(PModeWin,FM,psource);
					 return Laps;
		default : return new TSprite(PModeWin,FM,psource);
	 }
  }
  else
  {
	 FM.SetRamImmed();
	 switch (id)
	 {
		case  0 : return new TSprite(PModeWin,FM);
		case  1 : Reel1 = new THSReel(PModeWin,FM);
					 return Reel1;
		case  2 : Reel2 = new THSReel(PModeWin,FM);
					 return Reel2;
		case  3 : Reel3 = new THSReel(PModeWin,FM);
					 return Reel3;
		case  4 : Sounds =  new THSSound(PModeWin,FM);
					 return Sounds;
		case  5 : Value = new THSValue(PModeWin,FM);
					 return Value;
		case  6 : PayLine = new THSPayLine(PModeWin,FM);
					 return PayLine;
		case  7 : WinPaid = new THSWinPaid(PModeWin,FM);
					 return WinPaid;
		case  8 : Credits = new THSCredits(PModeWin,FM);
					 return Credits;
		case  9 : CoinsPlayed = new THSCoinsPlayed(PModeWin,FM);
					 return CoinsPlayed;
		case  10: Progressive = new THSProgressive(PModeWin,FM);
					 return Progressive;
		case  11: NamePlate1 = new THSNamePlate(PModeWin,FM);
					 return NamePlate1;
		case  12: BankCashDisplay = new THSCashDisplay(PModeWin,FM);
					 return BankCashDisplay;
		case  13: CoinPay = new THSCoinPay(PModeWin,FM);
					 return CoinPay;
		case  14: Button3 = new TCasButton(PModeWin,FM,this,125,b3rect,HSidButton3,true,'b');
					 return Button3;
		case  15: Button4 = new TCasButton(PModeWin,FM,this,125,b4rect,HSidButton4,true,'m');
					 return Button4;
		case  16: Button5 = new TCasButton(PModeWin,FM,this,125,b5rect,HSidButton5,true,'s');
					 return Button5;
		case  17: Button1 = new TCasButton(PModeWin,FM,this,100,b1rect,HSidButton1,true);
					 return Button1;
		case  18: Button2 = new TCasButton(PModeWin,FM,this,125,b2rect,HSidButton2,true);
					 return Button2;
		case  19: Button0 = new TCasButton(PModeWin,FM,this,125,b0rect,HSidButton0,true,'c');
					 return Button0;
		case  20: WinHighLight = new THSWinHighLight(PModeWin,FM);
					 return WinHighLight;
		case  21: return new TSprite(PModeWin,FM);//break;//return new (PModeWin,FM));
		case  22: Reel4 = new THSReel(PModeWin,FM);
					 return Reel4;
		case  23: Button6 = new TCasButton(PModeWin,FM,this,100,b6rect,HSidButton6,true);
					 return Button6;
		case  24: ZodiacSign = new THSZodiacSign(PModeWin,FM);
					 return ZodiacSign;
		case  25: MultiplierAnm = new THSMultiplier(PModeWin,FM);
					 return MultiplierAnm;
		case  26: Button4 = new TCasButton(PModeWin,FM,this,125,b4rect_2,HSidButton4,true,'m');
					 return Button4;
		case  33: Button4 = new TCasButton(PModeWin,FM,this,125,b4rect_2,HSidButton4,true,'m');
					 return Button4;
		case  34: Medalion = new THSMedalion(PModeWin,FM);
					 return Medalion;
		case  45: MileMarker = new THSMileMarker(PModeWin,FM);
					 return MileMarker;
		case  46: Odometer = new THSOdometer(PModeWin,FM);
					 return Odometer;
		case  47: Button4 = new TCasButton(PModeWin,FM,this,125,b4rect_2,HSidButton4,true,'m');
					 return Button4;
		case  48: Travel = new THSTravel(PModeWin,FM);
					 return Travel;
		case  89: Laps = new THSLaps(PModeWin,FM);
					 return Laps;
		default : return new TSprite(PModeWin,FM);
	 }
  }
}
//*******************************************************************
bool TCasinoHSGameLord::AddCredits(int16 addcredits)
{
  TMoney mikefuckup = addcredits;
  if(GetCash(activeplayer) >= double(mikefuckup*coinsize))
  {
	 credits += mikefuckup;
	 SubCash(activeplayer,mikefuckup*coinsize);
	 BankCashDisplay->SetNum(GetCash(activeplayer));
	 Credits->SetNum(credits);
	 Button0->ShowVoidUp();
  }
  else
  {
    string strtext = "You don't have enough money to add 50 credits";
    string strtitle = "Bankrupt";
    TBankruptMsgDlg *pbmd = new TBankruptMsgDlg(PModeWin,strtext,strtitle);
    pbmd->Execute();
    delete pbmd;
  }
  return true;
}
//*******************************************************************
void TCasinoHSGameLord::EnableButton(int16 button)
{
  switch(button)
  {
	 case 0  : Button0->Enabled = true;break;
	 case 1  : Button1->Enabled = true;break;
	 case 2  : Button2->Enabled = true;break;
	 case 3  : if(Button3){Button3->Enabled = true;}break;
	 case 4  : Button4->Enabled = true;break;
	 case 5  : if(Button5){Button5->Enabled = true;}break;
	 case 6  : Button6->Enabled = true;break;
  //	 case 7  : Button7->Enabled = true;break;
  }
}
//*******************************************************************
void TCasinoHSGameLord::DisEnableButton(int16 button)
{
  switch(button)
  {
	 case 0  : Button0->Enabled = false;break;
	 case 1  : Button1->Enabled = false;break;
	 case 2  : Button2->Enabled = false;break;
	 case 3  : if(Button3){Button3->Enabled = false;}break;
	 case 4  : Button4->Enabled = false;break;
	 case 5  : if(Button5){Button5->Enabled = false;}break;
	 case 6  : Button6->Enabled = false;break;
	// case 7  : Button7->Enabled = false;break;
  }
}
//*******************************************************************
void TCasinoHSGameLord::FreezeAllButtons()
{
  Button0->Freeze = true;
  Button1->Freeze = true;
  Button2->Freeze = true;
  if(Button3){Button3->Freeze = true;}
  Button4->Freeze = true;
  if(Button5){Button5->Freeze = true;}
  if(Button6 != NULL)
  {Button6->Freeze = true;}
}
//*******************************************************************
void TCasinoHSGameLord::UnFreezeAllButtons()
{
  Button0->Freeze = false;
  Button1->Freeze = false;
  Button2->Freeze = false;
  if(Button3){Button3->Freeze = false;}
  Button4->Freeze = false;
  if(Button5){Button5->Freeze = false;}
  if(Button6 != NULL)
  {Button6->Freeze = false;}
 // Button7->Freeze = false;
}
//*******************************************************************
void TCasinoHSGameLord::EnableAllButtons()
{
  Button0->Enabled = true;
  Button1->Enabled = true;
  Button2->Enabled = true;
  if(Button3){Button3->Enabled = true;}
  Button4->Enabled = true;
  if(Button5){Button5->Enabled = true;}
  if(Button6 != NULL)
  {Button6->Enabled = true;}
 // Button7->Enabled = true;
}
//*******************************************************************
void TCasinoHSGameLord::DisEnableAllButtons()
{
  Button0->Enabled = false;
  Button1->Enabled = false;
  Button2->Enabled = false;
  if(Button3){Button3->Enabled = false;}
  Button4->Enabled = false;
  if(Button5){Button5->Enabled = false;}
  if(Button6 != NULL)
  {Button6->Enabled = false;}
  //Button7->Enabled = false;
}
//*******************************************************************
#pragma argsused
bool TCasinoHSGameLord::Respond(int16 button,int16 info,void *pdata)
{
  if(info == -5)//gray button hit
  {
	 return true;
  }
  ButtonInfo = info;
  if(info != -1)
  {
	 switch(button)
	 {
	 case HSidButton0  : ButtonHit[HSidButton0]=true;break;
	 case HSidButton1  : ButtonHit[HSidButton1]=true;break;
	 case HSidButton2  : ButtonHit[HSidButton2]=true;break;
	 case HSidButton3  : if(coinsplayed < maxbet){ButtonHit[HSidButton3]=true;}break;
	 case HSidButton4  : if(coinsplayed < maxbet){ButtonHit[HSidButton4]=true;}break;
	 case HSidButton5  : ButtonHit[HSidButton5]=true;break;
	 case HSidButton6  : ButtonHit[HSidButton6]=true;break;
	// case HSidButton7  : ButtonHit[HSidButton7]=true;break;
	 default         : WaitOnButtonDown = false;break;
	 }
  }
  return true;
}
//*******************************************************************
void TCasinoHSGameLord::ButtonClear(int16 button)
{
  switch(button)
  {
	 case HSidButton0  : ButtonHit[HSidButton0]=false;break;
	 case HSidButton1  : ButtonHit[HSidButton1]=false;break;
	 case HSidButton2  : ButtonHit[HSidButton2]=false;GetFW()->CmShowMenu();break;
	 case HSidButton3  : ButtonHit[HSidButton3]=false;break;//PModeWin->ModeHelp();break;
	 case HSidButton4  : ButtonHit[HSidButton4]=false;break;
	 case HSidButton5  : ButtonHit[HSidButton5]=false;break;
	 case HSidButton6  : ButtonHit[HSidButton6]=false;break;
	 case HSidButton7  : ButtonHit[HSidButton7]=false;break;
	 default         : WaitOnButtonDown = false;break;
  }
  WaitOnButtonDown = false;
  return;
}
//*******************************************************************

