//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  hsintgld.cpp
//    Project Name:  HunSlots
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.3     7/7/97     M.Perry    original baseline
//  2.0    09/09/97    M.Perry    32-bit conversion.
//********************************************************************
#include "hsintgld.h"
#include "hsintmw.h"
#include "orespond.h"
#include "hsmenu.rh"
#include "casgfw.h"
//*******************************************************************
THSIntroGameLord::THSIntroGameLord(THSIntroModeWin *pmodewin,TFileMode fm)
:TCasinoGameLord(pmodewin,fm,ciACHSIntro,TMoney::did_0_00)//0,0)
{
  TFileMode splfm(SpriteListName,
                  TFileMode::fm_None,
                  TFileMode::fm_Immed,
                  FileMode.GetDirIndex());
  CreateAddSpriteList(splfm);
  TRect r(0,0,640,480);
  PBigResponder = new TResponder(pmodewin,1,r,1,this,true,'^');
  SetupSprites();
}
//*******************************************************************
THSIntroGameLord::~THSIntroGameLord()
{
  delete PBigResponder;
  PBigResponder = NULL;
}
//*******************************************************************
bool THSIntroGameLord::Respond(TResponder &responder)
{
  if (responder.GetResponseEvent() == reLUp ||
      responder.GetResponseEvent() == reRUp ||
      responder.GetResponseEvent() == reChar)
  {
//    GetFW()->SetFadeIn(false); // MRP - 06/27/99 - v2.3
    TOgleGameFrameWindow *pgfw = GetFW();
    if (pgfw != NULL)
    {
      pgfw->SetIntroUserSkipped();
    }
    PModeWin->PostCommandToFW(CM_GAME_HSLOTS_LOBBY);
    return true;
  }
  return false;
}
//*******************************************************************
void THSIntroGameLord::Update(dword fuc)
{
  if (fuc == EndFuc)
  {
//    GetCasMW()->GetCasGFW()->SetFadeIn(true); // MRP - 06/27/99 - v2.3
    PModeWin->PostCommandToFW(CM_GAME_HSLOTS_LOBBY );
  }
  TCasinoGameLord::Update(fuc);
}
//*******************************************************************
void THSIntroGameLord::SetupSprites()
{
  PSprite1 = GetSpritePtr(0);
  if (PSprite1 == NULL) {SpriteError("intro","ndx 0");}
  EndFuc = PSprite1->Get_FUC_Length();
  ActivateSpriteNow(PSprite1);
}
//*******************************************************************

