//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  hsjpsp.cpp
//    Project Name:  Casino
// Original Author:  Adam Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0      7/19/96   A.Krist      moved into cpp file.
//  2.0     09/04/97   M.Perry      32-bit conversion.
//********************************************************************
#include "hsjpsp.h"
#include "oanm.h"
//*******************************************************************
THSProgressive::THSProgressive(TOgleModeWindow *pmw,const TFileMode &NewFileMode)
:TSprite(pmw,NewFileMode)
{
  SetupAnms();
}
//*******************************************************************
THSProgressive::THSProgressive(TOgleModeWindow *pmw,const TFileMode &NewFileMode,void *psource)
:TSprite(pmw,NewFileMode,psource)
{
  SetupAnms();
}
//*******************************************************************
THSProgressive::~THSProgressive()
{
}
//*******************************************************************
void THSProgressive::SetupAnms()
{
	 for (int16 j=0;j<13;j++)
	 {
		PProgressive[j] = NULL;
		PProgressive[j] = GetAnm(int16(12-j));
		if (PProgressive[j] == NULL) {AnmError("Progressive","num",int16(12-j));}
		PProgressive[j]->CAD.ClearAutoStart();
		PProgressive[j]->CAD.ClearAutoStop();
		PProgressive[j]->CAD.SetDirStill();
	 }
}
//*******************************************************************
void THSProgressive::SetNum(TMoney prog)
{
  for(int j=0;j<13;j++)
  {
	 if (PProgressive[j] == NULL) {return;}
  }

  long num = (long)prog;
  int framesused=7,i=0;
  bool found = false;
  long million=0;
  long hunthou=0;
  long tenthou=0;
  long thousan=0;
  long hun=0;
  long ten=0;
  long one=0;

  for(i=0;i<13;i++)
  {
	 PProgressive[i]->CAD.SetX(PProgressive[i]->SAD.GetX());
	 PProgressive[i]->CAD.SetCurrentFrame(0);
	 PProgressive[i]->NoShow();
  }
  if( (num/1000) )
  {
	 PProgressive[6]->CAD.SetCurrentFrame(11);
	 PProgressive[6]->Show();
  }
  if( (num/1000000l) )
  {
	 PProgressive[10]->CAD.SetCurrentFrame(11);
	 PProgressive[10]->Show();
  }
  PProgressive[2]->CAD.SetCurrentFrame(12);
  PProgressive[2]->Show();
  if(prog < 0)
  {
	 PProgressive[4]->CAD.SetCurrentFrame(10);
	 PProgressive[4]->Show();
  }
  million = (num/1000000l) %10;
  if(!million && !found){framesused--;}else{found=TRUE;}

  hunthou = (num/100000l)  %10;
  if(!hunthou && !found){framesused--;}else{found=TRUE;}

  tenthou = (num/10000)   %10;
  if(!tenthou && !found){framesused--;}else{found=TRUE;}

  thousan = (num/1000)    %10;
  if(!thousan && !found)   {framesused--;}else{found=TRUE;}

  hun     = (num/100)     %10;
  if(!hun && !found)    {framesused--;}else{found=TRUE;}

  ten     = (num/10)      %10;
  if(!ten && !found)    {framesused--;}else{found=TRUE;}

  one     = (num  )       %10;
  if(!one && !found)    {framesused--;}else{found=TRUE;}

  PProgressive[0]->CAD.SetCurrentFrame(int16(prog.GetCents()%10));
  PProgressive[0]->Show();
  PProgressive[1]->CAD.SetCurrentFrame(int16(prog.GetCents()/10));
  PProgressive[1]->Show();
  PProgressive[3]->CAD.SetCurrentFrame(int16(one));
  PProgressive[3]->Show();

  if(framesused > 1)
  {
	 PProgressive[4]->CAD.SetCurrentFrame(int16(ten));
	 PProgressive[4]->Show();
  }
  else
  {
	 PProgressive[4]->CAD.SetCurrentFrame(10);
	 PProgressive[4]->Show();
  }

  if(framesused > 2)
  {
	 PProgressive[5]->CAD.SetCurrentFrame(int16(hun));
	 PProgressive[5]->Show();
  }
  else
  {
	 if(framesused == 2)
	 {
		PProgressive[5]->CAD.SetCurrentFrame(10);
		PProgressive[5]->Show();
	 }
  }

  if(framesused > 3)
  {
	 PProgressive[6]->CAD.SetCurrentFrame(11);
	 PProgressive[6]->Show();
  }
  else
  {
	 if(framesused == 3)
	 {
		PProgressive[6]->CAD.SetCurrentFrame(10);
		PProgressive[6]->Show();
	 }
  }
  if(framesused > 4)
  {
	 PProgressive[7]->CAD.SetCurrentFrame(int16(thousan));
	 PProgressive[7]->Show();
  }
  else
  {
	 if(framesused == 4)
	 {
		PProgressive[7]->CAD.SetCurrentFrame(int16(thousan));
		PProgressive[7]->Show();
		PProgressive[8]->CAD.SetCurrentFrame(10);
		PProgressive[8]->Show();
	 }
  }

  if(framesused > 5)
  {
	 PProgressive[8]->CAD.SetCurrentFrame(int16(tenthou));
	 PProgressive[8]->Show();
  }
  else
  {
	 if(framesused == 5)
	 {
		PProgressive[8]->CAD.SetCurrentFrame(int16(tenthou));
		PProgressive[8]->Show();
		PProgressive[9]->CAD.SetCurrentFrame(10);
		PProgressive[9]->Show();
	 }
  }

  if(framesused > 6)
  {
	 PProgressive[9]->CAD.SetCurrentFrame(int16(hunthou));
	 PProgressive[9]->Show();
	 PProgressive[10]->CAD.SetCurrentFrame(11);
	 PProgressive[10]->Show();
  }
  else
  {
	 if(framesused == 6)
	 {
		PProgressive[9]->CAD.SetCurrentFrame(int16(hunthou));
		PProgressive[9]->Show();
		PProgressive[10]->CAD.SetCurrentFrame(10);
		PProgressive[10]->Show();
	 }
  }

  if(framesused > 7)
  {
	 PProgressive[11]->CAD.SetCurrentFrame(int16(million));
	 PProgressive[11]->Show();
  }
  else
  {
	 if(framesused == 7)
	 {
		PProgressive[11]->CAD.SetCurrentFrame(int16(million));
		PProgressive[11]->Show();
		PProgressive[12]->CAD.SetCurrentFrame(10);
		PProgressive[12]->Show();

	 }
  }
  Update(GetAdjFUC());
}
//*******************************************************************
