//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  hsla1st.cpp
//    Project Name:  Casino
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     05/29/97   A. Krist    Original baseline
//  2.0     09/09/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "hsla1st.h"
#include "hslglord.h"
#include "hslplay.h"
#include "hslmw.h"
#include "hslwinst.h"
#include "orespond.h"
#include "oanm.h"
#include "owav.h"
//*******************************************************************
THSLAct1State::THSLAct1State(TCasinoHSLGameLord *pNewHSLLord)
:THSLLordState(pNewHSLLord)
{
	 SetRunOrder(ess_Execute,ess_Execute,ess_Execute,ess_Done);
	 WaitOnSpin = false;
	 pOwnerLord->winnerpaid = 0;
	 pOwnerLord->coinsplayed = 0;
	 StopReelTime = 0;
}
//*******************************************************************
THSLAct1State::~THSLAct1State()
{
}
//*******************************************************************
void THSLAct1State::ExecuteFirstTime()
{
  pOwnerLord->Clear();
  ExecuteWaiting = true;
  ExecuteStatus    = ess_Execute;
}
//*******************************************************************
void THSLAct1State::CreateSubState1()
{
  PActiveSubState = new THSLWinState(pOwnerLord);
}
//*******************************************************************
void THSLAct1State::EndSubState1()
{
  TState::EndSubState1();
  pOwnerLord->Clear();
  StopReelTime = 0;
  ExecuteWaiting = true;
}
//*******************************************************************
#pragma argsused
void THSLAct1State::HandlePostUpdate(dword NewFUC)
{
  if (pOwnerLord->ButtonHit[0])
  {
	 pOwnerLord->ButtonClear(HSLidButton0);
	 return;
  }
  if (pOwnerLord->ButtonHit[1])
  {
	 pOwnerLord->ButtonClear(HSLidCreate);
	 return;
  }
  if (pOwnerLord->ButtonHit[2])
  {
	 pOwnerLord->ButtonClear(HSLidBudPlay);
	 if(pOwnerLord->BetMax())
	 {
		int x = random(100);
		pOwnerLord->StartingPullFUC = pOwnerLord->GetAdjFUC();
		pOwnerLord->FUCPullLength = 0;
		if(x < 70)
      {
        pOwnerLord->ActivateSprite(pOwnerLord->spin1,pOwnerLord->StartingPullFUC,pOwnerLord->FUCPullLength);
      }
		else if(x < 90)
      {
        pOwnerLord->ActivateSprite(pOwnerLord->spin2,pOwnerLord->StartingPullFUC,pOwnerLord->FUCPullLength);
      }
		else
      {
        pOwnerLord->ActivateSprite(pOwnerLord->spin3,pOwnerLord->StartingPullFUC,pOwnerLord->FUCPullLength);
      }
		pOwnerLord->FreezeAllButtons();
		pOwnerLord->shutdownstate = 1;
		pOwnerLord->ChangeActivePlayersOk = false;
	 }
	 return;
  }
  if(pOwnerLord->StartingPullFUC != 0 && pOwnerLord->StartingPullFUC+16 == NewFUC)
  {
	 pOwnerLord->StartingPullFUC = 0;
	 pOwnerLord->Sounds->PlaySound(2);
	 pOwnerLord->Spin();
	 pOwnerLord->Sounds->PlaySound(0);
	 WaitOnSpin = true;
  }
  if(WaitOnSpin)
  {
	 if(StopReelTime == 2){pOwnerLord->SetReel();}
	 StopReelTime++;
	 if(StopReelTime == 7)
	 {
		  pOwnerLord->Sounds->PlaySound(3);
	 }
	 else if(StopReelTime == 10)
	 {
		pOwnerLord->Reel1->ShowReel();
		pOwnerLord->Sounds->Sounds[0]->Stop();
		pOwnerLord->Sounds->Sounds[2]->Stop();
	 }
	 else if(StopReelTime == 13)
	 {
		  pOwnerLord->Sounds->PlaySound(4);
	 }
	 else if(StopReelTime == 16)
	 {
		pOwnerLord->Reel2->ShowReel();
		pOwnerLord->Sounds->Sounds[3]->Stop();
	 }
	 else if(StopReelTime == 25)
	 {
		pOwnerLord->Reel3->ShowReel();
	 }
	 else if(StopReelTime == 27)
	 {
		  pOwnerLord->Sounds->Sounds[4]->Stop();
		  WaitOnSpin = false;
		  if ((long)pOwnerLord->coinsplayed)
		  {                                //????
			 ExecuteWaiting = false;
			 ExecuteStatus = ess_StartSubState1;
		  }
		  else
		  {
			 pOwnerLord->Clear();
			 StopReelTime = 0;
		  }
	 }
  }
}
//*******************************************************************
