 //*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  hslglord.cpp
//    Project Name:  Casino
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     10/11/95   A.Krist      Original baseline
//  2.0     09/09/97   M.Perry      32-bit conversion.
//*******************************************************************
#include "hslglord.h"
#include "hsllst.h"
#include "hsllmst.h"
#include "ostate.h"

#include <time.h>   //To Set Random Number Generator
#define  NUMBEROFPLAYERS 3
#include <stdlib.h> //For Random Number Generator
#include "hslmw.h"
#include "oskitcat.h"
#include "hslplay.h"
#include "expert.h"

#include "cplaymgr.h"
#include "casapp.h"
#include "owl\inputdia.h"
#include "osndmgr.h"
#include <checks.h>
#include "orespond.h"
#include "oanm.h"
#include "hs_cm.rh"
#include "cas_cm.rh"
#include "omdat.h"
#include "hsmsg.h"
//*******************************************************************
void TCasinoHSLGameLord::NotifyPlayerCashChange(int16 slotnum)
{
  if(GetCasPD(slotnum))
  {
	 BankCashDisplay->SetNum(GetCash(slotnum));
  }
}
//*******************************************************************
void TCasinoHSLGameLord::FreezeAllButtons()
{
  //MenuEscButton->Freeze       = true;
  BudPlayButton->Freeze = true;
  CreateButton->Freeze  = true;
  Responders[103]->Remove();
}
//*******************************************************************
void TCasinoHSLGameLord::UnFreezeAllButtons()
{
 // MenuEscButton->Freeze       = false;
  BudPlayButton->Freeze = false;
  CreateButton->Freeze  = false;
  Responders[103]->Add();
}
//*******************************************************************
void TCasinoHSLGameLord::Clear()
{
  PayOffSound = -1;
  BetMaxNumOfCredits = 0;
  BetMaxNumOfCoins = 0;
  WaitOnButtonDown = false;
  UnFreezeAllButtons();
  shutdownstate    = 0;
  ChangeActivePlayersOk = true;
  coinsplayed = 0;
  if(activeplayer > -1 &&
     (GetCash(activeplayer) >= double(coinsize*maxbet) && PlayBud))
  {
	 BudPlayButton->ShowVoidUp();
  }
  if(activeplayer > -1){BankCashDisplay->SetNum(GetCash(activeplayer));}
  WinHighLight->NoShow();
}
//*******************************************************************
void TCasinoHSLGameLord::BudInit()
{
  BudPlayButton->PButtonResponder->Add();
  BudPlayButton->ShowVoidUp();
  SetReel();
  Reel1->Show();
  Reel2->Show();
  Reel3->Show();
  coinsplayed = 0;
}
//*******************************************************************
void TCasinoHSLGameLord::BudDelete()
{
 // BudPlayButton->PButtonResponder->Remove();
  BudPlayButton->NoShow();
  Reel1->NoShow();
  Reel2->NoShow();
  Reel3->NoShow();
  WinHighLight->NoShow();
}
//*******************************************************************
TMoney TCasinoHSLGameLord::Winner()
{
#ifdef DEBUGSLOT
  int w,x,y;
  pMWin->SetUpdatePause();
  char cardnum1[5] = "";
  char cardnum2[5] = "";
  char cardnum3[5] = "";
  TInputDialog getcard1(pMWin,"","#",cardnum1,5);
  getcard1.Execute();
  TInputDialog getcard2(pMWin,"","#",cardnum2,5);
  getcard2.Execute();
  TInputDialog getcard3(pMWin,"","#",cardnum3,5);
  getcard3.Execute();
  pMWin->ClearUpdatePause();
  w = atoi(cardnum1);
  x = atoi(cardnum2);
  y = atoi(cardnum3);
  Reel1->SetNum(w);
  Reel2->SetNum(x);
  Reel3->SetNum(y);
  Reel1->ShowReel();
  Reel2->ShowReel();
  Reel3->ShowReel();
#endif
  winnerpaid = (double)PayOut();
  int16 session = GetCasPD(activeplayer)->SData.CurrentSession;
  TCasinoSData &curdata = GetCasPD(activeplayer)->SData;
  TCSSession &cursession = curdata.Sessions[session];

  if(winnerpaid == 0)
  {
	 curdata.Cumulative -= double(coinsplayed*coinsize);
	 cursession.CurrentLosingStreak++;
	 cursession.CurrentWinStreak = 0;
	 cursession.Losses++;
	 if(cursession.CurrentLosingStreak > cursession.LosingStreak)
	 {
		cursession.LosingStreak = cursession.CurrentLosingStreak;
	 }
	 if(GetCash(activeplayer) < cursession.PeakLoss)
	 {
		cursession.PeakLoss = (double)GetCash(activeplayer);
	 }
  }
  else
  {
	 curdata.Cumulative += double(winnerpaid*coinsize);
	 cursession.CurrentWinStreak++;
	 cursession.CurrentLosingStreak = 0;
	 cursession.Wins++;  //???
	 if(cursession.CurrentWinStreak > cursession.WinStreak)
	 {
		cursession.WinStreak = cursession.CurrentWinStreak;
	 }
	 if(winnerpaid*coinsize > cursession.LargestWin)
	 {
		cursession.LargestWin = double(winnerpaid*coinsize);
	 }
	 if((GetCash(activeplayer) - cursession.StartingCash) > cursession.PeakWin)
	 {
		cursession.PeakWin = double(GetCash(activeplayer) - cursession.StartingCash);
	 }
	 if(winnerpaid > 18)
	 {
		cursession.nHiPayoffs++;
	 }
	 else
	 {
      cursession.nLowPayoffs++;
	 }
  }
	 StartingWinFUC = GetAdjFUC();
	 FUCWinLength = 0;
	 switch(PayOffSound)
	 {
		case 0  : ActivateSprite(win1,StartingWinFUC,FUCWinLength);break;
		case 1  : ActivateSprite(win2,StartingWinFUC,FUCWinLength);break;
		case 2  : ActivateSprite(win3,StartingWinFUC,FUCWinLength);break;
		case 3  : ActivateSprite(win4,StartingWinFUC,FUCWinLength);break;
		case 4  : ActivateSprite(win5,StartingWinFUC,FUCWinLength);break;
	 }
  AddCash(activeplayer,winnerpaid);
  return winnerpaid;
}// winner
//*******************************************************************
int16 TCasinoHSLGameLord::BetMax()
{
  // start MRP 7/29/97
  if (GetCasPD(activeplayer) != NULL) {GetCasPD(activeplayer)->Cash.RoundTo5Cent();}

  if (GetCash(activeplayer) < 0.05)
  {
    BudPlayButton->ShowGray();
    if (GetCasPD(activeplayer)->CreditCheck())
    {
      TBankruptMsgDlg *pbmd = new TBankruptMsgDlg(PModeWin,strBrokeCreditYes,strBankruptTitle);
      pbmd->Execute();
      delete pbmd;
    }
    else
    {
      TBankruptMsgDlg *pbmd = new TBankruptMsgDlg(PModeWin,strBrokeCreditNo,strBankruptTitle);
      pbmd->Execute();
      delete pbmd;
    }
    return 0;
  }
  else if (GetCash(activeplayer) < double(coinsize * maxbet))
  {
    BudPlayButton->ShowGray();
    if (GetCasPD(activeplayer)->CreditCheck())
    {
      TBankruptMsgDlg *pbmd = new TBankruptMsgDlg(PModeWin,strPlayCheaperCreditYes,strBankruptTitle);
      pbmd->Execute();
      delete pbmd;
    }
    else
    {
      TBankruptMsgDlg *pbmd = new TBankruptMsgDlg(PModeWin,strPlayCheaperCreditNo,strBankruptTitle);
      pbmd->Execute();
      delete pbmd;
    }
    return 0;
  }
  // end MRP 7/29/97
  TMoney cp = coinsplayed;
  int session=0;
  session = GetCasPD(activeplayer)->SData.CurrentSession;

  if (GetCash(activeplayer) > double((maxbet - coinsplayed) * coinsize))
  {
	 SubCash(activeplayer,(maxbet - coinsplayed) * coinsize);
	 GetCasPD(activeplayer)->SData.Sessions[session].TotalBetsCash += double((maxbet-coinsplayed)*coinsize);
	 StartFUC = GetAdjFUC();
	 FUCLength = 0;
	 ActivateSprite(coinsplayedwav,StartFUC,FUCLength);
	 coinsplayed = maxbet;
	 //if(Button5){Button5->ShowVoidUp();}
	 BankCashDisplay->SetNum(GetCash(activeplayer));
  }
  return (coinsplayed);
}
//*******************************************************************
void TCasinoHSLGameLord::Spin()
{
  int session=0;
  session = GetCasPD(activeplayer)->SData.CurrentSession;
  GetCasPD(activeplayer)->SData.Sessions[session].HandsPlayed++;
  Reel1->Blur();
  Reel2->Blur();
  Reel3->Blur();
}
//*******************************************************************
void TCasinoHSLGameLord::SetReel()
{
  int16 w,x,y;
  w=int16(random(GetReelDataPtr()->Getint16(1,21)));
  x=int16(random(GetReelDataPtr()->Getint16(2,21)));
  y=int16(random(GetReelDataPtr()->Getint16(3,21)));

  for (int16 i1 = 0;i1 <= 21;i1++)
  {
    if (w <= GetReelDataPtr()->Getint16(1,i1))
    {
      w = i1;
      break;
    }
  }
  /*
  if(w<=GetReelDataPtr()->Getint16(1,0)){w=0;}
  else if(w<=GetReelDataPtr()->Getint16(1,1)){w=1;}
  else if(w<=GetReelDataPtr()->Getint16(1,2)){w=2;}
  else if(w<=GetReelDataPtr()->Getint16(1,3)){w=3;}
  else if(w<=GetReelDataPtr()->Getint16(1,4)){w=4;}
  else if(w<=GetReelDataPtr()->Getint16(1,5)){w=5;}
  else if(w<=GetReelDataPtr()->Getint16(1,6)){w=6;}
  else if(w<=GetReelDataPtr()->Getint16(1,7)){w=7;}
  else if(w<=GetReelDataPtr()->Getint16(1,8)){w=8;}
  else if(w<=GetReelDataPtr()->Getint16(1,9)){w=9;}
  else if(w<=GetReelDataPtr()->Getint16(1,10)){w=10;}
  else if(w<=GetReelDataPtr()->Getint16(1,11)){w=11;}
  else if(w<=GetReelDataPtr()->Getint16(1,12)){w=12;}
  else if(w<=GetReelDataPtr()->Getint16(1,13)){w=13;}
  else if(w<=GetReelDataPtr()->Getint16(1,14)){w=14;}
  else if(w<=GetReelDataPtr()->Getint16(1,15)){w=15;}
  else if(w<=GetReelDataPtr()->Getint16(1,16)){w=16;}
  else if(w<=GetReelDataPtr()->Getint16(1,17)){w=17;}
  else if(w<=GetReelDataPtr()->Getint16(1,18)){w=18;}
  else if(w<=GetReelDataPtr()->Getint16(1,19)){w=19;}
  else if(w<=GetReelDataPtr()->Getint16(1,20)){w=20;}
  else if(w<=GetReelDataPtr()->Getint16(1,21)){w=21;}
  */

  for (int16 i2 = 0;i2 <= 21;i2++)
  {
    if (x <= GetReelDataPtr()->Getint16(2,i2))
    {
      x = i2;
      break;
    }
  }

  /*
  if(x<=GetReelDataPtr()->Getint16(2,0)){x=0;}
  else if(x<=GetReelDataPtr()->Getint16(2,1)){x=1;}
  else if(x<=GetReelDataPtr()->Getint16(2,2)){x=2;}
  else if(x<=GetReelDataPtr()->Getint16(2,3)){x=3;}
  else if(x<=GetReelDataPtr()->Getint16(2,4)){x=4;}
  else if(x<=GetReelDataPtr()->Getint16(2,5)){x=5;}
  else if(x<=GetReelDataPtr()->Getint16(2,6)){x=6;}
  else if(x<=GetReelDataPtr()->Getint16(2,7)){x=7;}
  else if(x<=GetReelDataPtr()->Getint16(2,8)){x=8;}
  else if(x<=GetReelDataPtr()->Getint16(2,9)){x=9;}
  else if(x<=GetReelDataPtr()->Getint16(2,10)){x=10;}
  else if(x<=GetReelDataPtr()->Getint16(2,11)){x=11;}
  else if(x<=GetReelDataPtr()->Getint16(2,12)){x=12;}
  else if(x<=GetReelDataPtr()->Getint16(2,13)){x=13;}
  else if(x<=GetReelDataPtr()->Getint16(2,14)){x=14;}
  else if(x<=GetReelDataPtr()->Getint16(2,15)){x=15;}
  else if(x<=GetReelDataPtr()->Getint16(2,16)){x=16;}
  else if(x<=GetReelDataPtr()->Getint16(2,17)){x=17;}
  else if(x<=GetReelDataPtr()->Getint16(2,18)){x=18;}
  else if(x<=GetReelDataPtr()->Getint16(2,19)){x=19;}
  else if(x<=GetReelDataPtr()->Getint16(2,20)){x=20;}
  else if(x<=GetReelDataPtr()->Getint16(2,21)){x=21;}
  */

  for (int16 i3 = 0;i3 <= 21;i3++)
  {
    if (y <= GetReelDataPtr()->Getint16(3,i3))
    {
      y = i3;
      break;
    }
  }

  /*
  if(y<=GetReelDataPtr()->Getint16(3,0)){y=0;}
  else if(y<=GetReelDataPtr()->Getint16(3,1)){y=1;}
  else if(y<=GetReelDataPtr()->Getint16(3,2)){y=2;}
  else if(y<=GetReelDataPtr()->Getint16(3,3)){y=3;}
  else if(y<=GetReelDataPtr()->Getint16(3,4)){y=4;}
  else if(y<=GetReelDataPtr()->Getint16(3,5)){y=5;}
  else if(y<=GetReelDataPtr()->Getint16(3,6)){y=6;}
  else if(y<=GetReelDataPtr()->Getint16(3,7)){y=7;}
  else if(y<=GetReelDataPtr()->Getint16(3,8)){y=8;}
  else if(y<=GetReelDataPtr()->Getint16(3,9)){y=9;}
  else if(y<=GetReelDataPtr()->Getint16(3,10)){y=10;}
  else if(y<=GetReelDataPtr()->Getint16(3,11)){y=11;}
  else if(y<=GetReelDataPtr()->Getint16(3,12)){y=12;}
  else if(y<=GetReelDataPtr()->Getint16(3,13)){y=13;}
  else if(y<=GetReelDataPtr()->Getint16(3,14)){y=14;}
  else if(y<=GetReelDataPtr()->Getint16(3,15)){y=15;}
  else if(y<=GetReelDataPtr()->Getint16(3,16)){y=16;}
  else if(y<=GetReelDataPtr()->Getint16(3,17)){y=17;}
  else if(y<=GetReelDataPtr()->Getint16(3,18)){y=18;}
  else if(y<=GetReelDataPtr()->Getint16(3,19)){y=19;}
  else if(y<=GetReelDataPtr()->Getint16(3,20)){y=20;}
  else if(y<=GetReelDataPtr()->Getint16(3,21)){y=21;}
  */

  Reel1->SetNum(w);
  Reel2->SetNum(x);
  Reel3->SetNum(y);
}
//*******************************************************************
TMoney TCasinoHSLGameLord::PayOut()
{
  int s0=0,s1=0,s2=0;
  s0 = GetReelDataPtr()->Getint16(11,(Reel1->GetCurrentAnmFrame(1)));
  s1 = GetReelDataPtr()->Getint16(11,(Reel2->GetCurrentAnmFrame(1)));
  s2 = GetReelDataPtr()->Getint16(11,(Reel3->GetCurrentAnmFrame(1)));
  if(s0 == 3 && s1 == 3 && s2 == 3)
  {
	 PayOffSound = 4;
	 return 5000;
  }
  if((s0 == 2) && (s1 == 2) && (s2 == 2))
  {
	 PayOffSound = 3;
	 return 100;
  }
  if((s0 == 1) && (s1 == 1) && (s2 == 1))
  {
	 PayOffSound = 2;
	 return 25;
  }
  if((s0 == 1 && s1 == 1) || (s1 == 1 && s2 == 1) || (s2 == 1 && s0 == 1))
  {
	 PayOffSound = 1;
	 return 10;
  }
  if((s0 == 1) || (s1 == 1) || (s2 == 1))
  {
	 PayOffSound = 0;
	 return 5;
  }
  return 0;
}
//*******************************************************************
#pragma argsused
bool TCasinoHSLGameLord::Respond(int16 button,int16 info,void *pdata)
{
  ButtonInfo = info;
  if(info != -1)
  {
	 switch(button)
	 {
	 case HSLidButton0  : ButtonHit[0]=true;break;
	 case HSLidCreate   : ButtonHit[1]=true;break;
	 case HSLidBudPlay  : ButtonHit[2]=true;break;
	 default            : WaitOnButtonDown = false;break;
	 }
  }
  return true;
}
//*******************************************************************
void TCasinoHSLGameLord::ButtonClear(int16 button)
{
  switch(button)
  {
	 case HSLidButton0  : ButtonHit[0]=false;GetFW()->CmShowMenu();break;
	 case HSLidCreate   : ButtonHit[1]=false;
								 PModeWin->PostCommandToFW(CM_FILEGAMBLERMANAGEMENT);break;
	 case HSLidBudPlay  : ButtonHit[2]=false;break;
	 default         : WaitOnButtonDown = false;break;
  }
  WaitOnButtonDown = false;
  return;
}
//*******************************************************************
bool TCasinoHSLGameLord::Respond(TResponder &responder)
{
  if (PState == NULL) {return true;}
  if((responder.GetResponseEvent() == reEnterArea ||
		responder.GetResponseEvent() == reLeaveArea  ) &&
		responder.GetID() != HSLidSpeed && responder.GetID() != HSLidButton0)
  {
	 if(responder.GetResponseEvent() == reEnterArea)
	 {
		switch (responder.GetID())
		{
		  case HSLidHotSpot1            :  MessageDisplay->ShowLobbyMessage(0);CurrentProgressiveDisplayed=0;break;
		  case HSLidHotSpot2            :  MessageDisplay->ShowLobbyMessage(1);CurrentProgressiveDisplayed=5;break;
		  case HSLidHotSpot3            :  MessageDisplay->ShowLobbyMessage(2);CurrentProgressiveDisplayed=3;break;
		  case HSLidHotSpot4            :  MessageDisplay->ShowLobbyMessage(3);CurrentProgressiveDisplayed=1;break;
		  case HSLidHotSpot5            :  MessageDisplay->ShowLobbyMessage(4);CurrentProgressiveDisplayed=6;break;
		  case HSLidHotSpot6            :  MessageDisplay->ShowLobbyMessage(5);CurrentProgressiveDisplayed=4;break;
		  case HSLidHotSpot7            :  MessageDisplay->ShowLobbyMessage(6);break;
		  case HSLidHotSpot8            :  MessageDisplay->ShowLobbyMessage(7);CurrentProgressiveDisplayed=2;break;
		  case HSLidHotSpot9            :  MessageDisplay->ShowLobbyMessage(8);break;
		  case HSLidHotSpot10           :  MessageDisplay->ShowLobbyMessage(9);break;
		  case HSLidHotSpot11           :  MessageDisplay->ShowLobbyMessage(10);break;
		  case HSLidHotSpot12           :  MessageDisplay->ShowLobbyMessage(11);break;
		  case HSLidHotSpot13           :  MessageDisplay->ShowLobbyMessage(12);break;
		  case HSLidHotSpot14           :  MessageDisplay->ShowLobbyMessage(13);break;
		  case HSLidHotSpot15           :  MessageDisplay->ShowLobbyMessage(14);break;
		  case HSLidHotSpot16           :  MessageDisplay->ShowLobbyMessage(15);break;
		  case HSLidHotSpot17           :  MessageDisplay->ShowLobbyMessage(16);break;
		  case HSLidHotSpot18           :  MessageDisplay->ShowLobbyMessage(17);break;
		  case HSLidHotSpot19           :  MessageDisplay->ShowLobbyMessage(18);break;
		  case HSLidHotSpot20           :  MessageDisplay->ShowLobbyMessage(19);break;
		  case HSLidHotSpot21           :  MessageDisplay->ShowLobbyMessage(20);break;
		  case HSLidHotSpot22           :  MessageDisplay->ShowLobbyMessage(21);break;
		  case HSLidHotSpot23           :  MessageDisplay->ShowLobbyMessage(22);break;
		  case HSLidHotSpot24           :  MessageDisplay->ShowLobbyMessage(23);break;
		  case HSLidHotSpot25           :  MessageDisplay->ShowLobbyMessage(24);break;
		  case HSLidHotSpot26           :  MessageDisplay->ShowLobbyMessage(25);break;
		  case HSLidHotSpot27           :  MessageDisplay->ShowLobbyMessage(26);break;
		  case HSLidHotSpot28           :  MessageDisplay->ShowLobbyMessage(27);break;
		  case HSLidHotSpot29           :  MessageDisplay->ShowLobbyMessage(28);break;
		  case HSLidHotSpot30           :  MessageDisplay->ShowLobbyMessage(29);break;
		  case HSLidHotSpot31           :  MessageDisplay->ShowLobbyMessage(30);break;
		  case HSLidHotSpot32           :  MessageDisplay->ShowLobbyMessage(31);break;
		  case HSLidHotSpot33           :  MessageDisplay->ShowLobbyMessage(32);break;
		  case HSLidHotSpot34           :  MessageDisplay->ShowLobbyMessage(33);break;
		  case HSLidHotSpot35           :  MessageDisplay->ShowLobbyMessage(34);break;
		  case HSLidHotSpot36           :  MessageDisplay->ShowLobbyMessage(35);break;
		  case HSLidHotSpot37           :  MessageDisplay->ShowLobbyMessage(36);break;
		  case HSLidHotSpot38           :  MessageDisplay->ShowLobbyMessage(37);break;
		  case HSLidHotSpot39           :  MessageDisplay->ShowLobbyMessage(38);break;
		  case HSLidHotSpot40           :  MessageDisplay->ShowLobbyMessage(39);break;
		  case HSLidHotSpot41           :  MessageDisplay->ShowLobbyMessage(40);break;
		  case HSLidHotSpot42           :  MessageDisplay->ShowLobbyMessage(41);break;
		  case HSLidHotSpot43           :  MessageDisplay->ShowLobbyMessage(42);break;
		  case HSLidHotSpot44           :  MessageDisplay->ShowLobbyMessage(43);break;
		  case HSLidHotSpot45           :  MessageDisplay->ShowLobbyMessage(44);break;
		  case HSLidHotSpot46           :  MessageDisplay->ShowLobbyMessage(45);break;
		  case HSLidHotSpot47           :  MessageDisplay->ShowLobbyMessage(46);break;
		  case HSLidHotSpot48           :  MessageDisplay->ShowLobbyMessage(47);break;
		  case HSLidHotSpot49           :  MessageDisplay->ShowLobbyMessage(48);break;
		  case HSLidHotSpot50           :  MessageDisplay->ShowLobbyMessage(49);break;
		  case HSLidHotSpot51           :  MessageDisplay->ShowLobbyMessage(50);break;
		  case HSLidHotSpot52           :  MessageDisplay->ShowLobbyMessage(51);break;
		  case HSLidHotSpot53           :  MessageDisplay->ShowLobbyMessage(52);break;
		  case HSLidHotSpot54           :  MessageDisplay->ShowLobbyMessage(53);break;
		  case HSLidHotSpot55           :  MessageDisplay->ShowLobbyMessage(54);break;
		  case HSLidHotSpot56           :  MessageDisplay->ShowLobbyMessage(55);break;
		  case HSLidHotSpot57           :  MessageDisplay->ShowLobbyMessage(56);break;
		  case HSLidHotSpot58           :  MessageDisplay->ShowLobbyMessage(57);break;
		  case HSLidHotSpot59           :  MessageDisplay->ShowLobbyMessage(58);break;
		  case HSLidHotSpot60           :  MessageDisplay->ShowLobbyMessage(59);break;
		  case HSLidHotSpot61           :  MessageDisplay->ShowLobbyMessage(60);break;
		  case HSLidHotSpot62           :  MessageDisplay->ShowLobbyMessage(61);break;
		  case HSLidHotSpot63           :  MessageDisplay->ShowLobbyMessage(62);break;
		  case HSLidHotSpot64           :  MessageDisplay->ShowLobbyMessage(63);break;
		  case HSLidHotSpot65           :  MessageDisplay->ShowLobbyMessage(64);break;
		  case HSLidHotSpot66           :  MessageDisplay->ShowLobbyMessage(65);break;
		  case HSLidHotSpot67           :  MessageDisplay->ShowLobbyMessage(66);break;
		  case HSLidHotSpot68           :  MessageDisplay->ShowLobbyMessage(67);break;
		  case HSLidHotSpot69           :  MessageDisplay->ShowLobbyMessage(68);break;
		  case HSLidHotSpot70           :  MessageDisplay->ShowLobbyMessage(69);break;
		  case HSLidHotSpot71           :  MessageDisplay->ShowLobbyMessage(70);break;
		  case HSLidHotSpot72           :  MessageDisplay->ShowLobbyMessage(71);break;
		  case HSLidHotSpot73           :  MessageDisplay->ShowLobbyMessage(72);break;
		  case HSLidHotSpot74           :  MessageDisplay->ShowLobbyMessage(73);break;
		  case HSLidHotSpot75           :  MessageDisplay->ShowLobbyMessage(74);break;
		  case HSLidHotSpot76           :  MessageDisplay->ShowLobbyMessage(75);break;
		  case HSLidHotSpot77           :  MessageDisplay->ShowLobbyMessage(76);break;
		  case HSLidHotSpot78           :  MessageDisplay->ShowLobbyMessage(77);break;
		  case HSLidHotSpot79           :  MessageDisplay->ShowLobbyMessage(78);break;
		  case HSLidHotSpot80           :  MessageDisplay->ShowLobbyMessage(79);break;
		  case HSLidHotSpot81           :  MessageDisplay->ShowLobbyMessage(80);break;
		  case HSLidHotSpot82           :  MessageDisplay->ShowLobbyMessage(81);break;
		  case HSLidHotSpot83           :  MessageDisplay->ShowLobbyMessage(82);break;
		  case HSLidHotSpot84           :  MessageDisplay->ShowLobbyMessage(83);break;
		  case HSLidHotSpot85           :  MessageDisplay->ShowLobbyMessage(84);break;
		  case HSLidHotSpot86           :  MessageDisplay->ShowLobbyMessage(85);break;
		  case HSLidHotSpot87           :  MessageDisplay->ShowLobbyMessage(86);break;
		  case HSLidHotSpot88           :  MessageDisplay->ShowLobbyMessage(87);break;
		  case HSLidHotSpot89           :  MessageDisplay->ShowLobbyMessage(88);break;
		  case HSLidHotSpot90           :  MessageDisplay->ShowLobbyMessage(89);break;
		  case HSLidHotSpot91           :  MessageDisplay->ShowLobbyMessage(90);break;
		  case HSLidHotSpot92           :  MessageDisplay->ShowLobbyMessage(91);break;
		  case HSLidHotSpot93           :  MessageDisplay->ShowLobbyMessage(92);break;
		  case HSLidHotSpot94           :  MessageDisplay->ShowLobbyMessage(93);break;
		  case HSLidHotSpot95           :  MessageDisplay->ShowLobbyMessage(94);break;
		  case HSLidHotSpot96           :  MessageDisplay->ShowLobbyMessage(95);break;
		  case HSLidHotSpot97           :  MessageDisplay->ShowLobbyMessage(96);break;
		  case HSLidHotSpot98           :  MessageDisplay->ShowLobbyMessage(97);break;
		  case HSLidHotSpot99           :  MessageDisplay->ShowLobbyMessage(98);break;
		  case HSLidHotSpot100          :  MessageDisplay->ShowLobbyMessage(99);break;
		  case HSLidHotSpot101          :  MessageDisplay->ShowLobbyMessage(100);break;
	  //	  case HSLidHotSpot2           :  MessageDisplay->ShowLobbyMessage(1);break;
		  default                    :  break;
		}
	 }
	 else
	 {MessageDisplay->ShowLobbyMessage(101);}
	 if(responder.GetResponseEvent() == reLeaveArea)
	 {
		GetOgleApp()->GetCursorMgr()->SetCursor(ctAction,0,0);
		return true;
	 }
	 return true;
  }
  else
  {
	 int command = 0;
	 switch (responder.GetID())
	 {
	 case HSLidHotSpot1  : command = CM_GAME_HSLOTS_MONKEYMADNESS_5CP;break;
	 case HSLidHotSpot2  : command = CM_GAME_HSLOTS_SUPERJACKPOT_10P;break;
	 case HSLidHotSpot3  : command = CM_GAME_HSLOTS_ALIENINVASION_25CP;break;
	 case HSLidHotSpot4  : command = CM_GAME_HSLOTS_MONKEYMADNESS_10CP;break;
	 case HSLidHotSpot5  : command = CM_GAME_HSLOTS_SUPERJACKPOT_100P;break;
	 case HSLidHotSpot6  : command = CM_GAME_HSLOTS_ALIENINVASION_1P;break;
	 case HSLidHotSpot7  : command = CM_GAME_HSLOTS_ROCKROLL_1000;break;
	 case HSLidHotSpot8  : command = CM_GAME_HSLOTS_MONKEYMADNESS_25CP;break;
	 case HSLidHotSpot9  : command = CM_GAME_HSLOTS_POOLSHARK_500;break;
	 case HSLidHotSpot10 : command = CM_GAME_HSLOTS_GOLDRUSH_500;break;
	 case HSLidHotSpot11 : command = CM_GAME_HSLOTS_HOTREELS_1000;break;
	 case HSLidHotSpot12 : command = CM_GAME_HSLOTS_SILVERSAFARI_1000;break;
	 case HSLidHotSpot13 : command = CM_GAME_HSLOTS_LIGHTNINGSTRIKES_1000;break;
	 case HSLidHotSpot14 : command = CM_GAME_HSLOTS_TREASURESATLANTIS_50;break;
	 case HSLidHotSpot15 : command = CM_GAME_HSLOTS_GOLDRUSH_1000;break;
	 case HSLidHotSpot16 : command = CM_GAME_HSLOTS_TREASUREHAUNT_50;break;
	 case HSLidHotSpot17 : command = CM_GAME_HSLOTS_ROCKROLL_100;break;
	 case HSLidHotSpot18 : command = CM_GAME_HSLOTS_LIGHTNINGSTRIKES_50;break;
	 case HSLidHotSpot19 : command = CM_GAME_HSLOTS_SILVERSAFARI_100;break;
	 case HSLidHotSpot20 : command = CM_GAME_HSLOTS_POOLSHARK_50;break;
	 case HSLidHotSpot21 : command = CM_GAME_HSLOTS_LIGHTNINGSTRIKES_100;break;
	 case HSLidHotSpot22 : command = CM_GAME_HSLOTS_GOLDRUSH_50;break;
	 case HSLidHotSpot23 : command = CM_GAME_HSLOTS_ROADRALLYII_100;break;
	 case HSLidHotSpot24 : command = CM_GAME_HSLOTS_ROCKROLL_50;break;
	 case HSLidHotSpot25 : command = CM_GAME_HSLOTS_HOTREELS_100;break;
	 case HSLidHotSpot26 : command = CM_GAME_HSLOTS_QUESTGOLD_25;break;
	 case HSLidHotSpot27 : command = CM_GAME_HSLOTS_SOUTHERNCROSS_25;break;
	 case HSLidHotSpot28 : command = CM_GAME_HSLOTS_POOLSHARK_25;break;
	 case HSLidHotSpot29 : command = CM_GAME_HSLOTS_POOLSHARK_10;break;
	 case HSLidHotSpot30 : command = CM_GAME_HSLOTS_SHOOTMOON_10;break;
	 case HSLidHotSpot31 : command = CM_GAME_HSLOTS_FRUITLOOT_10;break;
	 case HSLidHotSpot32 : command = CM_GAME_HSLOTS_SOUTHERNCROSS_10;break;
	 case HSLidHotSpot33 : command = CM_GAME_HSLOTS_TREASURESATLANTIS_10;break;
	 case HSLidHotSpot34 : command = CM_GAME_HSLOTS_TYCOONSTRUST_25;break;
	 case HSLidHotSpot35 : command = CM_GAME_HSLOTS_TEXASTWISTER_25;break;
	 case HSLidHotSpot36 : command = CM_GAME_HSLOTS_ROADRALLYII_25C;break;
	 case HSLidHotSpot37 : command = CM_GAME_HSLOTS_SHOOTMOON_25C;break;
	 case HSLidHotSpot38 : command = CM_GAME_HSLOTS_HOTREELS_25C;break;
	 case HSLidHotSpot39 : command = CM_GAME_HSLOTS_SWAMPMUSIC_25C;break;
	 case HSLidHotSpot40 : command = CM_GAME_HSLOTS_QUESTGOLD_25C;break;
	 case HSLidHotSpot41 : command = CM_GAME_HSLOTS_ZODIACATTACKI_10C;break;
	 case HSLidHotSpot42 : command = CM_GAME_HSLOTS_WINNERSCIRCLE_10C;break;
	 case HSLidHotSpot43 : command = CM_GAME_HSLOTS_TREASUREHAUNT_10C;break;
	 case HSLidHotSpot44 : command = CM_GAME_HSLOTS_QUESTGOLD_10C;break;
	 case HSLidHotSpot45 : command = CM_GAME_HSLOTS_RAGSRICHES_10C;break;
	 case HSLidHotSpot46 : command = CM_GAME_HSLOTS_CASHQUEST_5C;break;
	 case HSLidHotSpot47 : command = CM_GAME_HSLOTS_TREASUREHAUNT_5C;break;
	 case HSLidHotSpot48 : command = CM_GAME_HSLOTS_TREASURESATLANTIS_5C;break;
	 case HSLidHotSpot49 : command = CM_GAME_HSLOTS_BIRTHDAYBASH_5C;break;
	 case HSLidHotSpot50 : command = CM_GAME_HSLOTS_RAGSRICHES_5C;break;
	 case HSLidHotSpot51 : command = CM_GAME_HSLOTS_WINNERSCIRCLE_5C;break;
	 case HSLidHotSpot52 : command = CM_GAME_HSLOTS_ZODIACATTACKIII_10C;break;
	 case HSLidHotSpot53 : command = CM_GAME_HSLOTS_POOLSHARK_5;break;
	 case HSLidHotSpot54 : command = CM_GAME_HSLOTS_FRUITLOOT_5;break;
	 case HSLidHotSpot55 : command = CM_GAME_HSLOTS_ROADRALLYII_5;break;
	 case HSLidHotSpot56 : command = CM_GAME_HSLOTS_SILVERSAFARI_5;break;
	 case HSLidHotSpot57 : command = CM_GAME_HSLOTS_SHOOTMOON_1;break;
	 case HSLidHotSpot58 : command = CM_GAME_HSLOTS_SOUTHERNCROSS_1;break;
	 case HSLidHotSpot59 : command = CM_GAME_HSLOTS_FRUITLOOT_1;break;
	 case HSLidHotSpot60 : command = CM_GAME_HSLOTS_QUESTGOLD_1;break;
	 case HSLidHotSpot61 : command = CM_GAME_HSLOTS_ROADRALLYII_1;break;
	 case HSLidHotSpot62 : command = CM_GAME_HSLOTS_HOTREELS_1;break;
	 case HSLidHotSpot63 : command = CM_GAME_HSLOTS_TYCOONSTRUST_1;break;
	 case HSLidHotSpot64 : command = CM_GAME_HSLOTS_THUNDERALLEY_5;break;
	 case HSLidHotSpot65 : command = CM_GAME_HSLOTS_HOTREELS_5;break;
	 case HSLidHotSpot66 : command = CM_GAME_HSLOTS_TYCOONSTRUST_5;break;
	 case HSLidHotSpot67 : command = CM_GAME_HSLOTS_HOTREELS_10;break;
	 case HSLidHotSpot68 : command = CM_GAME_HSLOTS_TEXASTWISTER_10;break;
	 case HSLidHotSpot69 : command = CM_GAME_HSLOTS_TYCOONSTRUST_10;break;
	 case HSLidHotSpot70 : command = CM_GAME_HSLOTS_CASHQUEST_5;break;
	 case HSLidHotSpot71 : command = CM_GAME_HSLOTS_LIGHTNINGSTRIKES_5;break;
	 case HSLidHotSpot72 : command = CM_GAME_HSLOTS_TEXASTWISTER_5;break;
	 case HSLidHotSpot73 : command = CM_GAME_HSLOTS_SWAMPMUSIC_10;break;
	 case HSLidHotSpot74 : command = CM_GAME_HSLOTS_LIGHTNINGSTRIKES_25C;break;
	 case HSLidHotSpot75 : command = CM_GAME_HSLOTS_TREASUREHAUNT_25C;break;
	 case HSLidHotSpot76 : command = CM_GAME_HSLOTS_BIRTHDAYBASH_25C;break;
	 case HSLidHotSpot77 : command = CM_GAME_HSLOTS_WINNERSCIRCLE_25C;break;
	 case HSLidHotSpot78 : command = CM_GAME_HSLOTS_CASHQUEST_25C;break;
	 case HSLidHotSpot79 : command = CM_GAME_HSLOTS_THUNDERALLEY_25C;break;
	 case HSLidHotSpot80 : command = CM_GAME_HSLOTS_ZODIACATTACKIII_25C;break;
	 case HSLidHotSpot81 : command = CM_GAME_HSLOTS_TREASURESATLANTIS_25C;break;
	 case HSLidHotSpot82 : command = CM_GAME_HSLOTS_RAGSRICHES_25C;break;
	 case HSLidHotSpot83 : command = CM_GAME_HSLOTS_ZODIACATTACKII_25C;break;
	 case HSLidHotSpot84 : command = CM_GAME_HSLOTS_ROCKROLL_25C;break;
	 case HSLidHotSpot85 : command = CM_GAME_HSLOTS_ZODIACATTACKI_25C;break;
	 case HSLidHotSpot86 : command = CM_GAME_HSLOTS_TEXASTWISTER_25C;break;
	 case HSLidHotSpot87 : command = CM_GAME_HSLOTS_ROCKROLL_1;break;
	 case HSLidHotSpot88 : command = CM_GAME_HSLOTS_TREASURESATLANTIS_1;break;
	 case HSLidHotSpot89 : command = CM_GAME_HSLOTS_ZODIACATTACKI_1;break;
	 case HSLidHotSpot90 : command = CM_GAME_HSLOTS_THUNDERALLEY_1;break;
	 case HSLidHotSpot91 : command = CM_GAME_HSLOTS_ZODIACATTACKII_1;break;
	 case HSLidHotSpot92 : command = CM_GAME_HSLOTS_RAGSRICHES_1;break;
	 case HSLidHotSpot93 : command = CM_GAME_HSLOTS_ZODIACATTACKIII_1;break;
	 case HSLidHotSpot94 : command = CM_GAME_HSLOTS_SWAMPMUSIC_1;break;
	 case HSLidHotSpot95 : command = CM_GAME_HSLOTS_SILVERSAFARI_1;break;
	 case HSLidHotSpot96 : command = CM_GAME_HSLOTS_TEXASTWISTER_1;break;
	 case HSLidHotSpot97 : command = CM_GAME_HSLOTS_LIGHTNINGSTRIKES_1;break;
	 case HSLidHotSpot98 : command = CM_GAME_HSLOTS_CASHQUEST_1;break;
	 case HSLidHotSpot99 : command = CM_GAME_HSLOTS_BIRTHDAYBASH_1;break;
	 case HSLidHotSpot100 : command = CM_GAME_HSLOTS_SOUTHERNCROSS_5;break;
	 case HSLidHotSpot101 : command = CM_GAME_HSLOTS_ZODIACATTACKII_10C;break;
	 case HSLidHotSpot102 : /* Volcano slot "Bud" */;return false;
	 case HSLidSpeed      :  return true;
    case HSLidCredit    : if(responder.GetResponseEvent() == reLUp)
								  {
									 PModeWin->PostCommandToFW(CM_OPTIONS_LOBBY_CASINOCREDIT);
								  }
								  return true;
	 default           :  return true;
	 }
    if (command != 0)
    {
		PModeWin->PostCommandToFW(command);
    }
    return true;
  }
}
//*******************************************************************

