//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  hslordst.cpp
//    Project Name:  Ogle
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     05/01/97   A. Krist    Original baseline
//  2.0     09/04/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "hslordst.h"
#include "hsglord.h"

//*******************************************************************
THSLordState::THSLordState(TCasinoHSGameLord *pNewHSLord)
{
  pOwnerLord = pNewHSLord;
}
//*******************************************************************
THSLordState::~THSLordState()
{
}
//*******************************************************************
void THSLordState::HandleUpdate(dword NewFUC)
{
  if (pOwnerLord->SubGameType == cslMonkeyMadness ||
		pOwnerLord->SubGameType == cslAlienInvasion ||
		pOwnerLord->SubGameType == cslSuperJackpot   )
  {
	if(NewFUC%3600 == 0)
	{
	  if(random(300) == 1) {pOwnerLord->progressive = pOwnerLord->ProgressiveBaseAmount;}
	}
	if(pOwnerLord->progressive >= pOwnerLord->ProgressiveMaxAmount) {pOwnerLord->progressive = pOwnerLord->ProgressiveBaseAmount;}
	pOwnerLord->progressive += pOwnerLord->ProgressiveIncrement;
	pOwnerLord->Progressive->SetNum(pOwnerLord->progressive);
  }
}
//*******************************************************************
bool THSLordState::NamePlate(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((THSLordState *)PActiveSubState)->NamePlate(responder);
  }
  else
  {
	 return HandleNamePlate(responder);
  }
}
//*******************************************************************
bool THSLordState::SpeedClick(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((THSLordState *)PActiveSubState)->SpeedClick(responder);
  }
  else
  {
	 return HandleSpeedClick(responder);
  }
}
//*******************************************************************
bool THSLordState::AddCoin(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((THSLordState *)PActiveSubState)->AddCoin(responder);
  }
  else
  {
	 return HandleAddCoin(responder);
  }
}
//*******************************************************************

