//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  hslwhsp.cpp
//    Project Name:  Casino
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     9/26/95    A.Krist      original baseline
//  2.0    09/09/97    M.Perry      32-bit conversion.
//********************************************************************
#include "hslwhsp.h"
#include "oanm.h"
#include "owav.h"
//*******************************************************************
THSLWinHighLight::THSLWinHighLight(TOgleModeWindow *pmw,const TFileMode &NewFileMode)
:TSprite(pmw,NewFileMode)
{
  SetToManual();
  SetupAnms();
  CurrentSound = 0;
  WaveStarted = false;
}
//*******************************************************************
THSLWinHighLight::THSLWinHighLight(TOgleModeWindow *pmw,const TFileMode &NewFileMode,void *psource)
:TSprite(pmw,NewFileMode,psource)
{
  SetToManual();
  SetupAnms();
  CurrentSound = 0;
  WaveStarted = false;
}
//*******************************************************************
THSLWinHighLight::~THSLWinHighLight()
{
}
//********************************************************************
void THSLWinHighLight::StopAll()
{
  PWaves[CurrentSound]->Stop();
}
//********************************************************************
bool THSLWinHighLight::IsWaveStopped()
{
  if(PWaves[CurrentSound]->GetStarted() && !(PWaves[CurrentSound]->GetStopped()))
  {
	 return false;
  }
  return true;
}
//*******************************************************************
void THSLWinHighLight::PlaySound(int16 sound)
{
  if(PWaves[sound])
  {
	 PWaves[sound]->Start();
	 Update(GetAdjFUC());
	 CurrentSound = sound;
	 WaveStarted = true;
	 PTitle->CAD.SetCurrentFrame(sound);
	 PTitle->Show();
  }
}
//*******************************************************************
void THSLWinHighLight::SetupAnms()
{
	PTitle = GetAnm(0);
	if (PTitle == NULL) {AnmError("WinHighLight","Nums",0);}
	PTitle->CAD.ClearAutoStart();
	PTitle->CAD.ClearAutoStop();
	PTitle->CAD.SetDirStill();
	for(int16 i=0;i<8;i++)
	{
	  PWaves[i] = GetWav(i);
	  //if(PWaves[i] == NULL) {AnmError("WinHighLightSound Sprite","sound",i);}
	}
}
//*******************************************************************
void THSLWinHighLight::Update(dword NewFUC)
{
  if(WaveStarted)
  {
	 if(PWaves[CurrentSound]->GetStopped())
	 {
		WaveStarted = false;
		PTitle->NoShow();
	 }
	 else if(NewFUC%3 == 0)
	 {
		PTitle->Show();
	 }
	 else
	 {
		PTitle->NoShow();
	 }
  }
  TSprite::Update(NewFUC);
}
//****************************************************************