//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  hsmusp.cpp
//    Project Name:  Casino
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     9/26/95    A.Krist      original baseline
//  2.0    09/04/97    M.Perry      32-bit conversion.
//********************************************************************
#include "hsmusp.h"
#include "oanm.h"
#include "owav.h"
//*******************************************************************
THSMultiplier::THSMultiplier(TOgleModeWindow *pmw,const TFileMode &NewFileMode)
:TSprite(pmw,NewFileMode)
{
  PMultUp = NULL;
  PMultDown = NULL;
  SetToManual();
  SetupAnms();
}
//*******************************************************************
THSMultiplier::THSMultiplier(TOgleModeWindow *pmw,const TFileMode &NewFileMode,void *psource)
:TSprite(pmw,NewFileMode,psource)
{
  PMultUp = NULL;
  PMultDown = NULL;
  SetToManual();
  SetupAnms();
}
//*******************************************************************
THSMultiplier::~THSMultiplier()
{
}
//*******************************************************************
void THSMultiplier::SetNum(int16 frame)
{
  if(PMultUp != NULL)
  {
	 if(PMultiplier->CAD.GetCurrentFrame() < frame)
	 {
		PMultUp->Start();
	 }
	 else if(PMultDown != NULL)
	 {
		if(PMultiplier->CAD.GetCurrentFrame() > frame)
		{
		  PMultDown->Start();
		}
	 }
  }
  PMultiplier->CAD.SetCurrentFrame(frame);
  PMultiplier->Show();
  Update(GetAdjFUC());
}
//*******************************************************************
void THSMultiplier::SetupAnms()
{
	PMultiplier = GetAnm(0);
	if (PMultiplier == NULL) {AnmError("Multiplier","Nums",0);}
	PMultiplier->CAD.ClearAutoStart();
	PMultiplier->CAD.ClearAutoStop();
	PMultiplier->CAD.SetDirStill();
	PMultUp   = GetWav(0);
	PMultDown = GetWav(1);
	Update(GetAdjFUC());
}
//*******************************************************************
