//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  hsodsp.cpp
//    Project Name:  Casino
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     9/26/95    A.Krist      original baseline
//  2.0    09/04/97    M.Perry      32-bit conversion.
//********************************************************************
#include "hsodsp.h"
#include "oanm.h"
//*******************************************************************
THSOdometer::THSOdometer(TOgleModeWindow *pmw,const TFileMode &NewFileMode)
:TSprite(pmw,NewFileMode)
{
  SetToManual();
  SetupAnms();
}
//*******************************************************************
THSOdometer::THSOdometer(TOgleModeWindow *pmw,const TFileMode &NewFileMode,void *psource)
:TSprite(pmw,NewFileMode,psource)
{
  SetToManual();
  SetupAnms();
}
//*******************************************************************
THSOdometer::~THSOdometer()
{
}
//*******************************************************************
void THSOdometer::SetupAnms()
  {
	 POdometer[0] = GetAnm(2);
	 POdometer[1] = GetAnm(1);
	 POdometer[2] = GetAnm(0);

	 for (int16 j=0;j<3;j++)
	 {
		if (POdometer[j] == NULL) {AnmError("Win Paid","num",j);}
	 }

	 for (int i=0;i<3;i++)
	 {
		POdometer[i]->CAD.ClearAutoStart();
		POdometer[i]->CAD.ClearAutoStop();
		POdometer[i]->CAD.SetDirStill();
	 }
}
//*******************************************************************
void THSOdometer::SetNum(int16 num)
{
	 if (POdometer[0] == NULL) {return;}
	 if (POdometer[1] == NULL) {return;}
	 if (POdometer[2] == NULL) {return;}

	 ones    =  num % 10;
	 tens    = (num / 10  )  % 10;
	 huns    = (num / 100 )  % 10;
	 POdometer[0]->CAD.SetCurrentFrame(int16(ones));
	 POdometer[1]->CAD.SetCurrentFrame(int16(tens));
	 POdometer[2]->CAD.SetCurrentFrame(int16(huns));
	 for (int j=0;j<3;j++)
	 {
		POdometer[j]->Show();
	 }
	 Update(GetAdjFUC());
}
//*******************************************************************
