 //********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  hsreelsp.cpp
//    Project Name:  Casino
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     9/26/95    A.Krist      original baseline
//  2.0    09/04/97    M.Perry      32-bit conversion.
//********************************************************************
#include "hsreelsp.h"
#include "oanm.h"
#include "owav.h"
//*******************************************************************
THSReel::THSReel(TOgleModeWindow *pmw,const TFileMode &NewFileMode)
:TSprite(pmw,NewFileMode)
{
  SetToManual();
  BlurFrame0=0;
  BlurFrame1=0;
  BlurFrame2=0;
  NoShowStill = false;
  Blur0 = false;
  Blur1 = false;
  Blur2 = false;
  SetupAnms();
}
//*******************************************************************
THSReel::THSReel(TOgleModeWindow *pmw,const TFileMode &NewFileMode,void *psource)
:TSprite(pmw,NewFileMode,psource)
{
  SetToManual();
  BlurFrame0=0;
  BlurFrame1=0;
  BlurFrame2=0;
  NoShowStill = false;
  Blur0 = false;
  Blur1 = false;
  Blur2 = false;
  SetupAnms();
}
//*******************************************************************
THSReel::~THSReel()
{
}
//*******************************************************************
void THSReel::SetupAnms()
  {
	 PBlur = GetAnm(0);
	 PReel = GetAnm(1);

	 if (PBlur == NULL) {AnmError("Blur","num",0);}
	 if (PReel == NULL) {AnmError("Reel","num",1);}
	 PBlur->CAD.ClearAutoStart();
	 PBlur->CAD.ClearAutoStop();
	 PBlur->CAD.SetDirStill();
	 PBlur->NoShow();
	 PReel->CAD.ClearAutoStart();
	 PReel->CAD.ClearAutoStop();
	 PReel->CAD.SetDirStill();
	 PReel->CAD.SetCurrentFrame(int16(random(22)));
	 for(int16 i=0;i<22;i++)
	 {
		PReelStopSound[i] = GetWav(i);
		if(PReelStopSound[i] == NULL) {AnmError("ReelSound Sprite","sound",i);}
	 }
}
//*******************************************************************
void THSReel::PostUpdate(dword NewFUC)
{
  if(NoShowStill)
  {
	 PReel->NoShow();
	 NoShowStill = false;
  }
  if(Blur0)
  {
//	 BlurFrame0 = (BlurFrame0+1);
    BlurFrame0++;
	 if(BlurFrame0 >= 6){BlurFrame0=0;}
	 PBlur->CAD.SetCurrentFrame(BlurFrame0);
	 PBlur->Show();
  }
  TSprite::PostUpdate(NewFUC);
}
//*******************************************************************
void THSReel::SetReel()
{
	 if (PReel == NULL) {return;}
	 PBlur->NoShow();
	 Blur0 = false;
	 PReel->Show();
	 Update(GetAdjFUC());
}
//*******************************************************************
void THSReel::ShowReel()
{
	 if (PReel == NULL) {return;}
	 PBlur->NoShow();
	 Blur0 = false;
	 PReel->Show();
	 int16 x = PReel->CAD.GetCurrentFrame();
    if (x >= 0 && x < 22)
    {
      PReelStopSound[x]->Start();
    }
	 Update(GetAdjFUC());
}
//*******************************************************************
void THSReel::Blur()
{
  Blur0 = true;
  Blur1 = true;
  Blur2 = true;
  BlurFrame0 = int16(random(6));
  BlurFrame1 = int16(random(6));
  BlurFrame2 = int16(random(6));
}
//*******************************************************************
void THSReel::SetNum(int16 reel0)
{
	 if (PReel == NULL) {return;}

	 PReel->CAD.SetCurrentFrame(reel0);
	 PReel->NoShow();
	 Update(GetAdjFUC());
}
//*******************************************************************

