//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  hstrsp.cpp
//    Project Name:  Casino
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     9/26/95    A.Krist      original baseline
//  2.0    09/04/97    M.Perry      32-bit conversion.
//********************************************************************
#include "hstrsp.h"
#include "oanm.h"
#include "owav.h"
//*******************************************************************
THSTravel::THSTravel(TOgleModeWindow *pmw,const TFileMode &NewFileMode)
:TSprite(pmw,NewFileMode)
{
  SetToManual();
  NoShow();
  SetupAnms();
  MoveDone = true;
  NumOfMoveFrames = 0;
  StartFrame = 0;
  framecount = 0;
  MoveBack = false;
  LapIsDone = true;
  StartLapFrame = 0;
  LapInc = 0;
}
//*******************************************************************
THSTravel::THSTravel(TOgleModeWindow *pmw,const TFileMode &NewFileMode,void *psource)
:TSprite(pmw,NewFileMode,psource)
{
  SetToManual();
  NoShow();
  SetupAnms();
  MoveDone = true;
  NumOfMoveFrames = 0;
  StartFrame = 0;
  framecount = 0;
  MoveBack = false;
  LapIsDone = true;
  StartLapFrame = 0;
  LapInc = 0;
}
//*******************************************************************
THSTravel::~THSTravel()
{
}
//*******************************************************************
void THSTravel::PlayFlatWav()
{
  if (Flat != NULL)
  {
    Flat->Start();
    Update(GetAdjFUC());
  }
}
//*******************************************************************
int16 THSTravel::CurrentFrameIs()
{
  return PTravel->CAD.GetCurrentFrame();
}
//*******************************************************************
void THSTravel::DoLap()
{
  LapIsDone = false;
  StartLapFrame = PTravel->CAD.GetCurrentFrame();
  LapInc = 0;
}
//*******************************************************************
void THSTravel::MoveBackward(int16 framesbackward)
{
  if(framesbackward <= 0){return;}
  NumOfMoveFrames = framesbackward;
  MoveDone = false;
  MoveBack = true;
  StartFrame = PTravel->CAD.GetCurrentFrame();
 // if(StartFrame >= 37){StartFrame = 0;}
  framecount = 0;
}
//*******************************************************************
void THSTravel::MoveForward(int16 framesforward)
{
  if(framesforward <= 0){return;}
  NumOfMoveFrames = framesforward;
  MoveDone = false;
  StartFrame = PTravel->CAD.GetCurrentFrame();
  //if(StartFrame >= 37){StartFrame = 0;}
  framecount = 0;
}
//*******************************************************************
void THSTravel::SetNum(int16 frame)
{
  PTravel->CAD.SetCurrentFrame(int16(frame%38));
  PTravel->Show();
  Update(GetAdjFUC());
  return;
}
//*******************************************************************
void THSTravel::SetupAnms()
{
	PTravel = GetAnm(0);
	if (PTravel == NULL) {AnmError("Travel","Nums",0);}
	PTravel->CAD.ClearAutoStart();
	PTravel->CAD.ClearAutoStop();
	PTravel->CAD.SetDirStill();
	Flat = GetWav(0);
	Update(GetAdjFUC());
}
//*****************************************************************
void THSTravel::PostUpdate(dword NewFUC)
{
	if(!LapIsDone)
	{
	  LapInc++;
	  SetNum(int16((StartLapFrame + LapInc)%38));
	  if(LapInc >= 38){LapIsDone = true;}
	  return;
	}
	if(MoveBack)
	{
	  framecount++;
	  if(StartFrame-framecount < 0)
	  {
		 SetNum(37);
	  }
	  SetNum(int16(StartFrame-framecount));
	  if(framecount == NumOfMoveFrames)
	  {
		 MoveBack = false;
		 MoveDone = true;
	  }
	  return;
	}
	if(!MoveDone && !MoveBack)
	{
	  framecount++;
	 // if(StartFrame+framecount > 37)
	  //{
	 //	 SetNum(0);
	 //	 MoveDone = true;
	 // }
	  SetNum(int16(StartFrame+framecount));
	  if(framecount == NumOfMoveFrames)
	  {
		 MoveDone = true;
	  }
	}
	TSprite::PostUpdate(NewFUC);
}
//*******************************************************************

