//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  hswhsp.cpp
//    Project Name:  Casino
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     9/26/95    A.Krist      original baseline
//  2.0    09/04/97    M.Perry      32-bit conversion.
//********************************************************************
#include "hswhsp.h"
#include "oanm.h"
#include "owav.h"
//*******************************************************************
THSWinHighLight::THSWinHighLight(TOgleModeWindow *pmw,const TFileMode &NewFileMode)
:TSprite(pmw,NewFileMode)
{
  SetToManual();
  SetupAnms();
  CurrentSound = 0;
  WaveStarted = false;
}
//*******************************************************************
THSWinHighLight::THSWinHighLight(TOgleModeWindow *pmw,const TFileMode &NewFileMode,void *psource)
:TSprite(pmw,NewFileMode,psource)
{
  SetToManual();
  SetupAnms();
  CurrentSound = 0;
  WaveStarted = false;
}
//*******************************************************************
THSWinHighLight::~THSWinHighLight()
{
}
//********************************************************************
void THSWinHighLight::StopAll()
{
  PWaves[CurrentSound]->Stop();
}
//********************************************************************
bool THSWinHighLight::IsWaveStopped()
{
  if (CurrentSound >= 0 &&
      CurrentSound < 8 &&
      PWaves[CurrentSound] != NULL &&
      PWaves[CurrentSound]->GetStarted() &&
      !(PWaves[CurrentSound]->GetStopped()))
  {
	 return false;
  }
  return true;
}
//*******************************************************************
void THSWinHighLight::PlaySound(int16 sound)
{
  if (sound >= 0 &&
      sound < 8 &&
      PWaves[sound] != NULL)
  {
	 PWaves[sound]->Start();
	 Update(GetAdjFUC());
	 CurrentSound = sound;
	 WaveStarted = true;
	 PTitle->Show();
  }
}
//*******************************************************************
void THSWinHighLight::SetupAnms()
{
	PTitle = GetAnm(0);
	if (PTitle == NULL) {AnmError("WinHighLight","Nums",0);}
	PTitle->CAD.ClearAutoStart();
	PTitle->CAD.ClearAutoStop();
	PTitle->CAD.SetDirStill();
	for(int16 i=0;i<8;i++)
	{
	  PWaves[i] = GetWav(i);
	}
}
//*******************************************************************
void THSWinHighLight::Update(dword NewFUC)
{
  if(WaveStarted)
  {
	 if(PWaves[CurrentSound]->GetStopped())
	 {
		WaveStarted = false;
		PTitle->NoShow();
	 }
	 else if(NewFUC%3 == 0)
	 {
		PTitle->Show();
	 }
	 else
	 {
		PTitle->NoShow();
	 }
  }
  TSprite::Update(NewFUC);
}
//*****************************************************************
