//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  hswpsp.cpp
//    Project Name:  Casino
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     9/26/95    A.Krist      original baseline
//  2.0    09/04/97    M.Perry      32-bit conversion.
//********************************************************************
#include "hswpsp.h"
#include "oanm.h"
//*******************************************************************
THSWinPaid::THSWinPaid(TOgleModeWindow *pmw,const TFileMode &NewFileMode)
:TSprite(pmw,NewFileMode)
{
  SetToManual();
  SetupAnms();
}
//*******************************************************************
THSWinPaid::THSWinPaid(TOgleModeWindow *pmw,const TFileMode &NewFileMode,void *psource)
:TSprite(pmw,NewFileMode,psource)
{
  SetToManual();
  SetupAnms();
}
//*******************************************************************
THSWinPaid::~THSWinPaid()
{
}
//*******************************************************************
void THSWinPaid::SetupAnms()
  {
	 PWinPaid[0] = GetAnm(4);
	 PWinPaid[1] = GetAnm(3);
	 PWinPaid[2] = GetAnm(2);
	 PWinPaid[3] = GetAnm(1);
	 PWinPaid[4] = GetAnm(0);

	 for (int16 j=0;j<5;j++)
	 {
		if (PWinPaid[j] == NULL) {AnmError("Win Paid","num",j);}
	 }

	 for (int16 i=0;i<5;i++)
	 {
		PWinPaid[i]->CAD.ClearAutoStart();
		PWinPaid[i]->CAD.ClearAutoStop();
		PWinPaid[i]->CAD.SetDirStill();
	 }
	 for(int16 z=0;z<5;z++)
	 {
		PWinPaidSound[z] = GetWav(z);
		if (PWinPaidSound[z] == NULL) {AnmError("WinPaidSound Sprite","sound",z);}
	 }
}
//*******************************************************************
void THSWinPaid::SetNum(int16 num)
{
	 if (PWinPaid[0] == NULL) {return;}
	 if (PWinPaid[1] == NULL) {return;}
	 if (PWinPaid[2] == NULL) {return;}
	 if (PWinPaid[3] == NULL) {return;}
	 if (PWinPaid[4] == NULL) {return;}

	 ones    =  num % 10;
	 tens    = (num / 10  )  % 10;
	 huns    = (num / 100 )  % 10;
	 thou    = (num / 1000)  % 10;
	 tenthou = (num / 10000) % 10;
	 PWinPaid[0]->CAD.SetCurrentFrame(int16(ones));
	 PWinPaid[1]->CAD.SetCurrentFrame(int16(tens));
	 PWinPaid[2]->CAD.SetCurrentFrame(int16(huns));
	 PWinPaid[3]->CAD.SetCurrentFrame(int16(thou));
	 PWinPaid[4]->CAD.SetCurrentFrame(int16(tenthou));
    for (int j=0;j<5;j++)
	 {
		PWinPaid[j]->Show();
	 }
    Update(GetAdjFUC());
}
//*******************************************************************

