//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  hszssp.cpp
//    Project Name:  Casino
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     9/26/95    A.Krist      original baseline
//  2.0    09/04/97    M.Perry      32-bit conversion.
//********************************************************************
#include "hszssp.h"
#include "oanm.h"
//*******************************************************************
THSZodiacSign::THSZodiacSign(TOgleModeWindow *pmw,const TFileMode &NewFileMode)
:TSprite(pmw,NewFileMode)
{
  SetToManual();
  SetupAnms();
  CurrentSign = 3;
}
//*******************************************************************
THSZodiacSign::THSZodiacSign(TOgleModeWindow *pmw,const TFileMode &NewFileMode,void *psource)
:TSprite(pmw,NewFileMode,psource)
{
  SetToManual();
  SetupAnms();
  CurrentSign = 3;
}
//*******************************************************************
THSZodiacSign::~THSZodiacSign()
{
}
//*******************************************************************
int THSZodiacSign::GetCurrentSign()
{
  switch(CurrentSign)
  {
	 case 0  : return 4;
	 case 1  : return 3;
	 case 2  : return 2;
	 case 3  : return 1;
	 default : return 0;
  }
}
//*******************************************************************
int THSZodiacSign::Cycle()
{
  CurrentSign = int16((CurrentSign+1)%4);
  PZodiacSign->CAD.SetCurrentFrame(CurrentSign);
  PZodiacSign->Show();
  Update(GetAdjFUC());
  return CurrentSign;
}
//*******************************************************************
void THSZodiacSign::SetupAnms()
{
	PZodiacSign = GetAnm(0);
	if (PZodiacSign == NULL) {AnmError("ZodiacSign","Nums",0);}
	PZodiacSign->CAD.ClearAutoStart();
	PZodiacSign->CAD.ClearAutoStop();
	PZodiacSign->CAD.SetDirStill();
	PZodiacSign->CAD.SetCurrentFrame(CurrentSign);
	PZodiacSign->Show();
	Update(GetAdjFUC());
}
//*******************************************************************
