//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  l1mw.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     10/6/95    M.Perry    original baseline
//  1.2     04/10/97   M.Perry    changed credits bitmap
//  2.0     09/09/97   M.Perry    32-bit conversion.
//  2.3     06/26/99   M.Perry    filename mod's
//********************************************************************
#include "l1mw.h"

//#include "hslgl.h"
#include "hslgld.h"
#include "hslplay.h"

#include "hsmenu.rh"
#include "cplaymgr.h"
#include "ogamefw.h"
#include "hsnames.rh"
#include "cdebtdlg.h"
#include "hscred.rh"
#include "osndmgr.h"
//*******************************************************************
DEFINE_RESPONSE_TABLE1(THSLobby1ModeWin,THSLobbyModeWin)
  EV_COMMAND(CM_OPTIONS_LOBBY_CASINOCREDIT,CmCreditLine),
  EV_COMMAND_ENABLE(CM_OPTIONS_LOBBY_CASINOCREDIT,CeCreditLine),
END_RESPONSE_TABLE;
//*******************************************************************
THSLobby1ModeWin::THSLobby1ModeWin(string modename,TPal *PPal,string title)
:THSLobbyModeWin(modename,PPal,title)
{
  EnableCredits = true;
  EnableGiftShop = true;
  fCheckPaydays = true;
}
//*******************************************************************
THSLobby1ModeWin::~THSLobby1ModeWin()
{
}
//*******************************************************************
int THSLobby1ModeWin::GetCreditsBmpID()
{
  return IDB_HSLOTS_CREDITS;
}
//*******************************************************************
string THSLobby1ModeWin::GetDetName()
{
  return string("o1lobby.det");
}
//*******************************************************************
int THSLobby1ModeWin::GetMenuID()
{
  return IDM_HUNSLOTS_LOBBY;
}
//*******************************************************************
//void THSLobby1ModeWin::MakeGObjList()
//{
//  PGObjList = new THSLobby1GObjList(this);
//}
//*******************************************************************
//void THSLobby1ModeWin::InitGObjLists()
//{
//  GObj[0] = (TCasinoHSLPlayer *)GetGObjPtr(TAppString(IDS_H1_HSLOBBY));
//  pLord = (TCasinoHSLGameLord *)GetGObjPtr(TAppString(IDS_GL_HSLOBBY));
//  if (pLord == NULL) {GObjError("Lobby Game Lord",TAppString(IDS_GL_HSLOBBY));}
//  if (GObj[0] == NULL) {GObjError("Lobby Human 1",TAppString(IDS_H1_HSLOBBY));}
//}
//*******************************************************************
void THSLobby1ModeWin::Update(dword fuc)
{
  THSLobbyModeWin::Update(fuc);
  if ((fCheckPaydays) ||    // check first time thru and every resume updates.
      ((fuc % 360) == 0))   // and about every minute.
  {
    fCheckPaydays = false;
    GetCasPlayerMgr()->CheckActivePaydays();
  }
}
//*******************************************************************
void THSLobby1ModeWin::ResumeUpdates()
{
  THSLobbyModeWin::ResumeUpdates();
  fCheckPaydays = true;  // wait until next fuc to do our thing.
}
//*******************************************************************
void THSLobby1ModeWin::CmCreditLine()
{
  int16 slotnum = GetCasGameLord()->GetActivePlayer();
  TCasinoPlayerData *pdat = GetCasPlayerMgr()->GetActiveCasinoPlayerDataPtr(slotnum);
  if (pdat == NULL) {return;}
  bool waspaused = GetUpdatePause();
  SetUpdatePause();
  GetSoundMgr()->Stop(true);

  TGamblerDebtDlg *pgdd = new TGamblerDebtDlg(this,pdat);
  pgdd->Execute();
  delete pgdd;

  if (!waspaused) {ClearUpdatePause();}

  GetCasGameLord()->NotifyPlayerCashChange(slotnum);
}
//*******************************************************************
void THSLobby1ModeWin::CeCreditLine(TCommandEnabler &ce)
{
  int16 slotnum = GetCasGameLord()->GetActivePlayer();
  TCasinoPlayerData *pdat = GetCasPlayerMgr()->GetActiveCasinoPlayerDataPtr(slotnum);
  if (pdat == NULL)
  {
    ce.Enable(false);
  }
  else
  {
    ce.Enable(true);
  }
}
//*******************************************************************
TGameObject *THSLobby1ModeWin::CreateGObj(TFileMode &fm,int16 id,void *psource)
{
  if (psource != NULL)
  {
    return NULL;
  }
  else
  {
    if (fm == "\\o1glrd00\\o1glrd00.go")  // MRP - 06/26/99 - v2.3
    {
      pLord = new THSLobby1GameLord(this,fm);
      return pLord;
    }
    else if (fm == "\\o1humn01\\o1humn01.go") // MRP - 06/26/99 - v2.3
    {
      GObj[0] = new TCasinoHSLPlayer(this,fm,0);
      return GObj[0];
    }
    else
    {
  	   return new TGameObject(this,fm);
    }
  }
}
//*******************************************************************
