//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  ck1glspl.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     1/24/96    M.Perry    original baseline
//  2.0    09/17/97    M.Perry    32-bit conversion.
//********************************************************************
#include "ck1glspl.h"
#include "casnames.rh"
#include "cknames.rh"
#include "ckarowsp.h" //arrows
#include "ckgenisp.h" //genie
#include "ckmdsp.h"   //main display
#include "ckcksp.h"   //checks
#include "ckhdsp.h"   //history display
#include "ckposp.h"   //payoff schedule
#include "ckoldsp.h"  //old ticket results, diagonal across ticket
#include "ckhnsp.h"   //history game number
#include "cktimesp.h" //clock
#include "ckgnsp.h"   //current game number
#include "ckplsp.h"   //number of plays/games good for
#include "ckgtsp.h"   //game type 1spot,...
#include "ckbasp.h"   //bet amount per
#include "ckvgsp.h"   //valid games
#include "ckglord.h"
//*******************************************************************
TK1GLordSpriteList::TK1GLordSpriteList(TOgleModeWindow *pmw,const TFileMode &filemode,TGameObject *PGObj)
:TKGLordSpriteList(pmw,filemode,PGObj)
{
  Init(filemode,true,false);
}
//*******************************************************************
TK1GLordSpriteList::~TK1GLordSpriteList()
{
}
//*******************************************************************
bool TK1GLordSpriteList::compare(const string &s1,const string &s2)
{
  if (s1 == s2) {return true;}
  return false;
}
//*******************************************************************
#pragma argsused
TSprite *TK1GLordSpriteList::CreateSprite(string spritename,int16 id,void *psource)
{
  TFileMode FM(spritename,fm_None,fm_None,FileMode.DirIndex);
  if (psource == NULL)
  {
    FM.SetRamImmed();
  }

  if (spritename == GetResString(IDS_MS_SOUNDS_K1))
  {
    if (psource != NULL)
    {
      return new TKSound(PModeWin,FM,psource);
    }
    else
    {
      return new TKSound(PModeWin,FM);
    }
  }
  if (spritename == GetResString(IDS_MS_BANKCASH_K1))
  {
    if (psource != NULL)
    {
      return (new TCasCashDisplay(PModeWin,FM,psource));
    }
    else
    {
      return new TCasCashDisplay(PModeWin,FM);
    }
  }
  if (spritename == GetResString(IDS_MS_B0_K1))
  {
    if (psource != NULL)
    {
      return (new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,100,TRect(1,430,50,479),kidButton0,true,'x'));
    }
    else
    {
      return new TCasButton(PModeWin,FM,(TCasinoGameLord *)POwnerGObj,100,TRect(1,430,50,479),kidButton0,true,'x');
    }
  }
  if (spritename == GetResString(IDS_MS_B1_K1))
  {
    if (psource != NULL)
    {
	   return (new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,100,TRect(170,430,219,479),kidButton1,true));
    }
    else
    {
      return new TCasButton(PModeWin,FM,(TCasinoGameLord *)POwnerGObj,100,TRect(170,430,219,479),kidButton1,true);
    }
  }
  if (spritename == GetResString(IDS_MS_B2_K1))
  {
    if (psource != NULL)
    {
	   return (new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,100,TRect(223,464,258,479),kidButton2,true));
    }
    else
    {
      return new TCasButton(PModeWin,FM,(TCasinoGameLord *)POwnerGObj,100,TRect(223,464,258,479),kidButton2,true);
    }
  }
  if (spritename == GetResString(IDS_MS_B3_K1))
  {
    if (psource != NULL)
    {
	   return (new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,100,TRect(376,464,412,479),kidButton3,true));
    }
    else
    {
      return new TCasButton(PModeWin,FM,(TCasinoGameLord *)POwnerGObj,100,TRect(376,464,412,479),kidButton3,true);
    }
  }
  if (spritename == GetResString(IDS_MS_B4_K1))
  {
    if (psource != NULL)
    {
	   return (new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,125,TRect(416,430,468,479),kidButton4,true,'t'));
    }
    else
    {
      return new TCasButton(PModeWin,FM,(TCasinoGameLord *)POwnerGObj,125,TRect(416,430,468,479),kidButton4,true,'t');
    }
  }
  if (spritename == GetResString(IDS_MS_B5_K1))
  {
    if (psource != NULL)
    {
  	   return (new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,125,TRect(470,430,522,479),kidButton5,true,'r'));
    }
    else
    {
      return new TCasButton(PModeWin,FM,(TCasinoGameLord *)POwnerGObj,125,TRect(470,430,522,479),kidButton5,true,'r');
    }
  }
  if (spritename == GetResString(IDS_MS_B6_K1))
  {
    if (psource != NULL)
    {
	   return (new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,125,TRect(533,430,585,479),kidButton6,true,'n'));
    }
    else
    {
      return new TCasButton(PModeWin,FM,(TCasinoGameLord *)POwnerGObj,125,TRect(533,430,585,479),kidButton6,true,'n');
    }
  }
  if (spritename == GetResString(IDS_MS_B7_K1))
  {
    if (psource != NULL)
    {
	   return (new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)POwnerGObj,125,TRect(587,432,639,478),kidButton7,true,'p'));
    }
    else
    {
      return new TCasButton(PModeWin,FM,(TCasinoGameLord *)POwnerGObj,125,TRect(587,432,639,478),kidButton7,true,'p');
    }
  }
  if (spritename == GetResString(IDS_MS_NP1_K1))
  {
    if (psource != NULL)
    {
	   return (new TCasNamePlate(PModeWin,FM,psource));
    }
    else
    {
      return new TCasNamePlate(PModeWin,FM);
    }
  }
  if (spritename == GetResString(IDS_MS_NP2_K1))
  {
    if (psource != NULL)
    {
	   return (new TCasNamePlate(PModeWin,FM,psource));
    }
    else
    {
      return new TCasNamePlate(PModeWin,FM);
    }
  }
  if (spritename == GetResString(IDS_MS_NP3_K1))
  {
    if (psource != NULL)
    {
	   return (new TCasNamePlate(PModeWin,FM,psource));
    }
    else
    {
      return new TCasNamePlate(PModeWin,FM);
    }
  }
  if (compare(spritename,GetResString(IDS_MS_HISTLEFT_K1)))
  {
    if (psource != NULL)
    {
	   return (new TKArrow(PModeWin,FM,psource));
    }
    else
    {
      return new TKArrow(PModeWin,FM);
    }
  }
  if (compare(spritename,GetResString(IDS_MS_HISTRIGHT_K1)))
  {
    if (psource != NULL)
    {
	   return (new TKArrow(PModeWin,FM,psource));
    }
    else
    {
      return new TKArrow(PModeWin,FM);
    }
  }
  if (compare(spritename,GetResString(IDS_MS_TICKLEFT_K1)))
  {
    if (psource != NULL)
    {
	   return (new TKArrow(PModeWin,FM,psource));
    }
    else
    {
      return new TKArrow(PModeWin,FM);
    }
  }
  if (compare(spritename,GetResString(IDS_MS_TICKRIGHT_K1)))
  {
    if (psource != NULL)
    {
	   return (new TKArrow(PModeWin,FM,psource));
    }
    else
    {
      return new TKArrow(PModeWin,FM);
    }
  }
  if (compare(spritename,GetResString(IDS_MS_MAINDISPLAY_K1)))
  {
    if (psource != NULL)
    {
	   return (new TKMainDisplay(PModeWin,FM,psource));
    }
    else
    {
      return new TKMainDisplay(PModeWin,FM);
    }
  }
  if (compare(spritename,GetResString(IDS_MS_GENIE_K1)))
  {
    if (psource != NULL)
    {
	   return (new TKGenie(PModeWin,FM,psource));
    }
    else
    {
      return new TKGenie(PModeWin,FM);
    }
  }
  if (compare(spritename,GetResString(IDS_MS_HISTDISPLAY_K1)))
  {
    if (psource != NULL)
    {
	   return (new TKHistoryDisplay(PModeWin,FM,psource));
    }
    else
    {
      return new TKHistoryDisplay(PModeWin,FM);
    }
  }
  if (compare(spritename,GetResString(IDS_MS_CHECKS_K1)))
  {
    if (psource != NULL)
    {
	   return (new TKCheck(PModeWin,FM,psource));
    }
    else
    {
      return new TKCheck(PModeWin,FM);
    }
  }
  if (compare(spritename,GetResString(IDS_MS_PAYOFF_K1)))
  {
    if (psource != NULL)
    {
	   return (new TKPayOff(PModeWin,FM,psource));
    }
    else
    {
      return new TKPayOff(PModeWin,FM);
    }
  }
  if (compare(spritename,GetResString(IDS_MS_RESULT_K1)))
  {
    if (psource != NULL)
    {
	   return (new TKResult(PModeWin,FM,psource));
    }
    else
    {
      return new TKResult(PModeWin,FM);
    }
  }
  if (compare(spritename,GetResString(IDS_MS_HISTNUMS_K1)))
  {
    if (psource != NULL)
    {
	   return (new TKHistoryNums(PModeWin,FM,psource));
    }
    else
    {
      return new TKHistoryNums(PModeWin,FM);
    }
  }
  if (compare(spritename,GetResString(IDS_MS_CLOCK_K1)))
  {
    if (psource != NULL)
    {
	   return (new TKTime(PModeWin,FM,psource));
    }
    else
    {
      return new TKTime(PModeWin,FM);
    }
  }
  if (compare(spritename,GetResString(IDS_MS_GAMENUM_K1)))
  {
    if (psource != NULL)
    {
	   return (new TKGameNum(PModeWin,FM,psource));
    }
    else
    {
      return new TKGameNum(PModeWin,FM);
    }
  }
  if (compare(spritename,GetResString(IDS_MS_PLAYS_K1)))
  {
    if (psource != NULL)
    {
	   return (new TKPlays(PModeWin,FM,psource));
    }
    else
    {
      return new TKPlays(PModeWin,FM);
    }
  }
  if (compare(spritename,GetResString(IDS_MS_GAMETYPE_K1)))
  {
    if (psource != NULL)
    {
	   return (new TKGameType(PModeWin,FM,psource));
    }
    else
    {
      return new TKGameType(PModeWin,FM);
    }
  }
  if (compare(spritename,GetResString(IDS_MS_BETAMOUNT_K1)))
  {
    if (psource != NULL)
    {
	   return (new TKBetAmount(PModeWin,FM,psource));
    }
    else
    {
      return new TKBetAmount(PModeWin,FM);
    }
  }
  if (compare(spritename,GetResString(IDS_MS_VALIDGAMES_K1)))
  {
    if (psource != NULL)
    {
	   return (new TKValidGames(PModeWin,FM,psource));
    }
    else
    {
      return new TKValidGames(PModeWin,FM);
    }
  }
  if (compare(spritename,GetResString(IDS_MS_PAYOFF_K1)))
  {
    if (psource != NULL)
    {
	   return (new TKPayOff(PModeWin,FM,psource));
    }
    else
    {
      return new TKPayOff(PModeWin,FM);
    }
  }
  if(compare(spritename,GetResString(IDS_MS_CHIPS_K1)))
  {
    if (psource != NULL)
    {
	   return (new TCasChips(PModeWin,FM,psource));
    }
    else
    {
      return new TCasChips(PModeWin,FM);
    }
  }
  if (psource != NULL)
  {
    return new TSprite(PModeWin,FM,psource);
  }
  else
  {
    return new TSprite(PModeWin,FM);
  }
}
//*******************************************************************