//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  ckdata.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     9/9/96     M.Perry    split up cplaydat file.
//  2.0    09/17/97    M.Perry    32-bit conversion.
//********************************************************************
#include "ckdata.h"

//*******************************************************************
TCKSession::TCKSession()
{
	ClearData();
}
//*******************************************************************
void TCKSession::ClearData()
{
  TCasinoSession::ClearData();
  nTotalBets               = 0;
  nWinningBets             = 0;
  nLosingBetsLost          = 0;
  nLongestWinningStreak    = 0;
  nLongestLosingStreak     = 0;
  lLargestCashWin1Ticket   = 0;
  lLargestCashLoss1Ticket  = 0;
  lPeakCashWinLevel        = 0;
  lLowCashLossLevel        = 0;
  nNum1SpotBets            = 0;
  nNum2SpotBets            = 0;
  nNum3SpotBets            = 0;
  nNum4SpotBets            = 0;
  nNum5SpotBets            = 0;
  nNum6SpotBets            = 0;
  nNum7SpotBets            = 0;
  nNum8SpotBets            = 0;
  nNum9SpotBets            = 0;
  nNum10SpotBets           = 0;
  nNum3SpotSpecialBets     = 0;
  nNum4SpotSpecialBets     = 0;
  nNum6SpotSpecialBets     = 0;
  l1SpotBetsCash         = 0;
  l2SpotBetsCash         = 0;
  l3SpotBetsCash         = 0;
  l4SpotBetsCash         = 0;
  l5SpotBetsCash         = 0;
  l6SpotBetsCash         = 0;
  l7SpotBetsCash         = 0;
  l8SpotBetsCash         = 0;
  l9SpotBetsCash         = 0;
  l10SpotBetsCash        = 0;
  l3SpotSpecialBetsCash  = 0;
  l4SpotSpecialBetsCash  = 0;
  l6SpotSpecialBetsCash  = 0;
  l1SpotBetsCashWL         = 0;
  l2SpotBetsCashWL         = 0;
  l3SpotBetsCashWL         = 0;
  l4SpotBetsCashWL         = 0;
  l5SpotBetsCashWL         = 0;
  l6SpotBetsCashWL         = 0;
  l7SpotBetsCashWL         = 0;
  l8SpotBetsCashWL         = 0;
  l9SpotBetsCashWL         = 0;
  l10SpotBetsCashWL        = 0;
  l3SpotSpecialBetsCashWL  = 0;
  l4SpotSpecialBetsCashWL  = 0;
  l6SpotSpecialBetsCashWL  = 0;
  nTotalGames              = 0;

  for (int i=0;i<80;i++)
  {
    nMostFrequentNums[i] = 0;
  }
}
//*******************************************************************
void TCKSession::StartSession(TMoney startingcash,int16 subgametype,TMoney denom)
{
	ClearData();
	TCasinoSession::StartSession(startingcash,subgametype,denom);
}
//*******************************************************************
void TCKSession::EndSession(TMoney endingcash)
{
  TCasinoSession::EndSession(endingcash);
}
//*******************************************************************
bool TCasinoKData::IsActiveTicket()
{
  for( int i=0;i<100;i++)
  {
	 if(tickets[i].startinggame > -1 && tickets[i].paid == -1) {return true;}
  }
  return false;
}
//*******************************************************************
void TCasinoKData::IncCurrentSession()
{
  if (CurrentSession == 0 && !Sessions[0].Valid)
  {
	 CurrentSession = 0;
	 return;
  }
  CurrentSession++;
  if (CurrentSession >= NUMSESSIONS) {CurrentSession = 0;}
}
//*******************************************************************
int16 TCasinoKData::GetFirstValidSession()
{
  // Sanity check on CurrentSession.
  if ((CurrentSession < 0) || (CurrentSession >= NUMSESSIONS)) {SessionIterator = -1;}
  else {SessionIterator = CurrentSession;}

  if (SessionIterator == -1) {return SessionIterator;}

  // Validity check on current session.
  if (!Sessions[SessionIterator].Valid)
  {
	 SessionIterator = -1;
	 return SessionIterator;
  }
  // currents session is valid, so start looping from current session to find oldest session.
  for (SessionIterator++;SessionIterator<NUMSESSIONS;SessionIterator++)
  {
	 if (Sessions[SessionIterator].Valid) {return SessionIterator;}
  }
  if (CurrentSession == 0) // we already checked all sessions and didn't find a valid one.
  {
	 if (Sessions[0].Valid) {SessionIterator = 0;}
	 else {SessionIterator = -1;}
	 return SessionIterator;
  }

  for (SessionIterator = 0;SessionIterator < CurrentSession;SessionIterator++)
  {
	 if (Sessions[SessionIterator].Valid) {return SessionIterator;}
  }
  SessionIterator = -1;
  return SessionIterator;
}
//*******************************************************************
int16 TCasinoKData::GetPrevValidSession()
{
  int16 prevsession = CurrentSession;
  prevsession--;
  if (prevsession <= 0) {prevsession = NUMSESSIONS - 1;}
  if (!Sessions[prevsession].Valid) {return -1;}
  return prevsession;
}
//*******************************************************************
int16 TCasinoKData::GetNextValidSession()
{
  // check if already found last valid session.
  if (SessionIterator == -1) {return SessionIterator;}
  // go to next session.
  SessionIterator++;
  // check for wraparound.
  if (SessionIterator >= NUMSESSIONS) {SessionIterator = 0;}
  // check if we went all the way around to beginning.
  if (SessionIterator == CurrentSession)
  {
	 SessionIterator = -1;
	 return CurrentSession;
  }
  // validity check on session.
  if (!Sessions[SessionIterator].Valid)
  {
	 SessionIterator = -1;
	 return SessionIterator;
  }
  return SessionIterator;
}
//*******************************************************************
TCasinoKData::TCasinoKData()
{
  ClearData();
}
//*******************************************************************
void TCasinoKData::ClearData()
{
  TCasinoData::ClearData();
  Cumulative = 0;
  for (int16 j=0;j<100;j++)
  {
	 tickets[j].ticketnum      = j;
	 tickets[j].plays          = -1;
	 tickets[j].game           = kgNone;
	 tickets[j].amountper      = -1;
	 tickets[j].startinggame   = -1;
	 tickets[j].paid           = -1;
	 tickets[j].New            = false;
	 tickets[j].LoserPrintType = -1;
	 for(int k=0;k<80;k++)
	 {
		tickets[j].spots[k]   = false;
	 }
  }
  for (int i=0;i<NUMSESSIONS;i++)
  {
	 Sessions[i].ClearData();
  }
}
//*******************************************************************
void TCasinoKData::StartSession(TMoney startingcash,int16 subgametype,TMoney denom)
{
  IncCurrentSession();
  Sessions[CurrentSession].StartSession(startingcash,subgametype,denom);
}
//*******************************************************************
void TCasinoKData::EndSession(TMoney endingcash)
{
  Sessions[CurrentSession].EndSession(endingcash);
}
//*******************************************************************