//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  ccglord.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     3/26/96   A.Krist      Original baseline
//  2.0    09/17/97   M.Perry      32-bit conversion.
//  2.3    07/14/99    M.Perry    gobjlist removal
//*******************************************************************
#include "ckglord.h"
#include "cklordst.h"
#include "cklrdmst.h"
#include "ostate.h"
#include <assert.h>
#include <time.h>   //To Set Random Number Generator
//#include "ccaskex.h"
//#define  NUMBEROFPLAYERS 3
#include <stdlib.h> //For Random Number Generator
#include "caskmw.h"
#include "oskitcat.h"
#include "cplaymgr.h"
#include "ckplay.h"
#include "casnames.rh"
#include "casapp.h"
#include "orespond.h"
#include "oanm.h"
#include "cas_cm.rh"
#include "cknames.rh"
//*******************************************************************
string GetResString(int16 id)
{
  return TAppString(id);
}
//*******************************************************************
void TCasinoKGameLord::SetupUniqueIDStrings()
{
  strTicketLeft = GetResString(IDS_MS_TICKLEFT_K1);
  strTicketRight = GetResString(IDS_MS_TICKRIGHT_K1);
  strHistoryLeft = GetResString(IDS_MS_HISTLEFT_K1);
  strHistoryRight = GetResString(IDS_MS_HISTRIGHT_K1);
  strButton0 = GetResString(IDS_MS_B0_K1);
  strButton1 = GetResString(IDS_MS_B1_K1);
  strButton2 = GetResString(IDS_MS_B2_K1);
  strButton3 = GetResString(IDS_MS_B3_K1);
  strButton4 = GetResString(IDS_MS_B4_K1);
  strButton5 = GetResString(IDS_MS_B5_K1);
  strButton6 = GetResString(IDS_MS_B6_K1);
  strButton7 = GetResString(IDS_MS_B7_K1);
  strBetAmount = GetResString(IDS_MS_BETAMOUNT_K1);
  strChips = GetResString(IDS_MS_CHIPS_K1);
  strTime = GetResString(IDS_MS_CLOCK_K1);
  strChecks = GetResString(IDS_MS_CHECKS_K1);
  strGenie = GetResString(IDS_MS_GENIE_K1);
  strGameNum = GetResString(IDS_MS_GAMENUM_K1);
  strGameType = GetResString(IDS_MS_GAMETYPE_K1);
  strHistoryNums = GetResString(IDS_MS_HISTNUMS_K1);
  strMainDisplay = GetResString(IDS_MS_MAINDISPLAY_K1);
  strNP1 = GetResString(IDS_MS_NP1_K1);
  strNP2 = GetResString(IDS_MS_NP2_K1);
  strNP3 = GetResString(IDS_MS_NP3_K1);
  strHistoryDisplay = GetResString(IDS_MS_HISTDISPLAY_K1);
  strPlays = GetResString(IDS_MS_PLAYS_K1);
  strResult = GetResString(IDS_MS_RESULT_K1);
  strSounds = GetResString(IDS_MS_SOUNDS_K1);
  strPayoff = GetResString(IDS_MS_PAYOFF_K1);
  strValidGames = GetResString(IDS_MS_VALIDGAMES_K1);
  strBankCashDisplay = GetResString(IDS_MS_BANKCASH_K1);
}
//*******************************************************************
int16 TCasinoKGameLord::GetUniqueID(const string &s)
{
  if (s == strTicketLeft) {return 1;}
  if (s == strTicketRight) {return 2;}
  if (s == strHistoryLeft) {return 3;}
  if (s == strHistoryRight) {return 4;}
  if (s == strButton0) {return 5;}
  if (s == strButton1) {return 6;}
  if (s == strButton2) {return 7;}
  if (s == strButton3) {return 8;}
  if (s == strButton4) {return 9;}
  if (s == strButton5) {return 11;}
  if (s == strButton6) {return 12;}
  if (s == strButton7) {return 13;}
  if (s == strBetAmount) {return 14;}
  if (s == strChips) {return 15;}
  if (s == strTime) {return 16;}
  if (s == strChecks) {return 18;}
  if (s == strGenie) {return 19;}
  if (s == strGameNum) {return 20;}
  if (s == strGameType) {return 21;}
  if (s == strHistoryNums) {return 23;}
  if (s == strMainDisplay) {return 24;}
  if (s == strNP1) {return 26;}
  if (s == strNP2) {return 27;}
  if (s == strNP3) {return 28;}
  if (s == strHistoryDisplay) {return 29;}
  if (s == strPlays) {return 30;}
  if (s == strResult) {return 33;}
  if (s == strSounds) {return 34;}
  if (s == strPayoff) {return 35;}
  if (s == strValidGames) {return 36;}
  if (s == strBankCashDisplay) {return 10;}
  return 0;
}
//*******************************************************************
TSprite *TCasinoKGameLord::CreateSprite(string spritename,int16 id,void *psource)
{
//  TKGameType *pkgt = NULL; // temp placeholder

  TFileMode FM(spritename,
               TFileMode::fm_None,
               TFileMode::fm_None,
               FileMode.GetDirIndex());
  if (psource != NULL)
  {
    switch (id)
	 {
		case  0 : return new TSprite(PModeWin,FM,psource);
		case  1 : TicketLeft = new TKArrow(PModeWin,FM,psource);
					 return TicketLeft;
      case  2 : TicketRight = new TKArrow(PModeWin,FM,psource);
					 return TicketRight;
		case  3 : HistoryLeft = new TKArrow(PModeWin,FM,psource);
                return HistoryLeft;
		case  4 : HistoryRight = new TKArrow(PModeWin,FM,psource);
                return HistoryRight;
		case  5 : Button0 = new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)this,100,TRect(1,430,50,479),kidButton0,true,'x');
                return Button0;
		case  6 : Button1 = new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)this,100,TRect(170,430,219,479),kidButton1,true);
                return Button1;
		case  7 : Button2 = new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)this,100,TRect(223,464,258,479),kidButton2,true);
                return Button2;
		case  8 : Button3 = new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)this,100,TRect(376,464,412,479),kidButton3,true);
                return Button3;
		case  9 : Button4 = new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)this,125,TRect(416,430,468,479),kidButton4,true,'t');
                return Button4;
		case 10 : BankCashDisplay = new TCasCashDisplay(PModeWin,FM,psource);
                return BankCashDisplay;
		case 11 : Button5 = new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)this,125,TRect(470,430,522,479),kidButton5,true,'r');
                return Button5;
		case 12 : Button6 = new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)this,125,TRect(533,430,585,479),kidButton6,true,'n');
                return Button6;
		case 13 : Button7 = new TCasButton(PModeWin,FM,psource,(TCasinoGameLord *)this,125,TRect(587,432,639,478),kidButton7,true,'p');
                return Button7;
		case 14 : BetAmount = new TKBetAmount(PModeWin,FM,psource);
                return BetAmount;
		case 15 : Chips = new TCasChips(PModeWin,FM,psource);
                return Chips;
		case 16 : Time = new TKTime(PModeWin,FM,psource);
                return Time;
      /*case 17 : BurnTicket*/
		case 18 : Checks = new TKCheck(PModeWin,FM,psource);
                return Checks;
		case 19 : Genie = new TKGenie(PModeWin,FM,psource);
                return Genie;
		case 20 : GameNum = new TKGameNum(PModeWin,FM,psource);
                return GameNum;
		case 21 : // mrp - v2.4 - 09/03/99 - keno gpf fix.
                //if(GameType != NULL)
                //{
                //  delete GameType;
                //}
                GameType = new TKGameType(PModeWin,FM,psource);
                return GameType;
//		case 22 : // mrp - v2.4 - 09/03/99 - keno gpf fix.
//                //if(GameType != NULL)
//                //{
//                //  delete GameType;
//                //}
//                //GameType = new TKGameType(PModeWin,FM,psource);
//                //return GameType;
//                pkgt = new TKGameType(PModeWin,FM,psource);
//                if (GameType == NULL)
//                {
//                  GameType = pkgt;
//                }
//                return pkgt;
		case 23 : HistoryNums = new TKHistoryNums(PModeWin,FM,psource);
                return HistoryNums;
		case 24 : MainDisplay = new TKMainDisplay(PModeWin,FM,psource);
                return MainDisplay;
	  //	case 25 : ;
      //          return ;//old message area?
		case 26 : NamePlate1 = new TCasNamePlate(PModeWin,FM,psource);
                return NamePlate1;
		case 27 : NamePlate2 = new TCasNamePlate(PModeWin,FM,psource);
                return NamePlate2;
		case 28 : NamePlate3 = new TCasNamePlate(PModeWin,FM,psource);
                return NamePlate3;
		case 29 : HistoryDisplay = new TKHistoryDisplay(PModeWin,FM,psource);
                return HistoryDisplay;
		case 30 : Plays = new TKPlays(PModeWin,FM,psource);
                return Plays;
	  //	case 31 : ;
      //          return ; // Non-used stat bar?
	  //	case 32 : ;
       //         return ;//slot??
		case 33 : Result = new TKResult(PModeWin,FM,psource);
                return Result;
		case 34 : Sounds = new TKSound(PModeWin,FM,psource);
                return Sounds;
		case 35 : PayOff = new TKPayOff(PModeWin,FM,psource);
                return PayOff;
		case 36 : ValidGames = new TKValidGames(PModeWin,FM,psource);
                return ValidGames;
		default : return new TSprite(PModeWin,FM,psource);
	 }
  }
  else
  {
	 FM.SetRamImmed();
	 switch (id)
	 {
		case  0 : return new TSprite(PModeWin,FM);
		case  1 : TicketLeft = new TKArrow(PModeWin,FM);
					 return TicketLeft;
      case  2 : TicketRight = new TKArrow(PModeWin,FM);
					 return TicketRight;
		case  3 : HistoryLeft = new TKArrow(PModeWin,FM);
                return HistoryLeft;
		case  4 : HistoryRight = new TKArrow(PModeWin,FM);
                return HistoryRight;
		case  5 : Button0 = new TCasButton(PModeWin,FM,(TCasinoGameLord *)this,100,TRect(1,430,50,479),kidButton0,true,'x');
                return Button0;
		case  6 : Button1 = new TCasButton(PModeWin,FM,(TCasinoGameLord *)this,100,TRect(170,430,219,479),kidButton1,true);
                return Button1;
		case  7 : Button2 = new TCasButton(PModeWin,FM,(TCasinoGameLord *)this,100,TRect(223,464,258,479),kidButton2,true);
                return Button2;
		case  8 : Button3 = new TCasButton(PModeWin,FM,(TCasinoGameLord *)this,100,TRect(376,464,412,479),kidButton3,true);
                return Button3;
		case  9 : Button4 = new TCasButton(PModeWin,FM,(TCasinoGameLord *)this,125,TRect(416,430,468,479),kidButton4,true,'t');
                return Button4;
		case 10 : BankCashDisplay = new TCasCashDisplay(PModeWin,FM);
                return BankCashDisplay;
		case 11 : Button5 = new TCasButton(PModeWin,FM,(TCasinoGameLord *)this,125,TRect(470,430,522,479),kidButton5,true,'r');
                return Button5;
		case 12 : Button6 = new TCasButton(PModeWin,FM,(TCasinoGameLord *)this,125,TRect(533,430,585,479),kidButton6,true,'n');
                return Button6;
		case 13 : Button7 = new TCasButton(PModeWin,FM,(TCasinoGameLord *)this,125,TRect(587,432,639,478),kidButton7,true,'p');
                return Button7;
		case 14 : BetAmount = new TKBetAmount(PModeWin,FM);
                return BetAmount;
		case 15 : Chips = new TCasChips(PModeWin,FM);
                return Chips;
		case 16 : Time = new TKTime(PModeWin,FM);
                return Time;
      /*case 17 : BurnTicket*/
		case 18 : Checks = new TKCheck(PModeWin,FM);
                return Checks;
		case 19 : Genie = new TKGenie(PModeWin,FM);
                return Genie;
		case 20 : GameNum = new TKGameNum(PModeWin,FM);
                return GameNum;
		case 21 : // mrp - v2.4 - 09/03/99 - keno gpf fix.
                //if(GameType != NULL)
                //{
                //  delete GameType;
                //}
                GameType = new TKGameType(PModeWin,FM);
                return GameType;
//		case 22 : // mrp - v2.4 - 09/03/99 - keno gpf fix.
//                //if(GameType != NULL)
//                //{
//                //  delete GameType;
//                //}
//                //GameType = new TKGameType(PModeWin,FM);
//                //return GameType;
//                pkgt = new TKGameType(PModeWin,FM);
//                if (GameType == NULL)
//                {
//                  GameType = pkgt;
//                }
//                return pkgt;
		case 23 : HistoryNums = new TKHistoryNums(PModeWin,FM);
                return HistoryNums;
		case 24 : MainDisplay = new TKMainDisplay(PModeWin,FM);
                return MainDisplay;
	  //	case 25 : ;
      //          return ;//old message area?
		case 26 : NamePlate1 = new TCasNamePlate(PModeWin,FM);
                return NamePlate1;
		case 27 : NamePlate2 = new TCasNamePlate(PModeWin,FM);
                return NamePlate2;
		case 28 : NamePlate3 = new TCasNamePlate(PModeWin,FM);
                return NamePlate3;
		case 29 : HistoryDisplay = new TKHistoryDisplay(PModeWin,FM);
                return HistoryDisplay;
		case 30 : Plays = new TKPlays(PModeWin,FM);
                return Plays;
	  //	case 31 : ;
      //          return ; // Non-used stat bar?
	  //	case 32 : ;
       //         return ;//slot??
		case 33 : Result = new TKResult(PModeWin,FM);
                return Result;
		case 34 : Sounds = new TKSound(PModeWin,FM);
                return Sounds;
		case 35 : PayOff = new TKPayOff(PModeWin,FM);
                return PayOff;
		case 36 : ValidGames = new TKValidGames(PModeWin,FM);
                return ValidGames;
		default : return new TSprite(PModeWin,FM);
	 }
  }
}
//*******************************************************************
void TCasinoKGameLord::EnableButton(int16 button)
{
  switch(button)
  {
	 case 0  : Button0->Enabled = true;break;
	 case 1  : Button1->Enabled = true;break;
	 case 2  : Button2->Enabled = true;break;
	 case 3  : Button3->Enabled = true;break;
	 case 4  : Button4->Enabled = true;break;
	 case 5  : Button5->Enabled = true;break;
	 case 6  : Button6->Enabled = true;break;
	 case 7  : Button7->Enabled = true;break;
  }
}
//*******************************************************************
void TCasinoKGameLord::DisEnableButton(int16 button)
{
  switch(button)
  {
	 case 0  : Button0->Enabled = false;break;
	 case 1  : Button1->Enabled = false;break;
	 case 2  : Button2->Enabled = false;break;
	 case 3  : Button3->Enabled = false;break;
	 case 4  : Button4->Enabled = false;break;
	 case 5  : Button5->Enabled = false;break;
	 case 6  : Button6->Enabled = false;break;
	 case 7  : Button7->Enabled = false;break;
  }
}
//*******************************************************************
void TCasinoKGameLord::EnableAllButtons()
{
  Button0->Enabled = true;
  Button1->Enabled = true;
  Button2->Enabled = true;
  Button3->Enabled = true;
  Button4->Enabled = true;
  Button5->Enabled = true;
  Button6->Enabled = true;
  Button7->Enabled = true;
}
//*******************************************************************
void TCasinoKGameLord::DisEnableAllButtons()
{
  Button0->Enabled = false;
  Button1->Enabled = false;
  Button2->Enabled = false;
  Button3->Enabled = false;
  Button4->Enabled = false;
  Button5->Enabled = false;
  Button6->Enabled = false;
  Button7->Enabled = false;
}
//*******************************************************************
#pragma argsused
bool TCasinoKGameLord::Respond(int16 button,int16 info,void *pdata)
{
  if(info == -5)//gray button hit
  {
	 if(button == kidButton7 && GetCash(activeplayer) == 0l)
	 {
		if(GetCasPD(activeplayer)->IsActiveKenoTicket())
		{
        PModeWin->SetUpdatePause();
		  PModeWin->MessageBox("You're out of money and may not bet. Your only hope is that one of your Keno tickets pays off.","Out of Cash",MB_OK);
		  PModeWin->ClearUpdatePause();
		}
		else
		{
		  PModeWin->SetUpdatePause();
		  PModeWin->MessageBox("You've hit rock bottom. Your gambler is bankrupt. Select Create/Delete under the FILE menu to create or select a new gambler.","Bankrupt!",MB_OK);
		  PModeWin->ClearUpdatePause();
		}
	 }
	 else if(button == kidButton7 && !GameCheckMatch())
	 {
		PModeWin->SetUpdatePause();
		PModeWin->MessageBox("The GAME type written on the ticket does not match the number of Xs on the ticket.","Can't Play Ticket",MB_OK);
		PModeWin->ClearUpdatePause();
	 }
	 return true;
  }
  ButtonInfo = info;
  if(info != -1)
  {
	 switch(button)
	 {
	 case kidButton0  : ButtonHit[kidButton0]=true;break;
	 case kidButton1  : TCmMsg(CM_ASKEXPERTSTATISTICS).PostToFW();ButtonHit[kidButton1]=true;break;
	 case kidButton2  : ButtonHit[kidButton2]=true;break;
	 case kidButton3  : ButtonHit[kidButton3]=true;break;
	 case kidButton4  : ButtonHit[kidButton4]=true;break;
	 case kidButton5  : ButtonHit[kidButton5]=true;break;
	 case kidButton6  : ButtonHit[kidButton6]=true;break;
	 case kidButton7  : ButtonHit[kidButton7]=true;break;
	 default           : WaitOnButtonDown = false;break;
	 }
  }
  return true;
}
//*******************************************************************
void TCasinoKGameLord::ButtonClear(int16 button)
{
  switch(button)
  {
	 case kidButton0  : ButtonHit[kidButton0]=false;break;
	 case kidButton1  : ButtonHit[kidButton1]=false;break;
	 case kidButton2  : ButtonHit[kidButton2]=false;GetFW()->CmShowMenu();break;
	 case kidButton3  : ButtonHit[kidButton3]=false;PModeWin->ModeHelp();break;
	 case kidButton4  : ButtonHit[kidButton4]=false;break;
	 case kidButton5  : ButtonHit[kidButton5]=false;break;
	 case kidButton6  : ButtonHit[kidButton6]=false;break;
	 case kidButton7  : ButtonHit[kidButton7]=false;break;
	 default           : WaitOnButtonDown = false;break;
  }
  WaitOnButtonDown = false;
  return;
}
//*******************************************************************
void TCasinoKGameLord::BetUp()
{
  int16 temp=currentticketnum[activeplayer];
  TCasinoPlayerData *player;
  player = GetCasPD(activeplayer);
  if(player->KData.tickets[temp].New == true)
  {
	 amountbet++;
	 Sounds->PlaySound(2);
	 if(amountbet > 3l){amountbet = 1;}
	 CurrentTicket.amountper     = amountbet;
	 player->KData.tickets[temp].amountper     = amountbet;
  }
  DisplayTicket();
}
 //*******************************************************************
void TCasinoKGameLord::PlayUp()
{
  TCasinoPlayerData *player = GetCasPD(activeplayer);
  if (player == NULL) {return;}
  TCasinoKData &curdata = player->KData;

  int16 temp=currentticketnum[activeplayer];
  if(curdata.tickets[temp].New == true)
  {
	 Sounds->PlaySound(2);
	 numofplays++;
	 if(numofplays > 6){numofplays = 1;}
	 switch(numofplays)
	 {
		case 1  : CurrentTicket.plays               = 1;
					 curdata.tickets[temp].plays = 1;break;
		case 2  : CurrentTicket.plays               = 5;
					 curdata.tickets[temp].plays = 5;break;
		case 3  : CurrentTicket.plays               = 10;
					 curdata.tickets[temp].plays = 10;break;
		case 4  : CurrentTicket.plays               = 20;
					 curdata.tickets[temp].plays = 20;break;
		case 5  : CurrentTicket.plays               = 50;
					 curdata.tickets[temp].plays = 50;break;
		case 6  : CurrentTicket.plays               = 100;
					 curdata.tickets[temp].plays = 100;break;
		default : CurrentTicket.plays               = 0;
					 curdata.tickets[temp].plays = 0;break;
	 }
  }
  DisplayTicket();
}
 //*******************************************************************
void TCasinoKGameLord::GameUp()
{
  int16 temp=currentticketnum[activeplayer];
  TCasinoPlayerData *player;
  player = GetCasPD(activeplayer);
  if(player->KData.tickets[temp].New == true && PayOffOn)
  {
	 numofspots++;
	 Sounds->PlaySound(3);
	 if(numofspots > kg10Spot){numofspots = kg1Spot;}
	 CurrentTicket.game          = numofspots;
	 player->KData.tickets[temp].game          = numofspots;
  }
  else
  {
	 PayOffOn = true;
  }
  DisplayTicket();
}
//*******************************************************************
void TCasinoKGameLord::DeleteTicket(int16 ticket)
{
  TCasinoPlayerData *player = GetCasPD(activeplayer);
  TCasinoKData &curdata = player->KData;

  if(player != NULL)
  {
	 curdata.tickets[ticket].plays          = -1;
	 curdata.tickets[ticket].game           = kgNone;
	 curdata.tickets[ticket].amountper      = -1l;
	 curdata.tickets[ticket].startinggame   = -1;
	 curdata.tickets[ticket].paid           = -1l;
	 curdata.tickets[ticket].New            = false;
	 curdata.tickets[ticket].LoserPrintType = -1;
	 for(int16 z=0;z<80;z++)
	 {
		curdata.tickets[ticket].spots[z]    = false;
	 }
  }
}
//*******************************************************************
bool TCasinoKGameLord::TrashTicket(dword &StartFUC,dword &FUCLength)
{
  TCasinoPlayerData *player = GetCasPD(activeplayer);
  if (player == NULL) {return false;}
  TCasinoKData &curdata = player->KData;

  int16 temp=currentticketnum[activeplayer];
  if(DisplayTicketBackward() == false)
  {
    temp = currentticketnum[activeplayer];
	 CurrentTicket.plays          = -1;
	 CurrentTicket.game           = kgNone;
	 CurrentTicket.amountper      = -1l;
	 CurrentTicket.startinggame   = -1;
	 CurrentTicket.paid           = -1l;
	 CurrentTicket.New            = false;
	 CurrentTicket.LoserPrintType = -1;
	 for(int16 z=0;z<80;z++)
	 {
		CurrentTicket.spots[z]    = false;
	 }
  }
  if(temp != -1)
  {
	 curdata.tickets[temp].plays          = -1;
	 curdata.tickets[temp].game           = kgNone;
	 curdata.tickets[temp].amountper      = -1l;
	 curdata.tickets[temp].startinggame   = -1;
	 curdata.tickets[temp].paid           = -1l;
	 curdata.tickets[temp].New            = false;
	 curdata.tickets[temp].LoserPrintType = -1;
	 for(int16 z=0;z<80;z++)
	 {
		curdata.tickets[temp].spots[z]    = false;
	 }
  }
  if(temp == currentticketnum[activeplayer])
  {
	 currentticketnum[activeplayer] = -1;
	 DisplayTicket();

  }
  Sounds->PlaySound(9);
  return (ActivateSprite(trash,StartFUC,FUCLength));
}
//*******************************************************************
bool TCasinoKGameLord::DisplayTicket()
{
  if(currentticketnum[activeplayer] == -1)
  {
	 Plays->NoShow();
	 GameType->NoShow();
	 BetAmount->NoShow();
	 ValidGames->NoShow();
	 PayOff->NoShow();
	 Result->NoShow();
	 Checks->NoShow();
	 numofspots = (TKenoGame)1;
	 numofplays = 0;
	 amountbet  = 0l;
  }
  else
  {
	 Plays->SetNum(CurrentTicket.plays);
	 GameType->SetNum(CurrentTicket.game);
	 BetAmount->SetNum(CurrentTicket.amountper);
	 ValidGames->SetNum(CurrentTicket.startinggame,CurrentTicket.plays);
	 if(CurrentTicket.paid > -1)
	 {
		Button5->ShowVoidUp();
	 }
	 else
	 {
		Button5->ShowGray();
	 }
	 if(CurrentTicket.startinggame > -1 || !GameCheckMatch())
	 {
		Button7->ShowGray();
	 }
	 else
	 {
		Button7->ShowVoidUp();
	 }
	 if(PayOffOn)
	 {
		if(CurrentTicket.game == 0)
		{
//		  PayOff->SetNum((TKenoGame)1);
        PayOff->SetNum(kg1Spot);
		}
		else
		{
		  PayOff->SetNum(CurrentTicket.game);
		}
      GoodX = false;
	 }
	 else
	 {PayOff->NoShow();GoodX = true;}
	 Result->SetNum(CurrentTicket.paid,CurrentTicket.LoserPrintType);
	 Checks->SetNum(CurrentTicket.spots,CurrentTicket.startinggame);
  }
  return true;
}
//*******************************************************************
bool TCasinoKGameLord::DisplayHistory()
{
  HistoryDisplay->SetNum(int16(currenthistory));
  HistoryNums->SetNum(currenthistory);
  return true;
}
//*******************************************************************
bool TCasinoKGameLord::DisplayHistoryForward(int32 amount)
{
  if(currenthistory+amount > currentgame-1)
  {
	 currenthistory = currentgame-1;
  }
  else
  {
	 currenthistory += amount;
  }
  DisplayHistory();
  return true;
}
//*******************************************************************
bool TCasinoKGameLord::DisplayHistoryBackward(int32 amount)
{
  if(currenthistory-amount < 0 || currenthistory-amount < currentgame-50000l)
  {
	 if(currenthistory-amount <= 0)
	 {
		currenthistory = 0;
	 }
	 else if(currenthistory-amount <= currentgame-50000l)
	 {
		currenthistory = currentgame-50000l;
	 }
  }
  else
  {
	 currenthistory -= amount;
  }
  DisplayHistory();
  return true;
}
//*******************************************************************
bool TCasinoKGameLord::GetStartTicket()
{
  currentticketnum[activeplayer] = 0;
//  numofspots = 1;
  numofspots = kg1Spot;
  numofplays = 0;
  amountbet  = 0l;
  return true;
}
//*******************************************************************
int16 TCasinoKGameLord::NumOfSpots()
{
  int16 x=0;
  for(int16 i=0;i<80;i++)
  {
	 if(CurrentTicket.spots[i] == true){x++;}
  }
  return x;
}
//*******************************************************************
bool TCasinoKGameLord::ReplayTicket()
{
  if(GetCash(activeplayer) == 0l)
  {
	 if(GetCasPD(activeplayer)->IsActiveKenoTicket())
	 {
		PModeWin->SetUpdatePause();
		PModeWin->MessageBox("You're out of money and may not bet. Your only hope is that one of your Keno tickets pays off.","Out of Cash",MB_OK);
		PModeWin->ClearUpdatePause();
	 }
	 else
	 {
		PModeWin->SetUpdatePause();
		PModeWin->MessageBox("You've hit rock bottom. Your gambler is bankrupt. Select Create/Delete under the FILE menu to create or select a new gambler.","Bankrupt!",MB_OK);
		PModeWin->ClearUpdatePause();
	 }
	 return true;
  }
  TKenoTicket Replay;
  TCasinoPlayerData *player;
  player = GetCasPD(activeplayer);
  int16 temp=currentticketnum[activeplayer];
  if(player->KData.tickets[temp].paid > -1l)
  {
	 Replay.plays        = player->KData.tickets[temp].plays;
	 Replay.game         = player->KData.tickets[temp].game;
	 Replay.amountper    = player->KData.tickets[temp].amountper;
	 Replay.startinggame = -1;
	 Replay.paid         = -1l;
	 Replay.New          = true;
	 Replay.LoserPrintType = -1;
	 for(int16 z=0;z<80;z++)
	 {
		Replay.spots[z]   = player->KData.tickets[temp].spots[z];
	 }
		temp=currentticketnum[activeplayer];
		player->KData.tickets[temp].plays        = Replay.plays;
		player->KData.tickets[temp].game         = Replay.game; //just to make sure
		player->KData.tickets[temp].New          = true;
		player->KData.tickets[temp].LoserPrintType = -1;
		player->KData.tickets[temp].paid         = -1l; //just to make sure
		player->KData.tickets[temp].startinggame = -1;
		player->KData.tickets[temp].amountper    = Replay.amountper; //just to make sure
		CurrentTicket.plays        = player->KData.tickets[temp].plays;
		CurrentTicket.game         = player->KData.tickets[temp].game;
		CurrentTicket.amountper    = player->KData.tickets[temp].amountper;
		CurrentTicket.startinggame = player->KData.tickets[temp].startinggame;
		CurrentTicket.paid         = player->KData.tickets[temp].paid;
		CurrentTicket.New          = player->KData.tickets[temp].New;
		CurrentTicket.LoserPrintType = player->KData.tickets[temp].LoserPrintType;
		for(int16 z=0;z<80;z++)
		{
		  player->KData.tickets[temp].spots[z] = Replay.spots[z];
		  CurrentTicket.spots[z]   = player->KData.tickets[temp].spots[z];
		}
		numofspots = CurrentTicket.game;
		numofplays = CurrentTicket.plays;
		amountbet  = CurrentTicket.amountper;
      PlayTicket();
  }
  return true; // MRP 12/21/96
}
//*******************************************************************
bool TCasinoKGameLord::GameCheckMatch()
{
  int16 checks=0,spots=0;
  switch(CurrentTicket.game)
  {
	 case kgNone          : checks = 1;break; //must have at least one spot
	 case kg1Spot         : checks = 1;break;
	 case kg2Spot         : checks = 2;break;
	 case kg3Spot         : checks = 3;break;
	 case kg3SpotSpecial  : checks = 3;break;
	 case kg4Spot         : checks = 4;break;
	 case kg4SpotSpecial  : checks = 4;break;
	 case kg5Spot         : checks = 5;break;
	 case kg6Spot         : checks = 6;break;
	 case kg6SpotSpecial  : checks = 6;break;
	 case kg7Spot         : checks = 7;break;
	 case kg8Spot         : checks = 8;break;
	 case kg9Spot         : checks = 9;break;
	 case kg10Spot        : checks = 10;break;
	 default              : checks = 0;break;
  }
  for(int16 i=0;i<80;i++)
  {
	 if(CurrentTicket.spots[i]){spots++;}
  }
  if(checks == spots){return true;}
  return false;
}
//*******************************************************************
void TCasinoKGameLord::PlayTicket()
{
  if(GetCash(activeplayer) == 0l)
  {
	 if(GetCasPD(activeplayer)->IsActiveKenoTicket())
	 {
		PModeWin->SetUpdatePause();
		PModeWin->MessageBox("You're out of money and may not bet. Your only hope is that one of your Keno tickets pays off.","Out of Cash",MB_OK);
		PModeWin->ClearUpdatePause();
	 }
	 else
	 {
		PModeWin->SetUpdatePause();
		PModeWin->MessageBox("You've hit rock bottom. Your gambler is bankrupt. Select Create/Delete under the FILE menu to create or select a new gambler.","Bankrupt!",MB_OK);
		PModeWin->ClearUpdatePause();
	 }
	 return;
  }
  int16 temp=currentticketnum[activeplayer];
  TCasinoPlayerData *player;
  player = GetCasPD(activeplayer);

  if(player->KData.tickets[temp].New == true)
  {
	 if(GameCheckMatch())
	 {
		if(player->KData.tickets[temp].plays <= 0)
		{player->KData.tickets[temp].plays = 1;CurrentTicket.plays = 1;}
		if(player->KData.tickets[temp].amountper <= 0l)
		{player->KData.tickets[temp].amountper = 1l;CurrentTicket.amountper = 1l;}
		int16 realamount=0;
		switch((int32)player->KData.tickets[temp].amountper)
		{
		  case 1  : realamount = 1;break;
		  case 2  : realamount = 5;break;
		  case 3  : realamount = 10;break;
		  default : realamount = 1;break;
		}
		if(GetCash(activeplayer) < ((int32)(player->KData.tickets[temp].plays * realamount)))
		{
		  PModeWin->SetUpdatePause();
		  PModeWin->MessageBox("You don't have enough to play this ticket.","Not enough",MB_OK);
		  PModeWin->ClearUpdatePause();
		  return;
		}
		CurrentTicket.startinggame                   = currentgame+1;
		CurrentTicket.New                            = false;
		player->KData.tickets[temp].startinggame     = currentgame+1;
		player->KData.tickets[temp].New              = false;
		int16 a=0;
		switch((int32)CurrentTicket.amountper)
		{
		  case 1 : a=1;break;
		  case 2 : a=5;break;
		  case 3 : a=10;break;
		}
		SubCash(activeplayer,(int32)(player->KData.tickets[temp].plays*a));
		DisplayTicket();
		Sounds->PlaySound(5);
		BankCashDisplay->SetNum(GetCash(activeplayer));
	 }
  }
}
//*******************************************************************
bool TCasinoKGameLord::NewTicket()
{
  if(GetCash(activeplayer) == 0l)
  {
	 if(GetCasPD(activeplayer)->IsActiveKenoTicket())
	 {
		PModeWin->SetUpdatePause();
		PModeWin->MessageBox("You're out of money and may not bet. Your only hope is that one of your Keno tickets pays off.","Out of Cash",MB_OK);\
		PModeWin->ClearUpdatePause();
	 }
	 else
	 {
		PModeWin->SetUpdatePause();
		PModeWin->MessageBox("You've hit rock bottom. Your gambler is bankrupt. Select Create/Delete under the FILE menu to create or select a new gambler.","Bankrupt!",MB_OK);
		PModeWin->ClearUpdatePause();
	 }
	 return true;
  }
  int16 blanktic = HasBlankTicket();
  if(blanktic == currentticketnum[activeplayer]){return true;}
  if(blanktic != -1){DeleteTicket(blanktic);}
  if(currentticketnum[activeplayer] <= -1) //check activeplayer in state
  {
	 GetStartTicket();
  }
  int16 temp;
  temp = currentticketnum[activeplayer];
  temp = int16((temp+1)%100);
  TCasinoPlayerData *player;
  player = GetCasPD(activeplayer);
  if(player==NULL)
  {
	 return false;
  }
  while( ((player->KData.tickets[temp].plays > -1)||(player->KData.tickets[temp].New))
			&& (temp != currentticketnum[activeplayer]) )
  {
	 temp = int16((temp+1)%100);
  }
  if(temp == currentticketnum[activeplayer])
  {
	 PModeWin->SetUpdatePause();
	 PModeWin->MessageBox("You already have 100 tickets. 'Trash' some before pushing 'New Ticket'.","To many ticket's!",MB_OK);
	 PModeWin->ClearUpdatePause();
	 return false;
  }//??? put to many tickets
  else
  {
	 player->KData.tickets[temp].New = true;
	 player->KData.tickets[temp].paid = -1l; //just to make sure
	 CurrentTicket.ticketnum    = player->KData.tickets[temp].ticketnum;
	 CurrentTicket.plays        = player->KData.tickets[temp].plays;
	 CurrentTicket.game         = player->KData.tickets[temp].game;

	 CurrentTicket.amountper    = player->KData.tickets[temp].amountper;
	 CurrentTicket.startinggame = player->KData.tickets[temp].startinggame;
	 CurrentTicket.paid         = player->KData.tickets[temp].paid;
	 CurrentTicket.New          = player->KData.tickets[temp].New;
	 CurrentTicket.LoserPrintType = player->KData.tickets[temp].LoserPrintType;
	 for(int16 z=0;z<80;z++)
	 {
		CurrentTicket.spots[z]   = player->KData.tickets[temp].spots[z];
	 }
	 currentticketnum[activeplayer] = temp;

	 numofspots = kg1Spot;
	 numofplays = 0;
	 amountbet  = 0l;
  }
  DisplayTicket();
  return true;
}
//*******************************************************************
bool TCasinoKGameLord::DisplayTicketForward()
{
  if(currentticketnum[activeplayer] <= -1) //check activeplayer in state
  {
	 GetStartTicket();
  }
  if(currentticketnum[activeplayer] <= -1)
  {NewTicket();return false;}
  int16 temp;
  temp = currentticketnum[activeplayer];
  temp = int16((temp+1)%100);
  TCasinoPlayerData *player;
  player = GetCasPD(activeplayer);
  if(player==NULL)
  {
	 return false;
  }
  while( (player->KData.tickets[temp].plays <= -1) && (temp != currentticketnum[activeplayer]) &&
			(!player->KData.tickets[temp].New) )
  {
	 temp = int16((temp+1)%100);
  }
  if(temp == currentticketnum[activeplayer])
  {return false;}
  else
  {
	 CurrentTicket.ticketnum    = player->KData.tickets[temp].ticketnum;
	 CurrentTicket.plays        = player->KData.tickets[temp].plays;
	 CurrentTicket.game         = player->KData.tickets[temp].game;
	 CurrentTicket.amountper    = player->KData.tickets[temp].amountper;
	 CurrentTicket.startinggame = player->KData.tickets[temp].startinggame;
	 CurrentTicket.paid         = player->KData.tickets[temp].paid;
	 CurrentTicket.New          = player->KData.tickets[temp].New;
	 CurrentTicket.LoserPrintType = player->KData.tickets[temp].LoserPrintType;
	 for(int16 z=0;z<80;z++)
	 {
		CurrentTicket.spots[z]   = player->KData.tickets[temp].spots[z];
	 }
	 currentticketnum[activeplayer] = temp;
	 numofspots = CurrentTicket.game;
	 numofplays = CurrentTicket.plays;
	 amountbet  = CurrentTicket.amountper;
	 Sounds->PlaySound(6);
  }
  DisplayTicket();
  return true;
}
//*******************************************************************
bool TCasinoKGameLord::DisplayTicketBackward()
{
  if(currentticketnum[activeplayer] <= -1) //check activeplayer in state
  {
	 GetStartTicket();
  }
  if(currentticketnum[activeplayer] <= -1)
  {NewTicket();return false;}
  int16 temp;
  temp = currentticketnum[activeplayer];
  temp--;
  if(temp < 0){temp = 99;}
  TCasinoPlayerData *player;
  player = GetCasPD(activeplayer);
  if(player==NULL)
  {
	 return false;
  }
  while( (player->KData.tickets[temp].plays <= -1) && (temp != currentticketnum[activeplayer])&&
			(!player->KData.tickets[temp].New) )
  {
	 temp--;
    if(temp < 0){temp = 99;}
  }
  if(temp == currentticketnum[activeplayer] &&
	  player->KData.tickets[temp].New == false &&
	  player->KData.tickets[temp].plays == -1    )
  {
	 NewTicket();
	 return false;
  }
  else
  {
	 CurrentTicket.ticketnum    = player->KData.tickets[temp].ticketnum;
	 CurrentTicket.plays        = player->KData.tickets[temp].plays;
	 CurrentTicket.game         = player->KData.tickets[temp].game;
	 CurrentTicket.amountper    = player->KData.tickets[temp].amountper;
	 CurrentTicket.startinggame = player->KData.tickets[temp].startinggame;
	 CurrentTicket.paid         = player->KData.tickets[temp].paid;
	 CurrentTicket.New          = player->KData.tickets[temp].New;
	 CurrentTicket.LoserPrintType = player->KData.tickets[temp].LoserPrintType;
	 for(int16 z=0;z<80;z++)
	 {
		CurrentTicket.spots[z]   = player->KData.tickets[temp].spots[z];
	 }
	 currentticketnum[activeplayer] = temp;
	 numofspots = CurrentTicket.game;
	 numofplays = CurrentTicket.plays;
	 amountbet  = CurrentTicket.amountper;
	 Sounds->PlaySound(6);
  }
  DisplayTicket();
  return true;
}
//*******************************************************************
void TCasinoKGameLord::CleanupResponders()
{
  for(int16 i=0;i<NumResponders;i++) {delete Responders[i];}
}
//*******************************************************************
bool TCasinoKGameLord::Respond(TResponder &responder)
{
  if (PState == NULL) {return true;}

  switch (responder.GetID())
  {
	 case kidNum0           :  if(GoodX){return (GetKLordState()->BetSpot(responder,0));}
	 case kidNum1           :  if(GoodX){return (GetKLordState()->BetSpot(responder,1));}
	 case kidNum2           :  if(GoodX){return (GetKLordState()->BetSpot(responder,2));}
	 case kidNum3           :  if(GoodX){return (GetKLordState()->BetSpot(responder,3));}
	 case kidNum4           :  if(GoodX){return (GetKLordState()->BetSpot(responder,4));}
	 case kidNum5           :  if(GoodX){return (GetKLordState()->BetSpot(responder,5));}
	 case kidNum6           :  if(GoodX){return (GetKLordState()->BetSpot(responder,6));}
	 case kidNum7           :  if(GoodX){return (GetKLordState()->BetSpot(responder,7));}
	 case kidNum8           :  if(GoodX){return (GetKLordState()->BetSpot(responder,8));}
	 case kidNum9           :  if(GoodX){return (GetKLordState()->BetSpot(responder,9));}
	 case kidNum10          :  if(GoodX){return (GetKLordState()->BetSpot(responder,10));}
	 case kidNum11          :  if(GoodX){return (GetKLordState()->BetSpot(responder,11));}
	 case kidNum12          :  if(GoodX){return (GetKLordState()->BetSpot(responder,12));}
	 case kidNum13          :  if(GoodX){return (GetKLordState()->BetSpot(responder,13));}
	 case kidNum14          :  if(GoodX){return (GetKLordState()->BetSpot(responder,14));}
	 case kidNum15          :  if(GoodX){return (GetKLordState()->BetSpot(responder,15));}
	 case kidNum16          :  if(GoodX){return (GetKLordState()->BetSpot(responder,16));}
	 case kidNum17          :  if(GoodX){return (GetKLordState()->BetSpot(responder,17));}
	 case kidNum18          :  if(GoodX){return (GetKLordState()->BetSpot(responder,18));}
	 case kidNum19          :  if(GoodX){return (GetKLordState()->BetSpot(responder,19));}
	 case kidNum20          :  if(GoodX){return (GetKLordState()->BetSpot(responder,20));}
	 case kidNum21          :  if(GoodX){return (GetKLordState()->BetSpot(responder,21));}
	 case kidNum22          :  if(GoodX){return (GetKLordState()->BetSpot(responder,22));}
	 case kidNum23          :  if(GoodX){return (GetKLordState()->BetSpot(responder,23));}
	 case kidNum24          :  if(GoodX){return (GetKLordState()->BetSpot(responder,24));}
	 case kidNum25          :  if(GoodX){return (GetKLordState()->BetSpot(responder,25));}
	 case kidNum26          :  if(GoodX){return (GetKLordState()->BetSpot(responder,26));}
	 case kidNum27          :  if(GoodX){return (GetKLordState()->BetSpot(responder,27));}
	 case kidNum28          :  if(GoodX){return (GetKLordState()->BetSpot(responder,28));}
	 case kidNum29          :  if(GoodX){return (GetKLordState()->BetSpot(responder,29));}
	 case kidNum30          :  if(GoodX){return (GetKLordState()->BetSpot(responder,30));}
	 case kidNum31          :  if(GoodX){return (GetKLordState()->BetSpot(responder,31));}
	 case kidNum32          :  if(GoodX){return (GetKLordState()->BetSpot(responder,32));}
	 case kidNum33          :  if(GoodX){return (GetKLordState()->BetSpot(responder,33));}
	 case kidNum34          :  if(GoodX){return (GetKLordState()->BetSpot(responder,34));}
	 case kidNum35          :  if(GoodX){return (GetKLordState()->BetSpot(responder,35));}
	 case kidNum36          :  if(GoodX){return (GetKLordState()->BetSpot(responder,36));}
	 case kidNum37          :  if(GoodX){return (GetKLordState()->BetSpot(responder,37));}
	 case kidNum38          :  if(GoodX){return (GetKLordState()->BetSpot(responder,38));}
	 case kidNum39          :  if(GoodX){return (GetKLordState()->BetSpot(responder,39));}
	 case kidNum40          :  if(GoodX){return (GetKLordState()->BetSpot(responder,40));}
	 case kidNum41          :  if(GoodX){return (GetKLordState()->BetSpot(responder,41));}
	 case kidNum42          :  if(GoodX){return (GetKLordState()->BetSpot(responder,42));}
	 case kidNum43          :  if(GoodX){return (GetKLordState()->BetSpot(responder,43));}
	 case kidNum44          :  if(GoodX){return (GetKLordState()->BetSpot(responder,44));}
	 case kidNum45          :  if(GoodX){return (GetKLordState()->BetSpot(responder,45));}
	 case kidNum46          :  if(GoodX){return (GetKLordState()->BetSpot(responder,46));}
	 case kidNum47          :  if(GoodX){return (GetKLordState()->BetSpot(responder,47));}
	 case kidNum48          :  if(GoodX){return (GetKLordState()->BetSpot(responder,48));}
	 case kidNum49          :  if(GoodX){return (GetKLordState()->BetSpot(responder,49));}
	 case kidNum50          :  if(GoodX){return (GetKLordState()->BetSpot(responder,50));}
	 case kidNum51          :  if(GoodX){return (GetKLordState()->BetSpot(responder,51));}
	 case kidNum52          :  if(GoodX){return (GetKLordState()->BetSpot(responder,52));}
	 case kidNum53          :  if(GoodX){return (GetKLordState()->BetSpot(responder,53));}
	 case kidNum54          :  if(GoodX){return (GetKLordState()->BetSpot(responder,54));}
	 case kidNum55          :  if(GoodX){return (GetKLordState()->BetSpot(responder,55));}
	 case kidNum56          :  if(GoodX){return (GetKLordState()->BetSpot(responder,56));}
	 case kidNum57          :  if(GoodX){return (GetKLordState()->BetSpot(responder,57));}
	 case kidNum58          :  if(GoodX){return (GetKLordState()->BetSpot(responder,58));}
	 case kidNum59          :  if(GoodX){return (GetKLordState()->BetSpot(responder,59));}
	 case kidNum60          :  if(GoodX){return (GetKLordState()->BetSpot(responder,60));}
	 case kidNum61          :  if(GoodX){return (GetKLordState()->BetSpot(responder,61));}
	 case kidNum62          :  if(GoodX){return (GetKLordState()->BetSpot(responder,62));}
	 case kidNum63          :  if(GoodX){return (GetKLordState()->BetSpot(responder,63));}
	 case kidNum64          :  if(GoodX){return (GetKLordState()->BetSpot(responder,64));}
	 case kidNum65          :  if(GoodX){return (GetKLordState()->BetSpot(responder,65));}
	 case kidNum66          :  if(GoodX){return (GetKLordState()->BetSpot(responder,66));}
	 case kidNum67          :  if(GoodX){return (GetKLordState()->BetSpot(responder,67));}
	 case kidNum68          :  if(GoodX){return (GetKLordState()->BetSpot(responder,68));}
	 case kidNum69          :  if(GoodX){return (GetKLordState()->BetSpot(responder,69));}
	 case kidNum70          :  if(GoodX){return (GetKLordState()->BetSpot(responder,70));}
	 case kidNum71          :  if(GoodX){return (GetKLordState()->BetSpot(responder,71));}
	 case kidNum72          :  if(GoodX){return (GetKLordState()->BetSpot(responder,72));}
	 case kidNum73          :  if(GoodX){return (GetKLordState()->BetSpot(responder,73));}
	 case kidNum74          :  if(GoodX){return (GetKLordState()->BetSpot(responder,74));}
	 case kidNum75          :  if(GoodX){return (GetKLordState()->BetSpot(responder,75));}
	 case kidNum76          :  if(GoodX){return (GetKLordState()->BetSpot(responder,76));}
	 case kidNum77          :  if(GoodX){return (GetKLordState()->BetSpot(responder,77));}
	 case kidNum78          :  if(GoodX){return (GetKLordState()->BetSpot(responder,78));}
	 case kidNum79          :  if(GoodX){return (GetKLordState()->BetSpot(responder,79));}
	 case kidNamePlate      : return (GetKLordState()->NamePlate(responder));
	 case kidHistoryLeft    : return (GetKLordState()->HistoryLeft(responder));
	 case kidHistoryRight   : return (GetKLordState()->HistoryRight(responder));
	 case kidTicketLeft     : return (GetKLordState()->TicketLeft(responder));
	 case kidTicketRight    : return (GetKLordState()->TicketRight(responder));
	 case kidPlays          : return (GetKLordState()->Plays(responder));
	 case kidGames          : return (GetKLordState()->Games(responder));
	 case kidBetAmount      : return (GetKLordState()->BetAmount(responder));
	 case kidBlanket        : if(PayOffOn)
									  {
										 if(responder.GetResponseEvent() == reLUp ||
											 responder.GetResponseEvent() == reChar)
										 {
											PayOffOn = false;
											DisplayTicket();
											return true;
										 }
										 return true;
									  }
									  else
									  {
                               return false;
                             }
	 case kidTicketTemplate : if(responder.GetResponseEvent() == reLeaveArea)
									  {
										 GetOgleApp()->GetCursorMgr()->SetCursor(ctAction,0,0);
									  }
									  else if(responder.GetResponseEvent() == reEnterArea)
									  {
										 TCasinoPlayerData *player;
										 player = GetCasPD(activeplayer);
										 if(player==NULL) {return false;}
										 if(CurrentTicket.New)
										 {
											GetOgleApp()->GetCursorMgr()->SetCursor(ctAction,GetOgleApp(),ID_CRAYON_CURSOR);
										 }
									  }
									  return false;
	 default                : return true;
  }
}
//*******************************************************************
void TCasinoKGameLord::SetupResponders()
{
  Responders[0]  = new TResponder(PModeWin,100,TRect(65,276,87,291),kidNum0,this,true);
  Responders[1]  = new TResponder(PModeWin,100,TRect(86,276,111,291),kidNum1,this,true);
  Responders[2]  = new TResponder(PModeWin,100,TRect(110,276,134,291),kidNum2,this,true);
  Responders[3]  = new TResponder(PModeWin,100,TRect(133,276,158,291),kidNum3,this,true);
  Responders[4]  = new TResponder(PModeWin,100,TRect(157,276,182,291),kidNum4,this,true);
  Responders[5]  = new TResponder(PModeWin,100,TRect(181,276,206,291),kidNum5,this,true);
  Responders[6]  = new TResponder(PModeWin,100,TRect(205,276,230,291),kidNum6,this,true);
  Responders[7]  = new TResponder(PModeWin,100,TRect(229,276,254,291),kidNum7,this,true);
  Responders[8]  = new TResponder(PModeWin,100,TRect(253,276,277,291),kidNum8,this,true);
  Responders[9]  = new TResponder(PModeWin,100,TRect(276,276,298,291),kidNum9,this,true);
  Responders[10]  = new TResponder(PModeWin,100,TRect(65,292,87,306),kidNum10,this,true);
  Responders[11]  = new TResponder(PModeWin,100,TRect(86,292,111,306),kidNum11,this,true);
  Responders[12]  = new TResponder(PModeWin,100,TRect(110,292,134,306),kidNum12,this,true);
  Responders[13]  = new TResponder(PModeWin,100,TRect(133,292,158,306),kidNum13,this,true);
  Responders[14]  = new TResponder(PModeWin,100,TRect(157,292,182,306),kidNum14,this,true);
  Responders[15]  = new TResponder(PModeWin,100,TRect(181,292,206,306),kidNum15,this,true);
  Responders[16]  = new TResponder(PModeWin,100,TRect(205,292,230,306),kidNum16,this,true);
  Responders[17]  = new TResponder(PModeWin,100,TRect(229,292,254,306),kidNum17,this,true);
  Responders[18]  = new TResponder(PModeWin,100,TRect(253,292,277,306),kidNum18,this,true);
  Responders[19]  = new TResponder(PModeWin,100,TRect(276,292,298,306),kidNum19,this,true);
  Responders[20]  = new TResponder(PModeWin,100,TRect(61,307,87,321),kidNum20,this,true);
  Responders[21]  = new TResponder(PModeWin,100,TRect(86,307,111,321),kidNum21,this,true);
  Responders[22]  = new TResponder(PModeWin,100,TRect(110,307,134,321),kidNum22,this,true);
  Responders[23]  = new TResponder(PModeWin,100,TRect(133,307,158,321),kidNum23,this,true);
  Responders[24]  = new TResponder(PModeWin,100,TRect(157,307,182,321),kidNum24,this,true);
  Responders[25]  = new TResponder(PModeWin,100,TRect(181,307,206,321),kidNum25,this,true);
  Responders[26]  = new TResponder(PModeWin,100,TRect(205,307,230,321),kidNum26,this,true);
  Responders[27]  = new TResponder(PModeWin,100,TRect(229,307,254,321),kidNum27,this,true);
  Responders[28]  = new TResponder(PModeWin,100,TRect(253,307,277,321),kidNum28,this,true);
  Responders[29]  = new TResponder(PModeWin,100,TRect(276,307,298,321),kidNum29,this,true);
  Responders[30]  = new TResponder(PModeWin,100,TRect(59,322,87,336),kidNum30,this,true);
  Responders[31]  = new TResponder(PModeWin,100,TRect(86,322,111,336),kidNum31,this,true);
  Responders[32]  = new TResponder(PModeWin,100,TRect(110,322,134,336),kidNum32,this,true);
  Responders[33]  = new TResponder(PModeWin,100,TRect(133,322,158,336),kidNum33,this,true);
  Responders[34]  = new TResponder(PModeWin,100,TRect(157,322,182,336),kidNum34,this,true);
  Responders[35]  = new TResponder(PModeWin,100,TRect(181,322,206,336),kidNum35,this,true);
  Responders[36]  = new TResponder(PModeWin,100,TRect(205,322,230,336),kidNum36,this,true);
  Responders[37]  = new TResponder(PModeWin,100,TRect(229,322,254,336),kidNum37,this,true);
  Responders[38]  = new TResponder(PModeWin,100,TRect(253,322,277,336),kidNum38,this,true);
  Responders[39]  = new TResponder(PModeWin,100,TRect(276,322,298,336),kidNum39,this,true);
  Responders[40]  = new TResponder(PModeWin,100,TRect(58,347,80,363),kidNum40,this,true);
  Responders[41]  = new TResponder(PModeWin,100,TRect(79,347,104,363),kidNum41,this,true);
  Responders[42]  = new TResponder(PModeWin,100,TRect(103,347,129,363),kidNum42,this,true);
  Responders[43]  = new TResponder(PModeWin,100,TRect(128,347,152,363),kidNum43,this,true);
  Responders[44]  = new TResponder(PModeWin,100,TRect(151,347,178,363),kidNum44,this,true);
  Responders[45]  = new TResponder(PModeWin,100,TRect(177,347,202,363),kidNum45,this,true);
  Responders[46]  = new TResponder(PModeWin,100,TRect(201,347,227,363),kidNum46,this,true);
  Responders[47]  = new TResponder(PModeWin,100,TRect(226,347,253,363),kidNum47,this,true);
  Responders[48]  = new TResponder(PModeWin,100,TRect(252,347,276,363),kidNum48,this,true);
  Responders[49]  = new TResponder(PModeWin,100,TRect(275,347,298,363),kidNum49,this,true);
  Responders[50]  = new TResponder(PModeWin,100,TRect(55,364,80,380),kidNum50,this,true);
  Responders[51]  = new TResponder(PModeWin,100,TRect(79,364,104,380),kidNum51,this,true);
  Responders[52]  = new TResponder(PModeWin,100,TRect(103,364,129,380),kidNum52,this,true);
  Responders[53]  = new TResponder(PModeWin,100,TRect(128,364,152,380),kidNum53,this,true);
  Responders[54]  = new TResponder(PModeWin,100,TRect(151,364,178,380),kidNum54,this,true);
  Responders[55]  = new TResponder(PModeWin,100,TRect(177,364,202,380),kidNum55,this,true);
  Responders[56]  = new TResponder(PModeWin,100,TRect(201,364,227,380),kidNum56,this,true);
  Responders[57]  = new TResponder(PModeWin,100,TRect(226,364,253,380),kidNum57,this,true);
  Responders[58]  = new TResponder(PModeWin,100,TRect(252,364,276,380),kidNum58,this,true);
  Responders[59]  = new TResponder(PModeWin,100,TRect(275,364,298,380),kidNum59,this,true);
  Responders[60]  = new TResponder(PModeWin,100,TRect(54,381,80,396),kidNum60,this,true);
  Responders[61]  = new TResponder(PModeWin,100,TRect(79,381,104,396),kidNum61,this,true);
  Responders[62]  = new TResponder(PModeWin,100,TRect(103,381,129,396),kidNum62,this,true);
  Responders[63]  = new TResponder(PModeWin,100,TRect(128,381,152,396),kidNum63,this,true);
  Responders[64]  = new TResponder(PModeWin,100,TRect(151,381,178,396),kidNum64,this,true);
  Responders[65]  = new TResponder(PModeWin,100,TRect(177,381,202,396),kidNum65,this,true);
  Responders[66]  = new TResponder(PModeWin,100,TRect(201,381,227,396),kidNum66,this,true);
  Responders[67]  = new TResponder(PModeWin,100,TRect(226,381,253,396),kidNum67,this,true);
  Responders[68]  = new TResponder(PModeWin,100,TRect(252,381,276,396),kidNum68,this,true);
  Responders[69]  = new TResponder(PModeWin,100,TRect(275,381,298,396),kidNum69,this,true);
  Responders[70]  = new TResponder(PModeWin,100,TRect(53,397,80,411),kidNum70,this,true);
  Responders[71]  = new TResponder(PModeWin,100,TRect(79,397,104,411),kidNum71,this,true);
  Responders[72]  = new TResponder(PModeWin,100,TRect(103,397,129,411),kidNum72,this,true);
  Responders[73]  = new TResponder(PModeWin,100,TRect(128,397,152,411),kidNum73,this,true);
  Responders[74]  = new TResponder(PModeWin,100,TRect(151,397,178,411),kidNum74,this,true);
  Responders[75]  = new TResponder(PModeWin,100,TRect(177,397,202,411),kidNum75,this,true);
  Responders[76]  = new TResponder(PModeWin,100,TRect(201,397,227,411),kidNum76,this,true);
  Responders[77]  = new TResponder(PModeWin,100,TRect(226,397,253,411),kidNum77,this,true);
  Responders[78]  = new TResponder(PModeWin,100,TRect(252,397,276,411),kidNum78,this,true);
  Responders[79]  = new TResponder(PModeWin,100,TRect(275,397,298,411),kidNum79,this,true);

  Responders[80]  = new TResponder(PModeWin,100,TRect(260,465,375,477)  ,kidNamePlate,this,true,VK_TAB,TCursorData(GetOgleApp(),ID_POINTING_FINGER_CURSOR));

  Responders[81]  = new TResponder(PModeWin,100,TRect(369,407,407,420),kidHistoryLeft       ,this,true,VK_DOWN,TCursorData(GetOgleApp(),ID_POINTING_FINGER_CURSOR));
  Responders[82]  = new TResponder(PModeWin,100,TRect(576,407,613,420),kidHistoryRight      ,this,true,VK_UP,TCursorData(GetOgleApp(),ID_POINTING_FINGER_CURSOR));
  Responders[83]  = new TResponder(PModeWin,100,TRect(39,417,69,427)  ,kidTicketLeft        ,this,true,VK_LEFT,TCursorData(GetOgleApp(),ID_POINTING_FINGER_CURSOR));
  Responders[84]  = new TResponder(PModeWin,100,TRect(282,417,312,427),kidTicketRight       ,this,true,VK_RIGHT,TCursorData(GetOgleApp(),ID_POINTING_FINGER_CURSOR));
  Responders[85]  = new TResponder(PModeWin,100,TRect(67,252,118,275) ,kidPlays             ,this,true,'p');
  Responders[86]  = new TResponder(PModeWin,200,TRect(137,252,242,275),kidGames             ,this,true,'g');
  Responders[87]  = new TResponder(PModeWin,100,TRect(263,253,298,275),kidBetAmount         ,this,true,'4');

  Responders[88]  = new TResponder(PModeWin,150,TRect(1,1,638,478),kidBlanket,this,true,'~',TCursorData(0,0));
  Responders[89]  = new TResponder(PModeWin,250,TRect(67,262,298,411),kidTicketTemplate,this,true);

}
//*******************************************************************
