//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  ckgnsp.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0    03/23/96    A.Krist     moved inline functions into .cpp file.
//  2.0    09/17/97    M.Perry     32-bit conversion.
//********************************************************************
#include "ckgnsp.h"
#include "oanm.h"
//*******************************************************************
void TKGameNum::SetupAnms()
{
  for(int16 i=0;i<5;i++)
  {
	 PGameNum[i] = GetAnm(i);
	 if (PGameNum[i] == NULL) {AnmError("KGameNum","GameNum",i);}
	 PGameNum[i]->CAD.ClearAutoStart();
	 PGameNum[i]->CAD.ClearAutoStop();
	 PGameNum[i]->CAD.SetDirStill();
  }
}
//*******************************************************************
TKGameNum::TKGameNum(TOgleModeWindow *pmw,TFileMode NewFileMode)
:TSprite(pmw,NewFileMode)
{
  SetToManual();
  NoShow();
  SetupAnms();
}
//********************************************************************
TKGameNum::TKGameNum(TOgleModeWindow *pmw,TFileMode fm,void *psource)
:TSprite(pmw,fm,psource)
{
  SetToManual();
  NoShow();
  SetupAnms();
}
 //*******************************************************************
TKGameNum::~TKGameNum()
{
}
//*******************************************************************
void TKGameNum::SetNum(int32 num)
{
  int32 ones=0,tens=0,huns=0,thou=0,tenthou=0;
  if (PGameNum[0] == NULL) {return;}
  if (PGameNum[1] == NULL) {return;}
  if (PGameNum[2] == NULL) {return;}
  if (PGameNum[3] == NULL) {return;}
  if (PGameNum[4] == NULL) {return;}

  ones = num % 10;
  tens = (num / 10  ) % 10;
  huns = (num / 100 ) % 10;
  thou = (num / 1000) % 10;
  tenthou = (num / 10000) % 10;
  PGameNum[4]->CAD.SetCurrentFrame(int16(ones));
  PGameNum[3]->CAD.SetCurrentFrame(int16(tens));
  PGameNum[2]->CAD.SetCurrentFrame(int16(huns));
  PGameNum[1]->CAD.SetCurrentFrame(int16(thou));
  PGameNum[0]->CAD.SetCurrentFrame(int16(tenthou));
  for(int i=0;i<5;i++)
  {
    PGameNum[i]->Show();
  }
  Update(GetAdjFUC());
}
//*******************************************************************