//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  cksp.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0    03/23/96    A.Krist     moved inline functions into .cpp file.
//  2.0    09/17/97    M.Perry     32-bit conversion.
//********************************************************************
#include "ckgtsp.h"
#include "oanm.h"
//*******************************************************************
void TKGameType::SetupAnms()
{
  PGameType = GetAnm(0);
  if (PGameType == NULL) {AnmError("KGameType","GameType",0);}
  PGameType->CAD.ClearAutoStart();
  PGameType->CAD.ClearAutoStop();
  PGameType->CAD.SetDirStill();
}
//*******************************************************************
TKGameType::TKGameType(TOgleModeWindow *pmw,TFileMode NewFileMode)
:TSprite(pmw,NewFileMode)
{
  SetToManual();
  NoShow();
  SetupAnms();
}
//********************************************************************
TKGameType::TKGameType(TOgleModeWindow *pmw,TFileMode fm,void *psource)
:TSprite(pmw,fm,psource)
{
  SetToManual();
  NoShow();
  SetupAnms();
}
 //*******************************************************************
TKGameType::~TKGameType()
{
}
//*******************************************************************
void TKGameType::SetNum(TKenoGame type)
{
	switch(type)
	{
	  case kgNone         : PGameType->NoShow();return;
	  case kg1Spot        : PGameType->CAD.SetCurrentFrame(0);break;
	  case kg2Spot        : PGameType->CAD.SetCurrentFrame(1);break;
	  case kg3Spot        : PGameType->CAD.SetCurrentFrame(2);break;
	  case kg3SpotSpecial : PGameType->CAD.SetCurrentFrame(3);break;
	  case kg4Spot        : PGameType->CAD.SetCurrentFrame(4);break;
	  case kg4SpotSpecial : PGameType->CAD.SetCurrentFrame(5);break;
	  case kg5Spot        : PGameType->CAD.SetCurrentFrame(6);break;
	  case kg6Spot        : PGameType->CAD.SetCurrentFrame(7);break;
	  case kg6SpotSpecial : PGameType->CAD.SetCurrentFrame(8);break;
	  case kg7Spot        : PGameType->CAD.SetCurrentFrame(9);break;
	  case kg8Spot        : PGameType->CAD.SetCurrentFrame(10);break;
	  case kg9Spot        : PGameType->CAD.SetCurrentFrame(11);break;
	  case kg10Spot       : PGameType->CAD.SetCurrentFrame(12);break;
	  default             : PGameType->CAD.SetCurrentFrame(0);break;
	}
	PGameType->Show();
	Update(GetAdjFUC());
}
//*******************************************************************