//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  cksp.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0    03/23/96    A.Krist     moved inline functions into .cpp file.
//  2.0    09/17/97    M.Perry     32-bit conversion.
//********************************************************************
#include "ckmdsp.h"
#include "oanm.h"
//*******************************************************************
void TKMainDisplay::SetupAnms()
{
  for(int16 i=0;i<20;i++)
  {
	 PMainDisplay[i] = GetAnm(i);
	 if (PMainDisplay[i] == NULL) {AnmError("KMainDisplay","MainDisplay",i);}
	 PMainDisplay[i]->CAD.ClearAutoStart();
	 PMainDisplay[i]->CAD.ClearAutoStop();
	 PMainDisplay[i]->CAD.SetDirStill();
  }
}
//*******************************************************************
TKMainDisplay::TKMainDisplay(TOgleModeWindow *pmw,TFileMode NewFileMode)
:TSprite(pmw,NewFileMode)
{
  SetToManual();
  NoShow();
  SetupAnms();
}
//********************************************************************
TKMainDisplay::TKMainDisplay(TOgleModeWindow *pmw,TFileMode fm,void *psource)
:TSprite(pmw,fm,psource)
{
  SetToManual();
  NoShow();
  SetupAnms();
}
 //*******************************************************************
TKMainDisplay::~TKMainDisplay()
{
}
//*******************************************************************
void TKMainDisplay::ClearMainDisplay()
{
  for(int16 i=0;i<20;i++)
  {
	 PMainDisplay[i]->NoShow();
  }
}
//*******************************************************************
void TKMainDisplay::SetNum(int16 num,int16 currentnum)
{
  if(currentnum > 19){return;}
  PMainDisplay[currentnum]->CAD.SetCurrentFrame(num);
  PMainDisplay[currentnum]->Show();
  Update(GetAdjFUC());
}
//*******************************************************************