//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  cksp.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0    03/23/96    A.Krist     moved inline functions into .cpp file.
//  2.0    09/17/97    M.Perry     32-bit conversion.
//********************************************************************
#include "ckvgsp.h"
#include "oanm.h"
//*******************************************************************
void TKValidGames::SetupAnms()
{
  for(int16 i=0;i<11;i++)
  {
	 PValidGames[i] = GetAnm(i);
	 if (PValidGames[i] == NULL) {AnmError("KValidGames","ValidGames",i);}
	 PValidGames[i]->CAD.ClearAutoStart();
	 PValidGames[i]->CAD.ClearAutoStop();
	 PValidGames[i]->CAD.SetDirStill();
  }
}
//*******************************************************************
TKValidGames::TKValidGames(TOgleModeWindow *pmw,TFileMode NewFileMode)
:TSprite(pmw,NewFileMode)
{
  SetToManual();
  NoShow();
  SetupAnms();
}
//********************************************************************
TKValidGames::TKValidGames(TOgleModeWindow *pmw,TFileMode fm,void *psource)
:TSprite(pmw,fm,psource)
{
  SetToManual();
  NoShow();
  SetupAnms();
}
 //*******************************************************************
TKValidGames::~TKValidGames()
{
}
//*******************************************************************
void TKValidGames::SetNum(int32 startnum,int16 plays)
{
	if(startnum <= -1)
	{
	  for(int i=0;i<11;i++)
	  {
		 PValidGames[i]->NoShow();
	  }
	}
	else
	{
	 if (PValidGames[0]  == NULL) {return;}
	 if (PValidGames[1]  == NULL) {return;}
	 if (PValidGames[2]  == NULL) {return;}
	 if (PValidGames[3]  == NULL) {return;}
	 if (PValidGames[4]  == NULL) {return;}
	 if (PValidGames[5]  == NULL) {return;}
	 if (PValidGames[6]  == NULL) {return;}
	 if (PValidGames[7]  == NULL) {return;}
	 if (PValidGames[8]  == NULL) {return;}
	 if (PValidGames[9]  == NULL) {return;}
	 if (PValidGames[10] == NULL) {return;}

    int32 ones=0,tens=0,huns=0,thou=0,tenthou=0;
	 ones =    startnum           % 10;
	 tens =    (startnum / 10  )  % 10;
	 huns =    (startnum / 100 )  % 10;
	 thou =    (startnum / 1000)  % 10;
	 tenthou = (startnum / 10000) % 10;
	 PValidGames[4]->CAD.SetCurrentFrame(int16(ones));
	 PValidGames[3]->CAD.SetCurrentFrame(int16(tens));
	 PValidGames[2]->CAD.SetCurrentFrame(int16(huns));
	 PValidGames[1]->CAD.SetCurrentFrame(int16(thou));
	 PValidGames[0]->CAD.SetCurrentFrame(int16(tenthou));

	 PValidGames[5]->CAD.SetCurrentFrame(10);

	 switch(plays)
	 {
		case 1   : startnum+=0;break;
		case 5   : startnum+=4;break;
		case 10  : startnum+=9;break;
		case 20  : startnum+=19;break;
		case 50  : startnum+=49;break;
		case 100 : startnum+=99;break;
		default  : startnum+=0;break;
	 }
	 ones =    startnum           % 10;
	 tens =    (startnum / 10  )  % 10;
	 huns =    (startnum / 100 )  % 10;
	 thou =    (startnum / 1000)  % 10;
	 tenthou = (startnum / 10000) % 10;
	 PValidGames[10]->CAD.SetCurrentFrame(int16(ones));
	 PValidGames[9]->CAD.SetCurrentFrame(int16(tens));
	 PValidGames[8]->CAD.SetCurrentFrame(int16(huns));
	 PValidGames[7]->CAD.SetCurrentFrame(int16(thou));
	 PValidGames[6]->CAD.SetCurrentFrame(int16(tenthou));

	 for(int i=0;i<11;i++)
	 {
		PValidGames[i]->Show();
	 }
	}
   Update(GetAdjFUC());
}
//*******************************************************************