//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  caslmw.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     10/12/96   M.Perry    original baseline
//  2.0     09/09/97   M.Perry    32-bit conversion.
//********************************************************************
#include "caslmw.h"
#include "chelpid.h"
#include "casgfw.h"
#include "oloaddlg.h"
#include "ogaugdlg.rh"
#include "osndmgr.h"
#include "oscrnmgr.h"
#include "omode.h"
#include "ofilemgr.h"
#include "cas_cm.rh"
#include "osys.h"
//*******************************************************************
DEFINE_RESPONSE_TABLE1(TLobbyModeWin,TCasinoModeWin)
  EV_COMMAND(CM_OPTIONSLOBBYCREDITS ,CmOptionsCredits),
  EV_COMMAND_ENABLE(CM_OPTIONSLOBBYCREDITS ,CeOptionsCredits),
  EV_COMMAND(CM_OPTIONSLOBBYGIFTSHOP,CmOptionsGiftShop),
  EV_COMMAND_ENABLE(CM_OPTIONSLOBBYGIFTSHOP,CeOptionsGiftShop),
END_RESPONSE_TABLE;
//*******************************************************************
void TLobbyModeWin::CmOptionsCredits()
{
  bool waspaused = GetUpdatePause();
  SetUpdatePause();
  GetSoundMgr()->Stop(true);
  TBitmap *pbitmap = new TBitmap(*GetOgleApp(),GetCreditsBmpID());
  TBitmapDlg *pbd = new TBitmapDlg(this,this,pbitmap,bdRESIZE);
  pbd->Execute();
  delete pbd;
  delete pbitmap;
  if (!waspaused) {ClearUpdatePause();}
}
//*******************************************************************
void TLobbyModeWin::CeOptionsCredits(TCommandEnabler &enabler)
{
  enabler.Enable(EnableCredits);
}
//*******************************************************************
// giftshop not used for achs & acc 2000 re-releases,but only removed at menu level.
void TLobbyModeWin::CmOptionsGiftShop()
{
  string s = GetFileMgr()->PHDD->GetDrive();
  s += GetFileMgr()->PHDD->GetDir();
  s += "giftshop.hlp";
  WinHelp(s.c_str(),HELP_CONTENTS,0);
}
//*******************************************************************
void TLobbyModeWin::CeOptionsGiftShop(TCommandEnabler &enabler)
{
  enabler.Enable(EnableGiftShop);
}
//*******************************************************************
TLobbyModeWin::TLobbyModeWin(string modename,TPal *PPal,string title)
:TCasinoModeWin(modename,PPal,title)
{
  AllowFadeIn = false;//true;
  GoodCount = 0;
  SlowCount = 0;
  ModeHelpCommand = HELP_CONTEXT;
  ModeHelpData = IDH_CAS_LOBBY;
  HideGauge = false;
  EnableCredits = true;
  EnableGiftShop = false;//true;
}
//*******************************************************************
TLobbyModeWin::~TLobbyModeWin()
{
}
//*******************************************************************
int TLobbyModeWin::GetCreditsBmpID()
{
  return 1;  // dummy return value ... Must override.
}
//*******************************************************************
void TLobbyModeWin::Update(dword fuc)
{
  dword btime = TSys::GetMSec();
  TCasinoModeWin::Update(fuc);
  dword atime = TSys::GetMSec();

  dword delta = atime - btime;
  dword painttime = 0;
  if (GetMode() != NULL &&
      GetMode()->GetScreenMgr() != NULL &&
      GetMode()->GetScreenMgr()->PVideo != NULL &&
      GetMode()->GetScreenMgr()->PVideo->IsDropsOk())
  {
    painttime = (delta * 2) / 3; // Est. paint time is 2/3 of update time.
  }

  if ((delta + painttime) > 167)
  {
    SlowCount++;
  }
  else
  {
    GoodCount++;
  }
}
//*******************************************************************
////TBmp *TLobbyModeWin::MakeBG()
//bool TLobbyModeWin::MakeBG()
//{
//  ModeBGFileName = PMode->GetBGFileName();
//  TBmp *pbmp = new TBmp(this,TFileMode(ModeBGFileName,fm_None,fm_Immed));
//  if (GetCasGFW()->GetFadeIn())
//  {
//    GetCasGFW()->SetFadeIn(false);
//    HideGauge = true;
//    FadeIn(pbmp);
//  }
////  return pbmp;
//  PModeBackground = pbmp;
//  return true;
//}
//*******************************************************************
void TLobbyModeWin::CreateGroupGaugeDlg()
{
  if (GetFW() == NULL) {return;}

  if (GetFW()->IsSplashScreenActive() ||
      GetFW()->GetFadeIn() ||                 
      HideGauge)// ||
//      (GetFW()->GetMenuEnable()->GetPrevMode() == GetFW()->idsIntro &&
//       !GetFW()->GetIntroUserSkipped()))
  {
    PGroupGaugeDlg = CreateHiddenGrpGauge();
  }
  else
  {
    PGroupGaugeDlg = new TLoadDlg(this,
                                  this,
                                  new TBitmap(*GetOgleApp(),IDB_LOADING_V2),
                                  bdRESIZE | bdIGNOREINPUT | bdOWNBITMAP,
                                  TRect(20,160,300,175),
                                  TColor::LtYellow);
    PGroupGaugeDlg->Create();
  }
}
//*******************************************************************