//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  clglord.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     10/11/95   M.Perry    Original baseline
//  2.0     09/25/97   M.Perry    32-bit conversion.
//  2.3     07/08/99   M.Perry    gobjlist removal
//*******************************************************************
#include "clglord.h"
#include "llordst.h"
#include "llrdmst.h"
#include "ostate.h"
#include <time.h>   //To Set Random Number Generator
//#define  NUMBEROFPLAYERS 3
#include <stdlib.h> //For Random Number Generator
#include "caslmw.h"
#include "oskitcat.h"
#include "clplay.h"
#include "expert.h"
#include "cplaymgr.h"
#include "casapp.h"
#include "owl\inputdia.h"
#include "osndmgr.h"
#include <checks.h>
#include "orespond.h"
#include "oanm.h"
#include "accmenu.rh"
#include "clnames.rh"
//*******************************************************************
string GetAppString(int16 id)
{
  return TAppString(id);
}
//*******************************************************************
#if defined(SUPPORT_OLD_VER)
void TCasinoLGameLord::SetupUniqueIDStrings()
{
  strMsgDisplay = GetAppString(IDS_MS_MESS_L_L1);
  strMenuEsc = GetAppString(IDS_MS_B0_L_L1);
  strLow1 = GetAppString(IDS_IS_LOW1_L_L1);
  strLow2 = GetAppString(IDS_IS_LOW2_L_L1);
  strLow3 = GetAppString(IDS_IS_LOW3_L_L1);
  strLow4 = GetAppString(IDS_IS_LOW4_L_L1);
  strLow5 = GetAppString(IDS_IS_LOW5_L_L1);
  strLow6 = GetAppString(IDS_IS_LOW6_L_L1);
  strLow7 = GetAppString(IDS_IS_LOW7_L_L1);
  strLow8 = GetAppString(IDS_IS_LOW8_L_L1);
  strWater = GetAppString(IDS_IS_WATER_L_L1);
}
#endif
//*******************************************************************
#if defined(SUPPORT_OLD_VER)
int16 TCasinoLGameLord::GetUniqueID(const string &s)
{
  if (s == strMsgDisplay) {return 1;}
  if (s == strMenuEsc) {return 2;}
  if (s == strLow1) {return 3;}
  if (s == strLow2) {return 4;}
  if (s == strLow3) {return 5;}
  if (s == strLow4) {return 6;}
  if (s == strLow5) {return 7;}
  if (s == strLow6) {return 8;}
  if (s == strLow7) {return 9;}
  if (s == strLow8) {return 10;}
  if (s == strWater) {return 11;}
  return 0;
}
#endif
//*******************************************************************
void TCasinoLGameLord::SetupSprites()
{
}
//*******************************************************************
void TCasinoLGameLord::CleanupSprites()
{
 // do nothing
}
//*******************************************************************
TSprite *TCasinoLGameLord::CreateSprite(string spritename,int16 id,void *psource)
{
  TRect r1(307,426,337,440);

  TFileMode FM(spritename,
               TFileMode::fm_None,
               TFileMode::fm_None,
               FileMode.GetDirIndex());

  if (psource != NULL)
  {
    switch (id)
	 {
		case  0 : return new TSprite(PModeWin,FM,psource);
      case  1 : MessageDisplay = new TCasLobbyMessageDisplay(PModeWin,FM,psource);
                return MessageDisplay;
      case  2 : MenuEscButton = new TCasButton(PModeWin,FM,psource,this,100,r1,idButton0,true);
                return MenuEscButton;
      case  3 : PLow1 = new TSprite(PModeWin,FM,psource);
                return PLow1;
      case  4 : PLow2 = new TSprite(PModeWin,FM,psource);
                return PLow2;
      case  5 : PLow3 = new TSprite(PModeWin,FM,psource);
                return PLow3;
      case  6 : PLow4 = new TSprite(PModeWin,FM,psource);
                return PLow4;
      case  7 : PLow5 = new TSprite(PModeWin,FM,psource);
                return PLow5;
      case  8 : PLow6 = new TSprite(PModeWin,FM,psource);
                return PLow6;
      case  9 : PLow7 = new TSprite(PModeWin,FM,psource);
                return PLow7;
      case 10 : PLow8 = new TSprite(PModeWin,FM,psource);
                return PLow8;
      case 11 : PWater = new TSprite(PModeWin,FM,psource);
                return PWater;
      default : return new TSprite(PModeWin,FM,psource);
	 }
  }
  else
  {
	 FM.SetRamImmed();
	 switch (id)
	 {
		case  0 : return new TSprite(PModeWin,FM);
      case  1 : MessageDisplay = new TCasLobbyMessageDisplay(PModeWin,FM);
                return MessageDisplay;
      case  2 : MenuEscButton = new TCasButton(PModeWin,FM,this,100,r1,idButton0,true);
                return MenuEscButton;
      case  3 : PLow1 = new TSprite(PModeWin,FM);
                return PLow1;
      case  4 : PLow2 = new TSprite(PModeWin,FM);
                return PLow2;
      case  5 : PLow3 = new TSprite(PModeWin,FM);
                return PLow3;
      case  6 : PLow4 = new TSprite(PModeWin,FM);
                return PLow4;
      case  7 : PLow5 = new TSprite(PModeWin,FM);
                return PLow5;
      case  8 : PLow6 = new TSprite(PModeWin,FM);
                return PLow6;
      case  9 : PLow7 = new TSprite(PModeWin,FM);
                return PLow7;
      case 10 : PLow8 = new TSprite(PModeWin,FM);
                return PLow8;
      case 11 : PWater = new TSprite(PModeWin,FM);
                return PWater;
      default : return new TSprite(PModeWin,FM);
	 }
  }
}
//*******************************************************************
#pragma argsused
bool TCasinoLGameLord::Respond(int16 button,int16 info,void *pdata)
{
  ButtonInfo = info;
  if(info != -1)
  {
	 switch(button)
	 {
	   case idButton0  : ButtonHit[0]=true;
                        break;
	   default         : WaitOnButtonDown = false;
                        break;
	 }
  }
  return true;
}
//*******************************************************************
void TCasinoLGameLord::ButtonClear(int16 button)
{
  switch(button)
  {
	 case idButton0  : ButtonHit[0]=false;
                      GetFW()->CmShowMenu();
                      break;
	 default         : WaitOnButtonDown = false;
                      break;
  }
  WaitOnButtonDown = false;
  return;
}
//*******************************************************************
bool TCasinoLGameLord::Respond(TResponder &responder)
{
  // get and stash away.
  int16 id = responder.GetID();

  if (PState == NULL) {return true;}

  if ((responder.GetResponseEvent() == reEnterArea ||
      responder.GetResponseEvent() == reLeaveArea) &&
		id != idSpeed &&
      id != idButton0)
  {
	 if(responder.GetResponseEvent() == reEnterArea)
	 {
      if (id >= idHotSpot1 && id <= idHotSpot61)
      {
        MessageDisplay->ShowLobbyMessage(MsgCodes[id]);
      }
    /*
		switch (responder.GetID())
		{
		  case idHotSpot1     :  MessageDisplay->ShowLobbyMessage(32);
                               break;
		  case idHotSpot2     :  MessageDisplay->ShowLobbyMessage(59);
                               break;
		  case idHotSpot3     :  MessageDisplay->ShowLobbyMessage(31);
                               break;
		  case idHotSpot4     :  MessageDisplay->ShowLobbyMessage(58);
                               break;
		  case idHotSpot5     :  MessageDisplay->ShowLobbyMessage(57);
                               break;
		  case idHotSpot6     :  MessageDisplay->ShowLobbyMessage(56);
                               break;
		  case idHotSpot7     :  MessageDisplay->ShowLobbyMessage(39);
                               break;
		  case idHotSpot8     :  MessageDisplay->ShowLobbyMessage(53);
                               break;
		  case idHotSpot9     :  MessageDisplay->ShowLobbyMessage(42);
                               break;
		  case idHotSpot10    :  MessageDisplay->ShowLobbyMessage(55);
                               break;
		  case idHotSpot11    :  MessageDisplay->ShowLobbyMessage(38);
                               break;
		  case idHotSpot12    :  MessageDisplay->ShowLobbyMessage(48);
                               break;
		  case idHotSpot13    :  MessageDisplay->ShowLobbyMessage(26);
                               break;
		  case idHotSpot14    :  MessageDisplay->ShowLobbyMessage(52);
                               break;
		  case idHotSpot15    :  MessageDisplay->ShowLobbyMessage(51);
                               break;
		  case idHotSpot16    :  MessageDisplay->ShowLobbyMessage(25);
                               break;
		  case idHotSpot17    :  MessageDisplay->ShowLobbyMessage(54);
                               break;
		  case idHotSpot18    :  MessageDisplay->ShowLobbyMessage(47);
                               break;
		  case idHotSpot19    :  MessageDisplay->ShowLobbyMessage(37);
                               break;
		  case idHotSpot20    :  MessageDisplay->ShowLobbyMessage(24);
                               break;
		  case idHotSpot21    :  MessageDisplay->ShowLobbyMessage(46);
                               break;
		  case idHotSpot22    :  MessageDisplay->ShowLobbyMessage(50);
                               break;
		  case idHotSpot23    :  MessageDisplay->ShowLobbyMessage(36);
                               break;
		  case idHotSpot24    :  MessageDisplay->ShowLobbyMessage(30);
                               break;
		  case idHotSpot25    :  MessageDisplay->ShowLobbyMessage(35);
                               break;
		  case idHotSpot26    :  MessageDisplay->ShowLobbyMessage(49);
                               break;
 		  case idHotSpot27    :  MessageDisplay->ShowLobbyMessage(23);
                               break;
		  case idHotSpot28    :  MessageDisplay->ShowLobbyMessage(29);
                               break;
		  case idHotSpot29    :  MessageDisplay->ShowLobbyMessage(45);
                               break;
		  case idHotSpot30    :  MessageDisplay->ShowLobbyMessage(3);
                               break;
		  case idHotSpot31    :  MessageDisplay->ShowLobbyMessage(7);
                               break;
		  case idHotSpot32    :  MessageDisplay->ShowLobbyMessage(15);
                               break;
 		  case idHotSpot33    :  MessageDisplay->ShowLobbyMessage(11);
                               break;
		  case idHotSpot34    :  MessageDisplay->ShowLobbyMessage(44);
                               break;
		  case idHotSpot35    :  MessageDisplay->ShowLobbyMessage(41);
                               break;
		  case idHotSpot36    :  MessageDisplay->ShowLobbyMessage(22);
                               break;
		  case idHotSpot37    :  MessageDisplay->ShowLobbyMessage(28);
                               break;
		  case idHotSpot38    :  MessageDisplay->ShowLobbyMessage(34);
                               break;
		  case idHotSpot39    :  MessageDisplay->ShowLobbyMessage(10);
                               break;
		  case idHotSpot40    :  MessageDisplay->ShowLobbyMessage(14);
                               break;
		  case idHotSpot41    :  MessageDisplay->ShowLobbyMessage(2);
                               break;
		  case idHotSpot42    :  MessageDisplay->ShowLobbyMessage(6);
                               break;
		  case idHotSpot43    :  MessageDisplay->ShowLobbyMessage(27);
                               break;
		  case idHotSpot44    :  MessageDisplay->ShowLobbyMessage(33);
                               break;
		  case idHotSpot45    :  MessageDisplay->ShowLobbyMessage(43);
                               break;
		  case idHotSpot46    :  MessageDisplay->ShowLobbyMessage(40);
                               break;
		  case idHotSpot47    :  MessageDisplay->ShowLobbyMessage(21);
                               break;
		  case idHotSpot48    :  MessageDisplay->ShowLobbyMessage(5);
                               break;
		  case idHotSpot49    :  MessageDisplay->ShowLobbyMessage(9);
                               break;
		  case idHotSpot50    :  MessageDisplay->ShowLobbyMessage(13);
                               break;
		  case idHotSpot51    :  MessageDisplay->ShowLobbyMessage(1);
                               break;
		  case idHotSpot52    :  MessageDisplay->ShowLobbyMessage(12);
                               break;
		  case idHotSpot53    :  MessageDisplay->ShowLobbyMessage(0);
                               break;
		  case idHotSpot54    :  MessageDisplay->ShowLobbyMessage(8);
                               break;
		  case idHotSpot55    :  MessageDisplay->ShowLobbyMessage(4);
                               break;
		  case idHotSpot56    :  MessageDisplay->ShowLobbyMessage(60);
                               break;
		  case idHotSpot57    :  MessageDisplay->ShowLobbyMessage(16);
                               break;
		  case idHotSpot58    :  MessageDisplay->ShowLobbyMessage(20);
                               break;
		  case idHotSpot59    :  MessageDisplay->ShowLobbyMessage(19);
                               break;
		  case idHotSpot60    :  MessageDisplay->ShowLobbyMessage(17);
                               break;
		  case idHotSpot61    :  MessageDisplay->ShowLobbyMessage(18);
                               break;
		 // case idSpeed        :  MessageDisplay->ShowLobbyMessage();break;
		  default             :  break;
		}
      */
	 }
	 else
	 {
      MessageDisplay->ShowLobbyMessage(61);
    }
	 if(responder.GetResponseEvent() == reLeaveArea)
	 {
		GetOgleApp()->GetCursorMgr()->SetCursor(ctAction,0,0);
		return true;
	 }
	 return true;
  }
  else
  {
    int command = -1;
    if (id >= idHotSpot1 && id <= idHotSpot61)
    {
      command = CmdCodes[id];
    }
    /*
	 switch (responder.GetID())
	 {
	 case idHotSpot1  : command = CM_GAMESLOTSTOTAL1000;break;
	 case idHotSpot2  : command = CM_GAMESLOTSSPIRIT1000;break;
	 case idHotSpot3  : command = CM_GAMESLOTSTOTAL500;break;
	 case idHotSpot4  : command = CM_GAMESLOTSALADDIN500;break;
	 case idHotSpot5  : command = CM_GAMESLOTSALADDIN100;break;
	 case idHotSpot6  : command = CM_GAMESLOTSPARADISE100;break;
	 case idHotSpot7  : command = CM_GAMESLOTSPIRATE100;break;
	 case idHotSpot8  : command = CM_GAMESLOTSJOKERS100;break;
	 case idHotSpot9  : command = CM_GAMESLOTSJUNGLE100;break;
	 case idHotSpot10 : command = CM_GAMESLOTSPARADISE50;break;
	 case idHotSpot11 : command = CM_GAMESLOTSPIRATE50;break;
	 case idHotSpot12 : command = CM_GAMESLOTSLUCKY50;break;
	 case idHotSpot13 : command = CM_GAMESLOTSCHERRY50;break;
	 case idHotSpot14 : command = CM_GAMESLOTSJOKERS50;break;
	 case idHotSpot15 : command = CM_GAMESLOTSJOKERS25;break;
	 case idHotSpot16 : command = CM_GAMESLOTSCHERRY25;break;
	 case idHotSpot17 : command = CM_GAMESLOTSPARADISE25;break;
	 case idHotSpot18 : command = CM_GAMESLOTSLUCKY25;break;
	 case idHotSpot19 : command = CM_GAMESLOTSPIRATE25;break;
	 case idHotSpot20 : command = CM_GAMESLOTSCHERRY10;break;
	 case idHotSpot21 : command = CM_GAMESLOTSLUCKY10;break;
	 case idHotSpot22 : command = CM_GAMESLOTSJOKERS10;break;
	 case idHotSpot23 : command = CM_GAMESLOTSPIRATE10;break;
	 case idHotSpot24 : command = CM_GAMESLOTSTOTAL10;break;
	 case idHotSpot25 : command = CM_GAMESLOTSPIRATE5;break;
	 case idHotSpot26 : command = CM_GAMESLOTSJOKERS5;break;
	 case idHotSpot27 : command = CM_GAMESLOTSCHERRY5;break;
	 case idHotSpot28 : command = CM_GAMESLOTSTOTAL5;break;
	 case idHotSpot29 : command = CM_GAMESLOTSLUCKY5;break;
	 case idHotSpot30 : command = CM_GAMEVPJACK100;break;
	 case idHotSpot31 : command = CM_GAMEVPTEN100;break;
	 case idHotSpot32 : command = CM_GAMEVPJWILD100;break;
	 case idHotSpot33 : command = CM_GAMEVPDWILD100;break;
	 case idHotSpot34 : command = CM_GAMESLOTSLUCKY2;break;
	 case idHotSpot35 : command = CM_GAMESLOTSJUNGLE2;break;
	 case idHotSpot36 : command = CM_GAMESLOTSCHERRY2;break;
	 case idHotSpot37 : command = CM_GAMESLOTSTOTAL2;break;
	 case idHotSpot38 : command = CM_GAMESLOTSPIRATE2;break;
	 case idHotSpot39 : command = CM_GAMEVPDWILD25;break;
	 case idHotSpot40 : command = CM_GAMEVPJWILD25;break;
	 case idHotSpot41 : command = CM_GAMEVPJACK25;break;
	 case idHotSpot42 : command = CM_GAMEVPTEN25;break;
	 case idHotSpot43 : command = CM_GAMESLOTSTOTAL1;break;
	 case idHotSpot44 : command = CM_GAMESLOTSPIRATE1;break;
	 case idHotSpot45 : command = CM_GAMESLOTSLUCKY1;break;
	 case idHotSpot46 : command = CM_GAMESLOTSJUNGLE1;break;
	 case idHotSpot47 : command = CM_GAMESLOTSCHERRY1;break;
	 case idHotSpot48 : command = CM_GAMEVPTEN5;break;
	 case idHotSpot49 : command = CM_GAMEVPDWILD5;break;
	 case idHotSpot50 : command = CM_GAMEVPJWILD5;break;
	 case idHotSpot51 : command = CM_GAMEVPJACK5;break;
	 case idHotSpot52 : command = CM_GAMEVPJWILD1;break;
	 case idHotSpot53 : command = CM_GAMEVPJACK1;break;
	 case idHotSpot54 : command = CM_GAMEVPDWILD1;break;
	 case idHotSpot55 : command = CM_GAMEVPTEN1;break;
	 case idHotSpot56 : command = CM_GAMESLOTSALADDIN1P;break;
	 case idHotSpot57 : command = CM_GAMEVPJACK1P;break;
	 case idHotSpot58 : command = CM_GAMEKENO;break;
	 case idHotSpot59 : command = CM_GAMEROULETTE;break;
	 case idHotSpot60 : command = CM_GAMEBLACKJACKONE;break;
	 case idHotSpot61 : command = CM_GAMECRAPS;break;
  //	 case idSpeed      :  return true;
  //	 default           :  return true;
	 }
    */
    if (command >= 0)
    {
      PModeWin->PostCommandToFW(command);
    }
    return true;
  }
}
//*******************************************************************
void TCasinoLGameLord::SetupResponders()
{
  // to avoid changing responder ctor for now,
  // I spent even more time removing temp's passed
  // as non-const ref params.
  TRect r0(134,53,154,81);
  TRect r1(161,53,181,81);
  TRect r2(204,53,224,81);
  TRect r3(230,53,250,81);
  TRect r4(278,53,298,81);
  TRect r5(300,53,320,81);
  TRect r6(323,53,343,81);
  TRect r7(345,53,365,81);
  TRect r8(367,53,387,81);
  TRect r9(48,98,68,126);
  TRect r10(70,98,90,126);
  TRect r11(92,98,112,126);
  TRect r12(114,98,134,126);
  TRect r13(136,98,156,126);
  TRect r14(202,94,222,122);
  TRect r15(224,93,244,121);
  TRect r16(246,92,266,120);
  TRect r17(268,91,288,119);
  TRect r18(290,90,310,118);
  TRect r19(342,89,362,116);
  TRect r20(364,90,384,117);
  TRect r21(386,91,406,118);
  TRect r22(408,92,428,119);
  TRect r23(432,93,450,120);
  TRect r24(79,185,106,218);
  TRect r25(108,185,135,218);
  TRect r26(137,185,164,217);
  TRect r27(166,184,193,216);
  TRect r28(195,183,222,215);
  TRect r29(451,178,474,204);
  TRect r30(476,178,499,204);
  TRect r31(501,178,524,204);
  TRect r32(526,178,549,204);
  TRect r33(24,231,51,264);
  TRect r34(57,230,84,263);
  TRect r35(89,230,116,262);
  TRect r36(120,227,147,260);
  TRect r37(151,227,178,260);
  TRect r38(479,207,502,233);
  TRect r39(507,207,530,233);
  TRect r40(535,209,558,235);
  TRect r41(564,208,587,235);
  TRect r42(118,278,145,310);
  TRect r43(151,276,178,308);
  TRect r44(184,272,211,305);
  TRect r45(216,270,243,303);
  TRect r46(249,269,276,301);
  TRect r47(506,236,533,268);
  TRect r48(538,238,565,270);
  TRect r49(571,239,598,272);
  TRect r50(605,243,632,275);
  TRect r51(414,269,441,301);
  TRect r52(448,269,475,301);
  TRect r53(482,273,509,305);
  TRect r54(517,273,544,306);
  TRect r55(0,24,107,94);
  TRect r56(509,144,638,174);
  TRect r57(457,7,584,73);
  TRect r58(29,361,227,440);
  TRect r59(241,312,431,416);
  TRect r60(444,343,634,446);
  TRect r61(2,2,633,474);

  TCursorData spade_on(GetOgleApp(),ID_SPADE_ON_CURSOR);
  TCursorData spade_off(GetOgleApp(),ID_SPADE_OFF_CURSOR);

  Responders[0]  = new TResponder(PModeWin,100,r0,idHotSpot1,this,true,'~',spade_on);
  Responders[1]  = new TResponder(PModeWin,100,r1,idHotSpot2,this,true,'~',spade_on);
  Responders[2]  = new TResponder(PModeWin,100,r2,idHotSpot3,this,true,'~',spade_on);
  Responders[3]  = new TResponder(PModeWin,100,r3,idHotSpot4,this,true,'~',spade_on);
  Responders[4]  = new TResponder(PModeWin,100,r4,idHotSpot5,this,true,'~',spade_on);
  Responders[5]  = new TResponder(PModeWin,100,r5,idHotSpot6,this,true,'~',spade_on);
  Responders[6]  = new TResponder(PModeWin,100,r6,idHotSpot7,this,true,'~',spade_on);
  Responders[7]  = new TResponder(PModeWin,100,r7,idHotSpot8,this,true,'~',spade_on);
  Responders[8]  = new TResponder(PModeWin,100,r8,idHotSpot9,this,true,'~',spade_on);
  Responders[9]  = new TResponder(PModeWin,100,r9,idHotSpot10,this,true,'~',spade_on);
  Responders[10] = new TResponder(PModeWin,100,r10,idHotSpot11,this,true,'~',spade_on);
  Responders[11] = new TResponder(PModeWin,100,r11,idHotSpot12,this,true,'~',spade_on);
  Responders[12] = new TResponder(PModeWin,100,r12,idHotSpot13,this,true,'~',spade_on);
  Responders[13] = new TResponder(PModeWin,100,r13,idHotSpot14,this,true,'~',spade_on);
  Responders[14] = new TResponder(PModeWin,100,r14,idHotSpot15,this,true,'~',spade_on);
  Responders[15] = new TResponder(PModeWin,100,r15,idHotSpot16,this,true,'~',spade_on);
  Responders[16] = new TResponder(PModeWin,100,r16,idHotSpot17,this,true,'~',spade_on);
  Responders[17] = new TResponder(PModeWin,100,r17,idHotSpot18,this,true,'~',spade_on);
  Responders[18] = new TResponder(PModeWin,100,r18,idHotSpot19,this,true,'~',spade_on);
  Responders[19] = new TResponder(PModeWin,100,r19,idHotSpot20,this,true,'~',spade_on);
  Responders[20] = new TResponder(PModeWin,100,r20,idHotSpot21,this,true,'~',spade_on);
  Responders[21] = new TResponder(PModeWin,100,r21,idHotSpot22,this,true,'~',spade_on);
  Responders[22] = new TResponder(PModeWin,100,r22,idHotSpot23,this,true,'~',spade_on);
  Responders[23] = new TResponder(PModeWin,100,r23,idHotSpot24,this,true,'~',spade_on);
  Responders[24] = new TResponder(PModeWin,100,r24,idHotSpot25,this,true,'~',spade_on);
  Responders[25] = new TResponder(PModeWin,100,r25,idHotSpot26,this,true,'~',spade_on);
  Responders[26] = new TResponder(PModeWin,100,r26,idHotSpot27,this,true,'~',spade_on);
  Responders[27] = new TResponder(PModeWin,100,r27,idHotSpot28,this,true,'~',spade_on);
  Responders[28] = new TResponder(PModeWin,100,r28,idHotSpot29,this,true,'~',spade_on);
  Responders[29] = new TResponder(PModeWin,100,r29,idHotSpot30,this,true,'~',spade_on);
  Responders[30] = new TResponder(PModeWin,100,r30,idHotSpot31,this,true,'~',spade_on);
  Responders[31] = new TResponder(PModeWin,100,r31,idHotSpot32,this,true,'~',spade_on);
  Responders[32] = new TResponder(PModeWin,100,r32,idHotSpot33,this,true,'~',spade_on);
  Responders[33] = new TResponder(PModeWin,100,r33,idHotSpot34,this,true,'~',spade_on);
  Responders[34] = new TResponder(PModeWin,100,r34,idHotSpot35,this,true,'~',spade_on);
  Responders[35] = new TResponder(PModeWin,100,r35,idHotSpot36,this,true,'~',spade_on);
  Responders[36] = new TResponder(PModeWin,100,r36,idHotSpot37,this,true,'~',spade_on);
  Responders[37] = new TResponder(PModeWin,100,r37,idHotSpot38,this,true,'~',spade_on);
  Responders[38] = new TResponder(PModeWin,100,r38,idHotSpot39,this,true,'~',spade_on);
  Responders[39] = new TResponder(PModeWin,100,r39,idHotSpot40,this,true,'~',spade_on);
  Responders[40] = new TResponder(PModeWin,100,r40,idHotSpot41,this,true,'~',spade_on);
  Responders[41] = new TResponder(PModeWin,100,r41,idHotSpot42,this,true,'~',spade_on);
  Responders[42] = new TResponder(PModeWin,100,r42,idHotSpot43,this,true,'~',spade_on);
  Responders[43] = new TResponder(PModeWin,100,r43,idHotSpot44,this,true,'~',spade_on);
  Responders[44] = new TResponder(PModeWin,100,r44,idHotSpot45,this,true,'~',spade_on);
  Responders[45] = new TResponder(PModeWin,100,r45,idHotSpot46,this,true,'~',spade_on);
  Responders[46] = new TResponder(PModeWin,100,r46,idHotSpot47,this,true,'~',spade_on);
  Responders[47] = new TResponder(PModeWin,100,r47,idHotSpot48,this,true,'~',spade_on);
  Responders[48] = new TResponder(PModeWin,100,r48,idHotSpot49,this,true,'~',spade_on);
  Responders[49] = new TResponder(PModeWin,100,r49,idHotSpot50,this,true,'~',spade_on);
  Responders[50] = new TResponder(PModeWin,100,r50,idHotSpot51,this,true,'~',spade_on);
  Responders[51] = new TResponder(PModeWin,100,r51,idHotSpot52,this,true,'~',spade_on);
  Responders[52] = new TResponder(PModeWin,100,r52,idHotSpot53,this,true,'~',spade_on);
  Responders[53] = new TResponder(PModeWin,100,r53,idHotSpot54,this,true,'~',spade_on);
  Responders[54] = new TResponder(PModeWin,100,r54,idHotSpot55,this,true,'~',spade_on);
  Responders[55] = new TResponder(PModeWin,100,r55,idHotSpot56,this,true,'~',spade_on);
  Responders[56] = new TResponder(PModeWin,100,r56,idHotSpot57,this,true,'~',spade_on);
  Responders[57] = new TResponder(PModeWin,100,r57,idHotSpot58,this,true,'~',spade_on);
  Responders[58] = new TResponder(PModeWin,100,r58,idHotSpot59,this,true,'~',spade_on);
  Responders[59] = new TResponder(PModeWin,100,r59,idHotSpot60,this,true,'~',spade_on);
  Responders[60] = new TResponder(PModeWin,100,r60,idHotSpot61,this,true,'~',spade_on);
  Responders[61] = new TResponder(PModeWin,50,r61,idSpeed,this,true,'~',spade_off);
}
//*******************************************************************
TCasinoLGameLord::TCasinoLGameLord(TLobbyModeWin *pmwin,const TFileMode &fm)
:TCasLobbyGameLord(pmwin,fm,gtNone,TMoney::did_1_00),//cd1),
 MenuEscButton(NULL),
 MessageDisplay(NULL),
 PLow1(NULL),
 PLow2(NULL),
 PLow3(NULL),
 PLow4(NULL),
 PLow5(NULL),
 PLow6(NULL),
 PLow7(NULL),
 PLow8(NULL),
 PWater(NULL)
{
  PState   = new TLLordMainState(this);


  shutdownstate    = 0;
  pMWin  = pmwin;
  activeplayer = 0;
  playersin=0;

  SetupResponders();
  ProgSignKilled = false;

  // build hotspot to msg code table for quick lookup in Respond()
  MsgCodes[idHotSpot1] = 32;
  MsgCodes[idHotSpot2] = 59;
  MsgCodes[idHotSpot3] = 31;
  MsgCodes[idHotSpot4] = 58;
  MsgCodes[idHotSpot5] = 57;
  MsgCodes[idHotSpot6] = 56;
  MsgCodes[idHotSpot7] = 39;
  MsgCodes[idHotSpot8] = 53;
  MsgCodes[idHotSpot9] = 42;
  MsgCodes[idHotSpot10] = 55;
  MsgCodes[idHotSpot11] = 38;
  MsgCodes[idHotSpot12] = 48;
  MsgCodes[idHotSpot13] = 26;
  MsgCodes[idHotSpot14] = 52;
  MsgCodes[idHotSpot15] = 51;
  MsgCodes[idHotSpot16] = 25;
  MsgCodes[idHotSpot17] = 54;
  MsgCodes[idHotSpot18] = 47;
  MsgCodes[idHotSpot19] = 37;
  MsgCodes[idHotSpot20] = 24;
  MsgCodes[idHotSpot21] = 46;
  MsgCodes[idHotSpot22] = 50;
  MsgCodes[idHotSpot23] = 36;
  MsgCodes[idHotSpot24] = 30;
  MsgCodes[idHotSpot25] = 35;
  MsgCodes[idHotSpot26] = 49;
  MsgCodes[idHotSpot27] = 23;
  MsgCodes[idHotSpot28] = 29;
  MsgCodes[idHotSpot29] = 45;
  MsgCodes[idHotSpot30] = 3;
  MsgCodes[idHotSpot31] = 7;
  MsgCodes[idHotSpot32] = 15;
  MsgCodes[idHotSpot33] = 11;
  MsgCodes[idHotSpot34] = 44;
  MsgCodes[idHotSpot35] = 41;
  MsgCodes[idHotSpot36] = 22;
  MsgCodes[idHotSpot37] = 28;
  MsgCodes[idHotSpot38] = 34;
  MsgCodes[idHotSpot39] = 10;
  MsgCodes[idHotSpot40] = 14;
  MsgCodes[idHotSpot41] = 2;
  MsgCodes[idHotSpot42] = 6;
  MsgCodes[idHotSpot43] = 27;
  MsgCodes[idHotSpot44] = 33;
  MsgCodes[idHotSpot45] = 43;
  MsgCodes[idHotSpot46] = 40;
  MsgCodes[idHotSpot47] = 21;
  MsgCodes[idHotSpot48] = 5;
  MsgCodes[idHotSpot49] = 9;
  MsgCodes[idHotSpot50] = 13;
  MsgCodes[idHotSpot51] = 1;
  MsgCodes[idHotSpot52] = 12;
  MsgCodes[idHotSpot53] = 0;
  MsgCodes[idHotSpot54] = 8;
  MsgCodes[idHotSpot55] = 4;
  MsgCodes[idHotSpot56] = 60;
  MsgCodes[idHotSpot57] = 16;
  MsgCodes[idHotSpot58] = 20;
  MsgCodes[idHotSpot59] = 19;
  MsgCodes[idHotSpot60] = 17;
  MsgCodes[idHotSpot61] = 18;

  //build command code table for quick lookup in Respond()
  CmdCodes[idHotSpot1] = CM_GAMESLOTSTOTAL1000;
  CmdCodes[idHotSpot2] = CM_GAMESLOTSSPIRIT1000;
  CmdCodes[idHotSpot3] = CM_GAMESLOTSTOTAL500;
  CmdCodes[idHotSpot4] = CM_GAMESLOTSALADDIN500;
  CmdCodes[idHotSpot5] = CM_GAMESLOTSALADDIN100;
  CmdCodes[idHotSpot6] = CM_GAMESLOTSPARADISE100;
  CmdCodes[idHotSpot7] = CM_GAMESLOTSPIRATE100;
  CmdCodes[idHotSpot8] = CM_GAMESLOTSJOKERS100;
  CmdCodes[idHotSpot9] = CM_GAMESLOTSJUNGLE100;
  CmdCodes[idHotSpot10] = CM_GAMESLOTSPARADISE50;
  CmdCodes[idHotSpot11] = CM_GAMESLOTSPIRATE50;
  CmdCodes[idHotSpot12] = CM_GAMESLOTSLUCKY50;
  CmdCodes[idHotSpot13] = CM_GAMESLOTSCHERRY50;
  CmdCodes[idHotSpot14] = CM_GAMESLOTSJOKERS50;
  CmdCodes[idHotSpot15] = CM_GAMESLOTSJOKERS25;
  CmdCodes[idHotSpot16] = CM_GAMESLOTSCHERRY25;
  CmdCodes[idHotSpot17] = CM_GAMESLOTSPARADISE25;
  CmdCodes[idHotSpot18] = CM_GAMESLOTSLUCKY25;
  CmdCodes[idHotSpot19] = CM_GAMESLOTSPIRATE25;
  CmdCodes[idHotSpot20] = CM_GAMESLOTSCHERRY10;
  CmdCodes[idHotSpot21] = CM_GAMESLOTSLUCKY10;
  CmdCodes[idHotSpot22] = CM_GAMESLOTSJOKERS10;
  CmdCodes[idHotSpot23] = CM_GAMESLOTSPIRATE10;
  CmdCodes[idHotSpot24] = CM_GAMESLOTSTOTAL10;
  CmdCodes[idHotSpot25] = CM_GAMESLOTSPIRATE5;
  CmdCodes[idHotSpot26] = CM_GAMESLOTSJOKERS5;
  CmdCodes[idHotSpot27] = CM_GAMESLOTSCHERRY5;
  CmdCodes[idHotSpot28] = CM_GAMESLOTSTOTAL5;
  CmdCodes[idHotSpot29] = CM_GAMESLOTSLUCKY5;
  CmdCodes[idHotSpot30] = CM_GAMEVPJACK100;
  CmdCodes[idHotSpot31] = CM_GAMEVPTEN100;
  CmdCodes[idHotSpot32] = CM_GAMEVPJWILD100;
  CmdCodes[idHotSpot33] = CM_GAMEVPDWILD100;
  CmdCodes[idHotSpot34] = CM_GAMESLOTSLUCKY2;
  CmdCodes[idHotSpot35] = CM_GAMESLOTSJUNGLE2;
  CmdCodes[idHotSpot36] = CM_GAMESLOTSCHERRY2;
  CmdCodes[idHotSpot37] = CM_GAMESLOTSTOTAL2;
  CmdCodes[idHotSpot38] = CM_GAMESLOTSPIRATE2;
  CmdCodes[idHotSpot39] = CM_GAMEVPDWILD25;
  CmdCodes[idHotSpot40] = CM_GAMEVPJWILD25;
  CmdCodes[idHotSpot41] = CM_GAMEVPJACK25;
  CmdCodes[idHotSpot42] = CM_GAMEVPTEN25;
  CmdCodes[idHotSpot43] = CM_GAMESLOTSTOTAL1;
  CmdCodes[idHotSpot44] = CM_GAMESLOTSPIRATE1;
  CmdCodes[idHotSpot45] = CM_GAMESLOTSLUCKY1;
  CmdCodes[idHotSpot46] = CM_GAMESLOTSJUNGLE1;
  CmdCodes[idHotSpot47] = CM_GAMESLOTSCHERRY1;
  CmdCodes[idHotSpot48] = CM_GAMEVPTEN5;
  CmdCodes[idHotSpot49] = CM_GAMEVPDWILD5;
  CmdCodes[idHotSpot50] = CM_GAMEVPJWILD5;
  CmdCodes[idHotSpot51] = CM_GAMEVPJACK5;
  CmdCodes[idHotSpot52] = CM_GAMEVPJWILD1;
  CmdCodes[idHotSpot53] = CM_GAMEVPJACK1;
  CmdCodes[idHotSpot54] = CM_GAMEVPDWILD1;
  CmdCodes[idHotSpot55] = CM_GAMEVPTEN1;
  CmdCodes[idHotSpot56] = CM_GAMESLOTSALADDIN1P;
  CmdCodes[idHotSpot57] = CM_GAMEVPJACK1P;
  CmdCodes[idHotSpot58] = CM_GAMEKENO;
  CmdCodes[idHotSpot59] = CM_GAMEROULETTE;
  CmdCodes[idHotSpot60] = CM_GAMEBLACKJACKONE;
  CmdCodes[idHotSpot61] = CM_GAMECRAPS;
}
//*******************************************************************
TCasinoLGameLord::~TCasinoLGameLord()
{
  MenuEscButton = NULL;
  MessageDisplay = NULL;
  PLow1 = NULL;
  PLow2 = NULL;
  PLow3 = NULL;
  PLow4 = NULL;
  PLow5 = NULL;
  PLow6 = NULL;
  PLow7 = NULL;
  PLow8 = NULL;
  PWater = NULL;

  if(PState != NULL)
  {
	 delete PState;
	 PState = NULL;
  }
  CleanupResponders();
}
//*******************************************************************
void TCasinoLGameLord::CleanupResponders()
{
  for(int16 i=0;i<NumResponders;i++) {delete Responders[i];}
}
//*******************************************************************
int16 TCasinoLGameLord::InitL()
{
  for(int16 i=0;i<NumResponders-1;i++)
  {
	 Responders[i]->SetEnterLeave(true);
  }
  MenuEscButton->SetCurrentUpFrame(50);
  MenuEscButton->ShowUp();
  SetBJIdle();
  SetCrapIdle();
  SetRouletteIdle();
  SetFountainIdle();
  SetVPSignIdle();
  SetSlotsIdle();
  SetProgSignIdle();
  SetKeno();
  SetHorse();
  SetLight1();
  SetLight2();
  SetLight3();
  SetLight4();
  SetWheel();
  SetEscalator();
//  SetWater(); // water turned on in SetupSprites.
  SetSlot1();
  SetSlot2();
  SetSlot3();
 return 1;
}
//*******************************************************************
void  TCasinoLGameLord::ShuttingDown()
{
  if(shutdownstate == 0)
  {
	 if(GetCasPD(0))
	 {
		NotifyPlayerDeActivation(0);
	 }
	 if(GetCasPD(1))
	 {
		NotifyPlayerDeActivation(1);
	 }
	 if(GetCasPD(2))
	 {
		NotifyPlayerDeActivation(2);
	 }
  }
}
//*******************************************************************
#pragma argsused
void TCasinoLGameLord::NotifyPlayerActivation(int16 slotnum)
{
}
//*******************************************************************
#pragma argsused
void TCasinoLGameLord::NotifyPlayerDeActivation(int16 slotnum)
{
}
//*******************************************************************
#pragma argsused
void TCasinoLGameLord::SetupActivePlayer(int16 slot)
{
}
//*******************************************************************
void TCasinoLGameLord::Update(dword fuc)
{
  if (fuc > 1 &&
      PModeWin->GetSoundMgr() != NULL &&
      !PModeWin->GetSoundMgr()->IsAudioMuted() &&
      PWater != NULL &&
      PWater->GetWav(0) != NULL &&
      PWater->GetWav(0)->GetStopped())
  {
    PWater->GetWav(0)->Start(fuc);
  }

  TCasLobbyGameLord::Update(fuc);
}
//*******************************************************************
void TCasinoLGameLord::TurnOnNext()
{
  switch (GetTurnOffState())
  {
    case 1:SetWheel(0);
           SetTurnOffState(0);
           break;
    case 2:SetEscalator(0);
           SetTurnOffState(1);
           break;
    case 3:SetLight1(0);
           SetLight2(0);
           SetLight3(0);
           SetLight4(0);
           SetTurnOffState(2);
           break;
    case 4://SetProgSignIdle(0);        // don't turn back on because it look to obvious.
           SetTurnOffState(3);
           break;
    case 5:SetKeno(0);
           PLow1->GetAnm(0)->Stop();
           SetTurnOffState(4);
           break;
    case 6:SetVPSignIdle(0);
           PLow4->GetAnm(0)->Stop();
           SetTurnOffState(5);
           break;
    case 7:SetSlotsIdle(0);
           PLow3->GetAnm(0)->Stop();
           SetTurnOffState(6);
           break;
    case 8:SetHorse(0);
           PLow2->GetAnm(0)->Stop();
           SetTurnOffState(7);
           break;
    case 9:SetRouletteIdle(0);
           PLow6->GetAnm(0)->Stop();
           SetTurnOffState(8);
           break;
    case 10:SetCrapIdle(0);
           PLow7->GetAnm(0)->Stop();
           SetTurnOffState(9);
           break;
    case 11:SetBJIdle(0);
            PLow8->GetAnm(0)->Stop();
            SetTurnOffState(10);
            break;
    case 12:SetFountainIdle(0);
            SetTurnOffState(11);
            break;
  }
}
//*******************************************************************
void TCasinoLGameLord::TurnOffNext()
{
  switch (GetTurnOffState())
  {
    case 0:SetWheel(-1);
           SetTurnOffState(1);
           break;
    case 1:SetEscalator(-1);
           SetTurnOffState(2);
           break;
    case 2:SetLight1(-1);
           SetLight2(-1);
           SetLight3(-1);
           SetLight4(-1);
           SetTurnOffState(3);
           break;
    case 3:if (!ProgSignKilled)
           {
             SetProgSignIdle(-1);
             PLow5->GetAnm(0)->Start(GetFUC());
             ProgSignKilled = true;
           }
           SetTurnOffState(4);
           break;
    case 4:SetKeno(-1);
           PLow1->GetAnm(0)->Start(GetFUC());
           SetTurnOffState(5);
           break;
    case 5:SetVPSignIdle(-1);
           PLow4->GetAnm(0)->Start(GetFUC());
           SetTurnOffState(6);
           break;
    case 6:SetSlotsIdle(-1);
           PLow3->GetAnm(0)->Start(GetFUC());
           SetTurnOffState(7);
           break;
    case 7:SetHorse(-1);
           PLow2->GetAnm(0)->Start(GetFUC());
           SetTurnOffState(8);
           break;
    case 8:SetRouletteIdle(-1);
           PLow6->GetAnm(0)->Start(GetFUC());
           SetTurnOffState(9);
           break;
    case 9:SetCrapIdle(-1);
           PLow7->GetAnm(0)->Start(GetFUC());
           SetTurnOffState(10);
           break;
    case 10:SetBJIdle(-1);
            PLow8->GetAnm(0)->Start(GetFUC());
            SetTurnOffState(11);
            break;
    case 11:SetFountainIdle(-1);
            SetTurnOffState(12);
            break;
  }
}
//*******************************************************************
