//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  rgobj.cpp
//    Project Name:  Ogle
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     08/2/95   A. Krist    Original baseline
//*******************************************************************
#include "rgobj.h"
#include "bethead.h"

TRGObj::TRGObj()
{
  int i=0;
  //pGObj  = new TGObjMainState(this);
  cash = 1000;
  credit = 0;
  for(i=0;i<MAXBETS;i++)
  {
	 Bets[i] = NULL;
  }
  top = 0;
}
TRGObj::~TRGObj()
{
  int i=0;
  for(i=0;i<MAXBETS;i++)
  {
	 if(Bets[i] != NULL)
	 {
		delete Bets[i];
		Bets[i] = NULL;
	 }
  }
  top = 0;
}
TRGObj::AddBet(TRSpot betspot,int coins)
{
  switch (betspot) {
	case BETRED   : Bets[top] = new TBetRed(betspot,coins);top++;return 1;
	case BETBLACK : Bets[top] = new TBetBlack(betspot,coins);top++;return 1;
	case BETEVEN  : Bets[top] = new TBetEven(betspot,coins);top++;return 1;
	case BETODD   : Bets[top] = new TBetOdd(betspot,coins);top++;return 1;
	case BET1ST18 : Bets[top] = new TBetRange(betspot,1,18,coins);top++;return 1;
	case BET2ND18 : Bets[top] = new TBetRange(betspot,19,36,coins);top++;return 1;
	case BET1ST12 : Bets[top] = new TBetRange(betspot,1,12,coins);top++;return 1;
	case BET2ND12 : Bets[top] = new TBetRange(betspot,13,24,coins);top++;return 1;
	case BET3RD12 : Bets[top] = new TBetRange(betspot,25,36,coins);top++;return 1;
	case BETCOL1  : Bets[top] = new TBetCol1(betspot,coins);top++;return 1;
	case BETCOL2  : Bets[top] = new TBetCol2(betspot,coins);top++;return 1;
	case BETCOL3  : Bets[top] = new TBetCol3(betspot,coins);top++;return 1;
	case BET1     : Bets[top] = new TBetNum(betspot,1,coins);top++;return 1;
	case BET2     : Bets[top] = new TBetNum(betspot,2,coins);top++;return 1;
	case BET3     : Bets[top] = new TBetNum(betspot,3,coins);top++;return 1;
	case BET4     : Bets[top] = new TBetNum(betspot,4,coins);top++;return 1;
	case BET5     : Bets[top] = new TBetNum(betspot,5,coins);top++;return 1;
	case BET6     : Bets[top] = new TBetNum(betspot,6,coins);top++;return 1;
	case BET7     : Bets[top] = new TBetNum(betspot,7,coins);top++;return 1;
	case BET8     : Bets[top] = new TBetNum(betspot,8,coins);top++;return 1;
	case BET9     : Bets[top] = new TBetNum(betspot,9,coins);top++;return 1;
	case BET10    : Bets[top] = new TBetNum(betspot,10,coins);top++;return 1;
	case BET11    : Bets[top] = new TBetNum(betspot,11,coins);top++;return 1;
	case BET12    : Bets[top] = new TBetNum(betspot,12,coins);top++;return 1;
	case BET13    : Bets[top] = new TBetNum(betspot,13,coins);top++;return 1;
	case BET14    : Bets[top] = new TBetNum(betspot,14,coins);top++;return 1;
	case BET15    : Bets[top] = new TBetNum(betspot,15,coins);top++;return 1;
	case BET16    : Bets[top] = new TBetNum(betspot,16,coins);top++;return 1;
	case BET17    : Bets[top] = new TBetNum(betspot,17,coins);top++;return 1;
	case BET18    : Bets[top] = new TBetNum(betspot,18,coins);top++;return 1;
	case BET19    : Bets[top] = new TBetNum(betspot,19,coins);top++;return 1;
	case BET20    : Bets[top] = new TBetNum(betspot,20,coins);top++;return 1;
	case BET21    : Bets[top] = new TBetNum(betspot,21,coins);top++;return 1;
	case BET22    : Bets[top] = new TBetNum(betspot,22,coins);top++;return 1;
	case BET23    : Bets[top] = new TBetNum(betspot,23,coins);top++;return 1;
	case BET24    : Bets[top] = new TBetNum(betspot,24,coins);top++;return 1;
	case BET25    : Bets[top] = new TBetNum(betspot,25,coins);top++;return 1;
	case BET26    : Bets[top] = new TBetNum(betspot,26,coins);top++;return 1;
	case BET27    : Bets[top] = new TBetNum(betspot,27,coins);top++;return 1;
	case BET28    : Bets[top] = new TBetNum(betspot,28,coins);top++;return 1;
	case BET29    : Bets[top] = new TBetNum(betspot,29,coins);top++;return 1;
	case BET30    : Bets[top] = new TBetNum(betspot,30,coins);top++;return 1;
	case BET31    : Bets[top] = new TBetNum(betspot,31,coins);top++;return 1;
	case BET32    : Bets[top] = new TBetNum(betspot,32,coins);top++;return 1;
	case BET33    : Bets[top] = new TBetNum(betspot,33,coins);top++;return 1;
	case BET34    : Bets[top] = new TBetNum(betspot,34,coins);top++;return 1;
	case BET35    : Bets[top] = new TBetNum(betspot,35,coins);top++;return 1;
	case BET36    : Bets[top] = new TBetNum(betspot,36,coins);top++;return 1;
	case BET0     : Bets[top] = new TBetNum(betspot,0,coins);top++;return 1;
	case BET00    : Bets[top] = new TBetNum(betspot,37,coins);top++;return 1;
	case BET1ST3  : Bets[top] = new TBetRange(betspot,1,3,coins);top++;return 1;
	case BET2ND3  : Bets[top] = new TBetRange(betspot,4,6,coins);top++;return 1;
	case BET3RD3  : Bets[top] = new TBetRange(betspot,7,9,coins);top++;return 1;
	case BET4TH3  : Bets[top] = new TBetRange(betspot,10,12,coins);top++;return 1;
	case BET5TH3  : Bets[top] = new TBetRange(betspot,13,15,coins);top++;return 1;
	case BET6TH3  : Bets[top] = new TBetRange(betspot,16,18,coins);top++;return 1;
	case BET7TH3  : Bets[top] = new TBetRange(betspot,19,21,coins);top++;return 1;
	case BET8TH3  : Bets[top] = new TBetRange(betspot,22,24,coins);top++;return 1;
	case BET9TH3  : Bets[top] = new TBetRange(betspot,25,27,coins);top++;return 1;
	case BET10TH3 : Bets[top] = new TBetRange(betspot,28,30,coins);top++;return 1;
	case BET11TH3 : Bets[top] = new TBetRange(betspot,31,33,coins);top++;return 1;
	case BET12TH3 : Bets[top] = new TBetRange(betspot,34,36,coins);top++;return 1;
	case BET1ST6  : Bets[top] = new TBetRange(betspot,1,6,coins);top++;return 1;
	case BET2ND6  : Bets[top] = new TBetRange(betspot,4,9,coins);top++;return 1;
	case BET3RD6  : Bets[top] = new TBetRange(betspot,7,12,coins);top++;return 1;
	case BET4TH6  : Bets[top] = new TBetRange(betspot,10,15,coins);top++;return 1;
	case BET5TH6  : Bets[top] = new TBetRange(betspot,13,18,coins);top++;return 1;
	case BET6TH6  : Bets[top] = new TBetRange(betspot,16,21,coins);top++;return 1;
	case BET7TH6  : Bets[top] = new TBetRange(betspot,19,24,coins);top++;return 1;
	case BET8TH6  : Bets[top] = new TBetRange(betspot,22,27,coins);top++;return 1;
	case BET9TH6  : Bets[top] = new TBetRange(betspot,25,30,coins);top++;return 1;
	case BET10TH6 : Bets[top] = new TBetRange(betspot,28,33,coins);top++;return 1;
	case BET11TH6 : Bets[top] = new TBetRange(betspot,31,36,coins);top++;return 1;
	case BET1ST4  : Bets[top] = new TBet4num(betspot,1,2,4,5,coins);top++;return 1;
	case BET2ND4  : Bets[top] = new TBet4num(betspot,2,3,5,6,coins);top++;return 1;
	case BET3RD4  : Bets[top] = new TBet4num(betspot,4,5,7,8,coins);top++;return 1;
	case BET4TH4  : Bets[top] = new TBet4num(betspot,5,6,8,9,coins);top++;return 1;
	case BET5TH4  : Bets[top] = new TBet4num(betspot,7,8,10,11,coins);top++;return 1;
	case BET6TH4  : Bets[top] = new TBet4num(betspot,8,9,11,12,coins);top++;return 1;
	case BET7TH4  : Bets[top] = new TBet4num(betspot,10,11,13,14,coins);top++;return 1;
	case BET8TH4  : Bets[top] = new TBet4num(betspot,11,12,14,15,coins);top++;return 1;
	case BET9TH4  : Bets[top] = new TBet4num(betspot,13,14,16,17,coins);top++;return 1;
	case BET10TH4 : Bets[top] = new TBet4num(betspot,14,15,17,18,coins);top++;return 1;
	case BET11TH4 : Bets[top] = new TBet4num(betspot,16,17,19,20,coins);top++;return 1;
	case BET12TH4 : Bets[top] = new TBet4num(betspot,17,18,20,21,coins);top++;return 1;
	case BET13TH4 : Bets[top] = new TBet4num(betspot,19,20,22,23,coins);top++;return 1;
	case BET14TH4 : Bets[top] = new TBet4num(betspot,20,21,23,24,coins);top++;return 1;
	case BET15TH4 : Bets[top] = new TBet4num(betspot,22,23,25,26,coins);top++;return 1;
	case BET16TH4 : Bets[top] = new TBet4num(betspot,23,24,26,27,coins);top++;return 1;
	case BET17TH4 : Bets[top] = new TBet4num(betspot,25,26,28,29,coins);top++;return 1;
	case BET18TH4 : Bets[top] = new TBet4num(betspot,26,27,29,30,coins);top++;return 1;
	case BET19TH4 : Bets[top] = new TBet4num(betspot,28,29,31,32,coins);top++;return 1;
	case BET20TH4 : Bets[top] = new TBet4num(betspot,29,30,32,33,coins);top++;return 1;
	case BET21TH4 : Bets[top] = new TBet4num(betspot,31,32,34,35,coins);top++;return 1;
	case BET22TH4 : Bets[top] = new TBet4num(betspot,32,33,35,36,coins);top++;return 1;
	case BET1ST2  : Bets[top] = new TBet2num(betspot,0,37,coins);top++;return 1;
	case BET2ND2  : Bets[top] = new TBet2num(betspot,0,1,coins);top++;return 1;
	case BET3RD2  : Bets[top] = new TBet2num(betspot,0,2,coins);top++;return 1;
	case BET4TH2  : Bets[top] = new TBet2num(betspot,2,37,coins);top++;return 1;
	case BET5TH2  : Bets[top] = new TBet2num(betspot,3,37,coins);top++;return 1;
	case BET6TH2  : Bets[top] = new TBet2num(betspot,1,2,coins);top++;return 1;
	case BET7TH2  : Bets[top] = new TBet2num(betspot,2,3,coins);top++;return 1;
	case BET8TH2  : Bets[top] = new TBet2num(betspot,1,4,coins);top++;return 1;
	case BET9TH2  : Bets[top] = new TBet2num(betspot,2,5,coins);top++;return 1;
	case BET10TH2 : Bets[top] = new TBet2num(betspot,3,6,coins);top++;return 1;
	case BET11TH2 : Bets[top] = new TBet2num(betspot,4,5,coins);top++;return 1;
	case BET12TH2 : Bets[top] = new TBet2num(betspot,5,6,coins);top++;return 1;
	case BET13TH2 : Bets[top] = new TBet2num(betspot,4,7,coins);top++;return 1;
	case BET14TH2 : Bets[top] = new TBet2num(betspot,5,8,coins);top++;return 1;
	case BET15TH2 : Bets[top] = new TBet2num(betspot,6,9,coins);top++;return 1;
	case BET16TH2 : Bets[top] = new TBet2num(betspot,7,8,coins);top++;return 1;
	case BET17TH2 : Bets[top] = new TBet2num(betspot,8,9,coins);top++;return 1;
	case BET18TH2 : Bets[top] = new TBet2num(betspot,7,10,coins);top++;return 1;
	case BET19TH2 : Bets[top] = new TBet2num(betspot,8,11,coins);top++;return 1;
	case BET20TH2 : Bets[top] = new TBet2num(betspot,9,12,coins);top++;return 1;
	case BET21TH2 : Bets[top] = new TBet2num(betspot,10,11,coins);top++;return 1;
	case BET22TH2 : Bets[top] = new TBet2num(betspot,11,12,coins);top++;return 1;
	case BET23TH2 : Bets[top] = new TBet2num(betspot,10,13,coins);top++;return 1;
	case BET24TH2 : Bets[top] = new TBet2num(betspot,11,14,coins);top++;return 1;
	case BET25TH2 : Bets[top] = new TBet2num(betspot,12,15,coins);top++;return 1;
	case BET26TH2 : Bets[top] = new TBet2num(betspot,13,14,coins);top++;return 1;
	case BET27TH2 : Bets[top] = new TBet2num(betspot,14,15,coins);top++;return 1;
	case BET28TH2 : Bets[top] = new TBet2num(betspot,13,16,coins);top++;return 1;
	case BET29TH2 : Bets[top] = new TBet2num(betspot,14,17,coins);top++;return 1;
	case BET30TH2 : Bets[top] = new TBet2num(betspot,15,18,coins);top++;return 1;
	case BET31TH2 : Bets[top] = new TBet2num(betspot,16,17,coins);top++;return 1;
	case BET32TH2 : Bets[top] = new TBet2num(betspot,17,18,coins);top++;return 1;
	case BET33TH2 : Bets[top] = new TBet2num(betspot,16,19,coins);top++;return 1;
	case BET34TH2 : Bets[top] = new TBet2num(betspot,17,20,coins);top++;return 1;
	case BET35TH2 : Bets[top] = new TBet2num(betspot,18,21,coins);top++;return 1;
	case BET36TH2 : Bets[top] = new TBet2num(betspot,19,20,coins);top++;return 1;
	case BET37TH2 : Bets[top] = new TBet2num(betspot,20,21,coins);top++;return 1;
	case BET38TH2 : Bets[top] = new TBet2num(betspot,19,22,coins);top++;return 1;
	case BET39TH2 : Bets[top] = new TBet2num(betspot,20,23,coins);top++;return 1;
	case BET40TH2 : Bets[top] = new TBet2num(betspot,21,24,coins);top++;return 1;
	case BET41TH2 : Bets[top] = new TBet2num(betspot,22,23,coins);top++;return 1;
	case BET42TH2 : Bets[top] = new TBet2num(betspot,23,24,coins);top++;return 1;
	case BET43TH2 : Bets[top] = new TBet2num(betspot,22,25,coins);top++;return 1;
	case BET44TH2 : Bets[top] = new TBet2num(betspot,23,26,coins);top++;return 1;
	case BET45TH2 : Bets[top] = new TBet2num(betspot,24,27,coins);top++;return 1;
	case BET46TH2 : Bets[top] = new TBet2num(betspot,25,26,coins);top++;return 1;
	case BET47TH2 : Bets[top] = new TBet2num(betspot,26,27,coins);top++;return 1;
	case BET48TH2 : Bets[top] = new TBet2num(betspot,25,28,coins);top++;return 1;
	case BET49TH2 : Bets[top] = new TBet2num(betspot,26,29,coins);top++;return 1;
	case BET50TH2 : Bets[top] = new TBet2num(betspot,27,30,coins);top++;return 1;
	case BET51TH2 : Bets[top] = new TBet2num(betspot,28,29,coins);top++;return 1;
	case BET52TH2 : Bets[top] = new TBet2num(betspot,29,30,coins);top++;return 1;
	case BET53TH2 : Bets[top] = new TBet2num(betspot,28,31,coins);top++;return 1;
	case BET54TH2 : Bets[top] = new TBet2num(betspot,29,32,coins);top++;return 1;
	case BET55TH2 : Bets[top] = new TBet2num(betspot,30,33,coins);top++;return 1;
	case BET56TH2 : Bets[top] = new TBet2num(betspot,31,32,coins);top++;return 1;
	case BET57TH2 : Bets[top] = new TBet2num(betspot,32,33,coins);top++;return 1;
	case BET58TH2 : Bets[top] = new TBet2num(betspot,31,34,coins);top++;return 1;
	case BET59TH2 : Bets[top] = new TBet2num(betspot,32,35,coins);top++;return 1;
	case BET60TH2 : Bets[top] = new TBet2num(betspot,33,36,coins);top++;return 1;
	default       :   return 0;
  }
}
TRGObj::Winnings(int winnum)
{
  int i=0;
  for(i=0;i<top;i++)
  {
	 if(Bets[i] != NULL)
	 {
		if(Bets[i]->Win(winnum))
		{
		  cash += Bets[i]->Win(winnum);
		}
		delete Bets[i];
		Bets[i] = NULL;
	 }
  }
  cout << "Total cash -> " << cash << endl;
  top = 0;
}

