//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  betnum.cpp
//    Project Name:  Casino
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0    12/21/96   M.Perry     moved into cpp
//  2.0    09/19/97   M.Perry     32-bit conversion.
//********************************************************************
#include "betnum.h"
#include "oanm.h"
//*******************************************************************
TBetNum::TBetNum(int16 Num1,TOgleModeWindow *pmw,TFileMode NewFileMode,int16 code)
:TRBetSpot(pmw,NewFileMode,code)
{
  num1 = Num1;
  SpotType = SingleNum;
  PMarker = GetAnm(19);
  PMarker->CAD.ClearAutoStart();
  PMarker->CAD.ClearAutoStop();
  PMarker->CAD.SetDirStill();
}
//*******************************************************************
TBetNum::TBetNum(int16 Num1,TOgleModeWindow *pmw,TFileMode NewFileMode,void *psource,int16 code)
:TRBetSpot(pmw,NewFileMode,psource,code)
{
  num1 = Num1;
  SpotType = SingleNum;
  PMarker = GetAnm(19);
  PMarker->CAD.ClearAutoStart();
  PMarker->CAD.ClearAutoStop();
  PMarker->CAD.SetDirStill();
}
//*******************************************************************
TBetNum::~TBetNum()
{
}
//*******************************************************************
void TBetNum::ShowMarker()
{
  PMarker->CAD.SetY(TopY);
  PMarker->CAD.SetZ(TopZ);
  PMarker->Show();
  Update(GetAdjFUC());
}
//*******************************************************************
void TBetNum::ShowMarkerDown()
{
  PMarker->ResetCurrentData();
  PMarker->Show();
  Update(GetAdjFUC());
}
//*******************************************************************
void TBetNum::NoShowMarker()
{
 PMarker->NoShow();
}
//*******************************************************************
bool TBetNum::Winner(int16 WinNum)
{
  if(WinNum == num1)
  {
	 return true;
  }
  else
  {
	 return false;
  }
}
//*******************************************************************
bool TBetNum::Winner(int16 WinNum,int16 Player)
{
  return TRBetSpot::Winner(WinNum,Player);
}
//*******************************************************************
int32 TBetNum::Odds()
{
  return 35;
}
//*******************************************************************