//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  cr1gld.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     3/25/96    M.Perry    original baseline
//  2.0    09/19/97    M.Perry    32-bit conversion.
//  2.3    07/14/99    M.Perry    gobjlist removal
//********************************************************************
#include "cr1gld.h"
#include "casnames.rh"
#include "crnames.rh"
#include "ogamefw.h"

//#include "cr1glspl.h"
#include "oskitcat.h"
#include "orespond.h"
#include "oanm.h"
#include "owav.h"
//*******************************************************************
//TSpriteList *TR1GameLord::CreateSpriteList(TFileMode splfm)
//{
//  return (new TR1GLordSpriteList(PModeWin,splfm,this));
//}
//*******************************************************************
void TR1GameLord::SetupSkits()
{
  greetplayers              = GetSkitListIndex(GetResString(IDS_KCL_GREETPLAYERS_R1));
  if (greetplayers == -1)     {SpriteError("greetplayers",GetResString(IDS_KCL_GREETPLAYERS_R1));}

  placebets                 = GetSkitListIndex(GetResString(IDS_KCL_PLACEBETS_R1));
  if (placebets == -1)        {SpriteError("PlaceBets",GetResString(IDS_KCL_PLACEBETS_R1));}

  prespincom                = GetSkitListIndex(GetResString(IDS_KCL_PRESPINCOM_R1));
  if (prespincom == -1)       {SpriteError("PreSpinCom",GetResString(IDS_KCL_PRESPINCOM_R1));}

  winner                   = GetSkitListIndex(GetResString(IDS_KCL_WINNER_R1));
  if (winner == -1)          {SpriteError("Wineer",GetResString(IDS_KCL_WINNER_R1));}

//  winbetscom                   = GetSkitListIndex(GetResString(IDS_KCL_WINBETSCOM_R1));
//  if (winbetscom == -1)          {SpriteError("Winbetscom",GetResString(IDS_KCL_WINBETSCOM_R1));}

  result                   = GetSkitListIndex(GetResString(IDS_KCL_RESULT_R1));
  if (result == -1)          {SpriteError("Result",GetResString(IDS_KCL_RESULT_R1));}

  finalresult                   = GetSkitListIndex(GetResString(IDS_KCL_FINALRESULT_R1));
  if (finalresult == -1)          {SpriteError("Result",GetResString(IDS_KCL_FINALRESULT_R1));}

  payoff                   = GetSkitListIndex(GetResString(IDS_KCL_PAYOFFCOM_R1));
  if (payoff == -1)          {SpriteError("PayOff",GetResString(IDS_KCL_PAYOFFCOM_R1));}

  loser                    = GetSkitListIndex(GetResString(IDS_KCL_LOSER_R1));
  if (loser == -1)           {SpriteError("Loser",GetResString(IDS_KCL_LOSER_R1));}

  spincom                  = GetSkitListIndex(GetResString(IDS_KCL_SPINCOM_R1));
  if (spincom == -1) {SpriteError("SpinCom",GetResString(IDS_KCL_SPINCOM_R1));}

}
//*******************************************************************
void TR1GameLord::SetupSprites()
{                              /*
  for(int16 i=0;i<156;i++)
  {
	 BetSpot[i]        = NULL;
  }
  RSounds            = NULL;
  NumberHistory      = NULL;
  Button1            = NULL;
  Button2            = NULL;
  Button3            = NULL;
  Button4            = NULL;
  ButtonChip1        = NULL;
  ButtonChip5        = NULL;
  ButtonChip25       = NULL;
  ButtonChip100      = NULL;
  ButtonChip1000     = NULL;
  ButtonChip10000    = NULL;
  AskExpertButton    = NULL;
  MenuEscButton      = NULL;
  Chips              = NULL;
//  BetUnitChips       = NULL;
  CasStatusBar       = NULL;
  NamePlate1         = NULL;
  NamePlate2         = NULL;
  NamePlate3         = NULL;
  PayOffSp           = NULL;
  Marker             = NULL;
  MessageDisplay     = NULL;
  BankCashDisplay    = NULL;
  BetAmountDisplay   = NULL; */
  dealerspin1        = 0;
  dealerspin2        = 0;
  dealerspin3        = 0;
  removechips        = 0;
  ballspin           = 0;
  ballhand           = 0;
  spinsound          = 0;
  for(int16 i=0;i<38;i++)
  {
	 BallDrops[i] = 0;
  }
  removechips        = GetSpriteIndex(GetResString(IDS_AS_REMOVECHIPS_R1));
  placemarker1       = GetSpriteIndex(GetResString(IDS_AS_PLACEMARKER1_R1));
  placemarker2       = GetSpriteIndex(GetResString(IDS_AS_PLACEMARKER2_R1));
  placemarker3       = GetSpriteIndex(GetResString(IDS_AS_PLACEMARKER3_R1));
  placemarker4       = GetSpriteIndex(GetResString(IDS_AS_PLACEMARKER4_R1));
  placemarker5       = GetSpriteIndex(GetResString(IDS_AS_PLACEMARKER5_R1));
  placemarker6       = GetSpriteIndex(GetResString(IDS_AS_PLACEMARKER6_R1));
  placemarker7       = GetSpriteIndex(GetResString(IDS_AS_PLACEMARKER7_R1));
  removemarker1       = GetSpriteIndex(GetResString(IDS_AS_REMOVEMARKER1_R1));
  removemarker2       = GetSpriteIndex(GetResString(IDS_AS_REMOVEMARKER2_R1));
  removemarker3       = GetSpriteIndex(GetResString(IDS_AS_REMOVEMARKER3_R1));
  removemarker4       = GetSpriteIndex(GetResString(IDS_AS_REMOVEMARKER4_R1));
  removemarker5       = GetSpriteIndex(GetResString(IDS_AS_REMOVEMARKER5_R1));
  dealerspin1        = GetSpriteIndex(GetResString(IDS_AS_DEALERSPIN1_R1));
  dealerspin2        = GetSpriteIndex(GetResString(IDS_AS_DEALERSPIN2_R1));
  dealerspin3        = GetSpriteIndex(GetResString(IDS_AS_DEALERSPIN3_R1));
  ballspin           = GetSpriteIndex(GetResString(IDS_AS_BALLSPIN_R1));
  spinsound          = GetSpriteIndex(GetResString(IDS_AS_SPINSOUND_R1));
  ballhand           = GetSpriteIndex(GetResString(IDS_AS_BALLHAND_R1));

  GetSpritePtr(spinsound)->GetWav(0)->LoopCount=10;//Some Max value

  BallDrops[0]        = GetSpriteIndex(GetResString(IDS_AS_BALLDROP0_R1));
  BallDrops[1]        = GetSpriteIndex(GetResString(IDS_AS_BALLDROP01_R1));
  BallDrops[2]        = GetSpriteIndex(GetResString(IDS_AS_BALLDROP02_R1));
  BallDrops[3]        = GetSpriteIndex(GetResString(IDS_AS_BALLDROP03_R1));
  BallDrops[4]        = GetSpriteIndex(GetResString(IDS_AS_BALLDROP04_R1));
  BallDrops[5]        = GetSpriteIndex(GetResString(IDS_AS_BALLDROP05_R1));
  BallDrops[6]        = GetSpriteIndex(GetResString(IDS_AS_BALLDROP06_R1));
  BallDrops[7]        = GetSpriteIndex(GetResString(IDS_AS_BALLDROP07_R1));
  BallDrops[8]        = GetSpriteIndex(GetResString(IDS_AS_BALLDROP08_R1));
  BallDrops[9]        = GetSpriteIndex(GetResString(IDS_AS_BALLDROP09_R1));
  BallDrops[10]       = GetSpriteIndex(GetResString(IDS_AS_BALLDROP10_R1));
  BallDrops[11]       = GetSpriteIndex(GetResString(IDS_AS_BALLDROP11_R1));
  BallDrops[12]       = GetSpriteIndex(GetResString(IDS_AS_BALLDROP12_R1));
  BallDrops[13]       = GetSpriteIndex(GetResString(IDS_AS_BALLDROP13_R1));
  BallDrops[14]       = GetSpriteIndex(GetResString(IDS_AS_BALLDROP14_R1));
  BallDrops[15]       = GetSpriteIndex(GetResString(IDS_AS_BALLDROP15_R1));
  BallDrops[16]       = GetSpriteIndex(GetResString(IDS_AS_BALLDROP16_R1));
  BallDrops[17]       = GetSpriteIndex(GetResString(IDS_AS_BALLDROP17_R1));
  BallDrops[18]       = GetSpriteIndex(GetResString(IDS_AS_BALLDROP18_R1));
  BallDrops[19]       = GetSpriteIndex(GetResString(IDS_AS_BALLDROP19_R1));
  BallDrops[20]       = GetSpriteIndex(GetResString(IDS_AS_BALLDROP20_R1));
  BallDrops[21]       = GetSpriteIndex(GetResString(IDS_AS_BALLDROP21_R1));
  BallDrops[22]       = GetSpriteIndex(GetResString(IDS_AS_BALLDROP22_R1));
  BallDrops[23]       = GetSpriteIndex(GetResString(IDS_AS_BALLDROP23_R1));
  BallDrops[24]       = GetSpriteIndex(GetResString(IDS_AS_BALLDROP24_R1));
  BallDrops[25]       = GetSpriteIndex(GetResString(IDS_AS_BALLDROP25_R1));
  BallDrops[26]       = GetSpriteIndex(GetResString(IDS_AS_BALLDROP26_R1));
  BallDrops[27]       = GetSpriteIndex(GetResString(IDS_AS_BALLDROP27_R1));
  BallDrops[28]       = GetSpriteIndex(GetResString(IDS_AS_BALLDROP28_R1));
  BallDrops[29]       = GetSpriteIndex(GetResString(IDS_AS_BALLDROP29_R1));
  BallDrops[30]       = GetSpriteIndex(GetResString(IDS_AS_BALLDROP30_R1));
  BallDrops[31]       = GetSpriteIndex(GetResString(IDS_AS_BALLDROP31_R1));
  BallDrops[32]       = GetSpriteIndex(GetResString(IDS_AS_BALLDROP32_R1));
  BallDrops[33]       = GetSpriteIndex(GetResString(IDS_AS_BALLDROP33_R1));
  BallDrops[34]       = GetSpriteIndex(GetResString(IDS_AS_BALLDROP34_R1));
  BallDrops[35]       = GetSpriteIndex(GetResString(IDS_AS_BALLDROP35_R1));
  BallDrops[36]       = GetSpriteIndex(GetResString(IDS_AS_BALLDROP36_R1));
  BallDrops[37]       = GetSpriteIndex(GetResString(IDS_AS_BALLDROP00_R1));

  /*BetSpot[0]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS0_R1));
  BetSpot[1]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS1_R1));
  BetSpot[2]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS2_R1));
  BetSpot[3]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS3_R1));
  BetSpot[4]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS4_R1));
  BetSpot[5]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS5_R1));
  BetSpot[6]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS6_R1));
  BetSpot[7]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS7_R1));
  BetSpot[8]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS8_R1));
  BetSpot[9]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS9_R1));
  BetSpot[10]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS10_R1));
  BetSpot[11]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS11_R1));
  BetSpot[12]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS12_R1));
  BetSpot[13]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS13_R1));
  BetSpot[14]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS14_R1));
  BetSpot[15]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS15_R1));
  BetSpot[16]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS16_R1));
  BetSpot[17]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS17_R1));
  BetSpot[18]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS18_R1));
  BetSpot[19]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS19_R1));
  BetSpot[20]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS20_R1));
  BetSpot[21]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS21_R1));
  BetSpot[22]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS22_R1));
  BetSpot[23]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS23_R1));
  BetSpot[24]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS24_R1));
  BetSpot[25]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS25_R1));
  BetSpot[26]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS26_R1));
  BetSpot[27]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS27_R1));
  BetSpot[28]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS28_R1));
  BetSpot[29]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS29_R1));
  BetSpot[30]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS30_R1));
  BetSpot[31]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS31_R1));
  BetSpot[32]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS32_R1));
  BetSpot[33]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS33_R1));
  BetSpot[34]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS34_R1));
  BetSpot[35]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS35_R1));
  BetSpot[36]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS36_R1));
  BetSpot[37]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS37_R1));
  BetSpot[38]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS38_R1));
  BetSpot[39]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS39_R1));
  BetSpot[40]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS40_R1));
  BetSpot[41]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS41_R1));
  BetSpot[42]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS42_R1));
  BetSpot[43]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS43_R1));
  BetSpot[44]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS44_R1));
  BetSpot[45]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS45_R1));
  BetSpot[46]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS46_R1));
  BetSpot[47]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS47_R1));
  BetSpot[48]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS48_R1));
  BetSpot[49]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS49_R1));
  BetSpot[50]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS50_R1));
  BetSpot[51]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS51_R1));
  BetSpot[52]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS52_R1));
  BetSpot[53]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS53_R1));
  BetSpot[54]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS54_R1));
  BetSpot[55]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS55_R1));
  BetSpot[56]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS56_R1));
  BetSpot[57]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS57_R1));
  BetSpot[58]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS58_R1));
  BetSpot[59]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS59_R1));
  BetSpot[60]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS60_R1));
  BetSpot[61]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS61_R1));
  BetSpot[62]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS62_R1));
  BetSpot[63]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS63_R1));
  BetSpot[64]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS64_R1));
  BetSpot[65]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS65_R1));
  BetSpot[66]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS66_R1));
  BetSpot[67]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS67_R1));
  BetSpot[68]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS68_R1));
  BetSpot[69]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS69_R1));
  BetSpot[70]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS70_R1));
  BetSpot[71]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS71_R1));
  BetSpot[72]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS72_R1));
  BetSpot[73]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS73_R1));
  BetSpot[74]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS74_R1));
  BetSpot[75]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS75_R1));
  BetSpot[76]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS76_R1));
  BetSpot[77]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS77_R1));
  BetSpot[78]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS78_R1));
  BetSpot[79]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS79_R1));
  BetSpot[80]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS80_R1));
  BetSpot[81]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS81_R1));
  BetSpot[82]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS82_R1));
  BetSpot[83]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS83_R1));
  BetSpot[84]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS84_R1));
  BetSpot[85]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS85_R1));
  BetSpot[86]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS86_R1));
  BetSpot[87]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS87_R1));
  BetSpot[88]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS88_R1));
  BetSpot[89]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS89_R1));
  BetSpot[90]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS90_R1));
  BetSpot[91]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS91_R1));
  BetSpot[92]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS92_R1));
  BetSpot[93]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS93_R1));
  BetSpot[94]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS94_R1));
  BetSpot[95]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS95_R1));
  BetSpot[96]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS96_R1));
  BetSpot[97]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS97_R1));
  BetSpot[98]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS98_R1));
  BetSpot[99]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS99_R1));
  BetSpot[100]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS100_R1));
  BetSpot[101]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS101_R1));
  BetSpot[102]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS102_R1));
  BetSpot[103]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS103_R1));
  BetSpot[104]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS104_R1));
  BetSpot[105]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS105_R1));
  BetSpot[106]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS106_R1));
  BetSpot[107]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS107_R1));
  BetSpot[108]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS108_R1));
  BetSpot[109]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS109_R1));
  BetSpot[110]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS110_R1));
  BetSpot[111]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS111_R1));
  BetSpot[112]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS112_R1));
  BetSpot[113]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS113_R1));
  BetSpot[114]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS114_R1));
  BetSpot[115]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS115_R1));
  BetSpot[116]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS116_R1));
  BetSpot[117]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS117_R1));
  BetSpot[118]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS118_R1));
  BetSpot[119]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS119_R1));
  BetSpot[120]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS120_R1));
  BetSpot[121]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS121_R1));
  BetSpot[122]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS122_R1));
  BetSpot[123]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS123_R1));
  BetSpot[124]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS124_R1));
  BetSpot[125]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS125_R1));
  BetSpot[126]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS126_R1));
  BetSpot[127]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS127_R1));
  BetSpot[128]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS128_R1));
  BetSpot[129]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS129_R1));
  BetSpot[130]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS130_R1));
  BetSpot[131]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS131_R1));
  BetSpot[132]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS132_R1));
  BetSpot[133]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS133_R1));
  BetSpot[134]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS134_R1));
  BetSpot[135]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS135_R1));
  BetSpot[136]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS136_R1));
  BetSpot[137]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS137_R1));
  BetSpot[138]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS138_R1));
  BetSpot[139]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS139_R1));
  BetSpot[140]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS140_R1));
  BetSpot[141]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS141_R1));
  BetSpot[142]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS142_R1));
  BetSpot[143]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS143_R1));
  BetSpot[144]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS144_R1));
  BetSpot[145]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS145_R1));
  BetSpot[146]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS146_R1));
  BetSpot[147]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS147_R1));
  BetSpot[148]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS148_R1));
  BetSpot[149]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS149_R1));
  BetSpot[150]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS150_R1));
  BetSpot[151]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS151_R1));
  BetSpot[152]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS152_R1));
  BetSpot[153]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS153_R1));
  BetSpot[154]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS154_R1));
  BetSpot[155]         = (TRBetSpot *)            GetSpritePtr(GetResString(IDS_MS_BS155_R1));

  RSounds            = (TRSound                *) GetSpritePtr(GetResString(IDS_MS_SOUND_R1));
  MenuEscButton      = (TCasButton             *) GetSpritePtr(GetResString(IDS_MS_B0_R1));
  Button1            = (TCasButton             *) GetSpritePtr(GetResString(IDS_MS_B1_R1));
  Button2            = (TCasButton             *) GetSpritePtr(GetResString(IDS_MS_B2_R1));
  Button3            = (TCasButton             *) GetSpritePtr(GetResString(IDS_MS_B3_R1));
  Button4            = (TCasButton             *) GetSpritePtr(GetResString(IDS_MS_B4_R1));
  ButtonChip1        = (TCasButton             *) GetSpritePtr(GetResString(IDS_MS_BC1_R1));
  ButtonChip5        = (TCasButton             *) GetSpritePtr(GetResString(IDS_MS_BC5_R1));
  ButtonChip25       = (TCasButton             *) GetSpritePtr(GetResString(IDS_MS_BC25_R1));
  ButtonChip100      = (TCasButton             *) GetSpritePtr(GetResString(IDS_MS_BC100_R1));
  ButtonChip1000     = (TCasButton             *) GetSpritePtr(GetResString(IDS_MS_BC1000_R1));
  ButtonChip10000    = (TCasButton             *) GetSpritePtr(GetResString(IDS_MS_BC10000_R1));
  AskExpertButton    = (TCasButton             *) GetSpritePtr(GetResString(IDS_MS_B5_R1));
  CasStatusBar       = (TCasButton             *) GetSpritePtr(GetResString(IDS_MS_SB_R1));
  Chips              = (TCasChips             *) GetSpritePtr(GetResString(IDS_MS_CHIPS_R1));
//  BetUnitChips       = (TBetUnitChips         *) GetSpritePtr(GetResString(IDS_MS_BETUNITCHIPS_R1));
  NumberHistory      = (TRNumberHistory       *) GetSpritePtr(GetResString(IDS_MS_NUMHIS_R1));
  NamePlate1         = (TCasNamePlate         *) GetSpritePtr(GetResString(IDS_MS_NP1_R1));
  NamePlate2         = (TCasNamePlate         *) GetSpritePtr(GetResString(IDS_MS_NP2_R1));
  NamePlate3         = (TCasNamePlate         *) GetSpritePtr(GetResString(IDS_MS_NP3_R1));
  PayOffSp           = (TRPayOff              *) GetSpritePtr(GetResString(IDS_MS_PAYOFF_R1));
  Marker             = (TRMarker              *) GetSpritePtr(GetResString(IDS_MS_MARKER_R1));
  MessageDisplay     = (TCasMessageDisplay       *) GetSpritePtr(GetResString(IDS_MS_MESSCASH_R1));
  BankCashDisplay    = (TCasCashDisplay       *) GetSpritePtr(GetResString(IDS_MS_BANKCASH_R1));
  BetAmountDisplay   = (TCasCashDisplay       *) GetSpritePtr(GetResString(IDS_MS_UNITCASH_R1));
    */
  //
  if (RSounds == NULL)         {SpriteError("Sounds",        GetResString(IDS_MS_SOUND_R1));}
  if (BetSpot[0] == NULL)         {SpriteError("Bet Spot 0",        GetResString(IDS_MS_BS0_R1));}
  if (BetSpot[1] == NULL)         {SpriteError("Bet Spot 1",        GetResString(IDS_MS_BS1_R1));}
  if (BetSpot[2] == NULL)         {SpriteError("Bet Spot 2",        GetResString(IDS_MS_BS2_R1));}
  if (BetSpot[3] == NULL)         {SpriteError("Bet Spot 3",        GetResString(IDS_MS_BS3_R1));}
  if (BetSpot[4] == NULL)         {SpriteError("Bet Spot 4",        GetResString(IDS_MS_BS4_R1));}
  if (BetSpot[5] == NULL)         {SpriteError("Bet Spot 5",        GetResString(IDS_MS_BS5_R1));}
  if (BetSpot[6] == NULL)         {SpriteError("Bet Spot 6",        GetResString(IDS_MS_BS6_R1));}
  if (BetSpot[7] == NULL)         {SpriteError("Bet Spot 7",        GetResString(IDS_MS_BS7_R1));}
  if (BetSpot[8] == NULL)         {SpriteError("Bet Spot 8",        GetResString(IDS_MS_BS8_R1));}
  if (BetSpot[9] == NULL)         {SpriteError("Bet Spot 9",        GetResString(IDS_MS_BS9_R1));}
  if (BetSpot[10] == NULL)         {SpriteError("Bet Spot 10",        GetResString(IDS_MS_BS10_R1));}
  if (BetSpot[11] == NULL)         {SpriteError("Bet Spot 11",        GetResString(IDS_MS_BS11_R1));}
  if (BetSpot[12] == NULL)         {SpriteError("Bet Spot 12",        GetResString(IDS_MS_BS12_R1));}
  if (BetSpot[13] == NULL)         {SpriteError("Bet Spot 13",        GetResString(IDS_MS_BS13_R1));}
  if (BetSpot[14] == NULL)         {SpriteError("Bet Spot 14",        GetResString(IDS_MS_BS14_R1));}
  if (BetSpot[15] == NULL)         {SpriteError("Bet Spot 15",        GetResString(IDS_MS_BS15_R1));}
  if (BetSpot[16] == NULL)         {SpriteError("Bet Spot 16",        GetResString(IDS_MS_BS16_R1));}
  if (BetSpot[17] == NULL)         {SpriteError("Bet Spot 17",        GetResString(IDS_MS_BS17_R1));}
  if (BetSpot[18] == NULL)         {SpriteError("Bet Spot 18",        GetResString(IDS_MS_BS18_R1));}
  if (BetSpot[19] == NULL)         {SpriteError("Bet Spot 19",        GetResString(IDS_MS_BS19_R1));}
  if (BetSpot[20] == NULL)         {SpriteError("Bet Spot 20",        GetResString(IDS_MS_BS20_R1));}
  if (BetSpot[21] == NULL)         {SpriteError("Bet Spot 21",        GetResString(IDS_MS_BS21_R1));}
  if (BetSpot[22] == NULL)         {SpriteError("Bet Spot 22",        GetResString(IDS_MS_BS22_R1));}
  if (BetSpot[23] == NULL)         {SpriteError("Bet Spot 23",        GetResString(IDS_MS_BS23_R1));}
  if (BetSpot[24] == NULL)         {SpriteError("Bet Spot 24",        GetResString(IDS_MS_BS24_R1));}
  if (BetSpot[25] == NULL)         {SpriteError("Bet Spot 25",        GetResString(IDS_MS_BS25_R1));}
  if (BetSpot[26] == NULL)         {SpriteError("Bet Spot 26",        GetResString(IDS_MS_BS26_R1));}
  if (BetSpot[27] == NULL)         {SpriteError("Bet Spot 27",        GetResString(IDS_MS_BS27_R1));}
  if (BetSpot[28] == NULL)         {SpriteError("Bet Spot 28",        GetResString(IDS_MS_BS28_R1));}
  if (BetSpot[29] == NULL)         {SpriteError("Bet Spot 29",        GetResString(IDS_MS_BS29_R1));}
  if (BetSpot[30] == NULL)         {SpriteError("Bet Spot 30",        GetResString(IDS_MS_BS30_R1));}
  if (BetSpot[31] == NULL)         {SpriteError("Bet Spot 31",        GetResString(IDS_MS_BS31_R1));}
  if (BetSpot[32] == NULL)         {SpriteError("Bet Spot 32",        GetResString(IDS_MS_BS32_R1));}
  if (BetSpot[33] == NULL)         {SpriteError("Bet Spot 33",        GetResString(IDS_MS_BS33_R1));}
  if (BetSpot[34] == NULL)         {SpriteError("Bet Spot 34",        GetResString(IDS_MS_BS34_R1));}
  if (BetSpot[35] == NULL)         {SpriteError("Bet Spot 35",        GetResString(IDS_MS_BS35_R1));}
  if (BetSpot[36] == NULL)         {SpriteError("Bet Spot 36",        GetResString(IDS_MS_BS36_R1));}
  if (BetSpot[37] == NULL)         {SpriteError("Bet Spot 37",        GetResString(IDS_MS_BS37_R1));}
  if (BetSpot[38] == NULL)         {SpriteError("Bet Spot 38",        GetResString(IDS_MS_BS38_R1));}
  if (BetSpot[39] == NULL)         {SpriteError("Bet Spot 39",        GetResString(IDS_MS_BS39_R1));}
  if (BetSpot[40] == NULL)         {SpriteError("Bet Spot 40",        GetResString(IDS_MS_BS40_R1));}
  if (BetSpot[41] == NULL)         {SpriteError("Bet Spot 41",        GetResString(IDS_MS_BS41_R1));}
  if (BetSpot[42] == NULL)         {SpriteError("Bet Spot 42",        GetResString(IDS_MS_BS42_R1));}
  if (BetSpot[43] == NULL)         {SpriteError("Bet Spot 43",        GetResString(IDS_MS_BS43_R1));}
  if (BetSpot[44] == NULL)         {SpriteError("Bet Spot 44",        GetResString(IDS_MS_BS44_R1));}
  if (BetSpot[45] == NULL)         {SpriteError("Bet Spot 45",        GetResString(IDS_MS_BS45_R1));}
  if (BetSpot[46] == NULL)         {SpriteError("Bet Spot 46",        GetResString(IDS_MS_BS46_R1));}
  if (BetSpot[47] == NULL)         {SpriteError("Bet Spot 47",        GetResString(IDS_MS_BS47_R1));}
  if (BetSpot[48] == NULL)         {SpriteError("Bet Spot 48",        GetResString(IDS_MS_BS48_R1));}
  if (BetSpot[49] == NULL)         {SpriteError("Bet Spot 49",        GetResString(IDS_MS_BS49_R1));}
  if (BetSpot[50] == NULL)         {SpriteError("Bet Spot 50",        GetResString(IDS_MS_BS50_R1));}
  if (BetSpot[51] == NULL)         {SpriteError("Bet Spot 51",        GetResString(IDS_MS_BS51_R1));}
  if (BetSpot[52] == NULL)         {SpriteError("Bet Spot 52",        GetResString(IDS_MS_BS52_R1));}
  if (BetSpot[53] == NULL)         {SpriteError("Bet Spot 53",        GetResString(IDS_MS_BS53_R1));}
  if (BetSpot[54] == NULL)         {SpriteError("Bet Spot 54",        GetResString(IDS_MS_BS54_R1));}
  if (BetSpot[55] == NULL)         {SpriteError("Bet Spot 55",        GetResString(IDS_MS_BS55_R1));}
  if (BetSpot[56] == NULL)         {SpriteError("Bet Spot 56",        GetResString(IDS_MS_BS56_R1));}
  if (BetSpot[57] == NULL)         {SpriteError("Bet Spot 57",        GetResString(IDS_MS_BS57_R1));}
  if (BetSpot[58] == NULL)         {SpriteError("Bet Spot 58",        GetResString(IDS_MS_BS58_R1));}
  if (BetSpot[59] == NULL)         {SpriteError("Bet Spot 59",        GetResString(IDS_MS_BS59_R1));}
  if (BetSpot[60] == NULL)         {SpriteError("Bet Spot 60",        GetResString(IDS_MS_BS60_R1));}
  if (BetSpot[61] == NULL)         {SpriteError("Bet Spot 61",        GetResString(IDS_MS_BS61_R1));}
  if (BetSpot[62] == NULL)         {SpriteError("Bet Spot 62",        GetResString(IDS_MS_BS62_R1));}
  if (BetSpot[63] == NULL)         {SpriteError("Bet Spot 63",        GetResString(IDS_MS_BS63_R1));}
  if (BetSpot[64] == NULL)         {SpriteError("Bet Spot 64",        GetResString(IDS_MS_BS64_R1));}
  if (BetSpot[65] == NULL)         {SpriteError("Bet Spot 65",        GetResString(IDS_MS_BS65_R1));}
  if (BetSpot[66] == NULL)         {SpriteError("Bet Spot 66",        GetResString(IDS_MS_BS66_R1));}
  if (BetSpot[67] == NULL)         {SpriteError("Bet Spot 67",        GetResString(IDS_MS_BS67_R1));}
  if (BetSpot[68] == NULL)         {SpriteError("Bet Spot 68",        GetResString(IDS_MS_BS68_R1));}
  if (BetSpot[69] == NULL)         {SpriteError("Bet Spot 69",        GetResString(IDS_MS_BS69_R1));}
  if (BetSpot[70] == NULL)         {SpriteError("Bet Spot 70",        GetResString(IDS_MS_BS70_R1));}
  if (BetSpot[71] == NULL)         {SpriteError("Bet Spot 71",        GetResString(IDS_MS_BS71_R1));}
  if (BetSpot[72] == NULL)         {SpriteError("Bet Spot 72",        GetResString(IDS_MS_BS72_R1));}
  if (BetSpot[73] == NULL)         {SpriteError("Bet Spot 73",        GetResString(IDS_MS_BS73_R1));}
  if (BetSpot[74] == NULL)         {SpriteError("Bet Spot 74",        GetResString(IDS_MS_BS74_R1));}
  if (BetSpot[75] == NULL)         {SpriteError("Bet Spot 75",        GetResString(IDS_MS_BS75_R1));}
  if (BetSpot[76] == NULL)         {SpriteError("Bet Spot 76",        GetResString(IDS_MS_BS76_R1));}
  if (BetSpot[77] == NULL)         {SpriteError("Bet Spot 77",        GetResString(IDS_MS_BS77_R1));}
  if (BetSpot[78] == NULL)         {SpriteError("Bet Spot 78",        GetResString(IDS_MS_BS78_R1));}
  if (BetSpot[79] == NULL)         {SpriteError("Bet Spot 79",        GetResString(IDS_MS_BS79_R1));}
  if (BetSpot[80] == NULL)         {SpriteError("Bet Spot 80",        GetResString(IDS_MS_BS80_R1));}
  if (BetSpot[81] == NULL)         {SpriteError("Bet Spot 81",        GetResString(IDS_MS_BS81_R1));}
  if (BetSpot[82] == NULL)         {SpriteError("Bet Spot 82",        GetResString(IDS_MS_BS82_R1));}
  if (BetSpot[83] == NULL)         {SpriteError("Bet Spot 83",        GetResString(IDS_MS_BS83_R1));}
  if (BetSpot[84] == NULL)         {SpriteError("Bet Spot 84",        GetResString(IDS_MS_BS84_R1));}
  if (BetSpot[85] == NULL)         {SpriteError("Bet Spot 85",        GetResString(IDS_MS_BS85_R1));}
  if (BetSpot[86] == NULL)         {SpriteError("Bet Spot 86",        GetResString(IDS_MS_BS86_R1));}
  if (BetSpot[87] == NULL)         {SpriteError("Bet Spot 87",        GetResString(IDS_MS_BS87_R1));}
  if (BetSpot[88] == NULL)         {SpriteError("Bet Spot 88",        GetResString(IDS_MS_BS88_R1));}
  if (BetSpot[89] == NULL)         {SpriteError("Bet Spot 89",        GetResString(IDS_MS_BS89_R1));}
  if (BetSpot[90] == NULL)         {SpriteError("Bet Spot 90",        GetResString(IDS_MS_BS90_R1));}
  if (BetSpot[91] == NULL)         {SpriteError("Bet Spot 91",        GetResString(IDS_MS_BS91_R1));}
  if (BetSpot[92] == NULL)         {SpriteError("Bet Spot 92",        GetResString(IDS_MS_BS92_R1));}
  if (BetSpot[93] == NULL)         {SpriteError("Bet Spot 93",        GetResString(IDS_MS_BS93_R1));}
  if (BetSpot[94] == NULL)         {SpriteError("Bet Spot 94",        GetResString(IDS_MS_BS94_R1));}
  if (BetSpot[95] == NULL)         {SpriteError("Bet Spot 95",        GetResString(IDS_MS_BS95_R1));}
  if (BetSpot[96] == NULL)         {SpriteError("Bet Spot 96",        GetResString(IDS_MS_BS96_R1));}
  if (BetSpot[97] == NULL)         {SpriteError("Bet Spot 97",        GetResString(IDS_MS_BS97_R1));}
  if (BetSpot[98] == NULL)         {SpriteError("Bet Spot 98",        GetResString(IDS_MS_BS98_R1));}
  if (BetSpot[99] == NULL)         {SpriteError("Bet Spot 99",        GetResString(IDS_MS_BS99_R1));}
  if (BetSpot[100] == NULL)         {SpriteError("Bet Spot 100",        GetResString(IDS_MS_BS100_R1));}
  if (BetSpot[101] == NULL)         {SpriteError("Bet Spot 101",        GetResString(IDS_MS_BS101_R1));}
  if (BetSpot[102] == NULL)         {SpriteError("Bet Spot 102",        GetResString(IDS_MS_BS102_R1));}
  if (BetSpot[103] == NULL)         {SpriteError("Bet Spot 103",        GetResString(IDS_MS_BS103_R1));}
  if (BetSpot[104] == NULL)         {SpriteError("Bet Spot 104",        GetResString(IDS_MS_BS104_R1));}
  if (BetSpot[105] == NULL)         {SpriteError("Bet Spot 105",        GetResString(IDS_MS_BS105_R1));}
  if (BetSpot[106] == NULL)         {SpriteError("Bet Spot 106",        GetResString(IDS_MS_BS106_R1));}
  if (BetSpot[107] == NULL)         {SpriteError("Bet Spot 107",        GetResString(IDS_MS_BS107_R1));}
  if (BetSpot[108] == NULL)         {SpriteError("Bet Spot 108",        GetResString(IDS_MS_BS108_R1));}
  if (BetSpot[109] == NULL)         {SpriteError("Bet Spot 109",        GetResString(IDS_MS_BS109_R1));}
  if (BetSpot[110] == NULL)         {SpriteError("Bet Spot 110",        GetResString(IDS_MS_BS110_R1));}
  if (BetSpot[111] == NULL)         {SpriteError("Bet Spot 111",        GetResString(IDS_MS_BS111_R1));}
  if (BetSpot[112] == NULL)         {SpriteError("Bet Spot 112",        GetResString(IDS_MS_BS112_R1));}
  if (BetSpot[113] == NULL)         {SpriteError("Bet Spot 113",        GetResString(IDS_MS_BS113_R1));}
  if (BetSpot[114] == NULL)         {SpriteError("Bet Spot 114",        GetResString(IDS_MS_BS114_R1));}
  if (BetSpot[115] == NULL)         {SpriteError("Bet Spot 115",        GetResString(IDS_MS_BS115_R1));}
  if (BetSpot[116] == NULL)         {SpriteError("Bet Spot 116",        GetResString(IDS_MS_BS116_R1));}
  if (BetSpot[117] == NULL)         {SpriteError("Bet Spot 117",        GetResString(IDS_MS_BS117_R1));}
  if (BetSpot[118] == NULL)         {SpriteError("Bet Spot 118",        GetResString(IDS_MS_BS118_R1));}
  if (BetSpot[119] == NULL)         {SpriteError("Bet Spot 119",        GetResString(IDS_MS_BS119_R1));}
  if (BetSpot[120] == NULL)         {SpriteError("Bet Spot 120",        GetResString(IDS_MS_BS120_R1));}
  if (BetSpot[121] == NULL)         {SpriteError("Bet Spot 121",        GetResString(IDS_MS_BS121_R1));}
  if (BetSpot[122] == NULL)         {SpriteError("Bet Spot 122",        GetResString(IDS_MS_BS122_R1));}
  if (BetSpot[123] == NULL)         {SpriteError("Bet Spot 123",        GetResString(IDS_MS_BS123_R1));}
  if (BetSpot[124] == NULL)         {SpriteError("Bet Spot 124",        GetResString(IDS_MS_BS124_R1));}
  if (BetSpot[125] == NULL)         {SpriteError("Bet Spot 125",        GetResString(IDS_MS_BS125_R1));}
  if (BetSpot[126] == NULL)         {SpriteError("Bet Spot 126",        GetResString(IDS_MS_BS126_R1));}
  if (BetSpot[127] == NULL)         {SpriteError("Bet Spot 127",        GetResString(IDS_MS_BS127_R1));}
  if (BetSpot[128] == NULL)         {SpriteError("Bet Spot 128",        GetResString(IDS_MS_BS128_R1));}
  if (BetSpot[129] == NULL)         {SpriteError("Bet Spot 129",        GetResString(IDS_MS_BS129_R1));}
  if (BetSpot[130] == NULL)         {SpriteError("Bet Spot 130",        GetResString(IDS_MS_BS130_R1));}
  if (BetSpot[131] == NULL)         {SpriteError("Bet Spot 131",        GetResString(IDS_MS_BS131_R1));}
  if (BetSpot[132] == NULL)         {SpriteError("Bet Spot 132",        GetResString(IDS_MS_BS132_R1));}
  if (BetSpot[133] == NULL)         {SpriteError("Bet Spot 133",        GetResString(IDS_MS_BS133_R1));}
  if (BetSpot[134] == NULL)         {SpriteError("Bet Spot 134",        GetResString(IDS_MS_BS134_R1));}
  if (BetSpot[135] == NULL)         {SpriteError("Bet Spot 135",        GetResString(IDS_MS_BS135_R1));}
  if (BetSpot[136] == NULL)         {SpriteError("Bet Spot 136",        GetResString(IDS_MS_BS136_R1));}
  if (BetSpot[137] == NULL)         {SpriteError("Bet Spot 137",        GetResString(IDS_MS_BS137_R1));}
  if (BetSpot[138] == NULL)         {SpriteError("Bet Spot 138",        GetResString(IDS_MS_BS138_R1));}
  if (BetSpot[139] == NULL)         {SpriteError("Bet Spot 139",        GetResString(IDS_MS_BS139_R1));}
  if (BetSpot[140] == NULL)         {SpriteError("Bet Spot 140",        GetResString(IDS_MS_BS140_R1));}
  if (BetSpot[141] == NULL)         {SpriteError("Bet Spot 141",        GetResString(IDS_MS_BS141_R1));}
  if (BetSpot[142] == NULL)         {SpriteError("Bet Spot 142",        GetResString(IDS_MS_BS142_R1));}
  if (BetSpot[143] == NULL)         {SpriteError("Bet Spot 143",        GetResString(IDS_MS_BS143_R1));}
  if (BetSpot[144] == NULL)         {SpriteError("Bet Spot 144",        GetResString(IDS_MS_BS144_R1));}
  if (BetSpot[145] == NULL)         {SpriteError("Bet Spot 145",        GetResString(IDS_MS_BS145_R1));}
  if (BetSpot[146] == NULL)         {SpriteError("Bet Spot 146",        GetResString(IDS_MS_BS146_R1));}
  if (BetSpot[147] == NULL)         {SpriteError("Bet Spot 147",        GetResString(IDS_MS_BS147_R1));}
  if (BetSpot[148] == NULL)         {SpriteError("Bet Spot 148",        GetResString(IDS_MS_BS148_R1));}
  if (BetSpot[149] == NULL)         {SpriteError("Bet Spot 149",        GetResString(IDS_MS_BS149_R1));}
  if (BetSpot[150] == NULL)         {SpriteError("Bet Spot 150",        GetResString(IDS_MS_BS150_R1));}
  if (BetSpot[151] == NULL)         {SpriteError("Bet Spot 151",        GetResString(IDS_MS_BS151_R1));}
  if (BetSpot[152] == NULL)         {SpriteError("Bet Spot 152",        GetResString(IDS_MS_BS152_R1));}
  if (BetSpot[153] == NULL)         {SpriteError("Bet Spot 153",        GetResString(IDS_MS_BS153_R1));}
  if (BetSpot[154] == NULL)         {SpriteError("Bet Spot 154",        GetResString(IDS_MS_BS154_R1));}
  if (BetSpot[155] == NULL)         {SpriteError("Bet Spot 155",        GetResString(IDS_MS_BS155_R1));}
  if (MenuEscButton   == NULL)    {SpriteError("Menu Esc Button",       GetResString(IDS_MS_B0_R1));}
  if (Button1 == NULL)            {SpriteError("Button1",               GetResString(IDS_MS_B1_R1));}
  if (Button2 == NULL)            {SpriteError("Button2",               GetResString(IDS_MS_B2_R1));}
  if (Button3 == NULL)            {SpriteError("Button3",               GetResString(IDS_MS_B3_R1));}
  if (Button4 == NULL)            {SpriteError("Button4",               GetResString(IDS_MS_B4_R1));}
  if (ButtonChip1     == NULL)            {SpriteError("ButtonChip1",               GetResString(IDS_MS_BC1_R1));}
  if (ButtonChip5     == NULL)            {SpriteError("ButtonChip5",               GetResString(IDS_MS_BC5_R1));}
  if (ButtonChip25    == NULL)            {SpriteError("ButtonChip25",              GetResString(IDS_MS_BC25_R1));}
  if (ButtonChip100   == NULL)            {SpriteError("ButtonChip100",             GetResString(IDS_MS_BC100_R1));}
  if (ButtonChip1000  == NULL)            {SpriteError("ButtonChip1000",            GetResString(IDS_MS_BC1000_R1));}
  if (ButtonChip10000 == NULL)            {SpriteError("ButtonChip10000",           GetResString(IDS_MS_BC10000_R1));}
  if (AskExpertButton == NULL)    {SpriteError("Ask Expert Button",     GetResString(IDS_MS_B5_R1));}
  if (Chips == NULL)              {SpriteError("Chip Stacks",           GetResString(IDS_MS_CHIPS_R1));}
//  if (BetUnitChips == NULL)       {SpriteError("BetUnitChip Stacks",    GetResString(IDS_MS_BETUNITCHIPS_R1));}
  if (CasStatusBar == NULL)       {SpriteError("CasStatusBar",          GetResString(IDS_MS_SB_R1));}
  if (NamePlate1 == NULL)         {SpriteError("NamePlate1",             GetResString(IDS_MS_NP1_R1));}
  if (NamePlate2 == NULL)         {SpriteError("NamePlate2",             GetResString(IDS_MS_NP2_R1));}
  if (NamePlate3 == NULL)         {SpriteError("NamePlate3",             GetResString(IDS_MS_NP3_R1));}
  if (PayOffSp  == NULL)          {SpriteError("PayOffSp" ,             GetResString(IDS_MS_PAYOFF_R1));}
  if (NumberHistory == NULL)      {SpriteError("NumberHistory",         GetResString(IDS_MS_NUMHIS_R1));}
  if (Marker == NULL)             {SpriteError("Marker",                GetResString(IDS_MS_MARKER_R1));}
  if (MessageDisplay == NULL)     {SpriteError("MessageDisplay",    GetResString(IDS_MS_MESSCASH_R1));}
  if (BankCashDisplay == NULL)    {SpriteError("BankCashDisplay",       GetResString(IDS_MS_BANKCASH_R1));}
  if (BetAmountDisplay == NULL)   {SpriteError("BetAmountDisplay",      GetResString(IDS_MS_UNITCASH_R1));}

  /*ActivateSpriteNow(BetSpot[0]);
  ActivateSpriteNow(BetSpot[1]);
  ActivateSpriteNow(BetSpot[2]);
  ActivateSpriteNow(BetSpot[3]);
  ActivateSpriteNow(BetSpot[4]);
  ActivateSpriteNow(BetSpot[5]);
  ActivateSpriteNow(BetSpot[6]);
  ActivateSpriteNow(BetSpot[7]);
  ActivateSpriteNow(BetSpot[8]);
  ActivateSpriteNow(BetSpot[9]);
  ActivateSpriteNow(BetSpot[10]);
  ActivateSpriteNow(BetSpot[11]);
  ActivateSpriteNow(BetSpot[12]);
  ActivateSpriteNow(BetSpot[13]);
  ActivateSpriteNow(BetSpot[14]);
  ActivateSpriteNow(BetSpot[15]);
  ActivateSpriteNow(BetSpot[16]);
  ActivateSpriteNow(BetSpot[17]);
  ActivateSpriteNow(BetSpot[18]);
  ActivateSpriteNow(BetSpot[19]);
  ActivateSpriteNow(BetSpot[20]);
  ActivateSpriteNow(BetSpot[21]);
  ActivateSpriteNow(BetSpot[22]);
  ActivateSpriteNow(BetSpot[23]);
  ActivateSpriteNow(BetSpot[24]);
  ActivateSpriteNow(BetSpot[25]);
  ActivateSpriteNow(BetSpot[26]);
  ActivateSpriteNow(BetSpot[27]);
  ActivateSpriteNow(BetSpot[28]);
  ActivateSpriteNow(BetSpot[29]);
  ActivateSpriteNow(BetSpot[30]);
  ActivateSpriteNow(BetSpot[31]);
  ActivateSpriteNow(BetSpot[32]);
  ActivateSpriteNow(BetSpot[33]);
  ActivateSpriteNow(BetSpot[34]);
  ActivateSpriteNow(BetSpot[35]);
  ActivateSpriteNow(BetSpot[36]);
  ActivateSpriteNow(BetSpot[37]);
  ActivateSpriteNow(BetSpot[38]);
  ActivateSpriteNow(BetSpot[39]);
  ActivateSpriteNow(BetSpot[40]);
  ActivateSpriteNow(BetSpot[41]);
  ActivateSpriteNow(BetSpot[42]);
  ActivateSpriteNow(BetSpot[43]);
  ActivateSpriteNow(BetSpot[44]);
  ActivateSpriteNow(BetSpot[45]);
  ActivateSpriteNow(BetSpot[46]);
  ActivateSpriteNow(BetSpot[47]);
  ActivateSpriteNow(BetSpot[48]);
  ActivateSpriteNow(BetSpot[49]);
  ActivateSpriteNow(BetSpot[50]);
  ActivateSpriteNow(BetSpot[51]);
  ActivateSpriteNow(BetSpot[52]);
  ActivateSpriteNow(BetSpot[53]);
  ActivateSpriteNow(BetSpot[54]);
  ActivateSpriteNow(BetSpot[55]);
  ActivateSpriteNow(BetSpot[56]);
  ActivateSpriteNow(BetSpot[57]);
  ActivateSpriteNow(BetSpot[58]);
  ActivateSpriteNow(BetSpot[59]);
  ActivateSpriteNow(BetSpot[60]);
  ActivateSpriteNow(BetSpot[61]);
  ActivateSpriteNow(BetSpot[62]);
  ActivateSpriteNow(BetSpot[63]);
  ActivateSpriteNow(BetSpot[64]);
  ActivateSpriteNow(BetSpot[65]);
  ActivateSpriteNow(BetSpot[66]);
  ActivateSpriteNow(BetSpot[67]);
  ActivateSpriteNow(BetSpot[68]);
  ActivateSpriteNow(BetSpot[69]);
  ActivateSpriteNow(BetSpot[70]);
  ActivateSpriteNow(BetSpot[71]);
  ActivateSpriteNow(BetSpot[72]);
  ActivateSpriteNow(BetSpot[73]);
  ActivateSpriteNow(BetSpot[74]);
  ActivateSpriteNow(BetSpot[75]);
  ActivateSpriteNow(BetSpot[76]);
  ActivateSpriteNow(BetSpot[77]);
  ActivateSpriteNow(BetSpot[78]);
  ActivateSpriteNow(BetSpot[79]);
  ActivateSpriteNow(BetSpot[80]);
  ActivateSpriteNow(BetSpot[81]);
  ActivateSpriteNow(BetSpot[82]);
  ActivateSpriteNow(BetSpot[83]);
  ActivateSpriteNow(BetSpot[84]);
  ActivateSpriteNow(BetSpot[85]);
  ActivateSpriteNow(BetSpot[86]);
  ActivateSpriteNow(BetSpot[87]);
  ActivateSpriteNow(BetSpot[88]);
  ActivateSpriteNow(BetSpot[89]);
  ActivateSpriteNow(BetSpot[90]);
  ActivateSpriteNow(BetSpot[91]);
  ActivateSpriteNow(BetSpot[92]);
  ActivateSpriteNow(BetSpot[93]);
  ActivateSpriteNow(BetSpot[94]);
  ActivateSpriteNow(BetSpot[95]);
  ActivateSpriteNow(BetSpot[96]);
  ActivateSpriteNow(BetSpot[97]);
  ActivateSpriteNow(BetSpot[98]);
  ActivateSpriteNow(BetSpot[99]);
  ActivateSpriteNow(BetSpot[100]);
  ActivateSpriteNow(BetSpot[101]);
  ActivateSpriteNow(BetSpot[102]);
  ActivateSpriteNow(BetSpot[103]);
  ActivateSpriteNow(BetSpot[104]);
  ActivateSpriteNow(BetSpot[105]);
  ActivateSpriteNow(BetSpot[106]);
  ActivateSpriteNow(BetSpot[107]);
  ActivateSpriteNow(BetSpot[108]);
  ActivateSpriteNow(BetSpot[109]);
  ActivateSpriteNow(BetSpot[110]);
  ActivateSpriteNow(BetSpot[111]);
  ActivateSpriteNow(BetSpot[112]);
  ActivateSpriteNow(BetSpot[113]);
  ActivateSpriteNow(BetSpot[114]);
  ActivateSpriteNow(BetSpot[115]);
  ActivateSpriteNow(BetSpot[116]);
  ActivateSpriteNow(BetSpot[117]);
  ActivateSpriteNow(BetSpot[118]);
  ActivateSpriteNow(BetSpot[119]);
  ActivateSpriteNow(BetSpot[120]);
  ActivateSpriteNow(BetSpot[121]);
  ActivateSpriteNow(BetSpot[122]);
  ActivateSpriteNow(BetSpot[123]);
  ActivateSpriteNow(BetSpot[124]);
  ActivateSpriteNow(BetSpot[125]);
  ActivateSpriteNow(BetSpot[126]);
  ActivateSpriteNow(BetSpot[127]);
  ActivateSpriteNow(BetSpot[128]);
  ActivateSpriteNow(BetSpot[129]);
  ActivateSpriteNow(BetSpot[130]);
  ActivateSpriteNow(BetSpot[131]);
  ActivateSpriteNow(BetSpot[132]);
  ActivateSpriteNow(BetSpot[133]);
  ActivateSpriteNow(BetSpot[134]);
  ActivateSpriteNow(BetSpot[135]);
  ActivateSpriteNow(BetSpot[136]);
  ActivateSpriteNow(BetSpot[137]);
  ActivateSpriteNow(BetSpot[138]);
  ActivateSpriteNow(BetSpot[139]);
  ActivateSpriteNow(BetSpot[140]);
  ActivateSpriteNow(BetSpot[141]);
  ActivateSpriteNow(BetSpot[142]);
  ActivateSpriteNow(BetSpot[143]);
  ActivateSpriteNow(BetSpot[144]);
  ActivateSpriteNow(BetSpot[145]);
  ActivateSpriteNow(BetSpot[146]);
  ActivateSpriteNow(BetSpot[147]);
  ActivateSpriteNow(BetSpot[148]);
  ActivateSpriteNow(BetSpot[149]);
  ActivateSpriteNow(BetSpot[150]);
  ActivateSpriteNow(BetSpot[151]);
  ActivateSpriteNow(BetSpot[152]);
  ActivateSpriteNow(BetSpot[153]);
  ActivateSpriteNow(BetSpot[154]);
  ActivateSpriteNow(BetSpot[155]);
  */
  for (int16 j = 0;j<156;j++)
  {
	 BetSpot[j]->Priority();
	 BetSpot[j]->Start(GetFUC());
  }

  ActivateSpriteNow(MenuEscButton);
  if (!GetFW()->GetHandleShowMenu())
  {
	 MenuEscButton->PButton->CAD.SetCurrentFrame(1);
	 MenuEscButton->Show();
	 MenuEscButton->PButtonResponder->Remove();
  }
  ActivateSpriteNow(Button1);
  ActivateSpriteNow(Button2);
  ActivateSpriteNow(Button3);
  ActivateSpriteNow(Button4);
  ActivateSpriteNow(ButtonChip1);
  ActivateSpriteNow(ButtonChip5);
  ActivateSpriteNow(ButtonChip25);
  ActivateSpriteNow(ButtonChip100);
  ActivateSpriteNow(ButtonChip1000);
  ActivateSpriteNow(ButtonChip10000);
  ActivateSpriteNow(AskExpertButton);
  Chips->Start(GetFUC());
  //BetUnitChips->Start(GetFUC());
  Marker->Start(GetFUC());
  ActivateSpriteNow(CasStatusBar);
  NamePlate1->Start(GetFUC());
  NamePlate2->Start(GetFUC());
  NamePlate3->Start(GetFUC());
  PayOffSp->Start(GetFUC());
  NumberHistory->Start(GetFUC());
  MessageDisplay->Start(GetFUC());
  BankCashDisplay->Start(GetFUC());
  BetAmountDisplay->Start(GetFUC());

  BallIdle           = GetSpritePtr(GetResString(IDS_AS_BALLIDLE_R1));
  WheelIdle          = GetSpritePtr(GetResString(IDS_AS_WHEELIDLE_R1));
}
//*******************************************************************
void TR1GameLord::CleanupSprites()
{
  //CoinsPlayed->NoShow();
}
//*******************************************************************
TR1GameLord::TR1GameLord(TRouletteModeWin *prmodewin,const TFileMode &filemode)
:TCasinoRGameLord(prmodewin,filemode)
{
  randomize();
  TFileMode splfm(SpriteListName,
                  TFileMode::fm_None,
                  TFileMode::fm_Immed,
                  FileMode.GetDirIndex());
  CreateAddSpriteList(splfm);

  TFileMode skcfm(SkitCatName,
                  TFileMode::fm_None,
                  TFileMode::fm_Immed,
                  FileMode.GetDirIndex());
  CreateAddSkitCat(skcfm);

  SetupSprites();
  SetupSkits();
}
//*******************************************************************
TR1GameLord::~TR1GameLord()
{
}
//*******************************************************************
