//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  cract1st.cpp   ///
//    Project Name:  Casino
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     03/29/95   A. Krist    Original baseline
//  2.0     09/19/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "cract1st.h"
#include "crrmst.h"
#include "crplay.h"
#include "orespond.h"
#include "owav.h"
//*******************************************************************
TRAct1State::TRAct1State(TCasinoRGameLord *pNewRLord)
:TRLordState(pNewRLord)
{
	 SetRunOrder(ess_Execute,ess_StartSubState3,ess_Execute,ess_Done,ess_Done,ess_Done);
	 StartingFUC = 0;
	 FUCLength   = 0;
	 SpinStopFUC = 0;
	 StopSpinSound = true;
	 randoutspin = 0;
	 BetSpotResponder            = NULL;

	 OneChipResponder            = NULL;
	 FiveChipResponder           = NULL;
	 TwentyFiveChipResponder     = NULL;
	 OneHundredChipResponder     = NULL;
	 OneThouChipResponder        = NULL;
	 TenThouChipResponder        = NULL;

	 MenuEscResponder            = NULL;
	 Button1Responder            = NULL;
	 Button2Responder            = NULL;
	 Button3Responder            = NULL;
	 Button4Responder            = NULL;
	 AskExpertResponder          = NULL;
	 WaitOnSkit                  = false;
	 WaitOnPreDealCom            = false;
	 askexpertflag               = false;
	 WaitingOnWRCounter          = 0;
	 WaitOnSpinning              = false;
	 WaitOnBallSpinning          = false;
	 FinishBallSpinning          = false;
	 FinishBallDrop              = false;
	 FirstSpin                   = true;
	 IdleOff = 0;
    BallOn = 0;
}
//*******************************************************************
TRAct1State::~TRAct1State()
{
}
//*******************************************************************
void TRAct1State::ExecuteFirstTime()
{
  pOwnerLord->Responders[157]->Add();
  pOwnerLord->EnableAllButtons();
  pOwnerLord->BetSpotsOn = true;
  pOwnerLord->SetBodyIdle();
  pOwnerLord->Button1->NoShow();
  pOwnerLord->Button2->NoShow();
  pOwnerLord->Button3->NoShow();
  pOwnerLord->Button4->ShowGray();
  pOwnerLord->Clear();
  ExecuteWaiting = true;
  ExecuteStatus    = ess_Execute;
  if(!WaitOnSkit)
  {
	 StartingFUC = pOwnerLord->GetAdjFUC();
	 pOwnerLord->PlaceBets(StartingFUC,FUCLength);
	 WaitOnSkit = true;
  }

}
//*******************************************************************
void TRAct1State::CreateSubState1()
{
  //PActiveSubState = new TBJFirstDealState(pOwnerLord);
}
//*******************************************************************
void TRAct1State::CreateSubState2()
{
  pOwnerLord->PlaceBetsMode = false;
  pOwnerLord->PModeWin->ReSendEnterArea();
  PActiveSubState = new TRRemoveState(pOwnerLord);
}
//*******************************************************************
void TRAct1State::CreateSubState4()
{
}
//*******************************************************************
void TRAct1State::CreateSubState3()
{
  //pOwnerLord->SetBlackJack();
 // if(pOwnerLord->pHand->cards[0].name > Nine)
  //{
	// PActiveSubState = new TBJState(pOwnerLord);
  //}
}
//*******************************************************************
void TRAct1State::EndSubState4()
{
  TState::EndSubState4();
  ExecuteWaiting = false;
  ExecuteStatus = ess_Done;
}
//*******************************************************************
void TRAct1State::EndSubState2()
{
  TState::EndSubState2();
  ExecuteWaiting = true;
  pOwnerLord->PlaceBetsMode = true;
  if(!pOwnerLord->BetMade(pOwnerLord->activeplayer)){pOwnerLord->Button1->ShowGray();}
  pOwnerLord->PModeWin->ReSendEnterArea();
}
//*******************************************************************
void TRAct1State::HandlePostUpdate(dword NewFUC)
{
  if(pOwnerLord->ButtonHit[ridButton4])
  {
	 pOwnerLord->ButtonClear(ridButton4);
	 if (pOwnerLord->BetMade())
	 {
		pOwnerLord->BetSpotsOn = false;
		pOwnerLord->Responders[157]->Remove();
		StartingFUC = pOwnerLord->GetAdjFUC();
		pOwnerLord->PreSpinCom(StartingFUC,FUCLength);
		pOwnerLord->PreSpinStats();
		WaitOnSkit       = true;   //Trickle down to next if statement
		WaitOnPreDealCom = true;
		pOwnerLord->MessageDisplay->NoShowDisplay();
		LockHit = true;
	 }
  }
  if (pOwnerLord->ButtonHit[ridOneChip])
  {
	 pOwnerLord->ButtonClear(ridOneChip);
	 if(pOwnerLord->ButtonInfo == 1)
	 {
		pOwnerLord->UnBet1(1l);
	 }
	 else
	 {
		pOwnerLord->Bet1(1l);
	 }
	 if(!WaitOnSkit)
	 {
		return;
	 }
  }
  if (pOwnerLord->ButtonHit[ridFiveChip])
  {
	 pOwnerLord->ButtonClear(ridFiveChip);
	 if(pOwnerLord->ButtonInfo == 1)
	 {
		pOwnerLord->UnBet1(5l);
	 }
	 else
	 {
		pOwnerLord->Bet1(5l);
	 }
	 if(!WaitOnSkit)
	 {
		return;
	 }
  }
  if (pOwnerLord->ButtonHit[ridTwentyFiveChip])
  {
	 pOwnerLord->ButtonClear(ridTwentyFiveChip);
	 if(pOwnerLord->ButtonInfo == 1)
	 {
		pOwnerLord->UnBet1(25l);
	 }
	 else
	 {
		pOwnerLord->Bet1(25l);
	 }
	 if(!WaitOnSkit)
	 {
		return;
	 }
  }
  if (pOwnerLord->ButtonHit[ridOneHundredChip])
  {
	 pOwnerLord->ButtonClear(ridOneHundredChip);
	 if(pOwnerLord->ButtonInfo == 1)
	 {
		pOwnerLord->UnBet1(100l);
	 }
	 else
	 {
		pOwnerLord->Bet1(100l);
	 }
	 if(!WaitOnSkit)
	 {
		return;
	 }
  }
  if (pOwnerLord->ButtonHit[ridOneThouChip])
  {
	 pOwnerLord->ButtonClear(ridOneThouChip);
	 if(pOwnerLord->ButtonInfo == 1)
	 {
		pOwnerLord->UnBet1(1000l);
	 }
	 else
	 {
		pOwnerLord->Bet1(1000l);
	 }
	 if(!WaitOnSkit)
	 {
		return;
	 }
  }
  if (pOwnerLord->ButtonHit[ridTenThouChip])
  {
	 pOwnerLord->ButtonClear(ridTenThouChip);
	 if(pOwnerLord->ButtonInfo == 1)
	 {
		pOwnerLord->UnBet1(10000l);
	 }
	 else
	 {
		pOwnerLord->Bet1(10000l);
	 }
	 if(!WaitOnSkit)
	 {
		return;
	 }
  }
  if (BetSpotResponder != NULL)
  {
	 if(pOwnerLord->BetMade())
	 {
		pOwnerLord->Button4->ShowUp();
	 }
	 if (BetSpotResponder->GetResponseEvent() != reChar)
	 {
		BetSpotResponder->ClearPriority();
	 }
	 LockHit = false;
	 BetSpotResponder = NULL;
  }
  if(WaitOnSkit)
  {
	 if((StartingFUC + FUCLength) <= NewFUC)
	 {
		StartingFUC = 0;
		FUCLength   = 0;
		WaitOnSkit  = false;
		if(LockHit)
		{
		  LockHit = false;
		  LockButtons = false;
		}
	 }
	 return;//?
  }
  if (WaitingOnWRCounter)
  {
	 WaitingOnWRCounter--;
	 if (!WaitingOnWRCounter)
	 {
		ExecuteWaiting = false;
		ExecuteStatus = ess_StartSubState1;
	 }
  }


  if(pOwnerLord->ButtonHit[ridButton1])
  {
	 pOwnerLord->ButtonClear(ridButton1);
	 ExecuteWaiting = false;
	 LockHit = false;
	 ExecuteStatus = ess_StartSubState2;
	 return;
  }

  if(pOwnerLord->ButtonHit[ridButton2])
  {
	 pOwnerLord->ButtonClear(ridButton2);
	 pOwnerLord->ClearBet();
	 LockHit = false;

	 return;
  }
  if(pOwnerLord->ButtonHit[ridButton3])
  {
	 pOwnerLord->ButtonClear(ridButton3);
	 LockHit = false;

	 return;
  }
  if(pOwnerLord->ButtonHit[ridAskExpert])
  {
	 pOwnerLord->ButtonClear(ridAskExpert);
	 askexpertflag = false;
	 pOwnerLord->AskBetExpert();
	 return;
  }
  if(pOwnerLord->ButtonHit[ridStatBar])
  {
	 pOwnerLord->ButtonClear(ridStatBar);
	 return;
  }
  if(pOwnerLord->ButtonHit[ridMenuEsc])
  {
	 LockHit = false;
	 pOwnerLord->ButtonClear(ridMenuEsc);
	 return;
  }
  if(!WaitOnSkit && WaitOnPreDealCom)
  {
	 int16 x=0;
	 x = pOwnerLord->BallIdle->GetCurrentAnmFrame(0);
	 if(x>0 && x<11)
	 {
		if(x == 10)
		{
		  StartingFUC = pOwnerLord->GetAdjFUC();
		  pOwnerLord->DealerSpin(StartingFUC,FUCLength,IdleOff,BallOn,x);
		  WaitOnPreDealCom = false;
		  pOwnerLord->shutdownstate = 1;
		  WaitOnSpinning = true;
		}
		return;
	 }
	 else
	 {
		StartingFUC = pOwnerLord->GetAdjFUC();
		pOwnerLord->DealerSpin(StartingFUC,FUCLength,IdleOff,BallOn,x);
		WaitOnPreDealCom = false;
		pOwnerLord->shutdownstate = 1;
		WaitOnSpinning = true;
		IdleOff--;
		BallOn--;
		return;
	 }
  }
  if(WaitOnSpinning)
  {
	 if(StartingFUC + IdleOff == NewFUC)
	 {
			pOwnerLord->SetCurrentSpriteSet(2,-1);//off
	 }
	 if(StartingFUC+BallOn-2 == NewFUC)
	 {
		pOwnerLord->GetSpritePtr(pOwnerLord->spinsound)->GetWav(0)->Start(NewFUC);
	 }
	 if(StartingFUC + BallOn <= NewFUC)
	 {
		randoutspin = int16(random(3));
		pOwnerLord->numofspins = randoutspin;
		StartingFUC = pOwnerLord->GetAdjFUC();
		pOwnerLord->BallHand(StartingFUC,FUCLength);
		WaitOnBallSpinning = true;
		WaitOnSpinning = false;
		FirstSpin = true;
	 }
  }
  if(WaitOnBallSpinning)
  {
	 if(StartingFUC + FUCLength <= NewFUC)
	 {
		if(randoutspin > 0)
		{
		  if(FirstSpin)
		  {
			 dword shitFUC=0,duckLength=0;
			 shitFUC = pOwnerLord->GetAdjFUC();
			 pOwnerLord->SpinCom(shitFUC,duckLength);
			 FirstSpin = false;
		  }
		  StartingFUC = pOwnerLord->GetAdjFUC();
		  pOwnerLord->BallSpin(StartingFUC,FUCLength);
		  randoutspin--;
		}
		else
		{
		  FirstSpin = false;
		  FinishBallSpinning = true;
		  WaitOnBallSpinning = false;
		}
	 }
  }
  if(FinishBallSpinning)
  {
	 if(StartingFUC + FUCLength <= NewFUC)
	 {
		StartingFUC = pOwnerLord->GetAdjFUC();
		pOwnerLord->BallDrop(StartingFUC,FUCLength,SpinStopFUC);
		pOwnerLord->SetCurrentSpriteSet(2,2);//on
		FinishBallSpinning = false;
		FinishBallDrop = true;
	 }
  }
  if(FinishBallDrop)
  {
	 if(StartingFUC+SpinStopFUC == NewFUC && StopSpinSound)
	 {
		StopSpinSound = false;
		pOwnerLord->GetSpritePtr(pOwnerLord->spinsound)->GetWav(0)->Stop();
	 }
	 if(2+pOwnerLord->startresult+StartingFUC <= NewFUC && !FirstSpin)
	 {
      dword shitFUC=0,duckLength=0;
		FirstSpin = true;
		shitFUC = pOwnerLord->GetAdjFUC();
		pOwnerLord->Result(shitFUC,duckLength);
		pOwnerLord->NumberHistory->SetHistory(pOwnerLord->winnum);
		StartingFUC=shitFUC;FUCLength=duckLength;
	 }
	 if(StartingFUC + FUCLength <= NewFUC && FirstSpin)
	 {
      FirstSpin = false;
		FinishBallDrop = false;
		ExecuteWaiting = false;
		ExecuteStatus = ess_StartSubState1;
	 }
  }
  if(MenuEscResponder != NULL)
  {
	 pOwnerLord->MenuEscButton->ShowUp();
	 if (MenuEscResponder->GetResponseEvent() != reChar)
	 {
		MenuEscResponder->ClearPriority();
	 }
	 MenuEscResponder = NULL;

	 return;
  }
}
//*******************************************************************
bool TRAct1State::HandleNamePlate(TResponder &responder)
{
  if(responder.GetResponseEvent() == reLDown)
  {
	 responder.SetPriority();
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_PRESSING_FINGER_CURSOR));
	 return true;
  }
  if ((responder.GetResponseEvent() == reLUp    ) ||
		(responder.GetResponseEvent() == reLDblClk) ||
		(responder.GetResponseEvent() == reChar   )   )
  {
	 if(responder.GetIsPriority())
	 {
		responder.ClearPriority();
	 }
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_POINTING_FINGER_CURSOR));
	 if(responder.Contains(responder.GetPoint()) ||
		 responder.GetResponseEvent() == reChar     )
	 {
		if(pOwnerLord->GetNumActivePlayers() > 1)
		{
		  pOwnerLord->CyclePlayers();
		}
	 }
  }
  return true;
}
//*******************************************************************
bool TRAct1State::HandleBetSpot(TResponder &responder,int16 spot)
{
  if((pOwnerLord->GetRPlayer(pOwnerLord->activeplayer)->lastbet > 0l ||
		pOwnerLord->coinsplayed > 0l)&& (pOwnerLord->activeplayer != -1) &&
	  (!LockHit) && (pOwnerLord->BetSpotsOn))
  {
	 if (responder.GetResponseEvent() == reLUp)
	 {
		pOwnerLord->PlaceBet(spot);
		BetSpotResponder = &responder;
		LockHit = true;
	 }
	 if (responder.GetResponseEvent() == reLDown)
	 {
		responder.SetPriority();
	 }
	 if (responder.GetResponseEvent() == reChar)
	 {
		pOwnerLord->PlaceBet(spot);
		BetSpotResponder = &responder;
	 }
	 return true;
  }
  else
  {
	 return false;
  }
}
//*******************************************************************
bool TRAct1State::HandleButton1(TResponder &responder)
{
  if((pOwnerLord->activeplayer != -1) && (!WaitOnSkit) && (!LockHit))
  {
	 if(pOwnerLord->BetMade())
	 {
		if (responder.GetResponseEvent() == reLUp)
		{
		  LockHit = true;
		  Button1Responder = &responder;
		}
		if (responder.GetResponseEvent() == reLDown)
		{
		  pOwnerLord->Button1->ShowDown();
		  responder.SetPriority();
		}
		if (responder.GetResponseEvent() == reChar)
		{
		  pOwnerLord->Button1->ShowDown();
		  Button1Responder = &responder;
		}
	 }
	 return true;
  }
  return true;
}
//*******************************************************************
bool TRAct1State::HandleButton2(TResponder &responder)
{
  if((pOwnerLord->activeplayer != -1) && (!WaitOnSkit) && (!LockHit))
  {
	 if (responder.GetResponseEvent() == reLUp)
	 {
		Button2Responder = &responder;
		LockHit = true;
		pOwnerLord->ClearBet();
	 }

	 if (responder.GetResponseEvent() == reLDown)
	 {
		pOwnerLord->Button2->ShowDown();
		responder.SetPriority();
	 }

	 if (responder.GetResponseEvent() == reChar)
	 {
		pOwnerLord->Button2->ShowDown();
		Button2Responder = &responder;
		pOwnerLord->ClearBet();
	 }
	 return true;
  }
  return true;
}
//*******************************************************************
bool TRAct1State::HandleButton3(TResponder &responder)
{
  if((pOwnerLord->activeplayer != -1) && (!WaitOnSkit) && (!LockHit))
  {
	 if (responder.GetResponseEvent() == reLUp)
	 {
		LockHit = true;
		Button3Responder = &responder;
	 }

	 if (responder.GetResponseEvent() == reLDown)
	 {
		pOwnerLord->Button3->ShowDown();
		responder.SetPriority();
	 }

	 if (responder.GetResponseEvent() == reChar)
	 {
		pOwnerLord->Button3->ShowDown();
		Button3Responder = &responder;
	 }
	 return true;
  }
  return true;
}
//*******************************************************************
bool TRAct1State::HandleButton4(TResponder &responder)
{
  if((pOwnerLord->activeplayer != -1) && (!WaitOnSkit) && (!LockHit) &&
	  (pOwnerLord->BetMade()) )
  {
	 if (responder.GetResponseEvent() == reLUp)
	 {
		LockHit = true;
		Button4Responder = &responder;
	 }
	 if (responder.GetResponseEvent() == reLDown)
	 {
		pOwnerLord->Button4->ShowDown();
		responder.SetPriority();
	 }
	 if (responder.GetResponseEvent() == reChar)
	 {
		pOwnerLord->Button4->ShowDown();
		Button4Responder = &responder;
	 }
	 return true;
  }
  return true;
}
//*******************************************************************
bool TRAct1State::HandleOneChip(TResponder &responder)
{
  if(pOwnerLord->activeplayer != -1)
  {
	 if (responder.GetResponseEvent() == reLUp || responder.GetResponseEvent() == reRUp)
	 {
		OneChipResponder = &responder;
	 }

	 if (responder.GetResponseEvent() == reLDown || responder.GetResponseEvent() == reRDown)
	 {
		responder.SetPriority();
	 }

	 if (responder.GetResponseEvent() == reChar)
	 {
		OneChipResponder = &responder;
	 }
	 return true;
  }
  return true;
}
//*******************************************************************
bool TRAct1State::HandleFiveChip(TResponder &responder)
{
  if(pOwnerLord->activeplayer != -1)
  {
	 if (responder.GetResponseEvent() == reLUp || responder.GetResponseEvent() == reRUp)
	 {
		FiveChipResponder = &responder;
	 }

	 if (responder.GetResponseEvent() == reLDown || responder.GetResponseEvent() == reRDown)
	 {
		responder.SetPriority();
	 }

	 if (responder.GetResponseEvent() == reChar)
	 {
		FiveChipResponder = &responder;
	 }
	 return true;
  }
  return true;
}
//*******************************************************************
bool TRAct1State::HandleTwentyFiveChip(TResponder &responder)
{
  if(pOwnerLord->activeplayer != -1)
  {

  if (responder.GetResponseEvent() == reLUp || responder.GetResponseEvent() == reRUp)
  {
	 TwentyFiveChipResponder = &responder;
  }

  if (responder.GetResponseEvent() == reLDown || responder.GetResponseEvent() == reRDown)
  {
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
	 TwentyFiveChipResponder = &responder;
  }
  return true;
  }
  return true;
}
//*******************************************************************
bool TRAct1State::HandleOneHundredChip(TResponder &responder)
{
  if(pOwnerLord->activeplayer != -1)
  {

  if (responder.GetResponseEvent() == reLUp || responder.GetResponseEvent() == reRUp)
  {
	 OneHundredChipResponder = &responder;
  }

  if (responder.GetResponseEvent() == reLDown || responder.GetResponseEvent() == reRDown)
  {
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
	 OneHundredChipResponder = &responder;
  }
  return true;
  }
  return true;
}
//*******************************************************************
bool TRAct1State::HandleOneThouChip(TResponder &responder)
{
  if(pOwnerLord->activeplayer != -1)
  {

  if (responder.GetResponseEvent() == reLUp || responder.GetResponseEvent() == reRUp)
  {
	 OneThouChipResponder = &responder;
  }

  if (responder.GetResponseEvent() == reLDown || responder.GetResponseEvent() == reRDown)
  {
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
	 OneThouChipResponder = &responder;
  }
  return true;
  }
  return true;
}
//*******************************************************************
bool TRAct1State::HandleTenThouChip(TResponder &responder)
{
  if(pOwnerLord->activeplayer != -1)
  {

  if (responder.GetResponseEvent() == reLUp || responder.GetResponseEvent() == reRUp)
  {
	 TenThouChipResponder = &responder;
  }

  if (responder.GetResponseEvent() == reLDown || responder.GetResponseEvent() == reRDown)
  {
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
	 TenThouChipResponder = &responder;
  }
  return true;
  }
  return true;
}
//*******************************************************************
bool TRAct1State::HandleMenuEsc(TResponder &responder)
{
  if(!WaitOnSkit)
  {
  if (responder.GetResponseEvent() == reLUp)
  {
	 MenuEscResponder = &responder;
  }

  if (responder.GetResponseEvent() == reLDown)
  {
	 pOwnerLord->MenuEscButton->ShowDown();
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
	 pOwnerLord->MenuEscButton->ShowDown();
	 MenuEscResponder = &responder;
  }
  }
  return true;
}
//*******************************************************************
bool TRAct1State::HandleAskExpert(TResponder &responder)
{
  if(pOwnerLord->activeplayer != -1 && !WaitOnSkit)
  {

	if (responder.GetResponseEvent() == reLUp)
  {
	 AskExpertResponder = &responder;
  }

  if (responder.GetResponseEvent() == reLDown)
  {
	 pOwnerLord->AskExpertButton->ShowDown();
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
	 pOwnerLord->AskExpertButton->ShowDown();
	 AskExpertResponder = &responder;
  }

  return true;
  }
  return true;
}

//*******************************************************************