//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  crbssp.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0    03/23/96    A.Krist     moved inline functions into .cpp file.
//  2.0    09/19/97    M.Perry     32-bit conversion.
//********************************************************************
#include "crbssp.h"
#include "oanm.h"
//*******************************************************************
#pragma argsused
bool TRBetSpot::Winner(int16 WinNum)
{
  return false;
}
//*******************************************************************
bool TRBetSpot::Winner(int16 WinNum,int16 Player)
{
  if(Winner(WinNum) && HasBSBet(Player)) {return true;}
  return false;
}
//*******************************************************************
int32 TRBetSpot::Odds()
{
  return 0;
}
//*******************************************************************
void TRBetSpot::ShowSpark()
{
  PSpark->CAD.SetY(TopY);
  PSpark->CAD.SetZ(TopZ);
  if(BetAmount[2] > 0l)
  {
	 PSpark->CAD.SetX(PChips[2][0]->CAD.GetX());
	 PSpark->CAD.SetCurrentFrame(2);
	 PSpark->Show();
  }
  else if(BetAmount[1] > 0l)
  {
	 PSpark->CAD.SetX(PChips[1][0]->CAD.GetX());
	 PSpark->CAD.SetCurrentFrame(1);
	 PSpark->Show();
  }
  else if(BetAmount[0] > 0l)
  {
	 PSpark->CAD.SetX(PChips[0][0]->CAD.GetX());
	 PSpark->CAD.SetCurrentFrame(0);
	 PSpark->Show();
  }
  else
  {
	 PSpark->NoShow();
  }
  Update(GetAdjFUC());
}
//*******************************************************************
void TRBetSpot::NoShowSpark()
{
 PSpark->NoShow();
}
//*******************************************************************
TMoney TRBetSpot::GetBSCash(int16 slot)
{
  return BetAmount[slot];
}
//*******************************************************************
TMoney TRBetSpot::SubBSCash(int16 slot)
{
  TMoney temp=0l;
  temp = BetAmount[slot];
  BetAmount[slot] = 0l;
  SetNum();
  return temp;
}
//*******************************************************************
#pragma argsused
void TRBetSpot::ClearGlowChips(int16 slot)
{
}
//*******************************************************************
void TRBetSpot::AddBSCash(int16 slot,TMoney amount)
{
  BetAmount[slot] += amount;
  SetNum();
}
//*******************************************************************
bool TRBetSpot::HasBSBet(int16 slot)
{
  if(BetAmount[slot] > 0l)
  {
	 return 1;
  }
  else
  {
	 return 0;
  }
}
//*******************************************************************
bool TRBetSpot::IsBSBet()
{
  if(BetAmount[0] > 0l || BetAmount[1] > 0l || BetAmount[2] > 0l )
  {
	 return 1;
  }
  else
  {
	 return 0;
  }
}
//*******************************************************************
TMoney TRBetSpot::WinBSCash(int16 slot,int16 winnum)
{
  TMoney x=0l;
  if(Winner(winnum))
  {
	 //set glow chips
	 x = (BetAmount[slot]*Odds())+BetAmount[slot];
	 BetAmount[slot] = 0l;
	 return x;
  }
  else
  {
	 return 0l;
  }
}
//*******************************************************************
TMoney TRBetSpot::StatWinBSCash(int16 slot,int16 winnum)
{
  TMoney x=0l;
  if(Winner(winnum))
  {
	 x = (BetAmount[slot]*Odds())+BetAmount[slot];
	 return x;
  }
  else
  {
	 return 0l;
  }
}
//*******************************************************************
void TRBetSpot::ClearSpot()
{
  BetAmount[0] = 0l;
  BetAmount[1] = 0l;
  BetAmount[2] = 0l;
  NoShow();
}
//*******************************************************************
void TRBetSpot::SetSpot()
{
  if(BetAmount[0] == 0l && BetAmount[1] == 0l && BetAmount[2] == 0l)
  {
	 NoShow();
  }
}
//*******************************************************************
void TRBetSpot::SetupAnms()
{
  for(int16 j=0;j<3;j++)
  {
	 for (int16 i=0;i<6;i++)
	 {
		PChips[j][i] = GetAnm(int16(i+(j*6)));
		if (PChips[j][i] == NULL) {AnmError("RBetSpot","Chips",int16(i+(j*6)));}
		PChips[j][i]->CAD.ClearAutoStart();
		PChips[j][i]->CAD.ClearAutoStop();
		PChips[j][i]->CAD.SetDirStill();
	 }
  }
  PSpark = GetAnm(18);
  PSpark->CAD.ClearAutoStart();
  PSpark->CAD.ClearAutoStop();
  PSpark->CAD.SetDirStill();

  TopY = PChips[0][0]->SAD.GetY();
  TopZ = PChips[0][0]->SAD.GetZ();
}
//*******************************************************************
TRBetSpot::TRBetSpot(TOgleModeWindow *pmw,const TFileMode &NewFileMode,int16 messagecode)
:TSprite(pmw,NewFileMode)
{
  SetToManual();
  NotFound = false;
  MessageCode = messagecode;
  BetAmount[0] = 0l;
  BetAmount[1] = 0l;
  BetAmount[2] = 0l;
  NoShow();
  SetupAnms();
}
//********************************************************************
TRBetSpot::TRBetSpot(TOgleModeWindow *pmw,const TFileMode &fm,void *psource,int16 messagecode)
:TSprite(pmw,fm,psource)
{
  SetToManual();
  NotFound = false;
  MessageCode = messagecode;
  BetAmount[0] = 0l;
  BetAmount[1] = 0l;
  BetAmount[2] = 0l;
  NoShow();
  SetupAnms();
}
 //*******************************************************************
TRBetSpot::~TRBetSpot()
{
}
//*******************************************************************
void TRBetSpot::NoShowChips()
{
  for(int16 j=0;j<3;j++)
  {
	 for(int16 i=0;i<6;i++)
	 {
		PChips[j][i]->NoShow();
	 }
  }
}
//*******************************************************************
void TRBetSpot::SetNum()
{
  if (NotFound) {return;}
  int16 xoffset,yoffset,zoffset;
  int32 num;
  yoffset   = PChips[0][0]->SAD.GetY();
  zoffset   = PChips[0][0]->SAD.GetZ();
  xoffset   = PChips[0][0]->SAD.GetX();
	for(int16 i=0;i<3;i++)
  {
	 if(xoffset != PChips[i][0]->SAD.GetX())
	 {
		yoffset = PChips[i][0]->SAD.GetY();
		zoffset = PChips[i][0]->SAD.GetZ();
	 }
	 num = (int32)BetAmount[i];
	 num = num%100001l;
	 zoffset += i;
	 int32 tenthous = num / 10000;
	 int32 tenthousvalue = tenthous * 10000;
	 int32 thous = (num - tenthousvalue) / 1000;
	 int32 thousvalue = thous * 1000;
	 int32 huns = (num - tenthousvalue - thousvalue) / 100;
	 int32 hunsvalue = huns * 100;
	 int32 twfive = (num - tenthousvalue - thousvalue - hunsvalue) / 25;
	 int32 twfivevalue = twfive * 25;
	 int32 fives = (num - tenthousvalue - thousvalue - hunsvalue - twfivevalue) / 5;
	 int32 fivesvalue = fives * 5;
	 int32 ones = (num - tenthousvalue - thousvalue - hunsvalue - twfivevalue - fivesvalue);


	 if (tenthous)
	 {
		PChips[i][5]->CAD.SetY(yoffset);
		PChips[i][5]->CAD.SetZ(zoffset);

		PChips[i][5]->CAD.SetCurrentFrame(int16(tenthous - 1));
		PChips[i][5]->Show();
	 }
	 else {PChips[i][5]->NoShow();}
	 yoffset -= int16(2*tenthous);
	 zoffset += int16(tenthous);

	 if (thous)
	 {
		PChips[i][4]->CAD.SetY(yoffset);
		PChips[i][4]->CAD.SetZ(zoffset);

		PChips[i][4]->CAD.SetCurrentFrame(int16(thous - 1));
		PChips[i][4]->Show();
	 }
	 else {PChips[i][4]->NoShow();}
	 yoffset -= int16(2*thous);
	 zoffset += int16(thous);

	 if (huns)
	 {
		PChips[i][3]->CAD.SetY(yoffset);
		PChips[i][3]->CAD.SetZ(zoffset);

		PChips[i][3]->CAD.SetCurrentFrame(int16(huns - 1));
		PChips[i][3]->Show();
	 }
	 else {PChips[i][3]->NoShow();}
	 yoffset -= int16(2*huns);
	 zoffset += int16(huns);

	 if (twfive)
	 {
		PChips[i][2]->CAD.SetY(yoffset);
		PChips[i][2]->CAD.SetZ(zoffset);

		PChips[i][2]->CAD.SetCurrentFrame(int16(twfive - 1));
		PChips[i][2]->Show();
	 }
	 else {PChips[i][2]->NoShow();}
	 yoffset -= int16(2*twfive);
	 zoffset += int16(twfive);

	 if (fives)
	 {
		PChips[i][1]->CAD.SetY(yoffset);
		PChips[i][1]->CAD.SetZ(zoffset);

		PChips[i][1]->CAD.SetCurrentFrame(int16(fives - 1));
		PChips[i][1]->Show();
	 }
	 else {PChips[i][1]->NoShow();}
	 yoffset -= int16(2*fives);
	 zoffset += int16(fives);

	 if (ones)
	 {
		PChips[i][0]->CAD.SetY(yoffset);
		PChips[i][0]->CAD.SetZ(zoffset);

		PChips[i][0]->CAD.SetCurrentFrame(int16(ones - 1));
		PChips[i][0]->Show();
	 }
	 else {PChips[i][0]->NoShow();}
	 yoffset -= int16(2*ones);
	 zoffset += int16(ones);

	 TopY = yoffset;
	 TopZ = zoffset;
  }
  Update(GetAdjFUC());
}
//*******************************************************************