//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  crglord.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     3/26/96   A.Krist      Original baseline
//  2.0    09/18/97   M.Perry      32-bit conversion.
//  2.3    07/14/99    M.Perry    gobjlist removal
//*******************************************************************
#include "crglord.h"
#include "crlordst.h"
#include "crlrdmst.h"
#include "ostate.h"
#include <assert.h>
#include <time.h>   //To Set Random Number Generator
#include "craskex.h"
//#define  NUMBEROFPLAYERS 3
#include <stdlib.h> //For Random Number Generator
#include "casrmw.h"
#include "oskitcat.h"
#include "cplaymgr.h"
#include "crplay.h"
#include "casnames.rh"
#include "betnum.h"
#include "orespond.h"
//*******************************************************************
// the following commented out,
// looks like AKK's blind cut and paste job from bj
//#define FUC_DEALCARD1A 2
//#define FUC_DEALCARD1B 2
//#define FUC_DEALCARD1C 2
//#define FUC_DEALCARD2C 2
//#define FUC_DEALCARD2D 2
//#define FUC_DEALCARD2E 2
//#define FUC_DEALCARD3E 2
//#define FUC_DEALCARD3F 2
//#define FUC_DEALCARD3G 2
//#define FUC_DEALERUP 2
//#define FUC_DEALERDOWN 3
//#define FUC_SHOWBACK   5
//#define FUC_REMOVEBACK 2
//#define FUC_REMOVEBJBACK 12
//#define FUC_SHOWBJFACE   18
//#define FUC_SHOWFACE   5
//*******************************************************************
void TCasinoRGameLord::CleanupResponders()
{
  for(int16 i=0;i<NumResponders;i++) {delete Responders[i];}
}
//*******************************************************************
bool TCasinoRGameLord::Respond(TResponder &responder)
{
  if (PState == NULL) {return true;}
  if(responder.GetID() != ridFeltCursor && responder.GetID() != ridNamePlate  &&
	 (responder.GetResponseEvent() == reLeaveArea || responder.GetResponseEvent() == reEnterArea))
  {
	 if(responder.GetResponseEvent() == reEnterArea)
	 {
      int16 msg = 0;
		switch (responder.GetID())
		{
		  case ridBetSpot0           :  //MessageDisplay->ShowMessage(11);break;
		  case ridBetSpot1           :  msg = 11;break;//MessageDisplay->ShowMessage(11);break;
		  case ridBetSpot2           :  //MessageDisplay->ShowMessage(10);break;
		  case ridBetSpot3           :  msg = 10;break;//MessageDisplay->ShowMessage(10);break;
		  case ridBetSpot4           :  //MessageDisplay->ShowMessage(12);break;
		  case ridBetSpot5           :  msg = 12;break;//MessageDisplay->ShowMessage(12);break;
		  case ridBetSpot6           :  //MessageDisplay->ShowMessage(9);break;
		  case ridBetSpot7           :  //MessageDisplay->ShowMessage(9);break;
		  case ridBetSpot8           :  msg = 9;break;//MessageDisplay->ShowMessage(9);break;
		  case ridBetSpot9           :  //MessageDisplay->ShowMessage(8);break;
		  case ridBetSpot10          :  //MessageDisplay->ShowMessage(8);break;
		  case ridBetSpot11          :  msg = 8;break;//MessageDisplay->ShowMessage(8);break;
		  case ridBetSpot12          :  //MessageDisplay->ShowMessage(2);break;
		  case ridBetSpot13          :  //MessageDisplay->ShowMessage(2);break;
		  case ridBetSpot14          :  //MessageDisplay->ShowMessage(2);break;
		  case ridBetSpot15          :  //MessageDisplay->ShowMessage(2);break;
		  case ridBetSpot16          :  //MessageDisplay->ShowMessage(2);break;
		  case ridBetSpot17          :  //MessageDisplay->ShowMessage(2);break;
		  case ridBetSpot18          :  //MessageDisplay->ShowMessage(2);break;
		  case ridBetSpot19          :  //MessageDisplay->ShowMessage(2);break;
		  case ridBetSpot20          :  //MessageDisplay->ShowMessage(2);break;
		  case ridBetSpot21          :  //MessageDisplay->ShowMessage(2);break;
		  case ridBetSpot22          :  //MessageDisplay->ShowMessage(2);break;
		  case ridBetSpot23          :  //MessageDisplay->ShowMessage(2);break;
		  case ridBetSpot24          :  //MessageDisplay->ShowMessage(2);break;
		  case ridBetSpot25          :  //MessageDisplay->ShowMessage(2);break;
		  case ridBetSpot26          :  //MessageDisplay->ShowMessage(2);break;
		  case ridBetSpot27          :  //MessageDisplay->ShowMessage(2);break;
		  case ridBetSpot28          :  //MessageDisplay->ShowMessage(2);break;
		  case ridBetSpot29          :  //MessageDisplay->ShowMessage(2);break;
		  case ridBetSpot30          :  //MessageDisplay->ShowMessage(2);break;
		  case ridBetSpot31          :  //MessageDisplay->ShowMessage(2);break;
		  case ridBetSpot32          :  //MessageDisplay->ShowMessage(2);break;
		  case ridBetSpot33          :  //MessageDisplay->ShowMessage(2);break;
		  case ridBetSpot34          :  //MessageDisplay->ShowMessage(2);break;
		  case ridBetSpot35          :  //MessageDisplay->ShowMessage(2);break;
		  case ridBetSpot36          :  //MessageDisplay->ShowMessage(2);break;
		  case ridBetSpot37          :  //MessageDisplay->ShowMessage(2);break;
		  case ridBetSpot38          :  //MessageDisplay->ShowMessage(2);break;
		  case ridBetSpot39          :  //MessageDisplay->ShowMessage(2);break;
		  case ridBetSpot40          :  //MessageDisplay->ShowMessage(2);break;
		  case ridBetSpot41          :  //MessageDisplay->ShowMessage(2);break;
		  case ridBetSpot42          :  //MessageDisplay->ShowMessage(2);break;
		  case ridBetSpot43          :  //MessageDisplay->ShowMessage(2);break;
		  case ridBetSpot44          :  //MessageDisplay->ShowMessage(2);break;
		  case ridBetSpot45          :  //MessageDisplay->ShowMessage(2);break;
		  case ridBetSpot46          :  //MessageDisplay->ShowMessage(2);break;
		  case ridBetSpot47          :  //MessageDisplay->ShowMessage(2);break;
		  case ridBetSpot48          :  //MessageDisplay->ShowMessage(2);break;
		  case ridBetSpot49          :  msg = 2;break;//MessageDisplay->ShowMessage(2);break;
		  case ridBetSpot50          :  //MessageDisplay->ShowMessage(4);break;
		  case ridBetSpot51          :  //MessageDisplay->ShowMessage(4);break;
		  case ridBetSpot52          :  //MessageDisplay->ShowMessage(4);break;
		  case ridBetSpot53          :  //MessageDisplay->ShowMessage(4);break;
		  case ridBetSpot54          :  //MessageDisplay->ShowMessage(4);break;
		  case ridBetSpot55          :  //MessageDisplay->ShowMessage(4);break;
		  case ridBetSpot56          :  //MessageDisplay->ShowMessage(4);break;
		  case ridBetSpot57          :  //MessageDisplay->ShowMessage(4);break;
		  case ridBetSpot58          :  //MessageDisplay->ShowMessage(4);break;
		  case ridBetSpot59          :  //MessageDisplay->ShowMessage(4);break;
		  case ridBetSpot60          :  //MessageDisplay->ShowMessage(4);break;
		  case ridBetSpot61          :  msg = 4;break;//MessageDisplay->ShowMessage(4);break;
		  case ridBetSpot62          :  //MessageDisplay->ShowMessage(7);break;
		  case ridBetSpot63          :  //MessageDisplay->ShowMessage(7);break;
		  case ridBetSpot64          :  //MessageDisplay->ShowMessage(7);break;
		  case ridBetSpot65          :  //MessageDisplay->ShowMessage(7);break;
		  case ridBetSpot66          :  //MessageDisplay->ShowMessage(7);break;
		  case ridBetSpot67          :  //MessageDisplay->ShowMessage(7);break;
		  case ridBetSpot68          :  //MessageDisplay->ShowMessage(7);break;
		  case ridBetSpot69          :  //MessageDisplay->ShowMessage(7);break;
		  case ridBetSpot70          :  //MessageDisplay->ShowMessage(7);break;
		  case ridBetSpot71          :  //MessageDisplay->ShowMessage(7);break;
		  case ridBetSpot72          :  msg = 7;break;//MessageDisplay->ShowMessage(7);break;
		  case ridBetSpot73          :  //MessageDisplay->ShowMessage(5);break;
		  case ridBetSpot74          :  //MessageDisplay->ShowMessage(5);break;
		  case ridBetSpot75          :  //MessageDisplay->ShowMessage(5);break;
		  case ridBetSpot76          :  //MessageDisplay->ShowMessage(5);break;
		  case ridBetSpot77          :  //MessageDisplay->ShowMessage(5);break;
		  case ridBetSpot78          :  //MessageDisplay->ShowMessage(5);break;
		  case ridBetSpot79          :  //MessageDisplay->ShowMessage(5);break;
		  case ridBetSpot80          :  //MessageDisplay->ShowMessage(5);break;
		  case ridBetSpot81          :  //MessageDisplay->ShowMessage(5);break;
		  case ridBetSpot82          :  //MessageDisplay->ShowMessage(5);break;
		  case ridBetSpot83          :  //MessageDisplay->ShowMessage(5);break;
		  case ridBetSpot84          :  //MessageDisplay->ShowMessage(5);break;
		  case ridBetSpot85          :  //MessageDisplay->ShowMessage(5);break;
		  case ridBetSpot86          :  //MessageDisplay->ShowMessage(5);break;
		  case ridBetSpot87          :  //MessageDisplay->ShowMessage(5);break;
		  case ridBetSpot88          :  //MessageDisplay->ShowMessage(5);break;
		  case ridBetSpot89          :  //MessageDisplay->ShowMessage(5);break;
		  case ridBetSpot90          :  //MessageDisplay->ShowMessage(5);break;
		  case ridBetSpot91          :  //MessageDisplay->ShowMessage(5);break;
		  case ridBetSpot92          :  //MessageDisplay->ShowMessage(5);break;
		  case ridBetSpot93          :  //MessageDisplay->ShowMessage(5);break;
		  case ridBetSpot94          :  msg = 5;break;//MessageDisplay->ShowMessage(5);break;
		  case ridBetSpot95          :  //MessageDisplay->ShowMessage(3);break;
		  case ridBetSpot96          :  //MessageDisplay->ShowMessage(3);break;
		  case ridBetSpot97          :  //MessageDisplay->ShowMessage(3);break;
		  case ridBetSpot98          :  //MessageDisplay->ShowMessage(3);break;
		  case ridBetSpot99          :  //MessageDisplay->ShowMessage(3);break;
		  case ridBetSpot100         :  //MessageDisplay->ShowMessage(3);break;
		  case ridBetSpot101         :  //MessageDisplay->ShowMessage(3);break;
		  case ridBetSpot102         :  //MessageDisplay->ShowMessage(3);break;
		  case ridBetSpot103         :  //MessageDisplay->ShowMessage(3);break;
		  case ridBetSpot104         :  //MessageDisplay->ShowMessage(3);break;
		  case ridBetSpot105         :  //MessageDisplay->ShowMessage(3);break;
		  case ridBetSpot106         :  //MessageDisplay->ShowMessage(3);break;
		  case ridBetSpot107         :  //MessageDisplay->ShowMessage(3);break;
		  case ridBetSpot108         :  //MessageDisplay->ShowMessage(3);break;
		  case ridBetSpot109         :  //MessageDisplay->ShowMessage(3);break;
		  case ridBetSpot110         :  //MessageDisplay->ShowMessage(3);break;
		  case ridBetSpot111         :  //MessageDisplay->ShowMessage(3);break;
		  case ridBetSpot112         :  //MessageDisplay->ShowMessage(3);break;
		  case ridBetSpot113         :  //MessageDisplay->ShowMessage(3);break;
		  case ridBetSpot114         :  //MessageDisplay->ShowMessage(3);break;
		  case ridBetSpot115         :  //MessageDisplay->ShowMessage(3);break;
		  case ridBetSpot116         :  //MessageDisplay->ShowMessage(3);break;
		  case ridBetSpot117         :  //MessageDisplay->ShowMessage(3);break;
		  case ridBetSpot118         :  //MessageDisplay->ShowMessage(3);break;
		  case ridBetSpot119         :  //MessageDisplay->ShowMessage(3);break;
		  case ridBetSpot120         :  //MessageDisplay->ShowMessage(3);break;
		  case ridBetSpot121         :  //MessageDisplay->ShowMessage(3);break;
		  case ridBetSpot122         :  //MessageDisplay->ShowMessage(3);break;
		  case ridBetSpot123         :  //MessageDisplay->ShowMessage(3);break;
		  case ridBetSpot124         :  //MessageDisplay->ShowMessage(3);break;
		  case ridBetSpot125         :  //MessageDisplay->ShowMessage(3);break;
		  case ridBetSpot126         :  //MessageDisplay->ShowMessage(3);break;
		  case ridBetSpot127         :  //MessageDisplay->ShowMessage(3);break;
		  case ridBetSpot128         :  //MessageDisplay->ShowMessage(3);break;
		  case ridBetSpot129         :  //MessageDisplay->ShowMessage(3);break;
		  case ridBetSpot130         :  //MessageDisplay->ShowMessage(3);break;
		  case ridBetSpot131         :  //MessageDisplay->ShowMessage(3);break;
		  case ridBetSpot132         :  //MessageDisplay->ShowMessage(3);break;
		  case ridBetSpot133         :  //MessageDisplay->ShowMessage(3);break;
		  case ridBetSpot134         :  //MessageDisplay->ShowMessage(3);break;
		  case ridBetSpot135         :  //MessageDisplay->ShowMessage(3);break;
		  case ridBetSpot136         :  //MessageDisplay->ShowMessage(3);break;
		  case ridBetSpot137         :  //MessageDisplay->ShowMessage(3);break;
		  case ridBetSpot138         :  //MessageDisplay->ShowMessage(3);break;
		  case ridBetSpot139         :  //MessageDisplay->ShowMessage(3);break;
		  case ridBetSpot140         :  //MessageDisplay->ShowMessage(3);break;
		  case ridBetSpot141         :  //MessageDisplay->ShowMessage(3);break;
		  case ridBetSpot142         :  //MessageDisplay->ShowMessage(3);break;
		  case ridBetSpot143         :  //MessageDisplay->ShowMessage(3);break;
		  case ridBetSpot144         :  //MessageDisplay->ShowMessage(3);break;
		  case ridBetSpot145         :  //MessageDisplay->ShowMessage(3);break;
		  case ridBetSpot146         :  //MessageDisplay->ShowMessage(3);break;
		  case ridBetSpot147         :  //MessageDisplay->ShowMessage(3);break;
		  case ridBetSpot148         :  //MessageDisplay->ShowMessage(3);break;
		  case ridBetSpot149         :  //MessageDisplay->ShowMessage(3);break;
		  case ridBetSpot150         :  //MessageDisplay->ShowMessage(3);break;
		  case ridBetSpot151         :  //MessageDisplay->ShowMessage(3);break;
		  case ridBetSpot152         :  //MessageDisplay->ShowMessage(3);break;
		  case ridBetSpot153         :  //MessageDisplay->ShowMessage(3);break;
		  case ridBetSpot154         :  msg = 3;break;//MessageDisplay->ShowMessage(3);break;
		  case ridBetSpot155         :  msg = 6;break;//MessageDisplay->ShowMessage(6);break;
		  default                    :  break;
		}
      if (msg != 0) {MessageDisplay->ShowMessage(msg);}
	 }
	 else
	 {MessageDisplay->ShowMessage(messagestate);}
	 if(!BetSpotsOn){return true;}
	 if(responder.GetResponseEvent() == reLeaveArea)
	 {
		GetOgleApp()->GetCursorMgr()->SetCursor(ctAction,0,0);
		return true;
	 }
	 else if(responder.GetResponseEvent() == reEnterArea)
	 {
		if(coinsplayed > 0l && PlaceBetsMode)
		{
		  GetOgleApp()->GetCursorMgr()->SetCursor(ctAction,GetOgleApp(),ID_WHITE_CHIPS_CURSOR);
		}
		else if(!PlaceBetsMode && BetSpot[responder.GetID()-14]->HasBSBet(activeplayer))
		{
		  GetOgleApp()->GetCursorMgr()->SetCursor(ctAction,GetOgleApp(),ID_WHITE_REMOVE_CURSOR);
		}
		else if(coinsplayed == 0l && GetRPlayer(activeplayer)->lastbet > 0l &&
				  GetRPlayer(activeplayer)->lastbet <= GetCash(activeplayer) &&
				  PlaceBetsMode)
		{
		  GetOgleApp()->GetCursorMgr()->SetCursor(ctAction,GetOgleApp(),ID_WHITE_CHIPS_CURSOR);
		}
		else
		{
		  if((coinsplayed > 0l ||
			  (GetRPlayer(activeplayer)->lastbet > 0l &&
				GetRPlayer(activeplayer)->lastbet <= GetCash(activeplayer))) &&
				PlaceBetsMode)
		  {
			 GetOgleApp()->GetCursorMgr()->SetCursor(ctAction,GetOgleApp(),ID_BLACK_CHIPS_CURSOR);
		  }
		  else if(!PlaceBetsMode)
		  {
			 GetOgleApp()->GetCursorMgr()->SetCursor(ctAction,GetOgleApp(),ID_BLACK_REMOVE_CURSOR);
		  }
		}
		return true;
	 }
  }
  if (responder.GetID() == ridNamePlate)
  {
    return (((TRLordState *)PState)->NamePlate(responder));
  }
  else if (responder.GetID() == ridFeltCursor)
  {
    if(responder.GetResponseEvent() == reLeaveArea)
    {
      GetOgleApp()->GetCursorMgr()->SetCursor(ctAction,0,0);
    }
    else if(responder.GetResponseEvent() == reEnterArea)
    {
      if((coinsplayed > 0l ||
         (GetRPlayer(activeplayer)->lastbet > 0l &&
         GetRPlayer(activeplayer)->lastbet <= GetCash(activeplayer))) &&
         PlaceBetsMode)
      {
        GetOgleApp()->GetCursorMgr()->SetCursor(ctAction,GetOgleApp(),ID_BLACK_CHIPS_CURSOR);
      }
      else if(!PlaceBetsMode)
      {
        GetOgleApp()->GetCursorMgr()->SetCursor(ctAction,GetOgleApp(),ID_BLACK_REMOVE_CURSOR);
      }
    }
    return true;
  }
  else if (responder.GetID() >= ridBetSpot0 &&
           responder.GetID() <= ridBetSpot155)
  {
    int16 bs = int16(responder.GetID() - ridBetSpot0);
    return ((TRLordState *)PState)->BetSpot(responder,bs);
  }
  else
  {
    return true;
  }
/*
  switch (responder.GetID())
  {
	 case ridNamePlate          :  return (((TRLordState *)PState)->NamePlate(responder));
	 case ridFeltCursor :  if(responder.GetResponseEvent() == reLeaveArea)
									{
									  GetOgleApp()->GetCursorMgr()->SetCursor(ctAction,0,0);
									}
									else if(responder.GetResponseEvent() == reEnterArea)
									{
									  if((coinsplayed > 0l ||
										  (GetRPlayer(activeplayer)->lastbet > 0l &&
											GetRPlayer(activeplayer)->lastbet <= GetCash(activeplayer))) &&
											PlaceBetsMode)
									  {
										 GetOgleApp()->GetCursorMgr()->SetCursor(ctAction,GetOgleApp(),ID_BLACK_CHIPS_CURSOR);
									  }
									  else if(!PlaceBetsMode)
									  {
										 GetOgleApp()->GetCursorMgr()->SetCursor(ctAction,GetOgleApp(),ID_BLACK_REMOVE_CURSOR);
									  }
									}
									return true;

	 case ridBetSpot0           :  return (((TRLordState *)PState)->BetSpot(responder,0));
	 case ridBetSpot1           :  return (((TRLordState *)PState)->BetSpot(responder,1));
	 case ridBetSpot2           :  return (((TRLordState *)PState)->BetSpot(responder,2));
	 case ridBetSpot3           :  return (((TRLordState *)PState)->BetSpot(responder,3));
	 case ridBetSpot4           :  return (((TRLordState *)PState)->BetSpot(responder,4));
	 case ridBetSpot5           :  return (((TRLordState *)PState)->BetSpot(responder,5));
	 case ridBetSpot6           :  return (((TRLordState *)PState)->BetSpot(responder,6));
	 case ridBetSpot7           :  return (((TRLordState *)PState)->BetSpot(responder,7));
	 case ridBetSpot8           :  return (((TRLordState *)PState)->BetSpot(responder,8));
	 case ridBetSpot9           :  return (((TRLordState *)PState)->BetSpot(responder,9));
	 case ridBetSpot10          :  return (((TRLordState *)PState)->BetSpot(responder,10));
	 case ridBetSpot11          :  return (((TRLordState *)PState)->BetSpot(responder,11));
	 case ridBetSpot12          :  return (((TRLordState *)PState)->BetSpot(responder,12));
	 case ridBetSpot13          :  return (((TRLordState *)PState)->BetSpot(responder,13));
	 case ridBetSpot14          :  return (((TRLordState *)PState)->BetSpot(responder,14));
	 case ridBetSpot15          :  return (((TRLordState *)PState)->BetSpot(responder,15));
	 case ridBetSpot16          :  return (((TRLordState *)PState)->BetSpot(responder,16));
	 case ridBetSpot17          :  return (((TRLordState *)PState)->BetSpot(responder,17));
	 case ridBetSpot18          :  return (((TRLordState *)PState)->BetSpot(responder,18));
	 case ridBetSpot19          :  return (((TRLordState *)PState)->BetSpot(responder,19));
	 case ridBetSpot20          :  return (((TRLordState *)PState)->BetSpot(responder,20));
	 case ridBetSpot21          :  return (((TRLordState *)PState)->BetSpot(responder,21));
	 case ridBetSpot22          :  return (((TRLordState *)PState)->BetSpot(responder,22));
	 case ridBetSpot23          :  return (((TRLordState *)PState)->BetSpot(responder,23));
	 case ridBetSpot24          :  return (((TRLordState *)PState)->BetSpot(responder,24));
	 case ridBetSpot25          :  return (((TRLordState *)PState)->BetSpot(responder,25));
	 case ridBetSpot26          :  return (((TRLordState *)PState)->BetSpot(responder,26));
	 case ridBetSpot27          :  return (((TRLordState *)PState)->BetSpot(responder,27));
	 case ridBetSpot28          :  return (((TRLordState *)PState)->BetSpot(responder,28));
	 case ridBetSpot29          :  return (((TRLordState *)PState)->BetSpot(responder,29));
	 case ridBetSpot30          :  return (((TRLordState *)PState)->BetSpot(responder,30));
	 case ridBetSpot31          :  return (((TRLordState *)PState)->BetSpot(responder,31));
	 case ridBetSpot32          :  return (((TRLordState *)PState)->BetSpot(responder,32));
	 case ridBetSpot33          :  return (((TRLordState *)PState)->BetSpot(responder,33));
	 case ridBetSpot34          :  return (((TRLordState *)PState)->BetSpot(responder,34));
	 case ridBetSpot35          :  return (((TRLordState *)PState)->BetSpot(responder,35));
	 case ridBetSpot36          :  return (((TRLordState *)PState)->BetSpot(responder,36));
	 case ridBetSpot37          :  return (((TRLordState *)PState)->BetSpot(responder,37));
	 case ridBetSpot38          :  return (((TRLordState *)PState)->BetSpot(responder,38));
	 case ridBetSpot39          :  return (((TRLordState *)PState)->BetSpot(responder,39));
	 case ridBetSpot40          :  return (((TRLordState *)PState)->BetSpot(responder,40));
	 case ridBetSpot41          :  return (((TRLordState *)PState)->BetSpot(responder,41));
	 case ridBetSpot42          :  return (((TRLordState *)PState)->BetSpot(responder,42));
	 case ridBetSpot43          :  return (((TRLordState *)PState)->BetSpot(responder,43));
	 case ridBetSpot44          :  return (((TRLordState *)PState)->BetSpot(responder,44));
	 case ridBetSpot45          :  return (((TRLordState *)PState)->BetSpot(responder,45));
	 case ridBetSpot46          :  return (((TRLordState *)PState)->BetSpot(responder,46));
	 case ridBetSpot47          :  return (((TRLordState *)PState)->BetSpot(responder,47));
	 case ridBetSpot48          :  return (((TRLordState *)PState)->BetSpot(responder,48));
	 case ridBetSpot49          :  return (((TRLordState *)PState)->BetSpot(responder,49));
	 case ridBetSpot50          :  return (((TRLordState *)PState)->BetSpot(responder,50));
	 case ridBetSpot51          :  return (((TRLordState *)PState)->BetSpot(responder,51));
	 case ridBetSpot52          :  return (((TRLordState *)PState)->BetSpot(responder,52));
	 case ridBetSpot53          :  return (((TRLordState *)PState)->BetSpot(responder,53));
	 case ridBetSpot54          :  return (((TRLordState *)PState)->BetSpot(responder,54));
	 case ridBetSpot55          :  return (((TRLordState *)PState)->BetSpot(responder,55));
	 case ridBetSpot56          :  return (((TRLordState *)PState)->BetSpot(responder,56));
	 case ridBetSpot57          :  return (((TRLordState *)PState)->BetSpot(responder,57));
	 case ridBetSpot58          :  return (((TRLordState *)PState)->BetSpot(responder,58));
	 case ridBetSpot59          :  return (((TRLordState *)PState)->BetSpot(responder,59));
	 case ridBetSpot60          :  return (((TRLordState *)PState)->BetSpot(responder,60));
	 case ridBetSpot61          :  return (((TRLordState *)PState)->BetSpot(responder,61));
	 case ridBetSpot62          :  return (((TRLordState *)PState)->BetSpot(responder,62));
	 case ridBetSpot63          :  return (((TRLordState *)PState)->BetSpot(responder,63));
	 case ridBetSpot64          :  return (((TRLordState *)PState)->BetSpot(responder,64));
	 case ridBetSpot65          :  return (((TRLordState *)PState)->BetSpot(responder,65));
	 case ridBetSpot66          :  return (((TRLordState *)PState)->BetSpot(responder,66));
	 case ridBetSpot67          :  return (((TRLordState *)PState)->BetSpot(responder,67));
	 case ridBetSpot68          :  return (((TRLordState *)PState)->BetSpot(responder,68));
	 case ridBetSpot69          :  return (((TRLordState *)PState)->BetSpot(responder,69));
	 case ridBetSpot70          :  return (((TRLordState *)PState)->BetSpot(responder,70));
	 case ridBetSpot71          :  return (((TRLordState *)PState)->BetSpot(responder,71));
	 case ridBetSpot72          :  return (((TRLordState *)PState)->BetSpot(responder,72));
	 case ridBetSpot73          :  return (((TRLordState *)PState)->BetSpot(responder,73));
	 case ridBetSpot74          :  return (((TRLordState *)PState)->BetSpot(responder,74));
	 case ridBetSpot75          :  return (((TRLordState *)PState)->BetSpot(responder,75));
	 case ridBetSpot76          :  return (((TRLordState *)PState)->BetSpot(responder,76));
	 case ridBetSpot77          :  return (((TRLordState *)PState)->BetSpot(responder,77));
	 case ridBetSpot78          :  return (((TRLordState *)PState)->BetSpot(responder,78));
	 case ridBetSpot79          :  return (((TRLordState *)PState)->BetSpot(responder,79));
	 case ridBetSpot80          :  return (((TRLordState *)PState)->BetSpot(responder,80));
	 case ridBetSpot81          :  return (((TRLordState *)PState)->BetSpot(responder,81));
	 case ridBetSpot82          :  return (((TRLordState *)PState)->BetSpot(responder,82));
	 case ridBetSpot83          :  return (((TRLordState *)PState)->BetSpot(responder,83));
	 case ridBetSpot84          :  return (((TRLordState *)PState)->BetSpot(responder,84));
	 case ridBetSpot85          :  return (((TRLordState *)PState)->BetSpot(responder,85));
	 case ridBetSpot86          :  return (((TRLordState *)PState)->BetSpot(responder,86));
	 case ridBetSpot87          :  return (((TRLordState *)PState)->BetSpot(responder,87));
	 case ridBetSpot88          :  return (((TRLordState *)PState)->BetSpot(responder,88));
	 case ridBetSpot89          :  return (((TRLordState *)PState)->BetSpot(responder,89));
	 case ridBetSpot90          :  return (((TRLordState *)PState)->BetSpot(responder,90));
	 case ridBetSpot91          :  return (((TRLordState *)PState)->BetSpot(responder,91));
	 case ridBetSpot92          :  return (((TRLordState *)PState)->BetSpot(responder,92));
	 case ridBetSpot93          :  return (((TRLordState *)PState)->BetSpot(responder,93));
	 case ridBetSpot94          :  return (((TRLordState *)PState)->BetSpot(responder,94));
	 case ridBetSpot95          :  return (((TRLordState *)PState)->BetSpot(responder,95));
	 case ridBetSpot96          :  return (((TRLordState *)PState)->BetSpot(responder,96));
	 case ridBetSpot97          :  return (((TRLordState *)PState)->BetSpot(responder,97));
	 case ridBetSpot98          :  return (((TRLordState *)PState)->BetSpot(responder,98));
	 case ridBetSpot99          :  return (((TRLordState *)PState)->BetSpot(responder,99));
	 case ridBetSpot100         :  return (((TRLordState *)PState)->BetSpot(responder,100));
	 case ridBetSpot101         :  return (((TRLordState *)PState)->BetSpot(responder,101));
	 case ridBetSpot102         :  return (((TRLordState *)PState)->BetSpot(responder,102));
	 case ridBetSpot103         :  return (((TRLordState *)PState)->BetSpot(responder,103));
	 case ridBetSpot104         :  return (((TRLordState *)PState)->BetSpot(responder,104));
	 case ridBetSpot105         :  return (((TRLordState *)PState)->BetSpot(responder,105));
	 case ridBetSpot106         :  return (((TRLordState *)PState)->BetSpot(responder,106));
	 case ridBetSpot107         :  return (((TRLordState *)PState)->BetSpot(responder,107));
	 case ridBetSpot108         :  return (((TRLordState *)PState)->BetSpot(responder,108));
	 case ridBetSpot109         :  return (((TRLordState *)PState)->BetSpot(responder,109));
	 case ridBetSpot110         :  return (((TRLordState *)PState)->BetSpot(responder,110));
	 case ridBetSpot111         :  return (((TRLordState *)PState)->BetSpot(responder,111));
	 case ridBetSpot112         :  return (((TRLordState *)PState)->BetSpot(responder,112));
	 case ridBetSpot113         :  return (((TRLordState *)PState)->BetSpot(responder,113));
	 case ridBetSpot114         :  return (((TRLordState *)PState)->BetSpot(responder,114));
	 case ridBetSpot115         :  return (((TRLordState *)PState)->BetSpot(responder,115));
	 case ridBetSpot116         :  return (((TRLordState *)PState)->BetSpot(responder,116));
	 case ridBetSpot117         :  return (((TRLordState *)PState)->BetSpot(responder,117));
	 case ridBetSpot118         :  return (((TRLordState *)PState)->BetSpot(responder,118));
	 case ridBetSpot119         :  return (((TRLordState *)PState)->BetSpot(responder,119));
	 case ridBetSpot120         :  return (((TRLordState *)PState)->BetSpot(responder,120));
	 case ridBetSpot121         :  return (((TRLordState *)PState)->BetSpot(responder,121));
	 case ridBetSpot122         :  return (((TRLordState *)PState)->BetSpot(responder,122));
	 case ridBetSpot123         :  return (((TRLordState *)PState)->BetSpot(responder,123));
	 case ridBetSpot124         :  return (((TRLordState *)PState)->BetSpot(responder,124));
	 case ridBetSpot125         :  return (((TRLordState *)PState)->BetSpot(responder,125));
	 case ridBetSpot126         :  return (((TRLordState *)PState)->BetSpot(responder,126));
	 case ridBetSpot127         :  return (((TRLordState *)PState)->BetSpot(responder,127));
	 case ridBetSpot128         :  return (((TRLordState *)PState)->BetSpot(responder,128));
	 case ridBetSpot129         :  return (((TRLordState *)PState)->BetSpot(responder,129));
	 case ridBetSpot130         :  return (((TRLordState *)PState)->BetSpot(responder,130));
	 case ridBetSpot131         :  return (((TRLordState *)PState)->BetSpot(responder,131));
	 case ridBetSpot132         :  return (((TRLordState *)PState)->BetSpot(responder,132));
	 case ridBetSpot133         :  return (((TRLordState *)PState)->BetSpot(responder,133));
	 case ridBetSpot134         :  return (((TRLordState *)PState)->BetSpot(responder,134));
	 case ridBetSpot135         :  return (((TRLordState *)PState)->BetSpot(responder,135));
	 case ridBetSpot136         :  return (((TRLordState *)PState)->BetSpot(responder,136));
	 case ridBetSpot137         :  return (((TRLordState *)PState)->BetSpot(responder,137));
	 case ridBetSpot138         :  return (((TRLordState *)PState)->BetSpot(responder,138));
	 case ridBetSpot139         :  return (((TRLordState *)PState)->BetSpot(responder,139));
	 case ridBetSpot140         :  return (((TRLordState *)PState)->BetSpot(responder,140));
	 case ridBetSpot141         :  return (((TRLordState *)PState)->BetSpot(responder,141));
	 case ridBetSpot142         :  return (((TRLordState *)PState)->BetSpot(responder,142));
	 case ridBetSpot143         :  return (((TRLordState *)PState)->BetSpot(responder,143));
	 case ridBetSpot144         :  return (((TRLordState *)PState)->BetSpot(responder,144));
	 case ridBetSpot145         :  return (((TRLordState *)PState)->BetSpot(responder,145));
	 case ridBetSpot146         :  return (((TRLordState *)PState)->BetSpot(responder,146));
	 case ridBetSpot147         :  return (((TRLordState *)PState)->BetSpot(responder,147));
	 case ridBetSpot148         :  return (((TRLordState *)PState)->BetSpot(responder,148));
	 case ridBetSpot149         :  return (((TRLordState *)PState)->BetSpot(responder,149));
	 case ridBetSpot150         :  return (((TRLordState *)PState)->BetSpot(responder,150));
	 case ridBetSpot151         :  return (((TRLordState *)PState)->BetSpot(responder,151));
	 case ridBetSpot152         :  return (((TRLordState *)PState)->BetSpot(responder,152));
	 case ridBetSpot153         :  return (((TRLordState *)PState)->BetSpot(responder,153));
	 case ridBetSpot154         :  return (((TRLordState *)PState)->BetSpot(responder,154));
	 case ridBetSpot155         :  return (((TRLordState *)PState)->BetSpot(responder,155));

	 default                    :  return true;
  }
*/
}
//*******************************************************************
void TCasinoRGameLord::SetupResponders()
{
  Responders[156]  = new TResponder(PModeWin,100,TRect(260,465,375,477),ridNamePlate,this,true,VK_TAB,TCursorData(GetOgleApp(),ID_POINTING_FINGER_CURSOR));
  Responders[157]  = new TResponder(PModeWin,50,TRect(1,262,635,428),ridFeltCursor,this,true);

  Responders[0]  = new TResponder(PModeWin,100,TRect(228,377,323,395),ridBetSpot0          ,this,true);
  Responders[1]  = new TResponder(PModeWin,100,TRect(328,377,423,395),ridBetSpot1          ,this,true);
  Responders[2]  = new TResponder(PModeWin,100,TRect(130,377,220,395),ridBetSpot2          ,this,true);
  Responders[3]  = new TResponder(PModeWin,100,TRect(433,377,521,395),ridBetSpot3          ,this,true);
  Responders[4]  = new TResponder(PModeWin,100,TRect(31,377,117,395) ,ridBetSpot4          ,this,true);
  Responders[5]  = new TResponder(PModeWin,100,TRect(536,377,620,395),ridBetSpot5          ,this,true);
  Responders[6]  = new TResponder(PModeWin,100,TRect(43,358,223,374) ,ridBetSpot6          ,this,true);
  Responders[7]  = new TResponder(PModeWin,100,TRect(233,357,419,374),ridBetSpot7          ,this,true);
  Responders[8]  = new TResponder(PModeWin,100,TRect(428,357,607,374),ridBetSpot8          ,this,true);
  Responders[9]  = new TResponder(PModeWin,100,TRect(611,329,636,354),ridBetSpot9          ,this,true);
  Responders[10]  = new TResponder(PModeWin,100,TRect(593,304,630,326),ridBetSpot10          ,this,true);
  Responders[11]  = new TResponder(PModeWin,100,TRect(574,280,612,301),ridBetSpot11          ,this,true);
  Responders[12]  = new TResponder(PModeWin,100,TRect(64,336,85,348)  ,ridBetSpot12          ,this,true);
  Responders[13]  = new TResponder(PModeWin,100,TRect(77,308,98,320)  ,ridBetSpot13          ,this,true);
  Responders[14]  = new TResponder(PModeWin,100,TRect(94,284,115,296) ,ridBetSpot14          ,this,true);
  Responders[15]  = new TResponder(PModeWin,100,TRect(109,336,130,348),ridBetSpot15          ,this,true);
  Responders[16]  = new TResponder(PModeWin,100,TRect(120,309,141,321),ridBetSpot16          ,this,true);
  Responders[17]  = new TResponder(PModeWin,100,TRect(132,284,153,296),ridBetSpot17          ,this,true);
  Responders[18]  = new TResponder(PModeWin,100,TRect(154,336,175,348),ridBetSpot18          ,this,true);
  Responders[19]  = new TResponder(PModeWin,100,TRect(164,309,185,321),ridBetSpot19          ,this,true);
  Responders[20]  = new TResponder(PModeWin,100,TRect(172,284,193,296),ridBetSpot20          ,this,true);
  Responders[21]  = new TResponder(PModeWin,100,TRect(200,336,221,348),ridBetSpot21          ,this,true);
  Responders[22]  = new TResponder(PModeWin,100,TRect(207,310,228,321),ridBetSpot22          ,this,true);
  Responders[23]  = new TResponder(PModeWin,100,TRect(213,284,234,296),ridBetSpot23          ,this,true);
  Responders[24]  = new TResponder(PModeWin,100,TRect(247,336,268,348),ridBetSpot24          ,this,true);
  Responders[25]  = new TResponder(PModeWin,100,TRect(250,309,271,321),ridBetSpot25          ,this,true);
  Responders[26]  = new TResponder(PModeWin,100,TRect(253,285,274,296),ridBetSpot26          ,this,true);
  Responders[27]  = new TResponder(PModeWin,100,TRect(291,335,312,347),ridBetSpot27          ,this,true);
  Responders[28]  = new TResponder(PModeWin,100,TRect(293,309,312,321),ridBetSpot28          ,this,true);
  Responders[29]  = new TResponder(PModeWin,100,TRect(297,284,314,296),ridBetSpot29          ,this,true);
  Responders[30]  = new TResponder(PModeWin,100,TRect(334,336,358,347),ridBetSpot30          ,this,true);
  Responders[31]  = new TResponder(PModeWin,100,TRect(335,309,356,321),ridBetSpot31          ,this,true);
  Responders[32]  = new TResponder(PModeWin,100,TRect(333,284,356,296),ridBetSpot32          ,this,true);
  Responders[33]  = new TResponder(PModeWin,100,TRect(383,336,404,348),ridBetSpot33          ,this,true);
  Responders[34]  = new TResponder(PModeWin,100,TRect(379,309,400,321),ridBetSpot34          ,this,true);
  Responders[35]  = new TResponder(PModeWin,100,TRect(375,284,396,296),ridBetSpot35          ,this,true);
  Responders[36]  = new TResponder(PModeWin,100,TRect(428,336,449,348),ridBetSpot36          ,this,true);
  Responders[37]  = new TResponder(PModeWin,100,TRect(422,309,443,321),ridBetSpot37          ,this,true);
  Responders[38]  = new TResponder(PModeWin,100,TRect(414,284,435,296),ridBetSpot38          ,this,true);
  Responders[39]  = new TResponder(PModeWin,100,TRect(473,336,494,348),ridBetSpot39          ,this,true);
  Responders[40]  = new TResponder(PModeWin,100,TRect(465,309,486,321),ridBetSpot40          ,this,true);
  Responders[41]  = new TResponder(PModeWin,100,TRect(455,284,476,296),ridBetSpot41          ,this,true);
  Responders[42]  = new TResponder(PModeWin,100,TRect(520,336,541,348),ridBetSpot42          ,this,true);
  Responders[43]  = new TResponder(PModeWin,100,TRect(507,309,528,321),ridBetSpot43          ,this,true);
  Responders[44]  = new TResponder(PModeWin,100,TRect(496,284,517,296),ridBetSpot44          ,this,true);
  Responders[45]  = new TResponder(PModeWin,100,TRect(566,336,587,348),ridBetSpot45          ,this,true);
  Responders[46]  = new TResponder(PModeWin,100,TRect(551,308,572,320),ridBetSpot46          ,this,true);
  Responders[47]  = new TResponder(PModeWin,100,TRect(536,284,557,296),ridBetSpot47          ,this,true);
  Responders[48]  = new TResponder(PModeWin,100,TRect(14,323,40,345)  ,ridBetSpot48          ,this,true);
  Responders[49]  = new TResponder(PModeWin,100,TRect(41,286,64,309)  ,ridBetSpot49          ,this,true);
  Responders[50]  = new TResponder(PModeWin,100,TRect(102,271,116,282),ridBetSpot50          ,this,true);
  Responders[51]  = new TResponder(PModeWin,100,TRect(141,271,155,282),ridBetSpot51          ,this,true);
  Responders[52]  = new TResponder(PModeWin,100,TRect(180,271,194,282),ridBetSpot52          ,this,true);
  Responders[53]  = new TResponder(PModeWin,100,TRect(219,271,233,282),ridBetSpot53          ,this,true);
  Responders[54]  = new TResponder(PModeWin,100,TRect(258,271,272,282),ridBetSpot54          ,this,true);
  Responders[55]  = new TResponder(PModeWin,100,TRect(298,271,312,282),ridBetSpot55          ,this,true);
  Responders[56]  = new TResponder(PModeWin,100,TRect(338,271,352,282),ridBetSpot56          ,this,true);
  Responders[57]  = new TResponder(PModeWin,100,TRect(378,271,392,282),ridBetSpot57          ,this,true);
  Responders[58]  = new TResponder(PModeWin,100,TRect(416,271,430,282),ridBetSpot58          ,this,true);
  Responders[59]  = new TResponder(PModeWin,100,TRect(456,271,470,282),ridBetSpot59          ,this,true);
  Responders[60]  = new TResponder(PModeWin,100,TRect(495,271,509,282),ridBetSpot60          ,this,true);
  Responders[61]  = new TResponder(PModeWin,100,TRect(536,271,550,282),ridBetSpot61          ,this,true);
  Responders[62]  = new TResponder(PModeWin,100,TRect(122,271,136,282),ridBetSpot62          ,this,true);
  Responders[63]  = new TResponder(PModeWin,100,TRect(161,271,175,282),ridBetSpot63          ,this,true);
  Responders[64]  = new TResponder(PModeWin,100,TRect(200,271,214,282),ridBetSpot64          ,this,true);
  Responders[65]  = new TResponder(PModeWin,100,TRect(239,271,253,282),ridBetSpot65          ,this,true);
  Responders[66]  = new TResponder(PModeWin,100,TRect(278,271,292,282),ridBetSpot66          ,this,true);
  Responders[67]  = new TResponder(PModeWin,100,TRect(318,271,332,282),ridBetSpot67          ,this,true);
  Responders[68]  = new TResponder(PModeWin,100,TRect(357,271,371,282),ridBetSpot68          ,this,true);
  Responders[69]  = new TResponder(PModeWin,100,TRect(397,271,411,282),ridBetSpot69          ,this,true);
  Responders[70]  = new TResponder(PModeWin,100,TRect(434,271,448,282),ridBetSpot70          ,this,true);
  Responders[71]  = new TResponder(PModeWin,100,TRect(474,271,488,282),ridBetSpot71          ,this,true);
  Responders[72]  = new TResponder(PModeWin,100,TRect(514,271,528,282),ridBetSpot72          ,this,true);
  Responders[73]  = new TResponder(PModeWin,100,TRect(97,323,109,332) ,ridBetSpot73          ,this,true);
  Responders[74]  = new TResponder(PModeWin,100,TRect(110,299,122,307),ridBetSpot74          ,this,true);
  Responders[75]  = new TResponder(PModeWin,100,TRect(142,323,154,332),ridBetSpot75          ,this,true);
  Responders[76]  = new TResponder(PModeWin,100,TRect(152,298,164,307),ridBetSpot76          ,this,true);
  Responders[77]  = new TResponder(PModeWin,100,TRect(186,323,198,332),ridBetSpot77          ,this,true);
  Responders[78]  = new TResponder(PModeWin,100,TRect(194,299,206,307),ridBetSpot78          ,this,true);
  Responders[79]  = new TResponder(PModeWin,100,TRect(230,323,242,332),ridBetSpot79          ,this,true);
  Responders[80]  = new TResponder(PModeWin,100,TRect(235,298,247,307),ridBetSpot80          ,this,true);
  Responders[81]  = new TResponder(PModeWin,100,TRect(275,324,287,332),ridBetSpot81          ,this,true);
  Responders[82]  = new TResponder(PModeWin,100,TRect(277,299,289,307),ridBetSpot82          ,this,true);
  Responders[83]  = new TResponder(PModeWin,100,TRect(319,323,331,332),ridBetSpot83          ,this,true);
  Responders[84]  = new TResponder(PModeWin,100,TRect(319,298,331,307),ridBetSpot84          ,this,true);
  Responders[85]  = new TResponder(PModeWin,100,TRect(363,323,375,332),ridBetSpot85          ,this,true);
  Responders[86]  = new TResponder(PModeWin,100,TRect(361,298,373,307),ridBetSpot86          ,this,true);
  Responders[87]  = new TResponder(PModeWin,100,TRect(408,323,420,332),ridBetSpot87          ,this,true);
  Responders[88]  = new TResponder(PModeWin,100,TRect(403,298,415,307),ridBetSpot88          ,this,true);
  Responders[89]  = new TResponder(PModeWin,100,TRect(453,323,465,332),ridBetSpot89          ,this,true);
  Responders[90]  = new TResponder(PModeWin,100,TRect(445,298,457,307),ridBetSpot90          ,this,true);
  Responders[91]  = new TResponder(PModeWin,100,TRect(497,324,509,332),ridBetSpot91          ,this,true);
  Responders[92]  = new TResponder(PModeWin,100,TRect(486,298,498,307),ridBetSpot92          ,this,true);
  Responders[93]  = new TResponder(PModeWin,100,TRect(541,323,553,332),ridBetSpot93          ,this,true);
  Responders[94]  = new TResponder(PModeWin,100,TRect(528,298,540,307),ridBetSpot94          ,this,true);
  Responders[95]  = new TResponder(PModeWin,100,TRect(29,312,63,318)  ,ridBetSpot95          ,this,true);
  Responders[96]  = new TResponder(PModeWin,100,TRect(47,330,55,349)  ,ridBetSpot96          ,this,true);
  Responders[97]  = new TResponder(PModeWin,100,TRect(81,284,88,296)  ,ridBetSpot97          ,this,true);
  Responders[98]  = new TResponder(PModeWin,100,TRect(71,323,90,331)  ,ridBetSpot98          ,this,true);
  Responders[99]  = new TResponder(PModeWin,100,TRect(87,299,106,306) ,ridBetSpot99          ,this,true);
  Responders[100]  = new TResponder(PModeWin,100,TRect(93,335,100,347),ridBetSpot100          ,this,true);
  Responders[101]  = new TResponder(PModeWin,100,TRect(106,309,113,321),ridBetSpot101          ,this,true);
  Responders[102]  = new TResponder(PModeWin,100,TRect(119,285,126,296),ridBetSpot102          ,this,true);
  Responders[103]  = new TResponder(PModeWin,100,TRect(115,323,134,331),ridBetSpot103          ,this,true);
  Responders[104]  = new TResponder(PModeWin,100,TRect(127,299,146,307),ridBetSpot104          ,this,true);
  Responders[105]  = new TResponder(PModeWin,100,TRect(138,335,145,347),ridBetSpot105          ,this,true);
  Responders[106]  = new TResponder(PModeWin,100,TRect(149,309,156,321),ridBetSpot106          ,this,true);
  Responders[107]  = new TResponder(PModeWin,100,TRect(159,284,166,296),ridBetSpot107          ,this,true);
  Responders[108]  = new TResponder(PModeWin,100,TRect(160,323,179,331),ridBetSpot108          ,this,true);
  Responders[109]  = new TResponder(PModeWin,100,TRect(169,298,188,306),ridBetSpot109          ,this,true);
  Responders[110]  = new TResponder(PModeWin,100,TRect(184,335,191,347),ridBetSpot110          ,this,true);
  Responders[111]  = new TResponder(PModeWin,100,TRect(192,309,199,321),ridBetSpot111          ,this,true);
  Responders[112]  = new TResponder(PModeWin,100,TRect(200,284,207,296),ridBetSpot112          ,this,true);
  Responders[113]  = new TResponder(PModeWin,100,TRect(205,323,224,331),ridBetSpot113          ,this,true);
  Responders[114]  = new TResponder(PModeWin,100,TRect(211,298,230,306),ridBetSpot114          ,this,true);
  Responders[115]  = new TResponder(PModeWin,100,TRect(230,335,237,347),ridBetSpot115          ,this,true);
  Responders[116]  = new TResponder(PModeWin,100,TRect(235,309,242,321),ridBetSpot116          ,this,true);
  Responders[117]  = new TResponder(PModeWin,100,TRect(241,284,248,296),ridBetSpot117          ,this,true);
  Responders[118]  = new TResponder(PModeWin,100,TRect(250,323,269,331),ridBetSpot118          ,this,true);
  Responders[119]  = new TResponder(PModeWin,100,TRect(252,298,271,306),ridBetSpot119          ,this,true);
  Responders[120]  = new TResponder(PModeWin,100,TRect(276,335,283,347),ridBetSpot120          ,this,true);
  Responders[121]  = new TResponder(PModeWin,100,TRect(278,309,285,321),ridBetSpot121          ,this,true);
  Responders[122]  = new TResponder(PModeWin,100,TRect(281,284,288,296),ridBetSpot122          ,this,true);
  Responders[123]  = new TResponder(PModeWin,100,TRect(293,323,312,331),ridBetSpot123          ,this,true);
  Responders[124]  = new TResponder(PModeWin,100,TRect(295,298,314,306),ridBetSpot124          ,this,true);
  Responders[125]  = new TResponder(PModeWin,100,TRect(322,335,329,347),ridBetSpot125          ,this,true);
  Responders[126]  = new TResponder(PModeWin,100,TRect(321,309,328,321),ridBetSpot126          ,this,true);
  Responders[127]  = new TResponder(PModeWin,100,TRect(321,284,328,296),ridBetSpot127          ,this,true);
  Responders[128]  = new TResponder(PModeWin,100,TRect(338,323,357,331),ridBetSpot128          ,this,true);
  Responders[129]  = new TResponder(PModeWin,100,TRect(337,298,356,306),ridBetSpot129          ,this,true);
  Responders[130]  = new TResponder(PModeWin,100,TRect(368,335,375,347),ridBetSpot130          ,this,true);
  Responders[131]  = new TResponder(PModeWin,100,TRect(365,309,372,321),ridBetSpot131          ,this,true);
  Responders[132]  = new TResponder(PModeWin,100,TRect(362,284,369,296),ridBetSpot132          ,this,true);
  Responders[133]  = new TResponder(PModeWin,100,TRect(382,323,401,331),ridBetSpot133          ,this,true);
  Responders[134]  = new TResponder(PModeWin,100,TRect(378,298,397,306),ridBetSpot134          ,this,true);
  Responders[135]  = new TResponder(PModeWin,100,TRect(413,335,420,347),ridBetSpot135          ,this,true);
  Responders[136]  = new TResponder(PModeWin,100,TRect(408,309,415,321),ridBetSpot136          ,this,true);
  Responders[137]  = new TResponder(PModeWin,100,TRect(402,284,409,296),ridBetSpot137          ,this,true);
  Responders[138]  = new TResponder(PModeWin,100,TRect(427,323,446,331),ridBetSpot138          ,this,true);
  Responders[139]  = new TResponder(PModeWin,100,TRect(421,298,440,306),ridBetSpot139          ,this,true);
  Responders[140]  = new TResponder(PModeWin,100,TRect(459,335,466,347),ridBetSpot140          ,this,true);
  Responders[141]  = new TResponder(PModeWin,100,TRect(452,310,459,321),ridBetSpot141          ,this,true);
  Responders[142]  = new TResponder(PModeWin,100,TRect(442,284,449,296),ridBetSpot142          ,this,true);
  Responders[143]  = new TResponder(PModeWin,100,TRect(471,323,490,331),ridBetSpot143          ,this,true);
  Responders[144]  = new TResponder(PModeWin,100,TRect(462,298,481,306),ridBetSpot144          ,this,true);
  Responders[145]  = new TResponder(PModeWin,100,TRect(504,335,511,347),ridBetSpot145          ,this,true);
  Responders[146]  = new TResponder(PModeWin,100,TRect(494,309,501,321),ridBetSpot146          ,this,true);
  Responders[147]  = new TResponder(PModeWin,100,TRect(483,284,490,296),ridBetSpot147          ,this,true);
  Responders[148]  = new TResponder(PModeWin,100,TRect(515,323,534,331),ridBetSpot148          ,this,true);
  Responders[149]  = new TResponder(PModeWin,100,TRect(503,298,522,306),ridBetSpot149          ,this,true);
  Responders[150]  = new TResponder(PModeWin,100,TRect(550,335,557,347),ridBetSpot150          ,this,true);
  Responders[151]  = new TResponder(PModeWin,100,TRect(537,309,544,321),ridBetSpot151          ,this,true);
  Responders[152]  = new TResponder(PModeWin,100,TRect(523,284,530,296),ridBetSpot152          ,this,true);
  Responders[153]  = new TResponder(PModeWin,100,TRect(558,323,577,331),ridBetSpot153          ,this,true);
  Responders[154]  = new TResponder(PModeWin,100,TRect(546,298,565,306),ridBetSpot154          ,this,true);
  Responders[155]  = new TResponder(PModeWin,100,TRect(84,271,98,282),ridBetSpot155          ,this,true);

}
//*******************************************************************
TCasinoRGameLord::TCasinoRGameLord(TRouletteModeWin *pmwin,const TFileMode &fm)
:TCasinoGameLord(pmwin,fm,cr1,TMoney::did_1_00)//cd1)
{
  randomize();
  for(int16 i=0;i<156;i++)
  {
	 BetSpot[i]        = NULL;
  }
  RSounds            = NULL;
  NumberHistory      = NULL;
  Button1            = NULL;
  Button2            = NULL;
  Button3            = NULL;
  Button4            = NULL;
  ButtonChip1        = NULL;
  ButtonChip5        = NULL;
  ButtonChip25       = NULL;
  ButtonChip100      = NULL;
  ButtonChip1000     = NULL;
  ButtonChip10000    = NULL;
  AskExpertButton    = NULL;
  MenuEscButton      = NULL;
  Chips              = NULL;
//  BetUnitChips       = NULL;
  CasStatusBar       = NULL;
  NamePlate1         = NULL;
  NamePlate2         = NULL;
  NamePlate3         = NULL;
  PayOffSp           = NULL;
  Marker             = NULL;
  MessageDisplay     = NULL;
  BankCashDisplay    = NULL;
  BetAmountDisplay   = NULL;
  PState        = new TRLordMainState(this);
  pAskExpert    = new TRAsk(this);
  ALLHANDSWON      = true;
  pMWin            = pmwin;
  maxbet           = 3;
  credits          = 0;
  coinsize         = GameDenom;
  activeplayer     = -1;
  machinenum       = 0;
  playersin        = 1;
  coinsplayed      = 0l;
  shutdownstate    = 0;
  winnum           = -1;
  currentwinnings  = 0l;
  startresult      = 0;
  ButtonInfo = 0;
  BetSpotsOn = true;
  ExpertCode = 0;
  #ifdef DEBUGIDLES
  DealerPos = NULL;
  messagestate     = 0;
  Pos1 = NULL;
  Pos2 = NULL;
  Pos3 = NULL;
  #endif
  for(int16 i=0;i<NUMOFBUTTONS;i++)
  {
    ButtonHit[i] = false;
  }
  SetupResponders();
}
//*******************************************************************
TCasinoRGameLord::~TCasinoRGameLord()
{
  DestroyState();

  delete pAskExpert;
  pAskExpert = NULL;
  CleanupResponders();
}
//*******************************************************************
bool TCasinoRGameLord::BetMade(int16 player)
{
  if(player <= -1){return false;}
  for(int16 i=0;i<156;i++)
  {
	 if(BetSpot[i]->HasBSBet(player)) {return true;}
  }
  return false;
}
//*******************************************************************
bool TCasinoRGameLord::BetMade()
{
  for(int16 i=0;i<156;i++)
  {
	 if(BetSpot[i]->IsBSBet()) {return true;}
  }
  return false;
}
//*******************************************************************
void TCasinoRGameLord::PreSpinStats()
{
  TCasinoPlayerData *player;
  for(int16 j=0;j<3;j++)
  {
	 player = GetCasPD(j);
	 if(player)
	 {
		int16 session = player->RData.CurrentSession;
      TCRSession &cursession = player->RData.Sessions[session];

		for(int16 i=0;i<156;i++)
		{
		  if(BetSpot[i]->HasBSBet(j))
		  {
			 cursession.HandsPlayed++;
			 cursession.TotalBetsCash += BetSpot[i]->GetBSCash(j);
			 switch(BetSpot[i]->SpotType)
			 {
			 case SingleNum : cursession.SingleNumBets++;
									cursession.SingleNumBetsTotalCashWL -= BetSpot[i]->GetBSCash(j);
                           break;
			 case TwoNum    : cursession.TwoNumBets++;
									cursession.TwoNumBetsTotalCashWL -= BetSpot[i]->GetBSCash(j);
                           break;
			 case ThreeNum  : cursession.ThreeNumBets++;
									cursession.ThreeNumBetsTotalCashWL -= BetSpot[i]->GetBSCash(j);
                           break;
			 case FourNum   : cursession.FourNumBets++;
									cursession.FourNumBetsTotalCashWL -= BetSpot[i]->GetBSCash(j);
                           break;
			 case FiveNum   : cursession.FiveNumBets++;
									cursession.FiveNumBetsTotalCashWL -= BetSpot[i]->GetBSCash(j);
                           break;
			 case SixNum    : cursession.SixNumBets++;
									cursession.SixNumBetsTotalCashWL -= BetSpot[i]->GetBSCash(j);
                           break;
			 case Column    : cursession.ColumnBets++;
									cursession.ColumnBetsTotalCashWL -= BetSpot[i]->GetBSCash(j);
                           break;
			 case Dozen     : cursession.DozenBets++;
									cursession.DozenBetsTotalCashWL -= BetSpot[i]->GetBSCash(j);
                           break;
			 case Red       : cursession.RedBets++;
									cursession.RedBetsTotalCashWL -= BetSpot[i]->GetBSCash(j);
                           break;
			 case Black     : cursession.BlackBets++;
									cursession.BlackBetsTotalCashWL -= BetSpot[i]->GetBSCash(j);
                           break;
			 case Odd       : cursession.OddBets++;
									cursession.OddBetsTotalCashWL -= BetSpot[i]->GetBSCash(j);
                           break;
			 case Even      : cursession.EvenBets++;
									cursession.EvenBetsTotalCashWL -= BetSpot[i]->GetBSCash(j);
                           break;
			 case High      : cursession.HighBets++;
									cursession.HighBetsTotalCashWL -= BetSpot[i]->GetBSCash(j);
                           break;
			 case Low       : cursession.LowBets++;
									cursession.LowBetsTotalCashWL -= BetSpot[i]->GetBSCash(j);
                           break;
			 default        : break;
			 }
		  }
		}
	 }
  }
  return;
}
//*******************************************************************
