//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  crglord2.cpp
//    Project Name:  Casino
// Original Author:  Adam Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     5/15/96    M.Perry     split up crglord.cpp into 2 pieces
//  2.0    09/18/97    M.Perry     32-bit conversion.
//********************************************************************
#include "crglord.h"
#include "crlordst.h"
#include "crlrdmst.h"
#include "ostate.h"
#include <assert.h>
#include <time.h>   //To Set Random Number Generator
#include "craskex.h"
//#define  NUMBEROFPLAYERS 3
#include <stdlib.h> //For Random Number Generator
#include "casrmw.h"
#include "oskitcat.h"
#include "cplaymgr.h"
#include "crplay.h"
#include "casnames.rh"
#include "betnum.h"
#include "omsg.h"
#include "casapp.h"
//#include <owl\dialog.h>
//#include "owl\inputdia.h"
#include "orespond.h"
#include "oanm.h"
#include "owav.h"
#include "cas_cm.rh"
//*******************************************************************
void TCasinoRGameLord::EnableOddsMessage()
{
  for(int16 i=0;i<156;i++)
  {
	 Responders[i]->SetEnterLeave(true);
  }
}
//*******************************************************************
void TCasinoRGameLord::DisEnableOddsMessage()
{
  for(int16 i=0;i<156;i++)
  {
	 Responders[i]->SetEnterLeave(false);
  }
}
//*******************************************************************
void TCasinoRGameLord::EnableAllButtons()
{
  Button1->Enabled = true;
  Button2->Enabled = true;
  Button4->Enabled = true;
  ButtonChip10000->Enabled = true;
  ButtonChip1000->Enabled = true;
  ButtonChip100->Enabled = true;
  ButtonChip25->Enabled = true;
  ButtonChip5->Enabled = true;
  ButtonChip1->Enabled = true;
}
//*******************************************************************
void TCasinoRGameLord::DisableAllButtons()
{
  Button1->Enabled = false;
  Button2->Enabled = false;
  Button4->Enabled = false;
  ButtonChip10000->Enabled = false;
  ButtonChip1000->Enabled = false;
  ButtonChip100->Enabled = false;
  ButtonChip25->Enabled = false;
  ButtonChip5->Enabled = false;
  ButtonChip1->Enabled = false;
}
//*******************************************************************
void TCasinoRGameLord::ButtonClear(int16 button)
{
  switch(button)
  {
	 case ridStatBar          : ButtonHit[ridStatBar]=false;break;
	 case ridAskExpert        : ButtonHit[ridAskExpert]=false;break;
	 case ridOneChip          : ButtonHit[ridOneChip]=false;break;
	 case ridFiveChip         : ButtonHit[ridFiveChip]=false;break;
	 case ridTwentyFiveChip   : ButtonHit[ridTwentyFiveChip]=false;break;
	 case ridOneHundredChip   : ButtonHit[ridOneHundredChip]=false;break;
	 case ridOneThouChip      : ButtonHit[ridOneThouChip]=false;break;
	 case ridTenThouChip      : ButtonHit[ridTenThouChip]=false;break;
	 case ridMenuEsc          : ButtonHit[ridMenuEsc]=false;GetFW()->CmShowMenu();break;
	 case ridButton1          : ButtonHit[ridButton1]=false;break;
	 case ridButton2          : ButtonHit[ridButton2]=false;break;
	 case ridButton3          : ButtonHit[ridButton3]=false;PModeWin->ModeHelp();break;
	 case ridButton4          : ButtonHit[ridButton4]=false;;break;
	 default                  : WaitOnButtonDown = false;break;
  }
  WaitOnButtonDown = false;
  return;
}
//*******************************************************************
#pragma argsused
bool TCasinoRGameLord::Respond(int16 button,int16 info,void *pdata)
{
  if(info == -5)//gray button hit
  {
	 if(button == ridButton4 && GetCash(activeplayer) == 0l)
	 {
		if(activeplayer != -1 && BetMade(activeplayer))
		{
		  PModeWin->MessageBox("You're out of money and may not make additional bets. Your current bets are your only hope.","Out of Cash",MB_OK);
		}
		else if(GetCasPD(activeplayer)->IsActiveKenoTicket())
		{
		  PModeWin->MessageBox("You're out of money and may not bet. Your only hope is that one of your Keno tickets pays off.","Out of Cash",MB_OK);
		}
		else
		{
		  PModeWin->MessageBox("You've hit rock bottom. Your gambler is bankrupt. Select Create/Delete under the FILE menu to create or select a new gambler.","Bankrupt!",MB_OK);
		}
	 }
	 return true;
  }
  ButtonInfo = info;
  if(info != -1)
  {                      	 switch(button)
	 {
	 case ridStatBar : TCmMsg(CM_ASKEXPERTSTATISTICS).PostToFW();ButtonHit[ridStatBar]=true;break;
	 case ridAskExpert        : ButtonHit[ridAskExpert]=true;break;
	 case ridOneChip          : ButtonHit[ridOneChip]=true;break;
	 case ridFiveChip         : ButtonHit[ridFiveChip]=true;break;
	 case ridTwentyFiveChip   : ButtonHit[ridTwentyFiveChip]=true;break;
	 case ridOneHundredChip   : ButtonHit[ridOneHundredChip]=true;break;
	 case ridOneThouChip      : ButtonHit[ridOneThouChip]=true;break;
	 case ridTenThouChip      : ButtonHit[ridTenThouChip]=true;break;
	 case ridMenuEsc          : ButtonHit[ridMenuEsc]=true;break;
	 case ridButton1          : ButtonHit[ridButton1]=true;break;
	 case ridButton2          : ButtonHit[ridButton2]=true;break;
	 case ridButton3          : ButtonHit[ridButton3]=true;break;
	 case ridButton4          : ButtonHit[ridButton4]=true;DisableAllButtons();break;
	 }
#ifdef DEBUGCRITERIA
  /*if(button == ridMenuEsc)
  {
	 int crynum=0,cryanswer=0;
	 PModeWin->SetUpdatePause();
	 char criterianum[3] = "";
	 char cryer[10] = "";
	 TInputDialog getcriteria(PModeWin,"","#",criterianum,3);
	 getcriteria.Execute();
	 crynum = atoi(criterianum);
	 cryanswer = AskCriteriaQuestion(crynum);
	 itoa(cryanswer,cryer,10);
	 PModeWin->MessageBox(cryer,criterianum,MB_OK);
	 PModeWin->ClearUpdatePause();
  } */
  if(button == ridMenuEsc)
  {
	 int16 i,x=0;
	 char retval[5];
	 char question[7];
	 string CriteriaReport;
	 for(i=0;i<130;i++)
	 {
		x = AskCriteriaQuestion(i);
		itoa(x,retval,10);
		itoa(i,question,10);
		CriteriaReport += question;
		CriteriaReport += "-> ";
		CriteriaReport += retval;
		if(x < 0)     {CriteriaReport += "                                                ";}
		else          {CriteriaReport += "                                                 ";}
		if(i<9)       {CriteriaReport += "  ";}
		else if(i<100){CriteriaReport += " ";}
	 }
	 GetFW()->DisplayExpert(CriteriaReport);
  }
#endif

  }
  return true;
}
//*******************************************************************
void TCasinoRGameLord::ShowMarker()
{
  int16 bs = -1;
  switch(winnum)
  {
	 case 0    : bs = 48;break;//((TBetNum *)BetSpot[48])->ShowMarker();return;
	 case 1    : bs = 12;break;//((TBetNum *)BetSpot[12])->ShowMarker();return;
	 case 2    : bs = 13;break;//((TBetNum *)BetSpot[13])->ShowMarker();return;
	 case 3    : bs = 14;break;//((TBetNum *)BetSpot[14])->ShowMarker();return;
	 case 4    : bs = 15;break;//((TBetNum *)BetSpot[15])->ShowMarker();return;
	 case 5    : bs = 16;break;//((TBetNum *)BetSpot[16])->ShowMarker();return;
	 case 6    : bs = 17;break;//((TBetNum *)BetSpot[17])->ShowMarker();return;
	 case 7    : bs = 18;break;//((TBetNum *)BetSpot[18])->ShowMarker();return;
	 case 8    : bs = 19;break;//((TBetNum *)BetSpot[19])->ShowMarker();return;
	 case 9    : bs = 20;break;//((TBetNum *)BetSpot[20])->ShowMarker();return;
	 case 10   : bs = 21;break;//((TBetNum *)BetSpot[21])->ShowMarker();return;
	 case 11   : bs = 22;break;//((TBetNum *)BetSpot[22])->ShowMarker();return;
	 case 12   : bs = 23;break;//((TBetNum *)BetSpot[23])->ShowMarker();return;
	 case 13   : bs = 24;break;//((TBetNum *)BetSpot[24])->ShowMarker();return;
	 case 14   : bs = 25;break;//((TBetNum *)BetSpot[25])->ShowMarker();return;
	 case 15   : bs = 26;break;//((TBetNum *)BetSpot[26])->ShowMarker();return;
	 case 16   : bs = 27;break;//((TBetNum *)BetSpot[27])->ShowMarker();return;
	 case 17   : bs = 28;break;//((TBetNum *)BetSpot[28])->ShowMarker();return;
	 case 18   : bs = 29;break;//((TBetNum *)BetSpot[29])->ShowMarker();return;
	 case 19   : bs = 30;break;//((TBetNum *)BetSpot[30])->ShowMarker();return;
	 case 20   : bs = 31;break;//((TBetNum *)BetSpot[31])->ShowMarker();return;
	 case 21   : bs = 32;break;//((TBetNum *)BetSpot[32])->ShowMarker();return;
	 case 22   : bs = 33;break;//((TBetNum *)BetSpot[33])->ShowMarker();return;
	 case 23   : bs = 34;break;//((TBetNum *)BetSpot[34])->ShowMarker();return;
	 case 24   : bs = 35;break;//((TBetNum *)BetSpot[35])->ShowMarker();return;
	 case 25   : bs = 36;break;//((TBetNum *)BetSpot[36])->ShowMarker();return;
	 case 26   : bs = 37;break;//((TBetNum *)BetSpot[37])->ShowMarker();return;
	 case 27   : bs = 38;break;//((TBetNum *)BetSpot[38])->ShowMarker();return;
	 case 28   : bs = 39;break;//((TBetNum *)BetSpot[39])->ShowMarker();return;
	 case 29   : bs = 40;break;//((TBetNum *)BetSpot[40])->ShowMarker();return;
	 case 30   : bs = 41;break;//((TBetNum *)BetSpot[41])->ShowMarker();return;
	 case 31   : bs = 42;break;//((TBetNum *)BetSpot[42])->ShowMarker();return;
	 case 32   : bs = 43;break;//((TBetNum *)BetSpot[43])->ShowMarker();return;
	 case 33   : bs = 44;break;//((TBetNum *)BetSpot[44])->ShowMarker();return;
	 case 34   : bs = 45;break;//((TBetNum *)BetSpot[45])->ShowMarker();return;
	 case 35   : bs = 46;break;//((TBetNum *)BetSpot[46])->ShowMarker();return;
	 case 36   : bs = 47;break;//((TBetNum *)BetSpot[47])->ShowMarker();return;
	 case 37   : bs = 49;break;//((TBetNum *)BetSpot[49])->ShowMarker();return;
	 default   : return;
  }
  if (bs > -1) {((TBetNum *)BetSpot[bs])->ShowMarker();}
}
//*******************************************************************
void TCasinoRGameLord::NoShowMarker()
{
  int16 bs = -1;
  switch(winnum)
  {
	 case 0    : bs = 48;break;//((TBetNum *)BetSpot[48])->ClearSpot();return;
	 case 1    : bs = 12;break;//((TBetNum *)BetSpot[12])->ClearSpot();return;
	 case 2    : bs = 13;break;//((TBetNum *)BetSpot[13])->ClearSpot();return;
	 case 3    : bs = 14;break;//((TBetNum *)BetSpot[14])->ClearSpot();return;
	 case 4    : bs = 15;break;//((TBetNum *)BetSpot[15])->ClearSpot();return;
	 case 5    : bs = 16;break;//((TBetNum *)BetSpot[16])->ClearSpot();return;
	 case 6    : bs = 17;break;//((TBetNum *)BetSpot[17])->ClearSpot();return;
	 case 7    : bs = 18;break;//((TBetNum *)BetSpot[18])->ClearSpot();return;
	 case 8    : bs = 19;break;//((TBetNum *)BetSpot[19])->ClearSpot();return;
	 case 9    : bs = 20;break;//((TBetNum *)BetSpot[20])->ClearSpot();return;
	 case 10   : bs = 21;break;//((TBetNum *)BetSpot[21])->ClearSpot();return;
	 case 11   : bs = 22;break;//((TBetNum *)BetSpot[22])->ClearSpot();return;
	 case 12   : bs = 23;break;//((TBetNum *)BetSpot[23])->ClearSpot();return;
	 case 13   : bs = 24;break;//((TBetNum *)BetSpot[24])->ClearSpot();return;
	 case 14   : bs = 25;break;//((TBetNum *)BetSpot[25])->ClearSpot();return;
	 case 15   : bs = 26;break;//((TBetNum *)BetSpot[26])->ClearSpot();return;
	 case 16   : bs = 27;break;//((TBetNum *)BetSpot[27])->ClearSpot();return;
	 case 17   : bs = 28;break;//((TBetNum *)BetSpot[28])->ClearSpot();return;
	 case 18   : bs = 29;break;//((TBetNum *)BetSpot[29])->ClearSpot();return;
	 case 19   : bs = 30;break;//((TBetNum *)BetSpot[30])->ClearSpot();return;
	 case 20   : bs = 31;break;//((TBetNum *)BetSpot[31])->ClearSpot();return;
	 case 21   : bs = 32;break;//((TBetNum *)BetSpot[32])->ClearSpot();return;
	 case 22   : bs = 33;break;//((TBetNum *)BetSpot[33])->ClearSpot();return;
	 case 23   : bs = 34;break;//((TBetNum *)BetSpot[34])->ClearSpot();return;
	 case 24   : bs = 35;break;//((TBetNum *)BetSpot[35])->ClearSpot();return;
	 case 25   : bs = 36;break;//((TBetNum *)BetSpot[36])->ClearSpot();return;
	 case 26   : bs = 37;break;//((TBetNum *)BetSpot[37])->ClearSpot();return;
	 case 27   : bs = 38;break;//((TBetNum *)BetSpot[38])->ClearSpot();return;
	 case 28   : bs = 39;break;//((TBetNum *)BetSpot[39])->ClearSpot();return;
	 case 29   : bs = 40;break;//((TBetNum *)BetSpot[40])->ClearSpot();return;
	 case 30   : bs = 41;break;//((TBetNum *)BetSpot[41])->ClearSpot();return;
	 case 31   : bs = 42;break;//((TBetNum *)BetSpot[42])->ClearSpot();return;
	 case 32   : bs = 43;break;//((TBetNum *)BetSpot[43])->ClearSpot();return;
	 case 33   : bs = 44;break;//((TBetNum *)BetSpot[44])->ClearSpot();return;
	 case 34   : bs = 45;break;//((TBetNum *)BetSpot[45])->ClearSpot();return;
	 case 35   : bs = 46;break;//((TBetNum *)BetSpot[46])->ClearSpot();return;
	 case 36   : bs = 47;break;//((TBetNum *)BetSpot[47])->ClearSpot();return;
	 case 37   : bs = 49;break;//((TBetNum *)BetSpot[49])->ClearSpot();return;
	 default   : return;
  }
  if (bs > -1) {((TBetNum *)BetSpot[bs])->ClearSpot();}
}
//*******************************************************************
int16 TCasinoRGameLord::WinBucket(int16 randnum)
{
  int16 a = -1,b = -1;
  switch(randnum)
  {
	 case 0      :  startresult=19;a = 19;b = 29;break;//return CalcWheelPos(19,29);
	 case 1      :  startresult=10;a = 10;b = 18;break;//return CalcWheelPos(10,18);
	 case 2      :  startresult=4;a = 4;b = 5;break;//return CalcWheelPos(4,5);
	 case 3      :  startresult=12;a = 12;b = 12;break;//return CalcWheelPos(12,12);
	 case 4      :  startresult=19;a = 19;b = 23;break;//return CalcWheelPos(19,23);
	 case 5      :  startresult=8;a = 8;b = 12;break;//return CalcWheelPos(8,12);
	 case 6      :  startresult=16;a = 16;b = 23;break;//return CalcWheelPos(16,23);
	 case 7      :  startresult=17;a = 18;b = 36;break;//return CalcWheelPos(18,36);
	 case 8      :  startresult=14;a = 14;b = 21;break;//return CalcWheelPos(14,21);
	 case 9      :  startresult=16;a = 16;b = 34;break;//return CalcWheelPos(16,34);
	 case 10     :  startresult=22;a = 22;b = 8;break;//return CalcWheelPos(22,8);
	 case 11     :  startresult=7;a = 7;b = 8;break;//return CalcWheelPos(7,8);
	 case 12     :  startresult=24;a = 24;b = 9;break;//return CalcWheelPos(24,9);
	 case 13     :  startresult=13;a = 13;b = 14;break;//return CalcWheelPos(13,14);
	 case 14     :  startresult=6;a = 6;b = 2;break;//return CalcWheelPos(6,2);
	 case 15     :  startresult=10;a = 10;b = 13;break;//return CalcWheelPos(10,13);
	 case 16     :  startresult=27;a = 27;b = 15;break;//return CalcWheelPos(27,15);
	 case 17     :  startresult=8;a = 8;b = 11;break;//return CalcWheelPos(8,11);
	 case 18     :  startresult=14;a = 14;b = 24;break;//return CalcWheelPos(14,24);
	 case 19     :  startresult=26;a = 26;b = 10;break;//return CalcWheelPos(26,10);
	 case 20     :  startresult=31;a = 31;b = 24;break;//return CalcWheelPos(31,24);
	 case 21     :  startresult=16;a = 16;b = 22;break;//return CalcWheelPos(16,22);
	 case 22     :  startresult=10;a = 10;b = 11;break;//return CalcWheelPos(10,11);
	 case 23     :  startresult=17;a = 17;b = 27;break;//return CalcWheelPos(17,27);
	 case 24     :  startresult=32;a = 32;b = 29;break;//return CalcWheelPos(32,29);
	 case 25     :  startresult=36;a = 36;b = 33;break;//return CalcWheelPos(36,33);
	 case 26     :  startresult=10;a = 10;b = 3;break;//return CalcWheelPos(10,3);
	 case 27     :  startresult=34;a = 34;b = 31;break;//return CalcWheelPos(34,31);
	 case 28     :  startresult=8;a = 8;b = 3;break;//return CalcWheelPos(8,3);
	 case 29     :  startresult=12;a = 12;b = 19;break;//return CalcWheelPos(12,19);
	 case 30     :  startresult=6;a = 6;b = 8;break;//return CalcWheelPos(6,8);
	 case 31     :  startresult=15;a = 15;b = 21;break;//return CalcWheelPos(15,21);
	 case 32     :  startresult=8;a = 8;b = 10;break;//return CalcWheelPos(8,10);
	 case 33     :  startresult=17;a = 17;b = 24;break;//return CalcWheelPos(17,24);
	 case 34     :  startresult=10;a = 10;b = 12;break;//return CalcWheelPos(10,12);
	 case 35     :  startresult=9;a = 9;b = 36;break;//return CalcWheelPos(9,36);
	 case 36     :  startresult=13;a = 13;b = 13;break;//return CalcWheelPos(13,13);
	 case 37     :  startresult=11;a = 11;b = 18;break;//return CalcWheelPos(11,18);

	 default    :  return -1;
  }
  if (a > -1) {return CalcWheelPos(a,b);}
  return -1;
}
//*******************************************************************
bool TCasinoRGameLord::PlaceMarker(dword &StartFUC,dword &FUCLength,dword &MarkerFUC)
{
  if(random(100)<5)
  {
	 MarkerFUC = 8;
	 return (ActivateSprite(placemarker1,StartFUC,FUCLength));
  }
  if(winnum < 13 || winnum == 37)
  {
	 MarkerFUC = 13;
	 if(random(100)<5)
	 {
		return (ActivateSprite(placemarker2,StartFUC,FUCLength));
	 }
	 return (ActivateSprite(placemarker3,StartFUC,FUCLength));
  }
  if(winnum < 25)
  {
	 if(random(100)<5)
	 {
		MarkerFUC = 20;
		return (ActivateSprite(placemarker4,StartFUC,FUCLength));
	 }
	 MarkerFUC =8;
	 return (ActivateSprite(placemarker6,StartFUC,FUCLength));
  }
  if(winnum < 37)
  {
	 if(random(100)<5)
	 {
		MarkerFUC = 21;
		return (ActivateSprite(placemarker5,StartFUC,FUCLength));
    }
	 MarkerFUC =8;
	 return (ActivateSprite(placemarker7,StartFUC,FUCLength));
  }
  // MRP 12/21/96
  // I assume you shouldn't hit this.
  assert(false);
  return false;
}
//*******************************************************************
bool TCasinoRGameLord::RemoveMarker(dword &StartFUC,dword &FUCLength,dword &MarkerFUC)
{
  if(winnum == 0)
  {
	 if(random(100)<60)
	 {
		MarkerFUC = 4;
		return (ActivateSprite(removemarker1,StartFUC,FUCLength));
	 }
	 if(random(100)<30)
	 {
		MarkerFUC = 3;
		return (ActivateSprite(removemarker2,StartFUC,FUCLength));
	 }
	 MarkerFUC = 0;
	 return (ActivateSprite(removemarker3,StartFUC,FUCLength));
  }
  if(winnum == 7)
  {
	 if(random(100)<60)
	 {
		MarkerFUC = 4;
		return (ActivateSprite(removemarker1,StartFUC,FUCLength));
	 }
	 if(random(100)<30)
	 {
		MarkerFUC = 3;
		return (ActivateSprite(removemarker2,StartFUC,FUCLength));
	 }
	 MarkerFUC = 4;
	 return (ActivateSprite(removemarker4,StartFUC,FUCLength));
  }
  if(winnum == 13)
  {
	 if(random(100)<60)
	 {
		MarkerFUC = 4;
		return (ActivateSprite(removemarker1,StartFUC,FUCLength));
	 }
	 if(random(100)<30)
	 {
		MarkerFUC = 3;
		return (ActivateSprite(removemarker2,StartFUC,FUCLength));
	 }
	 MarkerFUC = 0;
	 return (ActivateSprite(removemarker5,StartFUC,FUCLength));
  }
  if(random(100)<70)
  {
	 MarkerFUC = 4;
	 return (ActivateSprite(removemarker1,StartFUC,FUCLength));
  }
  MarkerFUC = 3;
  return (ActivateSprite(removemarker2,StartFUC,FUCLength));
}
//*******************************************************************
bool TCasinoRGameLord::RemoveChips(dword &StartFUC,dword &FUCLength)
{
  return (ActivateSprite(removechips,StartFUC,FUCLength));
}
//*******************************************************************
bool TCasinoRGameLord::DealerSpin(dword &StartFUC,dword &FUCLength,int16 &IdleOff,
                                  int16 &BallOn,int16 frame)
{
  MessageDisplay->NoShow();
  ChangeActivePlayersOk = false;
  DisEnableOddsMessage();
  if(frame==10)
  {
    IdleOff=8;
    BallOn=15;
    return (ActivateSprite(dealerspin1,StartFUC,FUCLength));
  }
  IdleOff=6;
  BallOn=11;
  if(random(100)<97)
  {
    return (ActivateSprite(dealerspin2,StartFUC,FUCLength));
  }
  return (ActivateSprite(dealerspin3,StartFUC,FUCLength));
}
//*******************************************************************
bool TCasinoRGameLord::BallSpin(dword &StartFUC,dword &FUCLength)
{
  return (ActivateSprite(ballspin,StartFUC,FUCLength));
}
//*******************************************************************
bool TCasinoRGameLord::BallHand(dword &StartFUC,dword &FUCLength)
{
  return (ActivateSprite(ballhand,StartFUC,FUCLength));
}
//*******************************************************************
void  TCasinoRGameLord::ShuttingDown()
{
  if(shutdownstate == 0)
  {
	 if(GetCasPD(0))
	 {
		NotifyPlayerDeActivation(0);
	 }
	 if(GetCasPD(1))
	 {
		NotifyPlayerDeActivation(1);
	 }
	 if(GetCasPD(2))
	 {
		NotifyPlayerDeActivation(2);
	 }
  }
  else if(shutdownstate == 1)
  {
	 if(GetCasPD(0))
	 {
		GetCasPD(0)->EndRSession();
	 }
	 if(GetCasPD(1))
	 {
		GetCasPD(1)->EndRSession();
	 }
	 if(GetCasPD(2))
	 {
		GetCasPD(2)->EndRSession();
	 }
  }

}
//*******************************************************************
void  TCasinoRGameLord::SwitchToPlayer(int16 player)
{
  if(GetCasPD(player))
  {
	 if(activeplayer != player && activeplayer != -1)
	 {
	  //	GetCasPD(activeplayer)->Cash += coinsplayed;
		coinsplayed = 0l;
		GetRPlayer(activeplayer)->coinsplayed = 0l;
		GetCasPD(activeplayer)->Columns[0] = Chips->col1;
		GetCasPD(activeplayer)->Columns[1] = Chips->col2;
		GetCasPD(activeplayer)->Columns[2] = Chips->col3;
		GetCasPD(activeplayer)->Columns[3] = Chips->col4;
		GetCasPD(activeplayer)->Columns[4] = Chips->col5;
		GetCasPD(activeplayer)->Columns[5] = Chips->col6;
	 }

	 if(activeplayer != player)
	 {
		switch(activeplayer)
		{
			 case 0 : NamePlate1->NoShowNamePlate();break;
			 case 1 : NamePlate2->NoShowNamePlate();break;
			 case 2 : NamePlate3->NoShowNamePlate();break;
		}
		activeplayer = player;
		if(!BetMade(activeplayer)){Button1->ShowGray();}
		else{Button1->ShowVoidUp();}

		Chips->SetupCols(GetCasPD(player)->Cash,GetCasPD(player)->Columns[0],
						  GetCasPD(player)->Columns[1],GetCasPD(player)->Columns[2],
						  GetCasPD(player)->Columns[3],GetCasPD(player)->Columns[4],
						  GetCasPD(player)->Columns[5]);
		BankCashDisplay->SetNum(GetCash(activeplayer));
	  //	BetUnitChips->SetNum(GetRPlayer(activeplayer)->lastbet);
		BetAmountDisplay->SetNum(GetRPlayer(activeplayer)->lastbet);
		if(GetNumActivePlayers() > 1)
		{
		  string name;
		  name = GetCasPD(player)->GetName();
		  switch(player)
		  {
			 case 0 : NamePlate1->ShowNamePlateString(name);break;
			 case 1 : NamePlate2->ShowNamePlateString(name);break;
			 case 2 : NamePlate3->ShowNamePlateString(name);break;
		  }
		}
	 }
  }
}
//*******************************************************************
void  TCasinoRGameLord::CyclePlayers()
{
  if(activeplayer != -1)
  {
	 SwitchToPlayer(NextSlotNum(activeplayer));
  }
}
//*******************************************************************
bool TCasinoRGameLord::IsWinner()
{
  for(int16 i=0;i<156;i++)
  {
	 if(BetSpot[i]->Winner(winnum)) {return true;}
  }
  return false;
}
//*******************************************************************
bool TCasinoRGameLord::IsLoser()
{
  for(int16 i=0;i<156;i++)
  {
	 if(BetSpot[i]->IsBSBet() && !BetSpot[i]->Winner(winnum)) {return true;}
  }
  return false;
}
//*******************************************************************
void TCasinoRGameLord::NotifyPlayerActivation(int16 slotnum)
{
  if(GetCasPD(slotnum))
  {
	 GetCasPD(slotnum)->StartRSession(SubGameType,GameDenom);
//	 int session = GetCasPD(slotnum)->RData.CurrentSession;
//	 GetCasPD(slotnum)->RData.Sessions[session].GameName = (TGameName)game;
	 if(GetCash(slotnum) >= 5l)
	 {
		GetRPlayer(slotnum)->lastbet = 5l;
	 }

	 if(activeplayer == -1)
	 {
	  activeplayer = slotnum;
	  Button1->ShowGray();
	  Chips->SetupCols(GetCasPD(slotnum)->Cash,GetCasPD(slotnum)->Columns[0],
						  GetCasPD(slotnum)->Columns[1],GetCasPD(slotnum)->Columns[2],
						  GetCasPD(slotnum)->Columns[3],GetCasPD(slotnum)->Columns[4],
						  GetCasPD(slotnum)->Columns[5]);
		string name;
		name = GetCasPD(activeplayer)->GetName();
		BankCashDisplay->SetNum(GetCash(activeplayer));
		switch(slotnum)
		  {
			 case 0 : NamePlate1->ShowNamePlateString(name);break;
			 case 1 : NamePlate2->ShowNamePlateString(name);break;
			 case 2 : NamePlate3->ShowNamePlateString(name);break;
		  }
	 }
  }
}
//*******************************************************************
void TCasinoRGameLord::NotifyPlayerDeActivation(int16 slotnum)
{
  if(GetCasPD(slotnum))
  {
	 int16 i=0;
	 switch(activeplayer)
	 {
			 case 0 : NamePlate1->NoShowNamePlate();break;
			 case 1 : NamePlate2->NoShowNamePlate();break;
			 case 2 : NamePlate3->NoShowNamePlate();break;
	 }
	 for(i=0;i<156;i++)
	 {
		 GetCasPD(slotnum)->Cash += BetSpot[i]->SubBSCash(slotnum);
		 BetSpot[i]->SubBSCash(slotnum);
	 }
	 if(activeplayer == slotnum)
	 {
		coinsplayed = 0l;
		GetCasPD(slotnum)->Columns[0] = Chips->col1;
		GetCasPD(slotnum)->Columns[1] = Chips->col2;
		GetCasPD(slotnum)->Columns[2] = Chips->col3;
		GetCasPD(slotnum)->Columns[3] = Chips->col4;
		GetCasPD(slotnum)->Columns[4] = Chips->col5;
		GetCasPD(slotnum)->Columns[5] = Chips->col6;
	 }
	 if(GetNumActivePlayers() == 1)
	 {
		activeplayer = -1;
		Button1->ShowGray();
		Chips->SetNum(0l);
		BankCashDisplay->SetNum(0l);
	//	BetUnitChips->SetNum(0);
		BetAmountDisplay->SetNum(0l);
		NamePlate1->NoShow();NamePlate2->NoShow();NamePlate3->NoShow();
	 }
	 if(GetNumActivePlayers() > 1 && activeplayer == slotnum)
	 {
		int16 newplayer=-1;
		newplayer = NextSlotNum(slotnum);
		activeplayer = newplayer;
      if(!BetMade(activeplayer)){Button1->ShowGray();}
		else{Button1->ShowVoidUp();}

		Chips->SetupCols(GetCasPD(newplayer)->Cash,GetCasPD(newplayer)->Columns[0],
							  GetCasPD(newplayer)->Columns[1],GetCasPD(newplayer)->Columns[2],
							  GetCasPD(newplayer)->Columns[3],GetCasPD(newplayer)->Columns[4],
							  GetCasPD(newplayer)->Columns[5]);
		string name;
		BankCashDisplay->SetNum(GetCash(newplayer));
	//	BetUnitChips->SetNum(GetRPlayer(newplayer)->lastbet);
		BetAmountDisplay->SetNum(GetRPlayer(newplayer)->lastbet);
		name = GetCasPD(newplayer)->GetName();
		switch(newplayer)
		  {
			 case 0 : NamePlate1->ShowNamePlateString(name);break;
			 case 1 : NamePlate2->ShowNamePlateString(name);break;
			 case 2 : NamePlate3->ShowNamePlateString(name);break;
		  }
	 }
	 GetCasPD(slotnum)->EndRSession();
  }
}
//*******************************************************************
void TCasinoRGameLord::SetupActivePlayer(int16 slot)
{
  if(GetCasPD(slot))
  {
	 activeplayer = slot;
	 Chips->SetupCols(GetCasPD(slot)->Cash,GetCasPD(slot)->Columns[0],
						  GetCasPD(slot)->Columns[1],GetCasPD(slot)->Columns[2],
						  GetCasPD(slot)->Columns[3],GetCasPD(slot)->Columns[4],
						  GetCasPD(slot)->Columns[5]);
	 if(GetNumActivePlayers() > 0)
	 {
		string name;
		name = GetCasPD(slot)->GetName();
		switch(slot)
		  {
			 case 0 : NamePlate1->ShowNamePlateString(name);break;
			 case 1 : NamePlate2->ShowNamePlateString(name);break;
			 case 2 : NamePlate3->ShowNamePlateString(name);break;
		  }
	 }
  }
}
//*******************************************************************
void TCasinoRGameLord::AskBetExpert()
{
  if(ExpertCode == 0)
  {
	 pAskExpert->AskBetExpert();
  }
  else
  {
	 pAskExpert->AskCoach(ExpertCode);
	 ExpertCode = 0;
  }
}
//*******************************************************************
void TCasinoRGameLord::AskCoach()
{
  pAskExpert->AskCoach(ExpertCode);
  ExpertCode = 0;
}
//*******************************************************************
int16 TCasinoRGameLord::PlayerBet1000()
{
  if(currentwinnings > 1000l) {return 1;}
  return -1;
}
//*******************************************************************
#pragma argsused
int16 TCasinoRGameLord::PlayerBetGT(TMoney amount)
{
  if (GetRPlayer(activeplayer) == NULL) {return -1;}
  return 0;
}
//*******************************************************************
int16 TCasinoRGameLord::OneAndOnlyPlayerGT20000()
{
  if(GetNumActivePlayers() != 1){return -1;}
  if(GetRPlayer(activeplayer) == NULL){return -1;}
  if(GetCash(activeplayer) > 20000l) {return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoRGameLord::OneHumanPlayer()
{
  if(GetNumActivePlayers() == 1){return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoRGameLord::TwoHumanPlayers()
{
  if(GetNumActivePlayers() == 2){return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoRGameLord::ThreeHumanPlayers()
{
  if(GetNumActivePlayers() == 3){return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoRGameLord::AllPlayersMale()
{
  if(GetCasPD(0) != NULL && !GetCasPD(0)->Male) {return -1;}
  if(GetCasPD(1) != NULL && !GetCasPD(1)->Male) {return -1;}
  if(GetCasPD(2) != NULL && !GetCasPD(2)->Male) {return -1;}
  return 1;
}
//*******************************************************************
int16 TCasinoRGameLord::AllPlayersFemale()
{
  if(GetCasPD(0) != NULL && GetCasPD(0)->Male) {return -1;}
  if(GetCasPD(1) != NULL && GetCasPD(1)->Male) {return -1;}
  if(GetCasPD(2) != NULL && GetCasPD(2)->Male) {return -1;}
  return 1;
}
//*******************************************************************
int16 TCasinoRGameLord::RandomLT(int16 num)
{
  if(random(100) < num) {return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoRGameLord::BetweenDec22_Dec25()
{
  TDate today;
  if(today.Month() == 12 && today.DayOfMonth() > 21 && today.DayOfMonth() < 26)
  {
    return 1;
  }
  return -1;
}
//*******************************************************************
int16 TCasinoRGameLord::BetweenDec31_Jan2()
{
  TDate today;
  if((today.Month() == 12 && today.DayOfMonth() > 30) ||
     (today.Month() == 1 && today.DayOfMonth() < 3))
  {
	 return 1;
  }
  return -1;
}
//*******************************************************************
int16 TCasinoRGameLord::ValentinesDay()
{
  TDate today;
  if(today.Month() == 2 && today.DayOfMonth() == 14)
  {
	 return 1;
  }
  return -1;
}
//*******************************************************************
int16 TCasinoRGameLord::IsAWinningNumber()
{
  if(BetSpot[winnum+11]->HasBSBet(2))
  {
	 return 1;
  }
  else if(BetSpot[winnum+11]->HasBSBet(1))
  {
	 return 1;
  }
  else if(BetSpot[winnum+11]->HasBSBet(0))
  {
	 return 1;
  }
  else if(winnum == 0)
  {
	 if(BetSpot[48]->HasBSBet(2))
	 {
		return 1;
	 }
	 else if(BetSpot[48]->HasBSBet(1))
	 {
		return 1;
	 }
	 else if(BetSpot[48]->HasBSBet(0))
	 {
		return 1;
	 }
  }
  else if(winnum == 37)
  {
	 if(BetSpot[49]->HasBSBet(2))
	 {
		return 1;
	 }
	 else if(BetSpot[49]->HasBSBet(1))
	 {
		return 1;
	 }
	 else if(BetSpot[49]->HasBSBet(0))
	 {
		return 1;
	 }
  }
  return -1;
}
//*******************************************************************
int16 TCasinoRGameLord::FirstGamePlayer()
{
  //???
  return 0; //MRP 12/21/96
}
//*******************************************************************
int16 TCasinoRGameLord::Morning()
{
  TTime today;
  if((today.Hour())%24 < 12) {return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoRGameLord::Afternoon()
{
  TTime today;
  if((today.Hour())%24 > 11 && (today.Hour())%24 < 6) {return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoRGameLord::Evening()
{
  TTime today;
  if((today.Hour())%24 > 5) {return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoRGameLord::IsNumber(int16 x)
{
  if(winnum == x) {return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoRGameLord::StPatricksDay()
{
  TDate today;
  if(today.Month() == 3 && today.DayOfMonth() == 17) {return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoRGameLord::TwentyBets()
{
  int16 total = 0;
  for(int16 k=0;k<3;k++)
  {
	 if(GetCasPD(k))
	 {
		for(int16 i=0;i<156;i++)
		{
		  if(BetSpot[i]->HasBSBet(k)){total++;}
		}
	 }
  }
  if(total >19){return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoRGameLord::Laps(int16 laps)
{
  if(laps == numofspins){return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoRGameLord::AllLose()
{
  int16 total=0;
  for(int16 i=0;i<156;i++)
  {
	 if(!BetSpot[i]->Winner(winnum))
	 {
		total++;
	 }
  }
  if(total == 156){return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoRGameLord::OneWin()
{
  int16 total = 0;
  for(int16 k=0;k<3;k++)
  {
	 if(GetCasPD(k))
	 {
		for(int16 i=0;i<156;i++)
		{
		  if(BetSpot[i]->Winner(winnum,k)){total++;}
		}
	 }
  }
  if(total == 1){return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoRGameLord::Wins()
{
  int16 total = 0;
  for(int16 k=0;k<3;k++)
  {
	 if(GetCasPD(k))
	 {
		for(int16 i=0;i<156;i++)
		{
		  if(BetSpot[i]->Winner(winnum,k)){total++;}
		}
	 }
  }
  if(total > 1){return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoRGameLord::AllWin()
{
  int16 tot = 0;
  for(int16 x=0;x<3;x++)
  {
	 if(GetCasPD(x))
	 {
		for(int16 y=0;y<156;y++)
		{
		  if(BetSpot[y]->HasBSBet(x)){tot++;}
		}
	 }
  }
  int total = 0;
  for(int16 k=0;k<3;k++)
  {
	 if(GetCasPD(k))
	 {
		for(int16 i=0;i<156;i++)
		{
		  if(BetSpot[i]->Winner(winnum,k)){total++;}
		}
	 }
  }
  if(total == tot){return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoRGameLord::OneLoss()
{
  int16 total = 0;
  for(int16 k=0;k<3;k++)
  {
	 if(GetCasPD(k))
	 {
		for(int16 i=0;i<156;i++)
		{
		  if(!BetSpot[i]->Winner(winnum,k) && BetSpot[i]->HasBSBet(k)){total++;}
		}
	 }
  }
  if(total == 1){return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoRGameLord::Losses()
{
  int16 total = 0;
  for(int16 k=0;k<3;k++)
  {
	 if(GetCasPD(k))
	 {
		for(int16 i=0;i<156;i++)
		{
		  if(!BetSpot[i]->Winner(winnum,k) && BetSpot[i]->HasBSBet(k)){total++;}
		}
	 }
  }
  if(total > 1){return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoRGameLord::Bets()
{
  int16 total = 0;
  for(int16 k=0;k<3;k++)
  {
	 if(GetCasPD(k))
	 {
		for(int16 i=0;i<156;i++)
		{
		  if(BetSpot[i]->HasBSBet(k)){total++;}
		}
	 }
  }
  if(total > 1){return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoRGameLord::AllWinOne()
{
  int16 total = 0,j = 0;
  for(int16 k=0;k<3;k++)
  {
	 if(GetCasPD(k))
	 {
		j++;
		for(int16 i=0;i<156;i++)
		{
		  if(BetSpot[i]->Winner(winnum,k)){total++;i=156;}
		}
	 }
  }
  if(total == j){return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoRGameLord::ElevenPlusWins()
{
  int16 total = 0;
  for(int16 k=0;k<3;k++)
  {
	 if(GetCasPD(k))
	 {
		for(int16 i=0;i<156;i++)
		{
		  if(BetSpot[i]->Winner(winnum,k)){total++;}
		}
	 }
  }
  if(total > 10){return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoRGameLord::Win5001Plus()
{
  if(currentwinnings > 5000l) {return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoRGameLord::WinLess10()
{
  if(currentwinnings < 10l) {return 1;}
  return -1;
}
//*******************************************************************
int16 TCasinoRGameLord::AskCriteriaQuestion(int16 QNum)
{
  switch (QNum)
  {
	 case 0   : return FirstGamePlayer(); //activeplayer
	 case 1   : return Morning();
	 case 2   : return Afternoon();
	 case 3   : return Evening();
	 case 4   : return IsAWinningNumber();
	 case 5   : return IsNumber(37);
	 case 6   : return IsNumber(0);
	 case 7   : return IsNumber(1);
	 case 8   : return IsNumber(2);
	 case 9   : return IsNumber(3);
	 case 10  : return IsNumber(4);
	 case 11  : return IsNumber(5);
	 case 12  : return IsNumber(6);
	 case 13  : return IsNumber(7);
	 case 14  : return IsNumber(8);
	 case 15  : return IsNumber(9);
	 case 16  : return IsNumber(10);
	 case 17  : return IsNumber(11);
	 case 18  : return IsNumber(12);
	 case 19  : return IsNumber(13);
	 case 20  : return IsNumber(14);
	 case 21  : return IsNumber(15);
	 case 22  : return IsNumber(16);
	 case 23  : return IsNumber(17);
	 case 24  : return IsNumber(18);
	 case 25  : return IsNumber(19);
	 case 26  : return IsNumber(20);
	 case 27  : return IsNumber(21);
	 case 28  : return IsNumber(22);
	 case 29  : return IsNumber(23);
	 case 30  : return IsNumber(24);
	 case 31  : return IsNumber(25);
	 case 32  : return IsNumber(26);
	 case 33  : return IsNumber(27);
	 case 34  : return IsNumber(28);
	 case 35  : return IsNumber(29);
	 case 36  : return IsNumber(30);
	 case 37  : return IsNumber(31);
	 case 38  : return IsNumber(32);
	 case 39  : return IsNumber(33);
	 case 40  : return IsNumber(34);
	 case 41  : return IsNumber(35);
	 case 42  : return IsNumber(36);
	 case 43  : return PlayerBet1000();
	 case 44  : return TwentyBets();
	 case 45  : return Laps(1);
	 case 46  : return Laps(2);
	 case 47  : return Laps(0);
	 case 62  : return AllLose();
	 case 63  : return OneWin();
	 case 64  : return Wins();
	 case 65  : return AllWin();
	 case 66  : return OneLoss();
	 case 67  : return Losses();
	 case 68  : return Bets();
	 case 69  : return OneHumanPlayer();
	 case 70  : return TwoHumanPlayers();
	 case 71  : return ThreeHumanPlayers();
	 case 72  : return AllWinOne();
	 case 73  : return ElevenPlusWins();
	 case 74  : return Win5001Plus();
	 case 75  : return WinLess10();
	 case 76  : return RandomLT(2);
	 case 77  : return RandomLT(5);
	 case 78  : return RandomLT(10);
	 case 79  : return RandomLT(20);
	 case 80  : return RandomLT(30);
	 case 81  : return RandomLT(40);
	 case 82  : return RandomLT(50);
	 case 83  : return RandomLT(60);
	 case 84  : return RandomLT(70);
	 case 85  : return RandomLT(80);
	 case 86  : return RandomLT(90);
	 case 87  : return RandomLT(100);//What the hell kind of stupid f*&!ing question is this?
    case 88  : return int16((PModeWin->GetDetailLevel() >= 2)?1:-1);
    case 89  : return int16((PModeWin->GetDetailLevel() >= 1)?1:-1);
    case 90  : return int16((PModeWin->GetDetailLevel() >= 3)?1:-1);
  }
  return 0;
}
//*******************************************************************
int16 TCasinoRGameLord::Clear()
{
  ALLHANDSWON = true;
  shutdownstate    = 0;
  ChangeActivePlayersOk = true;
  EnableOddsMessage();
  messagestate = 0;
  for(int16 i=0;i<156;i++)
  {
	 BetSpot[i]->ClearSpot();
  }
  playersin       = 1;
  coinsplayed     = 0l;
  for(int16 i=0;i<3;i++)
  {
	 if(GetCasPD(i))
	 {
		GetRPlayer(i)->coinsplayed = 0l;
		if(GetCash(i) < GetRPlayer(i)->lastbet)
		{
		  GetRPlayer(i)->lastbet = GetCash(i);
		}
		if(activeplayer == i)
		{
		  BetAmountDisplay->SetNum(GetRPlayer(i)->lastbet);
		}
	 }
  }
  winnerpaid      = 0l;
  currentwinnings = 0l;
  return 1;
}
//*******************************************************************
void TCasinoRGameLord::ClearLosers()
{
  for(int16 i=0;i<156;i++)
  {
	 if(!BetSpot[i]->Winner(winnum))
	 {
		BetSpot[i]->ClearSpot();
	 }
  }
}
//*******************************************************************
int16 TCasinoRGameLord::NumOfCoins(TMoney money)
{
	 int32 coins=0;
	 int32 cash = (int32)money;
	 cash = cash%100001l;
	 int32 tenthous = cash / 10000;
	 int32 tenthousvalue = tenthous * 10000;
	 int32 thous = (cash - tenthousvalue) / 1000;
	 int32 thousvalue = thous * 1000;
	 int32 huns = (cash - tenthousvalue - thousvalue) / 100;
	 int32 hunsvalue = huns * 100;
	 int32 twfive = (cash - tenthousvalue - thousvalue - hunsvalue) / 25;
	 int32 twfivevalue = twfive * 25;
	 int32 fives = (cash - tenthousvalue - thousvalue - hunsvalue - twfivevalue) / 5;
	 int32 fivesvalue = fives * 5;
	 int32 ones = (cash - tenthousvalue - thousvalue - hunsvalue - twfivevalue - fivesvalue);
	 coins = tenthous+thous+huns+twfive+fives+ones;
	 if(coins == 0){return 5;}
	 if(coins == 1){return 1;}
	 if(coins >= 2 && coins <= 4){return 2;}
	 if(coins >= 5){return 3;}

    // MRP 12/21/96
    // I assume you shouldn't hit this.
    assert(false);
    return 0;
}
//*******************************************************************
int16 TCasinoRGameLord::NumOfBankCoins(TMoney money)
{
	 int32 coins=0;
	 int32 cash = (int32)money;
	 cash = cash%100001l;
	 int32 tenthous = cash / 10000;
	 int32 tenthousvalue = tenthous * 10000;
	 int32 thous = (cash - tenthousvalue) / 1000;
	 int32 thousvalue = thous * 1000;
	 int32 huns = (cash - tenthousvalue - thousvalue) / 100;
	 int32 hunsvalue = huns * 100;
	 int32 twfive = (cash - tenthousvalue - thousvalue - hunsvalue) / 25;
	 int32 twfivevalue = twfive * 25;
	 int32 fives = (cash - tenthousvalue - thousvalue - hunsvalue - twfivevalue) / 5;
	 int32 fivesvalue = fives * 5;
	 int32 ones = (cash - tenthousvalue - thousvalue - hunsvalue - twfivevalue - fivesvalue);
	 coins = tenthous+thous+huns+twfive+fives+ones;
	 if(coins == 0){return 7;}
	 if(coins == 1){return 7;}
	 if(coins >= 2 && coins <= 4){return 8;}
	 if(coins >= 5){return 9;}

    // MRP 12/21/96
    // I assume you shouldn't hit this
    assert(false);
    return 0;
}
//*******************************************************************
void TCasinoRGameLord::SetExpertCode(int16 betspot)
{
  if(GetCasPD(activeplayer) != NULL && GetCasPD(activeplayer)->CoachOn)
  {
	 switch(betspot)
	 {
		case 0   : if(BetSpot[1]->HasBSBet(activeplayer)){ExpertCode = 1;}break;
		case 1   : if(BetSpot[0]->HasBSBet(activeplayer)){ExpertCode = 1;}break;
		case 2   : if(BetSpot[3]->HasBSBet(activeplayer)){ExpertCode = 2;}break;
		case 3   : if(BetSpot[2]->HasBSBet(activeplayer)){ExpertCode = 2;}break;
		case 4   : if(BetSpot[5]->HasBSBet(activeplayer)){ExpertCode = 3;}break;
		case 5   : if(BetSpot[4]->HasBSBet(activeplayer)){ExpertCode = 3;}break;
		case 6   : if(BetSpot[7]->HasBSBet(activeplayer) &&
                    BetSpot[8]->HasBSBet(activeplayer)){ExpertCode = 5;}break;
		case 7   : if(BetSpot[6]->HasBSBet(activeplayer) &&
                    BetSpot[8]->HasBSBet(activeplayer)){ExpertCode = 5;}break;
		case 8   : if(BetSpot[6]->HasBSBet(activeplayer) &&
                    BetSpot[7]->HasBSBet(activeplayer)){ExpertCode = 5;}break;
		case 9   : if(BetSpot[10]->HasBSBet(activeplayer) &&
                    BetSpot[11]->HasBSBet(activeplayer)){ExpertCode = 4;}break;
		case 10  : if(BetSpot[9]->HasBSBet(activeplayer) &&
                    BetSpot[11]->HasBSBet(activeplayer)){ExpertCode = 4;}break;
		case 11  : if(BetSpot[9]->HasBSBet(activeplayer) &&
                    BetSpot[10]->HasBSBet(activeplayer)){ExpertCode = 4;}break;
		case 155 : ExpertCode = 6;break;
	 }
  }
}
//*******************************************************************
int16 TCasinoRGameLord::PlaceBet(int16 x)
{
  if(ExpertCode > 0)
  {
	 int16 temp=ExpertCode;
	 SetExpertCode(x);
	 if(temp == ExpertCode)
	 {
		ExpertCode = 0;
		AskExpertButton->NoShowExpert();
	 }
  }
  else
  {
	 SetExpertCode(x);
  }
  if(ExpertCode > 0)
  {
	 AskExpertButton->ShowExpert();
  }
  else
  {
	 if(coinsplayed==0l)
	 {
		BetLast();
	 }
	 if(coinsplayed+BetSpot[x]->GetBSCash(activeplayer) > 100000l)
	 {
		PModeWin->MessageBox("You may bet no more than $100,000 on any single bet spot.","Table Limit",MB_OK);
		return 0;
	 }
	 SubCash(activeplayer,coinsplayed);
	 RSounds->PlaySound(NumOfCoins(coinsplayed));
	 GetRPlayer(activeplayer)->lastbet = coinsplayed;
	 BetSpot[x]->AddBSCash(activeplayer,GetRPlayer(activeplayer)->lastbet);
	 coinsplayed = 0l;
	 GetRPlayer(activeplayer)->coinsplayed = 0l;
	 BankCashDisplay->SetNum(GetCash(activeplayer));
	 Chips->SetNum(GetCash(activeplayer));
	 if(GetCash(activeplayer) < GetRPlayer(activeplayer)->lastbet)
	 {
		GetRPlayer(activeplayer)->lastbet = GetCash(activeplayer);
		BetAmountDisplay->SetNum(GetRPlayer(activeplayer)->lastbet);
	 }
	 if(!BetMade(activeplayer)){Button1->ShowGray();}
	 else{Button1->ShowVoidUp();}

	 return 1;
  }
  return 0;
}
//*******************************************************************
int16 TCasinoRGameLord::RemoveBet(int16 x)
{
  if(BetSpot[x]->HasBSBet(activeplayer))
  {
	 AddCash(activeplayer,BetSpot[x]->SubBSCash(activeplayer));
	 Chips->SetNum(GetCash(activeplayer));
  }
  PModeWin->ReSendEnterArea();
  BankCashDisplay->SetNum(GetCash(activeplayer));
  if(!BetMade(activeplayer)){Button1->ShowGray();}
  PModeWin->ReSendEnterArea();
  return 1;
}
//*******************************************************************
#pragma argsused
bool TCasinoRGameLord::Winner(int16 winner,int16 player)
{
  //clear win stacks here
  BetSpot[winner]->ShowSpark();
  RSounds->PlaySound(0);
  ShowMarker();
  if(BetSpot[winner]->HasBSBet(2))
  {
	 SwitchToPlayer(2);
  }
  else if(BetSpot[winner]->HasBSBet(1))
  {
	 SwitchToPlayer(1);
  }
  else if(BetSpot[winner]->HasBSBet(0))
  {
	 SwitchToPlayer(0);
  }
  else
  {
	 return false;
  }
//  int session;
  PayOffSp->SetNum(BetSpot[winner]->Odds(),BetSpot[winner]->GetBSCash(activeplayer));
  MessageDisplay->ShowMessage(BetSpot[winner]->MessageCode,
                             ((BetSpot[winner]->GetBSCash(activeplayer))*
                             (BetSpot[winner]->Odds())) );
  currentwinnings = BetSpot[winner]->WinBSCash(activeplayer,winnum);
  AddCash(activeplayer,currentwinnings);
  return true;
}// winner
//*******************************************************************
#pragma argsused
int16 TCasinoRGameLord::Loser(int16 loser)
{
  int16 session=0;
  session = GetCasPD(activeplayer)->RData.CurrentSession;
  GetCasPD(activeplayer)->RData.Sessions[session].Losses++;
  return 1;
}// loser
//*******************************************************************
int16 TCasinoRGameLord::InitRoulette()
{
  for(int16 i=0;i<156;i++)
  {
	 Responders[i]->SetEnterLeave();
  }
  Responders[157]->SetEnterLeave();
  EnableOddsMessage();
  BetSpotsOn = true;
  NamePlate1->NoShow();NamePlate2->NoShow();NamePlate3->NoShow();
  string name;
  PlaceBetsMode = true;
  SetBodyIdle();
  SetWheelIdle();
  SetBallIdle();
  InitBall();
  Button1->ShowGray();
  SetupActivePlayer(NextSlotNum(-1)); // -1 because order of checking
  if(GetCasPD(0))
  {
	 name = GetCasPD(0)->GetName();
	 NamePlate1->ShowNamePlateString(name);
	 BankCashDisplay->SetNum(GetCash(0));
  }
  else if(GetCasPD(1))
  {
	 name = GetCasPD(1)->GetName();
	 NamePlate2->ShowNamePlateString(name);
	 BankCashDisplay->SetNum(GetCash(1));
  }
  else if(GetCasPD(2))
  {
	 name = GetCasPD(2)->GetName();
	 NamePlate3->ShowNamePlateString(name);
	 BankCashDisplay->SetNum(GetCash(2));
  }
  else
  {
	 BankCashDisplay->SetNum(0l);
  }
  BetAmountDisplay->SetNum(0l);
  if(GetCasPD(0))
  {
	 GetCasPD(0)->StartRSession(SubGameType,GameDenom);
	 if(GetCash(0) >= 5l)
	 {
		GetRPlayer(0)->lastbet = 5l;
	 }
  }
  if(GetCasPD(1))
  {
	 GetCasPD(1)->StartRSession(SubGameType,GameDenom);
	 if(GetCash(1) >= 5l)
	 {
		GetRPlayer(1)->lastbet = 5l;
	 }
  }
  if(GetCasPD(2))
  {
	 GetCasPD(2)->StartRSession(SubGameType,GameDenom);
	 if(GetCash(2) >= 5l)
	 {
		GetRPlayer(2)->lastbet = 5l;
	 }
  }
  if(activeplayer != -1 && GetCash(activeplayer) >= 5l)
  {
	 GetRPlayer(activeplayer)->lastbet = 5l;
	 BetAmountDisplay->SetNum(GetRPlayer(activeplayer)->lastbet);
  }
  credits = 0;
  coinsplayed = 0l;
  winnerpaid = 0l;
  if (!GetFW()->GetHandleShowMenu())
  {
	 MenuEscButton->PButton->CAD.SetCurrentFrame(3);
	 MenuEscButton->PButton->Show();
	 MenuEscButton->PButtonResponder->Remove();
  }
  return 1;
}
//*******************************************************************
int16 TCasinoRGameLord::Bet1(TMoney betsize)
{
  if(GetCash(activeplayer) == 0l)
  {
	 if(activeplayer != -1 && BetMade(activeplayer))
	 {
		  PModeWin->MessageBox("You're out of money and may not make additional bets. Your current bets are your only hope.","Out of Cash",MB_OK);
	 }
	 else if(GetCasPD(activeplayer)->IsActiveKenoTicket())
	 {
		PModeWin->MessageBox("You're out of money and may not bet. Your only hope is that one of your Keno tickets pays off.","Out of Cash",MB_OK);
	 }
	 else
	 {
		PModeWin->MessageBox("You've hit rock bottom. Your gambler is bankrupt. Select Create/Delete under the FILE menu to create or select a new gambler.","Bankrupt!",MB_OK);
	 }
	 return 1;
  }
  if(GetRPlayer(activeplayer)->coinsplayed+betsize >= 100001l)
  {
	 PModeWin->MessageBox("You may bet no more than $100,000 on any single bet spot.","Table Limit",MB_OK);
	 return 0;
  }
  if(GetCash(activeplayer) >= betsize+coinsplayed && GetRPlayer(activeplayer)->coinsplayed+betsize < 100001l)
  {
	 coinsplayed += betsize;
	 GetRPlayer(activeplayer)->coinsplayed += betsize;
	 BetAmountDisplay->SetNum(GetRPlayer(activeplayer)->coinsplayed);
	 if(coinsplayed == GetCash(activeplayer)){RSounds->PlaySound(4);}
  }
  else
  {
	 if(coinsplayed == GetCash(activeplayer) || GetCash(activeplayer) == 0l){RSounds->PlaySound(5);}
	 else
	 {
		if(GetRPlayer(activeplayer)->coinsplayed+betsize < 100001l)
		{
		  coinsplayed = GetCash(activeplayer);
		  GetRPlayer(activeplayer)->coinsplayed = GetCash(activeplayer);
		  BetAmountDisplay->SetNum(GetRPlayer(activeplayer)->coinsplayed);
		  RSounds->PlaySound(4);
		}
	 }
  }
  return 1;
}
//*******************************************************************
int16 TCasinoRGameLord::BetLast()
{
  if(GetCash(activeplayer) >= GetRPlayer(activeplayer)->lastbet)
  {
	 coinsplayed += GetRPlayer(activeplayer)->lastbet;
	 GetRPlayer(activeplayer)->coinsplayed += GetRPlayer(activeplayer)->lastbet;
  }
  return 1;
}
//*******************************************************************
int16 TCasinoRGameLord::UnBet1(TMoney betsize)
{
  if(coinsplayed >= betsize)
  {
	 coinsplayed -= betsize;
	 GetRPlayer(activeplayer)->coinsplayed -= betsize;

  BetAmountDisplay->SetNum(coinsplayed);
  }
  return 1;
}
//*******************************************************************
int16 TCasinoRGameLord::ClearBet()
{
  coinsplayed = 0l;
  GetRPlayer(activeplayer)->coinsplayed = 0l;
  GetRPlayer(activeplayer)->lastbet = 0l;
  BetAmountDisplay->SetNum(0l);
  return 1;
}
//*******************************************************************
int16 TCasinoRGameLord::BetMax()
{
  if(GetCash(activeplayer) > (maxbet-coinsplayed)*coinsize)
  {
	 SubCash(activeplayer,(maxbet-coinsplayed)*coinsize);
	 coinsplayed = maxbet;
  }
  else
  {
	 coinsplayed += (GetCash(activeplayer))/(coinsize);
	 SetCash(activeplayer,GetCash(activeplayer)%coinsize);
  }
  return 1;
}
//*******************************************************************
bool TCasinoRGameLord::BallDrop(dword &StartFUC,dword &FUCLength,dword &SpinStop)
{
  int16 x;
#ifdef ROULETTEDEBUG
  pMWin->SetUpdatePause();
  char cardnum[5] = "";
  TInputDialog getcard(pMWin,"","#",cardnum,5);
  getcard.Execute();
  pMWin->ClearUpdatePause();
  x = atoi(cardnum);
  winnum = x;WinBucket(x);
#else
  x = int16(random(38));
  winnum = WinBucket(x);
#endif
  SpinStop = GetSpritePtr(BallDrops[x])->GetWav(0)->GetFUCOffset();
  return (ActivateSprite(BallDrops[x],StartFUC,FUCLength));
}
//*******************************************************************
int16 TCasinoRGameLord::CalcWheelPos(int16 framelength,int16 stillbucket)
{
  int16 currentframe;
  int16 index=0;

  currentframe  = WheelIdle->GetCurrentAnmFrame(0);
  index  = int16((stillbucket+currentframe+framelength)%38);
  switch(index)
  {
	 case 0    : return 21;
	 case 1    : return 33;
	 case 2    : return 16;
	 case 3    : return 4;
	 case 4    : return 23;
	 case 5    : return 35;
	 case 6    : return 14;
	 case 7    : return 2;
	 case 8    : return 0;
	 case 9    : return 28;
	 case 10   : return 9;
	 case 11   : return 26;
	 case 12   : return 30;
	 case 13   : return 11;
	 case 14   : return 7;
	 case 15   : return 20;
	 case 16   : return 32;
	 case 17   : return 17;
	 case 18   : return 5;
	 case 19   : return 22;
	 case 20   : return 34;
	 case 21   : return 15;
	 case 22   : return 3;
	 case 23   : return 24;
	 case 24   : return 36;
	 case 25   : return 13;
	 case 26   : return 1;
	 case 27   : return 37;
	 case 28   : return 27;
	 case 29   : return 10;
	 case 30   : return 25;
	 case 31   : return 29;
	 case 32   : return 12;
	 case 33   : return 8;
	 case 34   : return 19;
	 case 35   : return 31;
	 case 36   : return 18;
	 case 37   : return 6;
	 default   : return -1;
  }
}
//*******************************************************************
void TCasinoRGameLord::InitBall()
{
  int16 x;
  x = int16(random(38));
  int16 currentframe;
  currentframe  = WheelIdle->GetCurrentAnmFrame(0);
  int16 a = -1;
  switch(x)
  {
	 case 0   : a = 30;break;//BallIdle->GetAnm(0)->CAD.SetCurrentFrame((30+currentframe)%38);break;
	 case 1   : a = 12;break;//BallIdle->GetAnm(0)->CAD.SetCurrentFrame((12+currentframe)%38);break;
	 case 2   : a = 31;break;//BallIdle->GetAnm(0)->CAD.SetCurrentFrame((31+currentframe)%38);break;
	 case 3   : a = 16;break;//BallIdle->GetAnm(0)->CAD.SetCurrentFrame((16+currentframe)%38);break;
	 case 4   : a = 35;break;//BallIdle->GetAnm(0)->CAD.SetCurrentFrame((35+currentframe)%38);break;
	 case 5   : a = 20;break;//BallIdle->GetAnm(0)->CAD.SetCurrentFrame((20+currentframe)%38);break;
	 case 6   : a = 1;break;//BallIdle->GetAnm(0)->CAD.SetCurrentFrame((1+currentframe)%38);break;
	 case 7   : a = 24;break;//BallIdle->GetAnm(0)->CAD.SetCurrentFrame((24+currentframe)%38);break;
	 case 8   : a = 5;break;//BallIdle->GetAnm(0)->CAD.SetCurrentFrame((5+currentframe)%38);break;
	 case 9   : a = 28;break;//BallIdle->GetAnm(0)->CAD.SetCurrentFrame((28+currentframe)%38);break;
	 case 10  : a = 9;break;//BallIdle->GetAnm(0)->CAD.SetCurrentFrame((9+currentframe)%38);break;
	 case 11  : a = 25;break;//BallIdle->GetAnm(0)->CAD.SetCurrentFrame((25+currentframe)%38);break;
	 case 12  : a = 6;break;//BallIdle->GetAnm(0)->CAD.SetCurrentFrame((6+currentframe)%38);break;
	 case 13  : a = 13;break;//BallIdle->GetAnm(0)->CAD.SetCurrentFrame((13+currentframe)%38);break;
	 case 14  : a = 32;break;//BallIdle->GetAnm(0)->CAD.SetCurrentFrame((32+currentframe)%38);break;
	 case 15  : a = 17;break;//BallIdle->GetAnm(0)->CAD.SetCurrentFrame((17+currentframe)%38);break;
	 case 16  : a = 36;break;//BallIdle->GetAnm(0)->CAD.SetCurrentFrame((36+currentframe)%38);break;
	 case 17  : a = 21;break;//BallIdle->GetAnm(0)->CAD.SetCurrentFrame((21+currentframe)%38);break;
	 case 18  : a = 2;break;//BallIdle->GetAnm(0)->CAD.SetCurrentFrame((2+currentframe)%38);break;
	 case 19  : a = 4;break;//BallIdle->GetAnm(0)->CAD.SetCurrentFrame((4+currentframe)%38);break;
	 case 20  : a = 23;break;//BallIdle->GetAnm(0)->CAD.SetCurrentFrame((23+currentframe)%38);break;
	 case 21  : a = 0;break;//BallIdle->GetAnm(0)->CAD.SetCurrentFrame((0+currentframe)%38);break;
	 case 22  : a = 19;break;//BallIdle->GetAnm(0)->CAD.SetCurrentFrame((19+currentframe)%38);break;
	 case 23  : a = 34;break;//BallIdle->GetAnm(0)->CAD.SetCurrentFrame((34+currentframe)%38);break;
	 case 24  : a = 15;break;//BallIdle->GetAnm(0)->CAD.SetCurrentFrame((15+currentframe)%38);break;
	 case 25  : a = 8;break;//BallIdle->GetAnm(0)->CAD.SetCurrentFrame((8+currentframe)%38);break;
	 case 26  : a = 27;break;//BallIdle->GetAnm(0)->CAD.SetCurrentFrame((27+currentframe)%38);break;
	 case 27  : a = 10;break;//BallIdle->GetAnm(0)->CAD.SetCurrentFrame((10+currentframe)%38);break;
	 case 28  : a = 29;break;//BallIdle->GetAnm(0)->CAD.SetCurrentFrame((29+currentframe)%38);break;
	 case 29  : a = 7;break;//BallIdle->GetAnm(0)->CAD.SetCurrentFrame((7+currentframe)%38);break;
	 case 30  : a = 26;break;//BallIdle->GetAnm(0)->CAD.SetCurrentFrame((26+currentframe)%38);break;
	 case 31  : a = 3;break;//BallIdle->GetAnm(0)->CAD.SetCurrentFrame((3+currentframe)%38);break;
	 case 32  : a = 22;break;//BallIdle->GetAnm(0)->CAD.SetCurrentFrame((22+currentframe)%38);break;
	 case 33  : a = 37;break;//BallIdle->GetAnm(0)->CAD.SetCurrentFrame((37+currentframe)%38);break;
	 case 34  : a = 18;break;//BallIdle->GetAnm(0)->CAD.SetCurrentFrame((18+currentframe)%38);break;
	 case 35  : a = 33;break;//BallIdle->GetAnm(0)->CAD.SetCurrentFrame((33+currentframe)%38);break;
	 case 36  : a = 14;break;//BallIdle->GetAnm(0)->CAD.SetCurrentFrame((14+currentframe)%38);break;
	 case 37  : a = 11;break;//BallIdle->GetAnm(0)->CAD.SetCurrentFrame((11+currentframe)%38);break;
  }
  if (a > -1) {BallIdle->GetAnm(0)->CAD.SetCurrentFrame(int16((a + currentframe) % 38));}

  NumberHistory->SetHistory(x);
}
//*******************************************************************
void TCasinoRGameLord::PostSpinStats()
{
  TMoney amountwon=0l,amountlost=0l;
  TCasinoPlayerData *player;
  for(int16 j=0;j<3;j++)
  {
	 player = GetCasPD(j);
	 if(player)
	 {
		int16 session = player->RData.CurrentSession;
      TCRSession &cursession = player->RData.Sessions[session];

		for(int16 i=0;i<156;i++)
		{
		  if(BetSpot[i]->HasBSBet(j))
		  {
			 if(BetSpot[i]->Winner(winnum))
			 {
			  cursession.Wins++;
			  amountwon += BetSpot[i]->StatWinBSCash(j,winnum);
			  amountwon -= BetSpot[i]->GetBSCash(j);
			  switch(BetSpot[i]->SpotType)
			  {
			  case SingleNum : cursession.SingleNumBetsTotalCashWL +=
                            BetSpot[i]->StatWinBSCash(j,winnum);
                            break;
			  case TwoNum    : cursession.TwoNumBetsTotalCashWL    +=
									 BetSpot[i]->StatWinBSCash(j,winnum);
                            break;
			  case ThreeNum  : cursession.ThreeNumBetsTotalCashWL  +=
									 BetSpot[i]->StatWinBSCash(j,winnum);
                            break;
			  case FourNum   : cursession.FourNumBetsTotalCashWL   +=
									 BetSpot[i]->StatWinBSCash(j,winnum);
                            break;
			  case FiveNum   : cursession.FiveNumBetsTotalCashWL   +=
									 BetSpot[i]->StatWinBSCash(j,winnum);
                            break;
			  case SixNum    : cursession.SixNumBetsTotalCashWL    +=
									 BetSpot[i]->StatWinBSCash(j,winnum);
                            break;
			  case Column    : cursession.ColumnBetsTotalCashWL    +=
									 BetSpot[i]->StatWinBSCash(j,winnum);
                            break;
			  case Dozen     : cursession.DozenBetsTotalCashWL     +=
									 BetSpot[i]->StatWinBSCash(j,winnum);
                            break;
			  case Red       : cursession.RedBetsTotalCashWL       +=
									 BetSpot[i]->StatWinBSCash(j,winnum);
                            break;
			  case Black     : cursession.BlackBetsTotalCashWL     +=
									 BetSpot[i]->StatWinBSCash(j,winnum);
                            break;
			  case Odd       : cursession.OddBetsTotalCashWL       +=
									 BetSpot[i]->StatWinBSCash(j,winnum);
                            break;
			  case Even      : cursession.EvenBetsTotalCashWL      +=
									 BetSpot[i]->StatWinBSCash(j,winnum);
                            break;
			  case High      : cursession.HighBetsTotalCashWL      +=
									 BetSpot[i]->StatWinBSCash(j,winnum);
                            break;
			  case Low       : cursession.LowBetsTotalCashWL       +=
									 BetSpot[i]->StatWinBSCash(j,winnum);
                            break;
			  default        : break;
			  }
			 }
			 else
			 {
				cursession.Losses++;
				amountlost += BetSpot[i]->GetBSCash(j);
			 }

		  }
		}
		if(amountlost < amountwon)
		{
		  if(amountwon-amountlost > cursession.LargestWin)
		  {
          cursession.LargestWin = amountwon-amountlost;
        }
		  cursession.CurrentWinStreak++;
		  cursession.CurrentLosingStreak=0;
		  if(cursession.CurrentWinStreak > cursession.WinStreak)
		  {
			 cursession.WinStreak = cursession.CurrentWinStreak;
		  }
		}
		else
		{
		  if(amountlost-amountwon > cursession.LargestLoss)
		  {
          cursession.LargestLoss = amountlost-amountwon;
        }
		  if(amountlost > amountwon)
		  {
			 cursession.CurrentLosingStreak++;
			 cursession.CurrentWinStreak = 0;
			 if (cursession.CurrentLosingStreak > cursession.LosingStreak)
			 {
				cursession.LosingStreak = cursession.CurrentLosingStreak;
			 }
		  }
		  else
		  {
			 cursession.CurrentWinStreak = 0;
			 cursession.CurrentLosingStreak = 0;
		  }
		}
		cursession.MostFrequentNums[winnum]++;
		if(IsRed())
		{
		  cursession.CurrentRedStreak++;
		  if(cursession.CurrentRedStreak > cursession.RedStreak)
		  {
			 cursession.RedStreak = cursession.CurrentRedStreak;
		  }
		}
		else
		{
		  switch(cursession.CurrentRedStreak)
		  {
			 case 0  : break;
			 case 1  : cursession.OneRedInRow++;break;
			 case 2  : cursession.TwoRedInRow++;break;
			 case 3  : cursession.ThreeRedInRow++;break;
			 case 4  : cursession.FourRedInRow++;break;
			 default : cursession.FivePlusRedInRow++;break;
		  }
		  cursession.CurrentRedStreak = 0;
		}
		if(IsBlack())
		{
		  cursession.CurrentBlackStreak++;
		  if(cursession.CurrentBlackStreak > cursession.BlackStreak)
		  {
			 cursession.BlackStreak = cursession.CurrentBlackStreak;
		  }
		}
		else
		{
		  switch(cursession.CurrentBlackStreak)
		  {
			 case 0  : break;
			 case 1  : cursession.OneBlackInRow++;break;
			 case 2  : cursession.TwoBlackInRow++;break;
			 case 3  : cursession.ThreeBlackInRow++;break;
			 case 4  : cursession.FourBlackInRow++;break;
			 default : cursession.FivePlusBlackInRow++;break;
		  }
		  cursession.CurrentBlackStreak = 0;
		}
		if(winnum%2 && winnum != 37)  //odd
		{
		  cursession.CurrentOddStreak++;
		  if(cursession.CurrentOddStreak > cursession.OddStreak)
		  {
			 cursession.OddStreak = cursession.CurrentOddStreak;
		  }
		}
		else
		{
		  switch(cursession.CurrentOddStreak)
		  {
			 case 0  : break;
			 case 1  : cursession.OneOddInRow++;break;
			 case 2  : cursession.TwoOddInRow++;break;
			 case 3  : cursession.ThreeOddInRow++;break;
			 case 4  : cursession.FourOddInRow++;break;
			 default : cursession.FivePlusOddInRow++;break;
		  }
		  cursession.CurrentOddStreak = 0;
		}
		if(!(winnum%2) && winnum != 0) //even
		{
		  cursession.CurrentEvenStreak++;
		  if(cursession.CurrentEvenStreak > cursession.EvenStreak)
		  {
			 cursession.EvenStreak = cursession.CurrentEvenStreak;
		  }
		}
		else
		{
		  switch(cursession.CurrentEvenStreak)
		  {
			 case 0  : break;
			 case 1  : cursession.OneEvenInRow++;break;
			 case 2  : cursession.TwoEvenInRow++;break;
			 case 3  : cursession.ThreeEvenInRow++;break;
			 case 4  : cursession.FourEvenInRow++;break;
			 default : cursession.FivePlusEvenInRow++;break;
		  }
		  cursession.CurrentEvenStreak = 0;
		}
		if(winnum > 18 && winnum < 37)  // high
		{
		  cursession.CurrentHighStreak++;
		  if (cursession.CurrentHighStreak > cursession.HighStreak)
		  {
			 cursession.HighStreak = cursession.CurrentHighStreak;
		  }
		}
		else
		{
		  switch(cursession.CurrentHighStreak)
		  {
			 case 0  : break;
			 case 1  : cursession.OneHighInRow++;break;
			 case 2  : cursession.TwoHighInRow++;break;
			 case 3  : cursession.ThreeHighInRow++;break;
			 case 4  : cursession.FourHighInRow++;break;
			 default : cursession.FivePlusHighInRow++;break;
		  }
		  cursession.CurrentHighStreak = 0;
		}
		if(winnum > 0  && winnum < 19)  // low
		{
		  cursession.CurrentLowStreak++;
		  if(cursession.CurrentLowStreak > cursession.LowStreak)
		  {
			 cursession.LowStreak = cursession.CurrentLowStreak;
		  }
		}
		else
		{
		  switch(cursession.CurrentLowStreak)
		  {
			 case 0  : break;
			 case 1  : cursession.OneLowInRow++;break;
			 case 2  : cursession.TwoLowInRow++;break;
			 case 3  : cursession.ThreeLowInRow++;break;
			 case 4  : cursession.FourLowInRow++;break;
			 default : cursession.FivePlusLowInRow++;break;
		  }
		  cursession.CurrentLowStreak = 0;
		}
	 }
  }
  return;
}
//*******************************************************************
bool TCasinoRGameLord::IsRed()
{
  if(winnum==1  || winnum==3  ||winnum==5  ||winnum==7  ||winnum==9  ||winnum==12 ||
     winnum==14 || winnum==16 ||winnum==18 ||winnum==19 ||winnum==21 ||winnum==23 ||
     winnum==25 || winnum==27 ||winnum==30 ||winnum==32 ||winnum==34 ||winnum==36)
  {
    return true;
  }
  else
  {
    return false;
  }
}
//*******************************************************************
bool TCasinoRGameLord::IsBlack()
{
  if(winnum==2  || winnum==4  ||winnum==6  ||winnum==8  ||winnum==10  ||winnum==11 ||
    winnum==13 || winnum==15 ||winnum==17 ||winnum==20 ||winnum==22 ||winnum==24 ||
    winnum==26 || winnum==28 ||winnum==29 ||winnum==31 ||winnum==33 ||winnum==35)
    {
      return true;
    }
    else
    {
      return false;
    }
}
//*******************************************************************

