//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  crlordst.cpp
//    Project Name:  Ogle
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     06/01/95   A. Krist    Original baseline
//  2.0     09/19/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "crlordst.h"
#include "crglord.h"
#include "crplay.h"
//*******************************************************************
TRLordState::TRLordState(TCasinoRGameLord *pNewRLord)
{
  pOwnerLord = pNewRLord;
  LockButtons = false;
  LockHit = false;
  HitTotal = false;
  IgnoreCoach = false;
  ExpertDelayStart = 0;
}
//*******************************************************************
TRLordState::~TRLordState()
{
}
//*******************************************************************
bool TRLordState::StatBar(TResponder &responder)
{
  return HandleStatBar(responder);
}
//*******************************************************************
bool TRLordState::BetSpot(TResponder &responder,int16 spot)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TRLordState *)PActiveSubState)->BetSpot(responder,spot);
  }
  else
  {
	 return HandleBetSpot(responder,spot);
  }
}
//*******************************************************************
bool TRLordState::NamePlate(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TRLordState *)PActiveSubState)->NamePlate(responder);
  }
  else
  {
	 return HandleNamePlate(responder);
  }
}
//*******************************************************************
bool TRLordState::OneChip(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TRLordState *)PActiveSubState)->OneChip(responder);
  }
  else
  {
	 return HandleOneChip(responder);
  }
}
//*******************************************************************
bool TRLordState::FiveChip(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TRLordState *)PActiveSubState)->FiveChip(responder);
  }
  else
  {
	 return HandleFiveChip(responder);
  }
}
//*******************************************************************
bool TRLordState::AskExpertButton(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TRLordState *)PActiveSubState)->AskExpertButton(responder);
  }
  else
  {
	 return HandleAskExpert(responder);
  }
}
//*******************************************************************
bool TRLordState::TwentyFiveChip(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TRLordState *)PActiveSubState)->TwentyFiveChip(responder);
  }
  else
  {
	 return HandleTwentyFiveChip(responder);
  }
}
//*******************************************************************
bool TRLordState::OneHundredChip(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TRLordState *)PActiveSubState)->OneHundredChip(responder);
  }
  else
  {
	 return HandleOneHundredChip(responder);
  }
}
//*******************************************************************
bool TRLordState::OneThouChip(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TRLordState *)PActiveSubState)->OneThouChip(responder);
  }
  else
  {
	 return HandleOneThouChip(responder);
  }
}
//*******************************************************************
bool TRLordState::TenThouChip(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TRLordState *)PActiveSubState)->TenThouChip(responder);
  }
  else
  {
	 return HandleTenThouChip(responder);
  }
}
//*******************************************************************
bool TRLordState::Button1(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TRLordState *)PActiveSubState)->Button1(responder);
  }
  else
  {
	 return HandleButton1(responder);
  }
}
//*******************************************************************
bool TRLordState::Button2(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TRLordState *)PActiveSubState)->Button2(responder);
  }
  else
  {
	 return HandleButton2(responder);
  }
}
//*******************************************************************
bool TRLordState::Button3(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TRLordState *)PActiveSubState)->Button3(responder);
  }
  else
  {
	 return HandleButton3(responder);
  }
}
//*******************************************************************
bool TRLordState::Button4(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TRLordState *)PActiveSubState)->Button4(responder);
  }
  else
  {
	 return HandleButton4(responder);
  }
}
//*******************************************************************
bool TRLordState::MenuEscButton(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TRLordState *)PActiveSubState)->MenuEscButton(responder);
  }
  else
  {
	 return HandleMenuEsc(responder);
  }
}
//*******************************************************************

