//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  crnhsp.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0    04/23/96    A.Krist     moved inline functions into .cpp file.
//  2.0    09/19/97    M.Perry     32-bit conversion.
//********************************************************************
#include "crnhsp.h"
#include "oanm.h"
//*******************************************************************
void TRNumberHistory::SetupAnms()
{
  for(int16 i=0;i<6;i++)
  {
    PWinNum[i] = GetAnm(i);
    if (PWinNum[i] == NULL) {AnmError("RNumberHistory","WinNum",i);}
  }
  for (int16 j=0;j<6;j++)
  {
	 PWinNum[j]->CAD.ClearAutoStart();
	 PWinNum[j]->CAD.ClearAutoStop();
	 PWinNum[j]->CAD.SetDirStill();
	 PWinNum[j]->CAD.SetCurrentFrame(WinNumHis[j]);

  }
}
//*******************************************************************
TRNumberHistory::TRNumberHistory(TOgleModeWindow *pmw,const TFileMode &NewFileMode)
:TSprite(pmw,NewFileMode)
{
//  SetToManual();
  NotFound = false;
  WinNumHis[0] = int16(random(38));
  WinNumHis[1] = int16(random(38));
  WinNumHis[2] = int16(random(38));
  WinNumHis[3] = int16(random(38));
  WinNumHis[4] = int16(random(38));
  WinNumHis[5] = int16(random(38));
//  NoShow();
  SetupAnms();
}
//********************************************************************
TRNumberHistory::TRNumberHistory(TOgleModeWindow *pmw,const TFileMode &fm,void *psource)
:TSprite(pmw,fm,psource)
{
 // SetToManual();
  NotFound = false;
  WinNumHis[0] = int16(random(38));
  WinNumHis[1] = int16(random(38));
  WinNumHis[2] = int16(random(38));
  WinNumHis[3] = int16(random(38));
  WinNumHis[4] = int16(random(38));
  WinNumHis[5] = int16(random(38));
 // NoShow();
  SetupAnms();
}
 //*******************************************************************
TRNumberHistory::~TRNumberHistory()
{
}
//*******************************************************************
void TRNumberHistory::SetHistory(int16 winnum)
{
  if (NotFound) {return;}
  WinNumHis[5] = WinNumHis[4];
  WinNumHis[4] = WinNumHis[3];
  WinNumHis[3] = WinNumHis[2];
  WinNumHis[2] = WinNumHis[1];
  WinNumHis[1] = WinNumHis[0];
  WinNumHis[0] = winnum;

  PWinNum[0]->CAD.SetCurrentFrame(WinNumHis[0]);
  PWinNum[1]->CAD.SetCurrentFrame(WinNumHis[1]);
  PWinNum[2]->CAD.SetCurrentFrame(WinNumHis[2]);
  PWinNum[3]->CAD.SetCurrentFrame(WinNumHis[3]);
  PWinNum[4]->CAD.SetCurrentFrame(WinNumHis[4]);
  PWinNum[5]->CAD.SetCurrentFrame(WinNumHis[5]);
  Update(GetFUC());

}
//*******************************************************************