//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  crposp.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0    03/23/96    A.Krist     moved inline functions into .cpp file.
//  2.0    09/19/97    M.Perry     32-bit conversion.
//********************************************************************
#include "crposp.h"
#include "oanm.h"
//*******************************************************************
void TRPayOff::SetupAnms()
{
  for(int16 j=0;j<35;j++)
  {
	 for (int16 i=0;i<6;i++)
	 {
		PPayOffChips[j][i] = GetAnm(int16(i+(j*6)));
		if (PPayOffChips[j][i] == NULL) {AnmError("RPayOff","Chips",int16(i+(j*6)));}
      PPayOffChips[j][i]->CAD.ClearAutoStart();
		PPayOffChips[j][i]->CAD.ClearAutoStop();
		PPayOffChips[j][i]->CAD.SetDirStill();
	 }
  }
}
//*******************************************************************
TRPayOff::TRPayOff(TOgleModeWindow *pmw,const TFileMode &NewFileMode)
:TSprite(pmw,NewFileMode)
{
  SetToManual();
  NotFound = false;
  NoShow();
  WinAmount = 0l;
  SetupAnms();
}
//********************************************************************
TRPayOff::TRPayOff(TOgleModeWindow *pmw,const TFileMode &fm,void *psource)
:TSprite(pmw,fm,psource)
{
  SetToManual();
  NotFound = false;
  NoShow();
  WinAmount = 0l;
  SetupAnms();
}
 //*******************************************************************
TRPayOff::~TRPayOff()
{
}
//*******************************************************************
void TRPayOff::NoShowChips()
{
  for(int16 i=0;i<6;i++)
  {
	 PPayOffChips[0][i]->NoShow();
	 PPayOffChips[0][i]->NoShow();
	 PPayOffChips[0][i]->NoShow();
  }
}
//*******************************************************************
void TRPayOff::SetNum(int32 stacks,TMoney money)
{
  if (NotFound) {return;}
  int32 num=0;
  int32 amount = (int32)money;
  int16 yoffset,zoffset;
  num = amount;
  num = num%100000l;
  yoffset   = PPayOffChips[0][0]->SAD.GetY();
  zoffset   = PPayOffChips[0][0]->SAD.GetZ();

  int32 tenthous = num / 10000;
  int32 tenthousvalue = tenthous * 10000;
  int32 thous = (num - tenthousvalue) / 1000;
  int32 thousvalue = thous * 1000;
  int32 huns = (num - tenthousvalue - thousvalue) / 100;
  int32 hunsvalue = huns * 100;
  int32 twfive = (num - tenthousvalue - thousvalue - hunsvalue) / 25;
  int32 twfivevalue = twfive * 25;
  int32 fives = (num - tenthousvalue - thousvalue - hunsvalue - twfivevalue) / 5;
  int32 fivesvalue = fives * 5;
  int32 ones = (num - tenthousvalue - thousvalue - hunsvalue - twfivevalue - fivesvalue);


  if (tenthous)
  {
	 PPayOffChips[0][5]->CAD.SetY(yoffset);
	 PPayOffChips[0][5]->CAD.SetZ(zoffset);

	 PPayOffChips[0][5]->CAD.SetCurrentFrame(int16(tenthous - 1));
	 PPayOffChips[0][5]->Show();
  }
  else {PPayOffChips[0][5]->NoShow();}
  yoffset -= int16(2*tenthous);
  zoffset += int16(tenthous);

  if (thous)
  {
	 PPayOffChips[0][4]->CAD.SetY(yoffset);
	 PPayOffChips[0][4]->CAD.SetZ(zoffset);

	 PPayOffChips[0][4]->CAD.SetCurrentFrame(int16(thous - 1));
	 PPayOffChips[0][4]->Show();
  }
  else {PPayOffChips[0][4]->NoShow();}
  yoffset -= int16(2*thous);
  zoffset += int16(thous);

  if (huns)
  {
	 PPayOffChips[0][3]->CAD.SetY(yoffset);
	 PPayOffChips[0][3]->CAD.SetZ(zoffset);

	 PPayOffChips[0][3]->CAD.SetCurrentFrame(int16(huns - 1));
	 PPayOffChips[0][3]->Show();
  }
  else {PPayOffChips[0][3]->NoShow();}
  yoffset -= int16(2*huns);
  zoffset += int16(huns);

  if (twfive)
  {
	 PPayOffChips[0][2]->CAD.SetY(yoffset);
	 PPayOffChips[0][2]->CAD.SetZ(zoffset);

	 PPayOffChips[0][2]->CAD.SetCurrentFrame(int16(twfive - 1));
	 PPayOffChips[0][2]->Show();
  }
  else {PPayOffChips[0][2]->NoShow();}
  yoffset -= int16(2*twfive);
  zoffset += int16(twfive);

  if (fives)
  {
	 PPayOffChips[0][1]->CAD.SetY(yoffset);
	 PPayOffChips[0][1]->CAD.SetZ(zoffset);

	 PPayOffChips[0][1]->CAD.SetCurrentFrame(int16(fives - 1));
	 PPayOffChips[0][1]->Show();
  }
  else {PPayOffChips[0][1]->NoShow();}
  yoffset -= int16(2*fives);
  zoffset += int16(fives);

  if (ones)
  {
	 PPayOffChips[0][0]->CAD.SetY(yoffset);
	 PPayOffChips[0][0]->CAD.SetZ(zoffset);

	 PPayOffChips[0][0]->CAD.SetCurrentFrame(int16(ones - 1));
	 PPayOffChips[0][0]->Show();
  }
  else {PPayOffChips[0][0]->NoShow();}

  for(int16 i=1;i<stacks && i<25;i++)
  {
	 if (ones)
	 {
		PPayOffChips[i][0]->CAD.SetY(PPayOffChips[0][0]->CAD.GetY());
		PPayOffChips[i][0]->CAD.SetZ(PPayOffChips[0][0]->CAD.GetZ());
		PPayOffChips[i][0]->CAD.SetCurrentFrame(int16(ones - 1));
		PPayOffChips[i][0]->Show();
	 }
	 else {PPayOffChips[i][0]->NoShow();}

	 if (fives)
	 {
		PPayOffChips[i][1]->CAD.SetY(PPayOffChips[0][1]->CAD.GetY());
		PPayOffChips[i][1]->CAD.SetZ(PPayOffChips[0][1]->CAD.GetZ());

		PPayOffChips[i][1]->CAD.SetCurrentFrame(int16(fives - 1));
		PPayOffChips[i][1]->Show();
	 }
	 else {PPayOffChips[i][1]->NoShow();}

	 if (twfive)
	 {
		PPayOffChips[i][2]->CAD.SetY(PPayOffChips[0][2]->CAD.GetY());
		PPayOffChips[i][2]->CAD.SetZ(PPayOffChips[0][2]->CAD.GetZ());

		PPayOffChips[i][2]->CAD.SetCurrentFrame(int16(twfive - 1));
		PPayOffChips[i][2]->Show();
	 }
	 else {PPayOffChips[i][2]->NoShow();}

	 if (huns)
	 {
		PPayOffChips[i][3]->CAD.SetY(PPayOffChips[0][3]->CAD.GetY());
		PPayOffChips[i][3]->CAD.SetZ(PPayOffChips[0][3]->CAD.GetZ());

		PPayOffChips[i][3]->CAD.SetCurrentFrame(int16(huns - 1));
		PPayOffChips[i][3]->Show();
	 }
	 else {PPayOffChips[i][3]->NoShow();}

	 if (thous)
	 {
		PPayOffChips[i][4]->CAD.SetY(PPayOffChips[0][4]->CAD.GetY());
		PPayOffChips[i][4]->CAD.SetZ(PPayOffChips[0][4]->CAD.GetZ());

		PPayOffChips[i][4]->CAD.SetCurrentFrame(int16(thous - 1));
		PPayOffChips[i][4]->Show();
	 }
	 else {PPayOffChips[i][4]->NoShow();}

	 if (tenthous)
	 {
		PPayOffChips[i][5]->CAD.SetY(PPayOffChips[0][1]->CAD.GetY());
		PPayOffChips[i][5]->CAD.SetZ(PPayOffChips[0][1]->CAD.GetZ());

		PPayOffChips[i][5]->CAD.SetCurrentFrame(int16(tenthous - 1));
		PPayOffChips[i][5]->Show();
	 }
	 else {PPayOffChips[i][5]->NoShow();}
  }
  if(stacks > 25)
  {
	 for(int16 i=25;i<stacks;i++)
	 {
      if (ones)
	 {
		PPayOffChips[i][0]->CAD.SetY(int16(PPayOffChips[0][0]->CAD.GetY()+10));
		PPayOffChips[i][0]->CAD.SetZ(int16(PPayOffChips[0][0]->CAD.GetZ()+10));
		PPayOffChips[i][0]->CAD.SetCurrentFrame(int16(ones - 1));
		PPayOffChips[i][0]->Show();
	 }
	 else {PPayOffChips[i][0]->NoShow();}

	 if (fives)
	 {
		PPayOffChips[i][1]->CAD.SetY(int16(PPayOffChips[0][1]->CAD.GetY()+10));
		PPayOffChips[i][1]->CAD.SetZ(int16(PPayOffChips[0][1]->CAD.GetZ()+10));

		PPayOffChips[i][1]->CAD.SetCurrentFrame(int16(fives - 1));
		PPayOffChips[i][1]->Show();
	 }
	 else {PPayOffChips[i][1]->NoShow();}

	 if (twfive)
	 {
		PPayOffChips[i][2]->CAD.SetY(int16(PPayOffChips[0][2]->CAD.GetY()+10));
		PPayOffChips[i][2]->CAD.SetZ(int16(PPayOffChips[0][2]->CAD.GetZ()+10));

		PPayOffChips[i][2]->CAD.SetCurrentFrame(int16(twfive - 1));
		PPayOffChips[i][2]->Show();
	 }
	 else {PPayOffChips[i][2]->NoShow();}

	 if (huns)
	 {
		PPayOffChips[i][3]->CAD.SetY(int16(PPayOffChips[0][3]->CAD.GetY()+10));
		PPayOffChips[i][3]->CAD.SetZ(int16(PPayOffChips[0][3]->CAD.GetZ()+10));

		PPayOffChips[i][3]->CAD.SetCurrentFrame(int16(huns - 1));
		PPayOffChips[i][3]->Show();
	 }
	 else {PPayOffChips[i][3]->NoShow();}

	 if (thous)
	 {
		PPayOffChips[i][4]->CAD.SetY(int16(PPayOffChips[0][4]->CAD.GetY()+10));
		PPayOffChips[i][4]->CAD.SetZ(int16(PPayOffChips[0][4]->CAD.GetZ()+10));

		PPayOffChips[i][4]->CAD.SetCurrentFrame(int16(thous - 1));
		PPayOffChips[i][4]->Show();
	 }
	 else {PPayOffChips[i][4]->NoShow();}

	 if (tenthous)
	 {
		PPayOffChips[i][5]->CAD.SetY(int16(PPayOffChips[0][1]->CAD.GetY()+10));
		PPayOffChips[i][5]->CAD.SetZ(int16(PPayOffChips[0][1]->CAD.GetZ()+10));

		PPayOffChips[i][5]->CAD.SetCurrentFrame(int16(tenthous - 1));
		PPayOffChips[i][5]->Show();
	 }
	 else {PPayOffChips[i][5]->NoShow();}
	 }
  }
  Update(GetAdjFUC());
}
//*******************************************************************