//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  crrmst.cpp
//    Project Name:  Casino
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     3/9/96   A. Krist    Original baseline
//  2.0    09/19/97  M.Perry     32-bit conversion.
//*******************************************************************
#include "crrmst.h"
#include "crglord.h"
#include "casrmw.h"
#include "orespond.h"
//*******************************************************************
TRRemoveState::TRRemoveState(TCasinoRGameLord *pNewRLord)
:TRLordState(pNewRLord)
{
  BetSpotResponder           = NULL;
  Button1Responder            = NULL;
  QuickKick                   = false;
}
//*******************************************************************
TRRemoveState::~TRRemoveState()
{
  pOwnerLord->Button1->ShowVoidUp();
  pOwnerLord->Button2->ShowVoidUp();
  if(pOwnerLord->BetMade())
  {
  pOwnerLord->Button4->ShowVoidUp();
  }
  pOwnerLord->ButtonChip1->ShowVoidUp();
  pOwnerLord->ButtonChip5->ShowVoidUp();
  pOwnerLord->ButtonChip25->ShowVoidUp();
  pOwnerLord->ButtonChip100->ShowVoidUp();
  pOwnerLord->ButtonChip1000->ShowVoidUp();
  pOwnerLord->ButtonChip10000->ShowVoidUp();
  pOwnerLord->MessageDisplay->ShowMessage(0);
  pOwnerLord->messagestate = 0;
}
//*******************************************************************
void TRRemoveState::ExecuteFirstTime()
{
  ExecuteWaiting = true;
  pOwnerLord->messagestate = 1;
  pOwnerLord->MessageDisplay->ShowMessage(1);
  ExecuteStatus    = ess_Execute;
  pOwnerLord->Button1->ShowLite();
  pOwnerLord->Button2->ShowGray();
  pOwnerLord->Button4->ShowGray();
  pOwnerLord->ButtonChip1->ShowGray();
  pOwnerLord->ButtonChip5->ShowGray();
  pOwnerLord->ButtonChip25->ShowGray();
  pOwnerLord->ButtonChip100->ShowGray();
  pOwnerLord->ButtonChip1000->ShowGray();
  pOwnerLord->ButtonChip10000->ShowGray();

}
//*******************************************************************
void TRRemoveState::HandlePostUpdate(dword NewFUC)
{
  if(pOwnerLord->ButtonHit[ridButton3])
  {
	 pOwnerLord->ButtonClear(ridButton3);
	 LockHit = false;

	 return;
  }
  if(pOwnerLord->ButtonHit[ridAskExpert])
  {
	 pOwnerLord->ButtonClear(ridAskExpert);
	 pOwnerLord->AskBetExpert();
	 return;
  }
  if(pOwnerLord->ButtonHit[ridStatBar])
  {
	 pOwnerLord->ButtonClear(ridStatBar);
	 return;
  }
  if(pOwnerLord->ButtonHit[ridMenuEsc])
  {
	 LockHit = false;
	 pOwnerLord->ButtonClear(ridMenuEsc);
	 return;
  }
  if (BetSpotResponder != NULL)
  {
	 if (BetSpotResponder->GetResponseEvent() != reChar)
	 {
		BetSpotResponder->ClearPriority();
	 }
	 if(!pOwnerLord->BetMade(pOwnerLord->activeplayer))
	 {
		QuickKick = true;;
	 }
	 BetSpotResponder = NULL;
	 return;
  }
  if(pOwnerLord->ButtonHit[ridButton1])
  {
	 pOwnerLord->ButtonClear(ridButton1);
	 pOwnerLord->Button2->NoShow();
	 if(pOwnerLord->BetMade())
	 {
		pOwnerLord->Button4->NoShow();
	 }
	 ExecuteWaiting = false;
	 ExecuteStatus  = ess_Done;
	// pOwnerLord->CasStatusBar->NoShowStatusBar();
	 return;
  }
  if(QuickKick)
  {
	 QuickKick = false;
	 pOwnerLord->Button1->ShowVoidUp();
	 pOwnerLord->Button2->ShowVoidUp();
	 pOwnerLord->Button3->ShowVoidUp();
	 ExecuteWaiting = false;
	 ExecuteStatus  = ess_Done;
	 //pOwnerLord->CasStatusBar->NoShowStatusBar();
  }
  if(NewFUC){return;}
}
//*******************************************************************
bool TRRemoveState::HandleBetSpot(TResponder &responder,int16 spot)
{
  if (responder.GetResponseEvent() == reLUp)
  {
	 if(pOwnerLord->BetSpot[spot]->HasBSBet(pOwnerLord->activeplayer))
	 {
		pOwnerLord->RemoveBet(spot);

		BetSpotResponder = &responder;
	 }
	 else
	 {
		responder.ClearPriority();
	 }
  }

  if (responder.GetResponseEvent() == reLDown)
  {
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
	 if(pOwnerLord->BetSpot[spot]->HasBSBet(pOwnerLord->activeplayer))
	 {
		pOwnerLord->RemoveBet(spot);
		BetSpotResponder = &responder;
	 }
	 BetSpotResponder = &responder;
  }
  return true;
}
//*******************************************************************
bool TRRemoveState::HandleButton1(TResponder &responder)
{
  if (responder.GetResponseEvent() == reLUp)
  {
	 Button1Responder = &responder;
  }

  if (responder.GetResponseEvent() == reLDown)
  {
	 pOwnerLord->Button1->ShowDown();
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
	 pOwnerLord->Button1->ShowDown();
	 Button1Responder = &responder;
  }
  return true;
}
//*******************************************************************