//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  slgfw2.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.2     4/17/97    M.Perry     modified app & fw hierarchy.
//********************************************************************
#include "slgfw.h"
#include "cgametyp.h"

//#include "csalmw.h"
#include "slal1p.h"
//#include "csalhmw.h"
#include "slal100.h"
//#include "cs1mw.h"
#include "slcs1.h"
//#include "cs2mw.h"
#include "slcs2.h"
//#include "cs5mw.h"
#include "slcs5.h"
//#include "jj1mw.h"
#include "sljj1.h"
//#include "jj2mw.h"
#include "sljj2.h"
//#include "wj5mw.h"
#include "sljw5.h"
//#include "wj25mw.h"
#include "sljw25.h"
//#include "s76tmw.h"
#include "sls1000.h"

#include "slmw.h"

#include "slintmw.h"
#include "casnames.rh"
//*******************************************************************
void TSLGameFrameWindow::SetupModeStrings()
{
  strIntro            = string("s2intro");
  strLobby            = TAppString(IDS_M_LOBBY_SLOTLITE);
  strSlotsAladdin100  = TAppString(IDS_M_SL_ALADDIN100);
  strSlotsAladdin1P   = TAppString(IDS_M_SL_ALADDIN1P);
  strSlotsJungle1     = TAppString(IDS_M_SL_JUNGLE1);
  strSlotsJungle2     = TAppString(IDS_M_SL_JUNGLE2);
  strSlotsSpirit1000  = TAppString(IDS_M_SL_SPIRIT1000);
  strSlotsJokers5     = TAppString(IDS_M_SL_JOKER5);
  strSlotsJokers25    = TAppString(IDS_M_SL_JOKER25);
  strSlotsCherry1     = TAppString(IDS_M_SL_CHERRY1);
  strSlotsCherry2     = TAppString(IDS_M_SL_CHERRY2);
  strSlotsCherry5     = TAppString(IDS_M_SL_CHERRY5);
}
//*******************************************************************
TWindow *TSLGameFrameWindow::CreateModeWindow(int ModeIndex)
{
  GetSLMenuEnable()->SetModes(TRUE);

  if (!IsValidModeIndex(ModeIndex)) {return PModeWin;}

  string modename = GetModeName(ModeIndex);

  if (modename == strIntro)//"s2intro")
  {
    PModeWin = new TSLIntroModeWin(modename,GetOgleApp()->PMasterPalette,"Slots Champion Intro");
    GetSLMenuEnable()->CurrentMode = -1;
    return PModeWin;
  }
                                 
  if (modename == strLobby)//TAppString(IDS_M_LOBBY_SLOTLITE))
  {
	 PModeWin = new TSLobby1ModeWin(modename,GetOgleApp()->PMasterPalette,"Slots Champion Lobby");
	 GetSLMenuEnable()->CurrentMode = IDS_M_LOBBY_SLOTLITE;
	 GetSLMenuEnable()->Lobby = FALSE;
	 return PModeWin;
  }
  if (modename == strSlotsAladdin1P)//TAppString(IDS_M_SL_ALADDIN1P))
  {
//	 PModeWin = new TAladinModeWin(modename,GetOgleApp()->PMasterPalette);
    PModeWin = new TSLAL1PModeWin(modename,GetOgleApp()->PMasterPalette);
	 GetSLMenuEnable()->CurrentMode = IDS_M_SL_ALADDIN1P;
	 GetSLMenuEnable()->SlotsAladdin1P = FALSE;
	 return PModeWin;
  }
  if (modename == strSlotsAladdin100)//TAppString(IDS_M_SL_ALADDIN100))
  {
//	 PModeWin = new TAladin100ModeWin(modename,GetOgleApp()->PMasterPalette);
    PModeWin = new TSLAL100ModeWin(modename,GetOgleApp()->PMasterPalette);
	 GetSLMenuEnable()->CurrentMode = IDS_M_SL_ALADDIN100;
	 GetSLMenuEnable()->SlotsAladdin100 = FALSE;
	 return PModeWin;
  }
  if (modename == strSlotsSpirit1000)//TAppString(IDS_M_SL_SPIRIT1000))
  {
//	 PModeWin = new TSpirit76ModeWin(modename,GetOgleApp()->PMasterPalette);
    PModeWin = new TSLS1000ModeWin(modename,GetOgleApp()->PMasterPalette);
	 GetSLMenuEnable()->CurrentMode = IDS_M_SL_SPIRIT1000;
	 GetSLMenuEnable()->SlotsSpirit1000 = FALSE;
	 return PModeWin;
  }
  if (modename == strSlotsJokers5)//TAppString(IDS_M_SL_JOKER5))
  {
//	 PModeWin = new TWildJoke5ModeWin(modename,GetOgleApp()->PMasterPalette);
    PModeWin = new TSLJW5ModeWin(modename,GetOgleApp()->PMasterPalette);
	 GetSLMenuEnable()->CurrentMode = IDS_M_SL_JOKER5;
	 GetSLMenuEnable()->SlotsJokers5 = FALSE;
	 return PModeWin;
  }
  if (modename == strSlotsJokers25)//TAppString(IDS_M_SL_JOKER25))
  {
//	 PModeWin = new TWildJoke25ModeWin(modename,GetOgleApp()->PMasterPalette);
    PModeWin = new TSLJW25ModeWin(modename,GetOgleApp()->PMasterPalette);
	 GetSLMenuEnable()->CurrentMode = IDS_M_SL_JOKER25;
	 GetSLMenuEnable()->SlotsJokers25 = FALSE;
	 return PModeWin;
  }
  if (modename == strSlotsCherry1)//TAppString(IDS_M_SL_CHERRY1))
  {
//	 PModeWin = new TCherry1ModeWin(modename,GetOgleApp()->PMasterPalette);
    PModeWin = new TSLCS1ModeWin(modename,GetOgleApp()->PMasterPalette);
	 GetSLMenuEnable()->CurrentMode = IDS_M_SL_CHERRY1;
	 GetSLMenuEnable()->SlotsCherry1 = FALSE;
	 return PModeWin;
  }
  if (modename == strSlotsCherry2)//TAppString(IDS_M_SL_CHERRY2))
  {
//	 PModeWin = new TCherry2ModeWin(modename,GetOgleApp()->PMasterPalette);
    PModeWin = new TSLCS2ModeWin(modename,GetOgleApp()->PMasterPalette);
	 GetSLMenuEnable()->CurrentMode = IDS_M_SL_CHERRY2;
	 GetSLMenuEnable()->SlotsCherry2 = FALSE;
	 return PModeWin;
  }
  if (modename == strSlotsCherry5)//TAppString(IDS_M_SL_CHERRY5))
  {
//	 PModeWin = new TCherry5ModeWin(modename,GetOgleApp()->PMasterPalette);
    PModeWin = new TSLCS5ModeWin(modename,GetOgleApp()->PMasterPalette);
	 GetSLMenuEnable()->CurrentMode = IDS_M_SL_CHERRY5;
	 GetSLMenuEnable()->SlotsCherry5 = FALSE;
	 return PModeWin;
  }
  if (modename == strSlotsJungle1)//TAppString(IDS_M_SL_JUNGLE1))
  {
//	 PModeWin = new TJungle1ModeWin(modename,GetOgleApp()->PMasterPalette);
    PModeWin = new TSLJJ1ModeWin(modename,GetOgleApp()->PMasterPalette);
	 GetSLMenuEnable()->CurrentMode = IDS_M_SL_JUNGLE1;
	 GetSLMenuEnable()->SlotsJungle1 = FALSE;
	 return PModeWin;
  }
  if (modename == strSlotsJungle2)//TAppString(IDS_M_SL_JUNGLE2))
  {
//	 PModeWin = new TJungle2ModeWin(modename,GetOgleApp()->PMasterPalette);
    PModeWin = new TSLJJ2ModeWin(modename,GetOgleApp()->PMasterPalette);
	 GetSLMenuEnable()->CurrentMode = IDS_M_SL_JUNGLE2;
	 GetSLMenuEnable()->SlotsJungle2 = FALSE;
	 return PModeWin;
  }
  ::MessageBox(NULL,"Default Mode Window Created","Create Mode Window",MB_OK);
  PModeWin = new TCasinoModeWin(modename,GetOgleApp()->PMasterPalette,string("Default Casino ModeWin"));
  return PModeWin;
}
//*******************************************************************

