//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  slgld.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     10/11/95   M.Perry    Original baseline
//*******************************************************************
#include "slgld.h"
#include "slspl.h"
//#include "oskitcat.h"
#include "ogamefw.h"
#include "orespond.h"
//*******************************************************************
TSpriteList *TSLobby1GameLord::CreateSpriteList(TFileMode splfm)
{
  return (new TSLobby1SpriteList(PModeWin,splfm,this));
}
//*******************************************************************
void TSLobby1GameLord::SetupSprites()
{
  MenuEscButton = NULL;
  MenuEscButton = (TCasButton *) GetSpritePtr(GetResString(IDS_MS_B0_SL));
  if (MenuEscButton == NULL) {SpriteError("Menu Esc Button",GetResString(IDS_MS_B0_SL));}
  if (GetFW()->GetHandleShowMenu())
  {
	 ActivateSpriteNow(MenuEscButton);
  }
  else
  {
	 MenuEscButton->Freeze = TRUE;
	 MenuEscButton->PButtonResponder->Remove();
  }
  Car = 0;
  Tree = 0;
  Car = GetSpriteIndex(GetResString(IDS_AS_CAR_SL));
  Tree = GetSpriteIndex(GetResString(IDS_AS_TREE_SL));

  MessageDisplay = NULL;
  MessageDisplay = (TCasSLLobbyMessageDisplay *) GetSpritePtr(GetResString(IDS_MS_MESS_SL));
  if (MessageDisplay == NULL) {SpriteError("MessageDisplay",GetResString(IDS_MS_MESS_SL));}
  MessageDisplay->Start(GetFUC());
}
//*******************************************************************
void TSLobby1GameLord::CleanupSprites()
{
}
//*******************************************************************
TSLobby1GameLord::TSLobby1GameLord(TSLobby1ModeWin *pmwin,const TFileMode &fm)
:TCasinoSLGameLord(pmwin,fm)
{
  TFileMode splfm(SpriteListName,fm_None,fm_Immed,FileMode.DirIndex);
  CreateAddSpriteList(splfm);

  SetupSprites();
}
//*******************************************************************
TSLobby1GameLord::~TSLobby1GameLord()
{
  CleanupSprites();
}
//*******************************************************************
void TSLobby1GameLord::TurnOnNext()
{
  switch (GetTurnOffState())
  {
    case 1:SetSongIdle();
           SetTurnOffState(0);
           break;
    case 2:SetSound1Idle();
           SetTurnOffState(1);
           break;
    case 3:SetSound2Idle();
           SetTurnOffState(2);
           break;
    case 4:SetSound3Idle();
           SetTurnOffState(3);
           break;
    case 5:SetSound4Idle();
           SetTurnOffState(4);
           break;
    case 6:SetSound5Idle();
           SetTurnOffState(5);
           break;
    case 7:SetSound6Idle();
           SetTurnOffState(6);
           break;
    case 8:SetSound7Idle();
           SetTurnOffState(7);
           break;
    case 9:SetSound8Idle();
           SetTurnOffState(8);
           break;
  }
}
//*******************************************************************
void TSLobby1GameLord::TurnOffNext()
{
  switch (GetTurnOffState())
  {
    case 0:SetSongIdle(-1);
           SetTurnOffState(1);
           break;
    case 1:SetSound1Idle(-1);
           SetTurnOffState(2);
           break;
    case 2:SetSound2Idle(-1);
           SetTurnOffState(3);
           break;
    case 3:SetSound3Idle(-1);
           SetTurnOffState(4);
           break;
    case 4:SetSound4Idle(-1);
           SetTurnOffState(5);
           break;
    case 5:SetSound5Idle(-1);
           SetTurnOffState(6);
           break;
    case 6:SetSound6Idle(-1);
           SetTurnOffState(7);
           break;
    case 7:SetSound7Idle(-1);
           SetTurnOffState(8);
           break;
    case 8:SetSound8Idle(-1);
           SetTurnOffState(9);
           break;
  }
}
//*******************************************************************