//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  cscrsp.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     9/26/95    M.Perry     original baseline
//  2.0    09/25/97    M.Perry     32-bit conversion.
//********************************************************************
#include "cscrsp.h"
#include "oanm.h"
//*******************************************************************
TSCredits::TSCredits(TOgleModeWindow *pmw,const TFileMode &NewFileMode)
:TSprite(pmw,NewFileMode)
{
  SetToManual();
  SetupAnms();
}
//*******************************************************************
TSCredits::TSCredits(TOgleModeWindow *pmw,const TFileMode &NewFileMode,void *psource)
:TSprite(pmw,NewFileMode,psource)
{
  SetToManual();
  SetupAnms();
}
//*******************************************************************
TSCredits::~TSCredits()
{
}
//*******************************************************************
void TSCredits::SetupAnms()
{
	 PCredits[0] = GetAnm(0);
	 PCredits[1] = GetAnm(1);
	 PCredits[2] = GetAnm(2);
	 PCredits[3] = GetAnm(3);
	 PCredits[4] = GetAnm(4);

	 for (int16 j=0;j<5;j++)
	 {
		if (PCredits[j] == NULL) {AnmError("Credits","Nums",j);}
	 }

	 for (int16 i=0;i<5;i++)
	 {
		PCredits[i]->CAD.ClearAutoStart();
		PCredits[i]->CAD.ClearAutoStop();
		PCredits[i]->CAD.SetDirStill();
	 }
}
  //*****************************************************************
void TSCredits::SetNum(int16 num)
{
	 if (PCredits[0] == NULL) {return;}
	 if (PCredits[1] == NULL) {return;}
	 if (PCredits[2] == NULL) {return;}
	 if (PCredits[3] == NULL) {return;}
	 if (PCredits[4] == NULL) {return;}

	 ones    =  int16(num % 10);
	 tens    =  int16((num / 10  )  % 10);
	 huns    =  int16((num / 100 )  % 10);
	 thou    =  int16((num / 1000)  % 10);
	 tenthou =  int16((num / 10000) % 10);
	 PCredits[0]->CAD.SetCurrentFrame(ones);
	 PCredits[1]->CAD.SetCurrentFrame(tens);
	 PCredits[2]->CAD.SetCurrentFrame(huns);
	 PCredits[3]->CAD.SetCurrentFrame(thou);
	 PCredits[4]->CAD.SetCurrentFrame(tenthou);
    for (int j=0;j<5;j++)
	 {
		PCredits[j]->Show();
	 }
    Update(GetAdjFUC());
}
//*******************************************************************