//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  csdata.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//                                     
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     9/9/96     M.Perry     split up cplaydat file
//  2.0    08/31/97    M.Perry     32-bit conversion.
//********************************************************************
#include "csdata.h"
//*******************************************************************
TCSSession::TCSSession()
{
  ClearData();
}
//*******************************************************************
void TCSSession::ClearData()
{
  TCasinoSession::ClearData();
  nLowPayoffs  = 0;
  nHiPayoffs = 0;
}
//*******************************************************************
void TCSSession::StartSession(TMoney startingcash,int16 subgametype,TMoney denom)
{
	ClearData();
	TCasinoSession::StartSession(startingcash,subgametype,denom);
}
//*******************************************************************
void TCSSession::EndSession(TMoney endingcash)
{
  TCasinoSession::EndSession(endingcash);
}
//*******************************************************************
TCasinoSData::TCasinoSData()
{
  ClearData();
}
//*******************************************************************
void TCasinoSData::ClearData()
{
  TCasinoData::ClearData();
  Cumulative = 0.0;
  for (int16 i=0;i<NUMSESSIONS;i++)
  {
	 Sessions[i].ClearData();
  }
}
//*******************************************************************
void TCasinoSData::StartSession(TMoney startingcash,int16 subgametype,TMoney denom)
{
  IncCurrentSession();
  Sessions[CurrentSession].StartSession(startingcash,subgametype,denom);
}
//*******************************************************************
void TCasinoSData::EndSession(TMoney endingcash)
{
  Sessions[CurrentSession].EndSession(endingcash);
}
//*******************************************************************
void TCasinoSData::IncCurrentSession()
{
  if (CurrentSession == 0 && !Sessions[0].Valid)
  {
	 CurrentSession = 0;
	 return;
  }
  CurrentSession++;
  if (CurrentSession >= NUMSESSIONS) {CurrentSession = 0;}
}
//*******************************************************************
int16 TCasinoSData::GetFirstValidSession()
{
  // Sanity check on CurrentSession.
  if ((CurrentSession < 0) || (CurrentSession >= NUMSESSIONS)) {SessionIterator = -1;}
  else {SessionIterator = CurrentSession;}

  if (SessionIterator == -1) {return SessionIterator;}

  // Validity check on current session.
  if (!Sessions[SessionIterator].Valid)
  {
	 SessionIterator = -1;
	 return SessionIterator;
  }
  // currents session is valid, so start looping from current session to find oldest session.
  for (SessionIterator++;SessionIterator<NUMSESSIONS;SessionIterator++)
  {
	 if (Sessions[SessionIterator].Valid) {return SessionIterator;}
  }
  if (CurrentSession == 0) // we already checked all sessions and didn't find a valid one.
  {
	 if (Sessions[0].Valid) {SessionIterator = 0;}
	 else {SessionIterator = -1;}
	 return SessionIterator;
  }

  for (SessionIterator = 0;SessionIterator < CurrentSession;SessionIterator++)
  {
	 if (Sessions[SessionIterator].Valid) {return SessionIterator;}
  }
  SessionIterator = -1;
  return SessionIterator;
}
//*******************************************************************
int16 TCasinoSData::GetPrevValidSession()
{
  int16 prevsession = CurrentSession;
  prevsession -= int16(1);
  if (prevsession <= 0) {prevsession = NUMSESSIONS - 1;}
  if (!Sessions[prevsession].Valid) {return -1;}
  return prevsession;
}
//*******************************************************************
int16 TCasinoSData::GetNextValidSession()
{
  // check if already found last valid session.
  if (SessionIterator == -1) {return SessionIterator;}
  // go to next session.
  SessionIterator++;
  // check for wraparound.
  if (SessionIterator >= NUMSESSIONS) {SessionIterator = 0;}
  // check if we went all the way around to beginning.
  if (SessionIterator == CurrentSession)
  {
	 SessionIterator = -1;
	 return CurrentSession;
  }
  // validity check on session.
  if (!Sessions[SessionIterator].Valid)
  {
	 SessionIterator = -1;
	 return SessionIterator;
  }
  return SessionIterator;
}
//*******************************************************************

