//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  cvpglord.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     10/11/95   M.Perry    Original baseline
//  2.0     09/25/97   M.Perry    32-bit conversion.
//  2.3    07/14/99    M.Perry    gobjlist removal
//*******************************************************************
#include "csglord.h"
#include "slordst.h"
#include "slrdmst.h"
#include "ostate.h"
#include <time.h>   //To Set Random Number Generator
//#define  NUMBEROFPLAYERS 3
//#define  BET1  3
#include <stdlib.h> //For Random Number Generator
#include "cassmw.h"
#include "cscpsp.h"
#include "oskitcat.h"
#include "csplay.h"
#include "expert.h"
#include "cplaymgr.h"
#include "casapp.h"

#if defined(DEBUGSLOT)
  #include "owl\inputdia.h"
#endif

#include "orespond.h"
#include "oanm.h"
#include "cas_cm.rh"
//*******************************************************************
string GetResString(int16 id)
{
  return TAppString(id);
}
//*******************************************************************
#if defined(SUPPORT_OLD_VER)
void TCasinoSGameLord::SetUIDSStrings()
{
  // use resource string ids's to get actual string from app resources.
  strButton0 = GetResString(idsButton0);
  strButton1 = GetResString(idsButton1);
  strButton2 = GetResString(idsButton2);
  strButton3 = GetResString(idsButton3);
  strButton4 = GetResString(idsButton4);
  strButton5 = GetResString(idsButton5);
  strButton6 = GetResString(idsButton6);
  strButton7 = GetResString(idsButton7);
  strBankCashDisplay = GetResString(idsBankCashDisplay);
  strChips = GetResString(idsChips);
  strCoinsPlayed = GetResString(idsCoinsPlayed);
  strCoinPay = GetResString(idsCoinPay);
  strCredits = GetResString(idsCredits);
  strNP1 = GetResString(idsNP1);
  strNP2 = GetResString(idsNP2);
  strNP3 = GetResString(idsNP3);
  strReel = GetResString(idsReel);
  strSound = GetResString(idsSound);
  strWinPaid = GetResString(idsWinPaid);
  strSong = GetResString(idsSong);
  if (idsProgressive > 0)
  {
    strProgressive = GetResString(idsProgressive);
  }
}
#endif
//*******************************************************************
#if defined(SUPPORT_OLD_VER)
int16 TCasinoSGameLord::GetUniqueID(const string &s)
{
  if (s == strButton0) {return 1;}
  if (s == strButton1) {return 2;}
  if (s == strButton2) {return 3;}
  if (s == strButton3) {return 4;}
  if (s == strButton4) {return 5;}
  if (s == strButton5) {return 7;}
  if (s == strButton6) {return 8;}
  if (s == strButton7) {return 9;}
  if (s == strBankCashDisplay) {return 6;}
  if (s == strChips) {return 10;}
  if (s == strCoinPay) {return 11;}
  if (s == strCoinsPlayed) {return 12;}
  if (s == strCredits) {return 13;}
  if (s == strNP1) {return 14;}
  if (s == strNP2) {return 15;}
  if (s == strNP3) {return 16;}
  if (s == strReel) {return 17;}
  if (s == strSound) {return 18;}
  if (s == strWinPaid) {return 20;}
  if (s == strProgressive) {return 21;}
  return 0;
}
#endif
//*******************************************************************
TSprite *TCasinoSGameLord::CreateSprite(string spritename,int16 id,void *psource)
{
  TFileMode FM(spritename,
               TFileMode::fm_None,
               TFileMode::fm_None,
               FileMode.GetDirIndex());
  if (psource != NULL)
  {
    switch (id)
	 {
		case  0 : return new TSprite(PModeWin,FM,psource);
      case  1 : Button0 = new TCasButton(PModeWin,FM,psource,this,100,TRect(1,430,50,479),idButton0,true,'x');
               return Button0;
      case  2 : Button1 = new TCasButton(PModeWin,FM,psource,this,100,TRect(170,430,219,479),idButton1,true);
               return Button1;
      case  3 : Button2 = new TCasButton(PModeWin,FM,psource,this,100,TRect(223,464,258,479),idButton2,true);
               return Button2;
      case  4 : Button3 = new TCasButton(PModeWin,FM,psource,this,100,TRect(376,464,412,479),idButton3,true);
               return Button3;
      case  5 : Button4 = new TCasButton(PModeWin,FM,psource,this,125,TRect(416,430,468,479),idButton4,true,'c');
               return Button4;
      case  6 : BankCashDisplay = new TCasCashDisplay(PModeWin,FM,psource);
               return BankCashDisplay;
      case  7 : Button5 = new TCasButton(PModeWin,FM,psource,this,125,TRect(470,430,522,479),idButton5,true,'b');
               return Button5;
      case  8 : Button6 = new TCasButton(PModeWin,FM,psource,this,125,TRect(533,430,585,479),idButton6,true,'m');
               return Button6;
      case  9 : Button7 = new TCasButton(PModeWin,FM,psource,this,125,TRect(587,432,639,478),idButton7,true,'d');
               return Button7;
      case 10 : Chips = new TCasChips(PModeWin,FM,psource);
               return Chips;
      case 11 : CoinPay = new TSCoinPay(PModeWin,FM,psource);
               return CoinPay;
      case 12 : CoinsPlayed = new TSCoinsPlayed(PModeWin,FM,psource);
               return CoinsPlayed;
      case 13 : Credits = new TSCredits(PModeWin,FM,psource);
               return Credits;
      case 14 : NamePlate1 = new TCasNamePlate(PModeWin,FM,psource);
               return NamePlate1;
      case 15 : NamePlate2 = new TCasNamePlate(PModeWin,FM,psource);
               return NamePlate2;
      case 16 : NamePlate3 = new TCasNamePlate(PModeWin,FM,psource);
               return NamePlate3;
      case 17 : Reel = new TSReel(PModeWin,FM,psource);
               return Reel;
      case 18 : Sounds = new TSSound(PModeWin,FM,psource);
               return Sounds;
      case 20 : WinPaid = new TSWinPaid(PModeWin,FM,psource);
               return WinPaid;
      case 21 : Progressive = new TSProgressive(PModeWin,FM,psource);
               return Progressive;
      default : return new TSprite(PModeWin,FM,psource);
	 }
  }
  else
  {
	 FM.SetRamImmed();
	 switch (id)
	 {
		case  0 : return new TSprite(PModeWin,FM);
      case  1 : Button0 = (new TCasButton(PModeWin,FM,this,100,TRect(1,430,50,479),idButton0,true,'x'));
               return Button0;
      case  2 : Button1 = (new TCasButton(PModeWin,FM,this,100,TRect(170,430,219,479),idButton1,true));
               return Button1;
      case  3 : Button2 = (new TCasButton(PModeWin,FM,this,100,TRect(223,464,258,479),idButton2,true));
               return Button2;
      case  4 : Button3 = (new TCasButton(PModeWin,FM,this,100,TRect(376,464,412,479),idButton3,true));
               return Button3;
      case  5 : Button4 = (new TCasButton(PModeWin,FM,this,125,TRect(416,430,468,479),idButton4,true,'c'));
               return Button4;
      case  6 : BankCashDisplay = (new TCasCashDisplay(PModeWin,FM));
               return BankCashDisplay;
      case  7 : Button5 = (new TCasButton(PModeWin,FM,this,125,TRect(470,430,522,479),idButton5,true,'b'));
               return Button5;
      case  8 : Button6 = (new TCasButton(PModeWin,FM,this,125,TRect(533,430,585,479),idButton6,true,'m'));
               return Button6;
      case  9 : Button7 = (new TCasButton(PModeWin,FM,this,125,TRect(587,432,639,478),idButton7,true,'d'));
               return Button7;
      case 10 : Chips = (new TCasChips(PModeWin,FM));
               return Chips;
      case 11 : CoinPay = (new TSCoinPay(PModeWin,FM));
               return CoinPay;
      case 12 : CoinsPlayed = (new TSCoinsPlayed(PModeWin,FM));
               return CoinsPlayed;
      case 13 : Credits = (new TSCredits(PModeWin,FM));
               return Credits;
      case 14 : NamePlate1 = (new TCasNamePlate(PModeWin,FM));
               return NamePlate1;
      case 15 : NamePlate2 = (new TCasNamePlate(PModeWin,FM));
               return NamePlate2;
      case 16 : NamePlate3 = (new TCasNamePlate(PModeWin,FM));
               return NamePlate3;
      case 17 : Reel = (new TSReel(PModeWin,FM));
               return Reel;
      case 18 : Sounds = (new TSSound(PModeWin,FM));
               return Sounds;
      case 20 : WinPaid = (new TSWinPaid(PModeWin,FM));
               return WinPaid;
      case 21 : Progressive = (new TSProgressive(PModeWin,FM));
               return Progressive;
      default : return new TSprite(PModeWin,FM);
	 }
  }
}
//*******************************************************************
void TCasinoSGameLord::SetupSprites()
{
  Song = GetSpriteIndex(strSong);

  if (Sounds == NULL)          {SpriteError("Slots Sounds",strSound);}
  if (CoinsPlayed == NULL)     {SpriteError("Coins Played Nums",strCoinsPlayed);}
  if (WinPaid == NULL)         {SpriteError("Win Paid Nums",strWinPaid);}
  if (Credits == NULL)         {SpriteError("Credits Nums",strCredits);}
  if (Chips == NULL)           {SpriteError("Chip Stacks",strChips);}
  if (Reel == NULL)            {SpriteError("Reel",strReel);}
  if (NamePlate1 == NULL)      {SpriteError("NamePlate1",strNP1);}
  if (NamePlate2 == NULL)      {SpriteError("NamePlate2",strNP2);}
  if (NamePlate3 == NULL)      {SpriteError("NamePlate3",strNP3);}
  if (BankCashDisplay == NULL) {SpriteError("BankCashDisplay",strBankCashDisplay);}
  if (Button0 == NULL)         {SpriteError("Button0",strButton0);}
  if (Button1 == NULL)         {SpriteError("Button1",strButton1);}
  if (Button2 == NULL)         {SpriteError("Button2",strButton2);}
  if (Button3 == NULL)         {SpriteError("Button3",strButton3);}
  if (Button4 == NULL)         {SpriteError("Button4",strButton4);}
  if (Button5 == NULL)         {SpriteError("Button5",strButton5);}
  if (Button6 == NULL)         {SpriteError("Button6",strButton6);}
  if (Button7 == NULL)         {SpriteError("Button7",strButton7);}
  if (CoinPay == NULL)         {SpriteError("CoinPay",strCoinPay);}

  if (idsProgressive > 0)
  {
    if (Progressive == NULL) {SpriteError("Progressive",strProgressive);}
    ActivateSpriteNow(Progressive);
  }

  Sounds->Start(GetFUC());
  CoinsPlayed->Start(GetFUC());
  Credits->Start(GetFUC());
  WinPaid->Start(GetFUC());
  Chips->Start(GetFUC());
  ActivateSpriteNow(Reel);
  CoinPay->Start(GetFUC());
  BankCashDisplay->Start(GetFUC());
  ActivateSpriteNow(Button0);
  ActivateSpriteNow(Button1);
  ActivateSpriteNow(Button2);
  if (!GetFW()->GetHandleShowMenu())
  {
	 Button2->PButton->CAD.SetCurrentFrame(1);
	 Button2->Show();
	 Button2->PButtonResponder->Remove();
  }
  ActivateSpriteNow(Button3);
  ActivateSpriteNow(Button4);
  ActivateSpriteNow(Button5);
  ActivateSpriteNow(Button6);
  ActivateSpriteNow(Button7);
  NamePlate1->Start(GetFUC());
  NamePlate2->Start(GetFUC());
  NamePlate3->Start(GetFUC());
}
//*******************************************************************
void TCasinoSGameLord::CleanupSprites()
{
  CoinsPlayed->NoShow();   // is this necessary ??
}
//*******************************************************************
bool TCasinoSGameLord::AddCredits(int16 addcredits)
{
  TMoney mikefuckup = addcredits;
  if(GetCash(activeplayer) >= mikefuckup*coinsize)
  {
	 credits += mikefuckup;
	 SubCash(activeplayer,mikefuckup*coinsize);
	 BankCashDisplay->SetNum(GetCash(activeplayer));
	 Chips->SetNum(GetCash(activeplayer));
	 Credits->SetNum(credits);
    Button4->ShowVoidUp();
  }
  else
  {
	 PModeWin->MessageBox("You do not have that much.","Bankroll",MB_OK);
  }
  return true;
}
//*******************************************************************
void TCasinoSGameLord::AskExpert()
{
  string expertstring="";
  if(coinsplayed != maxbet && coinsplayed > 0)
  {
	 expertstring  = TAppString(5700);
	 expertstring  += TAppString(5701);
	 expertstring  += TAppString(5702);
	 expertstring  += TAppString(5703);
	 expertstring  += TAppString(5704);
  }
  else
  {
	 expertstring  = TAppString(5705);
	 expertstring  += TAppString(5706);
	 if(GetOgleApp()->GetAppType() == catSlotLite)
	 {
		expertstring  += TAppString(5728);
		expertstring  += TAppString(5729);
		expertstring  += TAppString(5730);
	 }
	 else
	 {
      expertstring  += TAppString(5707);
		expertstring  += TAppString(5708);
		expertstring  += TAppString(5709);
	 }
    expertstring  += TAppString(5710);
	 expertstring  += TAppString(5711);
	 expertstring  += TAppString(5712);
	 expertstring  += TAppString(5713);
	 expertstring  += TAppString(5714);
	 expertstring  += TAppString(5715);
	 expertstring  += TAppString(5716);
	 expertstring  += TAppString(5717);
	 expertstring  += TAppString(5718);
	 expertstring  += TAppString(5719);
	 expertstring  += TAppString(5720);
	 expertstring  += TAppString(5721);
	 expertstring  += TAppString(5722);
	 expertstring  += TAppString(5723);
	 expertstring  += TAppString(5724);
	 expertstring  += TAppString(5725);
	 expertstring  += TAppString(5726);
	 expertstring  += TAppString(5727);
  }
  GetFW()->DisplayExpert(expertstring);
}
//*******************************************************************
void TCasinoSGameLord::EnableButton(int16 button)
{
  switch(button)
  {
	 case 0  : Button0->Enabled = true;break;
	 case 1  : Button1->Enabled = true;break;
	 case 2  : Button2->Enabled = true;break;
	 case 3  : Button3->Enabled = true;break;
	 case 4  : Button4->Enabled = true;break;
	 case 5  : Button5->Enabled = true;break;
	 case 6  : Button6->Enabled = true;break;
	 case 7  : Button7->Enabled = true;break;
  }
}
//*******************************************************************
void TCasinoSGameLord::DisEnableButton(int16 button)
{
  switch(button)
  {
	 case 0  : Button0->Enabled = false;break;
	 case 1  : Button1->Enabled = false;break;
	 case 2  : Button2->Enabled = false;break;
	 case 3  : Button3->Enabled = false;break;
	 case 4  : Button4->Enabled = false;break;
	 case 5  : Button5->Enabled = false;break;
	 case 6  : Button6->Enabled = false;break;
	 case 7  : Button7->Enabled = false;break;
  }
}
//*******************************************************************
void TCasinoSGameLord::FreezeAllButtons()
{
  Button0->Freeze = true;
  Button1->Freeze = true;
  Button2->Freeze = true;
  Button3->Freeze = true;
  Button4->Freeze = true;
  Button5->Freeze = true;
  Button6->Freeze = true;
  Button7->Freeze = true;
}
//*******************************************************************
void TCasinoSGameLord::UnFreezeAllButtons()
{
  Button0->Freeze = false;
  Button1->Freeze = false;
  Button2->Freeze = false;
  Button3->Freeze = false;
  Button4->Freeze = false;
  Button5->Freeze = false;
  Button6->Freeze = false;
  Button7->Freeze = false;
}
//*******************************************************************
void TCasinoSGameLord::EnableAllButtons()
{
  Button0->Enabled = true;
  Button1->Enabled = true;
  Button2->Enabled = true;
  Button3->Enabled = true;
  Button4->Enabled = true;
  Button5->Enabled = true;
  Button6->Enabled = true;
  Button7->Enabled = true;
}
//*******************************************************************
void TCasinoSGameLord::DisEnableAllButtons()
{
  Button0->Enabled = false;
  Button1->Enabled = false;
  Button2->Enabled = false;
  Button3->Enabled = false;
  Button4->Enabled = false;
  Button5->Enabled = false;
  Button6->Enabled = false;
  Button7->Enabled = false;
}
//*******************************************************************
#pragma argsused
bool TCasinoSGameLord::Respond(int16 button,int16 info,void *pdata)
{
  if(info == -5)//gray button hit
  {
	 if(button == idButton7 && GetCash(activeplayer) == 0 && credits == 0)
	 {
      #if defined(KENO_COMPILE)
		if(GetCasPD(activeplayer)->IsActiveKenoTicket())
		{
		  PModeWin->MessageBox("You're out of money and may not bet. Your only hope is that one of your Keno tickets pays off.","Out of Cash",MB_OK);
		}
		else
		{
      #endif
		  PModeWin->MessageBox("You've hit rock bottom. Your gambler is bankrupt. Select Create/Delete under the FILE menu to create or select a new gambler.","Bankrupt!",MB_OK);
      #if defined(KENO_COMPILE)
		}
      #endif
	 }
	 return true;
  }
  ButtonInfo = info;
  if(info != -1)
  {
	 switch(button)
	 {
	 case idButton0  : ButtonHit[idButton0]=true;break;
	 case idButton1  : TCmMsg(CM_ASKEXPERTSTATISTICS).PostToFW();ButtonHit[idButton1]=true;break;
	 case idButton2  : ButtonHit[idButton2]=true;break;
	 case idButton3  : ButtonHit[idButton3]=true;break;
	 case idButton4  : ButtonHit[idButton4]=true;break;
	 case idButton5  : ButtonHit[idButton5]=true;break;
	 case idButton6  : ButtonHit[idButton6]=true;break;
	 case idButton7  : ButtonHit[idButton7]=true;break;
	 default         : WaitOnButtonDown = false;break;
	 }
  }
  return true;
}
//*******************************************************************
void TCasinoSGameLord::ButtonClear(int16 button)
{
  switch(button)
  {
	 case idButton0  : ButtonHit[idButton0]=false;break;
	 case idButton1  : ButtonHit[idButton1]=false;break;
	 case idButton2  : ButtonHit[idButton2]=false;GetFW()->CmShowMenu();break;
	 case idButton3  : ButtonHit[idButton3]=false;PModeWin->ModeHelp();break;
	 case idButton4  : ButtonHit[idButton4]=false;break;
	 case idButton5  : ButtonHit[idButton5]=false;break;
	 case idButton6  : ButtonHit[idButton6]=false;break;
	 case idButton7  : ButtonHit[idButton7]=false;break;
	 default         : WaitOnButtonDown = false;break;
  }
  WaitOnButtonDown = false;
  return;
}
//*******************************************************************
void TCasinoSGameLord::SetReel()
{
}
//*******************************************************************
TMoney TCasinoSGameLord::PayOut()
{
  return 0;
}
//*******************************************************************
bool TCasinoSGameLord::Respond(TResponder &responder)
{
  if (PState == NULL) {return true;}

  switch (responder.GetID())
  {
	 case idAddCoins  :  if(shutdownstate == 1) {return true;}
								return (((TSLordState *)PState)->AddCoin(responder));
	 case idSpeedClick:  return (((TSLordState *)PState)->SpeedClick(responder));

	 case idOneChip            :  return true;//(((TSLordState *)PState)->OneChip(responder));
	 case idFiveChip           :  return true;//(((TSLordState *)PState)->FiveChip(responder));
	 case idTwentyFiveChip     :  return true;//(((TSLordState *)PState)->TwentyFiveChip(responder));
	 case idOneHundredChip     :  return true;//(((TSLordState *)PState)->OneHundredChip(responder));
	 case idOneThouChip        :  return true;//(((TSLordState *)PState)->OneThouChip(responder));
	 case idTenThouChip        :  return true;//(((TSLordState *)PState)->TenThouChip(responder));
	 case idNamePlate          :  if(shutdownstate){return true;}
											return (((TSLordState *)PState)->NamePlate(responder));
	 default     :  return true;
  }
}
//*******************************************************************
void TCasinoSGameLord::SetupResponders()
{
  Responders[0]  = new TResponder(PModeWin,100,TRect(543,404,617,424),idAddCoins,this,true,'~',TCursorData(GetOgleApp(),ID_POINTING_FINGER_CURSOR));
  Responders[1]  = new TResponder(PModeWin,100,TRect(394,431,424,463),idOneChip,this,true,'~',TCursorData(GetOgleApp(),ID_POINTING_FINGER_CURSOR));
  Responders[2]  = new TResponder(PModeWin,100,TRect(358,431,390,463),idFiveChip,this,true,'~',TCursorData(GetOgleApp(),ID_POINTING_FINGER_CURSOR));
  Responders[3]  = new TResponder(PModeWin,100,TRect(323,431,354,463),idTwentyFiveChip,this,true,'~',TCursorData(GetOgleApp(),ID_POINTING_FINGER_CURSOR));
  Responders[4]  = new TResponder(PModeWin,100,TRect(288,431,320,463),idOneHundredChip,this,true,'~',TCursorData(GetOgleApp(),ID_POINTING_FINGER_CURSOR));
  Responders[5]  = new TResponder(PModeWin,100,TRect(253,431,285,463),idOneThouChip,this,true,'~',TCursorData(GetOgleApp(),ID_POINTING_FINGER_CURSOR));
  Responders[6]  = new TResponder(PModeWin,100,TRect(219,431,250,463),idTenThouChip,this,true,'~',TCursorData(GetOgleApp(),ID_POINTING_FINGER_CURSOR));
  Responders[7]  = new TResponder(PModeWin,200,TRect(5,5,635,475)    ,idSpeedClick        ,this,true,'~',TCursorData(0,0));
  Responders[8]  = new TResponder(PModeWin,100,TRect(260,465,375,477),idNamePlate,this,true,VK_TAB,TCursorData(GetOgleApp(),ID_POINTING_FINGER_CURSOR));
}
//*******************************************************************
TCasinoSGameLord::TCasinoSGameLord(TSlotsModeWin *pmwin,const TFileMode &fm,
                                   int16 subgametype,int16 denomid)
:TCasinoGameLord(pmwin,fm,subgametype,denomid)
{
  PState   = new TSLordMainState(this);

  Sounds = NULL;
  Button0 = NULL;
  Button1 = NULL;
  Button2 = NULL;
  Button3 = NULL;
  Button4 = NULL;
  Button5 = NULL;
  Button6 = NULL;
  Button7 = NULL;
  BankCashDisplay = NULL;
  CoinPay         = NULL;
  Reel            = NULL;
  CoinsPlayed     = NULL;
  WinPaid         = NULL;
  Credits         = NULL;
  Chips           = NULL;
  NamePlate1       = NULL;
  NamePlate2       = NULL;
  NamePlate3       = NULL;
  Progressive     = NULL;
  shutdownstate    = 0;
  progressive = 20000;
  pMWin  = pmwin;
 // maxbet=3;  // put in *1gld.cpp constructors
  credits = 0;
  coinsize = GameDenom;
  r1=0;
  r2=0;
  r3=0;
  activeplayer = 0;
  machinenum = 0;
  playersin=0;
  coinsplayed = 0;
  winnerpaid = 0;
  ButtonInfo = 0;
  for(int16 i=0;i<NUMOFBUTTONS;i++)
  {
    ButtonHit[i] = false;
  }
  SetupResponders();
  PayOffSound = 0;

  // mrp - v2.4 - 09/09/99 - idcode restructuring.
  idsButton0 = 0;
  idsButton1 = 0;
  idsButton2 = 0;
  idsButton3 = 0;
  idsButton4 = 0;
  idsButton5 = 0;
  idsButton6 = 0;
  idsButton7 = 0;
  idsBankCashDisplay = 0;
  idsChips = 0;
  idsCoinPay = 0;
  idsCredits = 0;
  idsNP1 = 0;
  idsNP2 = 0;
  idsNP3 = 0;
  idsReel = 0;
  idsSound = 0;
  idsWinPaid = 0;
  idsProgressive = 0;
  idsCoinsPlayed = 0;
}
//*******************************************************************
TCasinoSGameLord::~TCasinoSGameLord()
{
  if(PState != NULL)
  {
	 delete PState;
	 PState = NULL;
  }
  CleanupResponders();
}
//*******************************************************************
void TCasinoSGameLord::CleanupResponders()
{
  for(int16 i=0;i<NumResponders;i++) {delete Responders[i];}
}
//*******************************************************************
void TCasinoSGameLord::Spin()
{
  int16 session=0;
  session = GetCasPD(activeplayer)->SData.CurrentSession;
  GetCasPD(activeplayer)->SData.Sessions[session].HandsPlayed++;
  Reel->Blur();
}
//*******************************************************************
int16 TCasinoSGameLord::InitS()
{
  ActivateSprite(Song,GetAdjFUC());
  Button7->PButtonResponder->SetCh2(VK_RETURN);
  Button7->PButtonResponder->SetCh('s');
  Button5->PButtonResponder->SetCh('o');
  NamePlate1->NoShow();
  NamePlate2->NoShow();
  NamePlate3->NoShow();
  Reel->SetNum(int16(random(10)),int16(random(10)),int16(random(10)));
  if (SubGameType == cslAlladinsLamp)
  {
    progressive = ((TCasinoModeWin *)pMWin)->GetCasPlayerMgr()->GetCasinoGameDataPtr()->ProgressiveSAmount;
//    if(GameDenom == cd1)
    if (DenomID == TMoney::did_1_00)
    {
      dword interval=0;
	   interval = TTime().Seconds() - ((TCasinoModeWin *)pMWin)->GetCasPlayerMgr()->GetCasinoGameDataPtr()->ProgressiveSEndTime;

	   if(interval < 600 && interval > 0)
	   {
		 int i=0;
		  interval = interval/17;
		  for(i=0;i<interval;i++)
		  {
		    progressive += 1;
		    if(progressive > 99963l){progressive = 20000;}
		  }
		  if(random(300) == 1){progressive = 20000;}
	   }
	   else if(interval < 600000l && interval > 0)
	   {
		  int i=0;
		  interval = interval/600;
		  for(i=0;i<interval;i++)
		  {
		    if(random(300) == 1)
		    {progressive = 20000;}
		    progressive += 36;
		    if(progressive > 99963l){progressive = 20000;}
		  }
	   }
	   else
	   {
		  progressive = 20000 + random(6001);
	   }
    }
  }
  SetupActivePlayer(NextSlotNum(-1)); // -1 because order of checking
  if(GetCasPD(0))
  {
	 GetCasPD(0)->StartSSession(SubGameType,GameDenom);
  }
  if(GetCasPD(1))
  {
	 GetCasPD(1)->StartSSession(SubGameType,GameDenom);
  }
  if(GetCasPD(2))
  {
	 GetCasPD(2)->StartSSession(SubGameType,GameDenom);
  }
  credits = 0;
  coinsplayed = 0;
  winnerpaid = 0;
  if(credits!= 0){Button4->ShowVoidUp();}
  else{Button4->ShowGray();}
  if (!GetFW()->GetHandleShowMenu())
  {
	 Button2->PButton->CAD.SetCurrentFrame(3);
	 Button2->PButton->Show();
	 Button2->PButtonResponder->Remove();
  }
  return 1;
}
//*******************************************************************
void TCasinoSGameLord::SwitchToPlayer(int16 player)
{
  if(GetCasPD(player))
  {
	 if(activeplayer != player && activeplayer != -1)
	 {
      credits += coinsplayed;
		coinsplayed = 0;
		CoinsPlayed->SetNum(0);
		GetCasPlayer(activeplayer)->credit = credits;
		credits = 0;
		Button7->ShowGray();
		GetCasPD(activeplayer)->Columns[0] = Chips->col1;
		GetCasPD(activeplayer)->Columns[1] = Chips->col2;
		GetCasPD(activeplayer)->Columns[2] = Chips->col3;
		GetCasPD(activeplayer)->Columns[3] = Chips->col4;
		GetCasPD(activeplayer)->Columns[4] = Chips->col5;
		GetCasPD(activeplayer)->Columns[5] = Chips->col6;
	 }

	 if(activeplayer != player)
	 {
		switch(activeplayer)
		{
			 case 0 : NamePlate1->NoShowNamePlate();break;
			 case 1 : NamePlate2->NoShowNamePlate();break;
			 case 2 : NamePlate3->NoShowNamePlate();break;
		}
		activeplayer = player;
		BankCashDisplay->SetNum(GetCash(activeplayer));
		Chips->SetupCols(GetCasPD(player)->Cash,
                       GetCasPD(player)->Columns[0],
						     GetCasPD(player)->Columns[1],
                       GetCasPD(player)->Columns[2],
						     GetCasPD(player)->Columns[3],
                       GetCasPD(player)->Columns[4],
						     GetCasPD(player)->Columns[5],
                       false);
		credits = GetCasPlayer(player)->credit;
		GetCasPlayer(player)->credit = 0;
		Credits->SetNum(credits);
		if(GetCasPD(player)->Cash != 0)
		{
		  Button5->ShowVoidUp();
		  Button6->ShowVoidUp();
		}
		else
		{
		  Button5->ShowGray();
		  Button6->ShowGray();
		}
		if(GetNumActivePlayers() > 1)
		{
		  string name;
		  name = GetCasPD(player)->GetName();
		  switch(player)
		  {
			 case 0 : NamePlate1->ShowNamePlateString(name);break;
			 case 1 : NamePlate2->ShowNamePlateString(name);break;
			 case 2 : NamePlate3->ShowNamePlateString(name);break;
		  }
		}
	 }
	 if(credits != 0)
	 {
		Button4->ShowVoidUp();
	 }
	 else
	 {
		Button4->ShowGray();
	 }
  }
}
//*******************************************************************
void TCasinoSGameLord::CyclePlayers()
{
  if(activeplayer != -1)
  {
	 SwitchToPlayer(NextSlotNum(activeplayer));
  }
}
//*******************************************************************
void  TCasinoSGameLord::ShuttingDown()
{
 // if(shutdownstate == 0)
 // {
	 if(GetCasPD(0))
	 {
		NotifyPlayerDeActivation(0);
	 }
	 if(GetCasPD(1))
	 {
		NotifyPlayerDeActivation(1);
	 }
	 if(GetCasPD(2))
	 {
		NotifyPlayerDeActivation(2);
	 }
  if (SubGameType == cslAlladinsLamp)
  {
//	 if(GameDenom == cd1)
    if (DenomID == TMoney::did_1_00)
    {
      ((TCasinoModeWin *)pMWin)->GetCasPlayerMgr()->GetCasinoGameDataPtr()->ProgressiveSAmount =
	   progressive;

	   ((TCasinoModeWin *)pMWin)->GetCasPlayerMgr()->GetCasinoGameDataPtr()->ProgressiveSEndTime =
	   TTime().Seconds();
    }
  }
}
//*******************************************************************
void TCasinoSGameLord::NotifyPlayerActivation(int16 slotnum)
{
  if(GetCasPD(slotnum))
  {
	 GetCasPD(slotnum)->StartSSession(SubGameType,GameDenom);
//	 int session = GetCasPD(slotnum)->SData.CurrentSession;
//	 GetCasPD(slotnum)->SData.Sessions[session].GameName = (TGameName)game;
	 if(activeplayer == -1)
	 {
	  activeplayer = slotnum;
	  BankCashDisplay->SetNum(GetCash(activeplayer));
	  Chips->SetupCols(GetCasPD(slotnum)->Cash,
                      GetCasPD(slotnum)->Columns[0],
						    GetCasPD(slotnum)->Columns[1],
                      GetCasPD(slotnum)->Columns[2],
						    GetCasPD(slotnum)->Columns[3],
                      GetCasPD(slotnum)->Columns[4],
						    GetCasPD(slotnum)->Columns[5],
                      false);
	  if(GetCasPD(slotnum)->Cash >= coinsize)
		{
		  Button5->ShowVoidUp();
		  Button6->ShowVoidUp();
		}
		else
		{
		  Button5->ShowGray();
		  Button6->ShowGray();
		}

		string name;
		name = GetCasPD(activeplayer)->GetName();
		switch(slotnum)
		{
		  case 0 : NamePlate1->ShowNamePlateString(name);break;
		  case 1 : NamePlate2->ShowNamePlateString(name);break;
		  case 2 : NamePlate3->ShowNamePlateString(name);break;
		}
	 }
	 //SetupSessionData(activeplayer);
  }
}
//*******************************************************************
void TCasinoSGameLord::NotifyPlayerDeActivation(int16 slotnum)
{
  if(GetCasPD(slotnum))
  {
	 switch(slotnum)
	 {
			 case 0 : NamePlate1->NoShowNamePlate();break;
			 case 1 : NamePlate2->NoShowNamePlate();break;
			 case 2 : NamePlate3->NoShowNamePlate();break;
	 }
	 GetCasPD(slotnum)->Cash += GetCasPlayer(slotnum)->credit*coinsize;
	 GetCasPlayer(slotnum)->credit = 0;
	 if(activeplayer == slotnum)
	 {
		if(shutdownstate == 0)
		{
		  GetCasPD(slotnum)->Cash += coinsplayed*coinsize;
		}
		coinsplayed = 0;
		GetCasPD(slotnum)->Cash += credits*coinsize;
		credits = 0;
		Button7->ShowGray();
		Chips->SetNum(GetCash(activeplayer));
		CoinsPlayed->SetNum(0);
		GetCasPD(slotnum)->Columns[0] = Chips->col1;
		GetCasPD(slotnum)->Columns[1] = Chips->col2;
		GetCasPD(slotnum)->Columns[2] = Chips->col3;
		GetCasPD(slotnum)->Columns[3] = Chips->col4;
		GetCasPD(slotnum)->Columns[4] = Chips->col5;
		GetCasPD(slotnum)->Columns[5] = Chips->col6;
	 }
	 if(GetNumActivePlayers() == 1)
	 {
		activeplayer = -1;
		Chips->NoShow();
		Credits->SetNum(0);
		credits = 0;
		CoinsPlayed->SetNum(0);
		NamePlate1->NoShow();NamePlate2->NoShow();NamePlate3->NoShow();
		Button7->ShowGray();
		BankCashDisplay->SetNum(0);
	 }
	 if(GetNumActivePlayers() > 1 && activeplayer == slotnum)
	 {
		int16 newplayer=-1;
		newplayer = NextSlotNum(slotnum);
		activeplayer = newplayer;
		Chips->SetupCols(GetCasPD(newplayer)->Cash,
                       GetCasPD(newplayer)->Columns[0],
							  GetCasPD(newplayer)->Columns[1],
                       GetCasPD(newplayer)->Columns[2],
							  GetCasPD(newplayer)->Columns[3],
                       GetCasPD(newplayer)->Columns[4],
							  GetCasPD(newplayer)->Columns[5],
                       false);
		credits = GetCasPlayer(newplayer)->credit;
		GetCasPlayer(newplayer)->credit = 0;
		Credits->SetNum(credits);
		CoinsPlayed->SetNum(0);
		BankCashDisplay->SetNum(GetCash(activeplayer));
		if(GetCasPD(activeplayer)->Cash >= coinsize || credits > 0)
		{
		  Button5->ShowVoidUp();
		  Button6->ShowVoidUp();
		}
		else
		{
		  Button5->ShowGray();
		  Button6->ShowGray();
		}
		Button7->ShowGray();
		string name;
		name = GetCasPD(newplayer)->GetName();
      switch(newplayer)
		{
			 case 0 : NamePlate1->ShowNamePlateString(name);break;
			 case 1 : NamePlate2->ShowNamePlateString(name);break;
			 case 2 : NamePlate3->ShowNamePlateString(name);break;
		}
	 }
	 GetCasPD(slotnum)->EndSSession();
  }
}
//*******************************************************************
void TCasinoSGameLord::SetupActivePlayer(int16 slot)
{
  if(GetCasPD(slot))
  {
	 activeplayer = slot;
	 Chips->SetupCols(GetCasPD(slot)->Cash,
                     GetCasPD(slot)->Columns[0],
						   GetCasPD(slot)->Columns[1],
                     GetCasPD(slot)->Columns[2],
						   GetCasPD(slot)->Columns[3],
                     GetCasPD(slot)->Columns[4],
						   GetCasPD(slot)->Columns[5],
                     false);
	 if(GetNumActivePlayers() > 0)
	 {
		string name;
		name = GetCasPD(slot)->GetName();
      switch(slot)
		  {
			 case 0 : NamePlate1->ShowNamePlateString(name);break;
			 case 1 : NamePlate2->ShowNamePlateString(name);break;
			 case 2 : NamePlate3->ShowNamePlateString(name);break;
		  }
	 }
  }
}
//*******************************************************************
int16 TCasinoSGameLord::PayOutProgressive()
{
  return 1;
}
//*******************************************************************
int16 TCasinoSGameLord::Clear()
{
  PayOffSound = 0;
  UnFreezeAllButtons();
  shutdownstate    = 0;
  ChangeActivePlayersOk = true;
  coinsplayed = 0;
  if(credits > 0)
  {
	 Button4->ShowVoidUp();
  }
  else
  {
    Button4->ShowGray();
  }
  if(activeplayer > -1 && (GetCash(activeplayer) >= coinsize || credits > 0))
  {
	 Button5->ShowVoidUp();
	 Button6->ShowVoidUp();
  }
  if(activeplayer > -1){BankCashDisplay->SetNum(GetCash(activeplayer));}
  return 1;
}
//*******************************************************************
TMoney TCasinoSGameLord::Winner()
{
#ifdef DEBUGSLOT
  int16 x,y,z;
  pMWin->SetUpdatePause();
  char cardnum1[5] = "";
  char cardnum2[5] = "";
  char cardnum3[5] = "";
  TInputDialog getcard1(pMWin,"","#",cardnum1,5);
  getcard1.Execute();
  TInputDialog getcard2(pMWin,"","#",cardnum2,5);
  getcard2.Execute();
  TInputDialog getcard3(pMWin,"","#",cardnum3,5);
  getcard3.Execute();
  pMWin->ClearUpdatePause();
  x = atoi(cardnum1);
  y = atoi(cardnum2);
  z = atoi(cardnum3);
  Reel->SetNum(x,y,z);
  Reel->ShowReel(0);
  Reel->ShowReel(1);
  Reel->ShowReel(2);
#endif
  winnerpaid = PayOut();
  if(winnerpaid == -3)//jackpot
  {
	 winnerpaid = progressive;progressive = 20000;
	 Sounds->PlaySound(21);
  }

  TCasinoSData &cd = GetCasPD(activeplayer)->SData;
  int16 session = cd.CurrentSession;
  TCSSession &cs = cd.Sessions[session];

  if(winnerpaid == 0)
  {
	 cd.Cumulative -= coinsplayed*coinsize;
	 cs.CurrentLosingStreak++;
	 cs.CurrentWinStreak = 0;
	 cs.Losses++;
	 if (cs.CurrentLosingStreak > cs.LosingStreak)
	 {
		cs.LosingStreak = cs.CurrentLosingStreak;
	 }
	 if((GetCash(activeplayer)+(credits*coinsize)) < cs.PeakLoss)
	 {
		cs.PeakLoss = GetCash(activeplayer)+(credits*coinsize);
	 }
  }
  else
  {
	 cd.Cumulative += winnerpaid*coinsize;
	 cs.CurrentWinStreak++;
	 cs.CurrentLosingStreak = 0;
	 cs.Wins++;  //???
	 if(cs.CurrentWinStreak > cs.WinStreak)
	 {
		cs.WinStreak = cs.CurrentWinStreak;
	 }
	 if(winnerpaid*coinsize > cs.LargestWin)
	 {
		cs.LargestWin = winnerpaid*coinsize;
	 }
	 if((GetCash(activeplayer)+(credits*coinsize) - cs.StartingCash) > cs.PeakWin)
	 {
		cs.PeakWin = GetCash(activeplayer)+(credits*coinsize) - cs.StartingCash;
	 }
	 if(winnerpaid > 18)
	 {
		cs.nHiPayoffs++;
	 }
	 else
	 {
      cs.nLowPayoffs++;
	 }
  }
  switch(PayOffSound)
  {
	 case 1  : Sounds->PlaySound(17);break;
	 case 2  : Sounds->PlaySound(18);break;
	 case 3  : Sounds->PlaySound(19);break;
	 case 4  : Sounds->PlaySound(20);break;
  }
  return winnerpaid;
}// winner
//*******************************************************************
int16 TCasinoSGameLord::AddCoins()
{
  if(GetCash(activeplayer) == 0 && credits == 0)
  {
	 if(coinsplayed > 0)
	 {
		  PModeWin->MessageBox("You're out of money and may not make additional bets. Your current bets are your only hope.","Out of Cash",MB_OK);
	 }
    #if defined(KENO_COMPILE)
	 else if(GetCasPD(activeplayer)->IsActiveKenoTicket())
	 {
		PModeWin->MessageBox("You're out of money and may not bet. Your only hope is that one of your Keno tickets pays off.","Out of Cash",MB_OK);
	 }
    #endif
	 else
	 {
		PModeWin->MessageBox("You've hit rock bottom. Your gambler is bankrupt. Select Create/Delete under the FILE menu to create or select a new gambler.","Bankrupt!",MB_OK);
	 }
	 return 1;
  }
  if(coinsplayed < maxbet)
  {
	 SubCash(activeplayer,coinsize);
	 coinsplayed++;
  }
  else
  {
	 if(coinsplayed == maxbet)   // Not a needed check, oh well...
	 {
		SubCash(activeplayer,coinsize);
		credits++;
	 }
  }
  return 1;
}
//*******************************************************************
int16 TCasinoSGameLord::CashOut()
{
  return 1;
}
//*******************************************************************
int16 TCasinoSGameLord::Bet1()
{
  if((GetCash(activeplayer) == 0 || GetCash(activeplayer) < coinsize) && credits == 0)
  {
	 if(GetCash(activeplayer) < coinsize && GetCash(activeplayer) > 0)
	 {
		PModeWin->MessageBox("You don't have enough money to bet more.","Not Enough",MB_OK);
	 }
	 else if(coinsplayed > 0)
	 {
		  PModeWin->MessageBox("You're out of money and may not make additional bets. Your current bets are your only hope.","Out of Cash",MB_OK);
	 }
    #if defined(KENO_COMPILE)
	 else if(GetCasPD(activeplayer)->IsActiveKenoTicket())
	 {
		PModeWin->MessageBox("You're out of money and may not bet. Your only hope is that one of your Keno tickets pays off.","Out of Cash",MB_OK);
	 }
    #endif
	 else
	 {
		PModeWin->MessageBox("You've hit rock bottom. Your gambler is bankrupt. Select Create/Delete under the FILE menu to create or select a new gambler.","Bankrupt!",MB_OK);
	 }
	 return 0;
  }
  int session = GetCasPD(activeplayer)->SData.CurrentSession;
  TCSSession &cs = GetCasPD(activeplayer)->SData.Sessions[session];

	if(credits > 0)
	{
	  credits--;
	  Sounds->PlaySound(6);
	  coinsplayed++;
	  CoinsPlayed->SetNum(coinsplayed);
	  BankCashDisplay->SetNum(GetCash(activeplayer));
	  Credits->SetNum(credits);
	  Button7->ShowVoidUp();
	  cs.TotalBetsCash += coinsize;

	  if(credits == 0)
	  {
		 Button4->ShowGray();
	  }
	  WinPaid->SetNum(0);
     BankCashDisplay->SetNum(GetCash(activeplayer));
	  return 1;
	}
	if (GetCash(activeplayer) >= coinsize)
	{
	  SubCash(activeplayer,coinsize);
	  Sounds->PlaySound(0);
	  coinsplayed++;
	  cs.TotalBetsCash += coinsize;
	  CoinsPlayed->SetNum(coinsplayed);
	  Credits->SetNum(credits);
	  Button7->ShowVoidUp();
	  Chips->SetNum(GetCash(activeplayer));
	  WinPaid->SetNum(0);
     BankCashDisplay->SetNum(GetCash(activeplayer));
	}
	return 1;
}
//*******************************************************************
TMoney TCasinoSGameLord::BetX(TMoney x)
{
  if(GetCash(activeplayer) == 0 && credits == 0)
  {
	 if(coinsplayed > 0)
	 {
		  PModeWin->MessageBox("You're out of money and may not make additional bets. Your current bets are your only hope.","Out of Cash",MB_OK);
	 }
    #if defined(KENO_COMPILE)
	 else if(GetCasPD(activeplayer)->IsActiveKenoTicket())
	 {
		PModeWin->MessageBox("You're out of money and may not bet. Your only hope is that one of your Keno tickets pays off.","Out of Cash",MB_OK);
	 }
    #endif
	 else
	 {
		PModeWin->MessageBox("You've hit rock bottom. Your gambler is bankrupt. Select Create/Delete under the FILE menu to create or select a new gambler.","Bankrupt!",MB_OK);
	 }
	 return 0;
  }
	TMoney bm=0,returnvalue=0;
	bm = x/coinsize;
   x.Truncate();
	int16 session = GetCasPD(activeplayer)->SData.CurrentSession;
   TCSSession &cs = GetCasPD(activeplayer)->SData.Sessions[session];

	if (GetCash(activeplayer) >= x && bm > 0)
	{
	  SubCash(activeplayer,(coinsize * bm));
	  cs.TotalBetsCash += (coinsize * bm);
	  BankCashDisplay->SetNum(GetCash(activeplayer));
	  Chips->SetNum(GetCash(activeplayer));
	  if(coinsplayed == maxbet)
	  {
		 credits += bm;
		 Credits->SetNum(credits);
		 Button4->ShowVoidUp();
		 returnvalue = 0;
	  }
	  else if(coinsplayed+bm < maxbet+1)
	  {
		 returnvalue = bm;
		 coinsplayed += bm;
		 CoinsPlayed->SetNum(coinsplayed);
		 switch((long)bm)
		 {
			case 1  : Sounds->PlaySound(0);break;
			case 2  : Sounds->PlaySound(1);break;
			case 3  : Sounds->PlaySound(2);break;
			case 4  : Sounds->PlaySound(3);break;
			case 5  : Sounds->PlaySound(4);break;
			default : if(bm > 5) {Sounds->PlaySound(5);}
		 }
	  }
	  else if(coinsplayed+bm > maxbet)
	  {
		 switch((long)(maxbet - coinsplayed))
		 {
			case 1  : Sounds->PlaySound(0);break;
			case 2  : Sounds->PlaySound(1);break;
			case 3  : Sounds->PlaySound(2);break;
			case 4  : Sounds->PlaySound(3);break;
			case 5  : Sounds->PlaySound(4);break;
			default : if(bm > 5) {Sounds->PlaySound(5);}
		 }
		 returnvalue = maxbet - coinsplayed;
		 bm -= maxbet - coinsplayed;
		 credits += bm;
		 Credits->SetNum(credits);
		 coinsplayed = maxbet;
		 CoinsPlayed->SetNum(coinsplayed);
		 Button4->ShowVoidUp();
	  }
	  WinPaid->SetNum(0);
	  BankCashDisplay->SetNum(GetCash(activeplayer));
	  Button7->ShowVoidUp();
	  if(credits != 0){Button4->ShowVoidUp();}
	}
	return returnvalue;
}
//*******************************************************************
int16 TCasinoSGameLord::BetMax()
{
  if((GetCash(activeplayer) == 0 || GetCash(activeplayer) < coinsize) && credits == 0)
  {
	 if(GetCash(activeplayer) < coinsize && GetCash(activeplayer) > 0)
	 {
		PModeWin->MessageBox("You don't have enough money to bet more.","Not Enough",MB_OK);
	 }
	 else if(coinsplayed > 0)
	 {
		  PModeWin->MessageBox("You're out of money and may not make additional bets. Your current bets are your only hope.","Out of Cash",MB_OK);
	 }
    #if defined(KENO_COMPILE)
	 else if(GetCasPD(activeplayer)->IsActiveKenoTicket())
	 {
		PModeWin->MessageBox("You're out of money and may not bet. Your only hope is that one of your Keno tickets pays off.","Out of Cash",MB_OK);
	 }
    #endif
	 else
	 {
		PModeWin->MessageBox("You've hit rock bottom. Your gambler is bankrupt. Select Create/Delete under the FILE menu to create or select a new gambler.","Bankrupt!",MB_OK);
	 }
	 return 0;
  }
  TMoney cp = coinsplayed;
  int16 session = GetCasPD(activeplayer)->SData.CurrentSession;
  TCSSession &cs = GetCasPD(activeplayer)->SData.Sessions[session];

  if(credits >= maxbet-coinsplayed)
  {
	 credits -= maxbet-coinsplayed;
	 switch((long)(maxbet - coinsplayed))
		 {
			case 1  : Sounds->PlaySound(6);break;
			case 2  : Sounds->PlaySound(7);break;
			case 3  : Sounds->PlaySound(8);break;
			case 4  : Sounds->PlaySound(9);break;
			case 5  : Sounds->PlaySound(10);break;
		 }
	 cs.TotalBetsCash += (maxbet-coinsplayed)*coinsize;

	 coinsplayed = maxbet;
	 CoinsPlayed->SetNum(coinsplayed);
	 Credits->SetNum(credits);
	 Button7->ShowVoidUp();
	 if(credits == 0)
	 {
		Button4->ShowGray();
	 }
	 Button5->ShowGray();
	 Button6->ShowGray();
	 WinPaid->SetNum(0);
	 BankCashDisplay->SetNum(GetCash(activeplayer));
	 return (coinsplayed - cp);
  }
  else
  {
	 if(credits > 0)
	 {
		coinsplayed += credits;
		cs.TotalBetsCash += credits*coinsize;
		Button7->ShowVoidUp();
	 }
	 Button5->ShowGray();
	 Button6->ShowGray();
	 Button4->ShowGray();
	 credits = 0;                          // Could make a little faster
  }

  if (GetCash(activeplayer) > (maxbet - coinsplayed) * coinsize)
  {
	 SubCash(activeplayer,(maxbet - coinsplayed) * coinsize);
	 cs.TotalBetsCash += (maxbet-coinsplayed)*coinsize;
	 switch((long)(maxbet - coinsplayed))
	 {
			case 1  : Sounds->PlaySound(0);break;
			case 2  : Sounds->PlaySound(1);break;
			case 3  : Sounds->PlaySound(2);break;
			case 4  : Sounds->PlaySound(3);break;
			case 5  : Sounds->PlaySound(4);break;
	 }
	 coinsplayed = maxbet;
	 CoinsPlayed->SetNum(coinsplayed);
	 Credits->SetNum(credits);
	 Chips->SetNum(GetCash(activeplayer));
	 Button7->ShowVoidUp();
	 BankCashDisplay->SetNum(GetCash(activeplayer));
  }
  else
  {
	 TMoney x=0;
	 x = GetCash(activeplayer) / coinsize;
    x.Truncate();
	 coinsplayed += x;
	 switch((long)x)
	 {
			case 1  : Sounds->PlaySound(0);break;
			case 2  : Sounds->PlaySound(1);break;
			case 3  : Sounds->PlaySound(2);break;
			case 4  : Sounds->PlaySound(3);break;
			case 5  : Sounds->PlaySound(4);break;
	 }
	 SubCash(activeplayer,x*coinsize);
	 cs.TotalBetsCash += x*coinsize;
	 CoinsPlayed->SetNum(coinsplayed);
	 Credits->SetNum(credits);
	 Chips->SetNum(GetCash(activeplayer));
	 BankCashDisplay->SetNum(GetCash(activeplayer));
	 if(x>0){Button7->ShowVoidUp();}
  }
  if(coinsplayed > cp)
  {
	 WinPaid->SetNum(0);
    BankCashDisplay->SetNum(GetCash(activeplayer));
  }
  else if(coinsplayed == cp)
  {
  BankCashDisplay->SetNum(GetCash(activeplayer));
  }
  return (coinsplayed - cp);
}
//*******************************************************************
int16 TCasinoSGameLord::ShowWinner()
{
  credits += (winnerpaid)/(coinsize);
  return 1;
}
//*******************************************************************
