//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  csjpsp.cpp
//    Project Name:  Casino
// Original Author:  Adam Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0      7/19/96   M.Perry     moved into cpp file.
//  2.0     09/25/97   M.Perry     32-bit conversion.
//********************************************************************
#include "csjpsp.h"
#include "oanm.h"
//*******************************************************************
TSProgressive::TSProgressive(TOgleModeWindow *pmw,const TFileMode &NewFileMode)
:TSprite(pmw,NewFileMode)
{
  SetupAnms();
  ones = 0;
  tens = 0;
  huns = 0;
  thou = 0;
  tenthou = 0;
  penn = 0;
  dime = 0;
  num = 0;
}
//*******************************************************************
TSProgressive::TSProgressive(TOgleModeWindow *pmw,const TFileMode &NewFileMode,void *psource)
:TSprite(pmw,NewFileMode,psource)
{
  ones = 0;    // mike added these to this ctor.
  tens = 0;
  huns = 0;
  thou = 0;
  tenthou = 0;
  penn = 0;
  dime = 0;
  num = 0;

  SetupAnms();
}
//*******************************************************************
TSProgressive::~TSProgressive()
{
}
//*******************************************************************
void TSProgressive::SetupAnms()
{
	 PProgressive[0] = GetAnm(6);
	 PProgressive[1] = GetAnm(5);
	 PProgressive[2] = GetAnm(4);
	 PProgressive[3] = GetAnm(3);
	 PProgressive[4] = GetAnm(2);
	 PProgressive[5] = GetAnm(1);
	 PProgressive[6] = GetAnm(0);

	 for (int16 j=0;j<7;j++)
	 {
		if (PProgressive[j] == NULL) {AnmError("Progressive","num",j);}
	 }

	 for (int16 i=0;i<7;i++)
	 {
		PProgressive[i]->CAD.ClearAutoStart();
		PProgressive[i]->CAD.ClearAutoStop();
		PProgressive[i]->CAD.SetDirStill();
	 }
}
//*******************************************************************
void TSProgressive::SetNum(int32 pro)
{
	 num = (pro*100)+penn+(dime*10);
	 num++;
	 if (PProgressive[0] == NULL) {return;}
	 if (PProgressive[1] == NULL) {return;}
	 if (PProgressive[2] == NULL) {return;}
	 if (PProgressive[3] == NULL) {return;}
	 if (PProgressive[4] == NULL) {return;}
	 if (PProgressive[5] == NULL) {return;}
	 if (PProgressive[6] == NULL) {return;}

	 penn    = num % 10;
	 dime    = (num / 10  ) % 10;
	 ones    = (num / 100 ) % 10;
	 tens    = (num / 1000) % 10;
	 huns    = (num / 10000) % 10;
	 thou    = (num / 100000l) % 10;
	 tenthou = (num / 1000000l) % 10;
	 PProgressive[0]->CAD.SetCurrentFrame(penn);
	 PProgressive[1]->CAD.SetCurrentFrame(dime);
	 PProgressive[2]->CAD.SetCurrentFrame(ones);
	 PProgressive[3]->CAD.SetCurrentFrame(tens);
	 PProgressive[4]->CAD.SetCurrentFrame(huns);
	 PProgressive[5]->CAD.SetCurrentFrame(thou);
	 PProgressive[6]->CAD.SetCurrentFrame(tenthou);
}
//*******************************************************************