 //********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  csreelsp.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     9/26/95    M.Perry     original baseline
//  2.0    09/25/97    M.Perry     32-bit conversion.
//********************************************************************
#include "csreelsp.h"
#include "oanm.h"
//*******************************************************************
TSReel::TSReel(TOgleModeWindow *pmw,const TFileMode &NewFileMode)
:TSprite(pmw,NewFileMode)
{
  SetToManual();
  BlurFrame0=0;
  BlurFrame1=0;
  BlurFrame2=0;
  NoShowStill = false;
  Blur0=false;
  Blur1=false;
  Blur2=false;
  SetupAnms();
}
//*******************************************************************
TSReel::TSReel(TOgleModeWindow *pmw,const TFileMode &NewFileMode,void *psource)
:TSprite(pmw,NewFileMode,psource)
{
  SetToManual();
  BlurFrame0=0;
  BlurFrame1=0;
  BlurFrame2=0;
  NoShowStill = false;
  Blur0=false;
  Blur1=false;
  Blur2=false;
  SetupAnms();
}
//*******************************************************************
TSReel::~TSReel()
{
}
//*******************************************************************
void TSReel::SetupAnms()
  {
	 PBlur[0] = GetAnm(0);
	 PBlur[1] = GetAnm(1);
	 PBlur[2] = GetAnm(2);
	 PReel[0] = GetAnm(3);
	 PReel[1] = GetAnm(4);
	 PReel[2] = GetAnm(5);

	 for (int16 j=0;j<3;j++)
	 {
		if (PBlur[j] == NULL) {AnmError("Blur","num",j);}
		if (PReel[j] == NULL) {AnmError("Reel","num",j);}
	 }

	 for (int16 i=0;i<3;i++)
	 {
		PBlur[i]->CAD.ClearAutoStart();
		PBlur[i]->CAD.ClearAutoStop();
		PBlur[i]->CAD.SetDirStill();
		PBlur[0]->CAD.SetZ(int16(PReel[0]->CAD.GetZ()+2));
		PBlur[1]->CAD.SetZ(int16(PReel[1]->CAD.GetZ()+2));
		PBlur[2]->CAD.SetZ(int16(PReel[2]->CAD.GetZ()+2));
		PBlur[i]->NoShow();
		PReel[i]->CAD.ClearAutoStart();
		PReel[i]->CAD.ClearAutoStop();
		PReel[i]->CAD.SetDirStill();
      PReel[i]->CAD.SetCurrentFrame(int16(random(22)));
	 }
}
//*******************************************************************
void TSReel::PostUpdate(dword NewFUC)
{
  if(NoShowStill)
  {
    PReel[0]->NoShow();
	 PReel[1]->NoShow();
	 PReel[2]->NoShow();
	 NoShowStill = false;
  }
  if(Blur0)
  {
	 BlurFrame0++;;
	 if(BlurFrame0 >= 6){BlurFrame0=0;}
	 PBlur[0]->CAD.SetCurrentFrame(BlurFrame0);
	 PBlur[0]->Show();
  }
  if(Blur1)
  {
	 BlurFrame1++;
	 if(BlurFrame1 >= 6){BlurFrame1=0;}
	 PBlur[1]->CAD.SetCurrentFrame(BlurFrame1);
	 PBlur[1]->Show();
  }
  if(Blur2)
  {
	 BlurFrame2++;
	 if(BlurFrame2 >= 6){BlurFrame2=0;}
	 PBlur[2]->CAD.SetCurrentFrame(BlurFrame2);
	 PBlur[2]->Show();
  }
  TSprite::PostUpdate(NewFUC);
}
//*******************************************************************
void TSReel::ShowReel(int16 reel)
{
	 if (PReel[reel] == NULL) {return;}
	 PBlur[reel]->NoShow();
	 switch(reel)
	 {
		case 0 : Blur0 = false;break;
		case 1 : Blur1 = false;break;
		case 2 : Blur2 = false;break;
	 }
	 PReel[reel]->Show();
	 Update(GetAdjFUC());
}
//*******************************************************************
void TSReel::Blur()
{
  Blur0 = true;
  Blur1 = true;
  Blur2 = true;
  BlurFrame0 = int16(random(6));
  BlurFrame1 = int16(random(6));
  BlurFrame2 = int16(random(6));
}
//*******************************************************************
void TSReel::SetNum(int16 reel0,int16 reel1,int16 reel2)
{
	 if (PReel[0] == NULL) {return;}
	 if (PReel[1] == NULL) {return;}
	 if (PReel[2] == NULL) {return;}

	 PReel[0]->CAD.SetCurrentFrame(reel0);
	 PReel[1]->CAD.SetCurrentFrame(reel1);
	 PReel[2]->CAD.SetCurrentFrame(reel2);
	 Update(GetAdjFUC());
}
//*******************************************************************
