//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  sact1st.cpp   // FLop deal
//    Project Name:  Casino
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     06/29/95   A. Krist    Original baseline
//  2.0     09/25/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "sact1st.h"
#include "csglord.h"
#include "scoutst.h"
#include "csplay.h"
#include "swinst.h"
#include "cassmw.h"
#include "orespond.h"
#include "oanm.h"
#include "owav.h"
//*******************************************************************
TSAct1State::TSAct1State(TCasinoSGameLord *pNewSLord)
:TSLordState(pNewSLord)
{
	 SetRunOrder(ess_Execute,ess_Execute,ess_Execute,ess_Done);
	 Bet1Responder = NULL;
	 BetMaxResponder = NULL;
	 SpinResponder = NULL;
	 CashOutResponder = NULL;
	 AskExpertResponder = NULL;
	 MenuEscResponder = NULL;
    IgnoreCoach = false;

	 OneChipResponder            = NULL;
	 FiveChipResponder           = NULL;
	 TwentyFiveChipResponder     = NULL;
	 OneHundredChipResponder     = NULL;
	 OneThouChipResponder        = NULL;
	 TenThouChipResponder        = NULL;
	 AddCoinResponder            = NULL;
	 WaitOnTray          = false;
	 DelayFUC = 0;

	 Lock      = false;
	 StopReelTime = 0;
	 WaitOnSpin = false;
	 WaitingOnWRCounter = 0;
	 pOwnerLord->winnerpaid = 0;
	 pOwnerLord->coinsplayed = 0;
	 askexpertflag = false;
}
//*******************************************************************
TSAct1State::~TSAct1State()
{
}
//*******************************************************************
void TSAct1State::ExecuteFirstTime()
{
  pOwnerLord->Clear();
  ExecuteWaiting = true;
  ExecuteStatus    = ess_Execute;
}
//*******************************************************************
void TSAct1State::CreateSubState1()
{
  PActiveSubState = new TSWinState(pOwnerLord);
}
//*******************************************************************
void TSAct1State::EndSubState1()
{
  TState::EndSubState1();
  pOwnerLord->Clear();
  StopReelTime = 0;
  Lock = false;
  ExecuteWaiting = true;
}
//*******************************************************************
void TSAct1State::CreateSubState2()
{
  PActiveSubState = new TSCashOutState(pOwnerLord);
}
//*******************************************************************
void TSAct1State::EndSubState2()
{
  TState::EndSubState2();
  ExecuteWaiting = true;
  pOwnerLord->Button4->ShowGray();
  pOwnerLord->UnFreezeAllButtons();
  DelayFUC = pOwnerLord->GetAdjFUC();
  WaitOnTray = true;
}
//*******************************************************************
void TSAct1State::HandlePostUpdate(DWORD NewFUC)
{
  if(WaitOnTray)
  {
	 if(DelayFUC + 6 <= NewFUC)
	 {
      pOwnerLord->BankCashDisplay->SetNum(pOwnerLord->GetCash(pOwnerLord->activeplayer));
		pOwnerLord->Chips->SetNum(pOwnerLord->GetCash(pOwnerLord->activeplayer));
      pOwnerLord->CoinPay->ClearTray();
		WaitOnTray = false;
	 }
	 else{return;}
  }
  if (pOwnerLord->ButtonHit[idButton0])
  {
	 askexpertflag = false;
	 pOwnerLord->AskExpert();
	 pOwnerLord->ButtonClear(idButton0);
	 return;
  }
  if (pOwnerLord->ButtonHit[idButton1])
  {
	 pOwnerLord->ButtonClear(idButton1);
	 return;
  }
  if (pOwnerLord->ButtonHit[idButton2])
  {
	 pOwnerLord->ButtonClear(idButton2);
	 return;
  }
  if (pOwnerLord->ButtonHit[idButton3])
  {
	 pOwnerLord->ButtonClear(idButton3);
	 return;
  }
  if (pOwnerLord->ButtonHit[idButton4])
  {
	 pOwnerLord->FreezeAllButtons();
	 ExecuteWaiting = false;
	 ExecuteStatus = ess_StartSubState2;
	 pOwnerLord->ButtonClear(idButton4);
	 return;
  }
  if (pOwnerLord->ButtonHit[idButton5])
  {
	 pOwnerLord->ButtonClear(idButton5);
	 pOwnerLord->Bet1();
	 if (pOwnerLord->coinsplayed == pOwnerLord->maxbet)
	 {
		WaitingOnWRCounter = 1;
      IgnoreCoach = false;
	 }
  }
  if (pOwnerLord->ButtonHit[idButton6])
  {
	 pOwnerLord->ButtonClear(idButton6);
	 WaitingOnWRCounter = pOwnerLord->BetMax();
    IgnoreCoach = false;
	 return;
  }
  if (pOwnerLord->ButtonHit[idButton7])
  {
	 pOwnerLord->ButtonClear(idButton7);
	 if(pOwnerLord->GetCasPD(pOwnerLord->activeplayer)->CoachOn &&
		 pOwnerLord->maxbet != pOwnerLord->coinsplayed && !IgnoreCoach)
	 {
		  pOwnerLord->Button0->ShowExpert();
		  IgnoreCoach = true;
	 }
	 else
	 {
		if(pOwnerLord->coinsplayed > 0)
		{
		  pOwnerLord->ChangeActivePlayersOk = false;
		  pOwnerLord->Spin();
		  pOwnerLord->Sounds->PlaySound(24);
		  pOwnerLord->FreezeAllButtons();
		  WaitOnSpin = true;
		  pOwnerLord->Button5->ShowGray();
		  pOwnerLord->Button6->ShowGray();
		  pOwnerLord->Button4->ShowGray();
		  pOwnerLord->shutdownstate = 1;
		  IgnoreCoach = false;
		}
	 }
	 return;
  }
  if(WaitOnSpin)
  {
	 if(StopReelTime == 2){pOwnerLord->SetReel();}
	 StopReelTime++;
	 if(StopReelTime == 10)
	 {
		pOwnerLord->Reel->ShowReel(0);
		pOwnerLord->Sounds->Sounds[24]->Stop();
		pOwnerLord->Sounds->PlaySound(23);
		pOwnerLord->Sounds->PlaySound(25);
	 }
	 else if(StopReelTime == 16)
	 {
		pOwnerLord->Reel->ShowReel(1);
		pOwnerLord->Sounds->Sounds[25]->Stop();
		pOwnerLord->Sounds->PlaySound(23);
		pOwnerLord->Sounds->PlaySound(26);
	 }
	 else if(StopReelTime >= 25)
	 {
		WaitOnSpin = false;
		pOwnerLord->Reel->ShowReel(2);
		pOwnerLord->Sounds->Sounds[26]->Stop();
		pOwnerLord->Sounds->PlaySound(23);
		if ((long)pOwnerLord->coinsplayed)
		{                                //????
		  ExecuteWaiting = false;
		  ExecuteStatus = ess_StartSubState1;
		}
		else
		{
		  pOwnerLord->Clear();
		  StopReelTime = 0;
		  Lock = false;
		}
	 }
  }
  if (AddCoinResponder != NULL)
  {
	 if (AddCoinResponder->GetResponseEvent() != reChar)
	 {
		AddCoinResponder->ClearPriority();
	 }
	 AddCoinResponder = NULL;
	 pOwnerLord->BetX(pOwnerLord->coinsize);
	 //if(pOwnerLord->coinsplayed == pOwnerLord->maxbet)
	 //{
	  //	ExecuteWaiting = false;
	  //	ExecuteStatus = ess_StartSubState1;
	// }
	 return;
  }
  if (OneChipResponder != NULL)
  {
	 if (OneChipResponder->GetResponseEvent() != reChar)
	 {
		OneChipResponder->ClearPriority();
	 }
	 OneChipResponder = NULL;pOwnerLord->BetX(1);

	 if(pOwnerLord->coinsplayed == 5)
	 {
		ExecuteWaiting = false;
		ExecuteStatus = ess_StartSubState1;
	 }
	 return;
  }
  if (FiveChipResponder != NULL)
  {
	 if (FiveChipResponder->GetResponseEvent() != reChar)
	 {
		FiveChipResponder->ClearPriority();
	 }
	 FiveChipResponder = NULL;pOwnerLord->BetX(5);

	 if(pOwnerLord->coinsplayed == 5)
	 {
		ExecuteWaiting = false;
		ExecuteStatus = ess_StartSubState1;
	 }
	 return;
  }
  if (TwentyFiveChipResponder != NULL)
  {
	 if (TwentyFiveChipResponder->GetResponseEvent() != reChar)
	 {
		TwentyFiveChipResponder->ClearPriority();
	 }
	 TwentyFiveChipResponder = NULL;
	 pOwnerLord->BetX(25);
	 if(pOwnerLord->coinsplayed == 5)
	 {
		ExecuteWaiting = false;
		ExecuteStatus = ess_StartSubState1;
	 }
	 return;
  }
  if (OneHundredChipResponder != NULL)
  {
	 if (OneHundredChipResponder->GetResponseEvent() != reChar)
	 {
		OneHundredChipResponder->ClearPriority();
	 }
	 OneHundredChipResponder = NULL;
	 pOwnerLord->BetX(100);
	 if(pOwnerLord->coinsplayed == 5)
	 {
		ExecuteWaiting = false;
		ExecuteStatus = ess_StartSubState1;
	 }
	 return;
  }
  if (OneThouChipResponder != NULL)
  {
	 if (OneThouChipResponder->GetResponseEvent() != reChar)
	 {
		OneThouChipResponder->ClearPriority();
	 }
	 OneThouChipResponder = NULL;
	 pOwnerLord->BetX(1000);
	 if(pOwnerLord->coinsplayed == 5)
	 {
		ExecuteWaiting = false;
		ExecuteStatus = ess_StartSubState1;
	 }
	 return;
  }
  if (TenThouChipResponder != NULL)
  {
	 if (TenThouChipResponder->GetResponseEvent() != reChar)
	 {
		TenThouChipResponder->ClearPriority();
	 }
	 TenThouChipResponder = NULL;
	 pOwnerLord->BetX(10000);
	 if(pOwnerLord->coinsplayed == 5)
	 {
		ExecuteWaiting = false;
		ExecuteStatus = ess_StartSubState1;
	 }
	 return;
  }
  if (Bet1Responder != NULL)
  {
	 if (Bet1Responder->GetResponseEvent() != reChar)
	 {
		Bet1Responder->ClearPriority();
	 }
	 Bet1Responder = NULL;
	 pOwnerLord->Bet1();
	 if (pOwnerLord->coinsplayed == pOwnerLord->maxbet)
	 {
		ExecuteWaiting = false;
		ExecuteStatus = ess_StartSubState1;
	 }
	 return;
  }

  if (WaitingOnWRCounter)
  {
	 WaitingOnWRCounter--;
    if (!WaitingOnWRCounter && pOwnerLord->coinsplayed > 0)
	 {
		pOwnerLord->ChangeActivePlayersOk = false;
		pOwnerLord->Spin();
		pOwnerLord->FreezeAllButtons();
		pOwnerLord->Sounds->PlaySound(24);
		WaitOnSpin = true;
		pOwnerLord->Button5->ShowGray();
		pOwnerLord->Button6->ShowGray();
		pOwnerLord->Button4->ShowGray();
		pOwnerLord->shutdownstate = 1;
	 }

  }
}
//*******************************************************************
bool TSAct1State::HandleNamePlate(TResponder &responder)
{
  if(responder.GetResponseEvent() == reLDown)
  {
	 responder.SetPriority();
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_PRESSING_FINGER_CURSOR));
	 return true;
  }
  if ((responder.GetResponseEvent() == reLUp    ) ||
		(responder.GetResponseEvent() == reLDblClk) ||
		(responder.GetResponseEvent() == reChar   )   )
  {
	 if(responder.GetIsPriority())
	 {
		responder.ClearPriority();
	 }
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_POINTING_FINGER_CURSOR));
	 if(responder.Contains(responder.GetPoint()) ||
		 responder.GetResponseEvent() == reChar     )
	 {
		if(pOwnerLord->GetNumActivePlayers() > 1)
		{
		  pOwnerLord->CyclePlayers();
		}
	 }
  }
  return true;
}
//*******************************************************************
bool TSAct1State::HandleAddCoin(TResponder &responder)
{
  if(responder.GetResponseEvent() == reLDown)
  {
	 responder.SetPriority();
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_PRESSING_FINGER_CURSOR));
	 return true;
  }
  if ((responder.GetResponseEvent() == reLUp    ) ||
		(responder.GetResponseEvent() == reLDblClk) ||
		(responder.GetResponseEvent() == reChar   )   )
  {
	 if(responder.GetIsPriority())
	 {
		responder.ClearPriority();
	 }
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_POINTING_FINGER_CURSOR));
	 if(responder.Contains(responder.GetPoint()) ||
		 responder.GetResponseEvent() == reChar     )
	 {
		pOwnerLord->BetX(pOwnerLord->coinsize);
		if(pOwnerLord->maxbet == pOwnerLord->coinsplayed)
		{
		  pOwnerLord->Button5->ShowGray();
		  pOwnerLord->Button6->ShowGray();
		}
	 }
  }
  return true;
}
//*******************************************************************
bool TSAct1State::HandleOneChip(TResponder &responder)
{
  if(responder.GetResponseEvent() == reLDown)
  {
	 responder.SetPriority();
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_PRESSING_FINGER_CURSOR));
	 return true;
  }
  if ((responder.GetResponseEvent() == reLUp    ) ||
		(responder.GetResponseEvent() == reLDblClk) ||
		(responder.GetResponseEvent() == reChar   )   )
  {
	 if(responder.GetIsPriority())
	 {
		responder.ClearPriority();
	 }
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_POINTING_FINGER_CURSOR));
	 if(responder.Contains(responder.GetPoint()) ||
		 responder.GetResponseEvent() == reChar     )
	 {
		pOwnerLord->BetX(1);
		if(pOwnerLord->coinsplayed == 5)
		{
		  ExecuteWaiting = false;
		  ExecuteStatus = ess_StartSubState1;
		}
	 }
  }
  return true;
}
//*******************************************************************
bool TSAct1State::HandleFiveChip(TResponder &responder)
{
  if(responder.GetResponseEvent() == reLDown)
  {
	 responder.SetPriority();
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_PRESSING_FINGER_CURSOR));
	 return true;
  }
  if ((responder.GetResponseEvent() == reLUp    ) ||
		(responder.GetResponseEvent() == reLDblClk) ||
		(responder.GetResponseEvent() == reChar   )   )
  {
	 if(responder.GetIsPriority())
	 {
		responder.ClearPriority();
	 }
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_POINTING_FINGER_CURSOR));
	 if(responder.Contains(responder.GetPoint()) ||
		 responder.GetResponseEvent() == reChar     )
	 {
		pOwnerLord->BetX(5);
		if(pOwnerLord->coinsplayed == 5)
		{
		  ExecuteWaiting = false;
		  ExecuteStatus = ess_StartSubState1;
		}
	 }
  }
  return true;
}
//*******************************************************************
bool TSAct1State::HandleTwentyFiveChip(TResponder &responder)
{
  if(responder.GetResponseEvent() == reLDown)
  {
	 responder.SetPriority();
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_PRESSING_FINGER_CURSOR));
	 return true;
  }
  if ((responder.GetResponseEvent() == reLUp    ) ||
		(responder.GetResponseEvent() == reLDblClk) ||
		(responder.GetResponseEvent() == reChar   )   )
  {
	 if(responder.GetIsPriority())
	 {
		responder.ClearPriority();
	 }
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_POINTING_FINGER_CURSOR));
	 if(responder.Contains(responder.GetPoint()) ||
		 responder.GetResponseEvent() == reChar     )
	 {
		pOwnerLord->BetX(25);
		if(pOwnerLord->coinsplayed == 5)
		{
		  ExecuteWaiting = false;
		  ExecuteStatus = ess_StartSubState1;
		}
	 }
  }
  return true;
}
//*******************************************************************
bool TSAct1State::HandleOneHundredChip(TResponder &responder)
{
  if(responder.GetResponseEvent() == reLDown)
  {
	 responder.SetPriority();
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_PRESSING_FINGER_CURSOR));
	 return true;
  }
  if ((responder.GetResponseEvent() == reLUp    ) ||
		(responder.GetResponseEvent() == reLDblClk) ||
		(responder.GetResponseEvent() == reChar   )   )
  {
	 if(responder.GetIsPriority())
	 {
		responder.ClearPriority();
	 }
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_POINTING_FINGER_CURSOR));
	 if(responder.Contains(responder.GetPoint()) ||
		 responder.GetResponseEvent() == reChar     )
	 {
		pOwnerLord->BetX(100);
		if(pOwnerLord->coinsplayed == 5)
		{
		  ExecuteWaiting = false;
		  ExecuteStatus = ess_StartSubState1;
		}
	 }
  }
  return true;
}
//*******************************************************************
bool TSAct1State::HandleOneThouChip(TResponder &responder)
{
  if(responder.GetResponseEvent() == reLDown)
  {
	 responder.SetPriority();
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_PRESSING_FINGER_CURSOR));
	 return true;
  }
  if ((responder.GetResponseEvent() == reLUp    ) ||
		(responder.GetResponseEvent() == reLDblClk) ||
		(responder.GetResponseEvent() == reChar   )   )
  {
	 if(responder.GetIsPriority())
	 {
		responder.ClearPriority();
	 }
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_POINTING_FINGER_CURSOR));
	 if(responder.Contains(responder.GetPoint()) ||
		 responder.GetResponseEvent() == reChar     )
	 {
		pOwnerLord->BetX(1000);
		if(pOwnerLord->coinsplayed == 5)
		{
		  ExecuteWaiting = false;
		  ExecuteStatus = ess_StartSubState1;
		}
	 }
  }
  return true;
}
//*******************************************************************
bool TSAct1State::HandleTenThouChip(TResponder &responder)
{
  if(responder.GetResponseEvent() == reLDown)
  {
	 responder.SetPriority();
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_PRESSING_FINGER_CURSOR));
	 return true;
  }
  if ((responder.GetResponseEvent() == reLUp    ) ||
		(responder.GetResponseEvent() == reLDblClk) ||
		(responder.GetResponseEvent() == reChar   )   )
  {
	 if(responder.GetIsPriority())
	 {
		responder.ClearPriority();
	 }
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_POINTING_FINGER_CURSOR));
	 if(responder.Contains(responder.GetPoint()) ||
		 responder.GetResponseEvent() == reChar     )
	 {
		pOwnerLord->BetX(10000);
		if(pOwnerLord->coinsplayed == 5)
		{
		  ExecuteWaiting = false;
		  ExecuteStatus = ess_StartSubState1;
		}
	 }
  }
  return true;
}
//*******************************************************************
bool TSAct1State::HandleBet1(TResponder &responder)
{
  if(!Lock)
  {
	if (responder.GetResponseEvent() == reLUp)
	{
	 Bet1Responder = &responder;
	}

	if (responder.GetResponseEvent() == reLDown)
	{
	 responder.SetPriority();
	}

	if (responder.GetResponseEvent() == reChar)
	{
	 Bet1Responder = &responder;
	}
  }
  return true;
}
//*******************************************************************
bool TSAct1State::HandleBetMax(TResponder &responder)
{
  if(!Lock)
  {
	if (responder.GetResponseEvent() == reLUp)
	{
	 BetMaxResponder = &responder;
	}

	if (responder.GetResponseEvent() == reLDown)
	{
	 responder.SetPriority();
	 pOwnerLord->PModeWin->ActivateSpriteNow(2,0);
	}

	if (responder.GetResponseEvent() == reChar)
	{
	 BetMaxResponder = &responder;
	}
  }
  return true;
}
//*******************************************************************
bool TSAct1State::HandleSpin(TResponder &responder)
{
  if (pOwnerLord->coinsplayed != 0 && !Lock)
  {
	 if (responder.GetResponseEvent() == reLUp)
	 {
		Lock = true;
		SpinResponder = &responder;
		pOwnerLord->Spin();
	 }

	 if (responder.GetResponseEvent() == reLDown)
	 {
		responder.SetPriority();
	 }

	 if (responder.GetResponseEvent() == reChar)
	 {
		SpinResponder = &responder;
	 }
  }
  return true;
}
//*******************************************************************
bool TSAct1State::HandleMenuEsc(TResponder &responder)
{
	if (responder.GetResponseEvent() == reLUp)
  {
	 MenuEscResponder = &responder;
  }

  if (responder.GetResponseEvent() == reLDown)
  {
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
	 MenuEscResponder = &responder;
  }

  return true;
}
//*******************************************************************
bool TSAct1State::HandleAskExpert(TResponder &responder)
{
  if(!Lock)
  {
	if (responder.GetResponseEvent() == reLUp)
	{
	 AskExpertResponder = &responder;
	}

	if (responder.GetResponseEvent() == reLDown)
	{
	 responder.SetPriority();
	}

	if (responder.GetResponseEvent() == reChar)
	{
	 AskExpertResponder = &responder;
	}
  }
  return true;
}
//*******************************************************************
bool TSAct1State::HandleCashOut(TResponder &responder)
{
  if(pOwnerLord->credits > 0 && !Lock)
  {
	 if (responder.GetResponseEvent() == reLUp)
	 {
		CashOutResponder = &responder;
	 }

	 if (responder.GetResponseEvent() == reLDown)
	 {
		responder.SetPriority();
	 }

	 if (responder.GetResponseEvent() == reChar)
	 {
		CashOutResponder = &responder;
	 }
  }
  return true;
}
//*******************************************************************
