//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  sact2st.cpp
//    Project Name:  Casino
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     06/29/95   A. Krist    Original baseline
//  2.0     09/25/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "sact2st.h"
#include "csglord.h"
#include "swinst.h"
//#include "otimers.h"
#include "orespond.h"
//*******************************************************************
TSAct2State::TSAct2State(TCasinoSGameLord *pNewSLord)
:TSLordState(pNewSLord)
{
  SetRunOrder(ess_Execute,ess_StartSubState2,ess_Done);
  AskExpertResponder = NULL;
  MenuEscResponder = NULL;
  askexpertflag = false;
}
//*******************************************************************
TSAct2State::~TSAct2State()
{
}
//*******************************************************************
void TSAct2State::ExecuteFirstTime()
{
  ExecuteWaiting = true;
  ExecuteStatus    = ess_Execute;
}
//*******************************************************************
void TSAct2State::CreateSubState1()
{
  //PActiveSubState = new TSDrawState(pOwnerLord);
}
//*******************************************************************
void TSAct2State::CreateSubState2()
{
  PActiveSubState = new TSWinState(pOwnerLord);
}
//*******************************************************************
void TSAct2State::HandlePostUpdate(dword NewFUC)
{
  if(MenuEscResponder != NULL)
  {
	 if (MenuEscResponder->GetResponseEvent() != reChar)
	 {
		MenuEscResponder->ClearPriority();
	 }
	 MenuEscResponder = NULL;

	 return;
  }
  if(AskExpertResponder != NULL)
  {
	 if(!askexpertflag)
	 {
		if (AskExpertResponder->GetResponseEvent() != reChar)
		{
		  AskExpertResponder->ClearPriority();
		}
		askexpertflag = true;
	 }
	 else
	 {
		AskExpertResponder = NULL;
		askexpertflag = false;
	 }
	 return;
  }
  if(NewFUC){return;}
}
//*******************************************************************
bool TSAct2State::HandleMenuEsc(TResponder &responder)
{
	if (responder.GetResponseEvent() == reLUp)
  {
	 MenuEscResponder = &responder;
  }

  if (responder.GetResponseEvent() == reLDown)
  {
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
	 MenuEscResponder = &responder;
  }

  return true;
}
//*******************************************************************
bool TSAct2State::HandleAskExpert(TResponder &responder)
{
	if (responder.GetResponseEvent() == reLUp)
  {
	 AskExpertResponder = &responder;
  }

  if (responder.GetResponseEvent() == reLDown)
  {
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
	 AskExpertResponder = &responder;
  }

  return true;
}
//*******************************************************************
