//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  scoutst.cpp
//    Project Name:  Casino
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     09/29/95   A. Krist    Original baseline
//  2.0     09/25/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "scoutst.h"
#include "csplay.h"
#include "cassmw.h"
#include "orespond.h"
#include "owav.h"
#include "oanm.h"
//*******************************************************************
TSCashOutState::TSCashOutState(TCasinoSGameLord *pNewSLord)
:TSLordState(pNewSLord)
{
  SpeedClickResponder = NULL;
  Count = 0;
  Start16 = false;
}
//*******************************************************************
TSCashOutState::~TSCashOutState()
{
}
//*******************************************************************
void TSCashOutState::ExecuteFirstTime()
{
  ExecuteWaiting = true;
  ExecuteStatus    = ess_Execute;
  pOwnerLord->CashOut();
  if(pOwnerLord->credits > 0)
  {
	 switch((int32)pOwnerLord->credits)
	 {
		case 1  : pOwnerLord->Sounds->PlaySound(11);break;
		case 2  : pOwnerLord->Sounds->PlaySound(12);break;
		case 3  : pOwnerLord->Sounds->PlaySound(13);break;
		case 4  : pOwnerLord->Sounds->PlaySound(14);break;
		case 5  : pOwnerLord->Sounds->PlaySound(15);break;
		default : pOwnerLord->Sounds->PlaySound(16);Start16 = true;break;
	 }
  }
}
//*******************************************************************
void TSCashOutState::HandlePostUpdate(dword NewFUC)
{
  if (SpeedClickResponder != NULL)
  {
	 if (SpeedClickResponder->GetResponseEvent() != reChar)
	 {
		SpeedClickResponder->ClearPriority();
	 }
	 if (pOwnerLord->credits > 0)
	 {
		pOwnerLord->CoinPay->SetTray(pOwnerLord->credits-1+Count);
		pOwnerLord->AddCash(pOwnerLord->activeplayer,pOwnerLord->coinsize*pOwnerLord->credits);
		pOwnerLord->credits = 0;
		pOwnerLord->Chips->SetNum(pOwnerLord->GetCash(pOwnerLord->activeplayer));
		pOwnerLord->Credits->SetNum(pOwnerLord->credits);
		pOwnerLord->Sounds->Sounds[11]->Stop();
		pOwnerLord->Sounds->Sounds[12]->Stop();
		pOwnerLord->Sounds->Sounds[13]->Stop();
		pOwnerLord->Sounds->Sounds[14]->Stop();
		pOwnerLord->Sounds->Sounds[15]->Stop();
		pOwnerLord->Sounds->Sounds[16]->Stop();
	 }
	 SpeedClickResponder = NULL;
	 ExecuteWaiting = false;
	 pOwnerLord->Sounds->PlaySound(27);
	 return;
  }

  if (pOwnerLord->credits > 0)
  {
	 Count++;
	 pOwnerLord->CoinPay->SetTray(int16(Count-1));
	 if(pOwnerLord->Sounds->Sounds[16]->GetStopped() && Start16)
	 {
		pOwnerLord->Sounds->PlaySound(16);
	 }
	 if(pOwnerLord->CoinPay->PCoinPay->CAD.GetCurrentFrame() == 98 && Start16)
	 {
		pOwnerLord->Sounds->Sounds[16]->Stop();
		Start16 = false;
	 }
	 pOwnerLord->credits--;
	 pOwnerLord->AddCash(pOwnerLord->activeplayer,pOwnerLord->coinsize);
	 pOwnerLord->Credits->SetNum(pOwnerLord->credits);
  }
  else
  {
	 pOwnerLord->Sounds->Sounds[11]->Stop();
	 pOwnerLord->Sounds->Sounds[12]->Stop();
	 pOwnerLord->Sounds->Sounds[13]->Stop();
	 pOwnerLord->Sounds->Sounds[14]->Stop();
	 pOwnerLord->Sounds->Sounds[15]->Stop();
	 pOwnerLord->Sounds->Sounds[16]->Stop();
	 ExecuteWaiting = false;
	 pOwnerLord->Sounds->PlaySound(27);
  }
  if(NewFUC){return;}
}
//*******************************************************************
bool TSCashOutState::HandleSpeedClick(TResponder &responder)
{
  if (responder.GetResponseEvent() == reRUp)
  {
	 SpeedClickResponder = &responder;
  }

  if (responder.GetResponseEvent() == reRDown)
  {
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
	 SpeedClickResponder = &responder;
  }
  return true;
}

//*******************************************************************
