//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  vplordst.cpp
//    Project Name:  Ogle
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     06/01/95   A. Krist    Original baseline
//  2.0     09/25/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "slordst.h"
#include "csglord.h"
//*******************************************************************
TSLordState::TSLordState(TCasinoSGameLord *pNewSLord)
{
  pOwnerLord = pNewSLord;
}
//*******************************************************************
TSLordState::~TSLordState()
{
}
//*******************************************************************
void TSLordState::HandleUpdate(dword NewFUC)
{
//  if (pOwnerLord->SubGameType == cslAlladinsLamp && pOwnerLord->GameDenom == cd1)
  if (pOwnerLord->SubGameType == cslAlladinsLamp &&
      pOwnerLord->GetDenomID() == TMoney::did_1_00)
  {
	if(NewFUC%3600 == 0)
	{
	  if(random(300) == 1) {pOwnerLord->progressive = 4000;}
	}
	if(pOwnerLord->progressive >= 99995l) {pOwnerLord->progressive = 4000;}
	pOwnerLord->Progressive->SetNum(pOwnerLord->progressive);
	pOwnerLord->progressive = pOwnerLord->Progressive->GetNum();;
  }
}
//*******************************************************************
bool TSLordState::NamePlate(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TSLordState *)PActiveSubState)->NamePlate(responder);
  }
  else
  {
	 return HandleNamePlate(responder);
  }
}
//*******************************************************************
bool TSLordState::OneChip(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TSLordState *)PActiveSubState)->OneChip(responder);
  }
  else
  {
	 return HandleOneChip(responder);
  }
}
//*******************************************************************
bool TSLordState::FiveChip(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TSLordState *)PActiveSubState)->FiveChip(responder);
  }
  else
  {
	 return HandleFiveChip(responder);
  }
}
//*******************************************************************
bool TSLordState::TwentyFiveChip(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TSLordState *)PActiveSubState)->TwentyFiveChip(responder);
  }
  else
  {
	 return HandleTwentyFiveChip(responder);
  }
}
//*******************************************************************
bool TSLordState::OneHundredChip(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TSLordState *)PActiveSubState)->OneHundredChip(responder);
  }
  else
  {
	 return HandleOneHundredChip(responder);
  }
}
//*******************************************************************
bool TSLordState::OneThouChip(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TSLordState *)PActiveSubState)->OneThouChip(responder);
  }
  else
  {
	 return HandleOneThouChip(responder);
  }
}
//*******************************************************************
bool TSLordState::TenThouChip(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TSLordState *)PActiveSubState)->TenThouChip(responder);
  }
  else
  {
	 return HandleTenThouChip(responder);
  }
}
//*******************************************************************
bool TSLordState::StatBar(TResponder &responder)
{
  return HandleStatBar(responder);
}
//*******************************************************************
bool TSLordState::Bet1Button(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TSLordState *)PActiveSubState)->Bet1Button(responder);
  }
  else
  {
	 return HandleBet1(responder);
  }
}
//*******************************************************************
bool TSLordState::MenuEscButton(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TSLordState *)PActiveSubState)->MenuEscButton(responder);
  }
  else
  {
	 return HandleMenuEsc(responder);
  }
}
//*******************************************************************
bool TSLordState::SpeedClick(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TSLordState *)PActiveSubState)->SpeedClick(responder);
  }
  else
  {
	 return HandleSpeedClick(responder);
  }
}
//*******************************************************************
bool TSLordState::BetMaxButton(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TSLordState *)PActiveSubState)->BetMaxButton(responder);
  }
  else
  {
	 return HandleBetMax(responder);
  }
}
//*******************************************************************
bool TSLordState::CashOut(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TSLordState *)PActiveSubState)->CashOut(responder);
  }
  else
  {
	 return HandleCashOut(responder);
  }
}
//*******************************************************************
bool TSLordState::Spin(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TSLordState *)PActiveSubState)->Spin(responder);
  }
  else
  {
	 return HandleSpin(responder);
  }
}
//*******************************************************************
bool TSLordState::AddCoin(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TSLordState *)PActiveSubState)->AddCoin(responder);
  }
  else
  {
	 return HandleAddCoin(responder);
  }
}
//*******************************************************************
bool TSLordState::AskExpert(TResponder &responder)
{
  if (Status != ss_Running) {return true;}

  if (PActiveSubState != NULL)
  {
	 return ((TSLordState *)PActiveSubState)->HandleAskExpert(responder);
  }
  else
  {
	 return HandleAskExpert(responder);
  }
}
//*******************************************************************
#pragma argsused
bool TSLordState::HandleOneChip(TResponder &responder)
{
  return true;
}
//*******************************************************************
#pragma argsused
bool TSLordState::HandleFiveChip(TResponder &responder)
{
  return true;
}
//*******************************************************************
#pragma argsused
bool TSLordState::HandleTwentyFiveChip(TResponder &responder)
{
  return true;
}
//*******************************************************************
#pragma argsused
bool TSLordState::HandleOneHundredChip(TResponder &responder)
{
  return true;
}
//*******************************************************************
#pragma argsused
bool TSLordState::HandleOneThouChip(TResponder &responder)
{
  return true;
}
//*******************************************************************
#pragma argsused
bool TSLordState::HandleTenThouChip(TResponder &responder)
{
  return true;
}
//*******************************************************************
#pragma argsused
bool TSLordState::HandleSpeedClick(TResponder &responder)
{
  return false;
}
//*******************************************************************
#pragma argsused
bool TSLordState::HandleMenuEsc(TResponder &responder)
{
  return true;
}
//*******************************************************************
#pragma argsused
bool TSLordState::HandleBet1(TResponder &responder)
{
  return true;
}
//*******************************************************************
#pragma argsused
bool TSLordState::HandleBetMax(TResponder &responder)
{
  return true;
}
//*******************************************************************
#pragma argsused
bool TSLordState::HandleCashOut(TResponder &responder)
{
  return true;
}
//*******************************************************************
#pragma argsused
bool TSLordState::HandleSpin(TResponder &responder)
{
  return true;
}
//*******************************************************************
#pragma argsused
bool TSLordState::HandleAddCoin(TResponder &responder)
{
  return true;
}
//*******************************************************************
#pragma argsused
bool TSLordState::HandleAskExpert(TResponder &responder)
{
  return true;
}
//*******************************************************************
#pragma argsused
bool TSLordState::HandleStatBar(TResponder &responder)
{
  return true;
}
//*******************************************************************
#pragma argsused
bool TSLordState::HandleNamePlate(TResponder &responder)
{
  return true;
}
//*******************************************************************

