//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  cccalc.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     9/6/96     M.Perry     derived from Dave's code.
//  2.0    09/17/97    M.Perry     32-bit conversion.
//********************************************************************
#include "cccalc.h"
#include "cstatdlg.h"
#include <stdio.h>
#include <classlib\time.h>

//*******************************************************************
bool TStatCalcCraps::GetValues(int statindex,float *values,int maxvalues)
{
  int num = GetMaxValueIndex(maxvalues);
  switch (statindex)
  {
    case cTotalNumBets          :return GetTotalNumBets(values,num);
    case cTotalCashBets         :return GetTotalCashBets(values,num);
    case cAvgCashBet            :return GetAvgCashBets(values,num);
    case cTotalCashWL           :return GetTotalCashWL(values,num);
    case cCumCashWL             :return GetTotalCashWL(values,num);
    case cPeakCashWinLevel      :return GetPeakWinLevel(values,num);
    case cLowCashLossLevel      :return GetLowCashLostLevel(values,num);
    case cNumPassWins           :return GetNumPassWins(values,num);
    case cNumNaturals           :return GetNumNaturals(values,num);
    case cNumPtsMade            :return GetNumPtsMade(values,num);
    case cNumDontPassWins       :return GetNumDontPassWins(values,num);
    case cNumCrapOuts           :return GetNumCrapOuts(values,num);
    case cNum7Outs              :return GetNum7Outs(values,num);
    case cLongestShoot          :return GetLongestShoot(values,num);
    case cLongestPassStreak     :return GetLongestPassStreak(values,num);
    case cLongestDontPassStreak :return GetLongestDontPassStreak(values,num);
    default                     :return false;
  };
//  return false;
}
//*******************************************************************
bool TStatCalcCraps::GetNumPassWins(float *values,int num)
{
  for (int i=0;i<num;i++)
  {
    values[i] = GetCSession(i)->Numpasswins;
  }
  return true;
}
//*******************************************************************
bool TStatCalcCraps::GetNumNaturals(float *values,int num)
{
  for (int i=0;i<num;i++)
  {
    values[i] = GetCSession(i)->Numnaturals;
  }
  return true;
}
//*******************************************************************
bool TStatCalcCraps::GetNumPtsMade(float *values,int num)
{
  for (int i=0;i<num;i++)
  {
    values[i] = GetCSession(i)->Numpointsmade;
  }
  return true;
}
//*******************************************************************
bool TStatCalcCraps::GetNumDontPassWins(float *values,int num)
{
  for (int i=0;i<num;i++)
  {
    values[i] = GetCSession(i)->Numdontpasswins;
  }
  return true;
}
//*******************************************************************
bool TStatCalcCraps::GetNumCrapOuts(float *values,int num)
{
  for (int i=0;i<num;i++)
  {
    values[i] = GetCSession(i)->Numcrapouts;
  }
  return true;
}
//*******************************************************************
bool TStatCalcCraps::GetNum7Outs(float *values,int num)
{
  for (int i=0;i<num;i++)
  {
    values[i] = GetCSession(i)->Numsevenouts;
  }
  return true;
}
//*******************************************************************
bool TStatCalcCraps::GetLongestShoot(float *values,int num)
{
  for (int i=0;i<num;i++)
  {
    values[i] = GetCSession(i)->LongestShootNumRolls;
  }
  return true;
}
//*******************************************************************
bool TStatCalcCraps::GetLongestPassStreak(float *values,int num)
{
  for (int i=0;i<num;i++)
  {
    values[i] = GetCSession(i)->LongestPassStreak;
  }
  return true;
}
//*******************************************************************
bool TStatCalcCraps::GetLongestDontPassStreak(float *values,int num)
{
  for (int i=0;i<num;i++)
  {
    values[i] = GetCSession(i)->LongestDontPassStreak;
  }
  return true;
}
//*******************************************************************
#pragma argsused
string TStatCalcCraps::MakeSubGameTypeStr(int subgametype,TMoney gamedenom)
{
  string s = "Craps";
  return s;
}
//*******************************************************************
void TStatCalcCraps::Calc_TotalNumBets()
{
  Total_TotalNumBets = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
    TotalNumBets[i] = GetCSession(i)->Wins + GetCSession(i)->Losses;
    Total_TotalNumBets += TotalNumBets[i];
  }
}
//*******************************************************************
void TStatCalcCraps::Make_CumulativeCashWLStrs()
{
  // use TotalCasWL
}
//*******************************************************************
void TStatCalcCraps::Calc_CumulativeCashWL()
{
  // same as TotalCashWL
}
//*******************************************************************
void TStatCalcCraps::Make_TotalShootsStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    TotalShootsStr[i] = MakeString(GetCSession(i)->TotalShoots);
  }
  Total_TotalShootsStr = MakeString(Total_TotalShoots);
}
//*******************************************************************
void TStatCalcCraps::Calc_TotalShoots()
{
  Total_TotalShoots = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
    Total_TotalShoots += GetCSession(i)->TotalShoots;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_NumPassWinsStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    NumPassWinsStr[i] = MakeString(GetCSession(i)->Numpasswins);
  }
  Total_NumPassWinsStr = MakeString(Total_NumPassWins);
}
//*******************************************************************
void TStatCalcCraps::Calc_NumPassWins()
{
  Total_NumPassWins = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
    Total_NumPassWins += GetCSession(i)->Numpasswins;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_NumNaturalsStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    NumNaturalsStr[i] = MakeString(GetCSession(i)->Numnaturals);
  }
  Total_NumNaturalsStr = MakeString(Total_NumNaturals);
}
//*******************************************************************
void TStatCalcCraps::Calc_NumNaturals()
{
  Total_NumNaturals = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
    Total_NumNaturals += GetCSession(i)->Numnaturals;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_NumPtsMadeStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    NumPtsMadeStr[i] = MakeString(GetCSession(i)->Numpointsmade);
  }
  Total_NumPtsMadeStr = MakeString(Total_NumPtsMade);
}
//*******************************************************************
void TStatCalcCraps::Calc_NumPtsMade()
{
  Total_NumPtsMade = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
    Total_NumPtsMade += GetCSession(i)->Numpointsmade;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_NumDontPassWinsStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    NumDontPassWinsStr[i] = MakeString(GetCSession(i)->Numdontpasswins);
  }
  Total_NumDontPassWinsStr = MakeString(Total_NumDontPassWins);
}
//*******************************************************************
void TStatCalcCraps::Calc_NumDontPassWins()
{
  Total_NumDontPassWins = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
    Total_NumDontPassWins += GetCSession(i)->Numdontpasswins;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_NumCrapOutsStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    NumCrapOutsStr[i] = MakeString(GetCSession(i)->Numcrapouts);
  }
  Total_NumCrapOutsStr = MakeString(Total_NumCrapOuts);
}
//*******************************************************************
void TStatCalcCraps::Calc_NumCrapOuts()
{
  Total_NumCrapOuts = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
    Total_NumCrapOuts += GetCSession(i)->Numcrapouts;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_Num7OutsStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    Num7OutsStr[i] = MakeString(GetCSession(i)->Numsevenouts);
  }
  Total_Num7OutsStr = MakeString(Total_Num7Outs);
}
//*******************************************************************
void TStatCalcCraps::Calc_Num7Outs()
{
  Total_Num7Outs = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
    Total_Num7Outs += GetCSession(i)->Numsevenouts;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_LongestShootStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    LongestShootStr[i] = MakeString(GetCSession(i)->LongestShootNumRolls);
  }
  Total_LongestShootStr = MakeString(Total_LongestShoot);
}
//*******************************************************************
void TStatCalcCraps::Calc_LongestShoot()
{
  Total_LongestShoot = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
    Total_LongestShoot = max(GetCSession(i)->LongestShootNumRolls,Total_LongestShoot);
  }
}
//*******************************************************************
void TStatCalcCraps::Make_LongestPassStreakStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    LongestPassStreakStr[i] = MakeString(GetCSession(i)->LongestPassStreak);
  }
  Total_LongestPassStreakStr = MakeString(Total_LongestPassStreak);
}
//*******************************************************************
void TStatCalcCraps::Calc_LongestPassStreak()
{
  Total_LongestPassStreak = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
    Total_LongestPassStreak = max(GetCSession(i)->LongestPassStreak,Total_LongestPassStreak);
  }
}
//*******************************************************************
void TStatCalcCraps::Make_LongestDontPassStreakStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    LongestDontPassStreakStr[i] = MakeString(GetCSession(i)->LongestDontPassStreak);
  }
  Total_LongestDontPassStreakStr = MakeString(Total_LongestDontPassStreak);
}
//*******************************************************************
void TStatCalcCraps::Calc_LongestDontPassStreak()
{
  Total_LongestDontPassStreak = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
    Total_LongestDontPassStreak = max(GetCSession(i)->LongestDontPassStreak,
                                      Total_LongestDontPassStreak);
  }
}
//*******************************************************************
void TStatCalcCraps::Make_NumShootsBetRightStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    NumShootsBetRightStr[i] = MakeString(GetCSession(i)->NumShootsBettingRight);
  }
  Total_NumShootsBetRightStr = MakeString(Total_NumShootsBetRight);
}
//*******************************************************************
void TStatCalcCraps::Calc_NumShootsBetRight()
{
  Total_NumShootsBetRight = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
	 Total_NumShootsBetRight += GetCSession(i)->NumShootsBettingRight;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_TotalCashBetRBStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
	 TotalCashBetRBStr[i] = MakeString(GetCSession(i)->TotalCashBetRightBettor);
  }
  Total_TotalCashBetRBStr = MakeString(Total_TotalCashBetRB);
}
//*******************************************************************
void TStatCalcCraps::Calc_TotalCashBetRB()
{
  Total_TotalCashBetRB = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
	 Total_TotalCashBetRB += GetCSession(i)->TotalCashBetRightBettor;
  }
}                                    
//*******************************************************************
void TStatCalcCraps::Make_AvgCashBetPerShootRBStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
	 AvgCashBetPerShootRBStr[i] = MakeString(GetAvg(GetCSession(i)->TotalCashBetRightBettor,GetCSession(i)->NumShootsBettingRight));
  }
  Total_AvgCashBetPerShootRBStr = MakeString(Total_AvgCashBetPerShootRB);
}
//*******************************************************************
void TStatCalcCraps::Calc_AvgCashBetPerShootRB()
{
  Total_AvgCashBetPerShootRB = GetAvg(Total_TotalCashBetRB,Total_NumShootsBetRight);
}
//*******************************************************************
void TStatCalcCraps::Make_NumShootsWonCashRBStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
	 NumShootsWonCashRBStr[i] = MakeString(GetCSession(i)->NumShootsWonCashRightBettor);
  }
  Total_NumShootsWonCashRBStr = MakeString(Total_NumShootsWonCashRB);
}
//*******************************************************************
void TStatCalcCraps::Calc_NumShootsWonCashRB()
{
  Total_NumShootsWonCashRB = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
	 Total_NumShootsWonCashRB += GetCSession(i)->NumShootsWonCashRightBettor;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_NumShootsLostCashRBStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
	 NumShootsLostCashRBStr[i] = MakeString(GetCSession(i)->NumShootsLostCashRightBettor);
  }
  Total_NumShootsLostCashRBStr = MakeString(Total_NumShootsLostCashRB);
}
//*******************************************************************
void TStatCalcCraps::Calc_NumShootsLostCashRB()
{
  Total_NumShootsLostCashRB = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
	 Total_NumShootsLostCashRB += GetCSession(i)->NumShootsLostCashRightBettor;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_TotalCashWLRBStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
	 TotalCashWLRBStr[i] = MakeString(GetCSession(i)->TotalCashWonLostRightBettor);
  }
  Total_TotalCashWLRBStr = MakeString(Total_TotalCashWLRB);
}
//*******************************************************************
void TStatCalcCraps::Calc_TotalCashWLRB()
{
  Total_TotalCashWLRB = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
	 Total_TotalCashWLRB += GetCSession(i)->TotalCashWonLostRightBettor;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_AvgCashWLPerShootRBStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
	 AvgCashWLPerShootRBStr[i] = MakeString(GetAvg(GetCSession(i)->TotalCashWonLostRightBettor,GetCSession(i)->NumShootsBettingRight));
  }
  Total_AvgCashWLPerShootRBStr = MakeString(Total_AvgCashWLPerShootRB);
}
//*******************************************************************
void TStatCalcCraps::Calc_AvgCashWLPerShootRB()
{
  Total_AvgCashWLPerShootRB = GetAvg(Total_TotalCashWLRB,Total_NumShootsBetRight);
}
//*******************************************************************
void TStatCalcCraps::Make_LongestWinStreakRBStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
	 LongestWinStreakRBStr[i] = MakeString(GetCSession(i)->LongestWinStreakRightBettor);
  }
  Total_LongestWinStreakRBStr = MakeString(Total_LongestWinStreakRB);
}
//*******************************************************************
void TStatCalcCraps::Calc_LongestWinStreakRB()
{
  Total_LongestWinStreakRB = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
	 Total_LongestWinStreakRB = max(GetCSession(i)->LongestWinStreakRightBettor,
											  Total_LongestWinStreakRB);
  }
}
//*******************************************************************
void TStatCalcCraps::Make_MostCashWon1ShootRBStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
	 MostCashWon1ShootRBStr[i] = MakeString(GetCSession(i)->MostCashWon1ShootRightBettor);
  }
  Total_MostCashWon1ShootRBStr = MakeString(Total_MostCashWon1ShootRB);
}
//*******************************************************************
void TStatCalcCraps::Calc_MostCashWon1ShootRB()
{
  Total_MostCashWon1ShootRB = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
	 Total_MostCashWon1ShootRB = max(GetCSession(i)->MostCashWon1ShootRightBettor,
												Total_MostCashWon1ShootRB);
  }
}
//*******************************************************************
void TStatCalcCraps::Make_MostCashLost1ShootRBStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
	 MostCashLost1ShootRBStr[i] = MakeString(GetCSession(i)->MostCashLost1ShootRightBettor);
  }
  Total_MostCashLost1ShootRBStr = MakeString(Total_MostCashLost1ShootRB);
}
//*******************************************************************
void TStatCalcCraps::Calc_MostCashLost1ShootRB()
{
  Total_MostCashLost1ShootRB = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
	 Total_MostCashLost1ShootRB = min(GetCSession(i)->MostCashLost1ShootRightBettor,
												 Total_MostCashLost1ShootRB);
  }
}
//*******************************************************************
void TStatCalcCraps::Make_NumShootsBetWrongStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
	 NumShootsBetWrongStr[i] = MakeString(GetCSession(i)->NumShootsBettingWrong);
  }
  Total_NumShootsBetWrongStr = MakeString(Total_NumShootsBetWrong);
}
//*******************************************************************
void TStatCalcCraps::Calc_NumShootsBetWrong()
{
  Total_NumShootsBetWrong = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
	 Total_NumShootsBetWrong += GetCSession(i)->NumShootsBettingWrong;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_TotalCashBetWBStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
	 TotalCashBetWBStr[i] = MakeString(GetCSession(i)->TotalCashBetWrongBettor);
  }
  Total_TotalCashBetWBStr = MakeString(Total_TotalCashBetWB);
}
//*******************************************************************
void TStatCalcCraps::Calc_TotalCashBetWB()
{
  Total_TotalCashBetWB = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
	 Total_TotalCashBetWB += GetCSession(i)->TotalCashBetWrongBettor;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_AvgCashBetPerShootWBStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
	 AvgCashBetPerShootWBStr[i] = MakeString(GetAvg(GetCSession(i)->TotalCashBetWrongBettor,GetCSession(i)->NumShootsBettingWrong));
  }
  Total_AvgCashBetPerShootWBStr = MakeString(Total_AvgCashBetPerShootWB);
}
//*******************************************************************
void TStatCalcCraps::Calc_AvgCashBetPerShootWB()
{
  Total_AvgCashBetPerShootWB = GetAvg(Total_TotalCashBetWB,Total_NumShootsBetWrong);
}
//*******************************************************************
void TStatCalcCraps::Make_NumShootsWonCashWBStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
	 NumShootsWonCashWBStr[i] = MakeString(GetCSession(i)->NumShootsThatWonCashWrongBettor);
  }
  Total_NumShootsWonCashWBStr = MakeString(Total_NumShootsWonCashWB);
}
//*******************************************************************
void TStatCalcCraps::Calc_NumShootsWonCashWB()
{
  Total_NumShootsWonCashWB = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
	 Total_NumShootsWonCashWB += GetCSession(i)->NumShootsThatWonCashWrongBettor;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_NumShootsLostCashWBStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
	 NumShootsLostCashWBStr[i] = MakeString(GetCSession(i)->NumShootsThatLostCashWrongBettor);
  }
  Total_NumShootsLostCashWBStr = MakeString(Total_NumShootsLostCashWB);
}
//*******************************************************************
void TStatCalcCraps::Calc_NumShootsLostCashWB()
{
  Total_NumShootsLostCashWB = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
	 Total_NumShootsLostCashWB += GetCSession(i)->NumShootsThatLostCashWrongBettor;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_TotalCashWLWBStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
	 TotalCashWLWBStr[i] = MakeString(GetCSession(i)->TotalCashWonLostWrongBettor);
  }
  Total_TotalCashWLWBStr = MakeString(Total_TotalCashWLWB);
}
//*******************************************************************
void TStatCalcCraps::Calc_TotalCashWLWB()
{
  Total_TotalCashWLWB = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
	 Total_TotalCashWLWB += GetCSession(i)->TotalCashWonLostWrongBettor;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_AvgCashWLPerShootWBStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
	 AvgCashWLPerShootWBStr[i] = MakeString(GetAvg(GetCSession(i)->TotalCashWonLostWrongBettor,GetCSession(i)->NumShootsBettingWrong));
  }
  Total_AvgCashWLPerShootWBStr = MakeString(Total_AvgCashWLPerShootWB);
}
//*******************************************************************
void TStatCalcCraps::Calc_AvgCashWLPerShootWB()
{
  Total_AvgCashWLPerShootWB = GetAvg(Total_TotalCashWLWB,Total_NumShootsBetWrong);
}
//*******************************************************************
void TStatCalcCraps::Make_LongestWinStreakWBStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    LongestWinStreakWBStr[i] = MakeString(GetCSession(i)->LongestWinStreakWrongBettor);
  }
  Total_LongestWinStreakWBStr = MakeString(Total_LongestWinStreakWB);
}
//*******************************************************************
void TStatCalcCraps::Calc_LongestWinStreakWB()
{
  Total_LongestWinStreakWB = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
    Total_LongestWinStreakWB =  max(GetCSession(i)->LongestWinStreakWrongBettor,
                                    Total_LongestWinStreakWB);
  }
}
//*******************************************************************
void TStatCalcCraps::Make_MostCashWon1ShootWBStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    MostCashWon1ShootWBStr[i] = MakeString(GetCSession(i)->MostCashWon1ShootWrongBettor);
  }
  Total_MostCashWon1ShootWBStr = MakeString(Total_MostCashWon1ShootWB);
}
//*******************************************************************
void TStatCalcCraps::Calc_MostCashWon1ShootWB()
{
  Total_MostCashWon1ShootWB = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
    Total_MostCashWon1ShootWB = max(GetCSession(i)->MostCashWon1ShootWrongBettor,
                                    Total_MostCashWon1ShootWB);
  }
}
//*******************************************************************
void TStatCalcCraps::Make_MostCashLost1ShootWBStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    MostCashLost1ShootWBStr[i] = MakeString(GetCSession(i)->MostCashLost1ShootWrongBettor);
  }
  Total_MostCashLost1ShootWBStr = MakeString(Total_MostCashLost1ShootWB);
}
//*******************************************************************
void TStatCalcCraps::Calc_MostCashLost1ShootWB()
{
  Total_MostCashLost1ShootWB = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
    Total_MostCashLost1ShootWB = min(GetCSession(i)->MostCashLost1ShootWrongBettor,
                                     Total_MostCashLost1ShootWB);
  }
}
//*******************************************************************
void TStatCalcCraps::Make_PassBetsCashStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    PassBetsCashStr[i] = MakeString(GetCSession(i)->PassBetsCash);
  }
  Total_PassBetsCashStr = MakeString(Total_PassBetsCash);
}
//*******************************************************************
void TStatCalcCraps::Calc_PassBetsCash()
{
  Total_PassBetsCash = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
    Total_PassBetsCash += GetCSession(i)->PassBetsCash;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_PassFreeOddsBetsCashStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    PassFreeOddsBetsCashStr[i] = MakeString(GetCSession(i)->PassFreeOddsBetsCash);
  }
  Total_PassFreeOddsBetsCashStr = MakeString(Total_PassFreeOddsBetsCash);
}
//*******************************************************************
void TStatCalcCraps::Calc_PassFreeOddsBetsCash()
{
  Total_PassFreeOddsBetsCash = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
    Total_PassFreeOddsBetsCash += GetCSession(i)->PassFreeOddsBetsCash;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_DontPassBetsCashStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    DontPassBetsCashStr[i] = MakeString(GetCSession(i)->DontPassBetsCash);
  }
  Total_DontPassBetsCashStr = MakeString(Total_DontPassBetsCash);
}
//*******************************************************************
void TStatCalcCraps::Calc_DontPassBetsCash()
{
  Total_DontPassBetsCash = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
    Total_DontPassBetsCash += GetCSession(i)->DontPassBetsCash;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_DontPassFreeOddsBetsCashStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    DontPassFreeOddsBetsCashStr[i] = MakeString(GetCSession(i)->DontPassFreeOddsBetsCash);
  }
  Total_DontPassFreeOddsBetsCashStr = MakeString(Total_DontPassFreeOddsBetsCash);
}
//*******************************************************************
void TStatCalcCraps::Calc_DontPassFreeOddsBetsCash()
{
  Total_DontPassFreeOddsBetsCash = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
    Total_DontPassFreeOddsBetsCash += GetCSession(i)->DontPassFreeOddsBetsCash;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_ComeBetsCashStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    ComeBetsCashStr[i] = MakeString(GetCSession(i)->ComeBetsCash);
  }
  Total_ComeBetsCashStr = MakeString(Total_ComeBetsCash);
}
//*******************************************************************
void TStatCalcCraps::Calc_ComeBetsCash()
{
  Total_ComeBetsCash = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
    Total_ComeBetsCash += GetCSession(i)->ComeBetsCash;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_ComeFreeOddsBetsCashStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    ComeFreeOddsBetsCashStr[i] = MakeString(GetCSession(i)->ComeFreeOddsBetsCash);
  }
  Total_ComeFreeOddsBetsCashStr = MakeString(Total_ComeFreeOddsBetsCash);
}
//*******************************************************************
void TStatCalcCraps::Calc_ComeFreeOddsBetsCash()
{
  Total_ComeFreeOddsBetsCash = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
    Total_ComeFreeOddsBetsCash += GetCSession(i)->ComeFreeOddsBetsCash;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_DontComeBetsCashStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    DontComeBetsCashStr[i] = MakeString(GetCSession(i)->DontComeBetsCash);
  }
  Total_DontComeBetsCashStr = MakeString(Total_DontComeBetsCash);
}
//*******************************************************************
void TStatCalcCraps::Calc_DontComeBetsCash()
{
  Total_DontComeBetsCash = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
    Total_DontComeBetsCash += GetCSession(i)->DontComeBetsCash;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_DontComeFreeOddsBetsCashStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    DontComeFreeOddsBetsCashStr[i] = MakeString(GetCSession(i)->DontComeFreeOddsBetsCash);
  }
  Total_DontComeFreeOddsBetsCashStr = MakeString(Total_DontComeFreeOddsBetsCash);
}
//*******************************************************************
void TStatCalcCraps::Calc_DontComeFreeOddsBetsCash()
{
  Total_DontComeFreeOddsBetsCash = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
    Total_DontComeFreeOddsBetsCash += GetCSession(i)->DontComeFreeOddsBetsCash;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_FieldBetsCashStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    FieldBetsCashStr[i] = MakeString(GetCSession(i)->FieldBetsCash);
  }
  Total_FieldBetsCashStr = MakeString(Total_FieldBetsCash);
}
//*******************************************************************
void TStatCalcCraps::Calc_FieldBetsCash()
{
  Total_FieldBetsCash = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
    Total_FieldBetsCash += GetCSession(i)->FieldBetsCash;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_HardwayBetsCashStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    HardwayBetsCashStr[i] = MakeString(GetCSession(i)->HardwaysBetsCash);
  }
  Total_HardwayBetsCashStr = MakeString(Total_HardwayBetsCash);
}
//*******************************************************************
void TStatCalcCraps::Calc_HardwayBetsCash()
{
  Total_HardwayBetsCash = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
    Total_HardwayBetsCash += GetCSession(i)->HardwaysBetsCash;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_Big6Big8BetsCashStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    Big6Big8BetsCashStr[i] = MakeString(GetCSession(i)->Big6Big8BetsCash);
  }
  Total_Big6Big8BetsCashStr = MakeString(Total_Big6Big8BetsCash);
}
//*******************************************************************
void TStatCalcCraps::Calc_Big6Big8BetsCash()
{
  Total_Big6Big8BetsCash = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
    Total_Big6Big8BetsCash += GetCSession(i)->Big6Big8BetsCash;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_Buy4BetsCashStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    Buy4BetsCashStr[i] = MakeString(GetCSession(i)->Buy4BetsCash);
  }
  Total_Buy4BetsCashStr = MakeString(Total_Buy4BetsCash);
}
//*******************************************************************
void TStatCalcCraps::Calc_Buy4BetsCash()
{
  Total_Buy4BetsCash = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
    Total_Buy4BetsCash += GetCSession(i)->Buy4BetsCash;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_Place5BetsCashStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    Place5BetsCashStr[i] = MakeString(GetCSession(i)->Place5BetsCash);
  }
  Total_Place5BetsCashStr = MakeString(Total_Place5BetsCash);
}
//*******************************************************************
void TStatCalcCraps::Calc_Place5BetsCash()
{
  Total_Place5BetsCash = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
    Total_Place5BetsCash += GetCSession(i)->Place5BetsCash;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_Place6BetsCashStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    Place6BetsCashStr[i] = MakeString(GetCSession(i)->Place6BetsCash);
  }
  Total_Place6BetsCashStr = MakeString(Total_Place6BetsCash);
}
//*******************************************************************
void TStatCalcCraps::Calc_Place6BetsCash()
{
  Total_Place6BetsCash = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
    Total_Place6BetsCash += GetCSession(i)->Place6BetsCash;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_Place8BetsCashStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    Place8BetsCashStr[i] = MakeString(GetCSession(i)->Place8BetsCash);
  }
  Total_Place8BetsCashStr = MakeString(Total_Place8BetsCash);
}
//*******************************************************************
void TStatCalcCraps::Calc_Place8BetsCash()
{
  Total_Place8BetsCash = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
    Total_Place8BetsCash += GetCSession(i)->Place8BetsCash;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_Place9BetsCashStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    Place9BetsCashStr[i] = MakeString(GetCSession(i)->Place9BetsCash);
  }
  Total_Place9BetsCashStr = MakeString(Total_Place9BetsCash);
}
//*******************************************************************
void TStatCalcCraps::Calc_Place9BetsCash()
{
  Total_Place9BetsCash = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
    Total_Place9BetsCash += GetCSession(i)->Place9BetsCash;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_Buy10BetsCashStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    Buy10BetsCashStr[i] = MakeString(GetCSession(i)->Buy10BetsCash);
  }
  Total_Buy10BetsCashStr = MakeString(Total_Buy10BetsCash);
}
//*******************************************************************
void TStatCalcCraps::Calc_Buy10BetsCash()
{
  Total_Buy10BetsCash = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
    Total_Buy10BetsCash += GetCSession(i)->Buy10BetsCash;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_Place410BetsCashStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    Place410BetsCashStr[i] = MakeString(GetCSession(i)->Place410BetsCash);
  }
  Total_Place410BetsCashStr = MakeString(Total_Place410BetsCash);
}
//*******************************************************************
void TStatCalcCraps::Calc_Place410BetsCash()
{
  Total_Place410BetsCash = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
    Total_Place410BetsCash += GetCSession(i)->Place410BetsCash;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_Buy59BetsCashStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    Buy59BetsCashStr[i] = MakeString(GetCSession(i)->Buy59BetsCash);
  }
  Total_Buy59BetsCashStr = MakeString(Total_Buy59BetsCash);
}
//*******************************************************************
void TStatCalcCraps::Calc_Buy59BetsCash()
{
  Total_Buy59BetsCash = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
    Total_Buy59BetsCash += GetCSession(i)->Buy59BetsCash;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_Buy68BetsCashStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    Buy68BetsCashStr[i] = MakeString(GetCSession(i)->Buy68BetsCash);
  }
  Total_Buy68BetsCashStr = MakeString(Total_Buy68BetsCash);
}
//*******************************************************************
void TStatCalcCraps::Calc_Buy68BetsCash()
{
  Total_Buy68BetsCash = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
    Total_Buy68BetsCash += GetCSession(i)->Buy68BetsCash;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_Lay410BetsCashStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    Lay410BetsCashStr[i] = MakeString(GetCSession(i)->Lay410BetsCash);
  }
  Total_Lay410BetsCashStr = MakeString(Total_Lay410BetsCash);
}
//*******************************************************************
void TStatCalcCraps::Calc_Lay410BetsCash()
{
  Total_Lay410BetsCash = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
    Total_Lay410BetsCash += GetCSession(i)->Lay410BetsCash;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_Lay59BetsCashStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
	 Lay59BetsCashStr[i] = MakeString(GetCSession(i)->Lay59BetsCash);
  }
  Total_Lay59BetsCashStr = MakeString(Total_Lay59BetsCash);
}
//*******************************************************************
void TStatCalcCraps::Calc_Lay59BetsCash()
{
  Total_Lay59BetsCash = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
    Total_Lay59BetsCash += GetCSession(i)->Lay59BetsCash;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_Lay68BetsCashStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    Lay68BetsCashStr[i] = MakeString(GetCSession(i)->Lay68BetsCash);
  }
  Total_Lay68BetsCashStr = MakeString(Total_Lay68BetsCash);
}
//*******************************************************************
void TStatCalcCraps::Calc_Lay68BetsCash()
{
  Total_Lay68BetsCash = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
    Total_Lay68BetsCash += GetCSession(i)->Lay68BetsCash;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_PropositionBetsCashStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    PropositionBetsCashStr[i] = MakeString(GetCSession(i)->PropositionBetsCash);
  }
  Total_PropositionBetsCashStr = MakeString(Total_PropositionBetsCash);
}
//*******************************************************************
void TStatCalcCraps::Calc_PropositionBetsCash()
{
  Total_PropositionBetsCash = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
    Total_PropositionBetsCash += GetCSession(i)->PropositionBetsCash;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_TotalCashWonStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    TotalCashWonStr[i] = MakeString(GetCSession(i)->TotalCashWon);
  }
  Total_TotalCashWonStr = MakeString(Total_TotalCashWon);
}
//*******************************************************************
void TStatCalcCraps::Calc_TotalCashWon()
{
  Total_TotalCashWon = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
    Total_TotalCashWon += GetCSession(i)->TotalCashWon;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_TotalCashLostStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    TotalCashLostStr[i] = MakeString(GetCSession(i)->TotalCashLost);
  }
  Total_TotalCashLostStr = MakeString(Total_TotalCashLost);
}
//*******************************************************************
void TStatCalcCraps::Calc_TotalCashLost()
{
  Total_TotalCashLost = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
    Total_TotalCashLost += GetCSession(i)->TotalCashLost;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_PassBetsCashWLStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    PassBetsCashWLStr[i] = MakeString(GetCSession(i)->PassBetsCashWL);
  }
  Total_PassBetsCashWLStr = MakeString(Total_PassBetsCashWL);
}
//*******************************************************************
void TStatCalcCraps::Calc_PassBetsCashWL()
{
  Total_PassBetsCashWL = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
    Total_PassBetsCashWL += GetCSession(i)->PassBetsCashWL;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_PassFreeOddsBetsCashWLStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    PassFreeOddsBetsCashWLStr[i] = MakeString(GetCSession(i)->PassFreeOddsBetsCashWL);
  }
  Total_PassFreeOddsBetsCashWLStr = MakeString(Total_PassFreeOddsBetsCashWL);
}
//*******************************************************************
void TStatCalcCraps::Calc_PassFreeOddsBetsCashWL()
{
  Total_PassFreeOddsBetsCashWL = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
    Total_PassFreeOddsBetsCashWL += GetCSession(i)->PassFreeOddsBetsCashWL;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_DontPassBetsCashWLStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    DontPassBetsCashWLStr[i] = MakeString(GetCSession(i)->DontPassBetsCashWL);
  }
  Total_DontPassBetsCashWLStr = MakeString(Total_DontPassBetsCashWL);
}
//*******************************************************************
void TStatCalcCraps::Calc_DontPassBetsCashWL()
{
  Total_DontPassBetsCashWL = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
    Total_DontPassBetsCashWL += GetCSession(i)->DontPassBetsCashWL;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_DontPassFreeOddsBetsCashWLStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
	 DontPassFreeOddsBetsCashWLStr[i] = MakeString(GetCSession(i)->PassFreeOddsBetsCashWL87);// Don't ask me - Adam... DontPassFreeOddsBetsCashWL);
  }
  Total_DontPassFreeOddsBetsCashWLStr = MakeString(Total_DontPassFreeOddsBetsCash);
}
//*******************************************************************
void TStatCalcCraps::Calc_DontPassFreeOddsBetsCashWL()
{
  Total_DontPassFreeOddsBetsCashWL = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
	 Total_DontPassFreeOddsBetsCashWL += GetCSession(i)->PassFreeOddsBetsCashWL87;//DontPassFreeOddsBetsCashWL;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_ComeBetsCashWLStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    ComeBetsCashWLStr[i] = MakeString(GetCSession(i)->ComeBetsCashWL);
  }
  Total_ComeBetsCashWLStr = MakeString(Total_ComeBetsCashWL);
}
//*******************************************************************
void TStatCalcCraps::Calc_ComeBetsCashWL()
{
  Total_ComeBetsCashWL = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
    Total_ComeBetsCashWL += GetCSession(i)->ComeBetsCashWL;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_ComeFreeOddsBetsCashWLStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    ComeFreeOddsBetsCashWLStr[i] = MakeString(GetCSession(i)->ComeFreeOddsBetsCashWL);
  }
  Total_ComeFreeOddsBetsCashWLStr = MakeString(Total_ComeFreeOddsBetsCashWL);
}
//*******************************************************************
void TStatCalcCraps::Calc_ComeFreeOddsBetsCashWL()
{
  Total_ComeFreeOddsBetsCashWL = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
    Total_ComeFreeOddsBetsCashWL += GetCSession(i)->ComeFreeOddsBetsCashWL;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_DontComeBetsCashWLStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    DontComeBetsCashWLStr[i] = MakeString(GetCSession(i)->DontComeBetsCashWL);
  }
  Total_DontComeBetsCashWLStr = MakeString(Total_DontComeBetsCashWL);
}
//*******************************************************************
void TStatCalcCraps::Calc_DontComeBetsCashWL()
{
  Total_DontComeBetsCashWL = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
    Total_DontComeBetsCashWL += GetCSession(i)->DontComeBetsCashWL;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_DontComeFreeOddsBetsCashWLStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    DontComeFreeOddsBetsCashWLStr[i] = MakeString(GetCSession(i)->DontComeFreeOddsBetsCashWL);
  }
  Total_DontComeFreeOddsBetsCashWLStr = MakeString(Total_DontComeFreeOddsBetsCashWL);
}
//*******************************************************************
void TStatCalcCraps::Calc_DontComeFreeOddsBetsCashWL()
{
  Total_DontComeFreeOddsBetsCashWL = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
    Total_DontComeFreeOddsBetsCashWL += GetCSession(i)->DontComeFreeOddsBetsCashWL;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_FieldBetsCashWLStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    FieldBetsCashWLStr[i] = MakeString(GetCSession(i)->FieldBetsCashWL);
  }
  Total_FieldBetsCashWLStr = MakeString(Total_FieldBetsCashWL);
}
//*******************************************************************
void TStatCalcCraps::Calc_FieldBetsCashWL()
{
  Total_FieldBetsCashWL = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
    Total_FieldBetsCashWL += GetCSession(i)->FieldBetsCashWL;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_HardwayBetsCashWLStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    HardwayBetsCashWLStr[i] = MakeString(GetCSession(i)->HardwaysBetsCashWL);
  }
  Total_HardwayBetsCashWLStr = MakeString(Total_HardwayBetsCashWL);
}
//*******************************************************************
void TStatCalcCraps::Calc_HardwayBetsCashWL()
{
  Total_HardwayBetsCashWL = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
    Total_HardwayBetsCashWL += GetCSession(i)->HardwaysBetsCashWL;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_Big6Big8BetsCashWLStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    Big6Big8BetsCashWLStr[i] = MakeString(GetCSession(i)->Big6Big8BetsCashWL);
  }
  Total_Big6Big8BetsCashWLStr = MakeString(Total_Big6Big8BetsCashWL);
}
//*******************************************************************
void TStatCalcCraps::Calc_Big6Big8BetsCashWL()
{
  Total_Big6Big8BetsCashWL = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
    Total_Big6Big8BetsCash += GetCSession(i)->Big6Big8BetsCashWL;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_Buy4BetsCashWLStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    Buy4BetsCashWLStr[i] = MakeString(GetCSession(i)->Buy4BetsCashWL);
  }
  Total_Buy4BetsCashWLStr = MakeString(Total_Buy4BetsCashWL);
}
//*******************************************************************
void TStatCalcCraps::Calc_Buy4BetsCashWL()
{
  Total_Buy4BetsCashWL = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
    Total_Buy4BetsCashWL += GetCSession(i)->Buy4BetsCashWL;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_Place5BetsCashWLStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    Place5BetsCashWLStr[i] = MakeString(GetCSession(i)->Place5BetsCashWL);
  }
  Total_Place5BetsCashWLStr = MakeString(Total_Place5BetsCashWL);
}
//*******************************************************************
void TStatCalcCraps::Calc_Place5BetsCashWL()
{
  Total_Place5BetsCashWL = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
    Total_Place5BetsCashWL += GetCSession(i)->Place5BetsCashWL;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_Place6BetsCashWLStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    Place6BetsCashWLStr[i] = MakeString(GetCSession(i)->Place6BetsCashWL);
  }
  Total_Place6BetsCashWLStr = MakeString(Total_Place6BetsCashWL);
}
//*******************************************************************
void TStatCalcCraps::Calc_Place6BetsCashWL()
{
  Total_Place6BetsCashWL = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
    Total_Place6BetsCashWL += GetCSession(i)->Place6BetsCashWL;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_Place8BetsCashWLStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    Place8BetsCashWLStr[i] = MakeString(GetCSession(i)->Place8BetsCashWL);
  }
  Total_Place8BetsCashWLStr = MakeString(Total_Place8BetsCashWL);
}
//*******************************************************************
void TStatCalcCraps::Calc_Place8BetsCashWL()
{
  Total_Place8BetsCashWL = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
    Total_Place8BetsCashWL += GetCSession(i)->Place8BetsCashWL;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_Place9BetsCashWLStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    Place9BetsCashWLStr[i] = MakeString(GetCSession(i)->Place9BetsCashWL);
  }
  Total_Place9BetsCashWLStr = MakeString(Total_Place9BetsCashWL);
}
//*******************************************************************
void TStatCalcCraps::Calc_Place9BetsCashWL()
{
  Total_Place9BetsCashWL = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
    Total_Place9BetsCashWL += GetCSession(i)->Place9BetsCashWL;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_Buy10BetsCashWLStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    Buy10BetsCashWLStr[i] = MakeString(GetCSession(i)->Buy10BetsCashWL);
  }
  Total_Buy10BetsCashWLStr = MakeString(Total_Buy10BetsCashWL);
}
//*******************************************************************
void TStatCalcCraps::Calc_Buy10BetsCashWL()
{
  Total_Buy10BetsCashWL = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
    Total_Buy10BetsCashWL += GetCSession(i)->Buy10BetsCashWL;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_Place410BetsCashWLStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    Place410BetsCashWLStr[i] = MakeString(GetCSession(i)->Place410BetsCashWL);
  }
  Total_Place410BetsCashWLStr = MakeString(Total_Place410BetsCashWL);
}
//*******************************************************************
void TStatCalcCraps::Calc_Place410BetsCashWL()
{
  Total_Place410BetsCashWL = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
    Total_Place410BetsCashWL += GetCSession(i)->Place410BetsCashWL;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_Buy59BetsCashWLStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    Buy59BetsCashWLStr[i] = MakeString(GetCSession(i)->Buy59BetsCashWL);
  }
  Total_Buy59BetsCashWLStr = MakeString(Total_Buy59BetsCashWL);
}
//*******************************************************************
void TStatCalcCraps::Calc_Buy59BetsCashWL()
{
  Total_Buy59BetsCashWL = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
    Total_Buy59BetsCashWL += GetCSession(i)->Buy59BetsCashWL;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_Buy68BetsCashWLStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    Buy68BetsCashWLStr[i] = MakeString(GetCSession(i)->Buy68BetsCashWL);
  }
  Total_Buy68BetsCashWLStr = MakeString(Total_Buy68BetsCashWL);
}
//*******************************************************************
void TStatCalcCraps::Calc_Buy68BetsCashWL()
{
  Total_Buy68BetsCashWL = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
    Total_Buy68BetsCashWL += GetCSession(i)->Buy68BetsCashWL;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_Lay410BetsCashWLStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    Lay410BetsCashWLStr[i] = MakeString(GetCSession(i)->Lay410BetsCashWL);
  }
  Total_Lay410BetsCashWLStr = MakeString(Total_Lay410BetsCashWL);
}
//*******************************************************************
void TStatCalcCraps::Calc_Lay410BetsCashWL()
{
  Total_Lay410BetsCashWL = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
    Total_Lay410BetsCashWL += GetCSession(i)->Lay410BetsCash;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_Lay59BetsCashWLStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    Lay59BetsCashWLStr[i] = MakeString(GetCSession(i)->Lay59BetsCashWL);
  }
  Total_Lay59BetsCashStr = MakeString(Total_Lay59BetsCash);
}
//*******************************************************************
void TStatCalcCraps::Calc_Lay59BetsCashWL()
{
  Total_Lay59BetsCashWL = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
    Total_Lay59BetsCashWL += GetCSession(i)->Lay59BetsCashWL;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_Lay68BetsCashWLStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    Lay68BetsCashWLStr[i] = MakeString(GetCSession(i)->Lay68BetsCashWL);
  }
  Total_Lay68BetsCashWLStr = MakeString(Total_Lay68BetsCashWL);
}
//*******************************************************************
void TStatCalcCraps::Calc_Lay68BetsCashWL()
{
  Total_Lay68BetsCashWL = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
    Total_Lay68BetsCashWL += GetCSession(i)->Lay68BetsCashWL;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_PropositionBetsCashWLStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    PropositionBetsCashWLStr[i] = MakeString(GetCSession(i)->PropositionBetsCashWL);
  }
  Total_PropositionBetsCashWLStr = MakeString(Total_PropositionBetsCashWL);
}
//*******************************************************************
void TStatCalcCraps::Calc_PropositionBetsCashWL()
{
  Total_PropositionBetsCashWL = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
    Total_PropositionBetsCashWL += GetCSession(i)->PropositionBetsCashWL;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_PercRetPassBetsStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    PercRetPassBetsStr[i] = MakeString(PercRetPassBets[i]);
  }
  Total_PercRetPassBetsStr = MakeString(Total_PercRetPassBets);
}
//*******************************************************************
void TStatCalcCraps::Calc_PercRetPassBets()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    PercRetPassBets[i] = GetPercRet(GetCSession(i)->PassBetsCashWL,GetCSession(i)->PassBetsCash);
  }
  Total_PercRetPassBets = GetPercRet(Total_PassBetsCashWL,Total_PassBetsCash);
}
//*******************************************************************
void TStatCalcCraps::Make_PercRetPassFreeOddsBetsStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    PercRetPassFreeOddsBetsStr[i] = MakeString(PercRetPassFreeOddsBets[i]);
  }
  Total_PercRetPassFreeOddsBetsStr = MakeString(Total_PercRetPassFreeOddsBets);
}
//*******************************************************************
void TStatCalcCraps::Calc_PercRetPassFreeOddsBets()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    PercRetPassFreeOddsBets[i] = GetPercRet(GetCSession(i)->PassFreeOddsBetsCashWL,
                                            GetCSession(i)->PassFreeOddsBetsCash);
  }
  Total_PercRetPassFreeOddsBets = GetPercRet(Total_PassFreeOddsBetsCashWL,
                                             Total_PassFreeOddsBetsCash);
}
//*******************************************************************
void TStatCalcCraps::Make_PercRetDontPassBetsStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    PercRetDontPassBetsStr[i] = MakeString(PercRetDontPassBets[i]);
  }
  Total_PercRetDontPassBetsStr = MakeString(Total_PercRetDontPassBets);
}
//*******************************************************************
void TStatCalcCraps::Calc_PercRetDontPassBets()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    PercRetDontPassBets[i] = GetPercRet(GetCSession(i)->DontPassBetsCashWL,
                                        GetCSession(i)->DontPassBetsCash);
  }
  Total_PercRetDontPassBets = GetPercRet(Total_DontPassBetsCashWL,Total_DontPassBetsCash);
}
//*******************************************************************
void TStatCalcCraps::Make_PercRetDontPassFreeOddsBetsStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
	 PercRetDontPassFreeOddsBetsStr[i] = MakeString(PercRetDontPassFreeOddsBets[i]);
  }
  Total_PercRetDontPassFreeOddsBetsStr = MakeString(Total_PercRetDontPassFreeOddsBets);
}
//*******************************************************************
void TStatCalcCraps::Calc_PercRetDontPassFreeOddsBets()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
	 PercRetDontPassFreeOddsBets[i] = GetPercRet(GetCSession(i)->PassFreeOddsBetsCashWL87,GetCSession(i)->DontPassFreeOddsBetsCash);
  }
  Total_PercRetDontPassFreeOddsBets = GetPercRet(Total_DontPassFreeOddsBetsCashWL,
																 Total_DontPassFreeOddsBetsCash);
}
//*******************************************************************
void TStatCalcCraps::Make_PercRetComeBetsStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
	 PercRetComeBetsStr[i] = MakeString(PercRetComeBets[i]);
  }
  Total_PercRetComeBetsStr = MakeString(Total_PercRetComeBets);
}
//*******************************************************************
void TStatCalcCraps::Calc_PercRetComeBets()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    PercRetComeBets[i] = GetPercRet(GetCSession(i)->ComeBetsCashWL,GetCSession(i)->ComeBetsCash);
  }
  Total_PercRetComeBets = GetPercRet(Total_ComeBetsCashWL,Total_ComeBetsCash);
}
//*******************************************************************
void TStatCalcCraps::Make_PercRetComeFreeOddsBetsStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    PercRetComeFreeOddsBetsStr[i] = MakeString(PercRetComeFreeOddsBets[i]);
  }
  Total_PercRetComeFreeOddsBetsStr = MakeString(Total_PercRetComeFreeOddsBets);
}
//*******************************************************************
void TStatCalcCraps::Calc_PercRetComeFreeOddsBets()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    PercRetComeFreeOddsBets[i] = GetPercRet(GetCSession(i)->ComeFreeOddsBetsCashWL,
                                            GetCSession(i)->ComeFreeOddsBetsCash);
  }
  Total_PercRetComeFreeOddsBets = GetPercRet(Total_ComeFreeOddsBetsCashWL,
                                             Total_ComeFreeOddsBetsCash);
}
//*******************************************************************
void TStatCalcCraps::Make_PercRetDontComeBetsStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    PercRetDontComeBetsStr[i] = MakeString(PercRetDontComeBets[i]);
  }
  Total_PercRetDontComeBetsStr = MakeString(Total_PercRetDontComeBets);
}
//*******************************************************************
void TStatCalcCraps::Calc_PercRetDontComeBets()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    PercRetDontComeBets[i] = GetPercRet(GetCSession(i)->DontComeBetsCashWL,
                                        GetCSession(i)->DontComeBetsCash);
  }
  Total_PercRetDontComeBets = GetPercRet(Total_DontComeBetsCashWL,Total_DontComeBetsCash);
}
//*******************************************************************
void TStatCalcCraps::Make_PercRetDontComeFreeOddsBetsStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    PercRetDontComeFreeOddsBetsStr[i] = MakeString(PercRetDontComeFreeOddsBets[i]);
  }
  Total_PercRetDontComeFreeOddsBetsStr = MakeString(Total_PercRetDontComeFreeOddsBets);
}
//*******************************************************************
void TStatCalcCraps::Calc_PercRetDontComeFreeOddsBets()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    PercRetDontComeFreeOddsBets[i] = GetPercRet(GetCSession(i)->DontComeFreeOddsBetsCashWL,
                                                GetCSession(i)->DontComeFreeOddsBetsCash);
  }
  Total_PercRetDontComeFreeOddsBets = GetPercRet(Total_DontComeFreeOddsBetsCashWL,
                                                 Total_DontComeFreeOddsBetsCash);
}
//*******************************************************************
void TStatCalcCraps::Make_PercRetFieldBetsStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    PercRetFieldBetsStr[i] = MakeString(PercRetFieldBets[i]);
  }
  Total_PercRetFieldBetsStr = MakeString(Total_PercRetFieldBets);
}
//*******************************************************************
void TStatCalcCraps::Calc_PercRetFieldBets()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    PercRetFieldBets[i] = GetPercRet(GetCSession(i)->FieldBetsCashWL,
                                     GetCSession(i)->FieldBetsCash);
  }
  Total_PercRetFieldBets = GetPercRet(Total_FieldBetsCashWL,Total_FieldBetsCash);
}
//*******************************************************************
void TStatCalcCraps::Make_PercRetHardwaysBetsStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    PercRetHardwaysBetsStr[i] = MakeString(PercRetHardwaysBets[i]);
  }
  Total_PercRetHardwaysBetsStr = MakeString(Total_PercRetHardwaysBets);
}
//*******************************************************************
void TStatCalcCraps::Calc_PercRetHardwaysBets()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    PercRetHardwaysBets[i] = GetPercRet(GetCSession(i)->HardwaysBetsCashWL,
                                        GetCSession(i)->HardwaysBetsCash);
  }
  Total_PercRetHardwaysBets = GetPercRet(Total_HardwayBetsCashWL,Total_HardwayBetsCash);
}
//*******************************************************************
void TStatCalcCraps::Make_PercRetBig6Big8BetsStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    PercRetBig6Big8BetsStr[i] = MakeString(PercRetBig6Big8Bets[i]);
  }
  Total_PercRetBig6Big8BetsStr = MakeString(Total_PercRetBig6Big8Bets);
}
//*******************************************************************
void TStatCalcCraps::Calc_PercRetBig6Big8Bets()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    PercRetBig6Big8Bets[i] = GetPercRet(GetCSession(i)->Big6Big8BetsCashWL,
                                        GetCSession(i)->Big6Big8BetsCash);
  }
  Total_PercRetBig6Big8Bets = GetPercRet(Total_Big6Big8BetsCashWL,Total_Big6Big8BetsCash);
}
//*******************************************************************
void TStatCalcCraps::Make_PercRetBuy4BetsStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    PercRetBuy4BetsStr[i] = MakeString(PercRetBuy4Bets[i]);
  }
  Total_PercRetBuy4BetsStr = MakeString(Total_PercRetBuy4Bets);
}
//*******************************************************************
void TStatCalcCraps::Calc_PercRetBuy4Bets()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    PercRetBuy4Bets[i] = GetPercRet(GetCSession(i)->Buy4BetsCashWL,GetCSession(i)->Buy4BetsCash);
  }
  Total_PercRetBuy4Bets = GetPercRet(Total_Buy4BetsCashWL,Total_Buy4BetsCash);
}
//*******************************************************************
void TStatCalcCraps::Make_PercRetPlace5BetsStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    PercRetPlace5BetsStr[i] = MakeString(PercRetPlace5Bets[i]);
  }
  Total_PercRetPlace5BetsStr = MakeString(Total_PercRetPlace5Bets);
}
//*******************************************************************
void TStatCalcCraps::Calc_PercRetPlace5Bets()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    PercRetPlace5Bets[i] = GetPercRet(GetCSession(i)->Place5BetsCashWL,
                                      GetCSession(i)->Place5BetsCash);
  }
  Total_PercRetPlace5Bets = GetPercRet(Total_Place5BetsCashWL,Total_Place5BetsCash);
}
//*******************************************************************
void TStatCalcCraps::Make_PercRetPlace6BetsStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    PercRetPlace6BetsStr[i] = MakeString(PercRetPlace6Bets[i]);
  }
  Total_PercRetPlace6BetsStr = MakeString(Total_PercRetPlace6Bets);
}
//*******************************************************************
void TStatCalcCraps::Calc_PercRetPlace6Bets()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    PercRetPlace6Bets[i] = GetPercRet(GetCSession(i)->Place6BetsCashWL,
                                      GetCSession(i)->Place6BetsCash);
  }
  Total_PercRetPlace6Bets = GetPercRet(Total_Place6BetsCashWL,Total_Place6BetsCash);
}
//*******************************************************************
void TStatCalcCraps::Make_PercRetPlace8BetsStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    PercRetPlace8BetsStr[i] = MakeString(PercRetPlace8Bets[i]);
  }
  Total_PercRetPlace8BetsStr = MakeString(Total_PercRetPlace8Bets);
}
//*******************************************************************
void TStatCalcCraps::Calc_PercRetPlace8Bets()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    PercRetPlace8Bets[i] = GetPercRet(GetCSession(i)->Place8BetsCashWL,
                                      GetCSession(i)->Place8BetsCash);
  }
  Total_PercRetPlace8Bets = GetPercRet(Total_Place8BetsCashWL,Total_Place8BetsCash);
}
//*******************************************************************
void TStatCalcCraps::Make_PercRetPlace9BetsStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    PercRetPlace9BetsStr[i] = MakeString(PercRetPlace9Bets[i]);
  }
  Total_PercRetPlace9BetsStr = MakeString(Total_PercRetPlace9Bets);
}
//*******************************************************************
void TStatCalcCraps::Calc_PercRetPlace9Bets()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    PercRetPlace9Bets[i] = GetPercRet(GetCSession(i)->Place9BetsCashWL,
                                      GetCSession(i)->Place9BetsCash);
  }
  Total_PercRetPlace9Bets = GetPercRet(Total_Place9BetsCashWL,Total_Place9BetsCash);
}
//*******************************************************************
void TStatCalcCraps::Make_PercRetBuy10BetsStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    PercRetBuy10BetsStr[i] = MakeString(PercRetBuy10Bets[i]);
  }
  Total_PercRetBuy10BetsStr = MakeString(Total_PercRetBuy10Bets);
}
//*******************************************************************
void TStatCalcCraps::Calc_PercRetBuy10Bets()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    PercRetBuy10Bets[i] = GetPercRet(GetCSession(i)->Buy10BetsCashWL,
                                     GetCSession(i)->Buy10BetsCash);
  }
  Total_PercRetBuy10Bets = GetPercRet(Total_Buy10BetsCashWL,Total_Buy10BetsCash);
}
//*******************************************************************
void TStatCalcCraps::Make_PercRetPlace410BetsStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    PercRetPlace410BetsStr[i] = MakeString(PercRetPlace410Bets[i]);
  }
  Total_PercRetPlace410BetsStr = MakeString(Total_PercRetPlace410Bets);
}
//*******************************************************************
void TStatCalcCraps::Calc_PercRetPlace410Bets()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    PercRetPlace410Bets[i] = GetPercRet(GetCSession(i)->Place410BetsCashWL,
                                        GetCSession(i)->Place410BetsCash);
  }
  Total_PercRetPlace410Bets = GetPercRet(Total_Place410BetsCashWL,Total_Place410BetsCash);
}
//*******************************************************************
void TStatCalcCraps::Make_PercRetBuy59BetsStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    PercRetBuy59BetsStr[i] = MakeString(PercRetBuy59Bets[i]);
  }
  Total_PercRetBuy59BetsStr = MakeString(Total_PercRetBuy59Bets);
}
//*******************************************************************
void TStatCalcCraps::Calc_PercRetBuy59Bets()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    PercRetBuy59Bets[i] = GetPercRet(GetCSession(i)->Buy59BetsCashWL,
                                     GetCSession(i)->Buy59BetsCash);
  }
  Total_PercRetBuy59Bets = GetPercRet(Total_Buy59BetsCashWL,Total_Buy59BetsCash);
}
//*******************************************************************
void TStatCalcCraps::Make_PercRetBuy68BetsStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    PercRetBuy68BetsStr[i] = MakeString(PercRetBuy68Bets[i]);
  }
  Total_PercRetBuy68BetsStr = MakeString(Total_PercRetBuy68Bets);
}
//*******************************************************************
void TStatCalcCraps::Calc_PercRetBuy68Bets()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    PercRetBuy68Bets[i] = GetPercRet(GetCSession(i)->Buy68BetsCashWL,
                                     GetCSession(i)->Buy68BetsCash);
  }
  Total_PercRetBuy68Bets =  GetPercRet(Total_Buy68BetsCashWL,Total_Buy68BetsCash);
}
//*******************************************************************
void TStatCalcCraps::Make_PercRetLay410BetsStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    PercRetLay410BetsStr[i] = MakeString(PercRetLay410Bets[i]);
  }
  Total_PercRetLay410BetsStr = MakeString(Total_PercRetLay410Bets);
}
//*******************************************************************
void TStatCalcCraps::Calc_PercRetLay410Bets()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    PercRetLay410Bets[i] = GetPercRet(GetCSession(i)->Lay410BetsCashWL,
                                      GetCSession(i)->Lay410BetsCash);
  }
  Total_PercRetLay410Bets = GetPercRet(Total_Lay410BetsCashWL,Total_Lay410BetsCash);
}
//*******************************************************************
void TStatCalcCraps::Make_PercRetLay59BetsStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    PercRetLay59BetsStr[i] = MakeString(PercRetLay59Bets[i]);
  }
  Total_PercRetLay59BetsStr = MakeString(Total_PercRetLay59Bets);
}
//*******************************************************************
void TStatCalcCraps::Calc_PercRetLay59Bets()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    PercRetLay59Bets[i] = GetPercRet(GetCSession(i)->Lay59BetsCashWL,
                                     GetCSession(i)->Lay59BetsCash);
  }
  Total_PercRetLay59Bets = GetPercRet(Total_Lay59BetsCashWL,Total_Lay59BetsCash);
}
//*******************************************************************
void TStatCalcCraps::Make_PercRetLay68BetsStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    PercRetLay68BetsStr[i] = MakeString(PercRetLay68Bets[i]);
  }
  Total_PercRetLay68BetsStr = MakeString(Total_PercRetLay68Bets);
}
//*******************************************************************
void TStatCalcCraps::Calc_PercRetLay68Bets()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    PercRetLay68Bets[i] = GetPercRet(GetCSession(i)->Lay68BetsCashWL,
                                     GetCSession(i)->Lay68BetsCash);
  }
  Total_PercRetLay68Bets = GetPercRet(Total_Lay68BetsCashWL,Total_Lay68BetsCash);
}
//*******************************************************************
void TStatCalcCraps::Make_PercRetPropositionBetsStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    PercRetPropositionBetsStr[i] = MakeString(PercRetPropositionBets[i]);
  }
  Total_PercRetPropositionBetsStr = MakeString(Total_PercRetPropositionBets);
}
//*******************************************************************
void TStatCalcCraps::Calc_PercRetPropositionBets()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    PercRetPropositionBets[i] = GetPercRet(GetCSession(i)->PropositionBetsCashWL,
                                           GetCSession(i)->PropositionBetsCash);
  }
  Total_PercRetPropositionBets = GetPercRet(Total_PropositionBetsCashWL,
                                            Total_PropositionBetsCash);

}
//*******************************************************************
void TStatCalcCraps::Make_NumHighPercBetsStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    NumHighPercBetsStr[i] = MakeString(GetCSession(i)->NumHighPercentageBets);
  }
  Total_NumHighPercBetsStr = MakeString(Total_NumHighPercBets);
}
//*******************************************************************
void TStatCalcCraps::Calc_NumHighPercBets()
{
  Total_NumHighPercBets = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
    Total_NumHighPercBets += GetCSession(i)->NumHighPercentageBets;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_NumLowPercBetsStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    NumLowPercBetsStr[i] = MakeString(GetCSession(i)->NumLowPercentageBets);
  }
  Total_NumLowPercBetsStr = MakeString(Total_NumLowPercBets);
}
//*******************************************************************
void TStatCalcCraps::Calc_NumLowPercBets()
{
  Total_NumLowPercBets = 0;
  for (int i=0;i<=LastSessionNum;i++)
  {
    Total_NumLowPercBets += GetCSession(i)->NumLowPercentageBets;
  }
}
//*******************************************************************
void TStatCalcCraps::Make_PercPlayingAccuracyStrs()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    PercPlayingAccuracyStr[i] = MakeString(PercPlayingAccuracy[i]);
  }
  Total_PercPlayingAccuracyStr = MakeString(Total_PercPlayingAccuracy);
}
//*******************************************************************
void TStatCalcCraps::Calc_PercPlayingAccuracy()
{
  for (int i=0;i<=LastSessionNum;i++)
  {
    PercPlayingAccuracy[i] = GetPerc(GetCSession(i)->NumHighPercentageBets,
                                     TotalNumBets[i]);
  }
  Total_PercPlayingAccuracy = GetPerc(Total_NumHighPercBets,Total_TotalNumBets);
}
//*******************************************************************

