//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  cocalc.cpp          
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     9/6/96     M.Perry    derived from Dave's code.
//  2.0    09/17/97    M.Perry    32-bit conversion.
//********************************************************************
#include "cstatdlg.h"
#include "cocalc.h"

#if defined(ROULETTE_COMPILE)
  #include "crcalc.h"
#endif

#if defined(KENO_COMPILE)
  #include "ckcalc.h"
#endif

#if defined(SLOTS_COMPILE)
  #include "cscalc.h"
#endif

#if defined(VP_COMPILE)
  #include "cvpcalc.h"
#endif

#if defined(BJ_COMPILE)
  #include "cbjcalc.h"
#endif

#if defined(CRAPS_COMPILE)
  #include "cccalc.h"
#endif

#include <stdio.h>
#include <classlib\time.h>
#include "oapp.h"
//*******************************************************************
string TStatCalcOverall::GetLabelStr(int16 row_ndx)
{
  string s = TAppString::strEmpty;
  if (row_ndx >= 0 && row_ndx < oNumRows)
  {
    s = LabelStrs[row_ndx];
  }
  return s;
}
//*******************************************************************
TStatCalcOverall::TStatCalcOverall(TCasinoStatDlg *pstatdlg)
:TCasinoStatCalc(pstatdlg),
#if defined(BJ_COMPILE)
 PBJStats(NULL),
#endif
#if defined(CRAPS_COMPILE)
 PCrapsStats(NULL),
#endif
#if defined(KENO_COMPILE)
 PKenoStats(NULL),
#endif
#if defined(ROULETTE_COMPILE)
 PRouletteStats(NULL),
#endif
#if defined(SLOTS_COMPILE)
 PSlotsStats(NULL),
#endif
#if defined(VP_COMPILE)
 PVPStats(NULL)
#endif
{
  // setup label resource ids & then go get strings
  for (int16 i=0;i<oNumRows;i++)
  {
    LabelResIds[i] = 0;
    LabelStrs[i] = TAppString::strEmpty;
  }
  //row ndx enum name to label string res id
  LabelResIds[oTotalCashBet] = OverallLabel + 7;
  LabelResIds[oAvgCashBet] = OverallLabel + 8;
  LabelResIds[oStartingBankroll] = OverallLabel + 9;
  LabelResIds[oEndingBankroll] = OverallLabel + 10;
  LabelResIds[oTotalHoursPlayed] = OverallLabel + 11;
  LabelResIds[oTotalCashWL] = OverallLabel + 12;
  LabelResIds[oAvgWLPerHour] = OverallLabel + 13;
  LabelResIds[oCumCashWL] = OverallLabel + 14;
  LabelResIds[oPeakCashWinLevel] = OverallLabel + 15;
  LabelResIds[oLowCashLossLevel] = OverallLabel + 16;
  LabelResIds[oSESSIONS] = OverallLabel + 1;
  LabelResIds[oSESSIONSRECORDED] = OverallLabel + 17;

#if defined(BJ_COMPILE)
  LabelResIds[oBJSessions] = OverallLabel + 18;
#endif
#if defined(CRAPS_COMPILE)
  LabelResIds[oCrapsSessions = OverallLabel + 19;
#endif
#if defined(KENO_COMPILE)
  LabelResIds[oKenoSessions] = OverallLabel + 20;
#endif
#if defined(ROULETTE_COMPILE)
  LabelResIds[oRouletteSessions] = OverallLabel + 21;
#endif
#if defined(SLOTS_COMPILE)
  LabelResIds[oSlotsSessions] = OverallLabel + 22;
#endif
#if defined(VP_COMPILE)
  LabelResIds[oVPSessions] = OverallLabel + 23;
#endif
  LabelResIds[oTOTALCASHBET] = OverallLabel + 2;
#if defined(BJ_COMPILE)
  LabelResIds[oBJCash] = OverallLabel + 24;
#endif
#if defined(CRAPS_COMPILE)
  LabelResIds[oCrapsCash] = OverallLabel + 25;
#endif
#if defined(KENO_COMPILE)
  LabelResIds[oKenoCash] = OverallLabel + 26;
#endif
#if defined(ROULETTE_COMPILE)
  LabelResIds[oRouletteCash] = OverallLabel + 27;
#endif
#if defined(SLOTS_COMPILE)
  LabelResIds[oSlotsCash] = OverallLabel + 28;
#endif
#if defined(VP_COMPILE)
  LabelResIds[oVPCash] = OverallLabel + 29;
#endif
  LabelResIds[oTOTALHOURSPLAYED] = OverallLabel + 3;
#if defined(BJ_COMPILE)
  LabelResIds[oBJHoursPlayed] = OverallLabel + 30;
#endif
#if defined(CRAPS_COMPILE)
  LabelResIds[oCrapsHoursPlayed] = OverallLabel + 31;
#endif
#if defined(KENO_COMPILE)
  LabelResIds[oKenoHoursPlayed] = OverallLabel + 32;
#endif
#if defined(ROULETTE_COMPILE)
  LabelResIds[oRouletteHoursPlayed] = OverallLabel + 33;
#endif
#if defined(SLOTS_COMPILE)
  LabelResIds[oSlotsHoursPlayed] = OverallLabel + 34;
#endif
#if defined(VP_COMPILE)
  LabelResIds[oVPHoursPlayed] = OverallLabel + 35;
#endif
  LabelResIds[oTOTALCASHWL] = OverallLabel + 4;
#if defined(BJ_COMPILE)
  LabelResIds[oBJCashWL] = OverallLabel + 36;
#endif
#if defined(CRAPS_COMPILE)
  LabelResIds[oCrapsCashWL] = OverallLabel + 37;
#endif
#if defined(KENO_COMPILE)
  LabelResIds[oKenoCashWL] = OverallLabel + 38;
#endif
#if defined(ROULETTE_COMPILE)
  LabelResIds[oRouletteCashWL] = OverallLabel + 39;
#endif
#if defined(SLOTS_COMPILE)
  LabelResIds[oSlotsCashWL] = OverallLabel + 40;
#endif
#if defined(VP_COMPILE)
  LabelResIds[oVPCashWL] = OverallLabel + 41;
#endif
  LabelResIds[oRETURNPERC] = OverallLabel + 5;
#if defined(BJ_COMPILE)
  LabelResIds[oBJPerc] = OverallLabel + 42;
#endif
#if defined(CRAPS_COMPILE)
  LabelResIds[oCrapsPerc] = OverallLabel + 43;
#endif
#if defined(KENO_COMPILE)
  LabelResIds[oKenoPerc] = OverallLabel + 44;
#endif
#if defined(ROULETTE_COMPILE)
  LabelResIds[oRoulettePerc] = OverallLabel + 45;
#endif
#if defined(SLOTS_COMPILE)
  LabelResIds[oSlotsPerc] = OverallLabel + 46;
#endif
#if defined(VP_COMPILE)
  LabelResIds[oVPPerc] = OverallLabel + 47;
#endif
  LabelResIds[oWLPERHOUR] = OverallLabel + 6;
#if defined(BJ_COMPILE)
  LabelResIds[oBJCashWLPerHour] = OverallLabel + 48;
#endif
#if defined(CRAPS_COMPILE)
  LabelResIds[oCrapsWLPerHour] = OverallLabel + 49;
#endif
#if defined(KENO_COMPILE)
  LabelResIds[oKenoWLPerHour] = OverallLabel + 50;
#endif
#if defined(ROULETTE_COMPILE)
  LabelResIds[oRouletteWLPerHour] = OverallLabel + 51;
#endif
#if defined(SLOTS_COMPILE)
  LabelResIds[oSlotsWLPerHour] = OverallLabel + 52;
#endif
#if defined(VP_COMPILE)
  LabelResIds[oVPWLPerHour] = OverallLabel + 53;
#endif

  // get string from resources
  for (int16 i=0;i<oNumRows;i++)
  {
    if (LabelResIds[i] > 0)
    {
      LabelStrs[i] = TAppString(LabelResIds[i]);
    }
  }

}
//*******************************************************************
TStatCalcOverall::~TStatCalcOverall()
{
}
//*******************************************************************
void TStatCalcOverall::GetSessionPtrs()
{
#if defined(BJ_COMPILE)
  PBJStats = PStatDlg->PBJStats;
#endif
#if defined(CRAPS_COMPILE)
  PCrapsStats = PStatDlg->PCrapsStats;
#endif
#if defined(KENO_COMPILE)
  PKenoStats = PStatDlg->PKenoStats;
#endif
#if defined(VP_COMPILE)
  PVPStats = PStatDlg->PVPStats;
#endif
#if defined(SLOTS_COMPILE)
  PSlotsStats = PStatDlg->PSlotsStats;
#endif
#if defined(ROULETTE_COMPILE)
  PRouletteStats = PStatDlg->PRouletteStats;
#endif
}
//*******************************************************************
void TStatCalcOverall::Make_TotalCashBetsStrs()
{
  Total_TotalCashBetsStr = MakeString(Total_TotalCashBets);
}
//*******************************************************************
void TStatCalcOverall::Calc_TotalCashBets()
{
  Total_TotalCashBets =
                        #if defined(BJ_COMPILE)
                        PBJStats->Get_Total_TotalCashBets() +
                        #endif
                        #if defined(CRAPS_COMPILE)
                        PCrapsStats->Get_Total_TotalCashBets() +
                        #endif
                        #if defined(KENO_COMPILE)
                        PKenoStats->Get_Total_TotalCashBets() +
                        #endif
                        #if defined(ROULETTE_COMPILE)
                        PRouletteStats->Get_Total_TotalCashBets() +
                        #endif
                        #if defined(SLOTS_COMPILE)
                        PSlotsStats->Get_Total_TotalCashBets() +
                        #endif
                        #if defined(VP_COMPILE)
                        PVPStats->Get_Total_TotalCashBets();
                        #endif
}
//*******************************************************************
void TStatCalcOverall::Make_TotalNumBetsStrs()
{
  Total_TotalNumBetsStr = MakeString(Total_TotalNumBets);
}
//*******************************************************************
void TStatCalcOverall::Calc_TotalNumBets()
{
  Total_TotalNumBets =
                       #if defined(BJ_COMPILE)
                       PBJStats->Get_Total_TotalNumBets() +
                       #endif
                       #if defined(CRAPS_COMPILE)
                       PCrapsStats->Get_Total_TotalNumBets() +
                       #endif
                       #if defined(KENO_COMPILE)
                       PKenoStats->Get_Total_TotalNumBets() +
                       #endif
                       #if defined(ROULETTE_COMPILE)
                       PRouletteStats->Get_Total_TotalNumBets() +
                       #endif
                       #if defined(SLOTS_COMPILE)
                       PSlotsStats->Get_Total_TotalNumBets() +
                       #endif
                       #if defined(VP_COMPILE)
                       PVPStats->Get_Total_TotalNumBets();
                       #endif
}
//*******************************************************************
void TStatCalcOverall::Make_AvgCashBetsStrs()
{
  Total_AvgCashBetsStr = MakeString(Total_AvgCashBets);
}
//*******************************************************************
void TStatCalcOverall::Calc_AvgCashBets()
{
  Total_AvgCashBets = GetAvg(Total_TotalCashBets,Total_TotalNumBets);
}
//*******************************************************************
void TStatCalcOverall::Make_StartingBankrollStrs()
{
  Total_StartingBankrollStr = MakeString(Total_StartingBankroll);
}
//*******************************************************************
void TStatCalcOverall::Calc_StartingBankroll()
{
  Total_StartingBankroll = Get_StartingBankroll();
}
//*******************************************************************
void TStatCalcOverall::Make_EndingBankrollStrs()
{
  Total_EndingBankrollStr = MakeString(Total_EndingBankroll);
}
//*******************************************************************
void TStatCalcOverall::Calc_EndingBankroll()
{
  Total_EndingBankroll = Get_EndingBankroll();
}
//*******************************************************************
void TStatCalcOverall::Make_HoursPlayedStrs()
{
  Total_HoursPlayedStr = MakeTimeStr(Total_SecondsPlayed);
}
//*******************************************************************
void TStatCalcOverall::Calc_HoursPlayed()
{
  Total_SecondsPlayed =
                        #if defined(BJ_COMPILE)
                        PBJStats->Get_Total_SecondsPlayed() +
                        #endif
                        #if defined(CRAPS_COMPILE)
                        PCrapsStats->Get_Total_SecondsPlayed() +
                        #endif
                        #if defined(KENO_COMPILE)
                        PKenoStats->Get_Total_SecondsPlayed() +
                        #endif
                        #if defined(ROULETTE_COMPILE)
                        PRouletteStats->Get_Total_SecondsPlayed() +
                        #endif
                        #if defined(SLOTS_COMPILE)
                        PSlotsStats->Get_Total_SecondsPlayed() +
                        #endif
                        #if defined(VP_COMPILE)
                        PVPStats->Get_Total_SecondsPlayed();
                        #endif
}
//*******************************************************************
void TStatCalcOverall::Make_TotalCashWLStrs()
{
  Total_TotalCashWLStr = MakeString(Total_TotalCashWL);
}
//*******************************************************************
void TStatCalcOverall::Calc_TotalCashWL()
{
  Total_TotalCashWL =
                      #if defined(BJ_COMPILE)
                      PBJStats->Get_Total_TotalCashWL() +
                      #endif
                      #if defined(CRAPS_COMPILE)
                      PCrapsStats->Get_Total_TotalCashWL() +
                      #endif
                      #if defined(KENO_COMPILE)
                      PKenoStats->Get_Total_TotalCashWL() +
                      #endif
                      #if defined(ROULETTE_COMPILE)
                      PRouletteStats->Get_Total_TotalCashWL() +
                      #endif
                      #if defined(SLOTS_COMPILE)
                      PSlotsStats->Get_Total_TotalCashWL() +
                      #endif
                      #if defined(VP_COMPILE)
                      PVPStats->Get_Total_TotalCashWL();
                      #endif
}
//*******************************************************************
void TStatCalcOverall::Make_AvgWLPerHourStrs()
{
  Total_AvgWLPerHourStr = MakeString(Total_AvgWLPerHour);
}
//*******************************************************************
void TStatCalcOverall::Calc_AvgWLPerHour()
{
  Total_AvgWLPerHour = GetAvgPerHour(Total_TotalCashWL,Total_SecondsPlayed);
}
//*******************************************************************
void TStatCalcOverall::Make_PeakCashWinLevelStrs()
{
  Total_PeakCashWinLevelStr = MakeString(Total_PeakWinLevel);
}
//*******************************************************************
void TStatCalcOverall::Calc_PeakCashWinLevel()
{
  Total_PeakWinLevel = 0;
  #if defined(BJ_COMPILE)
  Total_PeakWinLevel = max(Total_PeakWinLevel,PBJStats->Get_Total_PeakWinLevel());
  #endif
  #if defined(CRAPS_COMPILE)
  Total_PeakWinLevel = max(Total_PeakWinLevel,PCrapsStats->Get_Total_PeakWinLevel());
  #endif
  #if defined(KENO_COMPILE)
  Total_PeakWinLevel = max(Total_PeakWinLevel,PKenoStats->Get_Total_PeakWinLevel());
  #endif
  #if defined(ROULETTE_COMPILE)
  Total_PeakWinLevel = max(Total_PeakWinLevel,PRouletteStats->Get_Total_PeakWinLevel());
  #endif
  #if defined(SLOTS_COMPILE)
  Total_PeakWinLevel = max(Total_PeakWinLevel,PSlotsStats->Get_Total_PeakWinLevel());
  #endif
  #if defined(VP_COMPILE)
  Total_PeakWinLevel = max(Total_PeakWinLevel,PVPStats->Get_Total_PeakWinLevel());
  #endif
}
//*******************************************************************
void TStatCalcOverall::Make_LowCashLostLevelStrs()
{
  Total_LowCashLostLevelStr = MakeString(Total_LowCashLostLevel);
}
//*******************************************************************
void TStatCalcOverall::Calc_LowCashLostLevel()
{
  Total_LowCashLostLevel = Total_StartingBankroll;
  Total_LowCashLostLevel = min(Total_StartingBankroll,Total_EndingBankroll);
  #if defined(BJ_COMPILE)
  Total_LowCashLostLevel = min(Total_LowCashLostLevel,PBJStats->Get_Total_LowCashLostLevel());
  #endif
  #if defined(CRAPS_COMPILE)
  Total_LowCashLostLevel = min(Total_LowCashLostLevel,PCrapsStats->Get_Total_LowCashLostLevel());
  #endif
  #if defined(KENO_COMPILE)
  Total_LowCashLostLevel = min(Total_LowCashLostLevel,PKenoStats->Get_Total_LowCashLostLevel());
  #endif
  #if defined(ROULETTE_COMPILE)
  Total_LowCashLostLevel = min(Total_LowCashLostLevel,PRouletteStats->Get_Total_LowCashLostLevel());
  #endif
  #if defined(SLOTS_COMPILE)
  Total_LowCashLostLevel = min(Total_LowCashLostLevel,PSlotsStats->Get_Total_LowCashLostLevel());
  #endif
  #if defined(VP_COMPILE)
  Total_LowCashLostLevel = min(Total_LowCashLostLevel,PVPStats->Get_Total_LowCashLostLevel());
  #endif
}
//*******************************************************************
#if defined(BJ_COMPILE)
void TStatCalcOverall::Calc_NumBJSessions()
{
  NumBJSessions = PBJStats->Get_NumSessions();
}
#endif
//*******************************************************************
#if defined(BJ_COMPILE)
void TStatCalcOverall::Make_NumBJSessionsStr()
{
  NumBJSessionsStr = MakeString(NumBJSessions);
}
#endif
//*******************************************************************
#if defined(CRAPS_COMPILE)
void TStatCalcOverall::Calc_NumCrapsSessions()
{
  NumCrapsSessions = PCrapsStats->Get_NumSessions();
}
#endif
//*******************************************************************
#if defined(CRAPS_COMPILE)
void TStatCalcOverall::Make_NumCrapsSessionsStr()
{
  NumCrapsSessionsStr = MakeString(NumCrapsSessions);
}
#endif
//*******************************************************************
#if defined(KENO_COMPILE)
void TStatCalcOverall::Calc_NumKenoSessions()
{
  NumKenoSessions = PKenoStats->Get_NumSessions();
}
#endif
//*******************************************************************
#if defined(KENO_COMPILE)
void TStatCalcOverall::Make_NumKenoSessionsStr()
{
  NumKenoSessionsStr = MakeString(NumKenoSessions);
}
#endif
//*******************************************************************
#if defined(ROULETTE_COMPILE)
void TStatCalcOverall::Calc_NumRouletteSessions()
{
  NumRouletteSessions = PRouletteStats->Get_NumSessions();
}
#endif
//*******************************************************************
#if defined(ROULETTE_COMPILE)
void TStatCalcOverall::Make_NumRouletteSessionsStr()
{
  NumRouletteSessionsStr = MakeString(NumRouletteSessions);
}
#endif
//*******************************************************************
#if defined(SLOTS_COMPILE)
void TStatCalcOverall::Calc_NumSlotsSessions()
{
  NumSlotsSessions = PSlotsStats->Get_NumSessions();
}
#endif
//*******************************************************************
#if defined(SLOTS_COMPILE)
void TStatCalcOverall::Make_NumSlotsSessionsStr()
{
  NumSlotsSessionsStr = MakeString(NumSlotsSessions);
}
#endif
//*******************************************************************
#if defined(VP_COMPILE)
void TStatCalcOverall::Calc_NumVPSessions()
{
  NumVPSessions = PVPStats->Get_NumSessions();
}
#endif
//*******************************************************************
#if defined(VP_COMPILE)
void TStatCalcOverall::Make_NumVPSessionsStr()
{
  NumVPSessionsStr = MakeString(NumVPSessions);
}
#endif
//*******************************************************************
void TStatCalcOverall::Calc_NumAllSessions()
{
  NumAllSessions =
                   #if defined(BJ_COMPILE)
                   NumBJSessions +
                   #endif
                   #if defined(CRAPS_COMPILE)
                   NumCrapsSessions +
                   #endif
                   #if defined(KENO_COMPILE)
                   NumKenoSessions +
                   #endif
                   #if defined(ROULETTE_COMPILE)
                   NumRouletteSessions +
                   #endif
                   #if defined(SLOTS_COMPILE)
                   NumSlotsSessions +
                   #endif
                   #if defined(VP_COMPILE)
                   NumVPSessions;
                   #endif
}
//*******************************************************************
void TStatCalcOverall::Make_NumAllSessionsStr()
{
  NumAllSessionsStr = MakeString(NumAllSessions);
}
//*******************************************************************
#if defined(BJ_COMPILE)
void TStatCalcOverall::Calc_BJTotalCashBets()
{
  BJTotalCashBets = PBJStats->Get_Total_TotalCashBets();
}
#endif
//*******************************************************************
#if defined(BJ_COMPILE)
void TStatCalcOverall::Make_BJTotalCashBetsStr()
{
  BJTotalCashBetsStr = MakeString(BJTotalCashBets);
}
#endif
//*******************************************************************
#if defined(CRAPS_COMPILE)
void TStatCalcOverall::Calc_CrapsTotalCashBets()
{
  CrapsTotalCashBets = PCrapsStats->Get_Total_TotalCashBets();
}
#endif
//*******************************************************************
#if defined(CRAPS_COMPILE)
void TStatCalcOverall::Make_CrapsTotalCashBetsStr()
{
  CrapsTotalCashBetsStr = MakeString(CrapsTotalCashBets);
}
#endif
//*******************************************************************
#if defined(KENO_COMPILE)
void TStatCalcOverall::Calc_KenoTotalCashBets()
{
  KenoTotalCashBets = PKenoStats->Get_Total_TotalCashBets();
}
#endif
//*******************************************************************
#if defined(KENO_COMPILE)
void TStatCalcOverall::Make_KenoTotalCashBetsStr()
{
  KenoTotalCashBetsStr = MakeString(KenoTotalCashBets);
}
#endif
//*******************************************************************
#if defined(ROULETTE_COMPILE)
void TStatCalcOverall::Calc_RouletteTotalCashBets()
{
  RouletteTotalCashBets = PRouletteStats->Get_Total_TotalCashBets();
}
#endif
//*******************************************************************
#if defined(ROULETTE_COMPILE)
void TStatCalcOverall::Make_RouletteTotalCashBetsStr()
{
  RouletteTotalCashBetsStr = MakeString(RouletteTotalCashBets);
}
#endif
//*******************************************************************
#if defined(SLOTS_COMPILE)
void TStatCalcOverall::Calc_SlotsTotalCashBets()
{
  SlotsTotalCashBets = PSlotsStats->Get_Total_TotalCashBets();
}
#endif
//*******************************************************************
#if defined(SLOTS_COMPILE)
void TStatCalcOverall::Make_SlotsTotalCashBetsStr()
{
  SlotsTotalCashBetsStr = MakeString(SlotsTotalCashBets);
}
#endif
//*******************************************************************
#if defined(VP_COMPILE)
void TStatCalcOverall::Calc_VPTotalCashBets()
{
  VPTotalCashBets = PVPStats->Get_Total_TotalCashBets();
}
#endif
//*******************************************************************
#if defined(VP_COMPILE)
void TStatCalcOverall::Make_VPTotalCashBetsStr()
{
  VPTotalCashBetsStr = MakeString(VPTotalCashBets);
}
#endif
//*******************************************************************
#if defined(BJ_COMPILE)
void TStatCalcOverall::Calc_BJHoursPlayed()
{
  BJSecondsPlayed = PBJStats->Get_Total_SecondsPlayed();
}
#endif
//*******************************************************************
#if defined(BJ_COMPILE)
void TStatCalcOverall::Make_BJHoursPlayedStr()
{
  BJHoursPlayedStr = MakeTimeStr(BJSecondsPlayed);
}
#endif
//*******************************************************************
#if defined(CRAPS_COMPILE)
void TStatCalcOverall::Calc_CrapsHoursPlayed()
{
  CrapsSecondsPlayed = PCrapsStats->Get_Total_SecondsPlayed();
}
#endif
//*******************************************************************
#if defined(CRAPS_COMPILE)
void TStatCalcOverall::Make_CrapsHoursPlayedStr()
{
  CrapsHoursPlayedStr = MakeTimeStr(CrapsSecondsPlayed);
}
#endif
//*******************************************************************
#if defined(KENO_COMPILE)
void TStatCalcOverall::Calc_KenoHoursPlayed()
{
  KenoSecondsPlayed = PKenoStats->Get_Total_SecondsPlayed();
}
#endif
//*******************************************************************
#if defined(KENO_COMPILE)
void TStatCalcOverall::Make_KenoHoursPlayedStr()
{
  KenoHoursPlayedStr = MakeTimeStr(KenoSecondsPlayed);
}
#endif
//*******************************************************************
#if defined(ROULETTE_COMPILE)
void TStatCalcOverall::Calc_RouletteHoursPlayed()
{
  RouletteSecondsPlayed = PRouletteStats->Get_Total_SecondsPlayed();
}
#endif
//*******************************************************************
#if defined(ROULETTE_COMPILE)
void TStatCalcOverall::Make_RouletteHoursPlayedStr()
{
  RouletteHoursPlayedStr = MakeTimeStr(RouletteSecondsPlayed);
}
#endif
//*******************************************************************
#if defined(SLOTS_COMPILE)
void TStatCalcOverall::Calc_SlotsHoursPlayed()
{
  SlotsSecondsPlayed = PSlotsStats->Get_Total_SecondsPlayed();
}
#endif
//*******************************************************************
#if defined(SLOTS_COMPILE)
void TStatCalcOverall::Make_SlotsHoursPlayedStr()
{
  SlotsHoursPlayedStr = MakeTimeStr(SlotsSecondsPlayed);
}
#endif
//*******************************************************************
#if defined(VP_COMPILE)
void TStatCalcOverall::Calc_VPHoursPlayed()
{
  VPSecondsPlayed = PVPStats->Get_Total_SecondsPlayed();
}
#endif
//*******************************************************************
#if defined(VP_COMPILE)
void TStatCalcOverall::Make_VPHoursPlayedStr()
{
  VPHoursPlayedStr = MakeTimeStr(VPSecondsPlayed);
}
#endif
//*******************************************************************
#if defined(BJ_COMPILE)
void TStatCalcOverall::Calc_BJCashWL()
{
  BJCashWL = PBJStats->Get_Total_TotalCashWL();
}
#endif
//*******************************************************************
#if defined(BJ_COMPILE)
void TStatCalcOverall::Make_BJCashWLStr()
{
  BJCashWLStr = MakeString(BJCashWL);
}
#endif
//*******************************************************************
#if defined(CRAPS_COMPILE)
void TStatCalcOverall::Calc_CrapsCashWL()
{
  CrapsCashWL = PCrapsStats->Get_Total_TotalCashWL();
}
#endif
//*******************************************************************
#if defined(CRAPS_COMPILE)
void TStatCalcOverall::Make_CrapsCashWLStr()
{
  CrapsCashWLStr = MakeString(CrapsCashWL);
}
#endif
//*******************************************************************
#if defined(KENO_COMPILE)
void TStatCalcOverall::Calc_KenoCashWL()
{
  KenoCashWL = PKenoStats->Get_Total_TotalCashWL();
}
#endif
//*******************************************************************
#if defined(KENO_COMPILE)
void TStatCalcOverall::Make_KenoCashWLStr()
{
  KenoCashWLStr = MakeString(KenoCashWL);
}
#endif
//*******************************************************************
#if defined(ROULETTE_COMPILE)
void TStatCalcOverall::Calc_RouletteCashWL()
{
  RouletteCashWL = PRouletteStats->Get_Total_TotalCashWL();
}
#endif
//*******************************************************************
#if defined(ROULETTE_COMPILE)
void TStatCalcOverall::Make_RouletteCashWLStr()
{
  RouletteCashWLStr = MakeString(RouletteCashWL);
}
#endif
//*******************************************************************
#if defined(SLOTS_COMPILE)
void TStatCalcOverall::Calc_SlotsCashWL()
{
  SlotsCashWL = PSlotsStats->Get_Total_TotalCashWL();
}
#endif
//*******************************************************************
#if defined(SLOTS_COMPILE)
void TStatCalcOverall::Make_SlotsCashWLStr()
{
  SlotsCashWLStr = MakeString(SlotsCashWL);
}
#endif
//*******************************************************************
#if defined(VP_COMPILE)
void TStatCalcOverall::Calc_VPCashWL()
{
  VPCashWL = PVPStats->Get_Total_TotalCashWL();
}
#endif
//*******************************************************************
#if defined(VP_COMPILE)
void TStatCalcOverall::Make_VPCashWLStr()
{
  VPCashWLStr = MakeString(VPCashWL);
}
#endif
//*******************************************************************
#if defined(BJ_COMPILE)
void TStatCalcOverall::Calc_BJPercRet()
{
  BJPercRet = GetPercRet(BJCashWL,PBJStats->Get_Total_TotalCashBets());
}
#endif
//*******************************************************************
#if defined(BJ_COMPILE)
void TStatCalcOverall::Make_BJPercRetStr()
{
  BJPercRetStr = MakeString(BJPercRet);
}
#endif
//*******************************************************************
#if defined(CRAPS_COMPILE)
void TStatCalcOverall::Calc_CrapsPercRet()
{
  CrapsPercRet = GetPercRet(CrapsCashWL,PCrapsStats->Get_Total_TotalCashBets());
}
#endif
//*******************************************************************
#if defined(CRAPS_COMPILE)
void TStatCalcOverall::Make_CrapsPercRetStr()
{
  CrapsPercRetStr = MakeString(CrapsPercRet);
}
#endif
//*******************************************************************
#if defined(KENO_COMPILE)
void TStatCalcOverall::Calc_KenoPercRet()
{
  KenoPercRet = GetPercRet(KenoCashWL,PKenoStats->Get_Total_TotalCashBets());
}
#endif
//*******************************************************************
#if defined(KENO_COMPILE)
void TStatCalcOverall::Make_KenoPercRetStr()
{
  KenoPercRetStr = MakeString(KenoPercRet);
}
#endif
//*******************************************************************
#if defined(ROULETTE_COMPILE)
void TStatCalcOverall::Calc_RoulettePercRet()
{
  RoulettePercRet = GetPercRet(RouletteCashWL,PRouletteStats->Get_Total_TotalCashBets());
}
#endif
//*******************************************************************
#if defined(ROULETTE_COMPILE)
void TStatCalcOverall::Make_RoulettePercRetStr()
{
  RoulettePercRetStr = MakeString(RoulettePercRet);
}
#endif
//*******************************************************************
#if defined(SLOTS_COMPILE)
void TStatCalcOverall::Calc_SlotsPercRet()
{
  SlotsPercRet = GetPercRet(SlotsCashWL,PSlotsStats->Get_Total_TotalCashBets());
}
#endif
//*******************************************************************
#if defined(SLOTS_COMPILE)
void TStatCalcOverall::Make_SlotsPercRetStr()
{
  SlotsPercRetStr = MakeString(SlotsPercRet);
}
#endif
//*******************************************************************
#if defined(VP_COMPILE)
void TStatCalcOverall::Calc_VPPercRet()
{
  VPPercRet = GetPercRet(VPCashWL,PVPStats->Get_Total_TotalCashBets());
}
#endif
//*******************************************************************
#if defined(VP_COMPILE)
void TStatCalcOverall::Make_VPPercRetStr()
{
  VPPercRetStr = MakeString(VPPercRet);
}
#endif
//*******************************************************************
#if defined(BJ_COMPILE)
void TStatCalcOverall::Calc_BJCashWLPerHour()
{
  BJCashWLPerHour = GetAvgPerHour(BJCashWL,BJSecondsPlayed);
}
#endif
//*******************************************************************
#if defined(BJ_COMPILE)
void TStatCalcOverall::Make_BJCashWLPerHourStr()
{
  BJCashWLPerHourStr = MakeString(BJCashWLPerHour);
}
#endif
//*******************************************************************
#if defined(CRAPS_COMPILE)
void TStatCalcOverall::Calc_CrapsCashWLPerHour()
{
  CrapsCashWLPerHour = GetAvgPerHour(CrapsCashWL,CrapsSecondsPlayed);
}
#endif
//*******************************************************************
#if defined(CRAPS_COMPILE)
void TStatCalcOverall::Make_CrapsCashWLPerHourStr()
{
  CrapsCashWLPerHourStr = MakeString(CrapsCashWLPerHour);
}
#endif
//*******************************************************************
#if defined(KENO_COMPILE)
void TStatCalcOverall::Calc_KenoCashWLPerHour()
{
  KenoCashWLPerHour = GetAvgPerHour(KenoCashWL,KenoSecondsPlayed);
}
#endif
//*******************************************************************
#if defined(KENO_COMPILE)
void TStatCalcOverall::Make_KenoCashWLPerHourStr()
{
  KenoCashWLPerHourStr = MakeString(KenoCashWLPerHour);
}
#endif
//*******************************************************************
#if defined(ROULETTE_COMPILE)
void TStatCalcOverall::Calc_RouletteCashWLPerHour()
{
  RouletteCashWLPerHour = GetAvgPerHour(RouletteCashWL,RouletteSecondsPlayed);
}
#endif
//*******************************************************************
#if defined(ROULETTE_COMPILE)
void TStatCalcOverall::Make_RouletteCashWLPerHourStr()
{
  RouletteCashWLPerHourStr = MakeString(RouletteCashWLPerHour);
}
#endif
//*******************************************************************
#if defined(SLOTS_COMPILE)
void TStatCalcOverall::Calc_SlotsCashWLPerHour()
{
  SlotsCashWLPerHour = GetAvgPerHour(SlotsCashWL,SlotsSecondsPlayed);
}
#endif
//*******************************************************************
#if defined(SLOTS_COMPILE)
void TStatCalcOverall::Make_SlotsCashWLPerHourStr()
{
  SlotsCashWLPerHourStr = MakeString(SlotsCashWLPerHour);
}
#endif
//*******************************************************************
#if defined(VP_COMPILE)
void TStatCalcOverall::Calc_VPCashWLPerHour()
{
  VPCashWLPerHour = GetAvgPerHour(VPCashWL,VPSecondsPlayed);
}
#endif
//*******************************************************************
#if defined(VP_COMPILE)
void TStatCalcOverall::Make_VPCashWLPerHourStr()
{
  VPCashWLPerHourStr = MakeString(VPCashWLPerHour);
}
#endif
//*******************************************************************
void TStatCalcOverall::LocalCalculate()
{
  if (PPlayerData == NULL) {return;}

  #if defined(BJ_COMPILE)
  PBJStats->Calculate();
  #endif
  #if defined(CRAPS_COMPILE)
  PCrapsStats->Calculate();
  #endif
  #if defined(KENO_COMPILE)
  PKenoStats->Calculate();
  #endif
  #if defined(ROULETTE_COMPILE)
  PRouletteStats->Calculate();
  #endif
  #if defined(SLOTS_COMPILE)
  PSlotsStats->Calculate();
  #endif
  #if defined(VP_COMPILE)
  PVPStats->Calculate();
  #endif

  Calc_TotalCashBets();
  Calc_TotalNumBets();
  Calc_AvgCashBets();
  Calc_StartingBankroll();
  Calc_EndingBankroll();
  Calc_HoursPlayed();
  Calc_TotalCashWL();
  Calc_AvgWLPerHour();
  Calc_PeakCashWinLevel();
  Calc_LowCashLostLevel();
  #if defined(BJ_COMPILE)
  Calc_NumBJSessions();
  #endif
  #if defined(CRAPS_COMPILE)
  Calc_NumCrapsSessions();
  #endif
  #if defined(KENO_COMPILE)
  Calc_NumKenoSessions();
  #endif
  #if defined(ROULETTE_COMPILE)
  Calc_NumRouletteSessions();
  #endif
  #if defined(SLOTS_COMPILE)
  Calc_NumSlotsSessions();
  #endif
  #if defined(VP_COMPILE)
  Calc_NumVPSessions();
  #endif
  Calc_NumAllSessions();
  #if defined(BJ_COMPILE)
  Calc_BJTotalCashBets();
  #endif
  #if defined(CRAPS_COMPILE)
  Calc_CrapsTotalCashBets();
  #endif
  #if defined(KENO_COMPILE)
  Calc_KenoTotalCashBets();
  #endif
  #if defined(ROULETTE_COMPILE)
  Calc_RouletteTotalCashBets();
  #endif
  #if defined(SLOTS_COMPILE)
  Calc_SlotsTotalCashBets();
  #endif
  #if defined(VP_COMPILE)
  Calc_VPTotalCashBets();
  #endif
  #if defined(BJ_COMPILE)
  Calc_BJHoursPlayed();
  #endif
  #if defined(CRAPS_COMPILE)
  Calc_CrapsHoursPlayed();
  #endif
  #if defined(KENO_COMPILE)
  Calc_KenoHoursPlayed();
  #endif
  #if defined(ROULETTE_COMPILE)
  Calc_RouletteHoursPlayed();
  #endif
  #if defined(SLOTS_COMPILE)
  Calc_SlotsHoursPlayed();
  #endif
  #if defined(VP_COMPILE)
  Calc_VPHoursPlayed();
  #endif
  #if defined(BJ_COMPILE)
  Calc_BJCashWL();
  #endif
  #if defined(CRAPS_COMPILE)
  Calc_CrapsCashWL();
  #endif
  #if defined(KENO_COMPILE)
  Calc_KenoCashWL();
  #endif
  #if defined(ROULETTE_COMPILE)
  Calc_RouletteCashWL();
  #endif
  #if defined(SLOTS_COMPILE)
  Calc_SlotsCashWL();
  #endif
  #if defined(VP_COMPILE)
  Calc_VPCashWL();
  #endif
  #if defined(BJ_COMPILE)
  Calc_BJPercRet();
  #endif
  #if defined(CRAPS_COMPILE)
  Calc_CrapsPercRet();
  #endif
  #if defined(KENO_COMPILE)
  Calc_KenoPercRet();
  #endif
  #if defined(ROULETTE_COMPILE)
  Calc_RoulettePercRet();
  #endif
  #if defined(SLOTS_COMPILE)
  Calc_SlotsPercRet();
  #endif
  #if defined(VP_COMPILE)
  Calc_VPPercRet();
  #endif
  #if defined(BJ_COMPILE)
  Calc_BJCashWLPerHour();
  #endif
  #if defined(CRAPS_COMPILE)
  Calc_CrapsCashWLPerHour();
  #endif
  #if defined(KENO_COMPILE)
  Calc_KenoCashWLPerHour();
  #endif
  #if defined(ROULETTE_COMPILE)
  Calc_RouletteCashWLPerHour();
  #endif
  #if defined(SLOTS_COMPILE)
  Calc_SlotsCashWLPerHour();
  #endif
  #if defined(VP_COMPILE)
  Calc_VPCashWLPerHour();
  #endif
}
//*******************************************************************
void TStatCalcOverall::LocalMakeAllStrings()
{
  if (PPlayerData == NULL) {return;}

  Make_TotalCashBetsStrs();
  Make_TotalNumBetsStrs();
  Make_AvgCashBetsStrs();
  Make_StartingBankrollStrs();
  Make_EndingBankrollStrs();
  Make_HoursPlayedStrs();
  Make_TotalCashWLStrs();
  Make_AvgWLPerHourStrs();
  Make_PeakCashWinLevelStrs();
  Make_LowCashLostLevelStrs();

  #if defined(BJ_COMPILE)
  Make_NumBJSessionsStr();
  #endif
  #if defined(CRAPS_COMPILE)
  Make_NumCrapsSessionsStr();
  #endif
  #if defined(KENO_COMPILE)
  Make_NumKenoSessionsStr();
  #endif
  #if defined(ROULETTE_COMPILE)
  Make_NumRouletteSessionsStr();
  #endif
  #if defined(SLOTS_COMPILE)
  Make_NumSlotsSessionsStr();
  #endif
  #if defined(VP_COMPILE)
  Make_NumVPSessionsStr();
  #endif
  Make_NumAllSessionsStr();
  #if defined(BJ_COMPILE)
  Make_BJTotalCashBetsStr();
  #endif
  #if defined(CRAPS_COMPILE)
  Make_CrapsTotalCashBetsStr();
  #endif
  #if defined(KENO_COMPILE)
  Make_KenoTotalCashBetsStr();
  #endif
  #if defined(ROULETTE_COMPILE)
  Make_RouletteTotalCashBetsStr();
  #endif
  #if defined(SLOTS_COMPILE)
  Make_SlotsTotalCashBetsStr();
  #endif
  #if defined(VP_COMPILE)
  Make_VPTotalCashBetsStr();
  #endif
  #if defined(BJ_COMPILE)
  Make_BJHoursPlayedStr();
  #endif
  #if defined(CRAPS_COMPILE)
  Make_CrapsHoursPlayedStr();
  #endif
  #if defined(KENO_COMPILE)
  Make_KenoHoursPlayedStr();
  #endif
  #if defined(ROULETTE_COMPILE)
  Make_RouletteHoursPlayedStr();
  #endif
  #if defined(SLOTS_COMPILE)
  Make_SlotsHoursPlayedStr();
  #endif
  #if defined(VP_COMPILE)
  Make_VPHoursPlayedStr();
  #endif
  #if defined(BJ_COMPILE)
  Make_BJCashWLStr();
  #endif
  #if defined(CRAPS_COMPILE)
  Make_CrapsCashWLStr();
  #endif
  #if defined(KENO_COMPILE)
  Make_KenoCashWLStr();
  #endif
  #if defined(ROULETTE_COMPILE)
  Make_RouletteCashWLStr();
  #endif
  #if defined(SLOTS_COMPILE)
  Make_SlotsCashWLStr();
  #endif
  #if defined(VP_COMPILE)
  Make_VPCashWLStr();
  #endif
  #if defined(BJ_COMPILE)
  Make_BJPercRetStr();
  #endif
  #if defined(CRAPS_COMPILE)
  Make_CrapsPercRetStr();
  #endif
  #if defined(KENO_COMPILE)
  Make_KenoPercRetStr();
  #endif
  #if defined(ROULETTE_COMPILE)
  Make_RoulettePercRetStr();
  #endif
  #if defined(SLOTS_COMPILE)
  Make_SlotsPercRetStr();
  #endif
  #if defined(VP_COMPILE)
  Make_VPPercRetStr();
  #endif
  #if defined(BJ_COMPILE)
  Make_BJCashWLPerHourStr();
  #endif
  #if defined(CRAPS_COMPILE)
  Make_CrapsCashWLPerHourStr();
  #endif
  #if defined(KENO_COMPILE)
  Make_KenoCashWLPerHourStr();
  #endif
  #if defined(ROULETTE_COMPILE)
  Make_RouletteCashWLPerHourStr();
  #endif
  #if defined(SLOTS_COMPILE)
  Make_SlotsCashWLPerHourStr();
  #endif
  #if defined(VP_COMPILE)
  Make_VPCashWLPerHourStr();
  #endif
}
//*******************************************************************
void TStatCalcOverall::LocalFillGrid()
{
  if (PPlayerData == NULL) {return;}

  PStatDlg->totalcol[oTotalCashBet] = Total_TotalCashBetsStr;
  PStatDlg->totalcol[oAvgCashBet] = Total_AvgCashBetsStr;
  PStatDlg->totalcol[oStartingBankroll] = Total_StartingBankrollStr;
  PStatDlg->totalcol[oEndingBankroll] = Total_EndingBankrollStr;
  PStatDlg->totalcol[oTotalHoursPlayed] = Total_HoursPlayedStr;
  PStatDlg->totalcol[oTotalCashWL] = Total_TotalCashWLStr;
  PStatDlg->totalcol[oAvgWLPerHour] = Total_AvgWLPerHourStr;
  PStatDlg->totalcol[oCumCashWL] = Total_TotalCashWLStr;
  PStatDlg->totalcol[oPeakCashWinLevel] = Total_PeakCashWinLevelStr;
  PStatDlg->totalcol[oLowCashLossLevel] = Total_LowCashLostLevelStr;
  PStatDlg->totalcol[oSESSIONSRECORDED] = NumAllSessionsStr;

  #if defined(BJ_COMPILE)
  PStatDlg->totalcol[oBJSessions] = NumBJSessionsStr;
  #endif
  #if defined(CRAPS_COMPILE)
  PStatDlg->totalcol[oCrapsSessions] = NumCrapsSessionsStr;
  #endif
  #if defined(KENO_COMPILE)
  PStatDlg->totalcol[oKenoSessions] = NumKenoSessionsStr;
  #endif
  #if defined(ROULETTE_COMPILE)
  PStatDlg->totalcol[oRouletteSessions] = NumRouletteSessionsStr;
  #endif
  #if defined(SLOTS_COMPILE)
  PStatDlg->totalcol[oSlotsSessions] = NumSlotsSessionsStr;
  #endif
  #if defined(VP_COMPILE)
  PStatDlg->totalcol[oVPSessions] = NumVPSessionsStr;
  #endif
  #if defined(BJ_COMPILE)
  PStatDlg->totalcol[oBJCash] = BJTotalCashBetsStr;
  #endif
  #if defined(CRAPS_COMPILE)
  PStatDlg->totalcol[oCrapsCash] = CrapsTotalCashBetsStr;
  #endif
  #if defined(KENO_COMPILE)
  PStatDlg->totalcol[oKenoCash] = KenoTotalCashBetsStr;
  #endif
  #if defined(ROULETTE_COMPILE)
  PStatDlg->totalcol[oRouletteCash] = RouletteTotalCashBetsStr;
  #endif
  #if defined(SLOTS_COMPILE)
  PStatDlg->totalcol[oSlotsCash] = SlotsTotalCashBetsStr;
  #endif
  #if defined(VP_COMPILE)
  PStatDlg->totalcol[oVPCash] = VPTotalCashBetsStr;
  #endif
  #if defined(BJ_COMPILE)
  PStatDlg->totalcol[oBJHoursPlayed] = BJHoursPlayedStr;
  #endif
  #if defined(CRAPS_COMPILE)
  PStatDlg->totalcol[oCrapsHoursPlayed] = CrapsHoursPlayedStr;
  #endif
  #if defined(KENO_COMPILE)
  PStatDlg->totalcol[oKenoHoursPlayed] = KenoHoursPlayedStr;
  #endif
  #if defined(ROULETTE_COMPILE)
  PStatDlg->totalcol[oRouletteHoursPlayed] = RouletteHoursPlayedStr;
  #endif
  #if defined(SLOTS_COMPILE)
  PStatDlg->totalcol[oSlotsHoursPlayed] = SlotsHoursPlayedStr;
  #endif
  #if defined(VP_COMPILE)
  PStatDlg->totalcol[oVPHoursPlayed] = VPHoursPlayedStr;
  #endif
  #if defined(BJ_COMPILE)
  PStatDlg->totalcol[oBJCashWL] = BJCashWLStr;
  #endif
  #if defined(CRAPS_COMPILE)
  PStatDlg->totalcol[oCrapsCashWL] = CrapsCashWLStr;
  #endif
  #if defined(KENO_COMPILE)
  PStatDlg->totalcol[oKenoCashWL] = KenoCashWLStr;
  #endif
  #if defined(ROULETTE_COMPILE)
  PStatDlg->totalcol[oRouletteCashWL] = RouletteCashWLStr;
  #endif
  #if defined(SLOTS_COMPILE)
  PStatDlg->totalcol[oSlotsCashWL] = SlotsCashWLStr;
  #endif
  #if defined(VP_COMPILE)
  PStatDlg->totalcol[oVPCashWL] = VPCashWLStr;
  #endif
  #if defined(BJ_COMPILE)
  PStatDlg->totalcol[oBJPerc] = BJPercRetStr;
  #endif
  #if defined(CRAPS_COMPILE)
  PStatDlg->totalcol[oCrapsPerc] = CrapsPercRetStr;
  #endif
  #if defined(KENO_COMPILE)
  PStatDlg->totalcol[oKenoPerc] = KenoPercRetStr;
  #endif
  #if defined(ROULETTE_COMPILE)
  PStatDlg->totalcol[oRoulettePerc] = RoulettePercRetStr;
  #endif
  #if defined(SLOTS_COMPILE)
  PStatDlg->totalcol[oSlotsPerc] = SlotsPercRetStr;
  #endif
  #if defined(VP_COMPILE)
  PStatDlg->totalcol[oVPPerc] = VPPercRetStr;
  #endif
  #if defined(BJ_COMPILE)
  PStatDlg->totalcol[oBJCashWLPerHour] = BJCashWLPerHourStr;
  #endif
  #if defined(CRAPS_COMPILE)
  PStatDlg->totalcol[oCrapsWLPerHour] = CrapsCashWLPerHourStr;
  #endif
  #if defined(KENO_COMPILE)
  PStatDlg->totalcol[oKenoWLPerHour] = KenoCashWLPerHourStr;
  #endif
  #if defined(ROULETTE_COMPILE)
  PStatDlg->totalcol[oRouletteWLPerHour] = RouletteCashWLPerHourStr;
  #endif
  #if defined(SLOTS_COMPILE)
  PStatDlg->totalcol[oSlotsWLPerHour] = SlotsCashWLPerHourStr;
  #endif
  #if defined(VP_COMPILE)
  PStatDlg->totalcol[oVPWLPerHour] = VPCashWLPerHourStr;
  #endif
}
//*******************************************************************
