//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  cstatdlg.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     9/6/96     M.Perry    derived from Dave's code.
//********************************************************************
#include "cstatdlg.h"
#include <stdio.h>

#if defined(VP_COMPILE)
  #include "cvpcalc.h"
#endif

#if defined(SLOTS_COMPILE)
  #include "cscalc.h"
#endif

#if defined(KENO_COMPILE)
  #include "ckcalc.h"
#endif

#if defined(BJ_COMPILE)
  #include "cbjcalc.h"
#endif

#if defined(CRAPS_COMPILE)
  #include "cccalc.h"
#endif

#if defined(ROULETTE_COMPILE)
  #include "crcalc.h"
#endif

#if defined(OVERALL_COMPILE)
  #include "cocalc.h"
#endif

#include "cplaymgr.h"
#include "cgraph.h"
#include "oapp.h"
//*******************************************************************
DEFINE_RESPONSE_TABLE1(TCasinoStatDlg,TDialog)
  EV_COMMAND(cmGraph,CmGraph),
  EV_COMMAND(cmUp,ScrollUp),
  EV_COMMAND(cmDown,ScrollDown),
  EV_COMMAND(cmLeft,ScrollLeft),
  EV_COMMAND(cmRight,ScrollRight),
  #if defined(GAMES_COMBOBOX)
  EV_CBN_SELCHANGE(IDC_STAT_GAME_CB,EvGameChange),
  #endif
  EV_CBN_SELCHANGE(IDC_STAT_NAME_CB,EvNameChange),
END_RESPONSE_TABLE;
//*******************************************************************
TCasinoStatDlg::TCasinoStatDlg(TWindow *parent,TCasinoPlayerMgr *pplayermgr,int16 playernum)
#if defined(GAMES_COMBOBOX)
:TDialog(parent,IDD_STATISTICS),
#else
:TDialog(parent,IDD_STATISTICS_1GAME),
#endif
 PPlayerMgr(pplayermgr),
 PlayerTTIndex(-1),
 m_NUMROWS(17),
 m_NUMCOLS(6),
 m_CELLWIDTH(9),
 m_LABELWIDTH(17),
 #if defined(BJ_COMPILE)
 m_NUMBLACKJACKROWS(59),
 #endif
 #if defined(CRAPS_COMPILE)
 m_NUMCRAPSROWS(138),
 #endif
 #if defined(KENO_COMPILE)
 m_NUMKENOROWS(101),
 #endif
 #if defined(ROULETTE_COMPILE)
 m_NUMROULETTEROWS(108),
 #endif
 #if defined(SLOTS_COMPILE)
 m_NUMSLOTSROWS(28),
 #endif
 #if defined(VP_COMPILE)
 m_NUMVIDEOPOKERROWS(TStatCalcVP::vpNumRows),//75),
 #endif
 #if defined(OVERALL_COMPILE)
 m_NUMOVERALLROWS(TStatCalcOverall::oNumRows),//59),
 #endif
 m_bSound(true),
 m_currentX(1),
 m_currentY(1),
 GameType(gtOverall),
 PlayerNumTT(NULL),
 LastPlayerTTNum(-1),
 PPlayerData(NULL)
{
  strEmpty = "";
  strGameStatsContinued = "GAME STATS (cont'd)";
  strTotalCashBetContinued = "TOTAL $ BET (cont'd)";
  strTotalCashWLContinued = "TOTAL $ WON/LOST (cont'd)";
  strTrendAnalysisContinued = "TREND ANALYSIS (cont'd)";
  strPercRetContinued = "% RETURN (cont'd)";

  #if defined(BJ_COMPILE)
  strBlackJack = "Blackjack";
  #endif
  #if defined(CRAPS_COMPILE)
  strCraps = "Craps";
  #endif
  #if defined(KENO_COMPILE)
  strKeno = "Keno";
  #endif
  #if defined(ROULETTE_COMPILE)
  strRoulette = "Roulette";
  #endif
  #if defined(SLOTS_COMPILE)
  strSlots = "Slots";
  #endif
  #if defined(VP_COMPILE)
  strVideoPoker = "Video Poker";
  #endif
  #if defined(OVERALL_COMPILE)
  strOverall = "Overall";
  #endif
  strStatistics = "Statistics";
  strfor = "for";
  strCumulative = "Cumulative";
  strSpace = " ";

  SetupGameTT();
  SetupPlayerNumTT();

  for (int16 i=0;i<=LastPlayerTTNum;i++)
  {
    if (PlayerNumTT[i] == playernum)
    {
      PlayerTTIndex = i;
      break;
    }
  }

  if (PlayerTTIndex < 0 && LastPlayerTTNum >= 0)
  {
    PlayerTTIndex = 0;
  }

  #if defined(VP_COMPILE)
  PVPStats = new TStatCalcVP(this);
  #endif

  #if defined(SLOTS_COMPILE)
  PSlotsStats = new TStatCalcSlots(this);
  #endif

  #if defined(KENO_COMPILE)
  PKenoStats = new TStatCalcKeno(this);
  #endif

  #if defined(BJ_COMPILE)
  PBJStats = new TStatCalcBJ(this);
  #endif

  #if defined(ROULETTE_COMPILE)
  PRouletteStats = new TStatCalcRoulette(this);
  #endif

  #if defined(CRAPS_COMPILE)
  PCrapsStats = new TStatCalcCraps(this);
  #endif

  #if defined(OVERALL_COMPILE)
  POverallStats = new TStatCalcOverall(this);
  #endif

  SetupPlayerData();

  #if defined(GAMES_COMBOBOX)
  if (PPlayerData != NULL)
  {
    if (PPlayerData->GameType > gtNone && PPlayerData->GameType <= gtOverall)
    {
      GameType = int16(PPlayerData->GameType);
    }
  }
  #elif defined(VP_COMPILE)
  GameType = gtVideoPoker;
  #elif defined(SLOTS_COMPILE)
  GameType = gtSlots;
  #endif

  m_btnGraph = new TButton(this,cmGraph);
  EmptyCacheAndTotals();
  #if defined(GAMES_COMBOBOX)
  PGames_CB = new TComboBox(this,IDC_STAT_GAME_CB);
  #else
  PGames_STB = new TStatic(this,IDC_GAMENAME);
  #endif
  PNames_CB = new TComboBox(this,IDC_STAT_NAME_CB);

  // mrp - v2.4 - 09/16/99 - conditional compile around bg color
  #if defined(ENB_STATS_BGCOLOR)
  SetBkgndColor(TColor(RGB(36,152,194))); // light blue.
  #endif
}
//*******************************************************************
TCasinoStatDlg::~TCasinoStatDlg()
{
  if (m_btnGraph)
  {
    delete m_btnGraph;
  }
  #if defined(GAMES_COMBOBOX)
  delete PGames_CB;
  PGames_CB = NULL;
  #else
  delete PGames_STB;
  PGames_STB = NULL;
  #endif
  delete PNames_CB;
  PNames_CB = NULL;

  delete [] PlayerNumTT;
  LastPlayerTTNum = -1;
}
//*******************************************************************
void TCasinoStatDlg::SetupGameTT()
{
//  #if defined(VPLITE_COMPILE)
//  GameTT[0] = gtVideoPoker;
//  #elif defined(SLOTLITE_COMPILE)
//  GameTT[0] = gtSlots;
//  #elif defined(KENOLITE_COMPILE)
//  GameTT[0] = gtKeno;
//  #else
//  GameTT[0] = gtBlackJack;
//  GameTT[1] = gtCraps;
//  GameTT[2] = gtRoulette;
//  GameTT[3] = gtKeno;
//  GameTT[4] = gtVideoPoker;
//  GameTT[5] = gtSlots;
//  GameTT[6] = gtOverall;
//  #endif

  int16 i = 0;
  #if defined(BJ_COMPILE)
  GameTT[i++] = gtBlackJack;
  #endif
  #if defined(CRAPS_COMPILE)
  GameTT[i++] = gtCraps;
  #endif
  #if defined(ROULETTE_COMPILE)
  GameTT[i++] = gtRoulette;
  #endif
  #if defined(KENO_COMPILE)
  GameTT[i++] = gtKeno;
  #endif
  #if defined(VP_COMPILE)
  GameTT[i++] = gtVideoPoker;
  #endif
  #if defined(SLOTS_COMPILE)
  GameTT[i++] = gtSlots;
  #endif
  #if defined(OVERALL_COMPILE)
  GameTT[i++] = gtOverall;
  #endif
}
//*******************************************************************
int16 TCasinoStatDlg::GetGameTTIndex(int16 gametype)
{
  for (int16 i=0;i<NUM_STAT_GAMES;i++)
  {
    if (GameTT[i] == gametype) {return i;}
  }
  return 0;
}
//*******************************************************************
void TCasinoStatDlg::LoadGamesCB()
{
  #if defined(GAMES_COMBOBOX)

    #if defined(BJ_COMPILE)
    PGames_CB->AddString(strBlackJack.c_str());
    #endif
    #if defined(CRAPS_COMPILE)
    PGames_CB->AddString(strCraps.c_str());
    #endif
    #if defined(ROULETTE_COMPILE)
    PGames_CB->AddString(strRoulette.c_str());
    #endif
    #if defined(KENO_COMPILE)
    PGames_CB->AddString(strKeno.c_str());
    #endif
    #if defined(VP_COMPILE)
    PGames_CB->AddString(strVideoPoker.c_str());
    #endif
    #if defined(SLOTS_COMPILE)
    PGames_CB->AddString(strSlots.c_str());
    #endif
    #if defined(OVERALL_COMPILE)
    PGames_CB->AddString(strOverall.c_str());
    #endif

    int16 index = GetGameTTIndex(GetGameType());
    PGames_CB->SetSelIndex(index);
  #else
    #if defined(BJ_COMPILE)
    PGames_STB->SetText(strBlackJack.c_str());
    #elif defined(CRAPS_COMPILE)
    PGames_STB->SetText(strCraps.c_str());
    #elif defined(ROULETTE_COMPILE)
    PGames_STB->SetText(strRoulette.c_str());
    #elif defined(KENO_COMPILE)
    PGames_STB->SetText(strKeno.c_str());
    #elif defined(VP_COMPILE)
    PGames_STB->SetText(strVideoPoker.c_str());
    #elif defined(SLOTS_COMPILE)
    PGames_STB->SetText(strSlots.c_str());
    #else
    PGames_STB->SetText("Unknown game");
    #endif
  #endif
}
//*******************************************************************
void TCasinoStatDlg::SetupPlayerNumTT()
{
  PlayerNumTTSize = PPlayerMgr->GetNumPlayersAllowed();
  PlayerNumTT = new int16[PlayerNumTTSize];
  LastPlayerTTNum = -1;
  for (int16 i=0;i<PlayerNumTTSize;i++)
  {
    if (PPlayerMgr->IsPlayerValid(i))
    {
      LastPlayerTTNum++;
      PlayerNumTT[LastPlayerTTNum] = i;
    }
  }
}
//*******************************************************************
void TCasinoStatDlg::LoadNamesCB()
{
  for (int16 i=0;i<=LastPlayerTTNum;i++)
  {
    string name = PPlayerMgr->GetPlayerName(PlayerNumTT[i]);
    PNames_CB->AddString(name.c_str());
  }
  PNames_CB->SetSelIndex(PlayerTTIndex);
}
//*******************************************************************
string TCasinoStatDlg::GetPlayerName()
{
  if (PPlayerData == NULL) {return string("Nobody");}
  return PPlayerData->GetName();
}
//*******************************************************************
void TCasinoStatDlg::SetupPlayerData()
{
  if ((PlayerTTIndex < 0) || (PlayerTTIndex > LastPlayerTTNum)) {return;}
  PPlayerMgr->ReleaseUnActivePlayerData();
  PPlayerData = PPlayerMgr->GetCasinoPlayerDataPtr(PlayerNumTT[PlayerTTIndex]);

  #if defined(BJ_COMPILE)
  PBJStats->GetPlayerData();
  #endif

  #if defined(CRAPS_COMPILE)
  PCrapsStats->GetPlayerData();
  #endif

  #if defined(ROULETTE_COMPILE)
  PRouletteStats->GetPlayerData();
  #endif

  #if defined(KENO_COMPILE)
  PKenoStats->GetPlayerData();
  #endif

  #if defined(VP_COMPILE)
  PVPStats->GetPlayerData();
  #endif

  #if defined(SLOTS_COMPILE)
  PSlotsStats->GetPlayerData();
  #endif

  #if defined(OVERALL_COMPILE)
  POverallStats->GetPlayerData();
  #endif
}
//*******************************************************************
void TCasinoStatDlg::EvNameChange()
{
  if (LastPlayerTTNum == 0) {return;}
  PlayerTTIndex = int16(PNames_CB->GetSelIndex());
  if (PlayerTTIndex > LastPlayerTTNum) {PlayerTTIndex = 0;}
  SetupPlayerData();
//  #if defined(VPLITE_COMPILE)
//  CmVideoPoker();
//  #elif defined(SLOTLITE_COMPILE)
//  CmSlots();
//  #elif defined(KENOLITE_COMPILE)
//  CmKeno();
//  #else
//  switch (GetGameType())
//  {
//    case gtBlackJack  : CmBlackjack();  break;
//    case gtCraps      : CmCraps();      break;
//    case gtKeno       : CmKeno();       break;
//    case gtRoulette   : CmRoulette();   break;
//    case gtSlots      : CmSlots();      break;
//    case gtVideoPoker : CmVideoPoker(); break;
//    case gtOverall    : CmOverall();    break;
//  }
//  #endif

  switch(GetGameType())
  {
    #if defined(BJ_COMPILE)
    case gtBlackJack  : CmBlackjack();break;
    #endif
    #if defined(CRAPS_COMPILE)
    case gtCraps      : CmCraps();break;
    #endif
    #if defined(KENO_COMPILE)
    case gtKeno       : CmKeno();break;
    #endif
    #if defined(ROULETTE_COMPILE)
    case gtRoulette   : CmRoulette();break;
    #endif
    #if defined(SLOTS_COMPILE)
    case gtSlots      : CmSlots();break;
    #endif
    #if defined(VP_COMPILE)
    case gtVideoPoker : CmVideoPoker();break;
    #endif
    #if defined(OVERALL_COMPILE)
    case gtOverall    : CmOverall();break;
    #endif
  }
}
//*******************************************************************
#if defined(GAMES_COMBOBOX)
void TCasinoStatDlg::EvGameChange()
{
//  #if defined(VPLITE_COMPILE)
//  CmVideoPoker();
//  #elif defined(SLOTLITE_COMPILE)
//  CmSlots();
//  #elif defined(KENOLITE_COMPILE)
//  CmKeno();
//  #else
//  int sel = PGames_CB->GetSelIndex();
//  if (!CheckGameIndex(sel)) {return;}
//  SetGameType(GameTT[sel]);
//  switch(GetGameType())
//  {
//    case gtVideoPoker : CmVideoPoker();break;
//    case gtBlackJack  : CmBlackjack();break;
//    case gtRoulette   : CmRoulette();break;
//    case gtCraps      : CmCraps();break;
//    case gtSlots      : CmSlots();break;
//    case gtKeno       : CmKeno();break;
//    case gtOverall    : CmOverall();break;
//  }
//  #endif

  int16 sel = int16(PGames_CB->GetSelIndex());
  if (!CheckGameIndex(sel)) {return;}
  SetGameType(GameTT[sel]);
  switch (GetGameType())
  {
    #if defined(VP_COMPILE)
    case gtVideoPoker : CmVideoPoker();break;
    #endif
    #if defined(BJ_COMPILE)
    case gtBlackJack  : CmBlackjack();break;
    #endif
    #if defined(ROULETTE_COMPILE)
    case gtRoulette   : CmRoulette();break;
    #endif
    #if defined(CRAPS_COMPILE)
    case gtCraps      : CmCraps();break;
    #endif
    #if defined(SLOTS_COMPILE)
    case gtSlots      : CmSlots();break;
    #endif
    #if defined(KENO_COMPILE)
    case gtKeno       : CmKeno();break;
    #endif
    #if defined(OVERALL_COMPILE)
    case gtOverall    : CmOverall();break;
    #endif
  }
}
#endif
//*******************************************************************
#if defined(BJ_COMPILE)
void TCasinoStatDlg::CmBlackjack()
{
//	SetGameType(gtBlackJack);
   m_currentX = 1;
   m_currentY = PBJStats->LastSessionNum - 2;
   if (m_currentY < 1) {m_currentY = 1;}
   SetTitleToNameAndGame();
   EmptyCacheAndTotals();
   PaintGrid();
   PBJStats->FillGrid();
	PaintGrid();
	m_btnGraph->EnableWindow(true);
}
#endif
//*******************************************************************
#if defined(CRAPS_COMPILE)
void TCasinoStatDlg::CmCraps()
{
//	 SetGameType(gtCraps);
  m_currentX = 1;
  m_currentY = PCrapsStats->LastSessionNum - 2;
  if (m_currentY < 1) {m_currentY = 1;}
  SetTitleToNameAndGame();
  EmptyCacheAndTotals();
  PaintGrid();
  PCrapsStats->FillGrid();
  PaintGrid();
  m_btnGraph->EnableWindow(true);
}
#endif
//*******************************************************************
#if defined(KENO_COMPILE)
void TCasinoStatDlg::CmKeno()
{
//	SetGameType(gtKeno);
  m_currentX = 1;
  m_currentY = PKenoStats->LastSessionNum - 2;
  if (m_currentY < 1) {m_currentY = 1;}
  SetTitleToNameAndGame();
  EmptyCacheAndTotals();
  PaintGrid();
  PKenoStats->FillGrid();
  PaintGrid();
  m_btnGraph->EnableWindow(true);
}
#endif
//*******************************************************************
#if defined(ROULETTE_COMPILE)
void TCasinoStatDlg::CmRoulette()
{
//	SetGameType(gtRoulette);
  m_currentX = 1;
  m_currentY = PRouletteStats->LastSessionNum - 2;
  if (m_currentY < 1) {m_currentY = 1;}
  SetTitleToNameAndGame();
  EmptyCacheAndTotals();
  PaintGrid();
  PRouletteStats->FillGrid();
  PaintGrid();
  m_btnGraph->EnableWindow(true);
}
#endif
//*******************************************************************
#if defined(SLOTS_COMPILE)
void TCasinoStatDlg::CmSlots()
{
//	SetGameType(gtSlots);
  m_currentX = 1;
  m_currentY = PSlotsStats->LastSessionNum - 2;
  if (m_currentY < 1) {m_currentY = 1;}
  SetTitleToNameAndGame();
  EmptyCacheAndTotals();
  PaintGrid();
  PSlotsStats->FillGrid();
  PaintGrid();
  m_btnGraph->EnableWindow(true);
}
#endif
//*******************************************************************
#if defined(VP_COMPILE)
void TCasinoStatDlg::CmVideoPoker()
{
//	SetGameType(gtVideoPoker);
  m_currentX = 1;
  m_currentY = PVPStats->LastSessionNum - 2;
  if (m_currentY < 1) {m_currentY = 1;}
  SetTitleToNameAndGame();
  EmptyCacheAndTotals();
  PaintGrid();
  PVPStats->FillGrid();
  PaintGrid();
  m_btnGraph->EnableWindow(true);
}
#endif
//*******************************************************************
#if defined(OVERALL_COMPILE)
void TCasinoStatDlg::CmOverall()
{
//	SetGameType(gtOverall);
  m_currentX = 1;
  m_currentY = 1;
  SetTitleToNameAndGame();
  EmptyCacheAndTotals();
  PaintGrid();
  POverallStats->FillGrid();
  m_btnGraph->EnableWindow(false);
  PaintGrid();
}
#endif
//*******************************************************************
void TCasinoStatDlg::CmGraph()
{
   TCasinoGraphDlg *PGraphDialog = NULL;
   switch (GetGameType())
   {
     #if defined(BJ_COMPILE)
     case gtBlackJack: PGraphDialog = new TBJGraph(this,PBJStats);             break;
     #endif
     #if defined(KENO_COMPILE)
     case gtKeno:      PGraphDialog = new TKenoGraph(this,PKenoStats);         break;
     #endif
     #if defined(VP_COMPILE)
     case gtVideoPoker:PGraphDialog = new TVPGraph(this,PVPStats);             break;
     #endif
     #if defined(CRAPS_COMPILE)
     case gtCraps:     PGraphDialog = new TCrapsGraph(this,PCrapsStats);       break;
     #endif
     #if defined(ROULETTE_COMPILE)
     case gtRoulette:  PGraphDialog = new TRouletteGraph(this,PRouletteStats); break;
     #endif
     #if defined(SLOTS_COMPILE)
     case gtSlots:     PGraphDialog = new TSlotsGraph(this,PSlotsStats);       break;
     #endif
     default: return;
   };
   if (PGraphDialog != NULL)
   {
     PGraphDialog->Execute();
     delete PGraphDialog;
//     PGraphDialog = NULL;
   }
}
//*******************************************************************
#if defined(BJ_COMPILE)
void TCasinoStatDlg::ScrollUpBJ()
{
  switch(m_currentX)
  {
    case  1:	if (m_bSound) ::MessageBeep(-1);  break;
    case  5:   ResetX(1,strEmpty);               break;
    case 16:   ResetX(5,strEmpty);               break;
    case 31:   ResetX(16,strEmpty);              break;
    case 42:   ResetX(31,strGameStatsContinued); break;
    case 50:   ResetX(42,strGameStatsContinued); break;
  }
}
#endif
//*******************************************************************
#if defined(CRAPS_COMPILE)
void TCasinoStatDlg::ScrollUpCraps()
{
  switch(m_currentX)
  {
    case  1:   if (m_bSound) ::MessageBeep(-1);     break;
    case  5:   ResetX(1,strEmpty);                  break;
    case 18:   ResetX(5,strEmpty);                  break;
    case 30:   ResetX(18,strEmpty);                 break;
    case 42:   ResetX(30,strEmpty);                 break;
    case 54:   ResetX(42,strEmpty);                 break;
    case 70:   ResetX(54,strEmpty);                 break;
    case 81:   ResetX(70,strTotalCashBetContinued); break;
    case 97:   ResetX(81,strEmpty);                 break;
    case 109:  ResetX(97,strTotalCashWLContinued);  break;
    case 125:  ResetX(109,strEmpty);                break;
  }
}
#endif
//*******************************************************************
#if defined(ROULETTE_COMPILE)
void TCasinoStatDlg::ScrollUpRoulette()
{
  switch(m_currentX)
  {
    case  1:	if (m_bSound) ::MessageBeep(-1); break;
    case  5:   ResetX(1,strEmpty);break;
    case 16:   ResetX(5,strEmpty);break;
    case 32:   ResetX(16,strEmpty);break;
    case 40:   ResetX(32,strGameStatsContinued);break;
    case 57:   ResetX(40,strEmpty);break;
    case 74:   ResetX(57,strEmpty);break;
    case 88:   ResetX(74,strTrendAnalysisContinued);break;
    case 102:  ResetX(88,strTrendAnalysisContinued);break;
  }
}
#endif
//*******************************************************************
#if defined(KENO_COMPILE)
void TCasinoStatDlg::ScrollUpKeno()
{
  switch(m_currentX)
  {
    case  1:	if (m_bSound) ::MessageBeep(-1);break;
    case  5:   ResetX(1,strEmpty);break;
    case 16:   ResetX(5,strEmpty);break;
    case 29:   ResetX(16,strEmpty);break;
    case 46:   ResetX(29,strEmpty);break;
    case 63:   ResetX(46,strEmpty);break;
    case 80:   ResetX(63,strEmpty);break;
    case 96:   ResetX(80,strEmpty);break;
  }
}
#endif
//*******************************************************************
#if defined(SLOTS_COMPILE)
void TCasinoStatDlg::ScrollUpSlots()
{
  switch(m_currentX)
  {
    case  1:   if (m_bSound) ::MessageBeep(-1); break;
    case  5:   ResetX(1,strEmpty);break;
    case 16:   ResetX(5,strEmpty);break;
  }
}
#endif
//*******************************************************************
#if defined(VP_COMPILE)
void TCasinoStatDlg::ScrollUpVP()
{
  #if defined(ACVP_COMPILE)
  switch(m_currentX)
  {
    case TStatCalcVP::vpDate            : if (m_bSound) ::MessageBeep(-1);break;
    case TStatCalcVP::vpWinLossStats    : ResetX(TStatCalcVP::vpDate,strEmpty);break;
    case TStatCalcVP::vpGameStats       : ResetX(TStatCalcVP::vpWinLossStats,strEmpty);break;
    case TStatCalcVP::vpNumOccurrences  : ResetX(TStatCalcVP::vpGameStats,strEmpty);break;
    case TStatCalcVP::vpOcc1            : ResetX(TStatCalcVP::vpNumOccurrences,strEmpty);break;
    case TStatCalcVP::vpOcc2            : ResetX(TStatCalcVP::vpOcc1,"# occ (cont)");break;
    case TStatCalcVP::vpOcc3            : ResetX(TStatCalcVP::vpOcc2,"# occ (cont)");break;
    case TStatCalcVP::vpTotalCashWins   : ResetX(TStatCalcVP::vpOcc3,"# occ (cont)");break;
    case TStatCalcVP::vpCash1           : ResetX(TStatCalcVP::vpTotalCashWins,strEmpty);break;
    case TStatCalcVP::vpCash2           : ResetX(TStatCalcVP::vpCash1,"cash (cont)");break;
    case TStatCalcVP::vpCash3           : ResetX(TStatCalcVP::vpCash2,"cash (cont)");break;
    case TStatCalcVP::vpPercTotalCashWon: ResetX(TStatCalcVP::vpCash3,"cash (cont)");break;
    case TStatCalcVP::vpPerc1           : ResetX(TStatCalcVP::vpPercTotalCashWon,strEmpty);break;
    case TStatCalcVP::vpPerc2           : ResetX(TStatCalcVP::vpPerc1,"perc (cont)");break;
    case TStatCalcVP::vpPerc3           : ResetX(TStatCalcVP::vpPerc2,"perc (cont)");break;
    case TStatCalcVP::vpAdvancedStats   : ResetX(TStatCalcVP::vpPerc3,"perc (cont)");break;
  }
  #else
  switch(m_currentX)
  {
    case  TStatCalcVP::vpDate           : if (m_bSound) ::MessageBeep(-1);break;
    case  TStatCalcVP::vpWinLossStats   : ResetX(TStatCalcVP::vpDate,strEmpty);break;
    case TStatCalcVP::vpGameStats       : ResetX(TStatCalcVP::vpWinLossStats,strEmpty);break;
    case TStatCalcVP::vpNumOccurrences  : ResetX(TStatCalcVP::vpGameStats,strEmpty);break;
    case TStatCalcVP::vpTotalCashWins   : ResetX(TStatCalcVP::vpNumOccurrences,strEmpty);break;
    case TStatCalcVP::vpPercTotalCashWon: ResetX(TStatCalcVP::vpTotalCashWins,strEmpty);break;
    case TStatCalcVP::vpAdvancedStats   : ResetX(TStatCalcVP::vpPercTotalCashWon,strEmpty);break;
  }
  #endif
}
#endif
//*******************************************************************
#if defined(OVERALL_COMPILE)
void TCasinoStatDlg::ScrollUpOverall()
{
  switch(m_currentX)
  {
    case 1                                   : if (m_bSound) ::MessageBeep(-1);break;
    case TStatCalcOverall::oSESSIONS         : ResetX(1,strEmpty);break;
    case TStatCalcOverall::oTOTALCASHBET     : ResetX(TStatCalcOverall::oSESSIONS,strEmpty);break;
    case TStatCalcOverall::oTOTALHOURSPLAYED : ResetX(TStatCalcOverall::oTOTALCASHBET,strEmpty);break;
    case TStatCalcOverall::oTOTALCASHWL      : ResetX(TStatCalcOverall::oTOTALHOURSPLAYED,strEmpty);break;
    case TStatCalcOverall::oRETURNPERC       : ResetX(TStatCalcOverall::oTOTALCASHWL,strEmpty);break;
    case TStatCalcOverall::oWLPERHOUR        : ResetX(TStatCalcOverall::oRETURNPERC,strEmpty);break;

//    case  12:   ResetX( 1,strEmpty);break;
//    case  21:   ResetX(12,strEmpty);break;
//    case  37:   ResetX(21,strEmpty);break;
//    case  53:   ResetX(37,strEmpty);break;
  }
}
#endif
//*******************************************************************
void TCasinoStatDlg::ScrollUp()
{
//  #if defined(VPLITE_COMPILE)
//  ScrollUpVP();
//  #elif defined(SLOTLITE_COMPILE)
//  ScrollUpSlots();
//  #elif defined(KENOLITE_COMPILE)
//  ScrollUpKeno();
//  #else
//	switch(GetGameType())
//	{
//		case gtBlackJack : ScrollUpBJ();       break;
//		case gtCraps     : ScrollUpCraps();    break;
//		case gtKeno      : ScrollUpKeno();     break;
//		case gtRoulette  : ScrollUpRoulette(); break;
//		case gtSlots     : ScrollUpSlots();    break;
//		case gtVideoPoker: ScrollUpVP();       break;
//		case gtOverall   : ScrollUpOverall();  break;
//	}
//   #endif

  switch (GetGameType())
  {
    #if defined(BJ_COMPILE)
    case gtBlackJack  : ScrollUpBJ();break;
    #endif
    #if defined(CRAPS_COMPILE)
    case gtCraps      : ScrollUpCraps();break;
    #endif
    #if defined(KENO_COMPILE)
    case gtKeno       : ScrollUpKeno();break;
    #endif
    #if defined(ROULETTE_COMPILE)
    case gtRoulette   : ScrollUpRoulette();break;
    #endif
    #if defined(SLOTS_COMPILE)
    case gtSlots      : ScrollUpSlots();break;
    #endif
    #if defined(VP_COMPILE)
    case gtVideoPoker : ScrollUpVP();break;
    #endif
    #if defined(OVERALL_COMPILE)
    case gtOverall    : ScrollUpOverall();break;
    #endif
  }
}
//*******************************************************************
void TCasinoStatDlg::ResetX(int newX,string topLeftCorner)
{
	m_currentX = newX;
   if (GetHandle())
   {
     SetDlgItemText(GetID(0,0),topLeftCorner.c_str());
   }
	PaintGrid();
}
//*******************************************************************
#if defined(BJ_COMPILE)
void TCasinoStatDlg::ScrollDownBJ()
{
  switch(m_currentX)
  {
    case  1:   ResetX( 5,strEmpty);break;
    case  5:   ResetX(16,strEmpty);break;
    case 16:   ResetX(31,strGameStatsContinued);break;
    case 31:   ResetX(42,strGameStatsContinued);break;
    case 42:   ResetX(50,strEmpty);break;
    case 50:	if (m_bSound) ::MessageBeep(-1); break;
  }
}
#endif
//*******************************************************************
#if defined(CRAPS_COMPILE)
void TCasinoStatDlg::ScrollDownCraps()
{
  switch(m_currentX)
  {
    case  1:   ResetX(  5,strEmpty);break;
    case  5:   ResetX( 18,strEmpty);break;
    case 18:   ResetX( 30,strEmpty);break;
    case 30:   ResetX( 42,strEmpty);break;
    case 42:   ResetX( 54,strEmpty);break;
    case 54:   ResetX( 70,strTotalCashBetContinued);break;
    case 70:   ResetX( 81,strEmpty);break;
    case 81:   ResetX( 97,strTotalCashWLContinued);break;
    case 97:   ResetX(109,strEmpty);break;
    case 109:  ResetX(125,strPercRetContinued);break;
    case 125:  if (m_bSound) ::MessageBeep(-1); break;
  }
}
#endif
//*******************************************************************
#if defined(ROULETTE_COMPILE)
void TCasinoStatDlg::ScrollDownRoulette()
{
  switch(m_currentX)
  {
    case  1:   ResetX(5,strEmpty);break;
    case  5:   ResetX(16,strEmpty);break;
    case 16:   ResetX(32,strGameStatsContinued);break;
    case 32:   ResetX(40,strEmpty);break;
    case 40:   ResetX(57,strEmpty);break;
    case 57:   ResetX(74,strTrendAnalysisContinued);break;
    case 74:   ResetX(88,strTrendAnalysisContinued);break;
    case 88:   ResetX(102,strTrendAnalysisContinued);break;
    case 102:  if (m_bSound) ::MessageBeep(-1); break;
  }
}
#endif
//*******************************************************************
#if defined(KENO_COMPILE)
void TCasinoStatDlg::ScrollDownKeno()
{
  switch(m_currentX)
  {
    case  1:   ResetX(5,strEmpty);break;
    case  5:   ResetX(16,strEmpty);break;
    case 16:   ResetX(29,strEmpty);break;
    case 29:   ResetX(46,strEmpty);break;
    case 46:   ResetX(63,strEmpty);break;
    case 63:   ResetX(80,strEmpty);break;
    case 80:   ResetX(96,strTrendAnalysisContinued);break;
    case 96:   if (m_bSound) ::MessageBeep(-1); break;
  }
}
#endif
//*******************************************************************
#if defined(SLOTS_COMPILE)
void TCasinoStatDlg::ScrollDownSlots()
{
  switch(m_currentX)
  {
    case  1:   ResetX(5,strEmpty);break;
    case  5:   ResetX(16,strEmpty);break;
    case 16:	if (m_bSound) ::MessageBeep(-1); break;
  }
}
#endif
//*******************************************************************
#if defined(VP_COMPILE)
void TCasinoStatDlg::ScrollDownVP()
{
  #if defined(ACVP_COMPILE)
  switch(m_currentX)
  {
    case TStatCalcVP::vpDate            : ResetX(TStatCalcVP::vpWinLossStats,strEmpty);break;
    case TStatCalcVP::vpWinLossStats    : ResetX(TStatCalcVP::vpGameStats,strEmpty);break;
    case TStatCalcVP::vpGameStats       : ResetX(TStatCalcVP::vpNumOccurrences,strEmpty);break;
    case TStatCalcVP::vpNumOccurrences  : ResetX(TStatCalcVP::vpOcc1,"# occ (cont)");break;
    case TStatCalcVP::vpOcc1            : ResetX(TStatCalcVP::vpOcc2,"# occ (cont)");break;
    case TStatCalcVP::vpOcc2            : ResetX(TStatCalcVP::vpOcc3,"# occ (cont)");break;
    case TStatCalcVP::vpOcc3            : ResetX(TStatCalcVP::vpTotalCashWins,strEmpty);break;
    case TStatCalcVP::vpTotalCashWins   : ResetX(TStatCalcVP::vpCash1,"cash (cont)");break;
    case TStatCalcVP::vpCash1           : ResetX(TStatCalcVP::vpCash2,"cash (cont)");break;
    case TStatCalcVP::vpCash2           : ResetX(TStatCalcVP::vpCash3,"cash (cont)");break;
    case TStatCalcVP::vpCash3           : ResetX(TStatCalcVP::vpPercTotalCashWon,strEmpty);break;
    case TStatCalcVP::vpPercTotalCashWon: ResetX(TStatCalcVP::vpPerc1,"perc (cont)");break;
    case TStatCalcVP::vpPerc1           : ResetX(TStatCalcVP::vpPerc2,"perc (cont)");break;
    case TStatCalcVP::vpPerc2           : ResetX(TStatCalcVP::vpPerc3,"perc (cont)");break;
    case TStatCalcVP::vpPerc3           : ResetX(TStatCalcVP::vpAdvancedStats,strEmpty);break;
    case TStatCalcVP::vpAdvancedStats   : if (m_bSound) ::MessageBeep(-1);break;
  }
  #else
  switch(m_currentX)
  {
    case TStatCalcVP::vpDate            : ResetX(TStatCalcVP::vpWinLossStats,strEmpty);break;
    case TStatCalcVP::vpWinLossStats    : ResetX(TStatCalcVP::vpGameStats,strEmpty);break;
    case TStatCalcVP::vpGameStats       : ResetX(TStatCalcVP::vpNumOccurrences,strEmpty);break;
    case TStatCalcVP::vpNumOccurrences  : ResetX(TStatCalcVP::vpTotalCashWins,strEmpty);break;
    case TStatCalcVP::vpTotalCashWins   : ResetX(TStatCalcVP::vpPercTotalCashWon,strEmpty);break;
    case TStatCalcVP::vpPercTotalCashWon: ResetX(TStatCalcVP::vpAdvancedStats,strEmpty);break;
    case TStatCalcVP::vpAdvancedStats   : if (m_bSound) ::MessageBeep(-1);break;
  }
  #endif
}
#endif
//*******************************************************************
#if defined(OVERALL_COMPILE)
void TCasinoStatDlg::ScrollDownOverall()
{
  switch(m_currentX)
  {
//    case   1:   ResetX(12,strEmpty);break;
//    case  12:   ResetX(21,strEmpty);break;
//    case  21:   ResetX(37,strEmpty);break;
//    case  37:   ResetX(53,strEmpty);break;
//    case  53:   if (m_bSound) ::MessageBeep(-1);break;
//  }
    case 1                                   : ResetX(TStatCalcOverall::oSESSIONS,strEmpty);break;
    case TStatCalcOverall::oSESSIONS         : ResetX(TStatCalcOverall::oTOTALCASHBET,strEmpty);break;
    case TStatCalcOverall::oTOTALCASHBET     : ResetX(TStatCalcOverall::oTOTALHOURSPLAYED,strEmpty);break;
    case TStatCalcOverall::oTOTALHOURSPLAYED : ResetX(TStatCalcOverall::oTOTALCASHWL,strEmpty);break;
    case TStatCalcOverall::oTOTALCASHWL      : ResetX(TStatCalcOverall::oRETURNPERC,strEmpty);break;
    case TStatCalcOverall::oRETURNPERC       : ResetX(TStatCalcOverall::oWLPERHOUR,strEmpty);break;
    case TStatCalcOverall::oWLPERHOUR        : if (m_bSound) ::MessageBeep(-1);break;
  }

}
#endif
//*******************************************************************
void TCasinoStatDlg::ScrollDown()
{
//  #if defined(VPLITE_COMPILE)
//  ScrollDownVP();
//  #elif defined(SLOTLITE_COMPILE)
//  ScrollDownSlots();
//  #elif defined(KENOLITE_COMPILE)
//  ScrollDownKeno();
//  #else
//	switch(GetGameType())
//	{
//		case gtBlackJack : ScrollDownBJ();      break;
//		case gtCraps     : ScrollDownCraps();   break;
//		case gtKeno      : ScrollDownKeno();    break;
//		case gtRoulette  : ScrollDownRoulette();break;
//		case gtSlots     : ScrollDownSlots();   break;
//		case gtVideoPoker: ScrollDownVP();      break;
//		case gtOverall   : ScrollDownOverall(); break;
//	}
//   #endif

   switch (GetGameType())
   {
     #if defined(BJ_COMPILE)
     case gtBlackJack  : ScrollDownBJ();break;
     #endif
     #if defined(CRAPS_COMPILE)
     case gtCraps      : ScrollDownCraps();break;
     #endif
     #if defined(KENO_COMPILE)
     case gtKeno       : ScrollDownKeno();break;
     #endif
     #if defined(ROULETTE_COMPILE)
     case gtRoulette   : ScrollDownRoulette();break;
     #endif
     #if defined(SLOTS_COMPILE)
     case gtSlots      : ScrollDownSlots();break;
     #endif
     #if defined(VP_COMPILE)
     case gtVideoPoker : ScrollDownVP();break;
     #endif
     #if defined(OVERALL_COMPILE)
     case gtOverall    : ScrollDownOverall();break;
     #endif
   }
}
//*******************************************************************
void TCasinoStatDlg::ScrollRight()
{   //single column scroll

  if (m_currentY  < (NUMCACHECOLS -4))
  {
    m_currentY++;
	 PaintGrid();
  }
  else
  {
    if (m_bSound) {::MessageBeep(-1);}
  }
}
//*******************************************************************
void TCasinoStatDlg::ScrollLeft()
{// single column scroll

  if (m_currentY > 1)
  {
    m_currentY--;
    PaintGrid();
  }
  else
  {
    if (m_bSound) {::MessageBeep(-1);}
  }
}
//*******************************************************************
void TCasinoStatDlg::SetTitleToNameAndGame()
{
	string strNewTitle(strEmpty);

//   #if defined(VPLITE_COMPILE)
//   strNewTitle += strVideoPoker;
//   #elif defined(SLOTLITE_COMPILE)
//   strNewTitle += strSlots;
//   #elif defined(KENOLITE_COMPILE)
//   strNewTitle += strKeno;
//   #else
//	switch(GetGameType())
//	{
//		case gtBlackJack : strNewTitle += strBlackJack;   break;
//		case gtCraps     : strNewTitle += strCraps;       break;
//		case gtKeno      : strNewTitle += strKeno;        break;
//		case gtRoulette  : strNewTitle += strRoulette;    break;
//		case gtSlots     : strNewTitle += strSlots;       break;
//		case gtVideoPoker: strNewTitle += strVideoPoker; break;
//		case gtOverall   : strNewTitle += strOverall;     break;
//	}
//   #endif

   switch (GetGameType())
   {
     #if defined(BJ_COMPILE)
     case gtBlackJack  : strNewTitle += strBlackJack;break;
     #endif
     #if defined(CRAPS_COMPILE)
     case gtCraps      : strNewTitle += strCraps;break;
     #endif
     #if defined(KENO_COMPILE)
     case gtKeno       : strNewTitle += strKeno;break;
     #endif
     #if defined(ROULETTE_COMPILE)
     case gtRoulette   : strNewTitle += strRoulette;break;
     #endif
     #if defined(SLOTS_COMPILE)
     case gtSlots      : strNewTitle += strSlots;break;
     #endif
     #if defined(VP_COMPILE)
     case gtVideoPoker : strNewTitle == strVideoPoker;break;
     #endif
     #if defined(OVERALL_COMPILE)
     case gtOverall    : strNewTitle += strOverall;break;
     #endif
     default           : strNewTitle += "Unknown Game";break;
   }

   strNewTitle += strSpace;
   strNewTitle += strStatistics;
   strNewTitle += strSpace;
   strNewTitle += strfor;
   strNewTitle += strSpace;
   strNewTitle += GetPlayerName();

	SetWindowText(strNewTitle.c_str());
}
//*******************************************************************
void TCasinoStatDlg::SetupWindow()
{
	TDialog::SetupWindow();
	//get dialog box parameters
	TRect rec = GetWindowRect();
	int dialogWidth  = rec.right-rec.left;
	int dialogHeight = rec.bottom-rec.top;
	int xRes=   ::GetSystemMetrics(SM_CXSCREEN);
	int yRes=   ::GetSystemMetrics(SM_CYSCREEN);


	//make in relation to app

	MoveWindow((xRes - dialogWidth)/2,(yRes - dialogHeight)/2,
					dialogWidth,dialogHeight);

   LoadNamesCB();
   LoadGamesCB();

	SetTitleToNameAndGame();
	EmptyAllCells();
//   #if defined(VPLITE_COMPILE)
//   CmVideoPoker();
//   #elif defined(SLOTLITE_COMPILE)
//   CmSlots();
//   #elif defined(KENOLITE_COMPILE)
//   CmKeno();
//   #else
//	switch(GetGameType())//go load pertinent data in command handlers
//	{
//		case gtBlackJack : CmBlackjack();  break;
//		case gtCraps     : CmCraps();      break;
//		case gtKeno      : CmKeno();       break;
//		case gtRoulette  : CmRoulette();   break;
//		case gtSlots     : CmSlots();      break;
//		case gtVideoPoker: CmVideoPoker(); break;
//      case gtOverall   : CmOverall();    break;
//	}
//   #endif

   switch (GetGameType())
   {
     #if defined(BJ_COMPILE)
     case gtBlackJack  : CmBlackjack();break;
     #endif
     #if defined(CRAPS_COMPILE)
     case gtCraps      : CmCraps();break;
     #endif
     #if defined(KENO_COMPILE)
     case gtKeno       : CmKeno();break;
     #endif
     #if defined(ROULETTE_COMPILE)
     case gtRoulette   : CmRoulette();break;
     #endif
     #if defined(SLOTS_COMPILE)
     case gtSlots      : CmSlots();break;
     #endif
     #if defined(VP_COMPILE)
     case gtVideoPoker : CmVideoPoker();break;
     #endif
     #if defined(OVERALL_COMPILE)
     case gtOverall    : CmOverall();break;
     #endif
   }
}
//*******************************************************************
void TCasinoStatDlg::EmptyAllCells()
{
  for (int row = 0;row < m_NUMROWS; row++)
  {
    for (int col = 0;col < m_NUMCOLS;col++)
    {
      if (GetHandle())
      {
        SetDlgItemText(GetID(row,col),strEmpty.c_str());
      }
    }
  }
  if (GetHandle())
  {
    SetDlgItemText(GetID(0,5),strCumulative.c_str());
  }
}
//*******************************************************************
#if defined(BJ_COMPILE)
string TCasinoStatDlg::GetBlackjackLabel(int row)
{
	return(GetModule()->LoadString(BlackjackLabel + row));
}
#endif
//*******************************************************************
#if defined(CRAPS_COMPILE)
string TCasinoStatDlg::GetCrapsLabel(int row)
{
	return(GetModule()->LoadString(CrapsLabel + row));
}
#endif
//*******************************************************************
#if defined(ROULETTE_COMPILE)
string TCasinoStatDlg::GetRouletteLabel(int row)
{
	return (GetModule()->LoadString(RouletteLabel + row));
}
#endif
//*******************************************************************
#if defined(KENO_COMPILE)
string TCasinoStatDlg::GetKenoLabel(int row)
{
	return (GetModule()->LoadString(KenoLabel + row));
}
#endif
//*******************************************************************
#if defined(SLOTS_COMPILE)
string TCasinoStatDlg::GetSlotsLabel(int row)
{
	return (GetModule()->LoadString(SlotsLabel + row));
}
#endif
//*******************************************************************
#if defined(VP_COMPILE)
string TCasinoStatDlg::GetVideoPokerLabel(int row)
{
  if (PVPStats == NULL) {return TAppString::strEmpty;}
  return PVPStats->GetLabelStr(int16(row));
//	return (GetModule()->LoadString(VideoPokerLabel + row));
}
#endif
//*******************************************************************
#if defined(OVERALL_COMPILE)
string TCasinoStatDlg::GetOverallLabel(int row)
{
  if(POverallStats == NULL) {return TAppString::strEmpty;}
  return POverallStats->GetLabelStr(int16(row));
//	return (GetModule()->LoadString(OverallLabel + row));
}
#endif
//*******************************************************************
#if defined(BJ_COMPILE)
void TCasinoStatDlg::OutputRowLabelsBJ()
{
  for (int row=m_currentX;row<NUMCACHEROWS;row++)
  {
    if (row <= m_NUMBLACKJACKROWS)
    {
      string strLabel= GetBlackjackLabel(row);
      if (GetHandle())
      {
        SetDlgItemText(GetID(row+1-m_currentX,0),strLabel.c_str());
      }
    }
    else if (GetHandle())
    {
      SetDlgItemText(GetID(row,0),strEmpty.c_str());
    }
  }
}
#endif
//*******************************************************************
#if defined(CRAPS_COMPILE)
void TCasinoStatDlg::OutputRowLabelsCraps()
{
  for (int row=m_currentX;row<NUMCACHEROWS;row++)
  {
    if (row <= m_NUMCRAPSROWS)
    {
      string strLabel= GetCrapsLabel(row);
      if (GetHandle())
      {
        SetDlgItemText(GetID(row+1-m_currentX,0),strLabel.c_str());
      }
    }
    else if (GetHandle())
    {
      SetDlgItemText(GetID(row,0),strEmpty.c_str());
    }
  }
}
#endif
//*******************************************************************
#if defined(ROULETTE_COMPILE)
void TCasinoStatDlg::OutputRowLabelsRoulette()
{
  for (int row=m_currentX;row<NUMCACHEROWS;row++)
  {
    if (row <= m_NUMROULETTEROWS)
    {
      string strLabel= GetRouletteLabel(row);
      if (GetHandle())
      {
        SetDlgItemText(GetID(row+1-m_currentX,0),strLabel.c_str());
      }
    }
    else if (GetHandle())
    {
      SetDlgItemText(GetID(row,0),strEmpty.c_str());
    }
  }
}
#endif
//*******************************************************************
#if defined(KENO_COMPILE)
void TCasinoStatDlg::OutputRowLabelsKeno()
{
  for (int row=m_currentX;row<NUMCACHEROWS;row++)
  {
    if (row <= m_NUMKENOROWS)
    {
      string strLabel= GetKenoLabel(row);
      if (GetHandle())
      {
        SetDlgItemText(GetID(row+1-m_currentX,0),strLabel.c_str());
      }
    }
    else if (GetHandle())
    {
      SetDlgItemText(GetID(row,0),strEmpty.c_str());
    }
  }
}
#endif
//*******************************************************************
#if defined(SLOTS_COMPILE)
void TCasinoStatDlg::OutputRowLabelsSlots()
{
  for (int row=m_currentX;row<NUMCACHEROWS;row++)
  {
    if (row <= m_NUMSLOTSROWS)
    {
      string strLabel= GetSlotsLabel(row);
      if (GetHandle())
      {
        SetDlgItemText(GetID(row+1-m_currentX,0),strLabel.c_str());
      }
    }
    else if (GetHandle())
    {
      SetDlgItemText(GetID(row,0),strEmpty.c_str());
    }
  }
}
#endif
//*******************************************************************
#if defined(VP_COMPILE)
void TCasinoStatDlg::OutputRowLabelsVP()
{
  for (int row=m_currentX;row<NUMCACHEROWS;row++)
  {
    if (row <= m_NUMVIDEOPOKERROWS)
    {
      string strLabel= GetVideoPokerLabel(row);
      if (GetHandle())
      {
        SetDlgItemText(GetID(row+1-m_currentX,0),strLabel.c_str());
      }
    }
    else if (GetHandle())
    {
      SetDlgItemText(GetID(row,0),strEmpty.c_str());
    }
  }
}
#endif
//*******************************************************************
#if defined(OVERALL_COMPILE)
void TCasinoStatDlg::OutputRowLabelsOverall()
{
  for (int row=m_currentX;row<NUMCACHEROWS;row++)
  {
    if (row <= m_NUMOVERALLROWS)
    {
      string strLabel= GetOverallLabel(row);
      if (GetHandle())
      {
        SetDlgItemText(GetID(row+1-m_currentX,0),strLabel.c_str());
      }
    }
    else if (GetHandle())
    {
      SetDlgItemText(GetID(row,0),strEmpty.c_str());
    }
  }
}
#endif
//*******************************************************************
bool TCasinoStatDlg::OutputRowLabels()
{  //the limit for row labels is 17 chars, other cells are 9 chars wide
  SetSessionHeadingNumbers();
//  #if defined(VPLITE_COMPILE)
//  OutputRowLabelsVP();
//  #elif defined(SLOTLITE_COMPILE)
//  OutputRowLabelsSlots();
//  #elif defined(KENOLITE_COMPILE)
//  OutputRowLabelsKeno();
//  #else
//	switch (GetGameType())
//	{
//		case gtBlackJack : OutputRowLabelsBJ();       break;
//		case gtCraps     : OutputRowLabelsCraps();    break;
//		case gtKeno      : OutputRowLabelsKeno();     break;
//		case gtRoulette  : OutputRowLabelsRoulette(); break;
//		case gtSlots     : OutputRowLabelsSlots();    break;
//		case gtVideoPoker: OutputRowLabelsVP();       break;
//		case gtOverall   : OutputRowLabelsOverall();  break;
//	}
//   #endif

   switch (GetGameType())
   {
     #if defined(BJ_COMPILE)
     case gtBlackJack  : OutputRowLabelsBJ();break;
     #endif
     #if defined(CRAPS_COMPILE)
     case gtCraps      : OutputRowLabelsCraps();break;
     #endif
     #if defined(KENO_COMPILE)
     case gtKeno       : OutputRowLabelsKeno();break;
     #endif
     #if defined(ROULETTE_COMPILE)
     case gtRoulette   : OutputRowLabelsRoulette();break;
     #endif
     #if defined(SLOTS_COMPILE)
     case gtSlots      : OutputRowLabelsSlots();break;
     #endif
     #if defined(VP_COMPILE)
     case gtVideoPoker : OutputRowLabelsVP();break;
     #endif
     #if defined(OVERALL_COMPILE)
     case gtOverall    : OutputRowLabelsOverall();break;
     #endif
   }

	return true;
}
//*******************************************************************
//void TCasinoStatDlg::SetGameType(int gametype)
//{
//	GameType = gametype;
////	m_currentX = 1;
////   m_currentY = 1;
////	SetTitleToNameAndGame();
////	OutputRowLabels();//not necessary??
//}
//*******************************************************************
void TCasinoStatDlg::EmptyCacheAndTotals()
{
  for (int i = 0;i < NUMCACHEROWS; i ++)
  {
    totalcol[i] = strEmpty;
    for (int j = 0;j < NUMCACHECOLS; j++)
    {
      cell[i][j]=strEmpty;
    }
  }
  if (GetHandle()) //mrp - v2.4
  {
    SetDlgItemText(GetID(0,0),strEmpty.c_str());
  }
}
//*******************************************************************
int TCasinoStatDlg::GetGamesRowCount()
{
//  #if defined(VPLITE_COMPILE)
//  return m_NUMVIDEOPOKERROWS;
//  #elif defined(SLOTLITE_COMPILE)
//  return m_NUMSLOTSROWS;
//  #elif defined(KENOLITE_COMPILE)
//  return m_NUMKENOROWS;
//  #else
//  switch(GetGameType())
//  {
//    case gtBlackJack : return m_NUMBLACKJACKROWS;
//    case gtCraps     : return m_NUMCRAPSROWS;
//    case gtKeno      : return m_NUMKENOROWS;
//    case gtRoulette  : return m_NUMROULETTEROWS;
//    case gtSlots     : return m_NUMSLOTSROWS;
//    case gtVideoPoker: return m_NUMVIDEOPOKERROWS;
//    case gtOverall   : return m_NUMOVERALLROWS;
//    default          : return m_NUMBLACKJACKROWS;
//  }
//  #endif

  switch (GetGameType())
  {
    #if defined(BJ_COMPILE)
    case gtBlackJack : return m_NUMBLACKJACKROWS;
    #endif
    #if defined(CRAPS_COMPILE)
    case gtCraps     : return m_NUMCRAPSROWS;
    #endif
    #if defined(KENO_COMPILE)
    case gtKeno      : return m_NUMKENOROWS;
    #endif
    #if defined(ROULETTE_COMPILE)
    case gtRoulette  : return m_NUMROULETTEROWS;
    #endif
    #if defined(SLOTS_COMPILE)
    case gtSlots     : return m_NUMSLOTSROWS;
    #endif
    #if defined(VP_COMPILE)
    case gtVideoPoker : return m_NUMVIDEOPOKERROWS;
    #endif
    #if defined(OVERALL_COMPILE)
    case gtOverall    : return m_NUMOVERALLROWS;
    #endif
  }
  return 28; // this should be dead code.
}
//*******************************************************************
void TCasinoStatDlg::PaintTotalCell(int row)
{
  if ((row >= 0) && (row < NUMCACHEROWS))
  {
    if (totalcol[row].length() < 10)
    {
      if (GetHandle())
      {
        SetDlgItemText(GetID(row+1-m_currentX,m_NUMCOLS-1),totalcol[row].c_str());
      }
    }
    else if (GetHandle())
    {//overflowing cell
      char shortened[12];
      strncpy(shortened,totalcol[row].c_str(),10);
      shortened[10] = '+';shortened[11] = '\0';
      SetDlgItemText(GetID(row+1-m_currentX,m_NUMCOLS-1),shortened);
    }
  }
}
//*******************************************************************
void TCasinoStatDlg::PaintRowCells(int row)
{
  for (int col = m_currentY; col < m_currentY + m_NUMCOLS -2;col++)
  {
    if ((row >= 0) && (row < NUMCACHEROWS) && (col >= 0) && (col < NUMCACHECOLS))
    {
      if (cell[row][col].length() < 10)
      {
        if (GetHandle())
        {
          SetDlgItemText(GetID(row+1-m_currentX,col+1-m_currentY), cell[row][col].c_str());
        }
      }
      else if (GetHandle())
      {//overflowing cell
        char shortened[12];
//        strncpy(shortened,totalcol[row].c_str(),10);
        strncpy(shortened,cell[row][col].c_str(),10); // mike changed.
        shortened[10] = '+';shortened[11] = '\0';
        SetDlgItemText(GetID(row+1-m_currentX,col+1-m_currentY),shortened);
      }
    }
  }
}
//*******************************************************************
void TCasinoStatDlg::PaintCacheRowCells(int row)
{
  if (!GetHandle()) {return;}

  SetDlgItemText(GetID(row+1-m_currentX,m_NUMCOLS-1),strEmpty.c_str());//totalcol[row].c_str()
  SetDlgItemText(GetID(row+1-m_currentX,0),strEmpty.c_str());//zero label column
  for (int col = m_currentY; col < m_currentY + m_NUMCOLS -2;col++)
  {
    if ((row >= 0) && (row < NUMCACHEROWS) && (col >= 0) && (col < NUMCACHECOLS))
    {
      SetDlgItemText(GetID(row+1-m_currentX,col+1-m_currentY),strEmpty.c_str());
    }
  }
}
//*******************************************************************
void TCasinoStatDlg::PaintGrid()
{
	OutputRowLabels();
	int nGamesRowCount = GetGamesRowCount();
   int row;
	for (row = m_currentX;row <=  nGamesRowCount;row++)
	{
     PaintTotalCell(row);
     PaintRowCells(row);
	}
	for (;row < NUMCACHEROWS;row++)
	{
     PaintCacheRowCells(row);
	}
}
//*******************************************************************
void TCasinoStatDlg::SetSessionHeadingNumbers()
{
  if (!GetHandle()) {return;}
  
  char curY[15];
  for (int i=1;i<=4;i++)
  {
    itoa(m_currentY+i-1,curY,10);
    SetDlgItemText(GetID(0,i),curY);
  }
}
//*******************************************************************