//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  vlgld.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     10/11/95   M.Perry    Original baseline
//*******************************************************************
#include "vlgld.h"
#include "vlspl.h"
#include "oskitcat.h"
#include "ogamefw.h"
#include "orespond.h"
//*******************************************************************
TSpriteList *TVLobby1GameLord::CreateSpriteList(TFileMode splfm)
{
  return (new TVLobby1SpriteList(PModeWin,splfm,this));
}
//*******************************************************************
void TVLobby1GameLord::SetupSprites()
{
  MenuEscButton = NULL;
  MenuEscButton = (TCasButton *)GetSpritePtr(GetResString(IDS_MS_B0_VL));
  if (MenuEscButton == NULL) {SpriteError("Menu Esc Button",GetResString(IDS_MS_B0_VL));}
  if (GetFW()->GetHandleShowMenu())
  {
	 ActivateSpriteNow(MenuEscButton);
  }
  else
  {
	 MenuEscButton->Freeze = TRUE;
	 MenuEscButton->PButtonResponder->Remove();
  }
  Whirl = GetSpriteIndex(GetResString(IDS_AS_WHIRL_VL));

  MessageDisplay = NULL;
  MessageDisplay = (TCasLobbyMessageDisplay *) GetSpritePtr(GetResString(IDS_MS_MESS_VL));
  if (MessageDisplay == NULL) {SpriteError("MessageDisplay",GetResString(IDS_MS_MESS_VL));}
  MessageDisplay->Start(GetFUC());
//  ::MessageBox(NULL,"setup sprites","Hi Mike",MB_OK);
}
//*******************************************************************
void TVLobby1GameLord::CleanupSprites()
{
}
//*******************************************************************
TVLobby1GameLord::TVLobby1GameLord(TVLobby1ModeWin *pmwin,const TFileMode &fm)
:TCasinoVLGameLord(pmwin,fm)
{
  TFileMode splfm(SpriteListName,fm_None,fm_Immed,FileMode.DirIndex);
//  AddElement(CreateSpriteList(splfm));
  CreateAddSpriteList(splfm);

 // TFileMode skcfm(SkitCatName,fm_None,fm_Immed,FileMode.DirIndex);
//  AddElement(CreateSkitCat(skcfm));
//  CreateAddSkitCat(skcfm);

  SetupSprites();
}
//*******************************************************************
TVLobby1GameLord::~TVLobby1GameLord()
{
  CleanupSprites();
}
//*******************************************************************
void TVLobby1GameLord::TurnOnNext()
{
  switch (GetTurnOffState())
  {
    case 1:SetWaterIdle();
           SetTurnOffState(0);
           break;
    case 2:SetSound1Idle();
           SetTurnOffState(1);
           break;
    case 3:SetSound2Idle();
           SetTurnOffState(2);
           break;
    case 4:SetSound3Idle();
           SetTurnOffState(3);
           break;
    case 5:SetSound4Idle();
           SetTurnOffState(4);
           break;
    case 6:SetSound5Idle();
           SetTurnOffState(5);
           break;
    case 7:SetSound6Idle();
           SetTurnOffState(6);
           break;
    case 8:SetSound7Idle();
           SetTurnOffState(7);
           break;
    case 9:SetSound8Idle();
           SetTurnOffState(8);
           break;
  }
}
//*******************************************************************
void TVLobby1GameLord::TurnOffNext()
{
  switch (GetTurnOffState())
  {
    case 0:SetWaterIdle(-1);
           SetTurnOffState(1);
           break;
    case 1:SetSound1Idle(-1);
           SetTurnOffState(2);
           break;
    case 2:SetSound2Idle(-1);
           SetTurnOffState(3);
           break;
    case 3:SetSound3Idle(-1);
           SetTurnOffState(4);
           break;
    case 4:SetSound4Idle(-1);
           SetTurnOffState(5);
           break;
    case 5:SetSound5Idle(-1);
           SetTurnOffState(6);
           break;
    case 6:SetSound6Idle(-1);
           SetTurnOffState(7);
           break;
    case 7:SetSound7Idle(-1);
           SetTurnOffState(8);
           break;
    case 8:SetSound8Idle(-1);
           SetTurnOffState(9);
           break;
  }
}
//*******************************************************************