//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  vlglord.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     10/11/95   M.Perry    Original baseline
//*******************************************************************
#include "vlglord.h"
#include "vllordst.h"
#include "vllrdmst.h"
#include "ostate.h"
#include <time.h>   //To Set Random Number Generator
#define  NUMBEROFPLAYERS 3
#include <stdlib.h> //For Random Number Generator
//#include "casvlmw.h"
#include "vlmw.h"
#include "oskitcat.h"
#include "vlplay.h"
#include "expert.h"
#include "cplaymgr.h"
#include "casapp.h"
#include "orespond.h"
#include "vplmenu.rh"
//*******************************************************************
#pragma argsused
BOOL TCasinoVLGameLord::Respond(int button,int info,void *pdata)
{
  ButtonInfo = info;
  if(info != -1)
  {
	 switch(button)
	 {
	 case idButton0  : ButtonHit[0]=TRUE;break;
	 default         : WaitOnButtonDown = FALSE;break;
	 }
  }
  return TRUE;
}
//*******************************************************************
void TCasinoVLGameLord::ButtonClear(int button)
{
  switch(button)
  {
	 case idButton0  : ButtonHit[0]=FALSE;GetFW()->CmShowMenu();break;
	 default         : WaitOnButtonDown = FALSE;break;
  }
  WaitOnButtonDown = FALSE;
  return;
}
//*******************************************************************
BOOL TCasinoVLGameLord::Respond(TResponder &responder)
{
  if (PState == NULL) {return TRUE;}

  if((responder.GetResponseEvent() == reEnterArea ||
		responder.GetResponseEvent() == reLeaveArea  ) &&
		responder.GetID() != idBack && responder.GetID() != idButton0)
  {
	 if(responder.GetResponseEvent() == reEnterArea)
	 {
		switch (responder.GetID())
		{
		  case idJack5           :  MessageDisplay->ShowLobbyMessage(5);break;
		  case idDeuce25         :  MessageDisplay->ShowLobbyMessage(2);break;
		  case idJack25          :  MessageDisplay->ShowLobbyMessage(6);break;
		  case idDeuce1          :  MessageDisplay->ShowLobbyMessage(0);break;
		  case idJack1           :  MessageDisplay->ShowLobbyMessage(4);break;
		  case idJackProg        :  MessageDisplay->ShowLobbyMessage(8);break;
		  case idDeuce5          :  MessageDisplay->ShowLobbyMessage(1);break;
		  case idJack100         :  MessageDisplay->ShowLobbyMessage(7);break;
		  case idDeuce100        :  MessageDisplay->ShowLobbyMessage(3);break;
		  case idJoke100         :  MessageDisplay->ShowLobbyMessage(9);break;
		 // case idSpeed               :  MessageDisplay->ShowLobbyMessage();break;
		  default                :  break;
		}
	 }
	 else
	 {
      MessageDisplay->ShowLobbyMessage(10);
    }
	 if(responder.GetResponseEvent() == reLeaveArea)
	 {
		GetOgleApp()->GetCursorMgr()->SetCursor(ctAction,0,0);
		return TRUE;
	 }
	 return TRUE;
  }
  else
  {
	 DWORD FUCKLen=0;
	 DWORD STARTFUC=GetAdjFUC();
    int command = 0;
	 switch (responder.GetID())
	 {
		case idJack5      :  command = CM_GAMEVPJACK5;break;//((TCasinoModeWin *)PModeWin)->PostSwitchToJB5();return TRUE;
		case idDeuce25    :  command = CM_GAMEVPDWILD25;break;//((TCasinoModeWin *)PModeWin)->PostSwitchToDW25();return TRUE;
		case idJack25     :  command = CM_GAMEVPJACK25;break;//((TCasinoModeWin *)PModeWin)->PostSwitchToJB25();return TRUE;
		case idDeuce1     :  command = CM_GAMEVPDWILD1;break;//((TCasinoModeWin *)PModeWin)->PostSwitchToDW1();return TRUE;
		case idJack1      :  command = CM_GAMEVPJACK1;break;//((TCasinoModeWin *)PModeWin)->PostSwitchToJB1();return TRUE;
		case idJackProg   :  command = CM_GAMEVPJACK1P;break;//((TCasinoModeWin *)PModeWin)->PostSwitchToJB1P();return TRUE;
		case idDeuce5     :  command = CM_GAMEVPDWILD5;break;//((TCasinoModeWin *)PModeWin)->PostSwitchToDW5();return TRUE;
		case idJack100    :  command = CM_GAMEVPJACK100;break;//((TCasinoModeWin *)PModeWin)->PostSwitchToJB100();return TRUE;
		case idDeuce100   :  command = CM_GAMEVPDWILD100;break;//((TCasinoModeWin *)PModeWin)->PostSwitchToDW100();return TRUE;
		case idJoke100    :  command = CM_GAMEVPJWILD100;break;//((TCasinoModeWin *)PModeWin)->PostSwitchToJW100();return TRUE;
	// case idLogo       :  GetOgleApp()->Help(HELP_CONTENTS);return TRUE;
	// case idMen        :  GetFW()->CmShowMenu();return TRUE;
		case idBack       :  return TRUE;
		case idWhirl      :  if(responder.GetResponseEvent() == reLUp)
									{
									  return (ActivateSprite(Whirl,STARTFUC,FUCKLen));
									}
									return TRUE;
		default           :  return TRUE;
	 }
    if (command != 0)
    {
      PModeWin->PostCommandToFW(command);
    }
    return TRUE;
  }
}
//*******************************************************************
void TCasinoVLGameLord::SetupResponders()
{
  Responders[0]  = new TResponder(PModeWin,100,TRect(11,145,84,242)   ,idJack5,this,TRUE,'^',TCursorData(GetOgleApp(),ID_SPADE_ON_CURSOR));
  Responders[1]  = new TResponder(PModeWin,100,TRect(92,145,164,242) ,idDeuce25,this,TRUE,'^',TCursorData(GetOgleApp(),ID_SPADE_ON_CURSOR));
  Responders[2]  = new TResponder(PModeWin,100,TRect(168,145,241,242),idJack25,this,TRUE,'^',TCursorData(GetOgleApp(),ID_SPADE_ON_CURSOR));
  Responders[3]  = new TResponder(PModeWin,100,TRect(77,255,180,412),idDeuce1,this,TRUE,'^',TCursorData(GetOgleApp(),ID_SPADE_ON_CURSOR));
  Responders[4]  = new TResponder(PModeWin,100,TRect(205,255,308,412),idJack1,this,TRUE,'^',TCursorData(GetOgleApp(),ID_SPADE_ON_CURSOR));
  Responders[5]  = new TResponder(PModeWin,100,TRect(330,255,432,412),idJackProg,this,TRUE,'^',TCursorData(GetOgleApp(),ID_SPADE_ON_CURSOR));
  Responders[6]  = new TResponder(PModeWin,100,TRect(459,255,562,412),idDeuce5,this,TRUE,'^',TCursorData(GetOgleApp(),ID_SPADE_ON_CURSOR));
  Responders[7]  = new TResponder(PModeWin,100,TRect(388,145,460,242),idJack100,this,TRUE,'^',TCursorData(GetOgleApp(),ID_SPADE_ON_CURSOR));
  Responders[8]  = new TResponder(PModeWin,100,TRect(465,145,536,242),idDeuce100,this,TRUE,'^',TCursorData(GetOgleApp(),ID_SPADE_ON_CURSOR));
  Responders[9]  = new TResponder(PModeWin,100,TRect(552,145,624,242),idJoke100,this,TRUE,'^',TCursorData(GetOgleApp(),ID_SPADE_ON_CURSOR));
  Responders[10] = new TResponder(PModeWin,50,TRect(1,1,639,479)     ,idBack,this,TRUE,'^',TCursorData(GetOgleApp(),ID_SPADE_OFF_CURSOR));
  Responders[11] = new TResponder(PModeWin,100,TRect(254,65,383,245),idWhirl,this,TRUE,'^',TCursorData(GetOgleApp(),ID_SPADE_ON_CURSOR));

}
//*******************************************************************
TCasinoVLGameLord::TCasinoVLGameLord(TVLobby1ModeWin *pmwin,const TFileMode &fm)
:TCasLobbyGameLord(pmwin,fm,gtNone,cd1)
//:TCasinoGameLord(pmwin,fm,gtNone,cd1)
{
  PState   = new TVLLordMainState(this);
//  ask      = new TSAsk(this);


  shutdownstate    = 0;
//  pMWin  = pmwin;
  activeplayer = 0;
  playersin=0;

  SetupResponders();
}
//*******************************************************************
TCasinoVLGameLord::~TCasinoVLGameLord()
{
  if(PState != NULL)
  {
	 delete PState;
	 PState = NULL;
  }
  CleanupResponders();
}
//*******************************************************************
void TCasinoVLGameLord::CleanupResponders()
{
  for(int i=0;i<NumResponders;i++) {delete Responders[i];}
}
//*******************************************************************
TCasinoVLGameLord::InitL()
{
//  SetCashWhirlIdle();
 for(int i=0;i<NumResponders-1;i++)
  {
	 Responders[i]->SetEnterLeave(TRUE);
  }
  MenuEscButton->SetCurrentUpFrame(50);
  MenuEscButton->ShowUp();
  SetSound1Idle();
  SetSound2Idle();
  SetSound3Idle();
  SetSound4Idle();
  SetSound5Idle();
  SetSound6Idle();
  SetSound7Idle();
  SetSound8Idle();
  SetWaterIdle();
  MessageDisplay->ShowLobbyMessage(10);
  return 1;
}
//*******************************************************************
void  TCasinoVLGameLord::ShuttingDown()
{
  if(shutdownstate == 0)
  {
	 if(GetCasPD(0))
	 {
		NotifyPlayerDeActivation(0);
	 }
	 if(GetCasPD(1))
	 {
		NotifyPlayerDeActivation(1);
	 }
	 if(GetCasPD(2))
	 {
		NotifyPlayerDeActivation(2);
	 }
  }
}
//*******************************************************************
void TCasinoVLGameLord::NotifyPlayerActivation(int slotnum)
{
}
//*******************************************************************
void TCasinoVLGameLord::NotifyPlayerDeActivation(int slotnum)
{
}
//*******************************************************************
void TCasinoVLGameLord::SetupActivePlayer(int slot)
{
}
//*******************************************************************