//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  vplgfw.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.2     4/17/97    M.Perry    modified framewin hierarchy.
//********************************************************************
#include "vplgfw.h"
#include "vplapp.h"
#include "cgametyp.h"
#include "vplabt.rh"
#include "ogame.h"
#include "vplmenu.rh"
#include "casnames.rh"
//*******************************************************************
TVPLMenuEnable::TVPLMenuEnable(BOOL setvalues)
:TCasinoMenuEnable(FALSE)
{
  if (setvalues)
  {
    SetAll(TRUE);
  }
  CurrentMode =  IDS_M_LOBBY_VPLITE;
  Lobby = FALSE;
}
//*******************************************************************
TVPLMenuEnable::~TVPLMenuEnable()
{
}
//*******************************************************************
void TVPLMenuEnable::SetAll(BOOL value)
{
  TCasinoMenuEnable::SetAll(value);
}
//*******************************************************************
void TVPLMenuEnable::SetModes(BOOL value)
{
  TCasinoMenuEnable::SetModes(value);

  Lobby = value;

  VPJack1 = value;
  VPJack5 = value;
  VPJack25 = value;
  VPJack100 = value;
  VPJack1P = value;

  VPDWild1 = value;
  VPDWild5 = value;
  VPDWild25 = value;
  VPDWild100 = value;

  VPJWild100 = value;
}
//*******************************************************************
//*******************************************************************
DEFINE_RESPONSE_TABLE1(TVPLGameFrameWindow,TCasinoGameFrameWindow)
  // lobby
  EV_COMMAND(CM_GAMELOBBY,CmGameLobby),
  EV_COMMAND_ENABLE(CM_GAMELOBBY,CeGameLobby),

  EV_COMMAND(CM_OPTIONSLOBBY_SHOWINTRO ,CmShowIntro),
  EV_COMMAND_ENABLE(CM_OPTIONSLOBBY_SHOWINTRO ,CeShowIntro),

  // vp jb
  EV_COMMAND(CM_GAMEVPJACK1,CmGameVPJack1),
  EV_COMMAND_ENABLE(CM_GAMEVPJACK1,CeGameVPJack1),
  EV_COMMAND(CM_GAMEVPJACK5,CmGameVPJack5),
  EV_COMMAND_ENABLE(CM_GAMEVPJACK5,CeGameVPJack5),
  EV_COMMAND(CM_GAMEVPJACK100,CmGameVPJack100),
  EV_COMMAND_ENABLE(CM_GAMEVPJACK100,CeGameVPJack100),
  EV_COMMAND(CM_GAMEVPJACK25,CmGameVPJack25),
  EV_COMMAND_ENABLE(CM_GAMEVPJACK25,CeGameVPJack25),
  EV_COMMAND(CM_GAMEVPJACK1P,CmGameVPJack1P),
  EV_COMMAND_ENABLE(CM_GAMEVPJACK1P,CeGameVPJack1P),
  // vp dw
  EV_COMMAND(CM_GAMEVPDWILD1,CmGameVPDWild1),
  EV_COMMAND_ENABLE(CM_GAMEVPDWILD1,CeGameVPDWild1),
  EV_COMMAND(CM_GAMEVPDWILD5,CmGameVPDWild5),
  EV_COMMAND_ENABLE(CM_GAMEVPDWILD5,CeGameVPDWild5),
  EV_COMMAND(CM_GAMEVPDWILD100,CmGameVPDWild100),
  EV_COMMAND_ENABLE(CM_GAMEVPDWILD100,CeGameVPDWild100),
  EV_COMMAND(CM_GAMEVPDWILD25,CmGameVPDWild25),
  EV_COMMAND_ENABLE(CM_GAMEVPDWILD25,CeGameVPDWild25),
  // vp jw
  EV_COMMAND(CM_GAMEVPJWILD100,CmGameVPJWild100),
  EV_COMMAND_ENABLE(CM_GAMEVPJWILD100,CeGameVPJWild100),
END_RESPONSE_TABLE;
//*******************************************************************
TVPLGameFrameWindow::TVPLGameFrameWindow(TVPLiteApp *pvplapp,const char *szTitle)
:TCasinoGameFrameWindow(pvplapp,szTitle,true,false)
{
  SetupModeStrings();
  FadeIn = FALSE;
//  GetIniShowIntro();
  DoStyle();
  DoIcon();
  DoMenu();
  if (ShowIntro)
  {
    StartupModeIndex = GetPGame()->GetModeIndex("s3vintro");
  }
  else
  {
    StartupModeIndex = GetPGame()->GetModeIndex(TAppString(IDS_M_LOBBY_VPLITE));
  }
}
//*******************************************************************
TVPLGameFrameWindow::~TVPLGameFrameWindow()
{
}
//*******************************************************************
void TVPLGameFrameWindow::CreateMenuEnable()
{
  PMenuEnable = new TVPLMenuEnable(TRUE);
}
//*******************************************************************
int TVPLGameFrameWindow::GetMenuID()
{
  return IDM_VPLITE_DEF;
}
//*******************************************************************
int TVPLGameFrameWindow::GetAboutID()
{
  return IDB_VPLITE_ABOUT_V1_0;
}
//*******************************************************************
void TVPLGameFrameWindow::DoMenu()
{
  AssignMenu(IDM_VPLITE_DEF);
}
//*******************************************************************
void TVPLGameFrameWindow::SwitchGameModes(int modeindex)
{
  if (!IsValidModeIndex(modeindex))
  {
	 MessageBox("Internal error, no switch attempted","Switch Mode",MB_OK);
  }
  else
  {
	 if (!SwitchModes(modeindex))
	 {
		MessageBox("Internal error, switching to startup mode","Switch Mode",MB_OK);
		SwitchModes(GetModeIndex(strLobby));//TAppString(IDS_M_LOBBY_VPLITE)));
	 }
  }
}
//*******************************************************************
void TVPLGameFrameWindow::CmGameLobby()
{
  SwitchGameModes(strLobby);//TAppString(IDS_M_LOBBY_VPLITE));
}
//*******************************************************************
void TVPLGameFrameWindow::CeGameLobby(TCommandEnabler &enabler)
{
  enabler.Enable(GetVPLMenuEnable()->Lobby);
  if (GetVPLMenuEnable()->CurrentMode == IDS_M_LOBBY_VPLITE)
  {
    enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
    enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TVPLGameFrameWindow::CmGameVPJack1()
{
  SwitchGameModes(strVPJack1);//TAppString(IDS_M_VP_JB1));
}
//*******************************************************************
void TVPLGameFrameWindow::CeGameVPJack1(TCommandEnabler &enabler)
{
  enabler.Enable(GetVPLMenuEnable()->VPJack1);
  if (GetVPLMenuEnable()->CurrentMode == IDS_M_VP_JB1)
  {
    enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
    enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TVPLGameFrameWindow::CmGameVPJack5()
{
  SwitchGameModes(strVPJack5);//TAppString(IDS_M_VP_JB5));
}
//*******************************************************************
void TVPLGameFrameWindow::CeGameVPJack5(TCommandEnabler &enabler)
{
  enabler.Enable(GetVPLMenuEnable()->VPJack5);
  if (GetVPLMenuEnable()->CurrentMode == IDS_M_VP_JB5)
  {
    enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
    enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TVPLGameFrameWindow::CmGameVPJack100()
{
  SwitchGameModes(strVPJack100);//TAppString(IDS_M_VP_JB100));
}
//*******************************************************************
void TVPLGameFrameWindow::CeGameVPJack100(TCommandEnabler &enabler)
{
  enabler.Enable(GetVPLMenuEnable()->VPJack100);
  if (GetVPLMenuEnable()->CurrentMode == IDS_M_VP_JB100)
  {
    enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
    enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TVPLGameFrameWindow::CmGameVPJack25()
{
  SwitchGameModes(strVPJack25);//TAppString(IDS_M_VP_JB25));
}
//*******************************************************************
void TVPLGameFrameWindow::CeGameVPJack25(TCommandEnabler &enabler)
{
  enabler.Enable(GetVPLMenuEnable()->VPJack25);
  if (GetVPLMenuEnable()->CurrentMode == IDS_M_VP_JB25)
  {
    enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
    enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TVPLGameFrameWindow::CmGameVPJack1P()
{
  SwitchGameModes(strVPJack1P);//TAppString(IDS_M_VP_JB1P));
}
//*******************************************************************
void TVPLGameFrameWindow::CeGameVPJack1P(TCommandEnabler &enabler)
{
  enabler.Enable(GetVPLMenuEnable()->VPJack1P);
  if (GetVPLMenuEnable()->CurrentMode == IDS_M_VP_JB1P)
  {
    enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
    enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TVPLGameFrameWindow::CmGameVPDWild1()
{
  SwitchGameModes(strVPDWild1);//TAppString(IDS_M_VP_DW1));
}
//*******************************************************************
void TVPLGameFrameWindow::CeGameVPDWild1(TCommandEnabler &enabler)
{
  enabler.Enable(GetVPLMenuEnable()->VPDWild1);
  if (GetVPLMenuEnable()->CurrentMode == IDS_M_VP_DW1)
  {
    enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
    enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TVPLGameFrameWindow::CmGameVPDWild5()
{
  SwitchGameModes(strVPDWild5);//TAppString(IDS_M_VP_DW5));
}
//*******************************************************************
void TVPLGameFrameWindow::CeGameVPDWild5(TCommandEnabler &enabler)
{
  enabler.Enable(GetVPLMenuEnable()->VPDWild5);
  if (GetVPLMenuEnable()->CurrentMode == IDS_M_VP_DW5)
  {
    enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
    enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TVPLGameFrameWindow::CmGameVPDWild100()
{
  SwitchGameModes(strVPDWild100);//TAppString(IDS_M_VP_DW100));
}
//*******************************************************************
void TVPLGameFrameWindow::CeGameVPDWild100(TCommandEnabler &enabler)
{
  enabler.Enable(GetVPLMenuEnable()->VPDWild100);
  if (GetVPLMenuEnable()->CurrentMode == IDS_M_VP_DW100)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
    enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TVPLGameFrameWindow::CmGameVPDWild25()
{
  SwitchGameModes(strVPDWild25);//TAppString(IDS_M_VP_DW25));
}
//*******************************************************************
void TVPLGameFrameWindow::CeGameVPDWild25(TCommandEnabler &enabler)
{
  enabler.Enable(GetVPLMenuEnable()->VPDWild25);
  if (GetVPLMenuEnable()->CurrentMode == IDS_M_VP_DW25)
  {
    enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
    enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
void TVPLGameFrameWindow::CmGameVPJWild100()
{
  SwitchGameModes(strVPJWild100);//TAppString(IDS_M_VP_JW100));
}
//*******************************************************************
void TVPLGameFrameWindow::CeGameVPJWild100(TCommandEnabler &enabler)
{
  enabler.Enable(GetVPLMenuEnable()->VPJWild100);
  if (GetVPLMenuEnable()->CurrentMode == IDS_M_VP_JW100)
  {
	 enabler.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
	 enabler.SetCheck(TCommandEnabler::Unchecked);
  }
}
//*******************************************************************
