//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  vplord.cpp
//    Project Name:  Ogle
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     08/2/95   A. Krist    Original baseline
//*******************************************************************
#include "vplord.h"
#include "vplordst.h"
#include "vplordmst.h"
#include "ostate.h"
#include <time.h>   //To Set Random Number Generator
#include "vpdeck.h"
#define  NUMBEROFPLAYERS 3
#define  BET1  5
#include <iostream.h>
#include <stdlib.h> //For Random Number Generator
#include <conio.h>
#include "cvpglspl.h"
#include "casvpmw.h"
//#include "cvpcrdsp.h"
#include "oskitcat.h"
#include "vpgobj.h"
//*******************************************************************
BOOL TVPLord::Respond(TResponder &responder)
{
  if (PState == NULL) {return TRUE;}

  switch (responder.GetID())
  {
    case idBet1      :  return (((TVPLordState *)PState)->Bet1Button(responder));
    case idBetMax    :  return (((TVPLordState *)PState)->BetMaxButton(responder));
    case idCashOut   :  return (((TVPLordState *)PState)->CashOut(responder));
    case idAddCoins  :  return (((TVPLordState *)PState)->AddCoin(responder));
    case idDealDraw  :  return (((TVPLordState *)PState)->DealDraw(responder));
    case idHoldCard0 :  return (((TVPLordState *)PState)->HoldCard0(responder));
    case idHoldCard1 :  return (((TVPLordState *)PState)->HoldCard1(responder));
    case idHoldCard2 :  return (((TVPLordState *)PState)->HoldCard2(responder));
    case idHoldCard3 :  return (((TVPLordState *)PState)->HoldCard3(responder));
    case idHoldCard4 :  return (((TVPLordState *)PState)->HoldCard4(responder));
    case idAskExpert :  return (((TVPLordState *)PState)->AskExpert(responder));
    default     :  return TRUE;
  }
}
//*******************************************************************
void TVPLord::SetupResponders()
{
  Responders[0] = new TResponder(100,TRect(141,435,207,474),idBet1,this,TRUE,'b');
  Responders[1] = new TResponder(100,TRect(434,435,500,474),idBetMax,this,TRUE,'m');
  Responders[2] = new TResponder(100,TRect(61,435,128,474),idCashOut,this,TRUE,'c');
  Responders[3] = new TResponder(100,TRect(543,404,617,424),idAddCoins,this,TRUE);
  Responders[4] = new TResponder(100,TRect(513,435,579,474),idDealDraw,this,TRUE,'d');
  Responders[5] = new TResponder(100,TRect(25,263,116,402),idHoldCard0,this,TRUE,'1');
  Responders[6] = new TResponder(100,TRect(122,263,211,402),idHoldCard1,this,TRUE,'2');
  Responders[7] = new TResponder(100,TRect(217,263,307,402),idHoldCard2,this,TRUE,'3');
  Responders[8] = new TResponder(100,TRect(312,263,401,402),idHoldCard3,this,TRUE,'4');
  Responders[9] = new TResponder(100,TRect(407,263,497,402),idHoldCard4,this,TRUE,'5');
  Responders[10] = new TResponder(100,TRect(593,435,633,474),idAskExpert,this,TRUE);
}
//*******************************************************************
TSpriteList *TVPLord::CreateSpriteList(TFileMode splfm)
{
  return (new TVPGLordSpriteList(splfm,this));
}
//*******************************************************************
void TVPLord::SetupSprites()
{
  for (int i=0;i<5;i++)
  {
    CardSprites[i] = NULL;
  }

  Bet1Button = NULL;
  BetMaxButton = NULL;
  CashOutButton = NULL;
  DealDrawButton = NULL;

  CoinsPlayed = NULL;
  WinRatio = NULL;
  WinPaid = NULL;
  Credits = NULL;
  Chips = NULL;

  CardSprites[0] = (TVPCard *)       GetSpritePtr(VPCard1);
  CardSprites[1] = (TVPCard *)       GetSpritePtr(VPCard2);
  CardSprites[2] = (TVPCard *)       GetSpritePtr(VPCard3);
  CardSprites[3] = (TVPCard *)       GetSpritePtr(VPCard4);
  CardSprites[4] = (TVPCard *)       GetSpritePtr(VPCard5);
  Bet1Button     = (TVPBet1 *)       GetSpritePtr(VPBet1);
  BetMaxButton   = (TVPBetMax *)     GetSpritePtr(VPBetMax);
  CashOutButton  = (TVPCashOut *)    GetSpritePtr(VPCashOut);
  DealDrawButton = (TVPDealDraw *)   GetSpritePtr(VPDealDraw);
  CoinsPlayed    = (TVPCoinsPlayed *)GetSpritePtr(VPCoinsPlayed);
  WinRatio       = (TVPWinRatio *)   GetSpritePtr(VPWinRatio);
  WinPaid        = (TVPWinPaid *)    GetSpritePtr(VPWinPaid);
  Credits        = (TVPCredits *)    GetSpritePtr(VPCredits);
  Chips          = (TVPChips *)      GetSpritePtr(VPChips);

  if (CardSprites[0] == NULL) {SpriteError("Card Sprite 1",VPCard1);}
  if (CardSprites[1] == NULL) {SpriteError("Card Sprite 2",VPCard2);}
  if (CardSprites[2] == NULL) {SpriteError("Card Sprite 3",VPCard3);}
  if (CardSprites[3] == NULL) {SpriteError("Card Sprite 4",VPCard4);}
  if (CardSprites[4] == NULL) {SpriteError("Card Sprite 5",VPCard5);}
  if (Bet1Button == NULL)     {SpriteError("Bet 1 Button",VPBet1);}
  if (BetMaxButton == NULL)   {SpriteError("Bet Max Button",VPBetMax);}
  if (CashOutButton == NULL)  {SpriteError("Cash Out Button",VPCashOut);}
  if (DealDrawButton == NULL) {SpriteError("Deal Draw Button",VPDealDraw);}
  if (CoinsPlayed == NULL)    {SpriteError("Coins Played Nums",VPCoinsPlayed);}
  if (WinRatio == NULL)       {SpriteError("Win Ratio Bars",VPWinRatio);}
  if (WinPaid == NULL)        {SpriteError("Win Paid Nums",VPWinPaid);}
  if (Credits == NULL)        {SpriteError("Credits Nums",VPCredits);}
  if (Chips == NULL)          {SpriteError("Chip Stacks",VPChips);}

  ActivateSpriteNow(Bet1Button);
  ActivateSpriteNow(CoinsPlayed);
  ActivateSpriteNow(BetMaxButton);
  ActivateSpriteNow(DealDrawButton);
  ActivateSpriteNow(CashOutButton);
  ActivateSpriteNow(WinRatio);
  ActivateSpriteNow(Credits);
  ActivateSpriteNow(WinPaid);
  for (int j=0;j<5;j++)
  {
    ActivateSpriteNow(CardSprites[j]);
  }
  ActivateSpriteNow(Chips);
}
//*******************************************************************
void TVPLord::CleanupSprites()
{
  CoinsPlayed->NoShow();
}
//*******************************************************************
TVPLord::TVPLord(TVideoPokerModeWin *pmwin,TFileMode NewFileMode,TVPGameType gametype,int coindenom)
  :TGameObject(TRUE,pmwin,NewFileMode)
{
  TFileMode splfm(SpriteListName,fm_HD_Immed,fm_Ram_Immed,FileMode.DirIndex);
  AddElement(CreateSpriteList(splfm));

  TFileMode skcfm(SkitCatName,fm_HD_Immed,fm_Ram_Immed,FileMode.DirIndex);
  AddElement(CreateSkitCat(skcfm));

  PState   = new TVPLordMainState(this);
  pDeck    = new TVPDeck(pmwin);
  pSmarts  = new TVPSmarts;
  fake     = new TPokerHand;
  pDeck->InitVPDeck();

  progressive = 4000;
  pMWin  = pmwin;
  maxbet=5;
  credits = 0;
  coinsize=coindenom;
  r1=0;
  r2=0;
  r3=0;
  activeplayer = 0;
  machinenum = 0;
  playersin=0;
  game   = gametype;
  numofsplits = 0;
  coinsplayed = 0;
  winnerpaid = 0;

  SetupResponders();

  SetupSprites();
}
//*******************************************************************
TVPLord::~TVPLord()
{
  if(PState != NULL)
  {
	 delete PState;
	 PState = NULL;
  }
  CleanupResponders();
}
//*******************************************************************
TVPLord::ChangeGame()
{
  int x=0;
  cout << "Pick new game, 1->10's,2->Jack's,3->Jack's progressive,4->2's,5->Joker ";
  cin >> x;
  if(x != 5 && game == 5)
  {
	 pDeck->RemoveJoker();
  }
  switch(x) {
	 case 1  : game = 1;break;
	 case 2  : game = 2;break;
	 case 3  : game = 3;break;
	 case 4  : game = 4;break;
	 case 5  : game = 5;break;
	 default : game = 0;break;
  }
  return 1;
}
//*******************************************************************
TVPLord::PayOutJacks()
{
  switch(pMWin->GObj[activeplayer]->pHand->highhand) {
	 case 10 :  if(pMWin->GObj[activeplayer]->pHand->highcard > Ten)
					{
					  credits += coinsplayed;
					}
					break;
	 case 15 :  credits += coinsplayed*2;break;
	 case 20 :  credits += coinsplayed*3;break;
	 case 23 :  credits += coinsplayed*4;break;
	 case 26 :  credits += coinsplayed*6;break;
	 case 70 :  credits += coinsplayed*9;break;
	 case 71 :  credits += coinsplayed*25;break;

	 case 99 :  if(pMWin->GObj[activeplayer]->pHand->highcard == AceHi)
					{
					  if(coinsplayed == 5)
					  {
						 credits += 4000;break;
					  }
					  else
					  {
						 credits += coinsplayed*250;break;
					  }
					}
					else
					{
					  credits += coinsplayed*50;break;
					}
	 default : return 1;
  }
  return 1;
}
//*******************************************************************
TVPLord::PayOutWild2()
{
  switch(pMWin->GObj[activeplayer]->pHand->highhand) {
	 case 20 :  winnerpaid += coinsplayed*1;break;
	 case 23 :  winnerpaid += coinsplayed*2;break;
	 case 26 :  winnerpaid += coinsplayed*2;break;
	 case 70 :  winnerpaid += coinsplayed*3;break;
	 case 71 :  winnerpaid += coinsplayed*5;break;

	 case 99 :  if(pMWin->GObj[activeplayer]->pHand->highcard == AceHi)
					{
					  if(coinsplayed == 5)
					  {
						 winnerpaid += 4000;break;
					  }
					  else
					  {
						 winnerpaid += coinsplayed*250;break;
					  }
					}
					else
					{
					  winnerpaid += coinsplayed*9;break;
					}
	 case 100 :   winnerpaid += coinsplayed*15;break;
	 case 105 :   winnerpaid += coinsplayed*25;break;
	 case 110 :   winnerpaid += coinsplayed*200;break;
	 default : return 1;
  }
  return 1;
}
//*******************************************************************
TVPLord::PayOutWildJoker()
{
  switch(pMWin->GObj[activeplayer]->pHand->highhand) {
	 case 15 :  credits += coinsplayed;cout << "Won " << coinsplayed;break;
	 case 20 :  credits += coinsplayed*2;cout << "Won " << coinsplayed*2;break;
	 case 23 :  credits += coinsplayed*5;cout << "Won " << coinsplayed*5;break;
	 case 26 :  credits += coinsplayed*7;cout << "Won " << coinsplayed*7;break;
	 case 70 :  credits += coinsplayed*8;cout << "Won " << coinsplayed*8;break;
	 case 71 :  credits += coinsplayed*20;cout << "Won " << coinsplayed*20;break;

	 case 99 :  if(pMWin->GObj[activeplayer]->pHand->highcard == AceHi)
					{
					  if(coinsplayed == 5)
					  {
						 cout << "Won 4000";
						 credits += 4000;break;
					  }
					  else
					  {
						 cout << "Won " << coinsplayed*250;
						 credits += coinsplayed*250;break;
					  }
					}
					else
					{
					  cout << "Won " << coinsplayed*50;
					  credits += coinsplayed*50;break;
					}
	 case 100 :   credits += coinsplayed*100;cout << "Won " << coinsplayed*100;break;
	 case 105 :   credits += coinsplayed*50;cout << "Won " << coinsplayed*50;break;
	 default : return 1;
  }
  return 1;
}
//*******************************************************************
TVPLord::PayOutProgressive()
{
  switch(pMWin->GObj[activeplayer]->pHand->highhand) {
	 case 10 :  if(pMWin->GObj[activeplayer]->pHand->highcard > Ten)
					{
					  credits += coinsplayed;cout << "Won " << coinsplayed;
					}
					break;
	 case 15 :  credits += coinsplayed*2;cout << "Won " << coinsplayed*2;break;
	 case 20 :  credits += coinsplayed*3;cout << "Won " << coinsplayed*3;break;
	 case 23 :  credits += coinsplayed*4;cout << "Won " << coinsplayed*4;break;
	 case 26 :  credits += coinsplayed*5;cout << "Won " << coinsplayed*5;break;
	 case 70 :  credits += coinsplayed*8;cout << "Won " << coinsplayed*8;break;
	 case 71 :  credits += coinsplayed*25;cout << "Won " << coinsplayed*25;break;

	 case 99 :  if(pMWin->GObj[activeplayer]->pHand->highcard == AceHi)
					{
					  if(coinsplayed == 5)
					  {
						 cout << "Won " << progressive << endl;;
						 credits += progressive;progressive = 4000;break;
					  }
					  else
					  {
						 cout << "Won " << coinsplayed*250;
						 credits += coinsplayed*250;break;
					  }
					}
					else
					{
					  cout << "Won " << coinsplayed*50;
					  credits += coinsplayed*50;break;
					}
	 default : return 1;
  }
  return 1;
}
//*******************************************************************
TVPLord::PayOutTens()
{
  switch(pMWin->GObj[activeplayer]->pHand->highhand) {
	 case 10 :  if(pMWin->GObj[activeplayer]->pHand->highcard > Nine)
					{
					  credits += coinsplayed;cout << "Won " << coinsplayed;
					}
					break;
	 case 15 :  credits += coinsplayed*2;cout << "Won " << coinsplayed*2;break;
	 case 20 :  credits += coinsplayed*3;cout << "Won " << coinsplayed*3;break;
	 case 23 :  credits += coinsplayed*4;cout << "Won " << coinsplayed*4;break;
	 case 26 :  credits += coinsplayed*5;cout << "Won " << coinsplayed*5;break;
	 case 70 :  credits += coinsplayed*6;cout << "Won " << coinsplayed*6;break;
	 case 71 :  credits += coinsplayed*25;cout << "Won " << coinsplayed*25;break;

	 case 99 :  if(pMWin->GObj[activeplayer]->pHand->highcard == AceHi)
					{
					  if(coinsplayed == 5)
					  {
						 cout << "Won 4000";
						 credits += 4000;break;
					  }
					  else
					  {
						 cout << "Won " << coinsplayed*250;
						 credits += coinsplayed*250;break;
					  }
					}
					else
					{
					  cout << "Won " << coinsplayed*50;
					  credits += coinsplayed*50;break;
					}
	 default : return 1;
  }
}
//*******************************************************************
TVPLord::FinalCashOut()
{
  int i=0;
  for(i=0;i<NUMBEROFPLAYERS;i++)
  {
	 for(;credits>0;credits--)
	 {
		pMWin->GObj[activeplayer]->cash += coinsize;
		cout << pMWin->GObj[activeplayer]->cash << endl;
	 }
	 Switch();
  }
  return 1;
}
//*******************************************************************
TVPLord::Clear()
{
  int i=0;
  pMWin->GObj[activeplayer]->pHand->highhand      = 0;
  pMWin->GObj[activeplayer]->pHand->highcard      = 0;
  pMWin->GObj[activeplayer]->pHand->toflush       = 0;
  pMWin->GObj[activeplayer]->pHand->instrght      = 0;
  pMWin->GObj[activeplayer]->pHand->outstrght     = 0;
  pMWin->GObj[activeplayer]->pHand->lohighcard    = 0;
  pMWin->GObj[activeplayer]->pHand->lolowcard     = 0;
  pMWin->GObj[activeplayer]->pHand->lohand        = 0;
  pMWin->GObj[activeplayer]->pHand->inhand        = 0;
  pMWin->GObj[activeplayer]->pHand->lowcard       = 0;
  pMWin->GObj[activeplayer]->pHand->wildcount     = 0;
  for(i=0;i<5;i++)
  {
	 pMWin->GObj[activeplayer]->pHand->hold[i]     = 0;
  }
  if(pDeck != NULL)
  {
	 pDeck->top                        = 0;
  }
  return 1;
}
//*******************************************************************
void TVPLord::FinalClear()
{
  int i=0;
  for(i=0;i<NUMBEROFPLAYERS;i++)
  {
  }
}
//*******************************************************************
TVPLord::GetNumOfWildCards()
{
  int i=0;
  if(game == 4)
  {
	 for(i=0;i<5;i++)
	 {
		if(pMWin->GObj[activeplayer]->pHand->cards[i].name == Two)
		{
		  pMWin->GObj[activeplayer]->pHand->wildcount++;
		}
	 }
  }
  else
  {
	 for(i=0;i<5;i++)
	 {
		if(pMWin->GObj[activeplayer]->pHand->cards[i].name == Joker)
		{
		  pMWin->GObj[activeplayer]->pHand->wildcount++;
		}
	 }
  }
  return 1;
}
//*******************************************************************
TVPLord::Wild2()
{
  int i=0,j=0;
  fake->inhand = 0;
  for(i=0;i<5;i++)
  {
	 fake->cards[i].name = pMWin->GObj[activeplayer]->pHand->cards[i].name;
	 fake->cards[i].suit = pMWin->GObj[activeplayer]->pHand->cards[i].suit;
	 fake->inhand++;
  }
  pSmarts->Insert_Sort(fake);

  if(pMWin->GObj[activeplayer]->pHand->wildcount)
  {
	 if(pMWin->GObj[activeplayer]->pHand->wildcount > 3)
	 {
		pMWin->GObj[activeplayer]->pHand->highhand = 110; // Four Deuces
		return 1;
	 }
	 if(pMWin->GObj[activeplayer]->pHand->wildcount > 2)
	 {
		if(fake->cards[3].suit == fake->cards[4].suit)
		{
		  if(fake->cards[3].name > Nine && fake->cards[4].name > Nine)
		  {
			 pMWin->GObj[activeplayer]->pHand->highhand = 105; // Royal with wild
			 return 1;
		  }
		  else
		  {
			 if(fake->cards[4].name - fake->cards[3].name < 5)
			 {
				pMWin->GObj[activeplayer]->pHand->highhand = 99; // Straight flush
				return 1;
			 }
		  }
		}
		else
		{
		  if(fake->cards[4].name == fake->cards[3].name)
		  {
			 pMWin->GObj[activeplayer]->pHand->highhand = 100; // Five of kind
			 return 1;
		  }
		}
		pMWin->GObj[activeplayer]->pHand->highhand = 71; // Four of a kind
		return 1;
	 }
	 if(pMWin->GObj[activeplayer]->pHand->wildcount > 1)
	 {
		if(fake->cards[4].suit == fake->cards[3].suit &&
			fake->cards[2].suit == fake->cards[3].suit)
		{
		  if(fake->cards[4].name - fake->cards[2].name < 5)
		  {
			 if(fake->cards[2].name >= Nine)
			 {
				pMWin->GObj[activeplayer]->pHand->highhand = 105;  // Royal wilds
				pMWin->GObj[activeplayer]->pHand->highcard = AceHi;
				return 1;
			 }
			 else
			 {
				pMWin->GObj[activeplayer]->pHand->highhand = 99; //Straight flush
				return 1;
			 }
		  }
		  else
		  {
			 pMWin->GObj[activeplayer]->pHand->highhand = 26; // flush
			 return 1;
		  }
		}
		if(fake->cards[4].name - fake->cards[2].name < 5)
		{
		  pMWin->GObj[activeplayer]->pHand->highhand = 23; // Straight
		}
		if(fake->cards[4].name == fake->cards[2].name)
		{
		  pMWin->GObj[activeplayer]->pHand->highhand = 100; // 5 o'kind
		  return 1;
		}
		if(fake->cards[3].name == fake->cards[2].name ||
			fake->cards[3].name == fake->cards[4].name)
		{
		  pMWin->GObj[activeplayer]->pHand->highhand = 71; // 4 o'kind
		  return 1;
		}
		if(pMWin->GObj[activeplayer]->pHand->highhand < 20)
		{
		  pMWin->GObj[activeplayer]->pHand->highhand = 20; // 3 o'kind
		}
		return 1;
	 }
	 for(i=Two;i<=AceHi;i++)
	 {
		fake->cards[0].name = i;
		for(j=0;j<4;j++)
		{
		  fake->cards[0].suit = j;
		  /*
		  if(pMWin->GObj[activeplayer]->pHand->wildcount > 1)   /////
		  {
			 for(k=Two;k<=AceHi;k++)
			 {
				fake->cards[1].name = k;
				for(l=0;l<4;l++)
				{
				  fake->cards[1].suit = l;
				  fake->highhand      = 0;
				  fake->highcard      = 0;
				  fake->toflush       = 0;
				  fake->instrght      = 0;
				  fake->outstrght     = 0;
				  fake->lohighcard    = 0;
				  fake->lolowcard     = 0;
				  fake->lohand        = 0;
				  fake->lowcard       = 0;
				  pSmarts->Holding(fake);
				  if(fake->highhand > pMWin->GObj[activeplayer]->pHand->highhand)
				  {
					 if(fake->highhand == 99 && fake->highcard == AceHi)
					 {
						pMWin->GObj[activeplayer]->pHand->highhand = 105;
						pMWin->GObj[activeplayer]->pHand->highcard = AceHi;
						return 1;
					 }
					 else
					 {
						pMWin->GObj[activeplayer]->pHand->highhand = fake->highhand;
						pMWin->GObj[activeplayer]->pHand->highcard = fake->highcard;
					 }
				  }
				  else
				  {
					 if(fake->highhand == 99 && fake->highcard == AceHi)
					 {
						pMWin->GObj[activeplayer]->pHand->highhand = 105;
						pMWin->GObj[activeplayer]->pHand->highcard = AceHi;
						return 1;
					 }
				  }
				}
			 }
		  }                                         /////////////////////
		  else
		  { */
			 fake->highhand      = 0;
			 fake->highcard      = 0;
			 fake->toflush       = 0;
			 fake->instrght      = 0;
			 fake->outstrght     = 0;
			 fake->lohighcard    = 0;
			 fake->lolowcard     = 0;
			 fake->lohand        = 0;
			 fake->lowcard       = 0;
			 pSmarts->Holding(fake);
			 if(fake->highhand > pMWin->GObj[activeplayer]->pHand->highhand)
			 {
				if(fake->highhand == 99 && fake->highcard == AceHi)
				{
				  pMWin->GObj[activeplayer]->pHand->highhand = 105;
				  pMWin->GObj[activeplayer]->pHand->highcard = AceHi;
				}
				else
				{
				  pMWin->GObj[activeplayer]->pHand->highhand = fake->highhand;
				  pMWin->GObj[activeplayer]->pHand->highcard = fake->highcard;
				}
			 }
			 else
			 {
				if(fake->highhand == 99 && fake->highcard == AceHi)
				{
				  pMWin->GObj[activeplayer]->pHand->highhand = 105;
				  pMWin->GObj[activeplayer]->pHand->highcard = AceHi;
				}
			 }
		 // }
		}
	 }
	 return 1;
  }//if(wildcount)
  pSmarts->Holding(pMWin->GObj[activeplayer]->pHand);
  return 1;
}
//*******************************************************************
TVPLord::WildJoker()
{
  int i=0,j=0;
  fake->inhand = 0;
  for(i=0;i<5;i++)
  {
	 fake->cards[i].name = pMWin->GObj[activeplayer]->pHand->cards[i].name;
	 fake->cards[i].suit = pMWin->GObj[activeplayer]->pHand->cards[i].suit;
	 fake->inhand++;
  }
  pSmarts->Insert_Sort(fake);

  if(pMWin->GObj[activeplayer]->pHand->wildcount)
  {
	 for(i=Two;i<=AceHi;i++)
	 {
		fake->cards[4].name = i;
		for(j=0;j<4;j++)
		{
		  fake->cards[4].suit = j;
		  fake->highhand      = 0;
		  fake->highcard      = 0;
		  fake->toflush       = 0;
		  fake->instrght      = 0;
		  fake->outstrght     = 0;
		  fake->lohighcard    = 0;
		  fake->lolowcard     = 0;
		  fake->lohand        = 0;
		  fake->lowcard       = 0;
		  pSmarts->Holding(fake);
		  if(fake->highhand > pMWin->GObj[activeplayer]->pHand->highhand)
		  {
			 if(fake->highhand == 99 && fake->highcard == AceHi)
			 {
				pMWin->GObj[activeplayer]->pHand->highhand = 105;
				pMWin->GObj[activeplayer]->pHand->highcard = AceHi;
			 }
			 else
			 {
				pMWin->GObj[activeplayer]->pHand->highhand = fake->highhand;
				pMWin->GObj[activeplayer]->pHand->highcard = fake->highcard;
			 }
		  }
		  else
		  {
			 if(fake->highhand == 99 && fake->highcard == AceHi)
			 {
				pMWin->GObj[activeplayer]->pHand->highhand = 105;
				pMWin->GObj[activeplayer]->pHand->highcard = AceHi;
			 }
		  }
		}
	 }
	 return 1;
  }//if(wildcount)
  pSmarts->Holding(pMWin->GObj[activeplayer]->pHand);
  return 1;
}
//*******************************************************************
TVPLord::Winner()
{
  winnerpaid = 0;
  if(game == 5 || game == 4)
  {
	 GetNumOfWildCards();
  }
  switch(game) {
	 case 1  :  pSmarts->Holding(pMWin->GObj[activeplayer]->pHand);break;
	 case 2  :  pSmarts->Holding(pMWin->GObj[activeplayer]->pHand);break;
	 case 3  :  pSmarts->Holding(pMWin->GObj[activeplayer]->pHand);break;
	 case 4  :  Wild2();break;
	 case 5  :  WildJoker();break;
	 default :  return 0;
  }
  if(pMWin->GObj[activeplayer]->pHand->highhand >= 10)
  {
	 switch(game) {
		case 1  : PayOutTens();break;
		case 2  : PayOutJacks();break;
		case 3  : PayOutProgressive();break;
		case 4  : PayOutWild2();break;
		case 5  : PayOutWildJoker();break;
		default : break;
	 }
  }
//  cout << "Credits-> " << credits;
  return winnerpaid;
}// winner
//*******************************************************************
TVPLord::Vid1()
{
  return 1;
}
//*******************************************************************
TVPLord::InitVid()
{
  int i=0;
  for(i=0;i<NUMBEROFPLAYERS;i++)
  {
  }
  activeplayer = 0;
  credits = 0;
  coinsplayed = 0;
  winnerpaid = 0;
  switch (machinenum) {
	 case 0  :   Vid1();break;
	 default :   Vid1();break;
  }
  return 1;
}
//*******************************************************************
TVPLord::GetBet()
{
 int z=1;
 coinsplayed = 0;
 winnerpaid = 0;
 while(z != 0)
 {
  cout << "Get Bet" << endl;
  if(coinsplayed < maxbet)
  {
	 cout << "Enter 1 to 'BET 1' ";
  }
  if(coinsplayed < maxbet && (credits > 0 || pMWin->GObj[activeplayer]->cash > coinsize))
  {
	 cout << "Enter 2 to 'BET MAX' ";
  }
  if(coinsplayed > 0)
  {
	 cout << "Enter 3 to 'DEAL' ";
  }
  if(credits > 0)
  {
	 cout << "Enter 4 to 'CASH OUT' ";
  }
  if(pMWin->GObj[activeplayer]->cash > coinsize)
  {
	 cout << "Enter 5 to 'ADD COINS' ";
  }

  cout << "Enter 6 to 'QUIT' ";
  if(coinsplayed == 0)
  {
	 cout << "Enter 7 to 'SWITCH' to another player ";
  }
  cout << "Enter 8 to change game ";
  cin >> z;
  switch (z) {
	 case 1 :  Bet1();break;
	 case 2 :  BetMax();return game;
	 case 3 :  return game;  // Spin
	 case 4 :  CashOut();break;
	 case 5 :  AddCoins();break;
	 case 6 :  FinalCashOut();return 0;
	 case 7 :  Switch();break;
	 case 8 :  ChangeGame();break;
	 default : return 0;  // Quit
  }
 }
 return 0;
}
//*******************************************************************
TVPLord::Switch()
{
  pMWin->GObj[activeplayer]->credit = credits;
  activeplayer++;
  activeplayer = activeplayer%NUMBEROFPLAYERS;
  cout << "Player " << activeplayer << endl;
  credits = pMWin->GObj[activeplayer]->credit;
}
//*******************************************************************
TVPLord::AddCoins()
{
  if(coinsplayed < maxbet)
  {
	 pMWin->GObj[activeplayer]->cash -= coinsize;
	 coinsplayed++;
  }
  else
  {
	 if(coinsplayed == maxbet)   // Not a needed check, oh well...
	 {
      pMWin->GObj[activeplayer]->cash -= coinsize;
		credits++;
	 }
  }
  return 1;
}
//*******************************************************************
TVPLord::CashOut()
{
  for(;credits>0;credits--)
  {
	 pMWin->GObj[activeplayer]->cash += coinsize;
	 cout << pMWin->GObj[activeplayer]->cash << endl;
  }
  return 1;
}
//*******************************************************************
TVPLord::Bet1()
{
	if(credits > 0)
	{
	  credits--;
	  coinsplayed++;
     CoinsPlayed->SetNum(coinsplayed);
     WinRatio->SetColumn(coinsplayed - 1);
     Credits->SetNum(credits);
	  return 1;
	}
	if(pMWin->GObj[activeplayer]->cash > coinsize)
	{
	  pMWin->GObj[activeplayer]->cash -= coinsize;
	  coinsplayed++;
     CoinsPlayed->SetNum(coinsplayed);
     WinRatio->SetColumn(coinsplayed - 1);
     Credits->SetNum(credits);
     Chips->SetNum(pMWin->GObj[activeplayer]->cash);
	}
	return 1;
}
//*******************************************************************
TVPLord::BetMax()
{
  int cp = coinsplayed;

  if(credits > maxbet-coinsplayed)
  {
	 credits -= maxbet-coinsplayed;
	 coinsplayed = maxbet;
    CoinsPlayed->SetNum(coinsplayed);
    WinRatio->SetColumn(MAXBET-1);
    Credits->SetNum(credits);
	 return (coinsplayed - cp);
  }
  else
  {
	 coinsplayed += credits;
	 credits = 0;                          // Could make a little faster
  }

  if(pMWin->GObj[activeplayer]->cash > (maxbet-coinsplayed)*coinsize)
  {
	 pMWin->GObj[activeplayer]->cash -= (maxbet-coinsplayed)*coinsize;
	 coinsplayed = maxbet;
    CoinsPlayed->SetNum(coinsplayed);
    WinRatio->SetColumn(MAXBET -1);
    Credits->SetNum(credits);
    Chips->SetNum(pMWin->GObj[activeplayer]->cash);
  }
  else
  {
	 coinsplayed += (pMWin->GObj[activeplayer]->cash)/(coinsize);
	 pMWin->GObj[activeplayer]->cash = 0;
    CoinsPlayed->SetNum(coinsplayed);
    WinRatio->SetColumn(coinsplayed - 1);
    Credits->SetNum(credits);
    Chips->SetNum(pMWin->GObj[activeplayer]->cash);
  }
  return (coinsplayed - cp);
}
//*******************************************************************
TVPLord::Discards()
{
  cout << "Enter 1-5 to toggle,Enter 0 to 'DRAW' " << endl;
  int z=1;
  while(z != 0)
  {
	 cin >> z;
	 if(z > 0 && z < 6)
	 {
		if(pMWin->GObj[activeplayer]->pHand->hold[z-1] == 1)
		{
		  pMWin->GObj[activeplayer]->pHand->hold[z-1] = 0;
		}
		else
		{
		  pMWin->GObj[activeplayer]->pHand->hold[z-1] = 1;
		}
	 }
  }
  return 1;
}
//*******************************************************************
void TVPLord::HoldCard(int cardnum)
{
  if ((cardnum < 0) || (cardnum > 4)) {return;}

  if(pMWin->GObj[activeplayer]->pHand->hold[cardnum] == 1)
  {
    pMWin->GObj[activeplayer]->pHand->hold[cardnum] = 0;
  }
  else
  {
    pMWin->GObj[activeplayer]->pHand->hold[cardnum] = 1;
  }

  BOOL held = pMWin->GObj[activeplayer]->pHand->hold[cardnum];
  CardSprites[cardnum]->Hold(held);
}
//*******************************************************************
TVPLord::ShowReels()
{
  switch (r1)
	 {
		case 0 :
		  cout << "BLANK ";
		  break;
		case 1 :
		  cout << "JOKER ";
		  break;
		case 2 :
		  cout << "ACE   ";
		  break;
		case 3 :
		  cout << "KING  ";
		  break;
		case 4 :
		  cout << "QUEEN ";
		  break;
		case 5 :
		  cout << "JACK  ";
		  break;
		default :
		  cout << "BLANK ";
	 }
  switch (r2)
	 {
		case 0 :
		  cout << "BLANK ";
		  break;
		case 1 :
		  cout << "JOKER ";
		  break;
		case 2 :
		  cout << "ACE   ";
		  break;
		case 3 :
		  cout << "KING  ";
		  break;
		case 4 :
		  cout << "QUEEN ";
		  break;
		case 5 :
		  cout << "JACK  ";
		  break;
		default :
		  cout << "BLANK ";
	 }
  switch (r3)
	 {
		case 0 :
		  cout << "BLANK ";
		  break;
		case 1 :
		  cout << "JOKER ";
		  break;
		case 2 :
		  cout << "ACE   ";
		  break;
		case 3 :
		  cout << "KING  ";
		  break;
		case 4 :
		  cout << "QUEEN ";
		  break;
		case 5 :
		  cout << "JACK  ";
		  break;
		default :
		  cout << "BLANK ";
	 }
  cout << "r's " << (int)r1 << "/" << (int)r2 << "/" << (int)r3 << endl;
  return 1;
}
//*******************************************************************
TVPLord::ShowWinner()
{
  cout << "You won " << winnerpaid*coinsize << " bucks.";
  credits += (winnerpaid)/(coinsize);
  cout << "You have " << pMWin->GObj[activeplayer]->cash << " bucks.";
  cout << "You have " << credits << " credits.";

  return 1;
}
//*******************************************************************
TVPLord::DrawCards()
{
  pDeck->Draw(pMWin->GObj[activeplayer]->pHand);
  return 1;
}
//*******************************************************************