//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  casvpmw.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     8/30/96    M.Perry     original baseline
//  2.0    09/25/97    M.Perry     32-bit conversion.
//  2.5    09/28/99    M.Perry    original baseline
//********************************************************************
#include "casvpmw.h"
#include "cvpglord.h"
#include "chelpid.h"
#include "oloaddlg.h"
#include "vp_cm.rh"
//*******************************************************************
DEFINE_RESPONSE_TABLE1(TVideoPokerModeWin,TCasinoModeWin)
  EV_COMMAND(CM_OPTIONSVP_ADD50CREDITS,CmOptionsAdd50Credits),
  EV_COMMAND_ENABLE(CM_OPTIONSVP_ADD50CREDITS,CeOptionsAdd50Credits),
  EV_COMMAND(CM_OPTIONSVP_ADD100CREDITS,CmOptionsAdd100Credits),
  EV_COMMAND_ENABLE(CM_OPTIONSVP_ADD100CREDITS,CeOptionsAdd100Credits),
  EV_COMMAND(CM_OPTIONSVP_ADD200CREDITS,CmOptionsAdd200Credits),
  EV_COMMAND_ENABLE(CM_OPTIONSVP_ADD200CREDITS,CeOptionsAdd200Credits),
END_RESPONSE_TABLE;
//*******************************************************************
void TVideoPokerModeWin::CmOptionsAdd50Credits()
{
  if (GetVPGameLord() == NULL) {return;}
  GetVPGameLord()->AddCredits(50);
}
//*******************************************************************
void TVideoPokerModeWin::CeOptionsAdd50Credits(TCommandEnabler &enabler)
{
  enabler.Enable(bool(GetVPGameLord() != NULL));
//  if (GetVPGameLord() != NULL)
//  {
//    enabler.Enable(TRUE);
//  }
//  else
//  {
//    enabler.Enable(FALSE);
//  }
}
//*******************************************************************
void TVideoPokerModeWin::CmOptionsAdd100Credits()
{
  if (GetVPGameLord() == NULL) {return;}
  GetVPGameLord()->AddCredits(100);
}
//*******************************************************************
void TVideoPokerModeWin::CeOptionsAdd100Credits(TCommandEnabler &enabler)
{
  enabler.Enable(bool(GetVPGameLord() != NULL));
//  if (GetVPGameLord() != NULL)
//  {
//    enabler.Enable(TRUE);
//  }
//  else
//  {
//    enabler.Enable(FALSE);
//  }
}
//*******************************************************************
void TVideoPokerModeWin::CmOptionsAdd200Credits()
{
  if (GetVPGameLord() == NULL) {return;}
  GetVPGameLord()->AddCredits(200);
}
//*******************************************************************
void TVideoPokerModeWin::CeOptionsAdd200Credits(TCommandEnabler &enabler)
{
  enabler.Enable(bool(GetVPGameLord() != NULL));
//  if (GetVPGameLord() != NULL)
//  {
//    enabler.Enable(TRUE);
//  }
//  else
//  {
//    enabler.Enable(FALSE);
//  }
}
//*******************************************************************
TVideoPokerModeWin::TVideoPokerModeWin(string modename,TPal *PPal,string title)
:TCasinoModeWin(modename,PPal,title)
{
  ModeHelpCommand = HELP_CONTEXT;
  ModeHelpData = IDH_CAS_VP;
}
//*******************************************************************
TVideoPokerModeWin::~TVideoPokerModeWin()
{
}
//*******************************************************************
string TVideoPokerModeWin::GetDetName()
{
  return string("vp");
}
//*******************************************************************
int TVideoPokerModeWin::GetMenuID()
{
  return IDM_CASINO_VP;
}
//*******************************************************************
void TVideoPokerModeWin::CreateGroupGaugeDlg()
{
  PGroupGaugeDlg = new TLoadDlg(this,
                                this,
                                new TBitmap(*GetOgleApp(),IDB_LOADING_V2),
                                bdRESIZE | bdIGNOREINPUT | bdOWNBITMAP,
                                TRect(20,160,300,175),
                                TColor::LtYellow);
  PGroupGaugeDlg->Create();
}
//*******************************************************************

