//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  cvpcrdsp.cpp
//    Project Name:  Casino
// Original Author:  Adam Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     7/19/96    M.Perry    moved into cpp file.
//  2.0    09/27/97    M.Perry    32-bit conversion.
//********************************************************************
#include "cvpcrdsp.h"
#include "oanm.h"
//*******************************************************************
void TVPCard::SetupAnms()
{
  PBack = GetAnm(0);
  if (PBack == NULL) {AnmError("Card Sprite","Back",0);}
  PCard = GetAnm(1);
  if (PCard == NULL) {AnmError("Card Sprite","Card Faces",1);}
  PHold = GetAnm(2);
  if (PHold == NULL) {AnmError("Card Sprite","Held",2);}

  PCard->NoShow();
  PCard->CAD.ClearAutoStart();
  PCard->CAD.ClearAutoStop();
  PCard->CAD.SetDirStill();
  PBack->Show();
  PBack->CAD.ClearAutoStart();
  PBack->CAD.ClearAutoStop();
  PBack->CAD.SetDirStill();
  PHold->NoShow();
  PHold->CAD.ClearAutoStart();
  PHold->CAD.ClearAutoStop();
  PHold->CAD.SetDirStill();
}
//*******************************************************************
TVPCard::TVPCard(TOgleModeWindow *pmw,const TFileMode &NewFileMode)
:TSprite(pmw,NewFileMode)
{
  SetToManual();
  NoShow();
  SetupAnms();
}
//*******************************************************************
TVPCard::TVPCard(TOgleModeWindow *pmw,const TFileMode &NewFileMode,void *psource)
:TSprite(pmw,NewFileMode,psource)
{
  SetToManual();
  NoShow();
  SetupAnms();
}
//*******************************************************************
TVPCard::~TVPCard()
{
}
//*******************************************************************
void TVPCard::ShowBack()
{
  PCard->NoShow();
  PBack->CAD.SetCurrentFrame(0);
  PBack->Show();
  Update(GetAdjFUC());
}
//*******************************************************************
void TVPCard::ShowFlip()
{
  PCard->NoShow();
  PBack->CAD.SetCurrentFrame(1);
  PBack->Show();
  Update(GetAdjFUC());
}
//*******************************************************************
void TVPCard::Hold(bool held)
{
  if (held)
  {
    PHold->Show();
  }
  else
  {
    PHold->NoShow();
  }
  Update(GetAdjFUC());
}
//*******************************************************************
void TVPCard::ShowFace(TSuit suit,TCardName cardname)
{
	 int16 num = 0;
	 if (PCard == NULL) {return;}

	 if (cardname > Joker) {return;}
	 if (suit > Spade) {return;}
	 if (cardname == AceHi) {cardname = AceLo;}

	 if (cardname == Joker)
	 {
		num = 52;
	 //  cardname -=1;
	 }
	 else
	 {
		num = int16((suit * 13) + cardname);
	 }

	 PBack->NoShow();
	 PCard->Show();
	 PCard->CAD.SetCurrentFrame(num);
    Update(GetAdjFUC());
}
//*******************************************************************

