//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  cvpcrsp.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0      7/19/96   M.Perry     moved into cpp file.
//  2.0     09/25/97   M.Perry     32-bit conversion.
//********************************************************************
#include "cvpcrsp.h"
#include "oanm.h"
//*******************************************************************
TVPCredits::TVPCredits(TOgleModeWindow *pmw,const TFileMode &NewFileMode)
:TSprite(pmw,NewFileMode)
{
  SetToManual();
  SetupAnms();
}
//*******************************************************************
TVPCredits::TVPCredits(TOgleModeWindow *pmw,const TFileMode &NewFileMode,void *psource)
:TSprite(pmw,NewFileMode,psource)
{
  SetToManual();
  SetupAnms();
}
//*******************************************************************
TVPCredits::~TVPCredits()
{
}
//*******************************************************************
void TVPCredits::SetupAnms()
{
	 PCredits[0] = GetAnm(0);
	 PCredits[1] = GetAnm(1);
	 PCredits[2] = GetAnm(2);
	 PCredits[3] = GetAnm(3);

	 for (int16 j=0;j<4;j++)
	 {
		if (PCredits[j] == NULL) {AnmError("Credits","Nums",j);}
	 }

	 for (int16 i=0;i<4;i++)
	 {
		PCredits[i]->CAD.ClearAutoStart();
		PCredits[i]->CAD.ClearAutoStop();
		PCredits[i]->CAD.SetDirStill();
	 }
}
//*******************************************************************
void TVPCredits::SetNum(int16 num)
{
	 if (PCredits[0] == NULL) {return;}
	 if (PCredits[1] == NULL) {return;}
	 if (PCredits[2] == NULL) {return;}
	 if (PCredits[3] == NULL) {return;}

	 ones = int16(num % 10);
	 tens = int16((num / 10  ) % 10);
	 huns = int16((num / 100 ) % 10);
	 thou = int16((num / 1000) % 10);
	 PCredits[0]->CAD.SetCurrentFrame(ones);
	 PCredits[1]->CAD.SetCurrentFrame(tens);
	 PCredits[2]->CAD.SetCurrentFrame(huns);
	 PCredits[3]->CAD.SetCurrentFrame(thou);
    for (int16 i=0;i<4;i++)
	 {
		PCredits[i]->Show();
	 }
    Update(GetAdjFUC());
}
//*******************************************************************