//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  cvpwpsp.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     7/19/96    M.Perry    moved into cpp file.
//  2.0    09/25/97    M.Perry    32-bit conversion.
//********************************************************************
#include "cvpwpsp.h"
#include "oanm.h"
//*******************************************************************
TVPWinPaid::TVPWinPaid(TOgleModeWindow *pmw,const TFileMode &NewFileMode)
:TSprite(pmw,NewFileMode)
{
  SetToManual();
  SetupAnms();
}
//*******************************************************************
TVPWinPaid::TVPWinPaid(TOgleModeWindow *pmw,const TFileMode &NewFileMode,void *psource)
:TSprite(pmw,NewFileMode,psource)
{
  SetToManual();
  SetupAnms();
}
//*******************************************************************
TVPWinPaid::~TVPWinPaid()
{
}
//*******************************************************************
void TVPWinPaid::SetupAnms()
{
  PWinPaid[0] = GetAnm(0);
  PWinPaid[1] = GetAnm(1);
  PWinPaid[2] = GetAnm(2);
  PWinPaid[3] = GetAnm(3);

  for (int16 j=0;j<4;j++)
  {
	 if (PWinPaid[j] == NULL) {AnmError("Win Paid","num",j);}
  }

  for (int16 i=0;i<4;i++)
  {
    PWinPaid[i]->CAD.ClearAutoStart();
    PWinPaid[i]->CAD.ClearAutoStop();
    PWinPaid[i]->CAD.SetDirStill();
  }
}
//*******************************************************************
void TVPWinPaid::SetNum(int16 num)
{
  if (PWinPaid[0] == NULL) {return;}
  if (PWinPaid[1] == NULL) {return;}
  if (PWinPaid[2] == NULL) {return;}
  if (PWinPaid[3] == NULL) {return;}

  ones = int16(num % 10);
  tens = int16((num / 10  ) % 10);
  huns = int16((num / 100 ) % 10);
  thou = int16((num / 1000) % 10);
  PWinPaid[0]->CAD.SetCurrentFrame(ones);
  PWinPaid[1]->CAD.SetCurrentFrame(tens);
  PWinPaid[2]->CAD.SetCurrentFrame(huns);
  PWinPaid[3]->CAD.SetCurrentFrame(thou);
  for (int16 j=0;j<4;j++)
  {
	 PWinPaid[j]->Show();
  }
  Update(GetAdjFUC());

}
//*******************************************************************

