//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  vpact2st.cpp
//    Project Name:  Casino
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     06/29/95   A. Krist    Original baseline
//  2.0     09/25/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "vpact2st.h"
//#include "cvpglord.h"
#include "vpdrawst.h"
#include "vpwinst.h"
#include "otimers.h"
#include "orespond.h"
//*******************************************************************
//TVPAct2State::TVPAct2State(TCasinoVPGameLord *pNewVPLord)
TVPAct2State::TVPAct2State(TACCVPGLord *pNewVPLord)
:TVPLordState(pNewVPLord)
{
  SetRunOrder(ess_Execute,ess_StartSubState2,ess_Done);
  DealDrawResponder = NULL;
  AskExpertResponder = NULL;
  MenuEscResponder = NULL;
  askexpertflag = false;
  IgnoreCoach = false;
  CursorFUC = 0;
}
//*******************************************************************
TVPAct2State::~TVPAct2State()
{
}
//*******************************************************************
void TVPAct2State::ExecuteFirstTime()
{
  ExecuteWaiting = true;
  ExecuteStatus    = ess_Execute;
  pOwnerLord->DrawBack->SetBack();
  pOwnerLord->Button4->ShowGray();
  pOwnerLord->Button5->ShowGray();
  pOwnerLord->Button6->ShowGray();
  pOwnerLord->DisEnableButton(idButton7);
  pOwnerLord->EnableButton(idButton8);
  pOwnerLord->UnFreezeAllButtons();//show background
  for(int16 i=1;i<6;i++)
  {
	 pOwnerLord->Responders[i]->Add();
  }
  pOwnerLord->Responders[0]->Remove();
  pOwnerLord->Responders[13]->Remove();
  for(int16 i=6;i<12;i++)
  {
	 pOwnerLord->Responders[i]->Remove();
  }
}
//*******************************************************************
void TVPAct2State::CreateSubState1()
{
  PActiveSubState = new TVPDrawState(pOwnerLord);
}
//*******************************************************************
void TVPAct2State::CreateSubState2()
{
  PActiveSubState = new TVPWinState(pOwnerLord);
}
//*******************************************************************
#pragma argsused
void TVPAct2State::HandlePostUpdate(dword NewFUC)
{
  if (pOwnerLord->ButtonHit[idButton0])
  {
	 pOwnerLord->Button0->ExpertStart = 0;
	 pOwnerLord->AskHoldCards(true);
	 pOwnerLord->ButtonClear(idButton0);
	 IgnoreCoach = false;
	 return;
  }
  if (pOwnerLord->ButtonHit[idButton1])
  {
	 pOwnerLord->ButtonClear(idButton1);
	 return;
  }
  if (pOwnerLord->ButtonHit[idButton2])
  {
	 pOwnerLord->ButtonClear(idButton2);
	 return;
  }
  if (pOwnerLord->ButtonHit[idButton3])
  {
	 pOwnerLord->ButtonClear(idButton3);
	 return;
  }
  if (pOwnerLord->ButtonHit[idButton8])
  {
	 pOwnerLord->AskHoldCards(false);
	 if(pOwnerLord->GetCasPD(pOwnerLord->activeplayer)->CoachOn &&
       !pOwnerLord->CheckExpertCode() &&
       !IgnoreCoach)
	 {
		pOwnerLord->Button0->ShowExpert();
		IgnoreCoach = true;
	 }
	 else
	 {
		if(!pOwnerLord->CheckExpertCode())
		{
		  int16 session = pOwnerLord->GetCasPD(pOwnerLord->activeplayer)->VPData.CurrentSession;
		  pOwnerLord->GetCasPD(pOwnerLord->activeplayer)->VPData.Sessions[session].IncorrectPlays++;
		}
		pOwnerLord->FreezeAllButtons();
		ExecuteWaiting = false;
		ExecuteStatus = ess_StartSubState1;
		IgnoreCoach = false;
	 }
	 pOwnerLord->ButtonClear(idButton8);
	 return;
  }
}
//*******************************************************************
bool TVPAct2State::HandleHoldCard0(TResponder &responder)
{
  if(responder.GetResponseEvent() == reLDown)
  {
	 responder.SetPriority();
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_PRESSING_FINGER_CURSOR));
	 return true;
  }
  if ((responder.GetResponseEvent() == reLUp    ) ||
		(responder.GetResponseEvent() == reLDblClk) ||
		(responder.GetResponseEvent() == reChar   )   )
  {
	 if(responder.GetIsPriority())
	 {
		responder.ClearPriority();
	 }
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_POINTING_FINGER_CURSOR));
	 if(responder.Contains(responder.GetPoint()) ||
		 responder.GetResponseEvent() == reChar)
	 {
		pOwnerLord->HoldCard(0);
	 }
  }
  return true;
}
//*******************************************************************
bool TVPAct2State::HandleHoldCard1(TResponder &responder)
{
  if(responder.GetResponseEvent() == reLDown)
  {
	 responder.SetPriority();
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_PRESSING_FINGER_CURSOR));
	 return true;
  }
  if ((responder.GetResponseEvent() == reLUp    ) ||
		(responder.GetResponseEvent() == reLDblClk) ||
		(responder.GetResponseEvent() == reChar   )   )
  {
	 if(responder.GetIsPriority())
	 {
		responder.ClearPriority();
	 }
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_POINTING_FINGER_CURSOR));
	 if(responder.Contains(responder.GetPoint()) ||
		 responder.GetResponseEvent() == reChar)
	 {
		pOwnerLord->HoldCard(1);
	 }
  }
  return true;
}
//*******************************************************************
bool TVPAct2State::HandleHoldCard2(TResponder &responder)
{
  if(responder.GetResponseEvent() == reLDown)
  {
	 responder.SetPriority();
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_PRESSING_FINGER_CURSOR));
	 return true;
  }
  if ((responder.GetResponseEvent() == reLUp    ) ||
		(responder.GetResponseEvent() == reLDblClk) ||
		(responder.GetResponseEvent() == reChar   )   )
  {
	 if(responder.GetIsPriority())
	 {
		responder.ClearPriority();
	 }
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_POINTING_FINGER_CURSOR));
	 if(responder.Contains(responder.GetPoint()) ||
		 responder.GetResponseEvent() == reChar)
	 {
		pOwnerLord->HoldCard(2);
	 }
  }
  return true;
}
//*******************************************************************
bool TVPAct2State::HandleHoldCard3(TResponder &responder)
{
  if(responder.GetResponseEvent() == reLDown)
  {
	 responder.SetPriority();
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_PRESSING_FINGER_CURSOR));
	 return true;
  }
  if ((responder.GetResponseEvent() == reLUp    ) ||
		(responder.GetResponseEvent() == reLDblClk) ||
		(responder.GetResponseEvent() == reChar   )   )
  {
	 if(responder.GetIsPriority())
	 {
		responder.ClearPriority();
	 }
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_POINTING_FINGER_CURSOR));
	 if(responder.Contains(responder.GetPoint()) ||
		 responder.GetResponseEvent() == reChar)
	 {
		pOwnerLord->HoldCard(3);
	 }
  }
  return true;
}
//*******************************************************************
bool TVPAct2State::HandleHoldCard4(TResponder &responder)
{
  if(responder.GetResponseEvent() == reLDown)
  {
	 responder.SetPriority();
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_PRESSING_FINGER_CURSOR));
	 return true;
  }
  if ((responder.GetResponseEvent() == reLUp    ) ||
		(responder.GetResponseEvent() == reLDblClk) ||
		(responder.GetResponseEvent() == reChar   )   )
  {
	 if(responder.GetIsPriority())
	 {
		responder.ClearPriority();
	 }
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_POINTING_FINGER_CURSOR));
	 if(responder.Contains(responder.GetPoint()) ||
		 responder.GetResponseEvent() == reChar)
	 {
		pOwnerLord->HoldCard(4);
	 }
  }
  return true;
}
//*******************************************************************
bool TVPAct2State::HandleDealDraw(TResponder &responder)
{
  if (responder.GetResponseEvent() == reLUp)
  {
	 DealDrawResponder = &responder;
  }

  if (responder.GetResponseEvent() == reLDown)
  {
responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
	 DealDrawResponder = &responder;
  }
  return true;
}
//*******************************************************************
bool TVPAct2State::HandleMenuEsc(TResponder &responder)
{
	if (responder.GetResponseEvent() == reLUp)
  {
	 MenuEscResponder = &responder;
  }

  if (responder.GetResponseEvent() == reLDown)
  {
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
	 MenuEscResponder = &responder;
  }

  return true;
}
//*******************************************************************
bool TVPAct2State::HandleAskExpert(TResponder &responder)
{
	if (responder.GetResponseEvent() == reLUp)
  {
	 AskExpertResponder = &responder;
  }

  if (responder.GetResponseEvent() == reLDown)
  {
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
	 AskExpertResponder = &responder;
  }

  return true;
}
//*******************************************************************

