//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  vpcoutst.cpp
//    Project Name:  Casino
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     09/29/95   A. Krist    Original baseline
//  2.0     09/25/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "vpaskex.h"
//#include "cvpglord.h"
#include "accvpgld.h"
#include "casvpmw.h"
#include "ogamefw.h"
//*******************************************************************
//TVPAsk::TVPAsk(TCasinoVPGameLord *pNewVPLord)
TVPAsk::TVPAsk(TACCVPGLord *pNewVPLord)
{
  pOwnerLord = pNewVPLord;
  ExpertCode = 0;
}
//*******************************************************************
TVPAsk::~TVPAsk()
{
}
//*******************************************************************
void TVPAsk::HoldCards(bool show)
{
  switch (pOwnerLord->SubGameType)
  {
	case cvpTensOrBetter : AskHoldTens();break;
	case cvpJacksOrBetter : AskHoldJacks();break;
	case cvpJacksProgressive : AskHoldJacksProg();break;
	case cvpDeucesWild : AskHoldDeuces();break;
	case cvpJokersWild : AskHoldJoker();break;
  }
  if(show)
  {
//	 pOwnerLord->pMWin->GetFW()->DisplayExpert(expertRecomString);
    pOwnerLord->GetFW()->DisplayExpert(expertRecomString);
  }
  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand      = 0;
  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highcard      = 0;
  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->toflush       = 0;
  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrght      = 0;
  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrght     = 0;
  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh     = 0;
  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh    = 0;
  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->lohighcard    = 0;
  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->lolowcard     = 0;
  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->lohand        = 0;
  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->lowcard       = 0;
  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->wildcount     = 0;
  pOwnerLord->fake->highhand      = 0;
  pOwnerLord->fake->highcard      = 0;
  pOwnerLord->fake->toflush       = 0;
  pOwnerLord->fake->instrght      = 0;
  pOwnerLord->fake->outstrght     = 0;
  pOwnerLord->fake->instrflsh     = 0;
  pOwnerLord->fake->outstrflsh    = 0;
  pOwnerLord->fake->lohighcard    = 0;
  pOwnerLord->fake->lolowcard     = 0;
  pOwnerLord->fake->lohand        = 0;
  pOwnerLord->fake->lowcard       = 0;
  pOwnerLord->fake->wildcount     = 0;

}
//*******************************************************************
void TVPAsk::AskHoldTens()
{
  pOwnerLord->fake->inhand = 0;
  for(int16 i=0;i<5;i++)
  {
	 pOwnerLord->fake->cards[i].name = pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->cards[i].name;
	 pOwnerLord->fake->cards[i].suit = pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->cards[i].suit;
	 pOwnerLord->fake->inhand++;
  }
  pOwnerLord->pSmarts->Insert_Sort(pOwnerLord->fake);
  pOwnerLord->pSmarts->Holding(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand);
  pOwnerLord->pSmarts->Holding(pOwnerLord->fake);

	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 105)
	 {//royal
		expertRecomString = TAppString(5003);
		ExpertCode = 1;
      return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 99)
	 {
		if(pOwnerLord->fake->cards[4].name == AceHi)
		{
		  expertRecomString = TAppString(5003);
		  ExpertCode =1;
        return;
		}
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 99)
	 {//straight flush
		expertRecomString = TAppString(5006);
		ExpertCode = 1;
      return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 71)
	 {//four o' kind
		expertRecomString = TAppString(5077);
		ExpertCode = 20;
      return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 70)
	 {//full house
		expertRecomString = TAppString(5010);
		ExpertCode = 1;
      return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
		 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh > 3)
	 {// four to a royal
		if(pOwnerLord->fake->cards[0].name > Nine ||
			  (pOwnerLord->fake->cards[1].name > Nine &&
			  (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[2].suit) &&
           (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[3].suit) &&
           (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[4].suit)   ))
		{
		  expertRecomString = TAppString(5009);
		  ExpertCode = 3;
        return;
		}
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 26)
	 { //flush
		expertRecomString = TAppString(5016);
		ExpertCode = 1;
      return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 20)
	 {//three o' kind
		expertRecomString = TAppString(5018);
		ExpertCode = 5;
      return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 23 &&
		 (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 3) )
	 {//straight and four to a straight flush
		expertRecomString = TAppString(5081);
		ExpertCode = 1;
      return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 23)
	 {//straight
		expertRecomString = TAppString(5017);
		ExpertCode = 1;
      return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 3 )
	 {//four to a straight flush
		expertRecomString = TAppString(5019);
		ExpertCode = 4;
      return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 15)
	 {//two pair
		expertRecomString = TAppString(5050);
		ExpertCode = 15;
      return;
	 }
	 if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 10)&&
		  (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrght > 3 ||
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrght  > 3 ))
	 {//four to a straight and a pair
		expertRecomString = TAppString(5028);
		ExpertCode = 16;
      return;
	 }
	 if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 10)&&
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highcard > Nine)
	 {//high pair && 3 to royal
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2 ||
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2 )
		{//three to a royal
		  if((pOwnerLord->fake->cards[0].name > Nine &&
			((pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit &&
           pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit &&
          pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit &&
          pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit &&
          pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit &&
          pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit &&
          pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) )) ||
		  (pOwnerLord->fake->cards[1].name > Nine &&
			((pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[1].suit &&
         pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[1].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[1].suit &&
          pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[1].suit) ||
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[1].suit &&
          pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[1].suit) )) ||
		  (pOwnerLord->fake->cards[2].name > Nine &&
			(pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[2].suit &&
         pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[2].suit)))

		  {
			 expertRecomString = TAppString(5079);
			 ExpertCode = 21;return;
		  }
		}
	 }
	 if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 10)&&
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highcard > Nine)
	 {//high pair
		expertRecomString = TAppString(5083);
		ExpertCode = 21;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2 ||
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2 )
	 {//three to a royal
		if((pOwnerLord->fake->cards[0].name > Nine &&
			((pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit &&
         pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit &&
          pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit &&
          pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit &&
          pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit &&
          pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit &&
          pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) )) ||
		  (pOwnerLord->fake->cards[1].name > Nine &&
			((pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[1].suit &&
         pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[1].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[1].suit &&
          pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[1].suit) ||
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[1].suit &&
          pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[1].suit) )) ||
		  (pOwnerLord->fake->cards[2].name > Nine &&
			(pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[2].suit &&
         pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[2].suit)))

		{
		  expertRecomString = TAppString(5021);
		  ExpertCode = 6;return;
		}

	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->toflush > 3)
	 {//four to a flush
		expertRecomString = TAppString(5029);
		ExpertCode = 9;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 10)
	 {// pair(low)
		expertRecomString = TAppString(5028);
		ExpertCode = 16;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2 &&
		 pOwnerLord->fake->cards[4].name > Nine)
	 {//three to a straight flush with a ten
		expertRecomString = TAppString(5044);
		ExpertCode = 22;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrght > 3)
	 {//four to straight
		expertRecomString = TAppString(5045);
		ExpertCode = 10;return;
	 }
	 if(((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2) ||
		  (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2)) &&
			pOwnerLord->fake->cards[4].name > Nine)
	 {//three to a straight flush with high card
		expertRecomString = TAppString(5044);
		ExpertCode = 22;return;
	 }
	 if(((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 1) ||
		  (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 1)) &&
		  ( (pOwnerLord->fake->cards[2].name > Nine &&
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[2].suit ||
			  pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[2].suit)) ||
			 (pOwnerLord->fake->cards[3].name > Nine &&
			 (pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[3].suit)) ))
	 {//two to a royal
		expertRecomString = TAppString(5031);
		ExpertCode = 18;return;
	 }
	 if(pOwnerLord->fake->cards[3].name > Nine  &&
		 pOwnerLord->fake->cards[4].name > Nine)
	 {//two high cards
		expertRecomString = TAppString(5084);
		ExpertCode = 25;return;
	 }
	 if(pOwnerLord->fake->cards[4].name > Nine)
	 {//high card
		expertRecomString = TAppString(5086);
		ExpertCode = 26;return;
	 }
	 if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2) ||
		 (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2)   )
	 {//three to a straight flush
		expertRecomString = TAppString(5044);
		ExpertCode = 22;return;
	 }
	 else
	 {
		expertRecomString = TAppString(5032);    //garbage
		ExpertCode = 13;return;
	 }
}
//*******************************************************************
void TVPAsk::AskHoldJoker()
{
  pOwnerLord->GetNumOfWildCards();
  pOwnerLord->WildJoker(TRUE);


  if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->wildcount)
  {
		switch(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand){
		  case 105 : expertRecomString = TAppString(5001);
						 ExpertCode = 1;return;
		  case 100 : expertRecomString = TAppString(5004);
						 ExpertCode = 1;return;
		  case  99 : expertRecomString = TAppString(5006);
						 ExpertCode = 1;return;
		  case  71 : expertRecomString = TAppString(5007);
						 ExpertCode = 402;return;
		  case  70 : expertRecomString = TAppString(5010);
						 ExpertCode = 1;return;
		}
		if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
			 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh > 3) &&
			 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 26 )
		{ // four to a royal flush and a flush
        if(pOwnerLord->fake->cards[0].name > Nine ||
			  (pOwnerLord->fake->cards[1].name > Nine &&
           (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[2].suit) &&
           (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[3].suit) &&
           (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[4].suit)   ))
		  {
			 expertRecomString = TAppString(5033);
			 ExpertCode = 1;return;
		  }
		}
		if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
			 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh > 3) &&
			 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 26 )
		{ // four to a straight flush and a flush
		  expertRecomString = TAppString(5034);
		  ExpertCode = 1;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 26)
		{ //flush
		  expertRecomString = TAppString(5016);
		  ExpertCode = 1;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
			 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh > 3)
		{ // four to a royal flush
        if(pOwnerLord->fake->cards[0].name > Nine ||
			  (pOwnerLord->fake->cards[1].name > Nine &&
           (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[2].suit) &&
           (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[3].suit) &&
           (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[4].suit)   ))
		  {
			 expertRecomString = TAppString(5009);
			 ExpertCode = 103;return;
		  }
		}
		if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
			 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh > 3) &&
			 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 23)
		{ // straight and four to a straight flush
		  if(pOwnerLord->fake->cards[1].name > Nine ||
			  (pOwnerLord->fake->cards[2].name > Nine &&
				(pOwnerLord->fake->cards[2].name < pOwnerLord->fake->cards[3].name &&
				 pOwnerLord->fake->cards[3].name < pOwnerLord->fake->cards[4].name) &&
				 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[3].suit &&
				  pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[4].suit)))
		  {
			 expertRecomString = TAppString(5035);
			 ExpertCode = 4;return;
		  }
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 &&
			pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 3)
		{//four to a straight flush
		  expertRecomString = TAppString(5019);
		  ExpertCode = 4;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 23)
		{//straight
		  expertRecomString = TAppString(5017);
		  ExpertCode = 1;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 20)
		{// three o' kind
		  expertRecomString = TAppString(5018);
		  ExpertCode = 5;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2 ||
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2 )
		{// three to a royal
		  if((pOwnerLord->fake->cards[0].name > Nine &&
			 ((pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit /*&& pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit*/) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit /*&& pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit*/) ||
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit /*&& pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit*/) )) ||
			 (pOwnerLord->fake->cards[1].name > Nine &&
			 ((pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[1].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[1].suit /*&& pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[1].suit*/) ||
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[1].suit /*&& pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[1].suit*/) )) ||
			 (pOwnerLord->fake->cards[2].name > Nine &&
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[2].suit /*&& pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[2].suit*/)))

		  {
			 expertRecomString = TAppString(5021);
			 ExpertCode = 6;return;
		  }

		}
		if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2 ||
			 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2) &&
			 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrght  > 3)
		{//four card straight(outside) and three to a straight flush
		  expertRecomString = TAppString(5036);
		  ExpertCode = 7;return;
		}
		if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrght  > 3) &&
			 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->toflush  > 3)
		{//four card straight(outside) and four to a flush
		  expertRecomString = TAppString(5037);
		  ExpertCode = 7;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrght  > 3)
		{//four card straight(outside)
		  expertRecomString = TAppString(5030);
		  ExpertCode = 7;return;
		}
	  //	if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2 ||
	  //		 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2) &&
	  //		 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrght  > 3)
	 //	{//four card straight(inside) and three to a straight flush
	 //	  expertRecomString = TAppString(5038);
	//	  return;
  //		}
  //		if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrght > 3) &&
  //			 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->toflush  > 3)
  //		{//four card straight(inside) and four to a flush
  //		  expertRecomString = TAppString(5039);
	//	  return;
		//}
		if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh  > 2) &&
			 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->toflush > 3)
		{//three to straight flush(outside) and four to a flush
		  expertRecomString = TAppString(5040);
		  ExpertCode = 88;return;
		}
		if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2) &&
			 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->toflush > 3)
		{//three to straight flush(inside) and four to a flush
		  expertRecomString = TAppString(5041);
		  ExpertCode = 9;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh  > 2)
		{//three to straight flush(outside)
		  expertRecomString = TAppString(5042);
		  ExpertCode = 88;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->toflush  > 3)
		{//four to flush
		  expertRecomString = TAppString(5043);
		  ExpertCode = 9;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2)
		{//three to straight flush(inside)
		  expertRecomString = TAppString(5042);
		  ExpertCode = 22;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrght  > 3)
		{//four to straight
		  expertRecomString = TAppString(5045);
		  ExpertCode = 10;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrght  > 2)
		{//three to straight
		  expertRecomString = TAppString(5047);
		  ExpertCode = 11;return;
		}
		expertRecomString = TAppString(5046);
		ExpertCode = 12;return;

  }
  else // no wild cards
  {
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 105)
	 {//royal
		expertRecomString = TAppString(5024);
		ExpertCode = 1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 99)
	 {
		if(pOwnerLord->fake->cards[4].name == AceHi)
		{
		  expertRecomString = TAppString(5003);
		  ExpertCode =1;return;
		}
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 99)
	 {//straight flush
		expertRecomString = TAppString(5006);
		ExpertCode = 1;return;
	 }
	 if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh > 3) &&
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 26)
	 {//four to a royal and a flush
      if(pOwnerLord->fake->cards[0].name > Nine ||
			  (pOwnerLord->fake->cards[1].name > Nine &&
           (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[2].suit) &&
           (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[3].suit) &&
           (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[4].suit)   ))
		{
		  expertRecomString = TAppString(5048);
		  ExpertCode = 3;return;
		}
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
		 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh > 3)
	 {// four to a royal
      if(pOwnerLord->fake->cards[0].name > Nine ||
			  (pOwnerLord->fake->cards[1].name > Nine &&
           (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[2].suit) &&
           (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[3].suit) &&
           (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[4].suit)   ))
		{
		  expertRecomString = TAppString(5009);
		  ExpertCode = 3;return;
		}
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 71)
	 {//four o' kind
		expertRecomString = TAppString(5007);
		ExpertCode = 2;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 70)
	 {//full house
		expertRecomString = TAppString(5010);
		ExpertCode = 1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 26)
	 { //flush
		expertRecomString = TAppString(5016);
		ExpertCode = 1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 23 &&
		 (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 3) )
	 {//straight and four to a straight flush
		expertRecomString = TAppString(5049);
		ExpertCode = 1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 23)
	 {//straight
		expertRecomString = TAppString(5017);
		ExpertCode = 1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3)
	 {//four to a straight flush
		expertRecomString = TAppString(5019);
		ExpertCode = 4;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 20)
	 {//three o' kind
		expertRecomString = TAppString(5018);
		ExpertCode = 5;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 3)
	 {//four to a inside straight flush
		expertRecomString = TAppString(5019);
		ExpertCode = 4;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 15)
	 {//two pair
		expertRecomString = TAppString(5050);
		ExpertCode = 15;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2 ||
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2 )
	 {//three to a royal
		if((pOwnerLord->fake->cards[0].name > Nine &&
			((pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) )) ||
		  (pOwnerLord->fake->cards[1].name > Nine &&
			((pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[1].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[1].suit) ||
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[1].suit) )) ||
		  (pOwnerLord->fake->cards[2].name > Nine &&
			(pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[2].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[2].suit)))

		{
		  expertRecomString = TAppString(5021);
		  ExpertCode = 6;return;
		}

	 }
	 if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->toflush > 3)&&
		  (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2 ||
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2 ))
	 {//four to a flush and three to a straight flush
		expertRecomString = TAppString(5051);
		ExpertCode = 9;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->toflush > 3)
	 {//four to a flush
		expertRecomString = TAppString(5029);
		ExpertCode = 9;return;
	 }
	 if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrght > 3)&&
		  (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2 ||
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2 ))
	 {//four to a straight(outside) and three to a straight flush
		expertRecomString = TAppString(5052);
		ExpertCode = 7;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrght > 3)
	 {//four to straight(outside)
		expertRecomString = TAppString(5045);
		ExpertCode = 7;return;
	 }
	 if(((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2) ||
		  (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2)) &&
			pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrght > 3)
	 {//four to a straight(inside) and three to a straight flush
		expertRecomString = TAppString(5053);
		ExpertCode = 22;return;
	 }
	 if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2) ||
		 (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2))
	 {//three to a straight flush
		expertRecomString = TAppString(5044);
		ExpertCode = 22;return;
	 }
	 if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 10) ||
		 (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 15))
	 {//any pair
		expertRecomString = TAppString(5028);
		ExpertCode = 16;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrght > 3)
	 { //four to a straight(inside)
		expertRecomString = TAppString(5045);
		ExpertCode = 38;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->toflush > 2)
	 { //three to a flush
		expertRecomString = TAppString(5054);
		ExpertCode = 17;return;
	 }
	 if(((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 1) ||
		  (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 1)) &&
		  ( (pOwnerLord->fake->cards[2].name > Nine &&
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[2].suit ||
			  pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[2].suit)) ||
			 (pOwnerLord->fake->cards[3].name > Nine &&
			 (pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[3].suit)) ))
	 {//two to a royal
		expertRecomString = TAppString(5031);
		ExpertCode = 18;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrght > 2)
	 {//three to a straight
		expertRecomString = TAppString(5047);
		ExpertCode = 11;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 1)
	 {//two to a straight flush
		expertRecomString = TAppString(5055);
		ExpertCode = 19;return;
	 }
	 expertRecomString = TAppString(5032);    //garbage
	 ExpertCode = 13;return;
  }
}
//*******************************************************************

