//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  vpcoutst.cpp
//    Project Name:  Casino
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     09/29/95   A. Krist    Original baseline
//  2.0     09/25/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "vpcoutst.h"
#include "cvpplay.h"
#include "casvpmw.h"
#include "orespond.h"
#include "owav.h"
#include "oanm.h"
//*******************************************************************
//TVPCashOutState::TVPCashOutState(TCasinoVPGameLord *pNewVPLord)
TVPCashOutState::TVPCashOutState(TACCVPGLord *pNewVPLord)
:TVPLordState(pNewVPLord)
{
  SpeedClickResponder = NULL;
  Count = 0;
  Start16 = false;
}
//*******************************************************************
TVPCashOutState::~TVPCashOutState()
{
}
//*******************************************************************
void TVPCashOutState::ExecuteFirstTime()
{
  ExecuteWaiting = true;
  ExecuteStatus    = ess_Execute;
  pOwnerLord->CashOut();
  if(pOwnerLord->credits > 0)
  {
	 switch((int32)pOwnerLord->credits)
	 {
		case 1  : pOwnerLord->VPSounds->PlaySound(11);break;
		case 2  : pOwnerLord->VPSounds->PlaySound(12);break;
		case 3  : pOwnerLord->VPSounds->PlaySound(13);break;
		case 4  : pOwnerLord->VPSounds->PlaySound(14);break;
		case 5  : pOwnerLord->VPSounds->PlaySound(15);break;
		default : pOwnerLord->VPSounds->PlaySound(16);Start16 = true;break;
	 }
  }
}
//*******************************************************************
void TVPCashOutState::HandlePostUpdate(dword NewFUC)
{
  if (SpeedClickResponder != NULL && ExecuteWaiting)
  {
	 if (SpeedClickResponder->GetResponseEvent() != reChar)
	 {
		SpeedClickResponder->ClearPriority();
	 }
	 if (pOwnerLord->credits > 0)
	 {
		pOwnerLord->CoinPay->SetTray(pOwnerLord->credits - 1 + Count);
		pOwnerLord->AddCash(pOwnerLord->activeplayer,pOwnerLord->coinsize*pOwnerLord->credits);
		pOwnerLord->credits = 0;
		pOwnerLord->Chips->SetNum(pOwnerLord->GetCash(pOwnerLord->activeplayer));
		pOwnerLord->Credits->SetNum(pOwnerLord->credits);
	  	pOwnerLord->VPSounds->Sounds[11]->Stop();
		pOwnerLord->VPSounds->Sounds[12]->Stop();
		pOwnerLord->VPSounds->Sounds[13]->Stop();
		pOwnerLord->VPSounds->Sounds[14]->Stop();
		pOwnerLord->VPSounds->Sounds[15]->Stop();
		pOwnerLord->VPSounds->Sounds[16]->Stop();
	 }
	 SpeedClickResponder = NULL;
	 ExecuteWaiting = false;
	 pOwnerLord->VPSounds->PlaySound(36);
	 return;
  }

  if (pOwnerLord->credits > 0 && ExecuteWaiting)
  {
	 Count++;
	 pOwnerLord->CoinPay->SetTray(int16(Count-1));
	 if(pOwnerLord->VPSounds->Sounds[16]->GetStopped() && Start16)
	 {
		pOwnerLord->VPSounds->PlaySound(16);
	 }
	 if(pOwnerLord->CoinPay->PCoinPay->CAD.GetCurrentFrame() == 98 && Start16)
	 {
		pOwnerLord->VPSounds->Sounds[16]->Stop();
		Start16 = false;
	 }
	 pOwnerLord->credits--;
	 pOwnerLord->AddCash(pOwnerLord->activeplayer,pOwnerLord->coinsize);
	 pOwnerLord->Credits->SetNum(pOwnerLord->credits);
  }
  else if(ExecuteWaiting)
  {
	 pOwnerLord->VPSounds->Sounds[11]->Stop();
	 pOwnerLord->VPSounds->Sounds[12]->Stop();
	 pOwnerLord->VPSounds->Sounds[13]->Stop();
	 pOwnerLord->VPSounds->Sounds[14]->Stop();
	 pOwnerLord->VPSounds->Sounds[15]->Stop();
	 pOwnerLord->VPSounds->Sounds[16]->Stop();
	 ExecuteWaiting = false;
	 pOwnerLord->VPSounds->PlaySound(36);
  }
  if(NewFUC){return;}
}
//*******************************************************************
bool TVPCashOutState::HandleSpeedClick(TResponder &responder)
{
  if (responder.GetResponseEvent() == reRUp)
  {
	 SpeedClickResponder = &responder;
  }

  if (responder.GetResponseEvent() == reRDown)
  {
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
	 SpeedClickResponder = &responder;
  }
  return true;
}
//*******************************************************************

