//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  vpdeck.cpp
//    Project Name:  Ogle
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     06/01/95   A. Krist    Original baseline
//  2.0     09/25/97   M.Perry     32-bit conversion.
//  2.3    07/14/99    M.Perry    retrofit to Ogle
//*******************************************************************
#include "vpdeck.h"
#include <stdlib.h>
#include "cvpglord.h"
#include "cvpplay.h"
#include "casvpmw.h"

#if defined(DEBUGCARD)
  #include "owl\inputdia.h"
#endif

//#define  NUMBEROFPLAYERS 3
//#define  HUMAN 3
//*******************************************************************
TVPDeck::TVPDeck(TVideoPokerModeWin *pMWin)
{
  pmwin = pMWin;
  deck = new TCard[53];  //Joker deck
  top  = 0;
}
//*******************************************************************
TVPDeck::~TVPDeck()
{
  delete []deck;
  deck = NULL;
  top  = 0;
  pmwin = NULL;
}
//*******************************************************************
int16 TVPDeck::RemoveJoker()
{
  for(int16 i=0; i < 53; i++)
  {
	 if(deck[i].name == Joker)
	 {
		Swap(i,52);
	 }
  }
  return 1;
}
//*******************************************************************
int16 TVPDeck::JokerShuffle()
{
  int16 count,x,y;
  count = 1000;

  for(int16 i=0; i < count; i++)
  {
	 x = int16(random(53));
	 y = int16(random(53));
	 Swap(x,y);
  }
  return 1;
}
//*******************************************************************
int16 TVPDeck::InitVPDeck()
{
  for(int16 i=0; i < 4 ;i++)
  {
	 for(int16 j=0; j < 13 ;j++)
	 {
		deck[(i*13)+j].name = (TCardName)(j+1);
		deck[(i*13)+j].suit = (TSuit)i;
	 }
  }
  deck[52].name = Joker;
  deck[52].suit = (TSuit)3;
  return 1;
}
//*******************************************************************
int16 TVPDeck::GetActPlayer()
{
//  return (((TCasinoVPGameLord *)(pmwin->pLord))->activeplayer);
  return pmwin->GetCasGameLord()->GetActivePlayer();
}
//*******************************************************************
int16 TVPDeck::FirstDeal()
{
  top = 0;
//  if (((TCasinoVPGameLord *)pmwin->pLord)->SubGameType == cvpJokersWild)
  if (pmwin->GetCasGameLord()->SubGameType == cvpJokersWild)
  {
	 JokerShuffle();
  }
  else
  {
	 Shuffle();
  }
  #ifdef DEBUGCARD
  for(int16 i=0;i<5;i++)
  {
		pmwin->SetUpdatePause();
		char cardnum[5] = "";
		TInputDialog getcard(pmwin,"","card number",cardnum,5);
		getcard.Execute();
		char cardtype[5] = "";
		TInputDialog getcardtype(pmwin,"","card type",cardtype,5);
		getcardtype.Execute();
		pmwin->ClearUpdatePause();
		/*((TCasinoPlayer *)*/pmwin->GetCasPlayer(GetActPlayer())->pHand->cards[i].suit = atoi(cardtype);
		/*((TCasinoPlayer *)*/pmwin->GetCasPlayer(GetActPlayer())->pHand->cards[i].name = atoi(cardnum)%15;
		/*((TCasinoPlayer *)*/pmwin->GetCasPlayer(GetActPlayer())->pHand->cards[i].updown = Up;
		/*((TCasinoPlayer *)*/pmwin->GetCasPlayer(GetActPlayer())->pHand->inhand++;
  }
  #else
  for(int16 j=0;j<5;j++)
  {
//	 ((TCasinoPlayer *)pmwin->GObj[GetActPlayer()])->pHand->cards[j] = deck[top++];
    pmwin->GetCasPlayer(GetActPlayer())->pHand->cards[j] = deck[top++];
//	 ((TCasinoPlayer *)pmwin->GObj[GetActPlayer()])->pHand->cards[j].updown = Up;
    pmwin->GetCasPlayer(GetActPlayer())->pHand->cards[j].updown = Up;
//	 ((TCasinoPlayer *)pmwin->GObj[GetActPlayer()])->pHand->inhand++;
    pmwin->GetCasPlayer(GetActPlayer())->pHand->inhand++;
  }
  #endif
  return 1;
}
//*******************************************************************
int16 TVPDeck::ShowWinner(THand * h)
{
  for(int16 i=0; i < h->inhand ;i++)
  {
	 ShowCard(&h->cards[i]);
  }
  return 1;
}
//*******************************************************************
int16 TVPDeck::Draw(THand * h)
{
  #ifdef DEBUGCARD
  for(int16 i=0; i < h->inhand ;i++)
  {
	 if(h->hold[i] == 0)
	 {
		pmwin->SetUpdatePause();
		char cardnum[5] = "";
		TInputDialog getcard(pmwin,"","card number",cardnum,5);
		getcard.Execute();
		pmwin->ClearUpdatePause();
		h->cards[i].suit = atoi(cardnum)/14;
		h->cards[i].name = atoi(cardnum)%14;
	 }
  }
  #else
  for(int16 i=0; i < h->inhand ;i++)
  {
	 if(h->hold[i] == 0)
	 {
		h->cards[i] = deck[top++];
		h->cards[i].updown = Up;
	 }
  }
  #endif
  return 1;
}
//*******************************************************************
