//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  vpdrawst.cpp
//    Project Name:  Casino
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     09/29/95   A. Krist    Original baseline
//  2.0     09/25/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "vpdrawst.h"
//#include "cvpglord.h"
#include "otimers.h"
#include "cvpplay.h"
#include "casvpmw.h"
#include "hand.h"
//*******************************************************************
//TVPDrawState::TVPDrawState(TCasinoVPGameLord *pNewVPLord)
TVPDrawState::TVPDrawState(TACCVPGLord *pNewVPLord)
:TVPLordState(pNewVPLord)
{
}
//*******************************************************************
TVPDrawState::~TVPDrawState()
{
}
//*******************************************************************
void TVPDrawState::ExecuteFirstTime()
{
  ExecuteWaiting = true;
  ExecuteStatus    = ess_Execute;
  pOwnerLord->pDeck->Draw(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand);
  for (int16 i=0;i<5;i++)
  {
    if (!pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->hold[i])
    {
      pOwnerLord->CardSprites[i]->ShowFlip();
    }
  }
  StartingFUC = pOwnerLord->GetAdjFUC();
  NextCardNum = 0;
  NextFUC = 2;
  Flipping = true;
}
//*******************************************************************
void TVPDrawState::HandlePostUpdate(dword NewFUC)
{
  if ((StartingFUC + 1) == NewFUC)
  {
    for (int16 i=0;i<5;i++)
    {
      if (!pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->hold[i])
      {
        pOwnerLord->CardSprites[i]->ShowBack();
      }
    }
  }
  else if ((StartingFUC + NextFUC) == NewFUC)
  {
    if (Flipping)
    {
      int16 i;
      for (i = NextCardNum;i<5;i++)
      {
        if (!pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->hold[i])
        {
          NextCardNum = i;
			 pOwnerLord->CardSprites[i]->ShowFlip();
			 pOwnerLord->VPSounds->PlaySound(int16(31+i));
          NextFUC += 1;
          Flipping = false;
          break;
        }
      }
      if (i >= 5)
      {
        ExecuteWaiting = false;
      }
    }
    else
    {
      pOwnerLord->CardSprites[NextCardNum]->ShowFace(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->cards[NextCardNum].suit,
         pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->cards[NextCardNum].name);
      NextCardNum++;
      NextFUC += 2;
      Flipping = true;
    }
  }
}
//*******************************************************************

