
//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  acvpa1st.cpp   // FLop deal
//    Project Name:  Casino
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     06/29/95   A. Krist    Original baseline
//  2.0     09/25/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "acvpa1st.h"
#include "acvpglrd.h"
#include "acvpdlst.h"
#include "acvpcost.h"
#include "cvpplay.h"
#include "casvpmw.h"
#include "hand.h"
#include "orespond.h"
//*******************************************************************
TACVPAct1State::TACVPAct1State(TACVPVPGLord *pNewVPLord)
:TVPLordState(pNewVPLord)
{
	 SetRunOrder(ess_Execute,ess_Done,ess_Execute,ess_Done);
	 Bet1Responder = NULL;
	 BetMaxResponder = NULL;
	 DealDrawResponder = NULL;
	 CashOutResponder = NULL;
	 AskExpertResponder = NULL;
	 MenuEscResponder = NULL;

	 AddCoinResponder            = NULL;


	 WaitingOnWRCounter = 0;
	 pOwnerLord->winnerpaid = 0;
	 pOwnerLord->coinsplayed = 0;
    pOwnerLord->Dcoinsplayed = 0;
	 askexpertflag = false;
	 WaitOnTray = false;
	 DelayFUC = 0;
	 IgnoreCoach = false;
}
//*******************************************************************
TACVPAct1State::~TACVPAct1State()
{
  pOwnerLord->Button6->Freeze = true;
}
//*******************************************************************
void TACVPAct1State::ExecuteFirstTime()
{
  pOwnerLord->Clear();
  pOwnerLord->Button6->Freeze = false;
  ExecuteWaiting = true;
  ExecuteStatus    = ess_Execute;
  for(int16 i=1;i<6;i++)
  {
	 pOwnerLord->Responders[i]->Remove();
  }
  pOwnerLord->Responders[0]->Add();
  pOwnerLord->Responders[13]->Add();
  
  for(int16 i=6;i<12;i++)
  {
	 pOwnerLord->Responders[i]->Add();
  }
  if(pOwnerLord->SubGameType == cvpFlushAssault && !pOwnerLord->FlushAssaultOn)
  {
    pOwnerLord->currentNumPlays++;
    if(pOwnerLord->currentNumPlays >= pOwnerLord->numPlays)
    {
      pOwnerLord->ShowFlushAssault();
    }
    if(pOwnerLord->FlushSwitch)
    {
      if(pOwnerLord->FlushAssaultOn)
      {pOwnerLord->BackG->Show();}
      else
      {pOwnerLord->BackG->NoShow();}

      pOwnerLord->DullWRatio->NoShow();
      pOwnerLord->FAss->NoShow();
      pOwnerLord->WinRatio->SetColumn(0);
      pOwnerLord->FlushSwitch = false;
    }
  }
}
//*******************************************************************
void TACVPAct1State::CreateSubState1()
{
  pOwnerLord->ChangeActivePlayersOk = false;
  PActiveSubState = new TACVPDealState(pOwnerLord);
}
//*******************************************************************
void TACVPAct1State::CreateSubState2()
{
  PActiveSubState = new TACVPCashOutState(pOwnerLord);
}
//*******************************************************************
void TACVPAct1State::EndSubState2()
{
  TState::EndSubState2();
  ExecuteWaiting = true;
  pOwnerLord->Button0->ShowGray();
  pOwnerLord->UnFreezeAllButtons();
  DelayFUC = pOwnerLord->GetAdjFUC();
  WaitOnTray = true;
}
//*******************************************************************
void TACVPAct1State::HandlePostUpdate(dword NewFUC)
{
  if(WaitOnTray)
  {
	 if(DelayFUC + 6 <= NewFUC)
	 {
      pOwnerLord->BankCashDisplay->SetNum(pOwnerLord->GetCash(pOwnerLord->activeplayer));
	  //???	pOwnerLord->Chips->SetNum(pOwnerLord->GetCash(pOwnerLord->activeplayer));
      pOwnerLord->CoinPay->ClearTray();
		WaitOnTray = false;
	 }
	 else{return;}
  }
  if (pOwnerLord->ButtonHit[idButton0])
  {
    pOwnerLord->ButtonClear(idButton0);
    pOwnerLord->FreezeAllButtons();
	 ExecuteWaiting = false;
	 ExecuteStatus = ess_StartSubState2;

	 return;
  }
  if (pOwnerLord->ButtonHit[idButton1])
  {
	 pOwnerLord->ButtonClear(idButton1);
    if(pOwnerLord->SubGameType == cvpTriplePlay)
    {pOwnerLord->BetTP1();}
    else
    {pOwnerLord->Bet1();}
	 if (pOwnerLord->coinsplayed == pOwnerLord->maxbet)
	 {
		ExecuteWaiting = false;
		pOwnerLord->FreezeAllButtons();
		pOwnerLord->shutdownstate = 1;
		ExecuteStatus = ess_StartSubState1;
	 }
	 return;
  }
  if (pOwnerLord->ButtonHit[idButton2])
  {
	 pOwnerLord->ButtonClear(idButton2);
	 if(pOwnerLord->SubGameType == cvpTriplePlay)
    {WaitingOnWRCounter = pOwnerLord->BetTPMax();}
    else
    {WaitingOnWRCounter = pOwnerLord->BetMax();}
	 pOwnerLord->shutdownstate = 1;
	 if (!WaitingOnWRCounter && pOwnerLord->coinsplayed > 0)
	 {
		pOwnerLord->FreezeAllButtons();
		ExecuteWaiting = false;
		ExecuteStatus = ess_StartSubState1;
	 }
	 return;
  }
  if (pOwnerLord->ButtonHit[idButton3])
  {
	 pOwnerLord->ButtonClear(idButton3);
	 if(pOwnerLord->GetCasPD(pOwnerLord->activeplayer)->CoachOn &&
		 pOwnerLord->coinsplayed < 5 && pOwnerLord->coinsplayed > 0 && !IgnoreCoach)
	 {
		pOwnerLord->Button7->ShowExpert();
		IgnoreCoach = true;
	 }
	 else
	 {
		pOwnerLord->FreezeAllButtons();
		ExecuteWaiting = false;
		ExecuteStatus = ess_StartSubState1;
		pOwnerLord->shutdownstate = 1;
		IgnoreCoach = false;
	 }
	 return;
  }
  if (pOwnerLord->ButtonHit[idButton4])
  {
	 pOwnerLord->ButtonClear(idButton4);
	 return;
  }
  if (pOwnerLord->ButtonHit[idButton5])
  {
	 pOwnerLord->ButtonClear(idButton5);
	 return;
  }
  if (pOwnerLord->ButtonHit[idButton6])
  {
    pOwnerLord->ButtonClear(idButton6);
    pOwnerLord->AddCredits(50);
  }
  if (pOwnerLord->ButtonHit[idButton7])
  {
	 pOwnerLord->ButtonClear(idButton7);
	 if(pOwnerLord->Button7->ExpertStart > 0)
	 {
		pOwnerLord->AskMoneyExpert();
		pOwnerLord->Button7->ExpertStart = 0;
	 }
	 else
	 {
		pOwnerLord->AskGenExpert();
	 }
	 IgnoreCoach = false;
	 return;
  }
  if (WaitingOnWRCounter)
  {
	 pOwnerLord->FreezeAllButtons();
	 pOwnerLord->WinRatio->SetColumn(pOwnerLord->coinsplayed-WaitingOnWRCounter+1);
	 WaitingOnWRCounter--;
	 if (!WaitingOnWRCounter)
	 {
		ExecuteWaiting = false;
		ExecuteStatus = ess_StartSubState1;
	 }
  }
  if(DealDrawResponder != NULL)
  {
	 DealDrawResponder = NULL;

	 if (pOwnerLord->coinsplayed != 0)
	 {
		ExecuteWaiting = false;
		ExecuteStatus = ess_StartSubState1;
	 }
	 return;
  }
  if(MenuEscResponder != NULL)
  {
	 if (MenuEscResponder->GetResponseEvent() != reChar)
	 {
		MenuEscResponder->ClearPriority();
	 }
	 MenuEscResponder = NULL;

	 return;
  }
  if(AskExpertResponder != NULL)
  {
	 if(!askexpertflag)
	 {
		if (AskExpertResponder->GetResponseEvent() != reChar)
		{
		  AskExpertResponder->ClearPriority();
		}
		askexpertflag = true;
	 }
	 else
	 {
		AskExpertResponder = NULL;
		askexpertflag = false;
		pOwnerLord->AskMoneyExpert();
	 }
	 return;
  }
  if(NewFUC){return;}
}
//*******************************************************************
bool TACVPAct1State::HandleNamePlate(TResponder &responder)
{
  if(responder.GetResponseEvent() == reLDown)
  {
	 responder.SetPriority();
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_PRESSING_FINGER_CURSOR));
	 return true;
  }
  if ((responder.GetResponseEvent() == reLUp    ) ||
		(responder.GetResponseEvent() == reLDblClk) ||
		(responder.GetResponseEvent() == reChar   )   )
  {
	 if(responder.GetIsPriority())
	 {
		responder.ClearPriority();
	 }
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_POINTING_FINGER_CURSOR));
	 if(responder.Contains(responder.GetPoint()) ||
		 responder.GetResponseEvent() == reChar     )
	 {
		if(pOwnerLord->GetNumActivePlayers() > 1)
		{
		  pOwnerLord->CyclePlayers();
		}
	 }
  }
  return true;
}
//*******************************************************************
bool TACVPAct1State::HandleAddCoin(TResponder &responder)
{
  if(responder.GetResponseEvent() == reLDown)
  {
	 responder.SetPriority();
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_PRESSING_FINGER_CURSOR));
	 return true;
  }
  if ((responder.GetResponseEvent() == reLUp    ) ||
		(responder.GetResponseEvent() == reLDblClk) ||
		(responder.GetResponseEvent() == reChar   )   )
  {
	 if(responder.GetIsPriority())
	 {
		responder.ClearPriority();
	 }
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_POINTING_FINGER_CURSOR));
	 if(responder.Contains(responder.GetPoint()) ||
		 responder.GetResponseEvent() == reChar     )
	 {
		pOwnerLord->BetX(pOwnerLord->coinsize);
		if(pOwnerLord->coinsplayed == 5)
		{
		  pOwnerLord->FreezeAllButtons();
		  ExecuteWaiting = false;
		  ExecuteStatus = ess_StartSubState1;
		}
	 }
  }
  return true;
}
//*******************************************************************
bool TACVPAct1State::HandleBet1(TResponder &responder)
{
  if (responder.GetResponseEvent() == reLUp)
  {
    Bet1Responder = &responder;
    if ((pOwnerLord->coinsplayed == 0) &&
		  ((pOwnerLord->credits != 0) || (pOwnerLord->GetCash(pOwnerLord->activeplayer) != 0)))
    {
      pOwnerLord->WinRatio->ClearColumn();
    }
  }

  if (responder.GetResponseEvent() == reLDown)
  {
	responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
	 Bet1Responder = &responder;
    if ((pOwnerLord->coinsplayed == 0) &&
		  ((pOwnerLord->credits != 0) || (pOwnerLord->GetCash(pOwnerLord->activeplayer) != 0)))
    {
      pOwnerLord->WinRatio->ClearColumn();
    }
  }

  return true;
}
//*******************************************************************
bool TACVPAct1State::HandleBetMax(TResponder &responder)
{
  if (responder.GetResponseEvent() == reLUp)
  {
    BetMaxResponder = &responder;
    if ((pOwnerLord->coinsplayed == 0) &&
		  ((pOwnerLord->credits != 0) || (pOwnerLord->GetCash(pOwnerLord->activeplayer) != 0)))
    {
      pOwnerLord->WinRatio->ClearColumn();
    }
  }

  if (responder.GetResponseEvent() == reLDown)
  {
	 responder.SetPriority();
//	 pOwnerLord->POwnerWindow->ActivateSpriteNow(2,0);
    pOwnerLord->PModeWin->ActivateSpriteNow(2,0);
  }

  if (responder.GetResponseEvent() == reChar)
  {
	 BetMaxResponder = &responder;
	 if ((pOwnerLord->coinsplayed == 0) &&
		  ((pOwnerLord->credits != 0) || (pOwnerLord->GetCash(pOwnerLord->activeplayer) != 0)))
	 {
		pOwnerLord->WinRatio->ClearColumn();
	 }
  }
  return true;
}
//*******************************************************************
bool TACVPAct1State::HandleDealDraw(TResponder &responder)
{
  if (pOwnerLord->coinsplayed != 0)
  {
	 if (responder.GetResponseEvent() == reLUp)
	 {
		DealDrawResponder = &responder;
	 }

	 if (responder.GetResponseEvent() == reLDown)
	 {
		responder.SetPriority();
	 }

	 if (responder.GetResponseEvent() == reChar)
	 {
		DealDrawResponder = &responder;
	 }
  }
  return true;
}
//*******************************************************************
bool TACVPAct1State::HandleMenuEsc(TResponder &responder)
{
	if (responder.GetResponseEvent() == reLUp)
  {
	 MenuEscResponder = &responder;
  }

  if (responder.GetResponseEvent() == reLDown)
  {
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
	 MenuEscResponder = &responder;
  }

  return true;
}
//*******************************************************************
bool TACVPAct1State::HandleAskExpert(TResponder &responder)
{
	if (responder.GetResponseEvent() == reLUp)
  {
	 AskExpertResponder = &responder;
  }

  if (responder.GetResponseEvent() == reLDown)
  {
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
	 AskExpertResponder = &responder;
  }

  return true;
}
//*******************************************************************
bool TACVPAct1State::HandleCashOut(TResponder &responder)
{
  if(pOwnerLord->credits > 0)
  {
	 if (responder.GetResponseEvent() == reLUp)
	 {
		CashOutResponder = &responder;
	 }

	 if (responder.GetResponseEvent() == reLDown)
	 {
		responder.SetPriority();
	 }

	 if (responder.GetResponseEvent() == reChar)
	 {
		CashOutResponder = &responder;
	 }
  }
  return true;
}
//*******************************************************************

