//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  acvpa2st.cpp
//    Project Name:  Casino
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     06/29/95   A. Krist    Original baseline
//  2.0     09/25/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "acvpa2st.h"
#include "acvpglrd.h"
#include "acvpdwst.h"
#include "acvpdtst.h"
#include "acvpwnst.h"
#include "acvpwtst.h"
#include "acvpwdst.h"
#include "acvpwsst.h"
#include "acvpwwst.h"
#include "otimers.h"
#include "orespond.h"
//*******************************************************************
TACVPAct2State::TACVPAct2State(TACVPVPGLord *pNewVPLord)
:TVPLordState(pNewVPLord)
{
  SetRunOrder(ess_Execute,ess_StartSubState2,ess_Done);
  DealDrawResponder = NULL;
  AskExpertResponder = NULL;
  MenuEscResponder = NULL;
  askexpertflag = false;
  IgnoreCoach = false;
  CursorFUC = 0;
  WaitingOnWRCounter = 0;
  for(int16 i=0;i<5;i++)
  {
    FlipShow[i] = false;
  }
}
//*******************************************************************
TACVPAct2State::~TACVPAct2State()
{
  if(pOwnerLord->SubGameType == cvpDDownStud)
  {
    pOwnerLord->Button1->SetCurrentUpFrame(0);
    pOwnerLord->Button1->SetCurrentDownFrame(1);
    pOwnerLord->Button2->SetCurrentUpFrame(0);
    pOwnerLord->Button2->SetCurrentDownFrame(1);
    TRect tempRect(407,400,473,452);
    pOwnerLord->Button1->PButtonResponder->SetRect(tempRect);
  }
  if(pOwnerLord->SubGameType == cvpRaiseJokersWild)
  {
    pOwnerLord->Button1->SetCurrentGrayFrame(3);
    pOwnerLord->Button2->SetCurrentGrayFrame(3);
    pOwnerLord->Button1->SetCurrentUpFrame(0);
    pOwnerLord->Button1->SetCurrentDownFrame(1);
    pOwnerLord->Button2->SetCurrentUpFrame(0);
    pOwnerLord->Button2->SetCurrentDownFrame(1);
  }
}
//*******************************************************************
void TACVPAct2State::ExecuteFirstTime()
{
  pOwnerLord->DoubleBet = false;
  ExecuteWaiting = true;
  ExecuteStatus    = ess_Execute;
 // pOwnerLord->CardSprite->SetBack();
  pOwnerLord->Button0->ShowGray();
  pOwnerLord->Button1->ShowGray();
  pOwnerLord->Button3->SetCurrentUpFrame(3);
  pOwnerLord->Button3->SetCurrentDownFrame(4);
  pOwnerLord->Button3->ShowVoidUp();
  pOwnerLord->Button2->ShowGray();
  if(pOwnerLord->SubGameType == cvpRaiseJokersWild)
  {
    pOwnerLord->Dcoinsplayed = 0;
    pOwnerLord->Button1->SetCurrentGrayFrame(2);
    pOwnerLord->Button2->SetCurrentGrayFrame(2);
    pOwnerLord->Button1->SetCurrentUpFrame(3);
    pOwnerLord->Button1->SetCurrentDownFrame(4);
    pOwnerLord->Button2->SetCurrentUpFrame(3);
    pOwnerLord->Button2->SetCurrentDownFrame(4);
    pOwnerLord->Button2->ShowVoidUp();
    pOwnerLord->Button1->ShowVoidUp();
  }
 //??? pOwnerLord->DisEnableButton(idButton7);
 //??? pOwnerLord->EnableButton(idButton8);
  pOwnerLord->UnFreezeAllButtons();//show background
  for(int16 i=1;i<6;i++)
  {
	 pOwnerLord->Responders[i]->Add();
  }
  pOwnerLord->Responders[0]->Remove();
  pOwnerLord->Responders[13]->Remove();
  pOwnerLord->Responders[12]->Remove(); //???
  for(int16 i=6;i<12;i++)
  {
	 pOwnerLord->Responders[i]->Remove();
  }
  if(pOwnerLord->SubGameType == cvpDDownStud)
  {
    pOwnerLord->Button1->SetCurrentUpFrame(8);
    pOwnerLord->Button1->SetCurrentDownFrame(9);
    pOwnerLord->Button1->ShowVoidUp();
    TRect tempRect(407,400,553,452);
    pOwnerLord->Button1->PButtonResponder->SetRect(tempRect);
    for(int16 i=1;i<6;i++)
    {
	   pOwnerLord->Responders[i]->Remove();
    }

  }
}
//*******************************************************************
void TACVPAct2State::CreateSubState1()
{
  for(int16 i=1;i<6;i++)
  {
	 pOwnerLord->Responders[i]->Remove();
  }
  if(pOwnerLord->SubGameType == cvpTriplePlay)
  {PActiveSubState = new TACVPTripleDrawState(pOwnerLord);}
  else
  {PActiveSubState = new TACVPDrawState(pOwnerLord);}
}
//*******************************************************************
void TACVPAct2State::CreateSubState2()
{
  if(pOwnerLord->SubGameType == cvpTriplePlay)
  {
    PActiveSubState = new TACVPWinTripleState(pOwnerLord);
  }
  else if(pOwnerLord->SubGameType == cvpDDownStud)
  {PActiveSubState = new TACVPWinStudState(pOwnerLord);}
  else if(pOwnerLord->IsDoubleType)
  {PActiveSubState = new TACVPWinDoubleState(pOwnerLord);}
  else if(pOwnerLord->IsNormalType)
  {PActiveSubState = new TACVPWinNormalState(pOwnerLord);}
  else if(pOwnerLord->IsDDrawType)
  {PActiveSubState = new TACVPWinDDrawState(pOwnerLord);}
}
//*******************************************************************
#pragma argsused
void TACVPAct2State::HandlePostUpdate(dword NewFUC)
{
 for(int16 j=0;j<5;j++)
 {
  if(FlipShow[j])
  {
    if(pOwnerLord->ShowTripleBack)
    {
      pOwnerLord->TopCardSprite->ShowBack(j);
      pOwnerLord->MidCardSprite->ShowBack(j);
    }
    else
    {
      pOwnerLord->TopCardSprite->ShowFace(pOwnerLord->TripTopHand->cards[j].suit,
                                          pOwnerLord->TripTopHand->cards[j].name,j);
      pOwnerLord->MidCardSprite->ShowFace(pOwnerLord->TripMidHand->cards[j].suit,
                                          pOwnerLord->TripMidHand->cards[j].name,j);
    }
    FlipShow[j] = false;
    return;
  }
 }
  if (pOwnerLord->ButtonHit[idButton0])
  {
    pOwnerLord->ButtonClear(idButton0);
	 return;
  }
  if (pOwnerLord->ButtonHit[idButton6])
  {
    pOwnerLord->ButtonClear(idButton6);
	 return;
  }
  if (pOwnerLord->ButtonHit[idButton4])
  {
    pOwnerLord->ButtonClear(idButton4);
	 return;
  }
  if (pOwnerLord->ButtonHit[idButton5])
  {
    pOwnerLord->ButtonClear(idButton5);
	 return;
  }
  if (pOwnerLord->ButtonHit[idButton1])
  {
    if(pOwnerLord->SubGameType == cvpRaiseJokersWild)
    {
      pOwnerLord->BetRD1();
      if(pOwnerLord->coinsplayed == pOwnerLord->Dcoinsplayed)
      {
        pOwnerLord->coinsplayed += pOwnerLord->Dcoinsplayed;
        ExecuteWaiting = false;
		  ExecuteStatus = ess_StartSubState1;
      }
    }
    if(pOwnerLord->SubGameType == cvpDDownStud)
    {
      pOwnerLord->AskHoldCards(false);
	   if(pOwnerLord->GetCasPD(pOwnerLord->activeplayer)->CoachOn &&
         !pOwnerLord->CheckExpertCode() &&
         !IgnoreCoach)
	   {
		  pOwnerLord->Button7->ShowExpert();
		  IgnoreCoach = true;
	   }
	   else
	   {
	  	  if(!pOwnerLord->CheckExpertCode())
	  	  {
	      int16 session = pOwnerLord->GetCasPD(pOwnerLord->activeplayer)->VPData.CurrentSession;
	  	    pOwnerLord->GetCasPD(pOwnerLord->activeplayer)->VPData.Sessions[session].IncorrectPlays++;
	  	  }
        pOwnerLord->DoubleTheBet();
        ExecuteWaiting = false;
        ExecuteStatus = ess_StartSubState1;
      }
    }
	 pOwnerLord->ButtonClear(idButton1);
	 return;
  }
  if (pOwnerLord->ButtonHit[idButton2])
  {
	 if(pOwnerLord->SubGameType == cvpRaiseJokersWild)
    {
      WaitingOnWRCounter = pOwnerLord->BetRDMax();
      if(WaitingOnWRCounter == 0)
      {
        pOwnerLord->coinsplayed += pOwnerLord->Dcoinsplayed;
		  ExecuteWaiting = false;
		  ExecuteStatus = ess_StartSubState1;
      }
    }
    pOwnerLord->ButtonClear(idButton2);
	 return;
  }
  if (pOwnerLord->ButtonHit[idButton7])
  {
	 pOwnerLord->Button7->ExpertStart = 0;
	 pOwnerLord->AskHoldCards(true);
	 pOwnerLord->ButtonClear(idButton7);
	 IgnoreCoach = false;
	 return;
  }
  if (WaitingOnWRCounter)
  {
	 pOwnerLord->FreezeAllButtons();
	 pOwnerLord->WinRatio->SetColumn(pOwnerLord->coinsplayed+pOwnerLord->Dcoinsplayed-WaitingOnWRCounter+1);
	 WaitingOnWRCounter--;
	 if (!WaitingOnWRCounter)
	 {
      pOwnerLord->coinsplayed += pOwnerLord->Dcoinsplayed;
		ExecuteWaiting = false;
		ExecuteStatus = ess_StartSubState1;
	 }
  }
  if (pOwnerLord->ButtonHit[idButton3])
  {
	 pOwnerLord->AskHoldCards(false);
	 if(pOwnerLord->GetCasPD(pOwnerLord->activeplayer)->CoachOn &&
       pOwnerLord->CheckExpertCode()                           &&
       !IgnoreCoach                                            &&
       pOwnerLord->SubGameType == cvpDDownStud)
	 {
		pOwnerLord->Button7->ShowExpert();
		IgnoreCoach = true;
	 }
	 else if(pOwnerLord->GetCasPD(pOwnerLord->activeplayer)->CoachOn &&
       !pOwnerLord->CheckExpertCode()                               &&
       !IgnoreCoach                                                 &&
       pOwnerLord->SubGameType != cvpDDownStud)
	 {
		pOwnerLord->Button7->ShowExpert();
		IgnoreCoach = true;
	 }
	 else
	 {
	  	if(!pOwnerLord->CheckExpertCode())
	  	{
	    int16 session = pOwnerLord->GetCasPD(pOwnerLord->activeplayer)->VPData.CurrentSession;
	  	  pOwnerLord->GetCasPD(pOwnerLord->activeplayer)->VPData.Sessions[session].IncorrectPlays++;
	  	}
      if(pOwnerLord->SubGameType == cvpRaiseJokersWild)
      {
        pOwnerLord->coinsplayed += pOwnerLord->Dcoinsplayed;
      }
		pOwnerLord->FreezeAllButtons();
		ExecuteWaiting = false;
      if(pOwnerLord->SubGameType == cvpDDownStud)
      {
        ExecuteStatus = ess_StartSubState1;
      }
      else
      {
		  ExecuteStatus = ess_StartSubState1;
      }
		IgnoreCoach = false;
	 }
	 pOwnerLord->ButtonClear(idButton3);
	 return;
  }
}
//*******************************************************************
bool TACVPAct2State::HandleHoldCard0(TResponder &responder)
{
  if(responder.GetResponseEvent() == reLDown)
  {
	 responder.SetPriority();
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_PRESSING_FINGER_CURSOR));
	 return true;
  }
  if ((responder.GetResponseEvent() == reLUp    ) ||
		(responder.GetResponseEvent() == reLDblClk) ||
		(responder.GetResponseEvent() == reChar   )   )
  {
	 if(responder.GetIsPriority())
	 {
		responder.ClearPriority();
	 }
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_POINTING_FINGER_CURSOR));
	 if(responder.Contains(responder.GetPoint()) ||
		 responder.GetResponseEvent() == reChar)
	 {
     if(pOwnerLord->SubGameType != cvpDDownStud && !FlipShow[0])
     {
		pOwnerLord->HoldCard(0);
      if(pOwnerLord->SubGameType == cvpTriplePlay)
      {
        pOwnerLord->HoldCardTrip(0);
        FlipShow[0] = true;
      }
     }
	 }
  }
  return true;
}
//*******************************************************************
bool TACVPAct2State::HandleHoldCard1(TResponder &responder)
{
  if(responder.GetResponseEvent() == reLDown)
  {
	 responder.SetPriority();
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_PRESSING_FINGER_CURSOR));
	 return true;
  }
  if ((responder.GetResponseEvent() == reLUp    ) ||
		(responder.GetResponseEvent() == reLDblClk) ||
		(responder.GetResponseEvent() == reChar   )   )
  {
	 if(responder.GetIsPriority())
	 {
		responder.ClearPriority();
	 }
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_POINTING_FINGER_CURSOR));
	 if(responder.Contains(responder.GetPoint()) ||
		 responder.GetResponseEvent() == reChar)
	 {
     if(pOwnerLord->SubGameType != cvpDDownStud && !FlipShow[1])
     {
		pOwnerLord->HoldCard(1);
      if(pOwnerLord->SubGameType == cvpTriplePlay)
      {
        pOwnerLord->HoldCardTrip(1);
        FlipShow[1] = true;
      }
     }
	 }
  }
  return true;
}
//*******************************************************************
bool TACVPAct2State::HandleHoldCard2(TResponder &responder)
{
  if(responder.GetResponseEvent() == reLDown)
  {
	 responder.SetPriority();
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_PRESSING_FINGER_CURSOR));
	 return true;
  }
  if ((responder.GetResponseEvent() == reLUp    ) ||
		(responder.GetResponseEvent() == reLDblClk) ||
		(responder.GetResponseEvent() == reChar   )   )
  {
	 if(responder.GetIsPriority())
	 {
		responder.ClearPriority();
	 }
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_POINTING_FINGER_CURSOR));
	 if(responder.Contains(responder.GetPoint()) ||
		 responder.GetResponseEvent() == reChar)
	 {
     if(pOwnerLord->SubGameType != cvpDDownStud && !FlipShow[2])
     {
		pOwnerLord->HoldCard(2);
      if(pOwnerLord->SubGameType == cvpTriplePlay)
      {
        pOwnerLord->HoldCardTrip(2);
        FlipShow[2] = true;
      }
     }
	 }
  }
  return true;
}
//*******************************************************************
bool TACVPAct2State::HandleHoldCard3(TResponder &responder)
{
  if(responder.GetResponseEvent() == reLDown)
  {
	 responder.SetPriority();
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_PRESSING_FINGER_CURSOR));
	 return true;
  }
  if ((responder.GetResponseEvent() == reLUp    ) ||
		(responder.GetResponseEvent() == reLDblClk) ||
		(responder.GetResponseEvent() == reChar   )   )
  {
	 if(responder.GetIsPriority())
	 {
		responder.ClearPriority();
	 }
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_POINTING_FINGER_CURSOR));
	 if(responder.Contains(responder.GetPoint()) ||
		 responder.GetResponseEvent() == reChar)
	 {
     if(pOwnerLord->SubGameType != cvpDDownStud && !FlipShow[3])
     {
		pOwnerLord->HoldCard(3);
      if(pOwnerLord->SubGameType == cvpTriplePlay)
      {
        pOwnerLord->HoldCardTrip(3);
        FlipShow[3] = true;
      }
     }
	 }
  }
  return true;
}
//*******************************************************************
bool TACVPAct2State::HandleHoldCard4(TResponder &responder)
{
  if(responder.GetResponseEvent() == reLDown)
  {
	 responder.SetPriority();
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_PRESSING_FINGER_CURSOR));
	 return true;
  }
  if ((responder.GetResponseEvent() == reLUp    ) ||
		(responder.GetResponseEvent() == reLDblClk) ||
		(responder.GetResponseEvent() == reChar   )   )
  {
	 if(responder.GetIsPriority())
	 {
		responder.ClearPriority();
	 }
	 responder.SetCDNow(TCursorData(pOwnerLord->GetOgleApp(),ID_POINTING_FINGER_CURSOR));
	 if(responder.Contains(responder.GetPoint()) ||
		 responder.GetResponseEvent() == reChar)
	 {
     if(pOwnerLord->SubGameType != cvpDDownStud && !FlipShow[4])
     {
		pOwnerLord->HoldCard(4);
      if(pOwnerLord->SubGameType == cvpTriplePlay)
      {
        pOwnerLord->HoldCardTrip(4);
        FlipShow[4] = true;
      }
     }
	 }
  }
  return true;
}
//*******************************************************************
bool TACVPAct2State::HandleDealDraw(TResponder &responder)
{
  if (responder.GetResponseEvent() == reLUp)
  {
	 DealDrawResponder = &responder;
  }

  if (responder.GetResponseEvent() == reLDown)
  {
responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
	 DealDrawResponder = &responder;
  }
  return true;
}
//*******************************************************************
bool TACVPAct2State::HandleMenuEsc(TResponder &responder)
{
	if (responder.GetResponseEvent() == reLUp)
  {
	 MenuEscResponder = &responder;
  }

  if (responder.GetResponseEvent() == reLDown)
  {
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
	 MenuEscResponder = &responder;
  }

  return true;
}
//*******************************************************************
bool TACVPAct2State::HandleAskExpert(TResponder &responder)
{
	if (responder.GetResponseEvent() == reLUp)
  {
	 AskExpertResponder = &responder;
  }

  if (responder.GetResponseEvent() == reLDown)
  {
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
	 AskExpertResponder = &responder;
  }

  return true;
}
//*******************************************************************

