//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  acvpbtsp.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     3/16/96    A. Krist    original baseline
//  2.0    09/02/97    M.Perry     32-bit conversion.
//********************************************************************
#include "acvpbtsp.h"
#include "omodewin.h"
#include "orespond.h"
#include "oanm.h"
#include "owav.h"
//*******************************************************************
void TACCasButton::SetupWavs()
{
	 PDownWav = GetWav(0);
	 PUpWav = GetWav(1);
	 PChime = GetWav(2);
	 if(PChime == NULL){ThirdWave = false;}
}
//*******************************************************************
void TACCasButton::SetupAnms()
{
	 PButton = GetAnm(0);

	 if (PButton == NULL) {AnmError("A ","button",0);}
	 PButton->CAD.ClearAutoStart();
	 PButton->CAD.SetDirStill();
	 PButton->CAD.ClearAutoStop();
}
//*******************************************************************
TACCasButton::TACCasButton(TOgleModeWindow *pmw,
                       TFileMode NewFileMode,
                       TCasinoGameLord *GameLord,
							  int16 ZOrder,
                       const TRect &rect,
                       int16 IdNum,
                       bool Handled,
                       char Ch,
                       const TCursorData &cd,
                       const TCursorData &dac)
:TSprite(pmw,NewFileMode)
{
	 SetToManual();
	 NoShow();
	 SetupAnms();
	 SetupWavs();
	 PButtonResponder = new TResponder(PModeWin,ZOrder,rect,IdNum,this,Handled,Ch,cd);
	 DefaultActionCursor = dac;
	 ButtonDownFUC = 0;
	 POwnerBase = GameLord;
	 ButtonUp = false;
	 Enabled  = true;
	 LeftUp   = false;
	 GoodUp   = -1;
	 Info = 0;
	 Freeze = false;
	 ExpertStart = 0;
	 CurrentUpFrame   = 0;
	 CurrentDownFrame = 1;
	 CurrentGrayFrame = -1;  //-1 = NoShow();
	 ThirdWave = true;
}
//*******************************************************************
TACCasButton::TACCasButton(TOgleModeWindow *pmw,
                       TFileMode fm,
                       void *psource,
                       TCasinoGameLord *GameLord,
							  int16 ZOrder,
                       const TRect &rect,
                       int16 IdNum,
                       bool Handled,
                       char Ch,
                       const TCursorData &cd,
                       const TCursorData &dac)
:TSprite(pmw,fm,psource)
{
	 SetToManual();
	 NoShow();
	 SetupAnms();
	 SetupWavs();
	 PButtonResponder = new TResponder(PModeWin,ZOrder,rect,IdNum,this,Handled,Ch,cd);
	 DefaultActionCursor = dac;
	 ButtonDownFUC = 0;
	 POwnerBase = GameLord;
	 ButtonUp = false;
	 Enabled  = true;
	 LeftUp   = false;
	 GoodUp   = -1;
	 Info = 0;
	 Freeze = false;
	 ExpertStart = 0;
	 CurrentUpFrame   = 0;
	 CurrentDownFrame = 1;
	 CurrentGrayFrame = -1;
	 ThirdWave = true;
}
//*******************************************************************
TACCasButton::TACCasButton(TOgleModeWindow *pmw,TFileMode NewFileMode)
:TSprite(pmw,NewFileMode)
{
	 SetToManual();
	 NoShow();
	 SetupAnms();
	 SetupWavs();
	 //PButtonResponder = new TResponder(ZOrder,rect,IdNum,this,Handled,Ch);
	 ButtonDownFUC = 0;
	 ButtonUp = false;
	 Enabled  = true;
	 LeftUp   = false;
	 GoodUp   = -1;
	 Info = 0;
	 Freeze = false;
	 ExpertStart = 0;
    CurrentUpFrame   = 0;
	 CurrentDownFrame = 1;
	 CurrentGrayFrame = -1;
    ThirdWave = true;
}
//*******************************************************************
TACCasButton::TACCasButton(TOgleModeWindow *pmw,TFileMode fm,void *psource)
:TSprite(pmw,fm,psource)
{
	 SetToManual();
	 NoShow();
	 SetupAnms();
	 SetupWavs();
  //	 PButtonResponder = new TResponder(ZOrder,rect,IdNum,this,Handled,Ch);
	 ButtonDownFUC = 0;
	 ButtonUp = false;
	 LeftUp   = false;
	 Enabled  = true;
	 GoodUp   = -1;
	 Info = 0;
	 Freeze = false;
	 ExpertStart = 0;
    CurrentUpFrame   = 0;
	 CurrentDownFrame = 1;
	 CurrentGrayFrame = -1;
    ThirdWave = true;
}
//*******************************************************************
TACCasButton::~TACCasButton()
{
  if(PButtonResponder != NULL){delete PButtonResponder;}
}
//*******************************************************************
void TACCasButton::SetCurrentGrayFrame(int16 frame)
{
  CurrentGrayFrame = frame;
}
//*******************************************************************
void TACCasButton::SetCurrentUpFrame(int16 frame)
{
  CurrentUpFrame = frame;
}
//*******************************************************************
void TACCasButton::PlayChime()
{
  PChime->Start();
}
//*******************************************************************
void TACCasButton::SetCurrentDownFrame(int16 frame)
{
  CurrentDownFrame = frame;
}
//*******************************************************************
void TACCasButton::ShowGray()
{
  if(CurrentGrayFrame == -1)
  {
	 PButton->NoShow();
  }
  else
  {
	 PButton->CAD.SetCurrentFrame(CurrentGrayFrame);
	 PButton->Show();
  }
  Enabled = false;
}
//*******************************************************************
void TACCasButton::NoShowExpert()
{
	 PButton->NoShow();
}
//*******************************************************************
void TACCasButton::ShowExpert()
{
	 PButton->CAD.SetCurrentFrame(0);
	 PButton->Show();
	 if(ThirdWave && PChime != NULL){PChime->Start();}
	 ExpertStart = GetAdjFUC();
}
//*******************************************************************
void TACCasButton::ShowLite()
{
	 PButton->CAD.SetCurrentFrame(2);
	 PButton->Show();
	 if(ThirdWave){PChime->Start();}
}
//*******************************************************************
void TACCasButton::ShowUp()
{
  if(CurrentUpFrame == -1)
  {
	 PButton->NoShow();
  }
  else
  {
	 if(CurrentUpFrame == 50)//lobby
	 {
		PButton->CAD.SetCurrentFrame(0);
	 }
	 else
	 {
	  //	CurrentUpFrame   = int16((CurrentUpFrame+3)%12);  //For freak'in crap's hort., vert., loop, rand. button only. Yeah, yeah, I'll derive next time...
	  //	CurrentGrayFrame = int16((CurrentGrayFrame+3)%12);
	  //	CurrentDownFrame = int16((CurrentDownFrame+3)%12);
		PButton->CAD.SetCurrentFrame(CurrentUpFrame);
	 }
	 PButton->Show();
  }
  if(PUpWav != NULL)
  {
	 PUpWav->Start();
  }
  Enabled = true;
}
//*******************************************************************
void TACCasButton::ShowVoidUp()
{
  if(CurrentUpFrame == -1)
  {
	 PButton->NoShow();
  }
  else
  {
	 if(CurrentUpFrame == 50)//lobby
	 {
		PButton->CAD.SetCurrentFrame(0);
	 }
	 else
	 {
		PButton->CAD.SetCurrentFrame(CurrentUpFrame);
	 }
	 PButton->Show();
  }
	Enabled = true;
}
//*******************************************************************
void TACCasButton::ShowDown()
{
	 if(CurrentUpFrame == 50)//lobby
	 {
		PButton->CAD.SetCurrentFrame(1);
	 }
	 else
	 {
		PButton->CAD.SetCurrentFrame(CurrentDownFrame);
	 }
	 PButton->Show();
	 if(PDownWav != NULL)
	 {
		PDownWav->Start();
	 }
}
//*******************************************************************
bool TACCasButton::Respond(TResponder &responder)
{
  if(Freeze){return true;}
  if(!Enabled &&
	 (PButton->CAD.GetCurrentFrame() == CurrentGrayFrame ||
	  CurrentGrayFrame == 50 || CurrentGrayFrame == -1    ))
  {return POwnerBase->Respond(responder.GetID(),-5);}//Gray button hit
  if(!Enabled){return false;}
  if(POwnerBase->WaitOnButtonDown)
  {return true;}
  else
  {
	 if (responder.GetResponseEvent() == reLUp || responder.GetResponseEvent() == reRUp)
	 {
		responder.ClearPriority();
		LeftUp = true;
		if(responder.Contains(responder.GetPoint()))
		{
		  GoodUp = responder.GetID();
        POwnerBase->WaitOnButtonDown = true;
		  if(responder.GetResponseEvent() == reRUp)
		  {Info = 1;}
		}
		else
		{
		  GoodUp = -2;//Extended dice shake in craps info only, so far.10/29/96.
		}
	 }
	 if(ButtonDownFUC){return true;}
	 if(responder.GetResponseEvent() == reLDown || responder.GetResponseEvent() == reRDown)
	 {
		ButtonDownFUC = GetAdjFUC();
		responder.SetPriority();
		POwnerBase->Respond(responder.GetID(),-1);    //down
	 }
	 if (responder.GetResponseEvent() == reChar)
	 {
		ButtonDownFUC = GetAdjFUC();
		LeftUp = true;
		GoodUp = responder.GetID();
		POwnerBase->Respond(responder.GetID(),-1);
		POwnerBase->WaitOnButtonDown = true;
	 }
  }
  return true;
}
//*******************************************************************
void TACCasButton::Update(dword NewFUC)
{
  if(ExpertStart)
  {
	 if(ExpertStart + 30 <= NewFUC)
	 {
		ExpertStart = 0;
		ShowVoidUp();
	 }
  }
  if(ButtonDownFUC && !ButtonUp)
  {
	 ShowDown();
	 GetOgleApp()->GetCursorMgr()->SetCursor(ctAction,DefaultActionCursor);
	 ButtonUp = true;
  }
  if(ButtonDownFUC < NewFUC && LeftUp)
  {
	 if(GoodUp > -1)
	 {
		ShowUp();
	 }
	 else
	 {
		ShowVoidUp();
	 }
	 GetOgleApp()->GetCursorMgr()->SetCursor(ctAction,0,0);
	 ButtonUp      = false;
	 LeftUp        = false;
	 ButtonDownFUC = 0;
  }
  if((GoodUp > -1) && ((ButtonDownFUC+1) < NewFUC))
  {
	  POwnerBase->Respond(GoodUp,Info);
	  GoodUp = -1;
     Info = 0;
  }
  else if(GoodUp == -2)
  {
	 POwnerBase->Respond(GoodUp,Info);
	 GoodUp = -1;
  }
  TSprite::Update(NewFUC);
}
//*******************************************************************
void TACCasButton::PostUpdate(dword NewFUC)
{
	TSprite::PostUpdate(NewFUC);
}
//*******************************************************************

