//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  acvpcpsp.cpp
//    Project Name:  Casino
// Original Author:  Adam Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     7/19/96    M.Perry     moved into cpp file.
//  2.0    09/25/97    M.Perry     32-bit conversion.
//********************************************************************
#include "acvpcpsp.h"
#include "oanm.h"
//*******************************************************************
void TACVPCoinsPlayed::SetupAnms()
{
  PNumOnes = GetAnm(1);
  PNumTens = GetAnm(0);
  if (PNumOnes == NULL || PNumTens == NULL) {AnmError("Coins Played","Nums",0);}
  TAnmData ad = PNumOnes->CAD;
  ad.ClearAutoStart();
  ad.SetDirStill();
  ad.ClearAutoStop();
  PNumOnes->SetCurrentData(ad);

  TAnmData da = PNumTens->CAD;
  da.ClearAutoStart();
  da.SetDirStill();
  da.ClearAutoStop();
  PNumTens->SetCurrentData(da);
}
//*******************************************************************
TACVPCoinsPlayed::TACVPCoinsPlayed(TOgleModeWindow *pmw,const TFileMode &NewFileMode)
:TSprite(pmw,NewFileMode)
{
  SetToManual();
  SetupAnms();
}
//*******************************************************************
TACVPCoinsPlayed::TACVPCoinsPlayed(TOgleModeWindow *pmw,const TFileMode &NewFileMode,void *psource)
:TSprite(pmw,NewFileMode,psource)
{
  SetToManual();
  SetupAnms();
}
//*******************************************************************
TACVPCoinsPlayed::~TACVPCoinsPlayed()
{
}
//*******************************************************************
void TACVPCoinsPlayed::SetNum(int16 num)
{
  if (PNumOnes == NULL) {return;}
  PNumOnes->CAD.SetCurrentFrame(num%10);
  PNumOnes->Show();

  if (PNumTens == NULL) {return;}
  PNumTens->CAD.SetCurrentFrame(num/10);
  PNumTens->Show();
  Update(GetAdjFUC());
}
//*******************************************************************
