//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  acvpdwst.cpp
//    Project Name:  Casino
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     09/29/95   A. Krist    Original baseline
//  2.0     09/25/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "acvpdwst.h"
#include "acvpglrd.h"
#include "otimers.h"
#include "cvpplay.h"
#include "casvpmw.h"
#include "hand.h"
#include "owav.h"
//*******************************************************************
TACVPDrawState::TACVPDrawState(TACVPVPGLord *pNewVPLord)
:TVPLordState(pNewVPLord)
{
}
//*******************************************************************
TACVPDrawState::~TACVPDrawState()
{
}
//*******************************************************************
void TACVPDrawState::ExecuteFirstTime()
{
 if(pOwnerLord->SubGameType == cvpDDownStud)
 {
  ExecuteWaiting = false;
  ExecuteStatus    = ess_Done;
 }
 else
 {
  ExecuteWaiting = true;
  ExecuteStatus    = ess_Execute;
  pOwnerLord->pDeck->Draw(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand);
  pOwnerLord->CardSprite->PFlipSound[0]->Start();
  for (int16 i=0;i<5;i++)
  {
    if (!pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->hold[i])
    {
      pOwnerLord->CardSprite->ShowSilentFlip(i);
    }
  }
  if(pOwnerLord->SubGameType == cvpFreeLook)
  {
    pOwnerLord->Look->ShowSilentFlip();
  }
  StartingFUC = pOwnerLord->GetAdjFUC();
  NextCardNum = 0;
  NextFUC = 2;
  Flipping = true;
  fLook = false;
 }
}
//*******************************************************************
void TACVPDrawState::HandlePostUpdate(dword NewFUC)
{
  if(fLook)
  {
    pOwnerLord->Look->ShowFace(pOwnerLord->pDeck->deck[pOwnerLord->pDeck->top].suit,
             pOwnerLord->pDeck->deck[pOwnerLord->pDeck->top].name);
    ExecuteWaiting = false;
  }
  if ((StartingFUC + 1) == NewFUC)
  {
    for (int16 i=0;i<5;i++)
    {
      if (!pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->hold[i])
      {
        pOwnerLord->CardSprite->ShowBack(i);
      }
    }
    if(pOwnerLord->SubGameType == cvpFreeLook)
    {
      pOwnerLord->Look->ShowBack();
    }
  }
  else if ((StartingFUC + NextFUC) == NewFUC && !fLook)
  {
    if (Flipping)
    {
      int16 i;
      for (i = NextCardNum;i<5;i++)
      {
        if (!pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->hold[i])
        {
          NextCardNum = i;
			 pOwnerLord->CardSprite->ShowFlip(i);
          NextFUC += 1;
          Flipping = false;
          break;
        }
      }
      if (i >= 5)
      {
        if(pOwnerLord->SubGameType == cvpFreeLook)
        {
          fLook = true;
          pOwnerLord->Look->ShowFlip();
        }
        else
        {
          ExecuteWaiting = false;
        }
      }
    }
    else
    {
      pOwnerLord->CardSprite->ShowFace(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->cards[NextCardNum].suit,
         pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->cards[NextCardNum].name,NextCardNum);
      NextCardNum++;
      NextFUC += 2;
      Flipping = true;
    }
  }
}
//*******************************************************************

