//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  acvpgdsp.cpp
//    Project Name:  Casino
// Original Author:  Adam Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     7/19/96    M.Perry    moved into cpp file.
//  2.0    09/27/97    M.Perry    32-bit conversion.
//********************************************************************
#include "acvpgdsp.h"
#include "oanm.h"
#include "owav.h"
//*******************************************************************
void TACVPGrid::SetupAnms()
{
  for(int16 i=0;i<5;i++)
  {
    for(int j=0;j<5;j++)
    {
      PGrid[i][j] = GetAnm((i*5)+j);
	   if(PGrid[i][j] == NULL) {AnmError("Grid Sprite","Grid",((i*5)+j));}
      PGrid[i][j]->NoShow();
      PGrid[i][j]->CAD.ClearAutoStart();
      PGrid[i][j]->CAD.ClearAutoStop();
      PGrid[i][j]->CAD.SetDirStill();
    }
  }
}
//*******************************************************************
TACVPGrid::TACVPGrid(TOgleModeWindow *pmw,const TFileMode &NewFileMode)
:TSprite(pmw,NewFileMode)
{
  SetToManual();
  NoShow();
  SetupAnms();
}
//*******************************************************************
TACVPGrid::TACVPGrid(TOgleModeWindow *pmw,const TFileMode &NewFileMode,void *psource)
:TSprite(pmw,NewFileMode,psource)
{
  SetToManual();
  NoShow();
  SetupAnms();
}
//*******************************************************************
TACVPGrid::~TACVPGrid()
{
}
//*******************************************************************
void TACVPGrid::ClearRow(int row)
{
  for(int i=0;i<5;i++)
  {
    PGrid[row][i]->NoShow();
  }
  Update(GetAdjFUC());
}
//*******************************************************************
void TACVPGrid::ClearCol(int col)
{
  for(int i=0;i<5;i++)
  {
    PGrid[i][col]->NoShow();
  }
  Update(GetAdjFUC());
}
//*******************************************************************
void TACVPGrid::ShowCell(int row, int col)
{
  PGrid[row][col]->CAD.SetCurrentFrame(0);
  PGrid[row][col]->Show();
  Update(GetAdjFUC());
}
//*******************************************************************
void TACVPGrid::NoShowCell(int row, int col)
{
  PGrid[row][col]->CAD.SetCurrentFrame(0);
  PGrid[row][col]->NoShow();
  Update(GetAdjFUC());
}
//*******************************************************************

