//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  acvplksp.cpp
//    Project Name:  Casino
// Original Author:  Adam Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     7/19/96    M.Perry    moved into cpp file.
//  2.0    09/27/97    M.Perry    32-bit conversion.
//********************************************************************
#include "acvplksp.h"
#include "oanm.h"
#include "owav.h"
//*******************************************************************
void TACVPLook::SetupWavs()
{
	 PFlipSound = GetWav(0);
	 if (PFlipSound == NULL) {AnmError("Look Sprite","FlipSound",0);}
}
//*******************************************************************
void TACVPLook::SetupAnms()
{
    PCard = GetAnm(1);
	 if (PCard == NULL) {AnmError("Look Sprite","Card",1);}
     PCard->NoShow();
    PCard->CAD.ClearAutoStart();
    PCard->CAD.ClearAutoStop();
    PCard->CAD.SetDirStill();
    ShowBack();
}
//*******************************************************************
TACVPLook::TACVPLook(TOgleModeWindow *pmw,const TFileMode &NewFileMode)
:TSprite(pmw,NewFileMode)
{
  SetToManual();
  NoShow();
  SetupAnms();
  SetupWavs();
}
//*******************************************************************
TACVPLook::TACVPLook(TOgleModeWindow *pmw,const TFileMode &NewFileMode,void *psource)
:TSprite(pmw,NewFileMode,psource)
{
  SetToManual();
  NoShow();
  SetupAnms();
  SetupWavs();
}
//*******************************************************************
TACVPLook::~TACVPLook()
{
}
//*******************************************************************
void TACVPLook::SetBack()
{
  PCard->CAD.SetCurrentFrame(0);
  PCard->Show();
  Update(GetAdjFUC());
}
//*******************************************************************
void TACVPLook::ShowBack()
{
  PCard->CAD.SetCurrentFrame(0);
  PCard->Show();
  Update(GetAdjFUC());
}
//*******************************************************************
void TACVPLook::ShowSilentFlip()
{
  PCard->CAD.SetCurrentFrame(1);
  PCard->Show();
  Update(GetAdjFUC());
}
//*******************************************************************
void TACVPLook::ShowFlip()
{
  PCard->CAD.SetCurrentFrame(1);
  PCard->Show();
  PFlipSound->Start();
  Update(GetAdjFUC());
}
//*******************************************************************
void TACVPLook::ShowFace(TSuit suit,TCardName cardname)
{
	 int16 num = 0;
	 if (PCard == NULL) {return;}

	 if (suit > Spade) {return;}
	 if (cardname == AceHi) {cardname = AceLo;}

	 num = int16((suit * 13) + cardname+2);//+2 => back and flip frame

	 PCard->CAD.SetCurrentFrame(num);
    PCard->Show();

    Update(GetAdjFUC());
}
//*******************************************************************