//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  acvpposp.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     7/19/96    M.Perry     moved into cpp file.
//  2.0    09/25/97    M.Perry     32-bit conversion.
//********************************************************************
#include "acvpposp.h"
#include "oanm.h"
#include "owav.h"
//*******************************************************************
void TACVPCoinPay::SetupAnms()
{
    for(int i=0;i<8;i++)
    {
	   PCoinPay[i] = GetAnm(i);
      if (PCoinPay[i] == NULL) {AnmError("CoinPay","Bar",i);}
	   PCoinPay[i]->CAD.ClearAutoStart();
	   PCoinPay[i]->CAD.ClearAutoStop();
	   PCoinPay[i]->CAD.SetDirStill();;
    }
}
//*******************************************************************
void TACVPCoinPay::SetupWavs()
{
    for(int i=0;i<7;i++)
    {
	   PCoinWav[i] = GetWav(i);
      if (PCoinWav[i] == NULL) {AnmError("CoinWav","Bar",i);}
    }
}
//*******************************************************************
TACVPCoinPay::TACVPCoinPay(TOgleModeWindow *pmw,const TFileMode &NewFileMode)
:TSprite(pmw,NewFileMode)
{
  NoShow();
  SetToManual();
  SetupAnms();
  SetupWavs();
}
//*******************************************************************
TACVPCoinPay::TACVPCoinPay(TOgleModeWindow *pmw,const TFileMode &NewFileMode,void *psource)
:TSprite(pmw,NewFileMode,psource)
{
  NoShow();
  SetToManual();
  SetupAnms();
  SetupWavs();
}
//*******************************************************************
TACVPCoinPay::~TACVPCoinPay()
{
}
//*******************************************************************
void TACVPCoinPay::ClearTray()
{
	 for(int i=0;i<8;i++)
    {
      PCoinPay[i]->NoShow();
    }
}
//*******************************************************************
void TACVPCoinPay::SetTray(int16 num)
{
  if(num>=200)
  {
	 PCoinPay[7]->CAD.SetCurrentFrame(24);
	 PCoinPay[7]->Show();

  }
  else if(num>=175)
  {
	 PCoinPay[7]->CAD.SetCurrentFrame(int16(num - 175));
	 PCoinPay[7]->Show();
  }
  else if(num>=150)
  {
	 PCoinPay[6]->CAD.SetCurrentFrame(int16(num - 150));
	 PCoinPay[6]->Show();
  }
  else if(num>=125)
  {
	 PCoinPay[5]->CAD.SetCurrentFrame(int16(num - 125));
	 PCoinPay[5]->Show();
  }
  else if(num>=100)
  {
	 PCoinPay[4]->CAD.SetCurrentFrame(int16(num - 100));
	 PCoinPay[4]->Show();
  }
  else if(num>=75)
  {
	 PCoinPay[3]->CAD.SetCurrentFrame(int16(num - 75));
	 PCoinPay[3]->Show();
  }
  else if(num>=50)
  {
	 PCoinPay[2]->CAD.SetCurrentFrame(int16(num - 50));
	 PCoinPay[2]->Show();
  }
  else if(num>=25)
  {
	 PCoinPay[1]->CAD.SetCurrentFrame(int16(num - 25));
	 PCoinPay[1]->Show();
  }
  else if(num>=0)
  {
	 PCoinPay[0]->CAD.SetCurrentFrame(int16(num));
	 PCoinPay[0]->Show();
  }
  Update(GetAdjFUC());
}
//*******************************************************************
void TACVPCoinPay::StopSound(int sound)
{
  if(sound >= 0 && sound < 7)
  {
    PCoinWav[sound]->Stop();
  }
}
//*******************************************************************
bool TACVPCoinPay::IsStopped(int sound)
{
  if(sound >= 0 && sound < 7)
  {
    return PCoinWav[sound]->GetStopped();
  }
  return true;
}
//*******************************************************************
void TACVPCoinPay::StopAllSounds()
{
  for(int i=0;i<7;i++)
  {
    PCoinWav[i]->Stop();
  }
}
//*******************************************************************
void TACVPCoinPay::CoinSound(int sound)
{
  if(sound >= 0 && sound < 7);
  PCoinWav[sound]->Start();
}
//*******************************************************************
void TACVPCoinPay::PlayRegSound()
{
  CoinSound(6);
}
//*******************************************************************
