//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  acvpvlsp.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     7/19/96    M.Perry     moved into cpp file.
//  2.0    09/25/97    M.Perry     32-bit conversion.
//********************************************************************
#include "acvpvlsp.h"
#include "oanm.h"
#include "owav.h"
//*******************************************************************
void TACVPVertLite::SetupAnms()
{
  for(int16 i=0;i<13;i++)
  {
	 PWavs[i] = GetWav(i);
  }
  for(int16 i=0;i<5;i++)
  {
    PVertLite[i] = GetAnm(i);
    if(PVertLite[i] != NULL)
    {
      PVertLite[i]->CAD.ClearAutoStart();
      PVertLite[i]->CAD.ClearAutoStop();
      PVertLite[i]->CAD.SetDirStill();;
    }
  }
  int16 i=0;
  while(i<13 && PWavs[i] != NULL)
  {
	i++;
  }
  Rows = i;
}
//*******************************************************************
TACVPVertLite::TACVPVertLite(TOgleModeWindow *pmw,const TFileMode &NewFileMode)
:TSprite(pmw,NewFileMode)
{
  Rows = 0;
  NoShow();
  SetToManual();
  SetupAnms();
}
//*******************************************************************
TACVPVertLite::TACVPVertLite(TOgleModeWindow *pmw,const TFileMode &NewFileMode,void *psource)
:TSprite(pmw,NewFileMode,psource)
{
  Rows = 0;
  NoShow();
  SetToManual();
  SetupAnms();
}
//*******************************************************************
TACVPVertLite::~TACVPVertLite()
{
}
//*******************************************************************
void TACVPVertLite::ClearRows()
{
	 if (PVertLite[0] == NULL) {return;}
	 PVertLite[0]->NoShow();
    if (PVertLite[1] == NULL) {return;}
	 PVertLite[1]->NoShow();
    if (PVertLite[2] == NULL) {return;}
	 PVertLite[2]->NoShow();
    if (PVertLite[3] == NULL) {return;}
	 PVertLite[3]->NoShow();
    if (PVertLite[4] == NULL) {return;}
	 PVertLite[4]->NoShow();
}
//*******************************************************************
void TACVPVertLite::SetRow(int16 num)
{
  if (PVertLite[0] == NULL) {return;}

  PWavs[num]->Start();
  PVertLite[0]->CAD.SetCurrentFrame(num);
  PVertLite[0]->Show();

  Update(GetAdjFUC());
}
//*******************************************************************
int16 TACVPVertLite::GetCurFrame(int16 coinsIn)
{
  return PVertLite[coinsIn-1]->CAD.GetCurrentFrame();
}
//*******************************************************************
void TACVPVertLite::SetRow(int16 num,int16 coinsIn)
{
  if (PVertLite[0] == NULL) {return;}
  if (PVertLite[1] == NULL) {return;}
  if (PVertLite[2] == NULL) {return;}
  if (PVertLite[3] == NULL) {return;}
  if (PVertLite[4] == NULL) {return;}
  PWavs[num]->Start();
  switch(coinsIn)
  {
    case 1  : PVertLite[0]->CAD.SetCurrentFrame(num);
              PVertLite[0]->Show();
              PVertLite[1]->NoShow();PVertLite[3]->NoShow();
              PVertLite[2]->NoShow();PVertLite[4]->NoShow();
    case 2  : PVertLite[1]->CAD.SetCurrentFrame(num);
              PVertLite[1]->Show();
              PVertLite[0]->NoShow();PVertLite[3]->NoShow();
              PVertLite[2]->NoShow();PVertLite[4]->NoShow();
    case 3  : PVertLite[2]->CAD.SetCurrentFrame(num);
              PVertLite[2]->Show();
              PVertLite[1]->NoShow();PVertLite[3]->NoShow();
              PVertLite[0]->NoShow();PVertLite[4]->NoShow();
    case 4  : PVertLite[3]->CAD.SetCurrentFrame(num);
              PVertLite[3]->Show();
              PVertLite[1]->NoShow();PVertLite[0]->NoShow();
              PVertLite[2]->NoShow();PVertLite[4]->NoShow();
    case 5  : PVertLite[4]->CAD.SetCurrentFrame(num);
              PVertLite[4]->Show();
              PVertLite[1]->NoShow();PVertLite[3]->NoShow();
              PVertLite[2]->NoShow();PVertLite[0]->NoShow();
  }
  Update(GetAdjFUC());
}
//*******************************************************************