//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  acvpwdsp.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     7/19/96    M.Perry     moved into cpp file.
//  2.0    09/25/97    M.Perry     32-bit conversion.
//********************************************************************
#include "acvpwdsp.h"
#include "oanm.h"
#include "owav.h"
//*******************************************************************
void TACVPWheelDeal::SetupAnms()
{
//???	 PWavs[i] = GetWav(i);
  PWheel = GetAnm(0);
  PWheel->CAD.ClearAutoStart();
  PWheel->CAD.ClearAutoStop();
  PWheel->CAD.SetDirStill();;
 // int16 i=0;
  //while(i<13 && PWavs[i] != NULL)
  //{
  //	i++;
  //}
}
//*******************************************************************
TACVPWheelDeal::TACVPWheelDeal(TOgleModeWindow *pmw,const TFileMode &NewFileMode)
:TSprite(pmw,NewFileMode)
{
  NoShow();
  SetToManual();
  SetupAnms();
  multFrame = 0;
  delayFuc=0;
}
//*******************************************************************
TACVPWheelDeal::TACVPWheelDeal(TOgleModeWindow *pmw,const TFileMode &NewFileMode,void *psource)
:TSprite(pmw,NewFileMode,psource)
{
  NoShow();
  SetToManual();
  SetupAnms();
  multFrame = 0;
  delayFuc=0;
}
//*******************************************************************
TACVPWheelDeal::~TACVPWheelDeal()
{
}
//*******************************************************************
void TACVPWheelDeal::PostUpdate(dword NewFUC)
{
   if(delayFuc)
   {
     PWheel->CAD.SetCurrentFrame((PWheel->CAD.GetCurrentFrame()+1)%6);
     PWheel->Show();
     delayFuc--;
   }
	TSprite::PostUpdate(NewFUC);
}
//*******************************************************************
int16 TACVPWheelDeal::RollWheel()
{
    int diff=0;
    int rot=0;
    rot = random(10);
    if(rot < 1)
    {rot=0;}
    else if(rot<6)
    {rot=6;}
    else if(rot<8)
    {rot=12;}
    else
    {rot=18;}

    if (PWheel == NULL) {return -1;}
    if(multFrame >= currentFrame)
    {
      diff = multFrame-currentFrame;
    }
    else
    {
      diff = (6-currentFrame)+multFrame;
    }
    delayFuc = rot+diff;
	 return rot+diff;
}
//*******************************************************************
void TACVPWheelDeal::InitWheel(int16 num)
{
  if (PWheel == NULL) {return;}

  PWheel->CAD.SetCurrentFrame(num);
  PWheel->Show();
  multFrame = num;
  Update(GetAdjFUC());
}
//*******************************************************************
void TACVPWheelDeal::SetWheel(int16 num)
{
  if (PWheel == NULL) {return;}

  //PWavs[num]->Start();
  PWheel->CAD.SetCurrentFrame(num);
  PWheel->Show();

  Update(GetAdjFUC());
}
//*******************************************************************
int16 TACVPWheelDeal::SetMult()
{
  int16 multValue=0;
  int xx = random(100);
  currentFrame = multFrame;
  if(xx < 50)
  {multFrame = 0;}
  else if(xx < 75)
  {multFrame = 1;}
  else if(xx < 87)
  {multFrame = 2;}
  else if(xx < 93)
  {multFrame = 3;}
  else if(xx < 97)
  {multFrame = 4;}
  else
  {multFrame = 5;}

  switch(multFrame)
  {
    case 0 : multValue = 1;break;
    case 1 : multValue = 2;break;
    case 2 : multValue = 3;break;
    case 3 : multValue = 4;break;
    case 4 : multValue = 5;break;
    case 5 : multValue = 10;break;
  }
  return multValue;
}