//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  acvpwnst.cpp
//    Project Name:  Casino
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     09/29/95   A. Krist    Original baseline
//  2.0     09/25/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "acvpwsst.h"
#include "otimers.h"
#include "orespond.h"
//*******************************************************************
TACVPWinStudState::TACVPWinStudState(TACVPVPGLord *pNewVPLord)
:TVPLordState(pNewVPLord)
{
  SetRunOrder(ess_Execute,ess_Execute,ess_Done);
  wincount   = 0;
  SpeedClickResponder = NULL;
  wincountup = 0;
  showFlip = true;
  StartingFUC = 0;
}
//*******************************************************************
TACVPWinStudState::~TACVPWinStudState()
{
}
//*******************************************************************
void TACVPWinStudState::ExecuteFirstTime()
{
  ExecuteWaiting = true;
  ExecuteStatus    = ess_Execute;
  pOwnerLord->Responders[12]->Add();
  pOwnerLord->PreWinner();
  wincount = pOwnerLord->Winner();
  if(pOwnerLord->DoubleBet)
  {
    wincount *= 2;
  }
  if((int32)wincount)
  {
	 pOwnerLord->Button0->ShowVoidUp();
  }
  pOwnerLord->WinPaid->SetNum(0);
  pOwnerLord->Credits->SetNum(pOwnerLord->credits);
  pOwnerLord->CardSprite->ShowFlip(4);
  StartingFUC = pOwnerLord->GetAdjFUC();
}
//*******************************************************************
void TACVPWinStudState::EndSubState1()
{
  TState::EndSubState1();
}
//*******************************************************************
void TACVPWinStudState::CreateSubState1()
{
  PActiveSubState = new TACVPDoubleState(pOwnerLord);
}
//*******************************************************************
void TACVPWinStudState::HandlePostUpdate(dword NewFUC)
{
 if(showFlip)
 {
  if((StartingFUC + 1) >= NewFUC)
  {
     pOwnerLord->CardSprite->ShowFace(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->cards[4].suit,
         pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->cards[4].name,4);
     showFlip = false;
  }
 }
 else
 {
  if (SpeedClickResponder != NULL)
  {
    if (SpeedClickResponder->GetResponseEvent() != reChar)
    {
  	   SpeedClickResponder->ClearPriority();
    }
	 wincountup += wincount;
	 pOwnerLord->credits += wincount;
	 wincount = 0;
	 pOwnerLord->WinPaid->SetNum(wincountup);
	 pOwnerLord->Credits->SetNum(pOwnerLord->credits);
	 ExecuteWaiting = false;
	 pOwnerLord->Button1->ShowVoidUp();
	 pOwnerLord->Button2->ShowVoidUp();
	 pOwnerLord->Button3->ShowGray();
	 SpeedClickResponder = NULL;
	 return;
  }
  if (wincount > 0)
  {
	 if(wincount < pOwnerLord->coinsplayed)
	 {
		wincountup          += wincount;
		pOwnerLord->credits += wincount;
		wincount             = 0;
	 }
	 else
	 {
		wincount   -= pOwnerLord->coinsplayed;
		wincountup += pOwnerLord->coinsplayed;
		pOwnerLord->credits += pOwnerLord->coinsplayed;
	 }
	 pOwnerLord->WinPaid->SetNum(wincountup);
	 pOwnerLord->Credits->SetNum(pOwnerLord->credits);
  }
  else
  {
	 ExecuteWaiting = false;
	 pOwnerLord->Button1->ShowVoidUp();
	 pOwnerLord->Button2->ShowVoidUp();
	 pOwnerLord->Button3->ShowGray();

  }
 }
 if(NewFUC){return;}
}
//*******************************************************************
bool TACVPWinStudState::HandleSpeedClick(TResponder &responder)
{
  if (responder.GetResponseEvent() == reRUp)
  {
	 SpeedClickResponder = &responder;
  }

  if (responder.GetResponseEvent() == reRDown)
  {
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
	 SpeedClickResponder = &responder;
  }
  return true;
}
//*******************************************************************