//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  acvpwtst.cpp
//    Project Name:  Casino
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     09/29/95   A. Krist    Original baseline
//  2.0     09/25/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "acvpwtst.h"
#include "otimers.h"
#include "orespond.h"
//*******************************************************************
TACVPWinTripleState::TACVPWinTripleState(TACVPVPGLord *pNewVPLord)
:TVPLordState(pNewVPLord)
{
  SetRunOrder(ess_Execute,ess_Execute,ess_Done);
  wincount      = 0;
  wincountTop   = 0;
  wincountMid   = 0;
  wincountTotal   = 0;
  SpeedClickResponder = NULL;
  wincountup = 0;
  tempWin = 0;
}
//*******************************************************************
TACVPWinTripleState::~TACVPWinTripleState()
{
}
//*******************************************************************
void TACVPWinTripleState::ExecuteFirstTime()
{
  ExecuteWaiting = true;
  ExecuteStatus    = ess_Execute;
  pOwnerLord->Responders[12]->Add();
  pOwnerLord->PreWinner();
  pOwnerLord->pSmarts->Holding(pOwnerLord->TripTopHand);
  pOwnerLord->pSmarts->Holding(pOwnerLord->TripMidHand);

  wincountTotal = pOwnerLord->Winner();
  wincountTop   = pOwnerLord->WinnerTop();
  wincountMid   = pOwnerLord->WinnerMid();
  wincount = wincountTotal+wincountTop+wincountMid;
  if((int32)wincount)
  {
	 pOwnerLord->Button0->ShowVoidUp();
  }
  pOwnerLord->WinPaid->SetNum(0);
  pOwnerLord->WinPaidTop->SetNum(wincountTop);
  pOwnerLord->WinPaidMid->SetNum(wincountMid);
  pOwnerLord->WinPaidBot->SetNum(wincountTotal);
  pOwnerLord->Credits->SetNum(pOwnerLord->credits);
}
//*******************************************************************
void TACVPWinTripleState::HandlePostUpdate(dword NewFUC)
{

  if (SpeedClickResponder != NULL)
  {
    if (SpeedClickResponder->GetResponseEvent() != reChar)
    {
  	   SpeedClickResponder->ClearPriority();
    }
	 wincountup += wincount;
	 pOwnerLord->credits += wincount;
	 wincount = 0;
	 pOwnerLord->WinPaid->SetNum(wincountup);
	 pOwnerLord->Credits->SetNum(pOwnerLord->credits);
	 ExecuteWaiting = false;
	 pOwnerLord->Button1->ShowVoidUp();
	 pOwnerLord->Button2->ShowVoidUp();
	 pOwnerLord->Button3->ShowGray();
	 SpeedClickResponder = NULL;
	 return;
  }
  if (wincount > 0)
  {
	 if(NewFUC%2==0)
    {
      if(NewFUC%4==0)
      {
        pOwnerLord->Title->Show();
      }
      else
      {
        pOwnerLord->Title->NoShow();
      }
    }
    if(wincount < pOwnerLord->coinsplayed)
	 {
		wincountup          += wincount;
		pOwnerLord->credits += wincount;
		wincount             = 0;
	 }
	 else
	 {
		wincount   -= pOwnerLord->coinsplayed;
		wincountup += pOwnerLord->coinsplayed;
		pOwnerLord->credits += pOwnerLord->coinsplayed;
	 }
	 pOwnerLord->WinPaid->SetNum(wincountup);
	 pOwnerLord->Credits->SetNum(pOwnerLord->credits);
  }
  else
  {
	 ExecuteWaiting = false;
	 pOwnerLord->Button1->ShowVoidUp();
	 pOwnerLord->Button2->ShowVoidUp();
	 pOwnerLord->Button3->ShowGray();

  }
  if(NewFUC){return;}
}
//*******************************************************************
bool TACVPWinTripleState::HandleSpeedClick(TResponder &responder)
{
  if (responder.GetResponseEvent() == reRUp)
  {
	 SpeedClickResponder = &responder;
  }

  if (responder.GetResponseEvent() == reRDown)
  {
	 responder.SetPriority();
  }

  if (responder.GetResponseEvent() == reChar)
  {
	 SpeedClickResponder = &responder;
  }
  return true;
}
//*******************************************************************