//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  cvpcrdsp.cpp
//    Project Name:  Casino
// Original Author:  Adam Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     7/19/96    M.Perry    moved into cpp file.
//  2.0    09/27/97    M.Perry    32-bit conversion.
//********************************************************************
#include "vp5crdsp.h"
#include "oanm.h"
#include "owav.h"
//*******************************************************************
void TVP5Card::SetupWavs()
{
  for(int16 i=0;i<5;i++)
  {
	 PFlipSound[i] = GetWav(i);
	 if (PFlipSound[i] == NULL) {AnmError("Card5 Sprite","FlipSound",i);}
  }
  PHoldSound = GetWav(5);
 //??? if (PHoldSound == NULL) {AnmError("Card5 Sprite","HoldSound",0);}
}
//*******************************************************************
void TVP5Card::SetupAnms()
{
  for(int16 i=0;i<5;i++)
  {
	 PCard[i] = GetAnm(i);
	 if (PCard[i] == NULL) {AnmError("Card5 Sprite","Card",i);}
     PCard[i]->NoShow();
    PCard[i]->CAD.ClearAutoStart();
    PCard[i]->CAD.ClearAutoStop();
    PCard[i]->CAD.SetDirStill();

    PHold[i] = GetAnm(i+5);
	 if (PHold[i] != NULL)//??? {AnmError("Card5 Sprite","Hold",i);}
    {
      PHold[i]->NoShow();
      PHold[i]->CAD.ClearAutoStart();
      PHold[i]->CAD.ClearAutoStop();
      PHold[i]->CAD.SetDirStill();
    }
    ShowBack(i);
  }
}
//*******************************************************************
TVP5Card::TVP5Card(TOgleModeWindow *pmw,const TFileMode &NewFileMode)
:TSprite(pmw,NewFileMode)
{
  SetToManual();
  NoShow();
  SetupAnms();
  SetupWavs();
}
//*******************************************************************
TVP5Card::TVP5Card(TOgleModeWindow *pmw,const TFileMode &NewFileMode,void *psource)
:TSprite(pmw,NewFileMode,psource)
{
  SetToManual();
  NoShow();
  SetupAnms();
  SetupWavs();
}
//*******************************************************************
TVP5Card::~TVP5Card()
{
}
//*******************************************************************
void TVP5Card::SetBack()
{
  //???PCard[card]->NoShow();
  for(int i=0;i<5;i++)
  {
    PCard[i]->CAD.SetCurrentFrame(0);
    PCard[i]->Show();
  }
  Update(GetAdjFUC());
}
//*******************************************************************
void TVP5Card::ShowBack(int card)
{
  //???PCard[card]->NoShow();
  PCard[card]->CAD.SetCurrentFrame(0);
  PCard[card]->Show();
  Update(GetAdjFUC());
}
//*******************************************************************
void TVP5Card::ShowSilentFlip(int card)
{
  PCard[card]->CAD.SetCurrentFrame(1);
  PCard[card]->Show();
  Update(GetAdjFUC());
}
//*******************************************************************
void TVP5Card::ShowFlip(int card)
{
  PCard[card]->CAD.SetCurrentFrame(1);
  PCard[card]->Show();
  PFlipSound[card]->Start();
  Update(GetAdjFUC());
}
//*******************************************************************
void TVP5Card::Hold(bool held,int card)
{
  if (held)
  {
    PHold[card]->Show();
  }
  else
  {
    PHold[card]->NoShow();
  }
  if(PHoldSound != NULL){PHoldSound->Start();}
  Update(GetAdjFUC());
}
//*******************************************************************
void TVP5Card::ShowFace(TSuit suit,TCardName cardname,int card)
{
	 int16 num = 0;
	 if (PCard[card] == NULL) {return;}

	//??? if (cardname > Joker) {return;}
	 if (suit > Spade) {return;}
	 if (cardname == AceHi) {cardname = AceLo;}

	 if (cardname == Joker)
	 {
		num = 54;
	 }
	 else
	 {
		num = int16((suit * 13) + cardname+2);//+2 => back and flip frame
	 }

	 PCard[card]->CAD.SetCurrentFrame(num);
    PCard[card]->Show();

    Update(GetAdjFUC());
}
//*******************************************************************

