//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  acvplmw.cpp
//    Project Name:  acvp
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  2.5    10/14/99    M.Perry    original baseline
//********************************************************************
#include "acvplmw.h"

#include "acvplgld.h" 
#include "clplay.h" //??? change to acvplplr.h later

#include "acvpmenu.rh"
#include "cplaymgr.h"
#include "ogamefw.h"
#include "acvpname.rh"
#include "cdebtdlg.h"
//#include "hscred.rh"
#include "acvpcred.rh"
#include "osndmgr.h"
//*******************************************************************
DEFINE_RESPONSE_TABLE1(TACVPLobbyModeWin,TLobbyModeWin)
  EV_COMMAND(CM_OPTIONS_LOBBY_CASINOCREDIT,CmCreditLine),
  EV_COMMAND_ENABLE(CM_OPTIONS_LOBBY_CASINOCREDIT,CeCreditLine),
END_RESPONSE_TABLE;
//*******************************************************************
TACVPLobbyModeWin::TACVPLobbyModeWin(string modename,TPal *PPal,string title)
:TLobbyModeWin(modename,PPal,title),
 ModeSubGameType(clACVPLobby),
 ModeDenomID(TMoney::did_0_25),
 idsGameLord(0),
 idsHuman0(0)
{
  EnableCredits = true; //??? change to true after bmp added to rc's.
  EnableGiftShop = false;
  fCheckPaydays = true;
}
//*******************************************************************
TACVPLobbyModeWin::~TACVPLobbyModeWin()
{
}
//*******************************************************************
int TACVPLobbyModeWin::GetCreditsBmpID()
{
//  return 0;//IDB_HSLOTS_CREDITS;
  return IDB_ACVP_CREDITS;
}
//*******************************************************************
string TACVPLobbyModeWin::GetDetName()
{
  return string("z1.det");
}
//*******************************************************************
int TACVPLobbyModeWin::GetMenuID()
{
  return IDM_ACVP_LOBBY;
}
//*******************************************************************
void TACVPLobbyModeWin::Update(dword fuc)
{
  TLobbyModeWin::Update(fuc);
  if ((fCheckPaydays) ||    // check first time thru and every resume updates.
      ((fuc % 360) == 0))   // and about every minute.
  {
    fCheckPaydays = false;
    GetCasPlayerMgr()->CheckActivePaydays();
  }
}
//*******************************************************************
void TACVPLobbyModeWin::ResumeUpdates()
{
  TLobbyModeWin::ResumeUpdates();
  fCheckPaydays = true;  // wait until next fuc to do our thing.
}
//*******************************************************************
void TACVPLobbyModeWin::CmCreditLine()
{
  int16 slotnum = GetCasGameLord()->GetActivePlayer();
  TCasinoPlayerData *pdat = GetCasPlayerMgr()->GetActiveCasinoPlayerDataPtr(slotnum);
  if (pdat == NULL) {return;}
  bool waspaused = GetUpdatePause();
  SetUpdatePause();
  GetSoundMgr()->Stop(true);

  TGamblerDebtDlg *pgdd = new TGamblerDebtDlg(this,pdat);
  pgdd->Execute();
  delete pgdd;

  if (!waspaused) {ClearUpdatePause();}

  GetCasGameLord()->NotifyPlayerCashChange(slotnum);
}
//*******************************************************************
void TACVPLobbyModeWin::CeCreditLine(TCommandEnabler &ce)
{
  int16 slotnum = GetCasGameLord()->GetActivePlayer();
  TCasinoPlayerData *pdat = GetCasPlayerMgr()->GetActiveCasinoPlayerDataPtr(slotnum);
  ce.Enable(bool(pdat != NULL));
}
//*******************************************************************
void TACVPLobbyModeWin::SetupGObjIDS()
{
  if (GObjIDSInitialized) {return;}

  TLobbyModeWin::SetupGObjIDS();  //call up chain.

  idsGameLord = IDS_GL_ACVP_LOBBY;
  idsHuman0 = IDS_H0_ACVP_LOBBY;
}
//*******************************************************************
void TACVPLobbyModeWin::SetupGObjStrings()
{
  if (GObjStringsInitialized) {return;}

  TLobbyModeWin::SetupGObjStrings();

  strGameLord = GetResString(idsGameLord);

  if (idsHuman0 > 0)
  {
    strHuman0 = GetResString(idsHuman0);
  }
}
//*******************************************************************
TGameObject *TACVPLobbyModeWin::CreateGObj(TFileMode &fm,int16 id,void *psource)
{
  #if defined(OGLE_DEBUG_GOBJ)
  if (psource != NULL)
  {
    ::MessageBox(NULL,
                 "param->psource != NULL",
                 "Warning! TACVPLobbyModeWin::CreateGObj()",
                 MB_OK | MB_TASKMODAL);
  }

  if (!GObjInfoInitialized)
  {
    ::MessageBox(NULL,
                 "GObjInfoInitialized == false",
                 "Warning! TACVPLobbyModeWin::CreateGObj()",
                 MB_OK | MB_TASKMODAL);
  }

  if (!TMoney().CheckDenomID(ModeDenomID))
  {
    ::MessageBox(NULL,
                 "Invalid denomination",
                 "Error! TACVPLobbyModeWin::CreateGObj()",
                 MB_OK | MB_TASKMODAL);
  }

  if (fm == strGameLord && pLord != NULL)
  {
    ::MessageBox(NULL,
                 "GameLord already created",
                 "Error! TACVPLobbyModeWin::CreateGObj()",
                 MB_OK | MB_TASKMODAL);
  }

  if (fm == strHuman0 && GObj[0] != NULL)
  {
    ::MessageBox(NULL,
                 "Human already created",
                 "Error! TACVPLobbyModeWin::CreateGObj()",
                 MB_OK | MB_TASKMODAL);
  }
  #endif

  if (fm == strHuman0)
  {
    GObj[0] = new TCasinoLPlayer(this,fm,0);
    return GObj[0];
  }
  else if (fm == strGameLord && pLord == NULL)
  {
    pLord = new TACVPLobbyGameLord(this,fm,clACVPLobby,TMoney::did_100_00);
    return pLord;
  }
  else
  {
    #if defined(OGLE_DEBUG_GOBJ)
    string s = "gobj failed match:";
    s += fm.Name.GetStr();
    s += "\nCreating default TGameObject";
    s += "\nstrGameLord:";
    s += strGameLord;
    ::MessageBox(NULL,s.c_str(),"Warning! TACVPLobbyModeWin::CreateGObj()",MB_OK | MB_TASKMODAL);
    #endif
    // if all else fails, then create a generic gobj.
    return new TGameObject(this,fm);
  }
}
//*******************************************************************
