//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  acvpsgld.cpp
//    Project Name:  acvp
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  2.5    10/14/99    M.Perry     Original baseline
//*******************************************************************
#include "acvpsgld.h"
#include "acvsmst.h"
#include "ostate.h"
#include <time.h>   //To Set Random Number Generator
#include <stdlib.h> //For Random Number Generator
#include "oskitcat.h"
#include "expert.h"
#include "cplaymgr.h"
#include "casapp.h"
#include "owl\inputdia.h"
#include "orespond.h"
#include "oanm.h"
#include "cas_cm.rh"
#include <stdio.h>
#include "hsmsg.h" //actually TBankruptMsgDlg class.
#include "acvpsmw.h"
#include "acvp_cm.rh"
#include "acvpname.rh"
//*******************************************************************
string GetAppString(int16 ids)
{
  return TAppString(ids);
}
//*******************************************************************
void TACVPSlotsGameLord::SetUIDS()
{
  switch (SubGameType)
  {
    case cslCrystalPalace: idsSounds = IDS_MS_SOUNDS_ACVP_SLOTS_CRYSTALPALACE;
                           idsCoinPay = IDS_MS_COINPAY_ACVP_SLOTS_CRYSTALPALACE;
                           idsNP1 = IDS_MS_NP1_ACVP_SLOTS_CRYSTALPALACE;
                           idsCoinsPlayed = IDS_MS_COINSPLAYED_ACVP_SLOTS_CRYSTALPALACE;
                           idsCredits = IDS_MS_CREDITS_ACVP_SLOTS_CRYSTALPALACE;
                           idsWinPaid = IDS_MS_WINPAID_ACVP_SLOTS_CRYSTALPALACE;
                           idsButton0 = IDS_MS_B0_ACVP_SLOTS_CRYSTALPALACE;
                           idsButton1 = IDS_MS_B1_ACVP_SLOTS_CRYSTALPALACE;
                           idsButton2 = IDS_MS_B2_ACVP_SLOTS_CRYSTALPALACE;
                           idsButton3 = IDS_MS_B3_ACVP_SLOTS_CRYSTALPALACE;
                           idsButton4 = IDS_MS_B4_ACVP_SLOTS_CRYSTALPALACE;
                           idsButton5 = IDS_MS_B5_ACVP_SLOTS_CRYSTALPALACE;
                           idsButton6 = IDS_MS_B6_ACVP_SLOTS_CRYSTALPALACE;
                           idsButton7 = IDS_MS_B7_ACVP_SLOTS_CRYSTALPALACE;
                           idsBankCash = IDS_MS_BANKCASH_ACVP_SLOTS_CRYSTALPALACE;
                           break;
    case cvpBlackJacks:    idsSounds = IDS_MS_SOUNDS_ACVP_SLOTS_SUPERSEVENS;
                           idsCoinPay = IDS_MS_COINPAY_ACVP_SLOTS_SUPERSEVENS;
                           idsNP1 = IDS_MS_NP1_ACVP_SLOTS_SUPERSEVENS;
                           idsCoinsPlayed = IDS_MS_COINSPLAYED_ACVP_SLOTS_SUPERSEVENS;
                           idsCredits = IDS_MS_CREDITS_ACVP_SLOTS_SUPERSEVENS;
                           idsWinPaid = IDS_MS_WINPAID_ACVP_SLOTS_SUPERSEVENS;
                           idsButton0 = IDS_MS_B0_ACVP_SLOTS_SUPERSEVENS;
                           idsButton1 = IDS_MS_B1_ACVP_SLOTS_SUPERSEVENS;
                           idsButton2 = IDS_MS_B2_ACVP_SLOTS_SUPERSEVENS;
                           idsButton3 = IDS_MS_B3_ACVP_SLOTS_SUPERSEVENS;
                           idsButton4 = IDS_MS_B4_ACVP_SLOTS_SUPERSEVENS;
                           idsButton5 = IDS_MS_B5_ACVP_SLOTS_SUPERSEVENS;
                           idsButton6 = IDS_MS_B6_ACVP_SLOTS_SUPERSEVENS;
                           idsButton7 = IDS_MS_B7_ACVP_SLOTS_SUPERSEVENS;
                           idsBankCash = IDS_MS_BANKCASH_ACVP_SLOTS_SUPERSEVENS;
                           break;
    default:break;
  }
}
//*******************************************************************
void TACVPSlotsGameLord::SetUIDSStrings()
{
  strSounds      = GetAppString(idsSounds);
  strCoinPay     = GetAppString(idsCoinPay);
  strNP1         = GetAppString(idsNP1);
  strCoinsPlayed = GetAppString(idsCoinsPlayed);
  strCredits     = GetAppString(idsCredits);
  strWinPaid     = GetAppString(idsWinPaid);
  strButton0     = GetAppString(idsButton0);
  strButton1     = GetAppString(idsButton1);
  strButton2     = GetAppString(idsButton2);
  strButton3     = GetAppString(idsButton3);
  strButton4     = GetAppString(idsButton4);
  strButton5     = GetAppString(idsButton5);
  strButton6     = GetAppString(idsButton6);
  strButton7     = GetAppString(idsButton7);
  strBankCash    = GetAppString(idsBankCash);
  strValue       = GetAppString(idsValue);
}
//*******************************************************************
void TACVPSlotsGameLord::SetReel()
{
  int16 w,x,y;//,z;
  w = int16(random(GetReelDataPtr()->Getint16(1,21)));
  x = int16(random(GetReelDataPtr()->Getint16(2,21)));
  y = int16(random(GetReelDataPtr()->Getint16(3,21)));

  for (int16 i1=0;i1<=21;i1++)
  {
    if (w <= GetReelDataPtr()->Getint16(1,i1))
    {
      w = i1;
      break;
    }
  }


  for (int16 i2=0;i2<=21;i2++)
  {
    if (x <= GetReelDataPtr()->Getint16(2,i2))
    {
      x = i2;
      break;
    }
  }


  for (int16 i3=0;i3<=21;i3++)
  {
    if (y <= GetReelDataPtr()->Getint16(3,i3))
    {
      y = i3;
      break;
    }
  }

  #if defined(ACVP_DEBUG_SLOTREELS)
  PModeWin->SetUpdatePause();
  char buffer[50];
  itoa(w,buffer,10);
  TInputDialog id1(PModeWin,"0-21","# for reel 1",buffer,3);
  id1.Execute();
  w = int16(atoi(buffer));
  if (w < 0 || w >= 22)
  {
    w = 0;
  }

  itoa(x,buffer,10);
  TInputDialog id2(PModeWin,"0-21","# for reel 2",buffer,3);
  id2.Execute();
  x = int16(atoi(buffer));
  if (x < 0 || x >= 22)
  {
    x = 0;
  }

  itoa(y,buffer,10);
  TInputDialog id3(PModeWin,"0-21","# for reel 3",buffer,3);
  id3.Execute();
  y = int16(atoi(buffer));
  if (y < 0 || y >= 22)
  {
    y = 0;
  }
  PModeWin->ClearUpdatePause();
  #endif

  PReel1->SetNum(w);
  PReel2->SetNum(x);
  PReel3->SetNum(y);
}
//*******************************************************************
int16 TACVPSlotsGameLord::PayOut()
{
  return PayLine1();
}
//*******************************************************************
int16 TACVPSlotsGameLord::GetReelDataint16(int16 index)
{
  int16 retvalue = 0;
  if (index >= 0 && index <= 21)
  {
    retvalue = GetReelDataPtr()->Getint16(/*11*/4,index);
  }
  return retvalue;
}
//*******************************************************************
void TACVPSlotsGameLord::SetupSprites()
{
//  Song = GetSpriteIndex("\\a1glrd00\\a100song.sp");

//  if (PSong == NULL)
//  {
//     #if defined(ACVP_DEBUG_SPRITES)
//     ::MessageBox(NULL,
//                  "Rich,this is Mike, do I get a Song sprite?",
//                  "Warning! Missing Sprite!",
//                  MB_OK | MB_TASKMODAL);
////     #else
////     SpriteError("Slots Song","Song");
//     #endif
//  }

  if (PSounds  == NULL) {SpriteError("Slots Sounds","sounds");}
  PSounds->Start(GetFUC());

  if (PColumn == NULL)
  {
//    #if defined(ACVP_DEBUG_SPRITES)
//    ::MessageBox(NULL,
//                 "Rich, this is Mike, do I get a column sprite?",
//                 "Warning! Missing Sprite",
//                 MB_OK | MB_TASKMODAL);
//    #endif
  }
  if (PValue           == NULL) {SpriteError("Value","value");}
  if (PPayLine         == NULL) {SpriteError("PayLine","line");}
  if (PCoinsPlayed     == NULL) {SpriteError("Coins Played Nums","cp00");}
  if (PWinPaid         == NULL) {SpriteError("Win Paid Nums","wp00");}
  if (PCredits         == NULL) {SpriteError("Credits Nums","cr00");}
  if (PReel1           == NULL) {SpriteError("Reel1","rel1");}
  if (PReel2           == NULL) {SpriteError("Reel2","rel2");}
  if (PReel3           == NULL) {SpriteError("Reel3","rel3");}

  if (PBankCashDisplay == NULL)    {SpriteError("BankCashDisplay","bank");}
  if (PButtons[0] == NULL)       {SpriteError("Button0","cash");}

//  if (PButtons[1] == NULL)
//  {
//    #if defined(ACVP_DEBUG_SPRITES)
//    ::MessageBox(NULL,
//               "Rich, this is Mike,Do I get an add 50 credits sprite?",
//               "Warning! Missing Sprite!",
//               MB_OK | MB_TASKMODAL);
////    #else
////    SpriteError("Button1","addc");
//    #endif
//  }
  if (PButtons[2] == NULL)       {SpriteError("Button2","menu");}
  if (PButtons[3] == NULL)       {SpriteError("Button3","bet1");}
  if (PButtons[4] == NULL)       {SpriteError("Button4","betm");}
  if (PButtons[5] == NULL)       {SpriteError("Button5","spin");}
  if (PButtons[6] == NULL)       {SpriteError("Button6","lobby");}
  if (PButtons[7] == NULL)       {SpriteError("Button7","help");}
  if (PCoinPay       == NULL)    {SpriteError("CoinPay","fall");}
  if (PNamePlate1 == NULL)       {SpriteError("NamePlate1","name");}
  PCoinsPlayed->Start(GetFUC());
  PPayLine->Start(GetFUC());
  PValue->Start(GetFUC());
  PCredits->Start(GetFUC());
  PWinPaid->Start(GetFUC());
  if (PColumn != NULL)
  {
    ActivateSpriteNow(PColumn);
    PColumn->NoShow();
  }
  if(PWinHighLight)
  {
	 ActivateSpriteNow(PWinHighLight);
    PWinHighLight->NoShow();
  }
  ActivateSpriteNow(PReel1);
  ActivateSpriteNow(PReel2);
  ActivateSpriteNow(PReel3);
  PCoinPay->Start(GetFUC());
  PBankCashDisplay->Start(GetFUC());
  for (int16 i=0;i<NumButtons;i++)
  {
    if (PButtons[i] != NULL)
    {
      if (i == 2 && !GetFW()->GetHandleShowMenu())
      {
         PButtons[2]->PButtonResponder->Remove();
      }
      else
      {
        ActivateSpriteNow(PButtons[i]);
      }
    }
  }

  PNamePlate1->Start(GetFUC());
  PValue->SetDenom(coinsize);
}
//*******************************************************************
void TACVPSlotsGameLord::CleanupSprites()
{
}
//*******************************************************************
bool TACVPSlotsGameLord::Respond(TResponder &responder)
{
  if (PState == NULL) {return true;}

  switch (responder.GetID())
  {
	 case acvpsidAddCoins:
          return GetState()->AddCoin(responder);
	 case acvpsidSpeedClick:
          if(IsCycle)  //???
			 {
				SwitchDenom(Denom[CurrentDenomNum]);// IsCycle set to false in SwitchDenom()
				GetFW()->NotifyDenomSwitch(coinsize);
				return false;
          }
          return GetState()->SpeedClick(responder);
	 case acvpsidDenom:
          if(ChangeActivePlayersOk)
			 {
			   if(responder.GetResponseEvent() == reLUp)
				{
				  IsCycle = false;
				  CycleDenom();
//				  GameDenom = coinsize;
				  GetFW()->NotifyDenomSwitch(coinsize);
				  IsCycle = true;
            }
          }
          return true;
	 default:return true;
  }
}
//*******************************************************************
void TACVPSlotsGameLord::SetupResponders()
{
//  TRect r0(543,370,617,393);
  TRect r0(556,412,612,429);
//  TCursorData curdata0(0,0);

  TRect r1(17,246,88,390);
  TCursorData curdata1(GetOgleApp(),ID_POINTING_FINGER_CURSOR);

  TRect r2(5,5,635,475);
  TCursorData curdata2(0,0);

  Responders[0] = new TResponder(PModeWin,100,r0,acvpsidAddCoins,this,true,'~',curdata1);
  Responders[1] = new TResponder(PModeWin,300,r1,acvpsidDenom,this,true,'~',curdata1);
  Responders[2] = new TResponder(PModeWin,200,r2,acvpsidSpeedClick,this,true,'^',curdata2);
}
//*******************************************************************
//ctor
TACVPSlotsGameLord::TACVPSlotsGameLord(TACVPSlotsModeWin *pmwin,const TFileMode &fm,
                                       int16 subgametype,int16 did)
:TCasinoGameLord(pmwin,fm,subgametype,did)
{
//  Song = -1;
  PSong = NULL;
  PState = new TACVPSlotsLordMainState(this);

  shutdownstate = 0;
  credits = 0l;
  coinsize = GameDenom; //mrp - v2.5 - 09/29/99
//  r1=0;
//  r2=0;
//  r3=0;
  activeplayer = 0;
//  machinenum = 0;
//  playersin=0;
  coinsplayed = 0l;
  winnerpaid = 0l;
  WinningCombo = -1;
  ButtonInfo = 0;
  for(int16 i=0;i<NumButtons;i++)
  {
	 ButtonHit[i] = false;
  }

  if (subgametype == cslCrystalPalace)
  {
    maxbet = 2;
  }
  else
  {
    maxbet = 5;
  }

  for(int16 i=0;i<TMoney::did_NumIDs;i++)
  {
	 Denom[i] = 0.0;
  }
  if (subgametype == cslCrystalPalace)
  {
    Denom[0] = (double)0.25;
    Denom[1] = (double)1.0;
    Denom[2] = (double)10.0;
    Denom[3] = (double)100.0;
    Denom[4] = (double)1000.0;
  }
  else //cslSuperSevens
  {
    Denom[0] = (double)0.05;
    Denom[1] = (double)0.25;
    Denom[2] = (double)1.0;
    Denom[3] = (double)25.0;
    Denom[4] = (double)500.0;
  }
  NumOfDenoms = 5;

  if (subgametype == cslCrystalPalace)
  {
    switch (GameDenom.GetDenomID())
    {
      case TMoney::did_0_25:CurrentDenomNum = 0;break;
      case TMoney::did_1_00:CurrentDenomNum = 1;break;
      case TMoney::did_10_00:CurrentDenomNum = 2;break;
      case TMoney::did_100_00:CurrentDenomNum = 3;break;
      case TMoney::did_1000_00:CurrentDenomNum = 4;break;
      default:CurrentDenomNum = -1;break;
    }
  }
  else // cslSuperSevens
  {
    switch (GameDenom.GetDenomID())
    {
      case TMoney::did_0_05:CurrentDenomNum = 0;break;
      case TMoney::did_0_25:CurrentDenomNum = 1;break;
      case TMoney::did_1_00:CurrentDenomNum = 2;break;
      case TMoney::did_25_00:CurrentDenomNum = 3;break;
      case TMoney::did_500_00:CurrentDenomNum = 4;break;
      default:CurrentDenomNum = -1;break;
    }
  }
  //start of winning combo setup
  for (int16 i=0;i<wcCrystalNumCombos;i++)
  {
    for (int16 j=0;j<6;j++)
    {
      CrystalPalaceWC[i][j] = 0.0;
      Super7WC[i][j] = 0.0;
    }
  }

  CrystalPalaceWC[wc1ofCrystalCherry][1] = 2;
  CrystalPalaceWC[wc2ofCrystalCherry][1] = 4;
  CrystalPalaceWC[wc3ofXCrystalBar][1] = 4;
  CrystalPalaceWC[wc3ofCrystalCherry][1] = 10;
  CrystalPalaceWC[wc3of1CrystalBar][1] = 10;
  CrystalPalaceWC[wc3of2CrystalBar][1] = 20;
  CrystalPalaceWC[wc3of3CrystalBar][1] = 30;
  CrystalPalaceWC[wc3ofCrystal7][1] = 50;
  CrystalPalaceWC[wc3ofBigCrystal][1] = 100;
  CrystalPalaceWC[wc3ofHugeCrystal][1] = 1500;
  for (int16 i = 0;i<wcCrystalNumCombos;i++)
  {
    CrystalPalaceWC[i][2] = int16(CrystalPalaceWC[i][1] * 2);
  }
  CrystalPalaceWC[wc3ofHugeCrystal][2] = 3200;

  Super7WC[wc1of1Cherry][1] = 1;
  Super7WC[wc2of1Cherry][1] = 3;
  Super7WC[wc1of2Cherry][1] = 2;
  Super7WC[wc1of1CherryAnd1of2Cherry][1] = 3;
  Super7WC[wc2of1CherryAnd1of2Cherry][1] = 5;
  Super7WC[wc2of2Cherry][1] = 10;
  Super7WC[wc1of1CherryAnd2of2Cherry][1] = 11;
  Super7WC[wc3of1Cherry][1] = 20;
  Super7WC[wc3of2Cherry][1] = 30;
  Super7WC[wc3ofXBar][1] = 20;
  Super7WC[wc3of1Bar][1] = 100;
  Super7WC[wc3of2Bar][1] = 200;
  Super7WC[wc3of3Bar][1] = 1500;
  Super7WC[wc3ofSuper7][1] = 5000;
  for (int16 i = 0;i<wcSuper7NumCombos;i++)
  {
    for (int16 j = 2;j<6;j++)
    {
      Super7WC[i][j] = int16(Super7WC[i][1] * j);
    }
  }
  Super7WC[wc3ofSuper7][5] = 27500; // special bonus.
  // end of winning combo setup

  PColumn = NULL;
  PSounds  = NULL;
  PValue   = NULL;
  PPayLine = NULL;
  for (int16 i=0;i<NumButtons;i++)
  {
    PButtons[i] = NULL;
  }
  PBankCashDisplay = NULL;
  PCoinPay         = NULL;
  PReel1           = NULL;
  PReel2           = NULL;
  PReel3           = NULL;
  PCoinsPlayed     = NULL;
  PWinPaid         = NULL;
  PCredits         = NULL;
  PNamePlate1      = NULL;
  PWinHighLight    = NULL;

//  PayOffSound = -1;
  IsCycle = false;
  IsMultiPayline = false;
//  Multiplier = 1;

//  HoldMultiplier = false;
  BetMaxNumOfCredits = 0;
  BetMaxNumOfCoins = 0;
  BMNumOfCredits = false;
  BMNumOfCoins = false;
  MaxOnly = false;

  strBankruptTitle = "Bankrupt";

  strPlayCheaperCreditYes = "You do not have enough money to play this slot machine.";
  strPlayCheaperCreditYes += " You can either select a more affordable slot machine, or perhaps";
  strPlayCheaperCreditYes += " you would like to visit the Casino Credit department and take out a loan.";
  strPlayCheaperCreditYes += "\nTo get casino credit, return to the lobby and select Casino Credit from the Options menu.";

  strPlayCheaperCreditNo = "You do not have enough money to play this slot machine.";
  strPlayCheaperCreditNo += " Unfortunately, you have no more Casino Credit available.";
  strPlayCheaperCreditNo += " You must either select a less expensive slot machine or create a new gambler.";
  strPlayCheaperCreditNo += "\nTo create a new gambler, select Create/Delete gambler from the File menu.";

  strBrokeCreditYes = "You're so poor that you can't even afford to play a nickel slot.";
  strBrokeCreditYes += " You can either take a loan from the Casino Credit department or create a new gambler";
  strBrokeCreditYes += "\nTo get casino credit, select Casino Credit from the Lobby Options menu.";
  strBrokeCreditYes += "\nTo create a new gambler, select Create/Delete Gambler from the File menu.";

  strBrokeCreditNo = "You've hit rock bottom. You are broke and have no more casino credit available.";
  strBrokeCreditNo += " You should create a new gambler.";
  strBrokeCreditNo += "\nTo create a new gambler, select Create/Delete Gambler from the File menu.";

  strHasCoinsPlayedCreditYes = "You do not have enough money to play additional coins in this slot machine.";
  strHasCoinsPlayedCreditYes += " You can play the coin(s) you've already inserted, select a more";
  strHasCoinsPlayedCreditYes += " affordable slot machine, or perhaps you would like to visit the Casino";
  strHasCoinsPlayedCreditYes += " Credit department and take out a loan.";
  strHasCoinsPlayedCreditYes += "\nTo get casino credit, return to the lobby and select Casino Credit from the Options menu.";

  strHasCoinsPlayedCreditNo = "You do not have enough money to play additional coins in this slot machine.";
  strHasCoinsPlayedCreditNo += " Unfortunately, you have no more Casino Credit available. You can either";
  strHasCoinsPlayedCreditNo += " play the coin(s) you've already inserted, select a less expensive slot machine";
  strHasCoinsPlayedCreditNo += " or create a new gambler.";
  strHasCoinsPlayedCreditNo += "\nTo Create a new gambler, select Create/Delete Gambler from the File menu.";

  idsSounds = 0;
//  idsVertLite = 0;
//  idsDrawBack = 0;
  idsCoinPay = 0;
//  idsChips = 0;
//  idsCard1 = 0;
//  idsCard2 = 0;
//  idsCard3 = 0;
//  idsCard4 = 0;
//  idsCard5 = 0;
  idsNP1 = 0;
//  idsNP2 = 0;
//  idsNP3 = 0;
  idsCoinsPlayed = 0;
  idsCredits = 0;
  idsWinPaid = 0;
  idsButton0 = 0;
  idsButton1 = 0;
  idsButton2 = 0;
  idsButton3 = 0;
  idsButton4 = 0;
  idsButton5 = 0;
  idsButton6 = 0;
  idsButton7 = 0;
//  idsButton8 = 0;
//  idsWinRatio = 0;
  idsBankCash = 0;
//  idsProgressive = 0;
  idsValue    = 0;
  strSounds = TAppString::strEmpty;
//  strVertLite = TAppString::strEmpty;
//  strDrawBack = TAppString::strEmpty;
  strCoinPay = TAppString::strEmpty;
//  strChips = TAppString::strEmpty;
//  strCard1 = TAppString::strEmpty;
//  strCard2 = TAppString::strEmpty;
//  strCard3 = TAppString::strEmpty;
//  strCard4 = TAppString::strEmpty;
//  strCard5 = TAppString::strEmpty;
  strNP1 = TAppString::strEmpty;
//  strNP2 = TAppString::strEmpty;
//  strNP3 = TAppString::strEmpty;
  strCoinsPlayed = TAppString::strEmpty;
  strCredits = TAppString::strEmpty;
  strWinPaid = TAppString::strEmpty;
  strButton0 = TAppString::strEmpty;
  strButton1 = TAppString::strEmpty;
  strButton2 = TAppString::strEmpty;
  strButton3 = TAppString::strEmpty;
  strButton4 = TAppString::strEmpty;
  strButton5 = TAppString::strEmpty;
  strButton6 = TAppString::strEmpty;
  strButton7 = TAppString::strEmpty;
//  strButton8 = TAppString::strEmpty;
//  strWinRatio = TAppString::strEmpty;
  strBankCash = TAppString::strEmpty;
//  strProgressive = TAppString::strEmpty;
  strValue    =  TAppString::strEmpty;

  SetupUniqueIDStrings();

  SetupResponders();

  TFileMode splfm(SpriteListName,
                  TFileMode::fm_None,
                  TFileMode::fm_Immed,
                  FileMode.GetDirIndex());

  CreateAddSpriteList(splfm);

  TFileMode mdfm(strMiscDataName,
                 TFileMode::fm_None,
                 TFileMode::fm_Immed,
                 FileMode.GetDirIndex());

  CreateAddMiscData(mdfm);

  SetupSprites();
}
//*******************************************************************
TACVPSlotsGameLord::~TACVPSlotsGameLord()
{
  CleanupSprites();

  CleanupResponders();

  if(PState != NULL)
  {
	 delete PState;
	 PState = NULL;
  }
}
//*******************************************************************
void TACVPSlotsGameLord::CleanupResponders()
{
  for(int16 i=0;i<NumResponders;i++)
  {
    if (Responders[i] != NULL)
    {
      delete Responders[i];
      Responders[i] = NULL;
    }
  }
}
//*******************************************************************
bool TACVPSlotsGameLord::Spin()
{
  int16 session = GetCasPD(activeplayer)->SData.CurrentSession;
  GetCasPD(activeplayer)->SData.Sessions[session].HandsPlayed++;
  PReel1->Blur();
  PReel2->Blur();
  PReel3->Blur();
  return true;
}
//*******************************************************************
bool TACVPSlotsGameLord::InitS()
{
  TCasinoGameData *pgamedata = GetCasGameData();

//  if (Song >= 0)
//  {
//    ActivateSprite(Song,GetAdjFUC());
//  }
  if (PSong != NULL)
  {
    ActivateSprite(PSong,GetAdjFUC());
  }

  for (int16 i =0;i<NumButtons;i++)
  {
    BtnSetCurrentUpFrame(i,50);
    BtnSetCurrentGrayFrame(i,-1);
  }
  BtnShowGray(0);
  if (GetFW()->GetHandleShowMenu())
  {
    BtnShowVoidUp(2);
  }
  BtnSetResponderCh(1,3,'o');
  BtnSetResponderCh(1,5,'s');
  BtnSetResponderCh(2,5,VK_RETURN);
  BtnShowVoidUp(6);
  BtnShowVoidUp(7);

  PReel1->SetNum(int16(random(10)));
  PReel2->SetNum(int16(random(10)));
  PReel3->SetNum(int16(random(10)));
  PReel1->SetReel();
  PReel2->SetReel();
  PReel3->SetReel();
  SetupActivePlayer(NextSlotNum(-1)); // -1 because order of checking
  if(GetCasPD(0))
  {
	 GetCasPD(0)->StartSSession(SubGameType,GameDenom);
  }
  credits = 0l;
  coinsplayed = 0l;
  winnerpaid = 0l;
  return true;
}
//*******************************************************************
void TACVPSlotsGameLord::SwitchToPlayer(int16 player)
{
  if(GetCasPD(player))
  {
	 if(activeplayer != player && activeplayer != -1)
	 {
		credits += coinsplayed;
		coinsplayed = 0l;
		PCoinsPlayed->SetNum(0);

      if (PColumn != NULL) {PColumn->SetColumn(-1);}

		GetCasPlayer(activeplayer)->credit = credits;
		credits = 0l;
	 }

	 if(activeplayer != player)
	 {
		switch(activeplayer)
		{
			 case 0 : PNamePlate1->NoShowNamePlate();break;
		}
		activeplayer = player;
		PBankCashDisplay->SetNum(GetCash(activeplayer));
		credits = GetCasPlayer(player)->credit;
		GetCasPlayer(player)->credit = 0l;
		PCredits->SetNum(credits);
		if(GetCasPD(player)->Cash != 0)
		{
        BtnShowVoidUp(5);
		}
		else
		{
        BtnShowGray(5);
		}
		if(GetNumActivePlayers() > 1)
		{
		  string name;
		  name = GetCasPD(player)->GetName();
		  switch(player)
		  {
			 case 0 : PNamePlate1->ShowNamePlateString(name);break;
		  }
		}
	 }
    if (credits > 0)
    {
//      BtnShowVoidUp(4);
      BtnShowVoidUp(0);
    }
    else
    {
//      BtnShowGray(4); //???
      BtnShowGray(0);
    }
  }
}
//*******************************************************************
void TACVPSlotsGameLord::CyclePlayers()
{
  if(activeplayer != -1)
  {
	 SwitchToPlayer(NextSlotNum(activeplayer));
  }
}
//*******************************************************************
void  TACVPSlotsGameLord::ShuttingDown()
{
  TCasinoGameData *pgamedata = GetCasGameData();

  if(GetCasPD(0))
  {
	 NotifyPlayerDeActivation(0);
  }
}
//*******************************************************************
void TACVPSlotsGameLord::NotifyPlayerActivation(int16 slotnum)
{
  if(GetCasPD(slotnum))
  {
	 GameDenom = coinsize;
	 GetFW()->NotifyDenomSwitch(coinsize);
	 GetCasPD(slotnum)->StartSSession(SubGameType,GameDenom);
	 if(activeplayer == -1)
	 {
	  activeplayer = slotnum;
	  PBankCashDisplay->SetNum(GetCash(activeplayer));
	  if(GetCasPD(slotnum)->Cash >= coinsize)
	  {
       BtnShowVoidUp(3);
       BtnShowVoidUp(4);
	  }
	  else
	  {
       BtnShowGray(3);
       BtnShowGray(4);
	  }
		string name;
		name = GetCasPD(activeplayer)->GetName();
		PNamePlate1->ShowNamePlateString(name);
	 }
  }
}
//*******************************************************************
void TACVPSlotsGameLord::NotifyPlayerDeActivation(int16 slotnum)
{
  if(GetCasPD(slotnum))
  {
	 PNamePlate1->NoShowNamePlate();
	 GetCasPD(slotnum)->Cash += double(GetCasPlayer(slotnum)->credit * coinsize);
	 GetCasPlayer(slotnum)->credit = 0;
	 if(activeplayer == slotnum)
	 {
		if(shutdownstate == 0)
		{
		  GetCasPD(slotnum)->Cash += double(coinsplayed * coinsize);
		}
		coinsplayed = 0;
		GetCasPD(slotnum)->Cash += double(credits * coinsize);
		credits = 0;
      BtnShowGray(5);
		PCoinsPlayed->SetNum(0);
	 }
	 if(GetNumActivePlayers() == 1)
	 {
		activeplayer = -1;
		PCredits->SetNum(0);
		credits = 0;
		PCoinsPlayed->SetNum(0);
		PNamePlate1->NoShow();
      BtnShowGray(5);
		PBankCashDisplay->SetNum(0);
	 }
	 if(GetNumActivePlayers() > 1 && activeplayer == slotnum)
	 {
		int16 newplayer=-1;
		newplayer = NextSlotNum(slotnum);
		activeplayer = newplayer;
		credits = GetCasPlayer(newplayer)->credit;
		GetCasPlayer(newplayer)->credit = 0;
		PCredits->SetNum(credits);
		PCoinsPlayed->SetNum(0);
		PBankCashDisplay->SetNum(GetCash(activeplayer));
		if(GetCasPD(activeplayer)->Cash >= coinsize || credits > 0)
		{
        BtnShowVoidUp(3);
        BtnShowVoidUp(4);
		}
		else
		{
        BtnShowGray(3);
        BtnShowGray(4);
		}
      BtnShowGray(5);
		string name;
		name = GetCasPD(newplayer)->GetName();
		switch(newplayer)
		{
			 case 0 : PNamePlate1->ShowNamePlateString(name);break;
		}
	 }
	 GetCasPD(slotnum)->EndSSession();
  }
}
//*******************************************************************
void TACVPSlotsGameLord::SetupActivePlayer(int16 slot)
{
  if(GetCasPD(slot))
  {
	 activeplayer = slot;
	 string name;
	 name = GetCasPD(slot)->GetName();
	 PNamePlate1->ShowNamePlateString(name);
	 PBankCashDisplay->SetNum(GetCash(activeplayer));
  }
}
//*******************************************************************
void TACVPSlotsGameLord::Clear()
{
  BtnShowGray(5);
//  PayOffSound = -1;
  BetMaxNumOfCredits = 0;
  BetMaxNumOfCoins = 0;
  WaitOnButtonDown = false;
  UnFreezeAllButtons();
  shutdownstate    = 0;
  ChangeActivePlayersOk = true;
  coinsplayed = 0;
  if(credits > 0)
  {
    BtnShowVoidUp(0);
  }
  else
  {
    BtnShowGray(0);
  }
  BtnShowVoidUp(6);
  BtnShowVoidUp(7);
  if(activeplayer > -1 && (GetCash(activeplayer) >= coinsize || credits > 0))
  {
	 if(GetCash(activeplayer) >= double(coinsize * 50))
	 {
      BtnShowVoidUp(1);
	 }
    BtnShowVoidUp(3);
    BtnShowVoidUp(4);
  }
  if(activeplayer > -1)
  {
    PBankCashDisplay->SetNum(GetCash(activeplayer));
  }
}
//*******************************************************************
int16 TACVPSlotsGameLord::Winner()
{
#ifdef DEBUGSLOT
  int w,x,y;//,z;
  bool waspaused = GetModeWin()->GetUpdatePause();
  GetModeWin()->SetUpdatePause();
  char cardnum1[5] = "";
  char cardnum2[5] = "";
  char cardnum3[5] = "";
  char cardnum4[5] = "";
  TInputDialog getcard1(pMWin,"","#",cardnum1,5);
  getcard1.Execute();
  TInputDialog getcard2(pMWin,"","#",cardnum2,5);
  getcard2.Execute();
  TInputDialog getcard3(pMWin,"","#",cardnum3,5);
  getcard3.Execute();
  if (waspaused) {GetModeWin()->ClearUpdatePause();}

  w = atoi(cardnum1);
  x = atoi(cardnum2);
  y = atoi(cardnum3);
  PReel1->SetNum(w);
  PReel2->SetNum(x);
  PReel3->SetNum(y);
  PReel1->ShowReel();
  PReel2->ShowReel();
  PReel3->ShowReel();
#endif
  winnerpaid = PayOut();

  int session = GetCasPD(activeplayer)->SData.CurrentSession;
  TCasinoSData &curdata = GetCasPD(activeplayer)->SData;
  TCSSession &cursession = curdata.Sessions[session];

  if(winnerpaid == 0)
  {
	 curdata.Cumulative -= double(coinsplayed * coinsize);
	 cursession.CurrentLosingStreak++;
	 cursession.CurrentWinStreak = 0;
	 cursession.Losses++;
	 if(cursession.CurrentLosingStreak > cursession.LosingStreak)
	 {
		cursession.LosingStreak = cursession.CurrentLosingStreak;
	 }
	 if((GetCash(activeplayer)+(credits * coinsize)) < cursession.PeakLoss)
	 {
		cursession.PeakLoss = double(GetCash(activeplayer) + (credits * coinsize));
	 }
  }
  else
  {
	 curdata.Cumulative += double(winnerpaid * coinsize);
	 cursession.CurrentWinStreak++;
	 cursession.CurrentLosingStreak = 0;
	 cursession.Wins++;  //???
	 if(cursession.CurrentWinStreak > cursession.WinStreak)
	 {
		cursession.WinStreak = cursession.CurrentWinStreak;
	 }
	 if(winnerpaid*coinsize > cursession.LargestWin)
	 {
		cursession.LargestWin = double(winnerpaid * coinsize);
	 }
	 if(GetCash(activeplayer)+(credits*coinsize)+winnerpaid*coinsize > cursession.PeakWin)
	 {
		cursession.PeakWin = double(GetCash(activeplayer) +
                                  (credits * coinsize) +
                                  (winnerpaid * coinsize));
	 }
	 if(winnerpaid > 18)
	 {
		cursession.nHiPayoffs++;
	 }
	 else
	 {
      cursession.nLowPayoffs++;
	 }
  }
  if(PWinHighLight != NULL && WinningCombo >= 0)
  {
    int16 sound = GetPayOffLevel(WinningCombo);
    PWinHighLight->PlaySound(sound);
//	 switch(PayOffSound) //set at calc winning combo time.
//	 {
//		case 0  : PWinHighLight->PlaySound(0);break;
//		case 1  : PWinHighLight->PlaySound(1);break;
//		case 2  : PWinHighLight->PlaySound(2);break;
//		case 3  : PWinHighLight->PlaySound(3);break;
//		case 4  : PWinHighLight->PlaySound(4);break;
//		case 5  : PWinHighLight->PlaySound(5);break;
//		case 6  : PWinHighLight->PlaySound(6);break;
//		case 7  : PWinHighLight->PlaySound(7);break;
//		case 8  : PWinHighLight->PlaySound(8);break;
//	 }
  }
  return winnerpaid;
}// winner
//*******************************************************************
bool TACVPSlotsGameLord::AddCoins()
{
  if (GetCasPD(activeplayer) != NULL) {GetCasPD(activeplayer)->Cash.RoundTo5Cent();}
  if(GetCash(activeplayer) == 0 && credits == 0)
  {
	 if(coinsplayed > 0)
	 {
		  PModeWin->MessageBox("You're out of money and may not make additional bets. Your current bets are your only hope.","Out of Cash",MB_OK);
	 }
	 else
	 {
		PModeWin->MessageBox("You've hit rock bottom. Your gambler is bankrupt. Select Create/Delete under the FILE menu to create or select a new gambler.","Bankrupt!",MB_OK);
	 }
	 return false;
  }
  if(coinsplayed < maxbet)
  {
	 SubCash(activeplayer,coinsize);
	 coinsplayed++;
  }
  else
  {
	 if(coinsplayed == maxbet)   // Not a needed check, oh well...
	 {
		SubCash(activeplayer,coinsize);
		credits++;
	 }
  }
  return true;
}
//*******************************************************************
int16 TACVPSlotsGameLord::CashOut()
{
  return 1;
}
//*******************************************************************
bool TACVPSlotsGameLord::Bet1()
{
  if (GetCasPD(activeplayer) != NULL) {GetCasPD(activeplayer)->Cash.RoundTo5Cent();}
  if((GetCash(activeplayer) == 0.0 || GetCash(activeplayer) < coinsize) && credits == 0.0)
  {
    string msg = TAppString::strEmpty;
    if (coinsplayed > 0.0)
    {
      if (GetCasPD(activeplayer)->CreditCheck())
      {
        msg = strHasCoinsPlayedCreditYes;
      }
      else
      {
        msg = strHasCoinsPlayedCreditNo;
      }
    }
    else if (GetCash(activeplayer) < 0.05)
    {
      if (GetCasPD(activeplayer)->CreditCheck())
      {
        msg = strBrokeCreditYes;
      }
      else
      {
        msg = strBrokeCreditNo;
      }
    }
    else if (GetCash(activeplayer) < coinsize)
    {
      if (GetCasPD(activeplayer)->CreditCheck())
      {
        msg = strPlayCheaperCreditYes;
      }
      else
      {
        msg = strPlayCheaperCreditNo;
      }
    }

    if (msg != TAppString::strEmpty)
    {
      TBankruptMsgDlg *pbmd = new TBankruptMsgDlg(PModeWin,msg,strBankruptTitle);
      pbmd->Execute();
      delete pbmd;
    }
	 return false;
  }
  int session = GetCasPD(activeplayer)->SData.CurrentSession;
  TCasinoSData &curdata = GetCasPD(activeplayer)->SData;
  TCSSession &cursession = curdata.Sessions[session];

	if(credits > 0.0)
	{
	  credits--;
//     PCoinsPlayed->PlayCreditsSound(1);
     if (PColumn != NULL)
     {
       PColumn->SetColumn(coinsplayed);
       PColumn->PlayCreditsSound(1);
     }
	  coinsplayed++;
	  PCoinsPlayed->SetNum(coinsplayed);
	  PBankCashDisplay->SetNum(GetCash(activeplayer));
	  PCredits->SetNum(credits);
     BtnShowVoidUp(5);
	  cursession.TotalBetsCash += coinsize;

	  if(credits == 0)
	  {
       BtnShowGray(0);
	  }
     else
     {
       BtnShowVoidUp(0);//mrp - 11/07/99
     }
	  PWinPaid->SetNum(0);
	  PBankCashDisplay->SetNum(GetCash(activeplayer));
	  return true;
	}
	if (GetCash(activeplayer) >= coinsize)
	{
	  SubCash(activeplayer,coinsize);
//     PCoinsPlayed->PlayCoinsSound(1);
     if (PColumn != NULL)
     {
       PColumn->SetColumn(coinsplayed);
       PColumn->PlayCoinsSound(1);
     }
	  coinsplayed++;
	  cursession.TotalBetsCash += coinsize;
	  PCoinsPlayed->SetNum(coinsplayed);
	  PCredits->SetNum(credits);
     BtnShowVoidUp(5);
	  PWinPaid->SetNum(0);
	  PBankCashDisplay->SetNum(GetCash(activeplayer));
	}
	return true;
}
//*******************************************************************
int16 TACVPSlotsGameLord::BetX(int16 numcoins)
{
  if (GetCasPD(activeplayer) != NULL) {GetCasPD(activeplayer)->Cash.RoundTo5Cent();}
  if(GetCash(activeplayer) == 0.0 && credits == 0.0)
  {
	 if(coinsplayed > 0.0)
	 {
		  PModeWin->MessageBox("You're out of money and may not make additional bets. Your current bets are your only hope.","Out of Cash",MB_OK);
	 }
	 else
	 {
		PModeWin->MessageBox("You've hit rock bottom. Your gambler is bankrupt. Select Create/Delete under the FILE menu to create or select a new gambler.","Bankrupt!",MB_OK);
	 }
	 return 0;
  }
  int16 returnvalue = 0;
  TMoney m(coinsize * numcoins);
  int session = GetCasPD(activeplayer)->SData.CurrentSession;
  TCasinoSData &curdata = GetCasPD(activeplayer)->SData;
  TCSSession &cursession = curdata.Sessions[session];

  if (GetCash(activeplayer) >= m && numcoins > 0)
  {
    SubCash(activeplayer,m);
    cursession.TotalBetsCash += m;
    PBankCashDisplay->SetNum(GetCash(activeplayer));
    if(coinsplayed == maxbet)
    {
      credits += numcoins;
  	   PCredits->SetNum(credits);
      BtnShowGray(3);
      BtnShowGray(4);
      BtnShowVoidUp(5);
		returnvalue = 0;
    }
    else if (maxbet == (coinsplayed + numcoins))
    {
      returnvalue = numcoins;
      coinsplayed += numcoins;
      PCoinsPlayed->SetNum(coinsplayed);
//      PCoinsPlayed->PlayCoinsSound(numcoins);
      if (PColumn != NULL)
      {
        PColumn->SetColumn(coinsplayed);
        PColumn->PlayCoinsSound(numcoins);
      }
      BtnShowVoidUp(5);
      BtnShowGray(3);
      BtnShowGray(4);
    }
	 else if ((coinsplayed + numcoins) < double(maxbet))
	 {
	  returnvalue = numcoins;
	  coinsplayed += numcoins;
	  PCoinsPlayed->SetNum(coinsplayed);
//     PCoinsPlayed->PlayCoinsSound(numcoins);
     if (PColumn != NULL)
     {
       PColumn->SetColumn(coinsplayed);
       PColumn->PlayCoinsSound(numcoins);
     }
     BtnShowVoidUp(5);
	 }
	 else if(coinsplayed + numcoins > maxbet)
	 {
//      PCoinsPlayed->PlayCoinsSound(numcoins);
      if (PColumn != NULL)
      {
        PColumn->SetColumn(coinsplayed);
        PColumn->PlayCoinsSound(numcoins);
      }
	   returnvalue = int16(maxbet - coinsplayed);
		numcoins -= int16(maxbet - coinsplayed);
		credits += numcoins;
		PCredits->SetNum(credits);
		coinsplayed = maxbet;
		PCoinsPlayed->SetNum(coinsplayed);
      BtnShowGray(3);
      BtnShowGray(4);
      BtnShowVoidUp(5);
    }
    PWinPaid->SetNum(0);
	 PBankCashDisplay->SetNum(GetCash(activeplayer));
	 if(credits != 0)
    {
      BtnShowVoidUp(0);
    }
  }
  return returnvalue;
}
//*******************************************************************
int16 TACVPSlotsGameLord::BetMax()
{
  if (GetCasPD(activeplayer) != NULL) {GetCasPD(activeplayer)->Cash.RoundTo5Cent();}
  if((GetCash(activeplayer) == 0.0 || GetCash(activeplayer) < coinsize) && credits == 0.0)
  {
    BtnShowGray(4);

    string msg = TAppString::strEmpty;
    if (coinsplayed > 0.0)
    {
      if (GetCasPD(activeplayer)->CreditCheck())
      {
        msg = strHasCoinsPlayedCreditYes;
      }
      else
      {
        msg = strHasCoinsPlayedCreditNo;
      }
    }
    else if (GetCash(activeplayer) < 0.05)
    {
      if (GetCasPD(activeplayer)->CreditCheck())
      {
        msg = strBrokeCreditYes;
      }
      else
      {
        msg = strBrokeCreditNo;
      }
    }
    else if (GetCash(activeplayer) < coinsize)
    {
      if (GetCasPD(activeplayer)->CreditCheck())
      {
        msg = strPlayCheaperCreditYes;
      }
      else
      {
        msg = strPlayCheaperCreditNo;
      }
    }
    if (msg != TAppString::strEmpty)
    {
      TBankruptMsgDlg *pbmd = new TBankruptMsgDlg(PModeWin,msg,strBankruptTitle);
      pbmd->Execute();
      delete pbmd;
    }
	 return 0;
  }
  if(MaxOnly)
  {
	 if((GetCash(activeplayer)/coinsize)+credits < maxbet)
	 {
      BtnShowGray(4);
        // start MRP 7/29/97
        if (GetCasPD(activeplayer)->CreditCheck())
        {
          TBankruptMsgDlg *pbmd = new TBankruptMsgDlg(PModeWin,strPlayCheaperCreditYes,strBankruptTitle);
          pbmd->Execute();
          delete pbmd;
        }
        else
        {
          TBankruptMsgDlg *pbmd = new TBankruptMsgDlg(PModeWin,strPlayCheaperCreditNo,strBankruptTitle);
          pbmd->Execute();
          delete pbmd;
        }
        // end MRP 7/29/97
		return 0;
	 }
  }
  TMoney cpp = 0.0;
  TMoney cp = coinsplayed;

  int session = GetCasPD(activeplayer)->SData.CurrentSession;
  TCasinoSData &curdata = GetCasPD(activeplayer)->SData;
  TCSSession &cursession = curdata.Sessions[session];

  BMNumOfCoins     = false;
  BetMaxNumOfCoins = false;
  if(credits >= double(maxbet-coinsplayed))
  {
	 credits -= double(maxbet-coinsplayed);
	 BetMaxNumOfCredits = int16(maxbet - coinsplayed);
	 BMNumOfCredits = true;
	 cursession.TotalBetsCash += double((maxbet-coinsplayed)*coinsize);

	 coinsplayed = maxbet;
	 PCoinsPlayed->SetNum(coinsplayed);
	 PCredits->SetNum(credits);
    BtnShowVoidUp(5);
	 if(credits == 0)
	 {
      BtnShowGray(0);
	 }
    else
    {
      BtnShowVoidUp(0); // mrp - 11/07/99
    }
    BtnShowGray(3);
    BtnShowGray(4);
	 PWinPaid->SetNum(0);
	 PBankCashDisplay->SetNum(GetCash(activeplayer));
	 return (coinsplayed - cp);
  }
  else
  {
	 if(credits > 0.0)
	 {
		coinsplayed += credits;
		cursession.TotalBetsCash += double(credits*coinsize);
      BtnShowVoidUp(5);
		BetMaxNumOfCredits = credits;
		BMNumOfCredits = true;;
	 }
    for (int16 i=3;i<=5;i++)
    {
      BtnShowGray(i);
    }
	 credits = 0;                          // Could make a little faster
  }

  if (GetCash(activeplayer) > double((maxbet - coinsplayed) * coinsize))
  {
//    TMoney m(double((maxbet - coinsplayed) * coinsize));
    TMoney m(coinsize * (maxbet - coinsplayed));
	 SubCash(activeplayer,m);//(maxbet - coinsplayed) * coinsize);
	 cursession.TotalBetsCash += double((maxbet-coinsplayed)*coinsize);
	 BetMaxNumOfCoins = int16(maxbet - coinsplayed);
	 BMNumOfCoins = true;
	 coinsplayed = maxbet;
	 PCoinsPlayed->SetNum(coinsplayed);
	 PCredits->SetNum(credits);
    BtnShowVoidUp(5);
	 PBankCashDisplay->SetNum(GetCash(activeplayer));
  }
  else
  {
	 int16 x=0;
	 x = GetCash(activeplayer) / coinsize;
	 cpp = x;
	 coinsplayed += x;
	 BetMaxNumOfCoins = x;
	 SubCash(activeplayer,coinsize*x);
	 cursession.TotalBetsCash += double(coinsize*x);
	 PCoinsPlayed->SetNum(coinsplayed);
	 PCredits->SetNum(credits);
	 PBankCashDisplay->SetNum(GetCash(activeplayer));
	 if(x>0)
	 {
      BtnShowVoidUp(5);
	 }
  }
  if(coinsplayed > cp)
  {
	 if(cpp>0)
    {
      BMNumOfCoins = true;
    }
	 PWinPaid->SetNum(0);
	 PBankCashDisplay->SetNum(GetCash(activeplayer));
  }
  else if(coinsplayed == cp)
  {
    PBankCashDisplay->SetNum(GetCash(activeplayer));
  }
  return (coinsplayed - cp);
}
//*******************************************************************
//int16 TACVPSlotsGameLord::ShowWinner()
//{
//  credits += double(winnerpaid / coinsize);
//  return 1;
//}
//*******************************************************************
void TACVPSlotsGameLord::CycleDenom() //initiated by denom sprite
{
  GetCasPlayer(activeplayer)->credit = 0;
  if(coinsplayed > 0 || credits > 0)
  {
    PCoinPay->PlayDump();
  }
  if(shutdownstate == 0)
  {
//	 GetCasPD(activeplayer)->Cash += double(coinsplayed*coinsize);
    AddCash(activeplayer,TMoney(coinsize * coinsplayed));
  }
  coinsplayed = 0;
//  GetCasPD(activeplayer)->Cash += double(credits*coinsize);
//  AddCash(activeplayer,TMoney(credits * coinsize));
  AddCash(activeplayer,TMoney(coinsize * credits));
  credits = 0;
  BtnShowGray(5);
  BtnShowGray(0);
  PCredits->SetNum(0);
  PCoinsPlayed->SetNum(0);
  PBankCashDisplay->SetNum(GetCash(activeplayer));

  CurrentDenomNum++;
  if(CurrentDenomNum >= NumOfDenoms){CurrentDenomNum = 0;}

  //mrp - 11/8/99 - added
  coinsize = Denom[CurrentDenomNum];
  GameDenom = coinsize;   //this removed from respond() and added here.

  PValue->ChangeDenom(Denom[CurrentDenomNum],IsCycle);

//  if(GetCasPD(0)->Cash >= Denom[CurrentDenomNum])
  if (GetCash(activeplayer) >= Denom[CurrentDenomNum])
  {
    BtnShowVoidUp(3);
    BtnShowVoidUp(4);
  }
  else
  {
    BtnShowGray(3);
    BtnShowGray(4);
  }
}
//*******************************************************************
bool TACVPSlotsGameLord::SwitchDenom(TMoney denom) //initiated by fw
{
  TCasinoGameData *pgamedata = GetCasGameData();

  GetCasPlayer(activeplayer)->credit = 0;
  if(coinsplayed > 0 || credits > 0)
  {
    PCoinPay->PlayDump();
  }
  if(shutdownstate == 0)
  {
//	 GetCasPD(activeplayer)->Cash += double(coinsplayed*coinsize);
    AddCash(activeplayer,TMoney(coinsize * coinsplayed));
  }
  coinsplayed = 0;
//  GetCasPD(activeplayer)->Cash += double(credits*coinsize);
  AddCash(activeplayer,TMoney(coinsize * credits));
  credits = 0;
  BtnShowGray(5);
  BtnShowGray(0);
  PCredits->SetNum(0);
  PCoinsPlayed->SetNum(0);
  PBankCashDisplay->SetNum(GetCash(activeplayer));

  while(denom != Denom[CurrentDenomNum])
  {
	 CurrentDenomNum++;
	 if(CurrentDenomNum >= NumOfDenoms)
    {
      CurrentDenomNum = 0;
    }
  }
  PValue->ChangeDenom(Denom[CurrentDenomNum],IsCycle);
  NotifyPlayerDeActivation(0);
  coinsize = Denom[CurrentDenomNum];
  NotifyPlayerActivation(0);
  IsCycle = false;
  GameDenom = coinsize;
  if(GetCasPD(activeplayer)->Cash < coinsize)
  {
    BtnShowGray(3);
    BtnShowGray(4);
  }
  else
  {
    BtnShowVoidUp(3);
    BtnShowVoidUp(4);
  }
  return true;
}
//*******************************************************************
int16 TACVPSlotsGameLord::GetCrystalPalaceWC(int16 s0,int16 s1,int16 s2,int16 &mult)
{
  int16 winningcombo = -1;

  //accumulate totals to make identifying winning combo w/ wilds a little easier.
  int16 numNone = 0;
  int16 numHugeCrystal = 0;
  int16 numBigCrystal = 0;
  int16 numCrystal7 = 0;
  int16 num3CrystalBar = 0;
  int16 num2CrystalBar = 0;
  int16 num1CrystalBar = 0;
  int16 numCrystalCherry = 0;

  switch (s0)
  {
    case symCrystalCherry:numCrystalCherry++;break;
    case sym1CrystalBar:num1CrystalBar++;break;
    case sym2CrystalBar:num2CrystalBar++;break;
    case sym3CrystalBar:num3CrystalBar++;break;
    case symCrystal7:numCrystal7++;break;
    case symBigCrystal:numBigCrystal++;break;
    case symHugeCrystal:numHugeCrystal++;break;
    default:numNone++;break;
  }

  switch (s1)
  {
    case symCrystalCherry:numCrystalCherry++;break;
    case sym1CrystalBar:num1CrystalBar++;break;
    case sym2CrystalBar:num2CrystalBar++;break;
    case sym3CrystalBar:num3CrystalBar++;break;
    case symCrystal7:numCrystal7++;break;
    case symBigCrystal:numBigCrystal++;break;
    case symHugeCrystal:numHugeCrystal++;break;
    default:numNone++;break;
  }

  switch (s2)
  {
    case symCrystalCherry:numCrystalCherry++;break;
    case sym1CrystalBar:num1CrystalBar++;break;
    case sym2CrystalBar:num2CrystalBar++;break;
    case sym3CrystalBar:num3CrystalBar++;break;
    case symCrystal7:numCrystal7++;break;
    case symBigCrystal:numBigCrystal++;break;
    case symHugeCrystal:numHugeCrystal++;break;
    default:numNone++;break;
  }

  int16 numwilds = int16(numHugeCrystal + numBigCrystal);

  //figure out multiplier
  mult = 1;
  if (numHugeCrystal == 1)
  {
    mult *= int16(3);
  }
  else if (numHugeCrystal == 2)
  {
    mult *= int16(9);
  }

  if (numBigCrystal == 1)
  {
    mult *= int16(2);
  }
  else if (numBigCrystal == 2)
  {
    mult *= int16(4);
  }

  // big if then structure to figure winningcombo w/wilds
  if (numHugeCrystal == 3)
  {
    winningcombo = wc3ofHugeCrystal;
  }
  else if ((numBigCrystal + numHugeCrystal) == 3)
  {
    winningcombo = wc3ofBigCrystal;
    // Big Crystal 2x mult doesn't count with 3ofBigCrystal winning combo
    // so just use 3x huge crystal mult if any huge
    if (numHugeCrystal == 1)
    {
      mult = int16(3);
    }
    else if (numHugeCrystal == 2)
    {
      mult = int16(9);
    }
    else
    {
      mult = 1;
    }
  }
  else if ((numCrystal7 + numwilds) == 3)
  {
    winningcombo = wc3ofCrystal7;
  }
  else if ((num3CrystalBar + numwilds) == 3)
  {
    winningcombo = wc3of3CrystalBar;
  }
  else if ((num2CrystalBar + numwilds) == 3)
  {
    winningcombo = wc3of2CrystalBar;
  }
  else if ((num1CrystalBar + numwilds) == 3)
  {
    winningcombo = wc3of1CrystalBar;
  }
  else if ((numCrystalCherry + numwilds) == 3)
  {
    winningcombo = wc3ofCrystalCherry;
  }
  else if ((num1CrystalBar + num2CrystalBar + num3CrystalBar + numwilds) == 3)
  {
    winningcombo = wc3ofXCrystalBar;
  }
  else if ((numCrystalCherry + numwilds) == 2)
  {
    winningcombo = wc2ofCrystalCherry;
  }
  else if (numCrystalCherry == 1)
  {
    winningcombo = wc1ofCrystalCherry;
  }
  return winningcombo;
}
//*******************************************************************
int16 TACVPSlotsGameLord::GetSuper7WC(int16 s0,int16 s1,int16 s2)
{
  int16 winningcombo = -1;
  if (s0 == symSuper7 && s1 == symSuper7 && s2 == symSuper7)
  {
    winningcombo = wc3ofSuper7;
  }
  else if (s0 == sym3Bar && s1 == sym3Bar && s2 == sym3Bar)
  {
    winningcombo = wc3of3Bar;
  }
  else if (s0 == sym2Bar && s1 == sym2Bar && s2 == sym2Bar)
  {
    winningcombo = wc3of2Bar;
  }
  else if (s0 == sym1Bar && s1 == sym1Bar && s2 == sym1Bar)
  {
    winningcombo = wc3of1Bar;
  }
  else if ((s0 == sym1Bar || s0 == sym2Bar || s0 == sym3Bar) &&
           (s1 == sym1Bar || s1 == sym2Bar || s1 == sym3Bar) &&
           (s2 == sym1Bar || s2 == sym2Bar || s2 == sym3Bar))
  {
    winningcombo = wc3ofXBar;
  }
  else if (s0 == sym2Cherry && s1 == sym2Cherry && s2 == sym2Cherry)
  {
    winningcombo = wc3of2Cherry;
  }
  else if (s0 == sym1Cherry && s1 == sym1Cherry && s2 == sym1Cherry)
  {
    winningcombo = wc3of1Cherry;
  }
  else if ((s0 == sym2Cherry && s1 == sym2Cherry) ||
           (s0 == sym2Cherry && s2 == sym2Cherry) ||
           (s1 == sym2Cherry && s2 == sym2Cherry))
  {
    winningcombo = wc2of2Cherry;
    if (s0 == sym1Cherry || s1 == sym1Cherry || s2 == sym1Cherry)
    {
      winningcombo = wc1of1CherryAnd2of2Cherry;
    }
  }
  else if (s0 == sym2Cherry || s1 == sym2Cherry || s2 == sym2Cherry)
  {
    winningcombo = wc1of2Cherry;
    if (s0 == sym1Cherry || s1 == sym1Cherry || s2 == sym1Cherry)
    {
      winningcombo = wc1of1CherryAnd1of2Cherry;
    }
  }
  else if ((s0 == sym1Cherry && s1 == sym1Cherry) ||
           (s0 == sym1Cherry && s2 == sym1Cherry) ||
           (s1 == sym1Cherry && s2 == sym1Cherry))
  {
    winningcombo = wc2of1Cherry;
    if (s0 == sym2Cherry || s1 == sym2Cherry || s2 == sym2Cherry)
    {
      winningcombo = wc2of1CherryAnd1of2Cherry;
    }
  }
  else if (s0 == sym1Cherry || s1 == sym1Cherry || s2 == sym1Cherry)
  {
    winningcombo = wc1of1Cherry;
  }
  return winningcombo;
}
//*******************************************************************
int16 TACVPSlotsGameLord::GetWinningCombo(int16 s0,int16 s1,int16 s2,int16 &mult)
{
  switch (SubGameType)
  {
    case cslCrystalPalace:return GetCrystalPalaceWC(s0,s1,s2,mult);
    case cslSuperSevens: return GetSuper7WC(s0,s1,s2);
    default:return -1;
  }
}
//*******************************************************************
int16 TACVPSlotsGameLord::GetPayOffLevel(int16 wc)
{
  switch (SubGameType)
  {
    case cslCrystalPalace: if (wc >= 0 && wc < wcCrystalNumCombos)
                           {
                             return wc;
                           }
                           return -1;
    case cslSuperSevens:
                         switch (wc)
                         {
                           case wc1of1Cherry: return 0;
                           case wc2of1Cherry: return 1;
                           case wc1of2Cherry: return 2;
                           case wc1of1CherryAnd1of2Cherry: return 2;
                           case wc2of1CherryAnd1of2Cherry: return 2;
                           case wc2of2Cherry: return 3;
                           case wc1of1CherryAnd2of2Cherry: return 3;
                           case wc3of1Cherry: return 4;
                           case wc3of2Cherry: return 5;
                           case wc3ofXBar: return 6;
                           case wc3of1Bar: return 7;
                           case wc3of2Bar: return 8;
                           case wc3of3Bar: return 9;
                           case wc3ofSuper7: return 10;
                           default: return -1;
                         }
                         //if (wc >= 0 && wc < wcSuper7NumCombos)
                         //{
                         //  return wc;
                         //}
                         //return -1;
    default:return -1;
  }
}
//*******************************************************************
TMoney TACVPSlotsGameLord::PayLine1()
//shouldn't be TMoney, but int16 instead because returning units of denomsize
//rather than actual money.
{
  TMoney amount = 0.0;
  int16 numcoinswon = 0;
  int16 s0=0,s1=0,s2=0;

  //get reel's current frame, this is the actual reel stop num.
  s0 = GetReelDataint16(PReel1->GetCurrentAnmFrame(1));
  s1 = GetReelDataint16(PReel2->GetCurrentAnmFrame(1));
  s2 = GetReelDataint16(PReel3->GetCurrentAnmFrame(1));

  // identify winning combo
  int16 mult = 1;
  WinningCombo = GetWinningCombo(s0,s1,s2,mult);

  int16 numcoins = int16(coinsplayed);
  // identify amount won.
  if (WinningCombo >= 0 && numcoins >= 0 && numcoins < MaxNumCoins)
  {
    switch (SubGameType)
    {
      case cslCrystalPalace:
            if (WinningCombo < wcCrystalNumCombos)
            {
              numcoinswon = CrystalPalaceWC[WinningCombo][numcoins];
              numcoinswon *= mult;
            }
            break;
      case cslSuperSevens:
            if (WinningCombo < wcSuper7NumCombos)
            {
               numcoinswon = Super7WC[WinningCombo][numcoins];
            }
            break;
      default:break;
    }
    amount = numcoinswon;
  }
  return amount;
}
//*******************************************************************
TSprite *TACVPSlotsGameLord::CreateSprite(string spritename,int16 id,void *psource)
{
  // the following added because of new C++ rule about
  // passing temp's as parameters.
  // new note: should've changed sprite's ctors to use const &'s instead.

  static TRect b0rect(405,445,452,475);  //cashout
  static TRect b1rect(1,1,2,2);  // add 50 credits ???
  static TRect b2rect(232,469,394,478); // askx
  static TRect b3rect(465,445,510,475); // betone
  static TRect b4rect(525,445,570,475); // betmax
  static TRect b5rect(585,445,630,475); // spin
  static TRect b6rect(7,445,47,475); // lobby
  static TRect b7rect(179,445,228,475); // help
//  static TRect b6rect(450,464,635,478);

//  static TRect b4rect_2(393,398,629,456);

  TFileMode FM(spritename,
               TFileMode::fm_None,
               TFileMode::fm_None,
               FileMode.GetDirIndex());

  if (psource != NULL)
  {
    switch (id)
	 {
      case  0 : return new TSprite(PModeWin,FM,psource);
      case  1 : return new TSprite(PModeWin,FM,psource);
                //Button1 = new TCasButton(PModeWin,FM,psource,this,100,b1rect,HSidButton1,true);
					 //return Button1;
      case  2 : return new TSprite(PModeWin,FM,psource); //???
      case  3 : PBankCashDisplay = new TACVPSlotsCashDisplay(PModeWin,FM,psource);
					 return PBankCashDisplay;
      case  4 : PButtons[3] = new TCasButton(PModeWin,FM,psource,this,125,b3rect,acvpsidButton3,true,'b');
					 return PButtons[3];
      case  5 : PButtons[4] = new TCasButton(PModeWin,FM,psource,this,125,b4rect,acvpsidButton4,true,'m');
					 return PButtons[4];
      case  6 : return new TSprite(PModeWin,FM,psource);
      case  7 : PButtons[0] = new TCasButton(PModeWin,FM,psource,this,125,b0rect,acvpsidButton0,true,'c');
					 return PButtons[0];
      case  8 : PColumn = new TACVPSlotsColumn(PModeWin,FM,psource);
                return PColumn;
      case  9 : PCredits = new TACVPSlotsCredits(PModeWin,FM,psource);
					 return PCredits;
      case 10 : return new TSprite(PModeWin,FM,psource); // vp only
      case 11 : return new TSprite(PModeWin,FM,psource); // vp only
      case 12 : PCoinPay = new TACVPSlotsCoinPay(PModeWin,FM,psource);
					 return PCoinPay;
      case 13 : PButtons[6] = new TCasButton(PModeWin,FM,psource,this,125,b6rect,acvpsidButton6,true,'l');
                return PButtons[6];
      case 14 : PButtons[2] = new TCasButton(PModeWin,FM,psource,this,125,b2rect,acvpsidButton2,true);
					 return PButtons[2];
      case 15 : PNamePlate1 = new TACVPSlotsNamePlate(PModeWin,FM,psource);
					 return PNamePlate1;
      case 16 : PWinPaid = new TACVPSlotsWinPaid(PModeWin,FM,psource);
					 return PWinPaid;
      case 17 : PWinHighLight = new TACVPSlotsWinHighLight(PModeWin,FM,psource);
					 return PWinHighLight;
      case 18 : PCoinsPlayed = new TACVPSlotsCoinsPlayed(PModeWin,FM,psource);
					 return PCoinsPlayed;
      case 19 : PSong = new TSprite(PModeWin,FM,psource);
                return PSong;
      case 20 : PValue = new TACVPSlotsValue(PModeWin,FM,psource);
					 return PValue;
      case 21 : return new TSprite(PModeWin,FM,psource);//???
      case 22 : return new TSprite(PModeWin,FM,psource);// vp only
      case 23 : return new TSprite(PModeWin,FM,psource);// vp only
      case 24 : return new TSprite(PModeWin,FM,psource);// vp only
      case 25 : return new TSprite(PModeWin,FM,psource);// vp only
      case 26 : return new TSprite(PModeWin,FM,psource);// vp only
      case 27 : return new TSprite(PModeWin,FM,psource);// vp only
      case 28 : return new TSprite(PModeWin,FM,psource);// vp only
      case 29 : return new TSprite(PModeWin,FM,psource);// vp only
      case 30 : return new TSprite(PModeWin,FM,psource);// vp only
      case 31 : return new TSprite(PModeWin,FM,psource);// vp only
      case 32 : return new TSprite(PModeWin,FM,psource);// vp only
      case 33 : PReel1 = new TACVPSlotsReel(PModeWin,FM,psource);
					 return PReel1;
		case 34 : PReel2 = new TACVPSlotsReel(PModeWin,FM,psource);
			 	    return PReel2;
		case 35 : PReel3 = new TACVPSlotsReel(PModeWin,FM,psource);
				    return PReel3;
      case 36 : PButtons[5] = new TCasButton(PModeWin,FM,psource,this,125,b5rect,acvpsidButton5,true,'s');
					 return PButtons[5];
      case 37 : PButtons[7] = new TCasButton(PModeWin,FM,psource,this,125,b7rect,acvpsidButton7,true,'h');
                return PButtons[7];
      case 38 : PPayLine = new TACVPSlotsPayLine(PModeWin,FM,psource);
					 return PPayLine;
      case 39 : return new TSprite(PModeWin,FM,psource);//???
      case 40 : return new TSprite(PModeWin,FM,psource);//???
      case 41 : return new TSprite(PModeWin,FM,psource);
      case 42 : PSounds = new TACVPSlotsSound(PModeWin,FM,psource);
					 return PSounds;
      default : return new TSprite(PModeWin,FM,psource);
    }
  }
  else
  {
    switch (id)
	 {
      case  0 : return new TSprite(PModeWin,FM);
      case  1 : return new TSprite(PModeWin,FM);
                //Button1 = new TCasButton(PModeWin,FM,this,100,b1rect,HSidButton1,true);
					 //return Button1;
      case  2 : return new TSprite(PModeWin,FM); //???
      case  3 : PBankCashDisplay = new TACVPSlotsCashDisplay(PModeWin,FM);
					 return PBankCashDisplay;
      case  4 : PButtons[3] = new TCasButton(PModeWin,FM,this,125,b3rect,acvpsidButton3,true,'b');
					 return PButtons[3];
      case  5 : PButtons[4] = new TCasButton(PModeWin,FM,this,125,b4rect,acvpsidButton4,true,'m');
					 return PButtons[4];
      case  6 : return new TSprite(PModeWin,FM);
      case  7 : PButtons[0] = new TCasButton(PModeWin,FM,this,125,b0rect,acvpsidButton0,true,'c');
					 return PButtons[0];
      case  8 : PColumn = new TACVPSlotsColumn(PModeWin,FM);
                return PColumn;
      case  9 : PCredits = new TACVPSlotsCredits(PModeWin,FM);
					 return PCredits;
      case 10 : return new TSprite(PModeWin,FM); // vp only
      case 11 : return new TSprite(PModeWin,FM); // vp only
      case 12 : PCoinPay = new TACVPSlotsCoinPay(PModeWin,FM);
					 return PCoinPay; //drop
      case 13 : PButtons[6] = new TCasButton(PModeWin,FM,this,125,b6rect,acvpsidButton6,true,'l');
                return PButtons[6];
      case 14 : PButtons[2] = new TCasButton(PModeWin,FM,this,125,b2rect,acvpsidButton2,true);
					 return PButtons[2];
      case 15 : PNamePlate1 = new TACVPSlotsNamePlate(PModeWin,FM);
					 return PNamePlate1;
      case 16 : PWinPaid = new TACVPSlotsWinPaid(PModeWin,FM);
					 return PWinPaid;
      case 17 : PWinHighLight = new TACVPSlotsWinHighLight(PModeWin,FM);
					 return PWinHighLight;
      case 18 : PCoinsPlayed = new TACVPSlotsCoinsPlayed(PModeWin,FM);
					 return PCoinsPlayed;
      case 19 : PSong = new TSprite(PModeWin,FM);
                return PSong;
      case 20 : PValue = new TACVPSlotsValue(PModeWin,FM);
					 return PValue;
      case 21 : return new TSprite(PModeWin,FM);//???
      case 22 : return new TSprite(PModeWin,FM);// vp only
      case 23 : return new TSprite(PModeWin,FM);// vp only
      case 24 : return new TSprite(PModeWin,FM);// vp only
      case 25 : return new TSprite(PModeWin,FM);// vp only
      case 26 : return new TSprite(PModeWin,FM);// vp only
      case 27 : return new TSprite(PModeWin,FM);// vp only
      case 28 : return new TSprite(PModeWin,FM);// vp only
      case 29 : return new TSprite(PModeWin,FM);// vp only
      case 30 : return new TSprite(PModeWin,FM);// vp only
      case 31 : return new TSprite(PModeWin,FM);// vp only
      case 32 : return new TSprite(PModeWin,FM);// vp only
      case 33 : PReel1 = new TACVPSlotsReel(PModeWin,FM);
					 return PReel1;
		case 34 : PReel2 = new TACVPSlotsReel(PModeWin,FM);
			 	    return PReel2;
  		case 35 : PReel3 = new TACVPSlotsReel(PModeWin,FM);
				    return PReel3;
      case 36 : PButtons[5] = new TCasButton(PModeWin,FM,this,125,b5rect,acvpsidButton5,true,'s');
					 return PButtons[5];
      case 37 : PButtons[7] = new TCasButton(PModeWin,FM,this,125,b7rect,acvpsidButton7,true,'h');
                return PButtons[7];
      case 38 : PPayLine = new TACVPSlotsPayLine(PModeWin,FM);
					 return PPayLine;
      case 39 : return new TSprite(PModeWin,FM);//???
      case 40 : return new TSprite(PModeWin,FM);//???
      case 41 : return new TSprite(PModeWin,FM);
      case 42 : PSounds = new TACVPSlotsSound(PModeWin,FM);
					 return PSounds;
      default : return new TSprite(PModeWin,FM);
    }
  }
}
//*******************************************************************
bool TACVPSlotsGameLord::AddCredits(int16 addcredits)
{
  TMoney m(coinsize);
  m *= addcredits;
  if(GetCash(activeplayer) >= m)//double(mikefuckup*coinsize))
  {
	 credits += addcredits;//mikefuckup;
	 SubCash(activeplayer,m);//mikefuckup*coinsize);
	 PBankCashDisplay->SetNum(GetCash(activeplayer));
	 PCredits->SetNum(credits);
    BtnShowVoidUp(0);
  }
  else
  {
    string strtext = "You don't have enough money to add 50 credits";
    string strtitle = "Bankrupt";
    TBankruptMsgDlg *pbmd = new TBankruptMsgDlg(PModeWin,strtext,strtitle);
    pbmd->Execute();
    delete pbmd;
  }
  return true;
}
//*******************************************************************
void TACVPSlotsGameLord::EnableButton(int16 button)
{
  if (CheckButtonIndex(button) && PButtons[button])
  {
    PButtons[button]->Enabled = true;
  }
}
//*******************************************************************
void TACVPSlotsGameLord::DisEnableButton(int16 button)
{
  if (CheckButtonIndex(button) && PButtons[button])
  {
    PButtons[button]->Enabled = false;
  }
}
//*******************************************************************
void TACVPSlotsGameLord::FreezeAllButtons()
{
  for (int16 i=0;i<NumButtons;i++)
  {
    if (PButtons[i])
    {
      PButtons[i]->Freeze = true;
    }
  }
}
//*******************************************************************
void TACVPSlotsGameLord::UnFreezeAllButtons()
{
  for (int16 i=0;i<NumButtons;i++)
  {
    if (PButtons[i])
    {
      PButtons[i]->Freeze = false;
    }
  }
}
//*******************************************************************
void TACVPSlotsGameLord::EnableAllButtons()
{
  for (int16 i=0;i<NumButtons;i++)
  {
    if (PButtons[i])
    {
      PButtons[i]->Enabled = true;
    }
  }
}
//*******************************************************************
void TACVPSlotsGameLord::DisEnableAllButtons()
{
  for (int16 i=0;i<NumButtons;i++)
  {
    if (PButtons[i])
    {
      PButtons[i]->Enabled = false;
    }
  }
}
//*******************************************************************
#pragma argsused
bool TACVPSlotsGameLord::Respond(int16 button,int16 info,void *pdata)
{
  if(info == -5)//gray button hit
  {
	 return true;
  }
  ButtonInfo = info;
  if(info == -1)
  {
    return true;
  }
  if (!CheckButtonIndex(button))
  {
    WaitOnButtonDown = false;
    return true;
  }
  if ((button == acvpsidButton3 || button == acvpsidButton4) &&
      coinsplayed >= maxbet)
  {
    return true;
  }
  BtnSetHit(button,true);
  return true;
}
//*******************************************************************
void TACVPSlotsGameLord::ButtonClear(int16 button)
{
  BtnSetHit(button,false);
  if (button == acvpsidButton2)
  {
    GetFW()->CmShowMenu();
  }
  WaitOnButtonDown = false;
}
//*******************************************************************
void TACVPSlotsGameLord::BtnShowVoidUp(int16 button)
{
  if (!CheckButtonIndex(button)) {return;}
  if (PButtons[button] == NULL) {return;}
  PButtons[button]->ShowVoidUp();
}
//*******************************************************************
void TACVPSlotsGameLord::BtnSetCurrentUpFrame(int16 button,int16 framenum)
{
  if (!CheckButtonIndex(button)) {return;}
  if (PButtons[button] == NULL) {return;}
  PButtons[button]->SetCurrentUpFrame(framenum);
}
//*******************************************************************
void TACVPSlotsGameLord::BtnSetCurrentGrayFrame(int16 button,int16 framenum)
{
  if (!CheckButtonIndex(button)) {return;}
  if (PButtons[button] == NULL) {return;}
  PButtons[button]->SetCurrentGrayFrame(framenum);
}
//*******************************************************************
void TACVPSlotsGameLord::BtnShowGray(int16 button)
{
  if (!CheckButtonIndex(button)) {return;}
  if (PButtons[button] == NULL) {return;}
  PButtons[button]->ShowGray();
}
//*******************************************************************
void TACVPSlotsGameLord::BtnSetResponderCh(int16 whichchar,int16 button,char ch)
{
  if (!CheckButtonIndex(button)) {return;}
  if (PButtons[button] == NULL) {return;}
  if (whichchar == 2)
  {
    PButtons[button]->PButtonResponder->SetCh2(ch);
  }
  else
  {
    PButtons[button]->PButtonResponder->SetCh(ch);
  }
}
//*******************************************************************

