//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  acvpsmw.cpp
//    Project Name:  acvp
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  2.5    10/16/99    M.Perry    original baseline
//********************************************************************
#include "acvpsmw.h"
//#include "hsglord.h"
//#include "casglord.h"
#include "acvpsgld.h"
#include "csplay.h"
#include "chelpid.h"
#include "oloaddlg.h"
//#include "hsmenu.rh"
#include "acvpmenu.rh"
#include "acvpname.rh"
//*******************************************************************
TACVPSlotsModeWin::TACVPSlotsModeWin(string modename,TPal *PPal,
                                     int16 sgt,int16 did,
                                     string title)
:TSlotsModeWin(modename,PPal,title),
 ModeSubGameType(sgt),
 ModeDenomID(did),
 idsGameLord(0),
 idsHuman0(0)
{
  ModeHelpCommand = HELP_CONTEXT;
  ModeHelpData = IDH_CAS_SLOTS;
}
//*******************************************************************
TACVPSlotsModeWin::~TACVPSlotsModeWin()
{
}
//*******************************************************************
string TACVPSlotsModeWin::GetDetName()
{
  string s = TAppString::strEmpty;
  switch(ModeSubGameType)
  {
    case cslCrystalPalace:s = "e7.det";break;
    case cslSuperSevens:s = "e8.det";break;
    default:break;
  }
  #if defined(ACVP_DEBUG_DETS)
  if (s == TAppString::strEmpty)
  {
    ::MessageBox(NULL,"det name not found","Warning!",MB_OK | MB_TASKMODAL);
  }
  #endif
  return s;
}
//*******************************************************************
int TACVPSlotsModeWin::GetMenuID()
{
  return IDM_ACVP_SLOTS;
}
//*******************************************************************
void TACVPSlotsModeWin::SetupGObjIDS()
{
  if (GObjIDSInitialized) {return;}

  TSlotsModeWin::SetupGObjIDS();  //call up chain.

  switch (ModeSubGameType)
  {
    case cslCrystalPalace:idsGameLord = IDS_GL_ACVP_SLOTS_CRYSTALPALACE;
                          idsHuman0 = IDS_H0_ACVP_SLOTS_CRYSTALPALACE;
                          break;
    case cslSuperSevens:idsGameLord = IDS_GL_ACVP_SLOTS_SUPERSEVENS;
                        idsHuman0 = IDS_H0_ACVP_SLOTS_SUPERSEVENS;
                        break;
    default:break;
  }
}
//*******************************************************************
void TACVPSlotsModeWin::SetupGObjStrings()
{
  if (GObjStringsInitialized) {return;}

  TSlotsModeWin::SetupGObjStrings();

  strGameLord = GetResString(idsGameLord);

  if (idsHuman0 > 0)
  {
    strHuman0 = GetResString(idsHuman0);
  }
}
//*******************************************************************
TGameObject *TACVPSlotsModeWin::CreateGObj(TFileMode &fm,int16 id,void *psource)
{
  #if defined(OGLE_DEBUG_GOBJ)
  if (!GObjInfoInitialized)
  {
    ::MessageBox(NULL,
                 "GObjInfoInitialized == false",
                 "Warning! TACVPSlotsModeWin::CreateGObj()",
                 MB_OK | MB_TASKMODAL);
  }

  if (!TMoney().CheckDenomID(ModeDenomID))
  {
    ::MessageBox(NULL,
                 "Invalid denomination",
                 "Error! TACVPSlotsModeWin::CreateGObj()",
                 MB_OK | MB_TASKMODAL);
  }

  if (fm == strGameLord && pLord != NULL)
  {
    ::MessageBox(NULL,
                 "GameLord already created",
                 "Error! TACVPSlotsModeWin::CreateGObj()",
                 MB_OK | MB_TASKMODAL);
  }
  #endif

  if (fm == strHuman0)
  {
    GObj[0] = new TCasinoSPlayer(this,fm,0);
    return GObj[0];
  }
  else if (fm == strGameLord && pLord == NULL)
  {
    pLord = new TACVPSlotsGameLord(this,fm,ModeSubGameType,ModeDenomID);
    return pLord;
  }
  else
  {
    #if defined(OGLE_DEBUG_GOBJ)
    string s = "gobj failed match:";
    s += fm.Name.GetStr();
    s += "\nCreating default TGameObject";
    s += "\nstrGameLord:";
    s += strGameLord;
    ::MessageBox(NULL,s.c_str(),"Warning! TACVPSlotsModeWin::CreateGObj()",MB_OK | MB_TASKMODAL);
    #endif
    // if all else fails, then create a generic gobj.
    return new TGameObject(this,fm);
  }
}
//*******************************************************************
