//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  acvscdsp.cpp
//    Project Name:  acvp
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  2.5    10/17/99    M.Perry     original baseline.
//********************************************************************
#include "acvscdsp.h"
#include "oanm.h"
//#include <assert.h>
//*******************************************************************
TACVPSlotsCashDisplay::TACVPSlotsCashDisplay(TOgleModeWindow *pmw,
                                             TFileMode NewFileMode,
                                             void *psource,
                                             bool lefttoright)
:TSprite(pmw,NewFileMode,psource),
 LeftToRightAnms(lefttoright)
{
  NoShow();
  SetToManual();
  SetupAnms();
}
//*******************************************************************
TACVPSlotsCashDisplay::TACVPSlotsCashDisplay(TOgleModeWindow *pmw,
                                             TFileMode NewFileMode,
                                             bool lefttoright)
:TSprite(pmw,NewFileMode),
 LeftToRightAnms(lefttoright)
{
  NoShow();
  SetToManual();
  SetupAnms();
}
//********************************************************************
TACVPSlotsCashDisplay::~TACVPSlotsCashDisplay()
{
}
//*******************************************************************
void TACVPSlotsCashDisplay::SetupAnms()
{
  // setup character to framenum converter.
  for (uint8 ui8 = 0;ui8 < uint8_max;ui8++)
  {
    FrameNums[ui8] = -1;
  }

  //now fill in FrameNum map with characters we're interested in.
  int16 counter = 0;
  for(uint8 ui8 = uint8('0'); //0-9
      ui8 <= uint8('9');
      ui8++,counter++)
  {
    FrameNums[ui8] = counter;
  }

  FrameNums[uint8('$')] = 10;
  FrameNums[uint8(',')] = 11;
  FrameNums[uint8('.')] = 12;

  for (int16 i=0;i<=MaxDigitNDX;i++)
  {
    if (LeftToRightAnms)
    {
      PDigits[i] = GetAnm(i);
    }
    else
    {
      PDigits[i] = GetAnm(int16(MaxDigitNDX - i));
    }
    if (PDigits[i] == NULL) {AnmError("Cash Display","Digits",i);}
    PDigits[i]->CAD.ClearAutoStart();
    PDigits[i]->CAD.ClearAutoStop();
	 PDigits[i]->CAD.SetDirStill();
  }
}
//*******************************************************************
#pragma argsused
bool TACVPSlotsCashDisplay::SetNum(TMoney money)
{
  Cash = money;
  if (Cash >= 10000000000.00) //display overflow
  {
    Cash = 9999999999.99;     //just show max value, at this point who cares?
  }
  strCash = Cash.GetStr(true,true,true);
  int16 len = int16(strCash.length());

  for(int16 i=0;i<NumDigits;i++)
  {
	 PDigits[i]->CAD.SetCurrentFrame(0);
	 PDigits[i]->NoShow();
  }
  int16 offset = int16((NumDigits - len)/2);

  //loop thru string setting frame numbers using char to framenum converter array.
  for(int16 i = 0;i<len;i++)
  {
    //use offset to center display.
    int16 fn = FrameNums[strCash[i]];
    if (fn >= 0) //was init'd to -1 so this is a little sanity check, just in case.
    {
//      PDigits[i + offset]->CAD.SetCurrentFrame(FrameNums[strCash[i]]);
      PDigits[i + offset]->CAD.SetCurrentFrame(fn);
      PDigits[i + offset]->Show();
    }
  }
  Update(GetAdjFUC());
  return true;
}
//*******************************************************************