//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  acvscmsp.cpp
//    Project Name:  acvp
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  2.5    10/26/99    M.Perry    original baseline
//********************************************************************
#include "acvscmsp.h"
#include "oanm.h"
#include "owav.h"
//********************************************************************
//bool TACVPSlotsCoinsPlayed::IsWaveStopped(int16 wave)
//{
//  if (wave >= 0 && wave < NumWavs)
//  {
//    if (PWavs[wave] != NULL &&
//        PWavs[wave]->GetStarted() &&
//        !PWavs[wave]->GetStopped())
//    {
//      return false; //found wave still playing
//    }
//  }
//  else if (MostRecentWav >= 0 &&                    //wave < 0
//           MostRecentWav < NumWavs &&
//           PWavs[MostRecentWav] != NULL &&
//           PWavs[MostRecentWav]->GetStarted() &&
//           !PWavs[MostRecentWav]->GetStopped())
//  {
//  	 return false; // found wave still playing
//  }
//  return true;
//}
//*******************************************************************
bool TACVPSlotsColumn::IsAllWavsStopped()
{
  for (int16 i=0;i<NumWavs;i++)
  {
    if (PWavs[i] != NULL &&
        PWavs[i]->GetStarted() &&
        !PWavs[i]->GetStopped())
    {
      return false;
    }
  }
  return true;
}
//*******************************************************************
void TACVPSlotsColumn::PlaySound(int16 sound)
{
  if (sound >= 0 && sound < NumWavs && PWavs[sound] != NULL)
  {
    PWavs[sound]->Start();
//    MostRecentWav = sound;
  }
}
//*******************************************************************
void TACVPSlotsColumn::PlayCoinsSound(int16 numcoins)
{
  int16 wavenum = int16(numcoins - 1);
  PlaySound(wavenum);
}
//*******************************************************************
void TACVPSlotsColumn::PlayCreditsSound(int16 numcredits)
{
  int16 wavenum = int16(numcredits + 4);
  PlaySound(wavenum);
}
//*******************************************************************
void TACVPSlotsColumn::SetupWavs()
{
  for(int16 i=0;i<NumWavs;i++)
  {
	 PWavs[i] = GetWav(i);
	 if (PWavs[i] == NULL)
    {
      WavError("Column Sprite","sound",i);
    }
  }
}
//*******************************************************************
void TACVPSlotsColumn::SetupAnms()
{
  PColumn = GetAnm(0);
//  #if defined(ACVP_DEBUG_SPRITES)
//  ::MessageBox(NULL,
//               "Rich, this is Mike, is there a column anm?",
//               "Warning! Missing Anm",
//               MB_OK | MB_TASKMODAL);
//  #endif
}
//*******************************************************************
TACVPSlotsColumn::TACVPSlotsColumn(TOgleModeWindow *pmw,const TFileMode &NewFileMode)
:TSprite(pmw,NewFileMode)
{
  PColumn = NULL;
  SetToManual();
  SetupAnms();
  SetupWavs();
//  MostRecentWav = 0;
}
//*******************************************************************
TACVPSlotsColumn::TACVPSlotsColumn(TOgleModeWindow *pmw,const TFileMode &NewFileMode,void *psource)
:TSprite(pmw,NewFileMode,psource)
{
  PColumn = NULL;
  SetToManual();
  SetupAnms();
  SetupWavs();
//  MostRecentWav = 0;
}
//*******************************************************************
TACVPSlotsColumn::~TACVPSlotsColumn()
{
}
//*******************************************************************
void TACVPSlotsColumn::SetColumn(int16 num)
{
  if (PColumn == NULL) {return;}
  if (num < 0)
  {
    PColumn->NoShow();
  }
  else
  {
    PColumn->CAD.SetCurrentFrame(num);
    PColumn->Show();
  }
  Update(GetAdjFUC());
}
//*******************************************************************
//void TACVPSlotsCoinsPlayed::SetNum(int16 num)
//{
//  if (PNums == NULL) {return;}
//  PNums->CAD.SetCurrentFrame(num);
//  PNums->Show();
//  Update(GetAdjFUC());
//}
//*******************************************************************