//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  acvscrsp.cpp
//    Project Name:  acvp
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  2.5    10/17/99    M.Perry    original baseline
//********************************************************************
#include "acvscrsp.h"
#include "oanm.h"
//*******************************************************************
TACVPSlotsCredits::TACVPSlotsCredits(TOgleModeWindow *pmw,const TFileMode &NewFileMode)
:TSprite(pmw,NewFileMode)
{
  SetToManual();
  SetupAnms();
}
//*******************************************************************
TACVPSlotsCredits::TACVPSlotsCredits(TOgleModeWindow *pmw,const TFileMode &NewFileMode,void *psource)
:TSprite(pmw,NewFileMode,psource)
{
  SetToManual();
  SetupAnms();
}
//*******************************************************************
TACVPSlotsCredits::~TACVPSlotsCredits()
{
}
//*******************************************************************
void TACVPSlotsCredits::SetupAnms()
{
	 PCredits[0] = GetAnm(4);
	 PCredits[1] = GetAnm(3);
	 PCredits[2] = GetAnm(2);
	 PCredits[3] = GetAnm(1);
	 PCredits[4] = GetAnm(0);

	 for (int16 j=0;j<5;j++)
	 {
		if (PCredits[j] == NULL) {AnmError("Credits","Nums",j);}
	 }

	 for (int16 i=0;i<5;i++)
	 {
		PCredits[i]->CAD.ClearAutoStart();
		PCredits[i]->CAD.ClearAutoStop();
		PCredits[i]->CAD.SetDirStill();
	 }
}
//*****************************************************************
void TACVPSlotsCredits::SetNum(int16 num)
{
	 if (PCredits[0] == NULL) {return;}
	 if (PCredits[1] == NULL) {return;}
	 if (PCredits[2] == NULL) {return;}
	 if (PCredits[3] == NULL) {return;}
	 if (PCredits[4] == NULL) {return;}

	 ones    =  num % 10;
	 tens    = (num / 10  )  % 10;
	 huns    = (num / 100 )  % 10;
	 thou    = (num / 1000)  % 10;
	 tenthou = (num / 10000) % 10;
	 PCredits[0]->CAD.SetCurrentFrame(int16(ones));
	 PCredits[1]->CAD.SetCurrentFrame(int16(tens));
	 PCredits[2]->CAD.SetCurrentFrame(int16(huns));
	 PCredits[3]->CAD.SetCurrentFrame(int16(thou));
	 PCredits[4]->CAD.SetCurrentFrame(int16(tenthou));
    for (int j=0;j<5;j++)
	 {
		PCredits[j]->Show();
	 }
    Update(GetAdjFUC());

}
//*******************************************************************
