//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  acvsmdsp.cpp
//    Project Name:  acvp
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  2.5    10/17/99    M.Perry    original baseline
//********************************************************************
#include "acvsmdsp.h"
#include "oanm.h"
#include "owav.h"
//*******************************************************************
TACVPSlotsMedalion::TACVPSlotsMedalion(TOgleModeWindow *pmw,const TFileMode &NewFileMode)
:TSprite(pmw,NewFileMode)
{
  SetToManual();
  NoShow();
  SetupAnms();
}
//*******************************************************************
TACVPSlotsMedalion::TACVPSlotsMedalion(TOgleModeWindow *pmw,const TFileMode &NewFileMode,void *psource)
:TSprite(pmw,NewFileMode,psource)
{
  SetToManual();
  NoShow();
  SetupAnms();
}
//*******************************************************************
TACVPSlotsMedalion::~TACVPSlotsMedalion()
{
}
//*******************************************************************
void TACVPSlotsMedalion::SetNum(int16 frame)
{
  if(PMedalion->CAD.GetCurrentFrame() < frame)
  {
	 PWave->Start();;
  }
  PMedalion->CAD.SetCurrentFrame(frame);
  PMedalion->Show();
  Update(GetAdjFUC());
}
//*******************************************************************
void TACVPSlotsMedalion::SetupAnms()
{
	PMedalion = GetAnm(0);
	if (PMedalion == NULL) {AnmError("Medalion","Nums",0);}
	PMedalion->CAD.ClearAutoStart();
	PMedalion->CAD.ClearAutoStop();
	PMedalion->CAD.SetDirStill();
	PWave = NULL;
	PWave = GetWav(0);
	if (PWave == NULL) {AnmError("Sound Sprite","sound",0);}
}
//*******************************************************************
