//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  acvsmmsp.cpp
//    Project Name:  acvp
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  2.5    10/17/99    M.Perry    original baseline
//********************************************************************
#include "acvsmmsp.h"
#include "oanm.h"
//*******************************************************************
TACVPSlotsMileMarker::TACVPSlotsMileMarker(TOgleModeWindow *pmw,const TFileMode &NewFileMode)
:TSprite(pmw,NewFileMode)
{
  SetToManual();
  NoShow();
  SetupAnms();
}
//*******************************************************************
TACVPSlotsMileMarker::TACVPSlotsMileMarker(TOgleModeWindow *pmw,const TFileMode &NewFileMode,void *psource)
:TSprite(pmw,NewFileMode,psource)
{
  SetToManual();
  NoShow();
  SetupAnms();
}
//*******************************************************************
TACVPSlotsMileMarker::~TACVPSlotsMileMarker()
{
}
//*******************************************************************
void TACVPSlotsMileMarker::SetNum(int16 frame)
{
  int16 setframe=0;
  if(frame < 0){return;}
  if(frame%100 == 0)
  {
	 if(frame/100){setframe = 4;}
    else
	 {
		PMileMarker->NoShow();
		Update(GetAdjFUC());
		return;
	 }
  }
  else if(frame%100 >= 80)
  {
	 setframe = 3;
  }
  else if(frame%100 >= 60)
  {
	 setframe = 2;
  }
  else if(frame%100 >= 40)
  {
	 setframe = 1;
  }
  else if(frame%100 >= 20)
  {
	 setframe = 0;
  }
  else if(frame%100 >= 0 )
  {
	 PMileMarker->NoShow();
	 Update(GetAdjFUC());
	 return;
  }
  PMileMarker->CAD.SetCurrentFrame(setframe);
  PMileMarker->Show();
  Update(GetAdjFUC());
  return;
}
//*******************************************************************
void TACVPSlotsMileMarker::SetupAnms()
{
	PMileMarker = GetAnm(0);
	if (PMileMarker == NULL) {AnmError("MileMarker","Nums",0);}
	PMileMarker->CAD.ClearAutoStart();
	PMileMarker->CAD.ClearAutoStop();
	PMileMarker->CAD.SetDirStill();
	Update(GetAdjFUC());
}
//*******************************************************************