//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  acvsmusp.cpp
//    Project Name:  acvp
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  2.5    10/17/99    M.Perry    original baseline
//********************************************************************
#include "acvsmusp.h"
#include "oanm.h"
#include "owav.h"
//*******************************************************************
TACVPSlotsMultiplier::TACVPSlotsMultiplier(TOgleModeWindow *pmw,const TFileMode &NewFileMode)
:TSprite(pmw,NewFileMode)
{
  PMultUp = NULL;
  PMultDown = NULL;
  SetToManual();
  SetupAnms();
}
//*******************************************************************
TACVPSlotsMultiplier::TACVPSlotsMultiplier(TOgleModeWindow *pmw,const TFileMode &NewFileMode,void *psource)
:TSprite(pmw,NewFileMode,psource)
{
  PMultUp = NULL;
  PMultDown = NULL;
  SetToManual();
  SetupAnms();
}
//*******************************************************************
TACVPSlotsMultiplier::~TACVPSlotsMultiplier()
{
}
//*******************************************************************
void TACVPSlotsMultiplier::SetNum(int16 frame)
{
  if(PMultUp != NULL)
  {
	 if(PMultiplier->CAD.GetCurrentFrame() < frame)
	 {
		PMultUp->Start();
	 }
	 else if(PMultDown != NULL)
	 {
		if(PMultiplier->CAD.GetCurrentFrame() > frame)
		{
		  PMultDown->Start();
		}
	 }
  }
  PMultiplier->CAD.SetCurrentFrame(frame);
  PMultiplier->Show();
  Update(GetAdjFUC());
}
//*******************************************************************
void TACVPSlotsMultiplier::SetupAnms()
{
	PMultiplier = GetAnm(0);
	if (PMultiplier == NULL) {AnmError("Multiplier","Nums",0);}
	PMultiplier->CAD.ClearAutoStart();
	PMultiplier->CAD.ClearAutoStop();
	PMultiplier->CAD.SetDirStill();
	PMultUp   = GetWav(0);
	PMultDown = GetWav(1);
	Update(GetAdjFUC());
}
//*******************************************************************
