 //********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  acvsrlsp.cpp
//    Project Name:  acvp
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  2.5    10/17/99    M.Perry      original baseline
//********************************************************************
#include "acvsrlsp.h"
#include "oanm.h"
#include "owav.h"
//*******************************************************************
TACVPSlotsReel::TACVPSlotsReel(TOgleModeWindow *pmw,const TFileMode &NewFileMode)
:TSprite(pmw,NewFileMode)
{
  SetToManual();
  BlurFrame0=0;
  BlurFrame1=0;
  BlurFrame2=0;
  NoShowStill = false;
  Blur0 = false;
  Blur1 = false;
  Blur2 = false;
  SetupAnms();
}
//*******************************************************************
TACVPSlotsReel::TACVPSlotsReel(TOgleModeWindow *pmw,const TFileMode &NewFileMode,void *psource)
:TSprite(pmw,NewFileMode,psource)
{
  SetToManual();
  BlurFrame0=0;
  BlurFrame1=0;
  BlurFrame2=0;
  NoShowStill = false;
  Blur0 = false;
  Blur1 = false;
  Blur2 = false;
  SetupAnms();
}
//*******************************************************************
TACVPSlotsReel::~TACVPSlotsReel()
{
}
//*******************************************************************
void TACVPSlotsReel::SetupAnms()
  {
	 PBlur = GetAnm(0);
	 PReel = GetAnm(1);

	 if (PBlur == NULL) {AnmError("Blur","num",0);}
	 if (PReel == NULL) {AnmError("Reel","num",1);}
	 PBlur->CAD.ClearAutoStart();
	 PBlur->CAD.ClearAutoStop();
	 PBlur->CAD.SetDirStill();
	 PBlur->NoShow();
	 PReel->CAD.ClearAutoStart();
	 PReel->CAD.ClearAutoStop();
	 PReel->CAD.SetDirStill();
	 PReel->CAD.SetCurrentFrame(int16(random(22)));
//	 for(int16 i=0;i<22;i++)
//	 {
//		PReelStopSound[i] = GetWav(i);
//		if(PReelStopSound[i] == NULL) {WavError("Reel Sprite","sound",i);}
//	 }
  PReelStopWav = GetWav(0);
  if (PReelStopWav == NULL) {WavError("Reel Sprite","stop sound",0);}
}
//*******************************************************************
void TACVPSlotsReel::PostUpdate(dword NewFUC)
{
  if(NoShowStill)
  {
	 PReel->NoShow();
	 NoShowStill = false;
  }
  if(Blur0)
  {
    BlurFrame0++;
	 if(BlurFrame0 >= 6){BlurFrame0=0;}
	 PBlur->CAD.SetCurrentFrame(BlurFrame0);
	 PBlur->Show();
  }
  TSprite::PostUpdate(NewFUC);
}
//*******************************************************************
void TACVPSlotsReel::SetReel()
{
	 if (PReel == NULL) {return;}
	 PBlur->NoShow();
	 Blur0 = false;
	 PReel->Show();
	 Update(GetAdjFUC());
}
//*******************************************************************
void TACVPSlotsReel::ShowReel()
{
	 if (PReel == NULL) {return;}
	 PBlur->NoShow();
	 Blur0 = false;
	 PReel->Show();
	 int16 x = PReel->CAD.GetCurrentFrame();
//    if (x >= 0 && x < 22)
//    {
//      PReelStopSound[x]->Start();
//    }
    if (PReelStopWav != NULL) {PReelStopWav->Start();}
	 Update(GetAdjFUC());
}
//*******************************************************************
void TACVPSlotsReel::Blur()
{
  Blur0 = true;
  Blur1 = true;
  Blur2 = true;
  BlurFrame0 = int16(random(6));
  BlurFrame1 = int16(random(6));
  BlurFrame2 = int16(random(6));
}
//*******************************************************************
void TACVPSlotsReel::SetNum(int16 reel0)
{
	 if (PReel == NULL) {return;}

	 PReel->CAD.SetCurrentFrame(reel0);
	 PReel->NoShow();
	 Update(GetAdjFUC());
}
//*******************************************************************

