//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  acvszssp.cpp
//    Project Name:  acvp
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  2.5    10/17/99    M.Perry    original baseline
//********************************************************************
#include "acvszssp.h"
#include "oanm.h"
//*******************************************************************
TACVPSlotsZodiacSign::TACVPSlotsZodiacSign(TOgleModeWindow *pmw,const TFileMode &NewFileMode)
:TSprite(pmw,NewFileMode)
{
  SetToManual();
  SetupAnms();
  CurrentSign = 3;
}
//*******************************************************************
TACVPSlotsZodiacSign::TACVPSlotsZodiacSign(TOgleModeWindow *pmw,const TFileMode &NewFileMode,void *psource)
:TSprite(pmw,NewFileMode,psource)
{
  SetToManual();
  SetupAnms();
  CurrentSign = 3;
}
//*******************************************************************
TACVPSlotsZodiacSign::~TACVPSlotsZodiacSign()
{
}
//*******************************************************************
int TACVPSlotsZodiacSign::GetCurrentSign()
{
  switch(CurrentSign)
  {
	 case 0  : return 4;
	 case 1  : return 3;
	 case 2  : return 2;
	 case 3  : return 1;
	 default : return 0;
  }
}
//*******************************************************************
int TACVPSlotsZodiacSign::Cycle()
{
  CurrentSign = int16((CurrentSign+1)%4);
  PZodiacSign->CAD.SetCurrentFrame(CurrentSign);
  PZodiacSign->Show();
  Update(GetAdjFUC());
  return CurrentSign;
}
//*******************************************************************
void TACVPSlotsZodiacSign::SetupAnms()
{
	PZodiacSign = GetAnm(0);
	if (PZodiacSign == NULL) {AnmError("ZodiacSign","Nums",0);}
	PZodiacSign->CAD.ClearAutoStart();
	PZodiacSign->CAD.ClearAutoStop();
	PZodiacSign->CAD.SetDirStill();
	PZodiacSign->CAD.SetCurrentFrame(CurrentSign);
	PZodiacSign->Show();
	Update(GetAdjFUC());
}
//*******************************************************************
