//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  caschsp.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0    12/23/95   M.Perry     moved inline header to cpp file.
//  2.0    09/02/97   M.Perry     32-bit conversion.
//********************************************************************
#include "caschsp.h"
#include "oanm.h"
#include "owav.h"
//*******************************************************************
TCasChips::TCasChips(TOgleModeWindow *pmw,const TFileMode &NewFileMode)
:TSprite(pmw,NewFileMode)
{
  oldnum = 1000l;
  col1 = 5;
  col2 = 4;
  col3 = 3;
  col4 = 9;
  col5 = 0;
  col6 = 0;

  SetToManual();
  NoShow();
  SetupAnms();
  SetupWavs();
}
//*******************************************************************
TCasChips::TCasChips(TOgleModeWindow *pmw,const TFileMode &NewFileMode,void *psource)
  :TSprite(pmw,NewFileMode,psource)
{
  oldnum = 1000l;
  col1 = 5;
  col2 = 4;
  col3 = 3;
  col4 = 9;
  col5 = 0;
  col6 = 0;
  SetToManual();
  NoShow();
  SetupAnms();
  SetupWavs();
}
//*******************************************************************
TCasChips::~TCasChips()
{
}
//*******************************************************************
void TCasChips::NoShowCards()
{
  for(int16 i=0;i<6;i++)
  {
	 PChips[i]->NoShow();
  }
}
//*******************************************************************
void TCasChips::SetupAnms()
{
  for (int16 i=0;i<6;i++)
  {
	 PChips[i] = GetAnm(i);
	 if (PChips[i] == NULL) {AnmError("CasChips","Chips",i);}
  }

  for (int16 j=0;j<6;j++)
  {
	 PChips[j]->CAD.ClearAutoStart();
	 PChips[j]->CAD.ClearAutoStop();
	 PChips[j]->CAD.SetDirStill();
  }
}
//*******************************************************************
void TCasChips::SetupWavs()
{
  OneChip = GetWav(0);
  TwoChip = GetWav(1);
  ThreeChip = GetWav(2);
}
//*******************************************************************
void TCasChips::SetupCols(TMoney money,int16 a,int16 b,int16 c,int16 d,int16 e,int16 f,bool sound)
{
  TMoney sum=0l;   //???New// int sum=0;
  sum += 1l*a;
  sum += 5l*b;
  sum += 25l*c;
  sum += 100l*d;
  sum += 1000l*e;
  sum += 10000l*f;
  for(int16 i=0;i<6;i++)
  {
	 PChips[i]->NoShow();
  }
  if(sum == money)
  {
	 oldnum = money;
	 col1 = a;
	 col2 = b;
	 col3 = c;
	 col4 = d;
	 col5 = e;
	 col6 = f;
	 SetNum(oldnum,sound);
  }
  else
  {
	 oldnum = 0l;
	 col1 = 0;
	 col2 = 0;
	 col3 = 0;
	 col4 = 0;
	 col5 = 0;
	 col6 = 0;
	 SetNum(money,sound);
  }
}
//*******************************************************************
void TCasChips::SetNum(TMoney money,bool sound)
{
  if(money == 0.0)
  {
	 for(int16 i=0;i<6;i++)
	 {
		PChips[i]->NoShow();
	 }
	 oldnum = 0l;
	 col1 = 0;
	 col2 = 0;
	 col3 = 0;
	 col4 = 0;
	 col5 = 0;
	 col6 = 0;
	 return;
  }
  if(money > oldnum)
  {
	 AddChips(money,sound);
  }
  else if(money < oldnum)
  {
	 SubChips(money);  //Make sure in state that you can subtract this much
  }
  else if(money == oldnum)
  {
	 if(col1)
	 {
		PChips[0]->CAD.SetCurrentFrame(int16(col1-1));
		PChips[0]->Show();
	 }
	 else
	 {
		PChips[0]->NoShow();
	 }
	 if(col2)
	 {
		PChips[1]->CAD.SetCurrentFrame(int16(col2-1));
		PChips[1]->Show();
	 }
	 else
	 {
		PChips[1]->NoShow();
	 }
	 if(col3)
	 {
		PChips[2]->CAD.SetCurrentFrame(int16(col3-1));
		PChips[2]->Show();
	 }
	 else
	 {
		PChips[2]->NoShow();
	 }
	 if(col4)
	 {
		PChips[3]->CAD.SetCurrentFrame(int16(col4-1));
		PChips[3]->Show();
	 }
	 else
	 {
		PChips[3]->NoShow();
	 }
	 if(col5)
	 {
		PChips[4]->CAD.SetCurrentFrame(int16(col5-1));
		PChips[4]->Show();
	 }
	 else
	 {
		PChips[4]->NoShow();
	 }
	 if(col6)
	 {
		PChips[5]->CAD.SetCurrentFrame(int16(col6-1));
		PChips[5]->Show();
	 }
	 else
	 {
		PChips[5]->NoShow();
	 }
  }
  Update(GetAdjFUC());
}
//*******************************************************************
void TCasChips::AddChips(TMoney money,bool sound)
{
  int32 num = (int32)money;
  int32 chips=0;
  int32 diff=0;
  int32 c1,c2,c3,c4,c5,c6;
  diff = num - (int32)oldnum;
  c6 = (diff%100000l)/10000;
  c5 = (diff%10000)/1000;
  c4 = (diff%1000)/100;
  c3 = (diff%100)/25;
  c2 = (diff%25)/5;
  c1 = (diff%5);
  chips = c6+c5+c4+c3+c2+c1;
  if(sound)
  {
	 if(chips==1 && OneChip != NULL){OneChip->Start();}
	 else if(chips>=2 && chips <= 4 && TwoChip != NULL){TwoChip->Start();}
	 else if(chips>=5 && ThreeChip != NULL){ThreeChip->Start();}
  }

  if (c1)
  {
	 if(c1+col1 < 11)
	 {
		col1 += int16(c1);
		PChips[0]->CAD.SetCurrentFrame(int16(col1-1));
		PChips[0]->Show();
	 }
	 else
	 {
		col1 = int16(c1+col1-5);
		c2++;
		PChips[0]->CAD.SetCurrentFrame(int16(col1-1));
		PChips[0]->Show();
	 }
  }

  if (c2)
  {
	 if(c2+col2 < 11)
	 {
		col2 += int16(c2);
		PChips[1]->CAD.SetCurrentFrame(int16(col2-1));
		PChips[1]->Show();
	 }
	 else
	 {
		col2 = int16(c2+col2-5);
		c3++;
		PChips[1]->CAD.SetCurrentFrame(int16(col2-1));
		PChips[1]->Show();
	 }
  }

  if (c3)
  {
	 if(c3+col3 < 11)
	 {
		col3 += int16(c3);
		PChips[2]->CAD.SetCurrentFrame(int16(col3-1));
		PChips[2]->Show();
	 }
	 else
	 {
		col3 = int16(c3+col3-4);
		c4++;
		PChips[2]->CAD.SetCurrentFrame(int16(col3-1));
		PChips[2]->Show();
	 }
  }

  if (c4)
  {
	 if(c4+col4 < 11)
	 {
		col4 += int16(c4);
		PChips[3]->CAD.SetCurrentFrame(int16(col4-1));
		PChips[3]->Show();
	 }
	 else
	 {
		col4 = int16(c4+col4-10);
		c5++;
		PChips[3]->CAD.SetCurrentFrame(int16(col4-1));
		PChips[3]->Show();
	 }
  }

  if (c5)
  {
	 if(c5+col5 < 11)
	 {
		col5 += int16(c5);
		PChips[4]->CAD.SetCurrentFrame(int16(col5-1));
		PChips[4]->Show();
	 }
	 else
	 {
		col5 = int16(c5+col5-10);
		c6++;
		PChips[4]->CAD.SetCurrentFrame(int16(col5-1));
		PChips[4]->Show();
	 }
  }

  if (c6)
  {
	 if(c6+col6 < 11)
	 {
		col6 += int16(c6);
		PChips[5]->CAD.SetCurrentFrame(int16(col6-1));
		PChips[5]->Show();
	 }
	 else
	 {
		col6 = int16(c6+col6-10);
		PChips[5]->CAD.SetCurrentFrame(int16(col6-1));
		PChips[5]->Show();
	 }
  }
  oldnum = money;
}
//*******************************************************************
int16 TCasChips::GetBorrow(int32 convertto)
{
  int32 convertfrom=0;
  switch(convertto) {
  case 1     :  if(col2 > 1)
					{
					  convertfrom=5;Convert(convertfrom,convertto);col2--;return 1;
  					}
  case 5     :  if(col3 > 1)
  					{
  					  convertfrom=25;Convert(convertfrom,convertto);col3--;return 1;
  					}
  case 25    :  if(col4 > 1)
  					{
  					  convertfrom=100;Convert(convertfrom,convertto);col4--;return 1;
  					}
  case 100   :  if(col5 > 1)
  					{
  					  convertfrom=1000;Convert(convertfrom,convertto);col5--;return 1;
  					}
  case 1000  :  if(col6 > 1)
  					{
  					  convertfrom=10000;Convert(convertfrom,convertto);col6--;return 1;
					}
  case 10000 :  if(((int32)((int32)oldnum-(col1)-(col2*5l)-(col3*25l)-(col4*100l)-(col5*1000l)))/100000l)
  					{
  					  convertfrom=100000l;Convert(convertfrom,convertto);return 1;
  					}
  }
  switch(convertto) {
  case 1     :  if(col2 == 1)
  					{
  					  convertfrom=5;Convert(convertfrom,convertto);col2--;return 1;
  					}
  case 5     :  if(col3 == 1)
  					{
  					  convertfrom=25;Convert(convertfrom,convertto);col3--;return 1;
  					}
  case 25    :  if(col4 == 1)
  					{
  					  convertfrom=100;Convert(convertfrom,convertto);col4--;return 1;
					}
  case 100   :  if(col5 == 1)
  					{
  					  convertfrom=1000;Convert(convertfrom,convertto);col5--;return 1;
  					}
  case 1000  :  if(col6 == 1)
  					{
  					  convertfrom=10000;Convert(convertfrom,convertto);col6--;return 1;
  					}
  case 10000 :  if(((int32)((int32)oldnum-(col1)-(col2*5)-(col3*25)-(col4*100)-(col5*1000)))/100000l)
  					{
  					  convertfrom=100000l;Convert(convertfrom,convertto);return 1;
  					}
  }

  return 0;
}
//*******************************************************************
void TCasChips::Convert(int32 confrom,int32 conto)
{
  if(confrom == 100000l)
  {
    if(conto == 1)
    {
      col6+=int16(9);
      col5+=int16(9);
      col4+=int16(9);
      col3+=int16(3);
      col2+=int16(4);
      col1+=int16(5);
    }
    if(conto == 5)
    {
      col6+=int16(9);
      col5+=int16(9);
      col4+=int16(9);
      col3+=int16(3);
      col2+=int16(5);
    }
    if(conto == 25)
    {
      col6+=int16(9);
      col5+=int16(9);
      col4+=int16(9);
      col3+=int16(4);
    }
    if(conto == 100)
    {
      col6+=int16(9);
      col5+=int16(9);
      col4+=int16(10);
    }
    if(conto == 1000)
    {
       col6+=int16(9);
       col5+=int16(10);
    }
    if(conto == 10000)
    {
      col6+=int16(10);
    }
  }
  if(confrom == 10000)
  {
    if(conto == 1)
    {
      col5+=int16(9);
      col4+=int16(9);
      col3+=int16(3);
      col2+=int16(4);
      col1+=int16(5);
    }
    if(conto == 5)
    {
      col5+=int16(9);
      col4+=int16(9);
      col3+=int16(3);
      col2+=int16(5);
    }
    if(conto == 25)
    {
       col5+=int16(9);
       col4+=int16(9);
       col3+=int16(4);
    }
    if(conto == 100)
    {
      col5+=int16(9);
      col4+=int16(10);
    }
    if(conto == 1000)
    {
       col5+=int16(10);
    }
  }
  if(confrom == 1000)
  {
    if(conto == 1)
    {
      col4+=int16(9);
      col3+=int16(3);
      col2+=int16(4);
      col1+=int16(5);
    }
    if(conto == 5)
    {
      col4+=int16(9);
      col3+=int16(3);
      col2+=int16(5);
    }
    if(conto == 25)
    {
      col4+=int16(9);
      col3+=int16(4);
    }
    if(conto == 100)
    {
      col4+=int16(10);
    }
  }
  if(confrom == 100)
  {
	 if(conto == 1)
    {
      col3+=int16(3);
      col2+=int16(4);
      col1+=int16(5);
    }
    if(conto == 5)
    {
      col3+=int16(3);
      col2+=int16(5);
    }
    if(conto == 25)
    {
      col3+=int16(4);
    }
  }
  if(confrom == 25)
  {
    if(conto == 1)
    {
      col2+=int16(4);
      col1+=int16(5);
    }
    if(conto == 5)
    {
      col2+=int16(5);
    }
  }
  if(confrom == 5)
  {
    if(conto == 1)
    {
      col1+=int16(5);
    }
  }
}
//*******************************************************************
void TCasChips::SubChips(TMoney money)
{
  int32 num = (int32)money;
  int32 diff=0;
  int32 c1,c2,c3,c4,c5,c6;
  diff = (int32)oldnum - num;
  c6 = (diff%100000l)/10000;
  c5 = (diff%10000)/1000;
  c4 = (diff%1000)/100;
  c3 = (diff%100)/25;
  c2 = (diff%25)/5;
  c1 = (diff%5);

  if (c1)
  {
    if(col1-c1 > 0)
    {
      col1 -= int16(c1);
      PChips[0]->CAD.SetCurrentFrame(int16(col1-1));
      PChips[0]->Show();
    }
    else
    {
      if(GetBorrow(1))
      {
        col1 -= int16(c1);
		  PChips[0]->CAD.SetCurrentFrame(int16(col1-1));
		  PChips[0]->Show();
		}
		else
		{
		  if(col1-c1 == 0)
		  {
			 col1 = 0;
			 PChips[0]->NoShow();
		  }
		  else
		  {
			 return ;  //error
		  }
		}
	 }
  }
  else
  {
	 if(col1)
	 {
		PChips[0]->CAD.SetCurrentFrame(int16(col1-1));
		PChips[0]->Show();
	 }
    else
	 {
		PChips[0]->NoShow();
	 }
  }

  if (c2)
  {
	 if(col2-c2 > 0)
	 {
		col2 -= int16(c2);
      PChips[1]->CAD.SetCurrentFrame(int16(col2-1));
      PChips[1]->Show();
    }
    else
    {
      if(GetBorrow(5))
      {
        col2 -= int16(c2);
        PChips[1]->CAD.SetCurrentFrame(int16(col2-1));
        PChips[1]->Show();
      }
      else
      {
        if(col2-c2 == 0)
        {
			 col2 = 0;
          PChips[1]->NoShow();
        }
        else
        {
          return ;  //error
        }
      }
    }
  }
  else
  {
    if(col2)
    {
      PChips[1]->CAD.SetCurrentFrame(int16(col2-1));
      PChips[1]->Show();
	 }
    else
	 {
		PChips[1]->NoShow();
	 }
  }

  if (c3)
  {
    if(col3-c3 > 0)
    {
      col3 -= int16(c3);
      PChips[2]->CAD.SetCurrentFrame(int16(col3-1));
      PChips[2]->Show();
    }
    else
    {
		if(GetBorrow(25))
      {
        col3 -= int16(c3);
        PChips[2]->CAD.SetCurrentFrame(int16(col3-1));
        PChips[2]->Show();
      }
      else
      {
        if(col3-c3 == 0)
        {
          col3 = 0;
          PChips[2]->NoShow();
        }
        else
        {
          return ;  //error
        }
      }
    }
  }
  else
  {
    if(col3)
    {
      PChips[2]->CAD.SetCurrentFrame(int16(col3-1));
		PChips[2]->Show();
	 }
    else
	 {
		PChips[2]->NoShow();
	 }
  }

  if (c4)
  {
    if(col4-c4 > 0)
    {
      col4 -= int16(c4);
      PChips[3]->CAD.SetCurrentFrame(int16(col4-1));
      PChips[3]->Show();
    }
    else
    {
      if(GetBorrow(100))
      {
        col4 -= int16(c4);
        PChips[3]->CAD.SetCurrentFrame(int16(col4-1));
        PChips[3]->Show();
      }
      else
      {
        if(col4-c4 == 0)
        {
          col4 = 0;
          PChips[3]->NoShow();
        }
        else
        {
          return ;  //error
        }
      }
    }
  }
  else
  {
    if(col4)
    {
      PChips[3]->CAD.SetCurrentFrame(int16(col4-1));
      PChips[3]->Show();
	 }
    else
	 {
		PChips[3]->NoShow();
	 }
  }

  if (c5)
  {
    if(col5-c5 > 0)
    {
      col5 -= int16(c5);
      PChips[4]->CAD.SetCurrentFrame(int16(col5-1));
      PChips[4]->Show();
    }
    else
    {
      if(GetBorrow(1000))
      {
        col5 -= int16(c5);
        PChips[4]->CAD.SetCurrentFrame(int16(col5-1));
        PChips[4]->Show();
      }
      else
      {
        if(col5-c5 == 0)
		  {
          col5 = 0;
          PChips[4]->NoShow();
        }
        else
        {
          return ;  //error
        }
      }
    }
  }
  else
  {
    if(col5)
    {
      PChips[4]->CAD.SetCurrentFrame(int16(col5-1));
      PChips[4]->Show();
	 }
    else
	 {
		PChips[4]->NoShow();
	 }
  }
  if (c6)
  {
    if(col6-c6 > 0)
    {
      col6 -= int16(c6);
      PChips[5]->CAD.SetCurrentFrame(int16(col6-1));
      PChips[5]->Show();
    }
    else
    {
		if(GetBorrow(10000))
      {
        col6 -= int16(c6);
        PChips[5]->CAD.SetCurrentFrame(int16(col6-1));
        PChips[5]->Show();
      }
      else
		{
        if(col6-c6 == 0)
        {
          col6 = 0;
          PChips[5]->NoShow();
        }
        else
        {
          return ;  //error
        }
      }
    }
  }
  else
  {
    if(col6)
    {
		PChips[5]->CAD.SetCurrentFrame(int16(col6-1));
		PChips[5]->Show();
	 }
	 else
	 {
		PChips[5]->NoShow();
	 }
  }
  oldnum = money;
}
//*******************************************************************
