//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  casdata.cpp
//    Project Name:  Casino                
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     9/9/96    M.Perry     split up cplaydat file.
//  2.0    08/31/97   M.Perry     32-bit conversion.
//********************************************************************
#include "casdata.h"
//*******************************************************************
TCasinoSession::TCasinoSession()
{
  ClearData();
}
//*******************************************************************
void TCasinoSession::ClearData()
{
//  GameName = gnNone;
  GameSubtype = gtNone;
  GameDenom = 0.0;
  Valid = false;
  InPlay = false;
  StartingTime = 0;
  EndingTime = 0;
  StartingCash = 0l;
  EndingCash = 0l;
  TotalBetsCash = 0l;
  Wins = 0;
  Losses = 0;
  HandsPlayed = 0;
  IncorrectPlays = 0;
  WinStreak = 0;
  LosingStreak = 0;
  CurrentWinStreak = 0;
  CurrentLosingStreak = 0;
  LargestWin = 0l;
  LargestLoss = 0l;
  PeakWin = 0l;
  PeakLoss = 0l;
}
//*******************************************************************
void TCasinoSession::SetStartingTime()
{
  StartingTime = TTime().Seconds();
}
//*******************************************************************
void TCasinoSession::SetEndingTime()
{
  EndingTime = TTime().Seconds();
}
//*******************************************************************
void TCasinoSession::StartSession(TMoney startingcash,int16 subgametype,TMoney denom)
{
  ClearData();
  SetStartingTime();
  Valid = true;
  InPlay = true;
  StartingCash = startingcash;
  GameSubtype = subgametype;
  GameDenom = denom;
  PeakLoss = startingcash;
  PeakWin = startingcash;
}
//*******************************************************************
void TCasinoSession::EndSession(TMoney endingcash)
{
  EndingCash = endingcash;
  SetEndingTime();
  InPlay = false;
}
//*******************************************************************
TCasinoData::TCasinoData()
{
  ClearData();
}
//*******************************************************************
void TCasinoData::ClearData()
{
  OverallWL = 0l;
  CurrentSession = 0;
}
//*******************************************************************
