//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  casmessp.cpp
//    Project Name:  Casino
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0    12/23/95    M.Perry    moved inline functions into .cpp file.
//  2.0    09/16/97    M.Perry    32-bit conversion.
//********************************************************************
#include "casmessp.h"
#include "oanm.h"

#define DigitSize 8
#define BitmapSize 41
#define WindowSize 188
//*******************************************************************
TCasMessageDisplay::TCasMessageDisplay(TOgleModeWindow *pmw,TFileMode NewFileMode,void *psource)
:TSprite(pmw,NewFileMode,psource)
{
  NoShow();
  SetToManual();
  SetupAnms();
  DelayEndFUC = 0;
  DELAY = false;
}
//*******************************************************************
TCasMessageDisplay::TCasMessageDisplay(TOgleModeWindow *pmw,TFileMode NewFileMode):TSprite(pmw,NewFileMode)
{
  NoShow();
  SetToManual();
  SetupAnms();
  DelayEndFUC = 0;
  DELAY = false;
}
//********************************************************************
TCasMessageDisplay::~TCasMessageDisplay()
{
}
//*******************************************************************
void TCasMessageDisplay::ShowLobbyMessage(int code)
{
	 NoShowDisplay();
	 PMessage->CAD.SetCurrentFrame(int16(code));
	 PMessage->Show();
	 Update(GetAdjFUC());
}
//*******************************************************************
void TCasMessageDisplay::ShowBJMessage(int code,TMoney money,bool bjack)
{
	 NoShowDisplay();
	 PMessage->CAD.SetCurrentFrame(int16(code));
	 if(code == 52)
	 {
		if(bjack){POdds->CAD.SetCurrentFrame(1);}
		else     {POdds->CAD.SetCurrentFrame(0);}
		SetNum(money);
	 }
	 PMessage->Show();
	 Update(GetAdjFUC());
}
//*******************************************************************
void TCasMessageDisplay::ShowMessage(int code,TMoney money)
{
	 NoShowDisplay();
	 switch(code)
	 {
		case 0  : PMessage->CAD.SetCurrentFrame(0);break;
		case 1  : PMessage->CAD.SetCurrentFrame(1);break;
		case 2  : PMessage->CAD.SetCurrentFrame(2);break;
		case 3  : PMessage->CAD.SetCurrentFrame(3);break;
		case 4  : PMessage->CAD.SetCurrentFrame(4);break;
		case 5  : PMessage->CAD.SetCurrentFrame(5);break;
		case 6  : PMessage->CAD.SetCurrentFrame(6);break;
		case 7  : PMessage->CAD.SetCurrentFrame(7);break;
		case 8  : PMessage->CAD.SetCurrentFrame(8);break;
		case 9  : PMessage->CAD.SetCurrentFrame(9);break;
		case 10 : PMessage->CAD.SetCurrentFrame(10);break;
		case 11 : PMessage->CAD.SetCurrentFrame(11);break;
		case 12 : PMessage->CAD.SetCurrentFrame(12);break;
		case 13 : PMessage->CAD.SetCurrentFrame(13);RouletteOdds(om35To1);SetNum(money);break;
		case 14 : PMessage->CAD.SetCurrentFrame(14);RouletteOdds(om17To1);SetNum(money);break;
		case 15 : PMessage->CAD.SetCurrentFrame(15);RouletteOdds(om11To1);SetNum(money);break;
		case 16 : PMessage->CAD.SetCurrentFrame(16);RouletteOdds(om8To1);SetNum(money);break;
		case 17 : PMessage->CAD.SetCurrentFrame(17);RouletteOdds(om6To1);SetNum(money);break;
		case 18 : PMessage->CAD.SetCurrentFrame(18);RouletteOdds(om5To1);SetNum(money);break;
		case 19 : PMessage->CAD.SetCurrentFrame(19);RouletteOdds(om2To1);SetNum(money);break;
		case 20 : PMessage->CAD.SetCurrentFrame(20);RouletteOdds(om2To1);SetNum(money);break;
		case 21 : PMessage->CAD.SetCurrentFrame(21);RouletteOdds(om1To1);SetNum(money);break;
		case 22 : PMessage->CAD.SetCurrentFrame(22);RouletteOdds(om1To1);SetNum(money);break;
		case 23 : PMessage->CAD.SetCurrentFrame(23);RouletteOdds(om1To1);SetNum(money);break;
		case 24 : PMessage->CAD.SetCurrentFrame(24);break;
		case 25 : PMessage->CAD.SetCurrentFrame(25);break;
		case 26 : PMessage->CAD.SetCurrentFrame(26);break;
		case 27 : PMessage->CAD.SetCurrentFrame(27);break;
		case 28 : PMessage->CAD.SetCurrentFrame(28);break;
		case 29 : PMessage->CAD.SetCurrentFrame(29);break;
		case 30 : PMessage->CAD.SetCurrentFrame(30);break;
		case 31 : PMessage->CAD.SetCurrentFrame(31);break;
		case 32 : PMessage->CAD.SetCurrentFrame(32);break;
		case 33 : PMessage->CAD.SetCurrentFrame(33);break;
		case 34 : PMessage->CAD.SetCurrentFrame(34);break;
		case 35 : PMessage->CAD.SetCurrentFrame(35);break;
		case 36 : PMessage->CAD.SetCurrentFrame(36);break;
		case 37 : PMessage->CAD.SetCurrentFrame(37);break;
		case 38 : PMessage->CAD.SetCurrentFrame(38);break;
		case 39 : PMessage->CAD.SetCurrentFrame(39);break;
		case 40 : PMessage->CAD.SetCurrentFrame(40);break;
		case 41 : PMessage->CAD.SetCurrentFrame(41);break;
		case 42 : PMessage->CAD.SetCurrentFrame(42);break;
		case 43 : PMessage->CAD.SetCurrentFrame(43);break;
	 }
	 PMessage->Show();
	 Update(GetAdjFUC());
}
//*******************************************************************
void TCasMessageDisplay::CrapOdds(int odds)
{
  switch(odds)
  {
	 case om1To2  : POdds->CAD.SetCurrentFrame(4);break;
	 case om2To3  : POdds->CAD.SetCurrentFrame(5);break;
	 case om5To6  : POdds->CAD.SetCurrentFrame(6);break;
	 case om1To1  : POdds->CAD.SetCurrentFrame(0);break;
	 case om2To1  : POdds->CAD.SetCurrentFrame(1);break;
	 case om3To2  : POdds->CAD.SetCurrentFrame(2);break;
	 case om6To5  : POdds->CAD.SetCurrentFrame(3);break;
	 case om3To1  : POdds->CAD.SetCurrentFrame(7);break;
	 case om9To5  : POdds->CAD.SetCurrentFrame(8);break;
	 case om7To5  : POdds->CAD.SetCurrentFrame(9);break;
	 case om7To6  : POdds->CAD.SetCurrentFrame(10);break;
	 case om4To1  : POdds->CAD.SetCurrentFrame(11);break;
	 case om7To1  : POdds->CAD.SetCurrentFrame(12);break;
	 case om9To1  : POdds->CAD.SetCurrentFrame(13);break;
	 case om15To1 : POdds->CAD.SetCurrentFrame(14);break;
	 case om30To1 : POdds->CAD.SetCurrentFrame(15);break;
  }
}
//*******************************************************************
void TCasMessageDisplay::RouletteOdds(int odds)
{
  switch(odds)
  {
	 case om1To1  :  POdds->CAD.SetCurrentFrame(0);break;
	 case om2To1  :  POdds->CAD.SetCurrentFrame(1);break;
	 case om5To1  :  POdds->CAD.SetCurrentFrame(2);break;
	 case om6To1  :  POdds->CAD.SetCurrentFrame(3);break;
	 case om8To1  :  POdds->CAD.SetCurrentFrame(4);break;
	 case om11To1 :  POdds->CAD.SetCurrentFrame(5);break;
	 case om17To1 :  POdds->CAD.SetCurrentFrame(6);break;
	 case om35To1 :  POdds->CAD.SetCurrentFrame(7);break;
  }
}
//*******************************************************************
int TCasMessageDisplay::HornOdds(int point)
{
  if(point == 12 || point == 2){return om30To1;}
  return om15To1;
}
//*******************************************************************
int TCasMessageDisplay::CEOdds(int point)
{
  if(point == 11){return om15To1;}
  return om7To1;
}
//*******************************************************************
int TCasMessageDisplay::FreeOdds(int point)
{
  if(point > 100)
  {
	 point = point/100;
	 if(point == 2 || point == 12){return om2To1;}
	 return om1To1;
  }
  switch(point)
  {
	 case -4  : return om1To2;
	 case -5  : return om2To3;
	 case -6  : return om5To6;
	 case -8  : return om5To6;
	 case -9  : return om2To3;
	 case -10 : return om1To2;
	 case 4   : return om2To1;
	 case 5   : return om3To2;
	 case 6   : return om6To5;
	 case 8   : return om6To5;
	 case 9   : return om3To2;
	 case 10  : return om2To1;
	 default  : return om1To1;
  }
}
//*******************************************************************
void TCasMessageDisplay::ShowCrapsMessage(int code,TMoney money,int point)
{
	 NoShowDisplay();
	 point += 2;
	 switch(code)
	 {
		case 0  : PMessage->CAD.SetCurrentFrame(0);break;
		case 1  : PMessage->CAD.SetCurrentFrame(1);break;
		case 2  : PMessage->CAD.SetCurrentFrame(2);break;
		case 3  : PMessage->CAD.SetCurrentFrame(3);break;
		case 4  : PMessage->CAD.SetCurrentFrame(4);break;
		case 5  : PMessage->CAD.SetCurrentFrame(5);break;
		case 6  : PMessage->CAD.SetCurrentFrame(6);break;
		case 7  : PMessage->CAD.SetCurrentFrame(7);break;
		case 8  : PMessage->CAD.SetCurrentFrame(8);break;
		case 9  : PMessage->CAD.SetCurrentFrame(9);break;
		case 10 : PMessage->CAD.SetCurrentFrame(10);break;
		case 11 : PMessage->CAD.SetCurrentFrame(11);break;
		case 12 : PMessage->CAD.SetCurrentFrame(12);break;
		case 13 : PMessage->CAD.SetCurrentFrame(13);break;
		case 14 : PMessage->CAD.SetCurrentFrame(14);break;
		case 15 : PMessage->CAD.SetCurrentFrame(15);break;
		case 16 : PMessage->CAD.SetCurrentFrame(16);break;
		case 17 : PMessage->CAD.SetCurrentFrame(17);break;
		case 18 : PMessage->CAD.SetCurrentFrame(18);break;
		case 19 : PMessage->CAD.SetCurrentFrame(19);break;
		case 20 : PMessage->CAD.SetCurrentFrame(20);break;
		case 21 : PMessage->CAD.SetCurrentFrame(21);break;
		case 22 : PMessage->CAD.SetCurrentFrame(22);break;
		case 23 : PMessage->CAD.SetCurrentFrame(23);break;
		case 24 : PMessage->CAD.SetCurrentFrame(24);break;
		case 25 : PMessage->CAD.SetCurrentFrame(25);break;
		case 26 : PMessage->CAD.SetCurrentFrame(26);break;
		case 27 : PMessage->CAD.SetCurrentFrame(27);break;
		case 28 : PMessage->CAD.SetCurrentFrame(28);break;
		case 29 : PMessage->CAD.SetCurrentFrame(29);break;
		case 30 : PMessage->CAD.SetCurrentFrame(30);break;
		case 31 : PMessage->CAD.SetCurrentFrame(31);break;
		case 32 : PMessage->CAD.SetCurrentFrame(32);break;
		case 33 : PMessage->CAD.SetCurrentFrame(33);break;
		case 34 : PMessage->CAD.SetCurrentFrame(34);break;
		case 35 : PMessage->CAD.SetCurrentFrame(35);break;
		case 36 : PMessage->CAD.SetCurrentFrame(36);break;
		case 37 : PMessage->CAD.SetCurrentFrame(37);break;
		case 38 : PMessage->CAD.SetCurrentFrame(38);break;
		case 39 : PMessage->CAD.SetCurrentFrame(39);break;
		case 40 : PMessage->CAD.SetCurrentFrame(40);break;
		case 41 : PMessage->CAD.SetCurrentFrame(41);break;
		case 42 : PMessage->CAD.SetCurrentFrame(42);break;
		case 43 : PMessage->CAD.SetCurrentFrame(43);break;
		case 44 : PMessage->CAD.SetCurrentFrame(44);break;
		case 45 : PMessage->CAD.SetCurrentFrame(45);break;
		case 46 : PMessage->CAD.SetCurrentFrame(46);break;
		case 47 : PMessage->CAD.SetCurrentFrame(47);break;
		case 48 : PMessage->CAD.SetCurrentFrame(48);break;
		case 49 : PMessage->CAD.SetCurrentFrame(49);break;
		case 50 : PMessage->CAD.SetCurrentFrame(50);break;
		case 51 : PMessage->CAD.SetCurrentFrame(51);break;
		case 52 : PMessage->CAD.SetCurrentFrame(52);CrapOdds(om1To1);         SetNum(money);break;
		case 53 : PMessage->CAD.SetCurrentFrame(53);CrapOdds(om1To1);         SetNum(money);break;
		case 54 : PMessage->CAD.SetCurrentFrame(54);CrapOdds(om1To1);         SetNum(money);break;
		case 55 : PMessage->CAD.SetCurrentFrame(55);CrapOdds(om1To1);         SetNum(money);break;
		case 56 : PMessage->CAD.SetCurrentFrame(56);CrapOdds(FreeOdds(point));SetNum(money);break;
		case 57 : PMessage->CAD.SetCurrentFrame(57);CrapOdds(FreeOdds(-point));SetNum(money);break;
		case 58 : PMessage->CAD.SetCurrentFrame(58);CrapOdds(FreeOdds(point));SetNum(money);break;
		case 59 : PMessage->CAD.SetCurrentFrame(59);CrapOdds(FreeOdds(-point));SetNum(money);break;
		case 60 : PMessage->CAD.SetCurrentFrame(60);CrapOdds(om1To1);         SetNum(money);break;
		case 61 : PMessage->CAD.SetCurrentFrame(61);CrapOdds(om1To1);         SetNum(money);break;
		case 62 : PMessage->CAD.SetCurrentFrame(62);CrapOdds(FreeOdds(point*100));SetNum(money);break;
		case 63 : PMessage->CAD.SetCurrentFrame(63);CrapOdds(om2To1);SetNum(money);break;
		case 64 : PMessage->CAD.SetCurrentFrame(64);CrapOdds(om3To2);SetNum(money);break;
		case 65 : PMessage->CAD.SetCurrentFrame(65);CrapOdds(om6To5);SetNum(money);break;
		case 66 : PMessage->CAD.SetCurrentFrame(66);CrapOdds(om6To5);SetNum(money);break;
		case 67 : PMessage->CAD.SetCurrentFrame(67);CrapOdds(om3To2);SetNum(money);break;
		case 68 : PMessage->CAD.SetCurrentFrame(68);CrapOdds(om2To1);SetNum(money);break;
		case 69 : PMessage->CAD.SetCurrentFrame(69);CrapOdds(om9To5);SetNum(money);break;
		case 70 : PMessage->CAD.SetCurrentFrame(70);CrapOdds(om7To5);SetNum(money);break;
		case 71 : PMessage->CAD.SetCurrentFrame(71);CrapOdds(om6To5);SetNum(money);break;
		case 72 : PMessage->CAD.SetCurrentFrame(72);CrapOdds(om6To5);SetNum(money);break;
		case 73 : PMessage->CAD.SetCurrentFrame(73);CrapOdds(om7To5);SetNum(money);break;
		case 74 : PMessage->CAD.SetCurrentFrame(74);CrapOdds(om9To5);SetNum(money);break;
		case 75 : PMessage->CAD.SetCurrentFrame(75);CrapOdds(om1To2);SetNum(money);break;
		case 76 : PMessage->CAD.SetCurrentFrame(76);CrapOdds(om2To3);SetNum(money);break;
		case 77 : PMessage->CAD.SetCurrentFrame(77);CrapOdds(om5To6);SetNum(money);break;
		case 78 : PMessage->CAD.SetCurrentFrame(78);CrapOdds(om5To6);SetNum(money);break;
		case 79 : PMessage->CAD.SetCurrentFrame(79);CrapOdds(om2To3);SetNum(money);break;
		case 80 : PMessage->CAD.SetCurrentFrame(80);CrapOdds(om1To2);SetNum(money);break;
		case 81 : PMessage->CAD.SetCurrentFrame(81);CrapOdds(om7To1);SetNum(money);break;
		case 82 : PMessage->CAD.SetCurrentFrame(82);CrapOdds(om9To1);SetNum(money);break;
		case 83 : PMessage->CAD.SetCurrentFrame(83);CrapOdds(om9To1);SetNum(money);break;
		case 84 : PMessage->CAD.SetCurrentFrame(84);CrapOdds(om7To1);SetNum(money);break;
		case 85 : PMessage->CAD.SetCurrentFrame(85);CrapOdds(om4To1);SetNum(money);break;
		case 86 : PMessage->CAD.SetCurrentFrame(86);CrapOdds(om7To1);SetNum(money);break;
		case 87 : PMessage->CAD.SetCurrentFrame(87);CrapOdds(om30To1);SetNum(money);break;
		case 88 : PMessage->CAD.SetCurrentFrame(88);CrapOdds(om15To1);SetNum(money);break;
		case 89 : PMessage->CAD.SetCurrentFrame(89);CrapOdds(om15To1);SetNum(money);break;
		case 90 : PMessage->CAD.SetCurrentFrame(90);CrapOdds(om30To1);SetNum(money);break;
		case 91 : PMessage->CAD.SetCurrentFrame(91);CrapOdds(HornOdds(point));SetNum(money);break;
		case 92 : PMessage->CAD.SetCurrentFrame(92);CrapOdds(CEOdds(point));SetNum(money);break;
		case 93 : PMessage->CAD.SetCurrentFrame(93);break;
		case 152 : PMessage->CAD.SetCurrentFrame(52);CrapOdds(om1To1);SetNum(money,false);break;
		case 153 : PMessage->CAD.SetCurrentFrame(53);CrapOdds(om1To1);SetNum(money,false);break;
		case 154 : PMessage->CAD.SetCurrentFrame(54);CrapOdds(om1To1);SetNum(money,false);break;
		case 155 : PMessage->CAD.SetCurrentFrame(55);CrapOdds(om1To1);SetNum(money,false);break;
	 }
	 PMessage->Show();
	 Update(GetAdjFUC());
}
//*******************************************************************
void TCasMessageDisplay::NoShowDisplay()
{
  int i=0;
  for(i=0;i<11;i++)
  {
	 PDigits[i]->NoShow();
  }
  PMessage->NoShow();
  POdds->NoShow();
  PMillComma->NoShow();
  PBillComma->NoShow();
  PThouComma->NoShow();
}
//*******************************************************************
void TCasMessageDisplay::SetupAnms()
{
  int j=0;
  PDigits[10] = GetAnm(0);
  PDigits[9]  = GetAnm(1);
  PBillComma  = GetAnm(2);
  PDigits[8]  = GetAnm(3);
  PDigits[7]  = GetAnm(4);
  PDigits[6]  = GetAnm(5);
  PMillComma  = GetAnm(6);
  PDigits[5]  = GetAnm(7);
  PDigits[4]  = GetAnm(8);
  PDigits[3]  = GetAnm(9);
  PThouComma  = GetAnm(10);
  PDigits[2]  = GetAnm(11);
  PDigits[1]  = GetAnm(12);
  PDigits[0]  = GetAnm(13);
  PMessage = GetAnm(14);
  POdds    = GetAnm(15);
  if(PDigits[j] != NULL)
  {
	 for(j=0;j<11;j++)
	 {
		PDigits[j]->CAD.ClearAutoStart();
		PDigits[j]->CAD.ClearAutoStop();
		PDigits[j]->CAD.SetDirStill();
	 }
  }
  if(PMessage != NULL)
  {
	 PMessage->CAD.ClearAutoStart();
	 PMessage->CAD.ClearAutoStop();
	 PMessage->CAD.SetDirStill();
  }

  if(POdds != NULL)
  {
	 POdds->CAD.ClearAutoStart();
	 POdds->CAD.ClearAutoStop();
	 POdds->CAD.SetDirStill();
  }

  if(PThouComma != NULL)
  {
	 PThouComma->CAD.ClearAutoStart();
	 PThouComma->CAD.ClearAutoStop();
	 PThouComma->CAD.SetDirStill();
  }

  if(PMillComma != NULL)
  {
	 PMillComma->CAD.ClearAutoStart();
	 PMillComma->CAD.ClearAutoStop();
	 PMillComma->CAD.SetDirStill();
  }

  if(PBillComma != NULL)
  {
	 PBillComma->CAD.ClearAutoStart();
	 PBillComma->CAD.ClearAutoStop();
	 PBillComma->CAD.SetDirStill();
  }

}
//*******************************************************************
int TCasMessageDisplay::SetNum(TMoney money,bool OddsOn)
{
  long num = (long)money;
  int framesused=13,i=0;
  bool found=false;
  long billion=0;
  long hunmil=0;
  long tenmil=0;
  long million=0;
  long hunthou=0;
  long tenthou=0;
  long thousan=0;
  long hun=0;
  long ten=0;
  long one=0;
  for(i=0;i<11;i++)
  {
	 PDigits[i]->CAD.SetX(PDigits[i]->SAD.GetX());
  }
  PThouComma->CAD.SetX(PThouComma->SAD.GetX());
  PMillComma->CAD.SetX(PThouComma->SAD.GetX());
  PBillComma->CAD.SetX(PThouComma->SAD.GetX());
  POdds->CAD.SetX(POdds->SAD.GetX());
  if( (num/1000) )
  {
	 PThouComma->Show();
  }
  else{PThouComma->NoShow();}
  if( (num/1000000l) )
  {
	 PMillComma->Show();
  }
  else{PMillComma->NoShow();}
  if( (num/1000000000l) )
  {
	 PBillComma->Show();
  }
  else{PBillComma->NoShow();}

  billion = (num/1000000000l)%10;
  if(!billion && !found){framesused-=2;}else{found=true;}

  hunmil  = (num/100000000l)%10;
  if(!hunmil && !found){framesused--;}else{found=true;}

  tenmil  = (num/10000000l)%10;
  if(!tenmil && !found){framesused--;}else{found=true;}

  million = (num/1000000l) %10;
  if(!million && !found){framesused-=2;}else{found=true;}

  hunthou = (num/100000l)  %10;
  if(!hunthou && !found){framesused--;}else{found=true;}

  tenthou = (num/10000)   %10;
  if(!tenthou && !found){framesused--;}else{found=true;}

  thousan = (num/1000)    %10;
  if(!thousan && !found)   {framesused-=2;}else{found=true;}

  hun     = (num/100)     %10;
  if(!hun && !found)    {framesused--;}else{found=true;}

  ten     = (num/10)      %10;
  if(!ten && !found)    {framesused--;}else{found=true;}

  one     = (num  )       %10;
  if(!one && !found)    {framesused--;}else{found=true;}

  int TotalLen=0,NumOffset=0,BitmapOffset=0;
  TotalLen     = (framesused*DigitSize)+BitmapSize;
  NumOffset    = (WindowSize-TotalLen)/2;
  BitmapOffset = (framesused*DigitSize)+NumOffset+(BitmapSize/2);

  if(framesused == 3)
  {
	 PDigits[3]->CAD.SetX(int16(PDigits[3]->SAD.GetX()+3));
  }
  if(framesused == 7)
  {
	 PDigits[6]->CAD.SetX(int16(PDigits[6]->SAD.GetX()+3));
  }
  if(framesused == 11)
  {
	 PDigits[9]->CAD.SetX(int16(PDigits[9]->SAD.GetX()+3));
  }
  for(i=0;i<11;i++)
  {
	 PDigits[i]->CAD.SetX(int16(PDigits[i]->CAD.GetX()-NumOffset));
  }
  PBillComma->CAD.SetX(int16(PBillComma->CAD.GetX()-NumOffset));
  PMillComma->CAD.SetX(int16(PMillComma->CAD.GetX()-NumOffset));
  PThouComma->CAD.SetX(int16(PThouComma->CAD.GetX()-NumOffset));
  POdds->CAD.SetX(int16(POdds->SAD.GetX()+156-BitmapOffset));
  if(OddsOn){POdds->Show();}
  PDigits[0]->CAD.SetCurrentFrame(int16(one+1));
  PDigits[0]->Show();

  if(framesused > 1)
  {
	 PDigits[1]->CAD.SetCurrentFrame(int16(ten+1));
	 PDigits[1]->Show();
  }
  else
  {
	 if(framesused >= 0)
	 {
		PDigits[1]->CAD.SetCurrentFrame(0);
		PDigits[1]->Show();
	 }
	 else
	 {
		PDigits[1]->NoShow();
	 }
  }

  if(framesused > 2)
  {
	 PDigits[2]->CAD.SetCurrentFrame(int16(hun+1));
	 PDigits[2]->Show();
  }
  else
  {
	 if(framesused == 2)
	 {
		PDigits[2]->CAD.SetCurrentFrame(0);
		PDigits[2]->Show();
	 }
	 else
	 {
		PDigits[2]->NoShow();
	 }
  }

  if(framesused > 4)
  {
	 PDigits[3]->CAD.SetCurrentFrame(int16(thousan+1));
	 PDigits[3]->Show();
  }
  else
  {
	 if(framesused == 3)
	 {
		PDigits[3]->CAD.SetCurrentFrame(0);
		PDigits[3]->Show();
	 }
	 else
	 {
		PDigits[3]->NoShow();
	 }
  }

  if(framesused > 5)
  {
	 PDigits[4]->CAD.SetCurrentFrame(int16(tenthou+1));
	 PDigits[4]->Show();
  }
  else
  {
	 if(framesused == 5)
	 {
		PDigits[4]->CAD.SetCurrentFrame(0);
		PDigits[4]->Show();
	 }
	 else
	 {
		PDigits[4]->NoShow();
	 }
  }

  if(framesused > 6)
  {
	 PDigits[5]->CAD.SetCurrentFrame(int16(hunthou+1));
	 PDigits[5]->Show();
  }
  else
  {
	 if(framesused == 6)
	 {
		PDigits[5]->CAD.SetCurrentFrame(0);
		PDigits[5]->Show();
	 }
	 else
	 {
		PDigits[5]->NoShow();
	 }
  }

  if(framesused > 8)
  {
	 PDigits[6]->CAD.SetCurrentFrame(int16(million+1));
	 PDigits[6]->Show();
  }
  else
  {
	 if(framesused == 7)
	 {
		PDigits[6]->CAD.SetCurrentFrame(0);
		PDigits[6]->Show();
	 }
	 else
	 {
		PDigits[6]->NoShow();
	 }
  }

  if(framesused > 9)
  {
	 PDigits[7]->CAD.SetCurrentFrame(int16(tenmil+1));
	 PDigits[7]->Show();
  }
  else
  {
	 if(framesused == 9)
	 {
		PDigits[7]->CAD.SetCurrentFrame(0);
		PDigits[7]->Show();
	 }
	 else
	 {
		PDigits[7]->NoShow();
	 }
  }

  if(framesused > 10)
  {
	 PDigits[8]->CAD.SetCurrentFrame(int16(hunmil+1));
	 PDigits[8]->Show();
  }
  else
  {
	 if(framesused == 10)
	 {
		PDigits[8]->CAD.SetCurrentFrame(0);
		PDigits[8]->Show();
	 }
	 else
	 {
		PDigits[8]->NoShow();
	 }
  }
  if(framesused > 11)
  {
	 PDigits[9]->CAD.SetCurrentFrame(int16(billion+1));
	 PDigits[9]->Show();
  }
  else
  {
	 if(framesused == 11)
	 {
		PDigits[9]->CAD.SetCurrentFrame(0);
		PDigits[9]->Show();
	 }
	 else
	 {
		PDigits[9]->NoShow();
	 }
  }
  if(framesused > 13)
  {
	 PDigits[10]->CAD.SetCurrentFrame(int16(billion+1));
	 PDigits[10]->Show();
  }
  else
  {
	 if(framesused == 13)
	 {
		PDigits[10]->CAD.SetCurrentFrame(0);
		PDigits[10]->Show();
	 }
	 else
	 {
		PDigits[10]->NoShow();
	 }
  }
  Update(GetAdjFUC());
  return framesused;
}
//*******************************************************************