//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  geddlgs.h
//    Project Name:  Game Editor
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     7/24/95    M.Perry    original baseline
//  2.0    11/3/97     M.Perry    32-bit conversion.
//********************************************************************
#if !defined(__geddlgs_h)
#define __geddlgs_h

#if !defined(OWL_RADIOBUT_H)
#include <owl\radiobut.h>
#endif

#if !defined(OWL_DIALOG_H)
#include <owl\dialog.h>
#endif

#if !defined(OWL_LISTBOX_H)
#include <owl/listbox.h>
#endif

#if !defined(OWL_BUTTON_H)
#include <owl/button.h>
#endif

#if !defined(OWL_EDIT_H)
#include <owl/edit.h>
#endif

#if !defined(__FSTREAM_H)
#include <fstream.h>
#endif

#if !defined(__gedmodew_rh)
#include "gedmodew.rh"
#endif

#include <assert.h>

#if !defined(__ogamefw_h)
#include "ogamefw.h"
#endif

#if !defined(__oapp_h)
#include "oapp.h"
#endif

//#include "osktplst.h"

#if !defined(__osktport_h)
#include "osktport.h"
#endif

#if !defined(__geddef_h)
#include "geddef.h"
#endif

#if !defined(__oanm_h)
#include "oanm.h"
#endif

class TGroupBox;
class GEDOWLCLASS TSpriteEditorClientWin;
class TGameObject;
//*******************************************************************
class GEDOWLCLASS TEditSpriteIdlesDlg:public TDialog
{
public:
  TSpriteEditorClientWin *PSprEdWin;
  int16 TypeIndex;
  int16 SetIndex;
  TEditSpriteIdlesDlg(TWindow *parent,TSpriteEditorClientWin *pspredwin,
                      int16 typeindex,int16 setindex);
  virtual ~TEditSpriteIdlesDlg();
  virtual void SetupWindow();
  TListBox *PSpriteIdlesLB;
  void CmAdd();
  void CmRemove();
  void CmDone();
  void LoadLB();
  void UnLoadLB();
  DECLARE_RESPONSE_TABLE(TEditSpriteIdlesDlg);
};
//*******************************************************************
class GEDOWLCLASS TEditSpriteSetsDlg:public TDialog
{
public:
  TSpriteEditorClientWin *PSprEdWin;
  int16 TypeIndex;
  TEditSpriteSetsDlg(TWindow *parent,TSpriteEditorClientWin *pspredwin,int16 typeindex);
  virtual ~TEditSpriteSetsDlg();
  virtual void SetupWindow();
  TListBox *PSpriteSetsLB;
  void CmActivate();
  void CmDeActivate();
  void CmAdd();
  void CmRemove();
  void CmEditIdles();
  void CmDone();
  void LoadLB();
  void UnLoadLB();
  void EvDblClk();
  DECLARE_RESPONSE_TABLE(TEditSpriteSetsDlg);
};
//*******************************************************************
class GEDOWLCLASS TEditSpriteTypesDlg:public TDialog
{
public:
  TSpriteEditorClientWin *PSprEdWin;
  TEditSpriteTypesDlg(TSpriteEditorClientWin *parent);
  virtual ~TEditSpriteTypesDlg();
  virtual void SetupWindow();
  TListBox *PSpriteTypesLB;
  TEdit *PEditTypeName;
  void CmAdd();
  void CmRemove();
  void EvDblClk();
  void CmEditSets();
  void CmDone();
  void LoadLB();
  void UnLoadLB();
  DECLARE_RESPONSE_TABLE(TEditSpriteTypesDlg);
};
//*******************************************************************
class GEDOWLCLASS TEditAnmCellDlg:public TDialog
{
public:
  TEditAnmCellDlg(TWindow *parent,
                  int16 x,
                  int16 y,
                  int16 z,
                  TDirection direction,
                  bool creating,
                  dword fuclen,
                  int16 startframenum);

  virtual ~TEditAnmCellDlg();
  
  virtual void SetupWindow();
  TDirection Direction;
  int16 X;
  int16 Y;
  int16 Z;
  TEdit *pXEdit;
  TEdit *pYEdit;
  TEdit *pZEdit;
  TRadioButton *PForwardRBtn;
  TRadioButton *PStillRBtn;
  TRadioButton *PReverseRBtn;
  TGroupBox *PDirectionGrpBox;
  TButton *PDeleteAnm_PB;
  TEdit *PFUCLen_ETB;
  TEdit *PStartFrameNum_ETB;
  bool bCreating;
  dword FUCLength;
  int16 StartFrameNum;
  
  void CmOk();
  void CmNo();
  int16 GetX() {return X;}
  int16 GetY() {return Y;}
  int16 GetZ() {return Z;}
  dword GetFUCLength() {return FUCLength;}
  void SetFUClength(dword fuclength) {FUCLength = fuclength;}

  TDirection GetDirection() {return Direction;}
  void SetDirection(TDirection direction) {Direction = direction;}

  int16 GetStartFrameNum() {return StartFrameNum;}
  void SetStartFrameNum(int16 startframenum) {StartFrameNum = startframenum;}

  DECLARE_RESPONSE_TABLE(TEditAnmCellDlg);
};
//*******************************************************************
class GEDOWLCLASS TEditWavCellDlg:public TDialog
{
protected:
  int16 WavFUCLength;
  TEdit *PWavFUCLengthETB;
public:
  TEditWavCellDlg(TWindow *parent,int16 wavfuclength);
  virtual ~TEditWavCellDlg();
  virtual void SetupWindow();
  void CmOk();
  void CmNo();
  int16 GetWavFUCLength() const {return WavFUCLength;}
  DECLARE_RESPONSE_TABLE(TEditWavCellDlg);
};
//*******************************************************************
class GEDOWLCLASS TPortfolioDlg:public TDialog
{
public:
  TPortfolioDlg(int16 skitcatindex,
                TWindow *parent,
                TSkitPortfolioList *Pspl,
                string Caption = "Edit Portfolio List");
  ~TPortfolioDlg();
  void CmAdd();
  void CmDel();
  protected:
  int16 SkitCatIndex;
  TSkitPortfolioList *PSPL;
  string CaptionStr;
  void ReloadLB();
  void UnloadLB();
  virtual void SetupWindow();
  TListBox *lb;
  int16 sel;
  DECLARE_RESPONSE_TABLE(TPortfolioDlg);
};
//*******************************************************************
class GEDOWLCLASS TSelectPortfolioListDlg:public TDialog
{
public:
  TWindow *Parent;
  TSkitPortfolio *PSkitPortfolio;
  int16 SkitCatIndex;
  TSelectPortfolioListDlg(TWindow *parent,int16 skitcatindex,
                          TSkitPortfolio *pskitportfolio,string skitcatname);
  ~TSelectPortfolioListDlg();
  void SetupWindow();
  void DoPortDlg(int16 listindex);
  void CmList0();
  void CmList1();
  void CmList2();
  void CmList3();
  void CmList4();
  void CmList5();
  void CmList6();
  void CmList7();
  void CmList8();
  void CmList9();
  void CmHelp();
  void UpdateText();
  TStatic *PStatic[10];
  DECLARE_RESPONSE_TABLE(TSelectPortfolioListDlg);
};
//*******************************************************************
class GEDOWLCLASS TSelectStringDlg:public TDialog
{
public:
  TSelectStringDlg(TWindow *parent,string Caption = "",
                   TResId resId = SELECTMODEDIALOG);
  ~TSelectStringDlg();
  string RetrieveSelection();
  int16 RetrieveIndex();
  protected:
  virtual void SetupWindow();
  void CmOK();
  void EvDblClk();
  TListBox *lb;
  TIArrayAsVector<string> lbStrings;
  int16 sel;
  virtual bool LoadlbStrings();
  string strCaption;
  DECLARE_RESPONSE_TABLE(TSelectStringDlg);
};
//*******************************************************************
class GEDOWLCLASS TSelectStringFromFileDlg:public TSelectStringDlg
{
public:
  TSelectStringFromFileDlg(TWindow *parent,string infile,string Caption = "",
                           TResId resId = SELECTMODEDIALOG)
    : TSelectStringDlg(parent,Caption,resId)
  {
    strFileName = infile;
  }
  ~TSelectStringFromFileDlg() {}
  string strFileName;
  virtual bool LoadlbStrings();
};
//*******************************************************************
class GEDOWLCLASS TSelectModeDlg : public TSelectStringDlg
{
protected:
  string strCurSel;
  int16 ndxCurSel;

public:
	TSelectModeDlg(TWindow* parent,string Caption = "",
                  string strcursel = string(""),
                  TResId resId = SELECTMODEDIALOG)
     :TSelectStringDlg(parent,Caption,resId),
      strCurSel(strcursel),
      ndxCurSel(0)
   {}
  ~TSelectModeDlg() {}
  virtual bool LoadlbStrings();
  virtual void SetupWindow();
};
//*******************************************************************
class GEDOWLCLASS TSelectGObjDlg : public TSelectStringDlg
{
public:
  TSelectGObjDlg(TWindow *parent,string Caption = "",TResId resId = SELECTMODEDIALOG)
    :TSelectStringDlg(parent,Caption,resId)
  {
  }
  ~TSelectGObjDlg() {}
  virtual bool LoadlbStrings();
};
//*******************************************************************
class GEDOWLCLASS TSelectSpriteDlg : public TSelectStringDlg
{
public:
  int16 SelectedGObj;
  TSelectSpriteDlg(TWindow *parent,string Caption = "",int16 SelectGObj = -1,
                   TResId resId = SELECTMODEDIALOG)
  :TSelectStringDlg(parent,Caption,resId)
  {
    SelectedGObj = SelectGObj;
  }
  ~TSelectSpriteDlg() {}
  virtual bool LoadlbStrings();
};
//*******************************************************************
class GEDOWLCLASS TSelectSpriteTypeDlg:public TSelectStringDlg
{
public:
  TSpriteEditorClientWin *PSprEdWin;
  TSelectSpriteTypeDlg(TSpriteEditorClientWin *parent,string Caption = "",
                       TResId resId = SELECTMODEDIALOG);
  ~TSelectSpriteTypeDlg() {}
  virtual bool LoadlbStrings();
};
//*******************************************************************
class GEDOWLCLASS TSelectSkitCatDlg:public TSelectStringDlg
{
public:
  TSelectSkitCatDlg(TWindow *parent,string Caption = "",TResId resId = SELECTMODEDIALOG)
  :TSelectStringDlg(parent,Caption,resId)
  {
  }
  ~TSelectSkitCatDlg() {}
  virtual bool LoadlbStrings();
};
//*******************************************************************
class GEDOWLCLASS TSelectSkitDlg:public TSelectStringDlg
{
public:
  int16 CurrentSkitCatIndex;
  TSelectSkitDlg(int16 NewSkitCatIndex,TWindow *parent,string Caption = "",
                 TResId resId = SELECTMODEDIALOG)
  :TSelectStringDlg(parent,Caption,resId)
  {
    CurrentSkitCatIndex = NewSkitCatIndex;
  }
  ~TSelectSkitDlg() {}
  virtual bool LoadlbStrings();
};
//*******************************************************************
class GEDOWLCLASS TSelectGameIdDlg:public TSelectStringDlg
{
public:
  TSelectGameIdDlg(TWindow *parent,string Caption = "",TResId resId = SELECTMODEDIALOG)
  :TSelectStringDlg(parent,Caption,resId)
  {}
  ~TSelectGameIdDlg() {}
  virtual bool LoadlbStrings();
};
//*******************************************************************
class GEDOWLCLASS TSpriteUsageDlg:public TDialog
{
public:
  TSpriteUsageDlg(TWindow *parent,TGameObject *pgobj,int16 gobjindex);
  virtual ~TSpriteUsageDlg();

protected:
  TGameObject *PGObj; // which gobj's skits are we checking.
  int16 GObjIndex;   // which gobj's sprite are we checking.
  int16 SkitCatIndex;
  int16 SkitIndex;
  int16 SpriteIndex;

  string StatusStr;
  string ChosenSkitCatStr;
  string ChosenSkitStr;
  string ChosenSpriteStr;
  string ChosenGObjStr;
  string AllStr;

  TStatic *PStatus_STB;
  TStatic *PChosenSkitCat_STB;
  TStatic *PChosenSkit_STB;
  TStatic *PChosenSprite_STB;
  TStatic *PChosenGObj_STB;
  TRadioButton *PSkitCatAll_RBtn;
  TRadioButton *PSkitCatOne_RBtn;
  TRadioButton *PSkitAll_RBtn;
  TRadioButton *PSkitOne_RBtn;
  TRadioButton *PSpriteAll_RBtn;
  TRadioButton *PSpriteOne_RBtn;
  TRadioButton *PGObjChoose_Btn;
  TEdit *PFileName_ETB;

  virtual void SetupWindow();

  string GetFileName();
  void SetStatus(string s);
  void SetGObjChoose();
  void SetSpriteAll();
  void SetSpriteOne();
  void SetSkitAll();
  void SetSkitOne();
  void SetSkitCatAll();
  void SetSkitCatOne();
  void CmSkitCatAll();
  void CmSkitCatOne();
  void CmSkitAll();
  void CmSkitOne();
  void CmSpriteAll();
  void CmSpriteOne();
  void CmGObjChoose();
  void CmOk();
  void CmCancel();
  void CmHelp();

  DECLARE_RESPONSE_TABLE(TSpriteUsageDlg);
};
//*******************************************************************
#endif

