//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  gedctrl.h
//    Project Name:  GEd
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     6/12/96    M.Perry    original baseline
//  2.0    10/28/97    M.Perry    32-bit conversion.
//********************************************************************
#if !defined(__gedctrl_h)
#define __gedctrl_h

#if !defined(__inifile_h)
#include "inifile.h"
#endif

#define INFOSECTION "info"
#define LOCKMODESECTION "locks"
#define GEDCTRLEXT ".ged"
#define USERCOUNTENTRY "usercount"
#define MASTERENTRY "master"
#define FILELOCKENTRY "filelock"
#define FILELOCKNAMEENTRY "lockname"
#define NONE_STR "none"
//*******************************************************************
class TGedControl:public TIniFile
{
private:
  bool LockedByMe;
  string UserName;
  string ModeName;
  bool Master;
  bool Registered;
  bool GetLockStatus();
  bool WriteLockStatus(bool lock);
public:
  TGedControl(string &hddrive,string &hddir,string fname,string &username);
  ~TGedControl();

  string GetUserName() const {return UserName;}

  bool SetLock(bool lock);
  bool WriteLockName();
  bool ClearLockName();
  string GetLockName();

  // below needs lock.
  bool IsRegistered() {return Registered;}
  void Register();
  void UnRegister();
  int GetUserCount();
  bool WriteUserCount(int count);
  bool IncUserCount();
  bool DecUserCount();
  bool IsMaster() {return Master;}
  bool SetMasterName();
  string GetMasterName();
  bool ClearMasterName();
  bool IsModeLocked(string &modename);
  bool SetModeLock(string &modename);
  bool ClearModeLock(string &modename);
  bool ClearModeLock();
  string GetModeLockUserName(string &modename);
  bool WaitForLock();
  void ReleaseLock() {if (LockedByMe) {SetLock(false);}}
};
//*******************************************************************
#endif
