//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  gedspred.h
//    Project Name:  Game Editor
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     7/24/95    M.Perry    original baseline
//  2.0    10/29/97    M.Perry    32-bit conversion.
//  2.2    06/01/99    M.Perry    fixed scroller (debug ver)
//********************************************************************
#if !defined(__gedspred_h)
#define __gedspred_h

//#include <cstring.h>

#if !defined(__geddef_h)
#include "geddef.h"
#endif

#if !defined(__gedspred_rh)
#include "gedspred.rh"
#endif

#if !defined(__gedmodew_h)
#include "gedmodew.h"
#endif

#if !defined(__gedwin_h)
#include "gedwin.h"
#endif

//#include "gedspmsg.h"

#if !defined(__osprlist_h)
#include "osprlist.h"
#endif

//class TVDFlags;

#if !defined(__osprcell_h)
#include "osprcell.h"
#endif

#if !defined(__osprrow_h)
#include "osprrow.h"
#endif

#if !defined(__sprtbl_h)
#include "osprtbl.h"
#endif
//*******************************************************************
class TFrameIs8Tracks
{
public:
	enum {NUM_TRACKS = 8};
	TRect track[NUM_TRACKS];
	TSpriteCell cellptr[NUM_TRACKS];
	int operator==(const TFrameIs8Tracks& thisframe) const;
};
//*******************************************************************
class GEDOWLCLASS TSpriteEditorClientWin: public TGedWin
{
	enum {NUM_TRACKS = 8,
	      NUM_FRAMES = 10,//initial frame count
	      MAX_FRAMES = 500,
	      MIN_FRAMES = 0,
	      FRAME_DELTA = 10,
	      FRAME_HEIGHT = 200,
         FRAME_WIDTH = 300,
         FRAME_SEPARATION = 15,
         BEFORE_FRAMES = 25,
         LEFT_BORDER = 10};
public:
	TSpriteEditorClientWin();
  ~TSpriteEditorClientWin();
protected:
   //TVDFlags &GetVDFlags();
   TSize GetSizeM(TDC &dc) {return (dc.GetTextExtent("M",1));}
   int16 GetOneLineSpacing() {return int16(FTNumSize.cy);}
   void SetFrameTrackStr(TDC &dc,int16 Frame,int16 Track)
   {
     wsprintf(FTStr,"F%d  T%d",Frame,Track);
     FTNumSize = dc.GetTextExtent(FTStr,sizeof(FTStr));
   }
   TSize FTNumSize;
   char FTStr[20];
	int16  num_frames;//current frame count
   void PaintRect(TDC &dc,int16 Frame,int16 Track);
   void PaintFrameTrackNum(TDC &dc,int16 Frame,int16 Track);
   void PaintFileName(TDC &dc,int16 Frame,int16 Track);
   void PaintFileWav(TDC &dc,int16 Frame,int16 Track);
   void PaintFileAnm(TDC &dc,int16 Frame,int16 Track);
   void PaintNotFilled(TDC &dc,int16 Frame,int16 Track);
   void PaintFileType(TDC &dc,int16 Frame,int16 Track);
	void Paint(TDC& dc, bool erase, TRect& r);
	virtual void SetupWindow();
	void EvLButtonDblClk(uint modKeys, TPoint& point);
	void EvRButtonDown(uint modKeys, TPoint& point);
	void EvLButtonDown(uint modKeys, TPoint& point);
	void EvLButtonUp(uint modKeys,TPoint& point);
	void EvKeyDown(uint key, uint repeat, uint flags);

   void StartDrag(TPoint &point);
   void EndDrag(TPoint &point);
   void PromptClearCell(TPoint &point);
   void EditAnmCell(int16 frame,int16 track,bool creating);
   void EditWavCell(int16 frame,int16 track);
   void FillCell(TPoint &point);
   void FillAnm(int16 Frame,int16 Track);
   dword GetEstWavFUCLen(const string &wavpathname);
   void FillWav(int16 Frame,int16 Track,const string &wavpathname);
public:

   void BackFromPreview();
   int16 CurrentGObjIndex;
   int16 CurrentSpriteIndex;
   TSprite *PCurrentSprite;

   void LoadTable();

   TEditorModeWin *GetEditorModeWin()
   {                                     
//     return ((TEditorModeWin *)POgleApp->GetFW()->PModeWin);
     return ((TEditorModeWin *)GetFW()->GetModeWin());
   }

   TGObjList *GetGObjList() {return GetEditorModeWin()->GetGObjList();}
   TGameObject *GetGObjPtr() {return (GetEditorModeWin()->GetGObjPtr(CurrentGObjIndex));}
   TSpriteList *GetSpriteList() {return (GetGObjPtr()->GetSpriteList());}
   TSprite *GetSpritePtrFromList() {return (GetSpriteList()->GetSpritePtr(CurrentSpriteIndex));}
   int16 GetSpriteIndex(string &SpriteName) {return (GetSpriteList()->GetSpriteIndex(SpriteName));}
   TSpriteTable *GetSpriteTable() {return (PCurrentSprite->GetTable());}
   int16 GetTableFrameCount() {return (GetSpriteTable()->GetFrameCount());}
   int16 GetSpriteTableLastNum() {return (GetSpriteTable()->GetLastNum());}
   TSpriteRow *GetSpriteRow(int16 RowNum) {return (GetSpriteTable()->GetSpriteRow(RowNum));}

   bool IsNameInSpriteList(string SpriteFName);
   bool IsSpriteUsedBySkit(int16 gobjindex,int16 spriteindex);

   void ClearAllUICells();
   void InsertCurrentSprite();
   void ReloadCurrentSprite();
   void SaveCurrentSprite();
   void SaveCurrentSpriteBail();
   int16 GetUIRowsCount();
   int16 GetUIValidRowsCount();
   void LoadTableIntoCurrentSprite();
   void MakeEnoughCurrentSpriteRows(int16 NumRows);
   void RemoveEnoughSpriteRows(int16 LastRow);
   void CopyUIRowToCurrentSpriteRow(int16 RowNum);
   void ClearCell(TSpriteCell *PCell);
   void CopyCell(TSpriteCell *PDestCell,TSpriteCell *PSourceCell);
   void CheckSaveCurrentSprite();
   void MakeEnoughUIRows();
   void Add10UIRows(int16 times);
   void Add10UIRows();                           

//   bool GetNewSpriteFName(string &spritefname);
   bool GetNewSpriteName(string &spritename);
   void CmSpriteNew();
   void CmSpriteNewEnable(TCommandEnabler &commandHandler);
   void CmSpriteOpen();
   void CmSpriteOpenEnable(TCommandEnabler &commandHandler);
   void CmSpriteGet();
   void CmSpriteGetEnable(TCommandEnabler &commandHandler);
   void CmSpriteSave();
   void CmSpriteSaveEnable(TCommandEnabler &commandHandler);
   void CmSpriteSaveAs();
   void CmSpriteSaveAsEnable(TCommandEnabler &commandHandler);
   void CmSpriteDelete();
   void CmSpriteDeleteEnable(TCommandEnabler &commandHandler);
   void CmSpriteWipe();
   void CmSpriteWipeEnable(TCommandEnabler &commandHandler);
   void CmSpriteAddFrames();
   void CmSpriteAddFramesEnable(TCommandEnabler &commandHandler);
   void CmSpriteEditSpriteTypes();
   void CmSpriteEditSpriteTypesEnable(TCommandEnabler &commandHandler);
   void CmSpriteEditType();
   void CmSpriteEditTypeEnable(TCommandEnabler &commandHandler);
   void CmSpritePreview();
   void CmSpritePreviewEnable(TCommandEnabler &commandHandler);
   void CmSpriteInfo();
   void CmSpriteInfoEnable(TCommandEnabler &commandHandler);
   void CmSpriteExit();
   void CmSpriteExitEnable(TCommandEnabler &commandHandler);
   void CmSpriteLength();
   void CmSpriteLengthEnable(TCommandEnabler & commandHandler);
   void CmSpriteEditXYZ();
   void CmSpriteEditXYZEnable(TCommandEnabler &commandHandler);
   void CmSpriteReport();
   void CeSpriteReport(TCommandEnabler &ce);
   void CmSpriteIDCode();
   void CeSpriteIDCode(TCommandEnabler &ce);
   void CmSpriteIDConflict();
   void CeSpriteIDConflict(TCommandEnabler &ce);
   void CmSpriteIDUsage();
   void CeSpriteIDUsage(TCommandEnabler &ce);

private:
   //bool SpriteDirty;
	TIArrayAsVector<TFrameIs8Tracks> dynframe;
	bool ScreenPointToFrameAndTrack(TPoint pt,int16& frame_found,int16& track_found);
	int16 m_screen_height,m_screen_width;
	bool dragging;
	int16 old_frame; int16 old_track;
	TSpriteCell DragCell;
	void ClearCellContents(int16 frame_at,int16 track_at);
//   int16 ConvertSpriteTypeToInt(string type);

   public:
   void PostSwitchToModeWin()
   {
    // (new TGedSwitchFromSprEdToModeEdMsg())->Post();
      TSwToMEdMsg().PostToFW();
   }

   void PostSwitchToModeWinPreview()
   {
//     (new TGedSwitchFromSprEdToModeEdPreviewMsg())->Post();
     TSpritePreviewMsg().PostToFW();
   }

   virtual void BeenSwitchedTo();

	DECLARE_RESPONSE_TABLE(TSpriteEditorClientWin);
};
//*******************************************************************
#endif

