//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  critdlg.cpp
//    Project Name:  GEd
// Original Author:  Dave Anderson
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     9/7/95     M.Perry     original baseline
//********************************************************************
#if !defined(__critdlg_h)
#include "critdlg.h"
#endif

#if !defined(__criteria_h)
#include "criteria.h"
#endif
//*******************************************************************
DEFINE_RESPONSE_TABLE1(TCriteriaDialog,TDialog)
   EV_COMMAND(IDC_PUSHBUTTONPREVIOUS,OnPrevious),
   EV_COMMAND(IDC_PUSHBUTTONPREVIOUS10,OnPrevious10),
   EV_COMMAND(IDC_PUSHBUTTONPREVIOUS50,OnPrevious50),
   EV_COMMAND(IDC_PUSHBUTTONNEXT,OnNext),
   EV_COMMAND(IDC_PUSHBUTTONNEXT10,OnNext10),
   EV_COMMAND(IDC_PUSHBUTTONNEXT50,OnNext50),
   EV_COMMAND(IDC_RADIOBUTTONYES,OnYes),
   EV_COMMAND(IDC_RADIOBUTTONNO,OnNo),
   EV_COMMAND(IDC_RADIOBUTTONDONTCARE,OnDontCare),
   EV_COMMAND(IDC_DONTCAREALL,OnClearAll),
END_RESPONSE_TABLE;
//*******************************************************************
TCriteriaDialog::TCriteriaDialog(TWindow *parent,
                                 TResId resId,
                                 int stringtablefirst,
                                 TSkitCriteria *PNewSkitCriteria,
                                 //BYTE* ptr,
                                 //int size,
                                 int currentQuestion)
  : TWindow((TWindow*)0),TDialog(parent,resId)
{
   m_stringtablefirst = stringtablefirst;
   //m_ptr = ptr;
   PSkitCriteria = PNewSkitCriteria;
   //m_UPPER_LIMIT = size;
   m_UPPER_LIMIT = PSkitCriteria->GetNumQuestions() - 1;
   if (m_UPPER_LIMIT < 0) {m_UPPER_LIMIT = 0;}
   m_LOWER_LIMIT = 0;
   m_CurrentQuestion = currentQuestion;
}
//*******************************************************************
void TCriteriaDialog::SetupWindow()
{
   int hres= ::GetSystemMetrics(SM_CXSCREEN);
   int vres= ::GetSystemMetrics(SM_CYSCREEN);
   TRect rc = GetWindowRect();
   int width = rc.right - rc.left;
   int height= rc.bottom - rc.top;
   int offset_from_left= (hres-(rc.right - rc.left))/2;
   int offset_from_top=  (vres-(rc.bottom - rc.top))/2;

   rc.top = offset_from_top;
   rc.bottom = offset_from_top + height;
   rc.left = offset_from_left;
   rc.right = offset_from_left + width;
   MoveWindow(rc);
   string temp = GetModule()->LoadString((uint)(m_stringtablefirst + m_CurrentQuestion));
   SetDlgItemText(IDC_TEXTFROMSTRINGTABLE,temp.c_str());
   SetDlgItemInt (IDC_QUESTIONNUMBER,m_CurrentQuestion);
   m_SetRadioButtons();
}
//*******************************************************************
void TCriteriaDialog::m_SetRadioButtons()
{
//    switch (m_ptr[m_CurrentQuestion])
   switch(PSkitCriteria->GetNeededAnswer(m_CurrentQuestion))
   {
      case -1: //No
         SendDlgItemMessage(IDC_RADIOBUTTONNO,BM_SETCHECK,1);
         SendDlgItemMessage(IDC_RADIOBUTTONYES,BM_SETCHECK,0);
         SendDlgItemMessage(IDC_RADIOBUTTONDONTCARE,BM_SETCHECK,0);
         break;
      case 0: //Dont care
         SendDlgItemMessage(IDC_RADIOBUTTONYES,BM_SETCHECK,0);
         SendDlgItemMessage(IDC_RADIOBUTTONNO,BM_SETCHECK,0);
         SendDlgItemMessage(IDC_RADIOBUTTONDONTCARE,BM_SETCHECK,1);
         break;
      case 1://yes
         SendDlgItemMessage(IDC_RADIOBUTTONDONTCARE,BM_SETCHECK,0);
         SendDlgItemMessage(IDC_RADIOBUTTONNO,BM_SETCHECK,0);
         SendDlgItemMessage(IDC_RADIOBUTTONYES,BM_SETCHECK,1);
         break;
   }
}
//*******************************************************************
void TCriteriaDialog::OnClearAll()
{
  PSkitCriteria->ClearData();
  m_SetRadioButtons();
}
//*******************************************************************
void TCriteriaDialog::OnYes()
{
  // m_ptr[m_CurrentQuestion] = 2;
  PSkitCriteria->SetNeededAnswer(m_CurrentQuestion,1);
}
//*******************************************************************
void TCriteriaDialog::OnNo()
{
  // m_ptr[m_CurrentQuestion] = 1;
  PSkitCriteria->SetNeededAnswer(m_CurrentQuestion,-1);
}
//*******************************************************************
void TCriteriaDialog::OnDontCare()
{
  // m_ptr[m_CurrentQuestion] = 0;
  PSkitCriteria->SetNeededAnswer(m_CurrentQuestion,0);
}
//*******************************************************************
void TCriteriaDialog::OnPrevious()
{
   Decrement(1);
}
//*******************************************************************
void TCriteriaDialog::OnPrevious10()
{
   Decrement(10);
}
//*******************************************************************
void TCriteriaDialog::OnPrevious50()
{
   Decrement(50);
}
//*******************************************************************
void TCriteriaDialog::Decrement(int by)
{
   if ((m_CurrentQuestion - by) >= m_LOWER_LIMIT)
   {
      m_CurrentQuestion -= by;
      string temp = GetModule()->LoadString((uint)(m_stringtablefirst + m_CurrentQuestion ));
      SetDlgItemText(IDC_TEXTFROMSTRINGTABLE,temp.c_str());
      SetDlgItemInt(IDC_QUESTIONNUMBER,m_CurrentQuestion);
      m_SetRadioButtons();
   }
   else
     ::MessageBox(NULL,"Less than zero","Decrement by less",MB_OK);
}
//*******************************************************************
void TCriteriaDialog::Increment(int by)
{
   if ((m_CurrentQuestion + by) <= m_UPPER_LIMIT)
   {
      m_CurrentQuestion += by;
      string temp = GetModule()->LoadString((uint)(m_stringtablefirst + m_CurrentQuestion ));
      SetDlgItemText(IDC_TEXTFROMSTRINGTABLE,temp.c_str());
      SetDlgItemInt(IDC_QUESTIONNUMBER,m_CurrentQuestion);
      m_SetRadioButtons();
   }
   else
     ::MessageBox(NULL,"Exceeds string table length","Increment by less",MB_OK);
}
//*******************************************************************
void TCriteriaDialog::OnNext()
{
   Increment(1);
}
//*******************************************************************
void TCriteriaDialog::OnNext10()
{
   Increment(10);
}
//*******************************************************************
void TCriteriaDialog::OnNext50()
{
   Increment(50);
}
//*******************************************************************

