//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  gediddlg.cpp
//    Project Name:  GEd
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.3     5/29/97    M.Perry    original baseline
//  2.0    10/28/97    M.Perry    32-bit conversion.
//********************************************************************
#if !defined(__gediddlg_h)
#include "gediddlg.h"
#endif

#if !defined(OWL_EDIT_H)
#include <owl\edit.h>
#endif

#if !defined(OWL_STATIC_H)
#include <owl\static.h>
#endif

#if !defined(__gediddlg_rh)
#include "gediddlg.rh"
#endif

#if !defined(__oapp_h)
#include "oapp.h"
#endif

#if !defined(__ofilemgr_h)
#include "ofilemgr.h"
#endif

#if !defined(OWL_OPENSAVE_H)
#include <owl\opensave.h>
#endif

#if !defined(OWL_LISTBOX_H)
#include <owl\listbox.h>
#endif
//*******************************************************************
DEFINE_RESPONSE_TABLE1(TIDCodeListDlg,TDialog)
  EV_COMMAND(IDC_UP_PB,CmUp),
  EV_COMMAND(IDC_DOWN_PB,CmDown),
  EV_COMMAND(IDOK,CmOk),
  EV_COMMAND(IDC_CLONE_PB,CmClone),
END_RESPONSE_TABLE;
//*******************************************************************
TIDCodeListDlg::TIDCodeListDlg(TWindow *pwin,string name)
:TDialog(pwin,IDD_IDCODELIST),
 Top(1),
 Bottom(0),
 strFileName(name)
{
  CreateEdit();
  CreateStatic();
//  strInfoSection = "Info";
//  strIDSection = "ID";
//  strNumIDKey = "NumID";
//  PIniFile = new TIniFile(name);
  PSpriteIDIniFile = new TSpriteIDIniFile(TOgleFileName(name));
//  SqueezeIniFile();
  PSpriteIDIniFile->Squeeze();
//  Bottom = (int16)PIniFile->ReadInt(strInfoSection,strNumIDKey,Bottom);
  Bottom = PSpriteIDIniFile->GetNumID();
}
//*******************************************************************
TIDCodeListDlg::~TIDCodeListDlg()
{
  DestroyEdit();
  DestroyStatic();
//  delete PIniFile;
  delete PSpriteIDIniFile;
  PSpriteIDIniFile = NULL;
}
//*******************************************************************
//void TIDCodeListDlg::SqueezeIniFile()
//{
//  if (PIniFile == NULL) {return;}
//  int16 bol = (int16)PIniFile->ReadInt(strInfoSection,strNumIDKey,0);
//  int16 lastgoodvalue = 0;
//  for (int16 i=0;i<=bol;i++)
//  {
//    string defstr = GetDefName(i);
//    string s = PIniFile->ReadString(strIDSection,i,defstr);
//    if (s != defstr)
//    {
//      lastgoodvalue = i;
//    }
//  }
//  if (lastgoodvalue != bol)
//  {
//    PIniFile->WriteInt(strInfoSection,strNumIDKey,lastgoodvalue);
//  }
//}
//*******************************************************************
void TIDCodeListDlg::SetupWindow()
{
  TDialog::SetupWindow();
  LoadEdits();
  LoadStatics();
}
//*******************************************************************
void TIDCodeListDlg::CreateEdit()
{
  int resid = IDC_CODE0_ETB;
  for (int i = 0;i<10;i++,resid++)
  {
    PEdit[i] = new TEdit(this,resid);
  }
}
//*******************************************************************
void TIDCodeListDlg::DestroyEdit()
{
  for (int i=0;i<10;i++)
  {
    delete PEdit[i];
  }
}
//*******************************************************************
void TIDCodeListDlg::CreateStatic()
{
  int resid = IDC_CODE0_STB;
  for (int i=0;i<10;i++,resid++)
  {
    PStatic[i] = new TStatic(this,resid);
  }
}
//*******************************************************************
void TIDCodeListDlg::DestroyStatic()
{
  for (int i=0;i<10;i++)
  {
    delete PStatic[i];
  }
}
//*******************************************************************
void TIDCodeListDlg::CmUp()
{
  SaveEdits();
  Top -= int16(10);
  if (Top < 1) {Top = 1;}
  LoadEdits();
  LoadStatics();
}
//*******************************************************************
void TIDCodeListDlg::CmDown()
{
  SaveEdits();
  Top += int16(10);
  LoadEdits();
  LoadStatics();
}
//*******************************************************************
void TIDCodeListDlg::SaveIDName(int16 i,string name)
{
  if (i > Bottom)
  {
    Bottom = i;
//    PIniFile->WriteInt(strInfoSection,strNumIDKey,i);
    PSpriteIDIniFile->SetNumID(i);
  }
//  PIniFile->WriteString(strIDSection,i,name);
  PSpriteIDIniFile->SetIDName(i,name);
}
//*******************************************************************
void TIDCodeListDlg::SaveEdits()
{
  char buffer[256];
  string ps[10];
  int16 lastgoodvalue = 0;
  for (int16 i=0;i<10;i++)
  {
    PEdit[i]->GetText(buffer,256);
    ps[i] = buffer;
    if (ps[i] != PSpriteIDIniFile->GetDefName(Top + i))
    {
      lastgoodvalue = i;
    }
  }
  for (int16 i=0;i<=lastgoodvalue;i++)
  {
    SaveIDName(int16(Top + i),ps[i]);
  }
}
//*******************************************************************
//string TIDCodeListDlg::GetDefName(int16 i)
//{
//  char buffer[33];
//  itoa(i,buffer,10);
//  string s = "IDCode";
//  s += buffer;
//  return s;
//}
//*******************************************************************
void TIDCodeListDlg::LoadEdits()
{
  for (int16 i=0;i<10;i++)
  {
    string defname = PSpriteIDIniFile->GetDefName(int16(Top + i));
//    string s = PIniFile->ReadString(strIDSection,i + Top,defname);
    string s = PSpriteIDIniFile->GetIDName(i + Top);
    PEdit[i]->SetText(s.c_str());
  }
}
//*******************************************************************
void TIDCodeListDlg::LoadStatics()
{
  char buffer[33];
  for (int16 i=0;i<10;i++)
  {
    itoa(Top + i,buffer,10);
    PStatic[i]->SetText(buffer);
  }
//  Invalidate();
}
//*******************************************************************
void TIDCodeListDlg::CmOk()
{
  SaveEdits();
  TDialog::CmOk();
}
//*******************************************************************
void TIDCodeListDlg::CmClone()
{
  string rootdir = TOgleApp::GetOgleApp()->GetFileMgr()->PCD->GetFullPath();
  char *buffer = strdup(rootdir.c_str());


  TOpenSaveDialog::TData *pdata;
  pdata = new TOpenSaveDialog::TData(OFN_FILEMUSTEXIST,
                                     "ID Code List Files(*.idc) | *.idc |",
                                     0,
                                     buffer,
                                     "idc");
  TFileOpenDialog *pfod = new TFileOpenDialog(this,*pdata,0,"Select existing IDCode List");
  int retvalue = pfod->Execute();
  if (retvalue == IDOK)
  {
    string fpn = pdata->FileName;
//    delete PIniFile;
    delete PSpriteIDIniFile;
    TOgleFileName::CopyFile(strFileName,fpn);
//    PIniFile = new TIniFile(strFileName);
    PSpriteIDIniFile = new TSpriteIDIniFile(TOgleFileName(strFileName));
//    Bottom = (int16)PIniFile->ReadInt(strInfoSection,strNumIDKey,Bottom);
    Bottom = PSpriteIDIniFile->GetNumID();
    LoadStatics();
    LoadEdits();
  }
  delete pfod;
  delete pdata;
  free(buffer);
}
//*******************************************************************
//*******************************************************************
DEFINE_RESPONSE_TABLE1(TSelectIDNameDlg,TDialog)
  EV_COMMAND(IDOK,CmOk),
  EV_LBN_DBLCLK(IDC_IDNAMES_LB,EvDblClk),
  EV_COMMAND(IDC_EDITLIST_PB,CmEdit),
END_RESPONSE_TABLE;
//*******************************************************************
TSelectIDNameDlg::TSelectIDNameDlg(TWindow *pwin,string name,int16 idcode,string spritename)
:TDialog(pwin,IDD_IDNAMELIST),
 SelectedIndex(idcode),
 strFileName(name),
 strSpriteName(spritename)
{
  PStatic = new TStatic(this,IDC_SPRITENAME_STB);
  PListBox = new TListBox(this,IDC_IDNAMES_LB);
//  strInfoSection = "Info";
//  strIDSection = "ID";
//  strNumIDKey = "NumID";
}
//*******************************************************************
TSelectIDNameDlg::~TSelectIDNameDlg()
{
}
//*******************************************************************
void TSelectIDNameDlg::SetupWindow()
{
  TDialog::SetupWindow();
  PStatic->SetText(strSpriteName.c_str());
  LoadLB();
}
//*******************************************************************
//string TSelectIDNameDlg::GetDefName(int16 i)
//{
//  char buffer[33];
//  itoa(i,buffer,10);
//  string s = "IDCode";
//  s += buffer;
//  return s;
//}
//*******************************************************************
void TSelectIDNameDlg::LoadLB()
{
//  TIniFile *PIniFile = new TIniFile(strFileName);
  TSpriteIDIniFile *pspriteidinifile = new TSpriteIDIniFile(strFileName);
//  int16 bottom = (int16)PIniFile->ReadInt(strInfoSection,strNumIDKey,0);
  int16 bottom = pspriteidinifile->GetNumID();
  for (int16 i=0;i<=bottom;i++)
  {
//    string strdef = GetDefName(i);
//    string strdef = pspriteidinifile->GetDefName(i);
//    string s = PIniFile->ReadString(strIDSection,i,strdef);//GetDefName(i));
    string s = pspriteidinifile->GetIDName(i);
    PListBox->AddString(s.c_str());
  }
  PListBox->SetSelIndex(SelectedIndex);
//  delete PIniFile;
  delete pspriteidinifile;
}
//*******************************************************************
void TSelectIDNameDlg::UnLoadLB()
{
  PListBox->ClearList();
}
//*******************************************************************
void TSelectIDNameDlg::CmOk()
{
  SelectedIndex = (int16)PListBox->GetSelIndex();
  TDialog::CmOk();
}
//*******************************************************************
void TSelectIDNameDlg::EvDblClk()
// note: the dblclk from the listbox is "sent" not "posted" so you
//       can't directly call CmOk(), you must "post" the msg to the dlg.
//       If you call CmOk() then you kill the stack that you're living in.
{
  ::PostMessage(HWindow,WM_COMMAND,IDOK,0);
}
//*******************************************************************
void TSelectIDNameDlg::CmEdit()
{
  TIDCodeListDlg *pd = new TIDCodeListDlg(this,strFileName);
  pd->Execute();
  delete pd;
  UnLoadLB();
  LoadLB();
}
//*******************************************************************
