//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  gedmodew.cpp
//    Project Name:  Game Editor
// Original Author:  Michael R. Perry                
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//   1.0    7/24/95    M.Perry    original baseline
//   2.0   10/29/97    M.Perry    32-bit conversion.
//********************************************************************
#if !defined(__gedmodew_h)
#include "gedmodew.h"
#endif

#if !defined(__osprlist_h)
#include "osprlist.h"
#endif

#if !defined(__gedmmain_h)
#include "gedmmain.h"
#endif

#if !defined(__gedapp_h)
#include "gedapp.h"
#endif

#if !defined(__ogame_h)
#include "ogame.h"
#endif

#if !defined(__omode_h)
#include "omode.h"
#endif

#if !defined(__ogobjlst_h)
#include "ogobjlst.h"
#endif

#if !defined(__ofilemgr_h)
#include "ofilemgr.h"
#endif

#if !defined(__gediddlg_h)
#include "gediddlg.h"
#endif

#if !defined(__omdatdlg_h)
#include "omdatdlg.h"
#endif

#if !defined(__omdat_h)
#include "omdat.h"
#endif

#if !defined(__osmsgdlg_h)
#include "osmsgdlg.h"
#endif
//*******************************************************************
DEFINE_RESPONSE_TABLE1(TEditorModeWin,TOgleModeWindow)
  EV_COMMAND(CM_GAMEINFO,CmGameInfo),
  EV_COMMAND_ENABLE(CM_GAMEINFO,CmGameInfoEnable),
  EV_COMMAND(CM_MODESAVE,CmModeSave),
  EV_COMMAND_ENABLE(CM_MODESAVE,CmModeSaveEnable),
  EV_COMMAND(CM_MODESAVEAS,CmModeSaveAs),
  EV_COMMAND_ENABLE(CM_MODESAVEAS,CmModeSaveAsEnable),
  EV_COMMAND(CM_MODEEDITBG,CmModeEditBG),
  EV_COMMAND_ENABLE(CM_MODEEDITBG,CmModeEditBGEnable),
  EV_COMMAND(CM_MODEEDITGAMEID,CmModeEditGameID),
  EV_COMMAND_ENABLE(CM_MODEEDITGAMEID,CmModeEditGameIDEnable),
  EV_COMMAND(CM_GOBJNEW,CmGObjNew),
  EV_COMMAND_ENABLE(CM_GOBJNEW,CmGObjNewEnable),
  EV_COMMAND(CM_GOBJOPEN,CmGObjOpen),
  EV_COMMAND_ENABLE(CM_GOBJOPEN,CmGObjOpenEnable),
  EV_COMMAND(CM_GOBJSAVE,CmGObjSave),
  EV_COMMAND_ENABLE(CM_GOBJSAVE,CmGObjSaveEnable),
  EV_COMMAND(CM_GOBJSAVEAS,CmGObjSaveAs),
  EV_COMMAND_ENABLE(CM_GOBJSAVEAS,CmGObjSaveAsEnable),
  EV_COMMAND(CM_GOBJDELETE,CmGObjDelete),
  EV_COMMAND_ENABLE(CM_GOBJDELETE,CmGObjDeleteEnable),
  EV_COMMAND(CM_GOBJCRITERIAREPORT,CmGObjSkitCriteriaReport),
  EV_COMMAND_ENABLE(CM_GOBJCRITERIAREPORT,CeGObjSkitCriteriaReport),
  EV_COMMAND(CM_GOBJ_IDCODE_LIST,CmGObjEditIDCodeList),
  EV_COMMAND_ENABLE(CM_GOBJ_IDCODE_LIST,CeGObjEditIDCodeList),
  EV_COMMAND(CM_GOBJ_MISCDATA,CmGObjMiscData),
  EV_COMMAND_ENABLE(CM_GOBJ_MISCDATA,CeGObjMiscData),
END_RESPONSE_TABLE;
//*******************************************************************
TVDFlags &TEditorModeWin::GetVDFlags()    
{
  return (((TGameEditorApp *)GetOgleApp())->VDFlags);
}
//*******************************************************************
TEditorModeWin::TEditorModeWin(TOgleApp *papp,TOgleGameFrameWindow *pgfw,
                               string modename,TPal *PPal,string title)
:TOgleModeWindow(papp,pgfw,modename,PPal,title)
{
  CurrentGObjIndex = -1;
  DoSpritePreview = false;
  DoSkitPreview = false;
}
//*******************************************************************
TEditorModeWin::~TEditorModeWin()
{
  delete Scroller;
}
//*******************************************************************
void TEditorModeWin::CmGameInfo()
{
//  string gamestr = GetOgleApp()->GetPGame()->GetFName();
  string gamestr = GetOgleApp()->GetPGame()->FileMode.Name.GetStr();
//  string modestr = PMode->GetFName();
  string modestr = PMode->FileMode.Name.GetStr();
  string modegamestr = PMode->GetGameStr();
  string gobjstr;
  string gobjindexstr;
  string strpalname = GetOgleApp()->GetGame()->GetPaletteName();
  if ((GetVDFlags().IsGObjValid()) && (CurrentGObjIndex >= 0))
  {
//    TGameObject *PGObj = PGObjList->GetGObjPtr(CurrentGObjIndex);
    TGameObject *PGObj = GetGObjList()->GetGObjPtr(CurrentGObjIndex);
//    gobjstr = PGObj->GetFName();
    gobjstr = PGObj->FileMode.Name.GetStr();
  }
  else
  {
    gobjstr = "None";
  }

  char buf[10];
  itoa(CurrentGObjIndex,buf,10);
  gobjindexstr = buf;

//  string msgstr = "Game name -> ";
//  msgstr += gamestr + "\n";
//  msgstr += "Mode name -> ";
//  msgstr += modestr + "\n";
//  msgstr += "Mode game name -> ";
//  msgstr += modegamestr + "\n";
//  msgstr += "GObj name -> ";
//  msgstr += gobjstr;
//  msgstr += "  -> (";
//  msgstr += gobjindexstr + ")\n";

//  MessageBox(msgstr.c_str(),"Game - Info",MB_OK);

  string strmsgarray[6];
  strmsgarray[0] = "Game name: " + gamestr;
  strmsgarray[1] = "Master Pal Name: " + strpalname;
  strmsgarray[2] = "Mode name: " + modestr;
  strmsgarray[3] = "Mode game name: " + modegamestr;
  strmsgarray[4] = "GObj name: " + gobjstr;
  strmsgarray[5] = "GObj Index: " + gobjindexstr;

  TScrollMsgDlg *psmd = new TScrollMsgDlg(this,
                                          string("Info - Game"),
                                          strmsgarray,6);
  psmd->Execute();
  delete psmd;
}
//*******************************************************************
void TEditorModeWin::CmGameInfoEnable(TCommandEnabler &commandHandler)
{
  commandHandler.Enable(true);
}
//*******************************************************************
void TEditorModeWin::SaveMode()
{
  if (GetVDFlags().IsModeValid()) // used to be if dirty.
  {
//    PMode->Write();
    GetMode()->Save();
    #ifdef GEDMSGBOX
    string str = ModeWindowFileName + " Mode File written to disk";
    MessageBox(str.c_str(),"Mode - Save",MB_OK);
    #endif
    GetVDFlags().ClearModeDirty();

//    if (GetVDFlags().IsGObjDirty())
//    {
//      CmGObjSave();
//    }
//    PGObjList->Save();
    GetVDFlags().ClearGObjDirty();
  }
}
//*******************************************************************
void TEditorModeWin::CmModeSave()
{
  SaveMode();
}
//*******************************************************************
void TEditorModeWin::CmModeSaveEnable(TCommandEnabler &commandHandler)
{
  if (GetVDFlags().IsModeValid()) // used to be if dirty.
  {
    commandHandler.Enable(true);
  }
  else
  {
    commandHandler.Enable(false);
  }
}
//*******************************************************************
void TEditorModeWin::CmModeSaveAs()
{
  MessageBox("Not Implemented Yet","Mode - Save As",MB_OK);
}
//*******************************************************************
void TEditorModeWin::CmModeSaveAsEnable(TCommandEnabler &commandHandler)
{
  commandHandler.Enable(false);
}
//*******************************************************************
void TEditorModeWin::CmModeEditBG()
{
  string str = GetMode()->BGFileName;

  TOpenSaveDialog::TData srcdata(OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST,
                                 "Background Files (*.bmp) | *.bmp |",
                                 0,
                                 "",
                                 "bmp");
  #if !defined(OGLEOWLVER2) && defined(BI_PLAT_WIN32)
  srcdata.Flags &= (~OFN_EXPLORER);
  #endif

  string title = "Select BG Source (";
  title += str;
  title += ") -";

  TFileOpenDialog srcfod(this,srcdata,0,title.c_str());

  int srcretval = srcfod.Execute();

  if (srcretval == IDOK)
  {
    TOgleFileName ofnsrc = string(srcdata.FileName);

    title = "Select BG Dest - ";
    string destdir = GetFileMgr()->GetCDRomPath(-1);
    char *pdestdir = strdup(destdir.c_str());

    TOpenSaveDialog::TData destdata(0,
                                    "Background Files (*.bmp) | *.bmp |",
                                    0,
                                    pdestdir,
                                    "bmp");
    #if !defined(OGLEOWLVER2) && defined(BI_PLAT_WIN32)
    destdata.Flags &= (~OFN_EXPLORER);
    #endif

    TFileOpenDialog destfod(this,destdata,0,title.c_str());
    int destretval = destfod.Execute();

    free(pdestdir);

    if (destretval == IDOK)
    {
      // check of logical root.
      string strdest = destdata.FileName;
      TOgleFileName ofntest(strdest);
      if (!ofntest.HasRoot(destdir))
      {
        string errmsg = "The dest dir must be a subdir of ";
        errmsg += destdir;
        errmsg += ".\n Please try again.";
        MessageBox(errmsg.c_str(),"Error - Editing BG",MB_OK);
        return;
      }

      TOgleFileName ofndir(strdest);
      if (!ofndir.CreateDir())
      {
        MessageBox("couldn't create dir",
                   "Error - Editing BG",
                   MB_OK | MB_TASKMODAL);
        return;
      }

      if (!ofnsrc.CopyFile(strdest))
      {
        MessageBox("File copy failed.","Editing BG",MB_OK);
        return;
      }

      int len = destdir.length();
      string strpartialdest = strdest.substr(len);
      TOgleFileName ofndest = strpartialdest;
      ofndest.MassageDir();

      bool rc = GetMode()->ChangeBG(ofndest);
      string s = "ChangeBG() returned - ";
      if (rc)
      {
        s += "ok";
      }
      else
      {
        s += "not ok";
      }
      MessageBox(s.c_str(),"Results - Editing BG",MB_OK);
      GetVDFlags().SetModeDirty();
    }
  }
}
//*******************************************************************
void TEditorModeWin::CmModeEditBGEnable(TCommandEnabler &commandHandler)
{
//  commandHandler.Enable(false);
  if ((GetVDFlags().IsModeValid()) &&
      (GetVDFlags().IsGameValid()))
  {
    commandHandler.Enable(true);
  }
  else
  {
    commandHandler.Enable(false);
  }
}
//*******************************************************************
void TEditorModeWin::CmModeEditGameID()
{
  TSelectGameIdDlg sgidd(this,"Select Game ID");
  if (sgidd.Execute() == IDOK)
  {
    string selgidstr = sgidd.RetrieveSelection();
    PMode->SetGameId(selgidstr);
    GetVDFlags().SetModeDirty();
  }
}
//*******************************************************************
void TEditorModeWin::CmModeEditGameIDEnable(TCommandEnabler &commandHandler)
{
  if ((GetVDFlags().IsModeValid()) && (GetVDFlags().IsGameValid()))
  {
    commandHandler.Enable(true);
  }
  else
  {
    commandHandler.Enable(false);
  }
}
//*******************************************************************
bool TEditorModeWin::ChangeToNewGObj(string NewGObjName)
{
  TOgleFileName ofn(GetFileMgr()->GetCDRomPath(-1));
  ofn += NewGObjName;
//  ofn.AppendDirPath(NewGObjName);
  if (!ofn.CreateDir()) {return false;}

  ofn.Clear();
  ofn = NewGObjName;

  TGameObject *PGObj = new TGameObject(this);
//  ofn.SetDirPath(NewGObjName);
//  ofn.SetFName(NewGObjName);
//  ofn.SetExt(string(".go"));
  PGObj->FileMode.Name = ofn;

  ofn.SetExt(string(".spl"));
  PGObj->SpriteListName = ofn.GetStr();
  PGObj->GetSpriteList()->FileMode.Name = ofn;
  ofn.SetExt(string(".skc"));
  PGObj->SkitCatName = ofn.GetStr();
  PGObj->GetSkitCat()->FileMode.Name = ofn;
  PGObj->GetSkitCat()->POwnerGObj = PGObj;

  GetGObjList()->AddGObj(PGObj);
  CurrentGObjIndex = GetGObjList()->GetGObjIndex(NewGObjName);

  PGObj->FileMode.SetDirIndex(CurrentGObjIndex);
  PGObj->GetSpriteList()->FileMode.SetDirIndex(CurrentGObjIndex);
  PGObj->GetSkitCat()->FileMode.SetDirIndex(CurrentGObjIndex);

  PGObj->GetMiscData()->FileMode = PGObj->FileMode;
  ofn.SetExt(string(".md"));
  PGObj->strMiscDataName = ofn.GetStr();
  PGObj->GetMiscData()->FileMode.Name = ofn;

  if (!PGObj->Write())
  {
    MessageBox("GObj write() returned error","Change To New GObj",MB_OK);
    return false;
  }
  else
  {
    #ifdef GEDMSGBOX
    MessageBox("GObj written to disk","Change To New GObj",MB_OK);
    #endif
  }
  ofn.SetExt(string(".go"));
  GetVDFlags().SetModeDirty();

  #if defined(GEDMSGBOX)
  char buffer[10];
  itoa(CurrentGObjIndex,buffer,10);
  string mstr = "GObj added, Index # - ";
  mstr += buffer;
  MessageBox(mstr.c_str(),"Change To New GObj",MB_OK);
  #endif
  return true;
}
//*******************************************************************
void TEditorModeWin::ChangeToGObj(string NewGObjName)
{
  CurrentGObjIndex = GetGObjList()->GetGObjIndex(NewGObjName);
  #ifdef GEDMSGBOX
  char buffer[10];
  itoa(CurrentGObjIndex,buffer,10);
  string mstr = "GObj switched, Index # - ";
  mstr += buffer;
  MessageBox(mstr.c_str(),"Change To GObj",MB_OK);
  #endif
}
//*******************************************************************
bool TEditorModeWin::GetNewGObjFName(string &gobjname)
{
  if (GetMode() == NULL) {return false;}

//  string dstr = "New GObj for ";
//  dstr += GetMode()->FileMode.Name.GetStr();
//  char buffer[TOgleFileName::MAXFILEPARTSIZE] = "gobjs\\somename";
//  string str = "Enter GObj name:";
//  TInputDialog tid(this,
//                   dstr.c_str(),
//                   str.c_str(),
//                   buffer,
//                   TOgleFileName::MAXFILEPARTSIZE);//7);
//  if (tid.Execute() != IDOK) {return false;}
//  string bufstr = buffer;
//  TOgleFileName ofn(bufstr);
//  ofn.SetExt(".go");
//  gobjfname = ofn.GetStr();
//  if (bufstr.length() <= 0) {return false;}
//  return true;

  string strroot = GetFileMgr()->GetCDRomPath(-1);
  string str = "GObj Files (*.go) | *.go";
  string strinitialdir = strroot;
  char *pidc = const_cast<char *>(strinitialdir.c_str());
  char *pc = const_cast<char *>(str.c_str());
  TOpenSaveDialog::TData gobjsavedata(0,pc,0,pidc,"*");

  #if !defined(OGLEOWLVER2) && defined(BI_PLAT_WIN32)
  gobjsavedata.Flags &= (~OFN_EXPLORER);
  #endif

  TFileSaveDialog osd(this,gobjsavedata);
  if (osd.Execute() != IDOK)
  {
    return false;
  }
  string s = gobjsavedata.FileName;
  s = s.strip(string::Both);
  if (s.length() == 0) {return false;}
  s.to_lower();
  TOgleFileName ofnsave(s);
  ofnsave.SetExt(".go");

  if (ofnsave.FileExists())
  {
    MessageBox("Dest file already existed","Error - New GObj Name",MB_OK | MB_TASKMODAL);
    return false;
  }

  TOgleFileName ofndir(ofnsave);

  if (!ofnsave.RemoveRoot(GetFileMgr()->GetCDRomPath(-1)))
  {
    MessageBox("Dest file wasn't in logical root",
               "Error - New Sprite Name",
               MB_OK | MB_TASKMODAL);
    return false;
  }

  if (!ofndir.CreateDir())
  {
    MessageBox("Dest dir couldn't be created",
               "Error - New Sprite Name",
               MB_OK | MB_TASKMODAL);
    return false;
  }
  gobjname = ofnsave.GetStr();
  return true;
}
//*******************************************************************
bool TEditorModeWin::IsGObjInList(string NewGObjName)
{
  int16 gi = GetGObjList()->GetGObjIndex(NewGObjName);
  return bool(gi >= 0);
}
//*******************************************************************
void TEditorModeWin::CmGObjNew()
{
  if (GetVDFlags().IsGObjDirty())
  {
    CmGObjSave();
  }

  string NewGObjName;
  if (!GetNewGObjFName(NewGObjName))
  {
    MessageBox("Error getting GObj name","Error !! GObj - New",MB_OK);
    return;
  }

  if (IsGObjInList(NewGObjName))
  {
    string mstr = "GObj Name (";
    mstr += NewGObjName;
    mstr += ") already exists";
    MessageBox(mstr.c_str(),"Error !! GObj - New",MB_OK);
    return;
  }

  if (ChangeToNewGObj(NewGObjName))
  {
    GetVDFlags().SetGObjValid();
  }
  else
  {
    MessageBox("Error changing to new GObj","Error !! GObj - New",MB_OK);
    return;
  }
}
//*******************************************************************
void TEditorModeWin::CmGObjNewEnable(TCommandEnabler &commandHandler)
{
  if ((GetVDFlags().IsGameValid()) &&
      (GetVDFlags().IsModeValid()))
  {
     commandHandler.Enable(true);
  }
  else
  {
    commandHandler.Enable(false);
  }
}
//*******************************************************************
void TEditorModeWin::CmGObjOpen()
{
  if (GetVDFlags().IsGObjDirty())
  {
    CmGObjSave();
  }

  string str = "GObj Open";
  TSelectGObjDlg sgd(this,str);
  if (sgd.Execute() == IDOK)
  {
    string NewGObjName = sgd.RetrieveSelection();
    #ifdef GEDMSGBOX
    string str = "GObj Name -> " + NewGObjName;
    MessageBox(str.c_str(),"GObj Name Selected",MB_OK);
    #endif
    ChangeToGObj(NewGObjName);
    GetVDFlags().SetGObjValid();
  }
}
//*******************************************************************
void TEditorModeWin::CmGObjOpenEnable(TCommandEnabler &commandHandler)
{
  if ((GetVDFlags().IsModeValid()) &&
      (GetVDFlags().IsGameValid()))
  {
    commandHandler.Enable(true);
  }
  else
  {
    commandHandler.Enable(false);
  }
}
//*******************************************************************
void TEditorModeWin::CmGObjSave()
{
  if ((!GetVDFlags().IsGObjValid()) ||
      (CurrentGObjIndex < 0))
  {
    MessageBox("Error - There was no GObj currently selected","GObj Save",MB_OK);
  }
  else
  {
//    TGameObject *PGObj = PGObjList->GetGObjPtr(CurrentGObjIndex);

//    if (PGObj == NULL)
    if (GetGObjPtr(CurrentGObjIndex) == NULL)
    {
      MessageBox("Error - GObj not found with Current GObj Index","GObj Save",MB_OK);
    }
    else
    {
//      PGObj->Save();
      GetGObjPtr(CurrentGObjIndex)->Save();
      #ifdef GEDMSGBOX
      MessageBox("Current GObj save to disk","GObj Save",MB_OK);
      #endif
      GetVDFlags().ClearGObjDirty();
    }
  }
}
//*******************************************************************
void TEditorModeWin::CmGObjSaveEnable(TCommandEnabler &commandHandler)
{
  if ((GetVDFlags().IsGObjValid()) && (CurrentGObjIndex >= 0))
//  if ((GetVDFlags().IsGObjDirty()) &&
//      (GetVDFlags().IsGObjValid()))
  {
    commandHandler.Enable(true);
  }
  else
  {
    commandHandler.Enable(false);
  }
}
//*******************************************************************
void TEditorModeWin::CmGObjSaveAs()
{
  MessageBox("Not Implemented Yet","GObj - Save As",MB_OK);
}
//*******************************************************************
void TEditorModeWin::CmGObjSaveAsEnable(TCommandEnabler &commandHandler)
{
  commandHandler.Enable(false);
}
//*******************************************************************
void TEditorModeWin::CmGObjDelete()
{
//#if 0
  string str = "GObj Delete";
  TSelectGObjDlg sgd(this,str);
  if (sgd.Execute() == IDOK)
  {
    string DelGObjName = sgd.RetrieveSelection();
//    int16 gi = PGObjList->GetGObjIndex(DelGObjName);
    int16 gi = GetGObjList()->GetGObjIndex(DelGObjName);
    if ((CurrentGObjIndex >= 0) && (gi == CurrentGObjIndex))
    {
      MessageBox("Can't delete Current GObj","Error !! GObj - Delete",MB_OK);
      return;
    }

//    if (PMode->RemoveGObjName(DelGObjName))
//    {
//      PGObjList->DeleteGObj(gi);
//    }
//    else
//    {
//      MessageBox("Couldn't remove GObj name from Mode","Error !! GObj - Delete",MB_OK);
//      return;
//    }
    if (GetGObjList()->DeleteGObj(gi))
    {
      MessageBox("GObj deleted","Info - GObj Delete",MB_OK);
    }
    else
    {
      MessageBox("GObjList reported error, GObj not deleted",
                 "Error - GObj Delete",
                 MB_OK);
    }
  }
//#endif
}
//*******************************************************************
void TEditorModeWin::CmGObjDeleteEnable(TCommandEnabler &commandHandler)
{
//  commandHandler.Enable(false);
  if ((GetVDFlags().IsModeValid()) &&
      (GetVDFlags().IsGameValid()))
  {
    commandHandler.Enable(true);
  }
  else
  {
    commandHandler.Enable(false);
  }
}
//*******************************************************************
void TEditorModeWin::CmGObjSkitCriteriaReport()
{
  TGameObject *pgobj = GetGObjPtr(CurrentGObjIndex);
  if (pgobj == NULL)
  {
    MessageBox("gobj invalid","Error - GObj Criteria Report",MB_OK);
    return;
  }
//  string str = "c:\\";
////  str += pgobj->GetFName();
//  str += pgobj->FileMode.Name.GetFName();
//  str += ".rpt";

  TOgleFileName ofn(GetFileMgr()->GetCDRomPath(-1));
  ofn.AppendDirPath("\\reports\\skitcat");
  ofn.AppendDirPath(pgobj->FileMode.Name.GetDirPath());
  ofn.SetFName(pgobj->FileMode.Name.GetFName());
  ofn.SetExt(".rpt");
  ofn.CreateDir();

//  ofstream os(str.c_str());
  ofstream os(ofn.GetStr().c_str());
  if (!os)
  {
    MessageBox("problem with output file","Error - GObj Criteria Report",MB_OK);
    return;
  }
  else
  {
    os<<"Report FileName: "<<ofn.GetStr().c_str()<<"\n";
    os<<"***************************** Start of GObj Criteria Report *****************\n";
    os<<"Criteria report for gobj: "<<pgobj->FileMode.Name.GetStr()<<"\n";
    pgobj->GetSkitCat()->CriteriaReport(os);
    os<<"***************************** End of GObj Criteria Report *******************\n";
    os.close();
    string s = "notepad.exe ";
    s += ofn.GetStr();
    WinExec(s.c_str(),SW_SHOWNORMAL);
  }
//  string msg = "GObj Criteria Report written to file: " + str;
//  MessageBox(msg.c_str(),"GObj Criteria Report",MB_OK);
}
//*******************************************************************
void TEditorModeWin::CeGObjSkitCriteriaReport(TCommandEnabler &enabler)
{
  if (GetVDFlags().IsGameValid() &&
      GetVDFlags().IsModeValid() &&
      GetVDFlags().IsGObjValid())
  {
    enabler.Enable(true);
  }
  else
  {
    enabler.Enable(false);
  }
}
//*******************************************************************
void TEditorModeWin::CmGObjEditIDCodeList()
{
  TGameObject *pgobj = GetGObjPtr(CurrentGObjIndex);
  if (pgobj == NULL) {return;}

//  string path = GetFileMgr()->GetCDRomPath(pgobj->FileMode.GetDirIndex());
//  path += pgobj->GetFName();
//  path += ".idc";
  TOgleFileName ofn = GetFileMgr()->GetCDRomPath(-1);//pgobj->FileMode.GetDirIndex());
  ofn.AppendDirPath(pgobj->FileMode.Name.GetDirPath());
  ofn.SetFName(pgobj->FileMode.Name.GetFName());
  ofn.SetExt(string(".idc"));

  TIDCodeListDlg *pd = new TIDCodeListDlg(this,ofn.GetStr());//path);
  pd->Execute();
  delete pd;
}
//*******************************************************************
void TEditorModeWin::CeGObjEditIDCodeList(TCommandEnabler &ce)
{
  if (GetVDFlags().IsGameValid() &&
      GetVDFlags().IsModeValid() &&
      GetVDFlags().IsGObjValid())
  {
    ce.Enable(true);
  }
  else
  {
    ce.Enable(false);
  }
}
//*******************************************************************
void TEditorModeWin::CmGObjMiscData()
{
  TGameObject *pgobj = GetGObjPtr(CurrentGObjIndex);
  if (pgobj == NULL) {return;}
  if (pgobj->GetMiscData() == NULL) {return;}

  TMiscDataDlg *pmdd = new TMiscDataDlg(this,pgobj->GetMiscData(),pgobj->FileMode.Name.GetStr());//pgobj->GetFName());
  pmdd->Execute();
  delete pmdd;
  GetVDFlags().SetGObjDirty();
}
//*******************************************************************
void TEditorModeWin::CeGObjMiscData(TCommandEnabler &ce)
{
  if (GetVDFlags().IsGameValid() &&
      GetVDFlags().IsModeValid() &&
      GetVDFlags().IsGObjValid())
  {
    ce.Enable(true);
  }
  else
  {
    ce.Enable(false);
  }
}
//*******************************************************************
void TEditorModeWin::BeenSwitchedTo()
{
  GetFW()->AssignMenu(GED_MENU);
//  string strTitle = GetOgleApp()->LoadString(IDS_GAME_TITLE);
//  GetFW()->SetWindowText(strTitle.c_str());
  ClearUpdatePause();
}
//*******************************************************************
void TEditorModeWin::ClearPreviews()
{
  DoSkitPreview = false;
  DoSpritePreview = false;
}
//*******************************************************************
void TEditorModeWin::CreateModeState()
{
  PState = new TGEdModeMainState(this);
}
//*******************************************************************

