//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  gedskm.cpp
//    Project Name:  GEd
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     9/2/95     M.Perry     original baseline
//  2.0    10/28/97    M.Perry     32-bit conversion.
//********************************************************************
#include "gedskm.h"
//*******************************************************************
TGEdModePreviewSkitState::TGEdModePreviewSkitState(TEditorModeWin *PNewModeWindow)
:TGEdModeState(PNewModeWindow)
{
  #ifdef STATEDEBUG
  strcpy(ClassName,"TGEdModePreviewSkitState");
  #endif
  LBEvent = false;
}
//*******************************************************************
TGEdModePreviewSkitState::~TGEdModePreviewSkitState()
{
  GetGEdModeWin()->SkitPreviewDone = true;
}
//*******************************************************************
void TGEdModePreviewSkitState::ExecuteFirstTime()
{
  JustStarted = true;
  ExecuteStatus = ess_Execute;
  LBEvent = false;
  SkitEndFUC = 0;
}
//*******************************************************************
void TGEdModePreviewSkitState::Execute()
{
  if (JustStarted)
  {
    ExecuteWaiting = true;
    JustStarted = false;
  }

  if (ExecuteWaiting)
  {
    if (!LBEvent)
    {
      if (POwnerWindow->PTime->GetFrameUpdateCount() >= SkitEndFUC)
      {
//        SkitEndFUC = POwnerWindow->PTime->GetFrameUpdateCount() +
//                     POwnerWindow->GetSkitLength(GetGEdModeWin()->PreviewGObjIndex,
//                                                 GetGEdModeWin()->PreviewSkitCatIndex,
//                                                 GetGEdModeWin()->PreviewSkitIndex);
//        POwnerWindow->ActivateSkitNow(GetGEdModeWin()->PreviewGObjIndex,
//                                      GetGEdModeWin()->PreviewSkitCatIndex,
//                                      GetGEdModeWin()->PreviewSkitIndex);
        int16 gi = GetGEdModeWin()->PreviewGObjIndex;
        int16 sci = GetGEdModeWin()->PreviewSkitCatIndex;
        int16 si = GetGEdModeWin()->PreviewSkitIndex;

        SkitEndFUC = POwnerWindow->GetAdjFUC() + POwnerWindow->GetSkitLength(gi,sci,si);
        POwnerWindow->ActivateSkit(gi,sci,si,POwnerWindow->GetAdjFUC());
      }
    }
    else
    {
      if (POwnerWindow->PTime->GetFrameUpdateCount() >= SkitEndFUC)
      {
        ExecuteWaiting = false;
        ExecuteStatus = ess_Done;
      }
    }
  }
  else
  {
    ExecuteStatus = ess_Done;
  }
}
//*******************************************************************
#pragma argsused
bool TGEdModePreviewSkitState::HandleLDown(uint modKeys,TPoint &point)
{
  LBEvent = true;
  return false;
}
//*******************************************************************
void TGEdModePreviewSkitState::RecommendSibling()
{
  Status = ss_Done;
}
//*******************************************************************

