create or replace package body PWesternUnionWDTX as
//*******************************************************************
procedure Modify(ean IN,txid IN,mac IN,mtc IN,wuwdtx OUT,ec OUT)
{
  Lock(txid,wuwdtx,ec);
  if (ec == EC_NONE)
  {
    wuwdtx.Modify(ean,mac,mtc,ec);
    UnLock(wuwdtx,ec);
  }
}
//*******************************************************************
procedure Commit(ean IN,ec OUT)
{
  LockArray(ean,wuwdtx_array,wuwdtx_num,ec);
  for (int i=0;i<wuwdtx_num;i++)
  {
    wuwdtx_array[i].Commit();
  }
  UnLockArray(wuwdtx_array,wuwdtx_num,ec);
}
//*******************************************************************
procedure Cancel(ean IN,ec OUT)
{
  LockArray(ean,wuwdtx_array,wuwdtx_num,ec);
  for (int i=0;i<wuwdtx_num;i++)
  {
    wuwdtx_array[i].Cancel();
  }
  UnLockArray(wuwdtx_array,wuwdtx_num,ec);
}
//*******************************************************************
procedure Lock(txid IN,wuwdtx OUT,ec OUT)
{
  ec = EC_NONE;

  select from Tbl_WesternUnionWDTX
  where rec.TXID == txid
  for update

  // wuwdtx = rec;

  if (!found)
  {
    ec = EC_TX_NOTFOUND;
  }
}
//*******************************************************************
procedure UnLock(wuwdtx IN,ec OUT)
{
  ec = EC_NONE;

  update Tbl_WesternUnionWDTX
  where rec.TXID == wuwdtx.TXID

  // rec = wuwdtx
}
//*******************************************************************
procedure LockArray(ean IN,wuwdtx_array OUT,wuwdtx_num OUT,ec OUT)
{
  // lock all from Tbl_WesternUnionWDTX
  // where rec.Current_EAN == ean
  // and put into array
  // incrementing num
}
//*******************************************************************
procedure UnLockArray(wuwdtx_array IN,wuwdtx_num IN,ec OUT)
{
  // update Tbl_WesternUnionWDTX
  // using array.
}
//*******************************************************************
procedure Create(ean IN,uan IN,amount IN,limitaddress IN,noservfee IN,
                 wuwdtx OUT,ec OUT)
{
  ec = EC_NONE;

  if (noservfee)
  {
    ServiceFee = 0;
  }
  else
  {
    PCasCfg.WU_GetWDServiceFeeAmount(ServiceFee,ec);
  }
  PWallet.Lock(uan,wallet,ec);
  if (ec == EC_NONE)
  {
    if (wallet.Balance < (amount + ServiceFee))
    {
      ec = EC_WALLET_BALANCE_NSF;
    }
    else
    {
      wallet.DecBalance(amount + ServiceFee);
      PWallet.UnLock(wallet,ec);
      wuwdtx TWesternUnionWDTX = TWesternUnionWDTX(TXID_Seq.Next(),
                                                   uan,
                                                   true,
                                                   amount,
                                                   servicefee,
                                                   ean,
                                                   SYSDATE,
                                                   0,
                                                   SC_NONE,
                                                   0,
                                                   true,
                                                   0,
                                                   SC_NONE,
                                                   0,
                                                   true,
                                                   0,
                                                   SC_NONE,
                                                   0,
                                                   true,
                                                   0,
                                                   SC_NONE,
                                                   0,
                                                   true,
                                                   0,
                                                   0);
      wuwdtx.VerifyENB();
    }
  }
}
//*******************************************************************
procedure Add(wuwdtx IN,ec OUT)
{
  ec = EC_NONE;

  insert wuwdtx
  into Tbl_WesternUnionWDTX
}
//*******************************************************************
procedure CreateAdd(ean IN,uan IN,amount IN,noservfee IN,txid OUT,ec OUT)
{
  Create(ean,uan,amount,noservfee,wuwdtx,ec);
  if (ec == EC_NONE)
  {
    txid = wuwdtx.TXID;
    Add(wuwdtx,ec);
  }
}
//*******************************************************************
procedure GetArray(filter IN,wuwdtx_array,wuwdtx_num,ec OUT)
{
  // get all from Tbl_WesternUnionWDTX
  // where rec == filter options
  // and put into array
  // do not lock elements.
}
//*******************************************************************
end;