create or replace package body PAdjDepTX as
//*******************************************************************
procedure Modify(ean IN,txid IN,mac IN,adjdeptx OUT,ec OUT)
{
  Lock(txid,adjdeptx,ec);
  if (ec == EC_NONE)
  {
    adjdeptx.Modify(ean,mac,ec);
    UnLock(adjdeptx,ec);
  }
}
//*******************************************************************
procedure Commit(ean IN,ec OUT)
{
  LockArray(ean,adjdeptx_array,adjdeptx_num,ec);
  for(int i=0;i<adjdeptx_num;i++)
  {
    adjdeptx_array[i].Commit();
  }
  UnLockArray(adjdeptx_array,adjdeptx_num,ec);
}
//*******************************************************************
procedure Cancel(ean IN,ec OUT)
{
  LockArray(ean,adjdeptx_array,adjdeptx_num,ec);
  for (int i=0;i<adjdeptx_num;i++)
  {
    adjdeptx_array[i].Cancel();
  }
  UnLockArray(adjdeptx_array,adjdeptx_num,ec);
}
//*******************************************************************
procedure Lock(txid IN,adjdeptx OUT,ec OUT)
{
  ec = EC_NONE;

  select from Tbl_AdjDepTX
  where rec.TXID == txid
  for update

  // adjdeptx = rec;

  if (!found)
  {
    ec = EC_TX_NOTFOUND;
  }
}
//*******************************************************************
procedure UnLock(adjdeptx IN,ec OUT)
{
  ec = EC_NONE;

  update Tbl_AdjDepTX
  where rec.TXID == adjdeptx.TXID

  // rec = adjdeptx;
}
//*******************************************************************
procedure LockArray(ean IN,adjdeptx_array OUT,adjdeptx_num OUT,ec OUT)
{
  // lock all from Tbl_AdjDepTX
  // where rec.Current_EAN == ean
  // and put into array
  // incrementing num
}
//*******************************************************************
procedure UnLockArray(adjdeptx_array IN,adjdeptx_num IN,ec OUT)
{
  // update Tbl_AdjDepTX
  // using array.
}
//*******************************************************************
procedure Create(ean IN,uan IN,amount IN,detail IN,adjdeptx OUT,ec OUT)
{
  ec = EC_NONE;

  adjdeptx TAdjDepTX = TAdjDepTX(TXID_Seq.Next(),
                                 uan,
                                 true,
                                 amount,
                                 ean,
                                 SYSDATE,
                                 SC_NONE,
                                 0,
                                 0,
                                 true,
                                 SC_NONE,
                                 0,
                                 0,
                                 true,
                                 detail);
  adjdeptx.VerifyENB();
}
//*******************************************************************
procedure Add(adjdeptx IN,ec OUT)
{
  ec = EC_NONE;

  insert adjdeptx
  into Tbl_AdjDepTX
}
//*******************************************************************
procedure CreateAdd(ean IN,uan IN,amount IN,detail IN,txid OUT,ec OUT)
{
  Create(ean,uan,amount,detail,adjdeptx,ec);
  if (ec == EC_NONE)
  {
    txid = adjdeptx.TXID;
    Add(adjdeptx,ec);
  }
}
//*******************************************************************
procedure GetArray(filter IN,adjdeptx_array OUT,adjdeptx_num OUT,ec OUT)
{
  // get all from Tbl_AdjDepTX
  // where rec == filter options
  // and put into array
  // do not lock elements.
}
//*******************************************************************
end;