create or replace package body PAdjWDTX as
//*******************************************************************
procedure Modify(ean IN,txid IN,adjwdtx OUT,ec OUT)
{
  Lock(txid,adjwdtx,ec);
  if (ec == EC_NONE)
  {
    adjwdtx.Modify(ean,mac,ec);
    UnLock(adjwdtx,ec);
  }
}
//*******************************************************************
procedure Commit(ean IN,ec OUT)
{
  LockArray(ean,adjwdtx_array,adjwdtx_num,ec);
  for (int i=0;i<adjwdtx_num;i++)
  {
    adjwdtx_array[i].Commit();
  }
  UnLockArray(adjwdtx_array,adjwdtx_num,ec);
}
//*******************************************************************
procedure Cancel(ean IN,ec OUT)
{
  LockArray(ean,adjwdtx_array,adjwdtx_num,ec);
  for (int i=0;i<adjwdtx_num;i++)
  {
    adjwdtx_array[i].Cancel();
  }
  UnLockArray(adjwdtx_array,adjwdtx_num,ec);
}
//*******************************************************************
procedure Lock(txid IN,adjwdtx OUT,ec OUT)
{
  ec = EC_NONE;

  select from Tbl_AdjWDTX
  where rec.TXID == txid
  for update

  // adjwdtx = rec;

  if (!found)
  {
    ec = EC_TX_NOTFOUND;
  }
}
//*******************************************************************
procedure UnLock(adjwdtx IN,ec OUT)
{
  ec = EC_NONE;

  update Tbl_AdjWDTX
  where rec.TXID == adjwdtx.TXID

  // rec = adjwdtx
}
//*******************************************************************
procedure LockArray(ean IN,adjwdtx_array OUT,adjwdtx_num OUT,ec OUT)
{
  // lock all from Tbl_AdjWDTX
  // where rec.Current_EAN == ean
  // and put into array
  // incrementing num
}
//*******************************************************************
procedure UnLockArray(adjwdtx_array IN,adjwdtx_num IN,ec OUT)
{
  // update Tbl_AdjWDTX
  // using array.
}
//*******************************************************************
procedure Create(ean IN,uan IN,bid IN,amount IN,detail IN,adjwdtx OUT,ec OUT)
{
  ec = EC_NONE;

  PWallet.Lock(uan,wallet,ec);
  if (ec == EC_NONE)
  {
    if (wallet.Balance < amount)
    {
      ec = EC_WALLET_BALANCE_NSF;
      PWallet.UnLock(wallet,ec);
    }
    else
    {
      wallet.DecBalance(amount);
      PWallet.UnLock(wallet,ec);
      adjwdtx TAdjWDTX = TAdjWDTX(TXID_Seq.Next(),
                                  uan,
                                  true,
                                  amount,
                                  0,
                                  ean,
                                  SYSDATE,
                                  0,
                                  SC_NONE,
                                  0,
                                  true,
                                  0,
                                  SC_NONE,
                                  0,
                                  true,
                                  detail);
      adjwdtx.VerifyENB();
    }
  }
}
//*******************************************************************
procedure Add(adjwdtx IN,ec OUT)
{
  ec = EC_NONE;

  insert adjwdtx
  into Tbl_AdjWDTX
}
//*******************************************************************
procedure CreateAdd(ean IN,uan IN,amount IN,detail IN,txid OUT,ec OUT)
{
  Create(ean,uan,bid,amount,detail,adjwdtx,ec);
  if (ec == EC_NONE)
  {
    txid = adjwdtx.TXID;
    Add(adjwdtx,ec);
  }
}
//*******************************************************************
procedure GetArray(filter IN,adjwdtx_array,adjwdtx_num,ec OUT)
{
  // get all from Tbl_AdjWDTX
  // where rec == filter options
  // and put into array
  // do not lock elements.
}
//*******************************************************************