create or replace package PCasCfg as
//*******************************************************************
// sections: "support",
             "lobby",
             "bank",
             "check",
             "cc",
             "wt",
             "wu",
             "slots",
             "bj",
             "vp",
             "roulette",
             "machine_stats"

#define CFG_ID_SUPPORT_PHONE                             1
#define CFG_ID_SUPPORT_EMAIL                             2
#define CFG_ID_SUPPORT_WEBURL                            3
#define CFG_ID_SUPPORT_NEWWELCOME                        4
#define CFG_ID_SUPPORT_NEWDISCLAIMER                     5

#define CFG_ID_LOBBY_GREETINGON                          10
#define CFG_ID_LOBBY_GREETINGTXT                         11
#define CFG_ID_LOBBY_MARQUEETXT                          12

#define CFG_ID_BANK_ALLOWCASHPLAY                        20
#define CFG_ID_BANK_ALLOWFREEPLAY                        21
#define CFG_ID_BANK_NEWUSERSFREEPLAYAMOUNT               22
#define CFG_ID_BANK_NEWFREEONLYFREEPLAYAMOUNT            23
#define CFG_ID_BANK_ADDDAILYFREEPLAYAMOUNT               24
#define CFG_ID_BANK_MAXADDDAILYFREEPLAYUNLESSFLAG        25
#define CFG_ID_BANK_MAXADDDAILYFREEPLAYUNLESSAMOUNT      26
#define CFG_ID_BANK_MAXADDDAILYFREEPLAYCASHOUTFLAG       27

#define CFG_ID_CHECK_ALLOWDEP                            30
#define CFG_ID_CHECK_MINDEPAMOUNT                        31
#define CFG_ID_CHECK_MAXDEPAMOUNT                        32
#define CFG_ID_CHECK_DEPSERVICEFEE                       33
#define CFG_ID_CHECK_ALLOWADVANCES                       34
#define CFG_ID_CHECK_DEPINSTRUCTIONS                     35
#define CFG_ID_CHECK_ALLOWWD                             36
#define CFG_ID_CHECK_MINWDAMOUNT                         37
#define CFG_ID_CHECK_MAXWDAMOUNT                         38
#define CFG_ID_CHECK_WDSERVICEFEEREGULAR                 39
#define CFG_ID_CHECK_WDSERVICEFEEEXPRESS                 40
#define CFG_ID_CHECK_WDINSTRUCTIONS                      41
#define CFG_ID_CHECK_ALLOWEMPNEWWD                       42

#define CFG_ID_CC_ALLOWDEP                               50
#define CFG_ID_CC_MINDEPAMOUNT                           51
#define CFG_ID_CC_MAXDEPAMOUNT                           52
#define CFG_ID_CC_DEPSERVICEFEEAMOUNT                    53
#define CFG_ID_CC_DEPINSTRUCTIONS                        54
#define CFG_ID_CC_ALLOWAUTODEP                           55
#define CFG_ID_CC_ALLOWWD                                56
#define CFG_ID_CC_MINWDAMOUNT                            57
#define CFG_ID_CC_MAXWDAMOUNT                            58
#define CFG_ID_CC_WDSERVICEFEEAMOUNT                     59
#define CFG_ID_CC_ALLOWWDGTDEP                           60
#define CFG_ID_CC_RECREDITEXPIREDAYS                     61
#define CFG_ID_CC_WDINSTRUCTIONS                         62
#define CFG_ID_CC_AUTOWD                                 63
#define CFG_ID_CC_ALLOWEMPNEWDEP                         64
#define CFG_ID_CC_ALLOWEMPNEWWD                          65

#define CFG_ID_WU_ALLOWDEP                               70
#define CFG_ID_WU_MINDEPAMOUNT                           71
#define CFG_ID_WU_MAXDEPAMOUNT                           72
#define CFG_ID_WU_DEPSERVICEFEEAMOUNT                    73
#define CFG_ID_WU_DEPINSTRUCTIONS                        74
#define CFG_ID_WU_ALLOWWD                                75
#define CFG_ID_WU_MINWDAMOUNT                            76
#define CFG_ID_WU_MAXWDAMOUNT                            77
#define CFG_ID_WU_WDSERVICEFEEAMOUNT                     78
#define CFG_ID_WU_WDINSTRUCTIONS                         79
#define CFG_ID_WU_AUTOWD                                 80
#define CFG_ID_WU_ALLOWEMPNEWWD                          81
#define CFG_ID_WU_ALLOWDEP                               82

#define CFG_ID_WT_ALLOWDEP                               90
#define CFG_ID_WT_MINDEP                                 91
#define CFG_ID_WT_MAXDEP                                 92
#define CFG_ID_WT_DEPSERVICEFEE                          93
#define CFG_ID_WT_ALLOWDEPADVANCES                       94
#define CFG_ID_WT_DEPINSTRUCTIONS                        95
#define CFG_ID_WT_ALLOWWD                                96
#define CFG_ID_WT_MINWD                                  97
#define CFG_ID_WT_MAXWD                                  98
#define CFG_ID_WT_WDSERVICEFEE                           99
#define CFG_ID_WT_WDINSTRUCTIONS                         100
#define CFG_ID_WT_ALLOWAUTOWD                            101
#define CFG_ID_WT_ALLOWEMPNEWWD                          102

#define CFG_ID_SLOTS_ON                                  110

#define CFG_ID_ROULETTE_ON                               120

#define CFG_ID_VP_ON                                     130

#define CFG_ID_BJ_ON                                     140

#define CFG_ID_MACHINE_STATS_UPDATE                      150


procedure Support_GetPhone(phone IN OUT,ec OUT);
procedure Support_SetPhone(phone IN,ec OUT);
procedure Support_GetEMail(email IN OUT,ec OUT);
procedure Support_SetEMail(email IN,ec OUT);
procedure Support_GetWebUrl(weburl IN OUT,ec OUT);
procedure Support_SetWebUrl(weburl IN,ec OUT);
procedure Support_GetNewWelcome(welcome IN OUT,ec OUT);
procedure Support_SetNewWelcome(welcome,ec);
procedure Support_GetNewDisclaimer(disclaimer,ec);
procedure Support_SetNewDisclaimer(disclaimer,ec);
procedure Lobby_GetGreetingOn(on,ec);
procedure Lobby_SetGreetingOn(on,ec);
procedure Lobby_GetGreetingTxt(greeting,ec);
procedure Lobby_SetGreetingTxt(greeting,ec);
procedure Lobby_GetMarqueeTxt(marquee,ec);
procedure Lobby_SetMarqueeTxt(marquee,ec);
procedure Bank_GetAllowCashPlay(cash,ec);
procedure Bank_SetAllowCashPlay(cash,ec);
procedure Bank_GetAllowFreePlay(free,ec);
procedure Bank_SetAllowFreePlay(free,ec);
procedure Bank_GetNewUsersFreePlayAmount(amount,ec);
procedure Bank_SetNewUsersFreePlayAmount(amount,ec);
procedure Bank_GetNewFreeOnlyFreePlayAmount(amount,ec);
procedure Bank_SetNewFreeOnlyFreePlayAmount(amount,ec);
procedure Bank_GetAddDailyFreePlayAmount(amount,ec);
procedure Bank_SetAddDailyFreePlayAmount(amount,ec);
procedure Bank_GetMaxAddDailyFreePlayUnlessFlag(flag,ec);
procedure Bank_SetMaxAddDailyFreePlayUnlessFlag(flag,ec);
procedure Bank_GetMaxAddDailyFreePlayUnlessAmount(amount,ec);
procedure Bank_SetMaxAddDailyFreePlayUnlessAmount(amount,ec);
procedure Bank_GetMaxAddDailyFreePlayCashLockoutFlag(flag,ec);
procedure Bank_SetMaxAddDailyFreePlayCashLockoutFlag(flag,ec);
procedure Check_GetAllowDep(allow,ec);
procedure Check_SetAllowDep(allow,ec);
procedure Check_GetMinDepAmount(amount,ec);
procedure Check_SetMinDepAmount(amount,ec);
procedure Check_GetMaxDepAmount(amount,ec);
procedure Check_SetMaxDepAmount(amount,ec);
procedure Check_GetDepServiceFee(amount,ec);
procedure Check_SetDepServiceFee(amount,ec);
procedure Check_GetAllowAdvances(allow,ec);
procedure Check_SetAllowAdvances(allow,ec);
procedure Check_GetDepInstructions(instr,ec);
procedure Check_SetDepInstructions(instr,ec);
procedure Check_GetAllowWD(allow,ec);
procedure Check_SetAllowWD(allow,ec);
procedure Check_GetMinWDAmount(amount,ec);
procedure Check_SetMinWDAmount(amount,ec);
procedure Check_GetMaxWDAmount(amount,ec);
procedure Check_SetMaxWDAmount(amount,ec);
procedure Check_GetWDServiceFeeRegular(amount,ec);
procedure Check_SetWDServiceFeeRegular(amount,ec);
procedure Check_GetWDServiceFeeExpress(amount,ec);
procedure Check_SetWDServiceFeeExpress(amount,ec);
procedure Check_GetWDInstructions(instr,ec);
procedure Check_SetWDInstructions(instr,ec);
procedure Check_GetAllowEmpNewWD(allow,ec);
procedure Check_SetAllowEmpNewWD(allow,ec);
procedure CC_GetAllowDep(allow,ec);
procedure CC_SetAllowDep(allow,ec);
procedure CC_GetMinDepAmount(amount,ec);
procedure CC_SetMinDepAmount(amount,ec);
procedure CC_GetMaxDepAmount(amount,ec);
procedure CC_SetMaxDepAmount(amount,ec);
procedure CC_GetDepServiceFeeAmount(amount,ec);
procedure CC_SetDepServiceFeeAmount(amount,ec);
procedure CC_GetDepInstructions(instr,ec);
procedure CC_SetDepInstructions(instr,ec);
procedure CC_GetAllowAutoDep(allow,ec);
procedure CC_SetAllowAutoDep(allow,ec);
procedure CC_GetAllowWD(allow,ec);
procedure CC_SetAllowWD(allow,ec);
procedure CC_GetMinWDAmount(amount,ec);
procedure CC_SetMinWDAmount(amount,ec);
procedure CC_GetMaxWDAmount(amount,ec);
procedure CC_SetMaxWDAmount(amount,ec);
procedure CC_GetWDServiceFeeAmount(amount,ec);
procedure CC_SetWDServiceFeeAmount(amount,ec);
procedure CC_GetAllowWD_GT_Dep(allow,ec);
procedure CC_SetAllowWD_GT_Dep(allow,ec);
procedure CC_GetRecreditExpireDays(amount,ec);
procedure CC_SetRecreditExpireDays(amount,ec);
procedure CC_GetWDInstructions(instr,ec);
procedure CC_SetWDInstructions(instr,ec);
procedure CC_GetAutoWD(auto,ec);
procedure CC_SetAutoWD(auto,ec);
procedure CC_GetAllowEmpNewDep(allow,ec);
procedure CC_SetAllowEmpNewDep(allow,ec);
procedure CC_GetAllowEmpNewWD(allow,ec);
procedure CC_SetAllowEmpNewWD(allow,ec);
procedure WU_GetAllowDep(allow,ec);
procedure WU_SetAllowDep(allow,ec);
procedure WU_GetMinDepAmount(amount,ec);
procedure WU_SetMinDepAmount(amount,ec);
procedure WU_GetMaxDepAmount(amount,ec);
procedure WU_SetMaxDepAmount(amount,ec);
procedure WU_GetDepServiceFeeAmount(amount,ec);
procedure WU_SetDepServiceFeeAmount(amount,ec);
procedure WU_GetDepInstructions(instr,ec);
procedure WU_SetDepInstructions(instr,ec);
procedure WU_GetAllowWD(allow,ec);
procedure WU_SetAllowWD(allow,ec);
procedure WU_GetMinWDAmount(amount,ec);
procedure WU_SetMInWDAmount(amount,ec);
procedure WU_GetMaxWDAmount(amount,ec);
procedure WU_SetMaxWDAmount(amount,ec);
procedure WU_GetWDServiceFeeAmount(amount,ec);
procedure WU_SetWDServiceFeeAmount(amount,ec);
procedure WU_GetWDInstructions(instr,ec);
procedure WU_SetWDInstructions(instr,ec);
procedure WU_GetAutoWD(auto,ec);
procedure WU_SetAutoWD(auto,ec);
procedure WU_GetAllowEmpNewWD(allow,ec);
procedure WU_SetAllowEmpNewWD(allow,ec);
procedure WT_GetAllowDep(allow,ec);
procedure WT_SetAllowDep(allow,ec);
procedure WT_GetMinDep(amount,ec);
procedure WT_SetMinDep(amount,ec);
procedure WT_GetMaxDep(amount,ec);
procedure WT_SetMaxDep(amount,ec);
procedure WT_GetDepServiceFee(amount,ec);
procedure WT_SetDepServiceFee(amount,ec);
procedure WT_GetAllowDepAdvances(allow,ec);
procedure WT_SetAllowDepAdvances(allow,ec);
procedure WT_GetDepInstructions(instr,ec);
procedure WT_SetDepInstructions(instr,ec);
procedure WT_GetAllowWD(allow,ec);
procedure WT_SetAllowWD(allow,ec);
procedure WT_GetMinWD(amount,ec);
procedure WT_SetMinWD(amount,ec);
procedure WT_GetMaxWD(amount,ec);
procedure WT_SetMaxWD(amount,ec);
procedure WT_GetWDServiceFee(amount,ec);
procedure WT_SetWDServiceFee(amount,ec);
procedure WT_GetWDInstructions(instr,ec);
procedure WT_SetWDInstructions(instr,ec);
procedure WT_GetAllowAutoWD(allow,ec);
procedure WT_SetAllowAutoWD(allow,ec);
procedure WT_GetAllowEmpNewWD(allow,ec);
procedure WT_SetAllowEmpNewWD(allow,ec);
procedure Slots_GetOn(on,ec);
procedure Slots_SetOn(on,ec);
procedure BJ_GetOn(on,ec);
procedure BJ_SetOn(on,ec);
procedure Roulette_GetOn(on,ec);
procedure Roulette_SetOn(on,ec);
procedure VP_GetOn(on,ec);
procedure VP_SetOn(on,ec);
procedure Machine_Stats_GetUpdate(setting,ec);
procedure Machine_Stats_SetUpdate(setting,ec);
//*******************************************************************
end;