create or replace package body PCheckWDTX as
//*******************************************************************
procedure Modify(ean IN PDef.TEAN,
                 txid IN TXID,
                 mac IN TMAC,
                 ec IN OUT TErrorCode,
                 checkwdtx OUT TCheckWDTX)
{
  Lock(txid,checkwdtx,ec);

  if (ec == PDef.EC_NONE)
  {
    checkwdtx.Modify(ean,mac,ec);

    UnLock(checkwdtx,ec);
  }
}
//*******************************************************************
procedure Commit(ean IN,ec OUT)
{
  // get and lock all "open" checkwdtx's that are currently
  // being modified by ean.

  LockArray(ean,checkwdtx_array,checkwdtx_num,ec);
  for (int i = 0;i < chwdtx_num;i++)
  {
    checkwdtx_array[i].Commit();
  }
  UnLockArray(checkwdtx_array,checkwdtx_num,ec);
}
//*******************************************************************
procedure Cancel(ean IN,ec OUT)
{
  LockArray(ean,checkwdtx_array,checkwdtx_num,ec);
  for (int i=0;i < checkwdtx_num;i++)
  {
    checkwdtx_array[i].Cancel();
  }
  UnLockArray(checkwdtx_array,checkwdtx_num,ec);
}
//*******************************************************************
procedure Lock(txid IN TXID,checkwdtx IN OUT TCheckWDTX,ec OUT TErrorcode)
{
  ec = EC_NONE;

  select from Tbl_CheckWDTX
  where rec.TXID == txid
  for update

  //checkwdtx = rec;

  if (!found)
  {
    ec = EC_TX_NOTFOUND;
  }
}
//*******************************************************************
procedure UnLock(checkwdtx IN TCheckWDTX,ec OUT TErrorCode)
{
  update Tbl_CheckWDTX
  where rec.TXID == checkwdtx.TXID;

  //rec = checkwdtx;
}
//*******************************************************************
procedure LockArray(ean IN,checkwdtx_array OUT,checkwdtx_num OUT,ec OUT)
{
  // lock all from Tbl_CheckWDTX
  // where rec.Current_EAN == ean
  // and put into array
  // incrementing num
}
//*******************************************************************
procedure UnLockArray(checkwdtx_array IN,checkwdtx_num IN,ec OUT)
{
  // update Tbl_CheckWDTX
  // using array.
}
//*******************************************************************
procedure Create(ean IN,uan IN,amount IN,express IN,noservfee IN,
                 checkwdtx OUT,ec OUT)
{
  ec = EC_NONE;

  servicefee TCurrency;
  if (noservfee)
  {
    servicefee = 0;
  }
  else
  {
    if (express)
    {
      PCasCfg.Check_GetWDServiceFeeExpress(servicefee,ec);
    }
    else
    {
      PCasCfg.Check_GetWDServiceFeeRegular(servicefee,ec);
    }
  }

  PWallet.Lock(uan,wallet,ec);
  if (ec == EC_NONE)
  {
    if (wallet.Balance < (amount + servicefee))
    {
      ec = EC_WALLET_BALANCE_NSF;
      PWallet.UnLock(wallet,ec);
    }
    else
    {
      wallet.DecBalance(amount + servicefee);
      PWallet.UnLock(wallet,ec);
      checkwdtx TCheckWDTX = TCheckWDTX(user.UAN,
                                        TXID_Seq.Next(),
                                        true,
                                        0,
                                        amount,
                                        express,
                                        servicefee,
                                        ean,
                                        SYSDATE,
                                        SC_NONE,
                                        0,
                                        0,
                                        true,
                                        SC_NONE,
                                        0,
                                        0,
                                        true,
                                        SC_NONE,
                                        0,
                                        0,
                                        true,
                                        SC_NONE,
                                        0,
                                        0,
                                        true);
      checkwdtx.VerifyENB();
    }
  }
}
//*******************************************************************
procedure Add(checkwdtx IN,ec OUT)
{
  insert checkwdtx
  into Tbl_CheckWDTX;
}
//*******************************************************************
procedure CreateAdd(ean IN,uan IN,amount IN,express IN TBool,
                    noservfee IN,txid OUT,ec OUT)
{
  Create(ean,uan,amount,express,noservfee,checkwdtx,ec);
  if (ec == EC_NONE)
  {
    txid = checkwdtx.TXID;
    Add(checkwdtx,ec);
  }
}
//*******************************************************************
procedure GetArray(filter IN TFilter,
                   checkwdtx_array OUT,checkwdtx_num OUT,ec OUT)
{
  //get all from Tbl_CheckWDTX
  //where rec == filter options
  //and put into array
  // don't lock
}
//*******************************************************************
end PCheckWithdrawal;