create or replace package body PCreditCardWDTX as
//*******************************************************************
procedure Modify(ean IN,txid IN,mac IN,fi_approvalcode IN,ccwdtx OUT,ec OUT)
{
  Lock(txid,ccwdtx,ec);
  if (ec == EC_NONE)
  {
    ccwdtx.Modify(ean,mac,fi_approvalcode,ec);
    UnLock(ccwdtx,ec);
  }
}
//*******************************************************************
procedure Commit(ean IN,ec OUT)
{
  LockArray(ean,ccwdtx_array,ccwdtx_num,ec);
  for (int i=0;i<ccwdtx_num;i++)
  {
    ccwdtx_array[i].Commit();
  }
  UnLockArray(ccwdtx_array,ccwdtx_num,ec);
}
//*******************************************************************
procedure Cancel(ean IN,ec OUT)
{
  LockArray(ean,ccwdtx_array,ccwdtx_num,ec);
  for (int i=0;i<ccwdtx_num;i++)
  {
    ccwdtx_array[i].Cancel();
  }
  UnLockArray(ccwdtx_array,ccwdtx_num,ec);
}
//*******************************************************************
procedure Lock(txid IN,ccwdtx OUT,ec OUT)
{
  ec = EC_NONE;

  select from Tbl_CreditCardWDTX
  where rec.TXID == txid
  for update

  // ccwdtx = rec;

  if (!found)
  {
    ec = EC_TX_NOTFOUND;
  }
}
//*******************************************************************
procedure UnLock(ccwdtx IN,ec OUT)
{
  ec = EC_NONE;

  update Tbl_CreditCardWDTX
  where rec.TXID == ccwdtx.TXID;

  // rec = ccwdtx
}
//*******************************************************************
procedure LockArray(ean IN,ccwdtx_array OUT,ccwdtx_num OUT,ec OUT)
{
  // lock all from Tbl_CreditCardWDTX
  // where rec.Current_EAN == ean
  // and put into array
  // incrementing num
}
//*******************************************************************
procedure UnLockArray(ccwdtx_array IN,ccwdtx_num IN,ec OUT)
{
  // update Tbl_CreditCardWDTX
  // using array.
}
//*******************************************************************
procedure Create(ean IN,uan IN,bid IN,amount IN,noservfee IN,
                 fi_approvalcode IN,ccwdtx OUT,ec OUT)
// note: need check against bank account to see whether we can wd
//       and how much before we wd more than dep on this cc.
{
  ec = EC_NONE;

  manuallyentered TBool = TBool(fi_approvalcode != 0);

  servicefee TCurrency;
  if (noservfee)
  {
    servicefee = 0;
  }
  else
  {
    PCasCfg.CC_GetWDServiceFee(servicefee,ec);
  }
  PWallet.Lock(uan,wallet,ec);
  if (ec == EC_NONE)
  {
    if (wallet.Balance < (amount + servicefee))
    {
      ec = EC_WALLET_BALANCE_NSF;
    }
    else
    {
      wallet.DecBalance(amount + servicefee);
      PWallet.UnLock(wallet,ec);
      ccwdtx TCreditCardWDTX = TCreditCardWDTX(TXID_Seq.Next(),
                                               uan,
                                               true,
                                               bid,
                                               0,
                                               0,
                                               0,
                                               0,
                                               amount,
                                               servicefee,
                                               manuallentered,
                                               ean,
                                               SYSDATE,
                                               0,
                                               SC_NONE,
                                               0,
                                               true,
                                               0,
                                               SC_NONE,
                                               0,
                                               true,
                                               0,
                                               SC_NONE,
                                               0,
                                               true,
                                               0,
                                               SC_NONE,
                                               0,
                                               true);
      ccwdtx.VerifyENB();
    }

  }
}
//*******************************************************************
procedure Add(ccwdtx IN,ec OUT)
{
  ec = EC_NONE;
  
  insert ccwdtx
  into Tbl_CreditCardWDTX
}
//*******************************************************************
procedure CreateAdd(ean IN,uan IN,bid IN,amount IN,noservfee IN,
                    fi_approvalcode IN,txid OUT,ec OUT)
{
  Create(ean,uan,bid,amount,noservfee,fi_approvalcode,ccwdtx,ec);
  if (ec == EC_NONE)
  {
    txid = ccwdtx.TXID;
    Add(ccwdtx,ec);
  }
}
//*******************************************************************
procedure GetArray(filter IN,ccwdtx_array OUT,ccwdtx_num OUT,ec OUT)
{
  // get all from Tbl_CreditCardWDTX
  // where rec == filter options
  // and put into array
  // don't lock.
}
//*******************************************************************
end;