create or replace package body PGS as
//*******************************************************************
procedure Login(ipaddr,ec)
{
  CreateAdd(ipaddr,ec);
}
//*******************************************************************
procedure Logoff(ipaddr,ec)
{
  Remove(ipaddr,ec);
}
//*******************************************************************
procedure Read(ipaddr IN,gs OUT,ec OUT)
{
  select gs from Tbl_GS
  where gs.IPAddr == ipaddr;
  ec = EC_NONE:
}
//*******************************************************************
procedure Get(ipaddr IN,gs OUT,ec OUT)
{
  select gs from Tbl_GS
  where gs.IPAddr == ipaddr
  for update;
  ec = EC_NONE;
}
//*******************************************************************
procedure Set(gs IN,ec OUT)
{
  // update gs in Tbl_GS;
}
//*******************************************************************
procedure Add(gs IN,ec OUT)
{
  TGS gs;
  Get(gs.IPAddr,gs,ec);
  if (ec == EC_NONE)
  {
    Remove(gs.IPAddr);
  }
  insert gs into Tbl_GS;
}
//*******************************************************************
procedure Create(ipaddr IN,gs OUT,ec OUT)
{
  TGS gs = TGS(ipaddr);
  ec = EC_NONE;
}
//*******************************************************************
procedure CreateAdd(ipaddr IN,ec OUT)
{
  TGS gs;
  Create(ipaddr,gs,ec);
  Add(gs,ec);
}
//*******************************************************************
procedure Remove(ipaddr IN,ec OUT)
{
  PGWLink.RemoveGS(ipaddr,ec);

  remove from Tbl_GS
  where gs.IPAddr == ipaddr;
  ec = EC_NONE;
}
//*******************************************************************
procedure Remove(gs IN,ec OUT)
{
  Remove(gs.IPAddr,ec);
}
//*******************************************************************
procedure AddGWLink(gs_ipaddr IN,gw_ipaddr IN,ec OUT)
{
  PGWLink.CreateAdd(gs_ipaddr,gw_ipaddr,ec);
}
//*******************************************************************
procedure RemoveGWLink(gs_ipaddr IN,gw_ipaddr IN,ec OUT)
{
  PGWLink.Remove(gs_ipaddr,gw_ipaddr,ec);
}
//*******************************************************************
procedure User_Login(username IN PDef.TUserNameStr,
                     pw IN PDef.TPWStr,
                     gatewayid IN OUT PDef.TGatewayID,
                     mustchangepw OUT PDef.TBool,
                     gt OUT PDef.TGame,
                     mid OUT PDef.TMID,
                     uan OUT PDef.TUAN,
                     ec OUT PDef.TErrorCode)
{
  // verify gs security access.
  // verify gw security access.


  PUser.Login(username,pw,
              gatewayid,mustchangepw,
              gt,mid,uan,ec);


  Commit();
}
//*******************************************************************
procedure User_NewLogin(username IN PDef.TUserNameStr,
                        pw IN PDef.TPWStr,
                        gwid IN PDef.TGatewayID,
                        fname IN PDef.TNameStr,
                        lname IN PDef.TNameStr,
                        street IN PDef.TStreetStr,
                        city IN PDef.TCityStr,
                        state IN PDef.TStateStr,
                        country IN PDef.TCountryStr,
                        zip IN PDef.TZipStr,
                        email IN PDef.TNameStr,
                        dayphone IN PDef.TNameStr,
                        eveningphone IN PDef.TNameStr,
                        dob IN PDef.TDate,
                        sex_male IN PDef.TBool,
                        mothersmaiden IN PDef.TNameStr,
                        hometown IN PDef.TCityStr,
                        uan OUT PDef.TUAN,
                        gt OUT PDef.TGame,
                        mid OUT PDef.TMID,
                        modun1 OUT PDef.TUserNameStr,
                        modun2 OUT PDef.TUserNameStr,
                        modun3 OUT PDef.TUserNameStr,
                        modun4 OUT PDef.TUserNameStr,
                        ec OUT PDef.TErrorCode)

// note: rollback everything unless no errors.
{
  PUser.NewLogin(username,pw,gwid,fname,lname,street,city,state,country,zip,
                 email,dayphone,eveningphone,dob,sex_male,mothersmaiden,
                 hometown,uan,gt,mid,modun1,modun2,modun3,modun4,ec);

  if (ec != PDef.EC_NONE)
  {
    Rollback();
  }
  else
  {
    Commit();
  }
}
//*******************************************************************
procedure User_Logoff(uan IN PDef.TUAN,
                      endcassession IN PDef.TBool,
                      ec OUT PDef.TErrorCode)
{
  PUser.Logoff(uan,endcassession,ec);
  if (ec != PDef.EC_NONE)
  {
    Rollback();
  }
  else
  {
    Commit();
  }
}
//*******************************************************************
procedure User_SwitchGame(uan IN PDef.TUAN,
                          endgamesession IN PDef.TBool,
                          gt IN OUT PDef.TGame,
                          mid IN OUT PDef.TMID,
                          ec OUT PDef.TErrorCode)
{
  PUser.SwitchGame(uan,endgamesession,gt,mid,ec);
  if (ec != PDef.EC_NONE)
  {
    Rollback();
  }
  else
  {
    Commit();
  }
}
//*******************************************************************
procedure TX(uan,bid,txt,txd,amount,balance,chips,ec)
{
  PUser.Get(uan,user,ec);
  PWallet.Get(user.UAN,wallet,ec);
  PTX.TX(user,wallet,bid,txt,txd,amount,"",ec);
  balance = wallet.GetBalance();
  chips = wallet.Chips;
  PWallet.Set(wallet,ec);
  PUser.Set(user,ec);
}
//*******************************************************************
end PGS;