create or replace package PGS as
//*******************************************************************

//*********************** game server proc's ************************
procedure Login(ipaddr,ec);

procedure Logoff(ipaddr,ec);

procedure Add(gs IN,ec OUT);

procedure Create(ipaddr IN,gs OUT,ec OUT);

procedure CreateAdd(ipaddr IN,ec OUT);

procedure Remove(ipaddr IN,ec OUT);

procedure Remove(gs IN,ec OUT);

procedure Read(ipaddr IN,gs OUT,ec OUT);

procedure Get(ipaddr IN,gs OUT,ec OUT);

procedure Set(gs IN,ec OUT);

procedure AddGWLink(gs_ipaddr IN,gw_ipaddr IN,ec OUT);

procedure RemoveGWLink(gs_ipaddr IN,gw_ipaddr IN,ec OUT);
//********************** user control proc's ************************

procedure User_Login(username IN PDef.TUserNameStr,
                     pw IN PDef.TPWStr,
                     gatewayid IN PDef.TGatewayID,
                     mustchangepw OUT PDef.TBool,
                     gt OUT PDef.TGame,
                     mid OUT PDef.TMID,
                     uan OUT PDef.TUAN,
                     ec OUT PDef.TErrorCode);

procedure User_NewLogin(username IN PDef.TUserNameStr,
                        pw IN PDef.TPWStr,
                        gwid IN PDef.TGatewayID,
                        fname IN PDef.TNameStr,
                        lname IN PDef.TNameStr,
                        street IN PDef.TStreetStr,
                        city IN PDef.TCityStr,
                        state IN PDef.TStateStr,
                        country IN PDef.TCountryStr,
                        zip IN PDef.TZipStr,
                        email IN PDef.TNameStr,
                        dayphone IN PDef.TNameStr,
                        eveningphone IN PDef.TNameStr,
                        dob IN PDef.TDate,
                        sex_male IN PDef.TBool,
                        mothersmaiden IN PDef.TNameStr,
                        hometown IN PDef.TCityStr,
                        uan OUT PDef.TUAN,
                        gt OUT PDef.TGame,
                        mid OUT PDef.TMID,
                        modun1 OUT PDef.TUserNameStr,
                        modun2 OUT PDef.TUserNameStr,
                        modun3 OUT PDef.TUserNameStr,
                        modun4 OUT PDef.TUserNameStr,
                        ec OUT PDef.TErrorCode);

procedure User_Logoff(uan IN PDef.TUAN,
                      endcassession IN PDef.TBool,
                      ec OUT PDef.TErrorCode);

procedure User_SwitchGame(uan IN PDef.TUAN,
                          endgamesession IN PDef.TBool,
                          gt IN OUT PDef.TGame,
                          mid IN OUT PDef.TMID,
                          ec OUT PDef.TErrorCode);

procedure User_SetFreePlay(uan IN PDef.TUAN,
                           free IN OUT PDef.TBool,
                           ErrorCode OUT PDef.TErrorCode);

procedure User_SetPassword(uan IN PDef.TUAN,
                           currentpw IN PDef.TPWStr,
                           newpw IN PDef.TPWStr,
                           ec OUT PDef.TErrorCode);

procedure User_GetAvailGTDataArray(uan IN,gtd_array OUT,num_gtd OUT,ec OUT);

procedure User_GetAvailMIDDataArray(uan IN,gt IN,md_array OUT,num_md OUT,ec OUT);

procedure User_GetSysInfo(uan IN,phone OUT,email OUT,website OUT,ec OUT);

procedure User_GetSysMsgArray(uan IN,gt IN,
                              m1 OUT,m2 OUT,m3 OUT,m4 OUT,m5 OUT,
                              ec OUT);

procedure User_GetAccount(uan IN,bid IN,account OUT,ec OUT);

procedure User_AddAccount(uan IN,ac IN,asc IN,fi_accnum IN,nameonacc IN,
                          expdate IN,street IN,city IN,state IN,country IN,
                          zip IN,bankname IN,abanum IN,bid OUT,ec OUT);

procedure User_RemoveAccount(uan IN,bid IN,ec OUT);

procedure User_GetWallet(uan IN PDef.TUAN,balance OUT PDef.TCurrency,
                         chips OUT PDef.TCurrency,ec OUT PDef.TErrorCode);

procedure User_GetGameInfo(uan IN,gt OUT,mid OUT,ec OUT);

// ********************* user TX proc's *****************************

procedure TX(uan IN PDef.TUAN,bid IN PDef.TBID,txt IN PDef.TTXT,
             txd IN PDef.TTXD,amount IN PDef.TCurrency,
             balance OUT TCurrency,chips OUT TCurrency,
             ErrorCode OUT PDef.TErrorCode);

procedure TX_GetAvailArray(uan IN,atx_array OUT,num_atx,wallet OUT,ec OUT);

procedure TX_GetArray(uan IN,tx_array OUT,tx_num OUT,ec OUT);

procedure TX_GetAllowed(uan IN,fullacccodes_array OUT,num_fullacccodes OUT,ec OUT);

//********************* slots related proc's ************************

procedure Slots_Spin(uan IN PDef.TUAN,
                     coinsplayed OUT PDef.TSmCount,credits OUT PDef.TLgCount,
                     chips OUT PDef.TCurrency,winnerpaid OUT PDef.TLgCount,
                     payoffhilitenum OUT PDef.TSmNum,reelstop1 OUT PDef.TSmNum,
                     reelstop2 OUT PDef.TSmNum,reelstop3 OUT PDef.TSmNum,
                     ec OUT PDef.TErrorCode);

procedure Slots_BetOne(uan IN PDef.TUAN,
                       coinsplayed OUT TSmCount,credits OUT PDef.TLgCount,
                       chips OUT PDef.TCurrency,ec OUT PDef.TErrorCode);

procedure Slots_BetMax(uan IN PDef.TUAN,
                       coinsplayed OUT PDef.TSmCount,credits OUT PDef.TLgCount
                       chips OUT PDef.TCurrency,ec OUT PDef.TErrorCode);

procedure Slots_CashOut(uan IN PDef.TUAN,
                        coinsplayed OUT PDef.TSmCount,credits OUT PDef.TLgCount,
                        chips OUT PDef.TCurrency,ec OUT TErrorCode);

procedure Slots_Info(uan In PDef.TUAN,
                     gt OUT PDef.TGame,mid OUT PDef.TMID,
                     state OUT PDef.TSlotsState,chips OUT PDef.TCurrency,
                     credits OUT PDef.TLgCount,rs1 OUT,rs2 OUT,rs3 OUT,
                     winnerpaid OUT,ec OUT PDef.TErrorCode);
                     
//*******************************************************************
end PGS;
