create or replace package body PGWLink as
//*******************************************************************
function HasGW(ipaddr IN) return TBool
{
  select rec from Tbl_GWLink
  where rec.GW_IPAddr == ipaddr;

  if (found)
  {
    return true;
  }
  else
  {
    return false;
  }
}
//*******************************************************************
procedure RemoveGS(ipaddr IN,ec OUT)
{
  gwl_array;
  gwl_num;

  GetArrayGS(ipaddr,gwl_array,gwl_num,ec); //get all matching links
  for (int i=0;i<gwl_num,i++)
  {
    Remove(gwl_array[i],ec);              // remove from tbl
  }
  for (int i = 0;i<gwl_num,i++)           // see if users orphaned.
  {
    if (!HasGW(gwl_array[i].GW_IPAddr))
    {
      PUser.LostGW(gwl_array.GW_IPAddr);
    }
  }
}
//*******************************************************************
procedure RemoveGW(ipaddr IN,ec OUT)
{
  delete all from Tbl_GWLink
  where rec.GW_IPAddr == ipaddr;

  PUser.LostGW(ipaddr,ec);
}
//*******************************************************************
procedure Remove(gs_ipaddr IN,gw_ipaddr IN,ec OUT)
{
  delete from Tbl_GWLink
  where (rec.GS_IPAddr == gs_ipaddr &&
         rec.GW_IPAddr == gw_ipaddr);

  ec = EC_NONE;
}
//*******************************************************************
procedure Remove(gwlink IN,ec OUT)
{
  delete from Tbl_GWLink
  where (rec.GWLink_ID == gwlink.GWLinkID);

  ec = EC_NONE;
}
//*******************************************************************
procedure Add(gwlink IN,ec OUT)
{
  // first check if already there.
  TGWLink gw2;
  Read(gwlink.GS_IPAddr,gwlink.GW_IPAddr,gw2,ec);
  if (ec != EC_NONE)
  {
    insert gwlink into Tbl_GWLink;
    ec = EC_NONE;
  }
}
//*******************************************************************
procedure Create(gs_ipaddr IN,gw_ipaddr IN,gwlink OUT,ec OUT)
{
  TGWLink gwlink = TGWLink(GWLink_Seq.Next(),gs_ipaddr,gw_ipaddr);
  ec = EC_NONE;
}
//*******************************************************************
procedure CreateAdd(gs_ipaddr IN,gw_ipaddr IN,ec OUT)
{
  TGWLink gwlink;
  Create(gs_ipaddr,gw_ipaddr,gwlink,ec);
  Add(gwlink,ec);
}
//*******************************************************************
procedure Get(gs_ipaddr IN,gw_ipaddr IN,gwlink OUT,ec OUT)
{
  select from Tbl_GWLink
  into gwlink
  where (rec.GS_IPAddr == gs_ipaddr &&
         rec.GW_IPAddr == gw_ipaddr)
  for update;
  if (found)
  {
    ec = EC_NONE;
  }
  else
  {
    ec = EC_GWLINK_NOTFOUND;
  }
}
//*******************************************************************
procedure GetArrayGS(gs_ipaddr IN,gwl_array OUT,gwl_num OUT,ec OUT)
{
  // create an array of TGWLink's
  // where (rec.GS_IPAddr == gs_ipaddr)
}
//*******************************************************************
procedure GetArrayGW(gw_ipaddr IN,gwl_array OUT,gwl_num OUT,ec OUT)
{
  // create an array of TGWLink's
  // where (rec.GW_IPAddr == gw_ipaddr)
}
//*******************************************************************
end;