create or replace package body PWesternUnionDepTX as
//*******************************************************************
procedure Modify(ean IN,txid IN,mac IN,wudeptx OUT,ec OUT)
{
  Lock(txid,wudeptx,ec);
  if (ec == EC_NONE)
  {
    wudeptx.Modify(ean,mac,ec);
    UnLock(wudeptx,ec);
  }
}
//*******************************************************************
procedure Commit(ean IN,ec OUT)
{
  LockArray(ean,wudeptx_array,wudeptx_num,ec);
  for (int i=0;i<wudeptx_num;i++)
  {
    wudeptx_array[i].Commit();
  }
  UnLockArray(wudeptx_array,wudeptx_num,ec);
}
//*******************************************************************
procedure Cancel(ean IN,ec OUT)
{
  LockArray(ean,wudeptx_array,wudeptx_num,ec);
  for (int i=0;i<wudeptx_num;i++)
  {
    wudeptx_array[i].Cancel();
  }
  UnLockArray(wudeptx_array,wudeptx_num,ec);
}
//*******************************************************************
procedure Lock(txid IN,wudeptx OUT,ec OUT)
{
  ec = EC_NONE;

  select from Tbl_WesternUnionDepTX
  where rec.TXID == txid
  for update

  // wudeptx = rec;

  if (!found)
  {
    ec = EC_TX_NOTFOUND;
  }
}
//*******************************************************************
procedure UnLock(wudeptx IN,ec OUT)
{
  ec = EC_NONE;

  update Tbl_WesternUnionDepTX
  where rec.TXID == wudeptx.TXID

  // rec = wudeptx;
}
//*******************************************************************
procedure LockArray(ean IN,wudeptx_array OUT,wudeptx_num OUT,ec OUT)
{
  // lock all from Tbl_WesternUnionDepTX
  // where rec.Current_EAN == ean
  // and put into array
  // incrementing num
}
//*******************************************************************
procedure UnLockArray(wudeptx_array IN,wudeptx_num IN,ec OUT)
{
  // update Tbl_WesternUnionDepTX
  // using array.
}
//*******************************************************************
procedure Create(ean IN,uan IN,bid IN,amount IN,noservfee IN,
                 complete IN,mtc IN,wudeptx OUT,ec OUT)
{
  ec = EC_NONE;

  if (noservfee)
  {
    servicefee = 0;
  }
  else
  {
    PCasCfg.WU_GetDepServiceFee(servicefee,ec);
  }

  if (complete)
  {
    PWallet.Lock(uan,wallet,ec);
    wallet.IncBalance(amount - servicefee);
    PWallet.UnLock(wallet,ec):

    fr_ean = ean;
    fr_sc = SC_ACCEPTED;
    fr_date = SYSDATE;
  }
  else
  {
    fr_ean = 0;
    fr_sc = SC_NONE;
    fr_date = 0;
  }

  wudeptx TWesternUnionDepTX = TWesternUnionDepTX(TXID_Seq.Next(),
                                                  uan,
                                                  bid,
                                                  !complete,
                                                  0,
                                                  ean,
                                                  SYSDATE,
                                                  amount,
                                                  mtc,
                                                  servicefee,
                                                  fr_ean,
                                                  fr_sc,
                                                  fr_date,
                                                  true,
                                                  0,
                                                  SC_NONE,
                                                  0,
                                                  true);
  wudeptx.VerifyENB();
}
//*******************************************************************
procedure Add(wudeptx IN,ec OUT)
{
  ec = EC_NONE;

  insert wudeptx
  into Tbl_WesternUnionDepTX
}
//*******************************************************************
procedure CreateAdd(ean IN,uan IN,bid IN,amount IN,noservfee IN,
                    complete IN,mtc IN,txid OUT,ec OUT)
{
  Create(ean,uan,bid,amount,noservfee,complete,mtc,wudeptx,ec);
  if (ec == EC_NONE)
  {
    txid = wudeptx.TXID;
    Add(wudeptx,ec);
  }
}
//*******************************************************************
procedure GetArray(filter IN,wudeptx_array OUT,wudeptx_num OUT,ec OUT)
{
  // get all from Tbl_WesternUnionDepTX
  // where rec == filter options
  // and put into array
  // do not lock elements.
}
//*******************************************************************
end;