create or replace package body PWireTransferDepTX as
//*******************************************************************
procedure Modify(ean IN,txid IN,mac IN,wtdeptx OUT,ec OUT)
{
  Lock(txid,wtdeptx,ec)
  if (ec == EC_NONE)
  {
    wtdeptx.Modify(ean,mac,ec);
    UnLock(wtdeptx,ec);
  }
}
//*******************************************************************
procedure Commit(ean IN,ec OUT)
{
  LockArray(ean,wtdeptx_array,wtdeptx_num,ec);
  for (int i=0;i<wtdeptx_num;i++)
  {
    wtdeptx_array[i].Commit();
  }
  UnLockArray(wtdeptx_array,wtdeptx_num,ec);
}
//*******************************************************************
procedure Cancel(ean IN,ec OUT)
{
  LockArray(ean,wtdeptx_array,wtdeptx_num,ec);
  for (int i=0;i<wtdeptx_num;i++)
  {
    wtdeptx_array[i].Cancel();
  }
  UnLockArray(wtdeptx_array,wtdeptx_num,ec);
}
//*******************************************************************
procedure Lock(txid IN,wtdeptx OUT,ec OUT)
{
  ec = EC_NONE;

  select from Tbl_WireTransferDepTX
  where rec.TXID == txid
  for update

  //wtdeptx = rec;

  if (!found)
  {
    ec = EC_TX_NOTFOUND;
  }
}
//*******************************************************************
procedure UnLock(wtdeptx IN,ec OUT)
{
  ec = EC_NONE;

  update Tbl_WireTransferDepTX
  where rec.TXID == wtdeptx.TXID

  //rec = wtdeptx;
}
//*******************************************************************
procedure LockArray(ean IN,wtdeptx_array OUT,wtdeptx_num OUT,ec OUT)
{
  // lock all from Tbl_WireTransferDepTX
  // where rec.Current_EAN == ean
  // and put into array
  // incrementing num.
}
//*******************************************************************
procedure UnLockArray(wtdeptx_array IN,wtdeptx_num IN,ec OUT)
{
  // update Tbl_WireTransferDepTX
  // using array.
}
//*******************************************************************
procedure Create(ean IN,uan IN,bid IN,amount IN,noservfee IN,
                 complete IN,fi_approvalcode IN,wtdeptx OUT,ec OUT)
{
  ec = EC_NONE;

  if (noservfee)
  {
    servicefee = 0;
  }
  else
  {
    PCasCfg.WT_GetDepServiceFee(servicefee,ec);
  }

  if (complete)
  {
    PWallet.Lock(uan,wallet,ec);
    wallet.IncBalance(amount - servicefee);
    PWallet.UnLock(wallet,ec);
    fr_ean = ean;
    fr_sc = SC_ACCEPTED;
    fr_date = SYSDATE;
  }
  else
  {
    fr_ean = 0;
    fr_sc = SC_NONE;
    fr_date = 0;
  }
  wtdeptx TWireTransferDepTX = TWireTransferDepTX(TXID_Seq.Next(),
                                                  uan,
                                                  bid,
                                                  !complete,
                                                  0,
                                                  amount,
                                                  servicefee,
                                                  fi_approvalcode,
                                                  ean,
                                                  SYSDATE,
                                                  fr_ean,
                                                  fr_sc,
                                                  fr_date,
                                                  true,
                                                  0,
                                                  SC_NONE,
                                                  0,
                                                  true);
  wtdeptx.VerifyENB();
}
//*******************************************************************
procedure Add(wtdeptx IN,ec OUT)
{
  ec = EC_NONE;

  insert wtdeptx
  into Tbl_WireTransferDepTX
}
//*******************************************************************
procedure CreateAdd(ean IN,uan IN,bid IN,amount IN,noservfee IN,
                    complete IN,fi_approvalcode IN,txid OUT,ec OUT)
{
  Create(ean,uan,bid,amount,noservfee,wtdeptx,ec);
  if (ec == EC_NONE)
  {
    txid = wtdeptx.TXID;
    Add(wtdeptx,ec);
  }
}
//*******************************************************************
procedure GetArray(filter IN,wtdeptx_array OUT,wtdeptx_num OUT,ec OUT)
{
  // get all from Tbl_WireTransferDepTX
  // where rec == filter options
  // and put into array.
  // do not lock elements.
}
//*******************************************************************
end;