create or replace package body TWireTransferWDTX as
//*******************************************************************
procedure Modify(ean IN,txid IN,mac IN,wtwdtx OUT,ec OUT)
{
  Lock(txid,wtwdtx,ec);
  if (ec == EC_NONE)
  {
    wtwdtx.Modify(ean,mac,ec);
    UnLock(wtwdtx,ec);
  }
}
//*******************************************************************
procedure Commit(ean IN,ec OUT)
{
  LockArray(ean,wtwdtx_array,wtwdtx_num,ec);
  for (int i=0;i<wtwdtx_num;i++)
  {
    wtwdtx_array[i].Commit();
  }
  UnLockArray(wtwdtx_array,wtwdtx_num,ec);
}
//*******************************************************************
procedure Cancel(ean IN,ec OUT)
{
  LockArray(ean,wtwdtx_array,wtwdtx_num,ec);
  for (int i=0;i<wtwdtx_num;i++)
  {
    wtwdtx_array[i].Cancel();
  }
  UnLockArray(wtwdtx_array,wtwdtx_num,ec);
}
//*******************************************************************
procedure Lock(txid IN,wtwdtx OUT,ec OUT)
{
  ec = EC_NONE;

  select from Tbl_WireTransferWDTX
  where rec.TXID == txid
  for update

  // wtwdtx = rec;

  if (!found)
  {
    ec = EC_TX_NOTFOUND;
  }
}
//*******************************************************************
procedure UnLock(wtwdtx IN,ec OUT)
{
  ec = EC_NONE;

  update Tbl_WireTransferWDTX
  where rec.TXID == wtwdtx.TXID

  // rec = wtwdtx
}
//*******************************************************************
procedure LockArray(ean IN,wtwdtx_array OUT,wtwdtx_num OUT,ec OUT)
{
  // lock all from Tbl_WireTransferWDTX
  // where rec.Current_EAN == ean
  // and put into array
  // incrementing num
}
//*******************************************************************
procedure UnLockArray(wtwdtx_array IN,wtwdtx_num IN,ec OUT)
{
  // update Tbl_WireTransferWDTX
  // using array.
}
//*******************************************************************
procedure Create(ean IN,uan IN,bid IN,amount IN,noservfee IN,wtwdtx OUT,ec OUT)
{
  ec = EC_NONE;

  if (noservfee)
  {
    serviceFee = 0;
  }
  else
  {
    PCasCfg.WT_GetWDServiceFeeAmount(serviceFee,ec);
  }
  PWallet.Lock(uan,wallet,ec);
  if (ec == EC_NONE)
  {
    if (wallet.Balance < (amount + serviceFee))
    {
      ec = EC_WALLET_BALANCE_NSF;
    }
    else
    {
      wallet.DecBalance(amount + serviceFee);
      PWallet.UnLock(wallet,ec);
      wuwdtx TWesternUnionWDTX = TWesternUnionWDTX(TXID_Seq.Next(),
                                                   uan,
                                                   bid,
                                                   true,
                                                   0,
                                                   amount,
                                                   servicefee,
                                                   ean,
                                                   SYSDATE,
                                                   0,
                                                   SC_NONE,
                                                   0,
                                                   true,
                                                   0,
                                                   SC_NONE,
                                                   0,
                                                   true,
                                                   0,
                                                   SC_NONE,
                                                   0,
                                                   true,
                                                   0,
                                                   SC_NONE,
                                                   0,
                                                   true,
                                                   0);

      wuwdtx.VerifyENB();
    }
  }
}
//*******************************************************************
procedure Add(wtwdtx IN,ec OUT)
{
  ec = EC_NONE;

  insert wtwdtx
  into Tbl_WireTransferWDTX
}
//*******************************************************************
procedure CreateAdd(ean IN,uan IN,bid IN,amount IN,noservfee IN,txid OUT,ec OUT)
{
  Create(ean,uan,bid,amount,noservfee,wtwdtx,ec);
  if (ec == EC_NONE)
  {
    txid = wtwdtx.TXID;
    Add(wtwdtx,ec);
  }
}
//*******************************************************************
procedure GetArray(filter IN,wtwdtx_array,wtwdtx_num,ec OUT)
{
  // get all from Tbl_WesternUnionWDTX
  // where rec == filter options
  // and put into array
  // do not lock elements.
}
//*******************************************************************