create or replace package body PSlot_Payoff as
//*******************************************************************
procedure Get(payofftypeid IN TPayoffTypeID,
              coinsplayed IN TSmNum,
              symbol1 IN TSlotsSymbol,
              symbol2 IN TSlotsSymbol,
              symbol3 IN TSlotsSymbol,
              payoff IN OUT TPayoff,
              ec OUT TErrorCode)
{
  // don't lock
  ec = PDef.EC_NONE;

  select payoff
  from Tbl_Slot_Payoffs
  where (rec.PayoffTypeID == payofftypeid &&
         rec.coinsplayed == coinsplayed &&
         rec.Symbol1 == symbol1 &&
         rec.Symbol2 == symbol2 &&
         rec.Symbol3 == symbol3)

  if (not found)
  {
    ec = PDef.EC_SLOT_PAYOFF_NOTFOUND;
  }
}
//*******************************************************************
end PSlot_Payoff;