//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  deck.h
//    Project Name:  Ogle
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     06/01/95   A. Krist    Original baseline
//  2.0     08/26/97   M.Perry     32-bit conversion.
//*******************************************************************
#if !defined _deck_h
#define _deck_h

#include <iostream.h>
#include "card.h"
#include "hand.h"

class TDiscards;
//*******************************************************************
class TDeck
{
public:
  TDiscards  *pDiscards;
  TCard  *deck;
  int16     top;
  TDeck();
  virtual ~TDeck();
  virtual int16 Shuffle()=0;
  virtual int16 FirstDeal(){return 1;};
  virtual int16 ShowHand(THand *phand)=0;
  virtual int16 InitDeck(int16 numofcards=52){return 1;};
  virtual int16 InitTemp()=0;
  virtual int16 ShowWinner(THand *phand)=0;
  virtual int16 ShowDeck()=0;
  virtual int16 Draw(THand *phand) {return 1;};
  virtual int16 Discard(int16 i)=0;
  virtual int16 ShuffleTemp()=0;
  virtual int16 AddLeftover(THand *hnd)=0;
  virtual int16 DealTemp(int16 i)=0;
};
//*******************************************************************
#endif

