//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  mstate.h
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     5/23/95    M.Perry    original baseline
//  2.0    08/27/97    M.Perry    32-bit conversion.
//********************************************************************
#if !defined(__mstate_h)
#define __mstate_h

#if !defined(__ostate_h)
#include "ostate.h"
#endif

#if !defined(__ogeo_h)
#include "ogeo.h"
#endif

class OGLEOWLCLASS TOgleModeWindow;
class TOgleScreenMgr;
//*******************************************************************
class TModeState:public TState
{
public:
  #if defined(ENB_FUC_STEPS)
  bool FUC_Stepping;
  bool Got_FUC_Key;
  bool Is_FUC_Stepping();
  #endif

  TOgleModeWindow *POwnerWindow;
  TModeState(TOgleModeWindow *PNewModeWindow);
  virtual ~TModeState();
  TOgleScreenMgr *GetScreenMgr();
  void LButtonDown(uint modKeys, TPoint &point);
  void LButtonUp(uint modKeys,TPoint &point);
  void LButtonDblClk(uint modKeys, TPoint &point);
  void RButtonDown(uint modKeys, TPoint &point);
  void RButtonUp(uint modKeys,TPoint &point);
  void RButtonDblClk(uint modKeys,TPoint &point);
  void MouseMove(uint modKeys,TPoint &point);
  void Char(uint key,uint repeatCount,uint flags);
  void Timer();

  // the handle functions must return false if you want screenmgr to process.
  // return true if you want to stop the chain of calls here.
  virtual bool HandleLDown(uint modKeys,TPoint &point) {return false;}
  virtual bool HandleLUp(uint modKeys,TPoint &point) {return false;}
  virtual bool HandleLDblClk(uint modKeys,TPoint &point) {return false;}
  virtual bool HandleRDown(uint modKeys,TPoint &point) {return false;}
  virtual bool HandleRUp(uint modKeys,TPoint &point) {return false;}
  virtual bool HandleRDblClk(uint modKeys,TPoint &point) {return false;}
  virtual bool HandleMouseMove(uint modKeys,TPoint &point) {return false;}
  virtual bool HandleChar(uint key,uint repeatCount,uint flags);
  virtual bool HandleTimer();

  //virtual void Update(dword ModeFrameUpdateCount);
  virtual void ExecuteFirstTime() {ExecuteWaiting = true;}
};
//********************************************************************
#endif

