//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  oanmlst.h
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     6/20/95   M.Perry    original baseline
//  2.0     8/22/97   M.Perry    32-bit conversion.
//********************************************************************
#if !defined(__oanmlst_h) 
#define __oanmlst_h

#if !defined(__olist_h)
#include "olist.h"
#endif

#if defined(DEBUGREPORTS) || defined(DEBUGSPRITES)
  #include <iostream.h>
  #include <fstream.h>
#endif

class TSprite;
class TAnm;
//*******************************************************************
class TAnmList:public TOgleList
{
public:
  TSprite *PSprite;
  void SpriteNotifyStop();
  #ifdef DEBUGREPORTS
  void Report(ofstream &os);
  #endif
  #ifdef DEBUGSPRITES
  void RTReport(ofstream &os);
  #endif
  TAnmList(TOgleModeWindow *pmw,TSprite *psprite);
  virtual ~TAnmList();
  void SetAllCADRelative(TTriplet &trip);
  bool AddAnm(TAnm *PNewAnm);
  bool AddAnm(TFileMode NewFileMode,int16 NewScreenZ = 1);
  bool AddAnm(TFileMode NewFileMode,int16 NewScreenX,int16 NewScreenY, int16 NewScreenZ);

  virtual void Start(dword StartFUC);
  virtual void Start();
//  dword GetLastFUC();
  TAnm *GetAnmPtr(int16 AnmIndex);
  int16 GetAnmIndex(string &AnmFName);
  TAnm *GetAnmPtr(string &AnmFName);
  void NotifyStart(TAnm *panm);
  void NotifyStop(TAnm *panm);
  word GetNotifyRef() {return NotifyRef;}
protected:
  word NotifyRef;
};
//*******************************************************************
//***********************  inlines **********************************
//*******************************************************************
inline TAnm *TAnmList::GetAnmPtr(int16 AnmIndex)
{
  return ((TAnm *)GetElementPtr(AnmIndex));
}
//*******************************************************************
inline int16 TAnmList::GetAnmIndex(string &AnmFName)
{
  return GetElementIndex(AnmFName);
}
//*******************************************************************
inline TAnm *TAnmList::GetAnmPtr(string &AnmFName)
{
  return ((TAnm *)GetElementPtr(AnmFName));
}
//*******************************************************************
inline void TAnmList::NotifyStart(TAnm *panm)
{
  NotifyRef++;
}
//*******************************************************************
inline void TAnmList::NotifyStop(TAnm *panm)
{
  if (NotifyRef > 0)
  {
    NotifyRef--;
  }
  if (NotifyRef == 0)
  {
    SetStopped();
    SpriteNotifyStop();
  }
}
//*******************************************************************
#endif

