//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name: oapp.h
//    Project Name: Ogle
// Original Author: Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     02/27/95   M.Perry     original baseline
//  2.0     08/25/97   M.Perry     32-bit conversion.
//  2.3     08/02/99   M.Perry     gobjlist removal,include sentries,etc.
//********************************************************************
#if !defined(__oapp_h)
#define __oapp_h

#if !defined(__ogle_h)
#include "ogle.h"
#endif

#if !defined(OWL_APPLICAT_H)
#include <owl\applicat.h>
#endif


#if !defined(__oapp_rh)
#include "oapp.rh"
#endif

#if !defined(__oflags_h)
#include "oflags.h"
#endif

#if !defined(__ogeo_h)
#include "ogeo.h"
#endif

class OGLEOWLCLASS TOgleGameFrameWindow;
class TOgleFileMgr;
class TOgleGame;
class TPal;
class TOgleSoundMgr;
class TCursorMgr;
class TOgleIniFile;
//*******************************************************************
#define oaiFIRST ((WORD)1)
#define oaiVT_NONE (oaiFIRST)
#define oaiVT_GDI ((WORD)(oaiVT_NONE * 2))
#define oaiVT_WING ((WORD)(oaiVT_GDI * 2))
#define oaiAT_NONE ((WORD)(oaiVT_WING * 2))
#define oaiAT_MM ((WORD)(oaiVT_NONE * 2))
#define oaiAT_WAVEMIX ((WORD)(oaiAT_MM * 2))
#define oaiMT_NONE ((WORD)(oaiAT_WAVEMIX * 2))
#define oaiMT_MCI ((WORD)(oaiMT_NONE * 2))
#define oaiLAST (oaiMT_MCI)
//*******************************************************************
class TOgleAppInfo
{
public:
  TOgleAppInfo() {}
  ~TOgleAppInfo() {}
  TSize MinDisplaySize;
  int32 MinNumColors;
  string MainTitle;
  int16 MinBitsPerPixel;
  int16 MajVer;
  int16 MinVer;
  TOgleWORDFlag TechFlags;    // not currently used by anything, yet.
};
//*******************************************************************
class OGLEOWLCLASS TOgleApp : public TApplication
{
private:
  #if !defined(OGLE_DLL)
  static TOgleApp *PAppHolder;
  #endif

protected:
  TOgleIniFile *PIniFile;
  TCursorMgr *PCursorMgr;
//  TOgleSoundMgr *PSoundMgr;
  string HDDrive;
  string HDDir;
  string AppName;
  TOgleFileMgr *PFileMgr;

public:
  TOgleGame *PGame;
  string GameFileName;
  string MasterPaletteFileName;
  TPal *PMasterPalette;
  bool Initialized;

protected:
  bool MaxFX;

public:
  TPal *GetPal() {return PMasterPalette;}
  virtual void GetAppInfo(TOgleAppInfo &appinfo);
  virtual int16 GetAppType();
  virtual int16 GetAppSubType();
  string GetAppName() {return AppName;}
  bool Help(uint command,uint32 data = 0);
  string GetHelpPath();
  string GetHelpPathName();
  virtual string GetHelpName();
  TOgleSoundMgr *GetSoundMgr();
//  void SetSoundMgr(TOgleSoundMgr *psoundmgr);
  TOgleFileMgr *GetFileMgr();
  TCursorMgr *GetCursorMgr();
  static TOgleApp *GetOgleApp(bool fatal = true);
  TOgleIniFile *GetIniFile();
  TOgleGameFrameWindow *GetFW();
  TOgleGame *GetPGame();
  TOgleGame *GetGame();
  void ChangePalette(string NewPaletteName);
  virtual void CreateIniFile();
  virtual void DestroyIniFile();
  virtual void CreateGameFile();
  virtual void DestroyGameFile();
  virtual void CreateFileMgr();
  virtual void DestroyFileMgr();
  virtual void CreatePalette();
  virtual void DestroyPalette();
  virtual TOgleGameFrameWindow *CreateGameFrameWindow();
  void DoShow();
  TOgleApp(string NewHDDrive,string NewHDDir,string NewAppName);
  virtual ~TOgleApp();
  bool IsInitialized();
  virtual bool Initialize();
  virtual bool DeInitialize();
  virtual void InitMainWindow();
  virtual bool CanClose ();

protected:
  virtual string GetDetName();
  void RegisterDet();
  void MaxPrevApp(HWND hwnd);
  bool CheckPrevInst();
  bool CheckDisplayRes();
  bool CreateCursorMgr();
  bool DestroyCursorMgr();
};
//*******************************************************************
class TAppString:public string
{
public:
  static const string strEmpty;
public:
  TAppString(int16 id) :string(*TOgleApp::GetOgleApp(),id) {}
  ~TAppString() {}
};
//*******************************************************************
//***************** TOgleApp inlines ********************************
//*******************************************************************
#if !defined(OGLE_DLL)
inline TOgleApp* TOgleApp::GetOgleApp(bool fatal)
{
  return PAppHolder;
}
#endif
//*******************************************************************
//inline TOgleSoundMgr *TOgleApp::GetSoundMgr()
//{
//  return PSoundMgr;
//}
//*******************************************************************
//inline void TOgleApp::SetSoundMgr(TOgleSoundMgr *psoundmgr)
//{
//  PSoundMgr = psoundmgr;
//}
//*******************************************************************
inline TOgleFileMgr *TOgleApp::GetFileMgr()
{
  return PFileMgr;
}
//*******************************************************************
inline TCursorMgr *TOgleApp::GetCursorMgr()
{
  return PCursorMgr;
}
//*******************************************************************
inline TOgleIniFile *TOgleApp::GetIniFile()
{
  return PIniFile;
}
//*******************************************************************
inline TOgleGameFrameWindow *TOgleApp::GetFW()
{
  return (TOgleGameFrameWindow *)GetMainWindow();
}
//*******************************************************************
inline TOgleGame *TOgleApp::GetPGame()
{
  return PGame;
}
//*******************************************************************
inline TOgleGame *TOgleApp::GetGame()
{
  return PGame;
}
//*******************************************************************
inline bool TOgleApp::IsInitialized()
{
  return Initialized;
}
//*******************************************************************
#endif

