//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//                             
//       File Name: obase.h
//    Project Name: Ogle
// Original Author: Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0      3/6/95    M.Perry     original baseline
//  2.0      8/20/97   M.Perry     32-bit type conversion.
//********************************************************************
#if !defined(__obase_h) 
#define __obase_h

#if !defined(__ogle_h)
#include "ogle.h"
#endif

#if !defined(__oapp_h)
#include "oapp.h"
#endif

#if !defined(__oflags_h)
#include "oflags.h"
#endif

#if !defined(__ofmode_h)
#include "ofmode.h"
#endif

#if !defined(__obasef_h)
#include "obasef.h"
#endif

#define FNAME_SIZE 9
#define FNAME_BYTES ((FNAME_SIZE) * sizeof(char))
//#define FILENAMESIZE FNAME_SIZE
//#define FILENAMEBYTES ((FILENAMESIZE) * sizeof(char))

#define IDNAMESIZE 4
#define IDNAMEBYTES ((IDNAMESIZE) * sizeof(char))

// the following is kludgy because I didn't use a struct for header, why? I don't remember.
#define FILEHEADERSIZE (IDNAMEBYTES + sizeof(WORD) + sizeof(WORD) + sizeof(DWORD))

#define TYPENAMESIZE (FNAME_SIZE)
#define TYPENAMEBYTES ((TYPENAMESIZE) * sizeof(char))

#define STARTLOAD_DELTA 60

// start flag defines
#define obFIRST ((WORD)1)
#define obSTARTED (obFIRST)
#define obSTOPPED ((WORD)(obSTARTED * 2))
#define obSHOWING ((WORD)(obSTOPPED * 2))
#define obUSEFILEOFFSET ((WORD)(obSHOWING * 2))
#define obFILENOTFOUND ((WORD)(obUSEFILEOFFSET * 2))
#define obBEENREAD ((WORD)(obFILENOTFOUND * 2))
#define obSLENDERIZED ((WORD)(obBEENREAD * 2))
#define obUSEDIRINDEX ((WORD)(obSLENDERIZED * 2))
#define obLAST obUSEDIRINDEX
// end flag defines

class OGLEOWLCLASS TOgleModeWindow;
class OGLEOWLCLASS TOgleGameFrameWindow;
class TResponder;
class TFileWriteBuf;
//*******************************************************************
class TOgleBase
{
//private:
//  string FName;                
protected: //data
//  TOgleApp *POgleApp;
//  TOgleFileMgr *PFileMgr;
  TOgleWORDFlag StatFlags;
  int16 ActiveCount;
  dword FUC_Length;
  dword BeginFUC;
  int16 FUC_Offset;
  int16 WhatType;
  int32 FileOffset;
  TFileWriteBuf *PWriteBuf;
  void huge *PExternal;
  TOgleBaseFile *PBaseFile;
  word MajVer;
  word MinVer;
  char IDChars[IDNAMESIZE];
  #ifdef DEBUG_BASECOUNT
  static int32 basecount;
  #endif

public: // data
  TOgleModeWindow *PModeWin;
  TOgleModeWindow *GetModeWin() {return PModeWin;}
  int32 ReadSize;
//  static string strGEmpty;
  TFileMode FileMode;

//protected: //functions
//  TOgleFileMgr *FindFileMgr();
//  TOgleApp *FindOgleApp(bool fatal = false);

public: //functions
  void SetUseDirIndex();
  void ClearUseDirIndex();
  bool GetUseDirIndex() const;

  bool GetHDBuffering() const;
  virtual void TimeChanged();
  virtual void Slenderize();
  void SetSlenderized();
  void ClearSlenderized();
  bool IsSlenderized() const;

  TOgleApp *GetOgleApp() const;
  TOgleFileMgr *GetFileMgr() const;
  TOgleGameFrameWindow *GetFW() const;

  string GetResString(uint id);

  enum
  {
    weNone = 0,
    weInvalidHFILE = 1,
    weOpen = 2,
    weHeader = 3,
    weLocal = 4,
    weClose = 5,
    weWriteData = 6
  };
  bool WriteError(char *descr,int errnum = weNone);

  virtual bool Respond(TResponder &responder);
  virtual bool Respond(int16 id,int16 info = 0,void *pdata = NULL);

  int16 GetActiveCount() const;

  dword GetFUC() const;  // global fuc
  dword GetAdjFUC() const; // next global fuc to show
  dword AskCurrentFUC() const; // same as GetFUC()

  dword Get_FUC_Length() const;
  void Set_FUC_Length(dword New_FUC_Length);
  void SetFUCOffset(int16 Offset);
  int16 GetFUCOffset() const;
//  string GetBaseName();
//  string GetFName() const {return FName;}
//  void SetFName(string &fname) {FName = fname;}
//  void SetFName(const string &fname) {FName = fname;}
//  virtual bool SetBaseName(string NewBaseName);
  string GetHDName() const;
  virtual void Update(dword NewFUC);
  virtual void PostUpdate(dword NewFUC);
  virtual void Start(dword StartFUC);
  virtual void Start();
  virtual void Stop();
  void SetStarted();
  void ClearStarted();
  void SetStopped();
  void ClearStopped();
  bool GetStarted() const;
  bool GetStopped() const;
  virtual int16 SetType(int16 NewType);
  virtual int16 GetType() const;
  virtual void Show();
  virtual void NoShow();
  virtual bool IsShowing() const;
  void SetShowing();
  void ClearShowing();
  bool GetShowing() const;
  virtual void Activate(dword StartFUC = 0);
  virtual void DeActivate();
  bool IsActive() const;
  virtual void SetIndexes();

  void SetBeenRead();
  bool GetBeenRead() const;

  void SetUseFileOffset();
  void ClearUseFileOffset();
  bool IsUseFileOffset() const;

  void *GetPtr();

  virtual bool ReadLocal();
  int32 Read(bool UseFOff = true,void *PSource = NULL);
  virtual bool WriteOpenCDRomFile();
  bool WriteCloseCDRomFile();
  virtual bool WriteLocal();
  bool Write(TFileWriteBuf *pwritebuf = NULL);
  virtual bool ReadLocalHeader();
  virtual bool WriteLocalHeader();
  virtual int32 GetSizeofData();
  virtual bool Save();

  int32 ReadData(void *PDest,int32 NumBytes);
  bool WriteData(const void *PSource,int32 NumBytes);

  bool Readbyte(byte *PDest);
  bool Writebyte(byte *PSource);

  bool Readword(word *PDest);
  bool Writeword(word *PSource);

  bool Readbool(bool *PDest);
  bool Writebool(bool *PSource);

  bool Readint16(int16 *PDest);
  bool Writeint16(int16 *PSource);

  bool Readuint16(uint16 *PDest);
  bool Writeuint16(uint16 *PSource);

  bool Readdword(dword *PDest);
  bool Writedword(dword *PSource);

  bool Readint32(int32 *PDest);
  bool Writeint32(int32 *PSource);

  bool Readchar(char *PDest);
  bool Writechar(char *PSource);

//  bool ReadFileNameChars(char *PDest);
//  bool WriteFileNameChars(char *PSource);

protected:
  bool ReadFNameChars(char *pdest);
  bool WriteFNameChars(char *psource);

public:
  bool ReadIDChars(char *PDest);
  bool WriteIDChars(char *PSource);

//  bool ReadFileNameString(string &Str);
//  bool WriteFileNameString(string &Str);

  bool ReadFNameString(string &str);
  bool WriteFNameString(string &str);

  bool ReadTypeNameChars(char *PDest);
  bool WriteTypeNameChars(char *PSource);

  bool ReadTypeNameString(string &Str);
  bool WriteTypeNameString(string &Str);

  bool Readstring(string &str);
  bool Writestring(const string &str);

  bool ReadFileName(string &str);
  bool WriteFileName(const string &str);

  void SetFileNotFound();
  void ClearFileNotFound();
  bool IsFileNotFound() const;

  TOgleBase(TOgleModeWindow *pmw);
  TOgleBase(TOgleModeWindow *pmw,bool dummy,const TFileMode &fm);
  TOgleBase(TOgleModeWindow *pmw,const TFileMode &NewFileMode,bool AutoRead = true,bool KeepBaseFile = false);
  TOgleBase(TOgleModeWindow *pmw,void *PReadData,bool AutoRead = true);
  virtual ~TOgleBase();
  void Init(const TFileMode &FM,bool AutoRead,bool KeepBaseFile);
  void Init(void *PReadData,bool AutoRead);
  virtual string AddExt();
  virtual bool CreateNewFileObject();

  void FMRegister();
  void FMUnRegister();

  bool Load(TFMStatus ramstatus,TFMStatus hdstatus);
  bool LoadRam(TFMStatus ramstatus);
  bool LoadHD(TFMStatus hdstatus);

  bool LoadImmed();
  bool LoadRamImmed();
  bool LoadHDImmed();
  bool LoadBGHi();
  bool LoadRamBGHi();
  bool LoadHDBGHi();
  bool LoadBGMed();
  bool LoadRamBGMed();
  bool LoadHDBGMed();
  bool LoadBGLo();
  bool LoadRamBGLo();
  bool LoadHDBGLo();
  bool LoadNone();
  bool LoadRamNone();
  bool LoadHDNone();
  virtual bool RequestChangeMode(TFileMode &NewFileMode);

  bool GetHDLoaded() const;
  bool GetRamLoaded() const;

  // Need a TOgleBaseFile copy method if you need to own a POgleBaseFile
  // that the FileMgr owns, because of the mode counters and flags and
  // because other TOgleBase objects might have a pointer to TOgleBaseFile.
  //protected:
  TOgleBaseFile *GetFilePtr() const;
  void huge *GetRamPtr() const;
  dword GetSizeRamPtr() const;
  dword GetFileSize();

protected:
  void FatalError(const string &msg,const string &title);

  void IncActiveCount();
  void DecActiveCount();
  virtual void ACLoad();
  bool DoLoadAhead(dword StartFUC);
  bool LoadAhead(dword StartFUC);
  virtual void SetMajVer();
  virtual void SetMinVer();
  void SetIDChars() {CopyIDChars(GetIDChars());}
  void CopyIDChars(const char *pchars);
  virtual const char *GetIDChars() const;
  bool IDOk();
  bool HeaderError();
  void VerError(word majver,word minver,word badmajver,word badminver);
};
//*******************************************************************
//***********************  inlines  *********************************
//*******************************************************************
inline void TOgleBase::SetUseDirIndex()
{
  StatFlags.Set(obUSEDIRINDEX);
}
//*******************************************************************
inline void TOgleBase::ClearUseDirIndex()
{
  StatFlags.Clear(obUSEDIRINDEX);
}
//*******************************************************************
inline bool TOgleBase::GetUseDirIndex() const
{
  return StatFlags.IsSet(obUSEDIRINDEX);
}
//*******************************************************************
inline bool TOgleBase::GetHDBuffering() const
{
  if (PBaseFile != NULL) {return PBaseFile->GetHDBuffering();}
  return false;
}
//*******************************************************************
inline void TOgleBase::SetSlenderized()
{
  StatFlags.Set(obSLENDERIZED);
}
//*******************************************************************
inline void TOgleBase::ClearSlenderized()
{
  StatFlags.Clear(obSLENDERIZED);
}
//*******************************************************************
inline bool TOgleBase::IsSlenderized() const
{
  return StatFlags.IsSet(obSLENDERIZED);
}
//*******************************************************************
inline TOgleApp *TOgleBase::GetOgleApp() const
{
//  return POgleApp;
  return TOgleApp::GetOgleApp();
}
//*******************************************************************
inline TOgleFileMgr *TOgleBase::GetFileMgr() const
{
  return GetOgleApp()->GetFileMgr();
}
//*******************************************************************
inline TOgleGameFrameWindow *TOgleBase::GetFW() const
{
  return GetOgleApp()->GetFW();
}
//*******************************************************************
inline int16 TOgleBase::GetActiveCount() const
{
  return ActiveCount;
}
//*******************************************************************
inline bool TOgleBase::IsActive() const
{
  return bool(GetActiveCount() > 0);
}
//*******************************************************************
inline void TOgleBase::IncActiveCount()
{
  ActiveCount++;
}
//*******************************************************************
inline void TOgleBase::DecActiveCount()
{
  ActiveCount--;
  if (ActiveCount < 0) {ActiveCount = 0;}
}
//*******************************************************************
inline dword TOgleBase::Get_FUC_Length() const
{
  return FUC_Length;
}
//*******************************************************************
inline void TOgleBase::Set_FUC_Length(dword New_FUC_Length)
{
  FUC_Length = New_FUC_Length;
}
//*******************************************************************
inline void TOgleBase::SetFUCOffset(int16 Offset)
{
  FUC_Offset = Offset;
}
//*******************************************************************
inline int16 TOgleBase::GetFUCOffset() const
{
  return FUC_Offset;
}
//*******************************************************************
//inline string TOgleBase::GetBaseName()
//{
////  return FileMode.Name;
////  return FileMode.GetName();
//  return FileMode.Name.GetStr();
//}
//*******************************************************************
inline void TOgleBase::SetStarted()
{
  StatFlags.Set(obSTARTED);
}
//*******************************************************************
inline void TOgleBase::ClearStarted()
{
  StatFlags.Clear(obSTARTED);
}
//*******************************************************************
inline void TOgleBase::SetStopped()
{
  StatFlags.Set(obSTOPPED);
}
//*******************************************************************
inline void TOgleBase::ClearStopped()
{
  StatFlags.Clear(obSTOPPED);
}
//*******************************************************************
inline bool TOgleBase::GetStarted() const
{
  return StatFlags.IsSet(obSTARTED);
}
//*******************************************************************
inline bool TOgleBase::GetStopped() const
{
  return StatFlags.IsSet(obSTOPPED);
}
//*******************************************************************
inline void TOgleBase::SetShowing()
{
  StatFlags.Set(obSHOWING);
}
//*******************************************************************
inline void TOgleBase::ClearShowing()
{
  StatFlags.Clear(obSHOWING);
}
//*******************************************************************
inline bool TOgleBase::GetShowing() const
{
  return StatFlags.IsSet(obSHOWING);
}
//*******************************************************************
inline void TOgleBase::SetBeenRead()
{
  StatFlags.Set(obBEENREAD);
}
//*******************************************************************
inline bool TOgleBase::GetBeenRead() const
{
  return StatFlags.IsSet(obBEENREAD);
}
//*******************************************************************
inline void TOgleBase::SetUseFileOffset()
{
  StatFlags.Set(obUSEFILEOFFSET);
}
//*******************************************************************
inline void TOgleBase::ClearUseFileOffset()
{
  StatFlags.Clear(obUSEFILEOFFSET);
}
//*******************************************************************
inline bool TOgleBase::IsUseFileOffset() const
{
  return StatFlags.IsSet(obUSEFILEOFFSET);
}
//*******************************************************************
inline bool TOgleBase::Readbyte(byte *PDest)
{
  return (ReadData(PDest,sizeof(byte)) == sizeof(byte));
}
//*******************************************************************
inline bool TOgleBase::Writebyte(byte *PSource)
{
  return (WriteData(PSource,sizeof(byte)));
}
//*******************************************************************
inline bool TOgleBase::Readword(word *PDest)
{
  return (ReadData(PDest,sizeof(word)) == sizeof(word));
}
//*******************************************************************
inline bool TOgleBase::Writeword(word *PSource)
{
  return (WriteData(PSource,sizeof(word)));
}
//*******************************************************************
inline bool TOgleBase::Readbool(bool *PDest)
// shitty workaround for old data files when BOOL was an int.
{
  int16 i16;
  bool result = Readint16(&i16); // read into an int16
  *PDest = bool(i16); // set bool to int16
  return result; // return read result.

//  return (ReadData(PDest,sizeof(BOOL)) == sizeof(BOOL));
}
//*******************************************************************
inline bool TOgleBase::Writebool(bool *PSource)
// bookend of shitty workaround.
{
  int16 i16 = int16(*PSource); // put bool into an int16
  return Writeint16(&i16); // write out the int16

//  return (WriteData(PSource,sizeof(BOOL)));
}
//*******************************************************************
inline bool TOgleBase::Readint16(int16 *PDest)
{
  return (ReadData(PDest,sizeof(int16)) == sizeof(int16));
}
//*******************************************************************
inline bool TOgleBase::Writeint16(int16 *PSource)
{
  return (WriteData(PSource,sizeof(int16)));
}
//*******************************************************************
inline bool TOgleBase::Readuint16(uint16 *PDest)
{
  return (ReadData(PDest,sizeof(uint16)) == sizeof(uint16));
}
//*******************************************************************
inline bool TOgleBase::Writeuint16(uint16 *PSource)
{
  return (WriteData(PSource,sizeof(uint16)));
}
//*******************************************************************
inline bool TOgleBase::Readdword(dword *PDest)
{
  return (ReadData(PDest,sizeof(dword)) == sizeof(dword));
}
//*******************************************************************
inline bool TOgleBase::Writedword(dword *PSource)
{
  return (WriteData(PSource,sizeof(dword)));
}
//*******************************************************************
inline bool TOgleBase::Readint32(int32 *PDest)
{
  return (ReadData(PDest,sizeof(int32)) == sizeof(int32));
}
//*******************************************************************
inline bool TOgleBase::Writeint32(int32 *PSource)
{
  return (WriteData(PSource,sizeof(int32)));
}
//*******************************************************************
inline bool TOgleBase::Readchar(char *PDest)
{
  return (ReadData(PDest,sizeof(char)) == sizeof(char));
}
//*******************************************************************
inline bool TOgleBase::Writechar(char *PSource)
{
  return (WriteData(PSource,sizeof(char)));
}
//*******************************************************************
//inline bool TOgleBase::ReadFileNameChars(char *PDest)
inline bool TOgleBase::ReadFNameChars(char *pdest)
{
//  return (ReadData(pdest,FILENAMEBYTES) == FILENAMEBYTES);
  return bool(ReadData(pdest,FNAME_BYTES) == FNAME_BYTES);
}
//*******************************************************************
//inline bool TOgleBase::WriteFileNameChars(char *PSource)
inline bool TOgleBase::WriteFNameChars(char *psource)
{
//  return (WriteData(psource,FILENAMEBYTES));
  return bool(WriteData(psource,FNAME_BYTES));
}
//*******************************************************************
inline bool TOgleBase::ReadIDChars(char *PDest)
{
  return (ReadData(PDest,sizeof(char) * IDNAMEBYTES) == (sizeof(char) * IDNAMEBYTES));
}
//*******************************************************************
inline bool TOgleBase::WriteIDChars(char *PSource)
{
  return (WriteData(PSource,sizeof(char) * IDNAMEBYTES));
}
//*******************************************************************
inline bool TOgleBase::ReadTypeNameChars(char *PDest)
{
  return (ReadData(PDest,sizeof(char) * TYPENAMEBYTES) == (sizeof(char) * TYPENAMEBYTES));
}
//*******************************************************************
inline bool TOgleBase::WriteTypeNameChars(char *PSource)
{
  return (WriteData(PSource,sizeof(char) *TYPENAMEBYTES));
}
//*******************************************************************
inline bool TOgleBase::ReadFileName(string &str)
{
  return Readstring(str);
}
//*******************************************************************
inline bool TOgleBase::WriteFileName(const string &str)
{
  return Writestring(str);
}
//*******************************************************************
inline void TOgleBase::SetFileNotFound()
{
  StatFlags.Set(obFILENOTFOUND);
}
//*******************************************************************
inline void TOgleBase::ClearFileNotFound()
{
  StatFlags.Clear(obFILENOTFOUND);
}
//*******************************************************************
inline bool TOgleBase::IsFileNotFound() const
{
  return StatFlags.IsSet(obFILENOTFOUND);
}
//*******************************************************************
inline bool TOgleBase::Load(TFMStatus ramstatus,TFMStatus hdstatus)
{
  TFileMode fm = FileMode;
  fm.SetRamStatus(ramstatus);
  fm.SetHDStatus(hdstatus);
  return RequestChangeMode(fm);
}
//*******************************************************************
inline bool TOgleBase::LoadRam(TFMStatus ramstatus)
{
  TFileMode fm = FileMode;
  fm.SetRamStatus(ramstatus);
  return RequestChangeMode(fm);
}
//*******************************************************************
inline bool TOgleBase::LoadHD(TFMStatus hdstatus)
{
  TFileMode fm = FileMode;
  fm.SetHDStatus(hdstatus);
  return RequestChangeMode(fm);
}
//*******************************************************************
inline bool TOgleBase::LoadImmed()
{
  return Load(TFileMode::fm_Immed,TFileMode::fm_Immed);
}
//*******************************************************************
inline bool TOgleBase::LoadRamImmed()
{
  return LoadRam(TFileMode::fm_Immed);
}
//*******************************************************************
inline bool TOgleBase::LoadHDImmed()
{
  return LoadHD(TFileMode::fm_Immed);
}
//*******************************************************************
inline bool TOgleBase::LoadBGHi()
{
  return Load(TFileMode::fm_BG_Hi,TFileMode::fm_BG_Hi);
}
//*******************************************************************
inline bool TOgleBase::LoadRamBGHi()
{
  return LoadRam(TFileMode::fm_BG_Hi);
}
//*******************************************************************
inline bool TOgleBase::LoadHDBGHi()
{
  return LoadHD(TFileMode::fm_BG_Hi);
}
//*******************************************************************
inline bool TOgleBase::LoadBGMed()
{
  return Load(TFileMode::fm_BG_Med,TFileMode::fm_BG_Med);
}
//*******************************************************************
inline bool TOgleBase::LoadRamBGMed()
{
  return LoadRam(TFileMode::fm_BG_Med);
}
//*******************************************************************
inline bool TOgleBase::LoadHDBGMed()
{
  return LoadHD(TFileMode::fm_BG_Med);
}
//*******************************************************************
inline bool TOgleBase::LoadBGLo()
{
  return Load(TFileMode::fm_BG_Lo,TFileMode::fm_BG_Lo);
}
//*******************************************************************
inline bool TOgleBase::LoadRamBGLo()
{
  return LoadRam(TFileMode::fm_BG_Lo);
}
//*******************************************************************
inline bool TOgleBase::LoadHDBGLo()
{
  return LoadHD(TFileMode::fm_BG_Lo);
}
//*******************************************************************
inline bool TOgleBase::LoadNone()
{
  return Load(TFileMode::fm_None,TFileMode::fm_None);
}
//*******************************************************************
inline bool TOgleBase::LoadRamNone()
{
  return LoadRam(TFileMode::fm_None);
}
//*******************************************************************
inline bool TOgleBase::LoadHDNone()
{
  return LoadHD(TFileMode::fm_None);
}
//*******************************************************************
inline bool TOgleBase::GetHDLoaded() const
{
  if (PBaseFile == NULL) {return false;}
  return (PBaseFile->IsHDAvail());
}
//*******************************************************************
inline bool TOgleBase::GetRamLoaded() const
{
  if (PBaseFile == NULL) {return false;}
  return(PBaseFile->IsRamAvail());
}
//*******************************************************************
inline TOgleBaseFile *TOgleBase::GetFilePtr() const
{
  return PBaseFile;
}
//*******************************************************************
inline void huge *TOgleBase::GetRamPtr() const
{
  if (PBaseFile == NULL) {return NULL;}
  return PBaseFile->GetRamPtr();
}
//*******************************************************************
inline dword TOgleBase::GetSizeRamPtr() const
{
  if (PBaseFile == NULL) {return 0;}
  return PBaseFile->GetSizeRamPtr();
}
//*******************************************************************
inline dword TOgleBase::GetFileSize()
{
  if (PBaseFile == NULL) {return 0;}
  return PBaseFile->GetSize();
}
//*******************************************************************
inline bool TOgleBase::DoLoadAhead(dword StartFUC)
{
  return (StartFUC <= (AskCurrentFUC() + STARTLOAD_DELTA));
}
//*******************************************************************
inline bool TOgleBase::LoadAhead(dword StartFUC)
{
  if (DoLoadAhead(StartFUC))
  {
    LoadRamImmed();
    return true;                            
  }
  return false;
}
//*******************************************************************
#endif

