//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  odc.h
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0    7/25/96     M.Perry    original baseline
//  2.0    8/22/97     M.Perry    32-bit conversion.
//********************************************************************
#if !defined(__odc_h)
#define __odc_h

// fixuptrace fixes problem with gdiobjec macro expansions
// of tgdiobjec::decref which uses the trace macro.
#if defined(__TRACE)
 #define FIXUPTRACE __TRACE
 #undef __TRACE
#endif

#if !defined(__ogle_h)
#include "ogle.h"
#endif

#if !defined(OWL_DC_H)
#include <owl\dc.h>
#endif

// undo fixuptrace.
#if defined(FIXUPTRACE)
 #define __TRACE FIXUPTRACE
 #undef FIXUPTRACE
#endif

#if !defined(__ogeo_h)
#include "ogeo.h"
#endif

class TOgleScreenDC;
class TOgleWindowDC;
class TOgleClientDC;
class TOglePaintDC;
class TOgleVideoDC;

class TBmp;
class TBitmapInfo;
class TPal;
//*******************************************************************
class TOgleDC:public TDC
{
public:
  TOgleDC(HDC hdc,TAutoDelete autodelete = NoAutoDelete);
  virtual ~TOgleDC();
  virtual bool SelectPal(TPal &pal,bool forcebg = false);
  void AlignRect(TOgleRect &rect);

protected:
  void PaletteRefs(HPALETTE oldpal,HPALETTE newpal);

private:
  TOgleDC();  // not defined.
};
//*******************************************************************
class TOgleCreatedDC:public TOgleDC
{
public:
  TOgleCreatedDC(HDC hdc,TAutoDelete autodelete);
  virtual ~TOgleCreatedDC();

private:
  TOgleCreatedDC(); // not defined.
};
//*******************************************************************
class TOgleWindowDC:public TOgleDC
{
public:
  TOgleWindowDC(HDC hdc,HWND hwnd,TAutoDelete autodelete);
  TOgleWindowDC(HWND hwnd);
  virtual ~TOgleWindowDC();

protected:
  TOgleWindowDC(); // not defined.
  HWND HWnd;
};
//*******************************************************************
class TOgleScreenDC:public TOgleWindowDC
{
public:
  TOgleScreenDC();
  virtual ~TOgleScreenDC();
};
//*******************************************************************
class TOgleClientDC:public TOgleWindowDC
{
public:
  TOgleClientDC(HWND hwnd);
  virtual ~TOgleClientDC();

private:
  TOgleClientDC(); // not defined.
};
//*******************************************************************
class TOgleDesktopDC:public TOgleWindowDC
{
public:
  TOgleDesktopDC();
  virtual ~TOgleDesktopDC();
};
//*******************************************************************
class TOgleVideoDC:public TOgleCreatedDC
{
public:
  TBmp *PBmp;
public:
  TOgleVideoDC(HDC hdc);
  virtual ~TOgleVideoDC();
  virtual bool SelectBmp(TBmp &bmp);
  virtual void RestoreBmp();
  void ReleaseBmp(TBmp *pbmp);
  TBmp *GetBmp();
  void  RestoreObjects();
  virtual HBITMAP CreateBitmap(TBitmapInfo &bitmapinfo,void **ppbits);
  virtual bool SelectPal(TPal &pal,bool forcebg = false);
protected:
  HBITMAP OrgBitmap;
  void BitmapRefs(HBITMAP oldbmp,HBITMAP newbmp);

private:
  TOgleVideoDC(); // not defined.
};
//*******************************************************************
class TOglePaintDC:public TOgleCreatedDC
{
public:
  TOglePaintDC(TDC &dc);
  virtual ~TOglePaintDC();
  virtual bool BitBlt(TOgleRect &rect,TOgleVideoDC &vdc);
private:
  TOglePaintDC(); // later override EvPaint and directly create instead of alias.
};
//*******************************************************************
//********************  TOgleVideoDC inlines ************************
//*******************************************************************
inline void TOgleVideoDC::ReleaseBmp(TBmp *pbmp)
{
  if (pbmp == PBmp) {RestoreBmp();}
}
//*******************************************************************
inline TBmp *TOgleVideoDC::GetBmp()
{
  return PBmp;
}
//*******************************************************************
#endif
