//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  odet.h
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)                 
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     4/28/96    M.Perry    original baseline
//  2.0     8/26/97    M.Perry    32-bit conversion.
//********************************************************************
#if !defined(__odet_h)
#define __odet_h

#if !defined(__ogle_h)
#include "ogle.h"
#endif

#if !defined(__obase_h)
#include "obase.h"
#endif

#if !defined(__ofile_h)
#include "ofile.h"
#endif

#if !defined(__ofilenam_h)
#include "ofilenam.h"
#endif

#if defined(GED_COMPILE) && !defined(__odetscr_h)
  #include "odetscr.h"
#endif

class TDirEntry;
//*******************************************************************
class TDet:public TOgleBase
{
protected:
  TDirEntry *PDirEntry;
//  string Name;
  TOgleFileName Name;
//  string DewName;
  TOgleFileName DewName;
  int16 UsageCount;
#if defined(GED_COMPILE)
  string DestDir;
  TDetScript *PDetScript;
#endif

#if defined(GED_COMPILE)
public:
  TOgleFile *PDewFile;
  TWindow *PWin;
  string Root;
#endif

public:
  TDirEntry *GetDirEntry(string &pathname);
  const string &GetDewName();
  void IncUsage();
  void DecUsage();
  int16 GetUsage();
  TDet();
  TDet(const TFileMode &fm,bool AutoRead = true,bool KeepBaseFile = false);
  virtual ~TDet();
  virtual string AddExt();
  virtual bool ReadLocal();
  virtual const char *GetIDChars() const;
  void DestroyDirEntry();

  #if defined(GED_COMPILE)
  virtual bool WriteOpenCDRomFile();
  virtual bool WriteLocal();
  string &GetRoot() {return Root;}
  void CreateDetScript(string &hddrive,string &hddir,string &desname);
  void DestroyDetScript();
  TDetScript *GetDetScript() {return PDetScript;}
  void Create(TWindow *pwin,string &hddrive,string &hddir,string &desname,const string &destdir);
  void DoDlg(TWindow *pwin);
  void Edit(TWindow *pwin,string &hddrive,string &hddir,string &desname);
  bool IsDirOk(string &dirfromroot,string &dir);
  bool IsExtOk(string &dirfromroot,string &name);
  bool IsNameOk(string &dirfromroot,string &name);
  void CreateDirEntry();
  void CreateDetDataFile();
  void CreateDewFile();
  #endif
};
//*******************************************************************
//******************** inlines **************************************
//*******************************************************************
inline const string &TDet::GetDewName()
{
//  return DewName;
  return DewName.GetStr();
}
//*******************************************************************
inline void TDet::IncUsage()
{
  UsageCount++;
}
//*******************************************************************
inline void TDet::DecUsage()
{
  UsageCount--;
  if (UsageCount < 0)
  {
    UsageCount = 0;
  }
}
//*******************************************************************
inline int16 TDet::GetUsage()
{
  return UsageCount;
}
//*******************************************************************
#endif

