//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  odetlscr.h
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     5/9/96     M.Perry    original baseline
//  2.0     8/26/97    M.Perry    32-bit conversion.
//********************************************************************
#if !defined(__odetlscr_h)
#define __odetlscr_h

#if !defined(__ogle_h)
#include "ogle.h"
#endif

#if !defined(__inifile_h)
#include "inifile.h"
#endif
//*******************************************************************
class TDetListScript
{
protected:
  string HDDrive;
  string HDDir;
  string FileName;
  string FileNameandExt;
  TIniFile *PScript;
  string Source;
  string Dest;

public:
  string DetScriptNames[100];
  int16 NumDets;
  bool Initialized;

public:
  void SetDest(string &dest) {Dest = dest;}
  string &GetDest() {return Dest;}
  void AddName(string &name);
  void RemoveName(int16 index);
  string &GetSource() {return Source;}
  int16 GetNumNames() {return NumDets;}
  string &GetName(int16 index) {return DetScriptNames[index];}
  TDetListScript(string &hddrive,string &hddir,string &filename);
  ~TDetListScript();
  void Initialize();
  void DeInitialize();
  bool Read();
  bool Write();
  bool ReadInfo();
  bool WriteInfo();
  bool ReadNames();
  bool WriteNames();
  void CreateScript();
  void DestroyScript();
};
//*******************************************************************
#endif
