//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  odirent.h
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     4/30/96    M.Perry     original baseline
//  2.0     8/26/97    M.Perry     32-bit conversion.
//********************************************************************
#if !defined(__odirent_h)
#define __odirent_h

#if !defined(__ogle_h)
#include "ogle.h"
#endif

#if !defined(__ostr_h)
#include "ostr.h"
#endif

class ofstream;
class TDet;
//*******************************************************************
class TDirEntry
{
protected:
  #if defined(GED_COMPILE)
  TStr Dir;
  #endif
  int32 Size;
  int32 Offset;
  TDet *PDet;
  TDirEntry **PPDirEntries;

public:
  TStr Name;
  #if defined(GED_COMPILE)
  static int32 refcount;
  #endif

protected:
  int16 NumEntries;
  bool IsDir;

public:
  TDet *GetDetPtr();
  int32 GetSize();
  int32 GetOffset();
  TDirEntry *GetDirEntry(string &pathname);
  TDirEntry *GetDirEntry(int16 index);
  const string &GetDewName();
  TDirEntry() {}
  TDirEntry(TDet *pdet);
  ~TDirEntry();
  bool Read();
  bool Write();
  #if defined(GED_COMPILE)
  TDirEntry(TDet *pdet,const string &dir,const string &filename,int32 size);
  TDirEntry(TDet *pdet,const string &dir,const string &dirname);
  void Report(ofstream &os);
  void Sort();
  bool CreateDewFile();
  #endif

protected:
  bool AddDirEntry(TDirEntry *pdirentry);
  bool RemoveDirEntry(int16 direntryindex);
  TDirEntry *Find(const string &name);
  bool CheckIndex(int16 index);
  int16 CompareNames(const string &name1,TDirEntry *pdirentry);
  #if defined(GED_COMPILE)
  string &GetRootDriveDir();
  TDirEntry *CreateDirEntry(const string &dir,const string &filename,int32 size);
  TDirEntry *CreateDirEntry(const string &dir,const string &dirname);
  void CreateDir();
  #endif
};
//*******************************************************************
//*********************** inlines ***********************************
//*******************************************************************
inline TDet *TDirEntry::GetDetPtr()
{
  return PDet;
}
//*******************************************************************
inline int32 TDirEntry::GetSize()
{
  return Size;
}
//*******************************************************************
inline int32 TDirEntry::GetOffset()
{
  return Offset;
}
//*******************************************************************
inline TDirEntry *TDirEntry::GetDirEntry(int16 index)
{
  if (!CheckIndex(index)) {return NULL;}
  return PPDirEntries[index];
}
//*******************************************************************
inline bool TDirEntry::CheckIndex(int16 index)
{
  return ((index >= 0) && (index < NumEntries));
}
//*******************************************************************
inline int16 TDirEntry::CompareNames(const string &name1,TDirEntry *pdirentry)
{
  if (pdirentry == NULL) {return 1;}
  return int16(strcmp(name1.c_str(),pdirentry->Name));
}
//*******************************************************************
#endif

