//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  oflags.h
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     8/12/96    M.Perry    original baseline
//********************************************************************
#if !defined(__oflags_h)
#define __oflags_h

#if !defined(__ogle_h)
#include "ogle.h"
#endif
//*******************************************************************
#define fBit0  0x0001
#define fBit1  0x0002
#define fBit2  0x0004
#define fBit3  0x0008
#define fBit4  0x0010
#define fBit5  0x0020
#define fBit6  0x0040
#define fBit7  0x0080
#define fBit8  0x0100
#define fBit9  0x0200
#define fBit10 0x0400
#define fBit11 0x0800
#define fBit12 0x1000
#define fBit13 0x2000
#define fBit14 0x4000
#define fBit15 0x8000
//*******************************************************************
class TOgleBYTEFlag
{
protected:
  byte Flags;

public:
  TOgleBYTEFlag(byte flags):Flags(flags) {}
  TOgleBYTEFlag(const TOgleBYTEFlag &bf):Flags(bf.Flags) {}
  TOgleBYTEFlag():Flags(0) {}
  ~TOgleBYTEFlag() {}
  bool IsSet(byte flags) const {return ((Flags & flags)?true:false);}
  bool IsClear(byte flags) const {return !IsSet(flags);}
  void Set(byte flags) {Flags |= flags;}
  void Clear(byte flags) {Flags &= byte(~flags);}

  byte &operator=(byte &flags) {Flags = flags;return Flags;}
  bool operator==(byte &flags) {return (Flags == flags);}
  bool operator!=(byte &flags) {return (Flags != flags);}
};
//*******************************************************************
class TOgleWORDFlag
{
protected:
  word Flags;

public:
  TOgleWORDFlag(word flags) {Flags = flags;}
  TOgleWORDFlag(const TOgleWORDFlag &wf):Flags(wf.Flags) {}
  TOgleWORDFlag() {Flags = 0;}
  ~TOgleWORDFlag() {}
  bool IsSet(word flags) const {return ((Flags & flags)?true:false);}
  bool IsClear(word flags) const {return !IsSet(flags);}
  void Set(word flags) {Flags |= flags;}
  void Clear(word flags) {Flags &= word(~flags);}

  word &operator=(word &flags) {Flags = flags; return Flags;}
  bool operator==(word &flags) {return (Flags == flags);}
  bool operator!=(word &flags) {return (Flags != flags);}
};
//*******************************************************************
class TOgleDWORDFlag
{
protected:
  dword Flags;

public:
  TOgleDWORDFlag() {Flags = 0;}
  TOgleDWORDFlag(dword flags):Flags(flags) {}
  TOgleDWORDFlag(const TOgleDWORDFlag &dwf):Flags(dwf.Flags) {}
  ~TOgleDWORDFlag() {}
  bool IsSet(dword flags) const {return ((Flags & flags)?true:false);}
  bool IsClear(dword flags) const {return !IsSet(flags);}
  void Set(dword flags) {Flags |= flags;}
  void Clear(dword flags) {Flags &= !flags;}

  dword &operator=(dword &flags) {Flags = flags; return Flags;}
  bool operator==(dword &flags) {return (Flags == flags);}
  bool operator!=(dword &flags) {return (Flags != flags);}
};
//*******************************************************************
#endif
