//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  og3dlg.h
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     11/15/96   M.Perry    original baseline
//  2.0     08/27/97   M.Perry    32-bit conversion.
//********************************************************************
#if !defined(__og3dlg_h)
#define __og3dlg_h

#if !defined(__ogle_h)
#include "ogle.h"
#endif

#if !defined(OWL_DIALOG_H)
#include <owl\dialog.h>
#endif

#if !defined(OWL_STATIC_H)
#include <owl\static.h>
#endif

#if !defined(OWL_GAUGE_H)
#include <owl\gauge.h>
#endif

#if !defined(__og3dlg_rh)
#include "og3dlg.rh"
#endif
//*******************************************************************
class OGLEOWLCLASS TG3Dlg:public TDialog
{
public:
  TG3Dlg(TWindow *parent,string title,string g1text,string g2text,string g3text,string text,string status);
  virtual ~TG3Dlg();
  void SetG1Text(const char *text) {PG1Text_STB->SetText(text);}
  void SetG2Text(const char *text) {PG2Text_STB->SetText(text);}
  void SetG3Text(const char *text) {PG3Text_STB->SetText(text);}
  void SetG1Value(int value)
  {
    G1Value = value;
    PGauge1->SetValue(value);
    PGauge1->UpdateWindow();
  }
  void SetG2Value(int value)
  {
    G2Value = value;
    PGauge2->SetValue(value);
    PGauge2->UpdateWindow();
  }
  void SetG3Value(int value)
  {
    G3Value = value;
    PGauge3->SetValue(value);
    PGauge3->UpdateWindow();
  }
  void IncG1Value() {SetG1Value(G1Value + 1);}
  void IncG2Value() {SetG2Value(G2Value + 1);}
  void IncG3Value() {SetG3Value(G3Value + 1);}

  void SetG1Range(int min,int max) {PGauge1->SetRange(min,max);}
  void SetG2Range(int min,int max) {PGauge2->SetRange(min,max);}
  void SetG3Range(int min,int max) {PGauge3->SetRange(min,max);}

  void SetStatus(string status) {PStatus_STB->SetText(status.c_str());}
  void SetText(string text) {PText_STB->SetText(text.c_str());}
  void SetG1Text(string text) {PG1Text_STB->SetText(text.c_str());}
  void SetG2Text(string text) {PG2Text_STB->SetText(text.c_str());}
  void SetG3Text(string text) {PG3Text_STB->SetText(text.c_str());}
  void ResetValues()
  {
    SetG1Value(0);
    SetG2Value(0);
    SetG3Value(0);
  }

protected:
  int G1Value;
  int G2Value;
  int G3Value;
  virtual void SetupWindow();
  TGauge *PGauge1;
  TGauge *PGauge2;
  TGauge *PGauge3;
  TControl *PDummy1;
  TControl *PDummy2;
  TControl *PDummy3;
  TStatic *PText_STB;
  TStatic *PG1Text_STB;
  TStatic *PG2Text_STB;
  TStatic *PG3Text_STB;
  TStatic *PStatus_STB;

private:
  // these strings are just holders from ctor to setupwindow.
  string MainText;
  string MainStatus;
  string G1Text;
  string G2Text;
  string G3Text;
};
//*******************************************************************
#endif
