//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  ogamedat.h
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     10/12/95   M.Perry    original baseline
//  2.0     8/24/97    M.Perry    32-bit conversion.
//********************************************************************
#if !defined(__ogamedat_h)
#define __ogamedat_h

#if !defined(__ogle_h)
#include "ogle.h"
#endif

#if !defined(CLASSLIB_TIME_H)
#include <classlib\time.h>
#endif
//*******************************************************************
struct TGameHeader
// Warning !! Put no virtual functions here.
{
  char IdStr[4];
  int16 MajVer;
  int16 MinVer;
  TGameHeader()
  {
    IdStr[0] = 'S';IdStr[1] = 'A';IdStr[2] = 'V';IdStr[3] = 'E';
    MajVer = 1;
    MinVer = 0;
  }
};
//*******************************************************************
struct TGameData
// Warning !! Put no virtual functions here.
{
private:
  dword CreationSec;
  dword LastSaveGDSec;
  dword LastSavePDSec;
  dword CurrentGameStartSec;
public:
  TGameData();
  dword CurrentTimeDelta();
  bool ShiftCreationSecBack();
  dword CurrentGameDuration();
  void SetCreationSec();
  void SetLastSaveGDSec();
  void SetLastSavePDSec();
  void SetCurrentGameStartSec();
};
//*******************************************************************
//******************** TGameData inlines ****************************
//*******************************************************************
inline TGameData::TGameData()
{
  SetCreationSec();
  LastSaveGDSec = CreationSec;
  LastSavePDSec = CreationSec;
  CurrentGameStartSec = CreationSec;
}
//*******************************************************************
inline dword TGameData::CurrentTimeDelta()
{
  dword now = TTime().Seconds();
  if (now < CreationSec) {return 0;}
  return (now - CreationSec);
}
//*******************************************************************
inline bool TGameData::ShiftCreationSecBack()
{
  dword now = TTime().Seconds();
  if(now < CurrentGameStartSec)
  {
    CreationSec -= CurrentGameStartSec - now;
    CurrentGameStartSec = now;
    return true;
  }
  return false;
}
//*******************************************************************
inline dword TGameData::CurrentGameDuration()
{
  dword now = TTime().Seconds();
  if (now < CurrentGameStartSec) {return 0;}
  return (CurrentGameStartSec - now);
}
//*******************************************************************
inline void TGameData::SetCreationSec()
{
  CreationSec = TTime().Seconds();
}
//*******************************************************************
inline void TGameData::SetLastSaveGDSec()
{
  LastSaveGDSec = TTime().Seconds();
}
//*******************************************************************
inline void TGameData::SetLastSavePDSec()
{
  LastSavePDSec = TTime().Seconds();
}
//*******************************************************************
inline void TGameData::SetCurrentGameStartSec()
{
  CurrentGameStartSec = TTime().Seconds();
}
//*******************************************************************
#endif

