//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  ogobjsk.h
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     2/5/96     M.Perry    original baseline
//  2.0     8/23/97    M.Perry    32-bit conversion.
//********************************************************************
#if !defined(__ogobjsk_h)
#define __ogobjsk_h            

#if !defined(__ogobjsp_h)
#include "ogobjsp.h"
#endif

class TSkitCat;
class TSkitList;
class TSkit;
//*******************************************************************
class TGObjSk:public TGObjSp
{
protected:
  TSkitCat *PSkitCat;

public:
  string SkitCatName;

public:
  #ifdef GED_COMPILE
  void ReportSpriteUsage(ofstream &os,int16 gobjindex,int16 skitcatindex,int16 skitindex,int16 spriteindex);
  bool IsSpriteUsedBySkit(int16 gobjindex,int16 spriteindex,int16 &usedskci,int16 &usedski);
  #endif

  TGObjSk(TOgleModeWindow *pmw);
  TGObjSk(TOgleModeWindow *pmw,const TFileMode &fm);
  virtual ~TGObjSk();

  bool CreateAddSkitCat(TFileMode skcfm);
  virtual TSkitCat *CreateSkitCat(TFileMode skcfm);
  int16 GetSkitListIndex(const string &SkitListName);
  bool ChooseStartSkit(int16 SkitCatIndex,dword &StartFUC,dword &FUCLen,int16 &skitindex);
  bool ChooseStartSkit(int16 SkitCatIndex,dword &StartFUC,dword &FUCLen);
  bool ActivateSkit(int16 SkitCatIndex,int16 SkitIndex,dword StartFUC);
  dword GetSkitLength(int16 SkitCatIndex,int16 SkitIndex);
  TSkitCat *GetSkitCat();
  TSkitList *GetSkitList(int16 SkitListIndex);
  TSkitList *GetSkitList(string SkitListName);
  int16 GetSkitIndex(int16 skitlistindex,string skitname);
  int16 GetNumSkitCats();
  int16 GetSkitCatsLastNum();
//  int16 CreateAddSkitCat(string NewSkitCatFName);
  int16 CreateAddSkitCat(string skitcatname);
  bool AddSkitCat(TSkitList *PNewSkitList);
//  int16 CreateAddSkit(string NewSkitFName,int16 SkitCatIndex);
  int16 CreateAddSkit(string skitname,int16 skitcatindex);
  bool AddSkit(TSkit *PSkit,int16 SkitCatIndex);
  virtual void SetIndexes();
  virtual void Slenderize();
};
//*******************************************************************
//********************** TGObjSk inlines ****************************
//*******************************************************************
inline bool TGObjSk::ChooseStartSkit(int16 SkitCatIndex,dword &StartFUC,dword &FUCLen)
{
  int16 skitindex;
  return ChooseStartSkit(SkitCatIndex,StartFUC,FUCLen,skitindex);
}
//*******************************************************************
inline TSkitCat *TGObjSk::GetSkitCat()
{
  return PSkitCat;
}
//*******************************************************************
inline int16 TGObjSk::GetNumSkitCats()
{
  return int16(GetSkitCatsLastNum() + 1);
}
//*******************************************************************
#endif
