//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  ogobjsp.h
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     2/5/96     M.Perry    original baseline
//  2.0     8/23/97    M.Perry    32-bit conversion.
//********************************************************************
#if !defined(__ogobjsp_h)
#define __ogobjsp_h

#if !defined(__osprite_h)
#include "osprite.h"
#endif

#if !defined(__ogobjbas_h)
#include "ogobjbas.h"
#endif

#ifdef DEBUGSPRITES
  #include <iostream.h>
  #include <fstream.h>
#endif

class TSpriteList;
//*******************************************************************
class TGObjSp:public TGObjBase
{
protected:
  TSpriteList *PSpriteList;

public:
  virtual TSprite *CreateSprite(string spritename,int16 id = 0,void *psource = NULL);

#if defined(SUPPORT_OLD_VER)
  virtual void SetupUniqueIDStrings();
  bool UniqueIDStringsInitialized;
  virtual void SetUIDS(); 
  virtual void SetUIDSStrings();
  virtual int16 GetUniqueID(const string &s) {return SPRITEID_UNK;}
#endif

  #ifdef DEBUGSPRITES
  void RTReport(ofstream &os);
  #endif

  #if defined(GED_COMPILE)
  bool CheckSpriteIDConflict();
  #endif

  #if defined(GED_COMPILE)
  bool CheckSpriteIDUsage();
  #endif

  bool SpritePriority(string &name,int16 count = 1);
  bool SpritePriority(int16 index,int16 count = 1);
  bool SpritePriority(TSprite *psprite,int16 count = 1);
  TGObjSp(TOgleModeWindow *pmw);
  TGObjSp(TOgleModeWindow *pmw,const TFileMode &fm);
  virtual ~TGObjSp();
  void SpriteError(string SpriteDescr,string SpriteFName);
  string SpriteListName;
  bool CreateAddSpriteList(TFileMode splfm);
  virtual TSpriteList *CreateSpriteList(TFileMode splfm);
  dword GetSpriteLength(int16 SpriteIndex);
  dword GetSpriteLength(int16 GObjIndex,int16 SpriteIndex);
  bool CanActivateSprite(int16 GObjIndex,int16 ListNum,dword StartFUC);
  bool CanActivateSprite(int16 ListNum,dword StartFUC);
  bool ActivateSprite(int16 GObjIndex,int16 ListNum,dword StartFUC);
  bool ActivateSprite(int16 ListNum,dword StartFUC);
  bool ActivateSprite(TSprite *psprite,dword StartFUC);
  bool ActivateSprite(int16 ListNum,dword &StartFUC,dword &FUCLength);
  bool CheckSpriteIndex(int16 index);
  bool ActivateSprite(string &spritefname,dword &StartFUC,dword &FUCLength);
  bool ActivateSpriteNow(TSprite *psprite);
  bool IsActiveSprite(int16 ListNum);
  void StartSpriteNow(int16 ListNum);
  bool AddSprite(TFileMode NewFileMode);
  bool AddSprite(TSprite *PNewSprite);
  int16 CreateAddSprite(string SpriteFName);
  TSpriteList *GetSpriteList();
  TSprite *GetSpritePtr(int16 SpriteIndex);
  TSprite *GetSpritePtr(string spriteFName);
  int16 GetSpriteIndex(string SpriteName);
  int16 GetSpriteIndex(TSprite *psprite);
  int16 GetLastNumSprites();
  int16 GetSpriteIndex(int16 GObjIndex,string SpriteName);
  bool SetCurrentSpriteSet(int16 typeindex,int16 setindex);
  virtual void Activate(dword StartFUC);
  virtual void DeActivate();
  virtual void SetIndexes();
  virtual void Slenderize();
  virtual void Update(dword NewFuc);
  virtual void PostUpdate(dword NewFUC);
};
//*******************************************************************
//********************* TGObjSp inlines *****************************
//*******************************************************************
inline bool TGObjSp::SpritePriority(string &name,int16 count)
{
  return SpritePriority(GetSpritePtr(name),count);
}
//*******************************************************************
inline bool TGObjSp::SpritePriority(int16 index,int16 count)
{
  return SpritePriority(GetSpritePtr(index),count);
}
//*******************************************************************
inline bool TGObjSp::SpritePriority(TSprite *psprite,int16 count)
{
  if (psprite == NULL) {return false;}
  return (psprite->Priority(count));
}
//*******************************************************************
inline bool TGObjSp::CheckSpriteIndex(int16 index)
{
  if (index < 0) {return false;}
  return true;
}
//*******************************************************************
inline bool TGObjSp::ActivateSprite(string &spritefname,dword &StartFUC,dword &FUCLength)
{
  int16 ListNum = GetSpriteIndex(spritefname);
  if (!CheckSpriteIndex(ListNum)) {return false;}
  return (ActivateSprite(ListNum,StartFUC,FUCLength));
}
//*******************************************************************
inline TSpriteList *TGObjSp::GetSpriteList()
{
  return PSpriteList;
}
//*******************************************************************
inline bool TGObjSp::ActivateSpriteNow(TSprite *psprite)
{
  return ActivateSprite(GetSpriteIndex(psprite),GetAdjFUC());
}
//*******************************************************************
#endif

