//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  ogrlist.h
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     7/24/96    M.Perry     original baseline
//  2.0     8/22/97    M.Perry     32-bit conversion.
//********************************************************************
#if !defined(__ogrlist_h)
#define __ogrlist_h

#if !defined(__ogle_h)
#include "ogle.h"
#endif

#if !defined(__osliq_h)
#include "osliq.h"
#endif

#if !defined(__ogr_h)
#include "ogr.h"
#endif

#if !defined(__orectlst_h)
#include "orectlst.h"
#endif
//*******************************************************************
class TGrList:public TSliq
{
protected:
  // compare functions must be static functions.
  static TCompareResult CompareLoToHiZ(void *pgr1,void *pgr2);
  static TCompareResult CompareHiToLoZ(void *pgr1,void *pgr2);

public:
  TGrList();
  virtual ~TGrList();
  TGr *GetFirst();
  TGr *GetNext();
  void SortByZ(bool closest);
  bool AddGr(TGr *pgr);
  bool RemoveGr(TGr *pgr);
  bool AddChanged(TOgleRectList &rectlist);
  void ClearChanged();
};
//*******************************************************************
//******************* inlines ***************************************
//*******************************************************************
inline TGr *TGrList::GetFirst()
{
  return (TGr *)LTravFirst();
}
//*******************************************************************
inline TGr *TGrList::GetNext()
{
  return (TGr *)LTravNext();
}
//*******************************************************************
inline bool TGrList::AddGr(TGr *pgr)
{
  return QFrontAdd(pgr);
}
//*******************************************************************
inline bool TGrList::RemoveGr(TGr *pgr)
{
  return LMatchRemove(pgr);
}
//*******************************************************************
#endif

