//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  omode.h
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     7/19/95    M.Perry    original baseline
//  2.0     8/24/97    M.Perry    32-bit conversion.
//  2.1     12/6/97    M.Perry    filename mod's.
//********************************************************************
#if !defined(__omode_h)
#define __omode_h

#if !defined(__obase_h)
#include "obase.h"
#endif

#if !defined(__oapp_rh)
#include "oapp.rh"
#endif

//#include "osliq.h"
class TGObjList;
class TGameObject;
class TBmp;
class TOgleScreenMgr;
//*******************************************************************
class TOgleMode:public TOgleBase
{
protected:
  bool UseBmpMono;
  int16 MonoColorNDX;
  TGObjList *PGObjList;
  TBmp *PBG;
  TPal *PPal;
  TOgleScreenMgr *PScreenMgr;

public:
  string BGFileName;
//  TSliq GObjs;
  int16 GameId;
  string GObjListName;

protected:
  void CreatePal();
  void DestroyPal();
  bool CreateBG();
  void DestroyBG();
  void CreateScreenMgr();
  void DestroyScreenMgr();

public:
  virtual void SetupGObjs();
  virtual bool NotifyMainPalChanged();
  // function added for skitcell's setindex being called in readlocal()
  // causing pmode->pgobjlist access while in pgobjlist's ctor
  // meaning mode's ptr is not set yet.
  // will probably undo hack when setindexes moved in calling sequence.
  void SetGObjList(TGObjList *pgol) {PGObjList = pgol;}
  bool ChangeBG(TOgleFileName ofn);
  void NotifyNumGObjs(int16 numgobjs);
  TGameObject *CreateGObj(TFileMode &fm,int16 id,void *psource = NULL);
  bool DestroyGObj(TGameObject *pgobj);
  TOgleScreenMgr *GetScreenMgr() {return PScreenMgr;}
  TPal *GetPal() {return PPal;}
  TBmp *GetBG() {return PBG;}
  TGObjList *GetGObjList() {return PGObjList;}
  virtual void CreateGObjList();
  void DestroyGObjList();
  void SetGameId(string gamename);
  int16 GetNumPossibleGames();
  void SetGameId(int16 NewGameId);
  int16 GetGameId();
  int16 GetStringTableID();
  string GetGameStr(int16 NewGameId);
  string GetGameStr();

  TOgleMode(TOgleModeWindow *pmw,string ModeName,bool usebmpmono = false,int16 monocolorndx = 0);
  TOgleMode(TOgleModeWindow *pmw,bool usebmpmono = false,int16 monocolorndx = 0);
  virtual ~TOgleMode();

//  int16 GetNumGObjs();
  string GetBGFileName();
  void SetBGFileName(string &NewBGFileName);
//  bool AddGObjName(string *PGObjName);
//  bool RemoveGObjName(string GObjName);
//  string GetGObjName(int16 GObjNum);
//  int16 GetGObjIndex(string GObjName);
  virtual bool ReadLocal();
  virtual string AddExt();
  virtual bool WriteLocal();
  virtual const char *GetIDChars() const;
//  void SortByName();
  virtual void SetMajVer();
  virtual void SetMinVer();
  #if defined(SUPPORT_OLD_VER)
  bool ReadLocal1_0();
  bool ReadLocal2_0();
  #endif
  bool ReadLocal2_1();
  virtual bool Save();
};
//*******************************************************************
//****************** TOgleMode inlines ******************************
//*******************************************************************
inline int16 TOgleMode::GetNumPossibleGames()
{
  return 7;
}
//*******************************************************************
inline void TOgleMode::SetGameId(int16 NewGameId)
{
  GameId = NewGameId;
}
//*******************************************************************
inline int16 TOgleMode::GetGameId()
{
  return GameId;
}
//*******************************************************************
inline string TOgleMode::GetGameStr()
{
  return GetGameStr(GameId);
}
//*******************************************************************
//inline int16 TOgleMode::GetNumGObjs()
//{
//  return GObjs.GetRecCount();
//}
//*******************************************************************
inline string TOgleMode::GetBGFileName()
{
  return BGFileName;
}
//*******************************************************************
inline void TOgleMode::SetBGFileName(string &NewBGFileName)
{
  BGFileName = NewBGFileName;
}
//*******************************************************************
//inline bool TOgleMode::AddGObjName(string *PGObjName)
//{
//  return GObjs.QFrontAdd(PGObjName);
//}
//*******************************************************************
#endif

