//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  omsg.h
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//   1.0   08/03/95    M.Perry     original baseline
//   2.0   08/27/97    M.Perry     32-bit conversion.
//********************************************************************
#if !defined(__omsg_h)
#define __omsg_h               

#if !defined(__ogle_h)
#include "ogle.h"
#endif

#if !defined(__omsg_rh)
#include "omsg.rh"
#endif

class TWindow;

// the following undocumented messages for Win16, but doc'd for Win32
#if !defined(WM_ENTERMENULOOP)
  #define WM_ENTERMENULOOP 0x0211
#endif

#if !defined(WM_EXITMENULOOP)
  #define WM_EXITMENULOOP 0x0212
#endif

#if !defined(MENULOOP_WINDOW)
  #define MENULOOP_WINDOW 0
#endif

#if !defined(MENULOOP_POPUP)
  #define MENULOOP_POPUP 1
#endif
//*******************************************************************
class TOgleMsg
{
public:
  uint MessageID;
  WPARAM Wparam;
  LPARAM Lparam;
  TOgleMsg(WPARAM wparam,LPARAM lparam,uint msgID = ID_OM_OGLEMSG);
  TOgleMsg(byte mt,byte smt,dword data);
  TOgleMsg(byte mt,byte smt,word datalo,word datahi);
  TOgleMsg(TOgleMsg &msg);
  byte GetMT();
  byte GetSMT();
  dword GetData();
  word GetDataWLo();
  word GetDataWHi();
  void Post(TWindow *pwin);
  void PostToFW();
};
//*******************************************************************
class TCmMsg:public TOgleMsg
{
public:
  TCmMsg(WPARAM wparam):TOgleMsg(wparam,0,WM_COMMAND){}
};
//*******************************************************************
class TSkitPreviewMsg:public TOgleMsg
{
public:
  TSkitPreviewMsg():TOgleMsg((byte)ID_MT_SWITCHCLIENTS,(byte)ID_SMT1_SWTO_SKT_PREVIEW,0) {}
};
//*******************************************************************
class TSpritePreviewMsg:public TOgleMsg
{
public:
  TSpritePreviewMsg() :TOgleMsg((byte)ID_MT_SWITCHCLIENTS,(byte)ID_SMT1_SWTO_SPR_PREVIEW,0) {}
};
//*******************************************************************
class TSwToSprEdMsg:public TOgleMsg
{
public:
  TSwToSprEdMsg():TOgleMsg((byte)ID_MT_SWITCHCLIENTS,(byte)ID_SMT1_SWTO_SPRED,0){}
};
//*******************************************************************
class TSwToSktEdMsg:public TOgleMsg
{
public:
  TSwToSktEdMsg():TOgleMsg((byte)ID_MT_SWITCHCLIENTS,(byte)ID_SMT1_SWTO_SKTED,0) {}
};
//*******************************************************************
class TSwToMEdMsg:public TOgleMsg
{
public:
  TSwToMEdMsg():TOgleMsg((byte)ID_MT_SWITCHCLIENTS,(byte)ID_SMT1_SWTO_MED,0) {}
};
//*******************************************************************
class TSwToModeMsg:public TOgleMsg
{
public:
  TSwToModeMsg(bool IsRes,uint id)
  :TOgleMsg(ID_MT_SWITCHCLIENTS,ID_SMT1_SWITCHMODES | ID_SMT1_DATA_RESID,id) {}

  TSwToModeMsg(int16 modeindex)
  :TOgleMsg(ID_MT_SWITCHCLIENTS,ID_SMT1_SWITCHMODES,(dword)modeindex) {}
};
//*******************************************************************
class TSwToModeIDCodeMsg:public TOgleMsg
{
public:
  TSwToModeIDCodeMsg(word idcode,word sidcode)
  :TOgleMsg(ID_MT_SWITCHCLIENTS,ID_SMT1_SWITCHMODES | ID_SMT1_DATA_IDCODE,idcode,sidcode) {}

  TSwToModeIDCodeMsg(TOgleMsg &msg) :TOgleMsg(msg) {}
  word GetIDCode() {return GetDataWLo();}
  word GetSIDCode() {return GetDataWHi();}
};
//*******************************************************************
#endif

