//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  omusmci.h
//    Project Name:  Ogle
// Original Author:  Dave Anderson
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0    06/14/95    D.Anderson   original baseline
//         10/21/96    M.Perry      under modifications.
//  2.0    08/23/97    M.Perry      32-bit conversion.
//  2.2    06/01/99    M.Perry      fixed focus problem.
//********************************************************************
#if !defined(__omusmci_h)
#define __omusmci_h

#if !defined(__ogle_h)
#include "ogle.h"
#endif

#if !defined(_INC_MMSYSTEM)
#include <mmsystem.h>
#endif

//#include <owl\dialog.h>
#if !defined(__ohidewin_h)
#include "ohidewin.h"
#endif

class TMidi;
class TMusicMCI;
//*******************************************************************
class OGLEOWLCLASS TChildMidi : public TOgleHideWin//TDialog
//window class for capture of MM_WOM_DONE
{
public:
	TChildMidi(TWindow* pparent);//, TResId resID);
//   :TDialog(parent,resID){};
   virtual ~TChildMidi();
	virtual LRESULT EvMMMCINotify(WPARAM wParam,LPARAM lParam);
   TMusicMCI *PMusicMgr;
	DECLARE_RESPONSE_TABLE(TChildMidi);
};
//*******************************************************************
class OGLEOWLCLASS TChildMidiChannel : public TChildMidi
{
public:
	 TChildMidiChannel(TWindow* pparent);//,TResId resID)
    //:TChildMidi(parent,resID){};
    virtual ~TChildMidiChannel();
	 LRESULT EvMMMCINotify(WPARAM ,LPARAM );
	 DECLARE_RESPONSE_TABLE(TChildMidiChannel);
};
//*******************************************************************
class TMusicMCI
{
private:
	 TWindow* m_parentWindow;
	 TChildMidiChannel* invisibleWindowMidi;
	 int m_deviceID;
	 bool m_bBusy;
	 TMidi* defaultTMidi;
	 bool   bDefaultMidiActive;
	 TMidi*  currentTMidi;
public:
    UINT GetNumDevs() {return midiOutGetNumDevs();}
	 TMidi* midi_waiting;
	 TMusicMCI(TWindow* parentWnd);
	 ~TMusicMCI();
	 bool SetDefaultMidi(TMidi*);
	 bool SetDefaultMidiActive(bool bActive = true);
	 bool SetDefaultMidiInactive(bool bActive = false);
	 bool PlayMidiDefault(TMidi *p);

	 bool Open(const char* strFileName);

	 bool Play(TMidi* p);
	 inline bool Busy(); //is a midi already playing
	 inline void SetBusy();
	 inline void SetNotBusy();
	 bool Close(int16 notify_msg = -1);
	 void MCIError(dword dwErr);
	 bool Stop(void);
private:
	bool Play(const char* strFileName);
	bool GetMidiCapabilities();
	bool IsOutputDeviceMidiMapper(void);
	bool SetLeftChannelOff(void);
};
//*******************************************************************
#endif
