//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  oplatdef.h
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//            note:  This file is the link between ogle and the compile-time
//                   environment,defining basic types by re-using C++'s RTL and
//                   BIDS, and OWL's data types, wherever possible keeping the
//                   dependencies as portable as possible, or making it easy for
//                   future porting work to be isolating in a small number of
//                   files. Future: MFC,VCL,XWINDOWS,PlayStation 2,etc.
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  2.3    08/05/99    M.Perry    created to organize root dependencies.
//********************************************************************
#if !defined(__oplatdef_h)
#define __oplatdef_h

#if !defined(__ogledef_h)
#include "ogledef.h"
#endif

// the following includes should be in oafx.h
// which is included here.

#define STRICT

#if !defined(_INC_WINDOWS)
#include <windows.h>
#endif

#if !defined(_INC_WINDOWSX)
#include <windowsx.h>
#endif

#if !defined(__LIMITS_H)
#include <limits.h>
#endif

#if !defined(OWL_OWLDEFS_H)
#include <owl\owldefs.h>
#endif

#if !defined(__CSTRING_H)
#include <cstring.h>
#endif

//#include <owl\owlpch.h>

//#define OGLEOWLCLASS _import _OWLFASTTHIS
#define OGLEOWLCLASS

#if defined(OWLVersion)
// Owl ver 5x was first with this define avail
  #define OGLEOWLVER OWLVersion
  #define OGLEOWLVER5
#else // since it's not defined then it must be owl 2x,Borland skipped some #'s.
  #define OGLEOWLVER 0x0200
  #define OGLEOWLVER2
#endif

// put other defines here.

#if defined(BI_PLAT_WIN16)
  #define OHUGE huge
  #define OGLE_PLAT_OS_WIN
  #define OGLE_PLAT_OS_WIN16
  #define OGLE_PLAT_PTR_SEL
#elif defined(BI_PLAT_WIN32)
  #define OHUGE
  #define OGLE_PLAT_OS_WIN
  #define OGLE_PLAT_OS_WIN32
  #define OGLE_PLAT_PTR_FLAT
#else
  #pragma message Ogle Compile Time Error - Unknown Platform
#endif

#if defined(__DEBUG)
#define OGLE_DEBUG
#endif

#endif