//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  oresplst.h
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     9/12/95    M.Perry     original baseline
//  2.0    08/28/97    M.Perry     32-bit conversion.
//********************************************************************
#if !defined(__oresplst_h)
#define __oresplst_h

#if !defined(__osliq_h)
#include "osliq.h"
#endif

#if !defined(__orespond_h)
#include "orespond.h"
#endif

class OGLEOWLCLASS TOgleModeWindow;
//*******************************************************************
TCompareResult ResponderCompareHiToLoZ(void *,void *);
//*******************************************************************
class TResponderList:public TSliq
{
protected:
  TOgleModeWindow *POwnerWindow;
  TOgleApp *PApp;
  TResponder *PResponderPriority;
  TResponder *PAreaResponder;
  bool ZChanged;

protected:
  TResponder *GetFirst() {return ((TResponder *)LTravFirst());}
  TResponder *GetNext() {return ((TResponder *)LTravNext());}
  void SortByZOrder();

public:
  void ReSendEnterArea() {SendToEnterAreaResponder(reEnterArea);}
  void SendToEnterAreaResponder(int msg);

  TResponderList(TOgleModeWindow *pownerwindow);
  virtual ~TResponderList();

  void SetZChanged() {ZChanged = true;}
  void ClearZChanged() {ZChanged = false;}

  bool SetPriority(TResponder *presponder);
  void ClearPriority(TResponder *presponder);

  bool AddResponder(TResponder *presponder);
  bool RemoveResponder(TResponder *presponder);

  void FindAreaResponder(TPoint &point);
  void FindKeyHandler(uint key,uint repeatCount,uint flags);
  void FindMouseHandler(TResponseEvent revent,uint modkeys,TPoint &point);

  void LDown(uint modkeys,TPoint &point);
  void LUp(uint modkeys,TPoint &point);
  void LDblClk(uint modkeys,TPoint &point);
  void RDown(uint modkeys,TPoint &point);
  void RUp(uint modkeys,TPoint &point);
  void RDblClk(uint modkeys,TPoint &point);
  void Move(uint modkeys,TPoint &point);
  void Char(uint key,uint repeatCount,uint flags);
  void SetCursor(TPoint &point);
};
//*******************************************************************
//***************** start of inlines ********************************
//*******************************************************************
inline bool TResponderList::AddResponder(TResponder *presponder)
{
  SetZChanged();
  return (Push(presponder));
}
//*******************************************************************
inline bool TResponderList::RemoveResponder(TResponder *presponder)
{
  if (presponder == PResponderPriority)
  {
    presponder->ClearPriority();
    PResponderPriority = NULL;
  }
  if (presponder == PAreaResponder)
  {
    PAreaResponder = NULL;
  }
  return (LMatchRemove(presponder));
}
//*******************************************************************
inline void TResponderList::LDown(uint modkeys,TPoint &point)
{
  FindMouseHandler(reLDown,modkeys,point);
}
//*******************************************************************
inline void TResponderList::LUp(uint modkeys,TPoint &point)
{
  FindMouseHandler(reLUp,modkeys,point);
}
//*******************************************************************
inline void TResponderList::LDblClk(uint modkeys,TPoint &point)
{
  FindMouseHandler(reLDblClk,modkeys,point);
}
//*******************************************************************
inline void TResponderList::RDown(uint modkeys,TPoint &point)
{
  FindMouseHandler(reRDown,modkeys,point);
}
//*******************************************************************
inline void TResponderList::RUp(uint modkeys,TPoint &point)
{
  FindMouseHandler(reRUp,modkeys,point);
}
//*******************************************************************
inline void TResponderList::RDblClk(uint modkeys,TPoint &point)
{
  FindMouseHandler(reRDblClk,modkeys,point);
}
//*******************************************************************
inline void TResponderList::Move(uint modkeys,TPoint &point)
{
  FindMouseHandler(reMove,modkeys,point);
}
//*******************************************************************
inline void TResponderList::Char(uint key,uint repeatCount,uint flags)
{
  FindKeyHandler(key,repeatCount,flags);
}
//*******************************************************************
inline void TResponderList::SetCursor(TPoint &point)
{
  FindMouseHandler(reSetCursor,0,point);
}
//*******************************************************************
//***************** end of inlines **********************************
//*******************************************************************
#endif

