//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  orespond.h
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     9/12/95    M.Perry    original baseline
//  2.0     8/27/97    M.Perry    32-bit conversion.
//********************************************************************
#if !defined(__orespond_h)
#define __orespond_h

#if !defined(__ogle_h)
#include "ogle.h"
#endif

class TOgleBase;
class OGLEOWLCLASS TOgleModeWindow;
class TOgleScreenMgr;

#if !defined(__CTYPE_H)
#include <ctype.h>
#endif

#if !defined(__ocurmgr_h)
#include "ocurmgr.h"
#endif

//#include "oapp.h"
//*******************************************************************
enum TResponseEvent
{
  reNone,
  reLDown,
  reLUp,
  reLDblClk,
  reRDown,
  reRUp,
  reRDblClk,
  reMove,
  reChar,
  reSetCursor,
  reEnterArea,
  reLeaveArea,
  reUser1,
  reUser2,
  reUser3,
  reUser4,
  reUser5
};
//*******************************************************************
class TResponder
{
public:
  TResponder(TOgleModeWindow *pmw,
             int16 z,
             TRect &rect,
             int16 id,
             TOgleBase *PBase,
             bool AutoAdd,
             char ch = '~',
             TCursorData cd = TCursorData(0,0),
             bool enterleave = false);

  TResponder(TOgleModeWindow *pmw,
             int16 z,
             const TRect &rect,
             int16 id,
             TOgleBase *pbase,
             bool autoadd,
             char ch = '~',
             const TCursorData &cd = TCursorData(0,0),
             bool enterleave = false); 

  TResponder(TOgleModeWindow *pmw);

  ~TResponder();

  void SetToDefCD();
  void SetDefCD(TCursorData &defcd);
  void SetCD(TCursorData &cd);
  void SetCDNow(TCursorData &cd);
  TCursorData &GetCD();
  bool GetIsPriority();
  TPoint &GetPoint();
  void SetCh(char ch);
  void SetCh2(char ch);
  int16 GetID();
  bool SetPriority();
  void ClearPriority();
  TResponseEvent GetResponseEvent();
  void SetResponseEvent(TResponseEvent revent);
  void NotifyScrMgrZ();
  void SetZ(int16 z);
  int16 GetZ();
  void SetNotifyMoves();
  void ClearNotifyMoves();
  bool GetNotifyMoves();
  void Add();
  void Remove();

  bool IsChar(uint ch);
  bool Contains(TPoint &point);

  bool HandleKeyEvent(TResponseEvent revent,uint repeatCount,uint flags);
  bool HandleMouseEvent(TResponseEvent revent,uint modKeys,TPoint &point);

  bool IsEnterLeave();
  void SetEnterLeave(bool enterleave = true);

  void SetRect(const TRect &rect) {Rect = rect;}
  const TRect &GetRect() {return Rect;}

protected:
  TOgleScreenMgr *GetScreenMgr();

protected:
  TOgleModeWindow *PModeWin;
  TOgleBase *POwner;
//  TOgleApp *PApp;
  int16 KeyCount;
  int16 Z;
  TRect Rect;
  int16 IDNum;
  TPoint Point;
  uint ModKeys;
  TResponseEvent ResponseEvent;
  TCursorData CD;
  TCursorData DefCD;
  bool EnterLeave;
  bool IsPriority;
  bool Added;
  bool NotifyMoves;
  char Ch;
  char Ch2;
};
//*******************************************************************
//*********************** inlines ***********************************
//*******************************************************************
inline TResponder::~TResponder()
{
  Remove();
}
//*******************************************************************
inline void TResponder::SetToDefCD()
{
  CD = DefCD;
}
//*******************************************************************
inline void TResponder::SetDefCD(TCursorData &defcd)
{
  DefCD = defcd;
}
//*******************************************************************
inline void TResponder::SetCD(TCursorData &cd)
{
  CD = cd;
}
//*******************************************************************
inline TCursorData &TResponder::GetCD()
{
  return CD;
}
//*******************************************************************
inline bool TResponder::GetIsPriority()
{
  return IsPriority;
}
//*******************************************************************
inline TPoint &TResponder::GetPoint()
{
  return Point;
}
//*******************************************************************
inline void TResponder::SetCh(char ch)
{
  Ch = ch;
}
//*******************************************************************
inline void TResponder::SetCh2(char ch)
{
  Ch2 = ch;
}
//*******************************************************************
inline int16 TResponder::GetID()
{
  return IDNum;
}
//*******************************************************************
inline TResponseEvent TResponder::GetResponseEvent()
{
  return ResponseEvent;
}
//*******************************************************************
inline void TResponder::SetResponseEvent(TResponseEvent revent)
{
  ResponseEvent = revent;
}
//*******************************************************************
inline void TResponder::SetZ(int16 z)
{
  Z = z;
  NotifyScrMgrZ();
}
//*******************************************************************
inline int16 TResponder::GetZ()
{
  return Z;
}
//*******************************************************************
inline void TResponder::SetNotifyMoves()
{
  NotifyMoves = true;
}
//*******************************************************************
inline void TResponder::ClearNotifyMoves()
{
  NotifyMoves = false;
}
//*******************************************************************
inline bool TResponder::GetNotifyMoves()
{
  return NotifyMoves;
}
//*******************************************************************
inline bool TResponder::IsChar(uint ch)
{
  if ((unsigned char)Ch == '^') {return true;}
  if ((unsigned char)toupper(ch) == (unsigned char)toupper(Ch)) {return true;}
  if ((unsigned char)toupper(ch) == (unsigned char)toupper(Ch2)) {return true;}
  return false;
}
//*******************************************************************
inline bool TResponder::Contains(TPoint &point)
{
  return Rect.Contains(point);
}
//*******************************************************************
inline bool TResponder::IsEnterLeave()
{
  return EnterLeave;
}
//*******************************************************************
inline void TResponder::SetEnterLeave(bool enterleave)
{
  EnterLeave = enterleave;
}
//*******************************************************************
#endif

