//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  oskit.h
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     8/27/95    M.Perry    original baseline
//  2.0     8/24/97    M.Perry    32-bit conversion.
//********************************************************************
#if !defined(__oskit_h)                   
#define __oskit_h

#if !defined(__obase_h)
#include "obase.h"
#endif

#if !defined(__osktdlst_h)
#include "osktdlst.h"
#endif

#if !defined(__oskittbl_h)
#include "oskittbl.h"
#endif

#if !defined(__osktcrit_h)
#include "osktcrit.h"
#endif

// start of skit stat flags
#define skFIRST ((WORD)(obLAST * 2))
#define skKNOWNEMPTYTABLE (skFIRST)
#define skLAST (skKNOWNEMPTYTABLE)
// end of skit stat flags
//*******************************************************************
class TSkit:public TOgleBase
{
protected:
  TSkitTable *PSkitTable;
  TSkitDataList *PSkitDataList;
  TSkitCriteria *PSkitCriteria;
  virtual void SetMinVer();
  TGObjSk *POwnerGObj;

public:
  TSkitDataList *GetDataList();
  virtual void Slenderize();

  #if defined(DEBUGSKIT)
  void SkitError(string msg);
  #endif

  #ifdef GED_COMPILE
  void CriteriaReport(ofstream &os);
  void ReportSpriteUsage(ofstream &os,int16 gobjindex,int16 spriteindex);
  bool IsSpriteUsedBySkit(int16 gobjindex,int16 spriteindex);
  #endif

  void SetKnownEmptyTable(bool empty = true);
  void ClearKnownEmptyTable();
  bool GetKnownEmptyTable() const;
  bool IsKnownEmptyTable() const;
  void SetCriteriaAns(int16 QNum,int16 QAns);
  int16 GetCriteriaAns(int16 QNum);
  bool CriteriaCheck(dword StartFUC);
  bool CanActivate(dword StartFUC);

  virtual string AddExt();
  virtual bool ReadLocal();
  bool ReadLocal1_0();
  bool ReadLocal1_1();
  virtual bool WriteLocal();
  virtual const char *GetIDChars() const;
  TSkit(TOgleModeWindow *pmw,TGObjSk *PNewGObj);
  TSkit(TOgleModeWindow *pmw,TFileMode NewFileMode,TGObjSk *PNewGObj,
        bool AutoRead = true,bool KeepBaseFile = false);
  TSkit(TOgleModeWindow *pmw,string &skitname,TGObjSk *PNewGObj,
        void *PReadData,bool AutoRead = true);
  virtual ~TSkit();
  virtual bool Save();
  TSkitTable *GetTable();
  TSkitCriteria *GetSkitCriteria();
  dword GetCalcFUCLength();
  virtual void SetIndexes();
  virtual void Activate(dword StartFUC);
  virtual void Start(dword StartFUC);
  virtual void Start();
};
//*******************************************************************
//***************** TSkit inlines ***********************************
//*******************************************************************
inline TSkitDataList *TSkit::GetDataList()
{
  return PSkitDataList;
}
//*******************************************************************
inline void TSkit::SetKnownEmptyTable(bool empty)
{
  if (empty) {StatFlags.Set(skKNOWNEMPTYTABLE);}
  else       {StatFlags.Clear(skKNOWNEMPTYTABLE);}
}
//*******************************************************************
inline void TSkit::ClearKnownEmptyTable()
{
  StatFlags.Clear(skKNOWNEMPTYTABLE);
}
//*******************************************************************
inline bool TSkit::GetKnownEmptyTable() const
{
  return StatFlags.IsSet(skKNOWNEMPTYTABLE);
}
//*******************************************************************
inline bool TSkit::IsKnownEmptyTable() const
{
  return StatFlags.IsSet(skKNOWNEMPTYTABLE);
}
//*******************************************************************
inline TSkitTable *TSkit::GetTable()
{
  return PSkitTable;
}
//*******************************************************************
inline TSkitCriteria *TSkit::GetSkitCriteria()
{
  return PSkitCriteria;
}
//*******************************************************************
#endif

