//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  oskitcel.h
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     8/27/95    M.Perry    original baseline
//  2.0     8/24/97    M.Perry    32-bit conversion.
//  2.1     12/6/97    M.Perry    filename mod's
//********************************************************************
#if !defined(__oskitcel_h)
#define __oskitcel_h          

#if !defined(__ocell_h)
#include "ocell.h"
#endif

class TGObjSk;
class TSkitDataList;
//*******************************************************************
class TSkitCell:public TOgleCell
{
public:
  string GObjName;
  string SpriteName;
  TGObjSk *POwnerGObj;
  int16 GObjIndex;
  int16 SpriteIndex;

public:
  void AddToDataList(TSkitDataList *pdatalist,int16 rownum);

  #ifdef GED_COMPILE
  void ReportSpriteUsage(ofstream &os,string &skitname,int16 gobjindex,int16 spriteindex);
  bool IsSpriteUsedBySkit(int16 gobjindex,int16 spriteindex);
  #endif

  virtual void SetIndexes();
  void SetGObjName(const string &NewGObjName);
  string &GetGObjName();
  void SetGObjIndex(int16 NewGObjIndex);
  int16 GetGObjIndex();
  void SetSpriteName(const string &NewSpriteName);
  string &GetSpriteName();
  void SetSpriteIndex(int16 NewSpriteIndex);
  int16 GetSpriteIndex();

  TSkitCell();
//  TSkitCell(TFileMode &NewFileMode);
  TSkitCell(TOgleModeWindow *pmw,TFileMode &NewFileMode,TGObjSk *PNewGObj);
  TSkitCell(TOgleModeWindow *pmw,TFileMode &NewFileMode,TGObjSk *PNewGObj,void *PReadData,bool AutoRead = true);
  virtual ~TSkitCell();

  bool ReadLocal1_1();
  bool ReadLocal1_2();
  bool ReadLocal2_0();
  virtual bool ReadLocal();
  virtual bool WriteLocal();
//  virtual void SetMinVer();
  virtual void SetMajVer();

  virtual void Activate(dword StartFUC);
  virtual void Start(dword StartFUC);
  virtual void Start();
  virtual bool CanActivate(dword StartFUC);
  dword GetCalcFUCLength();
};
//*******************************************************************
//******************** TSkitCell inlines ****************************
//*******************************************************************
inline void TSkitCell::SetGObjName(const string &NewGObjName)
{
  GObjName = NewGObjName;
}
//*******************************************************************
inline string &TSkitCell::GetGObjName()
{
  return GObjName;
}
//*******************************************************************
inline void TSkitCell::SetGObjIndex(int16 NewGObjIndex)
{
  GObjIndex = NewGObjIndex;
}
//*******************************************************************
inline int16 TSkitCell::GetGObjIndex()
{
  return GObjIndex;
}
//*******************************************************************
inline void TSkitCell::SetSpriteName(const string &NewSpriteName)
{
  SpriteName = NewSpriteName;
}
//*******************************************************************
inline string &TSkitCell::GetSpriteName()
{
  return SpriteName;
}
//*******************************************************************
inline void TSkitCell::SetSpriteIndex(int16 NewSpriteIndex)
{
  SpriteIndex = NewSpriteIndex;
}
//*******************************************************************
inline int16 TSkitCell::GetSpriteIndex()
{
  return SpriteIndex;
}
//*******************************************************************
#endif

