//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  osktcrit.h
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     9/7/95     M.Perry     original baseline
//  2.0     8/24/97    M.Perry     32-bit conversion.
//********************************************************************
#if !defined(__osktcrit_h)
#define __osktcrit_h

#if !defined(__obase_h)
#include "obase.h"
#endif

#define NUMQUESTIONS 200
#define NUMQUESTIONUINTS (NUMQUESTIONS / 8)
//*******************************************************************
struct TCriteriaBitField
{
  int Mod0 : 2;
  int Mod1 : 2;
  int Mod2 : 2;
  int Mod3 : 2;
  int Mod4 : 2;
  int Mod5 : 2;
  int Mod6 : 2;
  int Mod7 : 2;
};
//*******************************************************************
union TCriteriaUnion
{
  uint16 eight_twobits;
  TCriteriaBitField cbf;
};
//*******************************************************************
class TSkitCriteria:public TOgleBase
{
protected:
  TCriteriaUnion Data[NUMQUESTIONUINTS];
public:
  #ifdef GED_COMPILE
  void CriteriaReport(ofstream &os);
  #endif
  int16 GetNumQuestions() const;
  virtual bool ReadLocal();
  virtual bool WriteLocal();
  virtual const char *GetIDChars() const;

  TSkitCriteria();
  TSkitCriteria(void *PReadData,bool AutoRead = true);
  TSkitCriteria(const TSkitCriteria &sc);
  virtual ~TSkitCriteria();

  void SetData(int16 dataindex,uint16 NewData);
  uint16 GetData(int16 dataindex) const;
  void ClearData();
  int16 GetNeededAnswer(int16 QuestionNum);
  void SetNeededAnswer(int16 QuestionNum,int16 QuestionAns);
  
protected:
  int16 Get2BitInt(int16 dataindex,int16 ModNum);
  void Set2BitInt(int16 dataindex,int16 ModNum,int16 QuestionAns);
};
//*******************************************************************
//***************** TSkitCriteria inlines ***************************
//*******************************************************************
inline int16 TSkitCriteria::GetNumQuestions() const
{
  return NUMQUESTIONS;
}
//*******************************************************************
inline uint16 TSkitCriteria::GetData(int16 dataindex) const
{
  if (dataindex > NUMQUESTIONUINTS) {return 0;}
  if (dataindex < 0) {return 0;}
  return Data[dataindex].eight_twobits;
}
//*******************************************************************
#endif

