//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  osktdlst.h
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     10/16/96   M.Perry    original baseline
//  2.0     8/24/97    M.Perry    32-bit conversion.
//********************************************************************
#if !defined(__osktdlst_h)
#define __osktdlst_h

#if !defined(__ogle_h)
#include "ogle.h"
#endif

class TGObjSk;
class TSkit;
//*******************************************************************
class TSkitData
{
public:
  int16 GObjIndex;
  int16 SpriteIndex;
  int16 FUC_Offset;

public:
  TSkitData();
  ~TSkitData();
  void Set(int16 gobjindex,int16 spriteindex,int16 fuc_offset);
};
//*******************************************************************
class TSkitDataList
{
protected:
  TSkit *POwnerSkit;
  TGObjSk *POwnerGObj;
  TSkitData *PData;
  int16 Size;
  int16 LastAddedElementNum;

public:
  TSkitDataList(TSkit *pskit,TGObjSk *pgobjsk,int16 num);
  ~TSkitDataList();
  bool Add(int16 gobjindex,int16 spriteindex,int16 fuc_offset);
  bool CanActivate(dword StartFUC);
  void Start(dword StartFUC);
};
//*******************************************************************
//******************** TSkitData inlines ****************************
//*******************************************************************
inline TSkitData::TSkitData()
:GObjIndex(-1),
 SpriteIndex(-1),
 FUC_Offset(0)
{
}
//*******************************************************************
inline TSkitData::~TSkitData()
{
}
//*******************************************************************
inline void TSkitData::Set(int16 gobjindex,int16 spriteindex,int16 fuc_offset)
{
  GObjIndex = gobjindex;
  SpriteIndex = spriteindex;
  FUC_Offset = fuc_offset;
}
//*******************************************************************
#endif
