//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  osprtbl.h
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     6/20/95    M.Perry    original baseline
//  2.0     8/22/97    M.Perry    32-bit conversion.
//********************************************************************
#if !defined(__osprtbl_h)
#define __osprtbl_h

#if !defined(__otable_h)
#include "otable.h"
#endif

#if !defined(__osprrow_h)
#include "osprrow.h"
#endif

#include <assert.h>
//*******************************************************************
class TSpriteTable:public TOgleTable
{
public:
  TSprite *POwnerSprite;

public:
  TSpriteTable(TOgleModeWindow *pmw,TSprite *PSprite = NULL);
  TSpriteTable(TOgleModeWindow *pmw,TFileMode &FileMode,TSprite *PSprite,
               void *PReadData,bool AutoRead = true);
  virtual ~TSpriteTable();
  virtual TOgleRow *CreateNewRow();
  virtual TOgleRow *CreateNewRow(void *PSource);
  TSpriteRow *GetSpriteRow(int16 RowIndex);
  TSpriteCell *GetSpriteCell(int16 RowIndex,int16 CellIndex);
  virtual void SetMinVer();
};
//*******************************************************************
//*********************** inlines ***********************************
//*******************************************************************
inline TSpriteRow *TSpriteTable::GetSpriteRow(int16 RowIndex)
{
  if (RowIndex > LastAddedElementNum) {return NULL;}
  if (List[RowIndex] == NULL) {return NULL;}
  return ((TSpriteRow *)List[RowIndex]);
}
//*******************************************************************
inline TSpriteCell *TSpriteTable::GetSpriteCell(int16 RowIndex,int16 CellIndex)
{
  TSpriteRow *PSpriteRow = GetSpriteRow(RowIndex);
  if (PSpriteRow == NULL) {return NULL;}
  return (PSpriteRow->GetSpriteCell(CellIndex));
}
//*******************************************************************
#endif

