//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  ostate.h
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//   1.0    5/22/95    M.Perry    original baseline
//********************************************************************
#if !defined(__ostate_h)
#define __ostate_h

#if !defined(__ogle_h)
#include "ogle.h"
#endif

#define MAXSUBSTATES 24
//*******************************************************************
enum TStateStatus
{
  ss_Running = -2,
  ss_Done = -1,
  ss_Nothing     = 0,
  ss_DoneRecom1  = 1, ss_DoneRecom2  = 2, ss_DoneRecom3  = 3,
  ss_DoneRecom4  = 4, ss_DoneRecom5  = 5, ss_DoneRecom6  = 6,
  ss_DoneRecom7  = 7, ss_DoneRecom8  = 8, ss_DoneRecom9  = 9,
  ss_DoneRecom10 = 10,ss_DoneRecom11 = 11,ss_DoneRecom12 = 12,
  ss_DoneRecom13 = 13,ss_DoneRecom14 = 14,ss_DoneRecom15 = 15,
  ss_DoneRecom16 = 16,ss_DoneRecom17 = 17,ss_DoneRecom18 = 18,
  ss_DoneRecom19 = 19,ss_DoneRecom20 = 20,ss_DoneRecom21 = 21,
  ss_DoneRecom22 = 22,ss_DoneRecom23 = 23,ss_DoneRecom24 = 24
};
//*******************************************************************
enum TExecuteStateStatus
{
  ess_Error = -2,
  ess_Done = -1,
  ess_Nothing = 0,
  ess_Execute = 1,
  ess_ExecuteFirstTime = 2,
  ess_StartSubState1  = 3,
  ess_RunSubState1    = 4,
  ess_EndSubState1    = 5,
  ess_StartSubState2  = 6,
  ess_RunSubState2    = 7,
  ess_EndSubState2    = 8,
  ess_StartSubState3  = 9,
  ess_RunSubState3    = 10,
  ess_EndSubState3    = 11,
  ess_StartSubState4  = 12,
  ess_RunSubState4    = 13,
  ess_EndSubState4    = 14,
  ess_StartSubState5  = 15,
  ess_RunSubState5    = 16,
  ess_EndSubState5    = 17,
  ess_StartSubState6  = 18,
  ess_RunSubState6    = 19,
  ess_EndSubState6    = 20,
  ess_StartSubState7  = 21,
  ess_RunSubState7    = 22,
  ess_EndSubState7    = 23,
  ess_StartSubState8  = 24,
  ess_RunSubState8    = 25,
  ess_EndSubState8    = 26,
  ess_StartSubState9  = 27,
  ess_RunSubState9    = 28,
  ess_EndSubState9    = 29,
  ess_StartSubState10 = 30,
  ess_RunSubState10   = 31,
  ess_EndSubState10   = 32,
  ess_StartSubState11 = 33,
  ess_RunSubState11   = 34,
  ess_EndSubState11   = 35,
  ess_StartSubState12 = 36,
  ess_RunSubState12   = 37,
  ess_EndSubState12   = 38,
  ess_StartSubState13 = 39,
  ess_RunSubState13   = 40,
  ess_EndSubState13   = 41,
  ess_StartSubState14 = 42,
  ess_RunSubState14   = 43,
  ess_EndSubState14   = 44,
  ess_StartSubState15 = 45,
  ess_RunSubState15   = 46,
  ess_EndSubState15   = 47,
  ess_StartSubState16 = 48,
  ess_RunSubState16   = 49,
  ess_EndSubState16   = 50,
  ess_StartSubState17 = 51,
  ess_RunSubState17   = 52,
  ess_EndSubState17   = 53,
  ess_StartSubState18 = 54,
  ess_RunSubState18   = 55,
  ess_EndSubState18   = 56,
  ess_StartSubState19 = 57,
  ess_RunSubState19   = 58,
  ess_EndSubState19   = 59,
  ess_StartSubState20 = 60,
  ess_RunSubState20   = 61,
  ess_EndSubState20   = 62,
  ess_StartSubState21 = 63,
  ess_RunSubState21   = 64,
  ess_EndSubState21   = 65,
  ess_StartSubState22 = 66,
  ess_RunSubState22   = 67,
  ess_EndSubState22   = 68,
  ess_StartSubState23 = 69,
  ess_RunSubState23   = 70,
  ess_EndSubState23   = 71,
  ess_StartSubState24 = 72,
  ess_RunSubState24   = 73,
  ess_EndSubState24   = 74
};
//*******************************************************************
class TState
{
public:
  #if defined(STATEDEBUG)
  char ClassName[40];
  #endif

  TState              *PActiveSubState;
  TExecuteStateStatus ExecuteStatus;
  TStateStatus        Status;
  TStateStatus        SubStateStatus;

  TExecuteStateStatus SubStateRunOrder[MAXSUBSTATES + 1];
  bool HeedRecommend[MAXSUBSTATES + 1];
  bool                ExecuteWaiting;

public:
  virtual void SetRunOrder(TExecuteStateStatus S0  = ess_StartSubState1,
									TExecuteStateStatus S1  = ess_StartSubState2,
									TExecuteStateStatus S2  = ess_StartSubState3,
									TExecuteStateStatus S3  = ess_StartSubState4,
									TExecuteStateStatus S4  = ess_StartSubState5,
									TExecuteStateStatus S5  = ess_StartSubState6,
									TExecuteStateStatus S6  = ess_StartSubState7,
									TExecuteStateStatus S7  = ess_StartSubState8,
									TExecuteStateStatus S8  = ess_StartSubState9,
									TExecuteStateStatus S9  = ess_StartSubState10,
									TExecuteStateStatus S10 = ess_StartSubState11,
									TExecuteStateStatus S11 = ess_StartSubState12,
									TExecuteStateStatus S12 = ess_StartSubState13,
									TExecuteStateStatus S13 = ess_StartSubState14,
									TExecuteStateStatus S14 = ess_StartSubState15,
									TExecuteStateStatus S15 = ess_StartSubState16,
									TExecuteStateStatus S16 = ess_StartSubState17,
									TExecuteStateStatus S17 = ess_StartSubState18,
									TExecuteStateStatus S18 = ess_StartSubState19,
									TExecuteStateStatus S19 = ess_StartSubState20,
									TExecuteStateStatus S20 = ess_StartSubState21,
									TExecuteStateStatus S21 = ess_StartSubState22,
									TExecuteStateStatus S22 = ess_StartSubState23,
									TExecuteStateStatus S23 = ess_StartSubState24,
									TExecuteStateStatus S24 = ess_Done);

  virtual void SetHeedRecommend(bool S1 = false,bool S2 = false,
										  bool S3 = false,bool S4 = false,
										  bool S5 = false,bool S6 = false,
										  bool S7 = false,bool S8 = false,
										  bool S9 = false,bool S10 = false,
										  bool S11 = false,bool S12 = false,
										  bool S13 = false,bool S14 = false,
										  bool S15 = false,bool S16 = false,
										  bool S17 = false,bool S18 = false,
										  bool S19 = false,bool S20 = false,
										  bool S21 = false,bool S22 = false,
										  bool S23 = false,bool S24 = false);

  TState();
  virtual ~TState();

  virtual void SwitchToRecomSubState();
  virtual void RecommendSibling();

  TStateStatus Run();
  virtual void Execute();
  virtual void ExecuteFirstTime();
  virtual void ErrorHandler();
  void Update(dword NewFUC);
  virtual void HandleUpdate(dword NewFUC) {}
  void PostUpdate(dword NewFUC);
  virtual void HandlePostUpdate(dword NewFUC) {}
  bool  ShuttingDown();
  virtual bool HandleShuttingDown() {return true;}

  virtual void CreateSubState1();
  virtual void StartSubState1();
  virtual void RunSubState1();
  virtual void EndSubState1();

  virtual void CreateSubState2();
  virtual void StartSubState2();
  virtual void RunSubState2();
  virtual void EndSubState2();

  virtual void CreateSubState3();
  virtual void StartSubState3();
  virtual void RunSubState3();
  virtual void EndSubState3();

  virtual void CreateSubState4();
  virtual void StartSubState4();
  virtual void RunSubState4();
  virtual void EndSubState4();

  virtual void CreateSubState5();
  virtual void StartSubState5();
  virtual void RunSubState5();
  virtual void EndSubState5();

  virtual void CreateSubState6();
  virtual void StartSubState6();
  virtual void RunSubState6();
  virtual void EndSubState6();

  virtual void CreateSubState7();
  virtual void StartSubState7();
  virtual void RunSubState7();
  virtual void EndSubState7();

  virtual void CreateSubState8();
  virtual void StartSubState8();
  virtual void RunSubState8();
  virtual void EndSubState8();

  virtual void CreateSubState9();
  virtual void StartSubState9();
  virtual void RunSubState9();
  virtual void EndSubState9();

  virtual void CreateSubState10();
  virtual void StartSubState10();
  virtual void RunSubState10();
  virtual void EndSubState10();

  virtual void CreateSubState11();
  virtual void StartSubState11();
  virtual void RunSubState11();
  virtual void EndSubState11();

  virtual void CreateSubState12();
  virtual void StartSubState12();
  virtual void RunSubState12();
  virtual void EndSubState12();

  virtual void CreateSubState13();
  virtual void StartSubState13();
  virtual void RunSubState13();
  virtual void EndSubState13();

  virtual void CreateSubState14();
  virtual void StartSubState14();
  virtual void RunSubState14();
  virtual void EndSubState14();

  virtual void CreateSubState15();
  virtual void StartSubState15();
  virtual void RunSubState15();
  virtual void EndSubState15();

  virtual void CreateSubState16();
  virtual void StartSubState16();
  virtual void RunSubState16();
  virtual void EndSubState16();

  virtual void CreateSubState17();
  virtual void StartSubState17();
  virtual void RunSubState17();
  virtual void EndSubState17();

  virtual void CreateSubState18();
  virtual void StartSubState18();
  virtual void RunSubState18();
  virtual void EndSubState18();

  virtual void CreateSubState19();
  virtual void StartSubState19();
  virtual void RunSubState19();
  virtual void EndSubState19();

  virtual void CreateSubState20();
  virtual void StartSubState20();
  virtual void RunSubState20();
  virtual void EndSubState20();

  virtual void CreateSubState21();
  virtual void StartSubState21();
  virtual void RunSubState21();
  virtual void EndSubState21();

  virtual void CreateSubState22();
  virtual void StartSubState22();
  virtual void RunSubState22();
  virtual void EndSubState22();

  virtual void CreateSubState23();
  virtual void StartSubState23();
  virtual void RunSubState23();
  virtual void EndSubState23();

  virtual void CreateSubState24();
  virtual void StartSubState24();
  virtual void RunSubState24();
  virtual void EndSubState24();
};
//*******************************************************************
#endif

