//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  otable.h
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     6/20/95    M.Perry     original baseline
//  2.0     8/20/97    M.Perry     32-bit conversion.
//********************************************************************
#if !defined(__otable_h)
#define __otable_h

#if !defined(__orow_h)
#include "orow.h"
#endif
//*******************************************************************
class TOgleTable:public TOgleList
{
//public:
//  int NumRowsInFile;

public:
  virtual bool ReadLocal();
  virtual bool WriteLocal();
  virtual const char *GetIDChars() const; 
  void ReadRows();
  void CreateRows(int16 NewNumRows);
  TOgleTable(TOgleModeWindow *pmw);
  TOgleTable(TOgleModeWindow *pmw,bool dummy,const TFileMode &fm);
  TOgleTable(TOgleModeWindow *pmw,void *PSource,bool AutoRead = true);
  virtual ~TOgleTable();
  virtual TOgleRow *CreateNewRow();
  virtual TOgleRow *CreateNewRow(void *PSource);
  virtual void AddRow();
  virtual void CreateLists();
  virtual void Activate(dword StartFUC = 0);
  int16 GetFrameCount();
  int16 GetLastNum();
  int16 GetNumRows();
  void RemoveTopRow();
  virtual void SetIndexes();
  TOgleRow *GetRowPtr(int16 ElementNum);
}; 
//*******************************************************************
//*******************  inlines  *************************************
//*******************************************************************
inline int16 TOgleTable::GetFrameCount()
{
  return int16(LastAddedElementNum + 1);
}
//*******************************************************************
inline int16 TOgleTable::GetLastNum()
{
  return LastAddedElementNum;
}
//*******************************************************************
inline int16 TOgleTable::GetNumRows()
{
  return GetFrameCount();
}
//*******************************************************************
inline TOgleRow *TOgleTable::GetRowPtr(int16 ElementNum)
{
  return ((TOgleRow *)GetElementPtr(ElementNum));
}
//*******************************************************************
#endif

