//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  otypedef.h
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     9/9/96     M.Perry    original baseline
//********************************************************************
#if !defined(__otypedef_h)
#define __otypedef_h

#if !defined(__oplatdef_h)
#include "oplatdef.h"
#endif

typedef signed char int8;
typedef unsigned char uint8;
typedef unsigned char uchar;
typedef unsigned char byte;

typedef signed short int16;
typedef unsigned short uint16;
typedef unsigned short ushort;
typedef unsigned short word;

typedef unsigned int uint;

typedef signed long int32;
typedef unsigned long uint32;
typedef unsigned long ulong;
typedef unsigned long dword;

// start data ranges.
#define int8_min (-128)
#define uint8_min 0
#define uchar_min uint8_min
#define byte_min uint8_min

#define int8_max 127
#define uint8_max 255
#define uchar_max uint8_max
#define byte_max uint8_max

#define int16_min (-32768)
#define uint16_min 0
#define ushort_min uint16_min
#define word_min uint16_min

#define int16_max 32767
#define uint16_max 65535
#define ushort_max uint16_max
#define word_max uint16_max

#define int32_min (-2147483648l)
#define int32_max 2147483647l
#define uint32_min 0
#define uint32_max 4294967295l

#define ulong_min uint32_min
#define ulong_max uint32_max
#define long_min int32_min
#define long_max int32_max

#define dword_min uint32_min
#define dword_max uint32_max

#if defined(BI_PLAT_WIN16)
  #define uint_min uint16_min
  #define uint_max uint16_max
  #define int_min int16_min
  #define int_max int16_max
#else
  #define uint_min uint32_min
  #define uint_max uint32_max
  #define int_min int32_min
  #define int_max int32_max
#endif
//end data ranges

// start data packing functions.
inline byte lobyte(word w)
{
  return byte(w);
}

inline int8 loint8(uint16 u16)
{
  return int8(u16);
}

inline uint8 louint8(uint16 u16)
{
  return uint8(u16);
}

inline byte hibyte(word w)
{
  return byte(w >> 8);
}

inline int8 hiint8(uint16 u16)
{
  return int8(u16 >> 8);
}

inline uint8 hiuint8(uint16 u16)
{
  return uint8(u16 >> 8);
}

inline word makeword(byte lb,byte hb)
{
  return word(lb | (word(hb) << 8));
}

inline uint16 makeuint16(uint8 lo,uint8 hi)
{
  return uint16(lo | (uint16(hi) << 8));
}

inline word loword(dword dw)
{
  return word(dw);
}

inline uint16 louint16(uint32 u32)
{
  return uint16(u32);
}

inline int16 loint16(uint32 u32)
{
  return int16(u32);
}

inline word hiword(dword dw)
{
  return word(dw >> 16);
}

inline uint16 hiuint16(uint32 u32)
{
  return uint16(u32 >> 16);
}

inline int16 hiint16(uint32 u32)
{
  return int16(u32 >> 16);
}

inline dword makedword(word lw,word hw)
{
  return dword(lw | (dword(hw) << 16));
}

inline uint32 makeuint32(uint16 lo,uint16 hi)
{
  return uint32(lo | (uint32(hi) << 16));
}

inline int32 makeint32(int16 lo,int16 hi)
{
  return int32(word(lo) | dword(word(hi) << 16));
}
// end data packing functions.

#if !defined(__omoney_h)
#include "omoney.h"
#endif

#endif