//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  oupdsum.h
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     10/16/96   M.Perry    original baseline
//  2.0     08/29/97   M.Perry    32-bit conversion.
//********************************************************************
#if !defined(__oupdsum_h)
#define __oupdsum_h

#if !defined(__ogle_h)
#include "ogle.h"
#endif

#if !defined(__osys_h)
#include "osys.h"
#endif

#define NUMBLTTOSINGLES 50
#define NUMLISTWALS 25
#define NUMGOBJS 5
//*******************************************************************
class TMWUpdateSum
{
public:
  dword PaintStart;
  dword PaintEnd;
  dword PaintCount;
  dword PaintTotals;
  dword ScreenMgrStart;
  dword ScreenMgrEnd;
  dword ScreenMgrCount;
  dword ScreenMgrTotals;
  dword UpdateStart;
  dword UpdateEnd;
  dword UpdateCount;
  dword UpdateTotals;
  dword SndMgrStart;
  dword SndMgrEnd;
  dword SndMgrCount;
  dword SndMgrTotals;
  dword RunStateStart;
  dword RunStateEnd;
  dword RunStateCount;
  dword RunStateTotals;
  dword UpdateStateStart;
  dword UpdateStateEnd;
  dword UpdateStateCount;
  dword UpdateStateTotals;
  dword PostUpdateStateStart;
  dword PostUpdateStateEnd;
  dword PostUpdateStateCount;
  dword PostUpdateStateTotals;
  dword UpdateGObjStart;
  dword UpdateGObjEnd;
  dword UpdateGObjCount;
  dword UpdateGObjTotals;
  dword PostUpdateGObjStart;
  dword PostUpdateGObjEnd;
  dword PostUpdateGObjCount;
  dword PostUpdateGObjTotals;
  dword ProcessRectsStart;
  dword ProcessRectsEnd;
  dword ProcessRectsCount;
  dword ProcessRectsTotals;
  dword RenderBGStart;
  dword RenderBGEnd;
  dword RenderBGCount;
  dword RenderBGTotals;
  dword RenderStart;
  dword RenderEnd;
  dword RenderCount;
  dword RenderTotals;
  dword GrListSortStart;
  dword GrListSortEnd;
  dword GrListSortCount;
  dword GrListSortTotals;
  dword BltToStart;
  dword BltToEnd;
  dword BltToCount;
  dword BltToTotals;
  dword BltToSingleStart;
  dword BltToSingleEnd;
  int16 BltToSingleLastCount;
  dword BltToSingleTotals[NUMBLTTOSINGLES];
  string BltToSingleNames[NUMBLTTOSINGLES];
  int16 BltToSingleFrameNums[NUMBLTTOSINGLES];

  dword Generic1Start;
  dword Generic1End;
  dword Generic1Count;
  dword Generic1Totals;
  string Generic1Title;
  dword Generic2Start;
  dword Generic2End;
  dword Generic2Count;
  dword Generic2Totals;
  string Generic2Title;

  int16 CurGI;
  int16 LastGI;
  int16 LastUListWAL;
  dword UListWALStart;
  dword UListWALEnd;
  dword UListWALTotals[NUMGOBJS][NUMLISTWALS];
  dword UListWALCount[NUMGOBJS][NUMLISTWALS];
  string UListWALNames[NUMGOBJS][NUMLISTWALS];
  int16 UListWALLastCount[NUMGOBJS];
  dword UActiveListTotals[NUMGOBJS][NUMLISTWALS];
  dword UActiveListCount[NUMGOBJS][NUMLISTWALS];
  dword UActiveListStart;
  dword UActiveListEnd;
  dword UActiveListIdlesTotals[NUMGOBJS][NUMLISTWALS];
  dword UActiveListIdlesCount[NUMGOBJS][NUMLISTWALS];
  dword UActiveListIdlesStart;
  dword UActiveListIdlesEnd;
  int16 UActiveListNumElements[NUMGOBJS][NUMLISTWALS];
  bool UActiveListHasGoing[NUMGOBJS][NUMLISTWALS];

  dword PUListWALStart;
  dword PUListWALEnd;
  int16 LastPUListWAL;
  dword PUListWALTotals[NUMGOBJS][NUMLISTWALS];
  dword PUListWALCount[NUMGOBJS][NUMLISTWALS];
  string PUListWALNames[NUMGOBJS][NUMLISTWALS];
  int16 PUListWALLastCount[NUMGOBJS];
  dword PUActiveListTotals[NUMGOBJS][NUMLISTWALS];
  dword PUActiveListCount[NUMGOBJS][NUMLISTWALS];
  dword PUActiveListStart;
  dword PUActiveListEnd;
  dword PUActiveListIdlesTotals[NUMGOBJS][NUMLISTWALS];
  dword PUActiveListIdlesCount[NUMGOBJS][NUMLISTWALS];
  dword PUActiveListIdlesStart;
  dword PUActiveListIdlesEnd;
  int16 PUActiveListNumElements[NUMGOBJS][NUMLISTWALS];

  int16 LastSpriteType[NUMGOBJS];
  dword SpriteStartStart;
  dword SpriteStartEnd;
  dword SpriteStartTotals[NUMGOBJS][NUMLISTWALS];
  dword SpriteStartCount[NUMGOBJS][NUMLISTWALS];

  dword SpriteUpdateStart;
  dword SpriteUpdateEnd;
  dword SpriteUpdateTotals[NUMGOBJS][NUMLISTWALS];
  dword SpriteUpdateCount[NUMGOBJS][NUMLISTWALS];

  dword SpritePUpdateStart;
  dword SpritePUpdateEnd;
  dword SpritePUpdateTotals[NUMGOBJS][NUMLISTWALS];
  dword SpritePUpdateCount[NUMGOBJS][NUMLISTWALS];

  dword AnmStartStart;
  dword AnmStartEnd;
  dword AnmStartTotals[NUMGOBJS][NUMLISTWALS];
  dword AnmStartCount[NUMGOBJS][NUMLISTWALS];

  dword AnmUpdateStart;
  dword AnmUpdateEnd;
  dword AnmUpdateTotals[NUMGOBJS][NUMLISTWALS];
  dword AnmUpdateCount[NUMGOBJS][NUMLISTWALS];

  dword AnmPUpdateStart;
  dword AnmPUpdateEnd;
  dword AnmPUpdateTotals[NUMGOBJS][NUMLISTWALS];
  dword AnmPUpdateCount[NUMGOBJS][NUMLISTWALS];

  dword WavStartStart;
  dword WavStartEnd;
  dword WavStartTotals[NUMGOBJS][NUMLISTWALS];
  dword WavStartCount[NUMGOBJS][NUMLISTWALS];

  dword WavUpdateStart;
  dword WavUpdateEnd;
  dword WavUpdateTotals[NUMGOBJS][NUMLISTWALS];
  dword WavUpdateCount[NUMGOBJS][NUMLISTWALS];

  dword WavPUpdateStart;
  dword WavPUpdateEnd;
  dword WavPUpdateTotals[NUMGOBJS][NUMLISTWALS];
  dword WavPUpdateCount[NUMGOBJS][NUMLISTWALS];

  dword KeyStart;
  dword KeyEnd;
  dword KeyCount;
  dword KeyTotals;

  dword MouseStart;
  dword MouseEnd;
  dword MouseCount;
  dword MouseTotals;

  dword AreaStart;
  dword AreaEnd;
  dword AreaCount;
  dword AreaTotals;

  dword GetSysTime();

public:
  void ClearData(); // found in omodewin.cpp
  TMWUpdateSum();
  ~TMWUpdateSum();

  void StartPaint();
  void EndPaint();
  dword GetPaintAvg();

  void StartScreenMgr();
  void EndScreenMgr();
  dword GetScreenMgrAvg();

  void StartSndMgr();
  void EndSndMgr();
  dword GetSndMgrAvg();

  void StartRunState();
  void EndRunState();
  dword GetRunStateAvg();

  void StartUpdateState();
  void EndUpdateState();
  dword GetUpdateStateAvg();

  void StartPostUpdateState();
  void EndPostUpdateState();
  dword GetPostUpdateStateAvg();

  void StartUpdateGObj();
  void EndUpdateGObj();
  dword GetUpdateGObjAvg();

  void StartPostUpdateGObj();
  void EndPostUpdateGObj();
  dword GetPostUpdateGObjAvg();

  void StartUpdate();
  void EndUpdate();
  dword GetUpdateAvg();

  void StartProcessRects();
  void EndProcessRects();
  dword GetProcessRectsAvg();

  void StartRenderBG();
  void EndRenderBG();
  dword GetRenderBGAvg();

  void StartRender();
  void EndRender();
  dword GetRenderAvg();

  void StartGrListSort();
  void EndGrListSort();
  dword GetGrListSortAvg();

  void StartBltTo();
  void EndBltTo();
  dword GetBltToAvg();

  void StartBltToSingle(const string &name,int16 framenum,int16 count);
  void EndBltToSingle(int16 count);
  string strNoName;

  void StartGeneric1(string &name);
  void EndGeneric1();
  dword GetGeneric1Avg();

  void StartGeneric2(string &name);
  void EndGeneric2();
  dword GetGeneric2Avg();

  void SetCurGObjIndex(int16 gi);

  void StartUListWAL(int16 count,string &name);
  void EndUListWAL(int16 count);
  dword GetUListWALAvg(int16 gi,int16 count);

  void StartPUListWAL(int16 count,string &name);
  void EndPUListWAL(int16 count);
  dword GetPUListWALAvg(int16 gi,int16 count);

  void StartUActiveList();
  void EndUActiveList();
  dword GetUActiveListAvg(int16 gi,int16 count);

  void SetUActiveListNumElements(int16 num);
  int16 GetUActiveListNumElements(int16 gi,int16 count);

  void SetUActiveListHasGoing(bool going);
  bool GetUActiveListHasGoing(int16 gi,int16 count);

  void SetPUActiveListNumElements(int16 num);
  int16 GetPUActiveListNumElements(int16 gi,int16 count);

  void StartPUActiveList();
  void EndPUActiveList();
  dword GetPUActiveListAvg(int16 gi,int16 count);

  void StartUActiveListIdles();
  void EndUActiveListIdles();
  dword GetUActiveListIdlesAvg(int16 gi,int16 count);

  void StartPUActiveListIdles();
  void EndPUActiveListIdles();
  dword GetPUActiveListIdlesAvg(int16 gi,int16 count);

  void StartSpriteStart(int16 spritetype);
  void EndSpriteStart(int16 spritetype);
  dword GetSpriteStartAvg(int16 gi,int16 spritetype);
  dword GetSpriteStartTotals(int16 gi,int16 spritetype);
  dword GetSpriteStartCount(int16 gi,int16 spritetype);
  dword GetSpriteStartTotal(int16 gi);

  void StartSpriteUpdate(int16 spritetype);
  void EndSpriteUpdate(int16 spritetype);
  dword GetSpriteUpdateAvg(int16 gi,int16 spritetype);
  dword GetSpriteUpdateCount(int16 gi,int16 spritetype);
  dword GetSpriteUpdateTotals(int16 gi,int16 spritetype);
  dword GetSpriteUpdateTotal(int16 gi);

  void StartSpritePUpdate(int16 spritetype);
  void EndSpritePUpdate(int16 spritetype);
  dword GetSpritePUpdateAvg(int16 gi,int16 spritetype);
  dword GetSpritePUpdateCount(int16 gi,int16 spritetype);
  dword GetSpritePUpdateTotals(int16 gi,int16 spritetype);

  void StartAnmStart();
  void EndAnmStart();
  dword GetAnmStartAvg(int16 gi,int16 spritetype);
  dword GetAnmStartCount(int16 gi,int16 spritetype);
  dword GetAnmStartTotals(int16 gi,int16 spritetype);
  dword GetAnmStartTotal(int16 gi);

  void StartAnmUpdate();
  void EndAnmUpdate();
  dword GetAnmUpdateAvg(int16 gi,int16 spritetype);
  dword GetAnmUpdateCount(int16 gi,int16 spritetype);
  dword GetAnmUpdateTotals(int16 gi,int16 spritetype);
  dword GetAnmUpdateTotal(int16 gi);

  void StartAnmPUpdate();
  void EndAnmPUpdate();
  dword GetAnmPUpdateAvg(int16 gi,int16 spritetype);
  dword GetAnmPUpdateCount(int16 gi,int16 spritetype);
  dword GetAnmPUpdateTotals(int16 gi,int16 spritetype);

  void StartWavStart();
  void EndWavStart();
  dword GetWavStartAvg(int16 gi,int16 spritetype);
  dword GetWavStartCount(int16 gi,int16 spritetype);
  dword GetWavStartTotals(int16 gi,int16 spritetype);

  void StartWavUpdate();
  void EndWavUpdate();
  dword GetWavUpdateAvg(int16 gi,int16 spritetype);
  dword GetWavUpdateCount(int16 gi,int16 spritetype);
  dword GetWavUpdateTotals(int16 gi,int16 spritetype);

  void StartWavPUpdate();
  void EndWavPUpdate();
  dword GetWavPUpdateAvg(int16 gi,int16 spritetype);
  dword GetWavPUpdateCount(int16 gi,int16 spritetype);
  dword GetWavPUpdateTotals(int16 gi,int16 spritetype);

  void StartKey();
  void EndKey();
  dword GetKeyAvg();
  dword GetKeyCount();
  dword GetKeyTotals();

  void StartMouse();
  void EndMouse();
  dword GetMouseAvg();
  dword GetMouseCount();
  dword GetMouseTotals();

  void StartArea();
  void EndArea();
  dword GetAreaAvg();
  dword GetAreaCount();
  dword GetAreaTotals();
};
//*******************************************************************
//****************************  inlines *****************************
//*******************************************************************
inline dword TMWUpdateSum::GetSysTime()
{
  return TSys::GetMSec();
}
//*******************************************************************
inline TMWUpdateSum::TMWUpdateSum()
{
  ClearData();
}
//*******************************************************************
inline TMWUpdateSum::~TMWUpdateSum()
{
}
//*******************************************************************
inline void TMWUpdateSum::StartPaint()
{
  PaintStart = GetSysTime();
}
//*******************************************************************
inline void TMWUpdateSum::EndPaint()
{
  PaintEnd = GetSysTime();
  PaintCount++;
  PaintTotals += (PaintEnd - PaintStart);
}
//*******************************************************************
inline dword TMWUpdateSum::GetPaintAvg()
{
  return PaintCount?(PaintTotals / PaintCount):0;
}
//*******************************************************************
inline void TMWUpdateSum::StartScreenMgr()
{
  ScreenMgrStart = GetSysTime();
}
//*******************************************************************
inline void TMWUpdateSum::EndScreenMgr()
{
  ScreenMgrEnd = GetSysTime();
  ScreenMgrCount++;
  ScreenMgrTotals += (ScreenMgrEnd - ScreenMgrStart);
}
//*******************************************************************
inline dword TMWUpdateSum::GetScreenMgrAvg()
{
  return ScreenMgrCount?(ScreenMgrTotals / ScreenMgrCount):0;
}
//*******************************************************************
inline void TMWUpdateSum::StartSndMgr()
{
  SndMgrStart = GetSysTime();
}
//*******************************************************************
inline void TMWUpdateSum::EndSndMgr()
{
  SndMgrEnd = GetSysTime();
  SndMgrCount++;
  SndMgrTotals += (SndMgrEnd - SndMgrStart);
}
//*******************************************************************
inline dword TMWUpdateSum::GetSndMgrAvg()
{
  return SndMgrCount?(SndMgrTotals / SndMgrCount):0;
}
//*******************************************************************
inline void TMWUpdateSum::StartRunState()
{
  RunStateStart = GetSysTime();
}
//*******************************************************************
inline void TMWUpdateSum::EndRunState()
{
  RunStateEnd = GetSysTime();
  RunStateCount++;
  RunStateTotals += (RunStateEnd - RunStateStart);
}
//*******************************************************************
inline dword TMWUpdateSum::GetRunStateAvg()
{
  return RunStateCount?(RunStateTotals / RunStateCount):0;
}
//*******************************************************************
inline void TMWUpdateSum::StartUpdateState()
{
  UpdateStateStart = GetSysTime();
}
//*******************************************************************
inline void TMWUpdateSum::EndUpdateState()
{
  UpdateStateEnd = GetSysTime();
  UpdateStateCount++;
  UpdateStateTotals += (UpdateStateEnd - UpdateStateStart);
}
//*******************************************************************
inline dword TMWUpdateSum::GetUpdateStateAvg()
{
  return UpdateStateCount?(UpdateStateTotals / UpdateStateCount):0;
}
//*******************************************************************
inline void TMWUpdateSum::StartPostUpdateState()
{
  PostUpdateStateStart = GetSysTime();
}
//*******************************************************************
inline void TMWUpdateSum::EndPostUpdateState()
{
  PostUpdateStateEnd = GetSysTime();
  PostUpdateStateCount++;
  PostUpdateStateTotals += (PostUpdateStateEnd - PostUpdateStateStart);
}
//*******************************************************************
inline dword TMWUpdateSum::GetPostUpdateStateAvg()
{
  return PostUpdateStateCount?(PostUpdateStateTotals / PostUpdateStateCount):0;
}
//*******************************************************************
inline void TMWUpdateSum::StartUpdateGObj()
{
  UpdateGObjStart = GetSysTime();
}
//*******************************************************************
inline void TMWUpdateSum::EndUpdateGObj()
{
  UpdateGObjEnd = GetSysTime();
  UpdateGObjCount++;
  UpdateGObjTotals += (UpdateGObjEnd - UpdateGObjStart);
}
//*******************************************************************
inline dword TMWUpdateSum::GetUpdateGObjAvg()
{
  return UpdateGObjCount?(UpdateGObjTotals / UpdateGObjCount):0;
}
//*******************************************************************
inline void TMWUpdateSum::StartPostUpdateGObj()
{
  PostUpdateGObjStart = GetSysTime();
}
//*******************************************************************
inline void TMWUpdateSum::EndPostUpdateGObj()
{
  PostUpdateGObjEnd = GetSysTime();
  PostUpdateGObjCount++;
  PostUpdateGObjTotals += (PostUpdateGObjEnd - PostUpdateGObjStart);
}
//*******************************************************************
inline dword TMWUpdateSum::GetPostUpdateGObjAvg()
{
  return PostUpdateGObjCount?(PostUpdateGObjTotals / PostUpdateGObjCount):0;
}
//*******************************************************************
inline void TMWUpdateSum::StartUpdate()
{
  UpdateStart = GetSysTime();
}
//*******************************************************************
inline void TMWUpdateSum::EndUpdate()
{
  UpdateEnd = GetSysTime();
  UpdateCount++;
  UpdateTotals += (UpdateEnd - UpdateStart);
}
//*******************************************************************
inline dword TMWUpdateSum::GetUpdateAvg()
{
  return UpdateCount?(UpdateTotals / UpdateCount):0;
}
//*******************************************************************
inline void TMWUpdateSum::StartProcessRects()
{
  ProcessRectsStart = GetSysTime();
}
//*******************************************************************
inline void TMWUpdateSum::EndProcessRects()
{
  ProcessRectsEnd = GetSysTime();
  ProcessRectsCount++;
  ProcessRectsTotals += (ProcessRectsEnd - ProcessRectsStart);
}
//*******************************************************************
inline dword TMWUpdateSum::GetProcessRectsAvg()
{
  return ProcessRectsCount?(ProcessRectsTotals / ProcessRectsCount):0;
}
//*******************************************************************
inline void TMWUpdateSum::StartRenderBG()
{
  RenderBGStart = GetSysTime();
}
//*******************************************************************
inline void TMWUpdateSum::EndRenderBG()
{
  RenderBGEnd = GetSysTime();
  RenderBGCount++;
  RenderBGTotals += (RenderBGEnd - RenderBGStart);
}
//*******************************************************************
inline dword TMWUpdateSum::GetRenderBGAvg()
{
  return RenderBGCount?(RenderBGTotals / RenderBGCount):0;
}
//*******************************************************************
inline void TMWUpdateSum::StartRender()
{
  RenderStart = GetSysTime();
}
//*******************************************************************
inline void TMWUpdateSum::EndRender()
{
  RenderEnd = GetSysTime();
  RenderCount++;
  RenderTotals += (RenderEnd - RenderStart);
}
//*******************************************************************
inline dword TMWUpdateSum::GetRenderAvg()
{
  return RenderCount?(RenderTotals / RenderCount):0;
}
//*******************************************************************
inline void TMWUpdateSum::StartGrListSort()
{
  GrListSortStart = GetSysTime();
}
//*******************************************************************
inline void TMWUpdateSum::EndGrListSort()
{
  GrListSortEnd = GetSysTime();
  GrListSortCount++;
  GrListSortTotals += (GrListSortEnd - GrListSortStart);
}
//*******************************************************************
inline dword TMWUpdateSum::GetGrListSortAvg()
{
  return GrListSortCount?(GrListSortTotals / GrListSortCount):0;
}
//*******************************************************************
inline void TMWUpdateSum::StartBltTo()
{
  BltToStart = GetSysTime();
}
//*******************************************************************
inline void TMWUpdateSum::EndBltTo()
{
  BltToEnd = GetSysTime();
  BltToCount++;
  BltToTotals += (BltToEnd - BltToStart);
}
//*******************************************************************
inline dword TMWUpdateSum::GetBltToAvg()
{
  return BltToCount?(BltToTotals / BltToCount):0;
}
//*******************************************************************
inline void TMWUpdateSum::StartBltToSingle(const string &name,int16 framenum,int16 count)
{
  if (count >= NUMBLTTOSINGLES) {return;}
  BltToSingleNames[count] = name;
  BltToSingleFrameNums[count] = framenum;
  BltToSingleStart = GetSysTime();
}
//*******************************************************************
inline void TMWUpdateSum::EndBltToSingle(int16 count)
{
  if (count >= NUMBLTTOSINGLES) {return;}
  BltToSingleEnd = GetSysTime();
  BltToSingleTotals[count] = BltToSingleEnd - BltToSingleStart;
  BltToSingleLastCount = count;
}
//*******************************************************************
inline void TMWUpdateSum::StartGeneric1(string &name)
{
  Generic1Title = name;
  Generic1Start = GetSysTime();
}
//*******************************************************************
inline void TMWUpdateSum::EndGeneric1()
{
  Generic1End = GetSysTime();
  Generic1Count++;
  Generic1Totals += (Generic1End - Generic1Start);
}
//*******************************************************************
inline dword TMWUpdateSum::GetGeneric1Avg()
{
  return Generic1Count?(Generic1Totals / Generic1Count):0;
}
//*******************************************************************
inline void TMWUpdateSum::StartGeneric2(string &name)
{
  Generic2Title = name;
  Generic2Start = GetSysTime();
}
//*******************************************************************
inline void TMWUpdateSum::EndGeneric2()
{
  Generic2End = GetSysTime();
  Generic2Count++;
  Generic2Totals += (Generic2End - Generic2Start);
}
//*******************************************************************
inline dword TMWUpdateSum::GetGeneric2Avg()
{
  return Generic2Count?(Generic2Totals / Generic2Count):0;
}
//*******************************************************************
inline void TMWUpdateSum::SetCurGObjIndex(int16 gi)
{
  CurGI = gi;
  LastGI = gi;
}
//*******************************************************************
inline void TMWUpdateSum::StartUListWAL(int16 count,string &name)
{
  if (count >= NUMLISTWALS) {return;}
  UListWALNames[CurGI][count] = name;
  UListWALLastCount[CurGI] = count;
  UListWALCount[CurGI][count] += 1;
  LastUListWAL = count;
  UListWALStart = GetSysTime();
}
//*******************************************************************
inline void TMWUpdateSum::EndUListWAL(int16 count)
{
  if (count >= NUMLISTWALS) {return;}
  UListWALEnd = GetSysTime();
  UListWALTotals[CurGI][count] += (UListWALEnd - UListWALStart);
}
//*******************************************************************
inline dword TMWUpdateSum::GetUListWALAvg(int16 gi,int16 count)
{
  if (count >= NUMLISTWALS) {return 0;}
  if (gi >= NUMGOBJS) {return 0;}
  return UListWALCount[gi][count]?(UListWALTotals[gi][count] / UListWALCount[gi][count]):0;
}
//*******************************************************************
inline void TMWUpdateSum::StartPUListWAL(int16 count,string &name)
{
  if (count >= NUMLISTWALS) {return;}
  PUListWALNames[CurGI][count] = name;
  PUListWALLastCount[CurGI] = count;
  PUListWALCount[CurGI][count] += 1;
  LastPUListWAL = count;
  PUListWALStart = GetSysTime();
}
//*******************************************************************
inline void TMWUpdateSum::EndPUListWAL(int16 count)
{
  if (count >= NUMLISTWALS) {return;}
  PUListWALEnd = GetSysTime();
  PUListWALTotals[CurGI][count] += (PUListWALEnd - PUListWALStart);
}
//*******************************************************************
inline dword TMWUpdateSum::GetPUListWALAvg(int16 gi,int16 count)
{
  if (count >= NUMLISTWALS) {return 0;}
  if (gi >= NUMGOBJS) {return 0;}
  return PUListWALCount[gi][count]?(PUListWALTotals[gi][count] / PUListWALCount[gi][count]):0;
}
//*******************************************************************
inline void TMWUpdateSum::StartUActiveList()
{
  UActiveListStart = GetSysTime();
}
//*******************************************************************
inline void TMWUpdateSum::EndUActiveList()
{
  UActiveListCount[CurGI][LastUListWAL] += 1;
  UActiveListEnd = GetSysTime();
  UActiveListTotals[CurGI][LastUListWAL] += (UActiveListEnd - UActiveListStart);
}
//*******************************************************************
inline dword TMWUpdateSum::GetUActiveListAvg(int16 gi,int16 count)
{
  if (count >= NUMLISTWALS) {return 0;}
  if (gi >= NUMGOBJS) {return 0;}
  return UActiveListCount[gi][count]?(UActiveListTotals[gi][count] / UActiveListCount[gi][count]):0;
}
//*******************************************************************
inline void TMWUpdateSum::StartPUActiveList()
{
  PUActiveListStart = GetSysTime();
}
//*******************************************************************
inline void TMWUpdateSum::EndPUActiveList()
{
  PUActiveListCount[CurGI][LastPUListWAL] += 1;
  PUActiveListEnd = GetSysTime();
  PUActiveListTotals[CurGI][LastPUListWAL] += (PUActiveListEnd - PUActiveListStart);
}
//*******************************************************************
inline dword TMWUpdateSum::GetPUActiveListAvg(int16 gi,int16 count)
{
  if (count >= NUMLISTWALS) {return 0;}
  if (gi >= NUMGOBJS) {return 0;}
  return PUActiveListCount[gi][count]?(PUActiveListTotals[gi][count] / PUActiveListCount[gi][count]):0;
}
//*******************************************************************
inline void TMWUpdateSum::StartUActiveListIdles()
{
  UActiveListIdlesStart = GetSysTime();
}
//*******************************************************************
inline void TMWUpdateSum::EndUActiveListIdles()
{
  UActiveListIdlesCount[CurGI][LastUListWAL] += 1;
  UActiveListIdlesEnd = GetSysTime();
  UActiveListIdlesTotals[CurGI][LastUListWAL] += (UActiveListIdlesEnd - UActiveListIdlesStart);
}
//*******************************************************************
inline dword TMWUpdateSum::GetUActiveListIdlesAvg(int16 gi,int16 count)
{
  if (count >= NUMLISTWALS) {return 0;}
  if (gi >= NUMGOBJS) {return 0;}
  return UActiveListIdlesCount[gi][count]?(UActiveListIdlesTotals[gi][count] / UActiveListIdlesCount[gi][count]):0;
}
//*******************************************************************
inline void TMWUpdateSum::StartPUActiveListIdles()
{
  PUActiveListIdlesStart = GetSysTime();
}
//*******************************************************************
inline void TMWUpdateSum::EndPUActiveListIdles()
{
  PUActiveListIdlesCount[CurGI][LastPUListWAL] += 1;
  PUActiveListIdlesEnd = GetSysTime();
  PUActiveListIdlesTotals[CurGI][LastPUListWAL] += (PUActiveListIdlesEnd - PUActiveListIdlesStart);
}
//*******************************************************************
inline dword TMWUpdateSum::GetPUActiveListIdlesAvg(int16 gi,int16 count)
{
  if (count >= NUMLISTWALS) {return 0;}
  if (gi >= NUMGOBJS) {return 0;}
  return PUActiveListIdlesCount[gi][count]?(PUActiveListIdlesTotals[gi][count] / PUActiveListIdlesCount[gi][count]):0;
}
//*******************************************************************
inline void TMWUpdateSum::SetUActiveListNumElements(int16 num)
{
  UActiveListNumElements[CurGI][LastUListWAL] = num;
}
//*******************************************************************
inline int16 TMWUpdateSum::GetUActiveListNumElements(int16 gi,int16 count)
{
  if (gi >= NUMGOBJS) {return 0;}
  if (count >= NUMLISTWALS) {return 0;}
  return UActiveListNumElements[gi][count];
}
//*******************************************************************
inline void TMWUpdateSum::SetUActiveListHasGoing(bool going)
{
  UActiveListHasGoing[CurGI][LastUListWAL] = going;
}
//*******************************************************************
inline bool TMWUpdateSum::GetUActiveListHasGoing(int16 gi,int16 count)
{
  if (gi >= NUMGOBJS) {return false;}
  if (count >= NUMLISTWALS) {return false;}
  return UActiveListHasGoing[gi][count];
}
//*******************************************************************
inline void TMWUpdateSum::SetPUActiveListNumElements(int16 num)
{
  PUActiveListNumElements[CurGI][LastPUListWAL] = num;
}
//*******************************************************************
inline int16 TMWUpdateSum::GetPUActiveListNumElements(int16 gi,int16 count)
{
  if (gi >= NUMGOBJS) {return 0;}
  if (count >= NUMLISTWALS) {return 0;}
  return PUActiveListNumElements[gi][count];
}
//*******************************************************************
inline void TMWUpdateSum::StartSpriteStart(int16 spritetype)
{
  if (spritetype >= NUMLISTWALS) {return;}
  LastSpriteType[CurGI] = spritetype; // used by anm timing code.
  SpriteStartStart = GetSysTime();
}
//*******************************************************************
inline void TMWUpdateSum::EndSpriteStart(int16 spritetype)
{
  if (spritetype >= NUMLISTWALS) {return;}
  SpriteStartCount[CurGI][spritetype] += 1;
  SpriteStartEnd = GetSysTime();
  SpriteStartTotals[CurGI][spritetype] += (SpriteStartEnd - SpriteStartStart);
}
//*******************************************************************
inline dword TMWUpdateSum::GetSpriteStartAvg(int16 gi,int16 spritetype)
{
  if (gi >= NUMGOBJS) {return 0;}
  if (spritetype >= NUMLISTWALS) {return 0;}
  return SpriteStartCount[gi][spritetype]?(SpriteStartTotals[gi][spritetype] / SpriteStartCount[gi][spritetype]):0;
}
//*******************************************************************
inline dword TMWUpdateSum::GetSpriteStartTotals(int16 gi,int16 spritetype)
{
  if (gi >= NUMGOBJS) {return 0;}
  if (spritetype >= NUMLISTWALS) {return 0;}
  return SpriteStartTotals[gi][spritetype];
}
//*******************************************************************
inline dword TMWUpdateSum::GetSpriteStartCount(int16 gi,int16 spritetype)
{
  if (gi >= NUMGOBJS) {return 0;}
  if (spritetype >= NUMLISTWALS) {return 0;}
  return SpriteStartCount[gi][spritetype];
}
//*******************************************************************
inline void TMWUpdateSum::StartSpriteUpdate(int16 spritetype)
{
  if (spritetype >= NUMLISTWALS) {return;}
  LastSpriteType[CurGI] = spritetype;
  SpriteUpdateStart = GetSysTime();
}
//*******************************************************************
inline void TMWUpdateSum::EndSpriteUpdate(int16 spritetype)
{
  if (spritetype >= NUMLISTWALS) {return;}
  SpriteUpdateCount[CurGI][spritetype] += 1;
  SpriteUpdateEnd = GetSysTime();
  SpriteUpdateTotals[CurGI][spritetype] += (SpriteUpdateEnd - SpriteUpdateStart);
}
//*******************************************************************
inline dword TMWUpdateSum::GetSpriteUpdateAvg(int16 gi,int16 spritetype)
{
  if (gi >= NUMGOBJS) {return 0;}
  if (spritetype >= NUMLISTWALS) {return 0;}
  return SpriteUpdateCount[gi][spritetype]?(SpriteUpdateTotals[gi][spritetype] / SpriteUpdateCount[gi][spritetype]):0;
}
//*******************************************************************
inline dword TMWUpdateSum::GetSpriteUpdateCount(int16 gi,int16 spritetype)
{
  if (gi >= NUMGOBJS) {return 0;}
  if (spritetype >= NUMLISTWALS) {return 0;}
  return SpriteUpdateCount[gi][spritetype];
}
//*******************************************************************
inline dword TMWUpdateSum::GetSpriteUpdateTotals(int16 gi,int16 spritetype)
{
  if (gi >= NUMGOBJS) {return 0;}
  if (spritetype >= NUMLISTWALS) {return 0;}
  return SpriteUpdateTotals[gi][spritetype];
}
//*******************************************************************
inline void TMWUpdateSum::StartSpritePUpdate(int16 spritetype)
{
  LastSpriteType[CurGI] = spritetype;
  SpritePUpdateStart = GetSysTime();
}
//*******************************************************************
inline void TMWUpdateSum::EndSpritePUpdate(int16 spritetype)
{
  SpritePUpdateEnd = GetSysTime();
  SpritePUpdateCount[CurGI][spritetype] += 1;
  SpritePUpdateTotals[CurGI][spritetype] += (SpritePUpdateEnd - SpritePUpdateStart);
}
//*******************************************************************
inline dword TMWUpdateSum::GetSpritePUpdateAvg(int16 gi,int16 spritetype)
{
  if (gi >= NUMGOBJS) {return 0;}
  if (spritetype >= NUMLISTWALS) {return 0;}
  return SpritePUpdateCount[gi][spritetype]?(SpritePUpdateTotals[gi][spritetype] / SpritePUpdateCount[gi][spritetype]):0;
}
//*******************************************************************
inline dword TMWUpdateSum::GetSpritePUpdateCount(int16 gi,int16 spritetype)
{
  if (gi >= NUMGOBJS) {return 0;}
  if (spritetype >= NUMLISTWALS) {return 0;}
  return SpritePUpdateCount[gi][spritetype];
}
//*******************************************************************
inline dword TMWUpdateSum::GetSpritePUpdateTotals(int16 gi,int16 spritetype)
{
  if (gi >= NUMGOBJS) {return 0;}
  if (spritetype >= NUMLISTWALS) {return 0;}
  return SpritePUpdateTotals[gi][spritetype];
}
//*******************************************************************
inline void TMWUpdateSum::StartAnmStart()
{
  AnmStartStart = GetSysTime();
}
//*******************************************************************
inline void TMWUpdateSum::EndAnmStart()
{
  AnmStartEnd = GetSysTime();
  int16 st = LastSpriteType[CurGI];
  AnmStartCount[CurGI][st] += 1;
  AnmStartTotals[CurGI][st] += (AnmStartEnd - AnmStartStart);
}
//*******************************************************************
inline dword TMWUpdateSum::GetAnmStartAvg(int16 gi,int16 spritetype)
{
  if (gi >= NUMGOBJS) {return 0;}
  if (spritetype >= NUMLISTWALS) {return 0;}
  return AnmStartCount[gi][spritetype]?(AnmStartTotals[gi][spritetype] / AnmStartCount[gi][spritetype]):0;
}
//*******************************************************************
inline dword TMWUpdateSum::GetAnmStartCount(int16 gi,int16 spritetype)
{
  if (gi >= NUMGOBJS) {return 0;}
  if (spritetype >= NUMLISTWALS) {return 0;}
  return AnmStartCount[gi][spritetype];
}
//*******************************************************************
inline dword TMWUpdateSum::GetAnmStartTotals(int16 gi,int16 spritetype)
{
  if (gi >= NUMGOBJS) {return 0;}
  if (spritetype >= NUMLISTWALS) {return 0;}
  return AnmStartTotals[gi][spritetype];
}
//*******************************************************************
inline void TMWUpdateSum::StartAnmUpdate()
{
  AnmUpdateStart = GetSysTime();
}
//*******************************************************************
inline void TMWUpdateSum::EndAnmUpdate()
{
  AnmUpdateEnd = GetSysTime();
  int16 st = LastSpriteType[CurGI];
  AnmUpdateCount[CurGI][st] += 1;
  AnmUpdateTotals[CurGI][st] += (AnmUpdateEnd - AnmUpdateStart);
}
//*******************************************************************
inline dword TMWUpdateSum::GetAnmUpdateAvg(int16 gi,int16 spritetype)
{
  if (gi >= NUMGOBJS) {return 0;}
  if (spritetype >= NUMLISTWALS) {return 0;}
  return AnmUpdateCount[gi][spritetype]?(AnmUpdateTotals[gi][spritetype] / AnmUpdateCount[gi][spritetype]):0;
}
//*******************************************************************
inline dword TMWUpdateSum::GetAnmUpdateCount(int16 gi,int16 spritetype)
{
  if (gi >= NUMGOBJS) {return 0;}
  if (spritetype >= NUMLISTWALS) {return 0;}
  return AnmUpdateCount[gi][spritetype];
}
//*******************************************************************
inline dword TMWUpdateSum::GetAnmUpdateTotals(int16 gi,int16 spritetype)
{
  if (gi >= NUMGOBJS) {return 0;}
  if (spritetype >= NUMLISTWALS) {return 0;}
  return AnmUpdateTotals[gi][spritetype];
}
//*******************************************************************
inline void TMWUpdateSum::StartAnmPUpdate()
{
  AnmPUpdateStart = GetSysTime();
}
//*******************************************************************
inline void TMWUpdateSum::EndAnmPUpdate()
{
  AnmPUpdateEnd = GetSysTime();
  int16 st = LastSpriteType[CurGI];
  AnmPUpdateCount[CurGI][st] += 1;
  AnmPUpdateTotals[CurGI][st] += (AnmPUpdateEnd - AnmPUpdateStart);
}
//*******************************************************************
inline dword TMWUpdateSum::GetAnmPUpdateAvg(int16 gi,int16 spritetype)
{
  if (gi >= NUMGOBJS) {return 0;}
  if (spritetype >= NUMLISTWALS) {return 0;}
  return AnmPUpdateCount[gi][spritetype]?(AnmPUpdateTotals[gi][spritetype] / AnmPUpdateCount[gi][spritetype]):0;
}
//*******************************************************************
inline dword TMWUpdateSum::GetAnmPUpdateCount(int16 gi,int16 spritetype)
{
  if (gi >= NUMGOBJS) {return 0;}
  if (spritetype >= NUMLISTWALS) {return 0;}
  return AnmPUpdateCount[gi][spritetype];
}
//*******************************************************************
inline dword TMWUpdateSum::GetAnmPUpdateTotals(int16 gi,int16 spritetype)
{
  if (gi >= NUMGOBJS) {return 0;}
  if (spritetype >= NUMLISTWALS) {return 0;}
  return AnmPUpdateTotals[gi][spritetype];
}
//*******************************************************************
inline void TMWUpdateSum::StartWavStart()
{
  WavStartStart = GetSysTime();
}
//*******************************************************************
inline void TMWUpdateSum::EndWavStart()
{
  WavStartEnd = GetSysTime();
  int16 st = LastSpriteType[CurGI];
  WavStartCount[CurGI][st] += 1;
  WavStartTotals[CurGI][st] += (WavStartEnd - WavStartStart);
}
//*******************************************************************
inline dword TMWUpdateSum::GetWavStartAvg(int16 gi,int16 spritetype)
{
  if (gi >= NUMGOBJS) {return 0;}
  if (spritetype >= NUMLISTWALS) {return 0;}
  return WavStartCount[gi][spritetype]?(WavStartTotals[gi][spritetype] / WavStartCount[gi][spritetype]):0;
}
//*******************************************************************
inline dword TMWUpdateSum::GetWavStartCount(int16 gi,int16 spritetype)
{
  if (gi >= NUMGOBJS) {return 0;}
  if (spritetype >= NUMLISTWALS) {return 0;}
  return WavStartCount[gi][spritetype];
}
//*******************************************************************
inline dword TMWUpdateSum::GetWavStartTotals(int16 gi,int16 spritetype)
{
  if (gi >= NUMGOBJS) {return 0;}
  if (spritetype >= NUMLISTWALS) {return 0;}
  return WavStartTotals[gi][spritetype];
}
//*******************************************************************
inline void TMWUpdateSum::StartWavUpdate()
{
  WavUpdateStart = GetSysTime();
}
//*******************************************************************
inline void TMWUpdateSum::EndWavUpdate()
{
  WavUpdateEnd = GetSysTime();
  int16 st = LastSpriteType[CurGI];
  WavUpdateCount[CurGI][st] += 1;
  WavUpdateTotals[CurGI][st] += (WavUpdateEnd - WavUpdateStart);
}
//*******************************************************************
inline dword TMWUpdateSum::GetWavUpdateAvg(int16 gi,int16 spritetype)
{
  if (gi >= NUMGOBJS) {return 0;}
  if (spritetype >= NUMLISTWALS) {return 0;}
  return WavUpdateCount[gi][spritetype]?(WavUpdateTotals[gi][spritetype] / WavUpdateCount[gi][spritetype]):0;
}
//*******************************************************************
inline dword TMWUpdateSum::GetWavUpdateCount(int16 gi,int16 spritetype)
{
  if (gi >= NUMGOBJS) {return 0;}
  if (spritetype >= NUMLISTWALS) {return 0;}
  return WavUpdateCount[gi][spritetype];
}
//*******************************************************************
inline dword TMWUpdateSum::GetWavUpdateTotals(int16 gi,int16 spritetype)
{
  if (gi >= NUMGOBJS) {return 0;}
  if (spritetype >= NUMLISTWALS) {return 0;}
  return WavUpdateTotals[gi][spritetype];
}
//*******************************************************************
inline void TMWUpdateSum::StartWavPUpdate()
{
  WavPUpdateStart = GetSysTime();
}
//*******************************************************************
inline void TMWUpdateSum::EndWavPUpdate()
{
  WavPUpdateEnd = GetSysTime();
  int16 st = LastSpriteType[CurGI];
  WavPUpdateCount[CurGI][st] += 1;
  WavPUpdateTotals[CurGI][st] += (WavPUpdateEnd - WavPUpdateStart);
}
//*******************************************************************
inline dword TMWUpdateSum::GetWavPUpdateAvg(int16 gi,int16 spritetype)
{
  if (gi >= NUMGOBJS) {return 0;}
  if (spritetype >= NUMLISTWALS) {return 0;}
  return WavPUpdateCount[gi][spritetype]?(WavPUpdateTotals[gi][spritetype] / WavPUpdateCount[gi][spritetype]):0;
}
//*******************************************************************
inline dword TMWUpdateSum::GetWavPUpdateCount(int16 gi,int16 spritetype)
{
  if (gi >= NUMGOBJS) {return 0;}
  if (spritetype >= NUMLISTWALS) {return 0;}
  return WavPUpdateCount[gi][spritetype];
}
//*******************************************************************
inline dword TMWUpdateSum::GetWavPUpdateTotals(int16 gi,int16 spritetype)
{
  if (gi >= NUMGOBJS) {return 0;}
  if (spritetype >= NUMLISTWALS) {return 0;}
  return WavPUpdateTotals[gi][spritetype];
}
//*******************************************************************
inline void TMWUpdateSum::StartKey()
{
  KeyStart = GetSysTime();
}
//*******************************************************************
inline void TMWUpdateSum::EndKey()
{
  KeyEnd = GetSysTime();
  KeyCount++;
  KeyTotals += (KeyEnd - KeyStart);
}
//*******************************************************************
inline dword TMWUpdateSum::GetKeyAvg()
{
  return KeyCount?(KeyTotals / KeyCount):0;
}
//*******************************************************************
inline dword TMWUpdateSum::GetKeyCount()
{
  return KeyCount;
}
//*******************************************************************
inline dword TMWUpdateSum::GetKeyTotals()
{
  return KeyTotals;
}
//*******************************************************************
inline void TMWUpdateSum::StartMouse()
{
  MouseStart = GetSysTime();
}
//*******************************************************************
inline void TMWUpdateSum::EndMouse()
{
  MouseEnd = GetSysTime();
  MouseCount++;
  MouseTotals += (MouseEnd - MouseStart);
}
//*******************************************************************
inline dword TMWUpdateSum::GetMouseAvg()
{
  return MouseCount?(MouseTotals / MouseCount):0;
}
//*******************************************************************
inline dword TMWUpdateSum::GetMouseCount()
{
  return MouseCount;
}
//*******************************************************************
inline dword TMWUpdateSum::GetMouseTotals()
{
  return MouseTotals;
}
//*******************************************************************
inline void TMWUpdateSum::StartArea()
{
  AreaStart = GetSysTime();
}
//*******************************************************************
inline void TMWUpdateSum::EndArea()
{
  AreaEnd = GetSysTime();
  AreaCount++;
  AreaTotals += (AreaEnd - AreaStart);
}
//*******************************************************************
inline dword TMWUpdateSum::GetAreaAvg()
{
  return AreaCount?(AreaTotals / AreaCount):0;
}
//*******************************************************************
inline dword TMWUpdateSum::GetAreaCount()
{
  return AreaCount;
}
//*******************************************************************
inline dword TMWUpdateSum::GetAreaTotals()
{
  return AreaTotals;
}
//*******************************************************************
#endif

