//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  oversion.h
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  2.3    08/05/99   M.Perry     baseline
//********************************************************************
#if !defined(__oversion_h)
#define __oversion_h

#if !defined(__ogle_h)
#include "ogle.h"
#endif
//*******************************************************************
class TOVersion
{
public:
  enum {MAJVER_DEF = OGLE_VER_MAJ,MINVER_DEF = OGLE_VER_MIN};
  word MajVer;
  word MinVer;
  TOVersion(const TOVersion &ov);
  TOVersion(const word majver = MAJVER_DEF,const word minver = MINVER_DEF);
//  TOVersion(const double d);
  ~TOVersion();
//  void Assign(const double d);
  void Assign(const TOVersion &ov);
  bool IsEqual(const TOVersion &ov) const;
//  bool IsEqual(const double d) const;
  bool operator==(const TOVersion &ov) const;
  bool operator!=(const TOVersion &ov) const;
//  bool operator==(const double d) const;
//  bool operator!=(const double d) const;
  TOVersion &operator=(const TOVersion &ov);
};
//*******************************************************************
//************************** inlines ********************************
//*******************************************************************
inline TOVersion::TOVersion(const TOVersion &ov)
:MajVer(ov.MajVer),
 MinVer(ov.MinVer)
{
}
//*******************************************************************
inline TOVersion::TOVersion(const word majver,const word minver)
:MajVer(majver),
 MinVer(minver)
{
}
//*******************************************************************
//inline TOVersion::TOVersion(const double d)
//:MajVer(0),
// MinVer(0)
//{
//  Assign(d);
//}
//*******************************************************************
inline TOVersion::~TOVersion()
{
}
//*******************************************************************
//inline void TOVersion::Assign(const double d)
//{
//  MajVer = uint16(d);
//  double dtemp = double(d - uint16(d));
//  MinVer = uint16(uint16(double(dtemp * 100.0)) / 10); // grab 1st digit after dec for minver.
//}
//*******************************************************************
inline void TOVersion::Assign(const TOVersion &ov)
{
  if (&ov == this) {return;}
  MajVer = ov.MajVer;
  MinVer = ov.MinVer;
}
//*******************************************************************
inline bool TOVersion::IsEqual(const TOVersion &ov) const
{
  if (&ov == this) {return true;}
  if (MajVer == ov.MajVer && MinVer == ov.MinVer) {return true;}
  return false;
}
//*******************************************************************
//inline bool TOVersion::IsEqual(const double d) const
//{
//  TOVersion ov(d);
//  return bool(ov == *this);
//}
//*******************************************************************
inline bool TOVersion::operator==(const TOVersion &ov) const
{
  return IsEqual(ov);
}
//*******************************************************************
//inline bool TOVersion::operator==(const double d) const
//{
//  return IsEqual(d);
//}
//*******************************************************************
inline bool TOVersion::operator!=(const TOVersion &ov) const
{
  return !IsEqual(ov);
}
//*******************************************************************
//inline bool TOVersion::operator!=(const double d) const
//{
// return !IsEqual(d);
//}
//*******************************************************************
inline TOVersion &TOVersion::operator=(const TOVersion &ov)
{
  Assign(ov);
  return *this;
}
//*******************************************************************
#endif