//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  owav.h       
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0      5/15/95   M.Perry     original baseline
//  2.0      8/23/97   M.Perry     32-bit conversion.
//********************************************************************
#if !defined(__owav_h)
#define __owav_h

#if !defined(__osound_h)
#include "osound.h"
#endif

#if !defined(__oobj_h)
#include "oobj.h"
#endif

#ifdef DEBUGREPORTS
  #include <iostream.h>
  #include <fstream.h>
#elif DEBUGSPRITES
  #include <iostream.h>
  #include <fstream.h>
#endif

#define owavFIRST ((WORD)(osndLAST * 2))
#define owavCLIPEND (owavFIRST)
#define owavWLNOTIFIEDSTARTSCHEDULED ((WORD)(owavCLIPEND * 2))
#define owavLAST (owavWLNOTIFIEDSTARTSCHEDULED)

class TOgleSoundMgr;
class TWavList;
//*******************************************************************
class TWav:public TSound
{
public:
  TWavList *PWavList;  // set when added to TWavList.

  bool GetClipEnd();
  void SetClipEnd();
  void ClearClipEnd();

  bool GetWLNotifiedStartScheduled();
  void SetWLNotifiedStartScheduled();
  void ClearWLNotifiedStartScheduled();

  void WLNotifyStart();
  void WLNotifyStop();

  int16 LoopCount;
  TOgleObj *PSndMgrData;  // only to be used by SoundMgr.
                          // set by PSoundMgr()->Register,
                          // cleared by PSoundMgr()->UnRegister;

  #ifdef DEBUGREPORTS
  void Report(ofstream &os);
  #endif

  #ifdef DEBUGSPRITES
  void RTReport(ofstream &os);
  #endif

  TWav(TOgleModeWindow *pmw);
  TWav(TOgleModeWindow *pmw,
       const TFileMode &NewFileMode,int16 NewFUCLength = 0,
       bool AutoRead = false,bool KeepBaseFile = true);
  virtual ~TWav();
  virtual string AddExt();
  virtual void Update(dword NewFUC);
  virtual void PostUpdate(dword NewFUC);
  bool Play();
  virtual void Start(dword StartFUC);
  virtual void Start();
  virtual void Stop();
  void NotifyStop(); // called by sndmgr.
  virtual void Activate(dword StartFUC = 0);
  virtual void DeActivate();
  bool operator==(const TWav& wav) const;
  bool AddToSndMgr();
  bool RemoveFromSndMgr();
  static dword GetEstimateFUCLength(int32 filesize,int32 samplerate = 11025,
                                    int32 framerate = 6)
  {
    return dword((filesize / (samplerate / framerate)) + 1);
  }
};
//*******************************************************************
//************************ inlines **********************************
//*******************************************************************
inline bool TWav::Play()
{
  Start();
  return true;
}
//*******************************************************************
inline bool TWav::GetClipEnd()
{
  return StatFlags.IsSet(owavCLIPEND);
}
//*******************************************************************
inline void TWav::SetClipEnd()
{
  StatFlags.Set(owavCLIPEND);
}
//*******************************************************************
inline void TWav::ClearClipEnd()
{
  StatFlags.Clear(owavCLIPEND);
}
//*******************************************************************
inline bool TWav::GetWLNotifiedStartScheduled()
{
  return StatFlags.IsSet(owavWLNOTIFIEDSTARTSCHEDULED);
}
//*******************************************************************
inline void TWav::SetWLNotifiedStartScheduled()
{
  StatFlags.Set(owavWLNOTIFIEDSTARTSCHEDULED);
}
//*******************************************************************
inline void TWav::ClearWLNotifiedStartScheduled()
{
  StatFlags.Clear(owavWLNOTIFIEDSTARTSCHEDULED);
}
//*******************************************************************
#endif

