//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  owavlst.h
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     6/20/95    M.Perry    original baseline
//  2.0     8/23/97    M.Perry    32-bit conversion.
//********************************************************************
#if !defined(__owavlst_h) 
#define __owavlst_h

#if !defined(__olist_h)
#include "olist.h"
#endif

#if defined(DEBUGREPORTS) || defined(DEBUGSPRITES)
  #include <iostream.h>
  #include <fstream.h>
#endif

class TSprite;
class TWav;
//*******************************************************************
class TWavList:public TOgleList
{
public:
  TSprite *PSprite;
  #ifdef DEBUGREPORTS
  void Report(ofstream &os);
  #endif
  #ifdef DEBUGSPRITES
  void RTReport(ofstream &os);
  #endif
  TWavList(TOgleModeWindow *pmw,TSprite *psprite);
  virtual ~TWavList();
  bool AddWav(TFileMode NewFileMode,int16 NewFUCLength = -1);
  bool AddWav(TWav *PNewWav);
  virtual void Start(dword StartFUC);
  virtual void Start();
//  dword GetLastFUC();

  TWav *GetWavPtr(int16 WavIndex);
  TWav *GetWavPtr(string &WavFName);
  int16 GetWavIndex(string &WavFName);

  void NotifyStart(TWav *pwav);
  void NotifyStop(TWav *pwav);
protected:
  word NotifyRef;
  void SpriteNotifyStop();
};
//*******************************************************************
//************************ inlines **********************************
//*******************************************************************
inline TWav *TWavList::GetWavPtr(int16 WavIndex)
{
  return ((TWav *)GetElementPtr(WavIndex));
}
//*******************************************************************
inline TWav *TWavList::GetWavPtr(string &WavFName)
{
  return ((TWav *)GetElementPtr(WavFName));
}
//*******************************************************************
inline int16 TWavList::GetWavIndex(string &WavFName)
{
  return GetElementIndex(WavFName);
}
//*******************************************************************
inline void TWavList::NotifyStart(TWav *pwav)
// this gets called every time a wav in the list starts up.
{
  NotifyRef++;
  // the following added for Adam's startsound(offset),which needs to
  // get the wavlist turned back on.
  SetStarted();
  ClearStopped();
}
//*******************************************************************
inline void TWavList::NotifyStop(TWav *pwav)
{
  if (NotifyRef > 0) {NotifyRef--;}
  if (NotifyRef == 0)
  {
    SetStopped();
    SpriteNotifyStop();
  }
}
//*******************************************************************
#endif
                             
