//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  owmixdll.h
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     11/6/96    M.Perry    original baseline
//  2.0     8/23/97    M.Perry    32-bit conversion.
//********************************************************************
#if !defined(__owmixdll_h)
#define __owmixdll_h

#if !defined(__odll_h)
#include "odll.h"
#endif

#if !defined(__wavemix_h)
#include "wavemix.h"
#endif
//*******************************************************************
// typedefs
typedef word (WINAPI *wavemixgetinfo)(LPWAVEMIXINFO lpWaveMixInfo);
typedef HANDLE (WINAPI *wavemixinit)(void);
typedef HANDLE (WINAPI *wavemixconfigureinit)(LPMIXCONFIG lpConfig);
typedef uint (WINAPI *wavemixactivate)(HANDLE hMixSession,BOOL fActivate);
typedef LPMIXWAVE (WINAPI *wavemixopenwave)(HANDLE hMixSession,LPSTR szWaveFilename,HINSTANCE hInst,dword dwFlags);
typedef uint (WINAPI *wavemixopenchannel)(HANDLE hMixSession,int iChannel,dword dwFlags);
typedef uint (WINAPI *wavemixplay)(LPMIXPLAYPARAMS lpMixPlayParams);
typedef uint (WINAPI *wavemixflushchannel)(HANDLE hMixSession,int iChannel,dword dwFlags);
typedef uint (WINAPI *wavemixclosechannel)(HANDLE hMixSession,int iChannel,dword dwFlags);
typedef uint (WINAPI *wavemixfreewave)(HANDLE HMixSession,LPMIXWAVE lpMixWave);
typedef uint (WINAPI *wavemixclosesession)(HANDLE hMixSession);
typedef void (WINAPI *wavemixpump)(void);
//*******************************************************************
class TWaveMix:public TOgleDll
{
protected:
  static TWaveMix *PWaveMix;
  TWaveMix();
  virtual ~TWaveMix();

public:
  static TWaveMix *Dll() {return PWaveMix;}
  static bool LoadDll();
  static bool UnLoadDll(bool ignoreref = false);

  virtual bool SetupProcs();
  virtual bool CleanupProcs();

  // function ptrs.
  wavemixgetinfo GetInfo;
  wavemixinit Init;
  wavemixconfigureinit ConfigureInit;
  wavemixactivate Activate;
  wavemixopenwave OpenWave;
  wavemixopenchannel OpenChannel;
  wavemixplay Play;
  wavemixflushchannel FlushChannel;
  wavemixclosechannel CloseChannel;
  wavemixfreewave FreeWave;
  wavemixclosesession CloseSession;
  wavemixpump Pump;
};
//*******************************************************************
#endif
