 //********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name: obase.cpp
//    Project Name: Ogle
// Original Author: Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     3/6/95     M.Perry     original baseline
//********************************************************************
#if !defined(__obase_h)
#include "obase.h"
#endif

#include <assert.h>

#if !defined(__omodewin_h)
#include "omodewin.h"
#endif

#if !defined(__oapp_h)
#include "oapp.h"
#endif

#if !defined(__ofilemgr_h)
#include "ofilemgr.h"
#endif

#if !defined(__ofile_h)
#include "ofile.h"
#endif

#if !defined(__STDLIB_H)
#include <stdlib.h>
#endif

#define BASE_STR "Base Class"
DIAG_DEFINE_GROUP(Base,1,0);

#ifdef DEBUG_BASECOUNT
int32 TOgleBase::basecount = 0;
#endif
//string TOgleBase::strGEmpty = "";
//*******************************************************************
void TOgleBase::FatalError(const string &msg,const string &title)
{
  ::MessageBox(NULL,msg.c_str(),title.c_str(),MB_OK|MB_TASKMODAL);
  exit(EXIT_FAILURE);
}
//*******************************************************************
void TOgleBase::TimeChanged()
{
  // Placeholder.
}
//*******************************************************************
void TOgleBase::SetIndexes()
{
  //virtual.
}
//*******************************************************************
void TOgleBase::Slenderize()
{
  // do nothing.
}
//*******************************************************************
//TOgleApp *TOgleBase::FindOgleApp(bool fatal)
//{
//  if (PModeWin != NULL) {return PModeWin->GetOgleApp(fatal);}
//  return TOgleApp::GetOgleApp(fatal);
//}
//*******************************************************************
dword TOgleBase::GetFUC() const
{
  if (PModeWin == NULL) {return 0;}
  return PModeWin->GetFUC();
}
//*******************************************************************
dword TOgleBase::GetAdjFUC() const
{
  if (PModeWin == NULL) {return 0;}
  return PModeWin->GetAdjFUC();
}
//*******************************************************************
#pragma argsused
bool TOgleBase::Respond(TResponder &responder)
{
  return false;
}
//*******************************************************************
#pragma argsused
bool TOgleBase::Respond(int16 id,int16 info,void *pdata)
{
  return false;
}
//*******************************************************************
#pragma argsused
void TOgleBase::Update(dword NewFUC)
{
}
//*******************************************************************
#pragma argsused
void TOgleBase::PostUpdate(dword NewFUC)
{
}
//*******************************************************************
bool TOgleBase::ReadLocal()
{
  return true;
}
//*******************************************************************
bool TOgleBase::WriteLocal()
{
  return false;
}
//*******************************************************************
int32 TOgleBase::GetSizeofData()
{
  return 0;
}
//*******************************************************************
bool TOgleBase::Save()
{
  return true;
}
//*******************************************************************
string TOgleBase::AddExt()
{
  return string(".bas");
}
//*******************************************************************
void TOgleBase::SetMajVer()
{
  MajVer = 1;
}
//*******************************************************************
void TOgleBase::SetMinVer()
{
  MinVer = 0;
}
//*******************************************************************
const char *TOgleBase::GetIDChars() const
{
  return "OGLE";
}
//*******************************************************************
string TOgleBase::GetResString(uint id)
{
  return GetOgleApp()->LoadString(id);
}
//*******************************************************************
bool TOgleBase::WriteError(char *descr,int errnum)
{
  string s = descr;
  s += "\nError Type:\n";

  switch (errnum)
  {
    case weInvalidHFILE: s += "Invalid file handle";break;
    case weOpen:         s += "Couldn't open file";break;
    case weHeader:       s += "Couldn't write local header";break;
    case weLocal:        s += "Couldn't write local data";break;
    case weClose:        s += "Couldn't close file";break;
    case weWriteData:    s += "Couldn't write data";break;
    default:             s += "Unknown error";break;
  }
  s += "\nAborting";
//  ::MessageBox(NULL,s.c_str(),"Error - Write",MB_OK|MB_TASKMODAL);
//  abort();
  FatalError(s,string("Error -  Write"));
  return false;
}
//*******************************************************************
bool TOgleBase::IDOk()
{
  const char *pchar = GetIDChars();
  for (int i=0;i<IDNAMESIZE;i++)
  {
    if (IDChars[i] != pchar[i]) {return false;}
  }
  return true;
}
//*******************************************************************
bool TOgleBase::HeaderError()
{
  char temp[IDNAMESIZE + 1];
  for (int i=0;i<IDNAMESIZE;i++)
  {
    temp[i] = IDChars[i];
  }
  temp[IDNAMESIZE] = '\0';
  string msg = "Header ID read: '";
  msg += temp;
  msg += "'";
  msg += "\nHeader ID needed: '";
  const char *pchar = GetIDChars();
  for (int j=0;j<IDNAMESIZE;j++)
  {
    msg += pchar[j];
  }
  msg += '\0';
  msg += "'";
//  msg += "\nObject being read: " + GetBaseName();
  msg += "\nObject being read: " + FileMode.Name.GetStr();
  msg += "\nAborting Program";
  FatalError(msg,string("Fatal Error - Header ID"));
//  ::MessageBox(NULL,msg.c_str(),"Error - Header ID",MB_OK|MB_TASKMODAL);
//  exit(EXIT_FAILURE);
  return false;
}
//*******************************************************************
void TOgleBase::VerError(word majver,word minver,word badmajver,word badminver)
{
  if (majver == badmajver && minver == badminver) {return;}

  char buffer[33];
  string msg = "MajVer needed: ";
  itoa(majver,buffer,10);
  msg += buffer;
  msg += " ,MajVer read: ";
  itoa(badmajver,buffer,10);
  msg += buffer;
  msg += "\nMinVer needed: ";
  itoa(minver,buffer,10);
  msg += buffer;
  msg += " ,MinVer read: ";
  itoa(badminver,buffer,10);
  msg += buffer;
//  msg += "\nObject being read: " + GetBaseName();
  msg += "\nObject being read: " + FileMode.Name.GetStr();
  msg += "\nAborting Program";
  FatalError(msg,string("Fatal Error - Object Version"));
//  ::MessageBox(NULL,msg.c_str(),"Error - Object Version",MB_OK|MB_TASKMODAL);
//  exit(EXIT_FAILURE);
}
//*******************************************************************
//bool TOgleBase::SetBaseName(string NewBaseName)
//{
//  if (PBaseFile != NULL) {return false;}
//  SetFName(NewBaseName);   // MRP 12/12/96
//  FileMode.Name = NewBaseName + AddExt();
//  return true;
//}
//*******************************************************************
#pragma argsused
void TOgleBase::Start(dword StartFUC)
{
  Start();
}
//*******************************************************************
void TOgleBase::Start()
{
  SetStarted();
  ClearStopped();
}
//*******************************************************************
void TOgleBase::Stop()
{
  SetStopped();
}
//*******************************************************************
int16 TOgleBase::SetType(int16 NewType)
{
  int16 TempType = WhatType;
  WhatType = NewType;
  return TempType;
}
//*******************************************************************
int16 TOgleBase::GetType() const
{
  return WhatType;
}
//*******************************************************************
void TOgleBase::Show()
{
  SetShowing();
}
//*******************************************************************
void TOgleBase::NoShow()
{
  ClearShowing();
}
//*******************************************************************
bool TOgleBase::IsShowing() const
{
  return StatFlags.IsSet(obSHOWING);
}
//*******************************************************************
#pragma argsused
void TOgleBase::Activate(dword StartFUC)
{
  IncActiveCount();
}
//*******************************************************************
void TOgleBase::DeActivate()
{
  DecActiveCount();
}
//*******************************************************************
void TOgleBase::CopyIDChars(const char *pchars)
{
  for (int i=0;i<IDNAMESIZE;i++)
  {
    IDChars[i] = pchars[i];
  }
}
//*******************************************************************
//string TOgleBase::GetFName() const
//{
//  string str = FileMode.Name;
//  size_t periodpos = str.find_first_of(".");
//  if (periodpos < str.length())
//  {
//    str.resize(periodpos);
//  }
//  return str;
//}
//*******************************************************************
int32 TOgleBase::ReadData(void *PDest,int32 NumBytes)
{
  byte huge *PS;
  byte huge *PD = (byte *)PDest;

  if (PExternal == NULL) {PS = (byte huge *)GetRamPtr();}
  else {PS = (byte huge *)PExternal;}

  if ((PS == NULL) || (PD == NULL)) {return 0;}

  PS += FileOffset;

  hmemcpy(PD,PS,NumBytes);

  FileOffset += NumBytes;

  return NumBytes;
}
//*******************************************************************
//bool TOgleBase::ReadFileNameString(string &Str)
bool TOgleBase::ReadFNameString(string &str)
{
//  char FileName[FILENAMESIZE];
  char FileName[FNAME_SIZE];
  if (!ReadFNameChars(FileName)) {return false;}
  str = FileName;
  #ifdef GED_COMPILE
  str.to_lower();
  #endif
  return true;
}
//*******************************************************************
//bool TOgleBase::WriteFileNameString(string &Str)
bool TOgleBase::WriteFNameString(string &str)
{
  str.to_lower();
//  char FileName[FILENAMESIZE];
  char FileName[FNAME_SIZE];
  int len = strlen(str.c_str());
  len += 1;
//  if (len > FILENAMESIZE)
  if (len > FNAME_SIZE)
  {
//    len = FILENAMESIZE;
    len = FNAME_SIZE;
  }
  strncpy(FileName,str.c_str(),len);
  FileName[len - 1] = '\0';

  if (!WriteFNameChars(FileName)) {return false;}
  return true;
}
//*******************************************************************
bool TOgleBase::ReadTypeNameString(string &Str)
{
  char TypeName[TYPENAMESIZE];
  if (!ReadTypeNameChars(TypeName)) {return false;}
  Str = TypeName;
  return true;
}
//*******************************************************************
bool TOgleBase::WriteTypeNameString(string &Str)
{
  char TypeName[TYPENAMESIZE];
  int len = strlen(Str.c_str());
  len += 1;
  if (len > TYPENAMESIZE)
  {
    len = TYPENAMESIZE;
  }
  strncpy(TypeName,Str.c_str(),len);
  TypeName[len - 1] = '\0';
  if (!WriteTypeNameChars(TypeName)) {return false;}
  return true;
}
//*******************************************************************
bool TOgleBase::Readstring(string &str)
{
  int16 len;
  if (!Readint16(&len)) {return false;}
  char *buffer = new char[len];
  if (!ReadData(buffer,sizeof(char) * len)) {return false;}
  str = buffer;
  delete [] buffer;
  return true;
}
//*******************************************************************
bool TOgleBase::Writestring(const string &str)
{
  int16 len = int16(strlen(str.c_str()) + 1);
  char *buffer = new char[len];
  strcpy(buffer,str.c_str());
  if (!Writeint16(&len)) {return false;}
  if (!WriteData(buffer,sizeof(char) * len)) {return false;}
  delete [] buffer;
  return true;
}
//*******************************************************************
bool TOgleBase::WriteData(const void *PSource,int32 NumBytes)
{
  if (PWriteBuf == NULL) {return false;}
  if (PWriteBuf->Write(PSource,NumBytes)) {return true;}
  return WriteError(BASE_STR,weWriteData);
}
//*******************************************************************
bool TOgleBase::ReadLocalHeader()
{
  if (!ReadIDChars(IDChars)) {return false;}
  if (!IDOk()) {return HeaderError();}
  if (!Readword(&MajVer)) {return false;}
  if (!Readword(&MinVer)) {return false;}
  dword tempsize;
  if (!Readdword(&tempsize)) {return false;}
  return true;
}
//*******************************************************************
bool TOgleBase::WriteLocalHeader()
{
  SetIDChars();
  if (!WriteIDChars(IDChars)) {return false;}
  SetMajVer();
  if (!Writeword(&MajVer)) {return false;}
  SetMinVer();
  if (!Writeword(&MinVer)) {return false;}
  dword tempsize = 0;
  if (!Writedword(&tempsize)) {return false;}
  return true;
}
//*******************************************************************
dword TOgleBase::AskCurrentFUC() const
{
  if (PModeWin == NULL) {return 0;}

  return (PModeWin->GetFUC());
}
//*******************************************************************
string TOgleBase::GetHDName() const
{
  if (PBaseFile != NULL) {return (PBaseFile->GetHDName());}
  else {return string();}
}
//*******************************************************************
void TOgleBase::FMRegister()
{
  if (FileMode.Name.GetStr().is_null())
  {
    ::MessageBox(NULL,"Name is NULL","Base::FMRegister",MB_OK);
    SetFileNotFound();
    return;
  }

  assert(GetFileMgr());
  PBaseFile = GetFileMgr()->IsRegistered(FileMode);
  if (PBaseFile != NULL)
  {
    GetFileMgr()->RegisterNewOwner(PBaseFile,FileMode);
    ClearFileNotFound();
  }
  else
  {
    CreateNewFileObject(); // Creates a TOgleBaseFile derived object
                           // pointed to by PBaseFile.
    if (!GetFileMgr()->Register(PBaseFile,FileMode))
    {
      delete PBaseFile;
      PBaseFile = NULL;
      SetFileNotFound();
    }
  }// end else
}
//*******************************************************************
void TOgleBase::FMUnRegister()
{
  assert(GetFileMgr());
  if (PBaseFile != NULL)
  {
    GetFileMgr()->UnRegister(PBaseFile,FileMode);
  }
  PBaseFile = NULL;
}
//*******************************************************************
void TOgleBase::Init(const TFileMode &NewFileMode,bool AutoRead,bool KeepBaseFile)
// note: should be if (NewFileMode.IsRamImmed() && AutoRead) {Read();}
{
//  SetFName(NewFileMode.Name.GetFName()); // MRP 12/12/96

  FileMode = NewFileMode;
//  FileMode.Name += AddExt();
  FileMode.Name.SetExt(AddExt());
  FMRegister();

  #ifdef DEBUGFILEMGR
  if (IsFileNotFound())
  {
    string str = "File: ";
//    str += FileMode.Name;
    str += FileMode.Name.GetStr();
    str += " Not Found";
    ::MessageBox(NULL,str.c_str(),"Error - Base::Init",MB_OK);
  }
  #endif

  if (AutoRead && !IsFileNotFound())
  {
    TRACEX(Base,1,string(FileMode.Name.GetStr() + " Init").c_str());
    ReadSize = Read();

    #ifdef DEBUGFILEMGR
    if (ReadSize == -1)
    {
      ::MessageBox(NULL,"Unknown read error","Error - OBase",MB_OK|MB_ICONHAND|MB_SYSTEMMODAL);
      TRACEX(Base,0,"Read returned error code: -1");
    }
    #endif

    if (!KeepBaseFile)
    {
      FMUnRegister();
    }
  }
}
//*******************************************************************
void TOgleBase::Init(void *PReadData,bool AutoRead)
{
  TRACEX(Base,1,"Init with ptr");
//  FName = FileMode.Name;
//  FName = FileMode.Name.GetFName();
//  size_t periodpos = FName.find_first_of(".");
//  if (periodpos < FName.length())
//  {
//    FName.resize(periodpos);
//  }

  if ((PReadData != NULL) && (AutoRead))
  {
    ReadSize = Read(true,PReadData);

    #ifdef DEBUGFILEMGR
    if (ReadSize == -1)
    {
      ::MessageBox(NULL,"Unknown read error","Error - OBase",MB_OK|MB_ICONHAND|MB_SYSTEMMODAL);
      TRACEX(Base,0,"Read returned error code: -1");
    }
    #endif

  }
}
//*******************************************************************
#pragma argsused
TOgleBase::TOgleBase(TOgleModeWindow *pwm,bool dummy,const TFileMode &fm)
// to be called by most derived classes.
:PModeWin(pwm),
// PFileMgr(NULL),
 FileMode(fm),
// FName(fm.Name.GetStr()), // MRP 12/12/96
 BeginFUC(0),
 ActiveCount(0),
 PBaseFile(NULL),
 PExternal(NULL),
 WhatType(0),
 FUC_Offset(0),
 FUC_Length(0),
 FileOffset(0),
 PWriteBuf(NULL),
 StatFlags(obSHOWING)
{
//  POgleApp = FindOgleApp();
  #ifdef DEBUG_PMODEWIN_BASE
  if (PModeWin == NULL)
  {
    string s = "PModeWin == NULL in ";
    s += FileMode.Name;
    s += "'s ctor";
    ::MessageBox(NULL,s.c_str(),"Warning - TOgleBase 1",MB_OK);
  }
  #endif
  #ifdef DEBUG_BASECOUNT
  basecount++;
  #endif
}
//*******************************************************************
TOgleBase::TOgleBase(TOgleModeWindow *pmw,const TFileMode &NewFileMode,bool AutoRead,bool KeepBaseFile)
:PModeWin(pmw),
// PFileMgr(NULL),
 FileMode(NewFileMode),
// FName(NewFileMode.Name.GetStr()), // MRP 12/12/96
 BeginFUC(0),
 ActiveCount(0),
 PBaseFile(NULL),
 PExternal(NULL),
 WhatType(0),
 FUC_Offset(0),
 FUC_Length(0),
 FileOffset(0),
 PWriteBuf(NULL),
 StatFlags(obSHOWING)
{
//  POgleApp = FindOgleApp();
  #ifdef DEBUG_PMODEWIN_BASE
  if (PModeWin == NULL)
  {
    string s = "PModeWin == NULL in ";
    s += FileMode.Name;
    s += "'s ctor";
    ::MessageBox(NULL,s.c_str(),"Warning - TOgleBase 2",MB_OK);
  }
  #endif
  Init(NewFileMode,AutoRead,KeepBaseFile);
  #ifdef DEBUG_BASECOUNT
  basecount++;
  #endif
}
//*******************************************************************
TOgleBase::TOgleBase(TOgleModeWindow *pmw,void *PReadData,bool AutoRead)
:PModeWin(pmw),
// PFileMgr(NULL),
 BeginFUC(0),
 ActiveCount(0),
 PBaseFile(NULL),
 PExternal(NULL),
 WhatType(0),
 FUC_Offset(0),
 FUC_Length(0),
 FileOffset(0),
 PWriteBuf(NULL),
 StatFlags(obSHOWING)
{
//  POgleApp = FindOgleApp();
  #ifdef DEBUG_PMODEWIN_BASE
  if (PModeWin == NULL)
  {
    string s = "PModeWin == NULL in ";
    s += FileMode.Name;
    s += "'s ctor";
    ::MessageBox(NULL,s.c_str(),"Warning - TOgleBase 3",MB_OK);
  }
  #endif
  Init(PReadData,AutoRead);
  #ifdef DEBUG_BASECOUNT
  basecount++;
  #endif
}
//*******************************************************************
TOgleBase::TOgleBase(TOgleModeWindow *pmw)
:PModeWin(pmw),
// PFileMgr(NULL),
 BeginFUC(0),
 ActiveCount(0),
 PBaseFile(NULL),
 PExternal(NULL),
 WhatType(0),
 FUC_Offset(0),
 FUC_Length(0),
 FileOffset(0),
 PWriteBuf(NULL),
 StatFlags(obSHOWING)
{
//  POgleApp = FindOgleApp();
  #ifdef DEBUG_PMODEWIN_BASE
  if (PModeWin == NULL)
  {
    string s = "PModeWin == NULL in ";
    s += FileMode.Name;
    s += "'s ctor";
    ::MessageBox(NULL,s.c_str(),"Warning - TOgleBase 4",MB_OK);
  }
  #endif
  #ifdef DEBUG_BASECOUNT
  basecount++;
  #endif
}
//*******************************************************************
TOgleBase::~TOgleBase()
{
  FMUnRegister();
  PModeWin = NULL;
//  PFileMgr = NULL;
  #ifdef DEBUG_BASECOUNT
  basecount--;
  #endif
}
//*******************************************************************
bool TOgleBase::CreateNewFileObject()
{
  if (PBaseFile != NULL) {return false;}

  PBaseFile = new TOgleBaseFile();//GetOgleApp());
  return true;
}
//*******************************************************************
void *TOgleBase::GetPtr()
{
  byte huge *P;
  if (PExternal == NULL)
  {
    if (IsUseFileOffset())
    {
      P = (byte huge *)GetRamPtr() + FileOffset;
    }
    else
    {
      P = (byte huge *)GetRamPtr();
    }
  }
  else
  {
    if (IsUseFileOffset())
    {
      P = ((byte huge *)PExternal) + FileOffset;
    }
    else
    {
      P = (byte huge *)PExternal;
    }
  }
  return P;
}
//*******************************************************************
int32 TOgleBase::Read(bool UseFOff,void *PSource)
{
  // Mike - Check that file is loaded first.
  // ?? need to set PExternal to NULL before exiting ??

  if (UseFOff) {SetUseFileOffset();}
  else         {ClearUseFileOffset();}
  PExternal = (void huge *)PSource;
  FileOffset = 0;
  if (!ReadLocalHeader()) {return -1;}
  if (!ReadLocal()) {return -1;}
  SetBeenRead();
  return FileOffset;
}
//*******************************************************************
bool TOgleBase::WriteOpenCDRomFile()
{
//  string CDRomFullPathName;
//  CDRomFullPathName = GetFileMgr()->GetCDRomPath(FileMode.GetDirIndex());
//  CDRomFullPathName += FileMode.Name.GetStr();

  TOgleFileName ofn(GetFileMgr()->PCD->GetFullPath());
  ofn.AppendDirPath(FileMode.Name.GetDirPath());
  ofn.SetFName(FileMode.Name.GetFName());
  ofn.SetExt(FileMode.Name.GetExt());

//  PWriteBuf = new TFileWriteBuf(CDRomFullPathName);
  PWriteBuf = new TFileWriteBuf(ofn);//.GetStr());
  bool isopen = PWriteBuf->IsOpen();
  return isopen;//(PWriteBuf->IsOpen());
}
//*******************************************************************
bool TOgleBase::WriteCloseCDRomFile()
{
  if (PWriteBuf != NULL)
  {
    delete PWriteBuf;
    PWriteBuf = NULL;
  }
  return true;
}
//*******************************************************************
bool TOgleBase::Write(TFileWriteBuf *pwritebuf)
{
  PWriteBuf = pwritebuf;

  if (PWriteBuf != NULL)
  {
    if (!WriteLocalHeader())    {return WriteError(BASE_STR,weHeader);}
    if (!WriteLocal())          {return WriteError(BASE_STR,weLocal);}
    return true;
  }
  else
  {
    if (!WriteOpenCDRomFile())  {return WriteError(BASE_STR,weOpen);}
    if (!WriteLocalHeader())    {WriteCloseCDRomFile();return WriteError(BASE_STR,weHeader);}
    if (!WriteLocal())          {WriteCloseCDRomFile();return WriteError(BASE_STR,weLocal);}
    if (!WriteCloseCDRomFile()) {return WriteError(BASE_STR,weClose);}

    return true;
  }
}
//*******************************************************************
bool TOgleBase::RequestChangeMode(TFileMode &NewFileMode)
{
  TRACEX(Base,1,"RequestChangeMode");
  assert(GetFileMgr());

  if (PBaseFile == NULL) {return false;}

  // the following check is an effort to minimize calls to the filemgr.
  if (FileMode.GetHDStatus() == NewFileMode.GetHDStatus() &&
      FileMode.GetRamStatus() == NewFileMode.GetRamStatus())
  {
    return true;
  }

  return GetFileMgr()->ChangeRegisteredMode(PBaseFile,FileMode,NewFileMode);
}
//*******************************************************************
void TOgleBase::ACLoad()
{
  int ac = GetActiveCount();
       if (ac < 2) {LoadBGLo();}
  else if (ac == 2) {LoadBGMed();}
  else if (ac >= 3) {LoadBGHi();}
}
//*******************************************************************

