//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  pokersma.cpp
//    Project Name:  Ogle
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     06/01/95   A. Krist    Original baseline
//  1.1     02/11/97   A. Krist    Removed code at date
//  2.0     08/26/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "pokersma.h"
//*******************************************************************
TPokerSmarts::TPokerSmarts()
{
}
//*******************************************************************
TPokerSmarts::~TPokerSmarts()
{
}
//*******************************************************************
int16 TPokerSmarts::LoPairs(TPokerHand *h)
{
  TPokerHand  hx;
  TPokerHand  *hz=&hx;
  hx.Copy(h);
  int16 i,j;
  int16 current=0;
  if(h->inhand != 0)
  {
	 Insert_Sort(hz);
	 hx.lohighcard = int16(hx.cards[0].name);
    hx.highcardsuit = int16(hx.cards[0].suit);
	 for(i=0;i<hx.inhand;i++)
	 {
		for(j=int16(i+1);j<hx.inhand;j++)
		{
		  if(hx.cards[i].name == hx.cards[j].name)
		  {
			 current += int16(10);
		  }
		}//inner  for
		if(current > hx.lohand)
		{
		  if((hx.lohand == 10 || hx.lohand == 15) && current == 20)
		  {
			 hx.lohand = 70;//Fullhouse
		  }
		  else
		  {
			 hx.lohand = current;
		  }
		  hx.lohighcard = int16(hx.cards[i].name);
		}
		else
		{
		  if(current == hx.lohand || (hx.lohand == 15 && current == 10))
		  {
			 if(hx.cards[i].name > hx.lohighcard)
			 {
				hx.lolowcard  = hx.lohighcard;
				hx.lohighcard = int16(hx.cards[i].name);
			 }
			 if(current == 10)
			 {
				hx.lohand = 15;//Two pair
			 }
		  }
		  else
		  {
			 if(  (hx.cards[i].name != hx.lohighcard)
				 &&(current == 10 && hx.lohand == 20) )
			 {
				hx.lohand = 70;//Fullhouse
			 }
		  }
		}//if else
		current = 0;
	 }//outer for
  }
  h->lohand     = hx.lohand;
  h->lohighcard = hx.lohighcard;
  h->lolowcard  = hx.lolowcard;
  return 1;
}
//*******************************************************************
int16 TPokerSmarts::Pairs(TPokerHand *h)
{
  TPokerHand  hx;
  TPokerHand  *hz=&hx;
  hx.Copy(h);
  int16 i,j;
  int16 current=0;
  if(h->inhand != 0)
  {
	 Insert_Sort(hz);
	 hx.highcard = int16(hx.cards[0].name);
	 hx.highcardsuit = int16(hx.cards[0].suit);
	 for(i=0;i<hx.inhand;i++)
	 {
		for(j=int16(i+1);j<hx.inhand;j++)
		{
		  if(hx.cards[i].name == hx.cards[j].name)
		  {
			 current += int16(10);
		  }
		}//inner  for
		if(current > hx.highhand)
		{
		  if((hx.highhand == 10 || hx.highhand == 15) && current == 20)
		  {
			 hx.highhand = 70;//Fullhouse
		  }
		  else
		  {
			 if(current == 30)
			 {
				hx.highhand = 71; //four of a kind
			 }
			 else
			 {
				hx.highhand = current;
			 }
		  }
		  hx.lowcard      = hx.highcard;
		  hx.lowcardsuit  = hx.highcardsuit;
		  hx.highcard     = int16(hx.cards[i].name);
		  hx.highcardsuit = int16(hx.cards[i].suit);
		}
		else
		{
		  if(current == hx.highhand || (hx.highhand == 15 && current == 10))
		  {
			 if(hx.cards[i].name > hx.highcard)
			 {
				hx.lowcard      = hx.highcard;
				hx.lowcardsuit  = hx.highcardsuit;
				hx.highcard     = int16(hx.cards[i].name);
				hx.highcardsuit = int16(hx.cards[i].suit);
			 }
			 if(current == 10)
			 {
				hx.highhand = 15;//Two pair
			 }
		  }
		  else
		  {
			 if(  (hx.cards[i].name != hx.highcard)
				 &&(current == 10 && hx.highhand == 20) )
			 {
				hx.highhand = 70;//Fullhouse
			 }
		  }
		}//if else
		if(current == 40)
		{
		  hx.highhand = 100; //five of a kind
		}
		current = 0;
	 }//outer for
  }
  if(hx.highhand > h->highhand)
  {
	 h->highhand     = hx.highhand;
	 h->highcard     = hx.highcard;
    h->highcardsuit = hx.highcardsuit;
	 h->lowcard      = hx.lowcard;
	 h->lowcardsuit  = hx.lowcardsuit;
  }
  return 1;
}
//*******************************************************************
int16 TPokerSmarts::Strip(TPokerHand *h)
{
  int16 i=0;
  for(i=0;i<(h->inhand)-1;i++) // if last card, who cares
  {
	 Insert_Sort(h);
	 if(h->cards[i].name == h->lohighcard)
	 {
		h->cards[i].name   = h->cards[h->inhand-1].name;
		h->cards[i].suit   = h->cards[h->inhand-1].suit;
		h->cards[i].updown = h->cards[h->inhand-1].updown;
		break;
	 }
  }
  h->inhand -= int16(1);
  return 1;
}
//*******************************************************************
int16 TPokerSmarts::LowComp(THand *h1,THand *h2)
{
  if(h1->lohand < h2->lohand)
	 return(1);
  if(h1->lohand > h2->lohand)
	 return(-1);
  if(h1->lohighcard < h2->lohighcard)
	 return(1);
  if(h1->lohighcard > h2->lohighcard)
	 return(-1);
  if(h1->lohand == 15)
  {
	 if(h1->lolowcard < h2->lolowcard)
		return(1);
	 if(h1->lolowcard > h2->lolowcard)
		return(-1);
  }
  return(LowArb((TPokerHand *)h1,(TPokerHand *)h2));
}
//*******************************************************************
int16 TPokerSmarts::LowArb(TPokerHand *h1,TPokerHand *h2)
{
  int x=0,y=0;

  x = h1->inhand;
  while(h1->highcard < h1->cards[x--].name)
	;
  y = h2->inhand;
  while(h2->highcard < h2->cards[y--].name)
	;

  while(x != -1 && y != -1)
  {
	 if((h1->cards[x].name == h1->cards[x-1].name) && (x !=0))
	 {
		x--;
		if(h1->cards[x].name == h1->cards[x-1].name)
		{
		  x--;
		}
	 }
	 if((h2->cards[y].name == h2->cards[y-1].name) && (y !=0))
	 {
		y--;
		if(h2->cards[y].name == h2->cards[y-1].name)
		{
		  y--;
		}
	 }
	 if(h1->cards[x].name < h2->cards[y].name)
		return(1);
	 if(h1->cards[x].name > h2->cards[y].name)
		return(-1);
	 x--;y--;
  }
  return(0);
}
//*******************************************************************
int16 TPokerSmarts::AceLoStraight(TPokerHand *h)
{
 TPokerHand  hx;
 TPokerHand  *hz=&hx;
 hx.Copy(h);
 int16 i=0;
 for(i=0;i<hx.inhand;i++)
 {
	if(hx.cards[i].name == AceHi)
	{
	  hx.cards[i].name = AceLo;
	}
 }

  int stright,sf=0;
	stright=0;
  int instrt=0,instfh=0;   //Check inside straight flush**********
  hx.instrght = 1;
  if(hx.inhand != 0)
  {
	 Insert_Sort(hz);
	 hx.highcard = int16(hx.cards[0].name);
	 hx.highcardsuit = int16(hx.cards[0].suit);
	 for(i=0; i < (hx.inhand)-1;i++)
	 {
		  if((hx.cards[i].name)+1 == hx.cards[i+1].name)
		  {
			 if(hx.highcard < hx.cards[i+1].name)
			 {
				hx.lowcard      = hx.highcard;
				hx.lowcardsuit  = hx.highcardsuit;
				hx.highcard     = int16(hx.cards[i+1].name);
				hx.highcardsuit = int16(hx.cards[i+1].suit);
			 }
			 stright++;
			 if(stright+1 > hx.outstrght)
			 {
				hx.outstrght = int16(stright+1);
			 }


				if((hx.cards[i].suit) == hx.cards[i+1].suit)
				{
				  sf++;
				  if(sf+1 > hx.outstrflsh)
				  {
					 hx.outstrflsh = int16(sf+1);
                hx.outstrflshsuit = hx.cards[i].suit;
				  }
				  if(sf == 4)
				  {
					 hx.highhand = 99;
				  }
				}
				else
				{
				  if((hx.cards[i].name) != hx.cards[i+1].name)
				  {
					 if(instfh == 1)
					 {
						if(hx.instrflsh < hx.instrght + sf)
						{
						  hx.instrflsh = int16(hx.instrflsh + sf);
                    hx.instrflshsuit = hx.cards[i].suit;
						}
						instfh = 0;
					 }
					 if((hx.cards[i].name)+2 == hx.cards[i+1].name && (instfh == 0))
					 {
						instfh =1;
						if(hx.instrflsh < sf+2)
						{
						  hx.instrflsh = int16(sf+2);
                    hx.instrflshsuit = hx.cards[i].suit;
						}
					 }
					 if(i > 2 || (hx.cards[i].name+1 != hx.cards[i+2].name) || (hx.cards[i].suit != hx.cards[i+2].suit))
					 {
						sf = 0;
					 }
				  }
				}

			 if(hx.highhand < 26 && stright == 4)
			 {
				hx.highhand     = 23;
				hx.lowcard      = hx.highcard;
				hx.lowcardsuit  = hx.highcardsuit;
				hx.highcard     = int16(hx.cards[i+1].name);
				hx.highcardsuit = int16(hx.cards[i+1].suit);
			 }
		  }
		  else
		  {
			 if((hx.cards[i].name) != hx.cards[i+1].name) //skip pairs
			 {
				if(instrt == 1)
				{
				  if(hx.instrght < hx.instrght + stright)
				  {
					 hx.instrght = int16(hx.instrght + stright);
				  }
				  instrt = 0;
				}
				if((hx.cards[i].name)+2 == hx.cards[i+1].name && (instrt == 0))
				{
				  instrt =1;
				  if(hx.instrght < stright+2)
				  {
					 hx.instrght = int16(stright+2);
				  }
				}
				stright = 0;
				sf = 0;
			 }
			 else
			 {
				if(i > 0 && (hx.cards[i-1].suit != hx.cards[i+1].suit))
				{
				  sf = 0;
				}
			 }
		  }
	 }
 /* 2/11/97	 if(instrt == 1)      // ?Unreachable?
	 {
	  if(hx.instrght < hx.instrght + stright)
	  {
		 hx.instrght = hx.instrght + stright;
	  }
	 }    */
  }
  hx.outstrflsh = 0;
  int16 j=0,insuit=0,suitspot[5],z=0;
  for(j=0;j<4;j++)
  {
	 insuit = 0;
	 sf = 1;
	 for(z=0;z<5;z++){suitspot[z]= -1;}
	 for(z=0;z<(hx.inhand);z++)
	 {
		if(hx.cards[z].suit == j){suitspot[insuit]=z;insuit++;}
	 }
	 for(i=0;i<insuit-1;i++)
	 {
		  if((hx.cards[suitspot[i]].name)+1 == hx.cards[suitspot[i+1]].name)
		  {
			 sf++;
			 if(sf > hx.outstrflsh)
			 {
				hx.outstrflsh = int16(sf);
            hx.outstrflshsuit = hx.cards[suitspot[i]].suit;
			 }
		  }
		  else
		  {
			 sf = 1;
		  }
	 }
  }
  int16 cardnums[5][2];
  int16 lastsuit = 0;
  for(i=0;i<5;i++)
  {
	 cardnums[i][0] = 0;
	 cardnums[i][1] = 0;
	 lastsuit       = i;
	 for(j=int16(i+1);j<hx.inhand;j++)
	 {
		if((hx.cards[i].suit == hx.cards[j].suit) &&
			(hx.cards[j].name <  hx.cards[i].name + 5))
		{
		  cardnums[i][0]++;
		  if((hx.cards[lastsuit].name + 1) != hx.cards[j].name)
		  {
			 cardnums[i][1]++;
		  }
		  lastsuit = j;
		}
	 }
  }
  int16 indexx =0;
  for(i=0;i<5;i++)
  {
	 if(cardnums[i][1])
	 {
		if(cardnums[i][0] > indexx)
		{
		  indexx = cardnums[i][0];
        hx.instrflshsuit = hx.cards[i].suit;
		}
	 }
  }
  int16 instrnums[5];
  for(i=0;i<5;i++)
  {
	 instrnums[i] = 0;
	 for(j=int16(i+1);j<hx.inhand;j++)
	 {
		if(   (hx.cards[j].name <  hx.cards[i].name + 5)
         && (hx.cards[j].name !=  hx.cards[i].name)
         && (hx.cards[j].name !=  hx.cards[j-1].name)   )
		{
		  instrnums[i]++;
		}
	 }
  }
  int16 indexxx =0;
  for(i=0;i<5;i++)
  {
	 if(instrnums[i] > indexxx)
	 {
		indexxx = instrnums[i];
	 }
  }
  indexxx = int16(indexxx + 1);
  if(hx.highhand > h->highhand)
  {
	 h->highhand     = hx.highhand;
	 h->highcard     = hx.highcard;
	 h->highcardsuit = hx.highcardsuit;
	 h->lowcard      = hx.lowcard;
	 h->lowcardsuit  = hx.lowcardsuit;
  }

  if(h->instrght < indexxx)
  {
	 h->instrght     = indexxx;
  }
  if(h->outstrght < hx.outstrght)
  {
	  h->outstrght    = hx.outstrght;
  }
  if(h->instrflsh < indexx)
  {
	 h->instrflsh    = indexx;
    h->instrflshsuit    = hx.instrflshsuit;  // 4/25/97
  }
  if(h->outstrflsh < hx.outstrflsh)
  {
	 h->outstrflsh   = hx.outstrflsh;
    h->outstrflshsuit   = hx.outstrflshsuit;
  }
  return 1;
}
//*******************************************************************
int16 TPokerSmarts::Straight(TPokerHand *h)
{
  TPokerHand  hx;
  TPokerHand  *hz=&hx;
  hx.Copy(h);
  int16 i,stright,sf=0;     //j
	stright=0;
  int16 instrt=0,instfh=0;   //Check inside straight flush**********
  hx.instrght = 1;
  if(h->inhand != 0)
  {
	 Insert_Sort(hz);
	 hx.highcard = int16(hx.cards[0].name);
	 hx.highcardsuit = int16(hx.cards[0].suit);
	 for(i=0; i < (hx.inhand)-1;i++)
	 {
		  if((hx.cards[i].name)+1 == hx.cards[i+1].name)
		  {
			 if(hx.highcard < hx.cards[i+1].name)
			 {
				hx.lowcard      = hx.highcard;
				hx.lowcardsuit  = hx.highcardsuit;
				hx.highcard     = int16(hx.cards[i+1].name);
				hx.highcardsuit = int16(hx.cards[i+1].suit);
			 }
			 stright++;
			 if(stright+1 > hx.outstrght)
			 {
				hx.outstrght = int16(stright+1);
			 }


				if((hx.cards[i].suit) == hx.cards[i+1].suit)
				{
				  sf++;
				  if(sf+1 > hx.outstrflsh)
				  {
					 hx.outstrflsh = int16(sf+1);
                hx.outstrflshsuit = hx.cards[i].suit;
				  }
				  if(sf == 4)
				  {
					 hx.highhand = 99;
				  }
				}
				else
				{
				  if((hx.cards[i].name) != hx.cards[i+1].name)
				  {
					 if(instfh == 1)
					 {
						if(hx.instrflsh < hx.instrght + sf)
						{
						  hx.instrflsh = int16(hx.instrflsh + sf);
                    hx.instrflshsuit = hx.cards[i].suit;
						}
						instfh = 0;
					 }
					 if((hx.cards[i].name)+2 == hx.cards[i+1].name && (instfh == 0))
					 {
						instfh =1;
						if(hx.instrflsh < sf+2)
						{
						  hx.instrflsh = int16(sf+2);
                    hx.instrflshsuit = hx.cards[i].suit;
						}
					 }
					 if(i > 2 || (hx.cards[i].name+1 != hx.cards[i+2].name) || (hx.cards[i].suit != hx.cards[i+2].suit))
					 {
						sf = 0;
					 }
				  }
				}

			 if(hx.highhand < 26 && stright == 4)
			 {
				hx.highhand = 23;
				hx.lowcard      = hx.highcard;
				hx.lowcardsuit  = hx.highcardsuit;
				hx.highcard = int16(hx.cards[i+1].name);
				hx.highcardsuit = int16(hx.cards[i+1].suit);
			 }
		  }
		  else
		  {
			 if((hx.cards[i].name) != hx.cards[i+1].name) //skip pairs
			 {
				if(instrt == 1)
				{
				  if(hx.instrght < hx.instrght + stright)
				  {
					 hx.instrght = int16(hx.instrght + stright);
				  }
				  instrt = 0;
				}
				if((hx.cards[i].name)+2 == hx.cards[i+1].name && (instrt == 0))
				{
				  instrt =1;
				  if(hx.instrght < stright+2)
				  {
					 hx.instrght = int16(stright+2);
				  }
				}
				stright = 0;
				sf = 0;
			 }
			 else
			 {
				if(i > 0 && (hx.cards[i-1].suit != hx.cards[i+1].suit) &&
				  (hx.cards[i-1].suit != hx.cards[i].suit)               )
				{
				  sf = 0;
				}
			 }
		  }
	 }
  /* 2/11/97	 if(instrt == 1)      // ?Unreachable?
	 {
	  if(hx.instrght < hx.instrght + stright)
	  {
		  hx.instrght = hx.instrght + stright;
	  }
	 }*/
  }
  hx.outstrflsh = 0;
  int16 j=0,insuit=0,suitspot[5],z=0;
  for(j=0;j<4;j++)
  {
	 insuit = 0;
	 sf = 1;
	 for(z=0;z<5;z++){suitspot[z]= -1;}
	 for(z=0;z<(hx.inhand);z++)
	 {
		if(hx.cards[z].suit == j){suitspot[insuit]=z;insuit++;}
	 }
	 for(i=0;i<insuit-1;i++)
	 {
		  if((hx.cards[suitspot[i]].name)+1 == hx.cards[suitspot[i+1]].name)
		  {
			 sf++;
			 if(sf > hx.outstrflsh)
			 {
				hx.outstrflsh = sf;
            hx.outstrflshsuit = hx.cards[suitspot[i]].suit;
			 }
		  }
		  else
		  {
			 sf = 1;
		  }
	 }
  }
  int16 cardnums[5][2];
  int16 lastsuit=0;

  for(i=0;i<5;i++)
  {
	 cardnums[i][0] = 0;
	 cardnums[i][1] = 0;
	 lastsuit       = i;
	 for(j=int16(i+1);j<hx.inhand;j++)
	 {
		if((hx.cards[i].suit == hx.cards[j].suit) &&
			(hx.cards[j].name <  hx.cards[i].name + 5))
		{
		  cardnums[i][0]++;
		  if((hx.cards[lastsuit].name + 1) != hx.cards[j].name)
		  {
			 cardnums[i][1]++;
		  }
		  lastsuit = j;
		}
	 }
  }
  int16 indexx =0;
  for(i=0;i<5;i++)
  {
	 if(cardnums[i][1])
	 {
		if(cardnums[i][0] > indexx)
		{
		  indexx = cardnums[i][0];
        hx.instrflshsuit = hx.cards[i].suit;
		}
	 }
  }
  indexx = int16(indexx + 1);
  int16 instrnums[5];
  for(i=0;i<5;i++)
  {
	 instrnums[i] = 0;
	 for(j=int16(i+1);j<hx.inhand;j++)
	 {
      if(    (hx.cards[j].name <  hx.cards[i].name + 5)
          && (hx.cards[j].name !=  hx.cards[i].name)
          && (hx.cards[j].name !=  hx.cards[j-1].name)   )
		{
		  instrnums[i]++;
		}
	 }
  }
  int16 indexxx =0;
  for(i=0;i<5;i++)
  {
	 if(instrnums[i] > indexxx)
	 {
		indexxx = instrnums[i];
	 }
  }
  indexxx = int16(indexxx + 1);
  if(hx.highhand > h->highhand)
  {
	 h->highhand     = hx.highhand;
	 h->highcard     = hx.highcard;
	 h->highcardsuit = hx.highcardsuit;
	 h->lowcard      = hx.lowcard;
	 h->lowcardsuit  = hx.lowcardsuit;
  }
  if(h->instrght < indexxx)
  {
	 h->instrght     = indexxx;
  }
  if(h->outstrght < hx.outstrght)
  {
	  h->outstrght    = hx.outstrght;
  }
  if(h->instrflsh < indexx)
  {
	 h->instrflsh    = indexx;
    h->instrflshsuit = hx.instrflshsuit;
  }
  if(h->outstrflsh < hx.outstrflsh)
  {
	 h->outstrflsh   = hx.outstrflsh;
    h->outstrflshsuit = hx.outstrflshsuit;
  }

  return 1;
}
//*******************************************************************
int16 TPokerSmarts::Flushing(TPokerHand *h)
{
  TPokerHand  hx;
  TPokerHand  *hz=&hx;
  hx.Copy(h);
  int16 i,j,flush=1;
  if(h->inhand != 0)
  {
	 Insert_Sort(hz);
	 hx.highcard = int16(hx.cards[0].name);
	 hx.highcardsuit = int16(hx.cards[0].suit);
	 for(i=0; i < (hx.inhand)-1;i++)
	 {
		for(j=int16(i+1);j<hx.inhand;j++)
		{
		  if((hx.cards[i].suit) == hx.cards[j].suit)
		  {
			 flush++;
			 if(hx.highcard < hx.cards[j].name && flush >= hx.toflush)
			 {
				hx.lowcard      = hx.highcard;
				hx.lowcardsuit  = hx.highcardsuit;
				hx.highcard     = int16(hx.cards[j].name);
				hx.highcardsuit = int16(hx.cards[j].suit);
			 }
			 if(hx.highhand < 29 && flush == 5)
			 {
				hx.highhand = 26;
			 }
		  }
		  if(flush > hx.toflush)
		  {
			 hx.toflush = flush;
		  }
		}
		flush = 1;
	 }
  }
  if(hx.highhand > h->highhand)
  {
	 h->highhand     = hx.highhand;
	 h->highcard     = hx.highcard;
	 h->highcardsuit = hx.highcardsuit;
	 h->lowcard      = hx.lowcard;
	 h->lowcardsuit  = hx.lowcardsuit;
  }
  h->toflush      = hx.toflush;
  return 1;
}
//*******************************************************************
int16 TPokerSmarts::Insert_Sort(TPokerHand *h)
	{
		int16 j,p;
		int16 tmp,tmp2;

		for(p=1; p <= h->inhand-1 ;p++)
			{
				tmp2 = int16(h->cards[p].suit);
				tmp  = int16(h->cards[p].name);
				for(j=p; (tmp < h->cards[j-1].name) && (j > 0) ;j--)
				{
				  h->cards[j].name = h->cards[j-1].name;
				  h->cards[j].suit = h->cards[j-1].suit;
				}
				h->cards[j].suit = (TSuit)tmp2;
				h->cards[j].name = (TCardName)tmp;
			}
		return 1;
	}
//*******************************************************************
int16 TPokerSmarts::Compare(THand *h1,THand *h2)
{
  if(h1->highhand > h2->highhand)
	 return(1);
  if(h1->highhand < h2->highhand)
	 return(-1);
  if(h1->highcard > h2->highcard)
	 return(1);
  if(h1->highcard < h2->highcard)
	 return(-1);
  if(h1->highhand == 15)
  {
	 if(h1->lowcard > h2->lowcard)
		return(1);
	 if(h1->lowcard < h2->lowcard)
		return(-1);
  }
  return(Arbitrate((TPokerHand *)h1,(TPokerHand *)h2));
}
//*******************************************************************
int16 TPokerSmarts::Arbitrate(TPokerHand *h1,TPokerHand *h2)
{
  TPokerHand *arb1;
  TPokerHand *arb2;
  int16   i,overall=0;

  arb1 = new TPokerHand(h1->inhand);
  arb2 = new TPokerHand(h2->inhand);
  for(i=0;i<h1->inhand;i++)
  {
	 if(h1->cards[i].name != h1->highcard && h1->cards[i].name != h1->lowcard)
	 {
		arb1->cards[i].name = h1->cards[i].name;
		arb1->inhand++;
	 }
	 else
	 {
		overall++;
	 }
  }
  for(i=0;i<h2->inhand;i++)
  {
	 if(h2->cards[i].name != h2->highcard && h2->cards[i].name != h2->lowcard)
	 {
		arb2->cards[i].name = h2->cards[i].name;
		arb2->inhand++;
	 }
  }
  for(i=int16(arb1->inhand-1); i >= (arb1->inhand)-(5-overall) ;i--)
  {
	 if(arb1->cards[i].name > arb2->cards[i].name)
	 {
      delete arb1;
		delete arb2;
		return(1);
	 }
	 if(arb1->cards[i].name < arb2->cards[i].name)
	 {
      delete arb1;
		delete arb2;
		return(-1);
	 }
  }
	 delete arb1;
	 delete arb2;
	 return(0);
}
//*******************************************************************

