//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  pokerhan.cpp
//    Project Name:  Ogle
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     06/01/95   A. Krist    Original baseline
//  2.0     08/26/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "pokerhan.h"
//*******************************************************************
TPokerHand::TPokerHand(int16 len)
{
  length     = len;
}
//*******************************************************************
TPokerHand::~TPokerHand()
{
  length     = 0;
}
//*******************************************************************
int16 TPokerHand::Copy(TPokerHand *ref)
{
  for(int16 x=0;x<ref->inhand;x++)
  {
	 cards[x].name   = ref->cards[x].name;
	 cards[x].suit   = ref->cards[x].suit;
	 cards[x].updown = ref->cards[x].updown;
  }
  length     = ref->length;
  inhand     = ref->inhand;  // None in hand yet
  highcard   = ref->highcard;  // No card
  lowcard    = ref->lowcard; // Low pair/fullhouse value
  highhand   = ref->highhand;  // Type of hand, 0= high card,1=pair,ect...
  toflush    = ref->toflush;  // How many of same suit
  instrght   = ref->instrght;  // How many in a row, inside/outside
  outstrght  = ref->outstrght;  // Outside = 0, inside = 1
  instrflsh  = ref->instrflsh;  // To a inside straight flush
  outstrflsh = ref->outstrflsh;  // Outside straight flush
  lohand     = ref->lohand;
  lohighcard = ref->lohighcard;
  lolowcard  = ref->lolowcard;
  return 1;
}
//*******************************************************************

