//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  ogaugdlg.cpp
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     2/22/96    M.Perry    original baseline
//  2.0    08/27/97    M.Perry    32-bit conversion.
//********************************************************************
#if !defined(__ogaugdlg_h)
#include "ogaugdlg.h"
#endif

#if !defined(OWL_STATIC_H)
#include <owl\static.h>
#endif

#if !defined(OWL_GAUGE_H)
#include <owl\gauge.h>
#endif
//*******************************************************************
TGaugeDlg::TGaugeDlg(void *powner,TWindow *pwin,const char *title)
:TOgleGroupGaugeDlg(powner,pwin,NULL,bdIGNOREINPUT,IDD_OGLEGAUGE,title)
{
  PDummyControl = new TControl(this,IDC_OGLEGAUGE);
  PText = new TStatic(this,IDC_GAUGETEXT,20);
  PGauge = NULL;
}
//*******************************************************************
TGaugeDlg::~TGaugeDlg()
{
  delete PText;
  PText = NULL;
  delete PGauge;
  PGauge = NULL;
}
//*******************************************************************
#pragma argsused
void TGaugeDlg::SetGaugeText(string text,int gaugenum,int groupnum)
{
  PText->SetText(text.c_str());
}
//*******************************************************************
#pragma argsused
void TGaugeDlg::SetGaugeCaption(string caption,int gaugenum,int groupnum)
{
  PGauge->SetCaption(caption.c_str());
}
//*******************************************************************
#pragma argsused
void TGaugeDlg::SetGaugeValue(int value,int gaugenum,int groupnum)
{
  PGauge->SetValue(value);
  PGauge->UpdateWindow();
}
//*******************************************************************
#pragma argsused
void TGaugeDlg::IncGaugeValue(int gaugenum,int groupnum)
{
  PGauge->SetValue(PGauge->GetValue() + 1);
  PGauge->UpdateWindow();
}
//*******************************************************************
#pragma argsused
void TGaugeDlg::DecGaugeValue(int gaugenum,int groupnum)
{
  PGauge->SetValue(PGauge->GetValue() - 1);
  PGauge->UpdateWindow();
}
//*******************************************************************
#pragma argsused
void TGaugeDlg::SetGaugeRange(int min,int max,int gaugenum,int groupnum)
{
  PGauge->SetRange(min,max);
}
//*******************************************************************
void TGaugeDlg::SetupWindow()
{
  TOgleGroupGaugeDlg::SetupWindow();
  if (Parent != NULL)
  {
    TRect winrect = GetWindowRect();
    TRect parrect = Parent->GetWindowRect();
    int newleft = (parrect.Width() / 2) - (winrect.Width() / 2);
    newleft += parrect.left;
    int newtop = (parrect.Height() / 2) - (winrect.Height() /2);
    newtop += parrect.top;
    TRect newrect = winrect;
    newrect.Offset(newleft - winrect.left,newtop - winrect.top);
    MoveWindow(newrect);
  }

  TRect rect = PDummyControl->GetWindowRect();
  ScreenToClient(rect.TopLeft());
  ScreenToClient(rect.BottomRight());
  delete PDummyControl;
  PDummyControl = NULL;
  PGauge = new TGauge(this,"Num: %d",IDC_OGLEGAUGE,
                      rect.left,rect.top,rect.Width(),rect.Height());
  PGauge->Create();
}
//*******************************************************************

