//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  oloaddlg.cpp
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     12/22/96   M.Perry    original baseline
//********************************************************************
#if !defined(__oloaddlg_h)
#include "oloaddlg.h"
#endif

#if !defined(OWL_GAUGE_H)
#include <owl\gauge.h>
#endif

#define IDC_G1 200
#define IDC_G2 201
//*******************************************************************
TLoadDlg::TLoadDlg(void *powner,TWindow *pwin,TBitmap *pbitmap,word options,TRect r1,TRect r2,TColor c1,TColor c2)
:TOgleGroupGaugeDlg(powner,pwin,pbitmap,options),
 NumGaugesUsed(2)
{
  ActiveGaugeNum = 0;
  PG1 = new TGauge(this,"",IDC_G1,r1.left,r1.top,r1.Width(),r1.Height());
  PG1->SetColor(c1);
  #if !defined(OGLEOWLVER2)
  PG1->SetNativeUse(nuAvoid);
  #endif
  PG2 = new TGauge(this,"",IDC_G2,r2.left,r2.top,r2.Width(),r2.Height());
  PG2->SetColor(c2);
  #if !defined(OGLEOWLVER2)
  PG2->SetNativeUse(nuAvoid);
  #endif
}
//*******************************************************************
TLoadDlg::TLoadDlg(void *powner,TWindow *pwin,TBitmap *pbitmap,word options,TRect r,TColor c)
:TOgleGroupGaugeDlg(powner,pwin,pbitmap,options),
 NumGaugesUsed(1)
{
  ActiveGaugeNum = 0;
  PG1 = new TGauge(this,"",IDC_G1,r.left,r.top,r.Width(),r.Height());
  PG1->SetColor(c);
  #if !defined(OGLEOWLVER2)
  PG1->SetNativeUse(nuAvoid);
  #endif
  PG2 = NULL;
}
//*******************************************************************
TLoadDlg::~TLoadDlg()
{
  if (PG1 != NULL)
  {
    delete PG1;
    PG1 = NULL;
  }
  if (PG2 != NULL)
  {
    delete PG2;
    PG2 = NULL;
  }
}
//*******************************************************************
void TLoadDlg::SetupWindow()
{
  TOgleGroupGaugeDlg::SetupWindow();
}
//*******************************************************************
#pragma argsused
void TLoadDlg::SetGaugeText(string text,int gaugenum,int groupnum)
{
  // do nothing.
}
//*******************************************************************
#pragma argsused
void TLoadDlg::SetGaugeCaption(string caption,int gaugenum,int groupnum)
{
  int gauge = gaugenum;
  if (gauge == -1) {gauge = GetActiveGauge();}
  if (gauge == 1 && PG1 != NULL)
  {
    PG1->SetCaption(caption.c_str());
  }
  else if (gauge == 2 && PG2 != NULL)
  {
    PG2->SetCaption(caption.c_str());
  }
}
//*******************************************************************
#pragma argsused
void TLoadDlg::SetGaugeValue(int value,int gaugenum,int groupnum)
{
  int gauge = gaugenum;
  if (gauge == -1) {gauge = GetActiveGauge();}
  if (gauge == 1 && PG1 != NULL)
  {
    PG1->SetValue(value);
    PG1->UpdateWindow();
  }
  else if (gauge == 2 && PG2 != NULL)
  {
    PG2->SetValue(value);
    PG2->UpdateWindow();
  }
}
//*******************************************************************
#pragma argsused
void TLoadDlg::IncGaugeValue(int gaugenum,int groupnum)
{
  int gauge = gaugenum;
  if (gauge == -1) {gauge = GetActiveGauge();}
  if (gauge == 1 && PG1 != NULL)
  {
    PG1->SetValue(PG1->GetValue() + 1);
    PG1->UpdateWindow();
  }
  else if (gauge == 2 && PG2 != NULL)
  {
    PG2->SetValue(PG2->GetValue() + 1);
    PG2->UpdateWindow();
  }
}
//*******************************************************************
#pragma argsused
void TLoadDlg::DecGaugeValue(int gaugenum,int groupnum)
{
  int gauge = gaugenum;
  if (gauge == -1) {gauge = GetActiveGauge();}
  if (gauge == 1 && PG1 != NULL)
  {
    PG1->SetValue(PG1->GetValue() - 1);
    PG1->UpdateWindow();
  }
  else if (gauge == 2 && PG2 != NULL)
  {
    PG2->SetValue(PG2->GetValue() - 1);
    PG2->UpdateWindow();
  }
}
//*******************************************************************
#pragma argsused
void TLoadDlg::SetGaugeRange(int min,int max,int gaugenum,int groupnum)
{
  int gauge = gaugenum;
  if (gauge == -1) {gauge = GetActiveGauge();}
  if (gauge == 1 && PG1 != NULL)
  {
    PG1->SetRange(min,max);
  }
  else if (gauge == 2 && PG2 != NULL)
  {
    PG2->SetRange(min,max);
  }
}
//*******************************************************************

