//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  owarnmsg.cpp
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  2.3    08/05/99   M.Perry     baseline
//********************************************************************
#if !defined(__owarnmsg_h)
#include "owarnmsg.h"
#endif

#if !defined(__owarnmsg_rh)
#include "owarnmsg.rh"
#endif

#if !defined(OWL_STATIC_H)
#include "owl\static.h"
#endif

#if !defined(OWL_CHECKBOX_H)
#include "owl\checkbox.h"
#endif

#if !defined(__oapp_h)
#include "oapp.h"
#endif

#if !defined(__oinifile_h)
#include "oinifile.h"
#endif

DEFINE_RESPONSE_TABLE1(TWarnMsgDlg,TDialog)
  EV_COMMAND(IDOK,CmOk),
END_RESPONSE_TABLE;
//*******************************************************************
bool TWarnMsgDlg::CreateExecute(string msg,
                                string title,
                                int warn,
                                bool updateini)
{
  TWarnMsgDlg *pwmd = new TWarnMsgDlg(msg,title);
  pwmd->Execute();
  if (updateini)
  {
    bool enb = pwmd->GetWarnEnb();
    TOgleIniFile *poif = TOgleApp::GetOgleApp()->GetIniFile();
    if (poif != NULL)
    {
      poif->SetWarnMsg((TOgleIniFile::TWarnEnum)warn,enb);
    }
  }
  delete pwmd;
  return true;
}
//*******************************************************************
TWarnMsgDlg::TWarnMsgDlg(string msg,string title)
:TOgleDialog(NULL,IDD_WARNMSG,true),
 bWarnEnb(true),
 PMsgStatic(NULL),
 PEnbCheckBox(NULL),
 strMsg(msg),
 strTitle(title)
{
  PMsgStatic = new TStatic(this,IDC_WARNMSG_STATICTEXT);
  PEnbCheckBox = new TCheckBox(this,IDC_WARNMSG_CHECKBOX);
}
//*******************************************************************
TWarnMsgDlg::~TWarnMsgDlg()
{
  if (PMsgStatic != NULL)
  {
    delete PMsgStatic;
    PMsgStatic = NULL;
  }
  if (PEnbCheckBox != NULL)
  {
    delete PEnbCheckBox;
    PEnbCheckBox = NULL;
  }
}
//*******************************************************************
bool TWarnMsgDlg::GetWarnEnb()
{
  return bWarnEnb;
}
//*******************************************************************
void TWarnMsgDlg::SetupWindow()
{
  TOgleDialog::SetupWindow();

  SetCaption(strTitle.c_str());

  if (PMsgStatic != NULL)
  {
    PMsgStatic->SetCaption(strMsg.c_str());
  }

  if (PEnbCheckBox != NULL)
  {
    PEnbCheckBox->SetCheck(BF_UNCHECKED);
  }
}
//*******************************************************************
void TWarnMsgDlg::CmOk()
{
  if (PEnbCheckBox != NULL)
  {
    bWarnEnb = bool(PEnbCheckBox->GetCheck() == BF_UNCHECKED);
  }
  TOgleDialog::CmOk();
}
//*******************************************************************
