//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  gambler.cpp
//    Project Name:  Ogle
// Original Author:  Dave Anderson
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0               D.Anderson   original baseline
//          9/3/96    M.Perry      changed dialogs.
//  2.0     8/24/97   M.Perry      32-bit conversion.
//********************************************************************
#include "ogambler.h"
//#include <owl\dc.h>
//#include <owl\listbox.h>
#include <owl\edit.h>
#include <owl\checkbox.h>
#include <owl\radiobut.h>
#include <owl\validate.h>
#include <cstring.h>
#include "ogambler.rh"
#include "oplaymgr.h"
#include "oapp.h"
//*******************************************************************
DEFINE_RESPONSE_TABLE1(TGamblerDialog,TDialog)
  EV_COMMAND(IDC_GAMBLER_DONE_BTN,CmDone),
  EV_COMMAND(IDC_GAMBLER_ACTDEACT_BTN,CmActDeAct),
  EV_COMMAND(IDC_GAMBLER_CREATE_BTN,CmCreate),
  EV_COMMAND(IDC_GAMBLER_DELETE_BTN,CmDelete),
  EV_COMMAND(IDC_GAMBLER_HELP_BTN,CmHelp),
  EV_COMMAND(IDC_GAMBLER_STATISTICS_BTN,CmStatistics),
  EV_LBN_SELCHANGE(IDC_GAMBLER_LB,CmLBSelChange),
  EV_LBN_KILLFOCUS(IDC_GAMBLER_LB,CmLBKillFocus),
  EV_LBN_DBLCLK(IDC_GAMBLER_LB,CmLBDblClk),
END_RESPONSE_TABLE;
//*******************************************************************
TGamblerDialog::TGamblerDialog(TWindow* parent, TResId resId,TPlayerMgr* pplayermgr,dword helpid)
:TDialog(parent,resId),
 PPlayerMgr(pplayermgr),
 HelpID(helpid)
{
  ActivateCaption = GetModule()->LoadString(IDS_GAMBLER_ACTIVATE_CAPTION);
  DeActivateCaption = GetModule()->LoadString(IDS_GAMBLER_DEACTIVATE_CAPTION);

  NumPlayersAllowed = PPlayerMgr->GetNumPlayersAllowed();
  PlayerNumsTT = new int16[NumPlayersAllowed];
  LastPlayerIndex = -1;
  // listbox pts for formatting entry string.
  ActiveStart = 2;
  NameStart = int16(ActiveStart + 6);
  SexStart = int16(NameStart + PPlayerMgr->GetMaxNameLength() + 2);
  BankrollStart = int16(SexStart + 2);
  BankrollEnd = int16(BankrollStart + 10);

  PGambler_LB = new TListBox(this,IDC_GAMBLER_LB);
  PActDeAct_Btn = new TButton(this,IDC_GAMBLER_ACTDEACT_BTN);
  PCreate_Btn = new TButton(this,IDC_GAMBLER_CREATE_BTN);
  PDelete_Btn = new TButton(this,IDC_GAMBLER_DELETE_BTN);
  PStatistics_Btn = new TButton(this,IDC_GAMBLER_STATISTICS_BTN);
  PDone_Btn = new TButton(this,IDC_GAMBLER_DONE_BTN);
}
//*******************************************************************
void TGamblerDialog::SetupWindow()
{
	 TDialog::SetupWindow();
	 //get dialog box parameters
	 TRect rec = GetWindowRect();
	 int16 dialogWidth  = int16(rec.right-rec.left);
	 int16 dialogHeight = int16(rec.bottom-rec.top);
	 int16 xRes=   (int16)::GetSystemMetrics(SM_CXSCREEN);
	 int16 yRes=   (int16)::GetSystemMetrics(SM_CYSCREEN);
	 //make in relation to app
	 MoveWindow((xRes - dialogWidth)/2,(yRes - dialogHeight)/2,
					dialogWidth,dialogHeight);

    LoadLB();
    HandleButtonStatus();
}
//*******************************************************************
TGamblerDialog::~TGamblerDialog()
{
  delete PGambler_LB;
  delete PActDeAct_Btn;
  delete PCreate_Btn;
  delete PDelete_Btn;
  delete PStatistics_Btn;
  delete PDone_Btn;
  delete [] PlayerNumsTT;
}
//*******************************************************************
void TGamblerDialog::HandleActDeActStatus()
{
  int16 playernum = GetSelPlayerNum();
  if (!CheckPNIndex(playernum))
  {
    if (GetFocus() == PActDeAct_Btn->HWindow)
    {
      PDone_Btn->SetFocus();
    }
    PActDeAct_Btn->SetCaption(ActivateCaption.c_str());
    PActDeAct_Btn->EnableWindow(false);
    return;
  }
  if (PPlayerMgr->IsPlayerActive(playernum))
  {
    PActDeAct_Btn->SetCaption(DeActivateCaption.c_str());
    PActDeAct_Btn->EnableWindow(true);
  }
  else if (PPlayerMgr->CanActivatePlayer())
  {
    PActDeAct_Btn->SetCaption(ActivateCaption.c_str());
    PActDeAct_Btn->EnableWindow(true);
  }
  else
  {
    PActDeAct_Btn->SetCaption(ActivateCaption.c_str());
    PActDeAct_Btn->EnableWindow(false);
  }
}
//*******************************************************************
void TGamblerDialog::HandleCreateStatus()
{
  bool enable = PPlayerMgr->CanCreatePlayer();
  if (!enable && GetFocus() == PCreate_Btn->HWindow)
  {
    PDone_Btn->SetFocus();
  }
  PCreate_Btn->EnableWindow(enable);
}
//*******************************************************************
void TGamblerDialog::HandleDeleteStatus()
{
  int16 playernum = GetSelPlayerNum();
  if (!CheckPNIndex(playernum))
  {
    if (GetFocus() == PDelete_Btn->HWindow)
    {
      PDone_Btn->SetFocus();
    }
    PDelete_Btn->EnableWindow(false);
    return;
  }
  bool enable = !PPlayerMgr->IsPlayerActive(playernum);
  if (!enable && GetFocus() == PDelete_Btn->HWindow)
  {
    PDone_Btn->SetFocus();
  }
  PDelete_Btn->EnableWindow(enable);
}
//*******************************************************************
void TGamblerDialog::HandleStatisticsStatus()
{
  int16 playernum = GetSelPlayerNum();
  if (!CheckPNIndex(playernum))
  {
    if (GetFocus() == PStatistics_Btn->HWindow)
    {
      PDone_Btn->SetFocus();
    }
    PStatistics_Btn->EnableWindow(false);
    return;
  }
  bool enable = PPlayerMgr->IsPlayerValid(playernum);
  if (!enable && GetFocus() == PStatistics_Btn->HWindow)
  {
    PDone_Btn->SetFocus();
  }
  PStatistics_Btn->EnableWindow(enable);
}
//*******************************************************************
void TGamblerDialog::CmLBSelChange()
{
  HandleButtonStatus();
}
//*******************************************************************
void TGamblerDialog::CmLBKillFocus()
{
}
//*******************************************************************
void TGamblerDialog::CmDone()
{
  if (PPlayerMgr->GetNumActivePlayers() == 0)
  {
    PPlayerMgr->CreateActivateDefPlayer();
  }
  TDialog::CmOk();
}
//*******************************************************************
void TGamblerDialog::CmActDeAct()
{
  if (!PActDeAct_Btn->IsWindowEnabled()) {return;}

  int16 playernum = GetSelPlayerNum();
  if (PPlayerMgr->IsPlayerActive(playernum))
  {
    if (!PPlayerMgr->DeActivatePlayer(playernum))
    {
      string title(*GetModule(),IDS_GAMBLER_CANT_DEACTIVATE);
      string msg(*GetModule(),IDS_GAMBLER_ERROR_DEACTIVATE);
      TGamblerMsgDlg *pgmd = new TGamblerMsgDlg(this,title,msg);
      pgmd->Execute();
      delete pgmd;
    }
  }
  else
  {
    if (!PPlayerMgr->ActivatePlayer(playernum))
    {
      string title(*GetModule(),IDS_GAMBLER_CANT_ACTIVATE);
      string msg(*GetModule(),IDS_GAMBLER_ERROR_ACTIVATE);
      TGamblerMsgDlg *pgmd = new TGamblerMsgDlg(this,title,msg);
      pgmd->Execute();
      delete pgmd;
    }
  }
  ReLoadLB();
}
//*******************************************************************
void TGamblerDialog::CmLBDblClk()
{
  CmActDeAct();
}
//*******************************************************************
void TGamblerDialog::CmCreate()
{
  TGamblerCreateDialog *pgcd = new TGamblerCreateDialog(this,PPlayerMgr,HelpID);
  if (pgcd->Execute() == IDOK)
  {
    ReLoadLB();
  }
  delete pgcd;
}
//*******************************************************************
void TGamblerDialog::CmDelete()
{
  int16 playernum = GetSelPlayerNum();
  if (CheckPNIndex(playernum))
  {
    if (!PPlayerMgr->IsPlayerActive(playernum))
    {
      TGamblerDeleteDialog *pgdd = new TGamblerDeleteDialog(this,PPlayerMgr,playernum,HelpID);
      pgdd->Execute();
      delete pgdd;
      PPlayerMgr->CreateDefPlayer(); // just in case Joe Gambler was deleted.
      ReLoadLB();
    }
  }
}
//*******************************************************************
void TGamblerDialog::CmStatistics()
{
  int16 playernum = GetSelPlayerNum();
  if (!CheckPNIndex(playernum))
  {
    string msg = "Must select gambler to show statistics";
    string title = "Ooops!";
    TGamblerMsgDlg *pgmd = new TGamblerMsgDlg(this,title,msg);
    pgmd->Execute();
    delete pgmd;
    return;
  }
  PPlayerMgr->DoStatisticsDialog(playernum,this);
}
//*******************************************************************
void TGamblerDialog::CmHelp()
{
  TOgleApp::GetOgleApp()->Help(HELP_CONTEXT,HelpID);
}
//*******************************************************************
void TGamblerDialog::ClearPlayerNums()
{
  for (int16 i=0;i<NumPlayersAllowed;i++)
  {
    PlayerNumsTT[i] = -1;
  }
  LastPlayerIndex = -1;
}
//*******************************************************************
void TGamblerDialog::LoadPlayerNums()
{
  for (int16 i = 0;i<NumPlayersAllowed;i++)
  {
    if (PPlayerMgr->IsPlayerValid(i))
    {
      LastPlayerIndex++;
      PlayerNumsTT[LastPlayerIndex] = i;
    }
  }
}
//*******************************************************************
string TGamblerDialog::StringOfSpaces(int16 numspaces)
{
	string strTemp("");
	for (int16 i=0;i<numspaces;i++)
   {
     strTemp += " ";
   }
	return strTemp;
}
//*******************************************************************
string TGamblerDialog::MakeLBString(int16 playernum)
{
  string ActiveStr = ' ';
  if (PPlayerMgr->IsPlayerActive(playernum)) {ActiveStr = '*';}

  string NameStr = PPlayerMgr->GetPlayerName(playernum);

  string SexStr = 'M';
  if (!PPlayerMgr->IsPlayerMale(playernum)) {SexStr = 'F';}

  char buffer[34];
  string tempStr = ltoa(PPlayerMgr->GetPlayerCash(playernum),buffer,10);
  string BankrollStr = '$';
  BankrollStr += tempStr;

  string s = StringOfSpaces(ActiveStart);
  s += ActiveStr;
  s += StringOfSpaces(int16(NameStart - s.length()));
  s += NameStr;
  s += StringOfSpaces(int16(SexStart - s.length()));
  s += SexStr;
  s += StringOfSpaces(int16((BankrollEnd - BankrollStr.length()) - s.length()));
  s += BankrollStr;
  return s;
}
//*******************************************************************
void TGamblerDialog::LoadLB()
// listbox index is used with PlayerNumsTT to get actual PlayerNum.
{
  ClearPlayerNums();
  LoadPlayerNums();
  for (int16 i=0;i<=LastPlayerIndex;i++)
  {
    string s = MakeLBString(PlayerNumsTT[i]);
    PGambler_LB->AddString(s.c_str());
  }
}
//*******************************************************************
void TGamblerDialog::UnLoadLB()
{
  PGambler_LB->ClearList();
}
//*******************************************************************
void TGamblerDialog::ReLoadLB()
{
  int16 selindex = int16(PGambler_LB->GetSelIndex());
  UnLoadLB();
  LoadLB();
  PGambler_LB->SetSelIndex(selindex);
  HandleButtonStatus();
}
//*******************************************************************
//*******************************************************************
DEFINE_RESPONSE_TABLE1(TGamblerDeleteDialog,TDialog)
  EV_COMMAND(IDC_GAMBLER_DELETE_DELETE_BTN,CmDelete),
  EV_COMMAND(IDC_GAMBLER_DELETE_CANCEL_BTN,CmCancel),
  EV_COMMAND(IDC_GAMBLER_DELETE_HELP_BTN,CmHelp),
END_RESPONSE_TABLE;
//*******************************************************************
TGamblerDeleteDialog::TGamblerDeleteDialog(TWindow *parent,TPlayerMgr *pplayermgr,int16 playernum,dword helpid)
:TDialog(parent,IDD_GAMBLER_DELETE),
  PPlayerMgr(pplayermgr),
  PlayerNum(playernum),
  HelpID(helpid)
{
  PDelete_Btn = new TButton(this,IDC_GAMBLER_DELETE_DELETE_BTN);
  PCancel_Btn = new TButton(this,IDC_GAMBLER_DELETE_CANCEL_BTN);
  PHelp_Btn = new TButton(this,IDC_GAMBLER_DELETE_HELP_BTN);
  PName_STB = new TStatic(this,IDC_GAMBLER_DELETE_NAME_STB);
  AboutToDeleteStr = string(*GetModule(),IDS_GAMBLER_DELETE_ABOUTTODELETE);
}
//*******************************************************************
TGamblerDeleteDialog::~TGamblerDeleteDialog()
{
  delete PDelete_Btn;
  delete PCancel_Btn;
  delete PHelp_Btn;
  delete PName_STB;
}
//*******************************************************************
void TGamblerDeleteDialog::SetupWindow()
{
  TDialog::SetupWindow();
  string s = AboutToDeleteStr;
  s += PPlayerMgr->GetPlayerName(PlayerNum);
  PName_STB->SetText(s.c_str());
}
//*******************************************************************
void TGamblerDeleteDialog::CmDelete()
{
  PPlayerMgr->RemovePlayer(PlayerNum);
  TDialog::CmOk();
}
//*******************************************************************
void TGamblerDeleteDialog::CmCancel()
{
  TDialog::CmCancel();
}
//*******************************************************************
void TGamblerDeleteDialog::CmHelp()
{
  TOgleApp::GetOgleApp()->Help(HELP_CONTEXT,HelpID);
}
//*******************************************************************
//*******************************************************************
DEFINE_RESPONSE_TABLE1(TGamblerCreateDialog,TDialog)
  EV_COMMAND(IDC_GAMBLER_CREATE_CREATE_BTN,CmCreate),
  EV_COMMAND(IDC_GAMBLER_CREATE_CANCEL_BTN,CmCancel),
  EV_COMMAND(IDC_GAMBLER_CREATE_HELP_BTN,CmHelp),
  EV_COMMAND(IDC_GAMBLER_CREATE_200_RBTN,Cm200),
  EV_COMMAND(IDC_GAMBLER_CREATE_500_RBTN,Cm500),
  EV_COMMAND(IDC_GAMBLER_CREATE_2500_RBTN,Cm2500),
  EV_COMMAND(IDC_GAMBLER_CREATE_MALE_RBTN,CmMale),
  EV_COMMAND(IDC_GAMBLER_CREATE_FEMALE_RBTN,CmFemale),
END_RESPONSE_TABLE;
//*******************************************************************
TGamblerCreateDialog::TGamblerCreateDialog(TWindow *parent,TPlayerMgr *pplayermgr,dword helpid)
:TDialog(parent,IDD_GAMBLER_CREATE),
 PPlayerMgr(pplayermgr),
 HelpID(helpid)
{
  PCreate_Btn = new TButton(this,IDC_GAMBLER_CREATE_CREATE_BTN);
  PCancel_Btn = new TButton(this,IDC_GAMBLER_CREATE_CANCEL_BTN);
  PHelp_Btn = new TButton(this,IDC_GAMBLER_CREATE_HELP_BTN);
  PName_ETB = new TEdit(this,IDC_GAMBLER_CREATE_NAME_EB,PPlayerMgr->GetMaxNameLength() + 1);
  PName_ETB->SetValidator(new TFilterValidator("A-Za-z0-9 "));
  P200_RBtn = new TRadioButton(this,IDC_GAMBLER_CREATE_200_RBTN);
  P500_RBtn = new TRadioButton(this,IDC_GAMBLER_CREATE_500_RBTN);
  P2500_RBtn = new TRadioButton(this,IDC_GAMBLER_CREATE_2500_RBTN);
  PMale_RBtn = new TRadioButton(this,IDC_GAMBLER_CREATE_MALE_RBTN);
  PFemale_RBtn = new TRadioButton(this,IDC_GAMBLER_CREATE_FEMALE_RBTN);

  OoopsStr = string(*GetModule(),IDS_GAMBLER_CREATE_OOOPS);
  MustEnterNameStr = string(*GetModule(),IDS_GAMBLER_CREATE_MUSTENTERNAME);
  EnteredUsedNameStr = string(*GetModule(),IDS_GAMBLER_CREATE_ENTEREDUSEDNAME);
  UnknownErrorStr = string(*GetModule(),IDS_GAMBLER_CREATE_UNKNOWNERROR);
}
//*******************************************************************
TGamblerCreateDialog::~TGamblerCreateDialog()
{
  delete PCreate_Btn;
  delete PCancel_Btn;
  delete PHelp_Btn;
  delete PName_ETB;
  delete P200_RBtn;
  delete P500_RBtn;
  delete P2500_RBtn;
  delete PMale_RBtn;
  delete PFemale_RBtn;
}
//*******************************************************************
void TGamblerCreateDialog::SetupWindow()
{
  TDialog::SetupWindow();
  PMale_RBtn->SetCheck(BF_CHECKED);
  PFemale_RBtn->SetCheck(BF_UNCHECKED);
  P200_RBtn->SetCheck(BF_UNCHECKED);
  P500_RBtn->SetCheck(BF_CHECKED);
  P2500_RBtn->SetCheck(BF_UNCHECKED);
}
//*******************************************************************
void TGamblerCreateDialog::CmMale()
{
  PMale_RBtn->SetCheck(BF_CHECKED);
  PFemale_RBtn->SetCheck(BF_UNCHECKED);
}
//*******************************************************************
void TGamblerCreateDialog::CmFemale()
{
  PFemale_RBtn->SetCheck(BF_CHECKED);
  PMale_RBtn->SetCheck(BF_UNCHECKED);
}
//*******************************************************************
void TGamblerCreateDialog::Cm200()
{
  P200_RBtn->SetCheck(BF_CHECKED);
  P500_RBtn->SetCheck(BF_UNCHECKED);
  P2500_RBtn->SetCheck(BF_UNCHECKED);
}
//*******************************************************************
void TGamblerCreateDialog::Cm500()
{
  P200_RBtn->SetCheck(BF_UNCHECKED);
  P500_RBtn->SetCheck(BF_CHECKED);
  P2500_RBtn->SetCheck(BF_UNCHECKED);
}
//*******************************************************************
void TGamblerCreateDialog::Cm2500()
{
  P200_RBtn->SetCheck(BF_UNCHECKED);
  P500_RBtn->SetCheck(BF_UNCHECKED);
  P2500_RBtn->SetCheck(BF_CHECKED);
}
//*******************************************************************
string TGamblerCreateDialog::GetName()
{
  int16 len = int16(PName_ETB->GetTextLen());
  char *buffer = new char[len + 2];
  PName_ETB->GetText(buffer,len + 1);
  string s = buffer;
  delete [] buffer;
  s.strip(string::Both);
  return s;
}
//*******************************************************************
bool TGamblerCreateDialog::IsNameOk(string name)
{
  if (strlen(name.c_str()) == 0)
  {
    TGamblerMsgDlg *pgmd = new TGamblerMsgDlg(this,OoopsStr,MustEnterNameStr);
    pgmd->Execute();
    delete pgmd;
    return false;
  }
  if (PPlayerMgr->IsPlayerValid(name))
  {
    TGamblerMsgDlg *pgmd = new TGamblerMsgDlg(this,OoopsStr,EnteredUsedNameStr);
    pgmd->Execute();
    delete pgmd;
    return false;
  }
  return true;
}
//*******************************************************************
bool TGamblerCreateDialog::GetSex()
{
  if (PMale_RBtn->GetCheck() == BF_CHECKED) {return true;}
  return false;
}
//*******************************************************************
int16 TGamblerCreateDialog::GetBankroll()
{
  if (P200_RBtn->GetCheck() == BF_CHECKED)      {return 200;}
  else if (P500_RBtn->GetCheck() == BF_CHECKED) {return 500;}
  else                                          {return 2500;}
}
//*******************************************************************
void TGamblerCreateDialog::CmCreate()
{
  string title = "Info - Create Gambler";
  string name = GetName();
  if (!IsNameOk(name)) {return;}
  bool sex = GetSex();
  int16 bankroll = GetBankroll();
  if (!PPlayerMgr->CreatePlayer(name,sex,bankroll))
  {
    TGamblerMsgDlg *pgmd = new TGamblerMsgDlg(this,OoopsStr,UnknownErrorStr);
    pgmd->Execute();
    delete pgmd;
    return;
  }
  if (PPlayerMgr->ActivatePlayer(name))
  {
    string s = "Gambler ";
    s += name;
    s += " was also activated for your convenience.\n\nYou should see an asterisk next to the name.";
    TGamblerMsgDlg *pgmd = new TGamblerMsgDlg(this,title,s);
    pgmd->Execute();
    delete pgmd;
  }
  else if (PPlayerMgr->GetNumActivePlayers() == PPlayerMgr->GetNumActiveAllowed())
  {
    char buffer[34];
    ltoa(PPlayerMgr->GetNumActiveAllowed(),buffer,10);
    string s = "Due to the ";
    s += buffer;
    s += " active gambler limit gambler ";
    s += name;
    s += " couldn't be activated at this time.";
    s += "\nYou must DeActivate a gambler with an asterisk next to the name and then Activate ";
    s += name;
    s += ".";
    TGamblerMsgDlg *pgmd = new TGamblerMsgDlg(this,title,s);
    pgmd->Execute();
    delete pgmd;
  }
  else
  {
    string s = "Due to unknown reason gambler";
    s += name;
    s += "couldn't be activated at this time.";
    TGamblerMsgDlg *pgmd = new TGamblerMsgDlg(this,title,s);
    pgmd->Execute();
    delete pgmd;
  }
  TDialog::CmOk();
}
//*******************************************************************
void TGamblerCreateDialog::CmCancel()
{
  TDialog::CmCancel();
}
//*******************************************************************
void TGamblerCreateDialog::CmHelp()
{
  TOgleApp::GetOgleApp()->Help(HELP_CONTEXT,HelpID);
}
//*******************************************************************
//*******************************************************************
TGamblerMsgDlg::TGamblerMsgDlg(TWindow *pwin,string title,string msg)
:TDialog(pwin,IDD_GAMBLER_MSG)
{
  PMsg_STB = new TStatic(this,IDC_GAMBLER_MSG_STB);
  strTitle = title;
  strMsg = msg;
}
//*******************************************************************
TGamblerMsgDlg::~TGamblerMsgDlg()
{
  delete PMsg_STB;
  PMsg_STB = NULL;
}
//*******************************************************************
void TGamblerMsgDlg::SetupWindow()
{
  TDialog::SetupWindow();
  SetCaption(strTitle.c_str());
  PMsg_STB->SetText(strMsg.c_str());
}
//*******************************************************************

