//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  ogobjlst.cpp
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     6/24/95    M.Perry    original baseline
//  2.0     8/24/97    M.Perry    32-bit conversion.
//********************************************************************
#if !defined(__ogobjlst_h)
#include "ogobjlst.h"
#endif

#if !defined(__omodewin_h)
#include "omodewin.h"
#endif

#if !defined(__ofilemgr_h)
#include "ofilemgr.h"
#endif

#include <assert.h>

#if !defined(__omode_h)
#include "omode.h"
#endif
//*******************************************************************
#if defined(GED_COMPILE)
bool TGObjList::CheckSpriteIDConflict()
{
  bool rc = true;
  int16 numgo = GetLAEN();
  for (int16 i=0;i<=numgo;i++)
  {
    TGameObject *pgo = GetGObjPtr(i);
    if (pgo != NULL)
    {
      bool rc2 = pgo->CheckSpriteIDConflict();
      if (rc)
      {
        rc = rc2;
      }
    }
  }
  return rc;
}
#endif
//*******************************************************************
#if defined(GED_COMPILE)
bool TGObjList::CheckSpriteIDUsage()
{
  bool rc = true;
  int16 numgo = GetLAEN();
  for (int16 i = 0;i<=numgo;i++)
  {
    TGameObject *pgo = GetGObjPtr(i);
    if (pgo != NULL)
    {
      bool rc2 = pgo->CheckSpriteIDUsage();
      if (rc)
      {
        rc = rc2;
      }
    }
  }
  return rc;
}
#endif
//*******************************************************************
#ifdef GED_COMPILE
bool TGObjList::IsSpriteUsedBySkit(int16 gobjindex,int16 spriteindex,int16 &usedgi,int16 &usedskci,int16 &usedski)
{
  for (int16 i=0;i<=LastAddedElementNum;i++)
  {
    TGameObject *pgobj = GetGObjPtr(i);
    if (pgobj != NULL)
    {
      if (pgobj->IsSpriteUsedBySkit(gobjindex,spriteindex,usedskci,usedski))
      {
        usedgi = i;
        return true;
      }
    }
  }
  return false;
}
#endif
//*******************************************************************
void TGObjList::Show()
{
}
//*******************************************************************
void TGObjList::NoShow()
{
}
//*******************************************************************
#pragma argsused
bool TGObjList::IsActiveElement(int16 ElementNum)
{
  return true;
}
//*******************************************************************
#pragma argsused
bool TGObjList::IsActiveElement(TOgleBase *PBase)
{
  return true;
}
//*******************************************************************
#pragma argsused
bool TGObjList::ActivateElement(int16 ElementNum,dword StartFUC)
{
  return true;
}
//*******************************************************************
#pragma argsused
bool TGObjList::ActivateElement(TOgleBase *PBase,dword StartFUC)
{
  return true;
}
//*******************************************************************
#pragma argsused
void TGObjList::DeActivateElement(int16 ElementNum)
{
}
//*******************************************************************
#pragma argsused
void TGObjList::DeActivateElement(TOgleBase *PBase)
{
}
//*******************************************************************
#ifdef DEBUGSPRITES
void TGObjList::RTReport(ofstream &os)
{
  os<<"Start of Run Time GObjList Report\n";
  for (int16 i=0;i<=LastAddedElementNum;i++)
  {
    if (GetGObjPtr(i) != NULL) {GetGObjPtr(i)->RTReport(os);}
    else {os<<"Index #"<<i<<" ,GObj was NULL"<<"\n";}
  }
}
#endif
//*******************************************************************
void TGObjList::ShuttingDown()
{
  for (int16 i = 0;i<=LastAddedElementNum;i++)
  {
    TGameObject *pgobj = GetGObjPtr(i);
    if (pgobj != NULL) {pgobj->ShuttingDown();}
  }
}
//*******************************************************************
void TGObjList::Activate(dword StartFUC)
{
  for (int16 i=0;i<=LastAddedElementNum;i++)
  {
    TGameObject *pgobj = GetGObjPtr(i);
    if (pgobj != NULL) {pgobj->Activate(StartFUC);}
  }
}
//*******************************************************************
void TGObjList::DeActivate()
{
  for (int16 i=0;i<=LastAddedElementNum;i++)
  {
    TGameObject *pgobj = GetGObjPtr(i);
    if (pgobj != NULL) {pgobj->DeActivate();}
  }
}
//*******************************************************************
bool TGObjList::Save()
{
  if (!GetSorted())
  {
    Sort();
    SetIndexes();
  }
  
  if (!Write()) {return false;}
  return true;
}
//*******************************************************************
void TGObjList::SetMajVer()
{
  MajVer = 2;
}
//*******************************************************************
string TGObjList::AddExt()
{
  return string(".gol");
}
//*******************************************************************
const char *TGObjList::GetIDChars() const
{
  return "GOL ";
}
//*******************************************************************
bool TGObjList::ReadLocal()
{
  switch (MajVer)
  {
    case 2:return ReadLocal2_0();
    default:return false;
  }
}
//*******************************************************************
bool TGObjList::WriteLocal()
{
  int16 numgobjs = int16(LastAddedElementNum + 1);
  if (!Writeint16(&numgobjs)) {return false;}
  string s;
  int16 id;
  for (int16 i=0;i<=LastAddedElementNum;i++)
  {
    TGameObject *pgobj = GetGObjPtr(i);
    if (pgobj != NULL)
    {
      s = pgobj->FileMode.Name.GetStr();
      if (!WriteFileName(s)) {return false;}
      id = pgobj->GetID();
      if (!Writeint16(&id)) {return false;}
    }
  }

  for (int16 i = 0;i<=LastAddedElementNum;i++)
  {
    TGameObject *pgobj = GetGObjPtr(i);
    if (pgobj != NULL) {pgobj->Save();}
  }
  return true;
}
//*******************************************************************
bool TGObjList::ReadLocal2_0()
{
  int16 numgobjs;
  if (!Readint16(&numgobjs)) {return false;}
  CreateNameArray(numgobjs);
  string s;
  int16 id;
  for (int16 i=0;i<numgobjs;i++)
  {
    if (!ReadFileName(s)) {return false;}
    PNames[i] = s;
    if (!Readint16(&id)) {return false;}
    PIDs[i] = id;
  }
  bool rc = CreateGObjs();
  DestroyNameArray();
  SetSorted();  // assuming already sorted when written out.
  return rc;
}
//*******************************************************************
void TGObjList::CreateNameArray(int16 numnames)
{
  DestroyNameArray();

  NumNames = numnames;
  PNames = new string[NumNames];
  PIDs = new int16[NumNames];
  for (int16 i = 0;i<NumNames;i++)
  {
    PIDs[i] = i; // default id for old gobj data files.
  }
}
//*******************************************************************
void TGObjList::DestroyNameArray()
{
  if (PNames != NULL)
  {
    delete [] PNames;
    PNames = NULL;
  }
  if (PIDs != NULL)
  {
    delete [] PIDs;
    PIDs = NULL;
  }
  NumNames = 0;
}
//*******************************************************************
bool TGObjList::CreateGObjs(void *psource)
//note: called by ReadLocal, and by old TOgleMode.
{
  TFileMode fm = FileMode;
  fm.SetRamImmed();
  for (int16 i=0;i<NumNames;i++)
  {
    fm.Name = PNames[i];
//    fm.SetDirIndex(int16(GetLAEN() + 1));
    if (!CreateAddGObj(fm,PIDs[i],psource)) {return false;}
  }
  PostRead();
  return true;
}
//*******************************************************************
void TGObjList::SetIDs()
//note: only used by TOgleMode with old data files.
{
  TGameObject *pgobj;
  for (int16 i=0;i<NumNames;i++)
  {
    pgobj = GetGObjPtr(i);
    if (pgobj != NULL)
    {
      pgobj->SetID(PIDs[i]);
    }
  }
}
//*******************************************************************
void TGObjList::Slenderize()
{
  for (int16 i=0;i<= LastAddedElementNum;i++)
  {
    TGameObject *pgobj = GetGObjPtr(i);
    if (pgobj != NULL) {pgobj->Slenderize();}
  }
}
//*******************************************************************
TGObjList::TGObjList(TOgleModeWindow *pmw,TOgleMode *pmode)
:TOgleList(pmw),
 PMode(pmode),
 PNames(NULL),
 PIDs(NULL),
 NumNames(0)
{
  // see ctor hack note below. Probably not required for this ctor.
  if (pmode != NULL)
  {
    pmode->SetGObjList(this);
  }
}
//*******************************************************************
TGObjList::TGObjList(TOgleModeWindow *pmw,TOgleMode *pmode,TFileMode &fm)
:TOgleList(pmw,false,fm),
 PMode(pmode),
 PNames(NULL),
 PIDs(NULL),
 NumNames(0)
{
  // mrp - v2.4 - hack !! - fixes problems of gobj's and child obj's trying to
  // access modewin/modes->gobjlist before PGObjList is assigned ptr value.
  // adding to all ctor's. Unfortunately, means modewin/mode can only have 1
  // gobjlist, because of reach back and diddle. Maybe, set through
  // mode's method which add's to array, the index of which is passed in
  // via param and used to call back.
  if (pmode != NULL)
  {
    pmode->SetGObjList(this);
  }
  Init(fm,true,false);
}
//*******************************************************************
TGObjList::~TGObjList()
{
  PModeWin->DestroyPlayerList();
  DestroyNameArray();
}
//*******************************************************************
TGameObject *TGObjList::CreateNewElement(TFileMode NewFileMode)
{
  return (CreateGObj(NewFileMode));
}
//*******************************************************************
bool TGObjList::IsActiveSprite(int16 GObjIndex,int16 ListNum)
{
  TGameObject *pgobj = GetGObjPtr(GObjIndex);
  if (pgobj == NULL) {return false;}
  return pgobj->IsActiveSprite(ListNum);
}
//*******************************************************************
bool TGObjList::ActivateSprite(int16 GObjIndex,int16 ListNum,dword StartFUC)
{
  TGameObject *pgobj = GetGObjPtr(GObjIndex);
  if (pgobj == NULL) {return false;}
  return pgobj->ActivateSprite(ListNum,StartFUC);
}
//*******************************************************************
bool TGObjList::ActivateSkit(int16 GObjIndex,int16 SkitCatIndex,int16 SkitIndex,dword StartFUC)
{
  TGameObject *pgobj = GetGObjPtr(GObjIndex);
  if (pgobj == NULL) {return false;}
  return pgobj->ActivateSkit(SkitCatIndex,SkitIndex,StartFUC);
}
//*******************************************************************
dword TGObjList::GetSkitLength(int16 GObjIndex,int16 SkitCatIndex,int16 SkitIndex)
{
  TGameObject *pgobj = GetGObjPtr(GObjIndex);
  if (pgobj == NULL) {return 0;}
  return pgobj->GetSkitLength(SkitCatIndex,SkitIndex);
}
//*******************************************************************
dword TGObjList::GetSpriteLength(int16 GObjIndex,int16 SpriteIndex)
{
  TGameObject *pgobj = GetGObjPtr(GObjIndex);
  if (pgobj == NULL) {return 0;}
  return pgobj->GetSpriteLength(SpriteIndex);
}
//*******************************************************************
bool TGObjList::CanActivateSprite(int16 GObjIndex,int16 ListNum,dword StartFUC)
{
  TGameObject *pgobj = GetGObjPtr(GObjIndex);
  if (pgobj == NULL) {return false;}
  return pgobj->CanActivateSprite(ListNum,StartFUC);
}
//*******************************************************************
bool TGObjList::SetDefDir(int16 index,string name)
{
  TOgleFileName ofn;
  ofn.SetDirPath(name);
  GetFileMgr()->PDat->SetDir(index,ofn.GetDirPath());
  return true;
}
//*******************************************************************
TGameObject *TGObjList::CreateGObj(TFileMode &fm)
{
  return CreateGObj(fm,int16(LastAddedElementNum + 1));
}
//*******************************************************************
TGameObject *TGObjList::CreateGObj(TFileMode &fm,int16 id,void *psource)
{
  if (GetMode() == NULL) {return NULL;}
  SetDefDir(int16(LastAddedElementNum + 1),fm.Name.GetFName());
  fm.SetDirIndex(int16(GetLAEN() + 1));
  return GetMode()->CreateGObj(fm,id,psource);
}
//*******************************************************************
TGameObject *TGObjList::CreateGObj(string name)
{
  int16 dirindex = int16(LastAddedElementNum + 1);
  TOgleFileName ofn(name);
  SetDefDir(dirindex,ofn.GetFName());
  TGameObject *pgobj = new TGameObject(PModeWin,name,dirindex);
  return pgobj;
}
//*******************************************************************
bool TGObjList::DestroyGObj(TGameObject *pgobj)
{
  int16 gi = GetElementIndex(pgobj);
  if (gi >= 0) {RemoveGObj(gi);}
  return GetMode()->DestroyGObj(pgobj);
}
//*******************************************************************
bool TGObjList::CreateAddGObj(TFileMode &fm,int16 id,void *psource)
{
  return AddGObj(CreateGObj(fm,id,psource));
}
//*******************************************************************
bool TGObjList::CreateAddGObj(TFileMode &fm)
{
  return CreateAddGObj(fm,int16(LastAddedElementNum + 1));
}
//*******************************************************************
TGameObject *TGObjList::CreateAddGObj(string name)
{
  TGameObject *pgobj = CreateGObj(name);
  if (pgobj != NULL)
  {
    if (!AddGObj(pgobj))
    {
      DestroyGObj(pgobj);
      pgobj = NULL;
    }
  }
  return pgobj;
}
//*******************************************************************
bool TGObjList::AddGObj(TGameObject *PGObj)
{
  if (PGObj == NULL) {return false;}

//  int16 Index = int16(LastAddedElementNum + 1);
//  PGObj->FileMode.SetDirIndex(Index);
//  SetDefDir(Index,PGObj->FileMode.Name.GetFName());
  return AddElement(PGObj);
}
//*******************************************************************
TGameObject *TGObjList::RemoveGObj(int16 gi)
{
  bool removed = false;
  TGameObject *PGObj = GetGObjPtr(gi);
  if (PGObj != NULL)
  {
    //don't let list code do delete.
    bool lo = GetOwnListPtrs();
    ClearOwnListPtrs();

    removed = RemoveElement(gi);
//    if (RemoveElement(gi))
//    {
//      return PGObj;
//    }
    // now set list's flag back to like before.
    if (lo) {SetOwnListPtrs();}
    if (removed) {return PGObj;}
  }
  return NULL;
}
//*******************************************************************
bool TGObjList::DeleteGObj(int16 gi)
{
  if (!CheckElementNum(gi)) {return false;}

//  bool rc = false;
  TGameObject *PGObj = RemoveGObj(gi);
//  if (PGObj != NULL)
//  {
//    GetFileMgr()->PDat->SetDir(gi,TAppString::strEmpty);
//    return true;
//  }
//  return false;

  // Mike -> ?? delete ptr first ??
  if (PGObj != NULL)
  {
//    rc = true;
    delete PGObj;
    PGObj = NULL;
  }
//  return bool(PGObj != NULL);
//  return rc;
  return true;
}
//*******************************************************************
void TGObjList::Update(dword NewFUC)
{
  for (int16 i=0;i<=LastAddedElementNum;i++)
  {
    #if defined(DEBUGUPDATES)
    PModeWin->DebugUpdate.SetCurGObjIndex(i);
    #endif
    TGameObject *pgobj = GetGObjPtr(i);
    if (pgobj != NULL) {pgobj->Update(NewFUC);}
  }
}
//*******************************************************************
void TGObjList::PostUpdate(dword NewFUC)
{
  for (int16 i=0;i<=LastAddedElementNum;i++)
  {
    #if defined(DEBUGUPDATES)
    PModeWin->DebugUpdate.SetCurGObjIndex(i);
    #endif
    TGameObject *pgobj = GetGObjPtr(i);
    if (pgobj != NULL) {pgobj->PostUpdate(NewFUC);}
  }
}
//*******************************************************************
int16 TGObjList::GetGObjIndex(string GObjName)
{
  for (int16 i=0;i<=LastAddedElementNum;i++)
  {
    TGameObject *pgobj = GetGObjPtr(i);
    // mrp - v2.4 - ??? - do these strings/ofn's need to be set to lower case
    // before comparison, and/or is lower case guarenteed by here.
    // maybe add known lowercase flag to ofn
    if ((pgobj != NULL) && (pgobj->FileMode.Name.GetStr() == GObjName)) {return i;}
  }

  #if defined(OGLE_DEBUG_GOBJ)
  if (GetModeWin() != NULL)
  {
    string title = "Warning - GObjList";
    string pstrmsg[2];
    pstrmsg[0] = "TGObjList::GetGObjIndex(string gobjname)";
    pstrmsg[1] = "return GObjIndex == -1";
    GetModeWin()->ScrollMsg(title,pstrmsg,2,true);
  }
  #endif
  return -1;
}
//*******************************************************************
void TGObjList::RunState()
{
  for (int16 i=0;i<=LastAddedElementNum;i++)
  {
    TGameObject *pgobj = GetGObjPtr(i);
    if (pgobj != NULL) {pgobj->RunState();}
  }
}
//*******************************************************************
void TGObjList::UpdateState(dword NewFUC)
{
  for (int16 i=0;i<=LastAddedElementNum;i++)
  {
    TGameObject *pgobj = GetGObjPtr(i);
    if (pgobj != NULL) {pgobj->UpdateState(NewFUC);}
  }
}
//*******************************************************************
void TGObjList::PostUpdateState(dword NewFUC)
{
  for (int16 i=0;i<=LastAddedElementNum;i++)
  {
    TGameObject *pgobj = GetGObjPtr(i);
    if (pgobj != NULL) {pgobj->PostUpdateState(NewFUC);}
  }
}
//*******************************************************************
void TGObjList::SetIndexes()
{
  for (int16 i=0;i<=LastAddedElementNum;i++)
  {
    TGameObject *pgobj = GetGObjPtr(i);
    if (pgobj != NULL) {pgobj->SetIndexes();}
  }
}
//*******************************************************************
void TGObjList::NotifyModeNumGObjs(int16 numgobjs)
{
  if (GetMode() == NULL) {return;}
  GetMode()->NotifyNumGObjs(numgobjs);
}
//*******************************************************************
void TGObjList::PostRead()
{
  SetIndexes();
//  Activate(GetAdjFUC() + STARTLOAD_DELTA + 5);
  // the old statement would never do loadahead, especially for idles.
  Activate(GetAdjFUC()); // mrp - v2.4 - 09/10/99 - choppy hslots lobby sound.

  if (GetMode() != NULL)
  {
    GetMode()->SetupGObjs();
  }

  #if !defined(GED_COMPILE)
  Slenderize();
  #endif
}
//*******************************************************************
