//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  ogobjsk.cpp
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     2/5/96     M.Perry     original baseline
//  2.0     8/23/97    M.Perry     32-bit conversion.
//********************************************************************
#if !defined(__ogobjsk_h)
#include "ogobjsk.h"
#endif

#if !defined(__oskitcat_h)
#include "oskitcat.h"
#endif

#if !defined(__osprlist_h)
#include "osprlist.h"
#endif
//*******************************************************************
#ifdef GED_COMPILE
void TGObjSk::ReportSpriteUsage(ofstream &os,int16 gobjindex,int16 skitcatindex,int16 skitindex,int16 spriteindex)
{
  TSkitCat *pskitcat = GetSkitCat();
  if (pskitcat == NULL) {return;}

  if (spriteindex == -1)
  {
    int16 numsprites = GetLastNumSprites();
    for (int16 i=0;i<=numsprites;i++)
    {
      os<<"***************************************************\n";
//      os<<"Sprite Name: "<< GetSpriteList()->GetSpriteFName(i)<<"\n\n";
      os<<"Sprite Name: "<< GetSpriteList()->GetSpriteName(i)<<"\n\n";
      pskitcat->ReportSpriteUsage(os,gobjindex,skitcatindex,skitindex,i);
    }
  }
  else
  {
    os<<"***************************************************\n";
//    os<<"Sprite Name: "<<GetSpriteList()->GetSpriteFName(spriteindex)<<"\n\n";
    os<<"Sprite Name: "<<GetSpriteList()->GetSpriteName(spriteindex)<<"\n\n";
    pskitcat->ReportSpriteUsage(os,gobjindex,skitcatindex,skitindex,spriteindex);
  }
}
#endif
//*******************************************************************
#ifdef GED_COMPILE
bool TGObjSk::IsSpriteUsedBySkit(int16 gobjindex,int16 spriteindex,int16 &usedskci,int16 &usedski)
{
  if (GetSkitCat() == NULL) {return false;}
  return GetSkitCat()->IsSpriteUsedBySkit(gobjindex,spriteindex,usedskci,usedski);
}
#endif
//*******************************************************************
TGObjSk::TGObjSk(TOgleModeWindow *pmw)
:TGObjSp(pmw),
 PSkitCat(NULL)
{
}
//*******************************************************************
TGObjSk::TGObjSk(TOgleModeWindow *pmw,const TFileMode &fm)
:TGObjSp(pmw,fm),
 PSkitCat(NULL)
{
}
//*******************************************************************
TGObjSk::~TGObjSk()
{
  if (PSkitCat != NULL)
  {
    delete PSkitCat;
    PSkitCat = NULL;
  }
}
//*******************************************************************
void TGObjSk::SetIndexes()
{
  TGObjSp::SetIndexes();
  
  #if defined(GED_COMPILE)
  if (GetSkitCat() != NULL) {GetSkitCat()->SetIndexes();}
  #endif
}
//*******************************************************************
void TGObjSk::Slenderize()
{
  TGObjSp::Slenderize();
  if (GetSkitCat() != NULL) {GetSkitCat()->Slenderize();}
}
//*******************************************************************
bool TGObjSk::CreateAddSkitCat(TFileMode skcfm)
{
  PSkitCat = CreateSkitCat(skcfm);
  return true;
}
//*******************************************************************
TSkitCat *TGObjSk::CreateSkitCat(TFileMode skcfm)
{
  return new TSkitCat(PModeWin,skcfm,this);
}
//*******************************************************************
bool TGObjSk::AddSkitCat(TSkitList *PNewSkitList)
{
  if (GetSkitCat() == NULL) {return false;}
  return GetSkitCat()->AddElement(PNewSkitList);
}
//*******************************************************************
bool TGObjSk::AddSkit(TSkit *PSkit,int16 SkitCatIndex)
{
  TSkitList *pskitlist = GetSkitList(SkitCatIndex);
  if (pskitlist == NULL) {return false;}
  return pskitlist->AddElement(PSkit);
}
//*******************************************************************
TSkitList *TGObjSk::GetSkitList(int16 SkitListIndex)
{
  if (GetSkitCat() == NULL) {return NULL;}
  return GetSkitCat()->GetSkitList(SkitListIndex);
}
//*******************************************************************
TSkitList *TGObjSk::GetSkitList(string SkitListName)
{
  if (GetSkitCat() == NULL) {return NULL;}
  return GetSkitCat()->GetSkitList(SkitListName);
}
//*******************************************************************
int16 TGObjSk::GetSkitIndex(int16 skitlistindex,string skitname)
{
  TSkitList *pskitlist = GetSkitList(skitlistindex);
  if (pskitlist == NULL) {return -1;}
  return pskitlist->GetSkitIndex(skitname);
}
//*******************************************************************
int16 TGObjSk::GetSkitCatsLastNum()
{
  if (GetSkitCat() == NULL) {return -1;}
  return GetSkitCat()->GetLAEN();
}
//*******************************************************************
//int16 TGObjSk::CreateAddSkitCat(string NewSkitCatFName)
int16 TGObjSk::CreateAddSkitCat(string skitcatname)
{
  TSkitList *PSkitList = new TSkitList(PModeWin,this);
//  PSkitList->SetBaseName(NewSkitCatFName);
  PSkitList->FileMode.Name = skitcatname;
  PSkitList->FileMode.Name.SetExt(PSkitList->AddExt());
  PSkitList->FileMode.SetDirIndex(FileMode.GetDirIndex());
  AddSkitCat(PSkitList);
//  return GetSkitCat()->GetSkitListIndex(NewSkitCatFName);
//  return GetSkitCat()->GetSkitListIndex(skitcatname);
  return GetSkitCat()->GetSkitListIndex(PSkitList->FileMode.Name.GetStr());
}
//*******************************************************************
//int16 TGObjSk::CreateAddSkit(string NewSkitFName,int16 SkitCatIndex)
int16 TGObjSk::CreateAddSkit(string skitname,int16 skitcatindex)
{
  TSkit *PSkit = new TSkit(PModeWin,this);
//  PSkit->SetBaseName(NewSkitFName);
  PSkit->FileMode.Name = skitname;
  PSkit->FileMode.Name.SetExt(PSkit->AddExt());
  PSkit->FileMode.SetDirIndex(FileMode.GetDirIndex());
//  AddSkit(PSkit,SkitCatIndex);
  AddSkit(PSkit,skitcatindex);

//  TSkitList *pskitlist = GetSkitList(SkitCatIndex);
  TSkitList *pskitlist = GetSkitList(skitcatindex);
  if (pskitlist == NULL) {return -1;}
//  return pskitlist->GetSkitIndex(NewSkitFName);
  return pskitlist->GetSkitIndex(PSkit->FileMode.Name.GetStr());
}
//*******************************************************************
int16 TGObjSk::GetSkitListIndex(const string &SkitListName)
{
  if (GetSkitCat() == NULL) {return -1;}
  return GetSkitCat()->GetSkitListIndex(SkitListName);
}
//*******************************************************************
bool TGObjSk::ChooseStartSkit(int16 SkitCatIndex,dword &StartFUC,dword &FUCLen,int16 &skitindex)
{
  TSkitList *pskitlist = GetSkitList(SkitCatIndex);
  if (pskitlist == NULL) {return false;}
  return pskitlist->ChooseStartSkit(StartFUC,FUCLen,skitindex);
}
//*******************************************************************
bool TGObjSk::ActivateSkit(int16 SkitCatIndex,int16 SkitIndex,dword StartFUC)
{
  if (GetSkitCat() == NULL) {return false;}
  return GetSkitCat()->ActivateSkit(SkitCatIndex,SkitIndex,StartFUC);
}
//*******************************************************************
dword TGObjSk::GetSkitLength(int16 SkitCatIndex,int16 SkitIndex)
{
  if (GetSkitCat() == NULL) {return 0;}
  return GetSkitCat()->GetSkitLength(SkitCatIndex,SkitIndex);
}
//*******************************************************************

