//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  oplaydat.cpp
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     2/27/96    M.Perry    original baseline
//  2.0     8/24/97    M.Perry    32-bit conversion.
//********************************************************************
#include "oplaydat.h"

//*******************************************************************
TPlayerData::TPlayerData()
{
  ClearData();
}
//*******************************************************************
void TPlayerData::ClearData()
{
    SetValid(false);
    SetCash(2000l);
    SetInitialCash(2000l);
    SetMale(true);
    SetName("John Dough");
}
//*******************************************************************
void TPlayerData::SetName(const char *name)
{
  setmem(Name,NAMELENGTH,'\0');
  int16 len = int16(strlen(name));
  if (len > (NAMELENGTH - 1)) {len = NAMELENGTH - 1;}
  strncpy(Name,name,len);
}
//*******************************************************************
void TPlayerData::SetName(const string &name)
{
  setmem(Name,NAMELENGTH,'\0');
  int16 len = int16(strlen(name.c_str()));
  if (len > (NAMELENGTH - 1)) {len = NAMELENGTH - 1;}
  strncpy(Name,name.c_str(),len);
}
//*******************************************************************
const string TPlayerData::GetName()
{
  return string(Name);
}
//*******************************************************************
void TPlayerData::SetMale(bool male)
{
  Male = male;
}
//*******************************************************************
void TPlayerData::SetCash(TMoney cash)
{
  Cash = cash;
}
//*******************************************************************
void TPlayerData::SetInitialCash(TMoney cash)
{
  InitialCash = cash;
}
//*******************************************************************
void TPlayerData::SetValid(bool valid)
{
  Valid = valid;
}
//*******************************************************************

