//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  ogrlist.cpp
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     7/24/96    M.Perry    original baseline
//  2.0     8/22/97    M.Perry    32-bit conversion.
//********************************************************************
#include "ogrlist.h"

//*******************************************************************
TGrList::TGrList()
{
}
//*******************************************************************
TGrList::~TGrList()
{
}
//*******************************************************************
TCompareResult TGrList::CompareLoToHiZ(void *pgr1,void *pgr2)
{
  if (pgr1 == NULL || pgr2 == NULL) {return EQUAL_TO;}
  int z1 = ((TGr *)pgr1)->GetZ();
  int z2 = ((TGr *)pgr2)->GetZ();
  if (z1 > z2) {return GREATER_THAN;}
  if (z1 < z2) {return LESS_THAN;}
  return EQUAL_TO;
}
//*******************************************************************
TCompareResult TGrList::CompareHiToLoZ(void *pgr1,void *pgr2)
{
  if (pgr1 == NULL || pgr2 == NULL) {return EQUAL_TO;}
  int z1 = ((TGr *)pgr1)->GetZ();
  int z2 = ((TGr *)pgr2)->GetZ();
  if (z1 > z2) {return LESS_THAN;}
  if (z1 < z2) {return GREATER_THAN;}
  return EQUAL_TO;
}
//*******************************************************************
void TGrList::SortByZ(bool closest)
{
  TCompareFunct OldCompareFunct;
  if (closest)
  {
    OldCompareFunct = SetCompareFunct(CompareHiToLoZ);
  }
  else
  {
    OldCompareFunct = SetCompareFunct(CompareLoToHiZ);
  }
  SliqSort();
  SetCompareFunct(OldCompareFunct);
}
//*******************************************************************
bool TGrList::AddChanged(TOgleRectList &rectlist)
{
  TGr *pgr = GetFirst();
  while (pgr != NULL)
  {
    if (pgr->GrDrawData.IsChanged())
    {
      rectlist.Add(pgr->GrDrawData.GetOldVRect());
      rectlist.Add(pgr->GrDrawData.GetVRect());
    }
    pgr = GetNext();
  }
  return true;
}
//*******************************************************************
void TGrList::ClearChanged()
{
  TGr *pgr = GetFirst();
  while (pgr != NULL)
  {
    pgr->GrDrawData.SetChanged(false);
    pgr = GetNext();
  }
}
//*******************************************************************

