//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  ogr.cpp
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     4/5/95     M.Perry     original baseline
//********************************************************************
#if !defined(__ogr_h)
#include "ogr.h"
#endif

#if !defined(__omodewin_h)
#include "omodewin.h"
#endif

#if !defined(__omode_h)
#include "omode.h"
#endif

#if !defined(__odc_h)
#include "odc.h"
#endif

#if !defined(__oscrnmgr_h)
#include "oscrnmgr.h"
#endif
//*******************************************************************
TGrData::TGrData()
:VPt(0,0,0),
 OffsetVPt(0,0,0),
 AdjVPt(0,0,0),
 StatFlags(grdUSEDEFAULTXY)
{
}
//*******************************************************************
TGrData::TGrData(TTriplet &vpt,TTriplet &ovpt,TTriplet &avpt,bool usedefaultXY)
:VPt(vpt),
 OffsetVPt(ovpt),
 AdjVPt(avpt)
{
  if (usedefaultXY) {SetUseDefaultXY();}
}
//*******************************************************************
TGrData::TGrData(int16 x,int16 y,int16 z,bool usedefaultXY)
:VPt(x,y,z),
 OffsetVPt(0,0,0),
 AdjVPt(0,0,0)
{
  if (usedefaultXY) {SetUseDefaultXY();}
}
//*******************************************************************
TGrData::TGrData(TGrData &grdata)
:VPt(grdata.VPt),
 OffsetVPt(grdata.OffsetVPt),
 AdjVPt(grdata.AdjVPt)
{
  if (grdata.GetUseDefaultXY()) {SetUseDefaultXY();}
  else                          {ClearUseDefaultXY();}
}
//*******************************************************************
TGrData::~TGrData()
{
}
//*******************************************************************
//*******************************************************************
TGrDrawData::TGrDrawData()
:VRect(0,0,0,0),
 PBits(NULL),
 Z(0),
 FrameNum(0),
 StatFlags(grddCHANGED)
{
}
//*******************************************************************
TGrDrawData::TGrDrawData(TOgleRect &vrect,int16 z,byte *pbits,bool linear,bool topdown)
:VRect(vrect),
 PBits(pbits),
 Z(z),
 FrameNum(0),
 StatFlags(grddCHANGED)
{
  SetTopDown(topdown);
  SetLinear(linear);
}
//*******************************************************************
TGrDrawData::TGrDrawData(TOglePoint &tl,TOglePoint &br,int16 z,byte *pbits,bool linear,bool topdown)
:VRect(tl,br),
 PBits(pbits),
 Z(z),
 FrameNum(0),
 StatFlags(grddCHANGED)
{
  SetLinear(linear);
  SetTopDown(topdown);
}
//*******************************************************************
TGrDrawData::TGrDrawData(int16 x1,int16 y1,int16 x2,int16 y2,int16 z,byte *pbits,bool linear,bool topdown)
:VRect(x1,y1,x2,y2),
 PBits(pbits),
 Z(z),
 FrameNum(0),
 StatFlags(grddCHANGED)
{
  SetLinear(linear);
  SetTopDown(topdown);
}
//*******************************************************************
TGrDrawData::~TGrDrawData()
{
  PBits = NULL;
}
//*******************************************************************
//*******************************************************************
TGr::TGr(TOgleModeWindow *pmw)
:TOgleBase(pmw)
{
}
//*******************************************************************
TGr::TGr(TOgleModeWindow *pmw,const TFileMode &fm)
:TOgleBase(pmw,true,fm)
{
}
//*******************************************************************
TGr::~TGr()
{
  RemoveFromScrnMgr();
}
//*******************************************************************
bool TGr::AddToScrnMgr()
{
  if (GetAddedToScrnMgr()) {return true;}
  if (!GetRamLoaded()) {LoadRamImmed();}
  GrDrawData.GetOldVRect().SetEmpty();
  GrDrawData.SetChanged(true);  // just to make sure.
//  bool Added = PModeWin->PScreenMgr->AddGr(this);
  bool Added = PModeWin->GetMode()->GetScreenMgr()->AddGr(this);
  if (Added) {SetAddedToScrnMgr();}
  else       {ClearAddedToScrnMgr();}
  return Added;
}
//*******************************************************************
bool TGr::RemoveFromScrnMgr()
{
  if (!GetAddedToScrnMgr()) {return true;}

//  bool rc = PModeWin->PScreenMgr->RemoveGr(this);
  bool rc = PModeWin->GetMode()->GetScreenMgr()->RemoveGr(this);
  if (rc) {ClearAddedToScrnMgr();}
  return rc;
}
//*******************************************************************
#pragma argsused
bool TGr::BltTo(TOgleVideoDC &vdc,TOgleRect &clipvrect)
{
  return false;
}
//*******************************************************************

