//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  oskitrow.cpp
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     8/27/95    M.Perry    original baseline
//  2.0     8/24/97    M.Perry    32-bit conversion.
//********************************************************************
#if !defined(__oskitrow_h)
#include "oskitrow.h"
#endif

#if !defined(__osktdlst_h)
#include "osktdlst.h"
#endif
//*******************************************************************
#ifdef GED_COMPILE
void TSkitRow::ReportSpriteUsage(ofstream &os,string &skitname,int16 gobjindex,int16 spriteindex)
{
  for (int16 i=0;i<=LastAddedElementNum;i++)
  {
    TSkitCell *pskitcell = GetSkitCell(i);
    if (pskitcell != NULL)
    {
      pskitcell->ReportSpriteUsage(os,skitname,gobjindex,spriteindex);
    }
  }
}
#endif
//*******************************************************************
#ifdef GED_COMPILE
bool TSkitRow::IsSpriteUsedBySkit(int16 gobjindex,int16 spriteindex)
{
  for (int16 i=0;i<=LastAddedElementNum;i++)
  {
    TSkitCell *pskitcell = GetSkitCell(i);
    if (pskitcell != NULL)
    {
      if (pskitcell->IsSpriteUsedBySkit(gobjindex,spriteindex)) {return true;}
    }
  }
  return false;
}
#endif
//*******************************************************************
int16 TSkitRow::GetNumValidCells()
{
  int16 num = 0;
  for (int16 i=0;i<=LastAddedElementNum;i++)
  {
    TSkitCell *pskitcell = GetSkitCell(i);
    if (pskitcell != NULL)
    {
      num++;
    }
  }
  return num;
}
//*******************************************************************
void TSkitRow::AddToDataList(TSkitDataList *pdatalist,int16 rownum)
{
  for (int16 i=0;i<=LastAddedElementNum;i++)
  {
    TSkitCell *pskitcell = GetSkitCell(i);
    if (pskitcell != NULL)
    {
      pskitcell->AddToDataList(pdatalist,rownum);
    }
  }
}
//*******************************************************************
void TSkitRow::SetMinVer()
{
  MinVer = 1;
}
//*******************************************************************
void TSkitRow::Activate(dword StartFUC)
{
  Start(StartFUC);
}
//*******************************************************************
TSkitRow::TSkitRow(TOgleModeWindow *pmw,TFileMode &NewFileMode,TGObjSk *PNewGObj,
                   void *PReadData,bool AutoRead)
:TOgleRow(pmw,NewFileMode),
 POwnerGObj(PNewGObj)
{
  Init(PReadData,AutoRead);
}
//*******************************************************************
TSkitRow::TSkitRow(TOgleModeWindow *pmw,TFileMode &NewFileMode,TGObjSk *PNewGObj)
:TOgleRow(pmw,NewFileMode),
 POwnerGObj(PNewGObj)
{
}
//*******************************************************************
TSkitRow::~TSkitRow()
{
}
//*******************************************************************
TOgleCell *TSkitRow::CreateNewCell()
{
  return new TSkitCell(GetModeWin(),FileMode,POwnerGObj);
}
//*******************************************************************
TOgleCell *TSkitRow::CreateNewCell(void *PSource)
{
  return new TSkitCell(GetModeWin(),FileMode,POwnerGObj,PSource);
}
//*******************************************************************
void TSkitRow::MakeCellIfNull(int16 CellNum)
{
  if (CheckMap(byte(CellNum))) {return;}

  TSkitCell *PSkitCell = (TSkitCell *)CreateNewCell();
  ManualAddCell(CellNum,PSkitCell);
}
//*******************************************************************
void TSkitRow::ClearCellIfNotNull(int16 CellNum)
{
  TOgleCell *PCell = RemoveCell(byte(CellNum));
  if (PCell != NULL) {delete PCell;}
}
//*******************************************************************
dword TSkitRow::GetCalcFUCLength(int16 RowNum)
{
  dword lf = 0;
  for (int16 i=0;i<8;i++)
  {
    if (CheckMap(byte(i)))
    {
      TSkitCell *pcell = GetSkitCell(i);
      if (pcell != NULL)
      {
        dword cf = pcell->GetCalcFUCLength();
        cf += RowNum;
        if (cf > lf)
        {
          lf = cf;
        }
      }
    }
  }
  return lf;
}
//*******************************************************************

