//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  oskittbl.cpp
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     8/27/95    M.Perry    original baseline
//  2.0     8/24/97    M.Perry    32-bit conversion.
//********************************************************************
#if !defined(__oskittbl_h)
#include "oskittbl.h"
#endif

#if !defined(__osktdlst_h)
#include "osktdlst.h"
#endif
//*******************************************************************
#ifdef GED_COMPILE
void TSkitTable::ReportSpriteUsage(ofstream &os,string &skitname,int16 gobjindex,int16 spriteindex)
{
  for (int16 i=0;i<=LastAddedElementNum;i++)
  {
    TSkitRow *pskitrow = GetSkitRow(i);
    if (pskitrow != NULL)
    {
       pskitrow->ReportSpriteUsage(os,skitname,gobjindex,spriteindex);
    }
  }
}
#endif
//*******************************************************************
#ifdef GED_COMPILE
bool TSkitTable::IsSpriteUsedBySkit(int16 gobjindex,int16 spriteindex)
{
  for (int16 i=0;i<=LastAddedElementNum;i++)
  {
    TSkitRow *pskitrow = GetSkitRow(i);
    if (pskitrow != NULL)
    {
      if (pskitrow->IsSpriteUsedBySkit(gobjindex,spriteindex)) {return true;}
    }
  }
  return false;
}
#endif
//*******************************************************************
int16 TSkitTable::GetNumValidCells()
{
  int16 num = 0;
  for (int16 i=0;i<=LastAddedElementNum;i++)
  {
    TSkitRow *pskitrow = GetSkitRow(i);
    if (pskitrow != NULL)
    {
      num += pskitrow->GetNumValidCells();
    }
  }
  return num;
}
//*******************************************************************
void TSkitTable::AddToDataList(TSkitDataList *pdatalist)
{
  for (int16 i=0;i<=LastAddedElementNum;i++)
  {
    TSkitRow *pskitrow = GetSkitRow(i);
    if (pskitrow != NULL)
    {
      pskitrow->AddToDataList(pdatalist,i);
    }
  }
}
//*******************************************************************
void TSkitTable::SetMinVer()
{
  MinVer = 1;
}
//*******************************************************************
void TSkitTable::Activate(dword StartFUC)
{
  Start(StartFUC);
}
//*******************************************************************
void TSkitTable::Start()
{
  TOgleTable::Start();
}
//*******************************************************************
TSkitTable::TSkitTable(TOgleModeWindow *pmw,TGObjSk *PNewGObj)
:TOgleTable(pmw),
 POwnerGObj(PNewGObj)
{
}
//*******************************************************************
TSkitTable::TSkitTable(TOgleModeWindow *pmw,TFileMode &NewFileMode,TGObjSk *PNewGObj,
                       void *PReadData,bool AutoRead)
:TOgleTable(pmw,true,NewFileMode),
 POwnerGObj(PNewGObj)
{
  Init(PReadData,AutoRead);
}
//*******************************************************************
TSkitTable::~TSkitTable()
{
}
//*******************************************************************
TOgleRow *TSkitTable::CreateNewRow(void *PSource)
{
  return new TSkitRow(PModeWin,FileMode,POwnerGObj,PSource);
}
//*******************************************************************
TOgleRow *TSkitTable::CreateNewRow()
{
  return new TSkitRow(PModeWin,FileMode,POwnerGObj);
}
//*******************************************************************
TSkitCell *TSkitTable::GetSkitCell(int16 RowIndex,int16 CellIndex)
{
  TSkitRow *PSkitRow = GetSkitRow(RowIndex);
  if (PSkitRow == NULL) {return NULL;}
  return PSkitRow->GetSkitCell(CellIndex);
}
//*******************************************************************
void TSkitTable::Start(dword StartFUC)
{
  for (int16 i=0;i<= LastAddedElementNum;i++)
  {
    TSkitRow *pskitrow = GetSkitRow(i);
    if (pskitrow != NULL)
    {
      pskitrow->Start(StartFUC + i);
    }
  }
}
//*******************************************************************
bool TSkitTable::CanActivate(dword StartFUC)
{
  for (int16 i=0;i<= LastAddedElementNum;i++)
  {
    TSkitRow *pskitrow = GetSkitRow(i);
    if (pskitrow != NULL)
    {
      if (!pskitrow->CanActivate(StartFUC + i)) {return false;}
    }
  }
  return true;
}
//*******************************************************************
dword TSkitTable::GetCalcFUCLength()
{
  dword lf = 0;
  for (int16 i=0;i<=LastAddedElementNum;i++)
  {
    TSkitRow *pskitrow = GetSkitRow(i);
    if (pskitrow != NULL)
    {
      dword cf = pskitrow->GetCalcFUCLength(i);
      if (cf > lf)
      {
        lf = cf;
      }
    }
  }
  return lf;
}
//*******************************************************************

