//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  omidi.cpp
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     5/15/95    M.Perry     original baseline
//  2.0     8/23/97    M.Perry     32-bit conversion.
//********************************************************************
#if !defined(__omidi_h)
#include "omidi.h"
#endif

#if !defined(__osndmgr_h)
#include "osndmgr.h"
#endif
//*******************************************************************
TMidi::TMidi()
:TSound(NULL)
{
}
//*******************************************************************
TMidi::TMidi(TFileMode &NewFileMode,bool AutoRead,bool KeepBaseFile)
:TSound(NULL,NewFileMode)
{
  Init(NewFileMode,AutoRead,KeepBaseFile);
}
//*******************************************************************
TMidi::TMidi(TOgleModeWindow *pmw,TFileMode &fm,bool AutoRead,bool KeepBaseFile)
:TSound(pmw,fm)
{
  Init(fm,AutoRead,KeepBaseFile);
}
//*******************************************************************
TMidi::~TMidi()
{
}
//*******************************************************************
string TMidi::AddExt()
{
  return string(".mid");
}
//*******************************************************************
bool TMidi::Play()
{
  return (GetSoundMgr()->Play(this));
}
//*******************************************************************
bool TMidi::PlayMidiAsDefault()
{
  return (GetSoundMgr()->DefPlay(this));
}
//*******************************************************************
void TMidi::Start()
{
  if (GetStarted() && !GetStopped()) {Stop();}
  TSound::Start();
  LoadRamImmed();
  Play();
}
//*******************************************************************
#pragma argsused
void TMidi::Start(dword StartFUC)
{
  Start();
}
//*******************************************************************
void TMidi::Stop()
{
  if (GetStopped()) {return;}
//  GetSoundMgr()->StopWave(this); // change to stopmidi
  SetStopped();
//  ACLoad();
}
//*******************************************************************

