//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  osprrow.cpp
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     6/20/95    M.Perry    original baseline
//  2.0     8/22/97    M.Perry    32-bit conversion.
//********************************************************************
#include "osprrow.h"

//*******************************************************************
void TSpriteRow::SetMinVer()
{
  MinVer = 2;
}
//*******************************************************************
TOgleCell *TSpriteRow::CreateNewCell()
{
  return (new TSpriteCell(GetModeWin(),FileMode));
}
//*******************************************************************
TOgleCell *TSpriteRow::CreateNewCell(void *PSource)
{
  return (new TSpriteCell(GetModeWin(),FileMode,POwnerSprite,PSource));
}
//*******************************************************************
TSpriteRow::TSpriteRow(TOgleModeWindow *pmw,TFileMode &NewFileMode,TSprite *PSprite)
:TOgleRow(pmw,NewFileMode),
 POwnerSprite(PSprite)
{
}
//*******************************************************************
TSpriteRow::TSpriteRow(TOgleModeWindow *pmw,TFileMode &NewFileMode,TSprite *PSprite,
                       void *PReadData,bool AutoRead)
:TOgleRow(pmw,NewFileMode),
 POwnerSprite(PSprite)
{
  Init(PReadData,AutoRead);
}
//*******************************************************************
TSpriteRow::~TSpriteRow()
{
}
//*******************************************************************
TSpriteCell *TSpriteRow::GetSpriteCell(byte CellIndex)
{
  return ((TSpriteCell *)GetCell(CellIndex));
}
//*******************************************************************
void TSpriteRow::MakeCellIfNull(int16 CellNum)
{
  if (CheckMap((byte)CellNum)) {return;}

  TSpriteCell *PSpriteCell = (TSpriteCell *)CreateNewCell();
  ManualAddCell(CellNum,PSpriteCell);
}
//*******************************************************************
void TSpriteRow::ClearCellIfNotNull(int16 CellNum)
{
  TOgleCell *PCell = RemoveCell((byte)CellNum);
  if (PCell != NULL) {delete PCell;}
}
//*******************************************************************

