//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  ospidini.cpp
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  2.4    08/18/99    M.Perry     baseline
//********************************************************************
#if !defined(__ospidini_h)
#include "ospidini.h"
#endif
//*******************************************************************
TSpriteIDIniFile::TSpriteIDIniFile(const TOgleFileName &ofn)
:TIniFile(ofn.GetStr()),
 strInfoSection("Info"),
 strIDSection("ID"),
 strNumIDKey("NumID")
{
}
//*******************************************************************
TSpriteIDIniFile::~TSpriteIDIniFile()
{
}
//*******************************************************************
void TSpriteIDIniFile::Squeeze()
{
  int16 bol = (int16)ReadInt(strInfoSection,strNumIDKey,0);
  int16 lastgoodvalue = 0;
  for (int16 i=0;i<=bol;i++)
  {
    string defstr = GetDefName(i);
    string s = ReadString(strIDSection,i,defstr);
    if (s != defstr)
    {
      lastgoodvalue = i;
    }
  }
  if (lastgoodvalue != bol)
  {
    WriteInt(strInfoSection,strNumIDKey,lastgoodvalue);
  }
}
//*******************************************************************
string TSpriteIDIniFile::GetDefName(int16 id) const
{
  char buffer[33];
  itoa(id,buffer,10);
  string s = "IDCode";
  s += buffer;
  return s;
}
//*******************************************************************
int16 TSpriteIDIniFile::GetNumID() const
{
  return (int16)ReadInt(strInfoSection,strNumIDKey,0);
}
//*******************************************************************
void TSpriteIDIniFile::SetNumID(int16 numid)
{
  WriteInt(strInfoSection,strNumIDKey,numid);
}
//*******************************************************************
string TSpriteIDIniFile::GetIDName(int16 numid) const
{
  return ReadString(strIDSection,numid,GetDefName(numid));
}
//*******************************************************************
void TSpriteIDIniFile::SetIDName(int16 idnum,const string &idname)
{
  WriteString(strIDSection,idnum,idname);
}
//*******************************************************************
