//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  inifile.cpp
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     2/19/96    M.Perry     moved code into cpp file.
//  2.0     8/25/97    M.Perry     32-bit conversion.
//********************************************************************
#if !defined(__inifile_h)
#include "inifile.h"
#endif

//#include "omisc.h"

#if !defined(__ofilenam_h)
#include "ofilenam.h"
#endif
//*******************************************************************
TIniFile::TIniFile(const string &hddrive,const string &hddir,const string &inifilename)
{
  SetHDDrive(hddrive);
  SetHDDir(hddir);
  SetIniFile(inifilename);
  SetFullIniFile();
}
//*******************************************************************
//TIniFile::TIniFile(string fullpathname)
//{
//  string drive;
//  string dir;
//  string fname;
//  string fext;
//  TOgleFileName::SplitUp(fullpathname,drive,dir,fname,fext);
//  string name = fname + fext;
//  SetHDDrive(drive);
//  SetHDDir(dir);
//  SetIniFile(name);
//  SetFullIniFile();
//}
//*******************************************************************
TIniFile::TIniFile(const string &fullpathname)
{
  string drive,dir,fname,fext;
  TOgleFileName::SplitUp(fullpathname,drive,dir,fname,fext);
  string name = fname + fext;
  SetHDDrive(drive);
  SetHDDir(dir);
  SetIniFile(name);
  SetFullIniFile();
}
//*******************************************************************
bool TIniFile::WriteString(const string &inisection,const string &entrykey,const string &newentry)
{
  char buffer[200];
  strcpy(buffer,newentry.c_str());
  return WritePrivateProfileString(inisection.c_str(),
                                   entrykey.c_str(),
                                   buffer,
                                   GetFullIniFile().c_str());
}
//*******************************************************************
bool TIniFile::WriteString(const string &inisection,int entrykey,const string &newentry)
{
  char buffer[17];
  itoa(entrykey,buffer,10);
  string str = buffer;
  return WriteString(inisection,str,newentry);
}
//*******************************************************************
//bool TIniFile::WriteString(const char *inisection,int entrykey,string &newentry)
//{
//  char buffer[17];
//  itoa(entrykey,buffer,10);
//  string entrykeystr = buffer;
//  string inisectionstr = inisection;
//  return WriteString(inisectionstr,entrykeystr,newentry);
//}
//*******************************************************************
//bool TIniFile::WriteString(const char *inisection,const char *entrykey,const char *newentry)
//{
//  char buffer[200];
//  strcpy(buffer,newentry);
//  return WritePrivateProfileString(inisection,entrykey,buffer,GetFullIniFile().c_str());
//}
//*******************************************************************
//bool TIniFile::WriteString(const char *inisection,const char *entrykey,string &newentry)
//{
//  char buffer[200];
//  strcpy(buffer,newentry.c_str());
//  return WritePrivateProfileString(inisection,entrykey,buffer,GetFullIniFile().c_str());
//}
//*******************************************************************
//bool TIniFile::WriteString(string &inisection,const char *entrykey,string &newentry)
//{
//  char buffer[200];
//  strcpy(buffer,newentry.c_str());
//  return WritePrivateProfileString(inisection.c_str(),
//                                   entrykey,
//                                   buffer,
//                                   GetFullIniFile().c_str());
//}
//*******************************************************************
//bool TIniFile::WriteString(string &inisection,string &entrykey,const char *newentry)
//{
//  char buffer[200];
//  strcpy(buffer,newentry);
//  return WritePrivateProfileString(inisection.c_str(),
//                                   entrykey.c_str(),
//                                   buffer,
//                                   GetFullIniFile().c_str());
//}
//*******************************************************************
//bool TIniFile::WriteString(string &inisection,const char *entrykey,const char *newentry)
//{
//  char buffer[200];
//  strcpy(buffer,newentry);
//  return WritePrivateProfileString(inisection.c_str(),
//                                   entrykey,
//                                   buffer,
//                                   GetFullIniFile().c_str());
//}
//*******************************************************************
//bool TIniFile::WriteString(const char *inisection,string &entrykey,string &newentry)
//{
//  char buffer[200];
//  strcpy(buffer,newentry.c_str());
//  return WritePrivateProfileString(inisection,
//                                   entrykey.c_str(),
//                                   buffer,
//                                   GetFullIniFile().c_str());
//}
//*******************************************************************
//bool TIniFile::WriteString(const char *inisection,string &entrykey,const char *newentry)
//{
//  char buffer[200];
//  strcpy(buffer,newentry);
//  return WritePrivateProfileString(inisection,
//                                   entrykey.c_str(),
//                                   buffer,
//                                   GetFullIniFile().c_str());
//}
//*******************************************************************
string TIniFile::ReadString(const string &inisection,
                            const string &entrykey,
                            const string &defaultstring) const
{
  char buffer[_MAX_PATH];
  /*int rc = */GetPrivateProfileString(inisection.c_str(),
                                   entrykey.c_str(),
                                   defaultstring.c_str(),
                                   buffer,
                                   _MAX_PATH,
                                   GetFullIniFile().c_str());
  return string(buffer);
}
//*******************************************************************
string TIniFile::ReadString(const string &inisection,
                            int entrykey,
                            const string &defaultstring) const
{
  char buffer[17];
  itoa(entrykey,buffer,10);
  string str = buffer;
  return ReadString(inisection,str,defaultstring);
}
//*******************************************************************
//string TIniFile::ReadString(const char *inisection,int entrykey,string &defaultstring)
//{
//  char buffer[17];
//  itoa(entrykey,buffer,10);
//  string entrykeystr = buffer;
//  string inisectionstr = inisection;
//  return ReadString(inisectionstr,entrykeystr,defaultstring);
//}
//*******************************************************************
//string TIniFile::ReadString(const char *inisection,int entrykey,const char *defaultstring)
//{
//  char buffer[17];
//  itoa(entrykey,buffer,10);
//  string entrykeystr = buffer;
//  string inisectionstr = inisection;
//  string defstr = defaultstring;
//  return ReadString(inisectionstr,entrykeystr,defstr);
//}
//*******************************************************************
//string TIniFile::ReadString(const char *inisection,const char *entrykey,const char *defaultstring)
//{
//  char buffer[_MAX_PATH];
//  GetPrivateProfileString(inisection,
//                          entrykey,
//                          defaultstring,
//                          buffer,
//                          _MAX_PATH,
//                          GetFullIniFile().c_str());
//  return string(buffer);
//}
//*******************************************************************
//string TIniFile::ReadString(const char *inisection,const char *entrykey,string &defaultstring)
//{
//  char buffer[_MAX_PATH];
//  GetPrivateProfileString(inisection,
//                          entrykey,
//                          defaultstring.c_str(),
//                          buffer,
//                          _MAX_PATH,
//                          GetFullIniFile().c_str());
//  return string(buffer);
//}
//*******************************************************************
//string TIniFile::ReadString(string &inisection,const char *entrykey,const char *defaultstring)
//{
//  char buffer[_MAX_PATH];
//  GetPrivateProfileString(inisection.c_str(),
//                          entrykey,
//                          defaultstring,
//                          buffer,
//                          _MAX_PATH,
//                          GetFullIniFile().c_str());
//  return string(buffer);
//}
//*******************************************************************
//string TIniFile::ReadString(string &inisection,int entrykey,const char *defaultstring)
//{
//  char buffer[17];
//  itoa(entrykey,buffer,10);
//  string entrykeystr = buffer;
//  string defstr = defaultstring;
//  return ReadString(inisection,entrykeystr,defstr);
//}
//*******************************************************************
//string TIniFile::ReadString(const char *inisection,string &entrykey,const char *defaultstring)
//{
//  char buffer[_MAX_PATH];
//  GetPrivateProfileString(inisection,
//                          entrykey.c_str(),
//                          defaultstring,
//                          buffer,
//                          _MAX_PATH,
//                          GetFullIniFile().c_str());
//  return string(buffer);
//}
//*******************************************************************
int TIniFile::ReadInt(const string &inisection,const string &entrykey,int defaultint) const
{
  UINT rc = GetPrivateProfileInt(inisection.c_str(),
                                 entrykey.c_str(),
                                 defaultint,
                                 GetFullIniFile().c_str());
  return rc;
}
//*******************************************************************
int TIniFile::ReadInt(const string &inisection,int entrykey,int defaultint) const
{
  char buffer[17];
  itoa(entrykey,buffer,10);
  string str = buffer;
  return ReadInt(inisection,str,defaultint);
}
//*******************************************************************
//int TIniFile::ReadInt(const char *inisection,const char *entrykey,int defaultint)
//{
//  UINT rc = GetPrivateProfileInt(inisection,entrykey,defaultint,GetFullIniFile().c_str());
//  return rc;
//}
//*******************************************************************
//int TIniFile::ReadInt(string &inisection,const char *entrykey,int defaultint)
//{
//  return GetPrivateProfileInt(inisection.c_str(),entrykey,defaultint,GetFullIniFile().c_str());
//}
//*******************************************************************
bool TIniFile::WriteInt(const string &inisection,const string &entrykey,int newint)
{
  char buffer[17];
  itoa(newint,buffer,10);
  string str = buffer;
  return WriteString(inisection,entrykey,str);
}
//*******************************************************************
bool TIniFile::WriteInt(const string &inisection,int entrykey,int newint)
{
  char buffer[17];
  itoa(entrykey,buffer,10);
  string str = buffer;
  return WriteInt(inisection,str,newint);
}
//*******************************************************************
//bool TIniFile::WriteInt(const char *inisection,const char *entrykey,int newint)
//{
//  char buffer[17];
//  itoa(newint,buffer,10);
//  return WriteString(inisection,entrykey,buffer);
//}
//*******************************************************************
//bool TIniFile::WriteInt(string &inisection,const char *entrykey,int newint)
//{
//  return WriteInt(inisection.c_str(),entrykey,newint);
//}
//*******************************************************************

