//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  odetdlg.cpp
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//                                           
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     4/28/96    M.Perry    original baseline
//  2.0     8/26/97    M.Perry    32-bit conversion.
//********************************************************************
#if !defined(__odetdlg_h)
#include "odetdlg.h"
#endif

#if !defined(__owad_rh)
#include "owad.rh"
#endif

#if !defined(__odetscr_h)
#include "odetscr.h"
#endif

#if !defined(OWL_INPUTDIA_H)
#include <owl\inputdia.h>
#endif

#if !defined(OWL_LISTBOX_H)
#include <owl\listbox.h>
#endif

#if !defined(OWL_BUTTON_H)
#include <owl\button.h>
#endif

#if !defined(OWL_EDIT_H)
#include <owl\edit.h>
#endif

#if !defined(OWL_CHECKBOX_H)
#include <owl\checkbox.h>
#endif
//*******************************************************************
DEFINE_RESPONSE_TABLE1(TDetIncDataDlg,TDialog)
  EV_COMMAND(IDC_INCDONE,CmDone),
  EV_COMMAND(IDC_INCADD,CmAddExt),
  EV_COMMAND(IDC_INCREMOVE,CmRemoveExt),
END_RESPONSE_TABLE;
//*******************************************************************
TDetIncDataDlg::TDetIncDataDlg(TWindow *pwin,TDetIncData &did)
:TDialog(pwin,IDD_INCDLG),DetIncData(did)
{
  PRecurseChB = new TCheckBox(this,IDC_INCRECURSE);
  PExtLB = new TListBox(this,IDC_INCEXTLB);
  PDir = new TEdit(this,IDC_INCNAME);
}
//*******************************************************************
TDetIncDataDlg::~TDetIncDataDlg()
{
  delete PRecurseChB;
  PRecurseChB = NULL;
  delete PExtLB;
  PExtLB = NULL;
  delete PDir;
  PDir = NULL;
}
//*******************************************************************
void TDetIncDataDlg::SetupWindow()
{
  TDialog::SetupWindow();
  if (DetIncData.Recurse) {PRecurseChB->SetCheck(BF_CHECKED);}
  else {PRecurseChB->SetCheck(BF_UNCHECKED);}
  PDir->SetText(DetIncData.Name.c_str());
  LoadExtLB();
}
//*******************************************************************
void TDetIncDataDlg::LoadExtLB()
{
  for (int i=0;i<DetIncData.NumExts;i++)
  {
    string str = "'";
    str += DetIncData.Exts[i];
    str += "'";
    PExtLB->AddString(str.c_str());
  }
}
//*******************************************************************
void TDetIncDataDlg::UnLoadExtLB()
{
  PExtLB->ClearList();
}
//*******************************************************************
void TDetIncDataDlg::CmAddExt()
{
  char buffer[4] = "ext";
  TInputDialog *pid = new TInputDialog(this,"Add Ext","Enter new ext:",buffer,4);
  if (pid->Execute() == IDOK)
  {
    string s = buffer;
    DetIncData.AddExt(s);
    UnLoadExtLB();
    LoadExtLB();
    Invalidate();
  }
}
//*******************************************************************
void TDetIncDataDlg::CmRemoveExt()
{
  int16 index = (int16)PExtLB->GetSelIndex();
  if (index < 0)
  {
    MessageBox("Select Ext First","Error - Remove Ext",MB_OK);
    return;
  }
  else if (index >= DetIncData.NumExts)
  {
    MessageBox("Invalid index","Error - Remove Ext",MB_OK);
    return;
  }
  else
  {
    DetIncData.RemoveExt(index);
    UnLoadExtLB();
    LoadExtLB();
    Invalidate();
  }
}
//*******************************************************************
void TDetIncDataDlg::CmDone()
{
  if (PRecurseChB->GetCheck() == BF_CHECKED)
  {
    DetIncData.Recurse = true;
  }
  else
  {
    DetIncData.Recurse = false;
  }

  // get dir from TEdit
  int len = PDir->GetTextLen() + 1;
  char *buffer = new char[len];
  PDir->GetText(buffer,len);
  string s = buffer;
  s.to_lower();
  // append last slash if not entered by user.
  if (strlen(buffer) > 0)
  {
    size_t index = s.find_last_of("\\");
    if (index == NPOS)
    {
      s += "\\";
    }
    else if (index != (strlen(s.c_str()) - 1))
    {
      s += "\\";
    }
  }
  DetIncData.Name = s;
  delete [] buffer;

  CmOk();
}
//*******************************************************************
//*******************************************************************
DEFINE_RESPONSE_TABLE1(TDetExcDataDlg,TDialog)
  EV_COMMAND(IDC_EXCDONE,CmDone),
END_RESPONSE_TABLE;
//*******************************************************************
TDetExcDataDlg::TDetExcDataDlg(TWindow *pwin,TDetExcData &ded)
:TDialog(pwin,IDD_EXCDLG),DetExcData(ded)
{
  PDir = new TEdit(this,IDC_EXCNAME);
  PRecurseChB = new TCheckBox(this,IDC_EXCRECURSE);
}
//*******************************************************************
TDetExcDataDlg::~TDetExcDataDlg()
{
  delete PDir;
  PDir = NULL;
  delete PRecurseChB;
  PRecurseChB = NULL;
}
//*******************************************************************
void TDetExcDataDlg::CmDone()
{
  if (PRecurseChB->GetCheck() == BF_CHECKED)
  {
    DetExcData.Recurse = true;
  }
  else
  {
    DetExcData.Recurse = false;
  }

  // get dir from TEdit
  int len = PDir->GetTextLen() + 1;
  char *buffer = new char[len];
  PDir->GetText(buffer,len);
  string s = buffer;
  s.to_lower();
  // append last slash if not entered by user.
  if (strlen(buffer) > 0)
  {
    size_t index = s.find_last_of("\\");
    if (index == NPOS)
    {
      s += "\\";
    }
    else if (index != (strlen(s.c_str()) - 1))
    {
      s += "\\";
    }
  }
  DetExcData.Name = s;
  delete [] buffer;

  CmOk();
}
//*******************************************************************
void TDetExcDataDlg::SetupWindow()
{
  TDialog::SetupWindow();
  if (DetExcData.Recurse) {PRecurseChB->SetCheck(BF_CHECKED);}
  else {PRecurseChB->SetCheck(BF_UNCHECKED);}
  PDir->SetText(DetExcData.Name.c_str());
}
//*******************************************************************
//*******************************************************************
DEFINE_RESPONSE_TABLE1(TDetExcNameDataDlg,TDialog)
  EV_COMMAND(IDOK,CmOk),
END_RESPONSE_TABLE;
//*******************************************************************
TDetExcNameDataDlg::TDetExcNameDataDlg(TWindow *pwin,TDetExcNameData &dend)
:TDialog(pwin,IDD_EXCNAMEDLG),
 DetExcNameData(dend)
{
  PName_EB = new TEdit(this,IDC_EXCNAME_EB);
}
//*******************************************************************
TDetExcNameDataDlg::~TDetExcNameDataDlg()
{
  delete PName_EB;
  PName_EB = NULL;
}
//*******************************************************************
void TDetExcNameDataDlg::CmOk()
{
  // get dir from TEdit
  int len = PName_EB->GetTextLen() + 1;
  char *buffer = new char[len];
  PName_EB->GetText(buffer,len);
  string s = buffer;
  s.to_lower();
  DetExcNameData.Name = s;
  delete [] buffer;

  TDialog::CmOk();
}
//*******************************************************************
void TDetExcNameDataDlg::SetupWindow()
{
  TDialog::SetupWindow();
  PName_EB->SetText(DetExcNameData.Name.c_str());
}
//*******************************************************************
//*******************************************************************
DEFINE_RESPONSE_TABLE1(TDetDlg,TDialog)
  EV_COMMAND(IDC_DESDONE,CmDone),
  EV_COMMAND(IDC_DESINCDIRADD,CmAddIncDir),
  EV_COMMAND(IDC_DESINCDIRREMOVE,CmRemoveIncDir),
  EV_COMMAND(IDC_DESINCDIREDIT,CmEditIncDir),
  EV_COMMAND(IDC_DESEXCDIRADD,CmAddExcDir),
  EV_COMMAND(IDC_DESEXCDIRREMOVE,CmRemoveExcDir),
  EV_COMMAND(IDC_DESEXCDIREDIT,CmEditExcDir),
  EV_COMMAND(IDC_DESEXCNAMEADD_PB,CmAddExcName),
  EV_COMMAND(IDC_DESEXCNAMEREMOVE_PB,CmRemoveExcName),
  EV_COMMAND(IDC_DESEXCNAMEEDIT_PB,CmEditExcName),
END_RESPONSE_TABLE;
//*******************************************************************
TDetDlg::TDetDlg(TDetScript *pdetscript,TWindow *parent,string &root)
:TDialog(parent,IDD_DESDLG)
{
  PDetScript = pdetscript;
  PIncDirLB = new TListBox(this,IDC_DESINCDIRLB);
  PExcDirLB = new TListBox(this,IDC_DESEXCDIRLB);
  PExcName_LB = new TListBox(this,IDC_DESEXCNAME_LB);
  PName = new TStatic(this,IDC_DESNAME);
  PRoot = new TStatic(this,IDC_DESROOT);
  Root = root;
  Root.to_lower();
}
//*******************************************************************
TDetDlg::~TDetDlg()
{
  delete PIncDirLB;
  PIncDirLB = NULL;
  delete PExcDirLB;
  PExcDirLB = NULL;
  delete PExcName_LB;
  PExcName_LB = NULL;
  delete PName;
  PName = NULL;
  delete PRoot;
  PRoot = NULL;
}
//*******************************************************************
void TDetDlg::SetupWindow()
{
  TDialog::SetupWindow();
  PRoot->SetText(Root.c_str());
  string name = PDetScript->GetFileName();
  PName->SetText(name.c_str());
  LoadIncDirLB();
  LoadExcDirLB();
  LoadExcNameLB();
}
//*******************************************************************
void TDetDlg::CmAddIncDir()
{
  TDetIncData did;
  TDetIncDataDlg *pdidd = new TDetIncDataDlg(this,did);
  pdidd->Execute();
  delete pdidd;

  PDetScript->AddInc(did);
  UnLoadIncDirLB();
  LoadIncDirLB();
  Invalidate();
}
//*******************************************************************
void TDetDlg::CmRemoveIncDir()
{
  int16 index = (int16)PIncDirLB->GetSelIndex();
  if (index < 0)
  {
    MessageBox("Select Inc Dir first","Error - Remove Inc Dir",MB_OK);
    return;
  }
  else if (index >= PDetScript->GetNumIncs())
  {
    MessageBox("Invalid Index","Error - Remove Inc Dir",MB_OK);
    return;
  }
  else
  {
    PDetScript->RemoveInc(index);
    UnLoadIncDirLB();
    LoadIncDirLB();
    Invalidate();
  }
}
//*******************************************************************
void TDetDlg::CmDone()
{
  CmOk();
}
//*******************************************************************
void TDetDlg::CmEditIncDir()
{
  int16 index = (int16)PIncDirLB->GetSelIndex();
  if (index < 0)
  {
    MessageBox("Select Inc Dir First","Error - Edit Inc Dir",MB_OK);
    return;
  }
  else if (index >= PDetScript->GetNumIncs())
  {
    MessageBox("Invalid Index","Error - Edit Inc Dir",MB_OK);
    return;
  }
  else
  {
    TDetIncData *pdid = PDetScript->GetIncData(index);
    if (pdid == NULL)
    {
      MessageBox("Invalid Data","Error - Edit Inc Dir",MB_OK);
      return;
    }
    else
    {
      TDetIncDataDlg *pdidd = new TDetIncDataDlg(this,*pdid);
      pdidd->Execute();
      delete pdidd;
      UnLoadIncDirLB();
      LoadIncDirLB();
      PIncDirLB->SetSelIndex(index);
      Invalidate();
    }
  }
}
//*******************************************************************
void TDetDlg::CmAddExcDir()
{
  TDetExcData ded;
  TDetExcDataDlg *pdedd = new TDetExcDataDlg(this,ded);
  pdedd->Execute();
  PDetScript->AddExc(ded);
  UnLoadExcDirLB();
  LoadExcDirLB();
  Invalidate();
}
//*******************************************************************
void TDetDlg::CmRemoveExcDir()
{
  int16 index = (int16)PExcDirLB->GetSelIndex();
  if (index < 0)
  {
    MessageBox("Select Exc Dir First","Error - Remove Exc Dir",MB_OK);
    return;
  }
  else if (index >= PDetScript->GetNumExcs())
  {
    MessageBox("Invalid Index","Error - Remove Exc Dir",MB_OK);
    return;
  }
  else
  {
    PDetScript->RemoveExc(index);
    UnLoadExcDirLB();
    LoadExcDirLB();
    Invalidate();
  }
}
//*******************************************************************
void TDetDlg::CmEditExcDir()
{
  int16 index = (int16)PExcDirLB->GetSelIndex();
  if (index < 0)
  {
    MessageBox("Select Exc Dir First","Error - Edit Exc Dir",MB_OK);
    return;
  }
  else if (index >= PDetScript->GetNumExcs())
  {
    MessageBox("Invalid Index","Error - Edit Exc Dir",MB_OK);
    return;
  }
  else
  {
    TDetExcData *pded = PDetScript->GetExcData(index);
    if (pded == NULL)
    {
      MessageBox("Invalid Data","Error - Edit Inc Dir",MB_OK);
      return;
    }
    else
    {
      TDetExcDataDlg *pdedd = new TDetExcDataDlg(this,*pded);
      pdedd->Execute();
      delete pdedd;
      UnLoadExcDirLB();
      LoadExcDirLB();
      PExcDirLB->SetSelIndex(index);
      Invalidate();
    }
  }
}
//*******************************************************************
void TDetDlg::CmAddExcName()
{
  TDetExcNameData dend;
  TDetExcNameDataDlg *pdendd = new TDetExcNameDataDlg(this,dend);
  pdendd->Execute();
  PDetScript->AddExcName(dend);
  UnLoadExcNameLB();
  LoadExcNameLB();
  Invalidate();
}
//*******************************************************************
void TDetDlg::CmRemoveExcName()
{
  int16 index = (int16)PExcName_LB->GetSelIndex();
  if (index < 0)
  {
    MessageBox("Select Exc Name First","Error - Remove Exc Name",MB_OK);
    return;
  }
  else if (index >= PDetScript->GetNumExcNames())
  {
    MessageBox("Invalid Index","Error - Remove Exc Name",MB_OK);
    return;
  }
  else
  {
    PDetScript->RemoveExcName(index);
    UnLoadExcNameLB();
    LoadExcNameLB();
    Invalidate();
  }
}
//*******************************************************************
void TDetDlg::CmEditExcName()
{
  int16 index = (int16)PExcName_LB->GetSelIndex();
  if (index < 0)
  {
    MessageBox("Select Exc Name First","Error - Edit Exc Name",MB_OK);
    return;
  }
  else if (index >= PDetScript->GetNumExcNames())
  {
    MessageBox("Invalid Index","Error - Edit Exc Name",MB_OK);
    return;
  }
  else
  {
    TDetExcNameData *pdend = PDetScript->GetExcNameData(index);
    if (pdend == NULL)
    {
      MessageBox("Invalid Data","Error - Edit Exc Name",MB_OK);
      return;
    }
    else
    {
      TDetExcNameDataDlg *pdendd = new TDetExcNameDataDlg(this,*pdend);
      pdendd->Execute();
      delete pdendd;
      UnLoadExcNameLB();
      LoadExcNameLB();
      PExcName_LB->SetSelIndex(index);
      Invalidate();
    }
  }
}
//*******************************************************************
void TDetDlg::LoadIncDirLB()
{
  int16 numinc = PDetScript->GetNumIncs();
  for (int16 i=0;i<numinc;i++)
  {
    TDetIncData *pdid = PDetScript->GetIncData(i);
    string str = "'";
    str += pdid->Name;
    str += "'";
    if (pdid != NULL) {PIncDirLB->AddString(str.c_str());}
  }
}
//*******************************************************************
void TDetDlg::UnLoadIncDirLB()
{
  PIncDirLB->ClearList();
}
//*******************************************************************
void TDetDlg::LoadExcDirLB()
{
  int16 numexc = PDetScript->GetNumExcs();
  for (int16 i=0;i<numexc;i++)
  {
    TDetExcData *pded = PDetScript->GetExcData(i);
    string str = "'";
    str += pded->Name;
    str += "'";
    if (pded != NULL) {PExcDirLB->AddString(str.c_str());}
  }
}
//*******************************************************************
void TDetDlg::UnLoadExcDirLB()
{
  PExcDirLB->ClearList();
}
//*******************************************************************
void TDetDlg::LoadExcNameLB()
{
  int16 numexcnames = PDetScript->GetNumExcNames();
  for (int16 i=0;i<numexcnames;i++)
  {
    TDetExcNameData *pdend = PDetScript->GetExcNameData(i);
    string s = "'";
    s += pdend->Name;
    s += "'";
    PExcName_LB->AddString(s.c_str());
  }
}
//*******************************************************************
void TDetDlg::UnLoadExcNameLB()
{
  PExcName_LB->ClearList();
}
//*******************************************************************

