//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  odetldlg.cpp
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     5/9/96     M.Perry     original baseline
//  2.0     8/26/97    M.Perry     32-bit conversion.
//********************************************************************
#if !defined(__odetldlg_h)
#include "odetldlg.h"
#endif

#if !defined(__owad_rh)
#include "owad.rh"
#endif

#if !defined(__odetlist_h)
#include "odetlist.h"
#endif

#if !defined(OWL_INPUTDIA_H)
#include <owl\inputdia.h>
#endif
//*******************************************************************
DEFINE_RESPONSE_TABLE1(TDetListDlg,TDialog)
  EV_COMMAND(IDC_APPDESCREATEALL,CmCreateAll),
  EV_COMMAND(IDC_APPDESCREATE,CmCreate),
  EV_COMMAND(IDC_APPDESADD,CmAdd),
  EV_COMMAND(IDC_APPDESREMOVE,CmRemove),
  EV_COMMAND(IDC_APPDESEDIT,CmEdit),
  EV_COMMAND(IDC_APPDESDONE,CmDone),
END_RESPONSE_TABLE;
//*******************************************************************
TDetListDlg::TDetListDlg(TDetList *pdetlist,TWindow *pwin)
:TDialog(pwin,IDD_APPDESLISTDLG)
{
  PDetList = pdetlist;
  PSource = new TStatic(this,IDC_APPDESROOT);
  PDest = new TEdit(this,IDC_APPDESDEST);
  PDesNamesLB = new TListBox(this,IDC_APPDESLB);
  PStatus = new TStatic(this,IDC_APPDESSTATUS);
  PStatus2 = new TStatic(this,IDC_APPDESSTATUS2);
}
//*******************************************************************
TDetListDlg::~TDetListDlg()
{
  delete PSource;
  PSource = NULL;
  delete PDest;
  PDest = NULL;
  delete PDesNamesLB;
  PDesNamesLB = NULL;
  delete PStatus;
  PStatus = NULL;
  delete PStatus2;
  PStatus2 = NULL;
}
//*******************************************************************
void TDetListDlg::SetupWindow()
{
  TDialog::SetupWindow();
  PSource->SetText(PDetList->GetSource().c_str());
  PDest->SetText(PDetList->GetDest().c_str());
  LoadDesNamesLB();
}
//*******************************************************************
void TDetListDlg::CmCreateAll()
{
  SetStatus("Creating All");
  PDetList->CreateAll(this);
  SetStatus("Done Creating all");
}
//*******************************************************************
void TDetListDlg::CmCreate()
{
  int16 index = (int16)PDesNamesLB->GetSelIndex();
  if (index < 0)
  {
    SetStatus("Error - Create");
    SetStatus2("Select Name First");
    return;
  }
  else if (index >= PDetList->GetNumNames())
  {
    SetStatus("Error - Create");
    SetStatus2("Invalid Index");
    return;
  }
  else
  {
    SetStatus("Create");
    string s = "Creating: ";
    s += PDetList->GetName(index);
    SetStatus2(s);
    PDetList->Create(this,index);
    string s2 = "Done Creating " + PDetList->GetName(index);
    SetStatus("Create Done");
    SetStatus2(s2);
  }
}
//*******************************************************************
void TDetListDlg::CmAdd()
{
  char buffer[100];
  buffer[0] = '\0';
  TInputDialog *pid = new TInputDialog(this,"Enter new Des Name","Add DES",buffer,100);
  if (pid->Execute() == IDOK)
  {
    string str = buffer;
    str.to_lower();
    PDetList->AddName(str);
  }
  UnLoadDesNamesLB();
  LoadDesNamesLB();
  Invalidate();
}
//*******************************************************************
void TDetListDlg::CmRemove()
{
  int16 index = (int16)PDesNamesLB->GetSelIndex();
  if (index < 0)
  {
    SetStatus("Error - Remove");
    SetStatus2("Select Name First");
    return;
  }
  else if (index >= PDetList->GetNumNames())
  {
    SetStatus("Error - Remove");
    SetStatus2("Invalid Index");
    return;
  }
  else
  {
    PDetList->RemoveName(index);
    UnLoadDesNamesLB();
    LoadDesNamesLB();
    Invalidate();
  }
}
//*******************************************************************
void TDetListDlg::CmEdit()
{
  int16 index = (int16)PDesNamesLB->GetSelIndex();
  if (index < 0)
  {
    SetStatus("Error - Edit");
    SetStatus2("Select Name First");
    return;
  }
  else if (index >= PDetList->GetNumNames())
  {
    SetStatus("Error - Edit");
    SetStatus2("Invalid Index");
    return;
  }
  else
  {
    SetStatus("Editing Des");
    PDetList->EditDes(this,index);
    SetStatus("Done Editing Des");
  }
}
//*******************************************************************
void TDetListDlg::CmDone()
{
  char buffer[160];
  PDest->GetText(buffer,160);
  string str = buffer;
  str.to_lower();
  PDetList->SetDest(str);
  CmOk();
}
//*******************************************************************
void TDetListDlg::LoadDesNamesLB()
{
  int16 NumNames = PDetList->GetNumNames();
  for (int16 i=0;i<NumNames;i++)
  {
    PDesNamesLB->AddString(PDetList->GetName(i).c_str());
  }
}
//*******************************************************************
void TDetListDlg::UnLoadDesNamesLB()
{
  PDesNamesLB->ClearList();
}
//*******************************************************************

