//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  odlevdlg.cpp
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     12/17/96   M.Perry    original baseline
//  2.0     08/27/97   M.Perry    32-bit conversion.
//********************************************************************
#if !defined(__odlevdlg_h)
#include "odlevdlg.h"
#endif

#if !defined(__omodewin_h)
#include "omodewin.h"
#endif

#if !defined(__odlevdlg_rh)
#include "odlevdlg.rh"
#endif
//*******************************************************************
DEFINE_RESPONSE_TABLE1(TDetailLevelDlg,TDialog)
  EV_COMMAND(IDOK,CmOk),
END_RESPONSE_TABLE;
//*******************************************************************
TDetailLevelDlg::TDetailLevelDlg(TOgleModeWindow *pmw)
:TDialog(pmw,IDD_DETAILLEVEL),
 PModeWin(pmw)
{
  PDL3_RB = new TRadioButton(this,IDC_DL3_RB);
  PDL2_RB = new TRadioButton(this,IDC_DL2_RB);
  PDL1_RB = new TRadioButton(this,IDC_DL1_RB);
  PDL0_RB = new TRadioButton(this,IDC_DL0_RB);
}
//*******************************************************************
TDetailLevelDlg::~TDetailLevelDlg()
{
  delete PDL3_RB;
  delete PDL2_RB;
  delete PDL1_RB;
  delete PDL0_RB;
}
//*******************************************************************
void TDetailLevelDlg::SetupWindow()
{
  TDialog::SetupWindow();

  string s = PModeWin->GetModeName();
  s += " Game Speed Control";
  SetCaption(s.c_str());

  int level = PModeWin->GetDetailLevel();

  PDL3_RB->Uncheck();
  PDL2_RB->Uncheck();
  PDL1_RB->Uncheck();
  PDL0_RB->Uncheck();
  switch (level)
  {
    case 3  :PDL3_RB->Check();break;
    case 2  :PDL2_RB->Check();break;
    case 1  :PDL1_RB->Check();break;
    case 0  :PDL0_RB->Check();break;
    default :PDL3_RB->Check();break;
  }
}
//*******************************************************************
void TDetailLevelDlg::CmOk()
{
  if (PDL3_RB->GetCheck() == BF_CHECKED)
  {
    PModeWin->SetDetailLevel(3);
  }
  else if (PDL2_RB->GetCheck() == BF_CHECKED)
  {
    PModeWin->SetDetailLevel(2);
  }
  else if (PDL1_RB->GetCheck() == BF_CHECKED)
  {
    PModeWin->SetDetailLevel(1);
  }
  else
  {
    PModeWin->SetDetailLevel(0);
  }
  TDialog::CmOk();
}
//*******************************************************************