//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name: oscrnmgr.cpp
//    Project Name: Ogle
// Original Author: Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     02/27/95   M.Perry     original baseline
//  2.0     08/28/97   M.Perry     32-bit conversion.
//********************************************************************
#if !defined(__scrnmgr_h)
#include "oscrnmgr.h"
#endif

#if !defined(__ovidwing_h)
#include "ovidwing.h"
#endif

DIAG_DEFINE_GROUP(SCREENMGR,1,0);
//*******************************************************************
#ifdef DEBUGSPRITES
void TOgleScreenMgr::RTReport(ofstream &os)
{
  os<<"frame list removed, need to add to grlist\n";
}
#endif
//*******************************************************************
bool TOgleScreenMgr::ChangeBG(TBmp *pbmp)
{
  if (PVideo == NULL) {return false;}
  return PVideo->ChangeBG(pbmp);
}
//*******************************************************************
void TOgleScreenMgr::ChangePal(TPal &pal)
{
  if (PVideo != NULL)
  {
    PVideo->ChangePal(pal);
  }
}
//*******************************************************************
void TOgleScreenMgr::CreateResponderList()
{
  PResponderList = new TResponderList(PModeWin);
}
//*******************************************************************
void TOgleScreenMgr::DestroyResponderList()
{
  delete PResponderList;
  PResponderList = NULL;
}
//*******************************************************************
TOgleScreenMgr::TOgleScreenMgr(TOgleModeWindow *pmodewin,TBmp *pbg,TPal *ppal)
{
  PModeWin = pmodewin;
  PResponderList = NULL;
  CreateResponderList();
  PVideo = NULL;
  CreateVideo(PModeWin,*pbg,*ppal);
}
//*******************************************************************
TOgleScreenMgr::~TOgleScreenMgr()
{
  DestroyResponderList();
  DestroyVideo();
  PModeWin = NULL;
}
//*******************************************************************
bool TOgleScreenMgr::CreateVideo(TOgleModeWindow *pmw,TBmp &bmp,TPal &pal)
{
  PVideo = new TVideoWinG(pmw,bmp,pal,rmSLOPPY,rmSLOPPY);
  PVideo->Initialize();
  return true;
}
//*******************************************************************
bool TOgleScreenMgr::DestroyVideo()
{
  delete PVideo;
  PVideo = NULL;
  return true;
}
//*******************************************************************

