//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  otimers.cpp
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     6/6/95    M.Perry     original baseline
//  2.0    08/27/97   M.Perry     32-bit conversion.
//********************************************************************
#if !defined(__otimers_h)
#include "otimers.h"
#endif

#if !defined(__osys_h)
#include "osys.h"
#endif
//*******************************************************************
TOgleTime::TOgleTime(dword NewUpdateRate)
{
  #ifdef TIMEDEBUG
  NumOfMisses = 0;
  NumOfHits = 0;
  #endif

  FrameUpdateCount = 0;
  UpdateRate = NewUpdateRate;
    StartingTime = TSys::GetMSec();
    CurrentTime = StartingTime;
    NextUpdateTime = CurrentTime + UpdateRate;
    InitOk = true;
}
//*******************************************************************
TOgleTime::~TOgleTime()
{
}
//*******************************************************************
bool TOgleTime::UpdateNow()
{
    CurrentTime = TSys::GetMSec();
    if (CurrentTime >= (NextUpdateTime - TIMEFUDGEFACTOR))
    {
      NextUpdateTime = CurrentTime + UpdateRate;
      FrameUpdateCount++;

      #ifdef TIMEDEBUG
      NumOfHits++;
      #endif

      return true;
    }
    else
    {
      #ifdef TIMEDEBUG
      NumOfMisses++;
      #endif

      return false;
    }
}
//*******************************************************************

