//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  omsg.cpp
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0    03/01/96    M.Perry    original baseline
//  2.0    08/27/97    M.Perry    32-bit conversion.
//********************************************************************
#if !defined(__omsg_h)
#include "omsg.h"
#endif

#if !defined(__oapp_h)
#include "oapp.h"
#endif

#if !defined(__ogamefw_h)
#include "ogamefw.h"
#endif
//*******************************************************************
TOgleMsg::TOgleMsg(TOgleMsg &msg)
{
  MessageID = msg.MessageID;
  Wparam = msg.Wparam;
  Lparam = msg.Lparam;
}
//*******************************************************************
TOgleMsg::TOgleMsg(WPARAM wparam,LPARAM lparam,uint msgID)
{
  MessageID = msgID;
  Wparam = wparam;
  Lparam = lparam;
}
//*******************************************************************
TOgleMsg::TOgleMsg(byte mt,byte smt,dword data)
{
  MessageID = ID_OM_OGLEMSG;
  #if defined(BI_PLAT_WIN16)
  Wparam = makeword(mt,smt);
  #else
  Wparam = makeuint32(makeword(mt,smt),0);
  #endif
  Lparam = (LPARAM)data;
}
//*******************************************************************
TOgleMsg::TOgleMsg(byte mt,byte smt,word datalo,word datahi)
{
  MessageID = ID_OM_OGLEMSG;
  #if defined(BI_PLAT_WIN16)
  Wparam = makeword(mt,smt);
  #else
  Wparam = makeuint32(makeword(mt,smt),0);
  #endif
  Lparam = makeint32(datalo,datahi);
}
//*******************************************************************
byte TOgleMsg::GetMT()
{
  #if defined(BI_PLAT_WIN16)
  return lobyte(Wparam);
  #else
  return lobyte(loword(Wparam));
  #endif
}
//*******************************************************************
byte TOgleMsg::GetSMT()
{
  #if defined(BI_PLAT_WIN16)
  return hibyte(Wparam);
  #else
  return hibyte(loword(Wparam));
  #endif
}
//*******************************************************************
dword TOgleMsg::GetData()
{
  return (dword)Lparam;
}
//*******************************************************************
word TOgleMsg::GetDataWLo()
{
  return loword(Lparam);
}
//*******************************************************************
word TOgleMsg::GetDataWHi()
{
  return hiword(Lparam);
}
//*******************************************************************
void TOgleMsg::Post(TWindow *pwin)
{
  if (pwin != NULL)
  {
    pwin->PostMessage(MessageID,Wparam,Lparam);
  }
}
//*******************************************************************
void TOgleMsg::PostToFW()
{
  Post(TOgleApp::GetOgleApp()->GetFW());
}
//*******************************************************************

