//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  orespond.cpp
//    Project Name:  Ogle
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     6/12/95    M.Perry    original baseline
//  2.0     8/27/97    M.Perry    32-bit conversion.
//********************************************************************
#if !defined(__orespond_h)
#include "orespond.h"
#endif

#if !defined(__obase_h)
#include "obase.h"
#endif

#if !defined(__omodewin_h)
#include "omodewin.h"
#endif

#if !defined(__omode_h)
#include "omode.h"
#endif

#if !defined(__oscrnmgr_h)
#include "oscrnmgr.h"
#endif

#if !defined(__oapp_h)
#include "oapp.h"
#endif
//*******************************************************************
TResponder::TResponder(TOgleModeWindow *pmw,
                       int16 z,TRect &rect,
                       int16 id,
                       TOgleBase *PBase,
                       bool AutoAdd,
                       char ch,
                       TCursorData cd,
                       bool enterleave)
{
  PModeWin = pmw;
//  PApp = TOgleApp::GetOgleApp(true);
  EnterLeave = enterleave;
  Ch = ch;
  Ch2 = '^';
  Z = z;
  ResponseEvent = reNone;
  Rect = rect;
  IDNum = id;
  Added = false;
  POwner = PBase;
  CD = cd;
  DefCD = cd;
  if (AutoAdd) {Add();}
}
//*******************************************************************
TResponder::TResponder(TOgleModeWindow *pmw,
                       int16 z,
                       const TRect &rect,
                       int16 id,
                       TOgleBase *pbase,
                       bool autoadd,
                       char ch,
                       const TCursorData &cd,
                       bool enterleave)
:PModeWin(pmw),
 EnterLeave(enterleave),
 Ch(ch),
 Ch2('^'),
 Z(z),
 ResponseEvent(reNone),
 Rect(rect),
 IDNum(id),
 Added(false),
 POwner(pbase),
 CD(cd),
 DefCD(cd)
{
  if (autoadd) {Add();}
}
//*******************************************************************
TResponder::TResponder(TOgleModeWindow *pmw)
{
  PModeWin = pmw;
//  PApp = TOgleApp::GetOgleApp(true);
  Z = 0;
  ResponseEvent = reNone;
  Rect = TRect(0,0,0,0);
  IDNum = 0;
  POwner = NULL;
  Added = false;
  CD = TCursorData(0,0);
  EnterLeave = false;
}
//*******************************************************************
TOgleScreenMgr *TResponder::GetScreenMgr()
{
  if (PModeWin == NULL) {return NULL;}
  TOgleMode *pmode = PModeWin->GetMode();
  if (pmode == NULL) {return NULL;}
  return pmode->GetScreenMgr();
}
//*******************************************************************
void TResponder::SetCDNow(TCursorData &cd)
{
  SetCD(cd);
//  PApp->GetCursorMgr()->SetCursor(ctArea,CD);
  TOgleApp::GetOgleApp()->GetCursorMgr()->SetCursor(ctArea,CD);
}
//*******************************************************************
bool TResponder::SetPriority()
{
//  if (PModeWin == NULL || PModeWin->PScreenMgr == NULL) {return false;}
//  return (IsPriority = PModeWin->PScreenMgr->SetPriority(this));

  TOgleScreenMgr *psm = GetScreenMgr();
  if (psm == NULL) {return false;}
  IsPriority = psm->SetPriority(this);
  return IsPriority;
}
//*******************************************************************
void TResponder::ClearPriority()
{
//  if (PModeWin == NULL || PModeWin->PScreenMgr == NULL) {return;}
//  IsPriority = false;
//  PModeWin->PScreenMgr->ClearPriority(this);

  TOgleScreenMgr *psm = GetScreenMgr();
  if (psm != NULL)
  {
    psm->ClearPriority(this);
  }
  IsPriority = false;
}
//*******************************************************************
void TResponder::NotifyScrMgrZ()
{
//  if (PModeWin == NULL || PModeWin->PScreenMgr == NULL) {return;}
//  PModeWin->PScreenMgr->SetZChanged();

  TOgleScreenMgr *psm = GetScreenMgr();
  if (psm != NULL)
  {
    psm->SetZChanged();
  }
}
//*******************************************************************
bool TResponder::HandleKeyEvent(TResponseEvent revent,uint repeatCount,uint flags)
{
  if (POwner == NULL) {return false;}
  ResponseEvent = revent;
  ModKeys = flags;
  KeyCount = int16(repeatCount);
  return POwner->Respond(*this);
}
//*******************************************************************
bool TResponder::HandleMouseEvent(TResponseEvent revent,uint modKeys,TPoint &point)
{
  ResponseEvent = revent;
  ModKeys = modKeys;
  Point = point;
  if (revent == reSetCursor)
  {
    if (CD.ResId == 0) {return false;}
//    PApp->GetCursorMgr()->SetCursor(ctArea,CD);
    TOgleApp::GetOgleApp()->GetCursorMgr()->SetCursor(ctArea,CD);
    return true;
  }
  if (POwner != NULL) {return POwner->Respond(*this);}
  return false;
}
//*******************************************************************
void TResponder::Add()
{
//  if (PModeWin == NULL) {return;}
//  if (PModeWin->PScreenMgr == NULL) {return;}
//  if (!Added)
//  {
//    Added = PModeWin->PScreenMgr->AddResponder(this);
//  }

  if (Added) {return;}
  TOgleScreenMgr *psm = GetScreenMgr();
  if (psm != NULL)
  {
    Added = psm->AddResponder(this);
  }
}
//*******************************************************************
void TResponder::Remove()
{
//  if (PModeWin == NULL) {return;}
//  if (PModeWin->PScreenMgr == NULL) {return;}
//  if (Added)
//  {
//    PModeWin->PScreenMgr->RemoveResponder(this);
//    Added = false;
//  }

  if (!Added) {return;}
  TOgleScreenMgr *psm = GetScreenMgr();
  if (psm != NULL)
  {
    psm->RemoveResponder(this);
    Added = false;
  }
}
//*******************************************************************

