//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  geddlgs.cpp
//    Project Name:  Game Editor
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  1.0     7/24/95    M.Perry     original baseline
//  2.0     11/3/97    M.Perry     32-bit conversion.
//********************************************************************
#if !defined(__geddlgs_h)
#include "geddlgs.h"
#endif

#if !defined(__gedmodew_h)
#include "gedmodew.h"
#endif

#if !defined(__osprlist_h)
#include "osprlist.h"
#endif

#if !defined(__oskitcat_h)
#include "oskitcat.h"
#endif

#if !defined(__gedspred_h)
#include "gedspred.h"
#endif

#if !defined(__ogame_h)
#include "ogame.h"
#endif

#if !defined(__omode_h)
#include "omode.h"
#endif

#if !defined(__ogobjlst_h)
#include "ogobjlst.h"
#endif

#if !defined(OWL_GROUPBOX_H)
#include "owl\groupbox.h"
#endif

#if !defined(OWL_VALIDATE_H)
#include "owl\validate.h"
#endif

#if !defined(__ofilemgr_h)
#include "ofilemgr.h"
#endif
//*******************************************************************
DEFINE_RESPONSE_TABLE1(TEditSpriteIdlesDlg,TDialog)
  EV_COMMAND(IDC_IDLEDONE,CmDone),
  EV_COMMAND(IDC_IDLEADD,CmAdd),
  EV_COMMAND(IDC_IDLEREMOVE,CmRemove),
END_RESPONSE_TABLE;
//*******************************************************************
TEditSpriteIdlesDlg::TEditSpriteIdlesDlg(TWindow *parent,TSpriteEditorClientWin *pspredwin,
                                          int16 typeindex,int16 setindex)
:TDialog(parent,EDITSPRITEIDLESDLG)
{
  PSprEdWin = pspredwin;
  TypeIndex = typeindex;
  SetIndex = setindex;
  PSpriteIdlesLB = new TListBox(this,IDC_LBIDLEEDIT);
}
//*******************************************************************
TEditSpriteIdlesDlg::~TEditSpriteIdlesDlg()
{
  delete PSpriteIdlesLB;
  PSpriteIdlesLB = NULL;
}
//*******************************************************************
void TEditSpriteIdlesDlg::SetupWindow()
{
  TDialog::SetupWindow();
  LoadLB();
}
//*******************************************************************
void TEditSpriteIdlesDlg::CmAdd()
{
  TSelectSpriteDlg *PSSD = new TSelectSpriteDlg(this,"Select Idle Sprite");
  int retval = PSSD->Execute();
  if (retval == IDOK)
  {
    string spritefname = PSSD->RetrieveSelection();
    TSprite *PSprite = PSprEdWin->GetSpriteList()->GetSpritePtr(spritefname);
    int16 tndx = PSprEdWin->GetSpriteList()->GetActiveListIndex(PSprite);
    if (tndx != TypeIndex)
    {
      MessageBox("Sprite Selected not correct type.","Error - Add Idle",MB_OK);
    }
    else if (!PSprEdWin->GetSpriteList()->AddSpriteSetIdle(TypeIndex,SetIndex,spritefname))
    {
      MessageBox("Add Idle failed","Error - Add Idle",MB_OK);
    }
  }
  delete PSSD;
  PSSD = NULL;

  UnLoadLB();
  LoadLB();
  Invalidate();
}
//*******************************************************************
void TEditSpriteIdlesDlg::CmRemove()
{
  int16 idleindex = (int16)PSpriteIdlesLB->GetSelIndex();
  if (!PSprEdWin->GetSpriteList()->RemoveSpriteSetIdle(TypeIndex,SetIndex,idleindex))
  {
    MessageBox("Remove Idle failed","Error - Remove Idle",MB_OK);
  }
  UnLoadLB();
  LoadLB();
  Invalidate();
}
//*******************************************************************
void TEditSpriteIdlesDlg::CmDone()
{
  CmOk();
}
//*******************************************************************
void TEditSpriteIdlesDlg::LoadLB()
{
  string spritefname;
  int16 numsprites = PSprEdWin->GetSpriteList()->GetSpriteSetNumIdles(TypeIndex,SetIndex);
  for (int16 i = 0;i<numsprites;i++)
  {
    spritefname = PSprEdWin->GetSpriteList()->GetSpriteSetIdleName(TypeIndex,SetIndex,i);
    PSpriteIdlesLB->AddString(spritefname.c_str());
  }
}
//*******************************************************************
void TEditSpriteIdlesDlg::UnLoadLB()
{
  PSpriteIdlesLB->ClearList();
}
//*******************************************************************
DEFINE_RESPONSE_TABLE1(TEditSpriteSetsDlg,TDialog)
  EV_COMMAND(IDC_SETDONE,CmDone),
  EV_COMMAND(IDC_SETACTIVATE,CmActivate),
  EV_COMMAND(IDC_SETDEACTIVATE,CmDeActivate),
  EV_COMMAND(IDC_SETADDSET,CmAdd),
  EV_COMMAND(IDC_SETREMOVESET,CmRemove),
  EV_COMMAND(IDC_SETEDITIDLES,CmEditIdles),
  EV_LBN_DBLCLK(IDC_LBEDITSET,EvDblClk),
END_RESPONSE_TABLE;
//*******************************************************************
TEditSpriteSetsDlg::TEditSpriteSetsDlg(TWindow *parent,
                                       TSpriteEditorClientWin *pspredwin,int16 typeindex)
:TDialog(parent,EDITSPRITESETSDLG)
{
  PSprEdWin = pspredwin;
  TypeIndex = typeindex;
  PSpriteSetsLB = new TListBox(this,IDC_LBEDITSET);
  PSpriteSetsLB->EnableTransfer();
}
//*******************************************************************
TEditSpriteSetsDlg::~TEditSpriteSetsDlg()
{
  delete PSpriteSetsLB;
  PSpriteSetsLB = NULL;
}
//*******************************************************************
void TEditSpriteSetsDlg::SetupWindow()
{
  TDialog::SetupWindow();
  LoadLB();
}
//*******************************************************************
void TEditSpriteSetsDlg::CmActivate()
{
  int16 setindex = (int16)PSpriteSetsLB->GetSelIndex();
  if (setindex < 0)
  {
    MessageBox("Invalid Set Index, or Set not selected","Error - Activate Set",MB_OK);
    return;
  }
  PSprEdWin->GetSpriteList()->SetCurrentSpriteSet(TypeIndex,setindex);
  UnLoadLB();
  LoadLB();
  Invalidate();
}
//*******************************************************************
void TEditSpriteSetsDlg::CmDeActivate()
{
  PSprEdWin->GetSpriteList()->SetCurrentSpriteSet(TypeIndex,-1);
  UnLoadLB();
  LoadLB();
  Invalidate();
}
//*******************************************************************
void TEditSpriteSetsDlg::CmAdd()
{
  if (!PSprEdWin->GetSpriteList()->AddSpriteSet(TypeIndex))
  {
    MessageBox("Add Sprite Set Failed","Error - Add Sprite Set",MB_OK);
  }
  UnLoadLB();
  LoadLB();
  Invalidate();
}
//*******************************************************************
void TEditSpriteSetsDlg::CmRemove()
{
  int16 setindex = (int16)PSpriteSetsLB->GetSelIndex();
  if (!PSprEdWin->GetSpriteList()->RemoveSpriteSet(TypeIndex,setindex))
  {
    MessageBox("Remove Sprite Set Failed","Error - Remove Sprite Set",MB_OK);
  }
  UnLoadLB();
  LoadLB();
  Invalidate();
}
//*******************************************************************
void TEditSpriteSetsDlg::CmEditIdles()
{
  int16 setindex = (int16)PSpriteSetsLB->GetSelIndex();
  if (setindex < 0)
  {
    MessageBox("Invalid Set Index","Error - Edit Idles",MB_OK);
    return;
  }
  TEditSpriteIdlesDlg *PESID = new TEditSpriteIdlesDlg(this,PSprEdWin,TypeIndex,setindex);
  PESID->Execute();
  delete PESID;
}
//*******************************************************************
void TEditSpriteSetsDlg::EvDblClk()
// note: the dblclk from the listbox is "sent" not "posted".
//       On a dbl clk in the listbox we want to edit the sprite type sets.
{
  ::PostMessage(HWindow,WM_COMMAND,IDC_SETEDITIDLES,0);
}
//*******************************************************************
void TEditSpriteSetsDlg::CmDone()
{
  CmOk();
}
//*******************************************************************
void TEditSpriteSetsDlg::LoadLB()
{
  char Buffer[20];
  int16 activespriteset = PSprEdWin->GetSpriteList()->GetCurrentSpriteSetIndex(TypeIndex);
  string str;
  int16 numsets = PSprEdWin->GetSpriteList()->GetNumSets(TypeIndex);
  for (int16 i=0;i<numsets;i++)
  {
    itoa(i,Buffer,10);
    if (i == activespriteset) {str = "* ";}
    else {str = "  ";}
    str += Buffer;
    PSpriteSetsLB->AddString(str.c_str());
  }
}
//*******************************************************************
void TEditSpriteSetsDlg::UnLoadLB()
{
  PSpriteSetsLB->ClearList();
}
//*******************************************************************
DEFINE_RESPONSE_TABLE1(TEditSpriteTypesDlg,TDialog)
  EV_COMMAND(IDC_ADDTYPE,CmAdd),
  EV_COMMAND(IDC_REMOVETYPE,CmRemove),
  EV_COMMAND(IDC_EDITSETS,CmEditSets),
  EV_COMMAND(IDC_DONE,CmDone),
  EV_LBN_DBLCLK(IDC_LBTYPES,EvDblClk),
END_RESPONSE_TABLE;
//*******************************************************************
TEditSpriteTypesDlg::TEditSpriteTypesDlg(TSpriteEditorClientWin *parent)
  :TDialog(parent,EDITSPRITETYPESDLG)
{
  PSprEdWin = parent;
  PSpriteTypesLB = new TListBox(this,IDC_LBTYPES);
  PSpriteTypesLB->EnableTransfer();
  PEditTypeName = new TEdit(this,IDC_EDITTYPENAME,8);
}
//*******************************************************************
TEditSpriteTypesDlg::~TEditSpriteTypesDlg()
{
  delete PSpriteTypesLB;
  PSpriteTypesLB = NULL;
  delete PEditTypeName;
  PEditTypeName = NULL;
}
//*******************************************************************
void TEditSpriteTypesDlg::LoadLB()
{
  string str;
  int16 numtypes = PSprEdWin->GetSpriteList()->GetNumTypes();
  for (int16 i=0;i<numtypes;i++)
  {
    str = PSprEdWin->GetSpriteList()->GetTypeName(i);
    PSpriteTypesLB->AddString(str.c_str());
  }
}
//*******************************************************************
void TEditSpriteTypesDlg::UnLoadLB()
{
  PSpriteTypesLB->ClearList();
}
//*******************************************************************
void TEditSpriteTypesDlg::SetupWindow()
{
  TDialog::SetupWindow();
  LoadLB();
  PEditTypeName->SetText("");
}
//*******************************************************************
void TEditSpriteTypesDlg::CmAdd()
{
  char Buffer[10];
  PEditTypeName->GetText(Buffer,PEditTypeName->GetTextLen() + 1);
  if (strlen(Buffer) == 0)
  {
    MessageBox("Type Name Null","Error - Add Type Name",MB_OK);
    return;
  }

  string str = Buffer;
  if (PSprEdWin->GetSpriteList()->AddActiveList(str))
  {
    UnLoadLB();
    LoadLB();
    Invalidate();
  }
  else
  {
    MessageBox("Add Active List Failed","Error - Add Sprite Type",MB_OK);
  }
}
//*******************************************************************
void TEditSpriteTypesDlg::CmRemove()
{
  int16 typeindex = (int16)PSpriteTypesLB->GetSelIndex();
  if (typeindex == 0)
  {
    MessageBox("Can't remove Sprite Type 0 - (none)","Error - Remove Sprite Type",MB_OK);
    return;
  }

  if (PSprEdWin->GetSpriteList()->RemoveActiveList(typeindex))
  {
    UnLoadLB();
    LoadLB();
    Invalidate();
  }
  else
  {
    MessageBox("Remove Active List Failed","Error - Remove Sprite Type",MB_OK);
  }
}
//*******************************************************************
void TEditSpriteTypesDlg::EvDblClk()
// note: the dblclk from the listbox is "sent" not "posted".
//       On a dbl clk in the listbox we want to edit the sprite type sets.
{
  ::PostMessage(HWindow,WM_COMMAND,IDC_EDITSETS,0);
}
//*******************************************************************
void TEditSpriteTypesDlg::CmEditSets()
{
  int16 typeindex = (int16)PSpriteTypesLB->GetSelIndex();
  if (typeindex < 0)
  {
    MessageBox("Invalid Sprite Type Index","Error - Edit Sprite Set",MB_OK);
    return;
  }
  if (typeindex == 0)
  {
    MessageBox("Can't Edit Sprite Type 0","Error - Edit Sprite Set",MB_OK);
    return;
  }

  TEditSpriteSetsDlg *PEditSpriteSetsDlg = new TEditSpriteSetsDlg(this,PSprEdWin,typeindex);
  PEditSpriteSetsDlg->Execute();
  delete PEditSpriteSetsDlg;
}
//*******************************************************************
void TEditSpriteTypesDlg::CmDone()
{
  CmOk();
}
//*******************************************************************
DEFINE_RESPONSE_TABLE1(TEditAnmCellDlg,TDialog)
  EV_COMMAND(IDNO,CmNo),
  EV_COMMAND(IDOK,CmOk),
END_RESPONSE_TABLE;
//*******************************************************************
TEditAnmCellDlg::TEditAnmCellDlg(TWindow *parent,
                                 int16 x,
                                 int16 y,
                                 int16 z,
                                 TDirection dir,
                                 bool creating,
                                 dword fuclen,
                                 int16 startframenum)
:TDialog(parent,EDITANMCELLDLG),
 X(x),
 Y(y),
 Z(z),
 Direction(dir),
 bCreating(creating),
 FUCLength(fuclen),
 StartFrameNum(startframenum)
{
//  X = x;
//  Y = y;
//  Z = z;
  pXEdit = new TEdit(this,IDC_XEDIT,5);
  pYEdit = new TEdit(this,IDC_YEDIT,5);
  pZEdit = new TEdit(this,IDC_ZEDIT,5);
  PDirectionGrpBox = new TGroupBox(this,IDC_DIRECTION_GRPBOX);
  PForwardRBtn = new TRadioButton(this,IDC_DIRECTION_FORWARD_RBTN,PDirectionGrpBox);
  PStillRBtn = new TRadioButton(this,IDC_DIRECTION_STILL_RBTN,PDirectionGrpBox);
  PReverseRBtn = new TRadioButton(this,IDC_DIRECTION_REVERSE_RBTN,PDirectionGrpBox);

  PDeleteAnm_PB = new TButton(this,IDNO);
  PFUCLen_ETB = new TEdit(this,IDC_FUCLEN_ETB,5);
  PStartFrameNum_ETB = new TEdit(this,IDC_STARTFRAMENUM_ETB,5);
}
//*******************************************************************
// Future: uncomment comments to enable still direction input.
void TEditAnmCellDlg::SetupWindow()
{
  TDialog::SetupWindow();
  char Buffer[10];
  pXEdit->SetText(itoa(X,Buffer,10));
  pYEdit->SetText(itoa(Y,Buffer,10));
  pZEdit->SetText(itoa(Z,Buffer,10));

  int16 fd = BF_UNCHECKED;
  int16 rd = BF_UNCHECKED;
  int16 sd = BF_UNCHECKED;

  if (GetDirection() == dForward)
  {
    fd = BF_CHECKED;
  }
  else if (GetDirection() == dReverse)
  {
    rd = BF_CHECKED;
  }
  else
  {
    sd = BF_CHECKED;
  }
  PForwardRBtn->SetCheck(fd);
  PReverseRBtn->SetCheck(rd);
  PStillRBtn->SetCheck(sd);
//  PStillRBtn->EnableWindow(false);

  if (bCreating)
  {
    PDeleteAnm_PB->EnableWindow(false);
  }
  PFUCLen_ETB->SetText(itoa(FUCLength,Buffer,10));
  PStartFrameNum_ETB->SetText(itoa(StartFrameNum,Buffer,10));
}
//*******************************************************************
TEditAnmCellDlg::~TEditAnmCellDlg()
{
  delete pXEdit;
  pXEdit = NULL;

  delete pYEdit;
  pYEdit = NULL;

  delete pZEdit;
  pZEdit = NULL;

  delete PDeleteAnm_PB;
  PDeleteAnm_PB = NULL;

  delete PFUCLen_ETB;
  PFUCLen_ETB = NULL;

  delete PStartFrameNum_ETB;
  PStartFrameNum_ETB = NULL;
}
//*******************************************************************
void TEditAnmCellDlg::CmOk()
{
  char Buffer[25];

  pXEdit->GetText(Buffer,pXEdit->GetTextLen() + 1);
  string xstr = Buffer;
  pYEdit->GetText(Buffer,pYEdit->GetTextLen() + 1);
  string ystr = Buffer;
  pZEdit->GetText(Buffer,pZEdit->GetTextLen() + 1);
  string zstr = Buffer;
  PFUCLen_ETB->GetText(Buffer,PFUCLen_ETB->GetTextLen() + 1);
  string flstr = Buffer;
  PStartFrameNum_ETB->GetText(Buffer,PStartFrameNum_ETB->GetTextLen() + 1);
  string sfnstr = Buffer;

  X = (int16)atoi(xstr.c_str());
  Y = (int16)atoi(ystr.c_str());
  Z = (int16)atoi(zstr.c_str());
  FUCLength = (dword)atoi(flstr.c_str());
  StartFrameNum = (int16)atoi(sfnstr.c_str());

  if (PForwardRBtn->GetCheck() == BF_CHECKED)
  {
    Direction = dForward;
  }
  else if (PReverseRBtn->GetCheck() == BF_CHECKED)
  {
    Direction = dReverse;
  }
  else
  {
    Direction = dStill;
  }
  TDialog::CmOk();
}
//*******************************************************************
void TEditAnmCellDlg::CmNo()
{
  Destroy(IDNO);
}
//*******************************************************************
//*******************************************************************
DEFINE_RESPONSE_TABLE1(TEditWavCellDlg,TDialog)
  EV_COMMAND(IDNO,CmNo),
  EV_COMMAND(IDOK,CmOk),
END_RESPONSE_TABLE;
//*******************************************************************
TEditWavCellDlg::TEditWavCellDlg(TWindow *parent,int16 wavfuclength)
:TDialog(parent,IDD_EDITWAVCELL),
 WavFUCLength(wavfuclength)
{
  PWavFUCLengthETB = new TEdit(this,IDC_FUCLENGTH_ETB);
  TFilterValidator *pfv = new TFilterValidator("0123456789");
  PWavFUCLengthETB->SetValidator(pfv);
}
//*******************************************************************
TEditWavCellDlg::~TEditWavCellDlg()
{
  delete PWavFUCLengthETB;
  PWavFUCLengthETB = NULL;
}
//*******************************************************************
void TEditWavCellDlg::SetupWindow()
{
  TDialog::SetupWindow();
  
  char buffer[50];
  itoa(WavFUCLength,buffer,10);
  PWavFUCLengthETB->SetText(buffer);
}
//*******************************************************************
void TEditWavCellDlg::CmOk()
{
  char buffer[50];
  PWavFUCLengthETB->GetText(buffer,PWavFUCLengthETB->GetTextLen() + 1);
  WavFUCLength = (int16)atoi(buffer);
  TDialog::CmOk();
}
//*******************************************************************
void TEditWavCellDlg::CmNo()
{
  Destroy(IDNO);
}
//*******************************************************************
//*******************************************************************
DEFINE_RESPONSE_TABLE1(TPortfolioDlg,TDialog)
  EV_COMMAND(IDYES,CmAdd),
  EV_COMMAND(IDNO,CmDel),
END_RESPONSE_TABLE;
//*******************************************************************
TPortfolioDlg::TPortfolioDlg(int16 skitcatindex,
                             TWindow *parent,
                             TSkitPortfolioList *Pspl,
                             string Caption)
  :TDialog(parent,PORTFOLIODIALOG)
{
  SkitCatIndex = skitcatindex;
  CaptionStr = Caption;
  PSPL = Pspl;
  lb = new TListBox(this,IDC_SELECTMODELISTBOX);
  lb->EnableTransfer();
  sel = 0;
}
//*******************************************************************
TPortfolioDlg::~TPortfolioDlg()
{
}
//*******************************************************************
void TPortfolioDlg::ReloadLB()
{
  TSkitPortfolioElement *pspe;
  string Str;
  for (pspe = PSPL->GetFirst();
       pspe != NULL;
       pspe = PSPL->GetNext())
  {
    Str = pspe->GetSkitName();
    lb->AddString(Str.c_str());
  }
  lb->SetSelIndex(sel);
}
//*******************************************************************
void TPortfolioDlg::UnloadLB()
{
  lb->ClearList();
}
//*******************************************************************
void TPortfolioDlg::SetupWindow()
{
  TDialog::SetupWindow();

  SetCaption(CaptionStr.c_str());

  ReloadLB();
}
//*******************************************************************
void TPortfolioDlg::CmAdd()
{
  sel = (int16)lb->GetSelIndex();
  if (sel < 0) {sel = 0;}

  TSelectSkitDlg ssd(SkitCatIndex,this,"Select Skit");
  if (ssd.Execute() == IDOK)
  {
    string str = ssd.RetrieveSelection();
    if (PSPL->IndexAddName(sel,str))
    {
      UnloadLB();
      ReloadLB();
    }
    else
    {
      MessageBox("Error adding to list","Portfolio Dlg - Add",MB_OK);
    }
  }
}
//*******************************************************************
void TPortfolioDlg::CmDel()
{
  sel = (int16)lb->GetSelIndex();
  if (sel < 0) {return;}

  string *PStr = (string *)PSPL->IndexRemove(sel);
  if (sel > PSPL->GetLastNum())
  {
    sel = PSPL->GetLastNum();
  }

  if (PStr != NULL)
  {
    delete PStr;
    UnloadLB();
    ReloadLB();
  }
  else
  {
    MessageBox("Error remove from list","Portfolio Dlg - Remove",MB_OK);
  }
}
//*******************************************************************
DEFINE_RESPONSE_TABLE1(TSelectPortfolioListDlg,TDialog)
  EV_COMMAND(IDC_PL0,CmList0),
  EV_COMMAND(IDC_PL1,CmList1),
  EV_COMMAND(IDC_PL2,CmList2),
  EV_COMMAND(IDC_PL3,CmList3),
  EV_COMMAND(IDC_PL4,CmList4),
  EV_COMMAND(IDC_PL5,CmList5),
  EV_COMMAND(IDC_PL6,CmList6),
  EV_COMMAND(IDC_PL7,CmList7),
  EV_COMMAND(IDC_PL8,CmList8),
  EV_COMMAND(IDC_PL9,CmList9),
  EV_COMMAND(IDC_HELP2,CmHelp),
END_RESPONSE_TABLE;
//*******************************************************************
TSelectPortfolioListDlg::TSelectPortfolioListDlg(TWindow *parent,
                                                 int16 skitcatindex,
                                                 TSkitPortfolio *pskitportfolio,
                                                 string skitcatname)
:TDialog(parent,SELECTPORTFOLIODLG)
{
  Parent = parent;
  PSkitPortfolio = pskitportfolio;
  SkitCatIndex = skitcatindex;
  PStatic[0] = new TStatic(this,IDC_PLT0,4);
  PStatic[1] = new TStatic(this,IDC_PLT1,4);
  PStatic[2] = new TStatic(this,IDC_PLT2,4);
  PStatic[3] = new TStatic(this,IDC_PLT3,4);
  PStatic[4] = new TStatic(this,IDC_PLT4,4);
  PStatic[5] = new TStatic(this,IDC_PLT5,4);
  PStatic[6] = new TStatic(this,IDC_PLT6,4);
  PStatic[7] = new TStatic(this,IDC_PLT7,4);
  PStatic[8] = new TStatic(this,IDC_PLT8,4);
  PStatic[9] = new TStatic(this,IDC_PLT9,4);
  string caption = "Select Portfolio List for (";
  caption += skitcatname;
  caption += ") .skl";
  SetCaption(caption.c_str());
}
//*******************************************************************
TSelectPortfolioListDlg::~TSelectPortfolioListDlg()
{
  for (int i=0;i<10;i++)
  {
    delete PStatic[i];
    PStatic[i] = NULL;
  }
}
//*******************************************************************
void TSelectPortfolioListDlg::SetupWindow()
{
  TDialog::SetupWindow();
  UpdateText();
}
//*******************************************************************
void TSelectPortfolioListDlg::CmHelp()
{
  string str = "Random -> List(0-9).";
  str += " No entries -> inc list# until list w/ entries found.";
  str += " Cur list pos used next and inc'd.";
  str += " If criteria ok ->start skit else get next.";
  str += " If none good -> next list.";
  str += " If none good in List#9 -> no action.";
  MessageBox(str.c_str(),"Help - Skit Portfolio Lists",MB_OK);
}
//*******************************************************************
void TSelectPortfolioListDlg::DoPortDlg(int16 listindex)
{
  TSkitPortfolioList *POldPL = PSkitPortfolio->PortfolioLists[listindex];
  TSkitPortfolioList *PSPL = new TSkitPortfolioList(*POldPL);

  char buffer[17];
  itoa(listindex,buffer,10);
  string caption = "Edit Portfolio List #";
  caption += buffer;
  TPortfolioDlg spd(SkitCatIndex,this,PSPL,caption);
  if (spd.Execute() == IDOK)
  {
    TSkitPortfolioList *PTempPL = PSkitPortfolio->PortfolioLists[listindex];
    PSkitPortfolio->PortfolioLists[listindex] = PSPL;
    delete PTempPL;
    PTempPL = NULL;
  }
  else
  {
    delete PSPL;
    PSPL = NULL;
  }
}
//*******************************************************************
void TSelectPortfolioListDlg::CmList0()
{
  DoPortDlg(0);
  UpdateText();
}
//*******************************************************************
void TSelectPortfolioListDlg::CmList1()
{
  DoPortDlg(1);
  UpdateText();
}
//*******************************************************************
void TSelectPortfolioListDlg::CmList2()
{
  DoPortDlg(2);
  UpdateText();
}
//*******************************************************************
void TSelectPortfolioListDlg::CmList3()
{
  DoPortDlg(3);
  UpdateText();
}
//*******************************************************************
void TSelectPortfolioListDlg::CmList4()
{
  DoPortDlg(4);
  UpdateText();
}
//*******************************************************************
void TSelectPortfolioListDlg::CmList5()
{
  DoPortDlg(5);
  UpdateText();
}
//*******************************************************************
void TSelectPortfolioListDlg::CmList6()
{
  DoPortDlg(6);
  UpdateText();
}
//*******************************************************************
void TSelectPortfolioListDlg::CmList7()
{
  DoPortDlg(7);
  UpdateText();
}
//*******************************************************************
void TSelectPortfolioListDlg::CmList8()
{
  DoPortDlg(8);
  UpdateText();
}
//*******************************************************************
void TSelectPortfolioListDlg::CmList9()
{
  DoPortDlg(9);
  UpdateText();
}
//*******************************************************************
void TSelectPortfolioListDlg::UpdateText()
{
  int16 numnames = 0;
  char buffer[17];
  for (int16 i=0;i<10;i++)
  {
    numnames = PSkitPortfolio->PortfolioLists[i]->GetNumNames();
    itoa(numnames,buffer,10);
    PStatic[i]->SetText(buffer);
  }
  Invalidate();
}
//*******************************************************************
DEFINE_RESPONSE_TABLE1(TSelectStringDlg,TDialog)
	EV_COMMAND(IDOK,CmOK),
   EV_LBN_DBLCLK(IDC_SELECTMODELISTBOX,EvDblClk),
END_RESPONSE_TABLE;
//*******************************************************************
TSelectStringDlg::TSelectStringDlg(TWindow* parent, string Caption,TResId resId)
  :TDialog(parent,resId),
	lbStrings(25,0,10)
{
	lb = new TListBox(this,IDC_SELECTMODELISTBOX);
	lb->EnableTransfer();
	strCaption = Caption;
}
//*******************************************************************
TSelectStringDlg::~TSelectStringDlg()
{
	delete lb;
}
//*******************************************************************
string TSelectStringDlg::RetrieveSelection()
{
	return *lbStrings[sel];
}
//*******************************************************************
int16 TSelectStringDlg::RetrieveIndex()
{
  return sel;
}
//*******************************************************************
bool TSelectStringDlg::LoadlbStrings()
{
  // placeholder function.
  return true;
}
//*******************************************************************
void TSelectStringDlg::SetupWindow()
{
  TDialog::SetupWindow();
  SetCaption(strCaption.c_str());

  LoadlbStrings();

  for (int i=0;i<lbStrings.GetItemsInContainer();i++)
	  lb->AddString(lbStrings[i]->c_str());
  lb->SetSelIndex(0);
}
//*******************************************************************
void TSelectStringDlg::CmOK()
{
  sel = (int16)lb->GetSelIndex();
  TDialog::CmOk();
}
//*******************************************************************
void TSelectStringDlg::EvDblClk()
// note: the dblclk from the listbox is "sent" not "posted" so you
//       can't directly call CmOk(), you must "post" the msg to the dlg.
//       If you call CmOk() then you kill the stack that you're living in.
{
  ::PostMessage(HWindow,WM_COMMAND,IDOK,0);
}
//*******************************************************************
bool TSelectStringFromFileDlg::LoadlbStrings()
{
  ifstream inf(strFileName.c_str(),ios::in | ios::nocreate);

	assert(inf);
	char buffer[181];

	buffer[0]= '\0';

	while (inf.getline(buffer,140))
	{
	  if ((!inf.eof()) && (inf.gcount() > 1))
	  {
		  buffer[inf.gcount()] = '\0';
		  string* str = new string(buffer);
		  str->append("                              ");
		  lbStrings.Add(str);
		  buffer[0] = '\0';
	  }
	}
	return  true;
}
//*******************************************************************
bool TSelectModeDlg::LoadlbStrings()
{
  string Str;
  string *PStr = NULL;
  int16 NumModes = TOgleApp::GetOgleApp()->PGame->GetNumModes();
  for (int16 i=0;i < NumModes;i++)
  {
    Str = TOgleApp::GetOgleApp()->PGame->GetModeName(i);
    if (Str.is_null()) {assert(false);}
    if (Str == strCurSel)
    {
      ndxCurSel = i;
    }
    PStr = new string;
    *PStr = Str;
    //PStr->append("                              ");
    lbStrings.Add(PStr);
  }
  return true;
}
//*******************************************************************
void TSelectModeDlg::SetupWindow()
{
  TSelectStringDlg::SetupWindow();
  lb->SetSelIndex(ndxCurSel);
}
//*******************************************************************
bool TSelectGObjDlg::LoadlbStrings()
{
  string Str;
  string *PStr = NULL;
//  int16 NumGObjs = TOgleApp::GetOgleApp()->GetFW()->GetModeWin()->PMode->GetNumGObjs();
  TGObjList *pgobjlist = TOgleApp::GetOgleApp()->GetFW()->GetModeWin()->GetGObjList();
  int16 NumGObjs = pgobjlist->GetNumElements();

  for (int16 i = 0;i < NumGObjs;i++)
  {
//    Str = TOgleApp::GetOgleApp()->GetFW()->GetModeWin()->PMode->GetGObjName(i);
    TGameObject *pgobj = pgobjlist->GetGObjPtr(i);
    if (pgobj == NULL) {assert(false);}
    Str = pgobj->FileMode.Name.GetStr();

    if (Str.is_null()) {assert(false);}
    PStr = new string;
    *PStr = Str;
    lbStrings.Add(PStr);
  }
  return true;
}
//*******************************************************************
bool TSelectSpriteDlg::LoadlbStrings()
{
  string Str;
  string *PStr = NULL;
  if (SelectedGObj == -1)
  {
    SelectedGObj = ((TEditorModeWin *)TOgleApp::GetOgleApp()->GetFW()->GetModeWin())->CurrentGObjIndex;
  }
//  TGameObject *PGObj = TOgleApp::GetOgleApp()->GetFW()->GetModeWin()->PGObjList->GetGObjPtr(SelectedGObj);
  TGameObject *PGObj = TOgleApp::GetOgleApp()->GetFW()->GetModeWin()->GetGObjList()->GetGObjPtr(SelectedGObj);
  int16 NumSprites = PGObj->GetLastNumSprites();
  string sprname;
  for (int16 i = 0;i<=NumSprites;i++)
  {
//    sprname = PGObj->GetSpriteList()->GetSpriteFName(i);
    sprname = PGObj->GetSpriteList()->GetSpriteName(i);
    PStr = new string;
    *PStr = sprname;
    lbStrings.Add(PStr);
  }
  return true;
}
//*******************************************************************
TSelectSpriteTypeDlg::TSelectSpriteTypeDlg(TSpriteEditorClientWin *parent,
                                           string Caption,TResId resId)
:TSelectStringDlg(parent,Caption,resId)
{
  PSprEdWin = parent;
}
//*******************************************************************
bool TSelectSpriteTypeDlg::LoadlbStrings()
{
  string Str;
  string *PStr = NULL;
  if (PSprEdWin->GetSpriteList() == NULL) {return false;}

  int16 NumSpriteTypes = PSprEdWin->GetSpriteList()->GetNumTypes();
  for (int16 i = 0;i<NumSpriteTypes;i++)
  {
    Str = PSprEdWin->GetSpriteList()->GetTypeName(i);
    PStr = new string;
    *PStr = Str;
    lbStrings.Add(PStr);
  }
  return true;
}
//*******************************************************************
bool TSelectSkitCatDlg::LoadlbStrings()
{
  string Str;
  string *PStr = NULL;
  int16 CurrentGObj = ((TEditorModeWin *)TOgleApp::GetOgleApp()->GetFW()->GetModeWin())->CurrentGObjIndex;
//  TGameObject *PGObj = TOgleApp::GetOgleApp()->GetFW()->GetModeWin()->PGObjList->GetGObjPtr(CurrentGObj);
  TGameObject *PGObj = TOgleApp::GetOgleApp()->GetFW()->GetModeWin()->GetGObjList()->GetGObjPtr(CurrentGObj);
  int16 LastNumSkitCats = PGObj->GetSkitCatsLastNum();
  string skitcatname;
  for (int16 i = 0;i<=LastNumSkitCats;i++)
  {
    skitcatname = PGObj->GetSkitCat()->GetSkitCatName(i);
    PStr = new string;
    *PStr = skitcatname;
    lbStrings.Add(PStr);
  }
  return true;
}
//*******************************************************************
bool TSelectSkitDlg::LoadlbStrings()
{
  string Str;
  string *PStr = NULL;
  int16 CurrentGObj = ((TEditorModeWin *)TOgleApp::GetOgleApp()->GetFW()->GetModeWin())->CurrentGObjIndex;
//  TGameObject *PGObj = TOgleApp::GetOgleApp()->GetFW()->GetModeWin()->PGObjList->GetGObjPtr(CurrentGObj);
  TGameObject *PGObj = TOgleApp::GetOgleApp()->GetFW()->GetModeWin()->GetGObjList()->GetGObjPtr(CurrentGObj);
  int16 NumSkits = PGObj->GetSkitList(CurrentSkitCatIndex)->GetLastNumSkits();
  string skitname;
  for (int16 i = 0;i<=NumSkits;i++)
  {
//    skitname = PGObj->GetSkitList(CurrentSkitCatIndex)->GetSkitFName(i);
    skitname = PGObj->GetSkitList(CurrentSkitCatIndex)->GetSkitName(i);
    PStr = new string;
    *PStr = skitname;
    lbStrings.Add(PStr);
  }
  return true;                          
}
//*******************************************************************
bool TSelectGameIdDlg::LoadlbStrings()
{
  string Str;
  string *PStr = NULL;
//  int16 numids = TOgleApp::GetOgleApp()->GetFW()->GetModeWin()->PMode->GetNumPossibleGames();
  int16 numids = TOgleApp::GetOgleApp()->GetFW()->GetModeWin()->GetMode()->GetNumPossibleGames();
  for (int16 i = 1;i<=numids;i++)
  {
//    Str = TOgleApp::GetOgleApp()->GetFW()->GetModeWin()->PMode->GetGameStr(i);
    Str = TOgleApp::GetOgleApp()->GetFW()->GetModeWin()->GetMode()->GetGameStr(i);
    PStr = new string;
    *PStr = Str;
    lbStrings.Add(PStr);
  }
  return true;
}
//*******************************************************************
//*******************************************************************
DEFINE_RESPONSE_TABLE1(TSpriteUsageDlg,TDialog)
	EV_COMMAND(IDC_SPRITEUSAGE_OK_BTN,CmOk),
   EV_COMMAND(IDC_SPRITEUSAGE_CANCEL_BTN,CmCancel),
   EV_COMMAND(IDC_SPRITEUSAGE_HELP_BTN,CmHelp),
   EV_COMMAND(IDC_SPRITEUSAGE_SKITCATALL_RBTN,CmSkitCatAll),
   EV_COMMAND(IDC_SPRITEUSAGE_SKITCATONE_RBTN,CmSkitCatOne),
   EV_COMMAND(IDC_SPRITEUSAGE_SKITALL_RBTN,CmSkitAll),
   EV_COMMAND(IDC_SPRITEUSAGE_SKITONE_RBTN,CmSkitOne),
   EV_COMMAND(IDC_SPRITEUSAGE_SPRITEALL_RBTN,CmSpriteAll),
   EV_COMMAND(IDC_SPRITEUSAGE_SPRITEONE_RBTN,CmSpriteOne),
   EV_COMMAND(IDC_SPRITEUSAGE_CHOOSEGOBJ_BTN,CmGObjChoose),
END_RESPONSE_TABLE;
//*******************************************************************
TSpriteUsageDlg::TSpriteUsageDlg(TWindow *parent,TGameObject *pgobj,int16 gobjindex)
:TDialog(parent,IDD_SPRITEUSAGE),
 PGObj(pgobj),
 GObjIndex(gobjindex)
{
  PChosenSkitCat_STB = new TStatic(this,IDC_SPRITEUSAGE_CHOSENSKITCAT_STB);
  PChosenSkit_STB = new TStatic(this,IDC_SPRITEUSAGE_CHOSENSKIT_STB);
  PChosenSprite_STB = new TStatic(this,IDC_SPRITEUSAGE_CHOSENSPRITE_STB);
  PChosenGObj_STB = new TStatic(this,IDC_SPRITEUSAGE_CHOSENGOBJ_STB);
  PSkitCatAll_RBtn = new TRadioButton(this,IDC_SPRITEUSAGE_SKITCATALL_RBTN);
  PSkitCatOne_RBtn = new TRadioButton(this,IDC_SPRITEUSAGE_SKITCATONE_RBTN);
  PSkitAll_RBtn = new TRadioButton(this,IDC_SPRITEUSAGE_SKITALL_RBTN);
  PSkitOne_RBtn = new TRadioButton(this,IDC_SPRITEUSAGE_SKITONE_RBTN);
  PSpriteAll_RBtn = new TRadioButton(this,IDC_SPRITEUSAGE_SPRITEALL_RBTN);
  PSpriteOne_RBtn = new TRadioButton(this,IDC_SPRITEUSAGE_SPRITEONE_RBTN);
  PFileName_ETB = new TEdit(this,IDC_SPRITEUSAGE_FILENAME_ETB);
  PStatus_STB = new TStatic(this,IDC_SPRITEUSAGE_STATUS_STB);

  AllStr = "All";
  StatusStr = "";
  ChosenSkitCatStr = AllStr;
  ChosenSkitStr = AllStr;
  ChosenSpriteStr = AllStr;
//  ChosenGObjStr = PGObj->GetFName();
  ChosenGObjStr = PGObj->FileMode.Name.GetStr();

  SpriteIndex = -1;
  SkitCatIndex = -1;
  SkitIndex = -1;
}
//*******************************************************************
TSpriteUsageDlg::~TSpriteUsageDlg()
{
  delete PChosenSkitCat_STB;
  delete PChosenSkit_STB;
  delete PChosenSprite_STB;
  delete PChosenGObj_STB;
  delete PSkitCatAll_RBtn;
  delete PSkitCatOne_RBtn;
  delete PSkitAll_RBtn;
  delete PSkitOne_RBtn;
  delete PSpriteAll_RBtn;
  delete PSpriteOne_RBtn;
  delete PFileName_ETB;
  delete PStatus_STB;
}
//*******************************************************************
void TSpriteUsageDlg::SetupWindow()
{
  TDialog::SetupWindow();
  PSkitCatAll_RBtn->SetCheck(BF_CHECKED);
  PSkitCatOne_RBtn->SetCheck(BF_UNCHECKED);
  PSkitAll_RBtn->SetCheck(BF_CHECKED);
  PSkitOne_RBtn->SetCheck(BF_UNCHECKED);
  PSpriteAll_RBtn->SetCheck(BF_CHECKED);
  PSpriteOne_RBtn->SetCheck(BF_UNCHECKED);
  PChosenSkitCat_STB->SetText(ChosenSkitCatStr.c_str());
  PChosenSkit_STB->SetText(ChosenSkitStr.c_str());
  PChosenSprite_STB->SetText(ChosenSpriteStr.c_str());
  PChosenGObj_STB->SetText(ChosenGObjStr.c_str());
  PStatus_STB->SetText(StatusStr.c_str());
  TOgleFileName ofn(TOgleApp::GetOgleApp()->GetFileMgr()->GetCDRomPath(-1));
  ofn.AppendDirPath("\\reports\\sprusage");
  ofn.AppendDirPath(PGObj->FileMode.Name.GetDirPath());
  ofn.SetFName(PGObj->FileMode.Name.GetFName());
  ofn.SetExt(".rpt");
  ofn.CreateDir();
  PFileName_ETB->SetText(ofn.GetStr().c_str());
}
//*******************************************************************
void TSpriteUsageDlg::SetStatus(string s)
{
  PStatus_STB->SetText(s.c_str());
}
//*******************************************************************
void TSpriteUsageDlg::SetGObjChoose()
{
  PChosenGObj_STB->SetText(ChosenGObjStr.c_str());
  SetSpriteAll();
}
//*******************************************************************
void TSpriteUsageDlg::SetSpriteAll()
{
  PSpriteAll_RBtn->SetCheck(BF_CHECKED);
  PSpriteOne_RBtn->SetCheck(BF_UNCHECKED);
  ChosenSpriteStr = AllStr;
  PChosenSprite_STB->SetText(ChosenSpriteStr.c_str());
  SpriteIndex = -1;
}
//*******************************************************************
void TSpriteUsageDlg::SetSpriteOne()
{
  PSpriteAll_RBtn->SetCheck(BF_UNCHECKED);
  PSpriteOne_RBtn->SetCheck(BF_CHECKED);
  PChosenSprite_STB->SetText(ChosenSpriteStr.c_str());
}
//*******************************************************************
void TSpriteUsageDlg::SetSkitAll()
{
  PSkitAll_RBtn->SetCheck(BF_CHECKED);
  PSkitOne_RBtn->SetCheck(BF_UNCHECKED);
  ChosenSkitStr = AllStr;
  PChosenSkit_STB->SetText(ChosenSkitStr.c_str());
  SkitIndex = -1;
}
//*******************************************************************
void TSpriteUsageDlg::SetSkitOne()
{
  PSkitAll_RBtn->SetCheck(BF_UNCHECKED);
  PSkitOne_RBtn->SetCheck(BF_CHECKED);
  PChosenSkit_STB->SetText(ChosenSkitStr.c_str());
}
//*******************************************************************
void TSpriteUsageDlg::SetSkitCatAll()
{
  PSkitCatAll_RBtn->SetCheck(BF_CHECKED);
  PSkitCatOne_RBtn->SetCheck(BF_UNCHECKED);
  ChosenSkitCatStr = AllStr;
  PChosenSkitCat_STB->SetText(ChosenSkitCatStr.c_str());
  SkitCatIndex = -1;
  SetSkitAll();
}
//*******************************************************************
void TSpriteUsageDlg::SetSkitCatOne()
{
  PSkitCatAll_RBtn->SetCheck(BF_UNCHECKED);
  PSkitCatOne_RBtn->SetCheck(BF_CHECKED);
  PChosenSkitCat_STB->SetText(ChosenSkitCatStr.c_str());
  SetSkitAll();
}
//*******************************************************************
void TSpriteUsageDlg::CmSkitCatAll()
{
  if (PSkitCatAll_RBtn->GetCheck() == BF_CHECKED) {return;}

  SetSkitCatAll();
}
//*******************************************************************
void TSpriteUsageDlg::CmSkitCatOne()
{
  if (PSkitCatOne_RBtn->GetCheck() == BF_CHECKED) {return;}

  SetSkitCatOne();
  TSelectSkitCatDlg *psscd = new TSelectSkitCatDlg(this,"Select skit cat");
  if (psscd->Execute() == IDOK)
  {
    SkitCatIndex = psscd->RetrieveIndex();
    ChosenSkitCatStr = psscd->RetrieveSelection();
    SetSkitCatOne();
  }
  else
  {
    SetSkitCatAll();
  }
  delete psscd;
}
//*******************************************************************
void TSpriteUsageDlg::CmSkitAll()
{
  if (PSkitAll_RBtn->GetCheck() == BF_CHECKED) {return;}

  SetSkitAll();
}
//*******************************************************************
void TSpriteUsageDlg::CmSkitOne()
{
  if (PSkitOne_RBtn->GetCheck() == BF_CHECKED) {return;}
  if (SkitCatIndex == -1) {return;}

  SetSkitOne();
  TSelectSkitDlg *pssd = new TSelectSkitDlg(SkitCatIndex,this,"Select skit");
  if (pssd->Execute() == IDOK)
  {
    SkitIndex = pssd->RetrieveIndex();
    ChosenSkitStr = pssd->RetrieveSelection();
    SetSkitOne();
  }
  else
  {
    SetSkitAll();
  }
  delete pssd;
}
//*******************************************************************
void TSpriteUsageDlg::CmSpriteAll()
{
  if (PSpriteAll_RBtn->GetCheck() == BF_CHECKED) {return;}

  SetSpriteAll();
}
//*******************************************************************
void TSpriteUsageDlg::CmSpriteOne()
{
  if (PSpriteOne_RBtn->GetCheck() == BF_CHECKED) {return;}
  SetSpriteOne();
  TSelectSpriteDlg *pssd = new TSelectSpriteDlg(this,"Select Sprite",GObjIndex);
  if (pssd->Execute() == IDOK)
  {
    SpriteIndex = pssd->RetrieveIndex();
    ChosenSpriteStr = pssd->RetrieveSelection();
    SetSpriteOne();
  }
  else
  {
    SetSpriteAll();
  }
  delete pssd;
}
//*******************************************************************
void TSpriteUsageDlg::CmGObjChoose()
{
  TSelectGObjDlg *psgd = new TSelectGObjDlg(this,"Select GObj");
  if (psgd->Execute() == IDOK)
  {
    GObjIndex = psgd->RetrieveIndex();
    ChosenGObjStr = psgd->RetrieveSelection();
    SetGObjChoose();
  }
  delete psgd;
}
//*******************************************************************
string TSpriteUsageDlg::GetFileName()
{
  int len = PFileName_ETB->GetTextLen();
  char *buffer = new char[len + 2];
  PFileName_ETB->GetText(buffer,len + 1);
  string s = buffer;
  delete [] buffer;
  s.strip(string::Both);
  return s;
}
//*******************************************************************
void TSpriteUsageDlg::CmOk()
// need to add way to specify which gobj's whose sprite we are checking.
{
//  string filename = GetFileName();
  TOgleFileName ofn(GetFileName());
  ofn.CreateDir();
//  ofstream os(filename.c_str());
  ofstream os(ofn.GetStr().c_str());
  if (!os)
  {
    MessageBox("Error opening report file","Error - Sprite Usage",MB_OK);
    return;
  }
  os<<"Report FileName: "<<ofn.GetStr()<<"\n";
  os<<"Start of Sprite Usage Report\n";
  SetStatus("working ....");
  PGObj->ReportSpriteUsage(os,GObjIndex,SkitCatIndex,SkitIndex,SpriteIndex);
  os<<"End of Sprite Usage Report\n";
  os.close();
//  string s = "Written to ";
//  s += filename;
  SetStatus("Done");
//  MessageBox(s.c_str(),"Report Completed",MB_OK);
  string s = "notepad.exe ";
  s += ofn.GetStr();
  WinExec(s.c_str(),SW_SHOWNORMAL);
  TDialog::CmOk();
}
//*******************************************************************
void TSpriteUsageDlg::CmCancel()
{
  TDialog::CmCancel();
}
//*******************************************************************
void TSpriteUsageDlg::CmHelp()
{
  MessageBox("no help avail","Help - Sprite Usage",MB_OK);
}
//*******************************************************************

