//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  acvpgfw.cpp
//    Project Name:  acvp
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  2.5    09/22/99    M.Perry    original baseline
//********************************************************************
#include "acvpgfw.h"
#include "cgametyp.h"
#include "acvpmenu.rh"
#include "acvpname.rh"
#include "acvp_abt.rh"
#include "omodewin.h"

#include "acvpapp.h"
#include "ogame.h"
#include "cgametyp.h"
#include "omodewin.h"
#include "casmw.h"
#include "ofilemgr.h"

#include "cas_cm.rh"
#include "acvp_cm.rh"
#include "acvpvpmw.h"
#include "acvplmw.h"
#include "acvpsmw.h"
#include "acvpimw.h"
//*******************************************************************
string GetAppString(int16 ids)
{
  return TAppString(ids);
}
//*******************************************************************
TACVPMenuEnable::TACVPMenuEnable(bool setvalues)
:TCasinoMenuEnable(false)
{
  //init flags
  SetAllEnb(false);
  SetAllAllowed(false);
  SetValidAllowed();
  if (setvalues)
  {
    SetAll(true);
  }
  CurrentMode = -1;
  Denom = 0.0;
}
//*******************************************************************
TACVPMenuEnable::~TACVPMenuEnable()
{
}
//*******************************************************************
void TACVPMenuEnable::SetAll(bool value)
{
  TCasinoMenuEnable::SetAll(value);
}
//*******************************************************************
void TACVPMenuEnable::SetAllEnb(bool value)
{
  for (int16 i=0;i<TMoney::did_NumIDs;i++)
  {
    FivesUpEnb[i] = value;
    BlackJacksEnb[i] = value;
    BonusDeluxeEnb[i] = value;
    ClubBonusEnb[i] = value;
    Crazy8sEnb[i] = value;
    DDrawJacksOrBetterEnb[i] = value;
    DDrawJokerPokerEnb[i] = value;
    DDownStudEnb[i] = value;
    DeucesWildBonusEnb[i] = value;
    DeucesWildEnb[i] = value;
    DeucesWildProgEnb[i] = value;
    DiamondBonusEnb[i] = value;
    DBonusPokerEnb[i] = value;
    FlushAssaultEnb[i] = value;
    FreeLookEnb[i] = value;
    GamblersEdgeEnb[i] = value;
    HeartBonusEnb[i] = value;
    JacksOrBetterProgEnb[i] = value;
    JackpotBonusEnb[i] = value;
    JacksOrBetter96Enb[i] = value;
    JacksOrBetter85Enb[i] = value;
    JacksOrBetterDNothingEnb[i] = value;
    JokersWildProgEnb[i] = value;
    JumpinJokersEnb[i] = value;
    TripleProgEnb[i] = value;
    RoyalsProgEnb[i] = value;
    PowerHouseProgEnb[i] = value;
    RaiseDrawJokerPokerEnb[i] = value;
    SpadeBonusEnb[i] = value;
    SuperDJackpotEnb[i] = value;
    SevensWild1JokerEnb[i] = value;
    TensOrBetterEnb[i] = value;
    TreasureTroveEnb[i] = value;
    TriplePlayEnb[i] = value;
    TripleBonusEnb[i] = value;
    WheelDealEnb[i] = value;
    CrystalPalaceEnb[i] = value;
    SuperSevensEnb[i] = value;
  }
}
//*******************************************************************
void TACVPMenuEnable::SetValidAllowed()
//note: these are all the allowed denom's per mode.
{
  FivesUpAllowed[TMoney::did_0_25] = true;
  FivesUpAllowed[TMoney::did_1_00] = true;
  FivesUpAllowed[TMoney::did_50_00] = true;
  FivesUpAllowed[TMoney::did_100_00] = true;

  BlackJacksAllowed[TMoney::did_10_00] = true;
  BlackJacksAllowed[TMoney::did_50_00] = true;
  BlackJacksAllowed[TMoney::did_100_00] = true;
  BlackJacksAllowed[TMoney::did_1000_00] = true;

  BonusDeluxeAllowed[TMoney::did_0_25] = true;
  BonusDeluxeAllowed[TMoney::did_1_00] = true;
  BonusDeluxeAllowed[TMoney::did_5_00] = true;
  BonusDeluxeAllowed[TMoney::did_10_00] = true;
  BonusDeluxeAllowed[TMoney::did_25_00] = true;

  ClubBonusAllowed[TMoney::did_5_00] = true;
  ClubBonusAllowed[TMoney::did_100_00] = true;
  ClubBonusAllowed[TMoney::did_500_00] = true;

  Crazy8sAllowed[TMoney::did_1_00] = true;
  Crazy8sAllowed[TMoney::did_5_00] = true;
  Crazy8sAllowed[TMoney::did_10_00] = true;
  Crazy8sAllowed[TMoney::did_1000_00] = true;

  DDrawJacksOrBetterAllowed[TMoney::did_0_25] = true;
  DDrawJacksOrBetterAllowed[TMoney::did_1_00] = true;
  DDrawJacksOrBetterAllowed[TMoney::did_10_00] = true;
  DDrawJacksOrBetterAllowed[TMoney::did_50_00] = true;
  DDrawJacksOrBetterAllowed[TMoney::did_1000_00] = true;

  DDrawJokerPokerAllowed[TMoney::did_1_00] = true;
  DDrawJokerPokerAllowed[TMoney::did_5_00] = true;
  DDrawJokerPokerAllowed[TMoney::did_10_00] = true;
  DDrawJokerPokerAllowed[TMoney::did_25_00] = true;
  DDrawJokerPokerAllowed[TMoney::did_500_00] = true;

  DDownStudAllowed[TMoney::did_0_25] = true;
  DDownStudAllowed[TMoney::did_1_00] = true;
  DDownStudAllowed[TMoney::did_5_00] = true;
  DDownStudAllowed[TMoney::did_50_00] = true;
  DDownStudAllowed[TMoney::did_100_00] = true;

  DeucesWildBonusAllowed[TMoney::did_0_25] = true;
  DeucesWildBonusAllowed[TMoney::did_1_00] = true;
  DeucesWildBonusAllowed[TMoney::did_25_00] = true;
  DeucesWildBonusAllowed[TMoney::did_1000_00] = true;

  DeucesWildAllowed[TMoney::did_0_05] = true;
  DeucesWildAllowed[TMoney::did_0_10] = true;
  DeucesWildAllowed[TMoney::did_0_25] = true;
  DeucesWildAllowed[TMoney::did_1_00] = true;
  DeucesWildAllowed[TMoney::did_5_00] = true;
  DeucesWildAllowed[TMoney::did_25_00] = true;
  DeucesWildAllowed[TMoney::did_100_00] = true;

  DeucesWildProgAllowed[TMoney::did_0_05] = true;
  DeucesWildProgAllowed[TMoney::did_1_00] = true;
  DeucesWildProgAllowed[TMoney::did_5_00] = true;

  DiamondBonusAllowed[TMoney::did_0_10] = true;
  DiamondBonusAllowed[TMoney::did_0_25] = true;
  DiamondBonusAllowed[TMoney::did_10_00] = true;
  DiamondBonusAllowed[TMoney::did_25_00] = true;
  DiamondBonusAllowed[TMoney::did_50_00] = true;

  DBonusPokerAllowed[TMoney::did_0_05] = true;
  DBonusPokerAllowed[TMoney::did_0_10] = true;
  DBonusPokerAllowed[TMoney::did_0_25] = true;
  DBonusPokerAllowed[TMoney::did_1_00] = true;
  DBonusPokerAllowed[TMoney::did_100_00] = true;

  FlushAssaultAllowed[TMoney::did_1_00] = true;
  FlushAssaultAllowed[TMoney::did_25_00] = true;
  FlushAssaultAllowed[TMoney::did_100_00] = true;
  FlushAssaultAllowed[TMoney::did_500_00] = true;
  FlushAssaultAllowed[TMoney::did_1000_00] = true;

  FreeLookAllowed[TMoney::did_0_25] = true;
  FreeLookAllowed[TMoney::did_1_00] = true;
  FreeLookAllowed[TMoney::did_1000_00] = true;

  GamblersEdgeAllowed[TMoney::did_100_00] = true;
  GamblersEdgeAllowed[TMoney::did_500_00] = true;
  GamblersEdgeAllowed[TMoney::did_1000_00] = true;

  HeartBonusAllowed[TMoney::did_0_05] = true;
  HeartBonusAllowed[TMoney::did_0_10] = true;
  HeartBonusAllowed[TMoney::did_0_25] = true;
  HeartBonusAllowed[TMoney::did_1_00] = true;

  JacksOrBetterProgAllowed[TMoney::did_0_10] = true;
  JacksOrBetterProgAllowed[TMoney::did_0_25] = true;
  JacksOrBetterProgAllowed[TMoney::did_1_00] = true;
  JacksOrBetterProgAllowed[TMoney::did_5_00] = true;
  JacksOrBetterProgAllowed[TMoney::did_50_00] = true;

  JackpotBonusAllowed[TMoney::did_1_00] = true;

  JacksOrBetter96Allowed[TMoney::did_0_25] = true;
  JacksOrBetter96Allowed[TMoney::did_1_00] = true;
  JacksOrBetter96Allowed[TMoney::did_5_00] = true;
  JacksOrBetter96Allowed[TMoney::did_50_00] = true;
  JacksOrBetter96Allowed[TMoney::did_100_00] = true;
  JacksOrBetter96Allowed[TMoney::did_500_00] = true;
  JacksOrBetter96Allowed[TMoney::did_1000_00] = true;

  JacksOrBetter85Allowed[TMoney::did_0_05] = true;
  JacksOrBetter85Allowed[TMoney::did_0_10] = true;
  JacksOrBetter85Allowed[TMoney::did_0_25] = true;
  JacksOrBetter85Allowed[TMoney::did_1_00] = true;
  JacksOrBetter85Allowed[TMoney::did_5_00] = true;
  JacksOrBetter85Allowed[TMoney::did_10_00] = true;
  JacksOrBetter85Allowed[TMoney::did_25_00] = true;
  JacksOrBetter85Allowed[TMoney::did_50_00] = true;
  JacksOrBetter85Allowed[TMoney::did_100_00] = true;
  JacksOrBetter85Allowed[TMoney::did_500_00] = true;
  JacksOrBetter85Allowed[TMoney::did_1000_00] = true;

  JacksOrBetterDNothingAllowed[TMoney::did_0_25] = true;
  JacksOrBetterDNothingAllowed[TMoney::did_1_00] = true;
  JacksOrBetterDNothingAllowed[TMoney::did_5_00] = true;
  JacksOrBetterDNothingAllowed[TMoney::did_25_00] = true;
  JacksOrBetterDNothingAllowed[TMoney::did_100_00] = true;

  JokersWildProgAllowed[TMoney::did_0_05] = true;
  JokersWildProgAllowed[TMoney::did_0_25] = true;
  JokersWildProgAllowed[TMoney::did_1_00] = true;
  JokersWildProgAllowed[TMoney::did_100_00] = true;

  JumpinJokersAllowed[TMoney::did_5_00] = true;
  JumpinJokersAllowed[TMoney::did_50_00] = true;

  TripleProgAllowed[TMoney::did_0_05] = true;
  TripleProgAllowed[TMoney::did_0_25] = true;
  TripleProgAllowed[TMoney::did_1_00] = true;
  TripleProgAllowed[TMoney::did_10_00] = true;

  RoyalsProgAllowed[TMoney::did_0_10] = true;
  RoyalsProgAllowed[TMoney::did_1_00] = true;
  RoyalsProgAllowed[TMoney::did_25_00] = true;

  PowerHouseProgAllowed[TMoney::did_0_25] = true;
  PowerHouseProgAllowed[TMoney::did_1_00] = true;
  PowerHouseProgAllowed[TMoney::did_50_00] = true;

  RaiseDrawJokerPokerAllowed[TMoney::did_0_25] = true;
  RaiseDrawJokerPokerAllowed[TMoney::did_1_00] = true;
  RaiseDrawJokerPokerAllowed[TMoney::did_10_00] = true;
  RaiseDrawJokerPokerAllowed[TMoney::did_100_00] = true;
  RaiseDrawJokerPokerAllowed[TMoney::did_500_00] = true;

  SpadeBonusAllowed[TMoney::did_0_05] = true;
  SpadeBonusAllowed[TMoney::did_0_25] = true;
  SpadeBonusAllowed[TMoney::did_5_00] = true;

  SuperDJackpotAllowed[TMoney::did_0_25] = true;
  SuperDJackpotAllowed[TMoney::did_1_00] = true;
  SuperDJackpotAllowed[TMoney::did_100_00] = true;

  SevensWild1JokerAllowed[TMoney::did_5_00] = true;
  SevensWild1JokerAllowed[TMoney::did_25_00] = true;
  SevensWild1JokerAllowed[TMoney::did_1000_00] = true;

  TensOrBetterAllowed[TMoney::did_0_05] = true;
  TensOrBetterAllowed[TMoney::did_0_10] = true;
  TensOrBetterAllowed[TMoney::did_0_25] = true;
  TensOrBetterAllowed[TMoney::did_1_00] = true;
  TensOrBetterAllowed[TMoney::did_50_00] = true;

  TreasureTroveAllowed[TMoney::did_1_00] = true;
  TreasureTroveAllowed[TMoney::did_100_00] = true;
  TreasureTroveAllowed[TMoney::did_1000_00] = true;

  TriplePlayAllowed[TMoney::did_0_25] = true;
  TriplePlayAllowed[TMoney::did_1_00] = true;
  TriplePlayAllowed[TMoney::did_25_00] = true;
  TriplePlayAllowed[TMoney::did_500_00] = true;

  TripleBonusAllowed[TMoney::did_0_25] = true;
  TripleBonusAllowed[TMoney::did_50_00] = true;

  WheelDealAllowed[TMoney::did_1_00] = true;
  WheelDealAllowed[TMoney::did_10_00] = true;
  WheelDealAllowed[TMoney::did_1000_00] = true;

  CrystalPalaceAllowed[TMoney::did_0_25] = true;
  CrystalPalaceAllowed[TMoney::did_1_00] = true;
  CrystalPalaceAllowed[TMoney::did_10_00] = true;
  CrystalPalaceAllowed[TMoney::did_100_00] = true;
  CrystalPalaceAllowed[TMoney::did_1000_00] = true;

  SuperSevensAllowed[TMoney::did_0_05] = true;
  SuperSevensAllowed[TMoney::did_0_25] = true;
  SuperSevensAllowed[TMoney::did_1_00] = true;
  SuperSevensAllowed[TMoney::did_25_00] = true;
  SuperSevensAllowed[TMoney::did_500_00] = true;
}
//*******************************************************************
void TACVPMenuEnable::SetAllAllowed(bool value)
{
  for (int16 i=0;i<TMoney::did_NumIDs;i++)
  {
    FivesUpAllowed[i] = value;
    BlackJacksAllowed[i] = value;
    BonusDeluxeAllowed[i] = value;
    ClubBonusAllowed[i] = value;
    Crazy8sAllowed[i] = value;
    DDrawJacksOrBetterAllowed[i] = value;
    DDrawJokerPokerAllowed[i] = value;
    DDownStudAllowed[i] = value;
    DeucesWildBonusAllowed[i] = value;
    DeucesWildAllowed[i] = value;
    DeucesWildProgAllowed[i] = value;
    DiamondBonusAllowed[i] = value;
    DBonusPokerAllowed[i] = value;
    FlushAssaultAllowed[i] = value;
    FreeLookAllowed[i] = value;
    GamblersEdgeAllowed[i] = value;
    HeartBonusAllowed[i] = value;
    JacksOrBetterProgAllowed[i] = value;
    JackpotBonusAllowed[i] = value;
    JacksOrBetter96Allowed[i] = value;
    JacksOrBetter85Allowed[i] = value;
    JacksOrBetterDNothingAllowed[i] = value;
    JokersWildProgAllowed[i] = value;
    JumpinJokersAllowed[i] = value;
    TripleProgAllowed[i] = value;
    RoyalsProgAllowed[i] = value;
    PowerHouseProgAllowed[i] = value;
    RaiseDrawJokerPokerAllowed[i] = value;
    SpadeBonusAllowed[i] = value;
    SuperDJackpotAllowed[i] = value;
    SevensWild1JokerAllowed[i] = value;
    TensOrBetterAllowed[i] = value;
    TreasureTroveAllowed[i] = value;
    TriplePlayAllowed[i] = value;
    TripleBonusAllowed[i] = value;
    WheelDealAllowed[i] = value;

    CrystalPalaceAllowed[i] = value;
    SuperSevensAllowed[i] = value;
  }
}
//*******************************************************************
void TACVPMenuEnable::SetModes(bool value)
{
  TCasinoMenuEnable::SetModes(value);

  About = value;
  Contents = value;

  Lobby = value;

  if (!value)// if false then just do it, and quick out.
  {
    SetAllEnb(false);
  }
  else  // true then only set if denomid is allowed.
  {
    // loop thru each denomid and only enable if allowed.
    for (int16 i=0;i<TMoney::did_NumIDs;i++)
    {
      if (FivesUpAllowed[i])               {FivesUpEnb[i] = true;}
      if (BlackJacksAllowed[i])            {BlackJacksEnb[i] = true;}
      if (BonusDeluxeAllowed[i])           {BonusDeluxeEnb[i] = true;}
      if (ClubBonusAllowed[i])             {ClubBonusEnb[i] = true;}
      if (Crazy8sAllowed[i])               {Crazy8sEnb[i] = true;}
      if (DDrawJacksOrBetterAllowed[i])    {DDrawJacksOrBetterEnb[i] = true;}
      if (DDrawJokerPokerAllowed[i])       {DDrawJokerPokerEnb[i] = true;}
      if (DDownStudAllowed[i])             {DDownStudEnb[i] = true;}
      if (DeucesWildBonusAllowed[i])       {DeucesWildBonusEnb[i] = true;}
      if (DeucesWildAllowed[i])            {DeucesWildEnb[i] = true;}
      if (DeucesWildProgAllowed[i])        {DeucesWildProgEnb[i] = true;}
      if (DiamondBonusAllowed[i])          {DiamondBonusEnb[i] = true;}
      if (DBonusPokerAllowed[i])           {DBonusPokerEnb[i] = true;}
      if (FlushAssaultAllowed[i])          {FlushAssaultEnb[i] = true;}
      if (FreeLookAllowed[i])              {FreeLookEnb[i] = true;}
      if (GamblersEdgeAllowed[i])          {GamblersEdgeEnb[i] = true;}
      if (HeartBonusAllowed[i])            {HeartBonusEnb[i] = true;}
      if (JacksOrBetterProgAllowed[i])     {JacksOrBetterProgEnb[i] = true;}
      if (JackpotBonusAllowed[i])          {JackpotBonusEnb[i] = true;}
      if (JacksOrBetter96Allowed[i])       {JacksOrBetter96Enb[i] = true;}
      if (JacksOrBetter85Allowed[i])       {JacksOrBetter85Enb[i] = true;}
      if (JacksOrBetterDNothingAllowed[i]) {JacksOrBetterDNothingEnb[i] = true;}
      if (JokersWildProgAllowed[i])        {JokersWildProgEnb[i] = true;}
      if (JumpinJokersAllowed[i])          {JumpinJokersEnb[i] = true;}
      if (TripleProgAllowed[i])            {TripleProgEnb[i] = true;}
      if (RoyalsProgAllowed[i])            {RoyalsProgEnb[i] = true;}
      if (PowerHouseProgAllowed[i])        {PowerHouseProgEnb[i] = true;}
      if (RaiseDrawJokerPokerAllowed[i])   {RaiseDrawJokerPokerEnb[i] = true;}
      if (SpadeBonusAllowed[i])            {SpadeBonusEnb[i] = true;}
      if (SuperDJackpotAllowed[i])         {SuperDJackpotEnb[i] = true;}
      if (SevensWild1JokerAllowed[i])      {SevensWild1JokerEnb[i] = true;}
      if (TensOrBetterAllowed[i])          {TensOrBetterEnb[i] = true;}
      if (TreasureTroveAllowed[i])         {TreasureTroveEnb[i] = true;}
      if (TriplePlayAllowed[i])            {TriplePlayEnb[i] = true;}
      if (TripleBonusAllowed[i])           {TripleBonusEnb[i] = true;}
      if (WheelDealAllowed[i])             {WheelDealEnb[i] = true;}
      if (CrystalPalaceAllowed[i])         {CrystalPalaceEnb[i] = true;}
      if (SuperSevensAllowed[i])           {SuperSevensEnb[i] = true;}
    }
  }
}
//*******************************************************************
bool TACVPMenuEnable::GetModeFlags(int16 gt,int16 sgt,int16 did)
{
  if (!TMoney::CheckDenomID(did)) {return false;}

  if (gt != gtVideoPoker && gt != gtSlots) {return false;}

  if (gt == gtSlots)
  {
    switch (sgt)
    {
      case cslCrystalPalace: return bool(CrystalPalaceAllowed[did] && CrystalPalaceEnb[did]);
      case cslSuperSevens: return bool(SuperSevensAllowed[did] && SuperSevensEnb[did]);
      default:return false;
    }
  }

  //else if (gt == gtVideoPoker)
  switch (sgt)
  {
    case cvpFivesUp:        return bool(FivesUpAllowed[did] && FivesUpEnb[did]);
    case cvpBlackJacks:     return bool(BlackJacksAllowed[did] && BlackJacksEnb[did]);
    case cvpBonusDeluxe:    return bool(BonusDeluxeAllowed[did] && BonusDeluxeEnb[did]);
    case cvpClubBonus:      return bool(ClubBonusAllowed[did] && ClubBonusEnb[did]);
    case cvpCrazy8s:        return bool(Crazy8sAllowed[did] && Crazy8sEnb[did]);
    case cvpDDrawJB:        return bool(DDrawJacksOrBetterAllowed[did] && DDrawJacksOrBetterEnb[did]);
    case cvpDDrawJokerPoker:return bool(DDrawJokerPokerAllowed[did] && DDrawJokerPokerEnb[did]);
    case cvpDDownStud:      return bool(DDownStudAllowed[did] && DDownStudEnb[did]);
    case cvpDeucesWildBonus:return bool(DeucesWildBonusAllowed[did] && DeucesWildBonusEnb[did]);
    case cvpDeucesWildII:   return bool(DeucesWildAllowed[did] && DeucesWildEnb[did]);
    case cvpDeucesWildProg: return bool(DeucesWildProgAllowed[did] && DeucesWildProgEnb[did]);
    case cvpDiamondBonus:   return bool(DiamondBonusAllowed[did] && DiamondBonusEnb[did]);
    case cvpDBonusPoker:    return bool(DBonusPokerAllowed[did] && DBonusPokerEnb[did]);
    case cvpFlushAssault:   return bool(FlushAssaultAllowed[did] && FlushAssaultEnb[did]);
    case cvpFreeLook:       return bool(FreeLookAllowed[did] && FreeLookEnb[did]);
    case cvpGamblersEdge:   return bool(GamblersEdgeAllowed[did] && GamblersEdgeEnb[did]);
    case cvpHeartBonus:     return bool(HeartBonusAllowed[did] && HeartBonusEnb[did]);
    case cvpJacksProgII:    return bool(JacksOrBetterProgAllowed[did] && JacksOrBetterProgEnb[did]);
    case cvpJackpotBonus:   return bool(JackpotBonusAllowed[did] && JackpotBonusEnb[did]);
    case cvp96JacksOrBetterII:return bool(JacksOrBetter96Allowed[did] && JacksOrBetter96Enb[did]);
    case cvp85JacksOrBetter:return bool(JacksOrBetter85Allowed[did] && JacksOrBetter85Enb[did]);
    case cvpDJacksOrBetter: return bool(JacksOrBetterDNothingAllowed[did] && JacksOrBetterDNothingEnb[did]);
    case cvpJokersWildProg: return bool(JokersWildProgAllowed[did] && JokersWildProgEnb[did]);
    case cvpJumpinJokers:   return bool(JumpinJokersAllowed[did] && JumpinJokersEnb[did]);
    case cvpTripleProg:     return bool(TripleProgAllowed[did] && TripleProgEnb[did]);
    case cvpRoyalProg:      return bool(RoyalsProgAllowed[did] && RoyalsProgEnb[did]);
    case cvpPowerProg:      return bool(PowerHouseProgAllowed[did] && PowerHouseProgEnb[did]);
    case cvpRaiseJokersWild:return bool(RaiseDrawJokerPokerAllowed[did] && RaiseDrawJokerPokerEnb[did]);
    case cvpSpadeBonus:     return bool(SpadeBonusAllowed[did] && SpadeBonusEnb[did]);
    case cvpSuperDJackpot:  return bool(SuperDJackpotAllowed[did] && SuperDJackpotEnb[did]);
    case cvp7Wild1Joker:    return bool(SevensWild1JokerAllowed[did] && SevensWild1JokerEnb[did]);
    case cvpTensOrBetterII: return bool(TensOrBetterEnb[did] && TensOrBetterAllowed[did]);
    case cvpTreasureTrove:  return bool(TreasureTroveAllowed[did] && TreasureTroveEnb[did]);
    case cvpTriplePlay:     return bool(TriplePlayAllowed[did] && TriplePlayEnb[did]);
    case cvpTripleBonus:    return bool(TripleBonusAllowed[did] && TripleBonusEnb[did]);
    case cvpWheelDeal:      return bool(WheelDealAllowed[did] && WheelDealEnb[did]);
    default:                return false;
  }
}
//*******************************************************************
bool TACVPMenuEnable::GetModeEnb(int16 gt,int16 sgt,int16 did)
{
  if (!TMoney::CheckDenomID(did)) {return false;}
  
  if (gt != gtVideoPoker && gt != gtSlots) {return false;}

  if (gt == gtSlots)
  {
    switch (sgt)
    {
      case cslCrystalPalace:return CrystalPalaceEnb[did];
      case cslSuperSevens:return SuperSevensEnb[did];
      default:return false;
    }
  }
  // else if (gt == gtVideoPoker)
  switch (sgt)
  {
    case cvpFivesUp:        return FivesUpEnb[did];
    case cvpBlackJacks:     return BlackJacksEnb[did];
    case cvpBonusDeluxe:    return BonusDeluxeEnb[did];
    case cvpClubBonus:      return ClubBonusEnb[did];
    case cvpCrazy8s:        return Crazy8sEnb[did];
    case cvpDDrawJB:        return DDrawJacksOrBetterEnb[did];
    case cvpDDrawJokerPoker:return DDrawJokerPokerEnb[did];
    case cvpDDownStud:      return DDownStudEnb[did];
    case cvpDeucesWildBonus:return DeucesWildBonusEnb[did];
    case cvpDeucesWildII:   return DeucesWildEnb[did];
    case cvpDeucesWildProg: return DeucesWildProgEnb[did];
    case cvpDiamondBonus:   return DiamondBonusEnb[did];
    case cvpDBonusPoker:    return DBonusPokerEnb[did];
    case cvpFlushAssault:   return FlushAssaultEnb[did];
    case cvpFreeLook:       return FreeLookEnb[did];
    case cvpGamblersEdge:   return GamblersEdgeEnb[did];
    case cvpHeartBonus:     return HeartBonusEnb[did];
    case cvpJacksProgII:    return JacksOrBetterProgEnb[did];
    case cvpJackpotBonus:   return JackpotBonusEnb[did];
    case cvp96JacksOrBetterII:return JacksOrBetter96Enb[did];
    case cvp85JacksOrBetter:return JacksOrBetter85Enb[did];
    case cvpDJacksOrBetter: return JacksOrBetterDNothingEnb[did];
    case cvpJokersWildProg: return JokersWildProgEnb[did];
    case cvpJumpinJokers:   return JumpinJokersEnb[did];
    case cvpTripleProg:     return TripleProgEnb[did];
    case cvpRoyalProg:      return RoyalsProgEnb[did];
    case cvpPowerProg:      return PowerHouseProgEnb[did];
    case cvpRaiseJokersWild:return RaiseDrawJokerPokerEnb[did];
    case cvpSpadeBonus:     return SpadeBonusEnb[did];
    case cvpSuperDJackpot:  return SuperDJackpotEnb[did];
    case cvp7Wild1Joker:    return SevensWild1JokerEnb[did];
    case cvpTensOrBetterII: return TensOrBetterAllowed[did];
    case cvpTreasureTrove:  return TreasureTroveEnb[did];
    case cvpTriplePlay:     return TriplePlayEnb[did];
    case cvpTripleBonus:    return TripleBonusEnb[did];
    case cvpWheelDeal:      return WheelDealEnb[did];
    default:                return false;
  }
}
//*******************************************************************
void TACVPMenuEnable::SetModeEnb(int16 gt,int16 sgt,int16 did,bool flag)
{
  if (!TMoney::CheckDenomID(did)) {return;}

  if (gt != gtVideoPoker && gt != gtSlots) {return;}

  if (gt == gtSlots)
  {
    switch (sgt)
    {
      case cslCrystalPalace: CrystalPalaceEnb[did] = flag;break;
      case cslSuperSevens: SuperSevensEnb[did] = flag;break;
      default:break;
    }
    return;
  }
  // else if (gt == gtVideoPoker)
  switch (sgt)
  {
    case cvpFivesUp:        FivesUpEnb[did] = flag;break;
    case cvpBlackJacks:     BlackJacksEnb[did]= flag;break;
    case cvpBonusDeluxe:    BonusDeluxeEnb[did]= flag;break;
    case cvpClubBonus:      ClubBonusEnb[did]= flag;break;
    case cvpCrazy8s:        Crazy8sEnb[did]= flag;break;
    case cvpDDrawJB:        DDrawJacksOrBetterEnb[did]= flag;break;
    case cvpDDrawJokerPoker:DDrawJokerPokerEnb[did]= flag;break;
    case cvpDDownStud:      DDownStudEnb[did]= flag;break;
    case cvpDeucesWildBonus:DeucesWildBonusEnb[did]= flag;break;
    case cvpDeucesWildII:   DeucesWildEnb[did]= flag;break;
    case cvpDeucesWildProg: DeucesWildProgEnb[did]= flag;break;
    case cvpDiamondBonus:   DiamondBonusEnb[did]= flag;break;
    case cvpDBonusPoker:    DBonusPokerEnb[did]= flag;break;
    case cvpFlushAssault:   FlushAssaultEnb[did]= flag;break;
    case cvpFreeLook:       FreeLookEnb[did]= flag;break;
    case cvpGamblersEdge:   GamblersEdgeEnb[did]= flag;break;
    case cvpHeartBonus:     HeartBonusEnb[did]= flag;break;
    case cvpJacksProgII:    JacksOrBetterProgEnb[did]= flag;break;
    case cvpJackpotBonus:   JackpotBonusEnb[did]= flag;break;
    case cvp96JacksOrBetterII:JacksOrBetter96Enb[did]= flag;break;
    case cvp85JacksOrBetter:JacksOrBetter85Enb[did]= flag;break;
    case cvpDJacksOrBetter: JacksOrBetterDNothingEnb[did]= flag;break;
    case cvpJokersWildProg: JokersWildProgEnb[did]= flag;break;
    case cvpJumpinJokers:   JumpinJokersEnb[did]= flag;break;
    case cvpTripleProg:     TripleProgEnb[did]= flag;break;
    case cvpRoyalProg:      RoyalsProgEnb[did]= flag;break;
    case cvpPowerProg:      PowerHouseProgEnb[did]= flag;break;
    case cvpRaiseJokersWild:RaiseDrawJokerPokerEnb[did]= flag;break;
    case cvpSpadeBonus:     SpadeBonusEnb[did]= flag;break;
    case cvpSuperDJackpot:  SuperDJackpotEnb[did]= flag;break;
    case cvp7Wild1Joker:    SevensWild1JokerEnb[did]= flag;break;
    case cvpTensOrBetterII: TensOrBetterEnb[did]= flag;break;
    case cvpTreasureTrove:  TreasureTroveEnb[did]= flag;break;
    case cvpTriplePlay:     TriplePlayEnb[did]= flag;break;
    case cvpTripleBonus:    TripleBonusEnb[did]= flag;break;
    case cvpWheelDeal:      WheelDealEnb[did]= flag;break;
    default:                break;
  }
}
//*******************************************************************
//*******************************************************************
DEFINE_RESPONSE_TABLE1(TACVPGameFW,TCasinoGameFrameWindow)
  // lobby
  EV_COMMAND(CM_GAME_ACVP_LOBBY,CmGameLobby),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_LOBBY,CeGameLobby),

  EV_COMMAND(CM_OPTIONSLOBBY_SHOWINTRO ,CmShowIntro),
  EV_COMMAND_ENABLE(CM_OPTIONSLOBBY_SHOWINTRO ,CeShowIntro),
  // modes

  // slot modes
  EV_COMMAND(CM_GAME_ACVP_CRYSTALPALACE_DEF,CmCrystalPalace_Def),
  EV_COMMAND(CM_GAME_ACVP_CRYSTALPALACE_25C,CmCrystalPalace_25c),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_CRYSTALPALACE_25C,CeCrystalPalace_25c),
  EV_COMMAND(CM_GAME_ACVP_CRYSTALPALACE_1,CmCrystalPalace_1),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_CRYSTALPALACE_1,CeCrystalPalace_1),
  EV_COMMAND(CM_GAME_ACVP_CRYSTALPALACE_10,CmCrystalPalace_10),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_CRYSTALPALACE_10,CeCrystalPalace_10),
  EV_COMMAND(CM_GAME_ACVP_CRYSTALPALACE_100,CmCrystalPalace_100),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_CRYSTALPALACE_100,CeCrystalPalace_100),
  EV_COMMAND(CM_GAME_ACVP_CRYSTALPALACE_1000,CmCrystalPalace_1000),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_CRYSTALPALACE_1000,CeCrystalPalace_1000),

  EV_COMMAND(CM_GAME_ACVP_SUPERSEVENS_DEF,CmSuperSevens_Def),
  EV_COMMAND(CM_GAME_ACVP_SUPERSEVENS_5C,CmSuperSevens_5c),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_SUPERSEVENS_5C,CeSuperSevens_5c),
  EV_COMMAND(CM_GAME_ACVP_SUPERSEVENS_25C,CmSuperSevens_25c),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_SUPERSEVENS_25C,CeSuperSevens_25c),
  EV_COMMAND(CM_GAME_ACVP_SUPERSEVENS_1,CmSuperSevens_1),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_SUPERSEVENS_1,CeSuperSevens_1),
  EV_COMMAND(CM_GAME_ACVP_SUPERSEVENS_25,CmSuperSevens_25),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_SUPERSEVENS_25,CeSuperSevens_25),
  EV_COMMAND(CM_GAME_ACVP_SUPERSEVENS_500,CmSuperSevens_500),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_SUPERSEVENS_500,CeSuperSevens_500),

  EV_COMMAND(CM_GAME_ACVP_FIVESUP_DEF,CmFivesUp_Def),
  EV_COMMAND(CM_GAME_ACVP_FIVESUP_25C,CmFivesUp_25c),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_FIVESUP_25C,CeFivesUp_25c),
  EV_COMMAND(CM_GAME_ACVP_FIVESUP_1,CmFivesUp_1),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_FIVESUP_1,CeFivesUp_1),
  EV_COMMAND(CM_GAME_ACVP_FIVESUP_50,CmFivesUp_50),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_FIVESUP_50,CeFivesUp_50),
  EV_COMMAND(CM_GAME_ACVP_FIVESUP_100,CmFivesUp_100),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_FIVESUP_100,CeFivesUp_100),

  EV_COMMAND(CM_GAME_ACVP_BLACKJACKS_DEF,CmBlackJacks_Def),
  EV_COMMAND(CM_GAME_ACVP_BLACKJACKS_10,CmBlackJacks_10),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_BLACKJACKS_10,CeBlackJacks_10),
  EV_COMMAND(CM_GAME_ACVP_BLACKJACKS_50,CmBlackJacks_50),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_BLACKJACKS_50,CeBlackJacks_50),
  EV_COMMAND(CM_GAME_ACVP_BLACKJACKS_100,CmBlackJacks_100),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_BLACKJACKS_100,CeBlackJacks_100),
  EV_COMMAND(CM_GAME_ACVP_BLACKJACKS_1000,CmBlackJacks_1000),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_BLACKJACKS_1000,CeBlackJacks_1000),

  EV_COMMAND(CM_GAME_ACVP_BONUSDELUXE_DEF,CmBonusDeluxe_Def),
  EV_COMMAND(CM_GAME_ACVP_BONUSDELUXE_25C,CmBonusDeluxe_25c),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_BONUSDELUXE_25C,CeBonusDeluxe_25c),
  EV_COMMAND(CM_GAME_ACVP_BONUSDELUXE_1,CmBonusDeluxe_1),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_BONUSDELUXE_1,CeBonusDeluxe_1),
  EV_COMMAND(CM_GAME_ACVP_BONUSDELUXE_5,CmBonusDeluxe_5),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_BONUSDELUXE_5,CeBonusDeluxe_5),
  EV_COMMAND(CM_GAME_ACVP_BONUSDELUXE_10,CmBonusDeluxe_10),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_BONUSDELUXE_10,CeBonusDeluxe_10),
  EV_COMMAND(CM_GAME_ACVP_BONUSDELUXE_25,CmBonusDeluxe_25),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_BONUSDELUXE_25,CeBonusDeluxe_25),

  EV_COMMAND(CM_GAME_ACVP_CLUBBONUS_DEF,CmClubBonus_Def),
  EV_COMMAND(CM_GAME_ACVP_CLUBBONUS_5,CmClubBonus_5),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_CLUBBONUS_5,CeClubBonus_5),
  EV_COMMAND(CM_GAME_ACVP_CLUBBONUS_100,CmClubBonus_100),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_CLUBBONUS_100,CeClubBonus_100),
  EV_COMMAND(CM_GAME_ACVP_CLUBBONUS_500,CmClubBonus_500),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_CLUBBONUS_500,CeClubBonus_500),

  EV_COMMAND(CM_GAME_ACVP_CRAZY8S_DEF,CmCrazy8s_Def),
  EV_COMMAND(CM_GAME_ACVP_CRAZY8S_1,CmCrazy8s_1),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_CRAZY8S_1,CeCrazy8s_1),
  EV_COMMAND(CM_GAME_ACVP_CRAZY8S_5,CmCrazy8s_5),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_CRAZY8S_5,CeCrazy8s_5),
  EV_COMMAND(CM_GAME_ACVP_CRAZY8S_10,CmCrazy8s_10),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_CRAZY8S_10,CeCrazy8s_10),
  EV_COMMAND(CM_GAME_ACVP_CRAZY8S_1000,CmCrazy8s_1000),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_CRAZY8S_1000,CeCrazy8s_1000),

  EV_COMMAND(CM_GAME_ACVP_DDRAWJACKSORBETTER_DEF,CmDDrawJacksOrBetter_Def),
  EV_COMMAND(CM_GAME_ACVP_DDRAWJACKSORBETTER_25C,CmDDrawJacksOrBetter_25c),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_DDRAWJACKSORBETTER_25C,CeDDrawJacksOrBetter_25c),
  EV_COMMAND(CM_GAME_ACVP_DDRAWJACKSORBETTER_1,CmDDrawJacksOrBetter_1),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_DDRAWJACKSORBETTER_1,CeDDrawJacksOrBetter_1),
  EV_COMMAND(CM_GAME_ACVP_DDRAWJACKSORBETTER_10,CmDDrawJacksOrBetter_10),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_DDRAWJACKSORBETTER_10,CeDDrawJacksOrBetter_10),
  EV_COMMAND(CM_GAME_ACVP_DDRAWJACKSORBETTER_50,CmDDrawJacksOrBetter_50),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_DDRAWJACKSORBETTER_50,CeDDrawJacksOrBetter_50),
  EV_COMMAND(CM_GAME_ACVP_DDRAWJACKSORBETTER_1000,CmDDrawJacksOrBetter_1000),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_DDRAWJACKSORBETTER_1000,CeDDrawJacksOrBetter_1000),

  EV_COMMAND(CM_GAME_ACVP_DDRAWJOKERPOKER_DEF,CmDDrawJokerPoker_Def),
  EV_COMMAND(CM_GAME_ACVP_DDRAWJOKERPOKER_1,CmDDrawJokerPoker_1),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_DDRAWJOKERPOKER_1,CeDDrawJokerPoker_1),
  EV_COMMAND(CM_GAME_ACVP_DDRAWJOKERPOKER_5,CmDDrawJokerPoker_5),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_DDRAWJOKERPOKER_5,CeDDrawJokerPoker_5),
  EV_COMMAND(CM_GAME_ACVP_DDRAWJOKERPOKER_10,CmDDrawJokerPoker_10),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_DDRAWJOKERPOKER_10,CeDDrawJokerPoker_10),
  EV_COMMAND(CM_GAME_ACVP_DDRAWJOKERPOKER_25,CmDDrawJokerPoker_25),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_DDRAWJOKERPOKER_25,CeDDrawJokerPoker_25),
  EV_COMMAND(CM_GAME_ACVP_DDRAWJOKERPOKER_500,CmDDrawJokerPoker_500),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_DDRAWJOKERPOKER_500,CeDDrawJokerPoker_500),

  EV_COMMAND(CM_GAME_ACVP_DDOWNSTUD_DEF,CmDDownStud_Def),
  EV_COMMAND(CM_GAME_ACVP_DDOWNSTUD_25C,CmDDownStud_25c),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_DDOWNSTUD_25C,CeDDownStud_25c),
  EV_COMMAND(CM_GAME_ACVP_DDOWNSTUD_1,CmDDownStud_1),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_DDOWNSTUD_1,CeDDownStud_1),
  EV_COMMAND(CM_GAME_ACVP_DDOWNSTUD_5,CmDDownStud_5),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_DDOWNSTUD_5,CeDDownStud_5),
  EV_COMMAND(CM_GAME_ACVP_DDOWNSTUD_50,CmDDownStud_50),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_DDOWNSTUD_50,CeDDownStud_50),
  EV_COMMAND(CM_GAME_ACVP_DDOWNSTUD_100,CmDDownStud_100),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_DDOWNSTUD_100,CeDDownStud_100),

  EV_COMMAND(CM_GAME_ACVP_DEUCESWILDBONUS_DEF,CmDeucesWildBonus_Def),
  EV_COMMAND(CM_GAME_ACVP_DEUCESWILDBONUS_25C,CmDeucesWildBonus_25c),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_DEUCESWILDBONUS_25C,CeDeucesWildBonus_25c),
  EV_COMMAND(CM_GAME_ACVP_DEUCESWILDBONUS_1,CmDeucesWildBonus_1),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_DEUCESWILDBONUS_1,CeDeucesWildBonus_1),
  EV_COMMAND(CM_GAME_ACVP_DEUCESWILDBONUS_25,CmDeucesWildBonus_25),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_DEUCESWILDBONUS_25,CeDeucesWildBonus_25),
  EV_COMMAND(CM_GAME_ACVP_DEUCESWILDBONUS_1000,CmDeucesWildBonus_1000),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_DEUCESWILDBONUS_1000,CeDeucesWildBonus_1000),

  EV_COMMAND(CM_GAME_ACVP_DEUCESWILD_DEF,CmDeucesWild_Def),
  EV_COMMAND(CM_GAME_ACVP_DEUCESWILD_5C,CmDeucesWild_5c),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_DEUCESWILD_5C,CeDeucesWild_5c),
  EV_COMMAND(CM_GAME_ACVP_DEUCESWILD_10C,CmDeucesWild_10c),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_DEUCESWILD_10C,CeDeucesWild_10c),
  EV_COMMAND(CM_GAME_ACVP_DEUCESWILD_25C,CmDeucesWild_25c),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_DEUCESWILD_25C,CeDeucesWild_25c),
  EV_COMMAND(CM_GAME_ACVP_DEUCESWILD_1,CmDeucesWild_1),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_DEUCESWILD_1,CeDeucesWild_1),
  EV_COMMAND(CM_GAME_ACVP_DEUCESWILD_5,CmDeucesWild_5),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_DEUCESWILD_5,CeDeucesWild_5),
  EV_COMMAND(CM_GAME_ACVP_DEUCESWILD_25,CmDeucesWild_25),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_DEUCESWILD_25,CeDeucesWild_25),
  EV_COMMAND(CM_GAME_ACVP_DEUCESWILD_100,CmDeucesWild_100),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_DEUCESWILD_100,CeDeucesWild_100),

  EV_COMMAND(CM_GAME_ACVP_DEUCESWILDPROG_DEF,CmDeucesWildProg_Def),
  EV_COMMAND(CM_GAME_ACVP_DEUCESWILDPROG_5C,CmDeucesWildProg_5c),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_DEUCESWILDPROG_5C,CeDeucesWildProg_5c),
  EV_COMMAND(CM_GAME_ACVP_DEUCESWILDPROG_1,CmDeucesWildProg_1),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_DEUCESWILDPROG_1,CeDeucesWildProg_1),
  EV_COMMAND(CM_GAME_ACVP_DEUCESWILDPROG_5,CmDeucesWildProg_5),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_DEUCESWILDPROG_5,CeDeucesWildProg_5),

  EV_COMMAND(CM_GAME_ACVP_DIAMONDBONUS_DEF,CmDiamondBonus_Def),
  EV_COMMAND(CM_GAME_ACVP_DIAMONDBONUS_10C,CmDiamondBonus_10c),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_DIAMONDBONUS_10C,CeDiamondBonus_10c),
  EV_COMMAND(CM_GAME_ACVP_DIAMONDBONUS_25C,CmDiamondBonus_25c),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_DIAMONDBONUS_25C,CeDiamondBonus_25c),
  EV_COMMAND(CM_GAME_ACVP_DIAMONDBONUS_10,CmDiamondBonus_10),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_DIAMONDBONUS_10,CeDiamondBonus_10),
  EV_COMMAND(CM_GAME_ACVP_DIAMONDBONUS_25,CmDiamondBonus_25),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_DIAMONDBONUS_25,CeDiamondBonus_25),
  EV_COMMAND(CM_GAME_ACVP_DIAMONDBONUS_50,CmDiamondBonus_50),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_DIAMONDBONUS_50,CeDiamondBonus_50),

  EV_COMMAND(CM_GAME_ACVP_DBONUSPOKER_DEF,CmDBonusPoker_Def),
  EV_COMMAND(CM_GAME_ACVP_DBONUSPOKER_5C,CmDBonusPoker_5c),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_DBONUSPOKER_5C,CeDBonusPoker_5c),
  EV_COMMAND(CM_GAME_ACVP_DBONUSPOKER_10C,CmDBonusPoker_10c),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_DBONUSPOKER_10C,CeDBonusPoker_10c),
  EV_COMMAND(CM_GAME_ACVP_DBONUSPOKER_25C,CmDBonusPoker_25c),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_DBONUSPOKER_25C,CeDBonusPoker_25c),
  EV_COMMAND(CM_GAME_ACVP_DBONUSPOKER_1,CmDBonusPoker_1),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_DBONUSPOKER_1,CeDBonusPoker_1),
  EV_COMMAND(CM_GAME_ACVP_DBONUSPOKER_100,CmDBonusPoker_100),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_DBONUSPOKER_100,CeDBonusPoker_100),

  EV_COMMAND(CM_GAME_ACVP_FLUSHASSAULT_DEF,CmFlushAssault_Def),
  EV_COMMAND(CM_GAME_ACVP_FLUSHASSAULT_1,CmFlushAssault_1),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_FLUSHASSAULT_1,CeFlushAssault_1),
  EV_COMMAND(CM_GAME_ACVP_FLUSHASSAULT_25,CmFlushAssault_25),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_FLUSHASSAULT_25,CeFlushAssault_25),
  EV_COMMAND(CM_GAME_ACVP_FLUSHASSAULT_100,CmFlushAssault_100),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_FLUSHASSAULT_100,CeFlushAssault_100),
  EV_COMMAND(CM_GAME_ACVP_FLUSHASSAULT_500,CmFlushAssault_500),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_FLUSHASSAULT_500,CeFlushAssault_500),
  EV_COMMAND(CM_GAME_ACVP_FLUSHASSAULT_1000,CmFlushAssault_1000),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_FLUSHASSAULT_1000,CeFlushAssault_1000),

  EV_COMMAND(CM_GAME_ACVP_FREELOOK_DEF,CmFreeLook_Def),
  EV_COMMAND(CM_GAME_ACVP_FREELOOK_25C,CmFreeLook_25c),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_FREELOOK_25C,CeFreeLook_25c),
  EV_COMMAND(CM_GAME_ACVP_FREELOOK_1,CmFreeLook_1),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_FREELOOK_1,CeFreeLook_1),
  EV_COMMAND(CM_GAME_ACVP_FREELOOK_1000,CmFreeLook_1000),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_FREELOOK_1000,CeFreeLook_1000),

  EV_COMMAND(CM_GAME_ACVP_GAMBLERSEDGE_DEF,CmGamblersEdge_Def),
  EV_COMMAND(CM_GAME_ACVP_GAMBLERSEDGE_100,CmGamblersEdge_100),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_GAMBLERSEDGE_100,CeGamblersEdge_100),
  EV_COMMAND(CM_GAME_ACVP_GAMBLERSEDGE_500,CmGamblersEdge_500),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_GAMBLERSEDGE_500,CeGamblersEdge_500),
  EV_COMMAND(CM_GAME_ACVP_GAMBLERSEDGE_1000,CmGamblersEdge_1000),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_GAMBLERSEDGE_1000,CeGamblersEdge_1000),

  EV_COMMAND(CM_GAME_ACVP_HEARTBONUS_DEF,CmHeartBonus_Def),
  EV_COMMAND(CM_GAME_ACVP_HEARTBONUS_5C,CmHeartBonus_5c),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_HEARTBONUS_5C,CeHeartBonus_5c),
  EV_COMMAND(CM_GAME_ACVP_HEARTBONUS_10C,CmHeartBonus_10c),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_HEARTBONUS_10C,CeHeartBonus_10c),
  EV_COMMAND(CM_GAME_ACVP_HEARTBONUS_25C,CmHeartBonus_25c),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_HEARTBONUS_25C,CeHeartBonus_25c),
  EV_COMMAND(CM_GAME_ACVP_HEARTBONUS_1,CmHeartBonus_1),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_HEARTBONUS_1,CeHeartBonus_1),

  EV_COMMAND(CM_GAME_ACVP_JACKSORBETTERPROG_DEF,CmJacksOrBetterProg_Def),
  EV_COMMAND(CM_GAME_ACVP_JACKSORBETTERPROG_10C,CmJacksOrBetterProg_10c),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_JACKSORBETTERPROG_10C,CeJacksOrBetterProg_10c),
  EV_COMMAND(CM_GAME_ACVP_JACKSORBETTERPROG_25C,CmJackOrBetterProg_25c),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_JACKSORBETTERPROG_25C,CeJackOrBetterProg_25c),
  EV_COMMAND(CM_GAME_ACVP_JACKSORBETTERPROG_1,CmJacksOrBetterProg_1),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_JACKSORBETTERPROG_1,CeJacksOrBetterProg_1),
  EV_COMMAND(CM_GAME_ACVP_JACKSORBETTERPROG_5,CmJacksOrBetterProg_5),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_JACKSORBETTERPROG_5,CeJacksOrBetterProg_5),
  EV_COMMAND(CM_GAME_ACVP_JACKSORBETTERPROG_50,CmJacksOrBetterProg_50),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_JACKSORBETTERPROG_50,CeJacksOrBetterProg_50),

  EV_COMMAND(CM_GAME_ACVP_JACKPOTBONUS_DEF,CmJackpotBonus_Def),
  EV_COMMAND(CM_GAME_ACVP_JACKPOTBONUS_1,CmJackpotBonus_1),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_JACKPOTBONUS_1,CeJackpotBonus_1),

  EV_COMMAND(CM_GAME_ACVP_JACKSORBETTER96_DEF,CmJacksOrBetter96_Def),
  EV_COMMAND(CM_GAME_ACVP_JACKSORBETTER96_25C,CmJacksOrBetter96_25c),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_JACKSORBETTER96_25C,CeJacksOrBetter96_25c),
  EV_COMMAND(CM_GAME_ACVP_JACKSORBETTER96_1,CmJacksOrBetter96_1),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_JACKSORBETTER96_1,CeJacksOrBetter96_1),
  EV_COMMAND(CM_GAME_ACVP_JACKSORBETTER96_5,CmJacksOrBetter96_5),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_JACKSORBETTER96_5,CeJacksOrBetter96_5),
  EV_COMMAND(CM_GAME_ACVP_JACKSORBETTER96_50,CmJacksOrBetter96_50),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_JACKSORBETTER96_50,CeJacksOrBetter96_50),
  EV_COMMAND(CM_GAME_ACVP_JACKSORBETTER96_100,CmJacksOrBetter96_100),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_JACKSORBETTER96_100,CeJacksOrBetter96_100),
  EV_COMMAND(CM_GAME_ACVP_JACKSORBETTER96_500,CmJacksOrBetter96_500),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_JACKSORBETTER96_500,CeJacksOrBetter96_500),
  EV_COMMAND(CM_GAME_ACVP_JACKSORBETTER96_1000,CmJacksOrBetter96_1000),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_JACKSORBETTER96_1000,CeJacksOrBetter96_1000),

  EV_COMMAND(CM_GAME_ACVP_JACKSORBETTER85_DEF,CmJacksOrBetter85_Def),
  EV_COMMAND(CM_GAME_ACVP_JACKSORBETTER85_5C,CmJacksOrBetter85_5c),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_JACKSORBETTER85_5C,CeJacksOrBetter85_5c),
  EV_COMMAND(CM_GAME_ACVP_JACKSORBETTER85_10C,CmJacksOrBetter85_10c),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_JACKSORBETTER85_10C,CeJacksOrBetter85_10c),
  EV_COMMAND(CM_GAME_ACVP_JACKSORBETTER85_25C,CmJacksOrBetter85_25c),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_JACKSORBETTER85_25C,CeJacksOrBetter85_25c),
  EV_COMMAND(CM_GAME_ACVP_JACKSORBETTER85_1,CmJacksOrBetter85_1),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_JACKSORBETTER85_1,CeJacksOrBetter85_1),
  EV_COMMAND(CM_GAME_ACVP_JACKSORBETTER85_5,CmJacksOrBetter85_5),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_JACKSORBETTER85_5,CeJacksOrBetter85_5),
  EV_COMMAND(CM_GAME_ACVP_JACKSORBETTER85_10,CmJacksOrBetter85_10),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_JACKSORBETTER85_10,CeJacksOrBetter85_10),
  EV_COMMAND(CM_GAME_ACVP_JACKSORBETTER85_25,CmJacksOrBetter85_25),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_JACKSORBETTER85_25,CeJacksOrBetter85_25),
  EV_COMMAND(CM_GAME_ACVP_JACKSORBETTER85_50,CmJacksOrBetter85_50),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_JACKSORBETTER85_50,CeJacksOrBetter85_50),
  EV_COMMAND(CM_GAME_ACVP_JACKSORBETTER85_100,CmJacksOrBetter85_100),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_JACKSORBETTER85_100,CeJacksOrBetter85_100),
  EV_COMMAND(CM_GAME_ACVP_JACKSORBETTER85_500,CmJacksOrBetter85_500),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_JACKSORBETTER85_500,CeJacksOrBetter85_500),
  EV_COMMAND(CM_GAME_ACVP_JACKSORBETTER85_1000,CmJacksOrBetter85_1000),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_JACKSORBETTER85_1000,CeJacksOrBetter85_1000),

  EV_COMMAND(CM_GAME_ACVP_JACKSORBETTERDNOTHING_DEF,CmJacksOrBetterDNothing_Def),
  EV_COMMAND(CM_GAME_ACVP_JACKSORBETTERDNOTHING_25C,CmJacksOrBetterDNothing_25c),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_JACKSORBETTERDNOTHING_25C,CeJacksOrBetterDNothing_25c),
  EV_COMMAND(CM_GAME_ACVP_JACKSORBETTERDNOTHING_1,CmJacksOrBetterDNothing_1),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_JACKSORBETTERDNOTHING_1,CeJacksOrBetterDNothing_1),
  EV_COMMAND(CM_GAME_ACVP_JACKSORBETTERDNOTHING_5,CmJacksOrBetterDNothing_5),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_JACKSORBETTERDNOTHING_5,CeJacksOrBetterDNothing_5),
  EV_COMMAND(CM_GAME_ACVP_JACKSORBETTERDNOTHING_25,CmJacksOrBetterDNothing_25),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_JACKSORBETTERDNOTHING_25,CeJacksOrBetterDNothing_25),
  EV_COMMAND(CM_GAME_ACVP_JACKSORBETTERDNOTHING_100,CmJacksOrBetterDNothing_100),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_JACKSORBETTERDNOTHING_100,CeJacksOrBetterDNothing_100),

  EV_COMMAND(CM_GAME_ACVP_JOKERSWILDPROG_DEF,CmJokersWildProg_Def),
  EV_COMMAND(CM_GAME_ACVP_JOKERSWILDPROG_5C,CmJokersWildProg_5c),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_JOKERSWILDPROG_5C,CeJokersWildProg_5c),
  EV_COMMAND(CM_GAME_ACVP_JOKERSWILDPROG_25C,CmJokersWildProg_25c),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_JOKERSWILDPROG_25C,CeJokersWildProg_25c),
  EV_COMMAND(CM_GAME_ACVP_JOKERSWILDPROG_1,CmJokersWildProg_1),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_JOKERSWILDPROG_1,CeJokersWildProg_1),
  EV_COMMAND(CM_GAME_ACVP_JOKERSWILDPROG_100,CmJokersWildProg_100),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_JOKERSWILDPROG_100,CeJokersWildProg_100),

  EV_COMMAND(CM_GAME_ACVP_JUMPINJOKERS_DEF,CmJumpinJokers_Def),
  EV_COMMAND(CM_GAME_ACVP_JUMPINJOKERS_5,CmJumpinJokers_5),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_JUMPINJOKERS_5,CeJumpinJokers_5),
  EV_COMMAND(CM_GAME_ACVP_JUMPINJOKERS_50,CmJumpinJokers_50),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_JUMPINJOKERS_50,CeJumpinJokers_50),

  EV_COMMAND(CM_GAME_ACVP_TRIPLEPROG_DEF,CmTripleProg_Def),
  EV_COMMAND(CM_GAME_ACVP_TRIPLEPROG_5C,CmTripleProg_5c),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_TRIPLEPROG_5C,CeTripleProg_5c),
  EV_COMMAND(CM_GAME_ACVP_TRIPLEPROG_25C,CmTripleProg_25c),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_TRIPLEPROG_25C,CeTripleProg_25c),
  EV_COMMAND(CM_GAME_ACVP_TRIPLEPROG_1,CmTripleProg_1),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_TRIPLEPROG_1,CeTripleProg_1),
  EV_COMMAND(CM_GAME_ACVP_TRIPLEPROG_10,CmTripleProg_10),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_TRIPLEPROG_10,CeTripleProg_10),

  EV_COMMAND(CM_GAME_ACVP_ROYALSPROG_DEF,CmRoyalsProg_Def),
  EV_COMMAND(CM_GAME_ACVP_ROYALSPROG_10C,CmRoyalsProg_10c),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_ROYALSPROG_10C,CeRoyalsProg_10c),
  EV_COMMAND(CM_GAME_ACVP_ROYALSPROG_1,CmRoyalsProg_1),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_ROYALSPROG_1,CeRoyalsProg_1),
  EV_COMMAND(CM_GAME_ACVP_ROYALSPROG_25,CmRoyalsProg_25),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_ROYALSPROG_25,CeRoyalsProg_25),

  EV_COMMAND(CM_GAME_ACVP_POWERHOUSEPROG_DEF,CmPowerHouseProg_Def),
  EV_COMMAND(CM_GAME_ACVP_POWERHOUSEPROG_25C,CmPowerHouseProg_25c),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_POWERHOUSEPROG_25C,CePowerHouseProg_25c),
  EV_COMMAND(CM_GAME_ACVP_POWERHOUSEPROG_1,CmPowerHouseProg_1),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_POWERHOUSEPROG_1,CePowerHouseProg_1),
  EV_COMMAND(CM_GAME_ACVP_POWERHOUSEPROG_50,CmPowerHouseProg_50),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_POWERHOUSEPROG_50,CePowerHouseProg_50),

  EV_COMMAND(CM_GAME_ACVP_RAISEDRAWJOKERPOKER_DEF,CmRaiseDrawJokerPoker_Def),
  EV_COMMAND(CM_GAME_ACVP_RAISEDRAWJOKERPOKER_25C,CmRaiseDrawJokerPoker_25c),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_RAISEDRAWJOKERPOKER_25C,CeRaiseDrawJokerPoker_25c),
  EV_COMMAND(CM_GAME_ACVP_RAISEDRAWJOKERPOKER_1,CmRaiseDrawJokerPoker_1),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_RAISEDRAWJOKERPOKER_1,CeRaiseDrawJokerPoker_1),
  EV_COMMAND(CM_GAME_ACVP_RAISEDRAWJOKERPOKER_10,CmRaiseDrawJokerPoker_10),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_RAISEDRAWJOKERPOKER_10,CeRaiseDrawJokerPoker_10),
  EV_COMMAND(CM_GAME_ACVP_RAISEDRAWJOKERPOKER_100,CmRaiseDrawJokerPoker_100),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_RAISEDRAWJOKERPOKER_100,CeRaiseDrawJokerPoker_100),
  EV_COMMAND(CM_GAME_ACVP_RAISEDRAWJOKERPOKER_500,CmRaiseDrawJokerPoker_500),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_RAISEDRAWJOKERPOKER_500,CeRaiseDrawJokerPoker_500),

  EV_COMMAND(CM_GAME_ACVP_SPADEBONUS_DEF,CmSpadeBonus_Def),
  EV_COMMAND(CM_GAME_ACVP_SPADEBONUS_5C,CmSpadeBonus_5c),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_SPADEBONUS_5C,CeSpadeBonus_5c),
  EV_COMMAND(CM_GAME_ACVP_SPADEBONUS_25C,CmSpadeBonus_25c),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_SPADEBONUS_25C,CeSpadeBonus_25c),
  EV_COMMAND(CM_GAME_ACVP_SPADEBONUS_5,CmSpadeBonus_5),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_SPADEBONUS_5,CeSpadeBonus_5),

  EV_COMMAND(CM_GAME_ACVP_SUPERDJACKPOT_DEF,CmSuperDJackpot_Def),
  EV_COMMAND(CM_GAME_ACVP_SUPERDJACKPOT_25C,CmSuperDJackpot_25c),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_SUPERDJACKPOT_25C,CeSuperDJackpot_25c),
  EV_COMMAND(CM_GAME_ACVP_SUPERDJACKPOT_1,CmSuperDJackpot_1),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_SUPERDJACKPOT_1,CeSuperDJackpot_1),
  EV_COMMAND(CM_GAME_ACVP_SUPERDJACKPOT_100,CmSuperDJackpot_100),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_SUPERDJACKPOT_100,CeSuperDJackpot_100),

  EV_COMMAND(CM_GAME_ACVP_SEVENSWILD1JOKER_DEF,CmSevensWild1Joker_Def),
  EV_COMMAND(CM_GAME_ACVP_SEVENSWILD1JOKER_5,CmSevensWild1Joker_5),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_SEVENSWILD1JOKER_5,CeSevensWild1Joker_5),
  EV_COMMAND(CM_GAME_ACVP_SEVENSWILD1JOKER_25,CmSevensWild1Joker_25),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_SEVENSWILD1JOKER_25,CeSevensWild1Joker_25),
  EV_COMMAND(CM_GAME_ACVP_SEVENSWILD1JOKER_1000,CmSevensWild1Joker_1000),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_SEVENSWILD1JOKER_1000,CeSevensWild1Joker_1000),

  EV_COMMAND(CM_GAME_ACVP_TENSORBETTER_DEF,CmTensOrBetter_Def),
  EV_COMMAND(CM_GAME_ACVP_TENSORBETTER_5C,CmTensOrBetter_5c),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_TENSORBETTER_5C,CeTensOrBetter_5c),
  EV_COMMAND(CM_GAME_ACVP_TENSORBETTER_10C,CmTensOrBetter_10c),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_TENSORBETTER_10C,CeTensOrBetter_10c),
  EV_COMMAND(CM_GAME_ACVP_TENSORBETTER_25C,CmTensOrBetter_25c),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_TENSORBETTER_25C,CeTensOrBetter_25c),
  EV_COMMAND(CM_GAME_ACVP_TENSORBETTER_1,CmTensOrBetter_1),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_TENSORBETTER_1,CeTensOrBetter_1),
  EV_COMMAND(CM_GAME_ACVP_TENSORBETTER_50,CmTensOrBetter_50),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_TENSORBETTER_50,CeTensOrBetter_50),

  EV_COMMAND(CM_GAME_ACVP_TREASURETROVE_DEF,CmTreasureTrove_Def),
  EV_COMMAND(CM_GAME_ACVP_TREASURETROVE_1,CmTreasureTrove_1),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_TREASURETROVE_1,CeTreasureTrove_1),
  EV_COMMAND(CM_GAME_ACVP_TREASURETROVE_100,CmTreasureTrove_100),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_TREASURETROVE_100,CeTreasureTrove_100),
  EV_COMMAND(CM_GAME_ACVP_TREASURETROVE_1000,CmTreasureTrove_1000),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_TREASURETROVE_1000,CeTreasureTrove_1000),

  EV_COMMAND(CM_GAME_ACVP_TRIPLEPLAY_DEF,CmTriplePlay_Def),
  EV_COMMAND(CM_GAME_ACVP_TRIPLEPLAY_25C,CmTriplePlay_25c),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_TRIPLEPLAY_25C,CeTriplePlay_25c),
  EV_COMMAND(CM_GAME_ACVP_TRIPLEPLAY_1,CmTriplePlay_1),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_TRIPLEPLAY_1,CeTriplePlay_1),
  EV_COMMAND(CM_GAME_ACVP_TRIPLEPLAY_25, CmTriplePlay_25),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_TRIPLEPLAY_25,CeTriplePlay_25),
  EV_COMMAND(CM_GAME_ACVP_TRIPLEPLAY_500,CmTriplePlay_500),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_TRIPLEPLAY_500,CeTriplePlay_500),

  EV_COMMAND(CM_GAME_ACVP_TRIPLEBONUS_DEF,CmTripleBonus_Def),
  EV_COMMAND(CM_GAME_ACVP_TRIPLEBONUS_25C,CmTripleBonus_25c),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_TRIPLEBONUS_25C,CeTripleBonus_25c),
  EV_COMMAND(CM_GAME_ACVP_TRIPLEBONUS_50,CmTripleBonus_50),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_TRIPLEBONUS_50,CeTripleBonus_50),

  EV_COMMAND(CM_GAME_ACVP_WHEELDEAL_DEF,CmWheelDeal_Def),
  EV_COMMAND(CM_GAME_ACVP_WHEELDEAL_1,CmWheelDeal_1),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_WHEELDEAL_1,CeWheelDeal_1),
  EV_COMMAND(CM_GAME_ACVP_WHEELDEAL_10,CmWheelDeal_10),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_WHEELDEAL_10,CeWheelDeal_10),
  EV_COMMAND(CM_GAME_ACVP_WHEELDEAL_1000,CmWheelDeal_1000),
  EV_COMMAND_ENABLE(CM_GAME_ACVP_WHEELDEAL_1000,CeWheelDeal_1000),

END_RESPONSE_TABLE;
//*******************************************************************
void TACVPGameFW::CmGameLobby()
{
  SwitchGameModes(strLobby);
  GetACVPMenuEnable()->SetModes(true);
  GetACVPMenuEnable()->Lobby = false;
}
//*******************************************************************
void TACVPGameFW::CeGameLobby(TCommandEnabler &enabler)
{
  enabler.Enable(GetACVPMenuEnable()->Lobby);
}
//*******************************************************************
void TACVPGameFW::EnableCheckMenu(TCommandEnabler &ce,bool enable,int16 modeids)
{
  if (GetACVPMenuEnable()->GetCurrentMode() == modeids)
  {
    ce.SetCheck(TCommandEnabler::Checked);
  }
  else
  {
    ce.SetCheck(TCommandEnabler::Unchecked);
  }
  ce.Enable(enable);
}
//*******************************************************************
TACVPGameFW::TACVPGameFW(TACVPApp *pacvpapp,const char *szTitle)
:TCasinoGameFrameWindow(pacvpapp,szTitle,true,false),
 ModeDenom(0.0),
 ModeGameType(gtNone),
 ModeSubGameType(sgtNone)
{
//  GetIniShowIntro(); // already called by casgfw's ctor
  SetupModeInfo();
  GetIniModeDenom();
  DoStyle();
  DoIcon();
  DoMenu();
}
//*******************************************************************
TACVPGameFW::~TACVPGameFW()
{
  SetIniModeDenom();
}
//*******************************************************************
void TACVPGameFW::GetIniModeDenom()
{
  if (GetOgleApp() == NULL || GetOgleApp()->GetIniFile() == NULL) {return;}

  int16 did = (int16)GetOgleApp()->GetIniFile()->ReadInt("System","CurDenom",TMoney::did_0_25);
  if (!TMoney::CheckDenomID(did))
  {
    did = TMoney::did_0_25;
  }
  TMoney m(TMoney::ctorDenomID,did);
  ModeDenom = m;
}
//*******************************************************************
void TACVPGameFW::SetIniModeDenom()
{
  if (GetOgleApp() == NULL || GetOgleApp()->GetIniFile() == NULL) {return;}

  int16 did = ModeDenom.GetDenomID();
  if (!TMoney::CheckDenomID(did) || did == TMoney::did_0_00)
  {
    did = TMoney::did_0_25;
  }

  GetOgleApp()->GetIniFile()->WriteInt("System","CurDenom",did);
}
//*******************************************************************
void TACVPGameFW::SetupModeIDS()
{
  if (ModeIDSInitialized) {return;}

  TCasinoGameFrameWindow::SetupModeIDS();

  idsIntro = IDS_M_ACVP_INTRO;
  idsLobby = IDS_M_ACVP_LOBBY;
  idsFivesUp = IDS_M_ACVP_FIVESUP;
  idsBlackJacks = IDS_M_ACVP_BLACKJACKS;
  idsBonusDeluxe = IDS_M_ACVP_BONUSDELUXE;
  idsClubBonus = IDS_M_ACVP_CLUBBONUS;
  idsCrazy8s = IDS_M_ACVP_CRAZY8S;
  idsDDrawJacksOrBetter = IDS_M_ACVP_DDRAWJACKSORBETTER;
  idsDDrawJokerPoker = IDS_M_ACVP_DDRAWJOKERPOKER;
  idsDDownStud = IDS_M_ACVP_DDOWNSTUD;
  idsDeucesWildBonus = IDS_M_ACVP_DEUCESWILDBONUS;
  idsDeucesWild = IDS_M_ACVP_DEUCESWILD;
  idsDeucesWildProg = IDS_M_ACVP_DEUCESWILDPROG;
  idsDiamondBonus = IDS_M_ACVP_DIAMONDBONUS;
  idsDBonusPoker = IDS_M_ACVP_DBONUSPOKER;
  idsFlushAssault = IDS_M_ACVP_FLUSHASSAULT;
  idsFreeLook = IDS_M_ACVP_FREELOOK;
  idsGamblersEdge = IDS_M_ACVP_GAMBLERSEDGE;
  idsHeartBonus = IDS_M_ACVP_HEARTBONUS;
  idsJacksOrBetterProg = IDS_M_ACVP_JACKSORBETTERPROG;
  idsJackpotBonus = IDS_M_ACVP_JACKPOTBONUS;
  idsJacksOrBetter96 = IDS_M_ACVP_JACKSORBETTER96;
  idsJacksOrBetter85 = IDS_M_ACVP_JACKSORBETTER85;
  idsJacksOrBetterDNothing = IDS_M_ACVP_JACKSORBETTERDNOTHING;
  idsJokersWildProg = IDS_M_ACVP_JOKERSWILDPROG;
  idsJumpinJokers = IDS_M_ACVP_JUMPINJOKERS;
  idsTripleProg = IDS_M_ACVP_TRIPLEPROG;
  idsRoyalsProg = IDS_M_ACVP_ROYALSPROG;
  idsPowerHouseProg = IDS_M_ACVP_POWERHOUSEPROG;
  idsRaiseDrawJokerPoker = IDS_M_ACVP_RAISEDRAWJOKERPOKER;
  idsSpadeBonus = IDS_M_ACVP_SPADEBONUS;
  idsSuperDJackpot = IDS_M_ACVP_SUPERDJACKPOT;
  idsSevensWild1Joker = IDS_M_ACVP_SEVENSWILD1JOKER;
  idsTensOrBetter = IDS_M_ACVP_TENSORBETTER;
  idsTreasureTrove = IDS_M_ACVP_TREASURETROVE;
  idsTriplePlay = IDS_M_ACVP_TRIPLEPLAY;
  idsTripleBonus = IDS_M_ACVP_TRIPLEBONUS;
  idsWheelDeal = IDS_M_ACVP_WHEELDEAL;
  idsCrystalPalace = IDS_M_ACVP_CRYSTALPALACE;
  idsSuperSevens = IDS_M_ACVP_SUPERSEVENS;
}
//*******************************************************************
void TACVPGameFW::SetupModeStrings()
{
  if (ModeStringsInitialized) {return;}

  TCasinoGameFrameWindow::SetupModeStrings();

  strIntro = GetAppString(idsIntro);
  strLobby = GetAppString(idsLobby);
  strFivesUp = GetAppString(idsFivesUp);
  strBlackJacks = GetAppString(idsBlackJacks);
  strBonusDeluxe = GetAppString(idsBonusDeluxe);
  strClubBonus = GetAppString(idsClubBonus);
  strCrazy8s = GetAppString(idsCrazy8s);
  strDDrawJacksOrBetter = GetAppString(idsDDrawJacksOrBetter);
  strDDrawJokerPoker = GetAppString(idsDDrawJokerPoker);
  strDDownStud = GetAppString(idsDDownStud);
  strDeucesWildBonus = GetAppString(idsDeucesWildBonus);
  strDeucesWild = GetAppString(idsDeucesWild);
  strDeucesWildProg = GetAppString(idsDeucesWildProg);
  strDiamondBonus = GetAppString(idsDiamondBonus);
  strDBonusPoker = GetAppString(idsDBonusPoker);
  strFlushAssault = GetAppString(idsFlushAssault);
  strFreeLook = GetAppString(idsFreeLook);
  strGamblersEdge = GetAppString(idsGamblersEdge);
  strHeartBonus = GetAppString(idsHeartBonus);
  strJacksOrBetterProg = GetAppString(idsJacksOrBetterProg);
  strJackpotBonus = GetAppString(idsJackpotBonus);
  strJacksOrBetter96 = GetAppString(idsJacksOrBetter96);
  strJacksOrBetter85 = GetAppString(idsJacksOrBetter85);
  strJacksOrBetterDNothing = GetAppString(idsJacksOrBetterDNothing);
  strJokersWildProg = GetAppString(idsJokersWildProg);
  strJumpinJokers = GetAppString(idsJumpinJokers);
  strTripleProg = GetAppString(idsTripleProg);
  strRoyalsProg = GetAppString(idsRoyalsProg);
  strPowerHouseProg = GetAppString(idsPowerHouseProg);
  strRaiseDrawJokerPoker = GetAppString(idsRaiseDrawJokerPoker);
  strSpadeBonus = GetAppString(idsSpadeBonus);
  strSuperDJackpot = GetAppString(idsSuperDJackpot);
  strSevensWild1Joker = GetAppString(idsSevensWild1Joker);
  strTensOrBetter = GetAppString(idsTensOrBetter);
  strTreasureTrove = GetAppString(idsTreasureTrove);
  strTriplePlay = GetAppString(idsTriplePlay);
  strTripleBonus = GetAppString(idsTripleBonus);
  strWheelDeal = GetAppString(idsWheelDeal);
  strCrystalPalace = GetAppString(idsCrystalPalace);
  strSuperSevens = GetAppString(idsSuperSevens);
}
//*******************************************************************
void TACVPGameFW::SetupModeIndexes()
{
  if (ModeIndexesInitialized) {return;}

  TCasinoGameFrameWindow::SetupModeIndexes();

  miIntro = GetModeIndex(strIntro);
  miLobby = GetModeIndex(strLobby);
  miFivesUp = GetModeIndex(strFivesUp);
  miBlackJacks = GetModeIndex(strBlackJacks);
  miBonusDeluxe = GetModeIndex(strBonusDeluxe);
  miClubBonus = GetModeIndex(strClubBonus);
  miCrazy8s = GetModeIndex(strCrazy8s);
  miDDrawJacksOrBetter = GetModeIndex(strDDrawJacksOrBetter);
  miDDrawJokerPoker = GetModeIndex(strDDrawJokerPoker);
  miDDownStud = GetModeIndex(strDDownStud);
  miDeucesWildBonus = GetModeIndex(strDeucesWildBonus);
  miDeucesWild = GetModeIndex(strDeucesWild);
  miDeucesWildProg = GetModeIndex(strDeucesWildProg);
  miDiamondBonus = GetModeIndex(strDiamondBonus);
  miDBonusPoker = GetModeIndex(strDBonusPoker);
  miFlushAssault = GetModeIndex(strFlushAssault);
  miFreeLook = GetModeIndex(strFreeLook);
  miGamblersEdge = GetModeIndex(strGamblersEdge);
  miHeartBonus = GetModeIndex(strHeartBonus);
  miJacksOrBetterProg = GetModeIndex(strJacksOrBetterProg);
  miJackpotBonus = GetModeIndex(strJackpotBonus);
  miJacksOrBetter96 = GetModeIndex(strJacksOrBetter96);
  miJacksOrBetter85 = GetModeIndex(strJacksOrBetter85);
  miJacksOrBetterDNothing = GetModeIndex(strJacksOrBetterDNothing);
  miJokersWildProg = GetModeIndex(strJokersWildProg);
  miJumpinJokers = GetModeIndex(strJumpinJokers);
  miTripleProg = GetModeIndex(strTripleProg);
  miRoyalsProg = GetModeIndex(strRoyalsProg);
  miPowerHouseProg = GetModeIndex(strPowerHouseProg);
  miRaiseDrawJokerPoker = GetModeIndex(strRaiseDrawJokerPoker);
  miSpadeBonus = GetModeIndex(strSpadeBonus);
  miSuperDJackpot = GetModeIndex(strSuperDJackpot);
  miSevensWild1Joker = GetModeIndex(strSevensWild1Joker);
  miTensOrBetter = GetModeIndex(strTensOrBetter);
  miTreasureTrove = GetModeIndex(strTreasureTrove);
  miTriplePlay = GetModeIndex(strTriplePlay);
  miTripleBonus = GetModeIndex(strTripleBonus);
  miWheelDeal = GetModeIndex(strWheelDeal);
  miCrystalPalace = GetModeIndex(strCrystalPalace);
  miSuperSevens = GetModeIndex(strSuperSevens);

  StartupModeIndex = ShowIntro ? miIntro : miLobby;
//  StartupModeIndex = miLobby;//miTensOrBetter;
}
//*******************************************************************
void TACVPGameFW::NotifyDenomSwitch(TMoney denom)
{
  TACVPMenuEnable *pme = GetACVPMenuEnable();
  if (pme == NULL) {return;}

  ModeDenom = denom;
  pme->Denom = denom;
  pme->SetModes(true);

  int16 did = denom.GetDenomID();
  if (!TMoney::CheckDenomID(did)) {return;}

  pme->SetModeEnb(ModeGameType,ModeSubGameType,did,false);
}
//*******************************************************************
void TACVPGameFW::CreateMenuEnable()
{
  PMenuEnable = new TACVPMenuEnable(true);
}
//*******************************************************************
int TACVPGameFW::GetMenuID()
{
  return IDM_ACVP_DEF;
}
//*******************************************************************
void TACVPGameFW::DoMenu()
{
  AssignMenu(IDM_ACVP_DEF);
}
//*******************************************************************
int TACVPGameFW::GetAboutID()
{
  return IDB_ACVP_ABOUT;
}
//*******************************************************************
void TACVPGameFW::SwitchGameModes(int16 modeindex)
{
  if (!IsValidModeIndex(modeindex))
  {
	 MessageBox("Internal error, no switch attempted","Switch Mode",MB_OK|MB_TASKMODAL);
  }
  else
  {
	 if (!SwitchModes(modeindex))
	 {
		MessageBox("Internal error, switching to startup mode","Switch Mode",MB_OK|MB_TASKMODAL);
		SwitchModes(GetModeIndex(strLobby));
	 }
  }
}
//*******************************************************************
#pragma argsused
void TACVPGameFW::SwitchModesID(word id,word sid)
{
  MessageBox("absolete function","Error",MB_OK);
}
//*******************************************************************
bool TACVPGameFW::SwitchModeDenom(int16 modeid,TMoney money)
{
  if (GetACVPMenuEnable()->GetCurrentMode() != modeid) {return false;}
  if (money == GetACVPMenuEnable()->Denom) {return true;}
  if (PModeWin != NULL && PModeWin->SwitchDenom(money))
  {
    GetACVPMenuEnable()->Denom = money;
    ModeDenom = money;
    return true;
  }
  return false;
}
//*******************************************************************
TWindow *TACVPGameFW::CreateModeWindow(int16 ModeIndex)
//note: assumes ModeDenom is valid before call.
{
  if (!IsValidModeIndex(ModeIndex)) {return PModeWin;}

  string modename = GetModeName(ModeIndex);

  int16 sgt = sgtNone;
  int16 ids = 0;

  int16 slots_sgt = sgtNone;
  int16 slots_ids = 0;

  if (ModeIndex == miFivesUp)
  {
    sgt = cvpFivesUp;
    ids = idsFivesUp;
  }
  else if (ModeIndex == miBlackJacks)
  {
    sgt = cvpBlackJacks;
    ids = idsBlackJacks;
  }
  else if (ModeIndex == miBonusDeluxe)
  {
    sgt =  cvpBonusDeluxe;
    ids = idsBonusDeluxe;
  }
  else if (ModeIndex == miClubBonus)
  {
    sgt = cvpClubBonus;
    ids = idsClubBonus;
  }
  else if (ModeIndex == miCrazy8s)
  {
    sgt = cvpCrazy8s;
    ids = idsCrazy8s;
  }
  else if (ModeIndex == miDDrawJacksOrBetter)
  {
    sgt = cvpDDrawJB;
    ids = idsDDrawJacksOrBetter;
  }
  else if (ModeIndex == miDDrawJokerPoker)
  {
    sgt = cvpDDrawJokerPoker;
    ids = idsDDrawJokerPoker;
  }
  else if (ModeIndex == miDDownStud)
  {
    sgt = cvpDDownStud;
    ids = idsDDownStud;
  }
  else if (ModeIndex == miDeucesWildBonus)
  {
    sgt = cvpDeucesWildBonus;
    ids = idsDeucesWildBonus;
  }
  else if (ModeIndex == miDeucesWild)
  {
    sgt = cvpDeucesWildII;
    ids = idsDeucesWild;
  }
  else if (ModeIndex == miDeucesWildProg)
  {
    sgt = cvpDeucesWildProg;
    ids = idsDeucesWildProg;
  }
  else if (ModeIndex == miDiamondBonus)
  {
    sgt = cvpDiamondBonus;
    ids = idsDiamondBonus;
  }
  else if (ModeIndex == miDBonusPoker)
  {
    sgt = cvpDBonusPoker;
    ids = idsDBonusPoker;
  }
  else if (ModeIndex == miFlushAssault)
  {
    sgt = cvpFlushAssault;
    ids = idsFlushAssault;
  }
  else if (ModeIndex == miFreeLook)
  {
    sgt = cvpFreeLook;
    ids = idsFreeLook;
  }
  else if (ModeIndex == miGamblersEdge)
  {
    sgt = cvpGamblersEdge;
    ids = idsGamblersEdge;
  }
  else if (ModeIndex == miHeartBonus)
  {
    sgt = cvpHeartBonus;
    ids = idsHeartBonus;
  }
  else if (ModeIndex == miJacksOrBetterProg)
  {
    sgt = cvpJacksProgII;
    ids = idsJacksOrBetterProg;
  }
  else if (ModeIndex == miJackpotBonus)
  {
    sgt = cvpJackpotBonus;
    ids = idsJackpotBonus;
  }
  else if (ModeIndex == miJacksOrBetter96)
  {
    sgt = cvp96JacksOrBetterII;
    ids = idsJacksOrBetter96;
  }
  else if (ModeIndex == miJacksOrBetter85)
  {
    sgt = cvp85JacksOrBetter;
    ids = idsJacksOrBetter85;
  }
  else if (ModeIndex == miJacksOrBetterDNothing)
  {
    sgt = cvpDJacksOrBetter;
    ids = idsJacksOrBetterDNothing;
  }
  else if (ModeIndex == miJokersWildProg)
  {
    sgt = cvpJokersWildProg;
    ids = idsJokersWildProg;
  }
  else if (ModeIndex == miJumpinJokers)
  {
    sgt = cvpJumpinJokers;
    ids = idsJumpinJokers;
  }
  else if (ModeIndex == miTripleProg)
  {
    sgt = cvpTripleProg;
    ids = idsTripleProg;
  }
  else if (ModeIndex == miRoyalsProg)
  {
    sgt = cvpRoyalProg;
    ids = idsRoyalsProg;
  }
  else if (ModeIndex == miPowerHouseProg)
  {
    sgt = cvpPowerProg;
    ids = idsPowerHouseProg;
  }
  else if (ModeIndex == miRaiseDrawJokerPoker)
  {
    sgt = cvpRaiseJokersWild;
    ids = idsRaiseDrawJokerPoker;
  }
  else if (ModeIndex == miSpadeBonus)
  {
    sgt = cvpSpadeBonus;
    ids = idsSpadeBonus;
  }
  else if (ModeIndex == miSuperDJackpot)
  {
    sgt = cvpSuperDJackpot;
    ids = idsSuperDJackpot;
  }
  else if (ModeIndex == miSevensWild1Joker)
  {
    sgt = cvp7Wild1Joker;
    ids = idsSevensWild1Joker;
  }
  else if (ModeIndex == miTensOrBetter)
  {
    sgt = cvpTensOrBetterII;
    ids = idsTensOrBetter;
  }
  else if (ModeIndex == miTreasureTrove)
  {
    sgt = cvpTreasureTrove;
    ids = idsTreasureTrove;
  }
  else if (ModeIndex == miTriplePlay)
  {
    sgt = cvpTriplePlay;
    ids = idsTriplePlay;
  }
  else if (ModeIndex == miTripleBonus)
  {
    sgt = cvpTripleBonus;
    ids = idsTripleBonus;
  }
  else if (ModeIndex == miWheelDeal)
  {
    sgt = cvpWheelDeal;
    ids = idsWheelDeal;
  }
  else if (ModeIndex == miCrystalPalace)
  {
    slots_sgt = cslCrystalPalace;
    slots_ids = idsCrystalPalace;
  }
  else if (ModeIndex == miSuperSevens)
  {
    slots_sgt = cslSuperSevens;
    slots_ids = idsSuperSevens;
  }


  if (sgt > sgtNone)
  {
    PModeWin = new TACVPVPModeWin(modename,GetOgleApp()->PMasterPalette,
                                sgt,ModeDenom.GetDenomID());

    // ??? need to put above new ???
    GetACVPMenuEnable()->SetCurrentMode(ids);
    ModeSubGameType = sgt;
    ModeGameType = gtVideoPoker;
    return PModeWin;
  }
  else if (slots_sgt > sgtNone)
  {
    PModeWin = new TACVPSlotsModeWin(modename,GetOgleApp()->PMasterPalette,
                                     slots_sgt,ModeDenom.GetDenomID());
    GetACVPMenuEnable()->SetCurrentMode(slots_ids);
    ModeSubGameType = slots_sgt;
    ModeGameType = gtSlots;
    return PModeWin;
  }

  if (ModeIndex == miIntro)
  {
    PModeWin = new TACVPIntroModeWin(modename,GetOgleApp()->PMasterPalette,"Intro");
    GetACVPMenuEnable()->SetCurrentMode(IDS_M_ACVP_INTRO);
    return PModeWin;
  }

  if (ModeIndex == miLobby)
  {
    PModeWin = new TACVPLobbyModeWin(modename,GetOgleApp()->PMasterPalette);
    GetACVPMenuEnable()->SetCurrentMode(idsLobby);
    return PModeWin;
  }

  ::MessageBox(NULL,"Default Mode Window Created","Create Mode Window",MB_OK);
  PModeWin = new TCasinoModeWin(modename,GetOgleApp()->PMasterPalette,string("Default Casino ModeWin"));
  GetACVPMenuEnable()->SetCurrentMode(-1);
  return PModeWin;
}
//*******************************************************************
bool TACVPGameFW::SwitchACVPVPMode(int16 sgt,string strmodename,int16 mi,int16 ids,int16 did)
//note: assumes enabled already checked before call.
{
  TACVPMenuEnable *pme = GetACVPMenuEnable();
  if (pme == NULL) {return false;}
  if (!TMoney::CheckDenomID(did)) {return false;}
  if (!pme->GetModeEnb(gtVideoPoker,sgt,did)) {return false;}
  pme->SetModes(true);
  TMoney money(TMoney::ctorDenomID,did);
  if (!SwitchModeDenom(ids,money)) //don't set ModeDenom until after call.
  {
    ModeDenom = money;
    pme->Denom = money;
    SwitchGameModes(strmodename);
  }
  pme->SetModeEnb(gtVideoPoker,sgt,did,false);
  return true;
}
//*******************************************************************
bool TACVPGameFW::SwitchVPModeDefDenom(int16 sgt,
                                       const string &strmode,
                                       int16 mi,
                                       int16 ids)
{
  TACVPMenuEnable *pme = GetACVPMenuEnable();
  if (pme == NULL) {return false;} //?should show messagebox?

  int16 did = ModeDenom.GetDenomID();
  if (!TMoney::CheckDenomID(did) || did <= TMoney::did_0_00)
  {
    did = TMoney::did_0_25;
  }

  int16 startdid = did;

  //loop thru allowed denoms looking for first good denom going larger
  for (;did < TMoney::did_NumIDs;did++)
  {
    if (pme->GetModeFlags(gtVideoPoker,sgt,did) &&
        SwitchACVPVPMode(sgt,strmode,mi,ids,did))
    {
      return true; //found one and switched to it.
    }
  }
  // now trying going smaller
  for (did = startdid;did > TMoney::did_0_00;did--)
  {
    if (pme->GetModeFlags(gtVideoPoker,sgt,did) &&
        SwitchACVPVPMode(sgt,strmode,mi,ids,did))
    {
      return true; // found one and switched to it.
    }
  }
  return false;
}
//*******************************************************************
void TACVPGameFW::CmFivesUp_Def()
{
  SwitchVPModeDefDenom(cvpFivesUp,strFivesUp,miFivesUp,idsFivesUp);
}
//*******************************************************************
void TACVPGameFW::CmFivesUp_25c()
{
  SwitchACVPVPMode(cvpFivesUp,strFivesUp,miFivesUp,idsFivesUp,TMoney::did_0_25);
}
//*******************************************************************
void TACVPGameFW::CeFivesUp_25c(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->FivesUpEnb[TMoney::did_0_25],
                  idsFivesUp);
}
//*******************************************************************
void TACVPGameFW::CmFivesUp_1()
{
  SwitchACVPVPMode(cvpFivesUp,strFivesUp,miFivesUp,idsFivesUp,TMoney::did_1_00);
}
//*******************************************************************
void TACVPGameFW::CeFivesUp_1(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->FivesUpEnb[TMoney::did_1_00],
                  idsFivesUp);
}
//*******************************************************************
void TACVPGameFW::CmFivesUp_50()
{
  SwitchACVPVPMode(cvpFivesUp,strFivesUp,miFivesUp,idsFivesUp,TMoney::did_50_00);
}
//*******************************************************************
void TACVPGameFW::CeFivesUp_50(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->FivesUpEnb[TMoney::did_50_00],
                  idsFivesUp);
}
//*******************************************************************
void TACVPGameFW::CmFivesUp_100()
{
  SwitchACVPVPMode(cvpFivesUp,strFivesUp,miFivesUp,idsFivesUp,TMoney::did_100_00);
}
//*******************************************************************
void TACVPGameFW::CeFivesUp_100(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->FivesUpEnb[TMoney::did_100_00],
                  idsFivesUp);
}
//*******************************************************************
void TACVPGameFW::CmBlackJacks_Def()
{
  SwitchVPModeDefDenom(cvpBlackJacks,strBlackJacks,miBlackJacks,idsBlackJacks);
}
//*******************************************************************
void TACVPGameFW::CmBlackJacks_10()
{
  SwitchACVPVPMode(cvpBlackJacks,strBlackJacks,miBlackJacks,idsBlackJacks,TMoney::did_10_00);
}
//*******************************************************************
void TACVPGameFW::CeBlackJacks_10(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->BlackJacksEnb[TMoney::did_10_00],
                  idsBlackJacks);
}
//*******************************************************************
void TACVPGameFW::CmBlackJacks_50()
{
  SwitchACVPVPMode(cvpBlackJacks,strBlackJacks,miBlackJacks,idsBlackJacks,TMoney::did_50_00);
}
//*******************************************************************
void TACVPGameFW::CeBlackJacks_50(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->BlackJacksEnb[TMoney::did_50_00],
                  idsBlackJacks);
}
//*******************************************************************
void TACVPGameFW::CmBlackJacks_100()
{
  SwitchACVPVPMode(cvpBlackJacks,strBlackJacks,miBlackJacks,idsBlackJacks,TMoney::did_100_00);
}
//*******************************************************************
void TACVPGameFW::CeBlackJacks_100(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->BlackJacksEnb[TMoney::did_100_00],
                  idsBlackJacks);
}
//*******************************************************************
void TACVPGameFW::CmBlackJacks_1000()
{
  SwitchACVPVPMode(cvpBlackJacks,strBlackJacks,miBlackJacks,idsBlackJacks,TMoney::did_1000_00);
}
//*******************************************************************
void TACVPGameFW::CeBlackJacks_1000(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->BlackJacksEnb[TMoney::did_1000_00],
                  idsBlackJacks);
}
//*******************************************************************
void TACVPGameFW::CmBonusDeluxe_Def()
{
  SwitchVPModeDefDenom(cvpBonusDeluxe,strBonusDeluxe,miBonusDeluxe,idsBonusDeluxe);
}
//*******************************************************************
void TACVPGameFW::CmBonusDeluxe_25c()
{
  SwitchACVPVPMode(cvpBonusDeluxe,strBonusDeluxe,miBonusDeluxe,idsBonusDeluxe,TMoney::did_0_25);
}
//*******************************************************************
void TACVPGameFW::CeBonusDeluxe_25c(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->BonusDeluxeEnb[TMoney::did_0_25],
                  idsBonusDeluxe);
}
//*******************************************************************
void TACVPGameFW::CmBonusDeluxe_1()
{
  SwitchACVPVPMode(cvpBonusDeluxe,strBonusDeluxe,miBonusDeluxe,idsBonusDeluxe,TMoney::did_1_00);
}
//*******************************************************************
void TACVPGameFW::CeBonusDeluxe_1(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->BonusDeluxeEnb[TMoney::did_1_00],
                  idsBonusDeluxe);
}
//*******************************************************************
void TACVPGameFW::CmBonusDeluxe_5()
{
  SwitchACVPVPMode(cvpBonusDeluxe,strBonusDeluxe,miBonusDeluxe,idsBonusDeluxe,TMoney::did_5_00);
}
//*******************************************************************
void TACVPGameFW::CeBonusDeluxe_5(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->BonusDeluxeEnb[TMoney::did_5_00],
                  idsBonusDeluxe);
}
//*******************************************************************
void TACVPGameFW::CmBonusDeluxe_10()
{
  SwitchACVPVPMode(cvpBonusDeluxe,strBonusDeluxe,miBonusDeluxe,idsBonusDeluxe,TMoney::did_10_00);
}
//*******************************************************************
void TACVPGameFW::CeBonusDeluxe_10(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->BonusDeluxeEnb[TMoney::did_10_00],
                  idsBonusDeluxe);
}
//*******************************************************************
void TACVPGameFW::CmBonusDeluxe_25()
{
  SwitchACVPVPMode(cvpBonusDeluxe,strBonusDeluxe,miBonusDeluxe,idsBonusDeluxe,TMoney::did_25_00);
}
//*******************************************************************
void TACVPGameFW::CeBonusDeluxe_25(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->BonusDeluxeEnb[TMoney::did_25_00],
                  idsBonusDeluxe);
}
//*******************************************************************
void TACVPGameFW::CmClubBonus_Def()
{
  SwitchVPModeDefDenom(cvpClubBonus,strClubBonus,miClubBonus,idsClubBonus);
}
//*******************************************************************
void TACVPGameFW::CmClubBonus_5()
{
  SwitchACVPVPMode(cvpClubBonus,strClubBonus,miClubBonus,idsClubBonus,TMoney::did_5_00);
}
//*******************************************************************
void TACVPGameFW::CeClubBonus_5(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->ClubBonusEnb[TMoney::did_5_00],
                  idsClubBonus);
}
//*******************************************************************
void TACVPGameFW::CmClubBonus_100()
{
  SwitchACVPVPMode(cvpClubBonus,strClubBonus,miClubBonus,idsClubBonus,TMoney::did_100_00);
}
//*******************************************************************
void TACVPGameFW::CeClubBonus_100(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->ClubBonusEnb[TMoney::did_100_00],
                  idsClubBonus);
}
//*******************************************************************
void TACVPGameFW::CmClubBonus_500()
{
  SwitchACVPVPMode(cvpClubBonus,strClubBonus,miClubBonus,idsClubBonus,TMoney::did_500_00);
}
//*******************************************************************
void TACVPGameFW::CeClubBonus_500(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->ClubBonusEnb[TMoney::did_500_00],
                  idsClubBonus);
}
//*******************************************************************
void TACVPGameFW::CmCrazy8s_Def()
{
  SwitchVPModeDefDenom(cvpCrazy8s,strCrazy8s,miCrazy8s,idsCrazy8s);
}
//*******************************************************************
void TACVPGameFW::CmCrazy8s_1()
{
  SwitchACVPVPMode(cvpCrazy8s,strCrazy8s,miCrazy8s,idsCrazy8s,TMoney::did_1_00);
}
//*******************************************************************
void TACVPGameFW::CeCrazy8s_1(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->Crazy8sEnb[TMoney::did_1_00],
                  idsCrazy8s);
}
//*******************************************************************
void TACVPGameFW::CmCrazy8s_5()
{
  SwitchACVPVPMode(cvpCrazy8s,strCrazy8s,miCrazy8s,idsCrazy8s,TMoney::did_5_00);
}
//*******************************************************************
void TACVPGameFW::CeCrazy8s_5(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->Crazy8sEnb[TMoney::did_5_00],
                  idsCrazy8s);
}
//*******************************************************************
void TACVPGameFW::CmCrazy8s_10()
{
  SwitchACVPVPMode(cvpCrazy8s,strCrazy8s,miCrazy8s,idsCrazy8s,TMoney::did_10_00);
}
//*******************************************************************
void TACVPGameFW::CeCrazy8s_10(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->Crazy8sEnb[TMoney::did_10_00],
                  idsCrazy8s);
}
//*******************************************************************
void TACVPGameFW::CmCrazy8s_1000()
{
  SwitchACVPVPMode(cvpCrazy8s,strCrazy8s,miCrazy8s,idsCrazy8s,TMoney::did_1000_00);
}
//*******************************************************************
void TACVPGameFW::CeCrazy8s_1000(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->Crazy8sEnb[TMoney::did_1000_00],
                  idsCrazy8s);
}
//*******************************************************************
void TACVPGameFW::CmDDrawJacksOrBetter_Def()
{
  SwitchVPModeDefDenom(cvpDDrawJB,strDDrawJacksOrBetter,
                       miDDrawJacksOrBetter,idsDDrawJacksOrBetter);
}
//*******************************************************************
void TACVPGameFW::CmDDrawJacksOrBetter_25c()
{
  SwitchACVPVPMode(cvpDDrawJB,strDDrawJacksOrBetter,
                   miDDrawJacksOrBetter,idsDDrawJacksOrBetter,TMoney::did_0_25);
}
//*******************************************************************
void TACVPGameFW::CeDDrawJacksOrBetter_25c(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->DDrawJacksOrBetterEnb[TMoney::did_0_25],
                  idsDDrawJacksOrBetter);
}
//*******************************************************************
void TACVPGameFW::CmDDrawJacksOrBetter_1()
{
  SwitchACVPVPMode(cvpDDrawJB,strDDrawJacksOrBetter,
                   miDDrawJacksOrBetter,idsDDrawJacksOrBetter,TMoney::did_1_00);
}
//*******************************************************************
void TACVPGameFW::CeDDrawJacksOrBetter_1(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->DDrawJacksOrBetterEnb[TMoney::did_1_00],
                  idsDDrawJacksOrBetter);
}
//*******************************************************************
void TACVPGameFW::CmDDrawJacksOrBetter_10()
{
  SwitchACVPVPMode(cvpDDrawJB,strDDrawJacksOrBetter,
                   miDDrawJacksOrBetter,idsDDrawJacksOrBetter,TMoney::did_10_00);
}
//*******************************************************************
void TACVPGameFW::CeDDrawJacksOrBetter_10(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->DDrawJacksOrBetterEnb[TMoney::did_10_00],
                  idsDDrawJacksOrBetter);
}
//*******************************************************************
void TACVPGameFW::CmDDrawJacksOrBetter_50()
{
  SwitchACVPVPMode(cvpDDrawJB,strDDrawJacksOrBetter,
                   miDDrawJacksOrBetter,idsDDrawJacksOrBetter,TMoney::did_50_00);
}
//*******************************************************************
void TACVPGameFW::CeDDrawJacksOrBetter_50(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->DDrawJacksOrBetterEnb[TMoney::did_50_00],
                  idsDDrawJacksOrBetter);
}
//*******************************************************************
void TACVPGameFW::CmDDrawJacksOrBetter_1000()
{
  SwitchACVPVPMode(cvpDDrawJB,strDDrawJacksOrBetter,
                   miDDrawJacksOrBetter,idsDDrawJacksOrBetter,TMoney::did_1000_00);
}
//*******************************************************************
void TACVPGameFW::CeDDrawJacksOrBetter_1000(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->DDrawJacksOrBetterEnb[TMoney::did_1000_00],
                  idsDDrawJacksOrBetter);
}
//*******************************************************************
void TACVPGameFW::CmDDrawJokerPoker_Def()
{
  SwitchVPModeDefDenom(cvpDDrawJokerPoker,strDDrawJokerPoker,
                       miDDrawJokerPoker,idsDDrawJokerPoker);
}
//*******************************************************************
void TACVPGameFW::CmDDrawJokerPoker_1()
{
  SwitchACVPVPMode(cvpDDrawJokerPoker,strDDrawJokerPoker,
                   miDDrawJokerPoker,idsDDrawJokerPoker,TMoney::did_1_00);
}
//*******************************************************************
void TACVPGameFW::CeDDrawJokerPoker_1(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->DDrawJokerPokerEnb[TMoney::did_1_00],
                  idsDDrawJokerPoker);
}
//*******************************************************************
void TACVPGameFW::CmDDrawJokerPoker_5()
{
  SwitchACVPVPMode(cvpDDrawJokerPoker,strDDrawJokerPoker,
                   miDDrawJokerPoker,idsDDrawJokerPoker,TMoney::did_5_00);
}
//*******************************************************************
void TACVPGameFW::CeDDrawJokerPoker_5(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->DDrawJokerPokerEnb[TMoney::did_5_00],
                  idsDDrawJokerPoker);
}
//*******************************************************************
void TACVPGameFW::CmDDrawJokerPoker_10()
{
  SwitchACVPVPMode(cvpDDrawJokerPoker,strDDrawJokerPoker,
                   miDDrawJokerPoker,idsDDrawJokerPoker,TMoney::did_10_00);
}
//*******************************************************************
void TACVPGameFW::CeDDrawJokerPoker_10(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->DDrawJokerPokerEnb[TMoney::did_10_00],
                  idsDDrawJokerPoker);
}
//*******************************************************************
void TACVPGameFW::CmDDrawJokerPoker_25()
{
  SwitchACVPVPMode(cvpDDrawJokerPoker,strDDrawJokerPoker,
                   miDDrawJokerPoker,idsDDrawJokerPoker,TMoney::did_25_00);
}
//*******************************************************************
void TACVPGameFW::CeDDrawJokerPoker_25(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->DDrawJokerPokerEnb[TMoney::did_25_00],
                  idsDDrawJokerPoker);
}
//*******************************************************************
void TACVPGameFW::CmDDrawJokerPoker_500()
{
  SwitchACVPVPMode(cvpDDrawJokerPoker,strDDrawJokerPoker,
                   miDDrawJokerPoker,idsDDrawJokerPoker,TMoney::did_500_00);
}
//*******************************************************************
void TACVPGameFW::CeDDrawJokerPoker_500(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->DDrawJokerPokerEnb[TMoney::did_500_00],
                  idsDDrawJokerPoker);
}
//*******************************************************************
void TACVPGameFW::CmDDownStud_Def()
{
  SwitchVPModeDefDenom(cvpDDownStud,strDDownStud,miDDownStud,idsDDownStud);
}
//*******************************************************************
void TACVPGameFW::CmDDownStud_25c()
{
  SwitchACVPVPMode(cvpDDownStud,strDDownStud,miDDownStud,idsDDownStud,TMoney::did_0_25);
}
//*******************************************************************
void TACVPGameFW::CeDDownStud_25c(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->DDownStudEnb[TMoney::did_0_25],
                  idsDDownStud);
}
//*******************************************************************
void TACVPGameFW::CmDDownStud_1()
{
  SwitchACVPVPMode(cvpDDownStud,strDDownStud,miDDownStud,idsDDownStud,TMoney::did_1_00);
}
//*******************************************************************
void TACVPGameFW::CeDDownStud_1(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->DDownStudEnb[TMoney::did_1_00],
                  idsDDownStud);
}
//*******************************************************************
void TACVPGameFW::CmDDownStud_5()
{
  SwitchACVPVPMode(cvpDDownStud,strDDownStud,miDDownStud,idsDDownStud,TMoney::did_5_00);
}
//*******************************************************************
void TACVPGameFW::CeDDownStud_5(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->DDownStudEnb[TMoney::did_5_00],
                  idsDDownStud);
}
//*******************************************************************
void TACVPGameFW::CmDDownStud_50()
{
  SwitchACVPVPMode(cvpDDownStud,strDDownStud,miDDownStud,idsDDownStud,TMoney::did_50_00);
}
//*******************************************************************
void TACVPGameFW::CeDDownStud_50(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->DDownStudEnb[TMoney::did_50_00],
                  idsDDownStud);
}
//*******************************************************************
void TACVPGameFW::CmDDownStud_100()
{
  SwitchACVPVPMode(cvpDDownStud,strDDownStud,miDDownStud,idsDDownStud,TMoney::did_100_00);
}
//*******************************************************************
void TACVPGameFW::CeDDownStud_100(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->DDownStudEnb[TMoney::did_100_00],
                  idsDDownStud);
}
//*******************************************************************
void TACVPGameFW::CmDeucesWildBonus_Def()
{
  SwitchVPModeDefDenom(cvpDeucesWildBonus,strDeucesWildBonus,
                       miDeucesWildBonus,idsDeucesWildBonus);
}
//*******************************************************************
void TACVPGameFW::CmDeucesWildBonus_25c()
{
  SwitchACVPVPMode(cvpDeucesWildBonus,strDeucesWildBonus,
                   miDeucesWildBonus,idsDeucesWildBonus,TMoney::did_0_25);
}
//*******************************************************************
void TACVPGameFW::CeDeucesWildBonus_25c(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->DeucesWildBonusEnb[TMoney::did_0_25],
                  idsDeucesWildBonus);
}
//*******************************************************************
void TACVPGameFW::CmDeucesWildBonus_1()
{
  SwitchACVPVPMode(cvpDeucesWildBonus,strDeucesWildBonus,
                   miDeucesWildBonus,idsDeucesWildBonus,TMoney::did_1_00);
}
//*******************************************************************
void TACVPGameFW::CeDeucesWildBonus_1(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->DeucesWildBonusEnb[TMoney::did_1_00],
                  idsDeucesWildBonus);
}
//*******************************************************************
void TACVPGameFW::CmDeucesWildBonus_25()
{
  SwitchACVPVPMode(cvpDeucesWildBonus,strDeucesWildBonus,
                   miDeucesWildBonus,idsDeucesWildBonus,TMoney::did_25_00);
}
//*******************************************************************
void TACVPGameFW::CeDeucesWildBonus_25(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->DeucesWildBonusEnb[TMoney::did_25_00],
                  idsDeucesWildBonus);
}
//*******************************************************************
void TACVPGameFW::CmDeucesWildBonus_1000()
{
  SwitchACVPVPMode(cvpDeucesWildBonus,strDeucesWildBonus,
                   miDeucesWildBonus,idsDeucesWildBonus,TMoney::did_1000_00);
}
//*******************************************************************
void TACVPGameFW::CeDeucesWildBonus_1000(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->DeucesWildBonusEnb[TMoney::did_1000_00],
                  idsDeucesWildBonus);
}
//*******************************************************************
void TACVPGameFW::CmDeucesWild_Def()
{
  SwitchVPModeDefDenom(cvpDeucesWildII,strDeucesWild,miDeucesWild,idsDeucesWild);
}
//*******************************************************************
void TACVPGameFW::CmDeucesWild_5c()
{
  SwitchACVPVPMode(cvpDeucesWildII,strDeucesWild,miDeucesWild,idsDeucesWild,TMoney::did_0_05);
}
//*******************************************************************
void TACVPGameFW::CeDeucesWild_5c(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->DeucesWildEnb[TMoney::did_0_05],
                  idsDeucesWild);
}
//*******************************************************************
void TACVPGameFW::CmDeucesWild_10c()
{
  SwitchACVPVPMode(cvpDeucesWildII,strDeucesWild,miDeucesWild,idsDeucesWild,TMoney::did_0_10);
}
//*******************************************************************
void TACVPGameFW::CeDeucesWild_10c(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->DeucesWildEnb[TMoney::did_0_10],
                  idsDeucesWild);
}
//*******************************************************************
void TACVPGameFW::CmDeucesWild_25c()
{
  SwitchACVPVPMode(cvpDeucesWildII,strDeucesWild,miDeucesWild,idsDeucesWild,TMoney::did_0_25);
}
//*******************************************************************
void TACVPGameFW::CeDeucesWild_25c(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->DeucesWildEnb[TMoney::did_0_25],
                  idsDeucesWild);
}
//*******************************************************************
void TACVPGameFW::CmDeucesWild_1()
{
  SwitchACVPVPMode(cvpDeucesWildII,strDeucesWild,miDeucesWild,idsDeucesWild,TMoney::did_1_00);
}
//*******************************************************************
void TACVPGameFW::CeDeucesWild_1(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->DeucesWildEnb[TMoney::did_1_00],
                  idsDeucesWild);
}
//*******************************************************************
void TACVPGameFW::CmDeucesWild_5()
{
  SwitchACVPVPMode(cvpDeucesWildII,strDeucesWild,miDeucesWild,idsDeucesWild,TMoney::did_5_00);
}
//*******************************************************************
void TACVPGameFW::CeDeucesWild_5(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->DeucesWildEnb[TMoney::did_5_00],
                  idsDeucesWild);
}
//*******************************************************************
void TACVPGameFW::CmDeucesWild_25()
{
  SwitchACVPVPMode(cvpDeucesWildII,strDeucesWild,miDeucesWild,idsDeucesWild,TMoney::did_25_00);
}
//*******************************************************************
void TACVPGameFW::CeDeucesWild_25(TCommandEnabler &ce)
{

  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->DeucesWildEnb[TMoney::did_25_00],
                  idsDeucesWild);
}
//*******************************************************************
void TACVPGameFW::CmDeucesWild_100()
{
  SwitchACVPVPMode(cvpDeucesWildII,strDeucesWild,miDeucesWild,idsDeucesWild,TMoney::did_100_00);
}
//*******************************************************************
void TACVPGameFW::CeDeucesWild_100(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->DeucesWildEnb[TMoney::did_100_00],
                  idsDeucesWild);
}
//*******************************************************************
void TACVPGameFW::CmDeucesWildProg_Def()
{
  SwitchVPModeDefDenom(cvpDeucesWildProg,strDeucesWildProg,
                       miDeucesWildProg,idsDeucesWildProg);
}
//*******************************************************************
void TACVPGameFW::CmDeucesWildProg_5c()
{
  SwitchACVPVPMode(cvpDeucesWildProg,strDeucesWildProg,
                   miDeucesWildProg,idsDeucesWildProg,TMoney::did_0_05);
}
//*******************************************************************
void TACVPGameFW::CeDeucesWildProg_5c(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->DeucesWildProgEnb[TMoney::did_0_05],
                  idsDeucesWildProg);
}
//*******************************************************************
void TACVPGameFW::CmDeucesWildProg_1()
{
  SwitchACVPVPMode(cvpDeucesWildProg,strDeucesWildProg,
                   miDeucesWildProg,idsDeucesWildProg,TMoney::did_1_00);
}
//*******************************************************************
void TACVPGameFW::CeDeucesWildProg_1(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->DeucesWildProgEnb[TMoney::did_1_00],
                  idsDeucesWildProg);
}
//*******************************************************************
void TACVPGameFW::CmDeucesWildProg_5()
{
  SwitchACVPVPMode(cvpDeucesWildProg,strDeucesWildProg,
                   miDeucesWildProg,idsDeucesWildProg,TMoney::did_5_00);
}
//*******************************************************************
void TACVPGameFW::CeDeucesWildProg_5(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->DeucesWildProgEnb[TMoney::did_5_00],
                  idsDeucesWildProg);
}
//*******************************************************************
void TACVPGameFW::CmDiamondBonus_Def()
{
  SwitchVPModeDefDenom(cvpDiamondBonus,strDiamondBonus,miDiamondBonus,idsDiamondBonus);
}
//*******************************************************************
void TACVPGameFW::CmDiamondBonus_10c()
{
  SwitchACVPVPMode(cvpDiamondBonus,strDiamondBonus,miDiamondBonus,idsDiamondBonus,TMoney::did_0_10);
}
//*******************************************************************
void TACVPGameFW::CeDiamondBonus_10c(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->DiamondBonusEnb[TMoney::did_0_10],
                  idsDiamondBonus);
}
//*******************************************************************
void TACVPGameFW::CmDiamondBonus_25c()
{
  SwitchACVPVPMode(cvpDiamondBonus,strDiamondBonus,miDiamondBonus,idsDiamondBonus,TMoney::did_0_25);
}
//*******************************************************************
void TACVPGameFW::CeDiamondBonus_25c(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->DiamondBonusEnb[TMoney::did_0_25],
                  idsDiamondBonus);
}
//*******************************************************************
void TACVPGameFW::CmDiamondBonus_10()
{
  SwitchACVPVPMode(cvpDiamondBonus,strDiamondBonus,miDiamondBonus,idsDiamondBonus,TMoney::did_10_00);
}
//*******************************************************************
void TACVPGameFW::CeDiamondBonus_10(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->DiamondBonusEnb[TMoney::did_10_00],
                  idsDiamondBonus);
}
//*******************************************************************
void TACVPGameFW::CmDiamondBonus_25()
{
  SwitchACVPVPMode(cvpDiamondBonus,strDiamondBonus,miDiamondBonus,idsDiamondBonus,TMoney::did_25_00);
}
//*******************************************************************
void TACVPGameFW::CeDiamondBonus_25(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->DiamondBonusEnb[TMoney::did_25_00],
                  idsDiamondBonus);
}
//*******************************************************************
void TACVPGameFW::CmDiamondBonus_50()
{
  SwitchACVPVPMode(cvpDiamondBonus,strDiamondBonus,miDiamondBonus,idsDiamondBonus,TMoney::did_50_00);
}
//*******************************************************************
void TACVPGameFW::CeDiamondBonus_50(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->DiamondBonusEnb[TMoney::did_50_00],
                  idsDiamondBonus);
}
//*******************************************************************
void TACVPGameFW::CmDBonusPoker_Def()
{
  SwitchVPModeDefDenom(cvpDBonusPoker,strDBonusPoker,miDBonusPoker,idsDBonusPoker);
}
//*******************************************************************
void TACVPGameFW::CmDBonusPoker_5c()
{
  SwitchACVPVPMode(cvpDBonusPoker,strDBonusPoker,miDBonusPoker,idsDBonusPoker,TMoney::did_0_05);
}
//*******************************************************************
void TACVPGameFW::CeDBonusPoker_5c(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->DBonusPokerEnb[TMoney::did_0_05],
                  idsDBonusPoker);
}
//*******************************************************************
void TACVPGameFW::CmDBonusPoker_10c()
{
  SwitchACVPVPMode(cvpDBonusPoker,strDBonusPoker,miDBonusPoker,idsDBonusPoker,TMoney::did_0_10);
}
//*******************************************************************
void TACVPGameFW::CeDBonusPoker_10c(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->DBonusPokerEnb[TMoney::did_0_10],
                  idsDBonusPoker);
}
//*******************************************************************
void TACVPGameFW::CmDBonusPoker_25c()
{
  SwitchACVPVPMode(cvpDBonusPoker,strDBonusPoker,miDBonusPoker,idsDBonusPoker,TMoney::did_0_25);
}
//*******************************************************************
void TACVPGameFW::CeDBonusPoker_25c(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->DBonusPokerEnb[TMoney::did_0_25],
                  idsDBonusPoker);
}
//*******************************************************************
void TACVPGameFW::CmDBonusPoker_1()
{
  SwitchACVPVPMode(cvpDBonusPoker,strDBonusPoker,miDBonusPoker,idsDBonusPoker,TMoney::did_1_00);
}
//*******************************************************************
void TACVPGameFW::CeDBonusPoker_1(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->DBonusPokerEnb[TMoney::did_1_00],
                  idsDBonusPoker);
}
//*******************************************************************
void TACVPGameFW::CmDBonusPoker_100()
{
  SwitchACVPVPMode(cvpDBonusPoker,strDBonusPoker,miDBonusPoker,idsDBonusPoker,TMoney::did_100_00);
}
//*******************************************************************
void TACVPGameFW::CeDBonusPoker_100(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->DBonusPokerEnb[TMoney::did_100_00],
                  idsDBonusPoker);
}
//*******************************************************************
void TACVPGameFW::CmFlushAssault_Def()
{
  SwitchVPModeDefDenom(cvpFlushAssault,strFlushAssault,miFlushAssault,idsFlushAssault);
}
//*******************************************************************
void TACVPGameFW::CmFlushAssault_1()
{
  SwitchACVPVPMode(cvpFlushAssault,strFlushAssault,miFlushAssault,idsFlushAssault,TMoney::did_1_00);
}
//*******************************************************************
void TACVPGameFW::CeFlushAssault_1(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->FlushAssaultEnb[TMoney::did_1_00],
                  idsFlushAssault);
}
//*******************************************************************
void TACVPGameFW::CmFlushAssault_25()
{
  SwitchACVPVPMode(cvpFlushAssault,strFlushAssault,miFlushAssault,idsFlushAssault,TMoney::did_25_00);
}
//*******************************************************************
void TACVPGameFW::CeFlushAssault_25(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->FlushAssaultEnb[TMoney::did_25_00],
                  idsFlushAssault);
}
//*******************************************************************
void TACVPGameFW::CmFlushAssault_100()
{
  SwitchACVPVPMode(cvpFlushAssault,strFlushAssault,miFlushAssault,idsFlushAssault,TMoney::did_100_00);
}
//*******************************************************************
void TACVPGameFW::CeFlushAssault_100(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->FlushAssaultEnb[TMoney::did_100_00],
                  idsFlushAssault);
}
//*******************************************************************
void TACVPGameFW::CmFlushAssault_500()
{
  SwitchACVPVPMode(cvpFlushAssault,strFlushAssault,miFlushAssault,idsFlushAssault,TMoney::did_500_00);
}
//*******************************************************************
void TACVPGameFW::CeFlushAssault_500(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->FlushAssaultEnb[TMoney::did_500_00],
                  idsFlushAssault);
}
//*******************************************************************
void TACVPGameFW::CmFlushAssault_1000()
{
  SwitchACVPVPMode(cvpFlushAssault,strFlushAssault,miFlushAssault,idsFlushAssault,TMoney::did_1000_00);
}
//*******************************************************************
void TACVPGameFW::CeFlushAssault_1000(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->FlushAssaultEnb[TMoney::did_1000_00],
                  idsFlushAssault);
}
//*******************************************************************
void TACVPGameFW::CmFreeLook_Def()
{
  SwitchVPModeDefDenom(cvpFreeLook,strFreeLook,miFreeLook,idsFreeLook);
}
//*******************************************************************
void TACVPGameFW::CmFreeLook_25c()
{
  SwitchACVPVPMode(cvpFreeLook,strFreeLook,miFreeLook,idsFreeLook,TMoney::did_0_25);
}
//*******************************************************************
void TACVPGameFW::CeFreeLook_25c(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->FreeLookEnb[TMoney::did_0_25],
                  idsFreeLook);
}
//*******************************************************************
void TACVPGameFW::CmFreeLook_1()
{
  SwitchACVPVPMode(cvpFreeLook,strFreeLook,miFreeLook,idsFreeLook,TMoney::did_1_00);
}
//*******************************************************************
void TACVPGameFW::CeFreeLook_1(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->FreeLookEnb[TMoney::did_1_00],
                  idsFreeLook);
}
//*******************************************************************
void TACVPGameFW::CmFreeLook_1000()
{
  SwitchACVPVPMode(cvpFreeLook,strFreeLook,miFreeLook,idsFreeLook,TMoney::did_1000_00);
}
//*******************************************************************
void TACVPGameFW::CeFreeLook_1000(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->FreeLookEnb[TMoney::did_1000_00],
                  idsFreeLook);
}
//*******************************************************************
void TACVPGameFW::CmGamblersEdge_Def()
{
  SwitchVPModeDefDenom(cvpGamblersEdge,strGamblersEdge,miGamblersEdge,idsGamblersEdge);
}
//*******************************************************************
void TACVPGameFW::CmGamblersEdge_100()
{
  SwitchACVPVPMode(cvpGamblersEdge,strGamblersEdge,miGamblersEdge,idsGamblersEdge,TMoney::did_100_00);
}
//*******************************************************************
void TACVPGameFW::CeGamblersEdge_100(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->GamblersEdgeEnb[TMoney::did_100_00],
                  idsGamblersEdge);
}
//*******************************************************************
void TACVPGameFW::CmGamblersEdge_500()
{
  SwitchACVPVPMode(cvpGamblersEdge,strGamblersEdge,miGamblersEdge,idsGamblersEdge,TMoney::did_500_00);
}
//*******************************************************************
void TACVPGameFW::CeGamblersEdge_500(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->GamblersEdgeEnb[TMoney::did_500_00],
                  idsGamblersEdge);
}
//*******************************************************************
void TACVPGameFW::CmGamblersEdge_1000()
{
  SwitchACVPVPMode(cvpGamblersEdge,strGamblersEdge,miGamblersEdge,idsGamblersEdge,TMoney::did_1000_00);
}
//*******************************************************************
void TACVPGameFW::CeGamblersEdge_1000(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->GamblersEdgeEnb[TMoney::did_1000_00],
                  idsGamblersEdge);
}
//*******************************************************************
void TACVPGameFW::CmHeartBonus_Def()
{
  SwitchVPModeDefDenom(cvpHeartBonus,strHeartBonus,miHeartBonus,idsHeartBonus);
}
//*******************************************************************
void TACVPGameFW::CmHeartBonus_5c()
{
  SwitchACVPVPMode(cvpHeartBonus,strHeartBonus,miHeartBonus,idsHeartBonus,TMoney::did_0_05);
}
//*******************************************************************
void TACVPGameFW::CeHeartBonus_5c(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->HeartBonusEnb[TMoney::did_0_05],
                  idsHeartBonus);
}
//*******************************************************************
void TACVPGameFW::CmHeartBonus_10c()
{
  SwitchACVPVPMode(cvpHeartBonus,strHeartBonus,miHeartBonus,idsHeartBonus,TMoney::did_0_10);
}
//*******************************************************************
void TACVPGameFW::CeHeartBonus_10c(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->HeartBonusEnb[TMoney::did_0_10],
                  idsHeartBonus);
}
//*******************************************************************
void TACVPGameFW::CmHeartBonus_25c()
{
  SwitchACVPVPMode(cvpHeartBonus,strHeartBonus,miHeartBonus,idsHeartBonus,TMoney::did_0_25);
}
//*******************************************************************
void TACVPGameFW::CeHeartBonus_25c(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->HeartBonusEnb[TMoney::did_0_25],
                  idsHeartBonus);
}
//*******************************************************************
void TACVPGameFW::CmHeartBonus_1()
{
  SwitchACVPVPMode(cvpHeartBonus,strHeartBonus,miHeartBonus,idsHeartBonus,TMoney::did_1_00);
}
//*******************************************************************
void TACVPGameFW::CeHeartBonus_1(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->HeartBonusEnb[TMoney::did_1_00],
                  idsHeartBonus);
}
//*******************************************************************
void TACVPGameFW::CmJacksOrBetterProg_Def()
{
  SwitchVPModeDefDenom(cvpJacksProgII,strJacksOrBetterProg,miJacksOrBetterProg,idsJacksOrBetterProg);
}
//*******************************************************************
void TACVPGameFW::CmJacksOrBetterProg_10c()
{
  SwitchACVPVPMode(cvpJacksProgII,strJacksOrBetterProg,miJacksOrBetterProg,idsJacksOrBetterProg,TMoney::did_0_10);
}
//*******************************************************************
void TACVPGameFW::CeJacksOrBetterProg_10c(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->JacksOrBetterProgEnb[TMoney::did_0_10],
                  idsJacksOrBetterProg);
}
//*******************************************************************
void TACVPGameFW::CmJackOrBetterProg_25c()
{
  SwitchACVPVPMode(cvpJacksProgII,strJacksOrBetterProg,miJacksOrBetterProg,idsJacksOrBetterProg,TMoney::did_0_25);
}
//*******************************************************************
void TACVPGameFW::CeJackOrBetterProg_25c(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->JacksOrBetterProgEnb[TMoney::did_0_25],
                  idsJacksOrBetterProg);
}
//*******************************************************************
void TACVPGameFW::CmJacksOrBetterProg_1()
{
  SwitchACVPVPMode(cvpJacksProgII,strJacksOrBetterProg,miJacksOrBetterProg,idsJacksOrBetterProg,TMoney::did_1_00);
}
//*******************************************************************
void TACVPGameFW::CeJacksOrBetterProg_1(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->JacksOrBetterProgEnb[TMoney::did_1_00],
                  idsJacksOrBetterProg);
}
//*******************************************************************
void TACVPGameFW::CmJacksOrBetterProg_5()
{
  SwitchACVPVPMode(cvpJacksProgII,strJacksOrBetterProg,miJacksOrBetterProg,idsJacksOrBetterProg,TMoney::did_5_00);
}
//*******************************************************************
void TACVPGameFW::CeJacksOrBetterProg_5(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->JacksOrBetterProgEnb[TMoney::did_5_00],
                  idsJacksOrBetterProg);
}
//*******************************************************************
void TACVPGameFW::CmJacksOrBetterProg_50()
{
  SwitchACVPVPMode(cvpJacksProgII,strJacksOrBetterProg,miJacksOrBetterProg,idsJacksOrBetterProg,TMoney::did_50_00);
}
//*******************************************************************
void TACVPGameFW::CeJacksOrBetterProg_50(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->JacksOrBetterProgEnb[TMoney::did_50_00],
                  idsJacksOrBetterProg);
}
//*******************************************************************
void TACVPGameFW::CmJackpotBonus_Def()
{
  SwitchVPModeDefDenom(cvpJackpotBonus,strJackpotBonus,miJackpotBonus,idsJackpotBonus);
}
//*******************************************************************
void TACVPGameFW::CmJackpotBonus_1()
{
  SwitchACVPVPMode(cvpJackpotBonus,strJackpotBonus,miJackpotBonus,idsJackpotBonus,TMoney::did_1_00);
}
//*******************************************************************
void TACVPGameFW::CeJackpotBonus_1(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->JackpotBonusEnb[TMoney::did_1_00],
                  idsJackpotBonus);
}
//*******************************************************************
void TACVPGameFW::CmJacksOrBetter96_Def()
{
  SwitchVPModeDefDenom(cvp96JacksOrBetterII,strJacksOrBetter96,miJacksOrBetter96,idsJacksOrBetter96);
}
//*******************************************************************
void TACVPGameFW::CmJacksOrBetter96_25c()
{
  SwitchACVPVPMode(cvp96JacksOrBetterII,strJacksOrBetter96,miJacksOrBetter96,idsJacksOrBetter96,TMoney::did_0_25);
}
//*******************************************************************
void TACVPGameFW::CeJacksOrBetter96_25c(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->JacksOrBetter96Enb[TMoney::did_0_25],
                  idsJacksOrBetter96);
}
//*******************************************************************
void TACVPGameFW::CmJacksOrBetter96_1()
{
  SwitchACVPVPMode(cvp96JacksOrBetterII,strJacksOrBetter96,miJacksOrBetter96,idsJacksOrBetter96,TMoney::did_1_00);
}
//*******************************************************************
void TACVPGameFW::CeJacksOrBetter96_1(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->JacksOrBetter96Enb[TMoney::did_1_00],
                  idsJacksOrBetter96);
}
//*******************************************************************
void TACVPGameFW::CmJacksOrBetter96_5()
{
  SwitchACVPVPMode(cvp96JacksOrBetterII,strJacksOrBetter96,miJacksOrBetter96,idsJacksOrBetter96,TMoney::did_5_00);
}
//*******************************************************************
void TACVPGameFW::CeJacksOrBetter96_5(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->JacksOrBetter96Enb[TMoney::did_5_00],
                  idsJacksOrBetter96);
}
//*******************************************************************
void TACVPGameFW::CmJacksOrBetter96_50()
{
  SwitchACVPVPMode(cvp96JacksOrBetterII,strJacksOrBetter96,miJacksOrBetter96,idsJacksOrBetter96,TMoney::did_50_00);
}
//*******************************************************************
void TACVPGameFW::CeJacksOrBetter96_50(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->JacksOrBetter96Enb[TMoney::did_50_00],
                  idsJacksOrBetter96);
}
//*******************************************************************
void TACVPGameFW::CmJacksOrBetter96_100()
{
  SwitchACVPVPMode(cvp96JacksOrBetterII,strJacksOrBetter96,miJacksOrBetter96,idsJacksOrBetter96,TMoney::did_100_00);
}
//*******************************************************************
void TACVPGameFW::CeJacksOrBetter96_100(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->JacksOrBetter96Enb[TMoney::did_100_00],
                  idsJacksOrBetter96);
}
//*******************************************************************
void TACVPGameFW::CmJacksOrBetter96_500()
{
  SwitchACVPVPMode(cvp96JacksOrBetterII,strJacksOrBetter96,miJacksOrBetter96,idsJacksOrBetter96,TMoney::did_500_00);
}
//*******************************************************************
void TACVPGameFW::CeJacksOrBetter96_500(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->JacksOrBetter96Enb[TMoney::did_500_00],
                  idsJacksOrBetter96);
}
//*******************************************************************
void TACVPGameFW::CmJacksOrBetter96_1000()
{
  SwitchACVPVPMode(cvp96JacksOrBetterII,strJacksOrBetter96,miJacksOrBetter96,idsJacksOrBetter96,TMoney::did_1000_00);
}
//*******************************************************************
void TACVPGameFW::CeJacksOrBetter96_1000(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->JacksOrBetter96Enb[TMoney::did_1000_00],
                  idsJacksOrBetter96);
}
//*******************************************************************
void TACVPGameFW::CmJacksOrBetter85_Def()
{
  SwitchVPModeDefDenom(cvp85JacksOrBetter,strJacksOrBetter85,miJacksOrBetter85,idsJacksOrBetter85);
}
//*******************************************************************
void TACVPGameFW::CmJacksOrBetter85_5c()
{
  SwitchACVPVPMode(cvp85JacksOrBetter,strJacksOrBetter85,miJacksOrBetter85,idsJacksOrBetter85,TMoney::did_0_05);
}
//*******************************************************************
void TACVPGameFW::CeJacksOrBetter85_5c(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->JacksOrBetter85Enb[TMoney::did_0_05],
                  idsJacksOrBetter85);
}
//*******************************************************************
void TACVPGameFW::CmJacksOrBetter85_10c()
{
  SwitchACVPVPMode(cvp85JacksOrBetter,strJacksOrBetter85,miJacksOrBetter85,idsJacksOrBetter85,TMoney::did_0_10);
}
//*******************************************************************
void TACVPGameFW::CeJacksOrBetter85_10c(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->JacksOrBetter85Enb[TMoney::did_0_10],
                  idsJacksOrBetter85);
}
//*******************************************************************
void TACVPGameFW::CmJacksOrBetter85_25c()
{
  SwitchACVPVPMode(cvp85JacksOrBetter,strJacksOrBetter85,miJacksOrBetter85,idsJacksOrBetter85,TMoney::did_0_25);
}
//*******************************************************************
void TACVPGameFW::CeJacksOrBetter85_25c(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->JacksOrBetter85Enb[TMoney::did_0_25],
                  idsJacksOrBetter85);
}
//*******************************************************************
void TACVPGameFW::CmJacksOrBetter85_1()
{
  SwitchACVPVPMode(cvp85JacksOrBetter,strJacksOrBetter85,miJacksOrBetter85,idsJacksOrBetter85,TMoney::did_1_00);
}
//*******************************************************************
void TACVPGameFW::CeJacksOrBetter85_1(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->JacksOrBetter85Enb[TMoney::did_1_00],
                  idsJacksOrBetter85);
}
//*******************************************************************
void TACVPGameFW::CmJacksOrBetter85_5()
{
  SwitchACVPVPMode(cvp85JacksOrBetter,strJacksOrBetter85,miJacksOrBetter85,idsJacksOrBetter85,TMoney::did_5_00);
}
//*******************************************************************
void TACVPGameFW::CeJacksOrBetter85_5(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->JacksOrBetter85Enb[TMoney::did_5_00],
                  idsJacksOrBetter85);
}
//*******************************************************************
void TACVPGameFW::CmJacksOrBetter85_10()
{
  SwitchACVPVPMode(cvp85JacksOrBetter,strJacksOrBetter85,miJacksOrBetter85,idsJacksOrBetter85,TMoney::did_10_00);
}
//*******************************************************************
void TACVPGameFW::CeJacksOrBetter85_10(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->JacksOrBetter85Enb[TMoney::did_10_00],
                  idsJacksOrBetter85);
}
//*******************************************************************
void TACVPGameFW::CmJacksOrBetter85_25()
{
  SwitchACVPVPMode(cvp85JacksOrBetter,strJacksOrBetter85,miJacksOrBetter85,idsJacksOrBetter85,TMoney::did_25_00);
}
//*******************************************************************
void TACVPGameFW::CeJacksOrBetter85_25(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->JacksOrBetter85Enb[TMoney::did_25_00],
                  idsJacksOrBetter85);
}
//*******************************************************************
void TACVPGameFW::CmJacksOrBetter85_50()
{
  SwitchACVPVPMode(cvp85JacksOrBetter,strJacksOrBetter85,miJacksOrBetter85,idsJacksOrBetter85,TMoney::did_50_00);
}
//*******************************************************************
void TACVPGameFW::CeJacksOrBetter85_50(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->JacksOrBetter85Enb[TMoney::did_50_00],
                  idsJacksOrBetter85);
}
//*******************************************************************
void TACVPGameFW::CmJacksOrBetter85_100()
{
  SwitchACVPVPMode(cvp85JacksOrBetter,strJacksOrBetter85,miJacksOrBetter85,idsJacksOrBetter85,TMoney::did_100_00);
}
//*******************************************************************
void TACVPGameFW::CeJacksOrBetter85_100(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->JacksOrBetter85Enb[TMoney::did_100_00],
                  idsJacksOrBetter85);
}
//*******************************************************************
void TACVPGameFW::CmJacksOrBetter85_500()
{
  SwitchACVPVPMode(cvp85JacksOrBetter,strJacksOrBetter85,miJacksOrBetter85,idsJacksOrBetter85,TMoney::did_500_00);
}
//*******************************************************************
void TACVPGameFW::CeJacksOrBetter85_500(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->JacksOrBetter85Enb[TMoney::did_500_00],
                  idsJacksOrBetter85);
}
//*******************************************************************
void TACVPGameFW::CmJacksOrBetter85_1000()
{
  SwitchACVPVPMode(cvp85JacksOrBetter,strJacksOrBetter85,miJacksOrBetter85,idsJacksOrBetter85,TMoney::did_1000_00);
}
//*******************************************************************
void TACVPGameFW::CeJacksOrBetter85_1000(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->JacksOrBetter85Enb[TMoney::did_1000_00],
                  idsJacksOrBetter85);
}
//*******************************************************************
void TACVPGameFW::CmJacksOrBetterDNothing_Def()
{
  SwitchVPModeDefDenom(cvpDJacksOrBetter,
                       strJacksOrBetterDNothing,
                       miJacksOrBetterDNothing,
                       idsJacksOrBetterDNothing);
}
//*******************************************************************
void TACVPGameFW::CmJacksOrBetterDNothing_25c()
{
  SwitchACVPVPMode(cvpDJacksOrBetter,
                   strJacksOrBetterDNothing,
                   miJacksOrBetterDNothing,
                   idsJacksOrBetterDNothing,
                   TMoney::did_0_25);
}
//*******************************************************************
void TACVPGameFW::CeJacksOrBetterDNothing_25c(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->JacksOrBetterDNothingEnb[TMoney::did_0_25],
                  idsJacksOrBetterDNothing);
}
//*******************************************************************
void TACVPGameFW::CmJacksOrBetterDNothing_1()
{
   SwitchACVPVPMode(cvpDJacksOrBetter,
                    strJacksOrBetterDNothing,
                    miJacksOrBetterDNothing,
                    idsJacksOrBetterDNothing,
                    TMoney::did_1_00);
}
//*******************************************************************
void TACVPGameFW::CeJacksOrBetterDNothing_1(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->JacksOrBetterDNothingEnb[TMoney::did_1_00],
                  idsJacksOrBetterDNothing);
}
//*******************************************************************
void TACVPGameFW::CmJacksOrBetterDNothing_5()
{
  SwitchACVPVPMode(cvpDJacksOrBetter,
                   strJacksOrBetterDNothing,
                   miJacksOrBetterDNothing,
                   idsJacksOrBetterDNothing,
                   TMoney::did_5_00);
}
//*******************************************************************
void TACVPGameFW::CeJacksOrBetterDNothing_5(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->JacksOrBetterDNothingEnb[TMoney::did_5_00],
                  idsJacksOrBetterDNothing);
}
//*******************************************************************
void TACVPGameFW::CmJacksOrBetterDNothing_25()
{
  SwitchACVPVPMode(cvpDJacksOrBetter,
                   strJacksOrBetterDNothing,
                   miJacksOrBetterDNothing,
                   idsJacksOrBetterDNothing,
                   TMoney::did_25_00);
}
//*******************************************************************
void TACVPGameFW::CeJacksOrBetterDNothing_25(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->JacksOrBetterDNothingEnb[TMoney::did_25_00],
                  idsJacksOrBetterDNothing);
}
//*******************************************************************
void TACVPGameFW::CmJacksOrBetterDNothing_100()
{
  SwitchACVPVPMode(cvpDJacksOrBetter,
                   strJacksOrBetterDNothing,
                   miJacksOrBetterDNothing,
                   idsJacksOrBetterDNothing,
                   TMoney::did_100_00);
}
//*******************************************************************
void TACVPGameFW::CeJacksOrBetterDNothing_100(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->JacksOrBetterDNothingEnb[TMoney::did_100_00],
                  idsJacksOrBetterDNothing);
}
//*******************************************************************
void TACVPGameFW::CmJokersWildProg_Def()
{
  SwitchVPModeDefDenom(cvpJokersWildProg,
                       strJokersWildProg,
                       miJokersWildProg,
                       idsJokersWildProg);
}
//*******************************************************************
void TACVPGameFW::CmJokersWildProg_5c()
{
  SwitchACVPVPMode(cvpJokersWildProg,
                   strJokersWildProg,
                   miJokersWildProg,
                   idsJokersWildProg,
                   TMoney::did_0_05);
}
//*******************************************************************
void TACVPGameFW::CeJokersWildProg_5c(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->JokersWildProgEnb[TMoney::did_0_05],
                  idsJokersWildProg);
}
//*******************************************************************
void TACVPGameFW::CmJokersWildProg_25c()
{
  SwitchACVPVPMode(cvpJokersWildProg,
                   strJokersWildProg,
                   miJokersWildProg,
                   idsJokersWildProg,
                   TMoney::did_0_25);
}
//*******************************************************************
void TACVPGameFW::CeJokersWildProg_25c(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->JokersWildProgEnb[TMoney::did_0_25],
                  idsJokersWildProg);
}
//*******************************************************************
void TACVPGameFW::CmJokersWildProg_1()
{
  SwitchACVPVPMode(cvpJokersWildProg,
                   strJokersWildProg,
                   miJokersWildProg,
                   idsJokersWildProg,
                   TMoney::did_1_00);
}
//*******************************************************************
void TACVPGameFW::CeJokersWildProg_1(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->JokersWildProgEnb[TMoney::did_1_00],
                  idsJokersWildProg);
}
//*******************************************************************
void TACVPGameFW::CmJokersWildProg_100()
{
  SwitchACVPVPMode(cvpJokersWildProg,
                   strJokersWildProg,
                   miJokersWildProg,
                   idsJokersWildProg,
                   TMoney::did_100_00);
}
//*******************************************************************
void TACVPGameFW::CeJokersWildProg_100(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->JokersWildProgEnb[TMoney::did_100_00],
                  idsJokersWildProg);
}
//*******************************************************************
void TACVPGameFW::CmJumpinJokers_Def()
{
  SwitchVPModeDefDenom(cvpJumpinJokers,
                       strJumpinJokers,
                       miJumpinJokers,
                       idsJumpinJokers);
}
//*******************************************************************
void TACVPGameFW::CmJumpinJokers_5()
{
  SwitchACVPVPMode(cvpJumpinJokers,
                   strJumpinJokers,
                   miJumpinJokers,
                   idsJumpinJokers,
                   TMoney::did_5_00);
}
//*******************************************************************
void TACVPGameFW::CeJumpinJokers_5(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->JumpinJokersEnb[TMoney::did_5_00],
                  idsJumpinJokers);
}
//*******************************************************************
void TACVPGameFW::CmJumpinJokers_50()
{
  SwitchACVPVPMode(cvpJumpinJokers,
                   strJumpinJokers,
                   miJumpinJokers,
                   idsJumpinJokers,
                   TMoney::did_50_00);
}
//*******************************************************************
void TACVPGameFW::CeJumpinJokers_50(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->JumpinJokersEnb[TMoney::did_50_00],
                  idsJumpinJokers);
}
//*******************************************************************
void TACVPGameFW::CmTripleProg_Def()
{
  SwitchVPModeDefDenom(cvpTripleProg,
                       strTripleProg,
                       miTripleProg,
                       idsTripleProg);
}
//*******************************************************************
void TACVPGameFW::CmTripleProg_5c()
{
  SwitchACVPVPMode(cvpTripleProg,
                   strTripleProg,
                   miTripleProg,
                   idsTripleProg,
                   TMoney::did_0_05);
}
//*******************************************************************
void TACVPGameFW::CeTripleProg_5c(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->TripleProgEnb[TMoney::did_0_05],
                  idsTripleProg);
}
//*******************************************************************
void TACVPGameFW::CmTripleProg_25c()
{
  SwitchACVPVPMode(cvpTripleProg,
                   strTripleProg,
                   miTripleProg,
                   idsTripleProg,
                   TMoney::did_0_25);
}
//*******************************************************************
void TACVPGameFW::CeTripleProg_25c(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->TripleProgEnb[TMoney::did_0_25],
                  idsTripleProg);
}
//*******************************************************************
void TACVPGameFW::CmTripleProg_1()
{
  SwitchACVPVPMode(cvpTripleProg,
                   strTripleProg,
                   miTripleProg,
                   idsTripleProg,
                   TMoney::did_1_00);
}
//*******************************************************************
void TACVPGameFW::CeTripleProg_1(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->TripleProgEnb[TMoney::did_1_00],
                  idsTripleProg);
}
//*******************************************************************
void TACVPGameFW::CmTripleProg_10()
{
  SwitchACVPVPMode(cvpTripleProg,
                   strTripleProg,
                   miTripleProg,
                   idsTripleProg,
                   TMoney::did_10_00);
}
//*******************************************************************
void TACVPGameFW::CeTripleProg_10(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->TripleProgEnb[TMoney::did_10_00],
                  idsTripleProg);
}
//*******************************************************************
void TACVPGameFW::CmRoyalsProg_Def()
{
  SwitchVPModeDefDenom(cvpRoyalProg,
                       strRoyalsProg,
                       miRoyalsProg,
                       idsRoyalsProg);
}
//*******************************************************************
void TACVPGameFW::CmRoyalsProg_10c()
{
  SwitchACVPVPMode(cvpRoyalProg,
                   strRoyalsProg,
                   miRoyalsProg,
                   idsRoyalsProg,
                   TMoney::did_0_10);
}
//*******************************************************************
void TACVPGameFW::CeRoyalsProg_10c(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->RoyalsProgEnb[TMoney::did_0_10],
                  idsRoyalsProg);
}
//*******************************************************************
void TACVPGameFW::CmRoyalsProg_1()
{
  SwitchACVPVPMode(cvpRoyalProg,
                   strRoyalsProg,
                   miRoyalsProg,
                   idsRoyalsProg,
                   TMoney::did_1_00);
}
//*******************************************************************
void TACVPGameFW::CeRoyalsProg_1(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->RoyalsProgEnb[TMoney::did_1_00],
                  idsRoyalsProg);
}
//*******************************************************************
void TACVPGameFW::CmRoyalsProg_25()
{
  SwitchACVPVPMode(cvpRoyalProg,
                   strRoyalsProg,
                   miRoyalsProg,
                   idsRoyalsProg,
                   TMoney::did_25_00);
}
//*******************************************************************
void TACVPGameFW::CeRoyalsProg_25(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->RoyalsProgEnb[TMoney::did_25_00],
                  idsRoyalsProg);
}   //*******************************************************************
void TACVPGameFW::CmPowerHouseProg_Def()
{
  SwitchVPModeDefDenom(cvpPowerProg,
                       strPowerHouseProg,
                       miPowerHouseProg,
                       idsPowerHouseProg);
}
//*******************************************************************
void TACVPGameFW::CmPowerHouseProg_25c()
{
  SwitchACVPVPMode(cvpPowerProg,
                   strPowerHouseProg,
                   miPowerHouseProg,
                   idsPowerHouseProg,
                   TMoney::did_0_25);
}
//*******************************************************************
void TACVPGameFW::CePowerHouseProg_25c(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->PowerHouseProgEnb[TMoney::did_0_25],
                  idsPowerHouseProg);
}
//*******************************************************************
void TACVPGameFW::CmPowerHouseProg_1()
{
  SwitchACVPVPMode(cvpPowerProg,
                   strPowerHouseProg,
                   miPowerHouseProg,
                   idsPowerHouseProg,
                   TMoney::did_1_00);
}
//*******************************************************************
void TACVPGameFW::CePowerHouseProg_1(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->PowerHouseProgEnb[TMoney::did_1_00],
                  idsPowerHouseProg);
}
//*******************************************************************
void TACVPGameFW::CmPowerHouseProg_50()
{
  SwitchACVPVPMode(cvpPowerProg,
                   strPowerHouseProg,
                   miPowerHouseProg,
                   idsPowerHouseProg,
                   TMoney::did_50_00);
}
//*******************************************************************
void TACVPGameFW::CePowerHouseProg_50(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->PowerHouseProgEnb[TMoney::did_50_00],
                  idsPowerHouseProg);
}
//*******************************************************************
void TACVPGameFW::CmRaiseDrawJokerPoker_Def()
{
  SwitchVPModeDefDenom(cvpRaiseJokersWild,
                       strRaiseDrawJokerPoker,
                       miRaiseDrawJokerPoker,
                       idsRaiseDrawJokerPoker);
}
//*******************************************************************
void TACVPGameFW::CmRaiseDrawJokerPoker_25c()
{
  SwitchACVPVPMode(cvpRaiseJokersWild,
                   strRaiseDrawJokerPoker,
                   miRaiseDrawJokerPoker,
                   idsRaiseDrawJokerPoker,
                   TMoney::did_0_25);
}
//*******************************************************************
void TACVPGameFW::CeRaiseDrawJokerPoker_25c(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->RaiseDrawJokerPokerEnb[TMoney::did_0_25],
                  idsRaiseDrawJokerPoker);
}
//*******************************************************************
void TACVPGameFW::CmRaiseDrawJokerPoker_1()
{
  SwitchACVPVPMode(cvpRaiseJokersWild,
                   strRaiseDrawJokerPoker,
                   miRaiseDrawJokerPoker,
                   idsRaiseDrawJokerPoker,
                   TMoney::did_1_00);
}
//*******************************************************************
void TACVPGameFW::CeRaiseDrawJokerPoker_1(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->RaiseDrawJokerPokerEnb[TMoney::did_1_00],
                  idsRaiseDrawJokerPoker);
}
//*******************************************************************
void TACVPGameFW::CmRaiseDrawJokerPoker_10()
{
  SwitchACVPVPMode(cvpRaiseJokersWild,
                   strRaiseDrawJokerPoker,
                   miRaiseDrawJokerPoker,
                   idsRaiseDrawJokerPoker,
                   TMoney::did_10_00);
}
//*******************************************************************
void TACVPGameFW::CeRaiseDrawJokerPoker_10(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->RaiseDrawJokerPokerEnb[TMoney::did_10_00],
                  idsRaiseDrawJokerPoker);
}
//*******************************************************************
void TACVPGameFW::CmRaiseDrawJokerPoker_100()
{
  SwitchACVPVPMode(cvpRaiseJokersWild,
                   strRaiseDrawJokerPoker,
                   miRaiseDrawJokerPoker,
                   idsRaiseDrawJokerPoker,
                   TMoney::did_100_00);
}
//*******************************************************************
void TACVPGameFW::CeRaiseDrawJokerPoker_100(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->RaiseDrawJokerPokerEnb[TMoney::did_100_00],
                  idsRaiseDrawJokerPoker);
}
//*******************************************************************
void TACVPGameFW::CmRaiseDrawJokerPoker_500()
{
  SwitchACVPVPMode(cvpRaiseJokersWild,
                   strRaiseDrawJokerPoker,
                   miRaiseDrawJokerPoker,
                   idsRaiseDrawJokerPoker,
                   TMoney::did_500_00);
}
//*******************************************************************
void TACVPGameFW::CeRaiseDrawJokerPoker_500(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->RaiseDrawJokerPokerEnb[TMoney::did_500_00],
                  idsRaiseDrawJokerPoker);
}
//*******************************************************************
void TACVPGameFW::CmSpadeBonus_Def()
{
  SwitchVPModeDefDenom(cvpSpadeBonus,
                       strSpadeBonus,
                       miSpadeBonus,
                       idsSpadeBonus);
}
//*******************************************************************
void TACVPGameFW::CmSpadeBonus_5c()
{
  SwitchACVPVPMode(cvpSpadeBonus,
                   strSpadeBonus,
                   miSpadeBonus,
                   idsSpadeBonus,
                   TMoney::did_0_05);
}
//*******************************************************************
void TACVPGameFW::CeSpadeBonus_5c(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->SpadeBonusEnb[TMoney::did_0_05],
                  idsSpadeBonus);
}
//*******************************************************************
void TACVPGameFW::CmSpadeBonus_25c()
{
  SwitchACVPVPMode(cvpSpadeBonus,
                   strSpadeBonus,
                   miSpadeBonus,
                   idsSpadeBonus,
                   TMoney::did_0_25);
}
//*******************************************************************
void TACVPGameFW::CeSpadeBonus_25c(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->SpadeBonusEnb[TMoney::did_0_25],
                  idsSpadeBonus);
}
//*******************************************************************
void TACVPGameFW::CmSpadeBonus_5()
{
  SwitchACVPVPMode(cvpSpadeBonus,
                   strSpadeBonus,
                   miSpadeBonus,
                   idsSpadeBonus,
                   TMoney::did_5_00);
}
//*******************************************************************
void TACVPGameFW::CeSpadeBonus_5(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->SpadeBonusEnb[TMoney::did_5_00],
                  idsSpadeBonus);
}
//*******************************************************************
void TACVPGameFW::CmSuperDJackpot_Def()
{
  SwitchVPModeDefDenom(cvpSuperDJackpot,
                       strSuperDJackpot,
                       miSuperDJackpot,
                       idsSuperDJackpot);
}
//*******************************************************************
void TACVPGameFW::CmSuperDJackpot_25c()
{
  SwitchACVPVPMode(cvpSuperDJackpot,
                   strSuperDJackpot,
                   miSuperDJackpot,
                   idsSuperDJackpot,
                   TMoney::did_0_25);
}
//*******************************************************************
void TACVPGameFW::CeSuperDJackpot_25c(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->SuperDJackpotEnb[TMoney::did_0_25],
                  idsSuperDJackpot);
}
//*******************************************************************
void TACVPGameFW::CmSuperDJackpot_1()
{
  SwitchACVPVPMode(cvpSuperDJackpot,
                   strSuperDJackpot,
                   miSuperDJackpot,
                   idsSuperDJackpot,
                   TMoney::did_1_00);
}
//*******************************************************************
void TACVPGameFW::CeSuperDJackpot_1(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->SuperDJackpotEnb[TMoney::did_1_00],
                  idsSuperDJackpot);
}
//*******************************************************************
void TACVPGameFW::CmSuperDJackpot_100()
{
  SwitchACVPVPMode(cvpSuperDJackpot,
                   strSuperDJackpot,
                   miSuperDJackpot,
                   idsSuperDJackpot,
                   TMoney::did_100_00);
}
//*******************************************************************
void TACVPGameFW::CeSuperDJackpot_100(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->SuperDJackpotEnb[TMoney::did_100_00],
                  idsSuperDJackpot);
}
//*******************************************************************
void TACVPGameFW::CmSevensWild1Joker_Def()
{
  SwitchVPModeDefDenom(cvp7Wild1Joker,
                       strSevensWild1Joker,
                       miSevensWild1Joker,
                       idsSevensWild1Joker);
}
//*******************************************************************
void TACVPGameFW::CmSevensWild1Joker_5()
{
  SwitchACVPVPMode(cvp7Wild1Joker,
                   strSevensWild1Joker,
                   miSevensWild1Joker,
                   idsSevensWild1Joker,
                   TMoney::did_5_00);
}
//*******************************************************************
void TACVPGameFW::CeSevensWild1Joker_5(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->SevensWild1JokerEnb[TMoney::did_5_00],
                  idsSevensWild1Joker);
}
//*******************************************************************
void TACVPGameFW::CmSevensWild1Joker_25()
{
  SwitchACVPVPMode(cvp7Wild1Joker,
                   strSevensWild1Joker,
                   miSevensWild1Joker,
                   idsSevensWild1Joker,
                   TMoney::did_25_00);
}
//*******************************************************************
void TACVPGameFW::CeSevensWild1Joker_25(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->SevensWild1JokerEnb[TMoney::did_25_00],
                  idsSevensWild1Joker);
}
//*******************************************************************
void TACVPGameFW::CmSevensWild1Joker_1000()
{
  SwitchACVPVPMode(cvp7Wild1Joker,
                   strSevensWild1Joker,
                   miSevensWild1Joker,
                   idsSevensWild1Joker,
                   TMoney::did_1000_00);
}
//*******************************************************************
void TACVPGameFW::CeSevensWild1Joker_1000(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->SevensWild1JokerEnb[TMoney::did_1000_00],
                  idsSevensWild1Joker);
}
//*******************************************************************
void TACVPGameFW::CmTensOrBetter_Def()
{
  SwitchVPModeDefDenom(cvpTensOrBetterII,strTensOrBetter,miTensOrBetter,idsTensOrBetter);
}
//*******************************************************************
void TACVPGameFW::CmTensOrBetter_5c()
{
  SwitchACVPVPMode(cvpTensOrBetterII,strTensOrBetter,miTensOrBetter,idsTensOrBetter,TMoney::did_0_05);
}
//*******************************************************************
void TACVPGameFW::CeTensOrBetter_5c(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->TensOrBetterEnb[TMoney::did_0_05],
                  idsTensOrBetter);
}
//*******************************************************************
void TACVPGameFW::CmTensOrBetter_10c()
{
  SwitchACVPVPMode(cvpTensOrBetterII,strTensOrBetter,miTensOrBetter,idsTensOrBetter,TMoney::did_0_10);
}
//*******************************************************************
void TACVPGameFW::CeTensOrBetter_10c(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->TensOrBetterEnb[TMoney::did_0_10],
                  idsTensOrBetter);
}
//*******************************************************************
void TACVPGameFW::CmTensOrBetter_25c()
{
  SwitchACVPVPMode(cvpTensOrBetterII,strTensOrBetter,miTensOrBetter,idsTensOrBetter,TMoney::did_0_25);
}
//*******************************************************************
void TACVPGameFW::CeTensOrBetter_25c(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->TensOrBetterEnb[TMoney::did_0_25],
                  idsTensOrBetter);
}
//*******************************************************************
void TACVPGameFW::CmTensOrBetter_1()
{
  SwitchACVPVPMode(cvpTensOrBetterII,strTensOrBetter,miTensOrBetter,idsTensOrBetter,TMoney::did_1_00);
}
//*******************************************************************
void TACVPGameFW::CeTensOrBetter_1(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->TensOrBetterEnb[TMoney::did_1_00],
                  idsTensOrBetter);
}
//*******************************************************************
void TACVPGameFW::CmTensOrBetter_50()
{
  SwitchACVPVPMode(cvpTensOrBetterII,strTensOrBetter,miTensOrBetter,idsTensOrBetter,TMoney::did_50_00);
}
//*******************************************************************
void TACVPGameFW::CeTensOrBetter_50(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->TensOrBetterEnb[TMoney::did_50_00],
                  idsTensOrBetter);
}
//*******************************************************************
void TACVPGameFW::CmTreasureTrove_Def()
{
  SwitchVPModeDefDenom(cvpTreasureTrove,
                       strTreasureTrove,
                       miTreasureTrove,
                       idsTreasureTrove);
}
//*******************************************************************
void TACVPGameFW::CmTreasureTrove_1()
{
  SwitchACVPVPMode(cvpTreasureTrove,
                   strTreasureTrove,
                   miTreasureTrove,
                   idsTreasureTrove,
                   TMoney::did_1_00);
}
//*******************************************************************
void TACVPGameFW::CeTreasureTrove_1(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->TreasureTroveEnb[TMoney::did_1_00],
                  idsTreasureTrove);
}
//*******************************************************************
void TACVPGameFW::CmTreasureTrove_100()
{
  SwitchACVPVPMode(cvpTreasureTrove,
                   strTreasureTrove,
                   miTreasureTrove,
                   idsTreasureTrove,
                   TMoney::did_100_00);
}
//*******************************************************************
void TACVPGameFW::CeTreasureTrove_100(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->TreasureTroveEnb[TMoney::did_100_00],
                  idsTreasureTrove);
}
//*******************************************************************
void TACVPGameFW::CmTreasureTrove_1000()
{
  SwitchACVPVPMode(cvpTreasureTrove,
                   strTreasureTrove,
                   miTreasureTrove,
                   idsTreasureTrove,
                   TMoney::did_1000_00);
}
//*******************************************************************
void TACVPGameFW::CeTreasureTrove_1000(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->TreasureTroveEnb[TMoney::did_1000_00],
                  idsTreasureTrove);
}
//*******************************************************************
void TACVPGameFW::CmTriplePlay_Def()
{
  SwitchVPModeDefDenom(cvpTriplePlay,
                       strTriplePlay,
                       miTriplePlay,
                       idsTriplePlay);
}
//*******************************************************************
void TACVPGameFW::CmTriplePlay_25c()
{
  SwitchACVPVPMode(cvpTriplePlay,
                   strTriplePlay,
                   miTriplePlay,
                   idsTriplePlay,
                   TMoney::did_0_25);
}
//*******************************************************************
void TACVPGameFW::CeTriplePlay_25c(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->TriplePlayEnb[TMoney::did_0_25],
                  idsTriplePlay);
}
//*******************************************************************
void TACVPGameFW::CmTriplePlay_1()
{
  SwitchACVPVPMode(cvpTriplePlay,
                   strTriplePlay,
                   miTriplePlay,
                   idsTriplePlay,
                   TMoney::did_1_00);
}
//*******************************************************************
void TACVPGameFW::CeTriplePlay_1(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->TriplePlayEnb[TMoney::did_1_00],
                  idsTriplePlay);
}
//*******************************************************************
void TACVPGameFW::CmTriplePlay_25()
{
  SwitchACVPVPMode(cvpTriplePlay,
                   strTriplePlay,
                   miTriplePlay,
                   idsTriplePlay,
                   TMoney::did_25_00);
}
//*******************************************************************
void TACVPGameFW::CeTriplePlay_25(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->TriplePlayEnb[TMoney::did_25_00],
                  idsTriplePlay);
}
//*******************************************************************
void TACVPGameFW::CmTriplePlay_500()
{
  SwitchACVPVPMode(cvpTriplePlay,
                   strTriplePlay,
                   miTriplePlay,
                   idsTriplePlay,
                   TMoney::did_500_00);
}
//*******************************************************************
void TACVPGameFW::CeTriplePlay_500(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->TriplePlayEnb[TMoney::did_500_00],
                  idsTriplePlay);
}
//*******************************************************************
void TACVPGameFW::CmTripleBonus_Def()
{
  SwitchVPModeDefDenom(cvpTripleBonus,
                       strTripleBonus,
                       miTripleBonus,
                       idsTripleBonus);
}
//*******************************************************************
void TACVPGameFW::CmTripleBonus_25c()
{
  SwitchACVPVPMode(cvpTripleBonus,
                   strTripleBonus,
                   miTripleBonus,
                   idsTripleBonus,
                   TMoney::did_0_25);
}
//*******************************************************************
void TACVPGameFW::CeTripleBonus_25c(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->TripleBonusEnb[TMoney::did_0_25],
                  idsTripleBonus);
}
//*******************************************************************
void TACVPGameFW::CmTripleBonus_50()
{
  SwitchACVPVPMode(cvpTripleBonus,
                   strTripleBonus,
                   miTripleBonus,
                   idsTripleBonus,
                   TMoney::did_50_00);
}
//*******************************************************************
void TACVPGameFW::CeTripleBonus_50(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->TripleBonusEnb[TMoney::did_50_00],
                  idsTripleBonus);
}
//*******************************************************************
void TACVPGameFW::CmWheelDeal_Def()
{
  SwitchVPModeDefDenom(cvpWheelDeal,
                       strWheelDeal,
                       miWheelDeal,
                       idsWheelDeal);
}
//*******************************************************************
void TACVPGameFW::CmWheelDeal_1()
{
  SwitchACVPVPMode(cvpWheelDeal,
                   strWheelDeal,
                   miWheelDeal,
                   idsWheelDeal,
                   TMoney::did_1_00);
}
//*******************************************************************
void TACVPGameFW::CeWheelDeal_1(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->WheelDealEnb[TMoney::did_1_00],
                  idsWheelDeal);
}
//*******************************************************************
void TACVPGameFW::CmWheelDeal_10()
{
  SwitchACVPVPMode(cvpWheelDeal,
                   strWheelDeal,
                   miWheelDeal,
                   idsWheelDeal,
                   TMoney::did_10_00);
}
//*******************************************************************
void TACVPGameFW::CeWheelDeal_10(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->WheelDealEnb[TMoney::did_10_00],
                  idsWheelDeal);
}
//*******************************************************************
void TACVPGameFW::CmWheelDeal_1000()
{
  SwitchACVPVPMode(cvpWheelDeal,
                   strWheelDeal,
                   miWheelDeal,
                   idsWheelDeal,
                   TMoney::did_1000_00);
}
//*******************************************************************
void TACVPGameFW::CeWheelDeal_1000(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->WheelDealEnb[TMoney::did_1000_00],
                  idsWheelDeal);
}
//*******************************************************************
//********************* slots ***************************************
//*******************************************************************
bool TACVPGameFW::SwitchACVPSlotsMode(int16 sgt,string strmodename,int16 mi,int16 ids,int16 did)
//note: assumes enabled already checked before call.
{
  TACVPMenuEnable *pme = GetACVPMenuEnable();
  if (pme == NULL) {return false;}
  if (!TMoney::CheckDenomID(did)) {return false;}
  if (!pme->GetModeEnb(gtSlots,sgt,did)) {return false;}
  pme->SetModes(true);
  TMoney money(TMoney::ctorDenomID,did);
  if (!SwitchModeDenom(ids,money)) //don't set ModeDenom until after call.
  {
    ModeDenom = money;
    pme->Denom = money;
    SwitchGameModes(strmodename);
  }
  pme->SetModeEnb(gtSlots,sgt,did,false);
  return true;
}
//*******************************************************************
bool TACVPGameFW::SwitchSlotsModeDefDenom(int16 sgt,const string &strmode,int16 mi,int16 ids)
{
  TACVPMenuEnable *pme = GetACVPMenuEnable();
  if (pme == NULL) {return false;} //?should show messagebox?

  int16 did = ModeDenom.GetDenomID();
  if (!TMoney::CheckDenomID(did) || did <= TMoney::did_0_00)
  {
    did = TMoney::did_0_25;
  }

  int16 startdid = did;

  //loop thru allowed denoms looking for first good denom going larger
  for (;did < TMoney::did_NumIDs;did++)
  {
    if (pme->GetModeFlags(gtSlots,sgt,did) &&
        SwitchACVPSlotsMode(sgt,strmode,mi,ids,did))
    {
      return true; //found one and switched to it.
    }
  }
  // now trying going smaller
  for (did = startdid;did > TMoney::did_0_00;did--)
  {
    if (pme->GetModeFlags(gtSlots,sgt,did) &&
        SwitchACVPSlotsMode(sgt,strmode,mi,ids,did))
    {
      return true; // found one and switched to it.
    }
  }
  return false;
}
//*******************************************************************
void TACVPGameFW::CmCrystalPalace_Def()
{
  SwitchSlotsModeDefDenom(cslCrystalPalace,strCrystalPalace,miCrystalPalace,idsCrystalPalace);
}
//*******************************************************************
void TACVPGameFW::CmCrystalPalace_25c()
{
  SwitchACVPSlotsMode(cslCrystalPalace,strCrystalPalace,miCrystalPalace,idsCrystalPalace,TMoney::did_0_25);
}
//*******************************************************************
void TACVPGameFW::CeCrystalPalace_25c(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->CrystalPalaceEnb[TMoney::did_0_25],
                  idsCrystalPalace);
}
//*******************************************************************
void TACVPGameFW::CmCrystalPalace_1()
{
  SwitchACVPSlotsMode(cslCrystalPalace,strCrystalPalace,miCrystalPalace,idsCrystalPalace,TMoney::did_1_00);
}
//*******************************************************************
void TACVPGameFW::CeCrystalPalace_1(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->CrystalPalaceEnb[TMoney::did_1_00],
                  idsCrystalPalace);
}
//*******************************************************************
void TACVPGameFW::CmCrystalPalace_10()
{
  SwitchACVPSlotsMode(cslCrystalPalace,strCrystalPalace,miCrystalPalace,idsCrystalPalace,TMoney::did_10_00);
}
//*******************************************************************
void TACVPGameFW::CeCrystalPalace_10(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->CrystalPalaceEnb[TMoney::did_10_00],
                  idsCrystalPalace);
}
//*******************************************************************
void TACVPGameFW::CmCrystalPalace_100()
{
  SwitchACVPSlotsMode(cslCrystalPalace,strCrystalPalace,miCrystalPalace,idsCrystalPalace,TMoney::did_100_00);
}
//*******************************************************************
void TACVPGameFW::CeCrystalPalace_100(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->CrystalPalaceEnb[TMoney::did_100_00],
                  idsCrystalPalace);
}
//*******************************************************************
void TACVPGameFW::CmCrystalPalace_1000()
{
  SwitchACVPSlotsMode(cslCrystalPalace,strCrystalPalace,miCrystalPalace,idsCrystalPalace,TMoney::did_1000_00);
}
//*******************************************************************
void TACVPGameFW::CeCrystalPalace_1000(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->CrystalPalaceEnb[TMoney::did_1000_00],
                  idsCrystalPalace);
}
//*******************************************************************
void TACVPGameFW::CmSuperSevens_Def()
{
  SwitchSlotsModeDefDenom(cslSuperSevens,strSuperSevens,miSuperSevens,idsSuperSevens);
}
//*******************************************************************
void TACVPGameFW::CmSuperSevens_5c()
{
  SwitchACVPSlotsMode(cslSuperSevens,strSuperSevens,miSuperSevens,idsSuperSevens,TMoney::did_0_05);
}
//*******************************************************************
void TACVPGameFW::CeSuperSevens_5c(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->SuperSevensEnb[TMoney::did_0_05],
                  idsSuperSevens);
}
//*******************************************************************
void TACVPGameFW::CmSuperSevens_25c()
{
  SwitchACVPSlotsMode(cslSuperSevens,strSuperSevens,miSuperSevens,idsSuperSevens,TMoney::did_0_25);
}
//*******************************************************************
void TACVPGameFW::CeSuperSevens_25c(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->SuperSevensEnb[TMoney::did_0_25],
                  idsSuperSevens);
}
//*******************************************************************
void TACVPGameFW::CmSuperSevens_1()
{
  SwitchACVPSlotsMode(cslSuperSevens,strSuperSevens,miSuperSevens,idsSuperSevens,TMoney::did_1_00);
}
//*******************************************************************
void TACVPGameFW::CeSuperSevens_1(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->SuperSevensEnb[TMoney::did_1_00],
                  idsSuperSevens);
}
//*******************************************************************
void TACVPGameFW::CmSuperSevens_25()
{
  SwitchACVPSlotsMode(cslSuperSevens,strSuperSevens,miSuperSevens,idsSuperSevens,TMoney::did_25_00);
}
//*******************************************************************
void TACVPGameFW::CeSuperSevens_25(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->SuperSevensEnb[TMoney::did_25_00],
                  idsSuperSevens);
}
//*******************************************************************
void TACVPGameFW::CmSuperSevens_500()
{
  SwitchACVPSlotsMode(cslSuperSevens,strSuperSevens,miSuperSevens,idsSuperSevens,TMoney::did_500_00);
}
//*******************************************************************
void TACVPGameFW::CeSuperSevens_500(TCommandEnabler &ce)
{
  EnableCheckMenu(ce,
                  GetACVPMenuEnable()->SuperSevensEnb[TMoney::did_500_00],
                  idsSuperSevens);
}
//*******************************************************************

