//*******************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//*******************************************************************
//
//       File Name:  acvpaskx.cpp
//    Project Name:  Casino
// Original Author:  Adam K. Krist
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- ---------  ----------  ------------------------------
//  1.0     09/29/95   A. Krist    Original baseline
//  2.0     09/25/97   M.Perry     32-bit conversion.
//*******************************************************************
#include "acvpaskx.h"
#include "acvpglrd.h"
#include "casvpmw.h"
#include "ogamefw.h"
//*******************************************************************
TACVPAsk::TACVPAsk(TACVPVPGLord *pNewVPLord)
{
  pOwnerLord = pNewVPLord;
  ExpertCode = 0;
}
//*******************************************************************
TACVPAsk::~TACVPAsk()
{
}
//*******************************************************************
void TACVPAsk::HoldCards(bool show)
{
  switch (pOwnerLord->SubGameType)
  {
      case cvpFivesUp             : AskHoldFivesUp();           break;
      case cvpBonusDeluxe         : AskHoldBonusDeluxeP();      break;
      case cvpClubBonus           : AskHoldClubBonus();         break;
      case cvpCrazy8s             : AskHoldCrazy8();            break;
      case cvpDDrawJB             : AskHoldDDrawJacks();        break;
      case cvpDDrawJokerPoker     : AskHoldDDrawJokers();       break;
      case cvpDDownStud           : AskHoldDDownStud();         break;
      case cvpDeucesWildBonus     : AskHold2WildBonus();        break;
      case cvpDeucesWildII        : AskHold2Wild();             break;
      case cvpDeucesWildProg      : AskHold2WildProg();         break;
      case cvpDiamondBonus        : AskHoldDiamondBonus();      break;
      case cvpDBonusPoker         : AskHoldDoubleBonusPoker();  break;
      case cvpFlushAssault        : AskHoldFlushAssault();      break;
      case cvpFreeLook            : AskHoldFreeLook();          break;
      case cvpGamblersEdge        : AskHoldGamblersEdge();      break;
      case cvpHeartBonus          : AskHoldHeartBonus();        break;
      case cvpBlackJacks          : AskHoldBlackJacks();        break;
      case cvpJacksProgII         : AskHoldJacksBetterProg();   break;
      case cvpJackpotBonus        : AskHoldJackpotBonus();      break;
      case cvp96JacksOrBetterII   : AskHoldJacksBetter96();     break;
      case cvpTreasureTrove       : AskHoldTreasureTrove();     break;
      case cvp85JacksOrBetter     : AskHoldJacksBetter85();     break;
      case cvpDJacksOrBetter      : AskHoldJacksBetterDoubleD();break;
      case cvpJokersWildProg      : AskHoldJokerWildProg();     break;
      case cvpJumpinJokers        : AskHoldJumpinJoker();       break;
      case cvpTripleProg          : AskHoldTripProg();          break;
      case cvpRoyalProg           : AskHoldProgRoyals();        break;
      case cvpPowerProg           : AskHoldPowerFullHouse();    break;
      case cvpRaiseJokersWild     : AskHoldRaiseDrawJoker();    break;
      case cvpSpadeBonus          : AskHoldSpadeBonus();        break;
      case cvpSuperDJackpot       : AskHoldSuperDoubleJackpot();break;
      case cvp7Wild1Joker         : AskHoldSevenWildJoker();    break;
      case cvpTensOrBetterII      : AskHoldTensBetter();        break;
      case cvpTriplePlay          : AskHoldTriplePlay();        break;
      case cvpTripleBonus         : AskHoldTripleBonus();       break;
      case cvpWheelDeal           : AskHoldWheelDeal();         break;

		default:                  break;
  }

  if(show)
  {
	 pOwnerLord->PModeWin->GetFW()->DisplayExpert(expertRecomString);
  }
  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand      = 0;
  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highcard      = 0;
  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->toflush       = 0;
  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrght      = 0;
  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrght     = 0;
  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh     = 0;
  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh    = 0;
  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflshsuit     = 0;
  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflshsuit    = 0;
  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->lohighcard    = 0;
  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->lolowcard     = 0;
  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->lohand        = 0;
  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->lowcard       = 0;
  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->wildcount     = 0;
  pOwnerLord->fake->highhand      = 0;
  pOwnerLord->fake->highcard      = 0;
  pOwnerLord->fake->toflush       = 0;
  pOwnerLord->fake->instrght      = 0;
  pOwnerLord->fake->outstrght     = 0;
  pOwnerLord->fake->instrflsh     = 0;
  pOwnerLord->fake->outstrflsh    = 0;
  pOwnerLord->fake->instrflshsuit     = 0;
  pOwnerLord->fake->outstrflshsuit    = 0;
  pOwnerLord->fake->lohighcard    = 0;
  pOwnerLord->fake->lolowcard     = 0;
  pOwnerLord->fake->lohand        = 0;
  pOwnerLord->fake->lowcard       = 0;
  pOwnerLord->fake->wildcount     = 0;

}
//*******************************************************************
void TACVPAsk::AskHoldTens()
{
  pOwnerLord->fake->inhand = 0;
  for(int16 i=0;i<5;i++)
  {
	 pOwnerLord->fake->cards[i].name = pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->cards[i].name;
	 pOwnerLord->fake->cards[i].suit = pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->cards[i].suit;
	 pOwnerLord->fake->inhand++;
  }
  pOwnerLord->pSmarts->Insert_Sort(pOwnerLord->fake);
  pOwnerLord->pSmarts->Holding(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand);
  pOwnerLord->pSmarts->Holding(pOwnerLord->fake);

	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 105)
	 {//royal
		expertRecomString = TAppString(5003);
		ExpertCode = 1;
      return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 99)
	 {
		if(pOwnerLord->fake->cards[4].name == AceHi)
		{
		  expertRecomString = TAppString(5003);
		  ExpertCode =1;
        return;
		}
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 99)
	 {//straight flush
		expertRecomString = TAppString(5006);
		ExpertCode = 1;
      return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 71)
	 {//four o' kind
		expertRecomString = TAppString(5077);
		ExpertCode = 20;
      return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 70)
	 {//full house
		expertRecomString = TAppString(5010);
		ExpertCode = 1;
      return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
		 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh > 3)
	 {// four to a royal
		if(pOwnerLord->fake->cards[1].name > Nine ||
			  (pOwnerLord->fake->cards[2].name > Nine &&
				(pOwnerLord->fake->cards[2].name < pOwnerLord->fake->cards[3].name &&
				 pOwnerLord->fake->cards[3].name < pOwnerLord->fake->cards[4].name) &&
				 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[3].suit &&
				  pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[4].suit)))
		{
		  expertRecomString = TAppString(5009);
		  ExpertCode = 3;
        return;
		}
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 26)
	 { //flush
		expertRecomString = TAppString(5016);
		ExpertCode = 1;
      return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 20)
	 {//three o' kind
		expertRecomString = TAppString(5018);
		ExpertCode = 5;
      return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 23 &&
		 (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 3) )
	 {//straight and four to a straight flush
		expertRecomString = TAppString(5081);
		ExpertCode = 1;
      return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 23)
	 {//straight
		expertRecomString = TAppString(5017);
		ExpertCode = 1;
      return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 3 )
	 {//four to a straight flush
		expertRecomString = TAppString(5019);
		ExpertCode = 4;
      return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 15)
	 {//two pair
		expertRecomString = TAppString(5050);
		ExpertCode = 15;
      return;
	 }
	 if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 10)&&
		  (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrght > 3 ||
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrght  > 3 ))
	 {//four to a straight and a pair
		expertRecomString = TAppString(5028);
		ExpertCode = 16;
      return;
	 }
	 if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 10)&&
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highcard > Nine)
	 {//high pair && 3 to royal
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2 ||
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2 )
		{//three to a royal
		  if((pOwnerLord->fake->cards[0].name > Nine &&
			((pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit &&
           pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit &&
          pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit &&
          pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit &&
          pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit &&
          pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit &&
          pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) )) ||
		  (pOwnerLord->fake->cards[1].name > Nine &&
			((pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[1].suit &&
         pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[1].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[1].suit &&
          pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[1].suit) ||
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[1].suit &&
          pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[1].suit) )) ||
		  (pOwnerLord->fake->cards[2].name > Nine &&
			(pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[2].suit &&
         pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[2].suit)))

		  {
			 expertRecomString = TAppString(5079);
			 ExpertCode = 21;return;
		  }
		}
	 }
	 if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 10)&&
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highcard > Nine)
	 {//high pair
		expertRecomString = TAppString(5083);
		ExpertCode = 21;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2 ||
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2 )
	 {//three to a royal
		if((pOwnerLord->fake->cards[0].name > Nine &&
			((pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit &&
         pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit &&
          pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit &&
          pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit &&
          pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit &&
          pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit &&
          pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) )) ||
		  (pOwnerLord->fake->cards[1].name > Nine &&
			((pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[1].suit &&
         pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[1].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[1].suit &&
          pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[1].suit) ||
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[1].suit &&
          pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[1].suit) )) ||
		  (pOwnerLord->fake->cards[2].name > Nine &&
			(pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[2].suit &&
         pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[2].suit)))

		{
		  expertRecomString = TAppString(5021);
		  ExpertCode = 6;return;
		}

	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->toflush > 3)
	 {//four to a flush
		expertRecomString = TAppString(5029);
		ExpertCode = 9;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 10)
	 {// pair(low)
		expertRecomString = TAppString(5028);
		ExpertCode = 16;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2 &&
		 pOwnerLord->fake->cards[4].name > Nine)
	 {//three to a straight flush with a ten
		expertRecomString = TAppString(5044);
		ExpertCode = 22;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrght > 3)
	 {//four to straight
		expertRecomString = TAppString(5045);
		ExpertCode = 10;return;
	 }
	 if(((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2) ||
		  (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2)) &&
			pOwnerLord->fake->cards[4].name > Nine)
	 {//three to a straight flush with high card
		expertRecomString = TAppString(5044);
		ExpertCode = 22;return;
	 }
	 if(((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 1) ||
		  (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 1)) &&
		  ( (pOwnerLord->fake->cards[2].name > Nine &&
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[2].suit ||
			  pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[2].suit)) ||
			 (pOwnerLord->fake->cards[3].name > Nine &&
			 (pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[3].suit)) ))
	 {//two to a royal
		expertRecomString = TAppString(5031);
		ExpertCode = 18;return;
	 }
	 if(pOwnerLord->fake->cards[3].name > Nine  &&
		 pOwnerLord->fake->cards[4].name > Nine)
	 {//two high cards
		expertRecomString = TAppString(5084);
		ExpertCode = 25;return;
	 }
	 if(pOwnerLord->fake->cards[4].name > Nine)
	 {//high card
		expertRecomString = TAppString(5086);
		ExpertCode = 26;return;
	 }
	 if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2) ||
		 (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2)   )
	 {//three to a straight flush
		expertRecomString = TAppString(5044);
		ExpertCode = 22;return;
	 }
	 else
	 {
		expertRecomString = TAppString(5032);    //garbage
		ExpertCode = 13;return;
	 }
}
//*******************************************************************
void TACVPAsk::AskHoldJoker()
{
  pOwnerLord->GetNumOfWildCards();
  pOwnerLord->WildJoker(TRUE);


  if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->wildcount)
  {
		switch(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand){
		  case 105 : expertRecomString = TAppString(5001);
						 ExpertCode = 1;return;
		  case 100 : expertRecomString = TAppString(5004);
						 ExpertCode = 1;return;
		  case  99 : expertRecomString = TAppString(5006);
						 ExpertCode = 1;return;
		  case  71 : expertRecomString = TAppString(5007);
						 ExpertCode = 402;return;
		  case  70 : expertRecomString = TAppString(5010);
						 ExpertCode = 1;return;
		}
		if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
			 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh > 3) &&
			 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 26 )
		{ // four to a royal flush and a flush
		  if(pOwnerLord->fake->cards[1].name > Nine ||
			  (pOwnerLord->fake->cards[2].name > Nine &&
				(pOwnerLord->fake->cards[2].name < pOwnerLord->fake->cards[3].name &&
				 pOwnerLord->fake->cards[3].name < pOwnerLord->fake->cards[4].name) &&
				 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[3].suit &&
				  pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[4].suit)))
		  {
			 expertRecomString = TAppString(5033);
			 ExpertCode = 1;return;
		  }
		}
		if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
			 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh > 3) &&
			 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 26 )
		{ // four to a straight flush and a flush
		  expertRecomString = TAppString(5034);
		  ExpertCode = 1;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 26)
		{ //flush
		  expertRecomString = TAppString(5016);
		  ExpertCode = 1;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
			 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh > 3)
		{ // four to a royal flush
		  if(pOwnerLord->fake->cards[1].name > Nine ||
			  (pOwnerLord->fake->cards[2].name > Nine &&
				(pOwnerLord->fake->cards[2].name < pOwnerLord->fake->cards[3].name &&
				 pOwnerLord->fake->cards[3].name < pOwnerLord->fake->cards[4].name) &&
				 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[3].suit &&
				  pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[4].suit)))
		  {
			 expertRecomString = TAppString(5009);
			 ExpertCode = 103;return;
		  }
		}
		if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
			 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh > 3) &&
			 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 23)
		{ // straight and four to a straight flush
		  if(pOwnerLord->fake->cards[1].name > Nine ||
			  (pOwnerLord->fake->cards[2].name > Nine &&
				(pOwnerLord->fake->cards[2].name < pOwnerLord->fake->cards[3].name &&
				 pOwnerLord->fake->cards[3].name < pOwnerLord->fake->cards[4].name) &&
				 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[3].suit &&
				  pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[4].suit)))
		  {
			 expertRecomString = TAppString(5035);
			 ExpertCode = 4;return;
		  }
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 &&
			pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 3)
		{//four to a straight flush
		  expertRecomString = TAppString(5019);
		  ExpertCode = 4;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 23)
		{//straight
		  expertRecomString = TAppString(5017);
		  ExpertCode = 1;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 20)
		{// three o' kind
		  expertRecomString = TAppString(5018);
		  ExpertCode = 5;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2 ||
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2 )
		{// three to a royal
		  if((pOwnerLord->fake->cards[0].name > Nine &&
			 ((pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit /*&& pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit*/) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit /*&& pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit*/) ||
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit /*&& pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit*/) )) ||
			 (pOwnerLord->fake->cards[1].name > Nine &&
			 ((pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[1].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[1].suit /*&& pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[1].suit*/) ||
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[1].suit /*&& pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[1].suit*/) )) ||
			 (pOwnerLord->fake->cards[2].name > Nine &&
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[2].suit /*&& pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[2].suit*/)))

		  {
			 expertRecomString = TAppString(5021);
			 ExpertCode = 6;return;
		  }

		}
		if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2 ||
			 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2) &&
			 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrght  > 3)
		{//four card straight(outside) and three to a straight flush
		  expertRecomString = TAppString(5036);
		  ExpertCode = 7;return;
		}
		if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrght  > 3) &&
			 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->toflush  > 3)
		{//four card straight(outside) and four to a flush
		  expertRecomString = TAppString(5037);
		  ExpertCode = 7;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrght  > 3)
		{//four card straight(outside)
		  expertRecomString = TAppString(5030);
		  ExpertCode = 7;return;
		}
	  //	if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2 ||
	  //		 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2) &&
	  //		 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrght  > 3)
	 //	{//four card straight(inside) and three to a straight flush
	 //	  expertRecomString = TAppString(5038);
	//	  return;
  //		}
  //		if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrght > 3) &&
  //			 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->toflush  > 3)
  //		{//four card straight(inside) and four to a flush
  //		  expertRecomString = TAppString(5039);
	//	  return;
		//}
		if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh  > 2) &&
			 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->toflush > 3)
		{//three to straight flush(outside) and four to a flush
		  expertRecomString = TAppString(5040);
		  ExpertCode = 88;return;
		}
		if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2) &&
			 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->toflush > 3)
		{//three to straight flush(inside) and four to a flush
		  expertRecomString = TAppString(5041);
		  ExpertCode = 9;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh  > 2)
		{//three to straight flush(outside)
		  expertRecomString = TAppString(5042);
		  ExpertCode = 88;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->toflush  > 3)
		{//four to flush
		  expertRecomString = TAppString(5043);
		  ExpertCode = 9;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2)
		{//three to straight flush(inside)
		  expertRecomString = TAppString(5042);
		  ExpertCode = 22;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrght  > 3)
		{//four to straight
		  expertRecomString = TAppString(5045);
		  ExpertCode = 10;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrght  > 2)
		{//three to straight
		  expertRecomString = TAppString(5047);
		  ExpertCode = 11;return;
		}
		expertRecomString = TAppString(5046);
		ExpertCode = 12;return;

  }
  else // no wild cards
  {
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 105)
	 {//royal
		expertRecomString = TAppString(5024);
		ExpertCode = 1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 99)
	 {
		if(pOwnerLord->fake->cards[4].name == AceHi)
		{
		  expertRecomString = TAppString(5003);
		  ExpertCode =1;return;
		}
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 99)
	 {//straight flush
		expertRecomString = TAppString(5006);
		ExpertCode = 1;return;
	 }
	 if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh > 3) &&
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 26)
	 {//four to a royal and a flush
		if(pOwnerLord->fake->cards[1].name > Nine ||
		  (pOwnerLord->fake->cards[2].name > Nine &&
			(pOwnerLord->fake->cards[2].name < pOwnerLord->fake->cards[3].name &&
			 pOwnerLord->fake->cards[3].name < pOwnerLord->fake->cards[4].name) &&
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[3].suit &&
			  pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[4].suit)))
		{
		  expertRecomString = TAppString(5048);
		  ExpertCode = 3;return;
		}
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
		 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh > 3)
	 {// four to a royal
		if(pOwnerLord->fake->cards[1].name > Nine ||
			  (pOwnerLord->fake->cards[2].name > Nine &&
				(pOwnerLord->fake->cards[2].name < pOwnerLord->fake->cards[3].name &&
				 pOwnerLord->fake->cards[3].name < pOwnerLord->fake->cards[4].name) &&
				 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[3].suit &&
				  pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[4].suit)))
		{
		  expertRecomString = TAppString(5009);
		  ExpertCode = 3;return;
		}
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 71)
	 {//four o' kind
		expertRecomString = TAppString(5007);
		ExpertCode = 2;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 70)
	 {//full house
		expertRecomString = TAppString(5010);
		ExpertCode = 1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 26)
	 { //flush
		expertRecomString = TAppString(5016);
		ExpertCode = 1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 23 &&
		 (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 3) )
	 {//straight and four to a straight flush
		expertRecomString = TAppString(5049);
		ExpertCode = 1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 23)
	 {//straight
		expertRecomString = TAppString(5017);
		ExpertCode = 1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3)
	 {//four to a straight flush
		expertRecomString = TAppString(5019);
		ExpertCode = 4;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 20)
	 {//three o' kind
		expertRecomString = TAppString(5018);
		ExpertCode = 5;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 3)
	 {//four to a inside straight flush
		expertRecomString = TAppString(5019);
		ExpertCode = 4;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 15)
	 {//two pair
		expertRecomString = TAppString(5050);
		ExpertCode = 15;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2 ||
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2 )
	 {//three to a royal
		if((pOwnerLord->fake->cards[0].name > Nine &&
			((pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) )) ||
		  (pOwnerLord->fake->cards[1].name > Nine &&
			((pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[1].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[1].suit) ||
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[1].suit) )) ||
		  (pOwnerLord->fake->cards[2].name > Nine &&
			(pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[2].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[2].suit)))

		{
		  expertRecomString = TAppString(5021);
		  ExpertCode = 6;return;
		}

	 }
	 if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->toflush > 3)&&
		  (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2 ||
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2 ))
	 {//four to a flush and three to a straight flush
		expertRecomString = TAppString(5051);
		ExpertCode = 9;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->toflush > 3)
	 {//four to a flush
		expertRecomString = TAppString(5029);
		ExpertCode = 9;return;
	 }
	 if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrght > 3)&&
		  (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2 ||
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2 ))
	 {//four to a straight(outside) and three to a straight flush
		expertRecomString = TAppString(5052);
		ExpertCode = 7;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrght > 3)
	 {//four to straight(outside)
		expertRecomString = TAppString(5045);
		ExpertCode = 7;return;
	 }
	 if(((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2) ||
		  (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2)) &&
			pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrght > 3)
	 {//four to a straight(inside) and three to a straight flush
		expertRecomString = TAppString(5053);
		ExpertCode = 22;return;
	 }
	 if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2) ||
		 (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2))
	 {//three to a straight flush
		expertRecomString = TAppString(5044);
		ExpertCode = 22;return;
	 }
	 if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 10) ||
		 (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 15))
	 {//any pair
		expertRecomString = TAppString(5028);
		ExpertCode = 16;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrght > 3)
	 { //four to a straight(inside)
		expertRecomString = TAppString(5045);
		ExpertCode = 38;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->toflush > 2)
	 { //three to a flush
		expertRecomString = TAppString(5054);
		ExpertCode = 17;return;
	 }
	 if(((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 1) ||
		  (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 1)) &&
		  ( (pOwnerLord->fake->cards[2].name > Nine &&
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[2].suit ||
			  pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[2].suit)) ||
			 (pOwnerLord->fake->cards[3].name > Nine &&
			 (pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[3].suit)) ))
	 {//two to a royal
		expertRecomString = TAppString(5031);
		ExpertCode = 18;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrght > 2)
	 {//three to a straight
		expertRecomString = TAppString(5047);
		ExpertCode = 11;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 1)
	 {//two to a straight flush
		expertRecomString = TAppString(5055);
		ExpertCode = 19;return;
	 }
	 expertRecomString = TAppString(5032);    //garbage
	 ExpertCode = 13;return;
  }
}
//*******************************************************************
void TACVPAsk::AskHoldJacks()
{
  pOwnerLord->fake->inhand = 0;
  for(int16 i=0;i<5;i++)
  {
	 pOwnerLord->fake->cards[i].name = pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->cards[i].name;
	 pOwnerLord->fake->cards[i].suit = pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->cards[i].suit;
	 pOwnerLord->fake->inhand++;
  }
  pOwnerLord->pSmarts->Insert_Sort(pOwnerLord->fake);
  pOwnerLord->pSmarts->Holding(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand);
  pOwnerLord->pSmarts->Holding(pOwnerLord->fake);

	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 105)
	 {//royal
		expertRecomString = TAppString(5003);
		ExpertCode =1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 99)
	 {
      if(pOwnerLord->fake->cards[4].name == AceHi)
		{
		  expertRecomString = TAppString(5003);
		  ExpertCode =1;return;
		}
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 99)
	 {//straight flush
		expertRecomString = TAppString(5006);
		ExpertCode =1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 71)
	 {//four o' kind
		expertRecomString = TAppString(5077);
		ExpertCode =20;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 70)
	 {//full house
		expertRecomString = TAppString(5010);
		ExpertCode =1;return;
	 }
	 if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh > 3   )&&
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 26  	 )
	 {// four to a royal and a Flush
		if(pOwnerLord->fake->cards[1].name > Nine ||
			  (pOwnerLord->fake->cards[2].name > Nine &&
				(pOwnerLord->fake->cards[2].name < pOwnerLord->fake->cards[3].name &&
				 pOwnerLord->fake->cards[3].name < pOwnerLord->fake->cards[4].name) &&
				 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[3].suit &&
				  pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[4].suit)))
		{
		  expertRecomString = TAppString(5078);
		  ExpertCode =3;return;
		}
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
		 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh > 3)
	 {// four to a royal
		if(pOwnerLord->fake->cards[0].name > Nine ||
			  (pOwnerLord->fake->cards[1].name > Nine &&
				(pOwnerLord->fake->cards[0].suit != pOwnerLord->fake->cards[1].suit) &&
				(pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[2].suit)))
				/*(pOwnerLord->fake->cards[2].name < pOwnerLord->fake->cards[3].name &&
				 pOwnerLord->fake->cards[3].name < pOwnerLord->fake->cards[4].name) &&
				 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[3].suit &&
				  pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[4].suit)))*/
		{
		  expertRecomString = TAppString(5009);
		  ExpertCode =3;return;
		}
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 26)
	 { //flush
		expertRecomString = TAppString(5016);
		ExpertCode =1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 20)
	 {//three o' kind
		expertRecomString = TAppString(5018);
		ExpertCode =5;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 23 &&
		 (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 3) )
	 {//straight and four to a straight flush
		expertRecomString = TAppString(5081);
		ExpertCode =1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 23)
	 {//straight
		expertRecomString = TAppString(5017);
		ExpertCode =1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 3 )
	 {//four to a straight flush
		expertRecomString = TAppString(5019);
		ExpertCode =4;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 15)
	 {//two pair
		expertRecomString = TAppString(5050);
		ExpertCode =15;return;
	 }
	 if(pOwnerLord->fake->cards[0].name == Ten   &&
		 pOwnerLord->fake->cards[1].name == Ten   &&
		 pOwnerLord->fake->cards[2].name == Jack  &&
		 pOwnerLord->fake->cards[3].name == Queen &&
		 pOwnerLord->fake->cards[4].name == King)
	 {//k-q-j-10-10
		expertRecomString = TAppString(5088);
		ExpertCode =10;return;
	 }
	 if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 10)&&
		  (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrght > 3 ||
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrght  > 3 ))
	 {//four to a straight and a pair
		expertRecomString = TAppString(5089);
		ExpertCode =16;return;
	 }
	 if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 10)&&
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highcard > Ten)
	 {//high pair and three to a royal
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2 ||
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2 )
		{//three to a royal
		  if((pOwnerLord->fake->cards[0].name > Nine &&
			((pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) )) ||
		  (pOwnerLord->fake->cards[1].name > Nine &&
			((pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[1].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[1].suit) ||
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[1].suit) )) ||
		  (pOwnerLord->fake->cards[2].name > Nine &&
			(pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[2].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[2].suit)))

		  {
			 expertRecomString = TAppString(5080);
			 ExpertCode =27;return;
		  }
		}
	 }
	 if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 10)&&
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highcard > Ten)
	 {//high pair
		expertRecomString = TAppString(5082);
		ExpertCode =27;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2 ||
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2 )
	 {//three to a royal
		if((pOwnerLord->fake->cards[0].name > Nine &&
			((pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) )) ||
		  (pOwnerLord->fake->cards[1].name > Nine &&
			((pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[1].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[1].suit) ||
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[1].suit) )) ||
		  (pOwnerLord->fake->cards[2].name > Nine &&
			(pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[2].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[2].suit)))

		{
		  expertRecomString = TAppString(5021);
		  ExpertCode =6;return;
		}

	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->toflush > 3)
	 {//four to a flush  and a low pair
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 10)
		{// pair(low)
		  expertRecomString = TAppString(5090);
		  ExpertCode =9;return;
		}
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->toflush > 3)
	 {//four to a flush
		expertRecomString = TAppString(5029);
		ExpertCode =9;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 10)
	 {// pair(low)
		expertRecomString = TAppString(5028);
		ExpertCode =16;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrght > 3)
	 {//four to straight and two to a royal
		if(((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  == 2) ||
		  (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh == 2)) &&
		  ( (pOwnerLord->fake->cards[2].name > Nine &&
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[2].suit ||
			  pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[2].suit)) ||
			 (pOwnerLord->fake->cards[3].name > Nine &&
			 (pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[3].suit)) ))
		{//two to a royal(no 10)
		  expertRecomString = TAppString(5091);
		  ExpertCode =10;return;
		}
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrght > 3)
	 {//four to straight
		expertRecomString = TAppString(5045);
		ExpertCode =10;return;
	 }
	 if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2 &&
		  pOwnerLord->fake->cards[4].name > Ten) ||
		 (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2))
	 {//three to a straight flush with high card for gaps
		expertRecomString = TAppString(5044);
		ExpertCode =28;return;
	 }
	 if(((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 1) ||
		  (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 1)) &&
		  ( (pOwnerLord->fake->cards[2].name > Ten &&
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[2].suit ||
			  pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[2].suit)) ||
			 (pOwnerLord->fake->cards[3].name > Ten &&
			 (pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[3].suit)) ))
	 {//two to a royal(no 10)
		expertRecomString = TAppString(5031);
		ExpertCode =29;return;
	 }
	 if(pOwnerLord->fake->cards[2].name == Jack   &&
		 pOwnerLord->fake->cards[3].name == Queen  &&
		 pOwnerLord->fake->cards[4].name == King)
	 {//k-q-j
		expertRecomString = TAppString(5093);
		ExpertCode =31;return;
	 }
	 if(((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 1) ||
		  (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 1)) &&
		  ( (pOwnerLord->fake->cards[2].name > Nine &&
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[2].suit ||
			  pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[2].suit)) ||
			 (pOwnerLord->fake->cards[3].name > Nine &&
			 (pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[3].suit)) ))
	 {//two to a royal(10)
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highcard > Ten &&
			pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->lowcard > Ten)
		{ //two high cards
		  expertRecomString = TAppString(5092);
		  ExpertCode =30;return;
		}
	 }
	 if(pOwnerLord->fake->cards[2].name > Ten  &&
		 pOwnerLord->fake->cards[3].name > Ten  &&
		 pOwnerLord->fake->cards[4].name > Ten)
	 {//three high cards
		expertRecomString = TAppString(5094);
		ExpertCode =30;return;
	 }
	 if(pOwnerLord->fake->cards[3].name > Ten  &&
		 pOwnerLord->fake->cards[4].name > Ten)
	 {//two high cards
		expertRecomString = TAppString(5085);
		ExpertCode =30;return;
	 }
	 if(((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 1) ||
		  (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 1)) &&
		  ( (pOwnerLord->fake->cards[2].name > Nine &&
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[2].suit ||
			  pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[2].suit)) ||
			 (pOwnerLord->fake->cards[3].name > Nine &&
			 (pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[3].suit)) ))
	 {//two to a royal(10)
		expertRecomString = TAppString(5031);
		ExpertCode =18;return;
	 }

	 if(pOwnerLord->fake->cards[4].name > Ten)
	 {//high card
		expertRecomString = TAppString(5087);
		ExpertCode =32;return;
	 }
    if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2) ||
		 (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2))
	 {//three to a straight flush
		expertRecomString = TAppString(5044);
		ExpertCode =22;return;
	 }
	 expertRecomString = TAppString(5032);    //garbage
	 ExpertCode =13;return;

}
//*******************************************************************
void TACVPAsk::AskHoldJacksProg()
{
  pOwnerLord->fake->inhand = 0;
  for(int16 i=0;i<5;i++)
  {
	 pOwnerLord->fake->cards[i].name = pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->cards[i].name;
	 pOwnerLord->fake->cards[i].suit = pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->cards[i].suit;
	 pOwnerLord->fake->inhand++;
  }
  pOwnerLord->pSmarts->Insert_Sort(pOwnerLord->fake);
  pOwnerLord->pSmarts->Holding(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand);
  pOwnerLord->pSmarts->Holding(pOwnerLord->fake);

	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 105)
	 {//royal
		expertRecomString = TAppString(5003);
		ExpertCode =1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 99)
	 {
      if(pOwnerLord->fake->cards[4].name == AceHi)
		{
		  expertRecomString = TAppString(5003);
		  ExpertCode =1;return;
		}
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 99)
	 {//straight flush
		expertRecomString = TAppString(5006);
		ExpertCode =1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 71)
	 {//four o' kind
		expertRecomString = TAppString(5077);
		ExpertCode =20;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 70)
	 {//full house
		expertRecomString = TAppString(5010);
		ExpertCode =1;return;
	 }
	 if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh > 3   )&&
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 26  	 )
	 {// four to a royal and a Flush
		if(pOwnerLord->fake->cards[1].name > Nine ||
			  (pOwnerLord->fake->cards[2].name > Nine &&
				(pOwnerLord->fake->cards[2].name < pOwnerLord->fake->cards[3].name &&
				 pOwnerLord->fake->cards[3].name < pOwnerLord->fake->cards[4].name) &&
				 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[3].suit &&
				  pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[4].suit)))
		{
		  expertRecomString = TAppString(5078);
		  ExpertCode =3;return;
		}
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
		 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh > 3)
	 {// four to a royal
		if(pOwnerLord->fake->cards[1].name > Nine ||
			  (pOwnerLord->fake->cards[2].name > Nine &&
				(pOwnerLord->fake->cards[2].name < pOwnerLord->fake->cards[3].name &&
				 pOwnerLord->fake->cards[3].name < pOwnerLord->fake->cards[4].name) &&
				 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[3].suit &&
				  pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[4].suit)))
		{
		  expertRecomString = TAppString(5009);
		  ExpertCode =3;return;
		}
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 26)
	 { //flush
		expertRecomString = TAppString(5016);
		ExpertCode =1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 20)
	 {//three o' kind
		expertRecomString = TAppString(5018);
		ExpertCode =5;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 23 &&
		 (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 3) )
	 {//straight and four to a straight flush
		expertRecomString = TAppString(5081);
		ExpertCode =1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 23)
	 {//straight
		expertRecomString = TAppString(5017);
		ExpertCode =1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 15)
	 {//two pair
		expertRecomString = TAppString(5050);
		ExpertCode =15;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 3 )
	 {//four to a straight flush
		expertRecomString = TAppString(5019);
		ExpertCode =4;return;
	 }
	 if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 10)&&
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highcard > Ten)
	 {//high pair and three to royal
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2 ||
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2 )
		{//three to a royal
		  if((pOwnerLord->fake->cards[0].name > Nine &&
			((pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) )) ||
		  (pOwnerLord->fake->cards[1].name > Nine &&
			((pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[1].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[1].suit) ||
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[1].suit) )) ||
		  (pOwnerLord->fake->cards[2].name > Nine &&
			(pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[2].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[2].suit)))

		  {
			 expertRecomString = TAppString(5095);
			 ExpertCode =6;return;
		  }
		}
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2 ||
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2 )
	 {//three to a royal
		if((pOwnerLord->fake->cards[0].name > Nine &&
			((pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) )) ||
		  (pOwnerLord->fake->cards[1].name > Nine &&
			((pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[1].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[1].suit) ||
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[1].suit) )) ||
		  (pOwnerLord->fake->cards[2].name > Nine &&
			(pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[2].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[2].suit)))

		{
		  expertRecomString = TAppString(5021);
		  ExpertCode =6;return;
		}
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 10 &&
		 (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrght > 3 ||
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrght > 3) &&
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highcard > Ten)
	 {//four to a straight and a high pair
		expertRecomString = TAppString(5096);
		ExpertCode =27;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 10 &&
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrght > 3 &&
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->toflush == 4)
	 {//four to a Flush and a high pair
		expertRecomString = TAppString(5097);
		ExpertCode =27;return;
	 }
	 if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 10)&&
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highcard > Ten)
	 {//high pair
		expertRecomString = TAppString(5082);
		ExpertCode =27;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->toflush > 3)
	 {//four to a flush
		expertRecomString = TAppString(5029);
		ExpertCode =9;return;
	 }
	 if(pOwnerLord->fake->cards[0].name == Ten   &&
		 pOwnerLord->fake->cards[1].name == Ten   &&
		 pOwnerLord->fake->cards[2].name == Jack  &&
		 pOwnerLord->fake->cards[3].name == Queen &&
		 pOwnerLord->fake->cards[4].name == King)
	 {//k-q-j-10-10
		expertRecomString = TAppString(5088);
		ExpertCode =10;return;
	 }
	 if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 10)&&
		  (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrght > 3 ||
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrght  > 3 ))
	 {//four to a straight and a pair
		expertRecomString = TAppString(5089);
		ExpertCode =16;return;
	 }
	  if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 10)
	 {// pair(low)
		expertRecomString = TAppString(5028);
		ExpertCode =16;return;
	 }
	 if(pOwnerLord->fake->cards[2].name == Jack   &&
		 pOwnerLord->fake->cards[3].name == Queen  &&
		 pOwnerLord->fake->cards[4].name == King   &&
		 pOwnerLord->fake->cards[1].name == Ten      )
	 {//k-q-j-10
		expertRecomString = TAppString(5098);
		ExpertCode =10;return;
	 }
	 if(((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 1) ||
		  (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 1)) &&
		  ( (pOwnerLord->fake->cards[2].name > Ten &&
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[2].suit ||
			  pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[2].suit)) ||
			 (pOwnerLord->fake->cards[3].name > Ten &&
			 (pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[3].suit)) ))
	 {//two to a royal(no 10)
		expertRecomString = TAppString(5031);
		ExpertCode =29;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrght > 3)
	 {//four to straight
		expertRecomString = TAppString(5045);
		ExpertCode =10;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2)
	 {//three to a straight flush
		expertRecomString = TAppString(5044);
		ExpertCode =8;return;
	 }
	 if(((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 1) ||
		  (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 1)) &&
		  ( (pOwnerLord->fake->cards[2].name > Nine &&
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[2].suit ||
			  pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[2].suit)) ||
			 (pOwnerLord->fake->cards[3].name > Nine &&
			 (pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[3].suit)) ))
	 {//two to a royal(10)
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highcard > Ten &&
			pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->lowcard == Ten)
		{ //high card
		  expertRecomString = TAppString(5031);
		  ExpertCode =18;return;
		}
	 }
	 if(pOwnerLord->fake->cards[2].name == Jack   &&
		 pOwnerLord->fake->cards[3].name == Queen  &&
		 pOwnerLord->fake->cards[4].name == King)
	 {//k-q-j
		expertRecomString = TAppString(5093);
		ExpertCode =31;return;
	 }
	 if(pOwnerLord->fake->cards[2].name > Ten  &&
		 pOwnerLord->fake->cards[3].name > Ten  &&
		 pOwnerLord->fake->cards[4].name > Ten)
	 {//three high cards
		expertRecomString = TAppString(5094);
		ExpertCode =30;return;
	 }
	 if(pOwnerLord->fake->cards[3].name > Ten  &&
		 pOwnerLord->fake->cards[4].name > Ten)
	 {//two high cards
		expertRecomString = TAppString(5085);
		ExpertCode =30;return;
	 }
	 if(pOwnerLord->fake->cards[4].name > Ten)
	 {//high card
		expertRecomString = TAppString(5087);
		ExpertCode =32;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2 ||
		 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh > 2    )
	 {//three to a straight flush
		expertRecomString = TAppString(5044);
		ExpertCode =22;return;
	 }
	 expertRecomString = TAppString(5032);    //garbage
	 ExpertCode =13;return;

}
//*******************************************************************
void TACVPAsk::AskHoldDeuces()
{
  pOwnerLord->GetNumOfWildCards();
  pOwnerLord->Wild2(true);

  if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->wildcount)
  {
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->wildcount > 2)
	 {

		switch(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand){
		  case 110 : expertRecomString = TAppString(5002);ExpertCode =220;break;
		  case 105 : expertRecomString = TAppString(5000);ExpertCode =1;break;
		  case 100 : expertRecomString = TAppString(5004);ExpertCode =1;break;
		  default  : expertRecomString = TAppString(5005);ExpertCode =55;break;
		}
		return;
	 }
	 else if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->wildcount > 1)
	 {
		switch(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand){
		  case 105 : expertRecomString = TAppString(5000);ExpertCode =1;break;
		  case 100 : expertRecomString = TAppString(5004);ExpertCode =1;break;
		  case  99 : if(pOwnerLord->fake->cards[2].name == Nine)
						 {
							expertRecomString = TAppString(5100);ExpertCode =1;break;
						 }
						 else
						 {
							expertRecomString = TAppString(5006);ExpertCode =1;break;
						 }
		  case  71 : expertRecomString = TAppString(5007);ExpertCode =102;break;
		  default  : if(pOwnerLord->fake->cards[2].name > Nine)
						 {
							if((pOwnerLord->fake->cards[3].name >
									 pOwnerLord->fake->cards[2].name) &&
								(pOwnerLord->fake->cards[2].suit ==
									 pOwnerLord->fake->cards[3].suit)   )
							{
							  expertRecomString = TAppString(5009);ExpertCode =136;break;
							}
							else if((pOwnerLord->fake->cards[4].name >
											pOwnerLord->fake->cards[2].name) &&
									  (pOwnerLord->fake->cards[2].suit ==
											pOwnerLord->fake->cards[4].suit)   )
							{
							  expertRecomString = TAppString(5009);ExpertCode =136;break;
							}
						 }
						 else if(pOwnerLord->fake->cards[3].name > Nine)
						 {
							if((pOwnerLord->fake->cards[4].name >
									 pOwnerLord->fake->cards[3].name) &&
								(pOwnerLord->fake->cards[4].suit ==
									 pOwnerLord->fake->cards[3].suit)   )
							{
							  expertRecomString = TAppString(5009);ExpertCode =136;break;
							}
						 }
						 expertRecomString = TAppString(5008);ExpertCode =37;break;
		}
		return;
	 }
	 else if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->wildcount) //repetitive check
	 {
		switch(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand){
		  case 105 : expertRecomString = TAppString(5000);
						 ExpertCode =1;return;
		  case 100 : expertRecomString = TAppString(5004);
						 ExpertCode =1;return;
		  case  99 : expertRecomString = TAppString(5006);
						 ExpertCode =1;return;
		  case  71 : expertRecomString = TAppString(5007);
						 ExpertCode =302;return;
		  case  70 : expertRecomString = TAppString(5010);
						 ExpertCode =1;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh > 3)
		{
		  if(pOwnerLord->fake->cards[1].name > Nine ||
			  (pOwnerLord->fake->cards[2].name > Nine &&
				(pOwnerLord->fake->cards[2].name < pOwnerLord->fake->cards[3].name &&
				 pOwnerLord->fake->cards[3].name < pOwnerLord->fake->cards[4].name) &&
				 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[3].suit &&
				  pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[4].suit)))
		  {
			 expertRecomString = TAppString(5009);
			 ExpertCode =135;return;
		  }
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
			pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh > 3)
		{
		  if(pOwnerLord->fake->cards[1].name > Nine ||
			  (pOwnerLord->fake->cards[2].name > Nine &&
				(pOwnerLord->fake->cards[2].name < pOwnerLord->fake->cards[3].name &&
				 pOwnerLord->fake->cards[3].name < pOwnerLord->fake->cards[4].name) &&
				 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[3].suit &&
				  pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[4].suit)))
		  {
			 expertRecomString = TAppString(5009);
			 ExpertCode =135;return;
		  }
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 &&
			pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 26)
		{  //four to straight flush and a flush
		  expertRecomString = TAppString(5102);
		  ExpertCode =33;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 &&
			pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 23)
		{  //four to straight flush and a straight
		  expertRecomString = TAppString(5103);
		  ExpertCode =33;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3)
		{  //four to straight flush
		  expertRecomString = TAppString(5019);
		  ExpertCode =33;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh > 3 &&
			pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 26)
		{  //four to straight flush (gap) and a flush
		  expertRecomString = TAppString(5104);
		  ExpertCode =1;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh > 3 &&
			pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 23)
		{  //four to straight flush (gap) and a straight
		  expertRecomString = TAppString(5105);
		  ExpertCode =1;return;
		}
		switch(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand){
		  case 26 : expertRecomString = TAppString(5016);
						 ExpertCode =1;return;
		  case 23 : expertRecomString = TAppString(5017);
						 ExpertCode =1;return;
		  case 20 : expertRecomString = TAppString(5018);
						 ExpertCode =511;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh > 3)
		{   //four to straight flush (gap)
		  expertRecomString = TAppString(5019);
		  ExpertCode =104;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2 &&
			pOwnerLord->fake->cards[1].name > Nine &&
			((pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[2].suit) ||
			 (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[3].suit) ||
			 (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[4].suit)))
		{   //three to royal flush
		  expertRecomString = TAppString(5021);
		  ExpertCode =6;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2 &&
			pOwnerLord->fake->cards[2].name > Nine &&
			((pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[2].suit) ||
			 (pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[2].suit)))
		{   //three to royal flush
		  expertRecomString = TAppString(5021);
		  ExpertCode =6;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2 &&
			pOwnerLord->fake->cards[3].name > Nine &&
			(pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[4].suit))
		{   //three to royal flush
		  expertRecomString = TAppString(5021);
		  ExpertCode =6;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2)
		{
		  expertRecomString = TAppString(5044);
		  ExpertCode =88;return;
		}
		expertRecomString = TAppString(5106);
		ExpertCode =34;return;
	 }
  }
  else // no wild cards
  {
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 105)
	 {
		expertRecomString = TAppString(5003);
		ExpertCode =1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 99)
	 {
      if(pOwnerLord->fake->cards[4].name == AceHi)
		{
		  expertRecomString = TAppString(5003);
		  ExpertCode =1;return;
		}
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 99)
	 {
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
			pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh > 3)
		{
		  if(pOwnerLord->fake->cards[1].name > Nine ||
			  (pOwnerLord->fake->cards[2].name > Nine &&
				(pOwnerLord->fake->cards[2].name < pOwnerLord->fake->cards[3].name &&
				 pOwnerLord->fake->cards[3].name < pOwnerLord->fake->cards[4].name) &&
				 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[3].suit &&
				  pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[4].suit)))
		  {
			 expertRecomString = TAppString(5107);
			 ExpertCode =3;return;
		  }
		}
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
		 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh > 3)
	 {    //four to royal
		if(pOwnerLord->fake->cards[1].name > Nine ||
			  (pOwnerLord->fake->cards[2].name > Nine &&
				(pOwnerLord->fake->cards[2].name < pOwnerLord->fake->cards[3].name &&
				 pOwnerLord->fake->cards[3].name < pOwnerLord->fake->cards[4].name) &&
				 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[3].suit &&
				  pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[4].suit)))
		{
		  expertRecomString = TAppString(5009);
		  ExpertCode =3;return;
		}
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 99)
	 {         //straight flush
		expertRecomString = TAppString(5006);
		ExpertCode =1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 71)
	 {          // four o kind
		expertRecomString = TAppString(5007);
		ExpertCode =2;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 70)
	 {       //full house
		expertRecomString = TAppString(5010);
		ExpertCode =1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 20)
	 {       // three o kind
		expertRecomString = TAppString(5018);
		ExpertCode =5;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 26 &&
		 (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 3) )
	 {        // flush and four to straight flush
		expertRecomString = TAppString(5108);
		ExpertCode =1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 26)
	 {              //flush
		expertRecomString = TAppString(5016);
		ExpertCode =1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 23 &&
		 (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 3) )
	 {                          //straight and four to straight flush
		expertRecomString = TAppString(5109);
		ExpertCode =1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 23)
	 {              //straight
		expertRecomString = TAppString(5017);
		ExpertCode =1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 3 )
	 {               // four to straight flush (gap)
		expertRecomString = TAppString(5019);
		ExpertCode =4;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2 ||
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2 )
	 {               //three to royal
		if((pOwnerLord->fake->cards[0].name > Nine &&
			((pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) )) ||
		  (pOwnerLord->fake->cards[1].name > Nine &&
			((pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[1].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[1].suit) ||
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[1].suit) )) ||
		  (pOwnerLord->fake->cards[2].name > Nine &&
			(pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[2].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[2].suit)))

		{
		  expertRecomString = TAppString(5021);
		  ExpertCode =6;return;
		}
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 10 ||
		 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 15)
	 {                //hold one pair
		expertRecomString = TAppString(5028);
		ExpertCode =16;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->toflush > 3)
	 {           //four to flush
		expertRecomString = TAppString(5029);
		ExpertCode =9;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrght > 3)
	 {              //four to straight
		expertRecomString = TAppString(5045);
		ExpertCode =10;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh > 2 ||
		 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2  )
	 {        //three to straight flush (gap)
		expertRecomString = TAppString(5044);
		ExpertCode =8;return;
	 }
	 if(((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 1) ||
		  (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 1)) &&
		  ( (pOwnerLord->fake->cards[2].name > Nine &&
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[2].suit ||
			  pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[2].suit)) ||
			 (pOwnerLord->fake->cards[3].name > Nine &&
			 (pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[3].suit)) ))
	 {     //two to royal
		expertRecomString = TAppString(5031);
		ExpertCode =18;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrght > 3)
	 {  // four to a one gap straight
		expertRecomString = TAppString(5045);
		ExpertCode =38;return;
	 }
    expertRecomString = TAppString(5032);
	 ExpertCode =13;return;
  }
}
//*******************************************************************
void TACVPAsk::AskHoldFivesUp()
{
  AskHoldJacks();
}
//*******************************************************************
void TACVPAsk::AskHoldBonusDeluxeP()
{
  AskHoldJacks();
}
//*******************************************************************
void TACVPAsk::AskHoldCrazy8()
{
  AskHoldJacks();
}
//*******************************************************************
void TACVPAsk::AskHoldDDrawJacks()
{
  AskHoldJacks();
}
//*******************************************************************
void TACVPAsk::AskHoldJacksBetter85()
{
  AskHoldJacks();
}
//*******************************************************************
void TACVPAsk::AskHoldJacksBetterDoubleD()
{
  AskHoldJacks();
}
//*******************************************************************
void TACVPAsk::AskHoldProgRoyals()
{
  AskHoldJacksProg();
}
//*******************************************************************
void TACVPAsk::AskHoldTensBetter()
{
  AskHoldTens();
}
//*******************************************************************
void TACVPAsk::AskHoldWheelDeal()
{
  AskHoldJacks();
}
//*******************************************************************
void TACVPAsk::AskHoldBlackJacks()
{
  AskHoldJacks();
}
//*******************************************************************
void TACVPAsk::AskHoldJacksBetterProg()
{
  AskHoldJacksProg();
}
//*******************************************************************
void TACVPAsk::AskHold2Wild()
{
  AskHoldDeuces();
}
//*******************************************************************
void TACVPAsk::AskHoldGamblersEdge()
{
  AskHoldJacks();
}
//*******************************************************************
void TACVPAsk::AskHoldJackpotBonus()
{
  AskHoldJacks();
}
//*******************************************************************
void TACVPAsk::AskHoldJacksBetter96()
{
  AskHoldJacks();
}
//*******************************************************************
void TACVPAsk::AskHoldRaiseDrawJoker()
{
  AskHoldJokerA();
}
//*******************************************************************
void TACVPAsk::AskHoldSpadeBonus()
{
  AskHoldSuitBonus(3);
}
//*******************************************************************
void TACVPAsk::AskHoldClubBonus()
{
  AskHoldSuitBonus(0);
}
//*******************************************************************
void TACVPAsk::AskHoldDDrawJokers()
{
  AskHoldJokerB();
}
//*******************************************************************
void TACVPAsk::AskHoldDiamondBonus()
{
  AskHoldSuitBonus(1);
}
//*******************************************************************
void TACVPAsk::AskHoldHeartBonus()
{
  AskHoldSuitBonus(2);
}
//*******************************************************************
void TACVPAsk::AskHoldJokerWildProg()
{
  AskHoldJokerC();
}
//*******************************************************************
void TACVPAsk::AskHoldJumpinJoker()
{
  AskHoldFiveJokers();
}
//*******************************************************************
void TACVPAsk::AskHoldSevenWildJoker()
{
  AskHold7sOneJoker();
}
//*******************************************************************
void TACVPAsk::AskHoldFlushAssault()
{
  AskHoldBQD();
}
//*******************************************************************
void TACVPAsk::AskHoldTripProg()
{
  AskHoldBQC();
}
//*******************************************************************
void TACVPAsk::AskHoldTreasureTrove()
{
  AskHoldBQC();
}
//*******************************************************************
void TACVPAsk::AskHoldDoubleBonusPoker()
{
  AskHoldBQE();
}
//*******************************************************************
void TACVPAsk::AskHoldPowerFullHouse()
{
  AskHoldBQE();
}
//*******************************************************************
void TACVPAsk::AskHoldFreeLook()
{
  AskHoldBQF();
}
//*******************************************************************
void TACVPAsk::AskHoldTripleBonus()
{
  AskHoldBQF();
}
//*******************************************************************
void TACVPAsk::AskHoldSuperDoubleJackpot()
{
  AskHoldBQH();
}
//*******************************************************************
void TACVPAsk::AskHoldTriplePlay()
{
  AskHoldBQH();
}
//*******************************************************************
void TACVPAsk::AskHoldDDownStud()
{
  expertRecomString = TAppString(5170);
  ExpertCode =456;return;
}
//*******************************************************************
void TACVPAsk::AskHold2WildBonus()
{
  AskHoldDWC();
}
//*******************************************************************
void TACVPAsk::AskHold2WildProg()
{
  AskHoldPRF();
}
//*******************************************************************
//*******************************************************************
void TACVPAsk::AskHoldSuitBonus(int16 suit)
{
  pOwnerLord->fake->inhand = 0;
  for(int16 i=0;i<5;i++)
  {
	 pOwnerLord->fake->cards[i].name = pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->cards[i].name;
	 pOwnerLord->fake->cards[i].suit = pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->cards[i].suit;
	 pOwnerLord->fake->inhand++;
  }
  pOwnerLord->pSmarts->Insert_Sort(pOwnerLord->fake);
  pOwnerLord->pSmarts->Holding(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand);
  pOwnerLord->pSmarts->Holding(pOwnerLord->fake);

	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 105)
	 {//royal 'hold all five cards of the royal flush'
		expertRecomString = TAppString(5003);
		ExpertCode =1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 99)
	 {
      if(pOwnerLord->fake->cards[4].name == AceHi)
		{
		  expertRecomString = TAppString(5003);
		  ExpertCode =1;return;
		}
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 99)
	 {//straight flush
		expertRecomString = TAppString(5006);
		ExpertCode =1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 71)
	 {//four o' kind
		expertRecomString = TAppString(5077);
		ExpertCode =20;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 70)
	 {//full house
		expertRecomString = TAppString(5010);
		ExpertCode =1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
		 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh > 3)
	 {// four to a royal
		if(pOwnerLord->fake->cards[0].name > Nine ||
			  (pOwnerLord->fake->cards[1].name > Nine &&
				(pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[2].suit) &&
				(pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[3].suit) &&
				(pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[4].suit)))
		{
		  expertRecomString = TAppString(5009);
		  ExpertCode =3;return;
		}
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 26 &&
       pOwnerLord->fake->cards[1].suit == suit)
	 { //flush, suited
		expertRecomString = TAppString(5016);
		ExpertCode =1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 &&
       pOwnerLord->fake->cards[2].suit == suit)
	 {//four to a outside straight flush, suited
		expertRecomString = TAppString(5019);
		ExpertCode =4;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 26)
	 { //flush
		expertRecomString = TAppString(5016);
		ExpertCode =1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 20)
	 {//three o' kind
		expertRecomString = TAppString(5018);
		ExpertCode =5;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 3 &&
       ((pOwnerLord->fake->cards[1].suit == suit && pOwnerLord->fake->cards[2].suit == suit) ||
       (pOwnerLord->fake->cards[0].suit == suit && pOwnerLord->fake->cards[3].suit == suit)) )
	 {//four to a inside straight flush, suited
		expertRecomString = TAppString(5019);
		ExpertCode =4;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 23)
	 {//straight
		expertRecomString = TAppString(5017);
		ExpertCode =1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3)
	 {//four to a outside straight flush
		expertRecomString = TAppString(5019);
		ExpertCode =4;return;
	 }
	 if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2 ||
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2) )
	 {//three to a royal, suited
		if(((pOwnerLord->fake->cards[0].name > Nine && pOwnerLord->fake->cards[0].suit == suit) &&
			((pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) )) ||
		  ((pOwnerLord->fake->cards[1].name > Nine  && pOwnerLord->fake->cards[1].suit == suit) &&
			((pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[1].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[1].suit) ||
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[1].suit) )) ||
		  ((pOwnerLord->fake->cards[2].name > Nine  && pOwnerLord->fake->cards[2].suit == suit)&&
			(pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[2].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[2].suit)))
		{
		  expertRecomString = TAppString(5021);
		  ExpertCode =6;return;
		}
	 }
    if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 15)
	 {//two pair
		expertRecomString = TAppString(5050);
		ExpertCode =15;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh > 3)
	 {//four to a inside straight flush
		expertRecomString = TAppString(5019);
		ExpertCode =4;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->toflush > 3 &&
       ((pOwnerLord->fake->cards[1].suit == suit && pOwnerLord->fake->cards[2].suit == suit) ||
        (pOwnerLord->fake->cards[0].suit == suit && pOwnerLord->fake->cards[3].suit == suit)))
	 {//four to a flush, suited
		expertRecomString = TAppString(5029);
		ExpertCode =9;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2 ||
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2 )
	 {//three to a royal
		if((pOwnerLord->fake->cards[0].name > Nine &&
			((pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) )) ||
		  (pOwnerLord->fake->cards[1].name > Nine &&
			((pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[1].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[1].suit) ||
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[1].suit) )) ||
		  (pOwnerLord->fake->cards[2].name > Nine &&
			(pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[2].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[2].suit)))
		{
		  expertRecomString = TAppString(5021);
		  ExpertCode =6;return;
		}
	 }
	 if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 10)&&
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highcard > Ten)
	 {//high pair
		expertRecomString = TAppString(5082);
		ExpertCode =27;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->toflush > 3)
	 {//four to a flush
		expertRecomString = TAppString(5029);
		ExpertCode =9;return;
	 }
	 if(((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2 &&
         pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflshsuit == suit)  ||
		  (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2 &&
         pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflshsuit == suit))   )
	 {//three to a straight flush, suited
		expertRecomString = TAppString(5044);
		ExpertCode =22;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 10)
	 {// pair(low)
		expertRecomString = TAppString(5028);
		ExpertCode =16;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrght > 3)
	 {//four to outside straight
		expertRecomString = TAppString(5045);
		ExpertCode =10;return;
	 }
	 if(((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 1) ||
		  (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 1)) &&
		  ( (pOwnerLord->fake->cards[2].name > Nine &&
			 ((pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[2].suit &&
            pOwnerLord->fake->cards[3].suit == suit)                            ||
			  (pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[2].suit &&
            pOwnerLord->fake->cards[4].suit == suit)))                          ||
			 (pOwnerLord->fake->cards[3].name > Nine &&
			 ((pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[3].suit &&
            pOwnerLord->fake->cards[3].suit == suit))) )                               )
	 {//two to a royal, suited
		expertRecomString = TAppString(5031);
		ExpertCode =18;return;
	 }
	 if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2) ||
		 (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2))
	 {//three to a straight flush
		expertRecomString = TAppString(5044);
		ExpertCode =541;return;
	 }
	 if(pOwnerLord->fake->cards[1].name == Jack   &&
		 pOwnerLord->fake->cards[2].name == Queen  &&
		 pOwnerLord->fake->cards[3].name == King   &&
       pOwnerLord->fake->cards[4].name == AceHi)
	 {//A-k-q-j
		expertRecomString = TAppString(5151);
		ExpertCode =518;return;
	 }
	 if(pOwnerLord->fake->cards[2].name == Jack   &&
		 pOwnerLord->fake->cards[3].name == Queen  &&
		 pOwnerLord->fake->cards[4].name == King     )
	 {//k-q-j
		expertRecomString = TAppString(5093);
		ExpertCode =31;return;
	 }
	 if(((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 1) ||
		  (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 1)) &&
		  ( (pOwnerLord->fake->cards[2].name > Nine &&
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[2].suit ||
			  pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[2].suit)) ||
			 (pOwnerLord->fake->cards[3].name > Nine &&
			 (pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[3].suit)) ))
	 {//two to a royal(10)
      expertRecomString = TAppString(5031);
		ExpertCode =18;return;
	 }
	 if(pOwnerLord->fake->cards[3].name > Ten  ||
		 pOwnerLord->fake->cards[4].name > Ten    )
	 {//1-2 high cards
		expertRecomString = TAppString(5150);
		ExpertCode =519;return;
	 }
    expertRecomString = TAppString(5032);    //garbage
	 ExpertCode =13;return;
}
//*******************************************************************
void TACVPAsk::AskHoldJokerB()
{
  pOwnerLord->GetNumOfWildCards();
  pOwnerLord->WildJoker(TRUE);


  if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->wildcount)
  {
		switch(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand){
		  case 105 : expertRecomString = TAppString(5006); //rf, joker
						 ExpertCode = 1;return;
		  case 100 : expertRecomString = TAppString(5004); //5 kind
						 ExpertCode = 1;return;
		  case  99 : expertRecomString = TAppString(5006);//sf
						 ExpertCode = 1;return;
		  case  71 : expertRecomString = TAppString(5007);//4 kind
						 ExpertCode = 508;return;
		}
		if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
			 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh > 3)  )
		{ // four to a royal flush
		  if(pOwnerLord->fake->cards[1].name > Nine ||
			  (pOwnerLord->fake->cards[2].name > Nine &&
				(pOwnerLord->fake->cards[2].name < pOwnerLord->fake->cards[3].name &&
				 pOwnerLord->fake->cards[3].name < pOwnerLord->fake->cards[4].name) &&
				 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[3].suit &&
				  pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[4].suit)))
		  {
			 expertRecomString = TAppString(5009);
			 ExpertCode = 509;return;
		  }
		}
		if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
			 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh > 3) )
		{ // four to a straight flush
		  expertRecomString = TAppString(5019);
		  ExpertCode = 510;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 70)
	   {//full house
		  expertRecomString = TAppString(5010);
		  ExpertCode = 1;return;
	   }
	   if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 26)
		{ //flush
		  expertRecomString = TAppString(5016);
		  ExpertCode = 1;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 23)
		{//straight
		  expertRecomString = TAppString(5017);
		  ExpertCode = 1;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 20)
		{// three o' kind
		  expertRecomString = TAppString(5018);
		  ExpertCode = 511;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh  > 2)
		{//three to straight flush(outside)
		  expertRecomString = TAppString(5042);
		  ExpertCode = 512;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2)
		{//three to straight flush(inside)
		  expertRecomString = TAppString(5042);
		  ExpertCode = 517;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrght  > 3)
		{//four card straight(outside)
		  expertRecomString = TAppString(5030);
		  ExpertCode = 520;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->toflush  > 3)
		{//four to flush
		  expertRecomString = TAppString(5043);
		  ExpertCode = 515;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrght  > 3)
		{//four to inside straight
		  expertRecomString = TAppString(5045);
		  ExpertCode = 521;return;
		}
		expertRecomString = TAppString(5046);
		ExpertCode = 516;return;

  }
  else // no wild cards
  {
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 105)
	 {//royal
		expertRecomString = TAppString(5024);
		ExpertCode = 1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 99)
	 {
		if(pOwnerLord->fake->cards[4].name == AceHi)
		{
		  expertRecomString = TAppString(5003);
		  ExpertCode =1;return;
		}
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 99)
	 {//straight flush
		expertRecomString = TAppString(5006);
		ExpertCode = 1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 71)
	 {//four o' kind
		expertRecomString = TAppString(5007);
		ExpertCode = 2;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 70)
	 {//full house
		expertRecomString = TAppString(5010);
		ExpertCode = 1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
		 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh > 3)
	 {// four to a royal
		if(pOwnerLord->fake->cards[1].name > Nine ||
			  (pOwnerLord->fake->cards[2].name > Nine &&
				(pOwnerLord->fake->cards[2].name < pOwnerLord->fake->cards[3].name &&
				 pOwnerLord->fake->cards[3].name < pOwnerLord->fake->cards[4].name) &&
				 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[3].suit &&
				  pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[4].suit)))
		{
		  expertRecomString = TAppString(5009);
		  ExpertCode = 3;return;
		}
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3)
	 {//four to a straight flush
		expertRecomString = TAppString(5019);
		ExpertCode = 4;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 26)
	 { //flush
		expertRecomString = TAppString(5016);
		ExpertCode = 1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 20)
	 {//three o' kind
		expertRecomString = TAppString(5018);
		ExpertCode = 5;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 23)
	 {//straight
		expertRecomString = TAppString(5017);
		ExpertCode = 1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 3)
	 {//four to a inside straight flush
		expertRecomString = TAppString(5019);
		ExpertCode = 4;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 15)
	 {//two pair
		expertRecomString = TAppString(5050);
		ExpertCode = 15;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->toflush > 3)
	 {//four to a flush
		expertRecomString = TAppString(5029);
		ExpertCode = 9;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2 ||
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2 )
	 {//three to a royal
		if((pOwnerLord->fake->cards[0].name > Nine &&
			((pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) )) ||
		  (pOwnerLord->fake->cards[1].name > Nine &&
			((pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[1].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[1].suit) ||
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[1].suit) )) ||
		  (pOwnerLord->fake->cards[2].name > Nine &&
			(pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[2].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[2].suit)))

		{
		  expertRecomString = TAppString(5021);
		  ExpertCode = 6;return;
		}

	 }
	 if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2) ||
		 (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2))
	 {//three to a straight flush
		expertRecomString = TAppString(5044);
		ExpertCode = 541;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrght > 3)
	 {//four to straight(outside)
		expertRecomString = TAppString(5045);
		ExpertCode = 7;return;
	 }
	 if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 10) ||
		 (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 15))
	 {//any pair
		expertRecomString = TAppString(5028);
		ExpertCode = 16;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrght > 3)
	 { //four to a straight(inside)
		expertRecomString = TAppString(5045);
		ExpertCode = 38;return;
	 }
	 if(((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 1) ||
		  (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 1)) &&
		  ( (pOwnerLord->fake->cards[2].name > Nine &&
			 ((pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[2].suit &&
            pOwnerLord->fake->cards[3].name != AceHi) ||
			  (pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[2].suit &&
            pOwnerLord->fake->cards[4].name != AceHi))) ||
			 (pOwnerLord->fake->cards[3].name > Nine &&
			 (pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[3].suit &&
           pOwnerLord->fake->cards[4].name != AceHi)) ))
	 {//two to a royal, no ace
		expertRecomString = TAppString(5031);
		ExpertCode = 18;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->toflush > 2)
	 { //three to a flush
		expertRecomString = TAppString(5054);
		ExpertCode = 17;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 1)
	 {//two to a straight flush
		expertRecomString = TAppString(5055);
		ExpertCode = 19;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrght > 2)
	 {//three to a outside straight
		expertRecomString = TAppString(5047);
		ExpertCode = 11;return;
	 }
	 expertRecomString = TAppString(5032);    //garbage
	 ExpertCode = 13;return;
  }
}
//*******************************************************************
//*******************************************************************
void TACVPAsk::AskHoldJokerC()
{
  pOwnerLord->GetNumOfWildCards();
  pOwnerLord->WildJoker(TRUE);


  if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->wildcount)
  {
		switch(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand){
		  case 105 : expertRecomString = TAppString(5001); //rf, joker
						 ExpertCode = 1;return;
		  case 100 : expertRecomString = TAppString(5004); //5 kind
						 ExpertCode = 1;return;
		  case  99 : expertRecomString = TAppString(5006);//sf
						 ExpertCode = 1;return;
		  case  71 : expertRecomString = TAppString(5007);//4 kind
						 ExpertCode = 508;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 70)
	   {//full house
		  expertRecomString = TAppString(5010);
		  ExpertCode = 1;return;
	   }
	   if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
			 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh > 3)  )
		{ // four to a royal flush
		  if(pOwnerLord->fake->cards[1].name > Nine ||
			  (pOwnerLord->fake->cards[2].name > Nine &&
				(pOwnerLord->fake->cards[2].name < pOwnerLord->fake->cards[3].name &&
				 pOwnerLord->fake->cards[3].name < pOwnerLord->fake->cards[4].name) &&
				 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[3].suit &&
				  pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[4].suit)))
		  {
			 expertRecomString = TAppString(5009);
			 ExpertCode = 509;return;
		  }
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 26)
		{ //flush
		  expertRecomString = TAppString(5016);
		  ExpertCode = 1;return;
		}
		if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
			 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh > 3) )
		{ // four to a straight flush
		  expertRecomString = TAppString(5019);
		  ExpertCode = 510;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 20)
		{// three o' kind
		  expertRecomString = TAppString(5018);
		  ExpertCode = 511;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 23)
		{//straight
		  expertRecomString = TAppString(5017);
		  ExpertCode = 1;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->toflush  > 3 &&
         pOwnerLord->fake->cards[4].name > Queen                                    )
		{//four to flush with 1-2 high cards
		  expertRecomString = TAppString(5043);
		  ExpertCode = 515;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2 ||
		    pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2 )
	   {//three to a royal
		  if(pOwnerLord->fake->cards[0].name > Nine ||
		    (pOwnerLord->fake->cards[1].name > Nine &&
		     (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[1].suit || pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[1].suit)) ||
          (pOwnerLord->fake->cards[2].name > Nine &&
			  (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[2].suit ))                                                                        )
		  {
		    expertRecomString = TAppString(5021);
		    ExpertCode = 513;return;
		  }
	   }
	   if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh  > 2)
		{//three to straight flush(outside)
		  expertRecomString = TAppString(5042);
		  ExpertCode = 512;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2)
		{//three to straight flush(inside)
		  expertRecomString = TAppString(5042);
		  ExpertCode = 517;return;
		}
		if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 10) &&
		   (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highcard > Queen))
	   {//High pair
		  expertRecomString = TAppString(5028);
		  ExpertCode = 522;return;
	   }
	   if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrght  > 3)
		{//four card straight(outside)
		  expertRecomString = TAppString(5030);
		  ExpertCode = 520;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->toflush  > 3)
		{//four to flush
		  expertRecomString = TAppString(5043);
		  ExpertCode = 515;return;
		}
		if(pOwnerLord->fake->cards[3].name  > Queen)
		{//Joker and HC
		  expertRecomString = TAppString(5059);
		  ExpertCode = 545;return;
		}
		expertRecomString = TAppString(5046);
		ExpertCode = 516;return;
  }
  else // no wild cards
  {
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 105)
	 {//royal nat.
		expertRecomString = TAppString(5024);
		ExpertCode = 1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 99)
	 {
		if(pOwnerLord->fake->cards[4].name == AceHi)
		{
		  expertRecomString = TAppString(5003);
		  ExpertCode =1;return;
		}
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 99)
	 {//straight flush
		expertRecomString = TAppString(5006);
		ExpertCode = 1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 71)
	 {//four o' kind
		expertRecomString = TAppString(5007);
		ExpertCode = 2;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
		 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh > 3)
	 {// four to a royal
		if(pOwnerLord->fake->cards[1].name > Nine ||
			  (pOwnerLord->fake->cards[2].name > Nine &&
				(pOwnerLord->fake->cards[2].name < pOwnerLord->fake->cards[3].name &&
				 pOwnerLord->fake->cards[3].name < pOwnerLord->fake->cards[4].name) &&
				 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[3].suit &&
				  pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[4].suit)))
		{
		  expertRecomString = TAppString(5009);
		  ExpertCode = 3;return;
		}
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 70)
	 {//full house
		expertRecomString = TAppString(5010);
		ExpertCode = 1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 26)
	 { //flush
		expertRecomString = TAppString(5016);
		ExpertCode = 1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 20)
	 {//three o' kind
		expertRecomString = TAppString(5018);
		ExpertCode = 5;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3)
	 {//four to a outside straight flush
		expertRecomString = TAppString(5019);
		ExpertCode = 4;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 3)
	 {//four to a inside straight flush
		expertRecomString = TAppString(5019);
		ExpertCode = 4;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 23)
	 {//straight
		expertRecomString = TAppString(5017);
		ExpertCode = 1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 15)
	 {//two pair
		expertRecomString = TAppString(5050);
		ExpertCode = 15;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2 ||
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2 )
	 {//three to a royal
		if((pOwnerLord->fake->cards[0].name > Nine &&
			((pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) )) ||
		  (pOwnerLord->fake->cards[1].name > Nine &&
			((pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[1].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[1].suit) ||
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[1].suit) )) ||
		  (pOwnerLord->fake->cards[2].name > Nine &&
			(pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[2].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[2].suit)))

		{
		  expertRecomString = TAppString(5021);
		  ExpertCode = 6;return;
		}

	 }
	 if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 10) &&
	    (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highcard > Queen))
	 {//High pair
	   expertRecomString = TAppString(5028);
	   ExpertCode = 16;return;
	 }
    if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->toflush > 3)
	 {//four to a flush
		expertRecomString = TAppString(5029);
		ExpertCode = 9;return;
	 }
	 if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 10) ||
		 (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 15))
	 {//any pair
		expertRecomString = TAppString(5028);
		ExpertCode = 16;return;
	 }
	 if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2) ||
		 (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2))
	 {//three to a straight flush
		expertRecomString = TAppString(5044);
		ExpertCode = 541;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrght > 3)
	 {//four to straight(outside)
		expertRecomString = TAppString(5045);
		ExpertCode = 7;return;
	 }
	 if(((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 1) ||
		  (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 1)) &&
		  ( (pOwnerLord->fake->cards[2].name > Nine &&
			 ((pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[2].suit) ||
			  (pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[2].suit))) ||
			 (pOwnerLord->fake->cards[3].name > Nine &&
			 (pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[3].suit)) ))
	 {//two to a royal
		expertRecomString = TAppString(5031);
		ExpertCode = 18;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->toflush > 2)
	 { //three to a flush
		expertRecomString = TAppString(5054);
		ExpertCode = 17;return;
	 }
	 if(pOwnerLord->fake->cards[3].name > Queen  ||
		 pOwnerLord->fake->cards[4].name > Queen    )
	 {//1-2 high cards
		expertRecomString = TAppString(5150);
		ExpertCode =544;return;
	 }
    expertRecomString = TAppString(5032);    //garbage
	 ExpertCode = 13;return;
  }
}
//*******************************************************************
//*******************************************************************
void TACVPAsk::AskHoldJokerA()
{
  pOwnerLord->GetNumOfWildCards();
  pOwnerLord->WildJoker(TRUE);


  if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->wildcount)
  {
		switch(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand){
		  case 105 : expertRecomString = TAppString(5001); //rf, joker
						 ExpertCode = 1;return;
		  case 100 : expertRecomString = TAppString(5004); //5 kind
						 ExpertCode = 1;return;
		  case  99 : expertRecomString = TAppString(5006);//sf
						 ExpertCode = 1;return;
		  case  71 : expertRecomString = TAppString(5007);//4 kind
						 ExpertCode = 508;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 70)
	   {//full house
		  expertRecomString = TAppString(5010);
		  ExpertCode = 1;return;
	   }
	   if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 26)
		{ //flush
		  expertRecomString = TAppString(5016);
		  ExpertCode = 1;return;
		}
		if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
			 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh > 3)  )
		{ // four to a royal flush
		  if(pOwnerLord->fake->cards[1].name > Nine ||
			  (pOwnerLord->fake->cards[2].name > Nine &&
				(pOwnerLord->fake->cards[2].name < pOwnerLord->fake->cards[3].name &&
				 pOwnerLord->fake->cards[3].name < pOwnerLord->fake->cards[4].name) &&
				 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[3].suit &&
				  pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[4].suit)))
		  {
			 expertRecomString = TAppString(5009);
			 ExpertCode = 509;return;
		  }
		}
		if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
			 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh > 3) )
		{ // four to a straight flush
		  expertRecomString = TAppString(5019);
		  ExpertCode = 510;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 23)
		{//straight
		  expertRecomString = TAppString(5017);
		  ExpertCode = 1;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 20)
		{// three o' kind
		  expertRecomString = TAppString(5018);
		  ExpertCode = 511;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh  > 2)
		{//three to straight flush(outside)
		  expertRecomString = TAppString(5042);
		  ExpertCode = 512;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2)
		{//three to straight flush(inside)
		  expertRecomString = TAppString(5042);
		  ExpertCode = 517;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->toflush  > 3)
		{//four to flush
		  expertRecomString = TAppString(5043);
		  ExpertCode = 515;return;
		}
	   if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrght  > 3 ||
         pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrght   > 3   )
		{//four card straight
		  expertRecomString = TAppString(5030);
		  ExpertCode = 514;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrght  > 2)
		{//three card outside straight
		  expertRecomString = TAppString(5030);
		  ExpertCode = 7;return;
		}
		expertRecomString = TAppString(5046);
		ExpertCode = 516;return;
  }
  else // no wild cards
  {
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 105)
	 {//royal nat.
		expertRecomString = TAppString(5024);
		ExpertCode = 1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 99)
	 {
		if(pOwnerLord->fake->cards[4].name == AceHi)
		{
		  expertRecomString = TAppString(5003);
		  ExpertCode =1;return;
		}
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 99)
	 {//straight flush
		expertRecomString = TAppString(5006);
		ExpertCode = 1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
		 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh > 3)
	 {// four to a royal
		if(pOwnerLord->fake->cards[1].name > Nine ||
			  (pOwnerLord->fake->cards[2].name > Nine &&
				(pOwnerLord->fake->cards[2].name < pOwnerLord->fake->cards[3].name &&
				 pOwnerLord->fake->cards[3].name < pOwnerLord->fake->cards[4].name) &&
				 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[3].suit &&
				  pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[4].suit)))
		{
		  expertRecomString = TAppString(5009);
		  ExpertCode = 3;return;
		}
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 71)
	 {//four o' kind
		expertRecomString = TAppString(5007);
		ExpertCode = 2;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 70)
	 {//full house
		expertRecomString = TAppString(5010);
		ExpertCode = 1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 26)
	 { //flush
		expertRecomString = TAppString(5016);
		ExpertCode = 1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 23)
	 {//straight
		expertRecomString = TAppString(5017);
		ExpertCode = 1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3)
	 {//four to a outside straight flush
		expertRecomString = TAppString(5019);
		ExpertCode = 4;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 3)
	 {//four to a inside straight flush
		expertRecomString = TAppString(5019);
		ExpertCode = 4;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 20)
	 {//three o' kind
		expertRecomString = TAppString(5018);
		ExpertCode = 5;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 15)
	 {//two pair
		expertRecomString = TAppString(5050);
		ExpertCode = 15;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2 ||
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2 )
	 {//three to a royal
		if((pOwnerLord->fake->cards[0].name > Nine &&
			((pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) )) ||
		  (pOwnerLord->fake->cards[1].name > Nine &&
			((pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[1].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[1].suit) ||
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[1].suit) )) ||
		  (pOwnerLord->fake->cards[2].name > Nine &&
			(pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[2].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[2].suit)))

		{
		  expertRecomString = TAppString(5021);
		  ExpertCode = 6;return;
		}

	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->toflush > 3)
	 {//four to a flush
		expertRecomString = TAppString(5029);
		ExpertCode = 9;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrght > 3)
	 {//four to straight(outside)
		expertRecomString = TAppString(5045);
		ExpertCode = 7;return;
	 }
	 if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2) ||
		 (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2))
	 {//three to a straight flush
		expertRecomString = TAppString(5044);
		ExpertCode = 541;return;
	 }
    if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 10) ||
		 (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 15))
	 {//any pair
		expertRecomString = TAppString(5028);
		ExpertCode = 16;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrght > 3)
	 {//four to straight(inside)
		expertRecomString = TAppString(5045);
		ExpertCode = 531;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->toflush > 2)
	 { //three to a flush
		expertRecomString = TAppString(5054);
		ExpertCode = 17;return;
	 }
	 if(((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 1) ||
		  (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 1)) &&
		  ( (pOwnerLord->fake->cards[2].name > Nine &&
			 ((pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[2].suit) ||
			  (pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[2].suit))) ||
			 (pOwnerLord->fake->cards[3].name > Nine &&
			 (pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[3].suit)) ))
	 {//two to a royal
		expertRecomString = TAppString(5031);
		ExpertCode = 18;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrght > 2)
	 {//three to straight(outside)
		expertRecomString = TAppString(5047);
		ExpertCode = 539;return;
	 }
    if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 1 ||
       pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 1   )
	 {//two to a straight flush
		expertRecomString = TAppString(5055);
		ExpertCode = 529;return;
	 }
	 expertRecomString = TAppString(5032);    //garbage
	 ExpertCode = 13;return;
  }
}
//*******************************************************************
//*******************************************************************
void TACVPAsk::AskHoldFiveJokers()
{
  pOwnerLord->GetNumOfWildCards();
  pOwnerLord->WildJoker5(TRUE);


  if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->wildcount)
  {
    if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->wildcount > 3)
    {
		switch(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand)
      {
		  case 130 : expertRecomString = TAppString(5152); // five jokers
						 ExpertCode = 1;return;
        case 120 : expertRecomString = TAppString(5153); // four jokers
						 ExpertCode = 553;return;
      }
    }
    if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->wildcount == 3)
    {
      switch(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand)
      {
		  case 100 : expertRecomString = TAppString(5004); //5 kind
						 ExpertCode = 1;return;
		  case 105 : expertRecomString = TAppString(5001);// wild rf
						 ExpertCode = 1;return;
      }
      expertRecomString = TAppString(5154);// 3 jokers
		ExpertCode = 504;return;
    }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->wildcount == 2)
    {
      switch(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand)
      {
		  case 105 : expertRecomString = TAppString(5001); //rf, joker
						 ExpertCode = 1;return;
		  case 100 : expertRecomString = TAppString(5004); //5 kind
						 ExpertCode = 1;return;
		  case  99 : expertRecomString = TAppString(5006);//sf
						 ExpertCode = 1;return;
		  case  71 : expertRecomString = TAppString(5007);//4 kind
						 ExpertCode = 502;return;
		}
      if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
			 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh > 3)  )
		{ // four to a royal flush
		  if(pOwnerLord->fake->cards[1].name > Nine ||
			  (pOwnerLord->fake->cards[2].name > Nine &&
				(pOwnerLord->fake->cards[2].name < pOwnerLord->fake->cards[3].name &&
				 pOwnerLord->fake->cards[3].name < pOwnerLord->fake->cards[4].name) &&
				 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[3].suit &&
				  pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[4].suit)))
		  {
			 expertRecomString = TAppString(5009);
			 ExpertCode = 505;return;
		  }
		}
      if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 26)
		{ //flush
		  expertRecomString = TAppString(5016);
		  ExpertCode = 1;return;
		}
      if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
			 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh > 3) )
		{ // four to a straight flush
		  expertRecomString = TAppString(5019);
		  ExpertCode = 506;return;
		}
      expertRecomString = TAppString(5155);
      ExpertCode = 507;return;
    }
    if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->wildcount == 1)
    {
      switch(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand)
      {
		  case 105 : expertRecomString = TAppString(5001); //rf, joker
						 ExpertCode = 1;return;
		  case 100 : expertRecomString = TAppString(5004); //5 kind
						 ExpertCode = 1;return;
		  case  99 : expertRecomString = TAppString(5006);//sf
						 ExpertCode = 1;return;
		  case  71 : expertRecomString = TAppString(5007);//4 kind
						 ExpertCode = 508;return;
		}
      if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 70)
	   {//full house
		  expertRecomString = TAppString(5010);
		  ExpertCode = 1;return;
	   }
	   if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 26)
		{ //flush
		  expertRecomString = TAppString(5016);
		  ExpertCode = 1;return;
		}
		if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
			 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh > 3)  )
		{ // four to a royal flush
		  if(pOwnerLord->fake->cards[1].name > Nine ||
			  (pOwnerLord->fake->cards[2].name > Nine &&
				(pOwnerLord->fake->cards[2].name < pOwnerLord->fake->cards[3].name &&
				 pOwnerLord->fake->cards[3].name < pOwnerLord->fake->cards[4].name) &&
				 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[3].suit &&
				  pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[4].suit)))
		  {
			 expertRecomString = TAppString(5009);
			 ExpertCode = 509;return;
		  }
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 23)
		{//straight
		  expertRecomString = TAppString(5017);
		  ExpertCode = 1;return;
		}
		if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
			 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh > 3) )
		{ // four to a straight flush
		  expertRecomString = TAppString(5019);
		  ExpertCode = 510;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 20)
		{// three o' kind
		  expertRecomString = TAppString(5018);
		  ExpertCode = 511;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh  > 2)
		{//three to straight flush(outside)
		  expertRecomString = TAppString(5042);
		  ExpertCode = 512;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2)
		{//three to straight flush(inside)
		  expertRecomString = TAppString(5042);
		  ExpertCode = 517;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2 ||
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2 )
	   {//three to a royal
		  if((pOwnerLord->fake->cards[0].name > Nine &&
			  ((pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit) ||
			   (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit) ||
			   (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) ||
			   (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit) ||
			   (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) ||
		    	 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) )) ||
		    (pOwnerLord->fake->cards[1].name > Nine &&
		    	((pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[1].suit) ||
		    	 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[1].suit) ||
		    	 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[1].suit) )) ||
		    (pOwnerLord->fake->cards[2].name > Nine &&
		   	(pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[2].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[2].suit)))
		  {
		    expertRecomString = TAppString(5021);
		    ExpertCode = 513;return;
		  }
	   }
      if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrght  > 3 ||
         pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrght   > 3   )
		{//four card straight
		  expertRecomString = TAppString(5030);
		  ExpertCode = 514;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->toflush  > 3)
		{//four to flush
		  expertRecomString = TAppString(5043);
		  ExpertCode = 515;return;
		}
		expertRecomString = TAppString(5046);
		ExpertCode = 516;return;
    }
  }
  else // no wild cards
  {
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 105)
	 {//royal nat.
		expertRecomString = TAppString(5024);
		ExpertCode = 1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 99)
	 {
		if(pOwnerLord->fake->cards[4].name == AceHi)
		{
		  expertRecomString = TAppString(5003);
		  ExpertCode =1;return;
		}
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
		 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh > 3)
	 {// four to a royal
		if(pOwnerLord->fake->cards[1].name > Nine ||
			  (pOwnerLord->fake->cards[2].name > Nine &&
				(pOwnerLord->fake->cards[2].name < pOwnerLord->fake->cards[3].name &&
				 pOwnerLord->fake->cards[3].name < pOwnerLord->fake->cards[4].name) &&
				 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[3].suit &&
				  pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[4].suit)))
		{
		  expertRecomString = TAppString(5009);
		  ExpertCode = 3;return;
		}
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 99)
	 {//straight flush
		expertRecomString = TAppString(5006);
		ExpertCode = 1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 71)
	 {//four o' kind
		expertRecomString = TAppString(5007);
		ExpertCode = 2;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 70)
	 {//full house
		expertRecomString = TAppString(5010);
		ExpertCode = 1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 26)
	 { //flush
		expertRecomString = TAppString(5016);
		ExpertCode = 1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 23)
	 {//straight
		expertRecomString = TAppString(5017);
		ExpertCode = 1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 20)
	 {//three o' kind
		expertRecomString = TAppString(5018);
		ExpertCode = 5;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3)
	 {//four to a outside straight flush
		expertRecomString = TAppString(5019);
		ExpertCode = 4;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 3)
	 {//four to a inside straight flush
		expertRecomString = TAppString(5019);
		ExpertCode = 4;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2 ||
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2 )
	 {//three to a royal
		if((pOwnerLord->fake->cards[0].name > Nine &&
			((pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) )) ||
		  (pOwnerLord->fake->cards[1].name > Nine &&
			((pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[1].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[1].suit) ||
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[1].suit) )) ||
		  (pOwnerLord->fake->cards[2].name > Nine &&
			(pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[2].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[2].suit)))

		{
		  expertRecomString = TAppString(5021);
		  ExpertCode = 6;return;
		}

	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->toflush > 3)
	 {//four to a flush
		expertRecomString = TAppString(5029);
		ExpertCode = 9;return;
	 }
	 if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2) ||
		 (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2))
	 {//three to a straight flush
		expertRecomString = TAppString(5044);
		ExpertCode = 541;return;
	 }
    if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 15)
	 {//two pair
		expertRecomString = TAppString(5050);
		ExpertCode = 15;return;
	 }
	 if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 10) ||
		 (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 15))
	 {//any pair
		expertRecomString = TAppString(5028);
		ExpertCode = 16;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrght > 3)
	 {//four to straight(outside)
		expertRecomString = TAppString(5045);
		ExpertCode = 7;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrght > 3)
	 {//four to straight(inside)
		expertRecomString = TAppString(5045);
		ExpertCode = 7;return;
	 }
	 expertRecomString = TAppString(5032);    //garbage
	 ExpertCode = 13;return;
  }
}
//*******************************************************************
//*******************************************************************
void TACVPAsk::AskHold7sOneJoker()
{
  pOwnerLord->GetNumOfWildCards();
  pOwnerLord->WildSevensJoker(TRUE);


  if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->wildcount)
  {
    if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->wildcount == 5)
    {
      expertRecomString = TAppString(5156); // 4 sevens and a  jokers
	   ExpertCode = 1;return;
    }
    if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->wildcount == 4)
    {
      expertRecomString = TAppString(5157); // 4 wild cards
	   ExpertCode = 553;return;
    }
    if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->wildcount == 3)
    {
      switch(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand)
      {
		  case 100 : expertRecomString = TAppString(5004); //5 kind
						 ExpertCode = 1;return;
		  case 105 : expertRecomString = TAppString(5001);// wild rf
						 ExpertCode = 1;return;
      }
      expertRecomString = TAppString(5158);// 3 wild
		ExpertCode = 504;return;
    }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->wildcount == 2)
    {
      switch(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand)
      {
		  case 105 : expertRecomString = TAppString(5001); //rf, joker
						 ExpertCode = 1;return;
		  case 100 : expertRecomString = TAppString(5004); //5 kind
						 ExpertCode = 1;return;
		  case  99 : expertRecomString = TAppString(5006);//sf
						 ExpertCode = 1;return;
		  case  71 : expertRecomString = TAppString(5007);//4 kind
						 ExpertCode = 502;return;
		}
      if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
			 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh > 3)  )
		{ // four to a royal flush
		  if(pOwnerLord->fake->cards[1].name > Nine ||
			  (pOwnerLord->fake->cards[2].name > Nine &&
				(pOwnerLord->fake->cards[2].name < pOwnerLord->fake->cards[3].name &&
				 pOwnerLord->fake->cards[3].name < pOwnerLord->fake->cards[4].name) &&
				 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[3].suit &&
				  pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[4].suit)))
		  {
			 expertRecomString = TAppString(5009);
			 ExpertCode = 505;return;
		  }
		}
      if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 26)
		{ //flush
		  expertRecomString = TAppString(5016);
		  ExpertCode = 1;return;
		}
      if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
			 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh > 3) )
		{ // four to a straight flush
		  expertRecomString = TAppString(5019);
		  ExpertCode = 506;return;
		}
      expertRecomString = TAppString(5155);
      ExpertCode = 507;return;
    }
    if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->wildcount == 1)
    {
      switch(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand)
      {
		  case 105 : expertRecomString = TAppString(5001); //rf, joker
						 ExpertCode = 1;return;
		  case 100 : expertRecomString = TAppString(5004); //5 kind
						 ExpertCode = 1;return;
		  case  99 : expertRecomString = TAppString(5006);//sf
						 ExpertCode = 1;return;
		  case  71 : expertRecomString = TAppString(5007);//4 kind
						 ExpertCode = 508;return;
		}
      if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 70)
	   {//full house
		  expertRecomString = TAppString(5010);
		  ExpertCode = 1;return;
	   }
	   if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 26)
		{ //flush
		  expertRecomString = TAppString(5016);
		  ExpertCode = 1;return;
		}
		if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
			 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh > 3)  )
		{ // four to a royal flush
		  if(pOwnerLord->fake->cards[0].name > Nine ||
			  (pOwnerLord->fake->cards[1].name > Nine &&
            pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[2].suit &&
				pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[3].suit  ) )
		  {
			 expertRecomString = TAppString(5009);
			 ExpertCode = 509;return;
		  }
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 23)
		{//straight
		  expertRecomString = TAppString(5017);
		  ExpertCode = 1;return;
		}
		if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
			 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh > 3) )
		{ // four to a straight flush
		  expertRecomString = TAppString(5019);
		  ExpertCode = 510;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 20)
		{// three o' kind
		  expertRecomString = TAppString(5018);
		  ExpertCode = 511;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2 ||
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2 )
	   {//three to a royal
		  if(pOwnerLord->fake->cards[0].name > Nine ||
		    (pOwnerLord->fake->cards[1].name > Nine &&
		     ((pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[2].suit) ||
            (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[3].suit)   ) ) ||
		    (pOwnerLord->fake->cards[2].name > Nine &&
		   	(pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[2].suit))    )
		  {
		    expertRecomString = TAppString(5021);
		    ExpertCode = 513;return;
		  }
	   }
      if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh  > 2)
		{//three to straight flush(outside)
		  expertRecomString = TAppString(5042);
		  ExpertCode = 512;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2)
		{//three to straight flush(inside)
		  expertRecomString = TAppString(5042);
		  ExpertCode = 517;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrght  > 3 ||
         pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrght   > 3   )
		{//four card straight
		  expertRecomString = TAppString(5030);
		  ExpertCode = 514;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->toflush  > 3)
		{//four to flush
		  expertRecomString = TAppString(5043);
		  ExpertCode = 515;return;
		}
		expertRecomString = TAppString(5172);
		ExpertCode = 516;return;
    }
  }
  else // no wild cards
  {
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 105)
	 {//royal nat.
		expertRecomString = TAppString(5024);
		ExpertCode = 1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 99)
	 {
		if(pOwnerLord->fake->cards[4].name == AceHi)
		{
		  expertRecomString = TAppString(5003);
		  ExpertCode =1;return;
		}
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
		 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh > 3)
	 {// four to a royal
		if(pOwnerLord->fake->cards[1].name > Nine ||
			  (pOwnerLord->fake->cards[2].name > Nine &&
				(pOwnerLord->fake->cards[2].name < pOwnerLord->fake->cards[3].name &&
				 pOwnerLord->fake->cards[3].name < pOwnerLord->fake->cards[4].name) &&
				 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[3].suit &&
				  pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[4].suit)))
		{
		  expertRecomString = TAppString(5009);
		  ExpertCode = 3;return;
		}
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 99)
	 {//straight flush
		expertRecomString = TAppString(5006);
		ExpertCode = 1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 71)
	 {//four o' kind
		expertRecomString = TAppString(5007);
		ExpertCode = 2;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 70)
	 {//full house
		expertRecomString = TAppString(5010);
		ExpertCode = 1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 26)
	 { //flush
		expertRecomString = TAppString(5016);
		ExpertCode = 1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 23)
	 {//straight
		expertRecomString = TAppString(5017);
		ExpertCode = 1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 20)
	 {//three o' kind
		expertRecomString = TAppString(5018);
		ExpertCode = 5;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3)
	 {//four to a outside straight flush
		expertRecomString = TAppString(5019);
		ExpertCode = 4;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 3)
	 {//four to a inside straight flush
		expertRecomString = TAppString(5019);
		ExpertCode = 4;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2 ||
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2 )
	 {//three to a royal
		if((pOwnerLord->fake->cards[0].name > Nine &&
			((pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) )) ||
		  (pOwnerLord->fake->cards[1].name > Nine &&
			((pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[1].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[1].suit) ||
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[1].suit) )) ||
		  (pOwnerLord->fake->cards[2].name > Nine &&
			(pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[2].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[2].suit)))

		{
		  expertRecomString = TAppString(5021);
		  ExpertCode = 6;return;
		}

	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->toflush > 3)
	 {//four to a flush
		expertRecomString = TAppString(5029);
		ExpertCode = 9;return;
	 }
	 if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2) ||
		 (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2))
	 {//three to a straight flush
		expertRecomString = TAppString(5044);
		ExpertCode = 541;return;
	 }
    if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 15)
	 {//two pair
		expertRecomString = TAppString(5050);
		ExpertCode = 15;return;
	 }
	 if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 10) ||
		 (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 15))
	 {//any pair
		expertRecomString = TAppString(5028);
		ExpertCode = 16;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrght > 3)
	 {//four to straight(outside)
		expertRecomString = TAppString(5045);
		ExpertCode = 525;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrght > 3)
	 {//four to straight(inside)
		expertRecomString = TAppString(5045);
		ExpertCode = 531;return;
	 }
	 expertRecomString = TAppString(5032);    //garbage
	 ExpertCode = 13;return;
  }
}
//*******************************************************************
//*******************************************************************
void TACVPAsk::AskHoldBQC()
{
  pOwnerLord->fake->inhand = 0;
  for(int16 i=0;i<5;i++)
  {
	 pOwnerLord->fake->cards[i].name = pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->cards[i].name;
	 pOwnerLord->fake->cards[i].suit = pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->cards[i].suit;
	 pOwnerLord->fake->inhand++;
  }
  pOwnerLord->pSmarts->Insert_Sort(pOwnerLord->fake);
  pOwnerLord->pSmarts->Holding(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand);
  pOwnerLord->pSmarts->Holding(pOwnerLord->fake);

	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 105)
	 {//royal
		expertRecomString = TAppString(5003);
		ExpertCode =1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 99)
	 {
      if(pOwnerLord->fake->cards[4].name == AceHi)
		{
		  expertRecomString = TAppString(5003);
		  ExpertCode =1;return;
		}
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 99)
	 {//straight flush
		expertRecomString = TAppString(5006);
		ExpertCode =1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 71)
	 {//four o' kind
		expertRecomString = TAppString(5077);
		ExpertCode =20;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
		 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh > 3)
	 {// four to a royal
		if(pOwnerLord->fake->cards[0].name > Nine ||
			  (pOwnerLord->fake->cards[1].name > Nine &&
				(pOwnerLord->fake->cards[0].suit != pOwnerLord->fake->cards[1].suit) &&
				(pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[2].suit)))
		{
		  expertRecomString = TAppString(5009);
		  ExpertCode =3;return;
		}
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 70)
	 {//full house
		expertRecomString = TAppString(5010);
		ExpertCode =1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 26)
	 { //flush
		expertRecomString = TAppString(5016);
		ExpertCode =1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 20)
	 {//three o' kind
		expertRecomString = TAppString(5018);
		ExpertCode =5;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 23)
	 {//straight
		expertRecomString = TAppString(5017);
		ExpertCode =1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 15)
	 {//two pair
		expertRecomString = TAppString(5050);
		ExpertCode =15;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 3 )
	 {//four to a straight flush
		expertRecomString = TAppString(5019);
		ExpertCode =4;return;
	 }
	 if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 10)&&
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highcard > Ten)
	 {//high pair
		expertRecomString = TAppString(5082);
		ExpertCode =27;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2 ||
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2 )
	 {//three to a royal
		if((pOwnerLord->fake->cards[0].name > Nine &&
			((pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) )) ||
		  (pOwnerLord->fake->cards[1].name > Nine &&
			((pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[1].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[1].suit) ||
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[1].suit) )) ||
		  (pOwnerLord->fake->cards[2].name > Nine &&
			(pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[2].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[2].suit)))

		{
		  expertRecomString = TAppString(5021);
		  ExpertCode =6;return;
		}

	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->toflush > 3)
	 {//four to a flush
		expertRecomString = TAppString(5029);
		ExpertCode =9;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 10)
	 {// pair(low)
		expertRecomString = TAppString(5028);
		ExpertCode =16;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrght > 3  &&
       ((pOwnerLord->fake->cards[4].name > Ten &&
         pOwnerLord->fake->cards[4].suit ==
         pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highcardsuit) ||
        (pOwnerLord->fake->cards[3].name > Ten &&
         pOwnerLord->fake->cards[3].suit ==
         pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highcardsuit) )  )
	 {//four to straight and 1-3 high cards
		  expertRecomString = TAppString(5045);
		  ExpertCode =523;return;
	 }
    if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2) ||
		 (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2))
	 {//three to a straight flush, 9-10-j
      if((pOwnerLord->fake->cards[0].name == Nine &&
          pOwnerLord->fake->cards[1].name == Ten  &&
          pOwnerLord->fake->cards[2].name == Jack &&
          pOwnerLord->fake->cards[0].suit == pOwnerLord->fake->cards[1].suit &&
          pOwnerLord->fake->cards[0].suit == pOwnerLord->fake->cards[2].suit)    ||
         (pOwnerLord->fake->cards[1].name == Nine &&
          pOwnerLord->fake->cards[2].name == Ten  &&
          pOwnerLord->fake->cards[3].name == Jack &&
          pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[2].suit &&
          pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[3].suit)    ||
         (pOwnerLord->fake->cards[2].name == Nine &&
          pOwnerLord->fake->cards[3].name == Ten  &&
          pOwnerLord->fake->cards[4].name == Jack &&
          pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[4].suit &&
          pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[3].suit)      )
       {
		   expertRecomString = TAppString(5159);
		   ExpertCode = 524;return;
       }
	 }
    if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrght > 3)
	 {//four to outside straight
		expertRecomString = TAppString(5045);
		ExpertCode =525;return;
	 }
	 if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2) ||
		 (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2))
	 {//three to a straight flush
      expertRecomString = TAppString(5044);
		ExpertCode = 541;return;
    }
    if(pOwnerLord->fake->cards[1].name == Jack   &&
       pOwnerLord->fake->cards[4].name == AceHi   &&
		 pOwnerLord->fake->cards[2].name == Queen  &&
		 pOwnerLord->fake->cards[3].name == King)
	 {//a-k-q-j
		expertRecomString = TAppString(5151);
		ExpertCode =518;return;
	 }
	 if(((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 1) ||
		  (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 1)) &&
		  ( (pOwnerLord->fake->cards[2].name > Nine &&
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[2].suit ||
			  pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[2].suit)) ||
			 (pOwnerLord->fake->cards[3].name > Nine &&
			 (pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[3].suit)) ))
	 {//two to a royal(10)
		expertRecomString = TAppString(5031);
		ExpertCode =18;return;
	 }
    if(pOwnerLord->fake->cards[2].name == Jack   &&
		 pOwnerLord->fake->cards[3].name == Queen  &&
		 pOwnerLord->fake->cards[4].name == King)
	 {//k-q-j
		expertRecomString = TAppString(5093);
		ExpertCode =31;return;
	 }
	 if(pOwnerLord->fake->cards[3].name > Ten  ||
		 pOwnerLord->fake->cards[4].name > Ten)
	 {//1-2 high cards
		expertRecomString = TAppString(5150);
		ExpertCode =519;return;
	 }
	 expertRecomString = TAppString(5032);    //garbage
	 ExpertCode =13;return;
}
//*******************************************************************
void TACVPAsk::AskHoldBQD()
{
  pOwnerLord->fake->inhand = 0;
  for(int16 i=0;i<5;i++)
  {
	 pOwnerLord->fake->cards[i].name = pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->cards[i].name;
	 pOwnerLord->fake->cards[i].suit = pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->cards[i].suit;
	 pOwnerLord->fake->inhand++;
  }
  pOwnerLord->pSmarts->Insert_Sort(pOwnerLord->fake);
  pOwnerLord->pSmarts->Holding(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand);
  pOwnerLord->pSmarts->Holding(pOwnerLord->fake);

	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 105)
	 {//royal
		expertRecomString = TAppString(5003);
		ExpertCode =1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 99)
	 {
      if(pOwnerLord->fake->cards[4].name == AceHi)
		{
		  expertRecomString = TAppString(5003);
		  ExpertCode =1;return;
		}
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 99)
	 {//straight flush
		expertRecomString = TAppString(5006);
		ExpertCode =1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 71)
	 {//four o' kind
		expertRecomString = TAppString(5077);
		ExpertCode =20;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 26 &&
       pOwnerLord->FlushAssaultOn)
	 { //flush assault on
		expertRecomString = TAppString(5160);
		ExpertCode =1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
		 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh > 3)
	 {// four to a royal
		if(pOwnerLord->fake->cards[0].name > Nine ||
			  (pOwnerLord->fake->cards[1].name > Nine &&
				(pOwnerLord->fake->cards[0].suit != pOwnerLord->fake->cards[1].suit) &&
				(pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[2].suit)))
		{
		  expertRecomString = TAppString(5009);
		  ExpertCode =3;return;
		}
	 }
    if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 20 ||
        pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 70   ) &&
       pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highcard == AceHi     )
	 {//three aces
		expertRecomString = TAppString(5161);
		ExpertCode =526;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 70)
	 {//full house
		expertRecomString = TAppString(5010);
		ExpertCode =1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 26)
	 { //flush
		expertRecomString = TAppString(5016);
		ExpertCode =1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 20)
	 {//three o' kind
		expertRecomString = TAppString(5018);
		ExpertCode =5;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 3 )
	 {//four to a straight flush
		expertRecomString = TAppString(5019);
		ExpertCode =4;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->toflush > 3 )
	 {//four to a flush
		expertRecomString = TAppString(5029);
		ExpertCode =9;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 23)
	 {//straight
		expertRecomString = TAppString(5017);
		ExpertCode =1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2 ||
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2 )
	 {//three to a royal
		if((pOwnerLord->fake->cards[0].name > Nine &&
			((pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) )) ||
		  (pOwnerLord->fake->cards[1].name > Nine &&
			((pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[1].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[1].suit) ||
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[1].suit) )) ||
		  (pOwnerLord->fake->cards[2].name > Nine &&
			(pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[2].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[2].suit)))

	   {
	     expertRecomString = TAppString(5021);
	     ExpertCode =6;return;
      }
	 }
    if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 10 ||
        pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 15)&&
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highcard == AceHi)
	 {// pair of aces
		expertRecomString = TAppString(5162);
		ExpertCode =527;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 15)
	 {//two pair
		expertRecomString = TAppString(5050);
		ExpertCode =15;return;
	 }
	 if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 10)&&
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highcard > Ten)
	 {//high pair
		expertRecomString = TAppString(5082);
		ExpertCode =27;return;
	 }
	 if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2) ||
		 (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2))
	 {//three to a straight flush
      expertRecomString = TAppString(5044);
		ExpertCode = 541;return;
    }
    if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->toflush > 3)
	 {//four to a flush
		expertRecomString = TAppString(5029);
		ExpertCode =9;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->toflush > 2)
	 { //three to a flush
		expertRecomString = TAppString(5054);
		ExpertCode = 17;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 10)
	 {// pair(low)
		expertRecomString = TAppString(5028);
		ExpertCode =16;return;
	 }
	 if(((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 1) ||
		  (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 1)) &&
		  ( (pOwnerLord->fake->cards[0].name > Nine) ||
			 (pOwnerLord->fake->cards[1].name > Nine &&
           (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[2].suit ||
            pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[3].suit ||
            pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[4].suit  )) ||
          (pOwnerLord->fake->cards[2].name > Nine &&
           (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[3].suit ||
            pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[4].suit  )) ||
          (pOwnerLord->fake->cards[3].name > Nine &&
            pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[4].suit  ) ) )
	 {//two to a royal(10)
        expertRecomString = TAppString(5031);
        ExpertCode =18;return;
	 }
    if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrght > 3  &&
       ((pOwnerLord->fake->cards[4].name > Ten &&
         pOwnerLord->fake->cards[4].suit ==
         pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highcardsuit) ||
        (pOwnerLord->fake->cards[3].name > Ten &&
         pOwnerLord->fake->cards[3].suit ==
         pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highcardsuit) )  )
	 {//four to straight and 1-3 high cards
		  expertRecomString = TAppString(5045);
		  ExpertCode =523;return;
	 }
    if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrght > 3)
	 {//four to outside straight
		expertRecomString = TAppString(5045);
		ExpertCode =525;return;
	 }
    if(pOwnerLord->fake->cards[4].name == AceHi)
	 {//ace
		expertRecomString = TAppString(5163);
		ExpertCode =528;return;
	 }
	 if(((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 1) ||
		  (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 1)) &&
		  ( (pOwnerLord->fake->cards[2].name > Nine &&
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[2].suit ||
			  pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[2].suit)) ||
			 (pOwnerLord->fake->cards[3].name > Nine &&
			 (pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[3].suit)) ))
	 {//two to a royal(10)
		expertRecomString = TAppString(5031);
		ExpertCode =18;return;
	 }
    if(pOwnerLord->fake->cards[4].name > Ten)
	 {//1-3 high cards
		expertRecomString = TAppString(5164);
		ExpertCode =26;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->toflush > 1)
	 { //two to a flush
		expertRecomString = TAppString(5165);
		ExpertCode = 529;return;
	 }
	 expertRecomString = TAppString(5032);    //garbage
	 ExpertCode =13;return;
}
//*******************************************************************
void TACVPAsk::AskHoldBQE()
{
  pOwnerLord->fake->inhand = 0;
  for(int16 i=0;i<5;i++)
  {
	 pOwnerLord->fake->cards[i].name = pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->cards[i].name;
	 pOwnerLord->fake->cards[i].suit = pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->cards[i].suit;
	 pOwnerLord->fake->inhand++;
  }
  pOwnerLord->pSmarts->Insert_Sort(pOwnerLord->fake);
  pOwnerLord->pSmarts->Holding(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand);
  pOwnerLord->pSmarts->Holding(pOwnerLord->fake);

	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 105)
	 {//royal
		expertRecomString = TAppString(5003);
		ExpertCode =1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 99)
	 {
      if(pOwnerLord->fake->cards[4].name == AceHi)
		{
		  expertRecomString = TAppString(5003);
		  ExpertCode =1;return;
		}
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 99)
	 {//straight flush
		expertRecomString = TAppString(5006);
		ExpertCode =1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 71)
	 {//four o' kind
		expertRecomString = TAppString(5077);
		ExpertCode =20;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
		 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh > 3)
	 {// four to a royal
		if(pOwnerLord->fake->cards[0].name > Nine ||
			  (pOwnerLord->fake->cards[1].name > Nine &&
				(pOwnerLord->fake->cards[0].suit != pOwnerLord->fake->cards[1].suit) &&
				(pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[2].suit)))
		{
		  expertRecomString = TAppString(5009);
		  ExpertCode =3;return;
		}
	 }
    if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 20 ||
        pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 70   ) &&
       pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highcard == AceHi     )
	 {//three aces
		expertRecomString = TAppString(5161);
		ExpertCode =526;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 70)
	 {//full house
		expertRecomString = TAppString(5010);
		ExpertCode =1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 26)
	 { //flush
		expertRecomString = TAppString(5016);
		ExpertCode =1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 20)
	 {//three o' kind
		expertRecomString = TAppString(5018);
		ExpertCode =5;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 23)
	 {//straight
		expertRecomString = TAppString(5017);
		ExpertCode =1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 3 )
	 {//four to a straight flush
		expertRecomString = TAppString(5019);
		ExpertCode =4;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 15)
	 {//two pair
		expertRecomString = TAppString(5050);
		ExpertCode =15;return;
	 }
	 if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 10)&&
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highcard > Ten)
	 {//high pair
		expertRecomString = TAppString(5082);
		ExpertCode =27;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2 ||
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2 )
	 {//three to a royal
		if((pOwnerLord->fake->cards[0].name > Nine &&
			((pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) )) ||
		  (pOwnerLord->fake->cards[1].name > Nine &&
			((pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[1].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[1].suit) ||
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[1].suit) )) ||
		  (pOwnerLord->fake->cards[2].name > Nine &&
			(pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[2].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[2].suit)))

	   {
	     expertRecomString = TAppString(5021);
	     ExpertCode =6;return;
      }
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->toflush > 3)
	 {//four to a flush
		expertRecomString = TAppString(5029);
		ExpertCode =9;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrght > 3)
	 {//four to outside straight
		expertRecomString = TAppString(5045);
		ExpertCode =525;return;
	 }
    if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 10)
	 {// pair(low)
		expertRecomString = TAppString(5028);
		ExpertCode =16;return;
	 }
	 if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2) ||
		 (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2))
	 {//three to a straight flush, 9-10-j
      if((pOwnerLord->fake->cards[0].name == Nine &&
          pOwnerLord->fake->cards[1].name == Ten  &&
          pOwnerLord->fake->cards[2].name == Jack &&
          pOwnerLord->fake->cards[0].suit == pOwnerLord->fake->cards[1].suit &&
          pOwnerLord->fake->cards[0].suit == pOwnerLord->fake->cards[2].suit)    ||
         (pOwnerLord->fake->cards[1].name == Nine &&
          pOwnerLord->fake->cards[2].name == Ten  &&
          pOwnerLord->fake->cards[3].name == Jack &&
          pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[2].suit &&
          pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[3].suit)    ||
         (pOwnerLord->fake->cards[2].name == Nine &&
          pOwnerLord->fake->cards[3].name == Ten  &&
          pOwnerLord->fake->cards[4].name == Jack &&
          pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[4].suit &&
          pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[3].suit)      )
       {
		   expertRecomString = TAppString(5159);
		   ExpertCode = 524;return;
       }
	 }
    if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2) ||
		 (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2))
	 {//three to a straight flush
      expertRecomString = TAppString(5044);
		ExpertCode = 541;return;
    }
    if(pOwnerLord->fake->cards[1].name == Jack   &&
       pOwnerLord->fake->cards[4].name == AceHi   &&
		 pOwnerLord->fake->cards[2].name == Queen  &&
		 pOwnerLord->fake->cards[3].name == King)
	 {//a-k-q-j
		expertRecomString = TAppString(5151);
		ExpertCode =518;return;
	 }
	 if(pOwnerLord->fake->cards[2].name == Jack   &&
		 pOwnerLord->fake->cards[3].name == Queen  &&
		 pOwnerLord->fake->cards[4].name == King)
	 {//k-q-j
		expertRecomString = TAppString(5093);
		ExpertCode =31;return;
	 }
	 if(pOwnerLord->fake->cards[2].name == Jack   &&
		 pOwnerLord->fake->cards[3].name == Queen  &&
		 pOwnerLord->fake->cards[4].name == King)
	 {//q-j-10
		expertRecomString = TAppString(5166);
		ExpertCode =530;return;
	 }
	 if(((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 1) ||
		  (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 1)) &&
		  ( (pOwnerLord->fake->cards[2].name > Nine &&
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[2].suit ||
			  pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[2].suit)) ||
			 (pOwnerLord->fake->cards[3].name > Nine &&
			 (pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[3].suit)) ))
	 {//two to a royal
        expertRecomString = TAppString(5031);
        ExpertCode =18;return;
	 }
    if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrght > 3)
	 {//four to inside straight
		expertRecomString = TAppString(5045);
		ExpertCode =531;return;
	 }
    if(pOwnerLord->fake->cards[4].name > Ten)
	 {//1-2 high cards
		expertRecomString = TAppString(5150);
		ExpertCode =519;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->toflush > 2)
	 { //three to a flush
		expertRecomString = TAppString(5054);
		ExpertCode = 17;return;
	 }
	 expertRecomString = TAppString(5032);    //garbage
	 ExpertCode =13;return;
}
//*******************************************************************
void TACVPAsk::AskHoldBQF()
{
  pOwnerLord->fake->inhand = 0;
  for(int16 i=0;i<5;i++)
  {
	 pOwnerLord->fake->cards[i].name = pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->cards[i].name;
	 pOwnerLord->fake->cards[i].suit = pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->cards[i].suit;
	 pOwnerLord->fake->inhand++;
  }
  pOwnerLord->pSmarts->Insert_Sort(pOwnerLord->fake);
  pOwnerLord->pSmarts->Holding(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand);
  pOwnerLord->pSmarts->Holding(pOwnerLord->fake);

	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 105)
	 {//royal
		expertRecomString = TAppString(5003);
		ExpertCode =1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 99)
	 {
      if(pOwnerLord->fake->cards[4].name == AceHi)
		{
		  expertRecomString = TAppString(5003);
		  ExpertCode =1;return;
		}
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 99)
	 {//straight flush
		expertRecomString = TAppString(5006);
      if(pOwnerLord->SubGameType == cvpFreeLook)
      {expertRecomString += TAppString(5175);}
		ExpertCode =1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 71)
	 {//four o' kind
		expertRecomString = TAppString(5077);
      ExpertCode =20;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
		 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh > 3)
	 {// four to a royal
		if(pOwnerLord->fake->cards[0].name > Nine ||
			  (pOwnerLord->fake->cards[1].name > Nine &&
				(pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[3].suit) &&
				(pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[2].suit) &&
            (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[4].suit) ))
		{
		  expertRecomString = TAppString(5009);
		  if(pOwnerLord->SubGameType == cvpFreeLook)
        {expertRecomString += TAppString(5175);}
		  ExpertCode =3;return;
		}
	 }
    if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 20 ||
        pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 70   ) &&
       pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highcard == AceHi     )
	 {//three aces
		expertRecomString = TAppString(5161);
		if(pOwnerLord->SubGameType == cvpFreeLook)
      {expertRecomString += TAppString(5175);}
		ExpertCode =526;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 70)
	 {//full house
		expertRecomString = TAppString(5010);
		if(pOwnerLord->SubGameType == cvpFreeLook)
      {expertRecomString += TAppString(5175);}
		ExpertCode =1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 20)
	 {//three o' kind
		expertRecomString = TAppString(5018);
		if(pOwnerLord->SubGameType == cvpFreeLook)
      {expertRecomString += TAppString(5175);}
		ExpertCode =5;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 26)
	 { //flush
		expertRecomString = TAppString(5016);
		if(pOwnerLord->SubGameType == cvpFreeLook)
      {expertRecomString += TAppString(5175);}
		ExpertCode =1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 23)
	 {//straight
		expertRecomString = TAppString(5017);
		if(pOwnerLord->SubGameType == cvpFreeLook)
      {expertRecomString += TAppString(5175);}
		ExpertCode =1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 3 )
	 {//four to a straight flush
		expertRecomString = TAppString(5019);
		if(pOwnerLord->SubGameType == cvpFreeLook)
      {expertRecomString += TAppString(5175);}
		ExpertCode =4;return;
	 }
	 if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 10 ||
        pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 15)&&
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highcard == AceHi)
	 {// pair of aces
		expertRecomString = TAppString(5162);
		if(pOwnerLord->SubGameType == cvpFreeLook)
      {expertRecomString += TAppString(5175);}
		ExpertCode =527;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 15)
	 {//two pair
		expertRecomString = TAppString(5050);
		if(pOwnerLord->SubGameType == cvpFreeLook)
      {expertRecomString += TAppString(5175);}
		ExpertCode =15;return;
	 }
	 if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 10)&&
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highcard == King)
	 {// pair of Kings
		expertRecomString = TAppString(5167);
		if(pOwnerLord->SubGameType == cvpFreeLook)
      {expertRecomString += TAppString(5175);}
		ExpertCode =532;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->toflush > 3)
	 {//four to a flush
		expertRecomString = TAppString(5029);
		if(pOwnerLord->SubGameType == cvpFreeLook)
      {expertRecomString += TAppString(5175);}
		ExpertCode =9;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2 ||
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2 )
	 {//three to a royal
		if((pOwnerLord->fake->cards[0].name > Nine &&
			((pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) )) ||
		  (pOwnerLord->fake->cards[1].name > Nine &&
			((pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[1].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[1].suit) ||
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[1].suit) )) ||
		  (pOwnerLord->fake->cards[2].name > Nine &&
			(pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[2].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[2].suit)))

	   {
	     expertRecomString = TAppString(5021);
	     if(pOwnerLord->SubGameType == cvpFreeLook)
        {expertRecomString += TAppString(5175);}
		  ExpertCode =6;return;
      }
	 }
    if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 10)
	 {// pair(low)
		expertRecomString = TAppString(5028);
		if(pOwnerLord->SubGameType == cvpFreeLook)
      {expertRecomString += TAppString(5175);}
		ExpertCode =16;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrght > 3)
	 {//four to outside straight
		expertRecomString = TAppString(5045);
		if(pOwnerLord->SubGameType == cvpFreeLook)
      {expertRecomString += TAppString(5175);}
		ExpertCode =525;return;
	 }
    if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2) ||
		 (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2))
	 {//three to a straight flush
      expertRecomString = TAppString(5044);
		if(pOwnerLord->SubGameType == cvpFreeLook)
      {expertRecomString += TAppString(5175);}
		ExpertCode = 541;return;
    }
    if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->toflush > 2)
	 { //three to a flush
		expertRecomString = TAppString(5054);
		if(pOwnerLord->SubGameType == cvpFreeLook)
      {expertRecomString += TAppString(5175);}
		ExpertCode = 17;return;
	 }
    if(pOwnerLord->fake->cards[4].name == AceHi ||
       pOwnerLord->fake->cards[4].name == King    )
	 {//ace and/or king
		expertRecomString = TAppString(5168);
		if(pOwnerLord->SubGameType == cvpFreeLook)
      {expertRecomString += TAppString(5175);}
		ExpertCode =533;return;
	 }
    if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrght  > 3)
	 {//four to inside straight
	   expertRecomString = TAppString(5045);
	   if(pOwnerLord->SubGameType == cvpFreeLook)
      {expertRecomString += TAppString(5175);}
		ExpertCode = 531;return;
    }
	 expertRecomString = TAppString(5032);    //garbage
	 if(pOwnerLord->SubGameType == cvpFreeLook)
    {expertRecomString += TAppString(5175);}
    ExpertCode =13;return;
}
//*******************************************************************
void TACVPAsk::AskHoldBQH()
{
  pOwnerLord->fake->inhand = 0;
  for(int16 i=0;i<5;i++)
  {
	 pOwnerLord->fake->cards[i].name = pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->cards[i].name;
	 pOwnerLord->fake->cards[i].suit = pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->cards[i].suit;
	 pOwnerLord->fake->inhand++;
  }
  pOwnerLord->pSmarts->Insert_Sort(pOwnerLord->fake);
  pOwnerLord->pSmarts->Holding(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand);
  pOwnerLord->pSmarts->Holding(pOwnerLord->fake);

	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 105)
	 {//royal
		expertRecomString = TAppString(5003);
		ExpertCode =1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 99)
	 {
      if(pOwnerLord->fake->cards[4].name == AceHi)
		{
		  expertRecomString = TAppString(5003);
		  ExpertCode =1;return;
		}
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 99)
	 {//straight flush
		expertRecomString = TAppString(5006);
		ExpertCode =1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 71)
	 {//four o' kind
		expertRecomString = TAppString(5077);
		ExpertCode =20;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
		 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh > 3)
	 {// four to a royal
		if(pOwnerLord->fake->cards[0].name > Nine ||
			  (pOwnerLord->fake->cards[1].name > Nine &&
				(pOwnerLord->fake->cards[0].suit != pOwnerLord->fake->cards[1].suit) &&
				(pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[2].suit)))
		{
		  expertRecomString = TAppString(5009);
		  ExpertCode =3;return;
		}
	 }
    if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 20 ||
        pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 70   ) &&
       pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highcard == AceHi     )
	 {//three aces
		expertRecomString = TAppString(5161);
		ExpertCode =526;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 70)
	 {//full house
		expertRecomString = TAppString(5010);
		ExpertCode =1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 20)
	 {//three o' kind
		expertRecomString = TAppString(5018);
		ExpertCode =5;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 26)
	 { //flush
		expertRecomString = TAppString(5016);
		ExpertCode =1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 23)
	 {//straight
		expertRecomString = TAppString(5017);
		ExpertCode =1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 3 )
	 {//four to a straight flush
		expertRecomString = TAppString(5019);
		ExpertCode =4;return;
	 }
	 if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 10)&&
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highcard == AceHi)
	 {// pair of aces
		expertRecomString = TAppString(5162);
		ExpertCode =527;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 15)
	 {//two pair
		expertRecomString = TAppString(5050);
		ExpertCode =15;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2 ||
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2 )
	 {//three to a royal
		if((pOwnerLord->fake->cards[0].name > Nine &&
			((pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) )) ||
		  (pOwnerLord->fake->cards[1].name > Nine &&
			((pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[1].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[1].suit) ||
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[1].suit) )) ||
		  (pOwnerLord->fake->cards[2].name > Nine &&
			(pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[2].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[2].suit)))

	   {
	     expertRecomString = TAppString(5021);
	     ExpertCode =6;return;
      }
	 }
	 if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 10)&&
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highcard > Ten)
	 {//high pair
		expertRecomString = TAppString(5083);
		ExpertCode = 21;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->toflush > 3)
	 {//four to a flush
		expertRecomString = TAppString(5029);
		ExpertCode =9;return;
	 }
	 if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 10)&&
		  (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highcard == Two ||
         pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highcard == Three ||
         pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highcard == Four)   )
	 {// pair 2,3, or 4
		expertRecomString = TAppString(5169);
		ExpertCode = 534;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrght > 3  &&
       ((pOwnerLord->fake->cards[4].name > Ten &&
         pOwnerLord->fake->cards[4].suit ==
         pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highcardsuit) ||
        (pOwnerLord->fake->cards[3].name > Ten &&
         pOwnerLord->fake->cards[3].suit ==
         pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highcardsuit) )  )
	 {//four to outside straight and 1-3 high cards
		  expertRecomString = TAppString(5045);
		  ExpertCode =523;return;
	 }
    if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 10)
	 {// pair(low)
		expertRecomString = TAppString(5028);
		ExpertCode =16;return;
	 }
	 if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2) ||
		 (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2))
	 {//three to a straight flush, 9-10-j
      if((pOwnerLord->fake->cards[0].name == Nine &&
          pOwnerLord->fake->cards[1].name == Ten  &&
          pOwnerLord->fake->cards[2].name == Jack &&
          pOwnerLord->fake->cards[0].suit == pOwnerLord->fake->cards[1].suit &&
          pOwnerLord->fake->cards[0].suit == pOwnerLord->fake->cards[2].suit)    ||
         (pOwnerLord->fake->cards[1].name == Nine &&
          pOwnerLord->fake->cards[2].name == Ten  &&
          pOwnerLord->fake->cards[3].name == Jack &&
          pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[2].suit &&
          pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[3].suit)    ||
         (pOwnerLord->fake->cards[2].name == Nine &&
          pOwnerLord->fake->cards[3].name == Ten  &&
          pOwnerLord->fake->cards[4].name == Jack &&
          pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[4].suit &&
          pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[3].suit)      )
       {
		   expertRecomString = TAppString(5159);
		   ExpertCode = 524;return;
       }
	 }
    if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrght > 3)
	 {//four to outside straight
		expertRecomString = TAppString(5045);
		ExpertCode =525;return;
	 }
    if(pOwnerLord->fake->cards[1].name == Jack   &&
		 pOwnerLord->fake->cards[2].name == Queen  &&
		 pOwnerLord->fake->cards[3].name == King   &&
       pOwnerLord->fake->cards[4].name == AceHi)
	 {//A-k-q-j
		expertRecomString = TAppString(5151);
		ExpertCode =518;return;
	 }
	 if((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2) ||
		 (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2))
	 {//three to a straight flush
      expertRecomString = TAppString(5044);
		ExpertCode = 541;return;
    }
    if(((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 1) ||
		  (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 1)) &&
		  ( (pOwnerLord->fake->cards[2].name > Nine &&
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[2].suit ||
			  pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[2].suit)) ||
			 (pOwnerLord->fake->cards[3].name > Nine &&
			 (pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[3].suit)) ))
	 {//two to a royal
		expertRecomString = TAppString(5031);
		ExpertCode = 18;return;
	 }
	 if(pOwnerLord->fake->cards[2].name == Jack   &&
		 pOwnerLord->fake->cards[3].name == Queen  &&
		 pOwnerLord->fake->cards[4].name == King)
	 {//k-q-j
		expertRecomString = TAppString(5093);
		ExpertCode =31;return;
	 }
	 if(pOwnerLord->fake->cards[3].name > Ten  ||
		 pOwnerLord->fake->cards[4].name > Ten    )
	 {//1-2 high cards
		expertRecomString = TAppString(5150);
		ExpertCode =519;return;
	 }
    if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrght  > 3)
	 {//four to inside straight
	   expertRecomString = TAppString(5045);
	   ExpertCode = 531;return;
    }
	 expertRecomString = TAppString(5032);    //garbage
	 ExpertCode =13;return;
}
//*******************************************************************
void TACVPAsk::AskHoldDWC()
{
  pOwnerLord->GetNumOfWildCards();
  pOwnerLord->Wild2(true);

  if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->wildcount)
  {
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->wildcount > 2)
	 {
      if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 110)
      {//4 2s
        if(pOwnerLord->fake->cards[4].name == AceHi)
        {
          expertRecomString = TAppString(5173);ExpertCode =1;
        }
        else
        {
          expertRecomString = TAppString(5174);ExpertCode =540;
        }
      }
      else
      {
		 switch(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand)
       {
		  case 105 : expertRecomString = TAppString(5000);ExpertCode =1;break;//rf 2s
		  case 100 : expertRecomString = TAppString(5004);ExpertCode =1;break;//5 kind
		  default  : expertRecomString = TAppString(5005);ExpertCode =504;break;//
		 }
      }
		return;
	 }
	 else if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->wildcount > 1)
	 {
		switch(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand){
		  case 105 : expertRecomString = TAppString(5000);ExpertCode =1;break;//rf 2s
		  case 100 : expertRecomString = TAppString(5004);ExpertCode =1;break;//5 kind
		  case  99 : if(pOwnerLord->fake->cards[2].name == Nine)
						 {
							expertRecomString = TAppString(5100);ExpertCode =1;break;//rf 2s
						 }
						 else
						 {
							expertRecomString = TAppString(5006);ExpertCode =1;break;//sf
						 }
		  case  71 : expertRecomString = TAppString(5007);ExpertCode =502;break;//4 kind
		  default  : if(pOwnerLord->fake->cards[2].name > Nine)
						 {
							if((pOwnerLord->fake->cards[3].name >
									 pOwnerLord->fake->cards[2].name) &&
								(pOwnerLord->fake->cards[2].suit ==
									 pOwnerLord->fake->cards[3].suit)   )
							{
							  expertRecomString = TAppString(5009);ExpertCode =136;break;//4 to rf
							}
							else if((pOwnerLord->fake->cards[4].name >
											pOwnerLord->fake->cards[2].name) &&
									  (pOwnerLord->fake->cards[2].suit ==
											pOwnerLord->fake->cards[4].suit)   )
							{
							  expertRecomString = TAppString(5009);ExpertCode =136;break;//4 to rf
							}
						 }
						 else if(pOwnerLord->fake->cards[3].name > Nine)
						 {
							if((pOwnerLord->fake->cards[4].name >
									 pOwnerLord->fake->cards[3].name) &&
								(pOwnerLord->fake->cards[4].suit ==
									 pOwnerLord->fake->cards[3].suit)   )
							{
							  expertRecomString = TAppString(5009);ExpertCode =136;break;// 4 to rf
							}
						 }
						 else if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3)
                   {
                  	 {//four to a outside straight flush
                  		expertRecomString = TAppString(5019);
                    		ExpertCode =4;return;
                    	 }
                   }
                   expertRecomString = TAppString(5008);ExpertCode =37;break;
		}
		return;
	 }
	 else if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->wildcount) //repetitive check
	 {
		switch(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand){
		  case 105 : expertRecomString = TAppString(5000);
						 ExpertCode =1;return;
		  case 100 : expertRecomString = TAppString(5004);
						 ExpertCode =1;return;
		  case  99 : expertRecomString = TAppString(5006);
						 ExpertCode =1;return;
		  case  71 : expertRecomString = TAppString(5007);
						 ExpertCode =508;return;
		  case  70 : expertRecomString = TAppString(5010);
						 ExpertCode =1;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh > 3)
		{//4 to royal
		  if(pOwnerLord->fake->cards[1].name > Nine ||
			  (pOwnerLord->fake->cards[2].name > Nine &&
				(pOwnerLord->fake->cards[2].name < pOwnerLord->fake->cards[3].name &&
				 pOwnerLord->fake->cards[3].name < pOwnerLord->fake->cards[4].name) &&
				 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[3].suit &&
				  pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[4].suit)))
		  {
			 expertRecomString = TAppString(5009);
			 ExpertCode =135;return;
		  }
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
			pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh > 3)
		{
		  if(pOwnerLord->fake->cards[1].name > Nine ||
			  (pOwnerLord->fake->cards[2].name > Nine &&
				(pOwnerLord->fake->cards[2].name < pOwnerLord->fake->cards[3].name &&
				 pOwnerLord->fake->cards[3].name < pOwnerLord->fake->cards[4].name) &&
				 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[3].suit &&
				  pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[4].suit)))
		  {
			 expertRecomString = TAppString(5009);
			 ExpertCode =135;return;
		  }
		}
	   if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 26)
      {//flush
		  expertRecomString = TAppString(5016);
		  ExpertCode =1;return;
      }
      if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3)
		{  //four to straight flush
		  expertRecomString = TAppString(5019);
		  ExpertCode =33;return;
		}
		switch(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand)
		{
		  case 23 : expertRecomString = TAppString(5017);
						 ExpertCode =1;return;
		  case 20 : expertRecomString = TAppString(5018);
						 ExpertCode =511;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2 &&
			pOwnerLord->fake->cards[1].name > Nine &&
			((pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[2].suit) ||
			 (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[3].suit) ||
			 (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[4].suit)))
		{   //three to royal flush
		  expertRecomString = TAppString(5021);
		  ExpertCode =513;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2 &&
			pOwnerLord->fake->cards[2].name > Nine &&
			((pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[2].suit) ||
			 (pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[2].suit)))
		{   //three to royal flush
		  expertRecomString = TAppString(5021);
		  ExpertCode =513;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2 &&
			pOwnerLord->fake->cards[3].name > Nine &&
			(pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[4].suit))
		{   //three to royal flush
		  expertRecomString = TAppString(5021);
		  ExpertCode =513;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2)
		{
		  expertRecomString = TAppString(5044);
		  ExpertCode =512;return;
		}
		expertRecomString = TAppString(5106);
		ExpertCode =34;return;
	 }
  }
  else // no wild cards
  {
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 105)
	 {
		expertRecomString = TAppString(5003);
		ExpertCode =1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 99)
	 {
      if(pOwnerLord->fake->cards[4].name == AceHi)
		{
		  expertRecomString = TAppString(5003);
		  ExpertCode =1;return;
		}
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
		 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh > 3)
	 {    //four to royal
		if(pOwnerLord->fake->cards[1].name > Nine ||
			  (pOwnerLord->fake->cards[2].name > Nine &&
				(pOwnerLord->fake->cards[2].name < pOwnerLord->fake->cards[3].name &&
				 pOwnerLord->fake->cards[3].name < pOwnerLord->fake->cards[4].name) &&
				 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[3].suit &&
				  pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[4].suit)))
		{
		  expertRecomString = TAppString(5009);
		  ExpertCode =3;return;
		}
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 99)
	 {         //straight flush
		expertRecomString = TAppString(5006);
		ExpertCode =1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 99)
	 { // 4 to rf
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
			pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh > 3)
		{
		  if(pOwnerLord->fake->cards[1].name > Nine ||
			  (pOwnerLord->fake->cards[2].name > Nine &&
				(pOwnerLord->fake->cards[2].name < pOwnerLord->fake->cards[3].name &&
				 pOwnerLord->fake->cards[3].name < pOwnerLord->fake->cards[4].name) &&
				 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[3].suit &&
				  pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[4].suit)))
		  {
			 expertRecomString = TAppString(5107);
			 ExpertCode =3;return;
		  }
		}
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 71)
	 {          // four o kind
		expertRecomString = TAppString(5007);
		ExpertCode =2;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 70)
	 {       //full house
		expertRecomString = TAppString(5010);
		ExpertCode =1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 20)
	 {       // three o kind
		expertRecomString = TAppString(5018);
		ExpertCode =5;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 26)
	 {              //flush
		expertRecomString = TAppString(5016);
		ExpertCode =1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 23)
	 {              //straight
		expertRecomString = TAppString(5017);
		ExpertCode =1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3)
	 {  //four to straight flush
	   expertRecomString = TAppString(5019);
	   ExpertCode =33;return;
	 }
    if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2 ||
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2 )
	 {               //three to royal
		if((pOwnerLord->fake->cards[0].name > Nine &&
			((pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) )) ||
		  (pOwnerLord->fake->cards[1].name > Nine &&
			((pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[1].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[1].suit) ||
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[1].suit) )) ||
		  (pOwnerLord->fake->cards[2].name > Nine &&
			(pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[2].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[2].suit)))

		{
		  expertRecomString = TAppString(5021);
		  ExpertCode =6;return;
		}
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->toflush > 3)
	 {           //four to flush
		expertRecomString = TAppString(5029);
		ExpertCode =9;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 15)
	 {//two pair
		expertRecomString = TAppString(5050);
		ExpertCode = 15;
      return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 10 ||
		 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 15)
	 {                //hold one pair
		expertRecomString = TAppString(5028);
		ExpertCode =16;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrght > 3)
	 {              //four to outside straight
		expertRecomString = TAppString(5045);
		ExpertCode =525;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh > 2 ||
		 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2  )
	 {        //three to straight flush (gap)
		expertRecomString = TAppString(5044);
		ExpertCode =8;return;
	 }
	 if(((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 1) ||
		  (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 1)) &&
		  ( (pOwnerLord->fake->cards[2].name > Nine &&
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[2].suit ||
			  pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[2].suit)) ||
			 (pOwnerLord->fake->cards[3].name > Nine &&
			 (pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[3].suit)) ))
	 {     //two to royal
		expertRecomString = TAppString(5031);
		ExpertCode =18;return;
	 }
    expertRecomString = TAppString(5032);
	 ExpertCode =13;return;
  }
}
//*******************************************************************
void TACVPAsk::AskHoldPRF()
{
  pOwnerLord->GetNumOfWildCards();
  pOwnerLord->Wild2(true);

  if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->wildcount)
  {
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->wildcount > 2)
	 {

		switch(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand){
		  case 110 : expertRecomString = TAppString(5002);ExpertCode =220;break;//4 2s
		  case 105 : expertRecomString = TAppString(5000);ExpertCode =1;break;//rf 2s
		  case 100 : expertRecomString = TAppString(5004);ExpertCode =1;break;//5 kind
		  default  : expertRecomString = TAppString(5005);ExpertCode =55;break;//
		}
		return;
	 }
	 else if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->wildcount > 1)
	 {
		switch(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand){
		  case 105 : expertRecomString = TAppString(5000);ExpertCode =1;break;//rf 2s
		  case 100 : expertRecomString = TAppString(5004);ExpertCode =1;break;//5 kind
		  case  99 : if(pOwnerLord->fake->cards[2].name == Nine)
						 {
							expertRecomString = TAppString(5100);ExpertCode =1;break;//rf 2s
						 }
						 else
						 {
							expertRecomString = TAppString(5006);ExpertCode =1;break;//sf
						 }
		  case  71 : expertRecomString = TAppString(5007);ExpertCode =102;break;//4 kind
		  default  : if(pOwnerLord->fake->cards[2].name > Nine)
						 {
							if((pOwnerLord->fake->cards[3].name >
									 pOwnerLord->fake->cards[2].name) &&
								(pOwnerLord->fake->cards[2].suit ==
									 pOwnerLord->fake->cards[3].suit)   )
							{
							  expertRecomString = TAppString(5009);ExpertCode =136;break;//4 to rf
							}
							else if((pOwnerLord->fake->cards[4].name >
											pOwnerLord->fake->cards[2].name) &&
									  (pOwnerLord->fake->cards[2].suit ==
											pOwnerLord->fake->cards[4].suit)   )
							{
							  expertRecomString = TAppString(5009);ExpertCode =136;break;//4 to rf
							}
						 }
						 else if(pOwnerLord->fake->cards[3].name > Nine)
						 {
							if((pOwnerLord->fake->cards[4].name >
									 pOwnerLord->fake->cards[3].name) &&
								(pOwnerLord->fake->cards[4].suit ==
									 pOwnerLord->fake->cards[3].suit)   )
							{
							  expertRecomString = TAppString(5009);ExpertCode =136;break;// 4 to rf
							}
						 }
                   expertRecomString = TAppString(5008);ExpertCode =37;break;
		}
		return;
	 }
	 else if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->wildcount) //repetitive check
	 {
		switch(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand){
		  case 105 : expertRecomString = TAppString(5000);
						 ExpertCode =1;return;
		  case 100 : expertRecomString = TAppString(5004);
						 ExpertCode =1;return;
		  case  99 : expertRecomString = TAppString(5006);
						 ExpertCode =1;return;
		  case  71 : expertRecomString = TAppString(5007);
						 ExpertCode =508;return;
		  case  70 : expertRecomString = TAppString(5010);
						 ExpertCode =1;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh > 3)
		{//4 to royal
		  if(pOwnerLord->fake->cards[1].name > Nine ||
			  (pOwnerLord->fake->cards[2].name > Nine &&
				(pOwnerLord->fake->cards[2].name < pOwnerLord->fake->cards[3].name &&
				 pOwnerLord->fake->cards[3].name < pOwnerLord->fake->cards[4].name) &&
				 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[3].suit &&
				  pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[4].suit)))
		  {
			 expertRecomString = TAppString(5009);
			 ExpertCode =135;return;
		  }
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
			pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh > 3)
		{ //4 to royal
		  if(pOwnerLord->fake->cards[1].name > Nine ||
			  (pOwnerLord->fake->cards[2].name > Nine &&
				(pOwnerLord->fake->cards[2].name < pOwnerLord->fake->cards[3].name &&
				 pOwnerLord->fake->cards[3].name < pOwnerLord->fake->cards[4].name) &&
				 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[3].suit &&
				  pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[4].suit)))
		  {
			 expertRecomString = TAppString(5009);
			 ExpertCode =135;return;
		  }
		}
	   if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3)
		{  //four to straight flush
		  expertRecomString = TAppString(5019);
		  ExpertCode =33;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 26)
      {//flush
		  expertRecomString = TAppString(5016);
		  ExpertCode =1;return;
      }
      switch(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand)
		{
		  case 23 : expertRecomString = TAppString(5017);
						 ExpertCode =1;return;
		  case 20 : expertRecomString = TAppString(5018);
						 ExpertCode =511;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2 &&
			pOwnerLord->fake->cards[1].name > Nine &&
			((pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[2].suit) ||
			 (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[3].suit) ||
			 (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[4].suit)))
		{   //three to royal flush
		  expertRecomString = TAppString(5021);
		  ExpertCode =513;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2 &&
			pOwnerLord->fake->cards[2].name > Nine &&
			((pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[2].suit) ||
			 (pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[2].suit)))
		{   //three to royal flush
		  expertRecomString = TAppString(5021);
		  ExpertCode =513;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2 &&
			pOwnerLord->fake->cards[3].name > Nine &&
			(pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[4].suit))
		{   //three to royal flush
		  expertRecomString = TAppString(5021);
		  ExpertCode =513;return;
		}
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2 ||
         pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh > 2)
		{
		  expertRecomString = TAppString(5044);
		  ExpertCode =535;return;
		}
		expertRecomString = TAppString(5106);
		ExpertCode =34;return;
	 }
  }
  else // no wild cards
  {
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 105)
	 {
		expertRecomString = TAppString(5003);
		ExpertCode =1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 99)
	 {
      if(pOwnerLord->fake->cards[4].name == AceHi)
		{
		  expertRecomString = TAppString(5003);
		  ExpertCode =1;return;
		}
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
		 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh > 3)
	 {    //four to royal
		if(pOwnerLord->fake->cards[1].name > Nine ||
			  (pOwnerLord->fake->cards[2].name > Nine &&
				(pOwnerLord->fake->cards[2].name < pOwnerLord->fake->cards[3].name &&
				 pOwnerLord->fake->cards[3].name < pOwnerLord->fake->cards[4].name) &&
				 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[3].suit &&
				  pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[4].suit)))
		{
		  expertRecomString = TAppString(5009);
		  ExpertCode =3;return;
		}
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 99)
	 {         //straight flush
		expertRecomString = TAppString(5006);
		ExpertCode =1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 99)
	 { // 4 kind
		if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3 ||
			pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh > 3)
		{
		  if(pOwnerLord->fake->cards[1].name > Nine ||
			  (pOwnerLord->fake->cards[2].name > Nine &&
				(pOwnerLord->fake->cards[2].name < pOwnerLord->fake->cards[3].name &&
				 pOwnerLord->fake->cards[3].name < pOwnerLord->fake->cards[4].name) &&
				 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[3].suit &&
				  pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[4].suit)))
		  {
			 expertRecomString = TAppString(5107);
			 ExpertCode =3;return;
		  }
		}
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 71)
	 {          // four o kind
		expertRecomString = TAppString(5007);
		ExpertCode =2;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 70)
	 {       //full house
		expertRecomString = TAppString(5010);
		ExpertCode =1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 20)
	 {       // three o kind
		expertRecomString = TAppString(5018);
		ExpertCode =5;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 26)
	 {              //flush
		expertRecomString = TAppString(5016);
		ExpertCode =1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 23)
	 {              //straight
		expertRecomString = TAppString(5017);
		ExpertCode =1;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 3)
	 {  //four to straight flush
	   expertRecomString = TAppString(5019);
	   ExpertCode =33;return;
	 }
    if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2 ||
		  pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 2 )
	 {               //three to royal
		if((pOwnerLord->fake->cards[0].name > Nine &&
			((pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[1].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) ||
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[0].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[0].suit) )) ||
		  (pOwnerLord->fake->cards[1].name > Nine &&
			((pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[1].suit) ||
			 (pOwnerLord->fake->cards[2].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[1].suit) ||
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[1].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[1].suit) )) ||
		  (pOwnerLord->fake->cards[2].name > Nine &&
			(pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[2].suit && pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[2].suit)))

		{
		  expertRecomString = TAppString(5021);
		  ExpertCode =6;return;
		}
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2)
	 {        //three to outside straight flush
		expertRecomString = TAppString(5044);
		ExpertCode =8;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 15 ||
       pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->highhand == 10  )
	 {//hold only one pair
		expertRecomString = TAppString(5171);
		ExpertCode = 460;
      return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrght > 3)
	 {              //four to outside straight
		expertRecomString = TAppString(5045);
		ExpertCode =525;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->toflush > 3)
	 {           //four to flush
		expertRecomString = TAppString(5029);
		ExpertCode =9;return;
	 }
	 if(pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh > 2 ||
		 pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 2  )
	 {        //three to straight flush
		expertRecomString = TAppString(5044);
		ExpertCode =8;return;
	 }
	 if(((pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->instrflsh  > 1) ||
		  (pOwnerLord->GetCasPlayer(pOwnerLord->activeplayer)->pHand->outstrflsh > 1)) &&
		  ( (pOwnerLord->fake->cards[2].name > Nine &&
			 (pOwnerLord->fake->cards[3].suit == pOwnerLord->fake->cards[2].suit ||
			  pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[2].suit)) ||
			 (pOwnerLord->fake->cards[3].name > Nine &&
			 (pOwnerLord->fake->cards[4].suit == pOwnerLord->fake->cards[3].suit)) ))
	 {     //two to royal
		expertRecomString = TAppString(5031);
		ExpertCode =18;return;
	 }
    expertRecomString = TAppString(5032);
	 ExpertCode =13;return;
  }
}

