//********************************************************************
//                    Confidential Material.
//
//  Copyright (c) 1995 CARDOZA ENTERTAINMENT. All Rights Reserved.
//********************************************************************
//
//       File Name:  acvpglrd.cpp
//    Project Name:  acvp
// Original Author:  Michael R. Perry
//
// (Revision History)
// Version   Date      Author       Changes and Notes
// ------- --------   ---------  ------------------------------
//  2.5    09/28/99    M.Perry    original baseline
//********************************************************************
#include "acvpglrd.h"
#include "acvplmst.h"
#include "cvpglord.h"
#include "acvpname.rh"
#include "orespond.h"
//#include "vplordst.h"
//#include "vplordms.h"
#include "ostate.h"
#include <time.h>   //To Set Random Number Generator
#include "vpdeck.h"
#include <stdlib.h> //For Random Number Generator
#include "casvpmw.h"
#include "oskitcat.h"
#include "cvpplay.h"
#include "expert.h"
#include "acvpaskx.h"
#include "cplaymgr.h"
#include "ogamefw.h"
#include "casapp.h"
#include "orespond.h"
#include "oanm.h"
#include "cas_cm.rh"
#include "acvpvpmw.h"
#include "casvpmw.h"

#include "acvp_cm.rh"
#define  BET1  5
//*******************************************************************
string GetAppString(int16 ids)
{
  return TAppString(ids);
}
//*******************************************************************
bool TACVPVPGLord::DoGrid()
{
  switch (GetCasPlayer(activeplayer)->pHand->highhand)
  {
	 case TwoPair :
               Grid->ShowCell(2,2);
               JackpotGrid[2][2] = true;
               break;
	 case ThreeKind :
               Grid->ShowCell(0,0);
               JackpotGrid[0][0] = true;
               break;
	 case Straight :
               Grid->ShowCell(3,1);
               JackpotGrid[3][1] = true;
               break;
	 case Flush :
               if(GetCasPlayer(activeplayer)->pHand->highcardsuit == Club)
               {
                 Grid->ShowCell(2,4);
                 JackpotGrid[2][4] = true;
               }
               else if(GetCasPlayer(activeplayer)->pHand->highcardsuit == Diamond)
               {
                 Grid->ShowCell(0,2);
                 JackpotGrid[0][2] = true;
               }
               else if(GetCasPlayer(activeplayer)->pHand->highcardsuit == Heart)
               {
                 Grid->ShowCell(4,2);
                 JackpotGrid[4][2] = true;
               }
               else if(GetCasPlayer(activeplayer)->pHand->highcardsuit == Spade)
               {
                 Grid->ShowCell(2,0);
                 JackpotGrid[2][0] = true;
               }
               break;
	 case FullHouse :
               if(GetCasPlayer(activeplayer)->pHand->highcard == AceHi  ||
                  GetCasPlayer(activeplayer)->pHand->highcard == King     )
               {
                 Grid->ShowCell(3,3);
                 JackpotGrid[3][3] = true;
               }
               else if(GetCasPlayer(activeplayer)->pHand->highcard == Queen ||
                       GetCasPlayer(activeplayer)->pHand->highcard == Jack    )
               {
                 Grid->ShowCell(1,3);
                 JackpotGrid[1][3] = true;
               }
               else if(GetCasPlayer(activeplayer)->pHand->highcard == Eight ||
                       GetCasPlayer(activeplayer)->pHand->highcard == Nine  ||
                       GetCasPlayer(activeplayer)->pHand->highcard == Ten     )
               {
                 Grid->ShowCell(0,1);
                 JackpotGrid[0][1] = true;
               }
               else if(GetCasPlayer(activeplayer)->pHand->highcard == Five ||
                       GetCasPlayer(activeplayer)->pHand->highcard == Six  ||
                       GetCasPlayer(activeplayer)->pHand->highcard == Seven  )
               {
                 Grid->ShowCell(1,4);
                 JackpotGrid[1][4] = true;
               }
               else
               {
                 Grid->ShowCell(4,3);
                 JackpotGrid[4][3] = true;
               }
               break;
	 case FourKind :
               switch(GetCasPlayer(activeplayer)->pHand->highcard)
               {
                 case AceHi : Grid->ShowCell(3,0);
                                 JackpotGrid[3][0] = true;break;
                 case King  : Grid->ShowCell(3,2);
                                 JackpotGrid[3][2] = true;break;
                 case Queen : Grid->ShowCell(0,3);
                                 JackpotGrid[0][3] = true;break;
                 case Jack  : Grid->ShowCell(4,1);
                                 JackpotGrid[4][1] = true;break;
                 case Ten   : Grid->ShowCell(4,0);
                                 JackpotGrid[4][0] = true;break;
                 case Nine  : Grid->ShowCell(1,2);
                                 JackpotGrid[1][2] = true;break;
                 case Eight : Grid->ShowCell(4,4);
                                 JackpotGrid[4][4] = true;break;
                 case Seven : Grid->ShowCell(1,1);
                                 JackpotGrid[1][1] = true;break;
                 case Six   : Grid->ShowCell(2,3);
                                 JackpotGrid[2][3] = true;break;
                 case Five  : Grid->ShowCell(0,4);
                                 JackpotGrid[0][4] = true;break;
                 case Four  : Grid->ShowCell(1,0);
                                 JackpotGrid[1][0] = true;break;
                 case Three : Grid->ShowCell(3,4);
                                 JackpotGrid[3][4] = true;break;
                 case Two   : Grid->ShowCell(2,1);
                                 JackpotGrid[2][1] = true;break;
               }
               break;
	 default : return false;
  }
  for(int i=0;i<5;i++)
  {
    if(JackpotGrid[i][0] == true && JackpotGrid[i][1] == true &&
       JackpotGrid[i][2] == true && JackpotGrid[i][3] == true &&
       JackpotGrid[i][4] == true                                )
    {
      return true;
    }
    if(JackpotGrid[0][i] == true && JackpotGrid[1][i] == true &&
       JackpotGrid[2][i] == true && JackpotGrid[3][i] == true &&
       JackpotGrid[4][i] == true                                )
    {
      return true;
    }
  }
  return false;
}
//*******************************************************************
void TACVPVPGLord::ClearRowCol()
{
  int row=5,col=5;
      for(int i=0;i<5;i++)
      {
        if(JackpotGrid[i][0] == true && JackpotGrid[i][1] == true &&
           JackpotGrid[i][2] == true && JackpotGrid[i][3] == true &&
           JackpotGrid[i][4] == true                                )
        {
          Grid->ClearRow(i);
          for(int j=0;j<5;j++)
          {
            JackpotGrid[i][j] = false;
          }
        }
        if(JackpotGrid[0][i] == true && JackpotGrid[1][i] == true &&
           JackpotGrid[2][i] == true && JackpotGrid[3][i] == true &&
           JackpotGrid[4][i] == true                                )
        {
          Grid->ClearCol(i);
          for(int j=0;j<5;j++)
          {
            JackpotGrid[j][i] = false;
          }
        }
      }
}
//*******************************************************************
void TACVPVPGLord::SaveGrid()
{
  TCasinoGameData *pgamedata = GetCasGameData();
  if(coinsize == 0.25)
  {
    for(int i=0;i<5;i++)
    {
      for(int j=0;j<5;j++)
      {
        pgamedata->SDJackpot025Grid[i][j] = JackpotGrid[i][j];
      }
    }
    pgamedata->SDJackpot025EndTime = TTime().Seconds();
  }
  else if(coinsize == 1.0)
  {
    for(int i=0;i<5;i++)
    {
      for(int j=0;j<5;j++)
      {
        pgamedata->SDJackpot1Grid[i][j] = JackpotGrid[i][j];
      }
    }
    pgamedata->SDJackpot1EndTime = TTime().Seconds();
  }
  else if(coinsize == 100.0)
  {
    for(int i=0;i<5;i++)
    {
      for(int j=0;j<5;j++)
      {
        pgamedata->SDJackpot100Grid[i][j] = JackpotGrid[i][j];
      }
    }
    pgamedata->SDJackpot100EndTime = TTime().Seconds();
  }
}
//*******************************************************************
void TACVPVPGLord::SetupGrid()
{
  TCasinoGameData *pgamedata = GetCasGameData();
  if(coinsize == 0.25)
  {
    for(int i=0;i<5;i++)
    {
      for(int j=0;j<5;j++)
      {
        JackpotGrid[i][j] = pgamedata->SDJackpot025Grid[i][j];
      }
    }
    if((TTime().Seconds() - pgamedata->SDJackpot025EndTime) > 90000l)
    {
      for(int i=0;i<5;i++)
      {
        for(int j=0;j<5;j++)
        {
          if(random(100) > 49)
          {
            JackpotGrid[i][j] = true;
            pgamedata->SDJackpot025Grid[i][j] = true;
          }
        }
      }
      for(int i=0;i<5;i++)
      {
        if(JackpotGrid[i][0] == true && JackpotGrid[i][1] == true &&
           JackpotGrid[i][2] == true && JackpotGrid[i][3] == true &&
           JackpotGrid[i][4] == true                                )
        {
          int x=random(5);
          JackpotGrid[i][x] = false;
          pgamedata->SDJackpot025Grid[i][x] = false;
        }
        if(JackpotGrid[0][i] == true && JackpotGrid[1][i] == true &&
           JackpotGrid[2][i] == true && JackpotGrid[3][i] == true &&
           JackpotGrid[4][i] == true                                )
        {
          int x=random(5);
          JackpotGrid[x][i] = false;
          pgamedata->SDJackpot025Grid[x][i] = false;
        }
      }
    }
  }
  else if(coinsize == 1.0)
  {
    for(int i=0;i<5;i++)
    {
      for(int j=0;j<5;j++)
      {
        JackpotGrid[i][j] = pgamedata->SDJackpot1Grid[i][j];
      }
    }
    if((TTime().Seconds() - pgamedata->SDJackpot1EndTime) > 90000l)
    {
      for(int i=0;i<5;i++)
      {
        for(int j=0;j<5;j++)
        {
          if(random(100) > 49)
          {
            JackpotGrid[i][j] = true;
            pgamedata->SDJackpot1Grid[i][j] = true;
          }
        }
      }
      for(int i=0;i<5;i++)
      {
        if(JackpotGrid[i][0] == true && JackpotGrid[i][1] == true &&
           JackpotGrid[i][2] == true && JackpotGrid[i][3] == true &&
           JackpotGrid[i][4] == true                                )
        {
          int x=random(5);
          JackpotGrid[i][x] = false;
          pgamedata->SDJackpot1Grid[i][x] = false;
        }
        if(JackpotGrid[0][i] == true && JackpotGrid[1][i] == true &&
           JackpotGrid[2][i] == true && JackpotGrid[3][i] == true &&
           JackpotGrid[4][i] == true                                )
        {
          int x=random(5);
          JackpotGrid[x][i] = false;
          pgamedata->SDJackpot1Grid[x][i] = false;
        }
      }
    }
  }
  else if(coinsize == 100.0)
  {
    for(int i=0;i<5;i++)
    {
      for(int j=0;j<5;j++)
      {
        JackpotGrid[i][j] = pgamedata->SDJackpot100Grid[i][j];
      }
    }
    if((TTime().Seconds() - pgamedata->SDJackpot100EndTime) > 90000l)
    {
      for(int i=0;i<5;i++)
      {
        for(int j=0;j<5;j++)
        {
          if(random(100) > 49)
          {
            JackpotGrid[i][j] = true;
            pgamedata->SDJackpot100Grid[i][j] = true;
          }
        }
      }
      for(int i=0;i<5;i++)
      {
        if(JackpotGrid[i][0] == true && JackpotGrid[i][1] == true &&
           JackpotGrid[i][2] == true && JackpotGrid[i][3] == true &&
           JackpotGrid[i][4] == true                                )
        {
          int x=random(5);
          JackpotGrid[i][x] = false;
          pgamedata->SDJackpot100Grid[i][x] = false;
        }
        if(JackpotGrid[0][i] == true && JackpotGrid[1][i] == true &&
           JackpotGrid[2][i] == true && JackpotGrid[3][i] == true &&
           JackpotGrid[4][i] == true                                )
        {
          int x=random(5);
          JackpotGrid[x][i] = false;
          pgamedata->SDJackpot100Grid[x][i] = false;
        }
      }
    }
  }
  for(int i=0;i<5;i++)
  {
    for(int j=0;j<5;j++)
    {
      if(JackpotGrid[i][j] == true)
      {
        Grid->ShowCell(i,j);
      }
      else
      {
        Grid->NoShowCell(i,j);
      }
    }
  }
}
//*******************************************************************
void TACVPVPGLord::SetupDenoms()
{
  for(int16 i=0;i<11;i++)
  {
	 Denom[i] = 0.0;
  }
  if (SubGameType == cvpFreeLook)
  {
    Denom[0] = (double)0.25;
    Denom[1] = (double)1.0;
    Denom[2] = (double)1000.0;
    NumOfDenoms = 3;
    switch (GameDenom.GetDenomID())
    {
      case TMoney::did_0_25    :CurrentDenomNum = 0;break;
      case TMoney::did_1_00    :CurrentDenomNum = 1;break;
      case TMoney::did_1000_00  :CurrentDenomNum = 2;break;
      default:CurrentDenomNum = -1;break;
    }
  }
  else if(SubGameType == cvpFivesUp)
  {
    Denom[0] = (double)0.25;
    Denom[1] = (double)1.0;
    Denom[2] = (double)50.0;
    Denom[3] = (double)100.0;
    NumOfDenoms = 4;
    switch (GameDenom.GetDenomID())
    {
      case TMoney::did_0_25    :CurrentDenomNum = 0;break;
      case TMoney::did_1_00    :CurrentDenomNum = 1;break;
      case TMoney::did_50_00   :CurrentDenomNum = 2;break;
      case TMoney::did_100_00  :CurrentDenomNum = 3;break;
      default:CurrentDenomNum = -1;break;
    }
  }
  else if(SubGameType == cvpBonusDeluxe)
  {
    Denom[0] = (double)0.25;
    Denom[1] = (double)1.0;
    Denom[2] = (double)5.0;
    Denom[3] = (double)10.0;
    Denom[4] = (double)25.0;
    NumOfDenoms = 5;
    switch (GameDenom.GetDenomID())
    {
      case TMoney::did_0_25    :CurrentDenomNum = 0;break;
      case TMoney::did_1_00    :CurrentDenomNum = 1;break;
      case TMoney::did_5_00    :CurrentDenomNum = 2;break;
      case TMoney::did_10_00   :CurrentDenomNum = 3;break;
      case TMoney::did_25_00   :CurrentDenomNum = 4;break;
      default:CurrentDenomNum = -1;break;
    }
  }
  else if(SubGameType == cvpClubBonus)
  {
    Denom[0] = (double)5.0;
    Denom[1] = (double)100.0;
    Denom[2] = (double)500.0;
    NumOfDenoms = 3;
    switch (GameDenom.GetDenomID())
    {
      case TMoney::did_5_00    :CurrentDenomNum = 0;break;
      case TMoney::did_100_00  :CurrentDenomNum = 1;break;
      case TMoney::did_500_00  :CurrentDenomNum = 2;break;
      default:CurrentDenomNum = -1;break;
    }
  }
  else if(SubGameType == cvpCrazy8s)
  {
    Denom[0] = (double)1.0;
    Denom[1] = (double)5.0;
    Denom[2] = (double)10.0;
    Denom[3] = (double)1000.0;
    NumOfDenoms = 4;
    switch (GameDenom.GetDenomID())
    {
      case TMoney::did_1_00    :CurrentDenomNum = 0;break;
      case TMoney::did_5_00    :CurrentDenomNum = 1;break;
      case TMoney::did_10_00   :CurrentDenomNum = 2;break;
      case TMoney::did_1000_00 :CurrentDenomNum = 3;break;
      default:CurrentDenomNum = -1;break;
    }
  }
  else if(SubGameType == cvpDDrawJB)
  {
    Denom[0] = (double)0.25;
    Denom[1] = (double)1.0;
    Denom[2] = (double)10.0;
    Denom[3] = (double)50.0;
    Denom[4] = (double)1000.0;
    NumOfDenoms = 5;
    switch (GameDenom.GetDenomID())
    {
      case TMoney::did_0_25    :CurrentDenomNum = 0;break;
      case TMoney::did_1_00    :CurrentDenomNum = 1;break;
      case TMoney::did_10_00   :CurrentDenomNum = 2;break;
      case TMoney::did_50_00   :CurrentDenomNum = 3;break;
      case TMoney::did_1000_00 :CurrentDenomNum = 4;break;
      default:CurrentDenomNum = -1;break;
    }
  }
  else if(SubGameType == cvpDDrawJokerPoker)
  {
    Denom[0] = (double)1.0;
    Denom[1] = (double)5.0;
    Denom[2] = (double)10.0;
    Denom[3] = (double)25.0;
    Denom[4] = (double)500.0;
    NumOfDenoms = 5;
    switch (GameDenom.GetDenomID())
    {
      case TMoney::did_1_00    :CurrentDenomNum = 0;break;
      case TMoney::did_5_00    :CurrentDenomNum = 1;break;
      case TMoney::did_10_00   :CurrentDenomNum = 2;break;
      case TMoney::did_25_00   :CurrentDenomNum = 3;break;
      case TMoney::did_500_00  :CurrentDenomNum = 4;break;
      default:CurrentDenomNum = -1;break;
    }
  }
  else if(SubGameType == cvpDDownStud)
  {
    Denom[0] = (double)0.25;
    Denom[1] = (double)1.0;
    Denom[2] = (double)5.0;
    Denom[3] = (double)50.0;
    Denom[4] = (double)100.0;
    NumOfDenoms = 5;
    switch (GameDenom.GetDenomID())
    {
      case TMoney::did_0_25    :CurrentDenomNum = 0;break;
      case TMoney::did_1_00    :CurrentDenomNum = 1;break;
      case TMoney::did_5_00    :CurrentDenomNum = 2;break;
      case TMoney::did_50_00   :CurrentDenomNum = 3;break;
      case TMoney::did_100_00  :CurrentDenomNum = 4;break;
      default:CurrentDenomNum = -1;break;
    }
  }
  else if(SubGameType == cvpDeucesWildBonus)
  {
    Denom[0] = (double)0.25;
    Denom[1] = (double)1.0;
    Denom[2] = (double)25.0;
    Denom[3] = (double)1000.0;
    NumOfDenoms = 4;
    switch (GameDenom.GetDenomID())
    {
      case TMoney::did_0_25    :CurrentDenomNum = 0;break;
      case TMoney::did_1_00    :CurrentDenomNum = 1;break;
      case TMoney::did_25_00   :CurrentDenomNum = 2;break;
      case TMoney::did_1000_00 :CurrentDenomNum = 3;break;
      default:CurrentDenomNum = -1;break;
    }
  }
  else if(SubGameType == cvpDeucesWildII)
  {
    Denom[0] = (double)0.05;
    Denom[1] = (double)0.10;
    Denom[2] = (double)0.25;
    Denom[3] = (double)1.0;
    Denom[4] = (double)5.0;
    Denom[5] = (double)25.0;
    Denom[6] = (double)100.0;
    NumOfDenoms = 7;
    switch (GameDenom.GetDenomID())
    {
      case TMoney::did_0_05    :CurrentDenomNum = 0;break;
      case TMoney::did_0_10    :CurrentDenomNum = 1;break;
      case TMoney::did_0_25    :CurrentDenomNum = 2;break;
      case TMoney::did_1_00    :CurrentDenomNum = 3;break;
      case TMoney::did_5_00    :CurrentDenomNum = 4;break;
      case TMoney::did_25_00   :CurrentDenomNum = 5;break;
      case TMoney::did_100_00  :CurrentDenomNum = 6;break;
      default:CurrentDenomNum = -1;break;
    }
  }
  else if(SubGameType == cvpDeucesWildProg)
  {
    Denom[0] = (double)0.05;
    Denom[1] = (double)1.0;
    Denom[2] = (double)5.0;
    NumOfDenoms = 3;
    switch (GameDenom.GetDenomID())
    {
      case TMoney::did_0_05    :CurrentDenomNum = 0;break;
      case TMoney::did_1_00    :CurrentDenomNum = 1;break;
      case TMoney::did_5_00    :CurrentDenomNum = 2;break;
      default:CurrentDenomNum = -1;break;
    }
  }
  else if(SubGameType == cvpDiamondBonus)
  {
    Denom[0] = (double)0.10;
    Denom[1] = (double)0.25;
    Denom[2] = (double)10.0;
    Denom[3] = (double)25.0;
    Denom[4] = (double)50.0;
    NumOfDenoms = 5;
    switch (GameDenom.GetDenomID())
    {
      case TMoney::did_0_10    :CurrentDenomNum = 0;break;
      case TMoney::did_0_25    :CurrentDenomNum = 1;break;
      case TMoney::did_10_00   :CurrentDenomNum = 2;break;
      case TMoney::did_25_00   :CurrentDenomNum = 3;break;
      case TMoney::did_50_00   :CurrentDenomNum = 4;break;
      default:CurrentDenomNum = -1;break;
    }
  }
  else if(SubGameType == cvpDBonusPoker)
  {
    Denom[0] = (double)0.05;
    Denom[1] = (double)0.10;
    Denom[2] = (double)0.25;
    Denom[3] = (double)1.0;
    Denom[4] = (double)100.0;
    NumOfDenoms = 5;
    switch (GameDenom.GetDenomID())
    {
      case TMoney::did_0_05    :CurrentDenomNum = 0;break;
      case TMoney::did_0_10    :CurrentDenomNum = 1;break;
      case TMoney::did_0_25    :CurrentDenomNum = 2;break;
      case TMoney::did_1_00    :CurrentDenomNum = 3;break;
      case TMoney::did_100_00  :CurrentDenomNum = 4;break;
      default:CurrentDenomNum = -1;break;
    }
  }
  else if(SubGameType == cvpFlushAssault)
  {
    Denom[0] = (double)1.0;
    Denom[1] = (double)25.0;
    Denom[2] = (double)100.0;
    Denom[3] = (double)500.0;
    Denom[4] = (double)1000.0;
    NumOfDenoms = 5;
    switch (GameDenom.GetDenomID())
    {
      case TMoney::did_1_00    :CurrentDenomNum = 0;break;
      case TMoney::did_25_00   :CurrentDenomNum = 1;break;
      case TMoney::did_100_00  :CurrentDenomNum = 2;break;
      case TMoney::did_500_00  :CurrentDenomNum = 3;break;
      case TMoney::did_1000_00 :CurrentDenomNum = 4;break;
     default:CurrentDenomNum = -1;break;
    }
  }
  else if(SubGameType == cvpGamblersEdge)
  {
    Denom[0] = (double)100.0;
    Denom[1] = (double)500.0;
    Denom[2] = (double)1000.0;
    NumOfDenoms = 3;
    switch (GameDenom.GetDenomID())
    {
      case TMoney::did_100_00    :CurrentDenomNum = 0;break;
      case TMoney::did_500_00    :CurrentDenomNum = 1;break;
      case TMoney::did_1000_00   :CurrentDenomNum = 2;break;
      default:CurrentDenomNum = -1;break;
    }
  }
  else if(SubGameType == cvpHeartBonus)
  {
    Denom[0] = (double)0.05;
    Denom[1] = (double)0.10;
    Denom[2] = (double)0.25;
    Denom[3] = (double)1.0;
    NumOfDenoms = 4;
    switch (GameDenom.GetDenomID())
    {
      case TMoney::did_0_05    :CurrentDenomNum = 0;break;
      case TMoney::did_0_10    :CurrentDenomNum = 1;break;
      case TMoney::did_0_25    :CurrentDenomNum = 2;break;
      case TMoney::did_1_00    :CurrentDenomNum = 3;break;
      default:CurrentDenomNum = -1;break;
    }
  }
  else if(SubGameType == cvpBlackJacks)
  {
    Denom[0] = (double)10.0;
    Denom[1] = (double)50.0;
    Denom[2] = (double)100.0;
    Denom[3] = (double)1000.0;
    NumOfDenoms = 4;
    switch (GameDenom.GetDenomID())
    {
      case TMoney::did_10_00    :CurrentDenomNum = 0;break;
      case TMoney::did_50_00    :CurrentDenomNum = 1;break;
      case TMoney::did_100_00   :CurrentDenomNum = 2;break;
      case TMoney::did_1000_00  :CurrentDenomNum = 3;break;
      default:CurrentDenomNum = -1;break;
    }
  }
  else if(SubGameType == cvpJacksProgII)
  {
    Denom[0] = (double)0.10;
    Denom[1] = (double)0.25;
    Denom[2] = (double)1.0;
    Denom[3] = (double)5.0;
    Denom[4] = (double)50.0;
    NumOfDenoms = 5;
    switch (GameDenom.GetDenomID())
    {
      case TMoney::did_0_10    :CurrentDenomNum = 0;break;
      case TMoney::did_0_25    :CurrentDenomNum = 1;break;
      case TMoney::did_1_00    :CurrentDenomNum = 2;break;
      case TMoney::did_5_00    :CurrentDenomNum = 3;break;
      case TMoney::did_50_00   :CurrentDenomNum = 4;break;
      default:CurrentDenomNum = -1;break;
    }
  }
  else if(SubGameType == cvpJackpotBonus)
  {
    Denom[0] = (double)1.0;
    NumOfDenoms = 1;
    switch (GameDenom.GetDenomID())
    {
      case TMoney::did_1_00    :CurrentDenomNum = 0;break;
      default:CurrentDenomNum = -1;break;
    }
  }
  else if(SubGameType == cvp96JacksOrBetterII)
  {
    Denom[0] = (double)0.25;
    Denom[1] = (double)1.0;
    Denom[2] = (double)5.0;
    Denom[3] = (double)50.0;
    Denom[4] = (double)100.0;
    Denom[5] = (double)500.0;
    Denom[6] = (double)1000.0;
    NumOfDenoms = 7;
    switch (GameDenom.GetDenomID())
    {
      case TMoney::did_0_25    :CurrentDenomNum = 0;break;
      case TMoney::did_1_00    :CurrentDenomNum = 1;break;
      case TMoney::did_5_00    :CurrentDenomNum = 2;break;
      case TMoney::did_50_00   :CurrentDenomNum = 3;break;
      case TMoney::did_100_00  :CurrentDenomNum = 4;break;
      case TMoney::did_500_00  :CurrentDenomNum = 5;break;
      case TMoney::did_1000_00 :CurrentDenomNum = 6;break;
      default:CurrentDenomNum = -1;break;
    }
  }
  else if(SubGameType == cvpTreasureTrove)
  {
    Denom[0] = (double)1.0;
    Denom[1] = (double)100.0;
    Denom[2] = (double)1000.0;
    NumOfDenoms = 3;
    switch (GameDenom.GetDenomID())
    {
      case TMoney::did_1_00      :CurrentDenomNum = 0;break;
      case TMoney::did_100_00    :CurrentDenomNum = 1;break;
      case TMoney::did_1000_00   :CurrentDenomNum = 2;break;
      default:CurrentDenomNum = -1;break;
    }
  }
  else if(SubGameType == cvp85JacksOrBetter)
  {
    Denom[0]  = (double)0.05;
    Denom[1]  = (double)0.10;
    Denom[2]  = (double)0.25;
    Denom[3]  = (double)1.0;
    Denom[4]  = (double)5.0;
    Denom[5]  = (double)10.0;
    Denom[6]  = (double)25.0;
    Denom[7]  = (double)50.0;
    Denom[8]  = (double)100.0;
    Denom[9]  = (double)500.0;
    Denom[10] = (double)1000.0;
    NumOfDenoms = 11;
    switch (GameDenom.GetDenomID())
    {
      case TMoney::did_0_05    :CurrentDenomNum = 0;break;
      case TMoney::did_0_10    :CurrentDenomNum = 1;break;
      case TMoney::did_0_25    :CurrentDenomNum = 2;break;
      case TMoney::did_1_00    :CurrentDenomNum = 3;break;
      case TMoney::did_5_00    :CurrentDenomNum = 4;break;
      case TMoney::did_10_00   :CurrentDenomNum = 5;break;
      case TMoney::did_25_00   :CurrentDenomNum = 6;break;
      case TMoney::did_50_00   :CurrentDenomNum = 7;break;
      case TMoney::did_100_00  :CurrentDenomNum = 8;break;
      case TMoney::did_500_00  :CurrentDenomNum = 9;break;
      case TMoney::did_1000_00 :CurrentDenomNum = 10;break;
      default:CurrentDenomNum = -1;break;
    }
  }
  else if(SubGameType == cvpDJacksOrBetter)
  {
    Denom[0] = (double)0.25;
    Denom[1] = (double)1.0;
    Denom[2] = (double)5.0;
    Denom[3] = (double)25.0;
    Denom[4] = (double)100.0;
    NumOfDenoms = 5;
    switch (GameDenom.GetDenomID())
    {
      case TMoney::did_0_25    :CurrentDenomNum = 0;break;
      case TMoney::did_1_00    :CurrentDenomNum = 1;break;
      case TMoney::did_5_00    :CurrentDenomNum = 2;break;
      case TMoney::did_25_00   :CurrentDenomNum = 3;break;
      case TMoney::did_100_00  :CurrentDenomNum = 4;break;
      default:CurrentDenomNum = -1;break;
    }
  }
  else if(SubGameType == cvpJokersWildProg)
  {
    Denom[0] = (double)0.05;
    Denom[1] = (double)0.25;
    Denom[2] = (double)1.0;
    Denom[3] = (double)100.0;
    NumOfDenoms = 4;
    switch (GameDenom.GetDenomID())
    {
      case TMoney::did_0_05    :CurrentDenomNum = 0;break;
      case TMoney::did_0_25    :CurrentDenomNum = 1;break;
      case TMoney::did_1_00    :CurrentDenomNum = 2;break;
      case TMoney::did_100_00  :CurrentDenomNum = 3;break;
      default:CurrentDenomNum = -1;break;
    }
  }
  else if(SubGameType == cvpJumpinJokers)
  {
    Denom[0] = (double)5.0;
    Denom[1] = (double)50.0;
    NumOfDenoms = 2;
    switch (GameDenom.GetDenomID())
    {
      case TMoney::did_5_00    :CurrentDenomNum = 0;break;
      case TMoney::did_50_00    :CurrentDenomNum = 1;break;
      default:CurrentDenomNum = -1;break;
    }
  }
  else if(SubGameType == cvpTripleProg)
  {
    Denom[0] = (double)0.05;
    Denom[1] = (double)0.25;
    Denom[2] = (double)1.0;
    Denom[3] = (double)10.0;
    NumOfDenoms = 4;
    switch (GameDenom.GetDenomID())
    {
      case TMoney::did_0_05    :CurrentDenomNum = 0;break;
      case TMoney::did_0_25    :CurrentDenomNum = 1;break;
      case TMoney::did_1_00    :CurrentDenomNum = 2;break;
      case TMoney::did_10_00   :CurrentDenomNum = 3;break;
      default:CurrentDenomNum = -1;break;
    }
  }
  else if(SubGameType == cvpRoyalProg)
  {
    Denom[0] = (double)0.10;
    Denom[1] = (double)1.0;
    Denom[2] = (double)25.0;
    NumOfDenoms = 3;
    switch (GameDenom.GetDenomID())
    {
      case TMoney::did_0_10    :CurrentDenomNum = 0;break;
      case TMoney::did_1_00    :CurrentDenomNum = 1;break;
      case TMoney::did_25_00   :CurrentDenomNum = 2;break;
      default:CurrentDenomNum = -1;break;
    }
  }
  else if(SubGameType == cvpPowerProg)
  {
    Denom[0] = (double)0.25;
    Denom[1] = (double)1.0;
    Denom[2] = (double)50.0;
    NumOfDenoms = 3;
    switch (GameDenom.GetDenomID())
    {
      case TMoney::did_0_25    :CurrentDenomNum = 0;break;
      case TMoney::did_1_00    :CurrentDenomNum = 1;break;
      case TMoney::did_50_00   :CurrentDenomNum = 2;break;
      default:CurrentDenomNum = -1;break;
    }
  }
  else if(SubGameType == cvpRaiseJokersWild)
  {
    Denom[0] = (double)0.25;
    Denom[1] = (double)1.0;
    Denom[2] = (double)10.0;
    Denom[3] = (double)100.0;
    Denom[4] = (double)500.0;
    NumOfDenoms = 5;
    switch (GameDenom.GetDenomID())
    {
      case TMoney::did_0_25    :CurrentDenomNum = 0;break;
      case TMoney::did_1_00    :CurrentDenomNum = 1;break;
      case TMoney::did_10_00   :CurrentDenomNum = 2;break;
      case TMoney::did_100_00  :CurrentDenomNum = 3;break;
      case TMoney::did_500_00  :CurrentDenomNum = 4;break;
      default:CurrentDenomNum = -1;break;
    }
  }
  else if(SubGameType == cvpSpadeBonus)
  {
    Denom[0] = (double)0.05;
    Denom[1] = (double)0.25;
    Denom[2] = (double)5.0;
    NumOfDenoms = 3;
    switch (GameDenom.GetDenomID())
    {
      case TMoney::did_0_05    :CurrentDenomNum = 0;break;
      case TMoney::did_0_25    :CurrentDenomNum = 1;break;
      case TMoney::did_5_00    :CurrentDenomNum = 2;break;
      default:CurrentDenomNum = -1;break;
    }
  }
  else if(SubGameType == cvpSuperDJackpot)
  {
    Denom[0] = (double)0.25;
    Denom[1] = (double)1.0;
    Denom[2] = (double)100.0;
    NumOfDenoms = 3;
    switch (GameDenom.GetDenomID())
    {
      case TMoney::did_0_25    :CurrentDenomNum = 0;break;
      case TMoney::did_1_00    :CurrentDenomNum = 1;break;
      case TMoney::did_100_00  :CurrentDenomNum = 2;break;
      default:CurrentDenomNum = -1;break;
    }
  }
  else if(SubGameType == cvp7Wild1Joker)
  {
    Denom[0] = (double)5.0;
    Denom[1] = (double)25.0;
    Denom[2] = (double)1000.0;
    NumOfDenoms = 3;
    switch (GameDenom.GetDenomID())
    {
      case TMoney::did_5_00    :CurrentDenomNum = 0;break;
      case TMoney::did_25_00   :CurrentDenomNum = 1;break;
      case TMoney::did_1000_00 :CurrentDenomNum = 2;break;
      default:CurrentDenomNum = -1;break;
    }
  }
  else if(SubGameType == cvpTensOrBetterII)
  {
    Denom[0] = (double)0.05;
    Denom[1] = (double)0.10;
    Denom[2] = (double)0.25;
    Denom[3] = (double)1.0;
    Denom[4] = (double)50.0;
    NumOfDenoms = 5;
    switch (GameDenom.GetDenomID())
    {
      case TMoney::did_0_05    :CurrentDenomNum = 0;break;
      case TMoney::did_0_10    :CurrentDenomNum = 1;break;
      case TMoney::did_0_25    :CurrentDenomNum = 2;break;
      case TMoney::did_1_00    :CurrentDenomNum = 3;break;
      case TMoney::did_50_00   :CurrentDenomNum = 4;break;
      default:CurrentDenomNum = -1;break;
    }
  }
  else if(SubGameType == cvpTriplePlay)
  {
    Denom[0] = (double)0.25;
    Denom[1] = (double)1.0;
    Denom[2] = (double)25.0;
    Denom[3] = (double)500.0;
    NumOfDenoms = 4;
    switch (GameDenom.GetDenomID())
    {
      case TMoney::did_0_25    :CurrentDenomNum = 0;break;
      case TMoney::did_1_00    :CurrentDenomNum = 1;break;
      case TMoney::did_25_00   :CurrentDenomNum = 2;break;
      case TMoney::did_500_00  :CurrentDenomNum = 3;break;
      default:CurrentDenomNum = -1;break;
    }
  }
  else if(SubGameType == cvpTripleBonus)
  {
    Denom[0] = (double)0.25;
    Denom[1] = (double)50.0;
    NumOfDenoms = 2;
    switch (GameDenom.GetDenomID())
    {
      case TMoney::did_0_25    :CurrentDenomNum = 0;break;
      case TMoney::did_50_00   :CurrentDenomNum = 1;break;
      default:CurrentDenomNum = -1;break;
    }
  }
  else if(SubGameType == cvpWheelDeal)
  {
    Denom[0] = (double)1.0;
    Denom[1] = (double)10.0;
    Denom[2] = (double)1000.0;
    NumOfDenoms = 3;
    switch (GameDenom.GetDenomID())
    {
      case TMoney::did_1_00      :CurrentDenomNum = 0;break;
      case TMoney::did_10_00    :CurrentDenomNum = 1;break;
      case TMoney::did_1000_00  :CurrentDenomNum = 2;break;
      default:CurrentDenomNum = -1;break;
    }
  }
}
//*******************************************************************
void TACVPVPGLord::CycleDenom()
{
  GetCasPlayer(activeplayer)->credit = 0;
  if(coinsplayed > 0 || credits > 0)
  {
    CoinPay->PlayRegSound();
  }
  if(shutdownstate == 0)
  {
	 GetCasPD(activeplayer)->Cash += double(coinsplayed*coinsize);
  }
  coinsplayed = 0;
  GetCasPD(activeplayer)->Cash += double(credits*coinsize);
  credits = 0;
  Button0->ShowGray();
  Button3->ShowGray();
  Credits->SetNum(0);
  CoinsPlayed->SetNum(0);
  BankCashDisplay->SetNum(GetCash(activeplayer));

  CurrentDenomNum++;
  if(CurrentDenomNum >= NumOfDenoms){CurrentDenomNum = 0;}
  Value->ChangeDenom(Denom[CurrentDenomNum],IsCycle);
  if(GetCasPD(0)->Cash >= Denom[CurrentDenomNum])
  {
    Button1->ShowVoidUp();
    Button2->ShowVoidUp();
  }
  else
  {
    Button1->ShowGray();
    Button2->ShowGray();
  }
}
//*******************************************************************
bool TACVPVPGLord::SwitchDenom(TMoney denom)
{
  TCasinoGameData *pgamedata = GetCasGameData();
  if(SubGameType==cvpSuperDJackpot)
  {
    SaveGrid();
  }
  if (SubGameType==cvpJacksProgII || SubGameType==cvpPowerProg ||
      SubGameType==cvpJokersWildProg || SubGameType==cvpDeucesWildProg ||
      SubGameType==cvpRoyalProg || SubGameType==cvpTripleProg            )
  {
    SaveJackpots();
  }
  GetCasPlayer(activeplayer)->credit = 0;
  if(coinsplayed > 0 || credits > 0)
  {
    CoinPay->PlayRegSound();
  }
  if(shutdownstate == 0)
  {
	 GetCasPD(activeplayer)->Cash += double(coinsplayed*coinsize);
  }
  coinsplayed = 0;
  GetCasPD(activeplayer)->Cash += double(credits*coinsize);
  credits = 0;
  Button0->ShowGray();
  Button3->ShowGray();
  Credits->SetNum(0);
  CoinsPlayed->SetNum(0);
  BankCashDisplay->SetNum(GetCash(activeplayer));

  while(denom != Denom[CurrentDenomNum])
  {
	 CurrentDenomNum++;
	 if(CurrentDenomNum >= NumOfDenoms){CurrentDenomNum = 0;}
  }
  Value->ChangeDenom(Denom[CurrentDenomNum],IsCycle);
  NotifyPlayerDeActivation(0);
  coinsize = Denom[CurrentDenomNum];
  NotifyPlayerActivation(0);
  IsCycle = false;
  GameDenom = coinsize;
  if(GetCasPD(activeplayer)->Cash < coinsize)
  {
    Button2->ShowGray();
    Button1->ShowGray();
  }
  else
  {
    Button1->ShowVoidUp();
    Button2->ShowVoidUp();
  }
  if (SubGameType==cvpJacksProgII || SubGameType==cvpPowerProg ||
      SubGameType==cvpJokersWildProg || SubGameType==cvpDeucesWildProg ||
      SubGameType==cvpRoyalProg || SubGameType==cvpTripleProg            )
  {
    SetupJackpots();
  }
  if(SubGameType==cvpSuperDJackpot)
  {
    SetupGrid();
  }
  return true;
}
//*******************************************************************
void TACVPVPGLord::DoubleTheBet()
{
  if(GetCash(activeplayer)+(credits*coinsize) < coinsplayed*coinsize)
  {
	 PModeWin->MessageBox("You don't have enough money to bet more.","Not Enough",MB_OK);
	 return;
  }
  int cp = coinsplayed;
  int16 session = GetCasPD(activeplayer)->VPData.CurrentSession;
  TCVPSession &cs = GetCasPD(activeplayer)->VPData.Sessions[session];

  if(credits >= coinsplayed)
  {
	 credits -= coinsplayed;
	 cs.TotalBetsCash += (coinsplayed)*coinsize;
	 CoinsPlayed->SetNum(2*coinsplayed);
	 Credits->SetNum(credits);
	 if(credits == 0)
	 {
		Button0->ShowGray();
	 }
    DoubleBet = true;
	 return;
  }
  if (GetCash(activeplayer) > (coinsplayed-credits) * coinsize)
  {
	 SubCash(activeplayer,(coinsplayed-credits) * coinsize);
    cs.TotalBetsCash += (coinsplayed)*coinsize;
    credits = 0;
	 CoinsPlayed->SetNum(2*coinsplayed);
    Credits->SetNum(credits);
    DoubleBet = true;
  }
  BankCashDisplay->SetNum(GetCash(activeplayer));

}
 //*******************************************************************
void TACVPVPGLord::ShowFlushAssault()
{
  WinRatio = DullWRatio; //wrong name
  FlushSwitch = true;
  FlushAssaultOn = true;
  flushStartTime = TTime().Seconds() + 360 + random(360);
}
//*******************************************************************
void TACVPVPGLord::SetFlushAssault()
{
  numPlays = random(100)+50;
  currentNumPlays = 0;
  WinRatio = FAss;  //wrong name
  FlushSwitch = true;
  FlushAssaultOn = false;
  FAss->NoShow();
}
//*******************************************************************
TACVPVPGLord::TACVPVPGLord(TVideoPokerModeWin *pvpmw,const TFileMode &fm,
                         int16 sgt,int16 denomid)
:TCasinoVPGameLord(pvpmw,fm,sgt,denomid)
{
  JackpotBonusAmount = 0;
  XName = 12;
  IsDoubleType = false;
  IsNormalType = false;
  IsDDrawType  = false;
  MultPayoff = 1;
  isCoin = true;
  idsSounds = 0;
  idsVertLite = 0;
  idsVertLite2 = 0;
  idsDrawBack = 0;
  idsCoinPay = 0;
  idsChips = 0;
  idsCard1 = 0;
  idsCard2 = 0;
  idsCard3 = 0;
  idsCard4 = 0;
  idsCard5 = 0;
  idsNP1 = 0;
  idsNP2 = 0;
  idsNP3 = 0;
  idsCoinsPlayed = 0;
  idsCredits = 0;
  idsWinPaid = 0;
  idsWinPaidTop = 0;
  idsWinPaidMid = 0;
  idsWinPaidBot = 0;
  idsButton0 = 0;
  idsButton1 = 0;
  idsButton2 = 0;
  idsButton3 = 0;
  idsButton4 = 0;
  idsButton5 = 0;
  idsButton6 = 0;
  idsButton7 = 0;
  idsButton8 = 0;
  idsButton9 = 0;
  idsWinRatio = 0;
  idsBankCash = 0;
  idsProgressive = 0;
  idsValue    = 0;
  idsGridWin = 0;
  idsGrid = 0;
  idsFAss = 0;
  idsLook  = 0;
  idsWheel = 0;
  idsChest = 0;
  idsJackpotBonus = 0;
  idsProg1 = 0;
  idsProg2 = 0;
  idsProg3 = 0;
  idsProg4 = 0;
  idsBackG = 0;

  strSounds = TAppString::strEmpty;
  strVertLite = TAppString::strEmpty;
  strVertLite2 = TAppString::strEmpty;
  strDrawBack = TAppString::strEmpty;
  strCoinPay = TAppString::strEmpty;
  strChips = TAppString::strEmpty;
  strCard1 = TAppString::strEmpty;
  strCard2 = TAppString::strEmpty;
  strCard3 = TAppString::strEmpty;
  strCard4 = TAppString::strEmpty;
  strCard5 = TAppString::strEmpty;
  strNP1 = TAppString::strEmpty;
  strNP2 = TAppString::strEmpty;
  strNP3 = TAppString::strEmpty;
  strCoinsPlayed = TAppString::strEmpty;
  strCredits = TAppString::strEmpty;
  strWinPaid = TAppString::strEmpty;
//  strWinPaidTop = TAppString::strEmpty;
//  strWinPaidMid = TAppString::strEmpty;
  strButton0 = TAppString::strEmpty;
  strButton1 = TAppString::strEmpty;
  strButton2 = TAppString::strEmpty;
  strButton3 = TAppString::strEmpty;
  strButton4 = TAppString::strEmpty;
  strButton5 = TAppString::strEmpty;
  strButton6 = TAppString::strEmpty;
  strButton7 = TAppString::strEmpty;
  strButton8 = TAppString::strEmpty;
  strButton9 = TAppString::strEmpty;
  strWinRatio = TAppString::strEmpty;
  strBankCash = TAppString::strEmpty;
  strProgressive = TAppString::strEmpty;
  strValue    =  TAppString::strEmpty;
  strGridWin    =  TAppString::strEmpty;
  strGrid    =  TAppString::strEmpty;
  strFAss    =  TAppString::strEmpty;
  strLook     =  TAppString::strEmpty;
  strBackG    =  TAppString::strEmpty;
  strWheel     =  TAppString::strEmpty;
  strChest     =  TAppString::strEmpty;
  strJackpotBonus = TAppString::strEmpty;
  strProg1   = TAppString::strEmpty;
  strProg2   = TAppString::strEmpty;
  strProg3   = TAppString::strEmpty;
  strProg4   = TAppString::strEmpty;

  for(int i=0;i<5;i++)
  {
    for(int j=0;j<5;j++)
    {
      JackpotGrid[i][j] = false;
    }
  }
  CardSprite = NULL;


 //??? VPSounds = NULL;
  Chest = NULL;
  Prog1 = NULL;
  Prog2 = NULL;
  Prog3 = NULL;
  Prog4 = NULL;
  Value   = NULL;
  GridWin = NULL;
  Song = NULL;
  Title = NULL;
  Grid  = NULL;
  FAss = NULL;
  Look = NULL;
  BackG = NULL;
  JackpotBonus = NULL;
  Wheel = NULL;
  Progressive     = NULL;
  Button0 = NULL;
  Button1 = NULL;
  Button2 = NULL;
  Button3 = NULL;
  Button4 = NULL;
  Button5 = NULL;
  Button6 = NULL;
  Button7 = NULL;
  Button8 = NULL;
  Button9 = NULL;

  CoinsPlayed     = NULL;
  WinRatio        = NULL;
  WinPaid         = NULL;
  WinPaidTop      = NULL;
  WinPaidMid      = NULL;
  WinPaidBot      = NULL;
  Credits         = NULL;
  NamePlate1      = NULL;
  NamePlate2      = NULL;
  NamePlate3      = NULL;
  BankCashDisplay = NULL;
 //??? DrawBack        = NULL;
  CoinPay         = NULL;
  VertLite        = NULL;
  VertLite2       = NULL;

  shutdownstate    = 0;
  winhand = "";

  FlushAssaultOn = false;
  IncAdd2=0;
  IncAdd3=0;
  IncAdd4=0;

  r1=0;
  r2=0;
  r3=0;
  activeplayer = 0;
  machinenum = 0;
  playersin=0;
  numofsplits = 0;
  ButtonInfo = 0;

  progressive1=0;
  progressive2=0;
  progressive3=0;
  progressive4=0;

  for(int i=0;i<5;i++)
  {
    for(int j=0;j<5;j++)
    {
      JackpotGrid[i][j] = false;
    }
  }
  for(int16 i=0;i<NUMOFBUTTONS;i++)
  {
	 ButtonHit[i] = false;
  }
  SetupDenoms();

  PState   = new TACVPLordMainState(this);
  pDeck    = new TACVPDeck(pvpmw);
  pTopDeck = NULL;
  pMidDeck = NULL;
  TripTopHand = NULL;
  TripMidHand = NULL;
  TopCardSprite = NULL;
  MidCardSprite = NULL;
  //WinPaidTop  = NULL;
  //WinPaidMid  = NULL;
 // WinPaidBot  = NULL;
  if(SubGameType == cvpTriplePlay)
  {
    pTopDeck    = new TACVPDeck(pvpmw);
    pMidDeck    = new TACVPDeck(pvpmw);
    TripTopHand = new TPokerHand;
    TripMidHand = new TPokerHand;
  }
  pSmarts  = new TVPSmarts;
  fake     = new TPokerHand;

  ask      = new TACVPAsk(this);

  ShowTripleBack;
  pDeck->InitVPDeck();
  if(SubGameType == cvpTriplePlay)
  {
    pTopDeck->InitVPDeck();
    pMidDeck->InitVPDeck();
  }

  SetupUniqueIDStrings();

  SetupResponders();

  TFileMode splfm(SpriteListName,
                  TFileMode::fm_None,
                  TFileMode::fm_Immed,
                  FileMode.GetDirIndex());
  CreateAddSpriteList(splfm);

  SetupSprites();
}
//*******************************************************************
TACVPVPGLord::~TACVPVPGLord()
{
  if(PState != NULL)
  {
	 delete PState;
	 PState = NULL;
  }
  if (pSmarts != NULL)
  {
    delete pSmarts;
    pSmarts = NULL;
  }
  if (pTopDeck != NULL)
  {
    delete pTopDeck;
    pTopDeck = NULL;
  }
  if (pMidDeck != NULL)
  {
    delete pMidDeck;
    pMidDeck = NULL;
  }
  if (pDeck != NULL)
  {
    delete pDeck;
    pDeck = NULL;
  }
  if (ask != NULL)
  {
    delete ask;
    ask = NULL;
  }
  if (fake != NULL)
  {
    delete fake;
    fake = NULL;
  }
  CleanupSprites();
  CleanupResponders();
}
//*******************************************************************
void TACVPVPGLord::SetUIDS()
{
  switch (SubGameType)
  {
    case cvpFivesUp:       idsVertLite = IDS_MS_VERTLITE_ACVP_VP_FIVESUP;
                           idsCoinPay = IDS_MS_COINPAY_ACVP_VP_FIVESUP;
                           idsCard1 = IDS_MS_CARD1_ACVP_VP_FIVESUP;
                           idsNP1 = IDS_MS_NP1_ACVP_VP_FIVESUP;
                           idsCoinsPlayed = IDS_MS_COINSPLAYED_ACVP_VP_FIVESUP;
                           idsCredits = IDS_MS_CREDITS_ACVP_VP_FIVESUP;
                           idsWinPaid = IDS_MS_WINPAID_ACVP_VP_FIVESUP;
                           idsButton0 = IDS_MS_B0_ACVP_VP_FIVESUP;
                           idsButton1 = IDS_MS_B1_ACVP_VP_FIVESUP;
                           idsButton2 = IDS_MS_B2_ACVP_VP_FIVESUP;
                           idsButton3 = IDS_MS_B3_ACVP_VP_FIVESUP;
                           idsButton4 = IDS_MS_B4_ACVP_VP_FIVESUP;
                           idsButton5 = IDS_MS_B5_ACVP_VP_FIVESUP;
                           idsButton6 = IDS_MS_B6_ACVP_VP_FIVESUP;
                           idsButton7 = IDS_MS_B7_ACVP_VP_FIVESUP;
                           idsWinRatio = IDS_MS_WINRATIO_ACVP_VP_FIVESUP;
                           idsBankCash = IDS_MS_BANKCASH_ACVP_VP_FIVESUP;
                           break;
    case cvpBlackJacks:    idsVertLite = IDS_MS_VERTLITE_ACVP_VP_BLACKJACKS;
                           idsCoinPay = IDS_MS_COINPAY_ACVP_VP_BLACKJACKS;
                           idsCard1 = IDS_MS_CARD1_ACVP_VP_BLACKJACKS;
                           idsNP1 = IDS_MS_NP1_ACVP_VP_BLACKJACKS;
                           idsCoinsPlayed = IDS_MS_COINSPLAYED_ACVP_VP_BLACKJACKS;
                           idsCredits = IDS_MS_CREDITS_ACVP_VP_BLACKJACKS;
                           idsWinPaid = IDS_MS_WINPAID_ACVP_VP_BLACKJACKS;
                           idsButton0 = IDS_MS_B0_ACVP_VP_BLACKJACKS;
                           idsButton1 = IDS_MS_B1_ACVP_VP_BLACKJACKS;
                           idsButton2 = IDS_MS_B2_ACVP_VP_BLACKJACKS;
                           idsButton3 = IDS_MS_B3_ACVP_VP_BLACKJACKS;
                           idsButton4 = IDS_MS_B4_ACVP_VP_BLACKJACKS;
                           idsButton5 = IDS_MS_B5_ACVP_VP_BLACKJACKS;
                           idsButton6 = IDS_MS_B6_ACVP_VP_BLACKJACKS;
                           idsButton7 = IDS_MS_B7_ACVP_VP_BLACKJACKS;
                           idsWinRatio = IDS_MS_WINRATIO_ACVP_VP_BLACKJACKS;
                           idsBankCash = IDS_MS_BANKCASH_ACVP_VP_BLACKJACKS;
                           break;
    case cvpBonusDeluxe:   idsVertLite = IDS_MS_VERTLITE_ACVP_VP_BONUSDELUXE;
                           idsCoinPay = IDS_MS_COINPAY_ACVP_VP_BONUSDELUXE;
                           idsCard1 = IDS_MS_CARD1_ACVP_VP_BONUSDELUXE;
                           idsNP1 = IDS_MS_NP1_ACVP_VP_BONUSDELUXE;
                           idsCoinsPlayed = IDS_MS_COINSPLAYED_ACVP_VP_BONUSDELUXE;
                           idsCredits = IDS_MS_CREDITS_ACVP_VP_BONUSDELUXE;
                           idsWinPaid = IDS_MS_WINPAID_ACVP_VP_BONUSDELUXE;
                           idsButton0 = IDS_MS_B0_ACVP_VP_BONUSDELUXE;
                           idsButton1 = IDS_MS_B1_ACVP_VP_BONUSDELUXE;
                           idsButton2 = IDS_MS_B2_ACVP_VP_BONUSDELUXE;
                           idsButton3 = IDS_MS_B3_ACVP_VP_BONUSDELUXE;
                           idsButton4 = IDS_MS_B4_ACVP_VP_BONUSDELUXE;
                           idsButton5 = IDS_MS_B5_ACVP_VP_BONUSDELUXE;
                           idsButton6 = IDS_MS_B6_ACVP_VP_BONUSDELUXE;
                           idsButton7 = IDS_MS_B7_ACVP_VP_BONUSDELUXE;
                           idsButton8 = IDS_MS_B8_ACVP_VP_BONUSDELUXE;
                           idsButton9 = IDS_MS_B9_ACVP_VP_BONUSDELUXE;
                           idsWinRatio = IDS_MS_WINRATIO_ACVP_VP_BONUSDELUXE;
                           idsBankCash = IDS_MS_BANKCASH_ACVP_VP_BONUSDELUXE;
                           idsBackG   = IDS_MS_BACKG_ACVP_VP_BONUSDELUXE;
                           break;
    case cvpClubBonus:     idsVertLite = IDS_MS_VERTLITE_ACVP_VP_CLUBBONUS;
                           idsCoinPay = IDS_MS_COINPAY_ACVP_VP_CLUBBONUS;
                           idsCard1 = IDS_MS_CARD1_ACVP_VP_CLUBBONUS;
                           idsNP1 = IDS_MS_NP1_ACVP_VP_CLUBBONUS;
                           idsCoinsPlayed = IDS_MS_COINSPLAYED_ACVP_VP_CLUBBONUS;
                           idsCredits = IDS_MS_CREDITS_ACVP_VP_CLUBBONUS;
                           idsWinPaid = IDS_MS_WINPAID_ACVP_VP_CLUBBONUS;
                           idsButton0 = IDS_MS_B0_ACVP_VP_CLUBBONUS;
                           idsButton1 = IDS_MS_B1_ACVP_VP_CLUBBONUS;
                           idsButton2 = IDS_MS_B2_ACVP_VP_CLUBBONUS;
                           idsButton3 = IDS_MS_B3_ACVP_VP_CLUBBONUS;
                           idsButton4 = IDS_MS_B4_ACVP_VP_CLUBBONUS;
                           idsButton5 = IDS_MS_B5_ACVP_VP_CLUBBONUS;
                           idsButton6 = IDS_MS_B6_ACVP_VP_CLUBBONUS;
                           idsButton7 = IDS_MS_B7_ACVP_VP_CLUBBONUS;
                           idsWinRatio = IDS_MS_WINRATIO_ACVP_VP_CLUBBONUS;
                           idsBankCash = IDS_MS_BANKCASH_ACVP_VP_CLUBBONUS;
                           break;
    case cvpCrazy8s:       idsVertLite = IDS_MS_VERTLITE_ACVP_VP_CRAZY8S;
                           idsCoinPay = IDS_MS_COINPAY_ACVP_VP_CRAZY8S;
                           idsCard1 = IDS_MS_CARD1_ACVP_VP_CRAZY8S;
                           idsNP1 = IDS_MS_NP1_ACVP_VP_CRAZY8S;
                           idsCoinsPlayed = IDS_MS_COINSPLAYED_ACVP_VP_CRAZY8S;
                           idsCredits = IDS_MS_CREDITS_ACVP_VP_CRAZY8S;
                           idsWinPaid = IDS_MS_WINPAID_ACVP_VP_CRAZY8S;
                           idsButton0 = IDS_MS_B0_ACVP_VP_CRAZY8S;
                           idsButton1 = IDS_MS_B1_ACVP_VP_CRAZY8S;
                           idsButton2 = IDS_MS_B2_ACVP_VP_CRAZY8S;
                           idsButton3 = IDS_MS_B3_ACVP_VP_CRAZY8S;
                           idsButton4 = IDS_MS_B4_ACVP_VP_CRAZY8S;
                           idsButton5 = IDS_MS_B5_ACVP_VP_CRAZY8S;
                           idsButton6 = IDS_MS_B6_ACVP_VP_CRAZY8S;
                           idsButton7 = IDS_MS_B7_ACVP_VP_CRAZY8S;
                           idsWinRatio = IDS_MS_WINRATIO_ACVP_VP_CRAZY8S;
                           idsBankCash = IDS_MS_BANKCASH_ACVP_VP_CRAZY8S;
                           break;
    case cvpDDrawJB:       idsVertLite = IDS_MS_VERTLITE_ACVP_VP_DDRAWJACKSORBETTER;
                           idsCoinPay = IDS_MS_COINPAY_ACVP_VP_DDRAWJACKSORBETTER;
                           idsCard1 = IDS_MS_CARD1_ACVP_VP_DDRAWJACKSORBETTER;
                           idsNP1 = IDS_MS_NP1_ACVP_VP_DDRAWJACKSORBETTER;
                           idsCoinsPlayed = IDS_MS_COINSPLAYED_ACVP_VP_DDRAWJACKSORBETTER;
                           idsCredits = IDS_MS_CREDITS_ACVP_VP_DDRAWJACKSORBETTER;
                           idsWinPaid = IDS_MS_WINPAID_ACVP_VP_DDRAWJACKSORBETTER;
                           idsButton0 = IDS_MS_B0_ACVP_VP_DDRAWJACKSORBETTER;
                           idsButton1 = IDS_MS_B1_ACVP_VP_DDRAWJACKSORBETTER;
                           idsButton2 = IDS_MS_B2_ACVP_VP_DDRAWJACKSORBETTER;
                           idsButton3 = IDS_MS_B3_ACVP_VP_DDRAWJACKSORBETTER;
                           idsButton4 = IDS_MS_B4_ACVP_VP_DDRAWJACKSORBETTER;
                           idsButton5 = IDS_MS_B5_ACVP_VP_DDRAWJACKSORBETTER;
                           idsButton6 = IDS_MS_B6_ACVP_VP_DDRAWJACKSORBETTER;
                           idsButton7 = IDS_MS_B7_ACVP_VP_DDRAWJACKSORBETTER;
                           idsWinRatio = IDS_MS_WINRATIO_ACVP_VP_DDRAWJACKSORBETTER;
                           idsBankCash = IDS_MS_BANKCASH_ACVP_VP_DDRAWJACKSORBETTER;
                           break;
    case cvpDDrawJokerPoker://idsSounds = IDS_MS_SOUNDS_ACVP_VP_DDRAWJOKERPOKER;
                           idsVertLite = IDS_MS_VERTLITE_ACVP_VP_DDRAWJOKERPOKER;
                           //idsDrawBack = IDS_MS_DRAWBACK_ACVP_VP_DDRAWJOKERPOKER;
                           idsCoinPay = IDS_MS_COINPAY_ACVP_VP_DDRAWJOKERPOKER;
                           //idsChips = IDS_MS_CHIPS_ACVP_VP_DDRAWJOKERPOKER;
                           idsCard1 = IDS_MS_CARD1_ACVP_VP_DDRAWJOKERPOKER;
                           //idsCard2 = IDS_MS_CARD2_ACVP_VP_DDRAWJOKERPOKER;
                           //idsCard3 = IDS_MS_CARD3_ACVP_VP_DDRAWJOKERPOKER;
                           //idsCard4 = IDS_MS_CARD4_ACVP_VP_DDRAWJOKERPOKER;
                           //idsCard5 = IDS_MS_CARD5_ACVP_VP_DDRAWJOKERPOKER;
                           idsNP1 = IDS_MS_NP1_ACVP_VP_DDRAWJOKERPOKER;
                           //idsNP2 = IDS_MS_NP2_ACVP_VP_DDRAWJOKERPOKER;
                           //idsNP3 = IDS_MS_NP3_ACVP_VP_DDRAWJOKERPOKER;
                           idsCoinsPlayed = IDS_MS_COINSPLAYED_ACVP_VP_DDRAWJOKERPOKER;
                           idsCredits = IDS_MS_CREDITS_ACVP_VP_DDRAWJOKERPOKER;
                           idsWinPaid = IDS_MS_WINPAID_ACVP_VP_DDRAWJOKERPOKER;
                           idsButton0 = IDS_MS_B0_ACVP_VP_DDRAWJOKERPOKER;
                           idsButton1 = IDS_MS_B1_ACVP_VP_DDRAWJOKERPOKER;
                           idsButton2 = IDS_MS_B2_ACVP_VP_DDRAWJOKERPOKER;
                           idsButton3 = IDS_MS_B3_ACVP_VP_DDRAWJOKERPOKER;
                           idsButton4 = IDS_MS_B4_ACVP_VP_DDRAWJOKERPOKER;
                           idsButton5 = IDS_MS_B5_ACVP_VP_DDRAWJOKERPOKER;
                           idsButton6 = IDS_MS_B6_ACVP_VP_DDRAWJOKERPOKER;
                           idsButton7 = IDS_MS_B7_ACVP_VP_DDRAWJOKERPOKER;
                           //idsButton8 = IDS_MS_B8_ACVP_VP_DDRAWJOKERPOKER;
                           idsWinRatio = IDS_MS_WINRATIO_ACVP_VP_DDRAWJOKERPOKER;
                           idsBankCash = IDS_MS_BANKCASH_ACVP_VP_DDRAWJOKERPOKER;
                           break;
    case cvpDDownStud://idsSounds = IDS_MS_SOUNDS_ACVP_VP_DDOWNSTUD;
                           idsVertLite = IDS_MS_VERTLITE_ACVP_VP_DDOWNSTUD;
                           //idsDrawBack = IDS_MS_DRAWBACK_ACVP_VP_DDOWNSTUD;
                           idsCoinPay = IDS_MS_COINPAY_ACVP_VP_DDOWNSTUD;
                           //idsChips = IDS_MS_CHIPS_ACVP_VP_DDOWNSTUD;
                           idsCard1 = IDS_MS_CARD1_ACVP_VP_DDOWNSTUD;
                           //idsCard2 = IDS_MS_CARD2_ACVP_VP_DDOWNSTUD;
                           //idsCard3 = IDS_MS_CARD3_ACVP_VP_DDOWNSTUD;
                           //idsCard4 = IDS_MS_CARD4_ACVP_VP_DDOWNSTUD;
                           //idsCard5 = IDS_MS_CARD5_ACVP_VP_DDOWNSTUD;
                           idsNP1 = IDS_MS_NP1_ACVP_VP_DDOWNSTUD;
                           //idsNP2 = IDS_MS_NP2_ACVP_VP_DDOWNSTUD;
                           //idsNP3 = IDS_MS_NP3_ACVP_VP_DDOWNSTUD;
                           idsCoinsPlayed = IDS_MS_COINSPLAYED_ACVP_VP_DDOWNSTUD;
                           idsCredits = IDS_MS_CREDITS_ACVP_VP_DDOWNSTUD;
                           idsWinPaid = IDS_MS_WINPAID_ACVP_VP_DDOWNSTUD;
                           idsButton0 = IDS_MS_B0_ACVP_VP_DDOWNSTUD;
                           idsButton1 = IDS_MS_B1_ACVP_VP_DDOWNSTUD;
                           idsButton2 = IDS_MS_B2_ACVP_VP_DDOWNSTUD;
                           idsButton3 = IDS_MS_B3_ACVP_VP_DDOWNSTUD;
                           idsButton4 = IDS_MS_B4_ACVP_VP_DDOWNSTUD;
                           idsButton5 = IDS_MS_B5_ACVP_VP_DDOWNSTUD;
                           idsButton6 = IDS_MS_B6_ACVP_VP_DDOWNSTUD;
                           idsButton7 = IDS_MS_B7_ACVP_VP_DDOWNSTUD;
                           //idsButton8 = IDS_MS_B8_ACVP_VP_DDOWNSTUD;
                           idsWinRatio = IDS_MS_WINRATIO_ACVP_VP_DDOWNSTUD;
                           idsBankCash = IDS_MS_BANKCASH_ACVP_VP_DDOWNSTUD;
                           break;
    case cvpDeucesWildBonus: idsVertLite = IDS_MS_VERTLITE_ACVP_VP_DEUCESWILDBONUS;
                           idsCoinPay = IDS_MS_COINPAY_ACVP_VP_DEUCESWILDBONUS;
                           idsCard1 = IDS_MS_CARD1_ACVP_VP_DEUCESWILDBONUS;
                           idsNP1 = IDS_MS_NP1_ACVP_VP_DEUCESWILDBONUS;
                           idsCoinsPlayed = IDS_MS_COINSPLAYED_ACVP_VP_DEUCESWILDBONUS;
                           idsCredits = IDS_MS_CREDITS_ACVP_VP_DEUCESWILDBONUS;
                           idsWinPaid = IDS_MS_WINPAID_ACVP_VP_DEUCESWILDBONUS;
                           idsButton0 = IDS_MS_B0_ACVP_VP_DEUCESWILDBONUS;
                           idsButton1 = IDS_MS_B1_ACVP_VP_DEUCESWILDBONUS;
                           idsButton2 = IDS_MS_B2_ACVP_VP_DEUCESWILDBONUS;
                           idsButton3 = IDS_MS_B3_ACVP_VP_DEUCESWILDBONUS;
                           idsButton4 = IDS_MS_B4_ACVP_VP_DEUCESWILDBONUS;
                           idsButton5 = IDS_MS_B5_ACVP_VP_DEUCESWILDBONUS;
                           idsButton6 = IDS_MS_B6_ACVP_VP_DEUCESWILDBONUS;
                           idsButton7 = IDS_MS_B7_ACVP_VP_DEUCESWILDBONUS;
                           idsButton8 = IDS_MS_B8_ACVP_VP_DEUCESWILDBONUS;
                           idsButton9 = IDS_MS_B9_ACVP_VP_DEUCESWILDBONUS;
                           idsWinRatio = IDS_MS_WINRATIO_ACVP_VP_DEUCESWILDBONUS;
                           idsBankCash = IDS_MS_BANKCASH_ACVP_VP_DEUCESWILDBONUS;
                           idsBackG = IDS_MS_BACKG_ACVP_VP_DEUCESWILDBONUS;
                           break;
    case cvpDeucesWildII://idsSounds = IDS_MS_SOUNDS_ACVP_VP_DEUCESWILD;
                           idsVertLite = IDS_MS_VERTLITE_ACVP_VP_DEUCESWILD;
                           //idsDrawBack = IDS_MS_DRAWBACK_ACVP_VP_DEUCESWILD;
                           idsCoinPay = IDS_MS_COINPAY_ACVP_VP_DEUCESWILD;
                           //idsChips = IDS_MS_CHIPS_ACVP_VP_DEUCESWILD;
                           idsCard1 = IDS_MS_CARD1_ACVP_VP_DEUCESWILD;
                           //idsCard2 = IDS_MS_CARD2_ACVP_VP_DEUCESWILD;
                           //idsCard3 = IDS_MS_CARD3_ACVP_VP_DEUCESWILD;
                           //idsCard4 = IDS_MS_CARD4_ACVP_VP_DEUCESWILD;
                           //idsCard5 = IDS_MS_CARD5_ACVP_VP_DEUCESWILD;
                           idsNP1 = IDS_MS_NP1_ACVP_VP_DEUCESWILD;
                           //idsNP2 = IDS_MS_NP2_ACVP_VP_DEUCESWILD;
                           //idsNP3 = IDS_MS_NP3_ACVP_VP_DEUCESWILD;
                           idsCoinsPlayed = IDS_MS_COINSPLAYED_ACVP_VP_DEUCESWILD;
                           idsCredits = IDS_MS_CREDITS_ACVP_VP_DEUCESWILD;
                           idsWinPaid = IDS_MS_WINPAID_ACVP_VP_DEUCESWILD;
                           idsButton0 = IDS_MS_B0_ACVP_VP_DEUCESWILD;
                           idsButton1 = IDS_MS_B1_ACVP_VP_DEUCESWILD;
                           idsButton2 = IDS_MS_B2_ACVP_VP_DEUCESWILD;
                           idsButton3 = IDS_MS_B3_ACVP_VP_DEUCESWILD;
                           idsButton4 = IDS_MS_B4_ACVP_VP_DEUCESWILD;
                           idsButton5 = IDS_MS_B5_ACVP_VP_DEUCESWILD;
                           idsButton6 = IDS_MS_B6_ACVP_VP_DEUCESWILD;
                           idsButton7 = IDS_MS_B7_ACVP_VP_DEUCESWILD;
                           //idsButton8 = IDS_MS_B8_ACVP_VP_DEUCESWILD;
                           idsWinRatio = IDS_MS_WINRATIO_ACVP_VP_DEUCESWILD;
                           idsBankCash = IDS_MS_BANKCASH_ACVP_VP_DEUCESWILD;
                           break;
    case cvpDeucesWildProg:idsVertLite = IDS_MS_VERTLITE_ACVP_VP_DEUCESWILDPROG;
                           idsCoinPay = IDS_MS_COINPAY_ACVP_VP_DEUCESWILDPROG;
                           idsCard1 = IDS_MS_CARD1_ACVP_VP_DEUCESWILDPROG;
                           idsNP1 = IDS_MS_NP1_ACVP_VP_DEUCESWILDPROG;
                           idsCoinsPlayed = IDS_MS_COINSPLAYED_ACVP_VP_DEUCESWILDPROG;
                           idsCredits = IDS_MS_CREDITS_ACVP_VP_DEUCESWILDPROG;
                           idsWinPaid = IDS_MS_WINPAID_ACVP_VP_DEUCESWILDPROG;
                           idsButton0 = IDS_MS_B0_ACVP_VP_DEUCESWILDPROG;
                           idsButton1 = IDS_MS_B1_ACVP_VP_DEUCESWILDPROG;
                           idsButton2 = IDS_MS_B2_ACVP_VP_DEUCESWILDPROG;
                           idsButton3 = IDS_MS_B3_ACVP_VP_DEUCESWILDPROG;
                           idsButton4 = IDS_MS_B4_ACVP_VP_DEUCESWILDPROG;
                           idsButton6 = IDS_MS_B6_ACVP_VP_DEUCESWILDPROG;
                           idsButton7 = IDS_MS_B7_ACVP_VP_DEUCESWILDPROG;
                           idsProg1   = IDS_MS_PROG1_ACVP_VP_DEUCESWILDPROG;
                           idsWinRatio = IDS_MS_WINRATIO_ACVP_VP_DEUCESWILDPROG;
                           idsBankCash = IDS_MS_BANKCASH_ACVP_VP_DEUCESWILDPROG;
                           break;
    case cvpDiamondBonus://idsSounds = IDS_MS_SOUNDS_ACVP_VP_DIAMONDBONUS;
                           idsVertLite = IDS_MS_VERTLITE_ACVP_VP_DIAMONDBONUS;
                           //idsDrawBack = IDS_MS_DRAWBACK_ACVP_VP_DIAMONDBONUS;
                           idsCoinPay = IDS_MS_COINPAY_ACVP_VP_DIAMONDBONUS;
                           //idsChips = IDS_MS_CHIPS_ACVP_VP_DIAMONDBONUS;
                           idsCard1 = IDS_MS_CARD1_ACVP_VP_DIAMONDBONUS;
                           //idsCard2 = IDS_MS_CARD2_ACVP_VP_DIAMONDBONUS;
                           //idsCard3 = IDS_MS_CARD3_ACVP_VP_DIAMONDBONUS;
                           //idsCard4 = IDS_MS_CARD4_ACVP_VP_DIAMONDBONUS;
                           //idsCard5 = IDS_MS_CARD5_ACVP_VP_DIAMONDBONUS;
                           idsNP1 = IDS_MS_NP1_ACVP_VP_DIAMONDBONUS;
                           //idsNP2 = IDS_MS_NP2_ACVP_VP_DIAMONDBONUS;
                           //idsNP3 = IDS_MS_NP3_ACVP_VP_DIAMONDBONUS;
                           idsCoinsPlayed = IDS_MS_COINSPLAYED_ACVP_VP_DIAMONDBONUS;
                           idsCredits = IDS_MS_CREDITS_ACVP_VP_DIAMONDBONUS;
                           idsWinPaid = IDS_MS_WINPAID_ACVP_VP_DIAMONDBONUS;
                           idsButton0 = IDS_MS_B0_ACVP_VP_DIAMONDBONUS;
                           idsButton1 = IDS_MS_B1_ACVP_VP_DIAMONDBONUS;
                           idsButton2 = IDS_MS_B2_ACVP_VP_DIAMONDBONUS;
                           idsButton3 = IDS_MS_B3_ACVP_VP_DIAMONDBONUS;
                           idsButton4 = IDS_MS_B4_ACVP_VP_DIAMONDBONUS;
                           idsButton5 = IDS_MS_B5_ACVP_VP_DIAMONDBONUS;
                           idsButton6 = IDS_MS_B6_ACVP_VP_DIAMONDBONUS;
                           idsButton7 = IDS_MS_B7_ACVP_VP_DIAMONDBONUS;
                           //idsButton8 = IDS_MS_B8_ACVP_VP_DIAMONDBONUS;
                           idsWinRatio = IDS_MS_WINRATIO_ACVP_VP_DIAMONDBONUS;
                           idsBankCash = IDS_MS_BANKCASH_ACVP_VP_DIAMONDBONUS;
                           break;
    case cvpDBonusPoker:   idsVertLite = IDS_MS_VERTLITE_ACVP_VP_DBONUSPOKER;
                           idsCoinPay = IDS_MS_COINPAY_ACVP_VP_DBONUSPOKER;
                           idsCard1 = IDS_MS_CARD1_ACVP_VP_DBONUSPOKER;
                           idsNP1 = IDS_MS_NP1_ACVP_VP_DBONUSPOKER;
                           idsCoinsPlayed = IDS_MS_COINSPLAYED_ACVP_VP_DBONUSPOKER;
                           idsCredits = IDS_MS_CREDITS_ACVP_VP_DBONUSPOKER;
                           idsWinPaid = IDS_MS_WINPAID_ACVP_VP_DBONUSPOKER;
                           idsButton0 = IDS_MS_B0_ACVP_VP_DBONUSPOKER;
                           idsButton1 = IDS_MS_B1_ACVP_VP_DBONUSPOKER;
                           idsButton2 = IDS_MS_B2_ACVP_VP_DBONUSPOKER;
                           idsButton3 = IDS_MS_B3_ACVP_VP_DBONUSPOKER;
                           idsButton4 = IDS_MS_B4_ACVP_VP_DBONUSPOKER;
                           idsButton5 = IDS_MS_B5_ACVP_VP_DBONUSPOKER;
                           idsButton6 = IDS_MS_B6_ACVP_VP_DBONUSPOKER;
                           idsButton7 = IDS_MS_B7_ACVP_VP_DBONUSPOKER;
                           idsButton8 = IDS_MS_B8_ACVP_VP_DBONUSPOKER;
                           idsButton9 = IDS_MS_B9_ACVP_VP_DBONUSPOKER;
                           idsWinRatio = IDS_MS_WINRATIO_ACVP_VP_DBONUSPOKER;
                           idsBankCash = IDS_MS_BANKCASH_ACVP_VP_DBONUSPOKER;
                           idsBackG = IDS_MS_BACKG_ACVP_VP_DBONUSPOKER;
                           break;
    case cvpFlushAssault:  idsVertLite = IDS_MS_VERTLITE_ACVP_VP_FLUSHASSAULT;
                           idsCoinPay = IDS_MS_COINPAY_ACVP_VP_FLUSHASSAULT;
                           idsCard1 = IDS_MS_CARD1_ACVP_VP_FLUSHASSAULT;
                           idsNP1 = IDS_MS_NP1_ACVP_VP_FLUSHASSAULT;
                           idsCoinsPlayed = IDS_MS_COINSPLAYED_ACVP_VP_FLUSHASSAULT;
                           idsCredits = IDS_MS_CREDITS_ACVP_VP_FLUSHASSAULT;
                           idsWinPaid = IDS_MS_WINPAID_ACVP_VP_FLUSHASSAULT;
                           idsButton0 = IDS_MS_B0_ACVP_VP_FLUSHASSAULT;
                           idsButton1 = IDS_MS_B1_ACVP_VP_FLUSHASSAULT;
                           idsButton2 = IDS_MS_B2_ACVP_VP_FLUSHASSAULT;
                           idsButton3 = IDS_MS_B3_ACVP_VP_FLUSHASSAULT;
                           idsButton4 = IDS_MS_B4_ACVP_VP_FLUSHASSAULT;
                           idsButton5 = IDS_MS_B5_ACVP_VP_FLUSHASSAULT;
                           idsButton6 = IDS_MS_B6_ACVP_VP_FLUSHASSAULT;
                           idsButton7 = IDS_MS_B7_ACVP_VP_FLUSHASSAULT;
                           idsFAss    = IDS_MS_FASS_ACVP_VP_FLUSHASSAULT;
                           idsWinRatio = IDS_MS_WINRATIO_ACVP_VP_FLUSHASSAULT;
                           idsBankCash = IDS_MS_BANKCASH_ACVP_VP_FLUSHASSAULT;
                           idsBackG    = IDS_MS_BACKG_ACVP_VP_FLUSHASSAULT;
                           break;
    case cvpFreeLook:      idsVertLite = IDS_MS_VERTLITE_ACVP_VP_FREELOOK;
                           idsCoinPay = IDS_MS_COINPAY_ACVP_VP_FREELOOK;
                           idsCard1 = IDS_MS_CARD1_ACVP_VP_FREELOOK;
                           idsNP1 = IDS_MS_NP1_ACVP_VP_FREELOOK;
                           idsCoinsPlayed = IDS_MS_COINSPLAYED_ACVP_VP_FREELOOK;
                           idsCredits = IDS_MS_CREDITS_ACVP_VP_FREELOOK;
                           idsWinPaid = IDS_MS_WINPAID_ACVP_VP_FREELOOK;
                           idsButton0 = IDS_MS_B0_ACVP_VP_FREELOOK;
                           idsButton1 = IDS_MS_B1_ACVP_VP_FREELOOK;
                           idsButton2 = IDS_MS_B2_ACVP_VP_FREELOOK;
                           idsButton3 = IDS_MS_B3_ACVP_VP_FREELOOK;
                           idsButton4 = IDS_MS_B4_ACVP_VP_FREELOOK;
                           idsButton5 = IDS_MS_B5_ACVP_VP_FREELOOK;
                           idsButton6 = IDS_MS_B6_ACVP_VP_FREELOOK;
                           idsButton7 = IDS_MS_B7_ACVP_VP_FREELOOK;
                           idsLook    = IDS_MS_LOOK_ACVP_VP_FREELOOK;
                           idsWinRatio = IDS_MS_WINRATIO_ACVP_VP_FREELOOK;
                           idsBankCash = IDS_MS_BANKCASH_ACVP_VP_FREELOOK;
                           break;
    case cvpGamblersEdge:  idsVertLite = IDS_MS_VERTLITE_ACVP_VP_GAMBLERSEDGE;
                           idsCoinPay = IDS_MS_COINPAY_ACVP_VP_GAMBLERSEDGE;
                           idsCard1 = IDS_MS_CARD1_ACVP_VP_GAMBLERSEDGE;
                           idsNP1 = IDS_MS_NP1_ACVP_VP_GAMBLERSEDGE;
                           idsCoinsPlayed = IDS_MS_COINSPLAYED_ACVP_VP_GAMBLERSEDGE;
                           idsCredits = IDS_MS_CREDITS_ACVP_VP_GAMBLERSEDGE;
                           idsWinPaid = IDS_MS_WINPAID_ACVP_VP_GAMBLERSEDGE;
                           idsButton0 = IDS_MS_B0_ACVP_VP_GAMBLERSEDGE;
                           idsButton1 = IDS_MS_B1_ACVP_VP_GAMBLERSEDGE;
                           idsButton2 = IDS_MS_B2_ACVP_VP_GAMBLERSEDGE;
                           idsButton3 = IDS_MS_B3_ACVP_VP_GAMBLERSEDGE;
                           idsButton4 = IDS_MS_B4_ACVP_VP_GAMBLERSEDGE;
                           idsButton5 = IDS_MS_B5_ACVP_VP_GAMBLERSEDGE;
                           idsButton6 = IDS_MS_B6_ACVP_VP_GAMBLERSEDGE;
                           idsButton7 = IDS_MS_B7_ACVP_VP_GAMBLERSEDGE;
                           idsButton8 = IDS_MS_B8_ACVP_VP_GAMBLERSEDGE;
                           idsButton9 = IDS_MS_B9_ACVP_VP_GAMBLERSEDGE;
                           idsWinRatio = IDS_MS_WINRATIO_ACVP_VP_GAMBLERSEDGE;
                           idsBankCash = IDS_MS_BANKCASH_ACVP_VP_GAMBLERSEDGE;
                           idsBackG = IDS_MS_BACKG_ACVP_VP_GAMBLERSEDGE;
                           break;
    case cvpHeartBonus://idsSounds = IDS_MS_SOUNDS_ACVP_VP_HEARTBONUS;
                           idsVertLite = IDS_MS_VERTLITE_ACVP_VP_HEARTBONUS;
                           //idsDrawBack = IDS_MS_DRAWBACK_ACVP_VP_HEARTBONUS;
                           idsCoinPay = IDS_MS_COINPAY_ACVP_VP_HEARTBONUS;
                           //idsChips = IDS_MS_CHIPS_ACVP_VP_HEARTBONUS;
                           idsCard1 = IDS_MS_CARD1_ACVP_VP_HEARTBONUS;
                           //idsCard2 = IDS_MS_CARD2_ACVP_VP_HEARTBONUS;
                           //idsCard3 = IDS_MS_CARD3_ACVP_VP_HEARTBONUS;
                           //idsCard4 = IDS_MS_CARD4_ACVP_VP_HEARTBONUS;
                           //idsCard5 = IDS_MS_CARD5_ACVP_VP_HEARTBONUS;
                           idsNP1 = IDS_MS_NP1_ACVP_VP_HEARTBONUS;
                           //idsNP2 = IDS_MS_NP2_ACVP_VP_HEARTBONUS;
                           //idsNP3 = IDS_MS_NP3_ACVP_VP_HEARTBONUS;
                           idsCoinsPlayed = IDS_MS_COINSPLAYED_ACVP_VP_HEARTBONUS;
                           idsCredits = IDS_MS_CREDITS_ACVP_VP_HEARTBONUS;
                           idsWinPaid = IDS_MS_WINPAID_ACVP_VP_HEARTBONUS;
                           idsButton0 = IDS_MS_B0_ACVP_VP_HEARTBONUS;
                           idsButton1 = IDS_MS_B1_ACVP_VP_HEARTBONUS;
                           idsButton2 = IDS_MS_B2_ACVP_VP_HEARTBONUS;
                           idsButton3 = IDS_MS_B3_ACVP_VP_HEARTBONUS;
                           idsButton4 = IDS_MS_B4_ACVP_VP_HEARTBONUS;
                           idsButton5 = IDS_MS_B5_ACVP_VP_HEARTBONUS;
                           idsButton6 = IDS_MS_B6_ACVP_VP_HEARTBONUS;
                           idsButton7 = IDS_MS_B7_ACVP_VP_HEARTBONUS;
                           //idsButton8 = IDS_MS_B8_ACVP_VP_HEARTBONUS;
                           idsWinRatio = IDS_MS_WINRATIO_ACVP_VP_HEARTBONUS;
                           idsBankCash = IDS_MS_BANKCASH_ACVP_VP_HEARTBONUS;
                           break;
    case cvpJacksProgII:   idsVertLite = IDS_MS_VERTLITE_ACVP_VP_JACKSORBETTERPROG;
                           idsCoinPay = IDS_MS_COINPAY_ACVP_VP_JACKSORBETTERPROG;
                           idsCard1 = IDS_MS_CARD1_ACVP_VP_JACKSORBETTERPROG;
                           idsNP1 = IDS_MS_NP1_ACVP_VP_JACKSORBETTERPROG;
                           idsCoinsPlayed = IDS_MS_COINSPLAYED_ACVP_VP_JACKSORBETTERPROG;
                           idsCredits = IDS_MS_CREDITS_ACVP_VP_JACKSORBETTERPROG;
                           idsWinPaid = IDS_MS_WINPAID_ACVP_VP_JACKSORBETTERPROG;
                           idsButton0 = IDS_MS_B0_ACVP_VP_JACKSORBETTERPROG;
                           idsButton1 = IDS_MS_B1_ACVP_VP_JACKSORBETTERPROG;
                           idsButton2 = IDS_MS_B2_ACVP_VP_JACKSORBETTERPROG;
                           idsButton3 = IDS_MS_B3_ACVP_VP_JACKSORBETTERPROG;
                           idsButton4 = IDS_MS_B4_ACVP_VP_JACKSORBETTERPROG;
                           idsButton6 = IDS_MS_B6_ACVP_VP_JACKSORBETTERPROG;
                           idsButton7 = IDS_MS_B7_ACVP_VP_JACKSORBETTERPROG;
                           idsProg1   = IDS_MS_PROG1_ACVP_VP_JACKSORBETTERPROG;
                           idsWinRatio = IDS_MS_WINRATIO_ACVP_VP_JACKSORBETTERPROG;
                           idsBankCash = IDS_MS_BANKCASH_ACVP_VP_JACKSORBETTERPROG;
                           break;
    case cvpJackpotBonus:  idsVertLite = IDS_MS_VERTLITE_ACVP_VP_JACKPOTBONUS;
                           idsCoinPay = IDS_MS_COINPAY_ACVP_VP_JACKPOTBONUS;
                           idsCard1 = IDS_MS_CARD1_ACVP_VP_JACKPOTBONUS;
                           idsNP1 = IDS_MS_NP1_ACVP_VP_JACKPOTBONUS;
                           idsCoinsPlayed = IDS_MS_COINSPLAYED_ACVP_VP_JACKPOTBONUS;
                           idsCredits = IDS_MS_CREDITS_ACVP_VP_JACKPOTBONUS;
                           idsWinPaid = IDS_MS_WINPAID_ACVP_VP_JACKPOTBONUS;
                           idsButton0 = IDS_MS_B0_ACVP_VP_JACKPOTBONUS;
                           idsButton1 = IDS_MS_B1_ACVP_VP_JACKPOTBONUS;
                           idsButton2 = IDS_MS_B2_ACVP_VP_JACKPOTBONUS;
                           idsButton3 = IDS_MS_B3_ACVP_VP_JACKPOTBONUS;
                           idsButton4 = IDS_MS_B4_ACVP_VP_JACKPOTBONUS;
                           idsButton6 = IDS_MS_B6_ACVP_VP_JACKPOTBONUS;
                           idsButton7 = IDS_MS_B7_ACVP_VP_JACKPOTBONUS;
                           idsJackpotBonus = IDS_MS_JACKPOTBONUS_ACVP_VP_JACKPOTBONUS;
                           idsWinRatio = IDS_MS_WINRATIO_ACVP_VP_JACKPOTBONUS;
                           idsBankCash = IDS_MS_BANKCASH_ACVP_VP_JACKPOTBONUS;
                           break;
    case cvp96JacksOrBetterII://idsSounds = IDS_MS_SOUNDS_ACVP_VP_JACKSORBETTER96;
                           idsVertLite = IDS_MS_VERTLITE_ACVP_VP_JACKSORBETTER96;
                           //idsDrawBack = IDS_MS_DRAWBACK_ACVP_VP_JACKSORBETTER96;
                           idsCoinPay = IDS_MS_COINPAY_ACVP_VP_JACKSORBETTER96;
                           //idsChips = IDS_MS_CHIPS_ACVP_VP_JACKSORBETTER96;
                           idsCard1 = IDS_MS_CARD1_ACVP_VP_JACKSORBETTER96;
                           //idsCard2 = IDS_MS_CARD2_ACVP_VP_JACKSORBETTER96;
                           //idsCard3 = IDS_MS_CARD3_ACVP_VP_JACKSORBETTER96;
                           //idsCard4 = IDS_MS_CARD4_ACVP_VP_JACKSORBETTER96;
                           //idsCard5 = IDS_MS_CARD5_ACVP_VP_JACKSORBETTER96;
                           idsNP1 = IDS_MS_NP1_ACVP_VP_JACKSORBETTER96;
                           //idsNP2 = IDS_MS_NP2_ACVP_VP_JACKSORBETTER96;
                           //idsNP3 = IDS_MS_NP3_ACVP_VP_JACKSORBETTER96;
                           idsCoinsPlayed = IDS_MS_COINSPLAYED_ACVP_VP_JACKSORBETTER96;
                           idsCredits = IDS_MS_CREDITS_ACVP_VP_JACKSORBETTER96;
                           idsWinPaid = IDS_MS_WINPAID_ACVP_VP_JACKSORBETTER96;
                           idsButton0 = IDS_MS_B0_ACVP_VP_JACKSORBETTER96;
                           idsButton1 = IDS_MS_B1_ACVP_VP_JACKSORBETTER96;
                           idsButton2 = IDS_MS_B2_ACVP_VP_JACKSORBETTER96;
                           idsButton3 = IDS_MS_B3_ACVP_VP_JACKSORBETTER96;
                           idsButton4 = IDS_MS_B4_ACVP_VP_JACKSORBETTER96;
                           idsButton5 = IDS_MS_B5_ACVP_VP_JACKSORBETTER96;
                           idsButton6 = IDS_MS_B6_ACVP_VP_JACKSORBETTER96;
                           idsButton7 = IDS_MS_B7_ACVP_VP_JACKSORBETTER96;
                           //idsButton8 = IDS_MS_B8_ACVP_VP_JACKSORBETTER96;
                           idsWinRatio = IDS_MS_WINRATIO_ACVP_VP_JACKSORBETTER96;
                           idsBankCash = IDS_MS_BANKCASH_ACVP_VP_JACKSORBETTER96;
                           break;
    case cvp85JacksOrBetter://idsSounds = IDS_MS_SOUNDS_ACVP_VP_JACKSORBETTER85;
                           idsVertLite = IDS_MS_VERTLITE_ACVP_VP_JACKSORBETTER85;
                           //idsDrawBack = IDS_MS_DRAWBACK_ACVP_VP_JACKSORBETTER85;
                           idsCoinPay = IDS_MS_COINPAY_ACVP_VP_JACKSORBETTER85;
                           //idsChips = IDS_MS_CHIPS_ACVP_VP_JACKSORBETTER85;
                           idsCard1 = IDS_MS_CARD1_ACVP_VP_JACKSORBETTER85;
                           //idsCard2 = IDS_MS_CARD2_ACVP_VP_JACKSORBETTER85;
                           //idsCard3 = IDS_MS_CARD3_ACVP_VP_JACKSORBETTER85;
                           //idsCard4 = IDS_MS_CARD4_ACVP_VP_JACKSORBETTER85;
                           //idsCard5 = IDS_MS_CARD5_ACVP_VP_JACKSORBETTER85;
                           idsNP1 = IDS_MS_NP1_ACVP_VP_JACKSORBETTER85;
                           //idsNP2 = IDS_MS_NP2_ACVP_VP_JACKSORBETTER85;
                           //idsNP3 = IDS_MS_NP3_ACVP_VP_JACKSORBETTER85;
                           idsCoinsPlayed = IDS_MS_COINSPLAYED_ACVP_VP_JACKSORBETTER85;
                           idsCredits = IDS_MS_CREDITS_ACVP_VP_JACKSORBETTER85;
                           idsWinPaid = IDS_MS_WINPAID_ACVP_VP_JACKSORBETTER85;
                           idsButton0 = IDS_MS_B0_ACVP_VP_JACKSORBETTER85;
                           idsButton1 = IDS_MS_B1_ACVP_VP_JACKSORBETTER85;
                           idsButton2 = IDS_MS_B2_ACVP_VP_JACKSORBETTER85;
                           idsButton3 = IDS_MS_B3_ACVP_VP_JACKSORBETTER85;
                           idsButton4 = IDS_MS_B4_ACVP_VP_JACKSORBETTER85;
                           idsButton5 = IDS_MS_B5_ACVP_VP_JACKSORBETTER85;
                           idsButton6 = IDS_MS_B6_ACVP_VP_JACKSORBETTER85;
                           idsButton7 = IDS_MS_B7_ACVP_VP_JACKSORBETTER85;
                           //idsButton8 = IDS_MS_B8_ACVP_VP_JACKSORBETTER85;
                           idsWinRatio = IDS_MS_WINRATIO_ACVP_VP_JACKSORBETTER85;
                           idsBankCash = IDS_MS_BANKCASH_ACVP_VP_JACKSORBETTER85;
                           break;
    case cvpDJacksOrBetter:idsVertLite = IDS_MS_VERTLITE_ACVP_VP_JACKSORBETTERDNOTHING;
                           idsCoinPay = IDS_MS_COINPAY_ACVP_VP_JACKSORBETTERDNOTHING;
                           idsCard1 = IDS_MS_CARD1_ACVP_VP_JACKSORBETTERDNOTHING;
                           idsNP1 = IDS_MS_NP1_ACVP_VP_JACKSORBETTERDNOTHING;
                           idsCoinsPlayed = IDS_MS_COINSPLAYED_ACVP_VP_JACKSORBETTERDNOTHING;
                           idsCredits = IDS_MS_CREDITS_ACVP_VP_JACKSORBETTERDNOTHING;
                           idsWinPaid = IDS_MS_WINPAID_ACVP_VP_JACKSORBETTERDNOTHING;
                           idsButton0 = IDS_MS_B0_ACVP_VP_JACKSORBETTERDNOTHING;
                           idsButton1 = IDS_MS_B1_ACVP_VP_JACKSORBETTERDNOTHING;
                           idsButton2 = IDS_MS_B2_ACVP_VP_JACKSORBETTERDNOTHING;
                           idsButton3 = IDS_MS_B3_ACVP_VP_JACKSORBETTERDNOTHING;
                           idsButton4 = IDS_MS_B4_ACVP_VP_JACKSORBETTERDNOTHING;
                           idsButton5 = IDS_MS_B5_ACVP_VP_JACKSORBETTERDNOTHING;
                           idsButton6 = IDS_MS_B6_ACVP_VP_JACKSORBETTERDNOTHING;
                           idsButton7 = IDS_MS_B7_ACVP_VP_JACKSORBETTERDNOTHING;
                           idsButton8 = IDS_MS_B8_ACVP_VP_JACKSORBETTERDNOTHING;
                           idsButton9 = IDS_MS_B9_ACVP_VP_JACKSORBETTERDNOTHING;
                           idsWinRatio = IDS_MS_WINRATIO_ACVP_VP_JACKSORBETTERDNOTHING;
                           idsBankCash = IDS_MS_BANKCASH_ACVP_VP_JACKSORBETTERDNOTHING;
                           idsBackG = IDS_MS_BACKG_ACVP_VP_JACKSORBETTERDNOTHING;
                           break;
    case cvpJokersWildProg:idsVertLite = IDS_MS_VERTLITE_ACVP_VP_JOKERSWILDPROG;
                           idsCoinPay = IDS_MS_COINPAY_ACVP_VP_JOKERSWILDPROG;
                           idsCard1 = IDS_MS_CARD1_ACVP_VP_JOKERSWILDPROG;
                           idsNP1 = IDS_MS_NP1_ACVP_VP_JOKERSWILDPROG;
                           idsCoinsPlayed = IDS_MS_COINSPLAYED_ACVP_VP_JOKERSWILDPROG;
                           idsCredits = IDS_MS_CREDITS_ACVP_VP_JOKERSWILDPROG;
                           idsWinPaid = IDS_MS_WINPAID_ACVP_VP_JOKERSWILDPROG;
                           idsButton0 = IDS_MS_B0_ACVP_VP_JOKERSWILDPROG;
                           idsButton1 = IDS_MS_B1_ACVP_VP_JOKERSWILDPROG;
                           idsButton2 = IDS_MS_B2_ACVP_VP_JOKERSWILDPROG;
                           idsButton3 = IDS_MS_B3_ACVP_VP_JOKERSWILDPROG;
                           idsButton4 = IDS_MS_B4_ACVP_VP_JOKERSWILDPROG;
                           idsButton6 = IDS_MS_B6_ACVP_VP_JOKERSWILDPROG;
                           idsButton7 = IDS_MS_B7_ACVP_VP_JOKERSWILDPROG;
                           idsProg1   = IDS_MS_PROG1_ACVP_VP_JOKERSWILDPROG;
                           idsWinRatio = IDS_MS_WINRATIO_ACVP_VP_JOKERSWILDPROG;
                           idsBankCash = IDS_MS_BANKCASH_ACVP_VP_JOKERSWILDPROG;
                           break;
    case cvpJumpinJokers://idsSounds = IDS_MS_SOUNDS_ACVP_VP_JUMPINJOKERS;
                           idsVertLite = IDS_MS_VERTLITE_ACVP_VP_JUMPINJOKERS;
                           //idsDrawBack = IDS_MS_DRAWBACK_ACVP_VP_JUMPINJOKERS;
                           idsCoinPay = IDS_MS_COINPAY_ACVP_VP_JUMPINJOKERS;
                           //idsChips = IDS_MS_CHIPS_ACVP_VP_JUMPINJOKERS;
                           idsCard1 = IDS_MS_CARD1_ACVP_VP_JUMPINJOKERS;
                           //idsCard2 = IDS_MS_CARD2_ACVP_VP_JUMPINJOKERS;
                           //idsCard3 = IDS_MS_CARD3_ACVP_VP_JUMPINJOKERS;
                           //idsCard4 = IDS_MS_CARD4_ACVP_VP_JUMPINJOKERS;
                           //idsCard5 = IDS_MS_CARD5_ACVP_VP_JUMPINJOKERS;
                           idsNP1 = IDS_MS_NP1_ACVP_VP_JUMPINJOKERS;
                           //idsNP2 = IDS_MS_NP2_ACVP_VP_JUMPINJOKERS;
                           //idsNP3 = IDS_MS_NP3_ACVP_VP_JUMPINJOKERS;
                           idsCoinsPlayed = IDS_MS_COINSPLAYED_ACVP_VP_JUMPINJOKERS;
                           idsCredits = IDS_MS_CREDITS_ACVP_VP_JUMPINJOKERS;
                           idsWinPaid = IDS_MS_WINPAID_ACVP_VP_JUMPINJOKERS;
                           idsButton0 = IDS_MS_B0_ACVP_VP_JUMPINJOKERS;
                           idsButton1 = IDS_MS_B1_ACVP_VP_JUMPINJOKERS;
                           idsButton2 = IDS_MS_B2_ACVP_VP_JUMPINJOKERS;
                           idsButton3 = IDS_MS_B3_ACVP_VP_JUMPINJOKERS;
                           idsButton4 = IDS_MS_B4_ACVP_VP_JUMPINJOKERS;
                           idsButton5 = IDS_MS_B5_ACVP_VP_JUMPINJOKERS;
                           idsButton6 = IDS_MS_B6_ACVP_VP_JUMPINJOKERS;
                           idsButton7 = IDS_MS_B7_ACVP_VP_JUMPINJOKERS;
                           //idsButton8 = IDS_MS_B8_ACVP_VP_JUMPINJOKERS;
                           idsWinRatio = IDS_MS_WINRATIO_ACVP_VP_JUMPINJOKERS;
                           idsBankCash = IDS_MS_BANKCASH_ACVP_VP_JUMPINJOKERS;
                           break;
    case cvpTripleProg:    idsVertLite = IDS_MS_VERTLITE_ACVP_VP_TRIPLEPROG;
                           idsCoinPay = IDS_MS_COINPAY_ACVP_VP_TRIPLEPROG;
                           idsCard1 = IDS_MS_CARD1_ACVP_VP_TRIPLEPROG;
                           idsNP1 = IDS_MS_NP1_ACVP_VP_TRIPLEPROG;
                           idsCoinsPlayed = IDS_MS_COINSPLAYED_ACVP_VP_TRIPLEPROG;
                           idsCredits = IDS_MS_CREDITS_ACVP_VP_TRIPLEPROG;
                           idsWinPaid = IDS_MS_WINPAID_ACVP_VP_TRIPLEPROG;
                           idsButton0 = IDS_MS_B0_ACVP_VP_TRIPLEPROG;
                           idsButton1 = IDS_MS_B1_ACVP_VP_TRIPLEPROG;
                           idsButton2 = IDS_MS_B2_ACVP_VP_TRIPLEPROG;
                           idsButton3 = IDS_MS_B3_ACVP_VP_TRIPLEPROG;
                           idsButton4 = IDS_MS_B4_ACVP_VP_TRIPLEPROG;
                           idsButton6 = IDS_MS_B6_ACVP_VP_TRIPLEPROG;
                           idsButton7 = IDS_MS_B7_ACVP_VP_TRIPLEPROG;
                           idsProg1   = IDS_MS_PROG1_ACVP_VP_TRIPLEPROG;
                           idsProg2   = IDS_MS_PROG2_ACVP_VP_TRIPLEPROG;
                           idsProg3   = IDS_MS_PROG3_ACVP_VP_TRIPLEPROG;
                           idsWinRatio = IDS_MS_WINRATIO_ACVP_VP_TRIPLEPROG;
                           idsBankCash = IDS_MS_BANKCASH_ACVP_VP_TRIPLEPROG;
                           break;
    case cvpRoyalProg:     idsVertLite = IDS_MS_VERTLITE_ACVP_VP_ROYALSPROG;
                           idsCoinPay = IDS_MS_COINPAY_ACVP_VP_ROYALSPROG;
                           idsCard1 = IDS_MS_CARD1_ACVP_VP_ROYALSPROG;
                           idsNP1 = IDS_MS_NP1_ACVP_VP_ROYALSPROG;
                           idsCoinsPlayed = IDS_MS_COINSPLAYED_ACVP_VP_ROYALSPROG;
                           idsCredits = IDS_MS_CREDITS_ACVP_VP_ROYALSPROG;
                           idsWinPaid = IDS_MS_WINPAID_ACVP_VP_ROYALSPROG;
                           idsButton0 = IDS_MS_B0_ACVP_VP_ROYALSPROG;
                           idsButton1 = IDS_MS_B1_ACVP_VP_ROYALSPROG;
                           idsButton2 = IDS_MS_B2_ACVP_VP_ROYALSPROG;
                           idsButton3 = IDS_MS_B3_ACVP_VP_ROYALSPROG;
                           idsButton4 = IDS_MS_B4_ACVP_VP_ROYALSPROG;
                           idsButton6 = IDS_MS_B6_ACVP_VP_ROYALSPROG;
                           idsButton7 = IDS_MS_B7_ACVP_VP_ROYALSPROG;
                           idsProg1   = IDS_MS_PROG1_ACVP_VP_ROYALSPROG;
                           idsProg2   = IDS_MS_PROG2_ACVP_VP_ROYALSPROG;
                           idsProg3   = IDS_MS_PROG3_ACVP_VP_ROYALSPROG;
                           idsProg4   = IDS_MS_PROG4_ACVP_VP_ROYALSPROG;
                           idsWinRatio = IDS_MS_WINRATIO_ACVP_VP_ROYALSPROG;
                           idsBankCash = IDS_MS_BANKCASH_ACVP_VP_ROYALSPROG;
                           break;
    case cvpPowerProg:     idsVertLite = IDS_MS_VERTLITE_ACVP_VP_POWERHOUSEPROG;
                           idsCoinPay = IDS_MS_COINPAY_ACVP_VP_POWERHOUSEPROG;
                           idsCard1 = IDS_MS_CARD1_ACVP_VP_POWERHOUSEPROG;
                           idsNP1 = IDS_MS_NP1_ACVP_VP_POWERHOUSEPROG;
                           idsCoinsPlayed = IDS_MS_COINSPLAYED_ACVP_VP_POWERHOUSEPROG;
                           idsCredits = IDS_MS_CREDITS_ACVP_VP_POWERHOUSEPROG;
                           idsWinPaid = IDS_MS_WINPAID_ACVP_VP_POWERHOUSEPROG;
                           idsButton0 = IDS_MS_B0_ACVP_VP_POWERHOUSEPROG;
                           idsButton1 = IDS_MS_B1_ACVP_VP_POWERHOUSEPROG;
                           idsButton2 = IDS_MS_B2_ACVP_VP_POWERHOUSEPROG;
                           idsButton3 = IDS_MS_B3_ACVP_VP_POWERHOUSEPROG;
                           idsButton4 = IDS_MS_B4_ACVP_VP_POWERHOUSEPROG;
                           idsButton6 = IDS_MS_B6_ACVP_VP_POWERHOUSEPROG;
                           idsButton7 = IDS_MS_B7_ACVP_VP_POWERHOUSEPROG;
                           idsProg1 = IDS_MS_PROG1_ACVP_VP_POWERHOUSEPROG;
                           idsWinRatio = IDS_MS_WINRATIO_ACVP_VP_POWERHOUSEPROG;
                           idsBankCash = IDS_MS_BANKCASH_ACVP_VP_POWERHOUSEPROG;
                           break;
    case cvpRaiseJokersWild: idsVertLite = IDS_MS_VERTLITE_ACVP_VP_RAISEDRAWJOKERPOKER;
                           idsVertLite2 = IDS_MS_VERTLITE2_ACVP_VP_RAISEDRAWJOKERPOKER;
                           idsCoinPay = IDS_MS_COINPAY_ACVP_VP_RAISEDRAWJOKERPOKER;
                           idsCard1 = IDS_MS_CARD1_ACVP_VP_RAISEDRAWJOKERPOKER;
                           idsNP1 = IDS_MS_NP1_ACVP_VP_RAISEDRAWJOKERPOKER;
                           idsCoinsPlayed = IDS_MS_COINSPLAYED_ACVP_VP_RAISEDRAWJOKERPOKER;
                           idsCredits = IDS_MS_CREDITS_ACVP_VP_RAISEDRAWJOKERPOKER;
                           idsWinPaid = IDS_MS_WINPAID_ACVP_VP_RAISEDRAWJOKERPOKER;
                           idsButton0 = IDS_MS_B0_ACVP_VP_RAISEDRAWJOKERPOKER;
                           idsButton1 = IDS_MS_B1_ACVP_VP_RAISEDRAWJOKERPOKER;
                           idsButton2 = IDS_MS_B2_ACVP_VP_RAISEDRAWJOKERPOKER;
                           idsButton3 = IDS_MS_B3_ACVP_VP_RAISEDRAWJOKERPOKER;
                           idsButton4 = IDS_MS_B4_ACVP_VP_RAISEDRAWJOKERPOKER;
                           idsButton5 = IDS_MS_B5_ACVP_VP_RAISEDRAWJOKERPOKER;
                           idsButton6 = IDS_MS_B6_ACVP_VP_RAISEDRAWJOKERPOKER;
                           idsButton7 = IDS_MS_B7_ACVP_VP_RAISEDRAWJOKERPOKER;
                           idsWinRatio = IDS_MS_WINRATIO_ACVP_VP_RAISEDRAWJOKERPOKER;
                           idsBankCash = IDS_MS_BANKCASH_ACVP_VP_RAISEDRAWJOKERPOKER;
                           idsVertLite2 = IDS_MS_VERTLITE2_ACVP_VP_RAISEDRAWJOKERPOKER;
                           idsBackG     = IDS_MS_BACKG_ACVP_VP_RAISEDRAWJOKERPOKER;
                           break;
    case cvpSpadeBonus://idsSounds = IDS_MS_SOUNDS_ACVP_VP_SPADEBONUS;
                           idsVertLite = IDS_MS_VERTLITE_ACVP_VP_SPADEBONUS;
                           //idsDrawBack = IDS_MS_DRAWBACK_ACVP_VP_SPADEBONUS;
                           idsCoinPay = IDS_MS_COINPAY_ACVP_VP_SPADEBONUS;
                           //idsChips = IDS_MS_CHIPS_ACVP_VP_SPADEBONUS;
                           idsCard1 = IDS_MS_CARD1_ACVP_VP_SPADEBONUS;
                           //idsCard2 = IDS_MS_CARD2_ACVP_VP_SPADEBONUS;
                           //idsCard3 = IDS_MS_CARD3_ACVP_VP_SPADEBONUS;
                           //idsCard4 = IDS_MS_CARD4_ACVP_VP_SPADEBONUS;
                           //idsCard5 = IDS_MS_CARD5_ACVP_VP_SPADEBONUS;
                           idsNP1 = IDS_MS_NP1_ACVP_VP_SPADEBONUS;
                           //idsNP2 = IDS_MS_NP2_ACVP_VP_SPADEBONUS;
                           //idsNP3 = IDS_MS_NP3_ACVP_VP_SPADEBONUS;
                           idsCoinsPlayed = IDS_MS_COINSPLAYED_ACVP_VP_SPADEBONUS;
                           idsCredits = IDS_MS_CREDITS_ACVP_VP_SPADEBONUS;
                           idsWinPaid = IDS_MS_WINPAID_ACVP_VP_SPADEBONUS;
                           idsButton0 = IDS_MS_B0_ACVP_VP_SPADEBONUS;
                           idsButton1 = IDS_MS_B1_ACVP_VP_SPADEBONUS;
                           idsButton2 = IDS_MS_B2_ACVP_VP_SPADEBONUS;
                           idsButton3 = IDS_MS_B3_ACVP_VP_SPADEBONUS;
                           idsButton4 = IDS_MS_B4_ACVP_VP_SPADEBONUS;
                           idsButton5 = IDS_MS_B5_ACVP_VP_SPADEBONUS;
                           idsButton6 = IDS_MS_B6_ACVP_VP_SPADEBONUS;
                           idsButton7 = IDS_MS_B7_ACVP_VP_SPADEBONUS;
                           //idsButton8 = IDS_MS_B8_ACVP_VP_SPADEBONUS;
                           idsWinRatio = IDS_MS_WINRATIO_ACVP_VP_SPADEBONUS;
                           idsBankCash = IDS_MS_BANKCASH_ACVP_VP_SPADEBONUS;
                           break;
    case cvpSuperDJackpot: idsVertLite = IDS_MS_VERTLITE_ACVP_VP_SUPERDJACKPOT;
                           idsCoinPay = IDS_MS_COINPAY_ACVP_VP_SUPERDJACKPOT;
                           idsCard1 = IDS_MS_CARD1_ACVP_VP_SUPERDJACKPOT;
                           idsNP1 = IDS_MS_NP1_ACVP_VP_SUPERDJACKPOT;
                           idsCoinsPlayed = IDS_MS_COINSPLAYED_ACVP_VP_SUPERDJACKPOT;
                           idsCredits = IDS_MS_CREDITS_ACVP_VP_SUPERDJACKPOT;
                           idsWinPaid = IDS_MS_WINPAID_ACVP_VP_SUPERDJACKPOT;
                           idsButton0 = IDS_MS_B0_ACVP_VP_SUPERDJACKPOT;
                           idsButton1 = IDS_MS_B1_ACVP_VP_SUPERDJACKPOT;
                           idsButton2 = IDS_MS_B2_ACVP_VP_SUPERDJACKPOT;
                           idsButton3 = IDS_MS_B3_ACVP_VP_SUPERDJACKPOT;
                           idsButton4 = IDS_MS_B4_ACVP_VP_SUPERDJACKPOT;
                           idsButton5 = IDS_MS_B5_ACVP_VP_SUPERDJACKPOT;
                           idsButton6 = IDS_MS_B6_ACVP_VP_SUPERDJACKPOT;
                           idsButton7 = IDS_MS_B7_ACVP_VP_SUPERDJACKPOT;
                           idsGrid    = IDS_MS_GRID_ACVP_VP_SUPERDJACKPOT;
                           idsWinRatio = IDS_MS_WINRATIO_ACVP_VP_SUPERDJACKPOT;
                           idsBankCash = IDS_MS_BANKCASH_ACVP_VP_SUPERDJACKPOT;
                           break;
    case cvp7Wild1Joker://idsSounds = IDS_MS_SOUNDS_ACVP_VP_SEVENSWILD1JOKER;
                           idsVertLite = IDS_MS_VERTLITE_ACVP_VP_SEVENSWILD1JOKER;
                           //idsDrawBack = IDS_MS_DRAWBACK_ACVP_VP_SEVENSWILD1JOKER;
                           idsCoinPay = IDS_MS_COINPAY_ACVP_VP_SEVENSWILD1JOKER;
                           //idsChips = IDS_MS_CHIPS_ACVP_VP_SEVENSWILD1JOKER;
                           idsCard1 = IDS_MS_CARD1_ACVP_VP_SEVENSWILD1JOKER;
                           //idsCard2 = IDS_MS_CARD2_ACVP_VP_SEVENSWILD1JOKER;
                           //idsCard3 = IDS_MS_CARD3_ACVP_VP_SEVENSWILD1JOKER;
                           //idsCard4 = IDS_MS_CARD4_ACVP_VP_SEVENSWILD1JOKER;
                           //idsCard5 = IDS_MS_CARD5_ACVP_VP_SEVENSWILD1JOKER;
                           idsNP1 = IDS_MS_NP1_ACVP_VP_SEVENSWILD1JOKER;
                           //idsNP2 = IDS_MS_NP2_ACVP_VP_SEVENSWILD1JOKER;
                           //idsNP3 = IDS_MS_NP3_ACVP_VP_SEVENSWILD1JOKER;
                           idsCoinsPlayed = IDS_MS_COINSPLAYED_ACVP_VP_SEVENSWILD1JOKER;
                           idsCredits = IDS_MS_CREDITS_ACVP_VP_SEVENSWILD1JOKER;
                           idsWinPaid = IDS_MS_WINPAID_ACVP_VP_SEVENSWILD1JOKER;
                           idsButton0 = IDS_MS_B0_ACVP_VP_SEVENSWILD1JOKER;
                           idsButton1 = IDS_MS_B1_ACVP_VP_SEVENSWILD1JOKER;
                           idsButton2 = IDS_MS_B2_ACVP_VP_SEVENSWILD1JOKER;
                           idsButton3 = IDS_MS_B3_ACVP_VP_SEVENSWILD1JOKER;
                           idsButton4 = IDS_MS_B4_ACVP_VP_SEVENSWILD1JOKER;
                           idsButton5 = IDS_MS_B5_ACVP_VP_SEVENSWILD1JOKER;
                           idsButton6 = IDS_MS_B6_ACVP_VP_SEVENSWILD1JOKER;
                           idsButton7 = IDS_MS_B7_ACVP_VP_SEVENSWILD1JOKER;
                           //idsButton8 = IDS_MS_B8_ACVP_VP_SEVENSWILD1JOKER;
                           idsWinRatio = IDS_MS_WINRATIO_ACVP_VP_SEVENSWILD1JOKER;
                           idsBankCash = IDS_MS_BANKCASH_ACVP_VP_SEVENSWILD1JOKER;
                           break;

    case cvpTensOrBetterII://idsSounds = IDS_MS_SOUNDS_ACVP_VP_TENSORBETTER;
                           idsVertLite = IDS_MS_VERTLITE_ACVP_VP_TENSORBETTER;
                           //idsDrawBack = IDS_MS_DRAWBACK_ACVP_VP_TENSORBETTER;
                           idsCoinPay = IDS_MS_COINPAY_ACVP_VP_TENSORBETTER;
                           //idsChips = IDS_MS_CHIPS_ACVP_VP_TENSORBETTER;
                           idsCard1 = IDS_MS_CARD1_ACVP_VP_TENSORBETTER;
                           //idsCard2 = IDS_MS_CARD2_ACVP_VP_TENSORBETTER;
                           //idsCard3 = IDS_MS_CARD3_ACVP_VP_TENSORBETTER;
                           //idsCard4 = IDS_MS_CARD4_ACVP_VP_TENSORBETTER;
                           //idsCard5 = IDS_MS_CARD5_ACVP_VP_TENSORBETTER;
                           idsNP1 = IDS_MS_NP1_ACVP_VP_TENSORBETTER;
                           //idsNP2 = IDS_MS_NP2_ACVP_VP_TENSORBETTER;
                           //idsNP3 = IDS_MS_NP3_ACVP_VP_TENSORBETTER;
                           idsCoinsPlayed = IDS_MS_COINSPLAYED_ACVP_VP_TENSORBETTER;
                           idsCredits = IDS_MS_CREDITS_ACVP_VP_TENSORBETTER;
                           idsWinPaid = IDS_MS_WINPAID_ACVP_VP_TENSORBETTER;
                           idsButton0 = IDS_MS_B0_ACVP_VP_TENSORBETTER;
                           idsButton1 = IDS_MS_B1_ACVP_VP_TENSORBETTER;
                           idsButton2 = IDS_MS_B2_ACVP_VP_TENSORBETTER;
                           idsButton3 = IDS_MS_B3_ACVP_VP_TENSORBETTER;
                           idsButton4 = IDS_MS_B4_ACVP_VP_TENSORBETTER;
                           idsButton5 = IDS_MS_B5_ACVP_VP_TENSORBETTER;
                           idsButton6 = IDS_MS_B6_ACVP_VP_TENSORBETTER;
                           idsButton7 = IDS_MS_B7_ACVP_VP_TENSORBETTER;
                           //idsButton8 = IDS_MS_B8_ACVP_VP_TENSORBETTER;
                           idsWinRatio = IDS_MS_WINRATIO_ACVP_VP_TENSORBETTER;
                           idsBankCash = IDS_MS_BANKCASH_ACVP_VP_TENSORBETTER;
                           idsValue    = IDS_MS_VALUE_ACVP_VP_TENSORBETTER;
                           break;
    case cvpTreasureTrove: idsVertLite = IDS_MS_VERTLITE_ACVP_VP_TREASURETROVE;
                           idsCoinPay = IDS_MS_COINPAY_ACVP_VP_TREASURETROVE;
                           idsCard1 = IDS_MS_CARD1_ACVP_VP_TREASURETROVE;
                           idsNP1 = IDS_MS_NP1_ACVP_VP_TREASURETROVE;
                           idsCoinsPlayed = IDS_MS_COINSPLAYED_ACVP_VP_TREASURETROVE;
                           idsCredits = IDS_MS_CREDITS_ACVP_VP_TREASURETROVE;
                           idsWinPaid = IDS_MS_WINPAID_ACVP_VP_TREASURETROVE;
                           idsButton0 = IDS_MS_B0_ACVP_VP_TREASURETROVE;
                           idsButton1 = IDS_MS_B1_ACVP_VP_TREASURETROVE;
                           idsButton2 = IDS_MS_B2_ACVP_VP_TREASURETROVE;
                           idsButton3 = IDS_MS_B3_ACVP_VP_TREASURETROVE;
                           idsButton4 = IDS_MS_B4_ACVP_VP_TREASURETROVE;
                           idsButton6 = IDS_MS_B6_ACVP_VP_TREASURETROVE;
                           idsButton7 = IDS_MS_B7_ACVP_VP_TREASURETROVE;
                           idsChest   = IDS_MS_CHEST_ACVP_VP_TREASURETROVE;
                           idsWinRatio = IDS_MS_WINRATIO_ACVP_VP_TREASURETROVE;
                           idsBankCash = IDS_MS_BANKCASH_ACVP_VP_TREASURETROVE;
                           break;
    case cvpTriplePlay://idsSounds = IDS_MS_SOUNDS_ACVP_VP_TRIPLEPLAY;
                           idsVertLite = IDS_MS_VERTLITE_ACVP_VP_TRIPLEPLAY;
                           //idsDrawBack = IDS_MS_DRAWBACK_ACVP_VP_TRIPLEPLAY;
                           idsCoinPay = IDS_MS_COINPAY_ACVP_VP_TRIPLEPLAY;
                           //idsChips = IDS_MS_CHIPS_ACVP_VP_TRIPLEPLAY;
                           idsCard1 = IDS_MS_CARD1_ACVP_VP_TRIPLEPLAY;
                           //idsCard2 = IDS_MS_CARD2_ACVP_VP_TRIPLEPLAY;
                           //idsCard3 = IDS_MS_CARD3_ACVP_VP_TRIPLEPLAY;
                           //idsCard4 = IDS_MS_CARD4_ACVP_VP_TRIPLEPLAY;
                           //idsCard5 = IDS_MS_CARD5_ACVP_VP_TRIPLEPLAY;
                           idsNP1 = IDS_MS_NP1_ACVP_VP_TRIPLEPLAY;
                           //idsNP2 = IDS_MS_NP2_ACVP_VP_TRIPLEPLAY;
                           //idsNP3 = IDS_MS_NP3_ACVP_VP_TRIPLEPLAY;
                           idsCoinsPlayed = IDS_MS_COINSPLAYED_ACVP_VP_TRIPLEPLAY;
                           idsCredits = IDS_MS_CREDITS_ACVP_VP_TRIPLEPLAY;
                           idsWinPaid = IDS_MS_WINPAID_ACVP_VP_TRIPLEPLAY;
                           idsButton0 = IDS_MS_B0_ACVP_VP_TRIPLEPLAY;
                           idsButton1 = IDS_MS_B1_ACVP_VP_TRIPLEPLAY;
                           idsButton2 = IDS_MS_B2_ACVP_VP_TRIPLEPLAY;
                           idsButton3 = IDS_MS_B3_ACVP_VP_TRIPLEPLAY;
                           idsButton4 = IDS_MS_B4_ACVP_VP_TRIPLEPLAY;
                           idsButton5 = IDS_MS_B5_ACVP_VP_TRIPLEPLAY;
                           idsButton6 = IDS_MS_B6_ACVP_VP_TRIPLEPLAY;
                           idsButton7 = IDS_MS_B7_ACVP_VP_TRIPLEPLAY;
                           //idsButton8 = IDS_MS_B8_ACVP_VP_TRIPLEPLAY;
                           idsWinRatio = IDS_MS_WINRATIO_ACVP_VP_TRIPLEPLAY;
                           idsBankCash = IDS_MS_BANKCASH_ACVP_VP_TRIPLEPLAY;
                           break;
    case cvpTripleBonus:   idsVertLite = IDS_MS_VERTLITE_ACVP_VP_TRIPLEBONUS;
                           idsCoinPay = IDS_MS_COINPAY_ACVP_VP_TRIPLEBONUS;
                           idsCard1 = IDS_MS_CARD1_ACVP_VP_TRIPLEBONUS;
                           idsNP1 = IDS_MS_NP1_ACVP_VP_TRIPLEBONUS;
                           idsCoinsPlayed = IDS_MS_COINSPLAYED_ACVP_VP_TRIPLEBONUS;
                           idsCredits = IDS_MS_CREDITS_ACVP_VP_TRIPLEBONUS;
                           idsWinPaid = IDS_MS_WINPAID_ACVP_VP_TRIPLEBONUS;
                           idsButton0 = IDS_MS_B0_ACVP_VP_TRIPLEBONUS;
                           idsButton1 = IDS_MS_B1_ACVP_VP_TRIPLEBONUS;
                           idsButton2 = IDS_MS_B2_ACVP_VP_TRIPLEBONUS;
                           idsButton3 = IDS_MS_B3_ACVP_VP_TRIPLEBONUS;
                           idsButton4 = IDS_MS_B4_ACVP_VP_TRIPLEBONUS;
                           idsButton5 = IDS_MS_B5_ACVP_VP_TRIPLEBONUS;
                           idsButton6 = IDS_MS_B6_ACVP_VP_TRIPLEBONUS;
                           idsButton7 = IDS_MS_B7_ACVP_VP_TRIPLEBONUS;
                           idsButton8 = IDS_MS_B8_ACVP_VP_TRIPLEBONUS;
                           idsButton9 = IDS_MS_B9_ACVP_VP_TRIPLEBONUS;
                           idsWinRatio = IDS_MS_WINRATIO_ACVP_VP_TRIPLEBONUS;
                           idsBankCash = IDS_MS_BANKCASH_ACVP_VP_TRIPLEBONUS;
                           idsBackG = IDS_MS_BACKG_ACVP_VP_TRIPLEBONUS;
                           break;
    case cvpWheelDeal:     idsVertLite = IDS_MS_VERTLITE_ACVP_VP_WHEELDEAL;
                           idsCoinPay = IDS_MS_COINPAY_ACVP_VP_WHEELDEAL;
                           idsCard1 = IDS_MS_CARD1_ACVP_VP_WHEELDEAL;
                           idsNP1 = IDS_MS_NP1_ACVP_VP_WHEELDEAL;
                           idsCoinsPlayed = IDS_MS_COINSPLAYED_ACVP_VP_WHEELDEAL;
                           idsCredits = IDS_MS_CREDITS_ACVP_VP_WHEELDEAL;
                           idsWinPaid = IDS_MS_WINPAID_ACVP_VP_WHEELDEAL;
                           idsButton0 = IDS_MS_B0_ACVP_VP_WHEELDEAL;
                           idsButton1 = IDS_MS_B1_ACVP_VP_WHEELDEAL;
                           idsButton2 = IDS_MS_B2_ACVP_VP_WHEELDEAL;
                           idsButton3 = IDS_MS_B3_ACVP_VP_WHEELDEAL;
                           idsButton4 = IDS_MS_B4_ACVP_VP_WHEELDEAL;
                           idsButton5 = IDS_MS_B5_ACVP_VP_WHEELDEAL;
                           idsButton6 = IDS_MS_B6_ACVP_VP_WHEELDEAL;
                           idsButton7 = IDS_MS_B7_ACVP_VP_WHEELDEAL;
                           idsWinRatio = IDS_MS_WINRATIO_ACVP_VP_WHEELDEAL;
                           idsBankCash = IDS_MS_BANKCASH_ACVP_VP_WHEELDEAL;
                           idsWheel    = IDS_MS_WHEEL_ACVP_VP_WHEELDEAL;
                           break;
    default:break;
  }
}
//*******************************************************************
TSprite *TACVPVPGLord::CreateSprite(string spritename,int16 id,void *psource)
{
  TFileMode FM(spritename,
               TFileMode::fm_None,
               TFileMode::fm_None,
               FileMode.GetDirIndex());
  if (psource != NULL)
  {
    switch (id)
	 {
		case  0 : return new TSprite(PModeWin,FM,psource);
      case  1 : Button6 = new TACCasButton(PModeWin,FM,psource,this,100,
                                         TRect(454,463,541,479),idButton6,true);
                return Button6;
      case  2 : Button7 = new TACCasButton(PModeWin,FM,psource,this,100,
                                         TRect(553,463,637,479),idButton7,true,'x');
                return Button7;
      case  3 : BankCashDisplay = new TACVPSlotsCashDisplay(PModeWin,FM,psource);
                return BankCashDisplay;
      case  4 : Button1 = new TACCasButton(PModeWin,FM,psource,this,126,
                                         TRect(407,400,473,452),idButton1,true,'o');
                return Button1;
      case  5 : Button2 = new TACCasButton(PModeWin,FM,psource,this,125,
                                         TRect(487,400,553,452),idButton2,true,'m');
                return Button2;
      case  6 : CardSprite = new TVP5Card(PModeWin,FM,psource);
                return CardSprite;
      case  7 : Button0 = new TACCasButton(PModeWin,FM,psource,this,125,
                                         TRect(2,396,84,455),idButton0,true,'c');
                return Button0;
      case  8 : WinRatio = new TACVPWinRatio(PModeWin,FM,psource);
                return WinRatio;
      case  9 : Credits = new TACVPCredits(PModeWin,FM,psource);
                return Credits;
      case 10 : Button3 = new TACCasButton(PModeWin,FM,psource,this,125,
                                         TRect(567,400,633,452),idButton3,true,'d');
                return Button3;
      case 11 : Button8 = new TACCasButton(PModeWin,FM,psource,this,225,
                                         TRect(407,400,517,452),idButton8,true,'d');
                return Button8;
      case 12 : CoinPay = new TACVPCoinPay(PModeWin,FM,psource);
                return CoinPay;
      case 13 : Button4 = new TACCasButton(PModeWin,FM,psource,this,125,
                                         TRect(1,464,88,479),idButton4,true);
                return Button4;
      case 14 : Button5 = new TACCasButton(PModeWin,FM,psource,this,100,
                                         TRect(98,464,170,479),idButton5,true);
                return Button5;
      case 15 : NamePlate1 = new TACCasNamePlate(PModeWin,FM,psource,XName);
                return NamePlate1;
      case 16 : WinPaid = new TACVPWinPaid(PModeWin,FM,psource);
                return WinPaid;
      case 17 : VertLite = new TACVPVertLite(PModeWin,FM,psource);
                return VertLite;
      case 18 : CoinsPlayed = new TACVPCoinsPlayed(PModeWin,FM,psource);
                return CoinsPlayed;
      case 19 : Song = new TSprite(PModeWin,FM,psource);
                return Song;
      case 21 : Title = new TACVPBackground(PModeWin,FM,psource);
                  return Title;
      case 20 : Value = new TACVPValue(PModeWin,FM,psource);
                return Value;
      case 22 : Prog1 = new TACVPProgressive(PModeWin,FM,psource);
                return Prog1;
      case 23 : Look = new TACVPLook(PModeWin,FM,psource);
                return Look;
      case 24 : if(SubGameType == cvpWheelDeal)
                {Wheel = new TACVPWheelDeal(PModeWin,FM,psource);
                 return Wheel;}
                else if(SubGameType == cvpTreasureTrove)
                {Chest = new TACVPTreasureTrove(PModeWin,FM,psource);
                 return Chest;}
                else if(SubGameType == cvpJackpotBonus)
                {JackpotBonus = new TACVPJackpotBonus(PModeWin,FM,psource);
                 return JackpotBonus;}
      case 25 : Prog1 = new TACVPProgressive(PModeWin,FM,psource);
                return Prog1;
      case 26 : Prog2 = new TACVPProgressive(PModeWin,FM,psource);
                return Prog2;
      case 27 : Prog3 = new TACVPProgressive(PModeWin,FM,psource);
                return Prog3;
      case 28 : Prog1 = new TACVPProgressive(PModeWin,FM,psource);
                return Prog1;
      case 29 : Prog2 = new TACVPProgressive(PModeWin,FM,psource);
                return Prog2;
      case 30 : Prog3 = new TACVPProgressive(PModeWin,FM,psource);
                return Prog3;
      case 31 : Prog4 = new TACVPProgressive(PModeWin,FM,psource);
                return Prog4;
      case 38 : FAss = new TACVPWinRatio(PModeWin,FM,psource);
                return FAss;
      case 39 : if(SubGameType == cvpFlushAssault)
                {
                  BackG = new TACVPBackground(PModeWin,FM,psource);
                  return BackG;
                }
                else
                {
                  Button9 = new TACCasButton(PModeWin,FM,psource,this,225,
                                         TRect(522,400,633,452),idButton9,true,'w');
                }
                return Button9;
      case 40 : BackG = new TACVPBackground(PModeWin,FM,psource);
                return BackG;
      case 41 : VertLite2 = new TACVPVertLite(PModeWin,FM,psource);
                return VertLite2;
      case 45 : Grid = new TACVPGrid(PModeWin,FM,psource);
                return Grid;
      case 46 : GridWin = new TSprite(PModeWin,FM,psource);
                return GridWin;
      case 49 : MidCardSprite = new TVP5Card(PModeWin,FM,psource);
                return MidCardSprite;
      case 50 : TopCardSprite = new TVP5Card(PModeWin,FM,psource);
                return TopCardSprite;
      case 51 : WinPaidBot = new TACVPWinPaid(PModeWin,FM,psource);
                return WinPaidBot;
      case 52 : WinPaidMid = new TACVPWinPaid(PModeWin,FM,psource);
                return WinPaidMid;
      case 53 : WinPaidTop = new TACVPWinPaid(PModeWin,FM,psource);
                return WinPaidTop;
      default : return new TSprite(PModeWin,FM,psource);
	 }
  }
  else
  {
	 FM.SetRamImmed();
	 switch (id)
	 {
		case  0 : return new TSprite(PModeWin,FM);
      case  1 : Button6 = new TACCasButton(PModeWin,FM,this,100,
                                         TRect(454,463,541,479),idButton6,true);
                return Button6;
      case  2 : Button7 = new TACCasButton(PModeWin,FM,this,100,
                                         TRect(553,463,637,479),idButton7,true,'x');
                return Button7;
      case  3 : BankCashDisplay = new TACVPSlotsCashDisplay(PModeWin,FM);
                return BankCashDisplay;
      case  4 : Button1 = new TACCasButton(PModeWin,FM,this,126,
                                         TRect(407,400,473,452),idButton1,true,'o');
                return Button1;
      case  5 : Button2 = new TACCasButton(PModeWin,FM,this,125,
                                         TRect(487,400,553,452),idButton2,true,'m');
                return Button2;
      case  6 : CardSprite = new TVP5Card(PModeWin,FM);
                return CardSprite;
      case  7 : Button0 = new TACCasButton(PModeWin,FM,this,125,
                                         TRect(2,396,84,455),idButton0,true,'c');
                return Button0;
      case  8 : WinRatio = new TACVPWinRatio(PModeWin,FM);
                return WinRatio;
      case  9 : Credits = new TACVPCredits(PModeWin,FM);
                return Credits;
      case 10 : Button3 = new TACCasButton(PModeWin,FM,this,125,
                                         TRect(567,400,633,452),idButton3,true,'d');
                return Button3;
      case 11 : Button8 = new TACCasButton(PModeWin,FM,this,225,
                                         TRect(407,400,517,452),idButton8,true,'d');
                return Button8;
      case 12 : CoinPay = new TACVPCoinPay(PModeWin,FM);
                return CoinPay;
      case 13 : Button4 = new TACCasButton(PModeWin,FM,this,125,
                                         TRect(1,464,88,479),idButton4,true);
                return Button4;
      case 14 : Button5 = new TACCasButton(PModeWin,FM,this,100,
                                         TRect(98,464,170,479),idButton5,true);
                return Button5;
      case 15 : NamePlate1 = new TACCasNamePlate(PModeWin,FM,XName);
                return NamePlate1;
      case 16 : WinPaid = new TACVPWinPaid(PModeWin,FM);
                return WinPaid;
      case 17 : VertLite = new TACVPVertLite(PModeWin,FM);
                return VertLite;
      case 18 : CoinsPlayed = new TACVPCoinsPlayed(PModeWin,FM);
                return CoinsPlayed;
      case 19 : Song = new TSprite(PModeWin,FM);
                return Song;
      case 21 : Title = new TACVPBackground(PModeWin,FM);
                  return Title;
      case 20 : Value = new TACVPValue(PModeWin,FM);
                return Value;
      case 22 : Prog1 = new TACVPProgressive(PModeWin,FM);
                return Prog1;
      case 23 : Look = new TACVPLook(PModeWin,FM);
                return Look;
      case 24 : if(SubGameType == cvpWheelDeal)
                {Wheel = new TACVPWheelDeal(PModeWin,FM);
                 return Wheel;}
                else if(SubGameType == cvpTreasureTrove)
                {Chest = new TACVPTreasureTrove(PModeWin,FM);
                 return Chest;}
                else if(SubGameType == cvpJackpotBonus)
                {JackpotBonus = new TACVPJackpotBonus(PModeWin,FM);
                 return JackpotBonus;}
      case 25 : Prog1 = new TACVPProgressive(PModeWin,FM);
                return Prog1;
      case 26 : Prog2 = new TACVPProgressive(PModeWin,FM);
                return Prog2;
      case 27 : Prog3 = new TACVPProgressive(PModeWin,FM);
                return Prog3;
      case 28 : Prog1 = new TACVPProgressive(PModeWin,FM);
                return Prog1;
      case 29 : Prog2 = new TACVPProgressive(PModeWin,FM);
                return Prog2;
      case 30 : Prog3 = new TACVPProgressive(PModeWin,FM);
                return Prog3;
      case 31 : Prog4 = new TACVPProgressive(PModeWin,FM);
                return Prog4;
      case 38 : FAss = new TACVPWinRatio(PModeWin,FM);
                return FAss;
      case 39 : if(SubGameType == cvpFlushAssault)
                {
                  BackG = new TACVPBackground(PModeWin,FM);
                  return BackG;
                }
                else
                {
                  Button9 = new TACCasButton(PModeWin,FM,this,225,
                                         TRect(522,400,633,452),idButton9,true,'w');
                }
                return Button9;
      case 40 : BackG = new TACVPBackground(PModeWin,FM);
                return BackG;
      case 41 : VertLite2 = new TACVPVertLite(PModeWin,FM);
                return VertLite2;
      case 45 : Grid = new TACVPGrid(PModeWin,FM);
                return Grid;
      case 46 : GridWin = new TSprite(PModeWin,FM);
                return GridWin;
      case 49 : MidCardSprite = new TVP5Card(PModeWin,FM);
                return MidCardSprite;
      case 50 : TopCardSprite = new TVP5Card(PModeWin,FM);
                return TopCardSprite;
      case 51 : WinPaidBot = new TACVPWinPaid(PModeWin,FM);
                return WinPaidBot;
      case 52 : WinPaidMid = new TACVPWinPaid(PModeWin,FM);
                return WinPaidMid;
      case 53 : WinPaidTop = new TACVPWinPaid(PModeWin,FM);
                return WinPaidTop;
      default : return new TSprite(PModeWin,FM);
	 }
  }
}
//*******************************************************************
void TACVPVPGLord::SetupResponders()
{
  if(SubGameType == cvpTriplePlay)
  {
    Responders[0] = new TResponder(PModeWin,100,TRect(540,208,635,237),idAddCoins,this,true,'~',TCursorData(GetOgleApp(),ID_POINTING_FINGER_CURSOR));
    Responders[1] = new TResponder(PModeWin,100,TRect(254,160,303,233),idHoldCard0,this,true,'1',TCursorData(GetOgleApp(),ID_POINTING_FINGER_CURSOR));
    Responders[2] = new TResponder(PModeWin,100,TRect(308,160,359,233),idHoldCard1,this,true,'2',TCursorData(GetOgleApp(),ID_POINTING_FINGER_CURSOR));
    Responders[3] = new TResponder(PModeWin,100,TRect(364,160,415,233),idHoldCard2,this,true,'3',TCursorData(GetOgleApp(),ID_POINTING_FINGER_CURSOR));
    Responders[4] = new TResponder(PModeWin,100,TRect(420,160,470,233),idHoldCard3,this,true,'4',TCursorData(GetOgleApp(),ID_POINTING_FINGER_CURSOR));
    Responders[5] = new TResponder(PModeWin,100,TRect(475,160,529,233),idHoldCard4,this,true,'5',TCursorData(GetOgleApp(),ID_POINTING_FINGER_CURSOR));

  }
  else
  {
    Responders[0] = new TResponder(PModeWin,100,TRect(3,242,45,392),idAddCoins,this,true,'~',TCursorData(GetOgleApp(),ID_POINTING_FINGER_CURSOR));
    Responders[1] = new TResponder(PModeWin,100,TRect(56,249,146,378),idHoldCard0,this,true,'1',TCursorData(GetOgleApp(),ID_POINTING_FINGER_CURSOR));
    Responders[2] = new TResponder(PModeWin,100,TRect(154,249,242,378),idHoldCard1,this,true,'2',TCursorData(GetOgleApp(),ID_POINTING_FINGER_CURSOR));
    Responders[3] = new TResponder(PModeWin,100,TRect(247,249,338,378),idHoldCard2,this,true,'3',TCursorData(GetOgleApp(),ID_POINTING_FINGER_CURSOR));
    Responders[4] = new TResponder(PModeWin,100,TRect(344,249,431,378),idHoldCard3,this,true,'4',TCursorData(GetOgleApp(),ID_POINTING_FINGER_CURSOR));
    Responders[5] = new TResponder(PModeWin,100,TRect(437,249,524,378),idHoldCard4,this,true,'5',TCursorData(GetOgleApp(),ID_POINTING_FINGER_CURSOR));
  }
  Responders[6]  = new TResponder(PModeWin,100,TRect(39,43,42,46),idOneChip,this,true,'~',TCursorData(GetOgleApp(),ID_POINTING_FINGER_CURSOR));
  Responders[7]  = new TResponder(PModeWin,100,TRect(35,43,39,46),idFiveChip,this,true,'~',TCursorData(GetOgleApp(),ID_POINTING_FINGER_CURSOR));
  Responders[8]  = new TResponder(PModeWin,100,TRect(32,43,35,46),idTwentyFiveChip,this,true,'~',TCursorData(GetOgleApp(),ID_POINTING_FINGER_CURSOR));
  Responders[9]  = new TResponder(PModeWin,100,TRect(28,43,32,46),idOneHundredChip,this,true,'~',TCursorData(GetOgleApp(),ID_POINTING_FINGER_CURSOR));
  Responders[10]  = new TResponder(PModeWin,100,TRect(25,43,28,46),idOneThouChip,this,true,'~',TCursorData(GetOgleApp(),ID_POINTING_FINGER_CURSOR));
  Responders[11]  = new TResponder(PModeWin,100,TRect(21,43,25,46),idTenThouChip,this,true,'~',TCursorData(GetOgleApp(),ID_POINTING_FINGER_CURSOR));
  Responders[12]  = new TResponder(PModeWin,200,TRect(5,5,635,475)    ,idSpeedClick        ,this,true,VK_SPACE,TCursorData(0,0));
  Responders[13]  = new TResponder(PModeWin,100,TRect(26,46,37,47)   ,idNamePlate,this,true,VK_TAB,TCursorData(GetOgleApp(),ID_POINTING_FINGER_CURSOR));
}
//*******************************************************************
void TACVPVPGLord::AskHoldCards(bool show)
{
  ask->HoldCards(show);
}
//*******************************************************************
void TACVPVPGLord::AskMoneyExpert()
{
  string expertstring;

  if(coinsize*(maxbet - coinsplayed) > GetCash(activeplayer))
  {
	 expertstring = GetAppString(5123);
	 expertstring += GetAppString(5124);
	 expertstring += GetAppString(5125);
  }
  else
  {
	 expertstring = GetAppString(5126);
	 expertstring += GetAppString(5127);
	 expertstring += GetAppString(5128);
  }
  GetFW()->DisplayExpert(expertstring);
}
//*******************************************************************
void TACVPVPGLord::AskGenExpert()
{
  string  expertstring = GetAppString(5110);
  expertstring += GetAppString(5111);
  expertstring += GetAppString(5112);
  expertstring += GetAppString(5113);
  expertstring += GetAppString(5114);
  expertstring += GetAppString(5115);
  expertstring += GetAppString(5116);
  expertstring += GetAppString(5117);
  expertstring += GetAppString(5118);
  expertstring += GetAppString(5119);
  expertstring += GetAppString(5120);
  expertstring += GetAppString(5121);
  expertstring += GetAppString(5122);
  GetFW()->DisplayExpert(expertstring);
}
//*******************************************************************
TMoney TACVPVPGLord::PayOutJacks()
{
  int16 session = GetCasPD(activeplayer)->VPData.CurrentSession;
  TCVPSession &cs = GetCasPD(activeplayer)->VPData.Sessions[session];

  switch (GetCasPlayer(activeplayer)->pHand->highhand)
  {
	 case 10:   if (GetCasPlayer(activeplayer)->pHand->highcard > Ten)
					{
					  fake->highcard = GetCasPlayer(activeplayer)->pHand->highcard;
					  winnerpaid += coinsplayed;
					  cs.TotalHighPairCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.HighPairs++;
					  switch(GetCasPlayer(activeplayer)->pHand->highcard)
                 {
						 case Ten   : winhand = "Pair of Tens";break;
						 case Jack  : winhand = "Pair of Jacks";break;
						 case Queen : winhand = "Pair of Queens";break;
						 case King  : winhand = "Pair of Kings";break;
						 case AceHi : winhand = "Pair of Aces";break;
					  }
					  VertLite->SetRow(0);
					}
					break;
	 case 15 :  winnerpaid += coinsplayed*2;
               winhand = "Two Pair";
					cs.TotalTwoPairCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.TwoPairs++;
					VertLite->SetRow(1);
               break;
	 case 20 :  winnerpaid += coinsplayed*3;
               winhand = "Three of a Kind";
					cs.TotalThreeOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.ThreeOfKinds++;
					VertLite->SetRow(2);
               break;
	 case 23 :  winnerpaid += coinsplayed*4;
               winhand = "Straight";
					cs.TotalStraightCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Straights++;
					VertLite->SetRow(3);
               break;
	 case 26 :  winnerpaid += coinsplayed*6;
               winhand = "Flush";
					cs.TotalFlushCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Flushes++;
					VertLite->SetRow(4);
               break;
	 case 70 :  winnerpaid += coinsplayed*9;
               winhand = "Full House";
					cs.TotalFullHouseCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FullHouses++;
					VertLite->SetRow(5);
               break;
	 case 71 :  winnerpaid += coinsplayed*25;
               winhand = "Four of a Kind";
					cs.TotalFourOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FourOfKinds++;
					VertLite->SetRow(6);
               break;
	 case 99 :  if (GetCasPlayer(activeplayer)->pHand->highcard == AceHi)
					{
					  if(coinsplayed == 5)
					  {
						 winnerpaid += 4000;
                   winhand = "Royal Flush";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  else
					  {
						 winnerpaid += coinsplayed*250;
                   winhand = "Royal Flush";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  VertLite->SetRow(8);
                 break;
					}
					else
					{
					  winnerpaid += coinsplayed*50;winhand = "Straight Flush";
					  cs.TotalStraightFlushCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.StraightFlushes++;
					  VertLite->SetRow(7);
                 break;
					}
	 default : return 1;
  }
  //???switch(((int32)(winnerpaid/coinsplayed)))
  /*{
	 case 1  : //???VPSounds->PlaySound(17);break;
	 case 2  : VPSounds->PlaySound(18);break;
	 case 3  : VPSounds->PlaySound(19);break;
	 case 4  : VPSounds->PlaySound(20);break;
	 case 5  : VPSounds->PlaySound(21);break;
	 case 6  : VPSounds->PlaySound(22);break;
	 case 7  : VPSounds->PlaySound(23);break;
	 case 8  : VPSounds->PlaySound(24);break;
	 case 9  : VPSounds->PlaySound(25);break;
	 default : if(winnerpaid/coinsplayed > 9 && winnerpaid/coinsplayed < 26)
				  {
                VPSounds->PlaySound(26);
                break;
              }
				  else if(winnerpaid/coinsplayed > 25 && winnerpaid/coinsplayed < 4000)
				  {
                VPSounds->PlaySound(27);
                break;
              }
				  else if(winnerpaid >= 4000)
				  {
                VPSounds->PlaySound(28);
                break;
              }
  } */
  return 1;
}
//*******************************************************************
TMoney TACVPVPGLord::PayOutWild2()
{
  int16 session = GetCasPD(activeplayer)->VPData.CurrentSession;
  TCVPSession &cs = GetCasPD(activeplayer)->VPData.Sessions[session];

  switch (GetCasPlayer(activeplayer)->pHand->highhand) {
	 case 20 :  winnerpaid += coinsplayed*1;
               winhand = "Three of a Kind";
					cs.TotalThreeOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.ThreeOfKinds++;
					VertLite->SetRow(0);
               break;
	 case 23 :  winnerpaid += coinsplayed*2;
               winhand = "Straight";
					cs.TotalStraightCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Straights++;
					VertLite->SetRow(1);
               break;
	 case 26 :  winnerpaid += coinsplayed*2;
               winhand = "Flush";
					cs.TotalFlushCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Flushes++;
					VertLite->SetRow(2);
               break;
	 case 70 :  winnerpaid += coinsplayed*3;
               winhand = "Full House";
					cs.TotalFullHouseCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FullHouses++;
					VertLite->SetRow(3);
               break;
	 case 71 :  winnerpaid += coinsplayed*5;
               winhand = "Four of a Kind";
					cs.TotalFourOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FourOfKinds++;
					VertLite->SetRow(4);
               break;
	 case 99 :  if (GetCasPlayer(activeplayer)->pHand->highcard == AceHi)
					{
					  VertLite->SetRow(9);
					  if(coinsplayed == 5)
					  {
						 winnerpaid += 4000;
                   winhand = "Royal Flush(Nat)";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
                   break;
					  }
					  else
					  {
						 winnerpaid += coinsplayed*250;
                   winhand = "Royal Flush(Nat)";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
                   break;
					  }
					}
					else
					{
					  VertLite->SetRow(5);
					  winnerpaid += coinsplayed*9;
                 winhand = "Straight Flush";
					  cs.TotalStraightFlushCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.StraightFlushes++;
                 break;
					}
	 case 100 :   winnerpaid += coinsplayed*15;
                 winhand = "Five of a Kind";
					  cs.TotalFiveOfKindCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.FiveOfKinds++;
					  VertLite->SetRow(6);
                 break;
	 case 105 :   winnerpaid += coinsplayed*25;
                 winhand = "Royal Flush(Wild)";
					  cs.TotalWildRoyalCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.WildRoyals++;
					  VertLite->SetRow(7);
                 break;
	 case 110 :   winnerpaid += coinsplayed*200;
                 winhand = "Four Deuces";
					  cs.TotalFourDeuceCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.FourDeuces++;
					  VertLite->SetRow(8);
                 break;
	 default : return 1;
  }
  //???switch(((int32)(winnerpaid/coinsplayed)))
  /*{
	 case 1  : VPSounds->PlaySound(17);break;
	 case 2  : VPSounds->PlaySound(18);break;
	 case 3  : VPSounds->PlaySound(19);break;
	 case 4  : VPSounds->PlaySound(20);break;
	 case 5  : VPSounds->PlaySound(21);break;
	 case 6  : VPSounds->PlaySound(22);break;
	 case 7  : VPSounds->PlaySound(23);break;
	 case 8  : VPSounds->PlaySound(24);break;
	 case 9  : VPSounds->PlaySound(25);break;
	 default : if(winnerpaid/coinsplayed > 9 && winnerpaid/coinsplayed < 26)
				  {
                VPSounds->PlaySound(26);
                break;
              }
				  else if(winnerpaid/coinsplayed > 25 && winnerpaid/coinsplayed < 4000)
				  {
                VPSounds->PlaySound(27);
                break;
              }
				  else if(winnerpaid >= 4000)
				  {
                VPSounds->PlaySound(28);
                break;
              }
  }*/
  return 1;
}
//*******************************************************************
TMoney TACVPVPGLord::PayOutWildJoker()
{
  int16 session = GetCasPD(activeplayer)->VPData.CurrentSession;
  TCVPSession &cs = GetCasPD(activeplayer)->VPData.Sessions[session];

  switch (GetCasPlayer(activeplayer)->pHand->highhand) {
	 case 15 :  winnerpaid += coinsplayed;
               winhand = "Two Pair";
					cs.TotalTwoPairCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.TwoPairs++;
					VertLite->SetRow(0);
               break;
	 case 20 :  winnerpaid += coinsplayed*2;
               winhand = "Three of a Kind";
					cs.TotalThreeOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.ThreeOfKinds++;
					VertLite->SetRow(1);
               break;
	 case 23 :  winnerpaid += coinsplayed*5;
               winhand = "Straight";
					cs.TotalStraightCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Straights++;
					VertLite->SetRow(2);
               break;
	 case 26 :  winnerpaid += coinsplayed*7;
               winhand = "Flush";
					cs.TotalFlushCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Flushes++;
					VertLite->SetRow(3);
               break;
	 case 70 :  winnerpaid += coinsplayed*8;
               winhand = "Full House";
					cs.TotalFullHouseCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FullHouses++;
					VertLite->SetRow(4);
               break;
	 case 71 :  winnerpaid += coinsplayed*20;
               winhand = "Four of a Kind";
					cs.TotalFourOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FourOfKinds++;
					VertLite->SetRow(5);
               break;
	 case 99 :  if (GetCasPlayer(activeplayer)->pHand->highcard == AceHi)
					{
					  if(coinsplayed == 5)
					  {
						 winnerpaid += 4000;
                   winhand = "Royal Flush(Nat)";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  else
					  {
						 winnerpaid += coinsplayed*250;
                   winhand = "Royal Flush(Nat)";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  VertLite->SetRow(9);
                 break;
					}
					else
					{
					  winnerpaid += coinsplayed*50;
                 winhand = "Straight Flush";
					  cs.TotalStraightFlushCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.StraightFlushes++;
					  VertLite->SetRow(6);
                 break;
					}
	 case 100 :   winnerpaid += coinsplayed*100;
                 winhand = "Five of a Kind";
					  cs.TotalFiveOfKindCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.FiveOfKinds++;
					  VertLite->SetRow(8);
                 break;
	 case 105 :   winnerpaid += coinsplayed*50;
                 winhand = "Royal Flush(Wild)";
					  cs.TotalWildRoyalCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.WildRoyals++;
					  VertLite->SetRow(7);
                 break;
	 default : return 1;
  }
  //???switch(((int32)(winnerpaid/coinsplayed)))
  /*{
	 case 1  : VPSounds->PlaySound(17);break;
	 case 2  : VPSounds->PlaySound(18);break;
	 case 3  : VPSounds->PlaySound(19);break;
	 case 4  : VPSounds->PlaySound(20);break;
	 case 5  : VPSounds->PlaySound(21);break;
	 case 6  : VPSounds->PlaySound(22);break;
	 case 7  : VPSounds->PlaySound(23);break;
	 case 8  : VPSounds->PlaySound(24);break;
	 case 9  : VPSounds->PlaySound(25);break;
	 default : if(winnerpaid/coinsplayed > 9 && winnerpaid/coinsplayed < 26)
				  {
                VPSounds->PlaySound(26);
                break;
              }
				  else if(winnerpaid/coinsplayed > 25 && winnerpaid/coinsplayed < 4000)
				  {
                VPSounds->PlaySound(27);
                break;
              }
				  else if(winnerpaid >= 4000)
				  {
                VPSounds->PlaySound(28);
                break;
              }
  }*/
  return 1;
}
//*******************************************************************
TMoney TACVPVPGLord::PayOutProgressive()
{
  int16 session = GetCasPD(activeplayer)->VPData.CurrentSession;
  TCVPSession &cs = GetCasPD(activeplayer)->VPData.Sessions[session];

  switch (GetCasPlayer(activeplayer)->pHand->highhand) {
	 case 10 :  if (GetCasPlayer(activeplayer)->pHand->highcard > Ten)
					{
					  switch(GetCasPlayer(activeplayer)->pHand->highcard){
						 case Ten   : winhand = "Pair of Tens";break;
						 case Jack  : winhand = "Pair of Jacks";break;
						 case Queen : winhand = "Pair of Queens";break;
						 case King  : winhand = "Pair of Kings";break;
						 case AceHi : winhand = "Pair of Aces";break;
					  }
					  winnerpaid += coinsplayed;
					  cs.TotalHighPairCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.HighPairs++;
					  VertLite->SetRow(0);
					}
					break;
	 case 15 :  winnerpaid += coinsplayed*2 ;
               winhand = "Two Pair";
					cs.TotalTwoPairCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.TwoPairs++;
               VertLite->SetRow(1);
               break;
	 case 20 :  winnerpaid += coinsplayed*3;
               winhand = "Three of a Kind";
					cs.TotalThreeOfKindCash += winnerpaid*coinsize;
               cs.Wins++;
					cs.ThreeOfKinds++;
					VertLite->SetRow(2);
               break;
	 case 23 :  winnerpaid += coinsplayed*4 ;
               winhand = "Straight";
					cs.TotalStraightCash += winnerpaid*coinsize;
               cs.Wins++;
					cs.Straights++;
					VertLite->SetRow(3);
               break;
	 case 26 :  winnerpaid += coinsplayed*5;
               winhand = "Flush";
					cs.TotalFlushCash += winnerpaid*coinsize;
               cs.Wins++;
					cs.Flushes++;
					VertLite->SetRow(4);
               break;
	 case 70 :  winnerpaid += coinsplayed*8;
               winhand = "Full House";
					cs.TotalFullHouseCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FullHouses++;
					VertLite->SetRow(5);
               break;
	 case 71 :  winnerpaid += coinsplayed*25;
               winhand = "Four of a Kind";
					cs.TotalFourOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FourOfKinds++;
					VertLite->SetRow(6);
               break;
	 case 99 :  if (GetCasPlayer(activeplayer)->pHand->highcard == AceHi)
					{
					  if(coinsplayed == 5)
					  {
						 winnerpaid += progressive;
                   progressive = 4000;
                   winhand = "Royal Flush";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
					    cs.Wins++;
					    cs.NaturalRoyals++;
					  }
					  else
					  {
						 winnerpaid += coinsplayed*250;
                   winhand = "Royal Flush";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  VertLite->SetRow(8);
                 break;
					}
					else
					{
					  winnerpaid += coinsplayed*50;
                 winhand = "Straight Flush";
					  cs.TotalStraightFlushCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.StraightFlushes++;
					  VertLite->SetRow(7);
                 break;
					}
	 default : return 1;
  }
  //???switch(((int32)(winnerpaid/coinsplayed)))
  /*{
	 case 1  : VPSounds->PlaySound(17);break;
	 case 2  : VPSounds->PlaySound(18);break;
	 case 3  : VPSounds->PlaySound(19);break;
	 case 4  : VPSounds->PlaySound(20);break;
	 case 5  : VPSounds->PlaySound(21);break;
	 case 6  : VPSounds->PlaySound(22);break;
	 case 7  : VPSounds->PlaySound(23);break;
	 case 8  : VPSounds->PlaySound(24);break;
	 case 9  : VPSounds->PlaySound(25);break;
	 default : if(winnerpaid/coinsplayed > 9 && winnerpaid/coinsplayed < 26)
				  {
                VPSounds->PlaySound(26);
                break;
              }
				  else if(winnerpaid/coinsplayed > 25 && winnerpaid/coinsplayed < 4000)
				  {
                VPSounds->PlaySound(27);
                break;
              }
				  else if(winnerpaid >= 4000)
				  {
                VPSounds->PlaySound(28);
                break;
              }
  } */
  return 1;
}
//*******************************************************************
TMoney TACVPVPGLord::PayOutTens()
{
  int16 session = GetCasPD(activeplayer)->VPData.CurrentSession;
  TCVPSession &cs = GetCasPD(activeplayer)->VPData.Sessions[session];

  switch (GetCasPlayer(activeplayer)->pHand->highhand) {
	 case 10 :  if (GetCasPlayer(activeplayer)->pHand->highcard > Nine)
					{
					  switch(GetCasPlayer(activeplayer)->pHand->highcard){
						 case Ten   : winhand = "Pair of Tens";break;
						 case Jack  : winhand = "Pair of Jacks";break;
						 case Queen : winhand = "Pair of Queens";break;
						 case King  : winhand = "Pair of Kings";break;
						 case AceHi : winhand = "Pair of Aces";break;
					  }
					  cs.Wins++;
					  cs.HighPairs++;
					  winnerpaid += coinsplayed;
					  cs.TotalHighPairCash += winnerpaid*coinsize;
					  VertLite->SetRow(0);
					}
					break;
	 case 15 :  winnerpaid += coinsplayed*2;
               winhand = "Two Pair";
					cs.TotalTwoPairCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.TwoPairs++;
					VertLite->SetRow(1);
               break;
	 case 20 :  winnerpaid += coinsplayed*3;
               winhand = "Three of a Kind";
					cs.TotalThreeOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.ThreeOfKinds++;
					VertLite->SetRow(2);
               break;
	 case 23 :  winnerpaid += coinsplayed*4;
               winhand = "Straight";
					cs.TotalStraightCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Straights++;
					VertLite->SetRow(3);
               break;
	 case 26 :  winnerpaid += coinsplayed*5;
               winhand = "Flush";
					cs.TotalFlushCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Flushes++;
					VertLite->SetRow(4);
               break;
	 case 70 :  winnerpaid += coinsplayed*6;
               winhand = "Full House";
					cs.TotalFullHouseCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FullHouses++;
					VertLite->SetRow(5);
               break;
	 case 71 :  winnerpaid += coinsplayed*25;
               winhand = "Four of a Kind";
					cs.TotalFourOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FourOfKinds++;
					VertLite->SetRow(6);
               break;
	 case 99 :  if (GetCasPlayer(activeplayer)->pHand->highcard == AceHi)
					{
					  if(coinsplayed == 5)
					  {
						 winnerpaid += 4000;
                   winhand = "Rotal Flush";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  else
					  {
						 winnerpaid += coinsplayed*250;
                   winhand = "Royal Flush";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  VertLite->SetRow(8);
                 break;
					}
					else
					{
					  winnerpaid += coinsplayed*50;
                 winhand = "Straight Flush";
					  cs.TotalStraightFlushCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.StraightFlushes++;
					  VertLite->SetRow(7);
                 break;
					}
	 default : return 1;
  }
  //???switch(((int32)(winnerpaid/coinsplayed)))
  /*{
	 case 1  : VPSounds->PlaySound(17);break;
	 case 2  : VPSounds->PlaySound(18);break;
	 case 3  : VPSounds->PlaySound(19);break;
	 case 4  : VPSounds->PlaySound(20);break;
	 case 5  : VPSounds->PlaySound(21);break;
	 case 6  : VPSounds->PlaySound(22);break;
	 case 7  : VPSounds->PlaySound(23);break;
	 case 8  : VPSounds->PlaySound(24);break;
	 case 9  : VPSounds->PlaySound(25);break;
	 default : if(winnerpaid/coinsplayed > 9 && winnerpaid/coinsplayed < 26)
				  {
                VPSounds->PlaySound(26);
                break;
              }
				  else if(winnerpaid/coinsplayed > 25 && winnerpaid/coinsplayed < 4000)
				  {
                VPSounds->PlaySound(27);
                break;
              }
				  else if(winnerpaid >= 4000)
				  {
                VPSounds->PlaySound(28);
                break;
              }
  } */
  return 1;
}
//*******************************************************************
void TACVPVPGLord::ClearHand()
{
  GetCasPlayer(activeplayer)->pHand->highhand      = 0;
  GetCasPlayer(activeplayer)->pHand->highcard      = 0;
  GetCasPlayer(activeplayer)->pHand->toflush       = 0;
  GetCasPlayer(activeplayer)->pHand->instrght      = 0;
  GetCasPlayer(activeplayer)->pHand->outstrght     = 0;
  GetCasPlayer(activeplayer)->pHand->instrflsh     = 0;
  GetCasPlayer(activeplayer)->pHand->outstrflsh    = 0;
  GetCasPlayer(activeplayer)->pHand->instrflshsuit     = 0;
  GetCasPlayer(activeplayer)->pHand->outstrflshsuit    = 0;
  GetCasPlayer(activeplayer)->pHand->lohighcard    = 0;
  GetCasPlayer(activeplayer)->pHand->lolowcard     = 0;
  GetCasPlayer(activeplayer)->pHand->lohand        = 0;
  GetCasPlayer(activeplayer)->pHand->inhand        = 0;
  GetCasPlayer(activeplayer)->pHand->lowcard       = 0;
  GetCasPlayer(activeplayer)->pHand->wildcount     = 0;
  fake->highhand      = 0;
  fake->inhand        = 0;
  fake->highcard      = 0;
  fake->toflush       = 0;
  fake->instrght      = 0;
  fake->outstrght     = 0;
  fake->lohighcard    = 0;
  fake->lolowcard     = 0;
  fake->lohand        = 0;
  fake->lowcard       = 0;
  fake->instrflsh     = 0;
  fake->outstrflsh    = 0;
  fake->instrflshsuit     = 0;
  fake->outstrflshsuit    = 0;
  fake->wildcount     = 0;
  if(SubGameType == cvpTriplePlay)
  {
    TripTopHand->highhand      = 0;
    TripTopHand->highcard      = 0;
    TripTopHand->toflush       = 0;
    TripTopHand->instrght      = 0;
    TripTopHand->outstrght     = 0;
    TripTopHand->instrflsh     = 0;
    TripTopHand->outstrflsh    = 0;
    TripTopHand->instrflshsuit     = 0;
    TripTopHand->outstrflshsuit    = 0;
    TripTopHand->lohighcard    = 0;
    TripTopHand->lolowcard     = 0;
    TripTopHand->lohand        = 0;
    TripTopHand->inhand        = 0;
    TripTopHand->lowcard       = 0;
    TripTopHand->wildcount     = 0;

    TripMidHand->highhand      = 0;
    TripMidHand->highcard      = 0;
    TripMidHand->toflush       = 0;
    TripMidHand->instrght      = 0;
    TripMidHand->outstrght     = 0;
    TripMidHand->instrflsh     = 0;
    TripMidHand->outstrflsh    = 0;
    TripMidHand->instrflshsuit     = 0;
    TripMidHand->outstrflshsuit    = 0;
    TripMidHand->lohighcard    = 0;
    TripMidHand->lolowcard     = 0;
    TripMidHand->lohand        = 0;
    TripMidHand->inhand        = 0;
    TripMidHand->lowcard       = 0;
    TripMidHand->wildcount     = 0;
  }
}
//*******************************************************************
int16 TACVPVPGLord::Clear()
{
  Title->NoShow();
  UnFreezeAllButtons();
  Button3->SetCurrentUpFrame(0);
  Button3->SetCurrentDownFrame(1);
  Button3->ShowGray();
 // Button1->SetCurrentGrayFrame(-1);
 // Button2->SetCurrentGrayFrame(-1);
  WinRatio->SetStartFrame(0);
  shutdownstate    = 0;
  ChangeActivePlayersOk = true;
  if(credits > 0)
  {
	 Button0->ShowVoidUp();
  }
  else
  {
	 Button0->ShowGray();
  }
  if(activeplayer > -1 && (GetCash(activeplayer) >= coinsize || credits > 0))
  {
	 Button1->ShowVoidUp();
	 Button2->ShowVoidUp();
  }
  DisEnableButton(idButton8);
  if(activeplayer > -1){BankCashDisplay->SetNum(GetCash(activeplayer));}
  ClearHand();
  for(int16 i=0;i<5;i++)
  {
	 GetCasPlayer(activeplayer)->pHand->hold[i]    = 0;
  }
  if(pDeck != NULL)
  {
	 pDeck->top = 0;
  }
  return 1;
}
//*******************************************************************
int16 TACVPVPGLord::GetNumOfWildCards()
{
  if(SubGameType == cvpDeucesWild || SubGameType == cvpDeucesWildBonus ||
     SubGameType == cvpDeucesWildII || SubGameType == cvpDeucesWildProg  )
  {
    for(int16 i=0;i<5;i++)
	 {
		if (GetCasPlayer(activeplayer)->pHand->cards[i].name == Two)
		{
		  GetCasPlayer(activeplayer)->pHand->wildcount++;
		}
	 }
  }
  if (SubGameType == cvpJokersWild || SubGameType == cvpJokersWildProg ||
      SubGameType == cvpJumpinJokers || SubGameType == cvp7Wild1Joker  ||
      SubGameType == cvpRaiseJokersWild  || SubGameType == cvpDDrawJokerPoker )
  {
     for(int16 i=0;i<5;i++)
	 {
		if (GetCasPlayer(activeplayer)->pHand->cards[i].name == Joker)
		{
		  GetCasPlayer(activeplayer)->pHand->wildcount++;
		}
	 }
  }
  if(SubGameType == cvp7Wild1Joker)
  {
    for(int16 i=0;i<5;i++)
	 {
		if (GetCasPlayer(activeplayer)->pHand->cards[i].name == Seven)
		{
		  GetCasPlayer(activeplayer)->pHand->wildcount++;
		}
	 }
  }
  return 1;
}
//*******************************************************************
int16 TACVPVPGLord::Wild2(bool copy)
{
  if(copy)
  {
	 fake->inhand = 0;
	 for(int16 i=0;i<5;i++)
	 {
		fake->cards[i].name = GetCasPlayer(activeplayer)->pHand->cards[i].name;
		fake->cards[i].suit = GetCasPlayer(activeplayer)->pHand->cards[i].suit;
		fake->inhand++;
	 }
  }
  pSmarts->Insert_Sort(fake);

  if(GetCasPlayer(activeplayer)->pHand->wildcount && fake->inhand && fake->cards[0].name == Two)
  {
	 if(GetCasPlayer(activeplayer)->pHand->wildcount > 3)
	 {
		GetCasPlayer(activeplayer)->pHand->highhand = 110; // Four Deuces
		return 1;
	 }
	 if(GetCasPlayer(activeplayer)->pHand->wildcount > 2)
	 {
		if(fake->cards[3].suit == fake->cards[4].suit)
		{
		  if(fake->cards[3].name > Nine && fake->cards[4].name > Nine)
		  {
			 GetCasPlayer(activeplayer)->pHand->highhand = 105; // Royal with wild
			 return 1;
		  }
		  else
		  {
			 if(fake->cards[4].name - fake->cards[3].name < 5)
			 {
				GetCasPlayer(activeplayer)->pHand->highhand = 99; // Straight flush
				return 1;
			 }
			 else if(fake->cards[4].name == AceHi && fake->cards[3].name < Six)
			 {
				GetCasPlayer(activeplayer)->pHand->highhand = 99; // Straight flush
				return 1;
			 }
		  }
		}
		else
		{
		  if(fake->cards[4].name == fake->cards[3].name)
		  {
			 GetCasPlayer(activeplayer)->pHand->highhand = 100; // Five of kind
			 return 1;
		  }
		}
		GetCasPlayer(activeplayer)->pHand->highhand = 71; // Four of a kind
		return 1;
	 }
	 if(GetCasPlayer(activeplayer)->pHand->wildcount > 1)
	 {
		if(fake->cards[4].suit == fake->cards[3].suit &&
			fake->cards[2].suit == fake->cards[3].suit)
		{
		  if(fake->cards[4].name - fake->cards[2].name < 5)
		  {
			 if(fake->cards[2].name > Nine)
			 {
				GetCasPlayer(activeplayer)->pHand->highhand = 105;  // Royal wilds
				GetCasPlayer(activeplayer)->pHand->highcard = AceHi;
				return 1;
			 }
			 else
			 {
				GetCasPlayer(activeplayer)->pHand->highhand = 99; //Straight flush
				return 1;
			 }
		  }
		  else
		  {
			 if(fake->cards[4].name == AceHi && fake->cards[3].name < Six)
			 {
				GetCasPlayer(activeplayer)->pHand->highhand = 99; //Straight flush
				return 1;
			 }
			 else
			 {
				GetCasPlayer(activeplayer)->pHand->highhand = 26; // flush
				return 1;
			 }
		  }
		}
		if(fake->cards[4].name - fake->cards[2].name < 5)
		{
		  GetCasPlayer(activeplayer)->pHand->highhand = 23; // Straight
		}
		else
		{
		  if(fake->cards[4].name == AceHi && fake->cards[3].name < Six)
		  {
			 GetCasPlayer(activeplayer)->pHand->highhand = 23; // Straight
		  }
		}
		if(fake->cards[4].name == fake->cards[2].name)
		{
		  GetCasPlayer(activeplayer)->pHand->highhand = 100; // 5 o'kind
		  return 1;
		}
		if(fake->cards[3].name == fake->cards[2].name ||
			fake->cards[3].name == fake->cards[4].name)
		{
		  GetCasPlayer(activeplayer)->pHand->highhand = 71; // 4 o'kind
		  return 1;
		}
		if(GetCasPlayer(activeplayer)->pHand->highhand < 20)
		{
		  GetCasPlayer(activeplayer)->pHand->highhand = 20; // 3 o'kind
		}
		return 1;
	 }
	 for(int16 i=Two;i<=AceHi;i++)
	 {
		fake->cards[0].name = (TCardName)i;
		for(int16 j=0;j<4;j++)
		{
		  fake->cards[0].suit = (TSuit)j;
		  fake->highhand      = 0;
		  fake->highcard      = 0;
		  fake->toflush       = 0;
		  fake->instrght      = 0;
		  fake->outstrght     = 0;
		  fake->lohighcard    = 0;
		  fake->lolowcard     = 0;
		  fake->lohand        = 0;
		  fake->lowcard       = 0;
		  fake->instrght      = 0;
		  fake->outstrght     = 0;
		  fake->instrflsh     = 0;
		  fake->outstrflsh    = 0;
		  fake->instrflshsuit     = 0;
        fake->outstrflshsuit    = 0;
        pSmarts->Holding(fake);
		  if(fake->highhand > GetCasPlayer(activeplayer)->pHand->highhand)
		  {
			 if(fake->highhand == 99 && fake->highcard == AceHi)
			 {
				GetCasPlayer(activeplayer)->pHand->highhand = 105;
				GetCasPlayer(activeplayer)->pHand->highcard = AceHi;
			 }
			 else
			 {
				GetCasPlayer(activeplayer)->pHand->highhand = fake->highhand;
				GetCasPlayer(activeplayer)->pHand->highcard = fake->highcard;
			 }
		  }
		  else
		  {
			 if(fake->highhand == 99 && fake->highcard == AceHi)
			 {
				GetCasPlayer(activeplayer)->pHand->highhand = 105;
				GetCasPlayer(activeplayer)->pHand->highcard = AceHi;
			 }
		  }
		  if(fake->instrflsh > GetCasPlayer(activeplayer)->pHand->instrflsh)
		  {
			 GetCasPlayer(activeplayer)->pHand->instrflsh = fake->instrflsh;
		  }
		  if(fake->outstrflsh > GetCasPlayer(activeplayer)->pHand->outstrflsh)
		  {
			 GetCasPlayer(activeplayer)->pHand->outstrflsh = fake->outstrflsh;
		  }
		  if(fake->instrght > GetCasPlayer(activeplayer)->pHand->instrght)
		  {
			 GetCasPlayer(activeplayer)->pHand->instrght = fake->instrght;
		  }
		  if(fake->outstrght > GetCasPlayer(activeplayer)->pHand->outstrght)
		  {
			 GetCasPlayer(activeplayer)->pHand->outstrght = fake->outstrght;
		  }
		  if(fake->toflush > GetCasPlayer(activeplayer)->pHand->toflush)
		  {
			 GetCasPlayer(activeplayer)->pHand->toflush = fake->toflush;
		  }
		}
	 }
	 return 1;
  }//if(wildcount)
  pSmarts->Holding(GetCasPlayer(activeplayer)->pHand);
  pSmarts->Holding(fake);
  return 1;
}
//*******************************************************************
int16 TACVPVPGLord::WildJoker(bool copy)
{
  if(copy)
  {
	 fake->inhand = 0;
	 for(int16 i=0;i<5;i++)
	 {
		fake->cards[i].name = GetCasPlayer(activeplayer)->pHand->cards[i].name;
		fake->cards[i].suit = GetCasPlayer(activeplayer)->pHand->cards[i].suit;
		fake->inhand++;
	 }
  }
  pSmarts->Insert_Sort(fake);
  if(GetCasPlayer(activeplayer)->pHand->wildcount && fake->inhand && fake->cards[fake->inhand-1].name == Joker)
  {
	 for(int16 i=Two;i<=AceHi;i++)
	 {
		fake->cards[fake->inhand-1].name = (TCardName)i;
		for(int16 j=0;j<4;j++)
		{
		  fake->cards[fake->inhand-1].suit = (TSuit)j;
		  fake->highhand      = 0;
		  fake->highcard      = 0;
		  fake->toflush       = 0;
		  fake->instrght      = 0;
		  fake->outstrght     = 0;
		  fake->instrflsh      = 0;
		  fake->outstrflsh     = 0;
		  fake->instrflshsuit      = 0;
		  fake->outstrflshsuit     = 0;
		  fake->lohighcard    = 0;
		  fake->lolowcard     = 0;
		  fake->lohand        = 0;
		  fake->lowcard       = 0;
		  pSmarts->Holding(fake);
		  if(fake->highhand > GetCasPlayer(activeplayer)->pHand->highhand)
		  {
			 if(fake->highhand == 99 && fake->highcard == AceHi)
			 {
				GetCasPlayer(activeplayer)->pHand->highhand = 105;
				GetCasPlayer(activeplayer)->pHand->highcard = AceHi;
			 }
			 else
			 {
				GetCasPlayer(activeplayer)->pHand->highhand = fake->highhand;
				GetCasPlayer(activeplayer)->pHand->highcard = fake->highcard;
			 }
		  }
		  else
		  {
			 if(fake->highhand == 99 && fake->highcard == AceHi)
			 {
				GetCasPlayer(activeplayer)->pHand->highhand = 105;
				GetCasPlayer(activeplayer)->pHand->highcard = AceHi;
			 }
		  }
        if(fake->instrflsh > GetCasPlayer(activeplayer)->pHand->instrflsh)
		  {
			 GetCasPlayer(activeplayer)->pHand->instrflsh = fake->instrflsh;
		  }
		  if(fake->outstrflsh > GetCasPlayer(activeplayer)->pHand->outstrflsh)
		  {
			 GetCasPlayer(activeplayer)->pHand->outstrflsh = fake->outstrflsh;
		  }
		  if(fake->instrght > GetCasPlayer(activeplayer)->pHand->instrght)
		  {
			 GetCasPlayer(activeplayer)->pHand->instrght = fake->instrght;
		  }
		  if(fake->outstrght > GetCasPlayer(activeplayer)->pHand->outstrght)
		  {
			 GetCasPlayer(activeplayer)->pHand->outstrght = fake->outstrght;
		  }
		  if(fake->toflush > GetCasPlayer(activeplayer)->pHand->toflush)
		  {
			 GetCasPlayer(activeplayer)->pHand->toflush = fake->toflush;
		  }
		}
	 }
	 return 1;
  }//if(wildcount)
  pSmarts->Holding(GetCasPlayer(activeplayer)->pHand);
  pSmarts->Holding(fake);
  return 1;
}
//*******************************************************************
void TACVPVPGLord::PreWinner()
{
  GetNumOfWildCards();
  switch (SubGameType)
  {
	 case cvpDeucesWildBonus    :       Wild2s(true);break;
	 case cvpDeucesWildII       :       Wild2s(true);break;
	 case cvpDeucesWildProg     :       Wild2s(true);break;
	 case cvpDeucesWild         :       Wild2s(true);break;
	 case cvpRaiseJokersWild    :       WildJokers(true);break;
	 case cvpDDrawJokerPoker    :       WildJokers(true);break;
	 case cvpJokersWildProg     :       WildJokers(true);break;
	 case cvpJumpinJokers       :       WildJoker5(true);break;
	 case cvp7Wild1Joker        :       WildSevensJoker(true);break;
	 default                    :       pSmarts->Holding(GetCasPlayer(activeplayer)->pHand);break;//???return 0;
  }
}
//*******************************************************************
TMoney TACVPVPGLord::Winner()
{
  winnerpaid = 0;
  if(GetCasPlayer(activeplayer)->pHand->highhand >= Pair)
  {
	 switch (SubGameType)
	 {
      case cvpFivesUp             : PayOutFivesUp();           break;
      case cvpBonusDeluxe         : PayOutBonusDeluxeP();      break;
      case cvpClubBonus           : PayOutClubBonus();         break;
      case cvpCrazy8s             : PayOutCrazy8();            break;
      case cvpDDrawJB             : PayOutDDrawJacks();        break;
      case cvpDDrawJokerPoker     : PayOutDDrawJokers();       break;
      case cvpDDownStud           : PayOutDDownStud();         break;
      case cvpDeucesWildBonus     : PayOut2WildBonus();        break;
      case cvpDeucesWildII        : PayOut2Wild();             break;
      case cvpDeucesWildProg      : PayOut2WildProg();         break;
      case cvpDiamondBonus        : PayOutDiamondBonus();      break;
      case cvpDBonusPoker         : PayOutDoubleBonusPoker();  break;
      case cvpFlushAssault        : PayOutFlushAssault();      break;
      case cvpFreeLook            : PayOutFreeLook();          break;
      case cvpGamblersEdge        : PayOutGamblersEdge();      break;
      case cvpHeartBonus          : PayOutHeartBonus();        break;
      case cvpBlackJacks          : PayOutBlackJacks();        break;
      case cvpJacksProgII         : PayOutJacksBetterProg();   break;
      case cvpJackpotBonus        : PayOutJackpotBonus();      break;
      case cvp96JacksOrBetterII   : PayOutJacksBetter96();     break;
      case cvpTreasureTrove       : PayOutTreasureTrove();     break;
      case cvp85JacksOrBetter     : PayOutJacksBetter85();     break;
      case cvpDJacksOrBetter      : PayOutJacksBetterDoubleD();break;
      case cvpJokersWildProg      : PayOutJokerWildProg();     break;
      case cvpJumpinJokers        : PayOutJumpinJoker();       break;
      case cvpTripleProg          : PayOutTripProg();          break;
      case cvpRoyalProg           : PayOutProgRoyals();        break;
      case cvpPowerProg           : PayOutPowerFullHouse();    break;
      case cvpRaiseJokersWild     : PayOutRaiseDrawJoker();    break;
      case cvpSpadeBonus          : PayOutSpadeBonus();        break;
      case cvpSuperDJackpot       : PayOutSuperDoubleJackpot();break;
      case cvp7Wild1Joker         : PayOutSevenWildJoker();    break;
      case cvpTensOrBetterII      : PayOutTensBetter();        break;
      case cvpTriplePlay          : PayOutTriplePlay();        break;
      case cvpTripleBonus         : PayOutTripleBonus();       break;
      case cvpWheelDeal           : PayOutWheelDeal();         break;

		default:                  break;
	 }
	 if(winhand != "")
	 {
		winhand = "";
	 }
  }
  TCasinoVPData &cd = GetCasPD(activeplayer)->VPData;
  int16 session = cd.CurrentSession;
  TCVPSession &cs = cd.Sessions[session];
  winnerpaid *= MultPayoff;
  cs.TotalCashWon -= coinsplayed*coinsize;
  if(winnerpaid == 0)
  {
	 cd.Cumulative -= coinsplayed*coinsize;
	 cs.CurrentLosingStreak++;
	 cs.CurrentWinStreak = 0;
	 cs.Losses++;
	 cs.GarbageHands++;
	 if(cs.CurrentLosingStreak > cs.LosingStreak)
	 {
		cs.LosingStreak = cs.CurrentLosingStreak;
	 }
	 if((cs.StartingCash + cs.TotalCashWon) < cs.PeakLoss)
	 {
		cs.PeakLoss = cs.StartingCash + cs.TotalCashWon;
	 }
  }
  else
  {
	 cd.Cumulative += winnerpaid*coinsize;
	 cs.TotalCashWon += winnerpaid*coinsize;
	 cs.CurrentWinStreak++;
	 cs.CurrentLosingStreak = 0;
	 if(cs.CurrentWinStreak > cs.WinStreak)
	 {
		cs.WinStreak = cs.CurrentWinStreak;
	 }
	 if(winnerpaid*coinsize > cs.LargestWin)
	 {
		cs.LargestWin = winnerpaid*coinsize;
	 }
	 if((cs.StartingCash + cs.TotalCashWon) > cs.PeakWin)
	 {
		cs.PeakWin = cs.StartingCash + cs.TotalCashWon;
	 }
  }
  BankCashDisplay->SetNum(GetCash(activeplayer));
  return winnerpaid;
}// winner
//*******************************************************************
TMoney TACVPVPGLord::WinnerTop()
{
  winnerpaid = 0;
  if(TripTopHand->highhand >= Pair)
  {
    PayOutTriplePlayTop();
    if(winhand != "")
	 {
		winhand = "";
	 }
  }
  TCasinoVPData &cd = GetCasPD(activeplayer)->VPData;
  int16 session = cd.CurrentSession;
  TCVPSession &cs = cd.Sessions[session];
  cs.TotalCashWon -= coinsplayed*coinsize;
  if(winnerpaid == 0)
  {
	 cd.Cumulative -= coinsplayed*coinsize;
	 cs.CurrentLosingStreak++;
	 cs.CurrentWinStreak = 0;
	 cs.Losses++;
	 cs.GarbageHands++;
	 if(cs.CurrentLosingStreak > cs.LosingStreak)
	 {
		cs.LosingStreak = cs.CurrentLosingStreak;
	 }
	 if((cs.StartingCash + cs.TotalCashWon) < cs.PeakLoss)
	 {
		cs.PeakLoss = cs.StartingCash + cs.TotalCashWon;
	 }
  }
  else
  {
	 cd.Cumulative += winnerpaid*coinsize;
	 cs.TotalCashWon += winnerpaid*coinsize;
	 cs.CurrentWinStreak++;
	 cs.CurrentLosingStreak = 0;
	 if(cs.CurrentWinStreak > cs.WinStreak)
	 {
		cs.WinStreak = cs.CurrentWinStreak;
	 }
	 if(winnerpaid*coinsize > cs.LargestWin)
	 {
		cs.LargestWin = winnerpaid*coinsize;
	 }
	 if((cs.StartingCash + cs.TotalCashWon) > cs.PeakWin)
	 {
		cs.PeakWin = cs.StartingCash + cs.TotalCashWon;
	 }
  }
  BankCashDisplay->SetNum(GetCash(activeplayer));
  return winnerpaid;
}// winner
//*******************************************************************
TMoney TACVPVPGLord::WinnerMid()
{
  winnerpaid = 0;
  if(TripMidHand->highhand >= Pair)
  {
    PayOutTriplePlayMid();
	 if(winhand != "")
	 {
		winhand = "";
	 }
  }
  TCasinoVPData &cd = GetCasPD(activeplayer)->VPData;
  int16 session = cd.CurrentSession;
  TCVPSession &cs = cd.Sessions[session];
  cs.TotalCashWon -= coinsplayed*coinsize;
  if(winnerpaid == 0)
  {
	 cd.Cumulative -= coinsplayed*coinsize;
	 cs.CurrentLosingStreak++;
	 cs.CurrentWinStreak = 0;
	 cs.Losses++;
	 cs.GarbageHands++;
	 if(cs.CurrentLosingStreak > cs.LosingStreak)
	 {
		cs.LosingStreak = cs.CurrentLosingStreak;
	 }
	 if((cs.StartingCash + cs.TotalCashWon) < cs.PeakLoss)
	 {
		cs.PeakLoss = cs.StartingCash + cs.TotalCashWon;
	 }
  }
  else
  {
	 cd.Cumulative += winnerpaid*coinsize;
	 cs.TotalCashWon += winnerpaid*coinsize;
	 cs.CurrentWinStreak++;
	 cs.CurrentLosingStreak = 0;
	 if(cs.CurrentWinStreak > cs.WinStreak)
	 {
		cs.WinStreak = cs.CurrentWinStreak;
	 }
	 if(winnerpaid*coinsize > cs.LargestWin)
	 {
		cs.LargestWin = winnerpaid*coinsize;
	 }
	 if((cs.StartingCash + cs.TotalCashWon) > cs.PeakWin)
	 {
		cs.PeakWin = cs.StartingCash + cs.TotalCashWon;
	 }
  }
  BankCashDisplay->SetNum(GetCash(activeplayer));
  return winnerpaid;
}// winner
//*******************************************************************
int16 TACVPVPGLord::AddCoins()
{
  if(GetCash(activeplayer) == 0 && credits == 0)
  {
	 if(coinsplayed > 0)
	 {
		  PModeWin->MessageBox("You're out of money and may not make additional bets. Your current bets are your only hope.","Out of Cash",MB_OK);
	 }
    #if defined(KENO_COMPILE)
	 else if(GetCasPD(activeplayer)->IsActiveKenoTicket())
	 {
		PModeWin->MessageBox("You're out of money and may not bet. Your only hope is that one of your Keno tickets pays off.","Out of Cash",MB_OK);
	 }
    #endif
	 else
	 {
		PModeWin->MessageBox("You've hit rock bottom. Your gambler is bankrupt. Select GAMBLER MANAGEMENT under the FILE menu to create or select a new gambler.","Bankrupt!",MB_OK);
	 }
	 return 1;
  }
  if(coinsplayed < maxbet)
  {
	 SubCash(activeplayer,coinsize);
	 coinsplayed++;
  }
  else
  {
	 if(coinsplayed == maxbet)   // Not a needed check, oh well...
	 {
		SubCash(activeplayer,coinsize);
		credits++;
	 }
  }
  BankCashDisplay->SetNum(GetCash(activeplayer));
  return 1;
}
//*******************************************************************
int16 TACVPVPGLord::CashOut()
{
  return 1;
}
//*******************************************************************
int16 TACVPVPGLord::Bet1()
{
  if((GetCash(activeplayer) == 0 || GetCash(activeplayer) < coinsize) && credits == 0)
  {
	 if(GetCash(activeplayer) < coinsize && GetCash(activeplayer) > 0)
	 {
		PModeWin->MessageBox("You don't have enough money to bet more.","Not Enough",MB_OK);
	 }
	 else if(coinsplayed > 0)
	 {
		  PModeWin->MessageBox("You're out of money and may not make additional bets. Your current bets are your only hope.","Out of Cash",MB_OK);
	 }
    #if defined(KENO_COMPILE)
	 else if(GetCasPD(activeplayer)->IsActiveKenoTicket())
	 {
		PModeWin->MessageBox("You're out of money and may not bet. Your only hope is that one of your Keno tickets pays off.","Out of Cash",MB_OK);
	 }
    #endif
	 else
	 {
		PModeWin->MessageBox("You've hit rock bottom. Your gambler is bankrupt. Select Create/Delete under the FILE menu to create or select a new gambler.","Bankrupt!",MB_OK);
	 }
	 return 1;
  }
  int16 session = GetCasPD(activeplayer)->VPData.CurrentSession;
  TCVPSession &cs = GetCasPD(activeplayer)->VPData.Sessions[session];

	if(credits > 0)
	{
     if(SubGameType == cvpRaiseJokersWild)
     {
       BackG->NoShow();
       VertLite2->ClearRows();
       VertLite2->NoShow();
     }
	  credits--;
	  coinsplayed++;
	  CoinsPlayed->SetNum(coinsplayed);
	  VertLite->ClearRows();
	  WinRatio->SetColumn(coinsplayed);
     WinRatio->PlaySound(5);
	  Credits->SetNum(credits);
	  Button3->ShowVoidUp();
	  cs.TotalBetsCash += coinsize;

	  if(credits == 0)
	  {
		 Button0->ShowGray();
	  }
	  WinPaid->SetNum(0);
	  BankCashDisplay->SetNum(GetCash(activeplayer));
	  return 1;
	}
	if (GetCash(activeplayer) >= coinsize)
	{
     if(SubGameType == cvpRaiseJokersWild)
     {
       BackG->NoShow();
       VertLite2->ClearRows();
       VertLite2->NoShow();
     }
	  SubCash(activeplayer,coinsize);
	  coinsplayed++;
	  cs.TotalBetsCash += coinsize;
	  CoinsPlayed->SetNum(coinsplayed);
	  VertLite->ClearRows();
	  WinRatio->SetColumn(coinsplayed);
     WinRatio->PlaySound(0);
	  Credits->SetNum(credits);
	  Button3->ShowVoidUp();
	  WinPaid->SetNum(0);
	}
	BankCashDisplay->SetNum(GetCash(activeplayer));
	return 1;
}
//*******************************************************************
int16 TACVPVPGLord::BetTP1()
{
  if(GetCash(activeplayer)+(credits*coinsize) < coinsize*3)
  {
	 if(GetCash(activeplayer) < coinsize*3 && GetCash(activeplayer) > 0)
	 {
		PModeWin->MessageBox("You don't have enough money to bet more.","Not Enough",MB_OK);
	 }
	 else if(coinsplayed > 0)
	 {
		  PModeWin->MessageBox("You're out of money and may not make additional bets. Your current bets are your only hope.","Out of Cash",MB_OK);
	 }
	 else
	 {
		PModeWin->MessageBox("You've hit rock bottom. Your gambler is bankrupt. Select Create/Delete under the FILE menu to create or select a new gambler.","Bankrupt!",MB_OK);
	 }
	 return 1;
  }
  int16 session = GetCasPD(activeplayer)->VPData.CurrentSession;
  TCVPSession &cs = GetCasPD(activeplayer)->VPData.Sessions[session];

	if(credits > 2)
	{
	  credits -= 3;
	  coinsplayed++;
	  CoinsPlayed->SetNum(coinsplayed);
	  VertLite->ClearRows();
	  WinRatio->SetColumn(coinsplayed);
     WinRatio->PlaySound(5);
	  Credits->SetNum(credits);
	  Button3->ShowVoidUp();
	  cs.TotalBetsCash += coinsize;

	  if(credits == 0)
	  {
		 Button0->ShowGray();
	  }
	  WinPaid->SetNum(0);
	  WinPaidTop->SetNum(0);
	  WinPaidBot->SetNum(0);
	  WinPaidMid->SetNum(0);
	  BankCashDisplay->SetNum(GetCash(activeplayer));
	  return 1;
	}
	if (GetCash(activeplayer)+(credits*coinsize) >= coinsize*3)
	{
	  SubCash(activeplayer,(coinsize*3)-(coinsize*credits));
	  coinsplayed++;
     credits = 0;
	  cs.TotalBetsCash += coinsize*3;
	  CoinsPlayed->SetNum(coinsplayed);
	  VertLite->ClearRows();
	  WinRatio->SetColumn(coinsplayed);
     WinRatio->PlaySound(0);
	  Credits->SetNum(credits);
	  Button3->ShowVoidUp();
	  WinPaid->SetNum(0);
     WinPaidTop->SetNum(0);
     WinPaidMid->SetNum(0);
     WinPaidBot->SetNum(0);
	}
	BankCashDisplay->SetNum(GetCash(activeplayer));
	return 1;
}
//*******************************************************************
int16 TACVPVPGLord::BetRD1()
{
  if((GetCash(activeplayer) == 0 || GetCash(activeplayer) < coinsize) && credits == 0)
  {
	 if(GetCash(activeplayer) < coinsize && GetCash(activeplayer) > 0)
	 {
		PModeWin->MessageBox("You don't have enough money to bet more.","Not Enough",MB_OK);
	 }
	 else if(Dcoinsplayed > 0)
	 {
		  PModeWin->MessageBox("You're out of money and may not make additional bets. Your current bets are your only hope.","Out of Cash",MB_OK);
	 }
    #if defined(KENO_COMPILE)
	 else if(GetCasPD(activeplayer)->IsActiveKenoTicket())
	 {
		PModeWin->MessageBox("You're out of money and may not bet. Your only hope is that one of your Keno tickets pays off.","Out of Cash",MB_OK);
	 }
    #endif
	 else
	 {
		PModeWin->MessageBox("You've hit rock bottom. Your gambler is bankrupt. Select Create/Delete under the FILE menu to create or select a new gambler.","Bankrupt!",MB_OK);
	 }
	 return 1;
  }
  int16 session = GetCasPD(activeplayer)->VPData.CurrentSession;
  TCVPSession &cs = GetCasPD(activeplayer)->VPData.Sessions[session];

	if(credits > 0)
	{
	  credits--;
	  Dcoinsplayed++;
	  CoinsPlayed->SetNum(Dcoinsplayed+coinsplayed);
     VertLite->ClearRows();
     VertLite2->ClearRows();
	  WinRatio->SetColumn(Dcoinsplayed+coinsplayed);
     WinRatio->PlaySound(5);
	  Credits->SetNum(credits);
	  Button3->ShowVoidUp();
	  cs.TotalBetsCash += coinsize;

	  if(credits == 0)
	  {
		 Button0->ShowGray();
	  }
	  WinPaid->SetNum(0);
	  BankCashDisplay->SetNum(GetCash(activeplayer));
     if(coinsplayed+Dcoinsplayed > 5){BackG->Show();}
	  return 1;
	}
	if (GetCash(activeplayer) >= coinsize)
	{
	  SubCash(activeplayer,coinsize);
	  Dcoinsplayed++;
	  cs.TotalBetsCash += coinsize;
	  CoinsPlayed->SetNum(Dcoinsplayed+coinsplayed);
     VertLite->ClearRows();
     VertLite2->ClearRows();
	  WinRatio->SetColumn(Dcoinsplayed+coinsplayed);
     WinRatio->PlaySound(0);
	  Credits->SetNum(credits);
	 // Button3->ShowVoidUp();
	  WinPaid->SetNum(0);
	}
	BankCashDisplay->SetNum(GetCash(activeplayer));
   if(coinsplayed+Dcoinsplayed > 5){BackG->Show();}
	return 1;
}
//*******************************************************************
int16 TACVPVPGLord::BetD1()
{
  if((GetCash(activeplayer) == 0 || GetCash(activeplayer) < coinsize) && credits == 0)
  {
	 if(GetCash(activeplayer) < coinsize && GetCash(activeplayer) > 0)
	 {
		PModeWin->MessageBox("You don't have enough money to bet more.","Not Enough",MB_OK);
	 }
	 else if(Dcoinsplayed > 0)
	 {
		  PModeWin->MessageBox("You're out of money and may not make additional bets. Your current bets are your only hope.","Out of Cash",MB_OK);
	 }
    #if defined(KENO_COMPILE)
	 else if(GetCasPD(activeplayer)->IsActiveKenoTicket())
	 {
		PModeWin->MessageBox("You're out of money and may not bet. Your only hope is that one of your Keno tickets pays off.","Out of Cash",MB_OK);
	 }
    #endif
	 else
	 {
		PModeWin->MessageBox("You've hit rock bottom. Your gambler is bankrupt. Select Create/Delete under the FILE menu to create or select a new gambler.","Bankrupt!",MB_OK);
	 }
	 return 1;
  }
  int16 session = GetCasPD(activeplayer)->VPData.CurrentSession;
  TCVPSession &cs = GetCasPD(activeplayer)->VPData.Sessions[session];

	if(credits > 0)
	{
	  credits--;
	  Dcoinsplayed++;
	  CoinsPlayed->SetNum(Dcoinsplayed);
	  VertLite->ClearRows();
	  WinRatio->SetColumn(Dcoinsplayed);
     WinRatio->PlaySound(5);
	  Credits->SetNum(credits);
	  Button3->ShowVoidUp();
	  cs.TotalBetsCash += coinsize;

	  if(credits == 0)
	  {
		 Button0->ShowGray();
	  }
	  WinPaid->SetNum(0);
	  BankCashDisplay->SetNum(GetCash(activeplayer));
	  return 1;
	}
	if (GetCash(activeplayer) >= coinsize)
	{
	  SubCash(activeplayer,coinsize);
	  Dcoinsplayed++;
	  cs.TotalBetsCash += coinsize;
	  CoinsPlayed->SetNum(Dcoinsplayed);
	  VertLite->ClearRows();
	  WinRatio->SetColumn(Dcoinsplayed);
     WinRatio->PlaySound(0);
	  Credits->SetNum(credits);
	  Button3->ShowVoidUp();
	  WinPaid->SetNum(0);
	}
	BankCashDisplay->SetNum(GetCash(activeplayer));
	return 1;
}
//*******************************************************************
bool TACVPVPGLord::BetX(TMoney x)
{
  if(GetCash(activeplayer) == 0 && credits == 0)
  {
	 if(coinsplayed > 0)
	 {
		  PModeWin->MessageBox("You're out of money and may not make additional bets. Your current bets are your only hope.","Out of Cash",MB_OK);
	 }
    #if defined(KENO_COMPILE)
	 else if(GetCasPD(activeplayer)->IsActiveKenoTicket())
	 {
		PModeWin->MessageBox("You're out of money and may not bet. Your only hope is that one of your Keno tickets pays off.","Out of Cash",MB_OK);
	 }
    #endif
	 else
	 {
		PModeWin->MessageBox("You've hit rock bottom. Your gambler is bankrupt. Select Create/Delete under the FILE menu to create or select a new gambler.","Bankrupt!",MB_OK);
	 }
	 return true;
  }
  int32 bm=0;
	bm = ((int32)(x/coinsize));
	int16 session = GetCasPD(activeplayer)->VPData.CurrentSession;
   TCVPSession &cs = GetCasPD(activeplayer)->VPData.Sessions[session];

	if (GetCash(activeplayer) >= x && bm > 0)
	{
	  SubCash(activeplayer,(coinsize * bm));
	  cs.TotalBetsCash += (coinsize * bm);

	  //???Chips->SetNum(GetCash(activeplayer));
	  if(coinsplayed == 5)
	  {
		 credits += bm;
		 Credits->SetNum(credits);
		 Button4->ShowVoidUp();
	  }
	  else if(coinsplayed+bm < 6)
	  {
		 coinsplayed += bm;
		 CoinsPlayed->SetNum(coinsplayed);
		 WinRatio->SetColumn(coinsplayed,true);
		 //???switch((int32)bm)
		 /*{
			case 1  : VPSounds->PlaySound(0);break;
			case 2  : VPSounds->PlaySound(1);break;
			case 3  : VPSounds->PlaySound(2);break;
			case 4  : VPSounds->PlaySound(3);break;
			case 5  : VPSounds->PlaySound(4);break;
			default : if(bm > 5) {VPSounds->PlaySound(5);}
		 } */
	  }
	  else if(coinsplayed+bm > 5)
	  {
		 bm -= BET1 - (int32)coinsplayed;
		//??? switch(BET1 - (int32)coinsplayed)
		 /*{
			case 1  : VPSounds->PlaySound(0);break;
			case 2  : VPSounds->PlaySound(1);break;
			case 3  : VPSounds->PlaySound(2);break;
			case 4  : VPSounds->PlaySound(3);break;
			case 5  : VPSounds->PlaySound(4);break;
			default : if(bm > 5) {VPSounds->PlaySound(5);}
		 } */
		 credits += bm;
		 Credits->SetNum(credits);
		 coinsplayed = BET1;
		 CoinsPlayed->SetNum(coinsplayed);
		 WinRatio->SetColumn(coinsplayed,true);
		 Button4->ShowVoidUp();
	  }
	  VertLite->ClearRows();
	  WinPaid->SetNum(0);
	  Button3->ShowVoidUp();
	  BankCashDisplay->SetNum(GetCash(activeplayer));
	  if(credits != 0){Button4->ShowVoidUp();}
	  return true;
	}
	return false;
}
//*******************************************************************
int16 TACVPVPGLord::BetDMax()
{
  if((GetCash(activeplayer) == 0 || GetCash(activeplayer) < coinsize) && credits == 0)
  {
	 if(GetCash(activeplayer) < coinsize && GetCash(activeplayer) > 0)
	 {
		PModeWin->MessageBox("You don't have enough money to bet more.","Not Enough",MB_OK);
	 }
	 else if(Dcoinsplayed > 0)
	 {
		  PModeWin->MessageBox("You're out of money and may not make additional bets. Your current bets are your only hope.","Out of Cash",MB_OK);
	 }
    #if defined(KENO_COMPILE)
	 else if(GetCasPD(activeplayer)->IsActiveKenoTicket())
	 {
		PModeWin->MessageBox("You're out of money and may not bet. Your only hope is that one of your Keno tickets pays off.","Out of Cash",MB_OK);
	 }
    #endif
	 else
	 {
		PModeWin->MessageBox("You've hit rock bottom. Your gambler is bankrupt. Select Create/Delete under the FILE menu to create or select a new gambler.","Bankrupt!",MB_OK);
	 }
	 return 0;
  }
  int cp = Dcoinsplayed;
  int16 creditsoundoffset=0;
  int16 session = GetCasPD(activeplayer)->VPData.CurrentSession;
  TCVPSession &cs = GetCasPD(activeplayer)->VPData.Sessions[session];

  if(credits >= coinsplayed-Dcoinsplayed)
  {
	 credits -= coinsplayed-Dcoinsplayed;
	 switch((int32)(coinsplayed - Dcoinsplayed))
	 {
			case 1  : WinRatio->PlaySound(5);creditsoundoffset=2;break;
			case 2  : WinRatio->PlaySound(6);creditsoundoffset=4;break;
			case 3  : WinRatio->PlaySound(7);creditsoundoffset=5;break;
			case 4  : WinRatio->PlaySound(8);creditsoundoffset=6;break;
			case 5  : WinRatio->PlaySound(9);creditsoundoffset=7;break;
	 }
	 cs.TotalBetsCash += (coinsplayed-Dcoinsplayed)*coinsize;

	 Dcoinsplayed = coinsplayed;
	 CoinsPlayed->SetNum(Dcoinsplayed);
	 Credits->SetNum(credits);
	//??? Button3->ShowVoidUp();
	 if(credits == 0)
	 {
		Button0->ShowGray();
	 }
	 Button1->ShowGray();
	 Button2->ShowGray();
	 VertLite->ClearRows();
	 WinPaid->SetNum(0);
    isCoin = false;
	 return (Dcoinsplayed - cp);
  }
  else
  {
	 Dcoinsplayed += credits;
	 cs.TotalBetsCash += credits*coinsize;
	//??? Button3->ShowVoidUp();
	 Button1->ShowGray();
	 Button2->ShowGray();
	 Button0->ShowGray();
	 switch((int32)credits)
	 {
			case 1  : WinRatio->PlaySound(5);creditsoundoffset=0;break;
			case 2  : WinRatio->PlaySound(6);creditsoundoffset=2;break;
			case 3  : WinRatio->PlaySound(7);creditsoundoffset=3;break;
			case 4  : WinRatio->PlaySound(8);creditsoundoffset=4;break;
			case 5  : WinRatio->PlaySound(9);creditsoundoffset=5;break;
	 }
    WinRatio->startFrame += (int16)credits;
	 credits = 0;                          // Could make a little faster
  }

  if (GetCash(activeplayer) > (coinsplayed - Dcoinsplayed) * coinsize)
  {
	 SubCash(activeplayer,(coinsplayed - Dcoinsplayed) * coinsize);
    cs.TotalBetsCash += (coinsplayed-Dcoinsplayed)*coinsize;
    switch((int32)(coinsplayed - Dcoinsplayed))
	 {
			case 1  : WinRatio->PlaySound(0,creditsoundoffset);break;
			case 2  : WinRatio->PlaySound(1,creditsoundoffset);break;
			case 3  : WinRatio->PlaySound(2,creditsoundoffset);break;
			case 4  : WinRatio->PlaySound(3,creditsoundoffset);break;
			case 5  : WinRatio->PlaySound(4,creditsoundoffset);break;
	 }
    Dcoinsplayed = coinsplayed;
	 CoinsPlayed->SetNum(Dcoinsplayed);
    Credits->SetNum(credits);
  }
  else
  {
	 TMoney x;
	 x = GetCash(activeplayer) / coinsize;
    x.Truncate();
	 Dcoinsplayed += x;
	 SubCash(activeplayer,coinsize*x);
	 cs.TotalBetsCash += coinsize*x;

	 CoinsPlayed->SetNum(Dcoinsplayed);
	switch((int32)(x))
	 {
			case 1  : WinRatio->PlaySound(0,creditsoundoffset);break;
			case 2  : WinRatio->PlaySound(1,creditsoundoffset);break;
			case 3  : WinRatio->PlaySound(2,creditsoundoffset);break;
			case 4  : WinRatio->PlaySound(3,creditsoundoffset);break;
			case 5  : WinRatio->PlaySound(4,creditsoundoffset);break;
	 }
	 //?? if(coinsplayed > 0)
	//??? {
	//  	WinRatio->SetColumn(coinsplayed,true);
	// }
    Credits->SetNum(credits);
  }
  if(Dcoinsplayed > cp)
  {
	 VertLite->ClearRows();
	 WinPaid->SetNum(0);
  }
  else if(Dcoinsplayed == cp)
  {
	 //string allin("Your All In");
	 //StatusBar->ShowMessageString(allin,12);
  }
  BankCashDisplay->SetNum(GetCash(activeplayer));
  return (Dcoinsplayed - cp);
}
//*******************************************************************
int16 TACVPVPGLord::BetRDMax()
{
  if((GetCash(activeplayer) == 0 || GetCash(activeplayer) < coinsize) && credits == 0)
  {
	 if(GetCash(activeplayer) < coinsize && GetCash(activeplayer) > 0)
	 {
		PModeWin->MessageBox("You don't have enough money to bet more.","Not Enough",MB_OK);
	 }
	 else if(Dcoinsplayed > 0)
	 {
		  PModeWin->MessageBox("You're out of money and may not make additional bets. Your current bets are your only hope.","Out of Cash",MB_OK);
	 }
    #if defined(KENO_COMPILE)
	 else if(GetCasPD(activeplayer)->IsActiveKenoTicket())
	 {
		PModeWin->MessageBox("You're out of money and may not bet. Your only hope is that one of your Keno tickets pays off.","Out of Cash",MB_OK);
	 }
    #endif
	 else
	 {
		PModeWin->MessageBox("You've hit rock bottom. Your gambler is bankrupt. Select Create/Delete under the FILE menu to create or select a new gambler.","Bankrupt!",MB_OK);
	 }
	 return 0;
  }
  int cp = Dcoinsplayed;
  int16 creditsoundoffset=0;
  int16 session = GetCasPD(activeplayer)->VPData.CurrentSession;
  TCVPSession &cs = GetCasPD(activeplayer)->VPData.Sessions[session];

  if(credits >= coinsplayed-Dcoinsplayed)
  {
	 credits -= coinsplayed-Dcoinsplayed;
	 switch((int32)(coinsplayed - Dcoinsplayed))
	 {
			case 1  : WinRatio->PlaySound(5);creditsoundoffset=2;break;
			case 2  : WinRatio->PlaySound(6);creditsoundoffset=4;break;
			case 3  : WinRatio->PlaySound(7);creditsoundoffset=5;break;
			case 4  : WinRatio->PlaySound(8);creditsoundoffset=6;break;
			case 5  : WinRatio->PlaySound(9);creditsoundoffset=7;break;
	 }
	 cs.TotalBetsCash += (coinsplayed-Dcoinsplayed)*coinsize;

	 Dcoinsplayed = coinsplayed;
	 CoinsPlayed->SetNum(Dcoinsplayed+coinsplayed);
	 Credits->SetNum(credits);
	//??? Button3->ShowVoidUp();
	 if(credits == 0)
	 {
		Button0->ShowGray();
	 }
	 Button1->ShowGray();
	 Button2->ShowGray();
    VertLite->ClearRows();
    VertLite2->ClearRows();
	 WinPaid->SetNum(0);
    isCoin = false;
    if(coinsplayed+Dcoinsplayed > 5){BackG->Show();}
	 return (Dcoinsplayed - cp);
  }
  else
  {
	 Dcoinsplayed += credits;
	 cs.TotalBetsCash += credits*coinsize;
	//??? Button3->ShowVoidUp();
	 Button1->ShowGray();
	 Button2->ShowGray();
	 Button0->ShowGray();
	 switch((int32)credits)
	 {
			case 1  : WinRatio->PlaySound(5);creditsoundoffset=0;break;
			case 2  : WinRatio->PlaySound(6);creditsoundoffset=2;break;
			case 3  : WinRatio->PlaySound(7);creditsoundoffset=3;break;
			case 4  : WinRatio->PlaySound(8);creditsoundoffset=4;break;
			case 5  : WinRatio->PlaySound(9);creditsoundoffset=5;break;
	 }
    WinRatio->startFrame += (int16)credits;
	 credits = 0;                          // Could make a little faster
  }

  if (GetCash(activeplayer) > (coinsplayed - Dcoinsplayed) * coinsize)
  {
	 SubCash(activeplayer,(coinsplayed - Dcoinsplayed) * coinsize);
    cs.TotalBetsCash += (coinsplayed-Dcoinsplayed)*coinsize;
    switch((int32)(coinsplayed - Dcoinsplayed))
	 {
			case 1  : WinRatio->PlaySound(0,creditsoundoffset);break;
			case 2  : WinRatio->PlaySound(1,creditsoundoffset);break;
			case 3  : WinRatio->PlaySound(2,creditsoundoffset);break;
			case 4  : WinRatio->PlaySound(3,creditsoundoffset);break;
			case 5  : WinRatio->PlaySound(4,creditsoundoffset);break;
	 }
    Dcoinsplayed = coinsplayed;
	 CoinsPlayed->SetNum(Dcoinsplayed+coinsplayed);
    Credits->SetNum(credits);
  }
  else
  {
	 TMoney x;
	 x = GetCash(activeplayer) / coinsize;
    x.Truncate();
	 Dcoinsplayed += x;
	 SubCash(activeplayer,coinsize*x);
	 cs.TotalBetsCash += coinsize*x;

	 CoinsPlayed->SetNum(Dcoinsplayed+coinsplayed);
	switch((int32)(x))
	 {
			case 1  : WinRatio->PlaySound(0,creditsoundoffset);break;
			case 2  : WinRatio->PlaySound(1,creditsoundoffset);break;
			case 3  : WinRatio->PlaySound(2,creditsoundoffset);break;
			case 4  : WinRatio->PlaySound(3,creditsoundoffset);break;
			case 5  : WinRatio->PlaySound(4,creditsoundoffset);break;
	 }
    Credits->SetNum(credits);
  }
  if(Dcoinsplayed > cp)
  {
    VertLite2->ClearRows();
	 VertLite->ClearRows();
	 WinPaid->SetNum(0);
  }
  else if(Dcoinsplayed == cp)
  {
	 //string allin("Your All In");
	 //StatusBar->ShowMessageString(allin,12);
  }
  if(coinsplayed+Dcoinsplayed > 5){BackG->Show();}
  BankCashDisplay->SetNum(GetCash(activeplayer));
  return (Dcoinsplayed - cp);
}
//*******************************************************************
int16 TACVPVPGLord::BetMax()
{
  if((GetCash(activeplayer) == 0 || GetCash(activeplayer) < coinsize) && credits == 0)
  {
	 if(GetCash(activeplayer) < coinsize && GetCash(activeplayer) > 0)
	 {
		PModeWin->MessageBox("You don't have enough money to bet more.","Not Enough",MB_OK);
	 }
	 else if(coinsplayed > 0)
	 {
		  PModeWin->MessageBox("You're out of money and may not make additional bets. Your current bets are your only hope.","Out of Cash",MB_OK);
	 }
    #if defined(KENO_COMPILE)
	 else if(GetCasPD(activeplayer)->IsActiveKenoTicket())
	 {
		PModeWin->MessageBox("You're out of money and may not bet. Your only hope is that one of your Keno tickets pays off.","Out of Cash",MB_OK);
	 }
    #endif
	 else
	 {
		PModeWin->MessageBox("You've hit rock bottom. Your gambler is bankrupt. Select Create/Delete under the FILE menu to create or select a new gambler.","Bankrupt!",MB_OK);
	 }
	 return 0;
  }
  int cp = coinsplayed;
  int16 creditsoundoffset=0;
  int16 session = GetCasPD(activeplayer)->VPData.CurrentSession;
  TCVPSession &cs = GetCasPD(activeplayer)->VPData.Sessions[session];

  if(credits >= maxbet-coinsplayed)
  {
	 credits -= maxbet-coinsplayed;
	 switch((int32)(maxbet - coinsplayed))
	 {
			case 1  : WinRatio->PlaySound(5);creditsoundoffset=2;break;
			case 2  : WinRatio->PlaySound(6);creditsoundoffset=4;break;
			case 3  : WinRatio->PlaySound(7);creditsoundoffset=5;break;
			case 4  : WinRatio->PlaySound(8);creditsoundoffset=6;break;
			case 5  : WinRatio->PlaySound(9);creditsoundoffset=7;break;
         case 6  : WinRatio->PlaySound(13);creditsoundoffset=8;break;
			case 7  : WinRatio->PlaySound(14);creditsoundoffset=9;break;
			case 8  : WinRatio->PlaySound(15);creditsoundoffset=10;break;
	 }
	 cs.TotalBetsCash += (maxbet-coinsplayed)*coinsize;

	 coinsplayed = maxbet;
	 CoinsPlayed->SetNum(coinsplayed);
	 Credits->SetNum(credits);
	 Button3->ShowVoidUp();
	 if(credits == 0)
	 {
		Button0->ShowGray();
	 }
	 Button1->ShowGray();
	 Button2->ShowGray();
    if(SubGameType == cvpRaiseJokersWild)
    {
     BackG->NoShow();
     VertLite2->ClearRows();
    }
	 VertLite->ClearRows();
	 WinPaid->SetNum(0);
    isCoin = false;
	 return (coinsplayed - cp);
  }
  else
  {
	 coinsplayed += credits;
	 cs.TotalBetsCash += credits*coinsize;
	 Button3->ShowVoidUp();
	 Button1->ShowGray();
	 Button2->ShowGray();
	 Button0->ShowGray();
	 switch((int32)credits)
	 {
			case 1  : WinRatio->PlaySound(5);creditsoundoffset=0;break;
			case 2  : WinRatio->PlaySound(6);creditsoundoffset=2;break;
			case 3  : WinRatio->PlaySound(7);creditsoundoffset=3;break;
			case 4  : WinRatio->PlaySound(8);creditsoundoffset=4;break;
			case 5  : WinRatio->PlaySound(9);creditsoundoffset=5;break;
         case 6  : WinRatio->PlaySound(13);creditsoundoffset=6;break;
			case 7  : WinRatio->PlaySound(14);creditsoundoffset=7;break;
			case 8  : WinRatio->PlaySound(15);creditsoundoffset=8;break;
	 }
    WinRatio->startFrame += (int16)credits;
	 credits = 0;                          // Could make a little faster
  }

  if (GetCash(activeplayer) > (maxbet - coinsplayed) * coinsize)
  {
	 SubCash(activeplayer,(maxbet - coinsplayed) * coinsize);
    cs.TotalBetsCash += (maxbet-coinsplayed)*coinsize;
    switch((int32)(maxbet - coinsplayed))
	 {
			case 1  : WinRatio->PlaySound(0,creditsoundoffset );break;
			case 2  : WinRatio->PlaySound(1,creditsoundoffset );break;
			case 3  : WinRatio->PlaySound(2,creditsoundoffset );break;
			case 4  : WinRatio->PlaySound(3,creditsoundoffset );break;
			case 5  : WinRatio->PlaySound(4,creditsoundoffset );break;
         case 6  : WinRatio->PlaySound(10,creditsoundoffset);break;
			case 7  : WinRatio->PlaySound(11,creditsoundoffset);break;
			case 8  : WinRatio->PlaySound(12,creditsoundoffset);break;
	 }
    coinsplayed = maxbet;
	 CoinsPlayed->SetNum(coinsplayed);
    Credits->SetNum(credits);
  }
  else
  {
	 TMoney x;
	 x = GetCash(activeplayer) / coinsize;
    x.Truncate();
	 coinsplayed += x;
	 SubCash(activeplayer,coinsize*x);
	 cs.TotalBetsCash += coinsize*x;

	 CoinsPlayed->SetNum(coinsplayed);
	switch((int32)(x))
	 {
			case 1  : WinRatio->PlaySound(0,creditsoundoffset);break;
			case 2  : WinRatio->PlaySound(1,creditsoundoffset);break;
			case 3  : WinRatio->PlaySound(2,creditsoundoffset);break;
			case 4  : WinRatio->PlaySound(3,creditsoundoffset);break;
			case 5  : WinRatio->PlaySound(4,creditsoundoffset);break;
         case 6  : WinRatio->PlaySound(10,creditsoundoffset);break;
			case 7  : WinRatio->PlaySound(11,creditsoundoffset);break;
			case 8  : WinRatio->PlaySound(12,creditsoundoffset);break;
	 }
    Credits->SetNum(credits);
  }
  if(coinsplayed > cp)
  {
    if(SubGameType == cvpRaiseJokersWild)
    {
     BackG->NoShow();
     VertLite2->ClearRows();
    }
	 VertLite->ClearRows();
	 WinPaid->SetNum(0);
  }
  else if(coinsplayed == cp)
  {
	 //string allin("Your All In");
	 //StatusBar->ShowMessageString(allin,12);
  }
  BankCashDisplay->SetNum(GetCash(activeplayer));
  return (coinsplayed - cp);
}
//*******************************************************************
int16 TACVPVPGLord::BetTPMax()
{
  if(GetCash(activeplayer)+(credits*coinsize) < coinsize*3)
  {
	 if(GetCash(activeplayer)+(credits*coinsize) < coinsize*3)
	 {
		PModeWin->MessageBox("You don't have enough money to bet more.","Not Enough",MB_OK);
	 }
	 else if(coinsplayed > 0)
	 {
		  PModeWin->MessageBox("You're out of money and may not make additional bets. Your current bets are your only hope.","Out of Cash",MB_OK);
	 }
	 else
	 {
		PModeWin->MessageBox("You've hit rock bottom. Your gambler is bankrupt. Select Create/Delete under the FILE menu to create or select a new gambler.","Bankrupt!",MB_OK);
	 }
	 return 0;
  }
  int cp = coinsplayed;
  int16 creditsoundoffset=0;
  int16 session = GetCasPD(activeplayer)->VPData.CurrentSession;
  TCVPSession &cs = GetCasPD(activeplayer)->VPData.Sessions[session];

  if(credits >= (maxbet-coinsplayed)*3)
  {
	 credits -= (maxbet-coinsplayed)*3;
	 switch((int32)(maxbet - coinsplayed))
	 {
			case 1  : WinRatio->PlaySound(5);creditsoundoffset=2;break;
			case 2  : WinRatio->PlaySound(6);creditsoundoffset=4;break;
			case 3  : WinRatio->PlaySound(7);creditsoundoffset=5;break;
			case 4  : WinRatio->PlaySound(8);creditsoundoffset=6;break;
			case 5  : WinRatio->PlaySound(9);creditsoundoffset=7;break;
	 }
	 cs.TotalBetsCash += (maxbet-coinsplayed)*coinsize*3;

	 coinsplayed = maxbet;
	 CoinsPlayed->SetNum(coinsplayed);
	 Credits->SetNum(credits);
	 Button3->ShowVoidUp();
	 if(credits == 0)
	 {
		Button0->ShowGray();
	 }
	 Button1->ShowGray();
	 Button2->ShowGray();
	 VertLite->ClearRows();
	 WinPaid->SetNum(0);
    WinPaidTop->SetNum(0);
    WinPaidMid->SetNum(0);
    WinPaidBot->SetNum(0);
    isCoin = false;
	 return (coinsplayed - cp);
  }
  else
  {
	 coinsplayed += (int32)credits/(int32)3;
	 cs.TotalBetsCash += coinsize*(((int32)credits/(int32)3)*3);
	 Button3->ShowVoidUp();
	 Button1->ShowGray();
	 Button2->ShowGray();
	 Button0->ShowGray();
	 switch((int32)credits/(int32)3)
	 {
			case 1  : WinRatio->PlaySound(5);creditsoundoffset=0;break;
			case 2  : WinRatio->PlaySound(6);creditsoundoffset=2;break;
			case 3  : WinRatio->PlaySound(7);creditsoundoffset=3;break;
			case 4  : WinRatio->PlaySound(8);creditsoundoffset=4;break;
			case 5  : WinRatio->PlaySound(9);creditsoundoffset=5;break;
	 }
    WinRatio->startFrame += (int16)credits/(int16)3;
	 credits = credits-((int32)credits/(int32)3)*3;                          // Could make a little faster
  }

  if (GetCash(activeplayer)+(credits*coinsize) > (maxbet-coinsplayed)*coinsize*3)
  {
	 SubCash(activeplayer,((maxbet-coinsplayed)*coinsize*3)-(credits*coinsize));
    cs.TotalBetsCash += (maxbet-coinsplayed)*coinsize*3;
    switch((int32)(maxbet - coinsplayed))
	 {
			case 1  : WinRatio->PlaySound(0,creditsoundoffset);break;
			case 2  : WinRatio->PlaySound(1,creditsoundoffset);break;
			case 3  : WinRatio->PlaySound(2,creditsoundoffset);break;
			case 4  : WinRatio->PlaySound(3,creditsoundoffset);break;
			case 5  : WinRatio->PlaySound(4,creditsoundoffset);break;
	 }
    coinsplayed = maxbet;
	 CoinsPlayed->SetNum(coinsplayed);
    credits = 0;
    Credits->SetNum(credits);
  }
  else
  {
	 TMoney x;
	 x = (GetCash(activeplayer)+(credits*coinsize))/(coinsize*3);
    x.Truncate();
	 coinsplayed += x;
	 SubCash(activeplayer,(coinsize*x)-(credits*coinsize));
	 cs.TotalBetsCash += (coinsize*x)-(credits*coinsize);

	 CoinsPlayed->SetNum(coinsplayed);
	switch((int32)(x))
	 {
			case 1  : WinRatio->PlaySound(0,creditsoundoffset);break;
			case 2  : WinRatio->PlaySound(1,creditsoundoffset);break;
			case 3  : WinRatio->PlaySound(2,creditsoundoffset);break;
			case 4  : WinRatio->PlaySound(3,creditsoundoffset);break;
			case 5  : WinRatio->PlaySound(4,creditsoundoffset);break;
	 }
    if(x>0){credits=0;}
    Credits->SetNum(credits);
  }
  if(coinsplayed > cp)
  {
	 VertLite->ClearRows();
	 WinPaid->SetNum(0);
    WinPaidTop->SetNum(0);
    WinPaidMid->SetNum(0);
    WinPaidBot->SetNum(0);
  }
  else if(coinsplayed == cp)
  {
	 //string allin("Your All In");
	 //StatusBar->ShowMessageString(allin,12);
  }
  BankCashDisplay->SetNum(GetCash(activeplayer));
  return (coinsplayed - cp);
}
//*******************************************************************
void TACVPVPGLord::HoldCard(int16 cardnum)
{
  if ((cardnum < 0) || (cardnum > 4)) {return;}

  if(GetCasPlayer(activeplayer)->pHand->hold[cardnum] == 1)
  {
	 GetCasPlayer(activeplayer)->pHand->hold[cardnum] = 0;
  }
  else
  {
	 GetCasPlayer(activeplayer)->pHand->hold[cardnum] = 1;
  }

  bool held = GetCasPlayer(activeplayer)->pHand->hold[cardnum];
  CardSprite->Hold(held,cardnum);
}
//*******************************************************************
void TACVPVPGLord::HoldCardTrip(int16 cardnum)
{
  if ((cardnum < 0) || (cardnum > 4)) {return;}

  TopCardSprite->ShowFlip(cardnum);
  MidCardSprite->ShowSilentFlip(cardnum);

  if(GetCasPlayer(activeplayer)->pHand->hold[cardnum] == 1)
  {
    ShowTripleBack = false;
	 TripTopHand->hold[cardnum] = 1;
    TripMidHand->hold[cardnum] = 1;
    TripMidHand->cards[cardnum].name = GetCasPlayer(activeplayer)->pHand->cards[cardnum].name;
    TripMidHand->cards[cardnum].suit = GetCasPlayer(activeplayer)->pHand->cards[cardnum].suit;
    TripTopHand->cards[cardnum].name = GetCasPlayer(activeplayer)->pHand->cards[cardnum].name;
    TripTopHand->cards[cardnum].suit = GetCasPlayer(activeplayer)->pHand->cards[cardnum].suit;
  }
  else
  {
    ShowTripleBack = true;
    TripTopHand->hold[cardnum] = 0;
    TripMidHand->hold[cardnum] = 0;
  }
}
//*******************************************************************
int16 TACVPVPGLord::ShowWinner()
{
  credits += (winnerpaid)/(coinsize);
  return 1;
}
//*******************************************************************
//*******************************************************************
void TACVPVPGLord::SetUIDSStrings()
{
  strSounds = GetAppString(idsSounds);
  strVertLite = GetAppString(idsVertLite);
  strDrawBack = GetAppString(idsDrawBack);
  strCoinPay = GetAppString(idsCoinPay);
  strChips = GetAppString(idsChips);
  strCard1 = GetAppString(idsCard1);
  if (idsCard2 > 0)
  {
    strCard2 = GetAppString(idsCard2);
    if (idsCard3 > 0)
    {
      strCard3 = GetAppString(idsCard3);
      if (idsCard4 > 0)
      {
        strCard4 = GetAppString(idsCard4);
        if (idsCard5 > 0)
        {
          strCard5 = GetAppString(idsCard5);
        }
      }
    }
  }
  strNP1 = GetAppString(idsNP1);
  strNP2 = GetAppString(idsNP2);
  strNP3 = GetAppString(idsNP3);
  strCoinsPlayed = GetAppString(idsCoinsPlayed);
  strCredits = GetAppString(idsCredits);
  strWinPaid = GetAppString(idsWinPaid);
  strButton0 = GetAppString(idsButton0);
  strButton1 = GetAppString(idsButton1);
  strButton2 = GetAppString(idsButton2);
  strButton3 = GetAppString(idsButton3);
  strButton4 = GetAppString(idsButton4);
  strButton5 = GetAppString(idsButton5);
  strButton6 = GetAppString(idsButton6);
  strButton7 = GetAppString(idsButton7);
  strButton8 = GetAppString(idsButton8);
  strButton9 = GetAppString(idsButton9);
  strWinRatio = GetAppString(idsWinRatio);
  strBankCash = GetAppString(idsBankCash);
  strValue    = GetAppString(idsValue);
  if (idsGrid > 0)
  {
    strGrid    = GetAppString(idsGrid);
  }
  if (idsVertLite2 > 0)
  {
    strVertLite2    = GetAppString(idsVertLite2);
  }
  if (idsFAss > 0)
  {
    strFAss    = GetAppString(idsFAss);
  }
  if (idsLook > 0)
  {
    strLook    = GetAppString(idsLook);
  }
  if (idsBackG > 0)
  {
    strBackG    = GetAppString(idsBackG);
  }
  if (idsProg1 > 0)
  {
    strProg1    = GetAppString(idsProg1);
  }
  if (idsProg2 > 0)
  {
    strProg2    = GetAppString(idsProg2);
  }
  if (idsProg3 > 0)
  {
    strProg3    = GetAppString(idsProg3);
  }
  if (idsProg4 > 0)
  {
    strProg4    = GetAppString(idsProg4);
  }
  if (idsJackpotBonus > 0)
  {
    strJackpotBonus  = GetAppString(idsJackpotBonus);
  }
  if (idsChest > 0)
  {
    strChest  = GetAppString(idsChest);
  }
  if (idsWheel > 0)
  {
    strWheel  = GetAppString(idsWheel);
  }
  if (idsProgressive > 0)
  {
    strProgressive = GetAppString(idsProgressive);
  }
}
//*******************************************************************
void TACVPVPGLord::SetupSprites()
{
  //???if (idsSounds > 0 && VPSounds == NULL)        {SpriteError("VPSounds",strSounds);}
 //??? if (idsDrawBack > 0 && DrawBack == NULL)        {SpriteError("DrawBack",strDrawBack);}
  if (CoinPay == NULL)         {SpriteError("CoinPay",strCoinPay);}
  if (VertLite == NULL)        {SpriteError("VertLite",strVertLite);}
  if (idsVertLite2 > 0 && VertLite2 == NULL)        {SpriteError("VertLite2",strVertLite2);}
  //???if (NamePlate1 == NULL)      {SpriteError("NamePlate1",strNP1);}
 //??? if (idsNP2 > 0 && NamePlate2 == NULL)      {SpriteError("NamePlate2",strNP2);}
  //???if (idsNP3 > 0 && NamePlate3 == NULL)      {SpriteError("NamePlate3",strNP3);}
  if (BankCashDisplay == NULL) {SpriteError("BankCashDisplay",strBankCash);}
  if (idsButton0 > 0 && Button0 == NULL)         {SpriteError("Button0",strButton0);}
  if (idsButton1 > 0 && Button1 == NULL)         {SpriteError("Button1",strButton1);}
  if (idsButton2 > 0 && Button2 == NULL)         {SpriteError("Button2",strButton2);}
  if (idsButton3 > 0 && Button3 == NULL)         {SpriteError("Button3",strButton3);}
  if (idsButton4 > 0 && Button4 == NULL)         {SpriteError("Button4",strButton4);}
  if (idsButton5 > 0 && Button5 == NULL)         {SpriteError("Button5",strButton5);}
  if (idsButton6 > 0 && Button6 == NULL)         {SpriteError("Button6",strButton6);}
  if (idsButton7 > 0 && Button7 == NULL)         {SpriteError("Button7",strButton7);}
  if (idsButton8 > 0 && Button8 == NULL)         {SpriteError("Button8",strButton8);}
  if (idsButton9 > 0 && Button9 == NULL)         {SpriteError("Button9",strButton9);}
  if (CardSprite == NULL)  {SpriteError("Card Sprite 1",strCard1);}
  if (SubGameType == cvpTriplePlay)
  {
    if (TopCardSprite == NULL)  {SpriteError("Card Sprite top",strCard1);}
    if (MidCardSprite == NULL)  {SpriteError("Card Sprite bot",strCard1);}
    if (WinPaidTop == NULL)         {SpriteError("Win Paid Top",strWinPaidTop);}
    if (WinPaidMid == NULL)         {SpriteError("Win Paid Mid",strWinPaidMid);}
    if (WinPaidBot == NULL)         {SpriteError("Win Paid Bot",strWinPaidBot);}
  }
  if (CoinsPlayed == NULL)     {SpriteError("Coins Played Nums",strCoinsPlayed);}
  if (WinRatio == NULL)        {SpriteError("Win Ratio Bars",strWinRatio);}
  if (WinPaid == NULL)         {SpriteError("Win Paid Nums",strWinPaid);}
  if (Credits == NULL)         {SpriteError("Credits Nums",strCredits);}
  if (idsJackpotBonus > 0 && JackpotBonus == NULL)           {SpriteError("JPot B",strJackpotBonus);}
  if (Value == NULL)         {SpriteError("Value",strValue);}
  if (idsGrid > 0  && Grid  == NULL)           {SpriteError("Grid",strGrid);}
  if (idsFAss > 0  && FAss  == NULL)           {SpriteError("FAss",strFAss);}
  if (idsLook > 0  && Look  == NULL)           {SpriteError("Look",strLook);}
  if (idsBackG > 0 && BackG == NULL)           {SpriteError("Prog1",strBackG);}
  if (idsProg1 > 0 && Prog1 == NULL)           {SpriteError("Prog1",strProg1);}
  if (idsProg2 > 0 && Prog2 == NULL)           {SpriteError("Prog2",strProg2);}
  if (idsProg3 > 0 && Prog3 == NULL)           {SpriteError("Prog3",strProg3);}
  if (idsProg4 > 0 && Prog4 == NULL)           {SpriteError("Prog4",strProg4);}
  if (idsWheel > 0 && Wheel == NULL)           {SpriteError("Wheel",strWheel);}
  if (idsChest > 0 && Chest == NULL)           {SpriteError("Chest",strChest);}
  //
  if (idsProgressive > 0)
  {
    if (Progressive == NULL) {SpriteError("Progressive",strProgressive);}
    ActivateSpriteNow(Progressive);
  }

  //???if (idsSounds > 0) {ActivateSpriteNow(VPSounds);}
  VertLite->Start(GetFUC());
 //??? if (idsDrawBack > 0) {DrawBack->Start(GetFUC());}
  CoinPay->Start(GetFUC());

  BankCashDisplay->Start(GetFUC());
  if (!GetFW()->GetHandleShowMenu())
  {
	 //???Button5->PButton->CAD.SetCurrentFrame(-1);
	 Button5->NoShow();
	 Button5->PButtonResponder->Remove();
  }
  ActivateSpriteNow(Value);
  ActivateSpriteNow(Title);
  if(idsGrid  > 0)   {ActivateSpriteNow(Grid);}
  if(idsVertLite2  > 0)   {ActivateSpriteNow(VertLite2);}
  if(idsFAss  > 0)   {ActivateSpriteNow(FAss);}
  if(idsLook  > 0)   {ActivateSpriteNow(Look);}
  if(idsBackG > 0)   {ActivateSpriteNow(BackG);}
  if(idsProg1 > 0)   {ActivateSpriteNow(Prog1);}
  if(idsProg2 > 0)   {ActivateSpriteNow(Prog2);}
  if(idsProg3 > 0)   {ActivateSpriteNow(Prog3);}
  if(idsProg4 > 0)   {ActivateSpriteNow(Prog4);}
  if(idsJackpotBonus > 0)   {ActivateSpriteNow(JackpotBonus);}
  if(idsWheel > 0)   {ActivateSpriteNow(Wheel);}
  if(idsChest > 0)   {ActivateSpriteNow(Chest);}
  if(idsButton0 > 0) {ActivateSpriteNow(Button0);}
  if(idsButton1 > 0) {ActivateSpriteNow(Button1);}
  if(idsButton2 > 0) {ActivateSpriteNow(Button2);}
  if(idsButton3 > 0) {ActivateSpriteNow(Button3);}
  if(idsButton4 > 0) {ActivateSpriteNow(Button4);}
  if(idsButton5 > 0) {ActivateSpriteNow(Button5);}
  if(idsButton6 > 0) {ActivateSpriteNow(Button6);}
  if(idsButton7 > 0) {ActivateSpriteNow(Button7);}
  if(idsButton8 > 0) {ActivateSpriteNow(Button8);}
  if(idsButton9 > 0) {ActivateSpriteNow(Button9);}
  CoinsPlayed->Start(GetFUC());
  WinRatio->Start(GetFUC());
  Credits->Start(GetFUC());
  WinPaid->Start(GetFUC());

  CardSprite->Start(GetFUC());

  if (SubGameType == cvpTriplePlay)
  {
    TopCardSprite->Start(GetFUC());
    MidCardSprite->Start(GetFUC());
    WinPaidTop->Start(GetFUC());
    WinPaidMid->Start(GetFUC());
    WinPaidBot->Start(GetFUC());
  }

  //???if (idsChips > 0) {Chips->Start(GetFUC());}
  NamePlate1->Start(GetFUC());
  if (NamePlate2 != NULL) {NamePlate2->Start(GetFUC());}
  if (NamePlate3 != NULL) {NamePlate3->Start(GetFUC());}
}
//*******************************************************************
void TACVPVPGLord::CleanupSprites()
{
  CoinsPlayed->NoShow(); // is this necessary ??
}
//*******************************************************************
bool TACVPVPGLord::AddCredits(int16 addcredits)
{
  TMoney amount = addcredits;
  if(GetCasPlayer(activeplayer) && (GetCash(activeplayer) >= amount*coinsize))
  {
	 credits += (long)amount;
	 SubCash(activeplayer,amount*coinsize);
	 BankCashDisplay->SetNum(GetCash(activeplayer));
	 Credits->SetNum(credits);
	 Button0->ShowVoidUp();
  }
  else
  {
	 PModeWin->MessageBox("You do not have that much.","Bankroll",MB_OK);
  }
  return true;
}
//*******************************************************************
void TACVPVPGLord::EnableButton(int16 button)
{
  switch(button)
  {
	 case 0  : if(Button0 != NULL)
              {
                Button0->Enabled = true;
              }
              break;
	 case 1  : if(Button1 != NULL)
              {
                Button1->Enabled = true;
              }
              break;
	 case 2  : if(Button2 != NULL)
              {
                Button2->Enabled = true;
              }
              break;
	 case 3  : if(Button3 != NULL)
              {
                Button3->Enabled = true;
              }
              break;
	 case 4  : if(Button4 != NULL)
              {
                Button4->Enabled = true;
              }
              break;
	 case 5  : if(Button5 != NULL)
              {
                Button5->Enabled = true;
              }
              break;
	 case 6  : if(Button6 != NULL)
              {
                Button6->Enabled = true;
              }
              break;
	 case 7  : if(Button7 != NULL)
              {
                Button7->Enabled = true;
              }
              break;
	 case 8  : if(Button8 != NULL)
              {
                Button8->Enabled = true;
              }
              break;
    case 9  : if(Button9 != NULL)
              {
                Button9->Enabled = true;
              }
              break;
  }
}
//*******************************************************************
void TACVPVPGLord::DisEnableButton(int16 button)
{
  switch(button)
  {
	 case 0  : if(Button0 != NULL)
              {
                Button0->Enabled = false;
              }
              break;
	 case 1  : if(Button1 != NULL)
              {
                Button1->Enabled = false;
              }
              break;
	 case 2  : if(Button2 != NULL)
              {
                Button2->Enabled = false;
              }
              break;
	 case 3  : if(Button3 != NULL)
              {
                Button3->Enabled = false;
              }
              break;
	 case 4  : if(Button4 != NULL)
              {
                Button4->Enabled = false;
              }
              break;
	 case 5  : if(Button5 != NULL)
              {
                Button5->Enabled = false;
              }
              break;
	 case 6  : if(Button6 != NULL)
              {
                Button6->Enabled = false;
              }
              break;
	 case 7  : if(Button7 != NULL)
              {
                Button7->Enabled = false;
              }
              break;
	 case 8  : if(Button8 != NULL)
              {
                Button8->Enabled = false;
              }
              break;
    case 9  : if(Button9 != NULL)
              {
                Button9->Enabled = false;
              }
              break;
  }
}
//*******************************************************************
void TACVPVPGLord::FreezeAllButtons()
{
  if(Button0 != NULL)
  {
    Button0->Freeze = true;
  }
  if(Button1 != NULL)
  {
    Button1->Freeze = true;
  }
  if(Button2 != NULL)
  {
    Button2->Freeze = true;
  }
  if(Button3 != NULL)
  {
    Button3->Freeze = true;
  }
  if(Button4 != NULL)
  {
    Button4->Freeze = true;
  }
  if(Button5 != NULL)
  {
    Button5->Freeze = true;
  }
  if(Button6 != NULL)
  {
    Button6->Freeze = true;
  }
  if(Button7 != NULL)
  {
    Button7->Freeze = true;
  }
  if(Button8 != NULL)
  {
    Button8->Freeze = true;
  }
  if(Button9 != NULL)
  {
    Button9->Freeze = true;
  }
}
//*******************************************************************
void TACVPVPGLord::UnFreezeAllButtons()
{
  if(Button0 != NULL)
  {
    Button0->Freeze = false;
  }
  if(Button1 != NULL)
  {
    Button1->Freeze = false;
  }
  if(Button2 != NULL)
  {
    Button2->Freeze = false;
  }
  if(Button3 != NULL)
  {
    Button3->Freeze = false;
  }
  if(Button4 != NULL)
  {
    Button4->Freeze = false;
  }
  if(Button5 != NULL)
  {
    Button5->Freeze = false;
  }
  if(Button6 != NULL)
  {
    Button6->Freeze = false;
  }
  if(Button7 != NULL)
  {
    Button7->Freeze = false;
  }
  if(Button8 != NULL)
  {
    Button8->Freeze = false;
  }
  if(Button9 != NULL)
  {
    Button9->Freeze = false;
  }
}
//*******************************************************************
void TACVPVPGLord::EnableAllButtons()
{
  if(Button0 != NULL)
  {
    Button0->Enabled = true;
  }
  if(Button1 != NULL)
  {
    Button1->Enabled = true;
  }
  if(Button2 != NULL)
  {
    Button2->Enabled = true;
  }
  if(Button3 != NULL)
  {
    Button3->Enabled = true;
  }
  if(Button4 != NULL)
  {
    Button4->Enabled = true;
  }
  if(Button5 != NULL)
  {
    Button5->Enabled = true;
  }
  if(Button6 != NULL)
  {
    Button6->Enabled = true;
  }
  if(Button7 != NULL)
  {
    Button7->Enabled = true;
  }
  if(Button8 != NULL)
  {
    Button8->Enabled = true;
  }
  if(Button9 != NULL)
  {
    Button9->Enabled = true;
  }
}
//*******************************************************************
void TACVPVPGLord::DisEnableAllButtons()
{
  if(Button0 != NULL)
  {
    Button0->Enabled = false;
  }
  if(Button1 != NULL)
  {
    Button1->Enabled = false;
  }
  if(Button2 != NULL)
  {
    Button2->Enabled = false;
  }
  if(Button3 != NULL)
  {
    Button3->Enabled = false;
  }
  if(Button4 != NULL)
  {
    Button4->Enabled = false;
  }
  if(Button5 != NULL)
  {
    Button5->Enabled = false;
  }
  if(Button6 != NULL)
  {
    Button6->Enabled = false;
  }
  if(Button7 != NULL)
  {
    Button7->Enabled = false;
  }
  if(Button8 != NULL)
  {
    Button8->Enabled = false;
  }
  if(Button9 != NULL)
  {
    Button9->Enabled = false;
  }
}
//*******************************************************************
#pragma argsused
bool TACVPVPGLord::Respond(int16 button,int16 info,void *pdata)
{
  if(info == -5)//gray button hit
  {
	 if(button == idButton3 && (GetCash(activeplayer) > coinsize || credits > 0 || shutdownstate != 0))
	 {return false;}
	 if(button == idButton3 && GetCash(activeplayer) == 0 && credits == 0 && shutdownstate == 0)
	 {
		  PModeWin->MessageBox("You've hit rock bottom. Your gambler is bankrupt. Select GAMBLER MANAGEMENT under the FILE menu to create or select a new gambler.","Bankrupt!",MB_OK);
	 }
	 if(button == idButton8){return false;}
	 return true;
  }
  ButtonInfo = info;
  if(info != -1)
  {
	 switch(button)
	 { //??? TCmMsg(CM_ASKEXPERTSTATISTICS).PostToFW();
	 case idButton0  : ButtonHit[idButton0]=true;break;
	 case idButton1  : ButtonHit[idButton1]=true;break;
	 case idButton2  : ButtonHit[idButton2]=true;break;
	 case idButton3  : ButtonHit[idButton3]=true;break;
	 case idButton4  : ButtonHit[idButton4]=true;break;
	 case idButton5  : ButtonHit[idButton5]=true;break;
	 case idButton6  : ButtonHit[idButton6]=true;break;
	 case idButton7  : ButtonHit[idButton7]=true;break;
	 case idButton8  : ButtonHit[idButton8]=true;break;
	 case idButton9  : ButtonHit[idButton9]=true;break;
	 default           : WaitOnButtonDown = false;break;
	 }
  }
  return true;
}
//*******************************************************************
void TACVPVPGLord::ButtonClear(int16 button)
{
  switch(button)
  {
	 case idButton0  : ButtonHit[idButton0]=false;break;
	 case idButton1  : ButtonHit[idButton1]=false;break;
	 case idButton2  : ButtonHit[idButton2]=false;break;
	 case idButton3  : ButtonHit[idButton3]=false;break;//PModeWin->ModeHelp();
	 case idButton4  : ButtonHit[idButton4]=false;PModeWin->PostCommandToFW(CM_GAME_ACVP_LOBBY);break;
	 case idButton5  : ButtonHit[idButton5]=false;GetFW()->CmShowMenu();break;
	 case idButton6  : ButtonHit[idButton6]=false;break;
	 case idButton7  : ButtonHit[idButton7]=false;break;
	 case idButton8  : ButtonHit[idButton8]=false;break;
	 case idButton9  : ButtonHit[idButton9]=false;break;
	 default           : WaitOnButtonDown = false;break;
  }
  WaitOnButtonDown = false;
  return;
}
//*******************************************************************
bool TACVPVPGLord::Respond(TResponder &responder)
{
  if (PState == NULL) {return true;}
  //else {return false;}
//
  switch (responder.GetID())
  {
//	 case idAddCoins  :  return (((TVPLordState *)PState)->AddCoin(responder));
	 case idHoldCard0 :  return (((TVPLordState *)PState)->HoldCard0(responder));
	 case idHoldCard1 :  return (((TVPLordState *)PState)->HoldCard1(responder));
	 case idHoldCard2 :  return (((TVPLordState *)PState)->HoldCard2(responder));
	 case idHoldCard3 :  return (((TVPLordState *)PState)->HoldCard3(responder));
	 case idHoldCard4 :  return (((TVPLordState *)PState)->HoldCard4(responder));
	// case idSpeedClick:  return (((TVPLordState *)PState)->SpeedClick(responder));
    case idSpeedClick:
          //if(IsCycle)
			 //{
			 //	SwitchDenom(Denom[CurrentDenomNum]);// IsCycle set to false in SwitchDenom()
			 //	GetFW()->NotifyDenomSwitch(coinsize);
			 //	return false;
          //}
          return (((TVPLordState *)PState)->SpeedClick(responder));
	 case idAddCoins:   //denom really
          if(ChangeActivePlayersOk)
			 {
			   if(responder.GetResponseEvent() == reLUp)
				{
				  IsCycle = false;
				  CycleDenom();
				  GameDenom = coinsize;
				  GetFW()->NotifyDenomSwitch(coinsize);
				  IsCycle = true;
              SwitchDenom(Denom[CurrentDenomNum]);// IsCycle set to false in SwitchDenom()
				  GetFW()->NotifyDenomSwitch(coinsize);
            }
          }
          return true;
    //
//	 case idOneChip            :  return true;//(((TVPLordState *)PState)->OneChip(responder));
//	 case idFiveChip           :  return true;//(((TVPLordState *)PState)->FiveChip(responder));
//	 case idTwentyFiveChip     :  return true;//(((TVPLordState *)PState)->TwentyFiveChip(responder));
//	 case idOneHundredChip     :  return true;//(((TVPLordState *)PState)->OneHundredChip(responder));
//	 case idOneThouChip        :  return true;//((TVPLordState *)PState)->OneThouChip(responder));
//	 case idTenThouChip        :  return true;//(((TVPLordState *)PState)->TenThouChip(responder));
//	 case idNamePlate          :  if(shutdownstate){return true;}
//											return (((TVPLordState *)PState)->NamePlate(responder));
	 default     :  return false;
  }
}
//*******************************************************************
int16 TACVPVPGLord::SetMult()
{
   if(GetCasPlayer(activeplayer)->pHand->highhand >= ThreeKind)
   {
    if(SubGameType == cvpWheelDeal)
    {
      MultPayoff = Wheel->SetMult();
      return Wheel->RollWheel();
    }
    else if(SubGameType == cvpTreasureTrove)
    {
      MultPayoff = Chest->SetMult();
      return Chest->RollChest();
    }
    else if(SubGameType == cvpJackpotBonus &&
            GetCasPlayer(activeplayer)->pHand->highhand == FourKind)
    {
      JackpotBonusAmount = JackpotBonus->SetMult();
      return JackpotBonus->RollBonus();
    }
    else
    {
      MultPayoff = 1;
      return 0;
    }
   }
   else
   {
     MultPayoff = 1;
     return 0;
   }
}
//*******************************************************************
void TACVPVPGLord::CleanupResponders()
{
  for(int16 i=0;i<NumResponders;i++)
  {
    delete Responders[i];
  }
}
//*******************************************************************
void TACVPVPGLord::SetupJackpots()
{
 TCasinoGameData *pgamedata = GetCasGameData();
 dword interval1=0,interval2=0,interval3=0,interval4=0;
 ProgressiveBaseAmount = double(coinsize * 4000.0);

 if(SubGameType == cvpRoyalProg)
 {
  if(coinsize == 0.10)
  {
   progressive1 = pgamedata->ProgressiveRoyalClub010Amount;
   interval1 = TTime().Seconds() - pgamedata->ProgressiveRoyalClub010EndTime;
   progressive2 = pgamedata->ProgressiveRoyalDiamond010Amount;
   interval2 = TTime().Seconds() - pgamedata->ProgressiveRoyalDiamond010EndTime;
   progressive3 = pgamedata->ProgressiveRoyalHeart010Amount;
   interval3 = TTime().Seconds() - pgamedata->ProgressiveRoyalHeart010EndTime;
   progressive4 = pgamedata->ProgressiveRoyalSpade010Amount;
   interval4 = TTime().Seconds() - pgamedata->ProgressiveRoyalSpade010EndTime;
  }
  if(coinsize == 1.0)
  {
   progressive1 = pgamedata->ProgressiveRoyalClub1Amount;
   interval1 = TTime().Seconds() - pgamedata->ProgressiveRoyalClub1EndTime;
   progressive2 = pgamedata->ProgressiveRoyalDiamond1Amount;
   interval2 = TTime().Seconds() - pgamedata->ProgressiveRoyalDiamond1EndTime;
   progressive3 = pgamedata->ProgressiveRoyalHeart1Amount;
   interval3 = TTime().Seconds() - pgamedata->ProgressiveRoyalHeart1EndTime;
   progressive4 = pgamedata->ProgressiveRoyalSpade1Amount;
   interval4 = TTime().Seconds() - pgamedata->ProgressiveRoyalSpade1EndTime;
  }
  if(coinsize == 25.0)
  {
   progressive1 = pgamedata->ProgressiveRoyalClub25Amount;
   interval1 = TTime().Seconds() - pgamedata->ProgressiveRoyalClub25EndTime;
   progressive2 = pgamedata->ProgressiveRoyalDiamond25Amount;
   interval2 = TTime().Seconds() - pgamedata->ProgressiveRoyalDiamond25EndTime;
   progressive3 = pgamedata->ProgressiveRoyalHeart25Amount;
   interval3 = TTime().Seconds() - pgamedata->ProgressiveRoyalHeart25EndTime;
   progressive4 = pgamedata->ProgressiveRoyalSpade25Amount;
   interval4 = TTime().Seconds() - pgamedata->ProgressiveRoyalSpade25EndTime;
  }
 }
 if(SubGameType == cvpTripleProg)
 {
  if(coinsize == 0.05)
  {
   progressive1 = pgamedata->ProgressiveRoyalFlush05Amount;
   interval1 = TTime().Seconds() - pgamedata->ProgressiveRoyalFlush05EndTime;
   progressive2 = pgamedata->Progressive4Aces05Amount;
   interval2 = TTime().Seconds() - pgamedata->Progressive4Aces05EndTime;
   progressive3 = pgamedata->Progressive4234s05Amount;
   interval3 = TTime().Seconds() - pgamedata->Progressive4234s05EndTime;
  }
  if(coinsize == 0.25)
  {
   progressive1 = pgamedata->ProgressiveRoyalFlush025Amount;
   interval1 = TTime().Seconds() - pgamedata->ProgressiveRoyalFlush025EndTime;
   progressive2 = pgamedata->Progressive4Aces025Amount;
   interval2 = TTime().Seconds() - pgamedata->Progressive4Aces025EndTime;
   progressive3 = pgamedata->Progressive4234s025Amount;
   interval3 = TTime().Seconds() - pgamedata->Progressive4234s025EndTime;
  }
  if(coinsize == 1.0)
  {
   progressive1 = pgamedata->ProgressiveRoyalFlush1Amount;
   interval1 = TTime().Seconds() - pgamedata->ProgressiveRoyalFlush1EndTime;
   progressive2 = pgamedata->Progressive4Aces1Amount;
   interval2 = TTime().Seconds() - pgamedata->Progressive4Aces1EndTime;
   progressive3 = pgamedata->Progressive4234s1Amount;
   interval3 = TTime().Seconds() - pgamedata->Progressive4234s1EndTime;
  }
  if(coinsize == 10.0)
  {
   progressive1 = pgamedata->ProgressiveRoyalFlush10Amount;
   interval1 = TTime().Seconds() - pgamedata->ProgressiveRoyalFlush10EndTime;
   progressive2 = pgamedata->Progressive4Aces10Amount;
   interval2 = TTime().Seconds() - pgamedata->Progressive4Aces10EndTime;
   progressive3 = pgamedata->Progressive4234s10Amount;
   interval3 = TTime().Seconds() - pgamedata->Progressive4234s10EndTime;
  }
 }
 if(SubGameType == cvpJacksProgII)
 {
  if(coinsize == 0.10)
  {
   progressive1 = pgamedata->ProgressiveJacks010Amount;
   interval1 = TTime().Seconds() - pgamedata->ProgressiveJacks010EndTime;
  }
  if(coinsize == 0.25)
  {
   progressive1 = pgamedata->ProgressiveJacks025Amount;
   interval1 = TTime().Seconds() - pgamedata->ProgressiveJacks025EndTime;
  }
  if(coinsize == 1.0)
  {
   progressive1 = pgamedata->ProgressiveJacks1Amount;
   interval1 = TTime().Seconds() - pgamedata->ProgressiveJacks1EndTime;
  }
  if(coinsize == 5.0)
  {
   progressive1 = pgamedata->ProgressiveJacks5Amount;
   interval1 = TTime().Seconds() - pgamedata->ProgressiveJacks5EndTime;
  }
  if(coinsize == 50.0)
  {
   progressive1 = pgamedata->ProgressiveJacks50Amount;
   interval1 = TTime().Seconds() - pgamedata->ProgressiveJacks50EndTime;
  }
 }
 if(SubGameType == cvpDeucesWildProg)
 {
  if(coinsize == 0.05)
  {
   progressive1 = pgamedata->ProgressiveDeuces05Amount;
   interval1 = TTime().Seconds() - pgamedata->ProgressiveDeuces05EndTime;
  }
  if(coinsize == 1.0)
  {
   progressive1 = pgamedata->ProgressiveDeuces1Amount;
   interval1 = TTime().Seconds() - pgamedata->ProgressiveDeuces1EndTime;
  }
  if(coinsize == 5.0)
  {
   progressive1 = pgamedata->ProgressiveDeuces5Amount;
   interval1 = TTime().Seconds() - pgamedata->ProgressiveDeuces5EndTime;
  }
 }
 if(SubGameType == cvpJokersWildProg)
 {
  if(coinsize == 0.05)
  {
   progressive1 = pgamedata->ProgressiveJokerWild05Amount;
   interval1 = TTime().Seconds() - pgamedata->ProgressiveJokerWild05EndTime;
  }
  if(coinsize == 0.25)
  {
   progressive1 = pgamedata->ProgressiveJokerWild025Amount;
   interval1 = TTime().Seconds() - pgamedata->ProgressiveJokerWild025EndTime;
  }
  if(coinsize == 1.0)
  {
   progressive1 = pgamedata->ProgressiveJokerWild1Amount;
   interval1 = TTime().Seconds() - pgamedata->ProgressiveJokerWild1EndTime;
  }
  if(coinsize == 100.0)
  {
   progressive1 = pgamedata->ProgressiveJokerWild100Amount;
   interval1 = TTime().Seconds() - pgamedata->ProgressiveJokerWild100EndTime;
  }
 }
 if(SubGameType == cvpPowerProg)
 {
  if(coinsize == 0.25)
  {
   progressive1 = pgamedata->ProgressivePowerFH025Amount;
   interval1 = TTime().Seconds() - pgamedata->ProgressivePowerFH025EndTime;
  }
  if(coinsize == 1.0)
  {
   progressive1 = pgamedata->ProgressivePowerFH1Amount;
   interval1 = TTime().Seconds() - pgamedata->ProgressivePowerFH1EndTime;
  }
  if(coinsize == 50.0)
  {
   progressive1 = pgamedata->ProgressivePowerFH50Amount;
   interval1 = TTime().Seconds() - pgamedata->ProgressivePowerFH50EndTime;
  }
 }

 ProgressiveMaxAmount  = 9999995.0;
 ProgressiveIncrement = (coinsize / 91);
 IncAdd2= (ProgressiveIncrement*.3)/(random(100)+1);
 IncAdd3= (ProgressiveIncrement*.3)/(random(100)+1);
 IncAdd4= (ProgressiveIncrement*.3)/(random(100)+1);
 //////////////////////////////////////////////////////////////
 if(interval1 < 600 && interval1 > 0)
 {
  int i=0;
  interval1 = interval1/17;
  for(i=0;i<interval1;i++)
  {
    progressive1 += coinsize;
    if(progressive1 > ProgressiveMaxAmount){progressive1 = ProgressiveBaseAmount;}
  }
  if(random(300) == 1){progressive1 = ProgressiveBaseAmount;}
 }
 else if(interval1 < 600000l && interval1 > 0)
 {
  int i=0;
  interval1 = interval1/600;
  for(i=0;i<interval1;i++)
  {
    if(random(300) == 1)
    {progressive1 = ProgressiveBaseAmount;}
    progressive1 += coinsize;
    if(progressive1 > ProgressiveMaxAmount){progressive1 = ProgressiveBaseAmount;}
  }
 }
 else
 {
 	progressive1 = (ProgressiveBaseAmount + int32(random(int(ProgressiveBaseAmount))));
 }
 //////////////////////////////////////////////////////////////
if(SubGameType == cvpTripleProg)// || SubGameType == cvpRoyalProg)
{
 if(interval2 < 600 && interval2 > 0)
 {
  int i=0;
  interval2 = interval2/17;
  for(i=0;i<interval2;i++)
  {
    progressive2 += coinsize;
    if(progressive2 > ProgressiveMaxAmount){progressive2 = ProgressiveBaseAmount/8;}
  }
  if(random(300) == 1){progressive2 = ProgressiveBaseAmount/8;}
 }
 else if(interval2 < 600000l && interval2 > 0)
 {
  int i=0;
  interval2 = interval2/600;
  for(i=0;i<interval2;i++)
  {
    if(random(300) == 1)
    {progressive2 = ProgressiveBaseAmount/8;}
    progressive2 += coinsize;
    if(progressive2 > ProgressiveMaxAmount){progressive2 = ProgressiveBaseAmount/8;}
  }
 }
 else
 {
 	progressive2 = (ProgressiveBaseAmount/8 + int32(random(int(ProgressiveBaseAmount/8))));
 }
 //////////////////////////////////////////////////////////////
 if(interval3 < 600 && interval3 > 0)
 {
  int i=0;
  interval3 = interval3/17;
  for(i=0;i<interval3;i++)
  {
    progressive3 += coinsize;
    if(progressive3 > ProgressiveMaxAmount){progressive3 = ProgressiveBaseAmount/17;}
  }
  if(random(300) == 1){progressive3 = ProgressiveBaseAmount/17;}
 }
 else if(interval3 < 600000l && interval3 > 0)
 {
  int i=0;
  interval3 = interval3/600;
  for(i=0;i<interval3;i++)
  {
    if(random(300) == 1)
    {progressive3 = ProgressiveBaseAmount/17;}
    progressive3 += coinsize;
    if(progressive3 > ProgressiveMaxAmount){progressive3 = ProgressiveBaseAmount/17;}
  }
 }
 else
 {
 	progressive3 = (ProgressiveBaseAmount/17 + int32(random(int(ProgressiveBaseAmount/17))));
 }
}
if(SubGameType == cvpRoyalProg)
{
 if(interval2 < 600 && interval2 > 0)
 {
  int i=0;
  interval2 = interval2/17;
  for(i=0;i<interval2;i++)
  {
    progressive2 += coinsize;
    if(progressive2 > ProgressiveMaxAmount){progressive2 = ProgressiveBaseAmount;}
  }
  if(random(300) == 1){progressive2 = ProgressiveBaseAmount;}
 }
 else if(interval2 < 600000l && interval2 > 0)
 {
  int i=0;
  interval2 = interval2/600;
  for(i=0;i<interval2;i++)
  {
    if(random(300) == 1)
    {progressive2 = ProgressiveBaseAmount;}
    progressive2 += coinsize;
    if(progressive2 > ProgressiveMaxAmount){progressive2 = ProgressiveBaseAmount;}
  }
 }
 else
 {
 	progressive2 = (ProgressiveBaseAmount + int32(random(int(ProgressiveBaseAmount))));
 }
 //////////////////////////////////////////////////////////////
 if(interval3 < 600 && interval3 > 0)
 {
  int i=0;
  interval3 = interval3/17;
  for(i=0;i<interval3;i++)
  {
    progressive3 += coinsize;
    if(progressive3 > ProgressiveMaxAmount){progressive3 = ProgressiveBaseAmount;}
  }
  if(random(300) == 1){progressive3 = ProgressiveBaseAmount;}
 }
 else if(interval3 < 600000l && interval3 > 0)
 {
  int i=0;
  interval3 = interval3/600;
  for(i=0;i<interval3;i++)
  {
    if(random(300) == 1)
    {progressive3 = ProgressiveBaseAmount;}
    progressive3 += coinsize;
    if(progressive3 > ProgressiveMaxAmount){progressive3 = ProgressiveBaseAmount;}
  }
 }
 else
 {
 	progressive3 = (ProgressiveBaseAmount + int32(random(int(ProgressiveBaseAmount))));
 }
}
 //////////////////////////////////////////////////////////////
if(SubGameType == cvpRoyalProg)
{
 if(interval4 < 600 && interval4 > 0)
 {
  int i=0;
  interval4 = interval4/17;
  for(i=0;i<interval4;i++)
  {
    progressive4 += coinsize;
    if(progressive4 > ProgressiveMaxAmount){progressive4 = ProgressiveBaseAmount;}
  }
  if(random(300) == 1){progressive4 = ProgressiveBaseAmount;}
 }
 else if(interval4 < 600000l && interval4 > 0)
 {
  int i=0;
  interval4 = interval4/600;
  for(i=0;i<interval4;i++)
  {
    if(random(300) == 1)
    {progressive4 = ProgressiveBaseAmount;}
    progressive4 += coinsize;
    if(progressive4 > ProgressiveMaxAmount){progressive4 = ProgressiveBaseAmount;}
  }
 }
 else
 {
 	progressive4 = (ProgressiveBaseAmount + int32(random(int(ProgressiveBaseAmount))));
 }
}
}
//*******************************************************************
int16 TACVPVPGLord::InitVP()
{
  ActivateSpriteNow(Song);
  Title->NoShow();
  Button4->SetCurrentUpFrame(-1);
  Button4->SetCurrentDownFrame(0);
  Button5->SetCurrentUpFrame(0);
  Button5->SetCurrentDownFrame(1);
  Button6->SetCurrentUpFrame(-1);
  Button6->SetCurrentDownFrame(0);
  Button7->SetCurrentUpFrame(-1);
  Button7->SetCurrentDownFrame(1);
  if(SubGameType == cvpSuperDJackpot)
  {
    SetupGrid();
  }
  if(SubGameType == cvpRaiseJokersWild)
  {
    VertLite2->NoShow();
    BackG->NoShow();
  }
  DoubleBet = false;  // stud
  if(SubGameType == cvpFlushAssault)
  {
    DullWRatio = WinRatio;
    SetFlushAssault();
  }
  if(SubGameType == cvpCrazy8s)
  {
    maxbet = 8;
  }
  if(SubGameType == cvpBonusDeluxe || SubGameType == cvpDeucesWildBonus ||
     SubGameType == cvpDBonusPoker || SubGameType == cvpGamblersEdge    ||
     SubGameType == cvpTripleBonus || SubGameType == cvpDJacksOrBetter    )
  {
    IsDoubleType = true;
  }
  else if(SubGameType == cvpDDrawJB || SubGameType == cvpDDrawJokerPoker)
  {
    IsDDrawType = true;
  }
  else
  {
    IsNormalType = true;
  }
  if(Button8 != NULL)
  {Button8->PButtonResponder->Remove();}
  if(Button9 != NULL)
  {Button9->PButtonResponder->Remove();}

  if(SubGameType == cvpJackpotBonus)
  {
    JackpotBonus->InitBonus(random(7));
  }
  if(SubGameType == cvpWheelDeal)
  {
    Wheel->InitWheel(random(6));
  }
  if(SubGameType == cvpTreasureTrove)
  {
    Chest->InitChest(random(5));
  }
  if(SubGameType == cvpFreeLook)
  {
    Look->ShowBack();
  }
  Value->SetDenom(coinsize);
  if(BackG != NULL){BackG->NoShow();}
  Button3->PButtonResponder->SetCh2(VK_RETURN);
  //???Button5->PButtonResponder->SetCh('o');
  if (SubGameType==cvpJacksProgII || SubGameType==cvpPowerProg ||
      SubGameType==cvpJokersWildProg || SubGameType==cvpDeucesWildProg ||
      SubGameType==cvpRoyalProg || SubGameType==cvpTripleProg            )
  {
    SetupJackpots();
  }
  SetupActivePlayer(NextSlotNum(-1)); // -1 because order of checking
  if(GetCasPD(0))
  {
	 GetCasPD(0)->StartVPSession(SubGameType,GameDenom);
  }
  if(GetCasPD(1))
  {
	 GetCasPD(1)->StartVPSession(SubGameType,GameDenom);
  }
  if(GetCasPD(2))
  {
	 GetCasPD(2)->StartVPSession(SubGameType,GameDenom);
  }
  credits = 0;
  coinsplayed = 0;
  winnerpaid = 0;
  if(credits > 0)
  {
	 Button0->ShowVoidUp();
  }
  else
  {
	 Button0->ShowGray();
  }
  if (!GetFW()->GetHandleShowMenu())
  {
	 Button5->PButton->NoShow();
	 Button5->PButtonResponder->Remove();
  }
  else
  {
    Button5->ShowVoidUp();
  }
  return 1;
}
//*******************************************************************
void TACVPVPGLord::SwitchToPlayer(int16 player)
{
  if(GetCasPD(player))
  {
	 if(activeplayer != player && activeplayer != -1)
	 {
		credits += coinsplayed;
		coinsplayed = 0;
		CoinsPlayed->SetNum(0);
		GetCasPlayer(activeplayer)->credit = credits;
		credits = 0;
		Button3->ShowGray();
	  //???	GetCasPD(activeplayer)->Columns[0] = Chips->col1;
	  //	GetCasPD(activeplayer)->Columns[1] = Chips->col2;
	  //	GetCasPD(activeplayer)->Columns[2] = Chips->col3;
		//GetCasPD(activeplayer)->Columns[3] = Chips->col4;
		//GetCasPD(activeplayer)->Columns[4] = Chips->col5;
		//GetCasPD(activeplayer)->Columns[5] = Chips->col6;
	 }

	 if(activeplayer != player)
	 {
		switch(activeplayer)
		{
			 case 0 : NamePlate1->NoShowNamePlate();break;
			 case 1 : NamePlate2->NoShowNamePlate();break;
			 case 2 : NamePlate3->NoShowNamePlate();break;
		}
		activeplayer = player;
		BankCashDisplay->SetNum(GetCash(activeplayer));
		//???Chips->SetupCols(GetCasPD(player)->Cash,GetCasPD(player)->Columns[0],
			  //			  GetCasPD(player)->Columns[1],GetCasPD(player)->Columns[2],
				//		  GetCasPD(player)->Columns[3],GetCasPD(player)->Columns[4],
				 //		  GetCasPD(player)->Columns[5],false);
		credits = GetCasPlayer(player)->credit;
		GetCasPlayer(player)->credit = 0;
		Credits->SetNum(credits);
		if(GetCasPD(player)->Cash != 0)
		{
		  Button1->ShowVoidUp();
		  Button6->ShowVoidUp();
		}
		else
		{
		  Button1->ShowGray();
		  Button6->ShowGray();
		}
		if(GetNumActivePlayers() > 1)
		{
		  string name;
		  name = GetCasPD(player)->GetName();
		  switch(player)
		  {
			 case 0 : NamePlate1->ShowNamePlateString(name);break;
			 case 1 : NamePlate2->ShowNamePlateString(name);break;
			 case 2 : NamePlate3->ShowNamePlateString(name);break;
		  }
		}
	 }
	 if(credits != 0)
	 {
		Button0->ShowUp();
	 }
	 else
	 {
		Button0->ShowGray();
	 }
  }
}
//*******************************************************************
void TACVPVPGLord::CyclePlayers()
{
  if(activeplayer != -1)
  {
	 SwitchToPlayer(NextSlotNum(activeplayer));
  }
}
//*******************************************************************
void  TACVPVPGLord::ShuttingDown()
{
 	 if(GetCasPD(0))
	 {
		NotifyPlayerDeActivation(0);
	 }
	 if(GetCasPD(1))
	 {
		NotifyPlayerDeActivation(1);
	 }
	 if(GetCasPD(2))
	 {
		NotifyPlayerDeActivation(2);
	 }
    if(SubGameType == cvpJacksProgressive)
    {
      GetCasMW()->GetCasPlayerMgr()->GetCasinoGameDataPtr()->ProgressiveVPAmount = progressive;
      GetCasMW()->GetCasPlayerMgr()->GetCasinoGameDataPtr()->ProgressiveVPEndTime = TTime().Seconds();
    }
    if (SubGameType==cvpJacksProgII || SubGameType==cvpPowerProg ||
        SubGameType==cvpJokersWildProg || SubGameType==cvpDeucesWildProg ||
        SubGameType==cvpRoyalProg || SubGameType==cvpTripleProg            )
    {
      SaveJackpots();
    }
    if(SubGameType==cvpSuperDJackpot)
    {
      SaveGrid();
    }
}
//**********************************************************************
void  TACVPVPGLord::SaveJackpots()
{
  TCasinoGameData *pgamedata = GetCasGameData();

  if(SubGameType == cvpRoyalProg)
  {
  if(coinsize == 0.10)
  {
   pgamedata->ProgressiveRoyalClub010Amount     = progressive1;
   pgamedata->ProgressiveRoyalClub010EndTime    = TTime().Seconds();
   pgamedata->ProgressiveRoyalDiamond010Amount  = progressive2;
   pgamedata->ProgressiveRoyalDiamond010EndTime = TTime().Seconds();
   pgamedata->ProgressiveRoyalHeart010Amount    = progressive3;
   pgamedata->ProgressiveRoyalHeart010EndTime   = TTime().Seconds();
   pgamedata->ProgressiveRoyalSpade010Amount    = progressive4;
   pgamedata->ProgressiveRoyalSpade010EndTime   = TTime().Seconds();
  }
  if(coinsize == 1.0)
  {
   pgamedata->ProgressiveRoyalClub1Amount     = progressive1;
   pgamedata->ProgressiveRoyalClub1EndTime    = TTime().Seconds();
   pgamedata->ProgressiveRoyalDiamond1Amount  = progressive2;
   pgamedata->ProgressiveRoyalDiamond1EndTime = TTime().Seconds();
   pgamedata->ProgressiveRoyalHeart1Amount    = progressive3;
   pgamedata->ProgressiveRoyalHeart1EndTime   = TTime().Seconds();
   pgamedata->ProgressiveRoyalSpade1Amount    = progressive4;
   pgamedata->ProgressiveRoyalSpade1EndTime   = TTime().Seconds();
  }
  if(coinsize == 25.0)
  {
   pgamedata->ProgressiveRoyalClub25Amount     = progressive1;
   pgamedata->ProgressiveRoyalClub25EndTime    = TTime().Seconds();
   pgamedata->ProgressiveRoyalDiamond25Amount  = progressive2;
   pgamedata->ProgressiveRoyalDiamond25EndTime = TTime().Seconds();
   pgamedata->ProgressiveRoyalHeart25Amount    = progressive3;
   pgamedata->ProgressiveRoyalHeart25EndTime   = TTime().Seconds();
   pgamedata->ProgressiveRoyalSpade25Amount    = progressive4;
   pgamedata->ProgressiveRoyalSpade25EndTime   = TTime().Seconds();
  }
 }
 if(SubGameType == cvpTripleProg)
 {
  if(coinsize == 0.05)
  {
   pgamedata->ProgressiveRoyalFlush05Amount  = progressive1;
   pgamedata->ProgressiveRoyalFlush05EndTime = TTime().Seconds();
   pgamedata->Progressive4Aces05Amount       = progressive2;
   pgamedata->Progressive4Aces05EndTime      = TTime().Seconds();
   pgamedata->Progressive4234s05Amount       = progressive3;
   pgamedata->Progressive4234s05EndTime      = TTime().Seconds();
  }
  if(coinsize == 0.25)
  {
   pgamedata->ProgressiveRoyalFlush025Amount  = progressive1;
   pgamedata->ProgressiveRoyalFlush025EndTime = TTime().Seconds();
   pgamedata->Progressive4Aces025Amount       = progressive2;
   pgamedata->Progressive4Aces025EndTime      = TTime().Seconds();
   pgamedata->Progressive4234s025Amount       = progressive3;
   pgamedata->Progressive4234s025EndTime      = TTime().Seconds();
  }
  if(coinsize == 1.0)
  {
   pgamedata->ProgressiveRoyalFlush1Amount  = progressive1;
   pgamedata->ProgressiveRoyalFlush1EndTime = TTime().Seconds();
   pgamedata->Progressive4Aces1Amount       = progressive2;
   pgamedata->Progressive4Aces1EndTime      = TTime().Seconds();
   pgamedata->Progressive4234s1Amount       = progressive3;
   pgamedata->Progressive4234s1EndTime      = TTime().Seconds();
  }
  if(coinsize == 10.0)
  {
   pgamedata->ProgressiveRoyalFlush10Amount  = progressive1;
   pgamedata->ProgressiveRoyalFlush10EndTime = TTime().Seconds();
   pgamedata->Progressive4Aces10Amount       = progressive2;
   pgamedata->Progressive4Aces10EndTime      = TTime().Seconds();
   pgamedata->Progressive4234s10Amount       = progressive3;
   pgamedata->Progressive4234s10EndTime      = TTime().Seconds();
  }
 }
 if(SubGameType == cvpJacksProgII)
 {
  if(coinsize == 0.10)
  {
   pgamedata->ProgressiveJacks010Amount  = progressive1;
   pgamedata->ProgressiveJacks010EndTime = TTime().Seconds();
  }
  if(coinsize == 0.25)
  {
   pgamedata->ProgressiveJacks025Amount  = progressive1;
   pgamedata->ProgressiveJacks025EndTime = TTime().Seconds();
  }
  if(coinsize == 1.0)
  {
   pgamedata->ProgressiveJacks1Amount  = progressive1;
   pgamedata->ProgressiveJacks1EndTime = TTime().Seconds();
  }
  if(coinsize == 5.0)
  {
   pgamedata->ProgressiveJacks5Amount  = progressive1;
   pgamedata->ProgressiveJacks5EndTime = TTime().Seconds();
  }
  if(coinsize == 50.0)
  {
   pgamedata->ProgressiveJacks50Amount  = progressive1;
   pgamedata->ProgressiveJacks50EndTime = TTime().Seconds();
  }
 }
 if(SubGameType == cvpDeucesWildProg)
 {
  if(coinsize == 0.05)
  {
   pgamedata->ProgressiveDeuces05Amount  = progressive1;
   pgamedata->ProgressiveDeuces05EndTime = TTime().Seconds();
  }
  if(coinsize == 1.0)
  {
   pgamedata->ProgressiveDeuces1Amount  = progressive1;
   pgamedata->ProgressiveDeuces1EndTime = TTime().Seconds();
  }
  if(coinsize == 5.0)
  {
   pgamedata->ProgressiveDeuces5Amount  = progressive1;
   pgamedata->ProgressiveDeuces5EndTime = TTime().Seconds();
  }
 }
 if(SubGameType == cvpJokersWildProg)
 {
  if(coinsize == 0.05)
  {
   pgamedata->ProgressiveJokerWild05Amount  = progressive1;
   pgamedata->ProgressiveJokerWild05EndTime = TTime().Seconds();
  }
  if(coinsize == 0.25)
  {
   pgamedata->ProgressiveJokerWild025Amount  = progressive1;
   pgamedata->ProgressiveJokerWild025EndTime = TTime().Seconds();
  }
  if(coinsize == 1.0)
  {
   pgamedata->ProgressiveJokerWild1Amount  = progressive1;
   pgamedata->ProgressiveJokerWild1EndTime = TTime().Seconds();
  }
  if(coinsize == 100.0)
  {
   pgamedata->ProgressiveJokerWild100Amount  = progressive1;
   pgamedata->ProgressiveJokerWild100EndTime = TTime().Seconds();
  }
 }
 if(SubGameType == cvpPowerProg)
 {
  if(coinsize == 0.25)
  {
   pgamedata->ProgressivePowerFH025Amount  = progressive1;
   pgamedata->ProgressivePowerFH025EndTime = TTime().Seconds();
  }
  if(coinsize == 1.0)
  {
   pgamedata->ProgressivePowerFH1Amount  = progressive1;
   pgamedata->ProgressivePowerFH1EndTime = TTime().Seconds();
  }
  if(coinsize == 50.0)
  {
   pgamedata->ProgressivePowerFH50Amount  = progressive1;
   pgamedata->ProgressivePowerFH50EndTime = TTime().Seconds();
  }
 }

}
//*******************************************************************
void TACVPVPGLord::NotifyPlayerActivation(int16 slotnum)
{
  if(GetCasPD(slotnum))
  {
	 GetCasPD(slotnum)->StartVPSession(SubGameType,GameDenom);
	 if(activeplayer == -1)
	 {
		activeplayer = slotnum;
		BankCashDisplay->SetNum(GetCash(activeplayer));
		//???if(Chips != NULL)
      //{
        //Chips->SetupCols(GetCasPD(slotnum)->Cash,
          //             GetCasPD(slotnum)->Columns[0],
				  //			  GetCasPD(slotnum)->Columns[1],
            //           GetCasPD(slotnum)->Columns[2],
					 //		  GetCasPD(slotnum)->Columns[3],
                    //   GetCasPD(slotnum)->Columns[4],
						//	  GetCasPD(slotnum)->Columns[5],
                      // false);
      //}
		if(GetCasPD(slotnum)->Cash >= coinsize)
		{
			 Button1->ShowVoidUp();
			 Button6->ShowVoidUp();
		}
		else
		{
			 Button1->ShowGray();
			 Button6->ShowGray();
		}
		string name;
		name = GetCasPD(slotnum)->GetName();
		switch(slotnum)
		{
			 case 0 : NamePlate1->ShowNamePlateString(name);break;
			 case 1 : NamePlate2->ShowNamePlateString(name);break;
			 case 2 : NamePlate3->ShowNamePlateString(name);break;
		}
	 }
  }
}
//*******************************************************************
void TACVPVPGLord::NotifyPlayerDeActivation(int16 slotnum)
{
  if(GetCasPD(slotnum))
  {
	 switch(slotnum)
	 {
			 case 0 : NamePlate1->NoShowNamePlate();break;
			 case 1 : NamePlate2->NoShowNamePlate();break;
			 case 2 : NamePlate3->NoShowNamePlate();break;
	 }
	 GetCasPD(slotnum)->Cash += GetCasPlayer(slotnum)->credit*coinsize;
	 GetCasPlayer(slotnum)->credit = 0;
	 if(activeplayer == slotnum)
	 {
		if(shutdownstate == 0)
		{
		  GetCasPD(slotnum)->Cash += coinsplayed*coinsize;
		}
		GetCasPD(slotnum)->Cash += credits*coinsize;
		credits = 0;
		coinsplayed = 0;
		Button3->ShowGray();
		CoinsPlayed->SetNum(0);
		//???if(Chips != NULL)
    //{
      //  Chips->SetNum(GetCash(activeplayer));
		//  GetCasPD(slotnum)->Columns[0] = Chips->col1;
		//  GetCasPD(slotnum)->Columns[1] = Chips->col2;
		//  GetCasPD(slotnum)->Columns[2] = Chips->col3;
		//  GetCasPD(slotnum)->Columns[3] = Chips->col4;
		//  GetCasPD(slotnum)->Columns[4] = Chips->col5;
		//  GetCasPD(slotnum)->Columns[5] = Chips->col6;
      //}
	 }
	 if(GetNumActivePlayers() == 1)
	 {
		activeplayer = -1;
		//???if(Chips != NULL) {Chips->NoShow();}
		Credits->SetNum(0);
		credits = 0;
		CoinsPlayed->SetNum(0);
		NamePlate1->NoShow();
      if(NamePlate2 != NULL)
      {
        NamePlate2->NoShow();
        NamePlate3->NoShow();
      }
		Button3->ShowGray();
		BankCashDisplay->SetNum(0);
	 }
	 if(GetNumActivePlayers() > 1 && activeplayer == slotnum)
	 {
		int16 newplayer=-1;
		newplayer = NextSlotNum(slotnum);
		activeplayer = newplayer;
      //???if(Chips != NULL)
      //{
		 // Chips->SetupCols(GetCasPD(newplayer)->Cash,
       //                GetCasPD(newplayer)->Columns[0],
		 //					  GetCasPD(newplayer)->Columns[1],
       //                GetCasPD(newplayer)->Columns[2],
		 //					  GetCasPD(newplayer)->Columns[3],
        //               GetCasPD(newplayer)->Columns[4],
		 //					  GetCasPD(newplayer)->Columns[5],
        //               false);
      //}
		credits = GetCasPlayer(newplayer)->credit;
		GetCasPlayer(newplayer)->credit = 0;
		Credits->SetNum(credits);
		CoinsPlayed->SetNum(0);
		BankCashDisplay->SetNum(GetCash(activeplayer));
		if(GetCasPD(activeplayer)->Cash >= coinsize || credits > 0)
		{
		  Button1->ShowVoidUp();
		  Button6->ShowVoidUp();
		}
		else
		{
		  Button1->ShowGray();
		  Button6->ShowGray();
		}
		Button3->ShowGray();
		string name;
		name = GetCasPD(newplayer)->GetName();
		switch(newplayer)
		{
			 case 0 : NamePlate1->ShowNamePlateString(name);break;
			 case 1 : NamePlate2->ShowNamePlateString(name);break;
			 case 2 : NamePlate3->ShowNamePlateString(name);break;
		}
	 }
	 GetCasPD(slotnum)->EndVPSession();
  }
}
//*******************************************************************
void TACVPVPGLord::SetupActivePlayer(int16 slot)
{
  if(GetCasPD(slot))
  {
	 activeplayer = slot;
    //???if(Chips != NULL)
    //{
	  // Chips->SetupCols(GetCasPD(slot)->Cash,
     //                GetCasPD(slot)->Columns[0],
	  //					   GetCasPD(slot)->Columns[1],
      //               GetCasPD(slot)->Columns[2],
		//				   GetCasPD(slot)->Columns[3],
      //               GetCasPD(slot)->Columns[4],
		//				   GetCasPD(slot)->Columns[5],
       //              false);
    //}
	 if(GetNumActivePlayers() > 0)
	 {
		string name;
		name = GetCasPD(slot)->GetName();
		switch(slot)
		  {
			 case 0 : NamePlate1->ShowNamePlateString(name);break;
			 case 1 : NamePlate2->ShowNamePlateString(name);break;
			 case 2 : NamePlate3->ShowNamePlateString(name);break;
		  }
	 }
  }
}
//*******************************************************************
TMoney TACVPVPGLord::PayOutFivesUp()
{
  int16 session = GetCasPD(activeplayer)->VPData.CurrentSession;
  TCVPSession &cs = GetCasPD(activeplayer)->VPData.Sessions[session];

  switch (GetCasPlayer(activeplayer)->pHand->highhand)
  {
	 case Pair :
               if (GetCasPlayer(activeplayer)->pHand->highcard > Ten)
					{
					  fake->highcard = GetCasPlayer(activeplayer)->pHand->highcard;
					  winnerpaid += coinsplayed;
					  cs.TotalHighPairCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.HighPairs++;
					  switch(GetCasPlayer(activeplayer)->pHand->highcard)
                 {
						 case Ten   : winhand = "Pair of Tens";break;
						 case Jack  : winhand = "Pair of Jacks";break;
						 case Queen : winhand = "Pair of Queens";break;
						 case King  : winhand = "Pair of Kings";break;
						 case AceHi : winhand = "Pair of Aces";break;
					  }
					  VertLite->SetRow(0);
					}
					break;
	 case TwoPair :
               winnerpaid += coinsplayed*2;
               winhand = "Two Pair";
					cs.TotalTwoPairCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.TwoPairs++;
					VertLite->SetRow(1);
               break;
	 case ThreeKind :
               if(GetCasPlayer(activeplayer)->pHand->highcard == Five)
               {
                 winnerpaid += coinsplayed*5;
                 winhand = "Three Fives";
					  cs.TotalThreeOfKinds5Cash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.ThreeOfKinds5++;
					  VertLite->SetRow(3);
               }
               else
               {
                 winnerpaid += coinsplayed*3;
                 winhand = "Three of a Kind";
					  cs.TotalThreeOfKindCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.ThreeOfKinds++;
					  VertLite->SetRow(2);
               }
               break;
	 case Straight :
               winnerpaid += coinsplayed*4;
               winhand = "Straight";
					cs.TotalStraightCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Straights++;
					VertLite->SetRow(4);
               break;
	 case Flush :
               winnerpaid += coinsplayed*5;
               winhand = "Flush";
					cs.TotalFlushCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Flushes++;
					VertLite->SetRow(5);
               break;
	 case FullHouse :
               winnerpaid += coinsplayed*8;
               winhand = "Full House";
					cs.TotalFullHouseCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FullHouses++;
					VertLite->SetRow(6);
               break;
	 case FourKind :
               if(GetCasPlayer(activeplayer)->pHand->highcard == Five)
               {
                 if(coinsplayed == 5)
					  {
                   winnerpaid += 500;
                 }
                 else
                 {
                   winnerpaid += coinsplayed*50;
                 }
                 winhand = "Four Fives";
					  cs.TotalFourOfKinds5Cash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.FourOfKinds5++;
					  VertLite->SetRow(8);
               }
               else
               {
                 winnerpaid += coinsplayed*25;
                 winhand = "Four of a Kind";
					  cs.TotalFourOfKindCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.FourOfKinds++;
					  VertLite->SetRow(7);
               }
               break;
	 case StraightFlush :
               if (GetCasPlayer(activeplayer)->pHand->highcard == AceHi)
					{
					  if(coinsplayed == 5)
					  {
						 winnerpaid += 4000;
                   winhand = "Royal Flush";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  else
					  {
						 winnerpaid += coinsplayed*250;
                   winhand = "Royal Flush";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  VertLite->SetRow(10);
                 break;
					}
					else
					{
					  winnerpaid += coinsplayed*50;winhand = "Straight Flush";
					  cs.TotalStraightFlushCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.StraightFlushes++;
					  VertLite->SetRow(9);
                 break;
					}
	 default : return 1;
  }
  return 1;
}
//*******************************************************************
TMoney TACVPVPGLord::PayOutBonusDeluxeP()
{
  int16 session = GetCasPD(activeplayer)->VPData.CurrentSession;
  TCVPSession &cs = GetCasPD(activeplayer)->VPData.Sessions[session];

  switch (GetCasPlayer(activeplayer)->pHand->highhand)
  {
	 case Pair :
               if (GetCasPlayer(activeplayer)->pHand->highcard > Ten)
					{
					  fake->highcard = GetCasPlayer(activeplayer)->pHand->highcard;
					  winnerpaid += coinsplayed;
					  cs.TotalHighPairCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.HighPairs++;
					  switch(GetCasPlayer(activeplayer)->pHand->highcard)
                 {
						 case Ten   : winhand = "Pair of Tens";break;
						 case Jack  : winhand = "Pair of Jacks";break;
						 case Queen : winhand = "Pair of Queens";break;
						 case King  : winhand = "Pair of Kings";break;
						 case AceHi : winhand = "Pair of Aces";break;
					  }
					  VertLite->SetRow(0);
					}
					break;
	 case TwoPair :
               winnerpaid += coinsplayed;
               winhand = "Two Pair";
					cs.TotalTwoPairCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.TwoPairs++;
					VertLite->SetRow(1);
               break;
	 case ThreeKind :
                 winnerpaid += coinsplayed*3;
                 winhand = "Three of a Kind";
					  cs.TotalThreeOfKindCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.ThreeOfKinds++;
					  VertLite->SetRow(2);
               break;
	 case Straight :
               winnerpaid += coinsplayed*4;
               winhand = "Straight";
					cs.TotalStraightCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Straights++;
					VertLite->SetRow(3);
               break;
	 case Flush :
               winnerpaid += coinsplayed*5;
               winhand = "Flush";
					cs.TotalFlushCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Flushes++;
					VertLite->SetRow(4);
               break;
	 case FullHouse :
               winnerpaid += coinsplayed*8;
               winhand = "Full House";
					cs.TotalFullHouseCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FullHouses++;
					VertLite->SetRow(5);
               break;
	 case FourKind :
                 winnerpaid += coinsplayed*80;
                 winhand = "Four of a Kind";
					  cs.TotalFourOfKindCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.FourOfKinds++;
					  VertLite->SetRow(6);
               break;
	 case StraightFlush :
               if (GetCasPlayer(activeplayer)->pHand->highcard == AceHi)
					{
					  if(coinsplayed == 5)
					  {
						 winnerpaid += 4000;
                   winhand = "Royal Flush";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  else
					  {
						 winnerpaid += coinsplayed*250;
                   winhand = "Royal Flush";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  VertLite->SetRow(8);
                 break;
					}
					else
					{
					  winnerpaid += coinsplayed*50;winhand = "Straight Flush";
					  cs.TotalStraightFlushCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.StraightFlushes++;
					  VertLite->SetRow(7);
                 break;
					}
	 default : return 1;
  }
  return 1;
}
//*******************************************************************
TMoney TACVPVPGLord::PayOutClubBonus()
{
  int16 session = GetCasPD(activeplayer)->VPData.CurrentSession;
  TCVPSession &cs = GetCasPD(activeplayer)->VPData.Sessions[session];

  switch (GetCasPlayer(activeplayer)->pHand->highhand)
  {
	 case Pair :
               if (GetCasPlayer(activeplayer)->pHand->highcard > Ten)
					{
					  fake->highcard = GetCasPlayer(activeplayer)->pHand->highcard;
					  winnerpaid += coinsplayed;
					  cs.TotalHighPairCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.HighPairs++;
					  switch(GetCasPlayer(activeplayer)->pHand->highcard)
                 {
						 case Ten   : winhand = "Pair of Tens";break;
						 case Jack  : winhand = "Pair of Jacks";break;
						 case Queen : winhand = "Pair of Queens";break;
						 case King  : winhand = "Pair of Kings";break;
						 case AceHi : winhand = "Pair of Aces";break;
					  }
					  VertLite->SetRow(0);
					}
					break;
	 case TwoPair :
               winnerpaid += coinsplayed*2;
               winhand = "Two Pair";
					cs.TotalTwoPairCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.TwoPairs++;
					VertLite->SetRow(1);
               break;
	 case ThreeKind :
                 winnerpaid += coinsplayed*3;
                 winhand = "Three of a Kind";
					  cs.TotalThreeOfKindCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.ThreeOfKinds++;
					  VertLite->SetRow(2);
               break;
	 case Straight :
               winnerpaid += coinsplayed*4;
               winhand = "Straight";
					cs.TotalStraightCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Straights++;
					VertLite->SetRow(3);
               break;
	 case Flush :
               if(GetCasPlayer(activeplayer)->pHand->highcardsuit == Club)
					{
					  winnerpaid += coinsplayed*8;
                 winhand = "Club Flush";
					  cs.TotalFlushClubCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.FlushClub++;
					  VertLite->SetRow(5);
               }
               else
               {
                 winnerpaid += coinsplayed*5;
                 winhand = "Flush";
					  cs.TotalFlushCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.Flushes++;
					  VertLite->SetRow(4);
               }
               break;
	 case FullHouse :
               winnerpaid += coinsplayed*8;
               winhand = "Full House";
					cs.TotalFullHouseCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FullHouses++;
					VertLite->SetRow(6);
               break;
	 case FourKind :
                 winnerpaid += coinsplayed*25;
                 winhand = "Four of a Kind";
					  cs.TotalFourOfKindCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.FourOfKinds++;
					  VertLite->SetRow(7);
               break;
	 case StraightFlush :
               if (GetCasPlayer(activeplayer)->pHand->highcard == AceHi)
					{
					  if(coinsplayed == 5)
					  {
                   if(GetCasPlayer(activeplayer)->pHand->highcardsuit == Club)
					    {
                     winnerpaid += 4700;
                     winhand = "Club Royal Flush";
						   cs.TotalRoyalFlushesClubCash += winnerpaid*coinsize;
						   cs.Wins++;
						   cs.RoyalFlushesClub++;
                     VertLite->SetRow(11);
                   }
                   else
                   {
                     winnerpaid += 4000;
                     winhand = "Royal Flush";
						   cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						   cs.Wins++;
						   cs.NaturalRoyals++;
                     VertLite->SetRow(10);
                   }
					  }
					  else
					  {
						 if(GetCasPlayer(activeplayer)->pHand->highcardsuit == Club)
					    {
                     winnerpaid += coinsplayed*300;
                     winhand = "Club Royal Flush";
						   cs.TotalRoyalFlushesClubCash += winnerpaid*coinsize;
						   cs.Wins++;
						   cs.RoyalFlushesClub++;
                     VertLite->SetRow(11);
                   }
                   else
                   {
                     winnerpaid += coinsplayed*250;
                     winhand = "Royal Flush";
						   cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						   cs.Wins++;
						   cs.NaturalRoyals++;
                     VertLite->SetRow(10);
                   }
					  }

                 break;
					}
					else
					{
					  if(GetCasPlayer(activeplayer)->pHand->highcardsuit == Club)
                 {
                   winnerpaid += coinsplayed*200;winhand = "Club Straight Flush";
					    cs.TotalStraightFlushesClubCash += winnerpaid*coinsize;
					    cs.Wins++;
					    cs.StraightFlushesClub++;
					    VertLite->SetRow(9);
                 }
                 else
                 {
                   winnerpaid += coinsplayed*50;winhand = "Straight Flush";
					    cs.TotalStraightFlushCash += winnerpaid*coinsize;
					    cs.Wins++;
					    cs.StraightFlushes++;
					    VertLite->SetRow(8);
                 }
                 break;
					}
	 default : return 1;
  }
  return 1;
}
//*******************************************************************
TMoney TACVPVPGLord::PayOutCrazy8()
{
  int16 session = GetCasPD(activeplayer)->VPData.CurrentSession;
  TCVPSession &cs = GetCasPD(activeplayer)->VPData.Sessions[session];

  switch (GetCasPlayer(activeplayer)->pHand->highhand)
  {
	 case Pair :
               if (GetCasPlayer(activeplayer)->pHand->highcard > Ten)
					{
					  fake->highcard = GetCasPlayer(activeplayer)->pHand->highcard;
					  winnerpaid += coinsplayed;
					  cs.TotalHighPairCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.HighPairs++;
					  switch(GetCasPlayer(activeplayer)->pHand->highcard)
                 {
						 case Ten   : winhand = "Pair of Tens";break;
						 case Jack  : winhand = "Pair of Jacks";break;
						 case Queen : winhand = "Pair of Queens";break;
						 case King  : winhand = "Pair of Kings";break;
						 case AceHi : winhand = "Pair of Aces";break;
					  }
					  VertLite->SetRow(0);
					}
					break;
	 case TwoPair :
               winnerpaid += coinsplayed*2;
               winhand = "Two Pair";
					cs.TotalTwoPairCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.TwoPairs++;
					VertLite->SetRow(1);
               break;
	 case ThreeKind :
               if(GetCasPlayer(activeplayer)->pHand->highcard == Eight)
               {
                 if(coinsplayed == 8)
					  {
                   winnerpaid += 55;
                 }
                 else
                 {
                   winnerpaid += coinsplayed*5;
                 }
                 cs.TotalThreeOfKinds8Cash += winnerpaid*coinsize;
                 cs.ThreeOfKinds8++;
                 winhand = "Three Eights";
                 VertLite->SetRow(3);
               }
               else
               {
                 winnerpaid += coinsplayed*2;
                 winhand = "Three of a Kind";
                 VertLite->SetRow(2);
                 cs.TotalThreeOfKindCash += winnerpaid*coinsize;
                 cs.ThreeOfKinds++;
				   }
               cs.Wins++;
               break;
	 case Straight :
               winnerpaid += coinsplayed*4;
               winhand = "Straight";
					cs.TotalStraightCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Straights++;
					VertLite->SetRow(4);
               break;
	 case Flush :
               winnerpaid += coinsplayed*5;
               winhand = "Flush";
					cs.TotalFlushCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Flushes++;
					VertLite->SetRow(5);
               break;
	 case FullHouse :
               winnerpaid += coinsplayed*7;
               winhand = "Full House";
					cs.TotalFullHouseCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FullHouses++;
					VertLite->SetRow(6);
               break;
	 case FourKind :
               if(GetCasPlayer(activeplayer)->pHand->highcard == Eight)
               {
                 if(coinsplayed == 8)
					  {
                   winnerpaid += 1000;
                 }
                 else
                 {
                   winnerpaid += coinsplayed*55;
                 }
                 winhand = "Four Eights";
                 VertLite->SetRow(8);
                 cs.TotalFourOfKinds8Cash += winnerpaid*coinsize;
                 cs.FourOfKinds8++;
               }
               else
               {
                 winnerpaid += coinsplayed*25;
                 winhand = "Four of a Kind";
                 VertLite->SetRow(7);
                 cs.TotalFourOfKindCash += winnerpaid*coinsize;
                 cs.FourOfKinds++;
               }
               cs.Wins++;
               break;
	 case StraightFlush :
               if (GetCasPlayer(activeplayer)->pHand->highcard == AceHi)
					{
					  winnerpaid += coinsplayed*250;
                 winhand = "Royal Flush";
                 cs.NaturalRoyals++;
                 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
                 VertLite->SetRow(10);
					}
					else
					{
					  winnerpaid += coinsplayed*50;winhand = "Straight Flush";
					  cs.TotalStraightFlushCash += winnerpaid*coinsize;
					  cs.StraightFlushes++;
                 VertLite->SetRow(9);
					}
               cs.Wins++;

               break;
	 default : return 1;
  }
  return 1;
}
//*******************************************************************
TMoney TACVPVPGLord::PayOutDDrawJacks()
{
  int16 session = GetCasPD(activeplayer)->VPData.CurrentSession;
  TCVPSession &cs = GetCasPD(activeplayer)->VPData.Sessions[session];

  switch (GetCasPlayer(activeplayer)->pHand->highhand)
  {
	 case Pair :
               if (GetCasPlayer(activeplayer)->pHand->highcard > Ten)
					{
					  fake->highcard = GetCasPlayer(activeplayer)->pHand->highcard;
					  winnerpaid += coinsplayed;
					  cs.TotalHighPairCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.HighPairs++;
					  switch(GetCasPlayer(activeplayer)->pHand->highcard)
                 {
						 case Ten   : winhand = "Pair of Tens";break;
						 case Jack  : winhand = "Pair of Jacks";break;
						 case Queen : winhand = "Pair of Queens";break;
						 case King  : winhand = "Pair of Kings";break;
						 case AceHi : winhand = "Pair of Aces";break;
					  }
					  VertLite->SetRow(0);
					}
					break;
	 case TwoPair :
               winnerpaid += coinsplayed*1;
               winhand = "Two Pair";
					cs.TotalTwoPairCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.TwoPairs++;
					VertLite->SetRow(1);
               break;
	 case ThreeKind :
               winnerpaid += coinsplayed*2;
               winhand = "Three of a Kind";
					cs.TotalThreeOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.ThreeOfKinds++;
					VertLite->SetRow(2);
               break;
	 case Straight :
               winnerpaid += coinsplayed*4;
               winhand = "Straight";
					cs.TotalStraightCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Straights++;
					VertLite->SetRow(3);
               break;
	 case Flush :
               winnerpaid += coinsplayed*5;
               winhand = "Flush";
					cs.TotalFlushCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Flushes++;
					VertLite->SetRow(4);
               break;
	 case FullHouse :
               winnerpaid += coinsplayed*8;
               winhand = "Full House";
					cs.TotalFullHouseCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FullHouses++;
					VertLite->SetRow(5);
               break;
	 case FourKind :

               winnerpaid += coinsplayed*20;
               winhand = "Four of a Kind";
					cs.TotalFourOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FourOfKinds++;
					VertLite->SetRow(6);
               break;
	 case StraightFlush :
               cs.Wins++;
               if (GetCasPlayer(activeplayer)->pHand->highcard == AceHi)
					{
					  if(coinsplayed == 5)
					  {
						 winnerpaid += 1200;
					  }
					  else
					  {
						 winnerpaid += coinsplayed*200;
             	  }
                 winhand = "Royal Flush";
					  cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
					  cs.NaturalRoyals++;
					  VertLite->SetRow(8);
                 break;
					}
					else
					{
					  winnerpaid += coinsplayed*40;winhand = "Straight Flush";
					  cs.TotalStraightFlushCash += winnerpaid*coinsize;
					  cs.StraightFlushes++;
					  VertLite->SetRow(7);
                 break;
					}
    default : return 1;
  }
  return 1;
}
//*******************************************************************
TMoney TACVPVPGLord::PayOutDDrawJokers()
{
  int16 session = GetCasPD(activeplayer)->VPData.CurrentSession;
  TCVPSession &cs = GetCasPD(activeplayer)->VPData.Sessions[session];

  switch (GetCasPlayer(activeplayer)->pHand->highhand)
  {
	 case TwoPair :
               winnerpaid += coinsplayed*1;
               winhand = "Two Pair";
					cs.TotalTwoPairCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.TwoPairs++;
					VertLite->SetRow(0);
               break;
	 case ThreeKind :
               winnerpaid += coinsplayed*2;
               winhand = "Three of a Kind";
					cs.TotalThreeOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.ThreeOfKinds++;
					VertLite->SetRow(1);
               break;
	 case Straight :
               winnerpaid += coinsplayed*4;
               winhand = "Straight";
					cs.TotalStraightCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Straights++;
					VertLite->SetRow(2);
               break;
	 case Flush :
               winnerpaid += coinsplayed*5;
               winhand = "Flush";
					cs.TotalFlushCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Flushes++;
					VertLite->SetRow(3);
               break;
	 case FullHouse :
               winnerpaid += coinsplayed*8;
               winhand = "Full House";
					cs.TotalFullHouseCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FullHouses++;
					VertLite->SetRow(4);
               break;
	 case FourKind :
               winnerpaid += coinsplayed*20;
               winhand = "Four of a Kind";
					cs.TotalFourOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FourOfKinds++;
					VertLite->SetRow(5);
               break;
	 case StraightFlush :
               if (GetCasPlayer(activeplayer)->pHand->highcard == AceHi)
					{
					  winnerpaid += coinsplayed*100;
                 winhand = "Royal Flush";
					  cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.NaturalRoyals++;  //???stat
					  VertLite->SetRow(7);
                 break;
					}
					else
					{
					  winnerpaid += coinsplayed*40;winhand = "Straight Flush";
					  cs.TotalStraightFlushCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.StraightFlushes++;
					  VertLite->SetRow(6);
                 break;
					}
    case  WildRFlush :
                 winnerpaid += coinsplayed*40;
                 winhand = "Royal Flush(Wild)";
					  cs.TotalWildRoyalCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.WildRoyals++;
					  VertLite->SetRow(6);
                 break;
    case FiveKind :
               if(coinsplayed == 5)
               {
                 winnerpaid += 2500;
               }
               else
               {
                 winnerpaid += coinsplayed*250;
               }
               winhand = "Five of a Kind";
				  	cs.TotalFiveOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FiveOfKinds++;
 				   VertLite->SetRow(8);
               break;
	 default : return 1;
  }
  return 1;
}
//*******************************************************************
TMoney TACVPVPGLord::PayOutDDownStud()
{
  int16 session = GetCasPD(activeplayer)->VPData.CurrentSession;
  TCVPSession &cs = GetCasPD(activeplayer)->VPData.Sessions[session];

  switch (GetCasPlayer(activeplayer)->pHand->highhand)
  {
	 case Pair :if(GetCasPlayer(activeplayer)->pHand->highcard > Ten)
					{
					  fake->highcard = GetCasPlayer(activeplayer)->pHand->highcard;
					  winnerpaid += coinsplayed*2;
					  cs.TotalHighPairCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.HighPairs++;
					  switch(GetCasPlayer(activeplayer)->pHand->highcard)
                 {
						 case Ten   : winhand = "Pair of Tens";break;
						 case Jack  : winhand = "Pair of Jacks";break;
						 case Queen : winhand = "Pair of Queens";break;
						 case King  : winhand = "Pair of Kings";break;
						 case AceHi : winhand = "Pair of Aces";break;
					  }
					  VertLite->SetRow(1);
					}
               else if(GetCasPlayer(activeplayer)->pHand->highcard >= Six)
               {
                 winnerpaid += coinsplayed;
					  cs.TotalPair6Cash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.Pair6++;
                 winhand = "Sixs - Tens";
                 VertLite->SetRow(0);
                 break;
               }
					break;
	 case TwoPair :
               winnerpaid += coinsplayed*3;
               winhand = "Two Pair";
					cs.TotalTwoPairCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.TwoPairs++;
					VertLite->SetRow(2);
               break;
	 case ThreeKind :
               winnerpaid += coinsplayed*4;
               winhand = "Three of a Kind";
					cs.TotalThreeOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.ThreeOfKinds++;
					VertLite->SetRow(3);
               break;
	 case Straight :
               winnerpaid += coinsplayed*6;
               winhand = "Straight";
					cs.TotalStraightCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Straights++;
					VertLite->SetRow(4);
               break;
	 case Flush :
               winnerpaid += coinsplayed*9;
               winhand = "Flush";
					cs.TotalFlushCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Flushes++;
					VertLite->SetRow(5);
               break;
	 case FullHouse :
               winnerpaid += coinsplayed*12;
               winhand = "Full House";
					cs.TotalFullHouseCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FullHouses++;
					VertLite->SetRow(6);
               break;
	 case FourKind :
               winnerpaid += coinsplayed*50;
               winhand = "Four of a Kind";
					cs.TotalFourOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FourOfKinds++;
					VertLite->SetRow(7);
               break;
	 case StraightFlush :
               if (GetCasPlayer(activeplayer)->pHand->highcard == AceHi)
					{
					  if(coinsplayed == 5)
					  {
						 winnerpaid += 10000;
                   winhand = "Royal Flush";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  else
					  {
						 winnerpaid += coinsplayed*1000;
                   winhand = "Royal Flush";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  VertLite->SetRow(9);
                 break;
					}
					else
					{
					  winnerpaid += coinsplayed*200;winhand = "Straight Flush";
					  cs.TotalStraightFlushCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.StraightFlushes++;
					  VertLite->SetRow(8);
                 break;
					}
	 default : return 1;
  }
  return 1;
}

//*******************************************************************
TMoney TACVPVPGLord::PayOut2WildBonus()
{
  int16 session = GetCasPD(activeplayer)->VPData.CurrentSession;
  TCVPSession &cs = GetCasPD(activeplayer)->VPData.Sessions[session];

  switch (GetCasPlayer(activeplayer)->pHand->highhand)
  {
	 case ThreeKind :
               winnerpaid += coinsplayed*1;
               winhand = "Three of a Kind";
					cs.TotalThreeOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.ThreeOfKinds++;
					VertLite->SetRow(0);
               break;
	 case Straight :
               winnerpaid += coinsplayed*1;
               winhand = "Straight";
					cs.TotalStraightCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Straights++;
					VertLite->SetRow(1);
               break;
	 case Flush :
               winnerpaid += coinsplayed*3;
               winhand = "Flush";
					cs.TotalFlushCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Flushes++;
					VertLite->SetRow(2);
               break;
	 case FullHouse :
               winnerpaid += coinsplayed*3;
               winhand = "Full House";
					cs.TotalFullHouseCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FullHouses++;
					VertLite->SetRow(3);
               break;
	 case FourKind :
               winnerpaid += coinsplayed*4;
               winhand = "Four of a Kind";
					cs.TotalFourOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FourOfKinds++;
					VertLite->SetRow(4);
               break;
	 case StraightFlush :
               if (GetCasPlayer(activeplayer)->pHand->highcard == AceHi)
					{
					  if(coinsplayed == 5)
					  {
						 winnerpaid += 4000;
                   winhand = "Royal Flush(Nat)";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  else
					  {
						 winnerpaid += coinsplayed*250;
                   winhand = "Royal Flush(Nat)";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  VertLite->SetRow(12);
                 break;
					}
					else
					{
					  winnerpaid += coinsplayed*13;winhand = "Straight Flush";
					  cs.TotalStraightFlushCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.StraightFlushes++;
					  VertLite->SetRow(5);
                 break;
					}
	 case  WildRFlush :
                 winnerpaid += coinsplayed*25;
                 winhand = "Royal Flush(Wild)";
					  cs.TotalWildRoyalCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.WildRoyals++;
					  VertLite->SetRow(6);
                 break;
    case FiveKind :
               if(GetCasPlayer(activeplayer)->pHand->highcard == AceHi)
               {
                 winnerpaid += coinsplayed*80;
                 winhand = "Five Aces";
				     cs.TotalFiveOfKindsAcesCash += winnerpaid*coinsize;
					  cs.Wins++;
				  	  cs.FiveOfKindsAces++;
					  VertLite->SetRow(9);
               }
               else if(GetCasPlayer(activeplayer)->pHand->highcard < Six)
               {
                 winnerpaid += coinsplayed*40;
                 winhand = "Five of a Kind(3-5)";
				     cs.TotalFiveOfKinds3_5Cash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.FiveOfKinds3_5++;
					  VertLite->SetRow(8);
               }
               else
               {
                 winnerpaid += coinsplayed*20;
                 winhand = "Five of a Kind(6-K)";
				     cs.TotalFiveOfKinds6_KCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.FiveOfKinds6_K++;
					  VertLite->SetRow(7);
               }
               break;
	 case FourKind2 :
               int xx=0;
               bool what=false;
               for(xx=0;xx<5;xx++)
               {
                 if(GetCasPlayer(activeplayer)->pHand->cards[xx].name == AceHi)
                 {
                   what = true;
                 }
               }
               if(what)
               {
                 winnerpaid += coinsplayed*400;
                 winhand = "Four 2's with Ace";
					  cs.TotalFourOfKinds2WAceCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.FourOfKinds2WAce++;
					  VertLite->SetRow(11);
               }
               else
               {
                 winnerpaid += coinsplayed*200;
                 winhand = "Four 2's";
					  cs.TotalFourDeuceCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.FourDeuces++;
					  VertLite->SetRow(10);
               }
               break;
	 //???default : return 1;
  }
  return 1;
}

//*******************************************************************
TMoney TACVPVPGLord::PayOut2Wild()
{
  int16 session = GetCasPD(activeplayer)->VPData.CurrentSession;
  TCVPSession &cs = GetCasPD(activeplayer)->VPData.Sessions[session];

  switch (GetCasPlayer(activeplayer)->pHand->highhand)
  {
	 case ThreeKind :
               winnerpaid += coinsplayed*1;
               winhand = "Three of a Kind";
					cs.TotalThreeOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.ThreeOfKinds++;
					VertLite->SetRow(0);
               break;
	 case Straight :
               winnerpaid += coinsplayed*2;
               winhand = "Straight";
					cs.TotalStraightCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Straights++;
					VertLite->SetRow(1);
               break;
	 case Flush :
               winnerpaid += coinsplayed*2;
               winhand = "Flush";
					cs.TotalFlushCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Flushes++;
					VertLite->SetRow(2);
               break;
	 case FullHouse :
               winnerpaid += coinsplayed*3;
               winhand = "Full House";
					cs.TotalFullHouseCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FullHouses++;
					VertLite->SetRow(3);
               break;
	 case FourKind :
               winnerpaid += coinsplayed*5;
               winhand = "Four of a Kind";
					cs.TotalFourOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FourOfKinds++;
					VertLite->SetRow(4);
               break;
	 case StraightFlush :
               if (GetCasPlayer(activeplayer)->pHand->highcard == AceHi)
					{
					  if(coinsplayed == 5)
					  {
						 winnerpaid += 4000;
                   winhand = "Royal Flush(Nat)";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  else
					  {
						 winnerpaid += coinsplayed*250;
                   winhand = "Royal Flush(Nat)";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  VertLite->SetRow(9);
                 break;
					}
					else
					{
					  winnerpaid += coinsplayed*9;winhand = "Straight Flush";
					  cs.TotalStraightFlushCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.StraightFlushes++;
					  VertLite->SetRow(5);
                 break;
					}
	 case  WildRFlush :
                 winnerpaid += coinsplayed*25;
                 winhand = "Royal Flush(Wild)";
					  cs.TotalWildRoyalCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.WildRoyals++;
					  VertLite->SetRow(7);
                 break;
    case FiveKind :
                 winnerpaid += coinsplayed*15;
                 winhand = "Five of a Kind";
				     cs.TotalFiveOfKindCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.FiveOfKinds++;
					  VertLite->SetRow(6);
               break;
	 case FourKind2 :
               winnerpaid += coinsplayed*200;
               winhand = "Four 2's";
				  	cs.TotalFourDeuceCash += winnerpaid*coinsize;
					cs.Wins++;
				 	cs.FourDeuces++;
					VertLite->SetRow(8);
               break;
	 default : return 1;
  }
  return 1;
}

//*******************************************************************
TMoney TACVPVPGLord::PayOut2WildProg()
{
  int16 session = GetCasPD(activeplayer)->VPData.CurrentSession;
  TCVPSession &cs = GetCasPD(activeplayer)->VPData.Sessions[session];

  switch (GetCasPlayer(activeplayer)->pHand->highhand)
  {
	 case ThreeKind :
               winnerpaid += coinsplayed*1;
               winhand = "Three of a Kind";
					cs.TotalThreeOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.ThreeOfKinds++;
					VertLite->SetRow(0);
               break;
	 case Straight :
               winnerpaid += coinsplayed*2;
               winhand = "Straight";
					cs.TotalStraightCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Straights++;
					VertLite->SetRow(1);
               break;
	 case Flush :
               winnerpaid += coinsplayed*2;
               winhand = "Flush";
					cs.TotalFlushCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Flushes++;
					VertLite->SetRow(2);
               break;
	 case FullHouse :
               winnerpaid += coinsplayed*3;
               winhand = "Full House";
					cs.TotalFullHouseCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FullHouses++;
					VertLite->SetRow(3);
               break;
	 case FourKind :
               winnerpaid += coinsplayed*4;
               winhand = "Four of a Kind";
					cs.TotalFourOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FourOfKinds++;
					VertLite->SetRow(4);
               break;
	 case StraightFlush :
               if (GetCasPlayer(activeplayer)->pHand->highcard == AceHi)
					{
					  if(coinsplayed == 5)
					  {
						 winnerpaid += ((int16)(progressive1/coinsize))+1;
                   progressive1 = coinsize*4000;
                   winhand = "Royal Flush(Nat)";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  else
					  {
						 winnerpaid += coinsplayed*250;
                   winhand = "Royal Flush(Nat)";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  VertLite->SetRow(9);
                 break;
					}
					else
					{
					  winnerpaid += coinsplayed*8;winhand = "Straight Flush";
					  cs.TotalStraightFlushCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.StraightFlushes++;
					  VertLite->SetRow(5);
                 break;
					}
	 case  WildRFlush :
                 winnerpaid += coinsplayed*25;
                 winhand = "Royal Flush(Wild)";
					  cs.TotalWildRoyalCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.WildRoyals++;
					  VertLite->SetRow(7);
                 break;
    case FiveKind :
                 winnerpaid += coinsplayed*15;
                 winhand = "Five of a Kind";
				     cs.TotalFiveOfKindCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.FiveOfKinds++;
					  VertLite->SetRow(6);
               break;
	 case FourKind2 :
               winnerpaid += coinsplayed*200;
               winhand = "Four 2's";
				  	cs.TotalFourDeuceCash += winnerpaid*coinsize;
					cs.Wins++;
				  	cs.FourDeuces++;
					VertLite->SetRow(8);
               break;
	 default : return 1;
  }
  return 1;
}

//*******************************************************************
TMoney TACVPVPGLord::PayOutDiamondBonus()
{
  int16 session = GetCasPD(activeplayer)->VPData.CurrentSession;
  TCVPSession &cs = GetCasPD(activeplayer)->VPData.Sessions[session];

  switch (GetCasPlayer(activeplayer)->pHand->highhand)
  {
	 case Pair :
               if (GetCasPlayer(activeplayer)->pHand->highcard > Ten)
					{
					  fake->highcard = GetCasPlayer(activeplayer)->pHand->highcard;
					  winnerpaid += coinsplayed;
					  cs.TotalHighPairCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.HighPairs++;
					  switch(GetCasPlayer(activeplayer)->pHand->highcard)
                 {
						 case Ten   : winhand = "Pair of Tens";break;
						 case Jack  : winhand = "Pair of Jacks";break;
						 case Queen : winhand = "Pair of Queens";break;
						 case King  : winhand = "Pair of Kings";break;
						 case AceHi : winhand = "Pair of Aces";break;
					  }
					  VertLite->SetRow(0);
					}
					break;
	 case TwoPair :
               winnerpaid += coinsplayed*2;
               winhand = "Two Pair";
					cs.TotalTwoPairCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.TwoPairs++;
					VertLite->SetRow(1);
               break;
	 case ThreeKind :
                 winnerpaid += coinsplayed*3;
                 winhand = "Three of a Kind";
					  cs.TotalThreeOfKindCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.ThreeOfKinds++;
					  VertLite->SetRow(2);
               break;
	 case Straight :
               winnerpaid += coinsplayed*4;
               winhand = "Straight";
					cs.TotalStraightCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Straights++;
					VertLite->SetRow(3);
               break;
	 case Flush :
               if(GetCasPlayer(activeplayer)->pHand->highcardsuit == Diamond)
					{
					  winnerpaid += coinsplayed*8;
                 winhand = "Diamond Flush";
					  cs.TotalFlushDiamondCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.FlushDiamond++;
					  VertLite->SetRow(5);
               }
               else
               {
                 winnerpaid += coinsplayed*5;
                 winhand = "Flush";
					  cs.TotalFlushCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.Flushes++;
					  VertLite->SetRow(4);
               }
               break;
	 case FullHouse :
               winnerpaid += coinsplayed*8;
               winhand = "Full House";
					cs.TotalFullHouseCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FullHouses++;
					VertLite->SetRow(6);
               break;
	 case FourKind :
                 winnerpaid += coinsplayed*25;
                 winhand = "Four of a Kind";
					  cs.TotalFourOfKindCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.FourOfKinds++;
					  VertLite->SetRow(7);
               break;
	 case StraightFlush :
               if (GetCasPlayer(activeplayer)->pHand->highcard == AceHi)
					{
					  if(coinsplayed == 5)
					  {
                   if(GetCasPlayer(activeplayer)->pHand->highcardsuit == Diamond)
					    {
                     winnerpaid += 4700;
                     winhand = "Diamond Royal Flush";
						   cs.TotalRoyalFlushesDiamondCash += winnerpaid*coinsize;
						   cs.Wins++;
						   cs.RoyalFlushesDiamond++;
                     VertLite->SetRow(11);
                   }
                   else
                   {
                     winnerpaid += 4000;
                     winhand = "Royal Flush";
						   cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						   cs.Wins++;
						   cs.NaturalRoyals++;
                     VertLite->SetRow(10);
                   }
					  }
					  else
					  {
						 if(GetCasPlayer(activeplayer)->pHand->highcardsuit == Diamond)
					    {
                     winnerpaid += coinsplayed*300;
                     winhand = "Diamond Royal Flush";
						   cs.TotalRoyalFlushesDiamondCash += winnerpaid*coinsize;
						   cs.Wins++;
						   cs.RoyalFlushesDiamond++;
                     VertLite->SetRow(11);
                   }
                   else
                   {
                     winnerpaid += coinsplayed*250;
                     winhand = "Royal Flush";
						   cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						   cs.Wins++;
						   cs.NaturalRoyals++;
                     VertLite->SetRow(10);
                   }
					  }

                 break;
					}
					else
					{
					  if(GetCasPlayer(activeplayer)->pHand->highcardsuit == Diamond)
                 {
                   winnerpaid += coinsplayed*200;winhand = "Diamond Straight Flush";
					    cs.TotalStraightFlushesDiamondCash += winnerpaid*coinsize;
					    cs.Wins++;
					    cs.StraightFlushesDiamond++;
					    VertLite->SetRow(9);
                 }
                 else
                 {
                   winnerpaid += coinsplayed*50;winhand = "Straight Flush";
					    cs.TotalStraightFlushCash += winnerpaid*coinsize;
					    cs.Wins++;
					    cs.StraightFlushes++;
					    VertLite->SetRow(8);
                 }
                 break;
					}
	 default : return 1;
  }
  return 1;
}

//*******************************************************************
TMoney TACVPVPGLord::PayOutDoubleBonusPoker()
{
  int16 session = GetCasPD(activeplayer)->VPData.CurrentSession;
  TCVPSession &cs = GetCasPD(activeplayer)->VPData.Sessions[session];

  switch (GetCasPlayer(activeplayer)->pHand->highhand)
  {
	 case Pair :
               if(GetCasPlayer(activeplayer)->pHand->highcard > Ten)
					{
					  fake->highcard = GetCasPlayer(activeplayer)->pHand->highcard;
					  winnerpaid += coinsplayed*1;
					  cs.TotalHighPairCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.HighPairs++;
					  switch(GetCasPlayer(activeplayer)->pHand->highcard)
                 {
						 case Ten   : winhand = "Pair of Tens";break;
						 case Jack  : winhand = "Pair of Jacks";break;
						 case Queen : winhand = "Pair of Queens";break;
						 case King  : winhand = "Pair of Kings";break;
						 case AceHi : winhand = "Pair of Aces";break;
					  }
					  VertLite->SetRow(0);
					}
					break;
	 case TwoPair :
               winnerpaid += coinsplayed*1;
               winhand = "Two Pair";
					cs.TotalTwoPairCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.TwoPairs++;
					VertLite->SetRow(1);
               break;
	 case ThreeKind :
               winnerpaid += coinsplayed*3;
               winhand = "Three of a Kind";
					cs.TotalThreeOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.ThreeOfKinds++;
					VertLite->SetRow(2);
               break;
	 case Straight :
               winnerpaid += coinsplayed*5;
               winhand = "Straight";
					cs.TotalStraightCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Straights++;
					VertLite->SetRow(3);
               break;
	 case Flush :
               winnerpaid += coinsplayed*6;
               winhand = "Flush";
					cs.TotalFlushCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Flushes++;
					VertLite->SetRow(4);
               break;
	 case FullHouse :
               winnerpaid += coinsplayed*9;
               winhand = "Full House";
					cs.TotalFullHouseCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FullHouses++;
					VertLite->SetRow(5);
               break;
	 case FourKind :
               if(GetCasPlayer(activeplayer)->pHand->highcard == AceHi)
               {
                 winnerpaid += coinsplayed*160;
                 winhand = "Four Aces";
                 cs.TotalFourOfKindsAcesCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.FourOfKindsAces++;
					  VertLite->SetRow(8);
               }
               else if(GetCasPlayer(activeplayer)->pHand->highcard < Five)
               {
                 winnerpaid += coinsplayed*80;
                 winhand = "Four of a Kind(2-4)";
                 cs.TotalFourOfKinds2_4Cash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.FourOfKinds2_4++;
					  VertLite->SetRow(7);
               }
               else
               {
                 winnerpaid += coinsplayed*50;
                 winhand = "Four of a Kind(5-K)";
                 cs.TotalFourOfKinds5_KCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.FourOfKinds5_K++;
					  VertLite->SetRow(6);
               }
               break;
	 case StraightFlush :
               if (GetCasPlayer(activeplayer)->pHand->highcard == AceHi)
					{
					  if(coinsplayed == 5)
					  {
						 winnerpaid += 4000;
                   winhand = "Royal Flush";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  else
					  {
						 winnerpaid += coinsplayed*250;
                   winhand = "Royal Flush";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  VertLite->SetRow(10);
                 break;
					}
					else
					{
					  winnerpaid += coinsplayed*50;winhand = "Straight Flush";
					  cs.TotalStraightFlushCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.StraightFlushes++;
					  VertLite->SetRow(9);
                 break;
					}
	 default : return 1;
  }
  return 1;
}

//*******************************************************************
TMoney TACVPVPGLord::PayOutFlushAssault()
{
  int16 session = GetCasPD(activeplayer)->VPData.CurrentSession;
  TCVPSession &cs = GetCasPD(activeplayer)->VPData.Sessions[session];

  switch (GetCasPlayer(activeplayer)->pHand->highhand)
  {
	 case Pair :
               if(GetCasPlayer(activeplayer)->pHand->highcard > Ten)
					{
					  fake->highcard = GetCasPlayer(activeplayer)->pHand->highcard;
					  winnerpaid += coinsplayed*1;
					  cs.TotalHighPairCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.HighPairs++;
					  switch(GetCasPlayer(activeplayer)->pHand->highcard)
                 {
						 case Ten   : winhand = "Pair of Tens";break;
						 case Jack  : winhand = "Pair of Jacks";break;
						 case Queen : winhand = "Pair of Queens";break;
						 case King  : winhand = "Pair of Kings";break;
						 case AceHi : winhand = "Pair of Aces";break;
					  }
					  VertLite->SetRow(0);
					}
					break;
	 case TwoPair :
               winnerpaid += coinsplayed*1;
               winhand = "Two Pair";
					cs.TotalTwoPairCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.TwoPairs++;
					VertLite->SetRow(1);
               break;
	 case ThreeKind :
               winnerpaid += coinsplayed*3;
               winhand = "Three of a Kind";
					cs.TotalThreeOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.ThreeOfKinds++;
					VertLite->SetRow(2);
               break;
	 case Straight :
               winnerpaid += coinsplayed*4;
               winhand = "Straight";
					cs.TotalStraightCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Straights++;
					VertLite->SetRow(3);
               break;
	 case Flush :
               if(FlushAssaultOn)
               {
                 winnerpaid += coinsplayed*20;
                 VertLite->SetRow(6);
                 cs.TotalFlushAssaultCash += winnerpaid*coinsize;
                 cs.FlushAssault++;
               }
               else
               {
                 winnerpaid += coinsplayed*5;
                 VertLite->SetRow(4);
                 cs.TotalFlushCash += winnerpaid*coinsize;
                 cs.Flushes++;
               }
               winhand = "Flush";
					cs.Wins++;
               break;
	 case FullHouse :
               winnerpaid += coinsplayed*8;
               winhand = "Full House";
					cs.TotalFullHouseCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FullHouses++;
					VertLite->SetRow(5);
               break;
	 case FourKind :
               if(GetCasPlayer(activeplayer)->pHand->highcard == AceHi)
               {
                 winnerpaid += coinsplayed*160;
                 winhand = "Four Aces";
                 cs.TotalFourOfKindsAcesCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.FourOfKindsAces++;
					  VertLite->SetRow(9);
               }
               else if(GetCasPlayer(activeplayer)->pHand->highcard < Five)
               {
                 winnerpaid += coinsplayed*80;
                 winhand = "Four of a Kind(2-4)";
                 cs.TotalFourOfKinds2_4Cash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.FourOfKinds2_4++;
					  VertLite->SetRow(8);
               }
               else
               {
                 winnerpaid += coinsplayed*50;
                 winhand = "Four of a Kind(5-K)";
                 cs.TotalFourOfKinds5_KCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.FourOfKinds5_K++;
					  VertLite->SetRow(7);
               }

               break;
	 case StraightFlush :
               if (GetCasPlayer(activeplayer)->pHand->highcard == AceHi)
					{
					  if(coinsplayed == 5)
					  {
						 winnerpaid += 4000;
                   winhand = "Royal Flush";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  else
					  {
						 winnerpaid += coinsplayed*250;
                   winhand = "Royal Flush";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  VertLite->SetRow(11);
                 break;
					}
					else
					{
					  winnerpaid += coinsplayed*50;winhand = "Straight Flush";
					  cs.TotalStraightFlushCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.StraightFlushes++;
					  VertLite->SetRow(10);
                 break;
					}
	 default : return 1;
  }
  return 1;
}

//*******************************************************************
TMoney TACVPVPGLord::PayOutFreeLook()
{
  int16 session = GetCasPD(activeplayer)->VPData.CurrentSession;
  TCVPSession &cs = GetCasPD(activeplayer)->VPData.Sessions[session];

  switch (GetCasPlayer(activeplayer)->pHand->highhand)
  {
	 case Pair :
               if(GetCasPlayer(activeplayer)->pHand->highcard > Queen)
					{
					  fake->highcard = GetCasPlayer(activeplayer)->pHand->highcard;
					  winnerpaid += coinsplayed*1;
					  cs.TotalHighPairCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.HighPairs++;
					  switch(GetCasPlayer(activeplayer)->pHand->highcard)
                 {
						 case Ten   : winhand = "Pair of Tens";break;
						 case Jack  : winhand = "Pair of Jacks";break;
						 case Queen : winhand = "Pair of Queens";break;
						 case King  : winhand = "Pair of Kings";break;
						 case AceHi : winhand = "Pair of Aces";break;
					  }
					  VertLite->SetRow(0);
					}
					break;
	 case TwoPair :
               winnerpaid += coinsplayed*1;
               winhand = "Two Pair";
					cs.TotalTwoPairCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.TwoPairs++;
					VertLite->SetRow(1);
               break;
	 case ThreeKind :
               winnerpaid += coinsplayed*2;
               winhand = "Three of a Kind";
					cs.TotalThreeOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.ThreeOfKinds++;
					VertLite->SetRow(2);
               break;
	 case Straight :
               winnerpaid += coinsplayed*4;
               winhand = "Straight";
					cs.TotalStraightCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Straights++;
					VertLite->SetRow(3);
               break;
	 case Flush :
               winnerpaid += coinsplayed*5;
               winhand = "Flush";
					cs.TotalFlushCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Flushes++;
					VertLite->SetRow(4);
               break;
	 case FullHouse :
               winnerpaid += coinsplayed*7;
               winhand = "Full House";
					cs.TotalFullHouseCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FullHouses++;
					VertLite->SetRow(5);
               break;
	 case FourKind :
               if(GetCasPlayer(activeplayer)->pHand->highcard == AceHi)
               {
                 winnerpaid += coinsplayed*100;
                 winhand = "Four Aces";
                 cs.TotalFourOfKindsAcesCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.FourOfKindsAces++;
					  VertLite->SetRow(8);
               }
               else if(GetCasPlayer(activeplayer)->pHand->highcard < Five)
               {
                 winnerpaid += coinsplayed*50;
                 winhand = "Four of a Kind(2-4)";
                 cs.TotalFourOfKinds2_4Cash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.FourOfKinds2_4++;
					  VertLite->SetRow(7);
               }
               else
               {
                 winnerpaid += coinsplayed*25;
                 winhand = "Four of a Kind(5-K)";
                 cs.TotalFourOfKinds5_KCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.FourOfKinds5_K++;
					  VertLite->SetRow(6);
               }
               break;
	 case StraightFlush :
               if (GetCasPlayer(activeplayer)->pHand->highcard == AceHi)
					{
					  if(coinsplayed == 5)
					  {
						 winnerpaid += 4000;
                   winhand = "Royal Flush";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  else
					  {
						 winnerpaid += coinsplayed*250;
                   winhand = "Royal Flush";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  VertLite->SetRow(10);
                 break;
					}
					else
					{
					  winnerpaid += coinsplayed*40;winhand = "Straight Flush";
					  cs.TotalStraightFlushCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.StraightFlushes++;
					  VertLite->SetRow(9);
                 break;
					}
	 default : return 1;
  }
  return 1;
}

//*******************************************************************
TMoney TACVPVPGLord::PayOutGamblersEdge()
{
  int16 session = GetCasPD(activeplayer)->VPData.CurrentSession;
  TCVPSession &cs = GetCasPD(activeplayer)->VPData.Sessions[session];

  switch (GetCasPlayer(activeplayer)->pHand->highhand)
  {
	 case Pair :
               if(GetCasPlayer(activeplayer)->pHand->highcard > Ten)
					{
					  fake->highcard = GetCasPlayer(activeplayer)->pHand->highcard;
					  winnerpaid += coinsplayed*1;
					  cs.TotalHighPairCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.HighPairs++;
					  switch(GetCasPlayer(activeplayer)->pHand->highcard)
                 {
						 case Ten   : winhand = "Pair of Tens";break;
						 case Jack  : winhand = "Pair of Jacks";break;
						 case Queen : winhand = "Pair of Queens";break;
						 case King  : winhand = "Pair of Kings";break;
						 case AceHi : winhand = "Pair of Aces";break;
					  }
					  VertLite->SetRow(0);
					}
					break;
	 case TwoPair :
               winnerpaid += coinsplayed*2;
               winhand = "Two Pair";
					cs.TotalTwoPairCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.TwoPairs++;
					VertLite->SetRow(1);
               break;
	 case ThreeKind :
               winnerpaid += coinsplayed*3;
               winhand = "Three of a Kind";
					cs.TotalThreeOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.ThreeOfKinds++;
					VertLite->SetRow(2);
               break;
	 case Straight :
               winnerpaid += coinsplayed*4;
               winhand = "Straight";
					cs.TotalStraightCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Straights++;
					VertLite->SetRow(3);
               break;
	 case Flush :
               winnerpaid += coinsplayed*5;
               winhand = "Flush";
					cs.TotalFlushCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Flushes++;
					VertLite->SetRow(4);
               break;
	 case FullHouse :
               winnerpaid += coinsplayed*9;
               winhand = "Full House";
					cs.TotalFullHouseCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FullHouses++;
					VertLite->SetRow(5);
               break;
	 case FourKind :
               winnerpaid += coinsplayed*25;
               winhand = "Four of a Kind";
					cs.TotalFourOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FourOfKinds++;
					VertLite->SetRow(6);
               break;
	 case StraightFlush :
               if (GetCasPlayer(activeplayer)->pHand->highcard == AceHi)
					{
					  if(coinsplayed == 5)
					  {
						 winnerpaid += 4000;
                   winhand = "Royal Flush";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  else
					  {
						 winnerpaid += coinsplayed*250;
                   winhand = "Royal Flush";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  VertLite->SetRow(8);
                 break;
					}
					else
					{
					  winnerpaid += coinsplayed*50;winhand = "Straight Flush";
					  cs.TotalStraightFlushCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.StraightFlushes++;
					  VertLite->SetRow(7);
                 break;
					}
	 default : return 1;
  }
  return 1;
}
//*******************************************************************
TMoney TACVPVPGLord::PayOutHeartBonus()
{
  int16 session = GetCasPD(activeplayer)->VPData.CurrentSession;
  TCVPSession &cs = GetCasPD(activeplayer)->VPData.Sessions[session];

  switch (GetCasPlayer(activeplayer)->pHand->highhand)
  {
	 case Pair :
               if(GetCasPlayer(activeplayer)->pHand->highcard > Ten)
					{
					  fake->highcard = GetCasPlayer(activeplayer)->pHand->highcard;
					  winnerpaid += coinsplayed*1;
					  cs.TotalHighPairCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.HighPairs++;
					  switch(GetCasPlayer(activeplayer)->pHand->highcard)
                 {
						 case Ten   : winhand = "Pair of Tens";break;
						 case Jack  : winhand = "Pair of Jacks";break;
						 case Queen : winhand = "Pair of Queens";break;
						 case King  : winhand = "Pair of Kings";break;
						 case AceHi : winhand = "Pair of Aces";break;
					  }
					  VertLite->SetRow(0);
					}
					break;
	 case TwoPair :
               winnerpaid += coinsplayed*2;
               winhand = "Two Pair";
					cs.TotalTwoPairCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.TwoPairs++;
					VertLite->SetRow(1);
               break;
	 case ThreeKind :
               winnerpaid += coinsplayed*3;
               winhand = "Three of a Kind";
					cs.TotalThreeOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.ThreeOfKinds++;
					VertLite->SetRow(2);
               break;
	 case Straight :
               winnerpaid += coinsplayed*4;
               winhand = "Straight";
					cs.TotalStraightCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Straights++;
					VertLite->SetRow(3);
               break;
	 case Flush :
               if(GetCasPlayer(activeplayer)->pHand->highcardsuit == Heart)
					{
					  winnerpaid += coinsplayed*8;
                 winhand = "Heart Flush";
					  VertLite->SetRow(5);
                 cs.TotalFlushHeartCash += winnerpaid*coinsize;
                 cs.FlushHeart++;
               }
               else
               {
                 winnerpaid += coinsplayed*5;
                 winhand = "Flush";
                 VertLite->SetRow(4);
                 cs.TotalFlushCash += winnerpaid*coinsize;
                 cs.Flushes++;
               }
					cs.Wins++;
               break;
	 case FullHouse :
               winnerpaid += coinsplayed*8;
               winhand = "Full House";
					cs.TotalFullHouseCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FullHouses++;
					VertLite->SetRow(6);
               break;
	 case FourKind :
               winnerpaid += coinsplayed*25;
               winhand = "Four of a Kind";
					cs.TotalFourOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FourOfKinds++;
					VertLite->SetRow(7);
               break;
	 case StraightFlush :
               if (GetCasPlayer(activeplayer)->pHand->highcard == AceHi)
					{
					  if(coinsplayed == 5)
					  {
                   if(GetCasPlayer(activeplayer)->pHand->highcardsuit == Heart)
					    {
                     winnerpaid += 4700;
                     winhand = "Heart Royal Flush";
						   cs.TotalRoyalFlushesHeartCash += winnerpaid*coinsize;
						   cs.Wins++;
						   cs.RoyalFlushesHeart++;
                     VertLite->SetRow(11);
                   }
                   else
                   {
                     winnerpaid += 4000;
                     winhand = "Royal Flush";
						   cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						   cs.Wins++;
						   cs.NaturalRoyals++;
                     VertLite->SetRow(10);
                   }
					  }
					  else
					  {
						 if(GetCasPlayer(activeplayer)->pHand->highcardsuit == Heart)
					    {
                     winnerpaid += coinsplayed*300;
                     winhand = "Heart Royal Flush";
						   cs.TotalRoyalFlushesHeartCash += winnerpaid*coinsize;
						   cs.Wins++;
						   cs.RoyalFlushesHeart++;
                     VertLite->SetRow(11);
                   }
                   else
                   {
                     winnerpaid += coinsplayed*250;
                     winhand = "Royal Flush";
						   cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						   cs.Wins++;
						   cs.NaturalRoyals++;
                     VertLite->SetRow(10);
                   }
					  }
                 break;
					}
					else
					{
					  if(GetCasPlayer(activeplayer)->pHand->highcardsuit == Heart)
                 {
                   winnerpaid += coinsplayed*200;winhand = "heart Straight Flush";
					    cs.TotalStraightFlushesHeartCash += winnerpaid*coinsize;
					    cs.Wins++;
					    cs.StraightFlushesHeart++;
					    VertLite->SetRow(9);
                 }
                 else
                 {
                   winnerpaid += coinsplayed*50;winhand = "Straight Flush";
					    cs.TotalStraightFlushCash += winnerpaid*coinsize;
					    cs.Wins++;
					    cs.StraightFlushes++;
					    VertLite->SetRow(8);
                 }
                 break;
					}
	 default : return 1;
  }
  return 1;
}

//*******************************************************************
TMoney TACVPVPGLord::PayOutBlackJacks()
{
  int16 session = GetCasPD(activeplayer)->VPData.CurrentSession;
  TCVPSession &cs = GetCasPD(activeplayer)->VPData.Sessions[session];
  int BJackCount=0;
  int xx=0;
  for(xx=0;xx<5;xx++)
  {
    if((GetCasPlayer(activeplayer)->pHand->cards[xx].suit == Club ||
        GetCasPlayer(activeplayer)->pHand->cards[xx].suit == Spade ) &&
        GetCasPlayer(activeplayer)->pHand->cards[xx].name == Jack      )
    {
      BJackCount += 2;
    }
  }
  if(BJackCount == 0){BJackCount = 1;}
  switch (GetCasPlayer(activeplayer)->pHand->highhand)
  {
	 case Pair :
               if(GetCasPlayer(activeplayer)->pHand->highcard > Ten)
					{
					  fake->highcard = GetCasPlayer(activeplayer)->pHand->highcard;
					  winnerpaid += coinsplayed*1*BJackCount;
					  cs.TotalHighPairCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.HighPairs++;
					  switch(GetCasPlayer(activeplayer)->pHand->highcard)
                 {
						 case Ten   : winhand = "Pair of Tens";break;
						 case Jack  : winhand = "Pair of Jacks";break;
						 case Queen : winhand = "Pair of Queens";break;
						 case King  : winhand = "Pair of Kings";break;
						 case AceHi : winhand = "Pair of Aces";break;
					  }
					  VertLite->SetRow(0);
					}
					break;
	 case TwoPair :
               winnerpaid += coinsplayed*1*BJackCount;
               winhand = "Two Pair";
					cs.TotalTwoPairCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.TwoPairs++;
					VertLite->SetRow(1);
               break;
	 case ThreeKind :
               winnerpaid += coinsplayed*2*BJackCount;
               winhand = "Three of a Kind";
					cs.TotalThreeOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.ThreeOfKinds++;
					VertLite->SetRow(2);
               break;
	 case Straight :
               winnerpaid += coinsplayed*5*BJackCount;
               winhand = "Straight";
					cs.TotalStraightCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Straights++;
					VertLite->SetRow(3);
               break;
	 case Flush :
               winnerpaid += coinsplayed*5*BJackCount;
               winhand = "Flush";
					cs.TotalFlushCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Flushes++;
					VertLite->SetRow(4);
               break;
	 case FullHouse :
               winnerpaid += coinsplayed*5*BJackCount;
               winhand = "Full House";
					cs.TotalFullHouseCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FullHouses++;
					VertLite->SetRow(5);
               break;
	 case FourKind :
               winnerpaid += coinsplayed*25*BJackCount;
               winhand = "Four of a Kind";
					cs.TotalFourOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FourOfKinds++;
					VertLite->SetRow(6);
               break;
	 case StraightFlush :
               if (GetCasPlayer(activeplayer)->pHand->highcard == AceHi)
					{

					  winnerpaid += coinsplayed*600*BJackCount;
                 winhand = "Royal Flush";
					  cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.NaturalRoyals++;
					  VertLite->SetRow(8);
                 break;
					}
					else
					{
					  winnerpaid += coinsplayed*50*BJackCount;winhand = "Straight Flush";
					  cs.TotalStraightFlushCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.StraightFlushes++;
					  VertLite->SetRow(7);
                 break;
					}
	 default : return 1;
  }
  return 1;
}

//*******************************************************************
TMoney TACVPVPGLord::PayOutJacksBetterProg()
{
  int16 session = GetCasPD(activeplayer)->VPData.CurrentSession;
  TCVPSession &cs = GetCasPD(activeplayer)->VPData.Sessions[session];

  switch (GetCasPlayer(activeplayer)->pHand->highhand)
  {
	 case Pair :
               if(GetCasPlayer(activeplayer)->pHand->highcard > Ten)
					{
					  fake->highcard = GetCasPlayer(activeplayer)->pHand->highcard;
					  winnerpaid += coinsplayed*1;
					  cs.TotalHighPairCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.HighPairs++;
					  switch(GetCasPlayer(activeplayer)->pHand->highcard)
                 {
						 case Ten   : winhand = "Pair of Tens";break;
						 case Jack  : winhand = "Pair of Jacks";break;
						 case Queen : winhand = "Pair of Queens";break;
						 case King  : winhand = "Pair of Kings";break;
						 case AceHi : winhand = "Pair of Aces";break;
					  }
					  VertLite->SetRow(0);
					}
					break;
	 case TwoPair :
               winnerpaid += coinsplayed*2;
               winhand = "Two Pair";
					cs.TotalTwoPairCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.TwoPairs++;
					VertLite->SetRow(1);
               break;
	 case ThreeKind :
               winnerpaid += coinsplayed*3;
               winhand = "Three of a Kind";
					cs.TotalThreeOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.ThreeOfKinds++;
					VertLite->SetRow(2);
               break;
	 case Straight :
               winnerpaid += coinsplayed*4;
               winhand = "Straight";
					cs.TotalStraightCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Straights++;
					VertLite->SetRow(3);
               break;
	 case Flush :
               winnerpaid += coinsplayed*5;
               winhand = "Flush";
					cs.TotalFlushCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Flushes++;
					VertLite->SetRow(4);
               break;
	 case FullHouse :
               winnerpaid += coinsplayed*8;
               winhand = "Full House";
					cs.TotalFullHouseCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FullHouses++;
					VertLite->SetRow(5);
               break;
	 case FourKind :
               winnerpaid += coinsplayed*25;
               winhand = "Four of a Kind";
					cs.TotalFourOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FourOfKinds++;
					VertLite->SetRow(6);
               break;
	 case StraightFlush :
               if (GetCasPlayer(activeplayer)->pHand->highcard == AceHi)
					{
					  if(coinsplayed == 5)
					  {
						 winnerpaid += ((int16)(progressive1/coinsize))+1;
                   progressive1 = coinsize*4000;
                   winhand = "Royal Flush";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  else
					  {
						 winnerpaid += coinsplayed*250;
                   winhand = "Royal Flush";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  VertLite->SetRow(8);
                 break;
					}
					else
					{
					  winnerpaid += coinsplayed*50;winhand = "Straight Flush";
					  cs.TotalStraightFlushCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.StraightFlushes++;
					  VertLite->SetRow(7);
                 break;
					}
	 default : return 1;
  }
  return 1;
}

//*******************************************************************
TMoney TACVPVPGLord::PayOutJackpotBonus()
{
  int16 session = GetCasPD(activeplayer)->VPData.CurrentSession;
  TCVPSession &cs = GetCasPD(activeplayer)->VPData.Sessions[session];

  switch (GetCasPlayer(activeplayer)->pHand->highhand)
  {
	 case Pair :
               if(GetCasPlayer(activeplayer)->pHand->highcard > Ten)
					{
					  fake->highcard = GetCasPlayer(activeplayer)->pHand->highcard;
					  winnerpaid += coinsplayed*1;
					  cs.TotalHighPairCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.HighPairs++;
					  switch(GetCasPlayer(activeplayer)->pHand->highcard)
                 {
						 case Ten   : winhand = "Pair of Tens";break;
						 case Jack  : winhand = "Pair of Jacks";break;
						 case Queen : winhand = "Pair of Queens";break;
						 case King  : winhand = "Pair of Kings";break;
						 case AceHi : winhand = "Pair of Aces";break;
					  }
					  VertLite->SetRow(0);
					}
					break;
	 case TwoPair :
               winnerpaid += coinsplayed*2;
               winhand = "Two Pair";
					cs.TotalTwoPairCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.TwoPairs++;
					VertLite->SetRow(1);
               break;
	 case ThreeKind :
               winnerpaid += coinsplayed*3;
               winhand = "Three of a Kind";
					cs.TotalThreeOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.ThreeOfKinds++;
					VertLite->SetRow(2);
               break;
	 case Straight :
               winnerpaid += coinsplayed*4;
               winhand = "Straight";
					cs.TotalStraightCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Straights++;
					VertLite->SetRow(3);
               break;
	 case Flush :
               winnerpaid += coinsplayed*5;
               winhand = "Flush";
					cs.TotalFlushCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Flushes++;
					VertLite->SetRow(4);
               break;
	 case FullHouse :
               winnerpaid += coinsplayed*7;
               winhand = "Full House";
					cs.TotalFullHouseCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FullHouses++;
					VertLite->SetRow(5);
               break;
	 case FourKind :
               winnerpaid += coinsplayed*16;
               winnerpaid += GetJackpotBonusAmount();
               winhand = "Four of a Kind";
					cs.TotalFourOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FourOfKinds++;
					VertLite->SetRow(6);
               break;
	 case StraightFlush :
               if (GetCasPlayer(activeplayer)->pHand->highcard == AceHi)
					{
					  if(coinsplayed == 5)
					  {
						 winnerpaid += 4000;
                   winhand = "Royal Flush";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  else
					  {
						 winnerpaid += coinsplayed*250;
                   winhand = "Royal Flush";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  VertLite->SetRow(8);
                 break;
					}
					else
					{
					  winnerpaid += coinsplayed*50;winhand = "Straight Flush";
					  cs.TotalStraightFlushCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.StraightFlushes++;
					  VertLite->SetRow(7);
                 break;
					}
	 default : return 1;
  }
  return 1;
}

//*******************************************************************
TMoney TACVPVPGLord::PayOutJacksBetter96()
{
  int16 session = GetCasPD(activeplayer)->VPData.CurrentSession;
  TCVPSession &cs = GetCasPD(activeplayer)->VPData.Sessions[session];

  switch (GetCasPlayer(activeplayer)->pHand->highhand)
  {
	 case Pair :
               if(GetCasPlayer(activeplayer)->pHand->highcard > Ten)
					{
					  fake->highcard = GetCasPlayer(activeplayer)->pHand->highcard;
					  winnerpaid += coinsplayed*1;
					  cs.TotalHighPairCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.HighPairs++;
					  switch(GetCasPlayer(activeplayer)->pHand->highcard)
                 {
						 case Ten   : winhand = "Pair of Tens";break;
						 case Jack  : winhand = "Pair of Jacks";break;
						 case Queen : winhand = "Pair of Queens";break;
						 case King  : winhand = "Pair of Kings";break;
						 case AceHi : winhand = "Pair of Aces";break;
					  }
					  VertLite->SetRow(0);
					}
					break;
	 case TwoPair :
               winnerpaid += coinsplayed*2;
               winhand = "Two Pair";
					cs.TotalTwoPairCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.TwoPairs++;
					VertLite->SetRow(1);
               break;
	 case ThreeKind :
               winnerpaid += coinsplayed*3;
               winhand = "Three of a Kind";
					cs.TotalThreeOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.ThreeOfKinds++;
					VertLite->SetRow(2);
               break;
	 case Straight :
               winnerpaid += coinsplayed*4;
               winhand = "Straight";
					cs.TotalStraightCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Straights++;
					VertLite->SetRow(3);
               break;
	 case Flush :
               winnerpaid += coinsplayed*6;
               winhand = "Flush";
					cs.TotalFlushCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Flushes++;
					VertLite->SetRow(4);
               break;
	 case FullHouse :
               winnerpaid += coinsplayed*9;
               winhand = "Full House";
					cs.TotalFullHouseCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FullHouses++;
					VertLite->SetRow(5);
               break;
	 case FourKind :
               winnerpaid += coinsplayed*25;
               winhand = "Four of a Kind";
					cs.TotalFourOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FourOfKinds++;
					VertLite->SetRow(6);
               break;
	 case StraightFlush :
               if (GetCasPlayer(activeplayer)->pHand->highcard == AceHi)
					{
					  if(coinsplayed == 5)
					  {
						 winnerpaid += 4000;
                   winhand = "Royal Flush";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  else
					  {
						 winnerpaid += coinsplayed*250;
                   winhand = "Royal Flush";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  VertLite->SetRow(8);
                 break;
					}
					else
					{
					  winnerpaid += coinsplayed*50;winhand = "Straight Flush";
					  cs.TotalStraightFlushCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.StraightFlushes++;
					  VertLite->SetRow(7);
                 break;
					}
	 default : return 1;
  }
  return 1;
}

//*******************************************************************
TMoney TACVPVPGLord::PayOutJacksBetter85()
{
  int16 session = GetCasPD(activeplayer)->VPData.CurrentSession;
  TCVPSession &cs = GetCasPD(activeplayer)->VPData.Sessions[session];

  switch (GetCasPlayer(activeplayer)->pHand->highhand)
  {
	 case Pair :
               if(GetCasPlayer(activeplayer)->pHand->highcard > Ten)
					{
					  fake->highcard = GetCasPlayer(activeplayer)->pHand->highcard;
					  winnerpaid += coinsplayed*1;
					  cs.TotalHighPairCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.HighPairs++;
					  switch(GetCasPlayer(activeplayer)->pHand->highcard)
                 {
						 case Ten   : winhand = "Pair of Tens";break;
						 case Jack  : winhand = "Pair of Jacks";break;
						 case Queen : winhand = "Pair of Queens";break;
						 case King  : winhand = "Pair of Kings";break;
						 case AceHi : winhand = "Pair of Aces";break;
					  }
					  VertLite->SetRow(0);
					}
					break;
	 case TwoPair :
               winnerpaid += coinsplayed*2;
               winhand = "Two Pair";
					cs.TotalTwoPairCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.TwoPairs++;
					VertLite->SetRow(1);
               break;
	 case ThreeKind :
               winnerpaid += coinsplayed*3;
               winhand = "Three of a Kind";
					cs.TotalThreeOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.ThreeOfKinds++;
					VertLite->SetRow(2);
               break;
	 case Straight :
               winnerpaid += coinsplayed*4;
               winhand = "Straight";
					cs.TotalStraightCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Straights++;
					VertLite->SetRow(3);
               break;
	 case Flush :
               winnerpaid += coinsplayed*5;
               winhand = "Flush";
					cs.TotalFlushCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Flushes++;
					VertLite->SetRow(4);
               break;
	 case FullHouse :
               winnerpaid += coinsplayed*8;
               winhand = "Full House";
					cs.TotalFullHouseCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FullHouses++;
					VertLite->SetRow(5);
               break;
	 case FourKind :
               winnerpaid += coinsplayed*25;
               winhand = "Four of a Kind";
					cs.TotalFourOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FourOfKinds++;
					VertLite->SetRow(6);
               break;
	 case StraightFlush :
               if (GetCasPlayer(activeplayer)->pHand->highcard == AceHi)
					{
					  if(coinsplayed == 5)
					  {
						 winnerpaid += 4000;
                   winhand = "Royal Flush";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  else
					  {
						 winnerpaid += coinsplayed*250;
                   winhand = "Royal Flush";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  VertLite->SetRow(8);
                 break;
					}
					else
					{
					  winnerpaid += coinsplayed*50;winhand = "Straight Flush";
					  cs.TotalStraightFlushCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.StraightFlushes++;
					  VertLite->SetRow(7);
                 break;
					}
	 default : return 1;
  }
  return 1;
}

//*******************************************************************
TMoney TACVPVPGLord::PayOutJacksBetterDoubleD()
{
  int16 session = GetCasPD(activeplayer)->VPData.CurrentSession;
  TCVPSession &cs = GetCasPD(activeplayer)->VPData.Sessions[session];

  switch (GetCasPlayer(activeplayer)->pHand->highhand)
  {
	 case Pair :
               if(GetCasPlayer(activeplayer)->pHand->highcard > Ten)
					{
					  fake->highcard = GetCasPlayer(activeplayer)->pHand->highcard;
					  winnerpaid += coinsplayed*1;
					  cs.TotalHighPairCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.HighPairs++;
					  switch(GetCasPlayer(activeplayer)->pHand->highcard)
                 {
						 case Ten   : winhand = "Pair of Tens";break;
						 case Jack  : winhand = "Pair of Jacks";break;
						 case Queen : winhand = "Pair of Queens";break;
						 case King  : winhand = "Pair of Kings";break;
						 case AceHi : winhand = "Pair of Aces";break;
					  }
					  VertLite->SetRow(0);
					}
					break;
	 case TwoPair :
               winnerpaid += coinsplayed*2;
               winhand = "Two Pair";
					cs.TotalTwoPairCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.TwoPairs++;
					VertLite->SetRow(1);
               break;
	 case ThreeKind :
               winnerpaid += coinsplayed*3;
               winhand = "Three of a Kind";
					cs.TotalThreeOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.ThreeOfKinds++;
					VertLite->SetRow(2);
               break;
	 case Straight :
               winnerpaid += coinsplayed*4;
               winhand = "Straight";
					cs.TotalStraightCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Straights++;
					VertLite->SetRow(3);
               break;
	 case Flush :
               winnerpaid += coinsplayed*5;
               winhand = "Flush";
					cs.TotalFlushCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Flushes++;
					VertLite->SetRow(4);
               break;
	 case FullHouse :
               winnerpaid += coinsplayed*8;
               winhand = "Full House";
					cs.TotalFullHouseCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FullHouses++;
					VertLite->SetRow(5);
               break;
	 case FourKind :
               winnerpaid += coinsplayed*25;
               winhand = "Four of a Kind";
					cs.TotalFourOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FourOfKinds++;
					VertLite->SetRow(6);
               break;
	 case StraightFlush :
               if (GetCasPlayer(activeplayer)->pHand->highcard == AceHi)
					{
					  if(coinsplayed == 5)
					  {
						 winnerpaid += 4000;
                   winhand = "Royal Flush";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  else
					  {
						 winnerpaid += coinsplayed*250;
                   winhand = "Royal Flush";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  VertLite->SetRow(8);
                 break;
					}
					else
					{
					  winnerpaid += coinsplayed*50;winhand = "Straight Flush";
					  cs.TotalStraightFlushCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.StraightFlushes++;
					  VertLite->SetRow(7);
                 break;
					}
	 default : return 1;
  }
  return 1;
}

//*******************************************************************
TMoney TACVPVPGLord::PayOutJokerWildProg()
{
  int16 session = GetCasPD(activeplayer)->VPData.CurrentSession;
  TCVPSession &cs = GetCasPD(activeplayer)->VPData.Sessions[session];

  switch (GetCasPlayer(activeplayer)->pHand->highhand)
  {
	 case Pair :
               if(GetCasPlayer(activeplayer)->pHand->highcard > Queen)
					{
					  fake->highcard = GetCasPlayer(activeplayer)->pHand->highcard;
					  winnerpaid += coinsplayed*1;
					  cs.TotalHighPairCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.HighPairs++;
					  switch(GetCasPlayer(activeplayer)->pHand->highcard)
                 {
						 case Ten   : winhand = "Pair of Tens";break;
						 case Jack  : winhand = "Pair of Jacks";break;
						 case Queen : winhand = "Pair of Queens";break;
						 case King  : winhand = "Pair of Kings";break;
						 case AceHi : winhand = "Pair of Aces";break;
					  }
					  VertLite->SetRow(0);
					}
					break;
	 case TwoPair :
               winnerpaid += coinsplayed*1;
               winhand = "Two Pair";
					cs.TotalTwoPairCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.TwoPairs++;
					VertLite->SetRow(1);
               break;
	 case ThreeKind :
               winnerpaid += coinsplayed*2;
               winhand = "Three of a Kind";
					cs.TotalThreeOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.ThreeOfKinds++;
					VertLite->SetRow(2);
               break;
	 case Straight :
               winnerpaid += coinsplayed*3;
               winhand = "Straight";
					cs.TotalStraightCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Straights++;
					VertLite->SetRow(3);
               break;
	 case Flush :
               winnerpaid += coinsplayed*5;
               winhand = "Flush";
					cs.TotalFlushCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Flushes++;
					VertLite->SetRow(4);
               break;
	 case FullHouse :
               winnerpaid += coinsplayed*7;
               winhand = "Full House";
					cs.TotalFullHouseCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FullHouses++;
					VertLite->SetRow(5);
               break;
	 case FourKind :
               winnerpaid += coinsplayed*15;
               winhand = "Four of a Kind";
					cs.TotalFourOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FourOfKinds++;
					VertLite->SetRow(6);
               break;
	 case StraightFlush :
               if (GetCasPlayer(activeplayer)->pHand->highcard == AceHi)
					{
					  if(coinsplayed == 5)
					  {
						 winnerpaid += ((int16)(progressive1/coinsize))+1;
                   progressive1 = coinsize*4000;
                   winhand = "Royal Flush(Nat)";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  else
					  {
						 winnerpaid += coinsplayed*400;
                   winhand = "Royal Flush(Nat)";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  VertLite->SetRow(10);
                 break;
					}
					else
					{
					  winnerpaid += coinsplayed*50;winhand = "Straight Flush";
					  cs.TotalStraightFlushCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.StraightFlushes++;
					  VertLite->SetRow(7);
                 break;
					}
	 case  WildRFlush :
                 winnerpaid += coinsplayed*100;
                 winhand = "Royal Flush Joker";
					  cs.TotalWildRoyalCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.WildRoyals++;
					  VertLite->SetRow(8);
                 break;
    case FiveKind :
               winnerpaid += coinsplayed*200;
               winhand = "Five of a Kind";
				   cs.TotalFiveOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
				  	cs.FiveOfKinds++;
					VertLite->SetRow(9);
               break;
    default : return 1;
  }
  return 1;
}

//*******************************************************************
TMoney TACVPVPGLord::PayOutJumpinJoker()
{
  int16 session = GetCasPD(activeplayer)->VPData.CurrentSession;
  TCVPSession &cs = GetCasPD(activeplayer)->VPData.Sessions[session];

  switch (GetCasPlayer(activeplayer)->pHand->highhand)
  {
	 case ThreeKind :
               winnerpaid += coinsplayed*1;
               winhand = "Three of a Kind";
					cs.TotalThreeOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.ThreeOfKinds++;
					VertLite->SetRow(0);
               break;
	 case Straight :
               winnerpaid += coinsplayed*2;
               winhand = "Straight";
					cs.TotalStraightCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Straights++;
					VertLite->SetRow(1);
               break;
	 case Flush :
               winnerpaid += coinsplayed*2;
               winhand = "Flush";
					cs.TotalFlushCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Flushes++;
					VertLite->SetRow(2);
               break;
	 case FullHouse :
               winnerpaid += coinsplayed*3;
               winhand = "Full House";
					cs.TotalFullHouseCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FullHouses++;
					VertLite->SetRow(3);
               break;
	 case FourKind :
               winnerpaid += coinsplayed*4;
               winhand = "Four of a Kind";
					cs.TotalFourOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FourOfKinds++;
					VertLite->SetRow(4);
               break;
	 case StraightFlush :
               if (GetCasPlayer(activeplayer)->pHand->highcard == AceHi)
					{
					  if(coinsplayed == 5)
					  {
						 winnerpaid += 4000;
                   winhand = "Royal Flush(Nat)";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  else
					  {
						 winnerpaid += coinsplayed*250;
                   winhand = "Royal Flush(Nat)";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  VertLite->SetRow(9);
                 break;
					}
					else
					{
					  winnerpaid += coinsplayed*9;winhand = "Straight Flush";
					  cs.TotalStraightFlushCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.StraightFlushes++;
					  VertLite->SetRow(5);
                 break;
					}
	 case  WildRFlush :
                 winnerpaid += coinsplayed*20;
                 winhand = "Royal Flush Jokers";
					  cs.TotalWildRoyalCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.WildRoyals++;
					  VertLite->SetRow(7);
                 break;
    case FiveKind :
               winnerpaid += coinsplayed*13;
               winhand = "Five of a Kind";
				   cs.TotalFiveOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
				  	cs.FiveOfKinds++;
					VertLite->SetRow(6);
               break;
    case FourJokers :
               winnerpaid += coinsplayed*40;
               winhand = "Four Jokers";
				 //????mike  cs.TotalFiveKind += winnerpaid*coinsize;
					cs.Wins++;
				 //????mike	cs.FiveKind++;
					VertLite->SetRow(8);
               break;
    case FiveJokers :
               if(coinsplayed == 5)
               {
                 winnerpaid += 4000;
               }
               else
               {
                 winnerpaid += coinsplayed*250;
               }
               winhand = "Five Jokers";
				   cs.TotalFiveOfKindsJokerCash += winnerpaid*coinsize;
					cs.Wins++;
				 	cs.FiveOfKindsJoker++;
					VertLite->SetRow(10);
               break;
    default : return 1;
  }
  return 1;
}

//*******************************************************************
TMoney TACVPVPGLord::PayOutTripProg()
{
  int16 session = GetCasPD(activeplayer)->VPData.CurrentSession;
  TCVPSession &cs = GetCasPD(activeplayer)->VPData.Sessions[session];

  switch (GetCasPlayer(activeplayer)->pHand->highhand)
  {
	 case Pair :
               if(GetCasPlayer(activeplayer)->pHand->highcard > Ten)
					{
					  fake->highcard = GetCasPlayer(activeplayer)->pHand->highcard;
					  winnerpaid += coinsplayed*1;
					  cs.TotalHighPairCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.HighPairs++;
					  switch(GetCasPlayer(activeplayer)->pHand->highcard)
                 {
						 case Ten   : winhand = "Pair of Tens";break;
						 case Jack  : winhand = "Pair of Jacks";break;
						 case Queen : winhand = "Pair of Queens";break;
						 case King  : winhand = "Pair of Kings";break;
						 case AceHi : winhand = "Pair of Aces";break;
					  }
					  VertLite->SetRow(0);
					}
					break;
	 case TwoPair :
               winnerpaid += coinsplayed*2;
               winhand = "Two Pair";
					cs.TotalTwoPairCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.TwoPairs++;
					VertLite->SetRow(1);
               break;
	 case ThreeKind :
               winnerpaid += coinsplayed*3;
               winhand = "Three of a Kind";
					cs.TotalThreeOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.ThreeOfKinds++;
					VertLite->SetRow(2);
               break;
	 case Straight :
               winnerpaid += coinsplayed*4;
               winhand = "Straight";
					cs.TotalStraightCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Straights++;
					VertLite->SetRow(3);
               break;
	 case Flush :
               winnerpaid += coinsplayed*5;
               winhand = "Flush";
					cs.TotalFlushCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Flushes++;
					VertLite->SetRow(4);
               break;
	 case FullHouse :
               winnerpaid += coinsplayed*7;
               winhand = "Full House";
					cs.TotalFullHouseCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FullHouses++;
					VertLite->SetRow(5);
               break;
	 case FourKind :
               if(GetCasPlayer(activeplayer)->pHand->highcard == AceHi)
               {
                 if(coinsplayed == 5)
                 {
                   winnerpaid += ((int16)(progressive2/coinsize))+1;
                   progressive2 = 500*coinsize;
                 }
                 else
                 {
                   winnerpaid += coinsplayed*80;
                 }
                 winhand = "Four Aces";
                 cs.TotalFourOfKindsAcesCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.FourOfKindsAces++;
					  VertLite->SetRow(8);
               }
               else if(GetCasPlayer(activeplayer)->pHand->highcard < Five)
               {
                 if(coinsplayed == 5)
                 {
                   winnerpaid += ((int16)(progressive3/coinsize))+1;
                   progressive3 = 250*coinsize;
                 }
                 else
                 {
                   winnerpaid += coinsplayed*40;
                 }
                 winhand = "Four of a Kind(2-4)";
                 cs.TotalFourOfKinds2_4Cash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.FourOfKinds2_4++;
					  VertLite->SetRow(7);
               }
               else
               {
                 winnerpaid += coinsplayed*25;
                 winhand = "Four of a Kind(5-K)";
                 cs.TotalFourOfKinds5_KCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.FourOfKinds5_K++;
					  VertLite->SetRow(6);
               }
               break;
	 case StraightFlush :
               if (GetCasPlayer(activeplayer)->pHand->highcard == AceHi)
					{
					  if(coinsplayed == 5)
					  {
						 winnerpaid += ((int16)(progressive1/coinsize))+1;
                   progressive1 = coinsize*4000;
                   winhand = "Royal Flush";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  else
					  {
						 winnerpaid += coinsplayed*250;
                   winhand = "Royal Flush";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  VertLite->SetRow(10);
                 break;
					}
					else
					{
					  winnerpaid += coinsplayed*50;winhand = "Straight Flush";
					  cs.TotalStraightFlushCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.StraightFlushes++;
					  VertLite->SetRow(9);
                 break;
					}
	 default : return 1;
  }
  return 1;
}

//*******************************************************************
TMoney TACVPVPGLord::PayOutProgRoyals()
{
  int16 session = GetCasPD(activeplayer)->VPData.CurrentSession;
  TCVPSession &cs = GetCasPD(activeplayer)->VPData.Sessions[session];

  switch (GetCasPlayer(activeplayer)->pHand->highhand)
  {
	 case Pair :
               if(GetCasPlayer(activeplayer)->pHand->highcard > Ten)
					{
					  fake->highcard = GetCasPlayer(activeplayer)->pHand->highcard;
					  winnerpaid += coinsplayed*1;
					  cs.TotalHighPairCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.HighPairs++;
					  switch(GetCasPlayer(activeplayer)->pHand->highcard)
                 {
						 case Ten   : winhand = "Pair of Tens";break;
						 case Jack  : winhand = "Pair of Jacks";break;
						 case Queen : winhand = "Pair of Queens";break;
						 case King  : winhand = "Pair of Kings";break;
						 case AceHi : winhand = "Pair of Aces";break;
					  }
					  VertLite->SetRow(0);
					}
					break;
	 case TwoPair :
               winnerpaid += coinsplayed*2;
               winhand = "Two Pair";
					cs.TotalTwoPairCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.TwoPairs++;
					VertLite->SetRow(1);
               break;
	 case ThreeKind :
               winnerpaid += coinsplayed*3;
               winhand = "Three of a Kind";
					cs.TotalThreeOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.ThreeOfKinds++;
					VertLite->SetRow(2);
               break;
	 case Straight :
               winnerpaid += coinsplayed*4;
               winhand = "Straight";
					cs.TotalStraightCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Straights++;
					VertLite->SetRow(3);
               break;
	 case Flush :
               winnerpaid += coinsplayed*5;
               winhand = "Flush";
					cs.TotalFlushCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Flushes++;
					VertLite->SetRow(4);
               break;
	 case FullHouse :
               winnerpaid += coinsplayed*8;
               winhand = "Full House";
					cs.TotalFullHouseCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FullHouses++;
					VertLite->SetRow(5);
               break;
	 case FourKind :
               winnerpaid += coinsplayed*25;
               winhand = "Four of a Kind";
					cs.TotalFourOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FourOfKinds++;
					VertLite->SetRow(6);
               break;
	 case StraightFlush :
               if (GetCasPlayer(activeplayer)->pHand->highcard == AceHi)
					{
					  if(coinsplayed == 5)
					  {
                   switch(GetCasPlayer(activeplayer)->pHand->highcardsuit)
                   {
                     case Club    : winnerpaid += ((int16)(progressive1/coinsize))+1;
                                    progressive1 = coinsize*4000;break;
                     case Diamond : winnerpaid += ((int16)(progressive2/coinsize))+1;
                                    progressive2 = coinsize*4000;break;
                     case Heart   : winnerpaid += ((int16)(progressive3/coinsize))+1;
                                    progressive3 = coinsize*4000;break;
                     case Spade   : winnerpaid += ((int16)(progressive4/coinsize))+1;
                                    progressive4 = coinsize*4000;break;
                     default      : break;
                   }
                   winhand = "Royal Flush";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  else
					  {
						 winnerpaid += coinsplayed*250;
                   winhand = "Royal Flush";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  VertLite->SetRow(8);
                 break;
					}
					else
					{
					  winnerpaid += coinsplayed*50;winhand = "Straight Flush";
					  cs.TotalStraightFlushCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.StraightFlushes++;
					  VertLite->SetRow(7);
                 break;
					}
	 default : return 1;
  }
  return 1;
}

//*******************************************************************
TMoney TACVPVPGLord::PayOutPowerFullHouse()
{
  int16 session = GetCasPD(activeplayer)->VPData.CurrentSession;
  TCVPSession &cs = GetCasPD(activeplayer)->VPData.Sessions[session];

  switch (GetCasPlayer(activeplayer)->pHand->highhand)
  {
	 case Pair :
               if(GetCasPlayer(activeplayer)->pHand->highcard > Ten)
					{
					  fake->highcard = GetCasPlayer(activeplayer)->pHand->highcard;
					  winnerpaid += coinsplayed*1;
					  cs.TotalHighPairCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.HighPairs++;
					  switch(GetCasPlayer(activeplayer)->pHand->highcard)
                 {
						 case Ten   : winhand = "Pair of Tens";break;
						 case Jack  : winhand = "Pair of Jacks";break;
						 case Queen : winhand = "Pair of Queens";break;
						 case King  : winhand = "Pair of Kings";break;
						 case AceHi : winhand = "Pair of Aces";break;
					  }
					  VertLite->SetRow(0);
					}
					break;
	 case TwoPair :
               winnerpaid += coinsplayed*1;
               winhand = "Two Pair";
					cs.TotalTwoPairCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.TwoPairs++;
					VertLite->SetRow(1);
               break;
	 case ThreeKind :
               winnerpaid += coinsplayed*3;
               winhand = "Three of a Kind";
					cs.TotalThreeOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.ThreeOfKinds++;
					VertLite->SetRow(2);
               break;
	 case Straight :
               winnerpaid += coinsplayed*5;
               winhand = "Straight";
					cs.TotalStraightCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Straights++;
					VertLite->SetRow(3);
               break;
	 case Flush :
               winnerpaid += coinsplayed*7;
               winhand = "Flush";
					cs.TotalFlushCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Flushes++;
					VertLite->SetRow(4);
               break;
	 case FullHouse :
               winnerpaid += coinsplayed*12;
               winhand = "Full House";
					cs.TotalFullHouseCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FullHouses++;
					VertLite->SetRow(5);
               break;
	 case FourKind :
               if(GetCasPlayer(activeplayer)->pHand->highcard == AceHi)
               {

                 winnerpaid += coinsplayed*200;
                 winhand = "Four Aces";
                 cs.TotalFourOfKindsAcesCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.FourOfKindsAces++;
					  VertLite->SetRow(8);
               }
               else if(GetCasPlayer(activeplayer)->pHand->highcard < Five)
               {

                 winnerpaid += coinsplayed*40;
                 winhand = "Four of a Kind(2-4)";
                 cs.TotalFourOfKinds2_4Cash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.FourOfKinds2_4++;
					  VertLite->SetRow(7);
               }
               else
               {
                 winnerpaid += coinsplayed*25;
                 winhand = "Four of a Kind(5-K)";
                 cs.TotalFourOfKinds5_KCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.FourOfKinds5_K++;
					  VertLite->SetRow(6);
               }
               break;
	 case StraightFlush :
               if (GetCasPlayer(activeplayer)->pHand->highcard == AceHi)
					{
					  if(coinsplayed == 5)
					  {
						 winnerpaid += ((int16)(progressive1/coinsize))+1;
                   progressive1 = coinsize*4000;
                   winhand = "Royal Flush";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  else
					  {
						 winnerpaid += coinsplayed*250;
                   winhand = "Royal Flush";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  VertLite->SetRow(10);
                 break;
					}
					else
					{
					  winnerpaid += coinsplayed*100;winhand = "Straight Flush";
					  cs.TotalStraightFlushCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.StraightFlushes++;
					  VertLite->SetRow(9);
                 break;
					}
	 default : return 1;
  }
  return 1;
}

//*******************************************************************
TMoney TACVPVPGLord::PayOutRaiseDrawJoker()
{
  int16 session = GetCasPD(activeplayer)->VPData.CurrentSession;
  TCVPSession &cs = GetCasPD(activeplayer)->VPData.Sessions[session];

  switch (GetCasPlayer(activeplayer)->pHand->highhand)
  {
	 case TwoPair :
               winnerpaid += coinsplayed*1;
               winhand = "Two Pair";
					cs.TotalTwoPairCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.TwoPairs++;
               if(coinsplayed > 5)
               {
                 VertLite2->SetRow(0);
               }
               else
               {
					  VertLite->SetRow(0);
               }
               break;
	 case ThreeKind :
               winnerpaid += coinsplayed*2;
               winhand = "Three of a Kind";
					cs.TotalThreeOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.ThreeOfKinds++;
					if(coinsplayed > 5)
               {
                 VertLite2->SetRow(1);
               }
               else
               {
					  VertLite->SetRow(1);
               }
               break;
	 case Straight :
               winnerpaid += coinsplayed*4;
               winhand = "Straight";
					cs.TotalStraightCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Straights++;
					if(coinsplayed > 5)
               {
                 VertLite2->SetRow(2);
               }
               else
               {
					  VertLite->SetRow(2);
               }
               break;
	 case Flush :
               winnerpaid += coinsplayed*5;
               winhand = "Flush";
					cs.TotalFlushCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Flushes++;
					if(coinsplayed > 5)
               {
                 VertLite2->SetRow(3);
               }
               else
               {
					  VertLite->SetRow(3);
               }
               break;
	 case FullHouse :
               winnerpaid += coinsplayed*8;
               winhand = "Full House";
					cs.TotalFullHouseCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FullHouses++;
					if(coinsplayed > 5)
               {
                 VertLite2->SetRow(4);
               }
               else
               {
					  VertLite->SetRow(4);
               }
               break;
	 case FourKind :
               winnerpaid += coinsplayed*15;
               winhand = "Four of a Kind";
					cs.TotalFourOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FourOfKinds++;
					if(coinsplayed > 5)
               {
                 VertLite2->SetRow(5);
               }
               else
               {
					  VertLite->SetRow(5);
               }
               break;
	 case StraightFlush :
               if (GetCasPlayer(activeplayer)->pHand->highcard == AceHi)
					{
					  if(coinsplayed == 10)
					  {
						 winnerpaid += 10000;
                   winhand = "Royal Flush";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  else
					  {
						 winnerpaid += coinsplayed*500;
                   winhand = "Royal Flush";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  if(coinsplayed > 5)
                 {
                   VertLite2->SetRow(8);
                 }
                 else
                 {
					    VertLite->SetRow(8);
                 }
                 break;
					}
					else
					{
					  winnerpaid += coinsplayed*40;winhand = "Straight Flush";
					  cs.TotalStraightFlushCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.StraightFlushes++;
					  if(coinsplayed > 5)
                 {
                   VertLite2->SetRow(6);
                 }
                 else
                 {
				    	 VertLite->SetRow(6);
                 }
                 break;
					}
	 case  WildRFlush :
                 winnerpaid += coinsplayed*40;
                 winhand = "Straight Flush(Joker)";
					  cs.TotalWildRoyalCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.WildRoyals++;
					  if(coinsplayed > 5)
                 {
                   VertLite2->SetRow(6);
                 }
                 else
                 {
					    VertLite->SetRow(6);
                 }
                 break;
    case FiveKind :
               winnerpaid += coinsplayed*100;
               winhand = "Five of a Kind";
				   cs.TotalFiveOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FiveOfKinds++;
					if(coinsplayed > 5)
               {
                 VertLite2->SetRow(7);
               }
               else
               {
				    	VertLite->SetRow(7);
               }
               break;
    default : return 1;
  }
  return 1;
}

//*******************************************************************
TMoney TACVPVPGLord::PayOutSpadeBonus()
{
  int16 session = GetCasPD(activeplayer)->VPData.CurrentSession;
  TCVPSession &cs = GetCasPD(activeplayer)->VPData.Sessions[session];

  switch (GetCasPlayer(activeplayer)->pHand->highhand)
  {
	 case Pair :
               if(GetCasPlayer(activeplayer)->pHand->highcard > Ten)
					{
					  fake->highcard = GetCasPlayer(activeplayer)->pHand->highcard;
					  winnerpaid += coinsplayed*1;
					  cs.TotalHighPairCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.HighPairs++;
					  switch(GetCasPlayer(activeplayer)->pHand->highcard)
                 {
						 case Ten   : winhand = "Pair of Tens";break;
						 case Jack  : winhand = "Pair of Jacks";break;
						 case Queen : winhand = "Pair of Queens";break;
						 case King  : winhand = "Pair of Kings";break;
						 case AceHi : winhand = "Pair of Aces";break;
					  }
					  VertLite->SetRow(0);
					}
					break;
	 case TwoPair :
               winnerpaid += coinsplayed*2;
               winhand = "Two Pair";
					cs.TotalTwoPairCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.TwoPairs++;
					VertLite->SetRow(1);
               break;
	 case ThreeKind :
               winnerpaid += coinsplayed*3;
               winhand = "Three of a Kind";
					cs.TotalThreeOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.ThreeOfKinds++;
					VertLite->SetRow(2);
               break;
	 case Straight :
               winnerpaid += coinsplayed*4;
               winhand = "Straight";
					cs.TotalStraightCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Straights++;
					VertLite->SetRow(3);
               break;
	 case Flush :
               if(GetCasPlayer(activeplayer)->pHand->highcardsuit == Spade)
               {
                 winnerpaid += coinsplayed*8;
                 winhand = "Spade Flush";
                 VertLite->SetRow(5);
                 cs.TotalFlushSpadeCash += winnerpaid*coinsize;
                 cs.FlushSpade++;
               }
               else
               {
                 winnerpaid += coinsplayed*5;
                 winhand = "Flush";
                 VertLite->SetRow(4);
                 cs.TotalFlushCash += winnerpaid*coinsize;
                 cs.Flushes++;
               }
					cs.Wins++;
					break;
	 case FullHouse :
               winnerpaid += coinsplayed*8;
               winhand = "Full House";
					cs.TotalFullHouseCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FullHouses++;
					VertLite->SetRow(6);
               break;
	 case FourKind :
               winnerpaid += coinsplayed*25;
               winhand = "Four of a Kind";
					cs.TotalFourOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FourOfKinds++;
					VertLite->SetRow(7);
               break;
	 case StraightFlush :
               if (GetCasPlayer(activeplayer)->pHand->highcard == AceHi)
					{
                 if(GetCasPlayer(activeplayer)->pHand->highcardsuit == Spade)
                 {
					    if(coinsplayed == 5)
					    {
						   winnerpaid += 4700;
                     winhand = "Spade Royal Flush";
						   cs.TotalRoyalFlushesSpadeCash += winnerpaid*coinsize;
						   cs.Wins++;
						   cs.RoyalFlushesSpade++;
					    }
					    else
					    {
						   winnerpaid += coinsplayed*300;
                     winhand = "Spade Royal Flush";
						   cs.TotalRoyalFlushesSpadeCash += winnerpaid*coinsize;
						   cs.Wins++;
						   cs.RoyalFlushesSpade++;
					    }
                   VertLite->SetRow(11);
                 }
                 else
                 {
					    if(coinsplayed == 5)
					    {
						   winnerpaid += 4000;
                     winhand = "Royal Flush";
						   cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						   cs.Wins++;
						   cs.NaturalRoyals++;
					    }
					    else
					    {
						   winnerpaid += coinsplayed*250;
                     winhand = "Royal Flush";
						   cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						   cs.Wins++;
						   cs.NaturalRoyals++;
					    }
                   VertLite->SetRow(10);
                 }
                 break;
					}
					else
					{
					  if(GetCasPlayer(activeplayer)->pHand->highcardsuit == Spade)
                 {
                   winnerpaid += coinsplayed*200;
                   winhand = "Spade Straight Flush";
                   VertLite->SetRow(9);
                   cs.TotalStraightFlushesSpadeCash += winnerpaid*coinsize;
                   cs.StraightFlushesSpade++;
                 }
                 else
                 {
                   winnerpaid += coinsplayed*50;
                   winhand = "Straight Flush";
                   VertLite->SetRow(8);
                   cs.TotalStraightFlushCash += winnerpaid*coinsize;
                   cs.StraightFlushes++;
                 }
					  cs.Wins++;
                 break;
					}
	 default : return 1;
  }
  return 1;
}

//*******************************************************************
TMoney TACVPVPGLord::PayOutSuperDoubleJackpot()
{
  int16 session = GetCasPD(activeplayer)->VPData.CurrentSession;
  TCVPSession &cs = GetCasPD(activeplayer)->VPData.Sessions[session];
  int xx=0;
  bool IsFace=true;

  switch (GetCasPlayer(activeplayer)->pHand->highhand)
  {
	 case Pair :
               if(GetCasPlayer(activeplayer)->pHand->highcard > Ten)
					{
					  fake->highcard = GetCasPlayer(activeplayer)->pHand->highcard;
					  winnerpaid += coinsplayed*1;
					  cs.TotalHighPairCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.HighPairs++;
					  switch(GetCasPlayer(activeplayer)->pHand->highcard)
                 {
						 case Ten   : winhand = "Pair of Tens";break;
						 case Jack  : winhand = "Pair of Jacks";break;
						 case Queen : winhand = "Pair of Queens";break;
						 case King  : winhand = "Pair of Kings";break;
						 case AceHi : winhand = "Pair of Aces";break;
					  }
					  VertLite->SetRow(0);
					}
					break;
	 case TwoPair :
               winnerpaid += coinsplayed*1;
               winhand = "Two Pair";
					cs.TotalTwoPairCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.TwoPairs++;
					VertLite->SetRow(1);
               break;
	 case ThreeKind :
               winnerpaid += coinsplayed*3;
               winhand = "Three of a Kind";
					cs.TotalThreeOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.ThreeOfKinds++;
					VertLite->SetRow(2);
               break;
	 case Straight :
               winnerpaid += coinsplayed*4;
               winhand = "Straight";
					cs.TotalStraightCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Straights++;
					VertLite->SetRow(3);
               break;
	 case Flush :
               winnerpaid += coinsplayed*5;
               winhand = "Flush";
					cs.TotalFlushCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Flushes++;
					VertLite->SetRow(4);
               break;
	 case FullHouse :
               winnerpaid += coinsplayed*6;
               winhand = "Full House";
					cs.TotalFullHouseCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FullHouses++;
					VertLite->SetRow(5);
               break;
	 case FourKind :
               for(xx=0;xx<5;xx++)
               {
                 if(GetCasPlayer(activeplayer)->pHand->cards[xx].name < Jack)
                 {
                   IsFace = false;
                 }
               }
               if(GetCasPlayer(activeplayer)->pHand->highcard == AceHi)
               {
                 if(IsFace)
                 {
                   winnerpaid += coinsplayed*320;
                   winhand = "Four Aces with Face";
                   VertLite->SetRow(10);
                   cs.TotalFourOfKindsAcesWFaceCash += winnerpaid*coinsize;
					    cs.FourOfKindsAcesWFace++;
                 }
                 else
                 {
                   winnerpaid += coinsplayed*160;
                   winhand = "Four Aces";
                   VertLite->SetRow(8);
                   cs.TotalFourOfKindsAcesCash += winnerpaid*coinsize;
					    cs.FourOfKindsAces++;
                 }
                 cs.Wins++;
               }
               else if(GetCasPlayer(activeplayer)->pHand->highcard < Jack)
               {

                 winnerpaid += coinsplayed*40;
                 winhand = "Four of a Kind(2-10)";
                 cs.TotalFourOfKinds2_10Cash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.FourOfKinds2_10++;
					  VertLite->SetRow(6);
               }
               else
               {
                 if(IsFace)
                 {
                   winnerpaid += coinsplayed*160;
                   winhand = "Four(J-K) with Face";
                   VertLite->SetRow(9);
                   cs.TotalFourOfKindsFacesWAceOrFaceCash += winnerpaid*coinsize;
                   cs.FourOfKindsFacesWAceOrFace++;
                 }
                 else
                 {
                   winnerpaid += coinsplayed*80;
                   winhand = "Four of a Kind(J-K)";
                   VertLite->SetRow(7);
                   cs.TotalFourOfKindsFacesCash += winnerpaid*coinsize;
                   cs.FourOfKindsFaces++;
                 }
					  cs.Wins++;
               }
               break;
	 case StraightFlush :
               if (GetCasPlayer(activeplayer)->pHand->highcard == AceHi)
					{
					  if(coinsplayed == 5)
					  {
						 winnerpaid += 4000;
                   winhand = "Royal Flush";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  else
					  {
						 winnerpaid += coinsplayed*250;
                   winhand = "Royal Flush";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  VertLite->SetRow(12);
                 break;
					}
					else
					{
					  winnerpaid += coinsplayed*50;winhand = "Straight Flush";
					  cs.TotalStraightFlushCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.StraightFlushes++;
					  VertLite->SetRow(11);
                 break;
					}
	 default : return 1;
  }
  return 1;
}

//*******************************************************************
TMoney TACVPVPGLord::PayOutSevenWildJoker()
{
  int16 session = GetCasPD(activeplayer)->VPData.CurrentSession;
  TCVPSession &cs = GetCasPD(activeplayer)->VPData.Sessions[session];

  switch (GetCasPlayer(activeplayer)->pHand->highhand)
  {
    case ThreeKind :
               winnerpaid += coinsplayed*1;
               winhand = "Three of a Kind";
					cs.TotalThreeOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.ThreeOfKinds++;
					VertLite->SetRow(0);
               break;
	 case Straight :
               winnerpaid += coinsplayed*1;
               winhand = "Straight";
					cs.TotalStraightCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Straights++;
					VertLite->SetRow(1);
               break;
	 case Flush :
               winnerpaid += coinsplayed*2;
               winhand = "Flush";
					cs.TotalFlushCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Flushes++;
					VertLite->SetRow(2);
               break;
	 case FullHouse :
               winnerpaid += coinsplayed*3;
               winhand = "Full House";
					cs.TotalFullHouseCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FullHouses++;
					VertLite->SetRow(3);
               break;
    case FourSevens :
               winnerpaid += coinsplayed*100;
               winhand = "Four Sevens";
               VertLite->SetRow(8);
               cs.TotalFourOfKinds7Cash += winnerpaid*coinsize;
               cs.Wins++;
					cs.FourOfKinds7++;
               break;
    case FourSevensJoker :
               if(coinsplayed == 5)
               {
                 winnerpaid += 5000;
               }
               else
               {
                 winnerpaid += coinsplayed*500;
               }
               winhand = "Five Wilds";
               VertLite->SetRow(10);
               cs.TotalFourOfKinds7WJokerCash += winnerpaid*coinsize;
               cs.Wins++;
					cs.FourOfKinds7WJoker++;
               break;
	 case FourKind :
               winnerpaid += coinsplayed*3;
               winhand = "Four of a Kind";
               VertLite->SetRow(4);
					cs.TotalFourOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FourOfKinds++;
               break;
	 case StraightFlush :
               if (GetCasPlayer(activeplayer)->pHand->highcard == AceHi)
					{
					  winnerpaid += coinsplayed*500;
                 winhand = "Royal Flush(Nat)";
					  cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
					  cs.Wins++;
                 cs.NaturalRoyals++;
					  VertLite->SetRow(9);
                 break;
					}
					else
					{
					  winnerpaid += coinsplayed*4;winhand = "Straight Flush";
					  cs.TotalStraightFlushCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.StraightFlushes++;
					  VertLite->SetRow(5);
                 break;
					}
	 case  WildRFlush :
                 winnerpaid += coinsplayed*9;
                 winhand = "Royal Flush(Wild)";
					  cs.TotalWildRoyalCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.WildRoyals++;
					  VertLite->SetRow(7);
                 break;
    case FiveKind :
               winnerpaid += coinsplayed*6;
               winhand = "Five of a Kind";
               VertLite->SetRow(6);
					cs.TotalFiveOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FiveOfKinds++;
               break;
	 default : return 1;
  }
  return 1;
}

//*******************************************************************
TMoney TACVPVPGLord::PayOutTensBetter()
{
  int16 session = GetCasPD(activeplayer)->VPData.CurrentSession;
  TCVPSession &cs = GetCasPD(activeplayer)->VPData.Sessions[session];

  switch (GetCasPlayer(activeplayer)->pHand->highhand)
  {
	 case Pair :
               if(GetCasPlayer(activeplayer)->pHand->highcard > Nine)
					{
					  fake->highcard = GetCasPlayer(activeplayer)->pHand->highcard;
					  winnerpaid += coinsplayed*1;
					  cs.TotalHighPairCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.HighPairs++;
					  switch(GetCasPlayer(activeplayer)->pHand->highcard)
                 {
						 case Ten   : winhand = "Pair of Tens";break;
						 case Jack  : winhand = "Pair of Jacks";break;
						 case Queen : winhand = "Pair of Queens";break;
						 case King  : winhand = "Pair of Kings";break;
						 case AceHi : winhand = "Pair of Aces";break;
					  }
					  VertLite->SetRow(0);
					}
					break;
	 case TwoPair :
               winnerpaid += coinsplayed*2;
               winhand = "Two Pair";
					cs.TotalTwoPairCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.TwoPairs++;
					VertLite->SetRow(1);
               break;
	 case ThreeKind :
               winnerpaid += coinsplayed*3;
               winhand = "Three of a Kind";
					cs.TotalThreeOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.ThreeOfKinds++;
					VertLite->SetRow(2);
               break;
	 case Straight :
               winnerpaid += coinsplayed*4;
               winhand = "Straight";
					cs.TotalStraightCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Straights++;
					VertLite->SetRow(3);
               break;
	 case Flush :
               winnerpaid += coinsplayed*5;
               winhand = "Flush";
					cs.TotalFlushCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Flushes++;
					VertLite->SetRow(4);
               break;
	 case FullHouse :
               winnerpaid += coinsplayed*6;
               winhand = "Full House";
					cs.TotalFullHouseCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FullHouses++;
					VertLite->SetRow(5);
               break;
	 case FourKind :
               winnerpaid += coinsplayed*25;
               winhand = "Four of a Kind";
					cs.TotalFourOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FourOfKinds++;
					VertLite->SetRow(6);
               break;
	 case StraightFlush :
               if (GetCasPlayer(activeplayer)->pHand->highcard == AceHi)
					{
					  if(coinsplayed == 5)
					  {
						 winnerpaid += 4000;
                   winhand = "Royal Flush";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  else
					  {
						 winnerpaid += coinsplayed*250;
                   winhand = "Royal Flush";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  VertLite->SetRow(8);
                 break;
					}
					else
					{
					  winnerpaid += coinsplayed*50;winhand = "Straight Flush";
					  cs.TotalStraightFlushCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.StraightFlushes++;
					  VertLite->SetRow(7);
                 break;
					}
	 default : return 1;
  }
  return 1;
}

//*******************************************************************
TMoney TACVPVPGLord::PayOutTreasureTrove()
{
  int16 session = GetCasPD(activeplayer)->VPData.CurrentSession;
  TCVPSession &cs = GetCasPD(activeplayer)->VPData.Sessions[session];

  switch (GetCasPlayer(activeplayer)->pHand->highhand)
  {
	 case Pair :
               if(GetCasPlayer(activeplayer)->pHand->highcard > Ten)
					{
					  fake->highcard = GetCasPlayer(activeplayer)->pHand->highcard;
					  winnerpaid += coinsplayed*1;
					  cs.TotalHighPairCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.HighPairs++;
					  switch(GetCasPlayer(activeplayer)->pHand->highcard)
                 {
						 case Ten   : winhand = "Pair of Tens";break;
						 case Jack  : winhand = "Pair of Jacks";break;
						 case Queen : winhand = "Pair of Queens";break;
						 case King  : winhand = "Pair of Kings";break;
						 case AceHi : winhand = "Pair of Aces";break;
					  }
					  VertLite->SetRow(0);
					}
					break;
	 case TwoPair :
               winnerpaid += coinsplayed*1;
               winhand = "Two Pair";
					cs.TotalTwoPairCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.TwoPairs++;
					VertLite->SetRow(1);
               break;
	 case ThreeKind :
               winnerpaid += coinsplayed*2;
               winhand = "Three of a Kind";
					cs.TotalThreeOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.ThreeOfKinds++;
					VertLite->SetRow(2);
               break;
	 case Straight :
               winnerpaid += coinsplayed*4;
               winhand = "Straight";
					cs.TotalStraightCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Straights++;
					VertLite->SetRow(3);
               break;
	 case Flush :
               winnerpaid += coinsplayed*6;
               winhand = "Flush";
					cs.TotalFlushCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Flushes++;
					VertLite->SetRow(4);
               break;
	 case FullHouse :
               winnerpaid += coinsplayed*8;
               winhand = "Full House";
					cs.TotalFullHouseCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FullHouses++;
					VertLite->SetRow(5);
               break;
	 case FourKind :
               if(GetCasPlayer(activeplayer)->pHand->highcard == AceHi)
               {
                 winnerpaid += coinsplayed*100;
                 winhand = "Four Aces";
                 VertLite->SetRow(8);
                 cs.TotalFourOfKindsAcesCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.FourOfKindsAces++;

               }
               else if(GetCasPlayer(activeplayer)->pHand->highcard < Five)
               {
                 winnerpaid += coinsplayed*50;
                 winhand = "Four of a Kind(2-4)";
                 cs.TotalFourOfKinds2_4Cash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.FourOfKinds2_4++;
					  VertLite->SetRow(7);
               }
               else
               {
                 winnerpaid += coinsplayed*25;
                 winhand = "Four of a Kind(5-K)";
                 VertLite->SetRow(6);
                 cs.TotalFourOfKinds5_KCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.FourOfKinds5_K++;
               }
               break;
	 case StraightFlush :
               if (GetCasPlayer(activeplayer)->pHand->highcard == AceHi)
					{
					  if(coinsplayed == 5)
					  {
						 winnerpaid += 4000;
                   winhand = "Royal Flush";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  else
					  {
						 winnerpaid += coinsplayed*250;
                   winhand = "Royal Flush";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  VertLite->SetRow(10);
                 break;
					}
					else
					{
					  winnerpaid += coinsplayed*80;winhand = "Straight Flush";
					  cs.TotalStraightFlushCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.StraightFlushes++;
					  VertLite->SetRow(9);
                 break;
					}
	 default : return 1;
  }
  return 1;
}

//*******************************************************************
TMoney TACVPVPGLord::PayOutTriplePlayTop()
{
  int16 session = GetCasPD(activeplayer)->VPData.CurrentSession;
  TCVPSession &cs = GetCasPD(activeplayer)->VPData.Sessions[session];
  int zz=0;
  bool IsAce=false;
  int xx=0;
  bool IsFace=true;

  switch (TripTopHand->highhand)
  {
	 case Pair :
               if(TripTopHand->highcard > Ten)
					{
					  fake->highcard = TripTopHand->highcard;
					  winnerpaid += coinsplayed*1;
					  cs.TotalHighPairCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.HighPairs++;
					  switch(TripTopHand->highcard)
                 {
						 case Ten   : winhand = "Pair of Tens";break;
						 case Jack  : winhand = "Pair of Jacks";break;
						 case Queen : winhand = "Pair of Queens";break;
						 case King  : winhand = "Pair of Kings";break;
						 case AceHi : winhand = "Pair of Aces";break;
					  }
					  if(VertLite->GetCurFrame(coinsplayed) <= 0)
                 {
					    VertLite->SetRow(0,coinsplayed);
                 }
					}
					break;
	 case TwoPair :
               winnerpaid += coinsplayed*1;
               winhand = "Two Pair";
					cs.TotalTwoPairCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.TwoPairs++;
					if(VertLite->GetCurFrame(coinsplayed) < 1)
               {
					  VertLite->SetRow(1,coinsplayed);
               }
               break;
	 case ThreeKind :
               winnerpaid += coinsplayed*3;
               winhand = "Three of a Kind";
					cs.TotalThreeOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.ThreeOfKinds++;
					if(VertLite->GetCurFrame(coinsplayed) < 2)
               {
                 VertLite->SetRow(2,coinsplayed);
               }
               break;
	 case Straight :
               winnerpaid += coinsplayed*4;
               winhand = "Straight";
					cs.TotalStraightCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Straights++;
					if(VertLite->GetCurFrame(coinsplayed) < 3)
               {
                 VertLite->SetRow(3,coinsplayed);
               }
               break;
	 case Flush :
               winnerpaid += coinsplayed*5;
               winhand = "Flush";
					cs.TotalFlushCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Flushes++;
					if(VertLite->GetCurFrame(coinsplayed) < 4)
               {
				     VertLite->SetRow(4,coinsplayed);
               }
               break;
	 case FullHouse :
               winnerpaid += coinsplayed*7;
               winhand = "Full House";
					cs.TotalFullHouseCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FullHouses++;
					if(VertLite->GetCurFrame(coinsplayed) < 5)
               {
					  VertLite->SetRow(5,coinsplayed);
               }
               break;
	 case FourKind :
               for(xx=0;xx<5;xx++)
               {
                 if(TripTopHand->cards[xx].name < Jack)
                 {
                   IsFace = false;
                 }
               }
               if(TripTopHand->highcard == AceHi)
               {
                 if(IsFace)
                 {
                   winnerpaid += coinsplayed*400;
                   winhand = "Four Aces with Face";
                   cs.TotalFourOfKindsAcesWFaceCash += winnerpaid*coinsize;
                   cs.FourOfKindsAcesWFace++;
                   if(VertLite->GetCurFrame(coinsplayed) < 10)
                   {
					      VertLite->SetRow(10,coinsplayed);
                   }
                 }
                 else
                 {
                   winnerpaid += coinsplayed*160;
                   winhand = "Four Aces";
                   cs.TotalFourOfKindsAcesCash += winnerpaid*coinsize;
                   cs.FourOfKindsAces++;
                   if(VertLite->GetCurFrame(coinsplayed) < 8)
                   {
					      VertLite->SetRow(8,coinsplayed);
                   }
                 }
					  cs.Wins++;
                 break;
               }
               else if(TripTopHand->highcard < Jack)
               {
                 winnerpaid += coinsplayed*50;
                 winhand = "Four of a Kind(2-10)";
                 cs.TotalFourOfKinds2_10Cash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.FourOfKinds2_10++;
					  if(VertLite->GetCurFrame(coinsplayed) < 6)
                 {
					    VertLite->SetRow(6,coinsplayed);
                 }
               }
               else
               {
                 for(zz=0;zz<5;zz++)
                 {
                   if(TripTopHand->cards[zz].name == AceHi)
                   {
                     IsAce = true;
                   }
                 }
                 if(IsAce)
                 {
                   winnerpaid += coinsplayed*160;
                   winhand = "Four(J-K) with Ace";
                   cs.TotalFourOfKindsFacesWAceCash += winnerpaid*coinsize;
      			    cs.FourOfKindsFacesWAce++;
                   if(VertLite->GetCurFrame(coinsplayed) < 9)
                   {
					      VertLite->SetRow(9,coinsplayed);
                   }
                 }
                 else
                 {
                   winnerpaid += coinsplayed*80;
                   winhand = "Four of a Kind(J-K)";
                   cs.TotalFourOfKindsFacesCash += winnerpaid*coinsize;
					    cs.FourOfKindsFaces++;
                   if(VertLite->GetCurFrame(coinsplayed) < 7)
                   {
					      VertLite->SetRow(7,coinsplayed);
                   }
                 }
                 cs.Wins++;
               }
               break;
	 case StraightFlush :
               if (TripTopHand->highcard == AceHi)
					{
					  if(coinsplayed == 5)
					  {
						 winnerpaid += 4000;
                   winhand = "Royal Flush";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  else
					  {
						 winnerpaid += coinsplayed*250;
                   winhand = "Royal Flush";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  if(VertLite->GetCurFrame(coinsplayed) < 12)
                 {
					    VertLite->SetRow(12,coinsplayed);
                 }
                 break;
					}
					else
					{
					  winnerpaid += coinsplayed*50;winhand = "Straight Flush";
					  cs.TotalStraightFlushCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.StraightFlushes++;
                 if(VertLite->GetCurFrame(coinsplayed) < 11)
                 {
					    VertLite->SetRow(11,coinsplayed);
                 }
                 break;
					}
	 default : return 1;
  }
  return 1;
}

//*******************************************************************
TMoney TACVPVPGLord::PayOutTriplePlayMid()
{
  int16 session = GetCasPD(activeplayer)->VPData.CurrentSession;
  TCVPSession &cs = GetCasPD(activeplayer)->VPData.Sessions[session];
  int zz=0;
  bool IsAce=false;
  int xx=0;
  bool IsFace=true;

  switch (TripMidHand->highhand)
  {
	 case Pair :
               if(TripMidHand->highcard > Ten)
					{
					  fake->highcard = TripMidHand->highcard;
					  winnerpaid += coinsplayed*1;
					  cs.TotalHighPairCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.HighPairs++;
					  switch(TripMidHand->highcard)
                 {
						 case Ten   : winhand = "Pair of Tens";break;
						 case Jack  : winhand = "Pair of Jacks";break;
						 case Queen : winhand = "Pair of Queens";break;
						 case King  : winhand = "Pair of Kings";break;
						 case AceHi : winhand = "Pair of Aces";break;
					  }
					  if(VertLite->GetCurFrame(coinsplayed) <= 0)
                 {
					    VertLite->SetRow(0,coinsplayed);
                 }
					}
					break;
	 case TwoPair :
               winnerpaid += coinsplayed*1;
               winhand = "Two Pair";
					cs.TotalTwoPairCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.TwoPairs++;
					if(VertLite->GetCurFrame(coinsplayed) < 1)
               {
					  VertLite->SetRow(1,coinsplayed);
               }
               break;
	 case ThreeKind :
               winnerpaid += coinsplayed*3;
               winhand = "Three of a Kind";
					cs.TotalThreeOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.ThreeOfKinds++;
					if(VertLite->GetCurFrame(coinsplayed) < 2)
               {
                 VertLite->SetRow(2,coinsplayed);
               }
               break;
	 case Straight :
               winnerpaid += coinsplayed*4;
               winhand = "Straight";
					cs.TotalStraightCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Straights++;
					if(VertLite->GetCurFrame(coinsplayed) < 3)
               {
                 VertLite->SetRow(3,coinsplayed);
               }
               break;
	 case Flush :
               winnerpaid += coinsplayed*5;
               winhand = "Flush";
					cs.TotalFlushCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Flushes++;
					if(VertLite->GetCurFrame(coinsplayed) < 4)
               {
				     VertLite->SetRow(4,coinsplayed);
               }
               break;
	 case FullHouse :
               winnerpaid += coinsplayed*7;
               winhand = "Full House";
					cs.TotalFullHouseCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FullHouses++;
					if(VertLite->GetCurFrame(coinsplayed) < 5)
               {
					  VertLite->SetRow(5,coinsplayed);
               }
               break;
	 case FourKind :
               for(xx=0;xx<5;xx++)
               {
                 if(TripMidHand->cards[xx].name < Jack)
                 {
                   IsFace = false;
                 }
               }
               if(TripMidHand->highcard == AceHi)
               {
                 if(IsFace)
                 {
                   winnerpaid += coinsplayed*400;
                   winhand = "Four Aces with Face";
                   cs.TotalFourOfKindsAcesWFaceCash += winnerpaid*coinsize;
					    cs.FourOfKindsAcesWFace++;
                   if(VertLite->GetCurFrame(coinsplayed) < 10)
                   {
					      VertLite->SetRow(10,coinsplayed);
                   }
                 }
                 else
                 {
                   winnerpaid += coinsplayed*160;
                   winhand = "Four Aces";
                   cs.TotalFourOfKindsAcesCash += winnerpaid*coinsize;
					    cs.FourOfKindsAces++;
                   if(VertLite->GetCurFrame(coinsplayed) < 8)
                   {
					      VertLite->SetRow(8,coinsplayed);
                   }
                 }
                 ;
                 cs.Wins++;
                 break;
               }
               else if(TripMidHand->highcard < Jack)
               {
                 winnerpaid += coinsplayed*50;
                 winhand = "Four of a Kind(2-10)";
                 cs.TotalFourOfKinds2_10Cash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.FourOfKinds2_10++;
					  if(VertLite->GetCurFrame(coinsplayed) < 6)
                 {
					    VertLite->SetRow(6,coinsplayed);
                 }
               }
               else
               {
                 for(zz=0;zz<5;zz++)
                 {
                   if(TripMidHand->cards[zz].name == AceHi)
                   {
                     IsAce = true;
                   }
                 }
                 if(IsAce)
                 {
                   winnerpaid += coinsplayed*160;
                   winhand = "Four(J-K) with Ace";
                   cs.TotalFourOfKindsFacesWAceCash += winnerpaid*coinsize;
                   cs.FourOfKindsFacesWAce++;
                   if(VertLite->GetCurFrame(coinsplayed) < 9)
                   {
					      VertLite->SetRow(9,coinsplayed);
                   }
                 }
                 else
                 {
                   winnerpaid += coinsplayed*80;
                   winhand = "Four of a Kind(J-K)";
                   cs.TotalFourOfKindsFacesCash += winnerpaid*coinsize;
                   cs.FourOfKindsFaces++;
                   if(VertLite->GetCurFrame(coinsplayed) < 7)
                   {
					      VertLite->SetRow(7,coinsplayed);
                   }
                 }
					  cs.Wins++;
               }
               break;
	 case StraightFlush :
               if (TripMidHand->highcard == AceHi)
					{
					  if(coinsplayed == 5)
					  {
						 winnerpaid += 4000;
                   winhand = "Royal Flush";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  else
					  {
						 winnerpaid += coinsplayed*250;
                   winhand = "Royal Flush";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  if(VertLite->GetCurFrame(coinsplayed) < 12)
                 {
					    VertLite->SetRow(12,coinsplayed);
                 }
                 break;
					}
					else
					{
					  winnerpaid += coinsplayed*50;winhand = "Straight Flush";
					  cs.TotalStraightFlushCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.StraightFlushes++;
                 if(VertLite->GetCurFrame(coinsplayed) < 11)
                 {
					    VertLite->SetRow(11,coinsplayed);
                 }
                 break;
					}
	 default : return 1;
  }
  return 1;
}

//*******************************************************************
TMoney TACVPVPGLord::PayOutTriplePlay()
{
  int16 session = GetCasPD(activeplayer)->VPData.CurrentSession;
  TCVPSession &cs = GetCasPD(activeplayer)->VPData.Sessions[session];
  int zz=0;
  bool IsAce=false;
  int xx=0;
  bool IsFace=true;

  switch (GetCasPlayer(activeplayer)->pHand->highhand)
  {
	 case Pair :
               if(GetCasPlayer(activeplayer)->pHand->highcard > Ten)
					{
					  fake->highcard = GetCasPlayer(activeplayer)->pHand->highcard;
					  winnerpaid += coinsplayed*1;
					  cs.TotalHighPairCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.HighPairs++;
					  switch(GetCasPlayer(activeplayer)->pHand->highcard)
                 {
						 case Ten   : winhand = "Pair of Tens";break;
						 case Jack  : winhand = "Pair of Jacks";break;
						 case Queen : winhand = "Pair of Queens";break;
						 case King  : winhand = "Pair of Kings";break;
						 case AceHi : winhand = "Pair of Aces";break;
					  }
					  VertLite->SetRow(0,coinsplayed);
					}
					break;
	 case TwoPair :
               winnerpaid += coinsplayed*1;
               winhand = "Two Pair";
					cs.TotalTwoPairCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.TwoPairs++;
					VertLite->SetRow(1,coinsplayed);
               break;
	 case ThreeKind :
               winnerpaid += coinsplayed*3;
               winhand = "Three of a Kind";
					cs.TotalThreeOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.ThreeOfKinds++;
					VertLite->SetRow(2,coinsplayed);
               break;
	 case Straight :
               winnerpaid += coinsplayed*4;
               winhand = "Straight";
					cs.TotalStraightCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Straights++;
					VertLite->SetRow(3,coinsplayed);
               break;
	 case Flush :
               winnerpaid += coinsplayed*5;
               winhand = "Flush";
					cs.TotalFlushCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Flushes++;
					VertLite->SetRow(4,coinsplayed);
               break;
	 case FullHouse :
               winnerpaid += coinsplayed*7;
               winhand = "Full House";
					cs.TotalFullHouseCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FullHouses++;
					VertLite->SetRow(5,coinsplayed);
               break;
	 case FourKind :
               for(xx=0;xx<5;xx++)
               {
                 if(GetCasPlayer(activeplayer)->pHand->cards[xx].name < Jack)
                 {
                   IsFace = false;
                 }
               }
               if(GetCasPlayer(activeplayer)->pHand->highcard == AceHi)
               {
                 if(IsFace)
                 {
                   winnerpaid += coinsplayed*400;
                   winhand = "Four Aces with Face";
                   cs.TotalFourOfKindsAcesWFaceCash += winnerpaid*coinsize;
					    cs.Wins++;
					    cs.FourOfKindsAcesWFace++;
                   VertLite->SetRow(10,coinsplayed);
                 }
                 else
                 {
                   winnerpaid += coinsplayed*160;
                   winhand = "Four Aces";
                   cs.TotalFourOfKindsAcesCash += winnerpaid*coinsize;
					    cs.Wins++;
					    cs.FourOfKindsAces++;
                   VertLite->SetRow(8,coinsplayed);
                 }
                 break;
               }
               else if(GetCasPlayer(activeplayer)->pHand->highcard < Jack)
               {
                 winnerpaid += coinsplayed*50;
                 winhand = "Four of a Kind(2-10)";
                 cs.TotalFourOfKinds2_10Cash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.FourOfKinds2_10++;
					  VertLite->SetRow(6,coinsplayed);
               }
               else
               {
                 for(zz=0;zz<5;zz++)
                 {
                   if(GetCasPlayer(activeplayer)->pHand->cards[zz].name == AceHi)
                   {
                     IsAce = true;
                   }
                 }
                 if(IsAce)
                 {
                   winnerpaid += coinsplayed*160;
                   winhand = "Four(J-K) with Ace";
                   cs.TotalFourOfKindsFacesWAceCash += winnerpaid*coinsize;
					    cs.Wins++;
					    cs.FourOfKindsFacesWAce++;
                   VertLite->SetRow(9,coinsplayed);
                 }
                 else
                 {
                   winnerpaid += coinsplayed*80;
                   winhand = "Four of a Kind(J-K)";
                   cs.TotalFourOfKindsFacesCash += winnerpaid*coinsize;
					    cs.Wins++;
					    cs.FourOfKindsFaces++;
                   VertLite->SetRow(7,coinsplayed);
                 }
               }
               break;
	 case StraightFlush :
               if (GetCasPlayer(activeplayer)->pHand->highcard == AceHi)
					{
					  if(coinsplayed == 5)
					  {
						 winnerpaid += 4000;
                   winhand = "Royal Flush";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  else
					  {
						 winnerpaid += coinsplayed*250;
                   winhand = "Royal Flush";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  VertLite->SetRow(12,coinsplayed);
                 break;
					}
					else
					{
					  winnerpaid += coinsplayed*50;winhand = "Straight Flush";
					  cs.TotalStraightFlushCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.StraightFlushes++;
					  VertLite->SetRow(11,coinsplayed);
                 break;
					}
	 default : return 1;
  }
  return 1;
}

//*******************************************************************
TMoney TACVPVPGLord::PayOutTripleBonus()
{
  int16 session = GetCasPD(activeplayer)->VPData.CurrentSession;
  TCVPSession &cs = GetCasPD(activeplayer)->VPData.Sessions[session];

  switch (GetCasPlayer(activeplayer)->pHand->highhand)
  {
	 case Pair :
               if(GetCasPlayer(activeplayer)->pHand->highcard > Ten)
					{
					  fake->highcard = GetCasPlayer(activeplayer)->pHand->highcard;
					  winnerpaid += coinsplayed*1;
					  cs.TotalHighPairCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.HighPairs++;
					  switch(GetCasPlayer(activeplayer)->pHand->highcard)
                 {
						 case Ten   : winhand = "Pair of Tens";break;
						 case Jack  : winhand = "Pair of Jacks";break;
						 case Queen : winhand = "Pair of Queens";break;
						 case King  : winhand = "Pair of Kings";break;
						 case AceHi : winhand = "Pair of Aces";break;
					  }
					  VertLite->SetRow(0);
					}
					break;
	 case TwoPair :
               winnerpaid += coinsplayed*1;
               winhand = "Two Pair";
					cs.TotalTwoPairCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.TwoPairs++;
					VertLite->SetRow(1);
               break;
	 case ThreeKind :
               winnerpaid += coinsplayed*3;
               winhand = "Three of a Kind";
					cs.TotalThreeOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.ThreeOfKinds++;
					VertLite->SetRow(2);
               break;
	 case Straight :
               winnerpaid += coinsplayed*4;
               winhand = "Straight";
					cs.TotalStraightCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Straights++;
					VertLite->SetRow(3);
               break;
	 case Flush :
               winnerpaid += coinsplayed*7;
               winhand = "Flush";
					cs.TotalFlushCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Flushes++;
					VertLite->SetRow(4);
               break;
	 case FullHouse :
               winnerpaid += coinsplayed*10;
               winhand = "Full House";
					cs.TotalFullHouseCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FullHouses++;
					VertLite->SetRow(5);
               break;
	 case FourKind :
               if(GetCasPlayer(activeplayer)->pHand->highcard == AceHi)
               {
                 winnerpaid += coinsplayed*240;
                 winhand = "Four Aces";
                 VertLite->SetRow(8);
                 cs.TotalFourOfKindsAcesCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.FourOfKindsAces++;
                 break;
               }
               else if(GetCasPlayer(activeplayer)->pHand->highcard < Five)
               {
                 winnerpaid += coinsplayed*120;
                 winhand = "Four of a Kind(2-4)";
                 cs.TotalFourOfKinds2_4Cash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.FourOfKinds2_4++;
					  VertLite->SetRow(7);
               }
               else
               {
                 winnerpaid += coinsplayed*75;
                 winhand = "Four of a Kind(5-K)";
                 VertLite->SetRow(6);
                 cs.TotalFourOfKinds5_KCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.FourOfKinds5_K++;
               }
               break;
	 case StraightFlush :
               if (GetCasPlayer(activeplayer)->pHand->highcard == AceHi)
					{
					  if(coinsplayed == 5)
					  {
						 winnerpaid += 4000;
                   winhand = "Royal Flush";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  else
					  {
						 winnerpaid += coinsplayed*250;
                   winhand = "Royal Flush";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  VertLite->SetRow(10);
                 break;
					}
					else
					{
					  winnerpaid += coinsplayed*50;winhand = "Straight Flush";
					  cs.TotalStraightFlushCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.StraightFlushes++;
					  VertLite->SetRow(9);
                 break;
					}
	 default : return 1;
  }
  return 1;
}

//*******************************************************************
TMoney TACVPVPGLord::PayOutWheelDeal()
{
  int16 session = GetCasPD(activeplayer)->VPData.CurrentSession;
  TCVPSession &cs = GetCasPD(activeplayer)->VPData.Sessions[session];

  switch (GetCasPlayer(activeplayer)->pHand->highhand)
  {
	 case Pair :
               if(GetCasPlayer(activeplayer)->pHand->highcard > Ten)
					{
					  fake->highcard = GetCasPlayer(activeplayer)->pHand->highcard;
					  winnerpaid += coinsplayed*1;
					  cs.TotalHighPairCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.HighPairs++;
					  switch(GetCasPlayer(activeplayer)->pHand->highcard)
                 {
						 case Ten   : winhand = "Pair of Tens";break;
						 case Jack  : winhand = "Pair of Jacks";break;
						 case Queen : winhand = "Pair of Queens";break;
						 case King  : winhand = "Pair of Kings";break;
						 case AceHi : winhand = "Pair of Aces";break;
					  }
					  VertLite->SetRow(0);
					}
					break;
	 case TwoPair :
               winnerpaid += coinsplayed*1;
               winhand = "Two Pair";
					cs.TotalTwoPairCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.TwoPairs++;
					VertLite->SetRow(1);
               break;
	 case ThreeKind :
               winnerpaid += coinsplayed*2;
               winhand = "Three of a Kind";
					cs.TotalThreeOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.ThreeOfKinds++;
					VertLite->SetRow(2);
               break;
	 case Straight :
               winnerpaid += coinsplayed*4;
               winhand = "Straight";
					cs.TotalStraightCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Straights++;
					VertLite->SetRow(3);
               break;
	 case Flush :
               winnerpaid += coinsplayed*5;
               winhand = "Flush";
					cs.TotalFlushCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.Flushes++;
					VertLite->SetRow(4);
               break;
	 case FullHouse :
               winnerpaid += coinsplayed*7;
               winhand = "Full House";
					cs.TotalFullHouseCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FullHouses++;
					VertLite->SetRow(5);
               break;
	 case FourKind :
               winnerpaid += coinsplayed*25;
               winhand = "Four of a Kind";
					cs.TotalFourOfKindCash += winnerpaid*coinsize;
					cs.Wins++;
					cs.FourOfKinds++;
					VertLite->SetRow(6);
               break;
	 case StraightFlush :
               if (GetCasPlayer(activeplayer)->pHand->highcard == AceHi)
					{
					  if(coinsplayed == 5)
					  {
						 winnerpaid += 4000;
                   winhand = "Royal Flush";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  else
					  {
						 winnerpaid += coinsplayed*250;
                   winhand = "Royal Flush";
						 cs.TotalNaturalRoyalCash += winnerpaid*coinsize;
						 cs.Wins++;
						 cs.NaturalRoyals++;
					  }
					  VertLite->SetRow(8);
                 break;
					}
					else
					{
					  winnerpaid += coinsplayed*50;winhand = "Straight Flush";
					  cs.TotalStraightFlushCash += winnerpaid*coinsize;
					  cs.Wins++;
					  cs.StraightFlushes++;
					  VertLite->SetRow(7);
                 break;
					}
	 default : return 1;
  }
  return 1;
}
//*******************************************************************
TMoney TACVPVPGLord::GetJackpotBonusAmount()
{
 return JackpotBonusAmount;
}
//*******************************************************************
int16 TACVPVPGLord::Wild2s(bool copy)
{
  if(copy)
  {
	 fake->inhand = 0;
	 for(int16 i=0;i<5;i++)
	 {
		fake->cards[i].name = GetCasPlayer(activeplayer)->pHand->cards[i].name;
		fake->cards[i].suit = GetCasPlayer(activeplayer)->pHand->cards[i].suit;
		fake->inhand++;
	 }
  }
  pSmarts->Insert_Sort(fake);

  if(GetCasPlayer(activeplayer)->pHand->wildcount && fake->inhand && fake->cards[0].name == Two)
  {
	 if(GetCasPlayer(activeplayer)->pHand->wildcount > 3)
	 {
		GetCasPlayer(activeplayer)->pHand->highhand = 110; // Four Deuces
		return 1;
	 }
	 if(GetCasPlayer(activeplayer)->pHand->wildcount > 2)
	 {
		if(fake->cards[3].suit == fake->cards[4].suit)
		{
		  if(fake->cards[3].name > Nine && fake->cards[4].name > Nine)
		  {
			 GetCasPlayer(activeplayer)->pHand->highhand = 105; // Royal with wild
			 return 1;
		  }
		  else
		  {
			 if(fake->cards[4].name - fake->cards[3].name < 5)
			 {
				GetCasPlayer(activeplayer)->pHand->highhand = 99; // Straight flush
				return 1;
			 }
			 else if(fake->cards[4].name == AceHi && fake->cards[3].name < Six)
			 {
				GetCasPlayer(activeplayer)->pHand->highhand = 99; // Straight flush
				return 1;
			 }
		  }
		}
		else
		{
		  if(fake->cards[4].name == fake->cards[3].name)
		  {
			 GetCasPlayer(activeplayer)->pHand->highhand = 100; // Five of kind
			 return 1;
		  }
		}
		GetCasPlayer(activeplayer)->pHand->highhand = 71; // Four of a kind
		return 1;
	 }
	 if(GetCasPlayer(activeplayer)->pHand->wildcount > 1)
	 {
		if(fake->cards[4].suit == fake->cards[3].suit &&
			fake->cards[2].suit == fake->cards[3].suit)
		{
		  if(fake->cards[4].name - fake->cards[2].name < 5)
		  {
			 if(fake->cards[2].name > Nine)
			 {
				GetCasPlayer(activeplayer)->pHand->highhand = 105;  // Royal wilds
				GetCasPlayer(activeplayer)->pHand->highcard = AceHi;
				return 1;
			 }
			 else
			 {
				GetCasPlayer(activeplayer)->pHand->highhand = 99; //Straight flush
				return 1;
			 }
		  }
		  else
		  {
			 if(fake->cards[4].name == AceHi && fake->cards[3].name < Six)
			 {
				GetCasPlayer(activeplayer)->pHand->highhand = 99; //Straight flush
				return 1;
			 }
			 else
			 {
				GetCasPlayer(activeplayer)->pHand->highhand = 26; // flush
				return 1;
			 }
		  }
		}
		if(fake->cards[4].name - fake->cards[2].name < 5)
		{
		  GetCasPlayer(activeplayer)->pHand->highhand = 23; // Straight
		}
		else
		{
		  if(fake->cards[4].name == AceHi && fake->cards[3].name < Six)
		  {
			 GetCasPlayer(activeplayer)->pHand->highhand = 23; // Straight
		  }
		}
		if(fake->cards[4].name == fake->cards[2].name)
		{
		  GetCasPlayer(activeplayer)->pHand->highhand = 100; // 5 o'kind
		  return 1;
		}
		if(fake->cards[3].name == fake->cards[2].name ||
			fake->cards[3].name == fake->cards[4].name)
		{
		  GetCasPlayer(activeplayer)->pHand->highhand = 71; // 4 o'kind
		  return 1;
		}
		if(GetCasPlayer(activeplayer)->pHand->highhand < 20)
		{
		  GetCasPlayer(activeplayer)->pHand->highhand = 20; // 3 o'kind
		}
		return 1;
	 }
	 for(int16 i=Two;i<=AceHi;i++)
	 {
		fake->cards[0].name = (TCardName)i;
		for(int16 j=0;j<4;j++)
		{
		  fake->cards[0].suit = (TSuit)j;
		  fake->highhand      = 0;
		  fake->highcard      = 0;
		  fake->toflush       = 0;
		  fake->instrght      = 0;
		  fake->outstrght     = 0;
		  fake->lohighcard    = 0;
		  fake->lolowcard     = 0;
		  fake->lohand        = 0;
		  fake->lowcard       = 0;
		  fake->instrght      = 0;
		  fake->outstrght     = 0;
		  fake->instrflsh     = 0;
		  fake->outstrflsh    = 0;
		  fake->instrflshsuit     = 0;
		  fake->outstrflshsuit    = 0;
		  pSmarts->Holding(fake);
		  if(fake->highhand > GetCasPlayer(activeplayer)->pHand->highhand)
		  {
			 if(fake->highhand == 99 && fake->highcard == AceHi)
			 {
				GetCasPlayer(activeplayer)->pHand->highhand = 105;
				GetCasPlayer(activeplayer)->pHand->highcard = AceHi;
			 }
			 else
			 {
				GetCasPlayer(activeplayer)->pHand->highhand = fake->highhand;
				GetCasPlayer(activeplayer)->pHand->highcard = fake->highcard;
			 }
		  }
		  else
		  {
			 if(fake->highhand == 99 && fake->highcard == AceHi)
			 {
				GetCasPlayer(activeplayer)->pHand->highhand = 105;
				GetCasPlayer(activeplayer)->pHand->highcard = AceHi;
			 }
		  }
		  if(fake->instrflsh > GetCasPlayer(activeplayer)->pHand->instrflsh)
		  {
			 GetCasPlayer(activeplayer)->pHand->instrflsh = fake->instrflsh;
		  }
		  if(fake->outstrflsh > GetCasPlayer(activeplayer)->pHand->outstrflsh)
		  {
			 GetCasPlayer(activeplayer)->pHand->outstrflsh = fake->outstrflsh;
		  }
		  if(fake->instrght > GetCasPlayer(activeplayer)->pHand->instrght)
		  {
			 GetCasPlayer(activeplayer)->pHand->instrght = fake->instrght;
		  }
		  if(fake->outstrght > GetCasPlayer(activeplayer)->pHand->outstrght)
		  {
			 GetCasPlayer(activeplayer)->pHand->outstrght = fake->outstrght;
		  }
		  if(fake->toflush > GetCasPlayer(activeplayer)->pHand->toflush)
		  {
			 GetCasPlayer(activeplayer)->pHand->toflush = fake->toflush;
		  }
		}
	 }
	 return 1;
  }//if(wildcount)
  pSmarts->Holding(GetCasPlayer(activeplayer)->pHand);
  pSmarts->Holding(fake);
  return 1;
}
//*******************************************************************
int16 TACVPVPGLord::WildJokers(bool copy)
{
  if(copy)
  {
	 fake->inhand = 0;
	 for(int16 i=0;i<5;i++)
	 {
		fake->cards[i].name = GetCasPlayer(activeplayer)->pHand->cards[i].name;
		fake->cards[i].suit = GetCasPlayer(activeplayer)->pHand->cards[i].suit;
		fake->inhand++;
	 }
  }
  pSmarts->Insert_Sort(fake);
  if(GetCasPlayer(activeplayer)->pHand->wildcount && fake->inhand && fake->cards[fake->inhand-1].name == Joker)
  {
	 for(int16 i=Two;i<=AceHi;i++)
	 {
		fake->cards[fake->inhand-1].name = (TCardName)i;
		for(int16 j=0;j<4;j++)
		{
		  fake->cards[fake->inhand-1].suit = (TSuit)j;
		  fake->highhand      = 0;
		  fake->highcard      = 0;
		  fake->toflush       = 0;
		  fake->instrght      = 0;
		  fake->outstrght     = 0;
		  fake->lohighcard    = 0;
		  fake->lolowcard     = 0;
		  fake->lohand        = 0;
		  fake->lowcard       = 0;
		  pSmarts->Holding(fake);
		  if(fake->highhand >= GetCasPlayer(activeplayer)->pHand->highhand)
		  {
			 if(fake->highhand == 99 && fake->highcard == AceHi)
			 {
				GetCasPlayer(activeplayer)->pHand->highhand = 105;
				GetCasPlayer(activeplayer)->pHand->highcard = AceHi;
			 }
			 else
			 {
				GetCasPlayer(activeplayer)->pHand->highhand = fake->highhand;
				if(fake->highcard > GetCasPlayer(activeplayer)->pHand->highcard)
            {
              GetCasPlayer(activeplayer)->pHand->highcard = fake->highcard;
            }
			 }
		  }
		  else
		  {
			 if(fake->highhand == 99 && fake->highcard == AceHi)
			 {
				GetCasPlayer(activeplayer)->pHand->highhand = 105;
				GetCasPlayer(activeplayer)->pHand->highcard = AceHi;
			 }
		  }
        if(fake->instrflsh > GetCasPlayer(activeplayer)->pHand->instrflsh)
		  {
			 GetCasPlayer(activeplayer)->pHand->instrflsh = fake->instrflsh;
		  }
		  if(fake->outstrflsh > GetCasPlayer(activeplayer)->pHand->outstrflsh)
		  {
			 GetCasPlayer(activeplayer)->pHand->outstrflsh = fake->outstrflsh;
		  }
		  if(fake->instrght > GetCasPlayer(activeplayer)->pHand->instrght)
		  {
			 GetCasPlayer(activeplayer)->pHand->instrght = fake->instrght;
		  }
		  if(fake->outstrght > GetCasPlayer(activeplayer)->pHand->outstrght)
		  {
			 GetCasPlayer(activeplayer)->pHand->outstrght = fake->outstrght;
		  }
		  if(fake->toflush > GetCasPlayer(activeplayer)->pHand->toflush)
		  {
			 GetCasPlayer(activeplayer)->pHand->toflush = fake->toflush;
		  }
		}
	 }
	 return 1;
  }//if(wildcount)
  pSmarts->Holding(GetCasPlayer(activeplayer)->pHand);
  pSmarts->Holding(fake);
  return 1;
}
//*******************************************************************
int16 TACVPVPGLord::WildJoker5(bool copy)
{
  if(copy)
  {
	 fake->inhand = 0;
	 for(int16 i=0;i<5;i++)
	 {
		fake->cards[i].name = GetCasPlayer(activeplayer)->pHand->cards[i].name;
		fake->cards[i].suit = GetCasPlayer(activeplayer)->pHand->cards[i].suit;
		fake->inhand++;
	 }
  }
  pSmarts->Insert_Sort(fake);

  if(GetCasPlayer(activeplayer)->pHand->wildcount && fake->inhand)
  {
	 if(GetCasPlayer(activeplayer)->pHand->wildcount == 5)
	 {
		GetCasPlayer(activeplayer)->pHand->highhand = FiveJokers; // Five Jokers
		return 1;
	 }
	 if(GetCasPlayer(activeplayer)->pHand->wildcount == 4)
	 {
		GetCasPlayer(activeplayer)->pHand->highhand = FourJokers; // Five Jokers
		return 1;
	 }
	 if(GetCasPlayer(activeplayer)->pHand->wildcount == 3)
	 {
		if(fake->cards[0].suit == fake->cards[1].suit)
		{
		  if(fake->cards[0].name > Nine && fake->cards[1].name > Nine)
		  {
			 GetCasPlayer(activeplayer)->pHand->highhand = WildRFlush; // Royal with wild
			 return 1;
		  }
		  else
		  {
			 if(fake->cards[1].name - fake->cards[0].name < 5)
			 {
				GetCasPlayer(activeplayer)->pHand->highhand = StraightFlush; // Straight flush
				return 1;
			 }
			 else if(fake->cards[1].name == AceHi && fake->cards[0].name < Six)
			 {
				GetCasPlayer(activeplayer)->pHand->highhand = StraightFlush; // Straight flush
				return 1;
			 }
		  }
		}
		else
		{
		  if(fake->cards[1].name == fake->cards[0].name)
		  {
			 GetCasPlayer(activeplayer)->pHand->highhand = FiveKind; // Five of kind
			 return 1;
		  }
		}
		GetCasPlayer(activeplayer)->pHand->highhand = FourKind; // Four of a kind
		return 1;
	 }
	 if(GetCasPlayer(activeplayer)->pHand->wildcount == 2)
	 {
		if(fake->cards[0].suit == fake->cards[1].suit &&
			fake->cards[1].suit == fake->cards[2].suit)
		{
		  if(fake->cards[2].name - fake->cards[0].name < 5)
		  {
			 if(fake->cards[2].name > Nine)
			 {
				GetCasPlayer(activeplayer)->pHand->highhand = WildRFlush;  // Royal wilds
				GetCasPlayer(activeplayer)->pHand->highcard = AceHi;
				return 1;
			 }
			 else
			 {
				GetCasPlayer(activeplayer)->pHand->highhand = StraightFlush; //Straight flush
				return 1;
			 }
		  }
		  else
		  {
			 if(fake->cards[2].name == AceHi && fake->cards[1].name < Six)
			 {
				GetCasPlayer(activeplayer)->pHand->highhand = StraightFlush; //Straight flush
				return 1;
			 }
			 else
			 {
				GetCasPlayer(activeplayer)->pHand->highhand = Flush; // flush
				return 1;
			 }
		  }
		}
      ///// Below is true unless....
		if(fake->cards[2].name - fake->cards[0].name < 5)
		{
		  GetCasPlayer(activeplayer)->pHand->highhand = Straight; // Straight
		}
		else
		{                                                 //???
		  if(fake->cards[2].name == AceHi && fake->cards[1].name < Six)
		  {
			 GetCasPlayer(activeplayer)->pHand->highhand = Straight; // Straight
		  }
		}
      ///// UNLESS Start
		if(fake->cards[2].name == fake->cards[0].name)
		{
		  GetCasPlayer(activeplayer)->pHand->highhand = FiveKind; // 5 o'kind
		  return 1;
		}
		if(fake->cards[1].name == fake->cards[0].name ||
			fake->cards[1].name == fake->cards[2].name)
		{
		  GetCasPlayer(activeplayer)->pHand->highhand = FourKind; // 4 o'kind
		  return 1;
		}
      ///// UNLESS done
		if(GetCasPlayer(activeplayer)->pHand->highhand < ThreeKind)
		{
		  GetCasPlayer(activeplayer)->pHand->highhand = ThreeKind; // 3 o'kind
		}
		return 1;
	 }
	 for(int16 i=Two;i<=AceHi;i++)
	 {
		fake->cards[fake->inhand-1].name = (TCardName)i;
		for(int16 j=0;j<4;j++)
		{
		  fake->cards[fake->inhand-1].suit = (TSuit)j;
		  fake->highhand      = 0;
		  fake->highcard      = 0;
		  fake->toflush       = 0;
		  fake->instrght      = 0;
		  fake->outstrght     = 0;
		  fake->lohighcard    = 0;
		  fake->lolowcard     = 0;
		  fake->lohand        = 0;
		  fake->lowcard       = 0;
		  fake->instrght      = 0;
		  fake->outstrght     = 0;
		  fake->instrflsh     = 0;
		  fake->outstrflsh    = 0;
		  fake->instrflshsuit     = 0;
		  fake->outstrflshsuit    = 0;
		  pSmarts->Holding(fake);
		  if(fake->highhand > GetCasPlayer(activeplayer)->pHand->highhand)
		  {
			 if(fake->highhand == StraightFlush && fake->highcard == AceHi)
			 {
				GetCasPlayer(activeplayer)->pHand->highhand = WildRFlush;
				GetCasPlayer(activeplayer)->pHand->highcard = AceHi;
			 }
			 else
			 {
				GetCasPlayer(activeplayer)->pHand->highhand = fake->highhand;
				GetCasPlayer(activeplayer)->pHand->highcard = fake->highcard;
			 }
		  }
		  else
		  {
			 if(fake->highhand == StraightFlush && fake->highcard == AceHi)
			 {
				GetCasPlayer(activeplayer)->pHand->highhand = WildRFlush;
				GetCasPlayer(activeplayer)->pHand->highcard = AceHi;
			 }
		  }
		  if(fake->instrflsh > GetCasPlayer(activeplayer)->pHand->instrflsh)
		  {
			 GetCasPlayer(activeplayer)->pHand->instrflsh = fake->instrflsh;
		  }
		  if(fake->outstrflsh > GetCasPlayer(activeplayer)->pHand->outstrflsh)
		  {
			 GetCasPlayer(activeplayer)->pHand->outstrflsh = fake->outstrflsh;
		  }
		  if(fake->instrght > GetCasPlayer(activeplayer)->pHand->instrght)
		  {
			 GetCasPlayer(activeplayer)->pHand->instrght = fake->instrght;
		  }
		  if(fake->outstrght > GetCasPlayer(activeplayer)->pHand->outstrght)
		  {
			 GetCasPlayer(activeplayer)->pHand->outstrght = fake->outstrght;
		  }
		  if(fake->toflush > GetCasPlayer(activeplayer)->pHand->toflush)
		  {
			 GetCasPlayer(activeplayer)->pHand->toflush = fake->toflush;
		  }
		}
	 }
	 return 1;
  }//if(wildcount)
  pSmarts->Holding(GetCasPlayer(activeplayer)->pHand);
  pSmarts->Holding(fake);
  return 1;
}
//*******************************************************************
int16 TACVPVPGLord::WildSevensJoker(bool copy)
{
  if(copy)
  {
	 fake->inhand = 0;
	 for(int16 i=0;i<5;i++)
	 {
		fake->cards[i].name = GetCasPlayer(activeplayer)->pHand->cards[i].name;
		fake->cards[i].suit = GetCasPlayer(activeplayer)->pHand->cards[i].suit;
		fake->inhand++;
	 }
  }
  pSmarts->Insert_Sort(fake);
  if(GetCasPlayer(activeplayer)->pHand->wildcount && fake->inhand)
  {
	 if(GetCasPlayer(activeplayer)->pHand->wildcount == 5)
	 {
		GetCasPlayer(activeplayer)->pHand->highhand = FourSevensJoker; // Five Jokers
		return 1;
	 }
	 if(GetCasPlayer(activeplayer)->pHand->wildcount == 4)
	 {
      if(fake->cards[4].name != Joker)
      {
		  GetCasPlayer(activeplayer)->pHand->highhand = FourSevens; // Four Sevens
		  return 1;
      }
      for(int xx=0;xx<5;xx++)
      {
        if(fake->cards[xx].name != Joker &&
           fake->cards[xx].name != Seven &&
           fake->cards[xx].name >  Nine     )
        {
          GetCasPlayer(activeplayer)->pHand->highhand = WildRFlush; // Royal Flush with wild cards
		    return 1;
        }
      }
      GetCasPlayer(activeplayer)->pHand->highhand = FiveKind; // Five Kind
      return 1;
	 }
	 if(GetCasPlayer(activeplayer)->pHand->wildcount == 3)
	 {
      int spots[2];
      spots[0]=0;
      spots[1]=0;
      int spotIndex=0;
      int loop=0;
      for(loop=0;loop<(fake->inhand);loop++)
      {
        if(fake->cards[loop].name != Joker && fake->cards[loop].name != Seven)
        {
         spots[spotIndex++] =loop;
        }
      }
      if(fake->cards[spots[0]].suit == fake->cards[spots[1]].suit &&
         fake->inhand == 5)
      {
		  if(fake->cards[spots[0]].name > Nine && fake->cards[spots[1]].name > Nine)
		  {
		    GetCasPlayer(activeplayer)->pHand->highhand = WildRFlush; // Royal with wild
			 return 1;
        }
		  else
		  {
		    if(fake->cards[spots[1]].name - fake->cards[spots[0]].name < 5)
		    {
		      GetCasPlayer(activeplayer)->pHand->highhand = StraightFlush; // Straight flush
			   return 1;
			 }
		    else if(fake->cards[spots[1]].name == AceHi && fake->cards[spots[0]].name < Six)
			 {
			   GetCasPlayer(activeplayer)->pHand->highhand = StraightFlush; // Straight flush
			   return 1;
			 }
        }
      }
		else
		{
		  if(fake->cards[spots[0]].name == fake->cards[spots[1]].name &&
           fake->inhand == 5)
		  {
		    GetCasPlayer(activeplayer)->pHand->highhand = FiveKind; // Five of kind
			 return 1;
        }
      }
	   GetCasPlayer(activeplayer)->pHand->highhand = FourKind; // Four of a kind
	   return 1;
    }
    if(GetCasPlayer(activeplayer)->pHand->wildcount == 2)
	 {
      int spots[3];
      spots[0]=0;
      spots[1]=0;
      spots[2]=0;
      int spotIndex=0;
      int loop=0;
      for(loop=0;loop<(fake->inhand);loop++)
      {
        if(fake->cards[loop].name != Joker && fake->cards[loop].name != Seven)
        {
         spots[spotIndex++] =loop;
        }
      }
		if(fake->cards[spots[0]].suit == fake->cards[spots[1]].suit &&
			fake->cards[spots[1]].suit == fake->cards[spots[2]].suit &&
         spots[2] != 0 &&
         fake->inhand == 5)
		{
		  if((fake->cards[spots[2]].name - fake->cards[spots[0]].name < 5) &&
            spots[2] != 0)
		  {
			 if(fake->cards[spots[0]].name > Nine)
			 {
				GetCasPlayer(activeplayer)->pHand->highhand = WildRFlush;  // Royal wilds
				GetCasPlayer(activeplayer)->pHand->highcard = AceHi;
				return 1;
			 }
			 else
			 {
				GetCasPlayer(activeplayer)->pHand->highhand = StraightFlush; //Straight flush
				return 1;
			 }
		  }
		  else
		  {
			 if(fake->cards[spots[2]].name == AceHi &&
             fake->cards[spots[1]].name < Six  &&
             spots[2] != 0 &&
             fake->inhand == 5)
			 {
				GetCasPlayer(activeplayer)->pHand->highhand = StraightFlush; //Straight flush
				return 1;
			 }
			 else
			 {
				GetCasPlayer(activeplayer)->pHand->highhand = Flush; // flush
				return 1;
			 }
		  }
		}
      ///// Below is true unless....
		if(fake->cards[spots[2]].name - fake->cards[spots[0]].name < 5 &&
         spots[2] != 0 &&
         fake->inhand == 5                                             )
		{
		  GetCasPlayer(activeplayer)->pHand->highhand = Straight; // Straight
		}
		else
		{
		  if(fake->cards[spots[2]].name == AceHi && fake->cards[spots[1]].name < Six &&
           spots[2] != 0 &&
           fake->inhand == 5)
		  {
			 GetCasPlayer(activeplayer)->pHand->highhand = Straight; // Straight
		  }
		}
      ///// UNLESS Start
		if(fake->cards[spots[2]].name == fake->cards[spots[0]].name &&
         spots[2] != 0 &&
         fake->inhand == 5)
		{
		  GetCasPlayer(activeplayer)->pHand->highhand = FiveKind; // 5 o'kind
		  return 1;
		}
		if((fake->cards[spots[1]].name == fake->cards[spots[0]].name  ||
			 fake->cards[spots[1]].name == fake->cards[spots[2]].name) &&
          fake->inhand == 5                                           )
		{
		  GetCasPlayer(activeplayer)->pHand->highhand = FourKind; // 4 o'kind
		  return 1;
		}
      if(((fake->cards[0].name != Joker && fake->cards[0].name != Seven) &&
          (fake->cards[0].name == fake->cards[1].name))                      ||
         ((fake->cards[1].name != Joker && fake->cards[1].name != Seven) &&
          (fake->cards[1].name == fake->cards[2].name))                      ||
         ((fake->cards[2].name != Joker && fake->cards[2].name != Seven) &&
          (fake->cards[2].name == fake->cards[3].name))                      &&
           fake->inhand == 4                                           )
		{
		  GetCasPlayer(activeplayer)->pHand->highhand = FourKind; // 4 o'kind
		  return 1;
		}
      ///// UNLESS done
		if(GetCasPlayer(activeplayer)->pHand->highhand < ThreeKind)
		{
		  GetCasPlayer(activeplayer)->pHand->highhand = ThreeKind; // 3 o'kind
		}
		return 1;
	 }
    int spot = -1;
    int loop=0;
    for(loop=0;loop<fake->inhand;loop++)
    {
      if(fake->cards[loop].name == Joker || fake->cards[loop].name == Seven)
      {
        spot = loop;
        break;
      }
    }
    if(spot != -1)
    {
     fake->cards[spot].name = fake->cards[fake->inhand-1].name;
     fake->cards[spot].suit = fake->cards[fake->inhand-1].suit;

	  for(int16 i=Two;i<=AceHi;i++)
	  {
		fake->cards[fake->inhand-1].name = (TCardName)i;
		for(int16 j=0;j<4;j++)
		{
		  fake->cards[fake->inhand-1].suit = (TSuit)j;
		  fake->highhand      = 0;
		  fake->highcard      = 0;
		  fake->toflush       = 0;
		  fake->instrght      = 0;
		  fake->outstrght     = 0;
		  fake->lohighcard    = 0;
		  fake->lolowcard     = 0;
		  fake->lohand        = 0;
		  fake->lowcard       = 0;
		  fake->instrght      = 0;
		  fake->outstrght     = 0;
		  fake->instrflsh     = 0;
		  fake->outstrflsh    = 0;
		  fake->instrflshsuit     = 0;
		  fake->outstrflshsuit    = 0;
		  pSmarts->Holding(fake);
		  if(fake->highhand > GetCasPlayer(activeplayer)->pHand->highhand)
		  {
			 if(fake->highhand == StraightFlush && fake->highcard == AceHi)
			 {
				GetCasPlayer(activeplayer)->pHand->highhand = WildRFlush;
				GetCasPlayer(activeplayer)->pHand->highcard = AceHi;
			 }
			 else
			 {
				GetCasPlayer(activeplayer)->pHand->highhand = fake->highhand;
				GetCasPlayer(activeplayer)->pHand->highcard = fake->highcard;
			 }
		  }
		  else
		  {
			 if(fake->highhand == StraightFlush && fake->highcard == AceHi)
			 {
				GetCasPlayer(activeplayer)->pHand->highhand = WildRFlush;
				GetCasPlayer(activeplayer)->pHand->highcard = AceHi;
			 }
		  }
		  if(fake->instrflsh > GetCasPlayer(activeplayer)->pHand->instrflsh)
		  {
			 GetCasPlayer(activeplayer)->pHand->instrflsh = fake->instrflsh;
		  }
		  if(fake->outstrflsh > GetCasPlayer(activeplayer)->pHand->outstrflsh)
		  {
			 GetCasPlayer(activeplayer)->pHand->outstrflsh = fake->outstrflsh;
		  }
		  if(fake->instrght > GetCasPlayer(activeplayer)->pHand->instrght)
		  {
			 GetCasPlayer(activeplayer)->pHand->instrght = fake->instrght;
		  }
		  if(fake->outstrght > GetCasPlayer(activeplayer)->pHand->outstrght)
		  {
			 GetCasPlayer(activeplayer)->pHand->outstrght = fake->outstrght;
		  }
		  if(fake->toflush > GetCasPlayer(activeplayer)->pHand->toflush)
		  {
			 GetCasPlayer(activeplayer)->pHand->toflush = fake->toflush;
		  }
		}
	  }
    }
    else
    {
      pSmarts->Holding(fake);
    }
    pSmarts->Insert_Sort(fake);
	 return 1;

  }//if(wildcount)
  pSmarts->Holding(GetCasPlayer(activeplayer)->pHand);
  pSmarts->Holding(fake);
  return 1;
}
//*******************************************************************
bool TACVPVPGLord::CheckExpertCode()
{
  bool returnvalue = true;
  bool wildHeld = false;
  int16 numOfWildHeld=0;
  GetCasPlayer(activeplayer)->pHand->highhand      = 0;
  GetCasPlayer(activeplayer)->pHand->highcard      = 0;
  GetCasPlayer(activeplayer)->pHand->toflush       = 0;
  GetCasPlayer(activeplayer)->pHand->instrght      = 0;
  GetCasPlayer(activeplayer)->pHand->outstrght     = 0;
  GetCasPlayer(activeplayer)->pHand->instrflsh     = 0;
  GetCasPlayer(activeplayer)->pHand->outstrflsh    = 0;
  GetCasPlayer(activeplayer)->pHand->instrflshsuit     = 0;
  GetCasPlayer(activeplayer)->pHand->outstrflshsuit    = 0;
  GetCasPlayer(activeplayer)->pHand->lohighcard    = 0;
  GetCasPlayer(activeplayer)->pHand->lolowcard     = 0;
  GetCasPlayer(activeplayer)->pHand->lohand        = 0;
  GetCasPlayer(activeplayer)->pHand->lowcard       = 0;
  GetCasPlayer(activeplayer)->pHand->wildcount     = 0;
  fake->highhand      = 0;
  fake->highcard      = 0;
  fake->toflush       = 0;
  fake->instrght      = 0;
  fake->outstrght     = 0;
  fake->instrflsh     = 0;
  fake->outstrflsh    = 0;
  fake->instrflshsuit     = 0;
  fake->outstrflshsuit    = 0;
  fake->lohighcard    = 0;
  fake->lolowcard     = 0;
  fake->lohand        = 0;
  fake->lowcard       = 0;
  fake->wildcount     = 0;
  fake->inhand        = 0;
  GetNumOfWildCards();
  for(int16 i=0;i<5;i++)
  {
    if(SubGameType == cvpDDownStud)
    {
      if(i < 4)
      {
        fake->cards[fake->inhand].name = GetCasPlayer(activeplayer)->pHand->cards[i].name;
		  fake->cards[fake->inhand].suit = GetCasPlayer(activeplayer)->pHand->cards[i].suit;
        fake->inhand++;
      }
    }
	 else if(GetCasPlayer(activeplayer)->pHand->hold[i] == 1)
	 {
		fake->cards[fake->inhand].name = GetCasPlayer(activeplayer)->pHand->cards[i].name;
		fake->cards[fake->inhand].suit = GetCasPlayer(activeplayer)->pHand->cards[i].suit;
		if ((SubGameType == cvpDeucesWildII || SubGameType == cvpDeucesWildBonus ||
           SubGameType == cvpDeucesWild || SubGameType == cvpDeucesWildProg)
          && fake->cards[fake->inhand].name == Two)
		{
		  wildHeld = true;
        numOfWildHeld++;
		}
		if ((SubGameType == cvpDDrawJokerPoker ||
           SubGameType == cvpJokersWildProg || SubGameType == cvpJumpinJokers ||
           SubGameType == cvpRaiseJokersWild || SubGameType == cvp7Wild1Joker)
          && fake->cards[fake->inhand].name == Joker)
		{
		  wildHeld = true;
        numOfWildHeld++;
		}
		if (SubGameType == cvp7Wild1Joker && fake->cards[fake->inhand].name == Seven)
		{
		  wildHeld = true;
        numOfWildHeld++;
		}
		fake->inhand++;
	 }
  }
  if (SubGameType == cvpDeucesWildBonus ||
      SubGameType == cvpDeucesWildII ||
      SubGameType == cvpDeucesWildProg  )
  {
	 Wild2s(false);
  }
  else if (SubGameType == cvpJokersWildProg ||
           SubGameType == cvpRaiseJokersWild ||
           SubGameType == cvpDDrawJokerPoker )
  {
	 WildJokers(false);
  }
  else if (SubGameType == cvpJumpinJokers)
  {
	 WildJoker5(false);
  }
  else if (SubGameType == cvp7Wild1Joker)
  {
	 WildSevensJoker(false);
  }
  else
  {
	 pSmarts->Holding(GetCasPlayer(activeplayer)->pHand);
	 pSmarts->Holding(fake);
  }
  pSmarts->Insert_Sort(fake);
  if(ask->ExpertCode == 1)
  {
	 if(fake->inhand == 5)
	 {returnvalue = true;}
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 2)
  {
	 if(fake->inhand == 4 && GetCasPlayer(activeplayer)->pHand->highhand == 71 &&
		 fake->cards[0].name == fake->cards[1].name  &&
		 fake->cards[0].name == fake->cards[2].name  &&
		 fake->cards[0].name == fake->cards[3].name                               )
	 {returnvalue = true;}
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 102)
  {
	 if(fake->inhand == 4 &&
		 fake->cards[0].name == fake->cards[1].name &&
		 fake->cards[2].name == fake->cards[3].name &&
		 fake->cards[0].name == Two)
	 {returnvalue = true;}
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 302)
  {
	 if(fake->inhand == 4 &&
		 fake->cards[1].name == fake->cards[2].name &&
		 fake->cards[2].name == fake->cards[0].name &&
		 fake->cards[3].name == AceHi)
	 {returnvalue = true;}
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 402)
  {
	 if(fake->inhand == 4 && GetCasPlayer(activeplayer)->pHand->highhand == 71)
	 {returnvalue = true;}
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 3)
  {
	 if((GetCasPlayer(activeplayer)->pHand->outstrflsh > 3 ||
			 GetCasPlayer(activeplayer)->pHand->instrflsh > 3 ) &&
		  fake->cards[0].name > Nine && fake->inhand == 4      &&
		  fake->cards[0].suit == fake->cards[1].suit	          &&
		  fake->cards[0].suit == fake->cards[2].suit	          &&
		  fake->cards[0].suit == fake->cards[3].suit	            )
	 { // four to a royal flush
		returnvalue = true;
	 }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 103)
  {
	 returnvalue = false;
	 if((GetCasPlayer(activeplayer)->pHand->outstrflsh > 3 ||
		  GetCasPlayer(activeplayer)->pHand->instrflsh > 3 ) &&
		  fake->cards[0].name > Nine && fake->inhand == 4 &&
		  fake->cards[0].suit == fake->cards[1].suit	&&
		  fake->cards[0].suit == fake->cards[2].suit)
	 { // four to a royal flush
		for(int zz=0;zz<5;zz++)
		{
		  if(GetCasPlayer(activeplayer)->pHand->hold[zz] == 1   &&
			  GetCasPlayer(activeplayer)->pHand->cards[zz].name == Joker)
		  {
			 returnvalue = true;
		  }
		}
	 }
  }
  else if(ask->ExpertCode == 4)
  {
	 if(((fake->outstrflsh > 3 ||
         fake->instrflsh  > 3) &&
			fake->inhand == 4 &&
			!wildHeld) ||
			(wildHeld &&
         fake->inhand == 4 &&
			(GetCasPlayer(activeplayer)->pHand->outstrflsh > 3 ||
			 GetCasPlayer(activeplayer)->pHand->instrflsh  > 3   ))     )
	 {
      returnvalue = true;
    } //four to a straight flush
	 else
	 {
      returnvalue = false;
    }
  }
  else if(ask->ExpertCode == 104)
  {
	 if(((fake->outstrflsh > 3 || fake->instrflsh  > 3)         &&
			fake->inhand == 4                                     &&
			!wildHeld                                               ) ||
			(wildHeld &&
			 fake->inhand == 4 &&
			(GetCasPlayer(activeplayer)->pHand->outstrflsh > 3 ||
			 GetCasPlayer(activeplayer)->pHand->instrflsh  > 3   ))     )
	 {returnvalue = true;} //four to a straight flush
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 5)
  {
	 returnvalue = false;
	 if( fake->highhand == 20 && fake->inhand == 3  &&
		  fake->cards[0].name == fake->cards[1].name &&
		  fake->cards[1].name == fake->cards[2].name   )
	 {returnvalue = true;}// three o' kind
	 else if((GetCasPlayer(activeplayer)->pHand->highhand == 20 && fake->inhand == 3)  &&
				(SubGameType == cvpDeucesWild || SubGameType == cvpJokersWild)              )
	 {returnvalue = true;}// three o' kind
  }
  else if(ask->ExpertCode == 55)
  {
	 if( fake->inhand == 3 &&
		 (fake->cards[0].name == fake->cards[1].name && fake->cards[1].name ==
		  fake->cards[2].name) )
	 {returnvalue = true;}// three two's
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 6)
  {
	 returnvalue = false;
	 if(((GetCasPlayer(activeplayer)->pHand->outstrflsh > 2 ||
			GetCasPlayer(activeplayer)->pHand->instrflsh  > 2  ) &&
			wildHeld                                               ) ||
		  (!wildHeld  &&
		  (fake->outstrflsh > 2 || fake->instrflsh > 2)               )  )
	 {// three to a royal
		  if(fake->cards[0].name > Nine && fake->inhand == 3 )
		  {returnvalue = true;}
	 }
  }
  else if(ask->ExpertCode == 7)
  {
	 if((wildHeld && GetCasPlayer(activeplayer)->pHand->outstrght > 3 && fake->inhand == 4) ||
		 (!wildHeld && fake->outstrght > 3 && fake->inhand == 4)                               )
	 {returnvalue = true;}//four card straight
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 8)
  {
	 if(fake->inhand == 3 && fake->cards[0].suit == fake->cards[1].suit &&
		 fake->cards[0].suit == fake->cards[2].suit &&
		 fake->cards[2].name - fake->cards[0].name < 5)
	 {//three to straight flush
		returnvalue = true;
	 }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 88)
  {
	 if(fake->inhand == 3 && fake->cards[0].suit == fake->cards[1].suit &&
		 fake->cards[2].name == 13 &&
		 fake->cards[1].name - fake->cards[0].name < 5)
	 {//three to straight flush
		returnvalue = true;
	 }
	 else if(fake->inhand == 3 &&
				fake->cards[2].name == 13 &&
				fake->cards[1].name == 13 &&
			  (fake->cards[0].suit == fake->cards[1].suit ||
				fake->cards[0].suit == fake->cards[2].suit   )  &&
			  (fake->cards[1].name - fake->cards[0].name < 5 ||
				fake->cards[0].name < Six)                        )
	 {//three to straight flush
		returnvalue = true;
	 }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 9)
  {
	 if((wildHeld && GetCasPlayer(activeplayer)->pHand->toflush  > 3 && fake->inhand == 4) ||
		 (!wildHeld && fake->toflush > 3 && fake->inhand == 4)                                )
	 {//four to flush
		returnvalue = true;
	 }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 10)
  {
	 if(((wildHeld && GetCasPlayer(activeplayer)->pHand->outstrght > 3) ||
		  (!wildHeld && fake->outstrght > 3) ) && fake->inhand == 4        )
	 {//four to straight
		returnvalue = true;
	 }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 11)
  {
	 if((wildHeld && GetCasPlayer(activeplayer)->pHand->outstrght > 2 && fake->inhand == 3) ||
		 (!wildHeld && fake->outstrght > 2 && fake->inhand == 3)                               )
	 {//three to straight
		returnvalue = true;
	 }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 12)
  {
	 int xy=0;
	 returnvalue = false;
	 for(xy=0;xy<5;xy++)
	 {
		if(GetCasPlayer(activeplayer)->pHand->hold[xy] == 1)
		{
		  if(fake->inhand == 1 && GetCasPlayer(activeplayer)->pHand->cards[xy].name == Joker)
		  {returnvalue = true;} //joker only
		}
	 }
  }
  else if(ask->ExpertCode == 13)
  {
	 if(fake->inhand == 0)    //garbage
	 {returnvalue = true;}
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 15)
  {
	 if(((wildHeld && GetCasPlayer(activeplayer)->pHand->highhand == 15) ||
		  (!wildHeld && fake->highhand == 15) ) && fake->inhand == 4        )
	 {//two pair
		returnvalue = true;
	 }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 16)
  {
	 if(fake->highhand == 10 && fake->inhand == 2)
	 {//any pair
		returnvalue = true;
	 }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 17)
  {
	 if((wildHeld && GetCasPlayer(activeplayer)->pHand->toflush > 2 && fake->inhand == 3) ||
		 (!wildHeld && fake->toflush > 2 && fake->inhand == 3)                               )
	 { //three to a flush
		returnvalue = true;
	 }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 18)
  {
	 if(((GetCasPlayer(activeplayer)->pHand->instrflsh > 1 ||
		  GetCasPlayer(activeplayer)->pHand->outstrflsh > 1  ) &&
		  fake->inhand == 2 &&
		  wildHeld          &&
		  fake->cards[0].name > Nine)                          ||
		  (!wildHeld && fake->inhand == 2 && (fake->instrflsh > 1 || fake->outstrflsh > 1))  )
	 {//two to a royal
		returnvalue = true;
	 }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 19)
  {
	 if((wildHeld && GetCasPlayer(activeplayer)->pHand->outstrflsh > 1 && fake->inhand == 2) ||
		 (!wildHeld && fake->inhand == 2 && fake->outstrflsh > 1)                               )
	 {//two to a straight flush
		returnvalue = true;
	 }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 20)
  {
	 if(fake->inhand > 3 &&
		((wildHeld && GetCasPlayer(activeplayer)->pHand->highhand == 71) ||
		 (!wildHeld && fake->highhand == 71)                              ) )
	 {returnvalue = true;}//four of kind, hold 4 or 5 cards
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 220)
  {
	 if((fake->inhand == 4 &&
		  fake->cards[0].name == fake->cards[1].name &&
		  fake->cards[0].name == fake->cards[2].name &&
		  fake->cards[0].name == fake->cards[3].name   ) ||
		  fake->inhand == 5                                )
	 {returnvalue = true;}//four of kind, hold 4 or 5 cards
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 21)
  {
	 if(GetCasPlayer(activeplayer)->pHand->highhand == 10 && fake->inhand == 2 &&
		 fake->cards[0].name > Nine && fake->cards[1].name > Nine && fake->cards[0].name ==
		 fake->cards[1].name)
	 {//high pair
		returnvalue = true;
	 }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 22)
  {
	 if(((GetCasPlayer(activeplayer)->pHand->instrflsh  > 2 ||
			GetCasPlayer(activeplayer)->pHand->outstrflsh > 1  ) &&
			wildHeld                                             &&
			fake->inhand == 3)                                   ||
		  (!wildHeld && (fake->instrflsh > 2 || fake->outstrflsh > 1) && fake->inhand == 3)  )
	 {//three to straight flush (inside)
		returnvalue = true;
	 }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 23)
  {
	 if((wildHeld && GetCasPlayer(activeplayer)->pHand->outstrflsh  > 2 && fake->inhand == 3 &&
		  fake->cards[2].name > Nine)                                                           ||
		 (!wildHeld && fake->inhand == 3 && fake->outstrflsh > 2 && fake->cards[2].name > Nine)   )
	 {//three to straight flush with 10 or higher
		returnvalue = true;
	 }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 24)
  {
	 if((wildHeld && (GetCasPlayer(activeplayer)->pHand->instrflsh  > 2 ||
		  GetCasPlayer(activeplayer)->pHand->outstrflsh > 1  ) &&
		  fake->inhand == 3 &&
		  fake->cards[2].name > Nine)                                      ||
		((fake->instrflsh  > 2 ||
		  fake->outstrflsh > 1  ) &&
		  fake->inhand == 3 && !wildHeld &&
		  fake->cards[2].name > Nine)                                        )

	 {//three to straight flush with 10 or higher
		returnvalue = true;
	 }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 25)
  {
	 if(fake->inhand == 2 && fake->cards[0].name > Nine && fake->cards[1].name > Nine)
	 {//two high cards
		returnvalue = true;
	 }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 26)
  {
	 if(fake->inhand == 1 && fake->cards[0].name > Nine)
	 {//one high cards
		returnvalue = true;
	 }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 27)
  {
	 if(GetCasPlayer(activeplayer)->pHand->highhand == 10 && fake->inhand == 2 &&
		 fake->cards[0].name > Ten && fake->cards[0].name == fake->cards[1].name)
	 {//high pair
		returnvalue = true;
	 }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 28)
  {
	 if(((GetCasPlayer(activeplayer)->pHand->instrflsh  > 2 ||
			GetCasPlayer(activeplayer)->pHand->outstrflsh > 2  ) &&
			fake->inhand == 3 &&
			wildHeld)                                              ||
		  (!wildHeld && (fake->instrflsh > 2 || fake->outstrflsh > 2) && fake->inhand == 3)   )
	 {//three to straight flush with jack or higher
		returnvalue = true;
	 }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 29)
  {
	 if(((GetCasPlayer(activeplayer)->pHand->instrflsh > 1 ||
			GetCasPlayer(activeplayer)->pHand->outstrflsh > 1  ) &&
			fake->inhand == 2 &&
			fake->cards[0].name > Ten &&
			wildHeld)                                              ||
		  (!wildHeld && (fake->instrflsh > 1 || fake->outstrflsh > 1) &&
			fake->cards[0].name > Ten && fake->inhand == 2)               )

	 {//two to a royal no ten
		returnvalue = true;
	 }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 30)
  {
	 if(fake->inhand == 2 && fake->cards[0].name > Ten && fake->cards[1].name > Ten)
	 {//two high cards
		returnvalue = true;
	 }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 31)
  {
	 if(fake->inhand == 3 && fake->cards[0].name == Jack && fake->cards[1].name == Queen &&
		 fake->cards[2].name == King)
	 {//King-Queen-Jack
		returnvalue = true;
	 }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 32)
  {
	 if(fake->inhand == 1 && fake->cards[0].name > Ten)
	 {//one high cards
		returnvalue = true;
	 }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 33)
  {
	 if((wildHeld && GetCasPlayer(activeplayer)->pHand->outstrflsh > 3 && fake->inhand == 4) ||
		 (!wildHeld && fake->outstrflsh > 3 && fake->inhand == 4)                               )
	 {returnvalue = true;} //four to a straight flush
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 34)
  {
	 if(fake->inhand == 1)
	 {
		for(int z=0;z<5;z++)
		{
		  if(GetCasPlayer(activeplayer)->pHand->hold[z] == 1)
		  {
			  if(GetCasPlayer(activeplayer)->pHand->cards[z].name == Two)
			  {returnvalue = true;} //deuce only
			  else
			  {returnvalue = false;}
		  }
		}
	 }
	 else
	 {
		returnvalue = false;
	 }
  }
  else if(ask->ExpertCode == 35)
  {
	 if(((GetCasPlayer(activeplayer)->pHand->outstrflsh > 3 ||
			GetCasPlayer(activeplayer)->pHand->instrflsh > 3 ) &&
			fake->inhand == 4                                    &&
			fake->cards[1].name > Nine                           &&
			wildHeld  )                                             ||
		  (!wildHeld && (fake->outstrflsh > 3 || fake->instrflsh > 3) &&
			fake->inhand == 4 && fake->cards[1].name > Nine)             )
	 { // four to a royal flush
		returnvalue = true;
	 }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 135)
  {
	 returnvalue = false;
	 if((GetCasPlayer(activeplayer)->pHand->outstrflsh > 3 ||
			 GetCasPlayer(activeplayer)->pHand->instrflsh > 3 ) &&
		  fake->inhand == 4                                    &&
		  fake->cards[0].name > Nine                           &&
		  fake->cards[0].suit == fake->cards[1].suit           &&
		  (fake->cards[0].suit == fake->cards[2].suit          ||
			fake->cards[0].suit == fake->cards[3].suit	         ) )
	 { // four to a royal flush with one wild 2
		for(int zz=0;zz<5;zz++)
		{
		  if(GetCasPlayer(activeplayer)->pHand->hold[zz] == 1   &&
			  GetCasPlayer(activeplayer)->pHand->cards[zz].name == Two)
		  {
			 returnvalue = true;
		  }
		}
	 }
  }
  else if(ask->ExpertCode == 36)
  {
	 if(fake->cards[2].name > Nine && fake->inhand == 4)
	 { // four to a royal flush
		returnvalue = true;
	 }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 136)
  {
	 if(fake->cards[2].name > Nine                      &&
		 fake->inhand == 4                               &&
		 fake->cards[2].suit == fake->cards[3].suit      &&
		 fake->cards[0].name == Two                      &&
		 fake->cards[1].name == Two                        )
	 { // four to a royal flush with two wild 2's
		returnvalue = true;
	 }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 37)
  {
	 if(fake->inhand == 2 && fake->cards[0].name == Two && fake->cards[1].name == Two)
	 {//two deuces
		returnvalue = true;
	 }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 38)
  {
	 if(((wildHeld && GetCasPlayer(activeplayer)->pHand->instrght > 3) ||
		  (!wildHeld && fake->instrght > 3)) && fake->inhand == 4         )
	 {//four to straight
		returnvalue = true;
	 }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 553)
  {
	 if(fake->inhand == 4 && numOfWildHeld == 4)
	 {//four wild cards
		returnvalue = true;
	 }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 504)
  {
	 if(fake->inhand == 3 && numOfWildHeld == 3)
	 {//Three wild cards
		returnvalue = true;
	 }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 502)
  {
	 if(fake->inhand == 4 && GetCasPlayer(activeplayer)->pHand->highhand == 71)
	 {//4 kind, two wild
    returnvalue = true;}
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 505)
  {
	 if((GetCasPlayer(activeplayer)->pHand->outstrflsh > 3 ||
			 GetCasPlayer(activeplayer)->pHand->instrflsh > 3 ) &&
		  numOfWildHeld == 2 && fake->inhand == 4)
    {
      if(SubGameType == cvpDeucesWildII || SubGameType == cvpDeucesWildBonus ||
         SubGameType == cvpDeucesWild   || SubGameType == cvpDeucesWildProg      )
		{
        if(fake->cards[2].name > Nine &&
		     fake->cards[2].suit == fake->cards[3].suit)
        { // four to a royal flush, 2 wild
		    returnvalue = true;
	     }
        else{returnvalue = false;}
      }
      if(SubGameType == cvpJumpinJokers)
		{
        if(fake->cards[0].name > Nine &&
		     fake->cards[0].suit == fake->cards[1].suit)
        { // four to a royal flush, 2 wild
		    returnvalue = true;
	     }
        else{returnvalue = false;}
      }
      if(SubGameType == cvp7Wild1Joker)
		{
        if((fake->cards[1].name > Nine &&
            fake->cards[1].suit == fake->cards[2].suit) ||
		     (fake->cards[2].name > Nine &&
            fake->cards[2].suit == fake->cards[3].suit)   )
        { // four to a royal flush, 2 wild
		    returnvalue = true;
	     }
        else{returnvalue = false;}
      }
    }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 506)
  {
	 if((GetCasPlayer(activeplayer)->pHand->outstrflsh > 3 ||
			 GetCasPlayer(activeplayer)->pHand->instrflsh > 3 ) &&
		  numOfWildHeld == 2 && fake->inhand == 4)
    {
      if(SubGameType == cvpDeucesWildII || SubGameType == cvpDeucesWildBonus ||
         SubGameType == cvpDeucesWild   || SubGameType == cvpDeucesWildProg      )
		{
        if((fake->cards[3].name-fake->cards[2].name < 5) &&
		     fake->cards[2].suit == fake->cards[3].suit)
        { // four to a straight flush, 2 wild
		    returnvalue = true;
	     }
        else{returnvalue = false;}
      }
      if(SubGameType == cvpJumpinJokers)
		{
        if((fake->cards[1].name-fake->cards[0].name < 5) &&
		     fake->cards[0].suit == fake->cards[1].suit)
        { // four to a straight flush, 2 wild
		    returnvalue = true;
	     }
        else{returnvalue = false;}
      }
      if(SubGameType == cvp7Wild1Joker)
		{
        if(((fake->cards[2].name-fake->cards[1].name < 5) &&
            fake->cards[1].suit == fake->cards[2].suit) ||
		     ((fake->cards[3].name-fake->cards[2].name < 5) &&
            fake->cards[2].suit == fake->cards[3].suit)   )
        { // four to a straight flush, 2 wild
		    returnvalue = true;
	     }
        else{returnvalue = false;}
      }
    }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 507)
  {
	 if(numOfWildHeld == 2 && fake->inhand == 2)
    {//2 wild
      returnvalue = true;
    }
    else{returnvalue = false;}
  }
  else if(ask->ExpertCode == 508)
  {
	 if(fake->inhand == 4 && GetCasPlayer(activeplayer)->pHand->highhand == 71)
	 {//4 kind, one wild
    returnvalue = true;}
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 509)
  {
	 if((GetCasPlayer(activeplayer)->pHand->outstrflsh > 3 ||
			 GetCasPlayer(activeplayer)->pHand->instrflsh > 3 ) &&
		  numOfWildHeld == 1 && fake->inhand == 4)
    {
       // if(fake->cards[0].name > Nine &&
		 //    fake->cards[0].suit == fake->cards[1].suit &&
       //    fake->cards[0].suit == fake->cards[2].suit)
       // { // four to a royal flush, 1 wild
		    returnvalue = true;
	    // }
       // else{returnvalue = false;}
    }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 510)
  {
	 if((GetCasPlayer(activeplayer)->pHand->outstrflsh > 3 ||
			 GetCasPlayer(activeplayer)->pHand->instrflsh > 3 ) &&
		  numOfWildHeld == 1 && fake->inhand == 4)
    {//4 to sf
      returnvalue = true;
    }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 511)
  {
	 returnvalue = false;
   if(GetCasPlayer(activeplayer)->pHand->highhand == 20 && fake->inhand == 3 &&
      numOfWildHeld >= 1)
	{returnvalue = true;}// three o' kind
  }
  else if(ask->ExpertCode == 512)
  {
	 if((GetCasPlayer(activeplayer)->pHand->outstrflsh > 2) &&
		  numOfWildHeld == 1 && fake->inhand == 3)
    {//3 to sf, outside
      returnvalue = true;
    }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 517)
  {
	 if((GetCasPlayer(activeplayer)->pHand->instrflsh > 2 ) &&
		  numOfWildHeld == 1 && fake->inhand == 3)
    {//3 to sf inside
      returnvalue = true;
    }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 513)
  {
    if(SubGameType == cvpDeucesWildII || SubGameType == cvpDeucesWildBonus ||
         SubGameType == cvpDeucesWild   || SubGameType == cvpDeucesWildProg      )
	 {
      if((GetCasPlayer(activeplayer)->pHand->outstrflsh > 2 ||
			    GetCasPlayer(activeplayer)->pHand->instrflsh > 2 ) &&
		       numOfWildHeld == 1 && fake->inhand == 3 &&
             fake->cards[1].name > Nine)
      { // 3 to rf
        returnvalue = true;
      }
	   else
	   {returnvalue = false;}
    }
    else if(SubGameType == cvp7Wild1Joker)
	 {
      if((GetCasPlayer(activeplayer)->pHand->outstrflsh > 2 ||
			    GetCasPlayer(activeplayer)->pHand->instrflsh > 2 ) &&
		       numOfWildHeld == 1 && fake->inhand == 3 )
      {
        if(fake->cards[0].name > Ten)
        { // 3 to rf
          returnvalue = true;
        }
      }
	   else
	   {returnvalue = false;}
    }
	 else if((GetCasPlayer(activeplayer)->pHand->outstrflsh > 2 ||
			    GetCasPlayer(activeplayer)->pHand->instrflsh > 2 ) &&
		       numOfWildHeld == 1 && fake->inhand == 3 &&
             fake->cards[0].name > Nine)
    { // 3 to rf
      returnvalue = true;
    }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 514)
  {
   if((GetCasPlayer(activeplayer)->pHand->outstrght > 3 ||
       GetCasPlayer(activeplayer)->pHand->instrght > 3   ) &&
      fake->inhand == 4)
	 {returnvalue = true;}//four card straight
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 515)
  {
    if(GetCasPlayer(activeplayer)->pHand->toflush  > 3 && fake->inhand == 4)
	 {//four to flush
		returnvalue = true;
	 }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 516)
  {
    if(numOfWildHeld == 1)
	 {//one wild
		returnvalue = true;
	 }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 520)
  {
   if(GetCasPlayer(activeplayer)->pHand->outstrght > 3 &&
      fake->inhand == 4                                  )
	 {returnvalue = true;}//four card outside straight
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 521)
  {
   if(GetCasPlayer(activeplayer)->pHand->instrght > 3 &&
      fake->inhand == 4                                  )
	 {returnvalue = true;}//four card inside straight
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 522)
  {
   if(GetCasPlayer(activeplayer)->pHand->outstrght > 2 &&
      fake->inhand == 3                                  )
	 {returnvalue = true;}//4 card outside straight
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 518)
  {
   if(fake->cards[0].name == Jack && fake->cards[1].name == Queen &&
      fake->cards[2].name == King && fake->cards[3].name == AceHi &&
      fake->inhand == 4                                             )
	 {returnvalue = true;}//a-k-q-j
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 519)
  {
   if(fake->cards[0].name > Ten && fake->inhand < 3)
	 {returnvalue = true;}//1-2 high cards
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 538)
  {
   if(fake->cards[0].name > Ten && fake->inhand == 2 &&
      GetCasPlayer(activeplayer)->pHand->highhand == 10)
	 {returnvalue = true;}// high pair
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 523)
  {
   if((GetCasPlayer(activeplayer)->pHand->outstrght > 3 ||
       GetCasPlayer(activeplayer)->pHand->instrght > 3   ) &&
      fake->inhand == 4 && fake->cards[3].name > Ten)
	 {returnvalue = true;}//four card straight, 1-3 hc
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 524)
  {
	 if((GetCasPlayer(activeplayer)->pHand->instrflsh > 2 ||
        GetCasPlayer(activeplayer)->pHand->outstrflsh > 2   ) &&
		  fake->cards[0].name == Nine &&
        fake->cards[1].name == Ten  &&
        fake->cards[2].name == Jack &&
        fake->inhand == 3                                        )
    {//3 to sf j-10-9
      returnvalue = true;
    }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 525)
  {
   if(GetCasPlayer(activeplayer)->pHand->outstrght > 3 &&
      fake->inhand == 4                                  )
	 {returnvalue = true;}//four card outside straight
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 526)
  {
	 if(fake->cards[0].name == AceHi &&
       fake->cards[1].name == AceHi &&
       fake->cards[2].name == AceHi &&
       fake->inhand == 3             )
    {//3 aces
      returnvalue = true;
    }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 527)
  {
	 if(fake->cards[0].name == AceHi &&
       fake->cards[1].name == AceHi &&
       fake->inhand == 2             )
    {//2 aces
      returnvalue = true;
    }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 528)
  {
	 if(fake->cards[0].name == AceHi &&
       fake->inhand == 1             )
    {//1 ace
      returnvalue = true;
    }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 529)
  {
	 if((fake->cards[0].suit == fake->cards[1].suit) &&
       fake->inhand == 2)
    {//2 to a flush
      returnvalue = true;
    }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 530)
  {
	 if(fake->cards[0].name == Ten   &&
       fake->cards[1].name == Jack  &&
       fake->cards[2].name == Queen &&
       fake->inhand == 3              )
    {//q-j-10
      returnvalue = true;
    }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 531)
  {
   if(GetCasPlayer(activeplayer)->pHand->instrght > 3 &&
      fake->inhand == 4                                  )
	 {returnvalue = true;}//four card inside straight
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 532)
  {
	 if(fake->cards[0].name == King   &&
       fake->cards[1].name == King  &&
       fake->inhand == 2)
    {//k-k
      returnvalue = true;
    }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 533)
  {
	if(fake->inhand == 1)
   {
    if(fake->cards[0].name == King  ||
       fake->cards[0].name == AceHi   )
    {//A and/or K
      returnvalue = true;
    }
	 else
	 {returnvalue = false;}
   }
   else if(fake->inhand == 2)
   {
     if(fake->cards[0].name == King  &&
        fake->cards[1].name == AceHi   )
     {//A and/or K
       returnvalue = true;
     }
	  else
	  {returnvalue = false;}
   }
   else{returnvalue = false;}
  }
  else if(ask->ExpertCode == 534)
  {
	 if(fake->inhand == 2 &&
       ((fake->cards[0].name == Two   && fake->cards[1].name == Two  ) ||
        (fake->cards[0].name == Three && fake->cards[1].name == Three) ||
        (fake->cards[0].name == Four  && fake->cards[1].name == Four )   ))
    {//pair of 2s, 3s, or 4s
      returnvalue = true;
    }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 535)
  {
	 if((GetCasPlayer(activeplayer)->pHand->outstrflsh > 2 ||
        GetCasPlayer(activeplayer)->pHand->instrflsh  > 2  ) &&
		  numOfWildHeld == 1 && fake->inhand == 3)
    {//3 to sf, one wild
      returnvalue = true;
    }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 536)
  {
	 if(fake->inhand == 2 &&
       (fake->cards[0].name == fake->cards[1].name))
    {//pair
      returnvalue = true;
    }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 537)
  {
	 if(fake->inhand == 4 && GetCasPlayer(activeplayer)->pHand->highhand == 71)
	 {//4 kind, 7wildJoker
    returnvalue = true;}
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 539)
  {
   if(GetCasPlayer(activeplayer)->pHand->outstrght > 2 &&
      fake->inhand == 3                                  )
	 {returnvalue = true;}//3 card outside straight
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 540)
  {
   if(numOfWildHeld == 4 && fake->inhand == 4)
	 {returnvalue = true;}//4 2's, no ace
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 541)
  {
	 if((fake->outstrflsh > 2 ||
        fake->instrflsh  > 2  ) &&
		  fake->inhand == 3)
    {//3 to sf
      returnvalue = true;
    }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 542)
  {
	 if(fake->outstrflsh > 2 &&
		  fake->inhand == 3)
    {//3 to sf outside
      returnvalue = true;
    }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 543)
  {
	 if(fake->instrflsh > 2 &&
		  fake->inhand == 3)
    {//3 to sf inside
      returnvalue = true;
    }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 456)
  {
	 if(fake->instrflsh == 4 || fake->outstrflsh == 4 ||
       fake->toflush   == 4 || fake->outstrght  == 4 ||
       (fake->highhand >= 10 && fake->highcard > Five) ||
        fake->highhand >= 15                             )
    {//4 to -> rf, sf, flush, outside straight and any pat hand
      returnvalue = true;
    }
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 544)
  {
   if(fake->cards[0].name > Queen && fake->inhand < 3)
	 {returnvalue = true;}//1-2 high cards
	 else
	 {returnvalue = false;}
  }
  else if(ask->ExpertCode == 545)
  {
   if(fake->cards[0].name > Queen && numOfWildHeld == 1 &&
      fake->inhand == 2)
	 {returnvalue = true;}//joker and high card
	 else
	 {returnvalue = false;}
  }
  GetCasPlayer(activeplayer)->pHand->highhand      = 0;
  GetCasPlayer(activeplayer)->pHand->highcard      = 0;
  GetCasPlayer(activeplayer)->pHand->toflush       = 0;
  GetCasPlayer(activeplayer)->pHand->instrght      = 0;
  GetCasPlayer(activeplayer)->pHand->outstrght     = 0;
  GetCasPlayer(activeplayer)->pHand->instrflsh     = 0;
  GetCasPlayer(activeplayer)->pHand->outstrflsh    = 0;
  GetCasPlayer(activeplayer)->pHand->instrflshsuit     = 0;
  GetCasPlayer(activeplayer)->pHand->outstrflshsuit    = 0;
  GetCasPlayer(activeplayer)->pHand->lohighcard    = 0;
  GetCasPlayer(activeplayer)->pHand->lolowcard     = 0;
  GetCasPlayer(activeplayer)->pHand->lohand        = 0;
  GetCasPlayer(activeplayer)->pHand->lowcard       = 0;
  GetCasPlayer(activeplayer)->pHand->wildcount     = 0;
  fake->highhand      = 0;
  fake->highcard      = 0;
  fake->toflush       = 0;
  fake->instrght      = 0;
  fake->outstrght     = 0;
  fake->instrflsh     = 0;
  fake->outstrflsh    = 0;
  fake->instrflshsuit     = 0;
  fake->outstrflshsuit    = 0;
  fake->lohighcard    = 0;
  fake->lolowcard     = 0;
  fake->lohand        = 0;
  fake->lowcard       = 0;
  fake->wildcount     = 0;
  fake->inhand        = 0;
  return returnvalue;
}
//*******************************************************************

